*マニュアル*
PHASE/0のマニュアルは以下の場所にあります
pdf版：doc/phase0_manual-ja.pdf
html版：doc/html/index.html

html版はRead the Docs (https://readthedocs.org/) においても公開しています。
https://phase0.readthedocs.io/ja/latest/

*インストール*
インストール方法はマニュアルの記述のほか、以下のGitHubのリポジトリに説明があります。
https://github.com/Materials-Science-Software-Consortium/phase0_install

*チュートリアル*
実行環境としてWSL (https://learn.microsoft.com/ja-jp/windows/wsl/install) を念頭においた
チュートリアルがRead the Docsにおいて公開されています。
https://phase0-tutorial-wsl.readthedocs.io/ja/latest/

チュートリアルにおいて用いられている入力ファイルは以下のGitHubのリポジトリから取得することができます。
https://github.com/Materials-Science-Software-Consortium/phase0_tutorial_wsl

WSLだけでなくmacOSや一般的なGNU/Linuxにおいても実行することができます。

*お問い合わせ*
PHASEシステムソフトウェア利用に関する質問・回答・意見・要望などはGitHubの以下のリポジトリのIssuesから受け付けています。
https://github.com/Materials-Science-Software-Consortium/PHASE_System_Software_QandA

インストールおよびチュートリアルのリポジトリのIssuesからも受け付けています。
https://github.com/Materials-Science-Software-Consortium/phase0_install
https://github.com/Materials-Science-Software-Consortium/phase0_tutorial_wsl

SCF
1. move to "scf" folder
2. do "mpiexec -n 1 ../../../../bin/phase"
3. after a few tens of seconds, SCF calculation will end.
4. be sure, "nfcharge.data" is generated.

DOS
1. move to "dos" folder
2. do "mpiexec -n 1 ../../../../bin/ekcal"
3. after a minute, DOS calculation will end.
4. be sure, "dos.data" is generated.
5. in order to draw a graph, do
   "../../../../bin/dos.pl dos.data -erange=-10,10 -with_fermi"
6. do "evince density_of_states.eps"

BAND
1. move to "band" folder
2. do "mpiexec -n 1 ../../../../bin/ekcal"
3. after a minute, BAND calculation will end.
4. be sure, "nfenergy.data" is generated.
5. in order to draw a graph, do
   "../../../../bin/band.pl nfenergy.data ../../../tools/bandkpt_bcc_ghnpgn.in -erange=-10,10 -with_fermi"
6. do "evince band_structure.eps"

SCF
1. move to "scf" folder
2. do "mpiexec -n 1 ../../../../bin/phase"
3. after a few seconds, SCF calculation will end.
4. be sure, "nfchgt.data" is generated.

DOS
1. move to "dos" folder
2. do "mpiexec -n 1 ../../../../bin/ekcal"
3. after 10 seconds, DOS calculation will end.
4. be sure, "dos.data" is generated.
5. in order to draw a graph, do
   "../../../../bin/dos.pl dos.data -erange=-13,5 -with_fermi -color"
6. do "evince density_of_states.eps"

BAND
1. move to "band" folder
2. do "mpiexec -n 1 ../../../../bin/ekcal"
3. after 30 seconds, BAND calculation will end.
4. be sure, "nfenergy.data" is generated.
5. in order to draw a graph, do
   "../../../../bin/band.pl nfenergy.data ../../../tools/bandkpt_fcc_xglux.in -erange=-13,5 -with_fermi -color"
6. do "evince band_structure.eps"

RELAX
1. move to "relax" folder
2. do "mpiexec -n 1 ../../../../bin/phase"
3. after a minit, RELAX calculation will end.


How to generate a 'kpoint.data' file
1. do "../../../../bin/band_kpoint.pl ../../../tools/bandkpt_fcc_xglux.in"

subroutine ThomasFermiWeiz_loop

  use m_Control_Parameters, only : sw_modified_TFW_functional, &
       &                           sw_spherical_averaged_nonlocal, &
       &                           printable, ipritfwfunc, &
       &                           max_iteration_loop, &
       &                           threshold_exit_loop, &
       &                           threshold_skip_loop, &
       &                           threshold_enter_loop, &
       &                           use_deltaV, use_deltaW, use_averaged_nonlocal, &
       &                           kimg, nspin, sw_potential_mixing, &
       &                           m_CtrlP_rmx_now, noncol, ekmode, sw_hubbard, &
       &                           use_preconditioning, &
       &                           max_iter_linmin => max_iteration_linmin, &
       &                           threshold_linmin, iprinegativecharge

  use m_Const_Parameters,  only : ON, OFF, DP, PAI
  use m_ThomasFermiW_Potential,  only : m_TFW_calc_nonlocal_pot_avg_A, &
       &                                m_TFW_calc_nonlocal_pot_avg_B, &
       &                                m_TFW_CGoptimize_init, &
       &                                m_TFW_CGoptimize_finalize, &
       &                                m_TFW_calc_SD_direction, &
       &                                m_TFW_calc_CG_direction, &
       &                                m_TFW_calc_deltaW, &
       &                                m_TFW_store_Psi, &
       &                                m_TFW_try_new_Psi_and_charge, &
       &                                m_TFW_calc_energy_terms, &
       &                                m_TFW_remove_negative_charge, &
       &                                deltaV, &
       &                                m_TFW_alloc_deltaV, &
       &                                m_TFW_alloc_deltaW, &
       &                                m_TFW_dealloc_deltaV, &
       &                                m_TFW_dealloc_deltaW, &
       &                                m_TFW_init_Psi, &
       &                                Vin_tfw, Vlda_tfw, Vout_tfw, &
       &                                m_TFW_Kerker_mixing, &
       &                                m_TFW_calc_phi_MatH_phi

  use m_Total_Energy,  only : get_local_potential_energy, get_hartree_energy, &
       &                      ene_hartree => ehartr, &
       &                      ene_local  => elocal, m_TE_what_is_edeltb_now
  use m_XC_Potential,  only : ene_exc => exc

  use m_IterationNumbers,    only : iteration_electronic
  use m_Ionic_System,       only : natm
  use m_Electronic_Structure,  only : vlhxc_l, vlhxc_l_old, vlhxcQ, totch, dhub_aimag

  use m_Files,       only : nfout
  use m_Parallelization, only : mype, ista_kngp, iend_kngp
  use m_Charge_Density,  only : m_CD_cp_chgq_to_chgqo, chgq_l
  use m_CD_Mixing,       only : rmxtrc

  use m_IterationNumbers,    only : iteration_electronic, iteration_ionic
  use m_PlaneWaveBasisSet,  only : kg, kg1, kg_tfw
  use m_PseudoPotential,   only : flg_paw
  use m_Potential_Mixing,  only : vnonlocal_i,  m_Pot_add_vnonlocal_to_vlhxcQ
  use m_ES_Intgr_VlhxcQlm,   only : m_ESiVQ_integrate_VlhxcQlm
  use m_ES_NonCollinear,   only : m_ES_update_Mat_dion0_noncl, &
       &                          m_ES_set_Mat_dion_scr_noncl
  use m_Orbital_Population,    only :  m_OP_cp_om_to_ommix

  implicit none

! -----------
! variables
! -----------
  logical :: reset_cg
  integer :: niter, succession
  integer :: max_iter, i, flag, is
  integer :: iprinegativecharge_save

  real(kind=DP) :: zeta_product, zeta_product_old
  real(kind=DP) :: Ene(2), Ene_old, deltaE, E_first
  real(kind=DP) :: ekin_TF, ekin_Weiz, ene_deltaW, ene_deltaV
  real(kind=DP) :: ene_nonlocal_avg, dx
  real(kind=DP) :: psi_MatH_psi, phi_MatH_psi, phi_MatH_phi, theta
  real(kind=DP) :: threshold0, threshold1, threshold2
  real(kind=DP) :: edeltab_per_atom, edelta, zeta_norm, rmxt

  real(kind=DP), allocatable :: chgq_l_save(:,:,:)

! -----------
! parameters 
! -----------
  integer, parameter :: linmin_method = 2
  real(kind=DP), parameter :: min_zeta_norm = 1.0D-8

! --------------------------
!!
!!! initialization
!!
! --------------------------
  if ( sw_modified_TFW_functional == OFF ) return

!-----------------------------------------------------
!  if ( iteration_electronic < 5 ) return
  if ( iteration_electronic < 3 ) return
! --------------------------------------------------

  max_iter   = max_iteration_loop
  threshold0 = threshold_enter_loop
  threshold1 = threshold_skip_loop
  threshold2 = threshold_exit_loop

  edelta = m_TE_what_is_edeltb_now()
  edeltab_per_atom = m_TE_what_is_edeltb_now() / natm
  edeltab_per_atom = abs(edeltab_per_atom )

  if ( edeltab_per_atom > threshold0 ) return
  if ( edeltab_per_atom < threshold1 ) return

! --------------------------
!!
!!! set arrays for TFW 
!!
! --------------------------
  call m_TFW_CGoptimize_init
  if ( use_deltaW ) call m_TFW_alloc_deltaW
  if ( use_deltaV ) call m_TFW_alloc_deltaV

!!!!!!!!!  call m_TFW_remove_negative_charge
  call m_TFW_init_Psi

  if ( use_averaged_nonlocal ) then
     if ( sw_spherical_averaged_nonlocal == OFF ) then
        call m_TFW_calc_nonlocal_pot_avg_A
     else
        call m_TFW_calc_nonlocal_pot_avg_B
     endif
  endif

! 
! ---- Now, chgq_l (vlhxc_l) is the variable set after charge/potential mixing --
!
  if ( sw_potential_mixing == ON ) then
     Vout_tfw = vlhxc_l
  else
     call Renewal_of_Potential
     Vout_tfw = vlhxc_l
  endif

  if ( use_deltaW ) call m_TFW_calc_deltaW
  if ( use_deltaV ) call set_deltaV

  if ( sw_potential_mixing == OFF ) then
     allocate( chgq_l_save(ista_kngp:iend_kngp,kimg,nspin) )
     chgq_l_save = chgq_l
  endif

  iprinegativecharge_save = iprinegativecharge
  iprinegativecharge = 0
! --------------------------
!!
!!!  start scf loop 
!!
! --------------------------
  niter = 0;   succession = 0

  zeta_product_old = 0.0d0;  
  Ene_Old = 0.0d0;  deltaE = 0.0d0;

  vlhxc_l = Vin_tfw
! -----------
!
  do while (.true.)
     call m_TFW_calc_SD_direction( psi_MatH_psi, zeta_product )
     zeta_norm = zeta_product /totch
     if ( zeta_norm < min_zeta_norm ) then
        if ( mype == 0 ) then
           write(nfout,'(A,E12.5,A,E12.5)') "!** zeta_norm ", zeta_norm, &
                &                           " is lower than ", min_zeta_norm
        endif
        goto 1000
     endif

     call m_TFW_store_Psi
     call m_TFW_try_new_Psi_and_charge( 0.0d0 )        ! for numerical accuracy

     call m_TFW_calc_energy_terms( ekin_TF, ekin_Weiz, &
          &                        ene_nonlocal_avg, ene_deltaV, ene_deltaW )
     call Renewal_of_Potential
     call get_local_potential_energy
     call get_hartree_energy


     Ene(1) = ekin_TF +ekin_Weiz +ene_local +ene_hartree +ene_exc &
          &       +ene_nonlocal_avg  +ene_deltaV +ene_deltaW
     deltaE = ( Ene(1) -Ene_Old ) /dble(natm)

     if ( printable .and. ipritfwfunc >=2 ) then
        if ( mype == 0 )then
           write(nfout,*) "**** TFW functional info ***"
           write(nfout,*) "!- iter.   TF        Weiz     local    Hartree     Exc     AvgNonl    dV     dW"
           write(nfout,'(I7,8F10.4)') niter, ekin_TF, ekin_Weiz, &
                &                     ene_local, ene_hartree, &
                &                     ene_exc, ene_nonlocal_avg, ene_deltaV, ene_deltaW

           write(nfout,*) "!  iter.   Total      deltaE"
           write(nfout,'(I7,F15.6,E15.6)') niter, Ene(1), deltaE
           write(nfout,*) "**** *** ***"
        endif
     endif

     if ( abs(deltaE) < threshold2 )  succession = succession  +1
     if ( succession == 2 ) exit 

#if 0
     if ( niter == 0 ) E_first = Ene(1)
     if ( Ene(1) > E_first ) exit
#endif

! ------------
     reset_cg = .false.
!     if ( mod(niter,20) == 0 ) reset_cg = .true.
     if ( niter == 0 ) reset_cg = .true.
     
     call m_TFW_calc_CG_direction( reset_cg, zeta_product, zeta_product_old, &
          &                        phi_MatH_psi )
#if 0
     call check_differential
     stop
#endif

     select case (linmin_method)
     case(1)
        call line_minimization_rough( dx )
     case(2)
        call line_minimization_accurate( dx )
     end select

     if ( printable .and. ipritfwfunc >=2 ) then
        if ( mype == 0 ) write(nfout,*) '!! dx for psi update = ', dx
     endif
     call m_TFW_try_new_Psi_and_charge( dx )

     call Renewal_of_Potential

! -------------
     zeta_product_old = zeta_product
     ene_old = Ene(1)

     niter = niter + 1
     if ( niter == max_iter ) exit
  End do

1000  continue

  call m_TFW_CGoptimize_finalize
  call m_TFW_dealloc_deltaV
  call m_TFW_dealloc_deltaW

  call Renewal_of_Potential

! --------------------------
!!
!!!  set next chgq_l/vlhxc_l 
!!
! --------------------------
  rmxt = m_CtrlP_rmx_now(iteration_electronic, iteration_ionic)

  if ( sw_potential_mixing == ON ) then
     call m_TFW_Kerker_mixing( Vout_tfw, vlhxc_l, rmxt )   
  else
     call m_TFW_Kerker_mixing( chgq_l_save, chgq_l, rmxt )  
  endif

  call recover_higer_G_terms

  if ( sw_potential_mixing == OFF ) then

     call Renewal_of_Potential
  endif

! --------------------------
!!
!!!  set next vlhxcQ and related variables
!!
! --------------------------
  if ( sw_potential_mixing == ON ) then
     call update_nonlocal_for_potmix
  else
     call update_nonlocal_for_chgmix
  endif

  if ( allocated( chgq_l_save ) ) deallocate( chgq_l_save )

  iprinegativecharge = iprinegativecharge_save

contains

  subroutine line_minimization1( x )
    real(kind=DP), intent(out) :: x
    
    real(kind=DP) :: c1, c2
    
    call m_TFW_calc_phi_MatH_phi( phi_MatH_phi )
    c1 = psi_MatH_psi -phi_MatH_phi
    c2 = 2.0d0 *phi_MatH_psi
    x = atan(c2/c1) /2.0d0

  end subroutine line_minimization1
  
  subroutine line_minimization_rough( x )
    real(kind=DP), intent(out) :: x
    
    real(kind=DP) :: x0, c1, c2
    
    x0 = 1.0d0
    
    call m_TFW_try_new_Psi_and_charge( x0 )
    call m_TFW_calc_energy_terms( ekin_TF, ekin_Weiz, &
         &                        ene_nonlocal_avg, ene_deltaV, ene_deltaW )
    call Renewal_of_Potential
    call get_local_potential_energy
    call get_hartree_energy
    Ene(2) = ekin_TF +ekin_Weiz +ene_local +ene_hartree +ene_exc &
         &       +ene_nonlocal_avg +ene_deltaV +ene_deltaW

    c2 = phi_MatH_psi *2.0d0
    c1 = ( Ene(2) - c2 *x0 - Ene(1) ) / x0**2
    x = -c2 /c1/2.0d0
  end subroutine line_minimization_rough
  
  subroutine line_minimization_accurate( x )
    real(kind=DP), intent(out) :: x

    real(kind=DP) :: dx, df, d2f
    real(kind=DP), parameter :: x0 = 0.10d0

    integer :: num

    num = 0;  x = x0;   dx = 0.0d0
    Do while (.true.)
       call calc_df_and_d2f( x, df, d2f )
       dx = -df / abs(d2f);    x = x +dx

       if ( ipritfwfunc >=3 ) then
          if ( mype == 0 ) write(nfout,*) 'xnew = ', x
       endif
       num = num +1
       if ( num > max_iter_linmin ) exit
       if ( abs(dx) < threshold_linmin ) exit
    End do
    if ( dx > x0)  dx =  x0
    if ( dx <-x0 ) dx = -x0

  end subroutine line_minimization_accurate

  subroutine calc_df_and_d2f( x, df, d2f )
    real(kind=DP), intent(in) :: x
    real(kind=DP), intent(out) :: df, d2f
    real(kind=DP) :: dx, x1, x2, x3, e1, e2, e3

    dx = 1.0D-3
    x1 = x -dx;  x2 = x;  x3 = x + dx

    call m_TFW_try_new_Psi_and_charge( x1 )
    call m_TFW_calc_energy_terms( ekin_TF, ekin_Weiz, &
         &                        ene_nonlocal_avg, ene_deltaV, ene_deltaW )
    call Renewal_of_Potential
    call get_local_potential_energy
    call get_hartree_energy
    e1 = ekin_TF +ekin_Weiz +ene_local +ene_hartree +ene_exc &
         &       +ene_nonlocal_avg +ene_deltaV +ene_deltaW

    call m_TFW_try_new_Psi_and_charge( x2 )
    call m_TFW_calc_energy_terms( ekin_TF, ekin_Weiz, &
         &                        ene_nonlocal_avg, ene_deltaV, ene_deltaW )
    call Renewal_of_Potential
    call get_local_potential_energy
    call get_hartree_energy
    e2 = ekin_TF +ekin_Weiz +ene_local +ene_hartree +ene_exc &
         &       +ene_nonlocal_avg +ene_deltaV +ene_deltaW

    call m_TFW_try_new_Psi_and_charge( x3 )
    call m_TFW_calc_energy_terms( ekin_TF, ekin_Weiz, &
         &                        ene_nonlocal_avg, ene_deltaV, ene_deltaW )
    call Renewal_of_Potential
    call get_local_potential_energy
    call get_hartree_energy
    e3 = ekin_TF +ekin_Weiz +ene_local +ene_hartree +ene_exc &
         &       +ene_nonlocal_avg +ene_deltaV +ene_deltaW

    df = ( e3 -e1 ) / (2.0d0*dx)
    d2f = ( e1 +e3 -2.d0 *e2 ) /dx**2

  end subroutine calc_df_and_d2f

  subroutine check_differential
    real(kind=DP) :: x0

    x0 = 1.0D-5
    
    call m_TFW_try_new_Psi_and_charge( x0 )
    call m_TFW_calc_energy_terms( ekin_TF, ekin_Weiz, &
         &                        ene_nonlocal_avg, ene_deltaV, ene_deltaW )
    call Renewal_of_Potential
    call get_local_potential_energy
    call get_hartree_energy
    Ene(2) = ekin_TF +ekin_Weiz +ene_local +ene_hartree +ene_exc &
         &       +ene_nonlocal_avg +ene_deltaV +ene_deltaW
!
    if ( mype == 0 ) then
       write(nfout,*) 'EDiff numerical, analtical =', &
            &                  (Ene(2)-Ene(1))/x0, 2*phi_MatH_Psi
    endif

  end subroutine check_differential

  subroutine update_nonlocal_for_chgmix

    call Renewal_of_Potential

    if (sw_hubbard==ON) then
!       call Renewal_of_Hubbard_Parameters
       call Renewal_of_Hubbard_Potential
    end if

  end subroutine update_nonlocal_for_chgmix

  subroutine update_nonlocal_for_potmix
    call m_ESiVQ_integrate_VlhxcQlm(nfout) ! (lclchh) -> vlhxcQ
    call m_Pot_add_vnonlocal_to_vlhxcQ

    if ( noncol ) then
       if ( flg_paw ) then
          if ( ekmode==ON .or. iteration_electronic >= 1 ) then
             call m_ES_update_Mat_dion0_noncl
          endif
       endif
       call m_ES_set_Mat_dion_scr_noncl( VlhxcQ, vnonlocal_i )
    endif
  end subroutine update_nonlocal_for_potmix

  subroutine recover_higer_G_terms
    integer :: i

    if ( sw_potential_mixing == ON ) then
       Do i=ista_kngp, iend_kngp
          if ( i > kg_tfw ) then
             vlhxc_l(i,:,:) = vout_tfw(i,:,:)
          endif
       End do
    else
       Do i=ista_kngp, iend_kngp
          if ( i > kg_tfw ) then
             chgq_l(i,:,:) = chgq_l_save(i,:,:)
          endif
       End do
    endif
  end subroutine recover_higer_G_terms

  subroutine set_deltaV
    integer :: which_deltaV

    if ( sw_potential_mixing == ON ) then
       which_deltaV = 1
    else
       which_deltaV = 3
    endif

    select case (which_deltaV)
    case (1)
       deltaV = vout_tfw -vlda_tfw     
    case (2)
       deltaV = -( vout_tfw -vlda_tfw )
    case (3)
       deltaV = vout_tfw -vin_tfw  
    case (4) 
       deltaV = -( vout_tfw -vin_tfw )
    end select

  end subroutine set_deltaV

end subroutine ThomasFermiWeiz_loop

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  MODULE: m_Total_Energy
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
module m_Total_Energy
! $Id: m_Total_Energy_ep.f90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Force,            only : etotal
  use m_Const_Parameters, only : tag_total_energy
  implicit none

contains
  subroutine m_TE_rd_total_energy(nfcntn)
    integer, intent(in) :: nfcntn
    read(nfcntn,*)
    read(nfcntn,*) etotal
  end subroutine m_TE_rd_total_energy

  subroutine m_TE_wd_total_energy(nfcntn)
    integer, intent(in) :: nfcntn
    print *,' tag_total_energy'
    write(nfcntn,*) tag_total_energy
    write(nfcntn,'(2d24.16)') etotal
  end subroutine m_TE_wd_total_energy
end module m_Total_Energy

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  MODULE: m_Wannier
!
!  AUTHOR(S): T. Yamamoto   May/05/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Wannier
!! Maximally localized Wannier functions
!! Ref.
!! [1] N. Marzari and D. Vanderbilt, Phys. Rev. B 56 (1997) 12847.
!! [2] G. Berghold, et.al., Phys. Rev. B 61 (2000) 10040.
  use m_Const_Parameters,   only : DP,PAI2,SD,CG,CGPRC,BINARY,CUBE,VTK,DENSITY_ONLY &
       &                         , SKIP,EXECUT,GAMMA,ON
  use m_Control_Parameters, only : printable, kimg, neg, eps_wan, dt_wan &
       &                         , wannier_opt_method, max_iter_wan &
       &                         , wannier_filetype, ipri, sw_random_wannier &
       &                         , sw_potential_wannier, sw_continue_wannier
  use m_Crystal_Structure,  only : altv, rltv, univol
  use m_FFT,                only : nfft, fft_box_size_WF &
       &                         , m_FFT_alloc_WF_work &
       &                         , m_FFT_dealloc_WF_work
  use m_Electronic_Structure,only : totch, m_ES_WF_in_Rspace, neordr &
       &                         , fsr_l, fsi_l
  use m_Timing,             only : tstatc0_begin, tstatc0_end
  use m_Ionic_System,       only : ntyp,natm,natm2,ityp,iatomn,m_IS_pack_all_ions_in_uc &
       &                         , iwei,pos
  use m_PseudoPotential,    only : ival,modnrm,dk_wan,qitg_wan &
       &                         , m_PP_include_vanderbilt_pot &
       &                         , n_non0_lmtxlmt,index_lmt1_lmt2,lmta,nlmt,ilmt &
       &                         , ltp,taup,il2p,isph,iqitg,dl2p &
       &                         , m_PP_find_maximum_l
  use m_Files,              only : m_Files_open_nfwannier,nfwannier &
       &                         , m_Files_open_nfcntn_wannier &
       &                         , m_Files_open_nfpot_wannier &
       &                         , nfcntn_wannier,nfpot_wannier
  use m_Kpoints,            only : k_symmetry
  implicit none
  
  integer, public                     :: nwght
  real(kind=DP), private, allocatable :: wght(:) ! d(nwght)
  integer, public, allocatable        :: ghat(:,:) ! d(3,nwght) 

  integer, private                       :: nocc
  complex(kind=DP), private, allocatable :: zmat(:,:,:) ! d(nocc,nocc,nwght)
  complex(kind=DP), private, allocatable :: zn(:,:) ! d(nocc,nwght)

  real(kind=DP), private, allocatable :: umat(:,:) ! d(nocc,nocc)
  complex(kind=DP), private, allocatable :: bmat(:,:) ! d(nocc,nocc)
  real(kind=DP), private, allocatable :: mmat(:,:) ! d(nocc,nocc)

  integer, private                    :: ntri ! (nocc-1)*nocc/2
  real(kind=DP), private, allocatable :: amat(:) ! d(ntri)
  real(kind=DP), private, allocatable :: grad(:) ! d(ntri)
  real(kind=DP), private :: omega
  real(kind=DP), private :: gradmax

  complex(kind=DP), private, allocatable :: rmat(:,:) ! d(nocc,nocc)
  real(kind=DP), private, allocatable    :: lam(:) ! d(nocc)

  integer, private                    :: iteration

  complex(kind=DP), private, allocatable :: ftqe(:,:,:,:)!d(nlmt,nlmt,natm,nwght)

contains
  subroutine m_Wan_gen_weight(nfout)
    integer, intent(in) :: nfout
    integer :: i
    real(kind=DP) :: g(3,3),w
    real(kind=DP), parameter :: eps = 1.d-10

    nwght = 6
    allocate(wght(nwght),ghat(3,nwght))

    g = matmul(transpose(altv),altv)

    nwght = 0
    ! g^=(1,0,0)
    w = g(1,1)-g(1,2)-g(1,3)
    nwght = nwght + 1
    wght(nwght) = w
    ghat(1:3,nwght) = (/1,0,0/)
    ! g^=(0,1,0)
    w = g(2,2)-g(1,2)-g(2,3)
    nwght = nwght + 1
    wght(nwght) = w
    ghat(1:3,nwght) = (/0,1,0/)
    ! g^=(0,0,1)
    w = g(3,3)-g(1,3)-g(2,3)
    nwght = nwght + 1
    wght(nwght) = w
    ghat(1:3,nwght) = (/0,0,1/)
    ! g^=(1,1,0)
    w = g(1,2)
    if(abs(w) > eps) then
       nwght = nwght + 1
       wght(nwght) = w
       ghat(1:3,nwght) = (/1,1,0/)
    end if
    ! g^=(1,0,1)
    w = g(1,3)
    if(abs(w) > eps) then
       nwght = nwght + 1
       wght(nwght) = w
       ghat(1:3,nwght) = (/1,0,1/)
    end if
    ! g^=(1,1,0)
    w = g(2,3)
    if(abs(w) > eps) then
       nwght = nwght + 1
       wght(nwght) = w
       ghat(1:3,nwght) = (/0,1,1/)
    end if

    if(printable) then
       write(nfout,*) '!Wannier: nwght=',nwght
       do i=1,nwght
          write(nfout,'(" !Wannier: i=",i1," wght=",f18.5," g^=",3i2)') &
          & i,wght(i),ghat(1:3,i)
       end do
    end if

  end subroutine m_Wan_gen_weight

  subroutine m_Wan_opt_Omega(nfout)
    integer, intent(in) :: nfout
    integer :: id_sname = -1
    integer :: i
    call tstatc0_begin('m_Wan_opt_Omega ',id_sname)

    call alloc_zmat(nfout)
    if(sw_continue_wannier == ON) then
       call m_Files_open_nfcntn_wannier
       call rd_zmat_and_umat(nfout,nfcntn_wannier) ! => Z_Iij, U
    else
       call cal_zmat(nfout) ! => Z_Iij
    end if
    if(sw_random_wannier==ON) call random_number(amat)
    iteration = 0
    do 
       iteration = iteration + 1
       call diag_amat() ! => R+,L
       call cal_umat_and_bmat() ! => U,B
       amat(1:ntri) = 0.d0
       call update_zn() ! => Zn
       call cal_mmat() ! => M
       call cal_grad() ! => g = dOmega/dA, gradmax
       call cal_Omega() ! => Omega
       if(Omega_is_max(nfout)) exit
       call update_amat() ! => A
    end do
    call wannier_center(nfout)
    call wannier_function(nfout)
    call m_Files_open_nfcntn_wannier
    call wd_zmat_and_umat(nfout,nfcntn_wannier)! <= Z_Iij, U
    call dealloc_zmat()

    call tstatc0_end(id_sname)
  end subroutine m_Wan_opt_Omega

  subroutine alloc_zmat(nfout)
    integer, intent(in) :: nfout
    integer :: i
    nocc = int(totch+1.d-4)/2
    ntri = nocc*(nocc-1)/2
    if(printable) then
       write(nfout,*) '!Wannier: nocc=',nocc
    end if
    allocate(zmat(nocc,nocc,nwght))
    zmat(1:nocc,1:nocc,1:nwght) = (0.d0,0.d0)
    allocate(zn(nocc,nwght))
    zn(1:nocc,1:nwght) = (0.d0,0.d0)
    allocate(umat(nocc,nocc))
    umat(1:nocc,1:nocc) = 0.d0
    do i=1,nocc
       umat(i,i) = 1.d0
    end do
    allocate(bmat(nocc,nocc))
    allocate(mmat(nocc,nocc))
    allocate(amat(ntri))
    amat(1:ntri) = 0.d0
    allocate(grad(ntri))
    allocate(rmat(nocc,nocc))
    allocate(lam(nocc))
  end subroutine alloc_zmat

  subroutine dealloc_zmat
    deallocate(zmat)
    deallocate(zn)
    deallocate(umat)
    deallocate(bmat)
    deallocate(mmat)
    deallocate(amat)
    deallocate(grad)
  end subroutine dealloc_zmat

  subroutine cal_zmat(nfout)
    integer, intent(in) :: nfout
    integer :: id_sname = -1
    integer :: i,ip,iw,ik
    integer :: ib1,ib2,jb1,jb2
    integer :: nffth,ngrid
    integer :: id1,id2,id12
    integer :: r1,r2,r3
    real(kind=DP), allocatable :: rhat(:,:) !d(nfft/2,3)
    real(kind=DP), allocatable :: wf1(:) !d(nfft)
    real(kind=DP), allocatable :: wf2(:) !d(nfft)
    real(kind=DP), allocatable :: chgr(:) !d(nfft/2)
    real(kind=DP), allocatable :: chgi(:) !d(nfft/2)
    real(kind=DP), allocatable :: zcos(:,:) !d(nfft/2)
    real(kind=DP), allocatable :: zsin(:,:) !d(nfft/2)
    real(kind=DP) :: zr,zi,ph
    real(kind=DP) :: da(3)
    integer :: u,v,lmt1,lmt2,ia,it,mdvdb
    complex(kind=DP) :: defchg,fac,fs1u,fs1v,fs2u,fs2v
    integer :: kimg_t

    call tstatc0_begin('cal_zmat in m_Wan ',id_sname)

    ik = 1
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if

    if(modnrm == EXECUT) call constract_of_ftq()

    ngrid = product(fft_box_size_WF(1:3,1))

    nffth = nfft/2
    allocate(wf1(nfft))
    allocate(wf2(nfft))
    allocate(chgr(nffth))
    if(k_symmetry(ik) /= GAMMA) allocate(chgi(nffth))
    call m_FFT_alloc_WF_work()

    allocate(zcos(nffth,nwght))
    allocate(zsin(nffth,nwght))

    ! Phase factors, exp(iGI*r)
    allocate(rhat(nffth,3))
    id1 = fft_box_size_WF(1,0)
    id2 = fft_box_size_WF(2,0)
    id12 = id1*id2
    da(1:3) = 1.d0/fft_box_size_WF(1:3,1)
    do i=1,nffth
       ip = i-1
       r3 = ip/id12
       r2 = (ip-r3*id12)/id1
       r1 = ip-r2*id1-r3*id12
       rhat(i,1) = dble(r1)*da(1)
       rhat(i,2) = dble(r2)*da(2)
       rhat(i,3) = dble(r3)*da(3)
    end do
    ! debug
    !!  do i=1,nffth
    !!     write(nfout,*) 'i=',i,' rhat=',rhat(i,1:3)
    !!  end do
    ! end debug
    do iw=1,nwght
       do i=1,nffth
          ph = PAI2*dot_product(ghat(:,iw),rhat(i,:))
          zcos(i,iw) = cos(ph)
          zsin(i,iw) = sin(ph)
       end do
    end do
    deallocate(rhat)

    ! ZI,ij = <i|exp(iGI*r)|j>
    ik=1
    do ib2 = 1,nocc
       jb2 = neordr(ib2,ik)
       call m_ES_WF_in_Rspace(ik,jb2,wf2)
       do ib1 = 1,ib2
          jb1 = neordr(ib1,ik)
          call m_ES_WF_in_Rspace(ik,jb1,wf1)
          if(k_symmetry(ik) == GAMMA) then
             do i=1,nffth
                ip = 2*i-1
                chgr(i) = wf1(ip)*wf2(ip)
             end do
          else
             do i=1,nffth
                ip = 2*i-1
                chgr(i) = wf1(ip)*wf2(ip)+wf1(ip+1)*wf2(ip+1)
                chgi(i) = wf1(ip)*wf2(ip+1)-wf1(ip+1)*wf2(ip)
             end do
          end if
          ! debug
          write(nfout,*) ib1,ib2,sum(chgr)/ngrid
          ! end debug
          do iw=1,nwght
             zr=0.d0; zi=0.d0
             if(k_symmetry(ik) == GAMMA) then
                do i=1,nffth
                  zr = zr + zcos(i,iw)*chgr(i)
                  zi = zi + zsin(i,iw)*chgr(i)
                end do
             else
                do i=1,nffth
                  zr = zr + zcos(i,iw)*chgr(i) - zsin(i,iw)*chgi(i)
                  zi = zi + zsin(i,iw)*chgr(i) + zcos(i,iw)*chgi(i)
                end do
             end if
             zmat(ib1,ib2,iw) = dcmplx(zr,zi)/ngrid
             if(modnrm == EXECUT) then
                defchg = (0.d0,0.d0)
                do ia=1,natm
                   it=ityp(ia)
                   mdvdb = m_PP_include_vanderbilt_pot(it)
                   if(mdvdb == SKIP) cycle
                   ph = PAI2*dot_product(ghat(:,iw),pos(ia,:))
                   if(kimg_t==1) then
                      do ip = 1, n_non0_lmtxlmt(it)
                         lmt1  = index_lmt1_lmt2(ip,it,1)
                         lmt2  = index_lmt1_lmt2(ip,it,2)
                         u     = lmta(lmt1,ia)
                         v     = lmta(lmt2,ia)
                         fac   = ftqe(lmt1,lmt2,it,iw)*iwei(ia)*exp(dcmplx(0.d0,ph))
                         !!$write(6,*) 'ip,lmt1,lmt2,u,v,ftqe,fac,=', &
                         !!$  & ip,lmt1,lmt2,u,v,ftqe(lmt1,lmt2,it,iw),fac
                         if(lmt1/=lmt2) then
                            defchg = defchg + &
                         & fac*(fsr_l(jb1,u,ik)*fsr_l(jb2,v,ik) + &
                         &      fsr_l(jb1,v,ik)*fsr_l(jb2,u,ik) )
                         else
                            defchg = defchg + &
                         & fac*fsr_l(jb1,u,ik)*fsr_l(jb2,v,ik)
                         end if
                      end do
                   else
                      do ip = 1, n_non0_lmtxlmt(it)
                         lmt1  = index_lmt1_lmt2(ip,it,1)
                         lmt2  = index_lmt1_lmt2(ip,it,2)
                         u     = lmta(lmt1,ia)
                         v     = lmta(lmt2,ia)
                         fac   = ftqe(lmt1,lmt2,it,iw)*iwei(ia)*exp(dcmplx(0.d0,ph))
                         if(lmt1/=lmt2) then
                            fs1u  = dcmplx(fsr_l(jb1,u,ik),fsi_l(jb1,u,ik))
                            fs1v  = dcmplx(fsr_l(jb1,v,ik),fsi_l(jb1,v,ik))
                            fs2u  = dcmplx(fsr_l(jb2,u,ik),fsi_l(jb2,u,ik))
                            fs2v  = dcmplx(fsr_l(jb2,v,ik),fsi_l(jb2,v,ik))
                            defchg = defchg + fac*(fs1u*fs2v+fs1v*fs2v)
                         else
                            fs1u  = dcmplx(fsr_l(jb1,u,ik),fsi_l(jb1,u,ik))
                            fs2v  = dcmplx(fsr_l(jb2,v,ik),fsi_l(jb2,v,ik))
                            defchg = defchg + fac*fs1u*fs2v
                         end if
                      end do
                   end if
                end do
                zmat(ib1,ib2,iw) = zmat(ib1,ib2,iw) + defchg
             end if
             zmat(ib2,ib1,iw) = zmat(ib1,ib2,iw)
          end do
       end do
    end do

    deallocate(wf1,wf2,chgr)
    if(allocated(chgi)) deallocate(chgi)
    deallocate(zcos,zsin)
    call m_FFT_dealloc_WF_work()

    ! debug
      do iw=1,nwght
         write(nfout,*) 'iw=',iw
         write(nfout,*) 'Real'
         do ib1=1,min(nocc,5)
            write(nfout,'(5(1x,e12.4))') dble(zmat(ib1,1:min(nocc,5),iw))
         end do
         write(nfout,*) 'Imag.'
         do ib1=1,min(nocc,5)
            write(nfout,'(5(1x,e12.4))') dimag(zmat(ib1,1:min(nocc,5),iw))
         end do
      end do
    ! end debug

    call tstatc0_end(id_sname)
  end subroutine cal_zmat

  subroutine diag_amat
    integer :: i,j,ip
    character(len=1), parameter :: JOBZ = 'V', UPLO = 'U'
    integer :: lwork,lrwork,liwork
    complex(kind=DP),allocatable,dimension(:) :: work
    real(kind=DP),allocatable,dimension(:) :: rwork
    integer,allocatable,dimension(:) :: iwork
    integer :: info

    rmat = (0.d0,0.d0)
    do j=2,nocc
       do i=1,j-1
          ip = i + (j-2)*(j-1)/2
          rmat(i,j) = dcmplx(0.d0,-amat(ip))
       end do
    end do

    lwork=nocc*(2+nocc)
    lrwork=1+nocc*(5+2*nocc)
    liwork=3+5*nocc

    allocate(work(lwork))
    allocate(rwork(lrwork))
    allocate(iwork(liwork))

    call zheevd(JOBZ,UPLO,nocc,rmat,nocc,lam,work,lwork,rwork,lrwork,iwork,liwork,info)
    if(info > 0) then
       write(6,*) 'info=',info
       stop 'zheevd error'
    end if

    deallocate(work)
    deallocate(rwork)
    deallocate(iwork)
  end subroutine diag_amat

  subroutine cal_umat_and_bmat()
    ! U = exp(A) = R+ * e^L * R
    ! B_kl = (e^lam_k-e^lam_l)/(lam_k-lam_l)
    complex(kind=DP) :: explam(nocc)
    complex(kind=DP) :: tmat(nocc,nocc)
    complex(kind=DP) :: ctmp
    real(kind=DP) :: dl,dl2,dl3,cr,ci
    real(kind=DP), parameter :: r6 = 1.d0/6.d0
    real(kind=DP), parameter :: r24 = 1.d0/24.d0
    real(kind=DP), parameter :: r120 = 1.d0/120.d0
    real(kind=DP), parameter :: r720 = 1.d0/720.d0
    real(kind=DP) :: umat0(nocc,nocc)
    integer :: i,j

    explam = dcmplx(cos(lam),sin(lam))
    do j=1,nocc
       do i=1,nocc
          tmat(i,j) = rmat(i,j) * explam(j)
       end do
    end do
    umat0 = matmul(tmat,transpose(dconjg(rmat)))
    umat = matmul(umat,umat0)
    do i=1,nocc
       bmat(i,i) = explam(i)
    end do
    do j=1,nocc
       do i=1,j-1
          dl = lam(i)-lam(j)
          if(abs(dl) > 1.d-3) then
             ctmp = explam(i)-explam(j)
             bmat(i,j) = dcmplx(dimag(ctmp),-dble(ctmp))/dl
          else
             dl2 = dl*dl
             dl3 = dl*dl2
             cr=1.d0-r6*dl2+r120*dl2*dl2
             ci=0.5d0*dl-r24*dl3+r720*dl2*dl3
             bmat(i,j) = explam(j)*dcmplx(cr,ci)
          end if
       end do
       bmat(j,i) = bmat(i,j)
    end do
  end subroutine cal_umat_and_bmat

  subroutine update_zn
    integer :: iw,i,j,n
    ! update Z_In
    do iw=1,nwght
       do n=1,nocc
          zn(n,iw) = (0.d0,0.d0)
          do j=1,nocc
             do i=1,nocc
                zn(n,iw) = zn(n,iw) + umat(i,n)*umat(j,n)*zmat(i,j,iw)
             end do
          end do
       end do
    end do
  end subroutine update_zn

  subroutine cal_mmat()
    integer :: i,j,iw
    real(kind=DP) :: fac
    complex(kind=DP) :: zz
    mmat = 0.d0
    do iw=1,nwght
       fac = 4.d0*wght(iw)
       do j=1,nocc
          do i=1,nocc
             !!zz = dot_product(umat(:,i),zmat(:,j,iw))
             zz = dot_product(umat(:,i),matmul(zmat(:,:,iw),umat(:,j)))
             mmat(i,j) = mmat(i,j) + &
             & fac*(dble(zz)*dble(zn(j,iw))+dimag(zz)*dimag(zn(j,iw)))
          end do
       end do
    end do
  end subroutine cal_mmat

  subroutine cal_grad()
    integer :: i,j,ip
    complex(kind=DP) :: tmat(nocc,nocc)
    ! R * M^T * R+
    !!tmat = matmul(matmul(transpose(dconjg(rmat)),transpose(mmat)),rmat)
    ! {(R * M^T * R+),B}
    !!tmat = tmat*bmat
    ! R+ * {(R * M^T * R+),B} * R
    !!tmat = matmul(matmul(rmat,tmat),transpose(dconjg(rmat)))

    tmat = transpose(mmat)
    do j=2,nocc
       do i=1,j-1
          ip = i + (j-2)*(j-1)/2
          grad(ip) = dble(tmat(j,i)) - dble(tmat(i,j))
       end do
    end do

    gradmax = 0.d0
    do i=1,ntri
       gradmax = max(gradmax,abs(grad(i)))
    end do
  end subroutine cal_grad

  subroutine update_amat()
    if(wannier_opt_method == SD) then 
       call sd_method
    else if(wannier_opt_method == CG) then
       call cg_method
    else if(wannier_opt_method == CGPRC) then
       call cgprc_method
    end if
  contains

    subroutine sd_method
      real(kind=DP), save :: dt
      real(kind=DP), allocatable, save :: amat0(:)
      real(kind=DP), allocatable, save :: grad0(:)
      integer, save :: nold = 0
      real(kind=DP) :: yd
      if(.not.allocated(amat0)) allocate(amat0(ntri))
      if(.not.allocated(grad0)) allocate(grad0(ntri))
      if(nold == 0) then
         !!dt = 0.d0
         dt = dt_wan
         amat0 = amat
         grad0 = grad
         nold = 1
      else
         dt = dt + dt_wan
      end if
      yd = -dot_product(grad,grad0)/PAI2**2
      write(6,'(3(1x,f15.5))') dt, omega, yd
      !!call line_search(dt,nold,grad0)
      !!amat = amat0 + dt*grad0
      !!write(6,*) 'dt = ',dt,' nold=',nold
      !!amat = amat0 + dt_wan*grad
      amat = dt_wan*grad
    end subroutine sd_method

    subroutine cg_method
    end subroutine cg_method

    subroutine cgprc_method
    end subroutine cgprc_method

    subroutine line_search(dt,nold,grad0)
      real(kind=DP), intent(inout) :: dt
      integer, intent(inout) :: nold
      real(kind=DP), intent(in) :: grad0(ntri)
      real(kind=DP), allocatable, save :: old_grad(:) ! d(ntri)
      real(kind=DP), save :: old_omega
      real(kind=DP), save :: x0,x1
      real(kind=DP) :: x_opt,y0,y1,yd0,yd1
      real(kind=DP), parameter :: eps = 1.d-2

      if(.not.allocated(old_grad)) allocate(old_grad(ntri))

      if(nold>=1) then
         if(nold==1.or.nold==2) then
            y0 = old_omega
            y1 = omega
            yd0 = -dt_wan*dot_product(old_grad,grad0)/PAI2**2
            yd1 = -dt_wan*dot_product(grad,grad0)/PAI2**2
         else if(nold==3) then
            y0 = omega
            y1 = old_omega
            yd0 = -dt_wan*dot_product(grad,grad0)/PAI2**2
            yd1 = -dt_wan*dot_product(old_grad,grad0)/PAI2**2
         end if
         if(yd0 < 0.d0 .and. yd1 > 0.d0) then
            call parabolic_fit(x_opt,y0,y1,yd0)
            write(6,*) 'x0,x1=',x0,x1
            write(6,*) 'y0,y1=',y0,y1
            write(6,*) 'yd0,yd1=',yd0,yd1
            write(6,*) 'x_opt=',x_opt
            dt = x_opt*(x1-x0)+x0
            if(y0<y1) then
               x1=dt
            else
               x0=dt
            end if
            dt = dt*dt_wan
            if(abs(x0-x1) < eps*max(x0,x1)) then
               nold = 0
               return
            else
               nold = 2
            end if
         else
            dt = dt + dt_wan
         end if
      else
         dt = dt + dt_wan
      end if

      if(nold==0) then
         x0 = 0.d0
         x1 = 1.d0
      end if
      if(old_omega > omega .or. nold==0 .or. nold==1) then
         old_omega  = omega
         old_grad = grad
         if(nold==0)then
            nold = 1
         else if(nold==2) then
            nold = 2
         end if
      else
         nold = 3
      end if
    end subroutine line_search

    subroutine parabolic_fit(xmin,y0,y1,yd0)
      real(kind=DP), intent(out) :: xmin
      real(kind=DP), intent(in)  :: y0,y1,yd0
      real(kind=DP) :: a, b, c
      c = y0
      b = yd0
      a = y1-(b+c)
      xmin = -0.5d0*b/a
    end subroutine parabolic_fit

  end subroutine update_amat

  logical function Omega_is_max(nfout)
    integer, intent(in) :: nfout

    Omega_is_max = .true. 
    if(gradmax > eps_wan) Omega_is_max = .false. 
    if(iteration >= max_iter_wan) Omega_is_max = .true.

    if(printable) then
       write(nfout,'("!Wannier: ",i5," Omega= ",f18.5," Gradmax= ",f18.5)') iteration,omega,gradmax
    end if
  end function Omega_is_max

  subroutine cal_Omega()
    integer :: i,iw
    real(kind=DP) :: zr,zi
    omega = 0.d0
    do iw=1,nwght
       do i=1,nocc
          zr = dble(zn(i,iw))
          zi = dimag(zn(i,iw))
          omega = omega + wght(iw)*(1.d0-(zr*zr+zi*zi))
       end do
    end do
    omega = omega/PAI2**2
  end subroutine cal_Omega

  subroutine wannier_center(nfout)
    integer, intent(in) :: nfout
    integer :: n,i
    real(kind=DP) :: wfc(nocc,3)

    ! wannier center
    wfc = atan2(dimag(zn(:,1:3)),dble(zn(:,1:3)))/PAI2
    do i=1,3
       do n=1,nocc
          if(wfc(n,i)<-1.d-4) wfc(n,i) = wfc(n,i)+1.d0
       end do
    end do
    if(printable) then
      write(nfout,*) '== Wannier centers (in internal) =='
      do n=1,nocc
         write(nfout,'(i5,3(1x,f18.10))') n,wfc(n,1:3)
      end do
    end if
    wfc = matmul(wfc,transpose(altv))
    if(printable) then
      write(nfout,*) '== Wannier centers (in Cartesian) =='
      do n=1,nocc
         write(nfout,'(i5,3(1x,f18.10))') n,wfc(n,1:3)
      end do
    end if

  end subroutine wannier_center

  subroutine wannier_function(nfout)
    integer, intent(in) :: nfout
    integer :: nspin,ispin,ib,ib1,jb1,i,ik
    integer :: ip,nffth
    real(kind=DP) :: wf(nfft/2), wf1(nfft)

    call m_FFT_alloc_WF_work()

    nffth = nfft/2

    nspin = 1
    do ispin=1,nspin
       ik = ispin
       do ib=1,nocc
          call m_Files_open_nfwannier(nspin,ispin,ib)
          wf = 0.d0
          do ib1 = 1,nocc
             jb1 = neordr(ib1,ik)
             call m_ES_WF_in_Rspace(ik,jb1,wf1)
             do i=1,nffth
                ip = 2*i-1
                wf(i) = wf(i) + wf1(ip)*umat(ib1,ib)
             end do
          end do
          call wd_wf(nfout,nfwannier,nspin,ispin,ib)
       end do
    end do

    call m_FFT_dealloc_WF_work()

  contains

    subroutine wd_wf(nfout,nfwf,nspin,ispin,ib)
      integer, intent(in) :: nfout,nfwf,nspin,ispin,ib
      integer :: i,j,k, id, nl, nm, nn, nlhf,inew,jnew,knew,ip,mm
      real(kind=DP),allocatable,dimension(:,:,:) :: wkwf
      real(kind=DP) ::      s1, s2, sratio,x,y,z
      integer, parameter :: UP = 1 , DOWN = 2
      integer ::            up_down
      real(kind=DP),allocatable,dimension(:,:) :: cps_full
      integer, allocatable,dimension(:) :: ityp_full
      real(kind=DP), dimension(3) :: r_wk    !!! K.Mae 040315
      integer :: ucret, m   !!! K.Mae 040315
      real(kind=DP) :: norm
      integer :: n1,n2,n3
      real(kind=DP) :: dn1,dn2,dn3
      real(kind=DP) :: eig
      integer :: nk 

      nk=1
      eig=0.d0

      id = fft_box_size_WF(1,0)
      mm = fft_box_size_WF(2,0)
      nl = fft_box_size_WF(1,1)
      nm = fft_box_size_WF(2,1)
      nn = fft_box_size_WF(3,1)

      if(kimg == 1) then
         nlhf = id/2
      else
         nlhf = id
      end if

      if(wannier_filetype == DENSITY_ONLY &
      & .or. wannier_filetype == VTK &
      & .or. wannier_filetype == BINARY) then
         allocate(wkwf(nl,nm,nn)); wkwf = 0.d0
      else if(wannier_filetype == CUBE) then
         allocate(wkwf(nn,nm,nl)); wkwf = 0.d0
      end if

      if(nspin==2) then
         if(ispin == 1) then
            up_down = UP
         else
            up_down = DOWN
         end if
      end if

      if(ipri >= 2) write(nfout,9001) nl*nm*nn, nl, nm, nn
9001  format(' Wannier function ',i8,'(',3i5,')')

      if(ipri >= 2) write(nfout,*) ' !D FFT cube mapping start'
      do i = 1, nm
         do j = 1, nn
            do k = 1, nl
               if(kimg == 1 .and. k > nlhf) then
                  knew = id - k
                  jnew = nn+2 - j
                  inew = nm+2 - i
                  if(jnew > nn) then
                     jnew = jnew - nn
                  end if
                  if(inew > nm) then
                     inew = inew - nm
                  end if
               else
                  knew = k; jnew = j; inew = i
               end if
               ip = nlhf*mm*(jnew-1) + nlhf*(inew-1) + knew
               if(wannier_filetype == DENSITY_ONLY &
               & .or. wannier_filetype == VTK &
               & .or. wannier_filetype == BINARY) then
                  wkwf(k,i,j) = wf(ip)
               else if(wannier_filetype == CUBE) then
                  wkwf(j,i,k) = wf(ip)
               end if
            end do
         end do
      end do
      norm = 1.d0/dsqrt(univol)
      do i = 1, nm
         do j = 1, nn
            do k = 1, nl
               if(wannier_filetype == DENSITY_ONLY &
               & .or. wannier_filetype == VTK &
               & .or. wannier_filetype == BINARY) then
                  wkwf(k,i,j) = norm*wkwf(k,i,j)
               else if(wannier_filetype == CUBE) then
                  wkwf(j,i,k) = norm*wkwf(j,i,k)
               end if
            end do
         end do
      end do

      if(wannier_filetype == DENSITY_ONLY) then
         write(nfwf,9001) nl*nm*nn, nl, nm, nn
         write(nfwf,'(6e13.5)') wkwf
      else if(wannier_filetype == BINARY) then
         write(nfwf) nl*nm*nn, nl, nm, nn
         write(nfwf) altv, nspin, up_down, nk, ib, eig
         write(nfwf) wkwf(:,:,:)
      else if(wannier_filetype == VTK) then
         write(nfwf,'("# vtk DataFile Version 2.0")')
         if(nspin == 2) then
            if(up_down == 1) then
               write(nfwf,'(" Wannier function UP : n=",i7)') ib
            else
               write(nfwf,'(" Wannier function DOWN : n=",i7)') ib
            end if
         else
            write(nfwf,'(" Wannier function : n=",i7)') ib
         end if
         write(nfwf,'("ASCII")')
         write(nfwf,'("DATASET STRUCTURED_GRID")')
         write(nfwf,'("DIMENSIONS",3(1x,i5))') nl+1,nm+1,nn+1
         write(nfwf,'("POINTS",1x,i10,1x,"float")') (nl+1)*(nm+1)*(nn+1)
         do n1=0,nl
            do n2=0,nm
               do n3=0,nn
                  dn1 = n1/dble(nl)
                  dn2 = n2/dble(nm)
                  dn3 = n3/dble(nn)
                  x = altv(1,1)*dn1 + altv(1,2)*dn2 + altv(1,3)*dn3
                  y = altv(2,1)*dn1 + altv(2,2)*dn2 + altv(2,3)*dn3
                  z = altv(3,1)*dn1 + altv(3,2)*dn2 + altv(3,3)*dn3
                  write(nfwf,'(3(1x,e13.5))') x,y,z
               end do
            end do
         end do
         write(nfwf,'("")')
         write(nfwf,'("POINT_DATA",1x,i10)') (nl+1)*(nm+1)*(nn+1)
         write(nfwf,'("SCALARS scalars float")')
         write(nfwf,'("LOOKUP_TABLE default")')
         do n1=0,nl
            i=n1+1
             if(n1==nl) i=1
            do n2=0,nm
               j=n2+1
               if(n2==nm) j=1
               do n3=0,nn
                  k=n3+1
                  if(n3==nn) k=1
                  write(nfwf,'(e13.5)') wkwf(i,j,k)
               end do
            end do
         end do
      else if(wannier_filetype == CUBE) then
         !!if(len_trim(wf_title) >= 1) then
         !!   write(nfwf,*) trim(wf_title)
         !!else
            write(nfwf,'(" Calculated by phase")')
         !!end if
         if(nspin == 2) then
            if(up_down == 1) then
               write(nfwf,'(" Wannier function UP : n=",i7)') ib
            else
               write(nfwf,'(" Wannier function DOWN : n=",i7)') ib
            end if
         else
            write(nfwf,'(" Wannier function : n=",i7)') ib
         end if
         x = 0.d0; y = 0.d0; z = 0.d0
         write(nfwf,'(i6,3f10.4)') -natm2, x,y,z
         do i = 1, 3
            write(nfwf,'(i6,3f10.6)') fft_box_size_WF(i,1), altv(1:3,i)/dble(fft_box_size_WF(i,1))
         end do

         allocate(cps_full(natm2,3))
         allocate(ityp_full(natm2))
         call m_IS_pack_all_ions_in_uc(ityp_full,cps_full)
         do i = 1, natm2
            m = ityp_full(i)
            write(nfwf,'(i6,4f10.6)') nint(iatomn(m)), ival(m), cps_full(i,1:3)
         end do
         deallocate(ityp_full,cps_full)

         write(nfwf,'(10i5)') 1,1
         write(nfwf,'(6e13.5)') wkwf(:,:,:)
  
      end if
      if(allocated(wkwf)) deallocate(wkwf)
    end subroutine wd_wf

  end subroutine wannier_function

  subroutine constract_of_ftq()
    ! local varialbes
    integer :: it,ik,ip,lmt1,lmt2,u,v
    integer :: il1,il2,tau1,tau2,l3
    integer :: n,ilm3,iiqitg,iw
    integer :: mdvdb
    integer, allocatable :: il3(:)
    real(kind=DP) :: fac
    real(kind=DP) :: dk(3),ylm,dga
    real(kind=DP) :: ftqr(nwght),ftqi(nwght),ftqb
    complex(kind=DP) :: zi = (0.d0,1.d0)

    call m_PP_find_maximum_l(n)   !  n-1: maximum l
    n = (n-1) + (n-1) + 1
    allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)
    allocate(ftqe(nlmt,nlmt,ntyp,nwght)); ftqe=(0.d0,0.d0)
    TYPE: do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) cycle TYPE
       LMT_1: do lmt1=1,ilmt(it)
          il1 = ltp(lmt1,it)
          tau1 = taup(lmt1,it)
          LMT_2: do lmt2=lmt1,ilmt(it)
             il2 = ltp(lmt2,it)
             tau2 = taup(lmt2,it)
             ftqr(1:nwght) = 0.d0
             ftqi(1:nwght) = 0.d0
             LM3: do n=1,il2p(lmt1,lmt2,it)
                ilm3 = isph(lmt1,lmt2,n,it); l3=il3(ilm3)
                iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
                if(iiqitg == 0) cycle LM3
                do iw=1,nwght
                   dk(1:3)=matmul(rltv,ghat(1:3,iw))
                   call sphrp2_for_Berry(ilm3,dk,ylm)
                   ftqb = qitg_wan(iiqitg,iw)*dl2p(lmt1,lmt2,n,it)*ylm
                   !!$ write(6,*) 'it,lmt1,lmt2,n,iw,ftqb=',it,lmt1,lmt2,n,iw,ftqb
                   if(mod(l3,2)==0) then
                      !!ftqr(iw)=ftqr(iw)+real(zi**(-l3))*ftqb
                      ftqr(iw)=ftqr(iw)+real(zi**(l3))*ftqb
                   else
                      !!ftqi(iw)=ftqi(iw)+dimag(zi**(-l3))*ftqb
                      ftqi(iw)=ftqi(iw)+dimag(zi**(l3))*ftqb
                   end if
                end do
             end do LM3
             do iw=1,nwght
                ftqe(lmt1,lmt2,it,iw) = dcmplx(ftqr(iw),ftqi(iw))
                ftqe(lmt2,lmt1,it,iw) = ftqe(lmt1,lmt2,it,iw)
             end do
          end do LMT_2
       end do LMT_1
    end do TYPE

    deallocate(il3)
  end subroutine constract_of_ftq

  subroutine rd_zmat_and_umat(nfout,nfcnt)
    integer, intent(in) :: nfout,nfcnt
    write(nfout,*) 'Reading Z and U matrices'
    rewind(nfcnt)
    read(nfcnt) zmat,umat
  end subroutine rd_zmat_and_umat

  subroutine wd_zmat_and_umat(nfout,nfcnt)
    integer, intent(in) :: nfout,nfcnt
    write(nfout,*) 'Writing Z and U matrices'
    rewind(nfcnt)
    write(nfcnt) zmat,umat
  end subroutine wd_zmat_and_umat

end module m_Wannier

subroutine Optimize_Blocking_Parameters()
  use m_Const_Parameters,     only : DP, ORTHOGONALIZATION, EXECUT, VDB, NORMCONSERVATION, ON, OFF
  use m_Files,                only : nfout
  use m_PseudoPotential,      only : modnrm
  use m_Control_Parameters ,  only : printable, kimg, ipriblsize &
  &                                , nblsizecand_betar, blsizecand_betar, nblsizecand_mgs, blsizecand_mgs &
  &                                , nblocksize_mgs, nblocksize_mgs_is_given, nblocksize_betar_dot_wfs    &
  &                                , nblocksize_betar_is_given, ipriparallel,neg,nb_mgs_default &
  &                                , nblsizecand_vnonlocal_w, blsizecand_vnonolocal_w &
  &                                , nblocksize_vnonlocal_is_given, nblocksize_vnonlocal_w &
  &                                , nblsizecand_submat, blsizecand_submat &
  &                                , nblocksize_submat_is_given, nblocksize_submat &
  &                                , m_CntrlP_rst_submat_call_stat,nspin &
  &                                , sw_betar_dot_wfs_exp, sw_precalculate_phase_vnonlocal, damp, meg &
  &                                , sw_scalapack
  use m_Kpoints,              only : kv3
  use m_Parallelization,      only : np_g1k, np_e, np_fs
#ifdef FFT_3D_DIVISION
  use m_Parallelization,      only : fft_X_x_nel, fft_X_y_nel, fft_X_z_nel
#else
  use m_Parallelization,      only  :nel_fft_x, nel_fft_y, nel_fft_z
#endif
  use m_Parallelization,      only : mype, myrank_e, m_Parallel_dealloc_mpi_elec, m_Parallel_init_mpi_elec_3D &
  &                                , make_ball_buff, MPI_CommGroup, map_k, myrank_k
  use m_ES_ortho,             only : mgs_4_each_k_G_3D, m_ESortho_mgs_alloc, m_ESortho_mgs_dealloc &
  &                                , m_ES_modified_gram_schmidt
  use m_ES_nonlocal,          only : m_ES_betar_dot_Psi_4_each_k_3D, m_ES_Vnonlocal_W_3D
  use m_Parallelization,      only : make_index_band_3D,make_index_band_for_Gdiv_3D, nrank_e, nrank_k
  use m_ES_WF_by_submat,      only : evolve_WFs_in_subspace_3D, m_ESsubmat_alloc, m_ESsubmat_dealloc, m_ESsubmat_renew_WF
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_PlaneWaveBasisSet,    only : kg1, iba
  use m_Electronic_Structure, only : m_ES_dealloc, m_ES_alloc_zaj_etc, m_ES_alloc_vlhxc, m_ES_alloc_vlhxcQ
  use mpi


  implicit none

!  include 'mpif.h'             ! MPI

  integer :: i, t1, nbuf, lsize
  real(kind=DP) :: elapsed_time
  real(kind=DP), allocatable, dimension(:,:,:,:) :: phi_l
  real(kind=DP), allocatable, dimension(:,:,:) :: bsdr_l, bsdi_l
  real(kind=DP), allocatable, dimension(:,:) :: afft_l
  real(kind=DP), allocatable, dimension(:) :: ekin_l
  real(kind=DP) :: best
  logical :: logi
  integer :: max_blsize, ierr
  integer :: id_sname = -1

  call tstatc0_begin('Optimize_Blocking_Parameters ',id_sname,-1)
  if (nrank_k>1 .and. sw_scalapack == on ) then
    call phase_error_with_msg(nfout, &
   & 'optimization of the blocking parameters, kpoint parallelization and ScaLAPACK cannot be used simultaneously', &
   & __LINE__, __FILE__)
  endif
  nblocksize_mgs_is_given = .true.
  best = HUGE(0)
  nbuf = blsizecand_mgs(1)
  max_blsize = int(real(neg)/real(nrank_e))
  blsizecand_mgs(1) = max_blsize
  do i=1,nblsizecand_mgs
    blsizecand_mgs(i) = max_blsize/(2**(i-1))
    if (blsizecand_mgs(i) < 4) blsizecand_mgs(i) = 4
    if (blsizecand_betar(i)>max_blsize) cycle
    call system_clock(t1)
    nblocksize_mgs = blsizecand_mgs(i)
    call m_CntrlP_rst_submat_call_stat()
    call make_index_band_3D(nfout,ipriparallel,printable,kv3,neg,nblocksize_mgs,nblocksize_mgs_is_given,nb_mgs_default)
    call make_index_band_for_Gdiv_3D(neg, nblocksize_mgs,nblocksize_mgs_is_given,nb_mgs_default)
    allocate(phi_l(maxval(np_g1k),np_e,1,kimg))
    if(modnrm == EXECUT) then
      allocate(bsdr_l(np_e, np_fs, 1))
      allocate(bsdi_l(np_e, np_fs, 1))
    endif

    if(modnrm == EXECUT) then
      call mgs_4_each_k_G_3D(1,1,1,phi_l,ORTHOGONALIZATION,bsdr_l,bsdi_l,mod_pot=VDB,dryrun=.true.)
    else
      call mgs_4_each_k_G_3D(1,1,1,phi_l,ORTHOGONALIZATION,mod_pot=NORMCONSERVATION,dryrun=.true.)
    endif
    elapsed_time = get_time_from(t1)
    if(elapsed_time<best) then
      best = elapsed_time
      nbuf = nblocksize_mgs
    endif
    deallocate(phi_l)
    if(modnrm == EXECUT) then
      deallocate(bsdr_l)
      deallocate(bsdi_l)
    endif
    if(ipriblsize>=2) write(nfout,'(a,i5,1f12.4)') '!** MGS blocksize and elapsed time ',blsizecand_mgs(i),elapsed_time
  enddo
  call mpi_bcast(nbuf,1,mpi_integer,0,MPI_CommGroup,ierr)
  nblocksize_mgs = nbuf
  call m_CntrlP_rst_submat_call_stat()
  call make_index_band_3D(nfout,ipriparallel,printable,kv3,neg,nblocksize_mgs,nblocksize_mgs_is_given,nb_mgs_default)
  call make_index_band_for_Gdiv_3D(neg, nblocksize_mgs,nblocksize_mgs_is_given,nb_mgs_default)
  call make_ball_buff()
  call m_ES_dealloc()
  call m_ES_alloc_zaj_etc()
  call m_ES_alloc_vlhxc()
  call m_ES_alloc_vlhxcQ()

  allocate(phi_l(maxval(np_g1k),np_e,1,kimg))
  allocate(bsdr_l(np_e, np_fs, 1))
  allocate(bsdi_l(np_e, np_fs, 1))
  if(sw_betar_dot_wfs_exp==OFF) then
  best = HUGE(0)
  nbuf = blsizecand_betar(1)
  nblocksize_betar_is_given = .true.
  do i=1,nblsizecand_betar
    call system_clock(t1)
    nblocksize_betar_dot_wfs = blsizecand_betar(i)
    call m_ES_betar_dot_Psi_4_each_k_3D(nfout,phi_l,1,1,1,bsdr_l,bsdi_l,mod_ball=OFF)
    elapsed_time = get_time_from(t1)
    if(elapsed_time<best) then
      best = elapsed_time
      nbuf = nblocksize_betar_dot_wfs
    endif
    if(ipriblsize>=2) write(nfout,'(a,i5,1f12.4)') '!** betar_dot_WFs blocksize and elapsed time ' &
    & ,blsizecand_betar(i),elapsed_time
  enddo
  call mpi_bcast(nbuf,1,mpi_integer,0,MPI_CommGroup,ierr)
  nblocksize_betar_dot_wfs = nbuf
  endif

  if(sw_precalculate_phase_vnonlocal==OFF) then
  best = HUGE(0)
  nbuf = blsizecand_vnonolocal_w(1)
  nblocksize_vnonlocal_is_given = .true.
  do i=1,nblsizecand_vnonlocal_w
    call system_clock(t1)
    nblocksize_vnonlocal_w = blsizecand_vnonolocal_w(i)
    call m_ES_Vnonlocal_W_3D(1,1,1,switch_of_eko_part=OFF)
    elapsed_time = get_time_from(t1)
    if(elapsed_time<best) then
      best = elapsed_time
      nbuf = nblocksize_vnonlocal_w
    endif
    if(ipriblsize>=2) write(nfout,'(a,i5,1f12.4)') '!** vnonlocal_w blocksize and elapsed time ' &
    & ,blsizecand_vnonolocal_w(i),elapsed_time
  enddo
  call mpi_bcast(nbuf,1,mpi_integer,0,MPI_CommGroup,ierr)
  nblocksize_vnonlocal_w = nbuf
  endif

  if(map_k(1) == myrank_k) then
    best = HUGE(0)
    nbuf = blsizecand_submat(1)
    nblocksize_submat_is_given = .true.
#ifdef FFT_3D_DIVISION
    lsize = fft_X_x_nel*fft_X_y_nel*fft_X_z_nel
    allocate(afft_l(lsize*2,1))
#else
    lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
    allocate(afft_l(lsize*kimg,1))
#endif
    allocate(ekin_l(np_g1k(1)))
    call m_ESsubmat_alloc()
    do i=1,nblsizecand_submat
      blsizecand_submat(i) = neg/i
      if(blsizecand_submat(i)==0) blsizecand_submat(i) = 1
      if (blsizecand_submat(i)>neg) exit
      call system_clock(t1)
      nblocksize_submat = blsizecand_submat(i)
      call m_CntrlP_rst_submat_call_stat()
      call evolve_WFs_in_subspace_3D(1,1,1,meg,damp,ekin_l,afft_l(1,1),lsize,dryrun=.true.)
      elapsed_time = get_time_from(t1)
      if(elapsed_time<best) then
        best = elapsed_time
        nbuf = nblocksize_submat
      endif
      if(ipriblsize>=2) write(nfout,'(a,i5,1f12.4)') '!** submat blocksize and elapsed time ' &
      & ,blsizecand_submat(i),elapsed_time
    enddo
    call m_CntrlP_rst_submat_call_stat()
    call m_ESsubmat_dealloc()
    deallocate(afft_l)
    deallocate(ekin_l)
  endif
  call mpi_bcast(nbuf,1,mpi_integer,0,MPI_CommGroup,ierr)
  nblocksize_submat = nbuf

  if(printable) then
    write(nfout,'(a)')    '!** estimated optimal blocking parameters'
    write(nfout,'(a,i5)') '    nblocksize_mgs           = ',nblocksize_mgs
    if(sw_betar_dot_wfs_exp==OFF) write(nfout,'(a,i5)') '    nblocksize_betar_dot_wfs = ',nblocksize_betar_dot_wfs
    if(sw_precalculate_phase_vnonlocal==OFF)write(nfout,'(a,i5)') '    nblocksize_vnonlocal_w   = ',nblocksize_vnonlocal_w
    write(nfout,'(a,i5)') '    nblocksize_submat        = ',nblocksize_submat
  endif

  deallocate(phi_l)
  deallocate(bsdr_l)
  deallocate(bsdi_l)

  call tstatc0_end(id_sname)

  contains

  real(kind=DP) function get_time_from(t1)
    integer, intent(in) :: t1
    integer :: t2, t_rate, t_max, diff
    call system_clock(t2, t_rate, t_max)   ! 終了時を記録
    if ( t2 < t1 ) then
      diff = (t_max - t1) + t2 + 1
    else
      diff = t2 - t1
    endif
    get_time_from = diff/dble(t_rate)
  end function get_time_from

end subroutine Optimize_Blocking_Parameters

   Subroutine vc_nl(nx,ny,nz,nfftx,nffty,nfftz,nspin,rhoxyz,Exc,univol,rinplw,vcnlxyz,ista,iend)

     use m_Crystal_Structure,  only : altv
     use m_Total_Energy,       only : m_TE_what_is_edeltb_now
     use m_Ionic_System,       only : natm2
     use m_IterationNumbers,   only : iteration
     use m_Const_Parameters,   only : PAI

!$   use omp_lib

      Implicit None



!********************************* Note *******************************************
! This program calculates non-local exchange-correlation potential using the 
! van der Waals density functional (vdW-DF).
! The Algorism follows Thonhauser's self-consistent method.
!            (Reference; T.Thonhauser et al. PRB 76 (2007) 125112.)
! E_total = Ex_GGA + Ec_LDA + Ec_non-local
! v_total = vx_GGA + vc_LDA + vc_non-local
!
! Periodic systems are assumed.
! Only orthogonal corrdinates are applicable.
! Atomic unit (Hartree) is used.
!
!
!
! +++++++++++ Algorithm ++++++++++
!    ggaxcp0
! (m_XC_Potential.F90 in PHASE)
!
!      |
!      |
!      V 
!
!   vc_nl    --->   d_rho
!                  gauleg
!                 calPhi1  --->  d_q0
!                 calPhi2  --->  d_q0
!                 calPhi3  --->  d_q0
!                 calPhi4  --->  d_q0
!                    Phi1  --->  d_q0
!                    Phi2  --->  d_q0
!                    Phi3  --->  d_q0
!                    Phi4  --->  d_q0
!
!
!
! ++++++++ Input & Output ++++++++
! Input
!   rhoxyz(nx*ny*nz,nspin)  : Total density
!   nx,ny,nz                : Number of the grid points
!   nspin (dummy)           : Spin is not considered
!
! Output
!   vcnlxyz(nx*ny*nz,nspin) : Total Correlation potential
!     = vc(:,:,:) 
!     = vcnl + vcLDA
!         vcnl              : Non-local Correlation potential
!         vcLDA             : LDA Correlation potential
!
!
!
! ++++++ Internal parameters +++++
! Each internal parameter is set to restrict the error less than 10 meV.
!
! na(=nb) ( 30    )        : Gauss-Legendre integration is used.
! a2(=b2) ( 60    )        : Upper limit of the integral of dadb.
! etai    ( 1.3   )        : Radius of analytical integrating sphere (a.u.)
! eta1    ( 8     )        : Radius of numerical integrating sphere  (a.u.)
! eta2    ( 40    )        : Cutoff of asymptotic function     (unit cells)
! adj     ( 1     )        : Parameter to adjust error in Estimation Time
!
!
!
! ++++ Calculation procedure +++++
! 1. Calculate the coefficients of the asymptotic function.
!
! 2. Call d_rho and calculate differential of total density.
!     --- 7 points formula is used for differentiation.
!
! 3. Call Phi1 to Phi4 (and calPhi1 to calPhi4) to calculate
!             the functional derivative of the core function.
!
! 4. Calculate the local correlation potentail using LDA.
!
! 5. Output total correlation potential.
!     --- vcnlxyz = vc = vcnl + vcLDA
!
!
!
!                                              Written by Youky Ono 
!**********************************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  nx,ny,nz,nfftx,nffty,nfftz,nspin,nrxyz,iterstart
      Integer  ista,iend
      Real(8) da,db,a1,a2,ax,ay,az,rxyz,edel,sedel
      Integer  ci,cj,ck,ca,cb,na,nb,cD
      Parameter (sedel=1.e-4,iterstart=12)
      Parameter (na=30,a1=0,a2=60)

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Integer ndel,cdel,nphiD,cphiD,maxnphiD
      Real(8) ddel,del,phiD,phix,phiy,mphiD,maxD,minD,maxDii,minDii
      Parameter (ndel=20,nphiD=200,maxD=10,minD=0.1)
      Real(8), Allocatable :: &
&             phi1dD(:,:),phi2dD(:,:),phi3dD(:,:),phi4dD(:,:)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Integer  c1x,c1y,c1z,c4x,c4y,c4z

      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk
      Integer  i,j,k,zxp,zxm,zyp,zym,zzp,zzm,tx,ty,tz

!!$      Real(8)  eta,etai,eta1,eta2
      Real(8)  eta,etai,eta1
      Integer eta2
      Parameter (eta=0.0000000001,etai=1.3,eta1=8,eta2=20)

      Real(8), Allocatable ::  C6(:,:,:)
      Real(8), Allocatable ::  dxrho(:,:,:), d2xrho(:,:,:) &
&                            , dyrho(:,:,:), d2yrho(:,:,:) &
&                            , dzrho(:,:,:), d2zrho(:,:,:) &
&                            , dxyrho(:,:,:),dxzrho(:,:,:),dyzrho(:,:,:)

      Real(8) rs,x,nnx,nny,nnz,nn2,r,zo
      Real(8) nxp,nxm,nyp,nym,nzp,nzm

      Real(8) rhoxyz(nfftx*nffty*nfftz,nspin),vcnlxyz(nfftx*nffty*nfftz,nspin)

      Real(8), Allocatable ::  rho(:,:,:) &
&               ,vcnl(:,:,:),vc(:,:,:),vcLDA(:,:,:)
      Real(8) Exc,univol,rinplw,Ecnl,Ecnl1,Ecnl2,Ecnl3,Ecl,rhomin
      Parameter (rhomin=1.e-6)

      Real(8)  kF,ecLDA,ecLDAd,pi,Zab,wp,wq,q,m,h,e,GxcLDA
      Real(8)  gamma,a,b,C,d,q0,q0i,q0k
      Real(8)  v1,v2,v3,v4
      Parameter (pi=PAI)
      Parameter (e=1.0,m=1.0)
      Parameter (Zab=-0.8491)

      Real(8) T,W,phi,psi
      Real(8) naPhi1,naPhi2,naPhi3,naPhi4
      Real(8) n2nx,n2ny,n2nz,term1,term2,term3,term4,ns,excLDA,&
&      exLDAd,excLDAd,exc0,alfa1,alfa2,alfa3,alfa4,vcik,vcik1, &
&      vcik2,vcik3,q0dx,q0dy,q0dz,LD1,LD2,vii,vcii,v1d,v1dd,v2d,v2dd,&
&      v3d,v4d,Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24,Td,  &
&      Tdd,Tddk,iv12,iv13,iv14,iv23,iv24,iv34

! Estimate running time
      Real(8) time
      Integer hh,mm,ss

!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------

      Allocate(C6(0:nx-1,0:ny-1,0:nz-1))
      Allocate(dxrho(nx,ny,nz))
      Allocate(d2xrho(nx,ny,nz))
      Allocate(dyrho(nx,ny,nz))
      Allocate(d2yrho(nx,ny,nz))
      Allocate(dzrho(nx,ny,nz))
      Allocate(d2zrho(nx,ny,nz))
      Allocate(dxyrho(nx,ny,nz))
      Allocate(dxzrho(nx,ny,nz))
      Allocate(dyzrho(nx,ny,nz))
      Allocate(rho(nx,ny,nz))
      Allocate(vcnl(nx,ny,nz))
      Allocate(vc(nx,ny,nz))
      Allocate(vcLDA(nx,ny,nz))

      Do cix = 1,nx
      Do ciy = 1,ny
      Do ciz = 1,nz
         vcnl(cix,ciy,ciz)=0
         vcLDA(cix,ciy,ciz)=0
         vc(cix,ciy,ciz)=0
         C6(0:cix-1,0:ciy-1,0:ciz-1)=0
         dxrho(cix,ciy,ciz)=0
         dyrho(cix,ciy,ciz)=0
         dzrho(cix,ciy,ciz)=0
         d2xrho(cix,ciy,ciz)=0
         d2yrho(cix,ciy,ciz)=0
         d2zrho(cix,ciy,ciz)=0
         dxyrho(cix,ciy,ciz)=0
         dxzrho(cix,ciy,ciz)=0
         dyzrho(cix,ciy,ciz)=0

      End Do
      End Do
      End Do
      rho=0
      vcnlxyz=0
      da=0
      nb = na
      db = da

      dx = altv(1,1)/Real(nx)
      dy = altv(2,2)/Real(ny)
      dz = altv(3,3)/Real(nz)
      dv = dx*dy*dz

      Do cix = 1,nx
      Do ciy = 1,ny
      Do ciz = 1,nz
         nrxyz=(ciz-1)*nffty*(nfftx)+(ciy-1)*(nfftx)+cix
         !!if(nrxyz<ista .or. nrxyz>iend) cycle
         rho(cix,ciy,ciz) = rhoxyz(nrxyz,1)
      End Do
      End Do
      End Do


!++++  Calculate the coefficients of the asymptotic function. ++++
      ax = dx*nx
      ay = dy*ny
      az = dz*nz

      Do cix = 1,nx
      Do ciy = 1,ny
      Do ciz = 1,nz
         C6(cix-1,ciy-1,ciz-1) = 0
      End Do
      End Do
      End Do

      Do ckx = 0,nx-1
      Do cky = 0,ny-1
      Do ckz = 0,nz-1
         Do tx=-1*eta2,eta2
         Do ty=-1*eta2,eta2
         Do tz=-1*eta2,eta2

            rxyz= &
&  ((ckx*dx+tx*ax)**2 + (cky*dy+ty*ay)**2 + (ckz*dz+tz*az)**2)**0.5

         If(rxyz.GT.eta1) Then
            C6(ckx,cky,ckz) = C6(ckx,cky,ckz) + (rxyz**(-6))
         End If

         End Do
         End Do
         End Do
      End Do
      End Do
      End Do
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


!########  Call d_rho and obtain differential of the rho #########
   Call d_rho(nx,ny,nz,dx,dy,dz,rho,dxrho,dyrho,dzrho&
&              ,d2xrho,d2yrho,d2zrho,dxyrho,dxzrho,dyzrho)
!#################################################################


!############## Call gauleg for Gauss-Legendre integral ##########
      Call gauleg(a1,a2,na,xi,wi)
!#################################################################


      Allocate(phi1dD(-ndel:ndel,-1:nphiD+1))
      Allocate(phi2dD(-ndel:ndel,-1:nphiD+1))
      Allocate(phi3dD(-ndel:ndel,-1:nphiD+1))
      Allocate(phi4dD(-ndel:ndel,-1:nphiD+1))

      Do cdel = -ndel,ndel
      Do cphiD = -1,nphiD+1
         phi1dD(cdel,cphiD) = 0
         phi2dD(cdel,cphiD) = 0
         phi3dD(cdel,cphiD) = 0
         phi4dD(cdel,cphiD) = 0
      End Do
      End Do

!######################  Call Phi1 to Phi4  ######################
  If(iteration.GE.1.AND.iteration.LT.iterstart) Then
  Else
   Call calPhi1(maxD,minD,etai,eta1,na,xi,wi,ndel,nphiD,phi1dD)
   Call calPhi2(maxD,minD,etai,eta1,na,xi,wi,ndel,nphiD,phi2dD)
   Call calPhi3(maxD,minD,etai,eta1,na,xi,wi,ndel,nphiD,phi3dD)
  End If
   Call calPhi4(maxD,minD,etai,eta1,na,xi,wi,ndel,nphiD,phi4dD)
!#################################################################

      Call CPU_TIME(time)
      ss=time
      hh=time/3600
      ss=Mod(ss,3600)
      mm=ss/60
      ss=Mod(ss,60)
      time=time-3600*hh-60*mm-ss

      Ecnl  = 0
!!!!!!!!!!!!!!!!! Hot Spot !!!!!!!!!!!!!!
!$OMP  PARALLEL DO &
!$OMP& DEFAULT(SHARED) &
!$OMP& PRIVATE(cix,ciy,ciz,ni,nb,db,gamma,dv,kF,rs,x,  &
!$OMP&  nnx,nny,nnz,nn2,n2nx,n2ny,n2nz,term1,term2,term3,term4,  &
!$OMP&  ns,exLDAd,ecLDAd,excLDAd,lcx,hcx,&
!$OMP&  lcy,hcy,lcz,hcz,ckx,cky,ckz,r,nk,di,dk,vcik,vcik1,vcik2, &
!$OMP&  cD,C,psi,maxDii,minDii,q0,q0i,q0k,q0dx,q0dy,q0dz,LD1,LD2,vii,vcii,alfa1,alfa2,alfa3,alfa4,  &
!$OMP&  a,b,h,v1,v1d,v1dd,v2,v2d,v2dd,v3,v3d,v4,naPhi1,naPhi2,naPhi3,naPhi4,   &
!$OMP&  v4d,W,Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24,Td,Tdd, &
!$OMP&  Tddk,iv12,iv13,iv14,iv23,iv24,iv34,GxcLDA,excLDA,exc0,   &
!$OMP&  ddel,del,cdel,phiD,cphiD,phix,phiy,phi) &
!$OMP&  REDUCTION(+:Ecnl)
      Do cir = 1,nx*ny*nz
         cix = 1+(cir-MOD(cir-1+ny*nz,ny*nz)+1)/(ny*nz)
         ciy = 1+(cir-ny*nz*(cix-1)-(MOD(cir-1+nz,nz)+1))/nz
         ciz = (cir-ny*nz*(cix-1)-nz*(ciy-1))
         nrxyz=(ciz-1)*nffty*(nfftx)+(ciy-1)*(nfftx)+cix
         if(nrxyz<ista .or. nrxyz>iend) cycle

         naPhi1 = 0
         naPhi2 = 0
         naPhi3 = 0
         naPhi4 = 0

         ni = rho(cix,ciy,ciz)
         If(ni.GT.rhomin) Then

!######################  Call Phi1 to Phi4  ######################

   If(iteration.GE.0.AND.iteration.LT.iterstart) Then
   Else

   Call Phi1(maxD,minD,etai,eta1,na,xi,wi,nx,ny,nz,dx,dy,dz,rho,cix,ciy      &
&            ,ciz,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho,C6,ndel,nphiD,phi1dD,naPhi1)
   Call Phi2(maxD,minD,etai,eta1,na,xi,wi,nx,ny,nz,dx,dy,dz,rho,cix,ciy,ciz  &
&             ,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho                        &
&             ,dxyrho,dxzrho,dyzrho,C6,ndel,nphiD,phi2dD,naPhi2)
   Call Phi3(maxD,minD,etai,eta1,na,xi,wi,nx,ny,nz,dx,dy,dz,rho,cix,ciy,ciz  &
&             ,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho,C6,ndel,nphiD,phi3dD,naPhi3)
   End If

   If(iteration.GE.0.AND.iteration.LT.8) Then
   Else
   Call Phi4(maxD,minD,etai,eta1,na,xi,wi,nx,ny,nz,dx,dy,dz,rho,cix,ciy,ciz  &
&             ,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho,C6,ndel,nphiD,phi4dD,naPhi4)
   End If
!#################################################################

         vcnl(cix,ciy,ciz)= &
&           naPhi1 + naPhi2 + naPhi3 + naPhi4

         Ecnl = Ecnl + 0.5*ni*naPhi4

         End If
      End Do
!$OMP END PARALLEL DO
!!!!!!!!!!!!! End Hot Spot !!!!!!!!!!!!!!
      Ecnl = dv*Ecnl

      Call CPU_TIME(time)
      ss=time
      hh=time/3600
      ss=Mod(ss,3600)
      mm=ss/60
      ss=Mod(ss,60)
      time=time-3600*hh-60*mm-ss


!++++++++++++++++++++++  Calculate vcLDA  ++++++++++++++++++++++++
      Ecl = 0
      Do cjx = 1,nx
      Do cjy = 1,ny
      Do cjz = 1,nz
         nrxyz=(cjz-1)*nffty*(nfftx)+(cjy-1)*(nfftx)+cjx
         if(nrxyz<ista .or. nrxyz>iend) cycle

         nj = rho(cjx,cjy,cjz)

       If(nj.GT.rhomin) then

         rs = (3/(4*pi*nj))**0.3333333333333333
         x = rs/11.4

         term1 = (36*pi*(nj**4))**0.33333333333333333
         ecLDAd = -0.0333*(3*x*x*Log(1+1/x)-3*x+1.5-1/x)/(11.4*term1)

         GxcLDA = 0.5*((1+x**3)*Log(1+1/x)-x**2+x/2-1/3)
         ecLDA = -0.0666*GxcLDA

         vcLDA(cjx,cjy,cjz) = ecLDAd*nj + ecLDA
         Ecl = Ecl + dv*nj*ecLDA

       End If

      End Do
      End Do
      End Do
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      Exc = Exc + (Ecnl + Ecl)/(univol*rinplw)

      Do cix = 1,nx
      Do ciy = 1,ny
      Do ciz = 1,nz
         nrxyz = (ciz-1)*nffty*nfftx+(ciy-1)*nfftx+cix
         if(nrxyz<ista .or. nrxyz>iend) cycle
         vc(cix,ciy,ciz) = vcnl(cix,ciy,ciz) + vcLDA(cix,ciy,ciz)
         !vcnlxyz(nrxyz,1) = vcnlxyz(nrxyz,1) + vc(cix,ciy,ciz)
         vcnlxyz(nrxyz,1) = vc(cix,ciy,ciz)
      End Do
      End Do
      End Do


      Deallocate(C6)
      Deallocate(dxrho)
      Deallocate(d2xrho)
      Deallocate(dyrho)
      Deallocate(d2yrho)
      Deallocate(dzrho)
      Deallocate(d2zrho)
      Deallocate(dxyrho)
      Deallocate(dxzrho)
      Deallocate(dyzrho)
      Deallocate(rho)
      Deallocate(vcnl)
      Deallocate(vc)
      Deallocate(vcLDA)
      Deallocate(phi1dD)
      Deallocate(phi2dD)
      Deallocate(phi3dD)
      Deallocate(phi4dD)



   End Subroutine vc_nl



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
 
 
!** SUBROUTINE CPU_TIME ************************
      Subroutine CPU_TIME(time)
      Real(8) time
      Integer count,count_rate,hh,mm,ss
 
      Call System_clock(count,count_rate)
      If(count_rate.Eq.0) Then
         time=Real(count)/count_rate
      Else
         time=-1
      End If
 
      End Subroutine CPU_TIME
!** End SUBROUTINE CPU_TIME ********************





   Subroutine d_rho(nx,ny,nz,dx,dy,dz,rho,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho&
&                      ,dxyrho,dxzrho,dyzrho)
!$   use omp_lib
      Implicit None


!************************ Note *********************************
! This Algorism calculates the differential of the rho.
!
! Input
!   nx,ny,nz,dx,dy,dz,rho       : Information of the unit cell 
!                                 and the electron density.
!
! Output
!   drho,d2rho                  : 1st and 2nd order differential
!                                 of the rho.     
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  nx,ny,nz,cjx,cjy,cjz,i,j,k
      Real(8)  dx,dy,dz,nspin,dv,nj

      Real(8)  ::  rn(3,-3:3),rx(3,-3:3),ry(3,-3:3),rz(3,-3:3)
      Integer  ::  zx(-3:3),zy(-3:3),zz(-3:3)

      Real(8)  nxp,nxm,nyp,nym,nzp,nzm &
&             ,nxpyp,nxpym,nxmyp,nxmym &
&             ,nxpzp,nxpzm,nxmzp,nxmzm &
&             ,nypzp,nypzm,nymzp,nymzm 

      Real(8) :: rho(nx,ny,nz),dxrho(nx,ny,nz),d2xrho(nx,ny,nz) &
&                             ,dyrho(nx,ny,nz),d2yrho(nx,ny,nz) &
&                             ,dzrho(nx,ny,nz),d2zrho(nx,ny,nz) &
&           ,dxyrho(nx,ny,nz),dxzrho(nx,ny,nz),dyzrho(nx,ny,nz)
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      Do cjx = 1,nx
      Do cjy = 1,ny
      Do cjz = 1,nz

         Do j = -3,3
            zx(j) = MOD(2*nx+(cjx+j)-1,nx)+1
            zy(j) = MOD(2*ny+(cjy+j)-1,ny)+1
            zz(j) = MOD(2*nz+(cjz+j)-1,nz)+1

            rn(1,j) = rho(zx(j),cjy,cjz)
            rn(2,j) = rho(cjx,zy(j),cjz)
            rn(3,j) = rho(cjx,cjy,zz(j))
         End Do

         dxrho(cjx,cjy,cjz) = &
&           (rn(1,3)-9*rn(1,2)+45*rn(1,1)-45*rn(1,-1)+9*rn(1,-2)-rn(1,-3))/(60*dx)
         dyrho(cjx,cjy,cjz) = &
&           (rn(2,3)-9*rn(2,2)+45*rn(2,1)-45*rn(2,-1)+9*rn(2,-2)-rn(2,-3))/(60*dy)
         dzrho(cjx,cjy,cjz) = &
&           (rn(3,3)-9*rn(3,2)+45*rn(3,1)-45*rn(3,-1)+9*rn(3,-2)-rn(3,-3))/(60*dz)

      End Do
      End Do
      End Do



      Do cjx = 1,nx
      Do cjy = 1,ny
      Do cjz = 1,nz

         Do j = -3,3
            zx(j) = MOD(2*nx+(cjx+j)-1,nx)+1
            zy(j) = MOD(2*ny+(cjy+j)-1,ny)+1
            zz(j) = MOD(2*nz+(cjz+j)-1,nz)+1

            rn(1,j)  =  rho(zx(j),cjy,cjz)
            rn(2,j)  =  rho(cjx,zy(j),cjz)
            rn(3,j)  =  rho(cjx,cjy,zz(j))

            rx(1,j) = dxrho(zx(j),cjy,cjz)
            rx(2,j) = dxrho(cjx,zy(j),cjz)
            rx(3,j) = dxrho(cjx,cjy,zz(j))

            ry(1,j) = dyrho(zx(j),cjy,cjz)
            ry(2,j) = dyrho(cjx,zy(j),cjz)
            ry(3,j) = dyrho(cjx,cjy,zz(j))

            rz(1,j) = dzrho(zx(j),cjy,cjz)
            rz(2,j) = dzrho(cjx,zy(j),cjz)
            rz(3,j) = dzrho(cjx,cjy,zz(j))
         End Do

         d2xrho(cjx,cjy,cjz) = &
&           (rx(1,3)-9*rx(1,2)+45*rx(1,1)-45*rx(1,-1)+9*rx(1,-2)-rx(1,-3))/(60*dx)
         d2yrho(cjx,cjy,cjz) = &
&           (ry(2,3)-9*ry(2,2)+45*ry(2,1)-45*ry(2,-1)+9*ry(2,-2)-ry(2,-3))/(60*dy)
         d2zrho(cjx,cjy,cjz) = &
&           (rz(3,3)-9*rz(3,2)+45*rz(3,1)-45*rz(3,-1)+9*rz(3,-2)-rz(3,-3))/(60*dz)

         dxyrho(cjx,cjy,cjz) = &
&           (ry(1,3)-9*ry(1,2)+45*ry(1,1)-45*ry(1,-1)+9*ry(1,-2)-ry(1,-3))/(60*dx)
         dyzrho(cjx,cjy,cjz) = &
&           (rz(2,3)-9*rz(2,2)+45*rz(2,1)-45*rz(2,-1)+9*rz(2,-2)-rz(2,-3))/(60*dy)
         dxzrho(cjx,cjy,cjz) = &
&           (rx(3,3)-9*rx(3,2)+45*rx(3,1)-45*rx(3,-1)+9*rx(3,-2)-rx(3,-3))/(60*dz)

      End Do
      End Do
      End Do



   End Subroutine d_rho



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine gauleg(x1,x2,n,xi,wi)
     use m_Const_Parameters, only : PAI
!$   use omp_lib
      Implicit none

!************************ Note *********************************
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  m,j,i,n
      Real(8)  x1,x2,z1,z,xm,xl,pp,p3,p2,p1,pi,eta
      Parameter (pi=PAI , eta=0.0000000001)

      Real(8)  ::  xi(n),wi(n)
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      m=(n+1)/2
      xm=0.5*(x2+x1)
      xl=0.5*(x2-x1)
      z1=0.d0
      Do i=1,m
         z=COS(pi*(i-0.25)/(n+0.5))

         Do While (ABS(z-z1).GT.eta)
            p1=1.0
            p2=0.0

            Do j=1,n
               p3=p2
               P2=p1
               p1=((2.0*j-1.0)*z*p2-(j-1.0)*p3)/j
            End Do

            pp=n*(z*p1-p2)/(z*z-1.0)
            z1=z
            z=z1-p1/pp
            
         End Do

         xi(i) = xm-xl*z
         xi(n+1-i) = xm+xl*z
         wi(i) = 2.0*xl/((1.0-z*z)*pp*pp)
         wi(n+1-i) = wi(i)

      End Do


! End of Subroutine gauleg
   End Subroutine gauleg



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine calPhi1(maxD,minD,etai,eta1,na,xi,wi,ndel,nphiD,phi1dD)
     use m_Const_Parameters, only : PAI
!$   use omp_lib
      Implicit None


!************************ Note *********************************
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  ci,cj,ck,ca,cb,na,nb

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Real(8) ddel,dphiD,del,phiD,tmp,phix,phiy,maxD,minD,etai,eta1
      Integer ndel,cdel,nphiD,cphiD,cdelD
      Real(8) phi1dD(-ndel:ndel,-1:nphiD+1)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk,r
      Integer  i,j,k

      Real(8)  eta
      Parameter (eta=0.0000000001)

      Real(8)  kF,excLDAd,exLDAd,ecLDAd,pi,Zab,wp,wq,q,m,h,e
      Real(8)  gamma,a,b,C,d
      Real(8)  v1,v2,v3,v4,v1d,v2d
      Parameter (pi=PAI)
      Parameter (e=1,m=1)
      Parameter (Zab=-0.8491)

      Real(8) T,W,phi,psi,Tv1,Tv2
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      gamma = 4*pi/9

! phi(del,phiD)
      ddel = 1/Real(ndel+1)
      dphiD = (maxD-minD)/(Real(nphiD))


!$OMP  PARALLEL DO &
!$OMP& DEFAULT(SHARED) &
!$OMP& PRIVATE(cdel,cphiD,del,phiD,di,dk,phi,ca,cb,a,b,  &
!$OMP&  h,v1,v1d,v2,v2d,v3,v4,W,Tv1,Tv2)

   Do cdel = -ndel,ndel
   Do cphiD = -1,nphiD+1

      del = Real(cdel)*ddel
      phiD = minD + Real(cphiD)*dphiD
      
      di = phiD*(1+del)
      dk = phiD*(1-del)

      phi = 0
      Do ca=1,na
      Do cb=1,na
         a = xi(ca)
         b = xi(cb)

         h = 1-Exp(-gamma*((a/di)**2)) 
         v1 = (a**2)/(2*h)
         v1d = -4*pi*(a**4)*(h-1)/(9*(di**3)*(h**2))

         h = 1-Exp(-gamma*((b/di)**2)) 
         v2 = (b**2)/(2*h)
         v2d = -4*pi*(b**4)*(h-1)/(9*(di**3)*(h**2))

         h = 1-Exp(-gamma*((a/dk)**2)) 
         v3 = (a**2)/(2*h)

         h = 1-Exp(-gamma*((b/dk)**2)) 
         v4 = (b**2)/(2*h)

         W = 2*((3-a*a)*b*Cos(b)*Sin(a) + (3-b*b)*a*Cos(a)*Sin(b)           &
&            + (a*a+b*b-3)*Sin(a)*Sin(b)                                    &
&            -3*a*b*Cos(a)*Cos(b))/((a*b)**3)

         Tv1 = ((1/((v1+v2)**2))*(1/((v1+v3)*(v2+v4))+1/((v1+v4)*(v2+v3)))  &
&              +(1/(v1+v2)+1/(v3+v4))                                       &
&              *(1/(((v1+v3)**2)*(v2+v4))+1/(((v1+v4)**2)*(v2+v3))))*(-0.5)

         Tv2 = ((1/((v1+v2)**2))*(1/((v1+v3)*(v2+v4))+1/((v1+v4)*(v2+v3)))  &
&              +(1/(v1+v2)+1/(v3+v4))                                       &
&              *(1/((v1+v3)*((v2+v4)**2))+1/((v1+v4)*((v2+v3)**2))))*(-0.5)

         phi = phi + &
&              wi(ca)*wi(cb)*((a*b)**2)*W*(Tv1*v1d+Tv2*v2d)

      End Do
      End Do

      phi = phi * 2*m*(e**4)/(pi**2)

      phi1dD(cdel,cphiD) = phi

   End Do
   End Do
!$OMP END PARALLEL DO

   End Subroutine calPhi1



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine calPhi2(maxD,minD,etai,eta1,na,xi,wi,ndel,nphiD,phi2dD)
     use m_Const_Parameters, only : PAI
!$   use omp_lib
      Implicit None


!************************ Note *********************************
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  ci,cj,ck,ca,cb,na,nb

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Real(8) ddel,dphiD,del,phiD,tmp,phix,phiy,maxD,minD,etai,eta1
      Integer ndel,cdel,nphiD,cphiD,cdelD
      Real(8) phi2dD(-ndel:ndel,-1:nphiD+1)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk,r
      Integer  i,j,k

      Real(8)  eta
      Parameter (eta=0.0000000001)

      Real(8)  kF,excLDAd,exLDAd,ecLDAd,pi,Zab,wp,wq,q,m,h,e
      Real(8)  gamma,a,b,C,d
      Parameter (pi=PAI)
      Parameter (e=1.0,m=1.0)
      Parameter (Zab=-0.8491)

      Real(8) T,W,phi,psi,vcik,vcik1,vcik2,vcii,vii
      Real(8) Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24,Tdd
      Real(8) v1,v2,v3,v4,v1d,v2d,v3d,v4d,v1dd,v2dd

      Real(8) term1,term2,term3,term4,ns
      Real(8) iv12,iv13,iv14,iv23,iv24,iv34
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      gamma = 4*pi/9

! phi(del,phiD)
      ddel = 1/Real(ndel+1)
      dphiD = (maxD-minD)/(Real(nphiD))


!$OMP  PARALLEL DO &
!$OMP& DEFAULT(SHARED) &
!$OMP& PRIVATE(cdel,cphiD,del,phiD,di,dk,phi,ca,cb,a,b,  &
!$OMP&  h,v1,v1d,v1dd,v2,v2d,v2dd,v3,v4,W,               &
!$OMP&  iv12,iv13,iv14,iv23,iv24,iv34,Tv1,Tv2,Tv11,Tv22,Tv12,Tdd)

   Do cdel = -ndel,ndel
   Do cphiD = -1,nphiD+1

      del = Real(cdel)*ddel
      phiD = minD + Real(cphiD)*dphiD
      
      di = phiD*(1+del)
      dk = phiD*(1-del)

      phi = 0
      Do ca=1,na
      Do cb=1,na
         a = xi(ca)
         b = xi(cb)

         h = 1-Exp(-gamma*((a/di)**2)) 
         v1 = (a**2)/(2*h)
         v1d = -4*pi*(a**4)*(h-1)/(9*(di**3)*(h**2))
         v1dd = 2*((4*pi*(a**3)/(9*(di**3)))**2)*(1-h)*(2-3*h)/(h**3)

         h = 1-Exp(-gamma*((b/di)**2)) 
         v2 = (b**2)/(2*h)
         v2d = -4*pi*(b**4)*(h-1)/(9*(di**3)*(h**2))
         v2dd = 2*((4*pi*(b**3)/(9*(di**3)))**2)*(1-h)*(2-3*h)/(h**3)

         h = 1-Exp(-gamma*((a/dk)**2)) 
         v3 = (a**2)/(2*h)

         h = 1-Exp(-gamma*((b/dk)**2)) 
         v4 = (b**2)/(2*h)

         W = 2*((3-a*a)*b*Cos(b)*Sin(a) + (3-b*b)*a*Cos(a)*Sin(b)           &
&            + (a*a+b*b-3)*Sin(a)*Sin(b)                                    &
&            -3*a*b*Cos(a)*Cos(b))/((a*b)**3)


         iv12 = 1/(v1+v2)
         iv13 = 1/(v1+v3)
         iv14 = 1/(v1+v4)
         iv23 = 1/(v2+v3)
         iv24 = 1/(v2+v4)
         iv34 = 1/(v3+v4)


         Tv1 = -(1/2)*(iv12**2)*(iv13*iv24+iv14*iv23)              &
&              -(1/2)*(iv12+iv34)*(iv13**2*iv24+iv14**2*iv23)


         Tv2 = -(1/2)*(iv12**2)*(iv13*iv24+iv14*iv23)              &
&              -(1/2)*(iv12+iv34)*(iv13*iv24**2+iv14*iv23**2)


         Tv11 = iv12**3*(iv13*iv24+iv14*iv23)                      &
&              +iv12**2*(iv13**2*iv24+iv14**2*iv23)                &
&              +(iv12+iv34)*(iv13**3*iv24+iv14**3*iv23)


         Tv22 = iv12**3*(iv13*iv24+iv14*iv23)                      &
&              +iv12**2*(iv13*iv24**2+iv14*iv23**2)                &
&              +(iv12+iv34)*(iv13*iv24**3+iv14*iv23**3)


         Tv12 = iv12**3*(iv13*iv24+iv14*iv23)                      &
&              +(1/2)*iv12**2*(iv13*iv24**2+iv14*iv23**2)          &
&              +(1/2)*iv12**2*(iv13**2*iv24+iv14**2*iv23)          &
&              +(iv12+iv34)*(iv13**2*iv24**2+iv14**2*iv23**2)


      Tdd = Tv11*v1d**2 + Tv1*v1dd + Tv22*v2d**2 + Tv2*v2dd + 2*Tv12*v1d*v2d


         phi = phi + &
&              wi(ca)*wi(cb)*((a*b)**2)*W*Tdd

      End Do
      End Do

      phi = phi * 2*m*(e**4)/(pi**2)

      phi2dD(cdel,cphiD) = phi

   End Do
   End Do
!$OMP END PARALLEL DO

   End Subroutine calPhi2



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine calPhi3(maxD,minD,etai,eta1,na,xi,wi,ndel,nphiD,phi3dD)
     use m_Const_Parameters, only : PAI
!$   use omp_lib
      Implicit None

!************************ Note *********************************
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  ci,cj,ck,ca,cb,na,nb

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Real(8) ddel,dphiD,del,phiD,tmp,phix,phiy,maxD,minD,etai,eta1
      Integer ndel,cdel,nphiD,cphiD,cdelD
      Real(8) phi3dD(-ndel:ndel,-1:nphiD+1)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk,r
      Integer  i,j,k

      Real(8)  eta
      Parameter (eta=0.0000000001)

      Real(8)  kF,excLDAd,exLDAd,ecLDAd,pi,Zab,wp,wq,q,m,h,e
      Real(8)  gamma,a,b,C,d
      Parameter (pi=PAI)
      Parameter (e=1,m=1)
      Parameter (Zab=-0.8491)

      Real(8) T,W,phi,psi,vcik,vcik1,vcik2,vcii,vii
      Real(8) Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24,Td,Tdd,Tddk
      Real(8) v1,v2,v3,v4,v1d,v2d,v3d,v4d,v1dd,v2dd

      Real(8) naPhi3,alfa3,term1,term2,term3,term4,ns
      Real(8) iv12,iv13,iv14,iv23,iv24,iv34
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      gamma = 4*pi/9

! phi(del,phiD)
      ddel = 1/Real(ndel+1)
      dphiD = (maxD-minD)/(Real(nphiD))


!$OMP  PARALLEL DO &
!$OMP& DEFAULT(SHARED) &
!$OMP& PRIVATE(cdel,cphiD,del,phiD,di,dk,phi,ca,cb,a,b,  &
!$OMP&  h,v1,v1d,v2,v2d,v3,v3d,v4,v4d,iv12,iv13,iv14,    &
!$OMP&  iv23,iv24,iv34,W,Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24,Td,Tdd,Tddk)

   Do cdel = -ndel,ndel
   Do cphiD = -1,nphiD+1

      del = Real(cdel)*ddel
      phiD = minD + Real(cphiD)*dphiD

      di = phiD*(1+del)
      dk = phiD*(1-del)

      phi = 0
      Do ca=1,na
      Do cb=1,na
         a = xi(ca)
         b = xi(cb)

         h = 1-Exp(-gamma*((a/di)**2)) + eta
         v1 = (a**2)/(2*h)
         v1d = -4*pi*(a**4)*(h-1)/(9*(di**3)*(h**2))
         v1dd = 2*((4*pi*(a**3)/(9*(di**3)))**2)*(1-h)*(2-3*h)/(h**3)

         h = 1-Exp(-gamma*((b/di)**2)) + eta
         v2 = (b**2)/(2*h)
         v2d = -4*pi*(b**4)*(h-1)/(9*(di**3)*(h**2))
         v2dd = 2*((4*pi*(b**3)/(9*(di**3)))**2)*(1-h)*(2-3*h)/(h**3)

         h = 1-Exp(-gamma*((a/dk)**2)) + eta
         v3 = (a**2)/(2*h)
         v3d = -4*pi*(a**4)*(h-1)/(9*(di**3)*(h**2))

         h = 1-Exp(-gamma*((b/dk)**2)) + eta
         v4 = (b**2)/(2*h)
         v4d = -4*pi*(b**4)*(h-1)/(9*(di**3)*(h**2))

         W = 2*((3-a*a)*b*Cos(b)*Sin(a) + (3-b*b)*a*Cos(a)*Sin(b)           &
&            + (a*a+b*b-3)*Sin(a)*Sin(b)                                    &
&            -3*a*b*Cos(a)*Cos(b))/((a*b)**3)

         iv12 = 1/(v1+v2)
         iv13 = 1/(v1+v3)
         iv14 = 1/(v1+v4)
         iv23 = 1/(v2+v3)
         iv24 = 1/(v2+v4)
         iv34 = 1/(v3+v4)


         Tv1 = -(1/2)*(iv12**2)*(iv13*iv24 + iv14*iv23)              &
&              -(1/2)*(iv12 + iv34)*(iv13**2*iv24 + iv14**2*iv23)


         Tv2 = -(1/2)*(iv12**2)*(iv13*iv24 + iv14*iv23)              &
&              -(1/2)*(iv12 + iv34)*(iv13*iv24**2 + iv14*iv23**2)


         Tv11 = iv12**3*(iv13*iv24 + iv14*iv23)                      &
&              +iv12**2*(iv13**2*iv24 + iv14**2*iv23)                &
&              +(iv12 + iv34)*(iv13**3*iv24 + iv14**3*iv23)


         Tv22 = iv12**3*(iv13*iv24 + iv14*iv23)                      &
&              +iv12**2*(iv13*iv24**2 + iv14*iv23**2)                &
&              +(iv12 + iv34)*(iv13*iv24**3 + iv14*iv23**3)


         Tv12 = iv12**3*(iv13*iv24 + iv14*iv23)                      &
&              +(1/2)*iv12**2*(iv13*iv24**2 + iv14*iv23**2)          &
&              +(1/2)*iv12**2*(iv13**2*iv24 + iv14**2*iv23)          &
&              +(iv12 + iv34)*(iv13**2*iv24**2 + iv14**2*iv23**2)

         Tv13 = (1/2)*( iv12**2*(iv13**2*iv14 + iv14*iv23**2)        &
&              +iv34**2*(iv13**2*iv14 + iv14**2*iv23)                &
&              +(iv12 + iv34)*(2*iv13**3*iv14 + iv14**2*iv23**2) )


         Tv14 = (1/2)*( iv12**2*(iv13*iv14**2 + iv14**2*iv23)        &
&              +iv34**2*(iv13**2*iv14 + iv14**2*iv23)                &
&              +(iv12 + iv34)*(iv13**2*iv14**2 + 2*iv14**3*iv23) )


         Tv23 = (1/2)*( iv12**2*(iv13**2*iv14 + iv14*iv23**2)        &
&              +iv34**2*(iv13*iv14**2 + iv14*iv23**2)                &
&              +(iv12 + iv34)*(iv13**2*iv14**2 + 2*iv14*iv23**3) )


         Tv24 = (1/2)*( iv12**2*(iv13*iv14**2 + iv14**2*iv23)        &
&              +iv34**2*(iv13*iv14**2 + iv14*iv23**2)                &
&              +(iv12 + iv34)*(2*iv13*iv14**3 + iv14**2*iv23**2) )


      Td   = Tv1*v1d+Tv2*v2d
      Tdd  = Tv11*v1d**2 + Tv1*v1dd + Tv22*v2d**2 + Tv2*v2dd + 2*Tv12*v1d*v2d
      Tddk = Tv13*v3d*v1d + Tv14*v4d*v1d + Tv23*v3d*v2d + Tv14*v4d*v2d

         phi = phi + &
&              wi(ca)*wi(cb)*((a*b)**2)*W*(Td + di*Tdd + dk*Tddk)

      End Do
      End Do

      phi = phi * 2*m*(e**4)/(pi**2)

      phi3dD(cdel,cphiD) = phi

   End Do
   End Do
!$OMP END PARALLEL DO

   End Subroutine calPhi3



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine calPhi4(maxD,minD,etai,eta1,na,xi,wi,ndel,nphiD,phi4dD)
     use m_Const_Parameters, only : PAI
!$   use omp_lib
      Implicit None


!************************ Note *********************************
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  ci,cj,ck,ca,cb,na,nb

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Real(8) ddel,dphiD,del,phiD,tmp,phix,phiy,maxD,minD,etai,eta1
      Integer ndel,cdel,nphiD,cphiD,cdelD
      Real(8)  :: phi4dD(-ndel:ndel,-1:nphiD+1)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk,r
      Integer  i,j,k

      Real(8)  eta
      Parameter (eta=0.0000000001)

      Real(8)  kF,excLDAd,exLDAd,ecLDAd,pi,Zab,wp,wq,q,m,h,e
      Real(8)  gamma,a,b,C,d
      Parameter (pi=PAI)
      Parameter (e=1.0,m=1.0)
      Parameter (Zab=-0.8491)

      Real(8) T,W,phi,psi,vcik,vcik1,vcik2,vcii,vii
      Real(8) Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24,Tdd
      Real(8) v1,v2,v3,v4,v1d,v2d,v3d,v4d,v1dd,v2dd

      Real(8) term1,term2,term3,term4,ns
      Real(8) iv12,iv13,iv14,iv23,iv24,iv34
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++
      gamma = 4*pi/9

! phi(del,phiD)
      ddel = 1/Real(ndel+1)
      dphiD = (maxD-minD)/(Real(nphiD))


!$OMP  PARALLEL DO &
!$OMP& DEFAULT(SHARED) &
!$OMP& PRIVATE(cdel,cphiD,del,phiD,di,dk,phi,ca,cb,a,b,  &
!$OMP&  h,v1,v2,v3,v4,W,T)

   Do cdel = -ndel,ndel
   Do cphiD = -1,nphiD+1

      del = Real(cdel)*ddel
      phiD = minD + Real(cphiD)*dphiD
      
      di = phiD*(1+del)
      dk = phiD*(1-del)

      phi = 0
      Do ca=1,na
      Do cb=1,na
         a = xi(ca)
         b = xi(cb)

         h = 1-Exp(-gamma*((a/di)**2)) + eta
         v1 = (a**2)/(2*h)

         h = 1-Exp(-gamma*((b/di)**2)) + eta
         v2 = (b**2)/(2*h)

         h = 1-Exp(-gamma*((a/dk)**2)) + eta
         v3 = (a**2)/(2*h)

         h = 1-Exp(-gamma*((b/dk)**2)) + eta
         v4 = (b**2)/(2*h)

         W = 2*((3-a*a)*b*Cos(b)*Sin(a) + (3-b*b)*a*Cos(a)*Sin(b)&
&            + (a*a+b*b-3)*Sin(a)*Sin(b)&
&            -3*a*b*Cos(a)*Cos(b))/((a*b)**3)

         T = 0.5*(1/(v1+v2) + 1/(v3+v4) )&
&            *(1/((v1+v3)*(v2+v4)) + 1/((v1+v4)*(v2+v3)))

         phi = phi + &
&              wi(ca)*wi(cb)*((a*b)**2)*W*T

      End Do
      End Do

      phi = phi * 2*m*(e**4)/(pi**2)

      phi4dD(cdel,cphiD) = phi

   End Do
   End Do
!$OMP END PARALLEL DO

   End Subroutine calPhi4



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine d_q0(nx,ny,nz,n,nnx,nny,nnz,q0)
     use m_Const_Parameters, only : PAI
!$   use omp_lib
      Implicit None


!************************ Note *********************************
! This program calculates q0 and d.
!
! Input
!   rho(nrxyz,nsipn) : Total density
!
! Output
!   q0               : 
!
!
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  nx,ny,nz,nspin
      Double Precision n,rs,x,nnx,nny,nnz,nn2,r,term1,term2,term3

      Double precision  kF,exc0,exLDA,excLDA,pi,Zab,q0,m,h,e,GxcLDA,eta
      Parameter (pi=PAI)
      Parameter (e=1.0,m=1.0)
      Parameter (Zab=-0.8491)

!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      nn2 = (nnx**2)+(nny**2)+(nnz**2)

      rs = (3/(4*pi*n))**0.3333333333333333

! Eq.(58), (59) (p.93-94) of Theory of the Inhomogeneous Electron gas.
! S.Lundqvist and N.H.March 1983 Plenum Press, NY
      x = rs/11.4
      GxcLDA = 0.5*((1+x**3)*Log(1+1/x)-x**2+x/2-1/3)
      excLDA = -0.458/rs-0.0666*GxcLDA

      kF = (3*pi*pi*n)**0.3333333333333333
      exLDA = -3*e*kF/(4*pi)

! Eq.(12) of Dion PRL92,246401
      term1 = exLDA*Zab*nn2/(6*kF*n)
      term2 = term1/(6*kF*n)

      exc0 = excLDA - term2


! Eq.(11) of Dion PRL92,246401
      q0 = exc0*kF/exLDA



   End Subroutine d_q0



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine Phi1(maxD,minD,etai,eta1,na,xi,wi,nx,ny,nz,dx,dy,dz,rho,cix,ciy &
&           ,ciz,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho,C6,ndel,nphiD,phi1dD,naPhi1)
     use m_Const_Parameters, only : PAI
!$   use omp_lib
      Implicit None

!************************ Note *********************************
!
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  nx,ny,nz,nspin
      Real(8) da,db,a1,a2
      Integer  ci,cj,ck,ca,cb,na,nb
      Parameter (a1=0,a2=60)

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Real(8) ddel,dphiD,del,phiD,phix,phiy,maxD,minD
      Integer ndel,cdel,nphiD,cphiD
      Real(8) phi1dD(-ndel:ndel,-1:nphiD+1)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk
      Integer  i,j,k,zxp,zxm,zyp,zym,zzp,zzm

      Real(8)  eta,etai,eta1
      Parameter (eta=0.0000000001)

      Real(8) rs,r,x,nnx,nny,nnz,nn2,n2nx,n2ny,n2nz
      Real(8) :: rho(nx,ny,nz),Eii(nx,ny,nz)
      Real(8) :: dxrho(nx,ny,nz),d2xrho(nx,ny,nz) &
&               ,dyrho(nx,ny,nz),d2yrho(nx,ny,nz) &
&               ,dzrho(nx,ny,nz),d2zrho(nx,ny,nz)
      Real(8) rhomin
      Parameter (rhomin=1.e-6)

      Real(8)  kF,excLDAd,exLDAd,ecLDAd,pi,Zab,wp,wq,q,m,h,e
      Real(8)  gamma,a,b,C,d,q0,q0i,q0k
      Real(8)  v1,v2,v3,v4
      Parameter (pi=PAI)
      Parameter (e=1.0,m=1.0)
      Parameter (Zab=-0.8491)

      Real(8) :: C6(0:nx-1,0:ny-1,0:nz-1)

      Real(8) T,W,phi,psi,vcik,vcik1,vcik2,vcii,vii
      Real(8) Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24
      Real(8) v1d,v2d,v3d,v4dd

      Real(8) naPhi1,alfa1,term1,term2,ns

      integer cD,nD
      parameter (nD=100)
      real(8) minDii,maxDii,LD1,LD2,PLD,LDxi(nD),LDwi(nD)
      parameter (minDii=0)
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      nb = na
      da=0
      db = da
      gamma = 4*pi/9

      dv = dx*dy*dz
      ni = rho(cix,ciy,ciz)
      kF = (3*pi*pi*ni)**0.3333333333333333
      rs = (3/(4*pi*ni))**0.3333333333333333
      x = rs/11.4

      vcik1=0
      If(ni.GT.rhomin) Then

      nnx = dxrho(cix,ciy,ciz)
      nny = dyrho(cix,ciy,ciz)      
      nnz = dzrho(cix,ciy,ciz)
      nn2 = (nnx**2)+(nny**2)+(nnz**2)

      Call d_q0(nx,ny,nz,ni,nnx,nny,nnz,q0i)

! Calculate the coefficient alfa1.
      n2nx = d2xrho(cix,ciy,ciz)
      n2ny = d2yrho(cix,ciy,ciz)      
      n2nz = d2zrho(cix,ciy,ciz)
      term1 = n2nx+n2ny+n2nz 
      term2 = ((((pi/(3*ni))**0.666666666666667)/kF)+(1/ni))*nn2
      ns = (term1-term2)/(2*kF*ni)
      term1 = (36*pi*(ni**4))**0.33333333333333333
      exLDAd = -0.458/((rs**2)*term1)
      ecLDAd = -0.0333*(3*x*x*Log(1+1/x)-3*x+1.5-1/x)/(11.4*term1)
      excLDAd = exLDAd + ecLDAd
      alfa1 = ((zab*ns/9)+(7*zab*nn2/(3*9*4*kF*ni*ni))-(4*pi*ni*excLDAd/3))/q0i

      lcx = cix - Nint(eta1/dx)
      hcx = cix + Nint(eta1/dx)
      lcy = ciy - Nint(eta1/dy)
      hcy = ciy + Nint(eta1/dy)
      lcz = ciz - Nint(eta1/dz)
      hcz = ciz + Nint(eta1/dz)

      Do ckx = lcx,hcx
      Do cky = lcy,hcy
      Do ckz = lcz,hcz
      r =                              &
&        ((REAL(cix-ckx)*dx)**2        &
&       + (REAL(ciy-cky)*dy)**2        &
&       + (REAL(ciz-ckz)*dz)**2)**0.5

   If(r.Lt.eta1.AND.r.Ge.etai) Then

         cx=MOD(20*nx+ckx-1,nx)+1
         cy=MOD(20*ny+cky-1,ny)+1
         cz=MOD(20*nz+ckz-1,nz)+1
         nk = rho(cx,cy,cz)
      If(nk.GT.rhomin) Then

      nnx = dxrho(cx,cy,cz)
      nny = dyrho(cx,cy,cz)      
      nnz = dzrho(cx,cy,cz)

      Call d_q0(nx,ny,nz,nk,nnx,nny,nnz,q0k)
      di = r*q0i + eta
      dk = r*q0k + eta

      ddel = 1/Real(ndel+1)
      del = ((di-dk)/(di+dk))
      cdel = AINT(del/ddel)
      phiD = (di+dk)/2

      If(phiD.LT.maxD.AND.phiD.GT.minD) then
         cphiD = AINT(REAL(nphiD)*(phiD-minD)/(maxD-minD))

         phix = del/ddel - REAL(cdel)
         phiy = REAL(nphiD)*(phiD-minD)/(maxD-minD) - REAL(cphiD)

         phi =  (1-phix)*(1-phiy) * phi1dD(cdel  ,cphiD  )  &
&              +   phix *(1-phiy) * phi1dD(cdel+1,cphiD  )  &
&              +(1-phix)*   phiy  * phi1dD(cdel  ,cphiD+1)  &
&              +   phix *   phiy  * phi1dD(cdel+1,cphiD+1)
      End If


! vcik1 is the non-local correlation potential 
! v_c^nl summated for (etai < rik < eta1).
      vcik1 = vcik1 + dv*alfa1*di*phi*nk

      End If

   End If

      End Do
      End Do
      End Do
         End If



   vcik2 = 0
   If(ni.GT.rhomin) Then
   C = 12*m*(e**4)*((4*pi/9)**3)

   Do ckx = 1,nx
   Do cky = 1,ny
   Do ckz = 1,nz
   nk = rho(ckx,cky,ckz)
   If(nk.GT.rhomin) Then

      nnx = dxrho(ckx,cky,ckz)
      nny = dyrho(ckx,cky,ckz)      
      nnz = dzrho(ckx,cky,ckz)
      Call d_q0(nx,ny,nz,nk,nnx,nny,nnz,q0k)

      psi = 2*(3*q0i**2+q0k**2)/(q0i**3*q0k**2*(q0i**2+q0k**2)**2)

! vcik2 is the non-local correlation potential 
! v_c^nl summated for ( eta1 < rik ).
      vcik2 = vcik2 + dv*alfa1*C*q0i*psi*nk &
&      *C6(ABS(cix-ckx),ABS(ciy-cky),ABS(ciz-ckz))

   End If

   End Do
   End Do
   End Do

   End If



   vcik = vcik1 + vcik2



   vii=0
   vcii=0
   cjx=cix
   cjy=ciy
   cjz=ciz
      n = rho(cix,ciy,ciz)
   If(n.GT.rhomin) Then

      nnx = dxrho(cjx,cjy,cjz)
      nny = dyrho(cjx,cjy,cjz)      
      nnz = dzrho(cjx,cjy,cjz)
      Call d_q0(nx,ny,nz,n,nnx,nny,nnz,q0k)
      q0 = q0k

      maxDii = q0*etai

      Call gauleg(minDii,maxDii,nD,LDxi,LDwi)
!      Call gauleg(a1,a2,na,xi,wi)
      
      Do cD=1,nD
         LD1 = LDxi(cD)
         LD2 = LD1

         di = LD1
         dk = LD2

      phi = 0

      Do ca=1,na
      Do cb=1,na

         a = xi(ca)
         b = xi(cb)

         h = 1-Exp(-gamma*((a/di)**2)) + eta
         v1 = (a**2)/(2*h)
         v1d = -4*pi*(a**4)*(h-1)/(9*(di**3)*(h**2))

         h = 1-Exp(-gamma*((b/di)**2)) + eta
         v2 = (b**2)/(2*h)
         v2d = -4*pi*(b**4)*(h-1)/(9*(di**3)*(h**2))

         h = 1-Exp(-gamma*((a/dk)**2)) + eta
         v3 = (a**2)/(2*h)

         h = 1-Exp(-gamma*((b/dk)**2)) + eta
         v4 = (b**2)/(2*h)

         W = 2*((3-a*a)*b*Cos(b)*Sin(a) + (3-b*b)*a*Cos(a)*Sin(b)           &
&            + (a*a+b*b-3)*Sin(a)*Sin(b)                                    &
&            -3*a*b*Cos(a)*Cos(b))/((a*b)**3)

         Tv1 = ((1/((v1+v2)**2))*(1/((v1+v3)*(v2+v4))+1/((v1+v4)*(v2+v3)))  &
&              +(1/(v1+v2)+1/(v3+v4))                                       &
&              *(1/(((v1+v3)**2)*(v2+v4))+1/(((v1+v4)**2)*(v2+v3))))*(-0.5)

         Tv2 = ((1/((v1+v2)**2))*(1/((v1+v3)*(v2+v4))+1/((v1+v4)*(v2+v3)))  &
&              +(1/(v1+v2)+1/(v3+v4))                                       &
&              *(1/((v1+v3)*((v2+v4)**2))+1/((v1+v4)*((v2+v3)**2))))*(-0.5)

         phi = phi + &
&              wi(ca)*wi(cb)*((a*b)**2)*W*(Tv1*v1d+Tv2*v2d)

      End Do
      End Do

      phi = phi * 2*m*(e**4)/(pi**2)

      vii = vii + LDwi(cD)*4*pi*(LD1**2)*phi

      End Do


! vcii is the non-local correlation potential 
! v_c^nl summated for ( rik < etai ).
      vcii = alfa1*n*vii/(q0**3)

   End If

   naPhi1 = vcik1 + vcik2 + vcii



! End of Phi1
   End Subroutine Phi1



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine Phi2(maxD,minD,etai,eta1,na,xi,wi,nx,ny,nz,dx,dy,dz,rho,cix,ciy,ciz  &
&                     ,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho               &
&                     ,dxyrho,dxzrho,dyzrho,C6,ndel,nphiD,phi2dD,naPhi2)
     use m_Const_Parameters, only : PAI
!$   use omp_lib
      Implicit None


!************************ Note *********************************
!
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  nx,ny,nz,nspin
      Real(8) da,db,a1,a2
      Integer  ci,cj,ck,ca,cb,na,nb
      Parameter (a1=0,a2=60)

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Real(8) ddel,dphiD,del,phiD,phix,phiy,maxD,minD
      Integer ndel,cdel,nphiD,cphiD
      Real(8) phi2dD(-ndel:ndel,-1:nphiD+1)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk
      Integer  i,j,k,zxp,zxm,zyp,zym,zzp,zzm

      Real(8)  eta,etai,eta1
      Parameter (eta=0.0000000001)

      Real(8) rs,r,x,nnx,nny,nnz,nn2,n2nx,n2ny,n2nz,nxy,nxz,nyz
      Real(8) ::      rho(nx,ny,nz),Eii(nx,ny,nz)
      Real(8) ::      dxrho(nx,ny,nz),d2xrho(nx,ny,nz) &
&                    ,dyrho(nx,ny,nz),d2yrho(nx,ny,nz) &
&                    ,dzrho(nx,ny,nz),d2zrho(nx,ny,nz) &
&  ,dxyrho(nx,ny,nz),dxzrho(nx,ny,nz),dyzrho(nx,ny,nz)

      Real(8) rhomin
      Parameter (rhomin=1.e-6)

      Real(8)  kF,GxcLDA,excLDA,excLDAd,exLDAd,ecLDAd,pi,Zab,wp,wq,q,m,h,e
      Real(8)  gamma,a,b,C,d,q0,q0i,q0k,q0dx,q0dy,q0dz
      Parameter (pi=PAI)
      Parameter (e=1.0,m=1.0)
      Parameter (Zab=-0.8491)

      Real(8) :: C6(0:nx-1,0:ny-1,0:nz-1)

      Real(8) T,W,phi,psi,vcik,vcik1,vcik2,vcii,vii
      Real(8) Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24,Tdd
      Real(8) v1,v2,v3,v4,v1d,v2d,v3d,v4d,v1dd,v2dd

      Real(8) naPhi2,alfa2,term1,term2,term3,term4,ns
      Real(8) iv12,iv13,iv14,iv23,iv24,iv34

      integer cD,nD
      parameter (nD=100)
      real(8) minDii,maxDii,LD1,LD2,PLD,LDxi(nD),LDwi(nD)
      parameter (minDii=0)
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      nb = na
      da=0
      db = da
      gamma = 4*pi/9

      dv = dx*dy*dz
      ni = rho(cix,ciy,ciz)
      kF = (3*pi*pi*ni)**0.3333333333333333
      rs = (3/(4*pi*ni))**0.3333333333333333
      x = rs/11.4

      vcik1=0
      If(ni.GT.rhomin) Then

      nnx = dxrho(cix,ciy,ciz)
      nny = dyrho(cix,ciy,ciz)      
      nnz = dzrho(cix,ciy,ciz)
      nn2 = (nnx**2)+(nny**2)+(nnz**2)

      Call d_q0(nx,ny,nz,ni,nnx,nny,nnz,q0i)



!********* Calculate the coefficient alfa2. *********
      n2nx = d2xrho(cix,ciy,ciz)
      n2ny = d2yrho(cix,ciy,ciz)      
      n2nz = d2zrho(cix,ciy,ciz)
      nxy = dxyrho(cix,ciy,ciz)
      nxz = dxzrho(cix,ciy,ciz)
      nyz = dyzrho(cix,ciy,ciz)

! Eq.(58), (59) (p.93-94) of Theory of the Inhomogeneous Electron gas.
! S.Lundqvist and N.H.March 1983 Plenum Press, NY
      GxcLDA = 0.5*((1+x**3)*Log(1+1/x)-x**2+x/2-1/3)
      excLDA = -0.458/rs-0.0666*GxcLDA
      
      term1 = (36*pi*(ni**4))**0.33333333333333333
      exLDAd = -0.458/((rs**2)*term1)
      ecLDAd = -0.0333*(3*x*x*Log(1+1/x)-3*x+1.5-1/x)/(11.4*term1)
      excLDAd = exLDAd + ecLDAd

! q0dx
      term1 = -nnx*(4*pi/3)*(excLDAd*ni+excLDA)
      term2 = nn2*nnx*(((pi*pi*ni/9)**0.33333333333333333)+2*kF)/(-4*(kF**2)*(ni**3))
      term3 = 2*( nnx*n2nx + nny*nxy + nnz*nxz )/(4*kF*(ni**2))
      term4 = -(Zab/9)*(term2+term3)
      q0dx = term1 + term4

! q0dy
      term1 = -nny*(4*pi/3)*(excLDAd*ni+excLDA)
      term2 = nn2*nny*(((pi*pi*ni/9)**0.33333333333333333)+2*kF)/(-4*(kF**2)*(ni**3))
      term3 = 2*( nnx*nxy + nny*n2ny + nnz*nyz )/(4*kF*(ni**2))
      term4 = -(Zab/9)*(term2+term3)
      q0dy = term1 + term4

! q0dz
      term1 = -nnz*(4*pi/3)*(excLDAd*ni+excLDA)
      term2 = nn2*nnz*(((pi*pi*ni/9)**0.33333333333333333)+2*kF)/(-4*(kF**2)*(ni**3))
      term3 = 2*( nnx*nxz + nny*nyz + nnz*n2nz )/(4*kF*(ni**2))
      term4 = -(Zab/9)*(term2+term3)
      q0dz = term1 + term4

      term1 = ( nnx*q0dx + nny*q0dy + nnz*q0dz )/(2*kF*ni)

      alfa2 = (Zab/9)*term1/(q0i**2)
!******** End Calculating coefficient alfa2. ********



      lcx = cix - Nint(eta1/dx)
      hcx = cix + Nint(eta1/dx)
      lcy = ciy - Nint(eta1/dy)
      hcy = ciy + Nint(eta1/dy)
      lcz = ciz - Nint(eta1/dz)
      hcz = ciz + Nint(eta1/dz)

      Do ckx = lcx,hcx
      Do cky = lcy,hcy
      Do ckz = lcz,hcz
      r = (((cix-ckx)*dx)**2 + ((ciy-cky)*dy)**2 + ((ciz-ckz)*dz)**2)**0.5

   If(r.LT.eta1.AND.r.GE.etai) Then

         cx=MOD(20*nx+ckx-1,nx)+1
         cy=MOD(20*ny+cky-1,ny)+1
         cz=MOD(20*nz+ckz-1,nz)+1
         nk = rho(cx,cy,cz)
      If(nk.GT.rhomin) Then

      nnx = dxrho(cx,cy,cz)
      nny = dyrho(cx,cy,cz)      
      nnz = dzrho(cx,cy,cz)

      Call d_q0(nx,ny,nz,nk,nnx,nny,nnz,q0k)
      di = r*q0i + eta
      dk = r*q0k + eta

      ddel = 1/Real(ndel+1)
      del = ((di-dk)/(di+dk))
      cdel = AINT(del/ddel)
      phiD = (di+dk)/2

      If(phiD.LT.maxD.AND.phiD.GT.minD) then
         cphiD = AINT(REAL(nphiD)*(phiD-minD)/(maxD-minD))

         phix = del/ddel - REAL(cdel)
         phiy = REAL(nphiD)*(phiD-minD)/(maxD-minD) - REAL(cphiD)

         phi =  (1-phix)*(1-phiy) * phi2dD(cdel  ,cphiD  )  &
&              +   phix *(1-phiy) * phi2dD(cdel+1,cphiD  )  &
&              +(1-phix)*   phiy  * phi2dD(cdel  ,cphiD+1)  &
&              +   phix *   phiy  * phi2dD(cdel+1,cphiD+1)
      End If

! vcik1 is the non-local correlation potential 
! v_c^nl summated for (etai < rik < eta1).
      vcik1 = vcik1 + dv*alfa2*(di**2)*phi*nk

      End If

   End If

      End Do
      End Do
      End Do
         End If



   vcik2 = 0
   If(ni.GT.rhomin) Then
   C = 12*m*(e**4)*((4*pi/9)**3)

   Do ckx = 1,nx
   Do cky = 1,ny
   Do ckz = 1,nz
   nk = rho(ckx,cky,ckz)
   If(nk.GT.rhomin) Then

      nnx = dxrho(ckx,cky,ckz)
      nny = dyrho(ckx,cky,ckz)      
      nnz = dzrho(ckx,cky,ckz)
      Call d_q0(nx,ny,nz,nk,nnx,nny,nnz,q0k)

      psi = -2*(15*q0i**4+10*(q0i*q0k)**2+3*q0k**4) &
&             /(q0i**4*q0k**2*(q0i**2+q0k**2)**3)

! vcik2 is the non-local correlation potential 
! v_c^nl summated for ( eta1 < rik ).
      vcik2 = vcik2 + dv*alfa2*C*(q0i**2)*psi*nk &
&      *C6(ABS(cix-ckx),ABS(ciy-cky),ABS(ciz-ckz))

   End If

   End Do
   End Do
   End Do

   End If



   vcik = vcik1 + vcik2



   vcii=0
   vii=0
   cjx=cix
   cjy=ciy
   cjz=ciz
      n = rho(cix,ciy,ciz)
   If(n.GT.rhomin) Then

      nnx = dxrho(cjx,cjy,cjz)
      nny = dyrho(cjx,cjy,cjz)      
      nnz = dzrho(cjx,cjy,cjz)
      Call d_q0(nx,ny,nz,n,nnx,nny,nnz,q0k)
      q0 = q0k

      maxDii = q0*etai

      Call gauleg(minDii,maxDii,nD,LDxi,LDwi)
!      Call gauleg(a1,a2,na,xi,wi)
      
      Do cD=1,nD
         LD1 = LDxi(cD)
         LD2 = LD1

         di = LD1
         dk = LD2

      phi = 0

      Do ca=1,na
      Do cb=1,na

         a = xi(ca)
         b = xi(cb)

         h = 1-Exp(-gamma*((a/di)**2)) + eta
         v1 = (a**2)/(2*h)
         v1d = -4*pi*(a**4)*(h-1)/(9*(di**3)*(h**2))
         v1dd = 2*((4*pi*(a**3)/(9*(di**3)))**2)*(1-h)*(2-3*h)/(h**3)

         h = 1-Exp(-gamma*((b/di)**2)) + eta
         v2 = (b**2)/(2*h)
         v2d = -4*pi*(b**4)*(h-1)/(9*(di**3)*(h**2))
         v2dd = 2*((4*pi*(b**3)/(9*(di**3)))**2)*(1-h)*(2-3*h)/(h**3)

         h = 1-Exp(-gamma*((a/dk)**2)) + eta
         v3 = (a**2)/(2*h)

         h = 1-Exp(-gamma*((b/dk)**2)) + eta
         v4 = (b**2)/(2*h)

         W = 2*((3-a*a)*b*Cos(b)*Sin(a) + (3-b*b)*a*Cos(a)*Sin(b)           &
&            + (a*a+b*b-3)*Sin(a)*Sin(b)                                    &
&            -3*a*b*Cos(a)*Cos(b))/((a*b)**3)


         iv12 = 1/(v1+v2)
         iv13 = 1/(v1+v3)
         iv14 = 1/(v1+v4)
         iv23 = 1/(v2+v3)
         iv24 = 1/(v2+v4)
         iv34 = 1/(v3+v4)


         Tv1 = -(1/2)*(iv12**2)*(iv13*iv24+iv14*iv23)              &
&              -(1/2)*(iv12+iv34)*(iv13**2*iv24+iv14**2*iv23)


         Tv2 = -(1/2)*(iv12**2)*(iv13*iv24+iv14*iv23)              &
&              -(1/2)*(iv12+iv34)*(iv13*iv24**2+iv14*iv23**2)


         Tv11 = iv12**3*(iv13*iv24+iv14*iv23)                      &
&              +iv12**2*(iv13**2*iv24+iv14**2*iv23)                &
&              +(iv12+iv34)*(iv13**3*iv24+iv14**3*iv23)


         Tv22 = iv12**3*(iv13*iv24+iv14*iv23)                      &
&              +iv12**2*(iv13*iv24**2+iv14*iv23**2)                &
&              +(iv12+iv34)*(iv13*iv24**3+iv14*iv23**3)


         Tv12 = iv12**3*(iv13*iv24+iv14*iv23)                      &
&              +(1/2)*iv12**2*(iv13*iv24**2+iv14*iv23**2)          &
&              +(1/2)*iv12**2*(iv13**2*iv24+iv14**2*iv23)          &
&              +(iv12+iv34)*(iv13**2*iv24**2+iv14**2*iv23**2)


         Tdd = Tv11*v1d**2 + Tv1*v1dd + Tv22*v2d**2 + Tv2*v2dd + 2*Tv12*v1d*v2d
         
         phi = phi + &
&              wi(ca)*wi(cb)*((a*b)**2)*W*Tdd

      End Do
      End Do

      phi = phi * 2*m*(e**4)/(pi**2)

      vii = vii + LDwi(cD)*4*pi*(LD1**2)*phi

      End Do


! vcii is the non-local correlation potential 
! v_c^nl summated for ( rik < etai ).
      vcii = alfa2*n*vii/(q0**3)

   End If

   naPhi2 = vcik1 + vcik2 + vcii



! End of Phi2
   End Subroutine Phi2



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine Phi3(maxD,minD,etai,eta1,na,xi,wi,nx,ny,nz,dx,dy,dz,rho,cix,ciy,ciz  &
&                     ,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho,C6,ndel,nphiD,phi3dD,naPhi3)
     use m_Const_Parameters, only : PAI
!$   use omp_lib
      Implicit None


!************************ Note *********************************
!
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  nx,ny,nz,nspin
      Real(8) da,db
      Integer  ci,cj,ck,ca,cb,na,nb

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Real(8) ddel,dphiD,del,phiD,phix,phiy,maxD,minD
      Integer ndel,cdel,nphiD,cphiD
      Real(8) phi3dD(-ndel:ndel,-1:nphiD+1)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk
      Integer  i,j,k,zxp,zxm,zyp,zym,zzp,zzm

      Real(8)  eta,etai,eta1
      Parameter (eta=0.0000000001)

      Real(8) rs,r,x,nnx,nny,nnz,nn2,n2nx,n2ny,n2nz,nxy,nxz,nyz
      Real(8) ::      rho(nx,ny,nz),Eii(nx,ny,nz)
      Real(8) ::      dxrho(nx,ny,nz),d2xrho(nx,ny,nz) &
&                    ,dyrho(nx,ny,nz),d2yrho(nx,ny,nz) &
&                    ,dzrho(nx,ny,nz),d2zrho(nx,ny,nz)

      Real(8) rhomin
      Parameter (rhomin=1.e-6)

      Real(8)  kF,GxcLDA,excLDA,excLDAd,exLDAd,ecLDAd,pi,Zab,wp,wq,q,m,h,e
      Real(8)  gamma,a,b,C,d,q0,q0i,q0k,q0dx,q0dy,q0dz
      Parameter (pi=PAI)
      Parameter (e=1.0,m=1.0)
      Parameter (Zab=-0.8491)

      Real(8) :: C6(0:nx-1,0:ny-1,0:nz-1)

      Real(8) T,W,phi,psi,vcik,vcik1,vcik2,vcii,vii
      Real(8) Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24,Td,Tdd,Tddk
      Real(8) v1,v2,v3,v4,v1d,v2d,v3d,v4d,v1dd,v2dd

      Real(8) naPhi3,alfa3,term1,term2,term3,term4,ns
      Real(8) iv12,iv13,iv14,iv23,iv24,iv34
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      nb = na
      da=0
      db = da
      gamma = 4*pi/9

      dv = dx*dy*dz
      ni = rho(cix,ciy,ciz)
      kF = (3*pi*pi*ni)**0.3333333333333333
      rs = (3/(4*pi*ni))**0.3333333333333333
      x = rs/11.4

      vcik1=0
      If(ni.GT.rhomin) Then

      nnx = dxrho(cix,ciy,ciz)
      nny = dyrho(cix,ciy,ciz)      
      nnz = dzrho(cix,ciy,ciz)
      nn2 = (nnx**2)+(nny**2)+(nnz**2)

      Call d_q0(nx,ny,nz,ni,nnx,nny,nnz,q0i)

      lcx = cix - Nint(eta1/dx)
      hcx = cix + Nint(eta1/dx)
      lcy = ciy - Nint(eta1/dy)
      hcy = ciy + Nint(eta1/dy)
      lcz = ciz - Nint(eta1/dz)
      hcz = ciz + Nint(eta1/dz)



      Do ckx = lcx,hcx
      Do cky = lcy,hcy
      Do ckz = lcz,hcz
      r =                              &
&        ((REAL(cix-ckx)*dx)**2        &
&       + (REAL(ciy-cky)*dy)**2        &
&       + (REAL(ciz-ckz)*dz)**2)**0.5

   If(r.LT.eta1.AND.r.GE.etai) Then


!********* Calculate the coefficient alfa3. *********
      term1 = (REAL(cix-ckx)*dx)*nnx
      term2 = (REAL(ciy-cky)*dy)*nny
      term3 = (REAL(ciz-ckz)*dz)*nnz
      alfa3 = (Zab/9)*(1/(2*kF*ni))*(term1+term2+term3)
!******** End Calculating coefficient alfa3. ********


         cx=MOD(20*nx+ckx-1,nx)+1
         cy=MOD(20*ny+cky-1,ny)+1
         cz=MOD(20*nz+ckz-1,nz)+1
         nk = rho(cx,cy,cz)
      If(nk.GT.rhomin) Then

      nnx = dxrho(cx,cy,cz)
      nny = dyrho(cx,cy,cz)      
      nnz = dzrho(cx,cy,cz)

      Call d_q0(nx,ny,nz,nk,nnx,nny,nnz,q0k)
      di = r*q0i + eta
      dk = r*q0k + eta

      ddel = 1/Real(ndel+1)
      del = ((di-dk)/(di+dk))
      cdel = AINT(del/ddel)
      phiD = (di+dk)/2

      If(phiD.LT.maxD.AND.phiD.GT.minD) then
         cphiD = AINT(REAL(nphiD)*(phiD-minD)/(maxD-minD))

         phix = del/ddel - REAL(cdel)
         phiy = REAL(nphiD)*(phiD-minD)/(maxD-minD) - REAL(cphiD)

         phi =  (1-phix)*(1-phiy) * phi3dD(cdel  ,cphiD  )  &
&              +   phix *(1-phiy) * phi3dD(cdel+1,cphiD  )  &
&              +(1-phix)*   phiy  * phi3dD(cdel  ,cphiD+1)  &
&              +   phix *   phiy  * phi3dD(cdel+1,cphiD+1)
      End If

! vcik1 is the non-local correlation potential 
! v_c^nl summated for (etai < rik < eta1).
      vcik1 = vcik1 + dv*alfa3*phi*nk

      End If

   End If

      End Do
      End Do
      End Do
         End If



   vcik2 = 0

   vcik = vcik1 + vcik2

   vcii=0

   naPhi3 = vcik1 + vcik2 + vcii



! End of Phi3
   End Subroutine Phi3



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine Phi4(maxD,minD,etai,eta1,na,xi,wi,nx,ny,nz,dx,dy,dz,rho,cix,ciy,ciz  &
&                  ,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho,C6,ndel,nphiD,phi4dD,naPhi4)
     use m_Const_Parameters, only : PAI
!$   use omp_lib
      Implicit None

!************************ Note *********************************
!
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  nx,ny,nz,nspin
      Real(8) da,db,a1,a2
      Integer  ci,cj,ck,ca,cb,na,nb
      Parameter (a1=0,a2=60)

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Real(8) ddel,dphiD,del,phiD,phix,phiy,maxD,minD
      Integer ndel,cdel,nphiD,cphiD
      Real(8) :: phi4dD(-ndel:ndel,-1:nphiD+1)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk
      Integer  i,j,k,zxp,zxm,zyp,zym,zzp,zzm

      Real(8)  eta,etai,eta1
      Parameter (eta=0.0000000001)

      Real(8) rs,x,nnx,nny,nnz,nn2,r,zo
      Real(8) :: rho(nx,ny,nz),Eii(nx,ny,nz)
      Real(8) :: dxrho(nx,ny,nz),d2xrho(nx,ny,nz) &
&               ,dyrho(nx,ny,nz),d2yrho(nx,ny,nz) &
&               ,dzrho(nx,ny,nz),d2zrho(nx,ny,nz)
      Real(8) rhomin
      Parameter (rhomin=1.e-6)

      Real(8)  kF,exc0,exLDA,excLDA,pi,Zab,wp,wq,q,m,h,e,GxcLDA
      Real(8)  gamma,a,b,C,d,q0,q0i,q0k
      Real(8)  v1,v2,v3,v4
      Parameter (pi=PAI)
      Parameter (e=1.0,m=1.0)
      Parameter (Zab=-0.8491)

      Real(8) :: C6(0:nx-1,0:ny-1,0:nz-1)

      Real(8) T,W,phi,psi,vcik,vcik1,vcik2,vcii,vii

      Real(8) naPhi4,alfa4

      integer cD,nD
      parameter (nD=100)
      real(8) minDii,maxDii,LD1,LD2,PLD,LDxi(nD),LDwi(nD)
      parameter (minDii=0)
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------

      alfa4=1
      nb = na
      da=0
      db = da
      gamma = 4*pi/9

      dv = dx*dy*dz
      ni = rho(cix,ciy,ciz)

      vcik1=0
      If(ni.GT.rhomin) Then

      nnx = dxrho(cix,ciy,ciz)
      nny = dyrho(cix,ciy,ciz)      
      nnz = dzrho(cix,ciy,ciz)
      Call d_q0(nx,ny,nz,ni,nnx,nny,nnz,q0i)

      lcx = cix - Nint(eta1/dx)
      hcx = cix + Nint(eta1/dx)
      lcy = ciy - Nint(eta1/dy)
      hcy = ciy + Nint(eta1/dy)
      lcz = ciz - Nint(eta1/dz)
      hcz = ciz + Nint(eta1/dz)

!      Do ckx = cix,cix ! lcx,hcx
!      Do cky = ciy,ciy ! lcy,hcy
!      Do ckz = ciz,ciz ! lcz,hcz
      Do ckx = lcx,hcx
      Do cky = lcy,hcy
      Do ckz = lcz,hcz
      r = (((cix-ckx)*dx)**2 + ((ciy-cky)*dy)**2 + ((ciz-ckz)*dz)**2)**0.5

   If(r.LT.eta1.AND.r.GE.etai) Then

         cx=MOD(20*nx+ckx-1,nx)+1
         cy=MOD(20*ny+cky-1,ny)+1
         cz=MOD(20*nz+ckz-1,nz)+1
         nk = rho(cx,cy,cz)
      If(nk.GT.rhomin) Then

      nnx = dxrho(cx,cy,cz)
      nny = dyrho(cx,cy,cz)      
      nnz = dzrho(cx,cy,cz)
      Call d_q0(nx,ny,nz,nk,nnx,nny,nnz,q0k)
      di = r*q0i + eta
      dk = r*q0k + eta

      ddel = 1/Real(ndel+1)
      del = ((di-dk)/(di+dk))
      cdel = AINT(del/ddel)
      phiD = (di+dk)/2

      If(phiD.LT.maxD.AND.phiD.GT.minD) then
         cphiD = AINT(REAL(nphiD)*(phiD-minD)/(maxD-minD))

         phix = del/ddel - REAL(cdel)
         phiy = REAL(nphiD)*(phiD-minD)/(maxD-minD) - REAL(cphiD)

         phi =  (1-phix)*(1-phiy) * phi4dD(cdel  ,cphiD  )  &
&              +   phix *(1-phiy) * phi4dD(cdel+1,cphiD  )  &
&              +(1-phix)*   phiy  * phi4dD(cdel  ,cphiD+1)  &
&              +   phix *   phiy  * phi4dD(cdel+1,cphiD+1)
      End If


! vcik1 is the non-local correlation potential 
! v_c^nl summated for (etai < rik < eta1).
      vcik1 = vcik1 + dv*alfa4*phi*nk

      End If

   End If

      End Do
      End Do
      End Do
         End If



   vcik2 = 0
   If(ni.GT.rhomin) Then
   C = 12*m*(e**4)*((4*pi/9)**3)

   Do ckx = 1,nx
   Do cky = 1,ny
   Do ckz = 1,nz
   nk = rho(ckx,cky,ckz)
   If(nk.GT.rhomin) Then

      nnx = dxrho(ckx,cky,ckz)
      nny = dyrho(ckx,cky,ckz)      
      nnz = dzrho(ckx,cky,ckz)
      Call d_q0(nx,ny,nz,nk,nnx,nny,nnz,q0k)

      psi = (((q0i*q0k)**2)*(q0i**2+q0k**2))**(-1)

! vcik2 is the non-local correlation potential 
! v_c^nl summated for ( eta1 < rik ).
      vcik2 = vcik2 -1*dv*C*psi*nk &
&      *C6(ABS(cix-ckx),ABS(ciy-cky),ABS(ciz-ckz))

   End If

   End Do
   End Do
   End Do

   End If



!   vcik = vcik1 + vcik2



   vcii = 0
   vii=0
   cjx=cix
   cjy=ciy
   cjz=ciz
      n = rho(cix,ciy,ciz)
   If(n.GT.rhomin) Then

      nnx = dxrho(cjx,cjy,cjz)
      nny = dyrho(cjx,cjy,cjz)      
      nnz = dzrho(cjx,cjy,cjz)
      Call d_q0(nx,ny,nz,n,nnx,nny,nnz,q0k)
      q0 = q0k

      maxDii = q0*etai

      Call gauleg(minDii,maxDii,nD,LDxi,LDwi)
!      Call gauleg(a1,a2,na,xi,wi)
      
      Do cD=1,nD
         LD1 = LDxi(cD)
         LD2 = LD1

         di = LD1
         dk = LD2

      phi = 0
!      Do ca=1,nD
!      Do cb=1,nD

!         a = LDxi(ca)
!         b = LDxi(cb)

      Do ca=1,na
      Do cb=1,na

         a = xi(ca)
         b = xi(cb)

         h = 1-Exp(-gamma*((a/di)**2)) + eta
         v1 = (a**2)/(2*h)

         h = 1-Exp(-gamma*((b/di)**2)) + eta
         v2 = (b**2)/(2*h)

         h = 1-Exp(-gamma*((a/dk)**2)) + eta
         v3 = (a**2)/(2*h)

         h = 1-Exp(-gamma*((b/dk)**2)) + eta
         v4 = (b**2)/(2*h)

         W = 2*((3-a*a)*b*Cos(b)*Sin(a) + (3-b*b)*a*Cos(a)*Sin(b)&
&            + (a*a+b*b-3)*Sin(a)*Sin(b)&
&            -3*a*b*Cos(a)*Cos(b))/((a*b)**3)

         T = 0.5*(1/(v1+v2) + 1/(v3+v4) )&
&            *(1/((v1+v3)*(v2+v4)) + 1/((v1+v4)*(v2+v3)))

         phi = phi + &
&              wi(ca)*wi(cb)*((a*b)**2)*W*T

      End Do
      End Do

      phi = phi * 2*m*(e**4)/(pi**2)

      vii = vii + LDwi(cD)*4*pi*(LD1**2)*phi

      End Do


! vcii is the non-local correlation potential 
! v_c^nl summated for ( rik < etai ).
      vcii = 2*alfa4*n*vii/(q0**3)

   End If

   naPhi4 = vcik1 + vcik2 + vcii



! End of Phi4
   End Subroutine Phi4

!================================================
!  Software name : STM
!  Module : m_Charge_File
!  Subroutine(s) : m_CF_rd_Header_For_Cube
!  Author(s)     : Junichiro Koga (June 24, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

module m_Charge_File
! $Id: m_Charge_File.F90,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
  use m_Const_Parameters,     only : DP
  implicit none

  integer nchg_type
  integer :: natm2, natm
  real(kind=DP) ::  x_origin,y_origin,z_origin
  real(kind=DP), dimension(3) :: cell1,cell2,cell3
  real(kind=DP), allocatable, dimension(:) :: ival
  real(kind=DP), allocatable, dimension(:,:) :: atom_pos

  integer, dimension(3) :: fft_param
  integer, allocatable, dimension(:) :: iatomtype

contains

  subroutine m_CF_rd_Header_For_Cube(nfcntn_bin)
    integer, intent(in) :: nfcntn_bin
    integer :: i

    read(nfcntn_bin) natm2,x_origin,y_origin,z_origin, natm

    read(nfcntn_bin) fft_param(1), cell1(1:3)
    read(nfcntn_bin) fft_param(2), cell2(1:3)
    read(nfcntn_bin) fft_param(3), cell3(1:3)

    allocate(iatomtype(natm2))
    allocate(ival(natm2))
    allocate(atom_pos(natm2,3))

    do i=1,natm2
      read(nfcntn_bin) iatomtype(i), ival(i), atom_pos(i,1:3)
    enddo

  end subroutine m_CF_rd_Header_For_Cube

end module m_Charge_File

      SUBROUTINE ZUPMTR( SIDE, UPLO, TRANS, M, N, AP, TAU, C, LDC, WORK,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS, UPLO
      INTEGER            INFO, LDC, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         AP( * ), C( LDC, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZUPMTR overwrites the general complex M-by-N matrix C with
*
*                  SIDE = 'L'     SIDE = 'R'
*  TRANS = 'N':      Q * C          C * Q
*  TRANS = 'C':      Q**H * C       C * Q**H
*
*  where Q is a complex unitary matrix of order nq, with nq = m if
*  SIDE = 'L' and nq = n if SIDE = 'R'. Q is defined as the product of
*  nq-1 elementary reflectors, as returned by ZHPTRD using packed
*  storage:
*
*  if UPLO = 'U', Q = H(nq-1) . . . H(2) H(1);
*
*  if UPLO = 'L', Q = H(1) H(2) . . . H(nq-1).
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q**H from the Left;
*          = 'R': apply Q or Q**H from the Right.
*
*  UPLO    (input) CHARACTER*1
*          = 'U': Upper triangular packed storage used in previous
*                 call to ZHPTRD;
*          = 'L': Lower triangular packed storage used in previous
*                 call to ZHPTRD.
*
*  TRANS   (input) CHARACTER*1
*          = 'N':  No transpose, apply Q;
*          = 'C':  Conjugate transpose, apply Q**H.
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  AP      (input) COMPLEX*16 array, dimension
*                               (M*(M+1)/2) if SIDE = 'L'
*                               (N*(N+1)/2) if SIDE = 'R'
*          The vectors which define the elementary reflectors, as
*          returned by ZHPTRD.  AP is modified by the routine but
*          restored on exit.
*
*  TAU     (input) COMPLEX*16 array, dimension (M-1) if SIDE = 'L'
*                                     or (N-1) if SIDE = 'R'
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by ZHPTRD.
*
*  C       (input/output) COMPLEX*16 array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by Q*C or Q**H*C or C*Q**H or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace) COMPLEX*16 array, dimension
*                                   (N) if SIDE = 'L'
*                                   (M) if SIDE = 'R'
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ONE
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            FORWRD, LEFT, NOTRAN, UPPER
      INTEGER            I, I1, I2, I3, IC, II, JC, MI, NI, NQ
      COMPLEX*16         AII, TAUI
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZLARF
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DCONJG, MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
      UPPER = LSAME( UPLO, 'U' )
*
*     NQ is the order of Q
*
      IF( LEFT ) THEN
         NQ = M
      ELSE
         NQ = N
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'C' ) ) THEN
         INFO = -3
      ELSE IF( M.LT.0 ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -9
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZUPMTR', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Q was determined by a call to ZHPTRD with UPLO = 'U'
*
         FORWRD = ( LEFT .AND. NOTRAN ) .OR.
     $            ( .NOT.LEFT .AND. .NOT.NOTRAN )
*
         IF( FORWRD ) THEN
            I1 = 1
            I2 = NQ - 1
            I3 = 1
            II = 2
         ELSE
            I1 = NQ - 1
            I2 = 1
            I3 = -1
            II = NQ*( NQ+1 ) / 2 - 1
         END IF
*
         IF( LEFT ) THEN
            NI = N
         ELSE
            MI = M
         END IF
*
         DO 10 I = I1, I2, I3
            IF( LEFT ) THEN
*
*              H(i) or H(i)' is applied to C(1:i,1:n)
*
               MI = I
            ELSE
*
*              H(i) or H(i)' is applied to C(1:m,1:i)
*
               NI = I
            END IF
*
*           Apply H(i) or H(i)'
*
            IF( NOTRAN ) THEN
               TAUI = TAU( I )
            ELSE
               TAUI = DCONJG( TAU( I ) )
            END IF
            AII = AP( II )
            AP( II ) = ONE
            CALL ZLARF( SIDE, MI, NI, AP( II-I+1 ), 1, TAUI, C, LDC,
     $                  WORK )
            AP( II ) = AII
*
            IF( FORWRD ) THEN
               II = II + I + 2
            ELSE
               II = II - I - 1
            END IF
   10    CONTINUE
      ELSE
*
*        Q was determined by a call to ZHPTRD with UPLO = 'L'.
*
         FORWRD = ( LEFT .AND. .NOT.NOTRAN ) .OR.
     $            ( .NOT.LEFT .AND. NOTRAN )
*
         IF( FORWRD ) THEN
            I1 = 1
            I2 = NQ - 1
            I3 = 1
            II = 2
         ELSE
            I1 = NQ - 1
            I2 = 1
            I3 = -1
            II = NQ*( NQ+1 ) / 2 - 1
         END IF
*
         IF( LEFT ) THEN
            NI = N
            JC = 1
         ELSE
            MI = M
            IC = 1
         END IF
*
         DO 20 I = I1, I2, I3
            AII = AP( II )
            AP( II ) = ONE
            IF( LEFT ) THEN
*
*              H(i) or H(i)' is applied to C(i+1:m,1:n)
*
               MI = M - I
               IC = I + 1
            ELSE
*
*              H(i) or H(i)' is applied to C(1:m,i+1:n)
*
               NI = N - I
               JC = I + 1
            END IF
*
*           Apply H(i) or H(i)'
*
            IF( NOTRAN ) THEN
               TAUI = TAU( I )
            ELSE
               TAUI = DCONJG( TAU( I ) )
            END IF
            CALL ZLARF( SIDE, MI, NI, AP( II ), 1, TAUI, C( IC, JC ),
     $                  LDC, WORK )
            AP( II ) = AII
*
            IF( FORWRD ) THEN
               II = II + NQ - I + 1
            ELSE
               II = II - NQ + I - 2
            END IF
   20    CONTINUE
      END IF
      RETURN
*
*     End of ZUPMTR
*
      END

#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_IODO__
#   define __TIMER_IODO_START(a)   call timer_sta(a)
#   define __TIMER_IODO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_IODO_START(a)
#   define __TIMER_IODO_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif
#ifdef __TIMER_IOCOMM__
#   define __TIMER_IOCOMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_IOCOMM_START(a)       call timer_sta(a)
#   define __TIMER_IOCOMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_IOCOMM_START_w_BARRIER(str,a)
#   define __TIMER_IOCOMM_START(a)
#   define __TIMER_IOCOMM_STOP(a)
#endif

module m_KineticEnergy_Density
  use m_Control_Parameters,  only : nspin, kimg, noncol, &
       &                            use_symm_ekin_density, use_asymm_ekin_density, &
       &                            af

  use m_KPoints,             only : kv3, vkxyz
  use m_Const_Parameters,    only : DP, DIRECT, OFF, ELECTRON, DELTA, BUCS, PAI2, NO, &
       &                            ANTIFERRO
  use m_PlaneWaveBasisSet,    only : kgp, kg1, ngabc, iba, nbase, igf, kg, gr_l, &
       &                             ngpt_l, ista_k, iend_k
  use m_Crystal_Structure,    only : rltv, univol, tau, nopr
  use m_Electronic_Structure, only : zaj_l, occup_l, m_ES_WF_in_Rspace_3D1
  use m_FFT,                  only : m_FFT_alloc_WF_work, m_FFT_dealloc_WF_work, &
       &                             nfft, m_FFT_WF, fft_box_size_WF
  use m_Parallelization,      only : np_e, map_z, map_k, myrank_k, MPI_CommGroup, &
       &                             npes, ista_kngp, iend_kngp, mype
  use m_Files,                only : nfout

! === KT_add === 2014/09/19
  use m_Const_Parameters,   only : YES, NO, EXECUT, SKIP, zi, SIMPLE_CUBIC, PAI, ON
  use m_Control_Parameters,  only : m_CtrlP_cachesize, ndim_magmom, nel_ylm, &
       &                            ekin_density_type, sw_rspace_ekin_density, &
       &                            sw_calc_ekin_density_hardpart, &
       &                            sw_add_ekin_hardpart_on_Gspace, &
       &                            sw_fft_xzy, sw_communicator_for_chg, &
       &                            nblocksize_fftw_is_given, nblocksize_fftw
  use m_Parallelization,     only : nel_fft_z , nel_fft_y, nel_fft_x &
       &                          , np_fft_x, np_fft_y, np_fft_z  &
       &                          , fft_X_x_nel, fft_X_y_nel, fft_X_z_nel  &
       &                          , xyz_fft_x, mp_fft_x, ista_e, iend_e, istep_e &
       &                          , nrank_e, myrank_g, nrank_g, ista_k, iend_k   &
       &                          , nrank_chg, myrank_chg, np_g1k, np_kngp_gw   &
       &                          , ista_kngp_gw, iend_kngp_gw &
       &                          , mpi_ke_world, mpi_chg_world, mpi_kg_world &
       &                          , mpi_k_world, mpi_ge_world, ierr &
       &                          , ista_g1k , iend_g1k, np_g1k, is_kngp, ie_kngp
  use m_Ionic_System,           only : ntyp, ityp, natm, iwei, pos
  use m_Crystal_Structure,    only : nbztyp
  use m_PseudoPotential,    only :  kina_qitg_l, kins_qitg_l, modnrm, nqitg, &
       &                            m_PP_include_vanderbilt_pot, nlmt, dl2p, &
       &                            m_PP_find_maximum_l, &
       &                            m_PP_set_index_arrays1, m_PP_set_index_arrays2, &
       &                            mmesh, nmesh, xh, rmax, ilmt, ltp, mtp, taup, &
       &                            psirpw, phirpw
  use m_PlaneWaveBasisSet,    only : ylm_l, m_pwBS_sphrp2, fp_l
  use m_Charge_Density,       only : map_fft_to_chgq_3D

  use m_FFT,                 only : m_FFT_Direct_3D, m_FFT_Direct_XYZ_3D
#ifdef FFT_3D_DIVISION
  use m_FFT,                 only : m_FFT_Direct_3DIV_3D
#endif
  use m_Realspace,            only : nmesh_rs_aug_max, nmesh_rs_aug, &
       &                             meshx_rs_aug, meshy_rs_aug, meshz_rs_aug, &
       &                             meshxyz_rs_aug, m_RS_R_minus_pos
! ============== 2014/09/19

  use m_Files,  only : nf_ekindens
  use m_Const_Parameters,   only : CMPLDP
  use mpi

  implicit none
!  include 'mpif.h'

  real(kind=DP), allocatable, target :: ekins_l(:,:,:)  ! symmetric, positive definite
  real(kind=DP), allocatable, target :: ekina_l(:,:,:)  ! asymmetric

  real(kind=DP), allocatable, target :: ekins_old(:,:,:)
  real(kind=DP), allocatable, target :: ekina_old(:,:,:)

  real(kind=DP), allocatable :: kins_qrs_rspace(:,:,:,:)
  real(kind=DP), allocatable :: kina_qrs_rspace(:,:,:,:)

  real(kind=DP), public, pointer, dimension(:,:)        :: work

contains

  subroutine m_KE_alloc_ekin_density
    if ( use_symm_ekin_density ) then
       if ( noncol ) then
       else
          allocate( ekins_l(ista_kngp:iend_kngp,kimg,nspin) )
          allocate( ekins_old(ista_kngp:iend_kngp,kimg,nspin) )
       endif
       ekins_l = 0.0d0;   ekins_old = 0.0d0
    endif

    if ( use_asymm_ekin_density ) then
       if ( noncol ) then
       else
          allocate( ekina_l(ista_kngp:iend_kngp,kimg,nspin) )
          allocate( ekina_old(ista_kngp:iend_kngp,kimg,nspin) )
       endif
       ekina_l = 0.0d0;   ekina_old = 0.0d0
    endif
  end subroutine m_KE_alloc_ekin_density

  subroutine m_KE_dealloc_ekin_density
    if ( allocated( ekins_l ) ) deallocate( ekins_l )
    if ( allocated( ekina_l ) ) deallocate( ekina_l )
    if ( allocated( ekins_old ) ) deallocate( ekins_old )
    if ( allocated( ekina_old ) ) deallocate( ekina_old )

    if ( allocated( kins_qrs_rspace ) ) deallocate( kins_qrs_rspace )
  end subroutine m_KE_dealloc_ekin_density

  subroutine m_KE_cp_ekin_density_to_old
    if ( use_symm_ekin_density )  ekins_old = ekins_l
    if ( use_asymm_ekin_density ) ekina_old = ekina_l
  end subroutine m_KE_cp_ekin_density_to_old


  subroutine m_KE_symm_softpart_3D
    integer :: ispin, ik, ib, ixyz, ierr
    integer :: i, ig, ri, iend, i1
    integer :: isrsize, fft_l_size
    integer :: ib1, ib2, ibsize, lsize, ibesize

    real(kind=DP) :: fac, occupation
    real(kind=DP), allocatable :: qxyz(:,:), psi_l(:,:,:,:)
    real(kind=DP), allocatable,dimension(:,:) :: afft_l, afft_l_mpi
    real(kind=DP), allocatable,dimension(:,:) :: bfft_l, map_afft_l

    integer       :: ist,ien
    real(kind=DP), pointer, dimension(:,:,:) :: ekinq_p
    real(kind=DP), allocatable, target, dimension(:,:,:) :: ekinqtmp

    allocate( qxyz(maxval(np_g1k),3 ) ); qxyz = 0.0d0
    ekins_l = 0.0d0

#ifdef FFT_3D_DIVISION
    lsize = fft_X_x_nel*fft_X_y_nel*fft_X_z_nel
#else
    lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
#endif

    ibsize = 1
    if (nblocksize_fftw_is_given) then
       ibsize = nblocksize_fftw
       if (ibsize < 1) ibsize = 1
    endif

#ifdef FFT_3D_DIVISION
    allocate(afft_l(lsize*2,1) ,stat=ierr)
    allocate(bfft_l(lsize*2,ibsize) ,stat=ierr)
    afft_l = 0.0d0
    bfft_l = 0.0d0
#else
    allocate(afft_l(lsize*kimg,1) ,stat=ierr)
    allocate(bfft_l(lsize*kimg,ibsize) ,stat=ierr)
#endif

    fac = 2.d0/(univol*kv3*product(fft_box_size_WF(1:3,1)))

    Do ispin=1, nspin
       afft_l = 0.0d0
       do ik = ispin, kv3+ispin-nspin, nspin
          if ( map_k(ik) /= myrank_k ) cycle

          call k_plus_G_vectors_m_3D( ik, kg, kg1, kv3, iba, nbase, vkxyz, ngabc, rltv,&
               &                      qxyz(:,1), qxyz(:,2), qxyz(:,3) )

          allocate( psi_l( maxval(np_g1k), np_e, ik:ik, kimg ) ); psi_l = 0.0d0

          Do ib1 = 1, np_e, ibsize
             ib2 = min(ib1+ibsize-1,np_e)
             ibesize = ib2 - ib1 + 1

             occupation = occup_l( ib1,ik )
             if ( occupation < DELTA ) cycle

             Do ixyz=1, 3
                psi_l = 0.0d0
                if ( kimg == 1 ) then
                   call phase_error_with_msg(nfout,"Not supported",__LINE__,__FILE__)
                else
                   Do ig=1, np_g1k(ik)
                      psi_l(ig,ib1:ib2,ik,2) =  zaj_l(ig,ib1:ib2,ik,1) &
                           &                       *qxyz(ig,ixyz)
                      psi_l(ig,ib1:ib2,ik,1) = -zaj_l(ig,ib1:ib2,ik,2) &
                           &                       *qxyz(ig,ixyz)
                   End do
                endif

                bfft_l = 0.0d0
                call m_ES_WF_in_Rspace_3D1( ik, ik, ik, ib1, ib2, ibsize, lsize, &
                     &                      psi_l, bfft_l )
                call add_occupied_densities()
             End Do
          End do
          deallocate( psi_l )
       End do

#ifdef FFT_3D_DIVISION
       allocate(afft_l_mpi(lsize*2,1) ,stat=ierr)
#else
       allocate(afft_l_mpi(lsize*kimg,1) ,stat=ierr)
#endif

#ifdef FFT_3D_DIVISION
       call mpi_allreduce(afft_l,afft_l_mpi,lsize*2,mpi_double_precision,   &
            &                   mpi_sum,mpi_kg_world,ierr)
       afft_l = afft_l_mpi
       call mpi_allreduce(afft_l,afft_l_mpi,lsize*2,mpi_double_precision,   &
            &                   mpi_sum,mpi_ge_world,ierr)
#else
       if (sw_fft_xzy > 0) then
          call mpi_allreduce(afft_l,afft_l_mpi,np_fft_y*kimg,mpi_double_precision,   &
               &                   mpi_sum,mpi_kg_world,ierr)
          afft_l = afft_l_mpi
          call mpi_allreduce(afft_l,afft_l_mpi,np_fft_y*kimg,mpi_double_precision,   &
               &                   mpi_sum,mpi_ge_world,ierr)
       else
          call mpi_allreduce(afft_l,afft_l_mpi,lsize*kimg,mpi_double_precision,   &
               &                   mpi_sum,mpi_kg_world,ierr)
          afft_l = afft_l_mpi
          call mpi_allreduce(afft_l,afft_l_mpi,lsize*kimg,mpi_double_precision,   &
               &                   mpi_sum,mpi_ge_world,ierr)
       end if
#endif
       __TIMER_COMM_STOP(825)
       afft_l = afft_l_mpi

       deallocate(afft_l_mpi)

#ifdef FFT_3D_DIVISION
       call m_FFT_Direct_3DIV_3D (nfout, afft_l, lsize, 1)
#else
       if (sw_fft_xzy > 0) then
          call m_FFT_Direct_3D (nfout, afft_l, lsize, 1)
       else
          call m_FFT_Direct_XYZ_3D (nfout, afft_l, lsize, 1)
       end if
#endif
#ifdef FFT_3D_DIVISION
       allocate(map_afft_l(np_kngp_gw*2,1) ,stat=ierr)
#else
       allocate(map_afft_l(np_kngp_gw*kimg,1) ,stat=ierr)
#endif
       call map_fft_to_chgq_3D(lsize, 1, afft_l, map_afft_l, nfout)
       call substitute_KE_for_ekinq
       deallocate(map_afft_l)
    End Do

    ekins_l = ekins_l /2.0d0

    call symmetrize_ekin_3D( NO, ekins_l )

    deallocate( afft_l ); deallocate(bfft_l); deallocate( qxyz )

  contains

    subroutine add_occupied_densities
      integer  :: i, ib
      real(kind=DP) :: occupation
                                                 __TIMER_SUB_START(717)
                                                 __TIMER_DO_START(826)
      do ib = ib1, ib2
         occupation = occup_l(ib,ik)
         if(occupation < DELTA) cycle
#ifdef FFT_3D_DIVISION
         do i = 1, lsize*2-1, 2
            afft_l(i,1) = afft_l(i,1) + occupation*(bfft_l(i,ib-ib1+1)**2+bfft_l(i+1,ib-ib1+1)**2) ! MPI
         end do
#else
         if (sw_fft_xzy > 0) then
            do i = 1, np_fft_y*kimg-1, 2
               afft_l(i,1) = afft_l(i,1) + occupation*(bfft_l(i,ib-ib1+1)**2+bfft_l(i+1,ib-ib1+1)**2) ! MPI
            end do
         else
            do i = 1, np_fft_z*kimg-1, 2
               afft_l(i,1) = afft_l(i,1) + occupation*(bfft_l(i,ib-ib1+1)**2+bfft_l(i+1,ib-ib1+1)**2) ! MPI
            end do
         end if
#endif
      end do
                                                 __TIMER_DO_STOP(826)
                                                 __TIMER_SUB_STOP(717)
    end subroutine add_occupied_densities

    subroutine substitute_KE_for_ekinq

      real(kind=DP) :: fac
      integer       :: i, iend !mpi
      integer       :: ist,ien
      real(kind=DP), pointer, dimension(:,:,:) :: ekinq_p
      real(kind=DP), allocatable, target, dimension(:,:,:) :: ekinqtmp

      if(sw_communicator_for_chg == ON)then
          allocate(ekinqtmp(ista_kngp_gw:iend_kngp_gw,kimg,nspin));ekinqtmp = 0.d0
          ekinq_p => ekinqtmp
          ist = ista_kngp_gw
          ien = iend_kngp_gw
      else
          ekinq_p => ekins_l
          ist = ista_kngp
          ien = iend_kngp
      endif
                                                 __TIMER_SUB_START(719)
      fac = 2.d0/(univol*kv3*product(fft_box_size_WF(1:3,1)))
      iend = ien
      if( iend > kg ) iend = kg
                                                 __TIMER_DO_START(830)
      if( ist <= iend ) then
         if (kimg == 1) then
            do i = ist, iend  !for mpi
               ekinq_p(i,1,ispin) = map_afft_l(i-ist+1,1)*fac
            end do
         else
            do i = ist, iend  !for mpi
               ekinq_p(i,1,ispin) = map_afft_l((i-ist+1)*2-1,1)*fac
               ekinq_p(i,2,ispin) = map_afft_l((i-ist+1)*2  ,1)*fac
            end do
         end if
      endif
                                                 __TIMER_DO_STOP(830)
                                                 __TIMER_SUB_STOP(719)
      if(sw_communicator_for_chg == ON)then
        do i=ista_kngp,iend_kngp
           ekins_l(i,:,:) = ekinq_p(i,:,:)
        enddo
        deallocate(ekinqtmp)
      endif
    end subroutine substitute_KE_for_ekinq

  end subroutine m_KE_symm_softpart_3D

  subroutine symmetrize_ekin_3D(mode,ekin)
    integer,intent(in)           :: mode
    real(kind=DP), intent(inout) :: ekin(ista_kngp:iend_kngp,kimg,nspin)
    integer ::       ispin, ng, no, ngp, no1, no2
    real(kind=DP) :: fi, tx,ty,tz, fp, fc, fs, zcr, zci
    real(kind=DP), pointer, dimension(:,:) :: work2
    logical, save                           :: firstcall = .true.
    integer, save                           :: sendmax, recvmax, sendranks, recvranks
    integer                                 :: mymin, mymax, lrank
    integer,                    dimension(2)   :: my_from_to
    integer,       allocatable, dimension(:,:) :: all_from_to
    integer,       allocatable, dimension(:)   :: is_ngpt, ie_ngpt
    integer, save, allocatable, dimension(:,:) :: sendinfo, recvinfo
                                                 __TIMER_SUB_START(731)
    allocate(work2(ista_kngp:iend_kngp,kimg)); work2 = 0.d0

    if(mode == ANTIFERRO) then
       fi = 1.d0/af
       no1 = nopr + 1; no2 = nopr + af
    else
       fi = 1.d0/nopr
       no1 = 1; no2 = nopr
    end if

!XX!if (firstcall) then
    allocate(all_from_to(2,0:nrank_chg-1))
    allocate(is_ngpt(0:nrank_chg-1))
    allocate(ie_ngpt(0:nrank_chg-1))
    allocate(sendinfo(2,0:nrank_chg-1))
    allocate(recvinfo(2,0:nrank_chg-1))
    sendinfo = 0
    recvinfo = 0
    sendmax = 0
    recvmax = 0
    sendranks = 0
    recvranks = 0

    mymin = kgp
    mymax = 1
                                                 __TIMER_DO_START(848)
    do no = no1, no2
       do ng = ista_kngp, iend_kngp !for mp
          ngp = ngpt_l(ng,no)
          if (mymin > ngp) mymin = ngp
          if (mymax < ngp) mymax = ngp
       end do
    end do
                                                 __TIMER_DO_STOP(848)

    my_from_to(1) = mymin
    my_from_to(2) = mymax

                                                 __TIMER_COMM_START_w_BARRIER(mpi_chg_world,849)
    call mpi_allgather(my_from_to , 2, MPI_INTEGER, &
   &                   all_from_to, 2, MPI_INTEGER, mpi_chg_world, ierr)
                                                 __TIMER_COMM_STOP(849)
    is_ngpt(0:nrank_chg-1) = all_from_to(1,0:nrank_chg-1)
    ie_ngpt(0:nrank_chg-1) = all_from_to(2,0:nrank_chg-1)

                                                 __TIMER_DO_START(850)
    do lrank = 0, nrank_chg-1
      if(lrank == myrank_chg) cycle
      if(ie_ngpt(lrank) < ista_kngp) cycle
      if(iend_kngp < is_ngpt(lrank)) cycle
      if(ista_kngp <= ie_ngpt(lrank)) then
         sendinfo(1,lrank) = max(ista_kngp,is_ngpt(lrank))
         sendinfo(2,lrank) = min(iend_kngp,ie_ngpt(lrank))
         sendranks = sendranks + 1
      else if(is_ngpt(lrank) <= iend_kngp) then
         sendinfo(1,lrank) = max(ista_kngp,is_ngpt(lrank))
         sendinfo(2,lrank) = min(iend_kngp,ie_ngpt(lrank))
         sendranks = sendranks + 1
      endif
      sendmax = max(sendmax,sendinfo(2,lrank)-sendinfo(1,lrank)+1)
    end do
                                                 __TIMER_DO_STOP(850)
                                                 __TIMER_DO_START(851)
    do lrank = 0, nrank_chg-1
      if(lrank == myrank_chg) cycle
      if(ie_kngp(lrank) < mymin) cycle
      if(mymax < is_kngp(lrank)) cycle
      if(mymin <= ie_kngp(lrank)) then
         recvinfo(1,lrank) = max(mymin,is_kngp(lrank))
         recvinfo(2,lrank) = min(mymax,ie_kngp(lrank))
         recvranks = recvranks + 1
      else if(is_kngp(lrank) <= mymax) then
         recvinfo(1,lrank) = max(mymin,is_kngp(lrank))
         recvinfo(2,lrank) = min(mymax,ie_kngp(lrank))
         recvranks = recvranks + 1
      endif
      recvmax = max(recvmax,recvinfo(2,lrank)-recvinfo(1,lrank)+1)
    end do
                                                 __TIMER_DO_STOP(851)
    deallocate(all_from_to)
    deallocate(is_ngpt)
    deallocate(ie_ngpt)

!XX!firstcall = .false.
!XX!end if

    allocate(work(mymin:mymax,kimg))

    do ispin = 1, nspin, af+1
       call cp_chgq_by_ngpt() ! chg -> work
       work2 = 0.d0                   ! initialization
                                                 __TIMER_DO_START(852)
       do no = no1, no2
!!$          tx = tau(1,no,BUCS)*PAI2
!!$          ty = tau(2,no,BUCS)*PAI2
!!$          tz = tau(3,no,BUCS)*PAI2
          if(kimg == 1) then
             do ng = ista_kngp, iend_kngp !for mpi
                ngp = ngpt_l(ng,no)
!                fp = ngabc(ngp,1)*tx + ngabc(ngp,2)*ty + ngabc(ngp,3)*tz
!                fp = ngabc_kngp_l(ngp,1)*tx + ngabc_kngp_l(ngp,2)*ty + ngabc_kngp_l(ngp,3)*tz
                fp = fp_l(ng,no)
                work2(ng,1)        = work2(ng,1) + dcos(fp)*work(ngp,1)
             end do
          else if(kimg == 2) then
             do ng = ista_kngp, iend_kngp !for mpi
                ngp= ngpt_l(ng,no)
!                fp = ngabc(ngp,1)*tx + ngabc(ngp,2)*ty + ngabc(ngp,3)*tz
!                fp = ngabc_kngp_l(ngp,1)*tx + ngabc_kngp_l(ngp,2)*ty + ngabc_kngp_l(ngp,3)*tz
                fp = fp_l(ng,no)
                fc = dcos(fp);     fs = dsin(fp)
                zcr= work(ngp,1);  zci= work(ngp,kimg)
                work2(ng,1)        = work2(ng,1) + fc*zcr - fs*zci
                work2(ng,2)        = work2(ng,2) + fc*zci + fs*zcr
             end do
          end if
       end do
                                                 __TIMER_DO_STOP(852)
       if(mode /= ANTIFERRO) ekin(:,:,ispin) = work2(:,:)*fi
    end do

    if(mode == ANTIFERRO) ekin(:,:,nspin) = work2(:,:)*fi

    deallocate(work2)
    deallocate(sendinfo)
    deallocate(recvinfo)
    deallocate(work)
                                                 __TIMER_SUB_STOP(731)
   contains

    subroutine cp_chgq_by_ngpt()
      real(DP), allocatable, dimension(:,:) :: sendbuf
      real(DP), allocatable, dimension(:,:) :: recvbuf
      integer, dimension(sendranks) :: req_s
      integer, dimension(recvranks) :: req_r, src
      integer, dimension(MPI_STATUS_SIZE,sendranks) :: sta_s
      integer, dimension(MPI_STATUS_SIZE,recvranks) :: sta_r

      integer :: i, j, ri, ista, iend, nel
      integer :: icnt_s, icnt_r, ierr, itag=30
! === DEBUG by tkato 2012/06/04 ================================================
#ifndef USE_NONBLK_COMM
#ifndef USE_ALLTOALLV
      real(kind=DP), allocatable, dimension(:,:) :: sbuf, rbuf
      integer :: maxbuf
#else
      integer, allocatable, dimension(:) :: sdsp, rdsp
      integer, allocatable, dimension(:) :: scnt, rcnt
      real(kind=DP), allocatable, dimension(:,:) :: sbuf, rbuf
#endif
#endif
! ==============================================================================

                                                 __TIMER_SUB_START(732)
      allocate(recvbuf(recvmax*kimg,recvranks))
      allocate(sendbuf(sendmax*kimg,sendranks))

      icnt_r = 0
#ifdef USE_NONBLK_COMM
                                                 __TIMER_COMM_START_w_BARRIER(mpi_chg_world,853)
#endif
      do lrank = 0, nrank_chg - 1
         if(recvinfo(1,lrank) == 0) cycle
         ista = recvinfo(1,lrank)
         iend = recvinfo(2,lrank)
         nel  = iend-ista+1
         icnt_r = icnt_r + 1
         src(icnt_r) = lrank
#ifdef USE_NONBLK_COMM
         call mpi_irecv(recvbuf(1,icnt_r), nel*kimg, mpi_double_precision, &
        &               lrank, itag, mpi_chg_world, req_r(icnt_r), ierr)
          if (ierr /= 0) then
             call mpi_abort(mpi_comm_world, 171, ierr)
          endif
#endif
      end do

      icnt_s = 0
      do lrank = 0, nrank_chg-1
         if(sendinfo(1,lrank) == 0) cycle
         ista = sendinfo(1,lrank)
         iend = sendinfo(2,lrank)
         nel  = iend-ista+1
         icnt_s = icnt_s + 1
                                                 __TIMER_DO_START(854)
         do ri = 1, kimg
            do i = ista, iend
               sendbuf((i-ista+1+nel*(ri-1)),icnt_s) = ekin(i,ri,ispin)
            end do
         end do
                                                 __TIMER_DO_STOP(854)
#ifdef USE_NONBLK_COMM
         call mpi_isend(sendbuf(1,icnt_s), nel*kimg, mpi_double_precision, &
        &               lrank, itag, mpi_chg_world, req_s(icnt_s), ierr)
          if (ierr /= 0) then
             call mpi_abort(mpi_comm_world, 172, ierr)
          endif
#endif
      end do
                                                 __TIMER_DO_START(855)
      do ri = 1, kimg
         do i = ista_kngp, iend_kngp
            if (i < mymin) cycle
            if (mymax < i) cycle
            work(i,ri) = ekin(i,ri,ispin)
         end do
      end do
                                                 __TIMER_DO_STOP(855)
#ifdef USE_NONBLK_COMM
      call mpi_waitall(icnt_s, req_s, sta_s, ierr)
       if (ierr /= 0) then
          call mpi_abort(mpi_comm_world, 173, ierr)
       endif
      call mpi_waitall(icnt_r, req_r, sta_r, ierr)
       if (ierr /= 0) then
          call mpi_abort(mpi_comm_world, 174, ierr)
       endif
                                                 __TIMER_COMM_STOP(853)
#else
                                                 __TIMER_COMM_START_w_BARRIER(mpi_chg_world,694)
#ifndef USE_ALLTOALLV
! === DEBUG by tkato 2012/06/05 ================================================
!      if(sendmax/=0)then
! ==============================================================================
! === DEBUG by tkato 2012/06/04 ================================================
!      real(kind=DP), allocatable, dimension(:,:) :: sbuf, rbuf
! ==============================================================================
! === DEBUG by tkato 2012/06/04 ================================================
!      allocate(sbuf(sendmax*kimg,0:sendranks-1), stat=ierr)
!      allocate(rbuf(recvmax*kimg,0:recvranks-1), stat=ierr)
!      do i = 0, nrank_g - 1
!         sbuf(:,i)=sendbuf(:,i+1)
!      enddo
!      call MPI_ALLTOALL( sbuf, nel*kimg, mpi_double_precision, &
!     &                   rbuf, nel*kimg, mpi_double_precision, &
!     &                                    mpi_ke_world, ierr )
!      if (ierr /= 0) then
!         call mpi_abort(mpi_comm_world, 175, ierr)
!      endif
!      do i = 0, nrank_g - 1
!         recvbuf(:,i+1)=rbuf(:,i)
!      enddo
       maxbuf = max(sendmax,recvmax)
       call mpi_allreduce(MPI_IN_PLACE,maxbuf,1,mpi_integer,mpi_max,mpi_chg_world,ierr)
       allocate(sbuf(maxbuf*kimg,0:nrank_chg-1), stat=ierr)
       allocate(rbuf(maxbuf*kimg,0:nrank_chg-1), stat=ierr)
       icnt_s = 0
       do i = 0, nrank_chg - 1
          if(sendinfo(1,i) == 0) cycle
          icnt_s = icnt_s + 1
          sbuf(1:sendmax*kimg,i)=sendbuf(1:sendmax*kimg,icnt_s)
       enddo
       call MPI_ALLTOALL( sbuf, maxbuf*kimg, mpi_double_precision, &
      &                   rbuf, maxbuf*kimg, mpi_double_precision, &
      &                                    mpi_chg_world, ierr )
       if (ierr /= 0) then
          call mpi_abort(mpi_comm_world, 175, ierr)
       endif
       icnt_r = 0
       do i = 0, nrank_chg - 1
          if(recvinfo(1,i) == 0) cycle
          icnt_r = icnt_r + 1
          recvbuf(1:recvmax*kimg,icnt_r)=rbuf(1:recvmax*kimg,i)
       enddo
! ==============================================================================
       deallocate(sbuf)
       deallocate(rbuf)
! === DEBUG by tkato 2012/06/05 ================================================
!      endif
! ==============================================================================
#else
! === DEBUG by tkato 2012/06/05 ================================================
!      if(sendmax/=0)then
! ==============================================================================
! === DEBUG by tkato 2012/06/05 ================================================
!      integer, allocatable, dimension(:) :: sdsp, rdsp
!      integer, allocatable, dimension(:) :: scnt, rcnt
!      real(kind=DP), allocatable, dimension(:,:) :: sbuf, rbuf
!      allocate(sdsp(0:sendranks-1), stat=ierr)
!      allocate(rdsp(0:recvranks-1), stat=ierr)
!      allocate(scnt(0:sendranks-1), stat=ierr)
!      allocate(rcnt(0:recvranks-1), stat=ierr)
!      allocate(sbuf(sendmax*kimg,0:sendranks-1), stat=ierr)
!      allocate(rbuf(recvmax*kimg,0:recvranks-1), stat=ierr)
!      write(6,*) sendmax, recvmax, kimg
!      do i = 0, nrank_g - 1
!         sdsp(i)=sendmax*kimg*i
!         rdsp(i)=recvmax*kimg*i
!         scnt(i)=(sendinfo(2,i)-sendinfo(1,i)+1)*kimg
!         rcnt(i)=(recvinfo(2,i)-recvinfo(1,i)+1)*kimg
!         sbuf(:,i)=sendbuf(:,i+1)
!      enddo
!      call MPI_ALLTOALLV(      sendb, scnt, sdsp, &
!     &   mpi_double_precision, recvb, rcnt, rdsp, &
!     &   mpi_double_precision, mpi_ke_world, ierr )
!      if (ierr /= 0) then
!         call mpi_abort(mpi_comm_world, 175, ierr)
!      endif
!      do i = 0, nrank_g - 1
!         recvbuf(:,i+1)=rbuf(:,i)
!      enddo
       allocate(sdsp(0:nrank_chg-1), stat=ierr)
       allocate(rdsp(0:nrank_chg-1), stat=ierr)
       allocate(scnt(0:nrank_chg-1), stat=ierr)
       allocate(rcnt(0:nrank_chg-1), stat=ierr)
! === DEBUG by tkato 2012/06/05 ================================================
!      allocate(sbuf(sendmax*kimg,0:nrank_g-1), stat=ierr)
!      allocate(rbuf(recvmax*kimg,0:nrank_g-1), stat=ierr)
       if(sendmax /= 0) then
          allocate(sbuf(sendmax*kimg,0:nrank_chg-1), stat=ierr)
       else
          allocate(sbuf(1,0:nrank_chg-1), stat=ierr)
       endif
       if(recvmax /= 0) then
          allocate(rbuf(recvmax*kimg,0:nrank_chg-1), stat=ierr)
       else
          allocate(rbuf(1,0:nrank_chg-1), stat=ierr)
       endif
! ==============================================================================
       write(6,*) sendmax, recvmax, kimg
       icnt_s = 0
       do i = 0, nrank_chg - 1
          sdsp(i)=sendmax*kimg*i
          rdsp(i)=recvmax*kimg*i
          scnt(i)=(sendinfo(2,i)-sendinfo(1,i)+1)*kimg
          rcnt(i)=(recvinfo(2,i)-recvinfo(1,i)+1)*kimg
          if(sendinfo(1,i) == 0) cycle
          icnt_s = icnt_s + 1
          sbuf(:,i)=sendbuf(:,icnt_s)
       enddo
       call MPI_ALLTOALLV(      sbuf, scnt, sdsp, &
      &   mpi_double_precision, rbuf, rcnt, rdsp, &
      &   mpi_double_precision, mpi_chg_world, ierr )
       if (ierr /= 0) then
          call mpi_abort(mpi_comm_world, 175, ierr)
       endif
       icnt_r = 0
       do i = 0, nrank_chg - 1
          if(recvinfo(1,i) == 0) cycle
          icnt_r = icnt_r + 1
          recvbuf(:,icnt_r)=rbuf(:,i)
       enddo
! ==============================================================================
       deallocate(sdsp)
       deallocate(rdsp)
       deallocate(scnt)
       deallocate(rcnt)
       deallocate(sbuf)
       deallocate(rbuf)
! === DEBUG by tkato 2012/06/05 ================================================
!      endif
! ==============================================================================
#endif
                                                 __TIMER_COMM_STOP(694)
#endif
                                                 __TIMER_DO_START(856)
      do j = 1, icnt_r
         lrank = src(j)
         ista = recvinfo(1,lrank)
         iend = recvinfo(2,lrank)
         nel  = iend-ista+1
         do ri = 1, kimg
            do i = ista, iend
               work(i,ri) = recvbuf((i-ista+1+nel*(ri-1)),j)
            end do
         end do
      end do
                                                 __TIMER_DO_STOP(856)
      deallocate(sendbuf)
      deallocate(recvbuf)
                                                 __TIMER_SUB_STOP(732)
    end subroutine cp_chgq_by_ngpt
  end subroutine symmetrize_ekin_3D

  subroutine m_KE_set_modeled_ekin_density( ista_rho, iend_rho, &
       &                                    rho, grad_rho, grad2_rho, ekin_dens )
    integer,intent(in) :: ista_rho, iend_rho
    real(kind=DP), intent(in) :: rho( ista_rho:iend_rho, nspin )
    real(kind=DP), intent(in) :: grad_rho( ista_rho:iend_rho, nspin )
    real(kind=DP), intent(in) :: grad2_rho( ista_rho:iend_rho, nspin )
    real(kind=DP), intent(out) :: ekin_dens( ista_rho:iend_rho, nspin )

    select case ( ekin_density_type )

    case (1)
       call calc_Abramov_ekin_density( rho, grad_rho, grad2_rho, ekin_dens )

    case (2)                        ! Thomas-Fermi von Weizsacker
       call calc_TF_vWeiz_ekin_density( rho, grad_rho, grad2_rho, &
         &                              1.0d0, 1.0d0, ekin_dens )

    case (3)                        ! extended Thomas-Fermi
       call calc_Extended_TF_ekin_density( rho, grad_rho, grad2_rho, ekin_dens )

    end select

  contains

    subroutine calc_extended_TF_ekin_density( rho, grad_rho, grad2_rho, &
         &                                    ekin_dens )
      real(kind=DP), intent(in) :: rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad2_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(out) :: ekin_dens( ista_rho:iend_rho, nspin )

      integer :: is, i
      real(kind=DP) :: c1, c2, c3, kappa0, kappa2, kappa4, term1, term2, term3
      real(kind=DP), parameter :: delta1 = 1.0E-12

      c1 = (3.0d0*PAI**2)**(2.0d0/3.0d0)
      kappa0 = 3.0d0/5.0d0 *c1
      kappa2 = 1.0d0/36.0d0
      kappa4 = 1.0d0/6480.0d0/c1

      ekin_dens = 0.0d0

      Do is=1, nspin
         Do i=ista_rho, iend_rho
            c1 = rho(i,is)

            if ( c1 > delta1 ) then
               c2 =  grad_rho(i,is)/c1
               c3 = grad2_rho(i,is)/c1

               term1 = kappa0 *c1**(5.0d0/3.0d0)
               term2 = kappa2 *grad_rho(i,is)*c2
               term3 = kappa4 *c1**(1.0d0/3.0d0) &
                    &         *( 8.0d0 *c2**4 -27.0d0 *c2**2 *c3 +24.0d0 *c3**2 )

               ekin_dens(i,is) = term1 +term2 +term3
            endif
         End do
      End Do
      ekin_dens = ekin_dens /2.0d0

    end subroutine calc_extended_TF_ekin_density

    subroutine calc_TF_vWeiz_ekin_density( rho, grad_rho, grad2_rho, &
         &                                 weight_TF, weight_vWeiz, ekin_dens )
      real(kind=DP), intent(in) :: weight_TF,  weight_vWeiz
      real(kind=DP), intent(in) :: rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad2_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(out) :: ekin_dens( ista_rho:iend_rho, nspin )

      integer :: is, i
      real(kind=DP) :: c1, coeff, term1, term2, term3
      real(kind=DP), parameter :: delta1 = 1.0E-12

      coeff = 3.0d0/10.0d0 *(3.0D0*PAI**2)**( 2.0d0/3.0d0 )

      ekin_dens = 0.0d0

      Do is=1, nspin
         Do i=ista_rho, iend_rho
            c1 = rho(i,is)

            if ( c1 > delta1 ) then
               term1 = coeff *c1**(5.0d0/3.0d0)
               term2 = grad_rho(i,is)**2 /c1 /8.0d0
               ekin_dens(i,is) = weight_TF *term1 + weight_vWeiz *term2
            endif

         End do
      End Do
    end subroutine calc_TF_vWeiz_ekin_density

    subroutine calc_Abramov_ekin_density( rho, grad_rho, grad2_rho, ekin_dens )
      real(kind=DP), intent(in) :: rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad2_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(out) :: ekin_dens( ista_rho:iend_rho, nspin )

      integer :: is, i
      real(kind=DP) :: c1, c2, coeff, term1, term2, term3
      real(kind=DP), parameter :: delta1 = 1.0E-15

      coeff = 3.0d0/10.0d0 *(3.0D0*PAI**2)**( 2.0d0/3.0d0 )

      ekin_dens = 0.0d0

      Do is=1, nspin
         Do i=ista_rho, iend_rho
            c1 = rho(i,is) *nspin
            term1 = coeff *c1**(5.0d0/3.0d0) /nspin

            if ( c1 > delta1 ) then
               c2 = grad_rho(i,is) *nspin
               term2 = c2**2 /c1 /8.0 /nspin

               term2 = term2 /9.0d0
            else
               term2 = 0.0d0
            endif

            term3 = grad2_rho(i,is) /6.0d0
            term3 = term3 *1.05

            ekin_dens(i,is) = term1 + term2 + term3
         End do
      End Do
    end subroutine calc_Abramov_ekin_density

  end subroutine m_KE_set_modeled_ekin_density



  subroutine m_KE_add_ekindens_hard_rspace( ista_rho, iend_rho, ekin_dens )
    integer, intent(in) :: ista_rho, iend_rho
    real(kind=DP), intent(inout) :: ekin_dens( ista_rho,iend_rho, nspin )
    return
  end subroutine m_KE_add_ekindens_hard_rspace

  subroutine m_KE_wd_ekindens
    real(kind=DP), allocatable :: wk_mpi1(:,:,:), wk_mpi2(:,:,:)

    if(mype==0) rewind nf_ekindens
    if(npes > 1) then
       allocate(wk_mpi1(kgp,kimg,nspin)); wk_mpi1 = 0.d0
       allocate(wk_mpi2(kgp,kimg,nspin)); wk_mpi2 = 0.d0

       if ( use_symm_ekin_density ) then
          wk_mpi1(ista_kngp:iend_kngp,:,:) = ekins_l(ista_kngp:iend_kngp,:,:)
       else if ( use_asymm_ekin_density ) then
          wk_mpi1(ista_kngp:iend_kngp,:,:) = ekina_l(ista_kngp:iend_kngp,:,:)
       endif
       call mpi_allreduce( wk_mpi1, wk_mpi2, kgp*kimg*nspin, &
            &              mpi_double_precision, mpi_sum, mpi_chg_world, ierr)

       if(mype==0) write(nf_ekindens) wk_mpi2

       deallocate(wk_mpi1); deallocate(wk_mpi2)
    else
       if ( use_symm_ekin_density ) then
          write(nf_ekindens) ekins_l
       else if ( use_asymm_ekin_density ) then
          write(nf_ekindens) ekina_l
       end if
    endif

  end subroutine m_KE_wd_ekindens

  subroutine m_KE_rd_ekindens
    real(kind=DP), allocatable :: wk_mpi1(:,:,:)

    if(mype==0) rewind nf_ekindens
    if(npes > 1) then
       allocate(wk_mpi1(kgp,kimg,ndim_magmom)); wk_mpi1 = 0.d0

       if ( mype==0 ) read(nf_ekindens) wk_mpi1
       call mpi_bcast( wk_mpi1, kgp*kimg*ndim_magmom, mpi_double_precision, &
            &          0, MPI_CommGroup, ierr )

       if ( use_symm_ekin_density ) then
          ekins_l(ista_kngp:iend_kngp,:,:) = wk_mpi1(ista_kngp:iend_kngp,:,:)
       else if ( use_asymm_ekin_density ) then
          ekina_l(ista_kngp:iend_kngp,:,:) = wk_mpi1(ista_kngp:iend_kngp,:,:)
       endif
       deallocate(wk_mpi1)
    else
       if ( use_symm_ekin_density ) then
          read(nf_ekindens) ekins_l
       else if ( use_asymm_ekin_density ) then
          read(nf_ekindens) ekina_l
       end if
    endif
  end subroutine m_KE_rd_ekindens

end module m_KineticEnergy_Density

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 635 $)
!
!  MODULE: m_FFT
!
!  AUTHOR(S): T. Yamasaki, K. Betsuyaku,   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!                                   , March/14/2005, April/10/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!

module m_FFT
! $Id: m_FFT.F90 635 2021-02-26 07:16:10Z jkoga $
!
  use m_Timing,            only : tstatc0_begin, tstatc0_end
  use m_Files,             only : nfout
  use m_Control_Parameters,only : kimg, ipri, iprinegativecharge, iprinegativecharge0 &
       &                        , max_warnings_negativecharge, sw_positron, ldx, ldy, ldz
  use m_Const_Parameters,  only : DP,CMPLDP, ON, OFF, INVERSE, DIRECT, OUTER, INNER &
       &                        , ELECTRON, POSITRON, YES, NO
  use m_Parallelization,   only : MPI_CommGroup,ista_sfftp,iend_sfftp,ista_sfftph,iend_sfftph &
       &                        , ista_fftp, iend_fftp &
       &                        , mype,npes,ierr,nel_sfftp,idisp_sfftp &
       &                        , myrank_cdfft,myrank_ggacmp,nrank_ggacmp,npes_cdfft &
       &                        , nel_fftp, idisp_fftp, mpi_cdfft_world
#ifdef MKLFFT
  use MKL_DFTI
  use mklfft
#endif

! ================================= added by K. Tagami ============== 11.0
  use m_Const_Parameters,       only : CMPLDP
! =================================================================== 11.0

! ======= KT_add ========================================== 13.0F
  use m_Control_Parameters, only : sw_hybrid_functional
! ========================================================= 13.0F
  use mpi

  implicit none
  integer, dimension(3,0:1) :: fft_box_size_WF, fft_box_size_CD
  integer, dimension(3,0:1) :: fft_box_size_WF_prev
  integer, dimension(3,0:1) :: fft_box_size_CD_prev
  integer, dimension(3,0:0) :: fft_box_size_CD_c, fft_box_size_CD_nonpara
  integer, dimension(3,0:0) :: fft_box_size_CD_nonpara_prev
  integer, dimension(3,0:1) :: fft_box_size_CD_exx,fft_box_size_CD_exx_nonpara
  integer               :: nfft, nfftp, nfftps, nfftp_nonpara, nfftp_nonpara_prev

  integer               :: nfftp_exx_nonpara

  integer               :: ny_d, nz_d, ly_d, lx, ly, lz_d, lz &
       &                 , ny_ds,nz_ds,ly_ds,lxs,lys,lz_ds,lzs

  ! ------- Positron start
  integer, dimension(3,0:1) :: fft_box_size_pWF
  integer ::                   nfft_pstrn
  ! ------- Positron end

! ======= KT_add =================================== 13.0F
  integer, dimension(3,0:1) :: fft_box_size_EXX
  integer                   :: nfft_exx
! ================================================== 13.0F

#ifdef _MPIFFT_
  integer :: sw_mpifft = ON
#else
  integer :: sw_mpifft = OFF
#endif

  integer, private      :: CD_setup_is_done = NO
  integer, private      :: CD_setup_is_done_EXX = NO

  real(kind=DP),private,allocatable,dimension(:)           :: afft_CD
  real(kind=DP),private,allocatable,dimension(:)           :: afft_CD_exx
#ifdef VPP
  integer, private, parameter :: ncache=0
#elif DEC
  integer, private, parameter :: ncache=6*1024
#elif HP
  integer, private, parameter :: ncache=1*1024
#elif SUN
  integer, private, parameter :: ncache=1*1024
#elif ONYX
  integer, private, parameter :: ncache=1*1024
#elif IRIX64
  integer, private, parameter :: ncache=1*1024
#elif CRAY
  integer, private, parameter :: ncache=1*1024
#elif HIUX
  integer, private, parameter :: ncache=1*1024
#elif SX
  integer, private, parameter :: ncache=0
#elif SP2
  integer, private, parameter :: ncache=1*1024
#elif Linux
  integer, private, parameter :: ncache=6*1024
#endif

! contains
#ifdef JRCATFFT_WS
include "m_FFT_type1_jrcatfft.F90"
#define _INCLUDE_EXX_
#elif FFTW3
include "m_FFT_type4_fftw3_rev.F90"
#define _INCLUDE_EXX_
#elif MKLFFT
include "m_FFT_type3_mklfft.F90"
#elif ASLFFT
#ifdef _MPIFFT_
#ifdef NEC_TUNE_FFT
include "m_FFT_type5_aslfft+mpifft.hybrid.f90"
#else
include "m_FFT_type5_aslfft+mpifft.mpi.f90"
#endif
#else
#ifdef NEC_TUNE_FFT
include "m_FFT_type5_aslfft.hybrid.f90"
#else
include "m_FFT_type5_aslfft.mpi.f90"
#endif
#endif
#elif WF_JRCATFFT
include "m_FFT_type6_jrcatfft+ifft.F90"
#elif GOEDECKER_FFT
include "m_FFT_type8_goedecker.F90"
#elif FFTE
include "m_FFT_type9_ffte.F90"
#endif
! ---------------------

  ! 6. (common) wd_FFTboxsizes(nfout)
  ! 7. (common) m_FFT_set_box_sizes(n_rGv,n_rGpv,n_rGv_pstrn,outer_or_inner)
  ! 8. (common) m_FFT_wd_box_sizes(nf_bin)
  ! 9. (common) decomp3(oi,i,j)
  !10. (common) decomp3p(i,j)
  !13. (common) m_FFT_Vlocal_W(afft,bfft)
  !21. (common) m_FFT_check_of_negative_CD(npes_in,ista_fftp,iend_fftp,ista_fftph,iend_fftph &
  !22. (common) m_FFT_W_Vlocal_W(electron_or_positron,nabfft,afft,bfft,eg)
  !28. (common) m_FFT_set_cdata(aa,a)
  !29. (common) m_FFT_set_scdata(aa,a)
  !30. (common) m_FFT_coef_CD_integration(f2or1)
  !31. (common) m_FFT_set_cdata
  !32. (common) m_FFT_set_scdata(aa,a)


  subroutine wd_FFTboxsizes(nfout)
    integer, intent(in) :: nfout


    write(nfout,*) ' ---- (WF)FFT size ----'
    write(nfout,'("     (nfft, fft_box_size_WF)")')
    write(nfout,100) nfft
    write(nfout,101) fft_box_size_WF(1:3,0)
    write(nfout,102) fft_box_size_WF(1:3,1)

    write(nfout,*) ' ---- (CD)FFT size ----'
    write(nfout,'("     (nfftps, fft_box_size_CD)")')
    write(nfout,100) nfftps
    write(nfout,101) fft_box_size_CD(1:3,0)
    write(nfout,102) fft_box_size_CD(1:3,1)


#ifdef _MPIFFT_
    write(nfout,*) ' ---- (CD)FFT size ----'
    write(nfout,'("     (nfftps, fft_box_size_CD_nonpara)")')
    write(nfout,100) nfftp_nonpara
    write(nfout,101) fft_box_size_CD_nonpara(1:3,0)
#endif

    if(sw_positron /= OFF) then
       write(nfout,*) ' ---- (pWF)FFT size ----'
       write(nfout,'("     (nfft_pstrn, fft_box_size_pWF)")')
       write(nfout,100) nfft_pstrn
       write(nfout,101) fft_box_size_pWF(1:3,0)
       write(nfout,102) fft_box_size_pWF(1:3,1)
    end if

    write(nfout,*) ' ---- (CD_c)FFT size ----'
    write(nfout,'("     (nfftp, fft_box_size_CD_c)")')
    write(nfout,100) nfftp
    write(nfout,101) fft_box_size_CD_c(1:3,0)

100 format(" FFT total elements(including work area) = ",i10)
101 format(" FFT box adjustable dimension            = ",3i5)
102 format(" FFT box real dimension                  = ",3i5)
  end subroutine wd_FFTboxsizes

! =============== KT_add ============================= 13.0F
  subroutine wd_FFTboxsizes_exx(nfout)
    integer, intent(in) :: nfout

    write(nfout,*) ' ---- (Exx)FFT size ----'
    write(nfout,'("     (nfft_exx, fft_box_size_Exx)")')
    write(nfout,100) nfft_exx
    write(nfout,101) fft_box_size_EXX(1:3,0)
    write(nfout,102) fft_box_size_EXX(1:3,1)

    write(nfout,*) ' ---- (Exx)FFT_CD size ----'
    write(nfout,'("     (nfftp_exx_nonpara, fft_box_size_CD_Exx)")')
    write(nfout,100) nfftp_exx_nonpara
    write(nfout,101) fft_box_size_CD_EXX(1:3,0)
    write(nfout,102) fft_box_size_CD_EXX(1:3,1)

100 format(" FFT total elements(including work area) = ",i10)
101 format(" FFT box adjustable dimension            = ",3i5)
102 format(" FFT box real dimension                  = ",3i5)

  end subroutine wd_FFTboxsizes_exx
! ==================================================== 13.0F

  subroutine m_FFT_set_box_sizes(n_rGv,n_rGpv,n_rGv_pstrn,outer_or_inner)
    integer,intent(in),dimension(3) :: n_rGv,n_rGpv,n_rGv_pstrn
    integer,intent(in)              :: outer_or_inner

    integer :: i, ip
    fft_box_size_WF_prev = fft_box_size_WF
    do i = 1, 3
!  -- FFT box size for Wave Functions --
       ip = n_rGv(i)
       if(sw_avoiding_odd_fftbox == ON) then
          if(mod(ip,2) == 1) ip = ip + 1
       endif
       call decomp3(outer_or_inner,ip,fft_box_size_WF(i,1))
!  -- FFT box size for Charge Density --
       ip = n_rGpv(i)
       if(sw_avoiding_odd_fftbox == ON) then
          if(mod(ip,2) == 1) ip = ip + 1
       end if

#ifdef _PFFT_
       call decomp3p(ip,fft_box_size_CD(i,1))
#else
       call decomp3(outer_or_inner,ip,fft_box_size_CD(i,1))
#endif
    end do
    if(ipri>=1) then
       write(nfout,*) ' --- fft_box_size <<m_FFT_set_box_sizes>> ---'
       write(nfout,'("  WF ",3i5)') fft_box_size_WF(1:3,1)
       write(nfout,'("  CD ",3i5)') fft_box_size_CD(1:3,1)
    end if
    ! ------- Positron start
    if(sw_positron /= OFF) then
       do i = 1, 3
          !  -- FFT box size for positron Wave Functions --
          ip = n_rGv_pstrn(i)
          if(sw_avoiding_odd_fftbox == ON) then
             if(mod(ip,2) == 1) ip = ip + 1
          end if
          call decomp3(outer_or_inner,ip,fft_box_size_pWF(i,1))
       end do
       if(ipri>=1) write(nfout,'(" pWF ",3i5)') fft_box_size_pWF(1:3,1)
    end if
    ! ------- Positron end

  end subroutine m_FFT_set_box_sizes

  subroutine m_FFT_set_box_size_prev( n_rGv_prev, outer_or_inner )
    integer,intent(in),dimension(3) :: n_rGv_prev
    integer,intent(in)              :: outer_or_inner

    integer :: i, ip

    do i = 1, 3
       ip = n_rGv_prev(i)
       if(sw_avoiding_odd_fftbox == ON) then
          if(mod(ip,2) == 1) ip = ip + 1
       end if
       call decomp3(outer_or_inner,ip,fft_box_size_WF_prev(i,1))
    end do
    if(ipri>=1) write(nfout,'(" prev ",3i5)') fft_box_size_WF_prev(1:3,1)

  end subroutine m_FFT_set_box_size_prev

  subroutine m_FFT_set_box_size_cd_prev( n_rGpv_prev, outer_or_inner )
    integer,intent(in),dimension(3) :: n_rGpv_prev
    integer,intent(in)              :: outer_or_inner

    integer :: i, ip, ipad

    do i = 1, 3
       !  -- FFT box size for Wave Functions (exx) --
       ip = n_rGpv_prev(i)

       if(sw_avoiding_odd_fftbox == ON) then
          if(mod(ip,2) == 1) ip = ip + 1
       end if
       call decomp3(outer_or_inner,ip,fft_box_size_CD_prev(i,1))
    end do
    if(ipri>=1) write(nfout,'(" exx_CD ",3i5)') fft_box_size_CD_prev(1:3,1)
    if(kimg == 1) then  ! kimg == 1
       ipad = 2
    else if(kimg == 2) then ! kimg == 2
       ipad = 0
    end if

    fft_box_size_CD_nonpara_prev(1,0)   = fft_box_size_CD_prev(1,1) + ipad
    fft_box_size_CD_nonpara_prev(2:3,0) = fft_box_size_CD_prev(2:3,1)

    fft_box_size_CD_prev(1,0)   = fft_box_size_CD_prev(1,1) + ipad
    fft_box_size_CD_prev(2:3,0) = fft_box_size_CD_prev(2:3,1)

    nfftp_nonpara_prev  = product(fft_box_size_CD_nonpara_prev(1:3,0)) * kimg

  end subroutine m_FFT_set_box_size_cd_prev

! ======= KT_add ======================================= 13.0F
  subroutine m_FFT_set_box_size_exx( n_rGv_exx, outer_or_inner )
    integer,intent(in),dimension(3) :: n_rGv_exx
    integer,intent(in)              :: outer_or_inner

    integer :: i, ip

    if(sw_hybrid_functional /= OFF) then
       do i = 1, 3
          !  -- FFT box size for Wave Functions (exx) --
          ip = n_rGv_exx(i)

          if(sw_avoiding_odd_fftbox == ON) then
             if(mod(ip,2) == 1) ip = ip + 1
          end if
          call decomp3(outer_or_inner,ip,fft_box_size_exx(i,1))
       end do
       if(ipri>=1) write(nfout,'(" exx ",3i5)') fft_box_size_exx(1:3,1)
    end if

  end subroutine m_FFT_set_box_size_exx

  subroutine m_FFT_set_box_size_cd_exx( n_rGpv_exx, outer_or_inner )
    integer,intent(in),dimension(3) :: n_rGpv_exx
    integer,intent(in)              :: outer_or_inner

    integer :: i, ip, ipad

    if(sw_hybrid_functional /= OFF) then
       do i = 1, 3
          !  -- FFT box size for Wave Functions (exx) --
          ip = n_rGpv_exx(i)

          if(sw_avoiding_odd_fftbox == ON) then
             if(mod(ip,2) == 1) ip = ip + 1
          end if
          call decomp3(outer_or_inner,ip,fft_box_size_CD_exx(i,1))
       end do
       if(ipri>=1) write(nfout,'(" exx_CD ",3i5)') fft_box_size_CD_exx(1:3,1)
       if(kimg == 1) then  ! kimg == 1
          ipad = 2
       else if(kimg == 2) then ! kimg == 2
          ipad = 0
       end if

       fft_box_size_CD_exx_nonpara(1,0)   = fft_box_size_CD_exx(1,1) + ipad
       fft_box_size_CD_exx_nonpara(2:3,0) = fft_box_size_CD_exx(2:3,1)

       fft_box_size_CD_exx(1,0)   = fft_box_size_CD_exx(1,1) + ipad
       fft_box_size_CD_exx(2:3,0) = fft_box_size_CD_exx(2:3,1)

       nfftp_exx_nonpara  = product(fft_box_size_CD_exx_nonpara(1:3,0)) * kimg
    end if

  end subroutine m_FFT_set_box_size_cd_exx
! ====================================================== 13.0F

  subroutine m_FFT_wd_box_sizes(nf_bin)
    integer, intent(in) :: nf_bin
    if(mype == 0) &
         & write(nf_bin) fft_box_size_WF(1:3,1),fft_box_size_CD(1:3,1)
  end subroutine m_FFT_wd_box_sizes

  subroutine decomp3(oi,i,j)
    integer, intent(in)  :: oi, i
    integer, intent(out) :: j

    integer :: ipm, iab, ik, imini
    imini = i*189/200+1

    if(oi == OUTER) then
       ipm = +1
    else
       ipm = -1
    endif
100 iab=-1
110 iab=iab+1
    ik= i+ipm*iab
    if(ik < imini) then
       ipm=1
       goto 100
    end if
    j = ik*2
120 continue
    if(mod(j,2) == 0) then
       j=j/2
       goto 120
    else if(mod(j,3) == 0) then
       j=j/3
       goto 120
    else if(mod(j,5) == 0) then
       j=j/5
       goto 120
    else if(j == 1) then
       goto 130
    else
       goto 110
    end if
130 ik= i+ipm*iab
    j  = ik*2
  end subroutine decomp3

#ifdef _PFFT_
  subroutine decomp3p(i,j)
    integer, intent(in)  :: i
    integer, intent(out) :: j

    integer :: iab, ik

    iab=-1
110 iab=iab+1
    ik = i+iab
    if(mod(ik,npes) /= 0) goto 110
    j  = ik*2
120 continue
    if(mod(j,2) == 0) then
       j=j/2
       goto 120
    else if(mod(j,3) == 0) then
       j=j/3
       goto 120
    else if(mod(j,5) == 0) then
       j=j/5
       goto 120
    else if(j == 1) then
       goto 130
    else
       goto 110
    end if
130 ik= i+iab
    j  = ik*2
  end subroutine decomp3p
#endif

  subroutine m_FFT_Vlocal_W(afft,bfft)
    real(kind=DP), intent(in),    dimension(nfft) :: afft
    real(kind=DP), intent(inout), dimension(nfft) :: bfft

    integer i

    do i = 1, nfft-1, 2
       bfft(i)   = afft(i) * bfft(i)
       bfft(i+1) = afft(i) * bfft(i+1)
    end do
    if(mod(nfft,2) == 1) bfft(nfft) = afft(nfft)*bfft(nfft)
  end subroutine m_FFT_Vlocal_W

! =============================== added by K. Tagami ============= 11.0
  subroutine m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, ndim_chgpot, ndim_spinor )
    integer,  intent(in) :: ndim_spinor, ndim_chgpot
    real(kind=DP), intent(inout) :: afft_kt( nfft,ndim_chgpot )
    real(kind=DP), intent(inout) :: bfft_kt( nfft,ndim_spinor )

    real(kind=DP) :: ctmp_r, ctmp_i

    real(kind=DP), allocatable :: ccfft( :,: )
    integer i

    allocate( ccfft( nfft, ndim_spinor ) ); ccfft = 0.0d0

    do i = 1, nfft-1, 2
       ctmp_r = afft_kt(i,1) *bfft_kt(i,1) - afft_kt(i+1,1) *bfft_kt(i+1,1) &
            & + afft_kt(i,2) *bfft_kt(i,2) - afft_kt(i+1,2) *bfft_kt(i+1,2)
       ctmp_i = afft_kt(i+1,1) *bfft_kt(i,1) + afft_kt(i,1) *bfft_kt(i+1,1) &
            & + afft_kt(i+1,2) *bfft_kt(i,2) + afft_kt(i,2) *bfft_kt(i+1,2)
!       afft_kt(i,  1) = ctmp_r
!       afft_kt(i+1,1) = ctmp_i

       ccfft( i,1 ) = ctmp_r;  ccfft( i+1, 1 ) = ctmp_i
    end do
!
    do i = 1, nfft-1, 2
       ctmp_r = afft_kt(i,3) *bfft_kt(i,1) - afft_kt(i+1,3) *bfft_kt(i+1,1) &
            & + afft_kt(i,4) *bfft_kt(i,2) - afft_kt(i+1,4) *bfft_kt(i+1,2)
       ctmp_i = afft_kt(i+1,3) *bfft_kt(i,1) + afft_kt(i,3) *bfft_kt(i+1,1) &
            & + afft_kt(i+1,4) *bfft_kt(i,2) + afft_kt(i,4) *bfft_kt(i+1,2)
!       afft_kt(i,  2) = ctmp_r
!       afft_kt(i+1,2) = ctmp_i

       ccfft( i,2 ) = ctmp_r;  ccfft( i+1, 2 ) = ctmp_i
    end do

!    bfft_kt(:,1) = afft_kt(:,1)
!    bfft_kt(:,2) = afft_kt(:,2)

    bfft_kt(:,1) = ccfft(:,1)
    bfft_kt(:,2) = ccfft(:,2)

    deallocate( ccfft )

  end subroutine m_FFT_Vlocal_W_noncl
! ========================================================================= 11.0

  subroutine m_FFT_check_of_negative_CD(npes_in,ista_fftp,iend_fftp,ista_fftph,iend_fftph &
       &                               ,afft,nfout,nspin,ispin)
    integer, intent(in)          :: npes_in, ista_fftp, iend_fftp, ista_fftph, iend_fftph
    real(kind=DP), intent(inout) :: afft(ista_fftp:iend_fftp)
    integer, intent(in)          :: nfout,nspin,ispin

    integer                   :: ip, i,j,k, nlp,nmp,nnp,idp,nd2p,nd3p, nlph, nd1h
    integer                   :: icwarn_NEGA, icwarn_IMAG, icwarn_NEGA2,icwarn_IMAG2 &
         &                     , icwarn_NEGA_total,icwarn_IMAG_total, icwarn_NEGA_0, icwarn_IMAG_0, isw
    integer, allocatable, dimension(:)       :: istatus_afft_nega, istatus_afft_imag
!!$    integer, parameter        :: MXWARN = 10
    real(kind=DP),parameter   :: chgdel = 8.d-5
    real(kind=DP),parameter   :: D_min  = 1.d-40
!     Revised by T. Yamasaki, 14th Mar. 2005
!         Write statements in if-blocks in a do-loop have been excluded for vector processors.
    integer :: ipad1, ipad2, ipad3

    integer ::        kk, nstart, nend, itmp

    if(kimg ==  1) then
       idp = nfftp+10
    end if

    nlp = fft_box_size_CD(1,1)
    nmp = fft_box_size_CD(2,1)
    nnp = fft_box_size_CD(3,1)
    if(npes_in == npes) then
       nd2p = fft_box_size_CD(2,0)
       nd3p = fft_box_size_CD(3,0)
       if(kimg == 2) idp = fft_box_size_CD(1,0)
    else if(npes_in == npes_cdfft) then
       nd2p = fft_box_size_CD_c(2,0)
       nd3p = fft_box_size_CD_c(3,0)
       if(kimg == 2) idp = fft_box_size_CD_c(1,0)
    end if

! -- Zero padding
    if(kimg == 1) then
       ipad1 = fft_box_size_CD(1,0) - fft_box_size_CD(1,1)
       ipad2 = fft_box_size_CD(2,0) - fft_box_size_CD(2,1)
       ipad3 = fft_box_size_CD(3,0) - fft_box_size_CD(3,1)

! === DEBUG by tkato 2011/09/12 ================================================
       nlph = nlp/2
       nd1h = fft_box_size_CD(1,0)/2
! ==============================================================================
       if(ipad1 >= 4) then
! === DEBUG by tkato 2011/09/12 ================================================
!         nlph = nlp/2
!         nd1h = fft_box_size_CD(1,0)/2
! ==============================================================================
          do j = nlph+2, nd1h
             do i = 1, nd2p*nnp
                itmp = nd1h*(i-1)+j
                if(ipri >= 2) write(nfout,*) 'ZERO1: i=',itmp
                ip = 2*(nd1h*(i-1)+j)-1
                if(ip >= ista_fftp .and. ip <= iend_fftp) then
                   afft(ip)   = 0.d0
                   afft(ip+1) = 0.d0
                end if
             end do
          end do
       end if
       if(ipad2 >= 2) then
          do j = nmp+1, nd2p
             do k = 1, nnp
                do i = 1, nlph
                   itmp = i + nd1h*(j-1) + nd1h*nd2p*(k-1)
                   if(ipri >= 2) write(nfout,*) 'ZERO2: i=',itmp
                   ip = 2*(i + nd1h*(j-1) + nd1h*nd2p*(k-1))-1
                   if(ip >= ista_fftp .and. ip <= iend_fftp) then
                      afft(ip)   = 0.d0
                      afft(ip+1) = 0.d0
                   end if
                end do
             end do
          end do
       end if
       if(ipad3 >= 2) then
          do k = nnp+1, nd3p
             do i = 1, nd1h*nd2p
                itmp = nd1h*nd2p*(k-1) + i
                if(ipri >= 2) write(nfout,*) 'ZERO3: i=',itmp
                ip = 2*(nd1h*nd2p*(k-1) + i) - 1
                if(ip >= ista_fftp .and. ip <= iend_fftp) then
                   afft(ip) = 0.d0
                   afft(ip+1) = 0.d0
                end if
             end do
          end do
       end if
    end if

    if(sw_mpifft == ON) then
       if(kimg == 2) then
          do j = nlp+1, idp       ! x
             do i = 1, nd2p*nd3p  ! y,z
                ip = 2*(idp*(i-1)+j)-1
                if(ip >= ista_fftp .and. ip+1 <= iend_fftp) then
                   afft(ip)   = 0.d0
                   afft(ip+1) = 0.d0
                end if
             end do
          end do
!!$       lz_d   = fft_box_size_CD_c(3,0)/npes_cdfft
          do j = nmp+1, nd2p      ! y
             do k = 1, lz_d       ! z
                do i = 1, nlp     ! x
                   ip = 2*(i+idp*(j-1)+idp*nd2p*(k-1)+idp*nd2p*lz_d*myrank_cdfft)-1
                   if(ip >= ista_fftp .and. ip+1 <= iend_fftp) then
                      afft(ip)   = 0.d0
                      afft(ip+1) = 0.d0
                   end if
                end do
             end do
          end do
          nstart = min(lz_d*myrank_cdfft+nz_d+1,nnp+myrank_cdfft*(lz_d-nz_d)+1) ! = nnp + (isize-1)*ld + 1
          nend   = (myrank_cdfft+1)*lz_d
          do k = nstart, nend     ! z
             kk = k - lz_d*myrank_cdfft + 1
             do j = 1, nmp        ! y
                do i = 1, nlp     ! x
                   ip = 2*(i+idp*(j-1)+idp*nd2p*(kk-1)+idp*nd2p*lz_d*myrank_cdfft)-1
                   if(ip >= ista_fftp .and. ip+1 <= iend_fftp) then
                      afft(ip)   = 0.d0
                      afft(ip+1) = 0.d0
                   end if
                end do
             end do
          end do
       end if
    else
!!$#ifndef ASLFFT
       if(sw_zero_padding == ON) then
          if(kimg == 2) then
             do j = nlp+1, idp        ! x
                do i = 1, nmp*nnp     ! y,z
                   ip = 2*(idp*(i-1)+j)-1
                   if(ip >= ista_fftp .and. ip <= iend_fftp) then
                      afft(ip)   = 0.d0
                      afft(ip+1) = 0.d0
                   end if
                end do
             end do
             do j = nmp+1, nd2p       ! y
                do k = 1, nnp         ! z
                   do i = 1, nlp      ! x
                      ip = 2*(i + idp*(j-1) + idp*nd2p*(k-1))-1
                      if(ip >= ista_fftp .and. ip <= iend_fftp) then
                         afft(ip)   = 0.d0
                         afft(ip+1) = 0.d0
                      end if
                   end do
                end do
             end do
          end if
       end if
!!$#endif
    end if

    icwarn_NEGA = 0
    icwarn_IMAG = 0
    if(iprinegativecharge0 < 1 .or. max_warnings_negativecharge <= 0) then
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
       do i = ista_fftph, iend_fftph
          ip = i*2-1
          if(afft(ip) <= -chgdel .and. mod(ip+1,idp) /= 0) then
             icwarn_NEGA = icwarn_NEGA + 1
             afft(ip) = D_min
          else if (afft(ip) <= 0.d0) then
             afft(ip) = D_min
          end if
          if( (abs(afft(ip+1)) > chgdel).and. (mod(ip+1,idp) /= 0) ) then
             icwarn_IMAG = icwarn_IMAG + 1
             afft(ip+1) = 0.d0
          else if (abs(afft(ip+1)) > 0.d0) then
             afft(ip+1) = 0.d0
          end if
       end do

    else if(iprinegativecharge0 >= 1 .and. max_warnings_negativecharge > 0) then
#ifdef _VECTOR_TUNING_
       allocate(istatus_afft_nega(ista_fftph:iend_fftph)); istatus_afft_nega = 0;
       allocate(istatus_afft_imag(ista_fftph:iend_fftph)); istatus_afft_imag = 0;

       icwarn_NEGA2 = 0
       icwarn_IMAG2 = 0
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
       do i = ista_fftph, iend_fftph
          ip = i*2-1
          if(afft(ip) <= -chgdel .and. mod(ip+1,idp) /= 0) then
             istatus_afft_nega(i) = 1
             icwarn_NEGA = icwarn_NEGA + 1
          else if (afft(ip) <= 0.d0) then
             icwarn_NEGA2 = icwarn_NEGA2 + 1
             istatus_afft_nega(i) = 2
          end if
          if( (abs(afft(ip+1)) > chgdel).and. (mod(ip+1,idp) /= 0) ) then
             istatus_afft_imag(i) = 1
             icwarn_IMAG = icwarn_IMAG + 1
          else if (abs(afft(ip+1)) > 0.d0) then
             icwarn_IMAG2 = icwarn_IMAG2 + 1
             istatus_afft_imag(i) = 2
          end if
       end do

       if(iprinegativecharge >= 1) then
          if(icwarn_NEGA >= 1) then
             do i = ista_fftph, iend_fftph
                if(istatus_afft_nega(i) == 1) exit
             end do
             icwarn_NEGA_0 = i
             if(iprinegativecharge >= 2) &
                  & write(nfout,'(" ista_fftph, iend_fftph, icwarn_NEGA_0 = ",3i8)') ista_fftph, iend_fftph, icwarn_NEGA_0

! ============================ modified by K. Tagami ================ 11.0
!             if(nspin == 2)  write(nfout,'(" #spin = ",i3)') ispin
!
             if ( nspin == 100 ) then
                write(nfout,'(" #loop = ",i3)') ispin
             else if ( nspin == 2 )  then
                write(nfout,'(" #spin = ",i3)') ispin
             endif
! ============================ modified by K. Tagami ================ 11.0

             j = 0
             do i = icwarn_NEGA_0, iend_fftph
                ip = i*2-1
                if(istatus_afft_nega(i) == 1) then
                   j = j+1
                   if(j > max_warnings_negativecharge) exit
                   write(nfout,'(" *** WARN CHG.DEN = ",d15.7, " < 0.0 AT ",i8," ***")') afft(ip),i
                end if
             end do
          end if
          if(icwarn_IMAG >= 1) then
             do i = ista_fftph, iend_fftph
                if(istatus_afft_imag(i) == 1) exit
             end do
             icwarn_IMAG_0 = i
             if(iprinegativecharge >= 2) &
                  & write(nfout,'(" ista_fftph, iend_fftph, icwarn_NEGA_0 = ",3i8)') ista_fftph, iend_fftph, icwarn_IMAG_0

! =================================== modified by K. Tagami ================ 11.0
!             if(nspin == 2) write(nfout,'(" #spin = ",i3)') ispin
!
             if ( nspin == 100 ) then
                write(nfout,'(" #loop = ",i3)') ispin
             else if ( nspin == 2 ) then
                write(nfout,'(" #spin = ",i3)') ispin
             endif
! ========================================================================== 11.0

             j = 0
             do i = icwarn_IMAG_0, iend_fftph
                ip = i*2-1
                if(istatus_afft_imag(i) == 1) then
                   j = j+1
                   if(j > max_warnings_negativecharge) exit
                   write(nfout,'(" *** WARN IMAG(CHG) = ",d15.7, " > 0.0 AT ",i8," ***")') afft(ip+1),i
                end if
             end do
          end if
       end if

       if(icwarn_NEGA+icwarn_NEGA2 >=1 .or. icwarn_IMAG+icwarn_IMAG2 >=1) then
          do i = ista_fftph, iend_fftph
             ip = i*2-1
             if(istatus_afft_nega(i) >= 1) afft(ip) = D_min
             if(istatus_afft_imag(i) >= 1) afft(ip+1) = 0.d0
          end do
       end if

       deallocate(istatus_afft_imag, istatus_afft_nega)

#else
       isw = 0
       do i = ista_fftph, iend_fftph
          ip = i*2-1
          if(afft(ip) <= -chgdel .and. mod(ip+1,idp) /= 0) then
             icwarn_NEGA = icwarn_NEGA + 1
             if(icwarn_NEGA <= max_warnings_negativecharge) then

! ==================================== modified by K. Tagami ============= 11.0
!                if(icwarn_NEGA == 1 .and. nspin == 2) then
!                   if(iprinegativecharge>=1) then
!                      write(nfout,'(" #spin = ",i3)') ispin
!                      isw = 1
!                   end if
!                endif
!
                if (icwarn_NEGA == 1) then
                   if ( nspin == 100 ) then
                      if(iprinegativecharge>=1) then
                         write(nfout,'(" #loop = ",i3)') ispin
                         isw = 1
                      end if
                   else if ( nspin == 2 ) then
                      if(iprinegativecharge>=1) then
                         write(nfout,'(" #spin = ",i3)') ispin
                         isw = 1
                      end if
                   end if
                end if
! ====================================================================== 11.0

                if(iprinegativecharge >=1) &
                     & write(nfout,'(" *** WARN CHG.DEN = ",d15.7, " < 0.0 AT ",i8," ***")') afft(ip),i
             endif
             afft(ip) = D_min
          else if (afft(ip) <= 0.d0) then
             afft(ip) = D_min
          end if
          if( (abs(afft(ip+1)) > chgdel).and. (mod(ip+1,idp) /= 0) ) then
             icwarn_IMAG = icwarn_IMAG + 1
             if(icwarn_IMAG <= max_warnings_negativecharge) then
! ==================================== modified by K. Tagami ============ 11.0
!                if(icwarn_IMAG == 1 .and. nspin == 2) then
!                   if(iprinegativecharge >=1 .and. isw == 0) write(nfout,'("#spin = ",i3)') ispin
!                endif
!
                if (icwarn_IMAG == 1 ) then
                   if ( nspin == 100 ) then
                      if(iprinegativecharge >=1 .and. isw == 0) &
                           &         write(nfout,'(" #loop = ",i3)') ispin
                   else if ( nspin == 2 ) then
                      if(iprinegativecharge >=1 .and. isw == 0) &
                           &         write(nfout,'(" #spin = ",i3)') ispin
                   endif
                endif
! ======================================================================== 11.0

                if(iprinegativecharge>=1) &
                     & write(nfout,'(" *** WARN IMAG(CHG) = ",d15.7, " > 0.0 AT ",i8," ***")') afft(ip+1),i
             endif
             afft(ip+1) = 0.d0
          else if (abs(afft(ip+1)) > 0.d0) then
             afft(ip+1) = 0.d0
          end if
       end do
#endif
    end if

    if(iprinegativecharge0 >= 1) then
       if(npes_in == npes .and. npes > 1) then
          call mpi_allreduce(icwarn_NEGA,icwarn_NEGA_total,1,mpi_integer,mpi_sum,MPI_CommGroup,ierr)
          call mpi_allreduce(icwarn_IMAG,icwarn_IMAG_total,1,mpi_integer,mpi_sum,MPI_CommGroup,ierr)
       else if(npes_in == npes_cdfft .and. npes_cdfft > 1) then
          call mpi_allreduce(icwarn_NEGA,icwarn_NEGA_total,1,mpi_integer,mpi_sum &
               & ,mpi_cdfft_world(myrank_ggacmp),ierr)
          call mpi_allreduce(icwarn_IMAG,icwarn_IMAG_total,1,mpi_integer,mpi_sum &
               & ,mpi_cdfft_world(myrank_ggacmp),ierr)
       else
          icwarn_NEGA_total = icwarn_NEGA
          icwarn_IMAG_total = icwarn_IMAG
       end if
    end if

    if(iprinegativecharge >=1) then
       if(icwarn_NEGA_total >= 1) then
! =============================== modified by K. Tagami =============== 11.0
!          if(nspin == 2) write(nfout,'(" #spin = ",i3," : 1 = UP, 2 = DOWN")') ispin
!
          if ( nspin == 100 ) then
             write(nfout,'(" #loop = ",i3)' ) ispin
          else if (nspin == 2) then
             write(nfout,'(" #spin = ",i3," : 1 = UP, 2 = DOWN")') ispin
          endif
! ===================================================================== 11.0

          if(npes == 1) then
             !write(nfout,'(" *** WARN  # of <<Negative Charge Density>>  = ",i9)') icwarn_NEGA_total
             write(nfout,'(" ### Warning(4202): Number of <<Negative Charge Density>> =",i9)') icwarn_NEGA_total

          else
             !write(nfout,'(" *** WARN  # of <<Negative Charge Density>>  = ",i9,", (node ",i3,") = ",i9)') &
             !     & icwarn_NEGA_total, mype,icwarn_NEGA
             write(nfout,'(" ### Warning(4202): Number of <<Negative Charge Density>> =",i9,", (node ",i3,") = ",i9)') &
                  & icwarn_NEGA_total, mype,icwarn_NEGA
          end if
       endif

       if(icwarn_IMAG_total >= 1) then
! =============================== modified by K. Tagami =============== 11.0
!          if(nspin == 2) write(nfout,'(" #spin = ",i3," : 1 = UP, 2 = DOWN")') ispin
!
          if ( nspin == 100 ) then
             write(nfout,'(" #loop = ",i3)' ) ispin
          else if (nspin == 2) then
             write(nfout,'(" #spin = ",i3," : 1 = UP, 2 = DOWN")') ispin
          endif
! ===================================================================== 11.0

          if(npes == 1) then
             write(nfout,'(" *** WARN  # of <<Imaginary Charge Density>> = ",i9)') icwarn_IMAG_total
          else
             write(nfout,'(" *** WARN  # of <<Imaginary Charge Density>> = ",i9,", (node ",i3,") = ",i9)') &
                  & icwarn_IMAG_total, mype,icwarn_IMAG
          end if
       end if
    end if
  end subroutine m_FFT_check_of_negative_CD

  subroutine m_FFT_W_Vlocal_W(electron_or_positron,nabfft,afft,bfft,eg)
    integer, intent(in) ::                             electron_or_positron
    integer, intent(in) ::                             nabfft
    real(kind=DP), intent(in),    dimension(nabfft) :: afft
    real(kind=DP), intent(inout), dimension(nabfft) :: bfft
    real(kind=DP), intent(out)                 :: eg

    integer i, id, j, k, ip, nl, nm, nn, nd2, nd3, nlh, idh
    real(kind=DP) :: s



    if(electron_or_positron == ELECTRON) then
       id  = fft_box_size_WF(1,0)
       nl  = fft_box_size_WF(1,1)
       nm  = fft_box_size_WF(2,1)
       nn  = fft_box_size_WF(3,1)
       nd2 = fft_box_size_WF(2,0)
       nd3 = fft_box_size_WF(3,0)
    else if(electron_or_positron == POSITRON) then
       id  = fft_box_size_pWF(1,0)
       nl  = fft_box_size_pWF(1,1)
       nm  = fft_box_size_pWF(2,1)
       nn  = fft_box_size_pWF(3,1)
       nd2 = fft_box_size_pWF(2,0)
       nd3 = fft_box_size_pWF(3,0)
    end if

    s = 0.d0
    if(kimg == 1) then
       do i = 1, id*nd2*nn-1, 2
          bfft(i) = afft(i)*(bfft(i)**2 + bfft(i+1)**2)
       end do
       nlh = nl/2
       do i = 1, id*nd2*nn-1, 2
          s = s + bfft(i)
       end do
       s = s + s
       do i = 1, id*nd2*nn-1, id
          s = s - bfft(i)
       end do
       do i = nlh*2+1, id*nd2*nn-1, id
          s = s - bfft(i)
       end do
!!$       write(6,'(" s = ", d20.8)') s
    else if(kimg == 2) then
       do i = 1, id*nd2*nn*kimg-1, 2
          s = s + afft(i)*(bfft(i)**2 + bfft(i+1)**2)
       end do
!!$       if(sw_zero_padding == ON) then
!!$          do j = nl+1, id
!!$             do i = 1, nd2*nn
!!$                ip = id*(i-1) + j
!!$                bfft(ip*2-1) = 0.d0
!!$                bfft(ip*2) = 0.d0
!!$             end do
!!$          end do
!!$          do j = nm+1, nd2
!!$             do k = 1, nn
!!$                do i = 1, nl
!!$                   ip = i + id*(j-1) + id*nd2*(k-1)
!!$                   bfft(ip*2-1) = 0.d0
!!$                   bfft(ip*2) = 0.d0
!!$                end do
!!$             end do
!!$          end do
    end if
    eg = s / product(fft_box_size_WF(1:3,1))
  end subroutine m_FFT_W_Vlocal_W

! =========================== added by K. Tagami =================== 11.0
  subroutine m_FFT_W_Vlocal_W_noncl(electron_or_positron,nabfft,afft_kt,bfft_kt,eg, &
       &     ndim_spinor, ndim_chgpot )
    integer, intent(in) ::     electron_or_positron
    integer, intent(in) ::     nabfft
    integer, intent(in) ::     ndim_chgpot, ndim_spinor

    real(kind=DP), intent(in)    :: afft_kt( nabfft,ndim_chgpot )
    real(kind=DP), intent(inout) :: bfft_kt( nabfft,ndim_spinor  )
    real(kind=DP), intent(out)                 :: eg
!
    real(kind=DP), allocatable ::  afft_tmp(:)
    integer i, id, j, k, ip, nl, nm, nn, nd2, nd3, nlh, idh
    real(kind=DP) :: s, ctmp_r, ctmp_i

!
    integer :: is1, is2, is_tmp
    complex(kind=CMPLDP) :: z1, z2, z3, zsum

    if(electron_or_positron == ELECTRON) then
       id  = fft_box_size_WF(1,0)
       nl  = fft_box_size_WF(1,1)
       nm  = fft_box_size_WF(2,1)
       nn  = fft_box_size_WF(3,1)
       nd2 = fft_box_size_WF(2,0)
       nd3 = fft_box_size_WF(3,0)
    else if(electron_or_positron == POSITRON) then
       id  = fft_box_size_pWF(1,0)
       nl  = fft_box_size_pWF(1,1)
       nm  = fft_box_size_pWF(2,1)
       nn  = fft_box_size_pWF(3,1)
       nd2 = fft_box_size_pWF(2,0)
       nd3 = fft_box_size_pWF(3,0)
    end if

    allocate( afft_tmp( nabfft ) ); afft_tmp = 0.0d0

    s = 0.d0
    if(kimg == 1) then
       do i = 1, id*nd2*nn-1, 2
          ctmp_r = bfft_kt( i,  1 ) *bfft_kt( i,2 ) + bfft_kt( i+1,1 )*bfft_kt( i+1,2 )
          ctmp_i = bfft_kt( i+1,1 ) *bfft_kt( i,2 ) - bfft_kt( i  ,1 )*bfft_kt( i+1,2 )

          afft_tmp(i) =  afft_kt(i,1)*( bfft_kt(i,1)**2 + bfft_kt(i+1,1)**2 ) &
               &        +afft_kt(i,4)*( bfft_kt(i,2)**2 + bfft_kt(i+1,2)**2 ) &
               &        +( afft_kt(i,2)*ctmp_r -afft_kt(i+1,2)*ctmp_i )*2.0d0

       end do

       nlh = nl/2
       do i = 1, id*nd2*nn-1, 2
          s = s + afft_tmp(i)
       end do
       s = s + s
       do i = 1, id*nd2*nn-1, id
          s = s - afft_tmp(i)
       end do
       do i = nlh*2+1, id*nd2*nn-1, id
          s = s - afft_tmp(i)
       end do
!!$       write(6,'(" s = ", d20.8)') s
    else if(kimg == 2) then

       do i = 1, id*nd2*nn*kimg -1, 2
          zsum = 0.0d0
          Do is1=1, ndim_spinor
             Do is2=1, ndim_spinor

                is_tmp = ( is1- 1 )*ndim_spinor + is2
                z1 = dcmplx( bfft_kt(i,is1), bfft_kt(i+1,is1) )
                z2 = dcmplx( bfft_kt(i,is2), bfft_kt(i+1,is2) )
                z3 = dcmplx( afft_kt(i,is_tmp), afft_kt(i+1,is_tmp) )
                zsum = zsum + conjg( z1 )*z2 *z3
             End do
          End do

          afft_tmp(i) = real(zsum)

!          ctmp_r = bfft_kt( i,  1 ) *bfft_kt( i,2 ) + bfft_kt( i+1,1 )*bfft_kt( i+1,2 )
!          ctmp_i = bfft_kt( i+1,1 ) *bfft_kt( i,2 ) - bfft_kt( i  ,1 )*bfft_kt( i+1,2 )

!          afft_tmp(i) =  afft_kt(i,1)*( bfft_kt(i,1)**2 + bfft_kt(i+1,1)**2 ) &
!               &        +afft_kt(i,4)*( bfft_kt(i,2)**2 + bfft_kt(i+1,2)**2 ) &
!               &        +( afft_kt(i,2)*ctmp_r -afft_kt(i+1,2)*ctmp_i )*2.0d0

       end do
       do i = 1, id*nd2*nn*kimg -1, 2
          s = s + afft_tmp(i)
       end do

    end if
    eg = s / product(fft_box_size_WF(1:3,1))

    if ( allocated( afft_tmp ) ) deallocate( afft_tmp )

  end subroutine m_FFT_W_Vlocal_W_noncl
!! ============================================================================ 11.0

  subroutine m_FFT_afft_allgatherv(afft_mpi0,afft)
    real(kind=DP),intent(in),dimension(:) :: afft_mpi0(ista_sfftp:iend_sfftp)
    real(kind=DP),intent(out),dimension(:):: afft(nfftp)
    integer  :: id_sname = -1
    if(npes >= 2) then
       call tstatc0_begin('m_FFT_afft_allgatherv(in m_FFT.) ',id_sname)
       call mpi_allgatherv(afft_mpi0,nel_sfftp(mype),mpi_double_precision &  ! MPI
            &       ,afft,nel_sfftp,idisp_sfftp,mpi_double_precision,MPI_CommGroup,ierr)
    else     ! npes == 1
       afft = afft_mpi0
    end if
    if(npes >= 2) call tstatc0_end(id_sname)
  end subroutine m_FFT_afft_allgatherv

  subroutine m_FFT_afft_allgatherv_c(afft_mpi0,afft)
    real(kind=DP),intent(in),dimension(:) :: afft_mpi0(ista_fftp:iend_fftp)
    real(kind=DP),intent(out),dimension(:):: afft(nfftp)
    integer  :: id_sname = -1
    if(npes_cdfft >= 2) then
       call tstatc0_begin('m_FFT_afft_allgatherv_c(in m_FFT.) ',id_sname)
       if(myrank_ggacmp <nrank_ggacmp) then
          call mpi_allgatherv(afft_mpi0,nel_fftp(myrank_cdfft),mpi_double_precision &  ! MPI
               &       ,afft,nel_fftp,idisp_fftp,mpi_double_precision,mpi_cdfft_world(myrank_ggacmp),ierr)
       end if
       call tstatc0_end(id_sname)
    else     ! npes == 1
       afft = afft_mpi0
    end if
  end subroutine m_FFT_afft_allgatherv_c

  subroutine m_FFT_Vlocal_pW(afft,bfft)
    real(kind=DP), intent(in),    dimension(nfft_pstrn) :: afft
    real(kind=DP), intent(inout), dimension(nfft_pstrn) :: bfft

    integer i
    do i = 1, nfft_pstrn-1, 2
       bfft(i)   = afft(i) * bfft(i)
       bfft(i+1) = afft(i) * bfft(i+1)
    end do
    if(mod(nfft_pstrn,2) == 1) bfft(nfft_pstrn) = afft(nfft_pstrn)*bfft(nfft_pstrn)
  end subroutine m_FFT_Vlocal_pW

! === EXP_CELLOPT ==== 2015/09/24
  subroutine m_FFT_coef_CD_integration_kt(ista,iend,f2or1)
                                            ! from m_XC_Potential.F90,  for electron ?
    integer, intent(in) :: ista, iend
    real(kind=DP),intent(out) :: f2or1( ista:iend )

    integer                  :: idp,nlp,nmp,nnp,nd2p,nd3p,ip, idph, nlph

    nlp  = fft_box_size_CD(1,1)
    nmp  = fft_box_size_CD(2,1)
    nnp  = fft_box_size_CD(3,1)
#ifdef _MPIFFT_
    idp  = fft_box_size_CD_c(1,0)
    nd2p = fft_box_size_CD_c(2,0)
    nd3p = fft_box_size_CD_c(3,0)
#else
    idp  = fft_box_size_CD(1,0)
    nd2p = fft_box_size_CD(2,0)
    nd3p = fft_box_size_CD(3,0)
#endif

    call set_f2or1( npes, ista, iend, f2or1 )

  contains

    subroutine set_f2or1(npes,ista,iend,f2or1)
      integer, intent(in) :: npes,ista, iend
      real(kind=DP), intent(out), dimension(ista:iend) :: f2or1
      integer :: idph,nlph,ip,i,j,k

      if(kimg == 1) then
         idph = idp/2
         nlph = nlp/2
#ifdef _MPIFFT_

         f2or1 = 0.d0
!!$         do j = 1, min(nz_d,nnp-nz_d*myrank_cdfft)*nmp
!!$         do j = 1, min(nz_d,nnp-nz_d*myrank_cdfft)*nd2p
         do k = 1, min(nz_d, nnp-nz_d*myrank_cdfft)
            do j = 1, nmp
               do i = 1, nlph
!!$                  ip = i + idph*(j-1) + idph*ly*lz_d*myrank_cdfft
                  ip = i + idph*(j-1) + idph*ly*(k-1) + idph*ly*lz_d*myrank_cdfft
                  f2or1(ip) = 2.d0
               end do
               ip = 1 + idph*(j-1) + idph*ly*(k-1) + idph*ly*lz_d*myrank_cdfft
               f2or1(ip) = 1.d0
               ip = nlph+1 + idph*(j-1) + idph*ly*(k-1) + idph*ly*lz_d*myrank_cdfft
               f2or1(ip) = 1.d0
            end do
         end do
!!$            ip = idph*(j-1) + 1 + idph*ly*lz_d*myrank_cdfft
!!$            f2or1(ip) = 1.d0
!!$            ip = idph*(j-1)+ nlph + 1 + idph*ly*lz_d*myrank_cdfft
!!$            f2or1(ip) = 1.d0
!!$         end do
#else
         f2or1 = 2.d0
         if(npes >= 2) then
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + 1
               if(ip>= ista .and. ip <= iend) f2or1(ip) = 1.d0
            end do
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + nlph + 1
               if(ip>= ista .and. ip <= iend) f2or1(ip) = 1.d0
            end do
            do j = nlph+2, idph
               do i = 1,nd2p*nnp
                  ip = idph*(i-1)+j
                  if(ip>= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
            do j = nmp+1, nd2p
               do k = 1, nnp
                  do i = 1, nlph
                     ip = i + idph*(j-1) + idph*nd2p*(k-1)
                     if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p
               do i = 1, idph*nd2p
                  ip = i + idph*nd2p*(k-1)
                  if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
         else
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + 1
               f2or1(ip) = 1.d0
            end do
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + nlph + 1
               f2or1(ip) = 1.d0
            end do
            do j = nlph+2, idph
               do i = 1,nd2p*nnp
                  ip = idph*(i-1)+j
                  f2or1(ip) = 0.d0
               end do
            end do
            do j = nmp+1, nd2p
               do k = 1, nnp
                  do i = 1, nlph
                     ip = i + idph*(j-1) + idph*nd2p*(k-1)
                     f2or1(ip) = 0.d0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p
               do i = 1, idph*nd2p
                  ip = i + idph*nd2p*(k-1)
                  f2or1(ip) = 0.d0
               end do
            end do
         end if
!!$       do i = ista, iend
!!$          if(mod(i*2,idp) == 2 .or. mod(i*2,idp) == 0) f2or1(i) = 1.d0
!!$       end do
#endif
      else
#ifdef _MPIFFT_
!!$         f2or1 = 0.d0                 ! f2or1 works to the fft data in Rspace.
!!$         do k = 1, min(nz_d,nnp-nz_d*myrank_cdfft)
!!$            do j = 1, nmp     ! nmp = fft_box_size_CD(2,1)
!!$               do i = 1, nlp  ! nlp = fft_box_size_CD(1,1)
!!$                  ip = i+(j-1)*idp+(k-1)*idp*nd2p+idp*nd2p*lz_d*myrank_cdfft
!!$                  f2or1(ip) = 1.d0
!!$               end do
!!$            end do
!!$         end do
!         if(iprixc >= 2 ) write(nfout,'(" ix kimg = 2 <<set_f2or1>>")')
         f2or1 = 1.d0
         do j = nlp+1, idp      ! x
            do i = 1, ly*nz_d
               ip = idp*(i-1)+j+ista-1
               f2or1(ip) = 0.d0
            end do
         end do
!         if(iprixc >= 2 ) write(nfout,'(" iy kimg = 2 <<set_f2or1>>")')
         do j = nmp+1,ly         ! y
            do k = 1, nz_d
               do i = 1, nlp
                  ip = i + idp*(j-1) + idp*ly*(k-1) + ista-1
                  f2or1(ip) = 0.d0
               end do
            end do
         end do
!         if(iprixc >= 2 ) write(nfout,'(" iz kimg = 2 <<set_f2or1>>")')
         do  k = nz_d+1, lz_d   ! z
            do i = 1, idp*ly
               ip = i + idp*ly*(k-1) + ista-1
               f2or1(ip) = 0.d0
            end do
         end do
#else
         f2or1 = 1.d0
         if(npes >= 2) then
            do j = nlp+1, idp    ! x
               do i = 1, nd2p*nnp
                  ip = idp*(i-1)+j
                  if(ip>= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
            do j = nmp+1, nd2p   ! y
               do k = 1, nnp
                  do i = 1, nlp
                     ip = i + idp*(j-1) + idp*nd2p*(k-1)
                     if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p   ! z
               do i = 1, idp*nd2p
                  ip = i + idp*nd2p*(k-1)
                  if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
         else
            do j = nlp+1, idp    ! x
               do i = 1, nd2p*nnp
                  ip = idp*(i-1)+j
! ================================ modifed by K. Tagami ====( uncertain )== 11.0
!                  f2or1(ip) = 0.d0
                  if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
! ===================================================================== 11.0
               end do
            end do
            do j = nmp+1, nd2p   ! y
               do k = 1, nnp
                  do i = 1, nlp
                     ip = i + idp*(j-1) + idp*nd2p*(k-1)
! ================================ modifed by K. Tagami ====( uncertain )== 11.0
!                     f2or1(ip) = 0.d0
                     if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
! ===================================================================== 11.0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p   ! z
               do i = 1, idp*nd2p
                  ip = i + idp*nd2p*(k-1)
! ================================ modifed by K. Tagami ====( uncertain )== 11.0
!                  f2or1(ip) = 0.d0
                  if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
! ===================================================================== 11.0
               end do
            end do
         end if
#endif
      end if
    end subroutine set_f2or1
  end subroutine m_FFT_coef_CD_integration_kt
! ==================== 2015/09/24

  subroutine m_FFT_coef_CD_integration(f2or1)
    real(kind=DP),intent(out), dimension(ista_sfftph:iend_sfftph) :: f2or1
    integer :: idp, nlp, nmp, nnp, nd2p, idph, nlph, ip, i, j, k

    idp  = fft_box_size_CD(1,0)
    nlp  = fft_box_size_CD(1,1)
    nmp  = fft_box_size_CD(2,1)
    nnp  = fft_box_size_CD(3,1)
    nd2p = fft_box_size_CD(2,0)


    if(kimg == 1) then
       f2or1 = 2.d0
       idph = idp/2
       nlph = nlp/2
       if(npes >= 2) then
          do i = 1, nd2p*nnp
             ip = idph*(i-1) + 1
             if(ip>= ista_sfftph .and. ip <= iend_sfftph) f2or1(ip) = 1.d0
          end do
          do i = 1, nd2p*nnp
             ip = idph*(i-1) + nlph + 1
             if(ip>= ista_sfftph .and. ip <= iend_sfftph) f2or1(ip) = 1.d0
          end do
          do j = nlph+2, idph
             do i = 1,nd2p*nnp
                ip = idph*(i-1)+j
                if(ip>= ista_sfftph .and. ip <= iend_sfftph) f2or1(ip) = 0.d0
             end do
          end do
          do j = nmp+1, nd2p
             do i = 1, nlph
                ip = i + idph*(j-1) + idph*nd2p*(k-1)
                if(ip >= ista_sfftph .and. ip <= iend_sfftph) f2or1(ip) = 0.d0
             end do
          end do
       else
          do i = 1, nd2p*nnp
             ip = idph*(i-1) + 1
             f2or1(ip) = 1.d0
          end do
          do i = 1, nd2p*nnp
             ip = idph*(i-1) + nlph + 1
             f2or1(ip) = 1.d0
          end do
          do j = nlph+2, idph
             do i = 1,nd2p*nnp
                ip = idph*(i-1)+j
                f2or1(ip) = 0.d0
             end do
          end do
          do j = nmp+1, nd2p
             do i = 1, nlph
                ip = i + idph*(j-1) + idph*nd2p*(k-1)
                f2or1(ip) = 0.d0
             end do
          end do
       end if
!!$       do i = ista_sfftph, iend_sfftph
!!$          if(mod(i*2,idp) == 2 .or. mod(i*2,idp) == 0) f2or1(i) = 1.d0
!!$       end do
    else
       f2or1 = 1.d0
       if(npes >= 2) then
          do j = nlp+1, idp
             do i = 1, nd2p*nnp
                ip = idp*(i-1)+j
                if(ip>= ista_sfftph .and. ip <= iend_sfftph) f2or1(ip) = 0.d0
             end do
          end do
          do j = nmp+1, nd2p
             do k = 1, nnp
                do i = 1, nlp
                   ip = i + idp*(j-1) + idp*nd2p*(k-1)
                   if(ip >= ista_sfftph .and. ip <= iend_sfftph) f2or1(ip) = 0.d0
                end do
             end do
          end do
       else
          do j = nlp+1, idp
             do i = 1, nd2p*nnp
                ip = idp*(i-1)+j
                f2or1(ip) = 0.d0
             end do
          end do
          do j = nmp+1, nd2p
             do k = 1, nnp
                do i = 1, nlp
                   ip = i + idp*(j-1) + idp*nd2p*(k-1)
                   f2or1(ip) = 0.d0
                end do
             end do
          end do
       end if
    end if
  end subroutine m_FFT_coef_CD_integration
#ifdef _MPIFFT_
  subroutine m_FFT_set_cdata(aa,a)
    real(kind=DP), dimension(nfftp), intent(in)                :: aa
    real(kind=DP), dimension(ista_fftp:iend_fftp), intent(out) :: a
    integer :: i,j,k,ii,jj,kk,nn(3),nstart(3),nend(3)
    integer :: lx, llx,lly,lxy,llxy, indexa, ipout, ipin
    indexa = 2
    if(kimg == 1) then
       a = 0.d0
       nn(1:3) = fft_box_size_CD(1:3,1)
       nn(2)   = ny_d
       nstart(1:3) = 1
       nend(1:3) = nn(1:3)
       nstart(indexa)=myrank_cdfft*nn(indexa)+1
       nend(indexa)  =min(fft_box_size_CD(indexa,1),(myrank_cdfft+1)*nn(indexa))
       lx = fft_box_size_CD_c(1,0)
!!$       ly = ly_d   !          =fft_box_size_CD_c(2,0)/npes_cdfft
       llx = fft_box_size_CD_c(1,0)
       lly = fft_box_size_CD_c(2,0)
       lxy = lx*ly_d
       llxy = llx*lly
       do i=nstart(1),nend(1)
          ii=i-nstart(1)+1
          do j=nstart(2),nend(2)
             jj=j-nstart(2)+1
             do k=nstart(3),nend(3)
                kk=k-nstart(3)+1
                ipout = ista_fftp-1+ (ii +(jj-1)* lx+(kk-1)* lxy)
                ipin  =              ( i +( j-1)*llx+( k-1)*llxy)
                A(ipout)   = AA(ipin)
!!$                A(ipout+1) = AA(ipin+1)
             enddo
          enddo
       enddo
    else if(kimg == 2) then
       A = 0.d0
       nn(1:3) = fft_box_size_CD(1:3,1)
       nn(2) = ny_d
       nstart(1:3) = 1
       nend(1:3) = nn(1:3)
       nstart(indexa)=myrank_cdfft*nn(indexa)+1
       nend(indexa)  =min(fft_box_size_CD(indexa,1),(myrank_cdfft+1)*nn(indexa))
       lx = fft_box_size_CD_c(1,0)
!!$       ly = ly_d   !          =fft_box_size_CD_c(2,0)/npes_cdfft
       llx = fft_box_size_CD_c(1,0)
       lly = fft_box_size_CD_c(2,0)
       lxy = lx*ly_d
       llxy = llx*lly
       if(ipri >= 2) then
          write(nfout,'(" nstart(1), nend(1) = ",2i8)') nstart(1), nend(1)
          write(nfout,'(" nstart(2), nend(2) = ",2i8)') nstart(2), nend(2)
          write(nfout,'(" nstart(3), nend(3) = ",2i8)') nstart(3), nend(3)
          write(nfout,'(" llx,lx,lly,ly_d    = ",4i8)') llx,lx,lly,ly_d
       end if
!!$       if(npes_cdfft == 1) nend(2) = nend(2)/2
!!$       if(myrank_cdfft == 0) then
       do i=nstart(1),nend(1)
          ii=i-nstart(1)+1
          do j=nstart(2),nend(2)
             jj=j-nstart(2)+1
             do k=nstart(3),nend(3)
                kk=k-nstart(3)+1
                ipout = ista_fftp-1 + 2*(ii +(jj-1)* lx+(kk-1)* lxy)-1
                ipin  =               2*( i +( j-1)*llx+( k-1)*llxy)-1
                A(ipout)   = AA(ipin)
                A(ipout+1) = AA(ipin+1)
             end do
          end do
       end do
    end if

  end subroutine m_FFT_set_cdata

  subroutine m_FFT_set_scdata(aa,a)
    real(kind=DP), dimension(*), intent(in)                    :: aa
    real(kind=DP), dimension(ista_fftp:iend_fftp), intent(out) :: a
    integer :: i,j,k,ii,jj,kk,nn(3),nstart(3),nend(3)
    integer :: lx,llx,lly,lxy,llxy,indexa
    indexa = 2
    if(kimg == 2) then
       nn(1:3) = fft_box_size_CD(1:3,1)
       nn(2) = ny_ds
       nstart(1:3) = 1
       nend(1:3) = nn(1:3)
       nstart(indexa)=mype*nn(indexa)+1
       nend(indexa)  =min(fft_box_size_CD(indexa,1),(mype+1)*nn(indexa))
       lx = fft_box_size_CD_c(1,0)
!!$       ly = fft_box_size_CD(2,0)/npes ! = ly_ds
       llx = fft_box_size_CD_c(1,0)
       lly = fft_box_size_CD_c(2,0)
       lxy = lx*ly_ds
       llxy = llx*lly
       do i=nstart(1),nend(1)
          ii=i-nstart(1)+1
          do j=nstart(2),nend(2)
             jj=j-nstart(2)+1
             do k=nstart(3),nend(3)
                kk=k-nstart(3)+1
                A(ista_fftp-1+ii+(jj-1)*lx+(kk-1)*lxy)=AA(i+(j-1)*llx+(k-1)*llxy-ista_fftp)
             enddo
          enddo
       enddo
    end if

  end subroutine m_FFT_set_scdata
#endif

#ifdef _MPIFFT_
  subroutine check_ierr(ierr0)
    integer, intent(in),dimension(2) :: ierr0
    IF( IERR0(1) .GE. 3000 ) THEN
       WRITE(6,*) '*** 3D FFT ERROR ***'
       WRITE(6,*) mype,':IERR =',IERR0(1)
       IF( IERR0(1) .EQ. -1 ) THEN
          WRITE(6,*) mype,':MPI ERROR =',IERR0(2)
       ENDIF
       call phase_error_with_msg(nfout,'error hyb fft',__LINE__,__FILE__)
    ENDIF
  end subroutine check_ierr

  subroutine wd_time(time)
    real(kind=DP), intent(in), dimension(5) :: time
    WRITE(6,6000)
    WRITE(6,6010) mype,TIME(1:5)
6000 FORMAT(' RANK     X-FFT       Y-FFT       Z-FFT       ', &
          &       'TRANS       TOTAL  (Direct)')
6010 FORMAT(1X,I4,':',6(1PD12.4),0PF9.1)
  end subroutine wd_time

  subroutine get_nxnynz(nx,ny,nz)
    integer, intent(out) :: nx,ny,nz
    NX = fft_box_size_CD(1,1)
    NY = fft_box_size_CD(2,1)
    NZ = fft_box_size_CD(3,1)
  end subroutine get_nxnynz

#endif

  subroutine m_FFT_CD_direct(nfout,afft)   ! R space --> G space
#ifdef NEC_TUNE_FFT
      use m_Parallelization,   only : itask
#endif
    integer, intent(in)       :: nfout
    real(kind=DP), intent(inout) :: afft(ista_sfftp:iend_sfftp)
#ifdef _MPIFFT_
    INTEGER :: NX,NY,NZ
    INTEGER :: NT,ISW,IERR0(2)
    integer, parameter :: INDEXA = 2, INDEXB = 3
    real(kind=DP),allocatable :: B(:)
    real(kind=DP) :: TIME(5)
    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_CD_direct ',id_sname)

    call get_nxnynz(nx,ny,nz)

    allocate(B(ista_sfftp:iend_sfftp))
    ISW = 1
#ifdef NEC_TUNE_FFT
    NT = itask
#else
    NT = 1
#endif

    if(kimg==1) then
       call fft_r3d(nx,ny,nz,ny_ds,nz_ds,afft &
            &      ,lxs,lys,lzs,ly_ds,lz_ds,indexa,isw,time,b &
            &      ,nt, MPI_CommGroup,ierr0)
    else
       call fft_c3d(nx,ny,nz,ny_ds,nz_ds,afft &
            &      ,lxs,lys,lzs,ly_ds,lz_ds,indexa,isw,time,b &
            &      ,nt, MPI_CommGroup,ierr0)
    end if
    call check_ierr(ierr0)

    CALL MPI_BARRIER(MPI_CommGroup,IERR)

    if(ipri >= 2) call wd_time(time)

    deallocate(B)
#else
    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_CD_direct ',id_sname)

    if(npes >= 2) then
       call m_FFT_afft_allgatherv(afft,afft_CD)
    else
       afft_CD = afft
    end if

    call fft_CD_direct_core(afft_CD)

    afft(ista_sfftp:iend_sfftp) = afft_CD(ista_sfftp:iend_sfftp)
#endif
    call tstatc0_end(id_sname)
  end subroutine m_FFT_CD_direct

  subroutine m_FFT_reset_CD_setup_stat()
    CD_setup_is_done = NO
    fft_box_size_CD_prev = fft_box_size_CD
    fft_box_size_CD_nonpara_prev = fft_box_size_CD_nonpara
  end subroutine m_FFT_reset_CD_setup_stat

  subroutine m_FFT_CD0(nfout,afftp,inverse_or_direct)  ! R space --> G space
    integer, intent(in)          :: nfout, inverse_or_direct
    real(kind=DP), intent(inout) :: afftp(nfftp_nonpara)
    integer :: id_sname = -1
    integer, dimension(2) :: flag_mklfft = (/-1, 1/)

    if(ipri >= 2) write(nfout,'(" <<m_FFT_CD0>>")')
    call tstatc0_begin('m_FFT_CD0 ', id_sname, 1)
    if(CD_setup_is_done == NO) then
       if(ipri >= 1) write(nfout,'(" <<CDFFT_setup>>")')
       call CDFFT_setup()
    end if

    if(inverse_or_direct == DIRECT) then
       call fft_CD_direct_core(afftp)
    else if(inverse_or_direct == INVERSE) then
       call fft_CD_inverse_core(afftp)
    end if

    call tstatc0_end(id_sname)
  end subroutine m_FFT_CD0

  subroutine m_FFT_CD0_exx(nfout,afftp,inverse_or_direct)  ! R space --> G space
    integer, intent(in)          :: nfout, inverse_or_direct
    real(kind=DP), intent(inout) :: afftp(nfftp_exx_nonpara)
    integer :: id_sname = -1
    integer, dimension(2) :: flag_mklfft = (/-1, 1/)
#if defined(JRCATFFT_WS) || defined(FFTW3)
    if(ipri >= 2) write(nfout,'(" <<m_FFT_CD0_exx>>")')
    call tstatc0_begin('m_FFT_CD0_exx ', id_sname)
    if(CD_setup_is_done_exx == NO) then
#ifdef _INCLUDE_EXX_
       if(ipri >= 1) write(nfout,'(" <<CDFFT_setup_exx>>")')
       call CDFFT_setup_exx()
#endif
    end if
    if(inverse_or_direct == DIRECT) then
       call fft_CD_direct_core_exx(afftp)
    else if(inverse_or_direct == INVERSE) then
       call fft_CD_inverse_core_exx(afftp)
    end if

    call tstatc0_end(id_sname)
#else
    call phase_error_with_msg(nfout,'EXX in rspace can only be used with JRCAT FFT or FFTW3',__LINE__,__FILE__)
#endif
  end subroutine m_FFT_CD0_exx

  subroutine m_FFT_CD_direct_c(nfout,afft,mode)   ! R space --> G space
#ifdef NEC_TUNE_FFT
      use m_Parallelization,   only : itask
#endif
    integer, intent(in)       :: nfout
    real(kind=DP), intent(inout) :: afft(ista_fftp:iend_fftp)
    integer, intent(in), optional :: mode
#ifdef _MPIFFT_

    INTEGER :: NX,NY,NZ
    INTEGER :: NT,ISW,IERR0(2)

    integer, parameter :: INDEXA = 2, INDEXB = 3
    real(kind=DP),allocatable :: B(:)
    real(kind=DP) :: TIME(5)
#endif

    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_CD_direct_c ',id_sname)
    if(present(mode)) then
      if(mode == 0) goto 9999
    endif

#ifdef _MPIFFT_
    call get_nxnynz(nx,ny,nz)

    allocate(B(ista_fftp:iend_fftp))
    if(kimg == 1) then
       isw = -1
    else if(kimg == 2) then
       ISW = 1
    end if

#ifdef NEC_TUNE_FFT
    NT = itask
#else
    NT = 1
#endif

    if(kimg==1) then
       call fft_r3d(nx,ny,nz,ny_d,nz_d,afft &
            &      ,lx,ly,lz,ly_d,lz_d,indexb,isw,time,b &
            &      ,nt,mpi_cdfft_world(myrank_ggacmp),ierr0)
    else
       call fft_c3d(nx,ny,nz,ny_d,nz_d,afft &
            &      ,lx,ly,lz,ly_d,lz_d,indexb,isw,time,b &
            &      ,nt,mpi_cdfft_world(myrank_ggacmp),ierr0)
    end if
    IF( IERR0(1) .GE. 3000 ) THEN
       write(6,*) ' nx,ny,nz,ny_d,nz_d = ',nx,ny,nz,ny_d,nz_d
       write(6,*) ' lx,ly,lz,ly_d,lz_d = ',lx,ly,lz,ly_d,lz_d
    ENDIF
    call check_ierr(ierr0)

    CALL MPI_BARRIER(mpi_cdfft_world(myrank_ggacmp),IERR)
    if(ipri >= 2) call wd_time(time)

    deallocate(B)

#else
    call m_FFT_afft_allgatherv_c(afft,afft_CD)

    call fft_CD_direct_core(afft_CD)

    afft(ista_fftp:iend_fftp) = afft_CD(ista_fftp:iend_fftp)
#endif
9999 call tstatc0_end(id_sname)
  end subroutine m_FFT_CD_direct_c

  subroutine m_FFT_CD_inverse(nfout,afft)  ! G space --> R space
#ifdef NEC_TUNE_FFT
      use m_Parallelization,   only : itask
#endif
    integer, intent(in)          :: nfout
    real(kind=DP), intent(inout) :: afft(ista_sfftp:iend_sfftp)
#ifdef _MPIFFT_
    INTEGER :: NX,NY,NZ
    INTEGER :: NT,ISW,IERR0(2)
    integer, parameter :: INDEXA = 2, INDEXB = 3
    real(kind=DP),allocatable :: B(:)
    real(kind=DP) :: TIME(5)

    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_CD_inverse ', id_sname)

    call get_nxnynz(nx,ny,nz)

    allocate(B(ista_sfftp:iend_sfftp))
    CALL MPI_BARRIER(MPI_CommGroup,IERR)
    ISW = -1

#ifdef NEC_TUNE_FFT
    NT = itask
#else
    NT = 1
#endif

    if(kimg==1) then
       call fft_r3d(nx,ny,nz,ny_ds,nz_ds,afft &
            &      ,lxs,lys,lzs,ly_ds,lz_ds,indexa,isw,time,b &
            &      ,nt, MPI_CommGroup,ierr0)
    else
       call fft_c3d(nx,ny,nz,ny_ds,nz_ds,afft &
            &      ,lxs,lys,lzs,ly_ds,lz_ds,indexa,isw,time,b &
            &      ,nt,MPI_CommGroup,ierr0)
    end if
    call check_ierr(ierr0)
    CALL MPI_BARRIER(MPI_CommGroup,IERR)
    if(ipri >= 2) call wd_time(time)
    deallocate(B)
#else
    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_CD_inverse ', id_sname)

    if(npes >= 2) then
       call m_FFT_afft_allgatherv(afft,afft_CD)
    else
       afft_CD = afft
    end if

    call fft_CD_inverse_core(afft_CD)

    afft(ista_sfftp:iend_sfftp) = afft_CD(ista_sfftp:iend_sfftp)
#endif
    call tstatc0_end(id_sname)
  end subroutine m_FFT_CD_inverse

  subroutine m_FFT_CD_inverse_c(nfout,afft,mode)  ! G space --> R space
#ifdef NEC_TUNE_FFT
      use m_Parallelization,   only : itask
#endif
    integer, intent(in)          :: nfout
    real(kind=DP), intent(inout) :: afft(ista_fftp:iend_fftp)
    integer, intent(in), optional :: mode

#ifdef _MPIFFT_
    INTEGER :: NX,NY,NZ,lx,ly,lz
    INTEGER :: NT,ISW,IERR0(2)
    integer, parameter :: INDEXA = 2, INDEXB = 3
    real(kind=DP),allocatable :: B(:)
    integer :: i, ip, j, k
    real(kind=DP) :: TIME(5)
#endif

    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_CD_inverse_c ', id_sname)
    if(present(mode)) then
      if(mode == 0) goto 9999
    endif

#ifdef _MPIFFT_
    call get_nxnynz(nx,ny,nz)

    lx = fft_box_size_CD_c(1,0)
    ly = fft_box_size_CD_c(2,0)
    lz = fft_box_size_CD_c(3,0)

    allocate(B(ista_fftp:iend_fftp))

    if(kimg == 1) then
       isw = 1
    else if(kimg == 2) then
       ISW = -1
    end if

#ifdef NEC_TUNE_FFT
    NT = itask
#else
    NT = 1
#endif

    if(kimg==1) then
       if(ipri >= 2) then
          write(nfout,'(" before fft_r3d <<m_FFT_CD_inverse_c>>")')
          write(nfout,'(" nx,ny,nz,ny_d,nz_d = ",5i5)') nx,ny,nz,ny_d,nz_d
          write(nfout,'(" lx,ly,lz,ly_d,lz_d = ",5i5)') lx,ly,lz,ly_d,lz_d
       end if
       call fft_r3d(nx,ny,nz,ny_d,nz_d,afft &
            &      ,lx,ly,lz,ly_d,lz_d,indexa,isw,time,b &
            &      ,nt,mpi_cdfft_world(myrank_ggacmp),ierr0)
    else if(kimg == 2) then
       if(ipri >= 2) then
          write(nfout,'(" before fft_c3d <<m_FFT_CD_inverse_c>>")')
          do k = 1, nz
             if(k >= 4 .and. k<= nz-3) cycle
             do j = 1, ny_d
                write(nfout,'(" j, k = ", 2i8)') j+ny_d*myrank_cdfft, k
                ip = 2*((j-1)*lx + (k-1)*lx*ly_d) + ista_fftp - 1
                write(nfout,'(8d12.4)') (afft( ip+i),i=1,fft_box_size_CD(1,1)*2)
             end do
          end do
       end if
       call mpi_barrier(mpi_cdfft_world(myrank_ggacmp),ierr)
       call fft_c3d(nx,ny,nz,ny_d,nz_d,afft &
            &      ,lx,ly,lz,ly_d,lz_d,indexa,isw,time,B &
            &      ,nt,mpi_cdfft_world(myrank_ggacmp),ierr0)
       if(ipri >= 2) then
          write(nfout,'(" after fft_c3d <<m_FFT_CD_inverse_c>>")')
          do k = 1, min(nz_d,8)
             do j = 1, ny
                write(nfout,'(" j, k = ", 2i8)') j, k+nz_d*myrank_cdfft
                ip = 2*((j-1)*lx + (k-1)*lx*ly) + ista_fftp - 1
                write(nfout,'(8d12.4)') (afft( ip+i),i=1,16)
             end do
          end do
       end if
    end if
    call check_ierr(ierr0)
    CALL MPI_BARRIER(MPI_cdfft_world(myrank_ggacmp),IERR)
    if(ipri >= 2) call wd_time(time)

    deallocate(B)
#else
    call m_FFT_afft_allgatherv_c(afft,afft_CD)

    call fft_CD_inverse_core(afft_CD)

    afft(ista_fftp:iend_fftp) = afft_CD(ista_fftp:iend_fftp)
#endif
9999 call tstatc0_end(id_sname)
  end subroutine m_FFT_CD_inverse_c

  subroutine m_FFT_CD_inverse0(nfout,afftp)  ! G space --> R space
    integer, intent(in)          :: nfout
    real(kind=DP), intent(inout) :: afftp(nfftp_nonpara)
    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_CD_inverse0 ', id_sname)
    if(CD_setup_is_done == NO) call CDFFT_setup()

    call fft_CD_inverse_core(afftp)

    call tstatc0_end(id_sname)
  end subroutine m_FFT_CD_inverse0

  subroutine m_FFT_CD_direct0(nfout,afftp)  ! G space --> R space
    integer, intent(in)          :: nfout
    real(kind=DP), intent(inout) :: afftp(nfftp_nonpara)
    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_CD_direct0 ', id_sname)
    if(CD_setup_is_done == NO) call CDFFT_setup()

    call fft_CD_direct_core(afftp)

    call tstatc0_end(id_sname)
  end subroutine m_FFT_CD_direct0

!!$#ifdef _MPIFFT_
  subroutine set_mpifft_box_size_CD(inversion_symmetry)
    integer, intent(in) :: inversion_symmetry
    integer :: nx, ny, nz, ic, isize
    nx = fft_box_size_CD(1,1); ny = fft_box_size_CD(2,1); nz = fft_box_size_CD(3,1)
    do ic = 1, 2
       if(ic == 1) isize = npes
       if(ic == 2) isize = npes_cdfft
       ny_d =  ny/isize
       nz_d =  nz/isize
       if(mod( ny,isize) .ne. 0) ny_d = ny_d + 1
       if(mod( nz,isize) .ne. 0) nz_d = nz_d + 1
       ly_d = ny_d;   lz_d = nz_d
       if(inversion_symmetry == ON) then  ! kimg == 1
!!$          if(mod(nx,4) == 2) then
!!$             lx = nx + 4
!!$          else
          lx = nx + 2
!!$          end if
       else if(inversion_symmetry == OFF) then ! kimg == 2
          lx = nx
          if(mod(lx,2) == 0)   lx = nx + ldx
       end if

       if(mod(ly_d,2) == 0) ly_d = ny_d + ldy
       if(mod(lz_d,2) == 0) lz_d = nz_d + ldz

       ly   = ly_d*isize
       lz   = lz_d*isize
       if(ic == 1) then
          fft_box_size_CD(1,0) = lx
          fft_box_size_CD(2,0) = ly
          fft_box_size_CD(3,0) = lz
          ny_ds = ny_d;          nz_ds = nz_d;          ly_ds = ly_d
          lys   = ly;            lz_ds = lz_d;          lzs   = lz
          lxs   = lx
       else
          fft_box_size_CD_c(1,0) = lx
          fft_box_size_CD_c(2,0) = ly
          fft_box_size_CD_c(3,0) = lz
       end if
    end do
    if(ipri >= 1) then
       write(nfout,'(" nx,  ny,  nz,  ny_d, nz_d  = ",5i8)') nx,ny,nz,ny_d,nz_d
       write(nfout,'("      ly,  lz,  ly_d, lz_d  = ",8x,4i8)') ly,lz,ly_d,lz_d
!!$       write(nfout,'(" ny,nz,ny_d, nz_d, ly, lz, ly_d, lz_d  = ",/8x,8i8)')  &
!!$            &          ny,nz,ny_d, nz_d, ly, lz, ly_d, lz_d
       write(nfout,'("                ny_ds,nz_ds = ",24x,2i8)') ny_ds, nz_ds
       write(nfout,'("      lys, lzs, ly_ds,lz_ds = ",8x,4i8)') lys,lzs,ly_ds,lz_ds
!!$       write(nfout,'("       ny_ds,nz_ds,lys,lzs,ly_ds,lz_ds = ",/24x,6i8)')&
!!$            &                ny_ds,nz_ds,lys,lzs,ly_ds,lz_ds
    end if
  end subroutine set_mpifft_box_size_CD
!!$#endif


  subroutine m_FFT_cp_afft_CD(afft)
    real(kind=DP),intent(out),dimension(:):: afft(nfftp)
    !!$afft(1:nfftp)=afft_CD(1:nfftp)
    if(allocated(afft_CD)) afft=afft_CD
  end subroutine m_FFT_cp_afft_CD


end module m_FFT

subroutine UnitaryTransform_WF(imode,ik,zaj_l,update_fsr,wf_mode)
  use m_Const_Parameters, only : DP,ORTHONORMALIZATION
  use m_PlaneWaveBasisSet, only : kg1
  use m_Parallelization, only : np_e,ista_k,iend_k
  use m_Control_Parameters, only : kimg
  use m_ES_WF_by_submat, only : m_ESsubmat_utransform_wf
  use m_Files, only : nfout
  use m_ES_ortho, only : m_ES_MGS_4_each_k
  implicit none
  integer, intent(in) :: imode,ik
  real(kind=DP), dimension(kg1,np_e,ista_k:iend_k,kimg),intent(inout) :: zaj_l
  logical, intent(in) :: update_fsr,wf_mode
  call m_ESsubmat_utransform_wf(imode,ik,zaj_l,update_fsr,wf_mode)
  call m_ES_MGS_4_each_k(nfout,ik,ORTHONORMALIZATION)
end subroutine UnitaryTransform_WF

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 606 $)
!
!  MODULE: m_Representation
!
!  AUTHOR(S): T. Yamamoto   May/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Representation
  use m_Const_Parameters,  only : DP, CMPLDP, zi
  implicit none

  integer, parameter :: nrep0 = 12
  integer, parameter :: nsym0 = 48

  integer, parameter :: nrep0_dblegrp = 16
  
contains

  subroutine get_irr_rep(point_group,nsym,nrep,rep,symbol_irrep,active)
    character(len=3), intent(in) :: point_group
    integer, intent(out) :: nsym
    integer, intent(out) :: nrep
    integer, intent(out) :: rep(nsym0,nrep0)
    character(len=3), intent(out) :: symbol_irrep(nrep0) 
    character(len=4), intent(out) :: active(nrep0) 

    rep(1:nsym0,1:nrep0) = 0
    symbol_irrep(1:nrep0) = 'NON'
    active(1:nrep0) = 'NON '

    select case(point_group)  
    case('Oh ') !  1 
       call set_chartab_oh(rep)
       call set_symbol_oh(nrep,symbol_irrep,active)
       nsym = 48
    case('O  ') !  2
       call set_chartab_o(rep)
       call set_symbol_o(nrep,symbol_irrep,active)
       nsym = 24
    case('Td ') !  3
       call set_chartab_td(rep)
       call set_symbol_td(nrep,symbol_irrep,active)
       nsym = 24
    case('Th ') !  4
       call set_chartab_th(rep)
       call set_symbol_th(nrep,symbol_irrep,active)
       nsym = 24
    case('T  ') !  5
       call set_chartab_t(rep)
       call set_symbol_t(nrep,symbol_irrep,active)
       nsym = 12
    case('D4h') !  6
       call set_chartab_d4h(rep)
       call set_symbol_d4h(nrep,symbol_irrep,active)
       nsym = 16
    case('D4 ') !  7
       call set_chartab_d4(rep)
       call set_symbol_d4(nrep,symbol_irrep,active)
       nsym = 8
    case('D2d') !  8 
       call set_chartab_d2d(rep)
       call set_symbol_d2d(nrep,symbol_irrep,active)
       nsym = 8
    case('C4v') !  9
       call set_chartab_c4v(rep)
       call set_symbol_c4v(nrep,symbol_irrep,active)
       nsym = 8
    case('C4h') ! 10
       call set_chartab_c4h(rep)
       call set_symbol_c4h(nrep,symbol_irrep,active)
       nsym = 8
    case('S4 ') ! 11
       call set_chartab_s4(rep)
       call set_symbol_s4(nrep,symbol_irrep,active)
       nsym = 4
    case('C4 ') ! 12
       call set_chartab_c4(rep)
       call set_symbol_c4(nrep,symbol_irrep,active)
       nsym = 4
    case('D2h') ! 13
       call set_chartab_d2h(rep)
       call set_symbol_d2h(nrep,symbol_irrep,active)
       nsym = 8
    case('D2 ') ! 14
       call set_chartab_d2(rep)
       call set_symbol_d2(nrep,symbol_irrep,active)
       nsym = 4
    case('C2v') ! 15
       call set_chartab_c2v(rep)
       call set_symbol_c2v(nrep,symbol_irrep,active)
       nsym = 4
    case('D6h') ! 16
       call set_chartab_d6h(rep)
       call set_symbol_d6h(nrep,symbol_irrep,active)
       nsym = 24
    case('D6 ') ! 17
       call set_chartab_d6(rep)
       call set_symbol_d6(nrep,symbol_irrep,active)
       nsym = 12
    case('D3h') ! 18
       call set_chartab_d3h(rep)
       call set_symbol_d3h(nrep,symbol_irrep,active)
       nsym = 12
    case('C6v') ! 19
       call set_chartab_c6v(rep)
       call set_symbol_c6v(nrep,symbol_irrep,active)
       nsym = 12
    case('C6h') ! 20
       call set_chartab_c6h(rep)
       call set_symbol_c6h(nrep,symbol_irrep,active)
       nsym = 12
    case('C3h') ! 21
       call set_chartab_c3h(rep)
       call set_symbol_c3h(nrep,symbol_irrep,active)
       nsym = 6
    case('C6 ') ! 22
       call set_chartab_c6(rep)
       call set_symbol_c6(nrep,symbol_irrep,active)
       nsym = 6
    case('D3d') ! 23
       call set_chartab_d3d(rep)
       call set_symbol_d3d(nrep,symbol_irrep,active)
       nsym = 12
    case('D3 ') ! 24
       call set_chartab_d3(rep)
       call set_symbol_d3(nrep,symbol_irrep,active)
       nsym = 6
    case('C3v') ! 25
       call set_chartab_c3v(rep)
       call set_symbol_c3v(nrep,symbol_irrep,active)
       nsym = 6
    case('S6 ') ! 26
       call set_chartab_s6(rep)
       call set_symbol_s6(nrep,symbol_irrep,active)
       nsym = 6
    case('C3 ') ! 27
       call set_chartab_c3(rep)
       call set_symbol_c3(nrep,symbol_irrep,active)
       nsym = 3
    case('C2h') ! 28
       call set_chartab_c2h(rep)
       call set_symbol_c2h(nrep,symbol_irrep,active)
       nsym = 4
    case('Cs ') ! 29
       call set_chartab_cs(rep)
       call set_symbol_cs(nrep,symbol_irrep,active)
       nsym = 2
    case('C2 ') ! 30
       call set_chartab_c2(rep)
       call set_symbol_c2(nrep,symbol_irrep,active)
       nsym = 2
    case('Ci ') ! 30
       call set_chartab_ci(rep)
       call set_symbol_ci(nrep,symbol_irrep,active)
       nsym = 2
    case('C1 ') ! 32
       call set_chartab_c1(rep)
       call set_symbol_c1(nrep,symbol_irrep,active)
       nsym = 1
    end select

  contains

    subroutine set_chartab_oh(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer :: i
      integer, parameter :: nsym = 48
      integer, parameter :: nsym2 = nsym/2
      integer, parameter :: nrep = 10
      integer, parameter :: nrep2 = nrep/2

      call set_chartab_o(rep)
      do i=1,nsym2
         rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
      end do
      do i=1,nsym2
         rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
      end do
      do i=nsym2+1,nsym
         rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
      end do

    end subroutine set_chartab_oh

    subroutine set_symbol_oh(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(10)
      character(len=4), intent(out) :: active(10)

      nrep = 10
      symbol_irrep(1) = 'A1g'; active(1) = 'R   '
      symbol_irrep(2) = 'A2g' 
      symbol_irrep(3) = 'Eg '; active(3) = 'R   '
      symbol_irrep(4) = 'T1g'
      symbol_irrep(5) = 'T2g'; active(5) = 'R   '
      symbol_irrep(6) = 'A1u'
      symbol_irrep(7) = 'A2u'
      symbol_irrep(8) = 'Eu '
      symbol_irrep(9) = 'T1u'; active(9) = 'IR  '
      symbol_irrep(10) = 'T2u'
    end subroutine set_symbol_oh

    subroutine set_chartab_o(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 24

      rep(1:nsym,1)=1 ! A1

      rep(1:12,2)=1; rep(13:nsym,2)=-1 ! A2

      rep(1:4,3)=2; rep(5:12,3)=-1; rep(13:nsym,3)=0 ! E

      rep(1,4)=3; rep(2:4,4)=-1; rep(5:12,4)=0 ! T1
      rep(13:18,4)=-1; rep(19:nsym,4)=1          ! T1 (cont.)

      rep(1,5)=3; rep(2:4,5)=-1; rep(5:12,5)=0; rep(13:18,5)=1; rep(19:nsym,5)=-1 ! T2

    end subroutine set_chartab_o

    subroutine set_symbol_o(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(5)
      character(len=4), intent(out) :: active(5)
      nrep = 5
      symbol_irrep(1) = 'A1 '; active(1)='R   '
      symbol_irrep(2) = 'A2 '
      symbol_irrep(3) = 'E  '; active(3)='R   '
      symbol_irrep(4) = 'T1 '; active(4)='IR  '
      symbol_irrep(5) = 'T2 '; active(5)='R   '
    end subroutine set_symbol_o

    subroutine set_chartab_td(rep)
      integer, intent(out) :: rep(nsym0,nrep0)
      call set_chartab_o(rep)
    end subroutine set_chartab_td

    subroutine set_symbol_td(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(5)
      character(len=4), intent(out) :: active(5)
      call set_symbol_o(nrep,symbol_irrep,active)
      symbol_irrep(5) = 'T2 '; active(5)='IR&R'
    end subroutine set_symbol_td

    subroutine set_chartab_th(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer :: i
      integer, parameter :: nsym = 24
      integer, parameter :: nsym2 = nsym/2
      integer, parameter :: nrep = 6
      integer, parameter :: nrep2 = nrep/2

      call set_chartab_t(rep)
      do i=1,nsym2
         rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
      end do
      do i=1,nsym2
         rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
      end do
      do i=nsym2+1,nsym
         rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
      end do

    end subroutine set_chartab_th

    subroutine set_symbol_th(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(6)
      character(len=4), intent(out) :: active(6)

      nrep = 6
      symbol_irrep(1) = 'Ag '; active(1)='R   '
      symbol_irrep(2) = 'Eg '; active(2)='R   '
      symbol_irrep(3) = 'Tg '; active(3)='R   '
      symbol_irrep(4) = 'Au '
      symbol_irrep(5) = 'Eu '
      symbol_irrep(6) = 'Tu '; active(6)='IR  '

    end subroutine set_symbol_th

    subroutine set_chartab_t(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 12

      rep(1:nsym,1)=1 ! A

      rep(1:4,2)=2; rep(5:nsym,2)=-1 ! E

      rep(1,3)=3; rep(2:4,3)=-1; rep(5:nsym,3)=0 ! T

    end subroutine set_chartab_t

    subroutine set_symbol_t(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(3)
      character(len=4), intent(out) :: active(3)

      nrep = 3
      symbol_irrep(1) = 'A  '; active(1) = 'R   '
      symbol_irrep(2) = 'E  '; active(2) = 'R   '
      symbol_irrep(3) = 'T  '; active(3) = 'IR&R'

    end subroutine set_symbol_t

    subroutine set_chartab_d4h(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer :: i
      integer, parameter :: nsym = 16
      integer, parameter :: nsym2 = nsym/2
      integer, parameter :: nrep = 10
      integer, parameter :: nrep2 = nrep/2

      call set_chartab_d4(rep)
      do i=1,nsym2
         rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
      end do
      do i=1,nsym2
         rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
      end do
      do i=nsym2+1,nsym
         rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
      end do

    end subroutine set_chartab_d4h

    subroutine set_symbol_d4h(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(10)
      character(len=4), intent(out) :: active(10)

      nrep = 10
      symbol_irrep(1) = 'A1g'; active(1) = 'R   '
      symbol_irrep(2) = 'A2g'
      symbol_irrep(3) = 'B1g'; active(3) = 'R   '
      symbol_irrep(4) = 'B2g'; active(4) = 'R   '
      symbol_irrep(5) = 'Eg '; active(5) = 'R   '
      symbol_irrep(6) = 'A1u'
      symbol_irrep(7) = 'A2u'; active(7) = 'IR  '
      symbol_irrep(8) = 'B1u'
      symbol_irrep(9) = 'B2u'
      symbol_irrep(10) = 'Eu '; active(10) = 'IR'
    end subroutine set_symbol_d4h

    subroutine set_chartab_d4(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 8

      rep(1:nsym,1)=1 ! A1

      rep(1,2)=1; rep(2:3,2)=-1; rep(4,2)=1; rep(5:6,2)=-1; rep(7:nsym,2)=1 ! A2

      rep(1:4,3)=1; rep(5:nsym,3)=-1 ! B1

      rep(1,4)=1; rep(2:3,4)=-1; rep(4:6,4)=1; rep(7:nsym,4)=-1 ! B2

      rep(1,5)=2; rep(2:3,5)=0; rep(4,5)=-2; rep(6:nsym,5)=0 ! E

    end subroutine set_chartab_d4

    subroutine set_symbol_d4(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(5)
      character(len=4), intent(out) :: active(5)

      nrep = 5
      symbol_irrep(1) = 'A1 '; active(1) = 'R   '
      symbol_irrep(2) = 'A2 '; active(2) = 'IR  '
      symbol_irrep(3) = 'B1 '; active(3) = 'R   '
      symbol_irrep(4) = 'B2 '; active(4) = 'R   '
      symbol_irrep(5) = 'E  '; active(5) = 'IR&R'

    end subroutine set_symbol_d4

    subroutine set_chartab_d2d(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 8

      rep(1:nsym,1)=1 ! A1

      rep(1:2,2)=1; rep(3:6,2)=-1; rep(7:nsym,2)=1 ! A2

      rep(1:4,3)=1; rep(5:nsym,3)=-1 ! B1

      rep(1:2,4)=1; rep(3:4,4)=-1; rep(5:6,4)=1; rep(7:nsym,4)=-1 ! B2

      rep(1,5)=2; rep(2,5)=-2; rep(3:nsym,5)=0 ! E

    end subroutine set_chartab_d2d

    subroutine set_symbol_d2d(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(5)
      character(len=4), intent(out) :: active(5)

      nrep = 5
      symbol_irrep(1) = 'A1 '; active(1) = 'R   '
      symbol_irrep(2) = 'A2 '
      symbol_irrep(3) = 'B1 '; active(3) = 'R   '
      symbol_irrep(4) = 'B2 '; active(4) = 'IR&R'
      symbol_irrep(5) = 'E  '; active(5) = 'IR&R'

    end subroutine set_symbol_d2d

    subroutine set_chartab_c4v(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 8

      rep(1:nsym,1)=1 ! A1

      rep(1:4,2)=1; rep(5:nsym,2)=-1 ! A2

      rep(1:2,3)=1; rep(3:4,3)=-1; rep(5:6,3)=1; rep(7:nsym,3)=-1 ! B1

      rep(1:2,4)=1; rep(3:4,4)=-1; rep(5:6,4)=-1; rep(7:nsym,4)=1 ! B2

      rep(1,5)=2; rep(2,5)=-2; rep(3:nsym,5)=0 ! E

    end subroutine set_chartab_c4v

    subroutine set_symbol_c4v(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(5)
      character(len=4), intent(out) :: active(5)

      nrep = 5
      symbol_irrep(1) = 'A1 '; active(1) = 'IR&R'
      symbol_irrep(2) = 'A2 '
      symbol_irrep(3) = 'B1 '; active(3) = 'R   '
      symbol_irrep(4) = 'B2 '; active(4) = 'R   '
      symbol_irrep(5) = 'E  '; active(5) = 'IR&R'

    end subroutine set_symbol_c4v

    subroutine set_chartab_c4h(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      integer :: i
      integer, parameter :: nsym = 8
      integer, parameter :: nsym2 = nsym/2
      integer, parameter :: nrep = 6
      integer, parameter :: nrep2 = nrep/2

      call set_chartab_c4(rep)
      do i=1,nsym2
         rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
      end do
      do i=1,nsym2
         rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
      end do
      do i=nsym2+1,nsym
         rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
      end do

    end subroutine set_chartab_c4h

    subroutine set_symbol_c4h(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(6)
      character(len=4), intent(out) :: active(6)

      nrep = 6
      symbol_irrep(1) = 'Ag '; active(1) = 'R   '
      symbol_irrep(2) = 'Bg '; active(2) = 'R   '
      symbol_irrep(3) = 'Eg '; active(3) = 'R   '
      symbol_irrep(4) = 'Au '; active(4) = 'IR  '
      symbol_irrep(5) = 'Bu '
      symbol_irrep(6) = 'Eu '; active(6) = 'IR  '

    end subroutine set_symbol_c4h

    subroutine set_chartab_s4(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 4

      rep(1:nsym,1)=1 ! A

      rep(1:2,2)=1; rep(3:nsym,2)=-1 ! B

      rep(1,3)=2; rep(2,3)=-2; rep(3:nsym,3)=0 ! E

    end subroutine set_chartab_s4

    subroutine set_symbol_s4(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(3)
      character(len=4), intent(out) :: active(3)

      nrep = 3
      symbol_irrep(1) = 'A  '; active(1) = 'R   '
      symbol_irrep(2) = 'B  '; active(2) = 'IR&R'
      symbol_irrep(3) = 'E  '; active(3) = 'IR&R'

    end subroutine set_symbol_s4

    subroutine set_chartab_c4(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 4

      rep(1:nsym,1)=1 ! A

      rep(1:2,2)=1; rep(3:nsym,2)=-1 ! B

      rep(1,3)=2; rep(2,3)=-2; rep(3:nsym,3)=0 ! E

    end subroutine set_chartab_c4

    subroutine set_symbol_c4(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(3)
      character(len=4), intent(out) :: active(3)

      nrep = 3
      call set_symbol_s4(nrep,symbol_irrep,active)
      active(1) = 'IR&R'
      active(2) = 'R   '

    end subroutine set_symbol_c4

    subroutine set_chartab_d2h(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      integer :: i
      integer, parameter :: nsym = 8
      integer, parameter :: nsym2 = nsym/2
      integer, parameter :: nrep = 8
      integer, parameter :: nrep2 = nrep/2

      call set_chartab_d2(rep)
      do i=1,nsym2
         rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
      end do
      do i=1,nsym2
         rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
      end do
      do i=nsym2+1,nsym
         rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
      end do

    end subroutine set_chartab_d2h

    subroutine set_symbol_d2h(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(8)
      character(len=4), intent(out) :: active(8)

      nrep = 8
      symbol_irrep(1) = 'Ag '; active(1) = 'R  '
      symbol_irrep(2) = 'B1g'; active(2) = 'R  '
      symbol_irrep(3) = 'B2g'; active(3) = 'R  '
      symbol_irrep(4) = 'B3g'; active(4) = 'R  '
      symbol_irrep(5) = 'Au '
      symbol_irrep(6) = 'B1u'; active(6) = 'IR '
      symbol_irrep(7) = 'B2u'; active(7) = 'IR '
      symbol_irrep(8) = 'B3u'; active(8) = 'IR '

    end subroutine set_symbol_d2h

    subroutine set_chartab_d2(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 4

      rep(1:nsym,1)=1 ! A

      rep(1,2)=1; rep(2:3,2)=-1; rep(nsym,2)=1 ! B1

      rep(1,3)=1; rep(2,3)=-1; rep(3,3)=1; rep(4,3)=-1 ! B2

      rep(1:2,4)=1; rep(3:nsym,4)=-1 ! B3

    end subroutine set_chartab_d2

    subroutine set_symbol_d2(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(4)
      character(len=4), intent(out) :: active(4)

      nrep = 4
      symbol_irrep(1) = 'A  '; active(1) = 'R   '
      symbol_irrep(2) = 'B1 '; active(2) = 'IR&R'
      symbol_irrep(3) = 'B2 '; active(3) = 'IR&R'
      symbol_irrep(4) = 'B3 '; active(4) = 'IR&R'

    end subroutine set_symbol_d2

    subroutine set_chartab_c2v(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 4

      rep(1:nsym,1)=1 ! A1

      rep(1:2,2)=1; rep(3:nsym,2)=-1 ! A2

      rep(1,3)=1; rep(2:3,3)=-1; rep(nsym,3)=1 ! B1

      rep(1,4)=1; rep(2,4)=-1; rep(3,4)=1; rep(nsym,4)=-1 ! B2

    end subroutine set_chartab_c2v

    subroutine set_symbol_c2v(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(4)
      character(len=4), intent(out) :: active(4)

      nrep = 4
      symbol_irrep(1) = 'A1 '; active(1) = 'IR&R'
      symbol_irrep(2) = 'A2 '; active(2) = 'R   '
      symbol_irrep(3) = 'B1 '; active(3) = 'IR&R'
      symbol_irrep(4) = 'B2 '; active(4) = 'IR&R'

    end subroutine set_symbol_c2v

    subroutine set_chartab_d6h(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      integer :: i
      integer, parameter :: nsym = 24
      integer, parameter :: nsym2 = nsym/2
      integer, parameter :: nrep = 12
      integer, parameter :: nrep2 = nrep/2

      call set_chartab_d6(rep)
      do i=1,nsym2
         rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
      end do
      do i=1,nsym2
         rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
      end do
      do i=nsym2+1,nsym
         rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
      end do

    end subroutine set_chartab_d6h

    subroutine set_symbol_d6h(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(12)
      character(len=4), intent(out) :: active(12)

      nrep = 12
      symbol_irrep(1) = 'A1g'; active(1) = 'R   '
      symbol_irrep(2) = 'A2g'
      symbol_irrep(3) = 'B1g'
      symbol_irrep(4) = 'B2g'
      symbol_irrep(5) = 'E1g'; active(5) = 'R   '
      symbol_irrep(6) = 'E2g'; active(6) = 'R   '
      symbol_irrep(7) = 'A1u'
      symbol_irrep(8) = 'A2u'; active(8) = 'IR  '
      symbol_irrep(9) = 'B1u'
      symbol_irrep(10) = 'B2u'
      symbol_irrep(11) = 'E1u'; active(11) = 'IR  '
      symbol_irrep(12) = 'E2u'

    end subroutine set_symbol_d6h

    subroutine set_chartab_d6(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 12

      rep(1:nsym,1)=1 ! A1

      rep(1:6,2)=1; rep(7:nsym,2)=-1 ! A2

      rep(1,3)=1; rep(2,3)=-1; rep(3,3)=1; rep(4,3)=-1 ! B1
      rep(5,3)=1; rep(6,3)=-1; rep(7:9,3)=-1; rep(10:nsym,3)=1 ! B1 (cont.)

      rep(1,4)=1; rep(2,4)=-1; rep(3,4)=1; rep(4,4)=-1 ! B2
      rep(5,4)=1; rep(6,4)=-1; rep(7:9,4)=1; rep(10:nsym,4)=-1 ! B2 (cont.)

      rep(1,5)=2; rep(2,5)=1; rep(3,5)=-1; rep(4,5)=-2 ! E1
      rep(5,5)=-1; rep(6,5)=1; rep(7:nsym,5)=0 ! E1 (cont.)

      rep(1,6)=2; rep(2:3,6)=-1; rep(4,6)=2 ! E2
      rep(5:6,6)=-1; rep(7:nsym,6)=0 ! E2 (cont.)

    end subroutine set_chartab_d6

    subroutine set_symbol_d6(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(6)
      character(len=4), intent(out) :: active(6)

      nrep = 6
      symbol_irrep(1) = 'A1 '; active(1) = 'R   '
      symbol_irrep(2) = 'A2 '; active(2) = 'IR  '
      symbol_irrep(3) = 'B1 '
      symbol_irrep(4) = 'B2 '
      symbol_irrep(5) = 'E1 '; active(3) = 'IR&R'
      symbol_irrep(6) = 'E2 '; active(4) = 'R   '

    end subroutine set_symbol_d6

    subroutine set_chartab_d3h(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 12

      rep(1:nsym,1)=1 ! A1

      rep(1:3,2)=1; rep(4:6,2)=-1; rep(7:9,2)=1; rep(10:nsym,2)=-1 ! A2

      rep(1:6,3)=1; rep(7:nsym,3)=-1 ! B1

      rep(1:3,4)=1; rep(4:9,4)=-1; rep(10:nsym,4)=1 ! B2

      rep(1,5)=2; rep(2:3,5)=-1; rep(4:6,5)=0; rep(7,5)=1 ! E1
      rep(8,5)=-2; rep(9,5)=1; rep(10:nsym,5)=0 ! E1 (cont.)

      rep(1,6)=2; rep(2:3,6)=-1; rep(4:6,6)=0; rep(7,6)=-1 ! E2
      rep(8,6)=2; rep(9,6)=-1; rep(10:nsym,6)=0 ! E2 (cont.)

    end subroutine set_chartab_d3h

    subroutine set_symbol_d3h(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(6)
      character(len=4), intent(out) :: active(6)

      nrep = 6
      symbol_irrep(1) = "A1'"; active(1) = 'R   '
      symbol_irrep(2) = "A2'"
      symbol_irrep(3) = 'A1"'
      symbol_irrep(4) = 'A2"'; active(4) = 'IR  '
      symbol_irrep(5) = 'E" '; active(5) = 'R   '         !! ASMS 2015/03/17
      symbol_irrep(6) = "E' "; active(6) = 'IR&R'         !! ASMS 2015/03/17

    end subroutine set_symbol_d3h

    subroutine set_chartab_c6v(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 12

      call set_chartab_d6(rep)

    end subroutine set_chartab_c6v

    subroutine set_symbol_c6v(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(6)
      character(len=4), intent(out) :: active(6)

      nrep = 6
      symbol_irrep(1) = 'A1 '; active(1) = 'IR&R'
      symbol_irrep(2) = 'A2 '
      symbol_irrep(3) = 'B1 '
      symbol_irrep(4) = 'B2 '
      symbol_irrep(5) = 'E1 '; active(5) = 'IR&R'
      symbol_irrep(6) = 'E2 '; active(6) = 'R   '

    end subroutine set_symbol_c6v

    subroutine set_chartab_c6h(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      integer :: i
      integer, parameter :: nsym = 12
      integer, parameter :: nsym2 = nsym/2
      integer, parameter :: nrep = 8
      integer, parameter :: nrep2 = nrep/2

      call set_chartab_c6(rep)
      do i=1,nsym2
         rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
      end do
      do i=1,nsym2
         rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
      end do
      do i=nsym2+1,nsym
         rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
      end do

    end subroutine set_chartab_c6h

    subroutine set_symbol_c6h(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(8)
      character(len=4), intent(out) :: active(8)

      nrep = 8
      symbol_irrep(1) = 'Ag '; active(1) = 'R   '
      symbol_irrep(2) = 'Bg '
      symbol_irrep(3) = 'E2g'; active(3) = 'R   '
      symbol_irrep(4) = 'E1g'; active(4) = 'R   '
      symbol_irrep(5) = 'Au '; active(5) = 'IR  '
      symbol_irrep(6) = 'Bu '
      symbol_irrep(7) = 'E2u'
      symbol_irrep(8) = 'E1u'; active(8) = 'IR  '

    end subroutine set_symbol_c6h

    subroutine set_chartab_c3h(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 6

      rep(1:nsym,1)=1 ! A

      rep(1:3,2)=1; rep(4:nsym,2)=-1 ! B

      rep(1,3)=2; rep(2:3,3)=-1; rep(4,3)=-1; ! E2
      rep(5,3)=2; rep(nsym,3)=-1  ! E2

      rep(1,4)=2; rep(2:3,4)=-1; rep(4,4)=1 ! E1
      rep(5,4)=-2; rep(nsym,4)=1 ! E1

    end subroutine set_chartab_c3h

    subroutine set_symbol_c3h(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(4)
      character(len=4), intent(out) :: active(4)

      nrep = 4
      symbol_irrep(1) = "A' "; active(1) = 'R   '
      symbol_irrep(2) = 'A" '; active(2) = 'IR  '
      symbol_irrep(3) = "E' "; active(3) = 'IR&R'
      symbol_irrep(4) = 'E" '; active(4) = 'IR&R'

    end subroutine set_symbol_c3h

    subroutine set_chartab_c6(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 6

      rep(1:nsym,1)=1 ! A

      rep(1,2)=1; rep(2,2)=-1; rep(3,2)=1; rep(4,2)=-1 ! B
      rep(5,2)=1; rep(nsym,2)=-1 ! B

      rep(1,3)=2; rep(2:3,3)=-1; rep(4,3)=2; rep(5:nsym,3)=-1 ! E2

      rep(1,4)=2; rep(2,4)=1; rep(3,4)=-1; rep(4,4)=-2 ! E1
      rep(5,4)=-1; rep(nsym,4)=1 ! E1

    end subroutine set_chartab_c6

    subroutine set_symbol_c6(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(4)
      character(len=4), intent(out) :: active(4)

      nrep = 4
      symbol_irrep(1) = 'A  '; active(1) = 'IR&R'
      symbol_irrep(2) = 'B  '
      symbol_irrep(3) = 'E2 '; active(3) = 'R   '
      symbol_irrep(4) = 'E1 '; active(4) = 'IR&R'

    end subroutine set_symbol_c6

    subroutine set_chartab_d3d(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      integer :: i
      integer, parameter :: nsym = 12 
      integer, parameter :: nsym2 = nsym/2
      integer, parameter :: nrep = 6
      integer, parameter :: nrep2 = nrep/2

      call set_chartab_d3(rep)
      do i=1,nsym2
         rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
      end do
      do i=1,nsym2
         rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
      end do
      do i=nsym2+1,nsym
         rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
      end do

    end subroutine set_chartab_d3d

    subroutine set_symbol_d3d(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(6)
      character(len=4), intent(out) :: active(6)

      nrep = 6
      symbol_irrep(1) = 'A1g'; active(1) = 'R   '
      symbol_irrep(2) = 'A2g'
      symbol_irrep(3) = 'Eg '; active(3) = 'R   '
      symbol_irrep(4) = 'A1u'
      symbol_irrep(5) = 'A2u'; active(5) = 'IR  '
      symbol_irrep(6) = 'Eu '; active(6) = 'IR  '

    end subroutine set_symbol_d3d

    subroutine set_chartab_d3(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 6

      rep(1:nsym,1)=1 ! A1

      rep(1:3,2)=1; rep(4:nsym,2)=-1 ! A2

      rep(1,3)=2; rep(2:3,3)=-1; rep(4:nsym,3)=0 ! E

    end subroutine set_chartab_d3

    subroutine set_symbol_d3(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(3)
      character(len=4), intent(out) :: active(3)

      nrep = 3
      symbol_irrep(1) = 'A1 '; active(1) = 'R   '
      symbol_irrep(2) = 'A2 '; active(2) = 'IR  '
      symbol_irrep(3) = 'E  '; active(3) = 'IR&R'

    end subroutine set_symbol_d3

    subroutine set_chartab_c3v(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 6

      rep(1:nsym,1)=1 ! A1

      rep(1:3,2)=1; rep(4:nsym,2)=-1 ! A2

      rep(1,3)=2; rep(2:3,3)=-1; rep(4:nsym,3)=0 ! E

    end subroutine set_chartab_c3v

    subroutine set_symbol_c3v(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(3)
      character(len=4), intent(out) :: active(3)

      nrep = 3
      symbol_irrep(1) = 'A1 '; active(1) = 'IR&R'
      symbol_irrep(2) = 'A2 '
      symbol_irrep(3) = 'E  '; active(3) = 'IR&R'

    end subroutine set_symbol_c3v

    subroutine set_chartab_s6(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      integer :: i
      integer, parameter :: nsym = 6
      integer, parameter :: nsym2 = nsym/2
      integer, parameter :: nrep = 4
      integer, parameter :: nrep2 = nrep/2

      call set_chartab_c3(rep)
      do i=1,nsym2
         rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
      end do
      do i=1,nsym2
         rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
      end do
      do i=nsym2+1,nsym
         rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
      end do

    end subroutine set_chartab_s6

    subroutine set_symbol_s6(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(4)
      character(len=4), intent(out) :: active(4)

      nrep = 4
      symbol_irrep(1) = 'Ag '; active(1) = 'R   '
      symbol_irrep(2) = 'Eg '; active(2) = 'R   '
      symbol_irrep(3) = 'Au '; active(3) = 'IR  '
      symbol_irrep(4) = 'Eu '; active(4) = 'IR  '

    end subroutine set_symbol_s6

    subroutine set_chartab_c3(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 3

      rep(1:nsym,1)=1 ! A1

      rep(1,2)=2; rep(2:nsym,2)=-1 ! E

    end subroutine set_chartab_c3

    subroutine set_symbol_c3(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(2)
      character(len=4), intent(out) :: active(2)

      nrep = 2
      symbol_irrep(1) = 'A  '; active(1) = 'IR&R'
      symbol_irrep(2) = 'E  '; active(2) = 'IR&R'

    end subroutine set_symbol_c3

    subroutine set_chartab_c2h(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      integer :: i
      integer, parameter :: nsym = 4
      integer, parameter :: nsym2 = nsym/2
      integer, parameter :: nrep = 4
      integer, parameter :: nrep2 = nrep/2

      call set_chartab_c2(rep)
      do i=1,nsym2
         rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
      end do
      do i=1,nsym2
         rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
      end do
      do i=nsym2+1,nsym
         rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
      end do

    end subroutine set_chartab_c2h

    subroutine set_symbol_c2h(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(4)
      character(len=4), intent(out) :: active(4)

      nrep = 4
      symbol_irrep(1) = 'Ag '; active(1) = 'R   '
      symbol_irrep(2) = 'Bg '; active(2) = 'R   '
      symbol_irrep(3) = 'Au '; active(3) = 'IR  '
      symbol_irrep(4) = 'Bu '; active(4) = 'IR  '

    end subroutine set_symbol_c2h

    subroutine set_chartab_cs(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      call set_chartab_c2(rep)

    end subroutine set_chartab_cs

    subroutine set_symbol_cs(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(2)
      character(len=4), intent(out) :: active(2)

      nrep = 2
      symbol_irrep(1) = "A' "; active(1) = 'IR&R'
      symbol_irrep(2) = 'A" '; active(2) = 'IR&R'

    end subroutine set_symbol_cs

    subroutine set_chartab_c2(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 2

      rep(1:nsym,1)=1 ! A

      rep(1,2)=1; rep(nsym,2)=-1 ! B

    end subroutine set_chartab_c2

    subroutine set_symbol_c2(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(2)
      character(len=4), intent(out) :: active(2)

      nrep = 2
      symbol_irrep(1) = 'A  '; active(1) = 'IR&R'
      symbol_irrep(2) = 'B  '; active(2) = 'IR&R'

    end subroutine set_symbol_c2

    subroutine set_chartab_ci(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 2

      rep(1:nsym,1)=1 ! Ag 
      rep(1,2)=1; rep(nsym,2)=-1 ! Au

    end subroutine set_chartab_ci

    subroutine set_symbol_ci(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(2)
      character(len=4), intent(out) :: active(2)

      nrep = 2
      symbol_irrep(1) = 'A  '; active(1) = 'R   '
      symbol_irrep(2) = 'B  '; active(2) = 'IR  '

    end subroutine set_symbol_ci

    subroutine set_chartab_c1(rep)
      integer, intent(out) :: rep(nsym0,nrep0)

      ! local varibales
      integer, parameter :: nsym = 1

      rep(1:nsym,1)=1 ! A

    end subroutine set_chartab_c1

    subroutine set_symbol_c1(nrep,symbol_irrep,active)
      integer, intent(out) :: nrep
      character(len=3), intent(out) :: symbol_irrep(1)
      character(len=4), intent(out) :: active(1)

      nrep = 1
      symbol_irrep(1) = 'A  '; active(1) = 'IR&R'

    end subroutine set_symbol_c1

  end subroutine get_irr_rep

! =======================================================================
!  Reference: 
!  https://www.cryst.ehu.es/cgi-bin/cryst/programs/representations_point.pl?tipogrupo=dbg
!
! =======================================================================
  subroutine get_irr_rep_dblegrp( point_group, nsym, nrep, rep, symbol_irrep )
    character(len=3), intent(in) :: point_group
    integer, intent(out) :: nsym, nrep
    complex(kind=CMPLDP), intent(out) :: rep( nsym0, 2, nrep0_dblegrp )
    character(len=4), intent(out) :: symbol_irrep( nrep0_dblegrp ) 

    integer :: i, j
    
    rep = 0.0d0
    symbol_irrep( 1:nrep0_dblegrp ) = 'NON'

    select case(point_group)  
    case('Oh ') !  1 
       call set_chartab_oh( rep )
       call set_symbol_oh( nrep, symbol_irrep )
       nsym = 48
    case('O  ') !  2
       call set_chartab_o( rep )
       call set_symbol_o( nrep, symbol_irrep )
       nsym = 24
    case('Td ') !  3
       call set_chartab_td( rep )
       call set_symbol_td( nrep, symbol_irrep )
       nsym = 24
    case('S4 ') !  11
       call set_chartab_s4( rep )
       call set_symbol_s4( nrep, symbol_irrep )
       nsym = 4
    case('D2h') ! 13
       call set_chartab_d2h( rep )
       call set_symbol_d2h( nrep, symbol_irrep )
       nsym = 8
    case('D2 ') ! 14
       call set_chartab_d2( rep )
       call set_symbol_d2( nrep, symbol_irrep )
       nsym = 4
    case('C2v') ! 15
       call set_chartab_c2v( rep )
       call set_symbol_c2v( nrep, symbol_irrep )
       nsym = 4
    end select

    return
    
    Do i=1, nrep
       write(*,*) "irep = ", i,  symbol_irrep(i)
       Do j=1, nsym
          write(*,'(I5,2F8.4)') j, rep(j,1,i), rep(j,2,i)
       End do
       write(*,*)
    End Do
    stop
    
  contains

    subroutine set_chartab_oh( rep )
      complex(kind=CMPLDP), intent(out) :: rep( nsym0, 2, nrep0_dblegrp )

      integer, parameter :: nsym = 48
      integer, parameter :: nsym2 = nsym/2
      integer, parameter :: nrep = 16
      integer, parameter :: nrep2 = nrep/2
      integer :: i
      
      call set_chartab_o(rep)
      Do i=nsym2+1, nsym
         rep( i, :, 1:nrep2 ) = rep(i-nsym2,:,1:nrep2) 
      End Do
      Do i=nrep2, 1, -1
         rep( 1:nsym2, :, 2*i )        =  rep( 1:nsym2, :, i )
         rep( nsym2+1:nsym, :, 2*i )   = -rep( 1:nsym2, :, i )
         rep( 1:nsym2, :, 2*i-1 )      =  rep( 1:nsym2, :, i )
         rep( nsym2+1:nsym, :, 2*i-1 ) =  rep( 1:nsym2, :, i )
      End Do
    end subroutine set_chartab_oh

    subroutine set_symbol_oh( nrep, symbol_irrep )
      integer, intent(out) :: nrep
      character(len=4), intent(out) :: symbol_irrep(16)

      nrep = 16
      symbol_irrep(1)  = 'GM1+';      symbol_irrep(2)  = 'GM1-' 
      symbol_irrep(3)  = 'GM2+';      symbol_irrep(4)  = 'GM2-'
      symbol_irrep(5)  = 'GM3+';      symbol_irrep(6)  = 'GM3-'
      symbol_irrep(7)  = 'GM4+';      symbol_irrep(8)  = 'GM4-'
      symbol_irrep(9)  = 'GM5+';      symbol_irrep(10) = 'GM5-'
      symbol_irrep(11) = 'GM6+';      symbol_irrep(12) = 'GM6-'
      symbol_irrep(13) = 'GM7+';      symbol_irrep(14) = 'GM7-'
      symbol_irrep(15) = 'GM8+';      symbol_irrep(16) = 'GM8-'
    end subroutine set_symbol_oh

    subroutine set_chartab_o( rep )
      complex(kind=CMPLDP), intent(out) :: rep( nsym0, 2, nrep0_dblegrp )

      integer, parameter :: nsym = 24
! GM1 = A1
      rep( 1:nsym, :, 1 ) = 1    
! GM2 = A2
      rep(     1, :, 2 ) =  1           ! E
      rep(  2: 4, :, 2 ) =  1           ! C2xyz
      rep(  5:12, :, 2 ) =  1           ! C3
      rep( 13:18, :, 2 ) = -1           ! C2a,..
      rep( 19:24, :, 2 ) = -1           ! C4...
! GM3 = E
      rep(     1, :, 3 ) =  2           ! E
      rep(  2: 4, :, 3 ) =  2           ! C2xyz
      rep(  5:12, :, 3 ) = -1           ! C3
      rep( 13:18, :, 3 ) =  0           ! C2a,..
      rep( 19:24, :, 3 ) =  0           ! C4...
! GM4 = T1
      rep(     1, :, 4 ) =  3           ! E
      rep(  2: 4, :, 4 ) = -1           ! C2xyz
      rep(  5:12, :, 4 ) =  0           ! C3
      rep( 13:18, :, 4 ) = -1           ! C2a,..
      rep( 19:24, :, 4 ) =  1           ! C4...
! GM5 = T2
      rep(     1, :, 5 ) =  3           ! E
      rep(  2: 4, :, 5 ) = -1           ! C2xyz
      rep(  5:12, :, 5 ) =  0           ! C3
      rep( 13:18, :, 5 ) =  1           ! C2a,..
      rep( 19:24, :, 5 ) = -1           ! C4...
! GM6 = E1bar
      rep(     1, 1, 6 ) =  2           ! E
      rep(     1, 2, 6 ) = -2           ! E *R
      rep(  2: 4, :, 6 ) =  0           ! C2xyz
      rep(  5:12, 1, 6 ) =  1           ! C3
      rep(  5:12, 2, 6 ) = -1           ! C3 *R
      rep( 13:18, :, 6 ) =  0           ! C2a,..
      rep( 19:24, 1, 6 ) =  sqrt(2.)    ! C4...
      rep( 19:24, 2, 6 ) = -sqrt(2.)    ! C4... *R
! GM7 = E2bar
      rep(     1, 1, 7 ) =  2           ! E
      rep(     1, 2, 7 ) = -2           ! E *R
      rep(  2: 4, :, 7 ) =  0           ! C2xyz
      rep(  5:12, 1, 7 ) =  1           ! C3
      rep(  5:12, 2, 7 ) = -1           ! C3 *R
      rep( 13:18, :, 7 ) =  0           ! C2a,..
      rep( 19:24, 1, 7 ) = -sqrt(2.)    ! C4...
      rep( 19:24, 2, 7 ) =  sqrt(2.)    ! C4... *R
! GM8 = Fbar
      rep(     1, 1, 8 ) =  4           ! E
      rep(     1, 2, 8 ) = -4           ! E *R
      rep(  2: 4, :, 8 ) =  0           ! C2xyz
      rep(  5:12, 1, 8 ) = -1           ! C3
      rep(  5:12, 2, 8 ) =  1           ! C3 *R
      rep( 13:18, :, 8 ) =  0           ! C2a,..
      rep( 19:24, :, 8 ) =  0           ! C4...

    end subroutine set_chartab_o

    subroutine set_symbol_o( nrep, symbol_irrep )
      integer, intent(out) :: nrep
      character(len=4), intent(out) :: symbol_irrep(8)

      nrep = 8
      symbol_irrep(1) = 'GM1 ';      symbol_irrep(2) = 'GM2 '
      symbol_irrep(3) = 'GM3 ';      symbol_irrep(4) = 'GM4 '
      symbol_irrep(5) = 'GM5 ';      symbol_irrep(6) = 'GM6 '
      symbol_irrep(7) = 'GM7 ';      symbol_irrep(8) = 'GM8 '
    end subroutine set_symbol_o

    subroutine set_chartab_td( rep )
      complex(kind=CMPLDP), intent(out) :: rep( nsym0, 2, nrep0_dblegrp )

      call set_chartab_o( rep )
    end subroutine set_chartab_td

    subroutine set_symbol_td( nrep, symbol_irrep )
      integer, intent(out) :: nrep
      character(len=4), intent(out) :: symbol_irrep(8)

      nrep = 8
      symbol_irrep(1) = 'GM1 ';      symbol_irrep(2) = 'GM2 '
      symbol_irrep(3) = 'GM3 ';      symbol_irrep(4) = 'GM4 '
      symbol_irrep(5) = 'GM5 ';      symbol_irrep(6) = 'GM6 '
      symbol_irrep(7) = 'GM7 ';      symbol_irrep(8) = 'GM8 '

    end subroutine set_symbol_td

    subroutine set_chartab_s4( rep )
      complex(kind=CMPLDP), intent(out) :: rep( nsym0, 2, nrep0_dblegrp )

      integer, parameter :: nsym = 4
      complex(kind=CMPLDP) :: ztmp1, ztmp2
      
      ztmp1 = ( 1.d0 +zi )/sqrt(2.d0)
      ztmp2 = ( 1.d0 -zi )/sqrt(2.d0)
      
! GM1 = A
      rep(     1, :, 1 ) =  1           ! E
      rep(     4, :, 1 ) =  1           ! C2   0  0  1
      rep(    21, :, 1 ) =  1           ! C4+  0  0  1
      rep(    24, :, 1 ) =  1           ! C4-  0  0  1
! GM2 = B
      rep(     1, :, 2 ) =  1           ! E
      rep(     4, :, 2 ) =  1           ! C2   0  0  1
      rep(    21, :, 2 ) = -1           ! C4+  0  0  1
      rep(    24, :, 2 ) = -1           ! C4-  0  0  1
! GM3 = 2E
      rep(     1, :, 3 ) =  1           ! E
      rep(     4, :, 3 ) = -1           ! C2   0  0  1
      rep(    21, :, 3 ) =  zi          ! C4+  0  0  1
      rep(    24, :, 3 ) = -zi          ! C4-  0  0  1
! GM4 = 1E
      rep(     1, :, 4 ) =  1           ! E
      rep(     4, :, 4 ) = -1           ! C2   0  0  1
      rep(    21, :, 4 ) = -zi          ! C4+  0  0  1
      rep(    24, :, 4 ) =  zi          ! C4-  0  0  1
! GM5 = 2Ebar1
      rep(     1, 1, 5 ) =  1           ! E
      rep(     4, 1, 5 ) = -zi          ! C2   0  0  1
      rep(    21, 1, 5 ) =  ztmp2       ! C4+  0  0  1
      rep(    24, 1, 5 ) =  ztmp1       ! C4-  0  0  1
      rep(     1, 2, 5 ) = -1           ! E *R
      rep(     4, 2, 5 ) =  zi          ! C2   0  0  1 *R
      rep(    21, 2, 5 ) = -ztmp2       ! C4+  0  0  1 *R
      rep(    24, 2, 5 ) = -ztmp1       ! C4-  0  0  1 *R
! GM6 = 1Ebar1
      rep(     1, 1, 6 ) =  1           ! E
      rep(     4, 1, 6 ) =  zi          ! C2   0  0  1
      rep(    21, 1, 6 ) =  ztmp1       ! C4+  0  0  1
      rep(    24, 1, 6 ) =  ztmp2       ! C4-  0  0  1
      rep(     1, 2, 6 ) = -1           ! E *R
      rep(     4, 2, 6 ) = -zi          ! C2   0  0  1 *R
      rep(    21, 2, 6 ) = -ztmp1       ! C4+  0  0  1 *R
      rep(    24, 2, 6 ) = -ztmp2       ! C4-  0  0  1 *R
! GM7 = 2Ebar2
      rep(     1, 1, 7 ) =  1           ! E
      rep(     4, 1, 7 ) = -zi          ! C2   0  0  1
      rep(    21, 1, 7 ) = -ztmp2       ! C4+  0  0  1
      rep(    24, 1, 7 ) = -ztmp1       ! C4-  0  0  1
      rep(     1, 2, 7 ) = -1           ! E *R
      rep(     4, 2, 7 ) =  zi          ! C2   0  0  1 *R
      rep(    21, 2, 7 ) =  ztmp2       ! C4+  0  0  1 *R
      rep(    24, 2, 7 ) =  ztmp1       ! C4-  0  0  1 *R
! GM8 = 1Ebar2
      rep(     1, 1, 8 ) =  1           ! E
      rep(     4, 1, 8 ) =  zi          ! C2   0  0  1
      rep(    21, 1, 8 ) = -ztmp1       ! C4+  0  0  1
      rep(    24, 1, 8 ) = -ztmp2       ! C4-  0  0  1
      rep(     1, 2, 8 ) = -1           ! E *R
      rep(     4, 2, 8 ) = -zi          ! C2   0  0  1 *R
      rep(    21, 2, 8 ) =  ztmp1       ! C4+  0  0  1 *R
      rep(    24, 2, 8 ) =  ztmp2       ! C4-  0  0  1 *R
    end subroutine set_chartab_s4

    subroutine set_symbol_s4( nrep, symbol_irrep )
      integer, intent(out) :: nrep
      character(len=4), intent(out) :: symbol_irrep(8)

      nrep = 8
      symbol_irrep(1) = 'GM1 ';      symbol_irrep(2) = 'GM2 '
      symbol_irrep(3) = 'GM3 ';      symbol_irrep(4) = 'GM4 '
      symbol_irrep(5) = 'GM5 ';      symbol_irrep(6) = 'GM6 '
      symbol_irrep(7) = 'GM7 ';      symbol_irrep(8) = 'GM8 '

    end subroutine set_symbol_s4

    subroutine set_chartab_d2h( rep )
      complex(kind=CMPLDP), intent(out) :: rep( nsym0, 2, nrep0_dblegrp )

      integer, parameter :: nsym = 8
      integer, parameter :: nsym2 = nsym/2
      integer, parameter :: nrep = 10
      integer, parameter :: nrep2 = nrep/2
      integer :: i
      
      call set_chartab_d2(rep)
      Do i=nsym2+1, nsym
         rep( i, :, 1:nrep2 ) = rep(i-nsym2,:,1:nrep2) 
      End Do
      Do i=nrep2, 1, -1
         rep( 1:nsym2, :, 2*i )        =  rep( 1:nsym2, :, i )
         rep( nsym2+1:nsym, :, 2*i )   = -rep( 1:nsym2, :, i )
         rep( 1:nsym2, :, 2*i-1 )      =  rep( 1:nsym2, :, i )
         rep( nsym2+1:nsym, :, 2*i-1 ) =  rep( 1:nsym2, :, i )
      End Do
    end subroutine set_chartab_d2h

    subroutine set_symbol_d2h( nrep, symbol_irrep )
      integer, intent(out) :: nrep
      character(len=4), intent(out) :: symbol_irrep(10)

      nrep = 10
      symbol_irrep(1)  = 'GM1+';      symbol_irrep(2)  = 'GM1-' 
      symbol_irrep(3)  = 'GM2+';      symbol_irrep(4)  = 'GM2-'
      symbol_irrep(5)  = 'GM3+';      symbol_irrep(6)  = 'GM3-'
      symbol_irrep(7)  = 'GM4+';      symbol_irrep(8)  = 'GM4-'
      symbol_irrep(9)  = 'GM5+';      symbol_irrep(10) = 'GM5-'
    end subroutine set_symbol_d2h

    subroutine set_chartab_d2( rep )
      complex(kind=CMPLDP), intent(out) :: rep( nsym0, 2, nrep0_dblegrp )

      integer, parameter :: nsym = 4
      
! GM1 = A1
      rep(     1, :, 1 ) =  1           ! E
      rep(     2, 1, 1 ) =  1           ! C2   1  0  0
      rep(     3, 1, 1 ) =  1           ! C2   0  1  0
      rep(     4, 1, 1 ) =  1           ! C2   0  0  1
! GM2 = B2
      rep(     1, :, 2 ) =  1           ! E
      rep(     2, 1, 2 ) = -1           ! C2   1  0  0
      rep(     3, 1, 2 ) =  1           ! C2   0  1  0
      rep(     4, 1, 2 ) = -1           ! C2   0  0  1
! GM3 = B1
      rep(     1, :, 3 ) =  1           ! E
      rep(     2, 1, 3 ) = -1           ! C2   1  0  0
      rep(     3, 1, 3 ) = -1           ! C2   0  1  0
      rep(     4, 1, 3 ) =  1           ! C2   0  0  1
! GM4 = B3
      rep(     1, :, 4 ) =  1           ! E
      rep(     2, 1, 4 ) =  1           ! C2   1  0  0
      rep(     3, 1, 4 ) = -1           ! C2   0  1  0
      rep(     4, 1, 4 ) = -1           ! C2   0  0  1
! GM5 = Ebar
      rep(     1, 1, 5 ) =  2           ! E
      rep(     1, 2, 5 ) = -2           ! E *R
    end subroutine set_chartab_d2

    subroutine set_symbol_d2( nrep, symbol_irrep )
      integer, intent(out) :: nrep
      character(len=4), intent(out) :: symbol_irrep(5)

      nrep = 5
      symbol_irrep(1) = 'GM1 ';      symbol_irrep(2) = 'GM2 '
      symbol_irrep(3) = 'GM3 ';      symbol_irrep(4) = 'GM4 '
      symbol_irrep(5) = 'GM5 '; 
    end subroutine set_symbol_d2

    subroutine set_chartab_c2v( rep )
      complex(kind=CMPLDP), intent(out) :: rep( nsym0, 2, nrep0_dblegrp )

      integer, parameter :: nsym = 4
      
! GM1 = A1
      rep(     1, :, 1 ) =  1           ! E
      rep(     4, :, 1 ) =  1           ! C2   0  0  1
      rep( 24 +2, :, 1 ) =  1           ! C2   1  0  0 *Inv
      rep( 25 +2, :, 1 ) =  1           ! C2   0  1  0 *Inv
! GM2 = B1
      rep(     1, :, 2 ) =  1           ! E
      rep(     4, :, 2 ) = -1           ! C2   0  0  1
      rep( 24 +2, :, 2 ) = -1           ! C2   1  0  0 *Inv
      rep( 25 +2, :, 2 ) =  1           ! C2   0  1  0 *Inv
! GM3 = A2
      rep(     1, :, 3 ) =  1           ! E
      rep(     4, :, 3 ) = -1           ! C2   0  0  1
      rep( 24 +2, :, 3 ) =  1           ! C2   1  0  0 *Inv
      rep( 25 +2, :, 3 ) = -1           ! C2   0  1  0 *Inv
! GM4 = B2
      rep(     1, :, 4 ) =  1           ! E
      rep(     4, :, 4 ) =  1           ! C2   0  0  1
      rep( 24 +2, :, 4 ) = -1           ! C2   1  0  0 *Inv
      rep( 25 +2, :, 4 ) = -1           ! C2   0  1  0 *Inv
! GM5 = barE
      rep(     1, 1, 5 ) =  2           ! E
      rep(     1, 2, 5 ) = -2           ! R
    end subroutine set_chartab_c2v

    subroutine set_symbol_c2v( nrep, symbol_irrep )
      integer, intent(out) :: nrep
      character(len=4), intent(out) :: symbol_irrep(5)

      nrep = 5
      symbol_irrep(1) = 'GM1 ';      symbol_irrep(2) = 'GM2 '
      symbol_irrep(3) = 'GM3 ';      symbol_irrep(4) = 'GM4 '
      symbol_irrep(5) = 'GM5 '; 
    end subroutine set_symbol_c2v

  end subroutine get_irr_rep_dblegrp

end module m_Representation

       program main
       implicit none
!      Program of nlo susceptibility decomposition
!      This program read 'nlo.data' file containing the susceptibility data 
!      and write the tensor component specified to 'nlo_ijk.data'.
!      ijk is the tensor index
!      INPUT : nlo.data     (file no.=1)
!      OUTPUT: nlo_ijk.data (file no.=2)
!      T. Hamada, Univ. Tokyo (2005.9.1)
       integer       :: ind, i
       integer       :: icount
       character*12  :: file_name
       character*59  :: a
       character*3   :: ind_chi2
       real(kind=8)  :: energy, r_chi2, i_chi2, abs

       open(1,file = 'nlo.data',status="old")
       read(5,'(a3)') ind_chi2
       file_name = 'nlo_'//ind_chi2//'.data'
       open(2,file = file_name, status="replace")

       call read_write_header

    1  read(1,10,end=99) a
       if(index(a,ind_chi2)/=0) then
          read(1,10,end=99) a
          write(2,10) a
          icount=0
    2     read(1,10) a
          if(index(a,'*')==0) then
             backspace 1
             read(1,20) energy, r_chi2, i_chi2, abs
             write(2,20) energy, r_chi2, i_chi2, abs
             icount=icount+1
          else
             write(6,'("line number of ",a12 " = ",i5)') file_name, icount-1
             stop
          end if
          goto 2
        end if
       goto 1
    99 stop 
    10 format(a59)
    20 format(3x,f10.5,6x,3(f10.5,5x))
       end program main
 
       subroutine read_write_header
       implicit none
       character*59 :: a
       integer :: i
       rewind 1
       rewind 2
       read(1,10) a
       if(i==1.and.index(a,'Tensor')==0) then
          write(*,99)
          stop
       end if
       write(2,10) a
    10 format(a59)
    99 format("nlo.data file has no dielectric tensor component. STOP")
       end subroutine read_write_header

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: Renewal_of_pPotential
!
!  AUTHOR(S): M. Saito, T. Yamasaki   November/04/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!
subroutine Renewal_of_pPotential()
! $Id: Renewal_of_pPotential.f90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Files,               only : nfout
!!  use m_ES_Intgr_VlhxcQlm,   only : m_ESiVQ_integrate_VlhxcQlm
  use m_Charge_Density,      only : chgq_l
  use m_epc_potential,       only : m_epc_alloc, m_epc_cal_potential, &
       &                            m_epc_ESlhxc_potential, vepc_l, &
       &                            m_epc_ESlhxc_potential_mod
  use m_Control_Parameters,  only : positron_method
  use m_Const_Parameters,    only : Positron_CONV

  implicit none

  call m_epc_alloc()
  call m_epc_cal_potential(nfout,chgq_l) ! chgq_l -> vepc_l, tchgq_l
                                              ! (xcfft) -> vxc_l

  if ( positron_method == Positron_CONV ) then
     call m_epc_ESlhxc_potential(nfout)     ! vepc_l, tchgq_l ->  vlhxc_l
  else
     call m_epc_ESlhxc_potential_mod(nfout)
  endif

!!  call m_ESiVQ_integrate_VlhxcQlm(nfout) ! (lclchh) -> vlhxcQ

end subroutine Renewal_of_pPotential

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 606 $)
!
!  MODULE: m_ES_dos
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!      Further modification by T. Yamasaki   May/09/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_ES_dos
!     (m_ESdos)
! $Id: m_ES_dos.F90 606 2020-04-15 06:45:49Z ktagami $
!
! This module was originally coded by T. Yamasaki (FUJITSU Laboratories) in 2001.
! And this is transferred as match to PHASE by T. Yamasaki, 18th May. 2003.
!
  use m_Kpoints, only :              kv3, kv3_ek, qwgt,vkxyz_ek &
       &                           , np0,np2,ip20,iwt,ip2cub,nxyz_tetra,trmat &
       &                           , m_Kp_sample_mesh, qwgt_ek
  use m_Files, only :                nfout
!!$  use m_Files, only :                nfdos, nfout
  use m_Timing, only :               tstatc0_begin, tstatc0_end
  use m_Control_Parameters, only   : ekmode, ipridos, nspin, neg, af &
       &                            ,nwd_dos_window_width &
       &                            ,deltaE_dos,  variance_dos_GaussD &
       &                            ,sw_pdos, pdos_method, norbital &
       &                            ,maxorb, l_orb, t_orb, rc_orb, k_orb &
       &                            ,sw_orb_popu,dos_subroutine &
       &                            ,ipriinputfile, printable, sw_dos, dos_write_format &
       &                            ,sw_modified_kpoint_increment
  use m_Const_Parameters, only :     DP,Hartree,BUCS,EK,SCF, ALDOS, LAYERDOS, ON, OFF, TOTAL, PAI2 &
       &                           , WIDE, NARROW, eVunit
  use m_Parallelization, only :      MPI_CommGroup,map_ek,mype,map_e,map_k,myrank_e,myrank_k &
       &                            , ierr,np_e,map_z,ista_e,npes,mpi_kg_world &
       &                            , mpi_ge_world, nrank_e,ista_k,iend_k &
       &                            , nis_kv3_ek, ista_spin, iend_spin, myrank_spin, nrank_s
  use m_PseudoPotential, only :      nlmta_phi,nlmtt_phi &
       &                            ,m_PP_tell_iorb_ia_l_m_tau, qorb &
       &                            ,m_PP_tell_iorb_lmtt, ltp_phi, mtp_phi, taup_phi &
       &                            ,lmta_phi, nlmt_phi, ilmt_phi, iproj_phi, lmtt_phi
  use m_Nonlocal_Potential,  only : norm_phig
  use m_Crystal_Structure, only   : nopr, il, univol, altv
  use m_Electronic_Structure, only : occup_l, eko_l,eko_ek,totch, neordr &
       &                           , vbm, check_if_metalic_flag, metalic_system &
       &                           , compr_l, compi_l

!!$ASASASASAS
  use m_Kpoints,            only : k_symmetry
  use m_Const_Parameters,   only : GAMMA
  use m_Ionic_System,       only : iproj_group, natm, ityp, cps, if_pdos
!!$ASASASASAS


! =================================== added by K. Tagami ============ 11.0
  use m_Const_Parameters,   only : CMPLDP, zi, DIAG_SPIN_DENSITY_MATRIX, &
       &                           DIAG_CHARGE_DENSITY_MATRIX, DIAG_LS_with_t2g_octa, &
       &                           DIAG_LS, LOCAL_POINT_GROUP
  use m_Control_Parameters,   only : ndim_spinor, ndim_magmom, ndim_chgpot, noncol
! =================================================================== 11.0
  use m_ES_NonCollinear,    only : m_ES_DensMat_To_MagMom_porb, m_ES_set_Pauli_Matrix

! =================================== added by K. Tagami ============ 11.0
  use m_PseudoPotential, only :    modnrm, nloc, ntau
  use m_Parallelization, only :    ista_e,iend_e,istep_e, np_e
  use m_Control_Parameters,   only : kimg, hardpart_subroutine, &
       &                             calc_dos_magmom_contrib
  use m_Const_Parameters,   only : EXECUT, ELECTRON, DIRECT, YES, NO
  use m_PlaneWaveBasisSet, only :  kgp
  use m_FFT, only :                nfft, nfftp, nfftp_nonpara, fft_box_size_WF, &
       &                           fft_box_size_CD, &
       &                           m_FFT_alloc_WF_work, m_FFT_dealloc_WF_work, &
       &                           m_FFT_CD_inverse0,   m_FFT_WF, &
       &                           m_FFT_alloc_CD_box, m_FFT_dealloc_CD_box
  use m_Charge_Density, only :     chgq_l, chgq_enl, &
!       &                           m_CD_hardpart_sub_noncl, &
!       &                           m_CD_hardpart_sub2_noncl, &
       &                           m_CD_map_chgq_to_fft_box, &
       &                           m_CD_set_ylm_enl_etc, &
       &                           m_CD_dealloc_ylm_enl_etc, &
       &                           m_CD_map_chgqenl_to_fft_box_kt
!       &                           m_CD_map_valence_charge_to_fft_box, &
!       &                           m_CD_restore_chgq
!  use m_Electronic_Structure,only :m_ES_WF_in_Rspace
! =================================================================== 11.0

! =============== KT_add =============== 13.0E
  use m_Control_Parameters,  only : smearing_width_fdirac => width, width_tetra, &
       &                            orb_popu_method, sw_diagonalize_population, &
       &                            population_diag_mode
  use m_Electronic_Structure, only : efermi
! ====================================== 13.0E

  use m_OP_rotation,   only : m_OP_alloc_compri_rot,  m_OP_dealloc_compri_rot, &
       &                      m_OP_set_compri_rot, compr_rot_l, compi_rot_l, &
       &                      porb_rot_matrix_real,  porb_rot_matrix_cmplx
  use m_IterationNumbers, only : nkgroup, nk_in_the_process
  use mpi

  implicit none

  real(kind=DP),private ::                            Eminimum, Emaximum
  integer,private ::                                  nEwindows, nETailWindows
  integer,private,parameter ::                        nETailMax = 1000
  real(kind=DP),private ::                            ValenceBandMaximum
  real(kind=DP),private,parameter ::                  DeltaD = 1.d-18
  real(kind=DP),private,parameter ::                  DeltaDVBM = 1.d-4
  real(kind=DP),private ::                            sqrtDVI

!!$  real(kind=DP),public ::  deltaE_dos_GaussD = 1.d-4
!!$  real(kind=DP),public ::  variance_dos_GaussD = 1.d-6
!!$  integer,public ::        nwd_dos_window_width = 10

  real(kind=DP),private,allocatable,dimension(:,:) :: eko
  real(kind=DP),private,allocatable,dimension(:,:) :: dos
  real(kind=DP),private,allocatable,dimension(:,:) :: sumdos
  real(kind=DP),private,allocatable,dimension(:,:) :: dos_weight

! ===================== added by K. Tagami =============================== 11.0
  real(kind=DP),private,allocatable,dimension(:,:,:) :: dos_weight_noncl
! ======================================================================== 11.0

  integer, private ::                                 ndim_dos_weight1, ndim_dos_weight2

  !-- PDOS --
  real(kind=DP),private,allocatable,dimension(:,:,:,:) :: compr
  real(kind=DP),private,allocatable,dimension(:,:,:,:) :: compi
  real(kind=DP),private,allocatable,dimension(:,:) :: norm_phig_mpi
  real(kind=DP),private,allocatable,dimension(:,:,:) :: pdos
  real(kind=DP),private,allocatable,dimension(:,:,:) :: sumpdos

  character(len("pdos")),private,parameter :: tag_pdos       = "pdos"
  character(len("sw_pdos")),private,parameter :: tag_sw_pdos = "sw_pdos"
  character(len("sw_orb_popu")),private,parameter :: tag_sw_orb_popu = "sw_orb_popu"
  character(len("method")),private,parameter :: tag_method   = "method"
  character(len("element")),private,parameter :: tag_element = "element"
  character(len("orbitals")),private,parameter :: tag_orbitals = "orbitals"
  character(len("l")),private,parameter ::        tag_l    = "l"
  character(len("t")),private,parameter ::        tag_t    = "t"
  character(len("k")),private,parameter ::        tag_k    = "k"
  character(len("rc")),private,parameter ::       tag_rc   = "rc"
  character(len("projector")),private,parameter :: tag_projector = "projector"
  character(len("wavefunction")),private,parameter :: tag_wavefunction = "wavefunction"
  character(len("mulliken")),private,parameter :: tag_mulliken = "mulliken"

  character(len("use_rotated_compri")),private,parameter :: &
       &             tag_use_rotated_compri = "use_rotated_compri"
  integer :: use_rotated_compri = OFF

! -- pCOHP --
  character(len("pcohp")),private,parameter :: &
       &         tag_pcohp = "pcohp"
  character(len("sw_calc_pcohp")),private,parameter :: &
       &         tag_sw_calc_pcohp = "sw_calc_pcohp"
  character(len("atom1")),private,parameter :: &
       &         tag_atom1 = "atom1"
  character(len("max_distance_from_atom1")),private,parameter :: &
       &         tag_max_distance_from_atom1 = "max_distance_from_atom1"
!
  integer :: sw_calc_pcohp = off
  integer :: atom1_pcohp = 0
  real(kind=DP) :: max_distance_from_atom1_pcohp = 8.0d0  ! bohr

  real(kind=DP), private, allocatable :: pcohp(:,:,:,:)
  real(kind=DP), private, allocatable :: sum_pcohp(:,:,:,:)

  ! --- POSTPROCESSING ---
  character(len("Postprocessing")),private,parameter :: tag_postprocessing    = "postprocessing"

!  include 'mpif.h'
contains
  subroutine m_ESdos_alloc_dos_weight()
    if(.not.allocated(dos_weight)) then
       if(ekmode == ON) then
          allocate(dos_weight(neg,kv3_ek))
       else if(ekmode == OFF) then
          allocate(dos_weight(neg,kv3))
       end if
    end if
  end subroutine m_ESdos_alloc_dos_weight

  subroutine m_ESdos_dealloc_dos_weight()
    if(allocated(dos_weight)) deallocate(dos_weight)
  end subroutine m_ESdos_dealloc_dos_weight

! ========================= added by K. Tagami =============== 11.0
  subroutine m_ESdos_alloc_dos_wght_noncl()
    if (.not.allocated(dos_weight_noncl)) then
       if (ekmode == ON) then
          allocate( dos_weight_noncl(neg,kv3_ek,ndim_magmom) )
       else if (ekmode == OFF) then
          allocate( dos_weight_noncl(neg,kv3,ndim_magmom) )
       end if
       dos_weight_noncl = 0.0d0
    end if
  end subroutine m_ESdos_alloc_dos_wght_noncl

  subroutine m_ESdos_dealloc_dos_wght_noncl()
    if (allocated(dos_weight_noncl)) deallocate(dos_weight_noncl)
  end subroutine m_ESdos_dealloc_dos_wght_noncl
! ================================================================ 11.0

  subroutine m_ESdos_put_dos_weight(ne,nk,dos_weight_from)
    integer, intent(in) :: ne, nk
    real(kind=DP), intent(in), dimension(ne,nk) :: dos_weight_from
    if(.not.allocated(dos_weight)) &
         & call phase_error_with_msg(nfout,' dos_weight is not allocated <<m_ESdos_put_dos_weight>>',__LINE__,__FILE__)

    if(ekmode == ON) then
       if( ne /= neg .or. nk /= kv3_ek) then
          write(nfout,'(" !ldos ne /= neg or nk /= kv3_ek ",&
               & ": ne, neg, nk, kv3_ek = ",4i6," <<m_ESdos_put_dos_weight>>")') ne,neg,nk,kv3_ek
          call phase_error_with_msg(nfout,' ne /= neg or nk /= kv3_ek <<m_ESdos_put_dos_weight>>',__LINE__,__FILE__)
       end if
    else if(ekmode == OFF) then
       if( ne /= neg .or. nk /= kv3) then
          write(nfout,'(" !ldos ne /= neg or nk /= kv3 ",&
               & ": ne, neg, nk, kv3 = ",4i6," <<m_ESdos_put_dos_weight>>")') ne,neg,nk,kv3
          call phase_error_with_msg(nfout,' ne /= neg or nk /= kv3 <<m_ESdos_put_dos_weight>>',__LINE__,__FILE__)
       end if
    end if
    dos_weight(:,:) = dos_weight_from(:,:)
  end subroutine m_ESdos_put_dos_weight

! ============================== added by K. Tagami =============== 11.0
  subroutine m_ESdos_put_dos_weight_noncl(ne,nk,dos_weight_from)
    integer, intent(in) :: ne, nk
    real(kind=DP), intent(in), dimension(ne,nk,ndim_magmom) :: dos_weight_from

    if (.not.allocated(dos_weight_noncl)) &
         & call phase_error_with_msg(nfout,' dos_weight_noncl is not allocated <<m_ESdos_put_dos_weight_noncl>>'&
         &                          ,__LINE__,__FILE__)

    if (ekmode == ON) then
       if ( ne /= neg .or. nk /= kv3_ek) then
          write(nfout,'(" !ldos ne /= neg or nk /= kv3_ek ",&
               & ": ne, neg, nk, kv3_ek = ",4i6," <<m_ESdos_put_dos_weight_nocl>>")') &
               &  ne,neg,nk,kv3_ek
          call phase_error_with_msg(nfout,' ne /= neg or nk /= kv3_ek <<m_ESdos_put_dos_weight_noncl>>',__LINE__,__FILE__)
       end if

    else if(ekmode == OFF) then
       if ( ne /= neg .or. nk /= kv3) then
          write(nfout,'(" !ldos ne /= neg or nk /= kv3 ",&
               & ": ne, neg, nk, kv3 = ",4i6," <<m_ESdos_put_dos_weight_noncl>>")') &
               &    ne,neg,nk,kv3
          call phase_error_with_msg(nfout,' ne /= neg or nk /= kv3 <<m_ESdos_put_dos_weight_noncl>>',__LINE__,__FILE__)
       end if
    end if
    dos_weight_noncl(:,:,:) = dos_weight_from(:,:,:)

  end subroutine m_ESdos_put_dos_weight_noncl
! ============================================================== 11.0

  subroutine find_Erange(ek,neg,kv)
    integer, intent(in) :: neg,kv
    real(kind=DP), intent(in) :: ek(neg,kv)
    integer :: i, is
    logical :: found
    real(kind=DP) :: DeltaE, t
    real(kind=DP) :: derfc

    DeltaE = DeltaE_dos

    Eminimum = 9999.99d0;
    Emaximum  = -9999.99d0;

    sqrtdVI = 1.d0/dsqrt(2*Variance_dos_GaussD)
    t = DeltaE * sqrtdVI  ! t = DeltaE/dsqrt(2*Variance_dos_GaussD)

    if(ipridos >= 2) then
       write(nfout,'(" Attenuation check of a Gassuian function (find_Erange)")')
       write(nfout,'(" sqrtdVI = ",f10.5," DeltaE = ",f10.5, " t = ",f10.5 )')&
         & sqrtdVI, DeltaE, t
    end if

    i = 0; found = .false.
    do while(.not.found.and.i<=nETailMax)
       i = i + 1
       found = derfc(t*i) < DeltaD
    end do
    nETailWindows = i

    if(ipridos >= 2) write(nfout,'(" nETailWindows = ",i5)') nETailWindows

    Eminimum = minval(ek)
    Emaximum = maxval(ek)
!!$    write(nfout,'(" !! minval(ek), maxval(ek) = ",2f10.6)') Eminimum, Emaximum

    i = abs(Eminimum/DeltaE) + 1
    is = sign(1.d0,Eminimum)
    Eminimum = i*DeltaE*is - nETailWindows*DeltaE

    i = abs(Emaximum/DeltaE) + 1
    is = sign(1.d0,Emaximum)
    Emaximum = i*DeltaE*is + nETailWindows*DeltaE
    nEwindows = (Emaximum - Eminimum)/DeltaE + 1

    if(ipridos >= 2) then
       write(nfout,'(" Emaximum = ",f8.4, " Eminimum = ",f8.4 &
            & , " nEwindows = ",i8)') Emaximum, Eminimum, nEwindows+2*nETailWindows
    end if

  end subroutine find_Erange

! ================================= KT_add ======================== 13.0E
  subroutine find_Erange_fermidirac(ek,neg,kv)
    integer, intent(in) :: neg,kv
    real(kind=DP), intent(in) :: ek(neg,kv)
    integer :: i, is
    logical :: found
    real(kind=DP) :: DeltaE, t
    real(kind=DP) :: xx, yy
!
    real(kind=DP) :: threshold = 1.0E-4
!
    DeltaE = DeltaE_dos

    Eminimum = 9999.99d0;    Emaximum  = -9999.99d0;
    Eminimum = minval(ek);  Emaximum = maxval(ek)

    xx = 2.0D0 *log( 2.0D0 *sqrt(1.0D0 /threshold ) )  ! width of extent of df/dx
                                                       ! f: Fermi-Dirac fn
    xx = xx *smearing_width_fdirac

    nETailWindows = xx / DeltaE +1

    i = abs(Eminimum/DeltaE) +1;  is = sign(1.d0,Eminimum)
    Eminimum = i*DeltaE*is -nETailWindows*DeltaE

    i = abs(Emaximum/DeltaE) +1;  is = sign(1.d0,Emaximum)
    Emaximum = i*DeltaE*is + nETailWindows*DeltaE

    nEwindows = (Emaximum -Eminimum)/DeltaE +1
    if(ipridos >= 2) write(nfout,'(" nETailWindows = ",i5)') nETailWindows


  end subroutine find_Erange_fermidirac
! =========================================================== 13.0E

  subroutine alloc_eko_and_substitution(kv)
    use m_Parallelization, only : mpi_kg_world, mpi_ge_world
    integer, intent(in) :: kv
    integer ::             ik,ie,ip,iksnl
    integer :: iorb,iopr, nelm

! ==================== added by K. Tagami ================== 11.0
#ifdef forsafe
    integer :: ksym_ik
#endif
! ========================================================== 11.0
    integer :: ispin

    if ( sw_diagonalize_population == ON .and. use_rotated_compri == YES ) then
       call m_OP_alloc_compri_rot
       call m_OP_set_compri_rot
    endif

    allocate(eko(neg,kv));  eko = 0.d0
    if(sw_pdos == ON) then
       allocate(compr(neg,nlmta_phi,nopr,kv));  compr = 0.d0
       allocate(compi(neg,nlmta_phi,nopr,kv));  compi = 0.d0
       if(.not.allocated(norm_phig_mpi)) allocate(norm_phig_mpi(nlmtt_phi,kv/nspin))
       norm_phig_mpi=0.d0
    end if

! Substitution eko_l for eko in the order of thier values
    do ispin = ista_spin, iend_spin
!    do ik = 1, kv
    do ik = ispin, kv-nspin+ispin, nspin
       if(map_k(ik) /= myrank_k) cycle
! ============================= added by K. Tagami ============== 11.0
#ifdef forsafe
       ksym_ik = k_symmetry(ik)
#endif
! =============================================================== 11.0
       iksnl = (ik-1)/nspin + 1
       do ie = 1, neg
          ip = neordr(ie,ik)
          if(map_e(ip) == myrank_e) then
             eko(ie,ik) = eko_l(map_z(ip),ik)
             if(sw_pdos == ON) then
                if ( sw_diagonalize_population==ON .and. use_rotated_compri==YES ) then
                   compr(ie,1:nlmta_phi,1:nopr,ik) &
                        & = compr_rot_l(map_z(ip),1:nlmta_phi,1:nopr,ik)
#ifdef forsafe
                   if ( ksym_ik  /= GAMMA ) then
#else
                   if ( k_symmetry(ik) /= GAMMA ) then
#endif
                      compi(ie,1:nlmta_phi,1:nopr,ik) &
                           & = compi_rot_l(map_z(ip),1:nlmta_phi,1:nopr,ik)
                   else
                      compi(ie,1:nlmta_phi,1:nopr,ik) = 0.0d0
                   endif
                else
                   compr(ie,1:nlmta_phi,1:nopr,ik) &
                        & = compr_l(map_z(ip),1:nlmta_phi,1:nopr,ik)
#ifdef forsafe
                   if ( ksym_ik  /= GAMMA ) then
#else
                   if ( k_symmetry(ik) /= GAMMA ) then
#endif
                      compi(ie,1:nlmta_phi,1:nopr,ik) &
                           & = compi_l(map_z(ip),1:nlmta_phi,1:nopr,ik)
                   else
                      compi(ie,1:nlmta_phi,1:nopr,ik) = 0.0d0
                   endif
                endif
                norm_phig_mpi(1:nlmtt_phi,iksnl)  = norm_phig(1:nlmtt_phi,iksnl)
             end if
          end if
       end do
    end do
    end do

    if(npes >=2 ) then
       call mpi_allreduce(MPI_IN_PLACE,eko,neg*kv,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
       call mpi_allreduce(MPI_IN_PLACE,eko,neg*kv,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
       if(sw_pdos == ON) then
          nelm = neg*nlmta_phi*nopr*kv
          call mpi_allreduce(MPI_IN_PLACE,compr,nelm,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
          call mpi_allreduce(MPI_IN_PLACE,compr,nelm,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
          call mpi_allreduce(MPI_IN_PLACE,compi,nelm,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
          call mpi_allreduce(MPI_IN_PLACE,compi,nelm,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
       !call mpi_allreduce(norm_phig_mpi,norm_phig_mpi2,nlmtt_phi*kv/nspin,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
          call mpi_allreduce(MPI_IN_PLACE,norm_phig_mpi,nlmtt_phi*kv/nspin,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
          norm_phig_mpi = norm_phig_mpi / dble(nrank_s)
       end if
    end if
    if(ipridos >= 2) then
       ! -- writing --
       write(nfout,'(" !dos: eko <<alloc_eko_and_substitution>>")')
       do ik = 1, kv
          write(nfout,'(" !dos: ik = ",i5)') ik
          write(nfout,'(" !dos: ",10f8.4)') (eko(ie,ik),ie=1,neg)
       end do
       if(sw_pdos == ON) then
          do ik = 1, kv
             iksnl = (ik-1)/nspin + 1
             do iopr=1,nopr
                do iorb=1,nlmta_phi
                   write(nfout,'(" !dos: ik=",i5," iopr=",i5," iorb=",i5)')  ik,iopr,iorb
                   write(nfout,'(" !dos compr: ",10f8.4)') compr(1:neg,iorb,iopr,ik)
!!$ASASASASAS
!!$                write(nfout,'(" !dos compi: ",10f8.4)') &
!!$                              & compi(1:neg,iorb,iopr,ik)
! =========================== modified by K. Tagami ========= 11.0
!                if ( k_symmetry(ik) /= GAMMA ) then
#ifdef forsafe
                   if ( ksym_ik /= GAMMA ) then
#else
                      if ( k_symmetry(ik) /= GAMMA ) then
#endif
! =========================================================== 11.0

                         write(nfout,'(" !dos compi: ",10f8.4)') compi(1:neg,iorb,iopr,ik)
                      endif
!!$ASASASASAS
                   end do
                end do
             write(nfout,'(" !dos norm_phig: ",10f8.4)') norm_phig_mpi(1:nlmtt_phi,iksnl)
          end do
       end if
    end if
  end subroutine alloc_eko_and_substitution

! ========================= added by K. Tagami =================== 11.0
  subroutine alloc_eko_and_substit_noncl(kv)
    integer, intent(in) :: kv
    integer ::             ik,ie,ip,iksnl
    integer :: iorb,iopr
    integer :: is, nelm
    integer :: num_orbitals, kfac

#ifdef forsafe
    integer :: ksym_ik
#endif

    kfac = 1
    if ( sw_diagonalize_population == ON ) then
       if ( population_diag_mode /= DIAG_CHARGE_DENSITY_MATRIX &
            & .and. population_diag_mode /= LOCAL_POINT_GROUP ) then
          kfac = ndim_spinor
       endif
    endif
    num_orbitals = nlmta_phi *kfac

    if ( sw_diagonalize_population == ON .and. use_rotated_compri == YES ) then
       call m_OP_alloc_compri_rot
       call m_OP_set_compri_rot
    endif

    allocate(eko(neg,kv/ndim_spinor));  eko = 0.d0

    if(sw_pdos == ON) then
       allocate(compr(neg,num_orbitals,nopr,kv));  compr = 0.d0
       allocate(compi(neg,num_orbitals,nopr,kv));  compi = 0.d0
       allocate(norm_phig_mpi(nlmtt_phi,kv/ndim_spinor));
       norm_phig_mpi=0.d0
    end if

! Substitution eko_l for eko in the order of thier values
    do ik = 1, kv, ndim_spinor

! ============================= added by K. Tagami ============== 11.0
#ifdef forsafe
       ksym_ik = k_symmetry(ik)
#endif
! =============================================================== 11.0

       if(map_k(ik) /= myrank_k) cycle
       iksnl = (ik-1)/ndim_spinor + 1

       do ie = 1, neg
          ip = neordr(ie,ik)

          if (map_e(ip) == myrank_e) then
             eko( ie,iksnl ) = eko_l( map_z(ip),ik )

             if(sw_pdos == ON) then
                if ( sw_diagonalize_population==ON .and. use_rotated_compri==YES ) then
                   Do is=1, ndim_spinor
                      compr(ie,1:num_orbitals,1:nopr,ik+is-1) &
                           & = compr_rot_l(map_z(ip),1:num_orbitals,1:nopr,ik+is-1)
                      compi(ie,1:num_orbitals,1:nopr,ik+is-1) &
                           & = compi_rot_l(map_z(ip),1:num_orbitals,1:nopr,ik+is-1)
                   End do
                else
                   Do is=1, ndim_spinor
                      compr(ie,1:num_orbitals,1:nopr,ik+is-1) &
                           & = compr_l(map_z(ip),1:num_orbitals,1:nopr,ik+is-1)
                      compi(ie,1:num_orbitals,1:nopr,ik+is-1) &
                           & = compi_l(map_z(ip),1:num_orbitals,1:nopr,ik+is-1)
                   End do
                endif
                norm_phig_mpi(1:nlmtt_phi,iksnl)  = norm_phig(1:nlmtt_phi,iksnl)
             end if

          end if
       end do
    end do

    if (npes >=2 ) then
       call mpi_allreduce( MPI_IN_PLACE,eko,neg*kv/ndim_spinor,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
       if (sw_pdos == ON) then
          nelm = neg*num_orbitals*nopr*kv
          call mpi_allreduce( MPI_IN_PLACE,compr,nelm,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
          call mpi_allreduce( MPI_IN_PLACE,compi,nelm,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
          nelm = nlmtt_phi*kv/ndim_spinor
          call mpi_allreduce( MPI_IN_PLACE,norm_phig_mpi,nelm,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
          norm_phig_mpi = norm_phig_mpi / dble(nrank_s)
       end if

    end if

    if(ipridos >= 2) then
       ! -- writing --
       write(nfout,'(" !dos: eko <<alloc_eko_and_substi_noncl>>")')

       do ik = 1, kv, ndim_spinor
          iksnl = (ik-1)/ndim_spinor + 1
          write(nfout,'(" !dos: ik = ",i5)') ik
          write(nfout,'(" !dos: ",10f8.4)') (eko(ie,iksnl),ie=1,neg)
       end do

       if(sw_pdos == ON) then
          do ik = 1, kv, ndim_spinor
             iksnl = (ik-1)/ndim_spinor + 1

             do iopr=1,nopr
                do iorb=1,num_orbitals
                   write(nfout,'(" !dos: ik=",i5," iopr=",i5," iorb=",i5)')&
                        &  ik,iopr,iorb
                   write(nfout,'(" !dos compr: ",10f8.4)') compr(1:neg,iorb,iopr,ik)
                   write(nfout,'(" !dos compi: ",10f8.4)') compi(1:neg,iorb,iopr,ik)
                end do
             end do
             write(nfout,'(" !dos norm_phig: ",10f8.4)')  norm_phig_mpi(1:nlmtt_phi,iksnl)
          end do
       end if
    end if

  end subroutine alloc_eko_and_substit_noncl
! =================================================================== 11.0

  subroutine m_ES_dos_alloc_compr_compi_ek()
    allocate(compr(neg,nlmta_phi,nopr,kv3_ek));  compr = 0.d0
    allocate(compi(neg,nlmta_phi,nopr,kv3_ek));  compi = 0.d0
    if(allocated(norm_phig_mpi)) deallocate(norm_phig_mpi)
    allocate(norm_phig_mpi(nlmtt_phi,kv3_ek/nspin))
    norm_phig_mpi=0.d0
  end subroutine m_ES_dos_alloc_compr_compi_ek

  subroutine m_ES_dos_pdos_per_k()
    integer :: ik,ikn,is,ikt
    if(sw_modified_kpoint_increment == ON) then
      ik=myrank_k
      do is=1,nspin
        ikn = nspin*(nis_kv3_ek(ik)-1)+(nkgroup-1)*nspin+is
        if(ikn>kv3_ek) cycle
        call pdos_per_k(ik+1,ikn)
      enddo
    else
      do ik = 1, kv3
         if(map_k(ik) /= myrank_k) cycle
         ikn = nk_in_the_process+ik-1
         if(ikn>kv3_ek) cycle
         call pdos_per_k(ik,ikn)
      end do
    endif

    contains

    subroutine pdos_per_k(ik,ikn)
      integer, intent(in) :: ik, ikn
      integer :: iksnl, iksn, ip
      integer :: ie,ib,jb,ibo,jbo
      integer,allocatable,dimension(:) :: neordr_ek
      integer,parameter :: delta = 1.d-12
      iksn  = (ik-1)/nspin + 1
      iksnl = (ikn-1)/nspin + 1
      allocate(neordr_ek(neg))
      neordr_ek = (/(ib,ib=1,neg)/)
      do ib = 1,neg-1
         do jb = ib+1, neg
            ibo = neordr_ek(ib)
            jbo = neordr_ek(jb)
            if(eko_ek(jbo,ikn) < eko_ek(ibo,ikn)-delta) then
               neordr_ek(jb) = ibo
               neordr_ek(ib) = jbo
            end if
         end do
      end do
      do ie = 1, neg
         ip = neordr_ek(ie)
         if(map_e(ip) == myrank_e) then
            if ( sw_diagonalize_population==ON .and. use_rotated_compri==YES ) then
               compr(ie,1:nlmta_phi,1:nopr,ikn) &
                    & = compr_rot_l(map_z(ip),1:nlmta_phi,1:nopr,ik)
               if ( k_symmetry(ik) /= GAMMA ) then
                  compi(ie,1:nlmta_phi,1:nopr,ikn) &
                     & = compi_rot_l(map_z(ip),1:nlmta_phi,1:nopr,ik)
               else
                  compi(ie,1:nlmta_phi,1:nopr,ikn) = 0.0d0
               endif
            else
               compr(ie,1:nlmta_phi,1:nopr,ikn) &
                    & = compr_l(map_z(ip),1:nlmta_phi,1:nopr,ik)
               if ( k_symmetry(ik) /= GAMMA ) then
                  compi(ie,1:nlmta_phi,1:nopr,ikn) &
                       & = compi_l(map_z(ip),1:nlmta_phi,1:nopr,ik)
               else
                  compi(ie,1:nlmta_phi,1:nopr,ikn) = 0.0d0
               endif
            endif
         end if
      end do
      norm_phig_mpi(1:nlmtt_phi,iksnl)  = norm_phig(1:nlmtt_phi,iksn)
      deallocate(neordr_ek)
    end subroutine pdos_per_k
  end subroutine m_ES_dos_pdos_per_k

  subroutine m_ES_dos_gather_compr_compi_ek()
    integer :: nelm
    integer :: ib,ilm,iopr,ik


    if(npes >=2) then
       nelm = neg*nlmta_phi*nopr*kv3_ek
       call mpi_allreduce(MPI_IN_PLACE,compr,nelm,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
       call mpi_allreduce(MPI_IN_PLACE,compr,nelm,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
       call mpi_allreduce(MPI_IN_PLACE,compi,nelm,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
       call mpi_allreduce(MPI_IN_PLACE,compi,nelm,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
       call mpi_allreduce(MPI_IN_PLACE,norm_phig_mpi,nlmtt_phi*kv3_ek/nspin, &
       &    mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
       norm_phig_mpi = norm_phig_mpi / dble(nrank_s)
    end if
  end subroutine m_ES_dos_gather_compr_compi_ek

  subroutine pdos_ek()
    use m_Control_Parameters, only : af
    use m_Files, only : m_Files_open_nfzaj_kall, nfzaj_kall
    use m_IterationNumbers, only : m_Iter_reset_nk_in_the_process
    use m_ES_IO, only : m_ESIO_rd_next_wfs_ek
    use m_ES_nonlocal, only : m_ES_betar_dot_WFs_4_each_k_3D, m_ES_phir_dot_WFs_3D
    use m_Electronic_Structure, only : m_ES_sym_comp
    integer :: nk, is, ik

    call m_Files_open_nfzaj_kall()
    rewind(nfzaj_kall)
    call m_Iter_reset_nk_in_the_process()
    compr = 0.d0
    compi = 0.d0
    norm_phig_mpi = 0.d0
    do nk=1, kv3_ek, kv3
      call KpointNumber_Setting2()
      call Preparation_ek()
      call Preparation_for_mpi_ek()
      call epsmain_reallocate()
      call PseudoPotential_ek()
      do is=1, nspin, af+1
        do ik=is, kv3+is-nspin, nspin
          call m_ESIO_rd_next_wfs_ek(ik, nfout, nfzaj_kall)
          if(map_k(ik) /= myrank_k) cycle
          call m_ES_betar_dot_WFs_4_each_k_3D(nfout, ik)
        enddo
      enddo
      call m_ES_phir_dot_WFs_3D( nfout )
      call m_ES_sym_comp(nfout)
      call m_ES_dos_pdos_per_k()
    enddo
  end subroutine pdos_ek

  subroutine alloc_eko_and_substitution_ek(kv3_ek)
    integer, intent(in) :: kv3_ek
    integer :: ik,ie,ib,jb,ibo,jbo
    integer,allocatable,dimension(:) :: neordr_ek
    real(kind=DP),parameter :: delta = 1.d-12

    allocate(eko(neg,kv3_ek))
    allocate(neordr_ek(neg))
    do ik = 1, kv3_ek
       neordr_ek = (/(ib,ib=1,neg)/)
       do ib = 1,neg-1
          do jb = ib+1, neg
             ibo = neordr_ek(ib)
             jbo = neordr_ek(jb)
             if(eko_ek(jbo,ik) < eko_ek(ibo,ik)-delta) then
                neordr_ek(jb) = ibo
                neordr_ek(ib) = jbo
             end if
          end do
       end do
! Substitution eko_ek for eko in the order of thier values
       do ie = 1, neg
          eko(ie,ik) = eko_ek(neordr_ek(ie),ik)
       end do
    end do
!!$    write(nfout,'(" !! eko (alloc_eko_and_substitution_ek)")')
!!$    do ik = 1, kv3_ek
!!$       write(nfout,'(" !! ik = ",i5, "(",3f8.4,")")') ik, (vkxyz_ek(ib,ik,BUCS),ib=1,3)
!!$       write(nfout,'("(eko_ek): ",8f10.6)') (eko_ek(ie,ik),ie=1,neg)
!!$       write(nfout,'("(eko):    ",8f10.6)') (eko(ie,ik),ie=1,neg)
!!$    end do
    deallocate(neordr_ek)
  end subroutine alloc_eko_and_substitution_ek

! ============================== added by K. Tagami ============= 11.0
  subroutine alloc_eko_and_substit_ek_noncl(kv3_ek)
    integer, intent(in) :: kv3_ek
    integer :: ik,ie,ib,jb,ibo,jbo
    integer :: iksnl
    integer :: ikt

    integer,allocatable,dimension(:) :: neordr_ek
    real(kind=DP),parameter :: delta = 1.d-12

    allocate(eko(neg,kv3_ek/ndim_spinor))
    allocate(neordr_ek(neg))

    do ik = 1, kv3_ek, ndim_spinor
       iksnl = ( ik -1 ) /ndim_spinor + 1

       neordr_ek = (/(ib,ib=1,neg)/)
       do ib = 1,neg-1
          do jb = ib+1, neg
             ibo = neordr_ek(ib)
             jbo = neordr_ek(jb)
             if(eko_ek(jbo,ik) < eko_ek(ibo,ik)-delta) then
                neordr_ek(jb) = ibo
                neordr_ek(ib) = jbo
             end if
          end do
       end do
! Substitution eko_ek for eko in the order of thier values
       if(ik+kv3-1 > kv3_ek) then
       do ie = 1, neg
          eko(ie,iksnl) = eko_ek(neordr_ek(ie),ik)
       end do
       else
          ikt = myrank_k*kv3+mod(ik,kv3)
          eko(ie,iksnl) = eko_ek(neordr_ek(ie),ik)
       endif
    end do

    deallocate(neordr_ek)
  end subroutine alloc_eko_and_substit_ek_noncl
! ===================================================================== 11.0

  subroutine dealloc_eko()
    deallocate(eko)
    if(sw_pdos == ON) then
       deallocate(compr,compi)
       if (allocated(compr_rot_l) ) deallocate(compr_rot_l)
       if (allocated(compi_rot_l) ) deallocate(compi_rot_l)
    end if
  end subroutine dealloc_eko

  subroutine alloc_dos(i0,icomponent)
    integer,intent(in) :: i0,icomponent
    integer :: num_orbitals, kfac

    if ( noncol ) then
       allocate(dos(i0:nEwindows,ndim_magmom)); dos = 0.d0
       allocate(sumdos(i0:nEwindows,ndim_magmom)); sumdos = 0.d0
       if(icomponent == TOTAL .and. sw_pdos == ON) then
          kfac = 1
          if ( sw_diagonalize_population == ON ) then
             if ( population_diag_mode /= DIAG_CHARGE_DENSITY_MATRIX &
                  & .and. population_diag_mode /= LOCAL_POINT_GROUP ) then
                kfac = ndim_spinor
             endif
          endif
          num_orbitals = nlmta_phi *kfac
          allocate(pdos(i0:nEwindows,num_orbitals,ndim_magmom)); pdos = 0.d0
          allocate(sumpdos(i0:nEwindows,num_orbitals,ndim_magmom)); sumpdos = 0.d0
       end if

    else
       allocate(dos(i0:nEwindows,nspin)); dos = 0.d0
       allocate(sumdos(i0:nEwindows,nspin)); sumdos = 0.d0
       if(icomponent == TOTAL .and. sw_pdos == ON) then
          allocate(pdos(i0:nEwindows,nlmta_phi,nspin)); pdos = 0.d0
          allocate(sumpdos(i0:nEwindows,nlmta_phi,nspin)); sumpdos = 0.d0
       end if
    endif

  end subroutine alloc_dos

  subroutine dealloc_dos()
    deallocate(dos)
    deallocate(sumdos)
    if(sw_pdos == ON) then
       if(allocated(pdos)) deallocate(pdos)
       if(allocated(sumpdos)) deallocate(sumpdos)
    end if
  end subroutine dealloc_dos

  subroutine make_dos_with_GaussianDistrib( kv, iwsc, kpt_weight )
    integer, intent(in) :: kv, iwsc
    real(kind=DP), intent(in) :: kpt_weight( kv )

    integer ::             i, ik, is, ie, id, ispin, iorb, iopr, lmtt, iksnl
    real(kind=DP) ::       Es, e, El, Eu, tl, tu, w, DeltaE
    real(kind=DP) ::       derf
    real(kind=DP), allocatable :: porb(:)

    allocate( porb(nlmta_phi) );  porb = 0.0d0

    DeltaE = DeltaE_dos
    Es = Eminimum - DeltaE*0.5d0

    if(ipridos >= 2) write(nfout,'(" !! Es, DeltaE = ",2d20.10)') Es, DeltaE
    dos = 0.d0; sumdos = 0.d0
    if(iwsc == TOTAL .and. sw_pdos == ON) then
       pdos=0.d0; sumpdos=0.d0
    end if
    do ispin = 1, nspin
       do ik = ispin, kv, nspin
          iksnl = (ik-1)/nspin + 1
          do i = 1, neg
             w = 1.d0
             if(iwsc >= 1 ) w = dos_weight(i,ik)
             e = eko(i,ik) - nETailWindows*DeltaE - Es
             is = e/DeltaE
             ie = is + 2*nETailWindows
             if(is < 0) then
                if(ipridos >= 2) write(nfout,'(" is = ",i5," < 0")') is
                is = 0
             end if
             if(ie >= nEWindows ) then
                if(ipridos >= 2) write(nfout,'(" ie = ",i5, " > nEWindows")')ie
                ie = nEWindows-1
             end if
             if(ipridos >= 2) then
                write(nfout,'(" !! eko(",i3,",",i3,") = ",f10.6," is, ie = ",2i7, 2f10.6)') &
                     & i,ik, eko(i,ik),is,ie, Es+is*DeltaE, Es+ie*DeltaE
             end if

             do id = is, ie
                El = Es + id*DeltaE
                Eu = El + DeltaE
                tl = (El - eko(i,ik))*sqrtdVI
                tu = (Eu - eko(i,ik))*sqrtdVI
                !  d = (derf(tl) - derf(tu))*0.5d0/(DeltaE*kv)
                dos(id+1,ispin) = dos(id+1,ispin) &
                     & + w *2 *(derf(tu) - derf(tl)) *0.5d0 /DeltaE *kpt_weight(ik)
             end do
             if(iwsc == TOTAL .and. sw_pdos == ON) then
                w= 1.0d0;   porb = 0.0d0

                if ( sw_diagonalize_population == ON ) then
                   if ( use_rotated_compri == YES ) then
                      call set_porb_norot( porb )
                   else
                      call set_porb_rot_mode1( porb )
                   endif
                else
                   call set_porb_norot( porb )
                endif

                do iorb = 1, nlmta_phi
                   do id = is, ie
                      El = Es +id*DeltaE;    Eu = El +DeltaE
                      tl = (El -eko(i,ik))*sqrtdVI
                      tu = (Eu -eko(i,ik))*sqrtdVI
                      !  d = (derf(tl) - derf(tu))*0.5d0/(DeltaE*kv)
                      pdos(id+1,iorb,ispin) = pdos(id+1,iorb,ispin) &
                           & + porb(iorb) *w *2 *(derf(tu) - derf(tl)) &
                           &                *0.5d0 /DeltaE *kpt_weight(ik)
                   end do
                end do
             end if
          end do
       end do
       sumdos(1,ispin) = dos(1,ispin)*DeltaE
       do id = 1, nEWindows-1
          sumdos(id+1,ispin) = sumdos(id,ispin) + dos(id+1,ispin)*DeltaE
       end do
       if(iwsc == TOTAL .and. sw_pdos == ON) then
          do iorb = 1,nlmta_phi
             sumpdos(1,iorb,ispin) = pdos(1,iorb,ispin)*DeltaE
             do id = 1, nEWindows-1
                sumpdos(id+1,iorb,ispin) = sumpdos(id,iorb,ispin) + pdos(id+1,iorb,ispin)*DeltaE
             end do
          end do
       end if
    end do
    deallocate( porb )

  contains
    subroutine set_porb_norot( porb_out )
      real(kind=DP), intent(out) :: porb_out(nlmta_phi)

      integer :: iorb, iopr, lmtt
      real(kind=DP) :: ctemp

      Do iorb = 1, nlmta_phi
         call m_PP_tell_iorb_lmtt(iorb,lmtt)

         ctemp = 0.0d0
         if ( k_symmetry(ik) == GAMMA ) then
            do iopr=1,nopr
               ctemp = ctemp +compr(i,iorb,iopr,ik)**2 /2.0 &
                    &    *(1.d0+qorb(iorb)/(norm_phig_mpi(lmtt,iksnl)*2.) )
            end do
         else
            do iopr=1,nopr
               ctemp = ctemp + ( compr(i,iorb,iopr,ik)**2 &
                    &           +compi(i,iorb,iopr,ik)**2 ) &
                    &     *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt,iksnl) )
            end do
         endif
         porb_out(iorb) = porb_out(iorb) +ctemp /dble(nopr)
      End do
    end subroutine set_porb_norot

    subroutine set_porb_rot_mode1( porb_out )
      real(kind=DP), intent(out) :: porb_out(nlmta_phi)

      integer :: lmax, mmax, iopr
      integer :: ia, it, lmt, il, im, ip, iorb, lmtt
      integer :: lmt1, lmt2, im1, im2, iorb1, iorb2, lmtt1, lmtt2, im3
      integer :: tau, tau1, tau2
      real(kind=DP) :: c1, c2, ctmp
      real(kind=DP), allocatable :: dm(:,:,:,:)
      real(kind=DP), allocatable :: porb0(:,:,:)

      lmax = nloc;   mmax = 2*lmax -1

      allocate( dm( ntau, lmax, mmax, mmax ) )
      allocate( porb0( ntau, lmax, mmax ) )

      do ia=1,natm
         it = ityp(ia)
         if(iproj_group(ia) == 0) cycle

         dm = 0.0d0;  porb0 = 0.d00

         ! diagonal part
         do lmt=1,ilmt_phi(it)
            il = ltp_phi(lmt,it); im  = mtp_phi(lmt,it);
            tau = taup_phi(lmt,it)
            ip  = iproj_phi(lmt,it)
            iorb = lmta_phi(lmt,ia); lmtt = lmtt_phi(lmt,it)

            ctmp = 0.0d0
            if ( k_symmetry(ik) == GAMMA ) then
               do iopr=1, nopr
                  ctmp = ctmp + compr(i,iorb,iopr,ik)**2 /2.0 &
                       &      *(1.d0+qorb(iorb)/(norm_phig_mpi(lmtt,iksnl)*2.) )
               end do
            else
               do iopr=1, nopr
                  ctmp = ctmp + ( compr(i,iorb,iopr,ik)**2 &
                       &         +compi(i,iorb,iopr,ik)**2 ) &
                       &      *(1.d0+qorb(iorb)/norm_phig_mpi(lmtt,iksnl))
               end do
            endif
            dm(tau,il,im,im) = dm(tau,il,im,im) +ctmp/dble(nopr)
         end do
         ! non-diagonal part
         do lmt2=1,ilmt_phi(it)
            do lmt1=1,ilmt_phi(it)
               if ( lmt1 == lmt2 ) cycle
               if (ltp_phi(lmt1,it) /= ltp_phi(lmt2,it)) cycle
               if (taup_phi(lmt1,it) /= taup_phi(lmt2,it)) cycle

               il = ltp_phi(lmt1,it);     tau = taup_phi(lmt1,it)
               ip  = iproj_phi(lmt1,it)
               im1   = mtp_phi(lmt1,it);     im2 = mtp_phi(lmt2,it);
               iorb1 = lmta_phi(lmt1,ia);  iorb2 = lmta_phi(lmt2,ia)
               lmtt1 = lmtt_phi(lmt1,it);  lmtt2 = lmtt_phi(lmt2,it)

               c1 = ( qorb(iorb1) +qorb(iorb2) ) /2.0d0      ! approx
               c2 = sqrt(norm_phig_mpi(lmtt1,iksnl)*norm_phig_mpi(lmtt2,iksnl))

               ctmp = 0.0d0
               if(k_symmetry(ik) == GAMMA) then ! dame
                  do iopr = 1,nopr
                     ctmp = ctmp &
                          & + compr(i,iorb1,iopr,ik) &
                          &  *compr(i,iorb2,iopr,ik) /2.d0 &
                          &  *( 1.0d0 +c1 /( c2 *2.d0) )
                  end do
               else
                  do iopr = 1,nopr
                     ctmp = ctmp &
                          & + ( compr(i,iorb1,iopr,ik) &
                          &    *compr(i,iorb2,iopr,ik) &
                          &    +compi(i,iorb1,iopr,ik) &
                          &    *compi(i,iorb2,iopr,ik) )&
                          &  *( 1.0d0 +c1 /c2 )
                  end do
               endif
               dm(tau,il,im1,im2) = dm(tau,il,im1,im2) +ctmp/dble(nopr)
            end do
         end do

         Do tau=1, ntau
            Do il=1, lmax
               Do im1=1, mmax
                  ctmp = 0.0d0
                  Do im2=1, mmax
                     Do im3=1, mmax
                        ctmp = ctmp &
                             &    +porb_rot_matrix_real( ia,il,im2,im1 )  &
                             &       *dm(tau,il,im2,im3) &
                             &       *porb_rot_matrix_real( ia,il,im3,im1 )
                     End Do
                  End Do
                  porb0( tau, il, im1 ) = ctmp
               End DO
            End DO
         End Do

         Do lmt=1,ilmt_phi(it)
            il = ltp_phi(lmt,it);  im  = mtp_phi(lmt,it);  iorb = lmta_phi(lmt,ia)
            tau = taup_phi(lmt,it)
            porb_out( iorb ) = porb0( tau, il,im )
         ENd do
      End do
      deallocate( dm );  deallocate( porb0 )
    end subroutine set_porb_rot_mode1

  end subroutine make_dos_with_GaussianDistrib

! ==================================== added by K. Tagami ============== 11.0
  subroutine mkdos_with_GaussDistrib_noncl( kv, iwsc, kpt_weight )
    integer, intent(in) :: kv, iwsc
    real(kind=DP), intent(in) :: kpt_weight( kv )

    integer :: ik, iksnl, i, is, ie, istmp, id, iorb
    real(kind=DP) ::  Es, e, El, Eu, tl, tu, w, DeltaE
    real(kind=DP) ::  derf

    integer :: kfac, num_orbitals, ismax
    real(kind=DP), allocatable :: porb(:,:)
    complex(kind=CMPLDP), allocatable :: porb_ssrep(:,:)

    kfac = 1
    if ( sw_diagonalize_population == ON ) then
       if ( population_diag_mode /= DIAG_CHARGE_DENSITY_MATRIX &
            & .and. population_diag_mode /= LOCAL_POINT_GROUP ) then
          kfac = ndim_spinor
       endif
    endif
    num_orbitals = nlmta_phi *kfac

    allocate( porb(num_orbitals, ndim_magmom ) );  porb = 0.0d0
    allocate( porb_ssrep(num_orbitals, ndim_chgpot ) );  porb_ssrep = 0.0d0

    DeltaE = DeltaE_dos
    Es = Eminimum - DeltaE*0.5d0

    if (ipridos >= 2) write(nfout,'(" !! Es, DeltaE = ",2d20.10)') Es, DeltaE
    dos = 0.d0; sumdos = 0.d0
    if (iwsc == TOTAL .and. sw_pdos == ON) then
       pdos=0.d0; sumpdos=0.d0
    end if

    do ik = 1, kv, ndim_spinor
       iksnl = (ik-1)/ndim_spinor + 1
       do i = 1, neg

          e = eko(i,iksnl) - nETailWindows*DeltaE - Es

          is = e/DeltaE
          ie = is + 2*nETailWindows
          if(is < 0) then
             if(ipridos >= 2) write(nfout,'(" is = ",i5," < 0")') is
             is = 0
          end if
          if(ie >= nEWindows ) then
             if(ipridos >= 2) write(nfout,'(" ie = ",i5, " > nEWindows")')ie
             ie = nEWindows-1
          end if
          if(ipridos >= 2) then
             write(nfout,'(" !! eko(",i3,",",i3,") = ",f10.6," is, ie = ",2i7, 2f10.6)') &
                  & i,ik, eko(i,iksnl),is,ie, Es+is*DeltaE, Es+ie*DeltaE
          end if

          if ( calc_dos_magmom_contrib == YES ) then
             ismax = ndim_magmom
          else
             ismax = 1
          endif

          Do istmp=1, ismax
             w = dos_weight_noncl(i,ik,istmp)

             do id = is, ie
                El = Es + id*DeltaE
                Eu = El + DeltaE
                tl = (El - eko(i,iksnl))*sqrtdVI
                tu = (Eu - eko(i,iksnl))*sqrtdVI
                !  d = (derf(tl) - derf(tu))*0.5d0/(DeltaE*kv)
                dos(id+1,istmp) = dos(id+1,istmp) &
                     & + w *(derf(tu) - derf(tl)) *0.5d0 /DeltaE *kpt_weight(ik)
             end do
          End do

          if (iwsc == TOTAL .and. sw_pdos == ON) then
             w = 1.0d0;   porb_ssrep = 0.0d0

             if ( sw_diagonalize_population == ON ) then
                if ( use_rotated_compri == YES ) then
                   if ( population_diag_mode == DIAG_CHARGE_DENSITY_MATRIX &
                        &  .or. population_diag_mode == LOCAL_POINT_GROUP ) then
                      call set_porb_default( porb )
                   else
                      call set_porb_by_spinmixed_basis( porb )
                   endif
                else
                   if ( population_diag_mode == DIAG_CHARGE_DENSITY_MATRIX &
                        &  .or. population_diag_mode == LOCAL_POINT_GROUP ) then
                      call set_porb_rot_mode1( porb )
                   else
                      call set_porb_rot_mode2( porb )
                   endif
                endif
             else
                call set_porb_default( porb )
             endif

             Do iorb = 1, num_orbitals
                do id = is, ie
                   El = Es + id*DeltaE
                   Eu = El + DeltaE
                   tl = (El - eko(i,iksnl))*sqrtdVI
                   tu = (Eu - eko(i,iksnl))*sqrtdVI
                   !  d = (derf(tl) - derf(tu))*0.5d0/(DeltaE*kv)
                   pdos(id+1,iorb,:) = pdos(id+1,iorb,:) &
                        & + porb(iorb,:) *w *(derf(tu) - derf(tl)) &
                        &                *0.5d0 /DeltaE *kpt_weight(ik)
                end do
             End do

          end if
       end do
    end do

    sumdos(1,:) = dos(1,:)*DeltaE

    do id = 1, nEWindows-1
       sumdos(id+1,:) = sumdos(id,:) + dos(id+1,:)*DeltaE
    end do

    if(iwsc == TOTAL .and. sw_pdos == ON) then
       do iorb = 1,num_orbitals
          sumpdos(1,iorb,:) = pdos(1,iorb,:)*DeltaE
          do id = 1, nEWindows-1
             sumpdos(id+1,iorb,:) = sumpdos(id,iorb,:) + pdos(id+1,iorb,:)*DeltaE
          end do
       end do
    end if
    deallocate( porb ); deallocate( porb_ssrep )

  contains

    subroutine set_porb_default( porb_out )
      real(kind=DP), intent(out) :: porb_out(num_orbitals, ndim_magmom )

      integer :: iorb, is1, is2, istmp, iopr, lmtt
      complex(kind=CMPLDP) :: ztemp, z1, z2

      Do iorb = 1, nlmta_phi
         call m_PP_tell_iorb_lmtt(iorb,lmtt)

         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               istmp = ( is1 -1 )*ndim_spinor + is2

               ztemp = 0.0d0
               do iopr=1,nopr
                  z1 = dcmplx( compr(i,iorb,iopr,ik+is1-1 ), &
                       &       compi(i,iorb,iopr,ik+is1-1 ) )
                  z2 = dcmplx( compr(i,iorb,iopr,ik+is2-1 ), &
                       &       compi(i,iorb,iopr,ik+is2-1 ) )
                  ztemp = ztemp + z1 *conjg(z2) &
                       &      *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt,iksnl) )
               end do

               porb_ssrep(iorb,istmp) = porb_ssrep(iorb,istmp) &
                    &                   + ztemp /dble(nopr)
            End do
         End do
      End do
      call m_ES_DensMat_To_MagMom_porb( nlmta_phi, porb_ssrep, porb_out )

    end subroutine set_porb_default

    subroutine set_porb_by_spinmixed_basis( porb_out )
      real(kind=DP), intent(out) :: porb_out(num_orbitals, ndim_magmom )

      integer :: iorb, is1, is2, istmp, iopr, lmtt, iorb0
      complex(kind=CMPLDP) :: ztemp, z1, z2

      Do iorb = 1, num_orbitals
         iorb0 = int( (iorb-1)/ndim_spinor )+1
         call m_PP_tell_iorb_lmtt(iorb0,lmtt)

         ztemp = 0.0d0
         do iopr=1,nopr
            z1 = dcmplx( compr(i,iorb,iopr,ik ), &
                 &       compi(i,iorb,iopr,ik ) )
            z2 = dcmplx( compr(i,iorb,iopr,ik+1 ), &
                 &       compi(i,iorb,iopr,ik+1 ) )
            ztemp = ztemp + (z1+z2) *conjg(z1+z2) &
                 &  *( 1.d0+qorb(iorb0)/norm_phig_mpi(lmtt,iksnl) )
         end do
         porb_out(iorb,1) = ztemp /dble(nopr)
      End Do
    end subroutine set_porb_by_spinmixed_basis

    subroutine set_porb_rot_mode1( porb_out )
      real(kind=DP), intent(out) :: porb_out(num_orbitals, ndim_magmom )

      integer :: lmax, mmax, iopr
      integer :: ia, it, lmt, il, im, ip, iorb, lmtt, is1, is2, istmp
      integer :: lmt1, lmt2, im1, im2, iorb1, iorb2, lmtt1, lmtt2, im3
      integer :: tau, tau1, tau2
      real(kind=DP) :: c1, c2, ctmp
      complex(kind=CMPLDP) :: ztmp, z1, z2
      complex(kind=CMPLDP), allocatable :: dm_ssrep(:,:,:,:,:), dm(:,:,:,:,:)
      real(kind=DP), allocatable :: porb0(:,:,:,:)

      lmax = nloc;   mmax = 2*lmax -1

      allocate( dm_ssrep( ntau, lmax, mmax, mmax, ndim_chgpot ) );
      allocate( dm( ntau, lmax, mmax, mmax, ndim_magmom ) );
      allocate( porb0( ntau, lmax, mmax, ndim_magmom ) );

      do ia=1,natm
         it = ityp(ia)
         if(iproj_group(ia) == 0) cycle

         dm_ssrep = 0.0d0;  dm = 0.0d0;  porb0 = 0.d00

         ! diagonal part
         do lmt=1,ilmt_phi(it)
            il = ltp_phi(lmt,it); im  = mtp_phi(lmt,it);
            tau = taup_phi(lmt,it)
            ip  = iproj_phi(lmt,it)
            iorb = lmta_phi(lmt,ia); lmtt = lmtt_phi(lmt,it)

            Do is1=1, ndim_spinor
               Do is2=1, ndim_spinor
                  istmp = ( is1 -1 )*ndim_spinor + is2

                  ztmp = 0.0d0
                  do iopr=1,nopr
                     z1 = dcmplx( compr(i,iorb,iopr,ik+is1-1 ), &
                          &       compi(i,iorb,iopr,ik+is1-1 ) )
                     z2 = dcmplx( compr(i,iorb,iopr,ik+is2-1 ), &
                          &       compi(i,iorb,iopr,ik+is2-1 ) )
                     ztmp = ztmp + z1 *conjg(z2) &
                          &      *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt,iksnl) )
                  end do
                  dm_ssrep(tau,il,im,im,istmp) = dm_ssrep(tau,il,im,im,istmp) &
                       &                        +ztmp/dble(nopr)
               end do
            end Do
         end do
               ! non-diagonal part
         do lmt2=1,ilmt_phi(it)
            do lmt1=1,ilmt_phi(it)
               if ( lmt1 == lmt2 ) cycle
               if (ltp_phi(lmt1,it) /= ltp_phi(lmt2,it)) cycle
               if (taup_phi(lmt1,it) /= taup_phi(lmt2,it)) cycle

               il = ltp_phi(lmt1,it);     tau = taup_phi(lmt1,it)
               ip  = iproj_phi(lmt1,it)
               im1   = mtp_phi(lmt1,it);     im2 = mtp_phi(lmt2,it);
               iorb1 = lmta_phi(lmt1,ia);  iorb2 = lmta_phi(lmt2,ia)
               lmtt1 = lmtt_phi(lmt1,it);  lmtt2 = lmtt_phi(lmt2,it)

               c1 = ( qorb(iorb1) +qorb(iorb2) ) /2.0d0      ! approx
               c2 = sqrt(norm_phig_mpi(lmtt1,iksnl)*norm_phig_mpi(lmtt2,iksnl))

               Do is1=1, ndim_spinor
                  Do is2=1, ndim_spinor
                     istmp = ( is1 -1 )*ndim_spinor + is2
                     ztmp = 0.0d0
                     do iopr = 1,nopr
                        z1 = dcmplx( compr(i,iorb1,iopr,ik+is1-1 ), &
                             &       compi(i,iorb1,iopr,ik+is1-1 ) )
                        z2 = dcmplx( compr(i,iorb2,iopr,ik+is2-1 ), &
                             &       compi(i,iorb2,iopr,ik+is2-1 ) )
                        ztmp = ztmp + z1 *conjg(z2) &
                             &  *( 1.0d0 +c1 /c2 )
                     end do

                     dm_ssrep(tau,il,im1,im2,istmp) = dm_ssrep(tau,il,im1,im2,istmp) &
                          &                         + ztmp/dble(nopr)
                  end do
               end do
            end do
         end do

         dm(:,:,:,:,1) =  dm_ssrep(:,:,:,:,1) +dm_ssrep(:,:,:,:,4)
         dm(:,:,:,:,2) =  dm_ssrep(:,:,:,:,2) +dm_ssrep(:,:,:,:,3)
         dm(:,:,:,:,3) = (dm_ssrep(:,:,:,:,2) -dm_ssrep(:,:,:,:,3)) *zi
         dm(:,:,:,:,4) =  dm_ssrep(:,:,:,:,1) -dm_ssrep(:,:,:,:,4)

         ! ----
         Do tau=1, ntau
            Do il=1, lmax
               Do im1=1, mmax
                  DO is=1, ndim_magmom
                     ctmp = 0.0d0
                     Do im2=1, mmax
                        Do im3=1, mmax
                           ctmp = ctmp &
                                &    +porb_rot_matrix_real( ia,il,im2,im1 )  &
                                &       *dm(tau,il,im2,im3,is) &
                                &       *porb_rot_matrix_real( ia,il,im3,im1 )
                        End Do
                     End Do
                     porb0( tau, il, im1, is ) = ctmp
                  End DO
               End DO
            End Do
         End Do

         Do lmt=1,ilmt_phi(it)
            il = ltp_phi(lmt,it);  im  = mtp_phi(lmt,it);  iorb = lmta_phi(lmt,ia)
            tau = taup_phi(lmt,it)
            porb_out( iorb,1:ndim_magmom ) = porb0( tau, il,im,1:ndim_magmom )
         ENd do
      End do
      deallocate( dm ); deallocate( dm_ssrep ); deallocate( porb0 )

    end subroutine set_porb_rot_mode1

    subroutine set_porb_rot_mode2( porb_out )
      real(kind=DP), intent(out) :: porb_out(num_orbitals, ndim_magmom )

      integer :: lmax, mmax, iopr
      integer :: ia, it, lmt, il, im, ip, iorb, lmtt, is1, is2, istmp
      integer :: lmt1, lmt2, im1, im2, iorb1, iorb2, lmtt1, lmtt2, im3
      integer :: tau, tau1, tau2, is3, immax
      real(kind=DP) :: c1, c2
      complex(kind=CMPLDP) :: ztmp, z1, z2, z3
      complex(kind=CMPLDP), allocatable :: dm_ssrep(:,:,:,:,:)
      real(kind=DP), allocatable :: porb0(:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwk(:,:)
      complex(kind=CMPLDP) :: PauliMatrix( ndim_magmom, ndim_spinor, ndim_spinor )

      lmax = nloc;   mmax = 2*lmax -1

      allocate( dm_ssrep( ntau, lmax, mmax, mmax, ndim_chgpot ) );
      allocate( porb0( ntau, lmax, mmax*ndim_spinor, ndim_magmom ) );
      allocate( zwk( mmax*ndim_spinor, mmax*ndim_spinor ) );

      call m_ES_set_Pauli_Matrix( PauliMatrix )

      do ia=1,natm
         it = ityp(ia)
         if(iproj_group(ia) == 0) cycle

         dm_ssrep = 0.0d0;  porb0 = 0.d00

         ! diagonal part
         do lmt=1,ilmt_phi(it)
            il = ltp_phi(lmt,it); im  = mtp_phi(lmt,it);
            tau = taup_phi(lmt,it)
            ip  = iproj_phi(lmt,it); lmtt = lmtt_phi(lmt,it)
            iorb = lmta_phi(lmt,ia)

            Do is1=1, ndim_spinor
               Do is2=1, ndim_spinor
                  istmp = ( is1 -1 )*ndim_spinor + is2

                  ztmp = 0.0d0
                  do iopr=1,nopr
                     z1 = dcmplx( compr(i,iorb,iopr,ik+is1-1 ), &
                          &       compi(i,iorb,iopr,ik+is1-1 ) )
                     z2 = dcmplx( compr(i,iorb,iopr,ik+is2-1 ), &
                          &       compi(i,iorb,iopr,ik+is2-1 ) )
                     ztmp = ztmp + z1 *conjg(z2) &
                          &      *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt,iksnl) )
                  end do
                  dm_ssrep(tau,il,im,im,istmp) = dm_ssrep(tau,il,im,im,istmp) &
                       &                       +ztmp/dble(nopr)
               end do
            end Do
         end do
               ! non-diagonal part
         do lmt2=1,ilmt_phi(it)
            do lmt1=1,ilmt_phi(it)
               if ( lmt1 == lmt2 ) cycle
               if (ltp_phi(lmt1,it) /= ltp_phi(lmt2,it)) cycle
               if (taup_phi(lmt1,it) /= taup_phi(lmt2,it)) cycle

               il = ltp_phi(lmt1,it);     tau = taup_phi(lmt1,it)
               ip  = iproj_phi(lmt1,it)
               im1   = mtp_phi(lmt1,it);     im2 = mtp_phi(lmt2,it);
               iorb1 = lmta_phi(lmt1,ia);  iorb2 = lmta_phi(lmt2,ia)
               lmtt1 = lmtt_phi(lmt1,it);  lmtt2 = lmtt_phi(lmt2,it)

               c1 = ( qorb(iorb1) +qorb(iorb2) ) /2.0d0      ! approx
               c2 = sqrt(norm_phig_mpi(lmtt1,iksnl)*norm_phig_mpi(lmtt2,iksnl))

               Do is1=1, ndim_spinor
                  Do is2=1, ndim_spinor
                     istmp = ( is1 -1 )*ndim_spinor + is2
                     ztmp = 0.0d0
                     do iopr = 1,nopr
                        z1 = dcmplx( compr(i,iorb1,iopr,ik+is1-1 ), &
                             &       compi(i,iorb1,iopr,ik+is1-1 ) )
                        z2 = dcmplx( compr(i,iorb2,iopr,ik+is2-1 ), &
                             &       compi(i,iorb2,iopr,ik+is2-1 ) )
                        ztmp = ztmp + z1 *conjg(z2) &
                             &  *( 1.0d0 +c1 /c2 )
                     end do
                     dm_ssrep(tau,il,im1,im2,istmp) = dm_ssrep(tau,il,im1,im2,istmp) &
                          &                         + ztmp/dble(nopr)
                  end do
               end do
            end do
         end do

         Do tau=1, ntau
            Do il=1, lmax
               immax = 2 *il -1
               Do is=1, ndim_magmom
                  zwk = 0.0d0

                  Do im1=1, immax
                     Do im2=1, immax
                        Do is1=1, ndim_spinor
                           Do is2=1, ndim_spinor
                              ztmp = 0.0d0
                              Do is3=1, ndim_spinor
                                 istmp = ( is1 -1 )*ndim_spinor + is3
                                 ztmp = ztmp +dm_ssrep(tau,il,im1,im2,istmp) &
                                      &      *PauliMatrix(is,is3,is2)
                              End Do
                              zwk(im1+immax*(is1-1),im2+immax*(is2-1)) = ztmp
                           End Do
                        End Do
                     End Do
                  ENd Do
                  Do im1=1, immax *ndim_spinor
                     ztmp = 0.0d0
                     DO is2=1, ndim_spinor
                        DO is3=1, ndim_spinor
                           Do im2=1, immax
                              Do im3=1, immax
                                 z1 = porb_rot_matrix_cmplx(ia,il,immax*(is2-1)+im2,im1)
                                 z2 = zwk(immax*(is2-1)+im2,immax*(is3-1)+im3)
                                 z3 = porb_rot_matrix_cmplx(ia,il,immax*(is3-1)+im3,im1)
                                 ztmp = ztmp +conjg(z1) *z2 *z3
                              End Do
                           End Do
                        End Do
                     End DO
                     porb0( tau, il, im1, is ) = ztmp
                  End Do
               End Do
            End Do
         End Do
         Do lmt=1,ilmt_phi(it)
            il = ltp_phi(lmt,it);  im  = mtp_phi(lmt,it);  iorb = lmta_phi(lmt,ia)
            tau = taup_phi(lmt,it)
            Do is=1, ndim_spinor
               porb_out( (iorb-1)*ndim_spinor+is,1:ndim_magmom ) &
                    &    = porb0( tau,il,(im-1)*ndim_spinor+is,1:ndim_magmom )
            ENd do
         End Do
      End do
      deallocate(dm_ssrep); deallocate(porb0);    deallocate(zwk)

    end subroutine set_porb_rot_mode2

  end subroutine mkdos_with_GaussDistrib_noncl
! =================================================================== 11.0

! ====================== KT_add ======================= 13.0E
  subroutine make_dos_with_FDiracDistrib( kv, iwsc, kpt_weight )
    integer, intent(in) :: kv, iwsc
    real(kind=DP), intent(in) :: kpt_weight( kv )

    integer ::             i, ik, is, ie, id, ispin, iorb, iopr, lmtt, iksnl
    real(kind=DP) ::       Es, e, Ene1, c1, c2, w, DeltaE
    real(kind=DP) ::       porb

    DeltaE = DeltaE_dos
    Es = Eminimum - DeltaE*0.5d0

!    width_fermi_dirac = width

    if(ipridos >= 2) write(nfout,'(" !! Es, DeltaE = ",2d20.10)') Es, DeltaE
    dos = 0.d0; sumdos = 0.d0
    if(iwsc == TOTAL .and. sw_pdos == ON) then
       pdos=0.d0; sumpdos=0.d0
    end if
    do ispin = 1, nspin
       do ik = ispin, kv, nspin
          iksnl = (ik-1)/nspin + 1
          do i = 1, neg
             w = 1.d0
             if(iwsc >= 1 ) w = dos_weight(i,ik)
             e = eko(i,ik) - nETailWindows*DeltaE - Es
             is = e/DeltaE
             ie = is + 2*nETailWindows
             if(is < 0) then
                if(ipridos >= 2) write(nfout,'(" is = ",i5," < 0")') is
                is = 0
             end if
             if(ie >= nEWindows ) then
                if(ipridos >= 2) write(nfout,'(" ie = ",i5, " > nEWindows")')ie
                ie = nEWindows-1
             end if
             if(ipridos >= 2) then
                write(nfout,'(" !! eko(",i3,",",i3,") = ",f10.6," is, ie = ",2i7, 2f10.6)') &
                     & i,ik, eko(i,ik),is,ie, Es+is*DeltaE, Es+ie*DeltaE
             end if

             do id = is, ie
                ene1 = Es +id*DeltaE
                call width_fermi_dirac( ene1, eko(i,ik), smearing_width_fdirac, c1, c2 )
!!!                dos(id+1,ispin) = dos(id+1,ispin) + w *c1 *2.0d0 /dble(kv)
                dos(id+1,ispin) = dos(id+1,ispin) + w *c1 *2.0d0 *kpt_weight(ik)
             end do
             if(iwsc == TOTAL .and. sw_pdos == ON) then
                do iorb = 1,nlmta_phi
                   call m_PP_tell_iorb_lmtt(iorb,lmtt)
                   porb = 0.d0
!!$ASASASASAS
!!$                do iopr=1,nopr
!!$                   porb = porb + (compr(i,iorb,iopr,ik)**2 &
!!$                        &       + compi(i,iorb,iopr,ik)**2) &
!!$                        &     *(1.d0+qorb(iorb)/norm_phig_mpi(lmt,iksnl))
!!$                end do
                   if ( k_symmetry(ik) == GAMMA ) then
                      do iopr=1,nopr
                         porb = porb + compr(i,iorb,iopr,ik)**2  /2.0 &
                              &     *(1.d0+qorb(iorb)/(norm_phig_mpi(lmtt,iksnl)*2.) )
                      end do
                   else
                      do iopr=1,nopr
                         porb = porb + (compr(i,iorb,iopr,ik)**2 &
                              &       + compi(i,iorb,iopr,ik)**2) &
                              &     *(1.d0+qorb(iorb)/norm_phig_mpi(lmtt,iksnl))
                      end do
                   endif
!!$ASASASASAS
                   porb = porb/dble(nopr)
                   do id = is, ie
                      ene1 = Es +id*DeltaE
                      call width_fermi_dirac( ene1, eko(i,ik), &
                           &                  smearing_width_fdirac, c1, c2  )
                      pdos(id+1,iorb,ispin) = pdos(id+1,iorb,ispin) &
!!!                           & + porb *w *c1 *2.0d0 /dble(kv)
                           & + porb *w *c1 *2.0d0 *kpt_weight(ik)
                   end do
                end do
             end if
          end do
       end do
       sumdos(1,ispin) = dos(1,ispin)*DeltaE
       do id = 1, nEWindows-1
          sumdos(id+1,ispin) = sumdos(id,ispin) + dos(id+1,ispin)*DeltaE
       end do
       if(iwsc == TOTAL .and. sw_pdos == ON) then
          do iorb = 1,nlmta_phi
             sumpdos(1,iorb,ispin) = pdos(1,iorb,ispin)*DeltaE
             do id = 1, nEWindows-1
                sumpdos(id+1,iorb,ispin) = sumpdos(id,iorb,ispin) + pdos(id+1,iorb,ispin)*DeltaE
             end do
          end do
       end if
    end do
  end subroutine make_dos_with_FDiracDistrib
! =============================================================== 13.0E

  subroutine get_VBM(total_charge,deltad)
    real(kind=DP), intent(in) :: total_charge, deltad
    integer :: i
    logical :: found
    found = .false.
    i = nEWindows

    if(check_if_metalic_flag .and. .not.metalic_system) then
          ValenceBandMaximum = vbm
          if(ipridos >= 1) then
             if(dabs(ValenceBandMaximum) < 1.d6) then
                write(nfout,'(" ValenceBandMaximum = vbm = ",f12.4," total_charge = ",f12.4 &
                     & ," (m_ES_dos.get_VBM)")') ValenceBandMaximum,total_charge
             else
                write(nfout,'(" ValenceBandMaximum is not calculated")')
             end if
          end if
    else
! ============================== modified by K. Tagami ================ 11.0
!       if(nspin == 1) then
!          do while(.not.found.and.i >= 1)
!             i = i - 1
!             if(sumdos(i,nspin) < total_charge - deltad) found = .true.
!          end do
!       else if(nspin == 2) then
!          do while(.not.found.and.i<= nEWindows)
!             i = i - 1
!             if(sumdos(i,1)+sumdos(i,2) < total_charge - deltad) found = .true.
!          end do
!       end if

       if ( noncol ) then
          do while(.not.found.and.i >= 1)
             i = i - 1
             if(sumdos(i,1) < total_charge - deltad) found = .true.
          end do
       else
          if(nspin == 1) then
             do while(.not.found.and.i >= 1)
                i = i - 1
                if(sumdos(i,nspin) < total_charge - deltad) found = .true.
             end do
          else if(nspin == 2) then
             do while(.not.found.and.i<= nEWindows)
                i = i - 1
                if(sumdos(i,1)+sumdos(i,2) < total_charge - deltad) found = .true.
             end do
          end if
       endif
! ========================================================================= 11.0

       ValenceBandMaximum = Eminimum + i*DeltaE_dos
       if(ipridos >= 1) then
          write(nfout,'(" ValenceBandMaximum = ",f12.4, " i = ",i5," DeltaE_dos = ",d13.5 &
               & ," total_charge = ",f12.4," (m_ES_dos.get_VBM)")') &
               & ValenceBandMaximum,i,DeltaE_dos,total_charge
       end if
    end if

  end subroutine get_VBM

  subroutine write_dos(nf)
    integer, intent(in) :: nf
    integer       :: i, ii, nwdwidth, id, nrEWindows
    real(kind=DP) :: e,e_eV, dos_hr, dos_hr2, dos_eV, dos_eV2 &
         & , sumtotal, sumdos_avr, sumdos_avr2

    if(nwd_dos_window_width >= 1 .and. nwd_dos_window_width <= nEWindows) then
       nwdwidth = nwd_dos_window_width
    else
       nwdwidth = 1
    end if
    id = nwdwidth/2
    nrEWindows = nEWindows/nwdwidth * nwdwidth


    if(nspin == 1) then
       if(dos_write_format == WIDE) then
          write(nf,'("  No.   E(hr.)        dos(hr.)         E(eV)          dos(eV)              sum")')
       else if(dos_write_format == NARROW) then
          write(nf,'("  No.   E(hr.)    dos(hr.)       E(eV)          dos(eV)    sum")')
       else if(dos_write_format == eVunit) then
          write(nf,'("  No.   E(eV)          dos(eV)    sum")')
       end if
       do i = 1, nrEWindows, nwdwidth
          e = Eminimum + (i-1+id)*DeltaE_dos
          e_eV = (e - ValenceBandMaximum)*Hartree
          dos_hr = 0.d0; sumdos_avr = 0.d0
          do ii = i, i+nwdwidth-1
             dos_hr = dos_hr + dos(ii,nspin)
             sumdos_avr = sumdos_avr + sumdos(ii,nspin)
          end do
          dos_hr = dos_hr/nwdwidth; sumdos_avr = sumdos_avr/nwdwidth
!!$          dos_eV = dos(i,nspin)/Hartree
          dos_eV = dos_hr/Hartree
          if(dos_write_format == WIDE) then
             write(nf,'(i7,f10.5,f18.10,f14.6,f18.10,f20.10)') i+id, e, dos_hr &
                  & , e_eV, dos_eV, sumdos_avr
          else if(dos_write_format == NARROW) then
             write(nf,'(i7,f9.4,f16.8,f12.4,f16.10,f10.4)') i+id, e, dos_hr &
                  & , e_eV, dos_eV, sumdos_avr
          else if(dos_write_format == eVunit) then
             write(nf,'(i7,f12.4,f18.10,f10.4)') i+id, e_eV, dos_eV, sumdos_avr
          end if
       end do
    else if(nspin == 2) then
       if(dos_write_format == WIDE) then
          write(nf,'(1x,a47,5x,a45,6x,a27)') "No.  E(hr.)    dos_up(hr.)       dos_down(hr.)" &
               & ,"E(eV)         dos_up(eV)        dos_down(eV)" &
               & ,"sum_up   sum_down sum_total"
       else if(dos_write_format == NARROW) then
          write(nf,'(1x,a39,2x,a40,2x,a27)') "No.  E(hr.) dos_up(hr.)  dos_down(hr.)" &
               & ,"E(eV)       dos_up(eV)      dos_down(eV)" &
               & ,"sum_up   sum_down sum_total"
       else if(dos_write_format == eVunit) then
          write(nf,'(1x,a54,3x,a28)') "No.       E(eV)         dos_up(eV)        dos_down(eV)" &
               & ,"sum_up   sum_down  sum_total"
       end if
       do i = 1, nrEWindows, nwdwidth
          e = Eminimum + (i-1+id)*DeltaE_dos
          e_eV = (e - ValenceBandMaximum)*Hartree
          dos_hr = 0.d0; dos_hr2 = 0.d0;  sumdos_avr = 0.d0; sumdos_avr2 = 0.d0
          do ii = i, i+nwdwidth-1
             dos_hr  = dos_hr + dos(ii,1)
             dos_hr2 = dos_hr2 + dos(ii,2)
             sumdos_avr  = sumdos_avr  + sumdos(ii,1)
             sumdos_avr2 = sumdos_avr2 + sumdos(ii,2)
          end do
          dos_hr = dos_hr/nwdwidth; dos_hr2 = dos_hr2/nwdwidth
          sumdos_avr = sumdos_avr/nwdwidth; sumdos_avr2 = sumdos_avr2/nwdwidth
!!$          dos_eV  = dos(i,1)/Hartree
!!$          dos_eV2 = dos(i,2)/Hartree
!!$          sumtotal = sumdos(i,1) + sumdos(i,2)
          dos_eV  = dos_hr/Hartree
          dos_eV2 = dos_hr2/Hartree
          sumtotal = sumdos_avr + sumdos_avr2
          if(dos_write_format== WIDE) then
             write(nf,'(i7,f9.4,2f18.10,f15.4,2f18.10,3f10.4)') &
                  & i, e, dos_hr,dos_hr2,e_eV, dos_eV, dos_eV2, sumdos_avr,sumdos_avr2,sumtotal
          else if(dos_write_format == NARROW) then
             write(nf,'(i7,f9.4,2f14.6, f12.4,2f14.8,3f10.4)') &
                  & i, e, dos_hr,dos_hr2,e_eV, dos_eV, dos_eV2, sumdos_avr,sumdos_avr2,sumtotal
          else if(dos_write_format == eVunit) then
             write(nf,'(i7,f12.4,2f18.10,3f10.4)') i, e_eV, dos_eV, dos_eV2, sumdos_avr,sumdos_avr2,sumtotal
          end if
       end do
    end if
    write(nf,'("END")')
  end subroutine write_dos

! ================================== added by K. Tagami ================= 11.0
  subroutine write_dos_noncl(nf)
    integer, intent(in) :: nf
    integer       :: i, ii, nwdwidth, id, nrEWindows

    real(kind=DP) :: dos_hr( ndim_magmom ), sumdos_avr( ndim_magmom )
    real(kind=DP) :: dos_eV( ndim_magmom )
    real(kind=DP) :: e, e_eV
    real(kind=DP) :: sumtotal

    if(nwd_dos_window_width >= 1 .and. nwd_dos_window_width <= nEWindows) then
       nwdwidth = nwd_dos_window_width
    else
       nwdwidth = 1
    end if
    id = nwdwidth/2

    nrEWindows = nEWindows/nwdwidth * nwdwidth

    write(nf,'(2x,A,5x,A,4x,A)') "No.      E(eV)",&
         &     "  dos_chg(eV)    dos_mx(eV)    dos_my(eV)    dos_mz(eV)", &
         &      "sum_chg     sum_mx      sum_my      sum_mz"

    do i = 1, nrEWindows, nwdwidth
       e = Eminimum + (i-1+id)*DeltaE_dos
       e_eV = (e - ValenceBandMaximum)*Hartree

       dos_hr = 0.d0; sumdos_avr = 0.d0
       do ii = i, i+nwdwidth-1
          dos_hr(:) = dos_hr(:) + dos(ii,:)
          sumdos_avr(:) = sumdos_avr(:) + sumdos(ii,:)
       end do

       dos_hr = dos_hr/nwdwidth; sumdos_avr = sumdos_avr/nwdwidth
       dos_eV = dos_hr/Hartree

       write(nf,'(i5,f14.8,4f14.8,4f12.6)') &
               & i, e_eV, dos_eV(1:ndim_magmom), sumdos_avr(1:ndim_magmom)
!       write(nf,*) &
!               & i, e_eV, dos_eV(1:ndim_magmom), sumdos_avr(1:ndim_magmom)
    end do

    write(nf,'("END")')
  end subroutine write_dos_noncl

  subroutine write_dos_noncl_for_totchg(nf)

    integer, intent(in) :: nf
    integer       :: i, ii, nwdwidth, id, nrEWindows
    real(kind=DP) :: e,e_eV, dos_hr, dos_hr2, dos_eV, dos_eV2 &
         & , sumtotal, sumdos_avr, sumdos_avr2

    if(nwd_dos_window_width >= 1 .and. nwd_dos_window_width <= nEWindows) then
       nwdwidth = nwd_dos_window_width
    else
       nwdwidth = 1
    end if
    id = nwdwidth/2

    nrEWindows = nEWindows/nwdwidth * nwdwidth

    write(nf,'("     No.   E(hr.)        dos(hr.)         E(eV)          dos(eV)              sum")')

    do i = 1, nrEWindows, nwdwidth
       e = Eminimum + (i-1+id)*DeltaE_dos
       e_eV = (e - ValenceBandMaximum)*Hartree
       dos_hr = 0.d0; sumdos_avr = 0.d0

       do ii = i, i+nwdwidth-1
          dos_hr = dos_hr + dos(ii,1)
          sumdos_avr = sumdos_avr + sumdos(ii,1)
       end do

       dos_hr = dos_hr/nwdwidth; sumdos_avr = sumdos_avr/nwdwidth
       dos_eV = dos_hr/Hartree

       write(nf,'(i7,f10.5,f18.10,f14.6,f18.10,f20.10)') i+id, e, dos_hr &
            & , e_eV, dos_eV, sumdos_avr
    end do

    write(nf,'("END")')
  end subroutine write_dos_noncl_for_totchg
! ======================================================================== 11.0

  subroutine write_pdos(nf)
    integer, intent(in) :: nf

    integer :: iorb

    do iorb=1,nlmta_phi
       call write_pdos_orbital(nf,iorb)
!!$ASASASASAS
!!$       write(nf,'("END")')
!!$ASASASASAS
    end do

  end subroutine write_pdos

! =================================== added by K. Tagami =============== 11.0
  subroutine write_pdos_noncl(nf)
    integer, intent(in) :: nf
    integer :: iorb, kfac, num_orbitals

    kfac = 1
    if ( sw_diagonalize_population == ON ) then
       if ( population_diag_mode /= DIAG_CHARGE_DENSITY_MATRIX &
            & .and. population_diag_mode /= LOCAL_POINT_GROUP ) then
          kfac = ndim_spinor
       endif
    endif
    num_orbitals = nlmta_phi *kfac

    do iorb=1,num_orbitals
       call write_pdos_orbital_noncl(nf,iorb)
    end do

  end subroutine write_pdos_noncl
! ========================================================================= 11.0

  subroutine write_pdos_orbital(nf,iorb)
    integer, intent(in) :: nf
    integer, intent(in) :: iorb
    integer :: ia,il,im,tau,nspher
    integer       :: i, ii, nwdwidth, id, nrEWindows
    real(kind=DP) :: e,e_eV, dos_hr, dos_hr2, dos_eV, dos_eV2 &
         & , sumtotal, sumdos_avr, sumdos_avr2

    if(nwd_dos_window_width >= 1 .and. nwd_dos_window_width <= nEWindows) then
       nwdwidth = nwd_dos_window_width
    else
       nwdwidth = 1
    end if
    id = nwdwidth/2
    nrEWindows = nEWindows/nwdwidth * nwdwidth

    call m_PP_tell_iorb_ia_l_m_tau(iorb,ia,il,im,tau)
!!$ASASASASAS
    if ( iproj_group(ia)== 0 ) return
!!$ASASASASAS
    if ( if_pdos(ia) == 0 ) return
    if ( sw_diagonalize_population == ON ) then
       write(nf,'("PDOS: ia= ",i0," l=",i3," m''=",i3," t=",i3)') ia,il-1,im,tau
    else
       write(nf,'("PDOS: ia= ",i0," l=",i3," m=",i3," t=",i3)') ia,il-1,im,tau
    endif

    if(nspin == 1) then
       if(dos_write_format == WIDE .or. dos_write_format == NARROW) then
          write(nf,'("  No.   E(hr.)        dos(hr.)         E(eV)          dos(eV)              sum")')
       else if(dos_write_format == eVunit) then
          write(nf,'("  No.   E(eV)          dos(eV)              sum")')
       end if
       do i = 1, nrEWindows, nwdwidth
          e = Eminimum + (i-1+id)*DeltaE_dos
          e_eV = (e - ValenceBandMaximum)*Hartree
          dos_hr = 0.d0; sumdos_avr = 0.d0
          do ii = i, i+nwdwidth-1
             dos_hr = dos_hr + pdos(ii,iorb,nspin)
             sumdos_avr = sumdos_avr + sumpdos(ii,iorb,nspin)
          end do
          dos_hr = dos_hr/nwdwidth; sumdos_avr = sumdos_avr/nwdwidth
          dos_eV = dos_hr/Hartree
          if(dos_write_format == WIDE) then
             write(nf,'(i7,f10.5,f18.10,f14.6,f18.10,f20.10)') i+id, e, dos_hr &
                  & , e_eV, dos_eV, sumdos_avr
          else if(dos_write_format == NARROW) then
             write(nf,'(i7,f9.4,f16.8,f12.4,f16.10,f10.4)') i+id, e, dos_hr, e_eV, dos_eV, sumdos_avr
          else if(dos_write_format == eVunit) then
             write(nf,'(i7,f14.6,f18.10,f10.4)') i+id,e_eV,dos_eV,sumdos_avr
          end if
       end do
    else if(nspin == 2) then
       if(dos_write_format == WIDE .or. dos_write_format == NARROW) then
          write(nf,'(1x,a47,5x,a45,6x,a27)') "No.  E(hr.)    dos_up(hr.)       dos_down(hr.)" &
               & ,"E(eV)         dos_up(eV)        dos_down(eV)" &
               & ,"sum_up   sum_down sum_total"
       else if(dos_write_format == eVunit) then
          write(nf,'(1x,a54,3x,       a28)') "No.       E(eV)         dos_up(eV)        dos_down(eV)" &
               & ,"sum_up   sum_down  sum_total"
      end if
       do i = 1, nrEWindows, nwdwidth
          e = Eminimum + (i-1+id)*DeltaE_dos
          e_eV = (e - ValenceBandMaximum)*Hartree
          dos_hr = 0.d0; dos_hr2 = 0.d0;  sumdos_avr = 0.d0; sumdos_avr2 = 0.d0
          do ii = i, i+nwdwidth-1
             dos_hr  = dos_hr + pdos(ii,iorb,1)
             dos_hr2 = dos_hr2 + pdos(ii,iorb,2)
             sumdos_avr  = sumdos_avr  + sumpdos(ii,iorb,1)
             sumdos_avr2 = sumdos_avr2 + sumpdos(ii,iorb,2)
          end do
          dos_hr = dos_hr/nwdwidth; dos_hr2 = dos_hr2/nwdwidth
          sumdos_avr = sumdos_avr/nwdwidth; sumdos_avr2 = sumdos_avr2/nwdwidth
          dos_eV  = dos_hr/Hartree
          dos_eV2 = dos_hr2/Hartree
          sumtotal = sumdos_avr + sumdos_avr2
          if(dos_write_format == WIDE) then
             write(nf,'(i7,f9.4,2f18.10,f15.4,2f18.10,3f10.4)') &
                  & i, e, dos_hr,dos_hr2,e_eV, dos_eV, dos_eV2, sumdos_avr,sumdos_avr2,sumtotal
          else if(dos_write_format == NARROW) then
             write(nf,'(i7,f9.4,2f14.6,f12.4,2f14.8,3f10.4)') &
                  & i, e, dos_hr,dos_hr2,e_eV, dos_eV, dos_eV2, sumdos_avr,sumdos_avr2,sumtotal
          else if(dos_write_format == eVunit) then
             write(nf,'(i7,f12.4,2f18.10,3f10.4)') i, e_eV, dos_eV, dos_eV2, sumdos_avr,sumdos_avr2,sumtotal
          end if
       end do
    end if
!!$ASASASASAS
    write(nf,'("END")')
!!$ASASASASAS
  end subroutine write_pdos_orbital

! ================================= added by K. Tagami ==================== 11.0
  subroutine write_pdos_orbital_noncl(nf,iorb)
    integer, intent(in) :: nf
    integer, intent(in) :: iorb
    integer :: ia,il,im,tau,nspher
    integer       :: i, ii, nwdwidth, id, nrEWindows

    real(kind=DP) :: dos_hr( ndim_magmom ), sumdos_avr( ndim_magmom )
    real(kind=DP) :: dos_eV( ndim_magmom )
    real(kind=DP) :: e, e_eV

    integer :: kfac, iorb0, im0, my_l
    real(kind=DP) :: val_j, val_mj

    if(nwd_dos_window_width >= 1 .and. nwd_dos_window_width <= nEWindows) then
       nwdwidth = nwd_dos_window_width
    else
       nwdwidth = 1
    end if
    id = nwdwidth/2

    nrEWindows = nEWindows/nwdwidth * nwdwidth

    kfac = 1
    if ( sw_diagonalize_population == ON ) then
       if ( population_diag_mode /= DIAG_CHARGE_DENSITY_MATRIX &
            & .and. population_diag_mode /= LOCAL_POINT_GROUP ) then
          kfac = ndim_spinor
       endif
    endif

    iorb0 = int( (iorb-1)/kfac )+1
    call m_PP_tell_iorb_ia_l_m_tau(iorb0,ia,il,im0,tau)
    im = ( im0 -1 )*kfac +mod( iorb-1, kfac ) +1

    if ( iproj_group(ia)== 0 ) return

    if ( if_pdos(ia) == 0 ) return

    if ( sw_diagonalize_population == ON ) then
       if ( population_diag_mode == DIAG_LS ) then
          my_l = il -1
          if ( my_l > 0 ) then
             if ( im <= 2*my_l ) then
                val_j = my_l -0.5d0;    val_mj = -val_j +(im -1)
             else
                val_j = my_l +0.5d0;    val_mj = -val_j +(im -2*my_l -1)
             endif
          else
             val_j = my_l +0.5d0;       val_mj = -val_j +(im -2*my_l -1)
          endif
       endif
    endif
! ---
    if ( sw_diagonalize_population == ON ) then
       if ( population_diag_mode == DIAG_CHARGE_DENSITY_MATRIX &
            &  .or. population_diag_mode == LOCAL_POINT_GROUP ) then
          write(nf,'("PDOS: ia= ",i0," l=",i3," m''=",i3," t=",i3)') ia,il-1,im,tau
       else if ( population_diag_mode == DIAG_LS ) then
          write(nf,'(A,I0,A,I3,A,I3,A,I3,A,F4.1,A,F4.1,A)') &
               &   "PDOS: ia= ", ia, " l=", il -1," ms''=",im," t=",tau, &
               &   "                 ( j= ", val_j, "  mj= ", val_mj, " )"
       else
          write(nf,'("PDOS: ia= ",i0," l=",i3," ms''=",i3," t=",i3)') ia,il-1,im,tau
       endif
    else
       write(nf,'("PDOS: ia= ",i0," l=",i3," m=",i3," t=",i3)') ia,il-1,im,tau
    endif

    if ( sw_diagonalize_population == ON .and. use_rotated_compri == YES &
         &   .and. population_diag_mode /= DIAG_CHARGE_DENSITY_MATRIX ) then
       write(nf,'(2x,A,5x,A,4x,A)') "No.      E(eV)",&
            &     "  dos(eV)", &
            &      "sum"
    else
       write(nf,'(2x,A,5x,A,4x,A)') "No.      E(eV)",&
            &     "  dos_chg(eV)    dos_mx(eV)    dos_my(eV)    dos_mz(eV)", &
            &      "sum_chg     sum_mx      sum_my      sum_mz"
    endif

    do i = 1, nrEWindows, nwdwidth
       e = Eminimum + (i-1+id)*DeltaE_dos
       e_eV = (e - ValenceBandMaximum)*Hartree

       dos_hr = 0.0d0; sumdos_avr = 0.0d0
       do ii = i, i+nwdwidth-1
          dos_hr(:)  = dos_hr(:) + pdos(ii,iorb,:)
          sumdos_avr(:)  = sumdos_avr(:)  + sumpdos(ii,iorb,:)
       end do

       dos_hr = dos_hr/nwdwidth;         sumdos_avr = sumdos_avr/nwdwidth;
       dos_eV  = dos_hr/Hartree;

       if ( sw_diagonalize_population == ON .and. use_rotated_compri == YES &
            &   .and. population_diag_mode /= DIAG_CHARGE_DENSITY_MATRIX ) then
          write(nf,'(i5,f14.8,1f14.8,1f12.6)') &
               & i, e_eV, dos_eV(1), sumdos_avr(1)
       else
          write(nf,'(i5,f14.8,4f14.8,4f12.6)') &
               & i, e_eV, dos_eV(1:ndim_magmom), sumdos_avr(1:ndim_magmom)
       endif
    end do

    write(nf,'("END")')
  end subroutine write_pdos_orbital_noncl
! ========================================================================= 11.0

  subroutine m_ESdos_gaussdistrib(nfdos,icomponent)
    integer, intent(in) ::      nfdos, icomponent

    call alloc_eko_and_substitution(kv3) ! eko_l -> eko
    call find_Erange(eko,neg,kv3)
    call alloc_dos(1,icomponent)
    call make_dos_with_GaussianDistrib( kv3, icomponent, qwgt )
    if(icomponent == TOTAL) call get_VBM(totch,DeltaDVBM)
    if(mype == 0) call write_dos(nfdos)
!!$    call write_dos(nfout)
    if(mype == 0 .and. icomponent == TOTAL .and. sw_pdos == ON) then
       call write_pdos(nfdos)
    end if
! ---
    if ( sw_calc_pcohp == ON ) call m_ES_calc_pcohp
! ---
    call dealloc_eko()
    call dealloc_dos()
  end subroutine m_ESdos_gaussdistrib

! ================================ added by K. Tagami =================== 11.0
  subroutine m_ESdos_gaussdistrib_noncl(nfdos,icomponent)
    integer, intent(in) ::      nfdos, icomponent

    call alloc_eko_and_substit_noncl(kv3) ! eko_l -> eko
    call find_Erange( eko, neg, kv3/ndim_spinor )
    call alloc_dos(1,icomponent)

    call mkdos_with_GaussDistrib_noncl( kv3, icomponent, qwgt )
    if(icomponent == TOTAL) call get_VBM(totch,DeltaDVBM)

    if(mype == 0) then
       if ( calc_dos_magmom_contrib == YES ) then
          call write_dos_noncl(nfdos)
       else
          call write_dos_noncl_for_totchg(nfdos)
       endif
    endif

    if(mype == 0 .and. icomponent == TOTAL .and. sw_pdos == ON) then
       call write_pdos_noncl(nfdos)
    end if

    call dealloc_eko()
    call dealloc_dos()
  end subroutine m_ESdos_gaussdistrib_noncl
! ======================================================================= 11.0

  subroutine m_ESdos_gaussdistrib_ek(nfdos,icomponent)
    integer, intent(in) ::      nfdos, icomponent

    call alloc_eko_and_substitution_ek(kv3_ek) ! eko_ek -> eko
    call find_Erange(eko,neg,kv3_ek)
    call alloc_dos(1,icomponent)
    if(icomponent == TOTAL .and. sw_pdos == ON) then
       call pdos_ek()
       call m_ES_dos_gather_compr_compi_ek()
    endif
    call make_dos_with_GaussianDistrib( kv3_ek, icomponent, qwgt_ek )
    if(icomponent == TOTAL) call get_VBM(totch,DeltaDVBM)
    if(mype == 0) call write_dos(nfdos)
    if(mype == 0 .and. icomponent == TOTAL .and. sw_pdos == ON) then
       call write_pdos(nfdos)
    end if
    call dealloc_eko()
    call dealloc_dos()
  end subroutine m_ESdos_gaussdistrib_ek

! ==================================== added by K. Tagami ================ 11.0
  subroutine m_ESdos_gaussdistrib_ek_noncl(nfdos,icomponent)
    integer, intent(in) ::      nfdos, icomponent

    call alloc_eko_and_substit_ek_noncl(kv3_ek) ! eko_ek -> eko
    call find_Erange(eko,neg,kv3_ek/ndim_spinor)
    call alloc_dos(1,icomponent)
    if(icomponent == TOTAL .and. sw_pdos == ON) then
       call pdos_ek()
       call m_ES_dos_gather_compr_compi_ek()
    endif

    call mkdos_with_GaussDistrib_noncl( kv3_ek, icomponent, qwgt_ek )
    if(icomponent == TOTAL) call get_VBM(totch,DeltaDVBM)

    if(mype == 0) then
       if ( calc_dos_magmom_contrib == YES ) then
          call write_dos_noncl(nfdos)
       else
          call write_dos_noncl_for_totchg(nfdos)
       endif
    endif

    call dealloc_eko()
    call dealloc_dos()
  end subroutine m_ESdos_gaussdistrib_ek_noncl
! ========================================================================= 11.0

! ==================- KT_add ================= 13.0E
  subroutine m_ESdos_FdiracDistrib(nfdos,icomponent)
    integer, intent(in) ::      nfdos, icomponent

    call alloc_eko_and_substitution(kv3) ! eko_l -> eko
    call find_Erange_fermidirac(eko,neg,kv3)

    call alloc_dos(1,icomponent)
    call make_dos_with_FDiracDistrib( kv3, icomponent, qwgt )

!!!    if(icomponent == TOTAL) call get_VBM(totch,DeltaDVBM)
    if(icomponent == TOTAL) then
       ValenceBandMaximum = efermi
       write(nfout,*) '!!!! Efermi is used as ValenceBandMaximum in the Fermi Dirac case'
    endif

    if(mype == 0) call write_dos(nfdos)
!!$    call write_dos(nfout)
    if(mype == 0 .and. icomponent == TOTAL .and. sw_pdos == ON) then
       call write_pdos(nfdos)
    end if
    if ( sw_calc_pcohp == ON ) call m_ES_calc_pcohp

    call dealloc_eko(); call dealloc_dos()

  end subroutine m_ESdos_FdiracDistrib

  subroutine m_ESdos_FDiracDistrib_ek(nfdos,icomponent)
    integer, intent(in) ::      nfdos, icomponent

    call alloc_eko_and_substitution_ek(kv3_ek) ! eko_ek -> eko
    call find_Erange_fermidirac(eko,neg,kv3_ek)

    call alloc_dos(1,icomponent)
    if(icomponent == TOTAL .and. sw_pdos == ON) then
       call pdos_ek()
       call m_ES_dos_gather_compr_compi_ek()
    endif
    call make_dos_with_FDiracDistrib( kv3_ek, icomponent, qwgt_ek )

    if(icomponent == TOTAL) then
       ValenceBandMaximum = efermi
       write(nfout,*) '!!!! Efermi is used as ValenceBandMaximum in the Fermi Dirac case'
    endif

    if(mype == 0) call write_dos(nfdos)
    if(mype == 0 .and. icomponent == TOTAL .and. sw_pdos == ON) then
       call write_pdos(nfdos)
    end if
    call dealloc_eko();     call dealloc_dos()
  end subroutine m_ESdos_FDiracDistrib_ek
! ============================================ 13.0E

  subroutine m_ESdos_write_dos_header(nfdos,aldos_or_layerdos,icomponent,tagwords)
    integer, intent(in):: nfdos, aldos_or_layerdos, icomponent
    character(len=40), intent(in) :: tagwords
    if(mype == 0) then
       if(aldos_or_layerdos == ALDOS) then
          write(nfdos,'("ALDOS     num_atom = ",i7)') icomponent
       else if(aldos_or_layerdos == LAYERDOS) then
          write(nfdos,'("LAYERDOS   num_layer = ",i7,2x,a40)') icomponent,tagwords
       end if
    end if
  end subroutine m_ESdos_write_dos_header

  ! ----------------------------------------------

  subroutine m_ESdos_tetrahedral(nfdos,icomponent,mode)
    integer, intent(in) ::  nfdos, mode,icomponent
!!$#ifndef NO_TETRAHEDRON
    real(kind=DP), parameter :: delta = 1.d-12
    integer, parameter       :: idim = 3
    integer        :: neig,ispin,ip2,ik, ip, ib, jb, ie, nelm
    real(kind=DP)  :: et,wei,clpm
    real(kind=DP), allocatable, dimension(:,:,:)   :: eeig2
    real(kind=DP), allocatable,dimension(:,:)  :: dos_weight2 ! d(neg,np2)
!    real(kind=DP), allocatable, dimension(:,:,:,:) :: compr, compi
!    real(kind=DP), allocatable, dimension(:,:) :: norm_phig_mpi
    real(kind=DP), pointer, dimension(:) :: eawk,cdwk,cswk,e
    real(kind=DP), allocatable, dimension(:,:) ::  e_mpi
    real(kind=DP), pointer, dimension(:,:,:) :: cdos,cind
    real(kind=DP), allocatable, dimension(:,:) :: doswk,dosinwk
    integer, allocatable, dimension(:,:) :: nttra ! d(mtetra,4)
    integer ::                                  id_sname = -1
    integer :: i,iorb,iopr,ikorb,lmtt, ipridos_t, nEwindows_plus,mtetra,ikt,iloop, j, iss, ies
    integer, parameter :: ncl = 8
    real(kind=DP) :: porb

    call tstatc0_begin('m_ESdos_tetrahedral ', id_sname)

    if(mode /= SCF .and. mode /= EK) then
       write(nfout,'(" !dos:  mode = ",i6," <<m_ESdos_tetrahedral>>")') mode
       return
    end if

    if(npes > 1) then
       if(mype == 0) ipridos_t = ipridos
       call mpi_bcast(ipridos_t, 1, mpi_integer, 0, MPI_CommGroup, ierr)
    else
       ipridos_t = ipridos
    end if

    if(ipridos_t >= 3) then
       if(printable) write(nfout,'(" !dos: np2, np0 = ",2i7," <<m_ESdos_tetrahedral>>")') np2, np0
       allocate(e_mpi(neg,kv3))
       if(printable) write(nfout,'(" !dos: icomponent = ",i9," <<m_ESdos_tetrahedral>>")') icomponent
       if(printable) write(nfout,'(" !dos: --energy_eigenvalue--")')
       e_mpi = 0.d0
       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle
          do ie = 1, neg
             ip = neordr(ie,ik)
             if(map_e(ip) == myrank_e) e_mpi(ie,ik) = eko_l(map_z(ip),ik)
          end do
       end do
       if(npes >=2) then
          call mpi_allreduce(MPI_IN_PLACE,e_mpi,neg*kv3,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
       end if
       if(printable) then
          do ik = 1, kv3
             write(nfout,'(" !dos:  ik = ",i7)') ik
             write(nfout,'(" !dos: ",8f10.6)') (e_mpi(ie,ik),ie=1,neg)
          end do
       end if
       deallocate(e_mpi)
    end if

    allocate(eeig2(np2,neg,nspin)); eeig2 = 0.d0
    if(icomponent == TOTAL .and. sw_pdos == ON .and. ekmode==OFF) then
       if(allocated(compr))     deallocate(compr)
       if(allocated(compi))     deallocate(compi)
       if(allocated(norm_phig_mpi)) deallocate(norm_phig_mpi)
       allocate(compr(neg,nlmta_phi,nopr,np2*nspin));  compr = 0.d0
       allocate(compi(neg,nlmta_phi,nopr,np2*nspin));  compi = 0.d0
       allocate(norm_phig_mpi(nlmtt_phi,np2));  norm_phig_mpi = 0.d0
    end if

    if(icomponent == TOTAL .and. sw_pdos == ON.and. ekmode==ON) then
       call pdos_ek()
       call m_ES_dos_gather_compr_compi_ek()
    endif

    if(mode==EK .and. ipridos_t >= 1) then
       write(nfout,'(" !dos eko_ek ")')
       do ispin=1,nspin
          do ip2=1,np2
             ik = nspin*(ip2-1)+ispin
             write(nfout,'(" !dos -- ik = ",i5)') ik
             write(nfout,'(" !dos ",8f8.4)')(eko_ek(ib,ik),ib=1,neg)
          end do
       end do
    end if
    neig=neg
    iss = ista_spin
    ies = iend_spin
    if(mode == EK) then
      iss = 1
      ies = nspin
    endif
    do ispin=iss, ies
       do ip2=1,np2
          ik=nspin*(ip2-1)+ispin
          if(mode == EK) then
             do ib=1,neg
                eeig2(ip2,ib,ispin)=eko_ek(ib,ik)
             enddo
             do ib = 1,neg-1
                do jb = ib+1, neg
                   if(eeig2(ip2,jb,ispin) < eeig2(ip2,ib,ispin)-delta) then
                      et = eeig2(ip2,ib,ispin)
                      eeig2(ip2,ib,ispin) = eeig2(ip2,jb,ispin)
                      eeig2(ip2,jb,ispin) = et
                   end if
                end do
             end do
          else if(mode == SCF) then
             if(map_k(ik) /= myrank_k) cycle
             do ib = 1, neg
                ip = neordr(ib,ik)
                if(map_e(ip) == myrank_e) then
                   eeig2(ip2,ib,ispin)=eko_l(map_z(ip),ik)
                   if(icomponent == TOTAL .and. sw_pdos == ON) then
                      compr(ib,1:nlmta_phi,1:nopr,ik)=compr_l(map_z(ip),1:nlmta_phi,1:nopr,ik)
!!$ASASASASAS
!!$                      compi(ib,1:nlmta_phi,1:nopr,ik)=compi_l(map_z(ip),1:nlmta_phi,1:nopr,ik)
                      if ( k_symmetry(ik) /= GAMMA ) then
                         compi(ib,1:nlmta_phi,1:nopr,ik)=compi_l(map_z(ip),1:nlmta_phi,1:nopr,ik)
                      else
!                         compi = 0.0d0
                         compi(ib,1:nlmta_phi,1:nopr,ik) = 0.0d0
                      endif
!!$ASASASASAS
                      norm_phig_mpi(1:nlmtt_phi,ip2)=norm_phig(1:nlmtt_phi,ip2)
                   end if
                end if
             enddo
          end if
       enddo
    end do

    if(mode == SCF) then
       if(npes >= 2) then
          nelm = np2*neg*nspin
          call mpi_allreduce(MPI_IN_PLACE,eeig2,nelm,mpi_double_precision,mpi_sum, mpi_kg_world,ierr)
          call mpi_allreduce(MPI_IN_PLACE,eeig2,nelm,mpi_double_precision,mpi_sum, mpi_ge_world,ierr)
          !deallocate(eeig2_mpi)
          if(icomponent == TOTAL .and. sw_pdos == ON) then
             nelm = neg*nlmta_phi*nopr*np2*nspin
             call mpi_allreduce(MPI_IN_PLACE,compr,nelm,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
             call mpi_allreduce(MPI_IN_PLACE,compr,nelm,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
             call mpi_allreduce(MPI_IN_PLACE,compi,nelm,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
             call mpi_allreduce(MPI_IN_PLACE,compi,nelm,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
             nelm = nlmtt_phi*np2
             call mpi_allreduce(MPI_IN_PLACE,norm_phig_mpi,nelm,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
             norm_phig_mpi = norm_phig_mpi / dble(nrank_s)
          end if
       end if
    end if

    if(ipridos >= 2) then
!!$       if(mype == 0) then
          write(nfout,'(" !dos: --eeig2(energy_eigenvalue)--")')
          iloop = (neg-1)/ncl+1
          do ispin = 1, nspin
             write(nfout,'(" !dos: ispin = ",i5)') ispin
             do ip2 = 1, np2
                do i = 1, iloop
                   write(nfout,'(" !dos: (",i5,") ",8f9.5)') &
                        & ip2,(eeig2(ip2,ib,ispin),ib=ncl*(i-1)+1,min(neg,ncl*i))
                end do
!!$                write(nfout,'(" !dos:  ip2 = ",i7)') ip2
!!$                write(nfout,'(" !dos: ",8f9.5)') (eeig2(ip2,ib,ispin),ib=1,neg)
             end do
          end do
          if(icomponent == TOTAL .and. sw_pdos == ON) then
          do ispin=1,nspin
             write(nfout,'(" !dos: ispin = ",i5)') ispin
             do ip2 = 1, np2
                ikorb=nspin*(ik-1)+ispin
                write(nfout,'(" !dos:  ip2 = ",i7)') ip2
                write(nfout,'(" !dos norm_phig: ",10f8.4)') &
                          & norm_phig_mpi(1:nlmtt_phi,ip2)
                do iopr=1,nopr
                   do iorb=1,nlmta_phi
                      write(nfout,'(" !dos: ik=",i5," iopr=",i5," iorb=",i5)') ikorb,iopr,iorb
                      write(nfout,'(" !dos compr: ",10f8.4)') compr(1:neg,iorb,iopr,ikorb)
                      write(nfout,'(" !dos compi: ",10f8.4)') compi(1:neg,iorb,iopr,ikorb)
                   end do
                end do
             end do
          end do
          end if
!!$       end if
    end if

    if(mode == EK) then
       call find_Erange(eko_ek,neg,kv3_ek)
    else
       Eminimum = minval(eeig2) - 0.005 ! (hartree)
       Emaximum = maxval(eeig2) + 0.005 ! (hartree)
       nEWindows = (Emaximum - Eminimum)/DeltaE_dos + 1
    end if

#ifdef DEBUG_LDOS
    if(icomponent/=TOTAL) then
       write(6,'(" <<m_ESdos_tetrahedral>")')
       if (ekmode == ON) then
          ikt = kv3_ek
       else
          ikt = kv3
       end if
       write(6,'(" kv3 = ",i8, " neg = ",i8)') ikt, neg
       do j = 1, ikt
          write(6,'(" ik = ", i8)') j
          write(6,'(10f8.4)') (dos_weight(i,j),i=1,neg)
       end do
    end if
#endif
    if(ipridos >= 2) &
         & write(nfout,'(" !dos: Emaximum, Eminimum, nEwindows = ",2f10.6,i7)') &
         &       Eminimum,Emaximum, nEWindows

    call alloc_dos(0,icomponent)

    if(nspin == 1) then
       wei = 2.d0
    else
       wei = 1.d0
    end if

    if(ipridos >= 2) write(nfout,*) ' === tetrahedron method', &
                &  ' for k-space integration === <<m_ESdos_tetrahedral>>'
    if(ipridos >= 2) write(nfout,'(" !m_ES_dos dos_subroutine = ",i5)') dos_subroutine

    do ispin=1,nspin
!!$       write(nfout,*) ' ispin=',ispin
!!$       write(nfout,'(" !! nxyz_tetra = ",3i7)') nxyz_tetra(1:3)
!!$       write(nfout,'(" !! np0 = ",i7)') np0
!!$       do ik = 1, np0
!!$          write(nfout,'(" !! ik, ip20 = ",2i6," <<m_ESdos_tetrahedral>>")') ik,ip20(ik)
!!$       end do
       if(dos_subroutine == 3) then
          allocate(e(0:nEwindows))
          e(0:nEwindows) = (/(Eminimum + DeltaE_dos*ie,ie=0,nEWindows)/)
          ! e(0) = Eminimum, e(1) = Eminimum+DeltaE_dos, e(2) = Eminimum+DeltaE_dos*2,...

          allocate(cdos(np2,neg,0:nEWindows)); cdos = 0.d0
          allocate(cind(np2,neg,0:nEWindows)); cind = 0.d0
          allocate(eawk(np0)); eawk = 0.d0
          allocate(cdwk(np0)); cdwk = 0.d0
          allocate(cswk(np0)); cswk = 0.d0
          call nstt3i(idim,nEwindows,e,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
               &  ,np2,np2,neig,eeig2(1,1,ispin) &
               &  ,ip20,np0,eawk,cdwk,cswk,np2,neig,cdos,cind,width_tetra ) ! -> cdos, cind
          deallocate(cswk,cdwk,eawk)
          clpm = 1.d0
          do ik=1,np2
             ikt = nspin*(ik-1)+ispin
             if(icomponent == TOTAL .and. sw_pdos == ON) ikorb=nspin*(ik-1)+ispin
             do ib = 1, neg
!!$             if(icomponent >= 1) clpm = dos_weight(ib,ik)
                if(icomponent /= TOTAL) clpm = dos_weight(ib,ikt)

                do ie = 0, nEwindows
                   dos(ie,ispin) = dos(ie,ispin) + cdos(ik,ib,ie)*clpm*wei
                   sumdos(ie,ispin) = sumdos(ie,ispin) + cind(ik,ib,ie)*clpm*wei
                end do
                if(icomponent == TOTAL .and. sw_pdos == ON) then
                   do iorb = 1,nlmta_phi
                      call m_PP_tell_iorb_lmtt(iorb,lmtt)
                      porb = 0.d0
!!$ASASASASAS
!!$                      do iopr=1,nopr
!!$                         porb = porb + (   compr(ib,iorb,iopr,ikorb)**2 &
!!$                              &          + compi(ib,iorb,iopr,ikorb)**2) &
!!$                              &        *(1.d0+qorb(iorb)/norm_phig_mpi(lmt,ik))
!!$                      end do
                      if ( k_symmetry(ik) == GAMMA) then
                         do iopr=1,nopr
                            porb = porb + compr(ib,iorb,iopr,ikorb)**2 /2.0 &
                            &  *(1.d0+qorb(iorb)/(norm_phig_mpi(lmtt,ik)*2.) )
                         end do
                      else
                         do iopr=1,nopr
                            porb = porb + ( compr(ib,iorb,iopr,ikorb)**2 &
                                 &        + compi(ib,iorb,iopr,ikorb)**2) &
                            &    *(1.d0+qorb(iorb)/norm_phig_mpi(lmtt,ik))
                         enddo
                      endif
!!$ASASASASAS
                      porb = porb/dble(nopr)
                      ! debug
                      ! print *,'debug iorb=',iorb,' porb=',porb
                      ! end debug
                      do ie = 0, nEwindows
                         pdos(ie,iorb,ispin) = pdos(ie,iorb,ispin) + cdos(ik,ib,ie)*wei*porb
                         sumpdos(ie,iorb,ispin) = sumpdos(ie,iorb,ispin) + cind(ik,ib,ie)*wei*porb
                      end do
                   end do
                end if
             end do
          end do
          deallocate(cind,cdos)
          deallocate(e)
       else if(dos_subroutine == 4) then
          allocate(cdos(0:nEwindows,np2,neg)); cdos = 0.d0
          allocate(cind(0:nEwindows,np2,neg)); cind = 0.d0
          nEwindows_plus = nEwindows
          if(mod(nEwindows_plus,2)==1) nEwindows_plus = nEwindows_plus+1
          allocate(doswk(0:nEwindows_plus,4))
          allocate(dosinwk(0:nEwindows_plus,4))
          mtetra = product(nxyz_tetra(1:3))*6
          allocate(nttra(mtetra,4))
          call prepare_nttra(nxyz_tetra,mtetra,nttra)
          write(nfout,'(" !dos after prepare_nttra")')
          write(nfout,'(" !dos neig = ",i5)') neig
          cdos = 0.d0; cind =0.d0
          call nstt4i(ipridos,idim,nEwindows,nxyz_tetra,np2,np2,neig,eeig2(1,1,ispin) &
               &   ,  ip20,np0,np2,neig,mtetra,nttra,deltae_dos &
               &   ,  nEwindows_plus,doswk,dosinwk,cdos,cind)
          deallocate(nttra)
          deallocate(dosinwk,doswk)
          clpm = 1.d0
          do ik=1,np2
             ikt=nspin*(ik-1)+ispin
             do ib = 1, neg
                if(icomponent /= TOTAL) clpm = dos_weight(ib,ikt)
                ! clpm -> clpm(ib,ik)
                do ie = 0, nEwindows
                   dos(ie,ispin) = dos(ie,ispin) + cdos(ie,ik,ib)*clpm*wei
                   sumdos(ie,ispin) = sumdos(ie,ispin) + cind(ie,ik,ib)*clpm*wei
                end do
             end do
          end do
          if(icomponent == TOTAL .and. sw_pdos == ON) then
             do ik = 1,np2
                ikorb=nspin*(ik-1)+ispin
                do ib = 1, neg
                   do iorb = 1,nlmta_phi
                      call m_PP_tell_iorb_lmtt(iorb,lmtt)
                      porb = 0.d0
!!$ASASASASAS
!!$                      do iopr=1,nopr
!!$                         porb = porb + (   compr(ib,iorb,iopr,ikorb)**2 &
!!$                              &          + compi(ib,iorb,iopr,ikorb)**2) &
!!$                              &        *(1.d0+qorb(iorb)/norm_phig_mpi(lmt,ik))
!!$                      end do
                      if ( k_symmetry(ik) == GAMMA ) then
                         do iopr=1,nopr
                            porb = porb + compr(ib,iorb,iopr,ikorb)**2 /2.0 &
                              &   *(1.d0+qorb(iorb)/(norm_phig_mpi(lmtt,ik)*2.))
                           end do
                      else
                         do iopr=1,nopr
                            porb = porb + ( compr(ib,iorb,iopr,ikorb)**2 &
                                 &    + compi(ib,iorb,iopr,ikorb)**2) &
                                 &   *(1.d0+qorb(iorb)/norm_phig_mpi(lmtt,ik))
                         end do
                      endif
!!$ASASASASAS
                      porb = porb/dble(nopr)
                      ! porb -> porb(ib,iorb,ik)
                      ! debug
                      ! print *,'debug iorb=',iorb,' porb=',porb
                      ! end debug
                      do ie = 0, nEwindows
                         pdos(ie,iorb,ispin) = pdos(ie,iorb,ispin) + cdos(ie,ik,ib)*wei*porb
                         sumpdos(ie,iorb,ispin) = sumpdos(ie,iorb,ispin) + cind(ie,ik,ib)*wei*porb
                      end do
                   end do
                end do
             end do
          end if
          deallocate(cind,cdos)
       else if(dos_subroutine == 5) then
          nEwindows_plus = nEwindows
          if(mod(nEwindows_plus,2)==1) nEwindows_plus = nEwindows_plus+1
          allocate(doswk(0:nEwindows_plus,4))
          allocate(dosinwk(0:nEwindows_plus,4))
          mtetra = product(nxyz_tetra(1:3))*6
          allocate(nttra(mtetra,4))
          call prepare_nttra(nxyz_tetra,mtetra,nttra)
          allocate(dos_weight2(neg,np2))
          if(icomponent == TOTAL) then
             dos_weight2 = 1.d0
          else
             do ik = 1, np2
                ikt = nspin*(ik-1)+ispin
                do ib = 1, neg
                   dos_weight2(ib,ik) = dos_weight(ib,ikt)
                end do
             end do
          end if
          call care_of_degenerate_state(neig,np2,nspin,ispin,eeig2,dos_weight2) !dos_weight
          dos_weight2 = dos_weight2*wei
          dos(:,ispin) = 0.d0
          sumdos(:,ispin) = 0.d0
          call nstt5i(ipridos,idim,Eminimum,Emaximum,nEwindows,nxyz_tetra,np2,np2 &
               &   ,  neig,eeig2(1,1,ispin) &
               &   ,  ip20,np0,np2,neig,mtetra,nttra,deltae_dos,dos_weight2 &
               &   ,  nEwindows_plus,doswk,dosinwk,dos(0,ispin),sumdos(0,ispin))
!!$          call nstt5i_3D(ipridos,idim,Eminimum,Emaximum,nEwindows,nxyz_tetra,np2,np2 &
!!$               &   ,  neig,eeig2(1,1,ispin) &
!!$               &   ,  ip20,np0,np2,neig,mtetra,nttra,deltae_dos,dos_weight2 &
!!$               &   ,  nEwindows_plus,doswk,dosinwk,dos(0,ispin),sumdos(0,ispin))

          if(icomponent == TOTAL .and. sw_pdos == ON) then
             do iorb = 1, nlmta_phi
                call m_PP_tell_iorb_lmtt(iorb,lmtt)
                do ik = 1, np2
                   ikorb=nspin*(ik-1)+ispin
                   do ib = 1, neg
                      porb = 0.d0
!!$ASASASASAS
!!$                      do iopr=1,nopr
!!$                         porb = porb + (   compr(ib,iorb,iopr,ikorb)**2 &
!!$                              &          + compi(ib,iorb,iopr,ikorb)**2) &
!!$                              &        *(1.d0+qorb(iorb)/norm_phig_mpi(lmt,ik))
!!$                      end do
                      if ( k_symmetry(ik) == GAMMA ) then
                         do iopr=1,nopr
                            porb = porb + compr(ib,iorb,iopr,ikorb)**2 /2.0 &
                             &   *(1.d0+qorb(iorb)/(norm_phig_mpi(lmtt,ik)*2.) )
                         end do
                      else
                         do iopr=1,nopr
                            porb = porb + ( compr(ib,iorb,iopr,ikorb)**2 &
                                 &      + compi(ib,iorb,iopr,ikorb)**2) &
                                 &    *(1.d0+qorb(iorb)/norm_phig_mpi(lmtt,ik))
                         end do
                      endif
!!$ASASASASAS
                      dos_weight2(ib,ik) = porb/dble(nopr)*wei
                   end do
                end do
                call care_of_degenerate_state(neig,np2,nspin,ispin,eeig2,dos_weight2) !dos_weight
                call nstt5i(ipridos,idim,Eminimum,Emaximum,nEwindows,nxyz_tetra,np2 &
                     &   ,  np2,neig,eeig2(1,1,ispin) &
                     &   ,  ip20,np0,np2,neig,mtetra,nttra,deltae_dos,dos_weight2 &
                     &   ,  nEwindows_plus,doswk,dosinwk,pdos(0,iorb,ispin),sumpdos(0,iorb,ispin))
             end do
          end if
          deallocate(dos_weight2)
          deallocate(nttra)
          deallocate(dosinwk,doswk)
       !np2: #kpoints independent
       !np0: #all kpoints
!!$       call doscal_nstt(nEwindows,nxyz_tetra,np2,neig,eeig2(1,1,ispin),ip20,np0,wei,cdos,cind)

       end if
    end do

    deallocate(eeig2)

    if(icomponent == TOTAL) call get_VBM(totch,1.d-12)  ! -> ValenceBandMaximum
    if(mype == 0) call write_dos(nfdos)
    if(mype == 0 .and. icomponent == TOTAL .and. sw_pdos == ON) call write_pdos(nfdos)

    call dealloc_dos()
    call tstatc0_end(id_sname)
!!$#endif
  end subroutine m_ESdos_tetrahedral


! ============================= added by K. Tagami ======================= 11.0
  subroutine m_ESdos_tetrahedral_noncl(nfdos,icomponent,mode)

    integer, intent(in) ::  nfdos, mode,icomponent
!!$#ifndef NO_TETRAHEDRON
    real(kind=DP), parameter :: delta = 1.d-12
    integer, parameter       :: idim = 3
    integer        :: neig, ip2, ik, ip, ib, jb, ie
    real(kind=DP)  :: et,wei,clpm
    real(kind=DP), pointer, dimension(:,:,:)   :: eeig2, eeig2_mpi
    real(kind=DP), allocatable,dimension(:,:)  :: dos_weight2 ! d(neg,np2)

    real(kind=DP), pointer, dimension(:,:,:,:) :: compr, compr_mpi
    real(kind=DP), pointer, dimension(:,:,:,:) :: compi, compi_mpi
    real(kind=DP), pointer, dimension(:,:) :: norm_phig_mpi, norm_phig_mpi2
    real(kind=DP), pointer, dimension(:) :: eawk,cdwk,cswk,e
    real(kind=DP), allocatable, dimension(:,:) ::  e_mpi

    real(kind=DP), pointer, dimension(:,:,:) :: cdos,cind
    real(kind=DP), allocatable, dimension(:,:) :: doswk,dosinwk
    integer, allocatable, dimension(:,:) :: nttra ! d(mtetra,4)
    integer ::                                  id_sname = -1
    integer :: i, iorb,iopr, lmtt, ipridos_t, nEwindows_plus, mtetra, iloop
    integer, parameter :: ncl = 8

! -------
    complex(kind=CMPLDP), allocatable :: porb_ssrep(:,:)
    complex(kind=CMPLDP), allocatable :: porb_ssrep5(:,:,:)
    real(kind=DP), allocatable :: porb(:,:)
    real(kind=DP), allocatable :: dos_weight3(:,:,:)
!
    integer :: is1, is2, istmp, ismax
    complex(kind=CMPLDP) :: z1, z2, ztemp
! ---

    call tstatc0_begin('m_ESdos_tetrahedral_noncl ', id_sname)

    if(mode /= SCF .and. mode /= EK) then
       write(nfout,'(" !dos:  mode = ",i6," <<m_ESdos_tetrahedral_noncl>>")') mode
       return
    end if

    if(npes > 1) then
       if(mype == 0) ipridos_t = ipridos
       call mpi_bcast(ipridos_t, 1, mpi_integer, 0, MPI_CommGroup, ierr)
    else
       ipridos_t = ipridos
    end if

! --------------------------------------------------------
    if (ipridos_t >= 3) then
       if (printable) then
          write(nfout,'(" !dos: np2, np0 = ",2i7," <<m_ESdos_tetrahedral_noncl>>")') &
               &      np2, np0
       endif

       allocate(e_mpi(neg,kv3))

       if (printable) then
          write(nfout,'(" !dos: icomponent = ",i9," <<m_ESdos_tetrahedral_noncl>>")') &
               &      icomponent
       endif

       if(printable) write(nfout,'(" !dos: --energy_eigenvalue--")')
       e_mpi = 0.d0

       do ik = 1, kv3, ndim_spinor
          if (map_k(ik) /= myrank_k) cycle
          do ie = 1, neg
             ip = neordr(ie,ik)
             if (map_e(ip) == myrank_e) e_mpi(ie,ik) = eko_l(map_z(ip),ik)
          end do
       end do

       if (npes >=2) then
          call mpi_allreduce(MPI_IN_PLACE,e_mpi,neg*kv3,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
       end if
       if (printable) then
          do ik = 1, kv3, ndim_spinor
             write(nfout,'(" !dos:  ik = ",i7)') ik
             write(nfout,'(" !dos: ",8f10.6)') (e_mpi(ie,ik),ie=1,neg)
          end do
       end if
       deallocate(e_mpi)
    end if
! --------------------------------------------------

    allocate( eeig2(np2,neg,1) ); eeig2 = 0.d0
    if (icomponent == TOTAL .and. sw_pdos == ON) then
       allocate( compr(neg,nlmta_phi,nopr,np2*ndim_spinor));  compr = 0.d0
       allocate( compi(neg,nlmta_phi,nopr,np2*ndim_spinor));  compi = 0.d0
       allocate( norm_phig_mpi(nlmtt_phi,np2));  norm_phig_mpi = 0.d0
    end if

    if (mode==EK .and. ipridos_t >= 1) then
       write(nfout,'(" !dos eko_ek ")')
       do ip2=1,np2
          ik = ndim_spinor*( ip2 -1 ) +1
          write(nfout,'(" !dos -- ik = ",i5)') ik
          write(nfout,'(" !dos ",8f8.4)')( eko_ek(ib,ik),ib=1,neg)
       end do
    end if

    neig=neg

! -------------------------------------------------------
    Do ip2=1, np2
       ik = ndim_spinor *(ip2-1) +1

       if(mode == EK) then
          do ib=1,neg
             eeig2(ip2,ib,1)=eko_ek(ib,ik)
          enddo
          do ib = 1,neg-1
             do jb = ib+1, neg
                if ( eeig2(ip2,jb,1) < eeig2(ip2,ib,1)-delta) then
                   et = eeig2(ip2,ib,1)
                   eeig2(ip2,ib,1) = eeig2(ip2,jb,1)
                   eeig2(ip2,jb,1) = et
                end if
             end do
          end do
       else if(mode == SCF) then
          if(map_k(ik) /= myrank_k) cycle

          do ib = 1, neg
             ip = neordr(ib,ik)
             if (map_e(ip) == myrank_e) then
                eeig2(ip2,ib,1) = eko_l(map_z(ip),ik)
                if (icomponent == TOTAL .and. sw_pdos == ON) then

                   Do is1=1, ndim_spinor
                      compr(ib,1:nlmta_phi,1:nopr,ik+is1-1) &
                           &  = compr_l(map_z(ip),1:nlmta_phi,1:nopr,ik+is1-1)

                      if ( k_symmetry(ik) /= GAMMA ) then
                         compi(ib,1:nlmta_phi,1:nopr,ik+is1-1) &
                              &  = compi_l(map_z(ip),1:nlmta_phi,1:nopr,ik+is1-1)
                      else
                         call phase_error_with_msg(nfout,"Not supported : Gamma symmetry in noncollinear",__LINE__,__FILE__)
                      endif
                   End do
                   norm_phig_mpi(1:nlmtt_phi,ip2) = norm_phig(1:nlmtt_phi,ip2)
                end if
             end if
          enddo
       end if

    End do
! -------------------------------------------------------

    if (mode == SCF) then
       if (npes >= 2) then
          allocate(eeig2_mpi(np2,neg,1)); eeig2_mpi = 0.d0
          call mpi_allreduce( eeig2, eeig2_mpi, np2*neg, mpi_double_precision, &
               &              mpi_sum, mpi_kg_world, ierr )
          eeig2 = eeig2_mpi
          deallocate(eeig2_mpi)

          if (icomponent == TOTAL .and. sw_pdos == ON) then
            allocate( compr_mpi(neg,nlmta_phi,nopr,np2*ndim_spinor) ); compr_mpi=0.d0
            allocate( compi_mpi(neg,nlmta_phi,nopr,np2*ndim_spinor) ); compi_mpi=0.d0
            allocate( norm_phig_mpi2(nlmtt_phi,np2) ); norm_phig_mpi2 = 0.d0
!!$            call mpi_allreduce( compr, compr_mpi, neg*nlmta_phi*nopr*np2*ndim_spinor,&
!!$                 &              mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )
            call mpi_allreduce( compr, compr_mpi, neg*nlmta_phi*nopr*np2*ndim_spinor,&
                 &              mpi_double_precision, mpi_sum, mpi_kg_world, ierr )
!!$            call mpi_allreduce( compi,compi_mpi, neg*nlmta_phi*nopr*np2*ndim_spinor, &
!!$                 &              mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )
            call mpi_allreduce( compi,compi_mpi, neg*nlmta_phi*nopr*np2*ndim_spinor, &
                 &              mpi_double_precision, mpi_sum, mpi_kg_world, ierr )
!!$            call mpi_allreduce( norm_phig_mpi, norm_phig_mpi2, nlmtt_phi*np2, &
!!$                 &              mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )
            call mpi_allreduce( norm_phig_mpi, norm_phig_mpi2, nlmtt_phi*np2, &
                 &              mpi_double_precision, mpi_sum, mpi_kg_world, ierr )

            compr = compr_mpi;    compi = compi_mpi
            norm_phig_mpi = norm_phig_mpi2 / dble(nrank_s)
            deallocate(compr_mpi,compi_mpi,norm_phig_mpi2)
          end if

       end if
    end if

! ------------------------------------------------------------
    if (ipridos >= 2) then

       write(nfout,'(" !dos: --eeig2(energy_eigenvalue)--")')
       iloop = (neg-1)/ncl+1

       do ip2 = 1, np2
          do i = 1, iloop
             write(nfout,'(" !dos: (",i5,") ",8f9.5)') &
                  & ip2,(eeig2(ip2,ib,1),ib=ncl*(i-1)+1,min(neg,ncl*i))
          end do
       end do

       if (icomponent == TOTAL .and. sw_pdos == ON) then

          do ip2 = 1, np2
             ik = ndim_spinor *(ip2-1) + 1

             write(nfout,'(" !dos:  ip2 = ",i7)') ip2
             write(nfout,'(" !dos norm_phig: ",10f8.4)') &
                  & norm_phig_mpi(1:nlmtt_phi,ip2)

             do iopr=1,nopr
                do iorb=1,nlmta_phi
                   write(nfout,'(" !dos: ik=",i5," iopr=",i5," iorb=",i5)')&
                        &  ik, iopr, iorb
                   write(nfout,'(" !dos compr: ",10f8.4)') &
                        & compr(1:neg,iorb,iopr,ik)
                   write(nfout,'(" !dos compi: ",10f8.4)') &
                        & compi(1:neg,iorb,iopr,ik)
                end do
             end do
          end do
       end if

    end if
! -----------------------------------------------------

    if (mode == EK) then

       allocate( e_mpi( neg,kv3_ek/ndim_spinor) );   e_mpi = 0.d0;

       do ip2=1, np2
          ik = ( ip2 -1 )*ndim_spinor + 1
          e_mpi( :, ip2 ) = eko_ek( :, ik )
       end do
       call find_Erange( e_mpi, neg, kv3_ek /ndim_spinor )
       deallocate( e_mpi )

    else
       Eminimum = minval(eeig2) - 0.005 ! (hartree)
       Emaximum = maxval(eeig2) + 0.005 ! (hartree)
       nEWindows = (Emaximum - Eminimum)/DeltaE_dos + 1
    end if

    if (ipridos >= 2) &
         & write(nfout,'(" !dos: Emaximum, Eminimum, nEwindows = ",2f10.6,i7)') &
         &       Eminimum,Emaximum, nEWindows

    call alloc_dos(0,icomponent)

! ----------------------------------------------------
    wei = 1.d0                ! ??????????????? 2.0 ? docchi _

    if(ipridos >= 2) write(nfout,*) ' === tetrahedron method', &
                &  ' for k-space integration === <<m_ESdos_tetrahedral_noncl>>'
    if(ipridos >= 2) write(nfout,'(" !m_ES_dos dos_subroutine = ",i5)') dos_subroutine

! ---------------------------------------------------

    if ( calc_dos_magmom_contrib == YES ) then
       ismax = ndim_magmom
    else
       ismax = 1
    endif
! -------------------------------------------------

    if (dos_subroutine == 3) then
       allocate(e(0:nEwindows))
       e(0:nEwindows) = (/(Eminimum + DeltaE_dos*ie,ie=0,nEWindows)/)
                      ! e(0) = Eminimum, e(1) = Eminimum+DeltaE_dos,
                      ! e(2) = Eminimum+DeltaE_dos*2,...

       allocate(cdos(np2,neg,0:nEWindows)); cdos = 0.d0
       allocate(cind(np2,neg,0:nEWindows)); cind = 0.d0
       allocate(eawk(np0)); eawk = 0.d0
       allocate(cdwk(np0)); cdwk = 0.d0
       allocate(cswk(np0)); cswk = 0.d0

       call nstt3i(idim,nEwindows,e,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
            &  ,np2,np2,neig,eeig2(1,1,1) &
            &  ,ip20,np0,eawk,cdwk,cswk,np2,neig,cdos,cind,width_tetra ) ! -> cdos, cind
       deallocate(cswk,cdwk,eawk)

       clpm = 1.d0

       if (icomponent == TOTAL .and. sw_pdos == ON) then
          allocate( porb_ssrep( nlmta_phi, ndim_chgpot ) ); porb_ssrep = 0.0d0
          allocate( porb( nlmta_phi, ndim_magmom ) ); porb = 0.0d0
       endif

       do ip2 = 1, np2
          ik = ndim_spinor *(ip2-1) +1

          do ib = 1, neg

             Do istmp=1, ismax
                clpm = dos_weight_noncl( ib,ik,istmp )

                do ie = 0, nEwindows
                   dos(ie,istmp) = dos(ie,istmp) + cdos(ip2,ib,ie)*clpm*wei
                   sumdos(ie,istmp) = sumdos(ie,istmp) + cind(ip2,ib,ie)*clpm*wei
                end do
             End do

             if (icomponent == TOTAL .and. sw_pdos == ON) then
                clpm = 1.0d0
                porb_ssrep = 0.d0

! -----------------
                Do iorb = 1,nlmta_phi
                   call m_PP_tell_iorb_lmtt(iorb,lmtt)

                   if ( k_symmetry(ik) == GAMMA ) then
                      call phase_error_with_msg(nfout,'Not supported ',__LINE__,__FILE__)
                   else

                      Do is1=1, ndim_spinor
                         Do is2=1, ndim_spinor
                            istmp = ( is1 -1 )*ndim_spinor + is2

                            ztemp = 0.0d0
                            do iopr=1,nopr
                               z1 = dcmplx( compr(ib,iorb,iopr,ik+is1-1 ), &
                                    &       compi(ib,iorb,iopr,ik+is1-1 ) )
                               z2 = dcmplx( compr(ib,iorb,iopr,ik+is2-1 ), &
                                    &       compi(ib,iorb,iopr,ik+is2-1 ) )
                               ztemp = ztemp + z1 *conjg(z2) &
                                    &      *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt,ip2) )
                            end do

                            porb_ssrep(iorb,istmp) = porb_ssrep(iorb,istmp) &
                                 &                   + ztemp /dble(nopr)
                         End do
                      End do
                   endif
                End Do
! ---------------------
                call m_ES_DensMat_To_MagMom_porb( nlmta_phi, porb_ssrep, porb )

                do ie = 0, nEwindows
                   pdos(ie,iorb,:) = pdos(ie,iorb,:) &
                        &           + cdos(ip2,ib,ie) *wei *porb(iorb,:)
                   sumpdos(ie,iorb,:) = sumpdos(ie,iorb,:) &
                        &           + cind(ip2,ib,ie) *wei *porb(iorb,:)
                end do

             end if
          end do
       end do

       deallocate(cind,cdos);     deallocate(e)
       if ( allocated( porb ) ) deallocate( porb )
       if ( allocated( porb_ssrep ) ) deallocate( porb_ssrep )

! ---------------------------------------------------
    else if(dos_subroutine == 4) then
       allocate(cdos(0:nEwindows,np2,neg)); cdos = 0.d0
       allocate(cind(0:nEwindows,np2,neg)); cind = 0.d0
       nEwindows_plus = nEwindows

       if(mod(nEwindows_plus,2)==1) nEwindows_plus = nEwindows_plus+1
       allocate(doswk(0:nEwindows_plus,4))
       allocate(dosinwk(0:nEwindows_plus,4))
       mtetra = product(nxyz_tetra(1:3))*6

       allocate(nttra(mtetra,4))
       call prepare_nttra(nxyz_tetra,mtetra,nttra)
       write(nfout,'(" !dos after prepare_nttra")')
       write(nfout,'(" !dos neig = ",i5)') neig

       cdos = 0.d0; cind =0.d0
       call nstt4i(ipridos,idim,nEwindows,nxyz_tetra,np2,np2,neig,eeig2(1,1,1) &
            &   ,  ip20,np0,np2,neig,mtetra,nttra,deltae_dos &
            &   ,  nEwindows_plus,doswk,dosinwk,cdos,cind)
       deallocate(nttra);     deallocate(dosinwk,doswk)

       clpm = 1.d0

       do ip2 = 1,np2
          ik = ndim_spinor*(ip2-1) +1

          do ib = 1, neg
             Do istmp=1, ismax
                clpm = dos_weight_noncl(ib,ik,istmp)
                                       ! clpm -> clpm(ib,ik)
                do ie = 0, nEwindows
                   dos(ie,istmp) = dos(ie,istmp) + cdos(ie,ip2,ib)*clpm*wei
                   sumdos(ie,istmp) = sumdos(ie,istmp) + cind(ie,ip2,ib)*clpm*wei
                end do
             End do
          end do
       end do

       if (icomponent == TOTAL .and. sw_pdos == ON) then
          allocate( porb_ssrep( nlmta_phi, ndim_chgpot ) ); porb_ssrep = 0.0d0
          allocate( porb( nlmta_phi, ndim_magmom ) ); porb = 0.0d0

          do ip2 = 1,np2
             ik = ndim_spinor *(ip2-1) +1

             do ib = 1, neg
                porb_ssrep = 0.d0

                do iorb = 1,nlmta_phi
                   call m_PP_tell_iorb_lmtt(iorb,lmtt)

                   if ( k_symmetry(ik) == GAMMA ) then
                      call phase_error_with_msg(nfout,'Not supported ',__LINE__,__FILE__)
                   else
                      Do is1=1, ndim_spinor
                         Do is2=1, ndim_spinor
                            istmp = ( is1 -1 )*ndim_spinor + is2

                            ztemp = 0.0d0
                            do iopr=1,nopr
                               z1 = dcmplx( compr(ib,iorb,iopr,ik+is1-1 ), &
                                    &       compi(ib,iorb,iopr,ik+is1-1 ) )
                               z2 = dcmplx( compr(ib,iorb,iopr,ik+is2-1 ), &
                                    &       compi(ib,iorb,iopr,ik+is2-1 ) )
                               ztemp = ztemp + z1 *conjg(z2) &
                                    &      *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt,ip2) )
                            end do

                            porb_ssrep(iorb,istmp) = porb_ssrep(iorb,istmp) &
                                 &                   + ztemp /dble(nopr)
                         End do
                      End do
                   end if
                End do
! -----
                call m_ES_DensMat_To_MagMom_porb( nlmta_phi, porb_ssrep, porb )
!
                do ie = 0, nEwindows
                   pdos(ie,iorb,:) = pdos(ie,iorb,:) &
                        &           + cdos(ie,ip2,ib) *wei *porb(iorb,:)
                   sumpdos(ie,iorb,:) = sumpdos(ie,iorb,:) &
                        &           + cind(ie,ip2,ib) *wei *porb(iorb,:)
                end do
             end do
          end do

          deallocate( porb ); deallocate( porb_ssrep )
       end if

       deallocate(cind,cdos)

! ---------------------------------------------------------------
    else if(dos_subroutine == 5) then
       nEwindows_plus = nEwindows
       if(mod(nEwindows_plus,2)==1) nEwindows_plus = nEwindows_plus+1
       allocate(doswk(0:nEwindows_plus,4))
       allocate(dosinwk(0:nEwindows_plus,4))
       mtetra = product(nxyz_tetra(1:3))*6

       allocate(nttra(mtetra,4))
       call prepare_nttra(nxyz_tetra,mtetra,nttra)
       allocate(dos_weight2(neg,np2))

       Do istmp=1, ismax

          do ip2 = 1, np2
             ik = ndim_spinor *(ip2-1) +1
             do ib = 1, neg
                dos_weight2(ib,ip2) = dos_weight_noncl(ib,ik,istmp)
             end do
          end do

          call care_of_degenerate_state( neig, np2, 1, 1, eeig2, dos_weight2 )
                                                       !dos_weight

          dos_weight2 = dos_weight2*wei

          dos(:,istmp) = 0.d0;           sumdos(:,istmp) = 0.d0

          call nstt5i(ipridos,idim,Eminimum,Emaximum,nEwindows,nxyz_tetra,np2,np2 &
               &   ,  neig,eeig2(1,1,1) &
               &   ,  ip20,np0,np2,neig,mtetra,nttra,deltae_dos,dos_weight2 &
               &   ,  nEwindows_plus,doswk,dosinwk,dos(0,istmp),sumdos(0,istmp) )
       End do

       if (icomponent == TOTAL .and. sw_pdos == ON) then

          allocate( porb_ssrep5( neg, np2, ndim_chgpot ) ); porb_ssrep5 = 0.0d0
          allocate( dos_weight3( neg, np2, ndim_magmom ) ); dos_weight3 = 0.0d0

          do iorb = 1, nlmta_phi
             call m_PP_tell_iorb_lmtt(iorb,lmtt)

             porb_ssrep5 = 0.0d0
! ---------------
             do ip2 = 1, np2
                ik = ndim_spinor*( ip2 -1 ) +1

                do ib = 1, neg
                   if ( k_symmetry(ik) == GAMMA ) then
                      call phase_error_with_msg(nfout,'Not supported ',__LINE__,__FILE__)
                   else
                      Do is1=1, ndim_spinor
                         Do is2=1, ndim_spinor
                            istmp = ( is1 -1 )*ndim_spinor + is2

                            ztemp = 0.0d0
                            do iopr=1,nopr
                               z1 = dcmplx( compr(ib,iorb,iopr,ik+is1-1 ), &
                                    &       compi(ib,iorb,iopr,ik+is1-1 ) )
                               z2 = dcmplx( compr(ib,iorb,iopr,ik+is2-1 ), &
                                    &       compi(ib,iorb,iopr,ik+is2-1 ) )
                               ztemp = ztemp + z1 *conjg(z2) &
                                    &      *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt,ip2) )
                            end do

                            porb_ssrep5(ib,ip2,istmp) = porb_ssrep5(ib,ip2,istmp) &
                                 &                   + ztemp /dble(nopr)
                         End do
                      End Do

                   endif

                end do
             end do
! ---------------
             call m_ES_DensMat_To_MagMom_porb( np2*neg, porb_ssrep5, dos_weight3 )
             dos_weight3 = dos_weight3 *wei
! ------------------------------------ - - -- -
             Do istmp=1, ndim_magmom
                call care_of_degenerate_state( neig, np2, 1, 1, eeig2, &
                     &                         dos_weight3(:,:,istmp) )
                                                               !dos_weight
                call nstt5i( ipridos, idim, Eminimum, Emaximum, nEwindows, &
                     &       nxyz_tetra, np2, np2, neig, eeig2(1,1,1), &
                     &       ip20, np0, np2, neig, mtetra, nttra, deltae_dos, &
                     &       dos_weight3(:,:,istmp), nEwindows_plus, &
                     &       doswk, dosinwk, pdos(0,iorb,istmp), &
                     &       sumpdos(0,iorb,istmp) )
             End Do

          end do

          deallocate( dos_weight3 );  deallocate( porb_ssrep5 )

       end if

       deallocate(dos_weight2);    deallocate(nttra);  deallocate(dosinwk,doswk)
    end if
! ----------------------------------------------------------

    deallocate(eeig2)

    if(icomponent == TOTAL) call get_VBM(totch,1.d-12)  ! -> ValenceBandMaximum

    if(mype == 0) then
       if ( calc_dos_magmom_contrib == YES ) then
          call write_dos_noncl(nfdos)
       else
          call write_dos_noncl_for_totchg(nfdos)
       endif
    endif

    if(mype == 0 .and. icomponent == TOTAL .and. sw_pdos == ON) then
       call write_pdos_noncl(nfdos)
    endif

    call dealloc_dos()
    call tstatc0_end(id_sname)
!!$#endif
  end subroutine m_ESdos_tetrahedral_noncl
! ==================================================================== 11.0

  subroutine doscal_nstt(nEwindows,nxyz_tetra,np2,neg,eeig2,ip20,np0,wei,cdos,cind)
    integer, intent(in) :: nEwindows, np2, neg, np0
    integer, intent(in), dimension(3) :: nxyz_tetra
    real(kind=DP), intent(in), dimension(np2,neg) ::eeig2
    integer, intent(in), dimension(np0) :: ip20
    real(kind=DP), intent(in)           :: wei
    real(kind=DP), dimension(np2,neg,0:nEwindows) :: cdos, cind

    integer :: mtetra
    integer, allocatable, dimension(:,:)     :: nttra  ! d(mtetra,4)
    integer, allocatable, dimension(:)       :: ip8    ! d(8)
    real(kind=DP), allocatable, dimension(:) :: voltt  ! d(mtetra)
    real(kind=DP), allocatable, dimension(:,:) :: vctk, vwork ! d(4,3)
    integer, allocatable, dimension(:)       :: k_sample_mesh !d(3)
    real(kind=DP), dimension(4)              :: e
    integer, parameter :: D12 = 1, D13 = 2, D14 = 3, D23 = 4, D24 = 5 &
         &         , D34 = 6, DM  = 7, DA  = 8, mdoswk = da
    real(kind=DP), allocatable, dimension(:,:) :: dos ! d(nEwindows,neg)
    real(kind=DP), allocatable, dimension(:)   :: d

    integer :: ix,iy,iz,icub,npx,npy,ni,ip0,kx,ky,kz,nx1,ny1,nz1,nd,nn,nt,i,j,nxx,nyy,nzz,nv(3),iv,ib,ie
    integer :: iswap1, iswap2, ns, ne, idos
    real(kind=DP) :: sumv,es,ee,v,x,f0,f1,f2,f3,ed

    mtetra = product(nxyz_tetra(1:3))*6
    allocate(nttra(mtetra,4))
    allocate(voltt(mtetra))

    allocate(ip8(8))
    npx = nxyz_tetra(1)+1
    npy = nxyz_tetra(2)+1
    icub = 0
    do iz = 0, nxyz_tetra(3)-1
       do iy = 0, nxyz_tetra(2)-1
          do ix = 0, nxyz_tetra(1)-1
             icub = icub+1
             ni=npx*(npy*iz+iy)+ix
             do kz=1,2
                do ky=1,2
                   do kx=1,2
                      ip0 = ni+npx*(npy*(kz-1)+ky-1)+kx
                      ip8(kx+2*(ky-1)+4*(kz-1)) = ip0
                   end do
                end do
             end do
             nttra((icub-1)*6+1, 1:4) = (/ip8(1),ip8(2),ip8(4),ip8(8)/)
             nttra((icub-1)*6+2, 1:4) = (/ip8(1),ip8(2),ip8(6),ip8(8)/)
             nttra((icub-1)*6+3, 1:4) = (/ip8(1),ip8(5),ip8(6),ip8(8)/)
             nttra((icub-1)*6+4, 1:4) = (/ip8(1),ip8(3),ip8(4),ip8(8)/)
             nttra((icub-1)*6+5, 1:4) = (/ip8(1),ip8(3),ip8(7),ip8(8)/)
             nttra((icub-1)*6+6, 1:4) = (/ip8(1),ip8(5),ip8(7),ip8(8)/)
          end do
       end do
    end do
    deallocate(ip8)

    nxx = nxyz_tetra(1)
    nyy = nxyz_tetra(2)
    nzz = nxyz_tetra(3)
    allocate(k_sample_mesh(3))
    call m_Kp_sample_mesh(k_sample_mesh)
    nx1 = max(k_sample_mesh(1),1)
    ny1 = max(k_sample_mesh(2),1)
    nz1 = max(k_sample_mesh(3),1)
    deallocate(k_sample_mesh)
    nd = nx1*ny1*nz1
    if(ipridos >=2 ) write(nfout,'(" nd = ",i8)') nd
    allocate(vctk(4,3),vwork(4,3))
    if(ipridos>=2) write(nfout,'(" trmat = ",9f8.4)') trmat
    sumv = 0.d0
    do nt = 1, mtetra
       if(ipridos>=2) write(nfout,'(" nt = ",i8," : ",4i8)') nt, nttra(nt,1:4)
       do i = 1,4
          nn = nttra(nt,i)
          ix = mod(nn-1,nxx+1)
          iy = mod((nn-ix-1)/(nxx+1),nyy+1)
          iz = (nn-ix-1-iy*(nxx+1))/((nxx+1)*(nyy+1))
          nv(1) = ix*ny1*nz1; nv(2) = nx1*iy*nz1; nv(3) = nx1*ny1*iz
          if(ipridos >=2) write(nfout,'("  nvtk(",i4,",1:3) = ",3i8)') i,nv(1:3)
          vctk(i,1:3) = matmul(trmat,nv)/dble(nd)
       end do
       if(ipridos >=2) then
          write(nfout,'("  v(1) = ",3f8.4)') vctk(1,1:3)
          write(nfout,'("  v(2) = ",3f8.4)') vctk(2,1:3)
          write(nfout,'("  v(3) = ",3f8.4)') vctk(3,1:3)
          write(nfout,'("  v(4) = ",3f8.4)') vctk(4,1:3)
       end if

       do j = 1, 3
          vwork(1,j) = vctk(4,j) - vctk(1,j)
          vwork(2,j) = vctk(4,j) - vctk(2,j)
          vwork(3,j) = vctk(4,j) - vctk(3,j)
       enddo
       !     outer production
       vwork(4,1) = vwork(1,2)*vwork(2,3) - vwork(1,3)*vwork(2,2)
       vwork(4,2) = vwork(1,3)*vwork(2,1) - vwork(1,1)*vwork(2,3)
       vwork(4,3) = vwork(1,1)*vwork(2,2) - vwork(1,2)*vwork(2,1)
       !     inner procution
       voltt(nt) = dabs(dot_product(vwork(3,1:3),vwork(4,1:3)))/6.d0
       sumv = sumv + voltt(nt)
       if(ipridos >= 2) write(nfout,'(3x,i3,2x,f18.12)') nt,voltt(nt)
    end do
    if(ipridos >= 2) write(nfout,'(" sumv = ",f16.8, " univol*sumv/(2pi)**3 = ",f16.8)') sumv,univol*sumv/(PAI2*PAI2*PAI2)
    if(ipridos >= 2) write(nfout,'(" np2 = ",i8)') np2

    es = minval(eeig2)-0.005
    ee = maxval(eeig2)+0.005

    allocate(d(mdoswk))
    allocate(dos(nEwindows,neg))
    do iv = 1, mtetra
       v = 6.0d0*voltt(iv)*univol/(PAI2*PAI2*PAI2*nspin)
       write(nfout,'(" iv = ",i8," v = ",d12.4)') iv,v
       dos = 0.d0
       do ib = 1 ,neg
          do ie = 1, 4
             if(ip20(nttra(iv,ie)) > np2) then
                write(nfout,'(" nttra(iv,ie) = ",i8)') nttra(iv,ie)
             end if
             e(ie) = eeig2(ip20(nttra(iv,ie)),ib)
          end do
          do iswap1 = 1, 3
             do iswap2 = iswap1+1,4
                if(e(iswap1) < e(iswap2)) then
                   x = e(iswap1)
                   e(iswap1) = e(iswap2)
                   e(iswap2) = x
                end if
             end do
          end do
          if(e(4) > ee) cycle
          NS = (E(4) - ES)/DELTAE_dos + 1
          IF(NS.GT.nEwindows) cycle
          NE = (E(1) - ES)/DELTAE_dos + 1
          IF(NE.GT.nEwindows) NE = nEwindows

          write(nfout,'(" (iv,ib)=(",i4,",",i4,"), e = ",4f8.4," ns, ne = ",2i8)') iv,ib,e(1:4),ns,ne
          IF((NE-NS) == 0) THEN
             DOS(NS,ib) = DOS(NS,ib) + V/DELTAE_dos
          ELSE IF((NE-NS).EQ.1 ) THEN
             DOS(NS,ib) = DOS(NS,ib) + V/(2.D0*DELTAE_dos)
             DOS(NE,ib) = DOS(NE,ib) + V/(2.D0*DELTAE_dos)
          ELSE
             D(D34) = E(3) - E(4)
             D(D24) = E(2) - E(4)
             D(D14) = E(1) - E(4)
             D(D23) = E(2) - E(3)
             D(D13) = E(1) - E(3)
             D(D12) = E(1) - E(2)
             D(DM) = D(D13) + D(D24)
             D(DA) = (E(1)*E(2)-E(3)*E(4))/D(DM)

             if(d(d34).lt.deltae_dos) then
                f0 = 0.d0
             else
                f0 = v/(d(d34)*d(d24)*d(d14))
             endif

             F1 = V/D(DM)
             if(d(d23).lt.deltae_dos) then
                f2 = 0.d0
             else
                f2 = v*d(dm)/(d(d24)*d(d14)*d(d23)*d(d13))
             endif
             if(d(d12).lt.deltae_dos) then
                f3 = 0.d0
             else
                f3 = v/(d(d14)*d(d13)*d(d12))
             endif

             DO IDOS = NS, NE
                ED = ES + DELTAE_dos*(IDOS-0.5)
                IF(ED.LE.E(3)) THEN
                   DOS(IDOS,ib) = DOS(IDOS,ib) + (ED - E(4))*(ED - E(4)) * F0
                ELSE IF(ED.LE.E(2)) THEN
                   DOS(IDOS,ib) = DOS(IDOS,ib) + F1 - F2*(ED - D(DA))*(ED - D(DA))
                ELSE IF(ED.LE.E(1)) THEN
                   DOS(IDOS,ib) = DOS(IDOS,ib) + (ED - E(1))*(ED - E(1)) * F3
                ENDIF
             end DO
          ENDIF
          write(nfout,'(" tetra = ",i8," ik = ",4i8," ns,ne=",2i8)') &
               & iv, (ip20(nttra(iv,ie)),ie=1,4), ns, ne
!!$),ip20(nttra(iv,2)),ip20(nttra(iv,3)),ip20(nttra(iv,4)),ns,ne
          write(nfout,'(" dos = ",6d12.4)') (dos(idos,ib),idos=min(ns+10,ne),min(ns+15,ne))
          do ie = 1, 4
             i = ip20(nttra(iv,ie))
             do idos = ns, ne
                cdos(i,ib,idos) = cdos(i,ib,idos) + dos(idos,ib)*0.25/wei
             end do
          end do
       end do
    end do
    do i = 1, np2
       do ib = 1, neg
          cind(i,ib,1) = cdos(i,ib,1)*deltaE_dos
          do idos = 2, nEwindows
             cind(i,ib,idos) = cind(i,ib,idos-1)+cdos(i,ib,idos)*deltaE_dos
          end do
       end do
    end do
    deallocate(d)
    deallocate(dos)
    deallocate(vctk,vwork)
    deallocate(voltt,nttra)
  end subroutine doscal_nstt

  subroutine m_ESdos_rd_pdos_param(nfout)
    use m_Const_Parameters, only : FMAXVALLEN, ON, NOCONV, LOWER &
          &                      , Projector, Wavefunction, Mulliken
    use m_Ionic_System, only : speciesname,ntyp
    integer, intent(in) :: nfout

    character(len=FMAXVALLEN) :: rstr
    integer :: iret, f_selectBlock, f_getStringValue, f_getIntValue
    integer :: f_selectTop, f_selectParentBlock
    real(kind=DP) :: dret
    logical :: prealloc, tag_is_found
    integer :: i,it,n

    iret = f_selectTop()

    if( f_selectBlock(tag_postprocessing) == 0) then

! --- pdos
       if( f_selectBlock(tag_pdos) == 0) then
          if(f_getIntValue( tag_sw_orb_popu, iret) == 0) sw_orb_popu = iret
          if(f_getIntValue( tag_sw_pdos, iret) == 0) then
             sw_pdos = iret
             if(sw_pdos == ON) sw_orb_popu = ON
!             if ( sw_pdos == ON ) sw_dos = ON
          end if
          if(f_getIntValue( tag_use_rotated_compri, iret) == 0) then
             use_rotated_compri = iret
          endif
!!$if(sw_orb_popu == ON) then
!!$   iret = f_getStringValue(tag_method,rstr,LOWER)
!!$   if( rstr == tag_projector) then
!!$      pdos_method = Projector
!!$   else if( rstr == tag_wavefunction) then
!!$      pdos_method = Wavefunction
!!$   else if( rstr == tag_mulliken) then
!!$      pdos_method = Mulliken
!!$   end if
!!$   if( f_selectBlock(tag_orbitals) == 0) then
!!$      prealloc = .true.
!!$      call set_orbitals(prealloc) ! --> norbital
!!$      prealloc = .false.
!!$      call set_orbitals(prealloc) ! --> l_orb,t_orb
!!$      iret = f_selectParentBlock()
!!$   else
!!$      stop ' orbitals are not given properly in the inputfile'
!!$   end if
!!$end if
          if(ipriinputfile >= 1) then
             write(nfout,'(" !** sw_pdos             = ",i3)') sw_pdos
             write(nfout,'(" !** sw_orb_popu         = ",i3)') sw_orb_popu
!!$write(nfout,'(" !** pdos_method         = ",i3)') pdos_method
!!$if(sw_orb_popu == ON) then
!!$   write(nfout,'(" !** === orbitals === ")')
!!$   write(nfout,'(" !**   no   l   t   rc       k         type")')
!!$   n = 0
!!$   do it=1,ntyp
!!$      do i=1,norbital(it)
!!$         n = n + 1
!!$         write(nfout,'(" !** ",3i4,2f10.5,a6)') &
!!$           & n,l_orb(i,it),t_orb(i,it),rc_orb(i,it),k_orb(i,it),speciesname(it)
!!$      end do
!!$   end do
!!$end if
          end if
          iret = f_selectParentBlock()
       end if             ! pdos
       iret = f_selectParentBlock()
    end if

  contains

    subroutine set_orbitals(prealloc)
      logical, intent(in) :: prealloc

      character(len=FMAXVALLEN) :: rstr
      integer :: i,iret,ip,rint,it
      integer :: f_selectFirstTableLine, f_selectNextTableLine &
           &, f_getIntValue, f_getRealValue, f_getStringValue
      real(kind=DP) :: dret
      logical :: first

      if(.not.prealloc) then
         maxorb = 0
         do it=1,ntyp
            maxorb = max(maxorb,norbital(it))
         end do
         allocate(l_orb(maxorb,ntyp))
         allocate(t_orb(maxorb,ntyp))
         allocate(rc_orb(maxorb,ntyp)); rc_orb=0.d0
         allocate(k_orb(maxorb,ntyp)); k_orb=0.d0
      else
         allocate(norbital(ntyp)); norbital = 0
      end if

      do it=1,ntyp
         i = 1
         first = .true.
         do while(.true.)
            if (first) then
               if(f_selectFirstTableLine() /= 0) then
                  exit
               end if
               first = .false.
            else
               if(f_selectNextTableLine() /= 0) then
                  exit
               end if
            end if
            iret = f_getStringValue(tag_element,rstr,NOCONV)
            if(rstr == speciesname(it)) then
               if(.not.prealloc) then
                  ip = i
                  if( f_getIntValue(tag_l, rint) == 0) l_orb(ip,it) = rint
                  if( f_getIntValue(tag_t, rint) == 0) t_orb(ip,it) = rint
                  if( f_getRealValue(tag_rc, dret, 'bohr') == 0) rc_orb(ip,it) = dret
                  if( f_getRealValue(tag_k, dret, '') == 0) k_orb(ip,it) = dret
               end if
               i = i + 1
            end if

         end do
         norbital(it) = i - 1
      end do

    end subroutine set_orbitals

  end subroutine m_ESdos_rd_pdos_param

  subroutine prepare_nttra(nxyz_tetra,mtetra,nttra)
    integer, intent(in),  dimension(3)        :: nxyz_tetra
    integer, intent(in)                       :: mtetra
    integer, intent(out), dimension(mtetra,4) :: nttra

    integer :: npx,npy,icub,ix,iy,iz,ni,kx,ky,kz,ip0
    integer, allocatable, dimension(:) :: ip8

    allocate(ip8(8))
    npx = nxyz_tetra(1)+1
    npy = nxyz_tetra(2)+1
    icub = 0
    do iz = 0, nxyz_tetra(3)-1
       do iy = 0, nxyz_tetra(2)-1
          do ix = 0, nxyz_tetra(1)-1
             icub = icub+1
             ni=npx*(npy*iz+iy)+ix
             do kz=1,2
                do ky=1,2
                   do kx=1,2
                      ip0 = ni+npx*(npy*(kz-1)+ky-1)+kx
                      ip8(kx+2*(ky-1)+4*(kz-1)) = ip0
                   end do
                end do
             end do
             nttra((icub-1)*6+1, 1:4) = (/ip8(1),ip8(2),ip8(4),ip8(8)/)
             nttra((icub-1)*6+2, 1:4) = (/ip8(1),ip8(2),ip8(6),ip8(8)/)
             nttra((icub-1)*6+3, 1:4) = (/ip8(1),ip8(5),ip8(6),ip8(8)/)
             nttra((icub-1)*6+4, 1:4) = (/ip8(1),ip8(3),ip8(4),ip8(8)/)
             nttra((icub-1)*6+5, 1:4) = (/ip8(1),ip8(3),ip8(7),ip8(8)/)
             nttra((icub-1)*6+6, 1:4) = (/ip8(1),ip8(5),ip8(7),ip8(8)/)
          end do
       end do
    end do
    deallocate(ip8)
  end subroutine prepare_nttra

  subroutine care_of_degenerate_state(neig,np2,nspin,ispin,eeig2,dos_weight2)
    integer, intent(in) :: neig,np2,nspin,ispin
!!$    real(kind=DP),intent(in),dimension(neig,np2,nspin) :: eeig2
    real(kind=DP),intent(in),dimension(np2,neig,nspin) :: eeig2
    real(kind=DP),intent(inout),dimension(neig,np2) :: dos_weight2(neig,np2)
    real(kind=DP) :: eps,c1
    integer :: k2, ieig, n, i, ie
! ---- following lines are the later part of subroutine nstt3i --
!     take care of a weight on a degenerate state
!
    eps = dfloat(10)**(-5)

    do k2=1,np2
       if(ipridos >= 3) write(nfout,'(" k2 = ",i5," <<care_of_degenerate_state>>")') k2
       ieig=1
40     continue
       n=1
!!$do 42 i=1,20
       do i=1,neig
          if(ieig+i.gt.neig) go to 44
          if(dabs(eeig2(k2,ieig+i,ispin)-eeig2(k2,ieig,ispin)).lt.eps) then
             n=n+1
             cycle
          end if
          go to 44
       end do

44     continue

       if(ipridos >= 3) write(nfout,'("       n = ",i5)')  n
       c1=0
       do i=0,n-1
          if(ieig+i>neig) then
             if(ipridos>=1) write(nfout,'(" ieig+i = ",i8," > neig = ",i8)') ieig+i,neig
             cycle
          end if
          c1=c1+dos_weight2(ieig+i,k2)
       end do
       c1=c1/n
       do i=0,n-1
          if(ieig+i>neig) then
             if(ipridos>=1) write(nfout,'(" ieig+i = ",i8," > neig = ",i8)') ieig+i,neig
             cycle
          end if
          dos_weight2(ieig+i,k2)=c1
       end do
       ieig=ieig+n
       if(ieig.lt.neig) go to 40
    end do
  end subroutine care_of_degenerate_state


  subroutine m_ESdos_rd_pcohp_param(nfout)
    use m_Const_Parameters, only : FMAXVALLEN, ON, LOWER
    integer, intent(in) :: nfout

    character(len=FMAXVALLEN) :: rstr
    integer :: iret, f_selectBlock, f_getStringValue, f_getIntValue, f_getRealValue
    integer :: f_selectTop, f_selectParentBlock
    real(kind=DP) :: dret
    logical :: prealloc, tag_is_found
    integer :: i,it,n

    iret = f_selectTop()

    if( f_selectBlock(tag_postprocessing) == 0) then
! ---  pcohp --
       if( f_selectBlock( tag_pcohp ) == 0) then
          if ( f_getIntValue( tag_sw_calc_pcohp, iret) == 0) sw_calc_pcohp = iret

          if ( sw_calc_pcohp == ON ) then
             if ( nopr > 1 ) call phase_error_with_msg(nfout,"Nopr > 1 is no supported",__LINE__,__FILE__)

             sw_dos = ON ;  sw_pdos = ON;  orb_popu_method = 2
             if(printable) then
                write(nfout,'(A)') "!** orb_popu_method is forced to be 2"
             endif

             if ( f_getIntValue( tag_atom1, iret) == 0 ) then
                if ( iret > 0 .and. iret <= natm ) then
                   atom1_pcohp = iret
                else
                   write(*,*) "set atom1 in the range [1: ", natm ,"]"
                   call phase_error_with_msg(nfout,'set atom1 in the range [1:natm]',__LINE__,__FILE__)
                endif
             endif
             if ( f_getRealValue( tag_max_distance_from_atom1, dret, "") == 0) then
                max_distance_from_atom1_pcohp = dret
             endif
             if(printable) then
                write(nfout,*) ' ** atom1 of pcohp is ', atom1_pcohp
                write(nfout,*) ' ** max_distance_from_atom1 is ', &
                     &              max_distance_from_atom1_pcohp
             endif
          endif
          iret = f_selectParentBlock()
       endif
! ----------
    end if
  end subroutine m_ESdos_rd_pcohp_param

  subroutine m_ES_calc_pcohp
    integer :: ia, ja, it1, it2
    integer :: ik, ispin, lmt1, lmt2
    integer :: i, is, ie, id
    real(kind=DP) :: c1, w, e, El, Eu, tl, tu, Es, DeltaE, distance
    complex(kind=CMPLDP) :: z1

    real(kind=DP) :: derf

    complex(kind=CMPLDP), allocatable :: mat_p(:,:,:)
    complex(kind=CMPLDP), allocatable :: mat_h(:,:)

    integer, parameter :: lun = 355

! --- init --
    allocate( mat_p( neg,nlmt_phi,nlmt_phi ) );
    allocate( mat_h( nlmt_phi,nlmt_phi ) );

    allocate( pcohp( 1:nEwindows,nlmt_phi,nlmt_phi,nspin ) );
    allocate( sum_pcohp( 1:nEWindows,nlmt_phi,nlmt_phi,nspin ) );

    DeltaE = DeltaE_dos
    Es = Eminimum - DeltaE*0.5d0

    if ( mype == 0 ) then
       open( unit=lun, file='pcohp.data', status='unknown', form ='formatted' )
    endif

! ---- begin -----
    ia = atom1_pcohp
    Do ja=1, natm
       if ( ia == ja ) cycle

       call calc_distance_from_atom1( ia, ja, distance )
       if ( distance > max_distance_from_atom1_pcohp ) cycle

       it1 = ityp(ia);  it2 = ityp(ja)

       pcohp = 0.0d0;     sum_pcohp = 0.0d0

       Do ik=1, kv3
          ispin = mod( ik -1, nspin ) +1
          call calc_matrix_p_nosym( ik, ia, ja, mat_p )
          call calc_matrix_h( ik, ia, ja, mat_p, mat_h )

          Do lmt1=1, ilmt_phi(it1)
             Do lmt2=1, ilmt_phi(it2)

                do i = 1, neg
                   w = 1.d0
                   z1 = mat_p(i,lmt1,lmt2) *conjg( mat_h(lmt1,lmt2) )
                   c1 = real(z1)

                   e = eko(i,ik) -nETailWindows*DeltaE -Es
                   is = e /DeltaE;      ie = is +2*nETailWindows

                   if (is < 0) is = 0
                   if (ie >= nEWindows )ie = nEWindows-1

                   do id = is, ie
                      El = Es + id*DeltaE;    Eu = El + DeltaE
                      tl = (El -eko(i,ik))*sqrtdVI;   tu = (Eu -eko(i,ik))*sqrtdVI

                      pcohp(id+1,lmt1,lmt2,ispin) = pcohp(id+1,lmt1,lmt2,ispin) &
                           & + c1 *w *2 *(derf(tu) -derf(tl)) *0.5d0 /DeltaE &
                           &            *qwgt(ik)
                   end do
                end do
             end Do
          end Do
          ! ---- integ --
          Do lmt1=1, ilmt_phi(it1)
             Do lmt2=1, ilmt_phi(it2)
                sum_pcohp(1,lmt1,lmt2,ispin) = pcohp(1,lmt1,lmt2,ispin)*DeltaE
                do id = 1, nEWindows-1
                   sum_pcohp(id+1,lmt1,lmt2,ispin) &
                        & = sum_pcohp(id,lmt1,lmt2,ispin) &
                        &   +pcohp(id+1,lmt1,lmt2,ispin) *DeltaE
                end do
             End Do
          ENd Do

       end Do   ! ik
       ! --
       if ( mype == 0 )  then
!          call write_pcohp_full( lun, ia, ja )
          call write_pcohp_sum_over_atom( lun, ia, ja )
       endif
    End Do

    ! --- finalize--
    if ( mype == 0 ) close( lun )

    deallocate( mat_p ); deallocate( mat_h )
    deallocate( pcohp ); deallocate( sum_pcohp )

  contains

    subroutine calc_distance_from_atom1( ia, ja, dist_min )
      integer, intent(in) :: ia, ja
      real(kind=DP), intent(out) :: dist_min

      integer :: nx, ny, nz
      real(kind=DP) :: x1, y1, z1, dist

      dist_min = 1.0D3
      Do nx=-1, 1
         Do ny=-1, 1
            Do nz=-1, 1
               x1 = cps(ja,1) -cps(ia,1) +nx*altv(1,1) +ny*altv(1,2) +nz*altv(1,3)
               y1 = cps(ja,2) -cps(ia,2) +nx*altv(2,1) +ny*altv(2,2) +nz*altv(2,3)
               z1 = cps(ja,3) -cps(ia,3) +nx*altv(3,1) +ny*altv(3,2) +nz*altv(3,3)
               dist = sqrt( x1**2 +y1**2 +z1**2 )
               dist_min = min( dist_min, dist )
            End Do
         ENd Do
      End Do
    end subroutine calc_distance_from_atom1

  end subroutine m_ES_calc_pcohp

  subroutine write_pcohp_full( nf, ia, ja )
    integer, intent(in) :: nf, ia, ja

    integer :: it1, it2, lmt1, lmt2, il1, il2, im1, im2, tau1, tau2
    integer :: id, nrEWindows, ii, i, nwdwidth
    real(kind=DP) :: e, e_eV, pcohp_hr, pcohp_hr2, sum_pcohp_avr, sum_pcohp_avr2
    real(kind=DP) :: pcohp_eV, pcohp_eV2, sumtotal

    if(nwd_dos_window_width >= 1 .and. nwd_dos_window_width <= nEWindows) then
       nwdwidth = nwd_dos_window_width
    else
       nwdwidth = 1
    end if
    id = nwdwidth/2
    nrEWindows = nEWindows/nwdwidth * nwdwidth

    if ( iproj_group(ia)== 0 ) return
    if ( iproj_group(ja)== 0 ) return

    if ( if_pdos(ia)== 0 ) return
    if ( if_pdos(ja)== 0 ) return

    it1 = ityp(ia);     it2 = ityp(ja)

    Do lmt1=1, ilmt_phi(it1)
       il1 = ltp_phi(lmt1,it1); im1 = mtp_phi(lmt1,it1);  tau1 = taup_phi(lmt1,it1)

       Do lmt2=1, ilmt_phi(it2)
          il2 = ltp_phi(lmt2,it2); im2 = mtp_phi(lmt2,it2);  tau2 = taup_phi(lmt2,it2)

          write(nf,'(A,I5,3(A,I3),A,I5,3(A,I3))') &
               &       "-PCOHP: ia= ", ia, " l=", il1-1," m=", im1," t=", tau1, &
               &       "        ja= ", ja, " l=", il2-1," m=", im2," t=", tau2

          if (nspin == 1) then
             write(nf,*) "     E(eV)          pcohp(eV)           sum(eV)"
             do i = 1, nrEWindows, nwdwidth
                e = Eminimum + (i-1+id)*DeltaE_dos
                e_eV = (e - ValenceBandMaximum)*Hartree
                pcohp_hr = 0.d0;  sum_pcohp_avr = 0.d0

                do ii = i, i+nwdwidth-1
                   pcohp_hr = pcohp_hr + pcohp(ii,lmt1,lmt2,nspin)
                   sum_pcohp_avr = sum_pcohp_avr + sum_pcohp(ii,lmt1,lmt2,nspin)
                end do
                pcohp_hr = pcohp_hr /nwdwidth;
                sum_pcohp_avr = sum_pcohp_avr /nwdwidth
!                pcohp_eV = pcohp_hr /Hartree    ! ???
                pcohp_eV = pcohp_hr

                write(nf,'(f14.6,f18.10,f20.10)') &
                     &     e_eV, -pcohp_eV, -sum_pcohp_avr
             end do

          else if(nspin == 2) then
             write(nf,*) "   E(eV)         pcohp_up(eV)        pcohp_down(eV)" &
                  & ,"   sum_up    sum_down  sum_total"

             do i = 1, nrEWindows, nwdwidth
                e = Eminimum + (i-1+id)*DeltaE_dos
                e_eV = (e - ValenceBandMaximum)*Hartree
                pcohp_hr = 0.d0; pcohp_hr2 = 0.d0;
                sum_pcohp_avr = 0.d0; sum_pcohp_avr2 = 0.d0

                do ii = i, i+nwdwidth-1
                   pcohp_hr  = pcohp_hr  + pcohp(ii,lmt1,lmt2,1)
                   pcohp_hr2 = pcohp_hr2 + pcohp(ii,lmt1,lmt2,2)
                   sum_pcohp_avr  = sum_pcohp_avr  + sum_pcohp(ii,lmt1,lmt2,1)
                   sum_pcohp_avr2 = sum_pcohp_avr2 + sum_pcohp(ii,lmt1,lmt2,2)
                end do
                pcohp_hr = pcohp_hr/nwdwidth; pcohp_hr2 = pcohp_hr2/nwdwidth
                sum_pcohp_avr = sum_pcohp_avr/nwdwidth;
                sum_pcohp_avr2 = sum_pcohp_avr2/nwdwidth

!                pcohp_eV  = pcohp_hr/Hartree
!                pcohp_eV2 = pcohp_hr2/Hartree
                pcohp_eV  = pcohp_hr;
                pcohp_eV2 = pcohp_hr2
                sumtotal = sum_pcohp_avr + sum_pcohp_avr2
                write(nf,'(f15.4,2f18.10,3f10.4)') &
                     &    e_eV, -pcohp_eV, -pcohp_eV2, &
                     &    -sum_pcohp_avr, -sum_pcohp_avr2, -sumtotal
             end do
          end if
          write(nf,*) 'END'
       end Do
    end Do

  end subroutine write_pcohp_full

  subroutine write_pcohp_sum_over_atom( nf, ia, ja )
    integer, intent(in) :: nf, ia, ja

    integer :: it1, it2, lmt1, lmt2, il1, il2, im1, im2, tau1, tau2
    integer :: id, nrEWindows, ii, i, nwdwidth
    real(kind=DP) :: e, e_eV, pcohp_hr, pcohp_hr2, sum_pcohp_avr, sum_pcohp_avr2
    real(kind=DP) :: pcohp_eV, pcohp_eV2, sumtotal

    if(nwd_dos_window_width >= 1 .and. nwd_dos_window_width <= nEWindows) then
       nwdwidth = nwd_dos_window_width
    else
       nwdwidth = 1
    end if
    id = nwdwidth/2
    nrEWindows = nEWindows/nwdwidth * nwdwidth

    if ( iproj_group(ia)== 0 ) return
    if ( iproj_group(ja)== 0 ) return

    if ( if_pdos(ia)== 0 ) return
    if ( if_pdos(ja)== 0 ) return

    it1 = ityp(ia);     it2 = ityp(ja)

    write(nf,'(A,I5,A,I5)') &
         &       "-PCOHP: ia= ", ia, "        ja= ", ja
    if (nspin == 1) then
       write(nf,*) "     E(eV)          pcohp(eV)           sum(eV)"
       do i = 1, nrEWindows, nwdwidth
          e = Eminimum + (i-1+id)*DeltaE_dos
          e_eV = (e - ValenceBandMaximum)*Hartree
          pcohp_hr = 0.d0;  sum_pcohp_avr = 0.d0

          Do lmt1=1, ilmt_phi(it1)
             Do lmt2=1, ilmt_phi(it2)
                do ii = i, i+nwdwidth-1
                   pcohp_hr = pcohp_hr + pcohp(ii,lmt1,lmt2,nspin)
                   sum_pcohp_avr = sum_pcohp_avr + sum_pcohp(ii,lmt1,lmt2,nspin)
                end do
             End Do
          End Do
          pcohp_hr = pcohp_hr /nwdwidth;
          sum_pcohp_avr = sum_pcohp_avr /nwdwidth
!                pcohp_eV = pcohp_hr /Hartree    ! ???
          pcohp_eV = pcohp_hr
          sum_pcohp_avr = sum_pcohp_avr *Hartree

          write(nf,'(f14.6,f18.10,f20.10)') &
               &     e_eV, -pcohp_eV, -sum_pcohp_avr
       end do
    else if(nspin == 2) then
       write(nf,*) "   E(eV)         pcohp_up(eV)        pcohp_down(eV)" &
            & ,"sum_up   sum_down sum_total"
       do i = 1, nrEWindows, nwdwidth
          e = Eminimum + (i-1+id)*DeltaE_dos
          e_eV = (e - ValenceBandMaximum)*Hartree
          pcohp_hr = 0.d0; pcohp_hr2 = 0.d0;
          sum_pcohp_avr = 0.d0; sum_pcohp_avr2 = 0.d0

          Do lmt1=1, ilmt_phi(it1)
             Do lmt2=1, ilmt_phi(it2)
                do ii = i, i+nwdwidth-1
                   pcohp_hr  = pcohp_hr  + pcohp(ii,lmt1,lmt2,1)
                   pcohp_hr2 = pcohp_hr2 + pcohp(ii,lmt1,lmt2,2)
                   sum_pcohp_avr  = sum_pcohp_avr  + sum_pcohp(ii,lmt1,lmt2,1)
                   sum_pcohp_avr2 = sum_pcohp_avr2 + sum_pcohp(ii,lmt1,lmt2,2)
                end do
             end Do
          end Do
          pcohp_hr = pcohp_hr/nwdwidth; pcohp_hr2 = pcohp_hr2/nwdwidth
          sum_pcohp_avr = sum_pcohp_avr/nwdwidth;
          sum_pcohp_avr2 = sum_pcohp_avr2/nwdwidth

!                pcohp_eV  = pcohp_hr/Hartree
!                pcohp_eV2 = pcohp_hr2/Hartree
          pcohp_eV  = pcohp_hr
          pcohp_eV2 = pcohp_hr2

          sum_pcohp_avr  = sum_pcohp_avr  *Hartree
          sum_pcohp_avr2 = sum_pcohp_avr2 *Hartree

          sumtotal = sum_pcohp_avr + sum_pcohp_avr2
          write(nf,'(f15.4,2f18.10,3f10.4)') &
               &    e_eV, -pcohp_eV, -pcohp_eV2, &
               &    -sum_pcohp_avr, -sum_pcohp_avr2, -sumtotal
       end do
    end if
    write(nf,*) 'END'
  end subroutine write_pcohp_sum_over_atom

  subroutine calc_matrix_H( ik, ia, ja, mat_p, mat_H )
    integer, intent(in) :: ia, ja, ik
    complex(kind=CMPLDP), intent(in)  :: mat_p(neg,nlmt_phi,nlmt_phi)
    complex(kind=CMPLDP), intent(out) :: mat_h(nlmt_phi,nlmt_phi)

    integer :: it1, it2, lmt1, lmt2, ie
    complex(kind=CMPLDP) :: z1

    it1 = ityp(ia);     it2 = ityp(ja)

    mat_h = 0.0d0

    Do lmt1=1, ilmt_phi(it1)
       Do lmt2=1, ilmt_phi(it2)
          z1 = 0.0d0
          Do ie=1, neg
!             z1 = z1 + ( eko(ie,ik) -ValenceBandMaximum ) *mat_p(ie,lmt1,lmt2)
             z1 = z1 + eko(ie,ik) *mat_p(ie,lmt1,lmt2)
          End Do
          mat_h(lmt1,lmt2) = z1
       End Do
    End Do
  end subroutine calc_matrix_H

  subroutine calc_matrix_P_nosym( ik, ia, ja, mat_p )
    integer, intent(in) :: ia, ja, ik
    complex(kind=CMPLDP), intent(out) :: mat_p(neg,nlmt_phi,nlmt_phi)

    integer :: it1, it2, iorb1, iorb2, lmt1, lmt2, iopr1, iopr2, ie, i
    complex(kind=CMPLDP) :: porb, z1, z2
    logical :: First = .true.

    it1 = ityp(ia);     it2 = ityp(ja)

    mat_p = 0.0d0

    Do ie=1, neg
       Do lmt1=1, ilmt_phi(it1)
          iorb1 = lmta_phi(lmt1,ia)

          Do lmt2=1, ilmt_phi(it2)
             iorb2 = lmta_phi(lmt2,ja)

             porb = 0.0d0
             if ( k_symmetry(ik) == GAMMA ) then
                do iopr1=1, 1
                   porb = porb +compr(ie,iorb1,iopr1,ik) &
                        &      *compr(ie,iorb2,iopr1,ik) /2.0d0
                end do
             else
                Do iopr1=1, 1
                   z1 = cmplx( compr(ie,iorb1,iopr1,ik), compi(ie,iorb1,iopr1,ik) )
                   z2 = cmplx( compr(ie,iorb2,iopr1,ik), compi(ie,iorb2,iopr1,ik) )
                   porb = porb +conjg(z1)* z2
                end do
             endif
             mat_p( ie, lmt1, lmt2 ) = porb

          ENd Do
       End Do
    End Do
  end subroutine calc_matrix_P_nosym

! --*----1----*----2----*----3----*----4----*----5----*----6----*----7
!
  subroutine nstt5i_3D(ipri,idim,es,ee,newindows,nxyz_tetra, &
       &     np2,lmnp2e,neig, &
       &     eeig,ip20,np0,lmnp2c,lmneig,mtetra,nttra,deltae,dos_weight, &
       &     nep,dos,dosin,cdos,csumdos)
!
!     nstt0i, nstt1i, nstt2i and nstt3i are merged into
!  this subroutine nstt5i
!               by T. Yamasaki, Aug 2007
!
    integer, intent(in) :: ipri,idim, newindows
    real(kind=DP), intent(in) :: es,ee, deltae
    integer, intent(in) ::  nxyz_tetra(3)
    integer, intent(in) :: np2,lmnp2e,neig,lmneig,np0,mtetra,lmnp2c,nep
    real(kind=DP), intent(in), dimension(lmnp2e,lmneig) :: eeig
    integer, intent(in), dimension(np0)  :: ip20
    integer, intent(in), dimension(mtetra,4) :: nttra
    real(kind=DP), intent(in), dimension(lmneig,lmnp2c) :: dos_weight
    real(kind=DP), intent(out), dimension(0:nep,4) :: dos,dosin
    real(kind=DP), intent(out), dimension(0:newindows) :: cdos,csumdos

    integer :: ieb(4)

    real(kind=DP), dimension(4) :: eb
    integer :: ncounter,ncounter1,ncounter2,ncounter3
    real(kind=DP) :: etime1,etime2,etime3, wct_now, wct_start,etime4,etime5,etime0
    real(kind=DP) :: d21,d31,d41,d32,d42,d43,e,d1,d2,d3,d4,yy,x,y,xx,td21,yy3,d2d2,d2d2d2,d3d3 &
         &          ,x1,x2,x3,x4,x5,x6,y1,y2,y3,y4,esum,e1,e2,e3,e4,w,tdos
    integer :: ierr,itmp,nxx,nyy,nzz,npx,npy,npz,np,ncub,ntet,iloop,iv,ne1,ns,ns2,ns3,ne2,idos,ie,ib,ip,ne, ib_t

    nxx = nxyz_tetra(1); nyy = nxyz_tetra(2); nzz = nxyz_tetra(3)
    npx = nxx+1
    npy = nyy+1
    npz = nzz+1
    np = npx*npy*npz
    ncub = nxx*nyy*nzz
    ntet = 6*ncub

    dos = 0.0d0
    dosin = 0.0d0
    cdos = 0.0d0
    csumdos = 0.0d0
    if(ipri.ge.2) write(nfout,'(" np = ",i5," np2 = ",i5," idim = ",i5," ntet = ",i5)') np,np2,idim,ntet

    ncounter = 0
    ncounter1 = 0
    ncounter2 = 0
    ncounter3 = 0

    etime0 = 0.d0
    etime1 = 0.d0
    etime2 = 0.d0
    etime3 = 0.d0
    etime4 = 0.d0
    etime5 = 0.d0

    iloop = 0
    do iv = 1, ntet
       if(mod(iv,npes)/=(mype+1)) cycle
       if(ipri.ge.2) then
          write(nfout,'(" iv = ",i8)') iv
          write(nfout,'(" -- nttra  = ",4i8)') (nttra(iv,ie),ie=1,4)
       endif
!!$       do ib_t = 1, np_e
!!$          ib = ib_t + ista_e - 1
       do ib = 1, neig
          call gettod(wct_start)
          do ie = 1,4
             ieb(ie) = ip20(nttra(iv,ie))
             eb(ie) = eeig(ieb(ie),ib)
          end do

          call nsttod(eb,ieb)

          e1 = eb(1)
          e2 = eb(2)
          e3 = eb(3)
          e4 = eb(4)
          call nstts1(e1,e2,e3,e4)
          if(ipri.ge.3) then
             write(nfout,'(" (iv,ib) = (",2i5,") e(1:4) = ",4f9.5, " ieb(1:4) = ",4i3)') &
                  & iv,ib,e1,e2,e3,e4 ,ieb(1),ieb(2),ieb(3),ieb(4)
          end if
          if(e1 > ee) cycle
          ns = (e1 - es)/deltae
          if(es+deltae*ns .lt. e1) ns = ns + 1
          ne = (e4 - es)/deltae+1
          if(es+deltae*ne .ge. e4) ne = ne - 1
          if(es+deltae*ne .ge. e4) ne = ne - 1

          iloop = iloop + (ne-ns+1)
          ne1 = (e2-es)/deltae
          if(es+deltae*ne1>e2) ne1 = ne1-1
          ns2 = ne1+1
          ns3 = (e3-es)/deltae+1
          if(es+deltae*ns3 < e3) ns3 = ns3+1
          ne2 = ns3-1

          if(ipri .ge. 2) then
             write(nfout,'(" ns, ne1 = ",2i8," e = ",f9.5," - ",f9.5)')  ns,ne1,es+deltae*ns,es+deltae*ne1
             write(nfout,'(" ns2,ne2 = ",2i8," e = ",f9.5," - ",f9.5)')  ns2,ne2,es+deltae*ns2,es+deltae*ne2
             write(nfout,'(" ns3,ne  = ",2i8," e = ",f9.5," - ",f9.5)')  ns3,ne,es+deltae*ns3,es+deltae*ne
             if(es+deltae*ns <e1)write(nfout,'(" !! es+deltae+ns  < e1")')
             if(es+deltae*ne1>e2)write(nfout,'(" !! es+deltae*ne1 > e2")')
             if(es+deltae*ns2<e2)write(nfout,'(" !! es+deltae*ns2 < e2")')
             if(es+deltae*ne2>e3)write(nfout,'(" !! es+deltae*ne2 > e3")')
             if(es+deltae*ns3<e3)write(nfout,'(" !! es+deltae*ns3 < e3")')
             if(es+deltae*ne >e4)write(nfout,'(" !! es+deltae*ne  > e4")')
          end if

          call gettod(wct_now)
          etime0 = etime0 + (wct_now-wct_start)*1.d-6

          call gettod(wct_start)

          d21=e2-e1
          d31=e3-e1
          d41=e4-e1
          d32=e3-e2
          d42=e4-e2
          d43=e4-e3
          ncounter1 = ncounter1+(ne1-ns+1)
          do idos = ns, ne1
             e = es + deltae*idos
             d1=e-e1
             d4=e4-e
             d2=e2-e
             d3=e3-e
             yy=d41*d31*d21
             x=d2/d21+d3/d31+d4/d41
             y=(d1*d1)/yy
             dos(idos,1)=x*y
             dosin(idos,1)=0.25*d1*y*(x+1.0)
             xx=d1*d1*d1
             x=xx/(d21*yy)
             dos(idos,2)=x
             dosin(idos,2)=0.25*d1*x
             x=xx/(d31*yy)
             dos(idos,3)=x
             dosin(idos,3)=0.25*d1*x
             x=xx/(d41*yy)
             dos(idos,4)=x
             dosin(idos,4)=0.25*d1*x
          end do
          call gettod(wct_now)
          etime1 = etime1 + (wct_now-wct_start)*1.d-6

          call gettod(wct_start)
          ncounter3 = ncounter3+(ne-ns3+1)
          do idos = ns3,ne
             e = es + deltae*idos
             d1=e-e1
             d4=e4-e
             d2=e-e2
             d3=e-e3
             xx=d4*d4*d4
             yy=d41*d42*d43
             x=xx/(d41*yy)
             dos(idos,1)=x
             dosin(idos,1)=0.25*(1.0-d4*x)
             x=xx/(d42*yy)
             dos(idos,2)=x
             dosin(idos,2)=0.25*(1.0-d4*x)
             x=xx/(d43*yy)
             dos(idos,3)=x
             dosin(idos,3)=0.25*(1.0-d4*x)
             x=d3/d43+d2/d42+d1/d41
             y=(d4*d4)/yy
             dos(idos,4)=x*y
             dosin(idos,4)=0.25*(1.0-d4*y*(x+1.0))
          end do
          call gettod(wct_now)
          etime3 = etime3 + (wct_now-wct_start)*1.d-6

          call gettod(wct_start)
          ncounter2 = ncounter2+(ne2-ns2+1)
          td21 = 3.0*d21
          yy3=1.0/(d31*d42)+1.0/(d41*d32)
          do idos=ns2,ne2
             e = es + deltae*idos
!!$               e = es+deltae*(idos-0.5)
             d1=e-e1
             d4=e4-e
             d2=e-e2
             d3=e3-e
             d2d2 = d2*d2
             d2d2d2 = d2d2*d2
             d3d3 = d3*d3
             x1=(d3d3)/(d31*d31*d32)*(d2/d42+d1/d41)
             x2=(d4*d4)/(d41*d41*d42)*(d2/d32+d1/d31)
             x3=(d3*d4*d1)/(d31*d41)*yy3
             dos(idos,1)=0.5*(x1+x2+x3)
             x1=d2d2*(d32*d2+3.0*d3*(d32+d3))/12.0
             y1=x1
             x1=x1/(d31*d31*d32*d42)
             x2=d2*(d2d2*(d31+td21)+3.0*d3*(d2*d3+d32*(td21+d1)))
             x2=x2/12.0
             y2=x2
             x2=x2/(d31*d31*d32*d41)
             x3=d2d2*(d42*d2+3.0*d4*(d42+d4))/12.0
             y3=x3
             x3=x3/(d41*d41*d42*d32)
             x4=d2*(d2d2*(d41+td21)+3.0*d4*(d2*d4+d42*(td21+d1)))
             x4=x4/12.0
             y4=x4
             x4=x4/(d41*d41*d42*d31)
             x5=0.5*d2*d3*d4*(d1+d21)
             x5=x5+d2d2*(2.0*d21*(d3+d42) +(d1+d21)*(2.0*d3+d4+d42))/12.0
             x5=x5*yy3/(d31*d41)
             x6=0.25*d21*d21*(d42/d41+d32/d31+1.0)/(d41*d31)
             dosin(idos,1)=0.5*(x1+x2+x3+x4+x5)+x6

             x1=(d3d3)/(d32*d32*d31)*(d2/d42+d1/d41)
             x2=(d4*d4)/(d42*d42*d41)*(d2/d32+d1/d31)
             x3=(d3*d4*d2)/(d42*d32)*yy3
             dos(idos,2)=0.5*(x1+x2+x3)
             x1=y1/(d32*d32*d31*d42)
             x2=y2/(d32*d32*d31*d41)
             x3=y3/(d42*d42*d41*d32)
             x4=y4/(d42*d42*d41*d31)
             x5=d2d2*(d3*(d42+3.0*d4)+d32*(d42+d4))/12
             x5=x5*yy3/(d42*d32)
             x6=0.25*d21/d31*d21/d41
             dosin(idos,2)=0.5*(x1+x2+x3+x4+x5)+x6

             x1=(d2d2)/(d32*d32*d42)*(d3/d31+d4/d41)
             x2=(d1*d1)/(d31*d31*d41)*(d3/d32+d4/d42)
             x3=(d1*d2*d3)/(d32*d31)*yy3
             dos(idos,3)=0.5*(x1+x2+x3)
             x1=d2d2d2*(3*d3+d32)/12
             y1=x1
             x1=x1/(d32*d32*d42*d31)
             x2=d2d2d2*(3*d4+d42)/12
             y2=x2
             x2=x2/(d32*d32*d42*d41)
             x3=d2*(d2*d31*(d2+3*d21)+3*d3*(d2d2+3*d21*d1)+ 3*d21*d21*d32)/12
             y3=x3
             x3=x3/(d31*d31*d41*d32)
             x4=d2*(d2*d41*(d2+3*d21)+3*d4*(d2d2+3*d21*d1)+3*d21*d21*d42)/12
             y4=x4
             x4=x4/(d31*d31*d41*d42)
             x5=(d2d2)*(d3*(d21+3*d1)+d32*(d21+d1))/12
             x5=x5/(d32*d31)*yy3
             x6=0.25*(d21/d31*d21/d31*d21/d41)
             dosin(idos,3)=0.5*(x1+x2+x3+x4+x5)+x6

             x1=(d2d2)/(d42*d42*d32)*(d3/d31+d4/d41)
             x2=(d1*d1)/(d41*d41*d31)*(d3/d32+d4/d42)
             x3=(d1*d2*d4)/(d41*d42)*yy3
             dos(idos,4)=0.5*(x1+x2+x3)
             x1=y1/(d42*d42*d32*d31)
             x2=y2/(d42*d42*d32*d41)
             x3=y3/(d41*d41*d31*d32)
             x4=y4/(d41*d41*d31*d42)
             x5=(d2d2)*(d4*(d21+3*d1)+d42*(d21+d1))/12
             x5=x5/(d41*d42)*yy3
             x6=0.25*(d21/d31*d21/d41*d21/d41)
             dosin(idos,4)=0.5*(x1+x2+x3+x4+x5)+x6
          end do
          call gettod(wct_now)
          etime2 = etime2 + (wct_now-wct_start)*1.d-6

          call gettod(wct_start)
          if(idim .eq. -3) then
             esum = e1+e2+e3+e4
             do idos = ns, ne
                tdos = 0.025d0*(dos(idos,1)+dos(idos,2)+dos(idos,3)+dos(idos,4))
                dosin(idos,1)=dosin(idos,1)+tdos*(esum-4.d0*e1)
                dosin(idos,2)=dosin(idos,2)+tdos*(esum-4.d0*e2)
                dosin(idos,3)=dosin(idos,3)+tdos*(esum-4.d0*e3)
                dosin(idos,4)=dosin(idos,4)+tdos*(esum-4.d0*e4)
             end do
          end if
          do ip = 1,4
             do ie = ns, ne
                cdos(ie) = cdos(ie) + dos(ie,ip)*dos_weight(ib,ieb(ip))
                csumdos(ie) = csumdos(ie) + dosin(ie,ip)*dos_weight(ib,ieb(ip))
             end do
          end do
          w = (dos_weight(ib,ieb(1))+dos_weight(ib,ieb(2)) &
               &           +dos_weight(ib,ieb(3))+dos_weight(ib,ieb(4)))*0.25d0
          do ie = ne+1,nEwindows
             csumdos(ie) = csumdos(ie) + 1.d0*w
          end do
          call gettod(wct_now)
          etime4 = etime4 + (wct_now-wct_start)*1.d-6
       end do
    end do

    call gettod(wct_start)
    do ie = 0, nEwindows
       cdos(ie) = cdos(ie)/ntet
       csumdos(ie) = csumdos(ie)/ntet
    end do

!!$    if(nrank_e .gt.1) then
!!$       itmp = (nep+1)*4
!!$       call mpi_allreduce(MPI_IN_PLACE,dos,    itmp,       mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
!!$       call mpi_allreduce(MPI_IN_PLACE,dosin,  itmp,       mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
!!$       call mpi_allreduce(MPI_IN_PLACE,cdos,   newindows+1,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
!!$       call mpi_allreduce(MPI_IN_PLACE,csumdos,newindows+1,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
!!$    end if

    if (npes .gt. 1) then
       itmp = (nep+1)*4
       call mpi_allreduce(MPI_IN_PLACE,dos,  itmp,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
       call mpi_allreduce(MPI_IN_PLACE,dosin,itmp,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
       call mpi_allreduce(MPI_IN_PLACE,cdos,   newindows+1, mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
       call mpi_allreduce(MPI_IN_PLACE,csumdos,newindows+1, mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
    endif

    call gettod(wct_now)
    etime5 = etime5 + (wct_now-wct_start)*1.d-6

    if(ipri .ge. 2) then
       write(nfout,'(" !dos iloop    = ",i12)') iloop
       write(nfout,'(" !dos ncounter1 = ",i12)') ncounter1
       write(nfout,'(" !dos ncounter2 = ",i12)') ncounter2
       write(nfout,'(" !dos ncounter3 = ",i12)') ncounter3
       write(nfout,'(" !dos etime0    = ",f16.8)') etime0
       write(nfout,'(" !dos etime1    = ",f16.8)') etime1
       write(nfout,'(" !dos etime2    = ",f16.8)') etime2
       write(nfout,'(" !dos etime3    = ",f16.8)') etime3
       write(nfout,'(" !dos etime4    = ",f16.8)') etime4
       write(nfout,'(" !dos etime5    = ",f16.8)') etime5
    end if
  end subroutine nstt5i_3D

end module m_ES_dos

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  AUTHOR(S): J. Koga 
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!***************************************************************
module m_parameter
  use m_Const_Parameters, only : DP
  implicit none
  real(DP), parameter :: BOHR2ANG   = 0.5291772480d0
  real(DP), parameter :: Hartree2eV = 27.21139615d0
  real(DP), parameter :: autime2fs  = 2.418884327d-2
  real(DP), parameter :: HartreeBohr2eVAng = Hartree2eV/BOHR2ANG
  real(DP), parameter :: eV2kcal_mol = 627.509391d0/Hartree2eV
  real(DP), parameter :: eV2kJ_mol   = 2625.5d0/Hartree2eV
  real(DP), parameter :: erg2eV = 6.24150974d+11

  character(len=256) :: inpfile_name = 'nfinp.data'

end module m_parameter

! module for spline interpolation;
! from "numerical recipies in Fortran"
module m_spline
  use m_Const_Parameters, only : DP
  implicit none

  interface init_bicubic_spline
    module procedure init_bicubic_spline_noder
    module procedure init_bicubic_spline_der
  end interface init_bicubic_spline

  interface init_tricubic_spline
    module procedure init_tricubic_spline_noder
    module procedure init_tricubic_spline_der
  end interface init_tricubic_spline

  contains

  ! initialization routine for a 1D spline interpolation
  subroutine init_cubic_spline(x,y,n,yp1,ypn,y2)
    implicit none
    integer,intent(in) :: n
    real, intent(in) :: yp1,ypn
    real(DP), dimension(n), intent(in)  :: x,y
    real(DP), dimension(n), intent(out) :: y2
    integer, parameter :: NMAX=500
    integer i,k
    real(DP) p,qn,sig,un
    real(DP), dimension(NMAX) :: u

    y2=0.0d0
    u=0.0d0

    if(yp1.gt..99e30) then
        y2(1) = 0.
        u(1) = 0.
    else
        y2(1)=-0.5
        u(1) = (3./(x(2)-x(1)))*((y(2)-y(1))/(x(2)-x(1))-yp1)
    endif

    do i=2,n-1
      sig=(x(i)-x(i-1))/(x(i+1)-x(i-1))
      p=sig*y2(i-1)+2
      y2(i)=(sig-1)/p
      u(i)=(6*((y(i+1)-y(i))/(x(i+1)-x(i))-(y(i)-y(i-1)) &
      & /(x(i)-x(i-1)))/(x(i+1)-x(i-1))-sig*u(i-1))/p
    enddo

    if ( ypn.gt..99e30) then
        qn=0.
        un=0.
    else
        qn=0.5
        un=(3./(x(n)-x(n-1)))*(ypn-(y(n)-y(n-1))/(x(n)-x(n-1)))
    endif

    y2(n) = (un-qn*u(n-1))/(qn*y2(n-1)+1)
    do k=n-1,1,-1
      y2(k) = y2(k)*y2(k+1)+u(k)
    enddo
  end subroutine init_cubic_spline

  ! get the spline-interpolated value and its derivative
  ! using the second-derivative matrix
  ! obtained from init_cubic_spline.
  ! the return value is the interpolated value, while the last
  ! dummy argument is the derivative.
  real(DP) function cubic_spline(xa,ya,y2a,n,x,dy)
    integer, intent(in) :: n
    real(DP), intent(in) :: x
    real(DP), intent(out) :: dy
    real(DP), dimension(n), intent(in) :: xa,y2a,ya

    integer :: k,khi,klo
    real(DP) :: a,b,h

    klo=1
    khi=n

    do while ( (khi-klo).gt.1 ) 
      k=(khi+klo)/2
      if (xa(k).gt.x) then
          khi=k
      else
          klo=k
      endif
    enddo

    h=xa(khi)-xa(klo)
    if ( h.eq.0. ) stop 'bad xa input in splint'
    a=(xa(khi)-x)/h
    b=(x-xa(klo))/h
    dy = (ya(khi)-ya(klo))/h - (3*a**2-1)/6.0d0 * h * y2a(klo) + &
    & (3*b**2-1)/6.0d0 * h * y2a(khi)
    cubic_spline=a*ya(klo)+b*ya(khi)+((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**2)/6
  end function cubic_spline

  ! initialization routine for a 2D cubic-spline interpolation
  subroutine init_bicubic_spline_noder(x1a,x2a,ya,m,n,y2a)
    implicit none
    integer, intent(in) :: m,n
    real(DP), dimension(m), intent(in) :: x1a
    real(DP), dimension(n), intent(in) :: x2a
    real(DP), dimension(m,n), intent(in) :: ya
    real(DP), dimension(m,n), intent(out) :: y2a
    integer :: i,j,k
    real(DP), dimension(n) :: y2tmp,ytmp

    y2tmp=0.0d0;ytmp=0.0d0;y2a=0.0d0

    do j=1,m
      do k=1,n
        ytmp(k) = ya(j,k)
      enddo
      call init_cubic_spline(x2a,ytmp,n,1.e30,1.e30,y2tmp)
      do k=1,n
        y2a(j,k)=y2tmp(k)
      enddo
    enddo
  end subroutine init_bicubic_spline_noder

  subroutine init_bicubic_spline_der(x1a,x2a,ya,yp,m,n,y2a)
    integer, intent(in) :: m,n
    real(DP), dimension(m), intent(in) :: x1a
    real(DP), dimension(n), intent(in) :: x2a
    real(DP), dimension(m,n), intent(in) :: ya
    real(DP), dimension(m,n), intent(in) :: yp
    real(DP), dimension(m,n), intent(out) :: y2a
    real(DP), dimension(n) :: y2tmp,ytmp,yptmp,yp1,ypn
    integer :: i,j,k

    y2tmp=0.0d0;ytmp=0.0d0;y2a=0.0d0;yptmp=0.0d0

    do j=1,m
      do k=1,n
        ytmp(k) = ya(j,k)
      enddo
!      call init_cubic_spline(x2a,ytmp,n,,,y2tmp)
      do k=1,n
        y2a(j,k)=y2tmp(k)
      enddo
    enddo
  end subroutine init_bicubic_spline_der

  ! get the 2D-spline-interpolated value using the second-derivative matrix
  ! obtained from init_bicubic_spline
  real(DP) function bicubic_spline_fast(x1a,x2a,ya,y2a,m,n,x1,x2,dy1,dy2)
    implicit none
    integer, intent(in) :: m,n
    real(DP), dimension(m), intent(in) :: x1a
    real(DP), dimension(n), intent(in) :: x2a
    real(DP), dimension(m,n), intent(in) :: ya,y2a
    real(DP), intent(in) :: x1,x2
    real(DP), intent(out) :: dy1,dy2

    integer j,k
    real(DP) :: dytmp
    real(DP), dimension(n) :: y2tmp, ytmp,yytmp,dytmpmat,y2tmptmp

    y2tmp=0.0d0;ytmp=0.0d0;yytmp=0.0d0;dytmpmat=0.0d0;y2tmptmp=0.0d0

    do j=1,m
      ytmp(:) = ya(j,:)
      y2tmp(:) = y2a(j,:)
      yytmp(j) = cubic_spline(x2a,ytmp,y2tmp,n,x2,dytmp)
      dytmpmat(j) = dytmp
      y2tmptmp(j) = cubic_spline(x2a,y2tmp,y2tmp,n,x2,dytmp)
    enddo

    dy1=0.0d0;dy2=0.0d0

!    y2tmp=0.0d0
    y2tmp = y2tmptmp
!    call init_cubic_spline(x1a,dytmpmat,m,1.e30,1.e30,y2tmp)
    dy2 = cubic_spline(x1a,dytmpmat,y2tmp,m,x1,dytmp)

!    y2tmp=0.0d0
!    call init_cubic_spline(x1a,yytmp,m,1.e30,1.e30,y2tmp)
    bicubic_spline_fast = cubic_spline(x1a,yytmp,y2tmp,m,x1,dy1)
  end function bicubic_spline_fast

  ! get the 2D-spline-interpolated value using the second-derivative matrix
  ! obtained from init_bicubic_spline
  real(DP) function bicubic_spline(x1a,x2a,ya,y2a,m,n,x1,x2,dy1,dy2)
    implicit none
    integer, intent(in) :: m,n
    real(DP), dimension(m), intent(in) :: x1a
    real(DP), dimension(n), intent(in) :: x2a
    real(DP), dimension(m,n), intent(in) :: ya,y2a
    real(DP), intent(in) :: x1,x2
    real(DP), intent(out) :: dy1,dy2

    integer j,k
    real(DP) :: dytmp
    real(DP), dimension(n) :: y2tmp, ytmp,yytmp,dytmpmat

    y2tmp=0.0d0;ytmp=0.0d0;yytmp=0.0d0;dytmpmat=0.0d0

    do j=1,m
      ytmp(:) = ya(j,:)
      y2tmp(:) = y2a(j,:)
      yytmp(j) = cubic_spline(x2a,ytmp,y2tmp,n,x2,dytmp)
      dytmpmat(j) = dytmp
    enddo

    dy1=0.0d0;dy2=0.0d0

!    y2tmp=0.0d0
    call init_cubic_spline(x1a,dytmpmat,m,1.e30,1.e30,y2tmp)
    dy2 = cubic_spline(x1a,dytmpmat,y2tmp,m,x1,dytmp)

!    y2tmp=0.0d0
    call init_cubic_spline(x1a,yytmp,m,1.e30,1.e30,y2tmp)
    bicubic_spline = cubic_spline(x1a,yytmp,y2tmp,m,x1,dy1)
  end function bicubic_spline

  subroutine init_tricubic_spline_der
  end subroutine init_tricubic_spline_der

  ! initialization routine for a 3D cubic-spline interpolation 
  ! the routine is actually exactly the same for the 2D spline.
  subroutine init_tricubic_spline_noder(x1a,x2a,x3a,ya,m,n,o,y2a)
    implicit none
    integer, intent(in) :: m,n,o
    real(DP), dimension(m), intent(in) :: x1a
    real(DP), dimension(n), intent(in) :: x2a
    real(DP), dimension(o), intent(in) :: x3a
    real(DP), dimension(m,n,o), intent(in) :: ya
    real(DP), dimension(m,n,o), intent(out) :: y2a

    integer :: i
    real(DP), dimension(m,n) :: y2atmp,yatmp

    y2atmp=0.0d0;yatmp=0.0d0;y2a=0.0d0

    do i=1,o
      yatmp(:,:) = ya(:,:,i)
      call init_bicubic_spline(x1a,x2a,yatmp,m,n,y2atmp)
      y2a(:,:,i) = y2atmp(:,:)
    enddo
  end subroutine init_tricubic_spline_noder

  real(DP) function tricubic_spline_2d_precal(&
  & x3a,y2d,dy2d1,dy2d2,x3,dy1,dy2,dy3,o)
    implicit none
    integer, intent(in) :: o
    real(DP), intent(in), dimension(o) :: y2d,dy2d1,dy2d2
    real(DP), dimension(o), intent(in) :: x3a
    real(DP), intent(in) :: x3
    real(DP), intent(out) :: dy1,dy2,dy3

    real(DP), dimension(o) :: y2tmp
    real(DP) :: dy1tmp,dy2tmp

    y2tmp=0.0d0;dy3=0.0d0

    call init_cubic_spline(x3a,dy2d1,o,1.e30,1.e30,y2tmp)
    dy1 = cubic_spline(x3a,dy2d1,y2tmp,o,x3,dy1tmp)

    call init_cubic_spline(x3a,dy2d2,o,1.e30,1.e30,y2tmp)
    dy2 = cubic_spline(x3a,dy2d2,y2tmp,o,x3,dy2tmp)

    call init_cubic_spline(x3a,y2d,o,1.e30,1.e30,y2tmp)
    tricubic_spline_2d_precal = &
    & cubic_spline(x3a,y2d,y2tmp,o,x3,dy3)
  end function tricubic_spline_2d_precal

  ! get the 3D-spline-interpolated value using the second-derivative matrix
  ! obtained from init_tricubic_spline
  ! we first do bi-cubic spline interpolation for the first two index, and from
  ! the interpolated array thus obtained, perform a final interpolation by the
  ! third index.
  real(DP) function tricubic_spline(x1a,x2a,x3a,ya,y2a,m,n,o,x1,x2,x3,&
  & dy1,dy2,dy3)
    implicit none
    integer, intent(in) :: m,n,o
    real(DP), dimension(m), intent(in) :: x1a
    real(DP), dimension(n), intent(in) :: x2a
    real(DP), dimension(o), intent(in) :: x3a
    real(DP), dimension(m,n,o), intent (in) :: ya
    real(DP), dimension(m,n,o), intent(in) :: y2a
    real(DP), intent(in) :: x1,x2,x3
    real(DP), intent(out) :: dy1,dy2,dy3

    integer j,k
    real(DP), dimension(o) :: y2tmp
    real(DP), dimension(o) :: yytmp
    real(DP), dimension(o) :: dy1tmpmat
    real(DP), dimension(o) :: dy2tmpmat
    real(DP) :: dy1tmp,dy2tmp
    real(DP), dimension(m,n) :: ytmp,y2atmp

    y2tmp=0.0d0;yytmp=0.0d0;dy1tmpmat=0.0d0
    dy2tmpmat=0.0d0;ytmp=0.0d0;y2atmp=0.0d0

    dy1=0.0d0;dy2=0.0d0;dy3=0.0d0
    do j=1,o
      ytmp(:,:) = ya(:,:,j)
      y2atmp(:,:) = y2a(:,:,j)
      yytmp(j) = bicubic_spline(x1a,x2a,ytmp,y2atmp,m,n,x1,x2,&
      & dy1tmp,dy2tmp)
      dy1tmpmat(j) = dy1tmp
      dy2tmpmat(j) = dy2tmp
    enddo

    call init_cubic_spline(x3a,dy1tmpmat,o,1.e30,1.e30,y2tmp)
    dy1 = cubic_spline(x3a,dy1tmpmat,y2tmp,o,x3,dy1tmp)

    call init_cubic_spline(x3a,dy2tmpmat,o,1.e30,1.e30,y2tmp)
    dy2 = cubic_spline(x3a,dy2tmpmat,y2tmp,o,x3,dy2tmp)

    call init_cubic_spline(x3a,yytmp,o,1.e30,1.e30,y2tmp)
    tricubic_spline = cubic_spline(x3a,yytmp,y2tmp,o,x3,dy3)
  end function tricubic_spline

  ! get the 3D-spline-interpolated value using the second-derivative matrix
  ! obtained from init_tricubic_spline
  ! we first do bi-cubic spline interpolation for the first two index, and from
  ! the interpolated array thus obtained, perform a final interpolation by the
  ! third index.
  real(DP) function tricubic_spline_fast(x1a,x2a,x3a,ya,y2a,m,n,o,x1,x2,x3,&
  & dy1,dy2,dy3)
    implicit none
    integer, intent(in) :: m,n,o
    real(DP), dimension(m), intent(in) :: x1a
    real(DP), dimension(n), intent(in) :: x2a
    real(DP), dimension(o), intent(in) :: x3a
    real(DP), dimension(m,n,o), intent (in) :: ya
    real(DP), dimension(m,n,o), intent(in) :: y2a
    real(DP), intent(in) :: x1,x2,x3
    real(DP), intent(out) :: dy1,dy2,dy3

    integer j,k
    real(DP), dimension(o) :: y2tmp
    real(DP), dimension(o) :: y2tmptmp
    real(DP), dimension(o) :: yytmp
    real(DP), dimension(o) :: dy1tmpmat
    real(DP), dimension(o) :: dy2tmpmat
    real(DP) :: dy1tmp,dy2tmp
    real(DP), dimension(m,n) :: ytmp,y2atmp

    y2tmp=0.0d0;yytmp=0.0d0;dy1tmpmat=0.0d0
    dy2tmpmat=0.0d0;ytmp=0.0d0;y2atmp=0.0d0
    y2tmptmp=0.0d0

    dy1=0.0d0;dy2=0.0d0;dy3=0.0d0
    do j=1,o
      ytmp(:,:) = ya(:,:,j)
      y2atmp(:,:) = y2a(:,:,j)
      yytmp(j) = bicubic_spline_fast(x1a,x2a,ytmp,y2atmp,m,n,x1,x2,&
      & dy1tmp,dy2tmp)
      dy1tmpmat(j) = dy1tmp
      dy2tmpmat(j) = dy2tmp
      y2tmptmp(j) = bicubic_spline_fast(x1a,x2a,y2atmp,y2atmp,m,n,x1,x2,&
      & dy1tmp,dy2tmp)
    enddo

    y2tmp = y2tmptmp
!    call init_cubic_spline(x3a,dy1tmpmat,o,1.e30,1.e30,y2tmp)
    dy1 = cubic_spline(x3a,dy1tmpmat,y2tmp,o,x3,dy1tmp)

!    call init_cubic_spline(x3a,dy2tmpmat,o,1.e30,1.e30,y2tmp)
    dy2 = cubic_spline(x3a,dy2tmpmat,y2tmp,o,x3,dy2tmp)

!    call init_cubic_spline(x3a,yytmp,o,1.e30,1.e30,y2tmp)
    tricubic_spline_fast = cubic_spline(x3a,yytmp,y2tmp,o,x3,dy3)
  end function tricubic_spline_fast

end module m_spline

module m_bm
use m_Const_Parameters, only : NOCONV
use m_parameter, only : BOHR2ANG,Hartree2eV,autime2fs,HartreeBohr2eVAng, eV2kJ_mol, eV2kcal_mol, inpfile_name
use m_spline, only : init_cubic_spline,cubic_spline
implicit none

integer :: nsample = 1
integer :: ndim   = 1
integer :: nsteps = 2000
integer :: nsteps_per_sample=2000
integer :: nequib = 1000
integer :: nreac_coords = 1
integer :: max_reac_coords = 1
integer :: istart_reac_coords = 1
character(256) :: basedir='.'

real(8), allocatable, dimension(:,:) :: mean_force
real(8), allocatable, dimension(:) :: mean_force_av
real(8), allocatable, dimension(:) :: value

real(8) :: d_xsi
integer :: n_xsi = 1000

logical :: smooth = .false.

contains
  subroutine parse_input()
    integer :: iarg
    integer :: iargc
    integer :: iret
    integer :: dret
    character(len=256)    :: string
    logical :: ex
    integer :: f_openInputFile,f_getIntValue,f_selectBlock,f_selectParentBlock,f_closeInputFile,&
   & f_selectTop, f_getRealValue, f_getStringValue, f_getBoolValue
    logical :: bret
    iarg = iargc()
    if (iarg/=0) then
      call getarg(1,inpfile_name)
    endif

    inquire(file=trim(adjustl(inpfile_name)),exist=ex)

    if(.not.ex)then
      write(0,'(a)') 'input file : '//trim(adjustl(inpfile_name))//' does not exist.'
      stop
    endif
    iret = f_openInputFile(trim(adjustl(inpfile_name)))
    iret = f_selectTop()
    if(f_selectBlock("thermodynamic_integration")==0)then
      if(f_getIntValue('ndim',iret)==0)then
        ndim = iret
      endif
      if(f_getIntValue('nsteps',iret)==0)then
        nsteps = iret
      endif
      if(f_getIntValue('nequib',iret)==0)then
        nequib = iret
        if(nequib.ge.nsteps)then
          write(0,'(a)') 'nequib must be smaller than nsteps'
          write(0,'(a)') 'setting nequib = 0.5 * nsteps'
          nequib = nint(0.5d0*real(nsteps))
        endif
      endif
      if(f_getIntValue('nsample',iret)==0)then
        nsample = iret
        if(nsample<1)then
          nsample=1
          write(0,*) 'nsample must be larger then 1'
        endif
      endif
      if(f_getIntValue('nreac_coords',iret)==0)then
        nreac_coords = iret
        max_reac_coords = nreac_coords
      endif
      if(f_getIntValue('max_nreac_coords',iret)==0)then
        if(iret>nreac_coords) max_reac_coords = iret
      endif
      if(f_getIntValue('istart_reac_coords',iret)==0)then
        istart_reac_coords = iret
        if(istart_reac_coords.ge.nreac_coords)then
          write(0,*) 'istart_reac_coords must be smaller than nreac_coords'
          istart_reac_coords=1
        endif
      endif
      if(f_getIntValue('n_xsi',iret)==0)then
        n_xsi = iret
      endif
      if(f_getBoolValue('smooth',bret)==0)then
        smooth = bret
      endif
      allocate(value(nreac_coords-(istart_reac_coords-1)))
      allocate(mean_force_av(nreac_coords-(istart_reac_coords-1)))
      allocate(mean_force(nsample,nreac_coords-(istart_reac_coords-1)))
      if(f_getStringValue('basedir',string,NOCONV)==0)then
        basedir = trim(adjustl(string))
      endif
      iret = f_selectParentBlock()
    else
      write(0,*) 'could not find the thermodynamic_integration block'
      stop
    endif
    open(unit=11,file=trim(basedir)//'/mean_force_raw.data',status='replace')
    if(smooth) open(unit=12,file=trim(basedir)//'/mean_force_smoothed.data',status='replace')
    open(unit=13,file=trim(basedir)//'/potential_of_mean_force.data',status='replace')
    write(13,'(a)') '#value, potetial of mean force in Hartree, eV, kcal/mol, kJ/mol'
    nsteps_per_sample = (nsteps-nequib)/nsample
  end subroutine parse_input

  subroutine do_mean_force(ireac)
    integer, intent(in) :: ireac
    integer :: i,j
    character(len=256) :: fname
    character(len=10) :: tmp
    logical :: ex
    integer :: ifile=10
    integer :: istep
    integer :: iindex
    real(8) :: sumlambda, lamb, val,sigma,dmetric,sumdmetric
    real(8) :: ndiv

    tmp = get_id_char(max_reac_coords,ireac)
    fname = trim(basedir)//'/nfbluemoon.data.reac'//trim(adjustl(tmp))
    inquire(file=trim(fname),exist=ex)
    if(.not.ex)then
      write(0,'(a)') 'data file : '//trim(adjustl(fname))//' does not exist.'
      stop
    endif
    open(ifile,file=trim(fname),status='old')

    do i=1,nequib
      read(ifile,fmt=*,err=2) istep,val,lamb,dmetric
2   continue
    enddo
    ! kara yomi
    iindex = ireac-(istart_reac_coords-1)
    do i=1,nsample
      sumlambda = 0.0d0
      sumdmetric = 0.0d0
      do j=1,nsteps_per_sample
        read(ifile,fmt=*,err=3) istep,val,lamb,dmetric
        sumlambda = sumlambda+lamb/(dsqrt(dmetric))
        sumdmetric = sumdmetric+1.0d0/(dsqrt(dmetric))
3       continue
      enddo
      sumlambda = sumlambda/real(nsteps_per_sample)
      sumdmetric = sumdmetric/real(nsteps_per_sample)
      mean_force(i,iindex) = sumlambda/sumdmetric
    enddo
    value(iindex) = val

    sumlambda = 0.d0
    do i=1,nsample
      sumlambda = sumlambda+mean_force(i,iindex)
    enddo

    mean_force_av(iindex) = sumlambda/real(nsample)

    sigma = 0.d0
    do i=1,nsample
      sigma = sigma+ (mean_force(i,iindex)-sumlambda)**2
    enddo
    sigma = sigma/real(nsample)
    write(11,'(3f20.10)') val,-sumlambda/real(nsample),dsqrt(sigma/real(nsample))

    return
    !!$write(0,'(a)') 'caught error while reading : ',trim(fname)
  end subroutine do_mean_force

  character(len=10) function get_id_char(imax,i)
    integer, intent(in) :: imax,i
    integer :: iketa=2
    integer :: itmp
    character(len=256) :: ch
    character(len=256) :: string
    itmp=int(log10(real(imax)))+1
    if(itmp>2)iketa=itmp
    write(ch,*) iketa
    write(get_id_char,'(i'//trim(adjustl(ch))//'.'//trim(adjustl(ch))//')') i
  end function get_id_char


  subroutine do_thermodynamic_integration()
    integer :: isamp
    integer :: i
    integer :: j
    real(8) :: tmpvi,tmpvj,tmpfi,tmpfj
    real(8),allocatable,dimension(:) :: smoothed_value,smoothed_mean_force
    real(8) :: tmptmp,sumsum,res,tmpval
    real(8) :: inival,sigma
    real(8), allocatable, dimension(:) :: mean_force_2
    real(8), allocatable, dimension(:,:) :: potential
    real(8), allocatable, dimension(:) :: potential_av
    if(smooth)then
      !the 'value' array must be in canonical order in order to perform a cubic spline interpl
      do i=1,nreac_coords-(istart_reac_coords-1)-1
        do j=i+1,nreac_coords-(istart_reac_coords-1)
          if(value(i)>value(j))then
            tmpvi=value(j)
            tmpvj=value(i)
            tmpfi=mean_force_av(j)
            tmpfj=mean_force_av(i)
            value(i)=tmpvi
            value(j)=tmpvj
            mean_force_av(i)=tmpfi
            mean_force_av(j)=tmpfj
          endif
        enddo
      enddo
      allocate(mean_force_2(nreac_coords-(istart_reac_coords-1)))
      d_xsi = (value(nreac_coords-(istart_reac_coords-1))-value(1))/real(n_xsi)
      call init_cubic_spline(value,mean_force_av,nreac_coords-(istart_reac_coords-1),1.e30,1.e30,mean_force_2)
      allocate(smoothed_value(n_xsi));allocate(smoothed_mean_force(n_xsi))
      do i=1,n_xsi+1
        tmpval = value(1) + d_xsi * (i-1)
        res    = cubic_spline(value,mean_force_av,mean_force_2,nreac_coords-(istart_reac_coords-1),tmpval,tmptmp)
        smoothed_value(i) = tmpval
        smoothed_mean_force(i) = res
        write(12,'(2f20.10)') tmpval,-res
      enddo
      do i=1,n_xsi
        sumsum = 0.d0
        do j=i+1,n_xsi-1
          sumsum = sumsum+smoothed_mean_force(j)
        enddo
        sumsum = sumsum+(smoothed_mean_force(i)+smoothed_mean_force(n_xsi))*0.5d0
        sumsum = sumsum * d_xsi
        write(13,'(5f20.10)') smoothed_value(i),sumsum,&
       & sumsum*Hartree2eV,sumsum*Hartree2eV*eV2kcal_mol,sumsum*Hartree2eV*eV2kJ_mol
      enddo
      deallocate(smoothed_value); deallocate(smoothed_mean_force)
      deallocate(mean_force_2)
    else
      n_xsi = nreac_coords-(istart_reac_coords-1)
      d_xsi = (value(nreac_coords-(istart_reac_coords-1))-value(1))/real(n_xsi)
      allocate(potential(nsample,n_xsi));potential=0.d0
      allocate(potential_av(n_xsi));potential_av=0.d0
      do isamp=1,nsample
        do i=1,n_xsi
          sumsum = 0.d0
          do j=i+1,n_xsi-1
            sumsum = sumsum+mean_force(isamp,j)
          enddo
          sumsum = sumsum+(mean_force(isamp,i)+mean_force(isamp,n_xsi))*0.5d0
          sumsum = sumsum * d_xsi
          potential(isamp,i) = sumsum
        enddo
      enddo
      do isamp=1,nsample
        potential_av(:) = potential_av(:) + potential(isamp,:)
      enddo
      potential_av(:) = potential_av(:)/real(nsample)

      do i=1,n_xsi
        sigma = 0.d0
        do j=1,nsample
          sigma = sigma+(potential(j,i)-potential_av(i))**2
        enddo
        sigma = dsqrt(sigma)/real(nsample)
        write(13,'(9f20.10)') value(i),potential_av(i),sigma,&
       & potential_av(i)*Hartree2eV,sigma*Hartree2eV, &
       & potential_av(i)*Hartree2eV*eV2kcal_mol,sigma*Hartree2eV*eV2kcal_mol, &
       & potential_av(i)*Hartree2eV*eV2kJ_mol,sigma*Hartree2eV*eV2kJ_mol
      enddo
      deallocate(potential)
    endif
  end subroutine do_thermodynamic_integration

  subroutine finalize()
    close(11)
    if (smooth) close(12)
    close(13)
    deallocate(value)
    deallocate(mean_force)
  end subroutine finalize

end module m_bm

program bluemoon
  use m_bm, only : parse_input, istart_reac_coords,nreac_coords,do_mean_force &
  &              , do_thermodynamic_integration, finalize
  implicit none
  integer :: i

  call parse_input()
  do i=istart_reac_coords,nreac_coords
    call do_mean_force(i)
  enddo

  call do_thermodynamic_integration()
  call finalize()

  stop

end program bluemoon

integer function f_getBoolValue(tag,ret)
  implicit none
  character(*),intent(in) :: tag
  logical,intent(out)     :: ret
  integer :: integ,iret,f_getIntValue
  iret = f_getIntValue(tag,integ)
  if ( integ==0 ) then
    ret = .false.
  else
    ret = .true.
  endif
  f_getBoolValue = iret
end function f_getBoolValue

!================================================
!  Software name : STM
!  Module : m_Const_Parameters
!  Author(s)     : Takahiro Yamasaki (June 7, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

module m_Const_Parameters
! $Id: m_Const_Parameters.f90,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
  implicit none
  integer, parameter :: DP = kind(1.d0)
  integer, parameter :: SP = kind(1.0)
  integer, parameter :: CMPLDP = kind((1.d0, 0.d0))
  integer, parameter :: CMPLSP = kind((1.0 , 0.0 ))
  integer, parameter :: ON = 1, OFF = 0
  integer, parameter :: INVERSE = 1, DIRECT = 2
  integer, parameter :: BEGIN = 1, END = 2
  integer, parameter :: NODATA = 0, PUCV = 0, CARTS = 1, BUCS = 2
  integer, parameter :: CRDTYP = BUCS
  integer, parameter :: OLD = 0, NEW = 1, UNKNOWN = 2
  integer, parameter :: FORMATTED = 0, UNFORMATTED = 1
  integer, parameter :: check_file_name_on  = 1
  integer, parameter :: check_file_name_off = 0
  integer, parameter :: GENERAL = 100
  integer, parameter :: LOWER = 1, IN_BETWEEN = 0, HIGHER = 2
  integer, parameter :: NEGATIVE = -1
  real(kind=DP), parameter :: PAI  = 3.141592653589793238462D0
  real(kind=DP), parameter :: PAI2 = PAI*2.d0, PAI4 = PAI*4.d0
  real(kind=DP), parameter :: Hartree = 27.211396311

end module m_Const_Parameters

       program main
       implicit none
!      Program of epsilon file converesion
!      This program read 'eps.data' file containing dietric tensor
!      and write 'r_eps.data' and 'i_eps.data' files containing real and
!      imaginary parts of the dielectric tensor, respectively.
!      INPUT : eps.data   (file no.=1)
!      OUTPUT: r_eps.data (file no.=2)
!            : i_eps.data (file no.=3)
!      T. Hamada, Univ. Tokyo (2003.06.12)
!      iline : output control parameter
!            : write down data every iline
!            : default==1
!      T. Hamada, Univ. Tokyo (2004.1.12)
       integer :: ind, i, len
       integer :: iline,ilcount1,ilcount2
       character*80  :: file_name
       character*105 :: a
       real(kind=8) :: energy, eps_xx, eps_yy, eps_zz, eps_xy, eps_xz, eps_yz
       open(1,file='eps.data',status="old")
       open(2,file='r_eps.data',status="replace")
       open(3,file='i_eps.data',status="replace")

! read skipped line number -> not used at present
!       write(6,'("skip line = ?")')
!       read(5,'(i3)') iline
!       if(iline==0) iline=1
       iline = 1
       call read_write_header
       ilcount1=0
       ilcount2=0
     1 read(1,10,end=99) a
       ind=index(a,'(')
       if(ind==0) then
        backspace 1
        read(1,20) energy, eps_xx, eps_yy, eps_zz, eps_xy, eps_xz, eps_yz
        if(mod(ilcount1,iline)==0)  write(2,20) energy, eps_xx, eps_yy, eps_zz, eps_xy, eps_xz, eps_yz
        ilcount1=ilcount1+1
       else
        backspace 1
        read(1,30)  eps_xx, eps_yy, eps_zz, eps_xy, eps_xz, eps_yz
        if(mod(ilcount2,iline)==0)  write(3,20) energy, eps_xx, eps_yy, eps_zz, eps_xy, eps_xz, eps_yz
        ilcount2=ilcount2+1
       end if
       goto 1
    99 write(6,'("line number of r_eps.data = ",i5)') ilcount1
       write(6,'("line number of i_eps.data = ",i5)') ilcount2
       stop
    10 format(a105)
    20 format(3x,f10.5,6x,6(f10.5,5x))
    30 format(18x,6(1x,f10.5,4x))
       end program main
 
       subroutine read_write_header
       implicit none
       character*105 ::a
       integer :: i
       rewind 1
       rewind 2
       rewind 3
       do i=1,3
        read(1,10) a
        if(i==1.and.index(a,'Tensor')==0) then
         write(*,99)
         stop
        end if
        write(2,10) a
        write(3,10) a
       end do
    10 format(a105)
    99 format("eps.data file has no dielectric tensor component. STOP")
       end subroutine read_write_header

subroutine Potential_Construction

  use m_Const_Parameters,   only : ON, OFF
  use m_Control_Parameters,  only : sw_modified_TFW_functional, sw_potential_mixing, &
       &                            sw_hubbard, use_deltaV, kimg, nspin
  use m_ThomasFermiW_Potential,  only : Vin_TFW, Vlda_TFW

  use m_Parallelization, only : mype, ista_kngp, iend_kngp
  use m_Electronic_Structure,  only : vlhxc_l, vlhxc_l_old, m_ES_cp_vlhxc_to_old
  use m_Orbital_Population,   only : m_OP_cp_om_to_ommix
  use m_Files,  only : nfout

  use m_Potential_Mixing,  only : m_Pot_cp_vnonlocal_to_old

  implicit none

  integer :: i, ri, is

  if ( sw_modified_TFW_functional == OFF .and. sw_potential_mixing == OFF ) return

! ---
  call m_ES_cp_vlhxc_to_old
!  if ( sw_mix_charge_hardpart == ON ) call m_Pot_cp_vnonlocal_to_old
! ----
  call Renewal_of_Potential

  if ( sw_potential_mixing == ON ) then
     if (sw_hubbard==ON) then
        call Renewal_of_OccMat(.false., ON, .false. )  ! hsr --> om
        call m_OP_cp_om_to_ommix( nfout, 0.0d0 )       ! om --> ommix
        call Renewal_of_Hubbard_Parameters
        call Renewal_of_Hubbard_Potential
     endif
  end if

  if ( sw_modified_TFW_functional == ON ) then
     Vin_TFW(ista_kngp:iend_kngp,1:kimg,1:nspin) &
          &    = vlhxc_l_old(ista_kngp:iend_kngp,1:kimg,1:nspin)
     Vlda_TFW(ista_kngp:iend_kngp,1:kimg,1:nspin) &
          &    = vlhxc_l(   ista_kngp:iend_kngp,1:kimg,1:nspin)
  endif

end subroutine Potential_Construction

!ファイルのリーディングおよび計算で使用する変数の格納に関するモジュールのひとつ、ファイルリーディングに関する共通の変数および関数を定義する
!Copyright (C) 2014-2015 Ryosuke Tomita

#define READSELECT(nfin) \
  select case(readline(nfin));\
  case(-1); return;\
  case(0); exit;\
  end select

  module m_container_commons
    use m_tspace_defines, only: kvector, group, lattice_parameter
#include "defines.F"
    implicit none
!ファイルの読み込みバッファ
    character(len = 255), public:: linebuf
!ファイルのデータ区切り(parser)およびコメント文(comment)の始まりを表す文字列
    character(*), parameter::&
         parser_tag = '#', &
         comment_tag = '!'
!一つの縮退点に入るバンドの総数
!SAITO
!    integer, public, parameter:: max_num_deg_band = 3
    integer, public, parameter:: max_num_deg_band = 4
    type energy_tag
       integer:: ie
!エネルギー準位の、基準からの数値(UP,DOWN)
       DOUBLE_T:: hartree
    end type energy_tag
    
    type degeneracy
!一つの縮退点における準位の数およびそのインデクス
       integer:: ne, ie(max_num_deg_band)
    end type degeneracy
    
    type gvector_t
       integer:: num
       integer, pointer:: comp(:, :)
    end type gvector_t
    
    type psicoef_t
       integer:: num_energy, nspin, num_deg_point(2)!, nspinor
       type(gvector_t):: gv
       type(energy_tag), pointer:: e_tag(:,:)
       type(degeneracy), pointer:: deg(:,:)
       COMPLEX_T, pointer:: comp(:,:,:)
    end type psicoef_t
    
    type k_state
       type(kvector):: kpoint
       type(group):: kgroup
       DOUBLE_T:: trp2b(3,3), trb2p(3,3)
    end type k_state
    
    type c_state
       type(lattice_parameter):: latparam
       type(group):: crystal_group
       DOUBLE_T:: trp2b(3,3), trb2p(3,3)
    end type c_state
    
    type transd_vector_index
       integer:: numop, numg
       integer, pointer:: gv(:,:), kv(:)
    end type transd_vector_index
    
  contains
!ファイルnfinから意味のある行(コメントタグから始まらない、かつ空でない)を一行読み込み、バッファに格納する関数、リーディングエラーで-1,EOFで0、正常終了で1を返す
    integer function readline(nfin)
      integer, intent(in):: nfin
      do while(.true.)
         read(nfin, fmt = '(a)', err = 101, end = 100) linebuf
         linebuf = trim(linebuf)
         if(len(linebuf) > 0 .and. linebuf(1:1) /= comment_tag) exit
      enddo
      readline = 1; return
101   readline = -1; return
100   readline = 0; return
    end function readline

!指定されたtagがある行を読み込むまでファイルnfinの行を読み飛ばす。返り値の意味はreadlineのものと同じ。正常終了の時、バッファにはtagがある行が格納される
  integer function readline_until_tag(nfin, tag) result(iout)
    integer, intent(in):: nfin
    character(*), intent(in):: tag

    iout = 1
    do while(.true.)
       select case(readline(nfin))
       case(-1)
          iout = -1; return
       case(0)
          iout = 0; return
       end select
       if(index(linebuf, tag) > 0) exit
    end do
    
  end function readline_until_tag
end module m_container_commons

#ifdef __EDA__
subroutine ex_lda_libxc( nspin, ispin, ista_r, iend_r, chgrhr_l, &
     &                   wos, exc, dFx_drho, exc_on_a_grid_wk, ist, ien )
#else
subroutine ex_lda_libxc( nspin, ispin, ista_r, iend_r, chgrhr_l, &
     &                   wos, exc, dFx_drho, ist, ien )
#endif
  use m_Const_Parameters,  only : DP,PAI

  use m_Control_Parameters,  only : xc_func_exch
  use xc_f03_lib_m

#ifdef __EDA__
  use m_Const_Parameters,   only : ON
  use m_Control_Parameters, only : sw_eda
#endif

  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in)        :: ist, ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(out) :: dFx_drho(ista_r:iend_r,nspin)
#ifdef __EDA__
! -----  ascat starts modifying  -----
  real(kind=DP),intent(inout):: exc_on_a_grid_wk(ista_r:iend_r)
! -----  ascat ceases modifying  -----
#endif

  integer(8) :: npoint
  integer :: i, j, is
  integer :: istart, iend
  real(kind=DP) :: c1, c2
  real(kind=DP), allocatable :: rho(:,:), sigma(:,:), vrho(:,:), vsigma(:,:)
  real(kind=DP), allocatable :: exc0(:)

  istart = ista_r;   iend = iend_r
  istart = ist;      iend   = ien

  npoint = iend -istart +1
  if ( npoint < 1 ) return

  allocate( rho(nspin,npoint) )
  allocate( vrho(nspin,npoint) )
  allocate( exc0(npoint) )

  if ( nspin == 1 ) then
     Do i=1, npoint
        j = i +istart -1
        rho(1,i) = chgrhr_l(j,1)
     End Do
  else
     if ( ispin == 1 ) then
        Do i=1, npoint
           j = i +istart -1
           rho(1,i) = chgrhr_l(j,1) /2.0d0
           rho(2,i) = rho(1,i)
        End Do
     else
        Do i=1, npoint
           j = i +istart -1
           rho(1,i) = chgrhr_l(j,1);      rho(2,i) = chgrhr_l(j,2)
        End Do
     endif
  End if

  call xc_f03_lda_exc_vxc( xc_func_exch, npoint, rho, exc0, vrho )
!
  exc = 0.0d0
  if ( nspin == 1 ) then
     Do i=istart, iend
        j = i -istart +1
        dFx_drho(i,1) = vrho(1,j)
        exc = exc +wos(i) *exc0(j) *rho(1,j)
     End Do
  else
     if ( ispin == 1 ) then
        Do i=istart, iend
           j = i -istart +1
           dFx_drho(i,1) = vrho(1,j)
           dFx_drho(i,2) = vrho(1,j)
           exc = exc +wos(i) *exc0(j) *( rho(1,j)*2.0d0 )
        End Do
     else
        Do i=istart, iend
           j = i -istart +1
           dFx_drho(i,1) = vrho(1,j)
           dFx_drho(i,2) = vrho(2,j)
           exc = exc +wos(i) *exc0(j) *( rho(1,j) +rho(2,j) )
        End Do
     endif
  End if

#ifdef __EDA__
  if(sw_eda==ON) then
     Do is=1, ispin
        Do i=ista_r, iend_r
           exc_on_a_grid_wk(i) = exc_on_a_grid_wk(i) +exc0(i) *chgrhr_l(i,is)
        End Do
     End Do
  endif
#endif

  deallocate( rho );   deallocate( vrho );  deallocate( exc0 )

end subroutine ex_lda_libxc

#ifdef __EDA__
subroutine cr_lda_libxc( nspin, ispin, ista_r, iend_r, chgrhr_l, &
     &                   wos, exc, dF_drho, exc_on_a_grid_wk, ist, ien )
#else
subroutine cr_lda_libxc( nspin, ispin, ista_r, iend_r, chgrhr_l, &
     &                   wos, exc, dF_drho, ist, ien )
#endif
  use m_Const_Parameters,  only : DP,PAI
  use m_Control_Parameters,  only : xc_func_corr
  use xc_f03_lib_m
  
#ifdef __EDA__
  use m_Const_Parameters,   only : ON
  use m_Control_Parameters, only : sw_eda
#endif

  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in)        :: ist, ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)
  real(kind=DP),intent(inout) :: exc
  real(kind=DP),intent(out) :: dF_drho(ista_r:iend_r,nspin)
#ifdef __EDA__
! -----  ascat starts modifying  -----
  real(kind=DP),intent(inout):: exc_on_a_grid_wk(ista_r:iend_r)
! -----  ascat ceases modifying  -----
#endif

  integer(8) :: npoint
  integer :: i, j, is
  integer :: istart, iend
  real(kind=DP) :: c1, c2
  real(kind=DP), allocatable :: rho(:,:), sigma(:,:), vrho(:,:), vsigma(:,:)
  real(kind=DP), allocatable :: exc0(:)

  istart = ista_r;   iend = iend_r
  istart = ist;      iend   = ien

  npoint = iend -istart +1
  if ( npoint < 1 ) return

  allocate( rho(nspin,npoint) )
  allocate( vrho(nspin,npoint) )
  allocate( exc0(npoint) )

  if ( nspin == 1 ) then
     Do i=1, npoint
        j = i +istart -1
        rho(1,i) = chgrhr_l(j,1)
     End Do
  else
     if ( ispin == 1 ) then
        Do i=1, npoint
           j = i +istart -1
           rho(1,i) = chgrhr_l(j,1) /2.0d0
           rho(2,i) = rho(1,i)
        End Do
     else
        Do i=1, npoint
           j = i +istart -1
           rho(1,i) = chgrhr_l(j,1)
           rho(2,i) = chgrhr_l(j,2)
        End Do
     endif
  End if

  call xc_f03_lda_exc_vxc( xc_func_corr, npoint, rho, exc0, vrho )

!!  exc = 0.0d0
  if ( nspin == 1 ) then
     Do i=istart, iend
        j = i -istart +1
        dF_drho(i,1) = dF_drho(i,1) +vrho(1,j)
        exc = exc +wos(i) *exc0(j) *rho(1,j)
     End Do
  else
     if ( ispin == 1 ) then
        Do i=istart, iend
           j = i -istart +1
           dF_drho(i,1) = dF_drho(i,1) +vrho(1,j)
           dF_drho(i,2) = dF_drho(i,2) +vrho(1,j)
           exc = exc +wos(i) *exc0(j) *( rho(1,j)*2.0d0 )
        End Do
     else
        Do i=istart, iend
           j = i -istart +1
           dF_drho(i,1) = dF_drho(i,1) +vrho(1,j)
           dF_drho(i,2) = dF_drho(i,2) +vrho(2,j)
           exc = exc +wos(i) *exc0(j) *( rho(1,j) +rho(2,j) )
        End Do
     endif
  End if

#ifdef __EDA__
  if(sw_eda==ON) then
     Do is=1, ispin
        Do i=ista_r, iend_r
           exc_on_a_grid_wk(i) = exc_on_a_grid_wk(i) + exc0(i) *chgrhr_l(i,is)
        End Do
     End Do
  endif
#endif

  deallocate( rho );  deallocate( vrho );   deallocate( exc0 )

end subroutine cr_lda_libxc

#ifdef __EDA__
subroutine ex_gga_libxc( nspin, ispin, ista_r, iend_r, chgrhr_l, grad_rho, grad_trho, &
     &                   wos, exc, dFx_drho, dFx_dgradrho, exc_on_a_grid_wk, ist, ien )
#else
subroutine ex_gga_libxc( nspin, ispin, ista_r, iend_r, chgrhr_l, grad_rho, grad_trho, &
     &                   wos, exc, dFx_drho, dFx_dgradrho, ist, ien )
#endif
  use m_Const_Parameters,  only : DP,PAI

  use m_Control_Parameters,  only : xc_func_exch
  use xc_f03_lib_m
  use m_Parallelization,    only : mype

#ifdef __EDA__
  use m_Const_Parameters,   only : ON
  use m_Control_Parameters, only : sw_eda
#endif

  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
!  integer,intent(in), optional :: ist, ien
  integer,intent(in) :: ist, ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_r:iend_r,nspin)
  real(kind=DP),intent(in)  :: grad_trho(ista_r:iend_r)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(out) :: dFx_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out) :: dFx_dgradrho(ista_r:iend_r,nspin)
#ifdef __EDA__
! -----  ascat starts modifying  -----
  real(kind=DP),intent(inout):: exc_on_a_grid_wk(ista_r:iend_r)
! -----  ascat ceases modifying  -----
#endif

  integer(8) :: npoint
  integer :: i, j, is
  integer :: istart, iend
  real(kind=DP) :: c1, c2
  real(kind=DP), allocatable :: rho(:,:), sigma(:,:), vrho(:,:), vsigma(:,:)
  real(kind=DP), allocatable :: exc0(:)

  istart = ista_r;   iend = iend_r
  istart = ist;      iend   = ien

  npoint = iend -istart +1
  if ( npoint < 1 ) return

  allocate( rho(nspin,npoint) )
  allocate( sigma(2*nspin-1,npoint) )
  allocate( vrho(nspin,npoint) )
  allocate( vsigma(2*nspin-1,npoint) )
  allocate( exc0(npoint) )

  if ( nspin == 1 ) then
     Do i=1, npoint
        j = i +istart -1
        rho(1,i) = chgrhr_l(j,1)
        sigma(1,i) = grad_rho(j,1)**2
     End Do
  else
     if ( ispin == 1 ) then
        Do i=1, npoint
           j = i +istart -1
           rho(1,i) = chgrhr_l(j,1) /2.0d0
           rho(2,i) = rho(1,i)
           sigma(1,i) = grad_rho(j,1)**2 /4.0d0
           sigma(2,i) = sigma(1,j)
           sigma(3,i) = sigma(1,j)
        End Do
     else
        Do i=1, npoint
           j = i +istart -1
           rho(1,i) = chgrhr_l(j,1);      rho(2,i) = chgrhr_l(j,2)

           c1 = grad_rho(j,1)**2;         c2 = grad_rho(j,2)**2
           sigma(1,i) = c1
           sigma(2,i) = ( grad_trho(j)**2 -c1 -c2 ) /2.0d0
           sigma(3,i) = c2
        End Do
     endif
  End if

  call xc_f03_gga_exc_vxc( xc_func_exch, npoint, rho, sigma, exc0, vrho, vsigma )
!
  exc = 0.0d0
  if ( nspin == 1 ) then
     Do i=istart, iend
        j = i -istart +1
        dFx_drho(i,1) = vrho(1,j)
        dFx_dgradrho(i,1) = vsigma(1,j) *2.0d0
        exc = exc +wos(i) *exc0(j) *rho(1,j)
     End Do
  else
     if ( ispin == 1 ) then
        Do i=istart, iend
           j = i -istart +1
           dFx_drho(i,1) = vrho(1,j)
           dFx_drho(i,2) = vrho(1,j)
           dFx_dgradrho(i,1) = vsigma(1,j) *2.0d0
           dFx_dgradrho(i,2) = vsigma(1,j) *2.0d0
           exc = exc +wos(i) *exc0(j) *( rho(1,j)*2.0d0 )
        End Do
     else
        Do i=istart, iend
           j = i -istart +1
           dFx_drho(i,1) = vrho(1,j)
           dFx_drho(i,2) = vrho(2,j)
           dFx_dgradrho(i,1) = vsigma(1,j) *2.0d0
           dFx_dgradrho(i,2) = vsigma(3,j) *2.0d0
           exc = exc +wos(i) *exc0(j) *( rho(1,j) +rho(2,j) )
        End Do
     endif
  End if

#ifdef __EDA__
  if(sw_eda==ON) then
     Do is=1, ispin
        Do i=ista_r, iend_r
           exc_on_a_grid_wk(i) = exc_on_a_grid_wk(i) +exc0(i) *chgrhr_l(i,is)
        End Do
     End Do
  endif
#endif

  deallocate( rho );  deallocate( sigma )
  deallocate( vrho ); deallocate( vsigma )
  deallocate( exc0 )

end subroutine ex_gga_libxc

#ifdef __EDA__
subroutine cr_gga_libxc( nspin, ispin, ista_r, iend_r, chgrhr_l, grad_rho, grad_trho, &
     &                   wos, exc, dF_drho, dF_dgradrho, exc_on_a_grid_wk, ist, ien )
#else
subroutine cr_gga_libxc( nspin, ispin, ista_r, iend_r, chgrhr_l, grad_rho, grad_trho, &
     &                   wos, exc, dF_drho, dF_dgradrho, ist, ien )
#endif
  use m_Const_Parameters,  only : DP,PAI
  use m_Control_Parameters,  only : xc_func_corr
  use xc_f03_lib_m
  
#ifdef __EDA__
  use m_Const_Parameters,   only : ON
  use m_Control_Parameters, only : sw_eda
#endif

  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in)        :: ist, ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_r:iend_r,nspin)
  real(kind=DP),intent(in)  :: grad_trho(ista_r:iend_r)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)
  real(kind=DP),intent(inout) :: exc
  real(kind=DP),intent(out) :: dF_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out) :: dF_dgradrho(ista_r:iend_r,1)
#ifdef __EDA__
! -----  ascat starts modifying  -----
  real(kind=DP),intent(inout):: exc_on_a_grid_wk(ista_r:iend_r)
! -----  ascat ceases modifying  -----
#endif

  integer(8) :: npoint
  integer :: i, j, is
  integer :: istart, iend
  real(kind=DP) :: c1, c2
  real(kind=DP), allocatable :: rho(:,:), sigma(:,:), vrho(:,:), vsigma(:,:)
  real(kind=DP), allocatable :: exc0(:)

  istart = ista_r;   iend = iend_r
  istart = ist;      iend   = ien

  npoint = iend -istart +1
  if ( npoint < 1 ) return

  allocate( rho(nspin,npoint) )
  allocate( sigma(2*nspin-1,npoint) )
  allocate( vrho(nspin,npoint) )
  allocate( vsigma(2*nspin-1,npoint) )
  allocate( exc0(npoint) )

  if ( nspin == 1 ) then
     Do i=1, npoint
        j = i +istart -1
        rho(1,i) = chgrhr_l(j,1)
        sigma(1,i) = grad_rho(j,1)**2
     End Do
  else
     if ( ispin == 1 ) then
        Do i=1, npoint
           j = i +istart -1
           rho(1,i) = chgrhr_l(j,1) /2.0d0
           rho(2,i) = rho(1,i)
           sigma(1,i) = grad_rho(j,1)**2 /4.0d0
           sigma(2,i) = sigma(1,i)
           sigma(3,i) = sigma(1,i)
        End Do
     else
        Do i=1, npoint
           j = i +istart -1
           rho(1,i) = chgrhr_l(j,1)
           rho(2,i) = chgrhr_l(j,2)

           c1 = grad_rho(j,1)**2;         c2 = grad_rho(j,2)**2
           sigma(1,i) = c1
           sigma(2,i) = ( grad_trho(j)**2 -c1 -c2 ) /2.0d0
           sigma(3,i) = c2
        End Do
     endif
  End if

  call xc_f03_gga_exc_vxc( xc_func_corr, npoint, rho, sigma, exc0, vrho, vsigma )

!!  exc = 0.0d0
  if ( nspin == 1 ) then
     Do i=istart, iend
        j = i -istart +1
        dF_drho(i,1) = dF_drho(i,1) +vrho(1,j)
        dF_dgradrho(i,1) = vsigma(1,j) *2.0d0
        exc = exc +wos(i) *exc0(j) *rho(1,j)
     End Do
  else
     if ( ispin == 1 ) then
        Do i=istart, iend
           j = i -istart +1
           dF_drho(i,1) = dF_drho(i,1) +vrho(1,j)
           dF_drho(i,2) = dF_drho(i,2) +vrho(1,j)
           dF_dgradrho(i,1) = vsigma(1,j) *2.0d0
           exc = exc +wos(i) *exc0(j) *( rho(1,j)*2.0d0 )
        End Do
     else
        Do i=istart, iend
           j = i -istart +1
           dF_drho(i,1) = dF_drho(i,1) +vrho(1,j)
           dF_drho(i,2) = dF_drho(i,2) +vrho(2,j)
           dF_dgradrho(i,1) = ( vsigma(1,j) +vsigma(3,j) )    ! ???
           exc = exc +wos(i) *exc0(j) *( rho(1,j) +rho(2,j) )
        End Do
     endif
  End if

#ifdef __EDA__
  if(sw_eda==ON) then
     Do is=1, ispin
        Do i=ista_r, iend_r
           exc_on_a_grid_wk(i) = exc_on_a_grid_wk(i) + exc0(i) *chgrhr_l(i,is)
        End Do
     End Do
  endif
#endif

  deallocate( rho );  deallocate( sigma )
  deallocate( vrho ); deallocate( vsigma )
  deallocate( exc0 )

end subroutine cr_gga_libxc

subroutine ex_mgga_libxc( nspin, ispin, ista_r, iend_r, &
     &                    chgrhr_l, grad_rho, grad_trho, lapl_rho, ekin_dens, &
     &                    wos, exc,  &
     &                    dFx_drho, dFx_dgradrho, dFx_dlaplrho, dFx_dtau )
  use m_Const_Parameters,  only : DP,PAI
  use m_Control_Parameters,  only : xc_func_exch, xc_info_exch, xc_flag_exch, &
       &                            xc_name_exch, val_c_tb09
  use xc_f03_lib_m

  implicit none

  integer, intent(in) :: nspin, ispin, ista_r, iend_r
  real(kind=DP), intent(in) :: chgrhr_l( ista_r:iend_r, nspin )
  real(kind=DP), intent(in) :: grad_rho( ista_r:iend_r, nspin )
  real(kind=DP), intent(in) :: grad_trho( ista_r:iend_r )
  real(kind=DP), intent(in) :: lapl_rho( ista_r:iend_r, nspin )
  real(kind=DP), intent(in) :: ekin_dens( ista_r:iend_r, nspin )
  real(kind=DP), intent(in) :: wos(ista_r:iend_r)
  real(kind=DP), intent(out) :: dFx_drho( ista_r:iend_r, nspin )
  real(kind=DP), intent(out) :: dFx_dgradrho( ista_r:iend_r, nspin )
  real(kind=DP), intent(out) :: dFx_dlaplrho( ista_r:iend_r, nspin )
  real(kind=DP), intent(out) :: dFx_dtau( ista_r:iend_r, nspin )
  real(kind=DP),intent(inout) :: exc
!
  integer(8) :: npoint
  integer :: i, j, is
  real(kind=DP) :: c1, c2
  real(kind=DP), allocatable :: rho(:,:), sigma(:,:), vrho(:,:), vsigma(:,:)
  real(kind=DP), allocatable :: lapla(:,:), tau(:,:), vlapla(:,:), vtau(:,:)
  real(kind=DP), allocatable :: exc0(:)

  npoint = iend_r -ista_r +1
  if ( npoint < 1 ) return

  allocate( rho(nspin,npoint) )
  allocate( sigma(2*nspin-1,npoint) )
  allocate( lapla(nspin,npoint) )
  allocate( tau(nspin,npoint) )

  allocate( vrho(nspin,npoint) )
  allocate( vsigma(2*nspin-1,npoint) )
  allocate( vlapla(nspin,npoint) )
  allocate( vtau(nspin,npoint) )
  allocate( exc0(npoint) )

  if ( nspin == 1 ) then
     Do i=1, npoint
        j = i +ista_r -1
        rho(1,i) = chgrhr_l(j,1)
        sigma(1,i) = grad_rho(j,1)**2
        lapla(1,i) = lapl_rho(j,1)
        tau(1,i)   = ekin_dens(j,1)
     End Do
  else
     if ( ispin == 1 ) then
        Do i=1, npoint
           j = i +ista_r -1
           rho(1,i) = chgrhr_l(j,1) /2.0d0
           rho(2,i) = rho(1,i)
           sigma(1,i) = grad_rho(j,1)**2 /4.0d0
           sigma(2,i) = sigma(1,i)
           sigma(3,i) = sigma(1,i)
           lapla(1,i) = lapl_rho(j,1) /2.0d0
           lapla(2,i) = lapla(1,i)
           tau(1,i)   = ekin_dens(j,1) /2.0d0
           tau(2,i)   = tau(1,i)
        End Do
     else
        Do i=1, npoint
           j = i +ista_r -1
           rho(1,i) = chgrhr_l(j,1);      rho(2,i) = chgrhr_l(j,2)

           c1 = grad_rho(j,1)**2;         c2 = grad_rho(j,2)**2
           sigma(1,i) = c1
           sigma(2,i) = ( grad_trho(j)**2 -c1 -c2 ) /2.0d0
           sigma(3,i) = c2

           lapla(1,i) = lapl_rho(j,1);    lapla(2,i) = lapl_rho(j,2) 
           tau(1,i)   = ekin_dens(j,1);   tau(2,i)   = ekin_dens(j,2)
        End Do
     endif
  End if

  if ( xc_name_exch == "mgga_x_tb09" ) then
     call xc_f03_func_set_ext_params( xc_func_exch, [val_c_tb09] )
  endif

  if ( xc_flag_exch(0) == 0 ) then         ! pot_only
     call xc_f03_mgga_vxc( xc_func_exch, npoint, rho, sigma, lapla, tau, &
          &                vrho, vsigma, vlapla, vtau )
     exc0 = 0.0d0
  else
     call xc_f03_mgga_exc_vxc( xc_func_exch, npoint, rho, sigma, lapla, tau, &
          &                    exc0, vrho, vsigma, vlapla, vtau )
  endif
!
  exc = 0.0d0
  if ( nspin == 1 ) then
     Do i=ista_r, iend_r
        j = i -ista_r +1
        dFx_drho(i,1) = vrho(1,j)
        dFx_dgradrho(i,1) = vsigma(1,j) *2.0d0
        dFx_dlaplrho(i,1) = vlapla(1,j)
        dFx_dtau(i,1) = vtau(1,j)
        exc = exc +wos(i) *exc0(j) *rho(1,j)
     End Do
  else
     if ( ispin == 1 ) then
        Do i=ista_r, iend_r
           j = i -ista_r +1
           dFx_drho(i,1) = vrho(1,j)
           dFx_drho(i,2) = vrho(1,j)
           dFx_dgradrho(i,1) = vsigma(1,j) *2.0d0
           dFx_dgradrho(i,2) = vsigma(1,j) *2.0d0
           dFx_dlaplrho(i,1) = vlapla(1,j)
           dFx_dlaplrho(i,2) = vlapla(1,j)
           dFx_dtau(i,1) = vtau(1,j)
           dFx_dtau(i,2) = vtau(1,j)
           exc = exc +wos(i) *exc0(j) *( rho(1,j)*2.0d0 )
        End Do
     else
        Do i=ista_r, iend_r
           j = i -ista_r +1
           dFx_drho(i,1) = vrho(1,j)
           dFx_drho(i,2) = vrho(2,j)
           dFx_dgradrho(i,1) = vsigma(1,j) *2.0d0
           dFx_dgradrho(i,2) = vsigma(3,j) *2.0d0
           dFx_dlaplrho(i,1) = vlapla(1,j)
           dFx_dlaplrho(i,2) = vlapla(2,j)
           dFx_dtau(i,1) = vtau(1,j)
           dFx_dtau(i,2) = vtau(2,j)
           exc = exc +wos(i) *exc0(j) *( rho(1,j) +rho(2,j) )
        End Do
     endif
  End if

  deallocate( rho );  deallocate( sigma );  deallocate( lapla );  deallocate( tau )
  deallocate( vrho ); deallocate( vsigma ); deallocate( vlapla ); deallocate( vtau )
  deallocate( exc0 )
!
end subroutine ex_mgga_libxc

subroutine cr_mgga_libxc( nspin, ispin, ista_r, iend_r, &
     &                    chgrhr_l, grad_rho, grad_trho, lapl_rho, ekin_dens, &
     &                    wos, exc,  &
     &                    dF_drho, dF_dgradrho, dF_dlaplrho, dF_dtau )
  use m_Const_Parameters,  only : DP,PAI
  use m_Control_Parameters,  only : xc_func_corr
  use xc_f03_lib_m

  implicit none

  integer, intent(in) :: nspin, ispin, ista_r, iend_r
  real(kind=DP), intent(in) :: chgrhr_l( ista_r:iend_r, nspin )
  real(kind=DP), intent(in) :: grad_rho( ista_r:iend_r, nspin )
  real(kind=DP), intent(in) :: grad_trho( ista_r:iend_r )
  real(kind=DP), intent(in) :: lapl_rho( ista_r:iend_r, nspin )
  real(kind=DP), intent(in) :: ekin_dens( ista_r:iend_r, nspin )
  real(kind=DP), intent(in) :: wos(ista_r:iend_r)
  real(kind=DP), intent(inout) :: dF_drho( ista_r:iend_r, nspin )
  real(kind=DP), intent(inout) :: dF_dgradrho( ista_r:iend_r, 1 )
  real(kind=DP), intent(inout) :: dF_dlaplrho( ista_r:iend_r, nspin )
  real(kind=DP), intent(inout) :: dF_dtau( ista_r:iend_r, nspin )
  real(kind=DP),intent(inout) :: exc
!
  integer(8) :: npoint
  integer :: i, j, is
  real(kind=DP) :: c1, c2
  real(kind=DP), allocatable :: rho(:,:), sigma(:,:), vrho(:,:), vsigma(:,:)
  real(kind=DP), allocatable :: lapla(:,:), tau(:,:), vlapla(:,:), vtau(:,:)
  real(kind=DP), allocatable :: exc0(:)

!
  npoint = iend_r -ista_r +1
  if ( npoint < 1 ) return

  allocate( rho(nspin,npoint) )
  allocate( sigma(2*nspin-1,npoint) )
  allocate( lapla(nspin,npoint) )
  allocate( tau(nspin,npoint) )

  allocate( vrho(nspin,npoint) )
  allocate( vsigma(2*nspin-1,npoint) )
  allocate( vlapla(nspin,npoint) )
  allocate( vtau(nspin,npoint) )
  allocate( exc0(npoint) )

  if ( nspin == 1 ) then
     Do i=1, npoint
        j = i +ista_r -1
        rho(1,i) = chgrhr_l(j,1)
        sigma(1,i) = grad_rho(j,1)**2
        lapla(1,i) = lapl_rho(j,1)
        tau(1,i)   = ekin_dens(j,1)
     End Do
  else
     if ( ispin == 1 ) then
        Do i=1, npoint
           j = i +ista_r -1
           rho(1,i) = chgrhr_l(j,1) /2.0d0
           rho(2,i) = rho(1,i)
           sigma(1,i) = grad_rho(j,1)**2 /4.0d0
           sigma(2,i) = sigma(1,i)
           sigma(3,i) = sigma(1,i)
           lapla(1,i) = lapl_rho(j,1) /2.0d0
           lapla(2,i) = lapla(1,i)
           tau(1,i)   = ekin_dens(j,1) /2.0d0
           tau(2,i)   = tau(1,i)
        End Do
     else
        Do i=1, npoint
           j = i +ista_r -1
           rho(1,i) = chgrhr_l(j,1);      rho(2,i) = chgrhr_l(j,2)

           c1 = grad_rho(j,1)**2;         c2 = grad_rho(j,2)**2
           sigma(1,i) = c1
           sigma(2,i) = ( grad_trho(j)**2 -c1 -c2 ) /2.0d0
           sigma(3,i) = c2

           lapla(1,i) = lapl_rho(j,1);    lapla(2,i) = lapl_rho(j,2) 
           tau(1,i)   = ekin_dens(j,1);   tau(2,i)   = ekin_dens(j,2)
        End Do
     endif
  End if

  call xc_f03_mgga_exc_vxc( xc_func_corr, npoint, rho, sigma, lapla, tau, &
       &                    exc0, vrho, vsigma, vlapla, vtau )

!!  exc = 0.0d0
  if ( nspin == 1 ) then
     Do i=ista_r, iend_r
        j = i -ista_r +1
        dF_drho(i,1) = dF_drho(i,1) +vrho(1,j)
        dF_dgradrho(i,1) = vsigma(1,j) *2.0d0
        dF_dlaplrho(i,1) = dF_dlaplrho(i,1) +vlapla(1,j)
        dF_dtau(i,1)     = dF_dtau(i,1)     +vtau(1,j)
        exc = exc +wos(i) *exc0(j) *rho(1,j)
     End Do
  else
     if ( ispin == 1 ) then
        Do i=ista_r, iend_r
           j = i -ista_r +1
           dF_drho(i,1) = dF_drho(i,1) +vrho(1,j)
           dF_drho(i,2) = dF_drho(i,2) +vrho(1,j)
           dF_dgradrho(i,1) = vsigma(1,j) *2.0d0
           dF_dlaplrho(i,1) = dF_dlaplrho(i,1) +vlapla(1,j)
           dF_dlaplrho(i,2) = dF_dlaplrho(i,2) +vlapla(1,j)
           dF_dtau(i,1)     = dF_dtau(i,1)     +vtau(1,j)
           dF_dtau(i,2)     = dF_dtau(i,2)     +vtau(1,j)
           exc = exc +wos(i) *exc0(j) *( rho(1,j)*2.0d0 )
        End Do
     else
        Do i=ista_r, iend_r
           j = i -ista_r +1
           dF_drho(i,1) = dF_drho(i,1) +vrho(1,j)
           dF_drho(i,2) = dF_drho(i,2) +vrho(2,j)
           dF_dgradrho(i,1) = vsigma(1,j) +vsigma(3,j)

           dF_dlaplrho(i,1) = dF_dlaplrho(i,1) +vlapla(1,j)
           dF_dlaplrho(i,2) = dF_dlaplrho(i,2) +vlapla(2,j)
           dF_dtau(i,1)     = dF_dtau(i,1) +vtau(1,j)
           dF_dtau(i,2)     = dF_dtau(i,2) +vtau(2,j)
           exc = exc +wos(i) *exc0(j) *( rho(1,j) +rho(2,j) )
        End Do
     endif
  End if

  deallocate( rho );  deallocate( sigma );  deallocate( lapla );  deallocate( tau )
  deallocate( vrho ); deallocate( vsigma ); deallocate( vlapla ); deallocate( vtau )
  deallocate( exc0 )

end subroutine cr_mgga_libxc

! ======== PAW Surface Harmonics ====== 
subroutine ex_gga_paw_libxc( nrc, dnr, nspin, chgrhr_l, grad_rho, grad_trho, exc, &
     &                       dFx_drho, dFx_dgradrho, &
     &                       dFx_drr,  dFx_drg,  dFx_dgg, &
     &                       dFx_drrr, dFx_drrg, dFx_drgg, dFx_dggg, &
     &                       ista_nrc, iend_nrc, ist, ien )
  use m_Const_Parameters,  only : DP,PAI
  use m_Control_Parameters,  only : xc_func_exch, xc_flag_exch
  use m_Parallelization,   only : mype
  use xc_f03_lib_m

  implicit none

  integer,intent(in)        :: nrc, dnr, nspin
  real(kind=DP),intent(in)  :: chgrhr_l(ista_nrc:iend_nrc,nspin)
  real(kind=DP),intent(in)  :: grad_rho(ista_nrc:iend_nrc,nspin)
  real(kind=DP),intent(in)  :: grad_trho(ista_nrc:iend_nrc)

  real(kind=DP),intent(out) :: exc(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFx_drho(ista_nrc:iend_nrc,nspin)
  real(kind=DP),intent(out) :: dFx_dgradrho(ista_nrc:iend_nrc,nspin)
  real(kind=DP),intent(out) :: dFx_drr(ista_nrc:iend_nrc,nspin)
  real(kind=DP),intent(out) :: dFx_drg(ista_nrc:iend_nrc,nspin)
  real(kind=DP),intent(out) :: dFx_dgg(ista_nrc:iend_nrc,nspin)
  real(kind=DP),intent(out) :: dFx_drrr(ista_nrc:iend_nrc,nspin)
  real(kind=DP),intent(out) :: dFx_drrg(ista_nrc:iend_nrc,nspin)
  real(kind=DP),intent(out) :: dFx_drgg(ista_nrc:iend_nrc,nspin)
  real(kind=DP),intent(out) :: dFx_dggg(ista_nrc:iend_nrc,nspin)
  integer :: ista_nrc, iend_nrc, ist, ien

  integer(8) :: npoint
  integer :: i, j, is
  real(kind=DP) :: c1, c2
  real(kind=DP), allocatable :: rho(:,:), sigma(:,:), vrho(:,:), vsigma(:,:)
  real(kind=DP), allocatable :: v2rho2(:,:), v2rhosigma(:,:), v2sigma2(:,:)
  real(kind=DP), allocatable :: v3rho3(:,:), v3rho2sigma(:,:), v3rhosigma2(:,:), &
       &                        v3sigma3(:,:)
  real(kind=DP), allocatable :: v4rho4(:,:), v4rho3sigma(:,:), v4rho2sigma2(:,:), &
       &                        v4rhosigma3(:,:), v4sigma4(:,:)
  real(kind=DP), allocatable :: exc0(:)

  npoint = (ien -ist +1)/dnr
  if ( npoint < 1 ) return

  if ( nspin == 1 ) then
     allocate( rho(1,npoint) );      allocate( sigma(1,npoint) )
     allocate( vrho(1,npoint) );     allocate( vsigma(1,npoint) )
     allocate( v2rho2(1,npoint) );   allocate( v2rhosigma(1,npoint) )
     allocate( v2sigma2(1,npoint) )
#ifdef KXC_LXC_AVAILABLE
     if ( xc_flag_exch(3) == 1 .and. xc_flag_exch(4) == 1 ) then
        allocate( v3rho3(1,npoint) );   allocate( v3rho2sigma(1,npoint) )
        allocate( v3rhosigma2(1,npoint) );  
        allocate( v3sigma3(1,npoint) )
        allocate( v4rho4(1,npoint) );   allocate( v4rho3sigma(1,npoint) )
        allocate( v4rho2sigma2(1,npoint) );  
        allocate( v4rhosigma3(1,npoint) );
        allocate( v4sigma4(1,npoint) )
     endif
#endif
  else
     allocate( rho(2,npoint) );      allocate( sigma(3,npoint) )
     allocate( vrho(2,npoint) );     allocate( vsigma(3,npoint) )
     allocate( v2rho2(3,npoint) );   allocate( v2rhosigma(6,npoint) )
     allocate( v2sigma2(6,npoint) )
#ifdef KXC_LXC_AVAILABLE
     if ( xc_flag_exch(3) == 1 .and. xc_flag_exch(4) == 1 ) then
        allocate( v3rho3(4,npoint) );   allocate( v3rho2sigma(9,npoint) )
        allocate( v3rhosigma2(12,npoint) );  
        allocate( v3sigma3(10,npoint) )
        allocate( v4rho4(5,npoint) );   allocate( v4rho3sigma(12,npoint) )
        allocate( v4rho2sigma2(15,npoint) );  
        allocate( v4rhosigma3(20,npoint) );
        allocate( v4sigma4(15,npoint) )
     endif
#endif
  endif

  allocate( exc0(npoint) )

  if ( nspin == 1 ) then
     Do i=1, npoint
        j = ist +(i-1) *dnr
        rho(1,i) = chgrhr_l(j,1)
        sigma(1,i) = grad_rho(j,1)**2
     End Do
  else
     Do i=1, npoint
        j = ist +(i-1) *dnr
        rho(1,i) = chgrhr_l(j,1);      rho(2,i) = chgrhr_l(j,2)
        
        c1 = grad_rho(j,1)**2;         c2 = grad_rho(j,2)**2
        sigma(1,i) = c1
        sigma(2,i) = ( grad_trho(j)**2 -c1 -c2 ) /2.0d0
        sigma(3,i) = c2
     End Do
  End if

#ifdef KXC_LXC_AVAILABLE
  if ( xc_flag_exch(3) == 1 .and. xc_flag_exch(4) == 1 ) then
     call xc_f03_gga( xc_func_exch, npoint, rho, sigma, exc0, vrho, vsigma, &
          &           v2rho2, v2rhosigma,  v2sigma2, &
          &           v3rho3, v3rho2sigma, v3rhosigma2,  v3sigma3, &
          &           v4rho4, v4rho3sigma, v4rho2sigma2, v4rhosigma3, v4sigma4 )
  else
     call xc_f03_gga_exc_vxc_fxc( xc_func_exch, npoint, rho, sigma, exc0, &
          &           vrho, vsigma, &
          &           v2rho2, v2rhosigma, v2sigma2 )
  endif
#else
  call xc_f03_gga_exc_vxc_fxc( xc_func_exch, npoint, rho, sigma, exc0, &
       &           vrho, vsigma, &
       &           v2rho2, v2rhosigma, v2sigma2 )
#endif

  exc = 0.0d0
  if ( nspin == 1 ) then
     Do i=ist, ien, dnr
        j = ( i-ist ) /dnr +1
        dFx_drho(i,1) = vrho(1,j)
        dFx_dgradrho(i,1) = vsigma(1,j) *2.0d0 *grad_rho(i,1)
        exc(i) = exc(i) +exc0(j) *rho(1,j)

        dFx_drr(i,1) = v2rho2(1,j)
        dFx_drg(i,1) = v2rhosigma(1,j) *2.0d0 *grad_rho(i,1)
        dFx_dgg(i,1) = vsigma(1,j) *2.0d0 &
             &         +v2sigma2(1,j) *4.0d0 *grad_rho(i,1)**2 

#ifdef KXC_LXC_AVAILABLE
        if ( xc_flag_exch(3) == 1 .and. xc_flag_exch(4) == 1 ) then
           dFx_drrr(i,1) = v3rho3(1,j)
           dFx_drrg(i,1) = v3rho2sigma(1,j) *2.0d0 *grad_rho(i,1)
           dFx_drgg(i,1) = v2rhosigma(1,j) *2.0d0 &
                &          +v3rhosigma2(1,j) *4.0d0 *grad_rho(i,1)**2
           dFx_dggg(i,1) = vsigma2(1,j) *12.0d0 *grad_rho(i,1) &
                &          +v3sigma3(1,j) *8.0d0 *grad_rho(i,1)**3
        endif
#endif
     End Do
  else
     Do i=ist, ien, dnr
        j = ( i-ist ) /dnr +1
        dFx_drho(i,1) = vrho(1,j)
        dFx_drho(i,2) = vrho(2,j)
        dFx_dgradrho(i,1) = vsigma(1,j) *2.0d0 *grad_rho(i,1)
        dFx_dgradrho(i,2) = vsigma(3,j) *2.0d0 *grad_rho(i,2)

        exc(i) = exc(i) +exc0(j) *( rho(1,j) +rho(2,j) )
        dFx_drr(i,1) = v2rho2(1,j)
        dFx_drr(i,2) = v2rho2(3,j)
        dFx_drg(i,1) = v2rhosigma(1,j) *2.0d0 *grad_rho(i,1)
        dFx_drg(i,2) = v2rhosigma(6,j) *2.0d0 *grad_rho(i,2)
        dFx_dgg(i,1) = vsigma(1,j) *2.0d0 &
             &         +v2sigma2(1,j) *4.0d0 *grad_rho(i,1)**2 
        dFx_dgg(i,2) = vsigma(3,j) *2.0d0 &
             &         +v2sigma2(6,j) *4.0d0 *grad_rho(i,2)**2 

#ifdef KXC_LXC_AVAILABLE
        if ( xc_flag_exch(3) == 1 .and. xc_flag_exch(4) == 1 ) then
           dFx_drrr(i,1) = v3rho3(1,j)
           dFx_drrr(i,2) = v3rho3(4,j)
           dFx_drrg(i,1) = v3rho2sigma(1,j) *2.0d0 *grad_rho(i,1)
           dFx_drrg(i,2) = v3rho2sigma(9,j) *2.0d0 *grad_rho(i,2)
           
           dFx_drgg(i,1) = v2rhosigma(1,j) *2.0d0 &
                &          +v3rhosigma2(1,j) *4.0d0 *grad_rho(i,1)**2
           dFx_drgg(i,2) = v2rhosigma(6,j) *2.0d0 &
                &          +v3rhosigma2(12,j) *4.0d0 *grad_rho(i,2)**2
           dFx_dggg(i,1) = v2sigma2(1,j) *12.0d0 *grad_rho(i,1) &
                &          +v3sigma3(1,j) *8.0d0 *grad_rho(i,1)**3
           dFx_dggg(i,2) = v2sigma2(6,j) *12.0d0 *grad_rho(i,2) &
                &          +v3sigma3(10,j) *8.0d0 *grad_rho(i,2)**3
        endif
#endif
     End Do
  End if

  deallocate( rho );  deallocate( sigma )
  deallocate( vrho ); deallocate( vsigma )
  deallocate( v2rho2 ); deallocate( v2rhosigma );  deallocate( v2sigma2 )

#ifdef KXC_LXC_AVAILABLE
  if ( xc_flag_exch(3) == 1 .and. xc_flag_exch(4) == 1 ) then
     deallocate( v3rho3 ); deallocate( v3rho2sigma );  deallocate( v3rhosigma2 );
     deallocate( v3sigma3 )
     deallocate( v4rho4 ); deallocate( v4rho3sigma );  deallocate( v4rho2sigma2 );
     deallocate( v4rhosigma3 ); deallocate( v4sigma4 )
  endif
#endif

  deallocate( exc0 )

end subroutine ex_gga_paw_libxc

subroutine cr_gga_paw_libxc( nrc, dnr, nspin, chgrhr_l, grad_rho, grad_trho, exc, &
     &                       dF_drho,  dF_dgradrho, dFc_daa,  dFc_dbb,  dFc_dgg ,&
     &                       dFc_dab,  dFc_dag,     dFc_dbg,  dFc_daaa, dFc_dbbb, &
     &                       dFc_dggg, dFc_daab,    dFc_daag, dFc_dabb, dFc_dbbg, &
     &                       dFc_dagg, dFc_dbgg, dFc_dabg, &
     &                       ista_nrc, iend_nrc, ist, ien )
  use m_Const_Parameters,  only : PAI,DP
  use m_Control_Parameters,  only : xc_func_corr, xc_flag_corr
  use xc_f03_lib_m

  implicit none

  integer,intent(in)        :: nrc, dnr, nspin
  real(kind=DP),intent(in)  :: chgrhr_l(ista_nrc:iend_nrc,nspin)
  real(kind=DP),intent(in) :: grad_rho(ista_nrc:iend_nrc,nspin)
  real(kind=DP),intent(in) :: grad_trho(ista_nrc:iend_nrc)
  real(kind=DP),intent(inout) :: exc(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dF_drho(ista_nrc:iend_nrc,nspin)
  real(kind=DP),intent(out) :: dF_dgradrho(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_daa(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_dbb(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_dgg(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_dab(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_dag(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_dbg(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_daaa(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_dbbb(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_dggg(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_daab(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_daag(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_dabb(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_dbbg(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_dagg(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_dbgg(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_dabg(ista_nrc:iend_nrc)
  integer :: ista_nrc, iend_nrc, ist, ien
  integer(8) :: npoint
  integer :: i, j, is
  real(kind=DP) :: c1, c2
  real(kind=DP), allocatable :: rho(:,:), sigma(:,:), vrho(:,:), vsigma(:,:)
  real(kind=DP), allocatable :: v2rho2(:,:), v2rhosigma(:,:), v2sigma2(:,:)
  real(kind=DP), allocatable :: v3rho3(:,:), v3rho2sigma(:,:), v3rhosigma2(:,:), &
       &                        v3sigma3(:,:)
  real(kind=DP), allocatable :: v4rho4(:,:), v4rho3sigma(:,:), v4rho2sigma2(:,:), &
       &                        v4rhosigma3(:,:), v4sigma4(:,:)
  real(kind=DP), allocatable :: exc0(:)

  npoint = (ien -ist +1)/dnr
  if ( npoint < 1 ) return

  if ( nspin == 1 ) then
     allocate( rho(1,npoint) );      allocate( sigma(1,npoint) )
     allocate( vrho(1,npoint) );     allocate( vsigma(1,npoint) )
     allocate( v2rho2(1,npoint) );   allocate( v2rhosigma(1,npoint) )
     allocate( v2sigma2(1,npoint) )
#ifdef KXC_LXC_AVAILABLE
     if ( xc_flag_corr(3) == 1 .and. xc_flag_corr(4) == 1 ) then
        allocate( v3rho3(1,npoint) );   allocate( v3rho2sigma(1,npoint) )
        allocate( v3rhosigma2(1,npoint) );  
        allocate( v3sigma3(1,npoint) )
        allocate( v4rho4(1,npoint) );   allocate( v4rho3sigma(1,npoint) )
        allocate( v4rho2sigma2(1,npoint) );  
        allocate( v4rhosigma3(1,npoint) );
        allocate( v4sigma4(1,npoint) )
     endif
#endif
  else
     allocate( rho(2,npoint) );      allocate( sigma(3,npoint) )
     allocate( vrho(2,npoint) );     allocate( vsigma(3,npoint) )
     allocate( v2rho2(3,npoint) );   allocate( v2rhosigma(6,npoint) )
     allocate( v2sigma2(6,npoint) )
#ifdef KXC_LXC_AVAILABLE
     if ( xc_flag_corr(3) == 1 .and. xc_flag_corr(4) == 1 ) then
        allocate( v3rho3(4,npoint) );   allocate( v3rho2sigma(9,npoint) )
        allocate( v3rhosigma2(12,npoint) );  
        allocate( v3sigma3(10,npoint) )
        allocate( v4rho4(5,npoint) );   allocate( v4rho3sigma(12,npoint) )
        allocate( v4rho2sigma2(15,npoint) );  
        allocate( v4rhosigma3(20,npoint) );
        allocate( v4sigma4(15,npoint) )
     endif
#endif
  endif

  allocate( exc0(npoint) )

  if ( nspin == 1 ) then
     Do i=1, npoint
        j = ist +(i-1) *dnr
        rho(1,i) = chgrhr_l(j,1)
        sigma(1,i) = grad_rho(j,1)**2
     End Do
  else
     Do i=1, npoint
        j = ist +(i-1) *dnr
        rho(1,i) = chgrhr_l(j,1);      rho(2,i) = chgrhr_l(j,2)
        
        c1 = grad_rho(j,1)**2;         c2 = grad_rho(j,2)**2
        sigma(1,i) = c1
        sigma(2,i) = ( grad_trho(j)**2 -c1 -c2 ) /2.0d0
        sigma(3,i) = c2
     End Do
  End if

#ifdef KXC_LXC_AVAILABLE
  if ( xc_flag_corr(3) == 1 .and. xc_flag_corr(4) == 1 ) then
     call xc_f03_gga( xc_func_corr, npoint, rho, sigma, exc0, vrho, vsigma, &
          &           v2rho2, v2rhosigma,  v2sigma2, &
          &           v3rho3, v3rho2sigma, v3rhosigma2,  v3sigma3, &
          &           v4rho4, v4rho3sigma, v4rho2sigma2, v4rhosigma3, v4sigma4 )
  else
     call xc_f03_gga_exc_vxc_fxc( xc_func_corr, npoint, rho, sigma, exc0, &
          &           vrho, vsigma, &
          &           v2rho2, v2rhosigma,  v2sigma2 )
  endif
#else
  call xc_f03_gga_exc_vxc_fxc( xc_func_corr, npoint, rho, sigma, exc0, &
       &           vrho, vsigma, &
       &           v2rho2, v2rhosigma,  v2sigma2 )
#endif
!
!  exc = 0.0d0
  if ( nspin == 1 ) then
     Do i=ist, ien, dnr
        j = ( i-ist ) /dnr +1
        dF_drho(i,1) = dF_drho(i,1) +vrho(1,j)
        dF_dgradrho(i) = vsigma(1,j) *2.0d0 *grad_rho(i,1)
        exc(i) = exc(i) +exc0(j) *rho(1,j)

        dFc_daa(i) = v2rho2(1,j)
        dFc_dag(i) = v2rhosigma(1,j) *2.0d0 *grad_rho(i,1)
        dFc_dgg(i) = vsigma(1,j) *2.0d0 &
             &       +v2sigma2(1,j) *4.0d0 *grad_rho(i,1)**2

#ifdef KXC_LXC_AVAILABLE
        if ( xc_flag_corr(3) == 1 .and. xc_flag_corr(4) == 1 ) then
           dFc_daaa(i) = v3rho3(1,j)
           dFc_daag(i) = v3rho2sigma(1,j) *2.0d0 *grad_rho(i,1)
           dFc_dagg(i) = v2rhosigma(1,j) *2.0d0 &
                &        +v3rhosigma2(1,j) *4.0d0 *grad_rho(i,1)**2
           dFc_dggg(i) = vsigma2(1,j) *12.0d0 *grad_rho(i,1) &
                &        +v3sigma3(1,j) *8.0d0 *grad_rho(i,1)**3
        endif
#endif
     End Do
  else
     Do i=ist, ien, dnr
        j = ( i-ist ) /dnr +1
        dF_drho(i,1) = dF_drho(i,1) +vrho(1,j)
        dF_drho(i,2) = dF_drho(i,2) +vrho(2,j)

        dF_dgradrho(i) = ( vsigma(1,j) +vsigma(3,j) ) *grad_trho(i)

        exc(i) = exc(i) +exc0(j) *( rho(1,j) +rho(2,j) )

        dFc_daa(i) = v2rho2(1,j)
        dFc_dab(i) = v2rho2(2,j)
        dFc_dbb(i) = v2rho2(3,j)
        dFc_dag(i) = v2rhosigma(1,j) *2.0d0 *( grad_trho(i) )
        dFc_dbg(i) = v2rhosigma(6,j) *2.0d0 *( grad_trho(i) )

! is this correct ??
        dFc_dgg(i) = ( vsigma(1,j) +vsigma(3,j) )&  
             &       +v2sigma2(1,j) *4.0d0 *grad_rho(i,1) *grad_trho(i) &
             &       +v2sigma2(6,j) *4.0d0 *grad_rho(i,2) *grad_trho(i)

#ifdef KXC_LXC_AVAILABLE
        if ( xc_flag_corr(3) == 1 .and. xc_flag_corr(4) == 1 ) then
           stop "KXC_LXC are not supported"
           dFc_daaa(i) = v3rho3(1,j)
           dFc_daab(i) = v3rho3(2,j)
           dFc_dabb(i) = v3rho3(3,j)
           dFc_dbbb(i) = v3rho3(4,j)
           
           dFc_daag(i) = v3rho2sigma(1,j) *2.0d0 *grad_rho(i,1)
           dFc_dagg(i) = v2rhosigma(1,j) *2.0d0 &
                &        +v3rhosigma2(1,j) *4.0d0 *grad_rho(i,1)**2
           dFc_dggg(i) = vsigma2(1,j) *12.0d0 *grad_rho(i,1) &
                &        +v3sigma3(1,j) *8.0d0 *grad_rho(i,1)**3
        endif
#endif
     End Do
  End if

  deallocate( rho );  deallocate( sigma )
  deallocate( vrho ); deallocate( vsigma )
  deallocate( v2rho2 ); deallocate( v2rhosigma );  deallocate( v2sigma2 )
#ifdef KXC_LXC_AVAILABLE
  if ( xc_flag_corr(3) == 1 .and. xc_flag_corr(4) == 1 ) then
     deallocate( v3rho3 ); deallocate( v3rho2sigma );  deallocate( v3rhosigma2 );
     deallocate( v3sigma3 )
     deallocate( v4rho4 ); deallocate( v4rho3sigma );  deallocate( v4rho2sigma2 );
     deallocate( v4rhosigma3 ); deallocate( v4sigma4 )
  endif
#endif
  deallocate( exc0 )

end subroutine cr_gga_paw_libxc

subroutine ex_lda_paw_libxc( nrc, dnr, nspin, chgrhr_l, exc, &
     &                       dFx_drho, dFx_drr, dFx_drrr, &
     &                       ista_nrc, iend_nrc, ist, ien )
  use m_Const_Parameters,  only : DP,PAI
  use m_Control_Parameters,  only : xc_func_exch
  use xc_f03_lib_m

  implicit none

  integer,intent(in)        :: nrc, dnr, nspin
  real(kind=DP),intent(in)  :: chgrhr_l(ista_nrc:iend_nrc,nspin)

  real(kind=DP),intent(out) :: exc(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFx_drho(ista_nrc:iend_nrc,nspin)
  real(kind=DP),intent(out) :: dFx_drr(ista_nrc:iend_nrc,nspin)
  real(kind=DP),intent(out) :: dFx_drrr(ista_nrc:iend_nrc,nspin)
  integer :: ista_nrc, iend_nrc, ist, ien

  integer(8) :: npoint
  integer :: i, j, is
  real(kind=DP) :: c1, c2
  real(kind=DP), allocatable :: rho(:,:), vrho(:,:)
  real(kind=DP), allocatable :: v2rho2(:,:)
  real(kind=DP), allocatable :: v3rho3(:,:)
  real(kind=DP), allocatable :: v4rho4(:,:)
  real(kind=DP), allocatable :: exc0(:)

  npoint = (ien -ist +1)/dnr
  if ( npoint < 1 ) return

  if ( nspin == 1 ) then
     allocate( rho(1,npoint) ); 
     allocate( vrho(1,npoint) );
     allocate( v2rho2(1,npoint) );
#ifdef KXC_LXC_AVAILABLE
     allocate( v3rho3(1,npoint) );
     allocate( v4rho4(1,npoint) );
#endif
  else
     allocate( rho(2,npoint) );
     allocate( vrho(2,npoint) );
     allocate( v2rho2(3,npoint) );
#ifdef KXC_LXC_AVAILABLE
     allocate( v3rho3(4,npoint) );
     allocate( v4rho4(5,npoint) );
#endif
  endif

  allocate( exc0(npoint) )

  if ( nspin == 1 ) then
     Do i=1, npoint
        j = ist +(i-1) *dnr
        rho(1,i) = chgrhr_l(j,1)
     End Do
  else
     Do i=1, npoint
        j = ist +(i-1) *dnr
        rho(1,i) = chgrhr_l(j,1);      rho(2,i) = chgrhr_l(j,2)
     End Do
  End if

#ifdef KXC_LXC_AVAILABLE
  call xc_f03_lda( xc_func_exch, npoint, rho, exc0, vrho, &
       &           v2rho2, v3rho3, v4rho4 )
#else
  call xc_f03_lda_exc_vxc_fxc( xc_func_exch, npoint, rho, exc0, &
       &           vrho, v2rho2 )
#endif

  exc = 0.0d0
  if ( nspin == 1 ) then
     Do i=ist, ien, dnr
        j = ( i-ist ) /dnr +1
        dFx_drho(i,1) = vrho(1,j)
        exc(i) = exc(i) +exc0(j) *rho(1,j)

        dFx_drr(i,1) = v2rho2(1,j)
#ifdef KXC_LXC_AVAILABLE
        dFx_drrr(i,1) = v3rho3(1,j)
#endif
     End Do
  else
     Do i=ist, ien, dnr
        j = ( i-ist ) /dnr +1
        dFx_drho(i,1) = vrho(1,j)
        dFx_drho(i,2) = vrho(2,j)

        exc(i) = exc(i) +exc0(j) *( rho(1,j) +rho(2,j) )
        dFx_drr(i,1) = v2rho2(1,j)
        dFx_drr(i,2) = v2rho2(3,j)
#ifdef KXC_LXC_AVAILABLE
        dFx_drrr(i,1) = v3rho3(1,j)
        dFx_drrr(i,2) = v3rho3(4,j)
#endif
     End Do
  End if

  deallocate( rho );
  deallocate( vrho )
  deallocate( v2rho2 )

#ifdef KXC_LXC_AVAILABLE
  deallocate( v3rho3 )
  deallocate( v4rho4 )
#endif

  deallocate( exc0 )
  
end subroutine ex_lda_paw_libxc

subroutine cr_lda_paw_libxc( nrc, dnr, nspin, chgrhr_l, exc, &
     &                       dF_drho,  dFc_daa,  dFc_dbb, &
     &                       dFc_dab,  dFc_daaa, dFc_dbbb, &
     &                       dFc_daab, dFc_dabb, &
     &                       ista_nrc, iend_nrc, ist, ien )
  use m_Const_Parameters,  only : PAI,DP
  use m_Control_Parameters,  only : xc_func_corr
  use xc_f03_lib_m

  implicit none

  integer,intent(in)        :: nrc, dnr, nspin
  real(kind=DP),intent(in)  :: chgrhr_l(ista_nrc:iend_nrc,nspin)
  real(kind=DP),intent(inout) :: exc(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dF_drho(ista_nrc:iend_nrc,nspin)
  real(kind=DP),intent(out) :: dFc_daa(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_dbb(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_dab(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_daaa(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_dbbb(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_daab(ista_nrc:iend_nrc)
  real(kind=DP),intent(out) :: dFc_dabb(ista_nrc:iend_nrc)
  integer :: ista_nrc, iend_nrc, ist, ien
  integer(8) :: npoint
  integer :: i, j, is
  real(kind=DP) :: c1, c2
  real(kind=DP), allocatable :: rho(:,:)
  real(kind=DP), allocatable :: vrho(:,:)
  real(kind=DP), allocatable :: v2rho2(:,:)
  real(kind=DP), allocatable :: v3rho3(:,:)
  real(kind=DP), allocatable :: v4rho4(:,:)
  real(kind=DP), allocatable :: exc0(:)

  npoint = (ien -ist +1)/dnr
  if ( npoint < 1 ) return

  if ( nspin == 1 ) then
     allocate( rho(1,npoint) )
     allocate( vrho(1,npoint) )
     allocate( v2rho2(1,npoint) )
#ifdef KXC_LXC_AVAILABLE
     allocate( v3rho3(1,npoint) )
     allocate( v4rho4(1,npoint) ); 
#endif
  else
     allocate( rho(2,npoint) );    
     allocate( vrho(2,npoint) );   
     allocate( v2rho2(3,npoint) ); 
#ifdef KXC_LXC_AVAILABLE
     allocate( v3rho3(4,npoint) ); 
     allocate( v4rho4(5,npoint) );
#endif
  endif

  allocate( exc0(npoint) )

  if ( nspin == 1 ) then
     Do i=1, npoint
        j = ist +(i-1) *dnr
        rho(1,i) = chgrhr_l(j,1)
     End Do
  else
     Do i=1, npoint
        j = ist +(i-1) *dnr
        rho(1,i) = chgrhr_l(j,1);      rho(2,i) = chgrhr_l(j,2)
     End Do
  End if

#ifdef KXC_LXC_AVAILABLE
  call xc_f03_lda( xc_func_corr, npoint, rho, exc0, vrho, &
       &           v2rho2, v3rho3, v4rho4 )
#else
  call xc_f03_lda_exc_vxc_fxc( xc_func_corr, npoint, rho, exc0, &
       &           vrho, v2rho2 )
#endif
!
!  exc = 0.0d0
  if ( nspin == 1 ) then
     Do i=ist, ien, dnr
        j = ( i-ist ) /dnr +1
        dF_drho(i,1) = dF_drho(i,1) +vrho(1,j)
        exc(i) = exc(i) +exc0(j) *rho(1,j)

        dFc_daa(i) = v2rho2(1,j)
#ifdef KXC_LXC_AVAILABLE
        dFc_daaa(i) = v3rho3(1,j)
#endif
     End Do
  else
     Do i=ist, ien, dnr
        j = ( i-ist ) /dnr +1
        dF_drho(i,1) = dF_drho(i,1) +vrho(1,j)
        dF_drho(i,2) = dF_drho(i,2) +vrho(2,j)
        exc(i) = exc(i) +exc0(j) *( rho(1,j) +rho(2,j) )

        dFc_daa(i) = v2rho2(1,j)
        dFc_dab(i) = v2rho2(2,j)
        dFc_dbb(i) = v2rho2(3,j)

#ifdef KXC_LXC_AVAILABLE
        dFc_daaa(i) = v3rho3(1,j)
        dFc_daab(i) = v3rho3(2,j)
        dFc_dabb(i) = v3rho3(3,j)
        dFc_dbbb(i) = v3rho3(4,j)
#endif
     End Do
  End if

  deallocate( rho );
  deallocate( vrho )
  deallocate( v2rho2 )
#ifdef KXC_LXC_AVAILABLE
  deallocate( v3rho3 )
  deallocate( v4rho4 )
#endif
  deallocate( exc0 )

end subroutine cr_lda_paw_libxc

subroutine set_hyrid_params_exch
  use m_Const_Parameters,  only : DP, ON
  use m_Control_Parameters,  only : xc_info_exch, xc_name_exch, xc_func_exch, &
       &                            alpha_exx, omega_exx, omega_exx_pbe, &
       &                            sw_screened_exchange
  use m_Parallelization,     only : mype

  use xc_f03_lib_m

  implicit none

  integer :: num, i
  real(kind=DP) :: c1
  real(kind=DP), allocatable :: params(:)

  alpha_exx = xc_f03_hyb_exx_coef( xc_func_exch )

  num = xc_f03_func_info_get_n_ext_params( xc_info_exch )
  if ( num <= 0 ) return

  allocate( params(num) )
  Do i=0, num -1
     c1 = xc_f03_func_info_get_ext_params_default_value( xc_info_exch, i )
     params(i+1) = c1
  End Do
  
  deallocate( params )

end subroutine set_hyrid_params_exch

subroutine set_hyrid_params_corr
  use m_Const_Parameters,  only : DP, ON
  use m_Control_Parameters,  only : xc_info_corr, xc_name_corr, xc_func_corr, &
       &                            alpha_exx, omega_exx, omega_exx_pbe, &
       &                            sw_screened_exchange
  use m_Files,              only : nfout

  use xc_f03_lib_m

  implicit none

  integer :: num, i
  real(kind=DP) :: c1
  real(kind=DP), allocatable :: params(:)

  alpha_exx = 0.25d0
  c1 = xc_f03_hyb_exx_coef( xc_func_corr )
  if ( c1 /= 0.0d0 ) alpha_exx = c1

  write(nfout,*) " Exx mixing parameter (trial)    = ", alpha_exx
  write(nfout,*)

  if ( xc_name_corr == "hyb_gga_xc_hse03" &
       &         .or. xc_name_corr == "hyb_gga_xc_hse06" &
       &         .or. xc_name_corr == "hyb_gga_xc_hse12" &
       &         .or. xc_name_corr == "hyb_gga_xc_hse_sol"  &
       &         .or. xc_name_corr == "hyb_gga_xc_hjs_pbe"   &
       &         .or. xc_name_corr == "hyb_gga_xc_hjs_pbe_sol"   ) then
     sw_screened_exchange = ON
  endif

  num = xc_f03_func_info_get_n_ext_params( xc_info_corr )
  if ( num <= 0 ) return

  allocate( params(num) )
  Do i=0, num -1
     c1 = xc_f03_func_info_get_ext_params_default_value( xc_info_corr, i )
     params(i+1) = c1
  End Do
  
  if ( xc_name_corr == "hyb_gga_xc_hse03" &
       &         .or. xc_name_corr == "hyb_gga_xc_hse06" &
       &         .or. xc_name_corr == "hyb_gga_xc_hse12" &
       &         .or. xc_name_corr == "hyb_gga_xc_hse_sol"  &
       &         .or. xc_name_corr == "hyb_gga_xc_hjs_pbe"   &
       &         .or. xc_name_corr == "hyb_gga_xc_hjs_pbe_sol"   ) then
     alpha_exx     = params(1)        ! mixing parameter
     omega_exx     = params(2)        ! screening parameter for HF
     omega_exx_pbe = params(3)        ! screening parameter for PBE
!
     write(nfout,*) " Exx mixing parameter      = ", params(1)
     write(nfout,*) " screening parameter (HF)  = ", params(2)
     write(nfout,*) " screening parameter (DFT) = ", params(3)
     write(nfout,*)
  endif

  deallocate( params )

end subroutine set_hyrid_params_corr

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  MODULE: m_Stress
!
!  AUTHOR(S): H. Sawada   August/20/2003
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! *************************************************************
!
! =========== Contributions ===================================
!
! Through the courtesy of contributors, the following functions are added.
!
! Company:  ASMS Co.,Ltd.
! Functions:  [Identifier: 13.0B]
!                 stress terms are avaiable in the case of DFT-D2 calculations
!
! =============================================================

#ifndef NO_NONLOCAL_DGEMM
#define NONLOCAL_DGEMM
#endif

module m_Stress

!$$#ifndef PARA3D

!   This module is for the calculation of stress tensor.
!   Original program was coded with fortan77 by H. Sawada in 1997,
!  and translated into this module with fortran90 and mpi by H. Sawada
!  and T. Yamasaki in 1999.
!
! $Id: m_Stress.F90 633 2020-12-01 05:11:03Z jkoga $
  use m_Const_Parameters,     only : DP, PAI, PAI2, PAI4, SKIP, zi &
                                  &, Valence_plus_PC_Charge &
!!$ASASASASAS
!!$                                  &, EXC_ONLY,STRESS_, CRDTYP, GAMMA
                                  &, EXC_ONLY,STRESS_, CRDTYP, GAMMA &
                                  &, MAPPED,NOTMAPPED, ON
!!$ASASASASAS
  use m_Crystal_Structure,    only : altv,rltv,univol,nopr,op, p2bmat, b2pmat
  use m_Ionic_System,         only : ntyp, natm,ityp,iwei,pos,zfm3_l,s_ew
  use m_PlaneWaveBasisSet,    only : kg1,kg,kgp,ngabc,iba,nbase,nbmx,gr_l,ylm_l &
                                  &, m_pwBS_sphrp2,m_pwBS_sphrp2_diff
  use m_Electronic_Structure, only : zaj_l,occup_l,eko_l,totch &
                                  &, fsr_l,fsi_l
!!$ASASASASAS
!!$                                  &, m_ES_alloc_arai, m_ES_dealloc_arai
!!$ASASASASAS
  use m_ES_nonlocal,          only :                                            &
 &                                   m_ES_betar_dot_WFs_4_lmta_k                &
 &                                 , G_dot_R_map,G_dot_R_mpi                    &
 &                                 , m_ES_alloc_zfsincos, m_ES_dealloc_zfsincos &
 &                                 , m_ES_alloc_arai, m_ES_dealloc_arai         &
 &                                 , alloc_zfsincos_mpi, dealloc_zfsincos_mpi
#ifdef NONLOCAL_DGEMM
  use m_ES_nonlocal,          only : m_ES_betar_dot_Psi_4_each_k_snl
#endif
  use m_Kpoints,              only : k_symmetry
  use m_PseudoPotential,      only : nlmt,nlmta,lmta,ilmt,lmtt,ltp,mtp,il2p,isph &
                                  &, iqitg,taup,dl2p &
                                  &, q,dion,psc_l,psc_diff_l &
                                  &, qitg_l,qitg_diff_l, modnrm &
                                  &, itpcc,rhpcg_l,rhpcg_diff_l,epc,etot1,ival &
                                  &, m_PP_find_maximum_l, m_PP_include_vanderbilt_pot &
                                  &, ipaw,dion_paw, flg_paw &
                                  &, nqitg &
                                  &, m_PP_set_index_arrays1 &
                                  &, m_PP_set_index_arrays2
  use m_NonLocal_Potential,   only : snld
  use m_XC_Potential,         only : vxc_l, vxcpc_l, exc, s_gga1, s_gga2

#ifndef DISABLE_VDWDF
  use m_vdWDF,  only : s_cnl1, s_cnl2, s_cnl1_pc, s_cnl2_pc, ecnl_vdwdf
#endif

  use m_Charge_Density,       only : chgq_l, hsr, chgsoft
  use m_Control_Parameters,   only : nspin,ipri,kimg,af,nel_Ylm,sw_screening_correction,nhistory_stress, printable&
                                  &, sw_optimize_lattice,sw_uniform &
 &                                 , ke_e0,ke_sigma,ke_a, xctype &
 &                                 , m_CtrlP_cachesize
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Parallelization,      only : MPI_CommGroup,map_k,myrank_k,np_e,ierr,ista_k,iend_k &
                                  &, ista_kngp,iend_kngp,ista_snl,iend_snl,npes,mype &
                                  &, ista_spin, iend_spin
  use m_Screening,            only : screening

! =================================== Added by K. Tagami ============== p1100
  use m_Electronic_Structure,  only : dhub
  use m_Ionic_System,          only : ihubbard
  use m_Control_Parameters,    only : proj_attribute
! ===================================================================== p1100

  use m_IterationNumbers,      only : iteration_unit_cell

! ================================== added by K. Tagami ============= 11.0
  use m_Control_Parameters,   only : noncol, ndim_spinor, ndim_magmom, ndim_chgpot
  use m_PseudoPotential,     only : dion0_noncl, q_noncl
  use m_ES_NonCollinear,       only : m_ES_MagMom_To_DensMat_hsr
  use m_Electronic_Structure,  only : dhub_aimag
! =================================================================== 11.0

! =================================== KT_add ============ 13.0B &13.1AS
  use m_Control_Parameters,    only : external_stress, &
       &                              sw_fix_lattice_angles, sw_vdw_correction, &
       &                              sw_fix_lattice_lengths, &
       &                              fix_angle_alpha, fix_angle_beta, fix_angle_gamma, &
       &                              fix_length_a, fix_length_b, fix_length_c, &
       &                              sw_neglect_stress_offdiagonal, &
       &                              sw_fix_lattice_shapes, fix_shape_ab_plane, &
       &                              fix_shape_bc_plane, fix_shape_ac_plane, &
       &                              estress_has_been_set, sw_add_vlocal_gzero
  use m_Ionic_System,          only : s_vdw
! ======================================================= 13.0B &13.1AS

  use m_Charge_Density,      only : m_CD_symmtrz_of_ff_noncl_C
  use mpi

  implicit none
!  include 'mpif.h'

  integer,      private,pointer, dimension(:)   :: il3
  real(kind=DP),private,pointer, dimension(:)   :: vlength,wkc
  real(kind=DP),private,pointer, dimension(:)   :: grinv,zfsin_tmp,zfcos_tmp,mzfsin_tmp
  real(kind=DP),private,pointer, dimension(:)   :: flchgq
  real(kind=DP),private,pointer, dimension(:,:) :: g,alinvt,vloc
  real(kind=DP),private,pointer, dimension(:,:) :: s_ke,s_or,s_nl
  real(kind=DP),private,pointer, dimension(:,:) :: s_h1,s_h2,s_loc1,s_loc2
  real(kind=DP),private,pointer, dimension(:,:) :: s_xc1,s_xc2
  real(kind=DP),private,pointer, dimension(:,:) :: s_pc
  real(kind=DP),private,allocatable, dimension(:,:,:) :: fsr_diff_l,fsi_diff_l,ylmd
  real(kind=DP),private,pointer, dimension(:)   :: ylm
  real(kind=DP),private,pointer, dimension(:,:,:) :: flchgqd
  real(kind=DP),public, pointer, dimension(:,:,:,:,:,:) :: hsrd,esrd

! ========================= added by K. Tagami =========================== 11.0
  real(kind=DP),public, allocatable, dimension(:,:,:,:,:,:) :: hsid, esid
! ======================================================================== 11.0

  real(kind=DP),private,pointer, dimension(:,:) :: s_0,s_1,s_2
  real(kind=DP),private,pointer, dimension(:,:) :: s_tmp,s_up,s_dn,s
  character(len=2) ,private                     :: stress_name

! ====================== Added by K. Tagami ========================= p1100
  real(kind=DP),private,allocatable, dimension(:,:) :: s_hub
! =================================================================== p1100
  real(kind=DP),private,allocatable, dimension(:,:) :: s_vdwdf

  real(kind=DP),private :: stressmx=-1
  real(kind=DP),dimension(3,3),private :: currstress=0.d0

  real(kind=DP), dimension(3), private :: etot3=0.d0
  real(kind=DP), private :: univol0
  real(kind=DP) :: stress_correction = 0.d0
  character(len('stress_correction')), parameter, private :: tag_stress_correction='stress_correction'
  real(kind=DP), allocatable, target, dimension(:,:) :: ylm_red,ylm_ext
  integer :: nblk = 1000

  interface m_Stress_in_correction
    module procedure in_correction0
    module procedure in_correction1
  end interface m_Stress_in_correction
contains
  subroutine m_Stress_alloc
    allocate(s_ke(3,3)); s_ke = 0.d0
    allocate(s_or(3,3)); s_or = 0.d0
    allocate(s_nl(3,3)); s_nl = 0.d0
    allocate(s_xc1(3,3)); s_xc1 = 0.d0
    allocate(s_xc2(3,3)); s_xc2 = 0.d0
    allocate(s_h1 (3,3)); s_h1  = 0.d0
    allocate(s_h2 (3,3)); s_h2  = 0.d0
    allocate(s_loc1(3,3)); s_loc1 = 0.d0
    allocate(s_loc2(3,3)); s_loc2 = 0.d0
    allocate(s_pc(3,3)); s_pc = 0.d0

! ======================= modified by K. Tagami ================ 11.0
!    allocate(hsrd(natm,nlmt,nlmt,nspin,3,3)); hsrd = 0.d0
!    allocate(esrd(natm,nlmt,nlmt,nspin,3,3)); esrd = 0.d0
!
    if ( noncol ) then
       allocate(hsrd(natm,nlmt,nlmt,ndim_magmom,3,3)); hsrd = 0.d0
       allocate(esrd(natm,nlmt,nlmt,ndim_magmom,3,3)); esrd = 0.d0
       allocate(hsid(natm,nlmt,nlmt,ndim_magmom,3,3)); hsid = 0.d0
       allocate(esid(natm,nlmt,nlmt,ndim_magmom,3,3)); esid = 0.d0
    else
       allocate(hsrd(natm,nlmt,nlmt,nspin,3,3)); hsrd = 0.d0
       allocate(esrd(natm,nlmt,nlmt,nspin,3,3)); esrd = 0.d0
    endif
! ============================================================== 11.0
    allocate(s_0(3,3)); s_0 = 0.d0
    allocate(s_1(3,3)); s_1 = 0.d0
    allocate(s_2(3,3)); s_2 = 0.d0
    allocate(s_tmp(3,3)); s_tmp = 0.d0
    allocate(s_up(3,3)); s_up = 0.d0
    allocate(s_dn(3,3)); s_dn = 0.d0
    allocate(s(3,3)); s = 0.d0
    allocate(alinvt(3,3)); alinvt = rltv / PAI2

! =========================================== Added by K.Tagami ==== p1100
    allocate(s_hub(3,3)); s_hub = 0.d0
! ================================================================== p1100
    allocate(s_vdwdf(3,3)); s_vdwdf = 0.d0

  end subroutine m_Stress_alloc

  subroutine m_Stress_dealloc
    deallocate(s_ke)
    deallocate(s_or)
    deallocate(s_nl)
    deallocate(s_xc1)
    deallocate(s_xc2)
    deallocate(s_h1)
    deallocate(s_h2)
    deallocate(s_loc1)
    deallocate(s_loc2)
    deallocate(s_pc)
    deallocate(hsrd)
    deallocate(esrd)

! ============================== added by K. Tagami ============= 11.0
    if ( allocated(hsid) ) deallocate(hsid)
    if ( allocated(esid) ) deallocate(esid)
! =============================================================== 11.0

    deallocate(s_0)
    deallocate(s_1)
    deallocate(s_2)
    deallocate(s_tmp)
    deallocate(s_up)
    deallocate(s_dn)
    deallocate(s)
    deallocate(alinvt)

! =========================================== Added by K.Tagami ==== p1100
    deallocate(s_hub)
! ================================================================== p1100
    deallocate(s_vdwdf)

  end subroutine m_Stress_dealloc

  subroutine m_Stress_alloc_grinv_g
    integer :: i
    real(kind=DP) :: ga,gb,gc
    allocate(grinv(ista_kngp:iend_kngp)); grinv = 0.d0
    allocate(g(ista_kngp:iend_kngp,3)); g = 0.d0
    do i = ista_kngp, iend_kngp  !for mpi
      if(gr_l(i).lt.1.0d-20) then
        grinv(i)=0.d0
      else
        grinv(i)=1.d0/gr_l(i)
      endif
    enddo
    do i = ista_kngp, iend_kngp  !for mpi
      ga = ngabc(i,1)
      gb = ngabc(i,2)
      gc = ngabc(i,3)
      g(i,1) = rltv(1,1)*ga+rltv(1,2)*gb+rltv(1,3)*gc
      g(i,2) = rltv(2,1)*ga+rltv(2,2)*gb+rltv(2,3)*gc
      g(i,3) = rltv(3,1)*ga+rltv(3,2)*gb+rltv(3,3)*gc
    enddo
  end subroutine m_Stress_alloc_grinv_g

  subroutine m_Stress_dealloc_grinv_g
    deallocate(grinv)
    deallocate(g)
  end subroutine m_Stress_dealloc_grinv_g

  subroutine m_Stress_ke(nfout,kv3,kp_crdtyp,vkxyz)
    integer, intent(in) :: nfout, kv3, kp_crdtyp
    real(kind=DP), intent(in), dimension(kv3,3,kp_crdtyp) :: vkxyz
    real(kind=DP)       :: fac
    integer             :: ik,i,j,ib,ig, ispin
    real(kind=DP),pointer,dimension(:,:) :: s_ke_mpi   ! MPI
    integer             :: id_sname = -1

    call tstatc0_begin('m_Stress_ke ',id_sname)

    allocate(s_ke_mpi(3,3))
    allocate(g(kg1,3)); g = 0.d0
    allocate(vlength(kg1)); vlength = 0.d0
    allocate(wkc(kg1));  wkc  = 0.d0

    do ispin = ista_spin, iend_spin, af+1
    do ik = ispin, kv3-nspin+ispin, nspin
    !do ik = 1, kv3, af+1
       if(map_k(ik) /= myrank_k) cycle               ! MPI
       call k_plus_G_vectors(ik,kgp,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
            & ,g(1,1),g(1,2),g(1,3),vlength)         ! ->(bottom_Subr.)
       do ig = 1, iba(ik)
          wkc(ig) = 1.d0 &
               &  + 2.d0*ke_a/sqrt(PAI)/ke_sigma  &
               &  * exp(-((vlength(ig)**2/2.d0-ke_e0)/ke_sigma)**2)
       end do
       if(k_symmetry(ik) == GAMMA) then
          do ig = 2, iba(ik)
             wkc(ig) = wkc(ig)*2.d0
          end do
       end if

       do i = 1, 3
       do j = 1, 3
       if(kimg.eq.1) then
          do ib = 1, np_e                           ! MPI
             do ig =1,iba(ik)
                fac = wkc(ig)*g(ig,i)*(g(ig,1)*alinvt(1,j) &
                     &                +g(ig,2)*alinvt(2,j)+g(ig,3)*alinvt(3,j))
                s_ke(i,j) = s_ke(i,j) &
                     &        - fac*occup_l(ib,ik)*zaj_l(ig,ib,ik,1)**2
             end do
          end do
       elseif(kimg.eq.2) then
          do ib = 1, np_e                           ! MPI
             do ig =1,iba(ik)
                fac = wkc(ig)*g(ig,i)*(g(ig,1)*alinvt(1,j) &
                     &       +g(ig,2)*alinvt(2,j)+g(ig,3)*alinvt(3,j))
                s_ke(i,j) = s_ke(i,j) &
                     &        - fac*occup_l(ib,ik) &
                     &        *(zaj_l(ig,ib,ik,1)**2+zaj_l(ig,ib,ik,2)**2)
             end do
          end do
       endif
       enddo
       enddo
    enddo
    enddo

    call mpi_allreduce(s_ke,s_ke_mpi,3*3,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr) !MPI
    s_ke = s_ke_mpi  ! MPI

    s_ke=s_ke/dble(kv3)*2.d0

    stress_name = 'KI'
    if(af == 0) then
       s_0 = s_ke
       call check_stress(nfout)
    else
       s_up = s_ke
       call check_af(nfout)
    endif

    deallocate(s_ke_mpi)
    deallocate(g)
    deallocate(vlength)
    deallocate(wkc)

    call tstatc0_end(id_sname)
  end subroutine m_Stress_ke

! ========================= added by K. Tagami ======================= 11.0
  subroutine m_Stress_ke_noncl( nfout, kv3, kp_crdtyp, vkxyz )
    integer, intent(in) :: nfout, kv3, kp_crdtyp
    real(kind=DP), intent(in), dimension(kv3,3,kp_crdtyp) :: vkxyz
    real(kind=DP)       :: fac
    integer             :: ik,i,j,ib,ig
    real(kind=DP),pointer,dimension(:,:) :: s_ke_mpi   ! MPI
    integer             :: id_sname = -1

    integer :: is, k1

    call tstatc0_begin('m_Stress_ke_noncl ',id_sname)

    allocate(s_ke_mpi(3,3))
    allocate(g(kg1,3)); g = 0.d0
    allocate(vlength(kg1)); vlength = 0.d0
    allocate(wkc(kg1));  wkc  = 0.d0

    do ik = 1, kv3, ndim_spinor
       if(map_k(ik) /= myrank_k) cycle               ! MPI
       call k_plus_G_vectors(ik,kgp,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
            & ,g(1,1),g(1,2),g(1,3),vlength)         ! ->(bottom_Subr.)

       do ig = 1, iba(ik)
          wkc(ig) = 1.d0 &
               &  + 2.d0*ke_a/sqrt(PAI)/ke_sigma  &
               &  * exp(-((vlength(ig)**2/2.d0-ke_e0)/ke_sigma)**2)
       end do
       if(k_symmetry(ik) == GAMMA) then
          do ig = 2, iba(ik)
             wkc(ig) = wkc(ig)*2.d0
          end do
       end if

       Do is=1, ndim_spinor
          k1 = ik + is -1

          do i = 1, 3
             do j = 1, 3

                if(kimg.eq.1) then
                   do ib = 1, np_e                           ! MPI
                      do ig =1,iba(ik)
                         fac = wkc(ig)*g(ig,i)*(g(ig,1)*alinvt(1,j) &
                              &                +g(ig,2)*alinvt(2,j)+g(ig,3)*alinvt(3,j))
                         s_ke(i,j) = s_ke(i,j) &
                              &        - fac*occup_l(ib,ik)*zaj_l(ig,ib,k1,1)**2
                      end do
                   end do
                elseif(kimg.eq.2) then
                   do ib = 1, np_e                           ! MPI
                      do ig =1,iba(ik)
                         fac = wkc(ig)*g(ig,i)*(g(ig,1)*alinvt(1,j) &
                              &       +g(ig,2)*alinvt(2,j)+g(ig,3)*alinvt(3,j))
                         s_ke(i,j) = s_ke(i,j) &
                              &        - fac*occup_l(ib,ik) &
                              &        *(zaj_l(ig,ib,k1,1)**2+zaj_l(ig,ib,k1,2)**2)
                      end do
                   end do
                endif
             enddo
          enddo

       End do

    enddo


    if ( npes > 1 ) then
       call mpi_allreduce( s_ke, s_ke_mpi, 3*3, mpi_double_precision, &
            &              mpi_sum, MPI_CommGroup, ierr ) !MPI
       s_ke = s_ke_mpi  ! MPI
    endif

    s_ke = s_ke/ dble(kv3 /ndim_spinor)

    stress_name = 'KI'
    s_0 = s_ke
    call check_stress(nfout)

    deallocate(s_ke_mpi); deallocate(g);  deallocate(vlength); deallocate(wkc)

    call tstatc0_end(id_sname)
  end subroutine m_Stress_ke_noncl
! ================================================================== 11.0

  subroutine m_Stress_hsr_diff(nfout,kv3)
    integer, intent(in) :: nfout,kv3
!!$ASASASASAS
    !!$integer    :: i1,i2,ia,it,ispin,ik,i,lmt1,lmt2,lmta1,lmta2,iksnl
    integer    :: i1,i2,ia,it,ispin,ik,i,lmt1,lmt2,lmta1,lmta2,iksnl,mapmode
!!$ASASASASAS
    integer    :: id_sname = -1
    real(kind=DP) :: fac, w_n, ek_n, c
    real(kind=DP),pointer,dimension(:,:,:,:,:,:) :: hsrd_mpi, esrd_mpi  ! MPI
    real(kind=DP),pointer,dimension(:,:,:)       :: snld_mpi            ! MPI
!!$ASASASASAS
    real(kind=DP) :: dtmp1=0.d0
    real(kind=DP) :: dtmp2=0.d0
!!$ASASASASAS

    call tstatc0_begin('m_Stress_hsr_diff ',id_sname)

    allocate(hsrd_mpi(natm,nlmt,nlmt,nspin,3,3))   ! MPI
    allocate(esrd_mpi(natm,nlmt,nlmt,nspin,3,3))   ! MPI

    call m_ES_alloc_zfsincos(0)
    call m_ES_alloc_arai(0)
!!$ASASASASAS
    call alloc_zfsincos_mpi()
!!$ASASASASAS
    allocate(fsr_diff_l(np_e,nlmta,ista_k:iend_k)); fsr_diff_l = 0.d0
    allocate(fsi_diff_l(np_e,nlmta,ista_k:iend_k)); fsi_diff_l = 0.d0

    fac = 2.d0/dble(kv3)
    hsrd = 0.d0
    esrd = 0.d0

#ifdef NONLOCAL_DGEMM
    do i1 = 1, 3
    do i2 = 1, 3
!    do ispin = 1, nspin, af+1
    do ispin = ista_spin, iend_spin, af+1
       do ik = ispin, kv3+ispin-nspin, nspin
          if(map_k(ik) /= myrank_k) cycle         ! MPI
            snld_mpi => snld(:,:,:,i1,i2)   ! MPI
            call m_ES_betar_dot_Psi_4_each_k_snl &
            &   (nfout,snld_mpi,zaj_l,ista_k,iend_k,ik,fsr_diff_l,fsi_diff_l,precalculate_phase=.false.)
            do ia = 1, natm
              it = ityp(ia)
              do i = 1, np_e                          ! MPI
                 w_n = occup_l(i,ik) * fac
                 ek_n = eko_l(i,ik)
                 do lmt1 = 1,ilmt(it)
                   lmta1    = lmta(lmt1,ia)
                   do lmt2 = lmt1,ilmt(it)
                     lmta2    = lmta(lmt2,ia)
                     if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
                       dtmp1 = fsi_l(i,lmta2,ik)
                       dtmp2 = fsi_l(i,lmta1,ik)
                     endif
                     c= w_n * &
                      &     (  fsr_diff_l(i,lmta1,ik)*fsr_l(i,lmta2,ik) &
                      &     +  fsi_diff_l(i,lmta1,ik)*dtmp1 &
                      &     +  fsr_diff_l(i,lmta2,ik)*fsr_l(i,lmta1,ik) &
                      &     +  fsi_diff_l(i,lmta2,ik)*dtmp2 )
                     hsrd(ia,lmt1,lmt2,ispin,i1,i2)=hsrd(ia,lmt1,lmt2,ispin,i1,i2) &
                                   &     + c
                     esrd(ia,lmt1,lmt2,ispin,i1,i2)=esrd(ia,lmt1,lmt2,ispin,i1,i2) &
                                   &     + ek_n * c
                   enddo
                 enddo
              enddo
            enddo
       enddo
    enddo
    enddo
    enddo
#else
    do i1 = 1, 3
    do i2 = i1, 3
      do ia = 1, natm
        it = ityp(ia)
!!$ASASASASAS
!!$        call G_dot_R(natm,ia,pos,kgp,nbmx,ngabc,zfcos,zfsin)
        if ( kv3/nspin == 1 ) then
          mapmode = MAPPED
          call G_dot_R_map(ia,1)
        else
          mapmode = NOTMAPPED
          call G_dot_R_mpi(ia)
        endif
!!$ASASASASAS
!        do ispin = 1, nspin, af+1
        do ispin = ista_spin, iend_spin, af+1
        do ik = ispin, kv3+ispin-nspin, nspin
          if(map_k(ik) /= myrank_k) cycle         ! MPI
          iksnl = (ik-1)/nspin + 1
          snld_mpi => snld(:,:,ista_snl:iend_snl,i1,i2)   ! MPI
          call m_ES_betar_dot_WFs_4_lmta_k &
!!$ASASASASAS
!!$           & (ista_k,iend_k,ik,zaj_l,ia,iksnl,snld_mpi,fsr_diff_l,fsi_diff_l,0)  ! MPI
           & (ista_k,iend_k,ik,zaj_l,ia,iksnl,snld_mpi,fsr_diff_l,fsi_diff_l,mapmode)  ! MPI
!!$ASASASASAS
!!$           & (ista_k,iend_k,ik,zaj_l,ia,snld(1,1,ista_snl,i1,i2),fsr_diff_l,fsi_diff_l)  ! MPI
          do i = 1, np_e                          ! MPI
             w_n = occup_l(i,ik) * fac
             ek_n = eko_l(i,ik)
             do lmt1 = 1,ilmt(it)
               lmta1    = lmta(lmt1,ia)
               do lmt2 = lmt1,ilmt(it)
                 lmta2    = lmta(lmt2,ia)
!!$ASASASASAS
                 if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
                   dtmp1 = fsi_l(i,lmta2,ik)
                   dtmp2 = fsi_l(i,lmta1,ik)
                 endif
!!$                 c= w_n * &
!!$                  &     (  fsr_diff_l(i,lmta1,ik)*fsr_l(i,lmta2,ik) &
!!$                  &     +  fsi_diff_l(i,lmta1,ik)*fsi_l(i,lmta2,ik) &
!!$                  &     +  fsr_diff_l(i,lmta2,ik)*fsr_l(i,lmta1,ik) &
!!$                  &     +  fsi_diff_l(i,lmta2,ik)*fsi_l(i,lmta1,ik) )
                 c= w_n * &
                  &     (  fsr_diff_l(i,lmta1,ik)*fsr_l(i,lmta2,ik) &
                  &     +  fsi_diff_l(i,lmta1,ik)*dtmp1 &
                  &     +  fsr_diff_l(i,lmta2,ik)*fsr_l(i,lmta1,ik) &
                  &     +  fsi_diff_l(i,lmta2,ik)*dtmp2 )
!!$ASASASASAS
                 hsrd(ia,lmt1,lmt2,ispin,i1,i2)=hsrd(ia,lmt1,lmt2,ispin,i1,i2) &
                                  &     + c
                 esrd(ia,lmt1,lmt2,ispin,i1,i2)=esrd(ia,lmt1,lmt2,ispin,i1,i2) &
                                  &     + ek_n * c
               enddo    ! lmt2
             enddo    ! lmt1
          enddo    ! i
       enddo    ! ik
       enddo    ! ispin
    enddo    !ia
    enddo    !i2
    enddo    !i1
#endif

    call mpi_allreduce(hsrd,hsrd_mpi,natm*nlmt*nlmt*nspin*3*3,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr) ! MPI
    call mpi_allreduce(esrd,esrd_mpi,natm*nlmt*nlmt*nspin*3*3,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr) ! MPI
    hsrd = hsrd_mpi  ! MPI
    esrd = esrd_mpi  ! MPI

!!$ASASASASAS
    call dealloc_zfsincos_mpi()
!!$ASASASASAS
    call m_ES_dealloc_arai()
    call m_ES_dealloc_zfsincos()
    deallocate(fsr_diff_l); deallocate(fsi_diff_l)
    deallocate(hsrd_mpi); deallocate(esrd_mpi)

    call tstatc0_end(id_sname)
  end subroutine m_Stress_hsr_diff

! ========================== added by K. Tagami =========== 11.0
  subroutine m_Stress_hsr_diff_noncl(nfout,kv3)
    integer, intent(in) :: nfout,kv3
    integer    :: i1,i2,ia,it,ispin,ik,i,lmt1,lmt2,lmta1,lmta2,iksnl,mapmode

    integer    :: id_sname = -1
    real(kind=DP) :: fac, w_n, ek_n, c1, c2
    real(kind=DP),pointer,dimension(:,:,:,:,:,:) :: hsrd_mpi, esrd_mpi  ! MPI
    real(kind=DP),pointer,dimension(:,:,:)       :: snld_mpi            ! MPI

    real(kind=DP) :: rho_r_magmom(ndim_magmom)
    real(kind=DP) :: rho_i_magmom(ndim_magmom)
    real(kind=DP) :: c_nr( ndim_spinor,ndim_spinor )
    real(kind=DP) :: c_ni( ndim_spinor,ndim_spinor )
    real(kind=DP), allocatable, dimension(:,:,:) :: fsr_diff_l,fsi_diff_l

    integer :: is1, is2, istmp, k1, k2

    call tstatc0_begin('m_Stress_hsr_diff_noncl ',id_sname)

    allocate( hsrd_mpi(natm,nlmt,nlmt,ndim_magmom,3,3) )   ! MPI
    allocate( esrd_mpi(natm,nlmt,nlmt,ndim_magmom,3,3) )   ! MPI

    call m_ES_alloc_zfsincos(0)
    call m_ES_alloc_arai(0)

    call alloc_zfsincos_mpi()

    allocate(fsr_diff_l(np_e,nlmta,ista_k:iend_k)); fsr_diff_l = 0.d0
    allocate(fsi_diff_l(np_e,nlmta,ista_k:iend_k)); fsi_diff_l = 0.d0

    fac = 1.d0 /dble(kv3/ndim_spinor)

    hsrd = 0.d0;  esrd = 0.d0
    hsid = 0.d0;  esid = 0.d0

    do i1 = 1, 3
       do i2 = 1, 3
          do ia = 1, natm
             it = ityp(ia)

             if ( kv3 / ndim_spinor == 1 ) then
                mapmode = MAPPED
                call G_dot_R_map(ia,1)
             else
                mapmode = NOTMAPPED
                call G_dot_R_mpi(ia)
             endif

             Do ik=1, kv3, ndim_spinor
                if (map_k(ik) /= myrank_k) cycle         ! MPI
                iksnl = (ik-1) /ndim_spinor + 1

                snld_mpi => snld(:,:,ista_snl:iend_snl,i1,i2)   ! MPI

                Do is1=1, ndim_spinor
                   k1 = ik + is1 -1
                   call m_ES_betar_dot_WFs_4_lmta_k( ista_k, iend_k, k1, &
                        &                            zaj_l, ia, iksnl, snld_mpi,&
                        &                            fsr_diff_l, fsi_diff_l, mapmode )
                                                                   ! MPI
                End do

                Do i = 1, np_e                          ! MPI
                   w_n = occup_l(i,ik) * fac
                   ek_n = eko_l(i,ik)

                   do lmt1 = 1,ilmt(it)
                      lmta1    = lmta(lmt1,ia)

                      do lmt2 = lmt1,ilmt(it)
!!!!!!!                      do lmt2 = 1,ilmt(it)
                         lmta2    = lmta(lmt2,ia)

                         Do is1=1, ndim_spinor
                            Do is2=1, ndim_spinor
                               k1 = ik + is1 -1
                               k2 = ik + is2 -1
                               istmp = ( is1 -1 )*ndim_spinor + is2

                               c1 = w_n *( fsr_diff_l(i,lmta1,k1)*fsr_l(i,lmta2,k2) &
                                    &     +fsi_diff_l(i,lmta1,k1)*fsi_l(i,lmta2,k2) &
                                    &     +fsr_diff_l(i,lmta2,k2)*fsr_l(i,lmta1,k1) &
                                    &     +fsi_diff_l(i,lmta2,k2)*fsi_l(i,lmta1,k1) )
                               c2 = w_n *(-fsr_diff_l(i,lmta1,k1)*fsi_l(i,lmta2,k2) &
                                    &     +fsi_diff_l(i,lmta1,k1)*fsr_l(i,lmta2,k2) &
                                    &     +fsr_diff_l(i,lmta2,k2)*fsi_l(i,lmta1,k1) &
                                    &     -fsi_diff_l(i,lmta2,k2)*fsr_l(i,lmta1,k1) )

                               c_nr(is1,is2) = c1;      c_ni(is1,is2) = c2
                            End do
                         End do

! -- convert from ss to magmom representaion --
                         rho_r_magmom(1) = c_nr(1,1) + c_nr(2,2);         ! ctot
                         rho_r_magmom(2) = c_nr(1,2) + c_nr(2,1);         ! mx
                         rho_r_magmom(3) = c_ni(2,1) - c_ni(1,2);         ! my
                         rho_r_magmom(4) = c_nr(1,1) - c_nr(2,2);          ! mz
!
                         rho_i_magmom(1) = c_ni(1,1) + c_ni(2,2);         ! ctot
                         rho_i_magmom(2) = c_ni(1,2) + c_ni(2,1);         ! mx
                         rho_i_magmom(3) =-c_nr(2,1) + c_nr(1,2);         ! my
                         rho_i_magmom(4) = c_ni(1,1) - c_ni(2,2);          ! mz
! -----------------------------------------------------------------------

                         Do istmp=1, ndim_magmom
                            hsrd(ia,lmt1,lmt2,istmp,i1,i2) &
                                 & = hsrd(ia,lmt1,lmt2,istmp,i1,i2) &
                                 &  +rho_r_magmom(istmp)
                            esrd(ia,lmt1,lmt2,istmp,i1,i2) &
                                 & = esrd(ia,lmt1,lmt2,istmp,i1,i2) &
                                 &  +ek_n *rho_r_magmom(istmp)

                            hsid(ia,lmt1,lmt2,istmp,i1,i2) &
                                 & = hsid(ia,lmt1,lmt2,istmp,i1,i2) &
                                 &  +rho_i_magmom(istmp)
                            esid(ia,lmt1,lmt2,istmp,i1,i2) &
                                 & = esid(ia,lmt1,lmt2,istmp,i1,i2) &
                                 &  +ek_n *rho_i_magmom(istmp)
                         End do

                      enddo    ! lmt2
                   enddo    ! lmt1
                End do    ! i

             enddo    ! ik
          enddo    !ia
       enddo    !i2
    enddo    !i1

    if ( npes > 1 ) then
       call mpi_allreduce( hsrd, hsrd_mpi, natm*nlmt*nlmt*ndim_magmom*3*3, &
            &              mpi_double_precision, mpi_sum, MPI_CommGroup, ierr ) ! MPI
       call mpi_allreduce( esrd, esrd_mpi, natm*nlmt*nlmt*ndim_magmom*3*3,&
            &              mpi_double_precision, mpi_sum,MPI_CommGroup, ierr ) ! MPI
       hsrd = hsrd_mpi  ! MPI
       esrd = esrd_mpi  ! MPI
!
       call mpi_allreduce( hsid, hsrd_mpi, natm*nlmt*nlmt*ndim_magmom*3*3, &
            &              mpi_double_precision, mpi_sum, MPI_CommGroup, ierr ) ! MPI
       call mpi_allreduce( esid, esrd_mpi, natm*nlmt*nlmt*ndim_magmom*3*3,&
            &              mpi_double_precision, mpi_sum,MPI_CommGroup, ierr ) ! MPI
       hsid = hsrd_mpi  ! MPI
       esid = esrd_mpi  ! MPI

    endif

    call dealloc_zfsincos_mpi()
    call m_ES_dealloc_arai()
    call m_ES_dealloc_zfsincos()

    deallocate(fsr_diff_l); deallocate(fsi_diff_l)
    deallocate(hsrd_mpi); deallocate(esrd_mpi)

    if ( flg_paw ) then
       Do i1=1, 3
          Do i2=1, 3
             call m_CD_symmtrz_of_ff_noncl_C( hsrd(:,:,:,:,i1,i2), hsid(:,:,:,:,i1,i2) )
             call m_CD_symmtrz_of_ff_noncl_C( esrd(:,:,:,:,i1,i2), esid(:,:,:,:,i1,i2) )
          End Do
       End Do
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Stress_hsr_diff_noncl
! ================================================================ 11.0

!!$  subroutine m_Stress_xcfft_diff(nfout)
!!$    integer, intent(in) :: nfout
!!$    integer    :: id_sname = -1
!!$
!!$    call tstatc0_begin('m_Stress_xcfft_diff ',id_sname)
!!$
!!$    call xc_potential(nfout,Valence_plus_PC_Charge,chgq_l,STRESS &
!!$                 &   ,chgsoft,hsr,hsrd)
!!$
!!$    if(af == 0) then
!!$       s_0 = s_gga1
!!$       stress_name = 'G1'
!!$       call check_stress(nfout)
!!$       s_0 = s_gga2
!!$       stress_name = 'G2'
!!$       call check_stress(nfout)
!!$    else
!!$       s_up = s_gga1
!!$       stress_name = 'G1'
!!$       call check_af(nfout)
!!$       s_up = s_gga2
!!$       stress_name = 'G2'
!!$       call check_af(nfout)
!!$    endif
!!$
!!$    call tstatc0_end(id_sname)
!!$  end subroutine m_Stress_xcfft_diff

  subroutine m_Stress_check_g12(nfout)
    integer, intent(in) :: nfout
    if(af == 0) then
       s_0 = s_gga1
       stress_name = 'G1'
       call check_stress(nfout)
       s_0 = s_gga2
       stress_name = 'G2'
       call check_stress(nfout)
    else
       s_up = s_gga1
       stress_name = 'G1'
       call check_af(nfout)
       s_up = s_gga2
       stress_name = 'G2'
       call check_af(nfout)
    endif
  end subroutine m_Stress_check_g12

  subroutine m_Stress_lclchg_diff(nfout)
    integer, intent(in) :: nfout
    integer    :: n,ilm3,i,it,ik,mdvdb,ia,is,mspin,i1,i2
    integer    :: lmt1,lmt2,il1,il2,tau1,tau2,l3,iiqitg
    real(kind=DP) :: fac,dga,c1,c2
    real(kind=DP),allocatable,target,dimension(:) :: ylm_t
    real(kind=DP), pointer, dimension(:,:)        :: ylmd_mpi
    integer :: ibl1,ibl2
#ifndef _m_Stress_no_loop_exchange_
    integer :: m, maxm, ip, np, iq
    integer, parameter :: mcritical = 4*2+1
    integer, allocatable, dimension(:) :: nqitg_sp, nqitg_sp0 !d(ntyp)
    integer, allocatable, dimension(:) :: iq2l3 ! d(nqitg)
    integer, allocatable, dimension(:,:) :: nc  ! d(maxm,nqitg)
    integer :: mc ! maxval(nc)
    integer, allocatable, dimension(:,:,:) :: nc2lmt1, nc2lmt2, nc2n ! d(mc,maxm,nqitg)
#endif
    integer    :: id_sname = -1

    if(modnrm == SKIP) return

    call tstatc0_begin('m_Stress_lclchg_diff ',id_sname,level=1)

    do i1=1,3
    do i2=1,3

!    allocate(zfcos_tmp(ista_kngp:iend_kngp))
!    allocate(zfsin_tmp(ista_kngp:iend_kngp))
!    zfcos_tmp = 0.d0; zfsin_tmp = 0.d0
    allocate(vloc(ista_kngp:iend_kngp,kimg)); vloc = 0.d0

    allocate(flchgq(nspin)); flchgq = 0.d0
    allocate(flchgqd(3,3,nspin)); flchgqd = 0.d0

    do ik = 1, kimg
      do it = 1, ntyp
         do i = ista_kngp, iend_kngp  !for mpi
            vloc(i,ik)=vloc(i,ik)+psc_l(i,it)*zfm3_l(i,it,ik)
            if(sw_screening_correction==ON) then
               vloc(i,ik)=vloc(i,ik)-ival(it)*screening%phik(i)/univol*zfm3_l(i,it,ik)
            end if
        enddo
      enddo
    enddo

    call m_PP_find_maximum_l(n)   ! n-1: maximum l
    n = (n-1) + (n-1) + 1
    allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)
#ifndef _m_Stress_no_loop_exchange_
    allocate(nqitg_sp(ntyp)); allocate(nqitg_sp0(ntyp))
    allocate(iq2l3(nqitg))
    allocate(nc(mcritical,nqitg));nc=0
    call m_PP_set_index_arrays1(nfout,ntyp,nqitg,mcritical,n**2,il3 &
         & ,maxm,mc,nqitg_sp,nqitg_sp0,iq2l3,nc)
    allocate(nc2lmt1(mc,maxm,nqitg))
    allocate(nc2lmt2(mc,maxm,nqitg))
    allocate(nc2n(mc,maxm,nqitg))
    call m_PP_set_index_arrays2(nfout,mc,maxm,nqitg,mcritical,n**2,il3,iq2l3 &
         & ,nc2lmt1,nc2lmt2,nc2n,nc) ! -> nc2lmt1, nc2lmt2, nc2n, nc
#endif
!    allocate(ylm_t(ista_kngp:iend_kngp)); ylm_t = 0.d0
    allocate(ylmd(ista_kngp:iend_kngp,3,n**2)); ylmd = 0.d0
    allocate(ylmd_mpi(ista_kngp:iend_kngp,3)); ylmd_mpi = 0.d0
    do ilm3 = 1, n**2
!mpi       call m_pwBS_sphrp2(ilm3,rltv,ista_kngp,iend_kngp,ylm2(1,ilm3))
!!$       call m_pwBS_sphrp2(ilm3,rltv,ylm2_mpi)
!!$       do i = ista_kngp, iend_kngp  !for mpi
!!$          ylm2(i,ilm3) = ylm2_mpi(i)
!!$       enddo
!mpi       call m_pwBS_sphrp2_diff(ilm3,rltv,ylmd(1,1,ilm3))
       call m_pwBS_sphrp2_diff(ilm3,rltv,ylmd_mpi)
       do i = ista_kngp, iend_kngp  !for mpi
          ylmd(i,1,ilm3) = ylmd_mpi(i,1)
          ylmd(i,2,ilm3) = ylmd_mpi(i,2)
          ylmd(i,3,ilm3) = ylmd_mpi(i,3)
       enddo
    end do
    deallocate(ylmd_mpi)
    if(n**2 > nel_Ylm) then
       allocate(ylm_ext(ista_kngp:iend_kngp,nel_Ylm+1:n**2));  ylm_ext = 0.d0
       allocate(ylm_t(ista_kngp:iend_kngp)); ylm_t = 0.d0
       do ilm3 = nel_Ylm+1, n**2
          call m_pwBS_sphrp2(ilm3,rltv,ista_kngp,iend_kngp,ylm_t)  ! (ilm3,rltv,ngabc,gr_l)->(ylm)
          ylm_ext(:,ilm3) = ylm_t(:)
       end do
       deallocate(ylm_t)
    end if

    call blksize(n)
    do ibl1 = ista_kngp, iend_kngp, nblk
    ibl2 = ibl1+nblk-1
    if(ibl2 .gt. iend_kngp) ibl2 = iend_kngp
#ifndef _m_Stress_no_loop_exchange_
    allocate(zfsin_tmp(ibl1:ibl2));zfsin_tmp=0.d0
    allocate(zfcos_tmp(ibl1:ibl2));zfcos_tmp=0.d0
    allocate(mzfsin_tmp(ibl1:ibl2));mzfsin_tmp = 0.d0
    do ia = 1, natm
       it = ityp(ia)
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) cycle
       call calc_phase2(natm,pos,ia,kgp,ngabc,ibl1,ibl2,zfcos_tmp,zfsin_tmp)
       mzfsin_tmp = -zfsin_tmp
       do iiqitg = nqitg_sp0(it), nqitg_sp(it)
          l3 = iq2l3(iiqitg)
          do m = 1, 2*l3+1
             ilm3 = l3*l3+m
             if(ilm3 <= nel_Ylm) then
                ylm => ylm_l(ibl1:ibl2,ilm3)
             else
                ylm => ylm_ext(ibl1:ibl2,ilm3)
             end if
             do ip = 1, nc(m,iiqitg)
                lmt1 = nc2lmt1(ip,m,iiqitg)
                lmt2 = nc2lmt2(ip,m,iiqitg)
                np = nc2n(ip,m,iiqitg)
                dga = dl2p(lmt1,lmt2,np,it)
                fac = 2.d0 ; if(lmt1 == lmt2) fac = 1.d0
                if(mod(l3,2) == 0) then
                   call even_case
                else
                   call odd_case
                endif
             enddo
          enddo
       enddo
    enddo
    deallocate(mzfsin_tmp)
    deallocate(zfsin_tmp)
    deallocate(zfcos_tmp)
#else
    do ia = 1, natm
       it = ityp(ia)
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) cycle
       call calc_phase2(natm,pos,ia,kgp,ngabc,ista_kngp,iend_kngp,zfcos_tmp,zfsin_tmp)
                         ! -(b_Elec.)  -> zfcos_tmp, zfsin_tmp
       do lmt1 = 1,ilmt(it)
          il1 = ltp(lmt1,it); tau1 = taup(lmt1,it)
          do lmt2 = lmt1, ilmt(it)
            il2 = ltp(lmt2,it); tau2 = taup(lmt2,it)
            fac = 2.d0 ; if(lmt1 == lmt2) fac = 1.d0
            do n = 1, il2p(lmt1,lmt2,it)
              ilm3 = isph(lmt1,lmt2,n,it)
              l3   =  il3(ilm3)
              iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
              if(iiqitg == 0) cycle
              if(ilm3 <= nel_Ylm) then
                 ylm => ylm_l(ista_kngp:iend_kngp,ilm3)
              else
                 call m_pwBS_sphrp2(ilm3,rltv,ista_kngp,iend_kngp,ylm_t)
                 ylm => ylm_t(ista_kngp:iend_kngp)
              end if
              dga = dl2p(lmt1,lmt2,n,it)

              if (mod(il1+il2,2) == 0) then
                 call even_case
              else
                 call odd_case
              endif

            enddo
          enddo
       enddo
    enddo
#endif
    enddo

!    deallocate(zfsin_tmp); deallocate(zfcos_tmp)
    deallocate(il3)
!    deallocate(ylm_t)
    deallocate(ylmd)
    if(allocated(ylm_ext)) deallocate(ylm_ext)
#ifndef _m_Stress_no_loop_exchange_
    deallocate(nc2n,nc2lmt2,nc2lmt1,nc,iq2l3,nqitg_sp,nqitg_sp0)
#endif


    deallocate(vloc)
    deallocate(flchgq); deallocate(flchgqd)

    enddo
    enddo

    call mpi_allreduce(mpi_in_place,s_xc1,9 &
                 &  ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
    call mpi_allreduce(mpi_in_place,s_h1,9 &
                 &  ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
    call mpi_allreduce(mpi_in_place,s_loc1,9 &
                 &  ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)

    s_xc1  = s_xc1  * univol
    s_h1   = s_h1   * univol * PAI4
    s_loc1 = s_loc1 * univol

    if(af == 0) then
       s_0 = s_xc1
       stress_name = 'X1'
       call check_stress(nfout)
       s_0 = s_h1
       stress_name = 'H1'
       call check_stress(nfout)
       s_0 = s_loc1
       stress_name = 'L1'
       call check_stress(nfout)
    else
       s_up = s_xc1
       stress_name = 'X1'
       call check_af(nfout)
       s_up = s_h1
       stress_name = 'H1'
       call check_af(nfout)
       s_up = s_loc1
       stress_name = 'L1'
       call check_af(nfout)
    endif

    call tstatc0_end(id_sname)

  contains

    subroutine blksize(n)
      integer, intent(in) :: n
      integer :: ncache
      ncache = (m_CtrlP_cachesize()*1024)*3/4
      if(ncache == 0) then
         nblk = iend_kngp-ista_kngp+1
      else
         nblk=ncache/(8*(n**2))
      end if
      if (nblk<32) nblk = 1000
      !write(nfout,'(a,i8)') ' !** block size : ',nblk
    end subroutine blksize

    subroutine even_case
      do is=1,nspin,af+1
         flchgq(is) = fac*real(zi**(-l3))*dga &
              & *hsr(ia,lmt1,lmt2,is)
         flchgqd(i1,i2,is) = fac*real(zi**(-l3))*dga &
         & *hsrd(ia,lmt1,lmt2,is,i1,i2)
      enddo
      if(kimg == 1) then
         call real_case(ilm3,iiqitg,zfcos_tmp)
      else
         call complex_case(ilm3,iiqitg,zfcos_tmp,mzfsin_tmp)
      endif
    end subroutine even_case

    subroutine odd_case
      do is=1,nspin,af+1
         flchgq(is) = fac*aimag(zi**(-l3))*dga &
              & *hsr(ia,lmt1,lmt2,is)
         flchgqd(i1,i2,is) = fac*aimag(zi**(-l3))*dga &
         & *hsrd(ia,lmt1,lmt2,is,i1,i2)
      enddo
      if(kimg == 1) then
         call real_case(ilm3,iiqitg,zfsin_tmp)
      else
         call complex_case(ilm3,iiqitg,zfsin_tmp,zfcos_tmp)
      endif
    end subroutine odd_case

    subroutine real_case(ilm3,iiqitg,zf)
      integer,       intent(in) :: ilm3,iiqitg
      real(kind=DP), intent(in), dimension(ibl1:ibl2) :: zf
      real(kind=DP) :: sxc1,sh1,sloc1,c1,c2,c3up,c3down
      integer :: iy
      integer :: id_sname = -1

      sxc1 = 0.d0;sh1=0.d0;sloc1=0.d0
      do is=1,nspin,af+1
        flchgq(is) = flchgq(is) * dble(iwei(ia))
        flchgqd(i1,i2,is) = flchgqd(i1,i2,is) * dble(iwei(ia))
      enddo

      if(nspin==1 .or. af==1) then
         mspin=(nspin+1)/nspin
         do i = ibl1, ibl2  !for mpi
            iy = i - ibl1+1
            c1=(  g(i,1)*alinvt(1,i2) &
             &  + g(i,2)*alinvt(2,i2) &
             &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
            c2=(  ylmd(i,1,ilm3)*alinvt(1,i2) &
             &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
             &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)
            c3up =  &
             &  - flchgq(1) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,1)*ylm(iy)*qitg_l(i,iiqitg)

            sxc1=sxc1 &
                 &  +c3up*vxc_l(i,1,1)*zf(i)
            sh1=sh1 &
                 &  +grinv(i)**2*c3up &
                 &  *(chgq_l(i,1,1)+chgq_l(i,1,nspin))/mspin &
                 &  *zf(i)
            sloc1=sloc1 &
                 &  +c3up*zf(i)*vloc(i,1)
         enddo
!xocl end spread sum(s_xc1),sum(s_loc1),sum(s_h1)
      else  ! nspin ==2 and af /= 1
         do i = ibl1, ibl2  !for mpi
            iy = i - ibl1 + 1
            c1=(  g(i,1)*alinvt(1,i2) &
             &  + g(i,2)*alinvt(2,i2) &
             &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
            c2=(  ylmd(i,1,ilm3)*alinvt(1,i2) &
             &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
             &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)
            c3up =  &
             &  - flchgq(1) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,1)*ylm(iy)*qitg_l(i,iiqitg)
            c3down = &
             &  - flchgq(nspin) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,nspin)*ylm(iy)*qitg_l(i,iiqitg)

            sxc1=sxc1 &
                 &  +(c3up*vxc_l(i,1,1) &
                 &   +c3down*vxc_l(i,1,nspin)) &
                 &   *zf(i)
            sh1=sh1 &
                 &  +grinv(i)**2*(c3up+c3down) &
                 &  *(chgq_l(i,1,1)+chgq_l(i,1,nspin))*zf(i)
            sloc1=sloc1 &
                 &  +(c3up+c3down) &
                 &  *zf(i)*vloc(i,1)
         enddo
!xocl end spread sum(s_xc1),sum(s_loc1),sum(s_h1)
      endif
      s_xc1(i1,i2)  =  s_xc1(i1,i2)  + sxc1
      s_h1(i1,i2)   =  s_h1(i1,i2)   + sh1
      s_loc1(i1,i2) =  s_loc1(i1,i2) + sloc1
    end subroutine real_case

    subroutine complex_case(ilm3,iiqitg,zf1,zf2)
      integer,       intent(in) :: ilm3,iiqitg
      real(kind=DP), intent(in), dimension(ibl1:ibl2) :: zf1,zf2
      real(kind=DP) :: sxc1,sh1,sloc1,c1,c2,c3up,c3down
      integer :: iy
      real(kind=DP) :: factor
      integer :: id_sname = -1
      sxc1 = 0.d0;sh1=0.d0;sloc1=0.d0
      if(nspin.eq.1 .or. af.eq.1) then
!         mspin=(nspin+1)/nspin
!         do i = ista_kngp, iend_kngp  !for mpi
         factor = 0.5d0
         if(af .eq. 1) factor = 1.d0
         do i = ibl1, ibl2  !for mpi
!            iy = i - ista_kngp + 1
            iy = i - ibl1 + 1
            c1=(  g(i,1)*alinvt(1,i2) &
             &  + g(i,2)*alinvt(2,i2) &
             &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
            c2=(  ylmd(i,1,ilm3)*alinvt(1,i2) &
             &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
             &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)
            c3up = &
             &  - flchgq(1) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,1)*ylm(iy)*qitg_l(i,iiqitg)

            sxc1=sxc1 &
                 &  +c3up &
                 &  *(vxc_l(i,1,1)*zf1(i)+vxc_l(i,2,1)*zf2(i))
            sh1=sh1 &
                 &  +grinv(i)**2*c3up &
!                 &  *((chgq_l(i,1,1)+chgq_l(i,1,nspin))/mspin*zf1(i) &
!                 &   +(chgq_l(i,2,1)+chgq_l(i,2,nspin))/mspin*zf2(i))
                 &  *factor*((chgq_l(i,1,1)+chgq_l(i,1,nspin))*zf1(i) &
                 &   +(chgq_l(i,2,1)+chgq_l(i,2,nspin))*zf2(i))
            sloc1=sloc1 &
                 &  +c3up &
                 &  *(zf1(i)*vloc(i,1)+zf2(i)*vloc(i,2))
         enddo
!xocl end spread sum(s_xc1),sum(s_loc1),sum(s_h1)
      else  ! nspin ==2 and af /= 1
!         do i = ista_kngp, iend_kngp  !for mpi
!            iy = i - ista_kngp + 1
         do i = ibl1, ibl2  !for mpi
            iy = i - ibl1 + 1
            c1=(  g(i,1)*alinvt(1,i2) &
             &  + g(i,2)*alinvt(2,i2) &
             &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
            c2=(  ylmd(i,1,ilm3)*alinvt(1,i2) &
             &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
             &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)
            c3up =  &
             &  - flchgq(1) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,1)*ylm(iy)*qitg_l(i,iiqitg)
            c3down = &
             &  - flchgq(nspin) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,nspin)*ylm(iy)*qitg_l(i,iiqitg)

            sxc1=sxc1 &
                 &  +c3up &
                 &  *(vxc_l(i,1,1)*zf1(i)+vxc_l(i,2,1)*zf2(i)) &
                 &  +c3down &
                 &  *(vxc_l(i,1,nspin)*zf1(i)+vxc_l(i,2,nspin)*zf2(i))
            sh1=sh1 &
                 &  +grinv(i)**2*(c3up+c3down) &
                 &  *((chgq_l(i,1,1)+chgq_l(i,1,nspin))*zf1(i) &
                 &   +(chgq_l(i,2,1)+chgq_l(i,2,nspin))*zf2(i))
            sloc1=sloc1 &
                 &  +(c3up+c3down) &
                 &  *(zf1(i)*vloc(i,1)+zf2(i)*vloc(i,2))
         enddo
!xocl end spread sum(s_xc1),sum(s_loc1),sum(s_h1)
      endif
      s_xc1(i1,i2)  =  s_xc1(i1,i2)  + sxc1
      s_h1(i1,i2)   =  s_h1(i1,i2)   + sh1
      s_loc1(i1,i2) =  s_loc1(i1,i2) + sloc1
    end subroutine complex_case

  end subroutine m_Stress_lclchg_diff

! ========================= added by K. Tagami ======================= 11.0
  subroutine m_Stress_lclchg_diff_noncl(nfout)

    integer, intent(in) :: nfout
    integer    :: n,ilm3,i,it,ik,mdvdb,ia,is,mspin,i1,i2
    integer    :: lmt1,lmt2,il1,il2,tau1,tau2,l3,iiqitg
    real(kind=DP) :: fac,dga,c1,c2
    real(kind=DP),allocatable,target,dimension(:) :: ylm_t
    real(kind=DP), pointer, dimension(:,:)        :: ylmd_mpi
    integer :: ibl1,ibl2
#ifndef _m_Stress_no_loop_exchange_
    integer :: m, maxm, ip, np, iq
    integer, parameter :: mcritical = 4*2+1
    integer, allocatable, dimension(:) :: nqitg_sp, nqitg_sp0 !d(ntyp)
    integer, allocatable, dimension(:) :: iq2l3 ! d(nqitg)
    integer, allocatable, dimension(:,:) :: nc  ! d(maxm,nqitg)
    integer :: mc ! maxval(nc)
    integer, allocatable, dimension(:,:,:) :: nc2lmt1, nc2lmt2, nc2n ! d(mc,maxm,nqitg)
#endif
    integer    :: id_sname = -1

    if(modnrm == SKIP) return

    call tstatc0_begin('m_Stress_lclchg_diff_noncol ',id_sname,level=1)

    do i1=1,3
    do i2=1,3

    allocate(vloc(ista_kngp:iend_kngp,kimg)); vloc = 0.d0

    allocate(flchgq(ndim_magmom)); flchgq = 0.d0
    allocate(flchgqd(3,3,ndim_magmom)); flchgqd = 0.d0

    do ik = 1, kimg
      do it = 1, ntyp
         do i = ista_kngp, iend_kngp  !for mpi
            vloc(i,ik)=vloc(i,ik)+psc_l(i,it)*zfm3_l(i,it,ik)
            if(sw_screening_correction==ON) then
               vloc(i,ik)=vloc(i,ik)-ival(it)*screening%phik(i)/univol*zfm3_l(i,it,ik)
            end if
        enddo
      enddo
    enddo


    call m_PP_find_maximum_l(n)   ! n-1: maximum l
    n = (n-1) + (n-1) + 1
    allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)
#ifndef _m_Stress_no_loop_exchange_
    allocate(nqitg_sp(ntyp)); allocate(nqitg_sp0(ntyp))
    allocate(iq2l3(nqitg))
    allocate(nc(mcritical,nqitg));nc=0
    call m_PP_set_index_arrays1(nfout,ntyp,nqitg,mcritical,n**2,il3 &
         & ,maxm,mc,nqitg_sp,nqitg_sp0,iq2l3,nc)
    allocate(nc2lmt1(mc,maxm,nqitg))
    allocate(nc2lmt2(mc,maxm,nqitg))
    allocate(nc2n(mc,maxm,nqitg))
    call m_PP_set_index_arrays2(nfout,mc,maxm,nqitg,mcritical,n**2,il3,iq2l3 &
         & ,nc2lmt1,nc2lmt2,nc2n,nc) ! -> nc2lmt1, nc2lmt2, nc2n, nc
#endif
!    allocate(ylm_t(ista_kngp:iend_kngp)); ylm_t = 0.d0
    allocate(ylmd(ista_kngp:iend_kngp,3,n**2)); ylmd = 0.d0
    allocate(ylmd_mpi(ista_kngp:iend_kngp,3)); ylmd_mpi = 0.d0
    do ilm3 = 1, n**2
!mpi       call m_pwBS_sphrp2(ilm3,rltv,ista_kngp,iend_kngp,ylm2(1,ilm3))
!!$       call m_pwBS_sphrp2(ilm3,rltv,ylm2_mpi)
!!$       do i = ista_kngp, iend_kngp  !for mpi
!!$          ylm2(i,ilm3) = ylm2_mpi(i)
!!$       enddo
!mpi       call m_pwBS_sphrp2_diff(ilm3,rltv,ylmd(1,1,ilm3))
       call m_pwBS_sphrp2_diff(ilm3,rltv,ylmd_mpi)
       do i = ista_kngp, iend_kngp  !for mpi
          ylmd(i,1,ilm3) = ylmd_mpi(i,1)
          ylmd(i,2,ilm3) = ylmd_mpi(i,2)
          ylmd(i,3,ilm3) = ylmd_mpi(i,3)
       enddo
    end do
    deallocate(ylmd_mpi)
    if(n**2 > nel_Ylm) then
       allocate(ylm_ext(ista_kngp:iend_kngp,nel_Ylm+1:n**2));  ylm_ext = 0.d0
       allocate(ylm_t(ista_kngp:iend_kngp)); ylm_t = 0.d0
       do ilm3 = nel_Ylm+1, n**2
          call m_pwBS_sphrp2(ilm3,rltv,ista_kngp,iend_kngp,ylm_t)  ! (ilm3,rltv,ngabc,gr_l)->(ylm)
          ylm_ext(:,ilm3) = ylm_t(:)
       end do
       deallocate(ylm_t)
    end if

    call blksize(n)
    do ibl1 = ista_kngp, iend_kngp, nblk
    ibl2 = ibl1+nblk-1
    if(ibl2 .gt. iend_kngp) ibl2 = iend_kngp
#ifndef _m_Stress_no_loop_exchange_
    allocate(zfsin_tmp(ibl1:ibl2));zfsin_tmp=0.d0
    allocate(zfcos_tmp(ibl1:ibl2));zfcos_tmp=0.d0
    allocate(mzfsin_tmp(ibl1:ibl2));mzfsin_tmp = 0.d0
    do ia = 1, natm
       it = ityp(ia)
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) cycle
       call calc_phase2(natm,pos,ia,kgp,ngabc,ibl1,ibl2,zfcos_tmp,zfsin_tmp)
       mzfsin_tmp = -zfsin_tmp
       do iiqitg = nqitg_sp0(it), nqitg_sp(it)
          l3 = iq2l3(iiqitg)
          do m = 1, 2*l3+1
             ilm3 = l3*l3+m
             if(ilm3 <= nel_Ylm) then
                ylm => ylm_l(ibl1:ibl2,ilm3)
             else
                ylm => ylm_ext(ibl1:ibl2,ilm3)
             end if
             do ip = 1, nc(m,iiqitg)
                lmt1 = nc2lmt1(ip,m,iiqitg)
                lmt2 = nc2lmt2(ip,m,iiqitg)
                np = nc2n(ip,m,iiqitg)
                dga = dl2p(lmt1,lmt2,np,it)
                fac = 2.d0 ; if(lmt1 == lmt2) fac = 1.d0
                if(mod(l3,2) == 0) then
                   call even_case_noncl
                else
                   call odd_case_noncl
                endif
             enddo
          enddo
       enddo
    enddo
    deallocate(mzfsin_tmp)
    deallocate(zfsin_tmp)
    deallocate(zfcos_tmp)
#else
    do ia = 1, natm
       it = ityp(ia)
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) cycle
       call calc_phase2(natm,pos,ia,kgp,ngabc,ista_kngp,iend_kngp,zfcos_tmp,zfsin_tmp)
                         ! -(b_Elec.)  -> zfcos_tmp, zfsin_tmp
       do lmt1 = 1,ilmt(it)
          il1 = ltp(lmt1,it); tau1 = taup(lmt1,it)
          do lmt2 = lmt1, ilmt(it)
            il2 = ltp(lmt2,it); tau2 = taup(lmt2,it)
            fac = 2.d0 ; if(lmt1 == lmt2) fac = 1.d0
            do n = 1, il2p(lmt1,lmt2,it)
              ilm3 = isph(lmt1,lmt2,n,it)
              l3   =  il3(ilm3)
              iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
              if(iiqitg == 0) cycle
              if(ilm3 <= nel_Ylm) then
                 ylm => ylm_l(ista_kngp:iend_kngp,ilm3)
              else
                 call m_pwBS_sphrp2(ilm3,rltv,ista_kngp,iend_kngp,ylm_t)
                 ylm => ylm_t(ista_kngp:iend_kngp)
              end if
              dga = dl2p(lmt1,lmt2,n,it)

              if (mod(il1+il2,2) == 0) then
                 call even_case_noncl
              else
                 call odd_case_noncl
              endif

            enddo
          enddo
       enddo
    enddo
#endif
    enddo

!    deallocate(zfsin_tmp); deallocate(zfcos_tmp)
    deallocate(il3)
!    deallocate(ylm_t)
    deallocate(ylmd)
    if(allocated(ylm_ext)) deallocate(ylm_ext)
#ifndef _m_Stress_no_loop_exchange_
    deallocate(nc2n,nc2lmt2,nc2lmt1,nc,iq2l3,nqitg_sp,nqitg_sp0)
#endif


    deallocate(vloc)
    deallocate(flchgq); deallocate(flchgqd)

    enddo
    enddo

    call mpi_allreduce(mpi_in_place,s_xc1,9 &
                 &  ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
    call mpi_allreduce(mpi_in_place,s_h1,9 &
                 &  ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
    call mpi_allreduce(mpi_in_place,s_loc1,9 &
                 &  ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)

    s_xc1  = s_xc1  * univol
    s_h1   = s_h1   * univol * PAI4
    s_loc1 = s_loc1 * univol

    if(af == 0) then
       s_0 = s_xc1
       stress_name = 'X1'
       call check_stress(nfout)
       s_0 = s_h1
       stress_name = 'H1'
       call check_stress(nfout)
       s_0 = s_loc1
       stress_name = 'L1'
       call check_stress(nfout)
    else
       s_up = s_xc1
       stress_name = 'X1'
       call check_af(nfout)
       s_up = s_h1
       stress_name = 'H1'
       call check_af(nfout)
       s_up = s_loc1
       stress_name = 'L1'
       call check_af(nfout)
    endif

    call tstatc0_end(id_sname)

  contains

    subroutine blksize(n)
      integer, intent(in) :: n
      integer :: ncache
      ncache = (m_CtrlP_cachesize()*1024)*3/4
      if(ncache == 0) then
         nblk = iend_kngp-ista_kngp+1
      else
         nblk=ncache/(8*(n**2))
      end if
      if (nblk<32) nblk = 1000
    end subroutine blksize

    subroutine even_case_noncl
      integer :: is

      do is = 1,ndim_magmom
         flchgq(is) = fac *real(zi**(-l3)) *dga &
              &           *hsr(ia,lmt1,lmt2,is)
         flchgqd(i1,i2,is) = fac *real(zi**(-l3)) *dga &
                    &                  *hsrd(ia,lmt1,lmt2,is,i1,i2)
      enddo
      if (kimg == 1) then
         call real_case_noncl(ilm3,iiqitg,zfcos_tmp)
      else
         call complex_case_noncl(ilm3,iiqitg,zfcos_tmp,mzfsin_tmp)
      endif
    end subroutine even_case_noncl

    subroutine odd_case_noncl
      integer :: is

      do is = 1,ndim_magmom
         flchgq(is) = fac *aimag(zi**(-l3)) *dga &
              &           *hsr(ia,lmt1,lmt2,is)
         flchgqd(i1,i2,is) = fac * aimag(zi**(-l3)) *dga &
              &                  *hsrd(ia,lmt1,lmt2,is,i1,i2)
      enddo
      if (kimg == 1) then
         call real_case_noncl(ilm3,iiqitg,zfsin_tmp)
      else
         call complex_case_noncl(ilm3,iiqitg,zfsin_tmp,zfcos_tmp)
      endif
    end subroutine odd_case_noncl

    subroutine real_case_noncl( ilm3,iiqitg, zf )
      integer,       intent(in) :: ilm3,iiqitg
      real(kind=DP), intent(in), dimension(ibl1:ibl2) :: zf
      real(kind=DP) :: sxc1,sh1,sloc1,c1,c2
      real(kind=DP), allocatable, dimension(:) :: drhodh
      integer :: iy

      integer :: is
      allocate(drhodh(ndim_magmom))
      do is=1,ndim_magmom
         flchgq(is) = flchgq(is) * dble(iwei(ia))
         do i1=1,3
            do i2=1,3
               flchgqd(i1,i2,is) = flchgqd(i1,i2,is) * dble(iwei(ia))
            enddo
         enddo
      enddo

      sxc1=0.d0;sh1=0.d0;sloc1=0.d0
      do i = ibl1, ibl2  !for mpi
         iy = i - ibl1+1
         c1 =  ( g(i,1)*alinvt(1,i2) &
              &  + g(i,2)*alinvt(2,i2) &
              &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
         c2 =  ( ylmd(i,1,ilm3)*alinvt(1,i2) &
              &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
              &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)

         Do is=1, ndim_magmom
            drhodh(is) =  &
                 &  - flchgq(is) &
                 &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
                 &  +qitg_diff_l(i,iiqitg)*c1) &
                 &  +c2*qitg_l(i,iiqitg)) &
                 &  + flchgqd(i1,i2,is)*ylm(iy)*qitg_l(i,iiqitg)
         End do
         Do is=1, ndim_magmom
            sxc1 = sxc1 &
                 &      + drhodh(is)*vxc_l(i,1,is)*zf(i)
         End do

!               s_xc1_mpi1(i1,i2) = s_xc1_mpi1(i1,i2) &
!                    &            + drhodh(1)*vxc_l(i,1,1)*zf(i)
!
         sh1 = sh1 &
               & + grinv(i)**2 *drhodh(1) *chgq_l(i,1,1) *zf(i)
         sloc1 = sloc1 &
               & + drhodh(1)*zf(i)*vloc(i,1)
      end do

      s_xc1(i1,i2)  =  s_xc1(i1,i2)  + sxc1
      s_h1(i1,i2)   =  s_h1(i1,i2)   + sh1
      s_loc1(i1,i2) =  s_loc1(i1,i2) + sloc1
      deallocate(drhodh)

    end subroutine real_case_noncl

    subroutine complex_case_noncl(ilm3,iiqitg,zf1,zf2)
      integer,       intent(in) :: ilm3,iiqitg
      real(kind=DP), intent(in), dimension(ibl1:ibl2) &
           &  :: zf1,zf2
      integer :: iy
      integer :: is
      real(kind=DP) :: sxc1,sh1,sloc1,c1,c2
      real(kind=DP), allocatable, dimension(:) :: drhodh

      allocate(drhodh(ndim_magmom))
      sxc1=0.d0;sh1=0.d0;sloc1=0.d0
      do i = ibl1, ibl2  !for mpi
         iy = i - ibl1 + 1
         c1= ( g(i,1)*alinvt(1,i2) &
              &  + g(i,2)*alinvt(2,i2) &
              &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
         c2= ( ylmd(i,1,ilm3)*alinvt(1,i2) &
              &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
              &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)

         Do is=1, ndim_magmom
            drhodh(is) =  &
              &  - flchgq(is) &
              &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
              &  +qitg_diff_l(i,iiqitg)*c1) &
              &  +c2*qitg_l(i,iiqitg)) &
              &  + flchgqd(i1,i2,is)*ylm(iy)*qitg_l(i,iiqitg)
         End do
         Do is=1, ndim_magmom
            sxc1 = sxc1 &
                 &    + drhodh(is) &
                 &    *( vxc_l(i,1,is) *zf1(i) &
                 &    +vxc_l(i,2,is) *zf2(i) )
         End do

         sh1 = sh1 &
              &    + grinv(i)**2 *drhodh(1) &
              &    *( chgq_l(i,1,1)*zf1(i) &
              &    +chgq_l(i,2,1)*zf2(i) )
         sloc1 = sloc1 &
              &    + drhodh(1) &
              &    *(zf1(i)*vloc(i,1)+zf2(i)*vloc(i,2))
      enddo
      s_xc1(i1,i2)  =  s_xc1(i1,i2)  + sxc1
      s_h1(i1,i2)   =  s_h1(i1,i2)   + sh1
      s_loc1(i1,i2) =  s_loc1(i1,i2) + sloc1
      deallocate(drhodh)
    end subroutine complex_case_noncl

  end subroutine m_Stress_lclchg_diff_noncl
! =========================================================================== 11.0

  subroutine m_Stress_xc(nfout)
    integer, intent(in) :: nfout
    integer    :: is,ig,i,j,ia,it,ipc
    real(kind=DP) :: vxcp,pc
    integer    :: id_sname = -1
    integer       :: iend  !mpi
    real(kind=DP) :: vxcp_mpi
    real(kind=DP), pointer, dimension(:,:) :: s_xc2_mpi1, s_xc2_mpi2
    real(kind=DP), pointer, dimension(:,:) :: s_pc_mpi1, s_pc_mpi2

    call tstatc0_begin('m_Stress_xc ',id_sname)

    allocate(zfcos_tmp(ista_kngp:iend_kngp))
    allocate(zfsin_tmp(ista_kngp:iend_kngp))
    zfcos_tmp = 0.d0; zfsin_tmp = 0.d0

    vxcp_mpi = 0.d0
    vxcp=0.d0
    if(kimg==1) then
       do is=1,nspin
          iend = iend_kngp
          if( iend_kngp > kg ) iend = kg
          if( ista_kngp <= iend ) then
             do i = ista_kngp, iend  !for mpi
                vxcp_mpi=vxcp_mpi+vxc_l(i,1,is)*chgsoft(i,1,is)
             enddo
          endif
!xocl end spread sum(vxcp)
       enddo
    else
       do is=1,nspin
          iend = iend_kngp
          if( iend_kngp > kg ) iend = kg
          if( ista_kngp <= iend ) then
             do i = ista_kngp, iend  !for mpi
                vxcp_mpi=vxcp_mpi+vxc_l(i,1,is)*chgsoft(i,1,is) &
                     &    +vxc_l(i,2,is)*chgsoft(i,2,is)
             enddo
          endif
!xocl end spread sum(vxcp)
       enddo
    endif
    call mpi_allreduce(vxcp_mpi,vxcp,1 &
         &  ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)

#ifndef DISABLE_VDWDF
    s_xc2 = ( exc +ecnl_vdwdf -vxcp *univol ) *alinvt
#else
    s_xc2 = ( exc -vxcp *univol ) *alinvt
#endif

    allocate(s_xc2_mpi1(3,3)); s_xc2_mpi1 = 0.d0
    allocate(s_xc2_mpi2(3,3)); s_xc2_mpi2 = 0.d0
    allocate(s_pc_mpi1(3,3)); s_pc_mpi1 = 0.d0
    allocate(s_pc_mpi2(3,3)); s_pc_mpi2 = 0.d0

    do ia = 1, natm
    it=ityp(ia)
    if(itpcc(it).ne.0) then
       call calc_phase2(natm,pos,ia,kgp,ngabc,ista_kngp,iend_kngp,zfcos_tmp,zfsin_tmp)
                         ! -(b_Elec.)  -> zfcos_tmp, zfsin_tmp
       ipc=itpcc(it)
       if(kimg==1) then
          do is=1,nspin
          do i=1,3
          do j=1,3
             do ig = ista_kngp, iend_kngp  !for mpi
                pc = (rhpcg_l(ig,ipc)*alinvt(i,j) &
                     &   +rhpcg_diff_l(ig,ipc)*grinv(ig)*g(ig,i) &
                     &   *(g(ig,1)*alinvt(1,j)+g(ig,2)*alinvt(2,j) &
                     &    +g(ig,3)*alinvt(3,j))) &
                     &   *univol &
                     &   * dble(iwei(ia))
                s_xc2_mpi1(i,j) = s_xc2_mpi1(i,j) &
                     &   - vxc_l(ig,1,is) * zfcos_tmp(ig) * pc / nspin
                s_pc_mpi1(i,j) = s_pc_mpi1(i,j) &
                     &   - vxcpc_l(ig,1) * zfcos_tmp(ig) * pc / nspin
             enddo
          enddo
          enddo
          enddo
!xocl end spread sum(s_xc2),sum(s_pc)
       else
          do is=1,nspin
          do i=1,3
          do j=1,3
             do ig = ista_kngp, iend_kngp  !for mpi
                pc = (rhpcg_l(ig,ipc)*alinvt(i,j) &
                     &   +rhpcg_diff_l(ig,ipc)*grinv(ig)*g(ig,i) &
                     &   *(g(ig,1)*alinvt(1,j)+g(ig,2)*alinvt(2,j) &
                     &    +g(ig,3)*alinvt(3,j))) &
                     &   *univol &
                     &   * dble(iwei(ia))
                s_xc2_mpi1(i,j) = s_xc2_mpi1(i,j) &
                     &   - (vxc_l(ig,1,is) * zfcos_tmp(ig) &
                     &    - vxc_l(ig,2,is) * zfsin_tmp(ig) ) * pc / nspin
                s_pc_mpi1(i,j) = s_pc_mpi1(i,j) &
                     &   - (vxcpc_l(ig,1) * zfcos_tmp(ig) &
                     &    - vxcpc_l(ig,2) * zfsin_tmp(ig) ) * pc / nspin
             enddo
          enddo
          enddo
          enddo
!xocl end spread sum(s_xc2),sum(s_pc)
       endif
    endif
    enddo

    call mpi_allreduce(s_xc2_mpi1,s_xc2_mpi2,9 &
         &  ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
    call mpi_allreduce(s_pc_mpi1,s_pc_mpi2,9 &
         &  ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)

    s_xc2 = s_xc2 + s_xc2_mpi2
    s_pc = s_pc + s_pc_mpi2 + epc * alinvt
    deallocate(s_xc2_mpi1); deallocate(s_xc2_mpi2)
    deallocate(s_pc_mpi1); deallocate(s_pc_mpi2)

    s_0 = s_pc
    stress_name = 'PC'
    call check_stress(nfout)
    s_0 = s_xc1
    stress_name = 'X1'
    call check_stress(nfout)
    s_0 = s_xc2
    stress_name = 'X2'
    call check_stress(nfout)
    if(af == 0) then
       s_0 = s_xc1 + s_xc2 + s_gga1 + s_gga2
       stress_name = 'XC'
       call check_stress(nfout)
    else
       s_0 = s_xc2
       stress_name = 'X2'
       call check_stress(nfout)
    endif

    deallocate(zfsin_tmp); deallocate(zfcos_tmp)

    call tstatc0_end(id_sname)
  end subroutine m_Stress_xc

! ==================================== added by K. Tagami ============= 11.0
  subroutine m_Stress_xc_noncl(nfout)
    integer, intent(in) :: nfout
    integer    :: is,ig,i,j,ia,it,ipc
    real(kind=DP) :: vxcp,pc
    integer    :: id_sname = -1
    integer       :: iend  !mpi
    real(kind=DP) :: vxcp_mpi
    real(kind=DP), pointer, dimension(:,:) :: s_xc2_mpi1, s_xc2_mpi2
    real(kind=DP), pointer, dimension(:,:) :: s_pc_mpi1, s_pc_mpi2

    call tstatc0_begin('m_Stress_xc_noncl ',id_sname)

    allocate(zfcos_tmp(ista_kngp:iend_kngp))
    allocate(zfsin_tmp(ista_kngp:iend_kngp))
    zfcos_tmp = 0.d0; zfsin_tmp = 0.d0

    vxcp_mpi = 0.d0
    vxcp=0.d0

    if (kimg==1) return

    do is=1,ndim_magmom
       iend = iend_kngp
       if( iend_kngp > kg ) iend = kg
       if( ista_kngp <= iend ) then
          do i = ista_kngp, iend  !for mpi
             vxcp_mpi = vxcp_mpi +vxc_l(i,1,is)*chgsoft(i,1,is) &
                  &              +vxc_l(i,2,is)*chgsoft(i,2,is)
          enddo
       endif
    enddo

    call mpi_allreduce( vxcp_mpi, vxcp, 1, &
         &              mpi_double_precision, mpi_sum,MPI_CommGroup, ierr )

#ifndef DISABLE_VDWDF
    s_xc2 = ( exc +ecnl_vdwdf -vxcp *univol ) *alinvt
#else
    s_xc2 = ( exc -vxcp *univol ) *alinvt
#endif

    allocate(s_xc2_mpi1(3,3)); s_xc2_mpi1 = 0.d0
    allocate(s_xc2_mpi2(3,3)); s_xc2_mpi2 = 0.d0
    allocate(s_pc_mpi1(3,3)); s_pc_mpi1 = 0.d0
    allocate(s_pc_mpi2(3,3)); s_pc_mpi2 = 0.d0

    do ia = 1, natm
       it = ityp(ia)

       if (itpcc(it).eq.0 ) cycle
       call calc_phase2( natm, pos, ia, kgp, ngabc, ista_kngp, iend_kngp, &
            &            zfcos_tmp,zfsin_tmp )
                         ! -(b_Elec.)  -> zfcos_tmp, zfsin_tmp
       ipc = itpcc(it)
       do i=1,3
          do j=1,3
             do ig = ista_kngp, iend_kngp  !for mpi
                pc = (rhpcg_l(ig,ipc)*alinvt(i,j) &
                     &   +rhpcg_diff_l(ig,ipc)*grinv(ig)*g(ig,i) &
                     &   *(g(ig,1)*alinvt(1,j)+g(ig,2)*alinvt(2,j) &
                     &    +g(ig,3)*alinvt(3,j))) &
                     &   *univol &
                     &   * dble(iwei(ia))

                s_xc2_mpi1(i,j) = s_xc2_mpi1(i,j) &
                     &    -(  vxc_l(ig,1,1) * zfcos_tmp(ig) &
                     &      - vxc_l(ig,2,1) * zfsin_tmp(ig) ) * pc

                s_pc_mpi1(i,j) = s_pc_mpi1(i,j) &
                     &     -(  vxcpc_l(ig,1) * zfcos_tmp(ig) &
                     &       - vxcpc_l(ig,2) * zfsin_tmp(ig) ) * pc
             enddo
          enddo
       enddo
    enddo

    call mpi_allreduce( s_xc2_mpi1, s_xc2_mpi2, 9, &
         &              mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )
    call mpi_allreduce( s_pc_mpi1, s_pc_mpi2, 9, &
         &              mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )

    s_xc2 = s_xc2 + s_xc2_mpi2
    s_pc = s_pc + s_pc_mpi2 + epc * alinvt
    deallocate(s_xc2_mpi1); deallocate(s_xc2_mpi2)
    deallocate(s_pc_mpi1); deallocate(s_pc_mpi2)


! ---
    s_0 = s_pc
    stress_name = 'PC'
    call check_stress(nfout)

    s_0 = s_xc1 + s_xc2 + s_gga1 + s_gga2;
    stress_name = 'XC'
    call check_stress(nfout)

    deallocate(zfsin_tmp); deallocate(zfcos_tmp)

    call tstatc0_end(id_sname)

  end subroutine m_Stress_xc_noncl
! ============================================================= 11.0

  subroutine m_Stress_loc(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,it,is,ik,ig
    real(kind=DP) :: rsv
    integer    :: id_sname = -1
    integer    :: ist  !mpi
    real(kind=DP), pointer, dimension(:,:) :: s_loc2_mpi
    real(kind=DP) :: rsv_mpi

! ========================= added by K. Tagami =========== 11.0
    integer :: ismax
! ======================================================== 11.0

    call tstatc0_begin('m_Stress_loc ',id_sname)

    allocate(s_loc2_mpi(3,3)); s_loc2_mpi = 0.d0

! ========================= added by K. Tagami =========== 11.0
    if ( noncol ) then
       ismax = 1
    else
       ismax = nspin
    endif
! ======================================================== 11.0

    ist = ista_kngp
    if(ista_kngp==1) ist = 2
    if ( sw_add_vlocal_gzero == ON ) ist = ista_kngp

! ======================== modified by K. Tagami ======== 11.0
!    do is=1,nspin
    do is=1, ismax
! ======================================================== 11.0
       do i=1,3
          do j=1,3
             do it=1,ntyp
                do ik=1,kimg
!                   ist = ista_kngp
!                   if(ista_kngp==1) ist = 2
                   do ig = ist, iend_kngp  !for mpi
                      s_loc2_mpi(i,j) = s_loc2_mpi(i,j) &
                           &  - univol  &
                           &    * chgq_l(ig,ik,is)*zfm3_l(ig,it,ik)*psc_diff_l(ig,it) &
                           &    * 2.d0 * g(ig,i) &
                           &    * (g(ig,1)*alinvt(1,j)+g(ig,2)*alinvt(2,j) &
                           &      +g(ig,3)*alinvt(3,j))
                   enddo
!xocl end spread sum(s_loc2)
                enddo
             enddo
          enddo
       enddo
    enddo

    call mpi_allreduce( s_loc2_mpi, s_loc2, 9, &
         &              mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )
    deallocate(s_loc2_mpi)

    rsv_mpi = 0.d0
    rsv = 0.d0

    ist = ista_kngp
    if(ista_kngp==1) ist = 2
    if ( sw_add_vlocal_gzero == ON ) ist = ista_kngp

! ======================== modified by K. Tagami ======== 11.0
!    do is=1,nspin
    do is=1, ismax
! ======================================================== 11.0

      do it=1,ntyp
         do ik=1,kimg
            do ig = ist, iend_kngp  !for mpi
               rsv_mpi = rsv_mpi + chgsoft(ig,ik,is)*zfm3_l(ig,it,ik)*psc_l(ig,it)
              if(sw_screening_correction==ON) then
                  rsv_mpi = rsv_mpi - chgsoft(ig,ik,is)*zfm3_l(ig,it,ik)*ival(it)*Screening%phik(i)/univol
              end if
            enddo
         enddo
      enddo
    enddo

    call mpi_allreduce( rsv_mpi, rsv, 1, &
         &              mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )

    s_loc2 = s_loc2 - (etot1*totch + univol*rsv) * alinvt

    if(af == 0) then
       s_0 = s_loc1 + s_loc2
       stress_name = 'LO'
       call check_stress(nfout)
    else
       s_0 = s_loc2
       stress_name = 'L2'
       call check_stress(nfout)
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Stress_loc

  subroutine m_Stress_h(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,ik,ig
    integer    :: id_sname = -1
    real(kind=DP) :: eh
    integer       :: ist  !mpi
    real(kind=DP) :: eh_mpi
    real(kind=DP), pointer, dimension(:,:) :: s_h2_mpi1, s_h2_mpi2

    call tstatc0_begin('m_Stress_h ',id_sname)

    ist = ista_kngp
    if(ista_kngp==1) ist = 2

    eh = 0.d0
    do ik = 1,kimg
! ========================== modified by K. Tagami ========== 11.0
!       if(nspin.eq.1) then
       if ( nspin.eq.1 .or. noncol ) then
! ============================================================ 11.0
          do i = ist, iend_kngp  !for mpi
             eh = eh + (chgq_l(i,ik,1)*grinv(i))**2
          enddo
       else if(nspin.eq.2) then
          do i = ist, iend_kngp  !for mpi
             eh = eh + ((chgq_l(i,ik,1)+chgq_l(i,ik,nspin))*grinv(i))**2
          enddo
       endif
    enddo

    do ik = 1, kimg
! ========================== modified by K. Tagami ========== 11.0
!       if(nspin.eq.1) then
       if ( nspin.eq.1 .or. noncol ) then
! ============================================================ 11.0
          do i = ist, iend_kngp  !for mpi
             eh = eh - 2 * chgq_l(i,ik,1)*chgsoft(i,ik,1)*grinv(i)**2
          enddo
       else if(nspin.eq.2) then
          do i = ist, iend_kngp  !for mpi
             eh = eh - 2 * (chgq_l(i,ik,1)+chgq_l(i,ik,nspin)) &
                  &  * (chgsoft(i,ik,1)+chgsoft(i,ik,nspin)) * grinv(i)**2
          enddo
      endif
    enddo

    if(npes > 1) then
       call mpi_allreduce(eh,eh_mpi,1 &
            &  ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
       eh = eh_mpi
    end if

    eh = univol*pai4*eh*0.5d0
    s_h2 = s_h2 + eh * alinvt

    allocate(s_h2_mpi1(3,3)); s_h2_mpi1 = 0.d0
    allocate(s_h2_mpi2(3,3)); s_h2_mpi2 = 0.d0

    do i=1,3
       do j=1,3
          do ik=1,kimg
! ========================== modified by K. Tagami ========== 11.0
!             if(nspin.eq.1) then
             if ( nspin.eq.1 .or. noncol ) then
! ============================================================ 11.0
                do ig = ist, iend_kngp  !for mpi
                   s_h2_mpi1(i,j) = s_h2_mpi1(i,j) &
                        &   + univol*pai4 &
                        &   *chgq_l(ig,ik,1)**2*grinv(ig)**4 &
                        &   *g(ig,i) &
                        &   *(g(ig,1)*alinvt(1,j)+g(ig,2)*alinvt(2,j)+g(ig,3)*alinvt(3,j))
                enddo
             else if(nspin.eq.2) then
                do ig = ist, iend_kngp  !for mpi
                   s_h2_mpi1(i,j) = s_h2_mpi1(i,j) &
                        &   + univol*pai4 &
                        &   *(chgq_l(ig,ik,1)+chgq_l(ig,ik,nspin))**2*grinv(ig)**4 &
                        &   *g(ig,i) &
                        &   *(g(ig,1)*alinvt(1,j)+g(ig,2)*alinvt(2,j)+g(ig,3)*alinvt(3,j))
                enddo
             endif
          enddo
       enddo
    enddo

    if(npes > 1) then
       call mpi_allreduce(s_h2_mpi1,s_h2_mpi2,9 &
            &  ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
    else
       s_h2_mpi2 = s_h2_mpi1
    end if

    s_h2 = s_h2 + s_h2_mpi2
    deallocate(s_h2_mpi1); deallocate(s_h2_mpi2)

    if(af == 0) then
       s_0 = s_h1 +s_h2
       stress_name = 'HA'
       call check_stress(nfout)
    else
       s_0 = s_h2
       stress_name = 'H2'
       call check_stress(nfout)
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Stress_h

  subroutine m_Stress_ew(nfout)
    integer, intent(in) :: nfout

    s_0 = s_ew
    stress_name = 'EW'
    call check_stress(nfout)

  end subroutine m_Stress_ew

! =================================== KT_add ====================== 13.0B
  subroutine m_Stress_vdw(nfout)
    integer, intent(in) :: nfout
    integer :: i, j

    s_0 = s_vdw
    stress_name = 'VDW'

!    call check_stress(nfout)
    if(ipri >= 1) write(nfout,'(''  STRESS TENSOR'',5x,A2,/,(3f20.10))') &
         &     stress_name,((s_0(i,j),j=1,3),i=1,3)

  end subroutine m_Stress_vdw
! ================================================================= 13.0B

#ifndef DISABLE_VDWDF
  subroutine m_Stress_vdwdf(nfout)
    integer, intent(in) :: nfout
    integer :: i, j
!    s_vdwdf = s_cnl1 +s_cnl2 -s_cnl1_pc -s_cnl2_pc
    s_vdwdf = s_cnl1 +s_cnl2
    s_0 = s_vdwdf
!
    stress_name = 'VDWDF'

!    call check_stress(nfout)
    if(ipri >= 1) write(nfout,'(''  STRESS TENSOR'',5x,A2,/,(3f20.10))') &
         &     stress_name,((s_0(i,j),j=1,3),i=1,3)
  end subroutine m_Stress_vdwdf
#endif

  subroutine m_Stress_nl(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,ia,it,ispin,lmt1,lmt2,il1,il2,im1,im2
    integer    :: id_sname = -1
    real(kind=DP) :: fac

    call tstatc0_begin('m_Stress_nl ',id_sname)

    do i = 1, 3
    do j = 1, 3
    do ispin = 1, nspin, af+1
    do it = 1, ntyp
    do lmt1 = 1, ilmt(it)
    il1 = ltp(lmt1,it)
    im1 = mtp(lmt1,it)
    do lmt2 = lmt1, ilmt(it)
    il2 = ltp(lmt2,it)
    im2 = mtp(lmt2,it)
    if(ipaw(it)==0) then
        if(il1==il2 .and. im1==im2) then
           do ia = 1, natm
           if(ityp(ia)==it) then
              fac = 2.d0*dble(iwei(ia))
              if(lmt1==lmt2) fac = fac*0.5d0
              s_nl(i,j) = s_nl(i,j) &
                & + fac * dion(lmt1,lmt2,it) * hsrd(ia,lmt1,lmt2,ispin,i,j)

!              write(980,*) 'i j it = ', i, j, it
!              write(980,*) 'lmt1 kmt2 ia = ', lmt1, lmt2, ia
!              write(980,*) 'dion= ', dion(lmt1,lmt2,it)
!              write(980,*) 'hsrd= ', hsrd(ia,lmt1,lmt2,1,i,j), &
!                   &                 hsrd(ia,lmt1,lmt2,2,i,j)
           endif
           enddo
!
        endif
    else
! --- Check ---
       do ia = 1, natm
       if(ityp(ia)==it) then
          fac = 2.d0*dble(iwei(ia))
          if(lmt1==lmt2) fac = fac*0.5d0
          s_nl(i,j) = s_nl(i,j) &
            & + fac * dion_paw(lmt1,lmt2,ispin,ia) * hsrd(ia,lmt1,lmt2,ispin,i,j)
       endif
       enddo
    endif
    enddo  ! lmt2
    enddo  ! lmt1
    enddo  ! it
    enddo  ! ispin
    enddo  ! j
    enddo  ! i

    if(af == 0) then
       s_0 = s_nl
       stress_name = 'NL'
       call check_stress(nfout)
    else
       s_up = s_nl
       stress_name = 'NL'
       call check_af(nfout)
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Stress_nl

! =========================== added by K. Tagami ============ 11.0
  subroutine m_Stress_nl_nonclA(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,ia,it,ispin,lmt1,lmt2,il1,il2,im1,im2
    integer    :: id_sname = -1
    real(kind=DP) :: fac

    integer:: is

    call tstatc0_begin('m_Stress_nl_noncl ',id_sname)

    do i = 1, 3
       do j = 1, 3
          do it = 1, ntyp
             do lmt1 = 1, ilmt(it)
                il1 = ltp(lmt1,it)
                im1 = mtp(lmt1,it)
                do lmt2 = lmt1, ilmt(it)
                   il2 = ltp(lmt2,it)
                   im2 = mtp(lmt2,it)

                   if (ipaw(it)==0) then
                      if(il1==il2 .and. im1==im2) then
                         do ia = 1, natm
                            if(ityp(ia)==it) then
                               fac = 2.d0*dble(iwei(ia))
                               if(lmt1==lmt2) fac = fac*0.5d0
                               s_nl(i,j) = s_nl(i,j) +fac *dion(lmt1,lmt2,it) &
                                    &                     *hsrd(ia,lmt1,lmt2,1,i,j)

!                               write(980,*) 'i j it = ', i, j, it
!                               write(980,*) 'lmt1 kmt2 ia = ', lmt1, lmt2, ia
!                               write(980,*) 'dion= ', dion(lmt1,lmt2,it)
!                               write(980,*) 'hsrd= ', hsrd(ia,lmt1,lmt2,1,i,j), &
!                                    &                 hsrd(ia,lmt1,lmt2,2,i,j)

                            endif
                         enddo
                      endif
                   else

                      do ia = 1, natm
                         if(ityp(ia)==it) then
                            fac = 2.d0*dble(iwei(ia))
                            if(lmt1==lmt2) fac = fac*0.5d0

                            Do is=1, ndim_magmom
                               s_nl(i,j) = s_nl(i,j) +fac *dion_paw(lmt1,lmt2,is,ia)&
                                    &                     *hsrd(ia,lmt1,lmt2,is,i,j)
                            End do
                         endif
                      enddo
                   endif
                enddo  ! lmt2
             enddo  ! lmt1
          enddo  ! it
       enddo  ! j
    enddo  ! i

    s_0 = s_nl;        stress_name = 'NL'
    call check_stress(nfout)

    call tstatc0_end(id_sname)
  end subroutine m_Stress_nl_nonclA

  subroutine m_Stress_nl_nonclB(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,ia,it,ispin,lmt1,lmt2,il1,il2,im1,im2
    integer    :: id_sname = -1
    integer:: is

    real(kind=DP) :: fac, c1, c2
    real(kind=DP), allocatable ::  hsr_ssrep( :,:,:,: )
    real(kind=DP), allocatable ::  hsi_ssrep( :,:,:,: )

    call tstatc0_begin('m_Stress_nl_noncl ',id_sname)

    allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) )
    allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) )
!
    hsr_ssrep = 0.0d0;  hsi_ssrep = 0.0d0

    do i = 1, 3
       do j = 1, 3
!
          call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, &
               &                           hsrd(:,:,:,:,i,j), hsid(:,:,:,:,i,j ), &
               &                           hsr_ssrep, hsi_ssrep )
!
          do it = 1, ntyp
!
             do lmt1 = 1, ilmt(it)
                il1 = ltp(lmt1,it)
                im1 = mtp(lmt1,it)
                do lmt2 = lmt1, ilmt(it)
                   il2 = ltp(lmt2,it)
                   im2 = mtp(lmt2,it)

                   do ia = 1, natm
                      if ( ityp(ia) /= it ) cycle
                      fac = 2.d0*dble(iwei(ia))
                      if(lmt1==lmt2) fac = fac*0.5d0

                      Do is=1, ndim_chgpot
                         c1 = real(  dion0_noncl( lmt1,lmt2,is,ia ) ) &
                              &  *hsr_ssrep( ia,lmt1,lmt2,is )
                         c2 = aimag(  dion0_noncl( lmt1,lmt2,is,ia ) ) &
                              &  *hsi_ssrep( ia,lmt1,lmt2,is )
                         s_nl(i,j) = s_nl(i,j) +fac *( c1+c2 )
                      End do
                   enddo
                enddo  ! lmt2
             enddo  ! lmt1
          enddo  ! it
       enddo  ! j
    enddo  ! i
!
    deallocate( hsr_ssrep );   deallocate( hsi_ssrep )
!
    s_0 = s_nl;        stress_name = 'NL'
    call check_stress(nfout)

    call tstatc0_end(id_sname)

  end subroutine m_Stress_nl_nonclB
! ================================================================= 11.0

  subroutine m_Stress_or(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,ia,it,ispin,lmt1,lmt2,il1,il2,im1,im2
    integer    :: id_sname = -1
    real(kind=DP) :: fac

    call tstatc0_begin('m_Stress_or ',id_sname)

    do i = 1, 3
    do j = 1, 3
    do ispin = 1, nspin, af+1
    do it = 1, ntyp
    do lmt1 = 1, ilmt(it)
    il1 = ltp(lmt1,it)
    im1 = mtp(lmt1,it)
    do lmt2 = lmt1, ilmt(it)
    il2 = ltp(lmt2,it)
    im2 = mtp(lmt2,it)
    if(il1==il2 .and. im1==im2) then
       do ia = 1, natm
       if(ityp(ia)==it) then
          fac = 2.d0*dble(iwei(ia))
          if(lmt1==lmt2) fac = fac*0.5d0
          s_or(i,j) = s_or(i,j) &
            & + fac * q(lmt1,lmt2,it) * esrd(ia,lmt1,lmt2,ispin,i,j)
       endif
       enddo
    endif
    enddo  ! lmt2
    enddo  ! lmt1
    enddo  ! it
    enddo  ! ispin
    enddo  ! j
    enddo  ! i

    if(af == 0) then
       s_0 = s_or
       stress_name = 'OR'
       call check_stress(nfout)
    else
       s_up = s_or
       stress_name = 'OR'
       call check_af(nfout)
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Stress_or

! ================================= added by K. Tagami ============= 11.0
  subroutine m_Stress_or_nonclA(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,ia,it,ispin,lmt1,lmt2,il1,il2,im1,im2
    integer    :: id_sname = -1
    real(kind=DP) :: fac

    call tstatc0_begin('m_Stress_or_noncl ',id_sname)

    do i = 1, 3
       do j = 1, 3

          do it = 1, ntyp
             do lmt1 = 1, ilmt(it)
                il1 = ltp(lmt1,it)
                im1 = mtp(lmt1,it)
                do lmt2 = lmt1, ilmt(it)
                   il2 = ltp(lmt2,it)
                   im2 = mtp(lmt2,it)

                   if(il1==il2 .and. im1==im2) then
                      do ia = 1, natm
                         if(ityp(ia)==it) then
                            fac = 2.d0*dble(iwei(ia))
                            if(lmt1==lmt2) fac = fac*0.5d0
                            s_or(i,j) = s_or(i,j) &
                                 & + fac * q(lmt1,lmt2,it) * esrd(ia,lmt1,lmt2,1,i,j)
                         endif
                      enddo
                   endif
                enddo  ! lmt2
             enddo  ! lmt1
          enddo  ! it
       enddo  ! j
    enddo  ! i

    s_0 = s_or;        stress_name = 'OR'
    call check_stress(nfout)

    call tstatc0_end(id_sname)
  end subroutine m_Stress_or_nonclA

  subroutine m_Stress_or_nonclB(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,ia,it,ispin,lmt1,lmt2,il1,il2,im1,im2
    integer    :: id_sname = -1

    integer :: is
    real(kind=DP) :: fac, c1, c2
    real(kind=DP), allocatable ::  hsr_ssrep( :,:,:,: )
    real(kind=DP), allocatable ::  hsi_ssrep( :,:,:,: )

    call tstatc0_begin('m_Stress_or_noncl ',id_sname)

    allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) )
    allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) )
!
    hsr_ssrep = 0.0d0;  hsi_ssrep = 0.0d0

    do i = 1, 3
       do j = 1, 3
!
          call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, &
               &                           esrd(:,:,:,:,i,j), esid(:,:,:,:,i,j), &
               &                           hsr_ssrep, hsi_ssrep )
!
          do it = 1, ntyp
             do lmt1 = 1, ilmt(it)
                il1 = ltp(lmt1,it)
                im1 = mtp(lmt1,it)
                do lmt2 = lmt1, ilmt(it)
                   il2 = ltp(lmt2,it)
                   im2 = mtp(lmt2,it)

                   if (il1/=il2) cycle

                   do ia = 1, natm
                      if (ityp(ia)/=it) cycle

                      if ( ityp(ia) /= it ) cycle
                      fac = 2.d0*dble(iwei(ia))
                      if(lmt1==lmt2) fac = fac*0.5d0

                      Do is=1, ndim_chgpot
                         c1 = real(  q_noncl( lmt1,lmt2,is,it ) ) &
                              &  *hsr_ssrep( ia,lmt1,lmt2,is )
                         c2 = aimag(  q_noncl( lmt1,lmt2,is,it ) ) &
                              &  *hsi_ssrep( ia,lmt1,lmt2,is )
                         s_or(i,j) = s_or(i,j) +fac *( c1+c2 )
                      End do

                   end do
                enddo  ! lmt2
             enddo  ! lmt1
          enddo  ! it
       enddo  ! j
    enddo  ! i
!
    deallocate( hsr_ssrep );   deallocate( hsi_ssrep )
!
    s_0 = s_or;        stress_name = 'OR'
    call check_stress(nfout)

    call tstatc0_end(id_sname)
  end subroutine m_Stress_or_nonclB
! =============================================================== 11.0

! =========================== Added by K. Tagami =========== p1100
  subroutine m_Stress_Hub(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,ia,it,ispin,lmt1,lmt2,il1,il2,im1,im2
!
    integer ih, l1p
!
    integer    :: id_sname = -1
    real(kind=DP) :: fac

    call tstatc0_begin('m_Stress_Hub ',id_sname)

    do i = 1, 3
       do j = 1, 3
          do ispin = 1, nspin, af+1
             do ia = 1, natm
                ih = ihubbard(ia)
                if(ih == 0) cycle
                it = ityp(ia)
                l1p = proj_attribute(ih)%l+1
                do lmt1 = 1, ilmt(it)
                   il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
                   if(il1 /= l1p) cycle
                   do lmt2 = lmt1, ilmt(it)
                      il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                      if(il2 /= l1p) cycle
      !!$if(im1 /= im2) cycle
                      fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                      s_hub(i,j) = s_hub(i,j) &
                           & + fac * dhub(lmt1,lmt2,ia,ispin)  &
                           &       * hsrd(ia,lmt1,lmt2,ispin,i,j)
                   end do
                end do
             end do
          end do
       enddo
    enddo
! --
!    if ( nspin==1 ) then
!       s_hub =s_hub * 2.0d0
!    endif
!    s_hub = 0.0d0
    ! --
    if(af == 0) then
       s_0 = s_hub
       stress_name = 'HU'
       call check_stress(nfout)
    else
       s_up = s_hub
       stress_name = 'HU'
       call check_af(nfout)
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Stress_Hub

! ====================================================== p1100

! ============================ added by K. Tagami ============ 11.0
  subroutine m_Stress_Hub_nonclA(nfout)

    integer, intent(in) :: nfout
    integer    :: i,j,ia,it,is,lmt1,lmt2,il1,il2,im1,im2
!
    integer ih, l1p
!
    integer    :: id_sname = -1
    real(kind=DP) :: fac

    call tstatc0_begin('m_Stress_Hub_noncl ',id_sname)

    do i = 1, 3
       do j = 1, 3

          Do is=1, ndim_magmom
             do ia = 1, natm
                ih = ihubbard(ia)
                if(ih == 0) cycle
                it = ityp(ia)
                l1p = proj_attribute(ih)%l+1

                do lmt1 = 1, ilmt(it)
                   il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
                   if(il1 /= l1p) cycle

                   do lmt2 = lmt1, ilmt(it)
                      il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                      if(il2 /= l1p) cycle
      !!$if(im1 /= im2) cycle
                      fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                      s_hub(i,j) = s_hub(i,j) &
                           & + fac * dhub(lmt1,lmt2,ia,is)  &
                           &       * hsrd(ia,lmt1,lmt2,is,i,j)
                   end do
                end do
             end do
          End do

       enddo
    enddo
!
    s_0 = s_hub;     stress_name = 'HU'
    call check_stress(nfout)

    call tstatc0_end(id_sname)
  end subroutine m_Stress_Hub_nonclA

  subroutine m_Stress_Hub_nonclB(nfout)

    integer, intent(in) :: nfout
    integer    :: i,j,ia,it,is,lmt1,lmt2,il1,il2,im1,im2
!
    integer ih, l1p
!
    integer    :: id_sname = -1
    real(kind=DP) :: fac

    call tstatc0_begin('m_Stress_Hub_noncl ',id_sname)

    do i = 1, 3
       do j = 1, 3

          Do is=1, ndim_magmom
             do ia = 1, natm
                ih = ihubbard(ia)
                if(ih == 0) cycle
                it = ityp(ia)
                l1p = proj_attribute(ih)%l+1

                do lmt1 = 1, ilmt(it)
                   il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
                   if(il1 /= l1p) cycle

                   do lmt2 = lmt1, ilmt(it)
                      il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                      if(il2 /= l1p) cycle
      !!$if(im1 /= im2) cycle
                      fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                      s_hub(i,j) = s_hub(i,j) &
                           & + fac * dhub(lmt1,lmt2,ia,is)  &
                           &       * hsrd(ia,lmt1,lmt2,is,i,j) &
                           & + fac * dhub_aimag(lmt1,lmt2,ia,is)  &
                           &       * hsid(ia,lmt1,lmt2,is,i,j)
                   end do
                end do
             end do
          End do

       enddo
    enddo
!
    s_0 = s_hub;     stress_name = 'HU'
    call check_stress(nfout)

    call tstatc0_end(id_sname)
  end subroutine m_Stress_Hub_nonclB
! ================================================================ 11.0

  subroutine check_stress(nfout)
    integer, intent(in) :: nfout
    integer             :: i,j,k,l,iopr

    s_1 = 0.d0
    s_2 = 0.d0
    do i=1,3
    do j=1,3
      do k=1,3
      s_1(i,j)=s_1(i,j)-s_0(i,k)*altv(j,k)/univol
      enddo
    enddo
    enddo

    do i=1,3
    do j=1,3
      do k=1,3
      do l=1,3
        do iopr=1,nopr
        s_2(i,j)=s_2(i,j) + op(i,k,iopr)*op(j,l,iopr)*s_1(k,l)
        enddo
      enddo
      enddo
    s_2(i,j)=s_2(i,j)/nopr
    enddo
    enddo

    if(ipri >= 1) write(nfout,'(''  STRESS TENSOR'',5x,A2,/,(3f20.10))') &
         &     stress_name,((s_2(i,j),j=1,3),i=1,3)
  end subroutine check_stress

  subroutine check_af(nfout)
    integer, intent(in) :: nfout
    integer             :: i,j,k,l,iopr

    s_1 = 0.d0
    s_2 = 0.d0
    s_dn = 0.d0

    do i=1,3
    do j=1,3
      do k=1,3
      s_1(i,j)=s_1(i,j)-s_up(i,k)*altv(j,k)/univol
      enddo
    enddo
    enddo

    iopr = nopr +af
    do i=1,3
    do j=1,3
      do k=1,3
      do l=1,3
        s_dn(i,j)=s_dn(i,j) + op(i,k,iopr)*op(j,l,iopr)*s_1(k,l)
      enddo
      enddo
    enddo
    enddo

    s_1 = s_1 + s_dn

    do i=1,3
    do j=1,3
      do k=1,3
      do l=1,3
        do iopr=1,nopr
        s_2(i,j)=s_2(i,j) + op(i,k,iopr)*op(j,l,iopr)*s_1(k,l)
        enddo
      enddo
      enddo
    s_2(i,j)=s_2(i,j)/nopr
    enddo
    enddo

    if(ipri >= 1) write(nfout,'(''  STRESS TENSOR'',5x,A2,/,(3f20.10))') &
         &     stress_name,((s_2(i,j),j=1,3),i=1,3)
  end subroutine check_af

  subroutine m_Stress_sum(nfout)
    integer, intent(in) :: nfout
    integer             :: i,j,k,l,iopr
    real(kind=DP) :: c1
    real(kind=DP) :: altv_brav(3,3)

    s_tmp=0.d0
    s=0.d0
    if(af==0) then
       s = s_ke + s_xc1 + s_xc2 + s_gga1 + s_gga2 + s_loc1 + s_loc2 &
         &  + s_h1 + s_h2 + s_nl - s_or + s_ew

! ================================== Added by K. Tagami ======= p1100
       s = s + s_hub
! ============================================================== p1100

       do i=1,3
         do j=1,3
           do k=1,3
             s_tmp(i,j) = s_tmp(i,j) - s(i,k) * altv(j,k) / univol
           enddo
         enddo
       enddo
    else
       s_up = s_ke + s_xc1 + s_gga1 + s_gga2 + s_loc1 &
         &  + s_h1 + s_nl - s_or

! ================================== Added by K. Tagami ======= p1100
       s_up = s_up + s_hub
! ============================================================= p1100

       do i=1,3
         do j=1,3
           do k=1,3
             s_tmp(i,j) = s_tmp(i,j) - s_up(i,k) * altv(j,k) / univol
           enddo
         enddo
       enddo
       iopr = nopr + af
       s_dn = 0.d0
       do i=1,3
         do j=1,3
           do k=1,3
             do l=1,3
               s_dn(i,j) = s_dn(i,j) + op(i,k,iopr)*op(j,l,iopr)*s_tmp(k,l)
             enddo
           enddo
         enddo
       enddo
       s_tmp = s_tmp + s_dn
       s = s_xc2 + s_loc2 + s_h2 + s_ew

       do i=1,3
         do j=1,3
           do k=1,3
             s_tmp(i,j) = s_tmp(i,j) - s(i,k) * altv(j,k) / univol
           enddo
         enddo
       enddo
    endif

! ================================== KT_add  =============== 13.0B
    if ( sw_vdw_correction == ON ) s_tmp = s_tmp +s_vdw
! ========================================================== 13.0B
!    if ( xctype == "vdwdf" ) s = s +s_vdwdf

    s = 0.d0
    do i=1,3
      do j=1,3
        do k=1,3
          do l=1,3
            do iopr=1,nopr
              s(i,j) = s(i,j) + op(i,k,iopr)*op(j,l,iopr)*s_tmp(k,l)
            enddo
          enddo
        enddo
      enddo
    enddo
    s = s / nopr

    if ( xctype == "vdwdf" ) s = s +s_vdwdf

    if(ipri >= 1) write(nfout,'(''  STRESS TENSOR'',/,(3f20.10))') &
         &     ((s(i,j),j=1,3),i=1,3)

! ============================= KT_add ======================== 13.0B
    if (ipri >= 1) then
       write(nfout,*) '-------------------------- '
       write(nfout,'(''  External STRESS TENSOR'',/,(3f20.10))') &
            &            ( ( -external_stress(i,j),j=1,3),i=1,3)
       write(nfout,'(''  Total STRESS TENSOR'',/,(3f20.10))') &
            &            ( ( s(i,j)-external_stress(i,j),j=1,3),i=1,3)
       write(nfout,*) '-------------------------- '
    endif
! ============================================================= 13.0B

! ================================ KT_mod ================== 13.0B
!    stressmx = abs(s(1,1))
!    do i=1,3
!       do j=1,3
!          if(abs(s(j,i))>stressmx) stressmx = abs(s(j,i))
!       enddo
!    enddo
!    currstress(:,:) = s(:,:)
!    if(sw_uniform==ON)then
!       stressmx = abs(currstress(1,1)+currstress(2,2)+currstress(3,3))/3.0d0
!    endif

    if(.not.m_Stress_in_correction()) then
      currstress = s -external_stress
      call cal_stressmx()
    endif
!

! ================================================================= 13.0B

  end subroutine m_Stress_sum

  subroutine cal_stressmx()
    real(kind=DP) :: s_tmp(3,3)
    real(kind=DP) :: altv_brav(3,3)
    real(kind=DP) :: c1
    integer :: i,j
    stressmx = abs(currstress(1,1))
    do i=1,3
       do j=1,3
          if(abs(currstress(j,i))>stressmx) stressmx = abs(currstress(j,i))
       enddo
    enddo
    if ( sw_uniform == ON ) then
       stressmx = abs(currstress(1,1)+currstress(2,2)+currstress(3,3))/3.0d0
    endif

! === KT_add === 13.1AS
    if ( sw_neglect_stress_offdiagonal == ON ) then
       s_tmp = 0.0d0
       s_tmp(1,1) = currstress(1,1)
       s_tmp(2,2) = currstress(2,2)
       s_tmp(3,3) = currstress(3,3)

       stressmx = 0.0d0
       do i=1,3
          c1 = sqrt( s_tmp(i,1)**2 +s_tmp(i,2)**2 +s_tmp(i,3)**2 )
          if ( c1 > stressmx ) stressmx = c1
       enddo
    endif

    if ( sw_fix_lattice_angles == ON .or. sw_fix_lattice_lengths == ON ) then
       s_tmp = currstress

       if ( sw_fix_lattice_shapes == ON ) then
          if ( fix_shape_ab_plane ) then
             s_tmp(1,1) = ( currstress(1,1)+currstress(2,2) )/2.0d0
             s_tmp(2,2) = ( currstress(1,1)+currstress(2,2) )/2.0d0
             s_tmp(1,2) = 0.0d0
             s_tmp(2,1) = 0.0d0
          endif
          if ( fix_shape_ac_plane ) then
             s_tmp(1,1) = ( currstress(1,1)+currstress(3,3) )/2.0d0
             s_tmp(3,3) = ( currstress(1,1)+currstress(3,3) )/2.0d0
             s_tmp(1,3) = 0.0d0
             s_tmp(3,1) = 0.0d0
          endif
          if ( fix_shape_bc_plane ) then
             s_tmp(2,2) = ( currstress(2,2)+currstress(3,3) )/2.0d0
             s_tmp(3,3) = ( currstress(2,2)+currstress(3,3) )/2.0d0
             s_tmp(2,3) = 0.0d0
             s_tmp(3,2) = 0.0d0
          endif
       endif

       call get_latvec_from_prim_to_brav( p2bmat, altv, altv_brav )

       s_tmp = projected_stress_along_latvecs( altv_brav, s_tmp )
       stressmx = 0.0d0

       if ( sw_fix_lattice_angles == ON ) then
          s_tmp = constrain_on_stress_type1( altv_brav, s_tmp )
       endif
       if ( sw_fix_lattice_lengths == ON ) then
          s_tmp = constrain_on_stress_type2( altv_brav, s_tmp )
       endif

       do i=1,3
          c1 = sqrt( s_tmp(i,1)**2 +s_tmp(i,2)**2 +s_tmp(i,3)**2 )
          if ( c1 > stressmx ) stressmx = c1
       enddo
    endif
! ============= 13.1AS
  end subroutine cal_stressmx


  function m_Stress_get_stressmx() result(res)
     real(kind=DP) :: res
     res = stressmx
  end function m_Stress_get_stressmx

  subroutine m_Stress_set_stressmx(strmx)
    real(kind=DP), intent(in) :: strmx
    stressmx = strmx
  end subroutine m_Stress_set_stressmx

  function m_Stress_get_curr_stress() result(res)
     real(kind=DP), dimension(3,3) :: res
     res = currstress
  end function m_Stress_get_curr_stress
!$$#endif

! === KT_add ==== 13.1AS
function projected_stress_along_latvecs(altv_in,stress) result(ret)
  real(kind=DP), dimension(3,3), intent(in) :: stress, altv_in
  real(kind=DP), dimension(3,3) :: ret

  integer :: i
  real(kind=DP) :: normalized_lat_vec(3,3), c1
!
  Do i=1, 3
     c1 = sqrt( altv_in(1,i)**2 +altv_in(2,i)**2 + altv_in(3,i)**2 )
     normalized_lat_vec(:,i) = altv_in(:,i) / c1
  End do

  ret = 0.0d0

  do i=1,3
     ret(1,i) = dot_product(stress(i,:),normalized_lat_vec(:,1)) ! a-vec
     ret(2,i) = dot_product(stress(i,:),normalized_lat_vec(:,2)) ! b-vec
     ret(3,i) = dot_product(stress(i,:),normalized_lat_vec(:,3)) ! c-vec
  enddo
end function projected_stress_along_latvecs

function constrain_on_stress_type1(altv_in,s_in) result(s_out)
  real(kind=DP), intent(in) :: s_in(3,3), altv_in(3,3)
  real(kind=DP) :: s_out(3,3)

  integer :: i
  real(kind=DP) :: c1, c2, c3
  real(kind=DP) :: normalized_lat_vec(3,3), vectmp(3), vectmp2(3)
!
  s_out = s_in
!
  Do i=1, 3
     c1 = sqrt( altv_in(1,i)**2 +altv_in(2,i)**2 + altv_in(3,i)**2 )
     normalized_lat_vec(:,i) = altv_in(:,i) / c1
  End do

! -----------------------------------
  if ( fix_angle_alpha .and. fix_angle_beta .and. fix_angle_gamma ) then
     Do i=1, 3
        c1 = dot_product( s_out(i,:), normalized_lat_vec(:,i) )
        s_out(i,:) = c1 *normalized_lat_vec(:,i)
     End do
     return
  endif

! -----------------------------------
  if ( fix_angle_alpha ) then
     vectmp(:) = normalized_lat_vec(:,2) + normalized_lat_vec(:,3)

     Do i=2, 3
        c1 = dot_product( vectmp(:), normalized_lat_vec(:,i) )
        vectmp2(:) = vectmp(:) - c1*normalized_lat_vec(:,i)

        c2 = sqrt( vectmp2(1)**2 + vectmp2(2)**2 + vectmp2(3)**2 )
        vectmp2 = vectmp2 /c2

        c3 = dot_product( s_out(i,:), vectmp2(:) )
        s_out(i,:) = s_out(i,:) - c3 *vectmp2(:)
     End do
  endif

! -----------------------------------
  if ( fix_angle_beta ) then
     vectmp(:) = normalized_lat_vec(:,1) + normalized_lat_vec(:,3)

     Do i=1, 3, 2
        c1 = dot_product( vectmp(:), normalized_lat_vec(:,i) )
        vectmp2(:) = vectmp(:) - c1*normalized_lat_vec(:,i)

        c2 = sqrt( vectmp2(1)**2 + vectmp2(2)**2 + vectmp2(3)**2 )
        vectmp2 = vectmp2 /c2

        c3 = dot_product( s_out(i,:), vectmp2(:) )
        s_out(i,:) = s_out(i,:) - c3 *vectmp2(:)
     End do
  endif

! -----------------------------------
  if ( fix_angle_gamma ) then
     vectmp(:) = normalized_lat_vec(:,1) + normalized_lat_vec(:,2)

     Do i=1, 2
        c1 = dot_product( vectmp(:), normalized_lat_vec(:,i) )
        vectmp2(:) = vectmp(:) - c1*normalized_lat_vec(:,i)

        c2 = sqrt( vectmp2(1)**2 + vectmp2(2)**2 + vectmp2(3)**2 )
        vectmp2 = vectmp2 /c2

        c3 = dot_product( s_out(i,:), vectmp2(:) )
        s_out(i,:) = s_out(i,:) - c3 *vectmp2(:)
     End do

  endif

end function constrain_on_stress_type1

function constrain_on_stress_type2(altv_in,s_in) result(s_out)
  real(kind=DP), intent(in) :: s_in(3,3), altv_in(3,3)
  real(kind=DP) :: s_out(3,3)

  integer :: i
  real(kind=DP) :: c1, c2, c3
  real(kind=DP) :: normalized_lat_vec(3,3), vectmp(3), vectmp2(3)
!
  s_out = s_in
!
  Do i=1, 3
     c1 = sqrt( altv_in(1,i)**2 +altv_in(2,i)**2 + altv_in(3,i)**2 )
     normalized_lat_vec(:,i) = altv_in(:,i) / c1
  End do

! -----------------------------------
  if ( fix_length_a ) then
     c1 = dot_product( s_out(1,:), normalized_lat_vec(:,1) )
     s_out(1,:) = s_out(1,:) -c1 *normalized_lat_vec(:,1)
  endif
  if ( fix_length_b ) then
     c1 = dot_product( s_out(2,:), normalized_lat_vec(:,2) )
     s_out(2,:) = s_out(2,:) -c1 *normalized_lat_vec(:,2)
  endif
  if ( fix_length_c ) then
     c1 = dot_product( s_out(3,:), normalized_lat_vec(:,3) )
     s_out(3,:) = s_out(3,:) -c1 *normalized_lat_vec(:,3)
  endif
end function constrain_on_stress_type2
! ====== 13.1AS


subroutine m_Stress_correction(nfout,cntn)
  use m_IterationNumbers, only : iteration_stress_correction
  use m_Total_Energy, only: etotal0
  use m_Crystal_Structure, only : univol
  use m_Control_Parameters, only : gmax_org,decut_stress_correction,external_stress
  implicit none
  integer, intent(in) :: nfout
  logical, intent(in), optional :: cntn
  real(kind=DP) :: ecut,idelta_v,e1,e2,s1,s2
  logical :: from_cntn
  logical, save :: evaluated_correction = .false.
  if (evaluated_correction) return
  from_cntn = .false.
  if(present(cntn)) from_cntn = cntn
  if(iteration_stress_correction>=1 .and. iteration_stress_correction <= 2)then
    etot3(iteration_stress_correction) = etotal0
    univol0 = univol
  endif
  if(iteration_stress_correction == 2 .and. .not. from_cntn .or. &
  & (from_cntn.and.iteration_stress_correction>=3)) then !eval stress correction
    ecut = gmax_org*gmax_org
    idelta_v = -ecut/(1.5d0*univol0*decut_stress_correction)
    e1 = -etot3(1)
    e2 =  etot3(2)
    s1 = -e1*idelta_v
    s2 = -e2*idelta_v
    stress_correction = (s1+s2)*0.5d0
    if(printable) then
       write(nfout,'(a,f20.15)')  ' !** Pulay stress : ',stress_correction
    endif
    external_stress(1,1) = stress_correction
    external_stress(2,2) = stress_correction
    external_stress(3,3) = stress_correction
    estress_has_been_set = .true.
    evaluated_correction = .true.
  endif
end subroutine m_Stress_correction

function m_Stress_get_correction() result(res)
  implicit none
  real(kind=DP) :: res
  res = stress_correction
  return
end function m_Stress_get_correction

logical function in_correction0()
  use m_Const_Parameters, only : OFF
  use m_Control_Parameters, only : sw_stress_correction
  use m_IterationNumbers, only : iteration_stress_correction
  implicit none
  in_correction0 = in_correction1(2)
end function in_correction0

logical function in_correction1(ncount)
  use m_Const_Parameters, only : OFF
  use m_Control_Parameters, only : sw_stress_correction
  use m_IterationNumbers, only : iteration_stress_correction
  implicit none
  integer, intent(in) :: ncount
  if(sw_stress_correction == OFF) then
    in_correction1 = .false.
    return
  endif
  in_correction1 = iteration_stress_correction <= ncount
  return
end function in_correction1

function m_Stress_decut_for_correction() result(ret)
  use m_Const_Parameters, only : OFF,DP
  use m_Control_Parameters, only : sw_stress_correction, decut_stress_correction
  use m_IterationNumbers, only : iteration_stress_correction
  implicit none
  real(kind=DP) :: ret
  if(sw_stress_correction == OFF)then
     ret = 0.d0
     return
  endif
  if(iteration_stress_correction == 1) then
     ret = -decut_stress_correction
  else if (iteration_stress_correction == 2) then
     ret = +decut_stress_correction
  else
     ret = 0.d0
  endif
  return
end function m_Stress_decut_for_correction

subroutine m_Stress_wd_cdata_4_correction(nfcntn)
  use m_IterationNumbers, only : iteration_stress_correction
  implicit none
  integer, intent(in) :: nfcntn
  if(mype==0)then
     write(nfcntn,*) tag_stress_correction
     write(nfcntn,'(i8)') iteration_stress_correction
     write(nfcntn,'(4f20.10)') etot3(1),etot3(2),etot3(3),univol0
     write(nfcntn,'(l2)') estress_has_been_set
     write(nfcntn,'(3f20.10)') currstress(1,1),currstress(1,2),currstress(1,3)
     write(nfcntn,'(3f20.10)') currstress(2,1),currstress(2,2),currstress(2,3)
     write(nfcntn,'(3f20.10)') currstress(3,1),currstress(3,2),currstress(3,3)
  endif
end subroutine m_Stress_wd_cdata_4_correction

subroutine m_Stress_rd_cdata_4_correction(nfout,nfcntn)
  use m_IterationNumbers, only : iteration_stress_correction
  implicit none
  integer, intent(in) :: nfout,nfcntn
  integer,      parameter   :: len_str = 132
  character(len=len_str)    :: str
  logical             :: tag_is_found, EOF_reach
  integer :: ierr
  if(mype==0)then
     call rewind_to_tag0(nfcntn,len(tag_stress_correction),tag_stress_correction &
          &, EOF_reach, tag_is_found, str,len_str)
     if(.not.tag_is_found)then
       write(nfout,'(a)') '!** '//trim(tag_stress_correction)//' does not exist'
     else
       read(nfcntn,*) iteration_stress_correction
       read(nfcntn,*) etot3(1),etot3(2),etot3(3),univol0
       read(nfcntn,*) estress_has_been_set
       read(nfcntn,*) currstress(1,1),currstress(1,2),currstress(1,3)
       read(nfcntn,*) currstress(2,1),currstress(2,2),currstress(2,3)
       read(nfcntn,*) currstress(3,1),currstress(3,2),currstress(3,3)
     endif
  endif
  if(npes>1)then
     call mpi_bcast(tag_is_found,1,mpi_logical,0,MPI_CommGroup,ierr)
     if(tag_is_found)then
        call mpi_bcast(iteration_stress_correction,1,mpi_integer,0,MPI_CommGroup,ierr)
        call mpi_bcast(etot3,3,mpi_double_precision,0,MPI_CommGroup,ierr)
        call mpi_bcast(univol0,1,mpi_double_precision,0,MPI_CommGroup,ierr)
        call mpi_bcast(estress_has_been_set,1,mpi_logical,0,MPI_CommGroup,ierr)
        call mpi_bcast(currstress,9,mpi_double_precision,0,MPI_CommGroup,ierr)
     endif
  endif
end subroutine m_Stress_rd_cdata_4_correction

end module m_Stress

subroutine memsize(nfout)
implicit none
integer, intent(in) :: nfout
integer :: ipid, imemsize
character*16 :: cpid, c1, c2
character*256 :: status_file
real(kind=8) :: mb
integer :: getpid

ipid = getpid()
write(cpid,*) ipid

write(status_file,*) '/proc/', trim(adjustl(cpid)), '/status'

open(1, file=trim(adjustl(status_file)), action='read')
rewind 1
do while(.true.)
   read(1,*,end=999) c1, c2
   if(c1(1:6) .eq. 'VmHWM:') then
      read(c2,*) imemsize
      exit
   end if
end do

999 continue

close(1)

mb = dble(imemsize) / 1024.d0 ! with MB

!print '(1x,a,f10.3)', 'Memory Usage[MB]: ', mb
write(nfout, '(1x,a,f10.3)') 'Memory Usage[MB]: ', mb

return
end subroutine memsize

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  MODULE: m_FFT
!
!  AUTHOR(S): T. Yamasaki, K. Betsuyaku,   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!                                   , March/14/2005, April/10/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!

  type(DFTI_DESCRIPTOR), POINTER :: dh_WF, dh_CD 
  type(mklfft_rdh) :: rdh_WF, rdh_CD
  integer :: strides(4), Status

  ! ------- Positron start 
  type(DFTI_DESCRIPTOR), POINTER :: dh_pWF
  type(mklfft_rdh) :: rdh_pWF
  ! ------- Positron end

  integer :: sw_avoiding_odd_fftbox = OFF
  integer :: sw_zero_padding = OFF

!  include 'mpif.h'
contains

  subroutine m_FFT_alloc_WF_work
  end subroutine m_FFT_alloc_WF_work

  subroutine m_FFT_alloc_pWF_work()
  end subroutine m_FFT_alloc_pWF_work

  subroutine m_FFT_dealloc_WF_work
  end subroutine m_FFT_dealloc_WF_work

  subroutine m_FFT_alloc_CD_box
    integer :: istat
    if(sw_mpifft == OFF) then
       allocate(afft_CD(nfftp), stat=istat)
    end if
  end subroutine m_FFT_alloc_CD_box

  subroutine m_FFT_dealloc_CD_box
    integer :: istat
    if(sw_mpifft == OFF) then
       deallocate(afft_CD, stat=istat)
    end if
  end subroutine m_FFT_dealloc_CD_box

  subroutine m_FFT_setup(inversion_symmetry,paramset)
    integer, intent(in) :: inversion_symmetry
    logical, intent(in) :: paramset

    integer :: ipad
    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_setup ',id_sname)

    if(inversion_symmetry == ON) then  ! kimg == 1
       ipad = 2
    else if(inversion_symmetry == OFF) then ! kimg == 2
       ipad = 1
    end if
! --- fft_box_size_WF, fft_box_size_pWF ---
    fft_box_size_WF(1,0) = fft_box_size_WF(1,1) + ipad
    fft_box_size_WF(2:3,0) = fft_box_size_WF(2:3,1)
    if(sw_positron /= OFF) then
       fft_box_size_pWF(1,0)   = fft_box_size_pWF(1,1) + ipad
       fft_box_size_pWF(2:3,0) = fft_box_size_pWF(2:3,1)
    end if

    nfft =   product(fft_box_size_WF(1:3,0)) * (2-inversion_symmetry)
! --- fft_box_size_CD ---
    fft_box_size_CD_nonpara(1,0)   = fft_box_size_CD(1,1) + ipad
    fft_box_size_CD_nonpara(2:3,0) = fft_box_size_CD(2:3,1)
    nfftp_nonpara  = product(fft_box_size_CD_nonpara(1:3,0)) * (2-inversion_symmetry)

    if(sw_mpifft == ON) then
       if(ipri >= 1) write(nfout,*) '!FFT_CD = MPIFFT <<m_FFT_setup>>'
       call set_mpifft_box_size_CD(inversion_symmetry) ! -> fft_box_size_CD, fft_box_size_CD_c, ny_d, nz_d, etc.
       nfftp  = product(fft_box_size_CD_c(1:3,0)) * (2-inversion_symmetry)
       nfftps = product(fft_box_size_CD(1:3,0)) * (2-inversion_symmetry)
    else
       fft_box_size_CD(1:3,0) = fft_box_size_CD_nonpara(1:3,0)
       fft_box_size_CD_c(1:3,0) = fft_box_size_CD(1:3,0)
       nfftp  = product(fft_box_size_CD(1:3,0)) * (2-inversion_symmetry)
       nfftps = nfftp
    end if

    if(ipri >= 1) call wd_FFTboxsizes(nfout)

    if(sw_positron /= OFF) &
         & nfft_pstrn = product(fft_box_size_pWF(1:3,0))*(2-inversion_symmetry)

    if(.not. paramset) then
! Initialization of the Wave-Function FFT
       call init_fft_coefficients_arrays_WF()

       if(sw_mpifft == OFF) then
! Initialization of the Charge-Density FFT
          call CDFFT_setup()
       end if
    endif

    call tstatc0_end(id_sname)
  contains
    subroutine init_fft_coefficients_arrays_WF()
      integer :: id, id_p

      if(kimg == 1) then
         call init_mkl_rfft(fft_box_size_WF(1,1) &
                         & ,fft_box_size_WF(2,1) &
                         & ,fft_box_size_WF(3,1) &
                         & ,fft_box_size_WF(1,0) &
                         & ,fft_box_size_WF(2,0) &
                         & ,fft_box_size_WF(3,0) &
                         & ,rdh_WF)
      else
         id = fft_box_size_WF(1,0)
         Status = DftiCreateDescriptor( dh_WF, DFTI_DOUBLE, &
                             & DFTI_COMPLEX, 3, fft_box_size_WF(1,1))
         strides(1) = 0
         strides(2) = 1
         strides(3) = id
         strides(4) = id*fft_box_size_WF(2,0)
         Status = DftiSetValue(dh_WF, DFTI_INPUT_STRIDES, strides)
         Status = DftiCommitDescriptor( dh_WF )
      end if
      if(sw_positron /= OFF) then
         if(kimg == 1) then
            call init_mkl_rfft(fft_box_size_pWF(1,1) &
                            & ,fft_box_size_pWF(2,1) &
                            & ,fft_box_size_pWF(3,1) &
                            & ,fft_box_size_pWF(1,0) &
                            & ,fft_box_size_pWF(2,0) &
                            & ,fft_box_size_pWF(3,0) &
                            & ,rdh_pWF)
         else
            id_p = fft_box_size_pWF(1,0)
            Status = DftiCreateDescriptor( dh_pWF, DFTI_DOUBLE, &
                     & DFTI_COMPLEX, 3, fft_box_size_pWF(1,1))
            strides(1) = 0
            strides(2) = 1
            strides(3) = id_p
            strides(4) = id_p*fft_box_size_pWF(2,0)
            Status = DftiSetValue(dh_pWF, DFTI_INPUT_STRIDES, strides)
            Status = DftiCommitDescriptor( dh_pWF )
         end if
      end if
    end subroutine init_fft_coefficients_arrays_WF

  end subroutine m_FFT_setup

  subroutine CDFFT_setup()

    call init_fft_coefficients_arrays_CD()
    CD_setup_is_done = YES
  contains
    subroutine init_fft_coefficients_arrays_CD
      integer :: id

   !  ---> FFT for Charge density
      if(kimg == 1) then
         call init_mkl_rfft(fft_box_size_CD(1,1) &
                         & ,fft_box_size_CD(2,1) &
                         & ,fft_box_size_CD(3,1) &
                         & ,fft_box_size_CD_nonpara(1,0) &
                         & ,fft_box_size_CD_nonpara(2,0) &
                         & ,fft_box_size_CD_nonpara(3,0) &
                         & ,rdh_CD)
      else
         id = fft_box_size_CD_nonpara(1,0)
         Status = DftiCreateDescriptor( dh_CD, DFTI_DOUBLE, &
                             & DFTI_COMPLEX, 3, fft_box_size_CD(1,1))
         strides(1) = 0
         strides(2) = 1
         strides(3) = id
         strides(4) = id*fft_box_size_CD_nonpara(2,0)
         Status = DftiSetValue(dh_CD, DFTI_INPUT_STRIDES, strides)
         Status = DftiCommitDescriptor( dh_CD )
      end if
    end subroutine init_fft_coefficients_arrays_CD
  end subroutine CDFFT_setup

  subroutine m_FFT_WF(electron_or_positron,nfout,afft,inverse_or_direct,switch)  ! G space --> R space
    integer, intent(in)          :: electron_or_positron
    integer, intent(in)          :: nfout
    real(kind=DP), intent(inout) :: afft(nfft)
    integer, intent(in)          :: inverse_or_direct
    integer, intent(in)          :: switch

    integer :: id_sname = -1

    if(electron_or_positron == ELECTRON) then
       call tstatc0_begin('m_FFT_WF ',id_sname)
    else if(electron_or_positron == POSITRON) then
       call tstatc0_begin('m_FFT_pWF ',id_sname)
    end if

    if(electron_or_positron == ELECTRON) then
       if(inverse_or_direct == DIRECT) then
          if(kimg == 1) then
             call mkl_rfft(1,rdh_WF,afft)
          else
             Status = DftiComputeForward( dh_WF, afft)
          end if
       else
          if(kimg == 1) then
             call mkl_rfft(-1,rdh_WF,afft)
          else
             Status = DftiComputeBackward( dh_WF, afft)
          end if
       end if
    else if(electron_or_positron == POSITRON) then
       if(inverse_or_direct == DIRECT) then
          if(kimg == 1) then
             call mkl_rfft(1,rdh_pWF,afft)
          else
             Status = DftiComputeForward( dh_pWF, afft)
          end if
       else
          if(kimg == 1) then
             call mkl_rfft(-1,rdh_pWF,afft)
          else
             Status = DftiComputeBackward( dh_pWF, afft)
          end if
       end if
    end if

    call tstatc0_end(id_sname)
  end subroutine m_FFT_WF

  subroutine fft_CD_inverse_core(afft_CD)
    real(kind=DP),intent(inout),dimension(nfftp_nonpara) :: afft_CD

    if(kimg == 1) then
       call mkl_rfft(-1,rdh_CD,afft_CD)
    else
       Status = DftiComputeBackward( dh_CD, afft_CD)
    end if
  end subroutine fft_CD_inverse_core

  subroutine fft_CD_direct_core(afft_CD)
    real(kind=DP),intent(inout),dimension(nfftp_nonpara) :: afft_CD
    if(kimg == 1) then
       call mkl_rfft(1,rdh_CD,afft_CD)
    else
       Status = DftiComputeForward( dh_CD, afft_CD)
    end if
  end subroutine fft_CD_direct_core
  ! --------------------------

!#undef NEC_TIMER
!#ifdef NEC_TIMER
!#  define START_TIMER(a) call start_timer(a)
!#  define STOP_TIMER(a)  call stop_timer(a)
#ifdef FJ_TIMER_RMM
#  define START_TIMER(a) call timer_sta(a)
#  define STOP_TIMER(a)  call timer_end(a)
#else
#  define START_TIMER(a)
#  define STOP_TIMER(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 581 $)
!
!  MODULE: m_ES_WF_by_RMM
!
!  AUTHOR(S): T. Yamasaki, T. Uda   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004, June/04/2005
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifndef SX
#define DGEMM__       DGEMM
#endif

#ifndef NO_NONLOCAL_RMM_DGEMM
#define NONLOCAL_RMM_DGEMM
#endif

module m_ES_WF_by_RMM
! This module was coded by T. Yamasaki and T. Uda, 1998-2003
!
! previous Id: m_ES_WF_by_RMM.f90,v 1.6 2003/09/16 03:15:32 yamasaki Exp
! $Id: m_ES_WF_by_RMM.F90 581 2018-08-01 08:38:42Z jkoga $
!
#ifdef MPI_FFTW
  use, intrinsic :: iso_c_binding
#endif
  use m_Electronic_Structure,only : zaj_l, afft,bfft, eko_l,vnlph_l,vlhxcQ, occup_l &
#ifdef SAVE_FFT_TIMES
 &                                , status_saved_phifftr &
#endif
       &                          , m_ES_alloc_fft_related &
       &                          , m_ES_dealloc_fft_related &
       &                          , m_ES_wd_zaj_small_portion_3D &
       &                          , m_ES_WF_2D &
       &                          , hlocphi_l, m_ES_init_chgsoft, m_ES_dealloc_chgsoft
  use m_ES_nonlocal,         only : m_ES_Vnonlocal_W_3D,m_ES_betar_dot_WFs_4_each_k_3D
  use m_ES_ortho            ,only : m_ES_MGS_4_each_k
  use m_ES_WF_by_SDorCG,     only : m_ESsd_diff_WFs_to_zaj_old
  use m_NonLocal_Potential,  only : snl
  use m_PlaneWaveBasisSet,   only : kg1,kgp,nbmx,iba, igf, nbase, ngabc &
       &                          , m_pwBS_find_min_max_G, m_pwBS_kinetic_energies
  use m_PseudoPotential,     only : ilmt, lmtt, lmta, ltp, mtp &
       &                          , q, dion, nlmta1, nlmta2, modnrm, nac, fqwei, nlmta &
       &                          , m_PP_include_vanderbilt_pot &
       &                          , ipaw,dion_paw
  use m_Kpoints,             only : kv3,vkxyz, k_symmetry
  use m_Ionic_System,        only : ntyp,natm,ityp,iwei,pos
  use m_FFT,                 only : fft_box_size_WF
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,  only : nspin,iprirmm,imGSrmm, rr_Critical_Value, printable &
       &                          , rmm_save_memory_mode, rmm_precal_phase_matm,kimg,neg,af &
       &                          , sw_retard_eigval_evaluation,sw_precalculate, potential_update &
       &                          , sw_serial_fft &
       &                          , sw_gep &
#ifdef MPI_FFTW
       &                          , sw_mpi_fftw &
#endif
       &                          , sw_keep_hloc_phi &
       &                          , sw_reduce_fft_for_charge &
       &                          , delta_residual_occup, delta_residual_empty &
#ifdef SAVE_FFT_TIMES
       &                          , sw_hybrid_functional, sw_fef, sw_fft_xzy, sw_save_fft
#else
       &                          , sw_hybrid_functional, sw_fef, sw_fft_xzy
#endif
  use m_IterationNumbers,    only : iteration_electronic, iteration_rmm_start, iteration, nk_in_the_process
  use m_Const_Parameters,    only : DP,CMPLDP,DIRECT,ON,OFF,SKIP,EXECUT,RMM2,RMM2P,RMM3,PAI2 &
       &                          , ORTHONORMALIZATION, NORMALIZATION, OVER,UNDER, GAMMA &
       &                          , SmallestPositiveNumber, ELECTRON, OLD
  use m_Parallelization,     only : MPI_CommGroup &
       &                          , myrank_k,map_k,ista_e,iend_e,istep_e,np_e,map_z,ierr,npes &
       &                          , ista_k,iend_k, ista_spin, iend_spin
  use m_Electronic_Structure,only : neordr, nrvf_ordr, m_ES_decide_precon_factor_3D
  use m_Parallelization,     only : np_g1k, ista_g1k, iend_g1k, neg_g, mpi_ke_world &
                                  , ista_k, iend_k, mpi_kg_world
! === This should be modified after zaj_old is 3D-decomposed!!! by T.Kato ======
  use m_ES_WF_by_SDorCG,     only : zaj_old  &
                                  , m_ESsd_copy_zaj_old_to_zaj, m_ESsd_copy_phi_to_zaj_old
! ==============================================================================
  use m_PlaneWaveBasisSet,   only : ngabc_kngp_l, ngabc_kngp_B_l, kg
#ifdef NEC_TIMER
  use nec_timer
#endif
! === FFT Marge. by T.Kato ===============================================================
  use m_Parallelization,     only : nel_fft_x , nel_fft_y, nel_fft_z &
                                  , fft_X_x_nel, fft_X_y_nel, fft_X_z_nel &
                                  , mp_g1k, myrank_g
  use m_Electronic_Structure,only : m_ES_Vlocal_in_Rspace_3D, m_ES_WF_in_Rspace_3D &
                                  , vlhxc_l, vtau_l
  use m_FFT,                 only : m_FFT_Vlocal_W_3D, m_FFT_Direct_3D           &
#ifdef FFT_3D_DIVISION
 &                                , m_FFT_Vlocal_W_3DIV_3D, m_FFT_Direct_3DIV_3D &
#endif
 &                                , m_FFT_Direct_XYZ_3D
#ifdef MPI_FFTW
  use m_ES_WF_by_SDorCG,     only : map_fft_to_WF_3D, gen_fft_to_WF_map
  use m_Electronic_Structure, only : m_ES_fftbox_map
#else
  use m_ES_WF_by_SDorCG,     only : map_fft_to_WF_3D
#endif
! ========================================================================================
! === Marge to Riken Source by T.Kato ====================================================
  use m_Electronic_Structure,only : m_ES_decide_precon_factor_3D &
                                  , m_ES_eigen_values_for_each_k_3D &
                                  , fsr_l, fsi_l, zaj_ball, fsr_l_2D, fsi_l_2D &
                                  , nblocksize_mgs_default &
                                  , m_ES_gather_f_3d_to_2d_blk
! ========================================================================================
  use m_ES_ExactExchange,    only : m_ES_EXX_eigenvalue_for_each_k &
       &                          , m_ES_EXX_gather_valence_states, m_ES_EXX_cp_eigenvalue &
       &                          , m_ES_Vexx_add_vexx &
       &                          , m_ES_Vexx_W
  use m_FiniteElectricField, only : m_FEF_build_grad, m_FEF_add_grad_to_vnlph &
       &                          , m_FEF_add_grad_to_vnlph_RMM


! ====================================== added by K. Tagami ============= 11.0
  use m_Control_Parameters,  only : noncol, ndim_spinor, ndim_chgpot, SpinOrbit_mode, &
       &                            sw_hubbard
  use m_Const_Parameters,    only : Neglected, BuiltIn
  use m_PseudoPotential,     only : q_noncl, dion_scr_noncl, fqwei_noncl
! ======================================================================= 11.0
#ifdef MPI_FFTW
  use m_Electronic_Structure,only : m_ES_Vlocal_in_Rspace_mpifftw3d, m_ES_WF_in_Rspace_mpifftw &
                                  , m_ES_eigen_values_for_each_k_mpifftw3d, m_ES_eigen_values_for_each_k_mpifftw
  use m_FFT,                 only : m_FFT_Vlocal_W_mpifftw3d, m_FFT_Direct_MPI_FFTW, afft_mpifftw_vlocal
  use m_ES_WF_by_SDorCG,     only : map_fft_to_WF_mpifftw
#endif

  use m_Control_Parameters,  only : use_metagga, vtau_exists
  use m_ES_WF_by_SDorCG,     only : m_ES_contrib_kindens_to_vnlph, &
       &                            m_ES_kindens_to_vnlph_ib, m_ES_kindens_to_vnlph_ib2
#ifdef MPI_FFTW
  use m_ES_WF_by_SDorCG,     only : m_ES_con_kindens_to_vnlph_mpfw, &
       &                            m_ES_kindens_to_vnlph_ib_mpfw, &
       &                            m_ES_kindens_to_vnlph_ib2_mpfw
#endif
  use mpi


  implicit none

  real(kind=DP), private,allocatable,dimension(:,:)     :: zfc1,zfc2,zfc3
  real(kind=DP), private,allocatable,dimension(:,:)     :: zfs1,zfs2,zfs3
  real(kind=DP), private,allocatable,dimension(:,:)     :: phasec,phases
  integer,       private,allocatable,dimension(:,:,:)   :: nglist
  integer,       private,pointer,dimension(:,:)     :: nngabc
  integer,       private,pointer,dimension(:)       :: newp
  real(kind=DP), private,allocatable,dimension(:,:,:) :: bWr, bWi
  real(kind=DP), private,pointer,dimension(:)       :: ekin0
  real(kind=DP), private,pointer,dimension(:,:,:,:) ::      phi  ! d(kg1,kimg,n,0:nrmm-2)
  real(kind=DP), private,allocatable,dimension(:,:,:,:) ::  Rphi ! d(kg1,kimg,n,0:nrmm-2)
  real(kind=DP), private,allocatable,dimension(:,:,:,:) ::  rr_e, psp_e  ! d(0:nrmm-1,0:nrmm-1,n,kimg),
  !                                                      ( n={1(rmm_save_memory_mode)|np_e(otherwise)})

! ============================== added by K. Tagami ===================== 11.0
  real(kind=DP), private,pointer,dimension(:,:,:,:,:) ::      phi_noncl
                                                 ! d(kg1,kimg,n,0:nrmm-2,ndim_spinor)
  real(kind=DP), private,allocatable,dimension(:,:,:,:,:) ::  Rphi_noncl
                                                 ! d(kg1,kimg,n,0:nrmm-2,ndim_spinor)
  real(kind=DP), private,allocatable,dimension(:,:,:,:) :: bWr_noncl, bWi_noncl
! ======================================================================= 11.0

  integer,       private,        dimension(2)       :: pm = (/1,-1/)

  real(kind=DP), private                            :: rr_avr = 0.d0
  integer, private,allocatable,dimension(:,:)     :: rr_is_over_or_under

  integer,       private,save                       :: ng_max = 0, ng_min = 0 !

!   1. m_ESrmm_reset_ng_maxmin     <-(Renewal_of_WaveFunctions)
!   2. m_ESrmm_reset_r_norm_flag    <-(Renewal_of_WaveFunctions)
!   3. alloc_zfc_zfs     <-(9)
!   4. dealloc_zfc_zfs   <-(9)
!   5. alloc_phasecs_bW_phi_Rphi   <-(9)
!   6. dealloc_phasecs_bW_phi_Rphi <-(9)
!   7. alloc_bW_phi_Rphi           <-(9)
!      - sub_error1, - sub_error2
!   8. dealloc_bW_phi_Rphi         <-(9)
!      - sub_error1
!   9. m_ESrmm_renew_WF             <-(Renewal_of_WaveFunctions)
!      - orthonorm_or_norm, - zajold2zaj_phi2zaj_old_all, - zajold2zaj_phi2zaj_old
!      - rr_avr_final,
!      - what_is_the_dimension_of_rmm, - rmm1, - rmm_n, - evolve_WF_using_Residuals,
!      - wd_rr_and_psp, - wd_alpha, - rmm_n_uda, - rg_or_cg,
!      - solveAYB, - LUdecomp, - rr_and_psp_from_Rphi_and_phi, - phsphn,
!      - normalization_of_rr_and_psp, - set_phase_pointer, - zf_listing
!  10. Vnonlocal_W_RMM       <-(9)
!      - alloc_zfsincos_arai, - dealloc_zfsincos_arai, - alloc_scssqcqs,
!      - dealloc_scssqcqs,    - calc_phase_RMM,  - Vnonlocal_W_part_sum_over_lmt1
!      - sumset_rmm,   - add_vnlph_l_without_eko_part1, - add_vnlph_l_with_eko_part1
!  11. Vnonlocal_W_RMMn      <-(9)
!      - alloc_scssqcqs_x, - dealloc_scssqcqs_x, - find_max_n_ialist0, - sumset_rmm_all3
!      - add_vnlph_l_without_eko_part3, -add_vnlph_l_with_eko_part3
!      - Vnonlocal_W_part_sum_over_lmt1b

#ifdef MPI_FFTW
  include 'fftw3-mpi.f03'
#endif
!  include 'mpif.h'

contains

  subroutine m_ESrmm_reset_ng_maxmin()
    ! this subroutine is called when
    ! (icond == FIXED_CHARGE or icond == FIXED_CHARGE_CONTINUATION)
    ! and iteration_rmm_start is set.
    ng_max = 0; ng_min = 0
  end subroutine m_ESrmm_reset_ng_maxmin

  subroutine m_ESrmm_dealloc_r_norm_flag
     if(allocated(rr_is_over_or_under)) deallocate(rr_is_over_or_under)
  end subroutine m_ESrmm_dealloc_r_norm_flag

  subroutine m_ESrmm_reset_r_norm_flag
    if(.not.allocated(rr_is_over_or_under)) allocate(rr_is_over_or_under(np_e,ista_k:iend_k))
    rr_is_over_or_under = OVER
  end subroutine m_ESrmm_reset_r_norm_flag

  subroutine alloc_zfc_zfs(nfout,n_min,n_max,matm_t,natm,nrmm,matm)
    integer, intent(inout), dimension(3) :: n_min, n_max
    integer, intent(in)                  :: nfout, matm_t, natm,nrmm
    integer, intent(out) :: matm

    matm = matm_t
    if(matm > natm) matm = natm
    if(matm < 0) matm = 0

! ========================================== modified by K. Tagami =========== 11.0
!    call m_pwBS_find_min_max_G(nfout,nspin,ng_max,ng_min,n_max,n_min)
!
    if ( noncol ) then
       call m_pwBS_find_min_max_G(nfout,ndim_spinor,ng_max,ng_min,n_max,n_min)
    else
       call m_pwBS_find_min_max_G(nfout,nspin,ng_max,ng_min,n_max,n_min)
    endif
! ============================================================================ 11.0

    if(iprirmm >= 2) then
       write(nfout,'(" !!rmm kg1, matm = ",2i6)') kg1,matm
       write(nfout,'(" !! matm+1, natm = ",2i8," <<alloc_zfc_zfs>>")') matm+1,natm
    end if

    if(matm+1 <= natm) then
       allocate(zfc1(n_min(1):n_max(1),matm+1:natm))
       allocate(zfc2(n_min(2):n_max(2),matm+1:natm))
       allocate(zfc3(n_min(3):n_max(3),matm+1:natm))
       allocate(zfs1(n_min(1):n_max(1),matm+1:natm))
       allocate(zfs2(n_min(2):n_max(2),matm+1:natm))
       allocate(zfs3(n_min(3):n_max(3),matm+1:natm))
    end if
  end subroutine alloc_zfc_zfs

  subroutine dealloc_zfc_zfs()
    if(iprirmm >= 2) write(6,'(" rmm_save_memory_mode = ",i6," <<dealloc_zfc_zfs>>")') rmm_save_memory_mode
    if(allocated(zfs1)) then
       deallocate(zfs1);    deallocate(zfs2);    deallocate(zfs3)
       deallocate(zfc1);    deallocate(zfc2);    deallocate(zfc3)
    end if
  end subroutine dealloc_zfc_zfs

  subroutine alloc_phasecs_bW_phi_Rphi_3D(nrmm,n_min,n_max,matm)
    integer, intent(in) :: nrmm
    integer, intent(in) :: n_min(3),n_max(3),matm

    allocate(nngabc(kg1,3))
    allocate(newp(kg1))
    allocate(phi(maxval(np_g1k),kimg,1,0:nrmm-2));  phi  = 0.d0
    allocate(Rphi(maxval(np_g1k),kimg,1,0:nrmm-2)); Rphi = 0.d0
    allocate(rr_e(0:nrmm-1,0:nrmm-1,1,kimg))
    allocate(psp_e(0:nrmm-1,0:nrmm-1,1,kimg))
    allocate(phasec(kg1,matm)); allocate(phases(kg1,matm))
    allocate(nglist(n_min(1):n_max(1),n_min(2):n_max(2),n_min(3):n_max(3)))
    allocate(bWr(nlmta,0:nrmm-1,1)); allocate(bWi(nlmta,0:nrmm-1,1))
  end subroutine alloc_phasecs_bW_phi_Rphi_3D

  subroutine dealloc_phasecs_bW_phi_Rphi_3D()
    deallocate(bWi); deallocate(bWr)
    deallocate(nglist)
    deallocate(phasec); deallocate(phases)
    deallocate(psp_e)
    deallocate(rr_e)
    deallocate(Rphi)
    deallocate(phi)
    deallocate(newp)
    deallocate(nngabc)
  end subroutine dealloc_phasecs_bW_phi_Rphi_3D

  subroutine alloc_bW_phi_Rphi_3D(nrmm)
    integer, intent(in) :: nrmm
    integer :: istat
    character*4 :: name
    if(iprirmm >= 3) then
       write(6,'(" !! nlmta,             nrmm, np_e = ",3i10," <<alloc_bW_phi_Rphi>>")') nlmta,nrmm,np_e
       write(6,'(" !! maxval(np_g1k), kimg, np_e = ",3i10," <<alloc_bW_phi_Rphi>>")') maxval(np_g1k),kimg,np_e
    end if

    allocate(bWr(nlmta,0:nrmm-1,np_e),stat=istat)
    if(istat /= 0) then
       name = "bWr "
       call sub_error1
    end if
    bWr = 0.d0

    allocate(bWi(nlmta,0:nrmm-1,np_e),stat=istat)
    if(istat /= 0) then
       name = "bWi"
       call sub_error1
    end if
    bWi = 0.d0

    allocate(Rphi(maxval(np_g1k),kimg,np_e,0:nrmm-2),stat=istat)
    if(istat /= 0) then
       name = "Rphi"
       call sub_error2
       call sub_error1
    else
       if(iprirmm >= 2) write(6,*) 'Allocation success for Rphi <<alloc_bW_phi_Rphi>>'
    end if
    Rphi = 0.d0

    allocate(phi(maxval(np_g1k),kimg,np_e,0:nrmm-2),stat=istat)
    if(istat /= 0) then
       name = "phi "
       call sub_error2
       call sub_error1
    else
       if(iprirmm >= 2) write(6,*) 'Allocation success for phi <<alloc_bW_phi_Rphi>>'
    end if
    phi = 0.d0

    allocate(rr_e(0:nrmm-1,0:nrmm-1,np_e,kimg));    rr_e = 0.d0
    allocate(psp_e(0:nrmm-1,0:nrmm-1,np_e,kimg));   psp_e = 0.d0
  contains
    subroutine sub_error1
      write(6,'(" Allocation error for ",a4," <<m_ES_WF_by_RMM.alloc_bW_phi_Rphi>>")') name
      write(6,*) 'stat = ',istat
      call phase_error_with_msg(6,'Allocation error <<m_ES_WF_by_RMM.alloc_bW_phi_Rphi>>',__LINE__,__FILE__)
    end subroutine sub_error1
    subroutine sub_error2
      write(6,'(" required allocation size = ",i10," maxval(np_g1k),kimg,np_e,nrmm = ",4i8)') &
         maxval(np_g1k)*kimg*np_e*nrmm,maxval(np_g1k),kimg,np_e,nrmm
    end subroutine sub_error2

  end subroutine alloc_bW_phi_Rphi_3D

  subroutine dealloc_bW_phi_Rphi_3D()
    integer :: istat
    character*4 :: name
    deallocate(psp_e)
    deallocate(rr_e)
    deallocate(phi, stat=istat)
    if(istat /= 0) then
       name = "phi "
       call sub_error1
    end if
    deallocate(Rphi, stat=istat)
    if(istat /= 0) then
       name = "Rphi"
       call sub_error1
    end if
    deallocate(bWi, stat=istat)
    if(istat /= 0) then
       name = "bWi "
       call sub_error1
    end if
    deallocate(bWr, stat=istat)
    if(istat /= 0) then
       name = "bWr "
       call sub_error1
    end if
  contains
    subroutine sub_error1
      write(6,'(" Deallocation error for ",a4,"<<m_ES_WF_by_RMM.dealloc_bW_phi_Rphi>>")') name
      write(6,*) 'stat =', istat
      call phase_error_with_msg(6,'Deallocation error <<m_ES_WF_by_RMM.dealloc_bW_phi_Rphi>>',__LINE__,__FILE__)
    end subroutine sub_error1
  end subroutine dealloc_bW_phi_Rphi_3D

  subroutine m_ESrmm_renew_WF(nfout,isolver,precon,dtim)
    integer,       intent(in) :: nfout,isolver,precon
    real(kind=DP), intent(in) :: dtim

    !  R   := -(H-eS)
    !  zaj_l(:,i,k,1:kimg) :=  | \Phi_{k,i} >
    !  phi (:,1:kimg,0)    :=  | \Phi_{k,i} >
    !  Rphi(:,1:kimg,0)    := R|\Phi_{k,i}>
    !  phi (:,1:kimg,1)    := KR |\Phi_{k,i}>
    !  Rphi(:,1:kimg,1)    := RKR|\Phi_{k,i}>
    ! when isolver == RMM3,
    !  phi (:,1:kimg,2)    := KRKR |\Phi_{k,i}>
    !  Rphi(:,1:kimg,2)    := RKRKR|\Phi_{k,i}>
    ! when isolver == RMM2P,
    !  phi (:,1:kimg,2)    := |\Phi^{-1}_{k,i}> = |\Phi^{m}_{k,i}> - |\Phi^{m-1}_{k,i}>
    !  Rphi(:,1:kimg,2)    := R|\Phi^{-1}_{k,i}>
    !
    ! output
    !  zaj_l := |\Psi^{m+1}_{k,i}>
    !         = \alpha_0 phi(:,:,0) + \alpha_1 phi(:,:,1) + \alpha_2 phi(:,:,2)
    ! where,
    !  K is preconditioning operator,
    !  alpha_0,alpha_1, and alpha_2 are decided from <Rphi_i|Rphi_j> and <phi_i|S|phi_j>
    !
    ! For details, refer to G. Kresse and J. Furthmuller, PRB54,11169,(1996)
    ! The procedure in a case of isolver == RMM2P has been developped originally by T. Uda.
    !

! === Debug!!! These arrays should be saved for alloc_zfc_zfs call!!! by T.Kato ==========
!   integer :: n_max(3), n_min(3)
    integer, save :: n_max(3) = 0, n_min(3) = 0
! ========================================================================================
    integer :: ispin,ik,ib,iter_rmm, nrmm, matm,iilmt
    real(kind=DP), pointer, dimension(:)   :: ekin
    real(kind=DP), pointer, dimension(:,:) :: phi0
    real(kind=DP), allocatable,dimension(:,:,:) :: vxw_exx
    integer :: id_sname = -1
    real(kind=DP) :: exx
    integer :: ng
    integer :: iup
    logical :: store_e
    integer :: ig
    real(kind=DP) :: c1
    real(kind=DP), allocatable :: vtau_phl(:,:)

! === FFT Marge. by T.Kato ===============================================================
    integer :: lsize, ibsize, isrsize, fft_l_size
    real(kind=DP), allocatable, dimension(:) :: afft_l, cfft_l
    real(kind=DP), allocatable, dimension(:,:) :: wk_bfft_l
    real(kind=DP), allocatable, dimension(:,:) :: bfft_l
    real(kind=DP), allocatable, dimension(:,:,:) :: cfft_mpifftw_vlocal
! ========================================================================================
! === Marge to Riken Source by T.Kato ====================================================
    real(kind=DP), pointer, dimension(:) :: ekin_l
! ========================================================================================
!!$    call tstatc0_begin('m_ESrmm_renew_WF ', id_sname,1)
    real(kind=DP), allocatable, dimension(:,:) :: fsr, fsi
#ifdef MPI_FFTW
    integer(C_INTPTR_T)  :: local_n, local_n_offset, alloc_local, lx, ly, lz, mx,my,mz
    integer :: nsize
#endif
    logical, allocatable, dimension(:) :: rconv
    integer, allocatable, dimension(:) :: nrmm_of_band

    rr_avr = 0.d0
    call what_is_the_dimension_of_rmm() ! -(contained here) ->nrmm(= 2 or 3)

    if(potential_update>0) sw_retard_eigval_evaluation = OFF

! === DEBUG by tkato 2011/07/12 ================================================
!   allocate(rr_is_over_or_under(np_e,ista_k:iend_k))
    if(.not.allocated(rr_is_over_or_under)) then
       allocate(rr_is_over_or_under(np_e,ista_k:iend_k))
       rr_is_over_or_under = OVER
    endif
! ==============================================================================

    call m_ES_alloc_fft_related()  ! afft, bfft, m_FFT_alloc_WF_work
    if(isolver==RMM2P.and.nrmm==3) call m_ESsd_diff_WFs_to_zaj_old(1.d0) !->zaj_old

    if(rmm_save_memory_mode == ON) then
       call alloc_zfc_zfs(nfout,n_min,n_max,rmm_precal_phase_matm,natm,nrmm,matm) ! -(m_ES_WF_by_RMM)
       call zf_listing()                     ! -(contained here) -> zfc1,zfc2,zfc3,zfs1,zfs2,zfs3
    end if

! ==============================================================================
START_TIMER(1601)
!fj$$F    do ispin = 1, nspin, af+1
! === FFT Marge. by T.Kato ===============================================================
!fj$$F       call decomp_vlhxc_l_3D(vlhxc_l,vlhxc_l_3D,ispin)
! ========================================================================================
!fj$$F       do ik = ispin, kv3-nspin+ispin, nspin
!fj$$F          if(map_k(ik) /= myrank_k) cycle
!fj$$F          call decomp_zaj_l_3D_ik(zaj_l,zaj_l_3D,ik,nrvf_ordr,"sort")
!fj$$F          call decomp_eko_l_3D_new(eko_l,eko_l_3D,ik,nrvf_ordr,"sort")
!fj$$F          call decomp_rr_is_over_or_under_3D(rr_is_over_or_under,rr_is_over_or_under_3D,ik,nrvf_ordr,"sort")
!fj$$F          call decomp_fsr_l_3D_ik(fsr_l,fsr_l_3D,ik,nrvf_ordr,"sort")
!fj$$F          if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!fj$$F             call decomp_fsr_l_3D_ik(fsi_l,fsi_l_3D,ik,nrvf_ordr,"sort")
!fj$$F          endif
! === This should be modified after zaj_old is 3D-decomposed!!! by T.Kato ======
!fj$$F          call decomp_zaj_l_3D_ik(zaj_old,zaj_old_3D,ik,nrvf_ordr,"sort")
! ==============================================================================
!fj$$F       enddo
!fj$$F    enddo
STOP_TIMER(1601)
! ==============================================================================
! === Marge to Riken Source by T.Kato ====================================================
    allocate(ekin0(maxval(np_g1k)))
    ekin_l => ekin0
! ========================================================================================
! === FFT Marge. by T.Kato ===============================================================
#ifdef FFT_3D_DIVISION
    lsize = fft_X_x_nel*fft_X_y_nel*fft_X_z_nel
    allocate(afft_l(lsize*2), stat=ierr)
    if ( use_metagga .and. vtau_exists ) allocate(cfft_l(lsize*2), stat=ierr)
#else
#ifdef MPI_FFTW
    lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
    if(sw_mpi_fftw==ON) then
      lx = fft_box_size_WF(1,0)
      ly = fft_box_size_WF(2,0)
      lz = fft_box_size_WF(3,0)
      if(kimg==2) then
        alloc_local = fftw_mpi_local_size_3d(ly,lz,lx,mpi_ke_world,local_n,local_n_offset)
        lsize = local_n*lx*lz
        allocate(afft_mpifftw_vlocal(lx,lz,local_n));afft_mpifftw_vlocal=0.d0
        if ( use_metagga .and. vtau_exists ) then
           allocate(cfft_mpifftw_vlocal(lx,lz,local_n));cfft_mpifftw_vlocal=0.d0
        endif
     else
        alloc_local = fftw_mpi_local_size_3d(ly,lz,lx,mpi_ke_world,local_n,local_n_offset)
        lsize = local_n*lx*lz
        allocate(afft_mpifftw_vlocal(lx,lz,local_n));afft_mpifftw_vlocal=0.d0
        if ( use_metagga .and. vtau_exists ) then
           allocate(cfft_mpifftw_vlocal(lx,lz,local_n));cfft_mpifftw_vlocal=0.d0
        endif
      endif
    endif
#else
    lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
#endif
    allocate(afft_l(lsize*kimg), stat=ierr)
    if ( use_metagga .and. vtau_exists ) allocate(cfft_l(lsize*kimg), stat=ierr)
#endif
    if(ierr /= 0) then
       write(nfout,*)' m_ESrmm_renew_WF : Not allocated afft_l array'
       call flush(nfout)
       call mpi_abort(mpi_comm_world, 201, ierr)
    endif
    ibsize = 1
    call m_ES_init_chgsoft(lsize*kimg)

    allocate(rconv(np_e))
    allocate(nrmm_of_band(np_e));nrmm_of_band = nrmm
!   if (nblocksize_fftw_is_given) then
!      ibsize = nblocksize_fftw
!      if (ibsize < 1) ibsize = 1
!   endif
! ========================================================================================
!    Loop_spin: do ispin = 1, nspin, af+1
    Loop_spin: do ispin = ista_spin, iend_spin, af+1
! === FFT Marge. by T.Kato ===============================================================
#ifdef MPI_FFTW
       if(sw_mpi_fftw==ON) then
          call m_ES_Vlocal_in_Rspace_mpifftw3d(ispin,lx,local_n,lz,afft_mpifftw_vlocal)
          if ( use_metagga .and. vtau_exists ) then
             call m_ES_Vlocal_in_Rspace_mpifftw3d( ispin, lx, local_n, lz, &
                  &                cfft_mpifftw_vlocal, vtau_l )
          endif
       else
          call m_ES_Vlocal_in_Rspace_3D(ispin,afft_l,lsize,1,OFF)      ! (ptfft1) vlhxc_l->afft
          if ( use_metagga .and. vtau_exists ) then
             call m_ES_Vlocal_in_Rspace_3D( ispin, cfft_l, lsize, 1, OFF, vtau_l ) ! r space
          endif
       endif
#else
       call m_ES_Vlocal_in_Rspace_3D(ispin,afft_l,lsize,1,OFF) ! (ptfft1) ->afft
       if ( use_metagga .and. vtau_exists ) then
          call m_ES_Vlocal_in_Rspace_3D( ispin, cfft_l, lsize, 1, OFF, vtau_l ) ! r space
       endif
#endif
! ========================================================================================
       Loop_kpoints: do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle              ! MPI
! === DEBUG by tkato 2011/09/12=================================================
          if (allocated(vnlph_l)) then
             if (size(vnlph_l,1) .ne. np_g1k(ik)) then
                deallocate(vnlph_l)
                allocate(vnlph_l(np_g1k(ik),np_e,kimg))
             endif
          else
             allocate(vnlph_l(np_g1k(ik),np_e,kimg))
          endif
! ==============================================================================
! === FFT Marge. by T.Kato ===============================================================
          isrsize = min(lsize,mp_g1k(ik))
#ifdef MPI_FFTW
          if(sw_mpi_fftw==ON) then
            fft_l_size  = lsize
            call gen_fft_to_WF_map(ik)
            call m_ES_fftbox_map(ik)
          else
            fft_l_size  = nel_fft_x(myrank_g)
          endif
#else
          fft_l_size  = nel_fft_x(myrank_g)
#endif
#ifdef FFT_3D_DIVISION
          allocate(wk_bfft_l(lsize*2   ,ibsize) ,stat=ierr)
          allocate(bfft_l(lsize*2   ,ibsize) ,stat=ierr)
#else
          allocate(wk_bfft_l(lsize*kimg,ibsize) ,stat=ierr)
          allocate(bfft_l(lsize*kimg,ibsize) ,stat=ierr)
#endif
          if (ierr /= 0) then
             write(nfout,*)' m_ESrmm_renew_WF :  Not allocate '
             call flush(nfout)
             call mpi_abort(mpi_comm_world, 205, ierr)
          endif
! ========================================================================================

          if(iprirmm >= 3 .and. printable) then
             call m_ES_wd_zaj_small_portion_3D(nfout,ik," -- rmm --",10)
          endif

          call m_pwBS_kinetic_energies(ik,vkxyz,ekin_l)! (diakin) ->ekin

          if(rmm_save_memory_mode == ON) then
             call alloc_phasecs_bW_phi_Rphi_3D(nrmm,n_min,n_max,matm) ! allocations of bWr, bWi, phi and Rphi. (bWr,bWi) = <\beta |WF=zaj_l>
             call pre_calc_phase !-(contained here) -> phasec,phases,newp

             Loop_band: do ib = 1, np_e ! MPI
                if(rr_is_over_or_under(ib,ik) == UNDER.and.sw_precalculate==OFF) cycle
                Loop_res_dim: do iter_rmm = 0, nrmm-1
START_TIMER(1602)
                   if(isolver == RMM2P .and. iter_rmm == nrmm-1) &
                        & call zajold2zaj_phi2zaj_old_3D !-(contained here) zaj_old->zaj, phi0 ->zaj_old
STOP_TIMER(1602)

START_TIMER(1603)
                   call Vnonlocal_W_RMM_3D(ik,ib,ispin,rmm_precal_phase_matm,iter_rmm)! ->vnlph_l,bWr,bWi
STOP_TIMER(1603)
! === Support Hybrid on 3D_Parallel by tkato 2013/02/10 ========================
!                   if(sw_hybrid_functional==ON) call m_ES_Vexx_W_RMM(ik,ib)
! ==============================================================================
                   if ( use_metagga .and. vtau_exists ) then
#ifdef MPI_FFTW
                      if ( sw_mpi_fftw == ON ) then
                         call m_ES_kindens_to_vnlph_ib_mpfw( ispin, ik, ib, lsize, &
                              &            lx, ly, lz, local_n, cfft_mpifftw_vlocal )
                      else
                         call m_ES_kindens_to_vnlph_ib( ispin, ik, ib, lsize, cfft_l )
                      endif
#else
                      call m_ES_kindens_to_vnlph_ib( ispin, ik, ib, lsize, cfft_l )
#endif
                   endif

START_TIMER(1604)
#ifdef __TIMER_COMM__
                   call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l,0)
#else
#ifdef MPI_FFTW
                   if(sw_mpi_fftw==ON) then
                     call m_ES_WF_in_Rspace_mpifftw(ista_k,iend_k,ik,ib,zaj_l)
                   else
                     call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l)
                   endif
#else
                   call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l)
#endif
#endif
#ifdef FFT_3D_DIVISION
                   call m_FFT_Vlocal_W_3DIV_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_x(myrank_g))
                   call m_FFT_Direct_3DIV_3D(nfout,wk_bfft_l,lsize,ibsize)
#else
#ifdef MPI_FFTW
                   if(sw_mpi_fftw==ON) then
                     nsize = local_n*lx*lz
                     call m_FFT_Vlocal_W_mpifftw3d(afft_mpifftw_vlocal,lx,local_n,lz)
                     call m_FFT_Direct_MPI_FFTW(nfout)
                   else
                     call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
                     call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
                   endif
#else
                   if (sw_fft_xzy > 0) then
                      call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_y(myrank_g))
                      call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
                   else
                      call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
                      if(sw_serial_fft == ON) then
                         call m_ES_WF_2D(ik,wk_bfft_l,ib,ib,ibsize,lsize,DIRECT)
                      else
                         call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
                      endif
                   endif
#endif
#endif
#ifdef MPI_FFTW
                   if(sw_mpi_fftw==ON) then
                     call map_fft_to_WF_mpifftw(ik,lsize,ibsize,bfft_l,isrsize,fft_l_size)
                   else
                     call map_fft_to_WF_3D(ik,lsize,ibsize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
                   endif
#else
                   call map_fft_to_WF_3D(ik,lsize,ibsize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
#endif
STOP_TIMER(1604)
START_TIMER(1605)
!                  call rmm1_3D(ib,iter_rmm,nrmm)     ! -(contained here)
                   call rmm1_3D(ib,iter_rmm,nrmm,bfft_l,lsize)     ! -(contained here)
STOP_TIMER(1605)
                   !          zaj_l,vnlph_l,ekin,eko_l,bfft -> zaj_l,phi,Rphi
                end do Loop_res_dim
START_TIMER(1606)
                call rmm_n_uda_3D(ik,ib,nrmm)       ! -(contained here) phi,Rphi ->zaj_l, nrmm = 2 or 3
STOP_TIMER(1606)
                !                       Residual norm is also checked (->rr_is_oever_or_under)
             end do Loop_band

             call dealloc_phasecs_bW_phi_Rphi_3D()
          else
             call alloc_bW_phi_Rphi_3D(nrmm) ! allocations of bWr, bWi, phi and Rphi. (bWr,bWi) = <\beta |WF=zaj_l>
             rconv = .false.
             Loop_res_dim_b: do iter_rmm = 0, nrmm-1
START_TIMER(1607)
                if(isolver == RMM2P .and. iter_rmm == nrmm-1) &
                     & call zajold2zaj_phi2zaj_old_all_3D !-(contained here) zaj_old->zaj, phi0 ->zaj_old, if rr_is_over_or_under /= UNDER
STOP_TIMER(1607)

#ifdef RMM_NONLOCAL_NEW
                allocate(fsr(np_e,nlmta))
                if(k_symmetry(ik) /= GAMMA) allocate(fsi(np_e,nlmta))
                if(iter_rmm>0) call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik)
                call m_ES_gather_f_3d_to_2d_blk(fsr_l, fsr, ik, np_e, 1, np_e)
                if( k_symmetry(ik) /= GAMMA ) then
                   call m_ES_gather_f_3d_to_2d_blk(fsi_l, fsi, ik, np_e, 1, np_e)
                endif
                do ib=1,np_e
                  do iilmt=1,nlmta
                    bWr(iilmt,iter_rmm,ib) = fsr(ib,iilmt)
                    if( k_symmetry(ik) /= GAMMA) bWi(iilmt,iter_rmm,ib) = fsi(ib,iilmt)
                  enddo
                enddo
                deallocate(fsr)
                if(k_symmetry(ik) /= GAMMA) deallocate(fsi)
                call m_ES_Vnonlocal_W_3D(ik,(ik-1)/nspin+1,ispin,ON)
#else
START_TIMER(1608)
                call Vnonlocal_W_RMMn_3D(nfout,ik,ispin,iter_rmm)! ->vnlph_l,bWr,bWi
STOP_TIMER(1608)
#endif
                if(sw_hybrid_functional==ON) &
                &  call m_ES_Vexx_W(ik,2,store_exxp=iter_rmm==0)

                if ( use_metagga .and. vtau_exists ) then
#ifdef MPI_FFTW
                   if ( sw_mpi_fftw == ON ) then
                      call m_ES_con_kindens_to_vnlph_mpfw( ispin, ik, lsize, &
                           &                lx, ly, lz, local_n, cfft_mpifftw_vlocal )
                   else
                      call m_ES_contrib_kindens_to_vnlph( ispin, ik, lsize, cfft_l )
                   endif
#else
                   call m_ES_contrib_kindens_to_vnlph( ispin, ik, lsize, cfft_l )
#endif
                endif

                do ib = 1, np_e
                   if(rr_is_over_or_under(ib,ik) == UNDER.and.sw_precalculate==OFF) cycle
                   if(nrmm_of_band(ib)==2 .and. iter_rmm==2) cycle
                   if(iter_rmm>0 .or. sw_keep_hloc_phi==OFF) then
START_TIMER(1609)
#ifdef __TIMER_COMM__
                     call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l,0)
#else
#ifdef MPI_FFTW
                     if(sw_mpi_fftw==ON) then
                       call m_ES_WF_in_Rspace_mpifftw(ista_k,iend_k,ik,ib,zaj_l)
                     else
                       call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l)
                     endif
#else
                     call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l)
#endif
#endif
#ifdef FFT_3D_DIVISION
                     call m_FFT_Vlocal_W_3DIV_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_x(myrank_g))
                     call m_FFT_Direct_3DIV_3D(nfout,wk_bfft_l,lsize,ibsize)
#else
#ifdef MPI_FFTW
                     if(sw_mpi_fftw==ON) then
                       nsize = local_n*lx*lz
                       call m_FFT_Vlocal_W_mpifftw3d(afft_mpifftw_vlocal,lx,local_n,lz)
                       call m_FFT_Direct_MPI_FFTW(nfout)
                     else
                       call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
                       call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
                     endif
#else
                     if (sw_fft_xzy > 0) then
                        call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_y(myrank_g))
                        call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
                     else
                        call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
                        if(sw_serial_fft == ON) then
                           call m_ES_WF_2D(ik,wk_bfft_l,ib,ib,ibsize,lsize,DIRECT)
                        else
                           call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
                        endif
                     endif
#endif
#endif
#ifdef MPI_FFTW
                     if(sw_mpi_fftw==ON) then
                       call map_fft_to_WF_mpifftw(ik,lsize,ibsize,bfft_l,isrsize,fft_l_size)
                     else
                       call map_fft_to_WF_3D(ik,lsize,ibsize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
                     endif
#else
                     call map_fft_to_WF_3D(ik,lsize,ibsize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
#endif
STOP_TIMER(1609)
START_TIMER(1610)
                   endif
!                  call rmm1_3D(ib,iter_rmm,nrmm)     ! -(contained here)
                   call rmm1_3D(ib,iter_rmm,nrmm,bfft_l,lsize)     ! -(contained here)
STOP_TIMER(1610)
                      !          zaj_l,vnlph_l,ekin,eko_l,bfft -> zaj_l,phi,Rphi
                end do
             end do Loop_res_dim_b

             Loop_band_b: do ib = 1, np_e
                !!$if(rr_is_over_or_under(map_z(ib),ik) == UNDER) cycle
                !! rewrote for ifort on em64t 2006/4/19 T.Yamamoto
START_TIMER(1611)
                if(rr_is_over_or_under(ib,ik) /= UNDER) &
                   & call rmm_n_uda_3D(ik,ib,nrmm)       ! -(contained here) phi,Rphi ->zaj_l, nrmm = 2 or 3
STOP_TIMER(1611)
                !                       Residual norm is also checked (->rr_is_oever_or_under)
             end do Loop_band_b

             call dealloc_bW_phi_Rphi_3D()
          end if

!!$#ifdef SAVE_FFT_TIMES
!!$          do ib = 1, np_e
!!$             status_saved_phifftr(ib,ik) = OLD
!!$          end do
!!$#endif


!!$          call m_ES_betar_dot_WFs_4_each_k(nfout,ik)   !  -> fsr_l,fsi_l

!!$          call orthonorm_or_norm_3D(imGSrmm)  !-(contained here)
          call orthonorm_or_norm(imGSrmm)  !-(contained here)

          if(sw_hybrid_functional==ON) then
             if(sw_retard_eigval_evaluation==ON) then
                call m_ES_EXX_cp_eigenvalue(ik)
             else
                call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,iupdate=0)
             endif
          endif
#ifdef MPI_FFTW
          if(sw_mpi_fftw==ON) then
!            call m_ES_eigen_values_for_each_k_mpifftw(ispin,ik,ekin_l,afft_mpifftw_vlocal,lsize)
            call m_ES_eigen_values_for_each_k_mpifftw3d(ispin,ik,lx,local_n,lz,ekin_l,afft_mpifftw_vlocal, &
                                                        eval_charge=sw_reduce_fft_for_charge==ON)
          else
            call m_ES_eigen_values_for_each_k_3D(ispin,ik,ekin_l,afft_l,lsize,eval_charge=sw_reduce_fft_for_charge==ON)
          endif
#else
          call m_ES_eigen_values_for_each_k_3D(ispin,ik,ekin_l,afft_l,lsize,eval_charge=sw_reduce_fft_for_charge==ON)
#endif

          if ( use_metagga .and. vtau_exists ) then
             allocate( vtau_phl( maxval(np_g1k),kimg ) )
             Do ib=1, np_e
#ifdef MPI_FFTW
                if ( sw_mpi_fftw == ON ) then
                   call m_ES_kindens_to_vnlph_ib2_mpfw( ispin, ik, ib, lsize, &
                        &               lx, ly, lz, local_n, cfft_mpifftw_vlocal, &
                        &               vtau_phl )
                else
                   call m_ES_kindens_to_vnlph_ib2( ispin, ik, ib, lsize, cfft_l, &
                        &                          vtau_phl )
                endif
#else

                call m_ES_kindens_to_vnlph_ib2( ispin, ik, ib, lsize, cfft_l, vtau_phl )
#endif

                c1 = 0.0d0
                Do ig=1, np_g1k(ik)
                   c1 = c1 +vtau_phl(ig,1) *zaj_l(ig,ib,ik,1) &
                        &  +vtau_phl(ig,2) *zaj_l(ig,ib,ik,2)
                End Do
                call mpi_allreduce( MPI_IN_PLACE, c1, 1, mpi_double_precision, &
                     &              mpi_sum, mpi_ke_world, ierr)
                eko_l(ib,ik) = eko_l(ib,ik) +c1
             ENd Do
             deallocate( vtau_phl )
          endif

! === FFT Marge. by T.Kato ===============================================================
          deallocate(wk_bfft_l)
          deallocate(bfft_l)
! ========================================================================================
       end do Loop_kpoints
    end do Loop_spin

    if ( allocated(cfft_l) ) deallocate( cfft_l )
    if ( allocated(cfft_mpifftw_vlocal) ) deallocate( cfft_mpifftw_vlocal )

    if(sw_hybrid_functional==ON.and.sw_retard_eigval_evaluation==ON)then
       call m_ES_EXX_gather_valence_states(nfout)
       do ispin=1,nspin,af+1
          do ik=ispin, kv3+ispin-nspin, nspin
             if(map_k(ik) /= myrank_k) cycle ! MPI
             call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,update_eko=.false.,iupdate=2)
          enddo
       enddo
    endif
! === FFT Marge. by T.Kato ===============================================================
    deallocate(afft_l)
! ==============================================================================
#ifdef MPI_FFTW
    if(sw_mpi_fftw==ON) deallocate(afft_mpifftw_vlocal)
#endif
    deallocate(rconv)
    deallocate(nrmm_of_band)
START_TIMER(1612)
!fj$$F    do ispin = 1, nspin, af+1
!fj$$F       do ik = ispin, kv3-nspin+ispin, nspin
!fj$$F          if(map_k(ik) /= myrank_k) cycle
!fj$$F          call decomp_zaj_l_r_3D_ik(zaj_l,zaj_l_3D,ik,neordr,"sort")
!fj$$F          call decomp_rr_is_over_or_under_r_3D(rr_is_over_or_under,rr_is_over_or_under_3D,ik,neordr,"sort")
!fj$$F          call decomp_eko_l_r_3D_new(eko_l,eko_l_3D,ik,neordr,"sort")
!fj$$F          call decomp_fsr_l_r_3D_ik(fsr_l,fsr_l_3D,ik,neordr,"sort",0)
!fj$$F          if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!fj$$F             call decomp_fsr_l_r_3D_ik(fsi_l,fsi_l_3D,ik,neordr,"sort",0)
!fj$$F          endif
!fj$$F          call replacement_zaj_ball_sequence(zaj_ball,ik,neordr,nblocksize_mgs_default)
! === This should be modified after zaj_old is 3D-decomposed!!! by T.Kato ======
!fj$$F          call decomp_zaj_l_r_3D_ik(zaj_old,zaj_old_3D,ik,neordr,"sort")
! ==============================================================================
!fj$$F       enddo
!fj$$F    enddo
STOP_TIMER(1612)
! ==============================================================================

    if(rmm_save_memory_mode == ON) call dealloc_zfc_zfs()

    call rr_avr_final_3D !-(c.h.)  rr_avr = rr_avr/(kv3*neg)

    deallocate(ekin0)

    call m_ES_dealloc_fft_related()

!    deallocate(rr_is_over_or_under)
!!$    call tstatc0_end(id_sname)
#ifdef fj_dump
  call dump_zaj(zaj_l)
#endif
  contains
    subroutine orthonorm_or_norm(imGSrmm_t)
      integer, intent(in) :: imGSrmm_t
      if(mod(iteration_electronic - iteration_rmm_start, imGSrmm_t) == 0) then
         if(sw_gep == ON)then
            if(iprirmm >= 2 .and. ik == 1) write(nfout,'(" -- NORMALIZATION --")')
            call m_ES_MGS_4_each_k(nfout,ik,mode=NORMALIZATION)
         else
            if(iprirmm >= 2 .and. ik == 1) write(nfout,'(" -- ORTHONORMALIZATION --")')
            call m_ES_MGS_4_each_k(nfout,ik,mode=ORTHONORMALIZATION)
         endif
      else
         if(iprirmm >= 2 .and. ik == 1) write(nfout,'(" -- NORMALIZATION --")')
         call m_ES_MGS_4_each_k(nfout,ik,mode=NORMALIZATION)
      end if
#ifdef SAVE_FFT_TIMES
      if(sw_save_fft == ON) status_saved_phifftr(:,ik) = OLD
#endif
    end subroutine orthonorm_or_norm
!!$!BRANCH_P_END ORG_Parallel

    subroutine zajold2zaj_phi2zaj_old_all_3D
      integer :: ib, ibto
      do ib = 1, np_e
         if(rr_is_over_or_under(ib,ik) == UNDER.and.sw_precalculate==OFF) cycle
         if(nrmm == 3) call m_ESsd_copy_zaj_old_to_zaj(ik,ib)
         ibto = ib
         phi0 => phi(:,:,ibto,0)
         call m_ESsd_copy_phi_to_zaj_old(ik,ib,phi0)  ! phi->zaj_old
      end do
    end subroutine zajold2zaj_phi2zaj_old_all_3D

    subroutine zajold2zaj_phi2zaj_old_3D
      if(nrmm == 3) call m_ESsd_copy_zaj_old_to_zaj(ik,ib)
      phi0 => phi(:,:,1,0)
      call m_ESsd_copy_phi_to_zaj_old(ik,ib,phi0)  ! phi->zaj_old
    end subroutine zajold2zaj_phi2zaj_old_3D

    subroutine rr_avr_final_3D
      integer       :: i,j, n_rr_under, n_mpi
      real(kind=DP) :: rr_avr_mpi

      if(npes >= 2) then
                                                  __TIMER_COMM_START(1621)
         call mpi_allreduce(rr_avr, rr_avr_mpi,1,mpi_double_precision &
              & , mpi_sum,mpi_kg_world,ierr)
                                                  __TIMER_COMM_STOP(1621)
      else
         rr_avr_mpi = rr_avr
      end if
      rr_avr = rr_avr_mpi/(kv3*neg)
      if(iprirmm >= 2) &
           & write(nfout,'(" Residual Norm (sum_i <R_i|R_i>/sum_i) ( " &
           & ,i6," -th iter (electronic)) = ",d19.7)') iteration_electronic, rr_avr

      n_rr_under = 0
      do j = ista_k, iend_k
         do i = 1, np_e
            if(rr_is_over_or_under(i,j) == UNDER) n_rr_under = n_rr_under + 1
         end do
      end do
      if(npes >= 2) then
                                                  __TIMER_COMM_START(1621)
         call mpi_allreduce(n_rr_under,n_mpi, 1, mpi_integer,mpi_sum,MPI_CommGroup,ierr)
                                                  __TIMER_COMM_STOP(1621)
      else
         n_mpi = n_rr_under
      end if
      if(n_mpi > 0 .and. iprirmm >= 1) write(nfout,'(" Number of rr_under = ",i5)') n_mpi
    end subroutine rr_avr_final_3D

    subroutine what_is_the_dimension_of_rmm
      if(isolver == RMM2 ) then
         nrmm = 2
      else if(isolver == RMM2p) then
         if(iteration_electronic == iteration_rmm_start) then
            nrmm = 2
         else
            nrmm = 3
         end if
      else if(isolver == RMM3) then
         nrmm = 3
      else
         if(printable) write(nfout,'(" !isolver",i3," is illegal ( m_ESrmm_renew_WF )")') isolver
         call phase_error_with_msg(nfout,'solver is invalid',__LINE__,__FILE__)
      endif
    end subroutine what_is_the_dimension_of_rmm

    subroutine rmm1_3D(ibo,iter_rmm,nrmm,bfft_l,lsize)
      ! Revised by T. Yamasaki, 18th Sep. 2004
      !    <R_i|R_j> and <Phi_i|S|Phi_j> are calculated, then are substituted to
      !   rr_e and psp_e, respectively with not using
      integer, intent(in) :: ibo,iter_rmm,nrmm  ! nrmm = {2|3}
      !               iter_rmm = {0|1} (when nrmm == 2)}, {0|1|2} (when nrmm == 3)
      real(kind=DP) :: evr,devr,dnm,evi,e1,devi
      real(kind=DP) :: rrr, rri, pspr, pspi

      real(kind=DP), pointer, dimension(:,:) :: phi_t, Rphi_t !d(iba(ik),kimg)
      real(kind=DP), allocatable, dimension(:) :: p
      integer       :: i, i1, ib, ibt, ir, ii, j, iadd
      integer       :: iend
      integer, intent(in) :: lsize
!     real(kind=DP), intent(in), dimension(lsize*kimg,ibesize) :: bfft_l
#ifdef FFT_3D_DIVISION
      real(kind=DP), intent(in), dimension(lsize*2   ,1) :: bfft_l
#else
      real(kind=DP), intent(in), dimension(lsize*kimg,1) :: bfft_l
#endif
      allocate(p(maxval(np_g1k)))

      if(iter_rmm == nrmm-1) then
         allocate(phi_t(np_g1k(ik),kimg))
         allocate(Rphi_t(np_g1k(ik),kimg))
      end if

      ib = ibo                  ! MPI
      if(rmm_save_memory_mode == ON) then
         ibt = 1
      else
         ibt = ib
      end if
      dnm = 1.d0/product(fft_box_size_WF(1:3,1))
      call m_ES_decide_precon_factor_3D(precon,ik,ibo,ibo,1,ekin_l,p) ! ->p(1:iba(ik))

      if(kimg == 1) then
! ==============================================================================
         iend = iend_g1k(ik) - ista_g1k(ik) + 1
! ==============================================================================
         if(iter_rmm <= nrmm-2) then
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               i1    = igf(nbase(i,ik))
               evr   = zaj_l(iadd,ib,ik,1)
               if(iter_rmm==0 .and. sw_keep_hloc_phi==ON) then
                 devr  = hlocphi_l(iadd,ib,ik,1)-eko_l(ib,ik)*evr + vnlph_l(iadd,ib,1)
               else
                 devr  = (ekin_l(iadd)-eko_l(ib,ik))*evr + bfft_l(iadd,1)*dnm+vnlph_l(iadd,ib,1)
               endif
               zaj_l(iadd,ib,ik,1)    = -p(iadd)*devr
#ifdef SAVE_FFT_TIMES
               if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
               phi (iadd,1,ibt,iter_rmm)  =  evr
               Rphi(iadd,1,ibt,iter_rmm)  = -devr
            end do
            if(k_symmetry(ik) == GAMMA) then
               do i1 = 0, iter_rmm
                  if(ista_g1k(ik) == 1) then
                     rrr  = Rphi(1,1,ibt,i1)*Rphi(1,1,ibt,iter_rmm) + &
                          & 2.d0*dot_product(Rphi(2:iend,1,ibt,i1),Rphi(2:iend,1,ibt,iter_rmm))
                     pspr = phi (1,1,ibt,i1)*phi (1,1,ibt,iter_rmm) + &
                          & 2.d0*dot_product(phi (2:iend,1,ibt,i1),phi (2:iend,1,ibt,iter_rmm))
                  else
                     rrr  = 2.d0*dot_product(Rphi(1:iend,1,ibt,i1),Rphi(1:iend,1,ibt,iter_rmm))
                     pspr = 2.d0*dot_product(phi (1:iend,1,ibt,i1),phi (1:iend,1,ibt,iter_rmm))
                  endif
                                                  __TIMER_COMM_START(1622)
                  call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                  call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)
                  rr_e (i1,iter_rmm,ibt,1) = rrr
                  psp_e(i1,iter_rmm,ibt,1) = pspr
               end do
            else
               do i1 = 0, iter_rmm
                  rrr  = dot_product(Rphi(1:iend,1,ibt,i1),Rphi(1:iend,1,ibt,iter_rmm))
                  pspr = dot_product(phi (1:iend,1,ibt,i1),phi (1:iend,1,ibt,iter_rmm))
                                                  __TIMER_COMM_START(1622)
                  call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                  call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)
                  rr_e (i1,iter_rmm,ibt,1) = rrr
                  psp_e(i1,iter_rmm,ibt,1) = pspr
               end do
            end if
         else if(iter_rmm == nrmm-1) then
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               i1    = igf(nbase(i,ik))
               phi_t (iadd,1)  = zaj_l(iadd,ib,ik,1)
               Rphi_t(iadd,1)  = - ((ekin_l(iadd)-eko_l(ib,ik))*phi_t(iadd,1) + bfft_l(iadd,1)*dnm+vnlph_l(iadd,ib,1))
!!$               zaj_l(i,ib,ik,1) = evr
               !   when iter_rmm == nrmm-1, zaj_l (to which KR|Psi> is stored) is not
               !   going to be used recursively, so we do not need to store evr to zaj_l,
               !   instead we ues zaj_l as |phi_{iter_rmm}>.
            end do
            if(k_symmetry(ik) == GAMMA) then
               do i1 = 0, iter_rmm-1
                  if(ista_g1k(ik) == 1) then
                     rrr  = Rphi(1,1,ibt,i1)*Rphi_t(1,1) &
                        & + 2.d0*dot_product(Rphi(2:iend,ibt,1,i1),Rphi_t(2:iend,1))
                     pspr = phi (1,1,ibt,i1)*phi_t (1,1) &
                        & + 2.d0*dot_product(phi (2:iend,ibt,1,i1),phi_t (2:iend,1))
                  else
                     rrr  = 2.d0*dot_product(Rphi(1:iend,ibt,1,i1),Rphi_t(1:iend,1))
                     pspr = 2.d0*dot_product(phi (1:iend,ibt,1,i1),phi_t (1:iend,1))
                  endif
                                                  __TIMER_COMM_START(1622)
                  call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                  call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)
                  rr_e (i1,iter_rmm,ibt,1) = rrr
                  psp_e(i1,iter_rmm,ibt,1) = pspr
               end do
               if(ista_g1k(ik) == 1) then
                  rrr  = Rphi_t(1,1)*Rphi_t(1,1) &
                     & + 2.d0*dot_product(Rphi_t(2:iend,1),Rphi_t(2:iend,1))
                  pspr = phi_t (1,1)*phi_t (1,1) &
                     & + 2.d0*dot_product(phi_t (2:iend,1),phi_t (2:iend,1))
               else
                  rrr =  2.d0*dot_product(Rphi_t(1:iend,1),Rphi_t(1:iend,1))
                  pspr = 2.d0*dot_product(phi_t (1:iend,1),phi_t (1:iend,1))
               endif
                                                  __TIMER_COMM_START(1622)
               call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)

               rr_e (iter_rmm,iter_rmm,ibt,1) = rrr
               psp_e(iter_rmm,iter_rmm,ibt,1) = pspr
            else
               do i1 = 0, iter_rmm-1
                  rrr  = dot_product(Rphi(1:iend,1,ibt,i1),Rphi_t(1:iend,1))
                  pspr = dot_product(phi (1:iend,1,ibt,i1),phi_t (1:iend,1))
                                                  __TIMER_COMM_START(1622)
                  call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                  call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)
                  rr_e (i1,iter_rmm,ibt,1) = rrr
                  psp_e(i1,iter_rmm,ibt,1) = pspr
               end do
               rrr  = dot_product(Rphi_t(1:iend,1),Rphi_t(1:iend,1))
               pspr = dot_product(phi_t (1:iend,1),phi_t (1:iend,1))
                                                  __TIMER_COMM_START(1622)
               call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)
               rr_e (iter_rmm,iter_rmm,ibt,1) = rrr
               psp_e(iter_rmm,iter_rmm,ibt,1) = pspr
            end if
         else
            if(printable) write(nfout,'("  iter_rmm > nrmm-1 ( illegal relation) <<m_ES_WF_by_RMM.rmm1_3D>>")')
            call phase_error_with_msg(nfout,'   iter_rmm > nrmm-1 ( illegal relation) <<m_ES_WF_by_RMM.rmm1_3D>>'&
                                     ,__LINE__,__FILE__)
         end if
      else if(kimg == 2) then
         ir = iter_rmm
         if(iter_rmm <= nrmm-2) then
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               i1    = igf(nbase(i,ik))
               evr   = zaj_l(iadd,ib,ik,1);    evi   = zaj_l(iadd,ib,ik,2)
               if(iter_rmm==0 .and. sw_keep_hloc_phi==ON) then
                 e1    = - eko_l(ib,ik)
                 devr  = hlocphi_l(iadd,ib,ik,1) + e1*evr+vnlph_l(iadd,ib,1)
                 devi  = hlocphi_l(iadd,ib,ik,2) + e1*evi+vnlph_l(iadd,ib,2)
               else
                 e1    = ekin_l(iadd) - eko_l(ib,ik)
                 devr  = e1*evr+bfft_l(2*iadd-1,1)*dnm+vnlph_l(iadd,ib,1)
                 devi  = e1*evi+bfft_l(2*iadd  ,1)*dnm+vnlph_l(iadd,ib,2)
               endif
               zaj_l(iadd,ib,ik,1)   = -p(iadd)*devr
               zaj_l(iadd,ib,ik,2)   = -p(iadd)*devi
               phi (iadd,  1,ibt,iter_rmm) = evr;   phi (iadd, 2,ibt,iter_rmm) = evi
               Rphi(iadd,  1,ibt,iter_rmm) = -devr; Rphi(iadd, 2,ibt,iter_rmm) = -devi
            end do
#ifdef SAVE_FFT_TIMES
            if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
            do i1 = 0, iter_rmm
               rrr = 0.d0; rri = 0.d0; pspr = 0.d0; pspi = 0.d0
               if(k_symmetry(ik) == GAMMA) then
                  do i = max(ista_g1k(ik),2), iend_g1k(ik)
                     iadd = i - ista_g1k(ik) + 1
                     rrr  = rrr  + Rphi(iadd,1,ibt,i1)*Rphi(iadd,1,ibt,iter_rmm) + Rphi(iadd,2,ibt,i1)*Rphi(iadd,2,ibt,iter_rmm)
                     pspr = pspr + phi (iadd,1,ibt,i1)*phi (iadd,1,ibt,iter_rmm) + phi (iadd,2,ibt,i1)*phi (iadd,2,ibt,iter_rmm)
                  end do
                  if(ista_g1k(ik) == 1) then
                     rrr  = 2.d0*rrr  + Rphi(1,1,ibt,i1)*Rphi(1,1,ibt,iter_rmm)
                     pspr = 2.d0*pspr + phi (1,1,ibt,i1)*phi (1,1,ibt,iter_rmm)
                  else
                     rrr  = 2.d0*rrr
                     pspr = 2.d0*pspr
                  endif
               else
                  do i = ista_g1k(ik), iend_g1k(ik)
                     iadd = i - ista_g1k(ik) + 1
                     rrr  = rrr  + Rphi(iadd,1,ibt,i1)*Rphi(iadd,1,ibt,iter_rmm) + Rphi(iadd,2,ibt,i1)*Rphi(iadd,2,ibt,iter_rmm)
                     rri  = rri  + Rphi(iadd,1,ibt,i1)*Rphi(iadd,2,ibt,iter_rmm) - Rphi(iadd,2,ibt,i1)*Rphi(iadd,1,ibt,iter_rmm)
                     pspr = pspr + phi (iadd,1,ibt,i1)*phi (iadd,1,ibt,iter_rmm) + phi (iadd,2,ibt,i1)*phi (iadd,2,ibt,iter_rmm)
                     pspi = pspi + phi (iadd,1,ibt,i1)*phi (iadd,2,ibt,iter_rmm) - phi (iadd,2,ibt,i1)*phi (iadd,1,ibt,iter_rmm)
                  end do
               end if
                                                  __TIMER_COMM_START(1622)
               call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,rri, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,pspi,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)
               rr_e (i1,iter_rmm,ibt,1) = rrr;  rr_e (i1,iter_rmm,ibt,2) = rri
               psp_e(i1,iter_rmm,ibt,1) = pspr; psp_e(i1,iter_rmm,ibt,2) = pspi
            end do
         else if(iter_rmm == nrmm-1) then
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               i1    = igf(nbase(i,ik))
               phi_t(iadd,1) = zaj_l(iadd,ib,ik,1);    phi_t(iadd,2) = zaj_l(iadd,ib,ik,2)
               e1    = ekin_l(iadd) - eko_l(ib,ik)
               Rphi_t(iadd,1) = - (e1*phi_t(iadd,1)+bfft_l(2*iadd-1,1)*dnm+vnlph_l(iadd,ib,1))
               Rphi_t(iadd,2) = - (e1*phi_t(iadd,2)+bfft_l(2*iadd  ,1)*dnm+vnlph_l(iadd,ib,2))
            end do
            do i1 = 0, iter_rmm-1
               rrr = 0.d0; rri = 0.d0; pspr = 0.d0; pspi = 0.d0
               if(k_symmetry(ik) == GAMMA) then
                  do i = max(ista_g1k(ik),2), iend_g1k(ik)
                     iadd = i - ista_g1k(ik) + 1
                     rrr  = rrr  + Rphi(iadd,1,ibt,i1)*Rphi_t(iadd,1) + Rphi(iadd,2,ibt,i1)*Rphi_t(iadd,2)
                     pspr = pspr + phi (iadd,1,ibt,i1)*phi_t (iadd,1) + phi (iadd,2,ibt,i1)*phi_t (iadd,2)
                  end do
                  if(ista_g1k(ik) == 1) then
                     rrr  = 2.d0*rrr  + Rphi(1,1,ibt,i1)*Rphi_t(1,1)
                     pspr = 2.d0*pspr + phi (1,1,ibt,i1)*phi_t (1,1)
                  else
                     rrr  = 2.d0*rrr
                     pspr = 2.d0*pspr
                  endif
               else
                  do i = ista_g1k(ik), iend_g1k(ik)
                     iadd = i - ista_g1k(ik) + 1
                     rrr  = rrr  + Rphi(iadd,1,ibt,i1)*Rphi_t(iadd,1) + Rphi(iadd,2,ibt,i1)*Rphi_t(iadd,2)
                     rri  = rri  + Rphi(iadd,1,ibt,i1)*Rphi_t(iadd,2) - Rphi(iadd,2,ibt,i1)*Rphi_t(iadd,1)
                     pspr = pspr + phi (iadd,1,ibt,i1)*phi_t (iadd,1) + phi (iadd,2,ibt,i1)*phi_t (iadd,2)
                     pspi = pspi + phi (iadd,1,ibt,i1)*phi_t (iadd,2) - phi (iadd,2,ibt,i1)*phi_t (iadd,1)
                  end do
               end if
                                                  __TIMER_COMM_START(1622)
               call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,rri, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,pspi,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)
               rr_e (i1,iter_rmm,ibt,1) = rrr;  rr_e (i1,iter_rmm,ibt,2) = rri
               psp_e(i1,iter_rmm,ibt,1) = pspr; psp_e(i1,iter_rmm,ibt,2) = pspi
            end do
            rrr = 0.d0; rri = 0.d0; pspr = 0.d0; pspi = 0.d0
            if(k_symmetry(ik) == GAMMA) then
               do i = max(ista_g1k(ik),2), iend_g1k(ik)
                  iadd = i - ista_g1k(ik) + 1
                  rrr  = rrr  + Rphi_t(iadd,1)*Rphi_t(iadd,1) + Rphi_t(iadd,2)*Rphi_t(iadd,2)
                  pspr = pspr + phi_t (iadd,1)*phi_t (iadd,1) + phi_t (iadd,2)*phi_t (iadd,2)
               end do
               if(ista_g1k(ik) == 1) then
                  rrr  = 2.d0*rrr  + Rphi_t(1,1)*Rphi_t(1,1)
                  pspr = 2.d0*pspr + phi_t (1,1)*phi_t (1,1)
               else
                  rrr  = 2.d0*rrr
                  pspr = 2.d0*pspr
               endif
            else
               do i = ista_g1k(ik), iend_g1k(ik)
                  iadd = i - ista_g1k(ik) + 1
                  rrr  = rrr  + Rphi_t(iadd,1)*Rphi_t(iadd,1) + Rphi_t(iadd,2)*Rphi_t(iadd,2)
                  rri  = rri  + Rphi_t(iadd,1)*Rphi_t(iadd,2) - Rphi_t(iadd,2)*Rphi_t(iadd,1)
                  pspr = pspr + phi_t (iadd,1)*phi_t (iadd,1) + phi_t (iadd,2)*phi_t (iadd,2)
                  pspi = pspi + phi_t (iadd,1)*phi_t (iadd,2) - phi_t (iadd,2)*phi_t (iadd,1)
               end do
            end if
                                                  __TIMER_COMM_START(1622)
            call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            call mpi_allreduce(MPI_IN_PLACE,rri, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            call mpi_allreduce(MPI_IN_PLACE,pspi,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)
            rr_e (iter_rmm,iter_rmm,ibt,1) = rrr;  rr_e (iter_rmm,iter_rmm,ibt,2) = rri
            psp_e(iter_rmm,iter_rmm,ibt,1) = pspr; psp_e(iter_rmm,iter_rmm,ibt,2) = pspi
         else
            if(printable) write(nfout,'("  iter_rmm > nrmm-1 ( illegal relation) <<m_ES_WF_by_RMM.rmm1_3D>>")')
            call phase_error_with_msg(nfout,'   iter_rmm > nrmm-1 ( illegal relation) <<m_ES_WF_by_RMM.rmm1_3D>>'&
                                     ,__LINE__,__FILE__)
         end if
      end if

      if(iter_rmm==0) then
        if(occup_l(ibt,ik) > 0.d0) then
          if(rr_e(0,0,ibt,1)<delta_residual_occup) then
            nrmm_of_band(ibt) = 2
            rconv(ibt) = .true.
            if(iprirmm>1) write(nfout,'(a,2i8,a)') 'update method for occup band ',ik,ibt,' is changed to RMM2'
          endif
        else
          if(rr_e(0,0,ibt,1)<delta_residual_empty) then
            nrmm_of_band(ibt) = 2
            rconv(ibt) = .true.
            if(iprirmm>1) write(nfout,'(a,2i8,a)') 'update method for empty band ',ik,ibt,' is changed to RMM2'
          endif
        endif
      endif

      if(iter_rmm == nrmm-1) then
         deallocate(Rphi_t)
         deallocate(phi_t)
      end if
      deallocate(p)
    end subroutine rmm1_3D



    subroutine evolve_WF_using_Residuals_3D(ib,nrmm,alpha,nrmm_of_band)
!
!  * Rewritten by T. Uda and T. Yamasaki, 19th Mar. 2003
!      + alpha(nrmm-1) -> alpha(nrmm-1,kimg)
!
!  * Revised by T. Yamasaki, 18th Sep. 2004
!      + being changed not to use phi(:,:,:,nrmm-1) for saving the memory allocation area.
!      + phi(:,:,:,nrmm-1) is substituted to zaj_l before the program reached to this
!       subroutine.
!
      integer, intent(in) ::                             ib, nrmm
      real(kind=DP),intent(in),dimension(nrmm-1,kimg) :: alpha
      integer,intent(in),dimension(np_e)              :: nrmm_of_band
      integer ::                                         i, ibt, nr, ir, ii, j, ig, iadd
      real(kind=DP) ::                                   zr,zi

      if(rmm_save_memory_mode == ON) then
         ibt = 1
      else
         ibt = ib
      end if

      if(kimg==1) then
         ! previously in sub. rmm1, zaj_l(:,ib,ik,:) <= phi(:,:,ibt,nrmm-1)
         ! Following calculation is equivalent to
         !  zaj_l = phi(:,:,ibt,0) + alpha(nrmm-1)*phi(:,:,ibt,nrmm-1)
         !    |WF> = |phi_0> + alpha(nrmm-1)|phi_{nrmm-1}>
         do i = ista_g1k(ik), iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            zaj_l(iadd,ib,ik,1) = phi(iadd,1,ibt,0) + alpha(nrmm_of_band(ibt)-1,1)*zaj_l(iadd,ib,ik,1)
         end do
         do ir = 1, nrmm_of_band(ibt)-2
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               zaj_l(iadd,ib,ik,1) = zaj_l(iadd,ib,ik,1) + alpha(ir,1)*phi(iadd,1,ibt,ir)
            end do
         end do
      else if(kimg==2) then
         ! previously in <sub. rmm1>, zaj_l(:,ib,ik,:) <-- phi(:,:,ibt,nrmm-1)
         nr = nrmm_of_band(ibt)-1
         do i = ista_g1k(ik), iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            !   Calculation in this do-loop is equivalent to
            !  zaj_l(:,ib,ik,:) = phi(:,:,ibt,0) + alpha(nrmm-1)*phi(:,:,ibt,nrmm-1),
            !  namely, |WF> = |phi_0> + alpha(nrmm-1)|phi_{nrmm-1}>
            zr = zaj_l(iadd,ib,ik,1)
            zi = zaj_l(iadd,ib,ik,2)
            zaj_l(iadd,ib,ik,1) = phi(iadd,1,ibt,0) + alpha(nr,1)*zr - alpha(nr,2)*zi
            zaj_l(iadd,ib,ik,2) = phi(iadd,2,ibt,0) + alpha(nr,1)*zi + alpha(nr,2)*zr
         end do

         do i = 1, nrmm_of_band(ibt)-2
            do ig = ista_g1k(ik), iend_g1k(ik)
               iadd = ig - ista_g1k(ik) + 1
               zaj_l(iadd,ib,ik,1) = zaj_l(iadd,ib,ik,1) + alpha(i,1)*phi(iadd,1,ibt,i) - alpha(i,2)*phi(iadd,2,ibt,i)
               zaj_l(iadd,ib,ik,2) = zaj_l(iadd,ib,ik,2) + alpha(i,1)*phi(iadd,2,ibt,i) + alpha(i,2)*phi(iadd,1,ibt,i)
            end do
         end do
      else
         call phase_error_with_msg(nfout,' kimg is illegal (evolve_WF_using_Residuals_3D)',__LINE__,__FILE__)
      end if
#ifdef SAVE_FFT_TIMES
      if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif

      if(iprirmm >= 3) then
         ibt = 100
         if(ista_g1k(ik) == 1) then
            if(ibt > iend_g1k(ik)) ibt = iend_g1k(ik)
            if(ik <= 2 .or. ik >= kv3-1) then
               write(nfout,'(" !rmm  zaj_l in <<evolve_WF_using_Residuals_3D>>")')
               write(nfout,'(" !rmm  ik, ib = ",2i8)') ik, ib
               if(kimg == 2) write(nfout,'(" !rmm -- real part --")')
               write(nfout,'(" !rmm  ",8f8.4)') (zaj_l(i,ib,ik,1),i=1,ibt)
               if(kimg == 2) write(nfout,'(" !rmm -- imaginary part --")')
               write(nfout,'(" !rmm  ",8f8.4)') (zaj_l(i,ib,ik,2),i=1,ibt)
            end if
         end if
      end if

    end subroutine evolve_WF_using_Residuals_3D

    subroutine wd_rr_and_psp(nrmm,rr,psp)
      integer, intent(in)                                        :: nrmm
      real(kind=DP),intent(in),dimension(0:nrmm-1,0:nrmm-1,kimg) :: rr,psp
      integer :: i, j
      write(nfout,'("!rr =",6d15.7)') ((rr(i,j,1),j=i,nrmm-1),i=0,nrmm-1)
      write(nfout,'("!psp=",6d15.7)') ((psp(i,j,1),j=i,nrmm-1),i=0,nrmm-1)
    end subroutine wd_rr_and_psp

    subroutine wd_alpha(nrmm,alpha)
      integer, intent(in)                          :: nrmm
      real(kind=DP), intent(in), dimension(nrmm-1,kimg) :: alpha

      write(nfout,'(" ! alpha(1) = ", f20.10)') alpha(1,1)
      if(nrmm == 3) write(nfout,'(" ! alpha(2) = ", f20.10)') alpha(2,1)
    end subroutine wd_alpha

    subroutine rmm_n_uda_3D(ik,ibo,nrmm)
      integer,       intent(in) :: ik,ibo, nrmm

      real(DP) :: rr(0:nrmm-1,0:nrmm-1,kimg),psp(0:nrmm-1,0:nrmm-1,kimg)
      real(DP) :: alpha(nrmm-1,kimg)
      integer  :: ib
      integer :: id_sname = -1
      call tstatc0_begin('rmm_n_uda_3D ', id_sname)

      ib = ibo
!!$      call rr_and_psp_from_Rphi_and_phi(ib,nrmm,rr,psp) !-(m_ES_WF_by_RMM)
      call rr_and_psp_from_rr_e_and_psp_e_3D(ib,nrmm,rr,psp) ! -(m_ES_WF_by_RMM)
      !   rr(i,j) = <R_i|R_j>; psp(i,j) = <Phi_i|S|Phi_j>
      !                            S = 1 + \sum_{ij}q_{ij}|b_i><b_j|
      rr_avr = rr_avr + rr(0,0,1)
      if(rr(0,0,1) <= rr_Critical_Value) rr_is_over_or_under(ib,ik) = UNDER

    !!$  call normalization_of_rr_and_psp(nrmm,rr,psp)
      !   rr(i,j) = rr(i,j)/rr(0,0), psp(i,j) = psp(i,j)/psp(0,0)

      if(iprirmm >= 2) call wd_rr_and_psp(nrmm,rr,psp)

      if(kimg == 1) then
         if(nrmm_of_band(ib) == 2) then
            call rmm2_uda(iprirmm,nrmm,rr,psp,alpha)
         else
            call rmm3_uda(iprirmm,nrmm,rr,psp,alpha)
         end if
      else
         if(nrmm_of_band(ib) == 2) then
            call crmm2_uda(iprirmm,nrmm,rr,psp,alpha)
         else
            call crmm3_uda(iprirmm,nrmm,rr,psp,alpha)
         end if
      end if

      if(iprirmm >= 2) call wd_alpha(nrmm,alpha)
      call evolve_WF_using_Residuals_3D(ib,nrmm,alpha,nrmm_of_band) ! -(contained subr. m_ESrmm_renew_WF)
      if(iprirmm>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
      !   phi,alpha ->zaj_l(:,ib,ik,:)
      !   |WF> = |phi_0> + alpha(1)|phi_1> + alpha(2)|phi_2> , when nrmm == 3
      call tstatc0_end(id_sname)
    end subroutine rmm_n_uda_3D

    subroutine rg_or_cg(nrmm,ymat,eigenr,eigeni,vector,ww1,ww2,ww3)
      integer, intent(in) :: nrmm
      real(DP), dimension(0:nrmm-1,0:nrmm-1,kimg):: ymat
      real(DP), intent(out),dimension(0:nrmm-1)  :: eigenr, eigeni
      real(DP), intent(out),dimension(0:nrmm-1,0:nrmm-1,kimg):: vector
      real(DP), intent(out),dimension(nrmm*kimg) :: ww1,ww2,ww3
      integer                                    :: ier
      if(kimg == 1) then
         call rg_eispack(nrmm,nrmm,ymat,eigenr,eigeni,1,vector,ww1,ww2,ier)
      else if(kimg == 2) then
         call cg_eispack(nrmm,nrmm,ymat(0,0,1),ymat(0,0,kimg),eigenr,eigeni,1 &
              &, vector(0,0,1),vector(0,0,kimg),ww1,ww2,ww3,ier)
      end if
      if(ier /= 0 .and. printable) write(nfout,*) 'ier(rg_or_cg) = ',ier
    end subroutine rg_or_cg

    subroutine solveAYB(nrmm,psp,rr,ymat,ip)
      integer, intent(in) :: nrmm
      real(DP),intent(in), dimension(0:nrmm-1,0:nrmm-1,kimg):: psp,rr
      real(DP),intent(out),dimension(0:nrmm-1,0:nrmm-1,kimg):: ymat
      integer, intent(out),dimension(nrmm) :: ip(nrmm)

      if(kimg == 1) then
         call rsolve(nrmm,nrmm,psp,rr,ymat,ip)
      else
         call csolve2(nrmm,nrmm,psp,rr,ymat,ip)
      end if
    end subroutine solveAYB

    subroutine LUdecomp(nrmm,psp,ww1,ip,ier)
      integer, intent(in) :: nrmm
      real(DP),intent(inout), dimension(0:nrmm-1,0:nrmm-1,kimg):: psp
      real(DP),intent(out),dimension(nrmm*kimg)                :: ww1
      integer, intent(out)                 :: ip(nrmm), ier

      complex(CMPLDP)                      :: cpsp(nrmm*nrmm)
      integer i, j, n
      if(kimg == 1) then
         call rdecomp(nrmm,psp,ww1,ip,ier)
      else
         n = 0
         do j = 0, nrmm-1
            do i = 0, nrmm-1
               n = n + 1
               cpsp(n) = cmplx(psp(i,j,1),psp(i,j,2))
            end do
         end do
         call cdecomp(nrmm,cpsp,ww1,ip,ier)
      end if
    end subroutine LUdecomp


    subroutine rr_and_psp_from_rr_e_and_psp_e_3D(ib_t,nrmm,rr,psp)
      integer, intent(in)       :: ib_t,nrmm
      real(DP),intent(out),dimension(0:nrmm-1,0:nrmm-1,kimg)::rr,psp
      real(DP), dimension(kimg) :: sumqff
      integer  ::                  j,i,m,ri, ib

      if(rmm_save_memory_mode == ON) then
         ib = 1
      else
         ib = ib_t
      end if

      rr = 0.d0; psp = 0.d0
      do j = 0, nrmm-1
         do i = 0,j
            call phsphn_3D(i,j,ib,kimg,sumqff)  ! ->sumqff (= \sum_{n1,n2}q_{n1,n2}<W|b_{nl}><b_{n2}|W>
            do ri = 1, kimg
               rr(i,j,ri)  = rr_e(i,j,ib,ri)
               psp(i,j,ri) = psp_e(i,j,ib,ri)
               rr( j,i,ri) = pm(ri) * rr(i,j,ri)      ! pm=1,-1 (ri==1,2)
               psp(i,j,ri) = psp(i,j,ri) + sumqff(ri)
               psp(j,i,ri) = pm(ri) * psp(i,j,ri)
            end do
         end do
      end do

    end subroutine rr_and_psp_from_rr_e_and_psp_e_3D

    subroutine phsphn_3D(i,j,ib,nimg,sumqff)
      integer, intent(in)        :: i, j, ib, nimg  ! ib = 1 when save_memory_mode == ON
      real(kind=DP), intent(out) :: sumqff(nimg)
      integer         :: ia,m,n

      sumqff = 0.d0
      if(modnrm == EXECUT) then
         do ia = 1, nac
            m = nlmta1(ia); n = nlmta2(ia)
            sumqff(1) = sumqff(1) + fqwei(ia)*(bWr(m,i,ib)*bWr(n,j,ib)+bWi(m,i,ib)*bWi(n,j,ib))
         end do
         if(nimg == 2) then
            do ia = 1, nac
               m = nlmta1(ia); n = nlmta2(ia)
               sumqff(2) = sumqff(2) + fqwei(ia)*(bWr(m,i,ib)*bWi(n,j,ib)-bWi(m,i,ib)*bWr(n,j,ib))
            end do
         end if
      end if
    end subroutine phsphn_3D

    subroutine normalization_of_rr_and_psp(nrmm,rr,psp)
      integer, intent(in) :: nrmm
      real(DP),intent(out),dimension(0:nrmm-1,0:nrmm-1,kimg)::rr,psp
      real(DP) :: divrr,divpsp

      divrr = 1.d0/rr(0,0,1); divpsp = 1.d0/psp(0,0,1)
      rr    =  rr*divrr
      psp   = psp*divpsp

      if(iprirmm >= 2) call wd_rr_and_psp(nrmm,rr,psp)
    end subroutine normalization_of_rr_and_psp

    subroutine pre_calc_phase
!f      call mltpha4(natm,rmm_precal_phase_matm,pos,PAI2,kgp,ngabc,kg1,nbase(1,ik),iba(ik) &
!f           &     ,phasec,phases)
      call mltpha4(natm,rmm_precal_phase_matm,pos,PAI2,kg,ngabc,kg1,nbase(1,ik),iba(ik) &
           &     ,phasec,phases)
      if(rmm_precal_phase_matm < natm) then
!f         call setglist4(n_min(1),n_max(1),n_min(2),n_max(2) &  ! -(b_E.S.)
!f              &, n_min(3),n_max(3),nbase(1,ik),ngabc,kgp,iba(ik),nglist)
         call setglist4(n_min(1),n_max(1),n_min(2),n_max(2) &  ! -(b_E.S.)
              &, n_min(3),n_max(3),nbase(1,ik),ngabc,kg,iba(ik),nglist)
         call crngabc4(n_min(1),n_max(1),n_min(2),n_max(2) &   ! -(b_E.S.)
              &, n_min(3),n_max(3),nglist,kg1,nngabc,newp)
      end if

      if(iprirmm >= 2) then
         if(allocated(nglist)) then
            write(nfout,'(" !!rmm nglist is allocated <<pre_calc_phase>>")')
         else
            write(nfout,'(" !!rmm nglist is not allocated <<pre_calc_phase>>")')
         end if
      end if

    end subroutine pre_calc_phase

    subroutine zf_listing
      integer       :: ia
      real(kind=DP) :: f(3)

      integer :: id_sname = -1
      call tstatc0_begin('zf_listing ',id_sname)
      do ia = rmm_precal_phase_matm+1, natm
         f = pos(ia,1:3)*PAI2
         call zf_list_s(n_min(1),n_max(1),rmm_precal_phase_matm,natm,f(1),ia,zfc1,zfs1)
         call zf_list_s(n_min(2),n_max(2),rmm_precal_phase_matm,natm,f(2),ia,zfc2,zfs2)
         call zf_list_s(n_min(3),n_max(3),rmm_precal_phase_matm,natm,f(3),ia,zfc3,zfs3)
         !                 -(b_Electronic_Structure)
      end do
      call tstatc0_end(id_sname)

    end subroutine zf_listing
  end subroutine m_ESrmm_renew_WF


  subroutine Vnonlocal_W_RMM_3D(ik,ibo,ispin,matm,iter_rmm)
    integer, intent(in) :: ik,ibo,ispin,matm,iter_rmm
    integer :: mdvdb, it, ia, lmt2, lmta2, ib
    real(kind=DP), allocatable,dimension(:)        :: ar, ai               ! d(kg1)
    real(kind=DP), allocatable,dimension(:)        :: zfcos, zfsin               ! d(nbmx)
    real(kind=DP), allocatable,target,dimension(:) :: sc, ss, qc, qs ! d(kg1)

    integer :: id_sname = -1
    call tstatc0_begin('Vnonlocal_W_RMM_3D ',id_sname)

    ib = ibo        ! MPI
    vnlph_l(:,ib,:) = 0.d0
    call alloc_zfsincos_arai()
    call alloc_scssqcqs()

    Loop_ntyp: do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       Loop_natm : do ia = 1, natm
          if(ityp(ia) /= it) cycle
          call calc_phase_RMM(ik,ia,matm)  ! (zfc1,2,3,zfs1,2,3)-> zfcos,zfsin
          call sumset_rmm(ik,ib,iter_rmm,it,ia) ! zfcos,zfsin,sc,ss,zaj,snl -> bWr,bWi
          do lmt2 = 1, ilmt(it)
             lmta2 = lmta(lmt2,ia)
             call Vnonlocal_W_part_sum_over_lmt1(ispin,ik,it,ia,lmt2,mdvdb)
             if(mdvdb == SKIP) then
                call add_vnlph_l_without_eko_part1(ik,ib,lmta2,iter_rmm)
             else if(mdvdb == EXECUT) then
                call add_vnlph_l_with_eko_part1(ik,ib,lmta2,iter_rmm)
             endif
          end do
       end do Loop_natm
    end do Loop_ntyp
    call dealloc_scssqcqs()
    call dealloc_zfsincos_arai()
    call tstatc0_end(id_sname)
  contains
    subroutine alloc_zfsincos_arai()
      allocate(zfsin(nbmx)); allocate(zfcos(nbmx))
      allocate(ar(maxval(np_g1k))); allocate(ai(maxval(np_g1k)))
    end subroutine alloc_zfsincos_arai

    subroutine dealloc_zfsincos_arai()
      deallocate(ai,ar,zfcos,zfsin)
    end subroutine dealloc_zfsincos_arai

    subroutine alloc_scssqcqs()
      allocate(sc(maxval(np_g1k)))
      allocate(ss(maxval(np_g1k)))
      allocate(qc(maxval(np_g1k)))
      allocate(qs(maxval(np_g1k)))
    end subroutine alloc_scssqcqs

    subroutine dealloc_scssqcqs()
      deallocate(qs,qc,ss,sc)
    end subroutine dealloc_scssqcqs

    subroutine calc_phase_RMM(ik,ia,matm)
      integer, intent(in) :: ik,ia,matm

      integer  :: i, nb, n1,n2,n3
      real(DP) :: z12r,z12i
      integer :: id_sname = -1
      call tstatc0_begin('calc_phase_RMM ',id_sname)

      if(ia <= matm) then
         do i = 1, iba(ik)
            zfcos(i) = phasec(i,ia)
            zfsin(i) = phases(i,ia)
         end do
      else
         do i = 1, iba(ik)
            nb = newp(i)
            n1=nngabc(i,1); n2=nngabc(i,2); n3=nngabc(i,3)
            z12r = zfc1(n1,ia)*zfc2(n2,ia)-zfs1(n1,ia)*zfs2(n2,ia)
            z12i = zfs1(n1,ia)*zfc2(n2,ia)+zfc1(n1,ia)*zfs2(n2,ia)
            zfcos(nb) = zfc3(n3,ia)*z12r - zfs3(n3,ia)*z12i
            zfsin(nb) = zfs3(n3,ia)*z12r + zfc3(n3,ia)*z12i
         end do
      end if
      call tstatc0_end(id_sname)
    end subroutine calc_phase_RMM

    subroutine Vnonlocal_W_part_sum_over_lmt1(ispin,ik,it,ia,lmt2,mdvdb)
      integer, intent(in) :: ispin,ik,it,ia,lmt2,mdvdb
      integer             :: lmt1, lmtt1, il1, im1, il11, mdl, iksnl,il2,im2, ii, i, iadd
      real(kind=DP)       :: tmp

      integer :: id_sname = -1
      call tstatc0_begin('Vnonlocal_W_part_sum_over_lmt1 ',id_sname)

      iksnl = (ik-1)/nspin + 1
      il2   = ltp(lmt2,it)
      im2   = mtp(lmt2,it)

      sc = 0.d0; ss = 0.d0
      if(mdvdb == EXECUT) then
         qc = 0.d0; qs = 0.d0
      endif

      do lmt1 = 1,ilmt(it)
         lmtt1 = lmtt(lmt1,it)
         il1   = ltp(lmt1,it)
         im1   = mtp(lmt1,it)
         il11  = il1 - 1
         mdl   = mod(il11,4)
         if(il1 == il2 .and. im1 == im2) then
!!$            tmp = dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)
          if(ipaw(it)==0) then
              tmp = dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)
          else
              tmp = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
          end if
         else
!!$            tmp = vlhxcQ(lmt1,lmt2,ia,ispin)
          if(ipaw(it)==0) then
              tmp = vlhxcQ(lmt1,lmt2,ia,ispin)
          else
              tmp = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
          end if
         endif
         tmp = tmp * iwei(ia)
         if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
         if(mdl == 0 .or. mdl == 2) then
            do ii = ista_g1k(ik), iend_g1k(ik)
               iadd = ii - ista_g1k(ik) + 1
               sc(iadd) = sc(iadd) + tmp*zfcos(ii)*snl(ii,lmtt1,iksnl)
               ss(iadd) = ss(iadd) - tmp*zfsin(ii)*snl(ii,lmtt1,iksnl)
            end do
         else if(mdl == 1 .or. mdl == 3) then
            do ii = ista_g1k(ik), iend_g1k(ik)
               iadd = ii - ista_g1k(ik) + 1
               sc(iadd) = sc(iadd) - tmp*zfsin(ii)*snl(ii,lmtt1,iksnl)
               ss(iadd) = ss(iadd) - tmp*zfcos(ii)*snl(ii,lmtt1,iksnl)
            end do
         end if
         if(mdvdb == EXECUT .and. il1 == il2 .and. im1 == im2) then
            tmp = q(lmt1,lmt2,it)*iwei(ia)
            if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
            if(mdl == 0 .or. mdl == 2) then
               do ii = ista_g1k(ik), iend_g1k(ik)
                  iadd = ii - ista_g1k(ik) + 1
                  qc(iadd) = qc(iadd) + tmp*zfcos(ii)*snl(ii,lmtt1,iksnl)
                  qs(iadd) = qs(iadd) - tmp*zfsin(ii)*snl(ii,lmtt1,iksnl)
               end do
            else if(mdl == 1 .or. mdl == 3) then
               do ii = ista_g1k(ik), iend_g1k(ik)
                  iadd = ii - ista_g1k(ik) + 1
                  qc(iadd) = qc(iadd) - tmp*zfsin(ii)*snl(ii,lmtt1,iksnl)
                  qs(iadd) = qs(iadd) - tmp*zfcos(ii)*snl(ii,lmtt1,iksnl)
               end do
            end if
         end if
      end do
      call tstatc0_end(id_sname)
    end subroutine Vnonlocal_W_part_sum_over_lmt1

    subroutine sumset_rmm(ik,ib,iter_rmm,it,ia)
      integer, intent(in) :: ik,ib,iter_rmm,it,ia

      integer  :: lmt1, lmtt1, lmta1, il1, i, iksnl, il2, iadd
      real(DP) :: temp, fsrt,fsit,ar,ai,crt1,cit1

      iksnl = (ik-1)/nspin + 1
      do lmt1 = 1, ilmt(it)
         lmtt1 = lmtt(lmt1,it)
         lmta1 = lmta(lmt1,ia)
         il1   = ltp(lmt1,it)
         fsrt = 0.d0; fsit = 0.d0
         if(kimg == 1) then
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               temp = snl(i,lmtt1,iksnl)*zaj_l(iadd,ib,ik,1)
               fsrt = fsrt + zfcos(i)*temp
               fsit = fsit + zfsin(i)*temp
            end do
                                                  __TIMER_COMM_START(1623)
            call mpi_allreduce(MPI_IN_PLACE,fsrt,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            call mpi_allreduce(MPI_IN_PLACE,fsit,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1623)
         else if(kimg == 2) then
            if(k_symmetry(ik) == GAMMA) then
               il2 = mod(il1,2) ! il2 = 1 -> l=0,2,4,..,: il2 = 0 -> l=1,3,5,7,...
               if(il2 == 1) then
                  do i = max(2,ista_g1k(ik)), iend_g1k(ik)
                     iadd = i - ista_g1k(ik) + 1
                     ar = zfcos(i)*snl(i,lmtt1,iksnl)
                     ai = zfsin(i)*snl(i,lmtt1,iksnl)
                     crt1 = zaj_l(iadd,ib,ik,1)
                     cit1 = zaj_l(iadd,ib,ik,2)
                     fsrt = fsrt + ar*crt1 - ai*cit1
                  end do
                  if(ista_g1k(ik) == 1) then
                     fsrt = 2.d0*fsrt + zaj_l(1,ib,ik,1)*snl(1,lmtt1,iksnl)
                  else
                     fsrt = 2.d0*fsrt
                  endif
               else
                  do i = max(2,ista_g1k(ik)), iend_g1k(ik)
                     iadd = i - ista_g1k(ik) + 1
                     ar = zfcos(i)*snl(i,lmtt1,iksnl)
                     ai = zfsin(i)*snl(i,lmtt1,iksnl)
                     crt1 = zaj_l(iadd,ib,ik,1)
                     cit1 = zaj_l(iadd,ib,ik,2)
                     fsit = fsit + ai*crt1 + ar*cit1
                  end do
                  fsit = 2.d0*fsit
               end if
                                                  __TIMER_COMM_START(1623)
               call mpi_allreduce(MPI_IN_PLACE,fsrt,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,fsit,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1623)
            else
               do i = ista_g1k(ik), iend_g1k(ik)
                  iadd = i - ista_g1k(ik) + 1
                  ar = zfcos(i)*snl(i,lmtt1,iksnl)
                  ai = zfsin(i)*snl(i,lmtt1,iksnl)
                  crt1     = zaj_l(iadd,ib,ik,1)
                  cit1     = zaj_l(iadd,ib,ik,2)
                  fsrt = fsrt + ar*crt1-ai*cit1
                  fsit = fsit + ai*crt1+ar*cit1
               end do
                                                  __TIMER_COMM_START(1623)
               call mpi_allreduce(MPI_IN_PLACE,fsrt,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,fsit,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1623)
            end if
         end if

         i = mod(il1,4)
         if(i == 2) then
            temp =  fsit;         fsit =  fsrt;         fsrt = -temp
         else if(i == 3) then
            fsrt = -fsrt;         fsit = -fsit;
         else if(i == 0) then
            temp =  fsit;         fsit = -fsrt;         fsrt = temp
         end if
         bWr(lmta1,iter_rmm,1) = fsrt; bWi(lmta1,iter_rmm,1) = fsit
      end do
    end subroutine sumset_rmm

    subroutine add_vnlph_l_without_eko_part1(ik,ib,lmta2,iter_rmm)
      integer, intent(in) :: ik,ib,lmta2,iter_rmm
      real(kind=DP) :: bWFr, bWFi
      integer       :: i, iadd

      bWFr = bWr(lmta2,iter_rmm,1); bWFi = bWi(lmta2,iter_rmm,1)

      if(kimg == 1) then
         do i = ista_g1k(ik), iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*sc(iadd)-bWFi*ss(iadd)
         enddo
      else if(kimg == 2) then
         do i = ista_g1k(ik), iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*sc(iadd)-bWFi*ss(iadd)
            vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi*sc(iadd)+bWFr*ss(iadd)
         enddo
      endif
    end subroutine add_vnlph_l_without_eko_part1

    subroutine add_vnlph_l_with_eko_part1(ik,ib,lmta2,iter_rmm)
      integer, intent(in) :: ik,ib,lmta2,iter_rmm
      real(kind=DP) :: bWFr, bWFi, e
      integer       :: i, iadd

      integer :: id_sname = -1
      call tstatc0_begin('add_vnlph_l_with_eko_part1 ',id_sname)

      bWFr = bWr(lmta2,iter_rmm,1); bWFi = bWi(lmta2,iter_rmm,1); e = eko_l(ib,ik)

      if(kimg == 1) then
         do i = ista_g1k(ik), iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*(sc(iadd)-e*qc(iadd)) &
                                                      - bWFi*(ss(iadd)-e*qs(iadd))
         enddo
      else if(kimg == 2) then
         do i = ista_g1k(ik), iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*(sc(iadd)-e*qc(iadd)) &
                                                      - bWFi*(ss(iadd)-e*qs(iadd))
            vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi*(sc(iadd)-e*qc(iadd)) &
                                                      + bWFr*(ss(iadd)-e*qs(iadd))
         enddo
      endif
      call tstatc0_end(id_sname)
    end subroutine add_vnlph_l_with_eko_part1
  end subroutine Vnonlocal_W_RMM_3D

  subroutine Vnonlocal_W_RMMn_3D(nfout,ik,ispin,iter_rmm)
    integer, intent(in) :: nfout,ik,ispin,iter_rmm
    integer :: mdvdb, it, ia, lmt2, lmta2
#ifdef NONLOCAL_RMM_DGEMM
    integer :: ia_p, iap, lmta1
#endif
    integer :: n_ialist, n_ialist0, ia_start, n_iagroup, n_ia, ia_g, max_n_ialist0 ,nbmx_adj, kg1_adj
    real(kind=DP), allocatable,dimension(:,:) ::  ar_x, ai_x                      ! d(kg1_adj,n_ialist0)
    real(kind=DP), allocatable,dimension(:,:) ::  zfcos_x, zfsin_x                ! d(nbmx,n_ialist0)
    real(kind=DP), allocatable,target,dimension(:,:) :: sc_x,ss_x,qc_x,qs_x ! d(kg1+,n_ialist))
#ifdef NONLOCAL_RMM_DGEMM
    real(kind=DP), allocatable,target,dimension(:,:) :: sc_lmt, ss_lmt, qc_lmt, qs_lmt  ! d(kg1+,n_ialist))
#endif
    integer, allocatable, dimension(:) :: ia_list
    real(kind=DP), allocatable, dimension(:,:) :: fq
#ifdef NONLOCAL_RMM_DGEMM
    real(kind=DP), allocatable, dimension(:,:) :: bWr_lmt, bWi_lmt
#endif
    integer :: id_sname = -1
    call tstatc0_begin('Vnonlocal_W_RMMn_3D ',id_sname,1)

#ifdef NONLOCAL_RMM_DGEMM
    n_ialist = 16
#else
    n_ialist = 1
#ifdef HIUX
    n_ialist = 16
#endif
#ifdef VPP
    n_ialist = 1
#endif
#ifdef SX
    n_ialist = 8
#endif
#endif
    if(n_ialist <=0) call phase_error_with_msg(nfout,'n_ialist is illegal <<Vnonlocal_W_RMMn_3D>>',__LINE__,__FILE__)
    call find_max_n_ialist0(max_n_ialist0)
    if(iprirmm >= 2) write(nfout,'(" !Vnonlocal_W_RMMn_3D: max_n_ialist0 = ",i8)') max_n_ialist0
    nbmx_adj = nbmx
    if(mod(nbmx_adj,2) == 0) nbmx_adj = nbmx_adj+1
    kg1_adj = kg1
    if(mod(kg1_adj,2) == 0) kg1_adj = kg1_adj+1

    allocate(zfsin_x(maxval(np_g1k),max_n_ialist0))
    allocate(zfcos_x(maxval(np_g1k),max_n_ialist0))
    allocate(ar_x(maxval(np_g1k),max_n_ialist0))
    allocate(ai_x(maxval(np_g1k),max_n_ialist0))
    allocate(ia_list(n_ialist)); ia_list = 0
    allocate(fq(n_ialist,2)); fq = 0.d0

    vnlph_l(:,:,:) = 0.d0
    Loop_ntyp: do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
#ifdef NONLOCAL_RMM_DGEMM
       call alloc_scssqcqs_lmt(maxval(np_g1k),max_n_ialist0*ilmt(it),mdvdb)
#endif
       call alloc_scssqcqs_x(maxval(np_g1k),max_n_ialist0,mdvdb)

       n_ia = 0
       do ia = 1, natm
          if(ityp(ia) == it) n_ia = n_ia + 1
       end do

       n_iagroup = n_ia/n_ialist + 1
       ia_start = 1
       if(iprirmm >= 2) write(nfout,'(" !Vnonlocal_W_RMMn_3D: n_iagroup = ",i8, " ityp = ",i8)') n_iagroup,it
       Loop_ia_group: do ia_g = 1, n_iagroup
          n_ialist0 = 0
          ia_list = 0
          AtomcountLoop: do ia = ia_start, natm
             if(ityp(ia) == it) then
                n_ialist0 = n_ialist0 + 1
                ia_list(n_ialist0) = ia
             end if
              if(n_ialist0 >= n_ialist) exit AtomcountLoop
          end do AtomcountLoop
          ia_start = ia+1
          if(n_ialist0 >= 1 )then
             if(iprirmm >= 2) write(nfout,'(" !m_ES_WF_by_RMM.Vnonlocal_W_RMMn_3D: ia_list = ",8i8)') (ia_list(ia),ia=1,n_ialist0)

START_TIMER(1613)
!f             call calc_phasek_b_3D(natm,pos,n_ialist0,ia_list,kgp,ista_g1k(ik),iend_g1k(ik) &
!f                  & ,ngabc,kg1,nbase(1,ik),maxval(np_g1k),zfcos_x,zfsin_x) ! b_E.S.
             call calc_phasek_b_3D(natm,pos,n_ialist0,ia_list,kg,ista_g1k(ik),iend_g1k(ik) &
                  & ,ngabc,kg1,nbase(1,ik),maxval(np_g1k),zfcos_x,zfsin_x) ! b_E.S.
STOP_TIMER(1613)
#ifdef NONLOCAL_RMM_DGEMM
             call alloc_bW_lmt(it)                ! alloc bWr_lmt, bWi_lmp (np_e, n_ialist0*ilmt(it))
START_TIMER(1614)
             call sumset_rmm_all4()               ! zfcos,zfsin,sc,ss,zaj,snl -> bWr_tmp,bWi_tmp, bWr, bWi
STOP_TIMER(1614)

START_TIMER(1615)
             call Vnonlocal_W_part_sum_ovr_lmt4() ! -> sc_x,ss_x,qc_x,qs_x
STOP_TIMER(1615)
START_TIMER(1616)
             call add_vnlph_l_part4(mdvdb)
STOP_TIMER(1616)

             call dealloc_bW_lmt                  ! alloc bWr_lmt, bWi_lmp (np_e, n_ialist0*ilmt(it))
#else
START_TIMER(1617)
             call sumset_rmm_all3()                         ! zfcos,zfsin,sc,ss,zaj,snl -> bWr,bWi
STOP_TIMER(1617)
             do lmt2 = 1, ilmt(it)
START_TIMER(1618)
                call Vnonlocal_W_part_sum_over_lmt1b()      ! -> sc_x,ss_x,qc_x,qs_x
STOP_TIMER(1618)
                if(mdvdb == SKIP) then
START_TIMER(1619)
                   call add_vnlph_l_without_eko_part3()     ! -> vnlph_l
STOP_TIMER(1619)
                else if(mdvdb == EXECUT) then
START_TIMER(1620)
                   call add_vnlph_l_with_eko_part3()        ! -> vnlph_l
STOP_TIMER(1620)
                endif
             end do
#endif
          end if
       end do Loop_ia_group
       call dealloc_scssqcqs_x()
#ifdef NONLOCAL_RMM_DGEMM
       call dealloc_scssqcqs_lmt()
#endif
    end do Loop_ntyp

    deallocate(fq)
    deallocate(ai_x,ar_x)
    deallocate(ia_list)
    deallocate(zfsin_x,zfcos_x)
    call tstatc0_end(id_sname)
  contains
#ifdef NONLOCAL_RMM_DGEMM
    subroutine alloc_scssqcqs_lmt(kg1_adj,m,mdvdb)
      integer, intent(in) :: kg1_adj,m,mdvdb
      allocate(sc_lmt(kg1_adj,m))
      allocate(ss_lmt(kg1_adj,m))
      if(mdvdb == EXECUT) then
         allocate(qc_lmt(kg1_adj,m))
         allocate(qs_lmt(kg1_adj,m))
      end if
    end subroutine alloc_scssqcqs_lmt

    subroutine dealloc_scssqcqs_lmt()
      deallocate(sc_lmt,ss_lmt)
      if(mdvdb == EXECUT) deallocate(qc_lmt,qs_lmt)
    end subroutine dealloc_scssqcqs_lmt
#endif
    subroutine alloc_scssqcqs_x(kg1_adj,m,mdvdb)
      integer, intent(in) :: kg1_adj,m,mdvdb
      allocate(sc_x(kg1_adj,m))
      allocate(ss_x(kg1_adj,m))
      if(mdvdb == EXECUT) then
         allocate(qc_x(kg1_adj,m))
         allocate(qs_x(kg1_adj,m))
      end if
    end subroutine alloc_scssqcqs_x

    subroutine dealloc_scssqcqs_x()
      if(allocated(qs_x)) deallocate(qs_x)
      if(allocated(qc_x)) deallocate(qc_x)
      deallocate(ss_x,sc_x)
    end subroutine dealloc_scssqcqs_x

    subroutine find_max_n_ialist0(n)
       integer, intent(out) :: n

       n = 0
       do it = 1, ntyp

          n_ia = 0
          do ia = 1, natm
             if(ityp(ia) == it) n_ia = n_ia + 1
          end do

          n_iagroup = n_ia/n_ialist + 1
          ia_start = 1
          if(iprirmm >= 2) write(nfout,'(" !m_ES_WF_by_RMM.Vnonlocal_W_RMMn_3D: n_iagroup = ",i8, " ityp = ",i8)') n_iagroup,it
          do ia_g = 1, n_iagroup
             n_ialist0 = 0
             AtomcountLoop: do ia = ia_start, natm
                if(ityp(ia) == it)  n_ialist0 = n_ialist0 + 1
                if(n_ialist0 >= n_ialist) exit AtomcountLoop
             end do AtomcountLoop
             if(n < n_ialist0) n = n_ialist0
             ia_start = ia+1
           end do
        end do

     end subroutine find_max_n_ialist0

#ifdef NONLOCAL_RMM_DGEMM
    subroutine alloc_bW_lmt(it)
      integer, intent(in) :: it
      integer :: nsize1
      nsize1 = n_ialist0 * ilmt(it)
      allocate(bWr_lmt(nsize1,np_e))
      allocate(bWi_lmt(nsize1,np_e))
    end subroutine alloc_bW_lmt

    subroutine dealloc_bW_lmt()
      deallocate(bWr_lmt)
      deallocate(bWi_lmt)
    end subroutine dealloc_bW_lmt

    subroutine sumset_rmm_all4()
      integer  :: lmt1, lmtt1, lmta1, i, iksnl, ib, il1, ia, iap, il2, iadd
      integer :: M, N, K
      real(kind=DP) :: fsrt, fsit
      real(kind=DP), allocatable, dimension(:,:) :: bWr_tmp, bWi_tmp
      integer :: id_sname = -1
      call tstatc0_begin('sumset_rmm_all4 ',id_sname)

      allocate(bWr_tmp(n_ialist0,np_e)); bWr_tmp = 0.d0
      allocate(bWi_tmp(n_ialist0,np_e)); bWi_tmp = 0.d0

      iksnl = (ik-1)/nspin + 1
      do lmt1 = 1, ilmt(it)
         lmtt1 = lmtt(lmt1,it)
         il1   = ltp(lmt1,it)
         do iap = 1, n_ialist0
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/09/13 ================================================
!              ar_x(iadd,iap) = zfcos_x(iadd,iap)*snl(i,lmtt1,iksnl)
!              ai_x(iadd,iap) = zfsin_x(iadd,iap)*snl(i,lmtt1,iksnl)
               ar_x(iadd,iap) = zfcos_x(iadd,iap)*snl(iadd,lmtt1,iksnl)
               ai_x(iadd,iap) = zfsin_x(iadd,iap)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
            end do
         end do


         M = n_ialist0; N = np_e; K = iend_g1k(ik) - ista_g1k(ik) + 1
         if(kimg == 1) then
            call DGEMM__('T','N',M,N,K,1.d0,ar_x,maxval(np_g1k),zaj_l(1,1,ik,1),maxval(np_g1k),0.d0,bWr_tmp,M)
            call DGEMM__('T','N',M,N,K,1.d0,ai_x,maxval(np_g1k),zaj_l(1,1,ik,1),maxval(np_g1k),0.d0,bWi_tmp,M)

         else if(kimg == 2) then
            if(k_symmetry(ik) == GAMMA) then
               il2 = mod(il1,2) ! il2 = 1 -> l=0,2,4,6,...: il2 = 0 -> l=1,3,5,7,...
               if(il2 == 1) then
                  if(ista_g1k(ik) == 1) then
                     ai_x(1,1:n_ialist0) = 0.d0;  ar_x(1,1:n_ialist0) = ar_x(1,1:n_ialist0)*0.5d0
                  endif
                  call DGEMM__('T','N',M,N,K, 1.d0,ar_x,maxval(np_g1k),zaj_l(1,1,ik,1),maxval(np_g1k),0.d0,bWr_tmp,M)
                  call DGEMM__('T','N',M,N,K,-1.d0,ai_x,maxval(np_g1k),zaj_l(1,1,ik,2),maxval(np_g1k),1.d0,bWr_tmp,M)
                  bWr_tmp = bWr_tmp*2.d0;   bWi_tmp = 0.d0
               else
                  if(ista_g1k(ik) == 1) then
                     ar_x(1,1:n_ialist0) = 0.d0; ai_x(1,1:n_ialist0) = 0.d0
                  endif
                  call DGEMM__('T','N',M,N,K, 1.d0,ai_x,maxval(np_g1k),zaj_l(1,1,ik,1),maxval(np_g1k),0.d0,bWi_tmp,M)
                  call DGEMM__('T','N',M,N,K, 1.d0,ar_x,maxval(np_g1k),zaj_l(1,1,ik,2),maxval(np_g1k),1.d0,bWi_tmp,M)
                  bWr_tmp = 0.d0;           bWi_tmp = bWi_tmp*2.d0
               end if
            else
               call DGEMM__('T','N',M,N,K, 1.d0,ar_x,maxval(np_g1k),zaj_l(1,1,ik,1),maxval(np_g1k),0.d0,bWr_tmp,M)
               call DGEMM__('T','N',M,N,K,-1.d0,ai_x,maxval(np_g1k),zaj_l(1,1,ik,2),maxval(np_g1k),1.d0,bWr_tmp,M)
               call DGEMM__('T','N',M,N,K, 1.d0,ai_x,maxval(np_g1k),zaj_l(1,1,ik,1),maxval(np_g1k),0.d0,bWi_tmp,M)
               call DGEMM__('T','N',M,N,K, 1.d0,ar_x,maxval(np_g1k),zaj_l(1,1,ik,2),maxval(np_g1k),1.d0,bWi_tmp,M)
            end if
         end if
                                                  __TIMER_COMM_START(1624)
         call mpi_allreduce(MPI_IN_PLACE,bWr_tmp,n_ialist0*np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
         call mpi_allreduce(MPI_IN_PLACE,bWi_tmp,n_ialist0*np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1624)

         i = mod(il1,4)
!$omp parallel private(iap, ib, fsrt, fsit, ia, lmta1)
         do iap = 1, n_ialist0
            if(i==2) then
!$omp do
               do ib = 1, np_e
                  fsrt = bWr_tmp(iap,ib); fsit = bWi_tmp(iap,ib)
                  bWr_tmp(iap,ib) = -fsit; bWi_tmp(iap,ib) = fsrt
               end do
!$omp end do nowait
            else if(i==3) then
!$omp do
               do ib = 1, np_e
                  fsrt = bWr_tmp(iap,ib); fsit = bWi_tmp(iap,ib)
                  bWr_tmp(iap,ib) = -fsrt; bWi_tmp(iap,ib) = -fsit
               end do
!$omp end do nowait
            else if(i==0) then
!$omp do
               do ib = 1, np_e
                  fsrt = bWr_tmp(iap,ib); fsit = bWi_tmp(iap,ib)
                  bWr_tmp(iap,ib) = fsit; bWi_tmp(iap,ib) = -fsrt
               end do
!$omp end do nowait
            end if
         end do

         do ib = 1, np_e
            do iap = 1, n_ialist0
               ia = n_ialist0*(lmt1-1) + iap
               bWr_lmt(ia,ib) = bWr_tmp(iap,ib)
               bWi_lmt(ia,ib) = bWi_tmp(iap,ib)
            end do
         end do

         do iap = 1, n_ialist0
            ia = ia_list(iap)
            lmta1 = lmta(lmt1,ia)
!$omp do
            do ib = 1, np_e
               bWr(lmta1,iter_rmm,ib) =  bWr_tmp(iap,ib)
               bWi(lmta1,iter_rmm,ib) =  bWi_tmp(iap,ib)
            end do
!$omp end do
         end do
!$omp end parallel

      end do

      deallocate(bWr_tmp, bWi_tmp)

      call tstatc0_end(id_sname)

    end subroutine sumset_rmm_all4

    subroutine Vnonlocal_W_part_sum_ovr_lmt4()
      integer             :: lmt1, lmtt1, il1, im1, il11, mdl, iksnl,il2,im2, ia_p, ia, i, lmt2, iap, iadd
      real(kind=DP)       :: tmp

      integer :: id_sname = -1
      call tstatc0_begin('Vnonlocal_W_part_sum_ovr_lmt4 ',id_sname)

      sc_lmt = 0.d0; ss_lmt = 0.d0
      if(mdvdb == EXECUT) then
         qc_lmt = 0.d0; qs_lmt = 0.d0
      endif

      iksnl = (ik-1)/nspin + 1
      do lmt2 = 1, ilmt(it)
         il2   = ltp(lmt2,it)
         im2   = mtp(lmt2,it)


         do lmt1 = 1,ilmt(it)
            lmtt1 = lmtt(lmt1,it)
            il1   = ltp(lmt1,it)
            im1   = mtp(lmt1,it)
            il11  = il1 - 1
            mdl   = mod(il11,4)

!OCL NOFLTLD
            do ia_p = 1, n_ialist0
               ia = ia_list(ia_p)
               if(il1 == il2 .and. im1 == im2) then
                  if(ipaw(it)==0) then
                     tmp = (dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)) * iwei(ia)
                  else
                     tmp = (dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)) * iwei(ia)
                  end if
               else
                  if(ipaw(it)==0) then
                     tmp = vlhxcQ(lmt1,lmt2,ia,ispin) * iwei(ia)
                  else
                     tmp = (dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)) * iwei(ia)
                  end if
               endif
               if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
               fq(ia_p,1) = tmp
            end do

            if(mdvdb == EXECUT .and. il1 == il2 .and. im1 == im2) then
               do ia_p = 1, n_ialist0
                  ia = ia_list(ia_p)
                  tmp = q(lmt1,lmt2,it)*iwei(ia)
                  if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
                  fq(ia_p,2) = tmp
               end do

               if(mdl == 0 .or. mdl == 2) then
                  do ia_p = 1, n_ialist0
                     iap = n_ialist0*(lmt2-1) + ia_p
                     do i = ista_g1k(ik), iend_g1k(ik)
                        iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/09/13 ================================================
!                       sc_lmt(iadd,iap) = sc_lmt(iadd,iap) + fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                       ss_lmt(iadd,iap) = ss_lmt(iadd,iap) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                       qc_lmt(iadd,iap) = qc_lmt(iadd,iap) + fq(ia_p,2)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                       qs_lmt(iadd,iap) = qs_lmt(iadd,iap) - fq(ia_p,2)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
                        sc_lmt(iadd,iap) = sc_lmt(iadd,iap) + fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                        ss_lmt(iadd,iap) = ss_lmt(iadd,iap) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                        qc_lmt(iadd,iap) = qc_lmt(iadd,iap) + fq(ia_p,2)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                        qs_lmt(iadd,iap) = qs_lmt(iadd,iap) - fq(ia_p,2)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                     end do
                  end do
               else if(mdl == 1 .or. mdl == 3) then
                  do ia_p = 1, n_ialist0
                     iap = n_ialist0*(lmt2-1) + ia_p
                     do i = ista_g1k(ik), iend_g1k(ik)
                        iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/09/13 ================================================
!                       sc_lmt(iadd,iap) = sc_lmt(iadd,iap) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                       ss_lmt(iadd,iap) = ss_lmt(iadd,iap) - fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                       qc_lmt(iadd,iap) = qc_lmt(iadd,iap) - fq(ia_p,2)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                       qs_lmt(iadd,iap) = qs_lmt(iadd,iap) - fq(ia_p,2)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
                        sc_lmt(iadd,iap) = sc_lmt(iadd,iap) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                        ss_lmt(iadd,iap) = ss_lmt(iadd,iap) - fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                        qc_lmt(iadd,iap) = qc_lmt(iadd,iap) - fq(ia_p,2)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                        qs_lmt(iadd,iap) = qs_lmt(iadd,iap) - fq(ia_p,2)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                     end do
                  end do
               end if
            else
               if(mdl == 0 .or. mdl == 2) then
                  do ia_p = 1, n_ialist0
                     iap = n_ialist0*(lmt2-1) + ia_p
                     do i = ista_g1k(ik), iend_g1k(ik)
                        iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/09/13 ================================================
!                       sc_lmt(iadd,iap) = sc_lmt(iadd,iap) + fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                       ss_lmt(iadd,iap) = ss_lmt(iadd,iap) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
                        sc_lmt(iadd,iap) = sc_lmt(iadd,iap) + fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                        ss_lmt(iadd,iap) = ss_lmt(iadd,iap) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                     end do
                  end do
               else if(mdl == 1 .or. mdl == 3) then
                  do ia_p = 1, n_ialist0
                     iap = n_ialist0*(lmt2-1) + ia_p
                     do i = ista_g1k(ik), iend_g1k(ik)
                        iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/09/13 ================================================
!                       sc_lmt(iadd,iap) = sc_lmt(iadd,iap) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                       ss_lmt(iadd,iap) = ss_lmt(iadd,iap) - fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
                        sc_lmt(iadd,iap) = sc_lmt(iadd,iap) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                        ss_lmt(iadd,iap) = ss_lmt(iadd,iap) - fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                     end do
                  end do
               end if
            end if
         end do
      end do

      call tstatc0_end(id_sname)
    end subroutine Vnonlocal_W_part_sum_ovr_lmt4

    subroutine add_vnlph_l_part4(mdvdb)
       integer, intent(in) :: mdvdb
       integer       :: ib, iap,  M, N, K
       real(kind=DP), allocatable, dimension(:,:) :: bWer, bWei

       integer :: id_sname = -1
       call tstatc0_begin('add_vnlph_l_part4 ',id_sname)

       if(mdvdb == EXECUT) then
          allocate(bWer(ilmt(it)*n_ialist0,np_e))
          allocate(bWei(ilmt(it)*n_ialist0,np_e))
          do iap = 1, ilmt(it)*n_ialist0
             do ib = 1, np_e
                bWer(iap,ib) = bWr_lmt(iap,ib)*eko_l(ib,ik)
                bWei(iap,ib) = bWi_lmt(iap,ib)*eko_l(ib,ik)
             end do
          end do
       end if

       M =iend_g1k(ik) - ista_g1k(ik) + 1; N = np_e ; K = ilmt(it)*n_ialist0
       if(kimg == 1) then
! === DEBUG by tkato 2011/10/20 ================================================
!         call DGEMM__('N','N',M,N,K, 1.d0,sc_lmt,maxval(np_g1k),bWr_lmt,K,1.d0,vnlph_l(1,1,1),maxval(np_g1k))
!         call DGEMM__('N','N',M,N,K,-1.d0,ss_lmt,maxval(np_g1k),bWi_lmt,K,1.d0,vnlph_l(1,1,1),maxval(np_g1k))
          call DGEMM__('N','N',M,N,K, 1.d0,sc_lmt,maxval(np_g1k),bWr_lmt,K,1.d0,vnlph_l(1,1,1),np_g1k(ik))
          call DGEMM__('N','N',M,N,K,-1.d0,ss_lmt,maxval(np_g1k),bWi_lmt,K,1.d0,vnlph_l(1,1,1),np_g1k(ik))
! ==============================================================================

          if(mdvdb == EXECUT) then
! === DEBUG by tkato 2011/10/20 ================================================
!         call DGEMM__('N','N',M,N,K,-1.d0,qc_lmt,maxval(np_g1k),bWer,   K,1.d0,vnlph_l(1,1,1),maxval(np_g1k))
!         call DGEMM__('N','N',M,N,K, 1.d0,qs_lmt,maxval(np_g1k),bWei,   K,1.d0,vnlph_l(1,1,1),maxval(np_g1k))
          call DGEMM__('N','N',M,N,K,-1.d0,qc_lmt,maxval(np_g1k),bWer,   K,1.d0,vnlph_l(1,1,1),np_g1k(ik))
          call DGEMM__('N','N',M,N,K, 1.d0,qs_lmt,maxval(np_g1k),bWei,   K,1.d0,vnlph_l(1,1,1),np_g1k(ik))
! ==============================================================================
          end if
       else if(kimg == 2) then
! === DEBUG by tkato 2011/10/20 ================================================
!         call DGEMM__('N','N',M,N,K, 1.d0,sc_lmt,maxval(np_g1k),bWr_lmt,K,1.d0,vnlph_l(1,1,1),maxval(np_g1k))
!         call DGEMM__('N','N',M,N,K,-1.d0,ss_lmt,maxval(np_g1k),bWi_lmt,K,1.d0,vnlph_l(1,1,1),maxval(np_g1k))
!         call DGEMM__('N','N',M,N,K, 1.d0,sc_lmt,maxval(np_g1k),bWi_lmt,K,1.d0,vnlph_l(1,1,2),maxval(np_g1k))
!         call DGEMM__('N','N',M,N,K, 1.d0,ss_lmt,maxval(np_g1k),bWr_lmt,K,1.d0,vnlph_l(1,1,2),maxval(np_g1k))
          call DGEMM__('N','N',M,N,K, 1.d0,sc_lmt,maxval(np_g1k),bWr_lmt,K,1.d0,vnlph_l(1,1,1),np_g1k(ik))
          call DGEMM__('N','N',M,N,K,-1.d0,ss_lmt,maxval(np_g1k),bWi_lmt,K,1.d0,vnlph_l(1,1,1),np_g1k(ik))
          call DGEMM__('N','N',M,N,K, 1.d0,sc_lmt,maxval(np_g1k),bWi_lmt,K,1.d0,vnlph_l(1,1,2),np_g1k(ik))
          call DGEMM__('N','N',M,N,K, 1.d0,ss_lmt,maxval(np_g1k),bWr_lmt,K,1.d0,vnlph_l(1,1,2),np_g1k(ik))
! ==============================================================================

          if(mdvdb == EXECUT) then
! === DEBUG by tkato 2011/10/20 ================================================
!         call DGEMM__('N','N',M,N,K,-1.d0,qc_lmt,maxval(np_g1k),bWer,   K,1.d0,vnlph_l(1,1,1),maxval(np_g1k))
!         call DGEMM__('N','N',M,N,K, 1.d0,qs_lmt,maxval(np_g1k),bWei,   K,1.d0,vnlph_l(1,1,1),maxval(np_g1k))
!         call DGEMM__('N','N',M,N,K,-1.d0,qc_lmt,maxval(np_g1k),bWei,   K,1.d0,vnlph_l(1,1,2),maxval(np_g1k))
!         call DGEMM__('N','N',M,N,K,-1.d0,qs_lmt,maxval(np_g1k),bWer,   K,1.d0,vnlph_l(1,1,2),maxval(np_g1k))
          call DGEMM__('N','N',M,N,K,-1.d0,qc_lmt,maxval(np_g1k),bWer,   K,1.d0,vnlph_l(1,1,1),np_g1k(ik))
          call DGEMM__('N','N',M,N,K, 1.d0,qs_lmt,maxval(np_g1k),bWei,   K,1.d0,vnlph_l(1,1,1),np_g1k(ik))
          call DGEMM__('N','N',M,N,K,-1.d0,qc_lmt,maxval(np_g1k),bWei,   K,1.d0,vnlph_l(1,1,2),np_g1k(ik))
          call DGEMM__('N','N',M,N,K,-1.d0,qs_lmt,maxval(np_g1k),bWer,   K,1.d0,vnlph_l(1,1,2),np_g1k(ik))
! ==============================================================================
          end if
       end if

       if(mdvdb == EXECUT) deallocate(bWer,bWei)
       call tstatc0_end(id_sname)
    end subroutine add_vnlph_l_part4
#else
     subroutine sumset_rmm_all3()

       integer  :: lmt1, lmtt1, lmta1, i, iksnl, ib, il1, ia, iap, il2, iadd
       real(kind=DP) :: fsrt,fsit
       integer :: id_sname = -1
       call tstatc0_begin('sumset_rmm_all3 ',id_sname)

       iksnl = (ik-1)/nspin + 1
       do lmt1 = 1, ilmt(it)
          lmtt1 = lmtt(lmt1,it)
          il1   = ltp(lmt1,it)
          if(kimg == 1) then

#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do iap = 1, n_ialist0
                ia = ia_list(iap)
!               lmta1 = lmta(lmt1,ia)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/07/12 ================================================
!                  ar_x(iadd,iap) = zfcos_x(iadd,iap)*snl(i,lmtt1,iksnl)
!                  ai_x(iadd,iap) = zfsin_x(iadd,iap)*snl(i,lmtt1,iksnl)
                   ar_x(iadd,iap) = zfcos_x(iadd,iap)*snl(iadd,lmtt1,iksnl)
                   ai_x(iadd,iap) = zfsin_x(iadd,iap)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                end do
             end do
          else if(kimg == 2) then
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do iap = 1,n_ialist0
                ia = ia_list(iap)
!               lmta1 = lmta(lmt1,ia)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/07/12 ================================================
!                  ar_x(iadd,iap) = zfcos_x(iadd,iap)*snl(i,lmtt1,iksnl)
!                  ai_x(iadd,iap) = zfsin_x(iadd,iap)*snl(i,lmtt1,iksnl)
                   ar_x(iadd,iap) = zfcos_x(iadd,iap)*snl(iadd,lmtt1,iksnl)
                   ai_x(iadd,iap) = zfsin_x(iadd,iap)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                end do
             end do
          end if

          if(kimg == 1) then
#ifdef HIUX
*poption indep
*poption parallel
#endif
             do iap = 1, n_ialist0
                ia = ia_list(iap)
                lmta1 = lmta(lmt1,ia)
#ifdef VPP
*vocl loop, unroll(4)
#endif
                do ib = 1, np_e
                   fsrt = 0.d0; fsit = 0.d0
                   do i = ista_g1k(ik), iend_g1k(ik)
                      iadd = i - ista_g1k(ik) + 1
                      fsrt = fsrt + ar_x(iadd,iap)*zaj_l(iadd,ib,ik,1)
                      fsit = fsit + ai_x(iadd,iap)*zaj_l(iadd,ib,ik,1)
                   end do
                                                  __TIMER_COMM_START(1625)
                   call mpi_allreduce(MPI_IN_PLACE,fsrt,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                   call mpi_allreduce(MPI_IN_PLACE,fsit,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1625)
                   bWr(lmta1,iter_rmm,ib) = fsrt; bWi(lmta1,iter_rmm,ib) = fsit
                end do
             end do
          else if(kimg == 2) then
             if(k_symmetry(ik) == GAMMA) then
                il2 = mod(il1,2) ! il2 = 1 -> l=0,2,4,6,...: il2 = 0 -> l=1,3,5,7,...
#ifdef HIUX
*poption indep
*poption parallel
#endif
                do iap = 1, n_ialist0
                   ia = ia_list(iap)
                   lmta1 = lmta(lmt1,ia)
#ifdef VPP
*vocl loop, unroll(4)
#endif
                   do ib = 1, np_e
                      fsrt = 0.d0; fsit = 0.d0
                      if(il2 == 1) then
                         do i = max(2,ista_g1k(ik)), iend_g1k(ik)
                            iadd = i - ista_g1k(ik) + 1
                            fsrt = fsrt + ar_x(iadd,iap)*zaj_l(iadd,ib,ik,1) &
                                        - ai_x(iadd,iap)*zaj_l(iadd,ib,ik,2)
                         end do
                         if(ista_g1k(ik) == 1) then
                            fsrt = 2.d0*fsrt + zaj_l(1,ib,ik,1)*ar_x(1,iap)
                         else
                            fsrt = 2.d0*fsrt
                         endif
                                                  __TIMER_COMM_START(1625)
                         call mpi_allreduce(MPI_IN_PLACE,fsrt,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1625)
                      else
                         do i = max(2,ista_g1k(ik)), iend_g1k(ik)
                            iadd = i - ista_g1k(ik) + 1
                            fsit = fsit + ai_x(iadd,iap)*zaj_l(iadd,ib,ik,1) &
                                        + ar_x(iadd,iap)*zaj_l(iadd,ib,ik,2)
                         end do
                         fsit = 2.d0*fsit
                                                  __TIMER_COMM_START(1625)
                         call mpi_allreduce(MPI_IN_PLACE,fsit,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1625)
                      end if
                      bWr(lmta1,iter_rmm,ib) = fsrt; bWi(lmta1,iter_rmm,ib) = fsit
                   end do
                end do
             else
#ifdef HIUX
*poption indep
*poption parallel
#endif
                do iap = 1, n_ialist0
                   ia = ia_list(iap)
                   lmta1 = lmta(lmt1,ia)
#ifdef VPP
*vocl loop, unroll(4)
#endif
                   do ib = 1, np_e
                      fsrt = 0.d0; fsit = 0.d0
                      do i = ista_g1k(ik), iend_g1k(ik)
                         iadd = i - ista_g1k(ik) + 1
                         fsrt = fsrt + ar_x(iadd,iap)*zaj_l(iadd,ib,ik,1) &
                                     - ai_x(iadd,iap)*zaj_l(iadd,ib,ik,2)
                         fsit = fsit + ai_x(iadd,iap)*zaj_l(iadd,ib,ik,1) &
                                     + ar_x(iadd,iap)*zaj_l(iadd,ib,ik,2)
                      end do
                                                  __TIMER_COMM_START(1625)
                      call mpi_allreduce(MPI_IN_PLACE,fsrt,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                      call mpi_allreduce(MPI_IN_PLACE,fsit,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1625)
                      bWr(lmta1,iter_rmm,ib) = fsrt; bWi(lmta1,iter_rmm,ib) = fsit
                   end do
                end do
             end if
          end if

          i = mod(il1,4)
          do iap = 1, n_ialist0
             ia = ia_list(iap)
             lmta1 = lmta(lmt1,ia)
             if(i == 2) then
                do ib = 1, np_e
                   fsrt = bWr(lmta1,iter_rmm,ib); fsit = bWi(lmta1,iter_rmm,ib)
                   bWr(lmta1,iter_rmm,ib) = -fsit; bWi(lmta1,iter_rmm,ib) = fsrt
                end do
             else if(i == 3) then
                do ib = 1, np_e
                   fsrt = bWr(lmta1,iter_rmm,ib); fsit = bWi(lmta1,iter_rmm,ib)
                   bWr(lmta1,iter_rmm,ib) = -fsrt; bWi(lmta1,iter_rmm,ib) = -fsit
                end do
             else if(i == 0) then
                do ib = 1, np_e
                   fsrt = bWr(lmta1,iter_rmm,ib); fsit = bWi(lmta1,iter_rmm,ib)
                   bWr(lmta1,iter_rmm,ib) =  fsit; bWi(lmta1,iter_rmm,ib) = -fsrt
                end do
             end if
          end do
       end do
       call tstatc0_end(id_sname)
     end subroutine sumset_rmm_all3

     subroutine add_vnlph_l_without_eko_part3()
        real(kind=DP) :: bWFr, bWFi
        integer       :: i, ib, ia, iap, lmta2, iadd

        if(kimg == 1) then
!!$#ifdef HIUX
!!$*poption parallel
!!$#endif
           do iap = 1, n_ialist0
              ia = ia_list(iap)
              lmta2 = lmta(lmt2,ia)
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr = bWr(lmta2,iter_rmm,ib); bWFi = bWi(lmta2,iter_rmm,ib)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*sc_x(iadd,iap)-bWFi*ss_x(iadd,iap)
                enddo
             end do
          end do
       else if(kimg == 2) then
!!$#ifdef HIUX
!!$*poption parallel
!!$#endif
          do iap = 1, n_ialist0
             ia = ia_list(iap)
             lmta2 = lmta(lmt2,ia)
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr = bWr(lmta2,iter_rmm,ib); bWFi = bWi(lmta2,iter_rmm,ib)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*sc_x(iadd,iap)-bWFi*ss_x(iadd,iap)
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi*sc_x(iadd,iap)+bWFr*ss_x(iadd,iap)
                enddo
             end do
          end do
       endif
     end subroutine add_vnlph_l_without_eko_part3

     subroutine add_vnlph_l_with_eko_part3()
        real(kind=DP) :: bWFr, bWFi, e, sceqc, sseqs
        integer       :: i, ib, ia, iap, lmta2, iadd
#ifdef HIUX
        integer       :: lmta2_1, lmta2_2, lmta2_3, lmta2_4, lmta2_5, lmta2_6, lmta2_7, lmta2_8
        real(kind=DP) :: bWFr_1, bWFr_2, bWFr_3, bWFr_4, bWFr_5, bWFr_6, bWFr_7, bWFr_8
        real(kind=DP) :: bWFi_1, bWFi_2, bWFi_3, bWFi_4, bWFi_5, bWFi_6, bWFi_7, bWFi_8
        real(kind=DP) :: sceqc_1, sseqs_1, sceqc_2, sseqs_2, sceqc_3, sseqs_3, sceqc_4, sseqs_4 &
            &         , sceqc_5, sseqs_5, sceqc_6, sseqs_6, sceqc_7, sseqs_7, sceqc_8, sseqs_8
#endif

       integer :: id_sname = -1
       call tstatc0_begin('add_vnlph_l_with_eko_part3 ',id_sname)

#ifdef HIUX
       if(kimg == 1) then
          if(n_ialist0 == 1) then
             lmta2 = lmta(lmt2,ia_list(1))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr = bWr(lmta2,iter_rmm,ib); bWFi = bWi(lmta2,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*(sc_x(iadd,1)-e*qc_x(iadd,1)) &
                                                             - bWFi*(ss_x(iadd,1)-e*qs_x(iadd,1))
                enddo
             end do
          else if(n_ialist0 == 2) then
             lmta2_1 = lmta(lmt2,ia_list(1)); lmta2_2 = lmta(lmt2,ia_list(2))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib =1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*(sc_x(iadd,1)-e*qc_x(iadd,1)) &
                                                             - bWFi_1*(ss_x(iadd,1)-e*qs_x(iadd,1)) &
                                                             + bWFr_2*(sc_x(iadd,2)-e*qc_x(iadd,2)) &
                                                             - bWFi_2*(ss_x(iadd,2)-e*qs_x(iadd,2))
                end do
             end do
          else if(n_ialist0 == 3) then
             lmta2_1 = lmta(lmt2,ia_list(1)); lmta2_2 = lmta(lmt2,ia_list(2)); lmta2_3 = lmta(lmt2,ia_list(3))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib =1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib)
                bWFr_3 = bWr(lmta2_3,iter_rmm,ib); bWFi_3 = bWi(lmta2_3,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*(sc_x(iadd,1)-e*qc_x(iadd,1)) &
                                                             - bWFi_1*(ss_x(iadd,1)-e*qs_x(iadd,1)) &
                                                             + bWFr_2*(sc_x(iadd,2)-e*qc_x(iadd,2)) &
                                                             - bWFi_2*(ss_x(iadd,2)-e*qs_x(iadd,2)) &
                                                             + bWFr_3*(sc_x(iadd,3)-e*qc_x(iadd,3)) &
                                                             - bWFi_3*(ss_x(iadd,3)-e*qs_x(iadd,3))
                end do
             end do
          else if(n_ialist0 >= 4) then
             lmta2_1=lmta(lmt2,ia_list(1)); lmta2_2=lmta(lmt2,ia_list(2)); lmta2_3=lmta(lmt2,ia_list(3)); lmta2_4=lmta(lmt2,ia_list(4))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib =1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib)
                bWFr_3 = bWr(lmta2_3,iter_rmm,ib); bWFi_3 = bWi(lmta2_3,iter_rmm,ib)
                bWFr_4 = bWr(lmta2_4,iter_rmm,ib); bWFi_4 = bWi(lmta2_4,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*(sc_x(iadd,1)-e*qc_x(iadd,1)) &
                                                             - bWFi_1*(ss_x(iadd,1)-e*qs_x(iadd,1)) &
                                                             + bWFr_2*(sc_x(iadd,2)-e*qc_x(iadd,2)) &
                                                             - bWFi_2*(ss_x(iadd,2)-e*qs_x(iadd,2)) &
                                                             + bWFr_3*(sc_x(iadd,3)-e*qc_x(iadd,3)) &
                                                             - bWFi_3*(ss_x(iadd,3)-e*qs_x(iadd,3)) &
                                                             + bWFr_4*(sc_x(iadd,4)-e*qc_x(iadd,4)) &
                                                             - bWFi_4*(ss_x(iadd,4)-e*qs_x(iadd,4))
                end do
             end do
          end if
          if(n_ialist0 > 4) then
             do iap = 5, n_ialist0
                ia = ia_list(iap)
                lmta2 = lmta(lmt2,ia)
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
                do ib = 1, np_e
                   bWFr = bWr(lmta2,iter_rmm,ib); bWFi = bWi(lmta2,iter_rmm,ib); e = eko_l(ib,ik)
                   do i = ista_g1k(ik), iend_g1k(ik)
                      iadd = i - ista_g1k(ik) + 1
                      vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*(sc_x(iadd,iap)-e*qc_x(iadd,iap)) &
                                                                - bWFi*(ss_x(iadd,iap)-e*qs_x(iadd,iap))
                   enddo
                end do
             end do
          end if
       else if(kimg == 2) then
         if(n_ialist0 == 1) then
             lmta2 = lmta(lmt2,ia_list(1))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr = bWr(lmta2,iter_rmm,ib); bWFi = bWi(lmta2,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc = sc_x(iadd,1)-e*qc_x(iadd,1);  sseqs = ss_x(iadd,1)-e*qs_x(iadd,1)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*sceqc-bWFi*sseqs
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi*sceqc+bWFr*sseqs
                end do
             end do
          else if(n_ialist0 == 2) then
             lmta2_1 = lmta(lmt2,ia_list(1)); lmta2_2 = lmta(lmt2,ia_list(2))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc_1 = sc_x(iadd,1)-e*qc_x(iadd,1);  sseqs_1 = ss_x(iadd,1)-e*qs_x(iadd,1)
                   sceqc_2 = sc_x(iadd,2)-e*qc_x(iadd,2);  sseqs_2 = ss_x(iadd,2)-e*qs_x(iadd,2)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*sceqc_1-bWFi_1*sseqs_1 + bWFr_2*sceqc_2-bWFi_2*sseqs_2
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi_1*sceqc_1+bWFr_1*sseqs_1 + bWFi_2*sceqc_2+bWFr_2*sseqs_2
                end do
             end do
          else if(n_ialist0 == 3) then
             lmta2_1 = lmta(lmt2,ia_list(1)); lmta2_2 = lmta(lmt2,ia_list(2)); lmta2_3 = lmta(lmt2,ia_list(3))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib)
                bWFr_3 = bWr(lmta2_3,iter_rmm,ib); bWFi_3 = bWi(lmta2_3,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc_1 = sc_x(iadd,1)-e*qc_x(iadd,1);  sseqs_1 = ss_x(iadd,1)-e*qs_x(iadd,1)
                   sceqc_2 = sc_x(iadd,2)-e*qc_x(iadd,2);  sseqs_2 = ss_x(iadd,2)-e*qs_x(iadd,2)
                   sceqc_3 = sc_x(iadd,3)-e*qc_x(iadd,3);  sseqs_3 = ss_x(iadd,3)-e*qs_x(iadd,3)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*sceqc_1-bWFi_1*sseqs_1 + bWFr_2*sceqc_2-bWFi_2*sseqs_2 &
                                                             + bWFr_3*sceqc_3-bWFi_3*sseqs_3
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi_1*sceqc_1+bWFr_1*sseqs_1 + bWFi_2*sceqc_2+bWFr_2*sseqs_2 &
                                                             + bWFi_3*sceqc_3+bWFr_3*sseqs_3
                end do
             end do
          else if(n_ialist0 == 4) then
             lmta2_1=lmta(lmt2,ia_list(1)); lmta2_2=lmta(lmt2,ia_list(2)); lmta2_3=lmta(lmt2,ia_list(3));lmta2_4=lmta(lmt2,ia_list(4))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib)
                bWFr_3 = bWr(lmta2_3,iter_rmm,ib); bWFi_3 = bWi(lmta2_3,iter_rmm,ib)
                bWFr_4 = bWr(lmta2_4,iter_rmm,ib); bWFi_4 = bWi(lmta2_4,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc_1 = sc_x(iadd,1)-e*qc_x(iadd,1);  sseqs_1 = ss_x(iadd,1)-e*qs_x(iadd,1)
                   sceqc_2 = sc_x(iadd,2)-e*qc_x(iadd,2);  sseqs_2 = ss_x(iadd,2)-e*qs_x(iadd,2)
                   sceqc_3 = sc_x(iadd,3)-e*qc_x(iadd,3);  sseqs_3 = ss_x(iadd,3)-e*qs_x(iadd,3)
                   sceqc_4 = sc_x(iadd,4)-e*qc_x(iadd,4);  sseqs_4 = ss_x(iadd,4)-e*qs_x(iadd,4)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*sceqc_1-bWFi_1*sseqs_1 + bWFr_2*sceqc_2-bWFi_2*sseqs_2 &
                                                             + bWFr_3*sceqc_3-bWFi_3*sseqs_3 + bWFr_4*sceqc_4-bWFi_4*sseqs_4
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi_1*sceqc_1+bWFr_1*sseqs_1 + bWFi_2*sceqc_2+bWFr_2*sseqs_2 &
                                                             + bWFi_3*sceqc_3+bWFr_3*sseqs_3 + bWFi_4*sceqc_4+bWFr_4*sseqs_4
                end do
             end do
          else if(n_ialist0 == 5) then
             lmta2_1=lmta(lmt2,ia_list(1)); lmta2_2=lmta(lmt2,ia_list(2)); lmta2_3=lmta(lmt2,ia_list(3));lmta2_4=lmta(lmt2,ia_list(4))
             lmta2_5=lmta(lmt2,ia_list(5))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib)
                bWFr_3 = bWr(lmta2_3,iter_rmm,ib); bWFi_3 = bWi(lmta2_3,iter_rmm,ib)
                bWFr_4 = bWr(lmta2_4,iter_rmm,ib); bWFi_4 = bWi(lmta2_4,iter_rmm,ib)
                bWFr_5 = bWr(lmta2_5,iter_rmm,ib); bWFi_5 = bWi(lmta2_5,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc_1 = sc_x(iadd,1)-e*qc_x(iadd,1);  sseqs_1 = ss_x(iadd,1)-e*qs_x(iadd,1)
                   sceqc_2 = sc_x(iadd,2)-e*qc_x(iadd,2);  sseqs_2 = ss_x(iadd,2)-e*qs_x(iadd,2)
                   sceqc_3 = sc_x(iadd,3)-e*qc_x(iadd,3);  sseqs_3 = ss_x(iadd,3)-e*qs_x(iadd,3)
                   sceqc_4 = sc_x(iadd,4)-e*qc_x(iadd,4);  sseqs_4 = ss_x(iadd,4)-e*qs_x(iadd,4)
                   sceqc_5 = sc_x(iadd,5)-e*qc_x(iadd,5);  sseqs_5 = ss_x(iadd,5)-e*qs_x(iadd,5)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*sceqc_1-bWFi_1*sseqs_1 + bWFr_2*sceqc_2-bWFi_2*sseqs_2 &
                                                             + bWFr_3*sceqc_3-bWFi_3*sseqs_3 + bWFr_4*sceqc_4-bWFi_4*sseqs_4 &
                                                             + bWFr_5*sceqc_5-bWFi_5*sseqs_5
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi_1*sceqc_1+bWFr_1*sseqs_1 + bWFi_2*sceqc_2+bWFr_2*sseqs_2 &
                                                             + bWFi_3*sceqc_3+bWFr_3*sseqs_3 + bWFi_4*sceqc_4+bWFr_4*sseqs_4 &
                                                             + bWFi_5*sceqc_5+bWFr_3*sseqs_5
                end do
             end do
          else if(n_ialist0 == 6) then
             lmta2_1=lmta(lmt2,ia_list(1)); lmta2_2=lmta(lmt2,ia_list(2)); lmta2_3=lmta(lmt2,ia_list(3));lmta2_4=lmta(lmt2,ia_list(4))
             lmta2_5=lmta(lmt2,ia_list(5)); lmta2_6=lmta(lmt2,ia_list(6))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib)
                bWFr_3 = bWr(lmta2_3,iter_rmm,ib); bWFi_3 = bWi(lmta2_3,iter_rmm,ib)
                bWFr_4 = bWr(lmta2_4,iter_rmm,ib); bWFi_4 = bWi(lmta2_4,iter_rmm,ib)
                bWFr_5 = bWr(lmta2_5,iter_rmm,ib); bWFi_5 = bWi(lmta2_5,iter_rmm,ib)
                bWFr_6 = bWr(lmta2_6,iter_rmm,ib); bWFi_6 = bWi(lmta2_6,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc_1 = sc_x(iadd,1)-e*qc_x(iadd,1);  sseqs_1 = ss_x(iadd,1)-e*qs_x(iadd,1)
                   sceqc_2 = sc_x(iadd,2)-e*qc_x(iadd,2);  sseqs_2 = ss_x(iadd,2)-e*qs_x(iadd,2)
                   sceqc_3 = sc_x(iadd,3)-e*qc_x(iadd,3);  sseqs_3 = ss_x(iadd,3)-e*qs_x(iadd,3)
                   sceqc_4 = sc_x(iadd,4)-e*qc_x(iadd,4);  sseqs_4 = ss_x(iadd,4)-e*qs_x(iadd,4)
                   sceqc_5 = sc_x(iadd,5)-e*qc_x(iadd,5);  sseqs_5 = ss_x(iadd,5)-e*qs_x(iadd,5)
                   sceqc_6 = sc_x(iadd,6)-e*qc_x(iadd,6);  sseqs_6 = ss_x(iadd,6)-e*qs_x(iadd,6)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*sceqc_1-bWFi_1*sseqs_1 + bWFr_2*sceqc_2-bWFi_2*sseqs_2 &
                                                             + bWFr_3*sceqc_3-bWFi_3*sseqs_3 + bWFr_4*sceqc_4-bWFi_4*sseqs_4 &
                                                             + bWFr_5*sceqc_5-bWFi_5*sseqs_5 + bWFr_6*sceqc_6-bWFi_6*sseqs_6
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi_1*sceqc_1+bWFr_1*sseqs_1 + bWFi_2*sceqc_2+bWFr_2*sseqs_2 &
                                                             + bWFi_3*sceqc_3+bWFr_3*sseqs_3 + bWFi_4*sceqc_4+bWFr_4*sseqs_4 &
                                                             + bWFi_5*sceqc_5+bWFr_5*sseqs_5 + bWFi_6*sceqc_6+bWFr_6*sseqs_6
                end do
             end do
          else if(n_ialist0 == 7) then
             lmta2_1=lmta(lmt2,ia_list(1)); lmta2_2=lmta(lmt2,ia_list(2)); lmta2_3=lmta(lmt2,ia_list(3));lmta2_4=lmta(lmt2,ia_list(4))
             lmta2_5=lmta(lmt2,ia_list(5)); lmta2_6=lmta(lmt2,ia_list(6)); lmta2_7=lmta(lmt2,ia_list(7))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib)
                bWFr_3 = bWr(lmta2_3,iter_rmm,ib); bWFi_3 = bWi(lmta2_3,iter_rmm,ib)
                bWFr_4 = bWr(lmta2_4,iter_rmm,ib); bWFi_4 = bWi(lmta2_4,iter_rmm,ib)
                bWFr_5 = bWr(lmta2_5,iter_rmm,ib); bWFi_5 = bWi(lmta2_5,iter_rmm,ib)
                bWFr_6 = bWr(lmta2_6,iter_rmm,ib); bWFi_6 = bWi(lmta2_6,iter_rmm,ib)
                bWFr_7 = bWr(lmta2_7,iter_rmm,ib); bWFi_7 = bWi(lmta2_7,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc_1 = sc_x(iadd,1)-e*qc_x(iadd,1);  sseqs_1 = ss_x(iadd,1)-e*qs_x(iadd,1)
                   sceqc_2 = sc_x(iadd,2)-e*qc_x(iadd,2);  sseqs_2 = ss_x(iadd,2)-e*qs_x(iadd,2)
                   sceqc_3 = sc_x(iadd,3)-e*qc_x(iadd,3);  sseqs_3 = ss_x(iadd,3)-e*qs_x(iadd,3)
                   sceqc_4 = sc_x(iadd,4)-e*qc_x(iadd,4);  sseqs_4 = ss_x(iadd,4)-e*qs_x(iadd,4)
                   sceqc_5 = sc_x(iadd,5)-e*qc_x(iadd,5);  sseqs_5 = ss_x(iadd,5)-e*qs_x(iadd,5)
                   sceqc_6 = sc_x(iadd,6)-e*qc_x(iadd,6);  sseqs_6 = ss_x(iadd,6)-e*qs_x(iadd,6)
                   sceqc_7 = sc_x(iadd,7)-e*qc_x(iadd,7);  sseqs_7 = ss_x(iadd,7)-e*qs_x(iadd,7)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*sceqc_1-bWFi_1*sseqs_1 + bWFr_2*sceqc_2-bWFi_2*sseqs_2 &
                                                             + bWFr_3*sceqc_3-bWFi_3*sseqs_3 + bWFr_4*sceqc_4-bWFi_4*sseqs_4 &
                                                             + bWFr_5*sceqc_5-bWFi_5*sseqs_5 + bWFr_6*sceqc_6-bWFi_6*sseqs_6 &
                                                             + bWFr_7*sceqc_7-bWFi_7*sseqs_7
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi_1*sceqc_1+bWFr_1*sseqs_1 + bWFi_2*sceqc_2+bWFr_2*sseqs_2 &
                                                             + bWFi_3*sceqc_3+bWFr_3*sseqs_3 + bWFi_4*sceqc_4+bWFr_4*sseqs_4 &
                                                             + bWFi_5*sceqc_5+bWFr_5*sseqs_5 + bWFi_6*sceqc_6+bWFr_6*sseqs_6 &
                                                             + bWFi_7*sceqc_7+bWFr_7*sseqs_7
                end do
             end do
          else if(n_ialist0 >= 8) then
             lmta2_1=lmta(lmt2,ia_list(1)); lmta2_2=lmta(lmt2,ia_list(2)); lmta2_3=lmta(lmt2,ia_list(3));lmta2_4=lmta(lmt2,ia_list(4))
             lmta2_5=lmta(lmt2,ia_list(5)); lmta2_6=lmta(lmt2,ia_list(6)); lmta2_7=lmta(lmt2,ia_list(7));lmta2_8=lmta(lmt2,ia_list(8))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib)
                bWFr_3 = bWr(lmta2_3,iter_rmm,ib); bWFi_3 = bWi(lmta2_3,iter_rmm,ib)
                bWFr_4 = bWr(lmta2_4,iter_rmm,ib); bWFi_4 = bWi(lmta2_4,iter_rmm,ib)
                bWFr_5 = bWr(lmta2_5,iter_rmm,ib); bWFi_5 = bWi(lmta2_5,iter_rmm,ib)
                bWFr_6 = bWr(lmta2_6,iter_rmm,ib); bWFi_6 = bWi(lmta2_6,iter_rmm,ib)
                bWFr_7 = bWr(lmta2_7,iter_rmm,ib); bWFi_7 = bWi(lmta2_7,iter_rmm,ib)
                bWFr_8 = bWr(lmta2_8,iter_rmm,ib); bWFi_8 = bWi(lmta2_8,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc_1 = sc_x(iadd,1)-e*qc_x(iadd,1);  sseqs_1 = ss_x(iadd,1)-e*qs_x(iadd,1)
                   sceqc_2 = sc_x(iadd,2)-e*qc_x(iadd,2);  sseqs_2 = ss_x(iadd,2)-e*qs_x(iadd,2)
                   sceqc_3 = sc_x(iadd,3)-e*qc_x(iadd,3);  sseqs_3 = ss_x(iadd,3)-e*qs_x(iadd,3)
                   sceqc_4 = sc_x(iadd,4)-e*qc_x(iadd,4);  sseqs_4 = ss_x(iadd,4)-e*qs_x(iadd,4)
                   sceqc_5 = sc_x(iadd,5)-e*qc_x(iadd,5);  sseqs_5 = ss_x(iadd,5)-e*qs_x(iadd,5)
                   sceqc_6 = sc_x(iadd,6)-e*qc_x(iadd,6);  sseqs_6 = ss_x(iadd,6)-e*qs_x(iadd,6)
                   sceqc_7 = sc_x(iadd,7)-e*qc_x(iadd,7);  sseqs_7 = ss_x(iadd,7)-e*qs_x(iadd,7)
                   sceqc_8 = sc_x(iadd,8)-e*qc_x(iadd,8);  sseqs_8 = ss_x(iadd,8)-e*qs_x(iadd,8)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*sceqc_1-bWFi_1*sseqs_1 + bWFr_2*sceqc_2-bWFi_2*sseqs_2 &
                                                             + bWFr_3*sceqc_3-bWFi_3*sseqs_3 + bWFr_4*sceqc_4-bWFi_4*sseqs_4 &
                                                             + bWFr_5*sceqc_5-bWFi_5*sseqs_5 + bWFr_6*sceqc_6-bWFi_6*sseqs_6 &
                                                             + bWFr_7*sceqc_7-bWFi_7*sseqs_7 + bWFr_8*sceqc_8-bWFi_8*sseqs_8
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi_1*sceqc_1+bWFr_1*sseqs_1 + bWFi_2*sceqc_2+bWFr_2*sseqs_2 &
                                                             + bWFi_3*sceqc_3+bWFr_3*sseqs_3 + bWFi_4*sceqc_4+bWFr_4*sseqs_4 &
                                                             + bWFi_5*sceqc_5+bWFr_5*sseqs_5 + bWFi_6*sceqc_6+bWFr_6*sseqs_6 &
                                                             + bWFi_7*sceqc_7+bWFr_7*sseqs_7 + bWFi_8*sceqc_8+bWFr_8*sseqs_8
                end do
             end do
          end if
          if(n_ialist0 > 8) then
             do iap = 9, n_ialist0
                ia = ia_list(iap)
                lmta2 = lmta(lmt2,ia)
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
                do ib = 1, np_e
                   bWFr = bWr(lmta2,iter_rmm,ib); bWFi = bWi(lmta2,iter_rmm,ib); e = eko_l(ib,ik)
                   do i = ista_g1k(ik), iend_g1k(ik)
                      iadd = i - ista_g1k(ik) + 1
                      sceqc = sc_x(iadd,iap)-e*qc_x(iadd,iap)
                      sseqs = ss_x(iadd,iap)-e*qs_x(iadd,iap)
                      vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*sceqc-bWFi*sseqs
                      vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi*sceqc+bWFr*sseqs
                   end do
                enddo
            end do
         end if
       end if

#else
!  --> for ordinary scaler and vector machines but HIUX
!  = #ifndef HIUX

       if(kimg == 1) then
          do iap = 1, n_ialist0
             ia = ia_list(iap)
             lmta2 = lmta(lmt2,ia)
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr = bWr(lmta2,iter_rmm,ib); bWFi = bWi(lmta2,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*(sc_x(iadd,iap)-e*qc_x(iadd,iap)) &
                                                             - bWFi*(ss_x(iadd,iap)-e*qs_x(iadd,iap))
                enddo
             end do
          end do
       else if(kimg == 2) then
          do iap = 1, n_ialist0
             ia = ia_list(iap)
             lmta2 = lmta(lmt2,ia)
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr = bWr(lmta2,iter_rmm,ib); bWFi = bWi(lmta2,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc = sc_x(iadd,iap)-e*qc_x(iadd,iap)
                   sseqs = ss_x(iadd,iap)-e*qs_x(iadd,iap)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*sceqc-bWFi*sseqs
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi*sceqc+bWFr*sseqs
                end do
             enddo
          end do
       endif
#endif
       call tstatc0_end(id_sname)
     end subroutine add_vnlph_l_with_eko_part3

     subroutine Vnonlocal_W_part_sum_over_lmt1b()
       integer             :: lmt1, lmtt1, il1, im1, il11, mdl, iksnl,il2,im2, ia_p, ia, i, ii, iadd
       real(kind=DP)       :: tmp

       integer :: id_sname = -1
       call tstatc0_begin('Vnonlocal_W_part_sum_over_lmt1 ',id_sname)

       iksnl = (ik-1)/nspin + 1
       il2   = ltp(lmt2,it)
       im2   = mtp(lmt2,it)

       sc_x = 0.d0; ss_x = 0.d0
       if(mdvdb == EXECUT) then
          qc_x = 0.d0; qs_x = 0.d0
       endif

       do lmt1 = 1,ilmt(it)
          lmtt1 = lmtt(lmt1,it)
          il1   = ltp(lmt1,it)
          im1   = mtp(lmt1,it)
          il11  = il1 - 1
          mdl   = mod(il11,4)

          do ia_p = 1, n_ialist0
             ia = ia_list(ia_p)
             if(il1 == il2 .and. im1 == im2) then
!!$                tmp = (dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)) * iwei(ia)
                if(ipaw(it)==0) then
                    tmp = (dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)) * iwei(ia)
                else
                    tmp = (dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)) * iwei(ia)
                end if
             else
!!$                tmp = vlhxcQ(lmt1,lmt2,ia,ispin) * iwei(ia)
                if(ipaw(it)==0) then
                    tmp = vlhxcQ(lmt1,lmt2,ia,ispin) * iwei(ia)
                else
                    tmp = (dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)) * iwei(ia)
                end if
             endif
             if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
             fq(ia_p,1) = tmp
          end do

          if(mdvdb == EXECUT .and. il1 == il2 .and. im1 == im2) then
             do ia_p = 1, n_ialist0
                ia = ia_list(ia_p)
                tmp = q(lmt1,lmt2,it)*iwei(ia)
                if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
                fq(ia_p,2) = tmp
             end do

             if(mdl == 0 .or. mdl == 2) then
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
                do ia_p = 1, n_ialist0
                   do i = ista_g1k(ik), iend_g1k(ik)
                      iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/07/12 ================================================
!                     sc_x(iadd,ia_p) = sc_x(iadd,ia_p) + fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                     ss_x(iadd,ia_p) = ss_x(iadd,ia_p) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                     qc_x(iadd,ia_p) = qc_x(iadd,ia_p) + fq(ia_p,2)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                     qs_x(iadd,ia_p) = qs_x(iadd,ia_p) - fq(ia_p,2)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
                      sc_x(iadd,ia_p) = sc_x(iadd,ia_p) + fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                      ss_x(iadd,ia_p) = ss_x(iadd,ia_p) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                      qc_x(iadd,ia_p) = qc_x(iadd,ia_p) + fq(ia_p,2)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                      qs_x(iadd,ia_p) = qs_x(iadd,ia_p) - fq(ia_p,2)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                   end do
                end do
             else if(mdl == 1 .or. mdl == 3) then
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
                do ia_p = 1, n_ialist0
                   do i = ista_g1k(ik), iend_g1k(ik)
                      iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/07/12 ================================================
!                     sc_x(iadd,ia_p) = sc_x(iadd,ia_p) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                     ss_x(iadd,ia_p) = ss_x(iadd,ia_p) - fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                     qc_x(iadd,ia_p) = qc_x(iadd,ia_p) - fq(ia_p,2)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                     qs_x(iadd,ia_p) = qs_x(iadd,ia_p) - fq(ia_p,2)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
                      sc_x(iadd,ia_p) = sc_x(iadd,ia_p) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                      ss_x(iadd,ia_p) = ss_x(iadd,ia_p) - fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                      qc_x(iadd,ia_p) = qc_x(iadd,ia_p) - fq(ia_p,2)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                      qs_x(iadd,ia_p) = qs_x(iadd,ia_p) - fq(ia_p,2)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                   end do
                end do
             end if
          else
             if(mdl == 0 .or. mdl == 2) then
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
                do ia_p = 1, n_ialist0
                   do i = ista_g1k(ik), iend_g1k(ik)
                      iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/07/12 ================================================
!                     sc_x(iadd,ia_p) = sc_x(iadd,ia_p) + fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                     ss_x(iadd,ia_p) = ss_x(iadd,ia_p) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
                      sc_x(iadd,ia_p) = sc_x(iadd,ia_p) + fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                      ss_x(iadd,ia_p) = ss_x(iadd,ia_p) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                   end do
                end do
             else if(mdl == 1 .or. mdl == 3) then
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
                do ia_p = 1, n_ialist0
                   do i = ista_g1k(ik), iend_g1k(ik)
                      iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/07/12 ================================================
!                     sc_x(iadd,ia_p) = sc_x(iadd,ia_p) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                     ss_x(iadd,ia_p) = ss_x(iadd,ia_p) - fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
                      sc_x(iadd,ia_p) = sc_x(iadd,ia_p) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                      ss_x(iadd,ia_p) = ss_x(iadd,ia_p) - fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                   end do
                end do
             end if
          end if
       end do

       call tstatc0_end(id_sname)
     end subroutine Vnonlocal_W_part_sum_over_lmt1b
#endif
  end subroutine Vnonlocal_W_RMMn_3D

end module m_ES_WF_by_RMM

logical function itr_first_paw()
    use m_IterationNumbers,   only : iteration
    use m_PseudoPotential,    only : flg_paw
    implicit none
        
    itr_first_paw=(iteration==1.and.flg_paw)
    return
end function itr_first_paw

logical function use_paw()
    use m_PseudoPotential,    only : flg_paw
    use_paw=flg_paw
    return
end function use_paw
    
    
    
    

!#========================================================================
!#                                                                       #
!# Software Name : UVSOR ver. 3.01                                       #
!#                                                                       #
!#      Sub Routine : WriteDownData_onto_Files_Eps                       #
!#                                                                       #
!#                                Written by T. Hamada 2006/4/28         #
!#                                                                       #
!#      Contact address :  IIS,The University of Tokyo RSS21 project     #
!#                                                                       #
!#"Multiscale Simulation System for Functional Analysis of Nanomaterials"#
!#                                                                       #
!#========================================================================
!
! $Id: WriteDownData_onto_Files_Epsilon.f90 593 2019-06-20 03:47:31Z jkoga $
subroutine WriteDownData_onto_Files_Eps
  use m_Epsilon_ek,           only : nlo, wd_eps, dealloc_m_Epsilon, &
       &                             kv3_in_the_ek_process
  use m_Files,                only : m_Files_close_nfeps, m_Files_close_nfepscont, &
       &                             m_Files_close_nfnlo
  use m_Kpoints,              only : kv3

  use m_Control_Parameters,   only : sw_corelevel_spectrum, sw_local_approx_trans_moment, ipritiming
  use m_Const_Parameters,     only : ON
  use m_Timing,               only : tstatc_wd0

  implicit none

  if ( sw_corelevel_spectrum == ON .and. sw_local_approx_trans_moment == ON ) then
     call dealloc_m_Epsilon
  else
     call wd_eps
     call dealloc_m_Epsilon
     call m_Files_close_nfeps
     call m_Files_close_nfepscont
  endif
  if(nlo/=0) call m_Files_close_nfnlo
  if(ipritiming>=2) call tstatc_wd0

end subroutine WriteDownData_onto_Files_Eps

!================================================
!  Software name : STM
!  Module : m_PlaneWaveBasisSet
!  Subroutine(s) : wd_planewavebasisset, m_pwBS_rd_data,
!                  m_pwBS_kintetic_energies,
!                  m_pwBS_set_FFT_mapfunctions
!  Author(s)     : Takahiro Yamasaki (June 7, 2004)
!
!  FURTHER MODIFICATION: Junichiro  Koga (June 24, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

module m_PlaneWaveBasisSet
! $Id: m_PlaneWaveBasisSet.f90,v 1.1.1.1 2004/06/26 11:21:37 yamasaki Exp $
  use m_ArraySize_Parameters,only : kng,kng1,knv3,kngp
  use m_Const_Parameters,    only : DP, BEGIN, END, CARTS, BUCS, CRDTYP
  use m_Kpoints,             only : vkxyz
  use m_Control_Parameters,  only : n_fc, nc_z

  implicit none

!  integer, dimension(kngp,3)      :: ngabc
  integer, allocatable, dimension(:,:)      :: ngabc
!  real(kind=DP), dimension(kngp)  :: gr_l

!  integer, dimension(kng)         :: igf
!  integer, dimension(kngp)        :: igfp_l
!  integer, dimension(kngp)        :: igfpf_l
  integer, allocatable, dimension(:)         :: igf
  integer, allocatable, dimension(:)        :: igfp_l
  integer, allocatable, dimension(:)        :: igfpf_l

  integer                         :: kg, kgp
!!$  integer, dimension(3)           :: n_rGv
!!$  integer, dimension(3)           :: n_rGpv
  ! n_rG(p)v is the size of a rhombohedron which contains
  ! a sphere whose radius is 2*Gmax (Gmaxp) .

!  integer       :: nbase(kng1,knv3) ! PW Basis Set for each k-points
!  integer       :: iba(knv3)
  integer, allocatable, dimension(:,:)      :: nbase ! PW Basis Set for each k-points
  integer, allocatable, dimension(:)        :: iba

  real(kind=DP), dimension(6) :: ttr

contains

  subroutine wd_planewavebasisset_data(nfcntn_bin)
    integer, intent(in) :: nfcntn_bin
    write(nfcntn_bin) ngabc
    write(nfcntn_bin) igf
    write(nfcntn_bin) igfp_l
    write(nfcntn_bin) kg, kgp
    write(nfcntn_bin) nbase
    write(nfcntn_bin) iba
    write(nfcntn_bin) ttr
  end subroutine wd_planewavebasisset_data

  subroutine m_pwBS_rd_data(nfcntn_bin)
    integer, intent(in) :: nfcntn_bin

    allocate(ngabc(kngp,3))
    allocate(igf(kng))
    allocate(igfp_l(kngp))
    allocate(igfpf_l(kngp))
    allocate(nbase(kng1,knv3))
    allocate(iba(knv3))

    read(nfcntn_bin) ngabc
    read(nfcntn_bin) igf
    read(nfcntn_bin) igfp_l
    read(nfcntn_bin) kg, kgp
    read(nfcntn_bin) nbase
    read(nfcntn_bin) iba
    read(nfcntn_bin) ttr
 !   call calc_length_of_G
  end subroutine m_pwBS_rd_data
       
!!$  subroutine calc_length_of_G
!!$    integer :: i
!!$    do i = 1, kgp
!!$       gr_l(i) =      dsqrt(ttr(1)*ngabc(i,1)*ngabc(i,1) &
!!$            &             + ttr(2)*ngabc(i,2)*ngabc(i,2) &
!!$            &             + ttr(3)*ngabc(i,3)*ngabc(i,3) &
!!$            &             + ttr(4)*ngabc(i,1)*ngabc(i,2) &
!!$            &             + ttr(5)*ngabc(i,2)*ngabc(i,3) &
!!$            &             + ttr(6)*ngabc(i,3)*ngabc(i,1))
!!$    enddo
!!$  end subroutine calc_length_of_G

  subroutine m_pwBS_kinetic_energies(ik,vkxyz,ekin,nmp,nnp)
    integer, intent(in)       :: ik
    real(kind=DP), intent(in) :: vkxyz(knv3,3,CRDTYP)
    real(kind=DP), intent(out):: ekin(*) ! d(nmp*nnp)
    integer, intent(in)       :: nmp,nnp

    integer i, j, jj, k, kk
    real(kind=DP) :: gb,gc
    integer       :: id_sname = -1

    real*8 :: ttr2, ttr3, ttr5

    if(nc_z .eq. 1) then
       ttr2 = ttr(2); ttr3 = ttr(3); ttr5 = ttr(5)
    else if(nc_z .eq. 2) then
       ttr2 = ttr(1); ttr3 = ttr(3); ttr5 = ttr(6)
    else if(nc_z .eq. 3) then
       ttr2 = ttr(1); ttr3 = ttr(2); ttr5 = ttr(4)
    end if

    i = 0
    do j = 1, nmp
       jj = j
       if (jj > nmp/2 ) jj = jj -nmp
       do k = 1, nnp
          kk = k
          if ( kk > nnp/2 ) kk = kk -nnp
          gb = vkxyz(ik,n_fc(2),BUCS) + jj
          gc = vkxyz(ik,n_fc(3),BUCS) + kk
          i = i + 1
          ekin(i) = ( ttr2*gb*gb + ttr3*gc*gc  + ttr5*gb*gc )*0.5d0
!
       end do
    end do
  end subroutine m_pwBS_kinetic_energies

  subroutine m_pwBS_set_FFT_mapfunctions(fft_box_size_WF &
       &, fft_box_size_CD, fft_box_size_fine)
    integer, intent(in), dimension(0:3)    :: fft_box_size_WF
    integer, intent(in), dimension(0:3)    :: fft_box_size_CD
    integer, intent(in), dimension(0:3)    :: fft_box_size_fine
      
    integer id, i
    integer igf1, igf2, igf3
    integer               :: id_sname = -1

    id = fft_box_size_WF(0)
    do i = 1, kg
       igf1 = ngabc(i,1) + 1
       igf2 = ngabc(i,2) + 1
       igf3 = ngabc(i,3) + 1
       if(ngabc(i,1) <= -1) igf1 = igf1 + fft_box_size_WF(1)
       if(ngabc(i,2) <= -1) igf2 = igf2 + fft_box_size_WF(2)
       if(ngabc(i,3) <= -1) igf3 = igf3 + fft_box_size_WF(3)
       igf(i) = igf1 + (igf2-1)*id + (igf3-1)*id*fft_box_size_WF(2)
    enddo

    id = fft_box_size_CD(0)
    do i = 1, kgp
       igf1 = ngabc(i,1) + 1
       igf2 = ngabc(i,2) + 1
       igf3 = ngabc(i,3) + 1
       if(ngabc(i,1) <= -1) igf1 = igf1 + fft_box_size_CD(1)
       if(ngabc(i,2) <= -1) igf2 = igf2 + fft_box_size_CD(2)
       if(ngabc(i,3) <= -1) igf3 = igf3 + fft_box_size_CD(3)
       igfp_l(i) = igf1 + (igf2-1)*id + (igf3-1)*id*fft_box_size_CD(2)
    enddo

    id = fft_box_size_fine(0)
    do i = 1, kgp
!!$       igf1 = ngabc(i,1) + 1
!!$       igf2 = ngabc(i,2) + 1
!!$       igf3 = ngabc(i,3) + 1
       igf1 = ngabc(i,n_fc(1)) + 1
       igf2 = ngabc(i,n_fc(2)) + 1
       igf3 = ngabc(i,n_fc(3)) + 1
!!$       if(ngabc(i,1) <= -1) igf1 = igf1 + fft_box_size_fine(1)
!!$       if(ngabc(i,2) <= -1) igf2 = igf2 + fft_box_size_fine(2)
!!$       if(ngabc(i,3) <= -1) igf3 = igf3 + fft_box_size_fine(3)
       if(ngabc(i,n_fc(1)) <= -1) igf1 = igf1 + fft_box_size_fine(1)
       if(ngabc(i,n_fc(2)) <= -1) igf2 = igf2 + fft_box_size_fine(2)
       if(ngabc(i,n_fc(3)) <= -1) igf3 = igf3 + fft_box_size_fine(3)
       igfpf_l(i) = igf1 + (igf2-1)*id + (igf3-1)*id*fft_box_size_fine(2)
    enddo

  end subroutine m_pwBS_set_FFT_mapfunctions

end module m_PlaneWaveBasisSet

! Copyright (c) 2012, Minoru Otani <minoru.otani@aist.go.jp> 
! 
! Permission is hereby granted, free of charge, to any person 
! obtaining a copy of this software and associated documentation 
! files (the "Software"), to deal in the Software without restriction, 
! including without limitation the rights to use, copy, modify, merge, 
! publish, distribute, sublicense, and/or sell copies of the Software, 
! and to permit persons to whom the Software is furnished to do so, 
! subject to the following conditions:
 
! The above copyright notice and this permission notice shall be 
! included in all copies or substantial portions of the Software.
 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
! EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
! OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
! NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
! HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
! WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
! DEALINGS IN THE SOFTWARE.

Function qe_erf(x)
  Implicit none
  Real(8), Intent(In)  :: x
  Real(8) :: qe_erf
  qe_erf = erf(x)
End Function qe_erf

Function qe_erfc(x)
  Implicit none
  Real(8), Intent(In)  :: x
  Real(8) :: qe_erfc
  qe_erfc = erfc(x)
End Function qe_erfc

! --------------------------------------------------------
!
!  hybridized_kinetic_energy_fuctional
!
!   T_kin[rho] = a *T_TF[rho] + b *T_vW[rho];
!                             TF = Thomas Fermi,  vW = von Weizsacker
!
!    a: weight_TF_functional,  b: weight_Weiz_functional
!
! --------------------------------------------------------

module m_ThomasFermiW_Potential

  use m_Const_Parameters,  only : DP, CMPLDP, zi, PAI4, PAI2, PAI, ON, OFF

  use m_Control_Parameters,  only : kimg, nspin, sw_hubbard, &
       &                            use_averaged_nonlocal, use_deltaW, use_deltaV, &
       &                            weight_TF_functional, weight_Weiz_functional, &
       &                            ipritfwfunc, amin, use_preconditioning

  use m_Parallelization, only :  ista_kngp,iend_kngp, ista_fftp, iend_fftp, &
       &                         nel_fftp, nis_fftp, nie_fftp, ista_fftph, iend_fftph, &
       &                         ierr, MPI_CommGroup, mype, npes, mp_fftp, idisp_fftp, &
       &                         ista_fftp, iend_fftp, ista_k

  use m_Ionic_System,    only : ntyp, natm, ityp, pos, iatomn
  use m_Crystal_Structure,  only : rltv, univol
  use m_PseudoPotential,  only : n_non0_lmtxlmt, m_PP_find_maximum_l, dion, dion_paw, &
       &                         ipaw, il2p, dl2p, isph, mmesh, nmesh, ltp, taup, &
       &                         index_lmt1_lmt2, psir_val, radr, wos, mtp, ilmt, &
       &                         nloc, iloc, ntau, itau, lpsmax
  use m_PlaneWaveBasisSet, only : ngabc, gr_l, igfp_l, kgp_reduced, kg1, kg_tfw, &
       &                          gr_l
  use m_NonLocal_Potential, only : new_radr_and_wos
  use m_Electronic_Structure, only : dhub, vlhxc_l, vlhxc_l_old, totch, efermi

  use m_Charge_Density,  only : chgq_l, hsr, hsro
  use m_CD_Mag_Moment,   only : rad_cov_default, sw_monitor_atomcharge, &
       &                        m_CD_set_rad_cov_default

  use m_FFT,                   only : m_FFT_CD_direct_c, m_FFT_CD_inverse_c, &
       &                              m_FFT_alloc_CD_box, m_FFT_dealloc_CD_box, &
       &                              fft_box_size_CD, nfftp

  use m_Files,     only : nfout

  use m_Potential_Mixing,  only :   c_p_pot => c_p, precon_4_pot_mix
  use mpi

  implicit none
!  include 'mpif.h'

! --------------------------------------------------------
! nonlocal avgeraged potential
!
  integer, allocatable :: Table_for_ChargeDensityBasisFn(:,:,:,:)
  real(kind=DP), allocatable :: ChargeDensityBasisFn(:,:,:)
  real(kind=DP), allocatable :: vnonlocal_avg(:,:,:)
! --------------------------------------------------------
! Thomas Fermi von Weizsacker functional
!
  real(kind=DP) :: Coeff_TF
!
  real(kind=DP), allocatable :: Psi(:,:,:), Phi(:,:,:), Phi_Old(:,:,:)
  real(kind=DP), allocatable :: Zeta(:,:,:), deltaW(:,:,:), deltaV(:,:,:)
!
  real(kind=DP), allocatable :: Psi_Old(:,:,:), Vkin_TF(:,:,:)
  real(kind=DP), allocatable :: Vin_tfw(:,:,:), Vlda_tfw(:,:,:), Vout_tfw(:,:,:)
! --------------------------------------------------------
contains

! --------------------------------------------------------
!
! The "atomic wave funcions" Psir_val are normalized.
!
! --------------------------------------------------------
  subroutine m_TFW_normalize_psir_val
    integer :: it, ik, ilmt1, il1, tau1, ir
    real(kind=DP) :: csum, factor, rcut
    real(kind=DP), allocatable :: tmp_fn(:)

    allocate( tmp_fn(mmesh) );  allocate( radr(mmesh) );  allocate( wos(mmesh) )

    Do it=1, ntyp
       ik = ista_k
       call new_radr_and_wos(ik,it)                 ! --> radr, wos

       rcut = rad_cov_default( nint(iatomn(it)) ) ! Revised according to a report from ASMS Co.ltd, 10 March 2016.

       Do il1=1, lpsmax(it)
          if ( il1 == iloc(it) ) cycle

          Do tau1=1, itau(il1,it)
             tmp_fn = 0.0d0
             Do ir=1, nmesh(it)
                tmp_fn(ir) = psir_val(ir,il1,tau1,it) *exp( -radr(ir)/rcut)
             End do

             csum = 0.0d0
             Do ir=1, nmesh(it)
                csum = csum + wos(ir) *tmp_fn(ir)**2
             End do

             factor = 1.0d0 /sqrt(csum)

             psir_val(:,il1,tau1,it) = 0.0d0
             do ir = 1,nmesh(it)
                psir_val(ir,il1,tau1,it) = tmp_fn(ir) *factor
             end do
          End Do
       End Do
    End Do

    call mpi_barrier( MPI_CommGroup, ierr )
    deallocate(tmp_fn); deallocate(radr);  deallocate(wos)

  end subroutine m_TFW_normalize_psir_val

! --------------------------------------------------------
!
! ChargeDensityBasisFn is Fourier transform of
!
! (A-type) :  Psi_lt(r)*Y_lm  *Psi_lt'(r)*Y_lm'
! (B-type) :  Psi_lt(r)*Y_00  *Psi_lt'(r)*Y_00
!                           ( spherically averaged )
!
! --------------------------------------------------------
  subroutine m_TFW_alloc_ChgDensityBasisFn_A
    integer :: num, it

    num = 0
    Do it=1, ntyp
       num = num +n_non0_lmtxlmt(it)
    End do

    allocate( ChargeDensityBasisFn( ista_kngp:iend_kngp, num, 2 ) )
    ChargeDensityBasisFn = 0.0d0
  end subroutine m_TFW_alloc_ChgDensityBasisFn_A

  subroutine m_TFW_alloc_ChgDensityBasisFn_B
    integer :: num, it, il1, tau1, tau2

    allocate( Table_for_ChargeDensityBasisFn( ntyp, nloc, ntau, ntau ) )
    Table_for_ChargeDensityBasisFn = 0

    num = 0
    Do it=1, ntyp
       Do il1=1, lpsmax(it)
          if ( il1 == iloc(it) ) cycle
          do tau1=1, itau(il1,it)
             do tau2=1, itau(il1,it)
                num = num +1
                Table_for_ChargeDensityBasisFn(it,il1,tau1,tau2) = num
             end do
          End do
       End do
    End do

    allocate( ChargeDensityBasisFn( ista_kngp:iend_kngp, num, 1 ) )
    ChargeDensityBasisFn = 0.0d0
  end subroutine m_TFW_alloc_ChgDensityBasisFn_B

  subroutine m_TFW_dealloc_ChgDensityBasisFn
    deallocate( ChargeDensityBasisFn )
    if ( allocated(Table_for_ChargeDensityBasisFn) ) then
       deallocate( Table_for_ChargeDensityBasisFn )
    endif
  end subroutine m_TFW_dealloc_ChgDensityBasisFn

  subroutine m_TFW_set_ChgDensityBasisFn_A
    integer :: lmax, n, ig, ir, num
    integer :: it, ip, ik, nspher
    integer :: ilmt1, ilmt2, il1, il2, tau1, tau2, im1, im2
    real(kind=DP) :: fac, facr, csum
    complex(kind=CMPLDP) :: zfact

    integer, allocatable :: il3(:)
    real(kind=DP), allocatable :: qx(:), qy(:), qz(:), vlength(:)
    real(kind=DP), allocatable :: ylm(:), wka(:), wkb(:)
    complex(kind=CMPLDP), allocatable :: zsnl2(:)

! init ----
    call m_PP_find_maximum_l( lmax )
    n = 2*lmax -1
    allocate(il3(n**2)); call substitute_il3(n**2,il3)
!
    call alloc_arrays

    Do ig=ista_kngp, iend_kngp
       qx(ig) = rltv(1,1)*ngabc(ig,1) +rltv(1,2)*ngabc(ig,2) +rltv(1,3)*ngabc(ig,3)
       qy(ig) = rltv(2,1)*ngabc(ig,1) +rltv(2,2)*ngabc(ig,2) +rltv(2,3)*ngabc(ig,3)
       qz(ig) = rltv(3,1)*ngabc(ig,1) +rltv(3,2)*ngabc(ig,2) +rltv(3,3)*ngabc(ig,3)
       vlength(ig) = sqrt( qx(ig)**2 + qy(ig)**2 + qz(ig)**2 )
    End do

! begin --
!!    fac = PAI4 / univol     !! ??
    fac = sqrt( PAI4 )/ univol

    num = 0
    Do it=1, ntyp
       ik = ista_k
       call new_radr_and_wos(ik,it)                 ! --> radr, wos

       Do ip=1, n_non0_lmtxlmt(it)
          ilmt1 = index_lmt1_lmt2(ip,it,1);  ilmt2 = index_lmt1_lmt2(ip,it,2)

          il1 = ltp(ilmt1,it);  il2 = ltp(ilmt2,it)
          tau1 = taup(ilmt1,it);  tau2 = taup(ilmt2,it)
!
          num = num +1;    zsnl2 = 0.d0

          Do n=1, il2p( ilmt1,ilmt2, it )
             nspher = isph(ilmt1,ilmt2,n,it)
             zfact = zi**il3( nspher) *fac

             call sphr( iend_kngp -ista_kngp +1, nspher, &
                  &     qx(ista_kngp:iend_kngp), &
                  &     qy(ista_kngp:iend_kngp), &
                  &     qz(ista_kngp:iend_kngp), ylm(ista_kngp:iend_kngp) )
                                                        ! -(bottom_Subr.)
             do ir = 1,nmesh(it)
                facr = wos(ir) *psir_val(ir,il1,tau1,it) &
                     &         *psir_val(ir,il2,tau2,it)

                Do ig=ista_kngp, iend_kngp
                   wka(ig) = vlength(ig) *radr(ir)
                End do

                call dsjnv( il3(nspher), iend_kngp -ista_kngp +1, &
                     &      wka(ista_kngp:iend_kngp), &
                     &      wkb(ista_kngp:iend_kngp) )
                                                     ! -(bottom_Subr.)
                Do ig=ista_kngp, iend_kngp
                   zsnl2(ig) = zsnl2(ig) + zfact *facr *wkb(ig) *ylm(ig) &
                        &                        *dl2p(ilmt1,ilmt2,n,it)
                End do
             end do
          End Do

          Do ig=ista_kngp, iend_kngp
             ChargeDensityBasisFn( ig, num, 1 ) = real( zsnl2(ig) )
             ChargeDensityBasisFn( ig, num, 2 ) = aimag( zsnl2(ig) )
          End do
       End Do
    End Do

    call dealloc_arrays;   deallocate( il3 )

  contains

    subroutine alloc_arrays
      allocate( radr(mmesh) ); allocate( wos(mmesh) )
      allocate( qx(ista_kngp:iend_kngp) );
      allocate( qy(ista_kngp:iend_kngp) )
      allocate( qz(ista_kngp:iend_kngp) );
      allocate( ylm(ista_kngp:iend_kngp) ); allocate( vlength(ista_kngp:iend_kngp) )
      allocate( wka(ista_kngp:iend_kngp) );  allocate( wkb(ista_kngp:iend_kngp) )
      allocate( zsnl2(ista_kngp:iend_kngp) )
    end subroutine alloc_arrays

    subroutine dealloc_arrays
      deallocate( radr ); deallocate( wos )
      deallocate( qx ); deallocate( qy );  deallocate( qz ); deallocate( vlength )
      deallocate( wka ); deallocate( wkb ); deallocate( ylm )
      deallocate( zsnl2 )
    end subroutine dealloc_arrays

  end subroutine m_TFW_set_ChgDensityBasisFn_A

  subroutine m_TFW_set_ChgDensityBasisFn_B
    integer :: lmax, n, ig, ir, num
    integer :: it, ip, ik, nspher
    integer :: il1, tau1, tau2
    real(kind=DP) :: fac, facr, csum

    integer, allocatable :: il3(:)
    real(kind=DP), allocatable :: qx(:), qy(:), qz(:), vlength(:)
    real(kind=DP), allocatable :: ylm(:), wka(:), wkb(:)
    real(kind=DP), allocatable :: snl2(:)

! init ----
    call alloc_arrays

    Do ig=ista_kngp, iend_kngp
       qx(ig) = rltv(1,1)*ngabc(ig,1) +rltv(1,2)*ngabc(ig,2) +rltv(1,3)*ngabc(ig,3)
       qy(ig) = rltv(2,1)*ngabc(ig,1) +rltv(2,2)*ngabc(ig,2) +rltv(2,3)*ngabc(ig,3)
       qz(ig) = rltv(3,1)*ngabc(ig,1) +rltv(3,2)*ngabc(ig,2) +rltv(3,3)*ngabc(ig,3)
       vlength(ig) = sqrt( qx(ig)**2 + qy(ig)**2 + qz(ig)**2 )
    End do

! begin --
!!    fac = PAI4 / univol    !???
    fac = sqrt(PAI4) / univol

    Do it=1, ntyp
       ik = ista_k
       call new_radr_and_wos(ik,it)                 ! --> radr, wos

       Do il1=1, lpsmax(it)
          if ( il1 == iloc(it) ) cycle

          do tau1=1, itau(il1,it)
             do tau2=1, itau(il1,it)

                snl2 = 0.0d0;   nspher = 1

                call sphr( iend_kngp -ista_kngp +1, nspher, &
                     &     qx(ista_kngp:iend_kngp), &
                     &     qy(ista_kngp:iend_kngp), &
                     &     qz(ista_kngp:iend_kngp), ylm(ista_kngp:iend_kngp) )
                                                        ! -(bottom_Subr.)
                do ir = 1,nmesh(it)
                   facr = wos(ir) *psir_val(ir,il1,tau1,it) &
                        &         *psir_val(ir,il1,tau2,it)

                   Do ig=ista_kngp, iend_kngp
                      wka(ig) = vlength(ig) *radr(ir)
                   End do

                   call dsjnv( nspher -1, iend_kngp -ista_kngp +1, &
                        &      wka(ista_kngp:iend_kngp), &
                        &      wkb(ista_kngp:iend_kngp) )
                                                     ! -(bottom_Subr.)
                   Do ig=ista_kngp, iend_kngp
                      snl2(ig) = snl2(ig) + fac *facr *wkb(ig) *ylm(ig)
                   End do
                end do

                num = Table_for_ChargeDensityBasisFn( it, il1, tau1, tau2 )
                if ( num == 0 ) stop "PPPPPPP"

                Do ig=ista_kngp, iend_kngp
                   ChargeDensityBasisFn( ig, num, 1 ) = snl2(ig)
                End Do
             end do
          end do

       End Do
    End Do

    call dealloc_arrays
!
  contains

    subroutine alloc_arrays
      allocate( radr(mmesh) ); allocate( wos(mmesh) );
      allocate( qx(ista_kngp:iend_kngp) );
      allocate( qy(ista_kngp:iend_kngp) )
      allocate( qz(ista_kngp:iend_kngp) );
      allocate( ylm(ista_kngp:iend_kngp) ); allocate( vlength(ista_kngp:iend_kngp) )
      allocate( wka(ista_kngp:iend_kngp) );  allocate( wkb(ista_kngp:iend_kngp) )
      allocate( snl2(ista_kngp:iend_kngp) )
    end subroutine alloc_arrays

    subroutine dealloc_arrays
      deallocate( radr ); deallocate( wos );
      deallocate( qx ); deallocate( qy );  deallocate( qz ); deallocate( vlength )
      deallocate( wka ); deallocate( wkb ); deallocate( ylm )
      deallocate( snl2 )
    end subroutine dealloc_arrays

  end subroutine m_TFW_set_ChgDensityBasisFn_B

! --------------------------------------------------------
!
! Calc "averaged" nonlocal potential
!
! --------------------------------------------------------
  subroutine m_TFW_calc_nonlocal_pot_avg_A
    integer :: num, ig, it, ia, is
    integer :: ip, ilmt1, ilmt2
    real(kind=DP) :: weight, factor
    real(kind=DP) :: f1, f2, f3, ga, gb, gc, ph
    real(kind=DP), allocatable :: zfcos(:), zfsin(:)

    vnonlocal_avg = 0.0d0

    allocate( zfcos(ista_kngp:iend_kngp) ); allocate( zfsin(ista_kngp:iend_kngp) )
!
    num = 0
    Do it=1, ntyp
       Do ip=1, n_non0_lmtxlmt(it)
          ilmt1 = index_lmt1_lmt2(ip,it,1);  ilmt2 = index_lmt1_lmt2(ip,it,2)
          num = num +1

          if ( ilmt1 == ilmt2 ) then
             factor = 1.0d0
          else
             factor = 2.0d0
          endif

          Do ia=1, natm
             if ( ityp(ia) /= it ) cycle
             f1 = pos(ia,1)*PAI2; f2 = pos(ia,2)*PAI2; f3 = pos(ia,3)*PAI2
             Do ig=ista_kngp, iend_kngp
                ga = real(ngabc(ig,1),kind=DP)
                gb = real(ngabc(ig,2),kind=DP)
                gc = real(ngabc(ig,3),kind=DP)
                ph = ga *f1 +gb*f2 + gc*f3
                zfcos(ig) = cos(ph);  zfsin(ig) = sin(ph)
             End Do

             Do is=1, nspin
                if ( ipaw(it) == 0 ) then
                   weight = dion(ilmt1, ilmt2, it )
                else
                   weight = dion_paw(ilmt1, ilmt2, is, ia)
                endif
                if ( sw_hubbard == ON ) then
                   weight = weight + dhub( ilmt1,ilmt2,ia,is )
                endif

                weight = weight *hsr(ia, ilmt1,ilmt2,is )
!                weight = weight *hsro(ia, ilmt1,ilmt2,is )

                Do ig=ista_kngp, iend_kngp
                   vnonlocal_avg(ig,1,is) = vnonlocal_avg(ig,1,is) &
                        &      + factor *weight *( &
                        &                zfcos(ig) *ChargeDensityBasisFn( ig,num,1 ) &
                        &               -zfsin(ig) *ChargeDensityBasisFn( ig,num,2 ) )
                   if ( kimg == 2 ) then
                      vnonlocal_avg(ig,2,is) = vnonlocal_avg(ig,2,is) &
                           &   + factor *weight *( &
                           &             zfsin(ig) *ChargeDensityBasisFn( ig,num,1 ) &
                           &            +zfcos(ig) *ChargeDensityBasisFn( ig,num,2 ) )
                   endif
                Enddo

             End Do
          End Do
       End Do
    End Do

    deallocate( zfcos ); deallocate( zfsin )

  end subroutine m_TFW_calc_nonlocal_pot_avg_A

  subroutine m_TFW_calc_nonlocal_pot_avg_B
    integer :: num, ig, it, ia, is
    integer :: ip, ilmt1, ilmt2, il1, il2, tau1, tau2
    real(kind=DP) :: weight, factor
    real(kind=DP) :: f1, f2, f3, ga, gb, gc, ph
    real(kind=DP), allocatable :: zfcos(:), zfsin(:)

    vnonlocal_avg = 0.0d0

    allocate( zfcos(ista_kngp:iend_kngp) ); allocate( zfsin(ista_kngp:iend_kngp) )
!
    Do it=1, ntyp

       Do ia=1, natm
          if ( ityp(ia) /= it ) cycle
          f1 = pos(ia,1)*PAI2; f2 = pos(ia,2)*PAI2; f3 = pos(ia,3)*PAI2

          Do ig=ista_kngp, iend_kngp
             ga = real(ngabc(ig,1),kind=DP)
             gb = real(ngabc(ig,2),kind=DP)
             gc = real(ngabc(ig,3),kind=DP)
             ph = ga *f1 +gb*f2 + gc*f3
             zfcos(ig) = cos(ph);  zfsin(ig) = sin(ph)
          End Do

          Do ilmt1=1, ilmt(it)
             il1 = ltp(ilmt1,it);  tau1 = taup(ilmt1,it)
             Do ilmt2=1, ilmt(it)
                il2 = ltp(ilmt2,it);  tau2 = taup(ilmt2,it)

                if ( il1 /= il2 ) cycle

!                if ( ilmt1 == ilmt2 ) then
!                   factor = 1.0d0
!                else
!                   factor = 2.0d0
!                endif

                Do is=1, nspin
                   if ( ipaw(it) == 0 ) then
                      weight = dion(ilmt1, ilmt2, it )
                   else
                      weight = dion_paw(ilmt1, ilmt2, is, ia)
                   endif
                   if ( sw_hubbard == ON ) then
                      weight = weight + dhub( ilmt1,ilmt2,ia,is )
                   endif

                   weight = weight *hsr(ia, ilmt1,ilmt2,is )
!                   weight = weight *hsro(ia, ilmt1,ilmt2,is )

                   num = Table_for_ChargeDensityBasisFn( it, il1, tau1, tau2 )
                   Do ig=ista_kngp, iend_kngp
                      vnonlocal_avg(ig,1,is) = vnonlocal_avg(ig,1,is) &
                           &      + weight *( &
                           &             zfcos(ig) *ChargeDensityBasisFn( ig,num,1 ) )
                      if ( kimg == 2 ) then
                         vnonlocal_avg(ig,2,is) = vnonlocal_avg(ig,2,is) &
                              &   + weight *( &
                              &          zfsin(ig) *ChargeDensityBasisFn( ig,num,1 ) )
                      endif
                   Enddo
                End do
             End Do
          End Do
       End Do
    End Do

    deallocate( zfcos ); deallocate( zfsin )
  end subroutine m_TFW_calc_nonlocal_pot_avg_B

! ----------------------------
!
!  subroutines for Conjugate Gradient minimization
!
! ---------------------------
  subroutine m_TFW_alloc_deltaW
    allocate( deltaW(ista_kngp:iend_kngp,kimg,nspin) ); deltaW = 0.0d0
  end subroutine m_TFW_alloc_deltaW

  subroutine m_TFW_alloc_deltaV
    allocate( deltaV(ista_kngp:iend_kngp,kimg,nspin) ); deltaV = 0.0d0
  end subroutine m_TFW_alloc_deltaV

  subroutine m_TFW_alloc_Vnonlocal_avg
    allocate( vnonlocal_avg(ista_kngp:iend_kngp,kimg,nspin) )
    vnonlocal_avg = 0.0d0
  end subroutine m_TFW_alloc_Vnonlocal_avg

  subroutine m_TFW_dealloc_deltaW
    if (allocated(deltaW) ) deallocate(deltaW)
  end subroutine m_TFW_dealloc_deltaW

  subroutine m_TFW_dealloc_deltaV
    if (allocated(deltaV) ) deallocate(deltaV)
  end subroutine m_TFW_dealloc_deltaV

  subroutine m_TFW_dealloc_Vnonlocal_avg
    if (allocated(vnonlocal_avg) ) deallocate(vnonlocal_avg)
  end subroutine m_TFW_dealloc_Vnonlocal_avg

  subroutine m_TFW_alloc_Vin_and_Vlda
    allocate( Vin_tfw(ista_kngp:iend_kngp,kimg,nspin) );  Vin_tfw = 0.0d0
    allocate( Vlda_tfw(ista_kngp:iend_kngp,kimg,nspin) ); Vlda_tfw = 0.0d0
    allocate( Vout_tfw(ista_kngp:iend_kngp,kimg,nspin) ); Vout_tfw = 0.0d0
  end subroutine m_TFW_alloc_Vin_and_Vlda

  subroutine m_TFW_dealloc_Vin_and_Vlda
    if( allocated( Vin_tfw ) ) deallocate( Vin_tfw )
    if( allocated( Vlda_tfw ) ) deallocate( Vlda_tfw )
  end subroutine m_TFW_dealloc_Vin_and_Vlda

  subroutine m_TFW_CGoptimize_init
    Coeff_TF = ( 3.0*PAI*PAI )**(2.0d0/3.0d0) *3.0d0/10.0d0

    allocate( Psi(ista_kngp:iend_kngp,kimg,nspin) ); Psi = 0.0d0
    allocate( Phi(ista_kngp:iend_kngp,kimg,nspin) ); Phi = 0.0d0
    allocate( Phi_old(ista_kngp:iend_kngp,kimg,nspin) ); Phi_Old = 0.0d0
    allocate( Zeta(ista_kngp:iend_kngp,kimg,nspin) ); Zeta = 0.0d0

    allocate( Psi_Old(ista_kngp:iend_kngp,kimg,nspin) ); Psi_Old = 0.0d0
    allocate( Vkin_TF(ista_kngp:iend_kngp,kimg,nspin) ); Vkin_TF = 0.0d0

  end subroutine m_TFW_CGoptimize_init

  subroutine m_TFW_CGoptimize_finalize
    deallocate( Psi );   deallocate( Phi );   deallocate( Phi_old )
    deallocate( Zeta );

    deallocate( Psi_old ); deallocate( Vkin_TF )

  end subroutine m_TFW_CGoptimize_finalize

! ----------------------------
!
!  tools for using meshes
!
! ----------------------------
  subroutine map_matrix_on_FFTcd_mesh( matrix, afft )
    real(kind=DP), intent(in) :: matrix(ista_kngp:iend_kngp,kimg)
    real(kind=DP), intent(out) :: afft(ista_fftp:iend_fftp)

    integer :: is, j, i, ip, ilast
    real(kind=DP), allocatable :: afft_mpi1(:), afft_mpi2(:), afft_mpi3(:)

    ilast = min(iend_kngp,kgp_reduced)

    allocate( afft_mpi1(nfftp) )
    if ( npes > 1 ) then
       allocate( afft_mpi2(mp_fftp) );  allocate( afft_mpi3(mp_fftp) )
    end if

    afft = 0.0d0;   afft_mpi1=0.d0
    Do j=1, kimg
       do i=ista_kngp,ilast
          ip = ( igfp_l(i) -1 )*kimg +j
          afft_mpi1(ip) = matrix( i, j )
       end do
    End Do

    if ( npes > 1) then
       call mpi_barrier(MPI_CommGroup,ierr)
       do j=0,npes-1
          do i=nis_fftp(j),nie_fftp(j)
             afft_mpi2( i-nis_fftp(j) +1 ) = afft_mpi1(i)
          end do
          call mpi_allreduce( afft_mpi2, afft_mpi3, mp_fftp, &
               &              mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )
          if ( j == mype ) then
             do i=ista_fftp,iend_fftp
                afft(i) = afft_mpi3(i-ista_fftp+1)
             end do
          end if
       end do
    else
       afft = afft_mpi1
    end if

    deallocate( afft_mpi1 );
    if ( npes > 1 ) then
       deallocate( afft_mpi2 ); deallocate( afft_mpi3 )
    endif

  end subroutine map_matrix_on_FFTcd_mesh

  subroutine extract_matrix_from_FFTcd_mesh( afft, matrix )
    real(kind=DP), intent(in) :: afft(ista_fftp:iend_fftp)
    real(kind=DP), intent(out) :: matrix(ista_kngp:iend_kngp,kimg)

    integer :: ik, i, ip
    real(kind=DP) :: rinplw
    real(kind=DP), allocatable :: afft_mpi1(:)

    matrix = 0.0d0

    allocate(afft_mpi1(nfftp))
    if ( npes >1 ) then
       call mpi_allgatherv( afft, nel_fftp(mype), mpi_double_precision, &  ! MPI
            &               afft_mpi1, nel_fftp, idisp_fftp, mpi_double_precision, &
            &               MPI_CommGroup, ierr )
    else
       afft_mpi1 = afft
    end if

    rinplw = 1.d0 /product(fft_box_size_CD(1:3,1))
    do ik=1, kimg
       do i=ista_kngp, iend_kngp          !for mpi
          ip = (igfp_l(i)-1)*kimg + ik
          matrix(i,ik) = afft_mpi1(ip)*rinplw
       end do
    end do

  end subroutine extract_matrix_from_FFTcd_mesh

  subroutine dot_product_of_vectors_Rspace( MatA, MatB, csum )
    real(kind=DP), intent(in) :: MatA(ista_kngp:iend_kngp,kimg,nspin)
    real(kind=DP), intent(in) :: MatB(ista_kngp:iend_kngp,kimg,nspin)
    real(kind=DP), intent(out) :: csum

    integer :: is, i
    real(kind=DP) :: csum_mpi
    real(kind=DP), allocatable :: afft(:), bfft(:)

    csum = 0.0d0

    call m_FFT_alloc_CD_box

    allocate( afft(ista_fftp:iend_fftp) )
    allocate( bfft(ista_fftp:iend_fftp) )

    Do is=1, nspin
       call map_matrix_on_FFTcd_mesh( MatA(:,:,is), afft )
       call m_FFT_CD_inverse_c( nfout, afft )       ! afft(G) -> afft(R)
       call map_matrix_on_FFTcd_mesh( MatB(:,:,is), bfft )
       call m_FFT_CD_inverse_c( nfout, bfft )       ! afft(G) -> afft(R)

       if ( kimg == 1 ) then
          Do i=ista_fftp, iend_fftp
             csum = csum +afft(i) *bfft(i)
          End do
       else
          Do i=ista_fftph, iend_fftph
             csum = csum +afft(2*i-1) *bfft(2*i-1) &
                  &      +afft(2*i) *bfft(2*i)
          End do
       endif
    End do

    if ( npes > 1 ) then
       call mpi_allreduce( csum, csum_mpi, 1, mpi_double_precision, &
            &              mpi_sum, MPI_CommGroup, ierr )
       csum = csum_mpi
    endif
    csum = csum *univol /product(fft_box_size_CD(1:3,1))

    call m_FFT_dealloc_CD_box
    deallocate( afft );  deallocate( bfft )

  end subroutine dot_product_of_vectors_Rspace

  subroutine dot_product_of_vectors_Gspace( MatA, MatB, csum )
    real(kind=DP), intent(in) :: MatA(ista_kngp:iend_kngp,kimg,nspin)
    real(kind=DP), intent(in) :: MatB(ista_kngp:iend_kngp,kimg,nspin)
    real(kind=DP), intent(out) :: csum

    integer :: is, i, ri
    real(kind=DP) :: csum_mpi

    csum = 0.0d0
    Do is=1, nspin
       Do ri=1, kimg
          Do i=ista_kngp, iend_kngp
             csum = csum + MatA(i,ri,is) *MatB(i,ri,is)
          End Do
       End do
    End do
    if ( npes > 1 ) then
       call mpi_allreduce( csum, csum_mpi, 1, mpi_double_precision, &
            &              mpi_sum, MPI_CommGroup, ierr )
       csum = csum_mpi
    endif

    csum = csum *univol

  end subroutine dot_product_of_vectors_Gspace

! ---------------------
!
!  Psi(r) is rho(r)^(1/2)
!
! --------------------
  subroutine m_TFW_init_Psi
    integer :: is, i, ri
    real(kind=DP) :: c1
    real(kind=DP), allocatable :: afft(:), bfft(:), cfft(:)

    allocate( afft(ista_fftp:iend_fftp) ); afft = 0.0d0
    allocate( cfft(ista_fftp:iend_fftp) ); cfft = 0.0d0

    call m_FFT_alloc_CD_box

    Do is=1, nspin
       afft = 0.0d0;  cfft = 0.0d0

! -- calc charge density on FFT-mesh (Rspace)
       call map_matrix_on_FFTcd_mesh( chgq_l(:,:,is), cfft )
       call m_FFT_CD_inverse_c( nfout, cfft )       ! afft(G) -> afft(R)

! -- calc "wavefunction" on FFT-mesh (Rspace)
       if ( kimg == 1 ) then
          Do i=ista_fftp, iend_fftp
             c1 = cfft(i)
             if ( c1 > 0.0 ) afft(i) = sqrt(c1)
          End do
       else
          Do i=ista_fftph, iend_fftph
             c1 = cfft(2*i-1)
             if ( c1 > 0.0 ) then
                afft(2*i-1) = sqrt(c1)
#if 0
             else
                afft(2*i) = sqrt(-c1)
#endif
             endif
          End do
       endif

! -- Back to G-space
       call m_FFT_CD_direct_c( nfout, afft )         ! afft(R) -> afft(G)
       call extract_matrix_from_FFTcd_mesh( afft, Psi(:,:,is) )
    End Do

    call m_FFT_dealloc_CD_box

    deallocate( afft );  deallocate( cfft )

#if 0
    call cut_high_G_component( Psi )
#endif

  end subroutine m_TFW_init_Psi

  subroutine m_TFW_store_Psi
    Psi_Old = Psi
  end subroutine m_TFW_store_Psi

! ----------------------------
!
!  deltaW term
!
! ----------------------------
  subroutine m_TFW_calc_deltaW
    integer :: is, i, ri
    real(kind=DP) :: c0, c1, c2, gx, gy, gz, g2
    real(kind=DP), allocatable :: afft(:), bfft(:), cfft(:)
    real(kind=DP), allocatable :: vlocal_tmp(:,:)

    allocate( afft(ista_fftp:iend_fftp) ); afft = 0.0d0
    allocate( bfft(ista_fftp:iend_fftp) ); bfft = 0.0d0
    allocate( cfft(ista_fftp:iend_fftp) ); cfft = 0.0d0
    allocate( vlocal_tmp(ista_kngp:iend_kngp,kimg) ); vlocal_tmp = 0.0d0

    Zeta = 0.0d0;  deltaW = 0.0d0

    call m_FFT_alloc_CD_box

    Do is=1, nspin
       afft = 0.0d0;  bfft = 0.0d0;  cfft = 0.0d0;  vlocal_tmp = 0.0d0

! -- calc "wavefunction" on FFT-mesh (Rspace)
       call map_matrix_on_FFTcd_mesh( Psi(:,:,is), afft )
       call m_FFT_CD_inverse_c( nfout, afft )       ! afft(G) -> afft(R)

! -- calc charge density on FFT-mesh (Rspace)
       if ( kimg == 1 ) then
          Do i=ista_fftp, iend_fftp
             cfft(i) = afft(i)**2
          End do
       else
          Do i=ista_fftph, iend_fftph
#if 0
             cfft(2*i-1) = afft(2*i-1)**2 +afft(2*i)**2
#else
             cfft(2*i-1) = afft(2*i-1)**2
#endif
          End do
       endif

! -- local +averaged nonlocal pot on FFT mesh (Rspace)
       vlocal_tmp(:,:) = vin_tfw(:,:,is)
       if ( use_averaged_nonlocal ) then
          vlocal_tmp(:,:) = vlocal_tmp(:,:) +vnonlocal_avg(:,:,is)
       endif

       call map_matrix_on_FFTcd_mesh( vlocal_tmp, bfft )
       call m_FFT_CD_inverse_c( nfout, bfft )       ! afft(G) -> afft(R)

! -- add Thomas Fermi term on FFT mesh (Rspace)
       c0 = 5.0d0 /3.0d0 *Coeff_TF *weight_TF_functional
       if ( kimg == 1 ) then
          Do i=ista_fftp, iend_fftp
             c1 = cfft(i) *nspin
             if ( c1 > 0.0 ) then
                c1 = c1**(2.0d0/3.0d0)
             else
                c1 = 0.0d0
             endif
             c2 = bfft(i)
             cfft(i) = ( c0 *c1 +c2 )*afft(i)
          End do

       else
          Do i=ista_fftph, iend_fftph
             c1 = cfft(2*i-1) *nspin
             if ( c1 > 0.0 ) then
                c1 = c1**(2.0d0/3.0d0)
             else
                c1 = 0.0d0
             endif
             c2 = bfft(2*i-1)

             cfft(2*i-1) = ( c0 *c1 +c2 )*afft(2*i-1)
#if 0
             cfft(2*i) = ( c0 *c1 +c2 )*afft(2*i)
#endif
          End do
       endif
! -- Back to G-space
       call m_FFT_CD_direct_c( nfout, cfft )         ! afft(R) -> afft(G)
       call extract_matrix_from_FFTcd_mesh( cfft, Zeta(:,:,is) )
                                                      ! zeta is used as temporay array

!       call m_FFT_CD_direct_c( nfout, afft )         ! afft(R) -> afft(G)
!       call extract_matrix_from_FFTcd_mesh( afft, Psi(:,:,is) )

! -- add von Weizsacker term
       Do ri=1, kimg
          Do i=ista_kngp, iend_kngp
             gx = ngabc(i,1)*rltv(1,1) +ngabc(i,2)*rltv(1,2) +ngabc(i,3)*rltv(1,3)
             gy = ngabc(i,1)*rltv(2,1) +ngabc(i,2)*rltv(2,2) +ngabc(i,3)*rltv(2,3)
             gz = ngabc(i,1)*rltv(3,1) +ngabc(i,2)*rltv(3,2) +ngabc(i,3)*rltv(3,3)
             g2 = ( gx**2 +gy**2 +gz**2 ) /2.0d0
             Zeta(i,ri,is) = Zeta(i,ri,is) +weight_Weiz_functional *g2 *Psi(i,ri,is)
          End do
       End Do

       Zeta(:,:,is) = Zeta(:,:,is) -efermi *Psi(:,:,is)
       deltaW(:,:,is) = -Zeta(:,:,is)
    End Do

    call m_FFT_dealloc_CD_box

    deallocate( afft );  deallocate( bfft );  deallocate( cfft )
    deallocate( vlocal_tmp )

#if 0
    call cut_high_G_component( deltaW )
#endif

  end subroutine m_TFW_calc_deltaW

! ------------------------
!
!  Zeta: steepest descent vector
!  Phi : Conjugate Gradient vector
!
! ------------------------
  subroutine m_TFW_calc_SD_direction( psi_MatH_psi, zeta_product )
    real(kind=DP), intent(out) :: psi_MatH_psi, zeta_product

    integer :: is, i, ri
    real(kind=DP) :: c0, c1, c2, gx, gy, gz, g2
    real(kind=DP), allocatable :: afft(:), bfft(:), cfft(:), dfft(:)
    real(kind=DP), allocatable :: vlocal_tmp(:,:), HPsi_tmp(:,:)

    allocate( afft(ista_fftp:iend_fftp) ); afft = 0.0d0
    allocate( bfft(ista_fftp:iend_fftp) ); bfft = 0.0d0
    allocate( cfft(ista_fftp:iend_fftp) ); cfft = 0.0d0
    allocate( dfft(ista_fftp:iend_fftp) ); dfft = 0.0d0
    allocate( vlocal_tmp(ista_kngp:iend_kngp,kimg) ); vlocal_tmp = 0.0d0

    psi_MatH_psi = 0.0d0
    Zeta = 0.0d0

    call m_FFT_alloc_CD_box

    Do is=1, nspin
       afft = 0.0d0;  bfft = 0.0d0;  cfft = 0.0d0;  dfft = 0.0d0

! -- calc "wavefunction" on FFT-mesh (Rspace)
       call map_matrix_on_FFTcd_mesh( Psi(:,:,is), afft )
       call m_FFT_CD_inverse_c( nfout, afft )       ! afft(G) -> afft(R)

! -- calc charge density on FFT-mesh (Rspace)
       if ( kimg == 1 ) then
          Do i=ista_fftp, iend_fftp
             cfft(i) = afft(i)**2
          End do
       else
          Do i=ista_fftph, iend_fftph
#if 0
             cfft(2*i-1) = afft(2*i-1)**2 +afft(2*i)**2
#else
             cfft(2*i-1) = afft(2*i-1)**2
#endif
          End do
       endif

! -- calc Thomas Fermi kinetic functional
       if ( kimg == 1 ) then
          Do i=ista_fftp, iend_fftp
             c1 = cfft(i) *nspin
             if ( c1 > 0.0 ) dfft(i) = Coeff_TF *c1**(2.0d0/3.0d0)
          End do
       else
          Do i=ista_fftph, iend_fftph
             c1 = cfft(2*i-1) *nspin
             if ( c1 > 0.0 ) dfft(2*i-1) = Coeff_TF *c1**(2.0d0/3.0d0)
          End do
       endif

! -- local +averaged nonlocal pot on FFT mesh (Rspace)
       if ( use_averaged_nonlocal ) then
          vlocal_tmp(:,:) = vlhxc_l(:,:,is) +vnonlocal_avg(:,:,is)
       else
          vlocal_tmp(:,:) = vlhxc_l(:,:,is)
       endif

       if ( use_deltaV ) vlocal_tmp(:,:) = vlocal_tmp(:,:) +deltaV(:,:,is)

       call map_matrix_on_FFTcd_mesh( vlocal_tmp, bfft )
       call m_FFT_CD_inverse_c( nfout, bfft )       ! afft(G) -> afft(R)

! -- add Thomas Fermi term on FFT mesh (Rspace)
       c1 = 5.0d0 /3.0d0 *weight_TF_functional
       if ( kimg == 1 ) then
          Do i=ista_fftp, iend_fftp
             cfft(i) = ( bfft(i) + c1*dfft(i) )*afft(i)
          End do
       else
          Do i=ista_fftph, iend_fftph
             cfft(2*i-1) = ( bfft(2*i-1) + c1*dfft(2*i-1) )*afft(2*i-1)
#if 0
             cfft(2*i) = ( bfft(2*i-1) + c1*dfft(2*i-1) )*afft(2*i)
#endif
          End do
       endif

! -- Back to G-space
       call m_FFT_CD_direct_c( nfout, cfft )         ! afft(R) -> afft(G)
       call extract_matrix_from_FFTcd_mesh( cfft, Zeta(:,:,is) )

!       call m_FFT_CD_direct_c( nfout, afft )         ! afft(R) -> afft(G)
!       call extract_matrix_from_FFTcd_mesh( afft, Psi(:,:,is) )

       call m_FFT_CD_direct_c( nfout, dfft )         ! afft(R) -> afft(G)
       call extract_matrix_from_FFTcd_mesh( dfft, Vkin_TF(:,:,is) )

! -- add von Weizsacker term
       Do ri=1, kimg
          Do i=ista_kngp, iend_kngp
             gx = ngabc(i,1)*rltv(1,1) +ngabc(i,2)*rltv(1,2) +ngabc(i,3)*rltv(1,3)
             gy = ngabc(i,1)*rltv(2,1) +ngabc(i,2)*rltv(2,2) +ngabc(i,3)*rltv(2,3)
             gz = ngabc(i,1)*rltv(3,1) +ngabc(i,2)*rltv(3,2) +ngabc(i,3)*rltv(3,3)
             g2 = ( gx**2 +gy**2 +gz**2 ) /2.0d0
             Zeta(i,ri,is) = Zeta(i,ri,is) +Weight_Weiz_functional *g2 *Psi(i,ri,is)
          End do
       End Do
       if ( use_deltaW ) Zeta(:,:,is) = Zeta(:,:,is) + deltaW(:,:,is)
    End do

    call m_FFT_dealloc_CD_box
    deallocate( afft ); deallocate( bfft );  deallocate( cfft );  deallocate( dfft )
    deallocate( vlocal_tmp )

#if 0
    call cut_high_G_component( Zeta )
#endif

! ------------------
! if normalization is required
    call dot_product_of_vectors_Gspace( Psi, Psi, c1 )
    if ( ipritfwfunc >= 3 ) then
       if ( mype == 0 ) then
          write(nfout,*) "**** TFW functional info ***"
          write(nfout,*) "dot product of Psi-Psi before normalization: ", c1
       endif
    endif

    c1 = sqrt( totch /c1 )
    Psi = Psi *c1
! ------------------

    call dot_product_of_vectors_Gspace( Psi, Zeta, psi_MatH_psi )

    Zeta = psi_MatH_psi/totch *Psi -Zeta

    call dot_product_of_vectors_Gspace( zeta, zeta, zeta_product )
    if ( ipritfwfunc >= 3 ) then
       if ( mype == 0 ) write(nfout,*) "zeta_product is ", zeta_product
    endif
  end subroutine m_TFW_calc_SD_direction

  subroutine m_TFW_calc_CG_direction( FirstFlag, zeta_product, zeta_product_old, &
       &                              phi_MatH_psi )
    logical, intent(in) ::FirstFlag
    real(kind=DP), intent(in) :: zeta_product, zeta_product_old
    real(kind=DP), intent(out) :: phi_MatH_psi

    real(kind=DP) :: gamma, c1, c2

    if ( FirstFlag ) then
       gamma = 0.0d0
       Phi = zeta
    else
       gamma = zeta_product / zeta_product_old
       Phi = zeta +gamma *Phi_old
    endif
    Phi_old = Phi

#if 0
    call dot_product_of_vectors_Gspace( Phi, Phi, c1 )
    if ( ipritfwfunc >= 3 ) then
       if ( mype == 0 ) then
          write(nfout,*) "dot product of Phi-Phi before normalization: ", c1
       endif
    endif

    call dot_product_of_vectors_Gspace( Psi, Phi, c1 )
    Phi = Phi - c1 / totch *Psi
#endif

    call dot_product_of_vectors_Gspace( Phi, Phi, c1 )
    if ( ipritfwfunc >= 3 ) then
       if ( mype == 0 ) then
          write(nfout,*) "dot product of Phi-Phi after orthogonalization: ", c1
       endif
    endif

#if 1
    if ( abs(c1) < 1.0E-10 ) then
       if ( mype == 0) write(nfout,*) 'Norm of Phi is too small, ', abs(c1)
       Phi = Phi_old
    else
       c2 = totch /c1
       Phi = Phi *sqrt(c2)
    endif
#endif

    call dot_product_of_vectors_Gspace( Phi, Zeta, c1 )
    phi_MatH_psi = -c1

  end subroutine m_TFW_calc_CG_direction

  subroutine m_TFW_calc_phi_MatH_phi( phi_MatH_phi )
    real(kind=DP), intent(out) :: phi_MatH_phi

    integer :: is, i, ri
    real(kind=DP) :: c0, c1, c2, gx, gy, gz, g2
    real(kind=DP), allocatable :: afft(:), bfft(:), cfft(:)
    real(kind=DP), allocatable :: vlocal_tmp(:,:), HPhi_tmp(:,:)

    allocate( afft(ista_fftp:iend_fftp) ); afft = 0.0d0
    allocate( bfft(ista_fftp:iend_fftp) ); bfft = 0.0d0
    allocate( cfft(ista_fftp:iend_fftp) ); cfft = 0.0d0
    allocate( vlocal_tmp(ista_kngp:iend_kngp,kimg) ); vlocal_tmp = 0.d0

    phi_MatH_phi = 0.0d0

    call m_FFT_alloc_CD_box

    Do is=1, nspin
       afft = 0.0d0;  bfft = 0.0d0;  cfft = 0.0d0

! -- calc "wavefunction" on FFT-mesh (Rspace)
       call map_matrix_on_FFTcd_mesh( Phi(:,:,is), afft )
       call m_FFT_CD_inverse_c( nfout, afft )       ! afft(G) -> afft(R)

! -- calc charge density on FFT-mesh (Rspace)
       call map_matrix_on_FFTcd_mesh( chgq_l(:,:,is), cfft )
       call m_FFT_CD_inverse_c( nfout, cfft )       ! afft(G) -> afft(R)

! -- local +averaged nonlocal pot on FFT mesh (Rspace)
       if ( use_averaged_nonlocal ) then
          vlocal_tmp(:,:) = vlhxc_l(:,:,is) +vnonlocal_avg(:,:,is)
       else
          vlocal_tmp(:,:) = vlhxc_l(:,:,is)
       endif

       if ( use_deltaV ) vlocal_tmp(:,:) = vlocal_tmp(:,:) +deltaV(:,:,is)

       call map_matrix_on_FFTcd_mesh( vlocal_tmp, bfft )
       call m_FFT_CD_inverse_c( nfout, bfft )       ! afft(G) -> afft(R)

! -- add Thomas Fermi term on FFT mesh (Rspace)
       if ( kimg == 1 ) then
          Do i=ista_fftp, iend_fftp
             c0 = cfft(i) *nspin
             c1 = 5.0d0 /3.0d0 *Coeff_TF *weight_TF_functional *c0**(2.0d0/3.0d0)
             c2 = bfft(i)
             cfft(i) = ( c1 +c2 )*afft(i)
          End do
       else
          Do i=ista_fftph, iend_fftph
             c0 = cfft(2*i-1) *nspin
             c1 = 5.0d0 /3.0d0 *Coeff_TF *weight_TF_functional *c0**(2.0d0/3.0d0)
             c2 = bfft(2*i-1)
             cfft(2*i-1) = ( c1 +c2 )*afft(2*i-1)
          End do
       endif
! -- Back to G-space
       call m_FFT_CD_direct_c( nfout, cfft )         ! afft(R) -> afft(G)
       call extract_matrix_from_FFTcd_mesh( cfft, Zeta(:,:,is) )

! -- add von Weizsacker term
       Do ri=1, kimg
          Do i=ista_kngp, iend_kngp
             gx = ngabc(i,1)*rltv(1,1) +ngabc(i,2)*rltv(1,2) +ngabc(i,3)*rltv(1,3)
             gy = ngabc(i,1)*rltv(2,1) +ngabc(i,2)*rltv(2,2) +ngabc(i,3)*rltv(2,3)
             gz = ngabc(i,1)*rltv(3,1) +ngabc(i,2)*rltv(3,2) +ngabc(i,3)*rltv(3,3)
             g2 = ( gx**2 +gy**2 +gz**2 ) /2.0d0
             Zeta(i,ri,is) = Zeta(i,ri,is) +Weight_Weiz_functional *g2 *Phi(i,ri,is)
          End do
       End Do

       if ( use_deltaW ) Zeta(:,:,is) = Zeta(:,:,is) + deltaW(:,:,is)
    End do

    call m_FFT_dealloc_CD_box

    deallocate( afft );  deallocate( bfft );  deallocate( cfft )
    deallocate( vlocal_tmp )

    call dot_product_of_vectors_Gspace( Phi, Zeta, phi_MatH_phi )

  end subroutine m_TFW_calc_phi_MatH_phi

  subroutine m_TFW_try_new_Psi_and_charge( dx )
    real(kind=DP), intent(in) :: dx

    integer :: is, i
    real(kind=DP) :: csum, c1, cos_th, sin_th
    real(kind=DP), allocatable :: afft(:), bfft(:), cfft(:), dfft(:)
    real(kind=DP), allocatable :: K_phi(:,:,:)

    if ( use_preconditioning ) then
       allocate( K_phi( ista_kngp:iend_kngp, kimg, nspin ) )

       call m_TFW_set_preconditioned_Phi( Phi, K_Phi )
       Psi = Psi_Old + dx *K_Phi

       deallocate( K_Phi )
    else
       Psi = Psi_Old + dx *Phi
    endif

    if ( ipritfwfunc >= 3 ) then
       call dot_product_of_vectors_Gspace( Psi_Old, Psi_Old, csum )
       if ( mype == 0 ) write(nfout,*) "dot product of PsiOld-PsiOld : ", csum
    endif

    if ( ipritfwfunc >= 3 ) then
       call dot_product_of_vectors_Gspace( Phi, Phi, csum )
       if ( mype == 0 ) write(nfout,*) "dot product of Phi-Phi : ", csum
    endif

! ------------------
! if normalization is required
    call dot_product_of_vectors_Gspace( Psi, Psi, c1 )
    if ( ipritfwfunc >= 3 ) then
       if ( mype == 0 ) then
          write(nfout,*) "dot product of Psi-Psi before normalization: ", c1
          write(nfout,*) "*** ***"
       endif
    endif

    c1 = sqrt( totch /c1 )
    Psi = Psi *c1
! ------------------

    allocate( afft(ista_fftp:iend_fftp) ); afft = 0.0d0
    allocate( cfft(ista_fftp:iend_fftp) ); cfft = 0.0d0
    allocate( dfft(ista_fftp:iend_fftp) ); dfft = 0.0d0

    call m_FFT_alloc_CD_box

    csum = 0.0d0
    Do is=1, nspin
       afft = 0.0d0;  cfft = 0.0d0;   dfft = 0.0d0

! -- calc "wavefunction" on FFT-mesh (Rspace)
       call map_matrix_on_FFTcd_mesh( Psi(:,:,is), cfft )
       call m_FFT_CD_inverse_c( nfout, cfft )       ! afft(G) -> afft(R)

! -- calc charge density on FFT-mesh (Rspace)
       if ( kimg == 1 ) then
          Do i=ista_fftp, iend_fftp
             afft(i) = cfft(i)**2
          End do
       else
          Do i=ista_fftph, iend_fftph
#if 0
             afft(2*i-1) = cfft(2*i-1)**2 +cfft(2*i)**2
#else
             afft(2*i-1) = cfft(2*i-1)**2
#endif
          End do
       endif

! -- calc Thomas Fermi functional
       if ( kimg == 1 ) then
          Do i=ista_fftp, iend_fftp
             c1 = afft(i) *nspin
             dfft(i) = Coeff_TF *c1**(2.0d0/3.0d0)
          End do
       else
          Do i=ista_fftph, iend_fftph
             c1 = afft(2*i-1) *nspin
             dfft(2*i-1) = Coeff_TF *c1**(2.0d0/3.0d0)
          End do
       endif

! Back to G-space
       call m_FFT_CD_direct_c( nfout, afft )         ! afft(R) -> afft(G)
       call extract_matrix_from_FFTcd_mesh( afft, chgq_l(:,:,is) )

       call m_FFT_CD_direct_c( nfout, dfft )         ! afft(R) -> afft(G)
       call extract_matrix_from_FFTcd_mesh( dfft, Vkin_TF(:,:,is) )
    End do

    deallocate(afft); deallocate(cfft);  deallocate(dfft)
    call m_FFT_dealloc_CD_box

#if 0
    call m_TFW_remove_negative_charge
#endif

  end subroutine m_TFW_try_new_Psi_and_charge

  subroutine m_TFW_calc_energy_terms( ekin_TF, ekin_Weiz, &
       &                              ene_nonlocal_avg, ene_deltaV, ene_deltaW )
    real(kind=DP), intent(out) :: ekin_TF, ekin_Weiz
    real(kind=DP), intent(out) :: ene_nonlocal_avg, ene_deltaV, ene_deltaW

    integer :: is, i, ri
    real(kind=DP) :: csum, csum_mpi, gx, gy, gz, g2

    ene_deltaW = 0.0d0;  ene_deltaV = 0.0d0
    ene_nonlocal_avg = 0.0d0;  ekin_TF = 0.0d0;  ekin_Weiz = 0.0d0

! -- Thomas Fermi kinetic energy
    call dot_product_of_vectors_Gspace( chgq_l, Vkin_TF, csum )
!!!    ekin_TF = weight_TF_functional *csum /dble(nspin)
    ekin_TF = weight_TF_functional *csum

! -- von Weizsacker kinetic energy
    csum = 0.0d0
    Do is=1, nspin
       Do ri=1, kimg
          Do i=ista_kngp, iend_kngp
             gx = ngabc(i,1)*rltv(1,1) +ngabc(i,2)*rltv(1,2) +ngabc(i,3)*rltv(1,3)
             gy = ngabc(i,1)*rltv(2,1) +ngabc(i,2)*rltv(2,2) +ngabc(i,3)*rltv(2,3)
             gz = ngabc(i,1)*rltv(3,1) +ngabc(i,2)*rltv(3,2) +ngabc(i,3)*rltv(3,3)
             g2 = ( gx**2 +gy**2 +gz**2 ) /2.0d0
             csum = csum + g2 *Psi(i,ri,is)**2
          End do
       End Do
    End do
    if ( npes > 1 ) then
       call mpi_allreduce( csum, csum_mpi, 1, mpi_double_precision, mpi_sum, &
            &              MPI_CommGroup, ierr )
       csum = csum_mpi
    endif
    ekin_Weiz = Weight_Weiz_functional *csum *univol

! nonlocal avg energy
    if ( use_averaged_nonlocal ) then
       call dot_product_of_vectors_Gspace( chgq_l, vnonlocal_avg, csum )
       ene_nonlocal_avg = csum
    endif

! deltaV eergy
    if ( use_deltaV ) then
       call dot_product_of_vectors_Gspace( chgq_l, deltaV, csum )
       ene_deltaV = -csum
    endif

! correction energy
    if ( use_deltaW ) then
       call dot_product_of_vectors_Gspace( deltaW, Psi, csum )
       ene_deltaW = csum *2.0d0
    endif

  end subroutine m_TFW_calc_energy_terms

! ---------------------
!
! others
!
! ---------------------
  subroutine cut_high_G_component( mat )
    real(kind=DP), intent(inout) :: mat( ista_kngp:iend_kngp, kimg, nspin )

    integer :: i

    Do i=ista_kngp, iend_kngp
       if ( i> kg_tfw ) mat(i,:,:) = 0.0d0
    End do

  end subroutine cut_high_G_component

  subroutine m_TFW_remove_negative_charge
    integer :: is, i
    real(kind=DP) :: c1
    real(kind=DP), allocatable :: cfft(:)

    allocate( cfft(ista_fftp:iend_fftp) )

    call m_FFT_alloc_CD_box

    Do is=1, nspin
       cfft = 0.0d0

! -- calc charge density on FFT-mesh (Rspace)
       call map_matrix_on_FFTcd_mesh( chgq_l(:,:,is), cfft )
       call m_FFT_CD_inverse_c( nfout, cfft )       ! afft(G) -> afft(R)

! -- calc "wavefunction" on FFT-mesh (Rspace)
       if ( kimg == 1 ) then
          Do i=ista_fftph, iend_fftph
             c1 = cfft(2*i-1)
             if ( c1 < 0.0 ) cfft(2*i-1) = 0.0d0
          End do
       else
          Do i=ista_fftp, iend_fftp
             c1 = cfft(i)
             if ( c1 < 0.0 ) cfft(i) = 0.0d0
          End do
       endif
! -- Back to G-space
       call m_FFT_CD_direct_c( nfout, cfft )         ! afft(R) -> afft(G)
       call extract_matrix_from_FFTcd_mesh( cfft, chgq_l(:,:,is) )
    End do

    call m_FFT_dealloc_CD_box
    deallocate( cfft )

    if ( mype == 0 ) then
       c1 = 0.0d0
       Do is=1, nspin
          c1 = c1 + chgq_l(1,1,is)
       End do
       c1 = totch /(c1*univol)
    endif
    if ( npes > 1 ) then
       call mpi_bcast( c1, 1, mpi_double_precision, 0, MPI_CommGroup, ierr )
    endif
    chgq_l = c1 *chgq_l
  end subroutine m_TFW_remove_negative_charge

! -------------------------------
!
! Sometimes, the variable chgq_l/vlhxc_l obtained by TFW equations
! are not well screened. It means, the lower G components have non-negligible
! amplitudes.
!
! Using such variables as new inputs for Kohn-Sham equation,
! the calculations become unstable due to the charge sloshing.
! In order to prevent this, Kerker mixing is adopted.
!
! ------------------------------
  subroutine m_TFW_Kerker_mixing( V_in, V_out, rmxt )
    real(kind=DP), intent(in) :: rmxt
    real(kind=DP), intent(in)    :: V_in(  ista_kngp:iend_kngp,kimg,nspin )
    real(kind=DP), intent(inout) :: V_out( ista_kngp:iend_kngp,kimg,nspin )
!
    integer :: i, is, ri
    real(kind=DP) :: gg, q0
    real(kind=DP) :: rmxtrc(nspin)
!
    allocate( c_p_pot( ista_kngp:iend_kngp,nspin) );  c_p_pot = 0.0d0

    rmxtrc = rmxt

#if 0
    call precon_4_pot_mix( rmxtrc, c_p_pot )
#else
    q0 = 10.0d0
!    q0 = 1.0d0

    Do i=ista_kngp, iend_kngp
       gg = gr_l(i)*gr_l(i)
       Do is=1, nspin
!          c_p_pot(i,is) = rmxtrc(is) *max(gg/(gg+q0),amin)
!          c_p_pot(i,is) = rmxtrc(is) *gg/(gg+q0)
          c_p_pot(i,is) = gg/(gg+q0)
!          c_p_pot(i,is) = rmxtrc(is)
       End do
    End Do
#endif

    Do is=1, nspin
       Do ri=1, kimg
          Do i=ista_kngp, iend_kngp
             V_out(i,ri,is) = V_in(i,ri,is) &
                  &         + c_p_pot(i,is)*( V_out(i,ri,is) -V_in(i,ri,is) )
          End do
       End do
    End Do

    deallocate( c_p_pot )

  end subroutine m_TFW_Kerker_mixing

  subroutine m_TFW_set_preconditioned_Phi( V_in, V_out )
    real(kind=DP), intent(in)    :: V_in(  ista_kngp:iend_kngp,kimg,nspin )
    real(kind=DP), intent(inout) :: V_out( ista_kngp:iend_kngp,kimg,nspin )

    integer :: i, is, ri
    real(kind=DP) :: gg, q0
    real(kind=DP) :: rmxtrc(nspin)
!
    allocate( c_p_pot( ista_kngp:iend_kngp,nspin) );  c_p_pot = 0.0d0

#if 0
    call precon_4_pot_mix( rmxtrc, c_p_pot )
#else
    q0 = 10.0d0
!    q0 = 1.0d0

    Do i=ista_kngp, iend_kngp
       gg = gr_l(i)*gr_l(i)
       Do is=1, nspin
          c_p_pot(i,is) = gg/(gg+q0)
       End do
    End Do
#endif

    Do is=1, nspin
       Do ri=1, kimg
          Do i=ista_kngp, iend_kngp
             V_out(i,ri,is) = c_p_pot(i,is)*V_in(i,ri,is)
          End do
       End do
    End Do
    deallocate( c_p_pot )

  end subroutine m_TFW_set_preconditioned_Phi

end module m_ThomasFermiW_Potential

module m_External_Potential
  use m_Control_Parameters, only : sw_external_potential
  use m_Parallelization, only : MPI_CommGroup

  implicit none

  ! external point charge
  integer :: natom_ex = 0
  real(8), allocatable, dimension(:,:) :: pos_ex
  real(8), allocatable, dimension(:) :: charge_ex
  real(8), allocatable, dimension(:) :: coulomb_rc
  real(8), allocatable, dimension(:) :: coulomb_rn
  ! external potential (electrostatic potential)
  real(8), allocatable, dimension(:,:) :: espot
  real(8), allocatable, dimension(:,:,:) :: espot_g

  ! temporary
  real(8), dimension(:,:), pointer :: mesh_coord
  real(8) :: mesh_delta(3,3)
  real(8), dimension(:), pointer :: charge_r

contains

  subroutine m_EP_alloc_point_charge
    implicit none

    if( .not. allocated(pos_ex) ) allocate(pos_ex(natom_ex,3))
    if( .not. allocated(charge_ex) ) allocate(charge_ex(natom_ex))
    if( .not. allocated(coulomb_rc) ) allocate(coulomb_rc(natom_ex))
    if( .not. allocated(coulomb_rn) ) allocate(coulomb_rn(natom_ex))

  end subroutine m_EP_alloc_point_charge

  subroutine m_EP_dealloc_point_charge
    implicit none

    if( allocated(pos_ex) ) deallocate(pos_ex)
    if( allocated(charge_ex) ) deallocate(charge_ex)
    if( allocated(coulomb_rc) ) deallocate(coulomb_rc)
    if( allocated(coulomb_rn) ) deallocate(coulomb_rn)

  end subroutine m_EP_dealloc_point_charge

  subroutine m_EP_set_point_charge(n,pos,q,rc,rn)
    implicit none
    integer n
    real(8) pos(n,3)
    real(8) q(n)
    real(8) rc(n)
    real(8) rn(n)
    integer i

    natom_ex = n
    call m_EP_alloc_point_charge

    pos_ex = pos
    charge_ex = q
    coulomb_rc = rc
    coulomb_rn = rn

  end subroutine m_EP_set_point_charge

! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================
  subroutine m_EP_espot_by_external_charge

    use m_PlaneWaveBasisSet,    only : igfp_l
    use m_Crystal_Structure,    only : altv, univol
    use m_Control_Parameters,   only : nspin, kimg
    use m_Charge_Density,       only : chgq_l
    use m_FFT, only : nfftp, fft_box_size_CD, &
                      m_FFT_CD_direct, m_FFT_alloc_CD_box, m_FFT_dealloc_CD_box
    use m_Parallelization,      only : ista_kngp,iend_kngp, npes, mype, ierr &
                                     , ista_fftp,iend_fftp,ista_fftph,iend_fftph &
                                     , nis_fftp, nie_fftp, nel_fftp, idisp_fftp, mp_fftp
    use m_Files, only : nfout
    use mpi

    implicit none
!    include 'mpif.h'

    integer i, j, k, l, n, ik, iloop
    integer idp, nlp, nmp, nnp, nd2p
    integer ispin
    integer nn, ip
    integer, allocatable, dimension(:)  :: inx, jnx, knx
    real(8) rinplw
    real(8) r(3), r0(3), dist, rc, rn
    real(8) vpot, vpot1, vpot2
    real(8), allocatable, dimension(:) :: afft
    real(8), allocatable, dimension(:) :: afft_mpi1

    if(mype==0) write(6,*) 'electrostatic potential (point charge)...'

    ! allocate
    call m_FFT_alloc_CD_box()

    if( .not. allocated( espot ) ) then
       allocate( espot(ista_fftph:iend_fftph,nspin ) )
       espot = 0.0d0
    end if
    if( .not. allocated( espot_g ) ) then
       allocate( espot_g(ista_kngp:iend_kngp,kimg,nspin))
       espot_g = 0.d0
    end if

    allocate(afft(ista_fftp:iend_fftp))
    allocate(afft_mpi1(nfftp))
    !allocate(inx(ista_fftp:iend_fftp))
    !allocate(jnx(ista_fftp:iend_fftp))
    !allocate(knx(ista_fftp:iend_fftp))
    allocate(inx(1:nfftp))
    allocate(jnx(1:nfftp))
    allocate(knx(1:nfftp))

    ! map FFT mesh

    idp  = fft_box_size_CD(1,0)
    nlp  = fft_box_size_CD(1,1)
    nmp  = fft_box_size_CD(2,1)
    nnp  = fft_box_size_CD(3,1)
    nd2p = fft_box_size_CD(2,0)

    !do n = ista_fftp, iend_fftp
    do n = 1, nfftp
       nn = (n+kimg-1)/kimg
       i  = mod(nn,idp)
       j  = mod((nn-1)/idp,nd2p) + 1
       k  = (nn - (j-1)*idp - i)/(idp*nd2p) + 1
       inx(n) = i - 1;
       jnx(n) = j - 1;
       knx(n) = k - 1;
    end do

    espot = 0.d0
    do i = 1, natom_ex

       write(6,'(i5,3f15.8,3f10.5)') i, pos_ex(i,:), charge_ex(i), coulomb_rc(i), coulomb_rn(i)

       do k = ista_fftph, iend_fftph
          ip = 2*k-1
          r(1:3) = altv(1:3,1)*dble(inx(ip))/dble(nlp)+altv(1:3,2)*dble(jnx(ip))/dble(nmp)&
               +altv(1:3,3)*knx(ip)/dble(nnp)

          r0(1:3) = pos_ex(i,1:3)
          dist = sqrt(dot_product(r-r0, r-r0))
          rc = coulomb_rc(i)
          rn = coulomb_rn(i)
          vpot1 = 0.d0
          vpot2 = 0.d0
          if( dist > 0.d0 ) then
             do n = 0, int(rn)
                if( n /= 0 ) vpot1 = vpot1 + (rc**dble(rn-n))*(dist**dble(n-1))
                vpot2 = vpot2 + (rc**dble(rn-n))*(dist**dble(n))
             end do
          else
             vpot1 = rc**(rn-1.d0)
             vpot2 = rc**rn
          end if
          vpot = vpot1 / vpot2
          espot(k,1:nspin)=espot(k,1:nspin)-charge_ex(i)*vpot
       end do
    end do

    afft_mpi1 = 0.d0
    do iloop = 1, nspin
       ! copy R-space potential to FFT mesh
       afft = 0.d0
       do i = ista_fftph, iend_fftph
          afft(2*i-1) = espot(i,iloop)
       end do

       ! FFTl to G-space
       call m_FFT_CD_direct(nfout,afft)

       if(npes >= 2) then
          call mpi_allgatherv(afft,nel_fftp(mype),mpi_double_precision &  ! MPI
               &       ,afft_mpi1,nel_fftp,idisp_fftp,mpi_double_precision,MPI_CommGroup,ierr)
       else
          afft_mpi1 = afft
       end if

       rinplw = 1.d0/product(fft_box_size_CD(1:3,1))
       do ik = 1, kimg
          do i = ista_kngp, iend_kngp  !for mpi
             ip = (igfp_l(i)-1)*kimg + ik
             espot_g(i,ik,iloop)   = afft_mpi1(ip)*rinplw
          end do
       end do
    end do

    ! deallocate
    deallocate( inx )
    deallocate( jnx )
    deallocate( knx )
    deallocate(afft)
    deallocate(afft_mpi1)
    call m_FFT_dealloc_CD_box()

  end subroutine m_EP_espot_by_external_charge
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================

end module m_External_Potential

! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================
subroutine charge_density_realspace

  use m_PlaneWaveBasisSet,    only : igfp_l
  use m_Crystal_Structure,    only : altv, univol
  use m_Control_Parameters,   only : nspin, kimg
  use m_Charge_Density,       only : chgq_l
  use m_FFT, only : nfftp, fft_box_size_CD, &
                    m_FFT_CD_direct, m_FFT_CD_inverse_c, m_FFT_check_of_negative_CD, &
                    m_FFT_alloc_CD_box, m_FFT_dealloc_CD_box
  use m_Parallelization,      only : ista_kngp,iend_kngp, npes, mype, ierr &
                                   , npes_cdfft &
                                   , ista_fftp,iend_fftp,ista_fftph,iend_fftph &
                                   , nis_fftp, nie_fftp, nel_fftp, idisp_fftp, mp_fftp &
                                   , MPI_CommGroup
  use m_Files, only : nfout
  use m_External_Potential, only : mesh_coord, mesh_delta, charge_r
  use mpi

  implicit none

!  include 'mpif.h'

  integer i, j, k, l, n, ik, iloop
  integer idp, nlp, nmp, nnp, nd2p
  integer ispin
  integer nn, ip
  integer, allocatable, dimension(:)  :: inx, jnx, knx
  real(8) r(3)
  real(8), allocatable, dimension(:) :: afft
  real(8), allocatable, dimension(:) :: afft_mpi1
  real(8), allocatable, dimension(:) :: afft_mpi2,afft_mpi3
  real(8), allocatable, dimension(:) :: work

  ! allocate
  call m_FFT_alloc_CD_box()

  !ista_fftph = 1
  !iend_fftph = nfftp/2
  if( associated( mesh_coord ) ) deallocate(mesh_coord)
  allocate( mesh_coord(1:nfftp,3) )
  if(associated(charge_r)) deallocate(charge_r)
  allocate(charge_r(1:nfftp/2))
  charge_r = 0.0d0

  allocate(afft(ista_fftp:iend_fftp))
  allocate(afft_mpi1(nfftp))
  if(npes >= 2) then
     allocate(afft_mpi2(mp_fftp))
     allocate(afft_mpi3(mp_fftp))
  end if
  !  allocate(inx(ista_fftp:iend_fftp))
  !  allocate(jnx(ista_fftp:iend_fftp))
  !  allocate(knx(ista_fftp:iend_fftp))
  allocate(inx(1:nfftp))
  allocate(jnx(1:nfftp))
  allocate(knx(1:nfftp))

  ! map FFT mesh

  idp  = fft_box_size_CD(1,0)
  nlp  = fft_box_size_CD(1,1)
  nmp  = fft_box_size_CD(2,1)
  nnp  = fft_box_size_CD(3,1)
  nd2p = fft_box_size_CD(2,0)

  !  do n = ista_fftp, iend_fftp
  do n = 1, nfftp
     nn = (n+kimg-1)/kimg
     i  = mod(nn,idp)
     j  = mod((nn-1)/idp,nd2p) + 1
     k  = (nn - (j-1)*idp - i)/(idp*nd2p) + 1
     inx(n) = i - 1;
     jnx(n) = j - 1;
     knx(n) = k - 1;
  end do

  do k = 1, nfftp/2
     ip = 2*k-1
     r(1:3) = altv(1:3,1)*dble(inx(ip))/dble(nlp)+altv(1:3,2)*dble(jnx(ip))/dble(nmp)&
          +altv(1:3,3)*knx(ip)/dble(nnp)
     mesh_coord(ip,1:3) = r(1:3)
     mesh_delta(1:3,1) = altv(1:3,1)/dble(nlp)
     mesh_delta(1:3,2) = altv(1:3,2)/dble(nmp)
     mesh_delta(1:3,3) = altv(1:3,3)/dble(nnp)
  end do

  afft_mpi1 = 0.d0
  do iloop = 1, nspin
     ! map charge on FFT box
     do j = 1, kimg
        do i = ista_kngp, iend_kngp  !for mpi
           ip = (igfp_l(i)-1)*kimg + j
           afft_mpi1(ip) = afft_mpi1(ip) + chgq_l(i,j,iloop) !mpi
        end do
     end do

     if(npes >= 2) then
        call mpi_barrier(MPI_CommGroup,ierr)
        do j = 0, npes-1

           do i = nis_fftp(j),nie_fftp(j)
              afft_mpi2(i-nis_fftp(j)+1) = afft_mpi1(i)
           end do
           call mpi_allreduce(afft_mpi2,afft_mpi3,mp_fftp &
                &  ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)

           if(j == mype) then
              do i = ista_fftp, iend_fftp
                 afft(i) = afft_mpi3(i - ista_fftp + 1)
              end do
           end if
        end do
     else
        afft = afft_mpi1
     end if

     ! FFT G-space to R-space
     call m_FFT_CD_inverse_c(nfout,afft)
     !call m_FFT_check_of_negative_CD(afft,nfout,nspin,iloop)
     call m_FFT_check_of_negative_CD(npes_cdfft,ista_fftp,iend_fftp&
          & ,ista_fftph,iend_fftph,afft,nfout,nspin,iloop)

     ! copy afft to charge density(in R-space)
     do i = ista_fftph, iend_fftph
        charge_r(i) = afft(i*2-1)*univol/dble(idp*nd2p*nd2p)
     end do
  end do

  allocate(work(1:nfftp/2))
  call mpi_allreduce(charge_r,work,nfftp/2 &
       &  ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
  charge_r = work
  deallocate(work)

  ! deallocate
  deallocate( inx )
  deallocate( jnx )
  deallocate( knx )
  deallocate(afft)
  deallocate(afft_mpi1)
  if(npes >= 2) then
     deallocate(afft_mpi2)
     deallocate(afft_mpi3)
  end if
  call m_FFT_dealloc_CD_box()

end subroutine charge_density_realspace
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================

module m_CoreLevel_Spectrum

  use m_Control_Parameters,  only : kimg, nspin, printable, ipriinputfile, noncol, &
       &                            ndim_spinor, sw_corelevel_spectrum, &
       &                            sw_local_approx_trans_moment, &
       &                            sw_v2c_xes, ndim_chgpot
  use m_Const_Parameters, only : DP, CMPLDP, PAI2, PAI4, zi, BUCS, FMAXVALLEN, LOWER, &
       &                         OFF, ON, Hartree, CARTS, GAMMA, ELECTRON, DIRECT
  use m_Kpoints,    only : kv3, vkxyz, qwgt, k_symmetry

  use m_Files,  only : nfout, nfpot, nfcore_energy_out, &
       &               nfcore_energy_initial, nfcore_energy_final, &
       &               m_Files_open_ps_files, m_Files_close_ps_files, &
       &               m_Files_open_core_energy_file, m_Files_close_core_energy_file, &
       &               m_Files_open_core_ene_initial, m_Files_close_core_ene_initial, &
       &               m_Files_open_core_ene_final, m_Files_close_core_ene_final, &
       &               m_Files_open_ps_file, m_Files_close_ps_file


  use m_Parallelization,  only : mype, ierr, myrank_k, map_k, npes, ista_k, iend_k, &
       &                         np_e, ista_kngp, iend_kngp, MPI_CommGroup, ierr, &
       &                         mpi_k_world, nrank_e, np_g1k, ista_g1k

  use m_PlaneWaveBasisSet,  only : kg1, nbase, iba, ngabc, kgp, kg, igf
  use m_Ionic_System,  only : ityp, ivan, iatomn, ntyp, pos, natm, cps

  use m_PseudoPotential,  only : nmesh, radr, wos, xh, rmax, ltp, mtp, taup, &
       &                         ilmt, lmta, psirpw, wf_mnrc, radr_paw, mmesh, flg_paw

  use m_Crystal_Structure,  only : univol, rltv
  use m_NonLocal_Potential,  only : new_radr_and_wos
  use m_Electronic_Structure,     only : efermi, eko_l, occup_l, zaj_l, fsr_l, fsi_l, &
       &                                 vlhxc_l

#if 0
  use m_SPinOrbit_RadInt,  only : m_SO_calc_contrib_corelevels, &
       &                          m_SO_calc_core_energy_atoms, &
       &                          m_SO_calc_corelevel_splitting
#else
  use m_SPinOrbit_RadInt,  only : m_SO_calc_corelevel_splitting, &
       &                          m_SO_calc_contrib_corelevels
#endif

  use m_SpinOrbit_Potential, only :  EigenWfns_MatLS_L1,  EigenWfns_MatLS_L2, &
       &                             EigenWfns_MatLS_L3, &
       &                             m_SO_set_MatU_ylm_RC, &
       &                             m_SO_calc_MatLS_orb_s_to_f, &
       &                             m_SO_diagonalize_MatLS
  use m_Total_Energy,       only : etotal

! === KT_add ==== 2014/08/08
  use m_Const_Parameters,   only : ByPawPot, ReadFromPP
  use m_Control_Parameters,  only :  eval_core_level_splitting
  use m_Orbital_QuantumNum, only : num_orb_index_data, &
       &                           qnum_n_orb_index, qnum_l_orb_index, &
       &                           qnum_t_orb_index, qnum_tau_orb_index
! =============== 2014/08/08

  use m_FFT,            only :  nfft, fft_box_size_WF, m_FFT_alloc_WF_work, &
       &                        m_FFT_dealloc_WF_work, m_FFT_WF

! === KT_add === 2015/01/23
  use m_Control_Parameters,  only : SpinOrbit_mode
! ============== 2015/01/12
  use mpi

  implicit none
!  include 'mpif.h'
!
! --------------
!  General
!
  character(len("corelevel_spectrum")),   parameter  &
       &            ::   tag_corelevel_spectrum   = "corelevel_spectrum"
  character(len("sw_corelevel_spectrum")),   parameter  &
       &            ::   tag_sw_corelevel_spectrum   = "sw_corelevel_spectrum"
  character(len("sw_local_approx_trans_moment")),   parameter  &
       &            ::   tag_sw_local_approx_trans_mom = "sw_local_approx_trans_moment"
  character(len("sw_v2c_xes")),   parameter  &
       &            ::   tag_sw_v2c_xes = "sw_v2c_xes"
  character(len("on")), parameter          ::    tag_on =  "on"
  character(len("off")), parameter          ::    tag_off =  "off"
!
!!!  integer :: sw_corelevel_spectrum = OFF
!
! --------------
!  Core states to probe
!
  character(len("probe")),   parameter  ::   tag_probe   = "probe"
  character(len("atom_id")),   parameter  :: tag_atomid  = "atom_id"
  character(len("spin")),   parameter  :: tag_spin = "spin"
  character(len("orbital")),   parameter  :: tag_orbital  = "orbital"

  integer :: atom_to_probe =0
  integer :: spin_to_probe = 0
  integer :: qnum_n_to_probe =1, qnum_l_to_probe =0     ! K-edge default
  integer :: num_core_states
!
  integer :: ndim_spinor_core_states = 1
!
  real(kind=DP), allocatable :: psig_core_states(:,:,:,:)
  real(kind=DP), allocatable :: fsr_core_states(:,:,:), fsi_core_states(:,:,:)
!
  real(kind=DP), allocatable :: ene_core_states(:)
!
! --------------
! initial/final states
!
  character(len("initial_state_level")),   parameter :: &
       &                        tag_initial_state_level  = "initial_state_level"
  character(len("initial_state_splitting")),   parameter :: &
       &                        tag_initial_state_splitting  = "initial_state_splitting"

  character(len("initial_state_energy")),   parameter :: &
       &                        tag_initial_state_energy  = "initial_state_energy"
  character(len("final_state_energy")),   parameter :: &
       &                        tag_final_state_energy  = "final_state_energy"
  character(len("read_core_energy_from_file")),   parameter :: &
       &                  tag_read_core_energy_from_file = "read_core_energy_from_file"
  character(len("mimic_soc_split_spectrum")),   parameter :: &
       &                  tag_mimic_soc_split_spectrum = "mimic_soc_split_spectrum"

  real(kind=DP) :: ene_initial_state_level = 0.0d0
  real(kind=DP) :: ene_initial_state_splitting = 0.0d0
  real(kind=DP) :: etot_initial_state = 0.0d0
  real(kind=DP) :: etot_final_state = 0.0d0
!
  real(kind=DP) :: etot_change_initial_to_final = 0.0d0
!
  logical :: read_core_energy_from_file = .true.
  logical :: mimic_soc_split_spectrum = .true.
  logical :: initial_state_splitting_is_set = .false.
!
! ---
  real(kind=DP) :: eshift_corelevel_virtual = -0.1d0

! --------------
!  Momentum transfer
!
  character(len("momentum")),   parameter  ::  tag_momentum   = "momentum"
  character(len("qx")),   parameter  :: tag_qx  = "qx"
  character(len("qy")),   parameter  :: tag_qy  = "qy"
  character(len("qz")),   parameter  :: tag_qz  = "qz"
!
  real(kind=DP) :: vec_q(3) = (/0.0D0, 0.0D0, 1.0D0/)
!
  character(len("polarization")),   parameter  ::  tag_polarization   = "polarization"
  character(len("ux")),   parameter  :: tag_ux  = "ux"
  character(len("uy")),   parameter  :: tag_uy  = "uy"
  character(len("uz")),   parameter  :: tag_uz  = "uz"
!
! --------------
!  Energy range
!
  character(len("energy")),   parameter  ::  tag_energy   = "energy"
  character(len("low")),      parameter  ::  tag_low      = "low"
  character(len("high")),     parameter  ::  tag_high     = "high"
  character(len("step")),     parameter  ::  tag_step     = "step"
!
  real(kind=DP) :: e_low = -0.2D0,  e_high = 2.0D0,  e_step = 0.002d0   ! default
  integer :: ndiv_erange
!
! --------------
! Density Response Function
!
  character(len("smearing_width")),   parameter  ::  tag_eta = "smearing_width"

! real(kind=DP) :: eta = 0.01837451d0               ! 0.5 eV
  complex(kind=CMPLDP), allocatable :: Chi0_00(:)
!
! --------------
! AE wave functions of core orbs
!
  integer :: num_core_ae_wfns
  integer, allocatable :: qnum_n_core_ae_wfns(:)
  integer, allocatable :: qnum_l_core_ae_wfns(:)
  real(kind=DP), allocatable :: psir_core_ae_wfns(:,:)
  real(kind=DP), allocatable :: enelevel_core_ae_wfns(:)
  real(kind=DP), allocatable :: focc_core_ae_wfns(:)
  real(kind=DP), allocatable :: level_splitting_core_ae_wfns(:)
!
! --------------
!  Dipole correction term
!
  integer :: num_dipole_dxyz_core2val
  integer, allocatable :: dipole_dxyz_core2val_n1(:),   dipole_dxyz_core2val_t2(:)
  integer, allocatable :: dipole_dxyz_core2val_ylm1(:), dipole_dxyz_core2val_ylm2(:)
  real(kind=DP), allocatable :: dipole_dxyz_core2val(:,:)

contains

  subroutine m_CLS_initialize
    vec_q(1:3) = (/0.0D0, 0.0D0, 1.0D0/)
  end subroutine m_CLS_initialize

  subroutine m_CLS_chk_sw_corelevel_spectrum
    integer :: f_selectBlock, f_getStringValue, f_getRealValue, f_getIntValue
    integer :: f_selectParentBlock, f_selectTop, iret

    real(kind=DP) :: norm, dret
    character(3) :: str1
    character(len=FMAXVALLEN) :: rstr
    logical :: tf

    if( f_getStringValue( tag_sw_corelevel_spectrum, rstr, LOWER) == 0) then
       call strncmp0( tag_on, trim(rstr), tf)
       if(tf) sw_corelevel_spectrum = on
    end if
    if( f_getStringValue( tag_sw_v2c_xes, rstr, LOWER) == 0) then
       call strncmp0( tag_on, trim(rstr), tf)
       if(tf) sw_v2c_xes = on
    end if
    write(nfout,*) '!** CLS: sw_corelevel_spectrum is ', sw_corelevel_spectrum
    write(nfout,*) '!** CLS: sw_v2c_xes is ', sw_v2c_xes
  end subroutine m_CLS_chk_sw_corelevel_spectrum

  subroutine m_CLS_chk_sw_local_approx_trans
    integer :: f_selectBlock, f_getStringValue, f_getRealValue, f_getIntValue
    integer :: f_selectParentBlock, f_selectTop, iret

    real(kind=DP) :: norm, dret
    character(3) :: str1
    character(len=FMAXVALLEN) :: rstr
    logical :: tf

    if( f_getStringValue( tag_sw_local_approx_trans_mom, rstr, LOWER) == 0) then
       call strncmp0( tag_on, trim(rstr), tf)
       if(tf) sw_local_approx_trans_moment = on
    end if
    write(nfout,*) '!** CLS: sw_local_approx_trans_moment is ', &
         &                   sw_local_approx_trans_moment
  end subroutine m_CLS_chk_sw_local_approx_trans

  subroutine m_CLS_rd_n
    integer :: f_selectBlock, f_getStringValue, f_getRealValue, f_getIntValue
    integer :: f_selectParentBlock, f_selectTop, iret

    real(kind=DP) :: norm, dret
    character(3) :: str1
    character(len=FMAXVALLEN) :: rstr

    iret = f_selectTop()
    if ( ipriinputfile >= 2 .and. printable ) then
       write(nfout,'(" !*  tag_corelevel_spectrum")')
    endif

    if ( f_selectBlock( tag_corelevel_spectrum ) == 0 ) then
       sw_corelevel_spectrum = ON
    endif
    if ( sw_corelevel_spectrum == ON ) call m_CLS_rd_n_main

  end subroutine m_CLS_rd_n

  subroutine m_CLS_rd_n_main
    integer :: f_selectBlock, f_getStringValue, f_getRealValue, f_getIntValue
    integer :: f_selectParentBlock, f_selectTop, iret

    real(kind=DP) :: norm, dret
    character(3) :: str1
    character(len=FMAXVALLEN) :: rstr
    logical :: tf

! --
    initial_state_splitting_is_set = .false.

! ----- probe ---
    if ( f_selectBlock( tag_probe ) == 0 ) then
       if ( f_getIntValue( tag_atomid, iret ) == 0 ) then
!          if ( iret < 1 .or. iret > natm ) then
!             write(nfout,*) '!! AtomID is not set'
!             call phase_error_with_msg(nfout,'!! AtomID is not set',__LINE__,__FILE__)
!          else
             atom_to_probe = iret
!          endif
       endif
       if ( f_getIntValue( tag_spin, iret ) == 0 ) then
          spin_to_probe = iret
       endif
       if ( f_getStringValue( tag_orbital, rstr, LOWER ) == 0 ) then
          str1 = trim(rstr)

          if ( str1(1:1) == "1" ) qnum_n_to_probe = 1
          if ( str1(1:1) == "2" ) qnum_n_to_probe = 2
          if ( str1(1:1) == "3" ) qnum_n_to_probe = 3
          if ( str1(1:1) == "4" ) qnum_n_to_probe = 4
          if ( str1(1:1) == "5" ) qnum_n_to_probe = 5
          if ( str1(1:1) == "6" ) qnum_n_to_probe = 6

          if ( str1(2:2) == "s" .or. str1(2:2) == "s" ) qnum_l_to_probe = 0
          if ( str1(2:2) == "p" .or. str1(2:2) == "p" ) qnum_l_to_probe = 1
          if ( str1(2:2) == "d" .or. str1(2:2) == "d" ) qnum_l_to_probe = 2
          if ( str1(2:2) == "f" .or. str1(2:2) == "f" ) qnum_l_to_probe = 3

          if( f_getRealValue( tag_initial_state_level, dret, 'hartree') == 0) then
             ene_initial_state_level  = dret
          endif
          if( f_getRealValue( tag_initial_state_splitting, dret, 'hartree') == 0) then
             ene_initial_state_splitting  = dret
          endif

          if( f_getRealValue( tag_initial_state_energy, dret, 'hartree') == 0) then
             etot_initial_state  = dret
          endif
          if( f_getRealValue( tag_final_state_energy, dret, 'hartree') == 0) then
             etot_final_state  = dret
          endif

          if( f_getRealValue( tag_initial_state_splitting, dret, 'hartree') == 0) then
             ene_initial_state_splitting  = dret
             initial_state_splitting_is_set = .true.
          endif

          if ( f_getStringValue( tag_read_core_energy_from_file, rstr, LOWER )==0 ) then
             call strncmp0( tag_on, trim(rstr), tf )
             if ( tf ) read_core_energy_from_file = .true.
             call strncmp0( tag_off, trim(rstr), tf )
             if ( tf ) read_core_energy_from_file = .false.
          endif
          if ( f_getStringValue( tag_mimic_soc_split_spectrum, rstr, LOWER )==0 ) then
             call strncmp0( tag_on, trim(rstr), tf )
             if ( tf ) mimic_soc_split_spectrum = .true.
             call strncmp0( tag_off, trim(rstr), tf )
             if ( tf ) mimic_soc_split_spectrum = .false.
          endif

       endif
! ----- energy range ----
       if ( f_selectBlock( tag_energy ) == 0 ) then
          if( f_getRealValue( tag_low, dret, 'hartree') == 0) e_low  = dret
          if( f_getRealValue( tag_high, dret,'hartree') == 0) e_high = dret
          if( f_getRealValue( tag_step, dret,'hartree') == 0) e_step = dret
          iret = f_selectParentBlock()
       endif
! ----- momentum transfer
       if ( f_selectBlock( tag_momentum ) == 0 ) then
          if ( f_getRealValue( tag_qx, dret," " ) == 0 ) vec_q(1) = dret
          if ( f_getRealValue( tag_qy, dret," " ) == 0 ) vec_q(2) = dret
          if ( f_getRealValue( tag_qz, dret," " ) == 0 ) vec_q(3) = dret
          iret = f_selectParentBlock()
       endif
       if ( f_selectBlock( tag_polarization ) == 0 ) then
          if ( f_getRealValue( tag_ux, dret," " ) == 0 ) vec_q(1) = dret
          if ( f_getRealValue( tag_uy, dret," " ) == 0 ) vec_q(2) = dret
          if ( f_getRealValue( tag_uz, dret," " ) == 0 ) vec_q(3) = dret
          iret = f_selectParentBlock()
       endif

       iret = f_selectParentBlock()
    endif

    norm = sqrt( vec_q(1)**2 +vec_q(2)**2 +vec_q(3)**2 )
    if ( norm > 1.0D-8 ) then
       vec_q = vec_q /norm
    else
       vec_q = 0.0;  vec_q(3) = 1.0D0
    endif

    if ( etot_initial_state /= 0.0d0 .and. etot_final_state /= 0.0d0 ) then
       etot_change_initial_to_final = etot_final_state -etot_initial_state
    endif

    if ( qnum_l_to_probe > 0 ) then
       if ( nspin == 1 ) mimic_soc_split_spectrum = .true.
    endif

! === kT_add === 2014/09/22
    if ( ndim_spinor == 2 ) mimic_soc_split_spectrum = .false.
! ============== 2014/09/22

    num_core_states = 2 *qnum_l_to_probe +1

    if ( noncol ) then
       num_core_states = 2 *num_core_states
       ndim_spinor_core_states = 2
    else
       if ( qnum_l_to_probe > 0 ) then
          if ( .not. mimic_soc_split_spectrum ) then
             num_core_states = 2 *num_core_states
             ndim_spinor_core_states = 2
          endif
       endif
    endif

    if ( printable ) then
       write(nfout,*)
       write(nfout,*) '!** CLS: ****** Configuration of CoreLevel Spectrum *****'
       write(nfout,*) '!** CLS: Atom ID =', atom_to_probe
       write(nfout,*) '!** CLS: spin =', spin_to_probe
       write(nfout,*) '!** CLS: qnum_n, qnum_l =', qnum_n_to_probe, qnum_l_to_probe
       write(nfout,'(A,3F15.8)') ' !** CLS: Momentum transfer direction = ', &
            &                    vec_q(1), vec_q(2), vec_q(3)
       write(nfout,'(3(A,F15.8))') &
            &          ' !** CLS: energy range =  low: ', e_low, " high: ", e_high, &
            &          " step: ", e_step
       if ( ene_initial_state_level /= 0.0d0 ) then
          write(nfout,'(A,F15.8)') " !** CLS: initial_state_level = ", &
               &              ene_initial_state_level
       endif
       if ( ene_initial_state_splitting /= 0.0d0 ) then
          write(nfout,'(A,F15.8)') " !** CLS: initial_state_splitting = ", &
               &                        ene_initial_state_splitting
       endif

       if ( etot_initial_state /= 0.0d0 ) then
          write(nfout,'(A,F15.8)') " !! initial state total energy= ",etot_initial_state
       endif
       if ( etot_final_state /= 0.0d0 ) then
          write(nfout,'(A,F15.8)') " !! final   state total energy= ",etot_final_state
       endif
       if ( etot_change_initial_to_final /= 0.0d0 ) then
          write(nfout,'(A,F15.8)') " !! etot_change_initial_to_final = ", &
               &                    etot_change_initial_to_final
       endif

       write(nfout,*) '!** CLS: read_core_energy_from_file is ', &
            &                read_core_energy_from_file
       write(nfout,*) '!** CLS: mimic_soc_split_spectrum is ', mimic_soc_split_spectrum

       write(nfout,*) '!** CLS: num_core_states = ', num_core_states
       write(nfout,*) '!** CLS: ************************************************ '
       write(nfout,*)
    endif

  end subroutine m_CLS_rd_n_main

! === KT_add === 2014/10/02
  integer function m_CLS_find_orb_index_to_probe()
    integer :: index, i

    index = 0
    Do i=1, num_core_ae_wfns
       if ( qnum_n_core_ae_wfns(i) == qnum_n_to_probe .and. &
            qnum_l_core_ae_wfns(i) == qnum_l_to_probe ) then
          index = i
          exit
       endif
    End Do
    m_CLS_find_orb_index_to_probe = index

  end function m_CLS_find_orb_index_to_probe
! ============= 2014/10/02

  subroutine m_CLS_read_core_energy
    real(kind=DP) :: c1

    call m_Files_open_core_ene_initial
    call m_Files_open_core_ene_final

    if ( mype == 0 ) then
       call set_splitting_and_etotal( nfcore_energy_initial, c1, etot_initial_state )
       ene_initial_state_splitting = c1

       call set_splitting_and_etotal( nfcore_energy_final,   c1, etot_final_state   )
       etot_change_initial_to_final = etot_final_state -etot_initial_state

       write(nfout,*) '**********************************************'
       write(nfout,*) '** etot_initial_state is read and set to ', &
            &             etot_initial_state
       write(nfout,*) '** etot_final_state is read and set to ', &
            &             etot_final_state
       write(nfout,*) '** ene_initial_state_splitting is read and set to ', &
            &             ene_initial_state_splitting
       write(nfout,*) '**********************************************'
    endif

    if ( npes > 1 ) then
       call mpi_bcast( ene_initial_state_splitting, 1, mpi_double_precision, &
            &          0, mpi_comm_world, ierr )
       call mpi_bcast( etot_change_initial_to_final, 1, mpi_double_precision, &
            &          0, mpi_comm_world, ierr )
    endif

    call m_Files_close_core_ene_initial
    call m_Files_close_core_ene_final

  contains

    subroutine set_splitting_and_etotal( lun, ene_splitting, ene_total )
      integer, intent(in) :: lun
      real(kind=DP), intent(out) :: ene_splitting, ene_total

      integer :: n1, n2, n3, n4, ia, it
      real(kind=DP) :: c1
      logical :: found

      ene_splitting = 0.0d0;  ene_total = 0.0d0
      ia = atom_to_probe;    it = ityp(ia)

      found = .false.

      read(lun,*);   read(lun,*)
      Do while ( .true. )
         read(lun,*) n1, n2, n3, n4, c1
#if 0
         if ( n1 == it .and. n2 == ia .and. n3 == qnum_n_to_probe &
              &                       .and. n4 == qnum_l_to_probe ) then
#else
         if ( n2 == ia .and. n3 == qnum_n_to_probe &
              &        .and. n4 == qnum_l_to_probe ) then
#endif
            ene_splitting = c1
            found = .true.
         endif
         if ( n1 == 0 ) exit
      End do

      read(lun,*);  read(lun,*);   read(lun,*) ene_total

      if ( .not. found ) then
         if ( qnum_l_to_probe > 0 ) call phase_error_with_msg(nfout,"ene_splitting is not found",__LINE__,__FILE__)
      endif

    end subroutine set_splitting_and_etotal

  end subroutine m_CLS_read_core_energy

! ==== ONLY TEST ===
  subroutine m_CLS_set_corelevels_virtually
    integer :: orb_index, ia, it, i
    real(kind=DP) :: ene_lower, ene_higher
    real(kind=DP), allocatable :: level_splitting(:)

    ia = atom_to_probe;  it = ityp(ia)

    allocate( level_splitting( num_core_ae_wfns ) )
    level_splitting = 0.0d0

    if ( flg_paw .and. eval_core_level_splitting == ByPawPot ) then
       call m_SO_calc_corelevel_splitting( ia, it, &
            &                              num_core_ae_wfns, &
            &                              qnum_l_core_ae_wfns, &
            &                              nmesh(it), psir_core_ae_wfns, &
            &                              level_splitting )
    endif
!
    orb_index = m_CLS_find_orb_index_to_probe()
    ene_higher = efermi +eshift_corelevel_virtual
    ene_lower  = ene_higher -level_splitting( orb_index )
!
    if ( noncol ) then
       Do i=1, num_core_states
          if ( i <= 2*qnum_l_to_probe ) then
             ene_core_states(i) = ene_lower
          else
             ene_core_states(i) = ene_higher
          endif
       End Do
    else
       ene_core_states = ene_higher
    endif

    deallocate( level_splitting )

  end subroutine m_CLS_set_corelevels_virtually

#if 0
  subroutine m_CLS_estimate_corelevels
    integer :: ia, it, j, orb_index
    real(kind=DP) :: e_level_hard, e_level_soc

    real(kind=DP), allocatable :: e_levels_soft(:)

    ia = atom_to_probe;    it = ityp(ia)
    orb_index = m_CLS_find_orb_index_to_probe()

    allocate( e_levels_soft( num_core_states ) )
    call calc_softpart_contrib

!    write(*,*) "orb_index = ", orb_index

    call m_SO_calc_contrib_corelevels( ia, it, num_core_ae_wfns, &
         &                             orb_index, qnum_l_to_probe, &
         &                             nmesh(it), psir_core_ae_wfns, &
         &                             e_level_hard, e_level_soc )
    if ( mype == 0 ) then
       Do j=1, num_core_states
          write(9000+mype,*) j, e_levels_soft(j), e_level_hard, e_level_soc
       End do
    endif

    deallocate( e_levels_soft )

  contains

    subroutine calc_softpart_contrib
      integer :: ib, ik, ispin, i, ri, iend, i1, ig
      real(kind=DP) :: fac, epot, ekin, ekin_sum, c1
      real(kind=DP), allocatable :: afft(:), bfft(:), qxyz(:,:)
      real(kind=DP), allocatable :: psi_l(:,:,:,:), tmp_chgq_l(:,:,:)

!      fac = 2.d0 / (univol*kv3*product(fft_box_size_WF(1:3,1)))
      fac = 2.d0 / (univol*product(fft_box_size_WF(1:3,1)))

      allocate( afft(nfft) ); afft = 0.0d0
      allocate( bfft(nfft) ); bfft = 0.0d0

      allocate( qxyz(kg1,3 ) ); qxyz = 0.0d0
      allocate( tmp_chgq_l( ista_kngp:iend_kngp,kimg,nspin) ); tmp_chgq_l = 0.0d0

      call m_FFT_alloc_WF_work()

      Do ib=1, num_core_states
         afft = 0.0d0

         ekin = 0.0d0
         Do ispin=1, nspin
            Do ik = ispin, kv3+ispin-nspin, nspin
!            Do ik = 1, 1
               if ( map_k(ik) /= myrank_k ) cycle

               call k_plus_G_vectors_m( ik, kgp, kg1, kv3, iba, nbase, vkxyz, ngabc, &
                    &                   rltv, qxyz(:,1), qxyz(:,2), qxyz(:,3) )

               Do ig=1, iba(ik)
                  c1 = qxyz(ig,1)**2 + qxyz(ig,2)**2 + qxyz(ig,3)**2
                  c1 = c1 *qwgt(ik) /2.0d0
                  Do ri=1, kimg
                     ekin = ekin +psig_core_states(ig,ib,ik,ri)**2 *c1
                  End do
               End do

               allocate( psi_l( kg1, 1, ik:ik, kimg ) ); psi_l = 0.0d0
               psi_l(1:iba(ik),1,ik,:) = psig_core_states(1:iba(ik),ib,ik,:)

               call m_ES_WF_in_Rspace_kt( ik, ik, ik, psi_l, bfft )

               do i = 1, nfft-1, 2
                  afft(i) = afft(i) + ( bfft(i)**2 +bfft(i+1)**2 ) *qwgt(ik)
!                  afft(i) = afft(i) + ( bfft(i)**2 +bfft(i+1)**2 )
               end do
               deallocate( psi_l )
            End do
         End Do

         if ( npes > 1 ) then
            call mpi_allreduce( afft, bfft, nfft, mpi_double_precision, mpi_sum, &
                 &              MPI_CommGroup, ierr )
            afft = bfft /dble(nrank_e)
         endif

         call m_FFT_WF( ELECTRON, nfout, afft, DIRECT, OFF )

         Do ispin=1, nspin
            do ri = 1, kimg
               iend = iend_kngp
               if( iend_kngp > kg ) iend = kg
               if( ista_kngp <= iend ) then
                  do i = ista_kngp, iend  !for mpi
                     i1 = kimg*igf(i) + (ri - kimg)
                     tmp_chgq_l(i,ri,ispin) = afft(i1) *fac

                     write(9020+mype,*) i, ri, ispin, tmp_chgq_l(i,ri,ispin)*univol, vlhxc_l(i,ri,ispin)
                  end do
               endif
            end do
         End Do

         epot = 0.0d0
         Do ispin=1, nspin
            Do ri=1, kimg
               Do i=ista_kngp, iend_kngp
                  epot = epot +tmp_chgq_l(i,ri,ispin)*vlhxc_l(i,ri,ispin)
               End do
            End Do
         End do

         if ( npes > 1 ) then
            call mpi_allreduce( ekin, ekin_sum, 1, mpi_double_precision, mpi_sum, &
                 &              MPI_CommGroup, ierr )
            ekin = ekin_sum /dble(nrank_e)
         endif

         epot = epot /2.0d0 *univol

         e_levels_soft(ib) = epot +ekin
!
         write(9000+mype,*) "ib csum = ", ib, epot, ekin
      End Do
      call mpi_barrier( MPI_CommGroup, ierr )

      deallocate( afft ); deallocate( bfft ); deallocate( tmp_chgq_l )
      call m_FFT_dealloc_WF_work()

    end subroutine calc_softpart_contrib

  end subroutine m_CLS_estimate_corelevels
#endif

  subroutine m_CLS_set_data_core2val_from_pp
    integer :: ia, it
    integer :: nfp

!    if ( mype == 0 ) call m_Files_open_ps_files(ivan,iatomn,ntyp,ierr)
!    call m_Files_open_ps_files(ivan,iatomn,ntyp,ierr)
!    if (ierr/=0) call mpi_stop(nfout)

    ia = atom_to_probe;  it = ityp(ia)
    write(nfout,*) 'Reading core info from pp, ia = ', ia

! == KT_DEBUG === 2015/06/15 ==
!    call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierr)
!                                      ! this does not work properly by unknown reason.
    call m_Files_open_ps_files(ivan,iatomn,ntyp,ierr)
! =============== 2015/06/15

    if (ierr/=0) call mpi_stop(nfout)

    nfp = nfpot(it)

    if ( mype == 0 ) call read_num_core_ae_wfns( nfp, num_core_ae_wfns, it )
    if ( npes > 1 ) then
       call mpi_bcast(  num_core_ae_wfns, 1, mpi_integer, 0, mpi_comm_world, ierr )
    endif

    if ( num_core_ae_wfns == 0 ) return

    allocate( qnum_n_core_ae_wfns( num_core_ae_wfns ) )
    allocate( qnum_l_core_ae_wfns( num_core_ae_wfns ) )
    allocate( psir_core_ae_wfns( nmesh(it),  num_core_ae_wfns ) )
    allocate( enelevel_core_ae_wfns( num_core_ae_wfns ) )
    allocate( focc_core_ae_wfns( num_core_ae_wfns ) )
    allocate( level_splitting_core_ae_wfns( num_core_ae_wfns ) )

    if ( mype == 0 ) then
       call read_data_core_ae_wfns( nfp, num_core_ae_wfns, nmesh(it), &
            &                       qnum_n_core_ae_wfns, qnum_l_core_ae_wfns, &
            &                       psir_core_ae_wfns, &
            &                       enelevel_core_ae_wfns, focc_core_ae_wfns )
    endif

    if ( npes > 1 ) then
       call mpi_bcast( qnum_n_core_ae_wfns, num_core_ae_wfns, &
            &          mpi_integer, 0, mpi_comm_world, ierr )
       call mpi_bcast( qnum_l_core_ae_wfns, num_core_ae_wfns, &
            &          mpi_integer, 0, mpi_comm_world, ierr )
       call mpi_bcast( enelevel_core_ae_wfns, num_core_ae_wfns, &
            &          mpi_double_precision, 0, mpi_comm_world, ierr )
       call mpi_bcast( focc_core_ae_wfns, num_core_ae_wfns, &
            &          mpi_double_precision, 0, mpi_comm_world, ierr )
       call mpi_bcast( psir_core_ae_wfns, nmesh(it)*num_core_ae_wfns, &
            &          mpi_double_precision, 0, mpi_comm_world, ierr )
    endif

! === KT_add ===== 2015/01/23
    if ( eval_core_level_splitting == ReadFromPP ) then
       if ( mype == 0 ) then
          call read_data_core_level_splitting( nfp, it, num_core_ae_wfns, &
               &                               qnum_n_core_ae_wfns, &
               &                               qnum_l_core_ae_wfns, &
               &                               level_splitting_core_ae_wfns )
       endif
       if ( npes > 1 ) then
          call mpi_bcast( level_splitting_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
       endif
    endif
! =============== 2015/01/23

    if ( mype == 0 ) then
       call read_num_dipole_dxyz_core2val( nfp, num_dipole_dxyz_core2val,it )
    endif
    if ( npes > 1 ) then
       call mpi_bcast(  num_dipole_dxyz_core2val, 1, &
            &           mpi_integer, 0, mpi_comm_world, ierr )
    endif

    allocate( dipole_dxyz_core2val_n1( num_dipole_dxyz_core2val ) )
    allocate( dipole_dxyz_core2val_t2( num_dipole_dxyz_core2val ) )
    allocate( dipole_dxyz_core2val_ylm1( num_dipole_dxyz_core2val ) )
    allocate( dipole_dxyz_core2val_ylm2( num_dipole_dxyz_core2val ) )
    allocate( dipole_dxyz_core2val( num_dipole_dxyz_core2val,3 ) )

    if ( mype == 0 ) then
       if ( num_orb_index_data(it) > 0 ) then
          call read_dipole_dxyz_core2val_A( nfp, num_dipole_dxyz_core2val, &
               &                            dipole_dxyz_core2val_n1, &
               &                            dipole_dxyz_core2val_t2, &
               &                            dipole_dxyz_core2val_ylm1, &
               &                            dipole_dxyz_core2val_ylm2, &
               &                            dipole_dxyz_core2val, it )
       else
          call read_dipole_dxyz_core2val_B( nfp, num_dipole_dxyz_core2val, &
               &                            dipole_dxyz_core2val_n1, &
               &                            dipole_dxyz_core2val_t2, &
               &                            dipole_dxyz_core2val_ylm1, &
               &                            dipole_dxyz_core2val_ylm2, &
               &                            dipole_dxyz_core2val )
       endif
    endif
!
    if ( npes > 1 ) then
       call mpi_bcast( dipole_dxyz_core2val_n1, num_dipole_dxyz_core2val,&
            &          mpi_integer, 0, mpi_comm_world, ierr )
       call mpi_bcast( dipole_dxyz_core2val_t2, num_dipole_dxyz_core2val,&
            &          mpi_integer, 0, mpi_comm_world, ierr )
       call mpi_bcast( dipole_dxyz_core2val_ylm1, num_dipole_dxyz_core2val,&
            &          mpi_integer, 0, mpi_comm_world, ierr )
       call mpi_bcast( dipole_dxyz_core2val_ylm2, num_dipole_dxyz_core2val,&
            &          mpi_integer, 0, mpi_comm_world, ierr )
       call mpi_bcast( dipole_dxyz_core2val, num_dipole_dxyz_core2val*3,&
            &          mpi_double_precision, 0, mpi_comm_world, ierr )
    endif

    call m_Files_close_ps_file(it)

  end subroutine m_CLS_set_data_core2val_from_pp

  subroutine m_CLS_alloc_ene_core_states
    if ( .not. allocated(ene_core_states) ) then
       allocate( ene_core_states( num_core_states ) )
       ene_core_states = 0.0d0
    endif
  end subroutine m_CLS_alloc_ene_core_states

  subroutine m_CLS_alloc_wfn_core_states( psig_required )
    logical, intent(in) :: psig_required

    if ( allocated( psig_core_states ) ) deallocate( psig_core_states )
    if ( allocated( fsr_core_states ) ) deallocate( fsr_core_states )
    if ( allocated( fsi_core_states ) ) deallocate( fsi_core_states )

    if ( psig_required ) then
       allocate( psig_core_states( maxval(np_g1k), num_core_states, ista_k:iend_k, 2 ) )
       psig_core_states = 0.0d0
    endif
!
    allocate( fsr_core_states(num_core_states, 2*qnum_l_to_probe+1, ista_k:iend_k) )
    allocate( fsi_core_states(num_core_states, 2*qnum_l_to_probe+1, ista_k:iend_k ) )
    fsr_core_states = 0.0d0;  fsi_core_states = 0.0d0
!
  end subroutine m_CLS_alloc_wfn_core_states

  subroutine m_CLS_dealloc_ene_core_states
    if ( allocated( ene_core_states ) )  deallocate( ene_core_states )
  end subroutine m_CLS_dealloc_ene_core_states

  subroutine m_CLS_dealloc_wfn_core_states
    if ( allocated( psig_core_states ) ) deallocate( psig_core_states )
    if ( allocated( fsr_core_states ) )  deallocate( fsr_core_states )
    if ( allocated( fsi_core_states ) )  deallocate( fsi_core_states )
  end subroutine m_CLS_dealloc_wfn_core_states

  subroutine m_CLS_dealloc_core_ae_wfns
    if ( allocated( psir_core_ae_wfns ) ) deallocate( psir_core_ae_wfns )
    if ( allocated( enelevel_core_ae_wfns ) ) deallocate( enelevel_core_ae_wfns )
    if ( allocated( focc_core_ae_wfns ) )   deallocate( focc_core_ae_wfns )
    if ( allocated( qnum_n_core_ae_wfns ) ) deallocate( qnum_n_core_ae_wfns )
    if ( allocated( qnum_l_core_ae_wfns ) ) deallocate( qnum_l_core_ae_wfns )
    if ( allocated( level_splitting_core_ae_wfns ) ) then
       deallocate( level_splitting_core_ae_wfns )
    endif
  end subroutine m_CLS_dealloc_core_ae_wfns

  subroutine m_CLS_dealloc_dipole_core2val
    deallocate(dipole_dxyz_core2val_n1)
    deallocate(dipole_dxyz_core2val_t2)
    deallocate(dipole_dxyz_core2val_ylm1)
    deallocate(dipole_dxyz_core2val_ylm2)
    deallocate(dipole_dxyz_core2val)
  end subroutine m_CLS_dealloc_dipole_core2val

  subroutine m_CLS_set_ene_core_states
    integer :: i, ia, it, il1, index
    real(kind=DP) :: c1, c2, c0
    real(kind=DP), allocatable :: level_splitting(:)

    ia = atom_to_probe;   it = ityp(ia)
    il1 = qnum_l_to_probe +1

    index = 0
    Do i=1, num_core_ae_wfns
       if ( qnum_n_core_ae_wfns(i) == qnum_n_to_probe .and. &
            qnum_l_core_ae_wfns(i) == qnum_l_to_probe ) then
          index = i
          exit
       endif
    End Do
    if ( index == 0 ) call phase_error_with_msg(nfout,"index of core states is not found",__LINE__,__FILE__)

    ene_core_states = enelevel_core_ae_wfns(index)

! -------------
! set edge energy
! -------------
    if ( flg_paw .and. read_core_energy_from_file ) then        ! set automatically
       call m_CLS_read_core_energy
       if ( sw_v2c_xes == ON ) then
          ene_core_states = efermi +etot_change_initial_to_final     !! ????
       else
          ene_core_states = efermi -etot_change_initial_to_final     !! ????
       endif
!!!       ene_core_states = -etot_change_initial_to_final

    else
       if ( ene_initial_state_level /= 0.0 ) then
          ene_core_states = ene_initial_state_level
       endif
       if ( etot_change_initial_to_final /= 0.0d0 ) then
          ene_core_states = efermi -etot_change_initial_to_final
       endif
    endif

! ----------
! set spinorbit strength
! ----------
    if ( flg_paw .and. read_core_energy_from_file ) then
    else
       if ( .not. initial_state_splitting_is_set ) then
          if ( SpinOrbit_mode == ReadFromPP ) then
             ene_initial_state_splitting = level_splitting_core_ae_wfns( index )

          else if ( SpinOrbit_mode == ByPawPot ) then
             allocate( level_splitting( num_core_ae_wfns ) ); level_splitting = 0.0d0
             call m_SO_calc_corelevel_splitting( ia, it, &
                  &                              num_core_ae_wfns, &
                  &                              qnum_l_core_ae_wfns, &
                  &                              nmesh(it), psir_core_ae_wfns, &
                  &                              level_splitting )
             ene_initial_state_splitting = level_splitting( index )
             deallocate( level_splitting )
          endif
          write(nfout,*) "!** CLS: ene_initial_state_splitting = ", &
               &          ene_initial_state_splitting
       endif
    endif

    if ( qnum_l_to_probe > 0 ) then
       if ( mimic_soc_split_spectrum ) then
          c0 = ene_initial_state_splitting / (2 *qnum_l_to_probe +1)
          c1 = -c0 *( qnum_l_to_probe +1 )
          c2 =  c0 *qnum_l_to_probe
          ene_core_states = ene_core_states +c2

       else
          c0 = ene_initial_state_splitting / (2 *qnum_l_to_probe +1)
          c1 = -c0 *( qnum_l_to_probe +1 )
          c2 =  c0 *qnum_l_to_probe
!
          Do i=1, num_core_states
             if ( i<= qnum_l_to_probe*2 ) then
                ene_core_states(i) = ene_core_states(i) +c1
             else
                ene_core_states(i) = ene_core_states(i) +c2
             endif
          End Do
       endif
    endif

  end subroutine m_CLS_set_ene_core_states

  subroutine m_CLS_set_wfn_core_states( psig_required )         ! psig_core_stats
    logical, intent(in) :: psig_required

    integer :: i, ia, it, il1
    integer :: index

    real(kind=DP), allocatable :: psig_core_orb(:,:,:)

    ia = atom_to_probe;   it = ityp(ia)
    il1 = qnum_l_to_probe +1

    index = 0
    Do i=1, num_core_ae_wfns
       if ( qnum_n_core_ae_wfns(i) == qnum_n_to_probe .and. &
            qnum_l_core_ae_wfns(i) == qnum_l_to_probe ) then
          index = i
          exit
       endif
    End Do
    if ( index == 0 ) call phase_error_with_msg(nfout,"index of core states is not found",__LINE__,__FILE__)

    if ( psig_required ) then
       allocate( psig_core_orb( maxval(np_g1k), num_core_states/ndim_spinor_core_states, kv3/nspin ) )
       psig_core_orb = 0.0d0;

       call fourier_trans_of_core_ae_wfns
    endif

    if ( noncol ) then
       call set_core_states_with_phase_A
    else
       if ( ndim_spinor_core_states == 1 ) then
          call set_core_states_with_phase
       else
          call set_core_states_with_phase_A
       endif
    end if

    if ( allocated(psig_core_orb) ) deallocate( psig_core_orb );

  contains

    subroutine fourier_trans_of_core_ae_wfns
      integer :: ik, iksnl, im1, ig, nspher, n
      real(kind=DP), allocatable :: snl2(:), wka(:), wkb(:), ylm(:), vlength(:)
      real(kind=DP), allocatable :: qx(:), qy(:), qz(:)
      real(kind=DP) :: fac, facr, norm, hn

      allocate( snl2(kg1) ); allocate( vlength(kg1) );
      allocate( wka(kg1) ); allocate( wkb(kg1) );  allocate( ylm(kg1) )
      allocate( qx(kg1) ); allocate( qy(kg1) ); allocate( qz(kg1) );
      if ( allocated(radr) ) deallocate (radr)
      if ( allocated(wos) ) deallocate (wos)
      allocate( radr(nmesh(it) ) ); allocate( wos(nmesh(it) ) )

      fac = PAI4/dsqrt(univol)

! === KT_add == 2015/06/16
      call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
      call coef_simpson_integration(nmesh(it),nmesh(it),xh(it),radr,wos) ! -(b_PP)
! ============= 2015/06/16

      Do ik=1, kv3, nspin
         if(map_k(ik) /= myrank_k) cycle
         iksnl =(ik-1) /nspin +1

         call k_plus_G_vectors_3D( ik, kg, kg1, kv3, iba, nbase, vkxyz, ngabc, rltv,&
              &                 qx, qy, qz, vlength )
!         call new_radr_and_wos(ik,it)

         Do im1=1, 2*qnum_l_to_probe +1
            nspher = ( il1 -1 )**2 +im1

            call sphr(np_g1k(ik),nspher,qx,qy,qz,ylm)        ! -(bottom_Subr.)
            snl2 = 0.0d0

            do n=1, nmesh(it)
               facr = fac*wos(n)*radr(n)*psir_core_ae_wfns( n, index )
               do ig = 1, np_g1k(ik)
                  wka(ig) = vlength(ig)*radr(n)
               end do
               call dsjnv(il1-1,np_g1k(ik),wka,wkb)     ! -(bottom_Subr.)
               do ig = 1, np_g1k(ik)
                  snl2(ig) = snl2(ig) + facr *wkb(ig) *ylm(ig)
               end do
            end do
#if 0
! --- if normailzation is required ---
            norm = sum( snl2(1:kg1)*snl2(1:kg1) )
            do ig = 1, iba(ik)
               psig_core_orb(ig,im1,iksnl) = snl2(ig) /sqrt(norm)
            end do
#else
            do ig = 1, np_g1k(ik)
               psig_core_orb(ig,im1,iksnl) = snl2(ig)
            end do
#endif
         End do
      End do

      deallocate( snl2 ); deallocate( vlength );
      deallocate( wka ); deallocate( wkb );  deallocate( ylm )
      deallocate( qx ); deallocate( qy ); deallocate( qz );
      deallocate( radr ); deallocate( wos )

    end subroutine fourier_trans_of_core_ae_wfns

    subroutine set_core_states_with_phase
      integer::ik, iksnl,  mil, im1, ig, ii, ib
      real(kind=DP) :: ph, f1, f2, f3, ga, gb, gc
      real(kind=DP), allocatable :: zfcos(:), zfsin(:), tmp_wfn(:,:,:)

      if ( .not. psig_required ) goto 1000

      mil = mod( il1, 4 )

      allocate( zfcos(maxval(np_g1k)) );  allocate( zfsin(maxval(np_g1k)) )

      Do ik=1, kv3
         if(map_k(ik) /= myrank_k) cycle
         iksnl = ( ik-1 ) /nspin +1

         f1 = pos(ia,1)*PAI2; f2 = pos(ia,2)*PAI2; f3 = pos(ia,3)*PAI2

         Do ig = 1, np_g1k(ik)
            ii = nbase( ig+ista_g1k(ik)-1, ik )
!            if ( ii <= 0 ) cycle
!            ga = vkxyz(ik,1,BUCS) + real(ngabc(ii,1),kind=DP)
!            gb = vkxyz(ik,2,BUCS) + real(ngabc(ii,2),kind=DP)
!            gc = vkxyz(ik,3,BUCS) + real(ngabc(ii,3),kind=DP)
            ga = real(ngabc(ii,1),kind=DP)
            gb = real(ngabc(ii,2),kind=DP)
            gc = real(ngabc(ii,3),kind=DP)
            ph = ga *f1 +gb*f2 + gc*f3
            zfcos(ig) = dcos(ph);    zfsin(ig) = -dsin(ph)
         End do

         Do ib=1, num_core_states
            im1 = ib
            Do ig=1, np_g1k(ik)
               if ( kimg == 1 ) then
!                  psig_core_states(i,ib,ik,1) = zfcos(ig)*psig_core_orb(ig,im1,iksnl)
                  if ( mil == 1 .or. mil ==3 ) then
                     psig_core_states(ig,ib,ik,1) = zfcos(ig)*psig_core_orb(ig,im1,iksnl)
                     psig_core_states(ig,ib,ik,2) = zfsin(ig)*psig_core_orb(ig,im1,iksnl)
                  else
                     psig_core_states(ig,ib,ik,1) =-zfsin(ig)*psig_core_orb(ig,im1,iksnl)
                     psig_core_states(ig,ib,ik,2) = zfcos(ig)*psig_core_orb(ig,im1,iksnl)
                  endif
               else
                  if ( mil == 1 .or. mil ==3 ) then
                     psig_core_states(ig,ib,ik,1) = zfcos(ig)*psig_core_orb(ig,im1,iksnl)
                     psig_core_states(ig,ib,ik,2) = zfsin(ig)*psig_core_orb(ig,im1,iksnl)
                  else
                     psig_core_states(ig,ib,ik,1) =-zfsin(ig)*psig_core_orb(ig,im1,iksnl)
                     psig_core_states(ig,ib,ik,2) = zfcos(ig)*psig_core_orb(ig,im1,iksnl)
                  endif
               endif
            End do

         End Do

      End Do

      deallocate( zfcos, zfsin )

1000  continue
      Do ik=1, kv3
         if(map_k(ik) /= myrank_k) cycle
         Do ib=1, num_core_states
            im1 = ib
            fsr_core_states(ib,im1,ik) = 1.0d0
            fsi_core_states(ib,im1,ik) = 0.0d0
         End do
      End do

    end subroutine set_core_states_with_phase

    subroutine set_core_states_with_phase_A             ! nspin=2 only
      integer::ik, iksnl,  mil, im1, ig, ii, ib, jb, is
      integer :: ndim_spinor_bkup
      integer :: ndim_chgpot_bkup

      real(kind=DP) :: ph, f1, f2, f3, ga, gb, gc
      complex(kind=CMPLDP) :: z1, z2

      real(kind=DP), allocatable :: zfcos(:), zfsin(:), tmp_wfn(:,:,:)
!
      if ( .not. noncol ) then
         ndim_spinor_bkup = ndim_spinor;    ndim_spinor = 2
         ndim_chgpot_bkup = ndim_chgpot;    ndim_chgpot = 4
      endif
!
      call m_SO_set_MatU_ylm_RC
      call m_SO_calc_MatLS_orb_s_to_f
      call m_SO_diagonalize_MatLS
!
      if ( .not. noncol ) then
         ndim_spinor = ndim_spinor_bkup
         ndim_chgpot = ndim_chgpot_bkup
      endif
!
      if ( .not. psig_required ) goto 1000

      mil = mod( il1, 4 )
      allocate( zfcos( maxval(np_g1k) ) );
      allocate( zfsin( maxval(np_g1k) ) )
      allocate( tmp_wfn( maxval(np_g1k),num_core_states/ndim_spinor_core_states,2  ) )

      psig_core_states = 0.0d0

      Do ik=1, kv3, nspin
         if(map_k(ik) /= myrank_k) cycle
         iksnl = ( ik-1 ) /nspin +1

         f1 = pos(ia,1)*PAI2; f2 = pos(ia,2)*PAI2; f3 = pos(ia,3)*PAI2
         Do ig = 1, np_g1k(ik)
            ii = nbase( ig+ista_g1k(ik)-1, ik )
            ga = real(ngabc(ii,1),kind=DP)
            gb = real(ngabc(ii,2),kind=DP)
            gc = real(ngabc(ii,3),kind=DP)
            ph = ga *f1 +gb*f2 + gc*f3
            zfcos(ig) = dcos(ph);    zfsin(ig) = -dsin(ph)
         End do

         tmp_wfn = 0.0d0

         Do ib=1, num_core_states /ndim_spinor_core_states
            im1 = ib
            Do ig=1, np_g1k(ik)
               if ( kimg == 1 ) then
                  if ( mil == 1 .or. mil ==3 ) then
                     tmp_wfn(ig,ib,1) = zfcos(ig)*psig_core_orb(ig,im1,iksnl)
                     tmp_wfn(ig,ib,2) = zfsin(ig)*psig_core_orb(ig,im1,iksnl)
                  else
                     tmp_wfn(ig,ib,1) =-zfsin(ig)*psig_core_orb(ig,im1,iksnl)
                     tmp_wfn(ig,ib,2) = zfcos(ig)*psig_core_orb(ig,im1,iksnl)
                  endif
               else
                  if ( mil == 1 .or. mil ==3 ) then
                     tmp_wfn(ig,ib,1) = zfcos(ig)*psig_core_orb(ig,im1,iksnl)
                     tmp_wfn(ig,ib,2) = zfsin(ig)*psig_core_orb(ig,im1,iksnl)
                  else
                     tmp_wfn(ig,ib,1) =-zfsin(ig)*psig_core_orb(ig,im1,iksnl)
                     tmp_wfn(ig,ib,2) = zfcos(ig)*psig_core_orb(ig,im1,iksnl)
                  endif
               endif
            End do
         End Do
!
         Do ib=1, num_core_states
            Do jb=1, num_core_states
               im1 = mod( jb-1, 2*qnum_l_to_probe+1 ) +1
               is = int( (jb-1)/(2*qnum_l_to_probe+1) ) +1

               z1 = 0.0d0
               if ( qnum_l_to_probe == 1 ) then
                  z1 = EigenWfns_MatLS_L1(jb,ib)
               else if ( qnum_l_to_probe == 2 ) then
                  z1 = EigenWfns_MatLS_L2(jb,ib)
               else if ( qnum_l_to_probe == 3 ) then
                  z1 = EigenWfns_MatLS_L3(jb,ib)
               else
                  if ( ib == jb ) z1 = 1.0d0
               endif
!!!!!!!!!!               z1 = conjg(z1)

               Do ig=1, np_g1k(ik)
                  z2 = z1 *dcmplx(tmp_wfn(ig,im1,1), tmp_wfn(ig,im1,2) )
                  psig_core_states(ig,ib,ik+is-1,1) &
                       &      = psig_core_states(ig,ib,ik+is-1,1) +real(z2)
                  psig_core_states(ig,ib,ik+is-1,2) &
                       &      = psig_core_states(ig,ib,ik+is-1,2) +aimag(z2)
               End Do
            End Do
         End Do

      End Do

      deallocate( zfcos, zfsin );    deallocate( tmp_wfn )

1000  continue

      Do ik=1, kv3, nspin
         if(map_k(ik) /= myrank_k) cycle

         Do ib=1, num_core_states
            Do jb=1, num_core_states
               im1 = mod( jb-1, 2*qnum_l_to_probe+1 ) +1
               is = int( (jb-1)/(2*qnum_l_to_probe+1) ) +1

               z1 = 0.0d0
               if ( qnum_l_to_probe == 1 ) then
                  z1 = EigenWfns_MatLS_L1(jb,ib)
               else if ( qnum_l_to_probe == 2 ) then
                  z1 = EigenWfns_MatLS_L2(jb,ib)
               else if ( qnum_l_to_probe == 3 ) then
                  z1 = EigenWfns_MatLS_L3(jb,ib)
               else
                  if ( ib == jb ) z1 = 1.0d0
               endif

               fsr_core_states(ib,im1,ik+is-1) &
                    &     = fsr_core_states(ib,im1,ik+is-1) +real(z1)
               fsi_core_states(ib,im1,ik+is-1) &
                    &     = fsi_core_states(ib,im1,ik+is-1) +aimag(z1)
!!!!!!                    &     = fsi_core_states(ib,im1,ik+is-1) -aimag(z1)
            End do
         End Do
      End do

    end subroutine set_core_states_with_phase_A

  end subroutine m_CLS_set_wfn_core_states

  subroutine read_num_core_ae_wfns( nfp, nums, it )
    integer, intent(in) :: nfp, it
    integer, intent(out) :: nums

    integer :: length, ierr
    character(30) :: search_key

    nums = 0

    search_key = "CORE STATES";  length = len(search_key)
    call read_size_of_array_from_pp(nfp, nums, length, search_key, ierr)

    if ( ierr /= 0 ) then
       write(nfout,*) '----------------------'
       write(nfout,'(A,I2)') '!!! Keyword CORE STATES is not found in the PP', it
       write(nfout,*) '----------------------'
    endif

  end subroutine read_num_core_ae_wfns

  subroutine read_data_core_ae_wfns( nfp, num_core_ae_wfns, nmesh, &
       &                             qnum_n, qnum_l, psir_core, ene_level, focc )
    implicit none

    integer, intent(in) :: num_core_ae_wfns
    integer, intent(in) :: nmesh, nfp
    integer, intent(out) :: qnum_l(num_core_ae_wfns)
    integer, intent(out) :: qnum_n(num_core_ae_wfns)
    real(kind=8), intent(out) :: psir_core(nmesh, num_core_ae_wfns), &
         &                       ene_level(num_core_ae_wfns), focc(num_core_ae_wfns)

    integer :: i, n1, l1, k
    real(kind=DP) :: ene1, f1

    Do i=1, num_core_ae_wfns
       read(nfp,*) n1, l1, ene1, f1
       read(nfp,*) (psir_core(k,i),k=1,nmesh)
       !
       qnum_n(i) = n1;  qnum_l(i) = l1;  ene_level(i) = ene1;   focc(i) = f1
    End Do
  end subroutine read_data_core_ae_wfns

  subroutine read_data_core_energy_contrib( nfp, it, ekin_core, eion_core, ehart_core )
    implicit none

    integer, intent(in) :: nfp, it
    real(kind=DP), intent(out) :: ekin_core, eion_core, ehart_core

    integer :: ifound, ier
    character(30) :: search_tag
    character(30) :: line1

    ierr = 0;
    ekin_core = 0.0d0;  eion_core = 0.0d0;  ehart_core = 0.0d0

    search_tag = "CORE ENERGY CONTRIB"

    Do while (.true.)
       read(nfp,'(a30)',end=10) line1
       ifound = index( line1, search_tag )
       if ( ifound /= 0 ) goto 20
    End do

10  ierr = 1;
    write(nfout,*) '----------------------'
    write(nfout,'(A,I2)') '!!! Keyword CORE ENERGY CONTRIB is not found in the PP', it
    write(nfout,*) '----------------------'
    return

20  continue
    read(nfp,*) ekin_core,  line1
    read(nfp,*) eion_core,  line1
    read(nfp,*) ehart_core, line1

  end subroutine read_data_core_energy_contrib

! == KT_add === 2014/08/08
  subroutine read_data_core_level_splitting( nfp, it, num_core_ae_wfns, &
       &                                     qnum_n, qnum_l, level_splitting )
    implicit none

    integer, intent(in) :: nfp, it, num_core_ae_wfns
    integer, intent(in) :: qnum_n(num_core_ae_wfns)
    integer, intent(in) :: qnum_l(num_core_ae_wfns)
    real(kind=DP), intent(out) :: level_splitting(num_core_ae_wfns)

    integer :: ifound, ier
    integer :: count, n1, l1, i, j
    real(kind=DP) :: c1
    character(30) :: search_tag
    character(30) :: line1

    ierr = 0;
    level_splitting = 0.0d0

    search_tag = "SOC-CORE"

    Do while (.true.)
       read(nfp,'(a30)',end=10) line1
       ifound = index( line1, trim(search_tag) )
       if ( ifound /= 0 ) goto 20
    End do

10  ierr = 1;
    write(nfout,*) '----------------------'
    write(nfout,'(A,I2)') '!!! Keyword SOC-CORE is not found in the PP', it
    write(nfout,*) '----------------------'
    return

20  continue

    read(nfp,*) count
    Do i=1, count
       read(nfp,*) n1, l1, c1
       Do j=1, num_core_ae_wfns
          if ( qnum_n(j) == n1 .and. qnum_l(j) == l1 ) then
             level_splitting(j) = c1 *( 2.0d0 *l1 +1.0d0 ) /2.0d0
             exit
          endif
       End Do
    End Do
  end subroutine read_data_core_level_splitting
! ========= 2014/08/08

  subroutine read_num_dipole_dxyz_core2val( nfp, nums, it )
    integer, intent(in) :: nfp, it
    integer, intent(out) :: nums

    integer :: length, ierr
    character(30) :: search_key

    nums = 0

    search_key = "DIPOLE-CORE-TO-VALENCE";  length = len(search_key)

    call read_size_of_array_from_pp(nfp, nums, length, search_key, ierr)
    if ( ierr /= 0 ) then
       write(nfout,*) '----------------------'
       write(nfout,'(A,I2)') '!!! Keyword DIPOLE-CORE-TO-VALENCE not found in PP', it
       write(nfout,*) '----------------------'
    endif

  end subroutine read_num_dipole_dxyz_core2val

! === KT_add === 2014/08/11
  subroutine read_dipole_dxyz_core2val_A( nfp, ndata, dipole_n1, dipole_t2, &
       &                                  phase_ylm1, phase_ylm2, data_dipole, it )
    integer, intent(in) :: nfp, ndata, it
    integer, intent(out) :: dipole_n1(ndata)
    integer, intent(out) :: dipole_t2(ndata)
    integer, intent(out) :: phase_ylm1(ndata), phase_ylm2(ndata)
    real(kind=DP), intent(out) :: data_dipole(:,:)

    integer :: i, j1
    integer :: n1, l1, t1, m1, n2, l2, t2, m2

    do i=1, ndata
       read(nfp,53) n1, l1, t1, m1, n2, l2, t2, m2, &
            &       data_dipole(i,1), data_dipole(i,2), data_dipole(i,3), &
            &       phase_ylm1(i), phase_ylm2(i)

       dipole_n1(i) = n1;   dipole_t2(i) = t2

       Do j1=1, num_orb_index_data(it)
          if ( n2 == qnum_n_orb_index(it,j1) &
               &    .and. l2 == qnum_l_orb_index(it,j1) &
               &    .and. t2 == qnum_t_orb_index(it,j1) ) then
             dipole_t2(i) = qnum_tau_orb_index(it,j1)
             exit
          end if
       End Do
    end do

53  format(1x,8i3,3e18.10,2i3)

  end subroutine read_dipole_dxyz_core2val_A
! ==================== 2014/08/11

  subroutine read_dipole_dxyz_core2val_B( nfp, ndata, dipole_n1, dipole_t2, &
       &                                  phase_ylm1, phase_ylm2, data_dipole )
    integer, intent(in) :: nfp, ndata
    integer, intent(out) :: dipole_n1(ndata)
    integer, intent(out) :: dipole_t2(ndata)
    integer, intent(out) :: phase_ylm1(ndata), phase_ylm2(ndata)
    real(kind=DP), intent(out) :: data_dipole(:,:)

    integer, allocatable :: dipole_n2(:)
    integer, allocatable :: dipole_l1(:), dipole_l2(:)
    integer, allocatable :: dipole_m1(:), dipole_m2(:)
    integer, allocatable :: dipole_t1(:)

    integer, allocatable :: igeta(:,:)

    integer :: lmax, nmax, i, lval, count
    integer :: n2, l2, t2, old_n2, old_t2

    lmax = 3         ! s:0, p:1,  d:2,  f:3
    nmax = 8         ! 8s, 8p, 8d .. etc.

    allocate( dipole_n2(ndata) )
    allocate( dipole_l1(ndata) );  allocate( dipole_l2(ndata) )
    allocate( dipole_m1(ndata) );  allocate( dipole_m2(ndata) )
    allocate( dipole_t1(ndata) )

    allocate( igeta(nmax,0:lmax) );  igeta = -100

    do i=1, ndata
       read(nfp,53) dipole_n1(i), dipole_l1(i), dipole_t1(i), dipole_m1(i), &
            &       dipole_n2(i), dipole_l2(i), dipole_t2(i), dipole_m2(i), &
            &       data_dipole(i,1), data_dipole(i,2), data_dipole(i,3), &
            &       phase_ylm1(i), phase_ylm2(i)
    End do

    Do lval=0, lmax
       count = 0

       Do i=1, ndata
          if ( dipole_l2(i) == lval ) then
             n2 = dipole_n2(i);  t2 = dipole_t2(i)

             if ( count==0 ) then
                count = count +1
                if ( igeta(n2,lval) == -100 ) igeta(n2,lval) = 0
             else
                if ( old_n2 /=n2 .and. igeta(n2,lval)== -100 ) igeta(n2,lval)=old_t2
             endif
             old_n2 = n2;  old_t2 = t2
          endif
       End do
    End do

    Do i=1, ndata
       n2 = dipole_n2(i); l2 = dipole_l2(i);  t2 = dipole_t2(i)

!       dipole_t1(i) = dipole_t1(i) +igeta(n1,l1)
       dipole_t2(i) = dipole_t2(i) +igeta(n2,l2)
    end do

53  format(1x,8i3,3e18.10,2i3)

    deallocate( dipole_n2 )
    deallocate( dipole_l1 );  deallocate( dipole_l2 )
    deallocate( dipole_m1 );  deallocate( dipole_m2 )
    deallocate( dipole_t1 )

    deallocate( igeta )

  end subroutine read_dipole_dxyz_core2val_B

  subroutine m_CLS_find_ptrans_indx_core2val( n1, nspher1, nspher2, tau2, index )
!   find core-repair term with dipole_n1 = n1 (quantum number n of core states),
!                              dipole_tau2 = tau2 (valence orb)
!                              phase_ylm = nspher (combination of (l,m) )

    integer, intent(in)  :: n1, nspher1, nspher2, tau2
    integer, intent(out) :: index

    integer              :: i

    index = 0

    do i=1, num_dipole_dxyz_core2val
       if( dipole_dxyz_core2val_ylm1(i) == nspher1 &
            & .and. dipole_dxyz_core2val_ylm2(i) == nspher2 ) then
          if ( dipole_dxyz_core2val_n1(i) == n1 &
               &  .and. dipole_dxyz_core2val_t2(i) == tau2 ) then
             index = i
             exit
          end if
       end if
    end do

  end subroutine m_CLS_find_ptrans_indx_core2val

  subroutine read_size_of_array_from_pp( nfp, size_of_array, length, search_tag, ierr )
    implicit none

    integer, intent(in) :: nfp, length
    integer, intent(out) :: size_of_array, ierr
    character(length), intent(in) :: search_tag

    integer :: ifound
    character(30) :: line1

    size_of_array = 0;  ierr = 0

    Do while (.true.)
       read(nfp,'(a30)',end=10) line1
       ifound = index( line1, search_tag )
       if ( ifound /= 0 ) goto 20
    End do

10  ierr = 1; return

20  read(nfp,*) size_of_array

  end subroutine read_size_of_array_from_pp

! ----------------------------------------------
!!
!!! The following routine is used only in the postprocess of PHASE
!!!           ( before calculating spectrum )
!!
! ----------------------------------------------
  subroutine m_CLS_calc_core_energy
    use m_Control_Parameters, only : atom_with_corehole, qnum_n_corehole, &
         &                           qnum_l_corehole
    use m_PAW_XC_Potential,   only : m_PAW_XC_allocation, m_PAW_XC_deallocation, &
         &                            m_PAW_XC_cal_potential_sphex2, &
         &                            m_PAW_XC_cal_potential
    use m_PAW_ChargeDensity,    only : calcSphericalHarmonicsExpansion, &
         &                             calcGaussLegendreIntegration
    use m_Const_Parameters, only : VXC_AND_EXC
    use m_PseudoPotential,  only : flg_symmtry

    integer :: it, ia, i, nfp
    real(kind=DP) :: etot_core_sum
    real(kind=DP) :: ekin_core, ehart_core, eion_core, level_splitting_corehole
    real(kind=DP), allocatable :: etot_core(:), level_splitting(:)

     if ( flg_paw .and. eval_core_level_splitting == ByPawPot ) then
        call m_PAW_XC_allocation(nfout)
        if(calcSphericalHarmonicsExpansion) then
           call m_PAW_XC_cal_potential_sphex2(nfout,VXC_AND_EXC)
        end if
        if(calcGaussLegendreIntegration)then
           call m_PAW_XC_cal_potential(nfout,VXC_AND_EXC,flg_symmtry)
        endif
     endif

!    call m_Files_open_ps_files(ivan,iatomn,ntyp,ierr)
!    if (ierr/=0) call mpi_stop(nfout)

    call m_Files_open_core_energy_file

    allocate( etot_core(ntyp) ); etot_core = 0.0d0;
    etot_core_sum = 0.0d0
    level_splitting_corehole = 0.0d0

    if ( mype == 0 ) call print_header

    Do it=1, ntyp
       call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierr)
       if (ierr/=0) call mpi_stop(nfout)
       nfp = nfpot(it)

       if ( mype == 0 ) call read_num_core_ae_wfns( nfp, num_core_ae_wfns, it )
       if ( npes > 1 ) then
          call mpi_bcast(  num_core_ae_wfns, 1, mpi_integer, 0, mpi_comm_world, ierr )
       endif

       if ( num_core_ae_wfns == 0 ) cycle

       allocate( qnum_n_core_ae_wfns( num_core_ae_wfns ) )
       allocate( qnum_l_core_ae_wfns( num_core_ae_wfns ) )
       allocate( psir_core_ae_wfns( nmesh(it),  num_core_ae_wfns ) )
       allocate( enelevel_core_ae_wfns( num_core_ae_wfns ) )
       allocate( focc_core_ae_wfns( num_core_ae_wfns ) )
       allocate( level_splitting( num_core_ae_wfns ) )
       level_splitting = 0.0d0

       if ( mype == 0 ) then
          call read_data_core_ae_wfns( nfp, num_core_ae_wfns, nmesh(it), &
               &                       qnum_n_core_ae_wfns, qnum_l_core_ae_wfns, &
               &                       psir_core_ae_wfns, &
               &                       enelevel_core_ae_wfns, focc_core_ae_wfns )
          call read_data_core_energy_contrib( nfp, it, ekin_core, eion_core, ehart_core )
          etot_core(it) = ekin_core +eion_core +ehart_core
       endif

       if ( npes > 1 ) then
          call mpi_bcast( qnum_n_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_integer, 0, mpi_comm_world, ierr )
          call mpi_bcast( qnum_l_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_integer, 0, mpi_comm_world, ierr )
          call mpi_bcast( enelevel_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
          call mpi_bcast( focc_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
          call mpi_bcast( psir_core_ae_wfns, nmesh(it)*num_core_ae_wfns, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
          call mpi_bcast( etot_core(it), 1, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
       endif

       write(nfout,'(A,I5,F25.15)') " ! ", it, etot_core(it)

! === KT_add ===== 2014/08/08
       if ( eval_core_level_splitting == ReadFromPP ) then
          if ( mype == 0 ) then
             call read_data_core_level_splitting( nfp, it, num_core_ae_wfns, &
                  &                               qnum_n_core_ae_wfns, &
                  &                               qnum_l_core_ae_wfns, &
                  &                               level_splitting )
          endif
          if ( npes > 1 ) then
             call mpi_bcast( level_splitting, num_core_ae_wfns, &
                  &          mpi_double_precision, 0, mpi_comm_world, ierr )
          endif
       endif
! =============== 2014/08/08

       Do ia=1, natm
          if ( ityp(ia) /= it ) cycle

          etot_core_sum = etot_core_sum +etot_core(it)

          if ( flg_paw .and. eval_core_level_splitting == ByPawPot ) then
             call m_SO_calc_corelevel_splitting( ia, it, &
                  &                              num_core_ae_wfns, &
                  &                              qnum_l_core_ae_wfns, &
                  &                              nmesh(it), psir_core_ae_wfns, &
                  &                              level_splitting )
          endif

          if ( ia == atom_with_corehole ) then
             Do i=1, num_core_ae_wfns
                if ( qnum_n_core_ae_wfns(i) == qnum_n_corehole &
                     &  .and. qnum_l_core_ae_wfns(i) == qnum_l_corehole ) then
                   if ( focc_core_ae_wfns(i) > 2*qnum_l_corehole ) then
                      level_splitting_corehole = level_splitting(i)
                   endif
                endif
             End Do
          endif

          if ( mype == 0 ) call print_body
       End do

       deallocate( qnum_n_core_ae_wfns ); deallocate( qnum_l_core_ae_wfns )
       deallocate( psir_core_ae_wfns );   deallocate( enelevel_core_ae_wfns )
       deallocate( focc_core_ae_wfns )
       deallocate( level_splitting )
       call m_Files_close_ps_file(it)
    End Do

!    call m_Files_close_ps_files
    deallocate( etot_core )

    if ( mype == 0 ) then
       call print_tail
       call add_soc_corehole
    endif

    call m_Files_close_core_energy_file


    if ( flg_paw .and. eval_core_level_splitting == ByPawPot ) then
       call m_PAW_XC_deallocation(nfout)
    endif

  contains

    subroutine print_header
      write(nfout,*) '**********************************************'
      write(nfout,*) "! ** Total Energy of Core electrons for atom types "
      write(nfout,*) "!    it        energy "

      write(nfcore_energy_out,'(A)') "# Spin Orbit splitting of core orbitals"
      write(nfcore_energy_out,'(A)') " it    ia     n     l            value"

    end subroutine print_header

    subroutine print_body
      integer :: i

      Do i=1, num_core_ae_wfns
         if ( qnum_l_core_ae_wfns(i) == 0 ) cycle
         write(nfcore_energy_out,'(I3,I6,I6,I6,F25.15)') &
              &   it, ia, qnum_n_core_ae_wfns(i), qnum_l_core_ae_wfns(i), &
              &           level_splitting(i)
      End Do
    end subroutine print_body

    subroutine print_tail
      write(nfout,*) '!'
      write(nfout,*) '!  Etotal (Core+Valence) = ', etot_core_sum +etotal
      write(nfout,*) '**********************************************'

      write(nfcore_energy_out,'(I3,I6,I6,I6,F25.15)') 0, 0, 0, 0, 0.0d0
      write(nfcore_energy_out,*)
      write(nfcore_energy_out,'(A)') "# Etotal (Core+Valence)"
      write(nfcore_energy_out,*) etot_core_sum +etotal

    end subroutine print_tail

    subroutine add_soc_corehole
      real(kind=DP) :: c1, c2, e1, e2

      if ( level_splitting_corehole <= 0.0 ) return

      c1 = etot_core_sum +etotal
      c2 = level_splitting_corehole /( 2*qnum_l_corehole +1 )
      e1 = c2 *qnum_l_corehole
      e2 = c2 *( qnum_l_corehole +1 )

      write(nfcore_energy_out,*)
      write(nfcore_energy_out,'(A)') "# Etotal (Core+Valence+Soc_corehole)"
      write(nfcore_energy_out,'(A,I1,A,10X,F20.10)') &
           &            "# J = ", 2*qnum_l_corehole +1, "/2:", c1 -e1
      write(nfcore_energy_out,'(A,I1,A,10X,F20.10)') &
           &            "# J = ", 2*qnum_l_corehole -1, "/2:", c1 +e2
    end subroutine add_soc_corehole

  end subroutine m_CLS_calc_core_energy

end module m_CoreLevel_Spectrum

!簡約計算をまとめて行うためのモジュール
!Copyright (C) 2014-2015 Ryosuke Tomita

#define READSTOP(func, fileno) \
if(.not.func(fileno)) stop 'error while '//"func"

module m_classification
  use m_commons, only: stdout
  use m_tspace_defines, only: character_table
  use m_tspace_commons, only: print_kpoint_and_kgroup
  use m_container_commons, only: psicoef_t, transd_vector_index, k_state
  use m_container_psicoef, only: read_energy, read_gvector, read_psicoef, get_psicoef, readstate_psicoef, new_psicoef, set_gvector_to_braveis, delete_psicoef, allocate_psicoef, print_psicoef
  use m_transd_vector, only: get_transd_vector_index, new_transd_vector, delete_transd_vector, print_transd_vector
  use m_degeneracy, only: new_degeneracy, set_degeneracy, delete_degeneracy, print_degeneracy
  use m_reduce_band, only: delete_reduce_band, new_reduce_band, print_reduce_band

  type(character_table), target, private:: cht
  type(k_state), target, private:: kst
  type(psicoef_t), target, private:: pst
  type(transd_vector_index), target, private:: tvi
  logical, private:: is_gv_read = .false.
  
contains
!入力されたk点と指標から、電子状態を既約表現に簡約する
  subroutine calcAll(kstt, chtt, fileno)
    integer, intent(in):: fileno!データの出力装置番号
    type(k_state), intent(in):: kstt!k点の情報
    type(character_table), intent(in):: chtt!指標表
    integer:: is, ib
    
    kst = kstt
!指標表の情報を変数に格納
    cht = chtt
!波動関数の準備（空間情報の入力)
    call new_psicoef(kst%kpoint%isdouble)
!エネルギー準位の読み込み
    READSTOP(read_energy, fileno)
!G点の読み込み
    if(.not.is_gv_read) then
       READSTOP(read_gvector, fileno)
       call set_gvector_to_braveis(kst%trp2b)
       is_gv_read = .true.
    end if
!波動関数の準備（変数のアロケートなど）
    call allocate_psicoef
!波動関数の読み込み
    READSTOP(read_psicoef, fileno)
    if(kst%kpoint%isdouble) then
!スピン分極した系のとき、DOWNスピンの状態を読み込む
       READSTOP(readstate_psicoef, fileno)
       READSTOP(read_energy, fileno)
       READSTOP(read_psicoef, fileno)
    end if
    pst = get_psicoef()
! エネルギーの縮退組分け
    call new_degeneracy(pst%num_energy, pst%nspin, pst%e_tag,cht%maxdim > 1)
    call set_degeneracy(pst)
!k点群をもとに、kとGの変換を行う
    call new_transd_vector(kst, pst%gv)
    tvi = get_transd_vector_index()
#ifdef DEBUG
!データのデバッグ
    write(stdout, *) '!Degeneracy'
    call print_degeneracy(stdout)
    write(stdout, *) '!Psicoef'
    call print_psicoef(stdout)
    write(stdout, *) '!transvector'
    call print_transd_vector(stdout)
#endif
!可約表現の計算
    call new_reduce_band(cht, kst, pst, tvi)
  end subroutine calcAll

!データの出力
  subroutine printAll(kstt, is, fno)
    type(k_state), intent(in):: kstt!k点の情報
    integer, intent(in):: fno, is!出力装置番号とスピンインデックス
    write(fno, fmt = '(A)', advance = 'no') '!'
    call print_kpoint_and_kgroup(fno, kstt%kpoint, kstt%kgroup)
!簡約係数の出力
    call print_reduce_band(fno, is)
  end subroutine printAll

!アロケートしたデータのリセット
  subroutine deleteAll
    call delete_reduce_band
    call delete_degeneracy
    call delete_psicoef
    call delete_transd_vector
  end subroutine deleteAll
end module m_classification

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  MODULE: m_Wannier
!
!  AUTHOR(S): T. Yamamoto   May/05/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Wannier
!! Maximally localized Wannier functions
!! Ref.
!! [1] N. Marzari and D. Vanderbilt, Phys. Rev. B 56 (1997) 12847.
!! [2] G. Berghold, et.al., Phys. Rev. B 61 (2000) 10040.
  use m_Const_Parameters,   only : DP,PAI2,SD,CG,CGPRC,BINARY,CUBE,VTK,DENSITY_ONLY &
       &                         , SKIP,EXECUT,GAMMA,ON
  use m_Control_Parameters, only : printable, kimg, neg, eps_wan, dt_wan &
       &                         , wannier_opt_method, max_iter_wan &
       &                         , wannier_filetype, ipri, sw_random_wannier &
       &                         , sw_potential_wannier, sw_continue_wannier
  use m_Crystal_Structure,  only : altv, rltv, univol
  use m_FFT,                only : nfft, fft_box_size_WF &
       &                         , m_FFT_alloc_WF_work &
       &                         , m_FFT_dealloc_WF_work
  use m_Timing,             only : tstatc0_begin, tstatc0_end
  use m_Ionic_System,       only : ntyp,natm,natm2,ityp,iatomn,m_IS_pack_all_ions_in_uc &
       &                         , iwei,pos
  use m_PseudoPotential,    only : ival,modnrm,dk_wan,qitg_wan &
       &                         , m_PP_include_vanderbilt_pot &
       &                         , n_non0_lmtxlmt,index_lmt1_lmt2,lmta,nlmt,ilmt &
       &                         , ltp,taup,il2p,isph,iqitg,dl2p &
       &                         , m_PP_find_maximum_l
  use m_Files,              only : m_Files_open_nfwannier,nfwannier &
       &                         , m_Files_open_nfcntn_wannier &
       &                         , m_Files_open_nfpot_wannier &
       &                         , nfcntn_wannier,nfpot_wannier
  use m_Kpoints,            only : k_symmetry
  implicit none
  
  integer, public                     :: nwght
  real(kind=DP), private, allocatable :: wght(:) ! d(nwght)
  integer, public, allocatable        :: ghat(:,:) ! d(3,nwght) 

  integer, private                       :: nocc
  complex(kind=DP), private, allocatable :: zmat(:,:,:) ! d(nocc,nocc,nwght)
  complex(kind=DP), private, allocatable :: zn(:,:) ! d(nocc,nwght)

  real(kind=DP), private, allocatable :: umat(:,:) ! d(nocc,nocc)
  complex(kind=DP), private, allocatable :: bmat(:,:) ! d(nocc,nocc)
  real(kind=DP), private, allocatable :: mmat(:,:) ! d(nocc,nocc)

  integer, private                    :: ntri ! (nocc-1)*nocc/2
  real(kind=DP), private, allocatable :: amat(:) ! d(ntri)
  real(kind=DP), private, allocatable :: grad(:) ! d(ntri)
  real(kind=DP), private :: omega
  real(kind=DP), private :: gradmax

  complex(kind=DP), private, allocatable :: rmat(:,:) ! d(nocc,nocc)
  real(kind=DP), private, allocatable    :: lam(:) ! d(nocc)

  integer, private                    :: iteration

  complex(kind=DP), private, allocatable :: ftqe(:,:,:,:)!d(nlmt,nlmt,natm,nwght)

contains
  subroutine m_Wan_gen_weight(nfout)
    integer, intent(in) :: nfout
    integer :: i
    real(kind=DP) :: g(3,3),w
    real(kind=DP), parameter :: eps = 1.d-10

    nwght = 6
    allocate(wght(nwght),ghat(3,nwght))

    g = matmul(transpose(altv),altv)

    nwght = 0
    ! g^=(1,0,0)
    w = g(1,1)-g(1,2)-g(1,3)
    nwght = nwght + 1
    wght(nwght) = w
    ghat(1:3,nwght) = (/1,0,0/)
    ! g^=(0,1,0)
    w = g(2,2)-g(1,2)-g(2,3)
    nwght = nwght + 1
    wght(nwght) = w
    ghat(1:3,nwght) = (/0,1,0/)
    ! g^=(0,0,1)
    w = g(3,3)-g(1,3)-g(2,3)
    nwght = nwght + 1
    wght(nwght) = w
    ghat(1:3,nwght) = (/0,0,1/)
    ! g^=(1,1,0)
    w = g(1,2)
    if(abs(w) > eps) then
       nwght = nwght + 1
       wght(nwght) = w
       ghat(1:3,nwght) = (/1,1,0/)
    end if
    ! g^=(1,0,1)
    w = g(1,3)
    if(abs(w) > eps) then
       nwght = nwght + 1
       wght(nwght) = w
       ghat(1:3,nwght) = (/1,0,1/)
    end if
    ! g^=(1,1,0)
    w = g(2,3)
    if(abs(w) > eps) then
       nwght = nwght + 1
       wght(nwght) = w
       ghat(1:3,nwght) = (/0,1,1/)
    end if

    if(printable) then
       write(nfout,*) '!Wannier: nwght=',nwght
       do i=1,nwght
          write(nfout,'(" !Wannier: i=",i1," wght=",f18.5," g^=",3i2)') &
          & i,wght(i),ghat(1:3,i)
       end do
    end if

  end subroutine m_Wan_gen_weight


end module m_Wannier

!#define _DEBUG_WRITE_DFTU_MPI_PROCESSES_
!=======================================================================
!
!  SOFTWARE NAME : PHASE (ver. 7.01)
!
!  MODULE: m_Orbital_Population
!
!  AUTHOR(S): T. Yamamoto   May/04/2005
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!   patch 0.1 by K. Tagami @adv    2009/01/19
!   patch 0.2 by K. Tagami @adv    2009/01/19
!   patch 0.2a by K. Tagami @adv    2009/02/11
!   patch 0.2b by K. Tagami @adv    2009/02/15
!
! ==========================
!   patch 0.1 :  correction in m_OP_occ_mat_ylm
!   patch 0.2 :  introduction of m_OP_occ_mat_ao_kt
!                ( because the implementation of "m_ES_orbital_den_mat"
!                  in Electronic_Structure.F90 is unclear )
!   patch 0.2a : output zero values in the case of af=1
!                  in subroutine  wd_occ_mat
!   patch 0.2b : bug fix in patch level 0.2a ( if af/=0 statement )
! =========================================================
!
!
module m_Orbital_Population
! $Id: m_Orbital_Population.F90 618 2020-05-12 08:44:53Z ktagami $
  use m_Const_Parameters,     only : DP,ON,ANEW,RENEW,SIMPLE,BROYD1,BROYD2,DFP,PULAY,OFF,UNIT_MATRIX
  use m_Files,                only : nfout, nfoccmat, m_Files_open_nfoccmat
  use m_IterationNumbers,     only : iteration_for_cmix
  use m_Control_Parameters,   only : nspin,af,ipri,printable,num_projectors &
     &                             , proj_attribute &
     &                             , proj_group, num_proj_elems, max_projs &
     &                             , iprihubbard &
     &                             , hownew,nbxmix,istrbr,ipripulay, sw_force_simple_mixing_hub &
     &                             , sw_metric_diff, alpha_pulay, sw_recomposing &
     &                             , sw_mix_bothspins_sametime, sw_force_simple_mixing
  use m_Ionic_System,         only : natm,ntyp,ityp,iproj_group,zeta1
  use m_PseudoPotential,      only : prodphi,ilmt,ltp,mtp,taup,nlmt,ntau,nlmtt
  use m_Crystal_Structure,    only : op,nopr
  use m_Ionic_System,         only : napt
  use m_Charge_Density,       only : hsr
  use m_Electronic_Structure, only : m_ES_sym_comp, m_ES_orbital_den_mat
  use m_ES_nonlocal         , only : m_ES_phir_dot_WFs
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Parallelization,      only : mype, npes, ierr, MPI_CommGroup

! ================================== added by K. Tagami ====x======= 5.0
  use m_Const_Parameters,    only :  YES, NO
  use m_Control_Parameters,  only :  sw_force_simple_mixing_occdiff, &
      &                              sw_recomposing_occmat,initial_occmat, &
      &                              initial_occmat_factor
  use m_IterationNumbers,   only : iteration_electronic, iteration
  use m_Control_Parameters,  only : spin_density_mixfactor
  use m_Control_Parameters,  only : sw_mix_bothspins_sametime_hsr
! ================================================================== 5.0

! =========================== added by K. Tagami =========== 11.0
  use m_Control_Parameters,  only :  noncol, ndim_magmom, sw_mix_charge_hardpart, &
       &                             occmat_diag_mode, ndim_spinor, ndim_chgpot, &
       &                             occmat_file_format
  use m_Electronic_Structure, only : m_ES_orbital_den_mat_noncl
  use m_PseudoPotential,      only : flg_paw
  use m_ES_NonCollinear,     only : m_ES_MagMom_To_DensMat_porb
  use m_Const_Parameters,    only :  CMPLDP
  use m_Charge_Density,       only : hsi
! ========================================================== 11.0

  use m_Crystal_Structure,  only : altv
  use m_Ionic_System,     only : ihubbard, ionic_charge_atomtyp, cps, iatomn, &
       &                         mag_moment0_atoms_is_defined, ionic_charge_atoms, &
       &                         mag_moment0_atomtyp, mag_moment0_atoms, &
       &                         sw_set_initial_magmom_by_atom
  use m_PseudoPotential,  only : radr_paw, nmesh, mmesh, nloc, psirpw
  use m_Const_Parameters,  only : PAI4, SP
  use m_CD_Mag_Moment,  only : rad_cov
  use mpi

  implicit none

  integer, public, allocatable :: i2lp(:) ! d(num_projectors)

! ================================ modified by K. Tagami ================ 11.0
!  integer, private :: max2lp ! max. of i2lp
  integer, public :: max2lp ! max. of i2lp
! ======================================================================= 11.0

  integer, private :: l1max ! max. of l1
  real(kind=DP), public, allocatable, target :: om(:,:,:,:,:) ! d(max2lp,max2lp,max_projs,natm,nspin)
  real(kind=DP), public, allocatable, target :: ommix(:,:,:,:,:) ! d(max2lp,max2lp,max_projs,natm,nspin)
  real(kind=DP), public, allocatable :: omold(:,:,:,:,:) ! d(max2lp,max2lp,max_projs,natm,nspin)
                                                   ! occupation maxtrix, n(m,m)
  integer, private :: nyymax
  logical, private :: occmat_is_read = .false.
  integer, public, allocatable :: nyy(:) ! d(num_projectors)
  integer, public, allocatable :: ilmt_yy(:,:,:) ! d(2,nyymax,num_projectors)
  integer, private, allocatable :: nryy(:,:,:,:) ! d(2,nyymax,num_projectors,nopr+af)
  integer, private, allocatable :: iryy1(:,:,:,:) ! d(max2lp,nyymax,num_projectos,nopr+af)
  integer, private, allocatable :: iryy2(:,:,:,:) ! d(max2lp,nyymax,num_projectors,nopr+af)
  real(kind=DP), private, allocatable :: cryy(:,:,:,:,:) ! d(max2lp,max2lp,nyymax,num_projectors,nopr+af)

! ================================ added by K. Tagami ================ 11.0
  real(kind=DP), public, allocatable, target :: om_aimag(:,:,:,:,:)
  real(kind=DP), public, allocatable, target :: ommix_aimag(:,:,:,:,:)
  real(kind=DP), public, allocatable :: omold_aimag(:,:,:,:,:)
! ===================================================================== 11.0

  integer :: nsize_rho
  integer, private, allocatable :: imapom(:) ! d(nsize_rho)
  real(kind=DP),private,allocatable, dimension(:,:) ::       rho,rhoo ! d(nsize_rho,nspin)
  !         rho => ommix, rhoo => omold

  ! -- For Broyden and DFP mixing method --
  integer, private,parameter                :: iU = 1, iVD = 1, iW = 2, iY = 2, iV = 2
  integer, private                          :: nspin_m
  real(DP),private,allocatable,dimension(:,:) :: d0,u,v,w,dout,dd
  real(DP),private,pointer,dimension(:,:)         :: FF
  real(DP),private,allocatable,target,dimension(:,:) :: din
  !                                             d(nsize_rho,nspin_m)
  real(DP),private,allocatable,dimension(:,:)     :: dF
  !     dF_l(deltaF):= \Delta \cal F^{m} = \cal F^{m} - \cal F^{m-1}
  !              = F[\rho^{m}] - F[\rho^{m-1}] - (\rho^{m} - \rho^{m-1})
  real(DP),private,allocatable,target,dimension(:,:,:,:) :: urec
  real(DP),private,allocatable,dimension(:,:,:)     :: f      !d(nbxmix,nbxmix,nspin)
  real(DP),private,allocatable,dimension(:)         :: g      !d(nbxmix)
  !    f and g are used only when hownew == RENEW
  integer, private,allocatable,dimension(:)         :: ncrspd !d(nbxmix)
  real(DP),private,allocatable,dimension(:,:,:)     :: uuf    !d(nbxmix,nspin,2),
                                                   !only for DFP method
  real(DP),private,allocatable,dimension(:,:)       :: uuf_p
  real(DP),private,allocatable,dimension(:,:)       :: g_p

  integer, private :: previous_waymix = 0

  logical, save :: first = .true.

! ========================================================================= 5.8
  real(kind=DP),private, allocatable, dimension(:):: rmxtrck ! d(nspin_m)
  real(kind=DP), allocatable :: om_store(:,:,:,:,:)
  real(kind=DP), allocatable :: omold_store(:,:,:,:,:)
!
  real(kind=DP), allocatable :: rho_store(:,:)
  real(kind=DP), allocatable :: rhoo_store(:,:)
! ======================================================================== 5.8

! ================================= added by K. Tagami ================ 11.0
  integer :: nsize_rho_realpart
  integer, private :: sw_mix_imaginary_component = ON
! ===================================================================== 11.0

  real(DP),private,allocatable,target,dimension(:,:,:,:) :: urec_l
  real(DP),private,allocatable,dimension(:,:) :: d0_l,u_l,v_l
  real(kind=DP), allocatable, dimension(:,:) :: ynorm
  real(DP),private,allocatable,dimension(:) :: f_p !d(ista_kgpm:iend_kgpm)

!  include 'mpif.h'

contains

  logical function m_OP_occ_mat_is_not_read()
    m_OP_occ_mat_is_not_read = .false.
    if(.not.occmat_is_read) m_OP_occ_mat_is_not_read = .true.
  end function m_OP_occ_mat_is_not_read

  subroutine m_OP_set_i2lp_max2lp
    integer :: it,ip
    integer, parameter :: ntau0=2

! =========================== added by K. Tagami ====================== 11.0
    integer :: nsize
! ===================================================================== 11.0

    do ip=1,num_projectors
       i2lp(ip) = 2*proj_attribute(ip)%l+1
    end do
    max2lp = 0
    do ip=1,num_projectors
       if(i2lp(ip) > max2lp) then
          max2lp = i2lp(ip)
          l1max  = proj_attribute(ip)%l+1
       end if
    end do

! =========================== modified by K. Tagami ====================== 11.0
!!
!!    nyymax = ntau0*l1max**2*(l1max**2+1)/2
!
    nsize = ntau0*( 2*( l1max -1 )+1 )
    nyymax = nsize *( nsize +1 ) /2

! ======================================================================== 11.0

    !!$write(nfout,*) '== m_OP_set_i2lp_max2lp =='
    !!$write(nfout,*) 'ntau=',ntau
    !!$write(nfout,*) 'ntau0=',ntau0
    !!$write(nfout,*) 'i2lp=',i2lp
    !!$write(nfout,*) 'max2lp=',max2lp
    !!$write(nfout,*) 'l1max=',l1max
    !!$write(nfout,*) 'nyymax=',nyymax
  end subroutine m_OP_set_i2lp_max2lp

  subroutine m_OP_store_om()
    omold = om
  end subroutine m_OP_store_om

  subroutine m_OP_om_diff()
    integer :: is,ia,ja,it,ilmt1,ilmt2
    integer :: l1,l2,m1,m2,t1,t2,m1r,m2r
    integer :: iyy,iopr,mm1,mm2
    integer :: ig,ip,i

    integer :: ilp
    real(kind=DP) :: diff,sumdiff
    integer :: icount
    sumdiff = 0.d0
    icount=0
    do is=1,nspin,af+1

       do ia=1,natm
          ig = iproj_group(ia)
          if(ig<1) cycle

          do i=1,num_proj_elems(ig)
             ip=proj_group(i,ig)
             it = proj_attribute(ip)%ityp
             ilp = proj_attribute(ip)%l+1

             do ilmt1 = 1, ilmt(it)
                l1 = ltp(ilmt1,it); m1 = mtp(ilmt1,it)
                t1 = taup(ilmt1,it)
                if ( l1 /= ilp ) cycle

                do ilmt2 = 1, ilmt(it)
                   l2 = ltp(ilmt2,it); m2 = mtp(ilmt2,it)
                   t2 = taup(ilmt2,it)
                   if( l2 /= ilp ) cycle

                   diff = abs(omold(m1,m2,i,ia,is)-om(m1,m2,i,ia,is))
                   sumdiff = sumdiff+diff
                   icount = icount+1
                end do
             end do
! =============================================================
          end do
          !!if(printable) write(nfout,'(a,i5,a,f20.12)') 'omdiff for atom ',ia,' : ',sumdiff/dble(icount)
          sumdiff = 0.d0
          icount = 0
       end do
    end do
  end subroutine m_OP_om_diff

  subroutine m_OP_alloc
    if(.not.allocated(i2lp)) allocate(i2lp(num_projectors))
    call m_OP_set_i2lp_max2lp

! =========================== modified by K. Tagami ====================== 11.0
!    allocate(om(max2lp,max2lp,max_projs,natm,nspin)); om=0.d0
!    allocate(ommix(max2lp,max2lp,max_projs,natm,nspin)); ommix=0.d0
!    allocate(omold(max2lp,max2lp,max_projs,natm,nspin)); omold=0.d0

    if(.not.allocated(om)) then
       allocate(om(max2lp,max2lp,max_projs,natm,ndim_magmom)); om=0.d0
    endif
    if(.not.allocated(ommix))then
       allocate(ommix(max2lp,max2lp,max_projs,natm,ndim_magmom)); ommix=0.d0
    endif
    if(.not.allocated(omold)) then
       allocate(omold(max2lp,max2lp,max_projs,natm,ndim_magmom)); omold=0.d0
    endif
! ========================================================================= 11.0

! ========================= added by K. Tagami =================== 11.0
    if ( noncol ) then
       if(.not.allocated(om_aimag))then
          allocate( om_aimag(max2lp,max2lp,max_projs,natm,ndim_magmom) )
          om_aimag = 0.d0
       endif
       if(.not.allocated(ommix_aimag))then
          allocate( ommix_aimag(max2lp,max2lp,max_projs,natm,ndim_magmom) )
          ommix_aimag = 0.d0
       endif
       if(.not.allocated(omold_aimag))then
          allocate( omold_aimag(max2lp,max2lp,max_projs,natm,ndim_magmom) )
          omold_aimag = 0.d0
       endif
       !om_aimag = 0.d0; ommix_aimag = 0.0d0; omold_aimag = 0.0d0
    endif
! ================================================================ 11.0

    if(.not.allocated(nyy)) allocate(nyy(num_projectors))
    if(.not.allocated(ilmt_yy)) then
       allocate(ilmt_yy(2,nyymax,num_projectors)); ilmt_yy=100
    endif
    !!$write(nfout,*) 'nyymax',nyymax
    !!$write(nfout,*) 'num_projectors',num_projectors
    !!$write(nfout,*) 'allocate(ilmt_yy):',ilmt_yy
  end subroutine m_OP_alloc

  subroutine m_OP_dealloc
    deallocate(i2lp)
    deallocate(om)
    deallocate(ommix)
    deallocate(omold)
    deallocate(nyy)
    deallocate(ilmt_yy)
! ============================ addd by K. Tagami =========== 11.0
    if ( noncol ) then
       deallocate( om_aimag )
       deallocate( ommix_aimag )
       deallocate( omold_aimag )
    endif
! ========================================================== 11.0

! ======= KT_add ======= 13.0AS
    deallocate( nryy )
    deallocate( iryy1, iryy2 )
    deallocate( cryy )
! ====================== 13.0AS

  end subroutine m_OP_dealloc

  subroutine m_OP_ilmt_yy
    integer :: it,iyy,ilmt1,ilmt2,l1,l2,ip,ilp

    !!$write(nfout,*) 'ntyp=',ntyp
    !!$write(nfout,*) 'allocated(nyy)',allocated(nyy)
    !!$write(nfout,*) 'allocated(ilmt_yy)',allocated(ilmt_yy)
    !!$write(nfout,*) 'allocate(ilmt_yy):',ilmt_yy
    do ip=1,num_projectors
       it=proj_attribute(ip)%ityp
       ilp=proj_attribute(ip)%l+1
       if ( it==0 ) cycle
!!$write(nfout,*) 'ip,it,ilp=',ip,it,ilp
       iyy=0
       do ilmt2=1,ilmt(it)
          do ilmt1=1,ilmt2
             !!$write(nfout,*) 'ilmt1,ilmt2=',ilmt1,ilmt2
             l1=ltp(ilmt1,it)
             l2=ltp(ilmt2,it)
             !!$write(nfout,*) 'l1,l2=',l1,l2
             if(l1==ilp .and. l2 == l1) then
                iyy=iyy+1
                !!$write(nfout,*) 'iyy=',iyy
                ilmt_yy(1,iyy,ip) = ilmt1
                !!$write(nfout,*) 'ilmt_yy(1,iyy,it)=',ilmt1
                ilmt_yy(2,iyy,ip) = ilmt2
                !!$write(nfout,*) 'ilmt_yy(2,iyy,it)=',ilmt2
             end if
          end do
       end do
       nyy(ip)=iyy
    end do
  end subroutine m_OP_ilmt_yy

  subroutine m_OP_crotylm(nfout)
    integer, intent(in) :: nfout

    integer :: mmax,nsph
    integer :: lmt,ia,ja,it,mm,isph,isph1,isph2,m1,m2,mm1,mm2,l1
    integer :: iopr,ilmt1,ilmt2
    integer :: iyy,nylm1,nylm2,m1r,m2r
    integer :: ip
    real(kind=DP), allocatable :: crotylm(:,:,:)
    integer, allocatable :: iylm(:,:,:)
    integer, allocatable :: nylm(:,:)
    real(kind=DP) :: opr(3,3)

! debug
!    write(nfout,*) '=== In m_OP_crotylm ==='
! end debug

    mmax  = 2*l1max-1
    nsph = l1max**2
    allocate(crotylm(mmax,nsph,nopr+af))
    allocate(iylm(mmax,nsph,nopr+af))
    allocate(nylm(nsph,nopr+af))

    call get_crotylm(l1max,mmax,nsph,nopr+af,crotylm,iylm,nylm,op)

!debug
!!$    if(printable) then
!!$       do iopr=1,nopr+af
!!$          do isph=1,nsph
!!$             write(nfout,'(2(1x,i3))') iopr,isph
!!$             do mm=1,nylm(isph,iopr)
!!$                write(nfout,'(i3,"=>",f20.8)') iylm(mm,isph,iopr),crotylm(mm,isph,iopr)
!!$             end do
!!$          end do
!!$       end do
!!$    end if
!end debug

    if(.not.allocated(nryy)) allocate(nryy(2,nyymax,num_projectors,nopr+af))
    if(.not.allocated(iryy1)) allocate(iryy1(max2lp,nyymax,num_projectors,nopr+af))
    iryy1=-100
    if(.not.allocated(iryy2)) allocate(iryy2(max2lp,nyymax,num_projectors,nopr+af))
    iryy2=-200
    if(.not.allocated(cryy)) allocate(cryy(max2lp,max2lp,nyymax,num_projectors,nopr+af))
    cryy=-100.d0

    do ip=1,num_projectors
       it = proj_attribute(ip)%ityp
       l1 = proj_attribute(ip)%l+1
       if ( it == 0 ) cycle

       do iyy=1,nyy(ip)
          ilmt1 = ilmt_yy(1,iyy,ip);   ilmt2 = ilmt_yy(2,iyy,ip)
          m1 = mtp(ilmt1,it);          m2 = mtp(ilmt2,it)
          isph1 = get_isph(m1,l1);     isph2 = get_isph(m2,l1)

          do iopr=1,nopr+af
             nylm1 = nylm(isph1,iopr);       nylm2 = nylm(isph2,iopr)
             nryy(1,iyy,ip,iopr) = nylm1;    nryy(2,iyy,ip,iopr) = nylm2
             do mm1=1,nylm1
                iryy1(mm1,iyy,ip,iopr) = get_m(iylm(mm1,isph1,iopr),l1)
             end do
             do mm2=1,nylm2
                iryy2(mm2,iyy,ip,iopr) = get_m(iylm(mm2,isph2,iopr),l1)
             end do
             do mm2=1,nylm2
                do mm1=1,nylm1
                   cryy(mm1,mm2,iyy,ip,iopr) = crotylm(mm1,isph1,iopr) &
                        &                     *crotylm(mm2,isph2,iopr)
               !!!write(6,'("mm1,mm2,iyy,ip,iopr,cryy=",5i3,f10.5)') mm1,mm2,iyy,ip,iopr,cryy(mm1,mm2,iyy,ip,iopr)
                end do
             end do
          end do
       end do
    end do

    deallocate(crotylm);    deallocate(iylm);    deallocate(nylm)

! debug
!!$    if(printable) then
!!$       write(nfout,'("== Summary ==")')
!!$       do iopr=1,nopr+af
!!$          write(nfout,*) 'iopr=',iopr
!!$          do ip=1,num_projectors
!!$             it=proj_attribute(ip)%ityp
!!$             write(nfout,*) 'ip,it,l=',ip,it,proj_attribute(ip)%l
!!$             do iyy=1,nyy(ip)
!!$                ilmt1 = ilmt_yy(1,iyy,ip)
!!$                ilmt2 = ilmt_yy(2,iyy,ip)
!!$                m1 = mtp(ilmt1,it)
!!$                m2 = mtp(ilmt2,it)
!!$                do mm2=1,nryy(2,iyy,ip,iopr)
!!$                   do mm1=1,nryy(1,iyy,ip,iopr)
!!$                      m1r=iryy1(mm1,iyy,ip,iopr)
!!$                      m2r=iryy2(mm2,iyy,ip,iopr)
!!$                      write(nfout,'(3i3,"=>",2i3,f20.8,":",2i3)') &
!!$                  & iyy,m1,m2,m1r,m2r,cryy(mm1,mm2,iyy,ip,iopr),mm1,mm2
!!$                   end do
!!$                end do
!!$             end do
!!$          end do
!!$       end do
!!$    end if
! end debug

    !! Projector rotations
    mmax  = 2*l1max-1;    nsph = l1max**2
    allocate(crotylm(mmax,nsph,1))
    allocate(iylm(mmax,nsph,1));    allocate(nylm(nsph,1))

    do ip=1,num_projectors
       if(.not.proj_attribute(ip)%frotate) cycle
       call get_opr(proj_attribute(ip)%phi,proj_attribute(ip)%theta,proj_attribute(ip)%psi,opr)
       !debug
       !!$write(nfout,*) 'Rot mat: ip=',ip
       !!$do m1=1,3
       !!$   write(nfout,'(3f10.5)') (opr(m1,m2),m2=1,3)
       !!$end do
       !end debug
       call get_crotylm(l1max,mmax,nsph,1,crotylm,iylm,nylm,opr)
       l1 = proj_attribute(ip)%l+1
       allocate(proj_attribute(ip)%crotylm(2*l1-1,2*l1-1))
       proj_attribute(ip)%crotylm = 0.d0

       do m1=1,2*l1-1
          isph1 = get_isph(m1,l1)
          do mm2=1,nylm(isph1,1)
             isph2 = iylm(mm2,isph1,1)
             m2 = get_m(isph2,l1)
             proj_attribute(ip)%crotylm(m2,m1) = crotylm(mm2,isph1,1)
          end do
       end do
       !debug
       !!$write(nfout,*) 'CrotYlm: ip=',ip,' l=',l1-1
       !!$do m1=1,2*l1-1
       !!$   write(nfout,'(7f10.5)') (proj_attribute(ip)%crotylm(m1,m2),m2=1,2*l1-1)
       !!$end do
       !end debug
    end do
    deallocate(crotylm);    deallocate(iylm);    deallocate(nylm)

  contains

    integer function get_m(isph,l1)
      integer, intent(in) :: isph, l1
      get_m = isph - (l1-1)**2
    end function get_m

    integer function get_isph(m,l1)
      integer, intent(in) :: m, l1
      get_isph = (l1-1)**2 + m
    end function get_isph

    subroutine get_opr(phi,theta,psi,opr)
      real(kind=DP), intent(in) :: phi,theta,psi
      real(kind=DP), intent(out) :: opr(3,3)
      real(kind=DP) :: cphi,sphi,ctheta,stheta,cpsi,spsi
      cphi = cos(phi);         sphi = sin(phi)
      ctheta = cos(theta);     stheta = sin(theta)
      cpsi = cos(psi);         spsi = sin(psi)
      opr(1,1) = cphi*cpsi-sphi*ctheta*sphi
      opr(1,2) = -cphi*spsi-sphi*ctheta*cpsi
      opr(1,3) = sphi*stheta
      opr(2,1) = sphi*cpsi+cphi*ctheta*spsi
      opr(2,2) = -sphi*spsi+cphi*ctheta*cpsi
      opr(2,3) = -cphi*stheta
      opr(3,1) = stheta*spsi
      opr(3,2) = stheta*cpsi
      opr(3,3) = ctheta
    end subroutine get_opr

  end subroutine m_OP_crotylm

  subroutine m_OP_occ_mat_ylm(nfout,pmode)
    integer, intent(in) :: nfout
    integer, intent(in) :: pmode

    integer :: is,ia,ja,it,ilmt1,ilmt2
    integer :: l1,l2,m1,m2,t1,t2,m1r,m2r
    integer :: iyy,iopr,mm1,mm2
    integer :: ig,ip,i

    integer :: ilp
#ifdef _DEBUG_WRITE_DFTU_MPI_PROCESSES_
    real(kind=DP) :: om2_sum, hsr2_sum
    om2_sum = 0.d0
#endif    

#ifdef __TIMER_SUB__
    call timer_sta(737)
#endif
    !!$write(nfout,*) 'Constracting Occupation matrix...'
!!$    write(nfout,'(" --- << m_OP_occ_mat_ylm >> ---")')
    om = 0.d0
#ifdef __TIMER_DO__
  call timer_sta(861)
#endif
    do is=1,nspin,af+1

       do ia=1,natm
          ig = iproj_group(ia)
          if(ig<1) cycle

          do i=1,num_proj_elems(ig)
             ip=proj_group(i,ig)
             it = proj_attribute(ip)%ityp
             ilp = proj_attribute(ip)%l+1

             !!$write(nfout,*) 'ia,it,ip=',ia,it,ip
             !!$write(nfout,*) 'nyy=',nyy(ip)
! ============================== Modified by K. Tagami ============== 0.1
!             do iyy=1,nyy(ip)
!                !!$write(nfout,*) 'iyy=',iyy
!                ilmt1=ilmt_yy(1,iyy,ip)
!                l1=ltp(ilmt1,it)
!                m1=mtp(ilmt1,it)
!                t1=taup(ilmt1,it)
!
!                ilmt2=ilmt_yy(2,iyy,ip)
!                l2=ltp(ilmt2,it)
!                m2=mtp(ilmt2,it)
!                t2=taup(ilmt2,it)

                !!$write(nfout,*) 'om,hsr,prodphi=' &
                !!$& , om(m1,m2,i,ia,is), hsr(ia,ilmt1,ilmt2,is), prodphi(ip,t1,t2)

!                write(*,*) 'FFF I = ',i
!                if ( l1 /= l2 ) then
!                   write(*,*) 'FFFFFFFFFFFFFF AAAAAAAAA'
!                   stop
!                endif
!                om(m1,m2,i,ia,is)=om(m1,m2,i,ia,is) &
!                & + hsr(ia,ilmt1,ilmt2,is)*prodphi(ip,t1,t2)
! =
!             end do
!             do m2=1,i2lp(ip)
!                do m1=m2+1,i2lp(ip)
!                   !!$write(nfout,*) 'm1,m2=',m1,m2
!                   om(m1,m2,i,ia,is)=om(m2,m1,i,ia,is)
!                end do
!             end do
! ======= === ======== ============ =========== ============= ======== ===
             do ilmt1 = 1, ilmt(it)
                l1 = ltp(ilmt1,it); m1 = mtp(ilmt1,it)
                t1 = taup(ilmt1,it)
                if ( l1 /= ilp ) cycle

                do ilmt2 = 1, ilmt(it)
                   l2 = ltp(ilmt2,it); m2 = mtp(ilmt2,it)
                   t2 = taup(ilmt2,it)
                   if( l2 /= ilp ) cycle

                   if ( ilmt1 < ilmt2 ) then
                      om(m1,m2,i,ia,is)=om(m1,m2,i,ia,is) &
                           & + hsr(ia,ilmt1,ilmt2,is)*prodphi(ip,t1,t2)
                   else
                      om(m1,m2,i,ia,is)=om(m1,m2,i,ia,is) &
                           & + hsr(ia,ilmt2,ilmt1,is)*prodphi(ip,t1,t2)
                   endif
                end do
             end do
! =============================================================
          end do
       end do
    end do
#ifdef __TIMER_DO__
  call timer_end(861)
#endif
    if(nspin==1) om=0.5d0*om
    if(iprihubbard > 2) then
       write(nfout,*) '=== <Unsymmetrized occ. mat.> ==='
       call wd_occ_mat(om)
    end if

#ifdef _DEBUG_WRITE_DFTU_MPI_PROCESSES_
    om2_sum = 0.d0
    hsr2_sum = 0.d0
    do is = 1, nspin
       do ia = 1, natm
          ig = iproj_group(ia)
          if(ig<1) cycle
          do i = 1, num_proj_elems(ig)
             do m2 = 1, max2lp
                do m1 = 1, max2lp
                   om2_sum = om2_sum + om(m1,m2,i,ia,is)*om(m1,m2,i,ia,is)
                end do
             end do
          end do
       end do
       do ia = 1, natm
          it = ityp(ia)
          do ilmt1 = 1, ilmt(it)
             do ilmt2 = 1, ilmt(it)
                hsr2_sum = hsr2_sum + hsr(ia,ilmt2,ilmt1,is)*hsr(ia,ilmt2,ilmt1,is)
             end do
          end do
       end do
    end do
    write(nfout,'(" om2_sum = ",f20.10, " hsr2_sum = ",f20.10, " <<m_OP_occ_mat_ylm>>")') om2_sum, hsr2_sum
#endif
    if ( sw_mix_charge_hardpart == OFF ) call symmetrize_occ_mat(om)
!    call symmetrize_occ_mat(om)
    if( pmode==1 .and. iprihubbard > 1) then
       write(nfout,*) '=== <Symmetrized occ. mat.> ==='
       call wd_occ_mat(om)

       call diag_occ_mat
    end if
#ifdef __TIMER_SUB__
    call timer_end(737)
#endif

  end subroutine m_OP_occ_mat_ylm


! ========================= added by K. Tagami ============= 11.0
  subroutine m_OP_occ_mat_ylm_noncl( nfout, pmode )
    integer, intent(in) :: nfout
    integer, intent(in) :: pmode

    integer :: is,ia,ja,it,ilmt1,ilmt2
    integer :: l1,l2,m1,m2,t1,t2,m1r,m2r
    integer :: iyy,iopr,mm1,mm2
    integer :: ig,ip,i

    integer :: ilp

#ifdef __TIMER_SUB__
    call timer_sta(737)
#endif
    om = 0.d0; om_aimag = 0.0d0
#ifdef __TIMER_DO__
  call timer_sta(861)
#endif

    do is=1, ndim_magmom

       do ia=1,natm
          ig = iproj_group(ia)
          if(ig<1) cycle

          do i=1,num_proj_elems(ig)
             ip=proj_group(i,ig)
             it = proj_attribute(ip)%ityp
             ilp = proj_attribute(ip)%l+1

             do ilmt1 = 1, ilmt(it)
                l1 = ltp(ilmt1,it); m1 = mtp(ilmt1,it)
                t1 = taup(ilmt1,it)
                if ( l1 /= ilp ) cycle

                do ilmt2 = 1, ilmt(it)
                   l2 = ltp(ilmt2,it); m2 = mtp(ilmt2,it)
                   t2 = taup(ilmt2,it)
                   if( l2 /= ilp ) cycle

                   om(m1,m2,i,ia,is)=om(m1,m2,i,ia,is) &
                        & + hsr(ia,ilmt1,ilmt2,is)*prodphi(ip,t1,t2)
                   om_aimag(m1,m2,i,ia,is) = om_aimag(m1,m2,i,ia,is) &
                        & + hsi(ia,ilmt1,ilmt2,is)*prodphi(ip,t1,t2)
                end do
             end do

          end do
       end do
    end do
#ifdef __TIMER_DO__
    call timer_end(861)
#endif

!    if(iprihubbard >= 2) then
!       write(nfout,*) '=== <Unsymmetrized occ. mat.> ==='
!       call wd_occ_mat(om)
!    end if

    if ( flg_paw .or. sw_mix_charge_hardpart == ON ) then

    else
       if(iprihubbard > 2) then
          write(nfout,*) '=== <Unsymmetrized occ. mat.> ==='
          call wd_occ_mat_noncl(om,om_aimag)
       end if
       call symmetrize_occ_mat_noncl_B(om,om_aimag)
    endif

    if ( pmode==1 .and. iprihubbard > 1) then
       write(nfout,*) '=== <Symmetrized occ. mat.> ==='
       call wd_occ_mat_noncl(om,om_aimag)

!       if ( occmat_diag_mode == 1 ) then
!          call diag_occ_mat
!       else
          call diag_occ_mat_noncl
!       endif
    end if

#ifdef __TIMER_SUB__
    call timer_end(737)
#endif

  end subroutine m_OP_occ_mat_ylm_noncl
! ================================================================ 11.0

  subroutine m_OP_occ_mat_ao(nfout,pmode)
    integer :: nfout
    integer, intent(in) :: pmode

    call m_ES_phir_dot_WFs(nfout)
    call m_ES_sym_comp(nfout)

! =============== modified by K. Tagami ===================== 11.0
!    call m_ES_orbital_den_mat(nfout,om,max2lp,max_projs)
!
    if ( noncol ) then
       call m_ES_orbital_den_mat_noncl(nfout,om,max2lp,max_projs)
    else
       call m_ES_orbital_den_mat(nfout,om,max2lp,max_projs)
    endif
!!$    write(nfout,'(" *** calling m_ES_orbital_den_mat from m_OP_Occ_mat_ao ***")')
! =========================================================== 11.0

    !!if(printable) then
    !!   write(nfout,*) '=== <Unsymmetrized occ. mat.> ==='
    !!   call wd_occ_mat(om)
    !!end if

    !!call symmetrize_occ_mat(om)
    if ( pmode==1 .and. iprihubbard > 1) then
       write(nfout,*) '=== <Symmetrized occ. mat.> ==='
       call wd_occ_mat(om)

       call diag_occ_mat
    end if


  end subroutine m_OP_occ_mat_ao

! ==================================== Added by K. Tagami =============== 0.2
  subroutine m_OP_occ_mat_ao_kt(nfout, pmode )
    integer, intent(in) :: nfout
    integer, intent(in) :: pmode

    integer :: is,ia,ja,it,ilmt1,ilmt2
    integer :: l1,l2,m1,m2,t1,t2,m1r,m2r
    integer :: iyy,iopr,mm1,mm2
    integer :: ig,ip,i

    integer :: ilp, t0
#ifdef __TIMER_SUB__
    call timer_sta(738)
#endif
!!$    write(nfout,'(" *** << m_OP_occ_mat_ao_kt >> ***")')
    !!$write(nfout,*) 'Constracting Occupation matrix...'
    om = 0.d0
#ifdef __TIMER_DO__
  call timer_sta(862)
#endif
    do is=1,nspin,af+1

       do ia=1,natm
          ig = iproj_group(ia)
          if(ig<1) cycle

          do i=1,num_proj_elems(ig)
             ip=proj_group(i,ig)
             it = proj_attribute(ip)%ityp
             ilp = proj_attribute(ip)%l+1

             t0 = proj_attribute(ip)%t
!
             do ilmt1 = 1, ilmt(it)
                l1 = ltp(ilmt1,it); m1 = mtp(ilmt1,it)
                t1 = taup(ilmt1,it)
                if ( l1 /= ilp ) cycle

                do ilmt2 = 1, ilmt(it)
                   l2 = ltp(ilmt2,it); m2 = mtp(ilmt2,it)
                   t2 = taup(ilmt2,it)
                   if( l2 /= ilp ) cycle

                   if ( ilmt1 < ilmt2 ) then
                      om(m1,m2,i,ia,is)=om(m1,m2,i,ia,is) &
                           & + hsr(ia,ilmt1,ilmt2,is) &
                           &   *prodphi(ip,t1,t0)*prodphi(ip,t0,t2)
                   else
                      om(m1,m2,i,ia,is)=om(m1,m2,i,ia,is) &
                           & + hsr(ia,ilmt2,ilmt1,is) &
                           &   *prodphi(ip,t1,t0)*prodphi(ip,t0,t2)
                   endif
                end do
             end do
!
          end do
       end do
    end do
#ifdef __TIMER_DO__
  call timer_end(862)
#endif
    if(nspin==1) om=0.5d0*om
    if(iprihubbard > 2) then
       write(nfout,*) '=== <Unsymmetrized occ. mat.> ==='
       call wd_occ_mat(om)
    end if

    call symmetrize_occ_mat(om)
    if ( pmode==1 .and. iprihubbard > 1 ) then
       write(nfout,*) '=== <Symmetrized occ. mat.> ==='
       call wd_occ_mat(om)

       call diag_occ_mat
    end if
#ifdef __TIMER_SUB__
    call timer_end(738)
#endif

  end subroutine m_OP_occ_mat_ao_kt
! =============================================================================


! ======================== added by K. Tagami ================== 11.0
  subroutine m_OP_occ_mat_ao_kt_noncl(nfout, pmode )
    integer, intent(in) :: nfout
    integer, intent(in) :: pmode

    integer :: is,ia,ja,it,ilmt1,ilmt2
    integer :: l1,l2,m1,m2,t1,t2,m1r,m2r
    integer :: iyy,iopr,mm1,mm2
    integer :: ig,ip,i

    integer :: ilp, t0
#ifdef __TIMER_SUB__
    call timer_sta(738)
#endif
    !!$write(nfout,*) 'Constracting Occupation matrix...'
    om = 0.d0; om_aimag = 0.0d0
#ifdef __TIMER_DO__
  call timer_sta(862)
#endif

    do is=1, ndim_magmom, af+1

       do ia=1,natm
          ig = iproj_group(ia)
          if(ig<1) cycle

          do i=1,num_proj_elems(ig)
             ip=proj_group(i,ig)
             it = proj_attribute(ip)%ityp
             ilp = proj_attribute(ip)%l+1

             t0 = proj_attribute(ip)%t
!
             do ilmt1 = 1, ilmt(it)
                l1 = ltp(ilmt1,it); m1 = mtp(ilmt1,it)
                t1 = taup(ilmt1,it)
                if ( l1 /= ilp ) cycle

                do ilmt2 = 1, ilmt(it)
                   l2 = ltp(ilmt2,it); m2 = mtp(ilmt2,it)
                   t2 = taup(ilmt2,it)
                   if( l2 /= ilp ) cycle

                   om(m1,m2,i,ia,is) = om(m1,m2,i,ia,is) &
                        & + hsr(ia,ilmt1,ilmt2,is) &
                        &   *prodphi(ip,t1,t0)*prodphi(ip,t0,t2)
                   om_aimag(m1,m2,i,ia,is) = om_aimag(m1,m2,i,ia,is) &
                        & + hsi(ia,ilmt1,ilmt2,is) &
                        &   *prodphi(ip,t1,t0)*prodphi(ip,t0,t2)
                end do
             end do
!
          end do
       end do
    end do
#ifdef __TIMER_DO__
    call timer_end(862)
#endif

!    if(iprihubbard >= 2) then
!       write(nfout,*) '=== <Unsymmetrized occ. mat.> ==='
!       call wd_occ_mat(om)
!    end if

    if ( flg_paw .or. sw_mix_charge_hardpart == ON ) then

    else
       if(iprihubbard > 2) then
          write(nfout,*) '=== <Unsymmetrized occ. mat.> ==='
          call wd_occ_mat_noncl(om,om_aimag)
       end if
       call symmetrize_occ_mat_noncl_B(om,om_aimag)
    endif

    if ( pmode==1 .and. iprihubbard > 1 ) then
       write(nfout,*) '=== <Symmetrized occ. mat.> ==='
       call wd_occ_mat_noncl(om,om_aimag)

!       if ( occmat_diag_mode == 1 ) then
!          call diag_occ_mat
!       else
          call diag_occ_mat_noncl
!       endif
    end if

#ifdef __TIMER_SUB__
    call timer_end(738)
#endif

  end subroutine m_OP_occ_mat_ao_kt_noncl
! ============================================================= 11.0


  subroutine symmetrize_occ_mat(om)
! ===================================== modified by K. Tagami ============== 11.0
!    real(kind=DP), intent(inout) :: om(max2lp,max2lp,max_projs,natm,nspin)
    real(kind=DP), intent(inout) :: om(max2lp,max2lp,max_projs,natm,ndim_magmom)
! ========================================================================== 11.0

    integer :: is,ia,ja,it,ilmt1,ilmt2
    integer :: l1,l2,m1,m2,t1,t2,m1r,m2r
    integer :: iyy,iopr,mm1,mm2
    integer :: ig,ip,i
    real(kind=DP), allocatable :: om_nosym(:,:,:,:,:)

! ======================= modified by K. Tagami ========================= 11.0
!    allocate(om_nosym(max2lp,max2lp,max_projs,natm,nspin))

    allocate(om_nosym(max2lp,max2lp,max_projs,natm,ndim_magmom ))
! ======================================================================= 11.0

    om_nosym=om
    om = 0.d0

! ======================= modified by K. Tagami ========================= 11.0
!    do is=1,nspin,af+1
    do is=1, ndim_magmom, af+1
! ====================================================================== 11.0

       do ia=1,natm
          ig = iproj_group(ia)
          if(ig<1) cycle
          do i=1,num_proj_elems(ig)
             ip=proj_group(i,ig)
             it = proj_attribute(ip)%ityp
             !!$write(nfout,*) 'ia,it,ip=',ia,it,ip
             do iyy=1,nyy(ip)
                ilmt1 = ilmt_yy(1,iyy,ip)
                ilmt2 = ilmt_yy(2,iyy,ip)
                m1 = mtp(ilmt1,it)
                t1=taup(ilmt1,it)
                m2 = mtp(ilmt2,it)
                t2=taup(ilmt2,it)
                if(t1/=1.or.t2/=1) cycle
                do iopr=1,nopr
                   ja=napt(ia,iopr)
                   do mm2=1,nryy(2,iyy,ip,iopr)
                      do mm1=1,nryy(1,iyy,ip,iopr)
                         m1r=iryy1(mm1,iyy,ip,iopr)
                         m2r=iryy2(mm2,iyy,ip,iopr)
                  !!!print *,'mm1,mm2,iyy,ip,iopr,cryy=',mm1,mm2,iyy,ip,iopr,cryy(mm1,mm2,iyy,ip,iopr)
                         om(m1r,m2r,i,ja,is) =  om(m1r,m2r,i,ja,is) + &
                   & om_nosym(m1,m2,i,ia,is)*cryy(mm1,mm2,iyy,ip,iopr)
                         if(m1 /= m2) &
                   & om(m2r,m1r,i,ja,is) =  om(m2r,m1r,i,ja,is) + &
                   & om_nosym(m2,m1,i,ia,is)*cryy(mm1,mm2,iyy,ip,iopr)
                      end do
                   end do
                end do
             end do
          end do
       end do
    end do
    om = om/dble(nopr)
    deallocate(om_nosym)

    if(af /= 0) then
       do ia=1,natm
          ig = iproj_group(ia)
          if(ig<1) cycle
          do i=1,num_proj_elems(ig)
             ip=proj_group(i,ig)
             it = proj_attribute(ip)%ityp
             do iyy=1,nyy(ip)
                ilmt1 = ilmt_yy(1,iyy,ip)
                ilmt2 = ilmt_yy(2,iyy,ip)
                m1 = mtp(ilmt1,it)
                t1=taup(ilmt1,it)
                m2 = mtp(ilmt2,it)
                t2=taup(ilmt2,it)
                if(t1/=1.or.t2/=1) cycle
                iopr=nopr+af
                ja=napt(ia,iopr)
                do mm2=1,nryy(2,iyy,ip,iopr)
                   do mm1=1,nryy(1,iyy,ip,iopr)
                      m1r=iryy1(mm1,iyy,ip,iopr)
                      m2r=iryy2(mm2,iyy,ip,iopr)
               !!print *,'mm1,mm2,iyy,ip,iopr,cryy=',mm1,mm2,iyy,ip,iopr,cryy(mm1,mm2,iyy,ip,iopr)
                      om(m1r,m2r,i,ja,2) =  om(m1r,m2r,i,ja,2) + &
                  & om(m1,m2,i,ia,1)*cryy(mm1,mm2,iyy,ip,iopr)
                      if(m1 /= m2) &
                  & om(m2r,m1r,i,ja,2) = om(m2r,m1r,i,ja,2) + &
                  & om(m2,m1,i,ia,1)*cryy(mm1,mm2,iyy,ip,iopr)
                   end do
                end do
             end do
          end do
       end do
    end if

  end subroutine symmetrize_occ_mat


! ======================================= added by K. Tagami =============== 11.0
  subroutine symmetrize_occ_mat_noncl_A(om)
    real(kind=DP), intent(inout) :: om(max2lp,max2lp,max_projs,natm,ndim_magmom)

    integer :: is,ia,ja,it,ilmt1,ilmt2
    integer :: l1,l2,m1,m2,t1,t2,m1r,m2r
    integer :: iyy,iopr,mm1,mm2
    integer :: ig,ip,i
    real(kind=DP), allocatable :: om_nosym(:,:,:,:,:)

    allocate(om_nosym(max2lp,max2lp,max_projs,natm,ndim_magmom ))

    om_nosym=om
    om = 0.d0

    do is=1, ndim_magmom

       do ia=1,natm
          ig = iproj_group(ia)
          if(ig<1) cycle

          do i=1,num_proj_elems(ig)
             ip=proj_group(i,ig)
             it = proj_attribute(ip)%ityp
             !!$write(nfout,*) 'ia,it,ip=',ia,it,ip

             do iyy=1,nyy(ip)
                ilmt1 = ilmt_yy(1,iyy,ip)
                ilmt2 = ilmt_yy(2,iyy,ip)

                m1 = mtp(ilmt1,it);    t1=taup(ilmt1,it)
                m2 = mtp(ilmt2,it);    t2=taup(ilmt2,it)

                if (t1/=1.or.t2/=1) cycle

                do iopr=1,nopr
                   ja = napt(ia,iopr)

                   do mm2 = 1,nryy(2,iyy,ip,iopr)
                      do mm1 = 1,nryy(1,iyy,ip,iopr)
                         m1r = iryy1(mm1,iyy,ip,iopr)
                         m2r = iryy2(mm2,iyy,ip,iopr)

                         om(m1r,m2r,i,ja,is) =  om(m1r,m2r,i,ja,is) &
                              &               + om_nosym(m1,m2,i,ia,is) &
                              &                *cryy(mm1,mm2,iyy,ip,iopr)
                         if ( m1 /= m2 ) then
                            om(m2r,m1r,i,ja,is) = om(m2r,m1r,i,ja,is) &
                                 &              + om_nosym(m2,m1,i,ia,is) &
                                 &               *cryy(mm1,mm2,iyy,ip,iopr)
                         endif

                      end do
                   end do
                end do
             end do
          end do
       end do
    end do

    om = om/dble(nopr)
    deallocate(om_nosym)

  end subroutine symmetrize_occ_mat_noncl_A

  subroutine symmetrize_occ_mat_noncl_B(om, om_aimag)
    real(kind=DP), intent(inout) :: om(max2lp,max2lp,max_projs,natm,ndim_magmom)
    real(kind=DP), intent(inout) :: om_aimag(max2lp,max2lp,max_projs,natm,ndim_magmom)

    integer :: is,ia,ja,it,ilmt1,ilmt2
    integer :: l1,l2,m1,m2,t1,t2,m1r,m2r
    integer :: iyy,iopr,mm1,mm2
    integer :: ig,ip,i

    integer :: ixyz1, ixyz2
    real(kind=DP) :: ctmp1

    real(kind=DP), allocatable :: om_nosym(:,:,:,:,:)
    real(kind=DP), allocatable :: om_nosym_aimag(:,:,:,:,:)

    allocate( om_nosym(max2lp,max2lp,max_projs,natm,ndim_magmom ))
    allocate( om_nosym_aimag(max2lp,max2lp,max_projs,natm,ndim_magmom ))

    om_nosym = om;    om_nosym_aimag = om_aimag
    om = 0.d0;   om_aimag = 0.0d0

    do ia=1,natm
       ig = iproj_group(ia)
       if(ig<1) cycle

       do i=1,num_proj_elems(ig)
          ip=proj_group(i,ig)
          it = proj_attribute(ip)%ityp
             !!$write(nfout,*) 'ia,it,ip=',ia,it,ip

          do iyy=1,nyy(ip)
             ilmt1 = ilmt_yy(1,iyy,ip)
             ilmt2 = ilmt_yy(2,iyy,ip)
             m1 = mtp(ilmt1,it);    t1=taup(ilmt1,it)
             m2 = mtp(ilmt2,it);    t2=taup(ilmt2,it)

             if (t1/=1.or.t2/=1) cycle

             do iopr=1,nopr
                ja = napt(ia,iopr)

                do mm2 = 1,nryy(2,iyy,ip,iopr)
                   do mm1 = 1,nryy(1,iyy,ip,iopr)
                      m1r = iryy1(mm1,iyy,ip,iopr)
                      m2r = iryy2(mm2,iyy,ip,iopr)

                      om(m1r,m2r,i,ja,1) = om(m1r,m2r,i,ja,1) &
                           &              +om_nosym(m1,m2,i,ia,1) &
                           &               *cryy(mm1,mm2,iyy,ip,iopr)
                      om_aimag(m1r,m2r,i,ja,1) = om_aimag(m1r,m2r,i,ja,1) &
                           &              +om_nosym_aimag(m1,m2,i,ia,1) &
                           &               *cryy(mm1,mm2,iyy,ip,iopr)

                      if ( m1 /= m2 ) then
                         om(m2r,m1r,i,ja,1) = om(m2r,m1r,i,ja,1) &
                              &              +om_nosym(m2,m1,i,ia,1) &
                              &               *cryy(mm1,mm2,iyy,ip,iopr)
                         om_aimag(m2r,m1r,i,ja,1) = om_aimag(m2r,m1r,i,ja,1) &
                              &              +om_nosym_aimag(m2,m1,i,ia,1) &
                              &               *cryy(mm1,mm2,iyy,ip,iopr)
                      endif

                      Do ixyz1=1, 3
                         Do ixyz2=1, 3
                            ctmp1 = op(ixyz2, ixyz1, iopr)

                            om(m1r,m2r,i,ja,ixyz2+1) = om(m1r,m2r,i,ja,ixyz2+1) &
                                 &                    + ctmp1 &
                                 &                     *om_nosym(m1,m2,i,ia,ixyz1+1) &
                                 &                     *cryy(mm1,mm2,iyy,ip,iopr)
                            om_aimag(m1r,m2r,i,ja,ixyz2+1) &
                                 &            = om_aimag(m1r,m2r,i,ja,ixyz2+1) &
                                 &              + ctmp1 &
                                 &               *om_nosym_aimag(m1,m2,i,ia,ixyz1+1) &
                                 &               *cryy(mm1,mm2,iyy,ip,iopr)
                            if ( m1 /= m2 ) then
                               om(m2r,m1r,i,ja,ixyz2+1) = om(m2r,m1r,i,ja,ixyz2+1) &
                                    &                    + ctmp1 &
                                    &                     *om_nosym(m2,m1,i,ia,ixyz1+1) &
                                    &                     *cryy(mm1,mm2,iyy,ip,iopr)
                               om_aimag(m2r,m1r,i,ja,ixyz2+1) &
                                    &          = om_aimag(m2r,m1r,i,ja,ixyz2+1) &
                                    &           + ctmp1 &
                                    &             *om_nosym_aimag(m2,m1,i,ia,ixyz1+1) &
                                    &             *cryy(mm1,mm2,iyy,ip,iopr)
                            endif
                         End do
                      End do
                   end do
                end do
             end do
          end do
       end do
    end do

    om = om/dble(nopr)
    om_aimag = om_aimag /dble(nopr)

    deallocate(om_nosym)
    deallocate(om_nosym_aimag)

  end subroutine symmetrize_occ_mat_noncl_B
! ====================================================================== 11.0

  subroutine wd_occ_mat(om)
! =================================== modified by K. Tagami ============= 11.0
!    real(kind=DP), intent(in) :: om(max2lp,max2lp,max_projs,natm,nspin)
    real(kind=DP), intent(in) :: om(max2lp,max2lp,max_projs,natm,ndim_magmom)
! ======================================================================= 11.0

    integer :: l,is,ia,ig,i,ip,it,m1,m2

! ========================= Modified by K. Tagami ============= 11.0
!    do is=1,nspin, af+1
    do is=1, ndim_magmom, af+1
! ============================================================= 11.0

       do ia=1,natm
          ig = iproj_group(ia)
          if(ig<1) cycle
          do i=1,num_proj_elems(ig)
             ip=proj_group(i,ig)
             it = proj_attribute(ip)%ityp
             l = proj_attribute(ip)%l
             write(nfout,'("Occupation Matrix: is,ia,l=",3i5)') is,ia,l
             do m1=1,i2lp(ip)
                write(nfout,'(14f8.3)')(om(m1,m2,i,ia,is),m2=1,i2lp(ip))
             end do
          end do
       end do
    end do
! ========================== Added by K. Tagami ============= 0.2 ==
!    if ( af /=0 ) then
! ============================== Added by K. Tagami =======  0.2b
!      is = 2
! ====================================================
!       do ia=1,natm
!          ig = iproj_group(ia)
!          if(ig<1) cycle
!          do i=1,num_proj_elems(ig)
!             ip=proj_group(i,ig)
!             it = proj_attribute(ip)%ityp
!             l = proj_attribute(ip)%l
!             if(iprihubbard>1) then
!             write(nfout,'("Occupation Matrix: is,ia,l=",3i5)') is,ia,l
!             do m1=1,i2lp(ip)
!                write(nfout,'(14f8.3)')( 0.0d0, m2=1,i2lp(ip))
!             end do
!             endif
!          end do
!       end do
!    endif
! =====================================================================

  end subroutine wd_occ_mat

! ================================== added by K. Tagami ================== 11.0
  subroutine wd_occ_mat_noncl(om, om_aimag)
    real(kind=DP), intent(in) :: om(max2lp,max2lp,max_projs,natm,ndim_magmom)
    real(kind=DP), intent(in) :: om_aimag(max2lp,max2lp,max_projs,natm,ndim_magmom)

    integer :: l,is,ia,ig,i,ip,it,m1,m2

    do is=1, ndim_magmom

       do ia=1,natm
          ig = iproj_group(ia)
          if(ig<1) cycle
          do i=1,num_proj_elems(ig)
             ip=proj_group(i,ig)
             it = proj_attribute(ip)%ityp
             l = proj_attribute(ip)%l
             write(nfout,'("Occupation Matrix: is,ia,l=",3i5)') is,ia,l

             write(nfout,*) ' (Re)'
             do m1=1,i2lp(ip)
                write(nfout,'(14f9.4)')(om(m1,m2,i,ia,is),m2=1,i2lp(ip))
             end do

             write(nfout,*) ' (Im)'
             do m1=1,i2lp(ip)
                write(nfout,'(14f9.4)')(om_aimag(m1,m2,i,ia,is),m2=1,i2lp(ip))
             end do
          end do
       end do
    end do

  end subroutine wd_occ_mat_noncl
! ========================================================================= 11.0

  subroutine m_OP_occ_mat_init(nfout)
    integer, intent(in) :: nfout
    integer :: num_om, i, iproj, ia, is, ip, m1, m2, ig, it, l
    logical :: tf
    real(kind=DP) :: nn,zeta

    call m_Files_open_nfoccmat
    om = 0.d0
! ============================= added by K. Tagami ============== 11.0
    if ( noncol ) om_aimag = 0.0d0
! =============================================================== 11.0
    do is=1, ndim_magmom
       do ia=1,natm
          ig = iproj_group(ia)
          if(ig<1) cycle
          zeta = zeta1(ityp(ia))
          nn   = (1.d0+zeta)
          if(is.eq.2) nn=(1.d0-zeta)
          if(initial_occmat==UNIT_MATRIX) nn=1.d0
          if(initial_occmat==OFF)         nn=0.d0
          nn = nn*initial_occmat_factor
          do i=1,num_proj_elems(ig)
             ip=proj_group(i,ig)
             it = proj_attribute(ip)%ityp
             l = proj_attribute(ip)%l
             do m1=1,i2lp(ip)
                om(m1,m1,i,ia,is) = nn
             end do
          end do
       end do
    end do
  end subroutine m_OP_occ_mat_init

  subroutine m_OP_rd_occ_mat(nfout)
    integer, intent(in) :: nfout
    integer :: num_om, i, iproj, ia, is, ip, m1, m2, ig
    logical :: tf

    call m_Files_open_nfoccmat

    tf = .false.
    if(mype == 0) then
       write(nfout,*) '! Reading occ. mat.'
       rewind nfoccmat
       read(nfoccmat,*,err=101,end=101) num_om
       if(num_om < 1 ) goto 101
       tf = .true.

       do i=1,num_om
          read(nfoccmat,*,err=101,end=101) is,ia,iproj
          ig = iproj_group(ia)
          ip=proj_group(iproj,ig)
          do m1=1,i2lp(ip)
             read(nfoccmat,*,err=101,end=101)(om(m1,m2,iproj,ia,is),m2=1,i2lp(ip))
          end do
       end do

       occmat_is_read = .true.
    end if
101 if(npes > 1) then
       call mpi_bcast(tf,1,mpi_logical,0,MPI_CommGroup,ierr)

! ========================== modified by K. Tagami ====================== 11.0
!       if (tf) call mpi_bcast(om,max2lp*max2lp*max_projs*natm*nspin,mpi_double_precision,0,MPI_CommGroup,ierr)
       if (tf) then
          call mpi_bcast( om, max2lp *max2lp *max_projs *natm *ndim_magmom, &
               &          mpi_double_precision, 0, MPI_CommGroup, ierr )
       endif
       call mpi_bcast(occmat_is_read,1,mpi_logical,0,MPI_CommGroup,ierr)
    end if
! ======================================================================== 11.0

    if(.not.tf) then
       if(mype==0) write(nfout,*) '! no file of occ. mat.; init. om = 0'
       om = 0.d0
    end if

    return

!!$100 continue
!!$    call mpi_bcast(tf,1,mpi_logical,0,MPI_CommGroup,ierr)
!!$    if(mype==0) write(nfout,*) '! no file of occ. mat.; init. om = 0'
!!$    om = 0.d0
!!$    return

  end subroutine m_OP_rd_occ_mat

! ======================================= added by K. Tagami ============= 11.0
  subroutine m_OP_rd_occ_mat_noncl(nfout)
    integer, intent(in) :: nfout
    integer :: num_om, i, iproj, ia, is, ip, m1, m2, ig
    logical :: tf

    om = 0.0d0; om_aimag = 0.0d0

    call m_Files_open_nfoccmat

    tf = .false.
    if (mype == 0) then
       write(nfout,*) '! Reading occ. mat.'
       rewind nfoccmat
       read(nfoccmat,*,err=101,end=101) num_om

       if(num_om < 1 ) goto 101
       tf = .true.

       do i=1,num_om
          read(nfoccmat,*,err=101,end=101) is,ia,iproj
          ig = iproj_group(ia)
          ip=proj_group(iproj,ig)
          do m1=1,i2lp(ip)
             read(nfoccmat,*,err=101,end=101)(om(m1,m2,iproj,ia,is),m2=1,i2lp(ip))
          end do

          if ( occmat_file_format == 1 ) cycle

          do m1=1,i2lp(ip)
             read(nfoccmat,*,err=101,end=101)(om_aimag(m1,m2,iproj,ia,is),m2=1,i2lp(ip))
          end do
       end do
       occmat_is_read = .true.
    end if

101 if(npes > 1) then
       call mpi_bcast(tf,1,mpi_logical,0,MPI_CommGroup,ierr)

       if (tf) then
          call mpi_bcast( om, max2lp *max2lp *max_projs *natm *ndim_magmom, &
               &          mpi_double_precision, 0, MPI_CommGroup, ierr )
          call mpi_bcast( om_aimag, max2lp *max2lp *max_projs *natm *ndim_magmom, &
               &          mpi_double_precision, 0, MPI_CommGroup, ierr )
       endif
       call mpi_bcast(occmat_is_read,1,mpi_logical,0,MPI_CommGroup,ierr)
    end if

    if(.not.tf) then
       if(mype==0) write(nfout,*) '! no file of occ. mat.; init. om = 0'
       om = 0.d0; om_aimag = 0.0d0
    end if

  end subroutine m_OP_rd_occ_mat_noncl
! ====================================================================== 11.0

  subroutine m_OP_wd_occ_mat(nfout)
    integer, intent(in) :: nfout
    integer :: num_om, i, iproj, ia, is, it, ip, ig, m1, m2, l

    call m_Files_open_nfoccmat

    if(mype /= 0) return

    write(nfout,*) '! Writing occ mat'

    num_om=0

! ================================= modified by K. Tagami =========== 11.0
!    do is=1,nspin,af+1
    do is=1, ndim_magmom, af+1
! ================================================================== 11.0

       do ia=1,natm
          ig = iproj_group(ia)
          if(ig<1) cycle
          num_om = num_om + num_proj_elems(ig)
       end do
    end do
    rewind nfoccmat
    write(nfoccmat,'(i5," : num_om")') num_om

! ================================= modified by K. Tagami =========== 11.0
!    do is=1,nspin,af+1
    do is=1, ndim_magmom, af+1
! ================================================================== 11.0

       do ia=1,natm
          ig = iproj_group(ia)
          if(ig<1) cycle
          do i=1,num_proj_elems(ig)
             ip=proj_group(i,ig)
             it = proj_attribute(ip)%ityp
             l = proj_attribute(ip)%l
             !!iproj = proj_attribute(ip)%ielem
             iproj = i
             write(nfoccmat,'(5(1x,i5)," : is, ia, iproj; it, l")') is,ia,iproj,it,l
             do m1=1,i2lp(ip)
                write(nfoccmat,'(14(1x,e20.8))')(om(m1,m2,iproj,ia,is),m2=1,i2lp(ip))
             end do
          end do
       end do
    end do

  end subroutine m_OP_wd_occ_mat

! ======================================= added by K. Tagami =============== 11.0
  subroutine m_OP_wd_occ_mat_noncl(nfout)
    integer, intent(in) :: nfout
    integer :: num_om, i, iproj, ia, is, it, ip, ig, m1, m2, l

    call m_Files_open_nfoccmat
    if(mype /= 0) return

    write(nfout,*) '! Writing occ mat'

    num_om=0

    do is=1, ndim_magmom, af+1
       do ia=1,natm
          ig = iproj_group(ia)
          if(ig<1) cycle
          num_om = num_om + num_proj_elems(ig)
       end do
    end do

    rewind nfoccmat
    write(nfoccmat,'(i5," : num_om")') num_om

    do is=1, ndim_magmom, af+1
       do ia=1,natm
          ig = iproj_group(ia)
          if(ig<1) cycle
          do i=1,num_proj_elems(ig)
             ip=proj_group(i,ig)
             it = proj_attribute(ip)%ityp
             l = proj_attribute(ip)%l
             !!iproj = proj_attribute(ip)%ielem
             iproj = i

             write(nfoccmat,'(5(1x,i5)," : is, ia, iproj; it, l")') is,ia,iproj,it,l
             do m1=1,i2lp(ip)
                write(nfoccmat,'(14(1x,e20.8))') &
                     &       (om(m1,m2,iproj,ia,is),m2=1,i2lp(ip))
             end do
             do m1=1,i2lp(ip)
                write(nfoccmat,'(14(1x,e20.8))') &
                     &       (om_aimag(m1,m2,iproj,ia,is),m2=1,i2lp(ip))
             end do

          end do
       end do
    end do

  end subroutine m_OP_wd_occ_mat_noncl
! ======================================================================= 11.0

  subroutine diag_occ_mat()
    integer :: is,ia,it,ig,i,ip,l,m1,m2,m3
    integer :: lwork,info
    integer, allocatable :: iwork(:),ifail(:)
    real(kind=DP) :: amat(max2lp,max2lp),evec(max2lp),rvmat(max2lp,max2lp)
    real(kind=DP), allocatable :: rwork(:)
    real(kind=DP) :: abstol,nfound
    real(kind=DP), external :: dlamch
    lwork = 8*max2lp
    allocate(rwork(lwork))
    allocate(iwork(5*max2lp))
    allocate(ifail(max2lp))
    abstol = 2*dlamch('S')

! ============================== modified by K. Tagami =========== 11.0
!    do is=1,nspin,af+1
    do is=1,ndim_magmom,af+1
! ================================================================ 11.0

       do ia=1,natm
          ig = iproj_group(ia)
          if(ig<1) cycle
          do i=1,num_proj_elems(ig)
             ip=proj_group(i,ig)
             it = proj_attribute(ip)%ityp
             l = proj_attribute(ip)%l

!!$! ============================== modified by K. Tagami =========== 11.0
!!$!             write(nfout,'("Diagonalizing Occupation Mattrix: is,ia,l=",3i5)') is,ia,l
!!$             write(nfout,'("Diagonalizing Occupation Matrix: is,ia,l=",3i5)') is,ia,l
!!$! ================================================================ 11.0

             amat(:,:) = om(:,:,i,ia,is)
             call dsyevx('V','A','U',i2lp(ip),amat,max2lp,0.d0,0.d0,0,0, &
             & abstol,nfound,evec,rvmat,max2lp,rwork,lwork,iwork,ifail,info)
             if(info /= 0) then
                write(nfout,*) 'dsyevx: info=',info
             end if
!!$             do m1=1,i2lp(ip)
!!$! ================================= Modified by K. Tagami =============== 0.2a
!!$!                write(nfout,'(f8.3,":",14f8.3)') evec(m1),(rvmat(m2,m1),m2=1,i2lp(ip))
!!$                write(nfout,'(f13.7,":",14f8.3)') evec(m1),(rvmat(m2,m1),m2=1,i2lp(ip))
!!$! ======================================================================
!!$             end do
             !!$if(proj_attribute(ip)%strong_correlated) then
             !!$   om(:,:,i,ia,is) = 0.d0
             !!$   do m1=1,i2lp(ip)
             !!$      do m2=1,i2lp(ip)
             !!$         do m3=i2lp(ip)-proj_attribute(ip)%norbital+1,i2lp(ip)
             !!$            om(m1,m2,i,ia,is) = om(m1,m2,i,ia,is) + rvmat(m1,m3)*evec(m3)*rvmat(m2,m3)
             !!$         end do
             !!$      end do
             !!$   end do
             !!$end if
          end do
       end do
    end do
    deallocate(rwork)
    deallocate(iwork)
    deallocate(ifail)
  end subroutine diag_occ_mat

! ===================================== added by K. Tagami ================= 11.0
  subroutine diag_occ_mat_noncl()
    integer :: ia, it, i, ig, ie, ip, l, m1, m2
    integer :: lwork, info
!
    integer :: is1, is2, istmp, size1, size2
!
    real(kind=DP), allocatable :: dmmat_r_magmom( :,:,: )
    real(kind=DP), allocatable :: dmmat_i_magmom( :,:,: )
    complex(kind=CMPLDP), allocatable :: dmmat_ssrep( :,:,: )
!
    real(kind=DP), allocatable :: rwork(:), eigenval(:)
    complex(kind=CMPLDP), allocatable :: amat(:,:), work(:)
!
    do ia=1, natm
       ig = iproj_group(ia)
       if ( ig <1 ) cycle

       do i=1,num_proj_elems(ig)
          ip = proj_group(i,ig)
          it = proj_attribute(ip)%ityp
          ie = proj_attribute(ip)%ielem
          l  = proj_attribute(ip)%l

          size1 = i2lp(ip)
          size2 = size1 *ndim_spinor
          lwork = 2 *size2

          allocate( work(lwork) )
          allocate( amat(size2,size2) ); amat = 0.0d0
          allocate( eigenval(size2) ); eigenval = 0.0d0
          allocate( rwork( 3*size2 ) );

          allocate( dmmat_r_magmom(size1,size1,ndim_magmom) ); dmmat_r_magmom = 0.0d0
          allocate( dmmat_i_magmom(size1,size1,ndim_magmom) ); dmmat_i_magmom = 0.0d0
          allocate( dmmat_ssrep(size1,size1,ndim_chgpot) );  dmmat_ssrep = 0.0d0

          dmmat_r_magmom(:,:,:) = om(:,:,ie,ia,:)
          dmmat_i_magmom(:,:,:) = om_aimag(:,:,ie,ia,:)

          call m_ES_MagMom_To_DensMat_porb( size1**2, dmmat_r_magmom, dmmat_i_magmom, &
               &                            dmmat_ssrep )

          Do is1=1, ndim_spinor
             Do is2=1, ndim_spinor
                Do m1=1, size1
                   Do m2=1, size1
                      istmp = ( is1 -1 )*ndim_spinor +is2
                      amat( size1*(is1-1)+m1, size1*(is2-1)+m2 ) &
                           &           = dmmat_ssrep( m1, m2, istmp )
                   End do
                End Do
             End Do
          End Do

!!$          write(nfout,'("Diagonalizing Occupation Matrix: ia,l=",3i5)') ia, l

          call zheev( 'V', 'U', size2, amat, size2, &
               &       eigenval, work, lwork, rwork, info )

          if (info /= 0) then
             write(nfout,*) 'zheev : info=',info
          end if

          if(iprihubbard>1)then
             write(nfout,*) '(UP spin component)'
             do m1 = 1, size2
                write(nfout,'(f13.7,": (Re)",14f8.3)') eigenval(m1), &
                     &                      ( real(amat(m2,m1)),m2=1,size1 )
                write(nfout,'(15X,"(Im)",14f8.3)') &
                     &                      ( aimag(amat(m2,m1)),m2=1,size1 )
             end do

             write(nfout,*) '(DOWN spin component)'
             do m1 = 1, size2
                write(nfout,'(f13.7,": (Re)",14f8.3)') eigenval(m1), &
                     &                      ( real(amat(m2,m1)),m2=size1+1,size2 )
                write(nfout,'(15X,"(Im)",14f8.3)') &
                     &                      ( aimag(amat(m2,m1)),m2=size1+1,size2 )
             end do
          endif
          deallocate( dmmat_ssrep, dmmat_r_magmom, dmmat_i_magmom )
          deallocate( amat )
          deallocate(rwork,work)
          deallocate(eigenval)
       end do
    end do


  end subroutine diag_occ_mat_noncl
! ========================================================================= 11.0

  subroutine m_OP_mix_om(alpha)
    real(kind=DP), intent(in) :: alpha

! ======================= modified by K. Tagami ================= 11.0
!    ommix = (1.d0-alpha)*ommix + alpha*om
!    if(printable) then
!       write(nfout,*) '=== <Mixed occ. mat. 1> ==='
!       call wd_occ_mat(ommix)
!    end if
!
    if ( noncol ) then
       ommix = (1.d0-alpha)*ommix + alpha*om
       ommix_aimag = (1.d0-alpha)*ommix_aimag + alpha*om_aimag
       if(printable) then
          if(iprihubbard>1) then
             write(nfout,*) '=== <Mixed occ. mat. 1> ==='
             call wd_occ_mat_noncl(ommix,ommix_aimag)
          endif
       end if
    else
       ommix = (1.d0-alpha)*ommix + alpha*om
       if(printable) then
          if(iprihubbard>1) then
             write(nfout,*) '=== <Mixed occ. mat. 1> ==='
             call wd_occ_mat(ommix)
          endif
       end if
    endif
! ================================================================= 11.0
  end subroutine m_OP_mix_om

  function iter_from_reset()
    integer             :: n, nbox
    integer             :: iter_from_reset
    if(hownew ==  ANEW) then
       n = (iteration_for_cmix - istrbr - 1)/(nbxmix-1)
       if(n < 0) n = 0
       nbox = iteration_for_cmix - (n*(nbxmix-1) + istrbr +1) + 2
       iter_from_reset = nbox + istrbr - 1
    else
       iter_from_reset = iteration_for_cmix
    endif
  end function iter_from_reset

  function icrspd_is(iter)
    integer, intent(in) :: iter
    integer             :: icrspd_is
    if(iter-istrbr+1 < nbxmix) then
       icrspd_is = ncrspd(iter-istrbr+1)
    else
       icrspd_is = ncrspd(nbxmix)
    endif
  end function icrspd_is

  subroutine set_ncrspd_mxiter_etc(iter,iuv,mxiter)
    integer, intent(in)  :: iuv,iter
    integer, intent(out) :: mxiter
    if(hownew == RENEW) then
       if((iter-istrbr+1) >= 3) then
          if((iter-istrbr+1) > nbxmix) then   ! When the box overflows
             call rotate_cmix_arrays          !-(contained here) ->mxiter,ncrspd,urec,f,g
          else
             mxiter = (iter-istrbr+1) - 1
             ncrspd(iter-istrbr+1) = iter-istrbr+1
          endif
       else
          mxiter = (iter-istrbr+1) - 1
          ncrspd(1) = 1
          ncrspd(2) = 2
       endif
    else ! if(hownew == ANEW)
       mxiter = (iter-istrbr+1) - 1
       ncrspd(iter-istrbr+1) = iter-istrbr+1
    endif

  contains
    subroutine rotate_cmix_arrays
      integer :: is,j,i,icr,jcr,iwork

! ======================================= modified by K. Tagami ========= 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0

         do j = 3, nbxmix
            icr = ncrspd(2)
            jcr = ncrspd(j)
            g(j) = f(icr,jcr,is)
            do i = 3, j-1
               icr = ncrspd(i)
               g(j) = g(j) - f(icr,jcr,is)*g(i)
            enddo
            icr = ncrspd(2)
            urec(:,is,jcr,iuv) &
                 & = urec(:,is,jcr,iuv) + g(j)*urec(:,is,icr,iuv)
         enddo
      enddo
      mxiter = nbxmix-1
      iwork = ncrspd(2)
      do i = 2, mxiter
         ncrspd(i)= ncrspd(i+1)
      end do
      ncrspd(mxiter+1) = iwork
    end subroutine rotate_cmix_arrays
  end subroutine set_ncrspd_mxiter_etc

  subroutine mix_dealloc_previous()
    if(previous_waymix == BROYD1) then
       call mix_broyden_deallocate()
    else if(previous_waymix == BROYD2) then
       call mix_broyden_deallocate()
    else if(previous_waymix == DFP) then
       call mix_DFP_deallocate()
    else if(previous_waymix == PULAY) then
       call mix_PULAY_deallocate()
    end if
  end subroutine mix_dealloc_previous

  subroutine mix_broyden_allocate
! ========================= modified by K. Tagami =================== 11.0
!    nspin_m  = nspin/(af+1)
!
    if ( noncol ) then
       nspin_m  = ndim_magmom
    else
       nspin_m  = nspin/(af+1)
    endif
! ====================================================================== 11.0

    allocate(din(nsize_rho,nspin_m))
    allocate(dout(nsize_rho,nspin_m))
    allocate(dF(nsize_rho,nspin_m))
    allocate(urec(nsize_rho,nspin_m,nbxmix,2))
    if(hownew == RENEW) then
! ========================= modified by K. Tagami =================== 11.0
!       allocate(f(nbxmix,nbxmix,nspin))
       allocate(f(nbxmix,nbxmix,ndim_magmom))
! ==================================================================== 11.0

       allocate(g(nbxmix))
    end if
    allocate(ncrspd(nbxmix))
  end subroutine mix_broyden_allocate

  subroutine mix_broyden_deallocate
    if(allocated(din)) deallocate(din)
    if(allocated(dout)) deallocate(dout)
    if(allocated(dF)) deallocate(dF)
    if(allocated(urec)) deallocate(urec)
    if(allocated(f)) deallocate(f)
    if(allocated(g)) deallocate(g)
    if(allocated(ncrspd)) deallocate(ncrspd)
  end subroutine mix_broyden_deallocate

  subroutine mix_broyden_alloc2
    allocate(d0(nsize_rho,nspin_m))
    allocate(u(nsize_rho,nspin_m))
    allocate(v(nsize_rho,nspin_m))
  end subroutine mix_broyden_alloc2

  subroutine mix_broyden_dealloc2
    deallocate(d0); deallocate(u); deallocate(v)
  end subroutine mix_broyden_dealloc2

  subroutine mix_broyden_alloc3
    allocate(d0(nsize_rho,nspin_m))
    allocate(u(nsize_rho,nspin_m))
    allocate(v(nsize_rho,nspin_m))
    allocate(dd(nsize_rho,nspin_m))
  end subroutine mix_broyden_alloc3

  subroutine mix_broyden_dealloc3
    deallocate(d0); deallocate(u); deallocate(v); deallocate(dd)
  end subroutine mix_broyden_dealloc3

  subroutine mix_DFP_allocate
! ========================= modified by K. Tagami =================== 11.0
!    nspin_m  = nspin/(af+1)
!
    if ( noncol ) then
       nspin_m  = ndim_magmom
    else
       nspin_m  = nspin/(af+1)
    endif
! ====================================================================== 11.0

    allocate(din(nsize_rho,nspin_m))
    allocate(dout(nsize_rho,nspin_m))
    allocate(dF(nsize_rho,nspin_m))
    allocate(urec(nsize_rho,nspin_m,nbxmix,2))
    allocate(ncrspd(nbxmix))
    allocate(uuf(nbxmix,nspin_m,2))
  end subroutine mix_DFP_allocate

  subroutine mix_DFP_deallocate()
    if(allocated(din)) deallocate(din)
    if(allocated(dout)) deallocate(dout)
    if(allocated(dF)) deallocate(dF)
    if(allocated(urec)) deallocate(urec)
    if(allocated(ncrspd)) deallocate(ncrspd)
    if(allocated(uuf)) deallocate(uuf)
  end subroutine mix_DFP_deallocate

  subroutine mix_DFP_alloc2
    allocate(d0(nsize_rho,nspin_m))
    allocate(u(nsize_rho,nspin_m))
    allocate(w(nsize_rho,nspin_m))
  end subroutine mix_DFP_alloc2

  subroutine mix_DFP_dealloc2
    deallocate(d0); deallocate(u); deallocate(w)
  end subroutine mix_DFP_dealloc2

  subroutine renew_u_br(j,i)
    integer, intent(in) :: j,i

! ================================== modified by K. Tagami =========== 11.0
!    real(DP)      :: v_dF(nspin)
    real(DP)      :: v_dF(nspin_m)
! ===================================================================== 11.0

    integer       :: is

    v_dF = 0.d0
! ================================ modified by K. Tagami ============ 5.0
!    do is = 1, nspin, af+1
!       v_dF(is) = sum(urec(:,is,j,iV)*dF(:,is))
!       u(:,is) = u(:,is) - v_dF(is)*urec(:,is,j,iU)
!    end do

! ================================== modified by K. Tagami =========== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ===================================================================== 11.0
       v_dF(is) = sum(urec(:,is,j,iV)*dF(:,is))
    end do

! ================================== modified by K. Tagami =========== 11.0
!    if ( nspin==2 .and. sw_mix_bothspins_sametime_hsr == YES ) then
    if ( nspin_m==2 .and. sw_mix_bothspins_sametime_hsr == YES ) then
! ===================================================================== 11.0
      v_dF(1) = v_dF(1) + v_dF(2)
      v_dF(2) = v_dF(1)
    endif

! ======================== added by K. Tagami ============== 11.0
    if ( noncol ) then
       v_dF(1) = sum( v_dF(:) )
       v_dF(:) = v_dF(1)
    endif
! =========================================================== 11.0

! ================================== modified by K. Tagami =========== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ===================================================================== 11.0
       u(:,is) = u(:,is) - v_dF(is)*urec(:,is,j,iU)
    end do
! ================================================================== 5.0

! ================================== modified by K. Tagami =========== 11.0
!    if(hownew == RENEW) f(j,i,1:nspin) = v_dF(1:nspin)
    if(hownew == RENEW) f(j,i,1:nspin_m) = v_dF(1:nspin_m)
! ==================================================================== 11.0

  end subroutine renew_u_br

  subroutine renew_d_br(j)
    integer, intent(in) :: j

! ================================== modified by K. Tagami =========== 11.0
!    real(DP)  :: vF(nspin)
    real(DP)  :: vF(nspin_m)
! ==================================================================== 11.0

    integer :: is

    vF = 0.d0
! ================================ modified by K. Tagami ============ 5.0
!    do is = 1, nspin, af+1
!       vF(is) = sum(urec(:,is,j,iV)*FF(:,is))
!       d0(:,is) = d0(:,is) - vF(is)*urec(:,is,j,iU)
!    end do

! ================================== modified by K. Tagami =========== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ==================================================================== 11.0
       vF(is) = sum(urec(:,is,j,iV)*FF(:,is))
    end do
!
! ================================ modified by K. Tagami ============= 11.0
!    if ( nspin==2 .and. sw_mix_bothspins_sametime_hsr == YES ) then
    if ( nspin_m==2 .and. sw_mix_bothspins_sametime_hsr == YES ) then
! ===================================================================== 11.0
      vF(1) = vF(1) + vF(2)
      vF(2) = vF(1)
    endif
! ==================================================================== 5.0

! ======================== added by K. Tagami ============== 11.0
    if ( noncol ) then
       vF(1) = sum( vF(:) )
       vF(:) = vF(1)
    endif
! =========================================================== 11.0

! ================================ modified by K. Tagami ============= 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ===================================================================== 11.0
       d0(:,is) = d0(:,is) - vF(is)*urec(:,is,j,iU)
    end do
  end subroutine renew_d_br

  subroutine renew_d_last_br
    integer   :: is, i
! ================================ modified by K. Tagami ============= 11.0
!    real(DP)  :: vF(nspin)
    real(DP)  :: vF(nspin_m)
! ===================================================================== 11.0

! ================================ added by K. Tagami ============ 5.0
    integer :: ns
! ================================================================ 5.0

    vF = 0.d0
! ================================ modified by K. Tagami ============= 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ===================================================================== 11.0
       vF(is) = sum(v(:,is)*FF(:,is))
    end do

! ================================ added by K. Tagami ============ 5.0

! ========================================== modified by K. Tagami =========== 11.0
!    if ( nspin==2 .and. sw_mix_bothspins_sametime_hsr == YES ) then
    if ( nspin_m==2 .and. sw_mix_bothspins_sametime_hsr == YES ) then
! ============================================================================ 11.0
      vF(1) = vF(1) + vF(2)
      vF(2) = vF(1)
    endif

! ================================================================ 5.0

! ======================== added by K. Tagami ==================== 11.0
    if ( noncol ) then
       vF(1) = sum( vF(:) )
       vF(:) = vF(1)
    endif
! ================================================================ 11.0

! ================================ modified by K. Tagami ============= 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ===================================================================== 11.0
       din (:,is) = rhoo(:,is) ! chgqo
       dout(:,is) = rho (:,is) ! chgq
    end do

! ============================= modified by K. Tagami =============== 5.0
!    do is = 1, nspin, af+1
!       rho(:,is) = d0(:,is) - vF(is)*u(:,is)
!    end do

! ================================ modified by K. Tagami ============= 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ==================================================================== 11.0
       rho(:,is) = d0(:,is) - vF(is)*u(:,is)
    end do

! ============================= modified by K. Tagami =============== 11.0
!    if ( sw_force_simple_mixing_occdiff ==ON .and. sw_recomposing_occmat ==ON ) then
!       call simple_mix2_kt( rmxtrck )            ! without mapping to occmix
!    endif

    if ( .not. noncol ) then
       if ( sw_force_simple_mixing_occdiff ==ON .and. sw_recomposing_occmat ==ON ) then
          call simple_mix2_kt( rmxtrck )            ! without mapping to occmix
       endif
    endif
! ======================================================================= 11.0

!!!!!!!!!!!!    call map_rho_to_om(ommix,rho)
! ===================================================================5.0


  end subroutine renew_d_last_br

! <<< Quasi-Newton Methods >>>
!  1. Broyden's 1st method
!  2. Broyden's 2nd method
!  3. DFP method
!
  subroutine m_OP_mix_broyden1(rmx)
    real(kind=DP), intent(in) :: rmx
    integer   :: iter,j,mxiter,icr,jcr
!=========================== modified by K. Tagami ================== 11.0
!    real(DP)  :: vdF(nspin)
    real(DP)  :: vdF(nspin_m)
! ==================================================================== 11.0
    integer   :: is
    integer   :: id_sname = -1
#ifdef __TIMER_SUB__
    call timer_sta(1142)
#endif
    call tstatc0_begin('m_OP_mix_broyden1 ',id_sname)

    if(previous_waymix /= BROYD1) then
       if(first) then
          call create_map_func(.true.)
          call alloc_rho
          call create_map_func(.false.)
          first = .false.
       end if
       call mix_dealloc_previous()
       call mix_broyden_allocate()
       FF => din
    end if

    iter = iter_from_reset()                 !-(m_OP)

    if((iter-istrbr+1) <= 1) then
       call simple_mix(rmx)                  !-(m_OP)
    else
       call map_om_to_rho(om,rho)
       call map_om_to_rho(omold,rhoo)
       call mix_broyden_alloc3   !-(m_OP) d0,u,v, and dd are allocated
       call dF_F_d0_u_v_and_dd   !-(c.h.) dF, FF, dd, initial u,v,d0

       call set_ncrspd_mxiter_etc(iter,iU,mxiter) !-(m_CD) ->mxiter,ncrspd
       icr = icrspd_is(iter)                 !-(m_CD) function
       do j = 2, mxiter
          jcr = ncrspd(j)
          call renew_u_br(jcr,icr) !-(m_OP) |u(m)> = |u(m)> - <v(j)|dF(m)>|u(j)>
          call renew_v(jcr)        !-(c.h.) |v(m)> = |v(m)> - <u(j)|dd(m)>|v(j)>
          call renew_d_br(jcr)     !-(m_OP) |d(m)> = |d(m)> - <v(j)|F(m)> |u(j)>
       enddo!j-loop

       urec(:,:,icr,iU) = u(:,:)
       vdF=0.d0
#ifdef __TIMER_DO__
  call timer_sta(1191)
#endif

! ====================================== modified by K. Tagami ========== 11.0
!       do is=1,nspin,(af+1)
       do is=1,ndim_magmom,(af+1)
! ======================================================================== 11.0
          vdF(is) = sum(v(:,is)*dF(:,is))
          urec(:,is,icr,iV) = v(:,is)/vdF(is)
       end do
#ifdef __TIMER_DO__
  call timer_end(1191)
#endif

       call renew_d_last_br                 !-(m_CD)
                                            ! chgq(|d(m)>) = |d(m)>-<v(m)|F(m)>|u(m)>
       call mix_broyden_dealloc3()          !-(m_CD)
    endif

    previous_waymix = BROYD1
    call tstatc0_end(id_sname)
#ifdef __TIMER_SUB__
    call timer_end(1142)
#endif
  contains
    subroutine dF_F_d0_u_v_and_dd
      !   dF(=deltaF) = (rho - dout) - (rhoo - din)
      !   FF  = rho - rhoo (=\cal F^{m}); u  = (rhoo - din) + c_p*dF;
      !   dd = rhoo - din
      !   d0 = rhoo+c_p* F;               v  = c_p* dd_l

      integer                      :: is,k,i

! ====================================== modified by K. Tagami ========== 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! ======================================================================== 11.0
         dF(:,is) = (rho(:,is)-rhoo(:,is)) - (dout(:,is)-din(:,is))
         d0(:,is) = rhoo(:,is)+ rmx*(rho(:,is) - rhoo(:,is))
         dd(:,is) = rhoo(:,is) - din(:,is)
         u(:,is)  = rmx*dF(:,is) + dd(:,is)
         FF(:,is)  = rho(:,is) - rhoo(:,is)
      end do

! ====================================== modified by K. Tagami ========== 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! ======================================================================== 11.0
         v(:,is) = rmx*dd(:,is)
      end do

    end subroutine dF_F_d0_u_v_and_dd

    subroutine renew_v(j)
      integer, intent(in) :: j
! ====================================== modified by K. Tagami ========== 11.0
!      real(DP)  :: u_dd(nspin)
      real(DP)  :: u_dd(nspin_m)
! ======================================================================== 11.0
      integer :: is

      u_dd = 0.d0
! ====================================== modified by K. Tagami ========== 11.0
!      do is=1,nspin,(af+1)
      do is=1,ndim_magmom,(af+1)
! ======================================================================= 11.0
         u_dd(is) = sum(urec(:,is,j,iU)*dd(:,is))
         v(:,is)  = v(:,is) - u_dd(is)*urec(:,is,j,iV)
      end do
    end subroutine renew_v
  end subroutine m_OP_mix_broyden1

  subroutine m_OP_mix_broyden2(rmx)
    real(kind=DP), intent(in) :: rmx
    integer   :: iter,j,mxiter,icr,jcr
    logical   :: falloc
    integer   :: id_sname = -1
#ifdef __TIMER_SUB__
    call timer_sta(1143)
#endif
    call tstatc0_begin('m_OP_mix_broyden2 ',id_sname)

    if(previous_waymix /= BROYD2) then
       if(first) then
          call create_map_func(.true.)
          call alloc_rho
          call create_map_func(.false.)
          first = .false.
       end if
       call mix_dealloc_previous()
       call mix_broyden_allocate()
       FF => din
    end if

! ============================ modified by K. Tagami ============== 11.0
!    call map_om_to_rho(om,rho)
!    call map_om_to_rho(omold,rhoo)
!
    if ( noncol ) then
       call map_om_to_rho_noncl(om,   om_aimag,   rho)
       call map_om_to_rho_noncl(omold,omold_aimag,rhoo)
    else
       call map_om_to_rho(om,rho)
       call map_om_to_rho(omold,rhoo)
    endif
! ==================================================================== 11.0

    iter = iter_from_reset()                 !-(m_OP)

! ====================================== added by K. Tagami ========= 5.0

! ================= modified by K. Tagami ====== 11.0
!    nspin_m  = nspin/(af+1)
!    allocate( rmxtrck(nspin_m) )
!    if ( sw_recomposing_occmat == YES .and. af == 0 .and. nspin == 2 ) then
!!!       call alloc_occmatstore_recomp( rmx, rmxtrck )
!       call alloc_rhostore_recomp( rmx, rmxtrck )
!    else
!       rmxtrck = rmx
!    endif

    nspin_m  = ndim_magmom/(af+1)
    allocate( rmxtrck(nspin_m) )
    if ( noncol ) then
       rmxtrck = rmx
    else
       if ( sw_recomposing_occmat == YES .and. af == 0 .and. nspin == 2 ) then
          call alloc_rhostore_recomp( rmx, rmxtrck )
       else
          rmxtrck = rmx
       endif
    end if
! ================================================== 11.0

! =================================================================== 5.0

    if((iter-istrbr+1) <= 1) then
! ===================================== modified by K. Tagami ======== 5.0
!!       call simple_mix(rmx)                  !-(m_OP)
       call simple_mix_kt( rmxtrck )                  !-(m_OP)
! ==================================================================== 5.0
    else
       call mix_broyden_alloc2   !-(m_OP) d0,u, and v are allocated
       call dF_F_d0_u_and_v      !-(c.h.)   dF, FF, initial u,v,d0

       call set_ncrspd_mxiter_etc(iter,iU,mxiter) !-(m_OP) ->mxiter,ncrspd
       !                  when hownew == RENEW: f,g,ncrspd, and urec are reset.

       icr = icrspd_is(iter)                 !-(m_OP) function
       do j = 2, mxiter
          jcr = ncrspd(j)
          call renew_u_br(jcr,icr) !-(m_OP) |u(m)> = |u(m)> - <v(j)|dF(m)>|u(j)>
          call renew_d_br(jcr)     !-(m_OP) |d(m)> = |d(m)> - <v(j)|F(m)> |u(j)>
       enddo!j-loop

       urec(:,:,icr,iU) = u(:,:)  ! storing
       urec(:,:,icr,iV) = v(:,:)  ! storing

       call renew_d_last_br            !-(m_OP) chgq_l(|d(m)>) = |d(m)>-<v(m)|F(m)>|u(m)>
       call mix_broyden_dealloc2       !-(m_OP)
    endif

! ===================================- added by K. Tagami =============== 5.0

! ============== modiifed by K. Tagami ======= 11.0
!    if ( sw_recomposing_occmat == YES .and. af == 0 .and. nspin == 2 ) then
!       call compose_rho_dealloc_store
!    end if

    if ( .not. noncol ) then
       if ( sw_recomposing_occmat == YES .and. af == 0 .and. nspin == 2 ) then
          call compose_rho_dealloc_store
       end if
    endif
! =============================================== 11.0

    deallocate(rmxtrck)

! =========================== modified by K. Tagami =========== 11.0
!    call map_rho_to_om( ommix,rho )
!
    if ( noncol ) then
       call map_rho_to_om_noncl( ommix,ommix_aimag,rho )
    else
       call map_rho_to_om( ommix,rho )
    endif
! =============================================================== 11.0

! =======================================================================5.0

    previous_waymix = BROYD2

    call tstatc0_end(id_sname)
#ifdef __TIMER_SUB__
    call timer_end(1143)
#endif
  contains
    subroutine dF_F_d0_u_and_v
      !   dF(=deltaF) = (rho - dout) - (rhoo - din)
      !   FF = rho - rhoo (=\cal F^{m}); u = (rhoo - din) + a*dF;
      !   d0 = rhoo + a*FF;            v = dF/( |dF| )

      integer                      :: is,i
      real(DP), dimension(nspin_m) :: fff

! ==================================- modified by K. Tagami ============= 5.0
!      do is = 1, nspin, af+1
!         dF(:,is) = (rho(:,is)-rhoo(:,is)) - (dout(:,is)-din(:,is))
!         d0(:,is) = rhoo(:,is) + rmx*(rho(:,is) - rhoo(:,is))
!         u(:,is)  = rmx*dF(:,is) + (rhoo(:,is) - din(:,is))
!         FF(:,is) = rho(:,is) - rhoo(:,is)
!      end do

!      do is = 1, nspin, af+1
!         dF(:,is) = (rho(:,is)-rhoo(:,is)) - (dout(:,is)-FF(:,is))
!         d0(:,is) = rhoo(:,is) + rmx*(rho(:,is) - rhoo(:,is))
!         u(:,is)  = rmx*dF(:,is) + (rhoo(:,is) - FF(:,is))
!         FF(:,is) = rho(:,is) - rhoo(:,is)
!      end do

! ========================== modified by K. Tagami ====== 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! ======================================================= 11.0
         dF(:,is) = (rho(:,is)-rhoo(:,is)) - (dout(:,is)-FF(:,is))
         d0(:,is) = rhoo(:,is) + rmxtrck(is) *(rho(:,is) - rhoo(:,is))
         u(:,is)  = rmxtrck(is) *dF(:,is) + (rhoo(:,is) - FF(:,is))
         FF(:,is) = rho(:,is) - rhoo(:,is)
      end do
! ========================================================================= 5.0
! debug
!!$      write(nfout,*) 'dF=',dF
!!$      write(nfout,*) 'd0=',d0
!!$      write(nfout,*) 'u =',u
!!$      write(nfout,*) 'FF=',FF
! end debug

      fff = 0.d0

! ======================= modified by K. Tagami ========= 11.0
!      do is=1,nspin,af+1
      do is=1,ndim_magmom,af+1
! ======================================================= 11.0
         fff(is) = sum(dF(:,is)*dF(:,is))
      end do
      if(sum(fff) < 1.d-40)  call phase_error_with_msg(nfout,' fmult is too small' ,__LINE__,__FILE__)

! ================================= added by K. Tagami ================== 5.0
! === DEBUG by tkato 2011/11/19 ================================================
!     if ( nspin == 2 .and. sw_mix_bothspins_sametime_hsr == YES ) then
      if ( nspin_m == 2 .and. sw_mix_bothspins_sametime_hsr == YES ) then
! ==============================================================================
        fff(1) = fff(1) + fff(2)
        fff(2) = fff(1)
      endif
! ======================================================================= 5.0

! ========================= added by K. Tagami =========================== 11.0
      if ( noncol ) then
         fff(1) = sum( fff(:) )
         fff(:) = fff(1)
      endif
! ======================================================================== 11.0

! ========================================= modified by K. Tagami ========== 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! =========================================================================== 11.0
         do i=1,nsize_rho
            v(i,is) = dF(i,is)/fff(is)
         end do
      end do

    end subroutine dF_F_d0_u_and_v
  end subroutine m_OP_mix_broyden2

  subroutine m_OP_mix_DFP(rmx)
    real(kind=DP), intent(in) :: rmx
  end subroutine m_OP_mix_DFP

  subroutine mix_pulay_allocate
! ==================== modified by K. Tagami ======================== 11.0
!    nspin_m  = nspin/(af+1)
    if ( noncol ) then
       nspin_m = ndim_magmom
    else
       nspin_m  = nspin/(af+1)
    endif
! ================================================================= 11.0

! =========================================== Modified by K. Tagami =========
!    allocate(f_p(ista_kgpm:iend_kgpm)); call precon_4_mult(f_p) !-(m_CD)
    allocate(f_p(1:nsize_rho)); f_p = 0
! ============================================================================

    allocate(din(1:nsize_rho,nspin_m))
    allocate(dout(1:nsize_rho,nspin_m))
    allocate(urec_l(1:nsize_rho,nspin_m,nbxmix,2))
    allocate(uuf_p(nbxmix,nspin_m))
    allocate(f(nbxmix,nbxmix,nspin_m))
    allocate(g_p(nbxmix,nspin_m))
    allocate(ncrspd(nbxmix))

    allocate(ynorm(nbxmix,nspin_m));ynorm=1.d0
! ======================================= Added by K. Tagami ===========
    din = 0.0d0; dout = 0.0d0; urec_l = 0.0d0; uuf_p = 0.0d0; f = 0.0d0
    g_p = 0.0d0;  ncrspd = 0
! ======================================================================
  end subroutine mix_pulay_allocate

  subroutine mix_pulay_deallocate
    if(allocated(f_p)) deallocate(f_p)
    if(allocated(din)) deallocate(din)
    if(allocated(dout)) deallocate(dout)
    if(allocated(urec_l)) deallocate(urec_l)
    if(allocated(uuf_p)) deallocate(uuf_p)
    if(allocated(f)) deallocate(f)
    if(allocated(g_p)) deallocate(g_p)
    if(allocated(ncrspd)) deallocate(ncrspd)
    if (allocated(ynorm)) deallocate(ynorm)
  end subroutine mix_pulay_deallocate

  subroutine mix_pulay_alloc2
    allocate(d0_l(nsize_rho,nspin_m))
    d0_l = 0.0d0
  end subroutine mix_pulay_alloc2

  subroutine mix_pulay_dealloc2
    deallocate(d0_l)
  end subroutine mix_pulay_dealloc2

  subroutine m_OP_mix_pulay(rmx)
    integer, parameter  :: iRho = 1, iResid = 2
    real(DP),intent(in) :: rmx
    integer   :: iter, mxiter
    real(DP),pointer,dimension(:)  :: e_wk, f_wk, ww1, finv
    integer, pointer,dimension(:)  :: ip
! --> T. Yamasaki  03 Aug. 2009
    real(kind=DP), allocatable, dimension(:):: rmxtrc ! d(nspin_m)
!   real(kind=DP), allocatable, dimension(:,:,:) :: chgqstore_l, chgqostore_l
! <--
    real(kind=DP) :: rmxtt
    integer   :: id_sname = -1
    call tstatc0_begin('m_OP_mix_pulay ',id_sname,1)

    if(previous_waymix /= PULAY) then
       if(first) then
          call create_map_func(.true.)
          call alloc_rho
          call create_map_func(.false.)
          first = .false.
       end if
       call mix_dealloc_previous()
       call mix_pulay_allocate()
    end if

    if ( noncol ) then
       call map_om_to_rho_noncl(om,   om_aimag,   rho)
       call map_om_to_rho_noncl(omold,omold_aimag,rhoo)
    else
       call map_om_to_rho(om,rho)
       call map_om_to_rho(omold,rhoo)
    endif

    iter = iter_from_reset()                 !-(m_OP)

    nspin_m  = ndim_magmom/(af+1)
    allocate( rmxtrck(nspin_m) )
    if ( noncol ) then
       rmxtrck = rmx
    else
       if ( sw_recomposing_occmat == YES .and. af == 0 .and. nspin == 2 ) then
          call alloc_rhostore_recomp( rmx, rmxtrck )
       else
          rmxtrck = rmx
       endif
    end if
! ========================================================================= 11.0

    if((iter-istrbr+1) <= 1) then
! ===================================== modified by K. Tagami ======== 5.0
!!       call simple_mix(rmx)                  !-(m_OP)
       call simple_mix_kt( rmxtrck )                  !-(m_OP)
! ==================================================================== 5.0
    else
       call mix_pulay_alloc2   !-(m_CD) d0_l,u_l, and w_l are allocated
       call set_ncrspd_mxiter(nbxmix,iter-istrbr,mxiter) ! -> ncrspd, mxiter
!!$       call mix_pulay_alloc3(nbxmix,iter-istrbr)   !-(c.h.) e_wk,f_wk,ww1,finv,ip
       call mix_pulay_alloc3(mxiter)   !-(c.h.) e_wk,f_wk,ww1,finv,ip

       call Resid_and_dd_into_urec(mxiter) !-(c.h.)
       !                               dF ->urec_l; dd ->urec_l; d0_l,din,dout
       call Ri_dot_Rj(mxiter)          !-(c.h.) <R(i)|R(j)>->f
       call get_finv_lapack(nbxmix,mxiter,f)  !-(c.h.) f -> f^{-1}= <R(i)|R(j)>^{-1}

       call Rj_dot_d(mxiter)           !-(c.h.) <R(j)|d>,(j=1,iter-istrb) -> uuf_p

       call get_gmatrix(mxiter)        !-(c.h.) (f,uuf_p)->g
       call renew_d_using_g(mxiter,rmxtrck)     !-(c.h.)

       call mix_pulay_dealloc3                    !-(c.h.)
       call mix_pulay_dealloc2                    !-(m_CD)
    endif

    deallocate(rmxtrck)

    if ( noncol ) then
       call map_rho_to_om_noncl( ommix,ommix_aimag,rho )
    else
       call map_rho_to_om( ommix,rho )
    endif

    previous_waymix = PULAY
    call tstatc0_end(id_sname)
  contains
    subroutine mix_pulay_alloc3(m)
      integer, intent(in) :: m
      allocate(e_wk(m*m)); allocate(f_wk(m*m)); allocate(ww1(m)); allocate(finv(m*m))
      allocate(ip(m))
! ===================================== Added by K. Tagami ============
      e_wk = 0; f_wk = 0; ww1 = 0; finv = 0; ip = 0
! =====================================================================
    end subroutine mix_pulay_alloc3

    subroutine set_ncrspd_mxiter(n,iter,m)
      integer, intent(in)  :: n, iter
      integer, intent(out) :: m
      integer :: i, nx
      if(hownew == ANEW) then
         m = iter
!!$         ncrspd(:) = (/(i,i=1,m)/)
         do i=1,iter
            ncrspd(i) = i
         end do
      else ! hownew == RENEW
         if(iter <= n) then
            m = iter
!!$            ncrspd(:) = (/(i,i=1,m)/)
            do i=1,iter
               ncrspd(i) = i
            end do
         else
            m = n
            nx = ncrspd(1)
            do i = 1, m-1
               ncrspd(i) = ncrspd(i+1)
            end do
            ncrspd(m) = nx
         end if
      end if
    end subroutine set_ncrspd_mxiter

    subroutine mix_pulay_dealloc3
      deallocate(e_wk); deallocate(f_wk); deallocate(ww1); deallocate(finv)
      deallocate(ip)
    end subroutine mix_pulay_dealloc3

    subroutine Resid_and_dd_into_urec(iter)
      integer, intent(in) :: iter
      integer             :: itc,itc0,itc1
      integer :: i,j,k,imix
      real(kind=DP) :: sum1,sum2
      itc = ncrspd(iter)
      urec_l(:,:,itc,iResid) = rho(:,:) - rhoo(:,:) - (dout(:,:) - din(:,:)) ! =dF(=delta F^i)
      urec_l(:,:,itc,iRho  ) = rhoo(:,:) - din(:,:)                ! =dd
      d0_l(:,:) = rho(:,:) - rhoo(:,:)
      din(:,:)  = rhoo(:,:)
      dout(:,:) = rho(:,:)
      ynorm(itc,:)=0.d0
      do i=1,nspin_m
         do k=1,nsize_rho
            ynorm(itc,i) = ynorm(itc,i)+urec_l(k,i,itc,iResid)*urec_l(k,i,itc,iResid)
         enddo
      enddo
      ynorm(itc,:) = 1.d0/sqrt(ynorm(itc,:))
    end subroutine Resid_and_dd_into_urec

    subroutine Ri_dot_Rj(n)
      integer, intent(in) :: n
      integer  :: it,jt,itc,jtc
      real(DP) :: ff1(nspin_m),ff1tmp

      do it = 1, n
         itc = ncrspd(it)
         do jt = it, n
            jtc = ncrspd(jt)
            if(sw_mix_bothspins_sametime==ON .and. nspin_m>1)then
               call mult1s10_reduce_spin(urec_l,nbxmix,2,itc,iResid,urec_l,jtc,iResid,f_p,ff1tmp)   ! <delta F^i|delta F^j>
               ff1(1)=ff1tmp;ff1(2)=ff1tmp
            else
               call mult1s10(urec_l,nbxmix,2,itc,iResid,urec_l,jtc,iResid,f_p,ff1)   ! <delta F^i|delta F^j>
            endif

            if ( noncol ) then
               call mult1s10_reduce_spin( urec_l, nbxmix, 2, itc, iResid, &
                    &                     urec_l, jtc, iResid, f_p, ff1tmp )
                                                        ! <delta F^i|delta F^j>
               ff1(:) = ff1tmp
            endif
            f(it,jt,1:nspin_m) = ff1(1:nspin_m)
            if(jt /= it) f(jt,it,1:nspin_m) = f(it,jt,1:nspin_m)
         end do
      end do
    end subroutine Ri_dot_Rj

    subroutine Rj_dot_d(n)
      integer, intent(in) :: n
      integer  :: jt, jtc
      real(DP) :: ff1(nspin_m),ff1tmp

      do jt = 1, n
         jtc = ncrspd(jt)
         if(sw_mix_bothspins_sametime==ON .and. nspin_m>1)then
            call mult1s5_reduce_spin(urec_l,nbxmix,2,jtc,iResid,d0_l,f_p,ff1tmp)
            ff1(1) = ff1tmp;ff1(2)=ff1tmp
         else
            call mult1s5(urec_l,nbxmix,2,jtc,iResid,d0_l,f_p,ff1)
         endif

         if ( noncol ) then
            call mult1s5_reduce_spin(urec_l,nbxmix,2,jtc,iResid,d0_l,f_p,ff1tmp)
            ff1(:) = ff1tmp
         endif

         uuf_p(jt,1:nspin_m) = ff1(1:nspin_m)
      end do
    end subroutine Rj_dot_d

    subroutine get_finv_lapack(m,n,f)
      integer,intent(in)                             :: m,n
      real(DP),intent(inout),dimension(m,m,nspin_m) :: f
      real(DP), allocatable,dimension(:,:) :: fwork
      integer :: is,inf,it,jt,kt,nnspin
      real(DP) :: div,tmp
      allocate(fwork(n,n))
      nnspin = nspin
      if(sw_mix_bothspins_sametime==ON .or. af==1) nnspin=1

      if ( noncol ) then
         nnspin = 1
      end if

      do is=1,nnspin
         if(ipripulay >= 2) then
            write(nfout,600) n,(('(',it,jt,')',f(it,jt,is),jt=1,n),it=1,n)
600         format(//11x,"**input matrix**"/12x &
                 & ,"horder=",I5/(2x,4(1x,1a,i2,",",i2,1a,e14.6)))
         end if
         fwork=0
         do it=1,n
            do jt=1,n
               fwork(jt,it) = f(jt,it,is)*ynorm(jt,is)*ynorm(it,is)
               if(it==jt) fwork(jt,it)=fwork(jt,it)+alpha_pulay
            enddo
         enddo
         call dpotrf('U',n,fwork,n,inf)
         call dpotri('U',n,fwork,n,inf)
         do it=1,n-1
            do jt=it+1,n
               fwork(jt,it) = fwork(it,jt)
            enddo
         enddo
         do it=1,n
            do jt=1,n
               f(jt,it,is) = fwork(jt,it)*ynorm(jt,is)*ynorm(it,is)
            enddo
         enddo
         if(ipripulay >= 2) then
            write(nfout,630) (('(',it,jt,')',f(it,jt,is),it=1,n),jt=1,n)
630         format(/11x, "**inverse matrix**" &
                 & ,/(2x,4(1x,1a,i2,",",i2,1a,e14.6)))
         end if
      enddo
      if(sw_mix_bothspins_sametime==ON .and. nspin_m>1)then
         do it=1,n
            do jt=1,n
               f(jt,it,2) = f(jt,it,1)
            enddo
         enddo
      endif
! ============================== added by K. Tagami ========== 11.0
      if ( noncol ) then
         do it=1,n
            do jt=1,n
               f(jt,it,:) = f(jt,it,1)
            enddo
         end do
      endif
! ============================================================ 11.0
      deallocate(fwork)

    end subroutine get_finv_lapack

    subroutine get_finv(m,n,f)
      integer,intent(in)                             :: m,n
      real(DP),intent(inout),dimension(m,m,nspin_m) :: f

      integer                        :: icount,is,jt,it,icon
      real(DP)                       :: div

      e_wk = 0.d0
      do it = 1, n
         e_wk(it*it) = 1.d0
      end do

! ======================================= modified by K. Tagami =========== 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! ========================================================================== 11.0
         div = 1.d0/f(1,1,is)
         icount = 1
         do jt = 1, n
            do it = 1, n
               f_wk(icount) = f(it,jt,is)*div
               icount = icount + 1
            end do
         end do
         if(ipripulay >= 1) then
            write(nfout,600) n,(('(',it,jt,')',f(it,jt,is)*div,jt=1,n),it=1,n)
600         format(//11x,"**input matrix**"/12x &
                 & ,"horder=",I5/(2x,4(1x,1a,i2,",",i2,1a,e14.6)))
         end if
         call rdecomp(n,f_wk,ww1,ip,icon)
         if(icon /= 0) then
            call phase_error_with_msg(nfout,'LU decomposition is impossible.',__LINE__,__FILE__)
         else
            call rsolve(n,n,f_wk,e_wk,finv,ip)
         endif

         icount = 1
         do jt = 1, n
            do it = 1, n
               f(it,jt,is) = finv(icount)
               icount = icount + 1
            end do
         end do
         if(ipripulay >= 1) then
            write(nfout,630) (('(',it,jt,')',f(it,jt,is),it=1,n),jt=1,n)
630         format(/11x, "**inverse matrix**" &
                 & ,/(2x,4(1x,1a,i2,",",i2,1a,e14.6)))
         end if
      end do
    end subroutine get_finv

    subroutine get_gmatrix(n)
      integer,intent(in) :: n
      integer :: is, it, jt, nnspin
      nnspin = nspin
      if(sw_mix_bothspins_sametime==ON .or. af==1) nnspin=1

! ============================ added by K. Tagami ============= 11.0
      if ( noncol ) nnspin = 1
! ============================================================== 11.0

      g_p = 0.d0
      do is = 1, nnspin
         do it = 1, n
            do jt = 1, n
               g_p(it,is) = g_p(it,is) - f(jt,it,is)*uuf_p(jt,is)
            end do
         end do
         if(ipripulay >= 2) then
            write(nfout,'(" -- g_p(1:",i3,") --")') n
            write(nfout,'(8f20.12)') (g_p(it,is),it=1,n)
         end if
      end do
      if(sw_mix_bothspins_sametime==ON .and. nspin_m>1)then
         do it = 1,n
            g_p(it,2) = g_p(it,1)
         enddo
      endif
! ============================== added by K. Tagami ============ 11.0
      if ( noncol ) then
         do it = 1,n
            g_p(it,:) = g_p(it,1)
         enddo
      endif
! ============================================================== 11.0

    end subroutine get_gmatrix

    subroutine renew_d_using_g(n,p)
      integer, intent(in)                                :: n
      real(DP),intent(in),dimension(nspin_m) :: p
      integer    :: is, k, i, it, itc, ns

!!$      do is = 1, nspin, af+1
      ns = nspin_for_qnewton()
      do is = 1, ns,af+1
         do i = 1,nsize_rho
            rho(i,is)  = rhoo(i,is) + p(is)*d0_l(i,is)
         end do
         do it = 1, n
            itc = ncrspd(it)
            do i = 1,nsize_rho
               rho(i,is) = rho(i,is) + g_p(it,is)* &
                    &        (urec_l(i,is,itc,iRho) + p(is)*urec_l(i,is,itc,iResid))
            end do
         end do
      end do

    end subroutine renew_d_using_g

    integer function nspin_for_qnewton()
      if ( noncol ) then
         nspin_for_qnewton=ndim_magmom
      else
         nspin_for_qnewton=nspin
         if (sw_force_simple_mixing==ON .and. sw_recomposing==ON) nspin_for_qnewton=1
      endif
    end function nspin_for_qnewton

  end subroutine m_OP_mix_pulay

  subroutine create_map_func(paramset)
    logical :: paramset
    integer :: n,ia,ig,i,ip,it,m1,m2
    integer :: ii

    n=0
    do ia=1,natm
       ig = iproj_group(ia)
       if(ig<1) cycle
       do i=1,num_proj_elems(ig)
          ip=proj_group(i,ig)
          it = proj_attribute(ip)%ityp
          do m2=1,i2lp(ip)
             do m1=m2,i2lp(ip)
                n=n+1
                if(.not.paramset) &
                & imapom(n) = m1 + max2lp*(m2-1 + max2lp*( i-1 + max_projs*( ia-1 ) ) )
                !!$if(.not.paramset) write(nfout,*) 'n,m1,m2,i,ia,imapom=',n,m1,m2,i,ia,imapom(n)
             end do
          end do
       end do
    end do
    nsize_rho = n
    !!$if(.not.paramset) then
    !!$   write(nfout,*) 'm_OP: nsize_rho=',nsize_rho
    !!$   write(nfout,*) 'm_OP: imapom=',imapom(1:nsize_rho)
    !!$end if

! =============================== added by K. Tagami ================= 11.0
    if ( noncol ) then
       nsize_rho_realpart = n

      if ( sw_mix_imaginary_component == ON ) then
         do ia=1,natm
            ig = iproj_group(ia)
            if(ig<1) cycle
            do i=1,num_proj_elems(ig)
               ip=proj_group(i,ig)
               it = proj_attribute(ip)%ityp
               do m2=1,i2lp(ip)
                  do m1=m2+1,i2lp(ip)
                     n=n+1
                     if (.not.paramset) &
                          & imapom(n) = m1 + max2lp*(m2-1 &
                          &                + max2lp*( i-1 + max_projs*( ia-1 ) ) )
                  end do
               end do
            end do
         end do
         nsize_rho = n
      endif
    end if
! ===================================================================== 11.0

  end subroutine create_map_func

  subroutine alloc_rho
! ========================= modified by K. Tagami ============= 11.0
!    allocate(rho(nsize_rho,nspin))
!    allocate(rhoo(nsize_rho,nspin))
    allocate(rho(nsize_rho,ndim_magmom))
    allocate(rhoo(nsize_rho,ndim_magmom))
! ============================================================= 11.0
    allocate(imapom(nsize_rho))
  end subroutine alloc_rho

  subroutine dealloc_rho
    deallocate(rho)
    deallocate(rhoo)
    deallocate(imapom)
  end subroutine dealloc_rho

  subroutine map_om_to_rho(om,rho)
    real(kind=DP), intent(in) :: om(max2lp*max2lp*max_projs*natm,nspin)
    real(kind=DP), intent(out) :: rho(nsize_rho,nspin)

    integer :: i,is

    do is=1,nspin,(af+1)
       do i=1,nsize_rho
          rho(i,is) = om(imapom(i),is)
          ! debug
          !  write(nfout,*) 'is,i,imapom,rho=',is,i,imapom(i),rho(i,is)
          ! end debug
       end do
    end do
  end subroutine map_om_to_rho

! ==================================== added by K. Tagami ============== 11.0
  subroutine map_om_to_rho_noncl(om,om_aimag,rho)
    real(kind=DP), intent(in) :: om(max2lp*max2lp*max_projs*natm,ndim_magmom)
    real(kind=DP), intent(in) :: om_aimag(max2lp*max2lp*max_projs*natm,ndim_magmom)
    real(kind=DP), intent(out) :: rho(nsize_rho,ndim_magmom)

    integer :: i,is

    do is=1,ndim_magmom
       do i=1, nsize_rho_realpart
          rho(i,is) = om(imapom(i),is)
       end do
       do i=nsize_rho_realpart+1, nsize_rho
          rho(i,is) = om_aimag(imapom(i),is)
       end do
    end do

  end subroutine map_om_to_rho_noncl
! ============================================================================ 11.0

  subroutine map_rho_to_om(om,rho)
    real(kind=DP), intent(out) :: om(max2lp*max2lp*max_projs*natm,nspin)
    real(kind=DP), intent(in) :: rho(nsize_rho,nspin)
    integer :: i,is,ia,ig,ip,it,m1,m2

    do is=1,nspin,(af+1)
       do i=1,nsize_rho
          om(imapom(i),is) = rho(i,is)
       end do
    end do
    call symmetrize(om)

  contains

    subroutine symmetrize(om)
      real(kind=DP), intent(inout) :: om(max2lp,max2lp,max_projs,natm,nspin)

      do is=1,nspin,(af+1)
         do ia=1,natm
            ig = iproj_group(ia)
            if(ig<1) cycle
            do i=1,num_proj_elems(ig)
               ip=proj_group(i,ig)
               it = proj_attribute(ip)%ityp
               do m2=1,i2lp(ip)
                  do m1=m2,i2lp(ip)
                     if(m1/=m2) om(m2,m1,i,ia,is) = om(m1,m2,i,ia,is)
                  end do
               end do
            end do
         end do
      end do
    end subroutine symmetrize

  end subroutine map_rho_to_om

! ==================================== added by K. Tagami ================ 11.0
  subroutine map_rho_to_om_noncl(om,om_aimag,rho)
    real(kind=DP), intent(out) :: om(max2lp*max2lp*max_projs*natm,ndim_magmom)
    real(kind=DP), intent(out) :: om_aimag(max2lp*max2lp*max_projs*natm,ndim_magmom)
    real(kind=DP), intent(in) :: rho(nsize_rho,ndim_magmom)

    integer :: i,is,ia,ig,ip,it,m1,m2

    om = 0.0d0;
    if ( sw_mix_imaginary_component == ON ) om_aimag = 0.0d0

    do is=1,ndim_magmom
       do i=1,nsize_rho_realpart
          om(imapom(i),is) = rho(i,is)
       end do
       do i=nsize_rho_realpart+1, nsize_rho
          om_aimag(imapom(i),is) = rho(i,is)
       end do
    end do

    call symmetrize(om,om_aimag)

  contains

    subroutine symmetrize(om,om_aimag)

      real(kind=DP), intent(inout) :: om(max2lp,max2lp,max_projs,natm,ndim_magmom)
      real(kind=DP), intent(inout) :: om_aimag(max2lp,max2lp,max_projs,natm,ndim_magmom)

      do is=1,ndim_magmom

         do ia=1,natm
            ig = iproj_group(ia)
            if(ig<1) cycle
            do i=1,num_proj_elems(ig)
               ip=proj_group(i,ig)
               it = proj_attribute(ip)%ityp
               do m2=1,i2lp(ip)
                  do m1=m2,i2lp(ip)
                     if(m1/=m2) then
                        om(m2,m1,i,ia,is) = om(m1,m2,i,ia,is)
                        if ( sw_mix_imaginary_component == ON ) then
                           om_aimag(m2,m1,i,ia,is) = -om_aimag(m1,m2,i,ia,is)
                        endif
                     endif
                  end do
               end do
            end do
         end do
      end do
    end subroutine symmetrize

  end subroutine map_rho_to_om_noncl
! ===================================================================== 11.0

!OCL SERIAL
  subroutine simple_mix(rmx)
    real(kind=DP), intent(in) :: rmx
    din   = rhoo ! chgqo
    dout  = rho  ! chgq
! ================================== modified by K. Tagami ========== 5.0
!!    rho = (rmx-1.d0)*din + rmx*dout
    rho = (1.0d0-rmx)*din + rmx*dout
! ==================================================================== 5.0
    call map_rho_to_om(ommix,rho)
  end subroutine simple_mix

! =================================== added by K. Tagami ============= 5.0
  subroutine simple_mix_kt(rmx_this)
    real(kind=DP), intent(in) :: rmx_this(nspin_m)
! === DEBUG by tkato 2011/11/19 ================================================
    integer :: i
! ==============================================================================

    din   = rhoo ! chgqo
    dout  = rho  ! chgq
! === DEBUG by tkato 2011/11/19 ================================================
!   rho(:,1) = rmx_this(1) *dout(:,1) + ( 1.0D0 - rmx_this(1) )* din(:,1)
!   rho(:,2) = rmx_this(2) *dout(:,2) + ( 1.0D0 - rmx_this(2) )* din(:,2)
    do i = 1, nspin_m
       rho(:,i) = rmx_this(i) *dout(:,i) + ( 1.0D0 - rmx_this(i) )* din(:,i)
    enddo
! ==============================================================================
!!!!!!!!!!!    call map_rho_to_om(ommix,rho)
  end subroutine simple_mix_kt

  subroutine simple_mix2_kt(rmx_this)
    real(kind=DP), intent(in) :: rmx_this(nspin_m)

    din(:,2)   = rhoo(:,2) ! chgqo
    dout(:,2)  = rho(:,2)  ! chgq
    rho(:,2) = rmx_this(2) *dout(:,2) + ( 1.0D0 - rmx_this(2) )* din(:,2)
!!!!!!!!!!    call map_rho_to_om(ommix,rho)
  end subroutine simple_mix2_kt
! ========================================================================= 5.0

  subroutine m_OP_cp_ommix_to_omold
    omold = ommix
! ========================= added by K. Tagami ============== 11.0
    if ( noncol ) omold_aimag = ommix_aimag
! =========================================================== 11.0
  end subroutine m_OP_cp_ommix_to_omold

  subroutine m_OP_cp_ommix_to_om
    om = ommix
! ========================= added by K. Tagami ============== 11.0
    if ( noncol ) om_aimag = ommix_aimag
! =========================================================== 11.0
  end subroutine m_OP_cp_ommix_to_om

  subroutine m_OP_simple_mixing(nfout,rmxt)
    integer, intent(in) :: nfout
    real(kind=DP), intent(in) :: rmxt
#ifdef __TIMER_SUB__
    call timer_sta(1141)
#endif

! =========================== modified by K. Tagami =========== 11.0
!    ommix = (1.d0-rmxt)*ommix + rmxt*om
!    if(printable) then
!       write(nfout,*) '=== <Mixed occ. mat. 2> ==='
!       call wd_occ_mat(ommix)
!    end if
!
    if ( noncol ) then
       ommix = (1.d0-rmxt)*ommix + rmxt*om
       if ( sw_mix_imaginary_component ==  ON ) then
          ommix_aimag = (1.d0-rmxt)*ommix_aimag + rmxt*om_aimag
       endif

       if(printable) then
          if(iprihubbard>1) then
             write(nfout,*) '=== <Mixed occ. mat. 2> ==='
             call wd_occ_mat_noncl(ommix,ommix_aimag)
          endif
       end if
    else
       ommix = (1.d0-rmxt)*ommix + rmxt*om
       if(printable) then
          if(iprihubbard>1) then
             write(nfout,*) '=== <Mixed occ. mat. 2> ==='
             call wd_occ_mat(ommix)
          endif
       end if
    endif
! =============================================================== 11.0

#ifdef __TIMER_SUB__
    call timer_end(1141)
#endif
  end subroutine m_OP_simple_mixing

! ===================== added by K. Tagami ============================= 5.0
  subroutine m_OP_cp_om_to_ommix(nfout,rmxt)
    integer, intent(in) :: nfout
    real(kind=DP), intent(in) :: rmxt

! ================ modifiied by K. Tagami ======== 11.0
!    ommix = om
!    if(printable) then
!       write(nfout,*) '=== <Mixed occ. mat. 2A> ==='
!       call wd_occ_mat(ommix)
!    end if
!
    if ( noncol ) then
       ommix = om;  ommix_aimag = om_aimag
       if(printable) then
          if(iprihubbard>1) then
             write(nfout,*) '=== <Mixed occ. mat. 2A> ==='
             call wd_occ_mat_noncl(ommix,ommix_aimag)
          endif
       end if
    else
       ommix = om
       if(printable) then
          if(iprihubbard>1) then
             write(nfout,*) '=== <Mixed occ. mat. 2A> ==='
             call wd_occ_mat(ommix)
          endif
       end if
    endif
! ================================================ 11.0
  end subroutine m_OP_cp_om_to_ommix

  subroutine compose_rho_dealloc_store
    rho_store = rho

    rho(:,1) = 0.5*( rho_store(:,1) + rho_store(:,2) )
    rho(:,2) = 0.5*( rho_store(:,1) - rho_store(:,2) )

    rhoo = rhoo_store
    deallocate( rho_store, rhoo_store )
  end subroutine compose_rho_dealloc_store

  subroutine alloc_rhostore_recomp( rmxt, rmxtrc )
    real(kind=DP),intent(in) :: rmxt
    real(kind=DP),intent(out),dimension(nspin_m) :: rmxtrc

    allocate( rhoo_store( nsize_rho,nspin) )
    allocate( rho_store( nsize_rho,nspin) )

    rho_store = rho;      rhoo_store = rhoo

     rho(:,1) =  rho_store(:,1) +  rho_store(:,2)
     rho(:,2) =  rho_store(:,2) -  rho_store(:,2)
    rhoo(:,1) = rhoo_store(:,1) + rhoo_store(:,2)
    rhoo(:,2) = rhoo_store(:,2) - rhoo_store(:,2)

    rmxtrc(1) = rmxt;     rmxtrc(2) = rmxt*spin_density_mixfactor

  end subroutine alloc_rhostore_recomp

  subroutine mult1s5(u,mb,muv,j,iuv,v,f_q,fmult)
    integer,intent(in) :: mb,muv,j,iuv
    real(DP),intent(in), dimension(1:nsize_rho,nspin_m,mb,muv) :: u
    real(DP),intent(in), dimension(1:nsize_rho,nspin_m) :: v
    real(DP),intent(in), dimension(1:nsize_rho) :: f_q
    real(DP),intent(out),dimension(nspin_m)            :: fmult

    real(DP) :: p,  fac
    integer  :: is,i

    fmult = 0.d0
    do is = 1, ndim_magmom, af+1
       p = 0.d0
       fac=1.0d0
       do i = 1,nsize_rho
          if ( noncol ) then
             fac=f_q(i)
          else
             if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) then
                fac=f_q(i)
             endif
          end if
          p = p + fac*u(i,is,j,iuv)*v(i,is)
       end do
       fmult(is) = p
    enddo
  end subroutine mult1s5

  subroutine mult1s5_reduce_spin(u,mb,muv,j,iuv,v,f_q,fmult)
    integer,intent(in) :: mb,muv,j,iuv
    real(DP),intent(in), dimension(1:nsize_rho,nspin_m,mb,muv) :: u
    real(DP),intent(in), dimension(1:nsize_rho,nspin_m) :: v
    real(DP),intent(in), dimension(1:nsize_rho):: f_q
    real(DP),intent(out)            :: fmult

    real(DP) :: p,  fac
    integer  :: is,i

    fmult = 0.d0
    p = 0.d0

    do is = 1, ndim_magmom, af+1
       fac = 1.0d0
       do i = 1,nsize_rho
          if ( noncol ) then
             fac=f_q(i)
          else
             if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) then
                fac=f_q(i)
             endif
          end if
          p = p + fac*u(i,is,j,iuv)*v(i,is)
       end do
    enddo
    fmult = p
  end subroutine mult1s5_reduce_spin

  subroutine mult1s10(u,mb,muv,i,iu,v,j,iv,f_q,fmult)
    integer,intent(in) :: mb,muv,i,iu,j,iv
    real(DP),intent(in), dimension(1:nsize_rho,nspin_m,mb,muv) :: u,v
    real(DP),intent(in), dimension(1:nsize_rho):: f_q
    real(DP),intent(out),dimension(nspin_m)            :: fmult

    real(DP) :: p,  fac
    integer  :: is,ig
    fmult = 0.d0

    do is = 1, ndim_magmom, af+1
       p = 0.d0
       fac = 1.0d0
       do ig = 1,nsize_rho
          if ( noncol ) then
             fac=f_q(ig)
          else
             if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) then
                fac=f_q(ig)
             endif
          end if
          p = p + fac*u(ig,is,i,iu)*v(ig,is,j,iv)
       end do
       fmult(is) = p
    enddo
  end subroutine mult1s10

  subroutine mult1s10_reduce_spin(u,mb,muv,i,iu,v,j,iv,f_q,fmult)
    integer,intent(in) :: mb,muv,i,iu,j,iv
    real(DP),intent(in), dimension(1:nsize_rho,nspin_m,mb,muv) :: u,v
    real(DP),intent(in), dimension(1:nsize_rho):: f_q
    real(DP),intent(out)            :: fmult

    real(DP) :: p,  fac
    integer  :: is,ig

    fmult = 0.d0
    p = 0.d0

    do is = 1, ndim_magmom, af+1
       fac = 1.0d0
       do ig = 1,nsize_rho

          if ( noncol ) then
             fac=f_q(ig)
          else
             if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) then
                fac=f_q(ig)
             endif
          end if
          p = p + fac*u(ig,is,i,iu)*v(ig,is,j,iv)
       end do
    enddo
    fmult = p
  end subroutine mult1s10_reduce_spin

! ================================================================= 5.0
  subroutine m_OP_occ_mat_isotropic(nfout)
    integer, intent(in) :: nfout
!
    om = 0.0d0
    if ( noncol ) then
       call case_noncol
       call wd_occ_mat_noncl(om,om_aimag)
    else
       call case_col
       call wd_occ_mat(om)
    endif

  contains

    subroutine case_noncol
      integer :: ia, ih, it, ie, l1, immax, im1
      real(kind=DP) :: fac(4), chg1, chg2, cnorm

      Do ia=1, natm
         ih = ihubbard(ia)
         if ( ih == 0 ) cycle

         it = ityp(ia)
         ie = proj_attribute(ih)%ielem
         l1 = proj_attribute(ih)%l
         immax = 2*l1 +1

         chg1 = ( proj_attribute(ih)%initial_spin_sum &
              & +proj_attribute(ih)%initial_spin_diff ) /2.0d0
         chg2 = ( proj_attribute(ih)%initial_spin_sum &
              & -proj_attribute(ih)%initial_spin_diff ) /2.0d0
!
         fac = 0.0d0
         fac(1) = 1.0d0;  fac(ndim_magmom) = 0.0d0

         if ( mag_moment0_atoms_is_defined ) then
            cnorm = sqrt( mag_moment0_atoms(ia,1)**2 &
                  &      +mag_moment0_atoms(ia,2)**2 &
                  &      +mag_moment0_atoms(ia,3)**2 )
            if ( cnorm > 0.0d0 ) then
               fac(2) = mag_moment0_atoms(ia,1) /cnorm
               fac(3) = mag_moment0_atoms(ia,2) /cnorm
               fac(4) = mag_moment0_atoms(ia,3) /cnorm
            endif
         else
            cnorm = sqrt( mag_moment0_atomtyp(it,1)**2 &
                  &      +mag_moment0_atomtyp(it,2)**2 &
                  &      +mag_moment0_atomtyp(it,3)**2 )
            if ( cnorm > 0.0d0 ) then
               fac(2) = mag_moment0_atomtyp(it,1) /cnorm
               fac(3) = mag_moment0_atomtyp(it,2) /cnorm
               fac(4) = mag_moment0_atomtyp(it,3) /cnorm
            endif
         endif

         Do im1=1, immax
            om(im1,im1,ie,ia,1) = chg1 /dble(immax) *fac(1)
            om(im1,im1,ie,ia,2) = chg2 /dble(immax) *fac(2)
            om(im1,im1,ie,ia,3) = chg2 /dble(immax) *fac(3)
            om(im1,im1,ie,ia,4) = chg2 /dble(immax) *fac(4)
         End Do
      end Do
    end subroutine case_noncol

    subroutine case_col
      integer :: ia, ih, it, ie, l1, immax, im1
      real(kind=DP) :: fac, chg1, chg2

      Do ia=1, natm
         ih = ihubbard(ia)
         if ( ih == 0 ) cycle

         it = ityp(ia)
         ie = proj_attribute(ih)%ielem
         l1 = proj_attribute(ih)%l
         immax = 2*l1 +1

         fac = 1.0d0
         if ( mag_moment0_atoms_is_defined ) then
            if ( mag_moment0_atoms(ia,1) < 0.0 ) fac = -1.0d0
         else
            if ( mag_moment0_atomtyp(it,1) < 0.0 ) fac = -1.0d0
         endif

         chg1 = ( proj_attribute(ih)%initial_spin_sum &
              & + fac *proj_attribute(ih)%initial_spin_diff ) /2.0d0
         chg2 = ( proj_attribute(ih)%initial_spin_sum &
              & - fac *proj_attribute(ih)%initial_spin_diff ) /2.0d0

         if ( nspin == 2 ) then
            Do im1=1, immax
               om(im1,im1,ie,ia,1) = chg1 /dble(immax)
               om(im1,im1,ie,ia,2) = chg2 /dble(immax)
            End Do
         else
            call phase_error_with_msg(nfout,"UUU",__LINE__,__FILE__)
         endif
      end Do

    end subroutine case_col

  end subroutine m_OP_occ_mat_isotropic

  subroutine m_OP_occ_mat_gen_kt(nfout)
    integer, intent(in) :: nfout

    integer :: lcmax, msph_max
    integer, allocatable :: isph2(:,:,:), mmt2(:,:), il3(:)

    real(kind=DP), allocatable :: A_lm(:), rr_exp(:,:)
    real(kind=DP), allocatable :: cr2(:,:,:)
    real(kind=DP), allocatable :: elec_negativity(:)
!
    integer :: sw_use_elec_negativity = ON

    lcmax = 4
#ifdef LMAX_SPH_EQ_6
    if ( nloc == 4 ) lcmax = 6
#endif
    msph_max = ( lcmax +1 )**2

#ifdef LMAX_SPH_EQ_6
    allocate( cr2(  16,16,7) ); cr2 = 0.0d0
    allocate( isph2(16,16,7) ); isph2 = 0.0d0
    allocate( mmt2( 16,16)   ); mmt2 = 0
    call sphset_upto_L6( cr2, isph2, mmt2 )
#else
    allocate( cr2(  16,16,6) ); cr2 = 0.0d0
    allocate( isph2(16,16,6) ); isph2 = 0.0d0
    allocate( mmt2( 16,16)   ); mmt2 = 0
    call sphset2(nfout,ipri,lcmax,cr2,isph2,mmt2)
#endif

    allocate( il3(msph_max));call substitute_il3( msph_max, il3 )
    allocate( A_lm(msph_max) ); A_lm = 0.0d0
    allocate( rr_exp(0:lcmax,ntyp) ); rr_exp = 0.0d0
!
    call set_r_exp( rr_exp )

    if ( sw_use_elec_negativity == ON ) then
       allocate( elec_negativity(ntyp) )
       call set_electronegativity( ntyp, iatomn, elec_negativity )
    endif

    if ( noncol ) then
       call set_occmat_noncol
    else
       call set_occmat_col
    endif

    deallocate(il3)
    deallocate(cr2); deallocate(isph2);  deallocate(mmt2)
    deallocate(A_lm); deallocate(rr_exp)
    if ( sw_use_elec_negativity == ON ) deallocate(elec_negativity)

  contains

    subroutine set_occmat_col
      integer :: ia, ih, it, l1, immax, ie, is, n1, im1, im2
      integer :: nocc, count
      real(kind=DP) :: chg1, chg2, fac
      real(kind=DP), allocatable :: mat_wk(:,:), eigval(:), eigvec(:,:)
      real(kind=DP), allocatable :: weight(:)

      Do ia=1, natm
         ih = ihubbard(ia)
         if ( ih == 0 ) cycle

         it = ityp(ia)
         call set_mat_Alm( ia, A_lm )

         l1 = proj_attribute(ih)%l
         immax = 2*l1 +1

         allocate( mat_wk(immax,immax) )
         allocate( eigval(immax) );   allocate( eigvec(immax,immax) )
         allocate( weight(immax) );

         call set_mat_crystal_field_pot( it, l1, immax, mat_wk )
         call diagonalize( immax, mat_wk, eigval, eigvec )
!
         ie = proj_attribute(ih)%ielem
!
         fac = 1.0d0
         if ( mag_moment0_atoms_is_defined ) then
            if ( mag_moment0_atoms(ia,1) < 0.0 ) fac = -1.0d0
         else
            if ( mag_moment0_atomtyp(it,1) < 0.0 ) fac = -1.0d0
         endif
            !
         chg1 = ( proj_attribute(ih)%initial_spin_sum &
              & + fac *proj_attribute(ih)%initial_spin_diff ) /2.0d0
         chg2 = ( proj_attribute(ih)%initial_spin_sum &
              & - fac *proj_attribute(ih)%initial_spin_diff ) /2.0d0

         Do is=1, nspin
            mat_wk = 0.0d0
            if ( is==1 ) then
               nocc = nint( chg1 )
            else
               nocc = nint( chg2 )
            endif

            Do n1=1, immax
               if( n1 <= nocc ) then
                  weight(n1) = 1.0d0
               else
                  weight(n1) = 0.0d0
               endif
            End Do

            Do n1=1, immax
               Do im1=1, immax
                  Do im2=1, immax
                     mat_wk(im1,im2) = mat_wk(im1,im2) +eigvec(im1,n1)*eigvec(im2,n1) &
                          &                            *weight(n1)
                  End do
               End Do
            End do
            om(1:immax,1:immax,ie,ia,is) = mat_wk(1:immax,1:immax)
         End do
         deallocate( mat_wk )
         deallocate( eigvec );    deallocate( eigval )
         deallocate( weight )
      End Do
      call wd_occ_mat(om)

    end subroutine set_occmat_col

    subroutine set_occmat_noncol
      integer :: ia, ih, it, l1, immax, ie, is, n1, im1, im2
      integer :: nocc, count
      real(kind=DP) :: fac(ndim_magmom), cnorm, chg1, chg2
      real(kind=DP), allocatable :: mat_wk(:,:,:), eigval(:), eigvec(:,:)
      real(kind=DP), allocatable :: weight(:)

      Do ia=1, natm
         ih = ihubbard(ia)
         if ( ih == 0 ) cycle

         it = ityp(ia)
         call set_mat_Alm( ia, A_lm )

         l1 = proj_attribute(ih)%l
         immax = 2*l1 +1

         allocate( mat_wk(immax,immax,nspin) )
         allocate( eigval(immax) );   allocate( eigvec(immax,immax) )
         allocate( weight(immax) );

         call set_mat_crystal_field_pot( it, l1, immax, mat_wk )
         call diagonalize( immax, mat_wk, eigval, eigvec )
!
         ie = proj_attribute(ih)%ielem
!
         chg1 = ( proj_attribute(ih)%initial_spin_sum &
              & +proj_attribute(ih)%initial_spin_diff ) /2.0d0
         chg2 = ( proj_attribute(ih)%initial_spin_sum &
              & -proj_attribute(ih)%initial_spin_diff ) /2.0d0

         mat_wk = 0.0d0
         Do is=1, nspin
            if ( is==1 ) then
               nocc = nint( chg1 )
            else
               nocc = nint( chg2 )
            endif

            Do n1=1, immax
               if( n1 <= nocc ) then
                  weight(n1) = 1.0d0
               else
                  weight(n1) = 0.0d0
               endif
            End Do

            Do n1=1, immax
               Do im1=1, immax
                  Do im2=1, immax
                     mat_wk(im1,im2,is) = mat_wk(im1,im2,is) &
                          &              +eigvec(im1,n1)*eigvec(im2,n1) &
                          &                             *weight(n1)
                  End do
               End Do
            End do
         end Do

         fac = 0.0d0
         fac(1) = 1.0d0;  fac(ndim_magmom) = 0.0d0

         if ( mag_moment0_atoms_is_defined ) then
            cnorm = sqrt( mag_moment0_atoms(ia,1)**2 &
                  &      +mag_moment0_atoms(ia,2)**2 &
                  &      +mag_moment0_atoms(ia,3)**2 )
            if ( cnorm > 0.0d0 ) then
               fac(2) = mag_moment0_atoms(ia,1) /cnorm
               fac(3) = mag_moment0_atoms(ia,2) /cnorm
               fac(4) = mag_moment0_atoms(ia,3) /cnorm
            endif
         else
            cnorm = sqrt( mag_moment0_atomtyp(it,1)**2 &
                  &      +mag_moment0_atomtyp(it,2)**2 &
                  &      +mag_moment0_atomtyp(it,3)**2 )
            if ( cnorm > 0.0d0 ) then
               fac(2) = mag_moment0_atomtyp(it,1) /cnorm
               fac(3) = mag_moment0_atomtyp(it,2) /cnorm
               fac(4) = mag_moment0_atomtyp(it,3) /cnorm
            endif
         endif

         om(1:immax,1:immax,ie,ia,1) = ( mat_wk(1:immax,1:immax,1) &
              &                         +mat_wk(1:immax,1:immax,2) )
         Do is=2, ndim_magmom
            om(1:immax,1:immax,ie,ia,is) = ( mat_wk(1:immax,1:immax,1) &
                 &                         -mat_wk(1:immax,1:immax,2) ) *fac(is)
         End Do
         deallocate( mat_wk )
         deallocate( eigvec );    deallocate( eigval )
         deallocate( weight )
      End Do
      call wd_occ_mat_noncl(om,om_aimag)

    end subroutine set_occmat_noncol

    subroutine set_r_exp( rr_exp )        ! <r^l>
      real(kind=DP), intent(out) :: rr_exp(0:lcmax,ntyp)

      integer :: ia, ih, it, il1, l1, ir, ierr
      real(kind=DP) :: rr, c1, c2
      real(kind=DP), allocatable :: wos(:)

      allocate( wos(mmesh) ); wos = 0.0d0

      Do it=1, ntyp
         AtomLoop: Do ia=1, natm
            if ( ityp(ia) /= it ) cycle

            ih = ihubbard(ia)
            if ( ih == 0 ) cycle

            l1 = proj_attribute(ih)%l +1

            call set_weight_exp( ierr, 1, nmesh(it), radr_paw(:,it), wos )
            c1 = 0.0D0
            Do ir=1, nmesh(it)
               c1 = c1 +wos(ir) *psirpw(ir,l1,1,it) **2
            End Do

            if ( c1 > 1.1D0 ) then        ! unbound
            else
               Do il1=0, lcmax
                  c2 = 0.0d0
                  Do ir=1, nmesh(it)
                     rr = radr_paw(ir,it)
                     c2 = c2 +wos(ir) *psirpw(ir,l1,1,it) **2 *rr**(il1)
                  End do
                  rr_exp(il1,it) = c2
               End Do
            endif
            exit AtomLoop
         End do AtomLoop
      End Do
      deallocate( wos )
    end subroutine set_r_exp

    subroutine set_mat_Alm( ia, A_lm )
      integer, intent(in) :: ia
      real(kind=DP) :: A_lm(msph_max)

      integer :: nxmax, nymax, nzmax
      integer :: nx, ny, nz, ja, jt, l1, ilm1, it
      real(kind=DP) :: factor, x1, y1, z1, dist, rcut, q, c1, dist_min

      factor = 1.2
      nxmax = 1;   nymax = 1;     nzmax = 1

      A_lm = 0.0d0

      it = ityp(ia)
      dist_min = 1.0D2

      Do nz=-nzmax, nzmax
         Do ny=-nymax, nymax
            Do nx=-nxmax, nxmax
               Do ja=1, natm
                  jt = ityp(ja)
                  if ( it == jt ) cycle
                  x1 = cps(ja,1) -cps(ia,1) + nx*altv(1,1) +ny*altv(1,2) +nz*altv(1,3)
                  y1 = cps(ja,2) -cps(ia,2) + nx*altv(2,1) +ny*altv(2,2) +nz*altv(2,3)
                  z1 = cps(ja,3) -cps(ia,3) + nx*altv(3,1) +ny*altv(3,2) +nz*altv(3,3)
                  dist = sqrt( x1*x1 +y1*y1 +z1*z1 )
                  dist_min = min( dist_min, dist )
               End Do
            End Do
         End Do
      End Do
      rcut = dist_min *factor

      Do nz=-nzmax, nzmax
         Do ny=-nymax, nymax
            Do nx=-nxmax, nxmax
               Do ja=1, natm
                  jt = ityp(ja)
                  if ( it == jt ) cycle
                  x1 = cps(ja,1) -cps(ia,1) + nx*altv(1,1) +ny*altv(1,2) +nz*altv(1,3)
                  y1 = cps(ja,2) -cps(ia,2) + nx*altv(2,1) +ny*altv(2,2) +nz*altv(2,3)
                  z1 = cps(ja,3) -cps(ia,3) + nx*altv(3,1) +ny*altv(3,2) +nz*altv(3,3)
                  dist = sqrt( x1*x1 +y1*y1 +z1*z1 )

                  if ( dist > 0.1 .and. dist < rcut ) then
                     if ( sw_use_elec_negativity == OFF ) then

                        if ( sw_set_initial_magmom_by_atom == ON ) then
                           if ( mag_moment0_atoms_is_defined ) then
                              q = ionic_charge_atoms(ja)
                           else
                              q = ionic_charge_atomtyp(jt)
                           endif
                        else
                           q = ionic_charge_atomtyp(jt)
                        endif

                     else
                        q = -( elec_negativity(jt) -elec_negativity(it) )
                     endif
                     Do ilm1=1, msph_max
                        l1 = il3(ilm1)
                        call sphr_general( 1, ilm1, x1, y1, z1, c1 )
                        A_lm(ilm1) = A_lm(ilm1) -q *PAI4 /(2*l1 +1) /dist**(l1 +1)*c1
                     End do
                  endif

               End Do
            End do
         End do
      End do
    end subroutine set_mat_Alm

    subroutine set_mat_crystal_field_pot( it, l1, size1, mat )
      integer, intent(in) :: it, l1, size1
      real(kind=DP) :: mat( size1,size1 )

      integer :: nsph1, nsph2, nsph_min, nsph_max
      integer :: ilm3, n, l3
      real(kind=DP) :: c1, gaunt, rad_avg

      nsph_min = l1**2 +1;   nsph_max = ( l1+1 ) **2

      mat = 0.0d0
      Do nsph1=nsph_min, nsph_max
         Do nsph2=nsph_min, nsph_max
            c1 = 0.0d0
            Do n=1, mmt2(nsph1,nsph2)
               ilm3 = isph2(nsph1,nsph2,n); l3=il3(ilm3)
               gaunt = cr2(nsph1,nsph2,n)
               rad_avg = rr_exp( l3, it )
               c1 = c1 +rad_avg *A_lm(ilm3) *gaunt
            End Do
            mat(nsph1 -nsph_min +1,nsph2 -nsph_min +1) = c1
         End Do
      ENd Do
    end subroutine set_mat_crystal_field_pot

    subroutine diagonalize( immax, mat, eigval, eigvec )
      integer, intent(in) :: immax
      real(kind=DP), intent(in) :: mat( immax, immax )
      real(kind=DP), intent(out) :: eigval(immax), eigvec(immax,immax)

      integer :: lwork,info
      real(kind=DP) :: abstol,nfound, ctmp
      integer, allocatable :: iwork(:),ifail(:)
      real(kind=DP), allocatable :: rwork(:)
      real(kind=DP), external :: dlamch

      abstol = 2*dlamch('S')
      lwork = 8 *immax
      allocate( rwork(lwork) );
      allocate( iwork(5*immax) );   allocate( ifail(immax) )

      call dsyevx( 'V', 'A', 'U', immax, mat, immax, 0.d0, 0.d0, 0, 0, &
           &       abstol, nfound, eigval, eigvec, immax, rwork, lwork, &
           &       iwork, ifail, info )
      !
      if (info /= 0) then
         write(nfout,*) 'dsyevx: info=',info
      end if
      deallocate( rwork );   deallocate( iwork );   deallocate( ifail )
    end subroutine diagonalize

  end subroutine m_OP_occ_mat_gen_kt

! ********************
! https://en.wikipedia.org/wiki/Electronegativity
! ********************
  subroutine set_electronegativity( ntyp, iatomn, elec_negativity )
    integer, intent(in) :: ntyp
    real(kind=DP), intent(in) :: iatomn(ntyp)
    real(kind=DP), intent(inout) :: elec_negativity(ntyp)
    !
    integer :: nmax_elem = 120
    !
    integer :: it, i
    real(kind=DP), allocatable :: elec_negativity_table(:)

    allocate( elec_negativity_table( nmax_elem ) )
    elec_negativity_table = 0.0d0

    call set_table(  1, 2.20, 0.00, 0.98, 1.57, 2.04, 2.55, 3.04, 3.44, 3.98, 0.00 )
    call set_table( 11, 0.93, 1.31, 1.61, 1.90, 2.19, 2.58, 3.16, 0.00, 0.82, 1.00 )
    call set_table( 21, 1.36, 1.54, 1.63, 1.66, 1.55, 1.83, 1.88, 1.91, 1.90, 1.65 )
    call set_table( 31, 1.81, 2.01, 2.18, 2.55, 2.96, 3.00, 0.82, 0.95, 1.22, 1.33 )
    call set_table( 41, 1.60, 2.16, 1.90, 2.20, 2.28, 2.20, 1.93, 1.69, 1.78, 1.96 )
    call set_table( 51, 2.05, 2.10, 2.66, 2.60, 0.79, 0.89, 1.10, 1.12, 1.13, 1.14 )
    call set_table( 61, 1.13, 1.17, 1.20, 1.20, 1.20, 1.22, 1.23, 1.24, 1.25, 1.10 )
    call set_table( 71, 1.27, 1.30, 1.50, 2.36, 1.90, 2.20, 2.20, 2.28, 2.54, 2.00 )
    call set_table( 81, 1.62, 2.33, 2.02, 2.00, 2.20, 0.00, 0.70, 0.89, 1.10, 1.30 )
    call set_table( 91, 1.50, 1.38, 1.36, 1.28, 1.30, 1.30, 1.30, 1.30, 1.30, 1.30 )

    Do it=1, ntyp
       i = nint( iatomn(it) )
       elec_negativity(it) = elec_negativity_table(i)
    End do
    deallocate( elec_negativity_table )

  contains

    subroutine set_table( istart, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10 )
      integer, intent(in) :: istart
      real(kind=SP), intent(in) :: c1, c2, c3, c4, c5, c6, c7, c8, c9, c10

      elec_negativity_table( istart   ) = dble(c1)
      elec_negativity_table( istart+1 ) = dble(c2)
      elec_negativity_table( istart+2 ) = dble(c3)
      elec_negativity_table( istart+3 ) = dble(c4)
      elec_negativity_table( istart+4 ) = dble(c5)
      elec_negativity_table( istart+5 ) = dble(c6)
      elec_negativity_table( istart+6 ) = dble(c7)
      elec_negativity_table( istart+7 ) = dble(c8)
      elec_negativity_table( istart+8 ) = dble(c9)
      elec_negativity_table( istart+9 ) = dble(c10)
    end subroutine set_table

  end subroutine set_electronegativity

end module m_Orbital_Population

#define INDEX_L_ORDER_CONFLICT
!!$#define LDOShardpartsub3
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  MODULE: m_Ldos
!
!  AUTHOR(S): T. Yamasaki   January/18/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
module m_Ldos
! $Id: m_Ldos.F90 633 2020-12-01 05:11:03Z jkoga $
  use m_Const_Parameters, only   : DP, CMPLDP, REGULAR_INTERVALS, BY_ATOMIC_POSITIONS &
       &                         , DELTA10, EXECUT, ON, SOFTPART, HARDPART, DIRECT, PAI2 &
       &                         , ALDOS, LAYERDOS, NO, OFF, ELECTRON, BOHR
  use m_Control_Parameters, only : kimg, sw_aldos, sw_layerdos, crtdst_aldos, naldos_from, naldos_to &
       &                         , slicing_way_winlay, deltaz_winlay, normal_axis_winlay &
       &                         , crtdst_winlay,crtdst_is_given, nspin, neg, ipridos,ekmode &
       &                         , af, printable, hardpart_subroutine, sw_rspace_ldos, sw_save_ldos_weight &
       &                         , integration_dimension_winlay, sw_checksum &
       &                         , m_CtrlP_check_naldos_range &
       &                         , sw_ac_mesh, acmesh_factor, ipriparallel, sw_modified_kpoint_increment
  use m_Files, only              : nfout, nfldos, nfwfk_local_decomp &
       &                         , m_Files_open_nfldos, m_Files_close_nfldos
  use m_Crystal_Structure, only :  altv, rltv, univol
  use m_Ionic_System,   only :     natm2,natm,cps,numlay,ityp,iwei,if_aldos,pos
  use m_Parallelization, only :    ista_e,iend_e,istep_e, np_e, map_z, npes, ierr, mype &
       &                         , map_k, myrank_k, map_ek, ista_kngp, iend_kngp, ista_k, iend_k &
       &                         , nrank_e, nrank_k, myrank_e, map_e, mpi_k_world &
       &                         , MPI_CommGroup, ista_atm2, iend_atm2, m_Parallel_init_mpi_atm2 &
       &                         , nis_kv3_ek
  use m_Kpoints, only :            kv3, kv3_ek
  use m_FFT, only :                nfft, nfftp,nfftp_nonpara, fft_box_size_WF, fft_box_size_CD &
       &                         , fft_box_size_CD_nonpara &
       &                         , m_FFT_alloc_CD_box, m_FFT_dealloc_CD_box &
       &                         , m_FFT_CD_inverse0,   m_FFT_WF &
       &                         , m_FFT_CD_inverse &
       &                         , m_FFT_alloc_WF_work, m_FFT_dealloc_WF_work, m_FFT_CD_direct0
  use m_PlaneWaveBasisSet, only :  kg, igf, ngabc, kgp, kg1
  use m_PseudoPotential, only :    modnrm
!$$  use m_Electronic_Structure,only :neordr, totch, efermi &
!$$       &                         , m_ES_WF_in_Rspace &
!$$       &                         , m_ES_wd_zaj_small_portion
  use m_Electronic_Structure,only :neordr, totch, efermi
!$$#ifndef PARA3D
  use m_Electronic_Structure,only :m_ES_WF_in_Rspace, m_ES_WF_in_Rspace_kt &
       &                         , m_ES_wd_zaj_small_portion, zaj_l
!$$#endif
  use m_Charge_Density, only :     chgq_l, chgq_enl &
       &                         , m_CD_hardpart_sub &
       &                         , m_CD_hardpart_sub2 &
       &                         , m_CD_map_chgqenl_to_fft_box &
       &                         , m_CD_map_valence_charge_to_fft_box &
       &                         , m_CD_map_fft_box_to_chgqenl &
       &                         , m_CD_restore_chgq &
       &                         , m_CD_cp_chgq_to_chgqo & !ASMS
       &                         , m_CD_map_chgq_to_fft_box &
       &                         , m_CD_set_ylm_enl_etc &
       &                         , m_CD_dealloc_ylm_enl_etc &
       &                         , m_CD_keep_retrieve_hsr

! ============================== added by K. Tagami ============== 11.0
  use m_Control_Parameters,    only : noncol, ndim_magmom, ndim_spinor, sw_ldos
  use m_Charge_Density, only :    m_CD_hardpart_sub_noncl, &
       &                          m_CD_hardpart_sub2_noncl, &
       &                          m_CD_map_chgqenl_to_fft_box_kt, &
       &                          m_CD_hardpart_sub2_rs
! ================================================================ 11.0

  use m_Control_Parameters,   only : num_extra_bands, sw_rspace_lband, &
       &                             sw_calc_wf_atom_decomposition, &
       &                             sw_calc_wf_layer_decomposition, sw_lband, &
       &                             sw_wd_only_specified_atoms, &
       &                             sw_band_unfolding, band_unfolding_active

  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use mpi

  implicit none

  integer, private, target, allocatable, dimension(:,:,:) ::  mesh, meshp, meshl, meshpl

  integer ::  nlayer = 0
  integer ::  mlayer = 1
  integer ::  naldos = 0
  integer, private :: naldos_write = 0
  integer ::  maldos = 1
  integer, private ::  n_total_ldoscal = 0
  real(kind=DP),private,allocatable,dimension(:,:)  :: winlay ! d(mlayer,2)
  integer, private, allocatable, dimension(:)       :: nmeshlay, nmeshplay ! d(mlayer)
!  real(kind=DP),public,allocatable,dimension(:,:,:,:) :: weiwsc ! d(maldos,neg|np_e,1|ista_k:iend_k,nspin)
!  real(kind=DP),public,allocatable,dimension(:,:,:,:) :: weilay ! d(mlayer,neg|np_e,1|ista_k:iend_k,nspin)
  real(kind=DP),public,allocatable,dimension(:,:,:) :: weiwsc ! d(maldos,neg|np_e,1|ista_k:iend_k)
  real(kind=DP),public,allocatable,dimension(:,:,:) :: weilay ! d(mlayer,neg|np_e,1|ista_k:iend_k)
!  real(kind=DP),private,allocatable,dimension(:) ::    bfft   ! d(nfft)
  real(kind=DP),private :: maxhv, maxv
  real(kind=DP),private :: height
  integer,private,allocatable,dimension(:) :: if_aldos_full ! d(natm2)

  character(len("HARDPART")), private, dimension(2) :: tag_Hard_or_Soft = (/'SOFTPART','HARDPART'/)

! ============================= added by K. Tagami ===================== 11.0
  real(kind=DP),public,allocatable,dimension(:,:,:,:) :: weiwsc_noncl
  real(kind=DP),public,allocatable,dimension(:,:,:,:) :: weilay_noncl
! ====================================================================== 11.0

  integer, parameter :: ilen = 5

  integer, allocatable, target, dimension(:,:,:) :: ac_mesh,ac_mesh_cd
  integer, allocatable, target, dimension(:) :: nac_mesh,nac_mesh_cd

  real(kind=DP), allocatable, dimension(:,:,:,:) :: dos_weight_ek

  integer :: natom_decomp
  integer, allocatable :: atom_decomp_map(:)

!  include 'mpif.h'
  integer istatus(mpi_status_size)

contains
  integer function m_Ldos_what_is_n_total_ldos()
!!$    m_Ldos_what_is_n_total_ldos = n_total_ldos
    m_Ldos_what_is_n_total_ldos = naldos_write + mlayer
  end function m_Ldos_what_is_n_total_ldos

  subroutine m_Ldos_preparation()

    if(sw_aldos == ON .or. sw_calc_wf_atom_decomposition==ON ) then
       call set_naldos()      ! -> naldos, maldos
       call m_CtrlP_check_naldos_range(nfout,maldos)
!!$       call check_naldos_range()
       call set_if_aldos_full()
       call set_naldos_write()
       call alloc_mesh()
       call fillup_mesh(fillmode=ALDOS)
    end if
    if ( sw_calc_wf_atom_decomposition==ON ) call set_natom_decomp()

    call set_nlayer()
    if(sw_layerdos == ON .or. sw_calc_wf_layer_decomposition==ON ) then
       call alloc_winlay()
       call set_winlay()
       if(integration_dimension_winlay==3) then
          call alloc_meshl()
!!$          call fillup_meshl(fillmode=LAYERDOS)
          call fillup_mesh(fillmode=LAYERDOS)
       end if
!!$       call dealloc_winlay()
    end if
  end subroutine m_Ldos_preparation

  subroutine set_naldos()
    naldos = natm2
    maldos = naldos + 1
  end subroutine set_naldos

!!$  subroutine check_naldos_range()
!!$    if(naldos_from == 0 .and. naldos_to == 0) then
!!$       naldos_from = 1
!!$       naldos_to   = maldos
!!$    else
!!$       if(naldos_from < 1)     naldos_from = 1
!!$       if(naldos_from > maldos) naldos_from = maldos
!!$       if(naldos_to < 1)       naldos_to   = 1
!!$       if(naldos_to > maldos)   naldos_to   = maldos
!!$       if(naldos_to < naldos_from) naldos_to = naldos_from
!!$    end if
!!$    write(nfout,'(" !!ldos naldos_from         = ",i6," <<check_naldos_range>>")') naldos_from
!!$    write(nfout,'(" !!ldos naldos_to           = ",i6," <<check_naldos_range>>")') naldos_to
!!$  end subroutine check_naldos_range

  subroutine set_if_aldos_full()
    integer, allocatable, dimension(:) :: ip_atom
    integer :: i, nb

    if(.not.allocated(if_aldos_full)) allocate(if_aldos_full(naldos_from:naldos_to))
    if(.not.allocated(ip_atom)) allocate(ip_atom(natm2+1)); ip_atom = 0

    nb = natm
    do i = 1, natm
       ip_atom(i) = i
       if(iwei(i) == 2) then
          nb = nb + 1
          ip_atom(nb) = i
       end if
    end do

    do i = 1, natm2
       if(ip_atom(i) == 0) then
          if(ipridos>=1) write(nfout,'(" !!ldos i, ip_atom = ",i5,i5)') i,ip_atom(i)
          call phase_error_with_msg(nfout,' ip_atom is illegal <<set_if_aldos_full>>',__LINE__,__FILE__)
       end if
    end do

    if_aldos_full = OFF
    do i = naldos_from, naldos_to
       if(i <= natm2) then
          if_aldos_full(i) = if_aldos(ip_atom(i))
       else
          if_aldos_full(i) = ON
       end if
    end do
    
    nb = 0
    ip_atom = 0
    do i = naldos_from, naldos_to
       if(if_aldos_full(i) == ON) then
          nb = nb + 1
          ip_atom(nb) = i
       end if
    end do
    if(ipridos>=1) write(nfout,'(" !!ldos aldos_atoms = ",10i5)') (ip_atom(i),i=1,nb)

    deallocate(ip_atom)
  end subroutine set_if_aldos_full

  subroutine set_naldos_write()
    integer :: i
    naldos_write = 0
    do i = naldos_from, naldos_to
       if(if_aldos_full(i) == ON) naldos_write = naldos_write + 1
    end do
    if(ipridos>=1) write(nfout,'(" !!ldos naldos_write = ",i5)') naldos_write
!!$    naldos_write = naldos_to - naldos_from + 1
  end subroutine set_naldos_write

  subroutine set_natom_decomp()
    integer :: i

    natom_decomp = 0
    if ( sw_wd_only_specified_atoms == ON ) then
       do i = 1, natm2
          if(if_aldos_full(i) == ON) natom_decomp = natom_decomp +1
       end do
    else
       natom_decomp = natm2
    endif

    allocate( atom_decomp_map(natom_decomp+1) )

    natom_decomp = 0
    if ( sw_wd_only_specified_atoms == ON ) then
       do i = 1, natm2
          if(if_aldos_full(i) == ON) natom_decomp = natom_decomp +1
          atom_decomp_map( natom_decomp ) = i
       end do
    else
       do i = 1, natm2
          natom_decomp = natom_decomp +1
          atom_decomp_map( natom_decomp ) = i
       end do
    endif
    atom_decomp_map( natom_decomp +1 ) = natm2 +1

  end subroutine set_natom_decomp

  subroutine set_nlayer()
    integer :: i,j, io,jo
    real(kind=DP) :: h
    integer, allocatable, dimension(:) :: layer_index, layer_order

!    if(sw_layerdos == ON) then
    if (sw_layerdos == ON .or. sw_calc_wf_layer_decomposition==ON ) then
       call get_height(h)
       height = h
       if(slicing_way_winlay == REGULAR_INTERVALS) then
!!$       call get_height(h)
          if(kimg == 1) h = h*0.5d0
          nlayer = h/deltaz_winlay + (1-DELTA10)
          mlayer = nlayer + 1
       else if(slicing_way_winlay == BY_ATOMIC_POSITIONS) then
          allocate(layer_index(natm))
          nlayer = 1
          layer_index(nlayer) = numlay(1)
          do i = 2, natm
             do j = 1, nlayer
                if(layer_index(j) == numlay(i)) goto 1001
             end do
             nlayer = nlayer + 1
             layer_index(nlayer) = numlay(i)
1001         continue
          end do
          if(minval(layer_index(1:nlayer)) /= 1 .or. maxval(layer_index(1:nlayer)) /= nlayer) then
             allocate(layer_order(nlayer)); layer_order(:) = (/(i,i=1,nlayer)/)
             do i = 1, nlayer-1
                do j = i+1, nlayer
                   io = layer_order(i)
                   jo = layer_order(j)
                   if(layer_index(io) < layer_index(io)) then
                      layer_order(j) = io
                      layer_order(i) = jo
                   end if
                end do
             end do
             if(ipridos>=1) then
                write(nfout,'(" !!ldos i, layer_index, layer_order <<m_Ldos.set_nlayer>>")')
                do i = 1, nlayer
                   write(nfout,'(" !!ldos ",3i8)') i, layer_index(i), layer_order(i)
                end do
             end if
             do i = 1, natm
                do j = 1, nlayer
                   if(layer_index(j) == numlay(i)) then
                      numlay(i) = layer_order(j)
                      goto 1002
                   end if
                end do
1002            continue
             end do
             if(ipridos>=1) then
                write(nfout,'(" !!ldos #atom, numlay <<m_Ldos.set_nlayer>>")')
                do i = 1, natm
                   write(nfout,'(" !!ldos ",3i8)') i, numlay(i)
                end do
             end if
             deallocate(layer_order)
          end if
          deallocate(layer_index)
          mlayer = nlayer + 1
       end if
       if(ipridos>=1) write(nfout,'(" !!ldos nlayer, mlayer = ",2i8)') nlayer, mlayer
    else
       nlayer = 0
       mlayer = 0
    end if
  end subroutine set_nlayer

  subroutine alloc_mesh()
    integer :: id,nd2,nn
    id  = fft_box_size_WF(1,0)
    nd2 = fft_box_size_WF(2,0)
    nn  = fft_box_size_WF(3,1)
    if(.not.allocated(mesh)) allocate(mesh(id,nd2,nn))
    id  = fft_box_size_CD_nonpara(1,0)
    nd2 = fft_box_size_CD_nonpara(2,0)
    nn  = fft_box_size_CD(3,1)
    if(.not.allocated(meshp)) allocate(meshp(id,nd2,nn))
  end subroutine alloc_mesh

  subroutine alloc_meshl()
    integer :: id,nd2,nn
    id  = fft_box_size_WF(1,0)
    nd2 = fft_box_size_WF(2,0)
    nn  = fft_box_size_WF(3,1)
    if(.not.allocated(meshl)) allocate(meshl(id,nd2,nn))
    id  = fft_box_size_CD_nonpara(1,0)
    nd2 = fft_box_size_CD_nonpara(2,0)
    nn  = fft_box_size_CD(3,1)
    if(.not.allocated(meshpl)) allocate(meshpl(id,nd2,nn))
  end subroutine alloc_meshl

  subroutine m_Ldos_dealloc_mesh()
    deallocate(mesh)
    deallocate(meshp)
  end subroutine m_Ldos_dealloc_mesh

  subroutine alloc_winlay()
    if(allocated(winlay)) deallocate(winlay)
    if(allocated(nmeshlay)) deallocate(nmeshlay)
    if(allocated(nmeshplay)) deallocate(nmeshplay)
    allocate(winlay(mlayer,2))
    allocate(nmeshlay(mlayer))
    allocate(nmeshplay(mlayer))
  end subroutine alloc_winlay

  subroutine get_adjustfactor(winlay,m,nmeshl,factor,nwrite)
    integer, intent(in) :: m,nwrite
    real(kind=DP),intent(in), dimension(m,2) :: winlay
    integer, intent(in), dimension(m) :: nmeshl
    real(kind=DP),intent(out), dimension(m) :: factor
    integer :: i,nall
    nall = 0
    do i = 1, m
       nall = nall + nmeshl(i)
    end do
    do i = 1, m
       if(nmeshl(i)>0) then
          factor(i) = nall*(winlay(i,2)-winlay(i,1))/height/nmeshl(i)
       else
          factor(i) = 1.d0
       end if
    end do
    if(nwrite==0) then
       if(ipridos>=1) then
          write(nfout,'("!!ldos  no  delta_window   nmesh  factor  adjustednmesh")')
          do i = 1, m
             write(nfout,'("!!ldos ",i4, f12.5,  i8, f8.4, f16.5)') &
                  & i,winlay(i,2)-winlay(i,1),nmeshl(i),factor(i),nmeshl(i)*factor(i)
          end do
       end if
    end if
  end subroutine get_adjustfactor

  subroutine dealloc_winlay()
    deallocate(nmeshplay,nmeshlay,winlay)
  end subroutine dealloc_winlay

  subroutine fillup_mesh(fillmode)
    integer, intent(in) :: fillmode
    integer :: id, nd2, nl, nm, nn
    real(kind=DP),allocatable,dimension(:,:) :: wk_catoms, cps_full ! d(natm2,3)
    real(kind=DP),allocatable,dimension(:) :: wk_dstnc  ! d(natm2)
    integer, allocatable, dimension(:) ::     wk_ioddst, ityp_full ! d((natm2+1)*4)
    real(kind=DP),allocatable,dimension(:,:) :: winlay_internal    ! d(mlayer,2)
    integer :: nmmax,nmmax0,nsize
    integer :: ia,i,ii,ierr
    integer :: id_sname = -1

    call tstatc0_begin('fillup_mesh ',id_sname)
    call m_Parallel_init_mpi_atm2(nfout,ipriparallel,printable,natm2)
    call get_fftbox_size(SOFTPART,id,nd2,nl,nm,nn) ! fft_box_size_WF -> id,nd2,nl,nm,nn
    if(fillmode==ALDOS) then
       allocate(wk_catoms(natm2,3))
       allocate(wk_dstnc(natm2))
       allocate(wk_ioddst((natm2+1)*4))
       allocate(cps_full(natm2,3))
       allocate(ityp_full(natm2))
       cps_full(1:natm,1:3) = cps(1:natm,1:3)
       ityp_full(1:natm) = ityp(1:natm)
       call rplcps(cps_full,ityp_full,1,natm2,natm,iwei)
       if(sw_ac_mesh==ON)then
         allocate(ac_mesh(natm2,1,3));ac_mesh=0
         allocate(nac_mesh(natm2));nac_mesh=0
         call anlmes_ac(ista_atm2,iend_atm2,nfout,ipridos,1,ac_mesh,nac_mesh,id,nd2 &
              &        ,nl*acmesh_factor,nm*acmesh_factor,nn*acmesh_factor &
              &        ,altv,rltv,cps_full,natm2,crtdst_aldos,DELTA10,wk_catoms &
              &        ,wk_ioddst,wk_dstnc,.true.,nmmax)
         call mpi_allreduce(mpi_in_place,nmmax,1,mpi_integer,mpi_max,MPI_CommGroup,ierr)
         nsize = natm2*nmmax*3
         deallocate(ac_mesh);allocate(ac_mesh(natm2,nmmax,3));ac_mesh=0
         call anlmes_ac(ista_atm2,iend_atm2,nfout,ipridos,nmmax,ac_mesh,nac_mesh,id,nd2 &
              &        ,nl*acmesh_factor,nm*acmesh_factor,nn*acmesh_factor &
              &        ,altv,rltv,cps_full,natm2,crtdst_aldos,DELTA10,wk_catoms &
              &        ,wk_ioddst,wk_dstnc,.false.,nmmax0)
         call mpi_allreduce(mpi_in_place,nac_mesh,natm2,mpi_integer,mpi_sum,MPI_CommGroup,ierr)
         call mpi_allreduce(mpi_in_place,ac_mesh,nsize,mpi_integer,mpi_sum,MPI_CommGroup,ierr)
         write(nfout,'(a)') ' !** AC MESH number of mesh allocated to each atom '
         do ia=1,natm2
            write(nfout,'(2i8)') ia,nac_mesh(ia)
         enddo
         if(ipridos>1)then
           write(nfout,'(a)') ' !** AC MESH AC MESH for each atom '
           do ia=1,natm2
              do i=1,nac_mesh(ia)
                 write(nfout,'(5i8,f20.10)') ia,i,ac_mesh(ia,i,1),ac_mesh(ia,i,2),ac_mesh(ia,i,3)
              enddo
           enddo
         endif
       else
         call anlmes(nfout,ipridos,mesh,id,nd2,nl,nm,nn,altv,rltv,cps_full &
              &           ,natm2,crtdst_aldos,DELTA10,wk_catoms,wk_ioddst,wk_dstnc)
       endif
    else if(fillmode==LAYERDOS) then
       allocate(winlay_internal(mlayer,2))
       winlay_internal = winlay/height
       call anlmesl(nfout,ipridos,meshl,id,nd2,nl,nm,nn,winlay_internal,mlayer,normal_axis_winlay,nmeshlay)
    end if

    call get_fftbox_size(HARDPART,id,nd2,nl,nm,nn) ! fft_box_size_CD -> id,nd2,nl,nm,nn
    if(fillmode==ALDOS) then
       if(sw_ac_mesh==ON) then
          allocate(ac_mesh_cd(natm2,1,3));ac_mesh_cd=0
          allocate(nac_mesh_cd(natm2));nac_mesh_cd=0
          call anlmes_ac(ista_atm2,iend_atm2,nfout,ipridos,1,ac_mesh_cd,nac_mesh_cd,id,nd2 &
               &        ,nl*acmesh_factor,nm*acmesh_factor,nn*acmesh_factor &
               &        ,altv,rltv,cps_full,natm2,crtdst_aldos,DELTA10 &
               &        ,wk_catoms,wk_ioddst,wk_dstnc,.true.,nmmax)
          call mpi_allreduce(mpi_in_place,nmmax,1,mpi_integer,mpi_max,MPI_CommGroup,ierr)
          deallocate(ac_mesh_cd);allocate(ac_mesh_cd(natm2,nmmax,3));ac_mesh_cd=0
          nsize = natm2*nmmax*3
          call anlmes_ac(ista_atm2,iend_atm2,nfout,ipridos,nmmax,ac_mesh_cd,nac_mesh_cd,id,nd2 &
               &        ,nl*acmesh_factor,nm*acmesh_factor,nn*acmesh_factor &
               &        ,altv,rltv,cps_full,natm2,crtdst_aldos,DELTA10 &
               &        ,wk_catoms,wk_ioddst,wk_dstnc,.false.,nmmax0)
          call mpi_allreduce(mpi_in_place,nac_mesh_cd,natm2,mpi_integer,mpi_sum,MPI_CommGroup,ierr)
          call mpi_allreduce(mpi_in_place,ac_mesh_cd,nsize,mpi_integer,mpi_sum,MPI_CommGroup,ierr)
          write(nfout,'(a)') ' !** AC MESH number of mesh allocated to each atom (hardpart)'
          do ia=1,natm2
             write(nfout,'(2i8)') ia,nac_mesh_cd(ia)
          enddo
          if(ipridos>1)then
            write(nfout,'(a)') ' !** AC MESH AC MESH for each atom '
            do ia=1,natm2
               do i=1,nac_mesh_cd(ia)
                  write(nfout,'(5i8,f20.10)') ia,i,ac_mesh_cd(ia,i,1),ac_mesh_cd(ia,i,2),ac_mesh_cd(ia,i,3)
               enddo
            enddo
          endif
       else
          call anlmes(nfout,ipridos-1,meshp,id,nd2,nl,nm,nn,altv,rltv,cps_full &
         &           ,natm2,crtdst_aldos,DELTA10,wk_catoms,wk_ioddst,wk_dstnc)
       endif
       deallocate(ityp_full,cps_full,wk_ioddst,wk_dstnc,wk_catoms)
    else if(fillmode==LAYERDOS) then
       call anlmesl(nfout,ipridos,meshpl,id,nd2,nl,nm,nn,winlay_internal,mlayer,normal_axis_winlay,nmeshplay)
       deallocate(winlay_internal)
    end if
    call tstatc0_end(id_sname)

  end subroutine fillup_mesh

  subroutine get_height(h)
    real(kind=DP), intent(out) :: h
    integer :: iaxis,i2,i3
    real(kind=DP) :: a,b,S

    iaxis = normal_axis_winlay
    i2 = iaxis + 1
    if(i2 >= 4) i2 = i2 - 3
    i3 = i2 + 1
    if(i3 >= 4) i3 = i3 - 3
    a = dsqrt(altv(1,i2)**2 + altv(2,i2)**2 + altv(3,i2)**2)
    b = dsqrt(altv(1,i3)**2 + altv(2,i3)**2 + altv(3,i3)**2)
! ----------------------------
!        29 Jan. 2008
!     Revised by M. Usami
!!$    S = a*a * b*b - (altv(1,i2)*altv(1,i3)+altv(2,i2)*altv(2,i3)+altv(3,i2)*altv(3,i3))
    S = a*a * b*b - (altv(1,i2)*altv(1,i3)+altv(2,i2)*altv(2,i3)+altv(3,i2)*altv(3,i3))**2
! --------------------------
    S = dsqrt(S)
    h = univol/S
    if(ipridos>=1) write(nfout,'(" !!ldos S, h, V = ",3f16.8," <<m_Ldos.set_nlayer>>")') S,h,univol
  end subroutine get_height

  subroutine set_winlay()
! ----------------------------------------------
!       Nov. 17th 1992 by T.Yamasaki
!
!    the original subroutine name was "dwinly2"
!
!       modified by T. Yamasaki, 09th Feb 2004
! ----------------------------------------------
    real(kind=DP) :: zmin, tmp, h
    integer ::  i, nl
    i = normal_axis_winlay
!!$    call get_height(h)
    h = height
    if(kimg == 1) then
       maxhv = h*0.5d0
       maxv  = maxhv*2
    else
       maxhv = h
       maxv  = maxhv
    end if

    winlay = 0.d0
    if(slicing_way_winlay == REGULAR_INTERVALS) then
       if(ipridos>=1) then
          write(nfout,'(" !!ldos slicing_way = REGULAR_INTERVALS")')
          write(nfout,'(" !!ldos nlayer, mlayer = ",2i6)') nlayer, mlayer
          write(nfout,'(" !!ldos maxhv, maxv = ",2f8.4)') maxhv, maxv
          write(nfout,'(" !!deltaz_winlay = ",f8.4)') deltaz_winlay
       end if
       if(kimg == 1) then
          winlay(1,1) = 0.d0
          winlay(mlayer,2) = maxhv
          do i = 1, nlayer
             winlay(i,2) = deltaz_winlay * i
             if(winlay(i,2) > maxhv) winlay(i,2) = maxhv
             if(i+1 <= mlayer) winlay(i+1,1) = winlay(i,2)
          end do
       else if(kimg == 2) then
          zmin = minval(cps(1:natm,normal_axis_winlay))
          winlay(1,1) = zmin - crtdst_winlay
          winlay(mlayer,2) = winlay(1,1) + maxv
          do i = 1, nlayer
             winlay(i,2) = winlay(i,1) + deltaz_winlay
             if(winlay(i,2) > winlay(mlayer,2)) winlay(i,2) = winlay(mlayer,2)
             if(i+1 <= mlayer) winlay(i+1,1) = winlay(i,2)
          end do
       end if
    else if(slicing_way_winlay == BY_ATOMIC_POSITIONS) then
       if(ipridos>=1) &
            & write(nfout,'(" !!ldos slicing_selection = BY_ATOMIC_POSITIONS")')

       do i = 1, mlayer
          winlay(i,1) = +maxv*30
          winlay(i,2) = -maxv*30
       end do

       do i = 1, natm
          nl = numlay(i)
          if(winlay(nl,1) > cps(i,normal_axis_winlay)) winlay(nl,1) = cps(i,normal_axis_winlay)
          if(winlay(nl,2) < cps(i,normal_axis_winlay)) winlay(nl,2) = cps(i,normal_axis_winlay)
       end do

       if(ipridos>=1) then
          write(nfout,'(" !!ldos a range of atomic positions of each layer ")')
          do i = 1, nlayer
             write(nfout,'(2x,i4,2f20.8)') i, winlay(i,1), winlay(i,2)
          end do
       end if

       tmp = winlay(1,1) - crtdst_winlay
       if(kimg == 2) then
          if( tmp < winlay(nlayer,2) - maxhv + crtdst_winlay ) then
!     ( a unit cell has no vacuum region )
             winlay(1,1) = (winlay(1,1) + winlay(nlayer,2) - maxv)*0.5
             winlay(nlayer,2) = winlay(1,1)+maxv
             winlay(mlayer,1) = winlay(1,1)
             winlay(mlayer,2) = winlay(1,1)
          else
!     ( a unit cell has a vacuum region)
             winlay(1,1) = winlay(1,1) - crtdst_winlay
             winlay(nlayer,2) = winlay(nlayer,2) + crtdst_winlay
             winlay(mlayer,1) = winlay(nlayer,2)
             winlay(mlayer,2) = winlay(1,1) + maxv
          endif
       else if(kimg == 1) then
          winlay(1,1) = 0.d0
          winlay(mlayer,2) = maxhv
          winlay(nlayer,2) = winlay(nlayer,2) + crtdst_winlay
          winlay(mlayer,1) = winlay(nlayer,2)
       end if

       do i = 1, nlayer-1
          winlay(i,2) = (winlay(i,2) + winlay(i+1,1))*0.5
          winlay(i+1,1) = winlay(i,2)
       end do
    else
       if(ipridos>=1) write(nfout,'(" !!ldos slicing_selection is illegal")')
    end if

    if(ipridos>=1) then
       write(nfout,'(" !!ldos",3x,a2,5x,a9,11x,a9,8x,a11,5x,a11)') &
            &   "no","min(Bohr)","max(Bohr)","min(Angst.)","max(Angst.)"
!!$       write(nfout,'(" !!ldos    no,        min(Bohr),       max(Bohr),     min(Angst.),    max(Angst.)")')
       do i = 1, nlayer
          write(6,'(" !!ldos ",i4,2f20.8,2f16.4)') i, winlay(i,1), winlay(i,2), winlay(i,1)*BOHR,winlay(i,2)*BOHR
       enddo
       if(mlayer > nlayer) then
          write(6,'(" !!ldos ",i4,2f20.8,2f16.4)') mlayer, winlay(mlayer,1), winlay(mlayer,2) &
               &    ,  winlay(mlayer,1)*BOHR, winlay(mlayer,2)*BOHR
       endif
    end if

  end subroutine set_winlay

  subroutine m_Ldos_alloc_weiwsc_etc()
    integer :: n_ldos_allocated
    integer :: n_lband_allocated

    if ( hardpart_subroutine /= 2 ) then
       if ( sw_rspace_ldos == OFF .or. sw_rspace_lband == OFF ) then
          call m_CD_cp_chgq_to_chgqo() !ASMS
       endif
    endif

    n_total_ldoscal = 0

    if ( sw_aldos == ON .or. sw_calc_wf_atom_decomposition == ON ) then
       if ( noncol ) then
          call alloc_weiwsc_noncl(n_ldos_allocated)
       else
          call alloc_weiwsc(n_ldos_allocated)
       endif
       n_total_ldoscal = n_total_ldoscal + n_ldos_allocated
    end if
    if ( sw_layerdos == ON .or. sw_calc_wf_layer_decomposition == ON ) then
       if ( noncol ) then
          call alloc_weilay_noncl(n_ldos_allocated)
       else
          call alloc_weilay(n_ldos_allocated)
       endif
       n_total_ldoscal = n_total_ldoscal + n_ldos_allocated
    end if
  end subroutine m_Ldos_alloc_weiwsc_etc

  subroutine m_Ldos_dealloc_weiwsc_etc()
    if ( sw_aldos == ON .or. sw_calc_wf_atom_decomposition == ON ) then
       if ( noncol ) then
          call dealloc_weiwsc_noncl()
       else
          call dealloc_weiwsc()
       endif
    endif
    if ( sw_layerdos == ON .or. sw_calc_wf_layer_decomposition == ON ) then
       if ( noncol ) then
          call dealloc_weilay_noncl()
       else
          call dealloc_weilay()
       endif
    endif
  end subroutine m_Ldos_dealloc_weiwsc_etc

  subroutine alloc_weiwsc(n_ldos_allocated)
    integer, intent(out) :: n_ldos_allocated
    n_ldos_allocated = 0
    if(ekmode == ON) then
       if ( sw_lband == ON ) then
          if (hardpart_subroutine==2 .or. sw_rspace_lband==ON )then
             allocate(weiwsc(maldos,np_e,ista_k:iend_k)); weiwsc = 0.d0
          else
             allocate(weiwsc(maldos,neg,kv3)); weiwsc = 0.d0
          endif
       else
          allocate(weiwsc(maldos,neg,kv3_ek)); weiwsc = 0.d0
       endif
    else
       if (hardpart_subroutine==2 .or. sw_rspace_ldos==ON &
            &                     .or. sw_rspace_lband==ON )then
          allocate(weiwsc(maldos,np_e,ista_k:iend_k)); weiwsc = 0.d0
       else
          allocate(weiwsc(maldos,neg,kv3)); weiwsc = 0.d0
       endif
    end if
    n_ldos_allocated = maldos
  end subroutine alloc_weiwsc

! ================================= added by K. Tagami ============= 11.0
  subroutine alloc_weiwsc_noncl(n_ldos_allocated)
    integer, intent(out) :: n_ldos_allocated
    n_ldos_allocated = 0
    if(ekmode == ON) then
       if ( sw_lband == ON ) then
          if(hardpart_subroutine==2 .or. sw_rspace_lband==ON )then
             allocate(weiwsc_noncl(maldos,np_e,ista_k:iend_k,ndim_magmom))
          else
             allocate(weiwsc_noncl(maldos,neg,kv3,ndim_magmom))
          endif
       else
          allocate(weiwsc_noncl(maldos,neg,kv3_ek,ndim_magmom))
       endif
    else if(ekmode == OFF) then
       if(hardpart_subroutine==2 .or. sw_rspace_ldos==ON &
            &                    .or. sw_rspace_lband==ON )then
          allocate(weiwsc_noncl(maldos,np_e,ista_k:iend_k,ndim_magmom))
       else
          allocate(weiwsc_noncl(maldos,neg,kv3,ndim_magmom))
       endif
    end if

    weiwsc_noncl = 0.0d0
    n_ldos_allocated = maldos

  end subroutine alloc_weiwsc_noncl
! =============================================================== 11.0

  subroutine dealloc_weiwsc()
    deallocate(weiwsc)
  end subroutine dealloc_weiwsc

! ================================== added by K. Tagami ========== 11.0
  subroutine dealloc_weiwsc_noncl()
    deallocate(weiwsc_noncl)
  end subroutine dealloc_weiwsc_noncl
! =============================================================== 11.0

  subroutine alloc_weilay(n_ldos_allocated)
    integer, intent(out) :: n_ldos_allocated
!!$    allocate(weilay(mlayer,np_e)); weilay = 0.d0
    n_ldos_allocated = 0
    if(ekmode == ON) then
       if ( sw_lband == ON ) then
          if(hardpart_subroutine==2.or.sw_rspace_lband==ON)then
             allocate(weilay(mlayer,np_e,ista_k:iend_k)); weilay = 0.d0
          else
             allocate(weilay(mlayer,neg,kv3)); weilay = 0.d0
          endif
       else
          allocate(weilay(mlayer,neg,kv3_ek)); weilay = 0.d0
       endif
    else if(ekmode == OFF) then
       if(hardpart_subroutine==2.or.sw_rspace_ldos==ON)then
          allocate(weilay(mlayer,np_e,ista_k:iend_k)); weilay = 0.d0
       else
          allocate(weilay(mlayer,neg,kv3)); weilay = 0.d0
       endif
    end if
    n_ldos_allocated = mlayer
  end subroutine alloc_weilay

! ============================ added by K. Tagami ================= 11.0
  subroutine alloc_weilay_noncl(n_ldos_allocated)
    integer, intent(out) :: n_ldos_allocated

    n_ldos_allocated = 0
    if(ekmode == ON) then
       if ( sw_lband == ON ) then
          if(hardpart_subroutine==2.or.sw_rspace_lband==ON)then
             allocate(weilay_noncl(mlayer,np_e,ista_k:iend_k,ndim_magmom))
          else
             allocate(weilay_noncl(mlayer,neg,kv3,ndim_magmom))
          endif
       else
          allocate(weilay_noncl(mlayer,neg,kv3_ek,ndim_magmom))
       endif
    else if(ekmode == OFF) then
       if(hardpart_subroutine==2.or.sw_rspace_ldos==ON)then
          allocate(weilay_noncl(mlayer,np_e,ista_k:iend_k,ndim_magmom))
       else
          allocate(weilay_noncl(mlayer,neg,kv3,ndim_magmom))
       endif
    end if
    weilay_noncl = 0.d0
    n_ldos_allocated = mlayer
  end subroutine alloc_weilay_noncl
! =============================================================== 11.0

  subroutine dealloc_weilay()
    deallocate(weilay)
  end subroutine dealloc_weilay

! ============================== added by K. Tagami ========== 11.0
  subroutine dealloc_weilay_noncl()
    deallocate(weilay_noncl)
  end subroutine dealloc_weilay_noncl
! ============================================================= 11.0

  subroutine m_Ldos_wd_natm2_and_totch( nfldos )
    integer, intent(in) :: nfldos
    if(mype == 0 .and. ipridos>=0 ) then
!       write(nfldos,'(" natm2 = ",i8)') naldos ! natm2
!       write(nfldos,'(" totch = ",f20.8)') totch
       write(nfldos,'(" num_atoms  = ",i8)') naldos ! natm2
       write(nfldos,'(" num_layers = ",i8)') nlayer
       write(nfldos,'(" num_bands  = ",i8)') neg -num_extra_bands
       write(nfldos,*)
    end if
  end subroutine m_Ldos_wd_natm2_and_totch

  subroutine m_Ldos_cal_ek( nfldos )
    use m_Files, only : nfzaj_kall
    use m_IterationNumbers, only : m_Iter_reset_nk_in_the_process
    use m_ES_IO, only : m_ESIO_rd_next_wfs_ek
    use m_Files, only : m_Files_open_nfzaj_kall
    use m_ES_ortho, only : m_ES_modified_gram_schmidt
    use m_ES_occup, only : m_ESoc_check_if_metalic
    use m_ES_nonlocal, only : m_ES_betar_dot_WFs_4_each_k

    integer, intent(in) :: nfldos

    integer :: id_sname = -1
    integer :: i, is, ikt, nk, ierr, ik, ib
    integer :: sw_atom_decomp, sw_layer_decomp
    real(kind=DP), allocatable, dimension(:,:,:) :: wei
    integer, allocatable, dimension(:) :: kmap

    call m_Files_open_nfzaj_kall()
    rewind(nfzaj_kall)
    allocate(kmap(kv3))

    call tstatc0_begin('m_Ldos_cal_ek ',id_sname,1)
    call m_Iter_reset_nk_in_the_process()

    sw_atom_decomp = OFF;  sw_layer_decomp = OFF
    if ( sw_aldos == ON .or. sw_calc_wf_atom_decomposition == ON ) then
       sw_atom_decomp = ON
    endif
    if ( sw_layerdos == ON .or. sw_calc_wf_layer_decomposition == ON ) then
       sw_layer_decomp = ON
    endif

    do nk=1, kv3_ek, kv3
       if ( sw_atom_decomp==ON ) weiwsc = 0.d0
       if ( sw_layer_decomp==ON ) weilay = 0.d0
       call KpointNumber_Setting2()
       call Preparation_ek()
       call Preparation_for_mpi_ek()
       call PseudoPotential_ek()

       kmap = 0
       if(sw_modified_kpoint_increment == ON)then
          do i=0,nrank_k-1
             do is=1,nspin
                ikt = nspin*(nis_kv3_ek(i)-1)+(nk-1)*nspin+is
                kmap(i+1) = ikt
                if(ikt>kv3_ek) exit
                call m_ESIO_rd_next_wfs_ek(i+1, nfout, nfzaj_kall)
                if(map_k(i+1) /= myrank_k) cycle
                call m_ES_betar_dot_WFs_4_each_k(nfout, i+1)
             enddo
          enddo
       else
          do is=1, nspin, af+1
             do ik=is, kv3+is-nspin, nspin
                ikt = nk + ik - 1
                if(ikt>kv3_ek) exit
                kmap(ik) = ikt
                call m_ESIO_rd_next_wfs_ek(ik, nfout, nfzaj_kall)
                if(map_k(ik) /= myrank_k) cycle
                call m_ES_betar_dot_WFs_4_each_k(nfout, ik)
             enddo
          enddo
       endif
       if ( sw_ldos == ON .or. sw_lband ==ON ) call m_Ldos_cal( nfldos, .false. )

       if (sw_atom_decomp==ON) then
          call wd_weight_ek(maldos,kmap,weiwsc,ALDOS,nfldos)
       endif
       if (sw_layer_decomp==ON) then
          call wd_weight_ek(mlayer,kmap,weilay,LAYERDOS,nfldos)
       endif

    enddo
    deallocate(kmap)

    if(sw_atom_decomp==ON .and. sw_ac_mesh==ON) then
      call check_sum_full('total ',.true.)
      if(sw_checksum == ON) call check_sum_full('total ')
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Ldos_cal_ek


  subroutine wd_weight_ek(m,kmap,wei,mode,nfldos)
    real(kind=DP), intent(in), dimension(m,neg,kv3_ek) :: wei
    integer, intent(in), dimension(kv3) :: kmap
    integer, intent(in) :: mode, nfldos
    integer :: m, ib, ib_ordr, kend, kstep, iws, ik, ii

    if ( nrank_e > 1 ) then
       Do ii=1, kv3_ek
          call mpi_allreduce( mpi_in_place, wei(:,:,ii), m*neg, mpi_double_precision, &
               &              mpi_sum, MPI_CommGroup, ierr )
       End Do
    endif

    if(mype == 0) then
       do ik=1,kv3
         if (kmap(ik)>kv3_ek .or. kmap(ik)==0 ) cycle
         write(nfout,'(a,3i8)') '!** in wd_weight ',ik,kmap(ik),mode
!         write(nfldos,'(2i8)') mode,kmap(ik)
         if ( mode == 1 ) then
            write(nfldos,'(2i8,10x,a)') mode, kmap(ik), " # Atom decomposed,  ik"
         else
            write(nfldos,'(2i8,10x,a)') mode, kmap(ik), " # Layer decomposed, ik"
         endif

         do ib = 1, neg -num_extra_bands
            if(ilen >= m) then
               write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws,ib,ik),iws=1,m)
            else
               write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws,ib,ik),iws=1,ilen)
               write(nfldos,'(5x,5f15.10)') (wei(iws,ib,ik),iws=ilen+1,m)
            end if
         end do
      enddo
    endif
  end subroutine wd_weight_ek

  subroutine check_sum(ik,aword)
    integer,intent(in) :: ik
    character*(*),intent(in) :: aword

    integer :: sw_atom_decomp, sw_layer_decomp
    integer :: ib, ia, ilay, ib_ordr, ik_t
    real(kind=DP), allocatable, dimension(:) :: sum_aldos, sum_layer

    sw_atom_decomp = OFF;  sw_layer_decomp = OFF
    if ( sw_aldos == ON .or. sw_calc_wf_atom_decomposition == ON ) then
       sw_atom_decomp = ON
    endif
    if ( sw_layerdos == ON .or. sw_calc_wf_layer_decomposition == ON ) then
       sw_layer_decomp = ON
    endif

    if(sw_atom_decomp == ON) allocate(sum_aldos(neg))
    if(sw_layer_decomp == ON) allocate(sum_layer(neg))

    if ( sw_lband == ON ) then
       ik_t = ik
    else
       if(ekmode /= ON) then
          ik_t = ik
       else if(ekmode == ON) then
          ik_t = 1
       end if
    endif

    if(sw_atom_decomp == ON) then
       sum_aldos = 0.d0
       do ib = ista_e, iend_e, istep_e
!!$               ibt = neg_g(ib)
          do ia = 1, natm2 + 1
             sum_aldos(ib) = sum_aldos(ib) + weiwsc(ia,map_z(ib),ik_t)
!!$               sum_aldos(neg_g(ib)) = sum_aldos(neg_g(ib)) + weiwsc(ia,ibt,ik_t)
          end do
       end do
       call mpi_allreduce(MPI_IN_PLACE,sum_aldos,neg,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
    end if

    if(sw_layer_decomp == ON) then
       sum_layer = 0.d0
       do ib = ista_e, iend_e, istep_e
          do ilay = 1, mlayer
             sum_layer(ib) = sum_layer(ib) + weilay(ilay,map_z(ib),ik_t)
          end do
       end do
       call mpi_allreduce(MPI_IN_PLACE,sum_layer,neg,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
    end if

!!$      if(mype == 0) then
    if(ipridos>=1) then
       if(sw_atom_decomp == ON .and. sw_layer_decomp == ON) then
          write(nfout,9001) aword,"atomic, layer",neg,natm2,ik
          do ib = 1, neg
             write(nfout,'(" !!ldos ", i4,2f16.8)') ib, sum_aldos(ib), sum_layer(ib)
          end do
       else if(sw_atom_decomp == ON) then
          write(nfout,9002) aword,"atomic",neg,natm2,ik
          do ib = 1, neg
             write(nfout,'(" !!ldos ", i4,f16.8)') ib, sum_aldos(ib)
          end do
       else if(sw_layer_decomp == ON) then
          write(nfout,9002) aword,"layer ",neg,natm2,ik
          do ib = 1, neg
             write(nfout,'(" !!ldos ", i4,f16.8)') ib, sum_layer(ib)
          end do
       end if
9001     format(' !!ldos ',a13,' -- iban , sum(',a6,') --  neg = ',i6,' natm2 = ',i6,' ik = ',i6)
9002     format(' !!ldos ',a8, ' -- iban , sum(',a6,') --  neg = ',i6,' natm2 = ',i6,' ik = ',i6)
    end if

    if(sw_atom_decomp == ON) deallocate(sum_aldos)
    if(sw_layer_decomp == ON) deallocate(sum_layer)

  end subroutine check_sum

  subroutine check_sum_full(aword,normalize)
    character*(*),intent(in) :: aword
    logical, intent(in), optional :: normalize
    integer :: ik, ib, ia, ilay, ike,j,ierr
    integer, parameter :: num_kset = 4
    integer :: sw_atom_decomp, sw_layer_decomp
    real(kind=DP), allocatable, dimension(:,:) :: sum_aldos, sum_layer, sum_mpi
    logical :: norma
    norma = .false.
    if(present(normalize)) norma = .true.

    sw_atom_decomp = OFF;  sw_layer_decomp = OFF
    if ( sw_aldos == ON .or. sw_calc_wf_atom_decomposition == ON ) then
       sw_atom_decomp = ON
    endif
    if ( sw_layerdos == ON .or. sw_calc_wf_layer_decomposition == ON ) then
       sw_layer_decomp = ON
    endif

    if(sw_atom_decomp == ON) allocate(sum_aldos(neg,kv3))
    if(sw_layer_decomp == ON) allocate(sum_layer(neg,kv3))

    if(sw_atom_decomp==ON) then
       sum_aldos = 0.d0
       do ik = ista_k, iend_k
          do ib = ista_e, iend_e, istep_e
             do ia = 1, natm2 + 1
                sum_aldos(ib,ik) = sum_aldos(ib,ik) + weiwsc(ia,map_z(ib),ik)
             end do
          end do
       end do
       call mpi_allreduce(MPI_IN_PLACE,sum_aldos,neg*kv3,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
    end if
    if(sw_layer_decomp == ON) then
       sum_layer = 0.d0
       do ik = ista_k, iend_k
          do ib = ista_e, iend_e, istep_e
             do ilay = 1, mlayer
                sum_layer(ib,ik) = sum_layer(ib,ik) + weilay(ilay,map_z(ib),ik)
             end do
          end do
       end do
       call mpi_allreduce(MPI_IN_PLACE,sum_layer,neg*kv3,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
    end if

    if(ipridos>=1) then
       do ik = 1, kv3, num_kset
          ike = min(kv3,ik+num_kset-1)
          if(sw_atom_decomp == ON .and. sw_layer_decomp == ON) then
             write(nfout,9001) aword,"atomic,layer",neg,natm2,ik,ike
             write(nfout,'(" !!ldos iban ",4a24)')   (("   aldos      layerdos  "),j=1,4)
             do ib = 1, neg
                write(nfout,'(" !!ldos ",i4,8f12.8)') ib,(sum_aldos(ib,j),sum_layer(ib,j),j=ik,ike)
             end do
          else if(sw_atom_decomp == ON) then
             write(nfout,9002) aword,"atomic",neg,natm2,ik,ike
             do ib = 1, neg
                write(nfout,'(" !!ldos ",i4,4f14.8)') ib,(sum_aldos(ib,j),j=ik,ike)
             end do
          else if(sw_layer_decomp == ON) then
             write(nfout,9002) aword,"layer ",neg,natm2,ik,ike
             do ib = 1, neg
                write(nfout,'(" !!ldos ",i4,4f14.8)') ib,(sum_layer(ib,j),j=ik,ike)
             end do
          end if
       end do
9001     format(' !!ldos ',a13,' -- iban , sum(',a6,') --  neg = ',i6,' natm2 = ',i6,' ik = [',i4,':',i4,']')
9002     format(' !!ldos ',a8, ' -- iban , sum(',a6,') --  neg = ',i6,' natm2 = ',i6,' ik = [',i4,':',i4,']')
    end if
    if(norma .and. sw_atom_decomp==ON .and. sw_ac_mesh==ON)then
       do ik = ista_k, iend_k
          do ib = ista_e, iend_e, istep_e
             weiwsc(:,ib,ik) = weiwsc(:,ib,ik)/sum_aldos(ib,ik)
          enddo
       enddo
    endif
  end subroutine check_sum_full



  subroutine cal_weiwsc(ik,is)
    integer, intent(in) :: ik, is
  end subroutine cal_weiwsc

  subroutine m_Ldos_cal( nfldos, print_flag )
    use m_IterationNumbers,   only : nk_in_the_process
    use m_Ionic_System,       only : speciesname

    integer, intent(in) :: nfldos
    logical, intent(in) :: print_flag
    integer,allocatable,dimension(:,:) :: meshwk, meshwk_layer
    integer :: ik,is,ip, ib,j,i,ia
    integer :: ekmode_t
    integer :: sw_full_fftmesh
    integer :: sw_atom_decomp, sw_layer_decomp

    real(kind=DP) :: denom, chgq0
    real(kind=DP), allocatable, dimension(:) :: zrhoik ! d(kg*kimg)
    real(kind=DP), allocatable, dimension(:) :: bfft   ! d(nfft)

    real(kind=DP), allocatable, dimension(:,:,:) :: wsctmp,laytmp
    real(kind=DP), allocatable, dimension(:,:,:) :: wscsoft,wschard
    real(kind=DP), allocatable, dimension(:) :: zfcos,zfsin
    real(kind=DP), allocatable, dimension(:,:) :: psi_tmp

    sw_atom_decomp = OFF;  sw_layer_decomp = OFF
    if ( sw_aldos == ON .or. sw_calc_wf_atom_decomposition == ON ) then
       sw_atom_decomp = ON
    endif
    if ( sw_layerdos == ON .or. sw_calc_wf_layer_decomposition == ON ) then
       sw_layer_decomp = ON
    endif

    sw_full_fftmesh=OFF
    if(integration_dimension_winlay==3) sw_full_fftmesh=ON
    if(sw_layer_decomp == ON) allocate(zrhoik(kg*kimg))

    denom = 1.d0/product(fft_box_size_WF(1:3,1))

    call m_CD_keep_retrieve_hsr(.true.)
    if(sw_atom_decomp==ON .and. sw_ac_mesh==ON)then
       allocate(wscsoft(maldos,neg,kv3));wscsoft=0.d0
       allocate(wschard(maldos,neg,kv3));wschard=0.d0
    endif

     if(modnrm == EXECUT) call m_CD_set_ylm_enl_etc()

     if ( mype == 0 ) call wd_header

!==================================== added by K. Tagami ============= 11.0
     if ( sw_atom_decomp == ON ) weiwsc = 0.d0
     if ( sw_layer_decomp == ON ) weilay = 0.d0
!===================================================================== 11.0

     do is = 1, nspin, af+1
        if(hardpart_subroutine==2.or.sw_rspace_ldos==ON &
             & .or.  sw_rspace_lband ==ON ) then

           do ik = is, kv3+is-nspin, nspin
              if(map_k(ik) /= myrank_k) cycle
              if ( ekmode==ON ) then
                 if ( nk_in_the_process +ik -1 > kv3_ek ) cycle
              endif

              if(ipridos >= 2) write(nfout,'(" !!ldos ik = ",i6)') ik
              call m_FFT_alloc_WF_work()
              if(sw_atom_decomp==ON .and. sw_ac_mesh==OFF) then
                 call fillup_meshwk(mode=SOFTPART)
              endif
              if(sw_layer_decomp==ON .and. sw_full_fftmesh==ON) then
                 call fillup_meshwk_layer(mode=SOFTPART)
              endif

              allocate(bfft(nfft))
              if(ipridos >= 2 .and. printable) write(nfout,'(" !!ldos nfft = ",i6," <<m_Ldos_cal>>")') nfft
              if(ipridos >= 2 .and. printable) &
                   & call m_ES_wd_zaj_small_portion(nfout,ik," -- before m_ES_WF_in_Rspace <<m_Ldos_cal>> --",46)
              do ib = ista_e, iend_e, istep_e
                 bfft = 0.d0
                 if ( sw_band_unfolding == ON .and. band_unfolding_active ) then
                    call m_ES_WF_in_Rspace_kt( ik, ik, ik, &
                         &                     zaj_l(:,map_z(ib),ik,:), bfft )
                 else
                    call m_ES_WF_in_Rspace(ik,ib,bfft)
                 endif

                 if(sw_atom_decomp == ON.and.sw_ac_mesh==OFF) call substitute_weiwsc(ik,ib,.false.)
                 if(sw_atom_decomp == ON.and.sw_ac_mesh==ON)  call substitute_weiwsc_acmesh(ik,ib,.false.,.false.,wscsoft)
                 if(sw_layer_decomp==ON) then
                    if(sw_full_fftmesh==ON) call substitute_weilay_fftmesh(ik,ib,.false.)
                    if(sw_full_fftmesh==OFF) call substitute_weilay(ik,ib,.false.)
                 end if
              end do
              call check_sum(ik,"softpart",.false.,modnrm /= EXECUT)
              if(sw_ac_mesh==ON .and. modnrm /= EXECUT) &
              &  call check_sum(ik,"softpart",.false.,.false.)
              deallocate(bfft)
              call m_FFT_dealloc_WF_work()

              if(modnrm == EXECUT) then
                 call m_FFT_alloc_CD_box()
                 allocate(bfft(nfftp_nonpara))

                 if(sw_atom_decomp==ON .and. sw_ac_mesh==OFF) call fillup_meshwk(mode=HARDPART)
                 if(sw_layer_decomp==ON .and. sw_full_fftmesh==ON) call fillup_meshwk_layer(mode=HARDPART)

                 do ib = ista_e, iend_e, istep_e
                    if(ipridos>=2) write(nfout,'(" !ldos   ib = ", i5)') ib
                    if(sw_rspace_ldos==ON .or. sw_rspace_lband==ON)then
                       if(sw_layer_decomp == ON .and. sw_full_fftmesh==OFF) then
                          call m_CD_hardpart_sub2_rs(nfout,is,ik,ib,bfft,chgq0)
                       else
                          call m_CD_hardpart_sub2_rs(nfout,is,ik,ib,bfft)
                       endif
                    else
                       call m_CD_hardpart_sub2(nfout,is,ik,ib,chgq0)  ! -> chgq_enl
                       call m_CD_map_chgqenl_to_fft_box(is,nfftp_nonpara,bfft) ! -> bfft
                       call m_FFT_CD_inverse0(nfout,bfft) ! bfft(G_sp.) -> bfft(R_sp.)
                    endif

                    if(sw_atom_decomp == ON .and. sw_ac_mesh==OFF) &
                   &   call substitute_weiwsc_cd(ik,ib,.false.)

                    if(sw_atom_decomp == ON.and.sw_ac_mesh==ON)  &
                   &   call substitute_weiwsc_acmesh(ik,ib,.false.,.true.,wschard)

                    if(sw_layer_decomp==ON .and.sw_full_fftmesh==ON) call substitute_weilay_cd_fftmesh(1,ib,.false.)
                    if(sw_layer_decomp==ON .and. sw_full_fftmesh==OFF) call substitute_weilay_cd(ik,ib,chgq0,.false.)
                 end do
                 if(sw_atom_decomp==ON .and. sw_ac_mesh==OFF) deallocate(meshwk)
                 if(sw_layer_decomp==ON .and. sw_full_fftmesh==ON) deallocate(meshwk_layer)
                 deallocate(bfft)
                 call m_FFT_dealloc_CD_box()
                 call check_sum(ik,"total   ",.false.,.true.)
                 if(sw_ac_mesh==ON) call check_sum(ik,"total   ",.false.,.false.)
              end if

           end do

        else
!========================= modiifed by K. Tagami ============= 11.0
            weiwsc = 0.d0
            weilay = 0.d0
!============================================================= 11.0

           do ik = is, kv3+is-nspin, nspin
              if(map_k(ik) /= myrank_k) cycle
              if ( ekmode==ON ) then
                 if ( nk_in_the_process +ik -1 > kv3_ek ) cycle
              endif

              if(ipridos >= 2) write(nfout,'(" !!ldos ik = ",i6)') ik
              call m_FFT_alloc_WF_work()
              if(sw_atom_decomp==ON .and. sw_ac_mesh==OFF) call fillup_meshwk(mode=SOFTPART)
              if(sw_layer_decomp==ON .and. sw_full_fftmesh==ON) call fillup_meshwk_layer(mode=SOFTPART)

              allocate(bfft(nfft));bfft=0.d0
              if(ipridos >= 2 .and. printable) write(nfout,'(" !!ldos nfft = ",i6," <<m_Ldos_cal>>")') nfft
              if(ipridos >= 2 .and. printable) &
                   & call m_ES_wd_zaj_small_portion(nfout,ik," -- before m_ES_WF_in_Rspace <<m_Ldos_cal>> --",46)
              do ib = 1,neg
                 if(map_e(ib)/=myrank_e) cycle
                 bfft = 0.d0
                 if ( sw_band_unfolding == ON .and. band_unfolding_active ) then
                    call m_ES_WF_in_Rspace_kt( ik, ik, ik, &
                         &                     zaj_l(:,map_z(ib),ik,:), bfft )
                 else
                    call m_ES_WF_in_Rspace(ik,ib,bfft)
                 endif

                 if(sw_atom_decomp==ON.and.sw_ac_mesh==OFF) call substitute_weiwsc(ik,ib,.true.)
                 if(sw_atom_decomp==ON.and.sw_ac_mesh==ON)  call substitute_weiwsc_acmesh(ik,ib,.true.,.false.,wscsoft)
                 if(sw_layer_decomp==ON .and. sw_full_fftmesh==ON) call substitute_weilay_fftmesh(ik,ib,.true.)
                 if(sw_layer_decomp==ON .and. sw_full_fftmesh==OFF) call substitute_weilay(ik,ib,.true.)
              end do
              deallocate(bfft)
              call m_FFT_dealloc_WF_work()
           enddo
           if(npes>1)then
              if(sw_atom_decomp==ON.and.sw_ac_mesh==OFF) then
                 allocate(wsctmp(maldos,neg,kv3));wsctmp=0.d0
                 call mpi_allreduce( weiwsc, wsctmp, kv3*maldos*neg, &
                      &              mpi_double_precision, &
                      &              mpi_sum,MPI_CommGroup,ierr )
!============================== modified by K. Tagami =============== 11.0
                  weiwsc = wsctmp

                 Do ik=is, kv3+is-nspin,nspin
                    weiwsc(:,:,ik) = wsctmp(:,:,ik)
                 End do
!==================================================================== 11.0
                 deallocate(wsctmp)
              endif
              if(sw_layer_decomp==ON)then
                 allocate(laytmp(mlayer,neg,kv3));laytmp=0.d0
                 call mpi_allreduce( weilay, laytmp, kv3*mlayer*neg, &
                      &              mpi_double_precision, &
                      &              mpi_sum,MPI_CommGroup,ierr )
!============================== modified by K. Tagami =============== 11.0
                  weilay = laytmp

                 Do ik=is, kv3+is-nspin,nspin
                    weilay(:,:,ik) = laytmp(:,:,ik)
                 End do
!==================================================================== 11.0
                 deallocate(laytmp)
              endif
           endif
           if(sw_ac_mesh==OFF)then
              do ik=is,kv3+is-nspin,nspin
                 call check_sum(ik,"softpart",.true.,modnrm /= EXECUT)
              enddo
           endif

           if(modnrm == EXECUT) then
              allocate(bfft(nfftp_nonpara))
              do ik = is, kv3+is-nspin, nspin
                 call m_FFT_alloc_CD_box()
                 if(sw_atom_decomp==ON .and. sw_ac_mesh==OFF) call fillup_meshwk(mode=HARDPART)
                 if(sw_layer_decomp==ON .and. sw_full_fftmesh==ON) call fillup_meshwk_layer(mode=HARDPART)

                 do ib = 1,neg
                    if(ipridos>=2) write(nfout,'(" !ldos   ib = ", i5)') ib
                    call m_CD_hardpart_sub(nfout,is,ik,ib,chgq0)  ! -> chgq_l
                    call m_CD_map_valence_charge_to_fft_box(is,nfftp_nonpara,bfft)
                    call m_FFT_CD_inverse0(nfout,bfft) ! bfft(G_sp.) -> bfft(R_sp.)
                    if(sw_atom_decomp==ON .and.sw_ac_mesh==OFF) call substitute_weiwsc_cd(ik,ib,.true.)
                    if(sw_atom_decomp==ON.and.sw_ac_mesh==ON)   call substitute_weiwsc_acmesh(ik,ib,.true.,.true.,wschard)
                    if(sw_layer_decomp==ON .and. sw_full_fftmesh==ON) call substitute_weilay_cd_fftmesh(ik,ib,.true.)
                    if(sw_layer_decomp==ON .and. sw_full_fftmesh==OFF) call substitute_weilay_cd(ik,ib,chgq0,.true.)
                 end do
                 if(sw_atom_decomp==ON .and. sw_ac_mesh==OFF) deallocate(meshwk)
                 if(sw_layer_decomp==ON .and. sw_full_fftmesh==ON) deallocate(meshwk_layer)
                 call m_FFT_dealloc_CD_box()
                 if(sw_ac_mesh==OFF) call check_sum(ik,"total   ",.true.,.true.)
              enddo
              deallocate(bfft)
           endif

        endif
     enddo

     if(sw_atom_decomp==ON .and. sw_ac_mesh==ON) then
        call mpi_allreduce(mpi_in_place,wscsoft,kv3*neg*maldos,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
        call mpi_allreduce(mpi_in_place,wschard,kv3*neg*maldos,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
        weiwsc = wscsoft+wschard
        do is=1,nspin,af+1
           do ik = is, kv3+is-nspin, nspin
              call check_sum(ik,"total   ",.true.,.true.)
              call check_sum(ik,"total   ",.true.,.false.)
           enddo
        enddo
     endif

     if(npes > 1) call mpi_barrier(MPI_CommGroup,ierr)
!     if(sw_save_ldos_weight == ON .and. ekmode == OFF) then
     if(sw_save_ldos_weight == ON .and. print_flag ) then
        if ( sw_lband == ON ) then
           if(sw_atom_decomp==ON) call wd_weight2(ALDOS,nfldos)
           if(sw_layer_decomp==ON) call wd_weight2(LAYERDOS,nfldos)
        else
           if(hardpart_subroutine==2 .or. sw_rspace_ldos==ON ) then
              if(sw_atom_decomp==ON) call wd_weight(ALDOS,nfldos)
              if(sw_layer_decomp==ON) call wd_weight(LAYERDOS,nfldos)
           else
              if(sw_atom_decomp==ON) call wd_weight_serial(ALDOS,nfldos)
              if(sw_layer_decomp==ON) call wd_weight_serial(LAYERDOS,nfldos)
           endif
        endif
     end if

    call m_CD_keep_retrieve_hsr(.false.)

    if(sw_atom_decomp==ON .and. sw_ac_mesh==ON)then
       deallocate(wscsoft)
       deallocate(wschard)
    endif
    if(modnrm == EXECUT) call m_CD_dealloc_ylm_enl_etc()
    if(hardpart_subroutine/=2 .and. &
         &  (sw_rspace_ldos==OFF .or. sw_rspace_lband==OFF) ) call m_CD_restore_chgq()
    if(allocated(meshwk)) deallocate(meshwk)

    if(sw_layer_decomp==ON) deallocate(zrhoik)

  contains

    subroutine wd_header
      integer :: i, j

      if ( sw_lband == OFF ) then
         if(sw_save_ldos_weight == ON .and. ekmode==OFF) then
            call m_Ldos_wd_natm2_and_totch( nfldos )
         endif
         if ( ekmode == ON .and. nk_in_the_process == 1 ) then
            call m_Ldos_wd_natm2_and_totch( nfldos )
         endif
      endif
      if ( sw_lband == ON ) then
         if ( ( ekmode == ON .and. nk_in_the_process == 1 ) &
              &  .or. ( ekmode == OFF) ) then
            write(nfldos,'(A)') "# Local Decomposition for bands"
            write(nfldos,*) ""
            write(nfldos,'(A,I8)') ' num_kpoints = ', max(kv3,kv3_ek) /ndim_spinor
            write(nfldos,'(A,I8)') ' num_bands   = ', neg -num_extra_bands
            write(nfldos,'(A,I8)') ' nspin       = ', nspin /ndim_spinor
            write(nfldos,*) ""
            write(nfldos,'(A)') "# Decomposition Info."

            if ( sw_atom_decomp == ON ) then
               write(nfldos,'(A,I8,A)') ' num_atoms   = ', natom_decomp +1, &
                    &        "  ( last 1 corresponds to external region )"
            endif
            if ( sw_layer_decomp == ON ) then
               write(nfldos,'(A,I8,A)') ' num_layers  = ', nlayer +1, &
                    &        "  ( last 1 corresponds to external region )"
            endif
            write(nfldos,*) ""

            if ( sw_atom_decomp == ON ) then
               write(nfldos,'(A)') "# Atom Info."
               write(nfldos,'(A)') "   no.    target_atom    species"
               Do i=1, natom_decomp
                  j = atom_decomp_map(i)
                  write(nfldos,'(I5,5X,I5,12X,A)') i, j, speciesname(ityp(j))
               end Do
               write(nfldos,'(I5)') natom_decomp +1
               write(nfldos,*)
            endif
            if ( sw_layer_decomp == ON ) then
               write(nfldos,'(A)') "# Layer Info."
               write(nfldos,'(A)') "   no.       min.         max.  (Angstrom)"
               Do i=1, nlayer +1
                  write(nfldos,'(I5,2(5X,F8.4))') i, winlay(i,1)*BOHR, winlay(i,2)*BOHR
               end Do
               write(nfldos,*)
            endif
         endif
      endif
    end subroutine wd_header

    subroutine wd_weight2(mode,nfldos)
      integer, intent(in) :: mode, nfldos
      integer :: m, ib, ib_ordr, kend, kstep, iws, ik, iks
      integer :: itmp, count
      real(kind=DP),allocatable,dimension(:,:,:):: wei

!      write(nfout,'(a,2i8)') '!** in wd2_weight ',ik,mode

      if(mode==ALDOS) then
         m = maldos
      else if(mode==LAYERDOS) then
         m = mlayer
      end if
      allocate(wei(m,neg,kv3)); wei = 0.d0

      if(mode==ALDOS)then
         do ik=ista_k, iend_k
            do ib = ista_e, iend_e, istep_e
               wei(1:m,ib,ik) = weiwsc(1:m,map_z(ib),ik)
            end do
         end do
      else if(mode==LAYERDOS)then
         do ik=ista_k, iend_k
            do ib = ista_e, iend_e, istep_e
               wei(1:m,ib,ik) = weilay(1:m,map_z(ib),ik)
            end do
         end do
      endif

      if (npes>1) then
         call mpi_allreduce( MPI_IN_PLACE, wei, m*neg*kv3, mpi_double_precision, &
              &              mpi_sum, MPI_CommGroup, ierr )
      end if

      if(mype == 0) then
         Do ik=1, kv3
            iks = 0
            if ( sw_lband == ON .and. ekmode == ON ) then
               iks = nk_in_the_process -1
               if ( ik +iks > kv3_ek ) cycle
            endif
            if(mode==ALDOS) then
               write(nfldos,'(" weight for each atomic cell    nk = ",i8)') ik+iks
            else if(mode==LAYERDOS) then
               write(nfldos,'(" weight for each layer          nk = ",i8)') ik+iks
            end if

            if ( mode==ALDOS .and. sw_wd_only_specified_atoms == ON ) then
               do ib = 1, neg -num_extra_bands
                  write(nfldos,'(i4,A)',advance="no") ib, ")"
                  count = 0
                  do iws=1, m-1
                     if ( if_aldos_full(iws)==1 ) then
                        count = count +1
                        if ( count > 1 .and. mod(count,ilen)==1 ) then
                           write(nfldos,'(5x)',advance="no")
                        endif
                        write(nfldos,'(f15.10)',advance="no") wei(iws,ib,ik)
                        if ( mod(count,ilen)==0 ) write(nfldos,*)
                     endif
                  end do
                  count = count +1
                  if ( count > 1 .and. mod(count,ilen)==1 ) then
                     write(nfldos,'(5x)',advance="no")
                  endif
                  write(nfldos,'(f15.10)') wei(maldos,ib,ik)
               end do
            else
               do ib = 1, neg -num_extra_bands
                  if(ilen >= m) then
                     write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws,ib,ik),iws=1,m)
                  else
                     write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws,ib,ik),iws=1,ilen)
                     write(nfldos,'(5x,5f15.10)') (wei(iws,ib,ik),iws=ilen+1,m)
                  end if
               end do
            endif
         end Do
      end if
      deallocate(wei)
    end subroutine wd_weight2

    subroutine wd_weight(mode,nfldos)
      integer, intent(in) :: mode, nfldos
      integer :: m, ik, ib, ib_ordr, kend, kstep, iws, ip, iks
      real(kind=DP),allocatable,dimension(:):: wei

      if(mode==ALDOS) then
         m = maldos
      else if(mode==LAYERDOS) then
         m = mlayer
      end if

      allocate(wei(m))

      if(ekmode==OFF) then
         kend = kv3; kstep = af+1
      else if(ekmode==ON) then
!         kend = 1;   kstep = 1
         kend = kv3;   kstep = 1
      end if

      if(ipridos >= 3) then
         do ik = 1, kv3, af+1
            if(map_k(ik) /= myrank_k) cycle
            write(nfout,'(" !ldos: ik = ",i8)') ik
            do ib = 1, neg
               write(nfout,'(" !ldos: ib, ib_ordr = ",2i20)') ib, neordr(ib,ik)
            end do
         end do
      end if

      do ik = 1, kend, kstep
         iks = 0
         if ( sw_lband == ON .and. ekmode == ON ) then
            iks = nk_in_the_process -1
            if ( ik +iks > kv3_ek ) cycle
         endif
         if(mype == 0) then
            if(mode==ALDOS) then
               write(nfldos,'(" weight for each atomic cell    nk = ",i8)') ik+iks
            else if(mode==LAYERDOS) then
               write(nfldos,'(" weight for each layer          nk = ",i8)') ik+iks
            end if
         end if

         do ib = 1, neg -num_extra_bands

            if(nrank_k >= 2) then
               if(map_ek(ib,ik) == mype) ib_ordr = neordr(ib,ik)
               call mpi_bcast(ib_ordr,1,mpi_integer,map_ek(ib,ik),MPI_CommGroup,ierr)
            else
               ib_ordr = neordr(ib,ik)
            end if

            if(map_ek(ib_ordr,ik) == mype) then
               if(mode == ALDOS) then
                  wei(1:m) = weiwsc(1:m,map_z(ib_ordr),ik)
               else if(mode == LAYERDOS) then
                  wei(1:m) = weilay(1:m,map_z(ib_ordr),ik)
               end if
               if(map_ek(ib_ordr,ik) /= 0) &
                  call mpi_send(wei,m,mpi_double_precision,0,1,MPI_CommGroup,ierr)
             else if(mype == 0 .and. map_ek(ib_ordr,ik) /= 0) then
                call mpi_recv(wei,m,mpi_double_precision,map_ek(ib_ordr,ik),1,MPI_CommGroup,istatus,ierr)
             end if
             if(mype == 0)  then
               if(ilen >= m) then
                  write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws),iws=1,m)
               else
                  write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws),iws=1,ilen)
                  write(nfldos,'(5x,5f15.10)') (wei(iws),iws=ilen+1,m)
               end if
             end if
          end do
       end do

       deallocate(wei)
     end subroutine wd_weight

    subroutine wd_weight_serial(mode,nfldos)
      integer, intent(in) :: mode, nfldos
      integer :: m, ik, ib, ib_ordr, kend, kstep, iws, ip
      real(kind=DP),allocatable,dimension(:):: wei

      if(mode==ALDOS) then
         m = maldos
      else if(mode==LAYERDOS) then
         m = mlayer
      end if

      allocate(wei(m))

      if(ekmode==OFF) then
         kend = kv3; kstep = af+1
      else if(ekmode==ON) then
!         kend = 1;   kstep = 1
         kend = kv3;   kstep = 1
      end if

      if(ipridos >= 3) then
         do ik = 1, kv3, af+1
            if(map_k(ik) /= myrank_k) cycle
            write(nfout,'(" !ldos: ik = ",i8)') ik
            do ib = 1, neg
               write(nfout,'(" !ldos: ib, ib_ordr = ",2i20)') ib, neordr(ib,ik)
            end do
         end do
      end if

      do ik = 1, kend, kstep
         if(mype == 0) then
            if(mode==ALDOS) then
               write(nfldos,'(" weight for each atomic cell    nk = ",i8)') ik
            else if(mode==LAYERDOS) then
               write(nfldos,'(" weight for each layer          nk = ",i8)') ik
            end if
         end if

         do ib = 1, neg -num_extra_bands

             if(mode == ALDOS) then
                wei(1:m) = weiwsc(1:m,ib,ik)
             else if(mode == LAYERDOS) then
                wei(1:m) = weilay(1:m,ib,ik)
             end if
             if(mype == 0)  then
               if(ilen >= m) then
                  write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws),iws=1,m)
               else
                  write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws),iws=1,ilen)
                  write(nfldos,'(5x,5f15.10)') (wei(iws),iws=ilen+1,m)
               end if
             end if
         end do
      end do

       deallocate(wei)
     end subroutine wd_weight_serial

    subroutine check_sum(ik,aword,serial,norma)
      integer,intent(in) :: ik
      character*(*),intent(in) :: aword
      logical, intent(in) :: serial
      logical, intent(in) :: norma

      integer :: ib, ia, ilay, ib_ordr, ik_t
      real(kind=DP), allocatable, dimension(:) :: sum_aldos, sum_layer, sum_mpi


      if(sw_atom_decomp==ON) allocate(sum_aldos(neg))
      if(sw_layer_decomp==ON) allocate(sum_layer(neg))

      if ( sw_lband == ON ) then
         ik_t = ik
      else
         if(ekmode /= ON) then
            ik_t = ik
         else if(ekmode == ON) then
            ik_t = 1
         end if
      endif

      if(sw_atom_decomp==ON .or. sw_layer_decomp==ON) then
         if(nrank_e >= 2) then
            allocate(sum_mpi(neg)); sum_mpi = 0.d0
         end if
      end if
      if(sw_atom_decomp==ON) then
         sum_aldos = 0.d0
         do ib = 1, neg
            if(.not.serial)then
               if(map_ek(ib,ik_t) == mype) then
                  do ia = 1, natm2 + 1
                     sum_aldos(ib) = sum_aldos(ib) + weiwsc(ia,map_z(ib),ik_t)
                  end do
               endif
            else
               do ia = 1, natm2 + 1
                  sum_aldos(ib) = sum_aldos(ib) + weiwsc(ia,ib,ik_t)
               end do
            end if
         end do
         if(.not.serial)then
            if(nrank_e >= 2) then
               sum_mpi = 0.d0
               call mpi_allreduce(sum_aldos,sum_mpi,neg,mpi_double_precision &
                    & , mpi_sum, mpi_k_world(myrank_k),ierr)
               sum_aldos = sum_mpi
            end if
         endif
      end if

      if(sw_layer_decomp==ON) then
         sum_layer = 0.d0
         do ib = 1, neg
            if(.not.serial)then
               if(map_e(ib) == myrank_e) then
                  do ilay = 1, mlayer
                     sum_layer(ib) = sum_layer(ib) + weilay(ilay,map_z(ib),ik_t)
                  end do
               endif
            else
               do ilay = 1, mlayer
                  sum_layer(ib) = sum_layer(ib) + weilay(ilay,ib,ik_t)
               end do
            end if
         end do
         if(.not.serial)then
            if(nrank_e >= 2) then
               sum_mpi = 0.d0
               call mpi_allreduce(sum_layer,sum_mpi,neg,mpi_double_precision &
                    & , mpi_sum, mpi_k_world(myrank_k),ierr)
               sum_layer = sum_mpi
            end if
         endif
      end if

!!$      if(mype == 0) then
      if(ipridos>=1) then
         if(sw_atom_decomp==ON .and. sw_layer_decomp==ON) then
            write(nfout,'(" !!ldos ",a8," -- iban , sum(atomic, layer) --  neg = ",i6 &
                 & ," natm2 = ",i6, " ik = ",i6)') aword,neg,natm2,ik
            do ib = 1, neg
               if(serial) then
                  ib_ordr = ib
               else
                  ib_ordr = neordr(ib,ik)
               endif
               write(nfout,'(" !!ldos ", i4,2f16.8)') ib, sum_aldos(ib_ordr), sum_layer(ib_ordr)
            end do
         else if(sw_atom_decomp==ON) then
            write(nfout,'(" !!ldos ",a8," -- iban , sum(atomic) --  neg = ",i6 &
                 & ," natm2 = ",i6," ik = ",i6)') aword,neg,natm2,ik
            do ib = 1, neg
               if(serial) then
                  ib_ordr = ib
                  write(nfout,'(" !!ldos ", i4,f16.8)') ib, sum_aldos(ib_ordr)
               else
                  if(map_ek(ib,ik_t) == mype) then
                    ib_ordr = neordr(ib,ik)
                    write(nfout,'(" !!ldos ", i4,f16.8)') ib, sum_aldos(ib_ordr)
                  endif
               endif
            end do
         else if(sw_layer_decomp == ON) then
            write(nfout,'(" !!ldos ",a8," -- iban , sum(layer ) --  neg = ",i6 &
                 & ," natm2 = ",i6," ik = ",i6)') aword,neg,natm2,ik
            do ib = 1, neg
               if(serial) then
                  ib_ordr = ib
               else
                  ib_ordr = neordr(ib,ik)
               endif
               write(nfout,'(" !!ldos ",i4,f16.8)') ib, sum_layer(ib_ordr)
            end do
         end if
      end if
      if (norma .and. sw_atom_decomp==ON .and. sw_ac_mesh==ON) then
        if(.not.serial)then
           do ib=ista_e,iend_e,istep_e
              weiwsc(:,map_z(ib),ik_t) = weiwsc(:,map_z(ib),ik_t)/sum_aldos(ib)
           enddo
        else
           do ib=1,neg
              weiwsc(:,ib,ik_t) = weiwsc(:,ib,ik_t)/sum_aldos(ib)
           enddo
        endif
      endif

      if(sw_atom_decomp==ON) deallocate(sum_aldos)
      if(sw_layer_decomp==ON) deallocate(sum_layer)
      if(allocated(sum_mpi)) deallocate(sum_mpi)
!!$      if(ekmode /= ON .and. (sw_aldos == ON .or. sw_layerdos == ON) .and. npes >= 2) deallocate(sum_mpi)

    end subroutine check_sum

    subroutine substitute_weilay(ik,ib,serial)
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!
      integer, intent(in) :: ik,ib
      logical, intent(in) :: serial

      integer :: i, ilay, iax1, iax2, iax3, ib_t
      real(kind=DP) :: a1,a2,width, g,ss
      complex(kind=CMPLDP) :: zi,zsum,zchg
      real(kind=DP),allocatable,dimension(:) :: zsum_layer, zsum_layer_mpi

      allocate(zsum_layer(mlayer)); zsum_layer = 0.d0

!!$      zi = cmplx(0.d0,1.d0)
      zi = cmplx(0.d0,1.d0)*PAI2

      iax1 = normal_axis_winlay
      iax2 = iax1 + 1
      if(iax2 >= 4) iax2 = iax2 - 3
      iax3 = iax2 + 1
      if(iax3 >= 4) iax3 = iax3 - 3


!!$      rl11 = rltv(iax1,iax1)
!!$      ss = 1.d0/maxhv
      ss = 3.d0 - kimg

!!$      call get_height(height)

!!$      n = fft_box_size_WF(1,0)*fft_box_size_WF(2,0)*fft_box_size_WF(3,1)
!!$      n = nfft*kimg/kimg/2
      do i = 1, nfft/2
         bfft(2*i-1) = bfft(2*i-1)**2 + bfft(2*i)**2
         bfft(2*i  ) = 0.d0
      end do
      call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
      if(kimg == 1) then
         do i = 1, kg
            zrhoik(i) = bfft(igf(i))*denom
         end do
      else
         do i = 1, kg
            zrhoik(i*2-1) = bfft(igf(i)*2-1)*denom
            zrhoik(i*2  ) = bfft(igf(i)*2  )*denom
         end do
      end if

      do ilay = 1, mlayer
!!$         a2 = winlay(ilay,2)
!!$         a1 = winlay(ilay,1)
         a2 = winlay(ilay,2)/height
         a1 = winlay(ilay,1)/height
         width = a2 - a1
         zsum = cmplx(zrhoik(1)*width,0.d0)
!!$         zsum = univol*cmplx(zrhoik(1)*width,0.d0)
         if(kimg == 1) then
            do i = 2, kg
               if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
!!$                  g = rl11*ngabc(i,iax1)
                  g = ngabc(i,iax1)
                  zsum = zsum  &
                       & + zrhoik(i)*((cdexp(zi*g*a2)-cdexp(zi*g*a1))/( zi*g ))
               end if
            end do
         else if(kimg == 2) then
            do i = 2, kg
               if(ngabc(i,iax2) ==  0 .and. ngabc(i,iax3) == 0) then
!!$                  g = rl11*ngabc(i,iax1)
                  g = ngabc(i,iax1)
                  zchg = dcmplx(zrhoik(i*2-1),zrhoik(i*2))
                  zsum = zsum  &
                       & + zchg*((cdexp(zi*g*a2)-cdexp(zi*g*a1))/( zi*g ))
               endif
            enddo
         endif
         zsum_layer(ilay) = real(zsum)*ss
      end do

      if ( sw_lband == ON ) then
         ib_t = map_z(ib)
      else
         if(ekmode == ON.or.serial) then
            ib_t = ib
         else
            ib_t = map_z(ib)
         end if
      endif

      do ilay = 1, mlayer
         weilay(ilay,ib_t,ik) = zsum_layer(ilay)
      end do

      deallocate(zsum_layer)

    end subroutine substitute_weilay

    subroutine substitute_weilay_fftmesh(ik,ib,serial)
!   *********************************
!     by T.Yamasaki
!           7th Apr 2017
!   *********************************
!
      integer, intent(in) :: ik,ib
      logical, intent(in) :: serial
      integer :: ijk, nwsc,n, nel, ib_t
      real(kind=DP) :: xx, denom
      real(kind=DP),allocatable,dimension(:) :: adjustfactor ! d(mlayer)
      integer, save :: nwritecount = 0

      nel = product(fft_box_size_WF(1:3,1))
      denom = 1.d0/dble(nel)
      if(ipridos >= 2) write(nfout,'(" !!ldos: ib, nfft, natm2 = ",i6,i12,i6,"  <<substitute_weiwsc>>")') &
           & ib, nfft, natm2

      if ( sw_lband == ON ) then
         ib_t = map_z(ib)
      else
         if(ekmode == ON.or.serial) then
            ib_t = ib
         else if(ekmode == OFF) then
            ib_t = map_z(ib)
         end if
      endif

      allocate(adjustfactor(mlayer))
      call get_adjustfactor(winlay,mlayer,nmeshlay,adjustfactor,nwritecount) ! winlay,height,nmeshl -> adustfactor
      if(nwritecount==0) nwritecount=1
      do ijk = 1, nel
         nwsc = meshwk_layer(ijk,1)
         n    = meshwk_layer(ijk,2)
         if((n < 1 .or. 2*n > nfft) .or. (nwsc < 1 .or. nwsc >mlayer+1) ) then
            if(ipridos>=1) then
               write(nfout,'(" !!ldos: n = ",i6," ijk = ",i6)') n, ijk
               write(nfout,'(" !!ldos: nwsc = ",i9)') nwsc
            end if
         else
!!$            xx = denom*(bfft(2*n-1)**2 + bfft(2*n)**2)
            xx = denom*(bfft(2*n-1)**2 + bfft(2*n)**2)*adjustfactor(nwsc)
            weilay(nwsc,ib_t,ik) = weilay(nwsc,ib_t,ik) + xx
         end if
      end do
      deallocate(adjustfactor)
    end subroutine substitute_weilay_fftmesh

    subroutine substitute_weiwsc(ik,ib,serial)
      integer, intent(in) :: ik,ib
      logical, intent(in) :: serial
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!
      integer :: ijk, nwsc,n, nel, ib_t
      real(kind=DP) :: xx, denom

      nel = product(fft_box_size_WF(1:3,1))
      denom = 1.d0/dble(nel)
      if(ipridos >= 2) write(nfout,'(" !!ldos: ib, nfft, natm2 = ",i6,i12,i6,"  <<substitute_weiwsc>>")') &
           & ib, nfft, natm2

      if ( sw_lband == ON ) then
         ib_t = map_z(ib)
      else
         if(ekmode == ON.or.serial) then
            ib_t = ib
         else if(ekmode == OFF) then
            ib_t = map_z(ib)
         end if
      endif

      do ijk = 1, nel
         nwsc = meshwk(ijk,1)
         n    = meshwk(ijk,2)
         if((n < 1 .or. 2*n > nfft) .or. (nwsc < 1 .or. nwsc >natm2+1) ) then
            if(ipridos>=1) then
               write(nfout,'(" !!ldos: n = ",i6," ijk = ",i6)') n, ijk
               write(nfout,'(" !!ldos: nwsc = ",i9)') nwsc
            end if
         else
            xx = denom*(bfft(2*n-1)**2 + bfft(2*n)**2)
            weiwsc(nwsc,ib_t,ik) = weiwsc(nwsc,ib_t,ik) + xx
         end if
      end do

      if(ipridos >= 2) then
         write(nfout,'(" !ldos: ik, ib = ",2i8," <<substitute_weiwsc>>")') ik, ib
         write(nfout,'(" !ldos: ",8f10.5)') (weiwsc(nwsc,ib_t,ik),nwsc=1,maldos)
      end if

    end subroutine substitute_weiwsc

    subroutine substitute_weiwsc_acmesh(ik,ib,serial,cd,wsc)
      integer, intent(in) :: ik,ib
      logical, intent(in) :: serial,cd
      real(kind=DP), intent(inout), dimension(maldos,neg,kv3) :: wsc
      integer :: ijk, nwsc,n, ib_t
      real(kind=DP) :: xx, denom
      integer :: i,j,k, id, nl, nm, nn, nlhf,inew,jnew,knew,ip,mm,is,nl2,nm2,nn2
      integer :: ii,jj,kk,iatm
      real(kind=DP) :: ri,rj,rk
      real(kind=DP), allocatable, dimension(:) :: xmat,ymat,zmat
      real(kind=DP), allocatable, dimension(:,:,:) :: cmatr
      real(kind=DP) :: rho
      real(kind=DP) :: trilinear_interpolation,closest
      integer, pointer, dimension(:,:) :: amesh
      integer, pointer, dimension(:) :: namesh
      integer :: ista,iend
      integer :: id_sname = -1
      call tstatc0_begin('substitute_weiwsc_acmesh ',id_sname,level=1)
      if(printable .and. ib==1)then
        if(.not.cd) then
          write(nfout,'(a,i10,a)') ' !** AC MESH processing kpoint no. ',ik,' (softpart)'
        else
          write(nfout,'(a,i10,a)') ' !** AC MESH processing kpoint no. ',ik,' (hardpart)'
        endif
      endif
      if(cd)then
        id = fft_box_size_CD_nonpara(1,0)
        mm = fft_box_size_CD_nonpara(2,0)
        nl = fft_box_size_CD(1,1)
        nm = fft_box_size_CD(2,1)
        nn = fft_box_size_CD(3,1)
        ista = ista_atm2
        iend = iend_atm2
      else
        id = fft_box_size_WF(1,0)
        mm = fft_box_size_WF(2,0)
        nl = fft_box_size_WF(1,1)
        nm = fft_box_size_WF(2,1)
        nn = fft_box_size_WF(3,1)
        ista = 1
        iend = natm2
      endif
      nl2=nl+2;nm2=nm+2;nn2=nn+2
      allocate(xmat(nl2));allocate(ymat(nm2));allocate(zmat(nn2))
      allocate(cmatr(nl2,nm2,nn2))
      if(kimg == 1) then
         nlhf = id/2
      else
         nlhf = id
      end if
      if(cd) then
        do i = 0, nm+1
          do j = 0, nn+1
            do k = 0, nl+1
              ii=i;jj=j;kk=k
              if(i.eq.0) ii = nm
              if(j.eq.0) jj = nn
              if(k.eq.0) kk = nl
              if(i.eq.nm+1) ii = 1
              if(j.eq.nn+1) jj = 1
              if(k.eq.nl+1) kk = 1
              if(kimg == 1 .and. kk > nlhf) then
                 knew = id - kk
                 jnew = nn+2 - jj
                 inew = nm+2 - ii
                 if(jnew > nn) then
                    jnew = jnew - nn
                 end if
                 if(inew > nm) then
                    inew = inew - nm
                 end if
              else
                 knew = kk; jnew = jj; inew = ii
              end if
              ip = nlhf*mm*(jnew-1) + nlhf*(inew-1) + knew
              xmat(k+1) = dble(k)/dble(nl)
              ymat(i+1) = dble(i)/dble(nm)
              zmat(j+1) = dble(j)/dble(nn)
              cmatr(k+1,i+1,j+1) = bfft(ip*2-1)
             enddo
          enddo
        enddo
      else
        do i = 0, nm+1
          do j = 0, nn+1
            do k = 0, nl+1
              ii=i;jj=j;kk=k
              if(i.eq.0) ii = nm
              if(j.eq.0) jj = nn
              if(k.eq.0) kk = nl
              if(i.eq.nm+1) ii = 1
              if(j.eq.nn+1) jj = 1
              if(k.eq.nl+1) kk = 1
              if(kimg == 1 .and. kk > nlhf) then
                 knew = id - kk
                 jnew = nn+2 - jj
                 inew = nm+2 - ii
                 if(jnew > nn) then
                    jnew = jnew - nn
                 end if
                 if(inew > nm) then
                    inew = inew - nm
                 end if
              else
                 knew = kk; jnew = jj; inew = ii
              end if
              ip = nlhf*mm*(jnew-1) + nlhf*(inew-1) + knew
              xmat(k+1) = dble(k)/dble(nl)
              ymat(i+1) = dble(i)/dble(nm)
              zmat(j+1) = dble(j)/dble(nn)
              cmatr(k+1,i+1,j+1) = bfft(ip*2-1)**2+bfft(ip*2)**2
            enddo
          enddo
        enddo
      endif

      if ( sw_lband == ON ) then
         ib_t = map_z(ib)
      else
         ib_t = map_z(ib)
         if(ekmode == ON.or.serial) ib_t = ib
      endif

      if(cd) then
        namesh => nac_mesh_cd
      else
        namesh => nac_mesh
      endif

      if(cd) then
        denom = 0.5d0*univol/dble(product(fft_box_size_CD(1:3,1)))/dble(acmesh_factor*acmesh_factor*acmesh_factor)
      else
        denom = 1.d0/dble(product(fft_box_size_WF(1:3,1)))/dble(acmesh_factor*acmesh_factor*acmesh_factor)
      endif
      do iatm=ista,iend
         if(cd)then
           amesh => ac_mesh_cd(iatm,:,:)
         else
           amesh => ac_mesh(iatm,:,:)
         endif
         do ijk=1,namesh(iatm)
            ii = amesh(ijk,1)
            jj = amesh(ijk,2)
            kk = amesh(ijk,3)
            ri = dble(ii+acmesh_factor)/dble(nl*acmesh_factor)+pos(iatm,1)
            rj = dble(jj+acmesh_factor)/dble(nm*acmesh_factor)+pos(iatm,2)
            rk = dble(kk+acmesh_factor)/dble(nn*acmesh_factor)+pos(iatm,3)
            if(ri < 0.d0) ri = (ceiling(-ri)) + ri
            if(ri > 1.d0) ri = ri - floor(ri)
            if(rj < 0.d0) rj = (ceiling(-rj)) + rj
            if(rj > 1.d0) rj = rj - floor(rj)
            if(rk < 0.d0) rk = (ceiling(-rk)) + rk
            if(rk > 1.d0) rk = rk - floor(rk)
            rho = trilinear_interpolation(nl2,nm2,nn2,cmatr,xmat,ymat,zmat,ri,rj,rk)
            xx = denom*rho
            wsc(iatm,ib_t,ik) = wsc(iatm,ib_t,ik)+xx
         enddo
      enddo

      deallocate(xmat)
      deallocate(ymat)
      deallocate(zmat)
      deallocate(cmatr)
      call tstatc0_end(id_sname)
    end subroutine substitute_weiwsc_acmesh

    subroutine substitute_weiwsc_cd(ik,ib,serial)
      integer, intent(in) :: ik,ib
      logical, intent(in) :: serial
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!
      integer :: ijk, nwsc,n, ib_t
      real(kind=DP) :: denom

      denom = 0.5d0*univol/product(fft_box_size_CD(1:3,1))

      if ( sw_lband == ON ) then
         ib_t = map_z(ib)
      else
         if(ekmode == ON.or.serial) then
            ib_t = ib
         else if(ekmode == OFF) then
            ib_t = map_z(ib)
         end if
      endif

      do ijk = 1, product(fft_box_size_CD(1:3,1))
         nwsc = meshwk(ijk,1)
         n    = meshwk(ijk,2)
         if((n < 1 .or. 2*n > nfftp_nonpara) .or. (nwsc < 1 .or. nwsc >natm2+1) ) then
            if(ipridos>=1) then
               write(nfout,'(" !!ldos: n = ",i6," ijk = ",i6)') n, ijk
               write(nfout,'(" !!ldos: nwsc = ",i9)') nwsc
            end if
         else
            weiwsc(nwsc,ib_t,ik) = weiwsc(nwsc,ib_t,ik) + denom*bfft(2*n-1)
! =============================== modified by K. Tagami ============ 11.0
!            weiwsc(nwsc,ib_t,ik) = weiwsc(nwsc,ib_t,ik) + denom*bfft(2*n-1)
!
!            if (map_ek(ib,ik) == mype) then
!               weiwsc(nwsc,ib_t,ik) = weiwsc(nwsc,ib_t,ik) + denom*bfft(2*n-1)
!            endif
! ================================================================== 11.0
         end if
      end do

      if(ipridos >=2) then
         write(nfout,'(" !ldos: ik ,ib = ",2i8)') ik, ib
         write(nfout,'(" !ldos: ",8f10.5)') (weiwsc(nwsc,ib_t,ik),nwsc=1,maldos)
      end if

    end subroutine substitute_weiwsc_cd

    subroutine substitute_weilay_cd(ik,ib,chgq0,serial)
      integer, intent(in) :: ik, ib
      real(kind=DP), intent(in) :: chgq0
      logical, intent(in) :: serial
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!
      integer :: i, ista, iax1, iax2, iax3, ilay,  ib_t
      real(kind=DP) :: g, z_work, ss, a1, a2, width
      complex(kind=CMPLDP) :: zi,zsum,zchg
      real(kind=DP),allocatable,dimension(:,:) :: zsum_layer, zsum_layer_mpi

      allocate(zsum_layer(mlayer,2)); zsum_layer = 0.d0

      zi = cmplx(0.d0,1.d0)*PAI2

      iax1 = normal_axis_winlay
      iax2 = iax1 + 1
      if(iax2 >= 4) iax2 = iax2 - 3
      iax3 = iax2 + 1
      if(iax3 >= 4) iax3 = iax3 - 3

!!$      rl11 = rltv(iax1,iax1)
!!$      ss = 0.5d0*univol/maxhv
      ss = 0.5d0*univol*(3.d0-kimg)


      ista = ista_kngp
      if(ista == 1) ista = 2
      do ilay = 1, mlayer
         if(ipridos >= 2) write(nfout,'(" !!ldos: ib = ",i6," ilay = ",i6 &
              & ," <<substitute_weilay_cd>>")') ib,ilay
         a2 = winlay(ilay,2)/height
         a1 = winlay(ilay,1)/height
         width = a2 - a1
         z_work = chgq0*width
         if(serial)then
            if(ista/=2) z_work=0.d0
         endif
         zsum = 0.d0

         if(kimg == 1) then
            if ( sw_lband == ON ) then
               do i = 2, kgp
                  if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                     g = ngabc(i,iax1)
                     zsum = zsum  &
                          & + chgq_enl(i,1)*( ( cdexp(zi*g*a2) - cdexp(zi*g*a1))/(zi*g))
                  end if
               end do
            else
               if(ekmode == ON.or.serial) then
                  do i = ista, iend_kngp
                     if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                        g = ngabc(i,iax1)
                        zsum = zsum  &
                             & + chgq_l(i,1,1)*((cdexp(zi*g*a2) -cdexp(zi*g*a1))/(zi*g))
                     end if
                  end do
               else if(ekmode == OFF) then
                  do i = 2, kgp
                     if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                        g = ngabc(i,iax1)
                        zsum = zsum  &
                          & + chgq_enl(i,1)*( ( cdexp(zi*g*a2) - cdexp(zi*g*a1))/(zi*g))
                     end if
                  end do
               end if
            endif
         else if(kimg == 2) then
            if ( sw_lband == ON ) then
               do i = 2, kgp
                  if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                     g = ngabc(i,iax1)
                     zchg = cmplx(chgq_enl(i,1),chgq_enl(i,2))
                     zsum = zsum &
                          & + zchg * ((cdexp(zi*g*a2) - cdexp(zi*g*a1))/(zi*g))
                  end if
               end do
            else
               if(ekmode == ON.or.serial) then
                  do i = ista, iend_kngp
                     if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                        g = ngabc(i,iax1)
                        zchg = cmplx(chgq_l(i,1,1),chgq_l(i,2,1))
                        zsum = zsum &
                             & + zchg * ((cdexp(zi*g*a2) - cdexp(zi*g*a1))/(zi*g))
                     end if
                  end do
               else if(ekmode == OFF) then
                  do i = 2, kgp
                     if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                        g = ngabc(i,iax1)
                        zchg = cmplx(chgq_enl(i,1),chgq_enl(i,2))
                        zsum = zsum &
                             & + zchg * ((cdexp(zi*g*a2) - cdexp(zi*g*a1))/(zi*g))
                     end if
                  end do
               end if
            endif
         end if
         zsum = zsum + cmplx(z_work,0.d0)

         zsum_layer(ilay,1) = real(zsum)
         zsum_layer(ilay,2) = dimag(zsum)

      end do

#if 0
      if(ekmode == ON.or.serial) then
         if(npes > 1) then
            allocate(zsum_layer_mpi(mlayer,2))
            call mpi_allreduce(zsum_layer,zsum_layer_mpi,mlayer*2 &
                 & ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
            zsum_layer = zsum_layer_mpi
            deallocate(zsum_layer_mpi)
         end if
      end if

      if(mype == 0) then
         do ilay = 1, mlayer
            if(zsum_layer(ilay,2) > 1.d-6) then
               write(6,'(" !!ldos: zsum,ne.real imag = ",d16.8," ilay = ",i6)') &
                    & zsum_layer(ilay,2), ilay
            endif
!!$            write(6,'(" !!ldos zsum_layer = ",d16.8," ilay = ",i6)') &
!!$                 & zsum_layer(ilay,1), ilay
         end do
      end if
#endif

      if ( sw_lband == ON ) then
         ib_t = map_z(ib)
      else
         if(ekmode == ON.or.serial) then
            ib_t = ib
         else
            ib_t = map_z(ib)
         end if
      endif

      do ilay = 1, mlayer
         weilay(ilay,ib_t,ik) = weilay(ilay,ib_t,ik) + zsum_layer(ilay,1)*ss
      end do
! ========================= modified by K. Tagami =============== 11.0
!      do ilay = 1, mlayer
!         weilay(ilay,ib_t,ik) = weilay(ilay,ib_t,ik) + zsum_layer(ilay,1)*ss
!      end do
!
!      if (map_ek(ib,ik) == mype) then
!         do ilay = 1, mlayer
!            weilay(ilay,ib_t,ik) = weilay(ilay,ib_t,ik) + zsum_layer(ilay,1)*ss
!         end do
!      endif
! ============================================================== 11.0

      deallocate(zsum_layer)

    end subroutine substitute_weilay_cd

    subroutine substitute_weilay_cd_fftmesh(ik,ib,serial)
      integer, intent(in) :: ik, ib
      logical, intent(in) :: serial
!   *********************************
!     by T.Yamasaki
!           7th Apr 2017
!   *********************************
!
      integer :: ijk, nwsc,n, ib_t
      real(kind=DP) :: denom
      real(kind=DP),allocatable,dimension(:) :: adjustfactor ! d(mlayer)
      integer, save :: nwritecount = 0

      denom = 0.5d0*univol/product(fft_box_size_CD(1:3,1))

      if ( sw_lband == ON ) then
         ib_t = map_z(ib)
      else
         if(ekmode == ON.or.serial) then
            ib_t = ib
         else if(ekmode == OFF) then
            ib_t = map_z(ib)
         end if
      endif

      allocate(adjustfactor(mlayer))
      call get_adjustfactor(winlay,mlayer,nmeshplay,adjustfactor,nwritecount) ! winlay,height,nmeshl -> adustfactor
      if(nwritecount==0) nwritecount=1

      do ijk = 1, product(fft_box_size_CD(1:3,1))
         nwsc = meshwk_layer(ijk,1)
         n    = meshwk_layer(ijk,2)
         if((n < 1 .or. 2*n > nfftp_nonpara) .or. (nwsc < 1 .or. nwsc >mlayer+1) ) then
            if(ipridos>=1) then
               write(nfout,'(" !!ldos: n = ",i6," ijk = ",i6)') n, ijk
               write(nfout,'(" !!ldos: nwsc = ",i9)') nwsc
            end if
         else
!!$            weilay(nwsc,ib_t,ik) = weilay(nwsc,ib_t,ik) + denom*bfft(2*n-1)
            weilay(nwsc,ib_t,ik) = weilay(nwsc,ib_t,ik) + denom*bfft(2*n-1)*adjustfactor(nwsc)
         end if
      end do
      deallocate(adjustfactor)
    end subroutine substitute_weilay_cd_fftmesh

    subroutine fillup_meshwk(mode)
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!
      integer, intent(in) :: mode
!!$ASASASASAS
!!$      integer, pointer, dimension(:,:,:) :: mesh_t
      integer, allocatable :: mesh_t(:,:,:)
!!$ASASASASAS
      integer :: i,j,k, icount, nwsc, max_nwsc, min_nwsc, n, nl, nm,nn, nd2,id, nfftwk &
           &    , inew, jnew, knew, idr2, idh

      if(mode == SOFTPART) then

         nl = fft_box_size_WF(1,1)
         nm = fft_box_size_WF(2,1)
         nn = fft_box_size_WF(3,1)

         id  = fft_box_size_WF(1,0)
         nd2 = fft_box_size_WF(2,0)
         allocate(mesh_t(id,nd2,nn))
         mesh_t = mesh

         nfftwk = product(fft_box_size_WF(1:3,1))
      else if(mode == HARDPART) then

         nl = fft_box_size_CD(1,1)
         nm = fft_box_size_CD(2,1)
         nn = fft_box_size_CD(3,1)

         id  = fft_box_size_CD_nonpara(1,0)
         nd2 = fft_box_size_CD_nonpara(2,0)
         allocate(mesh_t(id,nd2,nn))
         mesh_t = meshp
         nfftwk = product(fft_box_size_CD(1:3,1))
      end if
      idr2 = (nl+2)/2
      idh  = id/2

      if(allocated(meshwk)) deallocate(meshwk)
      allocate(meshwk(nfftwk,2)); meshwk = 0

      if(ipridos>=2) write(nfout,'(" !! nfftwk = ",i8)') nfftwk

      max_nwsc = 0
      min_nwsc = natm2+2
      icount = 1
      do k = 1, nn
         do j = 1, nm
            do i = 1, nl
!!$               if(icount > nfftwk) then
!!$                  write(nfout,'(" ! icount = ",i7," > nfftwk")') icount
!!$                  stop  ' large icount <<fillup_meshwk.m_Ldos_cal>>'
!!$               end if
               nwsc = mesh_t(i,j,k)
               if(nwsc > max_nwsc) max_nwsc = nwsc
               if(nwsc < min_nwsc) min_nwsc = nwsc
               meshwk(icount,1) = nwsc
               if(kimg == 1) then
                  if( i <= idr2 ) then
                     n = idh*nd2*(k-1) + idr2*(j-1) + i
                  else
                     inew = nl + 2 - i
                     jnew = nm + 2 - j
                     knew = nn + 2 - k
                     if(jnew > nm) jnew = jnew - nm
                     if(knew > nn) knew = knew - nn
                     n = idh*nd2*(knew-1) + idh*(jnew-1) + inew
                  end if
               else
                  n = id*nd2*(k-1) + id*(j-1) + i
               end if
               meshwk(icount,2) = n
               icount = icount + 1
            end do
         end do
      end do
      if(ipridos>=2) then
         write(nfout,*) ' !!ldos:  max_nwsc =  ', max_nwsc
         write(nfout,*) ' !!ldos:  min_nwsc =  ', min_nwsc
#ifdef DEBUG_MESH
         n = 1000
         if(n*2 > nfftwk) n = nfftwk/2
         write(nfout,'(" !ldos nfftwk = ",i8)') nfftwk
         write(nfout,'(" !ldos: meshwk(*,1) first ",i8," elements")') n
         write(nfout,'(14i5)') (meshwk(i,1),i=1,n)
         write(nfout,'(" !ldos: meshwk(*,1) last  ",i8," elements")') n
         write(nfout,'(14i6)') (meshwk(i,1),i=nfftwk-n+1, nfftwk)

         write(nfout,'(" !ldos: meshwk(*,2) first ",i8," elements")') n
         write(nfout,'(14i5)') (meshwk(i,2),i=1,n)
         write(nfout,'(" !ldos: meshwk(*,2) last  ",i8," elements")') n
         write(nfout,'(14i6)') (meshwk(i,2),i=nfftwk-n+1, nfftwk)
#endif
      end if
      deallocate(mesh_t)
    end subroutine fillup_meshwk

    subroutine fillup_meshwk_layer(mode)
!   *********************************
!     by T.Yamasaki
!           7th Apr 2017
!   *********************************

      integer, intent(in) :: mode
      integer, allocatable :: mesh_t(:,:,:)
      integer :: i,j,k, icount, nwsc, max_nwsc, min_nwsc, n, nl, nm,nn, nd2,id, nfftwk &
           &    , inew, jnew, knew, idr2, idh

      if(mode == SOFTPART) then

         nl = fft_box_size_WF(1,1)
         nm = fft_box_size_WF(2,1)
         nn = fft_box_size_WF(3,1)

         id  = fft_box_size_WF(1,0)
         nd2 = fft_box_size_WF(2,0)
         allocate(mesh_t(id,nd2,nn))
         mesh_t = meshl

         nfftwk = product(fft_box_size_WF(1:3,1))
      else if(mode == HARDPART) then

         nl = fft_box_size_CD(1,1)
         nm = fft_box_size_CD(2,1)
         nn = fft_box_size_CD(3,1)

         id  = fft_box_size_CD_nonpara(1,0)
         nd2 = fft_box_size_CD_nonpara(2,0)
         allocate(mesh_t(id,nd2,nn))
         mesh_t = meshpl
         nfftwk = product(fft_box_size_CD(1:3,1))
      end if
      idr2 = (nl+2)/2
      idh  = id/2

      if(allocated(meshwk_layer)) deallocate(meshwk_layer)
      allocate(meshwk_layer(nfftwk,2)); meshwk_layer = 0

      if(ipridos>=2) write(nfout,'(" !! nfftwk = ",i8)') nfftwk

      max_nwsc = 0
      min_nwsc = mlayer+1
      icount = 1
      do k = 1, nn
         do j = 1, nm
            do i = 1, nl
!!$               if(icount > nfftwk) then
!!$                  write(nfout,'(" ! icount = ",i7," > nfftwk")') icount
!!$                  stop  ' large icount <<fillup_meshwk.m_Ldos_cal>>'
!!$               end if
               nwsc = mesh_t(i,j,k)
               if(nwsc > max_nwsc) max_nwsc = nwsc
               if(nwsc < min_nwsc) min_nwsc = nwsc
               meshwk_layer(icount,1) = nwsc
               if(kimg == 1) then
                  if( i <= idr2 ) then
                     n = idh*nd2*(k-1) + idr2*(j-1) + i
                  else
                     inew = nl + 2 - i
                     jnew = nm + 2 - j
                     knew = nn + 2 - k
                     if(jnew > nm) jnew = jnew - nm
                     if(knew > nn) knew = knew - nn
                     n = idh*nd2*(knew-1) + idh*(jnew-1) + inew
                  end if
               else
                  n = id*nd2*(k-1) + id*(j-1) + i
               end if
               meshwk_layer(icount,2) = n
               icount = icount + 1
            end do
         end do
      end do
      if(ipridos>=2) then
         write(nfout,*) ' !!ldos:  max_nwsc =  ', max_nwsc
         write(nfout,*) ' !!ldos:  min_nwsc =  ', min_nwsc
#ifdef DEBUG_MESH
         n = 1000
         if(n*2 > nfftwk) n = nfftwk/2
         write(nfout,'(" !ldos nfftwk = ",i8)') nfftwk
         write(nfout,'(" !ldos: meshwk_layer(*,1) first ",i8," elements")') n
         write(nfout,'(14i5)') (meshwk_layer(i,1),i=1,n)
         write(nfout,'(" !ldos: meshwk_layer(*,1) last  ",i8," elements")') n
         write(nfout,'(14i6)') (meshwk_layer(i,1),i=nfftwk-n+1, nfftwk)

         write(nfout,'(" !ldos: meshwk_layer(*,2) first ",i8," elements")') n
         write(nfout,'(14i5)') (meshwk_layer(i,2),i=1,n)
         write(nfout,'(" !ldos: meshwk_layer(*,2) last  ",i8," elements")') n
         write(nfout,'(14i6)') (meshwk_layer(i,2),i=nfftwk-n+1, nfftwk)
#endif
      end if
      deallocate(mesh_t)
    end subroutine fillup_meshwk_layer

  end subroutine m_Ldos_cal

  subroutine m_Ldos_cal_partial()
  end subroutine m_Ldos_cal_partial

! ======================= added by K. Tagami =================== 11.0
  subroutine m_Ldos_cal_noncl( nfldos, print_flag )
    use m_IterationNumbers,   only : nk_in_the_process
    use m_Ionic_System,       only : speciesname

    integer, intent(in) :: nfldos
    logical, intent(in) :: print_flag

    integer,allocatable,dimension(:,:) :: meshwk
    integer :: is, ik, ip, ib
    integer :: ekmode_t
    integer :: istmp
    integer :: sw_atom_decomp, sw_layer_decomp

    real(kind=DP) :: chgq0( ndim_magmom )
    real(kind=DP), allocatable, dimension(:,:) :: zrhoik_kt
    real(kind=DP), allocatable, dimension(:,:) :: bfft_kt
    real(kind=DP), allocatable, dimension(:,:) :: chgq_enl_kt(:,:,:)

    real(kind=DP), allocatable, dimension(:,:,:,:) :: wsctmp,laytmp

    sw_atom_decomp = OFF;  sw_layer_decomp = OFF
    if ( sw_aldos == ON .or. sw_calc_wf_atom_decomposition == ON ) then
       sw_atom_decomp = ON
    endif
    if ( sw_layerdos == ON .or. sw_calc_wf_layer_decomposition == ON ) then
       sw_layer_decomp = ON
    endif

    if ( mype == 0 ) call wd_header

    if (sw_layer_decomp == ON) then
       allocate( zrhoik_kt(kg*kimg,ndim_magmom) )
       zrhoik_kt = 0.0d0
    endif

    allocate( chgq_enl_kt(kgp,kimg,ndim_magmom) )
    chgq_enl_kt = 0.0d0

    call m_CD_keep_retrieve_hsr(.true.)

    if (ekmode == ON) then
       do ik = 1, kv3, ndim_spinor
          if ( nk_in_the_process +ik -1 > kv3_ek ) cycle

          call m_FFT_alloc_WF_work()

          if(ipridos >= 3) write(nfout,'(" !!ldos ik = ",i6)') ik
          if(sw_atom_decomp == ON) call fillup_meshwk(mode=SOFTPART)

          if(ipridos >= 3) write(nfout,'(" !!ldos nfft = ",i6," <<m_Ldos_cal>>")') nfft

          allocate(bfft_kt(nfft,ndim_spinor))

          do ib = 1, neg
             bfft_kt = 0.d0
             if (map_ek(ib,ik) == mype ) then
                Do is=1, ndim_spinor
                   if ( sw_band_unfolding == ON .and. band_unfolding_active ) then
                      call m_ES_WF_in_Rspace_kt( ik+is-1, ik+is-1, ik+is-1, &
                           &                     zaj_l(:,map_z(ib),ik+is-1,:), &
                           &                     bfft_kt(:,is) )
                   else
                      call m_ES_WF_in_Rspace(ik+is-1,ib,bfft_kt(:,is))
                   endif
                End do
!!                ip = mype
!!             end if
!!             if (npes > 1) then
!!                call mpi_bcast( bfft_kt, nfft*ndim_spinor, mpi_double_precision,&
!!                     &          ip, MPI_CommGroup, ierr )
!!             endif

!!             if(sw_atom_decomp == ON) call substitute_weiwsc_noncl(1,ib,.false.)
!!             if(sw_layer_decomp == ON) call substitute_weilay_noncl(1,ib,.false.)
                if(sw_atom_decomp == ON) call substitute_weiwsc_noncl(ik,ib,.false.)
                if(sw_layer_decomp == ON) call substitute_weilay_noncl(ik,ib,.false.)
             endif
          end do
          if ( map_k(ik) == 0 ) call check_sum_noncl(ik,"softpart",.false.)

          deallocate(bfft_kt)
          call m_FFT_dealloc_WF_work()

          if (modnrm == EXECUT) then
             call m_FFT_alloc_CD_box()
             allocate( bfft_kt(nfftp_nonpara,ndim_magmom) )

             if (sw_atom_decomp==ON) call fillup_meshwk(mode=HARDPART)
             do ib = 1, neg
                call m_CD_hardpart_sub_noncl( nfout, ik, ib, chgq0 )  ! -> chgq_l
                Do istmp=1, ndim_magmom
                   call m_CD_map_chgq_to_fft_box( istmp, nfftp_nonpara, &
                        &                         bfft_kt(:,istmp) )   ! -> bfft

                   call m_FFT_CD_inverse0( nfout, bfft_kt(:,istmp) )
                                                   ! bfft(G_sp.) -> bfft(R_sp.)
                End do

                if (sw_atom_decomp==ON) call substitute_weiwsc_cd_noncl(ik,ib,.false.)
                if (sw_layer_decomp==ON) then
                   call substitute_weilay_cd_noncl(ik,ib,chgq0,.false., chgq_enl_kt)
                endif
             end do

             if (sw_atom_decomp==ON) deallocate(meshwk)
             deallocate(bfft_kt)
             call m_FFT_dealloc_CD_box()

             if ( map_k(ik) == 0 ) call check_sum_noncl(ik,"total   ",.false.)
          end if

          if (sw_save_ldos_weight == ON .and. sw_lband == OFF ) then
             if (sw_atom_decomp==ON) call wd_weight_noncl(ALDOS,nfldos)
             if (sw_layer_decomp==ON) call wd_weight_noncl(LAYERDOS,nfldos)
          end if

       end do

       if ( sw_lband == ON ) then
          if(sw_atom_decomp==ON) call wd_weight2_noncl(ALDOS,nfldos)
          if(sw_layer_decomp==ON) call wd_weight2_noncl(LAYERDOS,nfldos)
       endif

    else if (ekmode == OFF) then
       if (modnrm == EXECUT) call m_CD_set_ylm_enl_etc()
!       if (sw_save_ldos_weight == ON) call m_Ldos_wd_natm2_and_totch( nfldos )

       if (hardpart_subroutine==2 .or. sw_rspace_ldos==ON &
            &                     .or. sw_rspace_lband==ON )then

          do ik = 1, kv3, ndim_spinor
             if (map_k(ik) /= myrank_k) cycle

             if (ipridos >= 2) write(nfout,'(" !!ldos ik = ",i6)') ik
             call m_FFT_alloc_WF_work()
             if (sw_atom_decomp==ON) call fillup_meshwk(mode=SOFTPART)

             allocate(bfft_kt(nfft,ndim_spinor))

             if (ipridos >= 2 .and. printable) then
                write(nfout,'(" !!ldos nfft = ",i6," <<m_Ldos_cal>>")') nfft
             endif
             if (ipridos >= 2 .and. printable) then
                call m_ES_wd_zaj_small_portion(nfout,ik, &
                     &    " -- before m_ES_WF_in_Rspace <<m_Ldos_cal>> --",46)
             endif

             do ib = ista_e, iend_e, istep_e
                bfft_kt = 0.d0
                Do is=1, ndim_spinor
                   if ( sw_band_unfolding == ON .and. band_unfolding_active ) then
                      call m_ES_WF_in_Rspace_kt( ik+is-1, ik+is-1, ik+is-1, &
                           &                     zaj_l(:,map_z(ib),ik+is-1,:), &
                           &                     bfft_kt(:,is) )
                   else
                      call m_ES_WF_in_Rspace(ik+is-1,ib,bfft_kt(:,is))
                   endif

                End do

                if (sw_atom_decomp==ON) call substitute_weiwsc_noncl(ik,ib,.false.)
                if (sw_layer_decomp==ON) call substitute_weilay_noncl(ik,ib,.false.)

             end do

             call check_sum_noncl(ik,"softpart",.false.)

             deallocate(bfft_kt)
             call m_FFT_dealloc_WF_work()

             if (modnrm == EXECUT) then
                call m_FFT_alloc_CD_box()

                allocate( bfft_kt(nfftp_nonpara,ndim_spinor) )

                if (sw_atom_decomp==ON) call fillup_meshwk(mode=HARDPART)
                do ib = ista_e, iend_e, istep_e
                   if (ipridos>=2) write(nfout,'(" !ldos   ib = ", i5)') ib

                   call m_CD_hardpart_sub2_noncl( nfout, ik, ib, chgq0, &
                        &                         chgq_enl_kt )     ! -> chgq_enl

                   Do istmp=1, ndim_magmom
                      call m_CD_map_chgqenl_to_fft_box_kt( istmp, nfftp_nonpara, &
                           &                               bfft_kt(:,istmp), &
                           &                               chgq_enl_kt )
                                                                 ! -> bfft
                      call m_FFT_CD_inverse0( nfout, bfft_kt(:,istmp) )
                                                    ! bfft(G_sp.) -> bfft(R_sp.)
                   End do

                   if (sw_atom_decomp==ON) call substitute_weiwsc_cd_noncl(ik,ib,.false.)
                   if (sw_layer_decomp==ON) then
                      call substitute_weilay_cd_noncl( ik, ib, chgq0, .false., &
                           &                          chgq_enl_kt )
                   endif

                end do

                if (sw_atom_decomp==ON) deallocate(meshwk)
                deallocate(bfft_kt)
                call m_FFT_dealloc_CD_box()

                call check_sum_noncl(ik,"total   ",.false.)
             end if

          end do

       else
          if ( sw_atom_decomp==ON ) weiwsc_noncl = 0.d0
          if ( sw_layer_decomp==ON ) weilay_noncl = 0.d0

          do ik = 1, kv3, ndim_spinor
             if (map_k(ik) /= myrank_k) cycle
             if (ipridos >= 2) write(nfout,'(" !!ldos ik = ",i6)') ik
             call m_FFT_alloc_WF_work()

             if (sw_atom_decomp==ON) call fillup_meshwk(mode=SOFTPART)

             allocate( bfft_kt(nfft,ndim_spinor) ); bfft_kt = 0.d0

             if (ipridos >= 2 .and. printable) then
                write(nfout,'(" !!ldos nfft = ",i6," <<m_Ldos_cal>>")') nfft
             endif
             if (ipridos >= 2 .and. printable) then
                call m_ES_wd_zaj_small_portion(nfout,ik, &
                     &  " -- before m_ES_WF_in_Rspace <<m_Ldos_cal>> --",46)
             endif

             do ib = 1,neg
                if(map_e(ib)/=myrank_e) cycle
                bfft_kt = 0.d0
                Do is=1, ndim_spinor
                   if ( sw_band_unfolding == ON .and. band_unfolding_active ) then
                      call m_ES_WF_in_Rspace_kt( ik+is-1, ik+is-1, ik+is-1, &
                           &                     zaj_l(:,map_z(ib),ik+is-1,:), &
                           &                     bfft_kt(:,is) )
                   else
                      call m_ES_WF_in_Rspace(ik+is-1,ib,bfft_kt(:,is))
                   endif
                End do

                if ( sw_lband == ON ) then
                   if (sw_atom_decomp==ON) call substitute_weiwsc_noncl(ik,ib,.false.)
                   if (sw_layer_decomp==ON) call substitute_weilay_noncl(ik,ib,.false.)
                else
                   if (sw_atom_decomp==ON) call substitute_weiwsc_noncl(ik,ib,.true.)
                   if (sw_layer_decomp==ON) call substitute_weilay_noncl(ik,ib,.true.)
                endif
             end do
             deallocate(bfft_kt)
             call m_FFT_dealloc_WF_work()
          enddo

          if ( sw_lband == OFF .and. npes > 1 ) then
             if (sw_atom_decomp==ON)then
                allocate( wsctmp(maldos,neg,kv3,ndim_magmom) );wsctmp = 0.d0
                call mpi_allreduce( weiwsc_noncl, wsctmp, kv3*maldos*neg*ndim_magmom, &
                     &              mpi_double_precision, &
                     &              mpi_sum,MPI_CommGroup,ierr )
                weiwsc_noncl = wsctmp
                deallocate(wsctmp)
             endif
             if (sw_layer_decomp==ON)then
                allocate( laytmp(mlayer,neg,kv3,ndim_magmom) );laytmp=0.d0
                call mpi_allreduce( weilay_noncl, laytmp, kv3*mlayer*neg*ndim_magmom, &
                     &              mpi_double_precision, &
                     &              mpi_sum,MPI_CommGroup, ierr )
                weilay_noncl = laytmp
                deallocate(laytmp)
             endif
          endif

          do ik=1, kv3, ndim_spinor
             if ( sw_lband == ON ) then
                if ( map_k(ik) == 0 ) call check_sum_noncl(ik,"softpart",.false.)
             else
                call check_sum_noncl(ik,"softpart",.true.)
             endif
          enddo

          if (modnrm == EXECUT) then
             allocate( bfft_kt(nfftp_nonpara,ndim_magmom) )
             do ik = 1, kv3, ndim_spinor
                call m_FFT_alloc_CD_box()
                if (sw_atom_decomp==ON) call fillup_meshwk(mode=HARDPART)
                do ib = 1,neg
                   if (ipridos>=2) write(nfout,'(" !ldos   ib = ", i5)') ib
                   call m_CD_hardpart_sub_noncl( nfout, ik, ib, chgq0 )
                                                ! -> chgq_enl

                   Do istmp=1, ndim_magmom
                      call m_CD_map_valence_charge_to_fft_box( istmp, nfftp_nonpara,&
                           &                                   bfft_kt(:,istmp) )
                      call m_FFT_CD_inverse0( nfout, bfft_kt(:,istmp) )
                                                    ! bfft(G_sp.) -> bfft(R_sp.)
                   End do

                   if ( sw_lband == ON ) then
                      if (sw_atom_decomp==ON) &
                           &   call substitute_weiwsc_cd_noncl(ik,ib,.false.)
                      if (sw_layer_decomp==ON) then
                         call substitute_weilay_cd_noncl( ik, ib, chgq0,.false., &
                              &                           chgq_enl_kt )
                      endif
                   else
                      if (sw_atom_decomp==ON) &
                           &   call substitute_weiwsc_cd_noncl(ik,ib,.true.)
                      if (sw_layer_decomp==ON) then
                         call substitute_weilay_cd_noncl( ik, ib, chgq0,.true., &
                              &                           chgq_enl_kt )
                      endif
                   endif
                end do

                if (sw_atom_decomp==ON) deallocate(meshwk)
                call m_FFT_dealloc_CD_box()

                if ( sw_lband == ON ) then
                   if ( map_k(ik) == 0 ) call check_sum_noncl(ik,"total   ",.false.)
                else
                   call check_sum_noncl(ik,"total   ",.true.)
                endif
             enddo
             deallocate(bfft_kt)
          endif

       endif

       if (npes > 1) call mpi_barrier(MPI_CommGroup,ierr)

       if (sw_save_ldos_weight == ON .and. print_flag ) then
          if ( sw_lband == ON ) then
             if(sw_atom_decomp==ON) call wd_weight2_noncl(ALDOS,nfldos)
             if(sw_layer_decomp==ON) call wd_weight2_noncl(LAYERDOS,nfldos)
          else
             if (hardpart_subroutine==2 .or. sw_rspace_ldos==ON &
                  &                     .or. sw_rspace_lband==ON )then
                if (sw_atom_decomp==ON) call wd_weight_noncl(ALDOS,nfldos)
                if (sw_layer_decomp==ON) call wd_weight_noncl(LAYERDOS,nfldos)
             else
                if(sw_atom_decomp==ON) call wd_weight_serial_noncl(ALDOS,nfldos)
                if(sw_layer_decomp==ON) call wd_weight_serial_noncl(LAYERDOS,nfldos)
             endif
          end if
       endif

    end if

    call m_CD_keep_retrieve_hsr(.false.)

    if (modnrm == EXECUT) call m_CD_dealloc_ylm_enl_etc()

    if (hardpart_subroutine/=2 .and. &
         &  (sw_rspace_ldos==OFF .or. sw_rspace_lband==OFF) ) call m_CD_restore_chgq()

    if (allocated(meshwk)) deallocate(meshwk)
    if (sw_layer_decomp==ON) deallocate(zrhoik_kt)
    deallocate( chgq_enl_kt )

  contains

    subroutine wd_header
      integer :: i, j

      if ( sw_lband == OFF ) then
         if(sw_save_ldos_weight == ON .and. ekmode==OFF) then
            call m_Ldos_wd_natm2_and_totch( nfldos )
         endif
         if ( ekmode == ON .and. nk_in_the_process == 1 ) then
            call m_Ldos_wd_natm2_and_totch( nfldos )
         endif
      endif
      if ( sw_lband == ON ) then
         if ( ( ekmode == ON .and. nk_in_the_process == 1 ) &
              &  .or. ( ekmode == OFF) ) then
            write(nfldos,'(A)') "# Local Decomposition for bands"
            write(nfldos,*) ""
            write(nfldos,'(A,I8)') ' num_kpoints = ', max(kv3,kv3_ek) /ndim_spinor
            write(nfldos,'(A,I8)') ' num_bands   = ', neg -num_extra_bands
            write(nfldos,'(A,I8)') ' nspin       = ', nspin /ndim_spinor
            write(nfldos,'(A,I8)') ' ndim_magmom = ', ndim_magmom
            write(nfldos,*) ""
            write(nfldos,'(A)') "# Decomposition Info."

            if ( sw_atom_decomp == ON ) then
               write(nfldos,'(A,I8,A)') ' num_atoms   = ', natom_decomp +1, &
                    &        "  ( last 1 corresponds to external region )"
            endif
            if ( sw_layer_decomp == ON ) then
               write(nfldos,'(A,I8,A)') ' num_layers  = ', nlayer +1, &
                    &        "  ( last 1 corresponds to external region )"
            endif
            write(nfldos,*) ""

            if ( sw_atom_decomp == ON ) then
               write(nfldos,'(A)') "# Atom Info."
               write(nfldos,'(A)') "   no.    target_atom    species"
               Do i=1, natom_decomp
                  j = atom_decomp_map(i)
                  write(nfldos,'(I5,5X,I5,12X,A)') i, j, speciesname(ityp(j))
               end Do
               write(nfldos,'(I5)') natom_decomp +1
               write(nfldos,*)
            endif
            if ( sw_layer_decomp == ON ) then
               write(nfldos,'(A)') "# Layer Info."
               write(nfldos,'(A)') "   no.       min.         max.  (Angstrom)"
               Do i=1, nlayer +1
                  write(nfldos,'(I5,2(5X,F8.4))') i, winlay(i,1)*BOHR, winlay(i,2)*BOHR
               end Do
               write(nfldos,*)
            endif
         endif
      endif
    end subroutine wd_header

    subroutine wd_weight2_noncl(mode,nfldos)
      integer, intent(in) :: mode, nfldos
      integer :: m, ib, ib_ordr, kend, kstep, iws, ik, iks
      integer :: iktmp, istmp
      integer :: count
      real(kind=DP),allocatable,dimension(:,:,:,:) :: wei

      if(mode==ALDOS) then
         m = maldos
      else if(mode==LAYERDOS) then
         m = mlayer
      end if
      allocate(wei(m,neg,kv3/ndim_spinor,ndim_magmom)); wei = 0.d0

      if(mode==ALDOS)then
         do ik=ista_k, iend_k, ndim_spinor
            iktmp = (ik-1)/ndim_spinor +1
            do ib = ista_e, iend_e, istep_e
               wei(1:m,ib,iktmp,1:ndim_magmom) &
!                    &   = weiwsc_noncl(1:m,ib,ik,1:ndim_magmom)
                    &   = weiwsc_noncl(1:m,map_z(ib),ik,1:ndim_magmom)
            end do
         end do
      else if(mode==LAYERDOS)then
         do ik=ista_k, iend_k, ndim_spinor
            iktmp = (ik-1)/ndim_spinor +1
            do ib = ista_e, iend_e, istep_e
               wei(1:m,ib,iktmp,1:ndim_magmom) &
                    &   = weilay_noncl(1:m,map_z(ib),ik,1:ndim_magmom)
            end do
         end do
      endif

      if (npes>1) then
         call mpi_allreduce( MPI_IN_PLACE, wei, m*neg*kv3/ndim_spinor*ndim_magmom, &
              &              mpi_double_precision, &
              &              mpi_sum, MPI_CommGroup, ierr )
      end if

      if(mype == 0) then
         Do ik=1, kv3, ndim_spinor
            iks = 0
            if ( sw_lband == ON .and. ekmode == ON ) then
               iks = nk_in_the_process -1
               if ( ik +iks > kv3_ek ) cycle
            endif
            if(mode==ALDOS) then
               write(nfldos,'(" weight for each atomic cell    nk = ",i8)') ik+iks
            else if(mode==LAYERDOS) then
               write(nfldos,'(" weight for each layer          nk = ",i8)') ik+iks
            end if

            iktmp = ( ik-1 )/ndim_spinor +1
            Do istmp=1, ndim_magmom
               select case( istmp )
               case (1)
                  write(nfldos,*) '! -------- for total charge ----- '
               case (2)
                  write(nfldos,*) '! -------- for magnetic moment X ----- '
               case (3)
                  write(nfldos,*) '! -------- for magnetic moment Y ----- '
               case (4)
                  write(nfldos,*) '! -------- for magnetic moment Z ----- '
               end select

               if ( mode==ALDOS .and. sw_wd_only_specified_atoms == ON ) then
                  do ib = 1, neg -num_extra_bands
                     write(nfldos,'(i4,A)',advance="no") ib, ")"
                     count = 0
                     do iws=1, m-1
                        if ( if_aldos_full(iws)==1 ) then
                           count = count +1
                           if ( count > 1 .and. mod(count,ilen)==1 ) then
                              write(nfldos,'(5x)',advance="no")
                           endif
                           write(nfldos,'(f15.10)',advance="no") wei(iws,ib,iktmp,istmp)
                           if ( mod(count,ilen)==0 ) write(nfldos,*)
                        endif
                     end do
                     count = count +1
                     if ( count > 1 .and. mod(count,ilen)==1 ) then
                        write(nfldos,'(5x)',advance="no")
                     endif
                     write(nfldos,'(f15.10)') wei(maldos,ib,iktmp,istmp)
                  end do
               else
                  do ib = 1, neg -num_extra_bands
                     if(ilen >= m) then
                        write(nfldos,'(i4,")",5f15.10)') &
                             &         ib,(wei(iws,ib,iktmp,istmp),iws=1,m)
                     else
                        write(nfldos,'(i4,")",5f15.10)') &
                             &         ib,(wei(iws,ib,iktmp,istmp),iws=1,ilen)
                        write(nfldos,'(5x,5f15.10)') &
                             &         (wei(iws,ib,iktmp,istmp),iws=ilen+1,m)
                     end if
                  end do
               endif
            end Do
         end Do
      end if

      deallocate(wei)
    end subroutine wd_weight2_noncl

    subroutine wd_weight_noncl(mode,nfldos)
      integer, intent(in) :: mode, nfldos
      integer :: m, ik, ib, ib_ordr, kend, kstep, iws, ip, count
      real(kind=DP),allocatable,dimension(:) :: wei

      integer :: istmp

      if(mode==ALDOS) then
         m = maldos
      else if(mode==LAYERDOS) then
         m = mlayer
      end if

      allocate(wei(m))

      if (ekmode==OFF) then
         kend = kv3;
      else if (ekmode==ON) then
!         kend = 1;
         kend = kv3;
      end if
      kstep = ndim_spinor

      if (ipridos >= 3) then
         do ik = 1, kv3, kstep
            if(map_k(ik) /= myrank_k) cycle
            write(nfout,'(" !ldos: ik = ",i8)') ik
            do ib = 1, neg
               write(nfout,'(" !ldos: ib, ib_ordr = ",2i20)') ib, neordr(ib,ik)
            end do
         end do
      end if

      do ik = 1, kend, kstep
         if (mype == 0) then
            if (mode==ALDOS) then
               write(nfldos,'(" weight for each atomic cell    nk = ",i8)') ik
            else if (mode==LAYERDOS) then
               write(nfldos,'(" weight for each layer          nk = ",i8)') ik
            end if
         end if

         Do istmp=1, ndim_magmom

            if ( mype == 0 ) then
               select case( istmp )
               case (1)
                  write(nfldos,*) '! -------- for total charge ----- '
               case (2)
                  write(nfldos,*) '! -------- for magnetic moment X ----- '
               case (3)
                  write(nfldos,*) '! -------- for magnetic moment Y ----- '
               case (4)
                  write(nfldos,*) '! -------- for magnetic moment Z ----- '
               end select
            endif

            do ib = 1, neg -num_extra_bands

               if (nrank_k >= 2) then
                  if (map_ek(ib,ik) == mype) ib_ordr = neordr(ib,ik)
                  call mpi_bcast( ib_ordr, 1, mpi_integer, map_ek(ib,ik), &
                       &          MPI_CommGroup, ierr )
               else
                  ib_ordr = neordr(ib,ik)
               end if

               if (map_ek(ib_ordr,ik) == mype) then
                  if (mode == ALDOS) then
                     wei(1:m) = weiwsc_noncl(1:m,map_z(ib_ordr),ik,istmp)
                  else if (mode == LAYERDOS) then
                     wei(1:m) = weilay_noncl(1:m,map_z(ib_ordr),ik,istmp)
                  end if
                  if (map_ek(ib_ordr,ik) /= 0) &
                       call mpi_send( wei, m, mpi_double_precision, &
                       &              0, 1, MPI_CommGroup, ierr )
               else if (mype == 0 .and. map_ek(ib_ordr,ik) /= 0) then
                  call mpi_recv( wei, m, mpi_double_precision, &
                       &         map_ek(ib_ordr,ik), 1, MPI_CommGroup, istatus, ierr )
               end if

               if ( mode==ALDOS .and. sw_wd_only_specified_atoms == ON ) then
                  write(nfldos,'(i4,A)',advance="no") ib, ")"
                  count = 0
                  do iws=1, m-1
                     if ( if_aldos_full(iws)==1 ) then
                        count = count +1
                        if ( count > 1 .and. mod(count,ilen)==1 ) then
                           write(nfldos,'(5x)',advance="no")
                        endif
                        write(nfldos,'(f15.10)',advance="no") wei(iws)
                        if ( mod(count,ilen)==0 ) write(nfldos,*)
                     endif
                  end do
                  count = count +1
                  if ( count > 1 .and. mod(count,ilen)==1 ) then
                     write(nfldos,'(5x)',advance="no")
                  endif
                  write(nfldos,'(f15.10)') wei(maldos)
               else
                  if(ilen >= m) then
                     write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws),iws=1,m)
                  else
                     write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws),iws=1,ilen)
                     write(nfldos,'(5x,5f15.10)') (wei(iws),iws=ilen+1,m)
                  end if
               endif

            end do
         End do
      end do

      deallocate(wei)
    end subroutine wd_weight_noncl

    subroutine wd_weight_serial_noncl(mode,nfldos)
      integer, intent(in) :: mode, nfldos
      integer :: m, ik, ib, ib_ordr, kend, kstep, iws, ip, count
      real(kind=DP),allocatable,dimension(:):: wei

      integer :: istmp

      if (mode==ALDOS) then
         m = maldos
      else if (mode==LAYERDOS) then
         m = mlayer
      end if

      allocate(wei(m))

      if(ekmode==OFF) then
         kend = kv3
      else if(ekmode==ON) then
!         kend = 1
         kend = kv3
      end if
      kstep = ndim_spinor

      if (ipridos >= 3) then
         do ik = 1, kv3, kstep
            if(map_k(ik) /= myrank_k) cycle
            write(nfout,'(" !ldos: ik = ",i8)') ik
            do ib = 1, neg
               write(nfout,'(" !ldos: ib, ib_ordr = ",2i20)') ib, neordr(ib,ik)
            end do
         end do
      end if

      do ik = 1, kend, kstep
         if (mype == 0) then
            if (mode==ALDOS) then
               write(nfldos,'(" weight for each atomic cell    nk = ",i8)') ik
            else if (mode==LAYERDOS) then
               write(nfldos,'(" weight for each layer          nk = ",i8)') ik
            end if
         end if

         Do istmp=1, ndim_magmom

            if ( mype == 0 ) then
               select case( istmp )
               case (1)
                  write(nfldos,*) '! -------- for total charge ----- '
               case (2)
                  write(nfldos,*) '! -------- for magnetic moment X ----- '
               case (3)
                  write(nfldos,*) '! -------- for magnetic moment Y ----- '
               case (4)
                  write(nfldos,*) '! -------- for magnetic moment Z ----- '
               end select
            endif

            do ib = 1, neg -num_extra_bands

               if (mode == ALDOS) then
                  wei(1:m) = weiwsc_noncl(1:m,ib,ik,istmp)
               else if(mode == LAYERDOS) then
                  wei(1:m) = weilay_noncl(1:m,ib,ik,istmp)
               end if

               if ( mode==ALDOS .and. sw_wd_only_specified_atoms == ON ) then
                  write(nfldos,'(i4,A)',advance="no") ib, ")"
                  count = 0
                  do iws=1, m-1
                     if ( if_aldos_full(iws)==1 ) then
                        count = count +1
                        if ( count > 1 .and. mod(count,ilen)==1 ) then
                           write(nfldos,'(5x)',advance="no")
                        endif
                        write(nfldos,'(f15.10)',advance="no") wei(iws)
                        if ( mod(count,ilen)==0 ) write(nfldos,*)
                     endif
                  end do
                  count = count +1
                  if ( count > 1 .and. mod(count,ilen)==1 ) then
                     write(nfldos,'(5x)',advance="no")
                  endif
                  write(nfldos,'(f15.10)') wei(maldos)
               else
                  if(ilen >= m) then
                     write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws),iws=1,m)
                  else
                     write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws),iws=1,ilen)
                     write(nfldos,'(5x,5f15.10)') (wei(iws),iws=ilen+1,m)
                  end if
               endif
            end do
         End Do
      end do

      deallocate(wei)
    end subroutine wd_weight_serial_noncl

    subroutine check_sum_noncl(ik,aword,serial)
      integer,intent(in) :: ik
      character*(*),intent(in) :: aword
      logical, intent(in) :: serial

      integer :: ib, ia, ilay, ib_ordr, ik_t
      real(kind=DP), allocatable, dimension(:,:) :: sum_aldos, sum_layer, sum_mpi

      if (sw_atom_decomp==ON) allocate(sum_aldos(neg,ndim_magmom))
      if (sw_layer_decomp==ON) allocate(sum_layer(neg,ndim_magmom))

      if ( sw_lband == ON ) then
         ik_t = ik
      else
         if (ekmode /= ON) then
            ik_t = ik
         else if (ekmode == ON) then
            ik_t = 1
         end if
      endif

      if (sw_atom_decomp==ON .or. sw_layer_decomp==ON) then
         if (nrank_e >= 2) then
            allocate(sum_mpi(neg,ndim_magmom)); sum_mpi = 0.d0
         end if
      end if

      if (sw_atom_decomp==ON) then
         sum_aldos = 0.d0
         do ib = 1, neg
            if (.not.serial)then
               if (map_ek(ib,ik_t) == mype) then
                  do ia = 1, natm2 + 1
                     sum_aldos(ib,:) = sum_aldos(ib,:) &
                          &          + weiwsc_noncl(ia,map_z(ib),ik_t,:)
                  end do
               endif
            else
               do ia = 1, natm2 + 1
                  sum_aldos(ib,:) = sum_aldos(ib,:) &
                       &          + weiwsc_noncl(ia,ib,ik_t,:)
               end do
            end if
         end do
         if (.not.serial)then
            if (nrank_e >= 2) then
               sum_mpi = 0.d0
               call mpi_allreduce( sum_aldos, sum_mpi, neg*ndim_magmom, &
                    &              mpi_double_precision, mpi_sum, &
                    &              mpi_k_world(myrank_k), ierr )
               sum_aldos = sum_mpi
            end if
         endif
      end if

      if (sw_layer_decomp==ON) then
         sum_layer = 0.d0
         do ib = 1, neg
            if (.not.serial)then
               if (map_e(ib) == myrank_e) then
                  do ilay = 1, mlayer
                     sum_layer(ib,:) = sum_layer(ib,:) &
                          &          + weilay_noncl(ilay,map_z(ib),ik_t,:)
                  end do
               endif
            else
               do ilay = 1, mlayer
                  sum_layer(ib,:) = sum_layer(ib,:) &
                       &          + weilay_noncl(ilay,ib,ik_t,:)
               end do
            end if
         end do
         if (.not.serial)then
            if (nrank_e >= 2) then
               sum_mpi = 0.d0
               call mpi_allreduce( sum_layer, sum_mpi, neg*ndim_magmom, &
                    &              mpi_double_precision, mpi_sum, &
                    &              mpi_k_world(myrank_k), ierr )
               sum_layer = sum_mpi
            end if
         endif
      end if

!!$      if(mype == 0) then
      if (ipridos>=1) then
         if (sw_atom_decomp==ON .and. sw_layer_decomp==ON) then
            write(nfout,'(" !!ldos ",a8," -- iban , sum(atomic, layer) --  neg = ",i6 &
                 & ," natm2 = ",i6, " ik = ",i6)') aword,neg,natm2,ik
            do ib = 1, neg
               if ( sw_lband == ON ) then
                  ib_ordr = ib
               else
                  if(serial) then
                     ib_ordr = ib
                  else
                     ib_ordr = neordr(ib,ik)
                  endif
               endif
               write(nfout,'(" !!ldos ", i4,2f16.8)') ib, sum_aldos(ib_ordr,1),&
                    &                                     sum_layer(ib_ordr,1)
            end do

         else if( sw_atom_decomp==ON ) then
            write(nfout,'(" !!ldos ",a8," -- iban , sum(atomic) --  neg = ",i6 &
                 & ," natm2 = ",i6," ik = ",i6)') aword,neg,natm2,ik
            do ib = 1, neg
               if ( sw_lband == ON ) then
                  ib_ordr = ib
               else
                  if(serial) then
                     ib_ordr = ib
                  else
                     ib_ordr = neordr(ib,ik)
                  endif
               endif
               write(nfout,'(" !!ldos ", i4,f16.8)') ib, sum_aldos(ib_ordr,1)
            end do

         else if ( sw_layer_decomp==ON ) then
            write(nfout,'(" !!ldos ",a8," -- iban , sum(layer ) --  neg = ",i6 &
                 & ," natm2 = ",i6," ik = ",i6)') aword,neg,natm2,ik
            do ib = 1, neg
               if ( sw_lband == ON ) then
                  ib_ordr = ib
               else
                  if(serial) then
                     ib_ordr = ib
                  else
                     ib_ordr = neordr(ib,ik)
                  endif
               endif
               write(nfout,'(" !!ldos ",i4,f16.8)') ib, sum_layer(ib_ordr,1)
            end do
         end if
      end if

      if (sw_atom_decomp==ON) deallocate(sum_aldos)
      if (sw_layer_decomp==ON) deallocate(sum_layer)
      if (allocated(sum_mpi)) deallocate(sum_mpi)
!!$      if(ekmode /= ON .and. (sw_aldos == ON .or. sw_layerdos == ON) .and. npes >= 2) deallocate(sum_mpi)

    end subroutine check_sum_noncl

    subroutine substitute_weilay_noncl(ik,ib,serial)
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!
      integer, intent(in) :: ik,ib
      logical, intent(in) :: serial

      integer :: i, ilay, iax1, iax2, iax3, ib_t
      real(kind=DP) :: a1,a2,width, g,ss

      complex(kind=CMPLDP) :: zi, zsum, zchg
      real(kind=DP),allocatable,dimension(:,:) :: zsum_layer, zsum_layer_mpi

      integer :: is1, is2, istmp
      real(kind=DP) :: rho_magmom(ndim_magmom)
      real(kind=DP) :: c_nr(ndim_spinor,ndim_spinor)
      real(kind=DP) :: c_ni(ndim_spinor,ndim_spinor)
      real(kind=DP) :: cr, ci, denom
      real(kind=DP), allocatable :: afft_kt(:,:)

      denom = 1.d0/product(fft_box_size_WF(1:3,1))

      allocate( zsum_layer(mlayer,ndim_magmom) ); zsum_layer = 0.d0

!!$      zi = cmplx(0.d0,1.d0)
      zi = cmplx(0.d0,1.d0)*PAI2

      iax1 = normal_axis_winlay
      iax2 = iax1 + 1
      if(iax2 >= 4) iax2 = iax2 - 3
      iax3 = iax2 + 1
      if(iax3 >= 4) iax3 = iax3 - 3


!!$      rl11 = rltv(iax1,iax1)
!!$      ss = 1.d0/maxhv
      ss = 3.d0 - kimg

!!$      call get_height(height)

!!$      n = fft_box_size_WF(1,0)*fft_box_size_WF(2,0)*fft_box_size_WF(3,1)
!!$      n = nfft*kimg/kimg/2


      allocate( afft_kt(nfft,ndim_magmom) );  afft_kt = 0.0d0

      do i = 1, nfft-1, 2

         Do is1 = 1, ndim_spinor
            Do is2 = 1, ndim_spinor
               istmp = ( is1 -1 )*ndim_spinor + is2

               cr =    bfft_kt(i,  is1) *bfft_kt(i,  is2) &
                    & +bfft_kt(i+1,is1) *bfft_kt(i+1,is2)

               ci =   -bfft_kt(i,  is1) *bfft_kt(i+1,is2) &
                    & +bfft_kt(i+1,is1) *bfft_kt(i,  is2)

               c_nr(is1,is2) = cr;   c_ni(is1,is2) = ci
            End do
         End do
! --------------------------- convert charge from ss-rep to magmom-rep --
         rho_magmom(1) = c_nr(1,1) + c_nr(2,2);         ! ctot
         rho_magmom(2) = c_nr(1,2) + c_nr(2,1);         ! mx
         rho_magmom(3) = c_ni(2,1) - c_ni(1,2);         ! my
         rho_magmom(4) = c_nr(1,1) - c_nr(2,2);          ! mz
! -----------------------------------------------------------------------
         afft_kt(i,:) = rho_magmom(:)
      End do
!
      Do istmp=1, ndim_magmom
         call m_FFT_WF( ELECTRON, nfout, afft_kt(:,istmp), DIRECT, ON )
         if(kimg == 1) then
            do i = 1, kg
               zrhoik_kt(i,istmp) = afft_kt(igf(i),istmp)*denom
            end do
         else
            do i = 1, kg
               zrhoik_kt(i*2-1,istmp) = afft_kt(igf(i)*2-1,istmp)*denom
               zrhoik_kt(i*2,  istmp) = afft_kt(igf(i)*2,  istmp)*denom
            end do
         end if
      End do
! --
      do ilay = 1, mlayer
!!$         a2 = winlay(ilay,2)
!!$         a1 = winlay(ilay,1)
         a2 = winlay(ilay,2)/height
         a1 = winlay(ilay,1)/height
         width = a2 - a1

         Do istmp=1, ndim_magmom
            zsum = cmplx( zrhoik_kt(1,istmp)*width, 0.d0 )
!!$         zsum = univol*cmplx(zrhoik(1)*width,0.d0)

            if (kimg == 1) then
               do i = 2, kg
                  if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
!!$                  g = rl11*ngabc(i,iax1)
                     g = ngabc(i,iax1)
                     zsum = zsum + zrhoik_kt(i,istmp) &
                          &        *((cdexp(zi*g*a2)-cdexp(zi*g*a1))/( zi*g ))
                  end if
               end do
            else if(kimg == 2) then
               do i = 2, kg
                  if(ngabc(i,iax2) ==  0 .and. ngabc(i,iax3) == 0) then
!!$                  g = rl11*ngabc(i,iax1)
                     g = ngabc(i,iax1)
                     zchg = dcmplx( zrhoik_kt(i*2-1,istmp),zrhoik_kt(i*2,istmp) )
                     zsum = zsum  + zchg*((cdexp(zi*g*a2)-cdexp(zi*g*a1))/( zi*g ))
                  endif
               enddo
            endif
            zsum_layer(ilay,istmp) = real(zsum) *ss
         End do
      end do

      if ( sw_lband == ON ) then
         ib_t = map_z(ib)
      else
         if(ekmode == ON.or.serial) then
            ib_t = ib
         else
            ib_t = map_z(ib)
         end if
      endif

      do ilay = 1, mlayer
         weilay_noncl(ilay,ib_t,ik,:) = zsum_layer(ilay,:)
      end do

      deallocate(zsum_layer)
      deallocate(afft_kt)

    end subroutine substitute_weilay_noncl

    subroutine substitute_weiwsc_noncl(ik,ib,serial)
      integer, intent(in) :: ik,ib
      logical, intent(in) :: serial
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!
      integer :: ijk, nwsc,n, nel, ib_t
      real(kind=DP) :: denom

      integer :: is1, is2
      real(kind=DP) :: rho_magmom(ndim_magmom)
      real(kind=DP) :: c_nr(ndim_spinor,ndim_spinor)
      real(kind=DP) :: c_ni(ndim_spinor,ndim_spinor)
      real(kind=DP) :: cr, ci

      nel = product(fft_box_size_WF(1:3,1))

      denom = 1.d0/dble(nel)
!      denom = 2.d0/dble(nel)

      if(ipridos >= 2) write(nfout,'(" !!ldos: ib, nfft, natm2 = ",i6,i12,i6,"  <<substitute_weiwsc_noncl>>")') &
           & ib, nfft, natm2

      if ( sw_lband == ON ) then
         ib_t = map_z(ib)
      else
         if(ekmode == ON.or.serial) then
            ib_t = ib
         else if(ekmode == OFF) then
            ib_t = map_z(ib)
         end if
      endif

      do ijk = 1, nel
         nwsc = meshwk(ijk,1)
         n    = meshwk(ijk,2)
         if((n < 1 .or. 2*n > nfft) .or. (nwsc < 1 .or. nwsc >natm2+1) ) then
            if(ipridos>=1) then
               write(nfout,'(" !!ldos: n = ",i6," ijk = ",i6)') n, ijk
               write(nfout,'(" !!ldos: nwsc = ",i9)') nwsc
            end if
         else

            Do is1 = 1, ndim_spinor
               Do is2 = 1, ndim_spinor
                  istmp = ( is1 -1 )*ndim_spinor + is2

                  cr =    bfft_kt(2*n-1,is1) *bfft_kt(2*n-1,is2) &
                       & +bfft_kt(2*n,  is1) *bfft_kt(2*n,  is2)

                  ci =   -bfft_kt(2*n-1,is1) *bfft_kt(2*n,  is2) &
                       & +bfft_kt(2*n,  is1) *bfft_kt(2*n-1,is2)

                  c_nr(is1,is2) = cr;   c_ni(is1,is2) = ci
               End do
            End do
! --------------------------- convert charge from ss-rep to magmom-rep --
            rho_magmom(1) = c_nr(1,1) + c_nr(2,2);         ! ctot
            rho_magmom(2) = c_nr(1,2) + c_nr(2,1);         ! mx
            rho_magmom(3) = c_ni(2,1) - c_ni(1,2);         ! my
            rho_magmom(4) = c_nr(1,1) - c_nr(2,2);          ! mz
! -----------------------------------------------------------------------

            weiwsc_noncl(nwsc,ib_t,ik,:) = weiwsc_noncl(nwsc,ib_t,ik,:) &
                 &                       + rho_magmom(:)*denom

         end if
      end do

      if(ipridos >= 2) then
         write(nfout,'(" !ldos: ik, ib = ",2i8," <<substitute_weiwsc_noncl>>")') ik, ib
         write(nfout,'(" !ldos: ",8f10.5)') (weiwsc_noncl(nwsc,ib_t,ik,1),nwsc=1,maldos)
      end if

    end subroutine substitute_weiwsc_noncl

    subroutine substitute_weiwsc_cd_noncl(ik,ib,serial)
      integer, intent(in) :: ik,ib
      logical, intent(in) :: serial
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!
      integer :: ijk, nwsc,n, ib_t
      real(kind=DP) :: denom

!      denom = 0.5d0*univol/product(fft_box_size_CD(1:3,1))
      denom = univol/product(fft_box_size_CD(1:3,1))

      if ( sw_lband == ON ) then
         ib_t = map_z(ib)
      else
         if(ekmode == ON.or.serial) then
            ib_t = ib
         else if(ekmode == OFF) then
            ib_t = map_z(ib)
         end if
      endif

      do ijk = 1, product(fft_box_size_CD(1:3,1))
         nwsc = meshwk(ijk,1)
         n    = meshwk(ijk,2)
         if((n < 1 .or. 2*n > nfftp_nonpara) .or. (nwsc < 1 .or. nwsc >natm2+1) ) then
            if(ipridos>=1) then
               write(nfout,'(" !!ldos: n = ",i6," ijk = ",i6)') n, ijk
               write(nfout,'(" !!ldos: nwsc = ",i9)') nwsc
            end if
         else
            if ( map_ek(ib,ik) == mype) then
               weiwsc_noncl(nwsc,ib_t,ik,:) = weiwsc_noncl(nwsc,ib_t,ik,:) &
                    &                        + denom *bfft_kt(2*n-1,:)
            endif
         end if
      end do

      if(ipridos >=2) then
         write(nfout,'(" !ldos: ik ,ib = ",2i8)') ik, ib
         write(nfout,'(" !ldos: ",8f10.5)') (weiwsc_noncl(nwsc,ib_t,ik,1),nwsc=1,maldos)
      end if

    end subroutine substitute_weiwsc_cd_noncl

    subroutine substitute_weilay_cd_noncl( ik, ib, chgq0, serial, chgq_enl_kt )
      integer, intent(in) :: ik, ib
      real(kind=DP), intent(in) :: chgq0( ndim_magmom )
      real(kind=DP), intent(in) :: chgq_enl_kt( kgp,kimg,ndim_magmom )
      logical, intent(in) :: serial
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!
      integer :: i, ista, iax1, iax2, iax3, ilay,  ib_t
      real(kind=DP) :: g, z_work, ss, a1, a2, width
      complex(kind=CMPLDP) :: zi,zsum,zchg
      real(kind=DP),allocatable,dimension(:,:,:) :: zsum_layer, zsum_layer_mpi

      allocate(zsum_layer(mlayer,2,ndim_magmom)); zsum_layer = 0.d0

      zi = cmplx(0.d0,1.d0)*PAI2

      iax1 = normal_axis_winlay
      iax2 = iax1 + 1
      if(iax2 >= 4) iax2 = iax2 - 3
      iax3 = iax2 + 1
      if(iax3 >= 4) iax3 = iax3 - 3

!!$      rl11 = rltv(iax1,iax1)
!!$      ss = 0.5d0*univol/maxhv

!!!!!!!!      ss = 0.5d0*univol*(3.d0-kimg)
      ss = univol*(3.d0-kimg)


      ista = ista_kngp
      if(ista == 1) ista = 2
      do ilay = 1, mlayer
         if(ipridos >= 2) write(nfout,'(" !!ldos: ib = ",i6," ilay = ",i6 &
              & ," <<substitute_weilay_cd_noncl>>")') ib,ilay
         a2 = winlay(ilay,2)/height
         a1 = winlay(ilay,1)/height
         width = a2 - a1

         Do istmp=1, ndim_magmom
            z_work = chgq0(istmp) *width
            if(serial)then
               if(ista/=2) z_work=0.d0
            endif
            zsum = 0.d0

            if(kimg == 1) then
               if ( sw_lband == ON ) then
                  do i = 2, kgp
                     if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                        g = ngabc(i,iax1)
                        zsum = zsum + chgq_enl_kt(i,1,istmp) &
                             &     *( ( cdexp(zi*g*a2) - cdexp(zi*g*a1))/(zi*g))
                     end if
                  end do
               else
                  if(ekmode == ON.or.serial) then
                     do i = ista, iend_kngp
                        if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                           g = ngabc(i,iax1)
                           zsum = zsum + chgq_l(i,1,istmp) &
                                &     *( ( cdexp(zi*g*a2) - cdexp(zi*g*a1))/(zi*g))

                        end if
                     end do
                  else if(ekmode == OFF) then
                     do i = 2, kgp
                        if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                           g = ngabc(i,iax1)
                           zsum = zsum + chgq_enl_kt(i,1,istmp) &
                                &     *( ( cdexp(zi*g*a2) - cdexp(zi*g*a1))/(zi*g))
                        end if
                     end do
                  end if
               endif
            else if(kimg == 2) then
               if ( sw_lband == ON ) then
                  do i = 2, kgp
                     if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                        g = ngabc(i,iax1)
                        zchg = cmplx(chgq_enl_kt(i,1,istmp),chgq_enl_kt(i,2,istmp))
                        zsum = zsum &
                             & + zchg * ((cdexp(zi*g*a2) - cdexp(zi*g*a1))/(zi*g))
                     end if
                  end do
               else
                  if(ekmode == ON.or.serial) then
                     do i = ista, iend_kngp
                        if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                           g = ngabc(i,iax1)
                           zchg = cmplx(chgq_l(i,1,istmp),chgq_l(i,2,istmp))
                           zsum = zsum &
                                & + zchg * ((cdexp(zi*g*a2) - cdexp(zi*g*a1))/(zi*g))
                        end if
                     end do
                  else if(ekmode == OFF) then
                     do i = 2, kgp
                        if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                           g = ngabc(i,iax1)
                           zchg = cmplx(chgq_enl_kt(i,1,istmp),chgq_enl_kt(i,2,istmp))
                           zsum = zsum &
                                & + zchg * ((cdexp(zi*g*a2) - cdexp(zi*g*a1))/(zi*g))
                        end if
                     end do
                  end if
               endif
            end if
            zsum = zsum + cmplx(z_work,0.d0)

            zsum_layer(ilay,1,istmp) = real(zsum)
            zsum_layer(ilay,2,istmp) = dimag(zsum)

         End do
      end do

#if 0
      if(ekmode == ON.or.serial) then
         if(npes > 1) then
            allocate( zsum_layer_mpi(mlayer,2,ndim_magmom) )
            call mpi_allreduce( zsum_layer, zsum_layer_mpi, mlayer*2*ndim_magmom, &
                 &              mpi_double_precision, mpi_sum, MPI_CommGroup,ierr )
            zsum_layer = zsum_layer_mpi
            deallocate(zsum_layer_mpi)
         end if
      end if

      if(mype == 0) then
         do ilay = 1, mlayer
            if(zsum_layer(ilay,2,1) > 1.d-6) then
               write(6,'(" !!ldos: zsum,ne.real imag = ",d16.8," ilay = ",i6)') &
                    & zsum_layer(ilay,2,1), ilay
            endif
!!$            write(6,'(" !!ldos zsum_layer = ",d16.8," ilay = ",i6)') &
!!$                 & zsum_layer(ilay,1), ilay
         end do
      end if
#endif

      if ( sw_lband == ON ) then
         ib_t = map_z(ib)
      else
         if(ekmode == ON.or.serial) then
            ib_t = ib
         else
            ib_t = map_z(ib)
         end if
      endif

      if ( map_ek(ib,ik) == mype) then
         do ilay = 1, mlayer
            weilay_noncl(ilay,ib_t,ik,:) = weilay_noncl(ilay,ib_t,ik,:) &
                 &                           + zsum_layer(ilay,1,:)*ss
         end do
      endif

      deallocate(zsum_layer)

    end subroutine substitute_weilay_cd_noncl

    subroutine fillup_meshwk(mode)
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!
      integer, intent(in) :: mode
!!$ASASASASAS
!!$      integer, pointer, dimension(:,:,:) :: mesh_t
      integer, allocatable :: mesh_t(:,:,:)
!!$ASASASASAS
      integer :: i,j,k, icount, nwsc, max_nwsc, min_nwsc, n, nl, nm,nn, nd2,id, nfftwk &
           &    , inew, jnew, knew, idr2, idh

      if(mode == SOFTPART) then

         nl = fft_box_size_WF(1,1)
         nm = fft_box_size_WF(2,1)
         nn = fft_box_size_WF(3,1)

         id  = fft_box_size_WF(1,0)
         nd2 = fft_box_size_WF(2,0)
         allocate(mesh_t(id,nd2,nn))
         mesh_t = mesh

         nfftwk = product(fft_box_size_WF(1:3,1))
      else if(mode == HARDPART) then

         nl = fft_box_size_CD(1,1)
         nm = fft_box_size_CD(2,1)
         nn = fft_box_size_CD(3,1)

         id  = fft_box_size_CD_nonpara(1,0)
         nd2 = fft_box_size_CD_nonpara(2,0)
         allocate(mesh_t(id,nd2,nn))
         mesh_t = meshp
         nfftwk = product(fft_box_size_CD(1:3,1))
      end if
      idr2 = (nl+2)/2
      idh  = id/2

      if(allocated(meshwk)) deallocate(meshwk)
      allocate(meshwk(nfftwk,2)); meshwk = 0

      if(ipridos>=2) write(nfout,'(" !! nfftwk = ",i8)') nfftwk

      max_nwsc = 0
      min_nwsc = natm2+2
      icount = 1
      do k = 1, nn
         do j = 1, nm
            do i = 1, nl
!!$               if(icount > nfftwk) then
!!$                  write(nfout,'(" ! icount = ",i7," > nfftwk")') icount
!!$                  stop  ' large icount <<fillup_meshwk.m_Ldos_cal>>'
!!$               end if
               nwsc = mesh_t(i,j,k)
               if(nwsc > max_nwsc) max_nwsc = nwsc
               if(nwsc < min_nwsc) min_nwsc = nwsc
               meshwk(icount,1) = nwsc
               if(kimg == 1) then
                  if( i <= idr2 ) then
                     n = idh*nd2*(k-1) + idr2*(j-1) + i
                  else
                     inew = nl + 2 - i
                     jnew = nm + 2 - j
                     knew = nn + 2 - k
                     if(jnew > nm) jnew = jnew - nm
                     if(knew > nn) knew = knew - nn
                     n = idh*nd2*(knew-1) + idh*(jnew-1) + inew
                  end if
               else
                  n = id*nd2*(k-1) + id*(j-1) + i
               end if
               meshwk(icount,2) = n
               icount = icount + 1
            end do
         end do
      end do
      if(ipridos>=2) then
         write(nfout,*) ' !!ldos:  max_nwsc =  ', max_nwsc
         write(nfout,*) ' !!ldos:  min_nwsc =  ', min_nwsc
#ifdef DEBUG_MESH
         n = 1000
         if(n*2 > nfftwk) n = nfftwk/2
         write(nfout,'(" !ldos nfftwk = ",i8)') nfftwk
         write(nfout,'(" !ldos: meshwk(*,1) first ",i8," elements")') n
         write(nfout,'(14i5)') (meshwk(i,1),i=1,n)
         write(nfout,'(" !ldos: meshwk(*,1) last  ",i8," elements")') n
         write(nfout,'(14i6)') (meshwk(i,1),i=nfftwk-n+1, nfftwk)

         write(nfout,'(" !ldos: meshwk(*,2) first ",i8," elements")') n
         write(nfout,'(14i5)') (meshwk(i,2),i=1,n)
         write(nfout,'(" !ldos: meshwk(*,2) last  ",i8," elements")') n
         write(nfout,'(14i6)') (meshwk(i,2),i=nfftwk-n+1, nfftwk)
#endif
      end if
      deallocate(mesh_t)
    end subroutine fillup_meshwk

  end subroutine m_Ldos_cal_noncl
! ================================================================= 11.0
!$$#endif

  subroutine m_Ldos_get_dos_weight(aldos_or_layerdos,ip,nfldos,ne,nk,dos_weight)
    integer, intent(in) :: aldos_or_layerdos, ip, nfldos
    integer, intent(in) :: ne, nk
    real(kind=DP), intent(out), dimension(ne,nk) :: dos_weight

    real(kind=DP), allocatable, dimension(:,:) :: dos_weight_mpi

    integer :: i, j
    real(kind=DP) :: w
    logical :: serial
    serial = .false.
    if(hardpart_subroutine/=2.and.sw_rspace_ldos==OFF) serial=.true.

    if(ne < neg) then
       if(ipridos>=1) write(nfout,'(" !ldos: ne (= ",i6," ) < neg (= ",i6 &
            & ," ) <<m_Ldos_get_dos_weight>>")') ne, neg
       call phase_error_with_msg(nfout,' ne < neg <<m_Ldos_get_dos_weight>>',__LINE__,__FILE__)
    end if

    if(ekmode == OFF) then
       if(nk < kv3_ek) then
          if(ipridos>=1) write(nfout,'(" !ldos: nk (= ",i6," ) < kv3_ek (= ",i6 &
               & ," ) <<m_Ldos_get_dos_weight>>")') nk, kv3_ek
          call phase_error_with_msg(nfout,' nk < kv3_ek <<m_Ldos_get_dos_weight>>',__LINE__,__FILE__)
       end if

!       if(ne <= iend_e .and. nk <= iend_k) then
        if(ne <= neg .and. nk <= kv3) then
          dos_weight = 0.d0
          if(aldos_or_layerdos == ALDOS) then
             if(.not.serial)then
               do j = ista_k, iend_k
                  do i = ista_e, iend_e, istep_e
                     dos_weight(i,j) = weiwsc(ip,map_z(i),j)
                  end do
               end do
             else
               do j = 1,kv3
                  do i = 1,neg
                     dos_weight(i,j) = weiwsc(ip,i,j)
                  end do
               end do
             endif
          else if(aldos_or_layerdos == LAYERDOS) then
             if(.not.serial)then
               do j = ista_k, iend_k
                  do i = ista_e, iend_e, istep_e
                     dos_weight(i,j) = weilay(ip,map_z(i),j)
                  end do
               end do
             else
               do j = 1, kv3
                  do i = 1,neg
                     dos_weight(i,j) = weilay(ip,i,j)
                  end do
               end do
             endif
          end if
          if(npes > 1.and..not.serial) then
            allocate(dos_weight_mpi(ne,nk))
            call mpi_allreduce(dos_weight, dos_weight_mpi,ne*nk &
                 & ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
            dos_weight = dos_weight_mpi
            deallocate(dos_weight_mpi)
          end if
        end if
    else if(ekmode == ON) then
       if(nk < kv3) then
          if(ipridos>=1) write(nfout,'(" !ldos: nk (= ",i6," ) < kv3 (= ",i6 &
               & ," ) <<m_Ldos_get_dos_weight>>")') nk, kv3_ek
          call phase_error_with_msg(nfout,' nk < kv3 <<m_Ldos_get_dos_weight>>',__LINE__,__FILE__)
       end if
       dos_weight(:,:) = dos_weight_ek(aldos_or_layerdos,ip,:,:)

!       call m_Files_open_nfldos()
!       call skip_headerpart()
!       if(aldos_or_layerdos == ALDOS) then
!          do j = 1, nk
!             do i = 1, ne
!                call read_aldos_weight(ip,w)
!                dos_weight(i,j) = w
!             end do
!          end do
!       else if(aldos_or_layerdos == LAYERDOS) then
!          do j = 1, nk
!             do i = 1, ne
!                call read_layerdos_weight(ip,w)
!                dos_weight(i,j) = w
!             end do
!          end do
!       end if
!       call m_Files_close_nfldos()
    end if
!  contains
!    subroutine skip_headerpart()
!      read(nfldos,*)
!    end subroutine skip_headerpart
!
!    subroutine read_aldos_weight(ip,w)
!      integer, intent(in) :: ip
!      real(kind=DP), intent(out) :: w
!      w = 0.d0
!    end subroutine read_aldos_weight
!
!    subroutine read_layerdos_weight(ip,w)
!      integer, intent(in) :: ip
!      real(kind=DP), intent(out) :: w
!      w = 0.d0
!    end subroutine read_layerdos_weight

  end subroutine m_Ldos_get_dos_weight

! ============================== added by K. Tagami ================== 11.0
  subroutine m_Ldos_get_dos_weight_noncl( aldos_or_layerdos, ip, nfldos, &
       &                                  ne, nk, dos_weight_noncl )
    integer, intent(in) :: aldos_or_layerdos, ip, nfldos
    integer, intent(in) :: ne, nk
    real(kind=DP), intent(out), dimension(ne,nk,ndim_magmom) :: dos_weight_noncl

    real(kind=DP), allocatable, dimension(:,:,:) :: dos_weight_mpi

    integer :: i, j
    real(kind=DP) :: w
    logical :: serial

    serial = .false.
    if(hardpart_subroutine/=2.and.sw_rspace_ldos==OFF) serial=.true.

    if(ne < neg) then
       if(ipridos>=1) write(nfout,'(" !ldos: ne (= ",i6," ) < neg (= ",i6 &
            & ," ) <<m_Ldos_get_dos_weight>>")') ne, neg
       call phase_error_with_msg(nfout,' ne < neg <<m_Ldos_get_dos_weight>>',__LINE__,__FILE__)
    end if

    if(ekmode == OFF) then
       if(nk < kv3_ek) then
          if(ipridos>=1) write(nfout,'(" !ldos: nk (= ",i6," ) < kv3_ek (= ",i6 &
               & ," ) <<m_Ldos_get_dos_weight>>")') nk, kv3_ek
          call phase_error_with_msg(nfout,' nk < kv3_ek <<m_Ldos_get_dos_weight>>',__LINE__,__FILE__)
       end if

!       if(ne <= iend_e .and. nk <= iend_k) then
        if(ne <= neg .and. nk <= kv3) then
          dos_weight_noncl = 0.d0
          if(aldos_or_layerdos == ALDOS) then
             if(.not.serial)then
               do j = ista_k, iend_k
                  do i = ista_e, iend_e, istep_e
                     dos_weight_noncl(i,j,:) = weiwsc_noncl(ip,map_z(i),j,:)
                  end do
               end do
             else
               do j = 1,kv3
                  do i = 1,neg
                     dos_weight_noncl(i,j,:) = weiwsc_noncl(ip,i,j,:)
                  end do
               end do
             endif
          else if(aldos_or_layerdos == LAYERDOS) then
             if(.not.serial)then
               do j = ista_k, iend_k
                  do i = ista_e, iend_e, istep_e
                     dos_weight_noncl(i,j,:) = weilay_noncl(ip,map_z(i),j,:)
                  end do
               end do
             else
               do j = 1, kv3
                  do i = 1,neg
                     dos_weight_noncl(i,j,:) = weilay_noncl(ip,i,j,:)
                  end do
               end do
             endif
          end if

          if(npes > 1.and..not.serial) then
            allocate(dos_weight_mpi(ne,nk,ndim_magmom))
            call mpi_allreduce( dos_weight_noncl, dos_weight_mpi, ne*nk*ndim_magmom, &
                 &              mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )
            dos_weight_noncl = dos_weight_mpi
            deallocate(dos_weight_mpi)
          end if
        end if

    else if(ekmode == ON) then
       if(nk < kv3) then
          if(ipridos>=1) write(nfout,'(" !ldos: nk (= ",i6," ) < kv3 (= ",i6 &
               & ," ) <<m_Ldos_get_dos_weight>>")') nk, kv3_ek
          call phase_error_with_msg(nfout,' nk < kv3 <<m_Ldos_get_dos_weight>>',__LINE__,__FILE__)
       end if

       call m_Files_open_nfldos()
       call skip_headerpart()
       if(aldos_or_layerdos == ALDOS) then
          do j = 1, nk
             do i = 1, ne
                call read_aldos_weight(ip,w)
                dos_weight_noncl(i,j,:) = w
             end do
          end do
       else if(aldos_or_layerdos == LAYERDOS) then
          do j = 1, nk
             do i = 1, ne
                call read_layerdos_weight(ip,w)
                dos_weight_noncl(i,j,:) = w
             end do
          end do
       end if
       call m_Files_close_nfldos()
    end if
  contains
    subroutine skip_headerpart()
      read(nfldos,*)
    end subroutine skip_headerpart

    subroutine read_aldos_weight(ip,w)
      integer, intent(in) :: ip
      real(kind=DP), intent(out) :: w
      w = 0.d0
    end subroutine read_aldos_weight

    subroutine read_layerdos_weight(ip,w)
      integer, intent(in) :: ip
      real(kind=DP), intent(out) :: w
      w = 0.d0
    end subroutine read_layerdos_weight

  end subroutine m_Ldos_get_dos_weight_noncl
! ==================================================================== 11.0

  subroutine m_Ldos_get_ldos_index(ip,aldos_or_layerdos,ipdos,tagwords)
    integer, intent(in) ::  ip
    integer, intent(out) :: aldos_or_layerdos, ipdos
    character(len=40), intent(out) :: tagwords
    integer :: i, na

    aldos_or_layerdos = NO
    ipdos = 0
    tagwords = ''
    if(sw_aldos == ON) then
!!$       if(1 <= ip .and. ip <= maldos ) then
       if(1 <= ip .and. ip <= naldos_write ) then
          aldos_or_layerdos = ALDOS
!!$          ipdos = naldos_from + ip - 1
          na = 0
          do i = naldos_from, naldos_to
             if(if_aldos_full(i) == ON) na = na + 1
             if(na == ip) then
                ipdos = i
                exit
             end if
          end do
          if(ipdos > maldos .or. ipdos < 1 ) then
             write(nfout,'(" !! ipdos ( = ",i8," ) is illegal << m_Ldos_get_ldos_index>>")') ipdos
             call phase_error_with_msg(nfout,' ipdos is illegal << m_Ldos_get_ldos_index>>',__LINE__,__FILE__)
          end if
       else if( ip > naldos_write ) then
          if(sw_layerdos == ON) then
             aldos_or_layerdos = LAYERDOS
             ipdos = ip - naldos_write
             write(tagwords,999) winlay(ipdos,1)*BOHR,winlay(ipdos,2)*BOHR
          end if
       end if
    else if(sw_layerdos == ON) then
       if( 1 <= ip .and. ip <= mlayer) then
          aldos_or_layerdos = LAYERDOS
          ipdos = ip
          write(tagwords,999) winlay(ipdos,1)*BOHR,winlay(ipdos,2)*BOHR
       end if
    end if
999 format(' range = [',f8.4,' : ',f8.4,']  (Angst.)')

  end subroutine m_Ldos_get_ldos_index

  subroutine m_Ldos_load_dos_weight()
    use m_Const_Parameters, only :FMAXTAGLEN
    integer :: nldos,imode,ik,kread,m,i,ierr
    real(kind=DP),allocatable,dimension(:) :: w
    integer :: ios
    logical :: eof

    call m_Files_open_nfldos()
    nldos = maldos
    if(mlayer>nldos) nldos = mlayer
    if(.not.allocated(dos_weight_ek)) allocate(dos_weight_ek(2,nldos,neg,kv3_ek))
    dos_weight_ek = 0.d0

    if (mype==0) then
      rewind(nfldos)
      kread = 0
      do i=1, 4
         read(nfldos,*,iostat=ios)
      end do

      do
         read(nfldos,*,iostat=ios) imode,ik
         if(ios==-1) then
           write(nfout,*) '!** EOF reached'
           exit
         endif
         if(imode==ALDOS) then
           m = maldos
         else if (imode==LAYERDOS) then
           m = mlayer
         endif
         allocate(w(m));w=0.d0

         do i = 1, neg -num_extra_bands
            call read_dos_weight(m,w,eof)
            dos_weight_ek(imode,1:m,i,ik) = w(1:m)
            if(eof) then
               write(nfout,*) '!** EOF reached'
               exit
            endif
         end do
         deallocate(w)
         kread = kread+1
!         if (kread == kv3_ek) exit
      enddo
    endif

    call m_Files_close_nfldos()
    if(npes>1) call mpi_bcast(dos_weight_ek,neg*kv3_ek*2*nldos, &
                    mpi_double_precision,0,MPI_CommGroup,ierr)

    contains

    subroutine read_dos_weight(m,w,eof)
      integer, intent(in) :: m
      real(kind=DP), dimension(m), intent(out) :: w
      logical, intent(out) :: eof
      character(len=FMAXTAGLEN) :: chr
      integer :: j,ios
      eof = .false.
      read(nfldos,*,iostat=ios) chr,(w(j),j=1,m)
      if(ios == -1) then
         eof = .true.
         return
      endif
    end subroutine read_dos_weight

  end subroutine m_Ldos_load_dos_weight


  subroutine m_Ldos_dealloc()
     if(allocated(if_aldos_full)) deallocate(if_aldos_full)
     if(allocated(mesh)) deallocate(mesh)
     if(allocated(meshp)) deallocate(meshp)
     if(allocated(winlay)) deallocate(winlay)
     if(allocated(ac_mesh)) deallocate(ac_mesh)
     if(allocated(nac_mesh)) deallocate(nac_mesh)
     if(allocated(ac_mesh_cd)) deallocate(ac_mesh_cd)
     if(allocated(nac_mesh_cd)) deallocate(nac_mesh_cd)
  end subroutine m_Ldos_dealloc

  subroutine get_fftbox_size(mode,nl0,nm0,nl,nm,nn)
    integer, intent(in)  :: mode
    integer, intent(out) :: nl0,nm0,nl,nm,nn
    if(mode==SOFTPART) then
       nl0 = fft_box_size_WF(1,0)
       nm0 = fft_box_size_WF(2,0)
       nl  = fft_box_size_WF(1,1)
       nm  = fft_box_size_WF(2,1)
       nn  = fft_box_size_WF(3,1)
    else if(mode==HARDPART) then
       nl0 = fft_box_size_CD_nonpara(1,0)
       nm0 = fft_box_size_CD_nonpara(2,0)
       nl  = fft_box_size_CD(1,1)
       nm  = fft_box_size_CD(2,1)
       nn  = fft_box_size_CD(3,1)
    end if
  end subroutine get_fftbox_size

end module m_Ldos

!================================================
!  Software name : STM
!  Subroutine(s) :
!  Author(s)     : Takahiro Yamasaki (June 7, 2004)
!
!  FURTHER MODIFICATION: Takahiro Yamasaki (June 24, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!                           @(#)miscellaneous.F 1.1 01/03/13 00:35:39
!
! $Id: miscellaneous.F90,v 1.1.1.1 2004/06/26 11:21:37 yamasaki Exp $
#ifndef VPP
#ifdef _USE_DATE_AND_TIME_
subroutine gettod(x)
  use m_Const_Parameters, only :DP
  real(kind=DP), parameter   :: milisec     = 1.d3
  real(kind=DP), parameter   :: t_mil2micro = 1.d3
  real(kind=DP), intent(out) :: x

  integer ipresent_time(8)
  real(kind=DP)       :: tstart
  real(kind=DP), save ::tstart0
  data istart/0/
  data tstart/0.0/
  ! Month   1   2   3   4   5   6   7   8   9  10  11  12
  ! days   31  28  31  30  31  30  31  31  30  31  30  31
  !sumdays 31  59  90 120 151 181 212 243 273 304 334 365
  integer, dimension(12) :: sdays
  integer, parameter     :: days_to_1970 = 719460
  data sdays/0, 31, 59, 90,120,151,181,212,243,273,304,334/
  integer  :: days_from_January_1st, month, year, day, days_from_1970_to_this_year

  call date_and_time(values=ipresent_time)
  year = ipresent_time(1); month = ipresent_time(2); day = ipresent_time(3)
!!$  days_from_1970_to_this_year = year*365 + year/4 - year/100 + year/400 - days_to_1970
  days_from_January_1st = sdays(month) + day - 1
  if(month >= 3 .and. mod(year,4) == 0) &
       & days_from_January_1st = days_from_January_1st + 1
!!$  tstart =(((days_from_1970_to_this_year + days_from_January_1st*24 & !hours
  tstart =(((days_from_January_1st*24 & !hours
       & + ipresent_time(5))*60 &             !minutes
       & + ipresent_time(6))*60 &             !seconds
       & + ipresent_time(7))*milisec  &       !mili-seconds
       & + ipresent_time(8)
!!$  if(istart <= 3) then
!!$     write(6,'(" total_days_from_January_1st = ",i10)') total_days_from_January_1st
!!$     write(6,'(" ipresent_time(1-3) = ",3i10)') ipresent_time(1),ipresent_time(2),ipresent_time(3)
!!$     write(6,'(" ipresent_time(4-6) = ",3i10)') ipresent_time(4),ipresent_time(5),ipresent_time(6)
!!$     write(6,'(" ipresent_time(7-8) = ",3i10)') ipresent_time(7),ipresent_time(8)
!!$  end if

  if(istart.eq.0) tstart0 = tstart

  istart = istart + 1
  x = (tstart - tstart0)*t_mil2micro
  return
end subroutine gettod
#else
subroutine gettod(x)
  use m_Const_Parameters, only :DP
  real(kind=DP), intent(out) :: x
  integer :: count, count_rate, count_max
  integer, save :: count_prev
  integer, save :: initialized = 0
  integer, save :: istart = 0
  real (kind=DP)       :: tstart
  real (kind=DP), save :: tstart0 
  call system_clock(count, count_rate, count_max)
  if(count_prev > count) initialized = initialized + 1
  tstart = (count+initialized*count_max)*1.d0/count_rate
  if(istart <= 2) then
     if(istart <= 1) write(6,'(" !@ -- system_clock check --")')
     write(6,'(" !@ count, count_rate, count_max = ",3i12)') count, count_rate, count_max
     write(6,'(" !@ tstart = ",d20.12)') tstart
  end if
  if(tstart == 0) tstart0 = tstart
  istart = istart + 1
  x  = (tstart-tstart0)*1.d6
  count_prev = count
  return
end subroutine gettod
#endif
#else
subroutine dummy
end subroutine dummy
#endif

#ifdef CRAY
function derf(x)
  implicit real*8(a-h,o-z)
  derf = erf(x)
  return
end function derf

function derfc(x)
  implicit real*8(a-h,o-z)
  derfc = erfc(x)
  return
end function derfc
#endif

module m_External_Potential
  use m_Control_Parameters, only : sw_external_potential
  use m_Parallelization, only : MPI_CommGroup

  implicit none

  ! external point charge
  integer :: natom_ex = 0
  real(8), allocatable, dimension(:,:) :: pos_ex
  real(8), allocatable, dimension(:) :: charge_ex
  real(8), allocatable, dimension(:) :: coulomb_rc
  real(8), allocatable, dimension(:) :: coulomb_rn
  ! external potential (electrostatic potential)
  real(8), allocatable, dimension(:,:) :: espot
  real(8), allocatable, dimension(:,:,:) :: espot_g

  ! temporary
  real(8), dimension(:,:), pointer :: mesh_coord
  real(8) :: mesh_delta(3,3)
  real(8), dimension(:), pointer :: charge_r

contains

  subroutine m_EP_alloc_point_charge
    implicit none

    if( .not. allocated(pos_ex) ) allocate(pos_ex(natom_ex,3))
    if( .not. allocated(charge_ex) ) allocate(charge_ex(natom_ex))
    if( .not. allocated(coulomb_rc) ) allocate(coulomb_rc(natom_ex))
    if( .not. allocated(coulomb_rn) ) allocate(coulomb_rn(natom_ex))

  end subroutine m_EP_alloc_point_charge

  subroutine m_EP_dealloc_point_charge
    implicit none

    if( allocated(pos_ex) ) deallocate(pos_ex)
    if( allocated(charge_ex) ) deallocate(charge_ex)
    if( allocated(coulomb_rc) ) deallocate(coulomb_rc)
    if( allocated(coulomb_rn) ) deallocate(coulomb_rn)

  end subroutine m_EP_dealloc_point_charge

  subroutine m_EP_set_point_charge(n,pos,q,rc,rn)
    implicit none
    integer n
    real(8) pos(n,3)
    real(8) q(n)
    real(8) rc(n)
    real(8) rn(n)
    integer i

    natom_ex = n
    call m_EP_alloc_point_charge

    pos_ex = pos
    charge_ex = q
    coulomb_rc = rc
    coulomb_rn = rn

  end subroutine m_EP_set_point_charge

! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================

end module m_External_Potential

! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================

#ifdef HIUX
*option MP(P(0))
#endif
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  MODULE: m_BP_Properties
!
!  AUTHOR(S): T. Yamamoto   Oct/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_BP_Properties
  ! $ID: $
  !
  ! Properties:
  ! 1. Berry-phase polarization
  !
  !    P_a = -qe/V sum_j Z_ion(j) * r(j)_a - qe/V * f/(2*pi) sum_i A_ia * phi_i
  !
  ! 2. Effective charge tensor
  !
  !    Z_ab = Z_ion + f/(2*pi) sum_i A_ia * d(phi_i)/d(u_b)
  !
  ! 3. piezoelectirc stress tensor
  !
  !    C_ab = f/(2*pi*V) sum_i A_ia * d(phi_i)/d(e_b)
  !

  use m_Files, only : nfout
  use m_Control_Parameters, only : polar_prop,nspin,printable, ndim_spinor
  use m_Const_Parameters,   only : DP, PAI, PAI2, ON, OFF &
       &      , POLARIZATION, EFFECTIVE_CHARGE &
       &      , PIEZOELECTRIC_CONST, UNIT_PIEZO_CONST
  use m_Parallelization,    only : MPI_CommGroup,mype,npes,ierr
  use mpi

  implicit none
!  include 'mpif.h'

  integer, private :: num_berry_phase,max_num_kpoints
  integer, private, allocatable :: num_kpoints(:) ! dim(num_berry_phase)
  integer, private, allocatable :: g_index(:) ! dim(num_berry_phase)
  integer, private, allocatable :: direction(:) ! dim(num_berry_phase)
  integer, private, allocatable :: displaced_atom(:) ! dim(num_berry_phase)
  ! 1 -> x, 2 -> y, 3 -> z
  real(kind=DP), private, allocatable :: u(:) ! dim(num_berry_phase)

! atomic displacement
  real(kind=DP), private, allocatable :: displacement(:,:) ! dim(3,num_berry_phase)
  complex(kind=DP), private, allocatable :: cphi(:,:,:) ! dim(nkprep_max,nspin,num_berry_phase)
  real(kind=DP), private, allocatable :: wgh(:,:) ! dim(nkprep_max,num_berry_phase)
  real(kind=DP), private, allocatable :: epsstr(:) ! dim(num_berry_phase)
  real(kind=DP), private, allocatable :: posstr(:,:,:) ! dim(natm,3,num_berry_phase)
  integer, private, allocatable :: istrain(:) ! dim(num_berry_phase)

! Properties
  real(kind=DP), allocatable :: zeff(:,:,:) ! dim(3,3,natm)
  real(kind=DP), allocatable :: piezo(:,:) ! dim(3,6)

contains

  subroutine m_BP_read_Berry_phase(paramset)
    use m_Files, only : m_Files_open_nfberry, nfberry
    use m_Ionic_System, only : natm
    implicit none

    logical, intent(in) :: paramset

! local variables
    integer :: i,k,ia,is, ismax
    integer :: idummy
    real(kind=DP) :: dummy,cphi_re,cphi_im,phi
    real(kind=DP) :: d(3),tmp,epstmp(3,3)

    ! debug
    !write(nfout,*) 'DEBUG: reading berry.data (1)'
    ! end debug

! === KT_add === 2015/03/23
       ismax = nspin /ndim_spinor
! ============== 2015/03/23

    if(.not.paramset) then
       allocate(num_kpoints(1),g_index(1),displaced_atom(1),displacement(3,1))
       allocate(wgh(1,1))
    else
       ! debug
       !   write(nfout,*) 'DEBUG: num_berry_phase = ',num_berry_phase
       !   write(nfout,*) 'DEBUG: max_num_kpoints = ',max_num_kpoints
       ! end debug
       allocate(num_kpoints(num_berry_phase))
       allocate(g_index(num_berry_phase))
       allocate(displaced_atom(num_berry_phase))
       allocate(displacement(3,num_berry_phase))


! === KT_mod === 2015/03/23
!       allocate(cphi(max_num_kpoints,nspin,num_berry_phase))
       allocate(cphi(max_num_kpoints,ismax,num_berry_phase))
! ============== 2015/03/23

       allocate(wgh(max_num_kpoints,num_berry_phase))
       allocate(direction(num_berry_phase))
       allocate(u(num_berry_phase))

       if( polar_prop == PIEZOELECTRIC_CONST ) then
          allocate(istrain(num_berry_phase))
          allocate(epsstr(num_berry_phase))
          allocate(posstr(natm,3,num_berry_phase))
       end if
    end if

    ! debug
    !write(nfout,*) 'DEBUG: reading berry.data (2)'
    ! end debug

    if(mype == 0) then

       if(.not.paramset) max_num_kpoints = 0

       call m_Files_open_nfberry()
       rewind nfberry
       read(nfberry,*) num_berry_phase

       ! debug
!!$       write(nfout,*) 'DEBUG: num_berry_phase = ',num_berry_phase;      call flush(nfout)
       ! end debug

       if(.not.paramset) then
          do i=1,num_berry_phase
             ! debug
!!$             write(nfout,'("m_BP_read_Berry_phase: "i7,"-th berry data is reading.")') i;   call flush(nfout)
             ! end debug
             read(nfberry,*) num_kpoints(1), g_index(1), displaced_atom(1), &
                  &                                     displacement(1:3,1)
             do is=1, ismax
                do k=1,num_kpoints(1)
                   read(nfberry,*) idummy,cphi_re,cphi_im,phi,wgh(1,1)
                end do
             end do
             if(num_kpoints(1) .gt. max_num_kpoints) then
                max_num_kpoints = num_kpoints(1)
             end if
             if( polar_prop == PIEZOELECTRIC_CONST ) then
                do k=1,3
                   read(nfberry,*)
                end do
                read(nfberry,*) idummy
                do k=1,idummy
                   read(nfberry,*)
                end do
             end if
          end do
          ! debug
!!$          write(nfout,*) 'DEBUG: max_num_kpoints = ',max_num_kpoints;  call flush(nfout)
          ! end debug
       else
          do i=1,num_berry_phase
             ! debug
!!$             write(nfout,'("m_BP_read_Berry_phase: "i7,"-th berry data is reading.")') i;   call flush(nfout)
             ! end debug

             read(nfberry,*) num_kpoints(i),g_index(i), displaced_atom(i), &
                  &                                     displacement(1:3,i)

             ! debug
!!$             write(nfout,'("DEBUG: the header was read.")');       call flush(nfout)
             ! end debug

             if(polar_prop == EFFECTIVE_CHARGE) then
                direction(i) = 1
                u(i) = 0.d0
                do k=1,3
                   if(abs(displacement(k,i)) > 1.d-10) then
                      ! debug
                      !write(nfout,'("m_BP_read_Berry_phase: displacement = ",e25.14)') displacement(k,i)
                      direction(i) = k
                      u(i) = displacement(k,i)
                      !write(nfout,'("m_BP_read_Berry_phase: "i7,"-th data. u=",e25.14)') i,u(i)
                      ! end debug
                   end if
                end do

                d(1:3) = displacement(1:3,i)
                d(direction(i)) = d(direction(i)) - u(i)
                if(abs(sum(d(1:3)**2)) > 1.d-10) then
                   if(printable) then
                      write(nfout,'("Displacement vector of ",i4,"-th atom =",3(1x,f10.5))') &
                           & displaced_atom(i),displacement(1:3,i)
                   end if
                   return
                   !stop 'Error of displacement in <<<m_BP_read_Berry_phase>>>'
                end if
                if(displaced_atom(i) <= 0) direction(i) = -1
             end if

             ! debug
!!$             write(nfout,'("DEBUG: berry phase is reading.")');      call flush(nfout)
             ! end debug

             do is=1, ismax
                do k=1,num_kpoints(i)
                   read(nfberry,*) idummy,cphi_re,cphi_im,phi,wgh(k,i)
                   cphi(k,is,i) = dcmplx(cphi_re,cphi_im)
                end do
             end do

             if( polar_prop == PIEZOELECTRIC_CONST ) then
                ! debug
!!$                write(nfout,'("DEBUG: strain tensor is reading.")');    call flush(nfout)
                ! end debug
                read(nfberry,*) epstmp(1,1:3)
                read(nfberry,*) epstmp(2,1:3)
                read(nfberry,*) epstmp(3,1:3)
                call set_istrain(epstmp,istrain(i),epsstr(i))
                read(nfberry,*) idummy
                if(idummy /= natm) then
                   call phase_error_with_msg(nfout,'natm in berry.data differs from natm in PHASE.',__LINE__,__FILE__)
                end if
                do ia=1,natm
                   read(nfberry,*) idummy,posstr(ia,1:3,i)
                end do
             end if
             if(printable) then
                write(nfout,'(i7,"-th berry data was read.")') i
                call flush(nfout)
             end if
          end do
       end if

    end if

    if(.not.paramset) then
       deallocate(num_kpoints,g_index,displaced_atom,displacement)
       deallocate(wgh)
    end if

    if(npes > 1) then
       if(.not.paramset) then
          call mpi_bcast(num_berry_phase,1,mpi_integer,0,MPI_CommGroup,ierr) ! MPI
          call mpi_bcast(max_num_kpoints,1,mpi_integer,0,MPI_CommGroup,ierr) ! MPI
       else
          call mpi_bcast(num_kpoints,num_berry_phase,mpi_integer,0,MPI_CommGroup,ierr)
          call mpi_bcast(g_index,num_berry_phase,mpi_double_precision,0,MPI_CommGroup,&
               &         ierr) ! MPI
          call mpi_bcast(displaced_atom,num_berry_phase,mpi_integer,0,MPI_CommGroup,&
               &         ierr) ! MPI
          call mpi_bcast(displacement,num_berry_phase*3,mpi_double_precision,0,&
               &         MPI_CommGroup,ierr) ! MPI
!!$          call mpi_bcast(cphi,max_num_kpoints*ismax*num_berry_phase*2,&
          call mpi_bcast(cphi,max_num_kpoints*ismax*num_berry_phase,&
               &         mpi_double_complex,0,MPI_CommGroup,ierr) ! MPI
          call mpi_bcast(wgh,max_num_kpoints*num_berry_phase,mpi_double_precision, &
               &         0,MPI_CommGroup,ierr) ! MPI
          call mpi_bcast(direction,num_berry_phase,mpi_integer,0,MPI_CommGroup,ierr)
          call mpi_bcast(u,num_berry_phase,mpi_double_precision,0,MPI_CommGroup,ierr)
       end if
    end if

  contains

    subroutine set_istrain(eps,istrain,str)
      real(kind=DP), intent(in) :: eps(3,3)
      integer, intent(out) :: istrain
      real(kind=DP), intent(out) :: str

      integer :: i
      real(kind=DP) :: dst(6)

      dst(1) = eps(1,1)
      dst(2) = eps(2,2)
      dst(3) = eps(3,3)
      dst(4) = eps(2,3)+eps(3,2)
      dst(5) = eps(3,1)+eps(1,3)
      dst(6) = eps(1,2)+eps(1,2)

      ! debug
      if(printable) then
         write(nfout,*) 'debug: set_istrain'
         do i=1,6
            write(nfout,*) i,dst(i)
         end do
         write(nfout,*) 'end debug: set_istrain'
      end if
      ! end debug

      istrain = 0
      do i=1,6
         if(abs(dst(i)) > 0.d0) then
            istrain = i
            str = dst(i)
            return
         end if
      end do

    end subroutine set_istrain

  end subroutine m_BP_read_Berry_phase

  subroutine m_BP_get_Berry_phase(atom_id,g_id,dir_id,cphi_out,wgh_out,nkp,u_out,exists)
    implicit none
    integer, intent(in) :: atom_id, g_id, dir_id
    complex(kind=DP), intent(out) :: cphi_out(max_num_kpoints,nspin/ndim_spinor)
    real(kind=DP), intent(out) :: wgh_out(max_num_kpoints)
    integer, intent(out) :: nkp
    real(kind=DP), intent(out) :: u_out
    logical, intent(out) :: exists

! lcoal variables
    integer :: i,k,is, ismax

! === KT_add === 2015/03/23
    ismax = nspin /ndim_spinor
! ============== 2015/03/23

    exists = .false.
    do i=1,num_berry_phase
       ! debug
       !write(6,*) 'atom_id,g_id,dir_id=',atom_id,g_id,dir_id,': i=',i
       ! end debug
       if(displaced_atom(i).eq.atom_id .and. &
            & g_index(i).eq.g_id .and. &
            & direction(i).eq.dir_id) then
          nkp = num_kpoints(i)

          do is=1,ismax
             do k=1,nkp
                cphi_out(k,is) = cphi(k,is,i)
                wgh_out(k) = wgh(k,i)
             end do
          end do
          u_out = u(i)
          exists = .true.
          return
       end if
    end do

    return
  end subroutine m_BP_get_Berry_phase

  subroutine m_BP_calc_diff_Berry_phase(dphi,present_atom)
    use m_Ionic_System, only : natm
    implicit none
    real(kind=DP), intent(out) :: dphi(3,3,natm)
    logical, intent(out) :: present_atom(natm)

! local variables
    integer :: ia,ig,id,k,ia0,is, ismax
    integer :: nkp0,nkp1
    complex(kind=DP) :: cphi0(max_num_kpoints,nspin/ndim_spinor)
    complex(kind=DP) :: cphi1(max_num_kpoints,nspin/ndim_spinor)
    real(kind=DP) :: wgh0(max_num_kpoints)
    real(kind=DP) :: wgh1(max_num_kpoints)
    real(kind=DP) :: phi(max_num_kpoints)
    real(kind=DP) :: u0,u1
!!$logical :: exists
    logical :: exists1, exists2

    present_atom(1:natm) = .false.

! === KT_add === 2015/03/23
    ismax = nspin /ndim_spinor
! ============== 2015/03/23

    ATOM: do ia=1,natm
!!$       write(6,'(" ia = ",i8," <<m_BP_calc_diff_Berry_phase>>")') ia
       do ig=1,3
          ia0 = 0
          id = -1
!!$call m_BP_get_Berry_phase(ia0,ig,id,cphi0,wgh0,nkp0,u0,exists)
!!$if(.not.exists) cycle ATOM
          call m_BP_get_Berry_phase(ia0,ig,id,cphi0,wgh0,nkp0,u0,exists1)
          do id=1,3
!!$call m_BP_get_Berry_phase(ia,ig,id,cphi1,wgh1,nkp1,u1,exists)
!!$if(.not.exists) cycle ATOM
             call m_BP_get_Berry_phase(ia,ig,id,cphi1,wgh1,nkp1,u1,exists2)
             if(.not.(exists1.and.exists2)) cycle
             present_atom(ia) = .true.
             if(nkp0.ne.nkp1) then
                if(printable) then
                   write(nfout,*) 'nkp0=',nkp0
                   write(nfout,*) 'nkp1=',nkp1
                end if
                call phase_error_with_msg(nfout,'nkp0 and nkp1 are different in <<<m_BP_calc_diff_Berry_phase>>'&
                                         ,__LINE__,__FILE__)
             end if

             ! debug
             !   write(nfout,*) 'ia,ig,id =',ia,ig,id
             ! end debug

             dphi(id,ig,ia) = 0.d0

             do is=1,ismax
                do k=1,nkp0
                   if(wgh0(k).ne.wgh1(k)) then
                      if(printable) then
                         write(nfout,*) 'wgh0=',wgh0(k)
                         write(nfout,*) 'wgh1=',wgh1(k)
                      end if
                      call phase_error_with_msg(nfout,'wgh0 and wgh1 are different in <<<m_BP_calc_diff_Berry_phase>>'&
                                               ,__LINE__,__FILE__)
                   end if
                   phi(k) = dimag(log(cphi1(k,is)/cphi0(k,is)))
                   ! debug
                   !     write(nfout,*) 'k=',k,' phi=',phi(k)
                   ! end debug
                   dphi(id,ig,ia) = dphi(id,ig,ia) + phi(k)*wgh0(k)
                end do
             end do
             ! debug
             !   write(nfout,*) 'ia,id,ig=',id,ig,ia,' dphi=',dphi(id,ig,ia)
             ! end debug
             dphi(id,ig,ia) = 2.d0*dphi(id,ig,ia)/u1
             ! debug
             !   write(nfout,*) 'ia,id,ig=',id,ig,ia,' dphi/u=',dphi(id,ig,ia)
             ! end debug
          end do
       end do
!!$present_atom(ia) = .true.
    end do ATOM
    return

  end subroutine m_BP_calc_diff_Berry_phase

  subroutine m_BP_calc_Polarization()
    use m_Crystal_Structure, only : altv
    use m_Ionic_System, only : natm,ntyp,ityp,cps
    use m_Crystal_Structure, only : univol
    use m_PseudoPotential, only : ival
    implicit none

! local variables
    integer :: i,ia,nkp,is, ismax
    real(kind=DP) :: polar_ion(3), polar_ele(3), polar_tot(3)
    real(kind=DP) :: phi(3)
    real(kind=DP) :: fac

    do ia=1,natm
       polar_ion(1:3) = polar_ion + ival(ityp(ia))*cps(ia,1:3)
    end do
    fac = 2.d0/(PAI2*univol)
    polar_ele(1:3) = 0.d0

! === KT_add === 2015/03/23
    ismax = nspin /ndim_spinor
! ============== 2015/03/23

    do i=1,3
       nkp = num_kpoints(i)
       phi(i) = 0.d0
       do is=1, ismax
          phi(i) = phi(i) +  sum(dimag(log(cphi(1:nkp,is,i)))*wgh(1:nkp,i))
       end do
       polar_ele(1:3) = polar_ele(1:3) + fac*altv(1:3,i)*phi(i)
    end do
    polar_tot(1:3) = polar_ion(1:3) + polar_ele(1:3)

! print polarization
    if(printable) then
       write(nfout,*) ' --- Berry phase ---'
       write(nfout,'("phi =",3(1x,f20.10))') phi(1:3)
       write(nfout,*) ' --- Polarization ---'
       write(nfout,'("P_ion =",3(1x,f20.10))') polar_ion(1:3)
       write(nfout,'("P_ele =",3(1x,f20.10))') polar_ele(1:3)
       write(nfout,'("P_tot =",3(1x,f20.10))') polar_tot(1:3)
    end if

    return
  end subroutine m_BP_calc_Polarization

  subroutine m_BP_calc_Effective_charge()
    use m_Crystal_Structure, only : altv,nopr,op
    use m_Ionic_System, only : natm,ntyp,ityp,cps,napt
    use m_Crystal_Structure, only : univol
    use m_PseudoPotential, only : ival
    use m_Files, only : nfeffchg, m_Files_open_nfeffchg
    use m_Control_Parameters,  only : sw_check_sumrule_born_charge

    implicit none

! local variables
    integer :: i,j,k,ia,ja,iopr
    logical :: present_atom(natm)
!    real(kind=DP) :: dphi(3,3,natm)
!    real(kind=DP) :: zeff_el(3,3,natm)
    real(kind=DP), allocatable :: dphi(:,:,:)
    real(kind=DP), allocatable :: zeff_el(:,:,:)
    !real(kind=DP) :: zeff(3,3,natm)

    real(kind=DP) :: fac
    real(kind=DP) :: ztmp(3,3)

! == ASMS DEBUG ==
!!!real(kind=DP) :: nsym
    integer :: nsym
! ===============

    real(kind=DP) :: nonzero(3,3)

!!$    write(nfout,'(" !! (-1) Effective_charge")');    call flush(nfout)
!!$    write(nfout,*) ' allocated(zeff) = ', allocated(zeff), " natm = ",natm

    allocate( dphi(3,3,natm) );  dphi = 0.0d0
    allocate( zeff_el(3,3,natm) );  zeff_el = 0.0d0
                        
    if(.not.allocated(zeff)) then
       allocate(zeff(3,3,natm))
       zeff = 0.0d0
    endif
!!$    write(nfout,'(" !! (0) Effective_charge")');    call flush(nfout)

    if( polar_prop == EFFECTIVE_CHARGE ) then

       call m_BP_calc_diff_Berry_phase(dphi,present_atom)
       fac = 1.d0/PAI2
       do ia=1,natm
          if(.not.present_atom(ia)) cycle
          do j=1,3
             do i=1,3
                zeff_el(i,j,ia) = fac*sum(altv(i,1:3)*dphi(j,1:3,ia))
                zeff(i,j,ia) = zeff_el(i,j,ia)
             end do
          end do
          do i=1,3
             zeff(i,i,ia) = zeff(i,i,ia) + ival(ityp(ia))
          end do
       end do

! print electronic effective charges
       if(printable) then
          write(nfout,*) ' --- Calculated electronic effective charges ---'
          do ia=1,natm
             if(.not.present_atom(ia)) cycle
             write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff_el(1,1:3,ia)
             write(nfout,'("Zel (",i3,") = [",3(1x,f10.5),1x,"]")') ia,zeff_el(2,1:3,ia)
             write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff_el(3,1:3,ia)
             write(nfout,*)
          end do

! print effective charges
          write(nfout,*) ' --- Calculated effective charges ---'
          do ia=1,natm
             if(.not.present_atom(ia)) cycle
             write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(1,1:3,ia)
             write(nfout,'("Zeff(",i3,") = [",3(1x,f10.5),1x,"]")') ia,zeff(2,1:3,ia)
             write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(3,1:3,ia)
             write(nfout,*)
          end do
       end if
    else
       call m_BP_read_Effective_charge(zeff,present_atom)
    end if

!!$    write(nfout,'(" !! (1) Effective_charge")');    call flush(nfout)

! Symmetrization
    ATOM: do ia=1,natm
       if(.not.present_atom(ia)) cycle ATOM
       ztmp(1:3,1:3) = 0.d0
       nsym=0
       OPERATION: do iopr=1,nopr
          if(napt(ia,iopr).ne.ia) cycle OPERATION
          nsym=nsym+1
          do j=1,3
             do i=1,3
                do k=1,3
                   ztmp(i,j) = ztmp(i,j)+sum(op(i,1:3,iopr)*zeff(1:3,k,ia))*op(j,k,iopr)
                end do
             end do
          end do
       end do OPERATION
       zeff(1:3,1:3,ia) = ztmp(1:3,1:3)/nsym
    end do ATOM

!!$    write(nfout,'(" !! (2) Effective_charge")')

! print effective charges
    if(printable) then
       write(nfout,*) ' --- Symmetrized effective charges ---'
       do ia=1,natm
          if(.not.present_atom(ia)) cycle
          write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(1,1:3,ia)
          write(nfout,'("Zsym(",i3,") = [",3(1x,f10.5),1x,"]")') ia,zeff(2,1:3,ia)
          write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(3,1:3,ia)
          write(nfout,*)
       end do
    end if

! calculate effective chareges of equivalent atoms
    ATOM2: do ia=1,natm
       ! debug
       !  print *,'DEGUG: ia=',ia
       if(.not.present_atom(ia)) cycle ATOM2
       OPERATION2: do iopr=1,nopr
          ja = napt(ia,iopr)
          ! debug
          !  print *,'DEGUG: operation iopr=',iopr
          !  print *,'DEGUG: equivalent atom ja=',ja

          if(ja.eq.ia) cycle OPERATION2
          if(present_atom(ja)) cycle OPERATION2
          zeff(1:3,1:3,ja) = 0.d0
          do j=1,3
             do i=1,3
                do k=1,3
                   zeff(i,j,ja) = zeff(i,j,ja) &
                        &        + sum(op(i,1:3,iopr)*zeff(1:3,k,ia))*op(j,k,iopr)
                end do
             end do
          end do
          present_atom(ja) = .true.
       end do OPERATION2
    end do ATOM2

! print effective charges of all atoms
    if(printable) then
       write(nfout,*) ' --- Effective charges of all atoms ---'
       do ia=1,natm
          write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(1,1:3,ia)
          write(nfout,'("Zeff(",i3,") = [",3(1x,f10.5),1x,"]")') ia,zeff(2,1:3,ia)
          write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(3,1:3,ia)
          write(nfout,*)
       end do
    end if

! === KT_add === 2014/06/30
    if ( sw_check_sumrule_born_charge == OFF ) goto 100
! ============== 2014/06/30

! check zero sum rule
    ztmp(1:3,1:3) = 0.d0
    nonzero(1:3,1:3) = 0
    do ia=1,natm
       do j=1,3
          do i=1,3
             if(dabs(zeff(i,j,ia)).gt.1.d-10) nonzero(i,j)=nonzero(i,j)+1
             ztmp(i,j) = ztmp(i,j) + zeff(i,j,ia)
          end do
       end do
    end do
    do j=1,3
       do i=1,3
          if(nonzero(i,j)==0) nonzero(i,j)=1
       end do
    end do
    ztmp(1:3,1:3) = ztmp(1:3,1:3)/nonzero(1:3,1:3)
! print averaged effective charge
    if(printable) then
       write(nfout,*) ' --- Averaged effective charges ---'
       write(nfout,'("       [",3(1x,f10.5),1x,"]")') ztmp(1,1:3)
       write(nfout,'("Zave = [",3(1x,f10.5),1x,"]")') ztmp(2,1:3)
       write(nfout,'("       [",3(1x,f10.5),1x,"]")') ztmp(3,1:3)
       write(nfout,*)
    end if

! correct effective charges
    do ia=1,natm
       do j=1,3
          do i=1,3
             if(dabs(zeff(i,j,ia)).lt.1.d-10) cycle
             zeff(i,j,ia) = zeff(i,j,ia) - ztmp(i,j)
          end do
       end do
    end do

! print corrected effective charges
    if(printable) then
       write(nfout,*) ' --- Corrected effective charges ---'
       do ia=1,natm
          write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(1,1:3,ia)
          write(nfout,'("Zeff(",i3,") = [",3(1x,f10.5),1x,"]")') ia,zeff(2,1:3,ia)
          write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(3,1:3,ia)
          write(nfout,*)
       end do
    end if

100 continue

    deallocate( dphi ); deallocate( zeff_el )

! ==== KT_add === 13.1R
    if ( mype == 0 ) then
       call m_Files_open_nfeffchg()

       write(nfeffchg,*) natm
       do ia=1,natm
          write(nfeffchg,'(I6)') ia
          write(nfeffchg,'(3F18.12)') zeff(1,1:3,ia)
          write(nfeffchg,'(3F18.12)') zeff(2,1:3,ia)
          write(nfeffchg,'(3F18.12)') zeff(3,1:3,ia)
       end do
       close( nfeffchg )
    endif
! =============== 13.1R
    return

  end subroutine m_BP_calc_Effective_charge

  subroutine m_BP_read_Effective_charge(zeff,present_atom)
    use m_Ionic_System, only : natm
    use m_Files, only : nfeffchg, m_Files_open_nfeffchg
    implicit none
    real(kind=DP), intent(out) :: zeff(3,3,natm)
    logical, intent(out) :: present_atom(natm)

    integer :: num_zeff
    integer :: i,ia

    if( polar_prop == EFFECTIVE_CHARGE ) return

    present_atom(1:natm) = .false.

    call m_Files_open_nfeffchg()
    if(mype == 0) then
       rewind nfeffchg
       read(nfeffchg,*) num_zeff
       do i=1,num_zeff
          read(nfeffchg,*) ia
          read(nfeffchg,*) zeff(1,1:3,ia)
          read(nfeffchg,*) zeff(2,1:3,ia)
          read(nfeffchg,*) zeff(3,1:3,ia)
          present_atom(ia) = .true.
       end do
       close( nfeffchg )  !ASMS
    end if

    if(npes>1) then
       call mpi_bcast(zeff,3*3*natm,mpi_double_precision,0,MPI_CommGroup,ierr) ! MPI
       call mpi_bcast(present_atom,natm,mpi_logical,0,MPI_CommGroup,ierr) ! MPI
    end if

    return
  end subroutine m_BP_read_Effective_charge

  subroutine m_BP_get_Berry_phase_strain(g_id,eps_id,cphi_out,wgh_out,nkp,eps_out, &
       &                                 posstr_out,exists)
    use m_Ionic_System, only : natm
    implicit none
    integer, intent(in) :: g_id, eps_id
    complex(kind=DP), intent(out) :: cphi_out(max_num_kpoints,nspin/ndim_spinor)
    real(kind=DP), intent(out) :: wgh_out(max_num_kpoints)
    integer, intent(out) :: nkp
    real(kind=DP), intent(out) :: eps_out
    real(kind=DP), intent(out) :: posstr_out(natm,3)
    logical, intent(out) :: exists

    integer :: i,k,is, ismax

! === KT_add === 2015/03/23
    ismax = nspin /ndim_spinor
! ============== 2015/03/23

    exists = .false.
    do i=1,num_berry_phase
       if(g_index(i).eq.g_id .and. &
            & istrain(i).eq.eps_id) then
          nkp = num_kpoints(i)

          do is=1,ismax
             do k=1,nkp
                cphi_out(k,is) = cphi(k,is,i)
                wgh_out(k) = wgh(k,i)
             end do
          end do
          eps_out = epsstr(i)
          posstr_out(1:natm,1:3) = posstr(1:natm,1:3,i)
          exists = .true.
          return
       end if
    end do

  end subroutine m_BP_get_Berry_phase_strain

  subroutine m_BP_calc_diff_Berry_strain(dphi,present_strain)
    use m_Ionic_System, only : natm
    implicit none
    real(kind=DP), intent(out) :: dphi(3,6)
    logical, intent(out) :: present_strain(6)

! local variables
    integer :: ia,ig,id,k,ist,is, ismax
    integer :: nkp0,nkp1
    complex(kind=DP) :: cphi0(max_num_kpoints,nspin/ndim_spinor)
    complex(kind=DP) :: cphi1(max_num_kpoints,nspin/ndim_spinor)
    real(kind=DP) :: wgh0(max_num_kpoints)
    real(kind=DP) :: wgh1(max_num_kpoints)
    real(kind=DP) :: phi(max_num_kpoints,nspin/ndim_spinor)
    real(kind=DP) :: eps0,eps1
    real(kind=DP) :: pos0(natm,3),pos1(natm,3)
    logical :: exists
    real(kind=DP) :: dphi_ion, dphi_0, dphi_1

! === KT_add === 2015/03/23
    ismax = nspin /ndim_spinor
! ============== 2015/03/23

    present_strain(1:6) = .false.

    do ig=1,3
       ist = 0
       call m_BP_get_Berry_phase_strain(ig,ist,cphi0,wgh0,nkp0,eps0,pos0,exists)
       if(.not.exists) cycle
       STRAIN: do ist=1,6
          call m_BP_get_Berry_phase_strain(ig,ist,cphi1,wgh1,nkp1,eps1,pos1,exists)
          if(.not.exists) cycle STRAIN
          present_strain(ist) = .true.

! <<< ASMS 2023.10.31
!          if(nkp0.ne.nkp1) then
!             if(printable) then
!                write(nfout,*) 'nkp0=',nkp0
!                write(nfout,*) 'nkp1=',nkp1
!             end if
!             call phase_error_with_msg(nfout,'nkp0 and nkp1 are different in <<<m_BP_calc_diff_Berry_strain>>', &
!             __LINE__,__FILE__)
!          end if
!          ! debug
!          !   write(nfout,*) 'ig,ist =',ig,ist
!          ! end debug
! ASMS 2023.10.31 >>>

          dphi(ig,ist) = 0.d0

! <<< ASMS 2023.10.31
!          do is=1, ismax
!             do k=1,nkp0
!                if(wgh0(k).ne.wgh1(k)) then
!                   if(printable) then
!                      write(nfout,*) 'wgh0=',wgh0(k)
!                      write(nfout,*) 'wgh1=',wgh1(k)
!                   end if
!                   call phase_error_with_msg(nfout,'wgh0 and wgh1 are different in <<<m_BP_calc_diff_Berry_strain>>'&
!                                            ,__LINE__,__FILE__)
!                end if
!                phi(k,is) = dimag(log(cphi1(k,is)/cphi0(k,is)))
!
!                ! debug
!                if(printable) write(nfout,*) 'k=',k,' is=',is,' phi=',phi(k,is)
!                ! end debug
!
!                dphi(ig,ist) = dphi(ig,ist) + phi(k,is)*wgh0(k)
!             end do
!          end do

          dphi_0 = 0.0d0;    dphi_1 = 0.0d0
          do is=1, ismax
             do k=1, nkp0
                dphi_0 = dphi_0 +dimag(log(cphi0(k,is))) *wgh0(k)
             end do
             do k=1, nkp1
                dphi_1 = dphi_1 +dimag(log(cphi1(k,is))) *wgh1(k)
             end do
          end do
          dphi(ig,ist) = dphi_1 -dphi_0
! ASMS 2023.10.31 >>>

          dphi(ig,ist) = 2.d0*dphi(ig,ist)

          ! debug
          if(printable) write(nfout,*) 'ig,ist=',ig,ist,' dphi=',dphi(ig,ist)
          ! end debug

          call ionic_part(pos0,pos1,ig,dphi_ion)

          ! debug
          if(printable) then
             write(nfout,*) 'ig,ist=',ig,ist,' dphi_ion=',dphi_ion
             write(nfout,*) 'ig,ist=',ig,ist,' dphi_tot=',dphi_ion+dphi(ig,ist)
             write(nfout,*) 'ig,ist=',ig,ist,' dphi_tot(mod.)=',4.d0*atan(tan(0.25d0*(dphi_ion + dphi(ig,ist))))
          end if
          ! end debug

          dphi(ig,ist) = 4.d0*atan(tan(0.25d0*(dphi_ion + dphi(ig,ist))))/eps1

          ! debug
          if(printable) then
             write(nfout,*) 'ig,ist=',ig,ist,' eps=',eps1
             write(nfout,*) 'ig,ist=',ig,ist,' dphi/eps=',dphi(ig,ist)
          end if
          ! end debug
       end do STRAIN
    end do

  contains

    subroutine ionic_part(pos0,pos1,ig,dphi)
      use m_Crystal_Structure, only : rltv
      use m_PseudoPotential, only : ival
      use m_Ionic_System, only : ityp
      real(kind=DP), intent(in) :: pos0(natm,3) ! internal coordinates
      real(kind=DP), intent(in) :: pos1(natm,3)
      integer, intent(in) :: ig
      real(kind=DP), intent(out) :: dphi

! local variables
      integer :: ia

      dphi = 0.d0
      do ia=1,natm
         dphi = dphi + ival(ityp(ia))*(pos1(ia,ig) - pos0(ia,ig))*PAI2
      end do

    end subroutine ionic_part

  end subroutine m_BP_calc_diff_Berry_strain

  subroutine m_BP_calc_piezoelectric_const
    use m_Crystal_Structure, only : altv
    use m_Ionic_System, only : natm,ntyp,ityp,cps,napt
    use m_Crystal_Structure, only : univol
    implicit none

! local variables
    integer :: i,ia,ist
    real(kind=DP) :: dphi(3,6)
    real(kind=DP) :: fac
    logical :: present_strain(6)

    if(.not.allocated(piezo)) allocate(piezo(3,6))
    piezo = 0.d0

    if( polar_prop == PIEZOELECTRIC_CONST ) then
       dphi = 0.d0
       call m_BP_calc_diff_Berry_strain(dphi,present_strain)
       fac = 1.d0/(PAI2*univol)
       ! debug
       if(printable) then
          write(nfout,*) 'fac=',fac
          write(nfout,*) 'present_strain=',present_strain(1:6)
       end if
       ! end debug
       do ist=1,6
          if(.not.present_strain(ist)) cycle
          ! debug
          if(printable) then
             write(nfout,*) 'ist=',ist
             write(nfout,'(" dphi=",3(1x,f10.5))') dphi(1:3,ist)
          end if
          ! end debug

         do i=1,3
             ! debug
             if(printable) then
                write(nfout,'(" a1i,a2i,a3i=",3(1x,f10.5))') altv(i,1:3)
             end if
             ! end debug
             piezo(i,ist) = fac*sum(altv(i,1:3)*dphi(1:3,ist))
          end do
       end do
    end if

    if(printable) then
       write(nfout,*) '=== Piezoelectric constant (a.u.) ==='
       do ist=1,6
          write(nfout,'(i5,3(1x,f18.10))') ist,piezo(1:3,ist)
       end do
       write(nfout,*) '=== Piezoelectric constant (C/m^2) ==='
       do ist=1,6
          write(nfout,'(i5,3(1x,f18.10))') ist,piezo(1:3,ist)*UNIT_PIEZO_CONST
       end do
    end if

  end subroutine m_BP_calc_piezoelectric_const

end module m_BP_Properties

!PHASEから入力されたG点の座標、エネルギー固有値、波動関数を読み込み、保存するモジュール
!Copyright (C) 2014-2015 Ryosuke Tomita

module m_container_psicoef
#include "defines.F"
  use m_container_commons, only: energy_tag, psicoef_t, linebuf, parser_tag, readline, readline_until_tag
  implicit none

!m_container_common::readline_until_tag用のタグ
  character(*), parameter, private::&
       gvector_tag = 'GVECTOR',&
       eigen_energy_tag = 'EIGEN_ENERGY',&
       psicoef_tag = 'PSICOEF',&
       magnetic_state_tag = 'MAGNETIC_STATE',&
       spinstate_tag = 'SPINSTATE',&
       numgv_tag = 'Number_of_Gvectors',&
       eigen_energy_num_tag = 'EIGEN_ENERGY NUMBER',&
       kpoint_tag = 'KPOINT'

!エネルギー準位およびGベクトルの数、後の関数で指定される
  integer, private:: num_energy = 0, num_gvector = 0
!エネルギー準位及びGベクトルの最大数
  integer, parameter:: num_energy_max = 4095, num_gvector_max = 65535, UP = 1, DOWN = 2
  integer, parameter, private:: NUM_COEF_COLUMN = 4
!Gベクトルの成分
  integer, private, target:: gvector(3, num_gvector_max)
  type(energy_tag), public, target:: e_tag(num_energy_max,2)
!波動関数の成分psicoef(1:num_gvector, 1:num_energy, 2)、領域は後の関数で確保される、psicoef(:,:,1)はアップ軌道、2はダウン軌道
  COMPLEX_T, allocatable, private, target:: psicoef(:,:,:)
  integer, public:: nspin = 1, af = 0, ikpoint = 1, ispin = 1, ndim_spinor = 1
contains
!波動関数のデータ読み込み
  logical function read_psicoef(nfin)&
       result(isread)
    integer, intent(in):: nfin
    integer:: ie, ig, irow, icol
    DOUBLE_T:: c(2,NUM_COEF_COLUMN)
    DOUBLE_T:: nrm
    isread = .false.
!new_psicoefが実行されていないのでFALSEを返す
    if(.not.allocated(psicoef)) return
!読み込み開始処理、波動関数タグまで読み飛ばし、タグがなければ異常終了
    if(readline_until_tag(nfin, psicoef_tag) < 1) return
!読み込み終了処理、読み込み終了タグもしくはEOFまで読み込む、読み込みエラーの時は異常終了

    ie = 1
    ig = 0
    do while(.true.)
       READSELECT(nfin)
       if(index(linebuf, eigen_energy_num_tag) > 0) then
          read(linebuf, *) ie
          ig = 0
          cycle
       end if
       if(index(linebuf, parser_tag) > 0) exit
       if(ie > num_energy .or. ig >= num_gvector) cycle
       read(linebuf, *) (c(1:2, icol), icol = 1,NUM_COEF_COLUMN)
       do icol = 1, NUM_COEF_COLUMN
          psicoef(ig + icol, ie, ispin) = CMPLX_(c(1, icol), c(2, icol))
       enddo
       ig = ig + NUM_COEF_COLUMN
    end do
    isread = .true.
!規格化
    do ie = 1, num_energy
       nrm = 0d0
       do ig = 1, num_gvector
          nrm = nrm + real(conjg(psicoef(ig, ie, ispin))* psicoef(ig, ie, ispin))
       end do
       nrm = 1d0/sqrt(nrm)
       do ig = 1, num_gvector
          psicoef(ig, ie, ispin) = psicoef(ig, ie, ispin) * nrm
       end do
    end do
  end function read_psicoef

!エネルギー準位および数値を読み込み、準位数num_energyを決定する
  logical function read_energy(nfin) result(isread)
    integer, intent(in):: nfin
    integer:: ie
    DOUBLE_T:: ene

    isread = .false.
!読み込み開始処理、psicoefと同様
    if(readline_until_tag(nfin, eigen_energy_tag) < 1) return
!読み込み終了処理、psicoefと同様
    do while(.true.)
       READSELECT(nfin)
       if(index(linebuf, parser_tag) > 0) exit
       read(linebuf, *) ie, ene
       if(ie > num_energy_max) cycle
       e_tag(ie,ispin)%ie = ie
       e_tag(ie,ispin)%hartree = ene
!最大数更新、num_energyの値を更新
       num_energy = max(ie, num_energy)
    end do

    isread = .true.
  end function read_energy

!磁性状態(スピンの数とantiferroかどうか)を読み込む
  logical function readmagstate_psicoef(nfin) result(is)
    integer, intent(in):: nfin
    is = .false.
!magnetic_state_tagまで読み飛ばし
    if(readline_until_tag(nfin, magnetic_state_tag) < 1 .or. &
         readline(nfin) < 1) return
!-----------------------------Modified by T.A.Ariasoca-----------------------------
    read(linebuf, *) nspin, af, ndim_spinor
!---------------------------------------------------------------------------
    is = .true.
  end function readmagstate_psicoef

!k点のインデックスとスピン状態を読み込む
  logical function readstate_psicoef(nfin) result(is)
    integer :: i
    integer, intent(in):: nfin
    DOUBLE_T:: dummy(3)
    character(len=4):: spinstate
    is = .false.
!kpoint_tagまで読み飛ばし
    if(readline_until_tag(nfin, kpoint_tag) < 1 .or. &
         readline(nfin) < 1) return
!-----------------------------Modified by T.A.Ariasoca-----------------------------
    if(nspin == 2 .and. ndim_spinor == 2) then
       read(linebuf, *) ikpoint
       if(mod(ikpoint,2)==1) then
          ispin = 1
          ikpoint = ikpoint/2 + 1
       else
          ispin = 2
          ikpoint = ikpoint/2
       end if
!----------------------------------------------------------------------------------
    else if(nspin == 2) then
       read(linebuf, *) ikpoint, dummy(1:3), spinstate
       if(spinstate(1:2) == 'UP') then !アップスピンのとき
          ispin = 1
          ikpoint = ikpoint/2 + 1
       else!ダウンスピンのとき
          ispin = 2
          ikpoint = ikpoint/2
       end if
    else!非磁性のとき
       read(linebuf, *) ikpoint
    end if
    is = .true.
  end function readstate_psicoef

!Gベクトルの成分の読み込み
  logical function read_gvector(nfin)
    integer, intent(in):: nfin
    integer:: a, gbuf(3)

    read_gvector = .false.
    if(readline_until_tag(nfin, numgv_tag) < 1 .or. &
         readline(nfin) < 1) return
    read(linebuf, *) num_gvector

!読み込み開始処理、psicoefと同様
    if(readline_until_tag(nfin, gvector_tag) < 1) return
!読み込み終了処理、psicoefと同様
    do while(.true.)
       READSELECT(nfin)
       if(index(linebuf, parser_tag) > 0) exit
       read(linebuf, *) a, gbuf
!領域外処理, psicoefと同様
       if(a > num_gvector) cycle
       gvector(:, a) = gbuf
    end do
    read_gvector = .true.
  end function read_gvector

!Gベクトル(基本逆格子の成分)をブラベ逆格子の成分に変換
  subroutine set_gvector_to_braveis(trp2b)
    DOUBLE_T, intent(in):: trp2b(3,3)
    integer:: ig
    do ig = 1, num_gvector
       gvector(1:3,ig) = nint(matmul(dble(gvector(1:3,ig)), trp2b))
    enddo
  end subroutine set_gvector_to_braveis

!得られたデータを構造体にコピーし、それを返す
  type(psicoef_t) function get_psicoef() result(p)
    p%num_energy = num_energy
    p%gv%num = num_gvector
    p%gv%comp => gvector
    p%nspin = nspin
    p%e_tag => e_tag
    p%comp => psicoef
!--------------------Modified by T.A.Ariasoca---------------------------------    
  ! p%nspinor = ndim_spinor
!-----------------------------------------------------------------------------
  end function get_psicoef

!k点の情報をコピーする(スピンの数およびk点の格子変換行列)
  subroutine new_psicoef(isdouble)
    logical, intent(in):: isdouble
    nspin = 1
!--------------------Modified by T.A.Ariasoca-------------------------------------
    !if(isnoncol) nspin = 2
!--------------------------------------------------------------------------------
    if(isdouble) nspin = 2
  end subroutine new_psicoef

!read_energy, read_gvectorで設定した変数num_energy, num_gvectorをもってpsicoefの領域を確保
  subroutine allocate_psicoef
    if(.not.allocated(psicoef))&
         allocate(psicoef(num_gvector, num_energy, nspin))
  end subroutine allocate_psicoef

!psicoefの領域を開放し、データをリセットする
  subroutine delete_psicoef
    num_energy = 0
!    num_gvector = 0
    if(allocated(psicoef)) deallocate(psicoef)
  end subroutine delete_psicoef

!設定したデータの出力
  subroutine print_psicoef(nfout)
    integer, intent(in):: nfout
    integer:: ie, ig, is

    write(nfout, *) num_energy, num_gvector, nspin

    do ig = 1, num_gvector
       write(nfout, *) ig, gvector(:, ig)
    enddo
    write(nfout, *)
    do is = 1, nspin
       write(nfout, *) 'ISPIN:', is
       do ie = 1, num_energy
          write(nfout, *) 'ENERGY:', e_tag(ie,is)%ie, e_tag(ie,is)%hartree
          do ig = 1, num_gvector
             write(nfout, *) ig, psicoef(ig, e_tag(ie,is)%ie, 1:nspin)
          enddo
          write(nfout, *)
       enddo
    end do
  end subroutine print_psicoef

end module m_container_psicoef

!================================================
!  Software name : STM
!  Subroutine(s) : InputData_Analysis
!  Author(s)     : Takahiro Yamasaki (June 7, 2004)
!
!  FURTHER MODIFICATION: Junichiro Koga (June 24, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

subroutine InputData_Analysis
! $Id: InputData_Analysis.F90,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
  use m_Files, only                : nfinp,nfcntn_bin
  use m_Control_Parameters, only   : m_CtrlP_rd_energy_range &
       &                           , m_CtrlP_rd_z_range &
       &	                   , m_CtrlP_rd_mixing_ratio &
       &                           , m_CtrlP_rd_error_limit &
       &                           , m_CtrlP_rd_nc_z_axis
  use m_Charge_File,          only : m_CF_rd_Header_For_Cube
  use m_ArraySize_Parameters, only : m_ArraySize_Parameters_rd
  use m_Electronic_Structure, only : m_ES_rd_EigenValues_etc
  use m_PlaneWaveBasisSet, only    : m_pwBS_rd_data
  use m_FFT, only                  : m_FFT_rd_fft_box_size &
	&                          , m_FFT_rd_fine_fft_box_size
  use m_Kpoints, only              : m_Kp_rd_kv3, m_Kp_alloc, m_Kp_rd_kpoints
  use m_Crystal_Structure, only    : m_CS_rd_neg_and_zl

  implicit none

  call m_Kp_rd_kv3(nfinp)
  call m_Kp_alloc()
  call m_Kp_rd_kpoints(nfinp)
  call m_CS_rd_neg_and_zl(nfinp)
  call m_CtrlP_rd_energy_range(nfinp)
  call m_FFT_rd_fine_fft_box_size(nfinp)
  call m_CtrlP_rd_z_range(nfinp)
  call m_CtrlP_rd_nc_z_axis(nfinp)
  call m_CtrlP_rd_mixing_ratio(nfinp)
  call m_CtrlP_rd_error_limit(nfinp)
  call m_ArraySize_Parameters_rd(nfcntn_bin)
  call m_ES_rd_EigenValues_etc(nfcntn_bin)
  call m_pwBS_rd_data(nfcntn_bin)
  call m_FFT_rd_fft_box_size(nfcntn_bin)
  call m_CF_rd_Header_For_Cube(nfcntn_bin)

end subroutine InputData_Analysis

!******************************************************************************
!
! GaussLeg - Calculates the Gauss-Legendre integration weights and points
!            on the interval (-1, 1)
!
! n   - Number of G-L points and weights to calculate
! X   - G-L Points
! W   - G-L weights
!
! NOTE: This routine is based on the routine from Numerical Recipes in Fortran
!
!******************************************************************************

SUBROUTINE GaussLeg(x1,x2,n,x,w)
  use m_Const_Parameters,     only : DP,PAI
  Real(DP), Intent(IN) :: x1,x2
  Integer, Intent(IN) :: n
  Real(DP),    Intent(OUT) :: X(n)
  Real(DP),    Intent(OUT) :: W(n)

  Real(DP), PARAMETER :: EPS=3.d-14  !** EPS is the relative precision.

  Real(DP) ::  p1,p2,p3,pp,xl,xm,z,z1,pi
  Integer :: i,j,m

!  pi=acos(-1.d0)
  pi=PAI
                     !** High precision is a good idea for this routine.
  m=(n+1)/2          !** The roots are symmetric in the interval, so we
  xl=0.5*(x2-x1)     !** only have to nd half of them. 
  xm=0.5d0*(x2+x1)
  
  do i=1,m           !** Loop over the desired roots.
     z=cos(pi*(i-.25d0)/(n+.5d0))
     !** Starting with the above approximation to the ith root,
     !** we enter the main loop of refinement by Newton's method.
     z1 = z+10*EPS               !** Cheat to enter loop

     Do While (ABS(z-z1) > EPS)
        p1=1.0d0
        p2=0.0d0

        do j=1,n        !** Loop up the recurrence relation to get the Legendre
           p3=p2        !** polynomial evaluated at z. 
           p2=p1
           p1=((2.0*j-1.d0)*z*p2-(j-1.0)*p3)/j
        end do

        !** p1 is now the desired Legendre polynomial. We next compute pp,
        !** its derivative, by a standard relation involving also p2, 
        !** the polynomial of one lower order.
        pp=n*(z*p1-p2)/(z*z-1.d0)
        z1=z
        z=z1-p1/pp  !**Newton's method.
     End Do

     x(i)=xm-xl*z                   !** Scale the root to the desired interval,
     x(n+1-i)=xm+xl*z               !** and put in its symmetric counterpart.
     w(i)=2.0*xl/((1.0-z*z)*pp*pp) !** Compute the weight
     w(n+1-i)=w(i)                  !**and its symmetric counterpart.
  end do
  return
End Subroutine

!=======================================================================
!
!  PROGRAM  PHASE/0 2023.01
!
!  MODULE: m_ES_occup
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki,  April/27/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! *************************************************************
!
! =========== Contributions ===================================
!
! Through the courtesy of contributors, the following functions are added.
!
! Company:  ASMS Co.,Ltd.
! Functions:  [Identifier: 13.0E]
!                    Fermi-Dirac smearing method is added
!
! =============================================================
!
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif

#define USE_MIDDLE_EIGENVAL

module m_ES_occup
!     (m_ESoc)
! $Id: m_ES_occup.F90 633 2020-12-01 05:11:03Z jkoga $
  use m_Electronic_Structure, only : efermi, efermi_spin, occup_l, eko_l, totch, neordr, eko_ek &
       &                            , vbm, metalic_system, check_if_metalic_flag &
       &                            , band_entropy
  use m_Kpoints,              only : kv3, kv3_ek, qwgt, qwgt_ek, vkxyz &
       &                            ,np0,np2,ip20,iwt,ip2cub,nxyz_tetra
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,   only : ipri, iprioccup, width, nspin, neg, af, ekmode, idimtetra &
       &                            ,partial_charge_Emin, partial_charge_Emax, partial_charge_deltaE &
       &                            ,fixed_charge_k_parallel, icond &
       &                            ,m_CtrlP_way_of_smearing, printable, width_tetra, order_mp, esearch_factor_mp,esearch
!!$       &                            ,deltaE_dos_Gaussdistrib, variance_dos_Gaussdistrib
  use m_Crystal_Structure,    only : sw_fix_total_spin, total_spin, imag
  use m_Const_Parameters,     only : DP, DELTA_FermiSearchRange, ON, OFF, NO, YES, HARTREE, DELTA10 &
       &                            ,PARABOLIC, TETRAHEDRON, COLD, FERRO, FIXED_CHARGE, ONE_BY_ONE, BUCS
  use m_Parallelization,      only : MPI_CommGroup,npes,map_ek,mype,map_e,map_k,myrank_e,myrank_k &
       &                            ,ierr,np_e,map_z,ista_e,ista_k,iend_k, nrank_k, nrank_e &
       &                            ,mp_e, nel_e, nie_e, nis_e &
       &                            ,mpi_spin_group, nrank_s, myrank_spin, ista_spin, iend_spin

! ======================================= added by K. Tagami ============= 11.0
   use m_Control_Parameters,   only : noncol, ndim_spinor, ndim_magmom
! ========================================================================= 11.0

  use m_Const_Parameters,     only : Fermi_Dirac, MP, LOWEST_AT_EACH_KPT
  use mpi

  implicit none
!   1. m_ESoc_fermi_parabolic       <-(ChargeDensity_Construction) ->(3)
!      - get_occup_l_and_tot, - get_entropic_term, - get_entropy, - find_eko_minimum_and_maximum
!   2. m_ESoc_fermi_tetrahedron     <-(ChargeDensity_Construction) ->(3)
!   3. check_totch           <-(1),(2)
!   4. m_ESoc_check_num_bands
!   5. m_ESoc_fermi_parabolic_ek
!      - get_tot
!   6. m_ESoc_fermi_tetra_ek
!   7. m_ESoc_check_if_metalic
!   8. check_if_metalic
!   9. m_ESoc_fermi_ColdSmearing
!      - get_occup_l_and_tot, - coldsmearing, - get_entropic_term, - get_entropy
!  10. m_ESoc_set_nEwindows_pc
!  11. find_emin_emax
!  12. m_ESoc_keep_occup
!  13. m_ESoc_retrieve_occup
!  14. m_ESoc_substitute_occup
!  15. m_ESoc_free_nEwindows
!  16. m_ESoc_if_elec_state
!
!    The subroutine "m_ESoc_fermi_parabolic" was originally coded by
!   Noriaki Hamada, 1984.05.17
!
  integer :: nEwindows_pc
  real(kind=DP), private, allocatable, dimension(:,:) :: Ewindows_partial_charge  ! d(nEwindows_pc,2)
  real(kind=DP), private, allocatable, dimension(:,:) :: occup_tmp  ! d(np_e, ista_k:iend_k)
  integer, private, allocatable, dimension(:) ::         if_elec_state ! d(nEwindows_pc)
  real(kind=DP), private ::                              e_origin, total_spin0
  logical, private, save :: efermi_is_defined = .false.

! parameters for manual occupation
  character(len("sw_manual_occupation")),private,parameter :: tag_sw_manual_occupation="sw_manual_occupation"
  integer :: sw_manual_occupation = OFF

  real(kind=DP),allocatable,dimension(:,:) :: occ_ext
  integer,allocatable,dimension(:) :: band_index
  character(len("occupation")),private,parameter :: tag_occupation = "occupation"
  character(len("band_index")),private,parameter :: tag_band_index = "band_index"
  character(len("occ")),private,parameter :: tag_occ = "occ"
  character(len("occ_up")),private,parameter :: tag_occ_up = "occ_up"
  character(len("occ_down")),private,parameter :: tag_occ_down = "occ_down"

  integer, private,parameter :: PRINTOUTLEVEL_TOTCH_SPIN = 2

! -------------------------------- added by T. Hamada --------------------------
  logical                    :: system_is_already_determined = .false.
  logical                    :: system_is_not_metallic = .false.
! ------------------------------------------------------------------------------

!  include 'mpif.h'
contains
! --> T. Yamasaki, 06 Aug. 2009
  real(kind=DP) function m_ESoc_efermi_diff()
! ============================================= modified by K. Tagami ========= 11.0
!!    if(nspin == 1) then
    if ( nspin == 1 .or. noncol ) then
! ============================================================================= 11.0
       m_ESoc_efermi_diff = 0.d0
       return
    else
       m_ESoc_efermi_diff = efermi_spin(1) - efermi_spin(2)
    end if
  end function m_ESoc_efermi_diff

  real(kind=DP) function m_ESoc_new_total_spin()
    m_ESoc_new_total_spin = (total_spin + total_spin0)*0.50
  end function m_ESoc_new_total_spin

  real(kind=DP) function m_ESoc_total_spin0()
    m_ESoc_total_spin0 =  total_spin0
  end function m_ESoc_total_spin0

  subroutine m_ESoc_fermi_parabolic(nfout)
!
!  An if-block of "if(imag == FERRO .and. sw_fix_total_spin == YES .and. nspin == 2) then",
! which defines efermi_spin and occup_l with fixing total spin, is coded.
!                        by T. Yamasaki   April/10/2007
!
    integer, intent(in) :: nfout

    integer             :: jcount, ik, ie, is
    Real(kind=DP)       :: emin, emax, e1, e2, tot, totch_spin(2), totch_spin0(2)
    real(kind=DP), parameter :: DELTA_TOTCH = 1.d-10
    integer,       parameter :: MAXITR = 100000
    real(kind=DP),allocatable, dimension(:,:) :: temp_mpi, eko_mpi, occup_mpi  ! MPI

    integer :: id_sname = -1, id_sname2 = -1

! ================================== added by K. Tagami ============= 11.0
    integer :: iksnl
! ==================================================================== 11.0

    integer :: iupdown

    call tstatc0_begin('barrier(m_Eoc_fermi_parabolic) ',id_sname2)
    if(npes > 1) call mpi_barrier(MPI_CommGroup,ierr)
    call tstatc0_end(id_sname2)

    call tstatc0_begin('m_ESoc_fermi_parabolic ', id_sname)

    call check_totch(nfout)           ! -(m_ES_occup) totch will be checked

! =================================== modified by K. Tagami ============ 11.0
!    allocate(eko_mpi  (neg,kv3)); eko_mpi = 0.d0
!    allocate(occup_mpi(neg,kv3)); occup_mpi = 0.d0
!
    if ( noncol ) then
      allocate(eko_mpi  (neg,kv3/ndim_spinor)); eko_mpi = 0.d0
      allocate(occup_mpi(neg,kv3)); occup_mpi = 0.d0
    else
      allocate(eko_mpi  (neg,kv3)); eko_mpi = 0.d0
      allocate(occup_mpi(neg,kv3)); occup_mpi = 0.d0
    endif
! ======================================================================= 11.0

! ==================================== added by K. Tagami =============== 11.0
!                               ( just in case )
! ---
    if ( noncol ) then
       do ik = 1, kv3, ndim_spinor
          Do is=2, ndim_spinor
            if ( map_k(ik+is-1) /= myrank_k ) cycle
             do ie = 1, neg
                if(map_e(ie) /= myrank_e) cycle
!
                eko_l(map_z(ie),ik +is -1 ) = 1.0D8
             End do
          End do
       end do
    endif
! ======================================================================= 11.0

! =========================================== modified by K. Tagami ======= 11.0
!    !  MPI Gather eko_l
!    if(npes >= 2) then                                 ! MPI
!       allocate(temp_mpi (neg,kv3)); temp_mpi = 0.d0      ! MPI
!       do ik = 1, kv3                                     ! MPI
!          if(map_k(ik) /= myrank_k) cycle                 ! MPI
!          do ie = 1, neg                                  ! MPI
!             if(map_e(ie) /= myrank_e) cycle              ! MPI
!             temp_mpi(ie,ik) = eko_l(map_z(ie),ik)        ! MPI
!          end do                                          ! MPI
!       end do                                             ! MPI
!       call mpi_allreduce(temp_mpi,eko_mpi,neg*kv3,mpi_double_precision &  ! MPI
!            &            ,mpi_sum,MPI_CommGroup,ierr)                     ! MPI
!       deallocate(temp_mpi )
!    else                                               ! MPI
!       eko_mpi = eko_l                                 ! MPI
!    end if                                             ! MPI
! --
    if ( noncol ) then
      if ( npes >= 2) then
         allocate(temp_mpi(neg,kv3/ndim_spinor)); temp_mpi = 0.d0
         do ik = 1, kv3, ndim_spinor
            if ( map_k(ik) /= myrank_k ) cycle
            iksnl = ( ik-1 )/ndim_spinor +1

            do ie = 1, neg
              if ( map_e(ie) /= myrank_e ) cycle
              temp_mpi(ie,iksnl) = eko_l(map_z(ie),ik)
            end do
         end do
!         call mpi_allreduce( temp_mpi, eko_mpi, neg*kv3/ndim_spinor, &
!                       	&    mpi_double_precision, mpi_sum,MPI_CommGroup, ierr )
         call mpi_allreduce( temp_mpi, eko_mpi, neg*kv3/ndim_spinor, &
                       	&    mpi_double_precision, mpi_sum,mpi_spin_group, ierr )
         deallocate( temp_mpi )
      else
         Do ik=1, kv3, ndim_spinor
            iksnl = ( ik-1 )/ndim_spinor +1
            eko_mpi(:,iksnl) = eko_l(:,ik)
         End do
      end if
    else
      if ( npes >= 2 ) then                                 ! MPI
         allocate(temp_mpi (neg,kv3)); temp_mpi = 0.d0      ! MPI
         do is = ista_spin, iend_spin
         do ik = is, kv3-nspin+is, nspin
        ! do ik = 1, kv3                                     ! MPI
            if(map_k(ik) /= myrank_k) cycle                 ! MPI
            do ie = 1, neg                                  ! MPI
              if(map_e(ie) /= myrank_e) cycle              ! MPI
               temp_mpi(ie,ik) = eko_l(map_z(ie),ik)        ! MPI
           end do                                          ! MPI
         end do                                             ! MPI
         enddo
         call mpi_allreduce(temp_mpi,eko_mpi,neg*kv3,mpi_double_precision &  ! MPI
            &            ,mpi_sum,MPI_CommGroup,ierr)                     ! MPI
         deallocate(temp_mpi )
      else                                               ! MPI
         eko_mpi = eko_l                                 ! MPI
      end if                                             ! MPI
    end if
! ======================================================================== 11.0

    emin = minval(eko_mpi)
    emax = maxval(eko_mpi)

    efermi = emax
    e1 = emin - dabs(DELTA_FermiSearchRange)
    e2 = emax + dabs(DELTA_FermiSearchRange)

    jcount = 1
    occupied_ch_equals_totch : do

! ======================================== modified by K. Tagami =========== 11.0
!!       call get_occup_l_and_tot(1,1,efermi,.true.)      ! -(contained here) ->(occup_l,tot)
!          ~~~~~~~~~~~~~~~~~~~~
! --
       if ( noncol ) then
          call get_occup_l_and_tot_noncl_parb( efermi, .true. )
       else
          call get_occup_l_and_tot( 1, 1, efermi, .true. )
       endif

! ======================================================================== 11.0

!          ~~~~~~~~~~~~~~~~~~~~
       if(jcount == 1 .and. tot < totch) &
            call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
       if(dabs(tot - totch) < DELTA_TOTCH) exit occupied_ch_equals_totch
       if( tot < totch) then
          e1 = efermi; efermi = efermi + (e2-efermi)/2
       else
          e2 = efermi; efermi = efermi + (e1-efermi)/2
       end if
       jcount = jcount + 1
       if(jcount > MAXITR) then
          call wd_fermi_error2 &   !-(b_Fermi)
               & (nfout,e1,e2,efermi,emin,emax,tot,totch,neg,MAXITR)
       end if
    end do occupied_ch_equals_totch
    if(iprioccup >= 2) &
         &write(nfout,'( "== Parabolic Broadening Method ==")')
    if(iprioccup >= 2) &
         &write(nfout,'( " efermi = ", f10.4, " tot = ", f10.4)') efermi, tot

! =================== modified by K. Tagami =================== 11.0
!    call get_entropic_term(band_entropy)

    if ( noncol ) then
       call get_entropic_term_noncl(band_entropy)
    else
       call get_entropic_term(band_entropy)
    endif
! ============================================================= 11.0

    if(iprioccup >= 2) &
         &write(nfout,'( " band_entropy = ", f20.14)') band_entropy

    if(imag == FERRO .and. sw_fix_total_spin == YES .and. nspin == 2) then
       if(total_spin > totch) then
          write(nfout,'( " !WARNING total_spin should be smaller than totch <<m_ESoc_fermi_parabolic>>")')

          totch_spin(1) = totch
          totch_spin(2) = totch
       else
          totch_spin(1) = (totch + total_spin)*1.0d0
          totch_spin(2) = (totch - total_spin)*1.0d0
       end if

       do is = 1, nspin
          emin = minval(eko_mpi)
          emax = maxval(eko_mpi)

          efermi_spin(is) = emax
          e1 = emin - dabs(DELTA_FermiSearchRange)
          e2 = emax + dabs(DELTA_FermiSearchRange)

          jcount = 1
          occupied_ch_equals_totch2 : do

             call get_occup_l_and_tot(nspin,is,efermi_spin(is),.true.)     ! -(contained here) ->(occup_l,tot)
             !    ~~~~~~~~~~~~~~~~~~~
             if(jcount == 1 .and. tot < totch_spin(is)) &
                  call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
             if(dabs(tot - totch_spin(is)) < DELTA_TOTCH) exit occupied_ch_equals_totch2
             if( tot < totch_spin(is)) then
                e1 = efermi_spin(is); efermi_spin(is) = (efermi_spin(is) + e2)/2
             else
                e2 = efermi_spin(is); efermi_spin(is) = (efermi_spin(is) + e1)/2
             end if
             jcount = jcount + 1
             if(jcount > MAXITR) then
                call wd_fermi_error2 &   !-(b_Fermi)
                     & (nfout,e1,e2,efermi_spin(is),emin,emax,tot,totch_spin(is),neg,MAXITR)
             end if
          end do occupied_ch_equals_totch2
          if(iprioccup >= 2) &
               &write(nfout,'( "== Parabolic Broadening Method ==")')
          if(iprioccup >= 2) &
               &write(nfout,'( " efermi_spin(",i2," ) = ", f10.4, ", tot/2 = ", f10.4)') &
               & is,efermi_spin(is), tot/2.0
       end do
       call get_total_spin0 ! -> totch_spin0
!!$       if(iprioccup >= 1) then
!!$          write(nfout,'(" == efermi_spin(1:2) = ",2f10.4, " total_spin  = ",f12.6,"totch_spin(1:2)  = ",2f12.6)') &
!!$               & efermi_spin(1:2),total_spin, totch_spin(1:2)*0.5d0
!!$          write(nfout,'(" == efermi = ",f10.4, 20x," total_spin0 = ",f12.6, " totch_spin0(1:2) = ",2f12.6)') &
!!$               & efermi, total_spin0, totch_spin0(1:2)
!!$       end if
       efermi = (efermi_spin(1)+efermi_spin(2))*0.5d0
       if(iprioccup>=1)then
          write(nfout,'(a,f10.4)') ' == new efermi = ',efermi
       endif
    else if(imag == FERRO .and. sw_fix_total_spin == NO .and. nspin == 2) then
       call get_total_spin0 ! ->totch_spin0
!!$       if(iprioccup >= 1) then
!!$          write(nfout,'(" == efermi = ",f10.4, 20x," total_spin0 = ",f12.6, " totch_spin0(1:2) = ",2f12.6)') &
!!$               & efermi, total_spin0, totch_spin0(1:2)
!!$       end if
! <--
    end if

    !do ik = ista_k, iend_k                              ! MPI
    do is = ista_spin, iend_spin
    do ik = is, kv3-nspin+is, nspin
       if(map_k(ik) /= myrank_k) cycle                 ! MPI
       do ie = 1, neg                                   ! MPI
          if(map_e(ie) == myrank_e) then                ! MPI
             occup_l(map_z(ie),ik) = occup_mpi(ie,ik)   ! MPI
             if(sw_manual_occupation==ON)then
               if(band_index(ie)>0)then
                  iupdown = 1
                  if(nspin>1.and.mod(ik,2)==0) iupdown = 2
                  occup_l(map_z(ie),ik) = occ_ext(band_index(ie),iupdown)
               endif
             endif
          end if                                        ! MPI
       end do                                           ! MPI
    end do                                              ! MPI
    enddo

    if(imag == FERRO .and. nspin == 2) then
       ie = 2
       if(sw_fix_total_spin == YES) call check_occupation(nfout,ie,totch_spin)
    else if(imag /= FERRO) then
       ie = 1
       totch_spin0(1) = totch
    end if

! ============================= modified by K. Tagami ============== 11.0
!    call check_occupation(nfout,ie,totch_spin0)
!
    if ( noncol ) then
       call check_occupation_noncl(nfout,totch_spin0)
    else
       call check_occupation(nfout,ie,totch_spin0)
    endif
! =================================================================== 11.0

    if ( af == 1 ) then
       Do ik=ista_k, iend_k, nspin
          occup_l(:,ik+1) = occup_l(:,ik)
       End Do
    endif

    deallocate(eko_mpi  )
    deallocate(occup_mpi)

    call tstatc0_end(id_sname)
  contains
    subroutine get_total_spin0
      do is = 1, nspin
         call get_occup_l_and_tot(nspin,is,efermi,.false.)
         totch_spin0(is) = tot
      end do
!      total_spin0 = totch_spin0(1) - totch_spin0(2)
      total_spin0 = (totch_spin0(1) - totch_spin0(2))*0.5d0
      if(iprioccup >= PRINTOUTLEVEL_TOTCH_SPIN) then
         if(sw_fix_total_spin == YES) then
            call wd_efermi_and_total_spin0_Plus(nfout,total_spin0,totch_spin0,totch_spin)
!!$            write(nfout,'(" == efermi_spin(1:2) = ",2f10.4, " total_spin  = ",f12.6 &
!!$                 & ," totch_spin(1:2)  = ",2f12.6)') &
!!$                 & efermi_spin(1:2),total_spin, totch_spin(1:2)*0.5d0
!!$            write(nfout,'(" == efermi = ",f10.4, 20x," total_spin0 = ",f12.6, " totch_spin0(1:2) = ",2f12.6)') &
!!$                 & efermi, total_spin0, totch_spin0(1:2)*0.5d0
!!$         end if
         else
            call wd_efermi_and_total_spin0(nfout,total_spin0,totch_spin0)
!!$            write(nfout,'(" == efermi = ",f10.4," total_spin0 = ",f12.6, "  totch_spin0(1:2) = ",2f12.6)') &
!!$                 & efermi, total_spin0, totch_spin0(1:2)*0.5d0
!!$         end if
         end if
      end if
    end subroutine get_total_spin0

    subroutine get_occup_l_and_tot(nspin,is,efermi,update_occ)
      integer, intent(in) :: nspin, is
      real(kind=DP), intent(in) :: efermi
      logical,intent(in) :: update_occ
      integer       :: k, i,iupdown
      real(kind=DP) :: wspin = 1.d0, e, dos, weight,tmp
      tot = 0.d0

      do k = is, kv3, max(nspin,af+1)
         do i = 1, neg
            e = eko_mpi(i,k)
            call width2(e,efermi,width,dos,weight)  ! -(b_Fermi)
            if(sw_manual_occupation==ON.and..not.update_occ)then
               if(band_index(i)>0)then
                  iupdown = 1
                  if(nspin>1.and.mod(k,2)==0) iupdown = 2
                  weight = occ_ext(band_index(i),iupdown)
               endif
            endif
! ====================================================================== 12.1

            tmp = weight*wspin*kv3*qwgt(k)
            if(update_occ) occup_mpi(i,k) = tmp
            !tot = tot + 2*occup_mpi(i,k)
            tot = tot + 2*tmp
         end do
      end do
      if(af == 1) then
         tot = tot/kv3 * (af+1)
      else
         tot = tot/(kv3/nspin)
      end if
      if(iprioccup >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12)') efermi,tot
    end subroutine get_occup_l_and_tot

! ================================ added by K. Tagami ========= 11.0
    subroutine get_occup_l_and_tot_noncl_parb( efermi, update_occ )
      real(kind=DP), intent(in) :: efermi
      logical,intent(in) :: update_occ

      integer       :: k, i, iksnl
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, wktmp, ctmp

      tot = 0.d0;  occup_mpi = 0.0d0
      wktmp = kv3 / ndim_spinor

      do k = 1, kv3, ndim_spinor
         iksnl = ( k -1 )/ndim_spinor + 1

         do i = 1, neg
            e = eko_mpi(i,iksnl)
            call width2(e,efermi,width,dos,weight)  ! -(b_Fermi)
            ctmp = weight *wspin *wktmp *qwgt(k)
            if ( update_occ ) occup_mpi(i,k) = ctmp
            tot = tot + ctmp
         end do
      end do
      tot = tot / wktmp

      if(ipri >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12)') efermi,tot
    end subroutine get_occup_l_and_tot_noncl_parb
! ============================================================== 11.0

    subroutine get_entropic_term(s)
      real(kind=DP), intent(out) :: s

      integer       :: k, i
      real(kind=DP) :: e, entropy
      s = 0.d0
      do k = 1, kv3, af+1
         do i = 1, neg
            e = eko_mpi(i,k)
            call get_entropy(e,efermi,width,entropy)
            s = s + 2.d0*entropy*qwgt(k)
         end do
      end do
      s = s * (af+1)
    end subroutine get_entropic_term

! ============================ added by K. Tagami =============== 11.0
    subroutine get_entropic_term_noncl(s)
      real(kind=DP), intent(out) :: s

      integer       :: k, i, iksnl
      real(kind=DP) :: e, entropy
      s = 0.d0
      do k = 1, kv3, ndim_spinor
         iksnl = ( k -1 )/ndim_spinor + 1
         do i = 1, neg
            e = eko_mpi(i,iksnl)
            call get_entropy(e,efermi,width,entropy)
            s = s + 1.d0*entropy*qwgt(k)
         end do
      end do
    end subroutine get_entropic_term_noncl
! ================================================================== 11.0

    subroutine get_entropy(e,efermi,width,entropy)
      real(kind=DP), intent(in) :: e,efermi,width
      real(kind=DP), intent(out) :: entropy

      real(kind=DP) :: xi,xj,xx
      real(kind=DP), parameter :: d16 = 1.d0/16.d0
      real(kind=DP), parameter :: d6 = 1.d0/6.d0
      real(kind=DP), parameter :: sd24 = 7.d0/24.d0

      xi = (efermi-e)/width

      if(xi < -2.d0) then
         entropy = 0.d0
      else if(xi < -1.d0) then
         xj = xi+2.d0
         xx = xj*xj
         entropy = -xx**2*d16+xx*xj*d6
      else if(xi < 1.d0) then
         xx = 0.25d0*xi*xi
         entropy = -xx*(1.d0-xx) + sd24
      else if(xi < 2.d0) then
         xj = xi-2.d0
         xx = xj*xj
         entropy = -xx**2*d16-xx*xj*d6
      else
         entropy = 0.d0
      end if

    end subroutine get_entropy

  end subroutine m_ESoc_fermi_parabolic

  subroutine m_ESoc_fermi_tetrahedron(nfout)
! tetra hedron method (Dr.Hamada-san's code)
!                        by Tsuyoshi Miyazaki '94.8.9
!
!  An if-block of "if(imag == FERRO .and. sw_fix_total_spin == YES .and. nspin == 2) then",
! which defines efermi_spin and occup_l with fixing total spin, is coded.
!                        by T. Yamasaki   April/10/2007
!
    integer, intent(in) :: nfout
#ifndef NO_TETRAHEDRON
    !!$integer, parameter       :: idim = 3
    integer        :: neig,nengy,ispin,ip2,ik,ieig,ikee,nxx,nyy,nzz, ip, ip_mpi
    real(kind=DP)  :: efermi2,eval,totind
    real(kind=DP), pointer, dimension(:,:,:) :: eig2,occup2,eig2_mpi,occup2_mpi
    real(kind=DP), pointer, dimension(:) :: eawk,cdwk,cswk,cdos,cind,valud
    real(kind=DP) :: totch_spin(2), totch_spin0(2)
    integer             :: id_sname = -1

! =================================== added by K. Tagami ============== 11.0
    integer :: is
! ===================================================================== 11.0

    call tstatc0_begin('m_ESoc_fermi_tetrahedron ', id_sname)

! ==================================== modified by K. Tagami ============ 11.0
!    allocate(eig2(np2,neg,nspin)); eig2 = 0.d0
!    allocate(eig2_mpi(np2,neg,nspin)); eig2_mpi = 0.d0     ! MPI
!    allocate(occup2(neg,np2,nspin)); occup2 = 0.d0
!    allocate(occup2_mpi(neg,np2,nspin)); occup2_mpi = 0.d0 ! MPI
!
   if ( noncol ) then
     allocate(eig2(np2,neg,1)); eig2 = 0.d0
     allocate(eig2_mpi(np2,neg,1)); eig2_mpi = 0.d0     ! MPI
     allocate(occup2(neg,np2,1)); occup2 = 0.d0
     allocate(occup2_mpi(neg,np2,1)); occup2_mpi = 0.d0 ! MPI
   else
     allocate(eig2(np2,neg,nspin)); eig2 = 0.d0
     allocate(eig2_mpi(np2,neg,nspin)); eig2_mpi = 0.d0     ! MPI
     allocate(occup2(neg,np2,nspin)); occup2 = 0.d0
     allocate(occup2_mpi(neg,np2,nspin)); occup2_mpi = 0.d0 ! MPI
   endif
! ======================================================================= 11.0

    allocate(eawk(np0)); eawk = 0.d0
    allocate(cdwk(np0)); cdwk = 0.d0
    allocate(cswk(np0)); cswk = 0.d0
    allocate(cdos(np2*neg)); cdos = 0.d0
    allocate(cind(np2*neg)); cind = 0.d0

! ==================================== modified by K. Tagami ============ 11.0
!    allocate(valud(nspin)); valud = 0.d0
    if ( noncol ) then
      allocate(valud(1)); valud = 0.d0
    else
      allocate(valud(nspin)); valud = 0.d0
    endif
! ======================================================================= 11.0

    call check_totch(nfout)           ! totch will be checked

    nxx = nxyz_tetra(1)
    nyy = nxyz_tetra(2)
    nzz = nxyz_tetra(3)
    neig=neg
!!$    if(nspin.eq.1) then
!!$       wei=2
!!$    else
!!$       wei=1
!!$    end if

! ==================================== added by K. Tagami =============== 11.0
!                               ( just in case )
! ---
    if ( noncol ) then
       Do is=2, ndim_spinor
          do ip2 = 1, kv3/ndim_spinor
            ik = ndim_spinor *(ip2 -1) +is

            if ( map_k(ik) /= myrank_k ) cycle
             do ieig = 1, neig
                ip = neordr(ieig,ik)
                if( map_e(ieig) /= myrank_e) cycle
                eko_l( map_z(ip),ik) = 1.0D15
             End do
          End do
       end do
    endif
! ======================================================================= 11.0

    nengy=0

!  ======================================= modified by K. Tagami ======== 11.0
!    do ispin=1,nspin
!       do ip2=1,np2
!          ik=nspin*(ip2-1)+ispin
!          if(map_k(ik) /= myrank_k) cycle               ! MPI
!          do ieig=1,neig
!             ip = neordr(ieig,ik)
!             if(map_e(ip) == myrank_e) then             ! MPI
!                eig2(ip2,ieig,ispin)=eko_l(map_z(ip),ik)! MPI
!             end if
!          enddo
!       enddo
!    enddo
!      call mpi_allreduce( eig2, eig2_mpi, np2*neg, &
!       &           mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )
!
    if ( noncol ) then
      do is = 1, 1
         do ip2=1,np2
            ik = ndim_spinor*(ip2-1) +is
            if (map_k(ik) /= myrank_k) cycle               ! MPI

            do ieig=1,neig
               ip = neordr(ieig,ik)

               if(map_e(ip) == myrank_e) then             ! MPI
                  eig2(ip2,ieig,is)=eko_l(map_z(ip),ik)! MPI
               end if
            enddo

         enddo
      end do
!      call mpi_allreduce( eig2, eig2_mpi, np2*neg, &
!	         &        mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )
      call mpi_allreduce( eig2, eig2_mpi, np2*neg, &
	         &        mpi_double_precision, mpi_sum, mpi_spin_group, ierr )

    else

!      do ispin=1,nspin
      do ispin=ista_spin, iend_spin
         do ip2=1,np2
            ik=nspin*(ip2-1)+ispin
            if(map_k(ik) /= myrank_k) cycle               ! MPI
            do ieig=1,neig
               ip = neordr(ieig,ik)

               if(map_e(ip) == myrank_e) then             ! MPI
                  eig2(ip2,ieig,ispin)=eko_l(map_z(ip),ik)! MPI

               end if
            enddo
         enddo
      enddo
      call mpi_allreduce( eig2, eig2_mpi, np2*neg*nspin, &
	         &        mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )


    endif
! ============================================================================= 11.0

    eig2 = eig2_mpi                                   ! MPI

    if(iprioccup>=2 ) write(nfout,*) ' === tetrahedron method', &
                &  ' for k-space integration ==='

    if(imag == FERRO .and. sw_fix_total_spin == YES .and. nspin == 2) then
       if(total_spin > totch) then
          write(nfout,'( " !WARNING total_spin should be smaller than totch <<m_ESoc_fermi_tetrahedron>>")')

          totch_spin(1) = totch
          totch_spin(2) = totch
       else
          totch_spin(1) = (totch + total_spin)*1.0d0
          totch_spin(2) = (totch - total_spin)*1.0d0
       end if

       do ispin = ista_spin, iend_spin
          efermi2 = (minval(eig2(:,:,ispin))+maxval(eig2(:,:,ispin)))*0.5d0

! ======================= modified by K. Tagami =================== 11.0
!                    The "optional" in spg+tetra.F does not seem to work, so...
!
!          call fermi1(nxx,nyy,nzz,np2,np2,neig,neg,1, &
!               &  eig2(1,1,ispin),ip20,np0,totch_spin(ispin), efermi2,eval,valud, &
!               &  iwt,ip2cub,iprioccup) ! -> efermi_spin

          call fermi1(nxx,nyy,nzz,np2,np2,neig,neg,1, &
               &  eig2(1:np2,1:neg,ispin),ip20,np0,totch_spin(ispin), efermi2,eval,valud, &
               &  iwt,ip2cub,iprioccup, .false. )
                                             ! -> efermi_spin
! ================================================================= 11.0

          efermi_spin(ispin) = efermi2
       end do
! --> T. Yamasaki 06th Aug. 2009
       efermi2 = efermi

! ======================= modified by K. Tagami =========== 11.0
!                    The "optional" in spg+tetra.F does not seem to work, so...
!
! ----
!       call fermi1(nxx,nyy,nzz,np2,np2,neig,neg,nspin, &
!            &  eig2,ip20,np0,totch, efermi2,eval,valud, &
!            &  iwt,ip2cub,iprioccup)
!
       call fermi1(nxx,nyy,nzz,np2,np2,neig,neg,nspin, &
            &  eig2,ip20,np0,totch, efermi2,eval,valud, &
            &  iwt,ip2cub,iprioccup, .false. )
! ========================================================= 11.0

       if(iprioccup >=2 ) write(nfout,*) 'eval=',eval
       efermi = efermi2
       do ispin=ista_spin, iend_spin
          call nstt3i(idimtetra,nengy,efermi,nxx,nyy,nzz, &
               &  np2,np2,neig,eig2(1,1,ispin), &
               &  ip20,np0,eawk,cdwk,cswk,np2,neig,cdos,cind,width_tetra )
!!$      efermi=efermi2
          totind=0.d0
          do ip2=1,np2
             do ieig=1,neig
                ikee=ip2+np2*(ieig-1)
                ik=nspin*(ip2-1)+ispin
                if(map_k(ik) == myrank_k) then            ! MPI
                   ip_mpi = neordr(ieig,ik)
                   if(map_e(ip_mpi) == myrank_e) &        ! MPI
                        & occup2(ip_mpi,ip2,ispin)=cind(ikee)*dble(np2) ! MPI
                end if
                totind=totind+cind(ikee)
             enddo
          enddo
          totch_spin0(ispin)= totind
       end do
       total_spin0 = totch_spin0(1) - totch_spin0(2)
       totch_spin0 = totch_spin0*2.0  ! 21 Jun. 2023 by T. Y.
       if(iprioccup >= PRINTOUTLEVEL_TOTCH_SPIN) &
            & call wd_efermi_and_total_spin0_Plus(nfout,total_spin0,totch_spin0,totch_spin)
       efermi = (efermi_spin(1)+efermi_spin(2))*0.5d0
       if(iprioccup>= PRINTOUTLEVEL_TOTCH_SPIN) &
            & write(nfout,'(" ! efermi_spin(1:2) = ",2f16.8," efermi = ",f16.8)') efermi_spin(1:2),efermi
    else
!!$! modified by H.Sawada on May 2, 1997
!!$       efermi2 = efermi
!!$! modified by H.Sawada on May 2, 1997

       if(efermi_is_defined) then
          efermi2 = efermi
! ======================================== added by K. Tagami ========= 11.0
       else if ( noncol ) then
          efermi2 = (minval(eig2(:,:,1))+maxval(eig2(:,:,1))) *0.5d0
! ====================================================================== 11.0
       else
          efermi2 = (minval(eig2(:,:,1:nspin))+maxval(eig2(:,:,1:nspin)))*0.5d0
       end if

! ========================================= modified by K. Tagami ============== 11.0
!       call fermi1(nxx,nyy,nzz,np2,np2,neig,neg,nspin, &
!            &  eig2,ip20,np0,totch, efermi2,eval,valud, &
!            &  iwt,ip2cub,iprioccup)
!       if(iprioccup >=2 ) write(nfout,*) 'eval=',eval
!       efermi = efermi2
!       efermi_spin(1) = efermi2
!       if(nspin == 2) efermi_spin(2) = efermi2
!

      if ( noncol ) then

        call fermi1( nxx, nyy, nzz, np2, np2, neig, neg, 1, &
             &  eig2, ip20, np0, totch, efermi2, eval, valud, &
             &  iwt, ip2cub, iprioccup, noncol )

        if(iprioccup >=2 ) write(nfout,*) 'eval A =',eval

        efermi = efermi2
        efermi_spin(1) = efermi2
!!!         if(nspin == 2) efermi_spin(2) = efermi2
      else
        call fermi1( nxx, nyy, nzz, np2, np2, neig, neg, nspin, &
             &  eig2, ip20, np0, totch, efermi2, eval, valud, &
             &  iwt, ip2cub, iprioccup, .false. )
        if(iprioccup >=2 ) write(nfout,*) 'eval=',eval

        efermi = efermi2
        efermi_spin(1) = efermi2
        if(nspin == 2) efermi_spin(2) = efermi2
      endif
! ========================================================================= 11.0

    end if

! ===================================== modified by K. Tagami =========== 11.0
!    do ispin=1,nspin
!!!$      write(nfout,*) ' ispin=',ispin
!!!$      instts1 = 0
!!!$      call nsdos3(nfout,idim,efermi2,nxx,nyy,nzz,np2,1,neig, &
!!!$               &  eig2(1,1,ispin),ip20,np0,eawk,instts1,np2,iwt,ip2cub,iprioccup)
!!!$      call nstt3i(idimtetra,nengy,efermi2,nxx,nyy,nzz, &
!!!$               &  np2,np2,neig,eig2(1,1,ispin), &
!!!$               &  ip20,np0,eawk,cdwk,cswk,np2,neig,cdos,cind )
!      call nstt3i(idimtetra,nengy,efermi_spin(ispin),nxx,nyy,nzz, &
!               &  np2,np2,neig,eig2(1,1,ispin), &
!               &  ip20,np0,eawk,cdwk,cswk,np2,neig,cdos,cind )
!!!$      efermi=efermi2
!
!      totind=0.d0
!      do ip2=1,np2
!         do ieig=1,neig
!            ikee=ip2+np2*(ieig-1)
!            ik=nspin*(ip2-1)+ispin
!            if(map_k(ik) == myrank_k) then            ! MPI
!               ip_mpi = neordr(ieig,ik)
!               if(map_e(ip_mpi) == myrank_e) &        ! MPI
!                    & occup2(ip_mpi,ip2,ispin)=cind(ikee)*dble(np2) ! MPI
!            end if
!            totind=totind+cind(ikee)
!         enddo
!      enddo
!! --> T. Yamasaki, 17th Aug. 2009
!      if(imag == FERRO .and. sw_fix_total_spin == NO .and. nspin == 2)  totch_spin0(ispin) = totind
!! <--
!      if(iprioccup>=2) write(nfout,'(" for spin=",i1," ** TOTAL CHARGE after fermi1 = ",f8.4)') ispin,totind
!    enddo

    if ( noncol ) then
      do is=1, 1
        call nstt3i( idimtetra, nengy, efermi_spin(is), nxx, nyy, nzz, &
                 &  np2, np2, neig, eig2(1,1,is), &
                 &  ip20, np0, eawk, cdwk, cswk, np2, neig, cdos, cind, width_tetra )
        totind=0.d0
        do ip2=1,np2
           do ieig=1,neig
              ikee = ip2 +np2 *(ieig-1)
              ik = ndim_spinor *(ip2-1)+is

              if ( map_k(ik) == myrank_k ) then            ! MPI
                 ip_mpi = neordr(ieig,ik)
                 if(map_e(ip_mpi) == myrank_e) &        ! MPI
                      & occup2(ip_mpi,ip2,is)=cind(ikee)*dble(np2) ! MPI
              end if
              totind=totind+cind(ikee)
           enddo
        enddo
        if ( iprioccup>=2 ) write(nfout,'(" for spin=",i1, &
	             &      " ** TOTAL CHARGE after fermi1 = ",f12.4)') is,totind
      end do

    else
      do ispin=ista_spin, iend_spin
        call nstt3i( idimtetra, nengy, efermi_spin(ispin), nxx, nyy, nzz, &
                 &  np2, np2, neig, eig2(1,1,ispin), &
                 &  ip20, np0, eawk, cdwk, cswk, np2, neig, cdos, cind, width_tetra )
        totind=0.d0
        do ip2=1,np2
           do ieig=1,neig
              ikee = ip2 +np2 *(ieig-1)
              ik = nspin *(ip2-1)+ispin

              if ( map_k(ik) == myrank_k ) then            ! MPI
                 ip_mpi = neordr(ieig,ik)
                 if(map_e(ip_mpi) == myrank_e) &        ! MPI
                      & occup2(ip_mpi,ip2,ispin)=cind(ikee)*dble(np2) ! MPI
              end if
              totind=totind+cind(ikee)
           enddo
        enddo
        if ( imag == FERRO .and. sw_fix_total_spin == NO .and. nspin == 2) then
	   totch_spin0(ispin) = totind
        endif
        if ( iprioccup>=2 ) write(nfout,'(" for spin=",i1, &
	         &      " ** TOTAL CHARGE after fermi1 = ",f12.4)') ispin,totind
      enddo
    endif
! ========================================================================= 11.0

    if(imag == FERRO .and. sw_fix_total_spin == NO .and. nspin == 2) then
       total_spin0 = totch_spin0(1) - totch_spin0(2)
       totch_spin0 = totch_spin0*2.0  ! 21 Jun. 2023 by T. Y.
       if(iprioccup >= PRINTOUTLEVEL_TOTCH_SPIN) call wd_efermi_and_total_spin0(nfout,total_spin0,totch_spin0)
    end if

! ============================== added by K. Tagami ======================== 11.0
    if ( noncol ) then
       if ( iprioccup >= 2 ) then
          write(nfout,'(A,F10.4)') " == efermi (noncol) = ", efermi
       end if
    end if
! ========================================================================== 11.0

! ============================================= modiifed by K. Tagami ======= 11.0
!    do ieig = 1, neg
!       if(map_e(ieig) /= myrank_e) cycle              ! MPI
!       do ispin=1,nspin
!          do ip2=1,np2
!             ik=nspin*(ip2-1)+ispin
!             if(map_k(ik) == myrank_k) then           ! MPI
!                occup_l(map_z(ieig),ik)=occup2(ieig,ip2,ispin) ! MPI
!             end if
!!          enddo
!       enddo
!    enddo
    if ( noncol ) then
      do ieig = 1, neg
         if(map_e(ieig) /= myrank_e) cycle
         do is=1, 1
            do ip2=1, np2
               ik = ndim_spinor *(ip2-1)+is
               if ( map_k(ik) == myrank_k ) then
                  occup_l(map_z(ieig),ik)=occup2(ieig,ip2,is)

               end if
            enddo
         enddo
      enddo
    else
      do ieig = 1, neg
         if(map_e(ieig) /= myrank_e) cycle              ! MPI
         do ispin=ista_spin, iend_spin
            do ip2=1,np2
               ik=nspin*(ip2-1)+ispin
               if(map_k(ik) == myrank_k) then           ! MPI
                  occup_l(map_z(ieig),ik)=occup2(ieig,ip2,ispin) ! MPI

               end if
            enddo
         enddo
      enddo
    endif

 ! ===================================================================== 11.0

    if(imag == FERRO .and. nspin == 2) then
       ip2 = 2
       if(sw_fix_total_spin == YES) call check_occupation(nfout,ip2,totch_spin)
    else if(imag /= FERRO) then
       ip2 = 1
       totch_spin0(1) = totch
    end if

! ============================== modified by K. Tagami ============= 11.0
!    call check_occupation(nfout,ip2,totch_spin0)
!
    if ( noncol ) then
       call check_occupation_noncl(nfout,totch_spin0)
    else
       call check_occupation(nfout,ip2,totch_spin0)
    endif
! ================================================================== 11.0

    deallocate(valud); deallocate(cind); deallocate(cdos); deallocate(cswk)
    deallocate(cdwk);  deallocate(eawk); deallocate(occup2_mpi); deallocate(occup2)
    deallocate(eig2_mpi); deallocate(eig2)
    call tstatc0_end(id_sname)
#endif
  end subroutine m_ESoc_fermi_tetrahedron
!$$#endif

  subroutine check_totch(nfout)
    integer, intent(in) :: nfout
    real(kind=DP), parameter :: minimum_critical = 1.d-14
    if(totch <= minimum_critical ) then
       write(nfout,*) '!D totch is too small: totch = ', totch
       call phase_error_with_msg(nfout, 'totch is too small',__LINE__,__FILE__)
    endif
  end subroutine check_totch

!!$  subroutine m_ESoc_dos_with_GaussDistrib()
!!$
!!$  end subroutine m_ESoc_dos_with_GaussDistrib

  logical function m_ESoc_check_num_bands()
    real(kind=DP) :: c

! =========================== modified by K. Tagami ================ 11.0
!    c = neg*2.d0
!
    if ( noncol ) then
       c = neg
    else
       c = neg*2.d0
    endif
! ================================================================== 11.0

    if( c > totch) then
       m_ESoc_check_num_bands = .true.
    else
       m_ESoc_check_num_bands = .false.
    end if
  end function m_ESoc_check_num_bands

  subroutine m_ESoc_fermi_parabolic_ek(nfout)
!
!   Coded from <m_ESoc_fermi_parabolic>
!                      by T. Yamasaki (FUJITSU LABORATORIES Ltd.), 28th Jun. 2003
    integer, intent(in) :: nfout

    integer             :: jcount
    real(kind=DP)       :: emin, emax, e1, e2, tot
    real(kind=DP), parameter :: DELTA_TOTCH = 1.d-10
    integer,       parameter :: MAXITR = 100000

! ================================ added by K. Tagami ================ 11.0
    integer :: ik, is, iksnl
    real(kind=DP), allocatable :: eko_tmp(:,:)
! ==================================================================== 11.0

    integer :: id_sname = -1

    call tstatc0_begin('m_ESoc_fermi_parabolic_ek ', id_sname)

    call check_totch(nfout)

! ============================ modified by K. Tagami =================  11.0
!    emin = minval(eko_ek)
!    emax = maxval(eko_ek)
!
     if ( noncol ) then
       allocate( eko_tmp( neg, kv3_ek/ndim_spinor ) ); eko_tmp = 0.0d0
       Do ik=1, kv3_ek, ndim_spinor
         iksnl = ( ik -1 )/ndim_spinor + 1
         eko_tmp( :,iksnl ) = eko_ek( :,ik )
       End do
       emin = minval(eko_tmp);   emax = maxval(eko_tmp)
       deallocate( eko_tmp )
     else
       emin = minval(eko_ek)
       emax = maxval(eko_ek)
     endif
! ===================================================================== 11.0

    efermi = emax
    e1 = emin - dabs(DELTA_FermiSearchRange)
    e2 = emax + dabs(DELTA_FermiSearchRange)

    jcount = 1
    occupied_ch_equals_totch : do

! ======================================== modified by K. Tagami ========== 11.0
!!       call get_tot()             ! -(contained here) ->tot
!
       if ( noncol ) then
         call get_tot_noncl()
       else
         call get_tot()
       endif
! ========================================================================== 11.0

!          ~~~~~~~~~~~~~~~~~~~~
       if(jcount == 1 .and. tot < totch) &
            call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
       if(dabs(tot - totch) < DELTA_TOTCH) exit occupied_ch_equals_totch
       if( tot < totch) then
          e1 = efermi; efermi = efermi + (e2-efermi)/2
       else
          e2 = efermi; efermi = efermi + (e1-efermi)/2
       end if
       jcount = jcount + 1
       if(jcount > MAXITR) then
          call wd_fermi_error2 &   !-(b_Fermi)
               & (nfout,e1,e2,efermi,emin,emax,tot,totch,neg,MAXITR)
       end if
    end do occupied_ch_equals_totch
    if(iprioccup >= 2) &
         &write(nfout,'( " efermi = ", f10.4, " tot = ", f10.4)') efermi, tot


! ===================================== modified by K. Tagami ========== 11.0
!    call check_if_metalic(nfout,metalic_system)

    if ( noncol ) then
      call check_if_metalic_noncl(nfout,metalic_system)
    else
      call check_if_metalic(nfout,metalic_system)
    endif
! ======================================================================= 11.0

    if(iprioccup >= 2 .and. .not.metalic_system) then
       if(dabs(vbm) < 1.d6) then
          write(nfout,'( " The highest occupied band energy = ", f10.4)') vbm
       else
          write(nfout,'( " The highest occupied band energy is not calculated")')
       end if
    end if

    call tstatc0_end(id_sname)
  contains
    subroutine get_tot
      integer       :: k, i
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, totw
      tot = 0.d0
      do k = 1, kv3_ek, af+1
         do i = 1, neg
            e = eko_ek(i,k)
            call width2(e,efermi,width,dos,weight)  ! -(b_Fermi)
            totw = weight*wspin*kv3_ek*qwgt_ek(k)
            tot = tot + 2*totw
         end do
      end do
      tot = tot/kv3_ek * (af+1)
      if(iprioccup >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12," jcount = ",i7)') efermi,tot, jcount
    end subroutine get_tot

! ======================================== added by K. Tagami ============ 11.0
    subroutine get_tot_noncl
      integer       :: k, i
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, totw, wktmp

      tot = 0.d0
      wktmp = kv3_ek / ndim_spinor

      do k = 1, kv3_ek, ndim_spinor
         do i = 1, neg
            e = eko_ek(i,k)
            call width2(e,efermi,width,dos,weight)  ! -(b_Fermi)
            totw = weight *wspin *wktmp *qwgt_ek(k)
            tot = tot + totw
         end do
      end do
      tot = tot /wktmp
      if(iprioccup >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12," jcount = ",i7)') efermi,tot, jcount

    end subroutine get_tot_noncl
! ======================================================================= 11.0

  end subroutine m_ESoc_fermi_parabolic_ek

  subroutine m_ESoc_fermi_tetra_ek(nfout)
!  Coded from <m_ESoc_fermi_tetrahedron>
!          by Takahiro Yamasaki(FUJITSU LABORATORIES Ltd.), 28th Jun. 2003
!
    integer, intent(in) :: nfout
#ifndef NO_TETRAHEDRON
    real(kind=DP), parameter :: delta = 1.d-12
    integer, parameter       :: idim = 3
    integer        :: neig,nengy,ispin,ip2,ik,instts1,ikee,nxx,nyy,nzz, ib, jb
    real(kind=DP)  :: efermi2,eval,totind, et
    real(kind=DP), pointer, dimension(:,:,:) :: eig2
    real(kind=DP), pointer, dimension(:) :: eawk,cdwk,cswk,cdos,cind,valud
    integer             :: id_sname = -1

! =================================== added by K. Tagami ==============- 11.0
    integer :: is
! ====================================================================== 11.0

    call tstatc0_begin('m_ESoc_fermi_tetra_ek ', id_sname)

! ================================= modified by K. Tagami ============= 11.0
!    allocate(eig2(np2,neg,nspin)); eig2 = 0.d0
    if ( noncol ) then
      allocate(eig2(np2,neg,1)); eig2 = 0.d0
    else
      allocate(eig2(np2,neg,nspin)); eig2 = 0.d0
    endif
! ===================================================================== 11.0

    allocate(eawk(np0)); eawk = 0.d0
    allocate(cdwk(np0)); cdwk = 0.d0
    allocate(cswk(np0)); cswk = 0.d0
    allocate(cdos(np2*neg)); cdos = 0.d0
    allocate(cind(np2*neg)); cind = 0.d0
! ================================= modified by K. Tagami ============= 11.0
!    allocate(valud(nspin)); valud = 0.d0
    if ( noncol ) then
      allocate(valud(1)); valud = 0.d0
    else
      allocate(valud(nspin)); valud = 0.d0
    endif
! ====================================================================== 11.0

    call check_totch(nfout)           ! totch is checked

    nxx = nxyz_tetra(1)
    nyy = nxyz_tetra(2)
    nzz = nxyz_tetra(3)
    neig=neg
    nengy=0

! ======================================= modified by K. Tagami ======== 11.0
!    do ispin=1,nspin
!       do ip2=1,np2
!          ik=nspin*(ip2-1)+ispin
!          do ib=1,neg
!             eig2(ip2,ib,ispin)=eko_ek(ib,ik)
!          enddo
!          do ib = 1,neg-1
!             do jb = ib+1, neg
!                if(eig2(ip2,jb,ispin) < eig2(ip2,ib,ispin)-delta) then
!                   et = eig2(ip2,ib,ispin)
!                   eig2(ip2,ib,ispin) = eig2(ip2,jb,ispin)
!                   eig2(ip2,jb,ispin) = et
!                end if
!             end do
!          end do
!       enddo
!    enddo
    if ( noncol ) then
      do is=1, 1
         do ip2=1,np2
            ik = ndim_spinor *(ip2-1)+is
            do ib=1,neg
               eig2(ip2,ib,is)=eko_ek(ib,ik)
            enddo
            do ib = 1,neg-1
               do jb = ib+1, neg
                  if(eig2(ip2,jb,is) < eig2(ip2,ib,is)-delta) then
                     et = eig2(ip2,ib,is)
                     eig2(ip2,ib,is) = eig2(ip2,jb,is)
                     eig2(ip2,jb,is) = et
                  end if
               end do
            end do
         enddo
      enddo
    else
      do ispin=1,nspin
         do ip2=1,np2
            ik=nspin*(ip2-1)+ispin
            do ib=1,neg
               eig2(ip2,ib,ispin)=eko_ek(ib,ik)
            enddo
            do ib = 1,neg-1
               do jb = ib+1, neg
                  if(eig2(ip2,jb,ispin) < eig2(ip2,ib,ispin)-delta) then
                     et = eig2(ip2,ib,ispin)
                     eig2(ip2,ib,ispin) = eig2(ip2,jb,ispin)
                     eig2(ip2,jb,ispin) = et
                  end if
               end do
            end do
         enddo
      enddo
    endif
! ==================================================================== 11.0

    if(iprioccup>=2) then
       write(nfout,'(" --- eko_ek --- <<m_ESoc_fermi_tetra_ek>>")')
! ================================== modified by K. Tagami =========== 11.0
!       do ik = 1, kv3_ek
       do ik = 1, kv3_ek, ndim_spinor
! ===================================================================== 11.0
          write(nfout,'(" ik = ",i8)') ik
          write(nfout,'(10f8.4)') (eko_ek(ib,ik),ib=1,neg)
       end do
    end if

    if(iprioccup>=2) write(nfout,*) ' === tetrahedron method', &
                &  ' for k-space integration ==='
    efermi2 = efermi

! ============================= modified by K. Tagami ============== 11.0
!    call fermi1(nxx,nyy,nzz,np2,np2,neig,neg,nspin, &
!             &  eig2,ip20,np0,totch, efermi2,eval,valud, &
!             &  iwt,ip2cub,iprioccup)
    if ( noncol ) then
      call fermi1( nxx, nyy, nzz, np2, np2, neig, neg, 1, &
               &   eig2, ip20, np0, totch, efermi2, eval, valud, &
               &   iwt, ip2cub, iprioccup, .true. )
    else
      call fermi1( nxx, nyy, nzz, np2, np2, neig, neg, nspin, &
               &   eig2, ip20, np0, totch, efermi2, eval, valud, &
               &   iwt, ip2cub, iprioccup, .false. )
    endif
! ================================================================== 11.0

    if(iprioccup>=2) write(nfout,*) 'eval=',eval

! ============================= modified by K. Tagami ============== 11.0
!    do ispin=1,nspin
!!!$      write(nfout,*) ' ispin=',ispin
!      instts1 = 0
!      call nsdos3(nfout,idim,efermi2,nxx,nyy,nzz,np2,1,neig, &
!               &  eig2(1,1,ispin),ip20,np0,eawk,instts1,np2,iwt,ip2cub,iprioccup)
!      call nstt3i(idim,nengy,efermi2,nxx,nyy,nzz, &
!               &  np2,np2,neig,eig2(1,1,ispin), &
!               &  ip20,np0,eawk,cdwk,cswk,np2,neig,cdos,cind )
!      efermi=efermi2
!
!      totind=0.d0
!      do ip2=1,np2
!         do ib=1,neig
!            ikee=ip2+np2*(ib-1)
!            totind=totind+cind(ikee)
!         enddo
!      enddo
!      if(iprioccup>=2) write(nfout,*) 'for spin=',ispin, &
!                  &  ' ** TOTAL CHARGE after fermi1 = ',totind
!   enddo
!
   if ( noncol ) then
      do is=1,1
        instts1 = 0
        call nsdos3( nfout, idim, efermi2, nxx, nyy, nzz, np2, 1, neig, &
                 &  eig2(1,1,is), ip20, np0, eawk, instts1, np2, &
 	         &  iwt, ip2cub, iprioccup )
        call nstt3i( idim, nengy, efermi2, nxx, nyy, nzz, &
                 &   np2, np2, neig, eig2(1,1,is), &
                 &   ip20, np0, eawk, cdwk, cswk, np2, neig, cdos, cind, width_tetra )
        efermi=efermi2

        totind=0.d0
        do ip2=1,np2
           do ib=1,neig
              ikee=ip2+np2*(ib-1)
              totind=totind+cind(ikee)
           enddo
        enddo
        if(iprioccup>=2) write(nfout,*) 'for spin=',is, &
                    &  ' ** TOTAL CHARGE after fermi1 = ',totind
     enddo
   else
      do ispin=1,nspin
        instts1 = 0
        call nsdos3( nfout, idim, efermi2, nxx, nyy, nzz, np2, 1, neig, &
                 &  eig2(1,1,ispin), ip20, np0, eawk, instts1, np2, &
 	         &  iwt, ip2cub, iprioccup )
        call nstt3i( idim, nengy, efermi2, nxx, nyy, nzz, &
                 &   np2, np2, neig, eig2(1,1,ispin), &
                 &   ip20, np0, eawk, cdwk, cswk, np2, neig, cdos, cind, width_tetra )
        efermi=efermi2

        totind=0.d0
        do ip2=1,np2
           do ib=1,neig
              ikee=ip2+np2*(ib-1)
              totind=totind+cind(ikee)
           enddo
        enddo
        if(iprioccup>=2) write(nfout,*) 'for spin=',ispin, &
                    &  ' ** TOTAL CHARGE after fermi1 = ',totind
     enddo
    endif
! =================================================================== 11.0

    deallocate(valud); deallocate(cind); deallocate(cdos); deallocate(cswk)
    deallocate(cdwk);  deallocate(eawk)
    deallocate(eig2)

! ========================================= modified by K. Tagami ====== 11.0
!    call check_if_metalic(nfout,metalic_system)
    if ( noncol ) then
      call check_if_metalic_noncl(nfout,metalic_system)
    else
      call check_if_metalic(nfout,metalic_system)
    endif
! ===================================================================== 11.0

    if(iprioccup >= 2 .and. .not.metalic_system) &
         &write(nfout,'( " The highest occupied band energy = ", f10.4)') vbm

    call tstatc0_end(id_sname)
#endif
  end subroutine m_ESoc_fermi_tetra_ek

! ============================== KT_add ====================== 13.0E
  subroutine m_ESoc_fermi_dirac_ek(nfout)
    integer, intent(in) :: nfout

    integer             :: jcount
    real(kind=DP)       :: emin, emax, e1, e2, tot
    real(kind=DP), parameter :: DELTA_TOTCH = 1.d-10
    integer,       parameter :: MAXITR = 100000

    integer :: ik, is, iksnl
    real(kind=DP), allocatable :: eko_tmp(:,:)

    integer :: id_sname = -1

    call tstatc0_begin('m_ESoc_fermi_dirac_ek ', id_sname)

    call check_totch(nfout)

    if ( noncol ) then
       allocate( eko_tmp( neg, kv3_ek/ndim_spinor ) ); eko_tmp = 0.0d0
       Do ik=1, kv3_ek, ndim_spinor
          iksnl = ( ik -1 )/ndim_spinor + 1
          eko_tmp( :,iksnl ) = eko_ek( :,ik )
       End do
       emin = minval(eko_tmp);   emax = maxval(eko_tmp)
       deallocate( eko_tmp )
    else
       emin = minval(eko_ek)
       emax = maxval(eko_ek)
    endif

    efermi = emax
    e1 = emin - dabs(DELTA_FermiSearchRange)
    e2 = emax + dabs(DELTA_FermiSearchRange)

    jcount = 1

! --------------------------------------------
    occupied_ch_equals_totch : do

       if ( noncol ) then
          call get_tot_noncl()
       else
         call get_tot()
       endif

!          ~~~~~~~~~~~~~~~~~~~~
       if(jcount == 1 .and. tot < totch) &
            call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
       if(dabs(tot - totch) < DELTA_TOTCH) exit occupied_ch_equals_totch
       if( tot < totch) then
          e1 = efermi; efermi = efermi + (e2-efermi)/2
       else
          e2 = efermi; efermi = efermi + (e1-efermi)/2
       end if
       jcount = jcount + 1
       if(jcount > MAXITR) then
          call wd_fermi_error2 &   !-(b_Fermi)
               & (nfout,e1,e2,efermi,emin,emax,tot,totch,neg,MAXITR)
       end if
    end do occupied_ch_equals_totch
    if(iprioccup >= 2) &
         &write(nfout,'( " efermi = ", f10.4, " tot = ", f10.4)') efermi, tot


    if ( noncol ) then
      call check_if_metalic_noncl(nfout,metalic_system)
    else
      call check_if_metalic(nfout,metalic_system)
    endif

    if(iprioccup >= 2 .and. .not.metalic_system) then
       if(dabs(vbm) < 1.d6) then
          write(nfout,'( " The highest occupied band energy = ", f10.4)') vbm
       else
          write(nfout,'( " The highest occupied band energy is not calculated")')
       end if
    end if

    call tstatc0_end(id_sname)
  contains
    subroutine get_tot
      integer       :: k, i
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, totw
      tot = 0.d0
      do k = 1, kv3_ek, af+1
         do i = 1, neg
            e = eko_ek(i,k)
            call width_fermi_dirac(e,efermi,width,dos,weight)  ! -(b_Fermi)
            totw = weight*wspin*kv3_ek*qwgt_ek(k)
            tot = tot + 2*totw
         end do
      end do
      tot = tot/kv3_ek * (af+1)
      if(iprioccup >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12," jcount = ",i7)') efermi,tot, jcount
    end subroutine get_tot

    subroutine get_tot_noncl
      integer       :: k, i
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, totw, wktmp

      tot = 0.d0
      wktmp = kv3_ek / ndim_spinor

      do k = 1, kv3_ek, ndim_spinor
         do i = 1, neg
            e = eko_ek(i,k)
            call width_fermi_dirac(e,efermi,width,dos,weight)  ! -(b_Fermi)
            totw = weight *wspin *wktmp *qwgt_ek(k)
            tot = tot + totw
         end do
      end do
      tot = tot /wktmp
      if(iprioccup >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12," jcount = ",i7)') efermi,tot, jcount

    end subroutine get_tot_noncl

  end subroutine m_ESoc_fermi_dirac_ek
! ========================================================== 13.0E

  subroutine m_ESoc_mp_ek(nfout)
!
!   Coded from <m_ESoc_fermi_parabolic>
!                      by T. Yamasaki (FUJITSU LABORATORIES Ltd.), 28th Jun. 2003
    integer, intent(in) :: nfout

    integer             :: jcount
    real(kind=DP)       :: emin, emax, e1, e2, tot
    real(kind=DP), parameter :: DELTA_TOTCH = 1.d-10
    integer,       parameter :: MAXITR = 100000

! ================================ added by K. Tagami ================ 11.0
    integer :: ik, is, iksnl
    real(kind=DP), allocatable :: eko_tmp(:,:)
! ==================================================================== 11.0

    integer :: id_sname = -1

    call tstatc0_begin('m_ESoc_mp_ek ', id_sname)

    call check_totch(nfout)

! ============================ modified by K. Tagami =================  11.0
!    emin = minval(eko_ek)
!    emax = maxval(eko_ek)
!
     if ( noncol ) then
       allocate( eko_tmp( neg, kv3_ek/ndim_spinor ) ); eko_tmp = 0.0d0
       Do ik=1, kv3_ek, ndim_spinor
         iksnl = ( ik -1 )/ndim_spinor + 1
         eko_tmp( :,iksnl ) = eko_ek( :,ik )
       End do
       emin = minval(eko_tmp);   emax = maxval(eko_tmp)
       deallocate( eko_tmp )
     else
       emin = minval(eko_ek)
       emax = maxval(eko_ek)
     endif
! ===================================================================== 11.0

    efermi = emax
    e1 = emin - dabs(DELTA_FermiSearchRange)
    e2 = emax + dabs(DELTA_FermiSearchRange)

    jcount = 1
    occupied_ch_equals_totch : do

! ======================================== modified by K. Tagami ========== 11.0
!!       call get_tot()             ! -(contained here) ->tot
!
       if ( noncol ) then
         call get_tot_noncl()
       else
         call get_tot()
       endif
! ========================================================================== 11.0

!          ~~~~~~~~~~~~~~~~~~~~
       if(jcount == 1 .and. tot < totch) &
            call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
       if(dabs(tot - totch) < DELTA_TOTCH) exit occupied_ch_equals_totch
       if( tot < totch) then
          e1 = efermi; efermi = efermi + (e2-efermi)/2
       else
          e2 = efermi; efermi = efermi + (e1-efermi)/2
       end if
       jcount = jcount + 1
       if(jcount > MAXITR) then
          call wd_fermi_error2 &   !-(b_Fermi)
               & (nfout,e1,e2,efermi,emin,emax,tot,totch,neg,MAXITR)
       end if
    end do occupied_ch_equals_totch
    if(iprioccup >= 2) &
         &write(nfout,'( " efermi = ", f10.4, " tot = ", f10.4)') efermi, tot


! ===================================== modified by K. Tagami ========== 11.0
!    call check_if_metalic(nfout,metalic_system)

    if ( noncol ) then
      call check_if_metalic_noncl(nfout,metalic_system)
    else
      call check_if_metalic(nfout,metalic_system)
    endif
! ======================================================================= 11.0

    if(iprioccup >= 2 .and. .not.metalic_system) then
       if(dabs(vbm) < 1.d6) then
          write(nfout,'( " The highest occupied band energy = ", f10.4)') vbm
       else
          write(nfout,'( " The highest occupied band energy is not calculated")')
       end if
    end if

    call tstatc0_end(id_sname)
  contains
    subroutine get_tot
      integer       :: k, i
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, totw,ent
      tot = 0.d0
      do k = 1, kv3_ek, af+1
         do i = 1, neg
            e = eko_ek(i,k)
            call width_methfessel_paxton(order_mp,e,efermi,width,dos,weight,ent)  ! -(b_Fermi)
            totw = weight*wspin*kv3_ek*qwgt_ek(k)
            tot = tot + 2*totw
         end do
      end do
      tot = tot/kv3_ek * (af+1)
      if(iprioccup >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12," jcount = ",i7)') efermi,tot, jcount
    end subroutine get_tot

! ======================================== added by K. Tagami ============ 11.0
    subroutine get_tot_noncl
      integer       :: k, i
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, totw, wktmp, ent

      tot = 0.d0
      wktmp = kv3_ek / ndim_spinor

      do k = 1, kv3_ek, ndim_spinor
         do i = 1, neg
            e = eko_ek(i,k)
            call width_methfessel_paxton(order_mp,e,efermi,width,dos,weight,ent)  ! -(b_Fermi)
            totw = weight *wspin *wktmp *qwgt_ek(k)
            tot = tot + totw
         end do
      end do
      tot = tot /wktmp
      if(iprioccup >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12," jcount = ",i7)') efermi,tot, jcount

    end subroutine get_tot_noncl
! ======================================================================= 11.0

  end subroutine m_ESoc_mp_ek

  subroutine m_ESoc_check_if_metalic(nfout)
!
!    Modified by T. Yamasaki   April/27/2007
!
    integer, intent(in) :: nfout
    integer :: way_of_smearing

    if(ekmode == ON .or. &
         & (icond>=FIXED_CHARGE .and. ekmode==OFF .and. fixed_charge_k_parallel == ONE_BY_ONE)) then
       way_of_smearing = m_CtrlP_way_of_smearing()
       if(way_of_smearing == PARABOLIC) then
          call m_ESoc_fermi_parabolic_ek(nfout)  ! -> efermi, metalic_system
!!$  else if(way_of_smearing == MP) then
!!$     call fermi_mesfessel_paxton(nfout)
       else if(way_of_smearing == TETRAHEDRON) then
          call m_ESoc_fermi_tetra_ek(nfout)     ! -> efermi, metalic_system

! ============================ KT_add ===================== 13.0E
       else if(way_of_smearing == Fermi_Dirac) then
          call m_ESoc_fermi_dirac_ek(nfout)
! ========================================================= 13.0E
       else if(way_of_smearing == MP) then
          call m_ESoc_mp_ek(nfout)
       else if(way_of_smearing == LOWEST_AT_EACH_KPT) then
         call phase_error_with_msg( nfout, &
              &  ' m_ESoc_check_if_metalic does not work with LOWEST_AT_EACH_KPT' &
              &   ,__LINE__,__FILE__)
      endif
    else
       way_of_smearing = m_CtrlP_way_of_smearing()
       if(way_of_smearing == PARABOLIC) then
          call m_ESoc_fermi_parabolic(nfout)
!!$  else if(way_of_smearing == MP) then
!!$     call fermi_mesfessel_paxton(nfout)
       else if(way_of_smearing == TETRAHEDRON) then
          call m_ESoc_fermi_tetrahedron(nfout)
       else if(way_of_smearing == COLD) then
          call m_ESoc_fermi_ColdSmearing(nfout)

! =========== KT_add=============================== 13.0E
       else if( way_of_smearing == Fermi_Dirac ) then
          call m_ESoc_fermi_Dirac(nfout)
! ============== ================================== 13.0E
       else if(way_of_smearing == MP) then
          call m_ESoc_methfessel_paxton(nfout)
       else if(way_of_smearing == LOWEST_AT_EACH_KPT) then
          call m_ESoc_occup_fix(nfout)
       end if
    end if

! ====================================== modified by K. Tagami ========== 11.0
!    call check_if_metalic(nfout,metalic_system)
    if ( noncol ) then
      call check_if_metalic_noncl(nfout,metalic_system)
    else
      call check_if_metalic(nfout,metalic_system)
    endif
! ====================================================================== 11.0

  end subroutine m_ESoc_check_if_metalic

  subroutine check_if_metalic(nfout,metalic)
!
!     Modified by T. Yamasaki   May/08/2007
!
    integer, intent(in) :: nfout
    logical, intent(out) :: metalic
    integer :: ieig, ie, ik, ihob0, kv3_t, way_of_smearing, is
    real(kind=DP) :: totw, emax, cbm, vbm0, weight0
    real(kind=DP), allocatable, dimension(:) :: ehob
    real(kind=DP), allocatable, dimension(:,:) :: eko_t, eko_mpi     ! d(neg,kv3|kv3_ek)
    real(kind=DP), allocatable, dimension(:,:) :: occup_t, occup_mpi ! d(neg,kv3|kv3_ek)
    integer, allocatable, dimension(:) :: ihob ! d(kv3|kv3_ek)

    if(ekmode == ON) then
       kv3_t = kv3_ek
    else
       kv3_t = kv3
    end if

    allocate(eko_t(neg,kv3_t))

    if(ekmode == ON) then
       eko_t = eko_ek
    else
       eko_t = 0.d0
       do is = ista_spin, iend_spin
       !do ik = 1, kv3
       do ik = is, kv3-nspin+is, nspin
          if(map_k(ik) /= myrank_k) cycle
          do ie = 1, neg
             if(map_e(ie) /= myrank_e) cycle
             eko_t(ie,ik) = eko_l(map_z(ie),ik)
          end do
       end do
       enddo
       if(npes > 1) then
          allocate(eko_mpi(neg,kv3_t))
          call mpi_allreduce(eko_t,eko_mpi,neg*kv3,mpi_double_precision &
               &               ,mpi_sum,MPI_CommGroup,ierr)
          eko_t = eko_mpi
          deallocate(eko_mpi)
       end if
    end if

    metalic = .false.

    allocate(ehob(kv3_t)); ehob = -999.d+20

    if(kv3_t/nspin >= 2) then
       allocate(ihob(kv3_t)); ihob = 0
       do is = 1, nspin
          do ik = is, kv3_t, nspin
             totw = 0.d0
             ihob(ik) = 0
             firstKpoint: do ieig = 1, neg
!!$                if(eko_t(ieig,is) < efermi) then
                if(eko_t(ieig,ik) <= efermi) then
                   totw = totw + 1.d0
                   ihob(ik) = ihob(ik) + 1
                   if(ehob(ik) < eko_t(ieig,ik)) ehob(ik) = eko_t(ieig,ik)
                end if
             end do firstKpoint
             totw = totw*2.d0
             if(iprioccup >= 2) write(nfout,'(" ---  ik = ",i3," ihob = ",i6," totw = ",f12.4," totch = ",f12.4)') &
                  & ik,ihob(ik),totw,totch
          end do
          do ik = nspin+is ,kv3_t, nspin
             if(ihob(ik) /= ihob(is)) then
                metalic = .true.
                exit
             end if
          end do
       end do
       deallocate(ihob)
    else
       do is = 1, nspin
          totw = 0.d0
          do ieig=1,neg
             if(eko_t(ieig,is) <= efermi) then
                if(ehob(is) < eko_t(ieig,is)) ehob(is) = eko_t(ieig,is)
             end if
          end do
       end do
    end if

    if(.not.metalic .and. ekmode == OFF) then
       allocate(occup_t(neg,kv3_t))

       occup_t = 0.d0
       do is = ista_spin, iend_spin
       !do ik = 1, kv3
       do ik = is, kv3-nspin+is, nspin
          if(map_k(ik) /= myrank_k) cycle
          do ie = 1, neg
             if(map_e(ie) /= myrank_e) cycle
             occup_t(ie,ik) = occup_l(map_z(ie),ik)
          end do
       end do
       end do
       if(npes > 1) then
          allocate(occup_mpi(neg,kv3_t))
          call mpi_allreduce(occup_t,occup_mpi,neg*kv3,mpi_double_precision &
               &               ,mpi_sum,MPI_CommGroup,ierr)
          occup_t = occup_mpi
          deallocate(occup_mpi)
       end if

       Kpoint2: do ik = 1 ,kv3_t
          ihob0 = 0; vbm0 = -999.d+20
          findvbm: do ieig=1, neg   ! finding Valence Band Maximum
             if(occup_t(ieig,ik) > DELTA10) then
                if(vbm0 < eko_t(ieig,ik)) then
                   vbm0 = eko_t(ieig,ik)
                   ihob0 = ieig
                end if
             end if
          end do findvbm
          weight0 = kv3*qwgt(ik)
          if(iprioccup >= 2) then
             write(nfout,'(" --- ihob0 = ",i8)') ik,ihob0
             if(ihob0 >= 1) write(nfout,'(" --- ik = ",i4," ihob0 = ",i8," vbm0, occup = "&
                  & ,2f10.5," weight0=",f8.4)') ik,ihob0,vbm0,occup_t(ihob0,ik),weight0
          end if
          if(ihob0 >= 1 .and. ihob0 <= neg) then
             if(occup_t(ihob0,ik) > DELTA10 .and. occup_t(ihob0,ik) < weight0-DELTA10) then
                metalic = .true.
                exit Kpoint2
             end if
          end if
       end do Kpoint2
       deallocate(occup_t)
    end if

    way_of_smearing = m_CtrlP_way_of_smearing()

    if(.not.metalic .or. way_of_smearing == Fermi_Dirac ) then
       cbm = 1.0D10
       Kpoint: do ik=1,kv3_t
          findcbm: do ieig = 1, neg
#if 0
             if(eko_t(ieig,ik) > efermi) then
                cbm = eko_t(ieig,ik)
                exit findcbm
             end if
#else
             if(eko_t(ieig,ik) > efermi) then
                cbm = min(eko_t(ieig,ik),cbm)
                exit findcbm
             end if
#endif
          end do findcbm

          if((way_of_smearing==PARABOLIC .and. cbm < efermi + width/2) &
               & .or. (way_of_smearing==TETRAHEDRON .and. cbm < efermi+DELTA10) &
! ========== KT_add================================= 13.0E
               & .or. (way_of_smearing==Fermi_Dirac .and. cbm < efermi +width/2) &
               & .or. (way_of_smearing==LOWEST_AT_EACH_KPT .and. cbm < efermi ) &
! ================================================== 13.0E
               & .or. (way_of_smearing==COLD .and. cbm < efermi + width/2)) then

             metalic = .true.
             if(iprioccup >= 2) then
                write(nfout,'(" --- cbm = ",f8.4," ik = ",i8)') cbm,ik
             end if
             exit Kpoint
          end if
       end do Kpoint
    end if

    if(metalic) then
       if(iprioccup>=1) write(nfout,'(" --- The system is metalic ---")')
! --------------------------- added by T. Hamada -------------------------
       system_is_not_metallic = .false.
! ------------------------------------------------------------------------
       if ( way_of_smearing == Fermi_Dirac ) then
          emax = maxval(ehob)
          if(iprioccup>=1) then
             write(nfout,'(A,f12.8)') " --- The highest band energy below Ef = ",emax
             write(nfout,'(A,f12.8)') "         lowest  band energy above Ef = ",cbm
             write(nfout,'(A,f12.8,A,f12.8,A)') &
                  &                   "                           Difference = ", &
                  &           (cbm -emax), " Ha   ( ", (cbm -emax)*Hartree, " eV )"
             write(nfout,*)
          endif
       endif
    else
       if(iprioccup>=1) write(nfout,'(" --- The system is insulating or semiconducting ---")')
       emax = maxval(ehob)
#if 0
       if(iprioccup>=1) write(nfout,'(" --- The highest occupied band energy (=vbm) = ",f12.8)') emax
#else
       if(iprioccup>=1) then
          write(nfout,'(A,f12.8)') " --- The highest  occupied band energy (=vbm) = ",emax
          write(nfout,'(A,f12.8)') "         lowest unoccupied band energy (=cbm) = ",cbm
          write(nfout,'(A,f12.8,A,f12.8,A)') &
               &           "                           estimated band gap = ", &
               &           (cbm -emax), " Ha   ( ", (cbm -emax)*Hartree, " eV )"
          write(nfout,*)
       endif
#endif
       vbm = emax
! -------------------------- added by T. Hamada --------------------------
       system_is_not_metallic = .true.
! ------------------------------------------------------------------------
    end if

    check_if_metalic_flag = .true.
! ------------------------- added by T. Hamada ---------------------------
    system_is_already_determined = .true.
!-------------------------------------------------------------------------a

    deallocate(ehob)
    deallocate(eko_t)

  end subroutine check_if_metalic

! ======================================= added by K. Tagami ========= 11.0
  subroutine check_if_metalic_noncl( nfout, metalic )
!
!     Modified by T. Yamasaki   May/08/2007
!
    integer, intent(in) :: nfout
    logical, intent(out) :: metalic
    integer :: ieig, ie, ik, ihob0, kv3_t, way_of_smearing, is

    integer  :: iksnl, iktmp

    real(kind=DP) :: totw, emax, cbm, vbm0, weight0
    real(kind=DP), allocatable, dimension(:) :: ehob
    real(kind=DP), allocatable, dimension(:,:) :: eko_t, eko_mpi     ! d(neg,kv3|kv3_ek)
    real(kind=DP), allocatable, dimension(:,:) :: occup_t, occup_mpi ! d(neg,kv3|kv3_ek)
    integer, allocatable, dimension(:) :: ihob ! d(kv3|kv3_ek)

    if(ekmode == ON) then
       kv3_t = kv3_ek
    else
       kv3_t = kv3
    end if

    allocate(eko_t(neg,kv3_t/ndim_spinor));  eko_t = 0.0d0

    if(ekmode == ON) then
! -------------------------- ktDEBUG ---------------------- 20121025
!       eko_t = eko_ek
!
       Do ik=1, kv3_t, ndim_spinor
          iksnl = ( ik -1 ) /ndim_spinor + 1
          eko_t(:,iksnl) = eko_ek(:,ik)
       End do
! -------------------------- ktDEBUG ---------------------- 20121025
    else
       eko_t = 0.d0
       do ik = 1, kv3, ndim_spinor
          if(map_k(ik) /= myrank_k) cycle
 	  iksnl = ( ik -1 )/ndim_spinor + 1
          do ie = 1, neg
             if(map_e(ie) /= myrank_e) cycle
             eko_t(ie,iksnl) = eko_l(map_z(ie),ik)
          end do
       end do
       if(npes > 1) then
          allocate(eko_mpi(neg,kv3_t/ndim_spinor))
!          call mpi_allreduce( eko_t, eko_mpi, neg*kv3/ndim_spinor, &
!	       &              mpi_double_precision, mpi_sum,MPI_CommGroup, ierr )
          call mpi_allreduce( eko_t, eko_mpi, neg*kv3/ndim_spinor, &
	       &              mpi_double_precision, mpi_sum,mpi_spin_group, ierr )
          eko_t = eko_mpi
          deallocate(eko_mpi)
       end if
    end if

    metalic = .false.

    allocate(ehob(kv3_t/ndim_spinor)); ehob = -999.d+20

    if ( kv3_t/ndim_spinor >= 2 ) then
       allocate(ihob(kv3_t/ndim_spinor)); ihob = 0

       do is = 1, 1
          do ik = 1, kv3_t /ndim_spinor
             totw = 0.d0
             ihob(ik) = 0
             firstKpoint: do ieig = 1, neg
!!$                if(eko_t(ieig,is) < efermi) then
                if(eko_t(ieig,ik) < efermi) then
                   totw = totw + 1.d0
                   ihob(ik) = ihob(ik) + 1
                   if(ehob(ik) < eko_t(ieig,ik)) ehob(ik) = eko_t(ieig,ik)
                end if
             end do firstKpoint

             if(iprioccup >= 2) write(nfout,'(" ---  ik = ",i3," ihob = ",i6," totw = ",f12.4," totch = ",f12.4)') &
                  & ik,ihob(ik),totw,totch
          end do
          do ik = 1+is, kv3_t/ndim_spinor
             if(ihob(ik) /= ihob(is)) then
                metalic = .true.
                exit
             end if
          end do
       end do
       deallocate(ihob)
    else
       do is = 1, 1
          totw = 0.d0
          do ieig=1,neg
             if(eko_t(ieig,is) < efermi) then
                if(ehob(is) < eko_t(ieig,is)) ehob(is) = eko_t(ieig,is)
             end if
          end do
       end do
    end if

    if(.not.metalic .and. ekmode == OFF) then
       allocate(occup_t(neg,kv3_t/ndim_spinor))

       occup_t = 0.d0
       do ik = 1, kv3, ndim_spinor
          if(map_k(ik) /= myrank_k) cycle
	  iksnl = ( ik -1 )/ndim_spinor + 1
          do ie = 1, neg
             if(map_e(ie) /= myrank_e) cycle
             occup_t(ie,iksnl) = occup_l(map_z(ie),ik)
          end do
       end do
       if(npes > 1) then
          allocate(occup_mpi( neg, kv3_t/ndim_spinor ))
!          call mpi_allreduce( occup_t, occup_mpi, neg*kv3/ndim_spinor, &
!	       &              mpi_double_precision, mpi_sum,MPI_CommGroup, ierr )
          call mpi_allreduce( occup_t, occup_mpi, neg*kv3/ndim_spinor, &
	       &              mpi_double_precision, mpi_sum,mpi_spin_group, ierr )
          occup_t = occup_mpi
          deallocate(occup_mpi)
       end if

       Kpoint2: do ik = 1 ,kv3_t /ndim_spinor
          ihob0 = 0; vbm0 = -999.d+20
          findvbm: do ieig=1, neg   ! finding Valence Band Maximum
             if(occup_t(ieig,ik) > DELTA10) then
                if(vbm0 < eko_t(ieig,ik)) then
                   vbm0 = eko_t(ieig,ik)
                   ihob0 = ieig
                end if
             end if
          end do findvbm

! -------------------------- ktDEBUG ---------------------- 20121027
!          weight0 = kv3 /ndim_spinor *qwgt(ik)
!
          iktmp = ndim_spinor*(ik-1) +1
          weight0 = kv3 /ndim_spinor *qwgt( iktmp )
! -------------------------- ktDEBUG ---------------------- 20121027
!
          if(iprioccup >= 2) then
             write(nfout,'(" --- ihob0 = ",i8)') ik,ihob0
             if(ihob0 >= 1) write(nfout,'(" --- ik = ",i4," ihob0 = ",i8, &
	   &              " vbm0, occup = " ,2f10.5," weight0=",f8.4)') &
	   &                ndim_spinor *ik -1, ihob0, vbm0, &
	   &                occup_t(ihob0,ik), weight0
          end if
          if(ihob0 >= 1 .and. ihob0 <= neg) then
             if(occup_t(ihob0,ik) > DELTA10 .and. occup_t(ihob0,ik) < weight0-DELTA10) then
                metalic = .true.
                exit Kpoint2
             end if
          end if
       end do Kpoint2
       deallocate(occup_t)
    end if

    way_of_smearing = m_CtrlP_way_of_smearing()

    if(.not.metalic .or. way_of_smearing == Fermi_Dirac ) then
       cbm = 1.0D10
       Kpoint: do ik= 1, kv3_t /ndim_spinor
          findcbm: do ieig = 1, neg
#if 0
             if(eko_t(ieig,ik) > efermi) then
                cbm = eko_t(ieig,ik)
                exit findcbm
             end if
#else
             if(eko_t(ieig,ik) > efermi) then
                cbm = min(eko_t(ieig,ik),cbm)
                exit findcbm
             end if
#endif
          end do findcbm

          if((way_of_smearing==PARABOLIC .and. cbm < efermi + width/2) &
               & .or. (way_of_smearing==TETRAHEDRON .and. cbm < efermi+DELTA10) &
! =================== KT_add ================ 13.0E
               & .or. (way_of_smearing==Fermi_Dirac .and. cbm < efermi +width/2 ) &
               & .or. (way_of_smearing==LOWEST_AT_EACH_KPT .and. cbm < efermi ) &
! =========================================== 13.0E
               & .or. (way_of_smearing==COLD .and. cbm < efermi + width/2)) then

             metalic = .true.
             if(iprioccup >= 2) then
                write(nfout,'(" --- cbm = ",f8.4," ik = ",i8)') cbm, ndim_spinor *ik -1
             end if
             exit Kpoint
          end if
       end do Kpoint
    end if

    if(metalic) then
       if(iprioccup>=1) write(nfout,'(" --- The system is metalic ---")')
       if ( way_of_smearing == Fermi_Dirac ) then
          emax = maxval(ehob)
          if(iprioccup>=1) then
             write(nfout,'(A,f12.8)') " --- The highest band energy below Ef = ",emax
             write(nfout,'(A,f12.8)') "         lowest  band energy above Ef = ",cbm
             write(nfout,'(A,f12.8,A,f12.8,A)') &
                  &                   "                           Difference = ", &
                  &           (cbm -emax), " Ha   ( ", (cbm -emax)*Hartree, " eV )"
             write(nfout,*)
          endif
       endif
    else
       if(iprioccup>=1) write(nfout,'(" --- The system is insulating or semiconducting ---")')
       emax = maxval(ehob)
#if 0
       if(iprioccup>=1) write(nfout,'(" --- The highest occupied band energy (=vbm) = ",f12.8)') emax
#else
       if(iprioccup>=1) then
          write(nfout,'(A,f12.8)') " --- The highest  occupied band energy (=vbm) = ",emax
          write(nfout,'(A,f12.8)') "         lowest unoccupied band energy (=cbm) = ",cbm
          write(nfout,'(A,f12.8,A,f12.8,A)') &
               &           "                           estimated band gap = ", &
               &           (cbm -emax), " Ha   ( ", (cbm -emax)*Hartree, " eV )"
          write(nfout,*)
       endif
#endif
       vbm = emax
    end if

    check_if_metalic_flag = .true.

    deallocate(ehob)
    deallocate(eko_t)

  end subroutine check_if_metalic_noncl
!================================================================ 11.0

  subroutine m_ESoc_fermi_ColdSmearing(nfout)
!
!  An if-block of "if(imag == FERRO .and. sw_fix_total_spin == YES .and. nspin == 2) then",
! which defines efermi_spin and occup_l with fixing total spin, is coded.
!                        by T. Yamasaki   April/10/2007
!
    integer, intent(in) :: nfout

    integer             :: jcount, ik, ie, is
    real(kind=DP)       :: emin, emax, e1, e2, tot, totch_spin(2), totch_spin0(2)
    real(kind=DP), parameter :: DELTA_TOTCH = 1.d-10
    integer,       parameter :: MAXITR = 100000
    real(kind=DP),allocatable, dimension(:,:) :: temp_mpi, eko_mpi, occup_mpi  ! MPI

    integer :: id_sname = -1, id_sname2 = -1

! ================================= added by K. Tagami ===================== 11.0
    integer  :: iksnl
! =========================================================================== 11.0

    call tstatc0_begin('barrier(m_Eoc_fermi_ColdSmearing) ',id_sname2)
    if(npes > 1) call mpi_barrier(MPI_CommGroup,ierr)
    call tstatc0_end(id_sname2)

    call tstatc0_begin('m_ESoc_fermi_ColdSmearing ', id_sname)

    call check_totch(nfout)           ! -(m_ES_occup) totch will be checked

! ==================================== added by K. Tagami =============== 11.0
!                               ( just in case )
! ---
    if ( noncol ) then
       do ik = 1, kv3, ndim_spinor
          Do is=2, ndim_spinor
            if ( map_k(ik+is-1) /= myrank_k ) cycle
             do ie = 1, neg
                if(map_e(ie) /= myrank_e) cycle
!
                eko_l(map_z(ie),ik +is -1 ) = 1.0D15
             End do
          End do
       end do
    endif
! ======================================================================= 11.0

! ===================================== modified by K. Tagami ========= 11.0
!    allocate(eko_mpi  (neg,kv3)); eko_mpi = 0.d0
!    allocate(occup_mpi(neg,kv3)); occup_mpi = 0.d0
!
    if ( noncol ) then
      allocate(eko_mpi  (neg,kv3/ndim_spinor)); eko_mpi = 0.d0
      allocate(occup_mpi(neg,kv3)); occup_mpi = 0.d0
    else
      allocate(eko_mpi  (neg,kv3)); eko_mpi = 0.d0
      allocate(occup_mpi(neg,kv3)); occup_mpi = 0.d0
    endif
! ======================================================================= 11.0

! ==================================== modified by K. Tagami =========== 11.0
!    !  MPI Gather eko_l
!    if(npes >= 2) then                                 ! MPI
!       allocate(temp_mpi (neg,kv3)); temp_mpi = 0.d0      ! MPI
!       do ik = 1, kv3                                     ! MPI
!          if(map_k(ik) /= myrank_k) cycle                 ! MPI
!          do ie = 1, neg                                  ! MPI
!             if(map_e(ie) /= myrank_e) cycle              ! MPI
!             temp_mpi(ie,ik) = eko_l(map_z(ie),ik)        ! MPI
!          end do                                          ! MPI
!       end do                                             ! MPI
!       call mpi_allreduce(temp_mpi,eko_mpi,neg*kv3,mpi_double_precision &  ! MPI
!            &            ,mpi_sum,MPI_CommGroup,ierr)                     ! MPI
!       deallocate(temp_mpi )
!    else                                               ! MPI
!       eko_mpi = eko_l                                 ! MPI
!    end if                                             ! MPI
! --
    if ( noncol ) then
      if ( npes >= 2) then
         allocate(temp_mpi(neg,kv3/ndim_spinor)); temp_mpi = 0.d0
         do ik = 1, kv3, ndim_spinor
            if ( map_k(ik) /= myrank_k ) cycle
            iksnl = ( ik-1 )/ndim_spinor +1

            do ie = 1, neg
              if ( map_e(ie) /= myrank_e ) cycle
              temp_mpi(ie,iksnl) = eko_l(map_z(ie),ik)
            end do
         end do
!         call mpi_allreduce( temp_mpi, eko_mpi, neg*kv3/ndim_spinor, &
!                       	&    mpi_double_precision, mpi_sum,MPI_CommGroup, ierr )
         call mpi_allreduce( temp_mpi, eko_mpi, neg*kv3/ndim_spinor, &
                       	&    mpi_double_precision, mpi_sum,mpi_spin_group, ierr )
         deallocate( temp_mpi )
      else
         Do ik=1, kv3, ndim_spinor
            iksnl = ( ik-1 )/ndim_spinor +1
            eko_mpi(:,iksnl) = eko_l(:,ik)
         End do
      end if
    else
      if ( npes >= 2 ) then                                 ! MPI
         allocate(temp_mpi (neg,kv3)); temp_mpi = 0.d0      ! MPI
         do is = ista_spin, iend_spin
!         do ik = 1, kv3                                     ! MPI
         do ik = is, kv3-nspin+is, nspin
            if(map_k(ik) /= myrank_k) cycle                 ! MPI
            do ie = 1, neg                                  ! MPI
              if(map_e(ie) /= myrank_e) cycle              ! MPI
               temp_mpi(ie,ik) = eko_l(map_z(ie),ik)        ! MPI
           end do                                          ! MPI
         end do                                             ! MPI
         enddo
         call mpi_allreduce(temp_mpi,eko_mpi,neg*kv3,mpi_double_precision &  ! MPI
            &            ,mpi_sum,MPI_CommGroup,ierr)                     ! MPI
         deallocate(temp_mpi )
      else                                               ! MPI
         eko_mpi = eko_l                                 ! MPI
      end if                                             ! MPI
    end if
! ========================================================================= 11.0

    emin = minval(eko_mpi)
    emax = maxval(eko_mpi)

    efermi = emax
    e1 = emin - dabs(DELTA_FermiSearchRange)
    e2 = emax + dabs(DELTA_FermiSearchRange)

    jcount = 1
    occupied_ch_equals_totch : do

! ============================== modified by K. Tagami ============ 11.0
!       call get_occup_l_and_tot(1,1,efermi,.true.)
!                                    ! -(contained here) ->(occup_l,tot)
       if ( noncol ) then
          call get_occup_l_and_tot_noncl_cld(efermi,.true. )
       else
          call get_occup_l_and_tot(1,1,efermi,.true. )
       endif
! ================================================================== 11.0

!          ~~~~~~~~~~~~~~~~~~~~
       if(jcount == 1 .and. tot < totch) &
            call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
       if(dabs(tot - totch) < DELTA_TOTCH) exit occupied_ch_equals_totch
       if( tot < totch) then
          e1 = efermi; efermi = efermi + (e2-efermi)/2
       else
          e2 = efermi; efermi = efermi + (e1-efermi)/2
       end if
       jcount = jcount + 1
       if(jcount > MAXITR) then
          call wd_fermi_error2 &   !-(b_Fermi)
               & (nfout,e1,e2,efermi,emin,emax,tot,totch,neg,MAXITR)
       end if
    end do occupied_ch_equals_totch
    if(iprioccup >= 2) &
         &write(nfout,'( "== Cold Smearing Method ==")')
    if(iprioccup >= 2) &
         &write(nfout,'( " efermi = ", f10.4, " tot = ", f10.4)') efermi, tot

! ============================================== modified by K. Tagami ==== 11.0
!    call get_entropic_term(band_entropy)
!
    if ( noncol ) then
       call get_entropic_term_noncl(band_entropy)
    else
       call get_entropic_term(band_entropy)
    endif
! ======================================================================= 11.0

    if(iprioccup >= 2) &
         &write(nfout,'( " band_entropy = ", f20.14)') band_entropy


    if(imag == FERRO .and. sw_fix_total_spin == YES .and. nspin == 2) then
       if(total_spin > totch) then
          write(nfout,'( " !WARNING total_spin should be smaller than totch <<m_ESoc_fermi_parabolic>>")')

          totch_spin(1) = totch
          totch_spin(2) = totch
       else
          totch_spin(1) = (totch + total_spin)*1.0d0
          totch_spin(2) = (totch - total_spin)*1.0d0
       end if

       do is = 1, nspin
          emin = minval(eko_mpi)
          emax = maxval(eko_mpi)

          efermi_spin(is) = emax
          e1 = emin - dabs(DELTA_FermiSearchRange)
          e2 = emax + dabs(DELTA_FermiSearchRange)

          jcount = 1
          occupied_ch_equals_totch2 : do

             call get_occup_l_and_tot(nspin,is,efermi_spin(is),.true.)      ! -(contained here) ->(occup_l,tot)
!                ~~~~~~~~~~~~~~~~~~~~
             if(jcount == 1 .and. tot < totch_spin(is)) &
                  call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
             if(dabs(tot - totch_spin(is)) < DELTA_TOTCH) exit occupied_ch_equals_totch2
             if( tot < totch_spin(is)) then
                e1 = efermi_spin(is); efermi_spin(is) = (efermi_spin(is) + e2)*0.5d0
             else
                e2 = efermi_spin(is); efermi_spin(is) = (efermi_spin(is) + e1)*0.5d0
             end if
             jcount = jcount + 1
             if(jcount > MAXITR) then
                call wd_fermi_error2 &   !-(b_Fermi)
                     & (nfout,e1,e2,efermi_spin(is),emin,emax,tot,totch_spin(is),neg,MAXITR)
             end if
          end do occupied_ch_equals_totch2
          if(iprioccup >= 2) &
               &write(nfout,'( "== Cold smearing Method ==")')
          if(iprioccup >= 2) &
               &write(nfout,'( " efermi_spin(",i2," ) = ", f10.4, ", tot/2 = ", f10.4)') &
               & is,efermi_spin(is), tot/2
       end do
       call get_total_spin0
       if(iprioccup >= PRINTOUTLEVEL_TOTCH_SPIN) &
            & call wd_efermi_and_total_spin0_Plus(nfout,total_spin0,totch_spin0,totch_spin)
       efermi = (efermi_spin(1)+efermi_spin(2))*0.5d0
    else if(imag == FERRO .and. sw_fix_total_spin == NO .and. nspin == 2) then
       call get_total_spin0
       if(iprioccup >= PRINTOUTLEVEL_TOTCH_SPIN) call wd_efermi_and_total_spin0(nfout,total_spin0,totch_spin0)
    end if

    do ik = ista_k, iend_k                              ! MPI
       do ie = 1, neg                                   ! MPI
          if(map_e(ie) == myrank_e) then                ! MPI
             occup_l(map_z(ie),ik) = occup_mpi(ie,ik)   ! MPI
          end if                                        ! MPI
       end do                                           ! MPI
    end do                                              ! MPI

    if(imag == FERRO .and. nspin == 2) then
       ie = 2
       if(sw_fix_total_spin == YES) call check_occupation(nfout,ie,totch_spin)
    else if(imag /= FERRO) then
       ie = 1
       totch_spin0(1) = totch
    end if


! ============================ modified by K. Tagami ================== 11.0
!    call check_occupation(nfout,ie,totch_spin0)
!
    if ( noncol ) then
       call check_occupation_noncl(nfout,totch_spin0)
    else
       call check_occupation(nfout,ie,totch_spin0)
    endif
! ====================================================================== 11.0

    if ( af == 1 ) then
       Do ik=ista_k, iend_k, nspin
          occup_l(:,ik+1) = occup_l(:,ik)
       End Do
    endif

    deallocate(eko_mpi  )
    deallocate(occup_mpi)

    call tstatc0_end(id_sname)
  contains
! --> T. Yamasaki, 17th Aug. 2009
    subroutine get_total_spin0
      do is = 1, nspin
         call get_occup_l_and_tot(nspin,is,efermi,.false.)
         totch_spin0(is) = tot
      end do
      total_spin0 = (totch_spin0(1) - totch_spin0(2))*0.5d0
    end subroutine get_total_spin0
! <--
    subroutine get_occup_l_and_tot(nspin,is,efermi,update_occ)
      integer, intent(in) :: nspin, is
      real(kind=DP), intent(in) :: efermi
      logical,intent(in) :: update_occ
      integer       :: k, i
      real(kind=DP) :: wspin = 1.d0, e, dos, weight,tmp
      tot = 0.d0
!!$      do k = 1, kv3, af+1
      do k = is, kv3, max(nspin,af+1)
         do i = 1, neg
            e = eko_mpi(i,k)
            call coldsmearing(e,efermi,width,dos,weight)
!            occup_mpi(i,k) = weight*wspin*kv3*qwgt(k)
            tmp = weight*wspin*kv3*qwgt(k)
            if(update_occ) occup_mpi(i,k) = tmp
            tot = tot + 2*tmp
         end do
      end do
      if(af == 1) then
         tot = tot/kv3 * (af+1)
      else
         tot = tot/(kv3/nspin)
      end if
      if(ipri >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12)') efermi,tot
    end subroutine get_occup_l_and_tot

! ================================ added by K. Tagami ========= 11.0
    subroutine get_occup_l_and_tot_noncl_cld( efermi, update_occ )
      real(kind=DP), intent(in) :: efermi
      logical,intent(in) :: update_occ

      integer       :: k, i, iktmp, iksnl
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, wktmp, ctmp

      tot = 0.d0;   occup_mpi = 0.0d0
      wktmp = kv3/ndim_spinor

      do k = 1, kv3, ndim_spinor
         do i = 1, neg
            e = eko_mpi(i,iksnl)
            call coldsmearing(e,efermi,width,dos,weight)
            ctmp = weight *wspin *wktmp *qwgt(k)
            if(update_occ) occup_mpi(i,k) = ctmp
            tot = tot + ctmp
         end do
      end do
      tot = tot / wktmp
      if(ipri >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12)') efermi,tot
    end subroutine get_occup_l_and_tot_noncl_cld
! ============================================================== 11.0

    subroutine coldsmearing(e,efermi,width,dos,weight)
      real(kind=DP), intent(in) :: e,efermi,width
      real(kind=DP), intent(out) :: dos,weight

      real(kind=DP) :: xi,xx,xf,ex
      real(kind=DP), parameter :: msq2 = -1.4142135623730950488d0 ! -sqrt(2)
      real(kind=DP), parameter :: msq2i = -0.7071067811865475244d0  ! -1/sqrt(2)
      real(kind=DP), parameter :: sqpii = 0.56418958354775628695d0 ! 1/sqrt(pi)
      real(kind=DP), parameter :: sq2pii = 0.39894228040143267794d0 ! 1/sqrt(2pi)

      real(kind=DP) :: derfc

      xi = (efermi-e)/width
      xx = xi+msq2i
      ex = exp(-xx*xx)
      xf = (2.d0+msq2*xi)

      dos = sqpii*ex*xf/width
      weight = sq2pii*ex+0.5d0*derfc(-xx)

    end subroutine coldsmearing

    subroutine get_entropic_term(s)
      real(kind=DP), intent(out) :: s

      integer       :: k, i
      real(kind=DP) :: e, entropy
      s = 0.d0
      do k = 1, kv3, af+1
         do i = 1, neg
            e = eko_mpi(i,k)
            call get_entropy(e,efermi,width,entropy)
            s = s + 2.d0*entropy*qwgt(k)
         end do
      end do
      s = s * (af+1)
    end subroutine get_entropic_term

! ============================ added by K. Tagami =============== 11.0
    subroutine get_entropic_term_noncl(s)
      real(kind=DP), intent(out) :: s

      integer       :: k, i
      real(kind=DP) :: e, entropy
      s = 0.d0
      do k = 1, kv3, ndim_spinor
         do i = 1, neg
            e = eko_mpi(i,k)
            call get_entropy(e,efermi,width,entropy)
            s = s + 1.d0*entropy*qwgt(k)
         end do
      end do
    end subroutine get_entropic_term_noncl
! ================================================================== 11.0

    subroutine get_entropy(e,efermi,width,entropy)
      real(kind=DP), intent(in) :: e,efermi,width
      real(kind=DP), intent(out) :: entropy

      real(kind=DP) :: xi,xx,xf,ex
      real(kind=DP), parameter :: msq2 = -1.4142135623730950488d0 ! -sqrt(2)
      real(kind=DP), parameter :: msq2i = -0.7071067811865475244d0  ! -1/sqrt(2)
      real(kind=DP), parameter :: sqpi2i = 0.28209479177387814347d0 ! 1/(2*sqrt(pi))

      xi = (efermi-e)/width
      xx = xi+msq2i
      ex = exp(-xx*xx)
      xf = (1.d0+msq2*xi)

      entropy = sqpi2i*ex*xf

    end subroutine get_entropy

  end subroutine m_ESoc_fermi_ColdSmearing
!$$#endif

  subroutine m_ESoc_set_nEwindows_pc_ek(nfout,nEwindows,eorig)
    integer, intent(in) :: nfout
    integer, intent(out) :: nEwindows
    real(kind=DP), intent(in), optional :: eorig
    real(kind=DP) :: emin, emax, emin_rev, emax_rev, e0
    integer :: nvb_windows, ncb_windows, iw, ie, ik

    emin = minval(eko_ek)
    emax = maxval(eko_ek)

    if(metalic_system)  e_origin = efermi
    if(.not.metalic_system) e_origin = vbm + 1.d-10
    if(present(eorig)) e_origin = eorig
    if(ipri >= 1) then
       write(nfout,'(" !pc e_origin = ",f9.6," <<m_ESoc_set_nEwindows_pc>>")') e_origin
       write(nfout,'(" !pc emin, emax = ",2f9.6)') emin, emax
    end if

    emin_rev = emin - e_origin
    emax_rev = emax - e_origin
    if(partial_charge_Emin > emin_rev) emin_rev = partial_charge_Emin
    if(partial_charge_Emax < emax_rev) emax_rev = partial_charge_Emax

    e0 = 0.d0
    if(emax_rev < 0.0) e0 = emax_rev
    nvb_windows = (e0-emin_rev)/partial_charge_deltaE + 1
    if(nvb_windows < 0) nvb_windows = 0
    emin_rev = e0 - nvb_windows*partial_charge_deltaE

    e0 = 0.d0
    if(emin_rev > 0.0) e0 = emin_rev
    ncb_windows = (emax_rev - e0)/partial_charge_deltaE + 1
    if(ncb_windows < 0) ncb_windows = 0

    nEwindows_pc = nvb_windows + ncb_windows
    nEwindows = nEwindows_pc
    allocate(Ewindows_partial_charge(nEwindows_pc,2))
    Ewindows_partial_charge(1,1) = emin_rev + e_origin
    do iw = 2, nEwindows_pc
       Ewindows_partial_charge(iw,1) = Ewindows_partial_charge(iw-1,1) + partial_charge_deltaE
       Ewindows_partial_charge(iw-1,2) = Ewindows_partial_charge(iw,1)
    end do
    Ewindows_partial_charge(nEwindows_pc,2) = Ewindows_partial_charge(nEwindows_pc,1) + partial_charge_deltaE

    allocate(if_elec_state(nEwindows_pc)); if_elec_state = NO

    do iw = 1, nEwindows_pc
       emin = Ewindows_partial_charge(iw,1); emax = Ewindows_partial_charge(iw,2)

       if ( noncol ) then
         Kloop: do ik = 1, kv3_ek/ndim_spinor
            do ie = 1, neg
               if(emin < eko_ek(ie,ik) .and. eko_ek(ie,ik) < emax) then
                  if_elec_state(iw) = YES
                  exit Kloop
               end if
            end do
         end do Kloop
       else
         Kloop2: do ik = 1, kv3_ek
            do ie = 1, neg
               if(emin < eko_ek(ie,ik) .and. eko_ek(ie,ik) < emax) then
                  if_elec_state(iw) = YES
                  exit Kloop2
               end if
            end do
         end do Kloop2
      endif
! =========================================================================== 11.0
    end do

    if(ipri >= 1) then
    nEwindows_pc = nvb_windows + ncb_windows
       write(nfout,'(" !pc nEwindows = ",i4,", nvb_windows = ",i4,", ncb_windows = ",i4 &
            & ," <<m_ESoc_set_nEwindows_pc>>")') nEwindows_pc, nvb_windows, ncb_windows
       write(nfout,'(" !pc",4x,"iw",2x,"if_elec_state",16x,"erange(hartree)",24x,"erange(eV)")')
       write(nfout,'(" !pc",29x,"(asis)",18x,"(shifted)",13x,"(shifted)")')
       do iw = 1, nEwindows_pc
          write(nfout,'(" !pc ",i5,7x,i1,7x,"(",2f10.6," )",1x,"(",2f10.6," )",1x,"(",2f10.6," )")') &
               &   iw, if_elec_state(iw) &
               & , Ewindows_partial_charge(iw,1),Ewindows_partial_charge(iw,2) &
               & , Ewindows_partial_charge(iw,1)-e_origin &
               & , Ewindows_partial_charge(iw,2)-e_origin &
               & , (Ewindows_partial_charge(iw,1)-e_origin)*HARTREE &
               & , (Ewindows_partial_charge(iw,2)-e_origin)*HARTREE
       end do
    end if

  end subroutine m_ESoc_set_nEwindows_pc_ek

  subroutine m_ESoc_set_nEwindows_pc(nfout,nEwindows,eorig)
    integer, intent(in) :: nfout
    integer, intent(out) :: nEwindows
    real(kind=DP), intent(in), optional :: eorig
    real(kind=DP) :: emin, emax, emin_rev, emax_rev, e0
    integer :: nvb_windows, ncb_windows, iw, ie, ik
    real(kind=DP),allocatable, dimension(:,:) :: eko_tmp

! ================================ modified by K. Tagami ============ 11.0
!    allocate(eko_tmp(neg,kv3)); eko_tmp = 0.d0
!    call find_emin_emax(emin,emax,eko_tmp)

    if ( noncol ) then
      allocate(eko_tmp(neg,kv3/ndim_spinor)); eko_tmp = 0.d0
      call find_emin_emax_noncl( emin,emax,eko_tmp )
    else
      allocate(eko_tmp(neg,kv3)); eko_tmp = 0.d0
      call find_emin_emax(emin,emax,eko_tmp)
    endif
! ================================================================== 11.0

    if(metalic_system)  e_origin = efermi
    if(.not.metalic_system) e_origin = vbm + 1.d-10
    if(present(eorig)) e_origin = eorig
    if(ipri >= 1) then
       write(nfout,'(" !pc e_origin = ",f9.6," <<m_ESoc_set_nEwindows_pc>>")') e_origin
       write(nfout,'(" !pc emin, emax = ",2f9.6)') emin, emax
    end if

    emin_rev = emin - e_origin
    emax_rev = emax - e_origin
    if(partial_charge_Emin > emin_rev) emin_rev = partial_charge_Emin
    if(partial_charge_Emax < emax_rev) emax_rev = partial_charge_Emax

    e0 = 0.d0
    if(emax_rev < 0.0) e0 = emax_rev
    nvb_windows = (e0-emin_rev)/partial_charge_deltaE + 1
    if(nvb_windows < 0) nvb_windows = 0
    emin_rev = e0 - nvb_windows*partial_charge_deltaE

    e0 = 0.d0
    if(emin_rev > 0.0) e0 = emin_rev
    ncb_windows = (emax_rev - e0)/partial_charge_deltaE + 1
    if(ncb_windows < 0) ncb_windows = 0

    nEwindows_pc = nvb_windows + ncb_windows
    nEwindows = nEwindows_pc
    allocate(Ewindows_partial_charge(nEwindows_pc,2))
    Ewindows_partial_charge(1,1) = emin_rev + e_origin
    do iw = 2, nEwindows_pc
       Ewindows_partial_charge(iw,1) = Ewindows_partial_charge(iw-1,1) + partial_charge_deltaE
       Ewindows_partial_charge(iw-1,2) = Ewindows_partial_charge(iw,1)
    end do
    Ewindows_partial_charge(nEwindows_pc,2) = Ewindows_partial_charge(nEwindows_pc,1) + partial_charge_deltaE

    allocate(if_elec_state(nEwindows_pc)); if_elec_state = NO

    do iw = 1, nEwindows_pc
       emin = Ewindows_partial_charge(iw,1); emax = Ewindows_partial_charge(iw,2)

! ========================================== modified by K. Tagami ========== 11.0
!       Kloop: do ik = 1, kv3
!          do ie = 1, neg
!             if(emin < eko_tmp(ie,ik) .and. eko_tmp(ie,ik) < emax) then
!                if_elec_state(iw) = YES
!                exit Kloop
!             end if
!          end do
!       end do Kloop
!
       if ( noncol ) then
         Kloop: do ik = 1, kv3/ndim_spinor
            do ie = 1, neg
               if(emin < eko_tmp(ie,ik) .and. eko_tmp(ie,ik) < emax) then
                  if_elec_state(iw) = YES
                  exit Kloop
               end if
            end do
         end do Kloop
       else
         Kloop2: do ik = 1, kv3
            do ie = 1, neg
               if(emin < eko_tmp(ie,ik) .and. eko_tmp(ie,ik) < emax) then
                  if_elec_state(iw) = YES
                  exit Kloop2
               end if
            end do
         end do Kloop2
      endif
! =========================================================================== 11.0
    end do

    if(ipri >= 1) then
    nEwindows_pc = nvb_windows + ncb_windows
       write(nfout,'(" !pc nEwindows = ",i4,", nvb_windows = ",i4,", ncb_windows = ",i4 &
            & ," <<m_ESoc_set_nEwindows_pc>>")') nEwindows_pc, nvb_windows, ncb_windows
       write(nfout,'(" !pc",4x,"iw",2x,"if_elec_state",16x,"erange(hartree)",24x,"erange(eV)")')
       write(nfout,'(" !pc",29x,"(asis)",18x,"(shifted)",13x,"(shifted)")')
       do iw = 1, nEwindows_pc
          write(nfout,'(" !pc ",i5,7x,i1,7x,"(",2f10.6," )",1x,"(",2f10.6," )",1x,"(",2f10.6," )")') &
               &   iw, if_elec_state(iw) &
               & , Ewindows_partial_charge(iw,1),Ewindows_partial_charge(iw,2) &
               & , Ewindows_partial_charge(iw,1)-e_origin &
               & , Ewindows_partial_charge(iw,2)-e_origin &
               & , (Ewindows_partial_charge(iw,1)-e_origin)*HARTREE &
               & , (Ewindows_partial_charge(iw,2)-e_origin)*HARTREE
       end do
    end if

    deallocate(eko_tmp)

  end subroutine m_ESoc_set_nEwindows_pc

  subroutine find_emin_emax(emin,emax,eko_tmp)
     real(kind=DP), intent(out) :: emin, emax
     real(kind=DP), intent(out), dimension(neg,kv3) :: eko_tmp

     integer :: ik, ie, ispin
     real(kind=DP),allocatable, dimension(:,:) :: temp_mpi ! MPI

     if(npes >=2 ) then
        allocate(temp_mpi(neg,kv3)); temp_mpi = 0.d0
        do ispin = ista_spin, iend_spin
        do ik = ispin, kv3-nspin+ispin, nspin

          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          do ie = 1, neg                                  ! MPI
             if(map_e(ie) /= myrank_e) cycle              ! MPI
             temp_mpi(ie,ik) = eko_l(map_z(ie),ik)        ! MPI
          end do                                          ! MPI
        end do                                            ! MPI
        end do                                            ! MPI
        call mpi_allreduce(temp_mpi,eko_tmp,neg*kv3,mpi_double_precision &  ! MPI
             &            ,mpi_sum,MPI_CommGroup,ierr)                      ! MPI
        deallocate(temp_mpi )
     else
        eko_tmp = eko_l
     end if
     emin = minval(eko_tmp)
     emax = maxval(eko_tmp)
  end subroutine find_emin_emax

! ======================================= added by K. Tagami ============== 11.0
  subroutine find_emin_emax_noncl( emin,emax,eko_tmp )
     real(kind=DP), intent(out) :: emin, emax
     real(kind=DP), intent(out), dimension(neg,kv3/ndim_spinor) :: eko_tmp

     integer :: ik, ie, iksnl
     real(kind=DP),allocatable, dimension(:,:) :: temp_mpi ! MPI

     if(npes >=2 ) then
        allocate(temp_mpi(neg,kv3/ndim_spinor)); temp_mpi = 0.d0

        do ik = 1, kv3, ndim_spinor
          if(map_k(ik) /= myrank_k) cycle
	  iksnl = ( ik - 1 )/ndim_spinor + 1
          do ie = 1, neg
             if(map_e(ie) /= myrank_e) cycle
             temp_mpi(ie,iksnl) = eko_l(map_z(ie),ik)
          end do
        end do
!        call mpi_allreduce( temp_mpi, eko_tmp, neg*kv3/ndim_spinor, &
!	  &                 mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )
        call mpi_allreduce( temp_mpi, eko_tmp, neg*kv3/ndim_spinor, &
	  &                 mpi_double_precision, mpi_sum, mpi_spin_group, ierr )
        deallocate(temp_mpi )
     else
        do ik = 1, kv3, ndim_spinor
	  iksnl = ( ik -1 )/ndim_spinor + 1
          eko_tmp(:,iksnl) = eko_l(:,ik)
	end do
     end if
     emin = minval(eko_tmp);   emax = maxval(eko_tmp)
  end subroutine find_emin_emax_noncl
! ========================================================================= 11.0

  subroutine m_ESoc_keep_occup()
     integer :: ie, ik

     allocate(occup_tmp(np_e, ista_k:iend_k))
     do ik = ista_k, iend_k
        do ie = 1, np_e
           occup_tmp(ie,ik) = occup_l(ie,ik)
        end do
     end do
  end subroutine m_ESoc_keep_occup

  subroutine m_ESoc_retrieve_occup()
     integer :: ie, ik

     do ik = ista_k, iend_k
        do ie = 1, np_e
           occup_l(ie,ik) = occup_tmp(ie,ik)
        end do
     end do
     deallocate(occup_tmp)
  end subroutine m_ESoc_retrieve_occup

  subroutine m_ESoc_occup_under_ef(nfout, nk)
    use m_Electronic_Structure, only : efermi
    integer, intent(in) :: nfout
    integer, intent(in), optional :: nk
    integer :: ik, ie
    real(kind=DP) :: e, weight, eo
    integer :: noff

    noff = 1
    if(present(nk)) noff = nk
    eo = efermi
    if(.not.metalic_system) eo = vbm + 1.d-10
    do ik = ista_k, iend_k    ! MPI
       do ie = 1, np_e        ! MPI
          if(ekmode==OFF) then
             e = eko_l(ie,ik)
          else
             e = eko_ek(ista_e-1+ie,noff+ik-1)
          endif
          if(e < eo) then
             weight = 1.d0
          else
             weight = 0.d0
          end if
! =========================================== modified by K. Tagami =========== 11.0
!         occup_l(ie,ik) = weight*wspin*kv3*qwgt(ik)
!
          if ( noncol ) then
            occup_l(ie,ik) = weight * kv3/ndim_spinor *qwgt(ik)
          else
            occup_l(ie,ik) = weight * kv3 *qwgt(ik)
          endif
! ============================================================================ 11.0
       end do
    end do
  end subroutine m_ESoc_occup_under_ef

  subroutine m_ESoc_substitute_occup(nfout,iw,nk)
    integer, intent(in) :: nfout,iw
    integer, intent(in), optional :: nk

    integer :: ie, ik, ipripe0, is, i, iset, j, is0, ie0
    integer, parameter :: NCLMN = 8
    real(kind=DP) :: wspin = 1.d0, weight, emin, emax, e
    real(kind=DP), allocatable, dimension(:,:) :: occup_mpi, temp_mpi, eko_mpi
    integer :: noff

    noff = 1
    if(present(nk)) noff = nk

    emin = Ewindows_partial_charge(iw,1)
    emax = Ewindows_partial_charge(iw,2)

    do ik = ista_k, iend_k    ! MPI
       do ie = 1, np_e        ! MPI
          if(ekmode==OFF) then
             e = eko_l(ie,ik)
          else
             e = eko_ek(ista_e-1+ie,noff+ik-1)
          endif
          if(e > emin .and. e < emax) then
             weight = 1.d0
          else
             weight = 0.d0
          end if
! =========================================== modified by K. Tagami =========== 11.0
!         occup_l(ie,ik) = weight*wspin*kv3*qwgt(ik)
!
          if ( noncol ) then
            occup_l(ie,ik) = weight *wspin *kv3/ndim_spinor *qwgt(ik)
          else
            occup_l(ie,ik) = weight *wspin *kv3 *qwgt(ik)
          endif
! ============================================================================ 11.0

       end do
    end do

    if(npes > 1) then
       if(mype == 0) ipripe0 = iprioccup
       call mpi_bcast(ipripe0, 1,mpi_integer,0,MPI_CommGroup,ierr)
    else
       ipripe0 = iprioccup
    end if

    if(ipripe0 >=1 ) then
       allocate(occup_mpi(neg,kv3)); occup_mpi = 0.d0
       if(npes >= 2) then
          allocate(temp_mpi(neg,kv3)); temp_mpi = 0.d0
          do ik = 1, kv3
             if(map_k(ik) /= myrank_k) cycle
             do ie = 1, neg
                if(map_e(ie) /= myrank_e) cycle
                temp_mpi(ie,ik) = occup_l(map_z(ie),ik)
             end do
          end do
!          call mpi_allreduce(temp_mpi,occup_mpi,neg*kv3,mpi_double_precision &
!               &            ,mpi_sum, MPI_CommGroup, ierr)
          call mpi_allreduce(temp_mpi,occup_mpi,neg*kv3,mpi_double_precision &
               &            ,mpi_sum, mpi_spin_group, ierr)
          deallocate(temp_mpi)
       else
          occup_mpi = occup_l
       end if

       allocate(eko_mpi(neg,kv3)); eko_mpi = 0.d0
       if(npes >= 2) then
          allocate(temp_mpi(neg,kv3)); temp_mpi = 0.d0
          do ik = 1, kv3
             if(map_k(ik) /= myrank_k) cycle
             do ie = 1, neg
                if(map_e(ie) /= myrank_e) cycle
                temp_mpi(ie,ik) = eko_l(map_z(ie),ik)
             end do
          end do
!          call mpi_allreduce(temp_mpi,eko_mpi,neg*kv3,mpi_double_precision &
!               &            ,mpi_sum, MPI_CommGroup, ierr)
          call mpi_allreduce(temp_mpi,eko_mpi,neg*kv3,mpi_double_precision &
               &            ,mpi_sum, mpi_spin_group, ierr)
          deallocate(temp_mpi)
       else
          eko_mpi = eko_l
       end if

    end if
    if(iprioccup >= 1) then
       write(nfout,'(" !pc iw = ",i5," <<m_ESoc_substitute_occup>>")') iw

! ======================================== modified by K. Tagami ========= 11.0
!       do ik = 1, kv3
       do ik = 1, kv3, ndim_spinor
! ======================================================================= 11.0

          is = neg+1; ie = 1-1
          Isloop: do i = 1, neg
             if(occup_mpi(i,ik) > 1.d-20) then
                is = i
                exit Isloop
             end if
          end do Isloop
          Ieloop: do i = neg, 1, -1
             if(occup_mpi(i,ik) > 1.d-20) then
                ie = i
                exit Ieloop
             end if
          end do Ieloop
          if(is > 0 .and. is <= neg .and. ie > 0 .and. ie <= neg .and. is <= ie) then
             iset = (ie-is+1+(NCLMN-1))/NCLMN
             is0 = is
             write(nfout,'(" !pc ( ik = ",i5," )")') ik
             do j = 1, iset
                ie0 = min(ie,is0+NCLMN-1)
                write(nfout,'(" !pc nband ",4x,8i10)') (i,i=is0,ie0)
                write(nfout,'(" !pc eko  ",5x,8f10.6)') (eko_mpi(i,ik),i=is0, ie0)
                write(nfout,'(" !pc eko(eV)",3x,8f10.6)') ((eko_mpi(i,ik)-e_origin)*HARTREE,i=is0, ie0)
                write(nfout,'(" !pc occup",5x,8f10.6)') (occup_mpi(i,ik),i=is0, ie0)
                is0 = is0 + NCLMN
             end do
          end if
       end do
    end if
    if(ipripe0 >=1 ) then
       deallocate(occup_mpi)
       deallocate(eko_mpi)
    end if

  end subroutine m_ESoc_substitute_occup

  subroutine m_ESoc_free_nEwindows()
    if(allocated(Ewindows_partial_charge)) deallocate(Ewindows_partial_charge)
    if(allocated(if_elec_state)) deallocate(if_elec_state)
  end subroutine m_ESoc_free_nEwindows

  integer function m_ESoc_if_elec_state(nfout,iw,emin,emax)
    integer, intent(in) :: nfout,iw
    real(kind=DP), intent(out) :: emin, emax

    if(iw < 0 .or. iw > nEwindows_pc) then
       write(nfout,'(" iw is out of the proper range. iw = ",i5," <<m_ESoc_if_elec_state>>")') iw
       m_ESoc_if_elec_state = NO
       return
    else
       emin = Ewindows_partial_charge(iw,1)
       emax = Ewindows_partial_charge(iw,2)
       m_ESoc_if_elec_state = if_elec_state(iw)
    end if
  end function m_ESoc_if_elec_state

  subroutine check_occupation(nfout,ispin,totch)
    integer, intent(in) :: nfout,ispin
    real(kind=DP),intent(in),dimension(*) :: totch
    integer  :: i
#ifdef _CHECK_OCCUPATION_STOP_
    integer :: ierror, errorcode
#endif

    if(mype==0) then
       do i =1, ispin
          if(dble(neg)-totch(i)*0.5d0 < 1.0) then
             if(iprioccup>=1) &
     &       write(nfout,'(" WARNING! neg may not be sufficient : &
     &    (neg = ",i8," ) - (totch(",i2,")*0.5 = ",f12.4,") < 1.0")') neg,i,totch(i)*0.5
          end if
       end do
    end if
#ifdef _CHECK_OCCUPATION_STOP_
    do i = 1, ispin
       if(dble(neg)-totch(i)*0.5d0 < 0.0) then
          if(iprioccup>=1) write(nfout,'(" STOP! neg is not sufficient : &
        & (neg = ",i8," ) - (totch(",i2,")*0.5 = ",f12.4,") < 0.0")') neg,i,totch(i)*0.5
          call mpi_abort(MPI_CommGroup,errorcode,ierror)
          call mpi_finalize(ierror)
       end if
    end do
#endif
  end subroutine check_occupation

! =========================== added by K. Tagami ================= 11.0
  subroutine check_occupation_noncl( nfout, totch )
    integer, intent(in) :: nfout
    real(kind=DP),intent(in),dimension(*) :: totch
    integer  :: i
#ifdef _CHECK_OCCUPATION_STOP_
    integer :: ierror, errorcode
#endif

    if(mype==0) then
       do i =1, 1
          if(dble(neg)-totch(i) < 1.0) then
             if(iprioccup>=1) &
     &       write(nfout,'(" WARNING! neg may not be sufficient : &
     &    (neg = ",i8," ) - (totch(",i2,") = ",f12.4,") < 1.0")') neg,i,totch(i)
          end if
       end do
    end if
#ifdef _CHECK_OCCUPATION_STOP_
    do i = 1, 1
       if(dble(neg)-totch(i) < 0.0) then
          if(iprioccup>=1) write(nfout,'(" STOP! neg is not sufficient : &
        & (neg = ",i8," ) - (totch(",i2,") = ",f12.4,") < 0.0")') neg,i,totch(i)
          call mpi_abort(MPI_CommGroup,errorcode,ierror)
          call mpi_finalize(ierror)
       end if
    end do
#endif
  end subroutine check_occupation_noncl
! ========================================================================= 11.0

  subroutine m_ESoc_occup_fix(nfout)
    integer, intent(in) :: nfout
    real(kind=DP),allocatable, dimension(:,:) :: eko_mpi  ! MPI
    real(kind=DP),allocatable, dimension(:) :: occup_mpi
    integer :: ik, ie, jcount, nb, iksnl
    real(kind=DP) :: emin, emax, e1, e2, tot
    real(kind=DP), parameter :: DELTA_TOTCH = 1.d-10
    integer,       parameter :: MAXITR = 10000
    integer, allocatable, dimension(:,:) :: n2_mpi  ! MPI
    real(DP),allocatable, dimension(:,:) :: e2_mpi  ! MPI
    integer :: itmp1, itmp2, nocc, is
    real(DP) :: maxval_vbm(2), vbm_spin(2), c1
    real(DP) :: minval_cbm(2), cbm_spin(2)

    maxval_vbm = -1.0D99
    minval_cbm =  1.0D99

    itmp1 = nint(totch);    itmp2 = nint(total_spin)
    c1 = totch -itmp1
    if ( abs(c1) > 1E-10 ) then
       call phase_error_with_msg(nfout, 'totch should be an integer',__LINE__,__FILE__)
    endif
    if ( ndim_magmom == 1 ) then
       if ( mod(itmp1,2) == 1 ) then
          call phase_error_with_msg(nfout, 'totch should be an even number',&
               &                    __LINE__,__FILE__)
       endif
    else if ( ndim_magmom == 2 ) then
       if ( mod(itmp1+itmp2,2) == 1 ) then
          call phase_error_with_msg(nfout, 'totch+total_spin should be an even number',&
               &                    __LINE__,__FILE__)
       endif
    endif
    if ( itmp2 /= 0 ) then
       if ( sw_fix_total_spin /= ON ) then
          call phase_error_with_msg(nfout, 'sw_fix_total_spin should be ON',&
               &                    __LINE__,__FILE__)
       endif
    endif

    occup_l = 0.0d0
    do ik = ista_k, iend_k, ndim_spinor
       if ( ndim_magmom == 1 ) then
          nocc = itmp1 /2
       else if ( ndim_magmom == 2 ) then
          if ( mod(ik,2)==1 ) then
             nocc = ( itmp1 +itmp2 ) /2
          else
             nocc = ( itmp1 -itmp2 ) /2
          endif
       else if ( ndim_magmom == 4 ) then
          nocc = itmp1
       endif

       is = 1
       if ( ndim_magmom == 2 .and. mod(ik,2)==0 ) is = 2

       vbm_spin = -1.0D99
       cbm_spin =  1.0D99
       do ie = 1, neg
          if(map_e(ie) == myrank_e) then
             if ( neordr(ie,ik) <= nocc ) then
                occup_l(map_z(ie),ik) = qwgt(ik) *kv3 /ndim_spinor
             else
                occup_l(map_z(ie),ik) = 0.0d0
             endif
             if ( neordr(ie,ik) == nocc )   vbm_spin(is) = eko_l(map_z(ie),ik)
             if ( neordr(ie,ik) == nocc+1 ) cbm_spin(is) = eko_l(map_z(ie),ik)
          endif
       end do
       maxval_vbm(is) = max( vbm_spin(is), maxval_vbm(is) )
       minval_cbm(is) = min( cbm_spin(is), minval_cbm(is) )
    end do
    if ( npes > 1 ) then
!       call mpi_allreduce( maxval_vbm, vbm_spin, 2, mpi_double_precision, &
!            &              mpi_max, MPI_CommGroup, ierr )
!       call mpi_allreduce( minval_cbm, cbm_spin, 2, mpi_double_precision, &
!            &              mpi_min, MPI_CommGroup, ierr )
       call mpi_allreduce( maxval_vbm, vbm_spin, 2, mpi_double_precision, &
            &              mpi_max, mpi_spin_group, ierr )
       call mpi_allreduce( minval_cbm, cbm_spin, 2, mpi_double_precision, &
            &              mpi_min, mpi_spin_group, ierr )
    endif
    if ( ndim_magmom == 2 ) then
       efermi_spin(:) = ( vbm_spin(:) +cbm_spin(:) ) /2.0d0
       efermi = ( efermi_spin(1) +efermi_spin(2) ) /2.0d0
    else
       efermi = ( vbm_spin(1) +cbm_spin(1) ) /2.0d0
    endif

    if ( vbm_spin(1) > cbm_spin(1) .or. vbm_spin(2) > cbm_spin(2) ) then
       write(nfout,*) "---- WARNING ( unphysical occupations ) ----"
       if ( vbm_spin(1) > cbm_spin(1) ) then
          write(nfout,'(A,F16.12,A,F16.12)') &
               &      " vbm_spin(1):", vbm_spin(1), " > cbm_spin(1):", cbm_spin(1)
       endif
       if ( vbm_spin(2) > cbm_spin(2) ) then
          write(nfout,'(A,F16.12,A,F16.12)') &
               &      " vbm_spin(2):", vbm_spin(2), " > cbm_spin(2):", cbm_spin(2)
       endif
       write(nfout,*) "--------------------------------------------"
    endif

  end subroutine m_ESoc_occup_fix


! ==================== KT_add ============================ 13.0E
  subroutine m_ESoc_fermi_Dirac(nfout)
    integer, intent(in) :: nfout

    integer             :: jcount, ik, ie, is
    Real(kind=DP)       :: emin, emax, e1, e2, tot, totch_spin(2), totch_spin0(2)
    real(kind=DP), parameter :: DELTA_TOTCH = 1.d-10
    integer,       parameter :: MAXITR = 100000
    real(kind=DP),allocatable, dimension(:,:) :: temp_mpi, eko_mpi, occup_mpi  ! MPI

    integer :: id_sname = -1, id_sname2 = -1
    integer :: iksnl, iupdown

    integer             :: n1, n2
    real(kind=DP)       :: c1, c2
    logical, save       :: First = .true.

    call tstatc0_begin('barrier(m_Eoc_fermi_dirac) ',id_sname2)
    if(npes > 1) call mpi_barrier(MPI_CommGroup,ierr)
    call tstatc0_end(id_sname2)

    call tstatc0_begin('m_ESoc_fermi_dirac ', id_sname)

    call check_totch(nfout)           ! -(m_ES_occup) totch will be checked

    if ( noncol ) then
      allocate(eko_mpi  (neg,kv3/ndim_spinor)); eko_mpi = 0.d0
      allocate(occup_mpi(neg,kv3)); occup_mpi = 0.d0
    else
      allocate(eko_mpi  (neg,kv3)); eko_mpi = 0.d0
      allocate(occup_mpi(neg,kv3)); occup_mpi = 0.d0
    endif

    if ( noncol ) then
       do ik = 1, kv3, ndim_spinor
          Do is=2, ndim_spinor
            if ( map_k(ik+is-1) /= myrank_k ) cycle
             do ie = 1, neg
                if(map_e(ie) /= myrank_e) cycle
!
                eko_l(map_z(ie),ik +is -1 ) = 1.0D8
             End do
          End do
       end do
    endif

    if ( noncol ) then
      if ( npes >= 2) then
         allocate(temp_mpi(neg,kv3/ndim_spinor)); temp_mpi = 0.d0
         do ik = 1, kv3, ndim_spinor
            if ( map_k(ik) /= myrank_k ) cycle
            iksnl = ( ik-1 )/ndim_spinor +1

            do ie = 1, neg
              if ( map_e(ie) /= myrank_e ) cycle
              temp_mpi(ie,iksnl) = eko_l(map_z(ie),ik)
            end do
         end do
!         call mpi_allreduce( temp_mpi, eko_mpi, neg*kv3/ndim_spinor, &
!                       	&    mpi_double_precision, mpi_sum,MPI_CommGroup, ierr )
         call mpi_allreduce( temp_mpi, eko_mpi, neg*kv3/ndim_spinor, &
                       	&    mpi_double_precision, mpi_sum,mpi_spin_group, ierr )
         deallocate( temp_mpi )
      else
         Do ik=1, kv3, ndim_spinor
            iksnl = ( ik-1 )/ndim_spinor +1
            eko_mpi(:,iksnl) = eko_l(:,ik)
         End do
      end if
    else
      if ( npes >= 2 ) then                                 ! MPI
         allocate(temp_mpi (neg,kv3)); temp_mpi = 0.d0      ! MPI
         do is = ista_spin, iend_spin
!         do ik = 1, kv3                                    ! MPI
         do ik = is, kv3-nspin+is, nspin
            if(map_k(ik) /= myrank_k) cycle                 ! MPI
            do ie = 1, neg                                  ! MPI
              if(map_e(ie) /= myrank_e) cycle              ! MPI
               temp_mpi(ie,ik) = eko_l(map_z(ie),ik)        ! MPI
           end do                                          ! MPI
         end do                                             ! MPI
         enddo
         call mpi_allreduce(temp_mpi,eko_mpi,neg*kv3,mpi_double_precision &  ! MPI
            &            ,mpi_sum,MPI_CommGroup,ierr)                     ! MPI
         deallocate(temp_mpi )
      else                                               ! MPI
         eko_mpi = eko_l                                 ! MPI
      end if                                             ! MPI
    end if

    emin = minval(eko_mpi);     emax = maxval(eko_mpi)
#ifdef USE_MIDDLE_EIGENVAL
    if ( First ) then
       efermi = emax;           First = .false.
    else
       if ( noncol ) then
          n1 = nint(totch);  n2 = n1+1
       else
          if ( mod(nint(totch),2) == 0 ) then
             n1 = nint(totch) /2;  n2 = n1 +1
          else
             n1 = ( nint(totch) +1 )/2;  n2 = n1
          endif
       end if
       c1 = 0.0d0; c2 = 0.0d0
       Do ik=1, kv3/ndim_spinor
          c1 = c1 +eko_mpi(n1,ik);   c2 = c2 +eko_mpi(n2,ik)
       End Do
       c1 = c1 /dble(kv3/ndim_spinor);   c2 = c2 /dble(kv3/ndim_spinor)
       efermi = ( c1+c2 )/2.0d0
    endif
#else
    efermi = emax
#endif

    e1 = emin - dabs(DELTA_FermiSearchRange)
    e2 = emax + dabs(DELTA_FermiSearchRange)

    jcount = 1
! ----------------------------
    occupied_ch_equals_totch : do

       if ( noncol ) then
          call get_occup_l_and_tot_noncl_dirac( efermi, .true. )
       else
          call get_occup_l_and_tot_dirac( 1, 1, efermi, .true. )
       endif

#ifndef USE_MIDDLE_EIGENVAL
       if(jcount == 1 .and. tot < totch) &
            call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
#endif

       if(dabs(tot - totch) < DELTA_TOTCH) exit occupied_ch_equals_totch
       if( tot < totch) then
          e1 = efermi; efermi = efermi + (e2-efermi)/2
       else
          e2 = efermi; efermi = efermi + (e1-efermi)/2
       end if
       jcount = jcount + 1
       if(jcount > MAXITR) then
          call wd_fermi_error2 &   !-(b_Fermi)
               & (nfout,e1,e2,efermi,emin,emax,tot,totch,neg,MAXITR)
       end if
    end do occupied_ch_equals_totch

    if(iprioccup >= 2) &
         &write(nfout,'( "== Fermi Dirac Broadening Method ==")')
    if(iprioccup >= 2) &
         &write(nfout,'( " efermi = ", f10.4, " tot = ", f10.4)') efermi, tot

    if ( noncol ) then
       call get_entropic_term_noncl(band_entropy)
    else
       call get_entropic_term(band_entropy)
    endif

    if(iprioccup >= 2) &
         &write(nfout,'( " band_entropy = ", f20.14)') band_entropy

    if(imag == FERRO .and. sw_fix_total_spin == YES .and. nspin == 2) then
       if(total_spin > totch) then
          write(nfout,'( " !WARNING total_spin should be smaller than totch <<m_ESoc_fermi_dirac>>")')

          totch_spin(1) = totch
          totch_spin(2) = totch
       else
          totch_spin(1) = (totch + total_spin)*1.0d0
          totch_spin(2) = (totch - total_spin)*1.0d0
       end if

       do is = 1, nspin
          emin = minval(eko_mpi)
          emax = maxval(eko_mpi)

          efermi_spin(is) = emax
          e1 = emin - dabs(DELTA_FermiSearchRange)
          e2 = emax + dabs(DELTA_FermiSearchRange)

          jcount = 1
          occupied_ch_equals_totch2 : do

             call get_occup_l_and_tot_dirac(nspin,is,efermi_spin(is),.true.)
                                      ! -(contained here) ->(occup_l,tot)
             !    ~~~~~~~~~~~~~~~~~~~
             if(jcount == 1 .and. tot < totch_spin(is)) &
                  call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
             if(dabs(tot - totch_spin(is)) < DELTA_TOTCH) exit occupied_ch_equals_totch2
             if( tot < totch_spin(is)) then
                e1 = efermi_spin(is); efermi_spin(is) = (efermi_spin(is) + e2)/2
             else
                e2 = efermi_spin(is); efermi_spin(is) = (efermi_spin(is) + e1)/2
             end if
             jcount = jcount + 1
             if(jcount > MAXITR) then
                call wd_fermi_error2 &   !-(b_Fermi)
                     & (nfout,e1,e2,efermi_spin(is),emin,emax,tot,totch_spin(is),neg,MAXITR)
             end if
          end do occupied_ch_equals_totch2

          if(iprioccup >= 2) &
               &write(nfout,'( "== Fermi Dirac Broadening Method ==")')
          if(iprioccup >= 2) &
               &write(nfout,'( " efermi_spin(",i2," ) = ", f10.4, ", tot/2 = ", f10.4)') &
               & is,efermi_spin(is), tot/2.0
       end do

       call get_total_spin0 ! -> totch_spin0

       efermi = (efermi_spin(1)+efermi_spin(2))*0.5d0
       if(iprioccup>=1)then
          write(nfout,'(a,f10.4)') ' == new efermi = ',efermi
       endif

    else if(imag == FERRO .and. sw_fix_total_spin == NO .and. nspin == 2) then
       call get_total_spin0 ! ->totch_spin0
    end if

    do ik = ista_k, iend_k                              ! MPI
       do ie = 1, neg                                   ! MPI
          if(map_e(ie) == myrank_e) then                ! MPI
             occup_l(map_z(ie),ik) = occup_mpi(ie,ik)   ! MPI
             if(sw_manual_occupation==ON)then
               if(band_index(ie)>0)then
                  iupdown = 1
                  if(nspin>1.and.mod(ik,2)==0) iupdown = 2
                  occup_l(map_z(ie),ik) = occ_ext(band_index(ie),iupdown)
               endif
             endif
          end if                                        ! MPI
       end do                                           ! MPI
    end do                                              ! MPI

    if(imag == FERRO .and. nspin == 2) then
       ie = 2
       if(sw_fix_total_spin == YES) call check_occupation(nfout,ie,totch_spin)
    else if(imag /= FERRO) then
       ie = 1
       totch_spin0(1) = totch
    end if

    if ( noncol ) then
       call check_occupation_noncl(nfout,totch_spin0)
    else
       call check_occupation(nfout,ie,totch_spin0)
    endif

    if ( af == 1 ) then
       Do ik=ista_k, iend_k, nspin
          occup_l(:,ik+1) = occup_l(:,ik)
       End Do
    endif

    deallocate(eko_mpi  )
    deallocate(occup_mpi)

    call tstatc0_end(id_sname)

  contains

    subroutine get_total_spin0
      do is = 1, nspin
         call get_occup_l_and_tot_dirac(nspin,is,efermi,.false.)
         totch_spin0(is) = tot
      end do

      total_spin0 = (totch_spin0(1) - totch_spin0(2))*0.5d0
      if(iprioccup >= PRINTOUTLEVEL_TOTCH_SPIN) then
         if(sw_fix_total_spin == YES) then
            call wd_efermi_and_total_spin0_Plus(nfout,total_spin0,totch_spin0,totch_spin)
         else
            call wd_efermi_and_total_spin0(nfout,total_spin0,totch_spin0)
         end if
      end if
    end subroutine get_total_spin0

    subroutine get_occup_l_and_tot_dirac(nspin,is,efermi,update_occ)
      integer, intent(in) :: nspin, is
      real(kind=DP), intent(in) :: efermi
      logical,intent(in) :: update_occ

      integer       :: k, i,iupdown
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, tmp

      tot = 0.d0

      do k = is, kv3, max(nspin,af+1)
         do i = 1, neg
            e = eko_mpi(i,k)

            call width_fermi_dirac(e,efermi,width,dos,weight)  ! -(b_Fermi)

            if(sw_manual_occupation==ON.and..not.update_occ)then
               if(band_index(i)>0)then
                  iupdown = 1
                  if(nspin>1.and.mod(k,2)==0) iupdown = 2
                  weight = occ_ext(band_index(i),iupdown)
               endif
            endif

            tmp = weight*wspin*kv3*qwgt(k)
            if(update_occ) occup_mpi(i,k) = tmp

            tot = tot + 2*tmp
         end do
      end do
      if(af == 1) then
         tot = tot/kv3 * (af+1)
      else
         tot = tot/(kv3/nspin)
      end if
      if(ipri >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12)') efermi,tot
    end subroutine get_occup_l_and_tot_dirac

    subroutine get_occup_l_and_tot_noncl_dirac( efermi, update_occ )
      real(kind=DP), intent(in) :: efermi
      logical,intent(in) :: update_occ

      integer       :: k, i, iksnl
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, wktmp, ctmp

      tot = 0.d0;  occup_mpi = 0.0d0
      wktmp = kv3 / ndim_spinor

      do k = 1, kv3, ndim_spinor
         iksnl = ( k -1 )/ndim_spinor + 1

         do i = 1, neg
            e = eko_mpi(i,iksnl)

            call width_fermi_dirac(e,efermi,width,dos,weight)  ! -(b_Fermi)

            ctmp = weight *wspin *wktmp *qwgt(k)
            if ( update_occ ) occup_mpi(i,k) = ctmp
            tot = tot + ctmp
         end do
      end do
      tot = tot / wktmp

      if(ipri >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12)') efermi,tot
    end subroutine get_occup_l_and_tot_noncl_dirac

    subroutine get_entropic_term(s)
      real(kind=DP), intent(out) :: s

      integer       :: k, i
      real(kind=DP) :: e, entropy
      s = 0.d0
      do k = 1, kv3, af+1
         do i = 1, neg
            e = eko_mpi(i,k)
            call get_entropy(e,efermi,width,entropy)
            s = s + 2.d0*entropy*qwgt(k)
         end do
      end do
      s = s * (af+1)
    end subroutine get_entropic_term

    subroutine get_entropic_term_noncl(s)
      real(kind=DP), intent(out) :: s

      integer       :: k, i, iksnl
      real(kind=DP) :: e, entropy
      s = 0.d0
      do k = 1, kv3, ndim_spinor
         iksnl = ( k -1 )/ndim_spinor + 1
         do i = 1, neg
            e = eko_mpi(i,iksnl)
            call get_entropy(e,efermi,width,entropy)
            s = s + 1.d0*entropy*qwgt(k)
         end do
      end do
    end subroutine get_entropic_term_noncl

    subroutine get_entropy( e, efermi, width, entropy )
      real(kind=DP), intent(in) :: e,efermi,width
      real(kind=DP), intent(out) :: entropy

      real(kind=DP) :: ee, c1, occ, unocc

      ee = ( e -efermi )/width
      c1 = exp( ee )

      occ = 1.0D0 / ( 1.0D0 +c1 )
      unocc = 1.0D0 - occ

      entropy = 0.0d0

      if ( occ > 1.0D-12 .and. unocc > 1.0D-12 ) then
         entropy = -occ*log( occ ) -unocc*log( unocc )
      endif

    end subroutine get_entropy

  end subroutine m_ESoc_fermi_Dirac


  subroutine m_ESoc_methfessel_paxton(nfout)
    integer, intent(in) :: nfout

    integer             :: jcount, ik, ie, is
    Real(kind=DP)       :: emin, emax, e1, e2, tot, totch_spin(2), totch_spin0(2)
    real(kind=DP)       :: emin0,emax0
    real(kind=DP), parameter :: DELTA_TOTCH = 1.d-10
    integer,       parameter :: MAXITR = 100000
    real(kind=DP),allocatable, dimension(:,:) :: temp_mpi, eko_mpi, occup_mpi  ! MPI

    integer :: id_sname = -1, id_sname2 = -1

    integer :: iksnl
    integer :: iupdown
    integer :: icount
    real(kind=DP) :: delta_energy

    call tstatc0_begin('barrier(m_Eoc_methfessel_paxton) ',id_sname2)
    if(npes > 1) call mpi_barrier(MPI_CommGroup,ierr)
    call tstatc0_end(id_sname2)

    call tstatc0_begin('m_ESoc_methfessel_paxton ', id_sname)

    call check_totch(nfout)           ! -(m_ES_occup) totch will be checked

    if ( noncol ) then
      allocate(eko_mpi  (neg,kv3/ndim_spinor)); eko_mpi = 0.d0
      allocate(occup_mpi(neg,kv3)); occup_mpi = 0.d0
    else
      allocate(eko_mpi  (neg,kv3)); eko_mpi = 0.d0
      allocate(occup_mpi(neg,kv3)); occup_mpi = 0.d0
    endif

    if ( noncol ) then
       do ik = 1, kv3, ndim_spinor
          Do is=2, ndim_spinor
            if ( map_k(ik+is-1) /= myrank_k ) cycle
             do ie = 1, neg
                if(map_e(ie) /= myrank_e) cycle
!
                eko_l(map_z(ie),ik +is -1 ) = 1.0D8
             End do
          End do
       end do
    endif

    if ( noncol ) then
      if ( npes >= 2) then
         allocate(temp_mpi(neg,kv3/ndim_spinor)); temp_mpi = 0.d0
         do ik = 1, kv3, ndim_spinor
            if ( map_k(ik) /= myrank_k ) cycle
            iksnl = ( ik-1 )/ndim_spinor +1

            do ie = 1, neg
              if ( map_e(ie) /= myrank_e ) cycle
              temp_mpi(ie,iksnl) = eko_l(map_z(ie),ik)
            end do
         end do
!         call mpi_allreduce( temp_mpi, eko_mpi, neg*kv3/ndim_spinor, &
!                       	&    mpi_double_precision, mpi_sum,MPI_CommGroup, ierr )
         call mpi_allreduce( temp_mpi, eko_mpi, neg*kv3/ndim_spinor, &
                       	&    mpi_double_precision, mpi_sum,mpi_spin_group, ierr )
         deallocate( temp_mpi )
      else
         Do ik=1, kv3, ndim_spinor
            iksnl = ( ik-1 )/ndim_spinor +1
            eko_mpi(:,iksnl) = eko_l(:,ik)
         End do
      end if
    else
      if ( npes >= 2 ) then                                 ! MPI
         allocate(temp_mpi (neg,kv3)); temp_mpi = 0.d0      ! MPI
         do is = ista_spin, iend_spin
         do ik = is, kv3-nspin+is, nspin
!         do ik = 1, kv3                                     ! MPI
            if(map_k(ik) /= myrank_k) cycle                 ! MPI
            do ie = 1, neg                                  ! MPI
              if(map_e(ie) /= myrank_e) cycle              ! MPI
               temp_mpi(ie,ik) = eko_l(map_z(ie),ik)        ! MPI
           end do                                          ! MPI
         end do                                             ! MPI
         enddo
         call mpi_allreduce(temp_mpi,eko_mpi,neg*kv3,mpi_double_precision &  ! MPI
            &            ,mpi_sum,MPI_CommGroup,ierr)                     ! MPI
         deallocate(temp_mpi )
      else                                               ! MPI
         eko_mpi = eko_l                                 ! MPI
      end if                                             ! MPI
    end if

    if(esearch==ON .and. order_mp>0)then
      delta_energy = esearch_factor_mp*width/dble(order_mp)
      emin = minval(eko_mpi);     emax = maxval(eko_mpi)
      !emin = emin+(emax-emin)*0.5d0*totch*0.5d0/dble(neg)
      emax = emin+delta_energy
      if(iprioccup>=2) write(nfout,'(a,2f10.5)') 'initial emin, emax ',emin,emax
      efermi = emax
      icount = 0
      do
         if ( noncol ) then
            call get_occup_l_and_tot_noncl_mp( efermi, .true. )
         else
            call get_occup_l_and_tot_mp( 1, 1, efermi, .true. )
         endif
         icount = icount+1
         if (tot>=totch) then
            emax = efermi
            exit
         endif
         emin = efermi
         efermi = efermi+delta_energy
      enddo
      emin0 = emin
      emax0 = emax
      efermi = emin
      e1 = emin
      e2 = emax
    else
      emin = minval(eko_mpi);     emax = maxval(eko_mpi) ; efermi = emax
      e1 = emin - dabs(DELTA_FermiSearchRange)
      e2 = emax + dabs(DELTA_FermiSearchRange)
    endif

    jcount = 1
! ----------------------------
    occupied_ch_equals_totch : do

       if ( noncol ) then
          call get_occup_l_and_tot_noncl_mp( efermi, .true. )
       else
          call get_occup_l_and_tot_mp( 1, 1, efermi, .true. )
       endif

       !if(jcount == 1 .and. tot < totch) &
       !     call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)

       if(dabs(tot - totch) < DELTA_TOTCH) exit occupied_ch_equals_totch
       if( tot < totch) then
          e1 = efermi; efermi = efermi + (e2-efermi)/2
       else
          e2 = efermi; efermi = efermi + (e1-efermi)/2
       end if
       jcount = jcount + 1
       if(jcount > MAXITR) then
          call wd_fermi_error2 &   !-(b_Fermi)
               & (nfout,e1,e2,efermi,emin,emax,tot,totch,neg,MAXITR)
       end if
    end do occupied_ch_equals_totch
    if(iprioccup >= 2 .and. esearch==ON) write(nfout,'(a,i8,3f15.5)') &
       & ' !** number of iteration for bracketing, emin0, emax0 and efermi: ',icount,emin0,emax0,efermi

    if(iprioccup >= 2) &
         &write(nfout,'( "== Methfessel-Paxton Broadening Method ==")')
    if(iprioccup >= 2) &
         &write(nfout,'( " efermi = ", f10.4, " tot = ", f10.4)') efermi, tot

    if ( noncol ) then
       call get_entropic_term_noncl(band_entropy)
    else
       call get_entropic_term(band_entropy)
    endif

    if(iprioccup >= 2) &
         &write(nfout,'( " band_entropy = ", f20.14)') band_entropy

    if(imag == FERRO .and. sw_fix_total_spin == YES .and. nspin == 2) then
       if(total_spin > totch) then
          write(nfout,'( " !WARNING total_spin should be smaller than totch <<m_ESoc_methfessel_paxton>>")')

          totch_spin(1) = totch
          totch_spin(2) = totch
       else
          totch_spin(1) = (totch + total_spin)*1.0d0
          totch_spin(2) = (totch - total_spin)*1.0d0
       end if

       do is = 1, nspin
          emin = minval(eko_mpi)
          emax = maxval(eko_mpi)

          efermi_spin(is) = emax
          e1 = emin - dabs(DELTA_FermiSearchRange)
          e2 = emax + dabs(DELTA_FermiSearchRange)

          jcount = 1
          occupied_ch_equals_totch2 : do

             call get_occup_l_and_tot_mp(nspin,is,efermi_spin(is),.true.)
                                      ! -(contained here) ->(occup_l,tot)
             !    ~~~~~~~~~~~~~~~~~~~
             if(jcount == 1 .and. tot < totch_spin(is)) &
                  call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
             if(dabs(tot - totch_spin(is)) < DELTA_TOTCH) exit occupied_ch_equals_totch2
             if( tot < totch_spin(is)) then
                e1 = efermi_spin(is); efermi_spin(is) = (efermi_spin(is) + e2)/2
             else
                e2 = efermi_spin(is); efermi_spin(is) = (efermi_spin(is) + e1)/2
             end if
             jcount = jcount + 1
             if(jcount > MAXITR) then
                call wd_fermi_error2 &   !-(b_Fermi)
                     & (nfout,e1,e2,efermi_spin(is),emin,emax,tot,totch_spin(is),neg,MAXITR)
             end if
          end do occupied_ch_equals_totch2

          if(iprioccup >= 2) &
               &write(nfout,'( "== Methfessel-Paxton Broadening Method ==")')
          if(iprioccup >= 2) &
               &write(nfout,'( " efermi_spin(",i2," ) = ", f10.4, ", tot/2 = ", f10.4)') &
               & is,efermi_spin(is), tot/2.0
       end do

       call get_total_spin0 ! -> totch_spin0

       efermi = (efermi_spin(1)+efermi_spin(2))*0.5d0
       if(iprioccup>=1)then
          write(nfout,'(a,f10.4)') ' == new efermi = ',efermi
       endif

    else if(imag == FERRO .and. sw_fix_total_spin == NO .and. nspin == 2) then
       call get_total_spin0 ! ->totch_spin0
    end if

    do ik = ista_k, iend_k                              ! MPI
       do ie = 1, neg                                   ! MPI
          if(map_e(ie) == myrank_e) then                ! MPI
             occup_l(map_z(ie),ik) = occup_mpi(ie,ik)   ! MPI
             if(sw_manual_occupation==ON)then
               if(band_index(ie)>0)then
                  iupdown = 1
                  if(nspin>1.and.mod(ik,2)==0) iupdown = 2
                  occup_l(map_z(ie),ik) = occ_ext(band_index(ie),iupdown)
               endif
             endif
          end if                                        ! MPI
       end do                                           ! MPI
    end do                                              ! MPI

    if(imag == FERRO .and. nspin == 2) then
       ie = 2
       if(sw_fix_total_spin == YES) call check_occupation(nfout,ie,totch_spin)
    else if(imag /= FERRO) then
       ie = 1
       totch_spin0(1) = totch
    end if

    if ( noncol ) then
       call check_occupation_noncl(nfout,totch_spin0)
    else
       call check_occupation(nfout,ie,totch_spin0)
    endif

    if ( af == 1 ) then
       Do ik=ista_k, iend_k, nspin
          occup_l(:,ik+1) = occup_l(:,ik)
       End Do
    endif

    deallocate(eko_mpi  )
    deallocate(occup_mpi)

    call tstatc0_end(id_sname)

  contains

    subroutine get_total_spin0
      do is = 1, nspin
         call get_occup_l_and_tot_mp(nspin,is,efermi,.false.)
         totch_spin0(is) = tot
      end do

      total_spin0 = (totch_spin0(1) - totch_spin0(2))*0.5d0
      if(iprioccup >= PRINTOUTLEVEL_TOTCH_SPIN) then
         if(sw_fix_total_spin == YES) then
            call wd_efermi_and_total_spin0_Plus(nfout,total_spin0,totch_spin0,totch_spin)
         else
            call wd_efermi_and_total_spin0(nfout,total_spin0,totch_spin0)
         end if
      end if
    end subroutine get_total_spin0

    subroutine get_occup_l_and_tot_mp(nspin,is,efermi,update_occ)
      integer, intent(in) :: nspin, is
      real(kind=DP), intent(in) :: efermi
      logical,intent(in) :: update_occ

      integer       :: k, i,iupdown
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, tmp, ent

      tot = 0.d0

      do k = is, kv3, max(nspin,af+1)
         do i = 1, neg
            e = eko_mpi(i,k)

            call width_methfessel_paxton(order_mp,e,efermi,width,dos,weight,ent)  ! -(b_Fermi)

            if(sw_manual_occupation==ON.and..not.update_occ)then
               if(band_index(i)>0)then
                  iupdown = 1
                  if(nspin>1.and.mod(k,2)==0) iupdown = 2
                  weight = occ_ext(band_index(i),iupdown)
               endif
            endif

            tmp = weight*wspin*kv3*qwgt(k)
            if(update_occ) occup_mpi(i,k) = tmp

            tot = tot + 2*tmp
         end do
      end do
      if(af == 1) then
         tot = tot/kv3 * (af+1)
      else
         tot = tot/(kv3/nspin)
      end if
      if(iprioccup >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12)') efermi,tot
    end subroutine get_occup_l_and_tot_mp

    subroutine get_occup_l_and_tot_noncl_mp( efermi, update_occ )
      real(kind=DP), intent(in) :: efermi
      logical,intent(in) :: update_occ

      integer       :: k, i, iksnl
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, wktmp, ctmp, ent

      tot = 0.d0;  occup_mpi = 0.0d0
      wktmp = kv3 / ndim_spinor

      do k = 1, kv3, ndim_spinor
         iksnl = ( k -1 )/ndim_spinor + 1

         do i = 1, neg
            e = eko_mpi(i,iksnl)

            call width_methfessel_paxton(order_mp,e,efermi,width,dos,weight,ent)  ! -(b_Fermi)

            ctmp = weight *wspin *wktmp *qwgt(k)
            if ( update_occ ) occup_mpi(i,k) = ctmp
            tot = tot + ctmp
         end do
      end do
      tot = tot / wktmp

      if(ipri >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12)') efermi,tot
    end subroutine get_occup_l_and_tot_noncl_mp

    subroutine get_entropic_term(s)
      real(kind=DP), intent(out) :: s

      integer       :: k, i
      real(kind=DP) :: e, entropy
      s = 0.d0
      do k = 1, kv3, af+1
         do i = 1, neg
            e = eko_mpi(i,k)
            call get_entropy(e,efermi,width,entropy)
            s = s + 2.d0*entropy*qwgt(k)
         end do
      end do
      s = s * (af+1)
    end subroutine get_entropic_term

    subroutine get_entropic_term_noncl(s)
      real(kind=DP), intent(out) :: s

      integer       :: k, i, iksnl
      real(kind=DP) :: e, entropy
      s = 0.d0
      do k = 1, kv3, ndim_spinor
         iksnl = ( k -1 )/ndim_spinor + 1
         do i = 1, neg
            e = eko_mpi(i,iksnl)
            call get_entropy(e,efermi,width,entropy)
            s = s + 1.d0*entropy*qwgt(k)
         end do
      end do
    end subroutine get_entropic_term_noncl

    subroutine get_entropy( e, efermi, width, entropy )
      real(kind=DP), intent(in) :: e,efermi,width
      real(kind=DP), intent(out) :: entropy

      real(kind=DP) :: occ,dos
      call width_methfessel_paxton(order_mp,e,efermi,width,dos,occ,entropy)
    end subroutine get_entropy

  end subroutine m_ESoc_methfessel_paxton
! ======================================================== 13.0E

  subroutine m_ES_rd_occ_ext(nfout)
    integer, intent(in) :: nfout
    integer :: f_getIntValue,f_selectBlock, f_selectParentBlock,f_getRealValue
    integer :: iret
    if(f_selectBlock('accuracy')==0)then
       if(f_getIntValue(tag_sw_manual_occupation,iret)==0)then
          sw_manual_occupation = iret
       endif
       if(sw_manual_occupation==ON)then
          call set_external_occupation()
       endif
       iret = f_selectParentBlock()
    endif
  contains
    subroutine set_external_occupation()
      integer :: f_selectFirstTableLine, f_selectNextTableLine,f_getRealValue
      integer :: iocc,io,iret
      real(kind=DP) :: dret
      if(f_selectBlock(tag_occupation)==0)then
         iocc = 1
         do
           if(iocc==1)then
              if(f_selectFirstTableLine() /= 0 ) then
                 exit
              endif
           else
              if(f_selectNextTableLine() /= 0 )then
                 exit
              endif
           endif
           iocc = iocc+1
         enddo
         iocc = iocc-1
         allocate(occ_ext(iocc,nspin));occ_ext=0.d0
         allocate(band_index(neg));band_index=0
         iret = f_selectFirstTableLine()
         do io=1,iocc
            if(f_getIntValue(tag_band_index,iret)==0) band_index(iret) = io
            if(f_getRealValue(tag_occ,dret,'')==0) occ_ext(io,1) = dret
            if(f_getRealValue(tag_occ_up,dret,'')==0) occ_ext(io,1) = dret
            if(nspin>1)then
               if(f_getRealValue(tag_occ_down,dret,'')==0) occ_ext(io,2) = dret
            endif
            iret = f_selectNextTableLine()
         enddo
         if(printable.and.sw_manual_occupation==ON)then
            write(nfout,'(a)') ' !** manual occupation given in the input'
            do io=1,neg
               if(band_index(io)<1) cycle
               if(nspin==1) then
               write(nfout,'(a,i8,a,f10.5)') ' !** band : ',io,' occ : ',occ_ext(band_index(io),1)
               else
               write(nfout,'(a,i8,a,f10.5,a,f10.5)') ' !** band : ',io,' occ (up) : ', &
            &          occ_ext(band_index(io),1),' occ (down) : ',occ_ext(band_index(io),2)
               endif
            enddo
         endif
         iret = f_selectParentBlock()
      endif
    end subroutine set_external_occupation
  end subroutine m_ES_rd_occ_ext

  subroutine wd_efermi_and_total_spin0(nfout,total_spin0,totch_spin0)
    ! Revised by T. Y. 21th Jun. 2023
    integer, intent(in) :: nfout
    real(kind=DP), intent(in) :: total_spin0, totch_spin0(2)
    write(nfout,'(" == efermi = ",f10.4, ", totch_diff0 = ",f12.6, ", totch_spin0(1:2) = ",2f12.6)') &
         & efermi, total_spin0, totch_spin0(1:2)*0.5d0
  end subroutine wd_efermi_and_total_spin0

  subroutine wd_efermi_and_total_spin0_plus(nfout,total_spin0,totch_spin0,totch_spin)
    ! Revised by T. Y. 21th Jun. 2023
    integer, intent(in) :: nfout
    real(kind=DP), intent(in) :: total_spin0, totch_spin0(2),totch_spin(2)
    write(nfout,'(" == efermi_spin(1:2) = ",2f10.4, ", totch_diff  = ",f12.6,", totch_spin(1:2)  = ",2f12.6)') &
         & efermi_spin(1:2),total_spin, totch_spin(1:2)*0.5d0
    write(nfout,'(" == efermi = ",f10.4, 20x,", totch_diff0 = ",f12.6, ", totch_spin0(1:2) = ",2f12.6)') &
         & efermi, total_spin0, totch_spin0(1:2)*0.5d0
  end subroutine wd_efermi_and_total_spin0_plus

! =============== KT_add ========================== 13.0E
  subroutine m_ESoc_count_charge_belowEF( nfout )
    integer, intent(in) :: nfout

    integer       :: ik, ie, is
    real(kind=DP) :: wspin = 1.d0, e, dos, weight
    real(kind=DP) :: wktmp, ctmp, csum, csum_mpi
!
    csum = 0.0d0

    if ( noncol ) then
       wktmp = kv3 / ndim_spinor

       do ik = 1, kv3, ndim_spinor
          if ( map_k(ik) /= myrank_k ) cycle

          do ie = 1, neg
             if ( map_e(ie) /= myrank_e ) cycle

             e = eko_l(map_z(ie),ik)
             if ( e > efermi ) cycle

             call width_fermi_dirac(e,efermi,width,dos,weight)  ! -(b_Fermi)
             ctmp = weight *wspin *wktmp *qwgt(ik)
             csum = csum +ctmp
          end do
       end do

       if ( npes > 2 ) then
!          call mpi_allreduce( csum, csum_mpi, 1, mpi_double_precision, &
!               &              mpi_sum, MPI_CommGroup, ierr )
          call mpi_allreduce( csum, csum_mpi, 1, mpi_double_precision, &
               &              mpi_sum, mpi_spin_group, ierr )
          csum = csum_mpi
       endif

       csum = csum /dble(wktmp)

    else
       do is = ista_spin, iend_spin
       do ik = is, kv3-nspin+is, nspin
!       do ik=1, kv3
          if (map_k(ik) /= myrank_k) cycle
          do ie=1, neg
             if (map_e(ie) /= myrank_e) cycle

             e = eko_l(map_z(ie),ik)
             if ( e > efermi ) cycle

             call width_fermi_dirac(e,efermi,width,dos,weight)  ! -(b_Fermi)

             ctmp = weight *wspin *kv3 *qwgt(ik)
             csum = csum + 2*ctmp
          end do
       end do
       enddo

       if ( npes > 2 ) then
          call mpi_allreduce( csum, csum_mpi, 1, mpi_double_precision, &
               &              mpi_sum, MPI_CommGroup, ierr )
          csum = csum_mpi
       endif
       csum = csum/dble(kv3)/dble(nspin)

    endif

    write(nfout,'(A,F20.12)') " !! Number of Charge below Fermi level = ", csum

  end subroutine m_ESoc_count_charge_belowEF

  subroutine m_ESoc_count_charge_belowEF_ek( nfout )
    integer, intent(in) :: nfout

    integer       :: k, i
    real(kind=DP) :: wspin = 1.d0, e, dos, weight
    real(kind=DP) :: totw, ctmp, csum, wktmp

    csum = 0.0d0

    if ( noncol ) then
       wktmp = kv3_ek /ndim_spinor

       do k=1, kv3_ek, ndim_spinor
          do i=1, neg
             e = eko_ek(i,k)
             if ( e > efermi ) cycle

             call width_fermi_dirac(e,efermi,width,dos,weight)  ! -(b_Fermi)
             totw = weight *wspin *wktmp *qwgt_ek(k)
             csum = csum + totw
          end do
       end do
       csum = csum /wktmp
    else
       do k = 1, kv3_ek, af+1
          do i = 1, neg
             e = eko_ek(i,k)
             if ( e > efermi ) cycle

             call width_fermi_dirac(e,efermi,width,dos,weight)  ! -(b_Fermi)
             totw = weight*wspin*kv3_ek*qwgt_ek(k)
             csum = csum + 2*totw
          end do
       end do
       csum = csum /kv3_ek *(af+1)
    endif

    write(nfout,'(A,F20.12,A,F20.12)') &
         &     "Total Chargeum of Charge below Fermi level = ", totch, &
         &     " Num of Charge below EF = ", csum

  end subroutine m_ESoc_count_charge_belowEF_ek
! ==================================================== 13.0E

  subroutine m_ES_occ_with_fermi_fixed
    integer :: ik, ib
    real(kind=DP) :: weight

    Do ik=ista_k, iend_k, ndim_spinor
       weight = kv3 *qwgt(ik) /dble(ndim_spinor)
       Do ib=1, np_e
          if ( eko_l(ib,ik) <= efermi ) then
             occup_l(ib,ik) = weight
          else
             occup_l(ib,ik) = 0.0d0
          endif
       End Do
    End Do
  end subroutine m_ES_occ_with_fermi_fixed

end module m_ES_occup

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: xc_gga_rad, EXCHPBE_wb_rad, EXCHrevPBE_wb_rad, 
!             EXCHRPBE_wb_rad, CORPBE_wb_rad, NEWTO2, 
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!
c
c%%%%%%%%%%%%%%%%%%%%% Header of hex.f %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c $Id: gncpp_xc_gga_rad.F 570 2017-04-21 20:34:50Z yamasaki $
c #1) gga introduction
c      1994/11/22 t.yamasaki
c
c     Modified by Y.Morikawa(JRCAT-NAIR), 7th Aug. 1998
c
c     A relativistic self-consistent field computer program
c     for atoms and ions using local potentials.
c     ( spin-orbit interaction is neglected. )
c     jfp = 1  spin-polarized state.
c           0  paramagnetic state.
c     made by akira hasegawa (1978).
c     ref:  d. d. koelling and b. n. harmon,
c           j. phys. c: solid state physics 10, 3107-14.
c**********************************************************************
c   input                                                             *
c        jrh  : if jrh=0 , starting charge density will be prepared.  *
c        jfp  : 0----para , 1----ferro                                *
c     i_rela  : 1: scalar rela.
c             : 2: scalar rela. small comp. neglected for valence states
c   output                                                            *
c        xe   : energy eigen value (hartree atomic unit)              *
c        rhc  : charge density of core states * r**2 * 4pi            *
c        rhv  : charge density of valence states * r**2 * 4pi         *
c        rh   : total charge density * r**2 * 4pi                     *
c        inder: 0---converged , 1---not converged                     *
c        ga   : radial wave function * r .   pl(r) in k.h.            *
c        gb   :                              ql(r) in k.h.            *
c        vr   : atomic self-consistent potential * r                  *
c**********************************************************************


C---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      subroutine xc_gga_rad
     > (kmesh,mesh,kspin,nspin,nfout,rad,h,omo,rh,xctype
     < ,vxc,exc
     w ,grad,wwk
     & )
c
c                           @(#)gncpp_xc_gga_rad.F 1.1 03/02/19 01:30:00
c Exchange and Correlation Potential based on a Generalized Gradient
c Approximation formed by using FFTs.
c
c GGA functional:
c  John P. Perdew, Kieron Burke, and Matthias Ernzerhof,
c  Phys. Rev. Lett. vol. 77, 3865, (1996)
c
c Gradients of the soft charge density are calculated by using FFT.
c Gradients of the augmentation charge are calculated on fine grid
c meshs.
c Real space calculation is implemented by T. Sanada @ Thinking Machines
c
c              26th Feb. 1998, Y. Morikawa @ JRCAT-NAIR
C***********************************************************
      use m_Const_Parameters, only : PAI
      implicit none
      integer kmesh,mesh,kspin,nspin,ispin,nfout
     & ,i1,lgga,nr,ig,ncut
c$$$     & ,lpot
      real*8 rh(kmesh,kspin),vxc(kmesh,kspin),exc,eps_chg,eps_grad
     & ,rad(kmesh),omo(kmesh),h
     w      ,grad(kmesh,0:2),wwk(kmesh,7),pi,pi4
      character*7 xctype
      parameter(pi=PAI)
      parameter(pi4 = 4.d0*pi)
c
c set up charge cutoff and gradient cutoff
c
      eps_chg  = 1.d-25
      eps_grad = 1.d-40
c     xctype='ldapw91'
c      xctype='ggapw91'
c       xctype='ggapbe '
c
c Initialization
c
      do ispin = 1,nspin
       do nr=1,mesh
        vxc(nr,ispin) = 0.d0
       end do
      end do

      exc  = 0.d0
c$$$      lpot = 1
      if(xctype.eq.'ldapw91'.or.xctype.eq.'LDAPW91') then
        lgga=0
       else if(xctype.eq.'ggapw91'.or.xctype.eq.'ggapbe '
     &     .or.xctype.eq.'GGAPW91'.or.xctype.eq.'GGAPBE '
     &     .or.xctype.eq.'revpbe '.or.xctype.eq.'REVPBE '
     &     .or.xctype.eq.'rpbe   '.or.xctype.eq.'RPBE   ') then
        lgga=1
      end if
c
c Exchange energy and potential
c
c The spin-scaling relationship
c Ex[up,down] = 0.5*(Ex[2*up]+Ex[2*down])
c is used.
c
c     Spin loop start
c
      do ispin = 1,nspin
c
c Initialization
c
       do i1 = 0,2
        do nr=1,mesh
         grad(nr,i1) = 0.d0
        end do
       end do
c
c Form the spin density.
c
       do nr=1,mesh
        grad(nr,0) = rh(nr,ispin)/(pi4*rad(nr)**2)*dble(nspin)
       enddo
       if(xctype.eq.'ldapw91'.or.xctype.eq.'LDAPW91') then
c
c LSDA: set the gradients to zero
c
         do i1=1,2
          do nr=1,mesh
           grad(nr,i1) = 0.d0
          end do
         end do
        else if(xctype.eq.'ggapw91'.or.xctype.eq.'ggapbe '
     &      .or.xctype.eq.'GGAPW91'.or.xctype.eq.'GGAPBE '
     &      .or.xctype.eq.'revpbe '.or.xctype.eq.'REVPBE '
     &      .or.xctype.eq.'rpbe   '.or.xctype.eq.'RPBE   ') then
c
c Form the (spin) density gradients in the real space.
c
c
c The first derivatives of the (spin) density.
c
         call newto2
     >   (kmesh,mesh,rad,grad(1,0)
     <   ,grad(1,1)
     w ,wwk(1,1),wwk(1,2),wwk(1,3),wwk(1,4),wwk(1,5),wwk(1,6),wwk(1,7))
c
c Spin scaling for spin-polarized system.
c
         if(nspin.eq.2) then
           do nr=1,mesh
             grad(nr,1) = grad(nr,1)*2.d0
           end do
         end if
       end if

c$$$cdebug
c$$$      write(6,1919)(nr,grad(nr,0),grad(nr,1),nr=1400,mesh)
c$$$ 1919 format('GRDEX:',i4,2d20.10)
c$$$cdebug

c
c Form the Exchange potential and energy
c
c grad(*,0) = rho * ex
c grad(*,1) = Grad(rho)/|Grad rho| * d(fx)/d(|Grad rho|)
c
       if(xctype.eq.'rpbe   '.or.xctype.eq.'RPBE   ') then
         call EXCHRPBE_wb_rad
     >   (kmesh,mesh,lgga,eps_chg
     =   ,grad,vxc(1,ispin))
        else if(xctype.eq.'revpbe '.or.xctype.eq.'REVPBE ') then
         call EXCHrevPBE_wb_rad
     >   (kmesh,mesh,lgga,eps_chg
     =   ,grad,vxc(1,ispin))
        else
         call EXCHPBE_wb_rad
     >   (kmesh,mesh,lgga,eps_chg
     =   ,grad,vxc(1,ispin))
       endif
c
c Construct GGA correction for the exchange potential.
c
       call newto2
     > (kmesh,mesh,rad,grad(1,1)
     < ,grad(1,2)
     w ,wwk(1,1),wwk(1,2),wwk(1,3),wwk(1,4),wwk(1,5),wwk(1,6),wwk(1,7))
c$$$cdebug
c$$$      write(6,1918)(nr,vxc(nr,1),grad(nr,1),grad(nr,2),nr=1400,mesh)
c$$$ 1918 format('WBEX:',i4,3d20.10)
c$$$cdebug
c
c Form the potential
c
       do ig=1,mesh
        vxc(ig,ispin)=vxc(ig,ispin)+grad(ig,2)+2.d0/rad(ig)*grad(ig,1)
       enddo

c$$$
#ifdef GGA_CHECK
       write(6,'(" after gradient correction for ex ( xc_gga_rad )")')
       write(6,'(" rad, rho, vxc")')
       do ig = 1, mesh
         write(6,'(" ( ",i4,") rad, rho, vxc = ",3d20.8," (exch)")')
     &        ig, rad(ig), rh(ig,1)/(pi4*rad(ig)**2), vxc(ig,1)
       end do
#endif
c
c Sum up the exchange energy
c
       do ig = 1,mesh
          exc = exc + pi4*grad(ig,0)*rad(ig)**2*omo(ig)/dble(nspin)
       enddo
c
c     Spin loop end
c
      end do
c
c Correlation part.
c
c
c Initialization
c
      call rsreal(kmesh*3,grad)
c
c Form the total charge density
c
      do ispin=1,nspin
       do nr=1,mesh
        grad(nr,0) = grad(nr,0)+rh(nr,ispin)/(pi4*rad(nr)**2)
       enddo
      enddo

      if( xctype.eq.'ggapw91'.or.xctype.eq.'ggapbe '
     &.or.xctype.eq.'GGAPW91'.or.xctype.eq.'GGAPBE '
     &.or.xctype.eq.'revpbe '.or.xctype.eq.'REVPBE '
     &.or.xctype.eq.'rpbe   '.or.xctype.eq.'RPBE   ') then
c
c Form the density gradients in the real space.
c
c
c The first derivatives of the charge density.
c
         call newto2
     >   (kmesh,mesh,rad,grad(1,0)
     <   ,grad(1,1)
     w ,wwk(1,1),wwk(1,2),wwk(1,3),wwk(1,4),wwk(1,5),wwk(1,6),wwk(1,7))
      end if
#ifdef GGA_CHECK
      write(6,'(" after newto2 for cr ( xc_gga_rad )")')
      write(6,'(" rad, rho, grad(*,1)")')
      do ig = 1, mesh
         write(6,'(" ( ",i4,") rad, rho, grad = ",3d20.8," (corl)")')
     &        ig, rad(ig), grad(ig,0), grad(ig,1)
      end do
#endif
c
c Form the spin polarization.
c
      if(nspin.eq.2) then
        do ig=1,mesh
         grad(ig,2) = (rh(ig,1)-rh(ig,2))/(rh(ig,1)+rh(ig,2))
        enddo
      endif
c
c Form the Correlation potential and energy
c
      call CORPBE_wb_rad
     > (kmesh,mesh,kspin,nspin,lgga,eps_chg,eps_grad
     = ,grad,vxc)
c
c Construct GGA correction for the correlation potential.
c
       call newto2
     > (kmesh,mesh,rad,grad(1,1)
     < ,grad(1,2)
     w ,wwk(1,1),wwk(1,2),wwk(1,3),wwk(1,4),wwk(1,5),wwk(1,6),wwk(1,7))
c
c Sumup
c

c$$$cdebug
c$$$      write(6,1991)(nr,vxc(nr,1),grad(nr,2)+2.d0/rad(nr)*grad(nr,1)
c$$$     &             ,nr=1400,mesh)
c$$$ 1991 format('EXCR:',i4,2d20.10)
c$$$cdebug

c
c Form the potential
c
c$$$      write(6,'(" before gradient correction for cr ( xc_gga_rad )")')
c$$$      write(6,'(" vxc, rho, rad")')
c$$$
c$$$      do ig = 1, mesh
c$$$         write(6,'(" ( ",i4,") rad, rho, vxc = ",3d20.8," (corl)")')
c$$$     &        ig, rad(ig), rh(ig,1)/(pi4*rad(ig)**2), vxc(ig,1)
c$$$      end do
c$$$      write(6,'(" ---")')
c$$$      do ig = mesh-10+1, mesh
c$$$         write(6,'(" ( ",i4,") rad, rho, vxc = ",3d20.8)')
c$$$     &        ig, rad(ig), rh(ig,1)/(pi4*rad(ig)**2), vxc(ig,1)
c$$$      end do

      do ispin=1,nspin
       do ig=1,mesh
         vxc(ig,ispin)=vxc(ig,ispin)+grad(ig,2)+2.d0/rad(ig)*grad(ig,1)
       enddo
      enddo
#ifdef GGA_CHECK
      write(6,'(" after gradient correction for cr ( xc_gga_rad )")')
      write(6,'(" rad, rho, vxc")')
      do ig = 1, mesh
         write(6,'(" ( ",i4,") rad,rho,vxc,v4,v5 = "
     &        ,5d18.6," (corl)")')
     &        ig, rad(ig), rh(ig,1)/(pi4*rad(ig)**2), vxc(ig,1)
     &        , 2/rad(ig)*grad(ig,1), grad(ig,2)
      end do
#endif
c
c Sum up the correlation energy
c
      do ig = 1,mesh
         exc = exc + pi4*grad(ig,0)*rad(ig)**2*omo(ig)
      enddo
c
c Cut error in low density region
c
      do ispin = 1,nspin
       do nr=mesh,1,-1
        if(rh(nr,ispin)/(pi4*rad(nr)**2).gt.eps_chg) then
          ncut = nr
          goto 1001
        endif
       enddo
 1001  continue
       do nr=ncut+1,mesh
        vxc(nr,ispin) = 0.d0
       enddo
      enddo
      return
      end
c----------------------------------------------------------------------
c######################################################################
c----------------------------------------------------------------------
      SUBROUTINE EXCHPBE_wb_rad
     > (kmesh,mesh,lgga,eps_chg
     = ,grad,vxc)
c----------------------------------------------------------------------
C  PBE EXCHANGE FOR A SPIN-UNPOLARIZED ELECTRONIC SYSTEM
c  K Burke's modification of PW91 codes, May 14, 1996
c  Modified again by K. Burke, June 29, 1996, with simpler Fx(s)
c
c----------------------------------------------------------------------
c  Modified to adopt White and Bird scheme(PRB50, 4954 (1994))
c  for GGA potential construction. by Y. Morikawa(JRCAT-NAIR),August 3, 1998.
c
c  Modified to built into gncpp program code. Y.Morikawa August 7th, 1998.
c
c  Inputs:
c   grad(kmesh,0) : rho
c   grad(kmesh,1) : d(rho)/dr
c  Outputs:
c   grad(kmesh,0) : rho * e_x
c   grad(kmesh,1) : d(rho)/dr * partial(f_x)/partial(|Grad rho|) / |Grad rho|
c   vxc( kmesh)   : ++ partial(f_x)/partial(rho)
c----------------------------------------------------------------------
c----------------------------------------------------------------------
C  INPUT rho : DENSITY
C  INPUT S:  ABS(GRAD rho)/(2*KF*rho), where kf=(3 pi^2 rho)^(1/3)
C  INPUT U:  (GRAD rho)*GRAD(ABS(GRAD rho))/(rho**2 * (2*KF)**3)
C  INPUT V: (LAPLACIAN rho)/(rho*(2*KF)**2)
c   (for U,V, see PW86(24))
c  input lgga:  (=0=>don't put in gradient corrections, just LDA)
c  input lpot:  (=0=>don't get potential and don't need U and V)
C  OUTPUT:  EXCHANGE ENERGY PER ELECTRON (EX) AND POTENTIAL (VX)
c----------------------------------------------------------------------
c----------------------------------------------------------------------
c References:
c [a]J.P.~Perdew, K.~Burke, and M.~Ernzerhof, submiited to PRL, May96
c [b]J.P. Perdew and Y. Wang, Phys. Rev.  B {\bf 33},  8800  (1986);
c     {\bf 40},  3399  (1989) (E).
c----------------------------------------------------------------------
c----------------------------------------------------------------------
c Formulas:
c   	e_x[unif]=ax*rho^(4/3)  [LDA]
c ax = -0.75*(3/pi)^(1/3)
c	e_x[PBE]=e_x[unif]*FxPBE(s)
c	FxPBE(s)=1+uk-uk/(1+ul*s*s)                 [a](13)
c uk, ul defined after [a](13) 
c----------------------------------------------------------------------
c----------------------------------------------------------------------
cYM
      use m_Const_Parameters, only : PAI
      implicit none
      real*8 thrd,thrd4,pi,ax,um,uk,ul,exunif,rho,grad_rho,s,s2,k_f2
     & ,thrpi2,P0,FxPBE,Fs,vxg,eps_chg
cYM
      parameter(thrd=1.d0/3.d0,thrd4=4.d0/3.d0)
      parameter(pi=PAI)
      parameter(ax=-0.738558766382022405884230032680836d0)
      parameter(um=0.2195149727645171d0,uk=0.8040d0,ul=um/uk)
c revPBE parameter Y.M 1998/08/14
c      parameter(um=0.2195149727645171d0,uk=1.2450d0,ul=um/uk)
c revPBE parameter Y.M 1998/08/14
cYM
      parameter(thrpi2 = 3.d0*pi*pi)
      integer kmesh,mesh,lgga,nr
      real*8 grad(kmesh,0:*), vxc(kmesh)
cYM
#ifdef GGA_CHECK
      write(6,'(" -- EXCHPBE_wb_rad --")')
#endif
c----------------------------------------------------------------------
c----------------------------------------------------------------------
c construct LDA exchange energy density
      if(lgga.eq.0)then
        do nr = 1,mesh
         rho        = max(grad(nr,0),eps_chg)
         exunif     = AX*rho**THRD
         grad(nr,0) = exunif*rho
         vxc( nr)   = vxc( nr) + exunif*thrd4
#ifdef GGA_CHECK
         write(6,'(" (",i4,") rho, vxc = ",2d20.8)') nr, rho, vxc(nr)
#endif
        end do
	return
      endif
c----------------------------------------------------------------------
c----------------------------------------------------------------------
      do nr=1,mesh
       rho    = max(grad(nr,0),eps_chg)
c construct LDA exchange energy density
       exunif = AX*rho**THRD
c
c Form S = ABS(Grad rho)/(2*k_F*rho)
c
       grad_rho = abs(  grad(nr,1))
       k_f2     = (thrpi2*rho)**thrd*2.d0
       s        = grad_rho/(k_f2*rho)
c
c construct PBE enhancement factor
c
       S2 = S*S
       P0=1.d0+ul*S2
       FxPBE = 1d0+uk-uk/P0
c       EX = exunif*FxPBE
ccheck
       if(abs(grad(nr,0)).lt.eps_chg) FxPBE = 1.d0
ccheck
       grad(nr,0) =  exunif*FxPBE*rho
c----------------------------------------------------------------------
c----------------------------------------------------------------------
C  ENERGY DONE. NOW THE POTENTIAL:
c  find first and second derivatives of Fx w.r.t s.
c  Fs=(1/s)*d FxPBE/ ds
c
       Fs=2.d0*uk*ul/(P0*P0)
ccheck
       if(abs(grad(nr,0)).lt.eps_chg) Fs = 0.d0
ccheck
       vxc(nr) = vxc(nr) + THRD4*exunif*(FxPBE-FS*S2)
c
c
c
       vxg           = 0.375d0*Fs/(pi*k_f2*rho)
       grad(nr,1)    = grad(nr,1) * vxg

#ifdef GGA_CHECK
       write(6,'(" (",i4,") rho, vxc = ",2d20.8," (EXCHPBE_wb_rad)")')
     &      nr, rho, vxc(nr)
#endif

      end do


      RETURN
      END
c----------------------------------------------------------------------
c######################################################################
c----------------------------------------------------------------------
      SUBROUTINE EXCHrevPBE_wb_rad
     > (kmesh,mesh,lgga,eps_chg
     = ,grad,vxc)
c----------------------------------------------------------------------
C  PBE EXCHANGE FOR A SPIN-UNPOLARIZED ELECTRONIC SYSTEM
c  K Burke's modification of PW91 codes, May 14, 1996
c  Modified again by K. Burke, June 29, 1996, with simpler Fx(s)
c
c----------------------------------------------------------------------
c  Modified to adopt White and Bird scheme(PRB50, 4954 (1994))
c  for GGA potential construction. by Y. Morikawa(JRCAT-NAIR),August 3, 1998.
c
c  Modified to built into gncpp program code. Y.Morikawa August 7th, 1998.
c
c  Inputs:
c   grad(kmesh,0) : rho
c   grad(kmesh,1) : d(rho)/dr
c  Outputs:
c   grad(kmesh,0) : rho * e_x
c   grad(kmesh,1) : d(rho)/dr * partial(f_x)/partial(|Grad rho|) / |Grad rho|
c   vxc( kmesh)   : ++ partial(f_x)/partial(rho)
c----------------------------------------------------------------------
c----------------------------------------------------------------------
C  INPUT rho : DENSITY
C  INPUT S:  ABS(GRAD rho)/(2*KF*rho), where kf=(3 pi^2 rho)^(1/3)
C  INPUT U:  (GRAD rho)*GRAD(ABS(GRAD rho))/(rho**2 * (2*KF)**3)
C  INPUT V: (LAPLACIAN rho)/(rho*(2*KF)**2)
c   (for U,V, see PW86(24))
c  input lgga:  (=0=>don't put in gradient corrections, just LDA)
c  input lpot:  (=0=>don't get potential and don't need U and V)
C  OUTPUT:  EXCHANGE ENERGY PER ELECTRON (EX) AND POTENTIAL (VX)
c----------------------------------------------------------------------
c----------------------------------------------------------------------
c References:
c [a]J.P.~Perdew, K.~Burke, and M.~Ernzerhof, submiited to PRL, May96
c [b]J.P. Perdew and Y. Wang, Phys. Rev.  B {\bf 33},  8800  (1986);
c     {\bf 40},  3399  (1989) (E).
c----------------------------------------------------------------------
c----------------------------------------------------------------------
c Formulas:
c   	e_x[unif]=ax*rho^(4/3)  [LDA]
c ax = -0.75*(3/pi)^(1/3)
c	e_x[PBE]=e_x[unif]*FxPBE(s)
c	FxPBE(s)=1+uk-uk/(1+ul*s*s)                 [a](13)
c uk, ul defined after [a](13) 
c----------------------------------------------------------------------
c----------------------------------------------------------------------
cYM
      use m_Const_Parameters, only : PAI
      implicit none
      real*8 thrd,thrd4,pi,ax,um,uk,ul,exunif,rho,grad_rho,s,s2,k_f2
     & ,thrpi2,P0,FxPBE,Fs,vxg,eps_chg
cYM
      parameter(thrd=1.d0/3.d0,thrd4=4.d0/3.d0)
      parameter(pi=PAI)
      parameter(ax=-0.738558766382022405884230032680836d0)
c$$$  parameter(um=0.2195149727645171d0,uk=0.8040d0,ul=um/uk)
c revPBE parameter Y.M 1998/08/14
      parameter(um=0.2195149727645171d0,uk=1.2450d0,ul=um/uk)
c revPBE parameter Y.M 1998/08/14
cYM
      parameter(thrpi2 = 3.d0*pi*pi)
      integer kmesh,mesh,lgga,nr
      real*8 grad(kmesh,0:*), vxc(kmesh)
cYM
c----------------------------------------------------------------------
c----------------------------------------------------------------------
c construct LDA exchange energy density
      if(lgga.eq.0)then
        do nr = 1,mesh
         rho        = max(grad(nr,0),eps_chg)
         exunif     = AX*rho**THRD
         grad(nr,0) = exunif*rho
         vxc( nr)   = vxc( nr) + exunif*thrd4
        end do
	return
      endif
c----------------------------------------------------------------------
c----------------------------------------------------------------------
      do nr=1,mesh
       rho    = max(grad(nr,0),eps_chg)
c construct LDA exchange energy density
       exunif = AX*rho**THRD
c
c Form S = ABS(Grad rho)/(2*k_F*rho)
c
       grad_rho = abs(  grad(nr,1))
       k_f2     = (thrpi2*rho)**thrd*2.d0
       s        = grad_rho/(k_f2*rho)
c
c construct PBE enhancement factor
c
       S2 = S*S
       P0=1.d0+ul*S2
       FxPBE = 1d0+uk-uk/P0
c       EX = exunif*FxPBE
ccheck
       if(abs(grad(nr,0)).lt.eps_chg) FxPBE = 1.d0
ccheck
       grad(nr,0) =  exunif*FxPBE*rho
c----------------------------------------------------------------------
c----------------------------------------------------------------------
C  ENERGY DONE. NOW THE POTENTIAL:
c  find first and second derivatives of Fx w.r.t s.
c  Fs=(1/s)*d FxPBE/ ds
c
       Fs=2.d0*uk*ul/(P0*P0)
ccheck
       if(abs(grad(nr,0)).lt.eps_chg) Fs = 0.d0
ccheck
       vxc(nr) = vxc(nr) + THRD4*exunif*(FxPBE-FS*S2)
c
c
c
       vxg           = 0.375d0*Fs/(pi*k_f2*rho)
       grad(nr,1)    = grad(nr,1) * vxg
      end do
      RETURN
      END
c----------------------------------------------------------------------
c######################################################################
c----------------------------------------------------------------------
      SUBROUTINE EXCHRPBE_wb_rad
     > (kmesh,mesh,lgga,eps_chg
     = ,grad,vxc)
c----------------------------------------------------------------------
C  PBE EXCHANGE FOR A SPIN-UNPOLARIZED ELECTRONIC SYSTEM
c  K Burke's modification of PW91 codes, May 14, 1996
c  Modified again by K. Burke, June 29, 1996, with simpler Fx(s)
c
c  Revised PBE functional after B.Hammer, L.B. Hansen and J.K. Noerskov
c
c----------------------------------------------------------------------
c  Modified to adopt White and Bird scheme(PRB50, 4954 (1994))
c  for GGA potential construction. by Y. Morikawa(JRCAT-NAIR),August 3, 1998.
c
c  Modified to built into gncpp program code. Y.Morikawa August 7th, 1998.
c
c  Inputs:
c   grad(kmesh,0) : rho
c   grad(kmesh,1) : d(rho)/dr
c  Outputs:
c   grad(kmesh,0) : rho * e_x
c   grad(kmesh,1) : d(rho)/dr * partial(f_x)/partial(|Grad rho|) / |Grad rho|
c   vxc( kmesh)   : ++ partial(f_x)/partial(rho)
c----------------------------------------------------------------------
c----------------------------------------------------------------------
C  INPUT rho : DENSITY
C  INPUT S:  ABS(GRAD rho)/(2*KF*rho), where kf=(3 pi^2 rho)^(1/3)
C  INPUT U:  (GRAD rho)*GRAD(ABS(GRAD rho))/(rho**2 * (2*KF)**3)
C  INPUT V: (LAPLACIAN rho)/(rho*(2*KF)**2)
c   (for U,V, see PW86(24))
c  input lgga:  (=0=>don't put in gradient corrections, just LDA)
c  input lpot:  (=0=>don't get potential and don't need U and V)
C  OUTPUT:  EXCHANGE ENERGY PER ELECTRON (EX) AND POTENTIAL (VX)
c----------------------------------------------------------------------
c----------------------------------------------------------------------
c References:
c [a]J.P.~Perdew, K.~Burke, and M.~Ernzerhof, submiited to PRL, May96
c [b]J.P. Perdew and Y. Wang, Phys. Rev.  B {\bf 33},  8800  (1986);
c     {\bf 40},  3399  (1989) (E).
c----------------------------------------------------------------------
c----------------------------------------------------------------------
c Formulas:
c   	e_x[unif]=ax*rho^(4/3)  [LDA]
c ax = -0.75*(3/pi)^(1/3)
c	e_x[PBE]=e_x[unif]*FxPBE(s)
c$$$	FxPBE(s)=1+uk-uk/(1+ul*s*s)                 [a](13)
c	FxPBE(s)=1+uk-uk*exp(-ul*s*s)
c uk, ul defined after [a](13) 
c----------------------------------------------------------------------
c----------------------------------------------------------------------
cYM
      use m_Const_Parameters, only : PAI
      implicit none
      real*8 thrd,thrd4,pi,ax,um,uk,ul,exunif,rho,grad_rho,s,s2,k_f2
     & ,thrpi2,FxPBE,Fs,vxg,eps_chg
c$$$     & ,P0
cYM
      parameter(thrd=1.d0/3.d0,thrd4=4.d0/3.d0)
      parameter(pi=PAI)
      parameter(ax=-0.738558766382022405884230032680836d0)
      parameter(um=0.2195149727645171d0,uk=0.8040d0,ul=um/uk)
c revPBE parameter Y.M 1998/08/14
c      parameter(um=0.2195149727645171d0,uk=1.2450d0,ul=um/uk)
c revPBE parameter Y.M 1998/08/14
cYM
      parameter(thrpi2 = 3.d0*pi*pi)
      integer kmesh,mesh,lgga,nr
      real*8 grad(kmesh,0:*), vxc(kmesh)
cYM
c----------------------------------------------------------------------
c----------------------------------------------------------------------
c construct LDA exchange energy density
      if(lgga.eq.0)then
        do nr = 1,mesh
         rho        = max(grad(nr,0),eps_chg)
         exunif     = AX*rho**THRD
         grad(nr,0) = exunif*rho
         vxc( nr)   = vxc( nr) + exunif*thrd4
        end do
	return
      endif
c----------------------------------------------------------------------
c----------------------------------------------------------------------
      do nr=1,mesh
       rho    = max(grad(nr,0),eps_chg)
c construct LDA exchange energy density
       exunif = AX*rho**THRD
c
c Form S = ABS(Grad rho)/(2*k_F*rho)
c
       grad_rho = abs(  grad(nr,1))
       k_f2     = (thrpi2*rho)**thrd*2.d0
       s        = grad_rho/(k_f2*rho)
c
c construct PBE enhancement factor
c
       S2 = S*S
c$$$       P0=1.d0+ul*S2
c$$$   FxPBE = 1d0+uk-uk/P0
       FxPBE = 1d0+uk-uk*exp(-ul*s2)
c       EX = exunif*FxPBE
ccheck
       if(abs(grad(nr,0)).lt.eps_chg) FxPBE = 1.d0
ccheck
       grad(nr,0) =  exunif*FxPBE*rho
c----------------------------------------------------------------------
c----------------------------------------------------------------------
C  ENERGY DONE. NOW THE POTENTIAL:
c  find first and second derivatives of Fx w.r.t s.
c  Fs=(1/s)*d FxPBE/ ds
c
c$$$   Fs=2.d0*uk*ul/(P0*P0)
       Fs=2.d0*uk*ul*exp(-ul*s2)
ccheck
       if(abs(grad(nr,0)).lt.eps_chg) Fs = 0.d0
ccheck
       vxc(nr) = vxc(nr) + THRD4*exunif*(FxPBE-FS*S2)
c
c
c
       vxg           = 0.375d0*Fs/(pi*k_f2*rho)
       grad(nr,1)    = grad(nr,1) * vxg
      end do
      RETURN
      END
c----------------------------------------------------------------------
c######################################################################
c----------------------------------------------------------------------
      SUBROUTINE CORPBE_wb_rad
     > (kmesh,mesh,kspin,nspin,lgga,eps_chg,eps_grad
     = ,grad,vxc)
c----------------------------------------------------------------------
c  Official PBE correlation code. K. Burke, May 14, 1996.
C  INPUT: RS=SEITZ RADIUS=(3/4pi rho)^(1/3)
C       : ZET=RELATIVE SPIN POLARIZATION = (rhoup-rhodn)/rho
C       : t=ABS(GRAD rho)/(rho*2.*KS*G)  -- only needed for PBE
C       : UU=(GRAD rho)*GRAD(ABS(GRAD rho))/(rho**2 * (2*KS*G)**3)
C       : VV=(LAPLACIAN rho)/(rho * (2*KS*G)**2)
C       : WW=(GRAD rho)*(GRAD ZET)/(rho * (2*KS*G)**2
c       :  UU,VV,WW, only needed for PBE potential
c       : lgga=flag to do gga (0=>LSD only)
c       : lpot=flag to do potential (0=>energy only)
c  output: ec=lsd correlation energy from [a]
c        : vcup=lsd up correlation potential
c        : vcdn=lsd dn correlation potential
c        : h=NONLOCAL PART OF CORRELATION ENERGY PER ELECTRON
c        : dvcup=nonlocal correction to vcup
c        : dvcdn=nonlocal correction to vcdn
c----------------------------------------------------------------------
c  Modified to adopt White and Bird scheme(PRB50, 4954 (1994))
c  for GGA potential construction. by Y. Morikawa(JRCAT-NAIR),August 4, 1998.
c  Inputs:
c   grad(kmesh,0) : rho=rho_up+rho_down
c   grad(kmesh,1) : d(rho)/dr
c   grad(kmesh,2) : (rho_up-rho_down)/(rho_up+rho_dowm)
c  Outputs:
c   grad(kmesh,0) : rho * e_c
c   grad(kmesh,1) : d(rho)/dr * d(f_c)/d(|Grad rho|) / |Grad rho|
c   vxc( kmesh,ispin) : ++ partial(f_c)/partial(rho)
c----------------------------------------------------------------------
c----------------------------------------------------------------------
c References:
c [a] J.P.~Perdew, K.~Burke, and M.~Ernzerhof, 
c     {\sl Generalized gradient approximation made simple}, sub.
c     to Phys. Rev.Lett. May 1996.
c [b] J. P. Perdew, K. Burke, and Y. Wang, {\sl Real-space cutoff
c     construction of a generalized gradient approximation:  The PW91
c     density functional}, submitted to Phys. Rev. B, Feb. 1996.
c [c] J. P. Perdew and Y. Wang, Phys. Rev. B {\bf 45}, 13244 (1992).
c----------------------------------------------------------------------
c----------------------------------------------------------------------
cYM
      use m_Const_Parameters, only : PAI
      implicit none
      integer kmesh,mesh,kspin,nspin,ig,lgga
      real*8 grad(kmesh,0:2), vxc( kmesh,kspin  )
cYM
c thrd*=various multiples of 1/3
c numbers for use in LSD energy spin-interpolation formula, [c](9).
c      GAM= 2^(4/3)-2
c      FZZ=f''(0)= 8/(9*GAM)
c numbers for construction of PBE
c      gamma=(1-log(2))/pi^2
c      bet=coefficient in gradient expansion for correlation, [a](4).
c      eta=small number to stop d phi/ dzeta from blowing up at 
c          |zeta|=1.
      real*8 thrd,thrdm,thrd2,sixthm,thrd4,GAM,fzz,gamma,bet,delt,eta
      parameter(thrd=1.d0/3.d0,thrdm=-thrd,thrd2=2.d0*thrd)
      parameter(sixthm=thrdm/2.d0)
      parameter(thrd4=4.d0*thrd)
      parameter(GAM=0.5198420997897463295344212145565d0)
      parameter(fzz=8.d0/(9.d0*GAM))
      parameter(gamma=0.03109069086965489503494086371273d0)
      parameter(bet=0.06672455060314922d0,delt=bet/gamma)
      parameter(eta=1.d-12)
cYM
      real*8 rs, rtrs, zet, pi,thopi,tho4pi,third,sixth,Q0,Q1,Q2,Q3
      parameter(pi=PAI)
      parameter(thopi=3.d0/pi,tho4pi=3.d0/(pi*4.d0)
     & ,third=1.d0/3.d0,sixth=1.d0/6.d0)
      real*8 Au,a1u,b1u,b2u,b3u,b4u,eu,eurs
     &      ,Ap,a1p,b1p,b2p,b3p,b4p,ep,eprs
     &      ,Aa,a1a,b1a,b2a,b3a,b4a,alfm,alfrsm
      parameter(Au  = 0.0310907D0 , a1u = 0.21370D0, b1u = 7.5957D0
     &         ,b2u = 3.5876D0    , b3u = 1.6382D0 , b4u = 0.49294D0)
      parameter(Ap  = 0.01554535D0, a1p = 0.20548D0, b1p =14.1189D0
     &         ,b2p = 6.1977D0    , b3p = 3.3662D0 , b4p = 0.62517D0)
      parameter(Aa  = 0.0168869D0 , a1a = 0.11125D0, b1a =10.357D0
     &         ,b2a = 3.6231D0    , b3a = 0.88026D0, b4a = 0.49671D0)
      real*8 rho,grad_rho,eps_grad,eps_chg,z4,f,ec,ecrs,fz,eczet
     & ,comm,g,g3,k_s,k_s2phi,T,PON,B,B2,T2,T4,Q4,Q5,H,G4,T6
     & ,RSTHRD,GZ,FAC,BG,BEC,Q8,Q9,hB,hRS,hZ,hT,pref,vcg
c$$$     & ,alfc
cYM
c----------------------------------------------------------------------
c----------------------------------------------------------------------
c find LSD energy contributions, using [c](10) and Table I[c].
c EU=unpolarized LSD correlation energy
c EURS=dEU/drs
c EP=fully polarized LSD correlation energy
c EPRS=dEP/drs
c ALFM=-spin stiffness, [c](3).
c ALFRSM=-dalpha/drs
c F=spin-scaling factor from [c](9).
c construct ec, using [c](8)

#ifdef GGA_CHECK
      write(6,'(" -- CORPBE_wb_rad --")')
#endif

      if(lgga.eq.0) then
c
c Only LSDA
c
      do ig = 1,mesh

       rho    = max(grad(ig,0),eps_chg)
       zet    = grad(ig,2)
       rs     = (1.d0/rho*tho4pi)**third
       rtrs=dsqrt(rs)

       Q0 = -2.D0*Au*(1.D0+A1u*rtrs*rtrs)
       Q1 =  2.D0*Au*rtrs*(B1u+rtrs*(B2u+rtrs*(B3u+B4u*rtrs)))
       Q2 =  DLOG(1.D0+1.D0/Q1)
       eu =  Q0*Q2
       Q3 =  Au*(B1u/rtrs+2.D0*B2u+rtrs*(3.D0*B3u+4.D0*B4u*rtrs))
       eurs = -2.D0*Au*A1u*Q2-Q0*Q3/(Q1*(1.d0+Q1))

       Q0 = -2.D0*Ap*(1.D0+A1p*rtrs*rtrs)
       Q1 =  2.D0*Ap*rtrs*(B1p+rtrs*(B2p+rtrs*(B3p+B4p*rtrs)))
       Q2 =  DLOG(1.D0+1.D0/Q1)
       ep =  Q0*Q2
       Q3 =  Ap*(B1p/rtrs+2.D0*B2p+rtrs*(3.D0*B3p+4.D0*B4p*rtrs))
       eprs = -2.D0*Ap*A1p*Q2-Q0*Q3/(Q1*(1.d0+Q1))

       Q0 = -2.D0*Aa*(1.D0+A1a*rtrs*rtrs)
       Q1 =  2.D0*Aa*rtrs*(B1a+rtrs*(B2a+rtrs*(B3a+B4a*rtrs)))
       Q2 =  DLOG(1.D0+1.D0/Q1)
       alfm =  Q0*Q2
       Q3 =  Aa*(B1a/rtrs+2.D0*B2a+rtrs*(3.D0*B3a+4.D0*B4a*rtrs))
       alfrsm = -2.D0*Ap*A1p*Q2-Q0*Q3/(Q1*(1.d0+Q1))

c$$$       ALFC = -ALFM
       Z4 = ZET**4
       F=((1.D0+ZET)**THRD4+(1.D0-ZET)**THRD4-2.D0)/GAM
       EC = EU*(1.D0-F*Z4)+EP*F*Z4-ALFM*F*(1.D0-Z4)/FZZ
c----------------------------------------------------------------------
c----------------------------------------------------------------------
c LSD potential from [c](A1)
c ECRS = dEc/drs [c](A2)
c ECZET=dEc/dzeta [c](A3)
c FZ = dF/dzeta [c](A4)
       ECRS = EURS*(1.D0-F*Z4)+EPRS*F*Z4-ALFRSM*F*(1.D0-Z4)/FZZ
       FZ   = THRD4*((1.D0+ZET)**THRD-(1.D0-ZET)**THRD)/GAM
       ECZET = 4.D0*(ZET**3)*F*(EP-EU+ALFM/FZZ)+FZ*(Z4*EP-Z4*EU
     1        -(1.D0-Z4)*ALFM/FZZ)
       COMM = EC -RS*ECRS/3.D0-ZET*ECZET

       grad(ig,0)     = rho*ec
       vxc( ig,1    ) = vxc(ig,1    ) + COMM + ECZET
       if(nspin.eq.2) 
     & vxc( ig,nspin) = vxc(ig,nspin) + COMM - ECZET

#ifdef GGA_CHECK
       write(6,'(" (",i4,") rho, vxc = ",2d18.8)') ig, rho, vxc(ig,1)
#endif
      enddo
      return
      endif
c----------------------------------------------------------------------

c
c LSDA + PBE Gradient Correction
c
      do ig = 1,mesh

       rho    = max(grad(ig,0),eps_chg)
       zet    = grad(ig,2)
       rs     = (1.d0/rho*tho4pi)**third
       rtrs=dsqrt(rs)

       Q0 = -2.D0*Au*(1.D0+A1u*rtrs*rtrs)
       Q1 =  2.D0*Au*rtrs*(B1u+rtrs*(B2u+rtrs*(B3u+B4u*rtrs)))
       Q2 =  DLOG(1.D0+1.D0/Q1)
       eu =  Q0*Q2
       Q3 =  Au*(B1u/rtrs+2.D0*B2u+rtrs*(3.D0*B3u+4.D0*B4u*rtrs))
       eurs = -2.D0*Au*A1u*Q2-Q0*Q3/(Q1*(1.d0+Q1))

       Q0 = -2.D0*Ap*(1.D0+A1p*rtrs*rtrs)
       Q1 =  2.D0*Ap*rtrs*(B1p+rtrs*(B2p+rtrs*(B3p+B4p*rtrs)))
       Q2 =  DLOG(1.D0+1.D0/Q1)
       ep =  Q0*Q2
       Q3 =  Ap*(B1p/rtrs+2.D0*B2p+rtrs*(3.D0*B3p+4.D0*B4p*rtrs))
       eprs = -2.D0*Ap*A1p*Q2-Q0*Q3/(Q1*(1.d0+Q1))

       Q0 = -2.D0*Aa*(1.D0+A1a*rtrs*rtrs)
       Q1 =  2.D0*Aa*rtrs*(B1a+rtrs*(B2a+rtrs*(B3a+B4a*rtrs)))
       Q2 =  DLOG(1.D0+1.D0/Q1)
       alfm =  Q0*Q2
       Q3 =  Aa*(B1a/rtrs+2.D0*B2a+rtrs*(3.D0*B3a+4.D0*B4a*rtrs))
       alfrsm = -2.D0*Ap*A1p*Q2-Q0*Q3/(Q1*(1.d0+Q1))

c$$$       ALFC = -ALFM
       Z4 = ZET**4
       F=((1.D0+ZET)**THRD4+(1.D0-ZET)**THRD4-2.D0)/GAM
       EC = EU*(1.D0-F*Z4)+EP*F*Z4-ALFM*F*(1.D0-Z4)/FZZ
c----------------------------------------------------------------------
c----------------------------------------------------------------------
c LSD potential from [c](A1)
c ECRS = dEc/drs [c](A2)
c ECZET=dEc/dzeta [c](A3)
c FZ = dF/dzeta [c](A4)
       ECRS = EURS*(1.D0-F*Z4)+EPRS*F*Z4-ALFRSM*F*(1.D0-Z4)/FZZ
       FZ   = THRD4*((1.D0+ZET)**THRD-(1.D0-ZET)**THRD)/GAM
       ECZET = 4.D0*(ZET**3)*F*(EP-EU+ALFM/FZZ)+FZ*(Z4*EP-Z4*EU
     1        -(1.D0-Z4)*ALFM/FZZ)
       COMM = EC -RS*ECRS/3.D0-ZET*ECZET

       grad(ig,0)     = rho*ec
       vxc( ig,1    ) = vxc(ig,1    ) + COMM + ECZET
       if(nspin.eq.2) 
     & vxc( ig,nspin) = vxc(ig,nspin) + COMM - ECZET
c----------------------------------------------------------------------
c PBE correlation energy
c G=phi(zeta), given after [a](3)
c DELT=bet/gamma
c B=A of [a](8)

       G  =((1.d0+ZET)**thrd2+(1.d0-ZET)**thrd2)/2.d0
       G3 = G**3

       grad_rho = max(abs(grad(ig,1)),eps_grad)
c$$$       grad_rho = abs(grad(ig,1))

       k_s      = 2.d0*(thopi*rho)**sixth
       k_s2phi  = 2.d0*k_s*g
       t  = grad_rho/(rho*k_s2phi)

       PON=-EC/(G3*gamma)
       B  = DELT/(DEXP(PON)-1.D0)
       B2 = B*B
       T2 = T*T
       T4 = T2*T2
c$$$       RS2 = RS*RS
       Q4 = 1.D0+B*T2
       Q5 = 1.D0+B*T2+B2*T4
       H = G3*(BET/DELT)*DLOG(1.D0+DELT*Q4*T2/Q5)
ccheck
       if(abs(grad(ig,0)).lt.eps_chg) H = 0.d0
ccheck
c----------------------------------------------------------------------
c----------------------------------------------------------------------
C ENERGY DONE. NOW THE POTENTIAL, using appendix E of [b].
       G4 = G3*G
       T6 = T4*T2
       RSTHRD = RS/3.D0
       GZ=(((1.d0+zet)**2+eta)**sixthm-
     1     ((1.d0-zet)**2+eta)**sixthm)/3.d0
       FAC = DELT/B+1.D0
       BG = -3.D0*B2*EC*FAC/(BET*G4)
       BEC = B2*FAC/(BET*G3)
       Q8 = Q5*Q5+DELT*Q4*Q5*T2
       Q9 = 1.D0+2.D0*B*T2
       hB = -BET*G3*B*T6*(2.D0+B*T2)/Q8
       hRS = -RSTHRD*hB*BEC*ECRS
       hZ = 3.D0*GZ*h/G + hB*(BG*GZ+BEC*ECZET)
       hT = 2.d0*BET*G3*Q9/Q8

       COMM = H+HRS-7.d0*T2*HT/6.D0
       PREF = HZ-GZ*T2*HT/G
       COMM = COMM-PREF*ZET

       vcg  = -t*hT/(grad_rho*k_s2phi)
c
c GGA energy correction
c
       grad(ig,0)     = grad(ig,0)+rho*H
c
c GGA potential correction
c
ccheck
       if(abs(grad(ig,0)).lt.eps_chg) COMM = 0.d0
       if(abs(grad(ig,0)).lt.eps_chg) PREF = 0.d0
       if(abs(grad(ig,0)).lt.eps_chg) vcg = 0.d0
ccheck
       vxc(ig,1    ) = vxc(ig,1    ) + COMM + PREF
       if(nspin.eq.2)
     & vxc(ig,nspin) = vxc(ig,nspin) + COMM - PREF
c
c GGA potential correction
c
       grad(ig,1)    = grad(ig,1) * vcg
#ifdef GGA_CHECK
       write(6,'(" (",i4,") rho, vxc = ",2d18.8)') ig, rho, vxc(ig,1)
#endif
      enddo
      RETURN
      END


      SUBROUTINE NEWTO2
     >                 (KMESH,MESH,X,A,
     <                  B,
     W                  A1,A2,A3,A4,A5,A6,A7)
C    FUNCTION A(X)
C    B(X) = DA/DX
C    7TH ORDER NEWTON'S FUNDAMENTAL FORMULA
C***********************************************************
      IMPLICIT LOGICAL(A-Z)
      INTEGER*4 KMESH,MESH,I,M
      REAL*8 X(KMESH),A(KMESH),B(KMESH),A1(KMESH),A2(KMESH),
     & A3(KMESH),A4(KMESH),A5(KMESH),A6(KMESH),A7(KMESH)
      DO 100 I=MESH-6,MESH
        A1(I) = 0.D0
        A2(I) = 0.D0
        A3(I) = 0.D0
        A4(I) = 0.D0
        A5(I) = 0.D0
        A6(I) = 0.D0
* a6 is changed to a7. 24th Apr. 1996 Y.M
c       A6(I) = 0.D0
        A7(I) = 0.D0
* a6 is changed to a7. 24th Apr. 1996 Y.M
  100 CONTINUE
      DO 200 I=1,MESH-1
        A1(I) = (A(I+1)-A(I))/(X(I+1)-X(I))
  200 CONTINUE
      DO 210 I=1,MESH-2
        A2(I) = (A1(I+1)-A1(I))/(X(I+2)-X(I))
  210 CONTINUE
      DO 220 I=1,MESH-3
        A3(I) = (A2(I+1)-A2(I))/(X(I+3)-X(I))
  220 CONTINUE
      DO 230 I=1,MESH-4
        A4(I) = (A3(I+1)-A3(I))/(X(I+4)-X(I))
  230 CONTINUE
      DO 240 I=1,MESH-5
        A5(I) = (A4(I+1)-A4(I))/(X(I+5)-X(I))
  240 CONTINUE
      DO 250 I=1,MESH-6
        A6(I) = (A5(I+1)-A5(I))/(X(I+6)-X(I))
  250 CONTINUE
      DO 260 I=1,MESH-7
        A7(I) = (A6(I+1)-A6(I))/(X(I+7)-X(I))
  260 CONTINUE
C--*--*--* EDGE POINTS
      M=MESH
      B(1) =    A1(1)
     &       + (X(1)-X(2))*(A2(1)
     &       + (X(1)-X(3))*(A3(1)
     &       + (X(1)-X(4))*(A4(1)
     &       + (X(1)-X(5))*(A5(1)
     &       + (X(1)-X(6))*(A6(1)
     &       + (X(1)-X(7))* A7(1))))))
      B(2) =    A1(1)
     &       + (X(2)-X(1))*(A2(1)
     &       + (X(2)-X(3))*(A3(1)
     &       + (X(2)-X(4))*(A4(1)
     &       + (X(2)-X(5))*(A5(1)
     &       + (X(2)-X(6))*(A6(1)
     &       + (X(2)-X(7))* A7(1))))))
      B(3) =    A1(1) + (X(3)-X(2))*A2(1)
     &       + (X(3)-X(1))*(A2(1)
     &       + (X(3)-X(2))*(A3(1)
     &       + (X(3)-X(4))*(A4(1)
     &       + (X(3)-X(5))*(A5(1)
     &       + (X(3)-X(6))*(A6(1)
     &       + (X(3)-X(7))* A7(1))))))
      B(4) =    A1(1) + (X(4)-X(2))*(A2(1)+(X(4)-X(3))*A3(1))
     &       + (X(4)-X(1))*(A2(1)+(X(4)-X(3))*A3(1)
     &       + (X(4)-X(2))*(A3(1)
     &       + (X(4)-X(3))*(A4(1)
     &       + (X(4)-X(5))*(A5(1)
     &       + (X(4)-X(6))*(A6(1)
     &       + (X(4)-X(7))* A7(1))))))
      B(M-2) = A1(M-7)
     &       + (X(M-2)-X(M-6))*(A2(M-7)
     &       + (X(M-2)-X(M-5))*(A3(M-7)
     &       + (X(M-2)-X(M-4))*(A4(M-7)
     &       + (X(M-2)-X(M-3))* A5(M-7))))
     &       + (X(M-2)-X(M-7))*(A2(M-7)
     &       + (X(M-2)-X(M-5))*(A3(M-7)
     &       + (X(M-2)-X(M-4))*(A4(M-7)
     &       + (X(M-2)-X(M-3))* A5(M-7)))
     &       + (X(M-2)-X(M-6))*(A3(M-7)
     &       + (X(M-2)-X(M-4))*(A4(M-7)
     &       + (X(M-2)-X(M-3))* A5(M-7))
     &       + (X(M-2)-X(M-5))*(A4(M-7)
     &       + (X(M-2)-X(M-3))* A5(M-7)
     &       + (X(M-2)-X(M-4))*(A5(M-7)
     &       + (X(M-2)-X(M-3))*(A6(M-7)
     &       + (X(M-2)-X(M-1))* A7(M-7))))))
      B(M-1) = A1(M-7)
     &       + (X(M-1)-X(M-6))*(A2(M-7) + (X(M-1)-X(M-5))*(A3(M-7)
     &       + (X(M-1)-X(M-4))*(A4(M-7) + (X(M-1)-X(M-3))*(A5(M-7)
     &       + (X(M-1)-X(M-2))* A6(M-7)))))
     &       + (X(M-1)-X(M-7))*(A2(M-7) + (X(M-1)-X(M-5))*(A3(M-7)
     &       + (X(M-1)-X(M-4))*(A4(M-7) + (X(M-1)-X(M-3))*(A5(M-7)
     &       + (X(M-1)-X(M-2))* A6(M-7))))
     &       + (X(M-1)-X(M-6))*(A3(M-7) + (X(M-1)-X(M-4))*(A4(M-7)
     &       + (X(M-1)-X(M-3))*(A5(M-7) + (X(M-1)-X(M-2))* A6(M-7)))
     &       + (X(M-1)-X(M-5))*(A4(M-7) + (X(M-1)-X(M-3))*(A5(M-7)
     &       + (X(M-1)-X(M-2))* A6(M-7))+ (X(M-1)-X(M-4))*(A5(M-7)
     &       + (X(M-1)-X(M-2))* A6(M-7) + (X(M-1)-X(M-3))*(A6(M-7)
     &       + (X(M-1)-X(M-2))* A7(M-7))))))
      B(M  ) = A1(M-7)
     &       + (X(M  )-X(M-6))*(A2(M-7) + (X(M  )-X(M-5))*(A3(M-7)
     &       + (X(M  )-X(M-4))*(A4(M-7) + (X(M  )-X(M-3))*(A5(M-7)
     &       + (X(M  )-X(M-2))*(A6(M-7) + (X(M  )-X(M-1))* A7(M-7))))))
     &       + (X(M  )-X(M-7))*(A2(M-7) + (X(M  )-X(M-5))*(A3(M-7)
     &       + (X(M  )-X(M-4))*(A4(M-7) + (X(M  )-X(M-3))*(A5(M-7)
     &       + (X(M  )-X(M-2))*(A6(M-7) + (X(M  )-X(M-1))* A7(M-7)))))
     &       + (X(M  )-X(M-6))*(A3(M-7) + (X(M  )-X(M-4))*(A4(M-7)
     &       + (X(M  )-X(M-3))*(A5(M-7) + (X(M  )-X(M-2))*(A6(M-7)
     &       + (X(M  )-X(M-1))* A7(M-7))))
     &       + (X(M  )-X(M-5))*(A4(M-7) + (X(M  )-X(M-3))*(A5(M-7)
     &       + (X(M  )-X(M-2))*(A6(M-7) + (X(M  )-X(M-1))* A7(M-7)))
     &       + (X(M  )-X(M-4))*(A5(M-7) + (X(M  )-X(M-2))*(A6(M-7)
     &       + (X(M  )-X(M-1))* A7(M-7))+ (X(M  )-X(M-3))*(A6(M-7)
     &       + (X(M  )-X(M-1))* A7(M-7)
     &       + (X(M  )-X(M-2))* A7(M-7))))))
C--*--*--* INNER POINTS
      DO 300 I=5,MESH-3
        B(I) = A1(I-4)
     &        +(X(I)-X(I-3))*(A2(I-4)
     &        +(X(I)-X(I-2))*(A3(I-4)
     &        +(X(I)-X(I-1))* A4(I-4)))
     &        +(X(I)-X(I-4))*(A2(I-4)
     &        +(X(I)-X(I-2))*(A3(I-4)
     &        +(X(I)-X(I-1))* A4(I-4))
     &        +(X(I)-X(I-3))*(A3(I-4)
     &        +(X(I)-X(I-1))* A4(I-4)
     &        +(X(I)-X(I-2))*(A4(I-4)
     &        +(X(I)-X(I-1))*(A5(I-4)
     &        +(X(I)-X(I+1))*(A6(I-4)
     &        +(X(I)-X(I+2))* A7(I-4))))))
*bug fixed    29th Apr. 1996 Y.M
*    &        +(X(I)-X(I-1))* A5(I-4)
*    &        +(X(I)-X(I+1))*(A6(I-4)
*    &        +(X(I)-X(I+2))* A7(I-4)))))
*bug fixed
  300 CONTINUE
      RETURN
      END

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 581 $)
!
!  MODULE: m_ES_WF_by_MatDiagon
!
!  AUTHOR(S): T. Yamasaki, M. Okamoto,   August/22/2003
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif

#ifndef SX
#define DGEMM__       DGEMM
#endif

#ifndef NO_MATDIAGON_DGEMM
#define MATDIAGON_DGEMM
#endif

module m_ES_WF_by_MatDiagon
! $Id: m_ES_WF_by_MatDiagon.F90 581 2018-08-01 08:38:42Z jkoga $
  use m_Electronic_Structure,only : zaj_l, eko_l, vlhxcQ,vlhxc_l &
#ifdef SAVE_FFT_TIMES
       &                          , status_saved_phifftr &
#endif
       &                          , m_ES_sort_eigen_vals_noncl &  ! <<== added by K. Tagami ============= 11.0
       &                          , m_ES_wd_zaj_small_portion
  use m_ES_nonlocal,         only : m_ES_betar_dot_WFs
  use m_NonLocal_Potential,  only : snl
  use m_PlaneWaveBasisSet,   only : kg1_ext,kg1,iba2,iba,nmatsz,nmatsz2,nbmat,nbmat2,nbase,ngabc,ttr,igpo &
       &                          , n_rGsv, nbase_gamma, kg2_gamma &
       &                          , m_pwBS_alloc_igpo &
       &                          , m_pwBS_dealloc_igpo &
       &                          , m_pwBS_GminusGmapfunction &
       &                          , m_pwBS_set_gmaxs &
       &                          , m_pwBS_alloc_nbmat_and_iba2 &
       &                          , m_pwBS_dealloc_nbmat_and_iba2 &
       &                          , m_pwBS_mat_for_each_WF
  use m_PseudoPotential,     only : modnrm,n_non0_lmtxlmt,index_lmt1_lmt2,lmtt &
       &                          , ltp,mtp,ilmt,dion,q,ivanl, nlmtt &
       &                          , ipaw,dion_paw
  use m_Kpoints,             only : kv3, vkxyz, k_symmetry
  use m_Ionic_System,        only : ntyp, natm, ityp, iwei, pos, ivan
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,  only : nspin,kimg,af,neg,iprimatdiagon,intzaj &
       &                          , n_matrix_size,gmax,eps_solve_Hx_eq_ex,gmaxs_given,ekmode &
#ifdef SAVE_FFT_TIMES
       &                          , skip_alloc_phonon, sw_save_fft
#else
       &                          , skip_alloc_phonon
#endif
  use m_Const_Parameters,    only : DP,PAI2,EXECUT,CMPLDP,BUCS,SmallestPositiveNumber,by_matrix_diagon,ON, GAMMA &
       &                          , GAMMA_base_symmetrization, OLD
  use m_Parallelization,     only : MPI_CommGroup,myrank_k,map_k,ierr,npes, np_e &
       &                          , ista_kngp,iend_kngp,ista_e,iend_e &
       &                          , istep_e,map_z

! =========================== added by K. Tagami =================== 11.0
  use m_Const_Parameters,     only : Neglected, BuiltIn, OFF, SKIP
  use m_Control_Parameters,  only : noncol, ndim_chgpot, ndim_spinor, SpinOrbit_mode, sw_hubbard
  use m_PseudoPotential,     only : dion_scr_noncl, q_noncl, nlmt
  use m_ES_NonCollinear,      only : m_ES_MagMom_to_DensMat_Gspace, &
       &                             m_ES_MagMom_to_DensMat_vlhxcl
! ================================================================== 11.0
  use mpi

  implicit none

  real(kind=DP),private,allocatable,target,dimension(:,:,:):: hsmat !d(nmatsz,nmatsz,kimg)
  real(kind=DP),private,allocatable,target,dimension(:,:,:):: hsmat_s !d(nmatsz,nmatsz,kimg)
  real(kind=DP),private,allocatable,target,dimension(:,:):: hsmat1
  real(kind=DP),private,allocatable,target,dimension(:,:):: hsmat2
  real(kind=DP),private,allocatable,dimension(:,:,:):: Linv  !d(nmatsz,nmatsz,kimg)
  real(kind=DP),private,allocatable,dimension(:,:)  :: ldag  !d(nmatsz,kimg)
  real(kind=DP),private,allocatable,dimension(:,:)  :: vlhxc   !d(nmatsz2,kimg)
  real(kind=DP),private,allocatable,dimension(:)    :: zfcos,zfsin !d(nmatsz2)
  real(kind=DP),private,allocatable,dimension(:,:,:)  :: zaj_mat !d(nmatsz,np_e,kimg)


  real(kind=DP),private,allocatable :: vlhxc_ssrep(:,:,:)   ! <<== added by K. Tagami =============== 11.0
  integer :: nmatsz_noncl                                   ! <<== added by K. Tagami =============== 11.0
  integer :: sw_use_zhegvx = on                             ! <<== added by K. Tagami =============== 11.0

  logical, private :: reduced_basis_mode = .false.

!  include 'mpif.h'

contains

  subroutine m_ESmat_set_reduced_basis_mode(reduced)
      logical, intent(in) :: reduced
      reduced_basis_mode = reduced
  end subroutine m_ESmat_set_reduced_basis_mode

  subroutine alloc_matrices()
!f    allocate(hsmat(nmatsz,nmatsz,kimg)); hsmat = 0.d0
    allocate(vlhxc(nmatsz2,kimg))
    allocate(zfcos(0:nmatsz2))
    allocate(zfsin(0:nmatsz2))
!f    if(modnrm == EXECUT) then
!f       allocate(linv(nmatsz,nmatsz,kimg))
!f       allocate(ldag(nmatsz,kimg))
!f    end if
!f    allocate(zaj_mat(nmatsz,np_e,kimg))
! ============================ modified by K. Tagami ================= 11.0
!    allocate(hsmat(nmatsz,nmatsz,kimg)); hsmat = 0.d0
!    if(modnrm == EXECUT) then
!       allocate(linv(nmatsz,nmatsz,kimg))
!       allocate(ldag(nmatsz,kimg))
!    end if
!    allocate(zaj_mat(nmatsz,np_e,kimg))
!
    if ( noncol ) then
      nmatsz_noncl = nmatsz *ndim_spinor
      allocate( hsmat( nmatsz_noncl, nmatsz_noncl, kimg )); hsmat =0.d0

      if ( modnrm == EXECUT ) then
         if ( sw_use_zhegvx == ON ) then
            allocate( hsmat_s( nmatsz_noncl, nmatsz_noncl, kimg) ); hsmat_s = 0.0d0
         else
            allocate( linv( nmatsz_noncl, nmatsz_noncl, kimg) )
            allocate( ldag( nmatsz_noncl, kimg ) )
         end if
      endif

      allocate( zaj_mat( nmatsz_noncl, np_e, kimg ) )

      allocate( vlhxc_ssrep( ista_kngp:iend_kngp,kimg,ndim_chgpot) )
      vlhxc_ssrep = 0.0d0

    else
      allocate(hsmat(nmatsz,nmatsz,kimg)); hsmat = 0.d0
      if ( modnrm == EXECUT ) then
         allocate(linv(nmatsz,nmatsz,kimg))
         allocate(ldag(nmatsz,kimg))
      end if
      allocate(zaj_mat(nmatsz,np_e,kimg))
    endif
! ===================================================================== 11.0
  end subroutine alloc_matrices

  subroutine dealloc_matrices()
    if(allocated(zaj_mat)) deallocate(zaj_mat)
    if(allocated(ldag))  deallocate(ldag)
    if(allocated(linv))  deallocate(linv)
    if(allocated(zfsin)) deallocate(zfsin)
    if(allocated(zfcos)) deallocate(zfcos)
    if(allocated(vlhxc)) deallocate(vlhxc)
    if(allocated(hsmat)) deallocate(hsmat)
    if ( allocated(vlhxc_ssrep) ) deallocate( vlhxc_ssrep )  ! <<== added by K. Tagami ========== 11.0
    if(allocated(hsmat_s)) deallocate(hsmat_s)
  end subroutine dealloc_matrices

  subroutine m_ESmat_solve_Hx_eq_eSx(nfout,iteration,iteration_electronic)
    integer, intent(in) :: nfout, iteration, iteration_electronic

    integer,parameter :: PRINT_LEVEL = 2
    integer   :: ispin, ik, iksnl, n=0
    integer   :: id_sname = -1
    logical   :: unitcell_can_change
    call tstatc0_begin('m_ESmat_solve_Hx_eq_eSx ',id_sname,1)

    if(iprimatdiagon >= 2) write(nfout,'(" !! iteration = ",i6, " m_ESmat_solve_Hx_eq_eSx")') iteration

    if(ekmode == ON ) then
       if(iteration_electronic == 1) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
       else
          call m_pwBS_set_gmaxs(n,gmax)
       end if
    else
       if(iteration == 1 .and. intzaj == by_matrix_diagon) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
       else if(skip_alloc_phonon .and. iteration_electronic == 1 .and. intzaj == by_matrix_diagon) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
       else if(unitcell_can_change() .and. iteration_electronic == 1 &
         &    .and. intzaj == by_matrix_diagon) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
       else if (reduced_basis_mode) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
          reduced_basis_mode = .false.
       else
          call m_pwBS_set_gmaxs(n,gmax)
       end if
    end if

    call m_pwBS_alloc_nbmat_and_iba2()
    call m_pwBS_mat_for_each_WF() ! -> nbmat,nbmat2,iba2

    call m_pwBS_alloc_igpo()
    call m_pwBS_GminusGmapfunction()  ! -> igpo, nmatsz2
    if(iprimatdiagon >= 3) write(nfout,'(" nmatsz2 = ",i9)') nmatsz2
    if(iprimatdiagon >= PRINT_LEVEL) write(nfout,'(" nmatsz, kg1_ext = ", 2i9)') nmatsz, kg1_ext

    call alloc_matrices()

    do ispin = 1, nspin, af+1
       call prjvlhxc_l2vlhxc_t()   ! vlhxc_l -> vlhxc
       do ik = ispin, kv3-nspin+ispin,nspin
          if(map_k(ik) /= myrank_k) cycle
          if(iprimatdiagon >= PRINT_LEVEL) write(nfout,'(" iba2(",i3,") = ", i9)') ik, iba2(ik)

          iksnl = (ik-1)/nspin + 1
          hsmat = 0.d0
          if(modnrm == EXECUT) then
             if(iprimatdiagon >=3 ) write(nfout,'(" !! modnrm == EXECUT (m_ESmat_solve_Hx_eq_eSx)")')
             call ovmtrx() ; if(iprimatdiagon >= 3) call wd_hsmat(" -- ovmtrx --")
             call cholde() ; if(iprimatdiagon >= 3) call wd_hsmat(" -- cholde --")   ! -> linv
          end if
          call nlmtrx()           ! (nlmtrx) -> hsmat <- snl
                          if(iprimatdiagon >= 3) call wd_hsmat(" -- nlmtrx --")
          call amtrxkinetic()     !  -> hsmat
                          if(iprimatdiagon >= 3) call wd_hsmat(" -- amtrxkinetic --")
          call amtrxlocalpt()     !  -> hsmat
                          if(iprimatdiagon >= 3) call wd_hsmat(" -- amtrxlocalpt --")
          if(modnrm == EXECUT) call lhl() ! -> hsmat
                          if(modnrm == EXECUT .and. iprimatdiagon >= 3) call wd_hsmat(" -- lhl --")
      ! [LAPACK] with LAPACK library
      !***** LAPACK [begin] ***** M.Okamoto
          call solve_Hx_eq_ex_LAPACK()
      !***** LAPACK [end] ***** M.Okamoto
          if(iprimatdiagon >= 3) call wd_hsmat(" -- after diagonalization --")
          if(modnrm == EXECUT) call lx() ! -> zaj_mat
          ! Debug
!!$          call zaj_mapping()
          if(k_symmetry(ik) == GAMMA .or. k_symmetry(ik) == GAMMA_base_symmetrization) call phase_mult()
          call cp_zaj_mat_to_zaj_l() ! zaj_mat -> zaj_l
       end do
    end do

    if(iprimatdiagon >= 3) then
       do ik = 1, kv3
          if(map_k(ik) /= myrank_k) cycle
          call m_ES_wd_zaj_small_portion(nfout,ik," (m_ESmat_solve_Hx_eq_eSx)",26)
!!$          write(nfout,'(" ik = ", i5)') ik
       end do
    end if

    call dealloc_matrices()
    call m_pwBS_dealloc_igpo()
    call m_pwBS_dealloc_nbmat_and_iba2()

    call m_ES_betar_dot_WFs(nfout) ! (fsrfsi) -> fsr_l, fsi_l

    call tstatc0_end(id_sname)
  contains
    ! Contained subroutines
    !  1)    subroutine wd_hsmat
    !  1)    subroutine wd_hsmat
    !  2)    subroutine solve_Hx_eq_ex_LAPACK
    !  3)    subroutine solve_Hx_eq_ex
    !  4)    subroutine calphase
    !  5)    subroutine nlmtrx
    !  6)    subroutine ovmtrx
    !  7)    subroutine cholde
    !  8)    subroutine amtrxkinetic
    !  9)    subroutine prjvlhxc_l2vlhxc_t
    ! 10)    subroutine amtrxlocalpt
    ! 11)    subroutine lhl
    ! 12)    subroutine lx
    ! 13)    subroutine phase_mult
    ! 14)    subroutine cp_zaj_mat_to_zaj_l

    subroutine wd_hsmat(str)
      character(len=*),intent(in) :: str
      integer :: i, imax, j, jmax
      integer, parameter :: NMATSIZE = 10
      write(nfout,'(a30," ik= ",i5)') str,ik
      imax = min(NMATSIZE, nmatsz)
      jmax = min(NMATSIZE, nmatsz)
      do j = 1, jmax
         write(nfout,'(" hsmat(1:*,",i3,",1): ",10f8.4,99(/19x,10f8.4))') j &
              & , (hsmat(i,j,1),i=1,imax)
      end do
      if(kimg == 2) then
         do j = 1, jmax
            write(nfout,'(" hsmat(1:*,",i3,",2): ",10f8.4,99(/19x,10f8.4))') j &
                 & , (hsmat(i,j,2),i=1,imax)
         end do
      end if
    end subroutine wd_hsmat

!!$    subroutine zaj_mapping()
!!$      integer :: ib, i, j, ib2
!!$      if(iba2(ik) < iba(ik)) then
!!$         write(nfout,'(" << zaj_mapping >> (nbmat -> nbase)")')
!!$         do ib = ista_e, iend_e, istep_e
!!$            ib2 = map_z(ib)
!!$            zfcos = 0.d0
!!$            do j = 1, iba2(ik)
!!$               do i = 1, iba(ik)
!!$                  if(nbase(i,ik) == nbmat(j,ik)) zfcos(i) = zaj_l(j,ib2,ik,1)
!!$               end do
!!$            end do
!!$            do i = 1, iba(ik)
!!$               zaj_l(i,ib2,ik,1) = zfcos(i)
!!$            end do
!!$         end do
!!$         if(kimg == 2) then
!!$            do ib = ista_e, iend_e, istep_e
!!$               ib2 = map_z(ib)
!!$               zfcos = 0.d0
!!$               do j = 1, iba2(ik)
!!$                  do i = 1, iba(ik)
!!$                     if(nbase(i,ik) == nbmat(j,ik)) zfcos(i) = zaj_l(j,ib2,ik,2)
!!$                  end do
!!$               end do
!!$               do i = 1, iba(ik)
!!$                  zaj_l(i,ib2,ik,2) = zfcos(i)
!!$               end do
!!$            end do
!!$         end if
!!$      end if
!!$    end subroutine zaj_mapping

   ! [LAPACK] with LAPACK library
   !***** LAPACK [begin] ***** M.Okamoto
    subroutine solve_Hx_eq_ex_LAPACK()
      integer :: n, lda, ne, ne_found, il, iu, info, ipos, i, j, ib, lwork, k
      real(kind=DP) :: abstol, vl, vu, sum, dlamch
      integer,allocatable ::              ifail(:), iwork(:)
      real(kind=DP),allocatable ::        amat(:,:), evec(:), rvmat(:,:), rwork(:)
      complex(kind=CMPLDP),allocatable :: cmat(:,:), cvmat(:,:), cwork(:)
      complex(kind=CMPLDP),parameter ::   IMG = (0.d0,1.d0)
      complex(kind=CMPLDP) :: ctemp(1)
      zaj_mat(:,:,:) = 0.d0
      lda = nmatsz
      vl = -1.d10 ; vu = 1.d10 ; il = 1 ; iu = neg   !! vl = -1.d10 ; vu = 1.d10 ; il = ista_e ; iu = iend_e
      ne = iu - il + 1
      abstol = 2*dlamch('S')
      n = iba2(ik)
      if (kimg == 1) then
         lwork = max(1,12*n)
        !+++++++++++++++++++++++++++++++++++++++++++++++++
         allocate(evec(n),iwork(5*n),ifail(n))
         allocate(amat(lda,n),rvmat(lda,ne),rwork(lwork)); amat = 0.d0
        !+++++++++++++++++++++++++++++++++++++++++++++++++
         amat(1:n,1:n) = hsmat(1:n,1:n,1)  ! initialization of amat

         if(iprimatdiagon>= 2)  call check_LAPACKinputs("solve_Hx_eq_ex_LAPACK "  &
              &                                   ,nfout,n,lda,vl,vu,il,iu,lwork,abstol,RMat=amat)
         call dsyevx('V','I','U',n,amat,lda,vl,vu,il,iu,abstol &
              &    , ne_found,evec,rvmat,lda,rwork,lwork,iwork,ifail,info)

         if(iprimatdiagon>= 2) call check_LAPACKoutputs("solve_Hx_eq_ex_LAPACK ",nfout,ik,n,ne,lda,evec,RMat=rvmat)
         call check_LAPACKerror(ne_found,ne,info)

         do ib = ista_e, iend_e, istep_e
            j = map_z(ib)
            do i = 1,n
               zaj_mat(i,j,1) = rvmat(i,ib) !!$ zaj_l(i,j,ik,1) = rvmat(i,ib-ista_e+1) ! M.Okamoto (August 22,2003)
            end do
            eko_l(j,ik) = evec(ib)          !!$ eko_l(j,ik) = evec(ib-ista_e+1) ! M.Okamoto (August 22,2003)
         end do
         if(af/=0) eko_l(:,ik+1) = eko_l(:,ik)
        !+++++++++++++++++++++++++++++
         deallocate(amat,rvmat,rwork)
        !+++++++++++++++++++++++++++++
      else if (kimg == 2) then
        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         allocate(evec(n),iwork(5*n),ifail(n))
         allocate(cmat(lda,n),cvmat(lda,ne),rwork(7*n))
         evec = 0.d0; iwork = 0; ifail = 0
         cmat = dcmplx(0.d0,0.d0); cvmat = dcmplx(0.d0,0.d0); rwork = 0.d0;
        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         do i = 1,n
         do j = 1,n
            cmat(i,j) = dcmplx(hsmat(i,j,1),hsmat(i,j,2))
         end do
         end do
! === DEBUG by tkato 2011/09/06 ================================================
         call zheevx('V','I','U',n,cmat,lda,vl,vu,il,iu,abstol, &
            ne_found,evec,cvmat,lda,ctemp,-1,rwork,iwork,ifail,info)
         lwork = int(real(ctemp(1)))
         allocate(cwork(lwork)); cwork = dcmplx(0.d0,0.d0)
! ==============================================================================
         if(iprimatdiagon>= 2)  call check_LAPACKinputs("solve_Hx_eq_ex_LAPACK "  &
              &                                   ,nfout,n,lda,vl,vu,il,iu,lwork,abstol,CMat=cmat)
         call zheevx('V','I','U',n,cmat,lda,vl,vu,il,iu,abstol, &
            ne_found,evec,cvmat,lda,cwork,lwork,rwork,iwork,ifail,info)

         if(iprimatdiagon>= 2) call check_LAPACKoutputs("solve_Hx_eq_ex_LAPACK ",nfout,ik,n,ne,lda,evec,CMat=cvmat)
         call check_LAPACKerror(ne_found,ne,info)

         do ib = ista_e, iend_e, istep_e
            j = map_z(ib)
            do i = 1,n
               zaj_mat(i,j,1) = real(cvmat(i,ib))
               zaj_mat(i,j,2) = aimag(cvmat(i,ib))
               !!$ zaj_l(i,j,ik,1)    = real(cvmat(i,ib-ista_e+1))  ! M.Okamoto (August 22,2003)
               !!$ zaj_l(i,j,ik,kimg) = aimag(cvmat(i,ib-ista_e+1)) ! M.Okamoto (August 22,2003)
            end do
            eko_l(j,ik) = evec(ib)    !! eko_l(j,ik) = evec(ib-ista_e+1) ! M.Okamoto (August 22,2003)
         end do
         if(af/=0) eko_l(:,ik+1) = eko_l(:,ik)
        !+++++++++++++++++++++++++++++++++++
         deallocate(cmat,cvmat,cwork,rwork)
        !+++++++++++++++++++++++++++++++++++
      end if
      if(iprimatdiagon >= 2) call wd_CalculatedEigenvalues(nfout,ik,n,ne,evec,"solve_Hx_eq_ex")

      sum = 0.d0
      do i = 1,ne
         sum = sum + abs(evec(i))
      end do
      if (sum < SmallestPositiveNumber*1.d5) call phase_error_with_msg(nfout, ' ! illegal evec (solve_Hx_eq_ex)'&
                                                                      , __LINE__, __FILE__)
      if (iprimatdiagon >= 2) write(nfout,'(" -- sum = ",f20.8)') sum
     !+++++++++++++++++++++++++++++
      deallocate(evec,iwork,ifail)
     !+++++++++++++++++++++++++++++
    end subroutine solve_Hx_eq_ex_LAPACK
   !***** LAPACK [end] ***** M.Okamoto

    subroutine calphase(ia)
      integer, intent(in) :: ia
      integer       :: i
      real(kind=DP) :: ph
      do i = 1, nmatsz2
         ph = (pos(ia,1)*ngabc(i,1)+pos(ia,2)*ngabc(i,2)+pos(ia,3)*ngabc(i,3))*PAI2
         zfcos(i) = cos(ph)
         zfsin(i) = sin(ph)
      end do
      zfcos(0) = 0.d0; zfsin(0) = 0.d0
    end subroutine calphase

    subroutine nlmtrx
      real(kind=DP),pointer,dimension(:,:,:) :: a
      real(kind=DP),allocatable,dimension(:,:)  :: s
      integer, pointer, dimension(:,:)       :: ng

      complex(kind=CMPLDP),parameter :: zi = (0.d0,1.d0)
      integer :: i,j,it,ia,u,v,n,lmt1,il1,lmt2,il2,j1,l1,l2,l3,ip,y,i1
      integer :: i2,j2,m
      real(kind=DP) :: fr,f21,f12,t

      a => hsmat
      ng => ngabc
!!$      s => snl(:,:,iksnl)
      allocate(s(kg1_ext,nlmtt)); s = 0.d0

      if(k_symmetry(ik) == GAMMA) then
         if(iprimatdiagon >= 2) write(nfout,'(" k_symmetry(ik) == GAMMA <<nlmtrx>>")')
         if(iprimatdiagon >= 2) write(nfout,'(" kg2_gamma, iba(ik), iba2(ik) = ",3i8)') kg2_gamma,iba(ik),iba2(ik)
         do j = 1, nlmtt
            ! --- finding it and lmt
            Finding: do u = 1, ntyp
               do ip = 1, ilmt(u)
                  if(lmtt(ip,u) == j) then
                     lmt1 = ip
                     it = u
                     exit Finding
                  end if
               end do
            end do Finding
            il1 = ltp(lmt1,it)
            if(iprimatdiagon >= 2) write(nfout,'(" nlmtt, j, lmt1, it, il1 = ",5i8)') nlmtt,j,lmt1,it,il1
            s(1,j) = snl(1,j,iksnl)
            if(mod(il1,2) == 0) then
               do i = 2, kg2_gamma
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) = snl(i,j,iksnl)
                  s(i2,j) = -snl(i,j,iksnl)
               end do
            else
               do i = 2, kg2_gamma
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) = snl(i,j,iksnl)
                  s(i2,j) = snl(i,j,iksnl)
               end do
            end if
         end do
      else
         if(iprimatdiagon >= 2) write(nfout,'(" k_symmetry(ik) /= GAMMA <<nlmtrx>>")')
         do j = 1, nlmtt
            do i = 1, iba(ik)
               s(i,j) = snl(i,j,iksnl)
            end do
         end do
      end if

      a = 0.d0
      do ia = 1, natm
         it = ityp(ia)
         call calphase(ia)  ! -> zfcos, zfsin
         do ip = 1, n_non0_lmtxlmt(it)
            lmt1  = index_lmt1_lmt2(ip,it,1)
            lmt2  = index_lmt1_lmt2(ip,it,2)
            u     = lmtt(lmt1,it)
            v     = lmtt(lmt2,it)
            il1   = ltp(lmt1,it)
            il2   = ltp(lmt2,it)
            if(lmt2 <= lmt1) cycle
!!$            if(ivanl(il1,it) /= 1 .and. &
            if(ivan(it) /= 1 .and. &
                 & (il1 /= il2 .or. mtp(lmt1,it) /= mtp(lmt2,it))) cycle
            if(mod(il1+il2,2) == 0) then
               if(ipaw(it)==0) then
                   fr  = dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)
               else
                   fr  = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
               endif
               if(il1==il2) then
                  f21 = fr*iwei(ia)
                  do j = 1, iba2(ik)
                     j1 = nbmat(j,ik)
                     j2 = nbmat2(j,ik)
                     l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
                     if(kimg == 1) then
                        do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           a(i,j,1) = a(i,j,1)+f21*(s(m,u)*s(j2,v)+s(m,v)*s(j2,u))*zfcos(y)
                        end do
                     else
                        do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           t  = f21*(s(m,u)*s(j2,v)+s(m,v)*s(j2,u))
                           a(i,j,1) = a(i,j,1) + t*zfcos(y)
                           a(i,j,2) = a(i,j,2) - t*zfsin(y)
                        end do
                     end if
                  end do
               else
                  f21 = real(zi**(il2-il1))*fr*iwei(ia)
                  f12 = real(zi**(il1-il2))*fr*iwei(ia)
!!$                  write(nfout,'(" zi**(il1-il2) = ",2f16.8)') zi**(il1-il2)
                  do j = 1, iba2(ik)
                     j1 = nbmat(j,ik)
                     j2 = nbmat2(j,ik)
                     l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
                     if(kimg == 1) then
                        do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           a(i,j,1) = a(i,j,1)+(f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u))*zfcos(y)
                        end do
                     else
                        do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           t  = f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u)
                           a(i,j,1) = a(i,j,1) + t*zfcos(y)
                           a(i,j,2) = a(i,j,2) - t*zfsin(y)
                        end do
                     end if
                  end do
               end if
            else if(mod(il1+il2,2) == 1) then
!!$               fr = vlhxcQ(lmt1,lmt2,ia,ispin)
               if(ipaw(it)==0) then
                   fr = vlhxcQ(lmt1,lmt2,ia,ispin)
               else
                   fr = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
               end if
               f21 = -aimag(zi**(il2-il1))*fr*iwei(ia)
               f12 = -aimag(zi**(il1-il2))*fr*iwei(ia)
               do j = 1, iba2(ik)
                  j1 = nbmat(j,ik)
                  j2 = nbmat2(j,ik)
                  l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
                  if(kimg == 1) then
                     do i = j, iba2(ik)
                        n = nbmat(i,ik)
                        m = nbmat2(i,ik)
                        y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                        a(i,j,1) = a(i,j,1)+ &
                            & (f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u))*zfsin(y)
                     end do
                  else
                     do i = j, iba2(ik)
                        n = nbmat(i,ik)
                        m = nbmat2(i,ik)
                        y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                        t = f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u)
                        a(i,j,1) = a(i,j,1) + t*zfsin(y)
                        a(i,j,2) = a(i,j,2) + t*zfcos(y)
                     end do
                  end if
               end do
            end if
         end do
         do lmt1 = 1, ilmt(it)
            if(ipaw(it)==0) then
                fr = (dion(lmt1,lmt1,it) + vlhxcQ(lmt1,lmt1,ia,ispin))*iwei(ia)
            else
                fr = (dion_paw(lmt1,lmt1,ispin,ia) + vlhxcQ(lmt1,lmt1,ia,ispin))*iwei(ia)
            endif
            u  = lmtt(lmt1,it)
            do j = 1, iba2(ik)
               j1 = nbmat(j,ik)
               j2 = nbmat2(j,ik)
               l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
               if(kimg == 1) then
                  do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     y = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)
                     a(i,j,1) = a(i,j,1) + fr*s(i2,u)*s(j2,u)*zfcos(y)
                  end do
               else if(kimg == 2) then
                  do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     y = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)
                     t = fr*s(i2,u)*s(j2,u)
                     a(i,j,1) = a(i,j,1) + t*zfcos(y)
                     a(i,j,2) = a(i,j,2) - t*zfsin(y)
                  end do
               end if
            end do
         end do
      end do
      deallocate(s)

    end subroutine nlmtrx

    subroutine ovmtrx
      integer :: i,j,it,ia,u,v,n,ip,y,jn,j1,l1,l2,l3,i1,lmt1,lmt2
      integer :: i2,j2,m,jm
      real(kind=DP) :: fr,t
      real(kind=DP),pointer,dimension(:,:,:) :: a
      real(kind=DP),allocatable,dimension(:,:)   :: s
      integer,pointer,dimension(:,:)         :: ng

      a => hsmat
      ng => ngabc

      allocate(s(kg1_ext,nlmtt)); s = 0.0d0

      if(k_symmetry(ik) == GAMMA) then
         do j = 1, nlmtt
            ! --- finding it and lmt
            Finding: do u = 1, ntyp
               do ip = 1, ilmt(u)
                  if(lmtt(ip,u) == j) then
                     lmt1 = ip
                     it = u
                     exit Finding
                  end if
               end do
            end do Finding
            l1 = ltp(lmt1,it)
            s(1,j) = snl(1,j,iksnl)
            if(mod(l1,2) == 0) then
               do i = 2, iba(ik)
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) =  snl(i,j,iksnl)
                  s(i2,j) = -snl(i,j,iksnl)
               end do
            else
               do i = 2, iba(ik)
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) = snl(i,j,iksnl)
                  s(i2,j) = snl(i,j,iksnl)
               end do
            end if
         end do
         if(iprimatdiagon >= 3) then
            write(nfout,'(" --- ovmtrx ---")')
            write(nfout,'(" ik = ",i8)') ik
            do j = 1, nlmtt
               write(nfout,'(" s(1:*,",i3,")      : ",10f8.4)')j, (s(i,j),i=1,10)
            end do
         end if
      else
         do j = 1, nlmtt
            do i = 1, kg1
               s(i,j) = snl(i,j,iksnl)
            end do
         end do
      end if

      a = 0.d0
      do i = 1, iba2(ik)
         a(i,i,1) = 1.d0
      end do
      do ia = 1, natm
         it = ityp(ia)
         call calphase(ia)  ! -> zfcos, zfsin
         do ip = 1, n_non0_lmtxlmt(it)
            lmt1 = index_lmt1_lmt2(ip,it,1)
            u = lmtt(lmt1,it)
            lmt2 = index_lmt1_lmt2(ip,it,2)
            if(lmt2 <= lmt1) cycle
            v = lmtt(lmt2,it)
            if(ltp(lmt1,it) /= ltp(lmt2,it) .or. mtp(lmt1,it) /= mtp(lmt2,it) ) cycle
            fr = q(lmt1,lmt2,it)*iwei(ia)
            do j = 1, iba2(ik)
               jn = nbmat(j,ik)
               jm = nbmat2(j,ik)
               l1 = ng(jn,1); l2 = ng(jn,2); l3 = ng(jn,3)
               if(kimg == 1) then
                  do i = j, iba2(ik)
                     n = nbmat(i,ik)
                     m = nbmat2(i,ik)
                     y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                     a(i,j,1) = a(i,j,1)+fr*(s(m,u)*s(jm,v)+s(m,v)*s(jm,u))*zfcos(y)
                  end do
               else
                  do i = j, iba2(ik)
                     n = nbmat(i,ik)
                     m = nbmat2(i,ik)
                     y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                     t  = fr*(s(m,u)*s(jm,v)+s(m,v)*s(jm,u))
                     a(i,j,1) = a(i,j,1) + t*zfcos(y)
                     a(i,j,2) = a(i,j,2) - t*zfsin(y)
                  end do
               end if
            end do
         end do
         do lmt1 = 1, ilmt(it)
            u  = lmtt(lmt1,it)
            fr = q(lmt1,lmt1,it)*iwei(ia)
            do j = 1, iba2(ik)
               j1 = nbmat(j,ik)
               j2 = nbmat2(j,ik)
               l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
               if(kimg == 1) then
                  do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     ip = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)
                     a(i,j,1) = a(i,j,1)+fr*s(i2,u)*s(j2,u)*zfcos(ip)
                  end do
               else if(kimg == 2) then
                  do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     ip = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)
                     t  = fr*s(i2,u)*s(j2,u)
                     a(i,j,1) = a(i,j,1) + t*zfcos(ip)
                     a(i,j,2) = a(i,j,2) - t*zfsin(ip)
                  end do
               end if
            end do
         end do
      end do

      if(kimg == 1) then
         do j = 2, iba2(ik)
            do i = 1, j-1
               a(i,j,1) = a(j,i,1)
            end do
         end do
      else
         do j = 2, iba2(ik)
            do i = 1, j-1
               a(i,j,1) =  a(j,i,1)
               a(i,j,2) = -a(j,i,2)
            end do
         end do
      end if
      deallocate(s)

    end subroutine ovmtrx

    subroutine cholde
! Choleski decomposition.
! ref: S.G.Louie,K.M.Ho,and M.L.Cohen, PRB19,(1979),p1774.
      integer       :: n,i,j
      real(kind=DP) :: t
      integer  :: imax, jmax
      integer, parameter :: NMATSIZE = 10

      linv = 0.d0
      linv(1,1,1) = 1.d0/sqrt(hsmat(1,1,1))
      if(kimg == 1) then
         do n = 1, iba2(ik)-1
            ldag = 0.d0
            do  i = 1, n
               do j = 1, i
                  ldag(i,1) = ldag(i,1) + linv(i,j,1)*hsmat(j,n+1,1)
               end do
            end do
            t = 0.d0
            do i = 1, n
               t = t + ldag(i,1)**2
            end do
            ldag(n+1,1) = sqrt(hsmat(n+1,n+1,1)-t)
            linv(n+1,n+1,1) = 1.d0/sqrt(hsmat(n+1,n+1,1)-t)
            do i = 1, n
               do j = 1, n
                  linv(n+1,i,1)=linv(n+1,i,1)-linv(n+1,n+1,1)*ldag(j,1)*linv(j,i,1)
               end do
            end do
         end do
      else if(kimg == 2) then
         do n = 1, iba2(ik)-1
            ldag = 0.d0
            do i = 1, n
               do j = 1, i
                  ldag(i,1) = ldag(i,1) &
                       & + linv(i,j,1)*hsmat(j,n+1,1)-linv(i,j,2)*hsmat(j,n+1,2)
                  ldag(i,2) = ldag(i,2) &
                       & + linv(i,j,1)*hsmat(j,n+1,2)+linv(i,j,2)*hsmat(j,n+1,1)
               end do
            end do
            t = 0.d0
            do i = 1, n
               t = t + ldag(i,1)**2 + ldag(i,2)**2
            end do
            ldag(n+1,1) = sqrt(hsmat(n+1,n+1,1)-t)
            linv(n+1,n+1,1) = 1.d0/sqrt(hsmat(n+1,n+1,1)-t)
            do i = 1, n
               do j = 1, n
                  linv(n+1,i,1) = linv(n+1,i,1) &
                       &       - linv(n+1,n+1,1)*(ldag(j,1)*linv(j,i,1) &
                       &                         +ldag(j,2)*linv(j,i,2))&
                       &       + linv(n+1,n+1,2)*(ldag(j,1)*linv(j,i,2)&
                       &                         -ldag(j,2)*linv(j,i,1) )
                  linv(n+1,i,2) = linv(n+1,i,2) &
                       &       - linv(n+1,n+1,1)*(ldag(j,1)*linv(j,i,2) &
                       &                         -ldag(j,2)*linv(j,i,1))&
                       &       - linv(n+1,n+1,2)*(ldag(j,1)*linv(j,i,1)&
                       &                         -ldag(j,2)*linv(j,i,2) )
               end do
            end do
         end do
      end if
      if(iprimatdiagon >= 2) then
         imax = NMATSIZE; if(imax > nmatsz) imax = nmatsz
         jmax = NMATSIZE; if(jmax > nmatsz) jmax = nmatsz
         do j = 1, jmax
            write(nfout,'(" linv(1:*,",i3,",1): ",10f8.4,99(/18x,10f8.4))') j &
                 & , (linv(i,j,1),i=1,imax)
         end do
         if(kimg == 2) then
            do j = 1, jmax
               write(nfout,'(" linv(1:*,",i3,",2): ",10f8.4,99(/18x,10f8.4))') j &
                    & , (linv(i,j,2),i=1,imax)
            end do
         end if
      end if
    end subroutine cholde

    subroutine amtrxkinetic
      integer :: i,j
      real(kind=DP) :: ga,gb,gc
      do i = 1, iba2(ik)
         j = nbmat(i,ik)
         ga = vkxyz(ik,1,BUCS) + ngabc(j,1)
         gb = vkxyz(ik,2,BUCS) + ngabc(j,2)
         gc = vkxyz(ik,3,BUCS) + ngabc(j,3)
         hsmat(i,i,1) = hsmat(i,i,1) + 0.5 &
              & * (ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
              & +  ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga)
      end do
    end subroutine amtrxkinetic

    subroutine prjvlhxc_l2vlhxc_t()
      integer :: i,irc
      vlhxc = 0.d0
      do irc = 1, kimg
         do i = ista_kngp, iend_kngp
            if(i > nmatsz2) cycle
            vlhxc(i,irc) = vlhxc_l(i,irc,ispin)
         end do
      end do
      if(npes >= 2) then
         call mpi_allreduce(MPI_IN_PLACE,vlhxc,nmatsz2*kimg,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
      end if
    end subroutine prjvlhxc_l2vlhxc_t

    subroutine amtrxlocalpt()
      integer :: j,j1,l1,l2,l3,i,n,ip
      real(kind=DP),pointer,dimension(:,:,:) :: a
      integer,      pointer,dimension(:,:)   :: ng
      a  => hsmat
      ng => ngabc

      do j = 1, iba2(ik)
         j1 = nbmat(j,ik)
         l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
         if(kimg == 1) then
            do i = j, iba2(ik)
               n = nbmat(i,ik)
               ip = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
               a(i,j,1) = a(i,j,1) + vlhxc(ip,1)
            end do
         else
            do i = j, iba2(ik)
               n = nbmat(i,ik)
               ip = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
               a(i,j,1) = a(i,j,1) + vlhxc(ip,1)
               a(i,j,2) = a(i,j,2) + vlhxc(ip,2)
            end do
         end if
      end do
      if(kimg == 1) then
         do j = 2, iba2(ik)
            do i = 1, j-1
               a(i,j,1) = a(j,i,1)
            end do
         end do
      else
         do j = 2, iba2(ik)
            do i = 1, j-1
               a(i,j,1) =  a(j,i,1)
               a(i,j,2) = -a(j,i,2)
            end do
         end do
      end if
    end subroutine amtrxlocalpt

    subroutine lhl
      real(kind=DP),pointer,dimension(:,:,:)     :: h
      real(kind=DP),allocatable,dimension(:,:,:) :: ww
      integer :: i,j,k, M, N

      h => hsmat
      allocate(ww(nmatsz,nmatsz,kimg)); ww = 0.d0

      if(kimg == 1) then
#ifdef MATDIAGON_DGEMM
         M = iba2(ik); N = iba2(ik); K = iba2(ik)
         call DGEMM__('N','N',M,N,K, 1.d0, linv(1,1,1),nmatsz,h(1,1,1),nmatsz,0.d0, ww(1,1,1),nmatsz)
#else
         do i = 1, iba2(ik)
            do j = 1, iba2(ik)
               do k = 1, i
                  ww(i,j,1) = ww(i,j,1) + linv(i,k,1)*h(k,j,1)
               end do
            end do
         end do
#endif
#ifdef MATDIAGON_DGEMM
         call DGEMM__('N','T',M,N,K, 1.d0, ww(1,1,1),nmatsz,linv(1,1,1),nmatsz,0.d0, h(1,1,1),nmatsz)
#else
         h = 0.d0
         do i = 1, iba2(ik)
            do j = 1, iba2(ik)
               do k = 1, j
                  h(i,j,1) = h(i,j,1) + ww(i,k,1)*linv(j,k,1)
              end do
            end do
         end do
#endif
      else if(kimg == 2) then
#ifdef MATDIAGON_DGEMM
         M = iba2(ik); N = iba2(ik); K = iba2(ik)
         call DGEMM__('N','N',M,N,K, 1.d0, linv(1,1,1),nmatsz,h(1,1,1),nmatsz,0.d0, ww(1,1,1),nmatsz)
         call DGEMM__('N','N',M,N,K,-1.d0, linv(1,1,2),nmatsz,h(1,1,2),nmatsz,1.d0, ww(1,1,1),nmatsz)
         call DGEMM__('N','N',M,N,K, 1.d0, linv(1,1,1),nmatsz,h(1,1,2),nmatsz,0.d0, ww(1,1,2),nmatsz)
         call DGEMM__('N','N',M,N,K, 1.d0, linv(1,1,2),nmatsz,h(1,1,1),nmatsz,1.d0, ww(1,1,2),nmatsz)
#else
         do i = 1, iba2(ik)
            do j = 1, iba2(ik)
               do k = 1, i
                  ww(i,j,1) = ww(i,j,1)+linv(i,k,1)*h(k,j,1)-linv(i,k,2)*h(k,j,2)
                  ww(i,j,2) = ww(i,j,2)+linv(i,k,1)*h(k,j,2)+linv(i,k,2)*h(k,j,1)
               end do
            end do
         end do
#endif
#ifdef MATDIAGON_DGEMM
         M = iba2(ik); N = iba2(ik); K = iba2(ik)
         call DGEMM__('N','T',M,N,K, 1.d0, ww(1,1,1),nmatsz,linv(1,1,1),nmatsz,0.d0, h(1,1,1),nmatsz)
         call DGEMM__('N','T',M,N,K, 1.d0, ww(1,1,2),nmatsz,linv(1,1,2),nmatsz,1.d0, h(1,1,1),nmatsz)
         call DGEMM__('N','T',M,N,K, 1.d0, ww(1,1,2),nmatsz,linv(1,1,1),nmatsz,0.d0, h(1,1,2),nmatsz)
         call DGEMM__('N','T',M,N,K,-1.d0, ww(1,1,1),nmatsz,linv(1,1,2),nmatsz,1.d0, h(1,1,2),nmatsz)
#else
         h = 0.d0
         do i = 1, iba2(ik)
            do j = 1, iba2(ik)
               do k = 1, j
                  h(i,j,1) = h(i,j,1)+ww(i,k,1)*linv(j,k,1)+ww(i,k,2)*linv(j,k,2)
                  h(i,j,2) = h(i,j,2)+ww(i,k,2)*linv(j,k,1)-ww(i,k,1)*linv(j,k,2)
               end do
            end do
         end do
#endif
      end if
      deallocate(ww)
    end subroutine lhl

    subroutine lx()
#ifdef HIUX
! *** 'poption''s have been inserted by Dr. Kino (National Institute  ***
! *** for Materials Science, Japan).  12 July 2005                    ***
#endif
      integer :: ib, ib2, i, j
      integer :: i1
      if(kimg == 1) then
         do ib = ista_e, iend_e, istep_e
            ib2 = map_z(ib)
            do i = 1, iba2(ik)
               ldag(i,1) = zaj_mat(i,ib2,1)
            end do
            zaj_mat(:,ib2,1) = 0.d0
            do i = 1, iba2(ik)
               do j = 1, iba2(ik)
                  zaj_mat(i,ib2,1) = zaj_mat(i,ib2,1) + linv(j,i,1)*ldag(j,1)
               end do
            end do
         end do
      else if(kimg == 2) then
         do ib = ista_e, iend_e, istep_e
            ib2 = map_z(ib)
            if(iba2(ik) > nmatsz)  call phase_error_with_msg(nfout, ' iba2(ik) > nmatsz' &
                                                            , __LINE__, __FILE__)
            do i = 1, iba2(ik)
               ldag(i,1) = zaj_mat(i,ib2,1)
               ldag(i,2) = zaj_mat(i,ib2,2)
            end do
            zaj_mat(:,ib2,1:2) = 0.d0
            do i = 1, iba2(ik)
               do j = i, iba2(ik)
                  zaj_mat(i,ib2,1) = zaj_mat(i,ib2,1) &
                       &        + linv(j,i,1)*ldag(j,1) + linv(j,i,2)*ldag(j,2)
                  zaj_mat(i,ib2,2) = zaj_mat(i,ib2,2) &
                       &        + linv(j,i,1)*ldag(j,2) - linv(j,i,2)*ldag(j,1)
               end do
            end do
         end do
      end if
    end subroutine lx

    subroutine phase_mult()
      integer :: ib, ib2, ig
      real(kind=DP) :: wfr,wfi,sqrwf, pcos,psin
#ifndef _PHASE_MULT_0_
      integer :: ig1, ig2, ig_max
      complex(kind=CMPLDP) :: exp2theta, exptheta
      real(kind=DP) :: sqrwf0, wfr2, wfi2, sqrwfi, sqrwf1, sqrwf2,f &
           &          ,phase2r, phase2i, cos2theta, pcos0,psin0, norm
      real(kind=DP), parameter :: abswf_min = 1.d-16
#endif

!!$      do ig = 1, nmatsz
      if(kimg == 2) then
         do ib = ista_e, iend_e, istep_e
            ib2 = map_z(ib)
#ifdef _PHASE_MULT_0_
            wfr = zaj_mat(1,ib2,1); wfi = zaj_mat(1,ib2,2)
            if(abs(wfi*wfi) > 1.d-30) then
               sqrwf = wfr**2 + wfi**2
               f = dsqrt(sqrwf)
               pcos = -wfr/f; psin = wfi/f
               if(iprimatdiagon >= 2) then
                  write(nfout,'(4x," pcos, psin = ",2e14.6)') pcos, psin
               end if
               do ig = 1, iba2(ik)
                  wfr = zaj_mat(ig,ib2,1); wfi = zaj_mat(ig,ib2,2)
                  zaj_mat(ig,ib2,1) = pcos*wfr - psin*wfi
                  zaj_mat(ig,ib2,2) = pcos*wfi + psin*wfr
               end do
            end if
#else
            wfi = zaj_mat(1,ib2,2)
            sqrwfi = wfi*wfi
            if(sqrwfi > 1.d-35) then
               wfr = zaj_mat(1,ib2,1)
               sqrwf0 = wfr**2 + sqrwfi
!!$               if(sqrwf0 > abswf_min) then
               if(sqrwfi > abswf_min) then
                  ig_max = 1
               else
                  ig_max = 1
                  g_search: do ig = 2, kg2_gamma
                     ig1 = nbase_gamma(ig,1)
                     wfr = zaj_mat(ig1,ib2,1); wfi = zaj_mat(ig1,ib2,2)
                     sqrwfi = wfi*wfi
                     sqrwf = wfr**2 + sqrwfi
                     if(sqrwfi > abswf_min) then
                        ig_max = ig
                        exit g_search
                     else
                        if(sqrwf > sqrwf0) then
                           ig_max = ig
                           sqrwf0 = sqrwf
                        end if
                     end if
                  end do g_search
               end if
               if(ig_max == 1) then
                  wfr = zaj_mat(1,ib2,1); wfi = zaj_mat(1,ib2,2)
                  sqrwf0 = wfr**2 + wfi**2
                  f = dsqrt(sqrwf0)
                  pcos = -wfr/f; psin = wfi/f
                  if(iprimatdiagon >= 2) then
                     write(nfout,'(4x," pcos, psin = ",2e14.6, " ig_max = ",i5 )') pcos, psin,ig_max
                     write(nfout,'(4x," sqrwf = ",e14.6)') sqrwf0
                  end if
               else if(ig_max >= 2) then
                  wfr = zaj_mat(1,ib2,1); wfi = zaj_mat(1,ib2,2)
                  sqrwf0 = wfr**2 + wfi**2
                  f = dsqrt(sqrwf0)
                  pcos0 = -wfr/f; psin0 = wfi/f
                  if(iprimatdiagon >= 2) then
                     write(nfout,'(4x," pcos, psin = ",2e14.6, " ig =  0")') pcos0, psin0
                  end if
                  ig1 = nbase_gamma(ig_max,1)
                  ig2 = nbase_gamma(ig_max,2)
                  wfr  = zaj_mat(ig1,ib2,1);  wfi  = zaj_mat(ig1,ib2,2)
                  wfr2 = zaj_mat(ig2,ib2,1);  wfi2 = zaj_mat(ig2,ib2,2)
                  sqrwf1 = wfr**2 + wfi**2
                  sqrwf2 = wfr2**2 + wfi2**2
                  sqrwf = sqrt(sqrwf1*sqrwf2)
                  phase2r =  (wfr*wfr2 - wfi*wfi2)/sqrwf
                  phase2i = -(wfr*wfi2 + wfr2*wfi)/sqrwf
                  norm = sqrt(phase2r*phase2r + phase2i*phase2i)
                  phase2r = phase2r/norm
                  phase2i = phase2i/norm
                  exp2theta = dcmplx(phase2r,phase2i)
                  exptheta = sqrt(exp2theta)
                  pcos = real(exptheta)
                  psin = imag(exptheta)
                  if(iprimatdiagon >= 2) then
                     write(nfout,'(4x," pcos, psin = ",2e14.6, " ig_max = ",i5 )') pcos, psin,ig_max
                     write(nfout,'(4x," sqrwf1, sqrwf2, sqrwf = ",3e14.6)') sqrwf1, sqrwf2, sqrwf
                  end if
                  cos2theta = (wfr*wfr2 - wfi*wfi2)/sqrwf
                  cos2theta = cos2theta/norm
                  if(cos2theta > 1.0) cos2theta = 1.d0
                  if(cos2theta < -1.0) then
                     pcos = 0.d0
                     psin = 1.d0
                  else
                     pcos =  sqrt((1+cos2theta)/2.0)
                     psin =  sqrt((1-cos2theta)/2.0)
                  end if
                  if(pcos0 < 0.0) pcos = - pcos
                  if(psin0 < 0.0) psin = - psin
                  if(iprimatdiagon >= 2) then
                     write(nfout,'(4x," pcos, psin = ",2e14.6, " ig_max = ",i5 )') pcos, psin,ig_max
                  end if
               end if
               do ig = 1, iba2(ik)
                  wfr = zaj_mat(ig,ib2,1); wfi = zaj_mat(ig,ib2,2)
                  zaj_mat(ig,ib2,1) = pcos*wfr - psin*wfi
                  zaj_mat(ig,ib2,2) = pcos*wfi + psin*wfr
               end do
               zaj_mat(1,ib2,2) = 0.d0
            !$else
            !$   do ig = 2, kg2_gamma
            !$      ig1 = nbase_gamma(ig,1)
            !$      wfr = zaj_mat(ig1,ib2,1)
            !$      sqrwf = sqrwf + wfr**2
            !$   end do
            !$   sqrwf = 2.d0*sqrwf + zaj_mat(1,ib2,1)**2
            !$   sqrwf = 1.d0/sqrt(sqrwf)
            !$   do ig = 1, iba2(ik)
            !$      wfr = zaj_mat(ig,ib2,1)
            !$      zaj_mat(ig,ib2,1) = wfr*sqrwf
            !$      zaj_mat(ig,ib2,2) = 0.d0
            !$   end do
            end if
#endif
            if(iprimatdiagon >=2 ) then
               write(nfout,'(i4," Re ",5e14.6)') ib, (zaj_mat(ig,map_z(ib),1),ig=1,5)
               write(nfout,'(8x,5e14.6)') (zaj_mat(ig,map_z(ib),1),ig=6,40)
               write(nfout,'(i4," Im ",5e14.6)') ib, (zaj_mat(ig,map_z(ib),2),ig=1,5)
               write(nfout,'(8x,5e14.6)') (zaj_mat(ig,map_z(ib),2),ig=6,40)
            end if
         end do

         if(k_symmetry(ik) == GAMMA_base_symmetrization) then
            do ib = ista_e, iend_e, istep_e
               ib2 = map_z(ib)
               do ig = 2, kg2_gamma
                  ig1 = nbase_gamma(ig,1)
                  ig2 = nbase_gamma(ig,2)
                  wfr = zaj_mat(ig1,ib2,1); wfi = zaj_mat(ig1,ib2,2)
                  zaj_mat(ig2,ib2,1) = wfr
                  zaj_mat(ig2,ib2,2) = -wfi
               end do
            end do
         end if
      end if
      if(iprimatdiagon >= 2) write(nfout,'(" out of <<phase_mult>>")')
    end subroutine phase_mult

    subroutine cp_zaj_mat_to_zaj_l()
      integer :: ib,ig, i, l
      zaj_l(:,:,ik,:) = 0.d0
      if(k_symmetry(ik) == GAMMA) then
         do l = 1, kimg
            do ib = 1, np_e
               do i = 1, kg2_gamma
                  ig = nbase(i,ik)
                  zaj_l(i,ib,ik,l) = zaj_mat(ig,ib,l)
               end do
            end do
         end do
      else
         do l = 1, kimg
            do ib = 1, np_e
               do i = 1, iba2(ik)
                  ig = nbmat2(i,ik)
                  zaj_l(ig,ib,ik,l) = zaj_mat(i,ib,l)
               end do
            end do
         end do
      end if
#ifdef SAVE_FFT_TIMES
      if(sw_save_fft == ON) then
         do ib = 1, np_e
            status_saved_phifftr(ib,ik) = OLD
         end do
      end if
#endif
    end subroutine cp_zaj_mat_to_zaj_l

  end subroutine m_ESmat_solve_Hx_eq_eSx

! ============================== added by Tagami ======================== 11.0
  subroutine m_ESmat_solve_Hx_eq_eSx_noncl( nfout,iteration,iteration_electronic )
    integer, intent(in) :: nfout, iteration, iteration_electronic

    integer,parameter :: PRINT_LEVEL = 2
    integer   :: ik, iksnl, n=0
    integer   :: is1, is2
    integer :: is_tmp


    integer   :: id_sname = -1
    call tstatc0_begin('m_ESmat_solve_Hx_eq_eSx_noncl ',id_sname,1)

    if(iprimatdiagon >= 2) then
       write(nfout,'(" !! iteration = ",i6, " m_ESmat_solve_Hx_eq_eSx_noncl")') &
	&        iteration
    end if

    if(ekmode == ON ) then
       if(iteration_electronic == 1) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
       else
          call m_pwBS_set_gmaxs(n,gmax)
       end if
    else
       if(iteration == 1 .and. intzaj == by_matrix_diagon) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
       else if ( skip_alloc_phonon .and. iteration_electronic == 1 &
                    	         & .and. intzaj == by_matrix_diagon) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
       else
          call m_pwBS_set_gmaxs(n,gmax)
       end if
    end if

    call m_pwBS_alloc_nbmat_and_iba2()
    call m_pwBS_mat_for_each_WF() ! -> nbmat,nbmat2,iba2

    call m_pwBS_alloc_igpo()
    call m_pwBS_GminusGmapfunction()  ! -> igpo, nmatsz2

    if(iprimatdiagon >= 3) write(nfout,'(" nmatsz2 = ",i9)') nmatsz2
    if(iprimatdiagon >= PRINT_LEVEL) &
         & write(nfout,'(" nmatsz, kg1_ext = ", 2i9)') nmatsz, kg1_ext

    call alloc_matrices()
!
    call m_ES_MagMom_to_DensMat_vlhxcl( vlhxc_l, vlhxc_ssrep )
!
    do ik = 1, kv3, ndim_spinor

       if(map_k(ik) /= myrank_k) cycle
       if(iprimatdiagon >= PRINT_LEVEL) &
               & write(nfout,'(" iba2(",i3,") = ", i9)') ik, iba2(ik)

       iksnl = (ik-1)/ndim_spinor + 1
       hsmat = 0.d0

       if ( modnrm == EXECUT ) then
          if ( iprimatdiagon >=3 ) then
            write(nfout,'(" !! modnrm == EXECUT (m_ESmat_solve_Hx_eq_eSx_noncl)")')
          endif

          Do is1=1, ndim_spinor
             call ovmtrx_noncl( is1, is1 )
             if ( iprimatdiagon >= 3 ) then
                call wd_hsmat_noncl(" -- ovmtrx --", is1, is1 )
             end if
          End do

          call complete_hermite_matrix_noncl

          if ( sw_use_zhegvx == ON ) then
             hsmat_s = hsmat
          else
             call cholde_noncl()
             if ( iprimatdiagon >= 3 ) then
                Do is1=1, ndim_spinor
                   call wd_hsmat_noncl(" -- cholde --",is1,is1 )
                End do
             endif
          endif

       endif

       hsmat = 0.d0
       Do is1=1, ndim_spinor
          Do is2=1, ndim_spinor
             call nlmtrx_noncl( is1, is2 )           ! (nlmtrx) -> hsmat <- snl
             if ( iprimatdiagon >= 3 ) then
                call wd_hsmat_noncl(" -- nlmtrx --",is1,is2 )
             end if

             if ( is1==is2 ) then
                call amtrxkinetic_noncl( is1, is2 )     !  -> hsmat
                if ( iprimatdiagon >= 3 ) then
                   call wd_hsmat_noncl(" -- amtrxkinetic --", is1, is2 )
                endif
             endif

             is_tmp = ( is1 -1 )*ndim_spinor + is2
             call prjvlhxc_l2vlhxc_t_noncl( is_tmp )    ! vlhxc_l -> vlhxc
             call amtrxlocalpt_noncl( is1, is2 )                !  -> hsmat
             if ( iprimatdiagon >= 3 ) then
	        call wd_hsmat_noncl(" -- amtrxlocalpt --", is1, is2 )
             endif
          End do
       End do

       call complete_hermite_matrix_noncl

       if ( modnrm == EXECUT ) then
          if ( sw_use_zhegvx == OFF ) then
             call lhl_noncl() ! -> hsmat
             if ( iprimatdiagon >= 3 ) then
                Do is1=1, ndim_spinor
                   Do is2=1, ndim_spinor
                      call wd_hsmat_noncl(" -- lhl --", is1, is2 )
                   End do
                End do
             endif
          endif
       endif

       if ( modnrm == EXECUT .and. sw_use_zhegvx == ON ) then
          call solve_Hx_eq_ex_LAPACK_noncl2()
       else
          call solve_Hx_eq_ex_LAPACK_noncl()
       endif

       if ( iprimatdiagon >= 3 ) then
          Do is1=1, ndim_spinor
             call wd_hsmat_noncl(" -- after diagonalization --",is1,1 )
          End do
       endif

       if ( modnrm == EXECUT ) then
          if ( sw_use_zhegvx == OFF ) then
             call lx_noncl() ! -> zaj_mat
          endif
       endif

!       if ( k_symmetry(ik) == GAMMA .or. &
!	&     k_symmetry(ik) == GAMMA_base_symmetrization ) then
!	  call phase_mult_noncl()
!       endif

       call cp_zaj_mat_to_zaj_l_noncl()     ! zaj_mat -> zaj_l

    end do


    if ( iprimatdiagon >= 3 ) then
       do ik = 1, kv3, ndim_spinor
          if ( map_k(ik) /= myrank_k ) cycle
          call m_ES_wd_zaj_small_portion( nfout, ik, &
	&                         " (m_ESmat_solve_Hx_eq_eSx_noncl)",31 )
       end do
    end if

    call dealloc_matrices()
    call m_pwBS_dealloc_igpo()
    call m_pwBS_dealloc_nbmat_and_iba2()

    call m_ES_betar_dot_WFs(nfout) ! (fsrfsi) -> fsr_l, fsi_l

! ****************************************** This is important ******
    call m_ES_sort_eigen_vals_noncl()
! *******************************************************************

    call tstatc0_end(id_sname)

  contains

    subroutine wd_hsmat_noncl( str, is1, is2 )
      character(len=*),intent(in) :: str
      integer, intent(in) :: is1, is2

      integer :: i, imax, j, jmax
      integer :: ishift, jshift

      integer, parameter :: NMATSIZE = 10
      write(nfout,'(a30," ik= ",i5)') str,ik

      imax = min(NMATSIZE, nmatsz)
      jmax = min(NMATSIZE, nmatsz)
!
      ishift = ( is1 -1 )*iba2(ik)
      jshift = ( is2 -1 )*iba2(ik)
!
      write(nfout,*) 'istart = ', ishift +1
      do j = 1, jmax
         write(nfout,'(" hsmat(istart:*,",i3,",1): ",10f8.4,99(/19x,10f8.4))') j+jshift &
              & , (hsmat( i+ishift, j+jshift, 1 ),i=1,imax)
      end do
      if(kimg == 2) then
         do j = 1, jmax
            write(nfout,'(" hsmat(istart:*,",i3,",2): ",10f8.4,99(/19x,10f8.4))') j+jshift &
                 & , (hsmat( i+ishift,j+jshift,2 ),i=1,imax)
         end do
      end if
    end subroutine wd_hsmat_noncl

   ! [LAPACK] with LAPACK library
   !***** LAPACK [begin] ***** M.Okamoto
    subroutine solve_Hx_eq_ex_LAPACK_noncl()
      integer :: n, lda, ne, ne_found, il, iu, info, ipos, &
                 i, j, ib, lwork, k
      real(kind=DP) ::                     abstol, vl, vu, sum, dlamch
      integer,allocatable ::               ifail(:), iwork(:)
      real(kind=DP),allocatable ::         amat(:,:), evec(:), rvmat(:,:), rwork(:)
      complex(kind=CMPLDP),allocatable ::  cmat(:,:), cvmat(:,:), cwork(:)
      complex(kind=CMPLDP),parameter ::    IMG = (0.d0,1.d0)
      complex(kind=CMPLDP) :: ctemp(1)

      zaj_mat(:,:,:) = 0.d0
      lda = nmatsz *ndim_spinor

      vl = -1.d10 ; vu = 1.d10 ; il = 1 ; iu = neg

      ne = iu - il + 1
      !abstol = eps_solve_Hx_eq_ex
!!$      abstol = 1.d-15
      !abstol = -1.d0

      abstol = 2*dlamch('S')
      if ( kimg == 1 ) then
         n = iba2(ik) *ndim_spinor

         lwork = max(1,12*n)
        !+++++++++++++++++++++++++++++++++++++++++++++++++
         allocate(evec(n),iwork(5*n),ifail(n))
         allocate(amat(lda,n),rvmat(lda,ne),rwork(lwork)); amat = 0.d0
        !+++++++++++++++++++++++++++++++++++++++++++++++++
         do i = 1,n
            do j = 1,n
               amat(i,j) = hsmat(i,j,1)
            end do
         end do
         if ( iprimatdiagon>= 2 )  call check_LAPACKinputs("solve_Hx_eq_ex_LAPACK_noncl "  &
              &                                   ,nfout,n,lda,vl,vu,il,iu,lwork,abstol,RMat=amat)
         call dsyevx( 'V', 'I', 'U', n, amat, lda, vl, vu, il, iu, abstol, &
                       ne_found, evec, rvmat, lda, rwork, lwork, iwork, ifail, info )

         if(iprimatdiagon>=2) call  check_LAPACKoutputs("solve_Hx_eq_ex_LAPACK_noncol " &
              &                                   ,nfout,ik,n,ne,lda,evec,Rmat=rvmat)
         call check_LAPACKerror(ne_found,ne,info)
         do ib = ista_e, iend_e, istep_e
            j = map_z(ib)
            do i = 1,n
               zaj_mat(i,j,1) = rvmat(i,ib)
            end do
            eko_l(j,ik) = evec(ib)
         end do
        !+++++++++++++++++++++++++++++
         deallocate(amat,rvmat,rwork)
        !+++++++++++++++++++++++++++++
      else if (kimg == 2) then
         n = iba2(ik) *ndim_spinor

        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         allocate(evec(n),iwork(5*n),ifail(n))
         allocate(cmat(lda,n),cvmat(lda,ne),rwork(7*n))
! -------------------------------- ktDEBUG --------
         evec = 0.d0; iwork = 0; ifail = 0; cmat = cmplx(0.d0,0.d0)
         cvmat = dcmplx(0.d0,0.d0); rwork = 0.d0;
! -------------------------------- ktDEBUG --------
        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         do i = 1,n
           do j = 1,n
              cmat(i,j) = cmplx(hsmat(i,j,1),hsmat(i,j,2))
           end do
         end do

! -------------------------------- ktDEBUG --------
         call zheevx( 'V', 'I', 'U', n, cmat, lda, vl, vu, il, iu, abstol, &
                       ne_found, evec, cvmat, lda, ctemp, -1, rwork, iwork, &
                       ifail, info )
         lwork = int(real(ctemp(1)))
         allocate(cwork(lwork)); cwork = dcmplx(0.d0,0.d0)
! -------------------------------- ktDEBUG --------

         if(iprimatdiagon>= 2)  call check_LAPACKinputs("solve_Hx_eq_ex_LAPACK_noncl "  &
              &                                   ,nfout,n,lda,vl,vu,il,iu,lwork,abstol,CMat=cmat)

         call zheevx( 'V', 'I', 'U', n, cmat, lda, vl, vu, il, iu, abstol, &
                       ne_found, evec, cvmat, lda, cwork, lwork, rwork, iwork, &
	               ifail, info )

         if(iprimatdiagon>=2) call  check_LAPACKoutputs("solve_Hx_eq_ex_LAPACK_noncol " &
              &                                   ,nfout,ik,n,ne,lda,evec,Cmat=cvmat)

         call check_LAPACKerror(ne_found,ne,info)

         do ib = ista_e, iend_e, istep_e
            j = map_z(ib)
            do i = 1,n
               zaj_mat(i,j,1) = real(cvmat(i,ib))
               zaj_mat(i,j,2) = aimag(cvmat(i,ib))
            end do
            eko_l(j,ik) = evec(ib)
         end do
        !+++++++++++++++++++++++++++++++++++
         deallocate(cmat,cvmat,cwork,rwork)
        !+++++++++++++++++++++++++++++++++++
      end if

      if(iprimatdiagon >= 2) call wd_CalculatedEigenvalues(nfout,ik,n,ne,evec,"solve_Hx_eq_ex_noncl")

      sum = 0.d0
      do i = 1,ne
         sum = sum + abs(evec(i))
      end do
      if (sum < SmallestPositiveNumber*1.d5) then
         call phase_error_with_msg(nfout, ' ! illegal evec (solve_Hx_eq_ex_noncl)',__LINE__,__FILE__)
      endif
      if (iprimatdiagon >= 2) write(nfout,'(" -- sum = ",f20.8)') sum

     !+++++++++++++++++++++++++++++
      deallocate(evec,iwork,ifail)
     !+++++++++++++++++++++++++++++

    end subroutine solve_Hx_eq_ex_LAPACK_noncl

    subroutine solve_Hx_eq_ex_LAPACK_noncl2()
      integer :: n, lda, ne, ne_found, il, iu, info, ipos, &
                 i, j, ib, lwork, k
      real(kind=DP) :: abstol, vl, vu, sum, dlamch
      integer,allocatable :: ifail(:), iwork(:)
      real(kind=DP),allocatable :: amat(:,:), evec(:), rvmat(:,:), rwork(:)
      complex(kind=CMPLDP),allocatable :: cmat(:,:), cmat2(:,:), cvmat(:,:), cwork(:)

      complex(kind=CMPLDP),parameter :: IMG = (0.d0,1.d0)

      complex(kind=CMPLDP) :: ctemp(1)

      zaj_mat(:,:,:) = 0.d0
      lda = nmatsz *ndim_spinor

      vl = -1.d10 ; vu = 1.d10 ; il = 1 ; iu = neg
      ne = iu - il + 1

      abstol = 2*dlamch('S')

      if ( kimg == 1 ) then

      else if (kimg == 2) then
         n = iba2(ik) *ndim_spinor

        !+++++++++++++++++++++++++++++++++++
         allocate(evec(n),iwork(5*n),ifail(n))
         allocate(cmat(lda,n),cmat2(lda,n),cvmat(lda,ne),rwork(7*n))
         evec = 0.d0; iwork = 0; ifail = 0;
         cmat = dcmplx(0.d0,0.d0); cmat2 = dcmplx(0.d0,0.d0); cvmat = dcmplx(0.d0,0.d0); rwork = 0.d0;
        !+++++++++++++++++++++++++++++++++++

         do i = 1,n
           do j = 1,n
              cmat(i,j) = cmplx(hsmat(i,j,1),hsmat(i,j,2))
              cmat2(i,j) = cmplx(hsmat_s(i,j,1),hsmat_s(i,j,2))
           end do
         end do

         call zhegvx( 1, 'V', 'I', 'U', n, cmat, lda, cmat2, lda, &
              &       vl, vu, il, iu, abstol, &
                      ne_found, evec, cvmat, lda, ctemp, -1, rwork, iwork, &
                      ifail, info )
         lwork = int(real(ctemp(1)))
         allocate(cwork(lwork)); cwork = dcmplx(0.d0,0.d0)

         if(iprimatdiagon>=2) call check_LAPACKinputs("solve_Hx_eq_ex_LAPACK_noncl2 "  &
              &                                   ,nfout,n,lda,vl,vu,il,iu,lwork,abstol,CMat=cmat)

         call zhegvx( 1, 'V', 'I', 'U', n, cmat, lda, cmat2, lda, &
              &       vl, vu, il, iu, abstol, &
                      ne_found, evec, cvmat, lda, cwork, lwork, rwork, iwork, &
                      ifail, info )

         if(iprimatdiagon>=2) call check_LAPACKoutputs("solve_Hx_eq_ex_LAPACK_noncl2 " &
              &                                   ,nfout,ik,n,ne,lda,evec,Cmat=cvmat)

         call check_LAPACKerror(ne_found,ne,info)

         do ib = ista_e, iend_e, istep_e
            j = map_z(ib)
            do i = 1,n
               zaj_mat(i,j,1) = real(cvmat(i,ib))
               zaj_mat(i,j,2) = aimag(cvmat(i,ib))
            end do
            eko_l(j,ik) = evec(ib)
         end do
        !+++++++++++++++++++++++++++++++++++
         deallocate(cmat,cmat2,cvmat,cwork,rwork)
        !+++++++++++++++++++++++++++++++++++
      end if

      if(iprimatdiagon >= 2) call wd_CalculatedEigenvalues(nfout,ik,n,ne,evec,"solve_Hx_eq_ex_noncl2")

      sum = 0.d0
      do i = 1,ne
         sum = sum + abs(evec(i))
      end do
      if (sum < SmallestPositiveNumber*1.d5) then
         call phase_error_with_msg(nfout, ' ! illegal evec (solve_Hx_eq_ex_noncl)',__LINE__,__FILE__)
      endif
      if (iprimatdiagon >= 2) write(nfout,'(" -- sum = ",f20.8)') sum

     !+++++++++++++++++++++++++++++
      deallocate(evec,iwork,ifail)
     !+++++++++++++++++++++++++++++

    end subroutine solve_Hx_eq_ex_LAPACK_noncl2

    subroutine calphase(ia)
      integer, intent(in) :: ia
      integer       :: i
      real(kind=DP) :: ph
      do i = 1, nmatsz2
         ph = (pos(ia,1)*ngabc(i,1)+pos(ia,2)*ngabc(i,2)+pos(ia,3)*ngabc(i,3))*PAI2
         zfcos(i) = cos(ph)
         zfsin(i) = sin(ph)
      end do
      zfcos(0) = 0.d0; zfsin(0) = 0.d0
    end subroutine calphase

    subroutine nlmtrx_noncl( is1, is2 )
      integer, intent(in) :: is1, is2

      real(kind=DP),pointer,dimension(:,:,:) :: a
      real(kind=DP),allocatable,dimension(:,:)  :: s
      integer, pointer, dimension(:,:)       :: ng

      complex(kind=CMPLDP),parameter :: zi = (0.d0,1.d0)
      integer :: i,j,it,ia,u,v,n,lmt1,il1,lmt2,il2,j1,l1,l2,l3,ip,y,i1
      integer :: i2,j2,m
      integer :: ishift, jshift

      integer :: is_tmp

      complex(kind=CMPLDP) :: fr,f21,f12,t, fr_tmp1, fr_tmp2
      real(kind=DP) :: t_r, t_i

!
      ishift = ( is1 -1 )*iba2(ik)
      jshift = ( is2 -1 )*iba2(ik)
!
      is_tmp = ( is1 -1 )*ndim_spinor + is2
!
      a => hsmat
      ng => ngabc

      allocate(s(kg1_ext,nlmtt)); s = 0.d0

      if(k_symmetry(ik) == GAMMA) then
         if(iprimatdiagon >= 2) write(nfout,'(" k_symmetry(ik) == GAMMA <<nlmtrx>>")')
         if(iprimatdiagon >= 2) write(nfout,'(" kg2_gamma, iba(ik), iba2(ik) = ",3i8)') kg2_gamma,iba(ik),iba2(ik)
         do j = 1, nlmtt
            ! --- finding it and lmt
            Finding: do u = 1, ntyp
               do ip = 1, ilmt(u)
                  if(lmtt(ip,u) == j) then
                     lmt1 = ip
                     it = u
                     exit Finding
                  end if
               end do
            end do Finding
            il1 = ltp(lmt1,it)
            if(iprimatdiagon >= 2) write(nfout,'(" nlmtt, j, lmt1, it, il1 = ",5i8)') nlmtt,j,lmt1,it,il1
            s(1,j) = snl(1,j,iksnl)
            if(mod(il1,2) == 0) then
               do i = 2, kg2_gamma
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) = snl(i,j,iksnl)
                  s(i2,j) = -snl(i,j,iksnl)
               end do
            else
               do i = 2, kg2_gamma
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) = snl(i,j,iksnl)
                  s(i2,j) = snl(i,j,iksnl)
               end do
            end if
         end do
      else
         if(iprimatdiagon >= 2) write(nfout,'(" k_symmetry(ik) /= GAMMA <<nlmtrx>>")')
         do j = 1, nlmtt
            do i = 1, iba(ik)
               s(i,j) = snl(i,j,iksnl)
            end do
         end do
      end if

      do ia = 1, natm
         it = ityp(ia)
         call calphase(ia)  ! -> zfcos, zfsin

! ===============
         if ( modnrm == SKIP .and. SpinOrbit_mode == Neglected &
              &              .and. sw_hubbard == OFF ) then
            do ip = 1, n_non0_lmtxlmt(it)
                                             ! This counts only m1==m2, l1==l2
               lmt1  = index_lmt1_lmt2(ip,it,1)
               lmt2  = index_lmt1_lmt2(ip,it,2)
               u     = lmtt(lmt1,it)
               v     = lmtt(lmt2,it)
               il1   = ltp(lmt1,it)
               il2   = ltp(lmt2,it)

               if(lmt2 <= lmt1) cycle

               if(ivan(it) /= 1 .and. &
                    & (il1 /= il2 .or. mtp(lmt1,it) /= mtp(lmt2,it))) cycle

               if(mod(il1+il2,2) == 0) then

                  fr = dion_scr_noncl(lmt1,lmt2,is_tmp,ia)

                  if(il1==il2) then
                     f21 = fr *iwei(ia)

                     do j = 1, iba2(ik)
                        j1 = nbmat(j,ik)
                        j2 = nbmat2(j,ik)
                        l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
                        if(kimg == 1) then

                           do i = j, iba2(ik)
                              n = nbmat(i,ik)
                              m = nbmat2(i,ik)
                              y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                              a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
                                   &                   + f21*( s(m,u)*s(j2,v) &
                                   &                          +s(m,v)*s(j2,u) ) &
                                   &                    *zfcos(y)
                           end do
                        else

                           do i = j, iba2(ik)
                              n = nbmat(i,ik)
                              m = nbmat2(i,ik)
                              y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                              t  = f21*( s(m,u)*s(j2,v)+s(m,v)*s(j2,u) )

                              t_r = real(t);  t_i = aimag(t)

                              a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
                                   &                   + t_r *zfcos(y) + t_i *zfsin(y)
                              a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) &
                                   &                   - t_r *zfsin(y) + t_i *zfcos(y)
                           end do
                        end if
                     end do
                  else
                     f21 = real(zi**(il2-il1)) *fr *iwei(ia)
                     f12 = real(zi**(il1-il2)) *fr *iwei(ia)

                     write(nfout,'(" zi**(il1-il2) = ",2f16.8)') zi**(il1-il2)

                     do j = 1, iba2(ik)
                        j1 = nbmat(j,ik)
                        j2 = nbmat2(j,ik)
                        l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)

                        if(kimg == 1) then

                           do i = j, iba2(ik)
                              n = nbmat(i,ik)
                              m = nbmat2(i,ik)
                              y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                              a( i+ishift, j+jshift, 1 ) = a( i+ishift, j+jshift,1 )&
                                   &                      +( f21*s(m,u)*s(j2,v) &
                                   &                        +f12*s(m,v)*s(j2,u) ) &
                                   &                       *zfcos(y)
                           end do
                        else

                           do i = j, iba2(ik)
                              n = nbmat(i,ik)
                              m = nbmat2(i,ik)
                              y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)

                              t  = f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u)

                              t_r = real(t);  t_i = aimag(t)

                              a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1) &
                                   &                   + t_r *zfcos(y) + t_i *zfsin(y)
                              a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) &
                                   &                   - t_r *zfsin(y) + t_i *zfcos(y)

                           end do
                        end if
                     end do
                  end if
               else if(mod(il1+il2,2) == 1) then

                  fr = dion_scr_noncl(lmt1,lmt2,is_tmp,ia)

                  f21 = aimag(zi**(il2-il1))*fr*iwei(ia)    !    f21 = -aimag(zi**(il2-il1))*fr*iwei(ia)
                  f12 = aimag(zi**(il1-il2))*fr*iwei(ia)    !    f12 = -aimag(zi**(il1-il2))*fr*iwei(ia)

                  do j = 1, iba2(ik)
                     j1 = nbmat(j,ik)
                     j2 = nbmat2(j,ik)
                     l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
                     if ( kimg == 1 ) then

                        do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 )&
                                &                    + ( f21*s(m,u)*s(j2,v) &
                                &                       +f12*s(m,v)*s(j2,u) ) &
                                &                     *zfsin(y)
                        end do
                     else

                        do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           t = f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u)

                           t_r = real(t);  t_i = aimag(t)

                           a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
                                &                   + t_r *zfsin(y) - t_i *zfcos(y)
                           a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) &
                                &                   + t_r *zfcos(y) + t_i *zfsin(y)
                        end do
                     end if
                  end do
               end if
            end do
! ----------------------------------------------- when Spin-Orbit is included --
         else

            do lmt1=1, ilmt(it)
               Do lmt2=1, ilmt(it)

                  u     = lmtt(lmt1,it)
                  v     = lmtt(lmt2,it)
                  il1   = ltp(lmt1,it)
                  il2   = ltp(lmt2,it)

                  if (lmt2 <= lmt1 ) cycle

!                  if(ivan(it) /= 1 .and. (il1 /= il2) ) cycle
!                  if ( il1 /= il2 ) cycle

                  if(mod(il1+il2,2) == 0) then

                     fr_tmp1 = dion_scr_noncl(lmt1,lmt2,is_tmp,ia)
                     fr_tmp2 = dion_scr_noncl(lmt2,lmt1,is_tmp,ia)

                     if(il1==il2) then
                        f21 = fr_tmp1 *iwei(ia)
                        f12 = fr_tmp2 *iwei(ia)

                        do j = 1, iba2(ik)
                           j1 = nbmat(j,ik)
                           j2 = nbmat2(j,ik)
                           l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
                           if(kimg == 1) then

                              do i = j, iba2(ik)
                                 n = nbmat(i,ik)
                                 m = nbmat2(i,ik)
                                 y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                                 a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
                                      &                   + ( f21 *s(m,u)*s(j2,v) &
                                      &                      +f12 *s(m,v)*s(j2,u) ) &
                                      &                    *zfcos(y)
                              end do
                           else

                              do i = j, iba2(ik)
                                 n = nbmat(i,ik)
                                 m = nbmat2(i,ik)
                                 y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)

                                 t  = f21*s(m,u)*s(j2,v) + f12*s(m,v)*s(j2,u)

                                 t_r = real(t);  t_i = aimag(t)

                                 a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
                                      &                   + t_r *zfcos(y) + t_i *zfsin(y)
                                 a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) &
                                      &                   - t_r *zfsin(y) + t_i *zfcos(y)
                              end do
                           end if
                        end do
                     else

                        f21 = real(zi**(il2-il1)) *fr_tmp1 *iwei(ia)
                        f12 = real(zi**(il1-il2)) *fr_tmp2 *iwei(ia)

!!!!                        write(nfout,'(" zi**(il1-il2) = ",2f16.8)') zi**(il1-il2)

                        do j = 1, iba2(ik)
                           j1 = nbmat(j,ik)
                           j2 = nbmat2(j,ik)
                           l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)

                           if(kimg == 1) then

                              do i = j, iba2(ik)
                                 n = nbmat(i,ik)
                                 m = nbmat2(i,ik)
                                 y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                                 a( i+ishift, j+jshift, 1 ) = a( i+ishift, j+jshift,1 )&
                                      &                      +( f21*s(m,u)*s(j2,v) &
                                      &                        +f12*s(m,v)*s(j2,u) ) &
                                      &                       *zfcos(y)
                              end do
                           else

                              do i = j, iba2(ik)
                                 n = nbmat(i,ik)
                                 m = nbmat2(i,ik)
                                 y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)

                                 t  = f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u)

                                 t_r = real(t);  t_i = aimag(t)

                                 a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1) &
                                      &                   + t_r *zfcos(y) + t_i *zfsin(y)
                                 a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) &
                                      &                   - t_r *zfsin(y) + t_i *zfcos(y)

                              end do
                           end if
                        end do
                     end if

                  else if(mod(il1+il2,2) == 1) then

                     fr_tmp1 = dion_scr_noncl(lmt1,lmt2,is_tmp,ia)
                     fr_tmp2 = dion_scr_noncl(lmt2,lmt1,is_tmp,ia)

!                     f21 = -aimag(zi**(il2-il1))*fr_tmp1*iwei(ia)
!                     f12 = -aimag(zi**(il1-il2))*fr_tmp2*iwei(ia)
                     f21 = aimag(zi**(il2-il1))*fr_tmp1*iwei(ia)
                     f12 = aimag(zi**(il1-il2))*fr_tmp2*iwei(ia)

                     do j = 1, iba2(ik)
                        j1 = nbmat(j,ik)
                        j2 = nbmat2(j,ik)
                        l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
                        if ( kimg == 1 ) then

                           do i = j, iba2(ik)
                              n = nbmat(i,ik)
                              m = nbmat2(i,ik)
                              y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                              a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 )&
                                   &                    + ( f21*s(m,u)*s(j2,v) &
                                   &                       +f12*s(m,v)*s(j2,u) ) &
                                   &                     *zfsin(y)
                           end do
                        else

                           do i = j, iba2(ik)
                              n = nbmat(i,ik)
                              m = nbmat2(i,ik)
                              y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                              t = f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u)

                              t_r = real(t);  t_i = aimag(t)

                              a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
                                   &                   + t_r *zfsin(y) - t_i *zfcos(y)
                              a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) &
                                   &                   + t_r *zfcos(y) + t_i *zfsin(y)
                           end do
                        end if
                     end do
                  end if
               end do
            end do
         endif
! ------------------------------------------ diagonal term ----
         do lmt1 = 1, ilmt(it)

            fr = ( dion_scr_noncl(lmt1,lmt1,is_tmp,ia) )*iwei(ia)

            u  = lmtt(lmt1,it)
            do j = 1, iba2(ik)
               j1 = nbmat(j,ik)
               j2 = nbmat2(j,ik)
               l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
               if(kimg == 1) then

                  do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     y = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)
                     a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
	&                         + fr*s(i2,u)*s(j2,u)*zfcos(y)
                  end do
               else if(kimg == 2) then

                  do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     y = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)
                     t = fr*s(i2,u)*s(j2,u)

                     t_r = real(t);  t_i = aimag(t)

                     a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
	&                                       + t_r *zfcos(y) + t_i *zfsin(y)
                     a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) &
	&                                       - t_r *zfsin(y) + t_i *zfcos(y)
                  end do
               end if
            end do
         end do
      end do
      deallocate(s)

    end subroutine nlmtrx_noncl

    subroutine ovmtrx_noncl( is1, is2 )
      integer, intent(in) :: is1, is2

      integer :: i,j,it,ia,u,v,n,ip,y,jn,j1,l1,l2,l3,i1,lmt1,lmt2
      integer :: i2,j2,m,jm
      integer :: il1, il2

      integer :: ishift, jshift

      integer :: is_tmp

      complex(kind=CMPLDP) :: fr,t, fr_tmp1, fr_tmp2
      real(kind=DP) :: t_r, t_i

      real(kind=DP),pointer,dimension(:,:,:) :: a
      real(kind=DP),allocatable,dimension(:,:)   :: s
      integer,pointer,dimension(:,:)         :: ng
!
      ishift = ( is1 -1 )*iba2(ik)
      jshift = ( is2 -1 )*iba2(ik)

      is_tmp = ( is1 -1 )*ndim_spinor + is2

      a => hsmat;        ng => ngabc
      allocate(s(kg1_ext,nlmtt))

      if(k_symmetry(ik) == GAMMA) then
         do j = 1, nlmtt
            ! --- finding it and lmt
            Finding: do u = 1, ntyp
               do ip = 1, ilmt(u)
                  if(lmtt(ip,u) == j) then
                     lmt1 = ip
                     it = u
                     exit Finding
                  end if
               end do
            end do Finding
            l1 = ltp(lmt1,it)
            s(1,j) = snl(1,j,iksnl)
            if(mod(l1,2) == 0) then
               do i = 2, iba(ik)
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) =  snl(i,j,iksnl)
                  s(i2,j) = -snl(i,j,iksnl)
               end do
            else
               do i = 2, iba(ik)
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) = snl(i,j,iksnl)
                  s(i2,j) = snl(i,j,iksnl)
               end do
            end if
         end do
         if(iprimatdiagon >= 3) then
            write(nfout,'(" --- ovmtrx ---")')
            write(nfout,'(" ik = ",i8)') ik
            do j = 1, nlmtt
               write(nfout,'(" s(1:*,",i3,")      : ",10f8.4)')j, (s(i,j),i=1,10)
            end do
         end if
      else
         do j = 1, nlmtt
            do i = 1, kg1
               s(i,j) = snl(i,j,iksnl)
            end do
         end do
      end if

      do i = 1, iba2(ik)
         a( i+ishift,i+jshift,1 ) = 1.d0
      end do

      do ia = 1, natm
         it = ityp(ia)
         call calphase(ia)  ! -> zfcos, zfsin

! ===============
         if ( SpinOrbit_mode /= BuiltIn  ) then
            do ip = 1, n_non0_lmtxlmt(it)
               lmt1 = index_lmt1_lmt2(ip,it,1)
               u = lmtt(lmt1,it)
               lmt2 = index_lmt1_lmt2(ip,it,2)

               if(lmt2 <= lmt1) cycle
               v = lmtt(lmt2,it)

               if(ltp(lmt1,it) /= ltp(lmt2,it) .or. mtp(lmt1,it) /= mtp(lmt2,it) ) cycle

               fr = q_noncl( lmt1, lmt2, is_tmp, it ) *iwei(ia)

               do j = 1, iba2(ik)
                  jn = nbmat(j,ik)
                  jm = nbmat2(j,ik)
                  l1 = ng(jn,1); l2 = ng(jn,2); l3 = ng(jn,3)

                  if ( kimg == 1 ) then

                     do i = j, iba2(ik)
                        n = nbmat(i,ik)
                        m = nbmat2(i,ik)
                        y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                        a( i+ishift, j+jshift, 1 ) = a( i+ishift, j+jshift, 1 ) &
                             &                      + fr *( s(m,u)*s(jm,v) &
                             &                             +s(m,v)*s(jm,u) ) &
                             &                        *zfcos(y)
                     end do
                  else

                     do i = j, iba2(ik)
                        n = nbmat(i,ik)
                        m = nbmat2(i,ik)
                        y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)

                        t  = fr *( s(m,u)*s(jm,v)+s(m,v)*s(jm,u) )
                        t_r = real(t);  t_i = aimag(t)

                        a( i+ishift, j+jshift, 1 ) = a( i+ishift,j+jshift, 1 ) &
                             &                      + t_r *zfcos(y) + t_i *zfsin(y)
                        a( i+ishift, j+jshift, 2 ) = a( i+ishift,j+jshift, 2 ) &
                             &                      - t_r *zfsin(y) + t_i *zfcos(y)
                     end do
                  end if
               end do
            end do

         else
! -------------------------------------- when Spin-Orbit is included -- ( builtin )
!            do lmt1=1, nlmt
!               Do lmt2=1, nlmt
            do lmt1=1, ilmt(it)
               Do lmt2=1, ilmt(it)

                  u     = lmtt(lmt1,it)
                  v     = lmtt(lmt2,it)
                  il1   = ltp(lmt1,it)
                  il2   = ltp(lmt2,it)

                  if(lmt2 <= lmt1) cycle

                  v = lmtt(lmt2,it)

                  if ( ltp(lmt1,it) /= ltp(lmt2,it) ) cycle

                  fr_tmp1 = q_noncl( lmt1, lmt2, is_tmp, it ) *iwei(ia)
                  fr_tmp2 = q_noncl( lmt2, lmt1, is_tmp, it ) *iwei(ia)

                  do j = 1, iba2(ik)
                     jn = nbmat(j,ik)
                     jm = nbmat2(j,ik)
                     l1 = ng(jn,1); l2 = ng(jn,2); l3 = ng(jn,3)

                     if ( kimg == 1 ) then

                        do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           a( i+ishift, j+jshift, 1 ) = a( i+ishift, j+jshift, 1 ) &
                                &                      + ( fr_tmp1*s(m,u)*s(jm,v) &
                                &                       +fr_tmp2*s(m,v)*s(jm,u) ) &
                                &                       *zfcos(y)
                        end do
                     else

                        do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)

                           t  = fr_tmp1*s(m,u)*s(jm,v) +fr_tmp2*s(m,v)*s(jm,u)

                           t_r = real(t);  t_i = aimag(t)

                           a( i+ishift, j+jshift, 1 ) = a( i+ishift,j+jshift, 1 ) &
                                &                      + t_r *zfcos(y) + t_i *zfsin(y)
                           a( i+ishift, j+jshift, 2 ) = a( i+ishift,j+jshift, 2 ) &
                                &                      - t_r *zfsin(y) + t_i *zfcos(y)
                        end do
                     end if
                  end do
               End do
            End do

         endif
! ------------------------------------------ diagonal term ----
         do lmt1 = 1, ilmt(it)
            u  = lmtt(lmt1,it)

            fr = q_noncl(lmt1,lmt1,is_tmp,it) *iwei(ia)

            do j = 1, iba2(ik)
               j1 = nbmat(j,ik)
               j2 = nbmat2(j,ik)
               l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)

               if ( kimg == 1 ) then

                  do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     ip = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)
                     a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
	&                         + fr *s(i2,u)*s(j2,u)*zfcos(ip)
                  end do
               else if (kimg == 2) then

                  do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     ip = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)

                     t  = fr *s(i2,u)*s(j2,u)
                     t_r = real(t);  t_i = aimag(t)

                     a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
	&                         + t_r *zfcos(ip) + t_i *zfsin(ip)
                     a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) &
	&                         - t_r *zfsin(ip) + t_i *zfcos(ip)
                  end do
               end if
            end do
         end do
      end do

!      if(kimg == 1) then
!         do j = 2, iba2(ik)
!            do i = 1, j-1
!               a(i+isfhit,j+jshift,1) = a(j+jshift,i+isfhit,1)
!            end do
!         end do
!      else
!         do j = 2, iba2(ik)
!            do i = 1, j-1
!               a(i+isfhit,j+jsfhit,1) =  a(j+jshift,i+ishift,1)
!               a(i+isfhit,j+jshift,2) = -a(j+jshift,i+isfhit,2)
!            end do
!         end do
!      end if

      deallocate(s)

    end subroutine ovmtrx_noncl

    subroutine cholde_noncl
! Choleski decomposition.
! ref: S.G.Louie,K.M.Ho,and M.L.Cohen, PRB19,(1979),p1774.
      integer       :: n,i,j
      real(kind=DP) :: t
      integer  :: imax, jmax
      integer, parameter :: NMATSIZE = 10

      linv = 0.d0
      linv(1,1,1) = 1.d0/sqrt(hsmat(1,1,1))
      if ( kimg == 1 ) then
         do n = 1, iba2(ik)*ndim_spinor -1
            ldag = 0.d0
            do  i = 1, n
               do j = 1, i
                  ldag(i,1) = ldag(i,1) + linv(i,j,1)*hsmat(j,n+1,1)
               end do
            end do
            t = 0.d0
            do i = 1, n
               t = t + ldag(i,1)**2
            end do
            ldag(n+1,1) = sqrt(hsmat(n+1,n+1,1)-t)
            linv(n+1,n+1,1) = 1.d0/sqrt(hsmat(n+1,n+1,1)-t)
            do i = 1, n
               do j = 1, n
                  linv(n+1,i,1)=linv(n+1,i,1)-linv(n+1,n+1,1)*ldag(j,1)*linv(j,i,1)
               end do
            end do
         end do
      else if(kimg == 2) then

         do n = 1, iba2(ik)*ndim_spinor -1
            ldag = 0.d0
            do i = 1, n
               do j = 1, i
                  ldag(i,1) = ldag(i,1) &
                       & + linv(i,j,1)*hsmat(j,n+1,1)-linv(i,j,2)*hsmat(j,n+1,2)
                  ldag(i,2) = ldag(i,2) &
                       & + linv(i,j,1)*hsmat(j,n+1,2)+linv(i,j,2)*hsmat(j,n+1,1)
               end do
            end do
            t = 0.d0
            do i = 1, n
               t = t + ldag(i,1)**2 + ldag(i,2)**2
            end do

!
            ldag(n+1,1) = sqrt(hsmat(n+1,n+1,1)-t)
            linv(n+1,n+1,1) = 1.d0/sqrt(hsmat(n+1,n+1,1)-t)
            do i = 1, n
               do j = 1, n
                  linv(n+1,i,1) = linv(n+1,i,1) &
                       &       - linv(n+1,n+1,1)*(ldag(j,1)*linv(j,i,1) &
                       &                         +ldag(j,2)*linv(j,i,2))&
                       &       + linv(n+1,n+1,2)*(ldag(j,1)*linv(j,i,2)&
                       &                         -ldag(j,2)*linv(j,i,1) )
                  linv(n+1,i,2) = linv(n+1,i,2) &
                       &       - linv(n+1,n+1,1)*(ldag(j,1)*linv(j,i,2) &
                       &                         -ldag(j,2)*linv(j,i,1))&
                       &       - linv(n+1,n+1,2)*(ldag(j,1)*linv(j,i,1)&
                       &                         -ldag(j,2)*linv(j,i,2) )
               end do
            end do
         end do
      end if

      if(iprimatdiagon >= 2) then
         imax = NMATSIZE; if(imax > nmatsz) imax = nmatsz
         jmax = NMATSIZE; if(jmax > nmatsz) jmax = nmatsz

         do j = 1, jmax
            write(nfout,'(" linv(1:*,",i3,",1): ",10f8.4,99(/18x,10f8.4))') j &
                 & , (linv(i,j,1),i=1,imax)
         end do

         if(kimg == 2) then
            do j = 1, jmax
               write(nfout,'(" linv(1:*,",i3,",2): ",10f8.4,99(/18x,10f8.4))') j &
                    & , (linv(i,j,2),i=1,imax)
            end do
         end if

      end if
    end subroutine cholde_noncl

    subroutine amtrxkinetic_noncl( is1, is2 )
      integer, intent(in) :: is1, is2

      integer :: i,j
      integer :: ishift, jshift
      real(kind=DP) :: ga,gb,gc
!
      ishift = ( is1 -1 )*iba2(ik)
      jshift = ( is2 -1 )*iba2(ik)
!
      do i = 1, iba2(ik)
         j = nbmat(i,ik)
         ga = vkxyz(ik,1,BUCS) + ngabc(j,1)
         gb = vkxyz(ik,2,BUCS) + ngabc(j,2)
         gc = vkxyz(ik,3,BUCS) + ngabc(j,3)
         hsmat( i+ishift,i+jshift,1 ) = hsmat( i+ishift,i+jshift, 1 ) &
	      & + 0.5d0 * (ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
              &           +ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga )
      end do
    end subroutine amtrxkinetic_noncl

    subroutine prjvlhxc_l2vlhxc_t_noncl( is )
      integer, intent(in) :: is

      integer :: i,irc
      vlhxc = 0.d0
      do irc = 1, kimg
         do i = ista_kngp, iend_kngp
            if(i > nmatsz2) cycle
            vlhxc(i,irc) = vlhxc_ssrep(i,irc,is)
         end do
      end do
      if(npes >= 2) then
         call mpi_allreduce(MPI_IN_PLACE,vlhxc,nmatsz2*kimg,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
      end if
    end subroutine prjvlhxc_l2vlhxc_t_noncl

    subroutine amtrxlocalpt_noncl( is1, is2 )
      integer, intent(in) :: is1, is2

      integer :: j,j1,l1,l2,l3,i,n,ip
      integer :: ishift, jshift
      real(kind=DP),pointer,dimension(:,:,:) :: a
      integer,      pointer,dimension(:,:)   :: ng
!
      ishift = ( is1 -1 )*iba2(ik)
      jshift = ( is2 -1 )*iba2(ik)
!
      a  => hsmat
      ng => ngabc

      do j = 1, iba2(ik)
         j1 = nbmat(j,ik)
         l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
         if(kimg == 1) then
!!!!!!!            do i = j, iba2(ik)
            do i = 1, iba2(ik)
               n = nbmat(i,ik)
               ip = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
               a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) + vlhxc(ip,1)
            end do
         else
!!!!!!!            do i = j, iba2(ik)
            do i = 1, iba2(ik)
               n = nbmat(i,ik)
               ip = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
               a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) + vlhxc(ip,1)
               a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) + vlhxc(ip,2)
            end do
         end if
      end do
! ============= dangerous -
!      if(kimg == 1) then
!         do j = 2, iba2(ik)
!            do i = 1, j-1
!               a( i+isfhit,j+jshift,1)  = a( j+jshift,i+isfhit,1 )
!!            end do
!         end do
!      else
!         do j = 2, iba2(ik)
!            do i = 1, j-1
!               a( i+ishift,j+jshift,1 ) =  a( j+jshift,i+ishift,1 )
!               a( i+ishift,j+jshift,2 ) = -a( j+jshift,i+ishift,2 )
!            end do
!         end do
!      end if
! ======================
    end subroutine amtrxlocalpt_noncl

    subroutine complete_hermite_matrix_noncl
      integer :: is1, is2, i, j
      integer :: ishift, jshift
      real(kind=DP),pointer,dimension(:,:,:) :: a

      a  => hsmat

      Do is1=1, ndim_spinor
         Do is2=1, ndim_spinor
            ishift = ( is1 -1 )*iba2(ik)
            jshift = ( is2 -1 )*iba2(ik)

!            istmp1 = ( is1 -1 )*ndim_spinor + is2
!            istmp2 = ( is2 -1 )*ndim_spinor + is1
!
            Do j=2, iba2(ik)
               Do i=1, j-1
                  a( i+ishift,j+jshift,1 ) =  a( j+jshift,i+ishift,1 )
                  a( i+ishift,j+jshift,2 ) = -a( j+jshift,i+ishift,2 )
               End do
            End do

         End do
      End do

    end subroutine complete_hermite_matrix_noncl

    subroutine lhl_noncl
      real(kind=DP),pointer,dimension(:,:,:)     :: h
      real(kind=DP),allocatable,dimension(:,:,:) :: ww
      integer :: i,j,k, M, N

      h => hsmat
      allocate( ww( nmatsz*ndim_spinor, nmatsz*ndim_spinor, kimg ) ); ww = 0.d0

      if (kimg == 1) then
#ifdef MATDIAGON_DGEMM
         M = iba2(ik) *ndim_spinor;
	 N = iba2(ik) *ndim_spinor;
	 K = iba2(ik) *ndim_spinor
         call DGEMM__(' N', 'N', M, N, K, 1.d0, linv(1,1,1), nmatsz*ndim_spinor, &
	&              h(1,1,1), nmatsz*ndim_spinor, 0.d0, &
	&              ww(1,1,1), nmatsz*ndim_spinor )
#else
         do i = 1, iba2(ik)*ndim_spinor
            do j = 1, iba2(ik)*ndim_spinor
               do k = 1, i
                  ww(i,j,1) = ww(i,j,1) + linv(i,k,1)*h(k,j,1)
               end do
            end do
         end do
#endif
#ifdef MATDIAGON_DGEMM
         call DGEMM__( 'N','T', M, N, K, 1.d0, ww(1,1,1), nmatsz*ndim_spinor, &
	&              linv(1,1,1), nmatsz*ndim_spinor, 0.d0, &
	&              h(1,1,1), nmatsz*ndim_spinor )
#else
         h = 0.d0
         do i = 1, iba2(ik) *ndim_spinor
            do j = 1, iba2(ik) *ndim_spinor
               do k = 1, j
                  h(i,j,1) = h(i,j,1) + ww(i,k,1)*linv(j,k,1)
              end do
            end do
         end do
#endif
      else if (kimg == 2) then
#ifdef MATDIAGON_DGEMM
         M = iba2(ik) *ndim_spinor
	 N = iba2(ik) *ndim_spinor
	 K = iba2(ik) *ndim_spinor
         call DGEMM__( 'N','N', M, N, K, 1.d0, linv(1,1,1), nmatsz*ndim_spinor,&
	&               h(1,1,1), nmatsz*ndim_spinor, 0.d0, &
	&               ww(1,1,1), nmatsz*ndim_spinor )
         call DGEMM__( 'N','N', M, N, K,-1.d0, linv(1,1,2), nmatsz*ndim_spinor,&
	&               h(1,1,2), nmatsz*ndim_spinor, 1.d0, &
	&               ww(1,1,1), nmatsz*ndim_spinor )
         call DGEMM__( 'N','N', M, N, K, 1.d0, linv(1,1,1), nmatsz*ndim_spinor,&
	&               h(1,1,2), nmatsz*ndim_spinor, 0.d0, &
	&               ww(1,1,2), nmatsz*ndim_spinor )
         call DGEMM__( 'N','N', M, N, K, 1.d0, linv(1,1,2), nmatsz*ndim_spinor,&
	&               h(1,1,1), nmatsz*ndim_spinor, 1.d0, &
	&               ww(1,1,2), nmatsz*ndim_spinor )
#else
         do i = 1, iba2(ik) *ndim_spinor
            do j = 1, iba2(ik) *ndim_spinor
               do k = 1, i
                  ww(i,j,1) = ww(i,j,1)+linv(i,k,1)*h(k,j,1)-linv(i,k,2)*h(k,j,2)
                  ww(i,j,2) = ww(i,j,2)+linv(i,k,1)*h(k,j,2)+linv(i,k,2)*h(k,j,1)
               end do
            end do
         end do
#endif
#ifdef MATDIAGON_DGEMM
         M = iba2(ik) *ndim_spinor;
	 N = iba2(ik) *ndim_spinor;
	 K = iba2(ik) *ndim_spinor
         call DGEMM__( 'N','T', M, N, K, 1.d0, ww(1,1,1), nmatsz*ndim_spinor, &
	&              linv(1,1,1), nmatsz*ndim_spinor, 0.d0, &
	&              h(1,1,1), nmatsz*ndim_spinor )
         call DGEMM__( 'N','T', M, N, K, 1.d0, ww(1,1,2), nmatsz*ndim_spinor, &
	&              linv(1,1,2), nmatsz*ndim_spinor, 1.d0, &
	&              h(1,1,1), nmatsz*ndim_spinor )
         call DGEMM__( 'N','T', M, N, K, 1.d0, ww(1,1,2), nmatsz*ndim_spinor, &
	&              linv(1,1,1), nmatsz*ndim_spinor, 0.d0, &
	&              h(1,1,2), nmatsz*ndim_spinor )
         call DGEMM__( 'N','T', M, N, K,-1.d0, ww(1,1,1), nmatsz*ndim_spinor, &
	&              linv(1,1,2), nmatsz*ndim_spinor, 1.d0, &
	&              h(1,1,2), nmatsz*ndim_spinor )
#else
         h = 0.d0
         do i = 1, iba2(ik) *ndim_spinor
            do j = 1, iba2(ik) *ndim_spinor
               do k = 1, j
                  h(i,j,1) = h(i,j,1)+ww(i,k,1)*linv(j,k,1)+ww(i,k,2)*linv(j,k,2)
                  h(i,j,2) = h(i,j,2)+ww(i,k,2)*linv(j,k,1)-ww(i,k,1)*linv(j,k,2)
               end do
            end do
         end do
#endif
      end if
      deallocate(ww)
    end subroutine lhl_noncl

    subroutine lx_noncl()
#ifdef HIUX
! *** 'poption''s have been inserted by Dr. Kino (National Institute  ***
! *** for Materials Science, Japan).  12 July 2005                    ***
#endif
      integer :: ib, ib2, i, j
      if(kimg == 1) then
         do ib = ista_e, iend_e, istep_e
            ib2 = map_z(ib)
            do i = 1, iba2(ik) *ndim_spinor
               ldag(i,1) = zaj_mat(i,ib2,1)
            end do
            zaj_mat(:,ib2,1) = 0.d0
            do i = 1, iba2(ik) *ndim_spinor
               do j = 1, iba2(ik) *ndim_spinor
                  zaj_mat(i,ib2,1) = zaj_mat(i,ib2,1) + linv(j,i,1)*ldag(j,1)
               end do
            end do
         end do
      else if(kimg == 2) then
         do ib = ista_e, iend_e, istep_e
            ib2 = map_z(ib)
            if(iba2(ik) > nmatsz)  call  phase_error_with_msg(nfout, ' iba2(ik) > nmatsz',__LINE__,__FILE__)
            do i = 1, iba2(ik) *ndim_spinor
               ldag(i,1) = zaj_mat(i,ib2,1)
               ldag(i,2) = zaj_mat(i,ib2,2)
            end do
            zaj_mat(:,ib2,1:2) = 0.d0
            do i = 1, iba2(ik) *ndim_spinor
               do j = i, iba2(ik)*ndim_spinor
                  zaj_mat(i,ib2,1) = zaj_mat(i,ib2,1) &
                       &        + linv(j,i,1)*ldag(j,1) + linv(j,i,2)*ldag(j,2)
                  zaj_mat(i,ib2,2) = zaj_mat(i,ib2,2) &
                       &        + linv(j,i,1)*ldag(j,2) - linv(j,i,2)*ldag(j,1)
               end do
            end do
         end do
      end if
    end subroutine lx_noncl

    subroutine phase_mult_noncl()
      integer :: ib, ib2, ig
      real(kind=DP) :: wfr, wfi, sqrwf, pcos,psin
#ifndef _PHASE_MULT_0_
      integer :: ig1, ig2, ig_max
      complex(kind=CMPLDP) :: exp2theta, exptheta
      real(kind=DP) :: sqrwf0, wfr2, wfi2, sqrwfi, sqrwf1, sqrwf2,f &
           &          ,phase2r, phase2i, cos2theta, pcos0,psin0, norm
      real(kind=DP), parameter :: abswf_min = 1.d-16
#endif

      integer :: is, igshift

!!$      do ig = 1, nmatsz
      if(kimg == 2) then
         do ib = ista_e, iend_e, istep_e
            ib2 = map_z(ib)
#ifdef _PHASE_MULT_0_

            Do is=1, ndim_spinor
              igshift = ( is-1 )*iba2(ik)
              wfr = zaj_mat( igshift+1,ib2,1 ); wfi = zaj_mat( igshift+1,ib2,2 )

              if (abs( wfi*wfi ) > 1.d-30) then
                 sqrwf = wfr1**2 + wfi**2
                 f = dsqrt(sqrwf)
                 pcos = -wfr/f; psin = wfi/f
                 if(iprimatdiagon >= 2) then
                    write(nfout,'(4x," pcos, psin = ",2e14.6)') pcos, psin
                 end if
                 do ig = 1, iba2(ik)
                    wfr = zaj_mat( ig+igshift,ib2,1 )
	            wfi = zaj_mat( ig+igshift,ib2,2 )
                    zaj_mat( ig+igshift,ib2,1 ) = pcos*wfr - psin*wfi
                    zaj_mat( ig+igshift,ib2,2 ) = pcos*wfi + psin*wfr
                 end do

              end if
            end do
#else
            Do is=1, ndim_spinor
              igshift = ( is-1 )*iba2(ik)
	      wfi = zaj_mat( igshift+1,ib2,2 )
              sqrwfi = wfi*wfi

              if (sqrwfi > 1.d-35) then
	         wfr = zaj_mat( igshift+1,ib2,1 );
                 sqrwf0 = wfr**2 + sqrwfi

                 if (sqrwfi > abswf_min) then
                    ig_max = 1
                 else
                    ig_max = 1
                    g_search: do ig = 2, kg2_gamma
                       ig1 = nbase_gamma(ig,1)
                       wfr = zaj_mat( ig1+igshift,ib2,1 );
                       wfi = zaj_mat( ig1+igshift,ib2,2 )

                       sqrwfi = wfi*wfi
                       sqrwf = wfr**2 + sqrwfi

                       if(sqrwfi > abswf_min) then
                          ig_max = ig
                          exit g_search
                       else
                          if(sqrwf > sqrwf0) then
                            ig_max = ig
                            sqrwf0 = sqrwf
                          end if
                       end if
                    end do g_search
                 end if

                 if (ig_max == 1) then
                    wfr = zaj_mat( igshift+1,ib2,1 ); wfi = zaj_mat( igshift+1,ib2,2 )
                    sqrwf0 = wfr**2 + wfi**2
                    f = dsqrt(sqrwf0)
                    pcos = -wfr/f; psin = wfi/f
                    if (iprimatdiagon >= 2 ) then
                        write(nfout,'(4x," pcos, psin = ",2e14.6, " ig_max = ",i5 )') &
	&                        pcos, psin,ig_max
                        write(nfout,'(4x," sqrwf = ",e14.6)') sqrwf0
                    end if
                 else if(ig_max >= 2) then
                    wfr = zaj_mat( igshift+1,ib2,1 ); wfi = zaj_mat( igshift+1,ib2,2 )
                    sqrwf0 = wfr**2 + wfi**2
                    f = dsqrt(sqrwf0)
                    pcos0 = -wfr/f; psin0 = wfi/f
                    if (iprimatdiagon >= 2) then
                       write(nfout,'(4x," pcos, psin = ",2e14.6, " ig =  0")') &
	&                       pcos0, psin0
                    end if

                    ig1 = nbase_gamma(ig_max,1);  ig2 = nbase_gamma(ig_max,2)

                    wfr  = zaj_mat( ig1+igshift,ib2,1 )
	            wfi  = zaj_mat( ig1+igshift,ib2,2 )
                    wfr2 = zaj_mat( ig2+igshift,ib2,1 )
	            wfi2 = zaj_mat( ig2+igshift,ib2,2 )

                    sqrwf1 = wfr**2 + wfi**2
                    sqrwf2 = wfr2**2 + wfi2**2
                    sqrwf = sqrt(sqrwf1*sqrwf2)

                    phase2r =  (wfr*wfr2 - wfi*wfi2)/sqrwf
                    phase2i = -(wfr*wfi2 + wfr2*wfi)/sqrwf
                    norm = sqrt(phase2r*phase2r + phase2i*phase2i)
                    phase2r = phase2r/norm;  phase2i = phase2i/norm
                    exp2theta = cmplx(phase2r,phase2i)
                    exptheta = sqrt(exp2theta)

                    pcos = real(exptheta);      psin = imag(exptheta)

                    if (iprimatdiagon >= 2) then
                       write(nfout,'(4x," pcos, psin = ",2e14.6, " ig_max = ",i5 )') &
	&                            pcos, psin,ig_max
                       write(nfout,'(4x," sqrwf1, sqrwf2, sqrwf = ",3e14.6)') &
	&                            sqrwf1, sqrwf2, sqrwf
                    end if

                    cos2theta = (wfr*wfr2 - wfi*wfi2)/sqrwf
                    cos2theta = cos2theta/norm
                    if (cos2theta > 1.0 ) cos2theta = 1.d0
                    if (cos2theta < -1.0 ) then
                       pcos = 0.d0;  psin = 1.d0
                    else
                       pcos = sqrt((1+cos2theta)/2.0); psin = sqrt((1-cos2theta)/2.0)
                    end if
                    if (pcos0 < 0.0 ) pcos = - pcos
                    if (psin0 < 0.0 ) psin = - psin
                    if (iprimatdiagon >= 2 ) then
                       write(nfout,'(4x," pcos, psin = ",2e14.6, " ig_max = ",i5 )') &
	&                                 pcos, psin,ig_max
                    end if
                 end if

                 do ig = 1, iba2(ik)
                    wfr = zaj_mat( ig+igshift,ib2,1 )
                    wfi = zaj_mat( ig+igshift,ib2,2 )
                    zaj_mat( ig+igshift,ib2,1 ) = pcos*wfr - psin*wfi
                    zaj_mat( ig+igshift,ib2,2 ) = pcos*wfi + psin*wfr
                 end do
                 zaj_mat( igshift+1,ib2,2 ) = 0.d0

              end if
            end do
#endif
            if ( iprimatdiagon >=2 ) then
               write(nfout,'(i4," Re ",5e14.6)') ib, (zaj_mat(ig,map_z(ib),1),ig=1,5)
               write(nfout,'(8x,5e14.6)') (zaj_mat(ig,map_z(ib),1),ig=6,40)
               write(nfout,'(i4," Im ",5e14.6)') ib, (zaj_mat(ig,map_z(ib),2),ig=1,5)
               write(nfout,'(8x,5e14.6)') (zaj_mat(ig,map_z(ib),2),ig=6,40)
            end if
         end do

         if (k_symmetry(ik) == GAMMA_base_symmetrization) then
            do ib = ista_e, iend_e, istep_e
               ib2 = map_z(ib)
               Do is=1, ndim_spinor
!!!!!!!                  igshift = ( is-1 ) *kg2_gamma
                  igshift = ( is-1 ) *iba2(ik)           ! ?????? kt : uncertain !!!

                  do ig = 2, kg2_gamma
                    ig1 = nbase_gamma(ig,1)
                    ig2 = nbase_gamma(ig,2)
                    wfr = zaj_mat( ig1+igshift,ib2,1 )
	            wfi = zaj_mat( ig1+igshift,ib2,2 )
                    zaj_mat( ig2+igshift,ib2,1 ) = wfr
                    zaj_mat( ig2+igshift,ib2,2 ) = -wfi
                  end do
               end do
            end do
         end if
      end if
      if(iprimatdiagon >= 2) write(nfout,'(" out of <<phase_mult_noncl>>")')
    end subroutine phase_mult_noncl

    subroutine cp_zaj_mat_to_zaj_l_noncl()
      integer :: ib,ig, i, is
      integer :: igshift

      if(k_symmetry(ik) == GAMMA) then
         if(kimg == 1) then
	    Do is=1, ndim_spinor
!!!!!!!	      igshift = kg2_gamma *(is-1)
	      igshift = iba2(ik) *(is-1)

              zaj_l( :, :, ik+is-1, 1 ) = 0.d0
              do ib = 1, np_e
                 do i = 1, kg2_gamma
                    ig = nbase(i,ik)
                    zaj_l( i, ib, ik+is-1, 1 ) = zaj_mat( ig+igshift, ib, 1 )
                 end do
               end do
            end do
         else if(kimg == 2) then
	    Do is=1, ndim_spinor
!!!!!!!	      igshift = kg2_gamma *(is-1)

	      igshift = iba2(ik) *(is-1)

              zaj_l( : ,:, ik+is-1, 1 ) = 0.d0
              zaj_l( : ,:, ik+is-1, 2 ) = 0.d0
              do ib = 1, np_e
                 do i = 1, kg2_gamma
                    ig = nbase(i,ik)
                    zaj_l( i, ib, ik+is-1, 1 ) = zaj_mat( ig+igshift, ib, 1 )
                    zaj_l( i, ib, ik+is-1, 2 ) = zaj_mat( ig+igshift, ib, 2 )
                 end do
              end do
           end do
         end if
      else
         if(kimg == 1) then
	    Do is=1, ndim_spinor
	      igshift = iba2(ik) *(is-1)
              zaj_l( :, :, ik+is-1, 1 ) = 0.d0

              do ib = 1, np_e
                 do i = 1, iba2(ik)
                    ig = nbmat2(i,ik)
                    zaj_l( ig, ib, ik+is-1, 1 ) = zaj_mat( i+igshift, ib, 1 )
                 end do
              end do
            end do
         else if(kimg == 2) then
	    Do is=1, ndim_spinor
	      igshift = iba2(ik) *(is-1)
              zaj_l( :, :, ik+is-1, 1 ) = 0.d0
              zaj_l( :, :, ik+is-1, 2 ) = 0.d0
              do ib = 1, np_e
                 do i = 1, iba2(ik)
                   ig = nbmat2(i,ik)
                   zaj_l( ig, ib, ik+is-1, 1 ) = zaj_mat( i+igshift, ib, 1 )
                   zaj_l( ig, ib, ik+is-1, 2 ) = zaj_mat( i+igshift, ib, 2 )
                 end do
               end do
            end do
         end if
      end if
#ifdef SAVE_FFT_TIMES
      if(sw_save_fft == ON) then
         do is=1,ndim_spinor
            do ib=1,np_e
               status_saved_phifftr(ib,ik+is-1) = OLD
            end do
         end do
      end if
#endif
    end subroutine cp_zaj_mat_to_zaj_l_noncl

  end subroutine m_ESmat_solve_Hx_eq_eSx_noncl
!=============================================================================== 11.0

!===============================================================================
  subroutine check_LAPACKinputs(str,nfout,n,lda,vl,vu,il,iu,lwork,abstol,RMat,CMat)
    character(len=*),intent(in) :: str
    integer, intent(in) ::         nfout,n,lda,il,iu,lwork
    real(DP), intent(in) ::        vl,vu,abstol
    real(DP),        optional, intent(in), dimension(lda,n) :: RMat
    complex(CMPLDP), optional, intent(in), dimension(lda,n) :: CMat
    integer :: i
    character(len=32) :: strp
    strp = "<<"//trim(str)//">>"
    write(nfout,'(" --- n   = ", i8,1x,a32)') n,strp
    write(nfout,'(" --- lda = ",i8)') lda
    write(nfout,'(" --- vl  = ",d20.8, " vu = ",d20.8)') vl, vu
    write(nfout,'(" --- il  = ",i8, " iu = ", i8)') il, iu
    write(nfout,'(" --- lwork = ",i8)') lwork
    write(nfout,'(" --- abstol = ", d20.8)') abstol
    if(present(RMat))  write(nfout,'(" --- amat(diagonal) = ",8f8.4)') (RMat(i,i),i=1,n)
    if(present(CMat)) then
       write(nfout,'(" --- Real(cmat(diagonal)) = ",8f8.4)') (real(CMat(i,i)),i=1,n)
       write(nfout,'(" --- Imag(cmat(diagonal)) = ",8f8.4)') (aimag(CMat(i,i)),i=1,n)
    end if
  end subroutine check_LAPACKinputs

  subroutine check_LAPACKoutputs(str,nfout,ik,n,ne,lda,evec,Rmat,Cmat)
    character(len=*),intent(in) ::       str
    integer, intent(in) ::               nfout,ik,n,ne,lda
    real(DP),intent(in), dimension(n) :: evec
    real(DP),        optional, intent(in), dimension(lda,n) :: RMat
    complex(CMPLDP), optional, intent(in), dimension(lda,n) :: CMat
    character(len=32) :: strp

    integer :: ib, ri, i
    character(len=4) :: a

    strp = "<<"//trim(str)//">>"
    write(nfout,'(" --- eigen values ik = ",i8,1x,a32," ---")')ik,strp
    write(nfout,'(8f10.6)') (evec(i),i=1,ne)

    if(Present(Rmat)) then
       do ib = ista_e, iend_e, istep_e               ! MPI
          write(nfout,'(" evec(",i4,",",i3,")= ",e14.6," ",4x,5e14.6)') &
               & ib,ik,evec(ib),(Rmat(i,ib),i=1,5)
       end do
    end if
    if(Present(Cmat)) then
       a = "     "
       do ib = ista_e, iend_e, istep_e               ! MPI
          do ri = 1, kimg
             if(ri == 1 .and. kimg == 2) a = "(Re) "
             if(ri == 2) a = "(Im) "
             if(ri == 1) write(nfout,'(" evec(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
                  & ib,ik,evec(ib),a,(real(Cmat(i,ib)),i=1,5)
             if(ri == 2) write(nfout,'(32x,a4,5e14.6)') a,(aimag(Cmat(i,ib)),i=1,5)
          end do
       end do
    end if

  end subroutine check_LAPACKoutputs

  subroutine check_LAPACKerror(ne_found,ne,info)
    integer, intent(in) :: ne_found,ne,info
    if (ne_found /= ne) then
       write(*,*) '### ERROR ### ne_found != ne'
       write(*,*) '   ne_found ...',ne_found
       write(*,*) '   ne       ...',ne
       call phase_error_with_msg(6, ' ne_found is not ne, stopped at <<check_LAPACKerror>>',__LINE__,__FILE__)
    end if
    if (info /= 0) then
       write(*,*) '### ERROR ### info /= 0'
       write(*,*) '   info ...',info
       call phase_error_with_msg(6, ' info is not zero, stopped at <<check_LAPACKerror>>',__LINE__,__FILE__)
    end if
  end subroutine check_LAPACKerror

  subroutine wd_CalculatedEigenvalues(nfout,ik,nmatsz,neg,ekt,str)
    integer, intent(in) :: nfout,ik,nmatsz,neg
    real(kind=DP),intent(in),dimension(nmatsz) :: ekt
    character(len=*),intent(in) :: str

    integer :: i, ib, ri
    character(len=5) :: ac

    write(nfout,'(" -- eigen values : ik = ",i8, 1x,a32," --")') ik,trim(str)
    write(nfout,'(8f10.6)') (ekt(i),i=1,neg)
    ac = "     "
    do ib = ista_e, iend_e, istep_e
       do ri = 1, kimg
          if(ri == 1 .and. kimg == 2) ac = "(Re) "
          if(ri == 2) ac = "(Im) "
          if(ri == 1) write(nfout,'(" eko(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
               & ib,ik,eko_l(map_z(ib),ik),ac,(zaj_mat(i,map_z(ib),ri),i=1,5)
          if(ri == 2) write(nfout,'(31x,a4,5e14.6)') ac,(zaj_mat(i,map_z(ib),ri),i=1,5)
          write(nfout,'(35x,5e14.6)') (zaj_mat(i,map_z(ib),ri),i=6,20)
       end do
    end do
  end subroutine wd_CalculatedEigenvalues

end module m_ES_WF_by_MatDiagon

!#========================================================================
!#                                                                       #
!# Software Name : UVSOR ver. 3.00                                       #
!#                                                                       #
!#      Sub Routine : Calc_Epsilon                                       #
!#                                                                       #
!#                                Written by T. Hamada 2006/4/28         #
!#                                                                       #
!#      Contact address :  IIS,The University of Tokyo RSS21 project     #
!#                                                                       #
!#"Multiscale Simulation System for Functional Analysis of Nanomaterials"#
!#                                                                       #
!#========================================================================
!
! $Id: Calc_Epsilon.f90 593 2019-06-20 03:47:31Z jkoga $
subroutine Calc_Epsilon
  use m_Epsilon_ek,    only : BZintegration_eps, calc_drude_eps, kkt_eps, optics_eps

! ========= KT_add ======== 13.0S
  use m_Control_Parameters,  only : sw_corelevel_spectrum, sw_local_approx_trans_moment
  use m_Const_Parameters, only : ON
  use m_Epsilon_ek,       only : corelevel_eps
! ========================= 13.0S

  implicit none

  if ( sw_corelevel_spectrum == ON .and. sw_local_approx_trans_moment == ON ) then
  else
     call BZintegration_eps
     call kkt_eps
  endif

  if ( sw_corelevel_spectrum == ON ) then
     call corelevel_eps
  else
     call calc_drude_eps
     call optics_eps
  endif

end subroutine Calc_Epsilon

!#========================================================================
!#                                                                       #
!# Software Name : UVSOR ver. 3.00                                       #
!#                                                                       #
!#      Sub Routine : Calc_Nonlinear_optics                              #
!#                                                                       #
!#                                Written by T. Hamada 2006/4/28         #
!#                                                                       #
!#      Contact address :  IIS,The University of Tokyo RSS21 project     #
!#                                                                       #
!#"Multiscale Simulation System for Functional Analysis of Nanomaterials"#
!#                                                                       #
!#========================================================================
!
! $Id: Nonlinear_Optics_Epsilon.f90 376 2014-06-17 07:48:31Z jkoga $
   subroutine Calc_Nonlinear_optics
     use m_Files,                 only : m_Files_open_nfnlo
     use m_Epsilon_ek,            only : nlo, calc_nlo
     if(nlo/=0) then
        call m_Files_open_nfnlo
        call calc_nlo
     end if
   end subroutine Calc_Nonlinear_optics

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a module for calculating Chi0 for the non-intearcting system.
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

module m_LinearResponse_NonInt

  use m_Kpoints,                    only : kv3_ek, kv3, vkxyz_ek, qwgt_ek, &
       &                                   k_symmetry, np0, np2
  use m_Const_Parameters,           only : DP, GAMMA, ELECTRON, DIRECT, &
       &                                   INVERSE, ON, OFF, CMPLDP, DELTA, &
       &                                   BUCS, &
       &                                   Hartree, NO, YES, &
       &                                   TETRAHEDRON, PARABOLIC

  use m_Control_Parameters,         only : ipri, nspin, kimg, af, neg, printable, &
       &                                   way_of_smearing
  use m_LinearResponse_Control,     only  : nrd_efermi, nmax_G_LR, &
       &                                    vqxyz,  &
       &                                    scissor, eta, sw_LongWaveLimit

  use m_LinearResponse_Density,     only : RhoTilde, occup_lkt_ek

  use m_Control_Parameters,         only : Num_q_Points
  use m_Electronic_Structure,       only : eko_ek
  use m_Crystal_Structure,    only :  rltv, univol
  use m_Timing,                     only : tstatc0_begin, tstatc0_end

  use m_Parallelization,          only : map_e,  map_z, myrank_e, MPI_CommGroup, &
       &                                 npes, ierr, mype

  use m_LinearResponse_Control,     only  : tddft_eqn_type, DYSON, BS

  Implicit None
  include 'mpif.h'

! ----------------------------- public -------------
  integer :: nband_LR, band_start_LR, band_end_LR
  Complex(kind=CMPLDP), allocatable :: Mat_Chi0(:,:,:)

contains

!------------------------------------------------------------------
!!
!!!            Alloc and Dealloc Chi0
!!
!-------------------------------------------------------------------
  subroutine m_LR_alloc_Mat_Chi0
    if ( tddft_eqn_type == DYSON ) then
       if ( mype == 0 ) then
          allocate( Mat_Chi0( nmax_G_LR, nmax_G_LR, nspin ) ); Mat_Chi0 = 0.0D0
       endif
    endif
    if ( tddft_eqn_type == BS ) then
       if ( mype == 0 ) then
          allocate( Mat_Chi0( 1,1,nspin ) ); Mat_Chi0 = 0.0D0
       endif
    endif
  end subroutine m_LR_alloc_Mat_Chi0

  subroutine m_LR_dealloc_Mat_Chi0
    if ( mype == 0 ) deallocate( Mat_Chi0 )
  end subroutine m_LR_dealloc_Mat_Chi0

!------------------------------------------------------------------
!!
!!!            Calc Chi0 in the case of Q > 0
!!
!-------------------------------------------------------------------
  subroutine Calc_Chi0_General( e_value )
    real(kind=DP), intent(in) :: e_value

    real(kind=DP)         :: weight
    real(kind=DP)         :: occ1, occ2
    complex(kind=CMPLDP)  :: ztmp, omega1, omega2
    integer               :: i,j, k, ispin
    integer               :: ik1, ik2, ik3
    integer               :: ib1, ib2

    integer               :: k_max, nq_max
    integer :: id_sname = -1
! ------------------------------ start ------------
    call tstatc0_begin('Calc_Chi0_General ', id_sname)
!
    nq_max = Num_q_points
    call set_value_kmax
    omega1 = cmplx( e_value, eta );  omega2 = cmplx( e_value, -eta );
! ---
    if ( mype==0 ) Mat_Chi0 = 0.0d0
! ------------------------------- main -----------
    Do i=1, nmax_G_LR
       Do j=1, nmax_G_LR

          Do ispin=1, nspin
             ztmp = 0.0d0

             Do k=1, k_max
                ik1 = ( nq_max +1 )*nspin*(k-1) + ispin
                ik2 = ik1 + nspin
                ik3 =  nspin*(k-1) + ispin

                weight = qwgt_ek(ik1) *nspin

                Do ib1=band_start_LR, band_end_LR           ! unoccpuied state
                   occ1 = Occup_lkt_ek( ib1, ik1 );
                   if ( occ1 > DELTA ) cycle

                   Do ib2=band_start_LR, band_end_LR          ! occupied state
                      occ2 = Occup_lkt_ek( ib2, ik2 )
                      if ( occ2 < DELTA ) cycle
!
                      if ( map_e(ib2) /= myrank_e ) cycle

                      call summation_ztmp
                   End do
                End do
             End do
             call add_ztmp_to_Chi0
          End do
       End do
    End do
! -------------------------------- end ----------
    if ( mype == 0 ) then
       if ( nspin==1 ) Mat_Chi0 = Mat_Chi0 *2.0d0
    endif
    call tstatc0_end(id_sname)

  contains

    subroutine set_value_kmax
      if ( way_of_smearing == TETRAHEDRON ) then
         k_max = np2
      else
         k_max = kv3_ek / ( nspin*( nq_max + 1 ))
      endif
    end subroutine set_value_kmax

    subroutine summation_ztmp
      integer :: jb2
      Real(kind=DP) :: ebi, ebj, ediff, c1
      Complex(kind=CMPLDP) :: zd1, zd2, z1, z2, gfn

      jb2 = map_z(ib2)

      ebi = Eko_ek( ib1,ik1 ); ebj = Eko_ek( ib2,ik2 )
      ediff = ebi - ebj + scissor

      zd1 = omega1 - ediff;  zd2 = omega2 + ediff
      gfn = 1.0d0 / zd1 - 1.0d0 / zd2
!                      c1 = occ1 - occ2
      z1 = RhoTilde( i, ib1, jb2, ik3 ); z2 = RhoTilde( j, ib1, jb2, ik3 )
!
      c1 = ( 1.0D0 - occ1 ) *occ2
      ztmp = ztmp + c1 *conjg( z1 )* z2 *gfn *weight
    end subroutine summation_ztmp

    subroutine add_ztmp_to_Chi0
      Complex(kind=CMPLDP) :: zsum

      if ( npes > 1 ) then
         call mpi_allreduce( ztmp, zsum, 2, MPI_DOUBLE_PRECISION, &
              &              MPI_SUM, MPI_CommGroup, ierr )
         ztmp = zsum
      endif
      if ( mype == 0 ) Mat_Chi0( i,j,ispin ) = ztmp / univol
    end subroutine add_ztmp_to_Chi0

  end subroutine Calc_Chi0_General

!------------------------------------------------------------------
!!
!!!            Calc Chi0 in the case of LongWaveLimit
!!
!-------------------------------------------------------------------
  subroutine Calc_Chi0_LWLimit( e_value )
    real(kind=DP), intent(in) :: e_value

    real(kind=DP)         :: occ1, occ2
    real(kind=DP)         :: weight
    complex(kind=CMPLDP)  :: ztmp, omega1, omega2

    integer               :: i,j, k, ispin
    integer               :: ik1, ik2, ik3
    integer               :: ib1, ib2
    integer               :: k_max, nq_max
    integer :: id_sname = -1
! ------------------------------- start ------------
    call tstatc0_begin('Calc_Mat_Chi0_LWLimit ', id_sname)
!
    nq_max = 0
    call set_value_kmax
    omega1 = cmplx( e_value, eta );  omega2 = cmplx( e_value, -eta );
! --
    if ( mype==0 ) Mat_Chi0 = 0.0d0
! -------------------------------- main -------------
    Do i=1, nmax_G_LR
!       write(*,*) ' i = ', i
       Do j=1, nmax_G_LR

          Do ispin=1, nspin
             ztmp = 0.0d0

             Do k=1, k_max
                ik1 = ( nq_max +1 )*nspin*(k-1) + ispin
                ik2 = ik1 + nspin
                ik3 =  nspin*(k-1) + ispin
                !
                weight = qwgt_ek(ik1) *nspin

                Do ib1=band_start_LR, band_end_LR           ! unoccpuied state
                   occ1 = Occup_lkt_ek( ib1, ik1 );
                   if ( occ1 > DELTA ) cycle

                   Do ib2=band_start_LR, band_end_LR          ! occupied state
                      occ2 = Occup_lkt_ek( ib2, ik1 )
                      if ( occ2 < DELTA ) cycle

                      if ( map_e(ib2) /= myrank_e ) cycle

                      call summation_ztmp
                   End do
                End do
             End do
             call add_ztmp_to_Chi0
          End do
       End do
    End do
! --------------------------------- end -------------
    if ( mype == 0 ) then
       if ( nspin==1 ) Mat_Chi0 = Mat_Chi0 *2.0d0
    endif
    call tstatc0_end(id_sname)

  contains

    subroutine set_value_kmax
      if ( way_of_smearing == TETRAHEDRON ) then
         k_max = np2
      else
         k_max = kv3_ek / ( nspin*( nq_max + 1 ))
      endif
    end subroutine set_value_kmax

    subroutine summation_ztmp
      integer :: jb2
      Real(kind=DP) :: ebi, ebj, ediff, c1
      Complex(kind=CMPLDP) :: zd1, zd2, z1, z2, gfn

      jb2 = map_z(ib2)

      ebi = Eko_ek( ib1,ik1 ); ebj = Eko_ek( ib2,ik1 )
      ediff = ebi - ebj + scissor

      zd1 = omega1 - ediff;  zd2 = omega2 + ediff
      gfn = 1.0d0 / zd1 - 1.0d0 / zd2
!
      z1 = RhoTilde( i, ib1,jb2, ik3 );  z2 = RhoTilde( j, ib1,jb2, ik3 )
!                      c1 = occ1 - occ2
      c1 = ( 1.0D0 - occ1 ) *occ2
      ztmp = ztmp + c1 *conjg( z1 )* z2 *gfn *weight
    end subroutine summation_ztmp

    subroutine add_ztmp_to_Chi0
      Complex(kind=CMPLDP) :: zsum

      if ( npes > 1 ) then
         call mpi_allreduce( ztmp, zsum, 2, MPI_DOUBLE_PRECISION, &
              &              MPI_SUM, MPI_CommGroup, ierr )
         ztmp = zsum
      endif
      if ( mype == 0 ) Mat_Chi0( i,j,ispin ) = ztmp / univol
    end subroutine add_ztmp_to_Chi0

  end subroutine Calc_Chi0_LWLimit

!------------------------------------------------------------------
!!
!!!            Calc Total Charge for DEBUG
!!
!-------------------------------------------------------------------
  subroutine Check_Total_Charge
    real(kind=DP)         :: occ1
    complex(kind=CMPLDP)  :: ztmp, z1

    integer               :: i,j, k, ispin
    integer               :: ik1, ik2, ik3
    integer               :: ib1, jb1
    integer               :: k_max, nq_max

    integer :: id_sname = -1
! ----------------------- start ----------------
    call set_value_nqmax
    call set_value_kmax
! ------------------------------ main ----------
    Do i=1, nmax_G_LR
       ztmp = 0.0d0

       Do ispin=1, nspin
          Do k=1, k_max
             ik1 = ( nq_max +1 )*nspin*(k-1) + ispin
             ik2 = ik1 + nspin
             ik3 =  nspin*(k-1) + ispin
             !
             Do ib1=1, neg           ! occpuied state
                occ1 = Occup_lkt_ek( ib1, ik1 );
                if ( occ1 < 0.5 ) cycle

                if ( map_e(ib1) /= myrank_e ) cycle
                jb1 = map_z(ib1)

                z1 = RhoTilde( i, ib1, jb1, ik3 )
                ztmp = ztmp + occ1 * z1 *qwgt_ek(ik1)
             End do
          End do
       End do
       if ( i==1 ) call print_total_charge
    End do

  contains

    subroutine set_value_nqmax
      if ( sw_LongWaveLimit==ON ) then
         nq_max = 0
      else
         nq_max = Num_Q_Points
      endif
    end subroutine set_value_nqmax

    subroutine set_value_kmax
      if ( way_of_smearing == TETRAHEDRON ) then
         k_max = np2
      else
         k_max = kv3_ek / ( nspin*( nq_max + 1 ))
      endif
    end subroutine set_value_kmax

    subroutine print_total_charge
      Complex(kind=CMPLDP) :: zsum

      if ( npes > 1 ) then
         call mpi_allreduce( ztmp, zsum, 1, MPI_DOUBLE_PRECISION, &
              &              MPI_SUM, MPI_CommGroup, ierr )
         ztmp = zsum
      endif
      write(*,*) 'Charge i ', i, ztmp / univol, ztmp
    end subroutine print_total_charge

  end subroutine Check_Total_Charge

end module m_LinearResponse_NonInt

module m_SpinOrbit_RadInt
! $Id: m_SpinOrbit_RadInt.F90 633 2020-12-01 05:11:03Z jkoga $
  use m_Const_Parameters,    only : DP, CMPLDP, PAI4, ON, &
       &                             SphericalHarmonicsExpansion, &
       &                             BUILTIN, ByPawPot, ZeffApprox, yes, SKIP, Hartree, InvHyperFineConst
  use m_Files,               only : nfout

  use m_Control_Parameters,  only : nspin ,ndim_magmom, noncol, ndim_chgpot, &
       &                            SpinOrbit_MassCorrection, &
       &                            SpinOrbit_Mode, sw_write_soi_on_atoms

  use m_PseudoPotential,   only : ipaw, nlmt, ilmt, ltp, mtp, taup, &
       &                          lppw, tppw, wf_mnrc, radr_paw, &
       &                          iltpw, psirpw, ival, mmesh, nmesh, xh, &
       &                          lpsmax, nloc, ntau, &
       &                          pot_has_soc, iloc, &
       &                          m_PP_include_vanderbilt_pot, dion_paw

  use m_Ionic_System,          only : ityp, ntyp, natm, iwei, iatomn, &
       &                              scaling_so, magmom_local_now

  use m_PAW_XC_Potential,    only : vxc_ae_k, vxc_ps_k

  use m_PAW_ChargeDensity,    only : paw_dnr, surface_integral_method, &
       &                             m_PAWCD_set_ae_cd_sphex2, &
       &                             m_PAWCD_ae_cd_sphex2_nonclA, &
       &                             m_PAWCD_set_ps_cd_sphex2, &
       &                             m_PAWCD_ps_cd_sphex2_nonclA

  use m_SpinOrbit_Potential,         only : Mat_LS_with_real_ylm_L0, &
       &                             Mat_LS_with_real_ylm_L1, &
       &                             Mat_LS_with_real_ylm_L2, &
       &                             Mat_LS_with_real_ylm_L3, dsoc

  use m_SpinOrbit_Potential,           only :  Mat_SOC_Strength

  use m_PseudoPotential,   only : flg_paw, Mat_SOC_Strength_nonpaw, rhcorpw, rhpcrpw
  use m_Parallelization,  only : mype
  use m_Charge_Density,  only : hsr

! === KT_add === 2014/08/11
  use m_Control_Parameters, only : sw_use_ival_for_paw_ps_soc, &
       &                           sw_use_rphi_Hsoc_rphi
  use m_PseudoPotential,  only : vlocr_pw, phirpw
! ============== 2014/08/11
  use mpi


  implicit none
!  include 'mpif.h'

  integer max_sph_expansion
  parameter( max_sph_expansion = 25 )

contains

  subroutine m_SO_calc_corelevel_splitting( ia, it, num_core_wfns, qnum_l, &
       &                                    num_mesh, psir_core_wfns, &
       &                                    level_splitting )
    integer, intent(in) :: ia, it, num_mesh, num_core_wfns
    integer, intent(in) :: qnum_l( num_core_wfns )
    real(kind=DP), intent(in) :: psir_core_wfns( num_mesh, num_core_wfns )
    real(kind=DP), intent(out) :: level_splitting( num_core_wfns )
!
    integer :: i, ir, ier, nrc, nrmax
    real(kind=DP) :: csum
    real(kind=DP), allocatable :: rho_00_ae(:), vtot_rad_ae(:), dV_rad_ae(:)
    real(kind=DP), allocatable :: rho_00_ps(:), vtot_rad_ps(:), dV_rad_ps(:)
    real(kind=DP), allocatable :: wos(:)

    level_splitting = 0.0d0

    if ( .not. flg_paw ) return

! ---- init ---
    allocate( rho_00_ae( mmesh ) );   rho_00_ae = 0.0d0
    allocate( vtot_rad_ae( mmesh ) ); vtot_rad_ae = 0.0d0
    allocate( dV_rad_ae( mmesh ) )  ; dV_rad_ae = 0.0d0
    allocate( wos( mmesh ) );  wos = 0.0d0

    if ( sw_use_rphi_Hsoc_rphi == ON  ) then
       allocate( rho_00_ps( mmesh ) );   rho_00_ps = 0.0d0
       allocate( vtot_rad_ps( mmesh ) ); vtot_rad_ps = 0.0d0
       allocate( dV_rad_ps( mmesh ) )  ; dV_rad_ps = 0.0d0
    endif

! -----------
    call calc_radial_charge_Y00( ia, it, nrc, rho_00_ae, 1 )      ! AE
    call calc_vh( nmesh(it), radr_paw(:,it), rho_00_ae, vtot_rad_ae )
    call calc_total_potential_Y00( ia, it, nrc, vtot_rad_ae, 1 )     ! AE
    call calc_central_potential( it, nrc, vtot_rad_ae, dV_rad_ae )

    if ( sw_use_rphi_Hsoc_rphi == ON ) then
       call calc_radial_charge_Y00( ia, it, nrc, rho_00_ps, 2 )      ! PS
       call calc_vh( nmesh(it), radr_paw(:,it), rho_00_ps, vtot_rad_ps )
       call calc_total_potential_Y00( ia, it, nrc, vtot_rad_ps, 2 )     ! PS
       call calc_central_potential( it, nrc, vtot_rad_ps, dV_rad_ps )
    endif

    call set_weight_exp( ier, 1, nrc, radr_paw(:,it), wos )

#if 0
    nrmax = nmesh(it)
#else
    nrmax = nrc
#endif

    Do i=1, num_core_wfns
       if ( qnum_l(i) == 0 ) cycle

       csum = 0.0d0
       if ( sw_use_rphi_Hsoc_rphi == ON ) then
          Do ir=1, nrmax
             csum = csum + wos(ir) *( dV_rad_ae(ir) -dV_rad_ps(ir) ) &
                  &                *psir_core_wfns(ir,i)**2
          End do
       else
          Do ir=1, nrmax
             csum = csum + wos(ir) *dV_rad_ae(ir) *psir_core_wfns(ir,i)**2
          End do
       endif
       level_splitting(i) = csum *( 2.0d0*qnum_l(i) +1.0d0 ) /2.0d0
    End do

! --- finalize ---
    deallocate( rho_00_ae ); deallocate( vtot_rad_ae );  deallocate( dV_rad_ae )
    if ( sw_use_rphi_Hsoc_rphi == ON ) then
       deallocate( rho_00_ps ); deallocate( vtot_rad_ps );  deallocate( dV_rad_ps )
    endif
    deallocate( wos )
! -----------

  end subroutine m_SO_calc_corelevel_splitting

  subroutine m_SO_calc_contrib_corelevels( ia, it, num_core_wfns, &
       &                                   orb_index, qnum_l_to_probe, &
       &                                   num_mesh, psir_core_wfns, &
       &                                   e_level, e_so_splitting )
    integer, intent(in) :: ia, it, num_mesh, num_core_wfns
    integer, intent(in) :: orb_index, qnum_l_to_probe
    real(kind=DP), intent(in) :: psir_core_wfns( num_mesh, num_core_wfns )
    real(kind=DP), intent(out) :: e_level, e_so_splitting
!
    integer :: i, ir, ier, nrc, nrmax, ll
    real(kind=DP) :: e_kin, e_pot_ae, e_pot_ps, e_soc, c1, c2
    real(kind=DP), allocatable :: rho_00_ae(:), vtot_rad_ae(:), dV_rad_ae(:)
    real(kind=DP), allocatable :: rho_00_ps(:), vtot_rad_ps(:), dV_rad_ps(:)
    real(kind=DP), allocatable :: vh_core(:)
    real(kind=DP), allocatable :: dpsir_tmp(:), wos(:)

! ---- init ---
    if ( .not. flg_paw ) return

    allocate( vh_core( mmesh ) ); vh_core = 0.0d0

    allocate( rho_00_ae( mmesh ) );   rho_00_ae = 0.0d0
    allocate( vtot_rad_ae( mmesh ) ); vtot_rad_ae = 0.0d0
    allocate( dV_rad_ae( mmesh ) )  ; dV_rad_ae = 0.0d0
    allocate( dpsir_tmp( mmesh ) );  dpsir_tmp = 0.0d0
    allocate( wos( mmesh ) );  wos = 0.0d0

    if ( sw_use_rphi_Hsoc_rphi == ON  ) then
       allocate( rho_00_ps( mmesh ) );   rho_00_ps = 0.0d0
       allocate( vtot_rad_ps( mmesh ) ); vtot_rad_ps = 0.0d0
       allocate( dV_rad_ps( mmesh ) )  ; dV_rad_ps = 0.0d0
    endif

    write(*,*) allocated( vxc_ae_k )
    write(*,*) allocated( vxc_ps_k )
!    stop

#if 0
    Do ir=1, nmesh(it)
       rho_00_ae(ir) = rhcorpw(ir,it) /radr_paw(ir,it)**2 /PAI4
    End Do
    call calc_vh( nmesh(it), radr_paw(:,it), rho_00_ae, vh_core )

    Do ir=1, nmesh(it)
       vlocr_pw(ir,it) = -dble(iatomn(it)) /radr_paw(ir,it) +vh_core(ir)
    End Do
#endif

    call calc_radial_charge_Y00( ia, it, nrc, rho_00_ae, 1 )      ! AE
    call calc_vh( nmesh(it), radr_paw(:,it), rho_00_ae, vtot_rad_ae )
    call calc_total_potential_Y00( ia, it, nrc, vtot_rad_ae, 1 )     ! AE
    call calc_central_potential( it, nrc, vtot_rad_ae, dV_rad_ae )
    
    if ( sw_use_rphi_Hsoc_rphi == ON ) then
       call calc_radial_charge_Y00( ia, it, nrc, rho_00_ps, 2 )      ! PS
       call calc_vh( nmesh(it), radr_paw(:,it), rho_00_ps, vtot_rad_ps )
       call calc_total_potential_Y00( ia, it, nrc, vtot_rad_ps, 2 )     ! PS
       call calc_central_potential( it, nrc, vtot_rad_ps, dV_rad_ps )
    endif
    
    call set_weight_exp( ier, 1, nrc, radr_paw(:,it), wos )

#if 0
    nrmax = nmesh(it)
#else
    nrmax = nrc
#endif

    i = orb_index;  ll = qnum_l_to_probe

    call calc_diff_exp( ier, 4, num_mesh, radr_paw(:,it), psir_core_wfns(:,i), &
         &              dpsir_tmp )
    
    e_kin = 0.0d0;   e_pot_ae = 0.0d0;   e_pot_ps = 0.0d0;   e_soc = 0.0d0
    Do ir=1, nrmax
       c1 = dpsir_tmp(ir)**2
       c2 = ( psir_core_wfns(ir,i)/radr_paw(ir,it) )**2
       e_kin = e_kin + wos(ir) *( c1 + c2 *ll*( ll +1 ) )
    End do
    e_kin = e_kin /2.0d0
    
    if ( sw_use_rphi_Hsoc_rphi == ON ) then
       Do ir=1, nrmax
          e_pot_ae = e_pot_ae + wos(ir) *Vtot_rad_ae(ir) *psir_core_wfns(ir,i)**2
          e_pot_ps = e_pot_ps + wos(ir) *Vtot_rad_ps(ir) *psir_core_wfns(ir,i)**2
          e_soc = e_soc + wos(ir) *( dV_rad_ae(ir) -dV_rad_ps(ir) ) &
               &                  *psir_core_wfns(ir,i)**2
       End do
    else
       Do ir=1, nrmax
          e_pot_ae = e_pot_ae + wos(ir) *Vtot_rad_ae(ir) *psir_core_wfns(ir,i)**2
          e_pot_ps = e_pot_ps + wos(ir) *Vtot_rad_ps(ir) *psir_core_wfns(ir,i)**2
          e_soc = e_soc + wos(ir) *dV_rad_ae(ir) *psir_core_wfns(ir,i)**2
       End do
    endif
    
    call add_kinetic_correction( e_kin, e_pot_ae )

    if ( sw_use_rphi_Hsoc_rphi == ON ) then
!       e_level = e_kin +e_pot_ae -e_pot_ps 
       e_level = e_pot_ae -e_pot_ps 
!       e_level = e_kin +e_pot_ae 
    else
       e_level = e_kin +e_pot_ae
    endif
    e_so_splitting = e_soc *( 2.0d0*ll +1.0d0 ) /2.0d0

! --- finalize ---
    deallocate( rho_00_ae ); deallocate( vtot_rad_ae );  deallocate( dV_rad_ae )
    if ( sw_use_rphi_Hsoc_rphi == ON ) then
       deallocate( rho_00_ps ); deallocate( vtot_rad_ps );  deallocate( dV_rad_ps )
    endif
    deallocate( dpsir_tmp );     deallocate( wos )
! -----------

  contains

    subroutine add_kinetic_correction( ene_kin, ene_pot )
      real(kind=DP), intent(inout) :: ene_kin
      real(kind=DP), intent(in) :: ene_pot

      real(kind=DP) :: HyperFineConst, fac1
      real(kind=DP) :: ene_corr, ene1, ene2

      HyperFineConst = 1.0d0 / InvHyperFineConst
      fac1 = 0.5d0 * HyperFineConst**2

      ene_corr = 0.0d0
      Do ir=1, nmesh(it)
         ene_corr = ene_corr + wos(ir) *Vtot_rad_ae(ir)**2 *psir_core_wfns(ir,i)**2
      End do

      ene1 = ene_kin +ene_pot
      ene2 = ene1**2 -2.0D0 *ene1 *ene_pot + ene_corr

      ene2 = -ene2 /2.d0 /( 511.0*1.0E3/Hartree )
      ene_kin = ene_kin +ene2

    end subroutine add_kinetic_correction

  end subroutine m_SO_calc_contrib_corelevels

  subroutine m_SO_calc_SOC_strength_pawpot

    integer :: ia, it, nrc, mesh_t, ir
    real(kind=DP), allocatable :: rho_00_ae(:), vtot_rad_ae(:), dV_rad_ae(:)
    real(kind=DP), allocatable :: rho_00_ps(:), vtot_rad_ps(:), dV_rad_ps(:)

! ---- init ---
    allocate( rho_00_ae( mmesh ) );   rho_00_ae = 0.0d0
    allocate( vtot_rad_ae( mmesh ) ); vtot_rad_ae = 0.0d0
    allocate( dV_rad_ae( mmesh ) )  ; dV_rad_ae = 0.0d0

    if ( sw_use_rphi_Hsoc_rphi == ON  ) then
       allocate( rho_00_ps( mmesh ) );   rho_00_ps = 0.0d0
       allocate( vtot_rad_ps( mmesh ) ); vtot_rad_ps = 0.0d0
       allocate( dV_rad_ps( mmesh ) )  ; dV_rad_ps = 0.0d0
    endif

! ----------
    Mat_SOC_Strength = 0.0d0

    do ia = 1, natm
       it = ityp(ia)

!       if( ipaw(it)/=1 .or. &
!              & surface_integral_method(it).ne.SphericalHarmonicsExpansion) cycle

       call calc_radial_charge_Y00( ia, it, nrc, rho_00_ae, 1 )      ! AE
       call calc_vh( nmesh(it), radr_paw(:,it), rho_00_ae, vtot_rad_ae )
       call calc_total_potential_Y00( ia, it, nrc, vtot_rad_ae, 1 )     ! AE
       call calc_central_potential( it, nrc, vtot_rad_ae, dV_rad_ae )

       if ( sw_use_rphi_Hsoc_rphi == ON ) then
          call calc_radial_charge_Y00( ia, it, nrc, rho_00_ps, 2 )      ! PS
          call calc_vh( nmesh(it), radr_paw(:,it), rho_00_ps, vtot_rad_ps )
          call calc_total_potential_Y00( ia, it, nrc, vtot_rad_ps, 2 )     ! PS
          call calc_central_potential( it, nrc, vtot_rad_ps, dV_rad_ps )
       endif

       if ( sw_use_rphi_Hsoc_rphi == ON ) then
          call integrate_central_potential_2( it, nrc, dV_rad_ae, dV_rad_ps, &
               &                              Mat_SOC_Strength(:,:,:,ia) )
       else
          call integrate_central_potential_1( it, nrc, dV_rad_ae, &
               &                              Mat_SOC_Strength(:,:,:,ia) )
       endif
    End Do

! --- finalize ---
    deallocate( rho_00_ae ); deallocate( vtot_rad_ae );  deallocate( dV_rad_ae )
    if ( sw_use_rphi_Hsoc_rphi == ON ) then
       deallocate( rho_00_ps ); deallocate( vtot_rad_ps );  deallocate( dV_rad_ps )
    endif
! -----------

  end subroutine m_SO_calc_SOC_strength_pawpot

  subroutine calc_central_potential( it, nrc, vtot_rad, dV_rad )        !  dV/dr *1/r
    integer, intent(in) :: it, nrc
    real(kind=DP), intent(in) :: vtot_rad(mmesh)
    real(kind=DP), intent(out) :: dV_rad(mmesh)
!
    real(kind=DP) :: HyperFineConst
    real(kind=DP) :: fac1, fac2
    integer :: ir, ier
!
    HyperFineConst = 1.0d0 / InvHyperFineConst
!
    dV_rad = 0.0d0
    call calc_diff_exp( ier, 4, nrc, radr_paw(:,it), vtot_rad, dV_rad )
!
    fac1 = 0.5d0 * HyperFineConst**2
!
    if ( SpinOrbit_MassCorrection == 0 ) then
       Do ir=1, nrc
          dV_rad(ir) = fac1 *dV_rad(ir) / radr_paw(ir,it)
       End do

    else if ( SpinOrbit_MassCorrection == 1 ) then
       Do ir=1, nrc
          fac2 = 1.0d0 - vtot_rad(ir) *HyperFineConst **2
          dV_rad(ir) = fac1 *dV_rad(ir) / radr_paw(ir,it) /fac2
       End do

    else if ( SpinOrbit_MassCorrection == 2 ) then
       Do ir=1, nrc
          fac2 = 1.0d0 - vtot_rad(ir) *HyperFineConst **2 /2.0d0
          dV_rad(ir) = fac1 *dV_rad(ir) / radr_paw(ir,it) /fac2
       End do
    endif
!
    if ( allocated( scaling_so ) ) then
       dV_rad(:) = dV_rad(:) *scaling_so(it)
    endif
  end subroutine calc_central_potential

  subroutine calc_total_potential_Y00( ia, it, nrc, vtot_rad, ae_or_ps )
    integer, intent(in) :: ia, it, nrc, ae_or_ps
    real(kind=DP), intent(inout) :: vtot_rad(mmesh)

    integer :: ir, ierr, itry
    real(kind=DP) :: factor, c1, c2, c3
    real(kind=DP) :: f1, f2, f3, r1, r2, r3
    real(kind=DP) :: ctmp1, ctmp2, rtmp1, rtmp2, cn
    
    factor = sqrt(PAI4)
    
    if ( ae_or_ps == 1 ) then              ! AE potential
!      Do ir=1, nrc
       Do ir=1, nmesh(it)
          if ( nspin==2 ) then
             c1 = vxc_ae_k( ir,1,1,ia ) + vxc_ae_k( ir,2,1,ia )
             c1 = c1 / 2.0d0
          else
             c1 = vxc_ae_k( ir,1,1,ia )
          endif
       
          c2 = -dble(iatomn(it)) / radr_paw(ir,it)
          c3 = ( c2 + vtot_rad(ir) ) *factor
          vtot_rad(ir) = c1 + c3
       End do

    else if ( ae_or_ps == 2 ) then          ! PS potential
       Do ir=1, nmesh(it)
          if ( nspin==2 ) then
             c1 = vxc_ps_k( ir,1,1,ia ) + vxc_ps_k( ir,2,1,ia )
             c1 = c1 / 2.0d0
          else
             c1 = vxc_ps_k( ir,1,1,ia )
          endif

          if ( sw_use_ival_for_paw_ps_soc == ON ) then
             c2 = -dble(ival(it)) / radr_paw(ir,it)
          else
             c2 = vlocr_pw(ir,it)
          endif

          c3 = ( c2 + vtot_rad(ir) ) *factor
          vtot_rad(ir) = c1 + c3
       End do
    endif

    vtot_rad = vtot_rad /factor

    return

#ifdef _POT_SMOOTHING_
    itry = 1
    Do while (.true.)
       r1 = radr_paw(nrc,  it)
       r2 = radr_paw(nrc- 5*itry,it)
       r3 = radr_paw(nrc-10*itry,it)
       f1 = vtot_rad( nrc )
       f2 = vtot_rad( nrc -5*itry )
       f3 = vtot_rad( nrc-10*itry )
!
       if ( f2/f1 > 1.0 .and. f3/f1 > 1.0 ) exit
       itry = itry + 1

       write(*,*) 'itry = ', itry
    End Do

    ctmp1 = log( -log( f1/f2)  ); ctmp2 = log( -log( f1/f3 ) )
    rtmp1 = log( r1-r2 ); rtmp2 = log( r1-r3 )

    cn = ( ctmp1 -ctmp2 ) / ( rtmp1 -rtmp2 )
    c1 = -log( f1/f2 ) /(r1-r2)**cn

    write(*,*) 'nrc = ', nrc
    write(*,*) 'ctmp1 ctmp2 = ', ctmp1, ctmp2
    write(*,*) 'rtmp1 rtmp2 = ', rtmp1, rtmp2
    
    write(*,*) 'c1, cn = ', c1, cn
    
    if ( c1 < 0.0 ) c1 = -c1
!
    Do ir=nrc+1, nmesh(it)
       c2 = radr_paw(ir,it) -radr_paw(nrc,it)
       vtot_rad(ir) = vtot_rad(nrc) *exp( -c1*c2**cn )
    End do
#endif

  end subroutine calc_total_potential_Y00
  

  subroutine calc_radial_charge_Y00( ia, it, nrc, rho_00, ae_or_ps )
    integer, intent(in) :: ia, it, ae_or_ps
    integer, intent(out) :: nrc
    real(kind=DP), intent(out) :: rho_00(mmesh)
    
    integer :: ier, ir, itry, nrmax
    integer :: nrc0, dnr, zz, nrc_tmp
    
    integer :: msphmx, msph, msphmx_chg
    integer :: num_isph_chg, isph_chg(max_sph_expansion)
    integer        :: id_sname = -1
!
    real(kind=DP) :: factor
    real(kind=DP) :: c1, c2, f1, f2, f3, r1, r2, r3
    real(kind=DP) :: ctmp1, ctmp2, rtmp1, rtmp2, cn

    real(kind=DP), allocatable :: dummy1(:,:)
    real(kind=DP), allocatable :: dummy2(:,:,:)
    real(kind=DP), allocatable :: rho_work(:,:,:)
    real(kind=DP), allocatable :: wos(:)
    
    allocate( wos(mmesh) ); wos = 0.0d0
   
    factor = sqrt(PAI4)

    dnr = paw_dnr(it)
!      dnr = 1

    rho_00 = 0.0d0

    if (dnr.gt.1) then
       nrc0 = wf_mnrc(it)
       nrc = 1 +int((nrc0-1)/dnr)*dnr
       zz = dble(nrc0-nrc)/dble(dnr)
       nrc = nrc +2*dnr                                                 ! 3rd
       call set_weight_exp3(ier,1,nrc,dnr,radr_paw(:,it),zz,wos)     !  3rd
    else
       nrc=wf_mnrc(it)
       call set_weight_exp(ier,1,nrc,radr_paw(:,it),wos)
    end if
    
    do ir=1,nrc,dnr
       wos(ir) = wos(ir)*radr_paw(ir,it)**2
    end do
    wos = wos*iwei(ia)
    
    msphmx_chg = 0
    msph = max_sph_expansion
    
    if ( noncol ) then
       allocate( dummy1(3,msph) );  allocate( dummy2(nrc,ndim_magmom,msph) )
       allocate( rho_work(mmesh,ndim_magmom,max_sph_expansion) )
       rho_work = 0.0d0

       if ( ae_or_ps == 1 ) then
          call m_PAWCD_ae_cd_sphex2_nonclA( ia, nspin, nrc, dnr, &
               &                            msph, rho_work(1:nrc,:,:), msphmx_chg, &
               &                            num_isph_chg, isph_chg, wos, &
               &                            1, dummy1, dummy2 )
       else if ( ae_or_ps == 2 ) then
          call m_PAWCD_ps_cd_sphex2_nonclA( ia, nspin, nrc, dnr, &
               &                            msph, rho_work(1:nrc,:,:), msphmx_chg, &
               &                            num_isph_chg, isph_chg, wos, &
               &                            1, dummy1, dummy2 )
       endif
       deallocate( dummy1 );  deallocate( dummy2 )

    else
       allocate( rho_work(mmesh,nspin,max_sph_expansion) ); rho_work = 0.0d0
#if 1
       nrmax = nrc
#else
       nrmax = nmesh(it)
#endif

       if ( ae_or_ps == 1 ) then
          call m_PAWCD_set_ae_cd_sphex2( ia, nspin, nrmax, dnr, &
               &                         msph, rho_work(1:nrmax,:,:), msphmx_chg, &
               &                         num_isph_chg, isph_chg )
       else if ( ae_or_ps == 2 ) then
          call m_PAWCD_set_ps_cd_sphex2( ia, nspin, nrmax, dnr, &
               &                         msph, rho_work(1:nrmax,:,:), msphmx_chg, &
               &                         num_isph_chg, isph_chg )
       endif

    endif
         
    if ( noncol ) then
       rho_00(:) = rho_work( :,1,1 ) + rho_work(:,2,1)
    else
       if ( nspin==1 ) then
          rho_00(:) = rho_work(:,1,1)
       else if ( nspin==2 ) then
          rho_00(:) = rho_work(:,1,1) + rho_work(:,2,1)
       endif
    end if
    
    deallocate( rho_work ); deallocate( wos )

    return

#ifdef _POT_SMOOTHING_
! -------------------------
!  in the vicinity of r=nrc, assuming rho = A*exp(-B*R**n )
!  f1 = A*exp(-B*r1**n); f2 = A*exp(-B*r2**n);
!  f1/f2 = exp(-B*(r1-r2)**n );  log(f1/f2) = -B*(r1-r2)**n;
!  f1/f3 = exp(-B*(r1-r3)**n );  log(f1/f3) = -B*(r1-r3)**n;
!
!  log( -log(f1/f2) ) = log(B) + n*log(r1-r2)
!  log( -log(f1/f3) ) = log(B) + n*log(r1-r3)
! -------------------------

    if ( m_PP_include_vanderbilt_pot(it) /= SKIP ) then
       nrc_tmp = nrc
       Do while ( .true. )
          if ( rho_00(nrc_tmp-1) < rho_00(nrc_tmp) ) then
             nrc_tmp = nrc_tmp -1
          else
             exit
          endif
       End Do

       itry = 1
       Do while (.true.)
          r1 = radr_paw(nrc_tmp,  it)
          r2 = radr_paw(nrc_tmp- 5*itry,it)
          r3 = radr_paw(nrc_tmp-10*itry,it)
          f1 = rho_00( nrc_tmp )
          f2 = rho_00( nrc_tmp-5 )
          f3 = rho_00( nrc_tmp-10 )
          !
          if ( f2/f1 > 1.0 .and. f3/f1 > 1.0 ) exit
          itry = itry + 1

!          write(*,*) 'itry = ', itry
       End Do

       ctmp1 = log( -log(f1/f2));  ctmp2 = log( -log(f1/f3) )
       rtmp1 = log( r1-r2 ); rtmp2 = log( r1-r3 )
       
       cn = ( ctmp1 -ctmp2 ) / ( rtmp1 -rtmp2 )

       c1 = -log(f1/f2) /(r1-r2)**cn

!         write(*,*) 'c1, cn = ', c1, cn

       if ( c1 < 0.0 ) c1 = -c1
       !
       Do ir=nrc_tmp+1, nmesh(it)
          c2 = radr_paw(ir,it) -radr_paw(nrc_tmp,it)
          rho_00(ir) = rho_00(nrc_tmp) *exp( -c1*c2**cn )
       End do
       
    endif
#endif

!  ---------
!      if ( SpinOrbit_MassCorrection == 2 ) then
!!!         rho_00 = rho_00 *factor
!      endif
! ---
  end subroutine calc_radial_charge_Y00

  subroutine calc_vh( nmesh, rpos, rho, vh )
    integer, intent(in) :: nmesh
    real(kind=DP), intent(in) :: rpos(mmesh), rho(mmesh)
    real(kind=DP), intent(out) :: vh(mmesh)
    
    integer :: ir, ii, i0, is, j, jr, ier
    real(kind=DP) :: sum1, sum2
    real(kind=DP), allocatable :: wt(:)
    
    allocate( wt (nmesh) ); wt = 0.0d0
    
    do ir = 1,nmesh
       sum1 = 0.d0;  sum2 = 0.d0
       if (ir == 1) then
          sum1 = 0.d0
       else if ((ir >= 2).and.(ir <= 5)) then
          do ii = 2,ir
             i0 = ii-1; is = 1
             call set_open_weight_exp(ier,i0,is,rpos,wt)
             
             do j = 1,4
                sum1 = sum1 +rpos(i0+j*is)**2 *rho(i0+j*is) *wt(i0+j*is)
             end do
          end do
       else
          call set_weight_exp(ier,1,ir,rpos,wt)
          do jr = 1,ir
             sum1 = sum1 + rpos(jr)**2*rho(jr)*wt(jr)
          end do
       end if
       sum1 = sum1 *PAI4 /rpos(ir)
       
       if (ir == nmesh) then
          sum2 = 0.d0
       else if ((ir <= nmesh-1).and.(ir >= nmesh-4)) then
          do ii = ir,nmesh-1
             i0 = ii+1; is = -1
             call set_open_weight_exp(ier,i0,is,rpos,wt)
             do j = 1,4
                sum2 = sum2 -rpos(i0+j*is)**2 *rho(i0+j*is) *wt(i0+j*is)
             end do
          end do
       else
          call set_weight_exp(ier,ir,nmesh,rpos,wt)
          do jr = ir,nmesh
             sum2 = sum2 + rpos(jr)*rho(jr)*wt(jr)
          end do
       end if
       sum2 = sum2 *PAI4
       vh(ir) = sum1 + sum2
    end do
    
    deallocate( wt )
  end subroutine calc_vh

  subroutine integrate_central_potential_1( it, nrc, dV_rad, Mat )
    integer, intent(in) :: nrc, it
    real(kind=DP), intent(in) :: dV_rad(mmesh)
    real(kind=DP), intent(out) :: Mat( nloc, ntau, ntau )
    
    integer :: ier, ir
    integer :: ilt1, ilt2
    integer :: il1, il2, it1, it2
    real(kind=DP) :: csum, tmp1
    real(kind=DP), allocatable :: wos(:)
    
    allocate( wos(mmesh) ); wos = 0.0d0
    call set_weight_exp( ier, 1, nrc, radr_paw(:,it), wos )

    Mat = 0.0d0
    
    Do ilt1=1, iltpw(it)
       il1 = lppw(ilt1,it);   it1 = tppw(ilt1,it)
       Do ilt2=1, iltpw(it)
          il2 = lppw(ilt2,it);  it2 = tppw(ilt2,it)
          if ( il1 /= il2 ) cycle
          
          csum = 0.0d0
          Do ir=1, nrc
             tmp1 = dV_rad(ir) *psirpw( ir, il1, it1, it )  &
                  &            *psirpw( ir, il2, it2, it )  &
                  &            *wos(ir)
             csum  = csum + tmp1
          End do
          Mat( il1, it1, it2 ) = csum
       End do
    End Do

    if ( sw_write_soi_on_atoms == ON ) then
       do il1 = 1, lpsmax(it)
          if ( il1 == iloc(it) ) then
             il2 = il1; it1 = 1; it2 = 1

             csum = 0.0d0
             Do ir=1, nrc
                tmp1 = dV_rad(ir) *psirpw( ir, il1, it1, it )  &
                     &            *psirpw( ir, il2, it2, it )  &
                     &            *wos(ir)
                csum  = csum + tmp1
             End do
             Mat( il1, it1, it2 ) = csum
          endif
       end do
    endif
    
    deallocate( wos )

  end subroutine integrate_central_potential_1

  subroutine integrate_central_potential_2( it, nrc, dV_rad_ae, dV_rad_ps, Mat )
    integer, intent(in) :: nrc, it
    real(kind=DP), intent(in) :: dV_rad_ae(mmesh), dV_rad_ps(mmesh)
    real(kind=DP), intent(out) :: Mat( nloc, ntau, ntau )
    
    integer :: ier, ir
    integer :: ilt1, ilt2
    integer :: il1, il2, it1, it2
    real(kind=DP) :: csum, tmp1, tmp2
    real(kind=DP), allocatable :: wos(:)
    
    allocate( wos(mmesh) ); wos = 0.0d0
    call set_weight_exp( ier, 1, nrc, radr_paw(:,it), wos )

    Mat = 0.0d0
    
    Do ilt1=1, iltpw(it)
       il1 = lppw(ilt1,it);   it1 = tppw(ilt1,it)
       Do ilt2=1, iltpw(it)
          il2 = lppw(ilt2,it);  it2 = tppw(ilt2,it)
          if ( il1 /= il2 ) cycle
          
          csum = 0.0d0
          Do ir=1, nrc
             tmp1 = dV_rad_ae(ir) *psirpw( ir, il1, it1, it )  &
                  &               *psirpw( ir, il2, it2, it )  &
                  &               *wos(ir)
             tmp2 = dV_rad_ps(ir) *phirpw( ir, il1, it1, it )  &
                  &               *phirpw( ir, il2, it2, it )  &
                  &               *wos(ir)
             csum  = csum + tmp1 -tmp2
          End do
          Mat( il1, it1, it2 ) = csum
       End do
    End Do

    if ( sw_write_soi_on_atoms == ON ) then
       do il1 = 1, lpsmax(it)
          if ( il1 == iloc(it) ) then
             il2 = il1; it1 = 1; it2 = 1

             csum = 0.0d0
             Do ir=1, nrc
                tmp1 = dV_rad_ae(ir) *psirpw( ir, il1, it1, it )  &
                     &               *psirpw( ir, il2, it2, it )  &
                     &               *wos(ir)
                tmp2 = dV_rad_ps(ir) *phirpw( ir, il1, it1, it )  &
                     &               *phirpw( ir, il2, it2, it )  &
                     &               *wos(ir)
                csum  = csum + tmp1 -tmp2
             End do
             Mat( il1, it1, it2 ) = csum
          endif
       end do
    endif

    deallocate( wos )

  end subroutine integrate_central_potential_2

  subroutine m_SO_check_mode_Builtin
    integer it
!
    Do it=1, 1
       if ( pot_has_soc(it) ) then
          
          if ( SpinOrbit_Mode /= BUILTIN ) then
             SpinOrbit_Mode = BUILTIN
             write(nfout,*) '** ------------------------- **'
             write(nfout,*) '** SpinOrbit mode is force to set to BUILTIN'
          endif
       else
          if ( SpinOrbit_Mode == BUILTIN ) then
             write(nfout,*) '** ------------------------- **'
             write(nfout,*) &
                  & '** Please use the spin-orbit splitted pseudopotential '
             write(nfout,*) &
                  & '** for atom type ', it
             call phase_error_with_msg(nfout,'pp is not spin-orbit splitted ',__LINE__,__FILE__)
          endif
       endif
    End do

    if ( SpinOrbit_Mode == BUILTIN ) then
       Do it=2, ntyp
          if ( .not. pot_has_soc(it) ) then
             write(nfout,*) '** ------------------------- **'
             write(nfout,*) &
                  & '** Please use the spin-orbit splitted pseudopotential '
             write(nfout,*) &
                  & '** for atom type ', it
             call phase_error_with_msg(nfout,'pp is not spin-orbit splitted ',__LINE__,__FILE__)
          endif
       End do
    end if
!
  end subroutine m_SO_check_mode_Builtin

  subroutine m_SO_check_mode_Pawpot
    integer it
!
    if ( SpinOrbit_Mode == BUILTIN ) return
    if ( SpinOrbit_Mode == ByPawPot ) then
       Do it=1, ntyp
          if ( ipaw(it) /= yes ) then
             write(nfout,*) '** ------------------------- **'
             write(nfout,*) &
                  & '** Please use the paw pseudopotential for atom type ', it
             write(nfout,*) '*** and confirm that "paw = off" is commeted out in the accuracy tag '
             call phase_error_with_msg(nfout,'non-paw potenttial unsupported ',__LINE__,__FILE__)
          endif
       End Do
    endif
!
  end subroutine m_SO_check_mode_Pawpot

  subroutine m_SO_check_mode_Zeff
    integer it
!
    if ( SpinOrbit_Mode == BUILTIN ) return
    if ( SpinOrbit_Mode == ByPawPot ) return
    if ( SpinOrbit_Mode == ZeffApprox ) then

    endif
!
  end subroutine m_SO_check_mode_Zeff

  subroutine m_SO_calc_SOC_strength_zeff
    integer :: ia, it, nrc
    real(kind=DP), allocatable :: vtot_rad(:), dV_rad(:)

    Mat_SOC_Strength = 0.0d0

    if ( flg_paw ) then
       allocate( vtot_rad( mmesh ) ); vtot_rad = 0.0d0
       allocate( dV_rad( mmesh ) )  ; dV_rad = 0.0d0

       do ia = 1, natm
          it = ityp(ia)
          nrc = wf_mnrc(it)
          call calc_central_pot_zeff( it, nrc, dV_rad )
          call integrate_central_potential_1( it, nrc, dV_rad, &
               &                              Mat_SOC_Strength(:,:,:,ia) )
       End Do
       deallocate( vtot_rad ); deallocate( dV_rad )

    else
       Do ia=1, natm
          it = ityp(ia)
          Mat_SOC_Strength(:,:,:,ia) = Mat_SOC_Strength_nonpaw(:,:,:,it)  &
               &                       * scaling_so(it)
       End do
    endif 

  contains

    subroutine calc_central_pot_zeff( it, nrc, dV_rad )        !  dV/dr *1/r
      integer, intent(in) :: it, nrc
      real(kind=DP), intent(out) :: dV_rad(mmesh)
!
      real(kind=DP) :: HyperFineConst
      real(kind=DP) :: fac1, fac2
      integer :: ir, ier
!
      HyperFineConst = 1.0d0 / InvHyperFineConst
!
      dV_rad = 0.0d0
      fac1 = 0.5d0 * HyperFineConst**2

      if ( SpinOrbit_MassCorrection == 0 ) then
         Do ir=1, nrc
            dV_rad(ir) = fac1 *dble(iatomn(it)) / radr_paw(ir,it)**3
         End do

      else if ( SpinOrbit_MassCorrection == 1 ) then
         Do ir=1, nrc
            fac2 = 1.0d0 + HyperFineConst**2 &
                 &         *dble(iatomn(it))/ radr_paw(ir,it) 
            dV_rad(ir) = fac1 *dble(iatomn(it)) / radr_paw(ir,it)**3 /fac2
         End do

      else if ( SpinOrbit_MassCorrection == 2 ) then
         Do ir=1, nrc
            fac2 = 1.0d0 + HyperFineConst**2 /2.0d0 &
                 &         *dble(iatomn(it))/ radr_paw(ir,it) 
            dV_rad(ir) = fac1 *dble(iatomn(it)) / radr_paw(ir,it)**3 /fac2
         End do

      end if
!
      dV_rad(:) = dV_rad(:) * scaling_so(it)
!
    end subroutine calc_central_pot_zeff

  end subroutine m_SO_calc_SOC_strength_zeff

#ifdef EVAL_SOC_PREVIOUS
  subroutine set_size_mesht( it, nrc, rho, mesh_t )
    integer, intent(in) :: it, nrc
    integer, intent(out) :: mesh_t
    real(kind=DP), intent(in) :: rho(mmesh)
    
    integer     :: i
    real(kind=DP), parameter :: CRDAMP = 1.d0
    real(kind=DP), parameter :: CRDIST = 10.d0
    
    mesh_t = nrc
!      return

    do i = 10, nmesh(it)-1
       if ( rho(i) - rho(i+1) > CRDAMP .and. radr_paw(i,it) < CRDIST) then
          mesh_t = i
!            if(iprippex>=1) write(nfout,'(" LMTO pot. r_ws=",i5,f12.6)') i, radr(i)

          write(*,*) 'mesht nrc = ', mesh_t, nrc, nmesh(it)
          
          return
       end if
    enddo
    mesh_t = nmesh(it)

  end subroutine set_size_mesht

  subroutine set_rho_for_poisson_eq( it, nrc, rho ) 
                                     ! 4 *pi *r**2 *rho_lm( r,l=0,ispin=1 )
    integer, intent(in) :: it, nrc
    real(kind=DP), intent(inout) :: rho(mmesh)

    integer :: ir

!      Do ir=1, nrc
    Do ir=1, nmesh(it)
       rho(ir) = PAI4 *radr_paw(ir,it)**2 * rho(ir)
    End Do
    
  end subroutine set_rho_for_poisson_eq

  subroutine calc_Hartree_pot_Y00( it, nsize, mesh_t, radr, rhvr, vvv )    
    integer, intent(in) :: nsize, mesh_t, it
    real(kind=DP), intent(in) :: radr( mmesh )
    real(kind=DP), intent(in) :: rhvr( mmesh )
    real(kind=DP), intent(out) :: vvv( mmesh )
    
    real(kind=DP)       :: s2, rhs, rhs1, bm
    real(kind=DP),allocatable,dimension(:) :: da, db ! d(nsize)
    real(kind=DP), allocatable :: wkx(:), wky(:), wkz(:)
    
    integer             :: i
    
    real(kind=DP) ::   hh
    
    hh = 1.0 / xh(it)
    allocate(wkx(mmesh)); wkx = 0.d0
    allocate(wky(mmesh)); wky = 0.d0
    allocate(wkz(mmesh)); wkz = 0.d0
    
    !+++++++++++++++++++++++++++++++
    allocate(da(nsize)); da = 0.d0
    allocate(db(nsize)); db = 0.d0
    !+++++++++++++++++++++++++++++++
    s2 = dlog(rhvr(2)/rhvr(1))/ hh
    rhs = rhvr(1)
    wkx(1)  = rhs*radr(1)/(s2+1)
    wky(1)  = rhs/s2
    db(1)   = hh*rhs*3.d0
    da(1)   = db(1)*radr(1)
    rhs1    = rhs
    do i = 2,3
       rhs     = rhvr(i)
       wkx(i)  = wkx(i-1) + hh *(rhs*radr(i)+rhs1*radr(i-1))*0.5d0
       wky(i)  = wky(i-1) + hh *(rhs        +rhs1          )*0.5d0
       db(i)   = hh *rhs*3.d0
       da(i)   = db(i)*radr(i)
       rhs1    = rhs
    enddo
    do i = 4,mesh_t
       rhs    = rhvr(i)
       db(4)  = hh *rhs*3.d0
       da(4)  = db(4)*radr(i)
       wkx(i)=(9*wkx(i-1)-wkx(i-3)+da(4)+2.d0*da(3)-da(2))/8.d0
       wky(i)=(9*wky(i-1)-wky(i-3)+db(4)+2.d0*db(3)-db(2))/8.d0
       da(1)  = da(2)
       db(1)  = db(2)
       da(2)  = da(3)
       db(2)  = db(3)
       da(3)  = da(4)
       db(3)  = db(4)
    enddo
    bm               = wky(mesh_t)
     !C--*--COULOMB POTENTIAL RVC
    vvv = 0.d0
    do i = 1,mesh_t
!!!         vvv(i) = wkx(i) + radr(i)*(bm-wky(i))        ! r *Vh(r)
       vvv(i) = wkx(i) + (bm-wky(i))                   ! Vh(r)
    enddo
     !+++++++++++++++++++++++++++++++
    deallocate(da); deallocate(db)
    deallocate(wkx)
    deallocate(wky)
    deallocate(wkz)
    !+++++++++++++++++++++++++++++++

  end subroutine Calc_Hartree_pot_Y00
#endif

end module m_SpinOrbit_RadInt

#define MOMENT_AS_PSEUDO_VECTOR

module m_OP_Moment
! $Id: m_OP_Moment.F90 479 2016-03-12 12:30:51Z ktagami $

! =========== Contributions ===================================
!
! Through the courtesy of contributors, the following functions are added.
!
! Company:  ASMS Co.,Ltd.
!       Calculation of Orbital Moment
!
! Note:
!       In order to work the whole functions, LIB_ASMS_INTEGRAL is required.
!
! =============================================================

  use m_Control_Parameters,  only : proj_attribute, proj_group, num_proj_elems, &
       &                            max_projs, ndim_spinor, ndim_magmom, ndim_chgpot, &
       &                            iprimagmom

  use m_Const_Parameters,     only : DP, CMPLDP, zi
  use m_Ionic_System,         only : natm, iproj_group

  use m_SpinOrbit_Potential,  only :  MatU_ylm_RC_L0,  MatU_ylm_RC_L1, &
       &                              MatU_ylm_RC_L2,  MatU_ylm_RC_L3
  use m_Orbital_Population,   only :  om, om_aimag, ommix, ommix_aimag, i2lp
  use m_Parallelization,       only : mype

  use m_ES_NonCollinear,       only :  m_ES_MagMom_To_DensMat_porb, &
       &                               m_ES_set_Pauli_Matrix
  use m_Files,                 only : nfout

! ==== KT_add === 2014/08/26
  use m_KPoints,           only : kv3, vkxyz
  use m_Const_Parameters,   only : PAI4, CARTS, ON, BOHR
  use m_Control_Parameters,  only : kimg, noncol, neg, sw_mix_charge_hardpart, &
       &                            sw_use_add_proj, sw_use_contracted_psir
  use m_PseudoPotential,    only : ltp, mtp, taup, nlmt, isph, il2p, dl2p, ilmt, &
       &                            q, q_noncl, nlmta, lmta, nmesh, mmesh, radr, wos, &
       &                            flg_paw, ia2ia_symmtry_op_inv, &
       &                            crotylm_paw, nylm_paw, iylm_paw, wf_mnrc, &
       &                            psir_val, &
       &                            nloc, ntau, lpsmax, itau, &
       &                            ilmt_add, nlmt_add, ltp_add, mtp_add, &
       &                            lmta_add, nlmta_add
  use m_PlaneWaveBasisSet,    only : ngabc, kgp, kg1, iba, nbase
  use m_Parallelization,    only : ista_kngp, iend_kngp, npes, MPI_CommGroup, ierr, &
       &                           map_k, map_e, map_z, myrank_k, myrank_e, np_e, &
       &                           ista_k, iend_k
  use m_NonLocal_Potential, only : new_radr_and_wos
  use m_Ionic_System,        only : ityp, pos, cps, iatomn, ntyp, speciesname
  use m_Crystal_Structure,   only : rltv, univol, nopr, op, altv
  use m_CS_Magnetic,     only : magmom_dir_inversion_opr_flag, determinant_op
  use m_Charge_Density,      only : hsr, hsi, hsr_add, hsi_add
  use m_CD_Mag_Moment,        only : rad_cov, rad_cov_default, product_psir_val, &
       &                             RhoMag_on_atom
  use m_ES_NonCollinear,     only : m_ES_MagMom_to_DensMat_Gspace, &
       &                            m_ES_MagMom_To_DensMat_hsr, &
       &                            m_ES_DensMat_To_MagMom_hsr
  use m_Electronic_Structure,  only : zaj_l, occup_l
! =============== 2014/08/26

  use m_Control_Parameters,   only : charge_symm_mode
  use m_Kpoints,             only : nopr_from_fbz_to_ibz, flg_opr_from_fbz_to_ibz
  use m_Const_Parameters,    only : chg_symm_level1
  use mpi

  implicit none
!  include 'mpif.h'

  complex(kind=CMPLDP) :: Mat_L_with_cmplx_ylm_L0(  0:0, 0:0, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_cmplx_ylm_L1( -1:1,-1:1, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_cmplx_ylm_L2( -2:2,-2:2, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_cmplx_ylm_L3( -3:3,-3:3, 3 )
!
  complex(kind=CMPLDP) :: Mat_L_with_real_ylm_L0( 1, 1, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_real_ylm_L1( 3, 3, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_real_ylm_L2( 5, 5, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_real_ylm_L3( 7, 7, 3 )

! ==== KT_add === 2014/08/26
  real(kind=DP), allocatable :: OrbMag_on_atom(:,:)
  real(kind=DP), allocatable :: rho_ylm1_ylm2_r(:,:,:,:), rho_ylm1_ylm2_i(:,:,:,:)
  complex(kind=CMPLDP), allocatable :: wfn_sph_decomposed(:,:,:)
! =============== 2014/08/26

contains

  subroutine m_OP_calc_orbmom_from_OCC           ! From occupation marix
    integer :: ia, it, i, ig, ie, ip, l, m1, m2
    integer :: is1, is2, istmp, size1
!
    real(kind=DP) :: orbmom(3), spinmom(3)
    complex(kind=CMPLDP) :: ztmp(3)
    complex(kind=CMPLDP) :: PauliMatrix( ndim_magmom, ndim_spinor, ndim_spinor )
!
    real(kind=DP), allocatable :: dmmat_r_magmom( :,:,: )
    real(kind=DP), allocatable :: dmmat_i_magmom( :,:,: )
    complex(kind=CMPLDP), allocatable :: dmmat_ssrep( :,:,: )

    logical :: FirstFlag = .true.
    logical :: print_header

! -----------
    if ( iprimagmom < 3 ) return

    if ( FirstFlag ) then
       call m_OP_calc_MatL_orb_s_to_f
       FirstFlag = .false.
    endif
    print_header = .true.

    call m_ES_set_Pauli_Matrix( PauliMatrix )

    do ia=1, natm
       ig = iproj_group(ia)
       if ( ig <1 ) cycle

       do i=1,num_proj_elems(ig)
          ip = proj_group(i,ig)
          it = proj_attribute(ip)%ityp
          ie = proj_attribute(ip)%ielem
          l  = proj_attribute(ip)%l

          size1 = i2lp(ip)
          allocate( dmmat_r_magmom(size1,size1,ndim_magmom) ); dmmat_r_magmom = 0.0d0
          allocate( dmmat_i_magmom(size1,size1,ndim_magmom) ); dmmat_i_magmom = 0.0d0
          allocate( dmmat_ssrep(size1,size1,ndim_chgpot) );  dmmat_ssrep = 0.0d0

!          dmmat_r_magmom(:,:,:) = om(:,:,ie,ia,:)
!          dmmat_i_magmom(:,:,:) = om_aimag(:,:,ie,ia,:)
          dmmat_r_magmom(:,:,:) = ommix(:,:,ie,ia,:)
          dmmat_i_magmom(:,:,:) = ommix_aimag(:,:,ie,ia,:)

          call m_ES_MagMom_To_DensMat_porb( size1**2, dmmat_r_magmom, dmmat_i_magmom, &
               &                            dmmat_ssrep )

          orbmom = 0.0d0; spinmom = 0.0d0

          Do is1=1, ndim_spinor
             Do is2=1, ndim_spinor
                if ( is1 /= is2 ) cycle

                istmp = ( is1 -1 )*ndim_spinor + is2

                Do m1=1, size1
                   Do m2=1, size1
                      ztmp = 0.0d0
                      if ( l == 1 ) then
                         ztmp(:) = Mat_L_with_real_ylm_L1( m2, m1, : )
                      else if ( l == 2 ) then
                         ztmp(:) = Mat_L_with_real_ylm_L2( m2, m1, : )
                      else if ( l == 3 ) then
                         ztmp(:) = Mat_L_with_real_ylm_L3( m2, m1, : )
                      endif

                      orbmom(1) = orbmom(1) +dmmat_ssrep(m1,m2,istmp) *ztmp(1)
                      orbmom(2) = orbmom(2) +dmmat_ssrep(m1,m2,istmp) *ztmp(2)
                      orbmom(3) = orbmom(3) +dmmat_ssrep(m1,m2,istmp) *ztmp(3)
                   End do
                End do
             End do
          End do

          Do is1=1, ndim_spinor
             Do is2=1, ndim_spinor
                istmp = ( is1 -1 )*ndim_spinor + is2
                Do m1=1, size1
                   Do m2=1, size1
                      if ( m1 /= m2 ) cycle

                      spinmom(1) = spinmom(1) +dmmat_ssrep(m1,m2,istmp) &
                           &                  *PauliMatrix(2,is2,is1)
                      spinmom(2) = spinmom(2) +dmmat_ssrep(m1,m2,istmp) &
                           &                  *PauliMatrix(3,is2,is1)
                      spinmom(3) = spinmom(3) +dmmat_ssrep(m1,m2,istmp) &
                           &                  *PauliMatrix(4,is2,is1)
                   End do
                End do
             End do
          End do
!
          deallocate( dmmat_r_magmom ); deallocate( dmmat_i_magmom )
          deallocate( dmmat_ssrep )
! --
          call  print_spin_orb_mom_local( ia, l, spinmom, orbmom, print_header )
          print_header = .false.
       end do
    End do

  contains

    subroutine print_spin_orb_mom_local( ia, l, spinmom, orbmom, print_header )
      integer, intent(in) :: ia, l
      real(kind=DP), intent(in) :: spinmom(3), orbmom(3)
      logical, intent(in) :: print_header

      if ( mype /= 0 ) return

      if (print_header) then
         write(nfout,*) '! ------------ Local Momemnt ( occmat )  --- '
      endif

      write(nfout,*) '!   ia   l   type          mx             my             mz  '
!
      write(nfout,'(I7,I4,3X,A5,3F15.8)') ia, l, &
           &                              "spin ", spinmom(1), spinmom(2), spinmom(3)
      write(nfout,'(14X,     A5,3F15.8)') &
           &                              "orb  ", orbmom(1), orbmom(2), orbmom(3)
!
      write(nfout,*) '! ------ '

    end subroutine print_spin_orb_mom_local

  end subroutine m_OP_calc_orbmom_from_OCC


! ------------------
  subroutine m_OP_calc_MatL_orb_s_to_f
    real(kind=DP) :: theta, phi

    theta = 0.0; phi = 0.0d0
    call m_OP_calc_MatL_with_Cmplx_ylm( 0, theta, phi, &
         &                              Mat_L_with_cmplx_ylm_L0 )
    call m_OP_calc_MatL_with_Real_ylm( 0, MatU_ylm_RC_L0, &
         &                             Mat_L_with_cmplx_ylm_L0, &
         &                             Mat_L_with_real_ylm_L0 )
!
    call m_OP_calc_MatL_with_Cmplx_ylm( 1, theta, phi, &
         &                              Mat_L_with_cmplx_ylm_L1 )
    call m_OP_calc_MatL_with_Real_ylm( 1, MatU_ylm_RC_L1, &
         &                             Mat_L_with_cmplx_ylm_L1, &
         &                             Mat_L_with_real_ylm_L1 )
!
    call m_OP_calc_MatL_with_Cmplx_ylm( 2, theta, phi, &
         &                              Mat_L_with_cmplx_ylm_L2 )
    call m_OP_calc_MatL_with_Real_ylm( 2, MatU_ylm_RC_L2, &
         &                              Mat_L_with_cmplx_ylm_L2, &
         &                              Mat_L_with_real_ylm_L2 )
!
    call m_OP_calc_MatL_with_Cmplx_ylm( 3, theta, phi, &
         &                              Mat_L_with_cmplx_ylm_L3 )
    call m_OP_calc_MatL_with_Real_ylm( 3, MatU_ylm_RC_L3, &
         &                             Mat_L_with_cmplx_ylm_L3, &
         &                             Mat_L_with_real_ylm_L3 )
  end subroutine m_OP_calc_MatL_orb_s_to_f


  subroutine m_OP_calc_MatL_with_Real_ylm( l_in, MatU_ylm_RC, &
       &                                   Mat_L_with_cmplx_ylm, &
       &                                   Mat_L_with_real_ylm )
    integer, intent(in) :: l_in
    Complex(kind=CMPLDP), intent(in) :: MatU_ylm_RC( 2*l_in+1, -l_in:l_in )
    complex(kind=CMPLDP), intent(in) :: &
         &    Mat_L_with_cmplx_ylm( -l_in:l_in, -l_in:l_in, 3 )
    complex(kind=CMPLDP), intent(out) :: &
         &    Mat_L_with_real_ylm( 2*l_in+1, 2*l_in+1, 3 )

    integer :: m_min, m_max
    !
    integer :: ixyz
    integer :: m1, m2, ma, mb
!
    Complex(kind=CMPLDP) :: ztmp( 3 )
!
    m_min = -l_in;  m_max = l_in
!
    Do m1=1, 2 *l_in +1
       Do m2=1, 2 *l_in +1

          ztmp = 0.0d0

          Do ma = m_min, m_max
             Do mb = m_min, m_max
                Do ixyz=1, 3
#if 0
                   ztmp(ixyz) = ztmp(ixyz) + conjg(MatU_ylm_RC( m1,ma ))&
                        &                *Mat_L_with_cmplx_ylm( ma,mb,ixyz ) &
                        &                *( MatU_ylm_RC( m2,mb ) )
#else
                   ztmp(ixyz) = ztmp(ixyz) + MatU_ylm_RC( m1,ma )&
                        &                *Mat_L_with_cmplx_ylm( ma,mb,ixyz ) &
                        &                *conjg( MatU_ylm_RC( m2,mb ) )
#endif

                End do
             End do
          End do
          Mat_L_with_real_ylm( m1,m2,: ) = ztmp(:)
       End do
    End do
  end subroutine m_OP_calc_MatL_with_Real_ylm

  subroutine m_OP_calc_MatL_with_Cmplx_ylm( l_in, theta, phi, Mat_L_term )
    integer, intent(in) :: l_in
    real(kind=DP), intent(in) :: theta, phi
    complex(kind=CMPLDP), intent(out) :: &
         &          Mat_L_term( -l_in:l_in, -l_in:l_in, 3 )

    real(kind=DP) :: cos_th, sin_th, cos2_th_h, sin2_th_h
    real(kind=DP) :: ctmp_m, ctmp_p, ctmp_0

    integer :: m1, m2

    Do m1=-l_in, l_in
       Do m2=-l_in, l_in

          if ( m2 == m1 +1 ) then
             ctmp_m = sqrt( (l_in +m1 +1.0d0) *( l_in -m1 ) )
          else
             ctmp_m = 0.0d0
          endif

          if ( m2 == m1 -1 ) then
             ctmp_p = sqrt( (l_in -m1 +1.0d0) *( l_in +m1 ) )
          else
            ctmp_p = 0.0d0
          endif
          !
          if ( m1 == m2 ) then
             ctmp_0 = dble(m1)
          else
             ctmp_0 = 0.0d0
          endif

          Mat_L_term( m1,m2,1 ) =  ( ctmp_p +ctmp_m ) /2.0d0
          Mat_L_term( m1,m2,2 ) =  ( ctmp_p -ctmp_m ) /2.0d0 /zi
          Mat_L_term( m1,m2,3 ) =  ctmp_0

       End do
    End Do

  end subroutine m_OP_calc_MatL_with_Cmplx_ylm

  subroutine m_OP_print_OrbMagMom_on_atom(nfout)
    integer, intent(in) :: nfout

    integer :: ia, it

    if ( mype /= 0 ) return

    write(nfout,*) &
         & '! ------------ Local Orbital Momemnt (in sphere) at this scf step --- '

    write(nfout,*) &
         & '    id      name         mx             my             mz'
    Do ia=1, natm
       it = ityp(ia)
       write(nfout,'(I7,6X,A5,3F15.8)') ia, speciesname(it), &
            &                          OrbMag_on_atom(ia,1), &
            &                          OrbMag_on_atom(ia,2), &
            &                          OrbMag_on_atom(ia,3)
    End Do
    write(nfout,*) '! ---------------------------------------------'

  end subroutine m_OP_print_OrbMagMom_on_atom

! ==== KT_add === 2014/08/26
  subroutine m_OP_calc_OrbMagMom_in_sphere
    logical :: FirstFlag = .true.

    if ( FirstFlag ) then
       call m_OP_calc_MatL_orb_s_to_f
       FirstFlag = .false.
    endif

    if ( kimg == 1 ) return
    if ( .not. noncol ) return

    call alloc_arrays

#ifdef USE_ASMS_INTEGRAL
    call calc_ylm_dot_wfns_fast
#else
    call calc_ylm_dot_wfns_exact
#endif

    call calc_rho_ylm1_ylm2
    if ( flg_paw .or. sw_mix_charge_hardpart == ON ) then
       call symmetrz_rho_ylm1_ylm2
    endif

    if ( .not. allocated( OrbMag_on_atom ) ) allocate( OrbMag_on_atom(natm,3) )
    OrbMag_on_atom = 0.0d0

    call calc_soft_part_contrib
    call calc_hard_part_contrib

    call dealloc_arrays
!    deallocate( OrbMag_on_atom )

!    call m_OP_print_OrbMagMom_on_atom(nfout)

  contains

    subroutine alloc_arrays
      allocate( wfn_sph_decomposed( np_e, nlmta, ista_k:iend_k ) )
      wfn_sph_decomposed = 0.0d0

      allocate( rho_ylm1_ylm2_r( natm, nlmt, nlmt, ndim_magmom ) )
      allocate( rho_ylm1_ylm2_i( natm, nlmt, nlmt, ndim_magmom ) )
      rho_ylm1_ylm2_r = 0.0d0;  rho_ylm1_ylm2_i = 0.0d0

    end subroutine alloc_arrays

    subroutine dealloc_arrays
      deallocate( wfn_sph_decomposed )
      deallocate( rho_ylm1_ylm2_r );  deallocate( rho_ylm1_ylm2_i )
    end subroutine dealloc_arrays

    subroutine calc_ylm_dot_wfns_exact
      integer :: ia, it, ik, ib, ie, ig
      integer :: lmt1, il1, im1, it1, ilmta
      integer :: nspher, ir
      real(kind=DP) :: rad1, c1, facr
      complex(kind=CMPLDP) :: zfac1, zsum, z2, csum

      real(kind=DP), allocatable :: qx(:), qy(:), qz(:), vlength(:)
      real(kind=DP), allocatable :: ylm(:), wka(:), wkb(:)
      real(kind=DP), allocatable :: rwork(:)
      complex(kind=CMPLDP), allocatable :: zph(:)

      allocate( radr(mmesh) );  allocate( wos(mmesh) )

      allocate( qx(kg1) ); allocate( qy(kg1) ); allocate( qz(kg1) );
      allocate( vlength(kg1) ); allocate( ylm(kg1) )
      allocate( wka(kg1) ); allocate( wkb(kg1) )

      allocate( zph(kg1) ); allocate( rwork(kg1) )

      Do ia=1, natm
         it = ityp(ia);  rad1 = rad_cov(ia)
         call new_radr_and_wos(ista_k,it)

         csum = 0.0d0
         Do ir=1, nmesh(it)
            if ( radr(ir) > rad_cov(ia) ) exit
!            csum = csum +wos(ir) *radr(ir)
            csum = csum +wos(ir) *radr(ir)**2
         End do
         csum = sqrt( csum )

         do lmt1=1,ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
            if ( it1 /=1 ) cycle

            ilmta = lmta(lmt1,ia)

            nspher = (il1-1)**2 + im1
            zfac1 = zi **(il1-1)

            Do ik=1, kv3
               if ( map_k(ik) /= myrank_k ) cycle

               call k_plus_G_vectors_3D( ik, kgp, kg1, kv3, iba, nbase, vkxyz, &
                    &                 ngabc, rltv, qx, qy, qz, vlength )
               call sphr( iba(ik), nspher, qx, qy, qz, ylm )

               Do ig=1, iba(ik)
                  c1 = qx(ig)*cps(ia,1) +qy(ig)*cps(ia,2) +qz(ig)*cps(ia,3)
                  zph(ig) = dcmplx( cos(c1), sin(c1) )
               End do

               rwork = 0.0d0

               Do ir=1, nmesh(it)
                  if ( radr(ir) > rad_cov(ia) ) exit
!                  if ( radr(ir) > 2.5 ) exit
!!                  if ( ir > wf_mnrc(it) ) exit

                  facr = wos(ir) *radr(ir)**2
!!!                  facr = wos(ir) *radr(ir)

                  Do ig=1, iba(ik)
                     wka(ig) = vlength(ig) *radr(ir)
                  End do
                  call dsjnv( il1-1, iba(ik), wka, wkb )

                  Do ig=1, iba(ik)
                     rwork(ig) = rwork(ig) + facr *wkb(ig) *ylm(ig)
                  End do
               End do
!
               Do ib=1, neg
                  if ( map_e(ib) /= myrank_e ) cycle
                  ie = map_z(ib)

                  zsum = 0.0d0
                  Do ig=1, iba(ik)
                     z2 = dcmplx( zaj_l(ig,ie,ik,1), zaj_l(ig,ie,ik,kimg) )
                     zsum = zsum + z2 *zph(ig) *rwork(ig)
                  End do
                  wfn_sph_decomposed(ie,ilmta,ik) = zsum *zfac1 /csum
               End do
            End Do
         End do
      End Do
!      stop
!
      wfn_sph_decomposed = wfn_sph_decomposed *PAI4 /sqrt(univol)

      deallocate( zph ); deallocate( radr ); deallocate( wos )
      deallocate( qx ); deallocate( qy ); deallocate( qz ); deallocate( vlength )
      deallocate( ylm )
      deallocate( wka ); deallocate( wkb )
    end subroutine calc_ylm_dot_wfns_exact

#ifdef USE_ASMS_INTEGRAL
    subroutine calc_ylm_dot_wfns_fast
      interface
         real(8) function ASMS_integ_spherical_bessel_j(a,b,c)
           integer :: a
           real(8) :: b, c
         end function ASMS_integ_spherical_bessel_j
      end interface

      integer :: ia, it, ik, ib, ie, ig
      integer :: lmt1, il1, im1, it1, ilmta
      integer :: nspher, ir
      real(kind=DP) :: rad1, c1, facr, bfact
      complex(kind=CMPLDP) :: zfac1, zsum, z2

      real(kind=DP), allocatable :: qx(:), qy(:), qz(:), vlength(:)
      real(kind=DP), allocatable :: ylm(:)
      real(kind=DP), allocatable :: sph_besselj_integ(:)
      complex(kind=CMPLDP), allocatable :: zph(:)

      allocate( qx(kg1) ); allocate( qy(kg1) ); allocate( qz(kg1) );
      allocate( vlength(kg1) );
      allocate( ylm(kg1) );     allocate( zph(kg1) );
      allocate( sph_besselj_integ(kg1) )

      Do ia=1, natm
         it = ityp(ia);  rad1 = rad_cov(ia)

         do lmt1=1,ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
            ilmta = lmta(lmt1,ia)

            nspher = (il1-1)**2 + im1
            zfac1 = zi **(il1-1)

            Do ik=1, kv3
               if ( map_k(ik) /= myrank_k ) cycle

               call k_plus_G_vectors_3D( ik, kgp, kg1, kv3, iba, nbase, vkxyz, &
                    &                    ngabc, rltv, qx, qy, qz, vlength )
               call sphr( iba(ik), nspher, qx, qy, qz, ylm )

               Do ig=1, iba(ik)
                  c1 = qx(ig)*cps(ia,1) +qy(ig)*cps(ia,2) +qz(ig)*cps(ia,3)
                  zph(ig) = dcmplx( cos(c1), sin(c1) )

                  sph_besselj_integ(ig) &
                       &   = ASMS_integ_spherical_bessel_j( il1 -1, vlength(ig), rad1 )
               End do

               Do ib=1, neg
                  if ( map_e(ib) /= myrank_e ) cycle
                  ie = map_z(ib)

                  zsum = 0.0d0
                  Do ig=1, iba(ik)
                     z2 = dcmplx( zaj_l(ig,ie,ik,1), zaj_l(ig,ie,ik,kimg) )
                     zsum = zsum + z2 *zph(ig) *ylm(ig) *sph_besselj_integ(ig)
                  End do
                  wfn_sph_decomposed(ie,ilmta,ik) = zsum *zfac1
               End do
            End Do
         End do
      End Do
!
      wfn_sph_decomposed = wfn_sph_decomposed *PAI4 /sqrt(univol)

      deallocate( qx ); deallocate( qy ); deallocate( qz ); deallocate( vlength )
      deallocate( ylm );deallocate( zph );
      deallocate( sph_besselj_integ )

    end subroutine calc_ylm_dot_wfns_fast
#endif

    subroutine calc_soft_part_contrib
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2
      real(kind=DP), allocatable :: hsr_ssrep(:,:,:,:), hsi_ssrep(:,:,:,:)
      real(kind=DP) :: orbmom(3)
      complex(kind=CMPLDP) :: ztmp(3), z1, z2

      allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsi_ssrep = 0.0d0

      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, rho_ylm1_ylm2_r, rho_ylm1_ylm2_i, &
           &                           hsr_ssrep, hsi_ssrep )

      Do ia=1, natm
         it = ityp(ia)

         orbmom = 0.0d0

         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               if ( is1 /= is2 ) cycle
               istmp = (is1 -1)*ndim_spinor +is2

               do lmt1=1,ilmt(it)
                  il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
                  if ( it1 > 1 ) cycle
                  if ( il1 <= 1 .or. il1 >4 ) cycle

                  do lmt2=1,ilmt(it)
                     il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)
                     if ( it2 > 1 ) cycle
                     if ( il1 /= il2 ) cycle

                     ztmp = 0.0d0
                     if ( il1 == 2 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L1( im2, im1, : )
                     else if ( il1 == 3 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L2( im2, im1, : )
                     else if ( il1 == 4 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L3( im2, im1, : )
                     endif

                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )

                     orbmom(1) = orbmom(1) +z1*ztmp(1)
                     orbmom(2) = orbmom(2) +z1*ztmp(2)
                     orbmom(3) = orbmom(3) +z1*ztmp(3)
                  End do
               End Do
!
            End do
         End do

         OrbMag_on_atom(ia,1) = OrbMag_on_atom(ia,1) +orbmom(1)
         OrbMag_on_atom(ia,2) = OrbMag_on_atom(ia,2) +orbmom(2)
         OrbMag_on_atom(ia,3) = OrbMag_on_atom(ia,3) +orbmom(3)
      End Do
      deallocate( hsr_ssrep, hsi_ssrep )
    end subroutine calc_soft_part_contrib

    subroutine calc_hard_part_contrib
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2
      real(kind=DP), allocatable :: hsr_ssrep(:,:,:,:), hsi_ssrep(:,:,:,:)
      real(kind=DP), allocatable :: ovp(:,:,:,:)
      real(kind=DP) :: orbmom(3)
      complex(kind=CMPLDP) :: ztmp(3), z1, z2

      allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsi_ssrep = 0.0d0

      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, hsr, hsi, hsr_ssrep, hsi_ssrep )

      allocate( ovp(ntau,ntau,nloc,ntyp ) );  ovp = 0.0d0
      Do it=1, ntyp
         do lmt1=1,ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
            do lmt2=1,ilmt(it)
               il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)
               if ( il1 == il2 .and. im1 == im2 ) then
                  ovp(it1,it2,il1,it) = q_noncl(lmt1,lmt2,1,it)
               endif
            end do
         end do
      end Do

      Do ia=1, natm
         it = ityp(ia)

         orbmom = 0.0d0

         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               if ( is1 /= is2 ) cycle
               istmp = (is1 -1)*ndim_spinor +is2

               do lmt1=1,ilmt(it)
                  il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
                  do lmt2=1,ilmt(it)
                     il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)

                     if ( il1 <= 1 .or. il1 >4 ) cycle
                     if ( il1 /= il2 ) cycle

                     ztmp = 0.0d0
                     if ( il1 == 2 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L1( im2, im1, : )
                     else if ( il1 == 3 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L2( im2, im1, : )
                     else if ( il1 == 4 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L3( im2, im1, : )
                     endif

                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )
#if 0
!                     z2 = z1 *q(lmt1,lmt2,it)
                     z2 = z1 *q_noncl(lmt1,lmt2,istmp,it)
#else
                     z2 = z1 *ovp(it1,it2,il1,it)
#endif

                     orbmom(1) = orbmom(1) +z2*ztmp(1)
                     orbmom(2) = orbmom(2) +z2*ztmp(2)
                     orbmom(3) = orbmom(3) +z2*ztmp(3)
                  End do
               End Do
!
            End do
         End do
         OrbMag_on_atom(ia,1) = OrbMag_on_atom(ia,1) +orbmom(1)
         OrbMag_on_atom(ia,2) = OrbMag_on_atom(ia,2) +orbmom(2)
         OrbMag_on_atom(ia,3) = OrbMag_on_atom(ia,3) +orbmom(3)
      End Do
      deallocate( hsr_ssrep, hsi_ssrep )
      deallocate( ovp )

    end subroutine calc_hard_part_contrib

  end subroutine m_OP_calc_OrbMagMom_in_sphere

  subroutine m_OP_calc_OrbMagMom_method1
    logical :: FirstFlag = .true.

    if ( FirstFlag ) then
       call m_OP_calc_MatL_orb_s_to_f
       FirstFlag = .false.
    endif

    if ( kimg == 1 ) return
    if ( .not. noncol ) return

    call alloc_arrays

    call calc_psir_ylm_dot_wfns

    call calc_rho_ylm1_ylm2
    if ( flg_paw .or. sw_mix_charge_hardpart == ON ) then
       call symmetrz_rho_ylm1_ylm2
    endif

    if ( .not. allocated( OrbMag_on_atom ) ) allocate( OrbMag_on_atom(natm,3) )
    OrbMag_on_atom = 0.0d0

    call calc_soft_part_contrib
    call calc_hard_part_contrib

    call print_orb_mom

    call dealloc_arrays
!    deallocate( OrbMag_on_atom )

  contains

    subroutine alloc_arrays
      allocate( wfn_sph_decomposed( np_e, nlmta, ista_k:iend_k ) )
      wfn_sph_decomposed = 0.0d0

      allocate( rho_ylm1_ylm2_r( natm, nlmt, nlmt, ndim_magmom ) )
      allocate( rho_ylm1_ylm2_i( natm, nlmt, nlmt, ndim_magmom ) )
      rho_ylm1_ylm2_r = 0.0d0;  rho_ylm1_ylm2_i = 0.0d0

    end subroutine alloc_arrays

    subroutine dealloc_arrays
      deallocate( wfn_sph_decomposed )
      deallocate( rho_ylm1_ylm2_r );  deallocate( rho_ylm1_ylm2_i )
    end subroutine dealloc_arrays

    subroutine calc_psir_ylm_dot_wfns
      integer :: ia, it, ik, ib, ie, ig
      integer :: lmt1, il1, im1, it1, ilmta
      integer :: nspher, ir
      real(kind=DP) :: rad1, c1, facr
      complex(kind=CMPLDP) :: zfac1, zsum, z2

      real(kind=DP), allocatable :: qx(:), qy(:), qz(:), vlength(:)
      real(kind=DP), allocatable :: ylm(:), wka(:), wkb(:)
      real(kind=DP), allocatable :: rwork(:)
      complex(kind=CMPLDP), allocatable :: zph(:)

      allocate( radr(mmesh) );  allocate( wos(mmesh) )

      allocate( qx(kg1) ); allocate( qy(kg1) ); allocate( qz(kg1) );
      allocate( vlength(kg1) ); allocate( ylm(kg1) )
      allocate( wka(kg1) ); allocate( wkb(kg1) )

      allocate( zph(kg1) ); allocate( rwork(kg1) )

      Do it=1, ntyp
         call new_radr_and_wos(ista_k,it)
         rad1 = rad_cov_default( nint(iatomn(it)) ) ! Revised according to a report from ASMS Co.ltd, 10 March 2016.

         do lmt1=1,ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)

            nspher = (il1-1)**2 +im1;
            zfac1 = zi **(il1-1)

            Do ik=1, kv3
               if ( map_k(ik) /= myrank_k ) cycle

               call k_plus_G_vectors_3D( ik, kgp, kg1, kv3, iba, nbase, vkxyz, &
                    &                    ngabc, rltv, qx, qy, qz, vlength )
               call sphr( iba(ik), nspher, qx, qy, qz, ylm )

               rwork = 0.0d0

               Do ir=1, nmesh(it)
!                  if ( ir > wf_mnrc(it) ) exit
                  if ( radr(ir) > rad1 ) exit

!                  facr = wos(ir) *psirpw(ir,il1,it1,it) *radr(ir)
                  facr = wos(ir) *psir_val(ir,il1,it1,it) *radr(ir)
!                  facr = wos(ir) *phirpw(ir,il1,it1,it) *radr(ir)

                  Do ig=1, iba(ik)
                     wka(ig) = vlength(ig) *radr(ir)
                  End do
                  call dsjnv( il1-1, iba(ik), wka, wkb )

                  Do ig=1, iba(ik)
                     rwork(ig) = rwork(ig) + facr *wkb(ig) *ylm(ig)
                  End do
               End do

               Do ia=1, natm
                  if ( ityp(ia) /= it ) cycle
                  ilmta = lmta(lmt1,ia)

                  Do ig=1, iba(ik)
                     c1 = qx(ig)*cps(ia,1) +qy(ig)*cps(ia,2) +qz(ig)*cps(ia,3)
                     zph(ig) = dcmplx( cos(c1), sin(c1) )
                  End do

!
                  Do ib=1, neg
                     if ( map_e(ib) /= myrank_e ) cycle
                     ie = map_z(ib)

                     zsum = 0.0d0
                     Do ig=1, iba(ik)
                        z2 = dcmplx( zaj_l(ig,ie,ik,1), zaj_l(ig,ie,ik,kimg) )
                        zsum = zsum + z2 *zph(ig) *rwork(ig)
                     End do
                     wfn_sph_decomposed(ie,ilmta,ik) = zsum *zfac1
                  End do
               End do
            End Do
         End do
      End Do
!
      wfn_sph_decomposed = wfn_sph_decomposed *PAI4 /sqrt(univol)

      deallocate( zph ); deallocate( radr ); deallocate( wos )
      deallocate( qx ); deallocate( qy ); deallocate( qz ); deallocate( vlength )
      deallocate( ylm )
      deallocate( wka ); deallocate( wkb )
    end subroutine calc_psir_ylm_dot_wfns

    subroutine calc_soft_part_contrib
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2
      real(kind=DP), allocatable :: hsr_ssrep(:,:,:,:), hsi_ssrep(:,:,:,:)
      real(kind=DP) :: orbmom(3)
      complex(kind=CMPLDP) :: ztmp(3), z1, z2

      allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsi_ssrep = 0.0d0

      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, rho_ylm1_ylm2_r, rho_ylm1_ylm2_i, &
           &                           hsr_ssrep, hsi_ssrep )

      Do ia=1, natm
         it = ityp(ia)

         orbmom = 0.0d0

         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               if ( is1 /= is2 ) cycle
               istmp = (is1 -1)*ndim_spinor +is2

               do lmt1=1,ilmt(it)
                  il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
                  if ( il1 <= 1 .or. il1 >4 ) cycle
!                  if (it1 >1 ) cycle

                  do lmt2=1,ilmt(it)
                     il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)
                     if ( il1 /= il2 ) cycle
!                     if (it2 >1 ) cycle

                     ztmp = 0.0d0
                     if ( il1 == 2 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L1( im2, im1, : )
                     else if ( il1 == 3 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L2( im2, im1, : )
                     else if ( il1 == 4 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L3( im2, im1, : )
                     endif

                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )
                     z1 = z1 *product_psir_val(il1,it1,it2,it)

                     orbmom(1) = orbmom(1) +z1*ztmp(1)
                     orbmom(2) = orbmom(2) +z1*ztmp(2)
                     orbmom(3) = orbmom(3) +z1*ztmp(3)
                  End do
               End Do
!
            End do
         End do

         OrbMag_on_atom(ia,1) = OrbMag_on_atom(ia,1) +orbmom(1)
         OrbMag_on_atom(ia,2) = OrbMag_on_atom(ia,2) +orbmom(2)
         OrbMag_on_atom(ia,3) = OrbMag_on_atom(ia,3) +orbmom(3)
      End Do
      deallocate( hsr_ssrep, hsi_ssrep )
    end subroutine calc_soft_part_contrib

    subroutine calc_hard_part_contrib
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2
      real(kind=DP), allocatable :: hsr_ssrep(:,:,:,:), hsi_ssrep(:,:,:,:)
      real(kind=DP), allocatable :: ovp(:,:,:,:)
      real(kind=DP) :: orbmom(3)
      complex(kind=CMPLDP) :: ztmp(3), z1, z2

      allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsi_ssrep = 0.0d0

      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, hsr, hsi, hsr_ssrep, hsi_ssrep )

      allocate( ovp(ntau,ntau,nloc,ntyp ) );  ovp = 0.0d0
      Do it=1, ntyp
         do lmt1=1,ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
            do lmt2=1,ilmt(it)
               il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)
               if ( il1 == il2 .and. im1 == im2 ) then
                  ovp(it1,it2,il1,it) = q_noncl(lmt1,lmt2,1,it)
               endif
            end do
         end do
      end Do

      Do ia=1, natm
         it = ityp(ia)

         orbmom = 0.0d0

         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               if ( is1 /= is2 ) cycle
               istmp = (is1 -1)*ndim_spinor +is2

               do lmt1=1,ilmt(it)
                  il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
                  do lmt2=1,ilmt(it)
                     il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)

                     if ( il1 <= 1 .or. il1 >4 ) cycle
                     if ( il1 /= il2 ) cycle

                     ztmp = 0.0d0
                     if ( il1 == 2 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L1( im2, im1, : )
                     else if ( il1 == 3 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L2( im2, im1, : )
                     else if ( il1 == 4 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L3( im2, im1, : )
                     endif

                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )
#if 0
!                     z2 = z1 *q(lmt1,lmt2,it)
                     z2 = z1 *q_noncl(lmt1,lmt2,istmp,it)
#else
                     z2 = z1 *ovp(it1,it2,il1,it)
#endif
                     orbmom(1) = orbmom(1) +z2*ztmp(1)
                     orbmom(2) = orbmom(2) +z2*ztmp(2)
                     orbmom(3) = orbmom(3) +z2*ztmp(3)
                  End do
               End Do
!
            End do
         End do
         OrbMag_on_atom(ia,1) = OrbMag_on_atom(ia,1) +orbmom(1)
         OrbMag_on_atom(ia,2) = OrbMag_on_atom(ia,2) +orbmom(2)
         OrbMag_on_atom(ia,3) = OrbMag_on_atom(ia,3) +orbmom(3)
      End Do
      deallocate( hsr_ssrep, hsi_ssrep )
      deallocate( ovp )

    end subroutine calc_hard_part_contrib

    subroutine print_orb_mom
      integer :: ia, it, k

      if ( mype /= 0 ) return

      write(nfout,*) &
           & '! ------------ Local Orbital Momemnt (method1) at this scf step --- '

       write(nfout,*) &
            & '!   id   atom no.        mx             my             mz'
       Do ia=1, natm
          it = ityp(ia)
          write(nfout,'(I7,F10.4,3F15.8)') ia, iatomn(it), &
               &                          OrbMag_on_atom(ia,1), &
               &                          OrbMag_on_atom(ia,2), &
               &                          OrbMag_on_atom(ia,3)
       End Do
       write(nfout,*) '! ---------------------------------------------'

    end subroutine print_orb_mom

  end subroutine m_OP_calc_OrbMagMom_method1

  subroutine m_OP_calc_OrbMagMom_method2
    logical :: FirstFlag = .true.

    if ( iprimagmom < 3 ) return

    if ( FirstFlag ) then
       call m_OP_calc_MatL_orb_s_to_f
       FirstFlag = .false.
    endif

    if ( kimg == 1 ) return
    if ( .not. noncol ) return

    if ( .not. allocated( OrbMag_on_atom ) ) allocate( OrbMag_on_atom(natm,3) )
    OrbMag_on_atom = 0.0d0

    call hardpart_contrib
    if ( sw_use_add_proj == ON ) call hardpart_contrib_add_proj

    call print_orb_mom

!    deallocate( OrbMag_on_atom )

  contains

    subroutine hardpart_contrib
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2
      real(kind=DP), allocatable :: hsr_ssrep(:,:,:,:), hsi_ssrep(:,:,:,:)
      real(kind=DP) :: orbmom(3)
      complex(kind=CMPLDP) :: ztmp(3), z1, z2

      allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsi_ssrep = 0.0d0

      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, hsr, hsi, hsr_ssrep, hsi_ssrep )

      Do ia=1, natm
         it = ityp(ia)

         orbmom = 0.0d0

         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               if ( is1 /= is2 ) cycle
               istmp = (is1 -1)*ndim_spinor +is2

               do lmt1=1,ilmt(it)
                  il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
                  do lmt2=1,ilmt(it)
                     il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)

                     if ( il1 <= 1 .or. il1 >4 ) cycle
                     if ( il1 /= il2 ) cycle

                     ztmp = 0.0d0
                     if ( il1 == 2 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L1( im2, im1, : )
                     else if ( il1 == 3 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L2( im2, im1, : )
                     else if ( il1 == 4 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L3( im2, im1, : )
                     endif

                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )
                     if ( sw_use_contracted_psir == ON ) then
                        z1 = z1 *product_psir_val( il1, it1, it2, it )
                     endif

                     orbmom(1) = orbmom(1) +z1*ztmp(1)
                     orbmom(2) = orbmom(2) +z1*ztmp(2)
                     orbmom(3) = orbmom(3) +z1*ztmp(3)
                  End do
               End Do
!
            End do
         End do

         OrbMag_on_atom(ia,1) = OrbMag_on_atom(ia,1) +orbmom(1)
         OrbMag_on_atom(ia,2) = OrbMag_on_atom(ia,2) +orbmom(2)
         OrbMag_on_atom(ia,3) = OrbMag_on_atom(ia,3) +orbmom(3)
      End Do
      deallocate( hsr_ssrep, hsi_ssrep )

    end subroutine hardpart_contrib

    subroutine hardpart_contrib_add_proj
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2
      real(kind=DP), allocatable :: hsr_ssrep(:,:,:,:), hsi_ssrep(:,:,:,:)
      real(kind=DP) :: orbmom(3)
      complex(kind=CMPLDP) :: ztmp(3), z1, z2

      allocate( hsr_ssrep( natm, nlmt_add, nlmt_add, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt_add, nlmt_add, ndim_chgpot ) ); hsi_ssrep = 0.0d0

      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt_add, hsr_add, hsi_add, &
           &                           hsr_ssrep, hsi_ssrep )

      Do ia=1, natm
         it = ityp(ia)

         orbmom = 0.0d0

         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               if ( is1 /= is2 ) cycle
               istmp = (is1 -1)*ndim_spinor +is2

               do lmt1=1,ilmt_add(it)
                  il1=ltp_add(lmt1,it); im1=mtp_add(lmt1,it); it1=1
                  do lmt2=1,ilmt_add(it)
                     il2=ltp_add(lmt2,it);  im2=mtp_add(lmt2,it); it2=1

                     if ( il1 <= 1 .or. il1 >4 ) cycle
                     if ( il1 /= il2 ) cycle

                     ztmp = 0.0d0
                     if ( il1 == 2 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L1( im2, im1, : )
                     else if ( il1 == 3 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L2( im2, im1, : )
                     else if ( il1 == 4 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L3( im2, im1, : )
                     endif

                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )

                     orbmom(1) = orbmom(1) +z1*ztmp(1)
                     orbmom(2) = orbmom(2) +z1*ztmp(2)
                     orbmom(3) = orbmom(3) +z1*ztmp(3)
                  End do
               End Do
!
            End do
         End do

         OrbMag_on_atom(ia,1) = OrbMag_on_atom(ia,1) +orbmom(1)
         OrbMag_on_atom(ia,2) = OrbMag_on_atom(ia,2) +orbmom(2)
         OrbMag_on_atom(ia,3) = OrbMag_on_atom(ia,3) +orbmom(3)
      End Do
      deallocate( hsr_ssrep, hsi_ssrep )

    end subroutine hardpart_contrib_add_proj

    subroutine print_orb_mom
      integer :: ia, it, k

      if ( mype /= 0 ) return

      write(nfout,*) &
           & '! ------------ Local Orbital Momemnt (method2) at this scf step --- '
       write(nfout,*) &
            & '    id      name          mx             my             mz'
       Do ia=1, natm
          it = ityp(ia)
          write(nfout,'(I7,6X,A5,3F15.8)') ia, speciesname(it), &
               &                          OrbMag_on_atom(ia,1), &
               &                          OrbMag_on_atom(ia,2), &
               &                          OrbMag_on_atom(ia,3)
       End Do

       write(nfout,*)

    end subroutine print_orb_mom

  end subroutine m_OP_calc_OrbMagMom_method2

  subroutine calc_rho_ylm1_ylm2
    integer         :: ia, is, k, i, lmt1, lmt2, p, q, it
    integer :: is1, is2, is_tmp, k1, k2

    real(kind=DP)   :: w_n, d_factor
    complex(kind=CMPLDP) :: z1

    integer :: il1, il2, im1, im2, it1, it2, istmp, jstmp

    real(kind=DP), allocatable, dimension(:,:,:,:) :: hsr_or_hsi_mpi
    real(kind=DP), allocatable, dimension(:,:,:,:) :: hsr_ssrep
    real(kind=DP), allocatable, dimension(:,:,:,:) :: hsi_ssrep
!
! ---------------------- kt : uncertain ---------
!!!!!    d_factor = 2.d0/ ( kv3 /ndim_spinor )
!
    d_factor = 1.d0/ ( kv3 /ndim_spinor )
! -------------------------------------------

    allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsr_ssrep = 0.0d0
    allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsi_ssrep = 0.0d0

    do ia = 1, natm
       it = ityp(ia)

       do is1 = 1, ndim_spinor
          do is2 = 1, ndim_spinor
             is_tmp = ( is1 -1 )*ndim_spinor + is2
             do i = 1, np_e                                  ! MPI

                do k = 1, kv3, ndim_spinor
                   if ( map_k(k) /= myrank_k ) cycle            ! MPI
                   w_n = occup_l(i,k) *d_factor

                   k1 = k + is1 -1;  k2 = k + is2 -1
                   do lmt1 = 1, ilmt(it)
                      p = lmta(lmt1,ia)
                      do lmt2 = 1, ilmt(it)
                         q = lmta(lmt2,ia)
                         z1 = wfn_sph_decomposed(i,p,k1) &
                              &      *conjg( wfn_sph_decomposed(i,q,k2) )

                         hsr_ssrep(ia,lmt1,lmt2,is_tmp) &
                              &  = hsr_ssrep(ia,lmt1,lmt2,is_tmp) &
                              &    + w_n * real(z1)
                         hsi_ssrep(ia,lmt1,lmt2,is_tmp) &
                              &  = hsi_ssrep(ia,lmt1,lmt2,is_tmp) &
                              &    + w_n * aimag(z1)
                      end do! lmt2
                   end do! lmt1
                end do! k
             end do! i
          end do! is2
       end do! is1
    end do! ia
!
    if (npes >= 2) then
       allocate(hsr_or_hsi_mpi(natm,nlmt,nlmt,ndim_chgpot))
       hsr_or_hsi_mpi = 0.0d0

       call mpi_allreduce( hsr_ssrep, hsr_or_hsi_mpi, natm*nlmt*nlmt*ndim_chgpot, &
            &              mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )
       hsr_ssrep = hsr_or_hsi_mpi

       call mpi_allreduce( hsi_ssrep, hsr_or_hsi_mpi, natm*nlmt*nlmt*ndim_chgpot, &
            &              mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )
       hsi_ssrep = hsr_or_hsi_mpi

       deallocate(hsr_or_hsi_mpi)
    end if
!
    call m_ES_DensMat_To_MagMom_hsr( natm, nlmt, hsr_ssrep, hsi_ssrep, &
         &                           rho_ylm1_ylm2_r, rho_ylm1_ylm2_i )
!
    deallocate( hsr_ssrep, hsi_ssrep )
!
  end subroutine calc_rho_ylm1_ylm2

  subroutine symmetrz_rho_ylm1_ylm2
    integer         :: ia, is, iopr, i, lmt1, lmt2, lmt3, lmt4, it
    real(kind=DP), allocatable, dimension(:,:,:,:) :: hsr_tmp
    real(kind=DP), allocatable, dimension(:,:,:,:) :: hsi_tmp

    integer :: il1,im1,it1,il2,im2,it2,il3,im3,it3,il4,im4,it4
    integer :: ii,jj,kk,ll,n,m,iii,jjj
    integer :: ja

    integer :: ixyz1, ixyz2, is_tmp
    real(kind=DP) :: ctmp1, weight, ctmp2, weight2, fi

    fi = 1.d0/nopr
    if ( charge_symm_mode >= chg_symm_level1 ) then
       fi = 1.0d0 /dble(nopr_from_fbz_to_ibz)
    endif

    allocate(hsr_tmp(natm,nlmt,nlmt,ndim_magmom)); hsr_tmp = 0.0d0
    allocate(hsi_tmp(natm,nlmt,nlmt,ndim_magmom)); hsi_tmp = 0.0d0
!
    hsr_tmp = rho_ylm1_ylm2_r;  hsi_tmp = rho_ylm1_ylm2_i

    do ia=1,natm
       it=ityp(ia)
       do is =1, ndim_magmom
          do lmt2=1,ilmt(it)
             do lmt1=lmt2+1,ilmt(it)
                hsr_tmp(ia,lmt1,lmt2,is) =  hsr_tmp(ia,lmt2,lmt1,is)
                hsi_tmp(ia,lmt1,lmt2,is) = -hsi_tmp(ia,lmt2,lmt1,is)
             end do
          end do
       end do
    end do

    rho_ylm1_ylm2_r = 0.d0; rho_ylm1_ylm2_i = 0.0d0

    do iopr=1,nopr
       if ( charge_symm_mode >= chg_symm_level1 )then
         if(flg_opr_from_fbz_to_ibz(iopr) == 0 ) cycle
       endif

       if ( magmom_dir_inversion_opr_flag(iopr) == -1 ) then
          weight = -1.0d0
       else
          weight = 1.0d0
       endif

       if ( determinant_op(iopr) > 0 ) then
          weight2 = 1.0d0
       else
          weight2 = -1.0d0
       endif

       do ia = 1, natm
          it = ityp(ia)
          ja=abs(ia2ia_symmtry_op_inv(ia,iopr))

          do lmt1 = 1, ilmt(it)
             il1=ltp(lmt1,it)
             im1=mtp(lmt1,it)
             it1=taup(lmt1,it)
             ii=(il1-1)**2+im1

             do lmt2 = lmt1, ilmt(it)
!             do lmt2 = 1, ilmt(it)
                il2=ltp(lmt2,it)
                im2=mtp(lmt2,it)
                it2=taup(lmt2,it)
                jj=(il2-1)**2+im2

                do n=1,nylm_paw(ii,iopr,ia)
                   iii=iylm_paw(n,ii,iopr,ia)
                   do m=1,nylm_paw(jj,iopr,ia)
                      jjj=iylm_paw(m,jj,iopr,ia)

                      do lmt3=1,ilmt(it)
                         il3=ltp(lmt3,it)
                         im3=mtp(lmt3,it)
                         it3=taup(lmt3,it)
                         kk=(il3-1)**2+im3

                         if(kk.ne.iii .or. it1.ne.it3) cycle

                         do lmt4=1,ilmt(it)
                            il4=ltp(lmt4,it)
                            im4=mtp(lmt4,it)
                            it4=taup(lmt4,it)
                            ll=(il4-1)**2+im4
                            if(ll.ne.jjj .or. it2.ne.it4) cycle

                            ctmp1 = 1.0d0;   ctmp2 = weight

                            rho_ylm1_ylm2_r(ia,lmt1,lmt2,1) = &
                                 rho_ylm1_ylm2_r(ia,lmt1,lmt2,1) + &
                                 ctmp1 * &
                                 hsr_tmp(ja,lmt3,lmt4,1)* &
                                 crotylm_paw(n,ii,iopr,ia)* &
                                 crotylm_paw(m,jj,iopr,ia)
                            rho_ylm1_ylm2_i(ia,lmt1,lmt2,1) = &
                                 rho_ylm1_ylm2_i(ia,lmt1,lmt2,1) + &
                                 ctmp2 * &
                                 hsi_tmp(ja,lmt3,lmt4,1)* &
                                 crotylm_paw(n,ii,iopr,ia)* &
                                 crotylm_paw(m,jj,iopr,ia)

                            Do ixyz1=1, 3
                               Do ixyz2=1, 3
                                  ctmp1 = op(ixyz2, ixyz1, iopr) *weight2 *weight
                                  ctmp2 = op(ixyz2, ixyz1, iopr) *weight2
!
                                  rho_ylm1_ylm2_r(ia,lmt1,lmt2,ixyz2+1) &
                                       & = rho_ylm1_ylm2_r(ia,lmt1,lmt2,ixyz2+1)  &
                                       &  + ctmp1 &
                                       &    *hsr_tmp(ja,lmt3,lmt4,ixyz1+1) &
                                       &    *crotylm_paw(n,ii,iopr,ia)  &
                                       &    *crotylm_paw(m,jj,iopr,ia)
                                  rho_ylm1_ylm2_i(ia,lmt1,lmt2,ixyz2+1) &
                                       & = rho_ylm1_ylm2_i(ia,lmt1,lmt2,ixyz2+1)  &
                                       &  + ctmp2 &
                                       &    *hsi_tmp(ja,lmt3,lmt4,ixyz1+1) &
                                       &    *crotylm_paw(n,ii,iopr,ia)  &
                                       &    *crotylm_paw(m,jj,iopr,ia)
                               End do
                            End do

                         end do! lmt4
                      end do! lmt3

                   end do! jjj
                end do! iii

             end do! lmt2
          end do! lmt1
       end do! ia
    end do! iopr

!    rho_ylm1_ylm2_r = rho_ylm1_ylm2_r/nopr; rho_ylm1_ylm2_i = rho_ylm1_ylm2_i/nopr;
    rho_ylm1_ylm2_r = rho_ylm1_ylm2_r *fi; rho_ylm1_ylm2_i = rho_ylm1_ylm2_i *fi

    do ia=1,natm
       it=ityp(ia)
       do is =1, ndim_magmom
          do lmt2=1,ilmt(it)
             do lmt1=lmt2+1,ilmt(it)
                rho_ylm1_ylm2_r(ia,lmt1,lmt2,is) = rho_ylm1_ylm2_r(ia,lmt2,lmt1,is)
                rho_ylm1_ylm2_i(ia,lmt1,lmt2,is) =-rho_ylm1_ylm2_i(ia,lmt2,lmt1,is)
             end do
          end do
       end do
    end do

    deallocate(hsr_tmp);  deallocate(hsi_tmp)

  end subroutine symmetrz_rho_ylm1_ylm2
! ============= 2014/08/26

! ====== KT_add === 2014/09/01
  subroutine m_OP_orb_decomposed_orb_magmom
    logical :: FirstFlag = .true.

    real(kind=DP), allocatable :: orb_magmom_orb_decomposed(:,:)
    real(kind=DP), allocatable :: orb_magmom_orb_decomposed_add(:,:)

    if ( FirstFlag ) then
       call m_OP_calc_MatL_orb_s_to_f
       FirstFlag = .false.
    endif

    if ( kimg == 1 ) return
    if ( .not. noncol ) return

    allocate( orb_magmom_orb_decomposed( nlmta, 3 ) )
    orb_magmom_orb_decomposed = 0.0d0
    if ( sw_use_add_proj == ON ) then
       allocate( orb_magmom_orb_decomposed_add( nlmta_add, 3 ) )
       orb_magmom_orb_decomposed_add = 0.0d0
    endif

    call contrib_hardpart
    if ( sw_use_add_proj == ON ) call contrib_hardpart_add_proj

    write(nfout,*) &
         &   "! --------- Orbital decomposed orbital magnetic moment (method2) ------"
    write(nfout,*) "< Detail >"
    call print_orb_decomposed_orb_mag_1

    write(nfout,*) "< Summed over m >"
    call print_orb_decomposed_orb_mag_2

    write(nfout,*) "< Summed over l,m >"
    call print_orb_decomposed_orb_mag_3
    write(nfout,*)

    deallocate( orb_magmom_orb_decomposed )
    if ( sw_use_add_proj == ON ) then
       deallocate( orb_magmom_orb_decomposed_add )
    endif

  contains

    subroutine contrib_hardpart
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2, ilmta
      real(kind=DP), allocatable :: hsr_ssrep(:,:,:,:), hsi_ssrep(:,:,:,:)
      real(kind=DP) :: ctmp(3)
      complex(kind=CMPLDP) :: ztmp(3), z1, z2

      allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsi_ssrep = 0.0d0

      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, hsr, hsi, hsr_ssrep, hsi_ssrep )

      Do ia=1, natm
         it = ityp(ia)

         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               if ( is1 /= is2 ) cycle
               istmp = (is1 -1)*ndim_spinor +is2

               do lmt1=1,ilmt(it)
                  il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
                  ilmta = lmta(lmt1,ia)

                  do lmt2=1,ilmt(it)
                     il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)

                     if ( il1 <= 1 .or. il1 >4 ) cycle
                     if ( il1 /= il2 ) cycle

                     ztmp = 0.0d0
                     if ( il1 == 2 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L1( im2, im1, : )
                     else if ( il1 == 3 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L2( im2, im1, : )
                     else if ( il1 == 4 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L3( im2, im1, : )
                     endif

                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )
                     if ( sw_use_contracted_psir == ON ) then
                        z1 = z1 *product_psir_val( il1, it1, it2, it )
                     endif

                     ctmp(:) = z1*ztmp(:)

                     orb_magmom_orb_decomposed( ilmta,: ) &
                             & = orb_magmom_orb_decomposed( ilmta,: ) +ctmp(:)
                  End do
               End Do
            End do
         End do
      End Do
      deallocate( hsr_ssrep, hsi_ssrep )

    end subroutine contrib_hardpart

    subroutine contrib_hardpart_add_proj
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2, ilmta
      real(kind=DP), allocatable :: hsr_ssrep(:,:,:,:), hsi_ssrep(:,:,:,:)
      real(kind=DP) :: ctmp(3)
      complex(kind=CMPLDP) :: ztmp(3), z1, z2

      allocate( hsr_ssrep( natm, nlmt_add, nlmt_add, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt_add, nlmt_add, ndim_chgpot ) ); hsi_ssrep = 0.0d0

      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt_add, hsr_add, hsi_add, &
           &                           hsr_ssrep, hsi_ssrep )

      Do ia=1, natm
         it = ityp(ia)

         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               if ( is1 /= is2 ) cycle
               istmp = (is1 -1)*ndim_spinor +is2

               do lmt1=1,ilmt_add(it)
                  il1=ltp_add(lmt1,it); im1=mtp_add(lmt1,it); it1=1
                  ilmta = lmta_add(lmt1,ia)
                  do lmt2=1,ilmt_add(it)
                     il2=ltp_add(lmt2,it);  im2=mtp_add(lmt2,it); it2=1

                     if ( il1 <= 1 .or. il1 >4 ) cycle
                     if ( il1 /= il2 ) cycle

                     ztmp = 0.0d0
                     if ( il1 == 2 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L1( im2, im1, : )
                     else if ( il1 == 3 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L2( im2, im1, : )
                     else if ( il1 == 4 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L3( im2, im1, : )
                     endif

                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )
                     ctmp(:) = z1*ztmp(:)

                     orb_magmom_orb_decomposed_add( ilmta,: ) &
                          & = orb_magmom_orb_decomposed_add( ilmta,: ) +ctmp(:)

                  End do
               End Do
            End do
         End do
      End Do
      deallocate( hsr_ssrep, hsi_ssrep )

    end subroutine contrib_hardpart_add_proj

    subroutine print_orb_decomposed_orb_mag_1
      integer :: ia, it, il1, im1, it1, lmt1, ilmta
      integer :: nspher
      real(kind=DP), allocatable :: orb_magmom_ylm(:,:)

      if ( mype /= 0 ) return

      allocate( orb_magmom_ylm(25,3) )

      write(nfout,'(A,5X,A)') &
           &         '    id      name     l    m', &
           &         '    mx             my             mz'

      Do ia=1, natm
         it = ityp(ia)
         orb_magmom_ylm = 0.0d0

         Do lmt1=1, ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
            ilmta = lmta(lmt1,ia)

            nspher = ( il1 -1 )**2 +im1
            orb_magmom_ylm( nspher,: ) = orb_magmom_ylm( nspher,: ) &
                 &                     + orb_magmom_orb_decomposed( ilmta,: )
         End do
         if ( sw_use_add_proj == ON ) then
            Do lmt1=1, ilmt_add(it)
               il1=ltp_add(lmt1,it); im1=mtp_add(lmt1,it); it1=1
               ilmta = lmta_add(lmt1,ia)

               nspher = ( il1 -1 )**2 +im1
               orb_magmom_ylm( nspher,: ) = orb_magmom_ylm( nspher,: ) &
                    &                     + orb_magmom_orb_decomposed_add( ilmta,: )
            End do
         endif
         Do il1=1, lpsmax(it)
            Do im1=1, 2*il1 -1
               nspher = ( il1 -1 )**2 +im1
               write(nfout,'(I6,6X,A5,2I5,3F15.8)') &
                    &              ia, speciesname(it), il1 -1, im1, &
                    &              orb_magmom_ylm(nspher,1:3)
            End do
         End do
      End do

      deallocate( orb_magmom_ylm )

    end subroutine print_orb_decomposed_orb_mag_1

    subroutine print_orb_decomposed_orb_mag_2
      integer :: ia, it, il1, im1, it1, lmt1, ilmta
      integer :: nspher
      real(kind=DP) :: csum(3)
      real(kind=DP), allocatable :: orb_magmom_ylm(:,:)

      if ( mype /= 0 ) return

      allocate( orb_magmom_ylm(25,3) )

      write(nfout,'(A,5X,A)') &
           & '    id      name     l    ', &
           & '     mx             my             mz'

      Do ia=1, natm
         it = ityp(ia)
         orb_magmom_ylm = 0.0d0

         Do lmt1=1, ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
            ilmta = lmta(lmt1,ia)

            nspher = ( il1 -1 )**2 +im1
            orb_magmom_ylm( nspher,: ) = orb_magmom_ylm( nspher,: ) &
                 &                     + orb_magmom_orb_decomposed( ilmta,: )
         End do
         if ( sw_use_add_proj == ON ) then
            Do lmt1=1, ilmt_add(it)
               il1=ltp_add(lmt1,it); im1=mtp_add(lmt1,it); it1=1
               ilmta = lmta_add(lmt1,ia)

               nspher = ( il1 -1 )**2 +im1
               orb_magmom_ylm( nspher,: ) = orb_magmom_ylm( nspher,: ) &
                    &                     + orb_magmom_orb_decomposed_add( ilmta,: )
            End do
         endif
         Do il1=1, lpsmax(it)
            csum = 0.0d0
            Do im1=1, 2*il1 -1
               nspher = ( il1 -1 )**2 +im1
               csum(:) = csum(:) +orb_magmom_ylm(nspher,:)
            End do
!
            write(nfout,'(I6,6X,A5,I5,5X,3F15.8)') &
                 &              ia, speciesname(it), il1 -1, &
                 &              csum(1:3)
         End do
      End do

      deallocate( orb_magmom_ylm )

    end subroutine print_orb_decomposed_orb_mag_2

    subroutine print_orb_decomposed_orb_mag_3
      integer :: ia, it, il1, im1, it1, lmt1, ilmta
      integer :: nspher
      real(kind=DP) :: csum(3)
      real(kind=DP), allocatable :: orb_magmom_ylm(:,:)

      if ( mype /= 0 ) return

      allocate( orb_magmom_ylm(25,3) )

      write(nfout,'(A,5X,A)') &
           & '    id      name          ', &
           & '     mx             my             mz'

      Do ia=1, natm
         it = ityp(ia)
         orb_magmom_ylm = 0.0d0

         Do lmt1=1, ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
            ilmta = lmta(lmt1,ia)

            nspher = ( il1 -1 )**2 +im1
            orb_magmom_ylm( nspher,: ) = orb_magmom_ylm( nspher,: ) &
                 &                     + orb_magmom_orb_decomposed( ilmta,: )
         End do
         if ( sw_use_add_proj == ON ) then
            Do lmt1=1, ilmt_add(it)
               il1=ltp_add(lmt1,it); im1=mtp_add(lmt1,it); it1=1
               ilmta = lmta_add(lmt1,ia)

               nspher = ( il1 -1 )**2 +im1
               orb_magmom_ylm( nspher,: ) = orb_magmom_ylm( nspher,: ) &
                    &                     + orb_magmom_orb_decomposed_add( ilmta,: )
            End do
         endif

         csum = 0.0d0
         Do il1=1, lpsmax(it)
            Do im1=1, 2*il1 -1
               nspher = ( il1 -1 )**2 +im1
               csum(:) = csum(:) +orb_magmom_ylm(nspher,:)
            End do
         End do
!
         write(nfout,'(I6,6X,A5,10X,3F15.8)') &
              &              ia, speciesname(it), &
              &              csum(1:3)
      End do

      deallocate( orb_magmom_ylm )

    end subroutine print_orb_decomposed_orb_mag_3

  end subroutine m_OP_orb_decomposed_orb_magmom
! ==================== 2014/09/01

  subroutine m_OP_wd_orbmom_xsf
    character*64 file1
    integer :: lun = 4000

    integer :: i, iloop
    real(kind=DP) :: ctmp(3)

    Do iloop=1, 2
       if ( iloop == 1 ) then
          file1 = "orb_mag_moment.xsf"
       else
          file1 = "total_mag_moment.xsf"
       endif
       open( unit=lun, file=file1, status="unknown", form="formatted" )

       write(lun,'(A)') 'CRYSTAL'
       write(lun,'(A)') 'PRIMVEC'
       write(lun,'(3F20.10)') altv(1:3,1) *Bohr
       write(lun,'(3F20.10)') altv(1:3,2) *Bohr
       write(lun,'(3F20.10)') altv(1:3,3) *Bohr
       write(lun,'(A)') 'CONVVEC'
       write(lun,'(3F20.10)') altv(1:3,1) *Bohr
       write(lun,'(3F20.10)') altv(1:3,2) *Bohr
       write(lun,'(3F20.10)') altv(1:3,3) *Bohr
       write(lun,'(A)') 'PRIMCOORD'
       write(lun,*) natm, 1
       Do i=1, natm
          if ( iloop == 1 ) then
             ctmp(1:3) = OrbMag_on_atom(i,1:3)
          else
             ctmp(1:3) = RhoMag_on_atom(i,2:4) +OrbMag_on_atom(i,1:3)
          endif
          write(lun,'(I5,6F20.10)') nint(iatomn(ityp(i))), cps(i,1:3)*Bohr, ctmp(1:3)
       End Do
       close(lun)
    End Do

  end subroutine m_OP_wd_orbmom_xsf

end module m_OP_Moment

subroutine UpdateUeff()
  use m_Control_Parameters, only : printable, num_projectors,proj_attribute, nUeff, driver
  use m_Const_Parameters, only : DRIVER_URAMP
  use m_Files, only : nfout
  use m_IterationNumbers, only : iteration_uramp
  implicit none
  integer :: i
  logical :: Uramping
  if (.not.Uramping()) return
  if (printable) write(nfout,'(a,i5,a,i5)') ' !** Uramping no ',iteration_uramp,'/',nUeff
  do i=1,num_projectors
     proj_attribute(i)%Ueff = (iteration_uramp-1) * proj_attribute(i)%deltaUeff + proj_attribute(i)%initialUeff
     if(printable) write(nfout,'(a,i5,a,f10.5)') ' !** new Ueff for projector',i,':',proj_attribute(i)%Ueff
  enddo
end subroutine UpdateUeff

function InUeffRamping() result(ret)
  use m_Const_Parameters, only : DRIVER_URAMP
  use m_Control_Parameters, only : driver, nUeff
  use m_IterationNumbers, only : iteration_uramp
  implicit none
  logical :: ret
  if (driver /= DRIVER_URAMP) then
    ret = .false.
    return
  endif
  if (iteration_uramp >= nUeff) then
    ret = .false.
    return
  endif 
  ret = .true.
end function InUeffRamping

function Uramping() result(ret)
  use m_Const_Parameters, only : DRIVER_URAMP
  use m_Control_Parameters, only : driver, nUeff
  implicit none
  logical :: ret
  ret = driver == DRIVER_URAMP
end function Uramping

subroutine alloc_qitg_exx()
  use m_PseudoPotential,    only : nqitg
  use m_PlaneWaveBasisSet,  only : kgp
  use m_ES_ExactExchange,   only : nqmk, qitg_exx
  use m_Control_Parameters, only : nmax_G_hyb
  use m_Const_Parameters,   only : ON
  implicit none
#if defined(MEMORY_SAVE_EXX) && defined(MEMORY_SAVE_MORE_EXX)
  if(.not.allocated(qitg_exx)) allocate(qitg_exx(nmax_G_hyb,nqitg))
#else
  if(.not.allocated(qitg_exx)) allocate(qitg_exx(nmax_G_hyb,nqitg,nqmk))
#endif
end subroutine alloc_qitg_exx

#if defined(MEMORY_SAVE_EXX) && defined(MEMORY_SAVE_MORE_EXX)
subroutine qitgft_qmk(it,nmm_il3,mm_il3,qrsps_mm,lcmax,h)
   use m_Const_Parameters, only : DP
   use m_PseudoPotential, only : mmesh, nqitg_sp
   use m_ES_ExactExchange, only : qitgft_qmk_each_k_setup
   implicit none
   integer, intent(in) :: it
   integer, intent(in) :: nmm_il3(lcmax+1)
   integer, intent(in) :: mm_il3(nqitg_sp(it),lcmax+1)
   real(kind=DP), intent(in) :: qrsps_mm(mmesh,nqitg_sp(it))
   integer, intent(in) :: lcmax
   real(kind=DP), intent(in) :: h(it)
   call qitgft_qmk_each_k_setup(it,nmm_il3,mm_il3,qrsps_mm,lcmax,h)
   return
end subroutine qitgft_qmk
#else
subroutine qitgft_qmk(it,nmm_il3,mm_il3,qrsps_mm,lcmax,h)
  use m_Const_Parameters,   only : DP, PAI4, DELTA, ON
  use m_Control_Parameters, only : nmax_G_hyb
  use m_Crystal_Structure,  only : rltv
  use m_PlaneWaveBasisSet,  only : ngabc,kgp
  use m_PseudoPotential,    only : mmesh,nmesh,rmax,radr,wos,nqitg_sp
  use m_Parallelization,    only : MPI_CommGroup,ista_kngp,iend_kngp,npes,ierr,ista_kngp_exx,iend_kngp_exx
  use m_ES_ExactExchange,   only : nqmk, qmk, qitg_exx
  use m_Timing,             only : tstatc0_begin, tstatc0_end
  use mpi
  implicit none
  integer, intent(in) :: it
  integer, intent(in) :: nmm_il3(lcmax+1)
  integer, intent(in) :: mm_il3(nqitg_sp(it),lcmax+1)
  real(kind=DP), intent(in) :: qrsps_mm(mmesh,nqitg_sp(it))
  integer, intent(in) :: lcmax
  real(kind=DP), intent(in) :: h(it)

  integer :: mm0, i, il3, mm, mmp, n, idp, iq, ik
  real(kind=DP) :: ttr(6), kg(3)
  real(kind=DP) :: qitg_sh, g2, gabs
  real(kind=DP) :: wkx(mmesh), wky(mmesh)
  real(kind=DP), allocatable :: gqmk_l(:) ! d(ista_kngp:iend_kngp)
  real(kind=DP), allocatable :: qitg_exx_l(:,:) ! d(ista_kngp:iend_kngp,nqitg_sp(it))
  real(kind=DP), allocatable :: qitg_t(:,:) ! d(kgp,nqitg_sp(it))

  integer :: iend_kngp0

!  include 'mpif.h'                                      ! MPI

  integer,save  :: id_sname = -1
  call tstatc0_begin('qitgft_qmk ',id_sname)

  call getttr(rltv,ttr)

  allocate(qitg_exx_l(ista_kngp:iend_kngp,nqitg_sp(it))); qitg_exx_l = 0.0d0
  allocate(gqmk_l(ista_kngp:iend_kngp))

  mm0 = 0
  do i = 1, it-1
     mm0 = mm0 + nqitg_sp(i)
  end do
  iend_kngp0 = iend_kngp
  if(iend_kngp0.gt.nmax_G_hyb) iend_kngp0 = nmax_G_hyb

  do ik=1,nqmk
     do i = ista_kngp, iend_kngp0
        kg(1:3) = qmk(ik,1:3) + ngabc(i,1:3)
        g2          = ttr(1)*kg(1)*kg(1) &
        &           + ttr(2)*kg(2)*kg(2) &
        &           + ttr(3)*kg(3)*kg(3) &
        &           + ttr(4)*kg(1)*kg(2) &
        &           + ttr(5)*kg(2)*kg(3) &
        &           + ttr(6)*kg(3)*kg(1)
        gqmk_l(i) = sqrt(g2)
     end do
     do il3 = 1, lcmax+1
        if(nmm_il3(il3) <= 0) cycle
        do i = ista_kngp, iend_kngp0
           gabs = gqmk_l(i)
           if(gabs < DELTA) then
              idp = nmesh(it)+1
           else
              idp = ceiling(nmesh(it) - dlog(rmax(it)*gabs)/h(it))
           end if

! ==== ASMS ====
           if ( idp > nmesh(it) +1 ) idp = nmesh(it) +1
! ==== ASMS ====

           wkx(1:nmesh(it)) = gabs*radr(1:nmesh(it))
           call dsjnvn(il3-1,nmesh(it),idp,wkx,wky)

           do mm = 1, nmm_il3(il3)
              mmp = mm_il3(mm,il3)
              if ( mmp <= 0 ) cycle

              qitg_sh = 0.d0
              do n = 1, nmesh(it)
                 qitg_sh = qitg_sh + wos(n)*qrsps_mm(n,mmp)*wky(n)
              end do
              qitg_exx_l(i,mmp) = qitg_sh*PAI4
           end do
        end do
     end do
     if(npes>1) then
        allocate(qitg_t(nmax_G_hyb,nqitg_sp(it))); qitg_t = 0.0d0
        do iq=1,nqitg_sp(it)
           do i=ista_kngp,iend_kngp0
              qitg_t(i,iq) = qitg_exx_l(i,iq)
           end do
        end do
        call mpi_allreduce(qitg_t,qitg_exx(1,mm0+1,ik),nmax_G_hyb*nqitg_sp(it) &
         &  ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
        do iq=1,nqitg_sp(it)
           do i=ista_kngp,iend_kngp0
              qitg_exx(i,mm0+iq,ik) = qitg_t(i,iq)
           enddo
        enddo
        deallocate(qitg_t)
     else
        do iq=1,nqitg_sp(it)
           do i=1,nmax_G_hyb
              qitg_exx(i,mm0+iq,ik) = qitg_exx_l(i,iq)
           end do
        end do
     end if

  end do ! ik

  deallocate(qitg_exx_l)
  deallocate(gqmk_l)

  call tstatc0_end(id_sname)
end subroutine qitgft_qmk
#endif

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a module for setting arrays used in the BS-like equation
!  for the LR-TDDFT .
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

module m_LinearResponse_BS

  use m_Const_Parameters,   only : ON, OFF, DP, CMPLDP, PAI, PAI4, Bohr, &
       &                           TETRAHEDRON, PARABOLIC, DELTA

  use m_LinearResponse_Control,   only :  sw_NODA
  use m_LinearResponse_NonInt,   only : nband_LR, band_start_LR, band_end_LR
  use m_Parallelization,      only : mype, ierr, npes, &
       &                  ista_fftp, iend_fftp, &
       &                  ista_fftph, iend_fftph, &
       &                  np_e, ista_k, iend_k, map_e, map_z, myrank_e, &
       &                  MPI_CommGroup

  use m_Control_Parameters,  only : Num_q_Points, way_of_smearing, neg, &
       &                            ipri, nspin, printable, xctype, kimg

 use m_FFT,                  only : fft_box_size_CD, fft_box_size_CD_c, &
       &                             nfft, nfftp, &
       &                             m_FFT_CD_inverse_c, &
       &                             m_FFT_check_of_negative_CD, &
       &                             m_FFT_CD_direct_c, &
       &                             m_FFT_alloc_CD_box, &
       &                             m_FFT_dealloc_CD_box
  use m_Files,                 only : nfout
  use m_Electronic_Structure,       only : eko_ek
  use m_Crystal_Structure,    only :  rltv, univol
  use m_PlaneWaveBasisSet,    only : ngabc, igf, kg1,kg, igfp_l, kgp

  use m_LinearResponse_tools,  only  : occup_k, occup_kmq, &
       &                                  eko_k, &
       &                                    fsval_k, fsval_kmq, &
       &                                    wfn_k, wfn_kmq, &
       &                                    map_z_k, map_z_kmq, &
       &                                   nbase_k, nbase_kmq, &
       &                                   igf_k, igf_kmq, iba_k, iba_kmq

  use m_Kpoints,                    only : kv3_ek, kv3, vkxyz_ek, qwgt_ek, &
       &                                   k_symmetry, np0, np2
  use m_LinearResponse_ALDA,   only : ker_cr, igfp_LR
  use m_LinearResponse_Density,  only : RhoTilde, occup_lkt_ek

  use m_LinearResponse_Control,     only  : nrd_efermi, nstep, e, nmax_G_LR, &
       &                                    vqxyz,  &
       &                                    xc_kernel_type, RPA, ALDA_R, &
       &                                    scissor, eta, &
       &                                    sw_LongWaveLimit

  use m_LinearResponse_Kernel,       only : Kernel_Coulomb

  use m_Timing,                     only : tstatc0_begin, tstatc0_end
  use m_LinearResponse_tools,  only  : Get_WF_in_Rspace, Get_WF_in_Rspace_CD

  implicit none
  include 'mpif.h'

! ------------------------------------------ BS && ALDA_R --
  Complex(kind=CMPLDP), allocatable :: MatV(:,:), MatK(:,:), MatXi(:,:)
  Complex(kind=CMPLDP), allocatable :: MatL0(:,:,:)

contains

!------------------------------------------------------------------
!!
!!!            Alloc and Dealloc in the case of BS && ALDA_R
!!
!-------------------------------------------------------------------
 subroutine m_LR_alloc_MatK_ALDA
    integer :: matsize
    matsize = nband_LR**2

    if ( mype == 0 ) then
       allocate( MatK(matsize, matsize) ); MatK = 0.0D0
    endif
  end subroutine m_LR_alloc_MatK_ALDA

  subroutine m_LR_dealloc_MatK_ALDA
    if ( mype == 0 ) deallocate( MatK )
  end subroutine m_LR_dealloc_MatK_ALDA

  subroutine m_LR_alloc_MatV
    integer :: matsize
    matsize = nband_LR **2

    if ( mype == 0 ) then
       allocate( MatV(matsize, matsize) ); MatV = 0.0D0
    endif
  end subroutine m_LR_alloc_MatV

  subroutine m_LR_dealloc_MatV
    if ( mype == 0 ) deallocate( MatV )
  end subroutine m_LR_dealloc_MatV

  subroutine m_LR_Alloc_MatXi
    integer :: matsize
    matsize = nband_LR **2

    if ( mype == 0 ) then
       allocate( MatXi(matsize, matsize) ); MatXi = 0.0D0
    endif
  end subroutine m_LR_Alloc_MatXi

  subroutine m_LR_dealloc_MatXi
    if ( mype == 0 ) deallocate( MatXi )
  end subroutine m_LR_dealloc_MatXi

  subroutine m_LR_alloc_MatL0
    if ( mype == 0 ) then
       allocate( MatL0( nband_LR, nband_LR, nspin ) );  MatL0 = 0.0D0
    endif
  end subroutine m_LR_alloc_MatL0

  subroutine m_LR_dealloc_MatL0
    if ( mype == 0 ) deallocate( MatL0 )
  end subroutine m_LR_dealloc_MatL0

!--------------------------------------------------------
!!
!!!           Matrix K, V, Xi      for   BS && ALDA_R
!!
!---------------------------------------------------------
  subroutine Calc_MatK_ALDA
    Real(kind=DP), allocatable :: wf1_tmp(:), wf2_tmp(:), wf3_tmp(:), wf4_tmp(:)
    Real(kind=DP), allocatable ::  chg1r(:), chg1i(:)
    Real(kind=DP), allocatable ::  chg2r(:), chg2i(:)
    Real(kind=DP), allocatable :: Wfns_on_Rspace(:,:)

    integer ib1, ib2, ib3, ib4
    integer ix1, ix2

    integer ik, jk
    integer ngrid
    integer matsize
! ---------------------------------- start ---------------------
    matsize = nband_LR**2
    ngrid = product(fft_box_size_CD(1:3,1))
    ik = 1; jk = 1

    call m_FFT_alloc_CD_box()
    call set_work_arrays
! ----------------------------- main ---------------------
    Do ix1=1, matsize
       ib1 = ( ix1-1 ) /nband_LR +1
       ib2 = mod( ix1-1,nband_LR ) + 1
!
       ib1 = ib1 + band_start_LR - 1;    ib2 = ib2 + band_start_LR - 1

       if ( mype == 0 ) then
          write( nfout,* ) 'Matrix K for ', ix1, '-th element is set'
       endif
       call set_chg1
! ---
       Do ix2=1, matsize
          if ( sw_NODA == ON .and. ix1 /= ix2 ) cycle

          ib3 = ( ix2-1 ) /nband_LR +1
          ib4 = mod( ix2-1,nband_LR ) + 1

          ib3 = ib3 + band_start_LR - 1;      ib4 = ib4 + band_start_LR - 1

          call set_chg2
          call set_each_element_in_MatK
       End do
    End do
! ----------------------------- end ------------
    if ( mype == 0 ) then
       MatK = MatK * univol / dble(ngrid)
!!!!!!!!!!!!!!!!!!!!!!!       MatK = MatK*2.0d0        ! ???? bug ??
    endif
! --
    call unset_work_arrays
    call m_FFT_dealloc_CD_box()

  contains

    subroutine set_work_arrays
      integer jj
      Real*8 c1
      allocate( wf1_tmp(ista_fftp:iend_fftp) ); wf1_tmp = 0.0d0
      allocate( wf2_tmp(ista_fftp:iend_fftp) ); wf2_tmp = 0.0d0
!
      allocate( chg1r(ista_fftph:iend_fftph) ); chg1r = 0.0d0
      allocate( chg1i(ista_fftph:iend_fftph) ); chg1i = 0.0d0
      allocate( chg2r(ista_fftph:iend_fftph) ); chg2r = 0.0d0
      allocate( chg2i(ista_fftph:iend_fftph) ); chg2i = 0.0d0
!
      allocate( Wfns_on_Rspace( ista_fftp:iend_fftp, band_start_LR: band_end_LR ) );
      Wfns_on_Rspace = 0.0d0
      Do ib1 = band_start_LR, band_end_LR
         Call  Get_WF_in_Rspace_CD( ik, ib1, wfn_k, wf1_tmp, &
              &                     nbase_k, iba_k, igfp_LR, map_z_k )
         Wfns_on_Rspace( ista_fftp:iend_fftp, ib1 ) = wf1_tmp( ista_fftp:iend_fftp )
      End do
      Wfns_on_Rspace = Wfns_on_Rspace / sqrt( univol )
! ----
!      c1 = 0.0d0
!      DO jj=ista_fftph,iend_fftph
!         c1 = c1 + Wfns_on_Rspace( 2*jj-1, band_start_LR )**2 &
!              &  + Wfns_on_Rspace( 2*jj,   band_start_LR )**2
!      End do
!      write(*,*) 'c1 = ', c1, c1 / dble(iend_fftph-ista_fftph+1), c1 * univol, c1 * univol /dble(iend_fftph-ista_fftph+1)           ! c1/(iend-isa+1) == 1 deshita.
! ---------------
!             wfns_on_rspace niha sqrt(V) ga kakatteiru
!      stop
! --
    end subroutine set_work_arrays

    subroutine unset_work_arrays
      deallocate( wf1_tmp, wf2_tmp );
      deallocate( chg1r, chg1i ); deallocate( chg2r, chg2i )
      deallocate( Wfns_On_Rspace )
    end subroutine unset_work_arrays

    subroutine set_chg1
      integer ::i, ip

      wf1_tmp( ista_fftp:iend_fftp ) = Wfns_on_Rspace( ista_fftp:iend_fftp, ib1 )
      wf2_tmp( ista_fftp:iend_fftp ) = Wfns_on_Rspace( ista_fftp:iend_fftp, ib2 )
      Do i=ista_fftph, iend_fftph
         ip = 2*i-1
         chg1r(i) = wf1_tmp(ip) *wf2_tmp(ip)   + wf1_tmp(ip+1) *wf2_tmp(ip+1)
         chg1i(i) = wf1_tmp(ip) *wf2_tmp(ip+1) - wf1_tmp(ip+1) *wf2_tmp(ip)
      End do
    end subroutine set_chg1

    subroutine set_chg2
      integer ::i, ip

      wf1_tmp( ista_fftp:iend_fftp ) = Wfns_on_Rspace( ista_fftp:iend_fftp, ib3 )
      wf2_tmp( ista_fftp:iend_fftp ) = Wfns_on_Rspace( ista_fftp:iend_fftp, ib4 )
      Do i=ista_fftph, iend_fftph
         ip = 2*i-1
         chg2r(i) = wf1_tmp(ip) *wf2_tmp(ip)   + wf1_tmp(ip+1) *wf2_tmp(ip+1)
         chg2i(i) = wf1_tmp(ip) *wf2_tmp(ip+1) - wf1_tmp(ip+1) *wf2_tmp(ip)
      End do
    end subroutine set_chg2

    subroutine set_each_element_in_MatK
      integer :: i
      Complex(kind=CMPLDP) :: z1, ztmp, zsum
      Real(kind=DP) :: c1, c2

      ztmp = 0.0D0
      Do i=ista_fftph, iend_fftph
         c1 = chg1r(i)*chg2r(i) + chg1i(i)*chg2i(i)
         c2 = chg1i(i)*chg2r(i) - chg1r(i)*chg2i(i)
         z1 = dcmplx( c1,c2 )
         ztmp = ztmp + z1*ker_cr( i,ik,jk )
      End do
      if ( npes > 1 ) then
         call mpi_allreduce( ztmp, zsum, 2, MPI_DOUBLE_PRECISION, &
              &              MPI_SUM, MPI_CommGroup, ierr )
         ztmp = zsum
      endif
      if ( mype==0 ) MatK(ix1,ix2) = ztmp
    end subroutine set_each_element_in_MatK

  end subroutine Calc_MatK_ALDA

  subroutine Calc_MatV
    Complex(kind=CMPLDP), allocatable :: rho1_tmp(:,:), rho2_tmp(:,:)
    Complex(kind=CMPLDP), allocatable :: rho2_tmp_mpi(:,:)

    integer ib1, ib2, ib3, ib4
    integer ix1, ix2
    integer matsize
!
    real(kind=DP) :: ttr(6)
! ------------------------------------ start- -------
    matsize = nband_LR**2
    call set_work_arrays
    Call getttr (rltv,ttr)
! --
!!    write(*,*) 'nband_LR = ', nband_LR
!!    write(*,*) 'nmax_G_LR = ', nmax_G_LR
! --------------------------- main ----------
    Do ix1=1, matsize
       ib1 = ( ix1-1 ) /nband_LR +1
       ib2 = mod( ix1-1,nband_LR ) + 1

       ib1 = ib1 + band_start_LR - 1;     ib2 = ib2 + band_start_LR - 1

       if ( mype == 0 ) then
          write( nfout,* ) 'Matrix V for ', ix1, '-th element is set'
       endif

       call set_rho1_tmp

       Do ix2=1, matsize
          if ( sw_NODA == ON .and. ix1 /= ix2 ) cycle

          ib3 = ( ix2-1 ) /nband_LR +1
          ib4 = mod( ix2-1,nband_LR ) + 1

          ib3 = ib3 + band_start_LR - 1;     ib4 = ib4 + band_start_LR - 1

          call set_rho2_tmp
          call set_each_element_in_MatV
       End do
    End do
! -------------------------- end -----------------
    if ( mype== 0 ) then
       MatV = MatV / univol
    endif
    call unset_work_arrays
  contains

    subroutine set_work_arrays
      allocate( rho1_tmp( kg1, kv3_ek ) ); rho1_tmp = 0.0d0
      allocate( rho2_tmp( kg1, kv3_ek ) ); rho2_tmp = 0.0d0
    end subroutine set_work_arrays

    subroutine unset_work_arrays
      deallocate( rho1_tmp, rho2_tmp )
    end subroutine unset_work_arrays

    subroutine set_rho1_tmp
      integer :: jb2

      if ( map_e(ib2) == myrank_e ) then
         jb2 = map_z(ib2)
         rho1_tmp( 1:kg1, 1:kv3_ek ) = RhoTilde( 1:kg1, ib1, jb2, 1:kv3_ek )
      endif
      if ( npes > 1 ) then
         call mpi_bcast( rho1_tmp, 2*kg1*kv3_ek, MPI_DOUBLE_PRECISION, &
              &         map_e(ib2), MPI_CommGroup, ierr )
      endif
    end subroutine set_rho1_tmp

    subroutine set_rho2_tmp
      integer :: jb4

      if ( map_e(ib4) == myrank_e ) then
         jb4 = map_z(ib4)
         rho2_tmp( 1:kg1, 1:kv3_ek ) = RhoTilde( 1:kg1, ib3, jb4, 1:kv3_ek )
      endif
      if ( npes > 1 ) then
         call mpi_bcast( rho2_tmp, 2*kg1*kv3_ek, MPI_DOUBLE_PRECISION, &
              &         map_e(ib4), MPI_CommGroup, ierr )
      endif
    end subroutine set_rho2_tmp

    subroutine set_each_element_in_MatV
      integer     :: i, ig
      Real(kind=DP) :: ga, gb, gc, g2
      Complex(kind=CMPLDP) :: z1, z2, ztmp
! -
      if ( mype /= 0 ) return
!
      ztmp = 0.0d0
      Do i=2, nmax_G_LR
         z1 = rho1_tmp( i,1 );  z2 = rho2_tmp( i,1 )
         ztmp = ztmp + z1* conjg(z2) * Kernel_Coulomb(i)
      End Do
      MatV( ix1,ix2 ) = ztmp
    end subroutine set_each_element_in_MatV

  end subroutine Calc_MatV

  subroutine Calc_MatXi
    if ( mype == 0 )  then
       select case( xc_kernel_type )
       case( RPA )
          MatXi = -MatV
       case ( ALDA_R )
          MatXi = -MatK - MatV
       end select
    endif
  end subroutine Calc_MatXi

!--------------------------------------------------------
!!
!!!        Matrix L0    for   BS && ALDA_R,   LongWaveLimit
!!
!---------------------------------------------------------
  subroutine Calc_MatL0( e_value )
    real(kind=DP), intent(in) :: e_value

    real(kind=DP)         :: occ1, occ2
    complex(kind=CMPLDP)  :: omega1, omega2

    integer               :: i,j, k, ispin
    integer               :: ik1, ik2, ik3, ib1, ib2
    integer               :: k_max, nq_max
    integer :: id_sname = -1
! ------------------------------- start ------------
    if ( mype /= 0 ) return
    nq_max = 0
    call set_value_kmax
    omega1 = cmplx( e_value, eta );  omega2 = cmplx( e_value, -eta );
!
    MatL0 = 0.0d0
! -------------------------------- main -------------
    Do ispin=1, nspin
       Do k=1, k_max
          ik1 = ( nq_max +1 )*nspin*(k-1) + ispin
          ik2 = ik1 + nspin
          ik3 =  nspin*(k-1) + ispin
          !
          Do ib1=band_start_LR, band_end_LR           ! unoccpuied state
             occ1 = Occup_lkt_ek( ib1, ik1 );

             Do ib2=band_start_LR, band_end_LR          ! occupied state
                occ2 = Occup_lkt_ek( ib2, ik1 )
                call set_each_element_in_MatL0
             End do
          End do
       End do
    End do
    if ( nspin==1 ) MatL0 = MatL0 *2.0d0
! --------------------------------- end -------------
    call tstatc0_end(id_sname)

  contains

    subroutine set_value_kmax
      if ( way_of_smearing == TETRAHEDRON ) then
         k_max = np2
      else
         k_max = kv3_ek / ( nspin*( nq_max + 1 ))
      endif
    end subroutine set_value_kmax

    subroutine set_each_element_in_MatL0
      integer ::  itmp1, itmp2
      Real(kind=DP) :: ebi, ebj, ediff, c1
      Complex(kind=CMPLDP) :: zd1, zd2, z1, z2, gfn

      ebi = Eko_ek( ib1,ik1 );  ebj = Eko_ek( ib2,ik1 )
      ediff = ebi - ebj + scissor

      zd1 = omega1 - ediff;  zd2 = omega2 + ediff
      gfn = 1.0d0 / zd1 - 1.0d0 / zd2

      itmp1 = ib1 - band_start_LR +1; itmp2 = ib2 - band_start_LR +1

      c1 = ( 1.0D0 - occ1 ) *occ2
      MatL0( itmp1,itmp2,ispin ) = c1*gfn *cmplx( 0.0D0, 1.0D0 )
    end subroutine set_each_element_in_MatL0

  end subroutine Calc_MatL0

!!!!!!!!!!!!!!! DEBUG -
  subroutine Check_Charge_on_mesh
    Real(kind=DP), allocatable :: wf1_tmp(:), wf2_tmp(:), wf3_tmp(:), wf4_tmp(:)
    Real(kind=DP), allocatable :: Wfns_on_Rspace(:,:)

    Real(kind=DP) :: c1
    integer :: ik, jk
    real(kind=DP)         :: occ1
    complex(kind=CMPLDP)  :: ztmp, z1

    integer :: ngrid, nfftph
    integer               :: i, ib1
    integer :: id_sname = -1

    ngrid = product(fft_box_size_CD(1:3,1))
    nfftph = nfftp / 2
    ik = 1; jk = 1

    call m_FFT_alloc_CD_box()
    call set_work_arrays
! ----------------------------- main ---------------------
    Do i=1, nfftph
       ztmp = 0.0d0
       Do ib1=1, neg
          occ1 = Occup_lkt_ek( ib1, ik );
          if ( occ1 < Delta ) cycle
          z1 = cmplx( Wfns_On_Rspace( 2*i-1,ib1 ), Wfns_On_Rspace( 2*i,ib1 ) )
          ztmp = ztmp + occ1 *z1 *conjg(z1)
       End do
!
       if ( ker_cr(i,1,1) > 1.0E-4 ) then
          c1 = 2.0 *real(ztmp) / ker_cr(i,1,1)
          write(*,*) i, ker_cr(i,1,1), c1
       endif
    End do
! --
    call unset_work_arrays
    call m_FFT_dealloc_CD_box()

  contains

    subroutine set_work_arrays
      allocate( wf1_tmp(ista_fftp:iend_fftp) ); wf1_tmp = 0.0d0
      allocate( Wfns_on_Rspace( ista_fftp:iend_fftp, 1:neg ) );
      Wfns_on_Rspace = 0.0d0
      Do ib1 = 1, neg
         Call  Get_WF_in_Rspace_CD( ik, ib1, wfn_k, wf1_tmp, &
              &                     nbase_k, iba_k, igfp_LR, map_z_k )
         Wfns_on_Rspace( ista_fftp:iend_fftp, ib1 ) = wf1_tmp( ista_fftp:iend_fftp )
      End do
      Wfns_on_Rspace = Wfns_on_Rspace / sqrt( univol )
    end subroutine set_work_arrays

    subroutine unset_work_arrays
      deallocate( wf1_tmp )
      deallocate( Wfns_On_Rspace )
    end subroutine unset_work_arrays

  End subroutine Check_Charge_on_mesh

  subroutine Check_Exc_energy
    Real(kind=DP), allocatable :: wf1_tmp(:), wf2_tmp(:), wf3_tmp(:), wf4_tmp(:)
    Real(kind=DP), allocatable :: Wfns_on_Rspace(:,:)

    Real(kind=DP) :: c1, weight
    integer :: ik, jk
    real(kind=DP)         :: occ1
    complex(kind=CMPLDP)  :: ztmp, z1

    integer :: ngrid, nfftph
    integer               :: i, ib1
    integer :: id_sname = -1

    ngrid = product(fft_box_size_CD(1:3,1))
    nfftph = nfftp / 2
    ik = 1; jk = 1

    call m_FFT_alloc_CD_box()
    call set_work_arrays
! ----------------------------- main ---------------------
    ztmp = 0.0d0
    Do i=1, nfftph
       Do ib1=1, neg
          occ1 = Occup_lkt_ek( ib1, ik );
          if ( occ1 < Delta ) cycle
          z1 = cmplx( Wfns_On_Rspace( 2*i-1,ib1 ), Wfns_On_Rspace( 2*i,ib1 ) )
          weight = ker_cr( i,1,1 )
          ztmp = ztmp + occ1 *z1 *conjg(z1) *weight
       End do
    End do
    ! --
    write(*,*) 'Exc = ', ztmp *univol / dble(ngrid) * 2.0d0            ! OK
! ----------------------------------------------- 2.0 : spin degeneracy
! --
    call unset_work_arrays
    call m_FFT_dealloc_CD_box()

  contains

    subroutine set_work_arrays
      allocate( wf1_tmp(ista_fftp:iend_fftp) ); wf1_tmp = 0.0d0
      allocate( Wfns_on_Rspace( ista_fftp:iend_fftp, 1:neg ) );
      Wfns_on_Rspace = 0.0d0
      Do ib1 = 1, neg
         Call  Get_WF_in_Rspace_CD( ik, ib1, wfn_k, wf1_tmp, &
              &                     nbase_k, iba_k, igfp_LR, map_z_k )
         Wfns_on_Rspace( ista_fftp:iend_fftp, ib1 ) = wf1_tmp( ista_fftp:iend_fftp )
      End do
      Wfns_on_Rspace = Wfns_on_Rspace / sqrt( univol )
    end subroutine set_work_arrays

    subroutine unset_work_arrays
      deallocate( wf1_tmp )
      deallocate( Wfns_On_Rspace )
    end subroutine unset_work_arrays

  End subroutine Check_Exc_energy

! --
  subroutine Print_MatK
    integer ib1, ib2, ib3, ib4
    integer ix1, ix2
    integer matsize
!
    matsize = nband_LR**2
! --------------------------- main ----------
    Do ix1=1, matsize
       ib1 = ( ix1-1 ) /nband_LR +1
       ib2 = mod( ix1-1,nband_LR ) + 1

       ib1 = ib1 + band_start_LR - 1;     ib2 = ib2 + band_start_LR - 1

!!!!       if ( ib1 == band_start_LR .and. ib2 == band_end_LR ) then
          if ( mype == 0 ) then
             write(*,*) 'K element = ', ib1, ib2, MatK( ix1,ix1 )
          endif
!!!       endif
    End do
   if ( npes > 1 ) call mpi_barrier( MPI_CommGroup,ierr )
  end subroutine Print_MatK

  subroutine Print_MatV
    integer ib1, ib2, ib3, ib4
    integer ix1, ix2
    integer matsize
!
    matsize = nband_LR**2
! --------------------------- main ----------
    Do ix1=1, matsize
       ib1 = ( ix1-1 ) /nband_LR +1
       ib2 = mod( ix1-1,nband_LR ) + 1

       ib1 = ib1 + band_start_LR - 1;     ib2 = ib2 + band_start_LR - 1

!!       if ( ib1 == band_start_LR .and. ib2 == band_end_LR ) then
          if ( mype == 0 ) then
             write(*,*) 'V element = ', ib1, ib2, MatV( ix1,ix1 )
          endif
!!!!       endif
    End do
    if ( npes > 1 ) call mpi_barrier( MPI_CommGroup,ierr )
  end subroutine Print_MatV
! -----------------
end module m_LinearResponse_BS

#define NEC_TUNE
!#undef NEC_TUNE
! AAS for Modified Davidson and Modified Kosugi
module m_ES_WF_by_ModifiedDavidson
#ifdef TRANSPOSE
#ifdef VPP
#define _ODD_BOUNDARY_
#endif
#ifdef SX
#define _ODD_BOUNDARY_
#endif
#ifdef NEC_TUNE1
#define _ODD_BOUNDARY_
#endif
#ifdef MPI_FFTW
  use, intrinsic :: iso_c_binding
#endif
  use m_Const_Parameters,    only : DP,SP,DIRECT,ON,OFF,SCF,GAMMA,OTHER_BANDS,SKIP,EXECUT,ELECTRON, OLD
  use m_Parallelization,     only : MPI_CommGroup &
       &                          , myrank_e,myrank_k,map_e,map_k,ista_e,iend_e,istep_e &
       &                          , ista_k,iend_k,np_g1k,ista_g1,mpi_k_world,ierr,map_z &
       &                          , np_e,npes,nrank_e,mype,nrank_g, ista_spin, iend_spin
  use m_Control_Parameters,  only : nspin,ipridavidson,kimg,neg,af,npartition_david &
       &                          , delta_eig_empty &
       &                          , delta_eig_occup &
       &                          , eps_mdkosugi, eps_residual_mdkosugi, sw_fft_xzy &
       &                          , max_iter_david, sw_MRCV_only,eps_david &
       &                          , nblocksize_fftw, nblocksize_fftw_is_given &
       &                          , sw_serial_fft &
       &                          , sw_keep_hloc_phi &
#ifdef SAVE_FFT_TIMES
       &                          , sw_divide_subspace, sw_save_fft, sw_hybrid_functional
#else
       &                          , sw_divide_subspace, sw_hybrid_functional
#endif
#ifdef MPI_FFTW
  use m_Control_Parameters,  only : sw_mpi_fftw
#endif
  use m_Files,               only : nfout
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_FFT,                 only : nfft,fft_box_size_WF, m_FFT_Vlocal_W_3D, m_FFT_Direct_3D &
#ifdef FFT_3D_DIVISION
 &                                , m_FFT_Vlocal_W_3DIV_3D, m_FFT_Direct_3DIV_3D             &
#endif
 &                                , m_FFT_Direct_XYZ_3D
#ifdef MPI_FFTW
  use m_FFT,                 only : m_FFT_Vlocal_W_mpifftw, m_FFT_Direct_MPI_FFTW, afft_mpifftw, bfft_mpifftw &
                                  , m_FFT_Vlocal_W_mpifftw3d, afft_mpifftw_vlocal
#endif
  use m_ES_WF_by_SDorCG,     only : map_fft_to_WF_3D
#ifdef MPI_FFTW
  use m_ES_WF_by_SDorCG,     only : map_fft_to_WF_mpifftw, gen_fft_to_WF_map
  use m_Electronic_Structure, only : m_ES_fftbox_map
#endif
  use m_Kpoints,             only : kv3,vkxyz, k_symmetry
  use m_PlaneWaveBasisSet,   only : kg1, iba, igf, nbase, m_pwBS_kinetic_energies
  use m_Electronic_Structure,only : zaj_l, neordr, nrvf_ordr, eko_l, vlhxcQ &
       &                          , occup_l &
       &                          , fsr_l,fsi_l, vnlph_l, vlhxc_l &
       &                          , m_ES_gather_f_3d_to_2d_k &
       &                          , m_ES_gather_f_3d_to_2d &
#ifdef SAVE_FFT_TIMES
       &                          , status_saved_phifftr &
#endif
       &                          , m_ES_Vlocal_in_Rspace_3D &
       &                          , m_ES_WF_in_Rspace_3D &
       &                          , m_ES_wd_zaj_small_portion_3D &
       &                          , m_ES_wd_eko_3D &
       &                          , m_ES_sort_eigen_values_3D &
       &                          , m_ES_WF_2D &
       &                          , hlocphi_l, vtau_l
#ifdef MPI_FFTW
  use m_Electronic_Structure,only : m_ES_WF_in_Rspace_mpifftw, m_ES_Vlocal_in_Rspace_mpifftw, m_ES_Vlocal_in_Rspace_mpifftw3d
#endif
  use m_ES_ortho,           only : np_g1k_x                                          &
       &                         , m_ES_orthogonal_phi_to_WFs
  use m_ES_nonlocal,        only : m_ES_Vnonlocal_W_3D                               &
       &                         , m_ES_betar_dot_WFs_4_each_k_3D                    &
       &                         , m_ES_alloc_scss_etc_3D                            &
       &                         , m_ES_dealloc_scss_etc                             &
       &                         , m_ES_betar_dot_Psi_4_each_k_3D
  use m_Ionic_System,       only : natm, iwei, ityp, ntyp
  use m_PseudoPotential,    only : ilmt,nlmta,lmta,q,dion &
       &                         , lmtt,ltp,mtp &
       &                         , m_PP_include_vanderbilt_pot &
       &                         , ipaw,dion_paw,modnrm
  use m_NonLocal_Potential, only : snl
  use m_Parallelization,    only : nel_fft_x , nel_fft_y, nel_fft_z        &
       &                         , fft_X_x_nel, fft_X_y_nel, fft_X_z_nel   &
       &                         , mp_g1k, myrank_g                        &
       &                         , ista_g1k, iend_g1k, neg_g, mpi_ke_world &
       &                         , mpi_kg_world            &
       &                         , np_fs, myrank_g, nis_fs
#ifdef NEC_TUNE
  use m_Parallelization,    only : ista_atm, iend_atm, ista_fs, iend_fs, np_fs
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
use mod_timer
#endif
! === TIMERTIMERTIMER ==========================================================


!!$! ============================== added by K. Tagami ================== 11.0
!!$  use m_Const_Parameters,   only : CMPLDP, Neglected
!!$  use m_Control_Parameters,  only : ndim_spinor, noncol, ndim_chgpot, SpinOrbit_mode, &
!!$       &                            sw_hubbard
!!$  use m_PseudoPotential,     only : q_noncl, dion_scr_noncl
!!$!  use m_Electronic_Structure,  only : m_ES_Vlocal_in_Rspace_noncl
!!$
!!$!  use m_FFT,                 only : m_FFT_Vlocal_W_noncl
!!$!  use m_ES_ortho,              only : m_ES_orthogonl_SD_to_WFs_noncl
!!$!  use m_Electronic_Structure,      only : m_ES_sort_eigen_vals_noncl
!!$! ==================================================================== 11.0

  use m_ES_ExactExchange, only : m_ES_Vexx_W,m_ES_EXX_potential &
     , m_ES_EXX_gather_valence_states

  use m_Control_Parameters,  only : use_metagga, vtau_exists
  use m_ES_WF_by_SDorCG,     only : m_ES_contrib_kindens_to_vnlph, &
       &                            m_ES_kindens_to_vnlph_ib, m_ES_kindens_to_vnlph_ib2
#ifdef MPI_FFTW
  use m_ES_WF_by_SDorCG,     only : m_ES_con_kindens_to_vnlph_mpfw, &
       &                            m_ES_kindens_to_vnlph_ib_mpfw, &
       &                            m_ES_kindens_to_vnlph_ib2_mpfw
#endif
  use mpi

  implicit none
  integer, private, parameter                         :: sw_timing_2ndlevel = ON

  private

  integer, allocatable, dimension(:) :: nsize_subspace, nsize_matrix
  integer, allocatable, dimension(:) :: ista_e_l,iend_e_l,ielm_e_l
  integer :: nsize_sb_now, nsize_mt_now, nsize_mt_old,msize_matrix
  integer :: nblock,msize_subspace
  real(kind=DP), allocatable, target, dimension(:) :: w1hw2,w1hw2_mpi
  real(kind=DP), allocatable, target, dimension(:) :: w1sw2,w1sw2_mpi
  real(kind=DP), allocatable, target, dimension(:,:,:,:) :: zat_l
  real(kind=DP), allocatable, target, dimension(:,:,:,:) :: zah_l
  real(kind=DP), allocatable, target, dimension(:,:,:) :: fsr,fsi
  real(kind=DP), pointer, dimension(:,:,:) :: fsr_p,fsi_p
  real(kind=DP), allocatable, target, dimension(:,:,:) :: fsr_t,fsi_t
  real(kind=DP), allocatable, dimension(:,:,:) :: fsr_mpi,fsi_mpi
  real(kind=DP), pointer, dimension(:,:,:,:) :: zat_l_p, zah_l_p
  real(kind=DP), allocatable, target, dimension(:,:,:,:) :: zat_l_t,zah_l_t
  logical, allocatable, target, dimension(:)   :: feigconv_t
  logical, allocatable, dimension(:)   :: feigconv_mpi
  logical, pointer, dimension(:)   :: feigconv_p
  real(kind=DP), allocatable, dimension(:,:,:) :: zajold_l
  real(kind=DP), allocatable, dimension(:,:,:) :: zaj_l_backup
  real(kind=DP), allocatable, dimension(:,:) :: fsrold_l,fsiold_l
  real(kind=DP), allocatable, dimension(:,:,:,:):: wfsd_l  !d(kg1,np_e,ik:ik,kimg)
  real(kind=DP), allocatable, dimension(:,:,:)  :: bsdr_l, bsdi_l !d(np_e,nlmta,1)
  real(kind=DP) :: eps_residual
  logical, allocatable, target, dimension(:)   :: feigconv
  integer, allocatable, dimension(:,:) :: ibover

  real(kind=DP), allocatable,dimension(:) ::     eko_d
  real(kind=DP), allocatable,dimension(:) ::     eko_d_mpi
  integer, allocatable,dimension(:) ::     occup

  public :: m_ESmddavid_Renew_WF
  public :: m_ESmddavid_Subspace_Rotation

! --------------------
! non-collinear
! --------------------
  real(kind=DP), allocatable, dimension(:,:,:,:,:) :: zat_l_noncl
  real(kind=DP), allocatable, dimension(:,:,:,:,:) :: zah_l_noncl
  real(kind=DP), allocatable, dimension(:,:,:,:) :: fsr_noncl, fsi_noncl
  real(kind=DP), allocatable, dimension(:,:,:,:) :: zaj_l_backup_noncl
!
  real(kind=DP), allocatable, dimension(:,:,:,:) :: zajold_l_noncl
  real(kind=DP), allocatable, dimension(:,:,:) :: fsrold_l_noncl,fsiold_l_noncl

! --------------------
! meta-gga
! --------------------
  real(kind=DP), allocatable :: cfft_l(:)
  real(kind=DP), allocatable :: cfft_mpifftw_vlocal(:,:,:)


  integer :: icountocc,icountuocc
  real(kind=DP), allocatable, dimension(:,:) :: eko_l_old

#ifdef MPI_FFTW
  include 'fftw3-mpi.f03'
#endif
!  include 'mpif.h'

contains

  subroutine SD_direction_3D( precon, ik, ibo, ekin_l, p_l, itot, lsize, &
       &                      ng, vexx, vtau_phl, VlocalW )
    integer     , intent(in)                   :: precon,ik,ibo,itot
    real(kind=DP), intent(in), dimension(maxval(np_g1k))  :: ekin_l
!!#ifdef FFT_3D_DIVISION
!!    real(kind=DP), intent(in), dimension(lsize*2   ,1) :: VlocalW
!!#else
!!    real(kind=DP), intent(in), dimension(lsize*kimg,1) :: VlocalW
!!#endif
    real(kind=DP)             , dimension(maxval(np_g1k))  :: p_l
    integer, intent(in) :: lsize,ng
    real(kind=DP), dimension(ng,kimg), intent(in) :: vexx
    real(kind=DP), intent(in), optional :: vtau_phl(maxval(np_g1k),kimg)

#ifdef FFT_3D_DIVISION
    real(kind=DP), intent(in), optional, dimension(lsize*2   ,1) :: VlocalW
#else
    real(kind=DP), intent(in), optional, dimension(lsize*kimg,1) :: VlocalW
#endif

    integer       :: i, ib, iadd
    real(kind=DP) :: devr,denom, e1, devi, norm, eko
    integer :: id_sname = -1

!   ib = map_z(ibo)                                  ! MPI
    call tstatc0_begin('SD_direction_3D ',id_sname)
    ib = ibo
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    norm = 0.d0
    eko = eko_l(ib,ik)

    if(itot==1) then
       if(sw_keep_hloc_phi==ON) then
          if(kimg == 1) then
             do i=ista_g1k(ik),iend_g1k(ik)
                iadd = i - ista_g1k(ik) + 1
                zah_l(iadd,ib,1,1) = hlocphi_l(iadd,ib,ik,1)
             enddo
             if(sw_hybrid_functional==ON) then
                zah_l(:,ib,1,1) = zah_l(:,ib,1,1) + vexx(:,1)
             endif
             if( use_metagga .and. vtau_exists ) then
                zah_l(:,ib,1,1) = zah_l(:,ib,1,1) +vtau_phl(:,1)
             endif
          else
             do i=ista_g1k(ik),iend_g1k(ik)
                iadd = i - ista_g1k(ik) + 1
                zah_l(iadd,ib,1,   1)= hlocphi_l(iadd,ib,ik,1)
                zah_l(iadd,ib,kimg,1)= hlocphi_l(iadd,ib,ik,kimg)
             enddo
             if(sw_hybrid_functional==ON) then
                zah_l(:,ib,1,1) = zah_l(:,ib,1,1) + vexx(:,1)
                zah_l(:,ib,kimg,1) = zah_l(:,ib,kimg,1) + vexx(:,kimg)
             endif
             if( use_metagga .and. vtau_exists ) then
                zah_l(:,ib,1,1)    = zah_l(:,ib,1,1)    +vtau_phl(:,1)
                zah_l(:,ib,kimg,1) = zah_l(:,ib,kimg,1) +vtau_phl(:,kimg)
             endif
          endif
       else
          if(kimg == 1) then
             do i = ista_g1k(ik), iend_g1k(ik)
                iadd = i - ista_g1k(ik) + 1
                devr  = ekin_l(iadd)*zaj_l(iadd,ib,ik,1)&
                     & + VlocalW(iadd,1)*denom
                zah_l(iadd,ib,1,1) = devr
             end do
             if(sw_hybrid_functional==ON) then
                zah_l(:,ib,1,1) = zah_l(:,ib,1,1) + vexx(:,1)
             endif
             if( use_metagga .and. vtau_exists ) then
                zah_l(:,ib,1,1) = zah_l(:,ib,1,1) + vtau_phl(:,1)
             endif
          else if(kimg == 2) then
             do i = ista_g1k(ik), iend_g1k(ik)
                iadd = i - ista_g1k(ik) + 1
                e1    = ekin_l(iadd)
                devr  = e1*zaj_l(iadd,ib,ik,1) + VlocalW(2*iadd-1,1)*denom
                devi  = e1*zaj_l(iadd,ib,ik,2) + VlocalW(2*iadd,  1)*denom
                zah_l(iadd,ib,1,   1) = devr
                zah_l(iadd,ib,kimg,1) = devi
             end do
             if(sw_hybrid_functional==ON) then
                zah_l(:,ib,1,1) = zah_l(:,ib,1,1) + vexx(:,1)
                zah_l(:,ib,kimg,1) = zah_l(:,ib,kimg,1) + vexx(:,kimg)
             endif
             if( use_metagga .and. vtau_exists ) then
                zah_l(:,ib,1,1)    = zah_l(:,ib,1,1)    + vtau_phl(:,1)
                zah_l(:,ib,kimg,1) = zah_l(:,ib,kimg,1) + vtau_phl(:,kimg)
             endif
          endif
       endif
    endif

    if(kimg == 1) then
       do i = ista_g1k(ik), iend_g1k(ik)
          iadd = i - ista_g1k(ik) + 1
          devr = zah_l(iadd,ib,1,1)+vnlph_l(iadd,ib,1) - eko*zaj_l(iadd,ib,ik,1)
          if(sw_hybrid_functional==ON) devr = devr-vexx(iadd,1)
          if( use_metagga .and. vtau_exists ) then
             devr = devr -vtau_phl(iadd,1)
          endif
          wfsd_l(iadd,ib,ik,1) = - devr
          norm = norm + devr*devr
       end do
    else if(kimg == 2) then
       do i = ista_g1k(ik), iend_g1k(ik)
          iadd = i - ista_g1k(ik) + 1
          e1    = ekin_l(iadd) - eko
          devr = zah_l(iadd,ib,1,1)+vnlph_l(iadd,ib,1) - eko*zaj_l(iadd,ib,ik,1)
          devi = zah_l(iadd,ib,2,1)+vnlph_l(iadd,ib,2) - eko*zaj_l(iadd,ib,ik,2)
          if(sw_hybrid_functional==ON) then
            devr = devr-vexx(iadd,1)
            devi = devi-vexx(iadd,2)
          endif
          if( use_metagga .and. vtau_exists ) then
             devr = devr -vtau_phl(iadd,1)
             devi = devi -vtau_phl(iadd,2)
          endif
          wfsd_l(iadd,ib,ik,1) = - devr
          wfsd_l(iadd,ib,ik,2) = - devi
          norm = norm + devr*devr + devi*devi
       end do
       if(k_symmetry(ik) == GAMMA) then
          if(ista_g1k(ik) == 1) then
             devr=wfsd_l(1,ib,ik,1)
             devi=wfsd_l(1,ib,ik,2)
             norm = norm*2.d0 - devr*devr - devi*devi
          end if
       end if
    end if
    call mpi_allreduce(MPI_IN_PLACE,norm,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)

!    feigconv(ib)=.false.
!    if(sqrt(norm) .lt. eps_residual) feigconv(ib)=.true.

    if(precon==ON) then
      call decide_precon_factor_wfsd_3D(ik,ibo,ekin_l,p_l)
!call decide_precon_factor_david(ik,hdiag,sdiag,eko_l(ib,ik),p)
      if(kimg == 1) then
         do i = ista_g1k(ik), iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            wfsd_l(iadd,ib,ik,1) = p_l(iadd)*wfsd_l(iadd,ib,ik,1)
         end do
      else if(kimg == 2) then
         do i = ista_g1k(ik), iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            wfsd_l(iadd,ib,ik,1) = p_l(iadd)*wfsd_l(iadd,ib,ik,1)
            wfsd_l(iadd,ib,ik,2) = p_l(iadd)*wfsd_l(iadd,ib,ik,2)
         end do
      end if
    end if
    call tstatc0_end(id_sname)
  end subroutine SD_direction_3D

  subroutine SD_direction_3D2( precon, ik, ib1, ib2, ibesize, ekin_l, p_l, &
       &                       itot, lsize, ng, vexx, vtau_phl, VlocalW )
    integer     , intent(in)                   :: precon,ik,ib1,ib2,ibesize,itot
    real(kind=DP), intent(in), dimension(maxval(np_g1k))  :: ekin_l
    real(kind=DP)             , dimension(maxval(np_g1k))  :: p_l
    integer, intent(in) :: lsize,ng
    real(kind=DP), dimension(ng,kimg), intent(in) :: vexx
    real(kind=DP), intent(in), optional :: vtau_phl(maxval(np_g1k),kimg)
#ifdef FFT_3D_DIVISION
    real(kind=DP), intent(in), optional, dimension(lsize*2   ,1) :: VlocalW
#else
    real(kind=DP), intent(in), optional, dimension(lsize*kimg,1) :: VlocalW
#endif

    integer       :: i, ib, iadd
    real(kind=DP) :: devr,denom, e1, devi, norm
    real(kind=DP),allocatable,dimension(:) :: normb
    integer :: id_sname = -1

    call tstatc0_begin('SD_direction_3D ',id_sname)
!   ib = map_z(ibo)                                  ! MPI
!!$    ib = ibo
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
!!$    norm = 0.d0
    allocate(normb(ib1:ib2)); normb = 0.d0

    if(itot==1) then
       if(sw_keep_hloc_phi==ON) then
          if(kimg == 1) then
             do ib=ib1,ib2
                do i=ista_g1k(ik),iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   zah_l(iadd,ib,1,1) = hlocphi_l(iadd,ib,ik,1)
                enddo
                if(sw_hybrid_functional==ON) then
                   zah_l(:,ib,1,1) = zah_l(:,ib,1,1) + vexx(:,1)
                endif
                if( use_metagga .and. vtau_exists ) then
                   zah_l(:,ib,1,1) = zah_l(:,ib,1,1) + vtau_phl(:,1)
                endif
             enddo
          else
             do ib=ib1,ib2
                do i=ista_g1k(ik),iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   zah_l(iadd,ib,1,   1)= hlocphi_l(iadd,ib,ik,1)
                   zah_l(iadd,ib,kimg,1)= hlocphi_l(iadd,ib,ik,2)
                enddo
                if(sw_hybrid_functional==ON) then
                   zah_l(:,ib,1,1) = zah_l(:,ib,1,1) + vexx(:,1)
                   zah_l(:,ib,kimg,1) = zah_l(:,ib,kimg,1) + vexx(:,kimg)
                endif
                if( use_metagga .and. vtau_exists ) then
                   zah_l(:,ib,1,1)    = zah_l(:,ib,1,1)    + vtau_phl(:,1)
                   zah_l(:,ib,kimg,1) = zah_l(:,ib,kimg,1) + vtau_phl(:,kimg)
                endif
             enddo
          endif
       else
          if(kimg == 1) then
             do ib=ib1,ib2
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   devr  = ekin_l(iadd)*zaj_l(iadd,ib,ik,1)&
                        & + VlocalW(iadd,1)*denom
                   zah_l(iadd,ib,1,1) = devr
                end do
                if(sw_hybrid_functional==ON) then
                   zah_l(:,ib,1,1) = zah_l(:,ib,1,1) + vexx(:,1)
                endif
                if( use_metagga .and. vtau_exists ) then
                   zah_l(:,ib,1,1) = zah_l(:,ib,1,1) + vtau_phl(:,1)
                endif
             enddo
          else if(kimg == 2) then
             do ib=ib1,ib2
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   e1    = ekin_l(iadd)
                   devr  = e1*zaj_l(iadd,ib,ik,1) + VlocalW(2*iadd-1,1)*denom
                   devi  = e1*zaj_l(iadd,ib,ik,2) + VlocalW(2*iadd,  1)*denom
                   zah_l(iadd,ib,1,   1) = devr
                   zah_l(iadd,ib,kimg,1) = devi
                end do
                if(sw_hybrid_functional==ON) then
                   zah_l(:,ib,1,1) = zah_l(:,ib,1,1) + vexx(:,1)
                   zah_l(:,ib,kimg,1) = zah_l(:,ib,kimg,1) + vexx(:,kimg)
                endif
                if( use_metagga .and. vtau_exists ) then
                   zah_l(:,ib,1,1)    = zah_l(:,ib,1,1)    + vtau_phl(:,1)
                   zah_l(:,ib,kimg,1) = zah_l(:,ib,kimg,1) + vtau_phl(:,kimg)
                endif
             enddo
          endif
       endif
    endif

    if(kimg == 1) then
       do i = ista_g1k(ik), iend_g1k(ik)
          iadd = i - ista_g1k(ik) + 1
          do ib = ib1, ib2
             devr  = zah_l(iadd,ib,1,1) + vnlph_l(iadd,ib,1)-eko_l(ib,ik)*zaj_l(iadd,ib,ik,1)
             if(sw_hybrid_functional==ON) then
                devr = devr - vexx(i,1)
             endif
             if( use_metagga .and. vtau_exists ) then
                devr = devr - vtau_phl(i,1)
             endif
             wfsd_l(iadd,ib,ik,1) = - devr
             normb(ib) = normb(ib) + devr*devr
          end do
       end do
    else if(kimg == 2) then
       do i = ista_g1k(ik), iend_g1k(ik)
          iadd = i - ista_g1k(ik) + 1
          do ib = ib1, ib2
             devr = zah_l(iadd,ib,1,1)+vnlph_l(iadd,ib,1) - eko_l(ib,ik) * zaj_l(iadd,ib,ik,1)
             devi = zah_l(iadd,ib,2,1)+vnlph_l(iadd,ib,2) - eko_l(ib,ik) * zaj_l(iadd,ib,ik,2)
             if(sw_hybrid_functional==ON) then
                devr = devr - vexx(i,1)
                devi = devi - vexx(i,2)
             endif
             if( use_metagga .and. vtau_exists ) then
                devr = devr - vtau_phl(i,1)
                devi = devi - vtau_phl(i,2)
             endif
             wfsd_l(iadd,ib,ik,1) = - devr
             wfsd_l(iadd,ib,ik,2) = - devi
             normb(ib) = normb(ib) + devr*devr + devi*devi
          end do
       end do
       if(k_symmetry(ik) == GAMMA) then
          if(ista_g1k(ik) == 1) then
             do ib = ib1, ib2
                devr=wfsd_l(1,ib,ik,1)
                devi=wfsd_l(1,ib,ik,2)
                normb(ib) = normb(ib)*2.d0 - devr*devr - devi*devi
             end do
          end if
       end if
    end if
    call mpi_allreduce(MPI_IN_PLACE,normb,ib2-ib1+1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)

    do ib = ib1, ib2
!       feigconv(ib)=.false.
!       if(sqrt(normb(ib)) .lt. eps_residual) feigconv(ib)=.true.

       if(precon==ON) then
!!$      call decide_precon_factor_wfsd_3D(ik,ibo,ekin_l,p_l)
          call decide_precon_factor_wfsd_3D(ik,ib,ekin_l,p_l)
!call decide_precon_factor_david(ik,hdiag,sdiag,eko_l(ib,ik),p)
          if(kimg == 1) then
             do i = ista_g1k(ik), iend_g1k(ik)
                iadd = i - ista_g1k(ik) + 1
                wfsd_l(iadd,ib,ik,1) = p_l(iadd)*wfsd_l(iadd,ib,ik,1)
             end do
          else if(kimg == 2) then
             do i = ista_g1k(ik), iend_g1k(ik)
                iadd = i - ista_g1k(ik) + 1
                wfsd_l(iadd,ib,ik,1) = p_l(iadd)*wfsd_l(iadd,ib,ik,1)
                wfsd_l(iadd,ib,ik,2) = p_l(iadd)*wfsd_l(iadd,ib,ik,2)
             end do
          end if
       end if
    end do
    deallocate(normb)
    call tstatc0_end(id_sname)
  end subroutine SD_direction_3D2

  subroutine decide_precon_factor_wfsd_3D(ik,ibo,ekin_l,p_l)
    integer, intent(in)                         :: ik,ibo
    real(kind=DP), intent(in),  dimension(maxval(np_g1k))  :: ekin_l
    real(kind=DP), intent(out), dimension(maxval(np_g1k))  :: p_l

    integer       :: i, iadd
    real(kind=DP) :: ektot, x, x1, x2, d_ektot

!    call kinetic_energy_wfsd(ik,ibo,ekin,ektot)   ! -here
    call kinetic_energy_3D(ik,ibo,ekin_l,ektot)   ! -here
    d_ektot = 4.d0/ektot/3.d0
    p_l = 0.d0
    do i = ista_g1k(ik), iend_g1k(ik)
       iadd = i - ista_g1k(ik) + 1
       x = ekin_l(iadd)*d_ektot
       x1 = (x*x+9.d0)*(x+3.d0)
       x2 = (x*x)*(x*x)
       p_l(iadd)  = x1/(x1 + x2 )
    end do
!    p=p*d_ektot
  end subroutine decide_precon_factor_wfsd_3D

  subroutine kinetic_energy_wfsd(ik,ibo,dekin,ektot)
    integer, intent(in) :: ik, ibo
    real(kind=DP), intent(in), dimension(kg1)  :: dekin
    real(kind=DP), intent(out)                 :: ektot
    integer  :: i, ri, ib
    ektot = 0.d0
    ib=map_z(ibo)
    do ri = 1, kimg
       do i = 1, iba(ik)
          ektot = ektot + dekin(i)*wfsd_l(i,ib,ik,ri)**2   ! MPI
       end do
    end do

    if(k_symmetry(ik) == GAMMA) ektot = ektot*2.d0

  end subroutine kinetic_energy_wfsd

  subroutine kinetic_energy_3D(ik,ibo,dekin,ektot)
    integer, intent(in) :: ik, ibo
    real(kind=DP), intent(in), dimension(maxval(np_g1k)) :: dekin
    real(kind=DP), intent(out)                 :: ektot
    integer  :: i, ib, iadd
    ektot = 0.d0
!   ib = map_z(ibo)
    ib = ibo
    if(kimg == 1) then
       do i = ista_g1k(ik), iend_g1k(ik)
          iadd = i - ista_g1k(ik) + 1
          ektot = ektot + dekin(iadd)*zaj_l(iadd,ib,ik,1)**2
       end do
    else
       do i = ista_g1k(ik), iend_g1k(ik)
          iadd = i - ista_g1k(ik) + 1
          ektot = ektot + dekin(iadd)*( zaj_l(iadd,ib,ik,1)**2 &
               &                      + zaj_l(iadd,ib,ik,2)**2)
       end do
    end if
    call mpi_allreduce(MPI_IN_PLACE,ektot,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
    if(k_symmetry(ik) == GAMMA)  ektot = ektot*2.d0
  end subroutine kinetic_energy_3D



  subroutine normalize_wfsd_3D(ik)
    integer,intent(in) :: ik
    real(kind=DP) :: norm, wfsdr, wfsdi
    integer :: ib1,ii,ib,iadd
    integer :: id_sname=-1
    call tstatc0_begin('normalize_wfsd_3D ',id_sname)
    do ib1 = 1, np_e
!      ib=map_z(ib1)
       ib=ib1
       norm = 0.d0
       if(kimg==1) then
          do ii=ista_g1k(ik),iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             wfsdr = wfsd_l(iadd,ib,ik,kimg)
             norm = norm + wfsdr*wfsdr
          end do
          call mpi_allreduce(MPI_IN_PLACE,norm,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
          norm = 1.d0/sqrt(norm)
          do ii=ista_g1k(ik),iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             wfsd_l(iadd,ib,ik,1) = wfsd_l(iadd,ib,ik,1)*norm
          end do
!!$          bsdr_l(ib,1:nlmta,ik) = bsdr_l(ib,1:nlmta,ik)*norm
!!$          bsdi_l(ib,1:nlmta,ik) = bsdi_l(ib,1:nlmta,ik)*norm
          bsdr_l(ib,:,ik) = bsdr_l(ib,:,ik)*norm
          bsdi_l(ib,:,ik) = bsdi_l(ib,:,ik)*norm
       else
          do ii=ista_g1k(ik),iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             wfsdr = wfsd_l(iadd,ib,ik,1   )
             wfsdi = wfsd_l(iadd,ib,ik,kimg)
             norm = norm + wfsdr*wfsdr+wfsdi*wfsdi
          end do
          call mpi_allreduce(MPI_IN_PLACE,norm,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
          norm = 1.d0/sqrt(norm)
          do ii=ista_g1k(ik),iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             wfsd_l(iadd,ib,ik,1) = wfsd_l(iadd,ib,ik,1)*norm
             wfsd_l(iadd,ib,ik,2) = wfsd_l(iadd,ib,ik,2)*norm
          enddo
          if(k_symmetry(ik) == GAMMA) then
            bsdr_l(ib,:,ik) = bsdr_l(ib,:,ik)*norm
          else
            bsdr_l(ib,:,ik) = bsdr_l(ib,:,ik)*norm
            bsdi_l(ib,:,ik) = bsdi_l(ib,:,ik)*norm
          end if
       end if
    end do
    call tstatc0_end(id_sname)
  end subroutine normalize_wfsd_3D



  subroutine m_ESmddavid_Subspace_Rotation(nfout)
    integer, intent(in) :: nfout

    integer             :: ispin, ik, iksnl, switch_of_eko_part
    real(kind=DP), allocatable, dimension(:) ::  afft, bfft
    real(kind=DP), allocatable, dimension(:) :: ekin
    real(kind=DP), allocatable, dimension(:) :: afft_l
    real(kind=DP), allocatable, dimension(:,:) :: wk_bfft_l
    real(kind=DP), allocatable, dimension(:,:) :: bfft_l
    integer :: lsize, ibsize, isrsize, fft_l_size
    real(kind=DP), allocatable, dimension(:) :: ekin_l
    integer :: ipri0
    integer :: ng
    real(kind=DP), allocatable, dimension(:,:,:) :: vexx
    real(kind=DP) :: exx
#ifdef FFT_3D_DIVISION
    lsize = fft_X_x_nel*fft_X_y_nel*fft_X_z_nel
!.. allocate(afft_l(lsize*2), stat=ierr)
#else
    lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
!.. allocate(afft_l(lsize*kimg), stat=ierr)
#endif
    if(ierr /= 0) then
       write(nfout,*)' m_ESmddavid_Subspace_Rotation: Not allocated afft_l array'
       call flush(nfout)
       call mpi_abort(mpi_comm_world, 201, ierr)
    endif
    ibsize = 1

    allocate(ekin_l(maxval(np_g1k)))
    call m_ES_alloc_scss_etc_3D()
    allocate(afft(nfft)); allocate(bfft(nfft))
    call allocate_fsri_3D

    if ( use_metagga .and. vtau_exists ) then
#ifdef FFT_3D_DIVISION
       allocate(cfft_l(lsize*2) ,stat=ierr)
#else
       allocate(cfft_l(lsize*kimg) ,stat=ierr)
#endif
    endif

    do ispin = 1, nspin, (af+1)
       call m_ES_Vlocal_in_Rspace_3D(ispin,afft_l,lsize,1,OFF)      ! (ptfft1) vlhxc_l->afft
       if ( use_metagga .and. vtau_exists ) then
          call m_ES_Vlocal_in_Rspace_3D( ispin, cfft_l, lsize, 1, OFF, vtau_l ) ! r space
       endif

       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle          ! MPI
          isrsize = min(lsize,mp_g1k(ik))
          fft_l_size  = nel_fft_x(myrank_g)
#ifdef FFT_3D_DIVISION
          allocate(wk_bfft_l(lsize*2   ,ibsize) ,stat=ierr)
          allocate(bfft_l(lsize*2   ,ibsize) ,stat=ierr)
#else
          allocate(wk_bfft_l(lsize*kimg,ibsize) ,stat=ierr)
          allocate(bfft_l(lsize*kimg,ibsize) ,stat=ierr)
#endif
          if (ierr /= 0) then
             write(nfout,*)' m_ESmddavid_Subspace_Rotation:  Not allocate '
             call flush(nfout)
             call mpi_abort(mpi_comm_world, 205, ierr)
          endif
          iksnl = (ik-1)/nspin + 1

          call allocate_t_matrix_sr_3D(ik) ! -> np_g1k_x
          call m_pwBS_kinetic_energies(ik,vkxyz,ekin_l) ! (diakin) ->ekin
          call m_ES_Vnonlocal_W_3D(ik,iksnl,ispin,switch_of_eko_part=OFF) ! -> vnlph_l

          if ( use_metagga .and. vtau_exists ) &
               &           call m_ES_contrib_kindens_to_vnlph( ispin, ik, lsize, cfft_l )

          if(sw_hybrid_functional==ON) call m_ES_Vexx_W(ik)
          call allreduce_fs_sr_3D(ik) ! -> fsr,fsi
          call evolve_WFs_in_subspace_sr_3D& !-(m_ES_WF_by_ModifiedDavidson)
                                      &(ik,ispin,ekin_l,afft_l,bfft_l, &
                                        wk_bfft_l,lsize,ibsize,isrsize,fft_l_size) !-> zaj_l
          if(ik==1.and.ipridavidson>= 2) &
            & call m_ES_wd_zaj_small_portion_3D(nfout,ik," -- after davidson subspace rotation --",21)
          call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik)   ! -> fsr_l,fsi_l
          if(ipridavidson>=2) then
             write(nfout,'("Davidson Subspace Rotation: ik=",i5," subspace=",i5)') ik, nsize_sb_now
          end if
          call deallocate_t_matrix_sr
          deallocate(wk_bfft_l)
          deallocate(bfft_l)

       enddo      ! k-point loop
    enddo      ! spin loop

    call deallocate_fsri
    if ( allocated(cfft_l) ) deallocate( cfft_l )

!!  ( in case of af=1 )
    if(af /= 0) then
       call cp_eigen_values_for_af       !-(contained here)
       call expand_neordr_and_nrvf_ordr  !-(contained here)
    end if

    call get_ipri0(ipridavidson,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko_3D(nfout,mode=SCF)

    deallocate(bfft);   deallocate(afft)
    call m_ES_dealloc_scss_etc()
    deallocate(ekin_l)

  contains

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,MPI_CommGroup,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine cp_eigen_values_for_af
      integer :: ik,ib
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle    ! MPI
         do ib = 1, np_e                    ! MPI
            eko_l(ib,ik+af) = eko_l(ib,ik)
         enddo
      enddo
    end subroutine cp_eigen_values_for_af

    subroutine expand_neordr_and_nrvf_ordr
      integer :: ik
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle     ! MPI
         neordr(1:neg,ik+af) = neordr(1:neg,ik)
         nrvf_ordr(1:neg,ik+af) = nrvf_ordr(1:neg,ik)
      end do
    end subroutine expand_neordr_and_nrvf_ordr

  end subroutine m_ESmddavid_Subspace_Rotation



  subroutine allocate_fsri_3D
    nsize_sb_now = neg
    nsize_mt_now =  nsize_sb_now*(nsize_sb_now+1)/2
    allocate(fsr(neg,nlmta,1))
    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       allocate(fsi(neg,nlmta,1))
    end if
    allocate(zaj_l_backup(maxval(np_g1k),np_e,kimg)) ! MPI
  end subroutine allocate_fsri_3D

  subroutine deallocate_fsri
    deallocate(fsr)
    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       deallocate(fsi)
    end if
    deallocate(zaj_l_backup)
  end subroutine deallocate_fsri


  subroutine allocate_t_matrix_sr_3D(ik)
    integer, intent(in) :: ik
    integer :: kimg_t
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if
#ifdef _ODD_BOUNDARY_
    if(mod(np_g1k(ik),2) == 0) then
       np_g1k_x = np_g1k(ik) + 1
    else
       np_g1k_x = np_g1k(ik)
    end if
#else
    np_g1k_x = np_g1k(ik)
#endif
    allocate(zat_l(maxval(np_g1k),neg,kimg,1)) ! MPI
    allocate(zah_l(maxval(np_g1k),np_e,kimg,1)) ! MPI
    allocate(w1hw2(nsize_mt_now*kimg_t))
    allocate(w1sw2(nsize_mt_now*kimg_t))
    if(npes>1) then
       allocate(w1hw2_mpi(nsize_mt_now*kimg_t))
       allocate(w1sw2_mpi(nsize_mt_now*kimg_t))
    end if
    zaj_l_backup(:,:,:) = zaj_l(:,:,ik,:)
  end subroutine allocate_t_matrix_sr_3D

  subroutine deallocate_t_matrix_sr
! ============================ modified by K. Tagami ========== 11.0
!    deallocate(zat_l) ! MPI
!    deallocate(zah_l) ! MPI

       deallocate(zat_l) ! MPI
       deallocate(zah_l) ! MPI
! ============================================================== 11.0
    deallocate(w1hw2)
    deallocate(w1sw2)
    if(npes>1) then
       deallocate(w1hw2_mpi)
       deallocate(w1sw2_mpi)
    end if
  end subroutine deallocate_t_matrix_sr

  subroutine allreduce_fs_sr_3D(ik)
    integer, intent(in) :: ik
    integer :: ib,ib1,kimg_t,is,is1
    real(kind=DP), allocatable, dimension(:,:) :: fs_mpi

    allocate(fs_mpi(neg,nlmta))

    fs_mpi=0.d0
    do is = 1, np_fs ! MPI
       is1=nis_fs(myrank_g)+is-1
       do ib = 1, np_e ! MPI
          ib1=neg_g(ib)
          fs_mpi(ib1,is1) = fsr_l(ib,is,ik)
       end do
    end do
    call mpi_allreduce(MPI_IN_PLACE,fs_mpi,neg*nlmta &
      & ,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)       ! MPI
    fsr(1:neg,1:nlmta,1) = fs_mpi(1:neg,1:nlmta)
    if(.not. k_symmetry(ik) == GAMMA) then
       fs_mpi=0.d0
       do is = 1, np_fs ! MPI
          is1=nis_fs(myrank_g)+is-1
          do ib = 1, np_e ! MPI
             ib1=neg_g(ib)
             fs_mpi(ib1,is1) = fsi_l(ib,is,ik)
          end do
       end do
       call mpi_allreduce(MPI_IN_PLACE,fs_mpi,neg*nlmta &
         & ,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)       ! MPI
       fsi(1:neg,1:nlmta,1) = fs_mpi(1:neg,1:nlmta)
    end if
    deallocate(fs_mpi)
  end subroutine allreduce_fs_sr_3D

  subroutine evolve_WFs_in_subspace_sr_3D(ik,ispin,ekin_l,afft_l,bfft_l, &
                                          wk_bfft_l,lsize,ibsize,isrsize,fft_l_size)
    integer, intent(in) :: ik,ispin,lsize,ibsize,isrsize,fft_l_size
    real(kind=DP), intent(in)  :: ekin_l(maxval(np_g1k))
#ifdef FFT_3D_DIVISION
    real(kind=DP), intent(in)  :: afft_l(lsize*2   )
    real(kind=DP), intent(out) :: bfft_l(lsize*2   ,1)
    real(kind=DP), intent(inout) :: wk_bfft_l(lsize*2   ,ibsize)
#else
    real(kind=DP), intent(in)  :: afft_l(lsize*kimg)
    real(kind=DP), intent(out) :: bfft_l(lsize*kimg,1)
    real(kind=DP), intent(inout) :: wk_bfft_l(lsize*kimg,ibsize)
#endif
    integer :: iadd, ib2_
! (allocatable variables)
    real(kind=DP), allocatable,dimension(:) ::     eig
    real(kind=DP), allocatable,dimension(:,:) ::   vec

    integer       :: ib1,ib2,ib1to,ib2to,i1,ii,ri,ib
!    integer       :: ibb1,ibb2
!    integer       :: ii1,ii2,iter,iter1,iter2
    real(kind=DP) :: denom, eko1, eko2, ekod
    real(kind=DP) :: hr2,hi2,dr1,dr2,di1,di2,dd
    integer :: ip0,ip0b,ip1,ip1b,ib1n,ib2n,ndata,nshift,kimg_t,ig1
    integer :: noffset
!    integer :: nsize_max_sb_now
    integer :: ierr_diag
    integer :: id_sname = -1, ipri0
    call tstatc0_begin('evolve_WFs_in_subspace_sr_3D(davidson) ', id_sname,1)

    call get_ipri0(ipridavidson,ipri0)

    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if

!    nsize_sb_now = nsize_subspace(1)
!    nsize_mt_now = nsize_matrix(1)

    allocate(eig(nsize_sb_now)); eig=0.d0
    allocate(vec(nsize_sb_now*kimg_t,nsize_sb_now))
    allocate(eko_d(neg));     eko_d = 0.d0
    allocate(occup(neg)); occup=0

    if(ipridavidson >=2) then
       write(nfout,*) 'MdDavidson Subspace Rotation:ik,nsize_sb_now=', ik,nsize_sb_now
    end if


    do ib1 = 1, np_e
       eko_d(neg_g(ib1)) = eko_l(ib1,ik)  ! MPI
    end do
    call mpi_allreduce(MPI_IN_PLACE,eko_d,neg,mpi_double_precision,mpi_sum &
         & ,mpi_kg_world,ierr) ! MPI
    eko1 = sum(eko_d(1:neg))

    do ib1=1,neg
       if(map_e(ib1) == myrank_e) then !MPI
          if( occup_l(map_z(ib1),ik) > 0.d0 ) occup(ib1) = 1  ! MPI
       end if
    end do
    call mpi_allreduce(MPI_IN_PLACE,occup,neg,mpi_integer,mpi_sum &
         & ,mpi_k_world(myrank_k),ierr)       ! MPI

! (zaj_l <- (T+Vloc)|phi> )
!!    zaj_l(:,:,ik,:) = zajold_l(:,:,:,idavid)
!( tenchi ) (zat_l <- zaj_l)
    zat_l(:,:,:,1) = 0.0d0
    do ib1 = 1, np_e
       zat_l(:,neg_g(ib1),:,1) = zaj_l(:,ib1,ik,:)
    enddo
    call mpi_allreduce(MPI_IN_PLACE,zat_l(:,:,:,1),maxval(np_g1k)*neg*kimg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_kg_world,ierr)
    do ib1 = 1, np_e ! MPI
       ib = ib1 ! MPI
#ifdef __TIMER_COMM__
       call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l,0)
#else
       call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l)
#endif
#ifdef FFT_3D_DIVISION
         call m_FFT_Vlocal_W_3DIV_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_x(myrank_g))
         call m_FFT_Direct_3DIV_3D(nfout,wk_bfft_l,lsize,ibsize)
#else
         if (sw_fft_xzy > 0) then
            call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_y(myrank_g))
            call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
         else
            call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
            if(sw_serial_fft == ON) then
              call m_ES_WF_2D(ik,wk_bfft_l,ib2,ib1,ibsize,lsize,DIRECT)
            else
              call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
            endif
         end if
#endif
       call map_fft_to_WF_3D(ik,lsize,ibsize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
       if(kimg == 1) then
          do ii=ista_g1k(ik),iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             dr1 = zaj_l(iadd,ib,ik,1)
             dr2 = bfft_l(iadd,1)*denom
             zaj_l(iadd,ib,ik,1)= ekin_l(iadd)*dr1+dr2
          enddo
       else
          do ii=ista_g1k(ik),iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             dr1  = zaj_l(iadd,ib,ik,1)
             di1  = zaj_l(iadd,ib,ik,kimg)
             zaj_l(iadd,ib,ik,1)    = ekin_l(iadd)*dr1+bfft_l(2*iadd-1,1)*denom
             zaj_l(iadd,ib,ik,kimg) = ekin_l(iadd)*di1+bfft_l(2*iadd,  1)*denom
          enddo
       endif
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
    enddo
!( tenchi ) (zah_l <- zaj_l)
    zah_l(:,:,:,1) = zaj_l(:,:,ik,:)

! (make matrix elements )
! parallel loop
    ! <n|T+Vloc|m> G-wise parallel
    w1hw2 = 0.d0
    w1sw2 = 0.d0
!   do ib2 = 1,nsize_sb_now
    do ib2_ = 1, np_e
       ib2 = neg_g(ib2_)
       ip0b = ib2*(ib2-1)/2
       do ib1 = 1,ib2
          ip0 = ip0b + ib1
          if(kimg == 1) then
             do ii = ista_g1k(ik), iend_g1k(ik) ! MPI
                iadd = ii - ista_g1k(ik) + 1
                hr2 = zah_l(iadd,ib2_,1,1)
                dr2 = zat_l(iadd,ib2, 1,1)
                dr1 = zat_l(iadd,ib1, 1,1)
                w1hw2(ip0) = w1hw2(ip0) + dr1*hr2
                w1sw2(ip0) = w1sw2(ip0) + dr1*dr2
             end do
          else
             if(k_symmetry(ik) == GAMMA) then
                do ii = max(ista_g1k(ik),2), iend_g1k(ik) ! MPI
                   iadd = ii - ista_g1k(ik) + 1
                   hr2 = zah_l(iadd,ib2_,1,1) ! MPI
                   hi2 = zah_l(iadd,ib2_,2,1) ! MPI
                   dr2 = zat_l(iadd,ib2, 1,1) ! MPI
                   di2 = zat_l(iadd,ib2, 2,1) ! MPI
                   dr1 = zat_l(iadd,ib1, 1,1) ! MPI
                   di1 = zat_l(iadd,ib1, 2,1) ! MPI
                   w1hw2(ip0) =w1hw2(ip0)+(dr1*hr2+di1*hi2)*2.d0
                   w1sw2(ip0) =w1sw2(ip0)+(dr1*dr2+di1*di2)*2.d0
                end do
                if(ista_g1k(ik) == 1) then
                   hr2 = zah_l(1,ib2_,1,1) ! MPI
                   hi2 = zah_l(1,ib2_,2,1) ! MPI
                   dr2 = zat_l(1,ib2, 1,1) ! MPI
                   di2 = zat_l(1,ib2, 2,1) ! MPI
                   dr1 = zat_l(1,ib1, 1,1) ! MPI
                   di1 = zat_l(1,ib1, 2,1) ! MPI
                   w1hw2(ip0) =w1hw2(ip0)+dr1*hr2+di1*hi2
                   w1sw2(ip0) =w1sw2(ip0)+dr1*dr2+di1*di2
                end if
             else
                do ii = ista_g1k(ik), iend_g1k(ik) ! MPI
                   iadd = ii - ista_g1k(ik) + 1
                   hr2 = zah_l(iadd,ib2_,1,1) ! MPI
                   hi2 = zah_l(iadd,ib2_,2,1) ! MPI
                   dr2 = zat_l(iadd,ib2, 1,1) ! MPI
                   di2 = zat_l(iadd,ib2, 2,1) ! MPI
                   dr1 = zat_l(iadd,ib1, 1,1) ! MPI
                   di1 = zat_l(iadd,ib1, 2,1) ! MPI
                   w1hw2(2*ip0-1) =w1hw2(2*ip0-1)+dr1*hr2+di1*hi2
                   w1hw2(2*ip0  ) =w1hw2(2*ip0  )+dr1*hi2-di1*hr2
                   w1sw2(2*ip0-1) =w1sw2(2*ip0-1)+dr1*dr2+di1*di2
                   w1sw2(2*ip0  ) =w1sw2(2*ip0  )+dr1*di2-di1*dr2
                end do
             end if
          end if
       end do
    end do
    if(ipridavidson >= 3) call wd_w1hw2(" -- w1hw2 without nl part--")
    ! <n|Vnl|m> G-wise parallel
    if(myrank_g == 0) then
    call add_nonlocal_part ! w1hw2 = w1hw2 + w1Vnlw2
                           ! w1sw2 = w1sw2 + w1qw2
    endif
    if(ipridavidson >= 3) call wd_w1hw2(" -- w1hw2 with nl part--")

!! (spread sum of w1hw2 and w1sw2)
    if(npes > 1) then
       w1hw2_mpi = 0.d0
       w1sw2_mpi = 0.d0
       nshift = 0
       ndata = nsize_mt_now*kimg_t
       call mpi_allreduce(w1hw2(nshift+1),w1hw2_mpi,ndata,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       w1hw2(nshift+1:nshift+ndata) = w1hw2_mpi(1:ndata) ! MPI
       call mpi_allreduce(w1sw2(nshift+1),w1sw2_mpi,ndata,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       w1sw2(nshift+1:nshift+ndata) = w1sw2_mpi(1:ndata) ! MPI
    end if

    if(ipridavidson >= 2) call wd_w1hw2(" -- just after making w1hw2 --")
    if(ipridavidson >= 2) then
       write(nfout,*) 'neordr for ik = ',ik
       write(nfout,9002) (neordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'nrvf_ordr for ik = ',ik
       write(nfout,9002) (nrvf_ordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'eig'
       write(nfout,'(5x,10f8.4)') (eko_l(ib1,ik),ib1=1,np_e)
    endif
9002 format(5x,10i8)

!! (Diagonalization )  !!

    if(kimg_t == 1) then
       call dspgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
    else
       call zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
    endif

    if(ierr_diag /= 0) then
       zaj_l(:,:,ik,:) = zaj_l_backup(:,:,:)
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(:,ik) = OLD
#endif
       do ib1 = 1, np_e
          eko_l(ib1,ik)=eko_d(neg_g(ib1))
       end do
       if(ipridavidson >= 2) then
          write(nfout,*) '** Mod Davidson SR error **'
       end if
    else

!!$       if(ipridavidson >= 2) then
       if(ipri0 >= 2) then
          write(nfout,*) 'eko_d for ik = ',ik
          write(nfout,9001) (eko_d(ib),ib=1,neg)
          write(nfout,*) 'eig for ik = ',ik
          write(nfout,9001) (eig(ib),ib=1,neg)
          call wd_w1hw2(" -- after diagonalization --")
!sum eko
          dr1=0.d0;dr2=0.d0
          do ib1=1,np_e
             ib1to = neordr(neg_g(ib1),ik)
             if(map_e(ib1to) == myrank_e) dr1=dr1+eko_l(ib1,ik) ! MPI
             dr2=dr2+eig(neg_g(ib1))
          enddo
          call mpi_allreduce(MPI_IN_PLACE,dr1,1,mpi_double_precision,mpi_sum,mpi_kg_world,ierr) ! MPI
          write(nfout,'(" sum of eko_l, eig, abs diff =",3e25.10)') dr1,dr2,abs(dr2-dr1)
       endif
!! (subspace rotation) !!
       call subspace_rotation ! vec,zat_l -> zat_l
!( tenchi ) (zaj_l <- zat_l)
       if(ipridavidson>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
       do ib1 = 1, np_e
          zaj_l(:,ib1,ik,:) = zat_l(:,neg_g(ib1),:,1)
#ifdef SAVE_FFT_TIMES
          if(sw_save_fft == ON) status_saved_phifftr(ib1,ik) = OLD
#endif
       enddo
       zaj_l_backup(:,:,:) = zaj_l(:,:,ik,:)
!! (eko_l)
       do ib1 = 1, np_e
          eko_l(ib1,ik)=eig(neg_g(ib1))
       end do
       if(ipridavidson >= 2) then
          eko2 = sum(eig(1:neg))
          write(nfout,1201) ik,eko1,ekod,eko2

          write(nfout,*) 'eko_l'
          write(nfout,9001) (eko_l(ib1,ik),ib1=1,np_e)
       endif
1201 format(' %% for ik = ',i4,4x,' eko1&ekod&eko2 = ',3f14.7)
9001 format(5x,6f12.5)
!! (neordr & nrvf_ordr)

    end if

    neordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
    nrvf_ordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)

! (deallocate)
    deallocate(eko_d)
    deallocate(eig)
    deallocate(vec)
    deallocate(occup)

    call tstatc0_end(id_sname)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine wd_w1hw2(somecomment)
      character(len=*), intent(in) :: somecomment
      integer :: ib1, ib2, neg_wd, nsb_wd
      write(nfout,'(a35)') somecomment
      write(nfout,*) 'w1hw2 for ik = ',ik
      neg_wd = 8
      nsb_wd = 8
      if(neg_wd > neg) neg_wd = neg
      if(nsb_wd > nsize_sb_now) nsb_wd = nsize_sb_now
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
      write(nfout,*) 'w1sw2 for ik = ',ik
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
9001  format(5x,9f12.5)
      write(nfout,*) 'eko_l for ik = ',ik
      write(nfout,9001) (eko_d(neordr(ib1,ik)),ib1=1,neg_wd)
    end subroutine wd_w1hw2

    subroutine add_nonlocal_part
      integer :: ip,ib1,ib2
      integer       :: ia, lmt1, lmt2, it, p, s, ib
      real(kind=DP) :: facv,facq,vr,vi,qr,qi
      real(kind=DP) :: tmpr,tmpi
! ========================== added by K. Tagami ========== 11.0
#ifdef forsafe
      integer :: ipaw_tmp
#endif
! ======================================================== 11.0
      do ib2 = 1,nsize_sb_now
         ip0b = ib2*(ib2-1)/2
         do ib1 = 1,ib2
            ip0 = ip0b + ib1
            if(mod(ip0-1,nrank_e)/=myrank_e) cycle
            if(kimg_t==1) then
               vr=0.d0
               qr=0.d0
            else
               vr=0.d0
               vi=0.d0
               qr=0.d0
               qi=0.d0
            end if
            do ia = 1, natm
               it = ityp(ia)
! ========================== added by K. Tagami =================== 11.0
#ifdef forsafe
               ipaw_tmp = ipaw(it)
#endif
! ================================================================= 11.0
               do lmt1 = 1, ilmt(it)
                  p = lmta(lmt1,ia)
!OCL NOPREEX
                  do lmt2 = 1, ilmt(it)
                     s = lmta(lmt2,ia)
! ========================== modified by K. Tagami =================== 11.0
!                     if(ipaw(it)==0)then
#ifdef forsafe
                     if ( ipaw_tmp == 0 ) then
#else
                     if (ipaw(it)==0 ) then
#endif
! ================================================================= 11.0
                        facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     else
                        facv   = iwei(ia)*(dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     endif
                     facq   = iwei(ia)*q(lmt1,lmt2,it)
                     if(kimg==1) then
                        tmpr = fsr(ib1,p,1)*fsr(ib2,s,1)&
                    &        + fsi(ib1,p,1)*fsi(ib2,s,1)
                        vr = vr + facv*tmpr
                        qr = qr + facq*tmpr
                     else
                        if(k_symmetry(ik) == GAMMA) then
                           tmpr = fsr(ib1,p,1)*fsr(ib2,s,1)
                           vr = vr + facv*tmpr
                           qr = qr + facq*tmpr
                        else
                           tmpr = fsr(ib1,p,1)*fsr(ib2,s,1)&
                    &        + fsi(ib1,p,1)*fsi(ib2,s,1)
                           tmpi = fsr(ib1,p,1)*fsi(ib2,s,1)&
                    &        - fsi(ib1,p,1)*fsr(ib2,s,1)
                           vr = vr + facv*tmpr
                           vi = vi + facv*tmpi
                           qr = qr + facq*tmpr
                           qi = qi + facq*tmpi
                        end if
                     end if
                  end do
               end do
            end do
            if(kimg_t==1) then
               w1hw2(ip0) = w1hw2(ip0) + vr
               w1sw2(ip0) = w1sw2(ip0) + qr
            else
               w1hw2(2*ip0-1) = w1hw2(2*ip0-1) + vr
               w1hw2(2*ip0  ) = w1hw2(2*ip0  ) + vi
               w1sw2(2*ip0-1) = w1sw2(2*ip0-1) + qr
               w1sw2(2*ip0  ) = w1sw2(2*ip0  ) + qi
            end if
         end do
      end do
    end subroutine add_nonlocal_part

    subroutine subspace_rotation
      integer :: ib1,ib2,ibb2,iadd
!!$      real(kind=DP), dimension(np_g1k_x,neg,kimg) :: zaj_wk
      real(kind=DP), allocatable, dimension(:,:,:) :: zaj_wk
!     allocate(zaj_wk(np_g1k_x,neg,kimg))
      allocate(zaj_wk(maxval(np_g1k),np_e,kimg))

      zaj_wk(:,:,:) = 0.d0
      if(kimg==1) then
         do ib1=1,np_e
            do ib2=1,neg
               do ii=ista_g1k(ik),iend_g1k(ik)
                  iadd = ii - ista_g1k(ik) + 1
                  zaj_wk(iadd,ib1,kimg) = zaj_wk(iadd,ib1,kimg) + zat_l(iadd,ib2,kimg,1)*vec(ib2,neg_g(ib1))
               end do
            end do
         end do
      else
         if(k_symmetry(ik) == GAMMA) then
            do ib1=1,np_e
               do ib2=1,neg
                  hr2=vec(ib2,neg_g(ib1))
                  do ii=ista_g1k(ik),iend_g1k(ik)
                     iadd = ii - ista_g1k(ik) + 1
                     dr1=zat_l(iadd,ib2,1   ,1)
                     di1=zat_l(iadd,ib2,kimg,1)
                     zaj_wk(iadd,ib1,1   ) = zaj_wk(iadd,ib1,1   ) + dr1*hr2
                     zaj_wk(iadd,ib1,kimg) = zaj_wk(iadd,ib1,kimg) + di1*hr2
                  end do
               end do
            end do
         else
            do ib1=1,np_e
               do ib2=1,neg
                  hr2=vec(2*ib2-1,neg_g(ib1))
                  hi2=vec(2*ib2  ,neg_g(ib1))
                  do ii=ista_g1k(ik),iend_g1k(ik)
                     iadd = ii - ista_g1k(ik) + 1
                     dr1=zat_l(iadd,ib2,1   ,1)
                     di1=zat_l(iadd,ib2,kimg,1)
                     zaj_wk(iadd,ib1,1   ) = zaj_wk(iadd,ib1,1   ) + dr1*hr2 - di1*hi2
                     zaj_wk(iadd,ib1,kimg) = zaj_wk(iadd,ib1,kimg) + dr1*hi2 + di1*hr2
                  end do
               end do
            end do
         end if
      end if
      zat_l(:,:,:,1) = 0.0d0
      do ib1 = 1, np_e
         zat_l(:,neg_g(ib1),:,1) = zaj_wk(:,ib1,:)
      enddo
      call mpi_allreduce(MPI_IN_PLACE,zat_l(:,:,:,1),maxval(np_g1k)*neg*kimg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_kg_world,ierr)
      deallocate(zaj_wk)
    end subroutine subspace_rotation

  end subroutine evolve_WFs_in_subspace_sr_3D


  subroutine dspgvx_driver(eig,vec,w1hw2,w1sw2,ierr,nel)
    real(kind=DP), intent(out) ,dimension(nsize_sb_now) :: eig
    real(kind=DP), intent(out) ,dimension(nsize_sb_now*neg) :: vec
    real(kind=DP), intent(inout) ,dimension(nsize_mt_now) :: w1hw2,w1sw2
    integer, intent(out) :: ierr
    integer, intent(in), optional :: nel

    integer :: ITYPE
    character(len=1) :: JOBZ,RANGE,UPLO
    integer :: il,iu
    real(kind=DP),allocatable,dimension(:) :: work_lapack
    integer, allocatable, dimension(:) :: iwork_lapack, ifail_lapack
    real(kind=DP) :: vl,vu,abstol
    integer :: info,m
    real(kind=DP), external :: dlamch
    !!$real(kind=DP), dimension(nsize_mt_now) :: ap,bp
    real(kind=DP), allocatable, dimension(:) :: ap,bp

    allocate(ap(nsize_mt_now),bp(nsize_mt_now))
    abstol = 2*dlamch('S')

    il=1; iu=neg
    if(present(nel)) iu=nel
!(LAPACK)  ITYPE = 1:  A*x = (lambda)*B*x, 2:  A*B*x = (lambda)*x, 3:  B*A*x = (lambda)*x
    ITYPE = 1
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  RANGE = A : all eigenvalues, V: all eigenvalues in (VL, VU], I: the IL-th through IU-th eigenvalues
    RANGE = 'I'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
    allocate(work_lapack(8*nsize_sb_now))
    allocate(iwork_lapack(5*nsize_sb_now))
    allocate(ifail_lapack(nsize_sb_now))

    ap = w1hw2
    bp = w1sw2

    call dspgvx(ITYPE,JOBZ,RANGE,UPLO,nsize_sb_now,ap,bp &
    &          ,vl,vu,il,iu,abstol,m,eig,vec,nsize_sb_now &
    &          ,work_lapack,iwork_lapack,ifail_lapack,info)

    if(ipridavidson >=2 .and. info/=0) then
       write(nfout,*) "debug(dspgvx) info=",info
       write(nfout,*) "debug(dspgvx) ifail"
       write(nfout,'(8(1x,i3))') ifail_lapack
       write(nfout,*) "debug(dspgvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(work_lapack)
    deallocate(iwork_lapack)
    deallocate(ifail_lapack)

    deallocate(ap,bp)

    if(info/=0) then
       !!write(nfout,*) "dspgvx: info=",info
       !!stop 'error in dspgvx_driver'
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine dspgvx_driver

  subroutine dspgvx_driver_loc(eig,vec,w1hw2,w1sw2,ierr,nel)
    integer, intent(in) :: nel
    real(kind=DP), intent(out) ,dimension(nsize_sb_now) :: eig
    real(kind=DP), intent(out) ,dimension(nsize_sb_now*nel) :: vec
    real(kind=DP), intent(inout) ,dimension(nsize_mt_now) :: w1hw2,w1sw2
    integer, intent(out) :: ierr

    integer :: ITYPE
    character(len=1) :: JOBZ,RANGE,UPLO
    integer :: il,iu
    real(kind=DP),allocatable,dimension(:) :: work_lapack
    integer, allocatable, dimension(:) :: iwork_lapack, ifail_lapack
    real(kind=DP) :: vl,vu,abstol
    integer :: info,m
    real(kind=DP), external :: dlamch
    !!$real(kind=DP), dimension(nsize_mt_now) :: ap,bp
    real(kind=DP), allocatable, dimension(:) :: ap,bp

    allocate(ap(nsize_mt_now),bp(nsize_mt_now))
    abstol = 2*dlamch('S')

    il=1; iu=nel
!(LAPACK)  ITYPE = 1:  A*x = (lambda)*B*x, 2:  A*B*x = (lambda)*x, 3:  B*A*x = (lambda)*x
    ITYPE = 1
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  RANGE = A : all eigenvalues, V: all eigenvalues in (VL, VU], I: the IL-th through IU-th eigenvalues
    RANGE = 'I'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
    allocate(work_lapack(8*nsize_sb_now))
    allocate(iwork_lapack(5*nsize_sb_now))
    allocate(ifail_lapack(nsize_sb_now))

    ap = w1hw2
    bp = w1sw2

    call dspgvx(ITYPE,JOBZ,RANGE,UPLO,nsize_sb_now,ap,bp &
    &          ,vl,vu,il,iu,abstol,m,eig,vec,nsize_sb_now &
    &          ,work_lapack,iwork_lapack,ifail_lapack,info)

!    if(ipridavidson >=2 .and. info/=0) then
    if(info/=0) then
       write(nfout,*) "debug(dspgvx) info=",info
       write(nfout,*) "debug(dspgvx) ifail"
       write(nfout,'(8(1x,i3))') ifail_lapack
       write(nfout,*) "debug(dspgvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(work_lapack)
    deallocate(iwork_lapack)
    deallocate(ifail_lapack)

    deallocate(ap,bp)

    if(info/=0) then
       !!write(nfout,*) "dspgvx: info=",info
       !!stop 'error in dspgvx_driver'
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine dspgvx_driver_loc
#ifdef NEC_TUNE
  subroutine dsygvx_driver(eig, vec, w1hw2, w1sw2, ierr, nel)
    integer, intent(in) :: nel
    real(kind=DP), intent(out),   dimension(nsize_sb_now)               :: eig
    real(kind=DP), intent(out),   dimension(nsize_sb_now*nel)           :: vec
    real(kind=DP), intent(inout), dimension(nsize_sb_now, nsize_sb_now) :: w1hw2, w1sw2
    integer, intent(out) :: ierr
    integer :: ITYPE, il, iu, lwork, info, m
    character(len=1) :: JOBZ, RANGE, UPLO
    real(kind=DP) :: vl, vu, abstol
    real(kind=DP), dimension(1) :: work_tmp
    real(kind=DP), allocatable, dimension(:) :: work
    integer, allocatable, dimension(:) :: iwork, ifail
    real(kind=DP), external :: dlamch

    abstol = 2*dlamch('S')
    il = 1; iu = nel
    ITYPE = 1; JOBZ = 'V'; RANGE = 'I'; UPLO = 'U'

    allocate(iwork(5*nsize_sb_now))
    allocate(ifail(nsize_sb_now))

    call dsygvx(ITYPE, JOBZ, RANGE, UPLO, nsize_sb_now, &
   &            w1hw2, nsize_sb_now, w1sw2, nsize_sb_now, &
   &            vl, vu, il, iu, abstol, m, eig, vec, nsize_sb_now, &
   &            work_tmp, -1, iwork, ifail, info)

    lwork = int(work_tmp(1))
    if(lwork<8*nsize_sb_now) lwork = 8*nsize_sb_now
    allocate(work(lwork))

    call dsygvx(ITYPE, JOBZ, RANGE, UPLO, nsize_sb_now, &
   &            w1hw2, nsize_sb_now, w1sw2, nsize_sb_now, &
   &            vl, vu, il, iu, abstol, m, eig, vec, nsize_sb_now, &
   &            work, lwork, iwork, ifail, info)

    if(info /= 0) then
       write(nfout,*) "debug(dsygvx) info=",info
       write(nfout,*) "debug(dsygvx) ifail"
       write(nfout,'(8(1x,i3))') ifail
       write(nfout,*) "debug(dsygvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(work)
    deallocate(iwork)
    deallocate(ifail)

    if(info /= 0) then
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine dsygvx_driver
#endif

  subroutine zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr,nel)
    real(kind=DP), intent(out) ,dimension(nsize_sb_now) :: eig
    real(kind=DP), intent(out) ,dimension(nsize_sb_now*kimg,nsize_sb_now) :: vec
    real(kind=DP), intent(in) ,dimension(nsize_mt_now*kimg) :: w1hw2,w1sw2
    integer, intent(out) :: ierr
    integer, intent(in), optional :: nel
    integer :: ITYPE
    character(len=1) :: JOBZ,RANGE,UPLO
    integer :: il,iu
    real(kind=DP),allocatable,dimension(:) :: work_lapack
    real(kind=DP),allocatable,dimension(:) :: rwork_lapack
    integer, allocatable, dimension(:) :: iwork_lapack, ifail_lapack
    real(kind=DP) :: vl,vu,abstol
    integer :: info,m
    real(kind=DP), external :: dlamch
!!$    real(kind=DP), dimension(nsize_mt_now*kimg) :: ap,bp
    real(kind=DP), allocatable, dimension(:) :: ap,bp
    integer :: ib,i

    abstol = 2*dlamch('S')

    il=1; iu=neg
    if(present(nel)) iu=nel
!(LAPACK)  ITYPE = 1:  A*x = (lambda)*B*x, 2:  A*B*x = (lambda)*x, 3:  B*A*x = (lambda)*x
    ITYPE = 1
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  RANGE = A : all eigenvalues, V: all eigenvalues in (VL, VU], I: the IL-th through IU-th eigenvalues
    RANGE = 'I'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
    allocate(work_lapack(2*nsize_sb_now*kimg)); work_lapack = 0.d0
    allocate(rwork_lapack(7*nsize_sb_now)); rwork_lapack = 0.d0
    allocate(iwork_lapack(5*nsize_sb_now)); iwork_lapack = 0
    allocate(ifail_lapack(nsize_sb_now)); ifail_lapack=0
    allocate(ap(nsize_mt_now*kimg));ap=0.d0
    allocate(bp(nsize_mt_now*kimg));bp=0.d0

    if(ipridavidson >=3 ) then
       write(nfout,*) "debug(zhpgvx) i,w1hw2,w1sw2"
       do ib=1,nsize_sb_now
          i = ib*(ib-1)/2 + ib
          write(nfout,*) ib,w1hw2(2*i-1),w1sw2(2*i-1)
       end do
       ap = w1sw2
       write(nfout,*) "debug(zhpgvx) i,ap,w1sw2"
       do i=1,nsize_mt_now
          write(nfout,*) i,ap(2*i-1),w1sw2(2*i-1)
       end do
       call zhpevx('N','A','U',nsize_sb_now,ap,vl,vu,il,iu,abstol,m &
    &          ,eig,vec,nsize_sb_now &
    &          ,work_lapack,rwork_lapack,iwork_lapack,ifail_lapack,info)
       write(nfout,*) "debug(zhpgvx) eig of w1sw2"
       do ib=1,nsize_sb_now
          write(nfout,*) ib,eig(ib)
       end do
    end if

    ap = w1hw2
    bp = w1sw2

    call zhpgvx(ITYPE,JOBZ,RANGE,UPLO,nsize_sb_now,ap,bp &
    &          ,vl,vu,il,iu,abstol,m,eig,vec,nsize_sb_now &
    &          ,work_lapack,rwork_lapack,iwork_lapack,ifail_lapack,info)

!    if(ipridavidson >=2 .and. info/=0) then
    if(info/=0) then
       write(nfout,*) "debug(zhpgvx) info=",info
       write(nfout,*) "debug(zhpgvx) ifail"
       write(nfout,'(8(1x,i3))') ifail_lapack
       write(nfout,*) "debug(zhpgvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(work_lapack)
    deallocate(rwork_lapack)
    deallocate(iwork_lapack)
    deallocate(ifail_lapack)
    deallocate(ap,bp)

    if(info/=0) then
       !!write(nfout,*) "zhpgvx: info=",info
       !!stop 'error in zhpgvx_driver'
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine zhpgvx_driver
#ifdef NEC_TUNE
  subroutine zhegvx_driver(eig, vec, w1hw2, w1sw2, ierr, nel)
    integer, intent(in):: nel
    real(kind=DP), intent(out),   dimension(nsize_sb_now) :: eig
    real(kind=DP), intent(out),   dimension(nsize_sb_now*kimg, nel) :: vec
    real(kind=DP), intent(inout), dimension(nsize_sb_now*kimg, nsize_sb_now) :: w1hw2, w1sw2
    integer, intent(out) :: ierr
    integer :: ITYPE, il, iu, lwork, info, m
    character(len=1) :: JOBZ, RANGE, UPLO
    complex(kind=DP) :: work_tmp(1)
    complex(kind=DP), allocatable, dimension(:) :: work
    real(kind=DP), allocatable, dimension(:) :: rwork
    integer, allocatable, dimension(:) :: iwork, ifail
    real(kind=DP) :: vl, vu, abstol
    real(kind=DP), external :: dlamch

    abstol = 2*dlamch('S')
    il = 1; iu = nel
    ITYPE = 1; JOBZ = 'V'; RANGE = 'I'; UPLO = 'U'

    allocate(rwork(7*nsize_sb_now))
    allocate(iwork(5*nsize_sb_now))
    allocate(ifail(nsize_sb_now))

    call zhegvx(ITYPE, JOBZ, RANGE, UPLO, nsize_sb_now, &
   &            w1hw2, nsize_sb_now, w1sw2, nsize_sb_now, &
   &            vl, vu, il, iu, abstol, m, eig, vec, nsize_sb_now, &
   &            work_tmp, -1, rwork, iwork, ifail, info)

    lwork = int(real(work_tmp(1)))
    if(lwork<8*nsize_sb_now) lwork = 8*nsize_sb_now
    allocate(work(lwork))

    call zhegvx(ITYPE, JOBZ, RANGE, UPLO, nsize_sb_now, &
   &            w1hw2, nsize_sb_now, w1sw2, nsize_sb_now, &
   &            vl, vu, il, iu, abstol, m, eig, vec, nsize_sb_now, &
   &            work, lwork, rwork, iwork, ifail, info)

    if(info /= 0) then
       write(nfout,*) "debug(zhegvx) info=",info
       write(nfout,*) "debug(zhegvx) ifail"
       write(nfout,'(8(1x,i3))') ifail
       write(nfout,*) "debug(zhegvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(work)
    deallocate(rwork)
    deallocate(iwork)
    deallocate(ifail)

    if(info /= 0) then
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine zhegvx_driver
#endif

  subroutine m_ESmddavid_Renew_WF(nfout,precon)
    integer, intent(in) :: nfout,precon
    integer             :: ispin, ik, iksnl, switch_of_eko_part
    integer :: iblock,itot
    real(kind=DP), allocatable, dimension(:) ::  afft, bfft
    real(kind=DP), allocatable, dimension(:) :: ekin,p
    real(kind=DP), allocatable, dimension(:) :: afft_l
    real(kind=DP), allocatable, dimension(:,:) :: wk_bfft_l
    real(kind=DP), allocatable, dimension(:,:) :: bfft_l
    integer :: lsize, ibsize, isrsize, fft_l_size
    real(kind=DP), allocatable, dimension(:) :: ekin_l,p_l
    logical :: frestart
    integer :: iblock_now, itot_now, ipri0
    integer :: n_unconv
    real(kind=DP), allocatable, dimension(:,:,:) :: vexx
    real(kind=DP) :: exx
    integer :: ng
#ifdef MPI_FFTW
    integer(C_INTPTR_T)  :: local_n, local_n_offset, alloc_local, lx, ly, lz, mx,my,mz
#endif

!!$    integer :: id_sname = -1

    integer, save :: print_ibsize = ON
#ifdef MPI_FFTW
    lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
    if(sw_mpi_fftw==ON) then
       lx = fft_box_size_WF(1,0)
       ly = fft_box_size_WF(2,0)
       lz = fft_box_size_WF(3,0)
       if(kimg==2) then
          alloc_local = fftw_mpi_local_size_3d(ly,lz,lx,mpi_ke_world,local_n,local_n_offset)
       else
          alloc_local = fftw_mpi_local_size_3d(ly,lz,lx/2,mpi_ke_world,local_n,local_n_offset)
       endif
       lsize = local_n*lx*lz
       allocate(afft_mpifftw_vlocal(lx,lz,local_n));afft_mpifftw_vlocal=0.d0
       if ( use_metagga .and. vtau_exists ) then
          allocate(cfft_mpifftw_vlocal(lx,lz,local_n));cfft_mpifftw_vlocal=0.d0
       endif
    else
       allocate(afft_l(lsize*kimg), stat=ierr)
       if ( use_metagga .and. vtau_exists ) allocate(cfft_l(lsize*kimg), stat=ierr)
    endif
#else
#ifdef FFT_3D_DIVISION
    lsize = fft_X_x_nel*fft_X_y_nel*fft_X_z_nel
    allocate(afft_l(lsize*2   ), stat=ierr)
    if ( use_metagga .and. vtau_exists ) allocate(cfft_l(lsize*2), stat=ierr)
#else
    lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
    allocate(afft_l(lsize*kimg), stat=ierr)
    if ( use_metagga .and. vtau_exists ) allocate(cfft_l(lsize*kimg), stat=ierr)
#endif
#endif
    if(ierr /= 0) then
       write(nfout,*)' m_ESmddavid_Renew_WF: Not allocated afft_l array'
       call flush(nfout)
       call mpi_abort(mpi_comm_world, 201, ierr)
    endif
    ibsize = 1
! === FFT Marge. by T. Yamasaki after T.Kato's prescrition in m_ES_WF_by_SDorCG.F90. 2013/02/21 ==
    if (nblocksize_fftw_is_given) then
       ibsize = nblocksize_fftw
       if (ibsize < 1) ibsize = 1
    endif
    if(ipridavidson>=2 .and. print_ibsize == ON) then
       write(nfout,'(" !! ibsize in m_ESmddavid_Renew_WF = ",i8)') ibsize
       print_ibsize = OFF
    end if
!!$! ========================================================================================


    allocate(ekin_l(maxval(np_g1k)),p_l(maxval(np_g1k)))
!    call m_ES_alloc_scss_etc_3D()
!    allocate(afft(nfft)); allocate(bfft(nfft))

    call allocate_matrix_3D
    if(sw_hybrid_functional==ON)then
       call m_ES_EXX_gather_valence_states(nfout)
    endif
#ifdef MPI_FFTW
    if(sw_mpi_fftw==ON)then
      allocate(wk_bfft_l(1,1))
    else
      allocate(wk_bfft_l(lsize*kimg,ibsize))
    endif
#else
    allocate(wk_bfft_l(lsize*kimg,ibsize))
#endif
    allocate(bfft_l(lsize*2   ,ibsize))
!    do ispin = 1, nspin, (af+1)
    do ispin = ista_spin, iend_spin, (af+1)

#ifdef MPI_FFTW
       if(sw_mpi_fftw==ON) then
          call m_ES_Vlocal_in_Rspace_mpifftw3d(ispin,lx,local_n,lz,afft_mpifftw_vlocal)
          if ( use_metagga .and. vtau_exists ) then
             call m_ES_Vlocal_in_Rspace_mpifftw3d( ispin, lx, local_n, lz, &
                  &               cfft_mpifftw_vlocal, vtau_l )
          endif
       else
          call m_ES_Vlocal_in_Rspace_3D(ispin,afft_l,lsize,1,OFF)      ! (ptfft1) vlhxc_l->afft
          if ( use_metagga .and. vtau_exists ) then
             call m_ES_Vlocal_in_Rspace_3D( ispin, cfft_l, lsize, 1, OFF, vtau_l ) ! r space
          endif
       endif
#else
       call m_ES_Vlocal_in_Rspace_3D(ispin,afft_l,lsize,1,OFF)      ! (ptfft1) vlhxc_l->afft
       if ( use_metagga .and. vtau_exists ) then
          call m_ES_Vlocal_in_Rspace_3D( ispin, cfft_l, lsize, 1, OFF, vtau_l ) ! r space
       endif
#endif
!!$       call tstatc0_begin('m_ESmddavid_Renew_WF ', id_sname,1)
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle          ! MPI
          isrsize = min(lsize,mp_g1k(ik))
#ifdef MPI_FFTW
          if(sw_mpi_fftw==ON) then
            fft_l_size  = lsize
            call gen_fft_to_WF_map(ik)
            call m_ES_fftbox_map(ik)
          else
            fft_l_size  = nel_fft_x(myrank_g)
          endif
#else
          fft_l_size  = nel_fft_x(myrank_g)
#endif
          if (ierr /= 0) then
             write(nfout,*)' m_ESmddavid_Renew_WF:  Not allocate '
             call flush(nfout)
             call mpi_abort(mpi_comm_world, 205, ierr)
          endif
          iksnl = (ik-1)/nspin + 1
          call allocate_t_matrix_3D(ik) ! alloc(zat_l,zah_l,w1hw2,w1sw2,wfsd_l,bsd[ri]_l)
          call m_pwBS_kinetic_energies(ik,vkxyz,ekin_l) ! (diakin) ->ekin
          if(.not.allocated(eko_l_old)) then
            allocate(eko_l_old(np_e,ista_k:iend_k));eko_l_old = 0.d0
          endif
          feigconv = .false.
!          call set_feigconv()
          call mpi_barrier(mpi_k_world(myrank_k),ierr)
          Loop: do itot=1,max_iter_david
             itot_now = itot
             call m_ES_Vnonlocal_W_3D(ik,iksnl,ispin,switch_of_eko_part=ON,map=feigconv) ! -> vnlph_l

             if ( use_metagga .and. vtau_exists ) then
#ifdef MPI_FFTW
                if ( sw_mpi_fftw == ON ) then
                   call m_ES_con_kindens_to_vnlph_mpfw( ispin, ik, lsize, &
                        &                lx, ly, lz, local_n, cfft_mpifftw_vlocal )
                else
                   call m_ES_contrib_kindens_to_vnlph( ispin, ik, lsize, cfft_l )
                endif
#else
                call m_ES_contrib_kindens_to_vnlph( ispin, ik, lsize, cfft_l )
#endif
             endif

             if(sw_hybrid_functional==ON) call m_ES_Vexx_W(ik)

             if(sw_keep_hloc_phi==ON) then
                call decide_correction_vector_3D( precon, ik, ispin, ekin_l, &
                     &       ibsize, p_l, itot, lsize )
             else
                call decide_correction_vector_3D( precon,ik,ispin,ekin_l, &
                     &       ibsize, p_l, itot, lsize, &
                     &       bfft_l=bfft_l, wk_bfft_l=wk_bfft_l, &
                     &       afft_l=afft_l )
             endif
             call prepare_Hloc_phi_3D( ik, ispin, ekin_l, afft_l, bfft_l, &
                  &          wk_bfft_l, lsize, ibsize, isrsize, fft_l_size,&
                  &          itot )

!print *,ik,itot
!write(nfout,*) 'B',feigconv
             icountocc=0
             icountuocc=0
             Block_Loop: do iblock=1,nblock
                iblock_now = iblock
                call evolve_WFs_in_subspace_3D(ik,ispin,iblock,itot,frestart)
             end do Block_Loop
             if(ipridavidson>=2) &
             write(nfout,'(a,4i8)') 'ik, iter_david, # of converged occup band, # of converged empty band ' &
             ,ik,itot,icountocc,icountuocc
!write(nfout,*) 'A',feigconv
!             call m_ES_betar_dot_WFs_4_each_k(nfout,ik)   ! -> fsr_l,fsi_l
             if(allbands_converged()) then
               if(ipridavidson>=2) &
               write(nfout,'(a,i5,a,i5)') 'kosugi/davidson iteration converged after ',itot,' iterations at kpoint ',ik
               exit
             endif
          end do Loop
          if(ipridavidson>=2) then
             write(nfout,'("Mddavid: ik=",i5," itot=",i5," subspace=",i5)') &
                                                                 ik, itot_now, nsize_sb_now
          end if
          call deallocate_t_matrix
! === DEBUG by tkato 2012/06/14 ================================================
!          deallocate(wk_bfft_l)
!          deallocate(bfft_l)
! ==============================================================================
       enddo      ! k-point loop
!!$       call tstatc0_end(id_sname)
    enddo      ! spin loop

    if ( allocated(cfft_l) ) deallocate( cfft_l )
    if ( allocated(cfft_mpifftw_vlocal) ) deallocate( cfft_mpifftw_vlocal )
    eko_l_old = eko_l

    deallocate(bfft_l)
    deallocate(wk_bfft_l)
    call deallocate_matrix
!    if(ipridavidson>=2) then
!       write(nfout,'("Modified Davidson: max_itot=",i5)') max_itot
!    end if
!
! ========================================================================================
! === NOTE: m_ES_sort_eigen_values_3D causes difference with ORG_Parallel!!! =============
! ========================================================================================
!   call m_ES_sort_eigen_values_3D()
! ========================================================================================
! ========================================================================================
! ========================================================================================
!!!  ( in case of af=1 )
!    if(af /= 0) then
!       call cp_eigen_values_for_af       !-(contained here)
!       call expand_neordr_and_nrvf_ordr  !-(contained here)
!    end if

    call get_ipri0(ipridavidson,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko_3D(nfout,mode=SCF)
!
!    deallocate(bfft);   deallocate(afft)
    call m_ES_dealloc_scss_etc()
    deallocate(ekin_l,p_l)
#ifdef MPI_FFTW
    if(sw_mpi_fftw==ON) then
      deallocate(afft_mpifftw_vlocal)
    endif
#endif
!.. deallocate(afft_l)
!deallocate(vnldi,hdiag,sdiag)
  contains

    subroutine set_feigconv()
      integer :: i
      feigconv = .false.
      do i=1,np_e
        if(occup_l(i,ik) > 0.d0) then
           if(abs(eko_l_old(i,ik)-eko_l(i,ik)) < delta_eig_occup) &
                                                  feigconv(i) = .true.
        else
           if(abs(eko_l_old(i,ik)-eko_l(i,ik)) < delta_eig_empty) &
                                                  feigconv(i) = .true.
        end if
      enddo
    end subroutine set_feigconv

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,MPI_CommGroup,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    logical function eigenvalues_are_converged(n_unconv)
       integer, intent(out) :: n_unconv
       integer :: ib

       n_unconv = 0
       eigenvalues_are_converged = .true.
       do ib=1,np_e
          if(.not.feigconv(ib)) then
             eigenvalues_are_converged = .false.
             n_unconv = n_unconv + 1
          end if
       end do
    end function eigenvalues_are_converged

  end subroutine m_ESmddavid_Renew_WF


  subroutine allocate_matrix_3D()
    integer:: i,j

    nblock = npartition_david
    if(np_e .lt. npartition_david) nblock = np_e
!!$    nblock = npartition_mddavid
!!$    if(np_e .lt. npartition_mddavid) nblock = np_e

    allocate(nsize_subspace(nblock))
    allocate(nsize_matrix(nblock))
    allocate(ista_e_l(nblock))
    allocate(iend_e_l(nblock))
    allocate(ielm_e_l(nblock))
    ielm_e_l=np_e/nblock
    j = mod(np_e,nblock)
    do i = 1, j
       ielm_e_l(i) = ielm_e_l(i) + 1
    end do
    ista_e_l(1) = 1
    do i = 2, nblock
       ista_e_l(i) = ista_e_l(i-1) + ielm_e_l(i-1)
       iend_e_l(i-1) = ista_e_l(i) - 1
    end do
    iend_e_l(nblock) = np_e
    do i=1,nblock
      if(sw_MRCV_only==ON)then
         nsize_subspace(i)=ielm_e_l(i)*2
         nsize_matrix(i)=nsize_subspace(i)*(nsize_subspace(i)+1)/2
      else
         nsize_subspace(i)=ielm_e_l(i)*(max_iter_david+1)
         nsize_matrix(i)=nsize_subspace(i)*(nsize_subspace(i)+1)/2
      endif
    end do
    msize_subspace=maxval(nsize_subspace)
    msize_matrix=maxval(nsize_matrix)
    allocate(feigconv(np_e))
    allocate(ibover(msize_subspace,nblock))
    if(sw_MRCV_only==ON)then
       allocate(fsr(np_e,nlmta,2));fsr=0.d0
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          allocate(fsi(np_e,nlmta,2));fsi=0.d0
       end if
    else
       allocate(fsr(np_e,nlmta,max_iter_david+1))
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          allocate(fsi(np_e,nlmta,max_iter_david+1))
       end if
    endif
    eps_residual = eps_david
    if(sw_MRCV_only==OFF)then
       allocate(zajold_l(maxval(np_g1k),np_e,kimg))
       allocate(fsrold_l(np_e,np_fs))
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
         allocate(fsiold_l(np_e,np_fs))
       end if
    endif
  end subroutine allocate_matrix_3D

  subroutine deallocate_matrix
    deallocate(nsize_subspace)
    deallocate(nsize_matrix)
    deallocate(ista_e_l)
    deallocate(iend_e_l)
    deallocate(ielm_e_l)
    deallocate(feigconv)
    deallocate(ibover)
    deallocate(fsr)
    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       deallocate(fsi)
    end if
    if(sw_MRCV_only==OFF)then
       deallocate(zajold_l)
       deallocate(fsrold_l)
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
         deallocate(fsiold_l)
       end if
    endif
  end subroutine deallocate_matrix

  subroutine allocate_t_matrix_3D(ik)
    integer, intent(in) :: ik
    integer :: kimg_t
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if
    allocate(zat_l(maxval(np_g1k),np_e,kimg,max_iter_david+1)) ! MPI
    allocate(zah_l(maxval(np_g1k),np_e,kimg,max_iter_david+1)) ! MPI
    allocate(w1hw2(msize_matrix*kimg_t))
    allocate(w1sw2(msize_matrix*kimg_t))
    allocate(wfsd_l(maxval(np_g1k),np_e,ik:ik,kimg)); wfsd_l = 0.d0
!!$    allocate(bsdr_l(np_e,nlmta,ik:ik)); bsdr_l = 0.d0
!!$    allocate(bsdi_l(np_e,nlmta,ik:ik)); bsdi_l = 0.d0
    allocate(bsdr_l(np_e,max(np_fs,1),ik:ik)); bsdr_l = 0.d0
    allocate(bsdi_l(np_e,max(np_fs,1),ik:ik)); bsdi_l = 0.d0
    if(sw_MRCV_only==OFF)then
       zajold_l(:,:,:)=zaj_l(:,:,ik,:)
       fsrold_l(:,:)=fsr_l(:,:,ik)
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
         fsiold_l(:,:)=fsi_l(:,:,ik)
       endif
    end if

  end subroutine allocate_t_matrix_3D

  subroutine deallocate_t_matrix
! ================================== modified by K. Tagami =========== 11.0
!    deallocate(zat_l) ! MPI
!    deallocate(zah_l) ! MPI

       deallocate(zat_l) ! MPI
       deallocate(zah_l) ! MPI
! ==================================================================== 11.0
    deallocate(w1hw2)
    deallocate(w1sw2)
    deallocate(wfsd_l)
    deallocate(bsdr_l)
    deallocate(bsdi_l)
    if(sw_divide_subspace==OFF)then
       if ( allocated( zat_l_t ) ) deallocate(zat_l_t)
       if ( allocated( zah_l_t ) ) deallocate(zah_l_t)
       if ( allocated( feigconv_t ) ) deallocate(feigconv_t)
       if ( allocated( fsr_t) ) deallocate(fsr_t)
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          if ( allocated( fsi_t) ) deallocate(fsi_t)
       endif
       deallocate(w1hw2_mpi)
       deallocate(w1sw2_mpi)
    endif
  end subroutine deallocate_t_matrix

  subroutine prepare_Hloc_phi_3D(ik,ispin,ekin_l,afft_l,bfft_l, &
       &                         wk_bfft_l,lsize,ibsize,isrsize,fft_l_size,itot )
    integer, intent(in) :: ik,ispin,lsize,ibsize,isrsize,fft_l_size
    integer, intent(in) :: itot
    real(kind=DP), intent(in)  :: ekin_l(maxval(np_g1k))
#ifdef FFT_3D_DIVISION
    real(kind=DP), intent(in)  :: afft_l(lsize*2   )
    real(kind=DP), intent(out) :: bfft_l(lsize*2   ,1)
    real(kind=DP), intent(inout) :: wk_bfft_l(lsize*2   ,ibsize)
#else
    real(kind=DP), intent(in)  :: afft_l(lsize*kimg)
    real(kind=DP), intent(out) :: bfft_l(lsize*kimg,ibsize)
    real(kind=DP), intent(inout) :: wk_bfft_l(lsize*kimg,ibsize)
#endif
#ifdef MPI_FFTW
!    complex(kind=DP), pointer :: bfft_mpifftw(:,:,:)
    integer(C_INTPTR_T) :: alloc_local, lx, ly, lz, local_n, local_n_offset
#endif

    integer       :: ib1,i1,ii,ib,iadd
!!$    real(kind=DP), allocatable, dimension(:,:) :: fs_mpi,fs_mpi2
    real(kind=DP), allocatable, dimension(:,:) :: fs_mpi
    real(kind=DP), allocatable, dimension(:,:) :: zah_t ! d(maxval(np_g1k),kimg)
    real(kind=DP) :: denom
    real(kind=DP) :: dr1,dr2,di1,di2,dd
    integer :: is,is1,ib2,ibesize
    integer :: id_sname = -1, id_sname1=-1, id_sname2=-1, id_sname3=-1, ipri0
    real(kind=DP), allocatable, dimension(:,:) :: vtau_phl
    real(kind=DP), allocatable, dimension(:,:) :: vexx
    real(kind=DP) :: exx
    integer :: niter
    integer :: ng, iflag
    integer :: nsize
    call tstatc0_begin('prepare_Hloc_phi_3D ', id_sname,1)

    call get_ipri0(ipridavidson,ipri0)

#ifdef MPI_FFTW
    lx = fft_box_size_WF(1,0)
    ly = fft_box_size_WF(2,0)
    lz = fft_box_size_WF(3,0)
    if(kimg==2)then
      alloc_local = fftw_mpi_local_size_3d(ly,lz,lx,mpi_ke_world,local_n,local_n_offset)
    else
      alloc_local = fftw_mpi_local_size_3d(ly,lz,lx/2,mpi_ke_world,local_n,local_n_offset)
    endif
#endif

    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    if(sw_hybrid_functional==ON) then
        ng = maxval(np_g1k)
        allocate(vexx(ng,kimg))
        vexx = 0.0d0
    endif
    if ( use_metagga .and. vtau_exists ) then
       allocate( vtau_phl(maxval(np_g1k),kimg) );  vtau_phl = 0.0d0
    endif
! (zaj_l <- (T+Vloc)|phi> )
!!    zaj_l(:,:,ik,:) = zajold_l(:,:,:,idavid)
!( tenchi ) (zat_l <- zaj_l)

    call tstatc0_begin('prepare_Hloc(1)', id_sname1)
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call start_timer('prepare_Hloc_phi_3D_000')
#endif
! === TIMERTIMERTIMER ==========================================================

    if(sw_MRCV_only==ON)then
       zat_l(:,:,:,1) = zaj_l(:,:,ik,:)
       zat_l(:,:,:,2) = wfsd_l(:,:,ik,:)
       call m_ES_gather_f_3d_to_2d_k(fsr_l(:,:,ik),  fsr(:,:,1))
       call m_ES_gather_f_3d_to_2d_k(bsdr_l(:,:,ik), fsr(:,:,2))
       if( k_symmetry(ik) /= GAMMA ) then
          call m_ES_gather_f_3d_to_2d_k(fsi_l(:,:,ik),  fsi(:,:,1))
          call m_ES_gather_f_3d_to_2d_k(bsdi_l(:,:,ik), fsi(:,:,2))
       endif
    else
       zat_l(:,:,:,itot+1) = wfsd_l(:,:,ik,:)
!!$       fsr(:,:,itot+1)=bsdr_l(:,:,ik)
       call m_ES_gather_f_3d_to_2d_k(bsdr_l(:,:,ik),  fsr(:,:,itot+1))
       if( k_symmetry(ik) /= GAMMA ) then
         call m_ES_gather_f_3d_to_2d_k(bsdi_l(:,:,ik),  fsi(:,:,itot+1))
       endif
    endif
!   allocate(fs_mpi(np_e,nlmta))
!   if(sw_MRCV_only==ON)then
!      zat_l(:,:,:,1) = zaj_l(:,:,ik,:)
!      zat_l(:,:,:,2) = wfsd_l(:,:,ik,:)
!     fs_mpi=0.d0
!     do is = 1, np_fs ! MPI
!        is1=nis_fs(myrank_g)+is-1
!        do ib = 1, np_e ! MPI
!           fs_mpi(ib,is1) = fsr_l(ib,is,ik)
!        end do
!     end do
!     call mpi_allreduce(MPI_IN_PLACE,fs_mpi,np_e*nlmta &
!       & ,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
!     fsr(1:np_e,1:nlmta,1) = fs_mpi(1:np_e,1:nlmta)
!!$       fsr(:,:,2)=bsdr_l(:,:,ik)
!      fs_mpi=0.d0
!      do is = 1, np_fs ! MPI
!         is1=nis_fs(myrank_g)+is-1
!         do ib = 1, np_e ! MPI
!            fs_mpi(ib,is1) = bsdr_l(ib,is,ik)
!         end do
!      end do
!      call mpi_allreduce(MPI_IN_PLACE,fs_mpi,np_e*nlmta &
!        & ,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
!      fsr(1:np_e,1:nlmta,2) = fs_mpi(1:np_e,1:nlmta)

!      if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!        fs_mpi=0.d0
!        do is = 1, np_fs ! MPI
!           is1=nis_fs(myrank_g)+is-1
!           do ib = 1, np_e ! MPI
!              fs_mpi(ib,is1) = fsi_l(ib,is,ik)
!           end do
!        end do
!        call mpi_allreduce(MPI_IN_PLACE,fs_mpi,np_e*nlmta &
!          & ,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
!        fsi(1:np_e,1:nlmta,1) = fs_mpi(1:np_e,1:nlmta)

!!$          fsi(:,:,2)=bsdi_l(:,:,ik)
!         fs_mpi=0.d0
!         do is = 1, np_fs ! MPI
!            is1=nis_fs(myrank_g)+is-1
!            do ib = 1, np_e ! MPI
!               fs_mpi(ib,is1) = bsdi_l(ib,is,ik)
!            end do
!         end do
!         call mpi_allreduce(MPI_IN_PLACE,fs_mpi,np_e*nlmta &
!              & ,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)       ! MPI
!         fsi(1:np_e,1:nlmta,2) = fs_mpi(1:np_e,1:nlmta)
!      end if
!   else
!      zat_l(:,:,:,itot+1) = wfsd_l(:,:,ik,:)
!!$       fsr(:,:,itot+1)=bsdr_l(:,:,ik)
!      fs_mpi=0.d0
!      do is = 1, np_fs ! MPI
!         is1=nis_fs(myrank_g)+is-1
!         do ib = 1, np_e ! MPI
!            fs_mpi(ib,is1) = bsdr_l(ib,is,ik)
!         end do
!      end do
!      call mpi_allreduce(MPI_IN_PLACE,fs_mpi,np_e*nlmta &
!        & ,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)       ! MPI
!      fsr(1:np_e,1:nlmta,itot+1) = fs_mpi(1:np_e,1:nlmta)

!      if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!!$          fsi(:,:,itot+1)=bsdi_l(:,:,ik)
!         fs_mpi=0.d0
!         do is = 1, np_fs ! MPI
!            is1=nis_fs(myrank_g)+is-1
!            do ib = 1, np_e ! MPI
!               fs_mpi(ib,is1) = bsdi_l(ib,is,ik)
!            end do
!         end do
!         call mpi_allreduce(MPI_IN_PLACE,fs_mpi,np_e*nlmta &
!              & ,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)       ! MPI
!         fsi(1:np_e,1:nlmta,itot+1) = fs_mpi(1:np_e,1:nlmta)
!      end if
!   endif
!   deallocate(fs_mpi)
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('prepare_Hloc_phi_3D_000')
#endif
! === TIMERTIMERTIMER ==========================================================

    call tstatc0_end(id_sname1)

!!    call tstatc0_begin('prepare_Hloc(2)', id_sname2)
!!    if(itot == 1) then
!!! === TIMERTIMERTIMER ==========================================================
!!#ifdef __TIMER_FFT__
!!call start_timer('prepare_Hloc_phi_3D_001')
!!#endif
!!! === TIMERTIMERTIMER ==========================================================
!!!!$      do ib1 = 1, np_e ! MPI
!!      do ib1 = 1, np_e, ibsize
!!!!$         ib = ib1
!!         ib2 = min(ib1+ibsize-1,np_e)
!!         ibesize = ib2 - ib1 + 1
!!
!!! === TIMERTIMERTIMER ==========================================================
!!#ifdef __TIMER_FFT__
!!call start_timer('- 001 m_ES_WF_in_Rspace_3D')
!!#endif
!!! === TIMERTIMERTIMER ==========================================================
!!#ifdef __TIMER_COMM__
!!         call m_ES_WF_in_Rspace_3D(ik,ib1,ib2,ibsize,lsize,wk_bfft_l,0)
!!#else
!!#ifdef MPI_FFTW
!!         if(sw_mpi_fftw==ON) then
!!           call m_ES_WF_in_Rspace_mpifftw(ista_k,iend_k,ik,ib1,zaj_l)
!!         else
!!           call m_ES_WF_in_Rspace_3D(ik,ib1,ib2,ibsize,lsize,wk_bfft_l)
!!         endif
!!#else
!!         call m_ES_WF_in_Rspace_3D(ik,ib1,ib2,ibsize,lsize,wk_bfft_l)
!!#endif
!!#endif
!!! === TIMERTIMERTIMER ==========================================================
!!#ifdef __TIMER_FFT__
!!call stop_timer('- 001 m_ES_WF_in_Rspace_3D')
!!call start_timer('- 001 m_FFT_Vlocal_W_3D')
!!#endif
!!! === TIMERTIMERTIMER ==========================================================
!!#ifdef FFT_3D_DIVISION
!!       call m_FFT_Vlocal_W_3DIV_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_x(myrank_g))
!!! === TIMERTIMERTIMER ==========================================================
!!#ifdef __TIMER_FFT__
!!call stop_timer('- 001 m_FFT_Vlocal_W_3D')
!!call start_timer('- 001 m_FFT_Direct_3D')
!!#endif
!!! === TIMERTIMERTIMER ==========================================================
!!       call m_FFT_Direct_3DIV_3D(nfout,wk_bfft_l,lsize,ibsize)
!!#else
!!#ifdef MPI_FFTW
!!       if(sw_mpi_fftw==ON) then
!!         nsize = local_n*lx*ly
!!!         call m_FFT_Vlocal_W_mpifftw(afft_l,lsize,nsize)
!!         call m_FFT_Vlocal_W_mpifftw3d(afft_mpifftw_vlocal,lx,local_n,lz)
!!         call m_FFT_Direct_MPI_FFTW(nfout)
!!       else
!!         call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
!!         call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
!!       endif
!!#else
!!       if (sw_fft_xzy > 0) then
!!          call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_y(myrank_g))
!!! === TIMERTIMERTIMER ==========================================================
!!#ifdef __TIMER_FFT__
!!call stop_timer('- 001 m_FFT_Vlocal_W_3D')
!!call start_timer('- 001 m_FFT_Direct_3D')
!!#endif
!!! === TIMERTIMERTIMER ==========================================================
!!          call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
!!       else
!!          call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
!!! === TIMERTIMERTIMER ==========================================================
!!#ifdef __TIMER_FFT__
!!call stop_timer('- 001 m_FFT_Vlocal_W_3D')
!!call start_timer('- 001 m_FFT_Direct_3D')
!!#endif
!!! === TIMERTIMERTIMER ==========================================================
!!          if(sw_serial_fft == ON) then
!!             call m_ES_WF_2D(ik,wk_bfft_l,ib2,ib1,ibsize,lsize,DIRECT)
!!          else
!!             call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
!!          endif
!!       end if
!!#endif
!!#endif
! === TIMERTIMERTIMER ==========================================================
!!#ifdef __TIMER_FFT__
!!call stop_timer('- 001 m_FFT_Direct_3D')
!!call start_timer('- 001 map_fft_to_WF_3D')
!!#endif
!!! === TIMERTIMERTIMER ==========================================================
!!#ifdef MPI_FFTW
!!         if(sw_mpi_fftw==ON) then
!!           call map_fft_to_WF_mpifftw(ik,lsize,ibesize,bfft_l,isrsize,fft_l_size)
!!         else
!!           call map_fft_to_WF_3D(ik,lsize,ibesize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
!!         endif
!!#else
!!         call map_fft_to_WF_3D(ik,lsize,ibesize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
!!#endif
!!! === TIMERTIMERTIMER ==========================================================
!!#ifdef __TIMER_FFT__
!!call stop_timer('- 001 map_fft_to_WF_3D')
!!call start_timer('- 001 others')
!!#endif
!!! === TIMERTIMERTIMER ==========================================================
!!         do ib = ib1, ib2
!!
!!            if(sw_hybrid_functional==ON) then
!!               if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!!                  call m_ES_EXX_potential(nfout,ispin,ib,ik,ng,fsr_l(ib,:,ik),fsi_l(ib,:,ik),vexx,0)
!!               else
!!                  call m_ES_EXX_potential(nfout,ispin,ib,ik,ng,fsr_l(ib,:,ik),fsr_l(ib,:,ik),vexx,0)
!!               endif
!!            endif
!!
!!            if(kimg == 1) then
!!               do ii=ista_g1k(ik),iend_g1k(ik)
!!                  iadd = ii - ista_g1k(ik) + 1
!!                  dr1 = zaj_l(iadd,ib,ik,1)
!!                  dr2 = bfft_l(iadd,ib-ib1+1)*denom
!!                  zah_l(iadd,ib,1,1) = ekin_l(iadd)*dr1+dr2
!!               enddo
!!               if(sw_hybrid_functional==ON)then
!!                  zah_l(:,ib,1,1) = zah_l(:,ib,1,1) + vexx(:,1)
!!               endif
!!            else
!!               do ii=ista_g1k(ik),iend_g1k(ik)
!!                  iadd = ii - ista_g1k(ik) + 1
!!                  dr1  = zaj_l(iadd,ib,ik,1)
!!                  di1  = zaj_l(iadd,ib,ik,kimg)
!!                  zah_l(iadd,ib,1,   1)= ekin_l(iadd)*dr1+bfft_l(2*iadd-1,ib-ib1+1)*denom
!!                  zah_l(iadd,ib,kimg,1)= ekin_l(iadd)*di1+bfft_l(2*iadd,  ib-ib1+1)*denom
!!               enddo
!!               if(sw_hybrid_functional==ON)then
!!                  zah_l(:,ib,1,1) = zah_l(:,ib,1,1) + vexx(:,1)
!!                  zah_l(:,ib,kimg,1) = zah_l(:,ib,kimg,1) + vexx(:,kimg)
!!               endif
!!            endif
!!         end do
!!! === TIMERTIMERTIMER ==========================================================
!!#ifdef __TIMER_FFT__
!!call stop_timer('- 001 others')
!!#endif
!!! === TIMERTIMERTIMER ==========================================================
!!      enddo
!!! === TIMERTIMERTIMER ==========================================================
!!#ifdef __TIMER_FFT__
!!call stop_timer('prepare_Hloc_phi_3D_001')
!!#endif
!!! === TIMERTIMERTIMER ==========================================================
!!    end if
!!    call tstatc0_end(id_sname2)

    call tstatc0_begin('prepare_Hloc(3)', id_sname3)
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call start_timer('prepare_Hloc_phi_3D_002')
#endif
! === TIMERTIMERTIMER ==========================================================
!!( tenchi ) (zah_l <- zaj_l)
    zaj_l(:,:,ik,:) = wfsd_l(:,:,ik,:)
#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) status_saved_phifftr(:,ik) = OLD
#endif

!!$    do ib1 = 1, np_e ! MPI
    do ib1 = 1, np_e, ibsize
       if (feigconv(ib1)) cycle
       ib2 = min(ib1+ibsize-1,np_e)
       ibesize = ib2 - ib1 + 1
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call start_timer('- 002 m_ES_WF_in_Rspace_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_COMM__
       call m_ES_WF_in_Rspace_3D(ik,ib1,ib2,ibsize,lsize,wk_bfft_l,0)
#else
#ifdef MPI_FFTW
         if(sw_mpi_fftw==ON) then
           call m_ES_WF_in_Rspace_mpifftw(ista_k,iend_k,ik,ib1,zaj_l)
         else
           call m_ES_WF_in_Rspace_3D(ik,ib1,ib2,ibsize,lsize,wk_bfft_l)
         endif
#else
         call m_ES_WF_in_Rspace_3D(ik,ib1,ib2,ibsize,lsize,wk_bfft_l)
#endif
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 002 m_ES_WF_in_Rspace_3D')
call start_timer('- 002 m_FFT_Vlocal_W_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef FFT_3D_DIVISION
       call m_FFT_Vlocal_W_3DIV_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_x(myrank_g))
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 002 m_FFT_Vlocal_W_3D')
call start_timer('- 002 m_FFT_Direct_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
       call m_FFT_Direct_3DIV_3D(nfout,wk_bfft_l,lsize,ibsize)
#else
#ifdef MPI_FFTW
       if(sw_mpi_fftw==ON) then
         nsize = local_n*lx*ly
!         call m_FFT_Vlocal_W_mpifftw(afft_l,lsize,nsize)
         call m_FFT_Vlocal_W_mpifftw3d(afft_mpifftw_vlocal,lx,local_n,lz)
         call m_FFT_Direct_MPI_FFTW(nfout)
       else
         call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
         call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
       endif
#else
       if (sw_fft_xzy > 0) then
          call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_y(myrank_g))
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 002 m_FFT_Vlocal_W_3D')
call start_timer('- 002 m_FFT_Direct_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
          call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
       else
          call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 002 m_FFT_Vlocal_W_3D')
call start_timer('- 002 m_FFT_Direct_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
        if(sw_serial_fft ==ON) then
          call m_ES_WF_2D(ik,wk_bfft_l,ib2,ib1,ibsize,lsize,DIRECT)
        else
          call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
        endif
       end if
#endif
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 002 m_FFT_Direct_3D')
call start_timer('- 002 map_fft_to_WF_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef MPI_FFTW
         if(sw_mpi_fftw==ON) then
           call map_fft_to_WF_mpifftw(ik,lsize,ibesize,bfft_l,isrsize,fft_l_size)
         else
           call map_fft_to_WF_3D(ik,lsize,ibesize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
         endif
#else
         call map_fft_to_WF_3D(ik,lsize,ibesize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
#endif

! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 002 map_fft_to_WF_3D')
call start_timer('- 002 others')
#endif
! === TIMERTIMERTIMER ==========================================================
       allocate(zah_t(maxval(np_g1k),kimg))
!!$       if(sw_MRCV_only==ON) then
       do ib = ib1, ib2
          if(sw_hybrid_functional==ON) then
             if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
                call m_ES_EXX_potential(nfout,ispin,ib,ik,ng,bsdr_l(ib,:,ik),bsdi_l(ib,:,ik),vexx)
             else
                call m_ES_EXX_potential(nfout,ispin,ib,ik,ng,bsdr_l(ib,:,ik),bsdr_l(ib,:,ik),vexx)
             endif
          endif

          if ( use_metagga .and. vtau_exists ) then
#ifdef MPI_FFTW
             if ( sw_mpi_fftw == ON ) then
                call m_ES_kindens_to_vnlph_ib2_mpfw( ispin, ik, ib, lsize, &
                     &               lx, ly, lz, local_n, cfft_mpifftw_vlocal, vtau_phl )
             else
                call m_ES_kindens_to_vnlph_ib2( ispin, ik, ib, lsize, cfft_l, vtau_phl )
             endif
#else
             call m_ES_kindens_to_vnlph_ib2( ispin, ik, ib, lsize, cfft_l, vtau_phl )
#endif
          endif

          if(kimg == 1) then
             do ii=ista_g1k(ik),iend_g1k(ik)
                iadd = ii - ista_g1k(ik) + 1
                dr1 = zaj_l(iadd,ib,ik,1)
                dr2 = bfft_l(iadd,ib-ib1+1)*denom
!!$                zah_l(iadd,ib,1,2) = ekin_l(iadd)*dr1+dr2
                zah_t(iadd,1) = ekin_l(iadd)*dr1+dr2
             enddo
             if(sw_MRCV_only == ON) then
                zah_l(:,ib,1,2) = zah_t(:,1)
             else
                zah_l(:,ib,1,itot+1) = zah_t(:,1)
             end if
             if(sw_hybrid_functional==ON)then
                if(sw_MRCV_only==ON)then
                   zah_l(:,ib,1,2) = zah_l(:,ib,1,2) + vexx(:,1)
                else
                   zah_l(:,ib,1,itot+1) = zah_l(:,ib,1,itot+1) + vexx(:,1)
                endif
             endif
             if( use_metagga .and. vtau_exists ) then
                if(sw_MRCV_only==ON)then
                   zah_l(:,ib,1,2)= zah_l(:,ib,1,2) +vtau_phl(:,1)
                else
                   zah_l(:,ib,1,itot+1)= zah_l(:,ib,1,itot+1)+vtau_phl(:,1)
                endif
             endif
          else
             do ii=ista_g1k(ik),iend_g1k(ik)
                iadd = ii - ista_g1k(ik) + 1
                dr1  = zaj_l(iadd,ib,ik,1)
                di1  = zaj_l(iadd,ib,ik,kimg)
!!$                zah_l(iadd,ib,1,   2) = ekin_l(iadd)*dr1+bfft_l(2*iadd-1,ib-ib1+1)*denom
!!$                zah_l(iadd,ib,kimg,2) = ekin_l(iadd)*di1+bfft_l(2*iadd,  ib-ib1+1)*denom
                zah_t(iadd,1   ) = ekin_l(iadd)*dr1+bfft_l(2*iadd-1,ib-ib1+1)*denom
                zah_t(iadd,kimg) = ekin_l(iadd)*di1+bfft_l(2*iadd,  ib-ib1+1)*denom
             enddo
             if(sw_MRCV_only==ON) then
                zah_l(:,ib,1,   2) = zah_t(:,1)
                zah_l(:,ib,kimg,2) = zah_t(:,kimg)
             else
                zah_l(:,ib,1,   itot+1) = zah_t(:,1   )
                zah_l(:,ib,kimg,itot+1) = zah_t(:,kimg)
             end if
             if(sw_hybrid_functional==ON)then
                if(sw_MRCV_only==ON)then
                   zah_l(:,ib,1,2)= zah_l(:,ib,1,2)+vexx(:,1)
                   zah_l(:,ib,kimg,2)= zah_l(:,ib,kimg,2)+vexx(:,kimg)
                else
                   zah_l(:,ib,1,itot+1)= zah_l(:,ib,1,itot+1)+vexx(:,1)
                   zah_l(:,ib,kimg,itot+1)= zah_l(:,ib,kimg,itot+1)+vexx(:,kimg)
                endif
             endif
             if( use_metagga .and. vtau_exists ) then
                if(sw_MRCV_only==ON)then
                   zah_l(:,ib,1,2)= zah_l(:,ib,1,2)+vtau_phl(:,1)
                   zah_l(:,ib,kimg,2)= zah_l(:,ib,kimg,2)+vtau_phl(:,kimg)
                else
                   zah_l(:,ib,1,itot+1)= zah_l(:,ib,1,itot+1)+vtau_phl(:,1)
                   zah_l(:,ib,kimg,itot+1)= zah_l(:,ib,kimg,itot+1)+vtau_phl(:,kimg)
                endif
             endif
          endif
       end do
       deallocate(zah_t)
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 002 others')
#endif
! === TIMERTIMERTIMER ==========================================================
    end do
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('prepare_Hloc_phi_3D_002')
#endif
! === TIMERTIMERTIMER ==========================================================

    if(sw_hybrid_functional==ON) deallocate(vexx)
    if ( allocated(vtau_phl) ) deallocate( vtau_phl )

    call tstatc0_end(id_sname3)

    call tstatc0_end(id_sname)
!    stop

  contains

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

  end subroutine prepare_Hloc_phi_3D

  subroutine evolve_WFs_in_subspace_3D(ik,ispin,iblock,itot,frestart)
    integer, intent(in) :: ik,ispin
    integer, intent(in) :: iblock,itot
    logical, intent(out) :: frestart
! (allocatable variables)
    real(kind=DP), allocatable,dimension(:) ::     eig
    real(kind=DP), allocatable,dimension(:,:) ::   vec

    integer :: i,iel

    integer       :: ib1,ib2,ib1to,ib2to,i1,ii,ri,ib,iadd
    integer       :: ibb1,ibb2
    integer       :: ii1,ii2,iter,iter1,iter2
    real(kind=DP) :: eko1, eko2, ekod
    real(kind=DP) :: hr2,hi2,dr1,dr2,di1,di2,dd
    integer :: ip0,ip0b,ip1,ip1b,ib1n,ib2n,ndata,nshift,kimg_t,ig1
    integer :: noffset
    integer :: nsize_max_sb_now
    integer :: ierr_diag
    integer :: nel,nsta,nend
    integer :: ng
    integer :: id_sname = -1, ipri0
#ifdef NEC_TUNE
    integer :: num, k, lda, ldb, ldc
    real(kind=DP), allocatable, dimension(:,:) :: w1hw2_, w1sw2_
    real(kind=DP), allocatable, dimension(:,:,:) :: zat_t, zah_t
    real(kind=DP), allocatable, dimension(:,:) :: zat_t1, zah_t1
    complex(kind=DP), parameter :: c0 = (0.0d0, 0.0d0), c1 = (1.0d0, 0.0d0)
#endif
    call tstatc0_begin('evolve_WFs_in_subspace  ', id_sname,1)

    call get_ipri0(ipridavidson,ipri0)

    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if

    nel =ielm_e_l(iblock)
    nsta=ista_e_l(iblock)
    nend=iend_e_l(iblock)

    if(sw_divide_subspace==OFF)then
       nel=neg
       nsta=1
       nend=neg
    endif
    allocate(eko_d(neg));eko_d=0.d0
    allocate(occup(neg));occup=0.d0
    if(sw_divide_subspace==ON)then
        zah_l_p => zah_l
        zat_l_p => zat_l
        fsr_p   => fsr
        fsi_p   => fsi
        feigconv_p => feigconv
        do iel=1,nel
!           eko_d(nsta+iel-1) = eko_l(iel,ik)
!           occup(nsta+iel-1) = occup_l(iel,ik)
           eko_d(nsta+iel-1) = eko_l(nsta+iel-1,ik)
           occup(nsta+iel-1) = occup_l(nsta+iel-1,ik)
        enddo
    else
    endif
    if(ipridavidson>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')

    if(sw_MRCV_only==ON)then
       ip0=nel
       do ib=1,nel
         ibover(ib,iblock)=ib
         if(.not.feigconv_p(nsta+ib-1)) then
           ip0=ip0+1
           ibover(nel+ib,iblock) = ip0
         else
           ibover(nel+ib,iblock) = -1
         end if
       end do
       nsize_sb_now = ip0
       nsize_mt_now = nsize_sb_now*(nsize_sb_now+1)/2
       nsize_max_sb_now = nsize_subspace(iblock)
    else
       if(itot==1) then
         do ib=1,nel
           ibover(ib,iblock)=ib
         end do
         nsize_subspace(iblock)=nel
       end if

       noffset=nel*itot
       ip0=nsize_subspace(iblock)
       do ib=1,nel
         if(.not.feigconv_p(nsta+ib-1)) then
           ip0=ip0+1
           ibover(noffset+ib,iblock) = ip0
         else
           ibover(noffset+ib,iblock) = -1
         end if
       end do

       nsize_sb_now = ip0
       nsize_subspace(iblock) = ip0
       nsize_mt_now = nsize_sb_now*(nsize_sb_now+1)/2
       nsize_max_sb_now = nel*(itot+1)                   !nsize_subspace(iblock)
    endif

    if(ipridavidson >=2) then
       write(nfout,*) 'ibover=',ibover(1:nsize_max_sb_now,iblock)
    end if
!
    allocate(eig(nsize_sb_now)); eig=0.d0
    allocate(vec(nsize_sb_now*kimg_t,nsize_sb_now))

    if(ipridavidson >=2) then
       write(nfout,*) 'Modified Davidson:ik,iblock,nsize_sb_now=', ik,iblock,nsize_sb_now
    end if

    ng = iba(ik)
    if(sw_divide_subspace==OFF) ng = np_g1k(ik)
    eko1 = sum(eko_d(1:neg))
!! (make matrix elements )
!    ! <n|T+Vloc|m> !
#ifdef NEC_TUNE
    allocate(w1hw2_(nsize_sb_now*kimg_t,nsize_sb_now))
    allocate(w1sw2_(nsize_sb_now*kimg_t,nsize_sb_now))

    if(kimg == 1) then
       allocate(zah_t(maxval(np_g1k),nsize_sb_now,1))
       allocate(zat_t(maxval(np_g1k),nsize_sb_now,1))
       num = 0
       do ibb1 = 1, nsize_max_sb_now
          if(ibover(ibb1,iblock) < 0) cycle
          iter1 = (ibb1-1)/nel+1
          ii1  = ibb1-nel*(iter1-1)
          ii1  = nsta+ii1-1
          num = num + 1
          zah_t(:,num,1) = zah_l(:,ii1,1,iter1)
          zat_t(:,num,1) = zat_l(:,ii1,1,iter1)
       end do
       k = np_g1k(ik); lda = maxval(np_g1k); ldb = maxval(np_g1k); ldc = nsize_sb_now
       call dgemm('T','N',num,num,k,1.0d0,zat_t,lda,zah_t,ldb,0.0d0,w1hw2_,ldc)
       call dgemm('T','N',num,num,k,1.0d0,zat_t,lda,zat_t,ldb,0.0d0,w1sw2_,ldc)
    else
      if(k_symmetry(ik) == GAMMA) then
         allocate(zah_t(maxval(np_g1k),nsize_sb_now,kimg))
         allocate(zat_t(maxval(np_g1k),nsize_sb_now,kimg))
         allocate(zah_t1(nsize_sb_now,kimg))
         allocate(zat_t1(nsize_sb_now,kimg))
         num = 0
         do ibb1 = 1, nsize_max_sb_now
            if(ibover(ibb1,iblock) < 0) cycle
            iter1 = (ibb1-1)/nel+1
            ii1  = ibb1-nel*(iter1-1)
            ii1  = nsta+ii1-1
            num = num + 1
            zah_t(:,num,1) = zah_l(:,ii1,1,iter1)
            zah_t(:,num,2) = zah_l(:,ii1,2,iter1)
            zat_t(:,num,1) = zat_l(:,ii1,1,iter1)
            zat_t(:,num,2) = zat_l(:,ii1,2,iter1)
         end do
         if(ista_g1k(ik) == 1) then
            zat_t1(:,:) = zat_t(1,:,:)
            zah_t1(:,:) = zah_t(1,:,:)
            zat_t(1,:,:) = zat_t(1,:,:)/sqrt(2.0d0)
            zah_t(1,:,:) = zah_t(1,:,:)/sqrt(2.0d0)
         end if
         k = np_g1k(ik); lda = maxval(np_g1k); ldb = maxval(np_g1k); ldc = nsize_sb_now
         call dgemm('T','N',num,num,k,2.0d0,zat_t(1,1,1),lda,zah_t(1,1,1),ldb,0.0d0,w1hw2_,ldc)
         call dgemm('T','N',num,num,k,2.0d0,zat_t(1,1,2),lda,zah_t(1,1,2),ldb,1.0d0,w1hw2_,ldc)
         call dgemm('T','N',num,num,k,2.0d0,zat_t(1,1,1),lda,zat_t(1,1,1),ldb,0.0d0,w1sw2_,ldc)
         call dgemm('T','N',num,num,k,2.0d0,zat_t(1,1,2),lda,zat_t(1,1,2),ldb,1.0d0,w1sw2_,ldc)
         if(ista_g1k(ik) == 1) then
            zat_t(1,:,:) = zat_t1(:,:)
            zah_t(1,:,:) = zah_t1(:,:)
         end if
         deallocate(zah_t1)
         deallocate(zat_t1)
      else
         allocate(zah_t(maxval(np_g1k)*kimg,nsize_sb_now,1))
         allocate(zat_t(maxval(np_g1k)*kimg,nsize_sb_now,1))
         num = 0
         do ibb1 = 1, nsize_max_sb_now
            if(ibover(ibb1,iblock) < 0) cycle
            iter1 = (ibb1-1)/nel+1
            ii1  = ibb1-nel*(iter1-1)
            ii1  = nsta+ii1-1
            num = num + 1
            do ii = 1, np_g1k(ik)
               zah_t(2*ii-1,num,1) = zah_l(ii,ii1,1,iter1)
               zah_t(2*ii,  num,1) = zah_l(ii,ii1,2,iter1)
               zat_t(2*ii-1,num,1) = zat_l(ii,ii1,1,iter1)
               zat_t(2*ii,  num,1) = zat_l(ii,ii1,2,iter1)
            end do
         end do
         k = np_g1k(ik); lda = maxval(np_g1k); ldb = maxval(np_g1k); ldc = nsize_sb_now
         call zgemm('C','N',num,num,k,c1,zat_t,lda,zah_t,ldb,c0,w1hw2_,ldc)
         call zgemm('C','N',num,num,k,c1,zat_t,lda,zat_t,ldb,c0,w1sw2_,ldc)
      end if
    end if
#else
    do ibb2 = 1,nsize_max_sb_now
       if(ibover(ibb2,iblock)<0) cycle
       ib2 = ibover(ibb2,iblock)
       iter2 = (ibb2-1)/nel+1
       ii2  = ibb2-nel*(iter2-1)
       ii2  = nsta+ii2-1
       ip0b = ib2*(ib2-1)/2
       do ibb1 = 1,ibb2
          if(ibover(ibb1,iblock)<0) cycle
          ib1 = ibover(ibb1,iblock)
          iter1 = (ibb1-1)/nel+1
          ii1 = ibb1-nel*(iter1-1)
          ii1 = nsta+ii1-1
          ip0 = ip0b + ib1
          if(kimg == 1) then
             w1hw2(ip0) = 0.d0
             w1sw2(ip0) = 0.d0
             do ii = ista_g1k(ik),iend_g1k(ik) ! MPI
                iadd = ii - ista_g1k(ik) + 1
                hr2 = zah_l(iadd,ii2,1,iter2)
                dr2 = zat_l(iadd,ii2,1,iter2)
                dr1 = zat_l(iadd,ii1,1,iter1)
                w1hw2(ip0) = w1hw2(ip0) + dr1*hr2
                w1sw2(ip0) = w1sw2(ip0) + dr1*dr2
             end do
             call mpi_allreduce(MPI_IN_PLACE,w1hw2(ip0),1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
             call mpi_allreduce(MPI_IN_PLACE,w1sw2(ip0),1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
          else
             if(k_symmetry(ik) == GAMMA) then
                w1hw2(ip0) = 0.d0
                w1sw2(ip0) = 0.d0
                do ii = max(2,ista_g1k(ik)), iend_g1k(ik) ! MPI
                   iadd = ii - ista_g1k(ik) + 1
                   hr2 = zah_l(iadd,ii2,1,iter2) ! MPI
                   hi2 = zah_l(iadd,ii2,2,iter2) ! MPI
                   dr2 = zat_l(iadd,ii2,1,iter2) ! MPI
                   di2 = zat_l(iadd,ii2,2,iter2) ! MPI
                   dr1 = zat_l(iadd,ii1,1,iter1) ! MPI
                   di1 = zat_l(iadd,ii1,2,iter1) ! MPI
                   w1hw2(ip0) =w1hw2(ip0)+(dr1*hr2+di1*hi2)*2.d0
                   w1sw2(ip0) =w1sw2(ip0)+(dr1*dr2+di1*di2)*2.d0
                end do
                if(ista_g1k(ik) == 1) then
                   hr2 = zah_l(1,ii2,1,iter2) ! MPI
                   hi2 = zah_l(1,ii2,2,iter2) ! MPI
                   dr2 = zat_l(1,ii2,1,iter2) ! MPI
                   di2 = zat_l(1,ii2,2,iter2) ! MPI
                   dr1 = zat_l(1,ii1,1,iter1) ! MPI
                   di1 = zat_l(1,ii1,2,iter1) ! MPI
                   w1hw2(ip0) =w1hw2(ip0)+dr1*hr2+di1*hi2
                   w1sw2(ip0) =w1sw2(ip0)+dr1*dr2+di1*di2
                end if
                call mpi_allreduce(MPI_IN_PLACE,w1hw2(ip0),1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                call mpi_allreduce(MPI_IN_PLACE,w1sw2(ip0),1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
             else
                w1hw2(2*ip0-1:2*ip0) = 0.d0
                w1sw2(2*ip0-1:2*ip0) = 0.d0
                do ii = ista_g1k(ik), iend_g1k(ik)
                   iadd = ii - ista_g1k(ik) + 1
                   hr2 = zah_l(iadd,ii2,1,iter2) ! MPI
                   hi2 = zah_l(iadd,ii2,2,iter2) ! MPI
                   dr2 = zat_l(iadd,ii2,1,iter2) ! MPI
                   di2 = zat_l(iadd,ii2,2,iter2) ! MPI
                   dr1 = zat_l(iadd,ii1,1,iter1) ! MPI
                   di1 = zat_l(iadd,ii1,2,iter1) ! MPI
                   w1hw2(2*ip0-1) =w1hw2(2*ip0-1)+dr1*hr2+di1*hi2
                   w1hw2(2*ip0  ) =w1hw2(2*ip0  )+dr1*hi2-di1*hr2
                   w1sw2(2*ip0-1) =w1sw2(2*ip0-1)+dr1*dr2+di1*di2
                   w1sw2(2*ip0  ) =w1sw2(2*ip0  )+dr1*di2-di1*dr2
                end do
                call mpi_allreduce(MPI_IN_PLACE,w1hw2(2*ip0-1),2,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                call mpi_allreduce(MPI_IN_PLACE,w1sw2(2*ip0-1),2,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
             end if
          end if
       end do
    end do
#endif
    if(ipridavidson >= 3 .and. ik == 1 .and. iblock == 1) call wd_w1hw2(" -- w1hw2 without nl part--",iblock)
    ! <n|Vnl|m>
!   if(myrank_g == 0) then
    call add_nonlocal_part ! w1hw2 = w1hw2 + w1Vnlw2
                           ! w1sw2 = w1sw2 + w1qw2
!   endif
#ifdef NEC_TUNE
    call mpi_allreduce(MPI_IN_PLACE,w1hw2_,nsize_sb_now*nsize_sb_now*kimg_t,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
    call mpi_allreduce(MPI_IN_PLACE,w1sw2_,nsize_sb_now*nsize_sb_now*kimg_t,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
#endif
    if(ipridavidson >= 3 .and. ik == 1 .and. iblock == 1) call wd_w1hw2(" -- w1hw2 with nl part--",iblock)
!
!!$    if(ipridavidson >= 2) call wd_w1hw2(" -- just after making w1hw2 --",iblock)
!    if(ipridavidson >= 2) then
!       write(nfout,*) 'neordr for ik = ',ik
!       write(nfout,9002) (neordr(ib1,ik),ib1=1,neg)
!       write(nfout,*) 'nrvf_ordr for ik = ',ik
!       write(nfout,9002) (nrvf_ordr(ib1,ik),ib1=1,neg)
!       write(nfout,*) 'eig'
!       write(nfout,'(5x,10f8.4)') (eko_l(ib1,ik),ib1=1,np_e)
!    endif
!9002 format(5x,10i8)

!! (Diagonalization )  !!

#ifdef NEC_TUNE
    if(kimg_t == 1) then
       call dsygvx_driver(eig, vec, w1hw2_, w1sw2_, ierr_diag, nel)
    else
       call zhegvx_driver(eig, vec, w1hw2_, w1sw2_, ierr_diag, nel)
    endif
!    deallocate(w1hw2_)
!    deallocate(w1sw2_)
#else
    if(kimg_t == 1) then
       call dspgvx_driver_loc(eig,vec,w1hw2,w1sw2,ierr_diag,nel)
    else
       call zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag,nel)
    endif
#endif

    frestart = .false.
    if(ierr_diag /= 0) then
!       zaj_l(:,:,ik,:) = zaj_l_backup(:,:,:)
!       do ib1 = 1, neg
!          if(map_e(ib1) == myrank_e) then         ! MPI
!             eko_l(map_z(ib1),ik)=eko_d(ib1)
!          end if
!       end do
      frestart = .true.
! === DEBUG by T.Kato 2013/08/01 ===============================================
!     do i=1,np_e
      do i=1,nel
! ==============================================================================
         zaj_l(:,i-1+nsta,ik,:)=zat_l(:,i,:,1)
      enddo
#ifdef SAVE_FFT_TIMES
      if(sw_save_fft == ON) then
         do i=1,nel
            status_saved_phifftr(i-1+nsta,ik) = OLD
         end do
      end if
#endif
      if(ipridavidson >= 2) then
        write(nfout,*) '** restart Modified Davidson iteration **'
        write(nfout,*) 'ik=',ik,' iblock=',iblock,' itot=',itot
      end if
      write(nfout,*) '** restart Modified Davidson **'
      write(nfout,*) 'ik=',ik,' iblock=',iblock,' itot=',itot
      call wd_w1hw2(" -- restart Modified Davidson iteration --",iblock)
!!$ print *,'Restart'
      goto 9000
    else

!      feigconv(nsta:nend) = .false.
      do ib=1,nel
         if(occup(nsta+ib-1) > 0.d0) then
            if(abs(eko_d(nsta+ib-1)-eig(ib)) < delta_eig_occup) &
                                                   feigconv(nsta+ib-1) = .true.
            if(feigconv(nsta+ib-1)) icountocc=icountocc+1
         else
            if(abs(eko_d(nsta+ib-1)-eig(ib)) < delta_eig_empty) &
                                                   feigconv(nsta+ib-1) = .true.
            if(feigconv(nsta+ib-1)) icountuocc=icountuocc+1
         end if
      end do
      if(ipri0 >= 2) then
         if(ik == 1 .and. iblock == 1) then
            write(nfout,*) 'eko_l for ik = ',ik
            write(nfout,*) 'iblock       = ',iblock
            write(nfout,9001) (eko_d(nsta+ib-1),ib=1,nel)
            write(nfout,*) 'eig for ik = ',ik
            write(nfout,9001) (eig(ib),ib=1,nel)
            if(ik == 1 .and. iblock == 1) call wd_w1hw2(" -- w1hw2 with nl part--",iblock)
            call wd_w1hw2(" -- after diagonalization --",iblock)
!sum eko
            dr1=0.d0;dr2=0.d0
            do ib1=1,nel
               dr1=dr1+eko_d(nsta+ib1-1) ! MPI
               dr2=dr2+eig(ib1)
            enddo
            write(nfout,'(" sum of eko_l, eig, abs diff =",3e25.10)') dr1,dr2,abs(dr2-dr1)
         end if
      endif
    endif

!!! (subspace rotation) !!
       call subspace_rotation ! vec,zat_l -> zat_l
       if(ipridavidson>=2 .and. ik==1 .and. iblock == 1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
!!( tenchi ) (zaj_l <- zat_l)
!       iter = min(idavid+1,ndavid)
!       call m_ES_W_transpose_back(ista_k,iend_k,ik,zaj_l,zat_l(1,1,1,iter))
!!       zaj_l_backup(:,nsta:nend,:) = zaj_l(:,nsta:nend,ik,:)
!! (eko_l)
    if(sw_divide_subspace==ON)then
       do ib1 = 1, nel
          eko_l(nsta+ib1-1,ik)=eig(ib1)
       end do
    else
       do ib1 = 1,neg
          if(map_e(ib1)==myrank_e) eko_l(map_z(ib1),ik) = eig(ib1)
       enddo
    endif

    if(ipridavidson >= 2) then
       if(ik == 1 .and. iblock == 1) then
          eko2 = sum(eig(1:nel))
          write(nfout,1201) ik,eko1,eko2

          write(nfout,*) 'eko_l'
          write(nfout,9001) (eko_d(nsta+ib1-1),ib1=1,nel)
       end if
    endif

1201 format(' %% for ik = ',i4,4x,' eko1&ekod&eko2 = ',3f14.7)
9001 format(5x,6f12.5)
!!! (neordr & nrvf_ordr)
!
9000 continue
!    neordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
!    nrvf_ordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
!
!! (deallocate)
#ifdef NEC_TUNE
    deallocate(zah_t)
    deallocate(zat_t)
#endif
    deallocate(eko_d)
    deallocate(occup)

    deallocate(eig)
    deallocate(vec)
#ifdef NEC_TUNE
    deallocate(w1hw2_)
    deallocate(w1sw2_)
#endif
    nullify(zah_l_p,zat_l_p,fsr_p,fsi_p,feigconv_p)
!
    call tstatc0_end(id_sname)
!
  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0
!
#ifdef NEC_TUNE
    subroutine wd_w1hw2(somecomment,iblock)
      character(len=*), intent(in) :: somecomment
      integer,intent(in) :: iblock
      integer :: ib1, ib2, nel_wd, nsb_wd
      write(nfout,'(a35)') somecomment
      write(nfout,*) 'w1hw2 for ik = ',ik
      nel_wd = 8
      nsb_wd = 8
      if(nel_wd > nel) nel_wd = nel
      if(nsb_wd > nsize_sb_now) nsb_wd = nsize_sb_now
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            write(nfout,9001) (w1hw2_(ib2,ip0),ip0=1,ib2)
         end do
      else
         do ib2=1,nsb_wd
            write(nfout,9001) (w1hw2_(2*ib2-1,ip0),ip0=1,ib2)
         end do
         do ib2=1,nsb_wd
            write(nfout,9001) (w1hw2_(2*ib2  ,ip0),ip0=1,ib2)
         end do
      end if
      write(nfout,*) 'w1sw2 for ik = ',ik
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            write(nfout,9001) (w1sw2_(ib2,ip0),ip0=1,ib2)
         end do
      else
         do ib2=1,nsb_wd
            write(nfout,9001) (w1sw2_(2*ib2-1,ip0),ip0=1,ib2)
         end do
         do ib2=1,nsb_wd
            write(nfout,9001) (w1sw2_(2*ib2  ,ip0),ip0=1,ib2)
         end do
      end if
9001  format(5x,9f12.5)
      write(nfout,*) 'eko_l for ik = ',ik
      write(nfout,9001) (eko_l(nsta+ib1-1,ik),ib1=1,nel_wd)
    end subroutine wd_w1hw2
#else
    subroutine wd_w1hw2(somecomment,iblock)
      character(len=*), intent(in) :: somecomment
      integer,intent(in) :: iblock
      integer :: ib1, ib2, nel_wd, nsb_wd
      write(nfout,'(a35)') somecomment
      write(nfout,*) 'w1hw2 for ik = ',ik
      nel_wd = 8
      nsb_wd = 8
      if(nel_wd > nel) nel_wd = nel
      if(nsb_wd > nsize_sb_now) nsb_wd = nsize_sb_now
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
      write(nfout,*) 'w1sw2 for ik = ',ik
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
9001  format(5x,9f12.5)
      write(nfout,*) 'eko_l for ik = ',ik
      write(nfout,9001) (eko_l(nsta+ib1-1,ik),ib1=1,nel_wd)
    end subroutine wd_w1hw2
#endif

    subroutine add_nonlocal_part
      integer :: ip,ib1,ib2,ibb1,ibb2
      integer       :: ia, lmt1, lmt2, it, p, s, ib
      real(kind=DP) :: facv,facq,vr,vi,qr,qi
      real(kind=DP) :: tmpr,tmpi
#ifdef NEC_TUNE
      real(kind=DP), dimension(nlmta,nel,itot+1) :: fsr_t, fsr_v, fsr_q
      real(kind=DP), dimension(nlmta,nel,itot+1) :: fsi_t, fsi_v, fsi_q
      real(kind=DP), allocatable, dimension(:,:) :: fsr_tt, fsr_vt, fsr_qt
      real(kind=DP), allocatable, dimension(:,:) :: fsi_tt, fsi_vt, fsi_qt
      integer :: iter, ncount, i,itot0
      itot0 = itot
      if(sw_MRCV_only==ON) itot0 = 1
      if(kimg == 1) then
         fsr_v = 0.0d0
         fsr_q = 0.0d0
         fsi_v = 0.0d0
         fsi_q = 0.0d0
         do iter = 1, itot0+1
            ncount = 0
            do ia = ista_atm, iend_atm
               it = ityp(ia)
               do lmt1 = 1, ilmt(it)
                  ncount = ncount + 1
                  p = lmta(lmt1,ia)
                  do ibb1 = 1, nel
                     ibb2 = nsta+ibb1-1
                     fsr_t(ncount,ibb1,iter) = fsr(ibb2,p,iter)
                     fsi_t(ncount,ibb1,iter) = fsi(ibb2,p,iter)
                  end do ! ibb1
                  do lmt2 = 1, ilmt(it)
                     s = lmta(lmt2,ia)
                     if(ipaw(it) == 0)then
                        facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     else
                        facv   = iwei(ia)*(dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     endif
                     facq   = iwei(ia)*q(lmt1,lmt2,it)
                     do ibb1 = 1, nel
                        ibb2 = nsta+ibb1-1
                        fsr_v(ncount,ibb1,iter) = fsr_v(ncount,ibb1,iter) + facv*fsr(ibb2,s,iter)
                        fsr_q(ncount,ibb1,iter) = fsr_q(ncount,ibb1,iter) + facq*fsr(ibb2,s,iter)
                        fsi_v(ncount,ibb1,iter) = fsi_v(ncount,ibb1,iter) + facv*fsi(ibb2,s,iter)
                        fsi_q(ncount,ibb1,iter) = fsi_q(ncount,ibb1,iter) + facq*fsi(ibb2,s,iter)
                     end do ! ibb1
                  end do ! lmt2
               end do ! lmt1
            end do ! ia
         end do ! iter
         allocate(fsr_tt(ncount,nsize_sb_now))
         allocate(fsr_vt(ncount,nsize_sb_now))
         allocate(fsr_qt(ncount,nsize_sb_now))
         allocate(fsi_tt(ncount,nsize_sb_now))
         allocate(fsi_vt(ncount,nsize_sb_now))
         allocate(fsi_qt(ncount,nsize_sb_now))
         num = 0
         do ibb1 = 1, nsize_max_sb_now
            if(ibover(ibb1,iblock)<0) cycle
            iter1=(ibb1-1)/nel+1
            ii1  = ibb1-nel*(iter1-1)
            num = num + 1
            fsr_tt(1:ncount,num) = fsr_t(1:ncount,ii1,iter1)
            fsr_vt(1:ncount,num) = fsr_v(1:ncount,ii1,iter1)
            fsr_qt(1:ncount,num) = fsr_q(1:ncount,ii1,iter1)
            fsi_tt(1:ncount,num) = fsi_t(1:ncount,ii1,iter1)
            fsi_vt(1:ncount,num) = fsi_v(1:ncount,ii1,iter1)
            fsi_qt(1:ncount,num) = fsi_q(1:ncount,ii1,iter1)
         end do
         ldc = nsize_sb_now
         if(ncount>0)then
            call dgemm('T','N',num,num,ncount,1.0d0,fsr_tt,ncount,fsr_vt,ncount,1.0d0,w1hw2_,ldc)
            call dgemm('T','N',num,num,ncount,1.0d0,fsi_tt,ncount,fsi_vt,ncount,1.0d0,w1hw2_,ldc)
            call dgemm('T','N',num,num,ncount,1.0d0,fsr_tt,ncount,fsr_qt,ncount,1.0d0,w1sw2_,ldc)
            call dgemm('T','N',num,num,ncount,1.0d0,fsi_tt,ncount,fsi_qt,ncount,1.0d0,w1sw2_,ldc)
         endif
         deallocate(fsr_tt)
         deallocate(fsr_vt)
         deallocate(fsr_qt)
         deallocate(fsi_tt)
         deallocate(fsi_vt)
         deallocate(fsi_qt)
      else ! if(kimg == 1)
         if(k_symmetry(ik) == GAMMA) then
            fsr_v = 0.0d0
            fsr_q = 0.0d0
            do iter = 1, itot0+1
               ncount = 0
               do ia = ista_atm, iend_atm
                  it = ityp(ia)
                  do lmt1 = 1, ilmt(it)
                     ncount = ncount + 1
                     p = lmta(lmt1,ia)
                     do ibb1 = 1, nel
                        ibb2 = nsta+ibb1-1
                        fsr_t(ncount,ibb1,iter) = fsr(ibb2,p,iter)
                     end do ! ibb1
                     do lmt2 = 1, ilmt(it)
                        s = lmta(lmt2,ia)
                        if(ipaw(it) == 0)then
                           facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                        else
                           facv   = iwei(ia)*(dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin))
                        endif
                        facq   = iwei(ia)*q(lmt1,lmt2,it)
                        do ibb1 = 1, nel
                           ibb2 = nsta+ibb1-1
                           fsr_v(ncount,ibb1,iter) = fsr_v(ncount,ibb1,iter) + facv*fsr(ibb2,s,iter)
                           fsr_q(ncount,ibb1,iter) = fsr_q(ncount,ibb1,iter) + facq*fsr(ibb2,s,iter)
                        end do ! ibb1
                     end do ! lmt2
                  end do ! lmt1
               end do ! ia
            end do ! iter
            allocate(fsr_tt(ncount,nsize_sb_now))
            allocate(fsr_vt(ncount,nsize_sb_now))
            allocate(fsr_qt(ncount,nsize_sb_now))
            num = 0
            do ibb1 = 1, nsize_max_sb_now
               if(ibover(ibb1,iblock)<0) cycle
               iter1=(ibb1-1)/nel+1
               ii1  = ibb1-nel*(iter1-1)
               num = num + 1
               fsr_tt(1:ncount,num) = fsr_t(1:ncount,ii1,iter1)
               fsr_vt(1:ncount,num) = fsr_v(1:ncount,ii1,iter1)
               fsr_qt(1:ncount,num) = fsr_q(1:ncount,ii1,iter1)
            end do
            ldc = nsize_sb_now
            if(ncount>0) then
               call dgemm('T','N',num,num,ncount,1.0d0,fsr_tt,ncount,fsr_vt,ncount,1.0d0,w1hw2_,ldc)
               call dgemm('T','N',num,num,ncount,1.0d0,fsr_tt,ncount,fsr_qt,ncount,1.0d0,w1sw2_,ldc)
            end if
            deallocate(fsr_tt)
            deallocate(fsr_vt)
            deallocate(fsr_qt)
         else ! if(k_symmetry(ik) == GAMMA)
            fsr_v = 0.0d0
            fsr_q = 0.0d0
            fsi_v = 0.0d0
            fsi_q = 0.0d0
            do iter = 1, itot0+1
               ncount = 0
               do ia = ista_atm, iend_atm
                  it = ityp(ia)
                  do lmt1 = 1, ilmt(it)
                     ncount = ncount + 1
                     p = lmta(lmt1,ia)
                     do ibb1 = 1, nel
                        ibb2 = nsta+ibb1-1
                        fsr_t(ncount,ibb1,iter) = fsr(ibb2,p,iter)
                        fsi_t(ncount,ibb1,iter) = fsi(ibb2,p,iter)
                     end do ! ibb1
                     do lmt2 = 1, ilmt(it)
                        s = lmta(lmt2,ia)
                        if(ipaw(it) == 0)then
                           facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                        else
                           facv   = iwei(ia)*(dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin))
                        endif
                        facq   = iwei(ia)*q(lmt1,lmt2,it)
                        do ibb1 = 1, nel
                           ibb2 = nsta+ibb1-1
                           fsr_v(ncount,ibb1,iter) = fsr_v(ncount,ibb1,iter) + facv*fsr(ibb2,s,iter)
                           fsr_q(ncount,ibb1,iter) = fsr_q(ncount,ibb1,iter) + facq*fsr(ibb2,s,iter)
                           fsi_v(ncount,ibb1,iter) = fsi_v(ncount,ibb1,iter) + facv*fsi(ibb2,s,iter)
                           fsi_q(ncount,ibb1,iter) = fsi_q(ncount,ibb1,iter) + facq*fsi(ibb2,s,iter)
                        end do ! ibb1
                     end do ! lmt2
                  end do ! lmt1
               end do ! ia
            end do ! iter
            allocate(fsr_tt(ncount*kimg,nsize_sb_now))
            allocate(fsr_vt(ncount*kimg,nsize_sb_now))
            allocate(fsr_qt(ncount*kimg,nsize_sb_now))
            num = 0
            do ibb1 = 1, nsize_max_sb_now
               if(ibover(ibb1,iblock)<0) cycle
               iter1=(ibb1-1)/nel+1
               ii1  = ibb1-nel*(iter1-1)
               num = num + 1
               do i = 1, ncount
                  fsr_tt(i*2-1,num) = fsr_t(i,ii1,iter1)
                  fsr_tt(i*2,  num) = fsi_t(i,ii1,iter1)
                  fsr_vt(i*2-1,num) = fsr_v(i,ii1,iter1)
                  fsr_vt(i*2,  num) = fsi_v(i,ii1,iter1)
                  fsr_qt(i*2-1,num) = fsr_q(i,ii1,iter1)
                  fsr_qt(i*2,  num) = fsi_q(i,ii1,iter1)
               end do
            end do
            ldc = nsize_sb_now
            if(ncount>0)then
               call zgemm('C','N',num,num,ncount,c1,fsr_tt,ncount,fsr_vt,ncount,c1,w1hw2_,ldc)
               call zgemm('C','N',num,num,ncount,c1,fsr_tt,ncount,fsr_qt,ncount,c1,w1sw2_,ldc)
            endif
            deallocate(fsr_tt)
            deallocate(fsr_vt)
            deallocate(fsr_qt)
         end if ! if(k_symmetry(ik) == GAMMA)
      end if ! if(kimg == 1)
#else
      do ibb2 = 1,nsize_max_sb_now
         if(ibover(ibb2,iblock)<0) cycle
         ib2 = ibover(ibb2,iblock)
         iter2= (ibb2-1)/nel+1
         ii2  = ibb2-nel*(iter2-1)
         ii2  = nsta+ii2-1
         ip0b = ib2*(ib2-1)/2
         do ibb1 = 1,ibb2
            if(ibover(ibb1,iblock)<0) cycle
            ib1 = ibover(ibb1,iblock)
            iter1=(ibb1-1)/nel+1
            ii1  = ibb1-nel*(iter1-1)
            ii1  = nsta+ii1-1
            ip0 = ip0b + ib1
!            if(mod(ip0-1,nrank_e)/=myrank_e) cycle
            if(kimg_t==1) then
               vr=0.d0
               qr=0.d0
            else
               vr=0.d0
               vi=0.d0
               qr=0.d0
               qi=0.d0
            end if
            do ia = 1, natm
               it = ityp(ia)
               do lmt1 = 1, ilmt(it)
                  p = lmta(lmt1,ia)
                  do lmt2 = 1, ilmt(it)
                     s = lmta(lmt2,ia)
                     if(ipaw(it)==0)then
                        facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     else
                        facv   = iwei(ia)*(dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     endif
                     facq   = iwei(ia)*q(lmt1,lmt2,it)
                     if(kimg==1) then
                        tmpr = fsr(ii1,p,iter1)*fsr(ii2,s,iter2)&
                    &        + fsi(ii1,p,iter1)*fsi(ii2,s,iter2)
                        vr = vr + facv*tmpr
                        qr = qr + facq*tmpr
                     else
                        if(k_symmetry(ik) == GAMMA) then
                           tmpr = fsr(ii1,p,iter1)*fsr(ii2,s,iter2)
                           vr = vr + facv*tmpr
                           qr = qr + facq*tmpr
                        else
                           tmpr = fsr(ii1,p,iter1)*fsr(ii2,s,iter2)&
                    &        + fsi(ii1,p,iter1)*fsi(ii2,s,iter2)
                           tmpi = fsr(ii1,p,iter1)*fsi(ii2,s,iter2)&
                    &        - fsi(ii1,p,iter1)*fsr(ii2,s,iter2)
                           vr = vr + facv*tmpr
                           vi = vi + facv*tmpi
                           qr = qr + facq*tmpr
                           qi = qi + facq*tmpi
                        end if
                     end if
                  end do
               end do
            end do
            if(kimg_t==1) then
               w1hw2(ip0) = w1hw2(ip0) + vr
               w1sw2(ip0) = w1sw2(ip0) + qr
            else
               w1hw2(2*ip0-1) = w1hw2(2*ip0-1) + vr
               w1hw2(2*ip0  ) = w1hw2(2*ip0  ) + vi
               w1sw2(2*ip0-1) = w1sw2(2*ip0-1) + qr
               w1sw2(2*ip0  ) = w1sw2(2*ip0  ) + qi
            end if
         end do
      end do
#endif
    end subroutine add_nonlocal_part


    subroutine subspace_rotation
      integer :: ib1,ib2,ibb2,iadd,is,is1
!!$      real(kind=DP), dimension(np_g1k_x,neg,kimg) :: zaj_wk
      real(kind=DP), allocatable, dimension(:,:,:) :: zaj_wk
      real(kind=DP), allocatable, dimension(:,:,:) :: zah_wk
      real(kind=DP), allocatable, dimension(:,:)   :: fsr_wk
      real(kind=DP), allocatable, dimension(:,:)   :: fsi_wk
#ifdef NEC_TUNE
      integer :: i
      real(kind=DP), allocatable, dimension(:,:)   :: fsr_t, fsi_t

      if(kimg==1) then
         allocate(zaj_wk(maxval(np_g1k),nel,kimg))
         if(itot /= max_iter_david) allocate(zah_wk(maxval(np_g1k),nel,kimg))
         allocate(fsr_wk(nel,np_fs),fsi_wk(nel,np_fs))
         allocate(fsr_t(nsize_sb_now,np_fs),fsi_t(nsize_sb_now,np_fs))
         num = 0
         do ibb2 = 1, nsize_max_sb_now
            if(ibover(ibb2,iblock) < 0) cycle
            iter2=(ibb2-1)/nel+1
            ii2=ibb2-nel*(iter2-1)
            ii2=nsta+ii2-1
            num = num + 1
            do ii = ista_fs, iend_fs
               i = ii - ista_fs + 1
               fsr_t(num,i) = fsr(ii2,ii,iter2)
               fsi_t(num,i) = fsi(ii2,ii,iter2)
            end do
         end do
         call dgemm('N','N',np_g1k(ik),nel,nsize_sb_now,1.0d0,zat_t,maxval(np_g1k),vec,nsize_sb_now,0.0d0,zaj_wk,maxval(np_g1k))
         call dgemm('T','N',nel,np_fs,nsize_sb_now,1.0d0,vec,nsize_sb_now,fsr_t,nsize_sb_now,0.0d0,fsr_wk,nel)
         call dgemm('T','N',nel,np_fs,nsize_sb_now,1.0d0,vec,nsize_sb_now,fsi_t,nsize_sb_now,0.0d0,fsi_wk,nel)
         if(itot /= max_iter_david) then
            call dgemm('N','N',np_g1k(ik),nel,nsize_sb_now,1.0d0,zah_t,maxval(np_g1k),vec,nsize_sb_now,0.0d0,zah_wk,maxval(np_g1k))
         end if
         zaj_l(:,nsta:nend,ik,:) = zaj_wk(:,:,:)
#ifdef SAVE_FFT_TIMES
         if(sw_save_fft == ON) status_saved_phifftr(nsta:nend,ik) = OLD
#endif
         if(itot /= max_iter_david) zah_l(:,nsta:nend,:,1) = zah_wk(:,:,:)
         do is = 1, np_fs ! MPI
            do ib = nsta, nend ! MPI
               fsr_l(ib,is,ik) = fsr_wk(ib-nsta+1,is)
               fsi_l(ib,is,ik) = fsi_wk(ib-nsta+1,is)
            end do
         end do
         deallocate(fsr_t,fsi_t)
         deallocate(zaj_wk,fsr_wk,fsi_wk)
         if(itot /= max_iter_david) deallocate(zah_wk)
      else
         if(k_symmetry(ik) == GAMMA) then
            allocate(zaj_wk(maxval(np_g1k),nel,kimg))
            if(itot /= max_iter_david) allocate(zah_wk(maxval(np_g1k),nel,kimg))
            allocate(fsr_wk(nel,np_fs))
            allocate(fsr_t(nsize_sb_now,np_fs))
            num = 0
            do ibb2 = 1, nsize_max_sb_now
               if(ibover(ibb2,iblock) < 0) cycle
               iter2=(ibb2-1)/nel+1
               ii2=ibb2-nel*(iter2-1)
               ii2=nsta+ii2-1
               num = num + 1
               do ii = ista_fs, iend_fs
                  i = ii - ista_fs + 1
                  fsr_t(num,i) = fsr(ii2,ii,iter2)
               end do
            end do
            call dgemm('N','N',np_g1k(ik),nel,nsize_sb_now,1.0d0,zat_t(1,1,1),   maxval(np_g1k), &
            & vec,nsize_sb_now,0.0d0,zaj_wk(1,1,1),   maxval(np_g1k))
            call dgemm('N','N',np_g1k(ik),nel,nsize_sb_now,1.0d0,zat_t(1,1,kimg),maxval(np_g1k), &
            & vec,nsize_sb_now,0.0d0,zaj_wk(1,1,kimg),maxval(np_g1k))
            call dgemm('T','N',nel,np_fs,nsize_sb_now,1.0d0,vec,nsize_sb_now,fsr_t,nsize_sb_now,0.0d0,fsr_wk,nel)
            if(itot /= max_iter_david) then
               call dgemm('N','N',np_g1k(ik),nel,nsize_sb_now,1.0d0,zah_t(1,1,1),   maxval(np_g1k), &
            & vec,nsize_sb_now,0.0d0,zah_wk(1,1,1),   maxval(np_g1k))
               call dgemm('N','N',np_g1k(ik),nel,nsize_sb_now,1.0d0,zah_t(1,1,kimg),maxval(np_g1k), &
            & vec,nsize_sb_now,0.0d0,zah_wk(1,1,kimg),maxval(np_g1k))
            end if
            zaj_l(:,nsta:nend,ik,:) = zaj_wk(:,:,:)
#ifdef SAVE_FFT_TIMES
            if(sw_save_fft == ON) status_saved_phifftr(nsta:nend,ik) = OLD
#endif
            if(itot /= max_iter_david) zah_l(:,nsta:nend,:,1) = zah_wk(:,:,:)
            do is = 1, np_fs ! MPI
               do ib = nsta, nend ! MPI
                  fsr_l(ib,is,ik) = fsr_wk(ib-nsta+1,is)
               end do
            end do
            deallocate(fsr_t)
            deallocate(zaj_wk,fsr_wk)
            if(itot /= max_iter_david) deallocate(zah_wk)
         else
            allocate(zaj_wk(maxval(np_g1k)*kimg,nel,1))
            if(itot /= max_iter_david) allocate(zah_wk(maxval(np_g1k)*kimg,nel,1))
            allocate(fsr_wk(nel*kimg,np_fs))
            allocate(fsr_t(nsize_sb_now*kimg,np_fs))
            num = 0
            do ibb2 = 1, nsize_max_sb_now
               if(ibover(ibb2,iblock) < 0) cycle
               iter2=(ibb2-1)/nel+1
               ii2=ibb2-nel*(iter2-1)
               ii2=nsta+ii2-1
               num = num + 1
               do ii = ista_fs, iend_fs
                  i = ii - ista_fs + 1
                  fsr_t(2*num-1,i) = fsr(ii2,ii,iter2)
                  fsr_t(2*num,  i) = fsi(ii2,ii,iter2)
               end do
            end do
            call zgemm('N','N',np_g1k(ik),nel,nsize_sb_now,c1,zat_t,maxval(np_g1k),vec,nsize_sb_now,c0,zaj_wk,maxval(np_g1k))
            call zgemm('T','N',nel,np_fs,nsize_sb_now,c1,vec,nsize_sb_now,fsr_t,nsize_sb_now,c0,fsr_wk,nel)
            if(itot /= max_iter_david) then
               call zgemm('N','N',np_g1k(ik),nel,nsize_sb_now,c1,zah_t,maxval(np_g1k),vec,nsize_sb_now,c0,zah_wk,maxval(np_g1k))
            end if
            do ib = nsta, nend
               i = ib - nsta + 1
               do ii = 1, np_g1k(ik)
                  zaj_l(ii,ib,ik,1)    = zaj_wk(2*ii-1,i,1)
                  zaj_l(ii,ib,ik,kimg) = zaj_wk(2*ii,  i,1)
               end do
            end do
#ifdef SAVE_FFT_TIMES
            if(sw_save_fft == ON) status_saved_phifftr(nsta:nend,ik) = OLD
#endif
            if(itot /= max_iter_david) then
               do ib = nsta, nend
                  i = ib - nsta + 1
                  do ii = 1, np_g1k(ik)
                     zah_l(ii,ib,1,   1) = zah_wk(2*ii-1,i,1)
                     zah_l(ii,ib,kimg,1) = zah_wk(2*ii,  i,1)
                  end do
               end do
            end if
            do is = 1, np_fs ! MPI
               do ib = nsta, nend ! MPI
                  i = ib - nsta + 1
                  fsr_l(ib,is,ik) = fsr_wk(2*i-1,is)
                  fsi_l(ib,is,ik) = fsr_wk(2*i,  is)
               end do
            end do
            deallocate(fsr_t)
            deallocate(zaj_wk,fsr_wk)
            if(itot /= max_iter_david) deallocate(zah_wk)
         end if
      end if
#else
      allocate(zaj_wk(maxval(np_g1k),nel,kimg))
      if(itot /= max_iter_david) then
        allocate(zah_wk(maxval(np_g1k),nel,kimg))
        zah_wk(:,:,:) = 0.d0
      end if
      allocate(fsr_wk(nel,nlmta))
      if(k_symmetry(ik) /= GAMMA) then
        allocate(fsi_wk(nel,nlmta))
        fsi_wk(:,:)=0.d0
      end if

      zaj_wk(:,:,:) = 0.d0
      fsr_wk(:,:)=0.d0
      if(kimg==1) then
         do ib1=1,nel
            do ibb2=1,nsize_max_sb_now
               if(ibover(ibb2,iblock)<0) cycle
               ib2 = ibover(ibb2,iblock)
               iter2=(ibb2-1)/nel+1
               ii2=ibb2-nel*(iter2-1)
               ii2=nsta+ii2-1
               hr2=vec(ib2,ib1)
               do ii=ista_g1k(ik),iend_g1k(ik)
                  iadd = ii - ista_g1k(ik) + 1
                  zaj_wk(iadd,ib1,kimg) = zaj_wk(iadd,ib1,kimg) + zat_l(iadd,ii2,kimg,iter2)*hr2
               end do
               do ii=1,nlmta
                 fsr_wk(ib1,ii) = fsr_wk(ib1,ii) + fsr(ii2,ii,iter2)*hr2
                 fsi_wk(ib1,ii) = fsi_wk(ib1,ii) + fsi(ii2,ii,iter2)*hr2
               end do
               if(itot /= max_iter_david) then
                 do ii=ista_g1k(ik),iend_g1k(ik)
                    iadd = ii - ista_g1k(ik) + 1
                    zah_wk(iadd,ib1,kimg) = zah_wk(iadd,ib1,kimg) + zah_l(iadd,ii2,kimg,iter2)*hr2
                 end do
               end if
            end do
         end do
      else
         if(k_symmetry(ik) == GAMMA) then
            do ib1=1,nel
               do ibb2=1,nsize_max_sb_now
                  if(ibover(ibb2,iblock)<0) cycle
                  ib2 = ibover(ibb2,iblock)
                  iter2=(ibb2-1)/nel+1
                  ii2=ibb2-nel*(iter2-1)
                  ii2=nsta+ii2-1
                  hr2=vec(ib2,ib1)
                  do ii=ista_g1k(ik),iend_g1k(ik)
                     iadd = ii - ista_g1k(ik) + 1
                     dr1=zat_l(iadd,ii2,1   ,iter2)
                     di1=zat_l(iadd,ii2,kimg,iter2)
                     zaj_wk(iadd,ib1,1   ) = zaj_wk(iadd,ib1,1   ) + dr1*hr2
                     zaj_wk(iadd,ib1,kimg) = zaj_wk(iadd,ib1,kimg) + di1*hr2
                  end do
                  do ii=1,nlmta
                    fsr_wk(ib1,ii) = fsr_wk(ib1,ii) + fsr(ii2,ii,iter2)*hr2
                  end do
                  if(itot /= max_iter_david) then
                    do ii=ista_g1k(ik),iend_g1k(ik)
                       iadd = ii - ista_g1k(ik) + 1
                       dr1=zah_l(iadd,ii2,1   ,iter2)
                       di1=zah_l(iadd,ii2,kimg,iter2)
                       zah_wk(iadd,ib1,1   ) = zah_wk(iadd,ib1,1   ) + dr1*hr2
                       zah_wk(iadd,ib1,kimg) = zah_wk(iadd,ib1,kimg) + di1*hr2
                    end do
                  end if
               end do
            end do
         else
            do ib1=1,nel
               do ibb2=1,nsize_max_sb_now
                  if(ibover(ibb2,iblock)<0) cycle
                  ib2 = ibover(ibb2,iblock)
                  iter2=(ibb2-1)/nel+1
                  ii2=ibb2-nel*(iter2-1)
                  ii2=nsta+ii2-1
                  hr2=vec(2*ib2-1,ib1)
                  hi2=vec(2*ib2  ,ib1)
                  do ii=ista_g1k(ik),iend_g1k(ik)
                     iadd = ii - ista_g1k(ik) + 1
                     dr1=zat_l(iadd,ii2,1   ,iter2)
                     di1=zat_l(iadd,ii2,kimg,iter2)
                     zaj_wk(iadd,ib1,1   ) = zaj_wk(iadd,ib1,1   ) + dr1*hr2 - di1*hi2
                     zaj_wk(iadd,ib1,kimg) = zaj_wk(iadd,ib1,kimg) + dr1*hi2 + di1*hr2
                  end do
                  do ii=1,nlmta
                     dr1=fsr(ii2,ii,iter2)
                     di1=fsi(ii2,ii,iter2)
                     fsr_wk(ib1,ii) = fsr_wk(ib1,ii) + dr1*hr2 - di1*hi2
                     fsi_wk(ib1,ii) = fsi_wk(ib1,ii) + dr1*hi2 + di1*hr2
                  end do
                  if(itot /= max_iter_david) then
                    do ii=ista_g1k(ik),iend_g1k(ik)
                       iadd = ii - ista_g1k(ik) + 1
                       dr1=zah_l(iadd,ii2,1   ,iter2)
                       di1=zah_l(iadd,ii2,kimg,iter2)
                       zah_wk(iadd,ib1,1   ) = zah_wk(iadd,ib1,1   ) + dr1*hr2 - di1*hi2
                       zah_wk(iadd,ib1,kimg) = zah_wk(iadd,ib1,kimg) + dr1*hi2 + di1*hr2
                    end do
                  end if
               end do
            end do
         end if
      end if
!print *,itot,  itot /= max_iter_david
      zaj_l(:,nsta:nend,ik,:) = zaj_wk(:,:,:)
#ifdef SAVE_FFT_TIMES
      if(sw_save_fft == ON) status_saved_phifftr(nsta:nend,ik) = OLD
#endif
      if(itot /= max_iter_david) zah_l(:,nsta:nend,:,1) = zah_wk(:,:,:)
!     fsr_l(nsta:nend,:,ik) = fsr_wk(:,:)
      do is = 1, np_fs ! MPI
         is1=nis_fs(myrank_g)+is-1
         do ib = nsta, nend ! MPI
             fsr_l(ib,is,ik) = fsr_wk(ib-nsta+1,is1)
         end do
      end do
!     if(k_symmetry(ik) /= GAMMA) fsi_l(nsta:nend,:,ik) = fsi_wk(:,:)
      if(k_symmetry(ik) /= GAMMA) then
         do is = 1, np_fs ! MPI
            is1=nis_fs(myrank_g)+is-1
            do ib = nsta, nend ! MPI
               fsi_l(ib,is,ik) = fsi_wk(ib-nsta+1,is1)
            end do
         end do
      end if

      deallocate(zaj_wk,fsr_wk)
      if(itot /= max_iter_david) deallocate(zah_wk)
      if(k_symmetry(ik) /= GAMMA) deallocate(fsi_wk)
#endif
    end subroutine subspace_rotation

  end subroutine evolve_WFs_in_subspace_3D

  subroutine decide_correction_vector_3D(precon,ik,ispin,ekin_l, &
                                         ibsize,p_l,itot, &
                                         lsize, bfft_l, wk_bfft_l ,afft_l )
    integer, intent(in)       :: precon, ik, ispin, ibsize
    real(kind=DP), intent(in)  :: ekin_l(maxval(np_g1k))
    integer, intent(in) :: lsize
#ifdef FFT_3D_DIVISION
    real(kind=DP), intent(in), optional  :: afft_l(lsize*2   )
    real(kind=DP), intent(out), optional :: bfft_l(lsize*2   ,1)
    real(kind=DP), intent(inout), optional :: wk_bfft_l(lsize*2   ,ibsize)
#else
    real(kind=DP), intent(in), optional  :: afft_l(lsize*kimg)
!!!$    real(kind=DP), intent(out) :: bfft_l(lsize*kimg,1)
    real(kind=DP), intent(out), optional :: bfft_l(lsize*kimg,ibsize)
    real(kind=DP), intent(inout), optional :: wk_bfft_l(lsize*kimg,ibsize)
#endif
    integer,       intent(in)  :: itot
    real(kind=DP)              :: p_l(maxval(np_g1k))
    integer :: ib,ib1,ib2,ibesize, iflag
    integer :: nsize
    integer :: isrsize, fft_l_size
#ifdef MPI_FFTW
    integer(C_INTPTR_T)  :: local_n, local_n_offset, alloc_local, lx, ly, lz, mx,my,mz
#endif
    real(kind=DP), allocatable, dimension(:,:) :: vexx
    real(kind=DP), allocatable, dimension(:,:) :: vtau_phl

    integer :: ng
    integer :: id_sname = -1, id_sname1 = -1, id_sname2 = -1, id_sname3 = -1, id_sname4 = -1, id_sname5 = -1
    call tstatc0_begin('decide_correction_vector_3D(0) ', id_sname,1)

    isrsize = min(lsize,mp_g1k(ik))
#ifdef MPI_FFTW
    if(sw_mpi_fftw==ON) then
      fft_l_size  = lsize
    else
      fft_l_size  = nel_fft_x(myrank_g)
    endif
#else
    fft_l_size  = nel_fft_x(myrank_g)
#endif
    if(sw_hybrid_functional==ON) then
        ng = maxval(np_g1k)
        allocate(vexx(ng,kimg))
        vexx = 0.0d0
    else
        ng = 1
        allocate(vexx(ng,kimg))
        vexx = 0.0d0
     endif
    if ( use_metagga .and. vtau_exists ) then
       allocate( vtau_phl(maxval(np_g1k),kimg) );  vtau_phl = 0.0d0
    endif

#ifdef MPI_FFTW
!    if(itot==1 .and. sw_keep_hloc_phi==OFF .and. sw_mpi_fftw==ON) then
    if (sw_mpi_fftw==ON) then
      lx = fft_box_size_WF(1,0)
      ly = fft_box_size_WF(2,0)
      lz = fft_box_size_WF(3,0)
      if(kimg==2) then
        alloc_local = fftw_mpi_local_size_3d(ly,lz,lx,mpi_ke_world,local_n,local_n_offset)
      else
        alloc_local = fftw_mpi_local_size_3d(ly,lz,lx/2,mpi_ke_world,local_n,local_n_offset)
      endif
    endif
#endif

!    iflag = 0
!    if ( use_metagga .and. vtau_exists ) iflag = 1
    do ib1 = 1, np_e, ibsize
       if(sw_hybrid_functional==ON) then
          if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
             call m_ES_EXX_potential(nfout,ispin,ib1,ik,ng,fsr_l(ib1,:,ik),fsi_l(ib1,:,ik),vexx,0)
          else
             call m_ES_EXX_potential(nfout,ispin,ib1,ik,ng,fsr_l(ib1,:,ik),fsr_l(ib1,:,ik),vexx,0)
          endif
       endif

       if ( use_metagga .and. vtau_exists ) then
#ifdef MPI_FFTW
          if ( sw_mpi_fftw == ON ) then
             call m_ES_kindens_to_vnlph_ib2_mpfw( ispin, ik, ib1, lsize, &
                  &             lx, ly, lz, local_n, cfft_mpifftw_vlocal, vtau_phl )
          else
             call m_ES_kindens_to_vnlph_ib2( ispin, ik, ib1, lsize, cfft_l, vtau_phl )
          endif
#else
          call m_ES_kindens_to_vnlph_ib2( ispin, ik, ib1, lsize, cfft_l, vtau_phl )
#endif
       endif

!       if((itot==1 .and. sw_keep_hloc_phi==OFF) .or. iflag==1) then
       if( itot==1 .and. sw_keep_hloc_phi==OFF ) then
         ib2 = min(ib1+ibsize-1,np_e)
         ibesize = ib2 - ib1 + 1

#ifdef __TIMER_COMM__
!!$       ib = ib1
         call m_ES_WF_in_Rspace_3D(ik,ib1,ib2,ibsize,lsize,wk_bfft_l,0)
#else
#ifdef MPI_FFTW
         if(sw_mpi_fftw==ON) then
           call m_ES_WF_in_Rspace_mpifftw(ista_k,iend_k,ik,ib1,zaj_l)
         else
           call m_ES_WF_in_Rspace_3D(ik,ib1,ib2,ibsize,lsize,wk_bfft_l)
         endif
#else
         call m_ES_WF_in_Rspace_3D(ik,ib1,ib2,ibsize,lsize,wk_bfft_l)
#endif
#endif
#ifdef FFT_3D_DIVISION
         call m_FFT_Vlocal_W_3DIV_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_x(myrank_g))
         call m_FFT_Direct_3DIV_3D(nfout,wk_bfft_l,lsize,ibsize)
#else
#ifdef MPI_FFTW
         if(sw_mpi_fftw==ON) then
           nsize = local_n*lx*ly
           call m_FFT_Vlocal_W_mpifftw3d(afft_mpifftw_vlocal,lx,local_n,lz)
           call m_FFT_Direct_MPI_FFTW(nfout)
         else
           call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
           call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
         endif
#else
         if (sw_fft_xzy > 0) then
            call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_y(myrank_g))
            call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
         else
            call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
            if(sw_serial_fft == ON) then
               call m_ES_WF_2D(ik,wk_bfft_l,ib2,ib1,ibsize,lsize,DIRECT)
            else
               call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
            endif
         end if
#endif
#endif
#ifdef MPI_FFTW
         if(sw_mpi_fftw==ON) then
            call map_fft_to_WF_mpifftw(ik,lsize,ibesize,bfft_l,isrsize,fft_l_size)
         else
            call map_fft_to_WF_3D(ik,lsize,ibesize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
         endif
#else
         call map_fft_to_WF_3D(ik,lsize,ibesize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
#endif
         if ( use_metagga .and. vtau_exists ) then
            if(ibsize == 1) then
               call SD_direction_3D( precon, ik, ib1, ekin_l, p_l, itot, lsize, &
                    &                ng, vexx, vtau_phl=vtau_phl, VlocalW=bfft_l ) !-here
            else
               call SD_direction_3D2( precon, ik, ib1, ib2, ibesize, ekin_l, p_l, &
                    &                 itot, lsize, ng, vexx, vtau_phl=vtau_phl, &
                    &                 VlocalW=bfft_l ) !-here
            end if
         else
            if(ibsize == 1) then
               call SD_direction_3D( precon, ik, ib1, ekin_l, p_l, itot, lsize, &
                    &                ng, vexx, VlocalW=bfft_l ) !-here
            else
               call SD_direction_3D2( precon, ik, ib1, ib2, ibesize, ekin_l, p_l, &
                    &                 itot, lsize, ng, vexx, VlocalW=bfft_l ) !-here
            end if
         endif
      else
         if ( use_metagga .and. vtau_exists ) then
            if(ibsize == 1) then
               call SD_direction_3D( precon, ik, ib1, ekin_l, p_l, itot, lsize, &
                    &                ng, vexx, vtau_phl=vtau_phl ) !-here
            else
               call SD_direction_3D2( precon, ik, ib1, ib2, ibesize, ekin_l, p_l, &
                    &                 itot, lsize, ng, vexx, vtau_phl=vtau_phl ) !-here
            end if
         else
            if(ibsize == 1) then
               call SD_direction_3D(precon,ik,ib1,ekin_l,p_l,itot,lsize,ng,vexx) !-here
            else
               call SD_direction_3D2(precon,ik,ib1,ib2,ibesize,ekin_l,p_l,itot,lsize,ng,vexx) !-here
            end if
         endif
      endif
   end do
   deallocate(vexx)
   if ( allocated( vtau_phl) ) deallocate( vtau_phl )

    call mpi_barrier(mpi_k_world(myrank_k),ierr)

!    call orthogonalize_SD_drctns(ik,to=OTHER_BANDS)  ! -(m_ES_WF_by_SDorCG) ->(wfsd_l, bsd(ri)_l)
    call orthogonalize_SD_drctns(ik,to=OTHER_BANDS)
    if(ipridavidson>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
!    call orthogonalize_SD_drctns(ik,to=ALL_BANDS)  ! -(m_ES_WF_by_SDorCG) ->(wfsd_l, bsd(ri)_l)

    call normalize_wfsd_3D(ik)

    call tstatc0_end(id_sname)
  end subroutine decide_correction_vector_3D

  subroutine orthogonalize_SD_drctns(ik,to)
    integer, intent(in) :: ik,to

    integer :: itmp
    integer :: id_sname = -1
    real(kind=DP), allocatable, dimension(:,:) :: fs_mpi
    integer :: is, is1, ib
    call tstatc0_begin('orthogonalize_SD_drctns(Mddavid) ', id_sname)

!    if(modnrm == EXECUT) call m_ES_betar_dot_Psi_4_each_k(nfout,wfsd_l,ik,ik,ik,bsdr_l,bsdi_l)
    !                                        ->bsd(ri)_l

    if(sw_MRCV_only==OFF)then
       zat_l(:,:,:,1) = zaj_l(:,:,ik,:)
!      allocate(fs_mpi(np_e,nlmta))
!!$       allocate(fs_mpi2(np_e,nlmta))
       call m_ES_gather_f_3d_to_2d_k(fsr_l(:,:,ik),  fsr(:,:,1))
       if( k_symmetry(ik) /= GAMMA ) then
         call m_ES_gather_f_3d_to_2d_k(fsi_l(:,:,ik),  fsi(:,:,1))
       endif
!      fs_mpi=0.d0
!      do is = 1, np_fs ! MPI
!         is1=nis_fs(myrank_g)+is-1
!         do ib = 1, np_e ! MPI
!            fs_mpi(ib,is1) = fsr_l(ib,is,ik)
!         end do
!      end do
!      call mpi_allreduce(MPI_IN_PLACE,fs_mpi,np_e*nlmta &
!        & ,mpi_double_precision,mpi_sum, mpi_ke_world,ierr)       ! MPI
!      fsr(1:np_e,1:nlmta,1) = fs_mpi(1:np_e,1:nlmta)
!      if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!         fs_mpi=0.d0
!         do is = 1, np_fs ! MPI
!            is1=nis_fs(myrank_g)+is-1
!            do ib = 1, np_e ! MPI
!               fs_mpi(ib,is1) = fsi_l(ib,is,ik)
!            end do
!         end do
!         call mpi_allreduce(MPI_IN_PLACE,fs_mpi,np_e*nlmta &
!           & ,mpi_double_precision,mpi_sum ,mpi_ke_world,ierr)       ! MPI
!         fsi(1:np_e,1:nlmta,1) = fs_mpi(1:np_e,1:nlmta)
!      end if
!      deallocate(fs_mpi)

       zaj_l(:,:,ik,:) = zajold_l(:,:,:)
       fsr_l(:,:,ik) = fsrold_l(:,:)
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          fsi_l(:,:,ik) = fsiold_l(:,:)
       end if
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(:,ik) = OLD
#endif
    endif

!!$    itmp=modnrm
!!$    modnrm=EXECUT
!!$    itmp=modnrm
!!$    modnrm=EXECUT
!!$    call m_ES_betar_dot_Psi_4_each_k_3D(wfsd_l,ik,ik,ik,bsdr_l,bsdi_l)
!!$    call m_ES_orthogonalize_SD_to_WFs_3D(ik,to,wfsd_l,bsdr_l,bsdi_l) ! ->(wfsd_l,bsd(ri)_l)
!!$    modnrm=itmp
    if(modnrm==EXECUT) then
       call m_ES_betar_dot_Psi_4_each_k_3D(nfout,wfsd_l,ik,ik,ik,bsdr_l,bsdi_l,map=feigconv)
       call m_ES_orthogonal_phi_to_WFs(ik,wfsd_l,bsdr_l,bsdi_l) ! ->(wfsd_l,bsd(ri)_l)
    else
       call m_ES_orthogonal_phi_to_WFs(ik,wfsd_l,bsdr_l,bsdi_l) ! ->(wfsd_l,bsd(ri)_l)
       call m_ES_betar_dot_Psi_4_each_k_3D(nfout,wfsd_l,ik,ik,ik,bsdr_l,bsdi_l,map=feigconv)
    end if
    call tstatc0_end(id_sname)
  end subroutine orthogonalize_SD_drctns

  logical function allbands_converged()
    integer :: ib,ierr
    logical :: logi
    logi = .true.
    do ib=1,np_e
      if(.not.feigconv(ib)) then
        logi = .false.
        exit
      endif
    enddo
    call mpi_allreduce(mpi_in_place,logi,1,mpi_logical,mpi_land,mpi_k_world(myrank_k),ierr)
    allbands_converged = logi
  end function allbands_converged

#endif
end module m_ES_WF_by_ModifiedDavidson

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: gsort, spsort, shellsort, sort_gvec_within_shell_by_heap,
!             sift_down, sort_gvec_heap, sift_down, swap_i, 
!             sort_gvec_quick, sort_gvec_simple
!
!  AUTHOR(S): T. Yamasaki, M. Okamoto,    August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!

! $Id: b_PlaneWaveBasisSet.F90 570 2017-04-21 20:34:50Z yamasaki $

!#####################################################################

subroutine sort_gvec_simple(ttr,k,n,ngvec)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: sort_gvec_simple
!
!  AUTHOR(S): M. Okamoto   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP),intent(in),dimension(6) :: ttr
  integer,intent(in)                    :: k, n
  integer,intent(inout),dimension(k,3)  :: ngvec
  real(kind=DP),allocatable :: norm_gvec(:)
  integer,allocatable :: idx_gvec(:), ngvec_tmp(:,:)
  integer :: i, j, ipos, jpos, ia, ib, ic
  real(kind=DP) :: sum, norm_gi, norm_gj
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  allocate(norm_gvec(n),idx_gvec(n),ngvec_tmp(k,3))
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  do i = 1,n
     ia = ngvec(i,1) ; ib = ngvec(i,2) ; ic = ngvec(i,3)
     sum = ttr(1)*ia*ia + ttr(2)*ib*ib + ttr(3)*ic*ic &
         + ttr(4)*ia*ib + ttr(5)*ib*ic + ttr(6)*ic*ia
     norm_gvec(i) = sqrt(sum)
     idx_gvec (i) = i
  end do
  do i = 1,n-1
     ipos    = idx_gvec(i)
     norm_gi = norm_gvec(ipos)
     do j = i+1,n
        jpos    = idx_gvec(j)
        norm_gj = norm_gvec(jpos)
        if (norm_gi > norm_gj) then
           idx_gvec(i) = jpos
           idx_gvec(j) = ipos
           ipos    = jpos
           norm_gi = norm_gj
        end if
     end do
  end do
  ngvec_tmp(:,:) = ngvec(:,:)
  do i = 1,n
     ngvec(i,:) = ngvec_tmp(idx_gvec(i),:)
  end do
 !+++++++++++++++++++++++++++++++++++++++++++
  deallocate(norm_gvec,idx_gvec,ngvec_tmp)
 !+++++++++++++++++++++++++++++++++++++++++++
end subroutine sort_gvec_simple


subroutine sort_gvec_quick(ttr,k,n,ngvec)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: sort_gvec_quick
!
!  AUTHOR(S): M. Okamoto   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP),intent(in),dimension(6) :: ttr
  integer,intent(in)                    :: k, n
  integer,intent(inout),dimension(k,3)  :: ngvec
  real(kind=DP),allocatable :: norm_gvec(:)
  integer,allocatable :: idx_gvec(:), ngvec_tmp(:,:)
  integer :: i, j, ia, ib, ic
  real(kind=DP) :: sum, v0
  integer,parameter :: NN=15, NSTACK=50
  integer :: jstack, l, r, ipos, jpos, ll, kk, istack(NSTACK)
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  allocate(norm_gvec(n),idx_gvec(n),ngvec_tmp(k,3))
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  do i = 1,n
     ia = ngvec(i,1) ; ib = ngvec(i,2) ; ic = ngvec(i,3)
     sum = ttr(1)*ia*ia + ttr(2)*ib*ib + ttr(3)*ic*ic &
         + ttr(4)*ia*ib + ttr(5)*ib*ic + ttr(6)*ic*ia
     norm_gvec(i) = sqrt(sum)
     idx_gvec (i) = i
  end do
  jstack = 0
  l = 1
  r = n
  do
     if (r-1 < NN) then
        do j = l+1,r
           jpos = idx_gvec(j)
           v0 = norm_gvec(jpos)
           do i = j-1,l,-1
              ipos = idx_gvec(i)
              if (norm_gvec(ipos) <= v0) then
                 exit
              end if
              idx_gvec(i+1) = idx_gvec(i)
           end do
           idx_gvec(i+1) = jpos
        end do
        if (jstack == 0) then
           return
        end if
        r = istack(jstack  )
        l = istack(jstack-1)
        jstack = jstack-2
     else
        kk = (l+r)/2
        call swap_i(idx_gvec(kk),idx_gvec(l+1))
        if (norm_gvec(idx_gvec(l)) > norm_gvec(idx_gvec(r))) then
           call swap_i(idx_gvec(l),idx_gvec(r))
        end if
        if (norm_gvec(idx_gvec(l+1)) > norm_gvec(idx_gvec(r))) then
           call swap_i(idx_gvec(l+1),idx_gvec(r))
        end if
        if (norm_gvec(idx_gvec(l)) > norm_gvec(idx_gvec(l+1))) then
           call swap_i(idx_gvec(l),idx_gvec(l+1))
        end if
        i = l+1
        j = r
        ll = idx_gvec(l+1)
        v0 = norm_gvec(ll)
        do
           do
              i = i+1
              if (norm_gvec(idx_gvec(i)) >= v0) then
                 exit
              end if
           end do
           do
              j = j-1
              if (norm_gvec(idx_gvec(j)) <= v0) then
                 exit
              end if
           end do
           if (j < i) then
              exit
           end if
           call swap_i(idx_gvec(i),idx_gvec(j))
        end do
        idx_gvec(l+1) = idx_gvec(j)
        idx_gvec(j) = ll
        jstack = jstack+2
        if (jstack > NSTACK) then
           !write(*,*) 'NSTACK too small in sort_gvec_quick'
           !stop
           call phase_error_with_msg(6, 'NSTACK too small in sort_gvec_quick',__LINE__,__FILE__)
        end if
        if (r-i+1 >= j-1) then
           istack(jstack  ) = r
           istack(jstack-1) = i
           r = j-1
        else
           istack(jstack  ) = j-1
           istack(jstack-1) = l
           l = i
        end if
     end if
  end do
  ngvec_tmp(:,:) = ngvec(:,:)
  do i = 1,n
     ngvec(i,:) = ngvec_tmp(idx_gvec(i),:)
  end do
 !+++++++++++++++++++++++++++++++++++++++++
  deallocate(norm_gvec,idx_gvec,ngvec_tmp)
 !+++++++++++++++++++++++++++++++++++++++++
end subroutine sort_gvec_quick


subroutine swap_i(a,b)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: swap_i
!
!  AUTHOR(S): M. Okamoto    August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  integer,intent(inout) :: a,b
  integer :: tmp
  tmp = a ; a = b ; b = tmp
end subroutine swap_i


subroutine sort_gvec_heap(ttr,k,n,ngvec)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: 
!
!  AUTHOR(S): M. Okamoto   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP),intent(in),dimension(6) :: ttr
  integer,intent(in)                    :: k, n
  integer,intent(inout),dimension(k,3)  :: ngvec
  real(kind=DP) :: sum
  real(kind=DP),allocatable :: norm_gvec(:)
  integer,allocatable :: idx_gvec(:), ngvec_tmp(:,:)
  integer :: i, j, ia, ib, ic
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  allocate(norm_gvec(n),idx_gvec(n),ngvec_tmp(k,3))
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  do i = 1,n
     ia = ngvec(i,1) ; ib = ngvec(i,2) ; ic = ngvec(i,3)
     sum = ttr(1)*ia*ia + ttr(2)*ib*ib + ttr(3)*ic*ic &
         + ttr(4)*ia*ib + ttr(5)*ib*ic + ttr(6)*ic*ia
     norm_gvec(i) = sqrt(sum)
     idx_gvec (i) = i
  end do
  do i = n/2,1,-1
     call sift_down(i,n)
  end do
  do i = n,2,-1
     call swap_i(idx_gvec(1),idx_gvec(i))
     call sift_down(1,i-1)
  end do
  ngvec_tmp(:,:) = ngvec(:,:)
  do i = 1,n
     ngvec(i,:) = ngvec_tmp(idx_gvec(i),:)
  end do
 !+++++++++++++++++++++++++++++++++++++++++
  deallocate(norm_gvec,idx_gvec,ngvec_tmp)
 !+++++++++++++++++++++++++++++++++++++++++
!....................................................................
  contains
  subroutine sift_down(l,r)
     integer,intent(in) :: l, r
     integer :: j, j0, l0
     real(kind=DP) :: v0
     l0 = idx_gvec(l)
     v0 = norm_gvec(l0)
     j0 = l
     j  = l+l
     do while (j <= r)
        if (j < r) then
           if (norm_gvec(idx_gvec(j)) < norm_gvec(idx_gvec(j+1))) then
              j = j+1
           end if
        end if
        if (v0 >= norm_gvec(idx_gvec(j))) then
           exit
        end if
        idx_gvec(j0) = idx_gvec(j)
        j0 = j
        j  = j+j
     end do
     idx_gvec(j0) = l0
  end subroutine sift_down
!....................................................................
end subroutine sort_gvec_heap

subroutine sort_gvec_heap2(ttr,k,n,ngvec,gr)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: 
!
!  AUTHOR(S): M. Okamoto   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP),intent(in),dimension(6) :: ttr
  integer,intent(in)                    :: k, n
  integer,intent(inout),dimension(k,3)  :: ngvec
  real(kind=DP),intent(inout),dimension(k) ::gr

!!$  real(kind=DP) :: sum
  real(kind=DP),allocatable :: norm_gvec(:), gr_tmp(:)
  integer,allocatable :: idx_gvec(:), ngvec_tmp(:,:)
  integer :: i, j, ia, ib, ic
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  allocate(norm_gvec(n),idx_gvec(n),ngvec_tmp(k,3),gr_tmp(k))
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  do i = 1,n
!!$     ia = ngvec(i,1) ; ib = ngvec(i,2) ; ic = ngvec(i,3)
!!$     sum = ttr(1)*ia*ia + ttr(2)*ib*ib + ttr(3)*ic*ic &
!!$         + ttr(4)*ia*ib + ttr(5)*ib*ic + ttr(6)*ic*ia
!!$     norm_gvec(i) = sqrt(sum)
     norm_gvec(i) = gr(i)
     idx_gvec (i) = i
  end do
  do i = n/2,1,-1
     call sift_down(i,n)
  end do
  do i = n,2,-1
     call swap_i(idx_gvec(1),idx_gvec(i))
     call sift_down(1,i-1)
  end do
  ngvec_tmp(:,:) = ngvec(:,:)
  gr_tmp(:)      = gr(:)
  do i = 1,n
     ngvec(i,:) = ngvec_tmp(idx_gvec(i),:)
     gr(i)      = gr_tmp(idx_gvec(i))
  end do
 !+++++++++++++++++++++++++++++++++++++++++
  deallocate(norm_gvec,idx_gvec,ngvec_tmp,gr_tmp)
 !+++++++++++++++++++++++++++++++++++++++++
!....................................................................
  contains
  subroutine sift_down(l,r)
     integer,intent(in) :: l, r
     integer :: j, j0, l0
     real(kind=DP) :: v0
     l0 = idx_gvec(l)
     v0 = norm_gvec(l0)
     j0 = l
     j  = l+l
     do while (j <= r)
        if (j < r) then
           if (norm_gvec(idx_gvec(j)) < norm_gvec(idx_gvec(j+1))) then
              j = j+1
           end if
        end if
        if (v0 >= norm_gvec(idx_gvec(j))) then
           exit
        end if
        idx_gvec(j0) = idx_gvec(j)
        j0 = j
        j  = j+j
     end do
     idx_gvec(j0) = l0
  end subroutine sift_down
!....................................................................
end subroutine sort_gvec_heap2

subroutine sort_gvec_heap3(ttr,k,n,ngvec,gr)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE:
!
!  AUTHOR(S): M. Okamoto   August/20/2003
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP),intent(in),dimension(6) :: ttr
  integer,intent(in)                    :: k, n
  integer,intent(inout),dimension(k,3)  :: ngvec
  real(kind=DP),intent(inout),dimension(k) ::gr

  real(kind=DP),allocatable :: gr_tmp(:)
  integer,allocatable :: idx_gvec(:), ngvec_tmp(:,:)
  integer :: i, j, ia, ib, ic, itmp
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  allocate(idx_gvec(n),ngvec_tmp(k,3),gr_tmp(k))
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  do i = 1,n
     idx_gvec (i) = i
  end do
  do i = n/2,1,-1
     call sift_down(i,n)
  end do
  do i = n,2,-1
     itmp = idx_gvec(1)
     idx_gvec(1) = idx_gvec(i)
     idx_gvec(i) = itmp
     call sift_down(1,i-1)
  end do
  ngvec_tmp(:,:) = ngvec(:,:)
  gr_tmp(:)      = gr(:)
  do i = 1,n
     ngvec(i,:) = ngvec_tmp(idx_gvec(i),:)
     gr(i)      = gr_tmp(idx_gvec(i))
  end do
 !+++++++++++++++++++++++++++++++++++++++++
  deallocate(idx_gvec,ngvec_tmp,gr_tmp)
 !+++++++++++++++++++++++++++++++++++++++++
!....................................................................
  contains
  subroutine sift_down(l,r)
     integer,intent(in) :: l, r
     integer :: j, j0, l0
     real(kind=DP) :: v0
     l0 = idx_gvec(l)
     v0 = gr(l0)
     j0 = l
     j  = l+l
     do while (j <= r)
        if (j < r) then
           if (gr(idx_gvec(j)) < gr(idx_gvec(j+1))) then
              j = j+1
           end if
        end if
        if (v0 >= gr(idx_gvec(j))) then
           exit
        end if
        idx_gvec(j0) = idx_gvec(j)
        j0 = j
        j  = j+j
     end do
     idx_gvec(j0) = l0
  end subroutine sift_down
!....................................................................
end subroutine sort_gvec_heap3

! This is a replacement of spsort
subroutine sort_gvec_within_shell_by_heap( &
              n,imin,jmin,jmax,kmin,kmax,na,nb,nc)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: 
!
!  AUTHOR(S): M. Okamoto   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  integer,intent(in)        :: n, imin, jmin, jmax, kmin, kmax
  integer,intent(inout)     :: na(n), nb(n), nc(n)
  real(kind=DP),allocatable :: val(:)
  integer,allocatable       :: idx(:), ntmp(:,:)
  integer                   :: i, b, c
 !++++++++++++++++++++++++++++++++++
  allocate(val(n),idx(n),ntmp(n,3))
 !++++++++++++++++++++++++++++++++++
  b = jmax-jmin+1 ; c = kmax-kmin+1
  do i = 1,n
     val(i) = (na(i)-imin)*b*c + (nb(i)-jmin)*c + (nc(i)-kmin) + 1
     idx(i) = i
  end do
  do i = n/2,1,-1
     call sift_down(i,n)
  end do
  do i = n,2,-1
     call swap_i(idx(1),idx(i))
     call sift_down(1,i-1)
  end do
  ntmp(:,1) = na(:) ; ntmp(:,2) = nb(:) ; ntmp(:,3) = nc(:)
  do i = 1,n
     na(i) = ntmp(idx(i),1)
     nb(i) = ntmp(idx(i),2)
     nc(i) = ntmp(idx(i),3)
  end do
 !+++++++++++++++++++++++++
  deallocate(val,idx,ntmp)
 !+++++++++++++++++++++++++
!....................................................................
  contains
  subroutine sift_down(l,r)
     integer,intent(in) :: l, r
     integer :: j, j0, l0
     real(kind=DP) :: v0
     l0 = idx(l)
     v0 = val(l0)
     j0 = l
     j  = l+l
     do while (j <= r)
        if (j < r) then
           if (val(idx(j)) < val(idx(j+1))) then
              j = j+1
           end if
        end if
        if (v0 >= val(idx(j))) then
           exit
        end if
        idx(j0) = idx(j)
        j0 = j
        j  = j+j
     end do
     idx(j0) = l0
  end subroutine sift_down
!....................................................................
end subroutine sort_gvec_within_shell_by_heap


!#####################################################################


subroutine shellsort(nfout,ipri,ttr,m,n,nG)
! $Id: b_PlaneWaveBasisSet.F90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)                       :: nfout,ipri
  real(kind=DP), intent(in), dimension(6)   :: ttr
  integer, intent(in)                       :: m, n
  integer, intent(inout), dimension(m,3) :: nG

      
  integer :: i, k, counter, m_shellsize = 0, nshell = 1, j
  real(kind=DP), parameter :: DELTA = 1.d-7
  real(kind=DP) :: length_start, length
  integer       :: imin, imax, jmin, jmax, kmin, kmax

  if(ipri >= 2 ) then
     write(nfout,*) ' ----- shell sorting of G-vectors ----'
     write(nfout,9000)
9000 format(' #shell  shellsize    range     length   range-x   range-y   range-z')
  endif
  imin = nG(1,1); imax = imin
  jmin = nG(1,2); jmax = jmin
  kmin = nG(1,3); kmax = kmin
  length_start = ttr(1)*nG(1,1)*nG(1,1) + ttr(2)*nG(1,2)*nG(1,2) &
       &       + ttr(3)*nG(1,3)*nG(1,3) + ttr(4)*nG(1,1)*nG(1,2) &
       &       + ttr(5)*nG(1,2)*nG(1,3) + ttr(6)*nG(1,3)*nG(1,1)
  k = 2
1 continue
  shellloop: do i = k, n
     length =    ttr(1)*nG(i,1)*nG(i,1) + ttr(2)*nG(i,2)*nG(i,2) &
          &    + ttr(3)*nG(i,3)*nG(i,3) + ttr(4)*nG(i,1)*nG(i,2) &
          &    + ttr(5)*nG(i,2)*nG(i,3) + ttr(6)*nG(i,3)*nG(i,1)
     if(length > length_start + DELTA .or. i == n) then
        counter = i - k + 1
        if(i == n) counter = i - k + 2
        if(counter > m_shellsize) m_shellsize = counter
        exit shellloop
     else
        if(imin > nG(i,1)) imin = nG(i,1)
        if(imax < nG(i,1)) imax = nG(i,1)
        if(jmin > nG(i,2)) jmin = nG(i,2)
        if(jmax < nG(i,2)) jmax = nG(i,2)
        if(kmin > nG(i,3)) kmin = nG(i,3)
        if(kmax < nG(i,3)) kmax = nG(i,3)
     endif
  enddo shellloop
#ifdef _RPL_SPSORT_
 ! (M.Okamoto)
  call sort_gvec_within_shell_by_heap( &
              counter,imin,jmin,jmax,kmin,kmax, &
              nG(k-1,1),nG(k-1,2),nG(k-1,3))
#else
  call spsort(counter,imin,jmin,jmax,kmin,kmax &
       & ,nG(k-1,1),nG(k-1,2),nG(k-1,3))
#endif
  if(ipri >= 2) write(nfout,9001) nshell, counter,k-1,k-1+counter-1&
       &,dsqrt(length_start),imin,imax,jmin,jmax,kmin,kmax
  if(ipri >= 3) then
     do j = 1, counter
        write(nfout,*) k-1+j-1,nG(k-1+j-1,1),nG(k-1+j-1,2),nG(k-1+j-1,3)
     end do
  end if
  length_start = length
  k = i + 1
  imin = nG(i,1); imax = imin; jmin = nG(i,2); jmax = jmin
  kmin = nG(i,3); kmax = kmin
9001 format(' ',i6,'  ',i4,' (',i6,':',i6,')', f10.5, ' (',i4,':',i4,',',i4,':',i4,',',i4,':',i4,')')
  
  nshell = nshell + 1
  if(k <= n) goto 1
  if(ipri >= 2) write(nfout,*) ' ! m_shellsize = ',m_shellsize
end subroutine shellsort

subroutine shellsort2(nfout,ipri,ttr,m,n,nG,gr)
! $Id: b_PlaneWaveBasisSet.F90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)                       :: nfout,ipri
  real(kind=DP), intent(in), dimension(6)   :: ttr
  integer, intent(in)                       :: m, n
  integer, intent(inout), dimension(m,3) :: nG
  real(kind=DP), intent(inout), dimension(m) :: gr

      
  integer :: i, k, counter, m_shellsize = 0, nshell = 1, j
  real(kind=DP), parameter :: DELTA = 1.d-7
  real(kind=DP) :: length_start, length
  integer       :: imin, imax, jmin, jmax, kmin, kmax

  if(ipri >= 2 ) then
     write(nfout,*) ' ----- shell sorting of G-vectors ----'
     write(nfout,9000)
9000 format(' #shell  shellsize    range     length   range-x   range-y   range-z')
  endif
  imin = nG(1,1); imax = imin
  jmin = nG(1,2); jmax = jmin
  kmin = nG(1,3); kmax = kmin
!!$  length_start = ttr(1)*nG(1,1)*nG(1,1) + ttr(2)*nG(1,2)*nG(1,2) &
!!$       &       + ttr(3)*nG(1,3)*nG(1,3) + ttr(4)*nG(1,1)*nG(1,2) &
!!$       &       + ttr(5)*nG(1,2)*nG(1,3) + ttr(6)*nG(1,3)*nG(1,1)
  length_start = gr(1)
  k = 2
1 continue
  shellloop: do i = k, n
!!$     length =    ttr(1)*nG(i,1)*nG(i,1) + ttr(2)*nG(i,2)*nG(i,2) &
!!$          &    + ttr(3)*nG(i,3)*nG(i,3) + ttr(4)*nG(i,1)*nG(i,2) &
!!$          &    + ttr(5)*nG(i,2)*nG(i,3) + ttr(6)*nG(i,3)*nG(i,1)
     length =    gr(i)
     if(length > length_start + DELTA .or. i == n) then
        counter = i - k + 1
        if(i == n) counter = i - k + 2
        if(counter > m_shellsize) m_shellsize = counter
        exit shellloop
     else
        if(imin > nG(i,1)) imin = nG(i,1)
        if(imax < nG(i,1)) imax = nG(i,1)
        if(jmin > nG(i,2)) jmin = nG(i,2)
        if(jmax < nG(i,2)) jmax = nG(i,2)
        if(kmin > nG(i,3)) kmin = nG(i,3)
        if(kmax < nG(i,3)) kmax = nG(i,3)
     endif
  enddo shellloop
#ifdef _RPL_SPSORT_
 ! (M.Okamoto)
  call sort_gvec_within_shell_by_heap( &
              counter,imin,jmin,jmax,kmin,kmax, &
              nG(k-1,1),nG(k-1,2),nG(k-1,3))
#else
  call spsort(counter,imin,jmin,jmax,kmin,kmax &
       & ,nG(k-1,1),nG(k-1,2),nG(k-1,3))
#endif
  if(ipri >= 2) write(nfout,9001) nshell, counter,k-1,k-1+counter-1&
       &,dsqrt(length_start),imin,imax,jmin,jmax,kmin,kmax
  if(ipri >= 3) then
     do j = 1, counter
        write(nfout,*) k-1+j-1,nG(k-1+j-1,1),nG(k-1+j-1,2),nG(k-1+j-1,3)
     end do
  end if
  length_start = length
  k = i + 1
  imin = nG(i,1); imax = imin; jmin = nG(i,2); jmax = jmin
  kmin = nG(i,3); kmax = kmin
9001 format(' ',i6,'  ',i4,' (',i6,':',i6,')', f10.5, ' (',i4,':',i4,',',i4,':',i4,',',i4,':',i4,')')
  
  nshell = nshell + 1
  if(k <= n) goto 1
  if(ipri >= 2) write(nfout,*) ' ! m_shellsize = ',m_shellsize
end subroutine shellsort2

subroutine spsort(n,imin,jmin,jmax,kmin,kmax,na,nb,nc)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: spsort
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  implicit none
  integer, intent(in) :: n, imin,jmin,jmax,kmin,kmax
  integer, intent(inout), dimension(n) :: na,nb,nc
!C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
!C     THIS SUBROUTINE SORTS THE ELEMENTS OF ARRAY BR IN ASCENDING
!C     ORDER. THE CODE IS BASED UPON HEAPSORT ALGORITHM WHICH HAS
!C     N*LOG(N) SCALING BEHAVIOUR, PARTICULARLY FAVOURABLE FOR LARGE
!C     VECTORS BR
!C                              STEFAN BL"UGEL, ISSP, NOV 1989
!c     interface is changed by T.Yamasaki at 28th Jun. 1994
!c     changed by T. Yamsaki at 17th Apr.1998
!c
!C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

  integer b, c
  integer  l,i,ii,iheap
  integer ia,ib,ic
  integer p1,p2,p3

  b = jmax-jmin+1
  c = kmax-kmin+1

!C=====> BUILD-UP OF THE HEAP

!-----> LOOP OVER ALL HIERACHICAL LEVELS OF THE HEAP TREE

  Loop_L : do L = N/2 , 1 , -1
     ia = na(L)
     ib = nb(L)
     ic = nc(L)
!!$     p1 = (ia-imin+1) + (ib-jmin)*a + (ic-kmin)*a*b
     p1 = (ia-imin)*b*c + (ib-jmin)*c + (ic-kmin+1)
     I   = L
     II  = L + L

!-----> GO DOWN ALL THE HIERACHICAL LEVELS OF THE HEAP TREE

20   IF ( II <= N ) THEN
!!$        p2 = (na(ii)-imin+1) + (nb(ii)-jmin)*a + (nc(ii)-kmin)*a*b
        p2 = (na(ii)-imin)*b*c + (nb(ii)-jmin)*c + (nc(ii)-kmin+1)
!-----> COMPARE NEIGHBOURING ELEMENTS
        IF ( II < N ) THEN
!!$           p3 = (na(ii+1)-imin+1) + (nb(ii+1)-jmin)*a + (nc(ii+1)-kmin)*a*b
           p3 = (na(ii+1)-imin)*b*c+(nb(ii+1)-jmin)*c+(nc(ii+1)-kmin+1)
           if(p2 < p3) then
              ii = ii + 1
              p2 = p3
           endif
        endif

!-----> COMPARE THE ELEMENTS OF TWO HIRACHICAL LEVELS
!       PROMOTE LARGER ONE, DEMOTE SMALLER ONE

        if( p1 < p2 ) then
           na(i) = na(ii)
           nb(i) = nb(ii)
           nc(i) = nc(ii)
           I     = II
           II    = II + II
        ELSE

!-----> THIS PART OF THE TREE IS ORDERED , STOP BY PUTTING II=N+1
           II    = N + 1
        END IF
        GO TO 20
     END IF
!-----> PUT ELEMENTS IN THE PROPER SLOT
     na(i) = ia
     nb(i) = ib
     nc(i) = ic
  enddo Loop_L

!=====> NOW COLLECT ALL ELEMENTS FROM THE HEAP

  Loop_IHEAP :  do IHEAP = N , 1 , -1

     ia = na(iheap)
     ib = nb(iheap)
     ic = nc(iheap)
!!$     p1  = (ia-imin+1) + (ib-jmin)*a + (ic-kmin)*a*b
     p1  = (ia-imin)*b*c + (ib-jmin)*c + (ic-kmin+1)

!-----> THE FIRST ELEMENT IS ALWAYS THE LARGEST
     na(iheap) = na(1)
     nb(iheap) = nb(1)
     nc(iheap) = nc(1)
!-----> NOW LARGEST ELEMENT OF ALL BR(I) WITH 1<=I<=IHEAP IS STORED

     I   = 1
     II  = 2

!-----> NOW GENERATE LARGEST ELEMENT OF BR(I) WITH 1<=I<=IHEAP-1

40   IF ( II <= IHEAP - 1 ) THEN

!!$        p2 = (na(ii)-imin+1) + (nb(ii)-jmin)*a + (nc(ii)-kmin)*a*b
        p2 = (na(ii)-imin)*b*c + (nb(ii)-jmin)*c + (nc(ii)-kmin+1)
!-----> COMPARE NEIGHBOURING ELEMENTS
        if ( ii < iheap - 1 ) then
!!$           p3 = (na(ii+1)-imin+1) + (nb(ii+1)-jmin)*a + (nc(ii+1)-kmin)*a*b
           p3 = (na(ii+1)-imin)*b*c+(nb(ii+1)-jmin)*c+(nc(ii+1)-kmin+1)
           if ( p2 < p3 ) then
              ii = ii + 1
              p2 = p3
           endif
        endif

!-----> PROMOTE EACH ELEMENT OF THE TWIG OF BR UNTIL BRR > BR(I)
        if ( p1 < p2 ) then
           na(i) = na(ii)
           nb(i) = nb(ii)
           nc(i) = nc(ii)
           I     = II
           II    = II + II
        ELSE

!-----> THIS PART OF THE TREE IS PROMOTED , STOP BY PUTTING II=IHEAP+1
           II    = IHEAP + 1
        END IF
        GO TO 40
     END IF
!-----> PUT ELEMENTS IN THE PROPER SLOT
     na(i) = ia
     nb(i) = ib
     nc(i) = ic
  enddo Loop_IHEAP
end subroutine spsort

!C-----CALL HPSOR2(KG,IGP,GX,GY,GZ,GR)
!
subroutine gsort(ttr,k,n,nG)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: gsort
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

!C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
!C     THIS SUBROUTINE SORTS THE ELEMENTS OF ARRAY BR IN ASCENDING
!C     ORDER. THE CODE IS BASED UPON HEAPSORT ALGORITHM WHICH HAS
!C     N*LOG(N) SCALING BEHAVIOUR, PARTICULARLY FAVOURABLE FOR LARGE
!C     VECTORS BR
!C                              STEFAN BL"UGEL, ISSP, NOV 1989
!c     interface is changed by T.Yamasaki at 28th Jun. 1994
!c     changed as it accords with fortran90 by T. Yamsaki at 17th Apr.1998
!c
!C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP), intent(in), dimension(6)   :: ttr
  integer, intent(in)                       :: k, n
  integer, intent(inout), dimension(k,3)    :: nG

!      integer DELTA
!      parameter (DELTA = 1.d-10)
  integer  l,i,ii,iheap
  integer ia,ib,ic
  real*8  brr,brr2, brr3

!C=====> BUILD-UP OF THE HEAP

!-----> LOOP OVER ALL HIERACHICAL LEVELS OF THE HEAP TREE

  loop_L :  do L = N/2 , 1 , -1
     ia = nG(L,1)
     ib = nG(L,2)
     ic = nG(L,3)
     brr    = ttr(1)*ia*ia + ttr(2)*ib*ib + ttr(3)*ic*ic &
          & + ttr(4)*ia*ib + ttr(5)*ib*ic + ttr(6)*ic*ia
     I   = L
     II  = L + L

!-----> GO DOWN ALL THE HIERACHICAL LEVELS OF THE HEAP TREE

20   IF ( II <= N ) THEN
        brr2 =  ttr(1)*nG(ii,1)*nG(ii,1)+ttr(2)*nG(ii,2)*nG(ii,2) &
             &+ ttr(3)*nG(ii,3)*nG(ii,3)+ttr(4)*nG(ii,1)*nG(ii,2) &
             &+ ttr(5)*nG(ii,2)*nG(ii,3)+ttr(6)*nG(ii,3)*nG(ii,1)

!-----> COMPARE NEIGHBOURING ELEMENTS
        IF ( II < N ) THEN
           brr3 = &
                &  ttr(1)*nG(ii+1,1)*nG(ii+1,1)+ttr(2)*nG(ii+1,2)*nG(ii+1,2) &
                &+ ttr(3)*nG(ii+1,3)*nG(ii+1,3)+ttr(4)*nG(ii+1,1)*nG(ii+1,2) &
                &+ ttr(5)*nG(ii+1,2)*nG(ii+1,3)+ttr(6)*nG(ii+1,3)*nG(ii+1,1)
           if(brr2 < brr3) then
!             if(brr2  < brr3 - DELTA) then
              ii = ii + 1
              brr2 = brr3
           endif
        endif

!-----> COMPARE THE ELEMENTS OF TWO HIRACHICAL LEVELS
!       PROMOTE LARGER ONE, DEMOTE SMALLER ONE

!           if( brr < brr2 - DELTA ) then
        if( brr < brr2 ) then
           nG(i,1) = nG(ii,1)
           nG(i,2) = nG(ii,2)
           nG(i,3) = nG(ii,3)
           I     = II
           II    = II + II
        ELSE

!-----> THIS PART OF THE TREE IS ORDERED , STOP BY PUTTING II=N+1
           II    = N + 1
        END IF
        GO TO 20
     END IF
!-----> PUT ELEMENTS IN THE PROPER SLOT
     nG(i,1) = ia
     nG(i,2) = ib
     nG(i,3) = ic
  enddo Loop_L

!=====> NOW COLLECT ALL ELEMENTS FROM THE HEAP

  loop_IHEAP :  do IHEAP = N , 1 , -1

     ia = nG(iheap,1)
     ib = nG(iheap,2)
     ic = nG(iheap,3)
     brr  =   ttr(1)*ia*ia + ttr(2)*ib*ib + ttr(3)*ic*ic &
          & + ttr(4)*ia*ib + ttr(5)*ib*ic + ttr(6)*ic*ia

!-----> THE FIRST ELEMENT IS ALWAYS THE LARGEST
     nG(iheap,1) = nG(1,1)
     nG(iheap,2) = nG(1,2)
     nG(iheap,3) = nG(1,3)
!-----> NOW LARGEST ELEMENT OF ALL BR(I) WITH 1<=I<=IHEAP IS STORED

     I   = 1
     II  = 2

!-----> NOW GENERATE LARGEST ELEMENT OF BR(I) WITH 1<=I<=IHEAP-1

40   IF ( II <= IHEAP - 1 ) THEN

        brr2 =    ttr(1)*ng(ii,1)*nG(ii,1) + ttr(2)*nG(ii,2)*nG(ii,2) &
             &  + ttr(3)*nG(ii,3)*nG(ii,3) + ttr(4)*nG(ii,1)*nG(ii,2) &
             &  + ttr(5)*nG(ii,2)*nG(ii,3) + ttr(6)*nG(ii,3)*nG(ii,1)
!-----> COMPARE NEIGHBOURING ELEMENTS
        if ( ii < iheap - 1 ) then
           brr3 = &
                &  ttr(1)*nG(ii+1,1)*nG(ii+1,1)+ttr(2)*nG(ii+1,2)*nG(ii+1,2)&
                &+ ttr(3)*nG(ii+1,3)*nG(ii+1,3)+ttr(4)*nG(ii+1,1)*nG(ii+1,2)&
                &+ ttr(5)*nG(ii+1,2)*nG(ii+1,3)+ttr(6)*nG(ii+1,3)*nG(ii+1,1)
!             if ( brr2 < brr3 - DELTA ) then
           if ( brr2 < brr3 ) then
              ii = ii + 1
              brr2 = brr3
           endif
        endif

!-----> PROMOTE EACH ELEMENT OF THE TWIG OF BR UNTIL BRR > BR(I)
!           if ( brr < brr2 - DELTA ) then
        if ( brr < brr2 ) then
           nG(i,1) = nG(ii,1)
           nG(i,2) = nG(ii,2)
           nG(i,3) = nG(ii,3)
           I     = II
           II    = II + II
        ELSE

!-----> THIS PART OF THE TREE IS PROMOTED , STOP BY PUTTING II=IHEAP+1
           II    = IHEAP + 1
        END IF
        GO TO 40
     END IF
!-----> PUT ELEMENTS IN THE PROPER SLOT
     nG(i,1) = ia
     nG(i,2) = ib
     nG(i,3) = ic
  enddo Loop_IHEAP
end subroutine gsort

subroutine gsort2(ttr,k,n,nG,gr)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: gsort2
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

!C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
!C     THIS SUBROUTINE SORTS THE ELEMENTS OF ARRAY BR IN ASCENDING
!C     ORDER. THE CODE IS BASED UPON HEAPSORT ALGORITHM WHICH HAS
!C     N*LOG(N) SCALING BEHAVIOUR, PARTICULARLY FAVOURABLE FOR LARGE
!C     VECTORS BR
!C                              STEFAN BL"UGEL, ISSP, NOV 1989
!c     interface is changed by T.Yamasaki at 28th Jun. 1994
!c     changed as it accords with fortran90 by T. Yamsaki at 17th Apr.1998
!c
!C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP), intent(in), dimension(6)   :: ttr
  integer, intent(in)                       :: k, n
  integer, intent(inout), dimension(k,3)    :: nG
  real(kind=DP), intent(inout), dimension(k) :: gr

!      integer DELTA
!      parameter (DELTA = 1.d-10)
  integer  l,i,ii,iheap
  integer ia,ib,ic
  real*8  brr,brr2, brr3

!C=====> BUILD-UP OF THE HEAP

!-----> LOOP OVER ALL HIERACHICAL LEVELS OF THE HEAP TREE

  loop_L :  do L = N/2 , 1 , -1
     ia = nG(L,1)
     ib = nG(L,2)
     ic = nG(L,3)
!!$     brr    = ttr(1)*ia*ia + ttr(2)*ib*ib + ttr(3)*ic*ic &
!!$          & + ttr(4)*ia*ib + ttr(5)*ib*ic + ttr(6)*ic*ia
     brr    = gr(L)
     I   = L
     II  = L + L

!-----> GO DOWN ALL THE HIERACHICAL LEVELS OF THE HEAP TREE

20   IF ( II <= N ) THEN
!!$        brr2 =  ttr(1)*nG(ii,1)*nG(ii,1)+ttr(2)*nG(ii,2)*nG(ii,2) &
!!$             &+ ttr(3)*nG(ii,3)*nG(ii,3)+ttr(4)*nG(ii,1)*nG(ii,2) &
!!$             &+ ttr(5)*nG(ii,2)*nG(ii,3)+ttr(6)*nG(ii,3)*nG(ii,1)
        brr2 =  gr(ii)
!-----> COMPARE NEIGHBOURING ELEMENTS
        IF ( II < N ) THEN
!!$           brr3 = &
!!$                &  ttr(1)*nG(ii+1,1)*nG(ii+1,1)+ttr(2)*nG(ii+1,2)*nG(ii+1,2) &
!!$                &+ ttr(3)*nG(ii+1,3)*nG(ii+1,3)+ttr(4)*nG(ii+1,1)*nG(ii+1,2) &
!!$                &+ ttr(5)*nG(ii+1,2)*nG(ii+1,3)+ttr(6)*nG(ii+1,3)*nG(ii+1,1)
           brr3 =  gr(ii+1)
           if(brr2 < brr3) then
!             if(brr2  < brr3 - DELTA) then
              ii = ii + 1
              brr2 = brr3
           endif
        endif

!-----> COMPARE THE ELEMENTS OF TWO HIRACHICAL LEVELS
!       PROMOTE LARGER ONE, DEMOTE SMALLER ONE

!           if( brr < brr2 - DELTA ) then
        if( brr < brr2 ) then
           nG(i,1) = nG(ii,1)
           nG(i,2) = nG(ii,2)
           nG(i,3) = nG(ii,3)
           gr(i)   = gr(ii)
           I     = II
           II    = II + II
        ELSE

!-----> THIS PART OF THE TREE IS ORDERED , STOP BY PUTTING II=N+1
           II    = N + 1
        END IF
        GO TO 20
     END IF
!-----> PUT ELEMENTS IN THE PROPER SLOT
     nG(i,1) = ia
     nG(i,2) = ib
     nG(i,3) = ic
     gr(i)   = brr
  enddo Loop_L

!=====> NOW COLLECT ALL ELEMENTS FROM THE HEAP

  loop_IHEAP :  do IHEAP = N , 1 , -1

     ia = nG(iheap,1)
     ib = nG(iheap,2)
     ic = nG(iheap,3)
!!$     brr  =   ttr(1)*ia*ia + ttr(2)*ib*ib + ttr(3)*ic*ic &
!!$          & + ttr(4)*ia*ib + ttr(5)*ib*ic + ttr(6)*ic*ia
     brr  =   gr(iheap)
!-----> THE FIRST ELEMENT IS ALWAYS THE LARGEST
     nG(iheap,1) = nG(1,1)
     nG(iheap,2) = nG(1,2)
     nG(iheap,3) = nG(1,3)
     gr(iheap)   = gr(1)
!-----> NOW LARGEST ELEMENT OF ALL BR(I) WITH 1<=I<=IHEAP IS STORED

     I   = 1
     II  = 2

!-----> NOW GENERATE LARGEST ELEMENT OF BR(I) WITH 1<=I<=IHEAP-1

40   IF ( II <= IHEAP - 1 ) THEN

!!$        brr2 =    ttr(1)*ng(ii,1)*nG(ii,1) + ttr(2)*nG(ii,2)*nG(ii,2) &
!!$             &  + ttr(3)*nG(ii,3)*nG(ii,3) + ttr(4)*nG(ii,1)*nG(ii,2) &
!!$             &  + ttr(5)*nG(ii,2)*nG(ii,3) + ttr(6)*nG(ii,3)*nG(ii,1)
        brr2 =    gr(ii)
!-----> COMPARE NEIGHBOURING ELEMENTS
        if ( ii < iheap - 1 ) then
!!$           brr3 = &
!!$                &  ttr(1)*nG(ii+1,1)*nG(ii+1,1)+ttr(2)*nG(ii+1,2)*nG(ii+1,2)&
!!$                &+ ttr(3)*nG(ii+1,3)*nG(ii+1,3)+ttr(4)*nG(ii+1,1)*nG(ii+1,2)&
!!$                &+ ttr(5)*nG(ii+1,2)*nG(ii+1,3)+ttr(6)*nG(ii+1,3)*nG(ii+1,1)
           brr3 = gr(ii+1)
!             if ( brr2 < brr3 - DELTA ) then
           if ( brr2 < brr3 ) then
              ii = ii + 1
              brr2 = brr3
           endif
        endif

!-----> PROMOTE EACH ELEMENT OF THE TWIG OF BR UNTIL BRR > BR(I)
!           if ( brr < brr2 - DELTA ) then
        if ( brr < brr2 ) then
           nG(i,1) = nG(ii,1)
           nG(i,2) = nG(ii,2)
           nG(i,3) = nG(ii,3)
           gr(i)   = gr(ii)
           I     = II
           II    = II + II
        ELSE

!-----> THIS PART OF THE TREE IS PROMOTED , STOP BY PUTTING II=IHEAP+1
           II    = IHEAP + 1
        END IF
        GO TO 40
     END IF
!-----> PUT ELEMENTS IN THE PROPER SLOT
     nG(i,1) = ia
     nG(i,2) = ib
     nG(i,3) = ic
     gr(i)   = brr
  enddo Loop_IHEAP
end subroutine gsort2

module m_ES_RSB
  use m_Files,                only : nfout
  use m_Const_Parameters,     only : DP,DIRECT,OFF,ELECTRON,EXECUT,NORMCONSERVATION,DELTA,ON,INVERSE
  use m_Kpoints,              only : kv3
  use m_FFT,                  only : nfft,fft_box_size_WF,m_FFT_WF
  use m_Parallelization,      only : myrank_k,map_k,np_e,ista_e,iend_e &
       &                           , istep_e, mpi_k_world, ista_k, iend_k, map_z &
       &                           , ista_ffth,iend_ffth,np_ffth,MPI_CommGroup,map_e,myrank_e,npes &
       &                           , nrank_e
  use m_Control_Parameters,   only : nspin,af,neg,printable,kimg,bisect_by,eps_rsb,lmax_rsb,ipri,iprirsb &
       &                           , sw_valence_electrons_only
  use m_PlaneWaveBasisSet,    only : kg1, iba, igf, nbase
  use m_Electronic_Structure, only : zaj_l,m_ES_WF_in_Rspace,fsr_l,fsi_l,occup_l,neordr,totch &
       &                           , m_ES_energy_eigen_values,m_ES_sort_eigen_values,eko_l
  use m_Timing,               only : tstatc0_begin,tstatc0_end
  use m_Crystal_Structure,    only : univol
  use m_ES_ortho,             only : m_ES_W_transpose_fft_cmplx, m_ES_W_transpose_back_fft_cmplx &
       &                           , m_ESortho_set_np_fs_x,np_fs_x, m_ES_F_transpose_r &
       &                           , m_ES_modified_gram_schmidt,np_g1k_x, m_ESortho_set_np_g1k_x &
       &                           , m_ES_W_transpose_r, m_ES_W_transpose_back_r,np_g1k
  use m_Realspace,            only : m_RS_get_coords
  use m_PseudoPotential,      only : modnrm,nlmta1_p,nlmta2_p,fqwei_p,nac_p,nlmta
  use m_ES_occup,             only : m_ESoc_fermi_parabolic
  use m_ES_nonlocal,          only : m_ES_betar_dot_WFs_4_each_k
  use mpi

  implicit none

  complex(kind=DP), private :: zero = (0.d0,0.d0)
  complex(kind=DP), private :: one  = (1.d0,0.d0)
  complex(kind=DP), private :: onei = (0.d0,1.d0)

  real(kind=DP), allocatable, dimension(:) :: volume
  real(kind=DP), allocatable, dimension(:,:,:) :: range_of_a_state
  real(kind=DP), allocatable, dimension(:,:,:,:) :: localized_region
  logical, allocatable, dimension(:,:) :: overlap
  integer, parameter :: nmaxregion=4
  integer :: nval,currnval

  integer :: noverl_old=0
  logical :: noverl_changed = .true.

  complex(kind=DP), allocatable, dimension(:,:) :: qout ! the unitary matrix which performs the RSB transformation

!  include 'mpif.h'                                      ! MPI

  contains

  function get_localization_volume(ndim,locrange) result(ret)
     integer, intent(in) :: ndim
     real(kind=DP), intent(in), dimension(ndim,3,nmaxregion,2) :: locrange
     real(kind=DP) :: ret
     real(kind=DP) :: dx,dy,dz,vol,v
     integer :: idi,ireg,ixyz
     vol = 0.d0
     do idi=1,ndim
        dx=0.d0;dy=0.d0;dz=0.d0
        do ireg=1,nmaxregion
           if(locrange(idi,1,ireg,1)>-0.1)then
              dx = dx + (locrange(idi,1,ireg,2)-locrange(idi,1,ireg,1))
           endif
           if(locrange(idi,2,ireg,1)>-0.1)then
              dy = dy + (locrange(idi,2,ireg,2)-locrange(idi,2,ireg,1))
           endif
           if(locrange(idi,3,ireg,1)>-0.1)then
              dz = dz + (locrange(idi,3,ireg,2)-locrange(idi,3,ireg,1))
           endif
        enddo
        v = dx*dy*dz
        if(printable.and.iprirsb>=3) write(nfout,'(a,i8,a,f10.5)') '!** volume of state ',idi,' : ',v
        vol = vol+v
     enddo
     ret = vol/real(ndim)
  end function get_localization_volume

  subroutine resolve_localization_region(ndim,nrecur,eigval,locrange)
     integer, intent(in) :: ndim,nrecur
     real(kind=DP), intent(in), dimension(ndim,nrecur) :: eigval
     real(kind=DP), intent(out), dimension(ndim,3,nmaxregion,2) :: locrange
     integer :: ir,irp,idi,ixyz,nr,iregion,iregionp,nregion,nregionp,icount
     real(kind=DP) :: c2,dr,rmin,rmax,rminp,rmaxp
     real(kind=DP),allocatable,dimension(:,:,:) :: region
     logical, allocatable, dimension(:,:) :: localized
     character(len=1),dimension(3) :: axi
     logical :: loc
     axi(1) = 'a'
     axi(2) = 'b'
     axi(3) = 'c'
     do idi=1,ndim
        do ixyz=1,3
           if(iprirsb>=3)write(nfout,'(a,i5,a)') '!-- resolving localization of state ',idi,', '//axi(ixyz)//'-axis'
           allocate(region(2**(nrecur-1)+1,2,nrecur));region=0.d0
           allocate(localized(2**(nrecur-1)+1,nrecur));localized=.false.
           do ir=1,nrecur
              nr = 2**ir
              nregion=2**(ir-1)+1
              dr = 1.d0/dble(nr)
              c2 = eigval(idi,(ir-1)*3+ixyz)
              do iregion=1,nregion
                 if(iregion.eq.1)then
                    region(iregion,1,ir) = 0.d0
                    region(iregion,2,ir) = dr
                 else if (iregion.eq.nregion)then
                    region(iregion,1,ir) = 1.d0-dr
                    region(iregion,2,ir) = 1.d0
                 else
                    region(iregion,1,ir) = (iregion-1)*2*dr-dr
                    region(iregion,2,ir) = iregion*2*dr-dr
                 endif
              enddo
              if(c2.lt.eps_rsb)then
                 do iregion=1,nregion,2
                    localized(iregion,ir) = .true.
                 enddo
              else if (1-c2.lt.eps_rsb)then
                 do iregion=2,nregion,2
                    localized(iregion,ir) = .true.
                 enddo
              endif
           enddo
           do ir=2,nrecur
              do irp=1,ir-1
                 nregion=2**(ir-1)+1;nregionp=2**(irp-1)+1
                 do iregionp=1,nregionp
                    if(localized(iregionp,irp))then
                       rminp = region(iregionp,1,irp)
                       rmaxp = region(iregionp,2,irp)
                       do iregion=1,nregion
                          rmin = region(iregion,1,ir)
                          rmax = region(iregion,2,ir)
                          if (rmaxp.lt.rmin .or. rminp.gt.rmax) then
                             localized(iregion,ir) = .false.
                          endif
                          if (rminp.gt.rmin.and.localized(iregion,ir))then
                             region(iregion,1,ir) = rminp
                          endif
                          if (rmaxp.lt.rmax.and.localized(iregion,ir))then
                             region(iregion,2,ir) = rmaxp
                          endif
                       enddo
                    endif
                 enddo
              enddo
           enddo
           do ir=1,nrecur
              c2 = eigval(idi,(ir-1)*3+ixyz)
              if(iprirsb>=3)write(nfout,'(a,i5)') '!-- level of recursion : ',ir
              nregion=2**(ir-1)+1
              do iregion=1,nregion
                 if(iprirsb>=3) write(nfout,'(a,i5,a,2f10.5,l,f10.5)') '!-- region ',iregion,' min, max, loc, cos^2 ', &
                   &  region(iregion,1,ir),region(iregion,2,ir),localized(iregion,ir),c2
              enddo
           enddo
           loc = .false.
           recur:do ir=nrecur,1,-1
              c2 = eigval(idi,(ir-1)*3+ixyz)
              nregion=2**(ir-1)+1
              icount = 0
              do iregion=1,nregion
                 if(localized(iregion,ir))then
                    if(iprirsb>=3) &
                    & write(nfout,'(a,2f10.5)') '!-- localized in region : ',region(iregion,1,ir),region(iregion,2,ir)
                    loc = .true.
                    icount = icount+1
                    locrange(idi,ixyz,icount,1) = region(iregion,1,ir)
                    locrange(idi,ixyz,icount,2) = region(iregion,2,ir)
                 endif
              enddo
              if(loc) exit recur
           enddo recur
           if(.not.loc.and.iprirsb>=3) write(nfout,'(a)') '!-- the state is delocalized'
           deallocate(region)
           deallocate(localized)
        enddo
     enddo
  end subroutine resolve_localization_region

  integer function get_nval()
     integer :: ibm,ik,ib,ib1,nv,irev,ierr
     ibm = 0
     do ik=1,kv3,af+1
        if(map_k(ik) /= myrank_k) cycle
        do ib=1,neg
           ib1 = neordr(ib,ik)
           if(map_e(ib1) == myrank_e) then
              if(occup_l(map_z(ib1),ik) > DELTA) then
                 ibm = max(ib,ibm)
              end if
           end if
        end do
     end do
     nv=0;irev=0
     if(npes>1) then
        call mpi_allreduce(ibm,irev,1,MPI_INTEGER,MPI_MAX,MPI_CommGroup,ierr)
        nv= irev
     else
        nv= ibm
     end if
     !!$call m_Parallel_init_mpi_nn(nfout,iprirsb,printable,nval*(nval-1)/2)
     get_nval = nv
     if(get_nval.eq.0) get_nval=totch*0.5d0

  end function get_nval

  subroutine resolve_overlap(ndim1,ndim,locregion,overl)
     integer, intent(in) :: ndim1,ndim
     real(kind=DP), intent(in), dimension(ndim,3,nmaxregion,2) :: locregion
     logical, intent(out), dimension(ndim1,ndim) :: overl
     integer :: i,j,iri,irj,ixyz,nover,ierr
     logical :: overlapping
     real(kind=DP) :: mini,maxi,minj,maxj
     logical, allocatable, dimension(:,:) :: overlt
     overl(:,:)=.true.
     nover=0
     do i=1,ndim
        if(map_e(i)/=myrank_e)cycle
        do j=1,ndim
           if (i.eq.j) cycle
           overl(map_z(i),j) = .true.
           do ixyz=1,3
              overlapping=.false.
              do iri=1,nmaxregion
                 if(locregion(i,ixyz,iri,1)>=-0.1)then
                    mini=locregion(i,ixyz,iri,1)
                    maxi=locregion(i,ixyz,iri,2)
                 else
                    cycle
                 endif
                 do irj=1,nmaxregion
                    if(locregion(j,ixyz,irj,1)>=-0.1)then
                       minj=locregion(j,ixyz,irj,1)
                       maxj=locregion(j,ixyz,irj,2)
                       if(.not.(maxi.le.minj.or.maxj.le.mini))then
                          overlapping=.true.
                       endif
                    else
                       cycle
                    endif
                 enddo
              enddo
              if(.not.overlapping)then
                 overl(map_z(i),j) = .false.
                 exit
              endif
           enddo
           if(.not.overl(map_z(i),j)) nover=nover+1
        enddo
     enddo
     call mpi_allreduce(MPI_IN_PLACE,nover,1,mpi_integer, MPI_SUM,mpi_k_world(myrank_k),ierr)
     if(printable) write(nfout,'(a,f10.5)') '!-- ratio of non-overlapping wf pairs    : ',dble(nover)/dble(ndim*ndim)

     noverl_changed = .false.
     if(noverl_old/=nover) then
        if(printable) write(nfout,'(a)') '!-- ratio of non-overlapping wf pairs has changed'
        noverl_changed = .true.
     endif
     noverl_old = nover

     allocate(overlt(ndim,ndim));overlt=.false.
     do i=1,ndim
        if(map_e(i)/=myrank_e)cycle
        overlt(i,:) = overl(map_z(i),:)
     enddo
     call mpi_allreduce(MPI_IN_PLACE,overlt,ndim*ndim,mpi_logical,mpi_lor,mpi_k_world(myrank_k),ierr)
     if(printable.and.iprirsb>=2)then
        do i=1,ndim
           do j=i+1,ndim
              write(nfout,'(a,2i8,a,l)') '!states ',i,j,' are overlapping : ',overlt(i,j)
           enddo
        enddo
     endif
     deallocate(overlt)
  end subroutine resolve_overlap

  subroutine m_ES_RSB_doit(verbose,fermi)
     logical, intent(in) :: verbose
     logical, intent(in), optional :: fermi
     integer :: ik,ib,ig,i1,ib1,ib2,i,j,k

     complex(kind=DP), allocatable, dimension(:,:) :: q,q1,qtran
     complex(kind=DP), allocatable, dimension(:,:,:) :: qoutt
     complex(kind=DP), allocatable, dimension(:) :: qtmp

     complex(kind=DP) :: ctmp
     real(kind=DP), allocatable, dimension(:) :: bfft
     real(kind=DP), allocatable, dimension(:,:) :: eigval
     real(kind=DP),allocatable,dimension(:,:,:) :: wf_t
     complex(kind=DP),allocatable,dimension(:,:) :: cwf_t,cwf_t2

     real(kind=DP) :: normr,normi,norm
     integer :: nffth
     integer :: modnrmt
     integer :: ir
     logical :: ferm
     integer :: id_sname=-1

     ferm = .true.
     if(present(fermi)) ferm = fermi

     call tstatc0_begin('m_ES_RSB ',id_sname,1)
     nffth = nfft/2
!     if(sw_valence_electrons_only==ON)then
!        nval = get_nval()
!     else
!        nval = neg
!     endif

!     if(ferm) call m_ESoc_fermi_parabolic(nfout)

     if(.not.allocated(qout)) then
        allocate(qout(nval,nval));qout=zero
        do i=1,nval
           qout(i,i) = one
        enddo
     else
!        do ik=1,kv3,af+1
!           if(map_k(ik)/=myrank_k) cycle
!           call m_ES_RSB_unitary_transform_wf(DIRECT,ik,zaj_l,.false.)
!        enddo
     endif

     allocate(qoutt(nval,nval,lmax_rsb*3));qoutt=zero
     allocate(qtmp(nffth));qtmp=zero
     allocate(bfft(nfft));bfft=0.d0
     allocate(eigval(nval,lmax_rsb*3));eigval=0.d0

     if(modnrm==EXECUT)then
        modnrmt = modnrm
        modnrm = NORMCONSERVATION
        call m_ES_modified_gram_schmidt(nfout)
        modnrm = modnrmt
     endif
     currnval = get_nval()
     do ik=1,kv3,af+1
        if(map_k(ik)/=myrank_k) cycle

        ! WF in rspace
        allocate(q(nffth,np_e));q=zero
        do ib=ista_e,iend_e,istep_e
           call m_ES_WF_in_Rspace(ik,ib,bfft)
           normr=0.d0;normi=0.d0;qtmp=zero
           do ig=1,nffth
              i1 = (ig-1)*kimg+1
              qtmp(ig) = dcmplx(bfft(i1),bfft(i1+1))
              normr = normr+bfft(i1)*bfft(i1)
              if(kimg==2) normi = normi+bfft(i1+1)*bfft(i1+1)
           enddo
           norm = normr+normi
           norm = 1.d0/dsqrt(norm)
           qtmp(1:nffth) = norm*qtmp(1:nffth)
           q(1:nffth,map_z(ib)) = qtmp(1:nffth)
        enddo
        allocate(qtran(np_ffth,neg));qtran=zero
        call m_ES_W_transpose_fft_cmplx(nffth,np_ffth,q,qtran)
        deallocate(q)

        ! recursive subspace bisection
        do ir=1,lmax_rsb
           call bisection_by_walsh(np_ffth,nval,0,qtran,qout,ir)
           qoutt(:,:,(ir-1)*3+1) = qout(:,:)
           call bisection_by_walsh(np_ffth,nval,1,qtran,qout,ir)
           qoutt(:,:,(ir-1)*3+2) = qout(:,:)
           call bisection_by_walsh(np_ffth,nval,2,qtran,qout,ir)
           qoutt(:,:,(ir-1)*3+3) = qout(:,:)
        enddo

        ! diagonalize the matrix qout
        call simultaneous_diagonalization(lmax_rsb*3,nval,qoutt,eigval,qout,verbose)

        localized_region=-1
        localized_region(:,:,1,1) = 0.d0
        localized_region(:,:,1,2) = 1.d0
        call resolve_localization_region(nval,lmax_rsb,eigval,localized_region)
        if(printable.and.verbose.or.iprirsb>=2)then
           do ib=1,nval
              write(nfout,'(a,i8)') '!-- localization info of state ',ib
              do ir=1,nmaxregion
                 if(localized_region(ib,1,ir,1)>=-0.1)then
                    write(nfout,'(a,f10.5,a,f10.5)') 'a-axis : ',localized_region(ib,1,ir,1),' - ',localized_region(ib,1,ir,2)
                 endif
              enddo
              do ir=1,nmaxregion
                 if(localized_region(ib,2,ir,1)>=-0.1)then
                    write(nfout,'(a,f10.5,a,f10.5)') 'b-axis : ',localized_region(ib,2,ir,1),' - ',localized_region(ib,2,ir,2)
                 endif
              enddo
              do ir=1,nmaxregion
                 if(localized_region(ib,3,ir,1)>=-0.1)then
                    write(nfout,'(a,f10.5,a,f10.5)') 'c-axis : ',localized_region(ib,3,ir,1),' - ',localized_region(ib,3,ir,2)
                 endif
              enddo
           enddo
        endif
        if(printable) write(nfout,'(a,f10.5)') '!-- compression ratio after localization : ',&
       & get_localization_volume(nval,localized_region)
        call resolve_overlap(np_e,nval,localized_region,overlap)

        ! unitary transformation
        !allocate(q1(np_ffth,neg));q1=zero
        !do i=1,nval
        !   do k=1,nval
        !      do j=1,np_ffth
        !         q1(j,i) = q1(j,i)+qtran(j,k)*(qout(k,i))
        !      enddo
        !   enddo
        !enddo
        !call zgemm('N','N',np_ffth,nval,nval,one,qtran,np_ffth,qout,nval,zero,q1,np_ffth)
        !if(neg>nval) q1(1:np_ffth,nval+1:neg) = qtran(1:np_ffth,nval+1:neg)
        !deallocate(qtran)
        deallocate(qtran)

        call m_ES_RSB_unitary_transform_wf(DIRECT,ik,zaj_l,.true.)
!        call m_ESortho_set_np_g1k_x(ik) !-> np_g1k_x
!        allocate(wf_t(np_g1k_x,neg,kimg));wf_t=0.d0
!        allocate(cwf_t(np_g1k_x,neg));cwf_t=0.d0
!        allocate(cwf_t2(np_g1k_x,neg));cwf_t2=0.d0
!        call m_ES_W_transpose_r(.false.,ista_k,iend_k,ik,zaj_l,wf_t)
!        if(kimg==1)then
!          cwf_t(:,:) = dcmplx(wf_t(:,:,1),0.d0)
!        else
!          cwf_t(:,:) = dcmplx(wf_t(:,:,1),wf_t(:,:,2))
!        endif
!        call zgemm('N','N',np_g1k_x,nval,nval,one,cwf_t,np_g1k_x,qout,nval,zero,cwf_t2,np_g1k_x)
!        wf_t(:,:,1) = dble(cwf_t2(:,:))
!        if(kimg>1)wf_t(:,:,2) = dimag(cwf_t2(:,:))
!        call m_ES_W_transpose_back_r(.false.,ista_k,iend_k,ik,zaj_l,wf_t)
!        deallocate(wf_t)
!        deallocate(cwf_t,cwf_t2)
!        ! back to G-space
        !allocate(q(nffth,np_e));q=0.d0
        !call m_ES_W_transpose_back_fft_cmplx(nffth,np_ffth,q,q1)
        !deallocate(q1)
        !do ib=1,np_e
        !   do ig=1,nffth
        !      i1 = (ig-1)*kimg+1
        !      bfft(i1) = real(q(ig,ib))
        !      if(kimg==2) bfft(i1+1) = aimag(q(ig,ib))
        !   enddo
        !   call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,OFF)
        !   do ig=1,iba(ik)
        !      i1 = kimg*igf(nbase(ig,ik))-1
        !      zaj_l(ig,ib,ik,1) = bfft(i1)
        !      if(kimg==2) zaj_l(ig,ib,ik,kimg) = bfft(i1+1)
        !   enddo
        !enddo
        !call m_ES_betar_dot_WFs_4_each_k(nfout,ik)   ! -> fsr_l,fsi_l
     enddo

     if(ferm)then
        !call m_ES_modified_gram_schmidt(nfout)
        !call ChargeDensity_Construction(1)
        !call Renewal_of_Potential()
        !call m_ES_energy_eigen_values(nfout,.true.)
        !call m_ESoc_fermi_parabolic(nfout)
     endif

     deallocate(qtmp)
     !!$deallocate(qout)
     deallocate(qoutt)
     deallocate(bfft)
     deallocate(eigval)
     call tstatc0_end(id_sname)

  end subroutine m_ES_RSB_doit

  real(kind=8) function get_sum_ek()
     integer :: i,ierr
     real(kind=8) :: sumek
     sumek=0.d0
     do i=1,np_e
        !if(occup_l(map_z(i),1) > DELTA) sumek = sumek+eko_l(i,1)
        sumek = sumek+eko_l(i,1)
     enddo
     call mpi_allreduce(MPI_IN_PLACE,sumek,1,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
     get_sum_ek = sumek
  end function get_sum_ek

  subroutine m_ES_RSB_alloc()
     if(sw_valence_electrons_only==ON)then
        nval = get_nval()
     else
        nval = neg
     endif
     if(.not.allocated(localized_region)) allocate(localized_region(nval,3,nmaxregion,2))
     localized_region=-1
     localized_region(:,:,1,1) = 0.d0
     localized_region(:,:,1,2) = 1.d0
     if(.not.allocated(overlap)) allocate(overlap(np_e,nval));overlap=.true.
  end subroutine m_ES_RSB_alloc

  subroutine m_ES_RSB_dealloc()
    deallocate(localized_region)
    deallocate(overlap)
  end subroutine m_ES_RSB_dealloc

  subroutine m_ES_RSB_test()
     integer :: ik,ib,ig,i1,ib1,ib2

     complex(kind=DP), allocatable, dimension(:,:) :: q,q1,qtran,qout
     complex(kind=DP), allocatable, dimension(:,:,:) :: qoutt
     complex(kind=DP), allocatable, dimension(:) :: qtmp

     real(kind=DP), allocatable, dimension(:) :: bfft
     real(kind=DP), allocatable, dimension(:) :: eigval
     real(kind=DP) :: normr,normi,norm
     integer :: nffth
     integer :: modnrmt
     integer, dimension(2) :: regionl,regionm,regionn

     integer :: id_sname=-1

     call tstatc0_begin('m_ES_RSB_test ',id_sname,1)
     nffth = nfft/2

     allocate(qout(neg,neg));qout=zero
     allocate(qoutt(neg,neg,1));qoutt=zero
     allocate(qtmp(nffth));qtmp=zero
     allocate(bfft(nfft));bfft=0.d0
     allocate(eigval(neg));eigval=0.d0

     if(modnrm==EXECUT)then
        modnrmt = modnrm
        modnrm = NORMCONSERVATION
        call m_ES_modified_gram_schmidt(nfout)
        modnrm = modnrmt
     endif

     regionl(1) = 1
     regionl(2) = fft_box_size_WF(1,1)
     regionm(1) = 1
     regionm(2) = fft_box_size_WF(2,1)
     regionn(1) = 1
     regionn(2) = fft_box_size_WF(3,1)

     do ik=1,kv3,af+1
        if(map_k(ik)/=myrank_k) cycle

        ! WF in rspace
        allocate(q(nffth,np_e));q=zero
        do ib=ista_e,iend_e,istep_e
           call m_ES_WF_in_Rspace(ik,ib,bfft)
           normr=0.d0;normi=0.d0;qtmp=zero
           do ig=1,nffth
              i1 = (ig-1)*kimg+1
              qtmp(ig) = dcmplx(bfft(i1),bfft(i1+1))
              normr = normr+bfft(i1)*bfft(i1)
              if(kimg==2) normi = normi+bfft(i1+1)*bfft(i1+1)
           enddo
           norm = normr+normi
           norm = 1.d0/dsqrt(norm)
           qtmp(1:nffth) = norm*qtmp(1:nffth)
           q(1:nffth,map_z(ib)) = qtmp(1:nffth)
        enddo
        allocate(qtran(np_ffth,neg));qtran=zero
        call m_ES_W_transpose_fft_cmplx(nffth,np_ffth,q,qtran)
        deallocate(q)

        ! bisection
        call bisection(regionl,regionm,regionn,np_ffth,bisect_by,qtran,qout,0)

        ! diagonalize the matrix qout
        !!call zheev_driver(neg,eigval,qout)
        qoutt(:,:,1) = qout(:,:)
        call simultaneous_diagonalization(1,neg,qoutt,eigval,qout)

        if(printable)then
           do ib=1,neg
              write(nfout,'(a,i8,a,f20.15)') &
             & ' !** eigen value of state ',ib,' : ',eigval(ib)
           enddo
        endif

        ! unitary transformation
        allocate(q1(np_ffth,neg));q1=zero
        call zgemm('N','N',np_ffth,neg,neg,one,qtran,np_ffth,qout,neg,zero,q1,np_ffth)
        deallocate(qtran)

        ! back to G-space
        allocate(q(nffth,np_e));q=0.d0
        call m_ES_W_transpose_back_fft_cmplx(nffth,np_ffth,q,q1)
        deallocate(q1)
        do ib=1,np_e
           do ig=1,nffth
              i1 = (ig-1)*kimg+1
              bfft(i1) = real(q(ig,ib))
              if(kimg==2) bfft(i1+1) = aimag(q(ig,ib))
           enddo
           call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,OFF)
           do ig=1,iba(ik)
              i1 = kimg*igf(nbase(ig,ik))-1
              zaj_l(ig,ib,ik,1) = bfft(i1)
              if(kimg==2) zaj_l(ig,ib,ik,kimg) = bfft(i1+1)
           enddo
        enddo
        deallocate(q)
     enddo

     call m_ES_modified_gram_schmidt(nfout)

     deallocate(qtmp)
     deallocate(qout)
     deallocate(bfft)
     deallocate(eigval)
     call tstatc0_end(id_sname)

  end subroutine m_ES_RSB_test

  subroutine m_ES_RSB_test_xyz()
     integer :: ik,ib,ig,i1,ib1,ib2

     complex(kind=DP), allocatable, dimension(:,:) :: q,q1,qtran
     complex(kind=DP), allocatable, dimension(:,:) :: qvec
     complex(kind=DP), allocatable, dimension(:,:,:) :: qout
     complex(kind=DP), allocatable, dimension(:) :: qtmp

     real(kind=DP), allocatable, dimension(:) :: bfft
     real(kind=DP), allocatable, dimension(:,:) :: eigval
     real(kind=DP) :: normr,normi,norm
     integer :: nffth
     integer :: modnrmt
     integer, dimension(2) :: regionl,regionm,regionn

     integer :: id_sname=-1

     call tstatc0_begin('m_ES_RSB_test ',id_sname,1)
     nffth = nfft/2

     allocate(qout(neg,neg,3));qout=zero
     allocate(qvec(neg,neg));qvec=zero
     allocate(qtmp(nffth));qtmp=zero
     allocate(bfft(nfft));bfft=0.d0
     allocate(eigval(neg,3));eigval=0.d0

     if(modnrm==EXECUT)then
        modnrmt = modnrm
        modnrm = NORMCONSERVATION
        call m_ES_modified_gram_schmidt(nfout)
        modnrm = modnrmt
     endif

     regionl(1) = 1
     regionl(2) = fft_box_size_WF(1,1)
     regionm(1) = 1
     regionm(2) = fft_box_size_WF(2,1)
     regionn(1) = 1
     regionn(2) = fft_box_size_WF(3,1)

     do ik=1,kv3,af+1
        if(map_k(ik)/=myrank_k) cycle

        ! WF in rspace
        allocate(q(nffth,np_e));q=zero
        do ib=ista_e,iend_e,istep_e
           call m_ES_WF_in_Rspace(ik,ib,bfft)
           normr=0.d0;normi=0.d0;qtmp=zero
           do ig=1,nffth
              i1 = (ig-1)*kimg+1
              qtmp(ig) = dcmplx(bfft(i1),bfft(i1+1))
              normr = normr+bfft(i1)*bfft(i1)
              if(kimg==2) normi = normi+bfft(i1+1)*bfft(i1+1)
           enddo
           norm = normr+normi
           norm = 1.d0/dsqrt(norm)
           qtmp(1:nffth) = norm*qtmp(1:nffth)
           q(1:nffth,map_z(ib)) = qtmp(1:nffth)
        enddo
        allocate(qtran(np_ffth,neg));qtran=zero
        call m_ES_W_transpose_fft_cmplx(nffth,np_ffth,q,qtran)
        deallocate(q)

        ! bisection
        call bisection_xyz(regionl,regionm,regionn,np_ffth,qtran,qout,1)

        ! diagonalize the matrix qout
        call simultaneous_diagonalization(3,neg,qout,eigval,qvec)

        !if(printable)then
        !   allocate(localization_info(lmax_rsb,3,neg))
        !   call build_localization_info(neg,lmax_rsb,eigval,localization_info)
        !   call print_localization_info(neg,lmax_rsb,localization_info,nfout)
        !   deallocate(localization_info)
        !endif

        ! unitary transformation
        allocate(q1(np_ffth,neg));q1=zero
        call zgemm('N','N',np_ffth,neg,neg,one,qtran,np_ffth,qvec,neg,zero,q1,np_ffth)
        deallocate(qtran)

        ! back to G-space
        allocate(q(nffth,np_e));q=0.d0
        call m_ES_W_transpose_back_fft_cmplx(nffth,np_ffth,q,q1)
        deallocate(q1)
        do ib=1,np_e
           do ig=1,nffth
              i1 = (ig-1)*kimg+1
              bfft(i1) = real(q(ig,ib))
              if(kimg==2) bfft(i1+1) = aimag(q(ig,ib))
           enddo
           call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,OFF)
           do ig=1,iba(ik)
              i1 = kimg*igf(nbase(ig,ik))-1
              zaj_l(ig,ib,ik,1) = bfft(i1)
              if(kimg==2) zaj_l(ig,ib,ik,kimg) = bfft(i1+1)
           enddo
        enddo
        deallocate(q)
     enddo

     call m_ES_modified_gram_schmidt(nfout)

     deallocate(qtmp)
     deallocate(qout)
     deallocate(qvec)
     deallocate(bfft)
     deallocate(eigval)
     call tstatc0_end(id_sname)
  end subroutine m_ES_RSB_test_xyz

  subroutine bisection_xyz(regionl,regionm,regionn,np_ffth,qtran,qout,lmax_rsb)
     integer, dimension(2), intent(in) :: regionl,regionm,regionn
     integer, intent(in) :: np_ffth
     complex(kind=DP),dimension(np_ffth,neg), intent(in) :: qtran
     complex(kind=DP), dimension(neg,neg,3), intent(out) :: qout
     integer, intent(in) :: lmax_rsb
!     call bisection(regionl,regionm,regionn,np_ffth,0,qtran,qout(:,:,1),phase)
!     call bisection(regionl,regionm,regionn,np_ffth,1,qtran,qout(:,:,2),phase)
!     call bisection(regionl,regionm,regionn,np_ffth,2,qtran,qout(:,:,3),phase)
     call bisection_by_walsh(np_ffth,neg,0,qtran,qout(:,:,1),lmax_rsb)
     call bisection_by_walsh(np_ffth,neg,1,qtran,qout(:,:,2),lmax_rsb)
     call bisection_by_walsh(np_ffth,neg,2,qtran,qout(:,:,3),lmax_rsb)
  end subroutine bisection_xyz

  subroutine bisection_by_walsh(np_ffth,nval,bisection_plane,qtran,qout,lmax_rsb)
     integer, intent(in) :: np_ffth,nval
     integer, intent(in) :: bisection_plane
     complex(kind=DP),dimension(np_ffth,nval), intent(in) :: qtran
     complex(kind=DP),dimension(nval,nval), intent(out) :: qout
     integer, intent(in) :: lmax_rsb

     integer :: ig
     integer :: ierr
     integer :: n1
     integer :: il,im,in
     integer :: fl,fm,fn
     integer :: lh,mh,nh
     complex(kind=DP), allocatable, dimension(:,:) :: q1
     real(kind=DP), allocatable, dimension(:,:) :: rq1,iq1,qout1,qout2,qout3,qout4
     complex(kind=DP) :: qtmp
     integer :: lmin,lmax,mmin,mmax,nmin,nmax
     integer :: id,mm,nl,nm,nn,nlhf
     integer :: ifft
     integer :: id_sname=-1
     real(kind=DP) :: x,denom

     call tstatc0_begin('bisection_by_walsh ',id_sname,1)

     id = fft_box_size_WF(1,0)
     mm = fft_box_size_WF(2,0)
     nl = fft_box_size_WF(1,1)
     nm = fft_box_size_WF(2,1)
     nn = fft_box_size_WF(3,1)
     if(kimg==1)then
       nlhf = id/2
     else
       nlhf = id
     endif
     n1 = 0
     allocate(q1(np_ffth,nval));q1=zero
     if(bisection_plane==0)then
        denom = 1.d0/dble(nl)
     else if (bisection_plane==1)then
        denom = 1.d0/dble(nm)
     else if (bisection_plane==2)then
        denom = 1.d0/dble(nn)
     endif

     do il=1,nl
        do im=1,nm
           do in=1,nn
              ig = nlhf*mm*(in-1)+nlhf*(im-1)+il
              if(ig.lt.ista_ffth.or.ig.gt.iend_ffth) cycle
              if(bisection_plane==0) then
                 x = dble(il)*denom
              else if(bisection_plane==1)then
                 x = dble(im)*denom
              else if(bisection_plane==2)then
                 x = dble(in)*denom
              endif
              if(walsh(lmax_rsb,x))then
                 n1=n1+1
                 q1(n1,1:nval) = qtran(ig-ista_ffth+1,1:nval)
              endif
           enddo
        enddo
     enddo

     ! qout = Q1H dot Q1
     qout=zero
#ifdef RSB_DEBUG
     do il=1,nval
        do im=1,nval
           qtmp=zero
           do in=1,n1
              qtmp = qtmp + dconjg(q1(in,il))*q1(in,im)
           enddo
           qout(il,im) = qtmp
        enddo
     enddo
#else
     if(n1>0)then
        call flush(0)
        allocate(rq1(n1,nval));rq1=0.d0
        allocate(iq1(n1,nval));iq1=0.d0
        allocate(qout1(nval,nval));qout1=0.d0
        allocate(qout2(nval,nval));qout2=0.d0
        allocate(qout3(nval,nval));qout3=0.d0
        allocate(qout4(nval,nval));qout4=0.d0
        rq1(1:n1,1:nval) = real(q1(1:n1,1:nval))
        iq1(1:n1,1:nval) = aimag(q1(1:n1,1:nval))
        call dgemm('T','N',nval,nval,n1,1.d0,rq1,n1,rq1,n1,0.d0,qout1,nval)
        call dgemm('T','N',nval,nval,n1,1.d0,iq1,n1,iq1,n1,0.d0,qout2,nval)
        call dgemm('T','N',nval,nval,n1,1.d0,iq1,n1,rq1,n1,0.d0,qout3,nval)
        call dgemm('T','N',nval,nval,n1,1.d0,rq1,n1,iq1,n1,0.d0,qout4,nval)
        qout = cmplx(qout1+qout2,-qout3+qout4)
        deallocate(rq1,iq1)
        deallocate(qout1,qout2,qout3,qout4)
     endif
#endif
     call mpi_allreduce(MPI_IN_PLACE,qout,nval*nval,mpi_double_complex,&
     &    mpi_sum,mpi_k_world(myrank_k),ierr)
     deallocate(q1)

     !currnval = 0.5*totch
        do il=1,nval
           do im=1,nval
              if(il.gt.currnval.and.im.le.currnval .or.  il.le.currnval.and.im.gt.currnval) qout(il,im)=zero
           enddo
        enddo

     call tstatc0_end(id_sname)
  end subroutine bisection_by_walsh

  subroutine bisection(regionl,regionm,regionn,np_ffth,bisection_plane,qtran,qout,phase)
     integer,dimension(2),intent(in) :: regionl,regionm,regionn
     integer, intent(in) :: np_ffth
     integer, intent(in) :: bisection_plane
     complex(kind=DP),dimension(np_ffth,neg), intent(in) :: qtran
     complex(kind=DP),dimension(neg,neg), intent(out) :: qout
     integer, intent(in) :: phase

     integer :: ig
     integer :: ierr
     integer :: n1
     integer :: il,im,in
     integer :: fl,fm,fn
     integer :: lh,mh,nh
     complex(kind=DP), allocatable, dimension(:,:) :: q1
     integer :: lmin,lmax,mmin,mmax,nmin,nmax
     integer :: id,mm,nl,nm,nn,nlhf

     integer :: id_sname=-1

     call tstatc0_begin('bisection ',id_sname,1)

     id = fft_box_size_WF(1,0)
     mm = fft_box_size_WF(2,0)
     nl = fft_box_size_WF(1,1)
     nm = fft_box_size_WF(2,1)
     nn = fft_box_size_WF(3,1)
     if(kimg==1)then
       nlhf = id/2
     else
       nlhf = id
     endif
     lmin=regionl(1);lmax=regionl(2)
     mmin=regionm(1);mmax=regionm(2)
     nmin=regionn(1);nmax=regionn(2)
     if(phase==0)then
        if(bisection_plane==0)then
           lmax = (lmax-lmin+1)/2
        else if (bisection_plane==1)then
           mmax = (mmax-mmin+1)/2
        else if (bisection_plane==2)then
           nmax = (nmax-nmin+1)/2
        endif
     else if (phase==1)then
        if(bisection_plane==0)then
           lmin = (lmax-lmin)/2
        else if (bisection_plane==1)then
           mmin = (mmax-mmin)/2
        else if (bisection_plane==2)then
           nmin = (nmax-nmin)/2
        endif
     endif
     n1 = 0
     allocate(q1(np_ffth,neg));q1=zero

     do il=lmin,lmax
        do im=mmin,mmax
           do in=nmin,nmax
              ig = nlhf*mm*(in-1)+nlhf*(im-1)+il
              if(ig.lt.ista_ffth.or.ig.gt.iend_ffth) cycle
              n1=n1+1
              q1(n1,1:neg) = qtran(ig-ista_ffth+1,1:neg)
           enddo
        enddo
     enddo

     ! qout = Q1H dot Q1
     qout=zero
     call zgemm('C','N',neg,neg,n1,one,q1,np_ffth,q1,np_ffth,zero,qout,neg)
     call mpi_allreduce(MPI_IN_PLACE,qout,neg*neg,mpi_double_complex,&
     &    mpi_sum,mpi_k_world(myrank_k),ierr)
     deallocate(q1)

     call tstatc0_end(id_sname)
  end subroutine bisection

  subroutine zheev_driver(ndim,eigval,cmtrx)
   integer, intent(in) :: ndim
   real(kind=DP), dimension(ndim), intent(out) :: eigval
   complex(kind=DP), dimension(ndim,ndim), intent(inout) :: cmtrx
   character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
   integer :: lda
! --> T. Yamasaki 2009/07/24 revised according to a Dr. Katagiri's report
!!$   integer :: lwork,lwork_min,rwork_size
   integer :: lwork_min,rwork_size
   integer, save :: lwork = 0
! <--
   integer, parameter :: lwork_huge=10**8
   real(kind=DP),allocatable,dimension(:) :: work_lapack
   real(kind=DP),allocatable,dimension(:) :: rwork_lapack
   integer :: info

   integer :: id_sname = -1
   call tstatc0_begin('zheev_driver ', id_sname)

      lda=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
     JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
     UPLO = 'U'
      lwork_min=max(1,2*ndim-1)
      rwork_size=max(3*ndim-2,1)
     if(lwork < lwork_min)  lwork=lwork_min
     if(lwork > lwork_huge) lwork=lwork_min

     allocate(work_lapack(lwork*2))
     allocate(rwork_lapack(rwork_size))

     call zheev(JOBZ,UPLO,ndim,cmtrx,lda,eigval,work_lapack,lwork,rwork_lapack,info)
     lwork= int(work_lapack(1))+1

     deallocate(work_lapack)
     deallocate(rwork_lapack)

     call tstatc0_end(id_sname)
  end subroutine zheev_driver

  subroutine dsyev_driver(ndim,eig,w1hw2)
    integer, intent(in):: ndim
    real(kind=DP), intent(out) ,dimension(ndim) :: eig
    real(kind=DP), intent(inout) ,dimension(ndim,ndim) :: w1hw2

    integer, parameter :: PRINTLEVEL = 2
    character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
    integer :: lda
!!$    integer :: lwork,lwork_min
    integer, save :: lwork=0
    integer       :: lwork_min
    integer,parameter :: nb = 64
    integer, parameter :: lwork_huge=10**8
    real(kind=DP),allocatable,dimension(:) :: work_lapack
    integer :: info

    integer :: id_sname = -1
    call tstatc0_begin('dsyev_driver ', id_sname)

    lda=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
! (define lwork)
!!$    lwork = 0
!!$    lwork_min=max(1,3*ndim-1)
    lwork_min=max(1,(nb+2)*ndim)
    if(lwork == 0) then
       lwork = -1
       allocate(work_lapack(1))
       call dsyev(JOBZ,UPLO,ndim,w1hw2,lda,eig,work_lapack,lwork,info)
       lwork = int(work_lapack(1))+1
       deallocate(work_lapack)
    end if
    if(lwork < lwork_min) lwork=lwork_min
    if(lwork > lwork_huge) lwork=lwork_min
    allocate(work_lapack(lwork))

    call dsyev(JOBZ,UPLO,ndim,w1hw2,lda,eig,work_lapack,lwork,info)
!!$    write(*,*) 'lwork& info & suggested lwork = ',lwork,info,work_lapack(1)
!!$    lwork= int(work_lapack(1))+1
    deallocate(work_lapack)

    call tstatc0_end(id_sname)
  end subroutine dsyev_driver

  subroutine get_rot_mat(ndim,nmatrices,matrices,i,j,rii,rjj,rij,rji)
     integer, intent(in) :: ndim,nmatrices
     complex(kind=8), dimension(ndim,ndim,nmatrices) :: matrices
     integer, intent(in) :: i,j
     complex(kind=8), intent(out) :: rii,rjj,rij,rji
     integer :: k,ih,jh
     real(kind=DP), dimension(3,3) :: Gmat
     complex(kind=DP), dimension(3) :: hvec
     real(kind=DP), dimension(3) :: Geigval
     real(kind=DP), dimension(3,3) :: hhh
     complex(kind=DP) :: aii,ajj,aij,aji
     complex(kind=DP) :: c,s
     real(kind=DP) :: x,y,z

     ! calculate the rotation angle
     Gmat(:,:) = 0.d0
     do k=1,nmatrices
        aii=matrices(i,i,k)
        ajj=matrices(j,j,k)
        aij=matrices(i,j,k)
        aji=matrices(j,i,k)
        hvec(1) = aii-ajj
        hvec(2) = aij+aji
        hvec(3) = onei*(aji-aij)
        do ih=1,3
           do jh=1,3
              hhh(ih,jh) = dconjg(hvec(ih))*hvec(jh)
           enddo
        enddo
        Gmat(:,:) = Gmat(:,:)+real(hhh(:,:))
     enddo
     Geigval=0.d0
     call dsyev_driver(3,Geigval,Gmat)
     if(Gmat(1,3)<0) Gmat(:,:) = -Gmat(:,:)
     x = Gmat(1,3)
     y = Gmat(2,3)
     z = Gmat(3,3)

     c = dcmplx(dsqrt(0.5d0+0.5d0*x),0.d0)
     s = dcmplx(0.5d0*y,-0.5d0*z)/c

     rii = c
     rji = s
     rij = -dconjg(s)
     rjj = c
  end subroutine get_rot_mat

  subroutine gather_curr_indpair(i,j,currindpair)
     integer, intent(in) :: i,j
     integer, dimension(2,0:nrank_e-1), intent(out) :: currindpair
     integer, allocatable, dimension(:,:) :: currindpairb
     integer :: ierr
     if(nrank_e>1)then
        allocate(currindpairb(2,0:nrank_e-1));currindpairb=0
        currindpairb(1,myrank_e) = i
        currindpairb(2,myrank_e) = j
        call mpi_allgather(currindpairb(1,myrank_e),2,mpi_integer, &
                         & currindpair(1,0),2,mpi_integer,mpi_k_world(myrank_k),ierr)
        deallocate(currindpairb)
     else
        currindpair(1,0) = i
        currindpair(2,0) = j
     endif
  end subroutine gather_curr_indpair

  subroutine gather_rot_mat(rii,rjj,rij,rji,rotmat)
     complex(kind=DP), intent(in) :: rii,rjj,rij,rji
     complex(kind=DP), dimension(4,0:nrank_e-1), intent(out) :: rotmat
     complex(kind=DP), allocatable, dimension(:,:) :: rotmatb
     integer :: ierr
     if(nrank_e>1)then
        allocate(rotmatb(4,0:nrank_e-1));rotmatb=zero
        rotmatb(1,myrank_e) = rii
        rotmatb(2,myrank_e) = rjj
        rotmatb(3,myrank_e) = rij
        rotmatb(4,myrank_e) = rji
        rotmat=zero
        call mpi_allgather(rotmatb(1,myrank_e),4,mpi_double_complex, &
                         & rotmat(1,0),4,mpi_double_complex,mpi_k_world(myrank_k),ierr)
        deallocate(rotmatb)
     else
        rotmat(1,0) = rii
        rotmat(2,0) = rjj
        rotmat(3,0) = rij
        rotmat(4,0) = rji
     endif
  end subroutine gather_rot_mat

  ! subroutine which approximately diagonalizes a set of matrices simultaneously
  subroutine simultaneous_diagonalization_dbg(nmatrices,ndim,matrices,eigval,eigvec,verbose)
     integer, intent(in) :: nmatrices,ndim
     complex(kind=DP), dimension(ndim,ndim,nmatrices),intent(inout) :: matrices
     real(kind=DP),    dimension(ndim,nmatrices),     intent(out)   :: eigval
     complex(kind=DP), dimension(ndim,ndim),          intent(out)   :: eigvec
     logical, intent(in), optional                                  :: verbose
     real(kind=DP), dimension(3,3) :: Gmat
     real(kind=DP), dimension(3,3) :: hhh
     complex(kind=DP) :: aii,ajj,aij,aji,rii,rij,rji,rjj
     complex(kind=DP), dimension(3) :: hvec
     real(kind=DP), dimension(3) :: Geigval
     complex(kind=DP) :: c,s
     real(kind=DP) :: x,y,z
     integer :: isweep
     integer :: i,j,k,ih,jh,kh,ii,jj
     integer :: nsweep = 1000
     real(kind=DP) :: sum_diag,sum_diago,sum_offdiag,sum_offdiago
     real(kind=DP) :: eps_diag=1.d-10
     complex(kind=DP),allocatable,dimension(:) :: ctmpval1,ctmpval2
     integer :: nblock
     integer, allocatable, dimension(:,:) :: indpair
     complex(kind=DP), allocatable, dimension(:,:,:) :: matbuf
     logical :: verb=.false.
     integer :: id_sname=-1
     call tstatc0_begin('simultaneous diagonalization ',id_sname,1)
     if(present(verbose))then
        verb = verbose
     endif
     allocate(ctmpval1(ndim))
     allocate(ctmpval2(ndim))
     eigvec(1:ndim,1:ndim) = zero
     do ih=1,ndim
        eigvec(ih,ih) = one
     enddo
     nblock = (ndim/2)/nrank_e
     allocate(indpair(nblock,2))
     sum_diago=0.d0
     sum_offdiago=0.d0
     do k=1,nmatrices
        do ih=1,ndim-1
           sum_diago = sum_diago + real(dconjg(matrices(ih,ih,k))*matrices(ih,ih,k))
           do jh=ih+1,ndim
              sum_offdiago = sum_offdiago+real(dconjg(matrices(ih,jh,k))*matrices(ih,jh,k))
           enddo
        enddo
        sum_diago = sum_diago + real(dconjg(matrices(ndim,ndim,k))*matrices(ndim,ndim,k))
     enddo
     if(printable.and.verb.or.iprirsb>=2)then
        write(nfout,'(a)') '!-- simultaneous diagonalization'
        write(nfout,'(a,i5,i8)') '!-- number of matrices and their dimension : ',nmatrices,ndim
        write(nfout,'(a,3f20.10)') &
        & '!-- initial sum of the square of the diagonal, offdiagonal, and total elements :        ' &
        & ,sum_diago,sum_offdiago*2,sum_diago+sum_offdiago*2
     endif
     allocate(matbuf(ndim,ndim,nmatrices));matbuf=zero
     call initial_indices(ndim,nblock,myrank_e,indpair)
     do isweep=1,nsweep
        do ii=1,ndim-1
!           do j=i+1,ndim
           do jj=1,nblock
              do k=1,nblock
                 matbuf(:,indpair(k,1),:) = matrices(:,indpair(k,1),:)
                 matbuf(:,indpair(k,2),:) = matrices(:,indpair(k,2),:)
              enddo
              i = indpair(jj,1)
              j = indpair(jj,2)
              Gmat(:,:) = 0.d0
              do k=1,nmatrices
                 aii=matbuf(i,i,k)
                 ajj=matbuf(j,j,k)
                 aij=matbuf(i,j,k)
                 aji=matbuf(j,i,k)
                 hvec(1) = aii-ajj
                 hvec(2) = aij+aji
                 hvec(3) = onei*(aji-aij)
                 do ih=1,3
                    do jh=1,3
                       hhh(ih,jh) = dconjg(hvec(ih))*hvec(jh)
                    enddo
                 enddo
                 Gmat(:,:) = Gmat(:,:)+real(hhh(:,:))
              enddo
              Geigval=0.d0
              call dsyev_driver(3,Geigval,Gmat)
              if(Gmat(1,3)<0) Gmat(:,:) = -Gmat(:,:)
              x = Gmat(1,3)
              y = Gmat(2,3)
              z = Gmat(3,3)

              c = dcmplx(dsqrt(0.5d0+0.5d0*x),0.d0)
              s = dcmplx(0.5d0*y,-0.5d0*z)/c

              rii = c
              rji = s
              rij = -dconjg(s)
              rjj = c
              do k=1,nmatrices
                 do ih=1,ndim
                    ctmpval1(ih) = dconjg(rii)*matbuf(i,ih,k)+dconjg(rji)*matbuf(j,ih,k)
                    ctmpval2(ih) = dconjg(rij)*matbuf(i,ih,k)+dconjg(rjj)*matbuf(j,ih,k)
                 enddo
                 matrices(i,1:ndim,k) = ctmpval1(1:ndim)
                 matrices(j,1:ndim,k) = ctmpval2(1:ndim)
                 do ih=1,ndim
                    ctmpval1(ih) = matrices(ih,i,k)*rii+matrices(ih,j,k)*rji
                    ctmpval2(ih) = matrices(ih,i,k)*rij+matrices(ih,j,k)*rjj
                 enddo
                 matrices(1:ndim,i,k) = ctmpval1(1:ndim)
                 matrices(1:ndim,j,k) = ctmpval2(1:ndim)
              enddo
              do ih=1,ndim
                 ctmpval1(ih) = eigvec(ih,i)*rii+eigvec(ih,j)*rji
                 ctmpval2(ih) = eigvec(ih,i)*rij+eigvec(ih,j)*rjj
              enddo
              eigvec(1:ndim,i) = ctmpval1(1:ndim)
              eigvec(1:ndim,j) = ctmpval2(1:ndim)
           enddo
           call send_recv_and_rotate(myrank_e,nrank_e,nblock,indpair,ndim,nmatrices,matrices,eigvec)
        enddo
        sum_diag=0.d0
        sum_offdiag=0.d0
        do k=1,nmatrices
           do ih=1,ndim-1
              sum_diag = sum_diag + real(dconjg(matrices(ih,ih,k))*matrices(ih,ih,k))
              do jh=ih+1,ndim
                 sum_offdiag = sum_offdiag+real(dconjg(matrices(ih,jh,k))*matrices(ih,jh,k))
              enddo
           enddo
           sum_diag = sum_diag + real(dconjg(matrices(ndim,ndim,k))*matrices(ndim,ndim,k))
        enddo
        if(printable.and.verb.or.iprirsb>=2) then
        write(nfout,'(a,i5,a,3f20.10)') &
        & '!-- sweep : ',isweep,', sum of the square of the diagonal, offdiagonal, and total elements : ' &
        & ,sum_diag,sum_offdiag*2,sum_diag+sum_offdiag*2
        endif
        if(abs(sum_diago-sum_diag)/(sum_diag+sum_offdiag*2)<eps_diag) then
           if(printable.and.verb.or.iprirsb>=2) write(nfout,'(a)') '!-- convergence reached'
           exit
        endif
        sum_diago = sum_diag
     enddo
     do k=1,nmatrices
        do i=1,ndim
           eigval(i,k) = real(matrices(i,i,k))
        enddo
     enddo
     deallocate(ctmpval1)
     deallocate(ctmpval2)
     call tstatc0_end(id_sname)
  end subroutine simultaneous_diagonalization_dbg

  ! subroutine which approximately diagonalizes a set of matrices simultaneously
  subroutine simultaneous_diagonalization(nmatrices,ndim,matrices,eigval,eigvec,verbose)
     integer, intent(in) :: nmatrices,ndim
     complex(kind=DP), dimension(ndim,ndim,nmatrices),intent(inout) :: matrices
     real(kind=DP),    dimension(ndim,nmatrices),     intent(out)   :: eigval
     complex(kind=DP), dimension(ndim,ndim),          intent(out)   :: eigvec
     logical, intent(in),optional                                   :: verbose
     complex(kind=DP) :: rii,rij,rji,rjj,crii,crij,crji,crjj,mi,mj,ccrii,ccrij,ccrji,ccrjj
     complex(kind=DP) :: criic,crijc,crjic,crjjc
     complex(kind=DP) :: mii,mij,mji,mjj
     integer :: isweep
     integer :: i,j,k,ih,jh,kh,ii,jj
     integer :: nsweep = 1000
     real(kind=DP) :: sum_diag,sum_diago,sum_offdiag,sum_offdiago
     real(kind=DP) :: eps_diag=1.d-8
     complex(kind=DP),allocatable,dimension(:) :: ctmpval1,ctmpval2
     integer, allocatable, dimension(:,:) :: indpair
     complex(kind=DP), allocatable, dimension(:,:) :: rotmat
     complex(kind=DP), allocatable, dimension(:,:,:) :: mbuf
     integer, allocatable, dimension(:,:) :: currindpair
     complex(kind=DP), allocatable, dimension(:,:) :: eigvec_buf
     integer :: nblock,ierr,irank,itmp,jtmp,i1,j1,kk
     logical :: verb=.false.
     integer :: id_sname=-1
     call tstatc0_begin('simultaneous diagonalization ',id_sname,1)
     if(present(verbose))then
        verb = verbose
     endif
     allocate(ctmpval1(ndim))
     allocate(ctmpval2(ndim))

     nblock = (ndim/2)/nrank_e
     allocate(indpair(nblock,2))

     eigvec(1:ndim,1:ndim) = zero
     do ih=1,ndim
        eigvec(ih,ih) = one
     enddo
     sum_diago=0.d0
     sum_offdiago=0.d0
     do k=1,nmatrices
        do ih=1,ndim-1
           sum_diago = sum_diago + real(dconjg(matrices(ih,ih,k))*matrices(ih,ih,k))
           do jh=ih+1,ndim
              sum_offdiago = sum_offdiago+real(dconjg(matrices(ih,jh,k))*matrices(ih,jh,k))
           enddo
        enddo
        sum_diago = sum_diago + real(dconjg(matrices(ndim,ndim,k))*matrices(ndim,ndim,k))
     enddo
     if(printable.and.verb.or.iprirsb>=2)then
        write(nfout,'(a)') '!-- simultaneous diagonalization'
        write(nfout,'(a,i5,i8)') '!-- number of matrices and their dimension : ',nmatrices,ndim
        write(nfout,'(a,3f20.10)') &
        & '!-- initial sum of the square of the diagonal, offdiagonal, and total elements :        ' &
        & ,sum_diago,sum_offdiago*2,sum_diago+sum_offdiago*2
     endif

     call initial_indices(ndim,nblock,myrank_e,indpair)
     allocate(rotmat(4,0:nrank_e-1));rotmat=zero
     allocate(currindpair(2,0:nrank_e-1));currindpair=0
     allocate(mbuf(ndim,2,nmatrices));mbuf=zero
     do isweep=1,nsweep
        do ii=1,ndim-1
           do jj=1,nblock

              i = indpair(jj,1)
              j = indpair(jj,2)
              mbuf(:,1,:)=matrices(:,i,:)
              mbuf(:,2,:)=matrices(:,j,:)
              call gather_curr_indpair(i,j,currindpair)
              call get_rot_mat(ndim,nmatrices,matrices,i,j,rii,rjj,rij,rji)
              call gather_rot_mat(rii,rjj,rij,rji,rotmat)
              ccrii=dconjg(rii);ccrij=dconjg(rij);ccrji=dconjg(rji);ccrjj=dconjg(rjj)
              do k=1,nmatrices
                 do ih=1,ndim
                    mi=matrices(ih,i,k);mj=matrices(ih,j,k)
                    matrices(ih,i,k) = mi*rii+mj*rji
                    matrices(ih,j,k) = mi*rij+mj*rjj
                 enddo
              enddo

              do k=1,nmatrices
                 do irank=0,nrank_e-1
                    itmp = currindpair(1,irank)
                    jtmp = currindpair(2,irank)
                    crii = rotmat(1,irank);criic=dconjg(crii)
                    crjj = rotmat(2,irank);crjjc=dconjg(crjj)
                    crij = rotmat(3,irank);crijc=dconjg(crij)
                    crji = rotmat(4,irank);crjic=dconjg(crji)
                    mii=dconjg(mbuf(itmp,1,k));mij=dconjg(mbuf(jtmp,1,k))
                    mjj=dconjg(mbuf(jtmp,2,k));mji=dconjg(mbuf(itmp,2,k))
                    matrices(itmp,i,k) = dconjg((mii*crii+mij*crji)*ccrii+(mji*crii+mjj*crji)*ccrji)
                    matrices(jtmp,i,k) = dconjg((mii*crij+mij*crjj)*ccrii+(mji*crij+mjj*crjj)*ccrji)
                    matrices(itmp,j,k) = dconjg((mii*crii+mij*crji)*ccrij+(mji*crii+mjj*crji)*ccrjj)
                    matrices(jtmp,j,k) = dconjg((mii*crij+mij*crjj)*ccrij+(mji*crij+mjj*crjj)*ccrjj)
                    do kk=1,nblock
                       if(kk.eq.jj) cycle
                       i1 = indpair(kk,1);j1=indpair(kk,2)
                       mii=matrices(itmp,i1,k);mji=matrices(jtmp,i1,k)
                       mjj=matrices(jtmp,j1,k);mij=matrices(itmp,j1,k)
                       matrices(itmp,i1,k) = criic*mii+crjic*mji
                       matrices(itmp,j1,k) = criic*mij+crjic*mjj
                       matrices(jtmp,i1,k) = crijc*mii+crjjc*mji
                       matrices(jtmp,j1,k) = crijc*mij+crjjc*mjj
                    enddo
                 enddo
              enddo

              do ih=1,ndim
                 ctmpval1(ih) = eigvec(ih,i)*rii+eigvec(ih,j)*rji
                 ctmpval2(ih) = eigvec(ih,i)*rij+eigvec(ih,j)*rjj
              enddo
              eigvec(1:ndim,i) = ctmpval1(1:ndim)
              eigvec(1:ndim,j) = ctmpval2(1:ndim)
           enddo
           call send_recv_and_rotate(myrank_e,nrank_e,nblock,indpair,ndim,nmatrices,matrices,eigvec)
        enddo
        sum_diag=0.d0
        sum_offdiag=0.d0
        do k=1,nmatrices
           do jh=1,nblock
              i = indpair(jh,1)
              j = indpair(jh,2)
              sum_diag = sum_diag + real(dconjg(matrices(i,i,k))*matrices(i,i,k))
              sum_diag = sum_diag + real(dconjg(matrices(j,j,k))*matrices(j,j,k))
              do kh=1,ndim
                 if(i/=kh) sum_offdiag = sum_offdiag+real(dconjg(matrices(kh,i,k))*matrices(kh,i,k))
              enddo
              do kh=1,ndim
                 if(j/=kh) sum_offdiag = sum_offdiag+real(dconjg(matrices(kh,j,k))*matrices(kh,j,k))
              enddo
           enddo
        enddo
        if(nrank_e>1)then
           call mpi_allreduce(MPI_IN_PLACE,sum_diag,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
           call mpi_allreduce(MPI_IN_PLACE,sum_offdiag,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
        endif
        if(printable.and.verb.or.iprirsb>=2) then
           write(nfout,'(a,i5,a,3f20.10)') &
        & '!-- sweep : ',isweep,', sum of the square of the diagonal, offdiagonal, and total elements : ' &
        & ,sum_diag,sum_offdiag,sum_diag+sum_offdiag
        endif
        if(abs(sum_diago-sum_diag)/(sum_diag+sum_offdiag)<eps_diag) then
           if(printable.and.verb.or.iprirsb>=2) write(nfout,'(a)') '!-- convergence reached'
           exit
        endif
        sum_diago = sum_diag
     enddo

     if(printable)then
        write(nfout,'(a,i5,a)') '!-- simultaneous diagonalization converged after ',isweep,' sweeps'
     endif

     do k=1,nmatrices
        do i=1,ndim
           eigval(i,k) = real(matrices(i,i,k))
        enddo
     enddo

     allocate(eigvec_buf(ndim,ndim));eigvec_buf=zero
     do i=1,nblock
        eigvec_buf(1:ndim,indpair(i,1)) = eigvec(1:ndim,indpair(i,1))
        eigvec_buf(1:ndim,indpair(i,2)) = eigvec(1:ndim,indpair(i,2))
     enddo
     if(nrank_e>1) call mpi_allreduce(MPI_IN_PLACE,eigvec_buf,ndim*ndim,mpi_double_complex,mpi_sum,mpi_k_world(myrank_k),ierr)
     eigvec = eigvec_buf
     deallocate(eigvec_buf)

     deallocate(rotmat)
     deallocate(mbuf)
     deallocate(ctmpval1)
     deallocate(ctmpval2)
     deallocate(indpair)
     deallocate(currindpair)
     call tstatc0_end(id_sname)
  end subroutine simultaneous_diagonalization

  subroutine initial_indices(n,nblock,p,indpair)
     implicit none
     integer, intent(in) :: n,nblock,p
     integer, dimension(nblock,2) :: indpair
     integer :: i,istart,iend
     istart = nblock*p
     do i=1,nblock
        indpair(i,1) = istart+i
     enddo
     iend = n-p*nblock
     do i=1,nblock
        indpair(i,2) = iend-(i-1)
     enddo
  end subroutine initial_indices

  subroutine send_recv_and_rotate(mype,npes,nblock,indpair,ndim,nmatrices,matrices,eigvec)
     implicit none
     integer, intent(in) :: mype,npes,nblock
     integer, dimension(nblock,2), intent(inout) :: indpair
     integer, intent(in) :: ndim,nmatrices
     complex(kind=DP), dimension(ndim,ndim,nmatrices), intent(inout) :: matrices
     complex(kind=DP), dimension(ndim,ndim), intent(inout) :: eigvec
     integer :: ii,i,j
     integer :: indbuf1,indbufn,sendbuf,recvbuf,ierr
     complex(kind=DP), allocatable, dimension(:,:) :: cbuf,cbufr
     integer, allocatable, dimension(:) :: ista
     allocate(ista(MPI_STATUS_SIZE))
     allocate(cbuf(1:ndim,1:nmatrices+1));cbuf=zero
     allocate(cbufr(1:ndim,1:nmatrices+1));cbufr=zero

     if(mype<npes-1)then
        sendbuf = indpair(nblock,1)
        cbuf(1:ndim,1:nmatrices) = matrices(1:ndim,sendbuf,1:nmatrices)
        cbuf(1:ndim,nmatrices+1) = eigvec(1:ndim,sendbuf)
        call mpi_send(sendbuf,1,mpi_integer,mype+1,0,mpi_k_world(myrank_k),ierr)
        call mpi_recv(recvbuf,1,mpi_integer,mype+1,0,mpi_k_world(myrank_k),ista,ierr)
        call mpi_send(cbuf,ndim*(nmatrices+1),mpi_double_complex,mype+1,0,mpi_k_world(myrank_k),ierr)
        call mpi_recv(cbufr,ndim*(nmatrices+1),mpi_double_complex,mype+1,0,mpi_k_world(myrank_k),ista,ierr)
        indpair(nblock,1) = recvbuf
        matrices(1:ndim,recvbuf,1:nmatrices) = cbufr(1:ndim,1:nmatrices)
        eigvec(1:ndim,recvbuf) = cbufr(1:ndim,nmatrices+1)
     endif
     if(mype>0)then
        sendbuf = indpair(1,2)
        cbuf(1:ndim,1:nmatrices) = matrices(1:ndim,sendbuf,1:nmatrices)
        cbuf(1:ndim,nmatrices+1) = eigvec(1:ndim,sendbuf)
        call mpi_recv(recvbuf,1,mpi_integer,mype-1,0,mpi_k_world(myrank_k),ista,ierr)
        call mpi_send(sendbuf,1,mpi_integer,mype-1,0,mpi_k_world(myrank_k),ierr)
        call mpi_recv(cbufr,ndim*(nmatrices+1),mpi_double_complex,mype-1,0,mpi_k_world(myrank_k),ista,ierr)
        call mpi_send(cbuf,ndim*(nmatrices+1),mpi_double_complex,mype-1,0,mpi_k_world(myrank_k),ierr)
        indpair(1,2) = recvbuf
        matrices(1:ndim,recvbuf,1:nmatrices) = cbufr(1:ndim,1:nmatrices)
        eigvec(1:ndim,recvbuf) = cbufr(1:ndim,nmatrices+1)
     endif

     deallocate(ista)
     deallocate(cbuf)
     deallocate(cbufr)

     indbufn = indpair(nblock,1)
     if(mype==0)then
        do i=nblock,3,-1
           indpair(i,1) = indpair(i-1,1)
        enddo
     else
        do i=nblock,2,-1
           indpair(i,1) = indpair(i-1,1)
        enddo
     endif
     indbuf1 = indpair(1,2)
     do i=1,nblock-1
        indpair(i,2) = indpair(i+1,2)
     enddo
     if(mype==0)then
        indpair(2,1) = indbuf1
     else
        indpair(1,1) = indbuf1
     endif
     indpair(nblock,2) = indbufn
  end subroutine send_recv_and_rotate

  logical function walsh(l,x)
    implicit none
    integer, intent(in) :: l
    real(kind=DP), intent(in) :: x
    real(kind=DP) :: xx,dx,dx2
    real(kind=DP) :: wal
    if(l.eq.1)then
      if(x.lt.0.5d0) then
        walsh=.false.
      else
        walsh=.true.
      endif
      return
    endif
    dx = 1.d0/dble(2**l)
    if(x.lt.dx)then
      walsh=.false.
      return
    endif
    dx2 = 2.d0*dx
    xx = x+dx
    if(xx.gt.1) xx=xx-1
    wal = 2*(mod(floor(xx/dx2),2)-0.5)
    walsh = wal>0
  end function walsh

  !transform a vector to rsb space/submat space
  !imode==DIRECT  -> to rsb space,
  !imode==INVERSE -> to submat space
  subroutine m_ES_RSB_unitary_transform_vec(imode,ik,vec)
    integer,intent(in) :: imode,ik
    real(kind=DP), intent(inout), dimension(kg1,np_e,kimg) :: vec
    complex(kind=DP),allocatable,dimension(:,:) :: bufvec1,bufvec2
    integer :: npg1k
    npg1k = maxval(np_g1k)
    allocate(bufvec1(kg1,np_e));bufvec1=zero
    if(kimg==1)then
       bufvec1(:,:) = dcmplx(vec(:,:,1),0.d0)
    else
       bufvec1(:,:) = dcmplx(vec(:,:,1),vec(:,:,2))
    endif

    allocate(bufvec2(npg1k,neg));bufvec2=zero
    call m_ES_W_transpose_fft_cmplx(kg1,npg1k,bufvec1,bufvec2)
    deallocate(bufvec1)

    allocate(bufvec1(npg1k,neg));bufvec1=zero
    if(imode==DIRECT)then
        call zgemm('N','N',npg1k,nval,nval,one,bufvec2,npg1k,qout,nval,zero,bufvec1,npg1k)
    else if (imode==INVERSE)then
        call zgemm('N','C',npg1k,nval,nval,one,bufvec2,npg1k,qout,nval,zero,bufvec1,npg1k)
    endif
    deallocate(bufvec2)

    allocate(bufvec2(kg1,np_e));bufvec2=zero
    call m_ES_W_transpose_back_fft_cmplx(kg1,npg1k,bufvec2,bufvec1)
    deallocate(bufvec1)

    vec(:,:,1) = dble(bufvec2(:,:))
    if(kimg>1) vec(:,:,2) = dimag(bufvec2(:,:))
    deallocate(bufvec2)

  end subroutine m_ES_RSB_unitary_transform_vec

  !transform the wfs to rsb space/submat space
  !imode==DIRECT  -> to rsb space,
  !imode==INVERSE -> to submat space
  subroutine m_ES_RSB_unitary_transform_wf(imode,ik,zaj_l,do_betar)
    integer,intent(in) :: imode,ik
    logical,intent(in) :: do_betar
    real(kind=DP), intent(inout), dimension(kg1,np_e,ista_k:iend_k,kimg) :: zaj_l
    real(kind=DP),allocatable,dimension(:,:,:)  :: bufwf
    complex(kind=DP),allocatable,dimension(:,:) :: bufwf1,bufwf2

    call m_ESortho_set_np_g1k_x(ik) !-> np_g1k_x
    allocate(bufwf(np_g1k_x,neg,kimg));bufwf=0.d0
    call m_ES_W_transpose_r(.false.,ista_k,iend_k,ik,zaj_l,bufwf)
    allocate(bufwf1(np_g1k_x,neg));bufwf1=zero
    if(kimg==1)then
       bufwf1(:,:) = dcmplx(bufwf(:,:,1),0.d0)
    else
       bufwf1(:,:) = dcmplx(bufwf(:,:,1),bufwf(:,:,2))
    endif
    deallocate(bufwf)


    allocate(bufwf2(np_g1k_x,neg));bufwf2=zero
    if(imode==DIRECT)then
        call zgemm('N','N',np_g1k_x,nval,nval,one,bufwf1,np_g1k_x,qout,nval,zero,bufwf2,np_g1k_x)
    else if (imode==INVERSE)then
        call zgemm('N','C',np_g1k_x,nval,nval,one,bufwf1,np_g1k_x,qout,nval,zero,bufwf2,np_g1k_x)
    endif

    allocate(bufwf(np_g1k_x,neg,kimg));bufwf=0.d0
    bufwf(:,:,1) = dble(bufwf2(:,:))
    if(kimg>1) bufwf(:,:,2) = dimag(bufwf2(:,:))
    deallocate(bufwf2)

    call m_ES_W_transpose_back_r(.false.,ista_k,iend_k,ik,zaj_l,bufwf)
    deallocate(bufwf)
    if(do_betar) call m_ES_betar_dot_WFs_4_each_k(nfout,ik)   ! -> fsr_l,fsi_l
  end subroutine m_ES_RSB_unitary_transform_wf


end module m_ES_RSB

!=======================================================================
!
!  SOFTWARE NAME : PHASE ($Revision: 603 $)
!
!  MODULE: m_Phonon
!
!  AUTHOR(S): T. Yamamoto   May/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Phonon
  ! $Id: m_Phonon.F90 603 2020-04-07 03:25:30Z jkoga $
  use m_Const_parameters,   only : DP, ON, OFF, NOCONV, FMAXVALLEN, PAI, PAI2, PAI4 &
       &     , PHONON_GAMMA, PHONON_BAND, PHONON_DOS &
       &     , LOWER, CARTS, UNIT_PIEZO_CONST &
       &     , CRDTYP, FILE, FERMI_DIRAC, Hartree, AMU, CONST_EV, PLANCK, speed_of_light
  use m_Control_Parameters, only : sw_phonon, sw_calc_force, sw_calc_force_all &
       &     , sw_vibrational_modes, sw_lo_to_splitting &
       &     , sw_lattice_dielectric_tensor &
       &     , sw_dielectric_function &
       &     , sw_correct_force_constants &
       &     , sw_polynomial_fit, norder &
       &     , sw_int_strain_piezo_tensor, sw_phonon_oneshot &
       &     , phonon_method, num_phonon_calc_mode &
       &     , ipriphonon, printable, way_of_smearing, width, width_tetra
  use m_Crystal_Structure,  only : altv,rltv,altv_super,rltv_super,nlpnt,lpnt,nbztyp_spg
  use m_Ionic_System,       only : num_force_data, phonon_atom &
       &, phonon_displacement &
       &,displaced_atom, displacement &
       &,input_coordinate_system,u &
       &,natm,ionic_mass,speciesname,ityp,ntyp &
       &,istart_phonon,iend_phonon &
       &,natm_prim,natm_super &
       &,pos,cps,phonon_iteration, natm_mobile, force_was_read, atom_key
  use m_BP_Properties,      only : zeff
  use m_Files,              only : nfout,nfkpoint,nfmatbp,m_Files_open_kpoint_files, &
       &                           nfqpoint, m_Files_open_qpoint_files
  use m_Parallelization,    only : mype,npes,ierr, MPI_CommGroup

  ! === KT_add === 13.1R
  use m_Control_Parameters,  only : sw_phonon_with_epsilon
  use m_Raman,               only : m_Raman_read_nfinp, m_Raman_initialize, &
       &                            m_Raman_print_param, m_Raman_calc_susceptibility, &
       &                            dielectric_read_from_file => dielectric
  ! ============== 13.1R

  use m_Kpoints,             only : itrs
  use m_Crystal_Structure,  only : rltv_refcell, altv_refcell
  use mpi

  implicit none
!  include 'mpif.h'

  real(kind=DP),allocatable,dimension(:,:,:) :: force_data ! dim(natm_super,3,num_force_data)
  real(kind=DP),allocatable,dimension(:,:,:) :: forces ! dim(natm_super*3,natm_prim*3,norder*2)
  real(kind=DP),allocatable,dimension(:) :: force0 ! dim(natm_super*3)
  real(kind=DP) :: dielectric(3,3) = 0.d0
  real(kind=DP) :: kvec_dir(3) = 0.d0
  character(len=3), allocatable, dimension(:) :: point_group ! dim(nqvec)
  character(len=3) :: pg_gamma = ''
  integer :: nlat(3) ! lattice size
  real(kind=DP),allocatable,dimension(:,:) :: qvec ! dim(nqvec,3)
  real(kind=DP),allocatable,dimension(:,:) :: qvin ! dim(nqvec,3)
  real(kind=DP),allocatable,dimension(:)   :: wght ! dim(nqvec)
  real(kind=DP),allocatable,dimension(:,:) :: qdir ! dim(nqvec,3)
  integer :: nsp = 1
  real(kind=DP),allocatable,dimension(:,:) :: spcpnt ! dim(nsp,3)
  character(len=3), allocatable, dimension(:)  :: pg_spcpnt ! dim(nsp)
  integer :: nsl = 1
  integer,allocatable,dimension(:,:) :: symln  ! dim(nsl,2)
  integer,allocatable,dimension(:) :: ndiv     ! dim(nsl)
  character(len=3), allocatable, dimension(:)  :: pg_symln ! dim(nsl)
  logical, allocatable, dimension(:,:) :: fksym ! dim(48,nqvec)
  real(kind=DP) :: rho_loto = 1.4d0
  ! strain force coupling const.
  real(kind=DP),allocatable         :: strfrc(:,:,:)   !d(3,natm,6)
  real(kind=DP) :: piezoelectric(3,6) = 0.d0

  ! energy range for dielectric function
  real(kind=DP), private :: max_energy = 0.01d0
  real(kind=DP), private :: min_energy = 0.d0
  integer, private :: num_division = 100
  real(kind=DP), private :: damping_factor = 1.d-2

  ! Phonon DOS
  integer, private :: phonon_dos_mesh(3)
  integer                           :: np0,np1,np2
  integer,allocatable, dimension(:) :: ip20,ip10,ip02,ip12
  integer,allocatable, dimension(:) :: ip01,ip21,iu21,iv21,iwt,ip2cub
  integer, dimension(3)             :: nxyz_tetra
  real(kind=DP)                     :: DeltaE_dos = 1.d-5


  ! calculated
  integer :: nmodes ! = 3*natm
  integer :: nqvec = 1
  integer :: qvec_from_file = ON
  real(kind=DP), allocatable,dimension(:,:,:) :: dynmat  ! dim(3*natm,3*natm,nlpnt)
  complex(kind=DP), allocatable,dimension(:,:,:) :: dynmatq ! dim(3*natm,3*natm,nqvec)
  real(kind=DP), allocatable,dimension(:,:)   :: omega   ! dim(3*natm,nqvec)
  complex(kind=DP), allocatable,dimension(:,:,:) :: modes   ! dim(3*natm,3*natm,nqvec)
  character(len=3), allocatable,dimension(:,:) :: mode_irr_rep ! dim(3*natm,nqvec)
  character(len=4), allocatable,dimension(:,:) :: mode_active  ! dim(3*natm,nqvec)
  real(kind=DP), allocatable,dimension(:)   :: msqinv     ! dim(3*natm)
  real(kind=DP), allocatable,dimension(:,:) :: zeff_mode  ! dim(3,nmodes)
  real(kind=DP) :: static_dielectric(3,3) ! static dielectric tensor
  real(kind=DP) :: lattice_dielectric(3,3) ! lattice dielectric tensor
  real(kind=DP), allocatable,dimension(:,:) :: strphcpl  ! dim(6,nmodes)

  real(DP), parameter :: ev2cminv = CONST_EV / PLANCK / speed_of_light * 1.0d-2

  ! Ewald sum
  real(kind=DP) :: deteps ! Det(epsilon)
  real(kind=DP), dimension(3,3) :: epsinv ! (epsilon)^-1

  integer :: sw_read_forces_pre = ON

  integer, allocatable, dimension(:) :: mode2atom
  integer, allocatable, dimension(:) :: atm2mobileatm
  ! Tags
  character(len("phonon")),private,parameter :: tag_phonon = "phonon"
  character(len("sw_phonon")),private,parameter :: tag_sw_phonon = "sw_phonon"
  character(len("sw_calc_force")),private,parameter :: tag_sw_calc_force = "sw_calc_force"
  character(len("sw_calc_force_all")),private,parameter :: tag_sw_calc_force_all = "sw_calc_force_all"
  character(len("sw_polynomial_fit")),private,parameter :: tag_sw_polynomial_fit = "sw_polynomial_fit"
  character(len("sw_phonon_oneshot")),private,parameter :: tag_sw_phonon_oneshot = "sw_phonon_oneshot"
  character(len("num_phonon_calc_mode")),private,parameter :: tag_num_phonon_calc_mode = "num_phonon_calc_mode"
  character(len("norder")),private,parameter :: tag_norder = "norder"
  character(len("displacement")),private,parameter :: tag_displacement = "displacement"
  character(len("force_calc")),private,parameter :: tag_force_calc = "force_calc"
  character(len("start")),private,parameter :: tag_start = "start"
  character(len("end")),private,parameter :: tag_end = "end"

  character(len("sw_vibrational_modes")),private,parameter :: tag_sw_vibrational_modes = "sw_vibrational_modes"
  character(len("sw_correct_force_constants")),private,parameter :: tag_sw_correct_force_constants = "sw_correct_force_constants"
  character(len("point_group")),private,parameter :: tag_point_group = "point_group"
  character(len("sw_lo_to_splitting")),private,parameter :: tag_sw_lo_to_splitting = "sw_lo_to_splitting"
  character(len("electronic_dielectric_constant")),private,parameter :: &
       & tag_electronic_dielectric_cnst = "electronic_dielectric_constant"
  character(len("exx")),private,parameter :: tag_exx = "exx"
  character(len("eyy")),private,parameter :: tag_eyy = "eyy"
  character(len("ezz")),private,parameter :: tag_ezz = "ezz"
  character(len("exy")),private,parameter :: tag_exy = "exy"
  character(len("eyz")),private,parameter :: tag_eyz = "eyz"
  character(len("ezx")),private,parameter :: tag_ezx = "ezx"
  character(len("k_vector")),private,parameter :: tag_k_vector = "k_vector"
  character(len("kx")),private,parameter :: tag_kx = "kx"
  character(len("ky")),private,parameter :: tag_ky = "ky"
  character(len("kz")),private,parameter :: tag_kz = "kz"

  character(len("sw_lattice_dielectric_tensor")),private,parameter :: &
       & tag_sw_lattice_dielec_tensor = "sw_lattice_dielectric_tensor"
  character(len("sw_internal_strain_piezoelectric_tensor")),private,parameter :: &
       & tag_sw_int_strain_piezo_tensor = "sw_internal_strain_piezoelectric_tensor"

  character(len("sw_dielectric_function")),private,parameter :: tag_sw_dielectric_function = "sw_dielectric_function"
  character(len("energy_range")),private,parameter :: tag_energy_range = "energy_range"
  character(len("min_energy")),private,parameter :: tag_min_energy = "min_energy"
  character(len("max_energy")),private,parameter :: tag_max_energy = "max_energy"
  character(len("division_number")),private,parameter :: tag_division_number = "division_number"
  character(len("damping_factor")),private,parameter :: tag_damping_factor = "damping_factor"


  character(len("lattice")),private,parameter :: tag_lattice = "lattice"
  character(len("l1")),private,parameter :: tag_l1 = "l1"
  character(len("l2")),private,parameter :: tag_l2 = "l2"
  character(len("l3")),private,parameter :: tag_l3 = "l3"

  character(len("no")),private,parameter :: tag_no = "no"
  character(len("id")),private,parameter :: tag_id = "id"
  character(len("special_points")),private,parameter :: tag_special_points = "special_points"
  character(len("symmetry_lines")),private,parameter :: tag_symmetry_lines = "symmetry_lines"
  character(len("k1")),private,parameter :: tag_k1 = "k1"
  character(len("k2")),private,parameter :: tag_k2 = "k2"
  character(len("k3")),private,parameter :: tag_k3 = "k3"
  character(len("num_division")),private,parameter :: tag_num_division = "num_division"

  character(len("method")),private,parameter :: tag_method = "method"
  character(len("calc_type")),private,parameter :: tag_calc_type = "calc_type"
  character(len("gamma")),private,parameter  :: tag_gamma  = "gamma"
  character(len("zone_center")),private,parameter :: tag_zone_center = "zone_center"
  character(len("band")),private,parameter   :: tag_band   = "band"
  character(len("dispersion")),private,parameter :: tag_dispersion = "dispersion"
  character(len("dos")),private,parameter    :: tag_dos    = "dos"

  character(len("mesh")),private,parameter   :: tag_mesh   = "mesh"
  character(len("nx")),private,parameter     :: tag_nx     = "nx"
  character(len("ny")),private,parameter     :: tag_ny     = "ny"
  character(len("nz")),private,parameter     :: tag_nz     = "nz"
  character(len("deltae")),private,parameter :: tag_deltae = "deltae"

  character(len("rho")),private,parameter :: tag_rho = "rho"

  character(len("qvec_from_file")),private, parameter :: tag_qvec_from_file = "qvec_from_file"
  character(len("sw_read_forces_pre")),private, parameter :: tag_sw_read_forces_pre = "sw_read_forces_pre"

  character(len("use_qpoint_data_file")),private, parameter &
       &   :: tag_use_qpoint_data_file = "use_qpoint_data_file"
  integer :: use_qpoint_data_file = OFF

! -------------------------
! phonon band unfolding
!
  character(len("phonon_band_unfolding")),private, parameter :: &
       &      tag_phonon_band_unfolding = "phonon_band_unfolding"
  character(len("sw_phonon_band_unfolding")),private, parameter :: &
       &      tag_sw_phonon_band_unfolding = "sw_phonon_band_unfolding"

  character(len("ngx")),private,parameter     :: tag_ngx     = "ngx"
  character(len("ngy")),private,parameter     :: tag_ngy     = "ngy"
  character(len("ngz")),private,parameter     :: tag_ngz     = "ngz"

  character(len("tolerance_gvec_matching")), private, parameter :: &
       &                     tag_tol_ph_gvec_matching = "tolerance_gvec_matching"

  integer :: sw_phonon_band_unfolding = OFF
  integer :: nmax_G_phonon(3) = (/4,4,4/)
  real(kind=DP) :: tolerance_ph_Gvec_matching = 1.0D-3

  integer, allocatable :: phonon_GVec_on_refcell(:,:,:)
  real(kind=DP),allocatable :: unfolding_weight(:,:)
  real(kind=DP),allocatable :: qvin_refcell(:,:)     ! dim(nqvec,3)

contains

  subroutine m_Phonon_rd_param(nfout)

    integer, intent(in) :: nfout

    integer :: iret, f_selectBlock, f_getIntValue, f_getRealValue, f_getStringValue
    integer :: f_selectParentBlock, f_selectTop
    real(kind=DP) :: dret
    character(len=FMAXVALLEN) :: cret
    real(kind=DP) :: dnorm

    iret = f_selectTop()
    if( f_selectBlock( tag_phonon) == 0) then
       if( f_getIntValue( tag_sw_phonon, iret) == 0) sw_phonon = iret
       if(sw_phonon == ON) then
          sw_calc_force = ON
          if( f_getStringValue( tag_method, cret,LOWER) == 0) then
             call set_phonon_method(cret) ! -> phonon_method
          else if( f_getStringValue( tag_calc_type, cret,LOWER) == 0) then
             call set_phonon_method(cret) ! -> phonon_method
          end if

          if( f_getIntValue( tag_sw_calc_force, iret) == 0) sw_calc_force = iret
          if( f_getIntValue( tag_sw_calc_force_all, iret) == 0) sw_calc_force_all = iret
          if( f_getIntValue( tag_sw_polynomial_fit, iret) == 0) sw_polynomial_fit = iret
          if( f_getIntValue( tag_norder, iret) == 0) norder = iret
          if( f_getRealValue( tag_displacement, dret, 'bohr') == 0) then
             u = dret
          else
             u = 0.1d0 ! default value
          end if
          if( f_getRealValue( tag_damping_factor, dret, '') == 0) damping_factor = dret
          damping_factor = abs(damping_factor)
          if( f_getIntValue( tag_sw_vibrational_modes, iret) == 0) sw_vibrational_modes = iret
          if( f_getIntValue( tag_sw_correct_force_constants, iret) == 0) sw_correct_force_constants = iret
          if( f_getStringValue( tag_point_group, cret, NOCONV) == 0) then
             pg_gamma = cret(1:3)
          else
             pg_gamma = '' ! default value
          end if

          if(f_getIntValue(tag_sw_read_forces_pre,iret)==0) then
             sw_read_forces_pre = iret
          endif

          if( f_selectBlock( tag_phonon_band_unfolding ) == 0) then
             if( f_getIntValue( tag_sw_phonon_band_unfolding, iret)==0) &
                  &      sw_phonon_band_unfolding = iret

             if( f_getRealValue( tag_tol_ph_gvec_matching, dret, "" ) == 0) then
                tolerance_ph_Gvec_matching = dret
             endif

             if( f_getIntValue( tag_ngx, iret) == 0) nmax_G_phonon(1) = iret
             if( f_getIntValue( tag_ngy, iret) == 0) nmax_G_phonon(2) = iret
             if( f_getIntValue( tag_ngz, iret) == 0) nmax_G_phonon(3) = iret
             iret = f_selectParentBlock()
          end if

          if( f_getIntValue( tag_sw_phonon_oneshot, iret)==0) sw_phonon_oneshot = iret
          if( f_getIntValue( tag_num_phonon_calc_mode,iret)==0) num_phonon_calc_mode = iret

          ! ==== KT_add ==== 13.1R
          call m_Raman_read_nfinp
          ! =============== 13.1R

          if( f_getIntValue( tag_sw_lattice_dielec_tensor, iret) == 0) &
               &  sw_lattice_dielectric_tensor = iret
          if( f_getIntValue( tag_sw_int_strain_piezo_tensor, iret) == 0) &
               &  sw_int_strain_piezo_tensor = iret

          if( f_getIntValue( tag_sw_dielectric_function, iret) == 0) sw_dielectric_function = iret

          if( f_getIntValue( tag_sw_lo_to_splitting, iret) == 0) sw_lo_to_splitting = iret
          if(sw_lo_to_splitting == ON) then
             if( f_getRealValue( tag_rho, dret, '') == 0) rho_loto = dret
          end if
          if( f_selectBlock( tag_force_calc) == 0) then
             if( f_getIntValue( tag_start, iret) == 0) istart_phonon = iret
             if( f_getIntValue( tag_end, iret) == 0) iend_phonon = iret
             iret = f_selectParentBlock()
          end if
          if( f_selectBlock( tag_electronic_dielectric_cnst) == 0) then
             if( f_getRealValue( tag_exx, dret, '') == 0) dielectric(1,1) = dret
             if( f_getRealValue( tag_eyy, dret, '') == 0) dielectric(2,2) = dret
             if( f_getRealValue( tag_ezz, dret, '') == 0) dielectric(3,3) = dret
             if( f_getRealValue( tag_exy, dret, '') == 0) dielectric(1,2) = dret
             dielectric(2,1) = dielectric(1,2)
             if( f_getRealValue( tag_eyz, dret, '') == 0) dielectric(2,3) = dret
             dielectric(3,2) = dielectric(2,3)
             if( f_getRealValue( tag_ezx, dret, '') == 0) dielectric(3,1) = dret
             dielectric(1,3) = dielectric(3,1)
             iret = f_selectParentBlock()
          end if
          if( f_selectBlock( tag_energy_range ) == 0) then
             if( f_getRealValue( tag_min_energy, dret, 'hartree') == 0) min_energy = dret
             if( f_getRealValue( tag_max_energy, dret, 'hartree') == 0) max_energy = dret
             if( f_getIntValue( tag_division_number, iret) == 0) num_division = iret
             iret = f_selectParentBlock()
          end if

          if( f_getIntValue(tag_qvec_from_file,iret)==0) qvec_from_file = iret

          ! ==== KT_add ====== 13.1R
          if( phonon_method == PHONON_GAMMA ) qvec_from_file = OFF
          ! ================== 13.1R

          if( phonon_method == PHONON_BAND .and. qvec_from_file== ON ) then
             if( f_getIntValue(tag_use_qpoint_data_file,iret)==0 ) then
                 use_qpoint_data_file = iret
              endif
          endif

          if(qvec_from_file==OFF)then
             if( f_selectBlock( tag_k_vector) == 0) then
                if( f_getRealValue( tag_kx, dret, '') == 0) kvec_dir(1) = dret
                if( f_getRealValue( tag_ky, dret, '') == 0) kvec_dir(2) = dret
                if( f_getRealValue( tag_kz, dret, '') == 0) kvec_dir(3) = dret
                iret = f_selectParentBlock()
                dnorm = sqrt(sum(kvec_dir(1:3)**2))
                if(abs(dnorm) < 1.d-10) then
                   kvec_dir(1:2)=0.d0
                   kvec_dir(3)=1.d0
                   dnorm = 1.d0
                end if
                kvec_dir(1:3) = kvec_dir(1:3)/dnorm
                iret = f_selectParentBlock()
             else
                kvec_dir(3) = 1.d0  ! default value
             end if
          endif

          ! === KT_add === 13.1R
          if ( sw_phonon_with_epsilon == ON ) then
             call m_Raman_initialize( kvec_dir )
             dielectric = dielectric_read_from_file
          endif
          ! ================ 13.1R

          if( phonon_method /= PHONON_GAMMA) then
             if( f_selectBlock( tag_lattice) == 0) then
                if( f_getIntValue( tag_l1, iret) == 0) nlat(1) = iret
                if( f_getIntValue( tag_l2, iret) == 0) nlat(2) = iret
                if( f_getIntValue( tag_l3, iret) == 0) nlat(3) = iret
                iret = f_selectParentBlock()
             else
                nlat(1:3) = 2
             end if
          else
             nlat(1:3) = 0
             if( f_selectBlock( tag_lattice) == 0) then
                if( f_getIntValue( tag_l1, iret) == 0) nlat(1) = iret
                if( f_getIntValue( tag_l2, iret) == 0) nlat(2) = iret
                if( f_getIntValue( tag_l3, iret) == 0) nlat(3) = iret
                iret = f_selectParentBlock()
             endif
          end if

          if( phonon_method == PHONON_BAND) then
             call rd_spcpnt_and_symln()
          else if( phonon_method == PHONON_DOS) then
             phonon_dos_mesh(1:3) = 4 ! default values
             if( f_selectBlock( tag_dos) == 0) then
                if( f_selectBlock( tag_mesh) == 0) then
                   if( f_getIntValue( tag_nx, iret) == 0) phonon_dos_mesh(1) = iret
                   if( f_getIntValue( tag_ny, iret) == 0) phonon_dos_mesh(2) = iret
                   if( f_getIntValue( tag_nz, iret) == 0) phonon_dos_mesh(3) = iret
                   iret = f_selectParentBlock()
                end if
                if( f_getRealValue( tag_deltae, dret, '') == 0) DeltaE_dos = dret
                iret = f_selectParentBlock()
             end if
          end if
          if(f_getIntValue(tag_sw_read_forces_pre,iret)==0) sw_read_forces_pre = iret

          iret = f_selectParentBlock()
       end if

       iret = f_selectParentBlock()
    end if

    if(sw_lattice_dielectric_tensor == ON) then
       phonon_method = PHONON_GAMMA
       sw_lo_to_splitting = OFF
    end if

    if(ipriphonon >= 1) then
       write(nfout,*) '!** sw_phonon = ',sw_phonon
       if(sw_phonon == ON) then
          write(nfout,*) '!** phonon_method = ',phonon_method
          write(nfout,*) '!** sw_calc_force = ',sw_calc_force
          write(nfout,*) '!** sw_calc_force_all = ',sw_calc_force_all
          write(nfout,*) '!** istart_phonon = ',istart_phonon
          write(nfout,*) '!** iend_phonon   = ',iend_phonon
          write(nfout,*) '!** sw_read_forces_pre   = ',sw_read_forces_pre
          write(nfout,*) '!** displacement (Phonon) = ',u
          write(nfout,*) '!** sw_vibrational_modes = ',sw_vibrational_modes
          write(nfout,*) '!** sw_polynomial_fit = ',sw_polynomial_fit
          write(nfout,*) '!** norder = ',norder
          write(nfout,*) '!** nlat = ',nlat
          write(nfout,*) '!** sw_correct_force_constants = ',sw_correct_force_constants
          write(nfout,*) '!** point_group = ',pg_gamma
          write(nfout,*) '!** sw_lo_to_splitting = ',sw_lo_to_splitting
          write(nfout,'(" !**           [",3(1x,f10.5),1x,"]")') dielectric(1:3,1)
          write(nfout,'(" !** epsilon = [",3(1x,f10.5),1x,"]")') dielectric(1:3,2)
          write(nfout,'(" !**           [",3(1x,f10.5),1x,"]")') dielectric(1:3,3)
          write(nfout,'(" !** k_vector =",3(1x,f10.5))') kvec_dir(1:3)
          write(nfout,*) '!** sw_lattice_dielectric_tensor = ',sw_lattice_dielectric_tensor
          write(nfout,*) '!** sw_dielectric_function = ',sw_dielectric_function
          write(nfout,*) '!** energy_range = ',min_energy,max_energy,num_division
          write(nfout,*) '!** damping_factor = ',damping_factor
          write(nfout,*) '!** sw_internal_strain_piezoelectric_tensor = ',sw_int_strain_piezo_tensor
          if( phonon_method == PHONON_DOS) then
             write(nfout,*) '!** phonon_dos_mesh = ',phonon_dos_mesh(1:3)
          end if
          if( phonon_method == PHONON_BAND) then
             write(nfout,*) '!** use_qpoint_data_file = ', use_qpoint_data_file
             if ( sw_phonon_band_unfolding == ON ) then
                write(nfout,*) '!** sw_phonon_band_unfolding = ', &
                     &          sw_phonon_band_unfolding
                write(nfout,*) "!** tolerance_phonon_Gvec_matching is ", &
                     &              tolerance_ph_Gvec_matching
                write(nfout,*) '!** nmax_G_phonon(1) = ', nmax_G_phonon(1)
                write(nfout,*) '!** nmax_G_phonon(2) = ', nmax_G_phonon(2)
                write(nfout,*) '!** nmax_G_phonon(3) = ', nmax_G_phonon(3)
             endif
          endif

          write(nfout,*) '!** sw_phonon_oneshot = ', sw_phonon_oneshot
          if(sw_phonon_oneshot == ON) then
             write(nfout,*) '!** num_phonon_calc_mode = ',num_phonon_calc_mode
          end if
          ! ====== KT_add ==== 13.1R
          if ( sw_phonon_with_epsilon == ON ) call m_Raman_print_param
          ! ================== 13.1R
       end if
    end if

  contains
    subroutine rd_spcpnt_and_symln()
      integer :: num

      call read_spcpnt(.true.,nsp,num)  ! paramset = .true.  -> nsp
      nsp = num
      allocate(spcpnt(nsp,3))
      allocate(pg_spcpnt(nsp))
      call read_spcpnt(.false.,nsp,num) ! paramset = .false. -> spcpnt,pg_spcpnt

      call read_symln(.true.,nsl,num)  ! paramset = .true.  -> nsl
      nsl = num
      allocate(symln(nsl,3))
      allocate(ndiv(nsl))
      allocate(pg_symln(nsl))
      call read_symln(.false.,nsl,num) ! paramset = .false. -> symln,ndiv,pg_symln
    end subroutine rd_spcpnt_and_symln

    subroutine read_spcpnt(paramset,num,icounted)
      logical, intent(in) :: paramset
      integer, intent(in) ::  num
      integer, intent(out) :: icounted

      integer :: i, no, iret
      integer :: f_selectFirstTableLine,f_selectNextTableLine,f_getRealValue,f_getIntValue
      real(kind=dP) :: dret
      character(len=FMAXVALLEN) :: cret

      i = 1
      if( f_selectBlock( tag_special_points) == 0) then
         do
            if(i == 1) then
               if( f_selectFirstTableLine() /= 0 ) then
                  exit
               end if
            else
               if( f_selectNextTableLine() /= 0 ) then
                  exit
               end if
            end if
            if(.not.paramset) then
               if(i > num) exit
               no = i
               if(f_getIntValue(tag_no, iret) == 0) then
                  no = iret
               else if(f_getIntValue(tag_id, iret) == 0) then
                  no = iret
               end if
               if(no <= num) then
                  if(f_getRealValue(tag_k1,dret,'') == 0) spcpnt(no,1) = dret
                  if(f_getRealValue(tag_k2,dret,'') == 0) spcpnt(no,2) = dret
                  if(f_getRealValue(tag_k3,dret,'') == 0) spcpnt(no,3) = dret
                  if( f_getStringValue( tag_point_group, cret, NOCONV) == 0) then
                     pg_spcpnt(no) = cret(1:3)
                  else
                     pg_spcpnt(no) = '' ! default value
                  end if
               end if
            end if
            i = i+1
         end do
         iret = f_selectParentBlock()
      end if
      icounted = i - 1

    end subroutine read_spcpnt

    subroutine read_symln(paramset,num,icounted)
      logical, intent(in) :: paramset
      integer, intent(in) ::  num
      integer, intent(out) :: icounted

      integer :: i, no, iret
      integer :: f_selectFirstTableLine,f_selectNextTableLine,f_getRealValue,f_getIntValue
      character(len=FMAXVALLEN) :: cret

      i = 1
      if( f_selectBlock( tag_symmetry_lines) == 0) then
         do
            if(i == 1) then
               if( f_selectFirstTableLine() /= 0 ) then
                  exit
               end if
            else
               if( f_selectNextTableLine() /= 0 ) then
                  exit
               end if
            end if
            if(.not.paramset) then
               if(i > num) exit
               no = i
               if(f_getIntValue(tag_no, iret) == 0) then
                  no = iret
               else if(f_getIntValue(tag_id, iret) == 0) then
                  no = iret
               end if
               if(no <= num) then
                  if(f_getIntValue(tag_k1,iret) == 0) symln(no,1) = iret
                  if(f_getIntValue(tag_k2,iret) == 0) symln(no,2) = iret
                  if( f_getStringValue( tag_point_group, cret, NOCONV) == 0) then
                     pg_symln(no) = cret(1:3)
                  else
                     pg_symln(no) = '' ! default value
                  end if
                  if(f_getIntValue(tag_num_division,iret) == 0) ndiv(no) = iret
                  if(iret <= 0) ndiv(no) = 1
               end if
            end if
            i = i+1
         end do
         iret = f_selectParentBlock()
      end if
      icounted = i - 1

    end subroutine read_symln

    subroutine set_phonon_method(rstr)
      character(len=FMAXVALLEN),intent(in) :: rstr
      logical :: tf
      call strncmp2(rstr, FMAXVALLEN, tag_gamma, len(tag_gamma), tf)
      if(.not.tf) &
           & call strncmp2(rstr, FMAXVALLEN, tag_zone_center, len(tag_zone_center), tf)
      if(tf) then
         phonon_method = PHONON_GAMMA
         goto 1001
      end if
      call strncmp2(rstr, FMAXVALLEN, tag_band, len(tag_band), tf)
      if(.not.tf) &
           & call strncmp2(rstr, FMAXVALLEN, tag_dispersion, len(tag_dispersion), tf)
      if(tf) then
         phonon_method = PHONON_BAND
         goto 1001
      end if
      call strncmp2(rstr, FMAXVALLEN, tag_dos, len(tag_dos), tf)
      if(tf) then
         phonon_method = PHONON_DOS
         goto 1001
      end if
1001  continue
    end subroutine set_phonon_method

  end subroutine m_Phonon_rd_param

  subroutine m_Phonon_alloc_qvec()
    integer :: isl,ishf
    real(kind=DP),allocatable,dimension(:,:,:) :: vkxyz_t
    real(kind=DP),allocatable,dimension(:) :: qwgt_t
    integer :: qnv3
    if(phonon_method == PHONON_GAMMA) then
       nqvec = 1
    else if(phonon_method == PHONON_BAND) then
       if(qvec_from_file==OFF)then
          nqvec = 0
          do isl=1,nsl
             ishf = 0
             if(isl/=nsl.and.symln(isl,2)==symln(isl+1,1)) ishf = 1
             nqvec = nqvec + ndiv(isl) + 1 - ishf
          end do
       else
          allocate(vkxyz_t(1,1,1))
          allocate(qwgt_t(1))
          qnv3=0

          if ( use_qpoint_data_file == OFF ) then
             call m_Files_open_kpoint_files(FILE,nbztyp_spg)
             call readk0(.true.,nfout,ipriphonon,qnv3,rltv,nfkpoint,nfmatbp &
                  & ,nqvec,vkxyz_t,qwgt_t)
          else
             call m_Files_open_qpoint_files(FILE,nbztyp_spg)
             call readk0(.true.,nfout,ipriphonon,qnv3,rltv,nfqpoint,nfmatbp &
                  & ,nqvec,vkxyz_t,qwgt_t)
          endif
          write(nfout,'(a,i5)') &
               & ' !** number of q-points for the phonon-band calculation : ',nqvec

          deallocate(vkxyz_t)
          deallocate(qwgt_t)
       endif
    else if(phonon_method == PHONON_DOS) then
       call make_qpoint_set(0,nqvec,.true.) ! ipri=0, paramset = .true.
       allocate(wght(nqvec))
    end if

    allocate(qvec(nqvec,3))
    allocate(qvin(nqvec,3))
    allocate(qdir(nqvec,3))
    allocate(point_group(nqvec)); point_group = ''
    allocate(fksym(48,nqvec)); fksym = .false.

    if ( sw_phonon_band_unfolding == ON ) allocate(qvin_refcell(nqvec,3))

  end subroutine m_Phonon_alloc_qvec

  subroutine m_Phonon_set_qvec(nfout)
    integer, intent(in) :: nfout

    call set_qvec(nfout)
    call set_qvec_point_group(nfout)
    call wd_qvec(nfout)
  contains
    subroutine set_qvec(nfout)
      integer,intent(in) :: nfout

      integer :: k1,k2
      integer :: i,isl,ishf,iqvec
      real(kind=DP) :: q1(3),q2(3),dq(3)
      real(kind=DP), allocatable, dimension(:,:,:) :: qvec_t, qvec_t_refcell
      real(kind=DP), allocatable, dimension(:) :: qw_t

      if(phonon_method == PHONON_GAMMA) then
         nqvec = 1
         qvec(nqvec,1:3) = 0.d0
         qvin(nqvec,1:3) = 0.d0
         qdir(nqvec,1:3) = kvec_dir(1:3)
         point_group(nqvec) = pg_gamma
      else if(phonon_method == PHONON_BAND) then
         if(qvec_from_file==OFF)then
            nqvec = 0
            do isl=1,nsl
               k1 = symln(isl,1)
               k2 = symln(isl,2)
               q1(1:3) = rltv(1:3,1)*spcpnt(k1,1) &
                    & + rltv(1:3,2)*spcpnt(k1,2) &
                    & + rltv(1:3,3)*spcpnt(k1,3)
               q2(1:3) = rltv(1:3,1)*spcpnt(k2,1) &
                    & + rltv(1:3,2)*spcpnt(k2,2) &
                    & + rltv(1:3,3)*spcpnt(k2,3)
               dq(1:3) = (q2(1:3)-q1(1:3))/ndiv(isl)
               ishf = 0
               if(isl/=nsl.and.symln(isl,2)==symln(isl+1,1)) ishf = 1
               iqvec = nqvec + 1
               do i=0,ndiv(isl)-ishf
                  nqvec = nqvec + 1
                  qvec(nqvec,1:3) = i*dq(1:3)+q1(1:3)
                  qdir(nqvec,1:3) = dq(1:3)
                  point_group(nqvec) = pg_symln(isl)
               end do
               point_group(iqvec) = pg_spcpnt(k1)
               if(ishf==0) point_group(nqvec) = pg_spcpnt(k2)
            end do
         else
            allocate(qvec_t(nqvec,3,CRDTYP));qvec_t=0.d0
            allocate(qw_t(nqvec));qw_t=1.d0

            if ( sw_phonon_band_unfolding == ON ) then
               allocate(qvec_t_refcell(nqvec,3,CRDTYP));qvec_t_refcell=0.d0
            endif

            if ( sw_phonon_band_unfolding == OFF ) then
               if ( use_qpoint_data_file == OFF ) then
                  call readk0(.false.,nfout,ipriphonon,nqvec,rltv,nfkpoint,nfmatbp &
                       & , nqvec, qvec_t, qw_t)
               else
                  call readk0(.false.,nfout,ipriphonon,nqvec,rltv,nfqpoint,nfmatbp &
                       & , nqvec, qvec_t, qw_t)
               endif
            else
               if ( use_qpoint_data_file == OFF ) then
                  call readk0( .false., nfout, ipriphonon, nqvec, rltv_refcell, &
                       &       nfkpoint, nfmatbp, nqvec, qvec_t_refcell, qw_t )
!                  call readk0_for_band_unfolding( .false., nfout, ipriphonon, &
!                       &       nqvec, rltv_refcell, altv, &
!                       &       nfkpoint, nfmatbp, nqvec, qvec_t, qw_t )
               else
                  call readk0( .false., nfout, ipriphonon, nqvec, rltv_refcell, &
                       &       nfqpoint, nfmatbp, nqvec, qvec_t_refcell, qw_t )
!                  call readk0_for_band_unfolding( .false., nfout, ipriphonon, &
!                       &       nqvec, rltv_refcell, altv, &
!                       &       nfqpoint, nfmatbp, nqvec, qvec_t, qw_t )
               endif
            endif

            qdir=0.d0
            if ( sw_phonon_band_unfolding == OFF ) then
               do i=1,nqvec
                  qvec(i,1:3) = qvec_t(i,1:3,CARTS)
               enddo
            else
               do i=1,nqvec
                  qvec(i,1:3) = qvec_t_refcell(i,1:3,CARTS)
               enddo
            endif
            do i=1,nqvec-1
               qdir(i,1) = qvec(i+1,1)-qvec(i,1)
               qdir(i,2) = qvec(i+1,2)-qvec(i,2)
               qdir(i,3) = qvec(i+1,3)-qvec(i,3)
            enddo
            if(nqvec>1) qdir(nqvec,:) = qdir(nqvec-1,:)
         endif
         do iqvec=1,nqvec
            do i=1,3
               qvin(iqvec,i) = sum(altv(1:3,i)*qvec(iqvec,1:3))/PAI2
            end do
         end do
         if ( sw_phonon_band_unfolding == ON ) then
            do iqvec=1,nqvec
               do i=1,3
                  qvin_refcell(iqvec,i) &
                       &  = sum(altv_refcell(1:3,i)*qvec(iqvec,1:3))/PAI2
               end do
            end do
         endif

      else if(phonon_method == PHONON_DOS) then
         call make_qpoint_set(1,nqvec,.false.) ! ipri=1, paramset = .false.
         do iqvec=1,nqvec
            do i=1,3
               qvin(iqvec,i) = sum(altv(1:3,i)*qvec(iqvec,1:3))/PAI2
            end do
            qdir(iqvec,1:3) = rltv(1:3,1)+rltv(1:3,2)+rltv(1:3,3)
         end do
      end if
    end subroutine set_qvec

    subroutine set_qvec_point_group(nfout)
      use m_Const_Parameters,  only: AUTOMATIC
      use m_Crystal_Structure, only: nopr,op,ig01,il,symmetry_method
      use m_CS_SpaceGroup,     only: lattice_system, &
           & get_kpoint_symmetry,get_point_group_name
      integer,intent(in) :: nfout

      integer :: i,j
      integer :: nopro,ig01o(48)
      integer :: nopro2,ig01o2(48)
      real(kind=DP) :: kvec(3)
      character(len=3) :: pg_name
      character(len=5) :: pg_name_i
      character(len=9) :: system

      if(symmetry_method==AUTOMATIC) then
         system = lattice_system
      else
         if(il>0) then
            system = 'cubic'
         else
            system = 'hexagonal'
         end if
      end if

      do i=1,nqvec
         if(point_group(i) == '') then
            kvec = qvec(i,1:3)
            call get_kpoint_symmetry(nopr,ig01,op,kvec,nopro,ig01o,nopro2,ig01o2)
            do j=1,nopro2
               fksym(ig01o2(j),i) = .true.
            end do
            call get_point_group_name(nfout,system,nopro,ig01o,pg_name,pg_name_i)
            point_group(i) = pg_name
         else
            fksym(1:nopr,i) = .true.
         end if
      end do
    end subroutine set_qvec_point_group

    subroutine wd_qvec(nfout)
      integer,intent(in) :: nfout

      integer :: i
      if(ipriphonon > 0) then
         write(nfout,'("=== q-vectors ===")')
         write(nfout,'("number of q-vectors = ",i5)') nqvec
         write(nfout,'(4x,"i",5x,"qvec(3)",26x,"qvin(3)",22x,"point_group")')
         do i=1,nqvec
            write(nfout,'(i5,3(1x,f10.5),3(1x,f10.5),1x,a3)') i,qvec(i,1:3),qvin(i,1:3),point_group(i)
         end do
      end if
    end subroutine wd_qvec

  end subroutine m_Phonon_set_qvec

  subroutine make_qpoint_set(ipri,nqvec,paramset)
    use m_Crystal_Structure, only: il,inv,ngen,igen,jgen,a,b,c,ca,cb,cc
    integer, intent(in) :: ipri
    integer, intent(inout) :: nqvec
    logical, intent(in) :: paramset

    integer :: nx1,ny1,nz1
    integer :: nx,ny,nz
    integer :: nxx,nyy,nzz
    integer :: nd, lmnp0, lmnp1, lmnp2
    real(kind=DP), pointer, dimension(:,:) :: pa0,pb0,pb
    integer,       pointer, dimension(:,:) :: ka0,ka2
    integer,       pointer, dimension(:,:) :: ip2cub_wk
    integer,       pointer, dimension(:)   :: nstar2
    integer                                :: i
    real(kind=DP) :: nv(3),trmat(3,3)

    nx = phonon_dos_mesh(1)
    ny = phonon_dos_mesh(2)
    nz = phonon_dos_mesh(3)
    call nskma0(il,nx,ny,nz,nxx,nyy,nzz,nx1,ny1,nz1,nd)

    lmnp0=(nxx+1)*(nyy+1)*(nzz+1)
    lmnp1=lmnp0
    lmnp2=lmnp0

    nxyz_tetra = 0
    allocate(ip10(lmnp0))  ; ip10 = 0
    if(paramset) allocate(ip20(lmnp0))
    ip20 = 0
    allocate(ip01(lmnp1))    ; ip01 = 0
    allocate(ip02(lmnp2))    ; ip02 = 0
    allocate(ip21(lmnp1))    ; ip21 = 0
    allocate(ip12(lmnp2))    ; ip12 = 0
    allocate(iu21(lmnp1))    ; iu21 = 0
    allocate(iv21(lmnp1))    ; iv21 = 0
    allocate(nstar2(lmnp2))  ; nstar2 = 0
    allocate(pa0(3,lmnp0))  ; pa0 = 0
    allocate(pb0(3,lmnp0))  ; pb0 = 0
    allocate(pb(3,lmnp2))  ; pb = 0
    allocate(ka0(4,lmnp0))  ; ka0 = 0
!!$  allocate(ka2(4,lmnp2))  ; ka2 = 0

    call setkp0_default_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
         &               ,nx,ny,nz &
         &               ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
         &               ,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3)&
         &               ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
         &               ,nstar2,pa0,pb0,pb,ka0 &
         &               ,ipri,itrs)

    if(.not.paramset) then
       call get_trmat1  !-(contained here) ->(trmat)
       do i=1,nqvec
          nv(1:3) = dble(ka0(1:3,ip02(i)))/dble(ka0(4,ip02(i)))
          qvec(i,1:3) = matmul(trmat,nv)
          wght(i)     = dble(nstar2(i))/dble(np1)
       end do
    else
       nqvec = np2
    end if

    deallocate(ip10)
    deallocate(ip01)
    deallocate(ip02)
    deallocate(ip21)
    deallocate(ip12)
    deallocate(iu21)
    deallocate(iv21)
    deallocate(nstar2)
    deallocate(pa0)
    deallocate(pb0)
    deallocate(pb)
    deallocate(ka0)
!!$  deallocate(ka2)

    if(paramset) return

    allocate(iwt(np2)) ; iwt = 0
    allocate(ip2cub(np1)) ; ip2cub = 0

    allocate(ip2cub_wk(9,nxyz_tetra(1)*nxyz_tetra(2)*nxyz_tetra(3)))
    ip2cub_wk = 0.d0
    call wtetra &
         &  (nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3),np0,np2,ip20 &
         &  ,iwt,ip2cub &
         &  ,ip2cub_wk)
    deallocate(ip2cub_wk)
  contains
    subroutine get_trmat1
      real(kind=DP), dimension(3,3) :: trbp,trpb,mat1,mat2
      !    make translation matrix  trpb (P -> B)

      call getspgtab(trbp)  ! spg+tetra

      call inver3n(3,trbp,trpb)

      mat1 = transpose(trpb)
      call inver3n(3,mat1,mat2)
      call matpr3(rltv,mat2,trmat)

    end subroutine get_trmat1
  end subroutine make_qpoint_set

  subroutine m_Phonon_write_forces()
    use m_IterationNumbers, only : iteration_ionic, iteration_electronic
    use m_Files, only : nfforce, m_Files_open_nfforce
    use m_Ionic_system, only : natm,num_force_calc,iconf
    use m_Control_Parameters, only : num_phonon_calc_mode
    use m_Force, only : forc_l
#ifdef WINDOWS
    use ifport
#endif

    ! local variables
    integer :: i,ic
    logical :: ini

    if(.not.allocated(force_data)) allocate(force_data(natm_super,3,num_force_data))
    ic = iconf(iteration_ionic)
    force_data(1:natm_super,1:3,ic) = forc_l(1:natm_super,1:3)

    if(mype /= 0) return

    ini = .false.
    do i=1,3*natm_prim*norder*2
       if(force_was_read(i)) then
         ini = .true.
         exit
       endif
    enddo
!    if(iteration_ionic == 1) then
    if(phonon_iteration == 1 .and. .not. ini) then
       call m_Files_open_nfforce(.false.)  ! new file (asms)
       if(istart_phonon == 1) then
          if(sw_phonon_oneshot == ON) then
             write(nfforce,'(4(1x,i7),"  : num_force_calc, norder, sw_polynomial_fit, num_phonon_calc_mode")') &
                  & num_force_calc,  norder, sw_polynomial_fit, num_phonon_calc_mode
          else
             write(nfforce,'(3(1x,i7),"  : num_force_calc, norder, sw_polynomial_fit")') &
                  & num_force_calc, norder, sw_polynomial_fit
          end if
       end if
    else
       call m_Files_open_nfforce(.true.)  ! append (asms)
    end if
    write(nfforce,'(i4,3(1x,e25.12),2i6,"  : displaced_atom, displacement(1:3), iteration_ionic,iteration_electronic")') &
         & displaced_atom,displacement(1:3),iteration_ionic,iteration_electronic
    do i=1,natm_super
       write(nfforce,'(i4,3(1x,e25.12))') i,forc_l(i,1:3)
    end do
    call flush(nfforce)

  end subroutine m_Phonon_write_forces

  ! ==== KT_add == 13.1R
  subroutine m_Phonon_print_Raman_susc
    call m_Raman_calc_susceptibility( nmodes, omega, modes, &
         &                            mode_active, mode_irr_rep )
  end subroutine m_Phonon_print_Raman_susc
  ! =============== 13.1R

  function m_Phonon_Check_iteration(iteration_ionic)
    use m_Control_Parameters, only : skip_alloc_phonon
    use m_Crystal_Structure, only : m_CS_phonon_symmetry
    use m_Ionic_System, only : m_IS_phonon_equilibrium, m_IS_cps_to_pos &
         & , istart_phonon, iend_phonon, num_force_calc &
         & , iconf
    logical :: m_Phonon_Check_iteration
    integer, intent(in) :: iteration_ionic
    integer :: id

    if(ipriphonon>=1) then
       id = iteration_ionic+istart_phonon-1
       write(nfout,*) 'PHONON: num_force_calc  = ',num_force_calc
       write(nfout,*) 'PHONON: istart, iend = ',istart_phonon, iend_phonon
       write(nfout,*) 'PHONON: id = ',id
       write(nfout,*) 'PHONON: iconf = ',iconf(id)
       write(nfout,*) 'PHONON: iteration_ionic = ',iteration_ionic
    end if
    if(iteration_ionic >= iend_phonon-istart_phonon+1 ) then
       m_Phonon_Check_iteration = .true.
       call m_IS_phonon_equilibrium()
       call m_IS_cps_to_pos()
       call m_CS_phonon_symmetry(ON)
    else
       m_Phonon_Check_iteration = .false.
    end if
    skip_alloc_phonon = .true.

  end function m_Phonon_Check_iteration

  subroutine m_Phonon_read_forces()
    use m_Files,        only : m_Files_open_nfforce, nfforce
    use m_Ionic_System, only : num_force_calc, napt_phonon, iequconf &
         &                    , iopr_equconf, iconf, phonon_atom,imdtyp
    use m_Crystal_Structure, only : op
#ifdef WINDOWS
    use ifport
#endif
    implicit none

    ! local variables
    integer :: n,i,ia,ja,ind,j,ic,iopr
    integer :: istart,idummy,iter
    character(len=5) :: num
    integer :: icount,jcount
    logical :: exi

    if(ipriphonon>=1) write(nfout,*) '<< m_Phonon_read_forces >>: Reading forces'
    call flush(nfout)
!    nmodes = natm_prim*3
    nmodes = natm_mobile*3

    !if(sw_calc_force == OFF) then
    !   if(ipriphonon>=2) write(nfout,'(" sw_calc_force = OFF")')

    !num_force_data = nmodes*norder*2
    num_force_data = natm_prim*3*norder*2
    if(sw_polynomial_fit == ON) num_force_data = num_force_data + 1

    if(sw_polynomial_fit == ON) then
      if(.not.allocated(forces)) allocate(forces(3*natm_mobile*nlpnt,nmodes,norder*2+1))
    else
      if(.not.allocated(forces)) allocate(forces(3*natm_mobile*nlpnt,nmodes,norder*2))
    endif
    if(.not.allocated(force0)) allocate(force0(3*natm_mobile*nlpnt))
    !if(.not.allocated(force_data)) allocate(force_data(natm_super,3,num_force_data))
    if(.not.allocated(force_data)) allocate(force_data(natm_super,3,num_force_data))
    if(.not.allocated(force_was_read)) then
      allocate(force_was_read(num_force_data));force_was_read = .false.
    endif

    if(mype == 0) then
       call m_Files_open_nfforce(.false.)
       inquire(unit=nfforce,exist=exi)
       if(exi)then
         rewind nfforce
         read(nfforce,*,end=100,err=100) num_force_calc, norder, sw_polynomial_fit
         do while(.true.)
            read(nfforce,*,end=100,err=100) displaced_atom,displacement(1:3),iter,idummy
            ic = iconf(iter)
            do ia=1,natm_super
               read(nfforce,*,end=100,err=100) idummy,force_data(ia,1:3,ic)
            end do
            force_was_read(ic) = .true.
         end do
100      continue
       endif
    end if
    !else
    !   if(ipriphonon>=2) write(nfout,'(" sw_calc_force = ON")')
    !end if

    if(ipriphonon>=2) write(nfout,'(" num_force_data = ",i8)') num_force_data
    do i=1,num_force_data
       ic = iequconf(i)
       if(ipriphonon>=2) write(nfout,'(" i, ic = ",2i8)') i, ic
       if(imdtyp(phonon_atom(i))==OFF) cycle
       if(ic >= 0) cycle
       ic = abs(ic)
       iopr = iopr_equconf(i)
       if(ipriphonon>=2) write(nfout,'(" i, ic, iopr = ",3i8)') i, ic,iopr
       do ia=1,natm_super
          ja = napt_phonon(ia,i)
          do j=1,3
             force_data(ia,j,ic) = (force_data(ia,j,ic) + dot_product(op(1:3,j,iopr),force_data(ja,1:3,i)))*0.5d0
          end do
       end do
    end do

    if(ipriphonon>=2) write(nfout,'(" num_force_data = ",i8)') num_force_data
    do i=1,num_force_data
       ic = iequconf(i)
       if(ic == 0) cycle
       ic = abs(ic)
       iopr = iopr_equconf(i)
       if(ipriphonon>=2) write(nfout,'(" i, ic, iopr = ",3i8)') i, ic,iopr
       do ia=1,natm_super
          ja = napt_phonon(ia,i)
          do j=1,3
             force_data(ja,j,i) =  dot_product(op(j,1:3,iopr),force_data(ia,1:3,ic))
          end do
       end do
    end do

    if(sw_polynomial_fit == ON) then
       ind=1
       icount = 0
       do ia=1,natm_super
          if(imdtyp(ia)==OFF) cycle
          icount = icount+1
          !istart = 3*(ia-1)+1
          istart = 3*(icount-1)+1
          force0(istart:istart+2) = force_data(ia,1:3,ind)
       end do
    else
       ind=0
    end if
!    do i=1,nmodes
    jcount = 0
    do i=1,3*natm_prim
       if (imdtyp((i-1)/3+1) /= OFF) jcount = jcount+1
       do n=1,norder*2
          ind = ind+1
          if (imdtyp((i-1)/3+1) == OFF) cycle
          icount = 0
          do ia=1,natm_super
             if(imdtyp(ia)==OFF) cycle
             icount = icount+1
             !istart = 3*(ia-1)+1
             istart = 3*(icount-1)+1
             !forces(istart:istart+2,i,n) = force_data(ia,1:3,ind)
             forces(istart:istart+2,jcount,n) = force_data(ia,1:3,ind)
          end do
       end do
    end do

    if(npes>1) then
       call mpi_bcast(forces,3*natm_mobile*nlpnt*nmodes*norder*2,mpi_double_precision,0,MPI_CommGroup,ierr) ! MPI
       call mpi_bcast(force0,3*natm_mobile*nlpnt,mpi_double_precision,0,MPI_CommGroup,ierr) ! MPI
       call mpi_bcast(force_was_read,num_force_data,mpi_logical,0,MPI_CommGroup,ierr)
    end if
    if(ipriphonon>1)then
       do ia=1,3*natm_prim*norder*2
          write(nfout,'(a,i8,l2)') ' !** force was read ',ia,force_was_read(ia)
       enddo
    endif

    if(ipriphonon>=1) write(nfout,*) '<< m_Phonon_read_forces >>: Forces are read.'
    call flush(nfout)

    ! check sum of force
    !!if(ipriphonon>=0) then
    if(ipriphonon>=2) then
       write(nfout,*) "check sum of force"
       do i=1,num_force_data
          ic = iconf(i)
          if(ic>num_force_data) cycle
          if(imdtyp(phonon_atom(ic))==OFF) cycle
          do j=1,3
             write(nfout,*) i,j,sum(force_data(1:natm_super,j,i))
          end do
          !do ia=1,natm_super
          !   write(nfout,'(a,2i5,3f20.10)') 'ia, i, f ',ia,i,force_data(ia,1:3,i)
          !enddo
       end do
    end if
    return
  end subroutine m_Phonon_read_forces


  subroutine m_Phonon_calc_dynamical_matrix()
    use m_Crystal_Structure, only : univol, altv
    use m_Ionic_System, only : imdtyp
    implicit none

    ! local variables
    integer :: i,j,k
    integer :: istart
    real(kind=DP) :: mi,ui

    real(kind=DP) :: coefna
    complex(kind=DP), allocatable :: nadynmat(:,:,:) ! dim(nmodes,nmodes,nqvec)
    complex(kind=DP), allocatable :: nafd(:,:,:) ! dim(3,3,natm)
    real(kind=DP) :: sum_rule(nmodes,3)
    integer :: na,ia,ja,ir,jr,ira,jra,n
    real(kind=DP) :: ae,ai,amelem
    integer :: icell,nre,jas
    real(kind=DP) :: r(3),re(3,8)
    real(kind=DP) :: ph,w
    complex(kind=DP) :: expqr
    integer :: ii,jj,iu,ju
    integer :: iq
    real(kind=DP) :: s(3)
    integer :: ng,nr
    real(kind=DP), allocatable :: gv(:,:),rv(:,:),cpstmp(:,:)
    real(kind=DP) :: g2bz

    real(kind=DP), parameter :: eps = 1.d-6
    integer :: icount,jcount

    allocate(mode2atom(nmodes))
    icount=0
    do i=1,natm_prim
       if(imdtyp(i) /= OFF)then
         icount = icount+1
         mode2atom(3*(icount-1)+1) = i
         mode2atom(3*(icount-1)+2) = i
         mode2atom(3*(icount-1)+3) = i
       endif
    enddo
    allocate(dynmat(nmodes,nmodes,nlpnt))
    allocate(dynmatq(nmodes,nmodes,nqvec))
    allocate(msqinv(nmodes))

    call m_Phonon_force_constant_matrix(dynmat)

    deallocate(forces)
    deallocate(force0)
    deallocate(force_was_read)

    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'calculated force constants:'
       call write_dynmat(dynmat)
    end if

    allocate(cpstmp(natm_mobile,3))
    icount=0
    do ia=1,natm
      if(imdtyp(ia) ==  OFF) cycle
      icount = icount+1
      cpstmp(icount,1:3) = cps(ia,1:3)
    enddo
    ! symmetrized force constants in Real space
    call symmetrize_force_const_Real(dynmat,natm_mobile,cpstmp)
    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'symmetrized force constants:'
       call write_dynmat(dynmat)
    end if

    ! check sum rule of force constants
    if(ipriphonon >=2) &
         & write(nfout,*) 'j ir sum_of_force_constants'

    icount = 0
    do ia=1,natm_prim
       if(imdtyp(ia)==OFF) cycle
       icount = icount+1
       do ir=1,3
          !i = (ia-1)*3+ir
          i = (icount-1)*3+ir
          do jr=1,3
             sum_rule(i,jr)=0
             do n=1,nlpnt
                jcount = 0
                do ja=1,natm_prim
                   if(imdtyp(ja)==OFF) cycle
                   jcount = jcount+1
                   !j=(ja-1)*3+jr
                   j=(jcount-1)*3+jr
                   !if(n==1.and.ia==ja) cycle
                   if(n==1.and.icount==jcount) cycle
                   sum_rule(i,jr) = sum_rule(i,jr) + dynmat(i,j,n)
                end do
             end do
             if(ipriphonon >=2) then
                !j=(ia-1)*3+jr
                j=(icount-1)*3+jr
                write(nfout,*) i,jr,sum_rule(i,jr)+dynmat(i,j,1)
             end if
          end do
       end do
    end do
    ! correct force constants
    if(sw_correct_force_constants == ON) then
       do i=1,nmodes
          ia = (i+2)/3
          do jr=1,3
             j=(ia-1)*3+jr
             dynmat(i,j,1) = - sum_rule(i,jr)
          end do
       end do
    end if

    ! output
    if(sw_correct_force_constants == ON) then
       if(printable) write(nfout,*) '*** Force constants were corrected. ***'
       if(ipriphonon >=2) then
          write(nfout,*) 'Corrected force constants:'
          call write_dynmat(dynmat)
       end if
    else
       if(printable) write(nfout,*) '*** Force constants were NOT corrected. ***'
    end if

    ! Fourier transform of force constants
    dynmatq(:,:,:) = dcmplx(0.d0,0.d0)
    do n=1,nqvec
!!$write(nfout,*) 'qvin=',qvin(n,1:3)
!!$write(nfout,*) 'qvec=',qvec(n,1:3)
       do icell=1,nlpnt
          do j=1,nmodes
             !ja = (j-1)/3 + 1
             ja = mode2atom(j)
!!$ju = mod(j-1,3)
             jas = ja + (icell-1)*natm
             do i=1,nmodes
                !ia = (i-1)/3 + 1
                ia = mode2atom(i)
!!$iu = mod(i-1,3)
!!$r(1:3) = cps(jas,1:3)-cps(ia,1:3)
                r(1:3) = cps(ia,1:3)-cps(jas,1:3)
                call get_pos_in_extcell(r,nre,re)
                expqr = dcmplx(0.d0,0.d0)
                do k=1,nre
                   ph = sum(qvec(n,1:3)*re(1:3,k))
                   expqr = expqr + dcmplx(cos(ph),sin(ph))
                end do
                expqr = expqr/dble(nre)
!!$write(nfout,*) 'ia,ja,i,j=',ia,ja,i,j
!!$write(nfout,'("r =",3f10.5)') r(1:3)
!!$do k=1,nre
!!$   write(nfout,'("k,re =",i3,3f10.5)') k,re(1:3,k)
!!$end do
!!$write(nfout,*) 'ph,expqr=',ph,expqr

                dynmatq(i,j,n) = dynmatq(i,j,n)+dynmat(i,j,icell)*expqr
!!$ii = (ja-1)*3 + iu + 1
!!$jj = (ia-1)*3 + ju + 1
!!$dynmatq(ii,jj,n) = dynmatq(ii,jj,n)+dynmat(i,j,icell)*expqr
             end do
          end do
       end do
    end do
    deallocate(dynmat)

    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'Force constant matrix in Fourier space:'
       call write_dynmatq(dynmatq)
    end if

    ! symmetrized force constants in Fourier space
    call symmetrize_force_const_Fourier(dynmatq,natm_mobile,cpstmp)

    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'Symmetrized force constants Fourier space:'
       call write_dynmatq(dynmatq)
    end if


    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'Dynamical matrix in Fourier space:'
       call write_dynmatq(dynmatq)
    end if

    ! non-analytic part
    if(sw_lo_to_splitting == ON) then
       allocate(nadynmat(nmodes,nmodes,nqvec))
       call get_g2bz(g2bz)
       do iq=1,nqvec
          s = qvin(iq,1:3)
          call mod1(s)
          if(abs(sum(s(1:3)**2)) < eps) then
             ! Gamma point
             call calc_napart_gamma(iq,nadynmat(1,1,iq))
          else
             call calc_napart_parlinski(iq,nadynmat(1,1,iq),g2bz)
          end if
       end do

       if(ipriphonon >=2) then
          ! output
          write(nfout,*) 'Non-analytic part of force constant matrix in Fourier space:'
          call write_dynmatq(nadynmat)
       end if

       do iq=1,nqvec
          do j=1,nmodes
             do i=1,nmodes
                dynmatq(i,j,iq) = dynmatq(i,j,iq) + nadynmat(i,j,iq)
             end do
          end do
       end do

       if(ipriphonon >=2) then
          ! output
          write(nfout,*) 'Total force constant matrix in Fourier space:'
          call write_dynmatq(dynmatq)
       end if

       deallocate(nadynmat)

    end if

    ! calculate 1/sqrt(mass)
    icount=0
    do i=1,natm_prim
       if(imdtyp(i) == OFF) cycle
       !istart=3*(i-1)+1
       icount = icount+1
       istart=3*(icount-1)+1
       mi = 1.d0/sqrt(ionic_mass(i))
       msqinv(istart) = mi
       msqinv(istart+1) = mi
       msqinv(istart+2) = mi
    end do
    if(ipriphonon > 1) then
       do i=1,nmodes
          write(nfout,*) 'debug: i= ',i,' msqinv = ',msqinv(i)
       end do
    end if

    ! calculate dynamical matrix in Fourier space
    do n=1,nqvec
       do j=1,nmodes
          do i=1,nmodes
             dynmatq(i,j,n) = dynmatq(i,j,n)*msqinv(i)*msqinv(j)
          end do
       end do
    end do


    do iq=1,nqvec
       !search the absolute maximum element
       amelem = abs(dynmatq(1,1,iq))
       do i=1,nmodes
          do j=i,nmodes
             ae = abs(dynmatq(i,j,iq))
             if(ae > amelem) amelem = ae
          end do
       end do
       if(ipriphonon >=2) then
          write(nfout,*) 'amelem = ',amelem
       end if
       do i=1,nmodes
          do j=1,nmodes
             ae = dble(dynmatq(i,j,iq))
             ai = dimag(dynmatq(i,j,iq))
             if(abs(ae) < amelem*1.d-14) ae = 0.d0
             if(abs(ai) < amelem*1.d-14) ai = 0.d0
             dynmatq(i,j,iq) = dcmplx(ae,ai)
          end do
       end do
    end do
    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'Dynamical matrix after removing small elements:'
       call write_dynmatq(dynmatq)
    end if

    deallocate(cpstmp)
    deallocate(mode2atom)
    return

  contains
    subroutine get_pos_in_extcell(r,nre,re)
      real(kind=DP), intent(in) :: r(3)
      integer, intent(out) :: nre
      real(kind=DP), intent(out) :: re(3,8)

      integer :: i,j,k,n(3),l
      real(kind=DP) :: s(3),p(3)
      real(kind=DP) :: eps = 1.d-6

      do i=1,3
         s(i) = sum(rltv_super(1:3,i)*r(1:3))/PAI2
      end do
      call mod1(s)
      do i=1,3
         n(i) = 1
         if(abs(s(i)-0.5d0)<eps) n(i) = 2
      end do
      do i=1,3
         if(s(i)>0.5d0-eps) s(i) = s(i) - 1.d0
      end do
      nre = 0
      do k=1,n(3)
         do j=1,n(2)
            do i=1,n(1)
               nre = nre + 1
               p(1) = s(1)+i-1
               p(2) = s(2)+j-1
               p(3) = s(3)+k-1
               do l=1,3
                  re(l,nre) = sum(altv_super(l,1:3)*p(1:3))
               end do
            end do
         end do
      end do
    end subroutine get_pos_in_extcell

    subroutine mod1(t)
      real(kind=DP), intent(inout) :: t(3)
      real(kind=DP), parameter :: eps = 1.d-6
      integer :: k
      t(1:3) = mod(t(1:3),1.d0)
      do k=1,3
         if(t(k) < -eps) t(k) = t(k) + 1.d0
         if(t(k) > 1.d0 - eps) t(k) = t(k) - 1.d0
      end do
    end subroutine mod1

    subroutine symmetrize_force_const_Real(fc,natm,cps)
      use m_Crystal_Structure, only : nopr,op,tau
      real(kind=DP), intent(inout) :: fc(nmodes,nmodes,nlpnt)
      integer, intent(in) :: natm
      real(kind=DP), intent(in) :: cps(natm,3)
      ! local variables
      integer :: i,j,icell,jcell,kcell,irc,jrc
      integer :: nr(natm,nlpnt),l(3,nlpnt),lx(3),ll(3)
      integer :: lr(natm,nlpnt),llr(nlpnt,nlpnt)
!!$  real(kind=DP) :: nonsym_fc(nmodes,nmodes,nlpnt)
      real(kind=DP),allocatable,dimension(:,:,:) :: nonsym_fc
      real(kind=DP) :: tensor(3,3)
      real(kind=DP) :: x(3),y(3)
      real(kind=DP) :: aa(3,3)
      real(kind=DP) :: eps = 1.d-6
      allocate(nonsym_fc(nmodes,nmodes,nlpnt));nonsym_fc=0.d0
      nonsym_fc(1:nmodes,1:nmodes,1:nlpnt) = fc(1:nmodes,1:nmodes,1:nlpnt)
      fc(1:nmodes,1:nmodes,1:nlpnt) = 0.d0

      do icell=1,nlpnt
         l(1:3,icell) = nint(matmul(transpose(rltv),lpnt(icell,1:3))/PAI2)
      end do

      aa = matmul(transpose(rltv_super),altv)/PAI2
      do icell=1,nlpnt
         do jcell=1,nlpnt
            ll = l(1:3,jcell)-l(1:3,icell)
            do kcell=1,nlpnt
               x = matmul(aa,ll-l(1:3,kcell))
               if(sum(abs(x-nint(x)))<eps) then
                  llr(icell,jcell) = kcell
                  exit
               end if
            end do
         end do
      end do

      do n=1,nopr
         do icell=1,nlpnt
            ATOM: do i=1,natm
               x(1:3) = cps(i,1:3) + lpnt(icell,1:3)
               y = matmul(op(1:3,1:3,n),x) + tau(1:3,n,CARTS)
               do j=1,natm
                  x = y-cps(j,1:3)
                  x = matmul(transpose(rltv),x)/PAI2
                  lx = nint(x(1:3))
                  if(sum(abs(x-lx))<eps) then
                     nr(i,icell) = j
                     do jcell=1,nlpnt
                        ll = lx-l(1:3,jcell)
                        x = matmul(aa,ll)
                        if(sum(abs(x-nint(x)))<eps) then
                           lr(i,icell) = jcell
                           exit
                        end if
                     end do
                     cycle ATOM
                  end if
               end do
               write(nfout,'("No equivalent atom for the atom ",i5," in the cell ",i5)') i,icell
               call phase_error_with_msg(nfout,'No equivalent atom',__LINE__,__FILE__)
            end do ATOM
         end do
         icell = 1
         do jcell=1,nlpnt
            do j=1,natm
               ja=3*(j-1)+1
               jr=nr(j,jcell)
               jra=3*(jr-1)+1
               jrc = lr(j,jcell)
               do i=1,natm
                  ia=3*(i-1)+1
                  ir=nr(i,icell)
                  ira=3*(ir-1)+1
                  irc = lr(i,icell)
                  kcell = llr(irc,jrc)
                  tensor(1:3,1:3)=nonsym_fc(ia:ia+2,ja:ja+2,jcell)
                  call rotate_tensor(tensor,n)
                  fc(ira:ira+2,jra:jra+2,kcell)= &
                       & fc(ira:ira+2,jra:jra+2,kcell) + tensor(1:3,1:3)
               end do
            end do
         end do
      end do
      fc(1:nmodes,1:nmodes,1:nlpnt) = fc(1:nmodes,1:nmodes,1:nlpnt)/nopr
      deallocate(nonsym_fc)
    end subroutine symmetrize_force_const_Real

    subroutine rotate_tensor(tensor,n)
      use m_Crystal_Structure, only : op
      real(kind=DP), intent(inout) :: tensor(3,3)
      integer, intent(in) :: n ! index of rotation

      ! local variables
      integer :: i,j,k,l
      real(kind=DP) :: tnew(3,3)

      tnew(1:3,1:3)=0.d0

      do l=1,3
         do i=1,3
            do k=1,3
               do j=1,3
!!$tnew(i,l)=tnew(i,l)+op(j,i,n)*tensor(j,k)*op(k,l,n)
                  tnew(i,l)=tnew(i,l)+op(i,j,n)*tensor(j,k)*op(l,k,n)
               end do
            end do
         end do
      end do

      tensor(1:3,1:3)=tnew(1:3,1:3)
    end subroutine rotate_tensor

    subroutine symmetrize_force_const_Fourier(fcq,natm,cps)
      use m_Ionic_System, only : napt
      use m_Crystal_Structure, only : nopr,op
      complex(kind=DP), intent(inout) :: fcq(nmodes,nmodes,nqvec)
      integer, intent(in) :: natm
      real(kind=DP), dimension(natm,3) :: cps
      ! local variables
      integer :: i,j,nop,iq
!!$  complex(kind=DP) :: nonsym_fcq(nmodes,nmodes,nqvec)
      complex(kind=DP),allocatable,dimension(:,:,:) :: nonsym_fcq
      complex(kind=DP) :: tensor(3,3)
      complex(kind=DP) :: expgr
      real(kind=DP) :: ph,g(3)

      allocate(nonsym_fcq(nmodes,nmodes,nqvec));nonsym_fcq=0.d0
      nonsym_fcq(1:nmodes,1:nmodes,1:nqvec) = fcq(1:nmodes,1:nmodes,1:nqvec)
      fcq(1:nmodes,1:nmodes,1:nqvec) = 0.d0

      do iq=1,nqvec
         nop = 0
         do n=1,nopr
            if(.not.fksym(n,iq)) cycle
            nop = nop + 1
            g = matmul(op(1:3,1:3,n),qvec(iq,1:3)) - qvec(iq,1:3)
            do j=1,natm
               ja=3*(j-1)+1
               jr=napt(j,n)
               jra=3*(jr-1)+1
               do i=1,natm
                  ia=3*(i-1)+1
                  ir=napt(i,n)
                  ira=3*(ir-1)+1
                  ph = dot_product(g,cps(j,1:3)-cps(i,1:3))
                  expgr = dcmplx(cos(ph),sin(ph))
                  tensor(1:3,1:3)=nonsym_fcq(ira:ira+2,jra:jra+2,iq)
                  call rotate_complex_tensor(tensor,n)
                  fcq(ia:ia+2,ja:ja+2,iq)= &
                       & fcq(ia:ia+2,ja:ja+2,iq) + tensor(1:3,1:3)*expgr
               end do
            end do
         end do
         fcq(1:nmodes,1:nmodes,iq) = fcq(1:nmodes,1:nmodes,iq)/nop
      end do
      deallocate(nonsym_fcq)
      do iq=1,nqvec
         do j=1,nmodes
            do i=1,j
               fcq(i,j,iq)=(fcq(i,j,iq)+dconjg(fcq(j,i,iq)))*0.5d0
               fcq(j,i,iq)=dconjg(fcq(i,j,iq))
            end do
         end do
      end do

    end subroutine symmetrize_force_const_Fourier


    subroutine rotate_complex_tensor(tensor,n)
      use m_Crystal_Structure, only : op
      complex(kind=DP), intent(inout) :: tensor(3,3)
      integer, intent(in) :: n ! index of rotation

      ! local variables
      integer :: i,j,k,l
      complex(kind=DP) :: tnew(3,3)

      tnew(1:3,1:3)=0.d0

      do l=1,3
         do i=1,3
            do k=1,3
               do j=1,3
                  tnew(i,l)=tnew(i,l)+op(j,i,n)*tensor(j,k)*op(k,l,n)
               end do
            end do
         end do
      end do

      tensor(1:3,1:3)=tnew(1:3,1:3)
    end subroutine rotate_complex_tensor

    subroutine write_dynmat(dynmat)
      real(kind=DP), intent(in) :: dynmat(nmodes,nmodes,nlpnt)
      integer :: icell,l1,l2,l3,n
      do icell=1,nlpnt
         l1 = nint(sum(rltv(1:3,1)*lpnt(icell,1:3))/PAI2)
         l2 = nint(sum(rltv(1:3,2)*lpnt(icell,1:3))/PAI2)
         l3 = nint(sum(rltv(1:3,3)*lpnt(icell,1:3))/PAI2)
         write(nfout,'("icell=",i4," l1=",i3," l2=",i3," l3=",i3," lp=",3f10.5)') icell,l1,l2,l3,lpnt(icell,1:3)
         do n=1,nmodes
            write(nfout,'(50(1x,e12.5))') dynmat(n,1:nmodes,icell)
         end do
      end do
    end subroutine write_dynmat

    subroutine write_dynmatq(dynmatq)
      complex(kind=DP), intent(in) :: dynmatq(nmodes,nmodes,nqvec)
      integer :: iq
      do iq=1,nqvec
         write(nfout,'(i4," q=(",f8.3,",",f8.3,",",f8.3,")")') iq,qvin(iq,1:3)
         write(nfout,'("=== Real part ===")')
         do n=1,nmodes
            write(nfout,'(50(1x,e12.5))') dble(dynmatq(n,1:nmodes,iq))
         end do
         write(nfout,'("=== Imag part ===")')
         do n=1,nmodes
            write(nfout,'(50(1x,e12.5))') dimag(dynmatq(n,1:nmodes,iq))
         end do
      end do
    end subroutine write_dynmatq

    subroutine calc_napart_gamma(iq,nafc)
      integer, intent(in) :: iq
      complex(kind=DP), intent(out) :: nafc(nmodes,nmodes)

      real(kind=DP) :: coefna,kzeff(nmodes)
      integer :: i,j,na,ia

      coefna = 0.d0
      do j=1,3
         do i=1,3
            coefna = coefna + qdir(iq,i)*dielectric(i,j)*qdir(iq,j)
         end do
      end do
      coefna = PAI4/(univol*coefna)
      i=0
      do na=1,natm
         if (imdtyp(na) == OFF) cycle
         do ia=1,3
            i=i+1
            kzeff(i) = sum(qdir(iq,1:3)*zeff(1:3,ia,na))
            !kzeff(i) = sum(qdir(iq,1:3)*zeff(1:3,mode2atom(i),na))
         end do
      end do
      do j=1,nmodes
         do i=1,nmodes
            nafc(i,j) = coefna*kzeff(i)*kzeff(j)
         end do
      end do

    end subroutine calc_napart_gamma

    subroutine calc_napart_parlinski(iq,nafc,g2bz)
      integer, intent(in) :: iq
      complex(kind=DP), intent(out) :: nafc(nmodes,nmodes)
      real(kind=DP), intent(in) :: g2bz

      real(kind=DP) :: coefna,kzeff(nmodes)
      real(kind=DP) :: expk,rho2
      integer :: i,j,na,ia

      rho2 = rho_loto**2*g2bz*0.25d0

      coefna = 0.d0
      do j=1,3
         do i=1,3
            coefna = coefna + qvec(iq,i)*dielectric(i,j)*qvec(iq,j)
         end do
      end do
      coefna = PAI4/(univol*coefna)
      i=0
      do na=1,natm
         if(imdtyp(na)==OFF)cycle
         do ia=1,3
            i=i+1
            kzeff(i) = sum(qvec(iq,1:3)*zeff(1:3,ia,na))
            !kzeff(i) = sum(qvec(iq,1:3)*zeff(1:3,mode2atom(i),na))
         end do
      end do
      expk = exp(-PAI**2*sum(qvec(iq,1:3)**2)/rho2)
      do j=1,nmodes
         do i=1,nmodes
            nafc(i,j) = coefna*kzeff(i)*kzeff(j)*expk
         end do
      end do

    end subroutine calc_napart_parlinski

    subroutine get_g2bz(g2)
      real(kind=DP), intent(out) :: g2

      integer :: i,j,k
      real(kind=DP) :: g(3),gg

      g2 = dot_product(rltv(1:3,1),rltv(1:3,1))
      do i=-2,2
         do j=-2,2
            do k=-2,2
               g(1:3) = i*rltv(1:3,1)+j*rltv(1:3,2)+k*rltv(1:3,3)
               gg = dot_product(g,g)
               if(abs(gg) > eps .and. gg < g2) then
                  g2 = gg
               end if
            end do
         end do
      end do
    end subroutine get_g2bz

  end subroutine m_Phonon_calc_dynamical_matrix

  subroutine m_Phonon_force_constant_matrix(force_const_mat)
    implicit none

    real(kind=DP), intent(out) :: force_const_mat(nmodes,nmodes,nlpnt)

    ! local variables
    integer :: is,nc,ind,i,j,jj,ic,icell
    real(kind=DP) :: ui,x
    real(kind=DP), allocatable :: cmat(:,:) !dim(nc,nc)
    real(kind=DP), allocatable :: fvec(:) !dim(nc)

    if(sw_polynomial_fit == ON) then
       nc = norder*2+1
       allocate(cmat(nc,nc)); cmat = 0.d0
       allocate(fvec(nc))
       cmat(1:nc,1) = 1.d0
       ind = 1
       do is = -norder,norder
          if(is==0) cycle
          ind=ind+1
          x = u/dble(is)
          do i=2,nc
             cmat(ind,i) = x**(i-1)
          end do
       end do
       do ic=1,nlpnt
          do j=1,nmodes
             jj = nmodes*(ic-1)+j
             do i=1,nmodes
                fvec(1) = force0(jj)
                fvec(2:nc) = forces(jj,i,1:nc-1)
                force_const_mat(i,j,ic) = -polyfit_diff(nc,cmat,fvec)
             end do
          end do
       end do
    else
       ui=dble(norder)/u
       if(printable .and. ipriphonon>=2) then
          write(nfout,*) 'u=',u
          write(nfout,*) 'ui= norder/u =',ui
       endif
       if(norder == 1) then
          ui = -0.5d0*ui
          do ic=1,nlpnt
             do j=1,nmodes
                jj = nmodes*(ic-1)+j
                do i=1,nmodes
                   force_const_mat(i,j,ic) = (forces(jj,i,2)-forces(jj,i,1))*ui
                end do
             end do
          end do
       else if(norder == 2) then
          ui = -ui/12.d0
          do ic=1,nlpnt
             do j=1,nmodes
                jj = nmodes*(ic-1)+j
                do i=1,nmodes
                   force_const_mat(i,j,ic) = (-8.d0*forces(jj,i,1)+forces(jj,i,2) &
                        &  -forces(jj,i,3)+8.d0*forces(jj,i,4))*ui
                end do
             end do
          end do
       else
          call phase_error_with_msg(nfout,'Your inputed norder is not supported for the differencial approximation.'&
                                   ,__LINE__,__FILE__)
       end if
    end if

  contains

    function polyfit_diff(nd,mat,vec)
      implicit none

      real(kind=DP) :: polyfit_diff

      integer, intent(in) :: nd
      real(kind=DP), intent(in) :: mat(nd,nd)
      real(kind=DP), intent(in) :: vec(nd)

      ! local variables
      integer :: ipiv(nd),info,i
      real(kind=DP) :: a(nd,nd),b(nd)
      real(kind=DP) :: x0,df
      real(kind=DP) :: xold
      real(kind=DP) :: eps = 1.d-10

      real(kind=DP) :: ux

      ! debug
      !  write(nfout,*) '<<polyfit_diff>>'
      !  call flush(nfout)
      ! end debug

      a = mat
      b = vec

      !debug
      !do i=1,nd
      !  write(nfout,*) 'a=',a(i,1:nd)
      !end do
      !do i=1,nd
      !  write(nfout,*) 'b=',b(i)
      !end do
      !  call flush(nfout)
      !end debug

      call dgesv(nd,1,a,nd,ipiv,b,nd,info)
      if(info .ne. 0 ) then
         if(printable) write(nfout,*) 'LAPACK routine DGETRS failure: info=',info
         call phase_error_with_msg(nfout,'LAPACK routine DGETRS failure',__LINE__,__FILE__)
      end if
      ! debug
      !  do i=1,nd
      !    print *,'i=',i,' b=',b(i)
      !  end do
      !  write(nfout,'("ux="f10.5," f=",2(1x,f15.10))') ux,vec(1),polyfunc(nd,b,0.d0)
      !  i=0
      !  do is=-norder,norder
      !    if(is==0) cycle
      !    i=i+1
      !    ux = u/dble(is)
      !    write(nfout,'("ux="f10.5," f=",2(1x,f15.10))') ux,vec(i+1),polyfunc(nd,b,ux)
      !  end do
      !  call flush(nfout)
      ! end debug

      x0 = 0.d0
      df = diff_polyfunc(nd,b,x0)
      ! debug
      !print *,'df=',df
      ! end debug
      polyfit_diff = df

    end function polyfit_diff

    function polyfunc(nd,b,x)
      implicit none

      real(kind=DP) :: polyfunc

      integer, intent(in) :: nd
      real(kind=DP), intent(in) :: b(nd),x

      integer :: i
      real(kind=DP) :: f

      f = b(1)
      do i=2,nd
         f = f + b(i)*x**(i-1)
      end do
      polyfunc = f

    end function polyfunc

    function diff_polyfunc(nd,b,x)
      implicit none

      real(kind=DP) :: diff_polyfunc

      integer, intent(in) :: nd
      real(kind=DP), intent(in) :: b(nd),x

      integer :: i
      real(kind=DP) :: df

      df = b(2)
      do i=3,nd
         df = df + b(i)*dble(i-1)*x**(i-2)
      end do
      diff_polyfunc = df

    end function diff_polyfunc

  end subroutine m_Phonon_force_constant_matrix


  subroutine m_Phonon_calc_vib_modes()
    implicit none

    ! local variables
    integer :: i,j
!!$real(DP) :: eps=1.d-8
    real(DP) :: eps=1.d-16
    real(DP) :: norm

    allocate(omega(nmodes,nqvec),modes(nmodes,nmodes,nqvec))

    write(nfout,*) 'calc_vib_modes is started.'

    do j=1,nqvec
       write(nfout,'(i4," q=(",f8.3,",",f8.3,",",f8.3,")")') j,qvin(j,1:3)
       call solve_eigenproblem(dynmatq(1,1,j) ,omega(1,j),modes(1,1,j))
       do i=1,nmodes
          if(ipriphonon>=2) &
               & write(nfout,*) 'omega**2 = ',omega(i,j)
          if(abs(omega(i,j)) < eps) omega(i,j)=0.d0
          if(omega(i,j) > 0.d0) then
             omega(i,j)=sqrt(omega(i,j))
          else
             omega(i,j)=-sqrt(abs(omega(i,j))) ! for the soft mode
          end if
          if(ipriphonon >=2) &
               & write(nfout,*) '==> omega = ',omega(i,j)
       end do
    end do

    deallocate(dynmatq)

  contains
    subroutine solve_eigenproblem(dynmat,omega,modes)
      complex(kind=DP), intent(inout) :: dynmat(nmodes,nmodes)
      real(kind=DP), intent(out)      :: omega(nmodes)
      complex(kind=DP), intent(out)   :: modes(nmodes,nmodes)

      real(kind=DP) :: abstol
      integer :: lcwork,lrwork,liwork
      complex(kind=DP), allocatable :: cwork(:) ! dim(lcwork)
      real(kind=DP), allocatable :: rwork(:) ! dim(lrwork)
      integer, allocatable :: iwork(:) ! dim(liwork)
      integer, allocatable :: ifail(:) ! dim(nmodes)
      integer :: info
      integer :: m
      integer :: il,iu
      real(DP) :: vl,vu

      real(DP), external :: dlamch

      abstol=2*dlamch('S')
      !abstol=4.45014771701440D-308
      !print *,'abstol=',abstol
!!$lwork=8*nmodes
      lcwork=4*nmodes
      lrwork=7*nmodes
      liwork=5*nmodes
!!$allocate(work(lwork))
      allocate(cwork(lcwork))
      allocate(rwork(lrwork))
      allocate(iwork(liwork),ifail(nmodes))
      lcwork=-1
      call zheevx('V','A','U',nmodes,dynmat,nmodes,vl,vu,il,iu,abstol, &
           &      m,omega,modes,nmodes,cwork,lcwork,rwork,iwork,ifail,info)
!!$call dsyevx('V','A','U',nmodes,dynmat,nmodes,vl,vu,il,iu, &
!!$ &      abstol,m,omega,modes,nmodes,work,lwork,iwork, &
!!$ &      ifail,info)
      lcwork = cwork(1)
      !print *,'lwork=',lwork
      !print *,'info=',info
      deallocate(cwork)
      allocate(cwork(lcwork))
      call zheevx('V','A','U',nmodes,dynmat,nmodes,vl,vu,il,iu,abstol, &
           &      m,omega,modes,nmodes,cwork,lcwork,rwork,iwork,ifail,info)
!!$call dsyevx('V','A','U',nmodes,dynmat,nmodes,vl,vu,il,iu, &
!!$ &      abstol,m,omega,modes,nmodes,work,lwork,iwork, &
!!$ &      ifail,info)
      !print *,'info=',info
      !print *,'ifail=',ifail(1:nmodes)
      deallocate(cwork,rwork,iwork,ifail)
    end subroutine solve_eigenproblem
  end subroutine m_Phonon_calc_vib_modes

  subroutine m_Phonon_det_irr_rep()
    use m_Representation, only : get_irr_rep
    use m_Crystal_Structure, only : nopr
    use m_Ionic_System, only : imdtyp
    implicit none

    ! local variabes
    integer :: i,j,ia,ja,ist,n
    real(DP) :: norm
    real(DP) :: eir(3),ejr(3),xir(1:nmodes)
    real(DP) :: eii(3),eji(3),xii(1:nmodes)
    integer :: nrep,nsym
    integer :: rep(48,12)
    character(len=3) :: symbol_irrep(12)
    character(len=4) :: active_rep(12)
    real(DP) :: eps = 1.d-1
    integer :: iq
    integer :: icount,jcount

    allocate(atm2mobileatm(natm_prim));atm2mobileatm=0
    icount=0
    do i=1,natm_prim
       if(imdtyp(i) /= OFF)then
         icount = icount+1
         atm2mobileatm(i) = icount
       endif
    enddo

    write(nfout,*) '** Representation **'

    allocate(mode_irr_rep(nmodes,nqvec))
    allocate(mode_active(nmodes,nqvec))
    do iq=1,nqvec
       write(nfout,'(i4," q=(",f8.3,",",f8.3,",",f8.3,")")') iq,qvin(iq,1:3)
       call get_irr_rep(point_group(iq),nsym,nrep,rep,symbol_irrep,active_rep)

       if(printable)  then
          write(nfout,'("Character table:",a3)') point_group(iq)
          do j=1,nrep
             write(nfout,'(a3,1x,48i3)') symbol_irrep(j), rep(1:nsym,j)
          end do
       end if
       ! debug
       !write(nfout,'("Product table:",a3)') point_group
       !do j=1,nrep
       !  write(nfout,'(a3,1x,48i3)') symbol_irrep(j),(sum(rep(1:nopr,j)*rep(1:nopr,i)),i=1,nrep)
       !end do
       ! end debug

       if ( printable ) then
          write(nfout,*) '** mode  repr. active **'
       endif

       do i=1,nmodes
          ! debug
          !        write(nfout,*) 'index of the mode =',i
          !        write(nfout,*) 'norm =',sum(dble(modes(1:nmodes,i,iq))**2+dimag(modes(1:nmodes,i,iq))**2)
          ! end debug
          mode_irr_rep(i,iq)='NON'
          Representation: do j=1,nrep
             xir(1:nmodes)=0.d0
             xii(1:nmodes)=0.d0
             do n=1,nopr
                icount = 0
                do ia=1,natm
                   if(imdtyp(ia)==OFF)cycle
                   !ist = 3*(ia-1)+1
                   icount = icount+1
                   ist = 3*(icount-1)+1
                   eir(1:3) = dble(modes(ist:ist+2,i,iq))
                   eii(1:3) = dimag(modes(ist:ist+2,i,iq))
                   call rotate_eigenvector(n,ia,ja,eir,ejr)
                   call rotate_eigenvector(n,ia,ja,eii,eji)
                   if ( atm2mobileatm(ja) ==0 ) cycle
                   ist = 3*(atm2mobileatm(ja)-1)+1
                   xir(ist:ist+2)=xir(ist:ist+2)+rep(n,j)*ejr(1:3)
                   xii(ist:ist+2)=xii(ist:ist+2)+rep(n,j)*eji(1:3)
                   ! debug
                   !        write(nfout,*) 'j =',j
                   !        write(nfout,*) 'n =',n
                   !        write(nfout,*) 'ia=',ia
                   !        write(nfout,*) 'eir=',eir(1:3)
                   !        write(nfout,*) 'eii=',eii(1:3)
                   !        write(nfout,*) 'ja=',ja
                   !        write(nfout,*) 'ejr=',ejr(1:3)
                   !        write(nfout,*) 'eji=',eji(1:3)
                   ! end debug
                end do
             end do
             !xi(1:nmodes) = xi(1:nmodes)/nopr
             norm = sum(xir(1:nmodes)**2+xii(1:nmodes)**2)
             ! debug
             !write(nfout,*) 'j=',j,' norm=',norm
             ! end debug
             if(norm > eps) then
                mode_irr_rep(i,iq)= symbol_irrep(j)
                mode_active(i,iq) = active_rep(j)
                ! exit Representation
             end if
          end do Representation

          if(printable) then
             write(nfout,'(1x,i5,5x,a3,4x,a4)') i,mode_irr_rep(i,iq),mode_active(i,iq)
          endif
       end do
    end do ! q loop

    deallocate(atm2mobileatm)
  contains

    subroutine rotate_eigenvector(n,ia,ja,ei,ej)
      use m_Ionic_System, only : napt
      use m_Crystal_Structure, only : op
      integer, intent(in) :: n, ia
      integer, intent(out) :: ja
      real(kind=DP), intent(in) :: ei(3)
      real(kind=DP), intent(out) :: ej(3)

      ! local variables
      integer :: i

      ja = napt(ia,n)

      do i=1,3
         ej(i) = sum(op(i,1:3,n)*ei(1:3))
      end do

    end subroutine rotate_eigenvector

  end subroutine m_Phonon_det_irr_rep


  subroutine m_Phonon_calc_static_dielectric()
    use m_Crystal_Structure, only : univol
    implicit none

    real(DP), parameter :: ha2ev = Hartree ! 1 Ha = 27.211383411 eV

    ! local variables
    integer :: im,i,na,ia,j
    real(DP) :: zsum
    real(DP) :: coef

    if(sw_lo_to_splitting == ON) return
    if(nqvec/=1) return

    allocate(zeff_mode(3,nmodes))
    do im=1,nmodes
       do i=1,3
          zsum = 0.d0
          j=0
          do na=1,natm
             do ia=1,3
                j=j+1
                zsum = zsum + zeff(i,ia,na)*dble(modes(j,im,nqvec))*msqinv(j)
             end do
          end do
          zeff_mode(i,im) = zsum
       end do
    end do

    coef = 16.d0*atan(1.d0)/univol
    lattice_dielectric(1:3,1:3) = 0.d0

    if (printable) then
       write(nfout,*) "*** Contribution to diagonal sum of dielectric tensor ***"
       write(nfout,'(A,15X,A)') '  mode   Repr. Active            Freq [cm-1]', &
            &                  ' Contrib.'
    endif

    do im=1,nmodes
       if(omega(im,nqvec)>1.d-10) then
          do j=1,3
             do i=1,3
                lattice_dielectric(i,j) = lattice_dielectric(i,j) +  &
                     & zeff_mode(i,im)*zeff_mode(j,im)/omega(im,nqvec)**2
             end do
          end do
          if(printable) write(nfout,'("im=",i6,1x,a3,1x,a4,2(1x,f25.10))')  &
               &  im,mode_irr_rep(im,nqvec),mode_active(im,nqvec) &
               & ,omega(im,nqvec)*ha2ev *ev2cminv &
               & ,coef*sum(zeff_mode(1:3,im)**2)/omega(im,nqvec)**2
       end if
    end do
    lattice_dielectric(1:3,1:3) = coef*lattice_dielectric(1:3,1:3)

    static_dielectric(1:3,1:3) =  &
         & lattice_dielectric(1:3,1:3) + dielectric(1:3,1:3)

  end subroutine m_Phonon_calc_static_dielectric


  subroutine m_Phonon_write_vib_modes()
    use m_Files, only : m_Files_open_nfmode, nfmode
    use m_Ionic_System, only : cps,imdtyp
    use m_Crystal_Structure, only : altv
    implicit none

    ! local variabes
!   real(DP), parameter :: amu = AMU ! 1 amu = 1822.88847974 Me
    real(DP), parameter :: ha2ev = Hartree ! 1 Ha = 27.211383411 eV
!   real(DP), parameter :: ev2cminv = 1.d0/1.23984185d-4 ! 1 cm^-1 = 1.233984185e-4 eV
    integer :: i,j,istart,iq
    real(DP) :: omega_ev,omega_cm
    real(DP) :: zamu(3),znorm
    real(DP) :: x,hbarW,free_e
    integer :: icount,jcount

    call  m_Files_open_nfmode()

    if(mype /= 0) return

    if ( sw_phonon_band_unfolding == ON ) then
       call m_Phonon_Unfold_spectr_weight
       write(nfmode,'(1x,"--- supercell lattice vectors ---")')
       do i=1,3
          write(nfmode,'(1x,3(f14.10,1x))') altv(1:3,i)
       end do
       write(nfmode,'(1x,"--- reference cell lattice vectors ---")')
       do i=1,3
          write(nfmode,'(1x,3(f14.10,1x))') altv_refcell(1:3,i)
       end do
    else
       write(nfmode,'(1x,"--- primitive lattice vectors ---")')
       do i=1,3
          write(nfmode,'(1x,3(f14.10,1x))') altv(1:3,i)
       end do
    endif

    write(nfmode,'(1x,"--- Equilibrium position and mass of each atom---")')
    write(nfmode,'(1x,"Natom=",i5)') natm
    do i=1,natm
       write(nfmode,'(1x,i5,3(1x,f14.10),1x,f14.5,1x,a4,i3)') &
            &                      i,cps(i,1:3),ionic_mass(i),speciesname(ityp(i)), &
            &                      atom_key(i)
    end do
    write(nfmode,'(1x,"--- Vibrational modes ---")')
    if(phonon_method == PHONON_GAMMA) then
       write(nfmode,'(1x,"Nmode=",i5," Natom=",i5)') nmodes,natm
    else
       write(nfmode,'(1x,"Nmode=",i5," Natom=",i5," Nqvec",i5)') nmodes,natm,nqvec
    end if

    if(phonon_method==PHONON_DOS .and. way_of_smearing==FERMI_DIRAC) free_e=0.d0

    do iq=1,nqvec
       if(phonon_method == PHONON_DOS) then
          write(nfmode,'(1x,"iq=",i5," q=(",f15.10,",",f15.10,",",f15.10,") (",f15.10,",",f15.10,",",f15.10,")",1x,f15.10)') &
               & iq,qvin(iq,1:3),qvec(iq,1:3),wght(iq)

!       else if(phonon_method /= PHONON_GAMMA) then
       else if(phonon_method == PHONON_BAND ) then
          if ( sw_phonon_band_unfolding == OFF ) then
             write(nfmode,'(1x,"iq=",i5," q=(",f15.10,",",f15.10,",",f15.10,") (",f15.10,",",f15.10,",",f15.10,")")') &
                  & iq,qvin(iq,1:3),qvec(iq,1:3)
          else
             write(nfmode,'(1x,"iq=",i5," q=(",f15.10,",",f15.10,",",f15.10,") (",f15.10,",",f15.10,",",f15.10,")")') &
                  & iq, qvin_refcell(iq,1:3), qvec(iq,1:3)
          endif
       end if

       do i=1,nmodes
          omega_ev = omega(i,iq)*ha2ev
          omega_cm = omega_ev*ev2cminv
          if ( sw_phonon_band_unfolding == ON ) then
             write(nfmode,'(1x,"n= ",i5, 1x, a3, 1x, a4, 5x,"weight=", e15.8, &
                  &                  /5x,"hbarW= ",e15.8," Ha = ",e15.8, &
                  &                " eV; nu= ",e15.8," cm^-1")') &
                  &                  i, mode_irr_rep(i,iq), mode_active(i,iq), &
                  &                  unfolding_weight(i,iq), &
                  &                  omega(i,iq), omega_ev, omega_cm
          else
             write(nfmode,'(1x,"n= ",i5, 1x, a3, 1x, a4, &
                  &                  /5x,"hbarW= ",e15.8," Ha = ",e15.8,&
                  &                  " eV; nu= ",e15.8," cm^-1")') &
                  &                  i, mode_irr_rep(i,iq), mode_active(i,iq), &
                  &                  omega(i,iq), omega_ev, omega_cm
          endif

          jcount=0
          do j=1,natm
             if(imdtyp(j)==OFF)cycle
             jcount = jcount+1
             istart = 3*(jcount-1)+1
             write(nfmode,'(1x,i5,1x,3f14.10)') j,dble(modes(istart:istart+2,i,iq))
          end do
          if(nqvec>1) then
             jcount=0
             do j=1,natm
                if(imdtyp(j)==OFF)cycle
                jcount = jcount+1
                istart = 3*(jcount-1)+1
                write(nfmode,'(1x,i5,1x,3f14.10)') j,dimag(modes(istart:istart+2,i,iq))
             end do
          end if
          if(phonon_method == PHONON_GAMMA.and.sw_lattice_dielectric_tensor == ON) then
             write(nfmode,'(3x,"Mode effective charge and its norm:")')
             zamu(1:3)=zeff_mode(1:3,i)*sqrt(amu)
             znorm = sqrt(sum(zamu(1:3)**2))
             write(nfmode,'(3x,"Z=",3(f14.10,1x),"Norm=",f14.10)') zamu(1:3),znorm
          end if
          if(phonon_method == PHONON_DOS.and.way_of_smearing==FERMI_DIRAC)then
             hbarW = omega(i,iq)
             x = hbarW/width
             if(x.gt.1.d-10) free_e = free_e + wght(iq)*(0.5d0*hbarW+width*log(1.d0-exp(-x)))
          endif
       end do
    end do
    if(phonon_method == PHONON_GAMMA.and.sw_lattice_dielectric_tensor == ON) then
       write(nfmode,'(1x,"--- Lattice and static dielectric tensors ---")')
       do i=1,3
          write(nfmode,'(1x,"[",3(1x,f10.4)," ]",2x,"[",3(1x,f10.4)," ]")') &
               & lattice_dielectric(i,1:3), static_dielectric(i,1:3)
       end do
    end if
    if(way_of_smearing==FERMI_DIRAC.and.phonon_method==PHONON_DOS.and.printable)then
       write(nfout,'(a,f15.10,a)') '!** Free energy due to lattice vibration : ',free_e,' hartree/cell'
    endif

    return
  end subroutine m_Phonon_write_vib_modes

  subroutine m_Phonon_write_epsilon()
    use m_Crystal_Structure, only : univol
    use m_Files, only : m_Files_open_nfepsilon, nfepsilon
    implicit none

    ! local variables
    real(DP), parameter :: ha2ev = Hartree ! 1 Ha = 27.211383411 eV
    integer :: n,im,i,j
    real(kind=DP) :: e,de,e2,e3,e4
    real(kind=DP) :: coef
    real(kind=DP) :: epsilon(3,3,2,0:num_division)

    if(nqvec /= 1) return

    coef = 16.d0*atan(1.d0)/univol
    de = (max_energy-min_energy)/num_division

    do n=0,num_division
       e = min_energy + de * n
       epsilon(1:3,1:3,1:2,n) = 0.d0
       do im=1,nmodes
          if(omega(im,nqvec)>1.d-5) then
             e2 = omega(im,nqvec)**2-e**2
             e3 = e*omega(im,nqvec)*damping_factor
             e4 = e2**2+e3**2
             if(abs(damping_factor) < 1.d-10) then
                if(abs(omega(im,nqvec)-e) < 1.d-10) then
                   if(e2 > 0.d0) then
                      e2 = 1.d-10
                   else
                      e2 = -1.d-10
                   end if
                end if
                do j=1,3
                   do i=1,j
                      epsilon(i,j,1,n) = epsilon(i,j,1,n) + zeff_mode(i,im)*zeff_mode(j,im)/e2
                      epsilon(i,j,2,n) = 0.d0
                   end do
                end do
             else
                do j=1,3
                   do i=1,j
                      epsilon(i,j,1,n) = epsilon(i,j,1,n) + zeff_mode(i,im)*zeff_mode(j,im)*e2/e4
                      epsilon(i,j,2,n) = epsilon(i,j,2,n) + zeff_mode(i,im)*zeff_mode(j,im)*e3/e4
                   end do
                end do
             end if
          end if
       end do
       epsilon(1:3,1:3,1,n)=dielectric(1:3,1:3)+coef*epsilon(1:3,1:3,1,n)
       epsilon(1:3,1:3,2,n)=coef*epsilon(1:3,1:3,2,n)
    end do

    call m_Files_open_nfepsilon()
    if(mype /= 0) return
    write(nfepsilon,'("Energy(eV) E1xx E1yy E1zz E1yz E1zx E1xy E2xx E2yy E2zz E2yz E2zx E2xy")')
    do n=0,num_division
       e = (min_energy + de * n) * ha2ev
       write(nfepsilon,'(13(1x,e25.10))') &
            & e, ((epsilon(i,i,j,n),i=1,3),epsilon(2,3,j,n),epsilon(1,3,j,n),epsilon(1,2,j,n),j=1,2)
    end do

  end subroutine m_Phonon_write_epsilon

  subroutine m_Phonon_set_supercell
    use m_Crystal_Structure, only: m_CS_supercell_on
    integer :: n1,n2,n3
    n1 = nlat(1)
    n2 = nlat(2)
    n3 = nlat(3)
    if(n1==0.and.n2==0.and.n3==0) then
       n1 = 1; n2 = 1; n3 = 1
       call m_CS_supercell_on(nfout,1,n1,n2,n3) ! 1: PRIMITIVE
    else
       call m_CS_supercell_on(nfout,0,n1,n2,n3) ! 0: BRAVAIS
    end if
  end subroutine m_Phonon_set_supercell

  subroutine m_Phonon_calc_dos()
    integer :: idim = 3
    integer :: iq,im,ie
    integer :: newin
    real(kind=DP) :: emin,emax
    !  real(kind=DP), dimension(np2,nmodes) :: omega2
    !  real(kind=DP), dimension(np0) :: eawk, cdwk, cswk
    real(kind=DP), allocatable, dimension(:,:) :: omega2 ! dim(np2,nmodes)      <ASMS>
    real(kind=DP), allocatable, dimension(:)   :: eawk, cdwk, cswk ! dim(np0)   <ASMS>
    real(kind=DP), allocatable, dimension(:,:,:) :: cdos,cind ! dim(np2,nmodes,0:newin)
    real(kind=DP), allocatable, dimension(:) :: e,dos,sumdos ! dim(0:newin)

    allocate(omega2(np2,nmodes))                     ! <ASMS>
    allocate(eawk(np0),cdwk(np0),cswk(np0))          ! <ASMS>
    eawk=0.d0
    cdwk=0.d0
    cswk=0.d0

    do iq=1,np2
       do im=1,nmodes
          omega2(iq,im) = omega(im,iq) * 1.0d3
       end do
    end do

    emin = minval(omega2) - 0.0005 ! (mhartree)
    emax = maxval(omega2) + 0.0005 ! (mhartree)
    newin = (emax - emin)/(DeltaE_dos*1.0d3) + 1

    allocate(cdos(np2,nmodes,0:newin)); cdos = 0.d0
    allocate(cind(np2,nmodes,0:newin)); cind = 0.d0

    allocate(e(0:newin))
    allocate(dos(0:newin)); dos=0.d0
    allocate(sumdos(0:newin)); sumdos=0.d0
    e(0:newin) = (/(emin + (DeltaE_dos*1.0d3)*ie,ie=0,newin)/)

    call nstt3i(idim,newin,e,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
         &  ,np2,np2,nmodes,omega2 &
         &  ,ip20,np0,eawk,cdwk,cswk,np2,nmodes,cdos,cind,width_tetra )

    do iq=1,np2
       do im=1,nmodes
          do ie=0,newin
             dos(ie)    = dos(ie)    + cdos(iq,im,ie)
             sumdos(ie) = sumdos(ie) + cind(iq,im,ie)
          end do
       end do
    end do
    deallocate(cdos)
    deallocate(cind)

    call write_dos(newin,e,dos,sumdos)

    deallocate(e)
    deallocate(dos)
    deallocate(sumdos)
  contains

    subroutine write_dos(newin,e,dos,sumdos)
      use m_Files, only : m_Files_open_nfphdos, nfphdos
      integer, intent(in) :: newin
      real(kind=DP), intent(in) :: e(0:newin), dos(0:newin), sumdos(0:newin)
      integer :: ie
      real(DP), parameter :: ha2ev = Hartree
      real(DP) :: eev, ecminv, dosev, doscminv

      if(mype /= 0) return
      call m_Files_open_nfphdos()

      write(nfphdos,'("# Index Omega(mHa) Omega(eV) Omega(cm-1) DOS(States/mHa) DOS(States/eV) DOS(States/cm-1) IntDOS(States)")')
      do ie = 0, newin
         eev = e(ie)*ha2ev/1.0d3  ! Hartree
         ecminv = eev*ev2cminv
         dosev = dos(ie)/ha2ev*1.0d3 ! Hartree
         doscminv = dosev/ev2cminv
         write(nfphdos,'(i7,7(1x,f15.8))') ie,e(ie), eev, ecminv, dos(ie), dosev, doscminv, sumdos(ie)
      end do
    end subroutine write_dos
  end subroutine m_Phonon_calc_dos

  subroutine m_Phonon_read_strain_forces
    use m_Files, only : nfout, nfstrfrc, m_Files_open_nfstrfrc
    integer :: i, ia, num_force, istr, ipm
    real(kind=DP) :: str, force(3,natm,6,2), strain(6,2), eps(3,3)
    logical :: present(6)

    strain = 0.d0
    present = .false.

    allocate(strfrc(3,natm,6))
    strfrc = 0.d0

    call m_Files_open_nfstrfrc()
    read(nfstrfrc,*) num_force
    do i=1,num_force
       read(nfstrfrc,*) istr, str
       if(str>0.d0) then
          ipm = 1
       else
          ipm = 2
       end if
       strain(istr,ipm) = str
       do ia=1,natm
          read(nfstrfrc,*) force(1:3,ia,istr,ipm)
       end do
    end do

    do istr=1,6
       if(strain(istr,1) > 1.d-8 .and. strain(istr,2) < -1.d-8 &
            & .and. abs(abs(strain(istr,1))-abs(strain(istr,2))) < 1.d-10) then
          present(istr) = .true.
       end if
    end do

    write(nfout,*) 'present strain : ',present

    do istr=1,6
       if(.not.present(istr)) cycle
       str = strain(istr,1)-strain(istr,2)
       eps = 0.d0
       if(istr==1) then
          eps(1,1) = 0.5d0
       else if(istr==2) then
          eps(2,2) = 0.5d0
       else if(istr==3) then
          eps(3,3) = 0.5d0
       else if(istr==4) then
          eps(2,3) = 0.25d0
          eps(3,2) = 0.25d0
       else if(istr==5) then
          eps(3,1) = 0.25d0
          eps(1,3) = 0.25d0
       else if(istr==6) then
          eps(1,2) = 0.25d0
          eps(2,1) = 0.25d0
       end if
       do ia=1,natm
          strfrc(1:3,ia,istr) = (force(1:3,ia,istr,1)-force(1:3,ia,istr,2))/str &
               & + matmul(eps,force(1:3,ia,istr,1)+force(1:3,ia,istr,2))
       end do
    end do

    write(nfout,*) '=== Strain-force coupling constants ==='
    do istr=1,6
       if(.not.present(istr)) cycle
       write(nfout,'("Strain : ",i1)') istr
       do ia=1,natm
          Write(nfout,'(i5,3(1x,f15.5))') ia,strfrc(1:3,ia,istr)
       end do
    end do

  end subroutine m_Phonon_read_strain_forces


  subroutine m_Phonon_calc_int_strain_piezo
    use m_Crystal_Structure, only : univol
    implicit none

    ! local variables
    integer :: im,i,na,ia,j
    real(DP) :: zsum,csum
    real(DP) :: coef

    if(sw_lo_to_splitting == ON) return
    if(nqvec/=1) return

    allocate(zeff_mode(3,nmodes))
    allocate(strphcpl(6,nmodes))
    do im=1,nmodes
       do i=1,3
          zsum = 0.d0
          j=0
          do na=1,natm
             do ia=1,3
                j=j+1
                zsum = zsum + zeff(i,ia,na)*dble(modes(j,im,nqvec))*msqinv(j)
             end do
          end do
          zeff_mode(i,im) = zsum
       end do
       do i=1,6
          csum = 0.d0
          j=0
          do na=1,natm
             do ia=1,3
                j=j+1
                csum = csum + strfrc(ia,na,i)*dble(modes(j,im,nqvec))*msqinv(j)
             end do
          end do
          strphcpl(i,im) = csum
       end do
    end do

    coef = 1.d0/univol
    piezoelectric(1:3,1:6) = 0.d0
    do j=1,6
       do i=1,3
          write(nfout,'("Direction:",i1," Strain:",i1)') i,j
          do im=1,nmodes
             if(omega(im,nqvec)>1.d-10) then
                piezoelectric(i,j) = piezoelectric(i,j) +  &
                     & zeff_mode(i,im)*strphcpl(j,im)/omega(im,nqvec)**2
                if(printable) write(nfout,'("im=",i4,1x,a3,1x,a4,3(1x,f25.10))')  &
                     &  im,mode_irr_rep(im,nqvec),mode_active(im,nqvec) &
!                    & ,omega(im,nqvec)*Hartree/1.23984185d-4 &
                     & ,omega(im,nqvec)*Hartree * ev2cminv &
                     & ,coef*zeff_mode(i,im)*strphcpl(j,im)/omega(im,nqvec)**2
             end if
          end do
       end do
    end do
    piezoelectric(1:3,1:6) = coef*piezoelectric(1:3,1:6)

    if(printable) then
       write(nfout,*) '=== Internal-strain piezoelectric tensor (a.u.) ==='
       do j=1,6
          write(nfout,'(i5,3(1x,f18.10))') j, piezoelectric(1:3,j)
       end do
       write(nfout,*) '=== Internal-strain piezoelectric tensor (C/m^2) ==='
       do j=1,6
          write(nfout,'(i5,3(1x,f18.10))') j, piezoelectric(1:3,j)*UNIT_PIEZO_CONST
       end do
    end if

  end subroutine m_Phonon_calc_int_strain_piezo

  subroutine m_Phonon_Unfold_spectr_weight
    use m_Ionic_System,          only : imdtyp
    use m_Const_Parameters,      only : CMPLDP, zi

    integer :: iq, i, ixyz, ig, ia
    integer :: jcount, istart
    integer :: nx, ny, nz
    real(kind=DP) :: csum1, csum2, c1, qq(3)
    complex(kind=CMPLDP) :: zsum1, zsum2, zfac

    integer :: nxmax, nymax, nzmax

    call m_Phonon_set_GVec_Flag_refcell
    allocate( unfolding_weight(nmodes,nqvec) )

    nxmax = nmax_G_phonon(1)
    nymax = nmax_G_phonon(2)
    nzmax = nmax_G_phonon(3)

    Do iq=1, nqvec
       Do i=1, nmodes
          csum1 = 0.0d0;    csum2 = 0.0d0
          Do ixyz=1, 3
             Do nx=-nxmax, nxmax
                Do ny=-nymax, nymax
                   Do nz=-nzmax, nzmax
!                      qq(1:3) = nx *rltv(1:3,1) +ny *rltv(1:3,2) +nz *rltv(1:3,3)
                      qq(1) = nx;     qq(2) = ny;     qq(3) = nz

                      jcount = 0;     zsum1 = 0.0d0

                      Do ia=1, natm
                         if (imdtyp(ia)==OFF) cycle
                         jcount = jcount+1
                         istart = 3*(jcount-1)+1

                         c1 = qq(1) *pos(ia,1) +qq(2) *pos(ia,2) +qq(3) *pos(ia,3)
!                         c1 = qq(1) *cps(ia,1) +qq(2) *cps(ia,2) +qq(3) *cps(ia,3)
                         zfac = exp( -zi *c1 *PAI2 )

                         zsum1 = zsum1 +zfac *modes( istart+ixyz-1, i, iq )
                      End Do
                      csum1 = csum1 +conjg(zsum1) *zsum1
                      if ( phonon_GVec_on_refcell(nx,ny,nz) == 1 ) then
                         csum2 = csum2 +conjg(zsum1) *zsum1
                      endif
                   End Do
                End Do
             End Do
          End Do
          unfolding_weight(i,iq) = csum2 /csum1
       End Do
    End Do

  end subroutine m_Phonon_Unfold_spectr_weight

  subroutine m_Phonon_set_GVec_Flag_refcell
    integer :: k, n1, n2, n3, nx, ny, nz
    real(kind=DP) :: vec1(3), cx, cy, cz, delta

    n1 = nmax_G_phonon(1)
    n2 = nmax_G_phonon(2)
    n3 = nmax_G_phonon(3)

    allocate( Phonon_GVec_on_refcell(-n1:n1,-n2:n2,-n3:n3) )
    Phonon_Gvec_on_refcell = 0

    delta = tolerance_ph_Gvec_matching

    Do nx=-n1, n1
       Do ny=-n2, n2
          Do nz=-n3, n3
             vec1(1) = nx *rltv(1,1) +ny *rltv(1,2) +nz *rltv(1,3)
             vec1(2) = nx *rltv(2,1) +ny *rltv(2,2) +nz *rltv(2,3)
             vec1(3) = nx *rltv(3,1) +ny *rltv(3,2) +nz *rltv(3,3)

             cx = 0.0d0; cy = 0.0d0; cz = 0.0d0
             Do k=1, 3
                cx = cx +altv_refcell(k,1) *vec1(k)
                cy = cy +altv_refcell(k,2) *vec1(k)
                cz = cz +altv_refcell(k,3) *vec1(k)
             End Do

             cx = cx /PAI2;     cy = cy /PAI2;      cz = cz /PAI2
             cx = abs( cx -nint(cx) );
             cy = abs( cy -nint(cy) );
             cz = abs( cz -nint(cz) );

             if ( cx < delta .and. cy < delta .and. cz < delta ) then
                phonon_GVec_on_refcell(nx,ny,nz) = 1
             endif
          ENd Do
       End Do
    ENd Do
  end subroutine m_Phonon_set_GVec_Flag_refcell

end module m_Phonon

module m_PlaneWaveEDA

#ifdef __EDA__
!  use m_Charge_Density,                   only  : chgq_l_EDA, chgq_l, hsr
  use m_Charge_Density,                   only  : chgq_l, hsr
  use m_Const_Parameters,                 only  : DIRECT, DP, EXC_ONLY, INVERSE, OFF, ON, Valence_plus_PC_Charge &
       &                                        , ELECTRON, GAMMA
  use m_Control_Parameters,               only  : af, kimg, nspin, neg
  use m_Crystal_Structure,                only  : altv, rltv, univol
  use m_Electronic_Structure,             only  : m_ES_WF_in_Rspace_3D, m_ES_WF_kin_in_Rspace &
       &                                        , occup_l, totch, zaj_l
  use m_FFT,                              only  : m_FFT_alloc_WF_work, m_FFT_dealloc_WF_work &
       &                                        , m_FFT_alloc_CD_box, m_FFT_dealloc_CD_box &
       &                                        , m_FFT_CD_direct0, m_FFT_CD_inverse0 &
       &                                        , m_FFT_WF &
       &                                        , fft_box_size_CD_nonpara, fft_box_size_WF, nfft, nfftp, nfftp_nonpara
  use m_Files,                            only  : nfout
  use m_Ionic_System,                     only  : cps, iatomn_EDA, ityp, iwei, natm, natm2, ntyp, pos, speciesname, zfm3_l &
       &                                        , eewald_per_atom, icount_EDA, zfm3_l_EDA
  use m_Kpoints,                          only  : kv3, vkxyz
  use m_Parallelization,                  only  : ista_e, iend_e, istep_e &
       &                                        , ista_kngp, iend_kngp &
       &                                        , map_k, map_e, map_z,  myrank_k, myrank_e, np_e, nrank_e, nrank_k, myrank_g
  use m_PlaneWaveBasisSet,                only  : gr_l, iba, igf, igfp_nonpara, kg, nbase, nbase_gamma, nbmx, ngabc, kg1
  use m_PseudoPotential,                  only  : dion, etot1, ilmt, ltp, mtp, psc_l &
       &                                        , epc_per_atom, PP_per_atom
  use m_XC_Potential_2D,                  only  : exc_on_a_grid, m_XC_cal_potential
  use m_Parallelization,                  only  : MPI_CommGroup, mype, npes &
       &                                        , nel_fft_x, nel_fft_y, nel_fft_z, mpi_chg_world, mpi_ke_world &
       &                                        , mpi_ge_world, mpi_kg_world, ista_g1k, iend_g1k, map_ek, myrank_ke
  use m_Timing,                           only  : tstatc0_begin, tstatc0_end, tstatc_wd, tstatc_init, tstatc_iter
  use m_Kpoints,                          only  : k_symmetry
  use mpi

  implicit none
!  include 'mpif.h'

! -----  for partitioning function  -----

  real(kind=DP),private,allocatable,dimension(:)       :: bragg_slater_radii
  real(kind=DP),private,dimension(3,3)                 :: rltv_inverse       ! <- inverse matrix of rltv
  real(kind=DP), allocatable, dimension(:,:)           :: rltv_t
  real(kind=DP),private,allocatable,dimension(:,:)     :: aij
  real(kind=DP),private,allocatable,dimension(:,:)     :: r_catom            ! <- internal vectors of atomic centers
  real(kind=DP),private,allocatable,dimension(:,:)     :: cps_new            ! <- real-space vectors of atomic centers

  real(kind=DP),private,allocatable,dimension(:)       :: grid_x_CD, grid_y_CD, grid_z_CD
  integer,private                                      :: ifxr_CD, ifyr_CD, ifzr_CD
  real(kind=DP),private                                :: grid_weight_CD
  real(kind=DP),private,allocatable,dimension(:,:,:,:) :: partition_function
  real(kind=DP),private,allocatable,dimension(:,:)     :: partition_function_on_a_grid
  real(kind=DP),allocatable,dimension(:)               :: afft
  real(kind=DP),allocatable,dimension(:)               :: bfft1
  real(kind=DP),allocatable,dimension(:)               :: bfft2
  real(kind=DP),allocatable,dimension(:)               :: density_on_a_grid
  real(kind=DP),allocatable,dimension(:)               :: ekin_on_a_grid
  real(kind=DP),allocatable,dimension(:)               :: ehartr_on_a_grid
  real(kind=DP),allocatable,dimension(:)               :: ehartr_on_a_grid2
  real(kind=DP),allocatable,dimension(:)               :: elocal_on_a_grid
  real(kind=DP),allocatable,dimension(:)               :: elocal_on_a_grid1
  real(kind=DP),allocatable,dimension(:)               :: elocal_on_a_grid2
  real(kind=DP),allocatable,dimension(:,:)             :: PP_on_a_grid
  real(kind=DP),allocatable,dimension(:)               :: PP_on_a_grid_wk

! -----  EDA  -----

  real(kind=DP),private,allocatable,dimension(:)       :: density_per_atom
  real(kind=DP),private,allocatable,dimension(:)       :: ekin_per_atom
  real(kind=DP),private,allocatable,dimension(:)       :: ehartr_per_atom
  real(kind=DP),private,allocatable,dimension(:)       :: exc_per_atom
  real(kind=DP),private,allocatable,dimension(:)       :: elocal_per_atom
  real(kind=DP),private,allocatable,dimension(:)       :: elocal_per_atom_from_electron
  real(kind=DP),private,allocatable,dimension(:)       :: elocal_from_nucleus1
  real(kind=DP),private,allocatable,dimension(:)       :: elocal_from_nucleus2
  real(kind=DP),private,allocatable,dimension(:)       :: enonlocal_per_atom
  real(kind=DP),private,allocatable,dimension(:)       :: epcx_per_atom
  real(kind=DP),private,allocatable,dimension(:)       :: etotal_per_atom

! -----  for FFT  -----

  real(kind=DP),allocatable,dimension(:)               :: wf_EDA        ! <- wavefunction in reciprocal space
  real(kind=DP),allocatable,dimension(:)               :: wf_kin_EDA    ! <- |k+G|^2 * |k+G>
  real(kind=DP),allocatable,dimension(:)               :: wf_hartr_EDA  ! <- 4pi*rho(G)/|G|^2 * |k+G>

! -----  Parameters of G-vectors  -----

  real(kind=DP),private,allocatable,dimension(:,:,:)   :: ekin_l
  real(kind=DP),private,allocatable,dimension(:,:,:)   :: ehartr_l
  real(kind=DP),private,allocatable,dimension(:,:)     :: elocal_l

! -----  Others  -----
  real(kind=DP),dimension(6)                           :: ttl

contains

  subroutine m_PW_EDA_allocation
    allocate(afft(nfftp_nonpara))
    allocate(bfft1(nfftp_nonpara))
    allocate(bfft2(nfftp_nonpara))
    call m_FFT_alloc_CD_box()
  end subroutine m_PW_EDA_allocation

  subroutine m_PW_EDA_deallocation
    deallocate(afft)
    deallocate(bfft1)
    deallocate(bfft2)
!   call m_FFT_dealloc_CD_box()
  end subroutine m_PW_EDA_deallocation

  subroutine execute_PlaneWaveEDA
    use m_IterationNumbers, only : iteration, first_iteration_of_this_job

    call tstatc_init
    call write_headermark_of_PW_EDA

       WRITE(6,*) 'before_Partitioning_Function'
    call before_Partitioning_Function                                         ! <- set Becke's space-partitioning function

       WRITE(6,*) 'set_partition_function'
    call set_partition_function

       WRITE(6,*) 'Each_Energy_Term'
    call Each_Energy_Term                                               ! <- calculating each energy term per atom

       WRITE(6,*) 'write_energies_per_atom'
    call write_energies_per_atom

    call write_endmark_of_PW_EDA
    call tstatc_iter(iteration, first_iteration_of_this_job)
    call tstatc_wd(iteration)

  end subroutine execute_PlaneWaveEDA

!-------------------------------------------------------------------------------
!   >>>>> preparing partitioning function >>>>>
!-------------------------------------------------------------------------------

  subroutine before_Partitioning_Function

!-------------------------------------------------------------------------------
!   1. set Bragg-Slater radii for all atoms
!       - subroutine set_bragg_slater_radii
!
!   2. set inverse matrix of rltv for calculating atom-center coordinates in G-space
!       - subroutine inverse_matrix
!
!   3. set aij: determined only by Bragg-Slater radii
!       - subroutine set_aij
!
!   4. set grid points in G-space, which are the same those used in FFT and
!      calculate partitioning function on each grid.
!       - subroutine set_grid_points
!-------------------------------------------------------------------------------

    allocate(bragg_slater_radii(137))
    call set_bragg_slater_radii

    call inverse_matrix(rltv,rltv_inverse)

    allocate(aij(natm2,natm2))
    call set_aij

    ifxr_CD = fft_box_size_CD_nonpara(1,0)
    ifyr_CD = fft_box_size_CD_nonpara(2,0)
    ifzr_CD = fft_box_size_CD_nonpara(3,0)

    grid_weight_CD = 1.d0/(dble(product(fft_box_size_CD_nonpara(1:3,0))))

    allocate(r_catom(natm2,3), cps_new(natm2,3), &
       &     grid_x_CD(ifxr_CD+1), grid_y_CD(ifyr_CD+1), grid_z_CD(ifzr_CD+1), &
       &     partition_function(ifxr_CD+1,ifyr_CD+1,ifzr_CD+1,natm2), partition_function_on_a_grid(natm2,nfftp_nonpara))

    call set_grid_points

 contains
      subroutine set_bragg_slater_radii

        real(kind=DP),dimension(137)               :: BSR_work

!-----------------------------------------------------------------------
!     Bragg-Slater radii for determining the relative size of the
!     polyhedra in the polyatomic integration scheme
!-----------------------------------------------------------------------

        data BSR_work  /0.35d0, 0.31d0, 1.45d0, 1.05d0, 0.85d0,  &
                     &  0.70d0, 0.65d0, 0.60d0, 0.50d0, 0.38d0,  &
                     &  1.80d0, 1.50d0, 1.25d0, 1.10d0, 1.00d0,  &
                     &  1.00d0, 1.00d0, 0.71d0, 2.20d0, 1.80d0,  &
                     &  1.60d0, 1.40d0, 1.35d0, 1.40d0, 1.40d0,  &
                     &  1.40d0, 1.35d0, 1.35d0, 1.35d0, 1.35d0,  &
                     &  1.30d0, 1.25d0, 1.15d0, 1.15d0, 1.15d0,  &
                     &  0.88d0, 2.35d0, 2.00d0, 1.80d0, 1.55d0,  &
                     &  1.45d0, 1.45d0, 1.35d0, 1.30d0, 1.35d0,  &
                     &  1.40d0, 1.60d0, 1.55d0, 1.55d0, 1.45d0,  &
                     &  1.45d0, 1.40d0, 1.40d0, 1.08d0, 2.60d0,  &
                     &  2.15d0, 1.95d0, 1.85d0, 1.85d0, 1.85d0,  &
                     &  1.85d0, 1.85d0, 1.85d0, 1.80d0, 1.75d0,  &
                     &  1.75d0, 1.75d0, 1.75d0, 1.75d0, 1.75d0,  &
                     &  1.75d0, 1.55d0, 1.45d0, 1.35d0, 1.35d0,  &
                     &  1.30d0, 1.35d0, 1.35d0, 1.35d0, 1.50d0,  &
                     &  1.90d0, 1.80d0, 1.60d0, 1.90d0, 1.27d0,  &
                     &  1.20d0, 2.60d0, 2.15d0, 1.95d0, 1.80d0,  &
                     &  1.75d0, 1.75d0, 1.75d0, 1.75d0, 1.75d0,  &
                     &  1.75d0, 1.75d0, 1.75d0, 1.75d0, 1.75d0,  &
                     &  1.75d0, 1.75d0, 1.75d0, 1.75d0, 1.75d0,  &
                     &  1.75d0, 1.75d0, 1.75d0, 1.75d0, 1.75d0,  &
                     &  1.75d0, 1.75d0, 1.75d0, 1.75d0, 1.75d0,  &
                     &  1.75d0, 1.75d0, 1.75d0, 1.75d0, 1.75d0,  &
                     &  1.75d0, 1.75d0, 1.75d0, 1.75d0, 1.75d0,  &
                     &  1.75d0, 1.75d0, 1.75d0, 1.75d0, 1.75d0,  &
                     &  1.75d0, 1.75d0, 1.75d0, 1.75d0, 1.75d0,  &
                     &  1.75d0, 1.75d0/

        bragg_slater_radii = BSR_work

      end subroutine set_bragg_slater_radii

      subroutine set_aij()

        real(kind=DP)                              :: aij_work
        integer                                    :: iatm, jatm
        real(kind=DP)                              :: chi, chi2

        IatmLoop: do iatm = 1, natm2
          JatmLoop: do jatm = 1, natm2

            chi  = bragg_slater_radii(iatomn_EDA(iatm))/bragg_slater_radii(iatomn_EDA(jatm))
            chi2 = (chi-1.d0)/(chi+1.d0)
            aij_work = chi2/(chi2*chi2-1.d0)

            if(aij_work > 0.5d0) then
              aij_work =  0.5d0
            elseif(aij_work < -0.5d0) then
              aij_work = -0.5d0
            endif

            aij(iatm,jatm) = aij_work

          enddo JatmLoop
        enddo IatmLoop

      end subroutine set_aij

      subroutine set_grid_points

        call calculate_ttl

        call internal_vector                                            ! <- internal vector of atomic centers

        call packuc_EDA                                                 ! <- packing atoms in the unit cell

        call determine_grid_points

      end subroutine set_grid_points

      subroutine calculate_ttl                                          ! <- subroutine calttl in b_Ldos_f77.F

        integer                                      :: i, j, jj

        ttl = 0.d0

        do j = 1, 3
          jj = mod(j+1,3)
          if(jj == 0) jj = 3

          do i = 1, 3
            ttl(j) = ttl(j) + altv(i,j)*altv(i,j)
            ttl(j+3) = ttl(j+3) + 2.d0*altv(i,j)*altv(i,jj)
          enddo
        enddo

      end subroutine calculate_ttl

      subroutine internal_vector

        real(kind=DP),dimension(3)                   :: r_catom_work
        real(kind=DP)                                :: pi2
        integer                                      :: i, j, k

!-----------------------------------------------------------------------
!     r_catom is internal vector of atomic centers
!-----------------------------------------------------------------------

        pi2 = 8.d0*datan(1.d0)

        do i = 1, natm2
          do j = 1, 3
            r_catom_work = 0.d0

            do k = 1, 3
              r_catom_work(j) = r_catom_work(j) + rltv(k,j)*cps(i,k)/pi2
            enddo
            r_catom(i,j) = r_catom_work(j)
          enddo
        enddo

      end subroutine internal_vector

      subroutine packuc_EDA                                             ! <- subroutine packuc in b_Ldos_f77.F

        integer                                      :: i, j, n

        do j = 1, 3
          do i = 1, natm2
            n = r_catom(i,j)
            r_catom(i,j) = r_catom(i,j) - n

            if(r_catom(i,j) < 0.d0) r_catom(i,j) = r_catom(i,j) + 1.d0
          enddo
        enddo

      end subroutine packuc_EDA

      subroutine determine_grid_points()

        integer                                      :: ix, iy, iz
        real(kind=DP)                                :: dx, dy, dz

        dx = 1.d0/dble(ifxr_CD)
        dy = 1.d0/dble(ifyr_CD)
        dz = 1.d0/dble(ifzr_CD)

        do ix = 1, ifxr_CD+1
          grid_x_CD(ix) = dx * (ix-1)
        enddo

        do iy = 1, ifyr_CD+1
          grid_y_CD(iy) = dy * (iy-1)
        enddo

        do iz = 1, ifzr_CD+1
          grid_z_CD(iz) = dz * (iz-1)
        enddo

      end subroutine determine_grid_points
  end subroutine before_Partitioning_Function

  subroutine set_partition_function()

    real(kind=DP)                                :: total
    integer                                      :: ix, iy, iz, j, mm
    integer                                      :: iix, iixmax, iiy, iiymax, iiz, iizmax &
                                                & , ijx, ijxmin, ijxmax &
                                                & , ijy, ijymin, ijymax &
                                                & , ijz, ijzmin, ijzmax
    integer, parameter                           :: cell_range = 3  ! cell_range must be odd number
    integer                                      :: cell_range2, center
    integer                                      :: next_to_center_x, next_to_center_y, next_to_center_z
    integer                                      :: icell1,  cell1_x,  cell1_y,  cell1_z &
                                                & , icellj,  cellj_x,  cellj_y,  cellj_z
    integer, dimension(natm2,3)                  :: edge_or_not
    integer                                      :: iatm, jatm, jmax
    integer                                      :: key
    integer                                      :: iteration
    real(kind=DP)                                :: ri, rj, rij
    real(kind=DP)                                :: xmuij, zmuij, f2, f4, cutij, cutji
    real(kind=DP)                                :: x_flag, y_flag, z_flag
    real(kind=DP), dimension(natm2,2,2,2)        :: pA
    real(kind=DP), dimension(3)                  :: mesh
    real(kind=DP), dimension(3)                  :: r_catom_wk_i, r_catom_wk_j
    integer                                      :: nsize, ig, nx, ny, nz, ierr
    integer                                      :: id_sname = -1
    call tstatc0_begin('set_partition_function ',id_sname,1)

    call determine_edge_or_not(edge_or_not)
    cell_range2 = cell_range/2
    center = cell_range**3/2 + 1

    next_to_center_x = cell_range2 + 2 + (cell_range2    )*cell_range + (cell_range2    )*cell_range**2
    next_to_center_y = cell_range2 + 1 + (cell_range2 + 1)*cell_range + (cell_range2    )*cell_range**2
    next_to_center_z = cell_range2 + 1 + (cell_range2    )*cell_range + (cell_range2 + 1)*cell_range**2

    mesh = 0.d0
    nx = ifxr_CD+1
    ny = ifyr_CD+1
    nz = ifzr_CD+1
    nsize = nx*ny*nz
    partition_function = 0.d0
    do ig=1, nsize
      if(mod(ig,npes)/=mype) cycle
      iz = (ig-1)/(nx*ny)+1
      mm = mod(ig,nx*ny)
      if(mm==0) mm=nx*ny
      iy = (mm-1)/nx+1
      ix = mod(mm,nx)
      if(ix==0) ix=nx

!    do iz = 1, ifzr_CD+1
      z_flag = 1.d0
      if(iz == 1 .or. iz == ifzr_CD+1) z_flag = 0.5d0

!    do iy = 1, ifyr_CD+1
      y_flag = 1.d0
      if(iy == 1 .or. iy == ifyr_CD+1) y_flag = 0.5d0

!    do ix = 1, ifxr_CD+1
      x_flag = 1.d0
      if(ix == 1 .or. ix == ifxr_CD+1) x_flag = 0.5d0

!-----------------------------------------------------------------------
!     grids in the center cell
!-----------------------------------------------------------------------
      do icell1 = 1, cell_range**3
        call flush(0)
        call cell_xyz(cell_range,icell1,cell1_x,cell1_y,cell1_z)

        mesh(1) = grid_x_CD(ix) + dble(cell1_x)
        mesh(2) = grid_y_CD(iy) + dble(cell1_y)
        mesh(3) = grid_z_CD(iz) + dble(cell1_z)

! ----- Setting atom i ( i must be in the center cell.)

        call set_pA(pA,edge_or_not)

        IatomLoop: do iatm = 1, natm2

          if(abs(aij(iatm,1)+1.d0) < 1.d-05) then
            pA(iatm,:,:,:) = 0.d0
            cycle IatomLoop
          endif

! ----- Distance between the grid point and the center of atom i

          do iiz = 1, edge_or_not(iatm,3)
            r_catom_wk_i(3) = r_catom(iatm,3) + dble(iiz - 1)
          do iiy = 1, edge_or_not(iatm,2)
            r_catom_wk_i(2) = r_catom(iatm,2) + dble(iiy - 1)
          do iix = 1, edge_or_not(iatm,1)
            r_catom_wk_i(1) = r_catom(iatm,1) + dble(iix - 1)

            call set_r(ri,r_catom_wk_i,mesh)

! ----- Setting atom j (i and j do not exist in the same cell.)

          do icellj = 1, cell_range**3
            if(icellj < center) then
              key = 1
              call cell_xyz(cell_range,icellj,cellj_x,cellj_y,cellj_z)
              jmax = natm2
            elseif(icellj == center) then
              key = 2
              cellj_x = 0; cellj_y = 0; cellj_z = 0

              if(product(edge_or_not(iatm,1:3)) == 1) then
                jmax = iatm - 1
              else
                jmax = iatm
              endif
            else
              key = 3
              call cell_xyz(cell_range,icellj,cellj_x,cellj_y,cellj_z)
              jmax = natm2
            endif

            JatomLoop: do jatm = 1, jmax

! ----- Avoid the case that atom j matches the edge atom of center cell

              ijxmin = 1; ijymin = 1; ijzmin = 1

              if(key == 3) then
                if(edge_or_not(jatm,1) == 2 .and. icellj == next_to_center_x) ijxmin = 2
                if(edge_or_not(jatm,2) == 2 .and. icellj == next_to_center_y) ijymin = 2
                if(edge_or_not(jatm,3) == 2 .and. icellj == next_to_center_z) ijzmin = 2
              endif

! ----- Consider edge atom only if the calculated cell is rightest.

              ijxmax = 1; ijymax = 1; ijzmax = 1

              if(key /= 2) then
                if(cellj_x == cell_range2) ijxmax = edge_or_not(jatm,1)
                if(cellj_y == cell_range2) ijymax = edge_or_not(jatm,2)
                if(cellj_z == cell_range2) ijzmax = edge_or_not(jatm,3)
              endif

! ----- Distance between the grid point and the center of atom i

              do ijz = ijzmin, ijzmax
                r_catom_wk_j(3) = r_catom(jatm,3) + dble(cellj_z) + dble(ijz - 1)
              do ijy = ijymin, ijymax
                r_catom_wk_j(2) = r_catom(jatm,2) + dble(cellj_y) + dble(ijy - 1)
              do ijx = ijxmin, ijxmax
                r_catom_wk_j(1) = r_catom(jatm,1) + dble(cellj_x) + dble(ijx - 1)

                if(abs(aij(iatm,jatm)-1.d0) < 1.d-05) then
                  cutij = 1.d0
                  cutji = 1.d0
                  go to 3
                endif

                call set_r(rj,r_catom_wk_j,mesh)
                call set_r(rij,r_catom_wk_i,r_catom_wk_j)  ! <- distance between the centers of atom i and j
                if(rij == 0.d0) cycle

! ----- Becke's fuzzy cell method for molecular grid quadrature

                zmuij = (ri-rj)/rij
                xmuij = zmuij + aij(iatm,jatm)*(1.d0-zmuij*zmuij)

                f4 = xmuij

                do iteration = 1, 4
                  f4 = f4*(1.5d0 - 0.5d0*f4*f4)
                enddo

                f2    = 0.5d0*f4
                cutij = 0.5d0-f2
                cutji = 0.5d0+f2

 3              pA(iatm,iix,iiy,iiz) = pA(iatm,iix,iiy,iiz)*cutij
                if(key == 2) then
                   pA(jatm,ijx,ijy,ijz) = pA(jatm,ijx,ijy,ijz)*cutji
                endif

              enddo
              enddo
              enddo
            enddo JatomLoop

          enddo

          enddo
          enddo
          enddo
        enddo IatomLoop
!        total = 0.d0
        do iatm = 1, natm2
          do iiz = 1, edge_or_not(iatm,3)
            do iiy = 1, edge_or_not(iatm,2)
              do iix = 1, edge_or_not(iatm,1)
                partition_function(ix,iy,iz,iatm) = partition_function(ix,iy,iz,iatm) &
                                                & + pA(iatm,iix,iiy,iiz)/dble(product(edge_or_not(iatm,1:3)))
!                total = total + pA(iatm,iix,iiy,iiz)/dble(product(edge_or_not(iatm,1:3)))
              enddo
            enddo
          enddo
        enddo

      enddo

!      total = 0.d0
      total = sum(partition_function(ix,iy,iz,1:natm2))
      partition_function(ix,iy,iz,:) = x_flag*y_flag*z_flag*partition_function(ix,iy,iz,:)/total

!    enddo
!    enddo
    enddo
    call mpi_allreduce(mpi_in_place, partition_function, nsize*natm2, mpi_double_precision, mpi_sum, MPI_CommGroup, ierr)
    call tstatc0_end(id_sname)
  end subroutine set_partition_function

  subroutine determine_edge_or_not(edge_or_not)

    integer, intent(out), dimension(natm2,3)   :: edge_or_not
    integer                                    :: iatm1, j

    do iatm1 = 1, natm2
      do j = 1, 3
        if(abs(r_catom(iatm1,j)) < 1.d-8) then
          edge_or_not(iatm1,j) = 2
        else
          edge_or_not(iatm1,j) = 1
        endif
      enddo
    enddo

  end subroutine determine_edge_or_not

  subroutine cell_xyz(cell_range,icell,cellx,celly,cellz)

    integer, intent(in)                          :: cell_range, icell
    integer, intent(out)                         :: cellx, celly, cellz
    integer                                      :: half_range
    integer                                      :: i0, i1, i2, i3, j, k

    half_range = cell_range/2 + 1

    i0 = mod(icell,cell_range)
    if(i0 .lt. 1) i0 = cell_range
    i1 = i0 - half_range

    j = (icell - i1)/cell_range
    i2 = mod(j,cell_range) + 1 - half_range

    k = (icell - i1 - (i2-1)*cell_range)/cell_range**2
    i3 = k + 1 - half_range

    cellx = i1; celly = i2; cellz = i3

  end subroutine cell_xyz

  subroutine set_pA(pA,edge_or_not)

    real(kind=DP), intent(out)                   :: pA(natm2,2,2,2)
    integer, intent(in)                          :: edge_or_not(natm2,3)
    integer                                      :: iatm1

    pA = 1.d0
    do iatm1 = 1, natm2
      if(edge_or_not(iatm1,1) == 2) then
        pA(iatm1,2,:,:) = pA(iatm1,2,:,:) * 1.d0
      else
        pA(iatm1,2,:,:) = pA(iatm1,2,:,:) * 0.d0
      endif
      if(edge_or_not(iatm1,2) == 2) then
        pA(iatm1,:,2,:) = pA(iatm1,:,2,:) * 1.d0
      else
        pA(iatm1,:,2,:) = pA(iatm1,:,2,:) * 0.d0
      endif
      if(edge_or_not(iatm1,3) == 2) then
        pA(iatm1,:,:,2) = pA(iatm1,:,:,2) * 1.d0
      else
        pA(iatm1,:,:,2) = pA(iatm1,:,:,2) * 0.d0
      endif
    enddo

  end subroutine set_pA

  subroutine set_r(r,point_1,point_2)

    real(kind=DP), intent(out)                   :: r
    real(kind=DP), intent(in)                    :: point_1(3), point_2(3)
    integer                                      :: j, k
    real(kind=DP), dimension(3)                  :: cps_1(3), cps_2(3)
    real(kind=DP)                                :: r_sqrd
    real(kind=DP)                                :: pi2

    pi2 = 8.d0*datan(1.d0)
    cps_1 = 0.d0; cps_2 = 0.d0

    do j = 1, 3
      do k = 1, 3
        cps_1(j) = cps_1(j) + pi2*point_1(k)*rltv_inverse(k,j)
        cps_2(j) = cps_2(j) + pi2*point_2(k)*rltv_inverse(k,j)
      enddo
    enddo

    r_sqrd = (cps_1(1) - cps_2(1))**2 &
         & + (cps_1(2) - cps_2(2))**2 &
         & + (cps_1(3) - cps_2(3))**2

    r = dsqrt(r_sqrd)

  end subroutine set_r

!------------------------------------------------------------------------------
!   >>>>> calculating each energy terms
!------------------------------------------------------------------------------

  subroutine Each_Energy_Term

!------------------------------------------------------------------------------
!   Etotal = Ekin + Ehartree + Exc + Elocal + Enonlocal
!
!   energies obtained in G-space: kinetic energy
!                                 hartree(coulomb) energy
!                                 local energy
!     - these terms are calculated in G-space and then
!       transformed into R-space expression by FFT.
!
!   energies obtained in R-space: exchange-correlation energy
!
!------------------------------------------------------------------------------

    allocate(density_per_atom(natm2)); density_per_atom = 0.d0
    call calculate_density_per_atom

    allocate(ekin_per_atom(natm2)); ekin_per_atom = 0.d0
    call calculate_kinetic_energy_per_atom

    allocate(ehartr_per_atom(natm2)); ehartr_per_atom = 0.d0
    call calculate_hartree_energy_per_atom

    allocate(exc_per_atom(natm2)); exc_per_atom = 0.d0
    call calculate_exchange_correlation_energy_per_atom

    allocate(elocal_per_atom(natm2)); elocal_per_atom = 0.d0
    call calculate_local_energy_per_atom

    allocate(enonlocal_per_atom(natm2)); enonlocal_per_atom = 0.d0
    call calculate_nonlocal_energy_per_atom

    allocate(epcx_per_atom(natm2)); epcx_per_atom = 0.d0
    call calculate_partial_core_xc_energy_per_atom

    allocate(etotal_per_atom(natm2)); etotal_per_atom = 0.d0
    call calculate_total_energy_per_atom

 contains
    subroutine calculate_density_per_atom

      integer                                    :: ispin, ib, ik, ifft, ri, iend, igp, ip, i1, iloop
      integer                                    :: iatm, ix, iy, iz
      real(kind=DP)                              :: fac, total
      integer                                    :: ierr
      integer                                    :: id_sname = -1
      call tstatc0_begin('calculate_density_per_atom ',id_sname,1)

!     allocate(density_on_a_grid(nfftp)); density_on_a_grid = 0.d0
        afft = 0.d0
!     call m_FFT_alloc_CD_box()

      do ispin = 1, nspin
        do ri = 1, kimg
          do igp = ista_kngp, iend_kngp
            ip = (igfp_nonpara(igp)-1)*kimg + ri
            afft(ip) = afft(ip) &
                                & + univol*chgq_l(igp,ri,ispin)
          enddo
        enddo
      enddo

      call mpi_allreduce(mpi_in_place, afft, nfftp_nonpara, mpi_double_precision &
      &                 ,mpi_sum, mpi_chg_world, ierr)
      call m_FFT_CD_inverse0(nfout,afft)
      total = 0.d0
      do igp = 1, nfftp_nonpara
        total = total + afft(igp)
      enddo

      call partition_into_atoms(afft,density_per_atom)

!     deallocate(density_on_a_grid)
      call m_FFT_dealloc_CD_box()

      call tstatc0_end(id_sname)

    end subroutine calculate_density_per_atom

    subroutine calculate_kinetic_energy_per_atom
      integer                                    :: ispin, ib, ik, ifft, ri, iend, igp, i, i1, ierr
      integer                                    :: ig
      real(kind=DP)                              :: fac
      integer                                    :: nfft
      real(kind=DP), allocatable, dimension(:,:) :: zajtmp
      integer(kind=DP)                           :: plan
      integer, parameter                         :: FFTW_MEASURE=0
      integer                                    :: id_sname = -1
      call tstatc0_begin('calculate_kinetic_energy_per_atom ',id_sname,1)

      allocate(zajtmp(kg1,kimg))
      call m_FFT_alloc_WF_work()

      nfft = product(fft_box_size_WF(1:3,0)) * kimg
      allocate(wf_EDA(nfft))
      allocate(wf_kin_EDA(nfft))

      allocate(ekin_on_a_grid(nfft)); ekin_on_a_grid = 0.d0
      allocate(ekin_l(ista_kngp:iend_kngp,kimg,nspin)); ekin_l = 0.d0

!-----------------------------------------------------------------------
!               1                i
!     Ekin(G) = -*sigma[|k+G|^2*c  ^2]
!               2  i,k           k+G
!-----------------------------------------------------------------------
      do ispin = 1, nspin, af+1
         ekin_on_a_grid = 0.0d0             ! added by ASMS 2024/03/19

         do ik = ispin, kv3+ispin-nspin, nspin
            if(map_k(ik) /= myrank_k) cycle                               ! MPI
            do ib = 1, neg
               if(map_e(ib) /= myrank_e) cycle
               !if(map_e(ib) /= myrank_e) cycle
               !if(map_ek(ib,ik) /= myrank_ke) cycle
               zajtmp = 0.d0
               do ig=ista_g1k(ik),iend_g1k(ik)
                  zajtmp(ig,:) = zaj_l(ig-ista_g1k(ik)+1,map_z(ib),ik,:)
               enddo
               call mpi_allreduce(mpi_in_place, zajtmp, kg1*kimg, mpi_double_precision, mpi_sum, mpi_ke_world, ierr)
               call map_zaj_to_fft_box(ik, kg1, nfft, zajtmp, wf_EDA)
               call m_FFT_WF(ELECTRON, nfout, wf_EDA, INVERSE, ON)
               call m_ES_WF_kin_in_Rspace(ik,ib,wf_kin_EDA,zajtmp)                  ! <- |k+G|^2*exp(-i(k+G)*r)
               do ifft = 1, nfft-1, 2
                  ekin_on_a_grid(ifft) = ekin_on_a_grid(ifft) &
                       &    + occup_l(map_z(ib),ik) &
                       &    *(wf_EDA(ifft)*wf_kin_EDA(ifft)+wf_EDA(ifft+1)*wf_kin_EDA(ifft+1))
               enddo
            enddo
         enddo
         
         call mpi_allreduce(mpi_in_place, ekin_on_a_grid, nfft, mpi_double_precision, &
              &                  mpi_sum, mpi_kg_world, ierr)
         call mpi_allreduce(mpi_in_place, ekin_on_a_grid, nfft, mpi_double_precision, &
              &                  mpi_sum, mpi_ge_world, ierr)
         call m_FFT_WF(ELECTRON,nfout,ekin_on_a_grid,DIRECT,OFF)
         
         fac = 2.d0/(kv3*product(fft_box_size_WF(1:3,1)))
         
         do ri = 1, kimg
            iend = iend_kngp
            if( iend_kngp > kg ) iend = kg
            if( ista_kngp <= iend ) then
               do igp = ista_kngp, iend                                    ! MPI
                  i1 = kimg*igf(igp) + (ri - kimg)
                  ekin_l(igp,ri,ispin) = ekin_on_a_grid(i1)*fac             ! <- Ekin(G)
               enddo
            endif
         enddo
      enddo
      
      call m_FFT_dealloc_WF_work()
      deallocate(wf_EDA); deallocate(wf_kin_EDA)
      deallocate(zajtmp)

      deallocate(ekin_on_a_grid)
!      allocate(ekin_on_a_grid(nfftp)); ekin_on_a_grid = 0.d0
      allocate(ekin_on_a_grid(nfftp_nonpara)); ekin_on_a_grid = 0.d0
      call m_FFT_alloc_CD_box()

      ekin_on_a_grid = 0.d0
      do ispin = 1, nspin
         do ri = 1, kimg
            do igp = ista_kngp, iend_kngp
               i1 = kimg*igfp_nonpara(igp) + (ri - kimg)
               ekin_on_a_grid(i1) = ekin_on_a_grid(i1) + ekin_l(igp,ri,ispin)
            enddo
         enddo
      enddo
      call mpi_allreduce(mpi_in_place, ekin_on_a_grid, nfftp_nonpara, mpi_double_precision, mpi_sum, &
      &                  mpi_ke_world, ierr)

      call m_FFT_CD_inverse0(nfout,ekin_on_a_grid)                    ! <- Ekin(G) --> Ekin(r)
      call partition_into_atoms(ekin_on_a_grid,ekin_per_atom)

      deallocate(ekin_l)
      deallocate(ekin_on_a_grid)
      call m_FFT_dealloc_CD_box()
      call tstatc0_end(id_sname)


    end subroutine calculate_kinetic_energy_per_atom

    subroutine map_zaj_to_fft_box(ik,kg1,nfft,psi_l,bfft)
      integer, intent(in):: ik,kg1,nfft
      real(kind=DP), dimension(kg1,kimg), intent(in) :: psi_l
      real(kind=DP), dimension(nfft), intent(out) :: bfft
      integer :: i,i1,ri, j, i2, ii
      integer :: id_sname2=-1
      call tstatc0_begin('map_zaj_to_fft_box ',id_sname2)

      bfft = 0.d0
      if(k_symmetry(ik) == GAMMA) then
         if(kimg == 1) then
            i1 = igf(1)
            bfft(i1) = psi_l(1,1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
            do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
               i = nbase(ii,ik)
               i1 = igf(i)
               bfft(i1) = psi_l(ii,1)
               j = nbase_gamma(ii,2)
               i2 = igf(j)
               bfft(i2) =   psi_l(ii,1)
            end do
         else if(kimg == 2) then
            i1 = 2*igf(1) - 1
            bfft(i1)   = psi_l(1,1)
            bfft(i1+1) = psi_l(1,2)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
            do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
               i = nbase(ii,ik)
               i1 = 2*igf(i)-1
               bfft(i1  ) = psi_l(ii,1)
               bfft(i1+1) = psi_l(ii,2)
               j = nbase_gamma(ii,2)
               i2 = 2*igf(j)-1
               bfft(i2  ) = psi_l(ii,1)
               bfft(i2+1) = -psi_l(ii,2)
            end do
         end if
      else
#ifdef NEC_TUNE_SMP
!CDIR NOLOOPCHG
#endif
         do ri = 1, kimg
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
            do i = 1, iba(ik)
               i1 = kimg*igf(nbase(i,ik)) + (ri - kimg)
               bfft(i1) = psi_l(i,ri)   ! MPI
            end do
         end do
      end if
    end subroutine map_zaj_to_fft_box

    subroutine calculate_hartree_energy_per_atom

!-----------------------------------------------------------------------
!                   4pi            rho(G)*rho(-G)
!     Ehartree(G) = --- * V     *  --------------   (G /= 0)
!                    2     cell         |G|^2
!-----------------------------------------------------------------------

      integer                                    :: ispin, ri, igp, ip, ierr
      integer, parameter                         :: UP = 1, DOWN = 2
      real(kind=DP)                              :: pi
      integer                                    :: id_sname = -1
      call tstatc0_begin('calculate_hartree_energy_per_atom ',id_sname,1)
      allocate(density_on_a_grid(nfftp_nonpara)); density_on_a_grid = 0.d0
      allocate(ehartr_on_a_grid2(nfftp_nonpara)); ehartr_on_a_grid2 = 0.d0
      call m_FFT_alloc_CD_box()

      do ri = 1, kimg
        do igp = ista_kngp, iend_kngp
          ip = (igfp_nonpara(igp)-1)*kimg + ri
          if(nspin == 1) then
            density_on_a_grid(ip) = density_on_a_grid(ip) + chgq_l(igp,ri,UP)
            if(igp == 1) cycle
            ehartr_on_a_grid2(ip) = ehartr_on_a_grid2(ip) + chgq_l(igp,ri,UP)/gr_l(igp)**2
          elseif(nspin == 2) then
            density_on_a_grid(ip) = density_on_a_grid(ip) + (chgq_l(igp,ri,UP)+chgq_l(igp,ri,DOWN))
            if(igp == 1) cycle
            ehartr_on_a_grid2(ip) = ehartr_on_a_grid2(ip) + (chgq_l(igp,ri,UP)+chgq_l(igp,ri,DOWN))/gr_l(igp)**2
          endif
        enddo
      enddo

      call mpi_allreduce(mpi_in_place, ehartr_on_a_grid2, nfftp_nonpara, mpi_double_precision &
      &                 ,mpi_sum, mpi_chg_world, ierr)
      call mpi_allreduce(mpi_in_place, density_on_a_grid, nfftp_nonpara, mpi_double_precision &
      &                 ,mpi_sum, mpi_chg_world, ierr)

      call m_FFT_CD_inverse0(nfout,density_on_a_grid)
      call m_FFT_CD_inverse0(nfout,ehartr_on_a_grid2)
!      call m_FFT_CD_inverse_ascat(nfout,ehartr_on_a_grid2)
!     call m_FFT_CD_direct0(nfout,ehartr_on_a_grid2)

      allocate(ehartr_on_a_grid(nfftp_nonpara)); ehartr_on_a_grid = 0.d0

      pi = 4.d0*datan(1.d0)

      do ip = 1, nfftp_nonpara
        ehartr_on_a_grid(ip) = 4.d0*pi*univol*0.5d0*density_on_a_grid(ip)*ehartr_on_a_grid2(ip)
      enddo

      call partition_into_atoms(ehartr_on_a_grid,ehartr_per_atom)

      deallocate(ehartr_on_a_grid)
      deallocate(ehartr_on_a_grid2)
      deallocate(density_on_a_grid)
      call m_FFT_dealloc_CD_box()
      call tstatc0_end(id_sname)
    end subroutine calculate_hartree_energy_per_atom

    subroutine calculate_exchange_correlation_energy_per_atom
      integer :: id_sname = -1
      call tstatc0_begin('calculate_exchange_correlation_energy_per_atom ',id_sname,1)
      call m_XC_cal_potential(nfout,Valence_plus_PC_Charge,chgq_l,EXC_ONLY)
      call partition_into_atoms(exc_on_a_grid,exc_per_atom)                 ! exc_on_a_grid -> m_XC_Potential
      call tstatc0_end(id_sname)
    end subroutine calculate_exchange_correlation_energy_per_atom

    subroutine calculate_local_energy_per_atom

!-----------------------------------------------------------------------
!                          atom                     local
!   Elocal = V     * sigma sigma rho(G)*exp(-iGR )*V(G)   + totch*etot1
!             cell   G/=0    A                  A   A
!-----------------------------------------------------------------------

      integer                                    :: ri, ip, igp, ispin, it, iatm, i, ierr
      integer, parameter                         :: UP = 1, DOWN = 2
      integer                                    :: id_sname = -1

      call tstatc0_begin('calculate_local_energy_per_atom ',id_sname,1)

!-----------------------------------------------------------------------
!     partition totch*etot1
!-----------------------------------------------------------------------

      allocate(elocal_on_a_grid1(nfftp_nonpara)); elocal_on_a_grid1 = 0.d0
      call m_FFT_alloc_CD_box()

      do ispin = 1, nspin
        do ri = 1, kimg
          do igp = ista_kngp, iend_kngp
            ip = (igfp_nonpara(igp)-1)*kimg + ri
            elocal_on_a_grid1(ip) = elocal_on_a_grid1(ip) & ! from electron
                                & + 0.5d0*etot1*univol*chgq_l(igp,ri,ispin)
                                                      !~~~~~~~~~~~~~~~~~~~~~~~~
          enddo
        enddo
      enddo

      call mpi_allreduce(mpi_in_place, elocal_on_a_grid1, nfftp_nonpara, mpi_double_precision &
      &                 ,mpi_sum, mpi_chg_world, ierr)
      call m_FFT_CD_inverse0(nfout,elocal_on_a_grid1)

      allocate(elocal_from_nucleus1(natm2)); elocal_from_nucleus1 = 0.d0

      do iatm = 1, natm2
        elocal_from_nucleus1(iatm) = elocal_from_nucleus1(iatm) & ! from nuclei
                                 & + 0.5d0*totch*PP_per_atom(ityp(iatm))/dble(icount_EDA(ityp(iatm)))
!                                               ~~~~~~~~~~~~~~~~~~~~~~~~
      enddo

!-----------------------------------------------------------------------
!     partition main part
!-----------------------------------------------------------------------

      allocate(density_on_a_grid(nfftp_nonpara)); density_on_a_grid = 0.d0

      do ispin = 1, nspin
        do ri = 1, kimg
          do igp = ista_kngp, iend_kngp
            ip = (igfp_nonpara(igp)-1)*kimg + ri
            density_on_a_grid(ip) = density_on_a_grid(ip) + chgq_l(igp,ri,ispin)
          enddo
        enddo
      enddo
      call mpi_allreduce(mpi_in_place, density_on_a_grid, nfftp_nonpara, mpi_double_precision &
      &                 ,mpi_sum, mpi_chg_world, ierr)

      call m_FFT_CD_inverse0(nfout,density_on_a_grid)

      allocate(PP_on_a_grid_wk(nfftp_nonpara)); PP_on_a_grid_wk = 0.d0

! ---> ASMS mod 2024/03/19
!!!      allocate(PP_on_a_grid(nfftp_nonpara,natm2)); PP_on_a_grid = 0.d0
      allocate(elocal_on_a_grid2(nfftp)); elocal_on_a_grid2 = 0.d0
      allocate(elocal_from_nucleus2(natm2)); elocal_from_nucleus2 = 0.d0
! <--- ASMS mod 2024/03/19

      do iatm = 1, natm2
        it = ityp(iatm)
        PP_on_a_grid_wk = 0.d0
        do ri = 1, kimg
          do igp = ista_kngp, iend_kngp
            ip = (igfp_nonpara(igp)-1)*kimg + ri
           !PP_on_a_grid_wk(ip) = PP_on_a_grid_wk(ip) + (-1.d0)**(ri-1)*psc_l(igp,it)*zfm3_l_EDA(igp,iatm,ri)
            PP_on_a_grid_wk(ip) = PP_on_a_grid_wk(ip) + psc_l(igp,it)*zfm3_l_EDA(igp,iatm,ri)
          enddo
        enddo
!        call m_FFT_CD_inverse_ascat(nfout,PP_on_a_grid_wk)
        call mpi_allreduce(mpi_in_place, PP_on_a_grid_wk, nfftp_nonpara, mpi_double_precision &
        &                 ,mpi_sum, mpi_chg_world, ierr)
        call m_FFT_CD_inverse0(nfout,PP_on_a_grid_wk)

! ---> ASMS mod 2024/03/19 
!!        PP_on_a_grid(:,iatm) = PP_on_a_grid_wk(:)
        do i = 1, nfftp_nonpara
           elocal_on_a_grid2(i) = elocal_on_a_grid2(i) &
                & + 0.5d0*univol*density_on_a_grid(i)*PP_on_a_grid_wk(i)
           elocal_from_nucleus2(iatm) = elocal_from_nucleus2(iatm) &
                &           + 0.5d0*univol*density_on_a_grid(i)*PP_on_a_grid_wk(i)
        enddo
! <--- ASMS mod 2024/03/19 

      enddo

      deallocate(PP_on_a_grid_wk)

! ---> ASMS mod 2024/03/19 
!      allocate(elocal_on_a_grid2(nfftp_nonpara)); elocal_on_a_grid2 = 0.d0
!      allocate(elocal_from_nucleus2(natm2)); elocal_from_nucleus2 = 0.d0
!
!      do iatm = 1, natm
!        do i = 1, nfftp_nonpara
!          elocal_on_a_grid2(i) = elocal_on_a_grid2(i) &
!                             & + 0.5d0*univol*density_on_a_grid(i)*PP_on_a_grid(i,iatm)
!          elocal_from_nucleus2(iatm) = elocal_from_nucleus2(iatm) &
!                                   & + 0.5d0*univol*density_on_a_grid(i)*PP_on_a_grid(i,iatm)
!        enddo
!      enddo
!      deallocate(PP_on_a_grid)
! <--- ASMS mod 2024/03/19 

      deallocate(density_on_a_grid)
      allocate(elocal_on_a_grid(nfftp_nonpara)); elocal_on_a_grid = 0.d0
      elocal_on_a_grid = elocal_on_a_grid1 + elocal_on_a_grid2

      deallocate(elocal_on_a_grid1)
      deallocate(elocal_on_a_grid2)
      allocate(elocal_per_atom_from_electron(natm2)); elocal_per_atom_from_electron = 0.d0

      call partition_into_atoms(elocal_on_a_grid,elocal_per_atom_from_electron)

      elocal_per_atom = elocal_per_atom_from_electron + elocal_from_nucleus1 + &
      &                 elocal_from_nucleus2/dble(product(fft_box_size_CD_nonpara(1:3,0)))

      deallocate(elocal_per_atom_from_electron)
      deallocate(elocal_on_a_grid)
      deallocate(elocal_from_nucleus1)
      deallocate(elocal_from_nucleus2)
      call m_FFT_dealloc_CD_box()
      call tstatc0_end(id_sname)

    end subroutine calculate_local_energy_per_atom

    subroutine calculate_nonlocal_energy_per_atom

      integer                                    :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, iatm
      real(kind=DP)                              :: fac
      integer                                    :: id_sname = -1

!-----------------------------------------------------------------------
!                 natom              A,ion  occ   A,i*    A,i
!     Enonlocal = sigma sigma sigma D      sigma f     * f
!                   A     lm   tt'   tt'l   i,k   tlmk    t'lmk
!
!          ion
!       - D    , f are defined by Vanderbilt's ultrasoft potential
!
!-----------------------------------------------------------------------

      call tstatc0_begin('calculate_nonlocal_energy_per_atom ',id_sname,1)

      do ispin = 1, nspin, af+1
        do it = 1, ntyp
          do lmt1 = 1, ilmt(it)
            il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
            do lmt2 = lmt1, ilmt(it)
              il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
              if( il1 /= il2 .or. im1 /= im2) cycle
              do iatm = 1, natm
                if(ityp(iatm) /= it) cycle
                fac = 2.d0*iwei(iatm); if(lmt1 == lmt2) fac = fac*0.5d0
                enonlocal_per_atom(iatm) = enonlocal_per_atom(iatm) &
                                       & + fac*dion(lmt1,lmt2,it)*hsr(iatm,lmt1,lmt2,ispin)
              end do
            end do
          end do
        end do
      end do

      enonlocal_per_atom = enonlocal_per_atom*(af+1)
      call tstatc0_end(id_sname)
    end subroutine calculate_nonlocal_energy_per_atom

    subroutine calculate_partial_core_xc_energy_per_atom

      integer                                    :: iatm
      integer :: id_sname = -1
      call tstatc0_begin('calculate_partial_core_xc_energy_per_atom ',id_sname,1)

      do iatm = 1, natm2
        epcx_per_atom(iatm) = -epc_per_atom(ityp(iatm))/dble(icount_EDA(ityp(iatm)))
      enddo
      call tstatc0_end(id_sname)
    end subroutine calculate_partial_core_xc_energy_per_atom

    subroutine calculate_total_energy_per_atom

      integer                                    :: iatm
      integer                                    :: id_sname = -1
      call tstatc0_begin('calculate_total_energy_per_atom ',id_sname,1)

      do iatm = 1, natm2
        etotal_per_atom(iatm) = etotal_per_atom(iatm)    &
                            & + ekin_per_atom(iatm)      &
                            & + ehartr_per_atom(iatm)    &
                            & + exc_per_atom(iatm)       &
                            & + elocal_per_atom(iatm)    &
                            & + enonlocal_per_atom(iatm) &
                            & + eewald_per_atom(iatm)    &
                            & + epcx_per_atom(iatm)
      enddo
      call tstatc0_end(id_sname)

    end subroutine calculate_total_energy_per_atom

  end subroutine Each_Energy_Term

!------------------------------------------------------------------------------
!   >>>>> partitioning subroutines >>>>>
!------------------------------------------------------------------------------

    subroutine partition_into_atoms(afft_on_a_grid,afft_per_atom)

      integer                                    :: id, mm, nl, nm, nn, nlhf, inew, jnew, knew
      integer                                    :: iatm, ix, iy, iz, ix2, iy2, iz2, ixnew, iynew, iznew, i1
      real(kind=DP),intent(in),dimension(nfftp_nonpara)  :: afft_on_a_grid
      real(kind=DP),intent(out),dimension(natm2) :: afft_per_atom
      integer :: id_sname = -1
      call tstatc0_begin('partition_into_atoms ',id_sname,1)

      id = fft_box_size_CD_nonpara(1,0)
      mm = fft_box_size_CD_nonpara(2,0)
      nl = fft_box_size_CD_nonpara(1,0)
      nm = fft_box_size_CD_nonpara(2,0)
      nn = fft_box_size_CD_nonpara(3,0)

      nlhf = id

      do iz2 = 1, ifzr_CD+1                                              ! ifzr_CD = nn
        iz = iz2
        if(iz2 == ifzr_CD+1) iz = 1

        do iy2 = 1, ifyr_CD+1                                            ! ifyr_CD = nm
          iy = iy2
          if(iy2 == ifyr_CD+1) iy = 1

          do ix2 = 1, ifxr_CD+1                                          ! ifxr_CD = nl
            ix = ix2
            if(ix2 == ifxr_CD+1) ix = 1

            if(kimg == 1 .and. ix > nlhf) then
              ixnew = id - ix
              iynew = nm + 2 - iy
              iznew = nn + 2 - iz

              if(iynew > nm) then
                iynew = iynew - nm
              endif
              if(iznew > nn) then
                iznew = iznew - nn
              endif

            else
              ixnew = ix; iynew = iy; iznew = iz
            end if

            i1 = ixnew + nlhf*mm*(iznew-1) + nlhf*(iynew-1)

            do iatm = 1, natm2
              afft_per_atom(iatm) = afft_per_atom(iatm) &
                                & + grid_weight_CD*partition_function(ix2,iy2,iz2,iatm) &
                                & * (afft_on_a_grid(i1*2-1)+afft_on_a_grid(i1*2))
            enddo
          enddo
        enddo
      enddo
      call tstatc0_end(id_sname)

    end subroutine partition_into_atoms

    subroutine write_energies_per_atom

      integer                                    :: iatm

      write(nfout,'("")')
      write(nfout,'(6x,"atom",8x,"density",8x,"kinetic",8x,"hartree",12x, &
      "exc",10x,"local",7x,"nonlocal",10x,"ewald",12x,"epc",10x,"total")')

      do iatm = 1, natm2
        write(nfout,'(i4,"  ",a4,9f15.7)') iatm, speciesname(ityp(iatm)), &
                                         & density_per_atom(iatm),        &
                                         & ekin_per_atom(iatm),           &
                                         & ehartr_per_atom(iatm),         &
                                         & exc_per_atom(iatm),            &
                                         & elocal_per_atom(iatm),         &
                                         & enonlocal_per_atom(iatm),      &
                                         & eewald_per_atom(iatm),         &
                                         & epcx_per_atom(iatm),           &
                                         & etotal_per_atom(iatm)
      enddo
      write(nfout,'("  total   ",9f15.7)') sum(density_per_atom(1:natm2)),   &
                                         & sum(ekin_per_atom(1:natm2)),      &
                                         & sum(ehartr_per_atom(1:natm2)),    &
                                         & sum(exc_per_atom(1:natm2)),       &
                                         & sum(elocal_per_atom(1:natm2)),    &
                                         & sum(enonlocal_per_atom(1:natm2)), &
                                         & sum(eewald_per_atom(1:natm2)),    &
                                         & sum(epcx_per_atom(1:natm2)),      &
                                         & sum(etotal_per_atom(1:natm2))

      write(nfout,'("")')

    end subroutine write_energies_per_atom

    subroutine inverse_matrix(matrix_in,matrix_out)

      real(kind=DP),intent(in),dimension(3,3)    :: matrix_in
      real(kind=DP),intent(out),dimension(3,3)   :: matrix_out
      real(kind=DP),dimension(3,6,4)             :: matrix_sweep
      real(kind=DP),dimension(3,6,4)             :: matrix_temp
      integer                                    :: i, j

!-----------------------------------------------------------------------
!     Due to symmetry, internal vectors of atomic centers are moved.
!     So inverse matrix of rltv is required  to obtain new real-space
!     coordinates of atomic centers.
!-----------------------------------------------------------------------

! -----  At first, matrix_sweep(:,i,1) (i=4,5,6) is identity matrix.  -----

      do i = 1, 3
        do j = 1, 3
          matrix_sweep(i,j,1) = matrix_in(i,j)
          if(i == j) then
            matrix_sweep(i,j+3,1) = 1.d0
          else
            matrix_sweep(i,j+3,1) = 0.d0
          endif
        enddo
      enddo

! -----  Sweep out matrix_in. In this procedure, matrix_sweeo becomes inverse matrix of matrix_in.  -----

      if(matrix_sweep(1,1,1) /= 0.d0) then
        matrix_sweep(1,:,2) = matrix_sweep(1,:,1)/matrix_sweep(1,1,1)
        matrix_sweep(2,:,2) = matrix_sweep(2,:,1) - matrix_sweep(2,1,1)/matrix_sweep(1,1,1)*matrix_sweep(1,:,1)
        matrix_sweep(3,:,2) = matrix_sweep(3,:,1) - matrix_sweep(3,1,1)/matrix_sweep(1,1,1)*matrix_sweep(1,:,1)

        if(matrix_sweep(2,2,2) /= 0.d0) then
          matrix_sweep(1,:,3) = matrix_sweep(1,:,2) - matrix_sweep(1,2,2)/matrix_sweep(2,2,2)*matrix_sweep(2,:,2)
          matrix_sweep(2,:,3) = matrix_sweep(2,:,2)/matrix_sweep(2,2,2)
          matrix_sweep(3,:,3) = matrix_sweep(3,:,2) - matrix_sweep(3,2,2)/matrix_sweep(2,2,2)*matrix_sweep(2,:,2)

          if(matrix_sweep(3,3,3) /= 0.d0) then
            matrix_sweep(1,:,4) = matrix_sweep(1,:,3) - matrix_sweep(1,3,3)/matrix_sweep(3,3,3)*matrix_sweep(3,:,3)
            matrix_sweep(2,:,4) = matrix_sweep(2,:,3) - matrix_sweep(2,3,3)/matrix_sweep(3,3,3)*matrix_sweep(3,:,3)
            matrix_sweep(3,:,4) = matrix_sweep(3,:,3)/matrix_sweep(3,3,3)

            go to 2
          else
            go to 1
          endif

        elseif(matrix_sweep(3,2,2) /= 0.d0) then

          matrix_temp(2,:,2)  = matrix_sweep(2,:,2)
          matrix_temp(3,:,2)  = matrix_sweep(3,:,2)
          matrix_sweep(2,:,2) = matrix_temp(3,:,2)
          matrix_sweep(3,:,2) = matrix_temp(2,:,2)

          matrix_sweep(1,:,3) = matrix_sweep(1,:,2) - matrix_sweep(1,2,2)/matrix_sweep(2,2,2)*matrix_sweep(2,:,2)
          matrix_sweep(2,:,3) = matrix_sweep(2,:,2)/matrix_sweep(2,2,2)
          matrix_sweep(3,:,3) = matrix_sweep(3,:,2) - matrix_sweep(3,2,2)/matrix_sweep(2,2,2)*matrix_sweep(2,:,2)

          if(matrix_sweep(3,3,3) /= 0.d0) then
            matrix_sweep(1,:,4) = matrix_sweep(1,:,3) - matrix_sweep(1,3,3)/matrix_sweep(3,3,3)*matrix_sweep(3,:,3)
            matrix_sweep(2,:,4) = matrix_sweep(2,:,3) - matrix_sweep(2,3,3)/matrix_sweep(3,3,3)*matrix_sweep(3,:,3)
            matrix_sweep(3,:,4) = matrix_sweep(3,:,3)/matrix_sweep(3,3,3)

            go to 2
          else
            go to 1
          endif
        endif

      elseif(matrix_sweep(2,1,1) /= 0.d0 .and. matrix_sweep(1,2,1) /= 0.d0) then

        matrix_temp(1,:,1)  = matrix_sweep(1,:,1)
        matrix_temp(2,:,1)  = matrix_sweep(2,:,1)
        matrix_sweep(1,:,1) = matrix_temp(2,:,1)
        matrix_sweep(2,:,1) = matrix_temp(1,:,1)

        matrix_sweep(1,:,2) = matrix_sweep(1,:,1)/matrix_sweep(1,1,1)
        matrix_sweep(2,:,2) = matrix_sweep(2,:,1) - matrix_sweep(2,1,1)/matrix_sweep(1,1,1)*matrix_sweep(1,:,1)
        matrix_sweep(3,:,2) = matrix_sweep(3,:,1) - matrix_sweep(3,1,1)/matrix_sweep(1,1,1)*matrix_sweep(1,:,1)

!       if(matrix_sweep(2,2,2) /= 0.d0) then
          matrix_sweep(1,:,3) = matrix_sweep(1,:,2) - matrix_sweep(1,2,2)/matrix_sweep(2,2,2)*matrix_sweep(2,:,2)
          matrix_sweep(2,:,3) = matrix_sweep(2,:,2)/matrix_sweep(2,2,2)
          matrix_sweep(3,:,3) = matrix_sweep(3,:,2) - matrix_sweep(3,2,2)/matrix_sweep(2,2,2)*matrix_sweep(2,:,2)

          if(matrix_sweep(3,3,3) /= 0.d0) then
            matrix_sweep(1,:,4) = matrix_sweep(1,:,3) - matrix_sweep(1,3,3)/matrix_sweep(3,3,3)*matrix_sweep(3,:,3)
            matrix_sweep(2,:,4) = matrix_sweep(2,:,3) - matrix_sweep(2,3,3)/matrix_sweep(3,3,3)*matrix_sweep(3,:,3)
            matrix_sweep(3,:,4) = matrix_sweep(3,:,3)/matrix_sweep(3,3,3)

            go to 2
          else
            go to 1
          endif

      elseif(matrix_sweep(3,1,1) /= 0.d0 .and. matrix_sweep(1,2,1) /= 0.d0) then

        matrix_temp(1,:,1)  = matrix_sweep(1,:,1)
        matrix_temp(3,:,1)  = matrix_sweep(3,:,1)
        matrix_sweep(1,:,1) = matrix_temp(3,:,1)
        matrix_sweep(3,:,1) = matrix_temp(1,:,1)

        matrix_sweep(1,:,2) = matrix_sweep(1,:,1)/matrix_sweep(1,1,1)
        matrix_sweep(2,:,2) = matrix_sweep(2,:,1) - matrix_sweep(2,1,1)/matrix_sweep(1,1,1)*matrix_sweep(1,:,1)
        matrix_sweep(3,:,2) = matrix_sweep(3,:,1) - matrix_sweep(3,1,1)/matrix_sweep(1,1,1)*matrix_sweep(1,:,1)

!       if(matrix_sweep(2,2,2) /= 0.d0) then
          matrix_sweep(1,:,3) = matrix_sweep(1,:,2) - matrix_sweep(1,2,2)/matrix_sweep(2,2,2)*matrix_sweep(2,:,2)
          matrix_sweep(2,:,3) = matrix_sweep(2,:,2)/matrix_sweep(2,2,2)
          matrix_sweep(3,:,3) = matrix_sweep(3,:,2) - matrix_sweep(3,2,2)/matrix_sweep(2,2,2)*matrix_sweep(2,:,2)

          if(matrix_sweep(3,3,3) /= 0.d0) then
            matrix_sweep(1,:,4) = matrix_sweep(1,:,3) - matrix_sweep(1,3,3)/matrix_sweep(3,3,3)*matrix_sweep(3,:,3)
            matrix_sweep(2,:,4) = matrix_sweep(2,:,3) - matrix_sweep(2,3,3)/matrix_sweep(3,3,3)*matrix_sweep(3,:,3)
            matrix_sweep(3,:,4) = matrix_sweep(3,:,3)/matrix_sweep(3,3,3)

            go to 2
          else
            go to 1
          endif

      endif

 1    write(nfout,'("Inverse matrix of this matrix does not exist")')

 2    do i = 1, 3
        matrix_out(:,i) = matrix_sweep(:,i+3,4)
      enddo

    end subroutine inverse_matrix

    subroutine write_headermark_of_PW_EDA

      write(nfout,'("")')
      write(nfout,'("=====   Start of Plane-wave EDA  (by ascat)   =====")')
      write(nfout,'("")')

    end subroutine write_headermark_of_PW_EDA

    subroutine write_endmark_of_PW_EDA

      write(nfout,'("")')
      write(nfout,'("=====   End of Plane-wave EDA  (by ascat)   =====")')
      write(nfout,'("")')

    end subroutine write_endmark_of_PW_EDA
#endif

end module m_PlaneWaveEDA

module m_Realspace
  use m_Const_Parameters,     only : DP, SOFTPART, HARDPART
  use m_PlaneWaveBasisSet,    only : kgp,kg1,ngabc
  use m_Crystal_Structure,    only : altv,univol
  use m_Ionic_System,         only : ntyp,pos,natm,ityp,iwei
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,   only : kimg,iprirs,printable,r0_factor,r0_factor_q
  use m_FFT,                  only : fft_box_size_WF,fft_box_size_CD,fft_box_size_CD_nonpara
  use m_Files,                only : nfout
  use m_PseudoPotential,      only : mmesh,nmesh,rmax,radr,wos,xh,ilmt,nqitg_sp &
  &                                , m_PP_tell_lmtt_l_m_tau, betar,qrspspw,il2p &
  &                                , ltp,taup,lmta,iqitg,m_PP_find_maximum_l    &
  &                                , isph, dl2p
  use m_Parallelization,      only : m_Parallel_init_mpi_rspace_aug

  use m_Const_Parameters,     only : ON
  use m_Control_Parameters,   only : sw_rspace_ekin_density
  use m_PseudoPotential,      only : wf_mnrc

  implicit none

  integer                                      :: nmesh_rs_max
  integer                                      :: nmesh_rs_max_h
  integer, allocatable, target, dimension(:)   :: nmesh_rs
  integer, allocatable, target, dimension(:)   :: nmesh_rs_h
  integer, allocatable, target, dimension(:,:) :: meshx_rs
  integer, allocatable, target, dimension(:,:) :: meshy_rs
  integer, allocatable, target, dimension(:,:) :: meshz_rs
  integer, allocatable, target, dimension(:,:) :: meshxyz_rs
  integer, allocatable, target, dimension(:,:) :: meshxyz_rs_h
  integer, allocatable, target, dimension(:,:) :: map_h
  integer, allocatable, target, dimension(:,:) :: map_h_i
  integer, allocatable, target, dimension(:,:) :: meshxyz_rs_conjg

  integer                                      :: nmesh_rs_aug_max
  integer                                      :: nmesh_rs_aug_max_h
  integer, allocatable, target, dimension(:)   :: nmesh_rs_aug
  integer, allocatable, target, dimension(:)   :: nmesh_rs_aug_h
  integer, allocatable, target, dimension(:,:) :: meshx_rs_aug
  integer, allocatable, target, dimension(:,:) :: meshy_rs_aug
  integer, allocatable, target, dimension(:,:) :: meshz_rs_aug
  integer, allocatable, target, dimension(:,:) :: meshxyz_rs_aug
  integer, allocatable, target, dimension(:,:) :: meshxyz_rs_aug_h
  integer, allocatable, target, dimension(:,:) :: map_aug_h
  integer, allocatable, target, dimension(:,:) :: map_aug_h_i
  integer, allocatable, target, dimension(:,:) :: meshxyz_rs_aug_conjg

  integer :: neix=2
  integer :: neiy=2
  integer :: neiz=2

  real(kind=DP), allocatable, dimension(:) :: rcut_betar, rcut_betar_rs
  real(kind=DP), allocatable, dimension(:) :: rcut_qr, rcut_qr_rs

  real(kind=DP), allocatable, dimension(:,:,:) :: qr_clm_ylm
  real(kind=DP), allocatable, dimension(:,:,:,:) :: dqr_clm_ylm
  
  integer, allocatable, dimension(:)   :: nlmtpair
  integer, allocatable, dimension(:,:) :: plmt1,plmt2

  interface m_RS_resolve_mesh_hard
    module procedure resolve_mesh_hard
    module procedure resolve_mesh_hard0
    module procedure resolve_mesh_hard1
  end interface m_RS_resolve_mesh_hard

  interface m_RS_build_qr_clm_ylm
    module procedure build_qr_clm_ylm0
    module procedure build_qr_clm_ylm1
  end interface m_RS_build_qr_clm_ylm

  contains

  subroutine m_RS_get_coords(nffth,flg,fmg,fng,ilg,img,ing)
     integer, intent(in) :: nffth 
     real(kind=DP), dimension(nffth), intent(out) :: flg,fmg,fng
     integer, dimension(nffth), intent(out) :: ilg,img,ing
     integer :: id,mm,nl,nm,nn
     real(kind=DP) :: invnl,invnm,invnn
     integer :: inl,inm,inn
     integer :: nlhf,ig
     flg=0.d0;fmg=0.d0;fng=0.d0
     id = fft_box_size_WF(1,0)
     mm = fft_box_size_WF(2,0)
     nl = fft_box_size_WF(1,1)
     nm = fft_box_size_WF(2,1)
     nn = fft_box_size_WF(3,1)
     invnl = 1.d0/dble(nl)
     invnm = 1.d0/dble(nm)
     invnn = 1.d0/dble(nn)
     if(kimg==1)then
       nlhf = id/2
     else
       nlhf = id
     endif
     do inl=1,nl
        do inm=1,nm
           do inn=1,nn
              ig = nlhf*mm*(inn-1)+nlhf*(inm-1)+inl
              flg(ig) = dble(inl)*invnl
              fmg(ig) = dble(inm)*invnm
              fng(ig) = dble(inn)*invnn
              ilg(ig) = inl
              img(ig) = inm
              ing(ig) = inn
           enddo
        enddo
     enddo
  end subroutine m_RS_get_coords

  subroutine resolve_cutoff_betar(nfout)
     integer, intent(in) :: nfout
     integer :: it,lmt,ilmtt,il,im,tau,nspher,imesh,icut,icutmax
     real(kind=DP)      :: hn,babs,eps,eps0
     real(kind=DP)      :: r0max,r1max
     if(.not.allocated(rcut_betar)) allocate(rcut_betar(ntyp));rcut_betar = 0.d0
     if(.not.allocated(rcut_betar_rs)) allocate(rcut_betar_rs(ntyp));rcut_betar_rs = 0.d0
     do it=1,ntyp
        call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
        icutmax = -1
        do lmt=1,ilmt(it) 
           call m_PP_tell_lmtt_l_m_tau(lmt,it,ilmtt,il,im,tau,nspher)
           eps0 = 1.d0
           do imesh=nmesh(it),1,-1
              babs = abs(betar(imesh,il,tau,it))
              if(babs.eq.0.d0)then
                 eps = 1.d0
              else
                 eps = babs
              endif
              if(eps.gt.5.d0*eps0)then
                 if(babs.gt.1.d-10)then
                    if(imesh>=nmesh(it)-1)then
                       icut = imesh+1
                    else
                       icut = imesh+2
                    endif
                    exit
                 endif
              endif
              eps0 = eps
           enddo
           if(icutmax<icut)then
              icutmax = icut
           endif
        enddo
        rcut_betar(it) = radr(icutmax)
        rcut_betar_rs(it) = rcut_betar(it)*r0_factor
     enddo
     r0max=0.d0
     r1max=0.d0
     do it=1,ntyp
        if(r0max<rcut_betar(it))then
          r0max = rcut_betar(it)
        endif
     enddo
     !rcut_betar = r0max
     !rcut_betar_rs = r0max*r0_factor
     if(iprirs>=2.and.printable) then
       do it=1,ntyp
         write(nfout,'(a,i4,a,f10.5,a)') ' !RS cutoff for the projector of element           ',it,' : ',&
         & rcut_betar(it),' bohr'
         write(nfout,'(a,i4,a,f10.5,a)') ' !RS cutoff for the optimized projector of element ',it,' : ',&
         & rcut_betar_rs(it),' bohr'
       enddo
     endif
  end subroutine resolve_cutoff_betar

  subroutine resolve_cutoff_q(nfout)
     integer, intent(in) :: nfout
     integer :: it,lmt1,lmt2,np,iiqitg
     integer :: n,il1,tau1,ilmta1,il2,tau2,ilmta2,ilm3,l3
     integer :: imesh
     real(kind=DP) :: hn
     real(kind=DP),allocatable,dimension(:) :: radr
     real(kind=DP) :: rcut_tmp,qab,eps,eps0
     integer :: icut
     integer, allocatable :: il3(:)


     call m_PP_find_maximum_l(n)    ! n-1: maximum l
     n = (n-1) + (n-1) + 1
     allocate(il3(n**2))
     call substitute_il3(n**2,il3) ! -(b_Elec..)

     if(.not.allocated(rcut_qr)) allocate(rcut_qr(ntyp));rcut_qr=0.d0
     if(.not.allocated(rcut_qr_rs)) allocate(rcut_qr_rs(ntyp));rcut_qr_rs=0.d0
     allocate(radr(mmesh)) 
     do it=1,ntyp
        call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
        rcut_tmp = 0.d0
        do lmt1=1,ilmt(it)
           il1  = ltp( lmt1, it)
           tau1 = taup(lmt1, it)
           do lmt2=1,ilmt(it)
              if(il2p(lmt1,lmt2,it)==0) cycle
              il2  = ltp( lmt2, it)
              tau2 = taup(lmt2, it)
              do np = 1, il2p(lmt1,lmt2,it)
                 ilm3 = isph(lmt1,lmt2,np,it)
                 l3 = il3(ilm3)
                 if(lmt2>=lmt1) then
                   iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
                 else
                   iiqitg = iqitg(il2,tau2,il1,tau1,l3+1,it)
                 end if
                 if(iiqitg == 0) cycle
                 eps0 = 1.d0
                 do imesh=nmesh(it),1,-1
                    if(iprirs>=3) write(500+iiqitg,'(2f20.10)') radr(imesh),qrspspw(imesh,iiqitg)
                    qab = abs(qrspspw(imesh,iiqitg))
                    if(qab.eq.0.d0)then
                       eps = 1.d0
                    else
                       eps = qab
                    endif
                    if(eps.gt.5.d0*eps0)then
                       if(qab.gt.1.d-10)then
                          if(imesh>=nmesh(it)-1)then
                             icut = imesh+1
                          else
                             icut = imesh+2
                          endif
                          exit
                       endif
                    endif
                    eps0 = eps
                 enddo
                 if(radr(icut)>rcut_tmp) rcut_tmp = radr(icut)
              enddo
           enddo
        enddo
        rcut_qr(it) = rcut_tmp
        rcut_qr_rs(it) = rcut_tmp * r0_factor_q
        if(iprirs>=2) write(nfout,'(a,i5,a,f10.5,a)') &
        & ' !RS cutoff of the aug. function for element ',it,' : ',rcut_qr(it),' bohr'
     enddo
     deallocate(il3)
     deallocate(radr)
  end subroutine resolve_cutoff_q

  subroutine resolve_cutoff_ekin_density(nfout)
    integer, intent(in) :: nfout

    integer :: it
    real(kind=DP) :: hn, rcut_tmp
    real(kind=DP),allocatable,dimension(:) :: radr

    if(.not.allocated(rcut_qr)) allocate(rcut_qr(ntyp));rcut_qr=0.d0
    if(.not.allocated(rcut_qr_rs)) allocate(rcut_qr_rs(ntyp));rcut_qr_rs=0.d0
    allocate(radr(mmesh))

    do it=1,ntyp
       call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)

       rcut_tmp = radr( wf_mnrc(it) )
       rcut_qr(it) = rcut_tmp
       rcut_qr_rs(it) = rcut_tmp * r0_factor_q
    end do
    deallocate(radr)

  end subroutine resolve_cutoff_ekin_density

  subroutine resolve_mesh_hard(nfout)
     integer, intent(in) :: nfout
     call resolve_mesh_hard1(nfout,fft_box_size_CD,fft_box_size_CD_nonpara)
  end subroutine resolve_mesh_hard

  subroutine resolve_mesh_hard1(nfout,box_size,box_size_nonpara)
     integer, intent(in) :: nfout
     integer, dimension(3,0:1), intent(in) :: box_size
     integer, dimension(3,0:0), intent(in) :: box_size_nonpara
     integer :: nl,nm,nn,mm,id
     id = box_size_nonpara(1,0)
     mm = box_size_nonpara(2,0)
     nl = box_size(1,1)
     nm = box_size(2,1)
     nn = box_size(3,1)
     call resolve_mesh_hard0(nfout,id,mm,nl,nm,nn)
  end subroutine resolve_mesh_hard1

  subroutine resolve_mesh_hard0(nfout,id,mm,nl,nm,nn)
     integer, intent(in) :: nfout
     integer, intent(in) :: id,mm,nl,nm,nn
     real(kind=DP) :: ntot
     integer :: id_sname = -1
     logical,save :: firstcall=.true.
     call tstatc0_begin('m_RS_resolve_mesh_hard ',id_sname,1)
     if (firstcall) then
#if 1
        call resolve_cutoff_q(nfout)
#else
        if ( sw_rspace_ekin_density == ON ) then
           call resolve_cutoff_ekin_density(nfout)
        else
          call resolve_cutoff_q(nfout)
        endif
#endif
        if(.not.allocated(nmesh_rs_aug)) allocate(nmesh_rs_aug(natm))
        if(kimg==1) then
           if(.not.allocated(nmesh_rs_aug_h)) allocate(nmesh_rs_aug_h(natm))
        endif
     endif

     ntot = dble(nl*nm*nn)

     if(.not.firstcall)then
       call m_RS_dealloc_hard()
     endif
     nmesh_rs_aug=0 
     if(kimg==1) nmesh_rs_aug_h=0 
     call resolve_atom_centered_mesh(&
     & prealloc=.true.,mode=HARDPART,rcutr=rcut_qr_rs, &
     & id=id,mm=mm,nl=nl,nm=nm,nn=nn,maxcount=nmesh_rs_aug_max,maxcount_h=nmesh_rs_aug_max_h)
     allocate(meshx_rs_aug(nmesh_rs_aug_max,natm));meshx_rs_aug = -1
     allocate(meshy_rs_aug(nmesh_rs_aug_max,natm));meshy_rs_aug = -1
     allocate(meshz_rs_aug(nmesh_rs_aug_max,natm));meshz_rs_aug = -1
     allocate(meshxyz_rs_aug(nmesh_rs_aug_max,natm));meshxyz_rs_aug = -1

     if(kimg==1) then
        allocate(meshxyz_rs_aug_conjg(nmesh_rs_max,natm));meshxyz_rs_aug_conjg = 1
        allocate(meshxyz_rs_aug_h(nmesh_rs_max_h,natm));meshxyz_rs_aug_h = -1
        allocate(map_aug_h(nmesh_rs_aug_max_h,natm));map_aug_h = -1
        allocate(map_aug_h_i(nmesh_rs_aug_max,natm));map_aug_h_i = -1
     endif

     call resolve_atom_centered_mesh(prealloc=.false.,mode=HARDPART,rcutr=rcut_qr_rs,id=id,mm=mm,nl=nl,nm=nm,nn=nn)

     if(iprirs>=2.and.printable)then
         call print_mesh(ntot,HARDPART)
     endif
     firstcall = .false.

     call m_Parallel_init_mpi_rspace_aug(nfout,iprirs,printable,natm,nmesh_rs_aug)

     call tstatc0_end(id_sname)

  end subroutine resolve_mesh_hard0

  subroutine m_RS_resolve_mesh_soft(nfout)
     integer, intent(in) :: nfout
     integer :: nl,nm,nn,mm,id
     real(kind=DP) :: ntot
     integer :: id_sname = -1
     logical,save :: firstcall=.true.
     call tstatc0_begin('m_RS_resolve_mesh_soft ',id_sname,1)
     if (firstcall) then
        call resolve_cutoff_betar(nfout)
        if(.not.allocated(nmesh_rs)) allocate(nmesh_rs(natm))
        if(kimg==1) then
           if(.not.allocated(nmesh_rs_h)) allocate(nmesh_rs_h(natm))
        endif
     endif
     id = fft_box_size_WF(1,0)
     mm = fft_box_size_WF(2,0)
     nl = fft_box_size_WF(1,1)
     nm = fft_box_size_WF(2,1)
     nn = fft_box_size_WF(3,1)
     ntot = dble(nl*nm*nn)

     if(.not.firstcall)then
       call m_RS_dealloc_soft()
     endif
     nmesh_rs=0 
     if(kimg==1) nmesh_rs_h=0 
     call resolve_atom_centered_mesh(prealloc=.true.,mode=SOFTPART,rcutr=rcut_betar_rs,&
        & id=id,mm=mm,nl=nl,nm=nm,nn=nn,maxcount=nmesh_rs_max,maxcount_h=nmesh_rs_max_h)
     allocate(meshx_rs(nmesh_rs_max,natm));meshx_rs = -1
     allocate(meshy_rs(nmesh_rs_max,natm));meshy_rs = -1
     allocate(meshz_rs(nmesh_rs_max,natm));meshz_rs = -1
     allocate(meshxyz_rs(nmesh_rs_max,natm));meshxyz_rs = -1

     if(kimg==1) then
        allocate(meshxyz_rs_conjg(nmesh_rs_max,natm));meshxyz_rs_conjg = 1
        allocate(meshxyz_rs_h(nmesh_rs_max_h,natm));meshxyz_rs_h = -1
        allocate(map_h(nmesh_rs_max_h,natm));map_h = -1
        allocate(map_h_i(nmesh_rs_max,natm));map_h_i = -1
     endif

     call resolve_atom_centered_mesh(prealloc=.false.,mode=SOFTPART,rcutr=rcut_betar_rs,id=id,mm=mm,nl=nl,nm=nm,nn=nn)

     if(iprirs>=2.and.printable)then
         call print_mesh(ntot,SOFTPART)
     endif
     firstcall = .false.

     call tstatc0_end(id_sname)

  end subroutine m_RS_resolve_mesh_soft

  subroutine print_mesh(ntot,mode)
     real(kind=DP), intent(in) :: ntot
     integer :: mode
     integer :: ia,nm
     integer :: totnmesh
     integer,pointer,dimension(:) :: nmesh_rs_p
     integer,pointer,dimension(:,:) :: meshx_rs_p,meshy_rs_p,meshz_rs_p,meshxyz_rs_p
     if(mode==SOFTPART)then
        nmesh_rs_p => nmesh_rs
        meshx_rs_p => meshx_rs
        meshy_rs_p => meshy_rs
        meshz_rs_p => meshz_rs
        meshxyz_rs_p => meshxyz_rs
     else if(mode==HARDPART) then
        nmesh_rs_p => nmesh_rs_aug
        meshx_rs_p => meshx_rs_aug
        meshy_rs_p => meshy_rs_aug
        meshz_rs_p => meshz_rs_aug
        meshxyz_rs_p => meshxyz_rs_aug
     endif
     totnmesh = 0
     do ia=1,natm
        write(nfout,'(a,i0,a,i0)') ' !RS number of mesh points associated to atom ',ia,' : ',nmesh_rs_p(ia)
        if(iprirs>=3)then
          write(nfout,'(a)')              ' !RS associated mesh points ... '
          do nm = 1,nmesh_rs_p(ia)
              write(nfout,'(a,4i8)')      ' !RS ',meshx_rs_p(nm,ia),meshy_rs_p(nm,ia),meshz_rs_p(nm,ia),meshxyz_rs_p(nm,ia)
          enddo
        endif
        totnmesh = totnmesh+nmesh_rs_p(ia)
     enddo
     totnmesh = totnmesh/natm
     write(nfout,'(a,i0,a,i0,a,f10.5)') ' !RS average number of mesh points associated to an atom / total FFT mesh = ' &
     &     ,totnmesh,'/',int(ntot),' = ',dble(totnmesh)/ntot
  end subroutine print_mesh

  subroutine resolve_atom_centered_mesh(prealloc,mode,rcutr,id,mm,nl,nm,nn,maxcount,maxcount_h)
     logical, intent(in) :: prealloc
     integer, intent(in) :: mode
     real(kind=DP), dimension(ntyp), intent(in) :: rcutr
     integer, intent(in) :: id,mm,nl,nm,nn
     integer, optional, intent(out) :: maxcount,maxcount_h
     real(kind=DP) :: rcut_max,rcut,rcut2,rr,rcutmax
     real(kind=DP) :: ex,ey,ez
     integer :: nl_per_atm,nm_per_atm,nn_per_atm
     integer :: nnx,nny,nnz
     integer :: it,ia
     integer :: i1,j1,k1,ii1,jj1,kk1,iil,iim,iin,cl,cm,cn
     integer :: i1min,i1max,j1min,j1max,k1min,k1max
     integer :: icount,icounth
     real(kind=DP) :: fl,fm,fn
     real(kind=DP) :: dx,dy,dz,r2,r,cx,cy,cz
     integer :: maxc,maxch
     integer :: pm
     logical :: smallx,smally,smallz,tof
     real(kind=DP) :: inl,inm,inn,nlhf

     integer,pointer,dimension(:) :: nmesh_rs_p
     integer,pointer,dimension(:) :: nmesh_rs_h_p
     integer,pointer,dimension(:,:) :: meshx_rs_p
     integer,pointer,dimension(:,:) :: meshy_rs_p
     integer,pointer,dimension(:,:) :: meshz_rs_p
     integer,pointer,dimension(:,:) :: meshxyz_rs_p
     integer,pointer,dimension(:,:) :: meshxyz_rs_h_p
     integer,pointer,dimension(:,:) :: map_h_p
     integer,pointer,dimension(:,:) :: map_h_i_p
     integer,pointer,dimension(:,:) :: meshxyz_rs_conjg_p

     if(mode==SOFTPART)then
        nmesh_rs_p => nmesh_rs
        nmesh_rs_h_p => nmesh_rs_h
        meshx_rs_p => meshx_rs
        meshy_rs_p => meshy_rs
        meshz_rs_p => meshz_rs
        meshxyz_rs_p => meshxyz_rs
        meshxyz_rs_h_p => meshxyz_rs_h
        map_h_p => map_h
        map_h_i_p => map_h_i 
        meshxyz_rs_conjg_p => meshxyz_rs_conjg
     else if(mode==HARDPART)then
        nmesh_rs_p => nmesh_rs_aug
        nmesh_rs_h_p => nmesh_rs_aug_h
        meshx_rs_p => meshx_rs_aug
        meshy_rs_p => meshy_rs_aug
        meshz_rs_p => meshz_rs_aug
        meshxyz_rs_p => meshxyz_rs_aug
        meshxyz_rs_h_p => meshxyz_rs_aug_h
        map_h_p => map_aug_h
        map_h_i_p => map_aug_h_i 
        meshxyz_rs_conjg_p => meshxyz_rs_aug_conjg
     endif

     rcut_max = 0.d0
     do it=1,ntyp 
        if(rcut_max<rcutr(it)) rcut_max = rcutr(it)
     enddo

     inl = 1.d0/dble(nl)
     inm = 1.d0/dble(nm)
     inn = 1.d0/dble(nn)

     if(kimg==1)then
       nlhf = id/2
     else
       nlhf = id
     endif

     ex = neix * dsqrt(altv(1,1)**2+altv(1,2)**2+altv(1,3)**2)
     ey = neiy * dsqrt(altv(2,1)**2+altv(2,2)**2+altv(2,3)**2)
     ez = neiz * dsqrt(altv(3,1)**2+altv(3,2)**2+altv(3,3)**2)

     nnx = floor(ex/rcut_max)
     nny = floor(ey/rcut_max)
     nnz = floor(ez/rcut_max)
     smallx = nnx<2
     smally = nny<2
     smallz = nnz<2

     nl_per_atm = floor(dble((2*neix+1)*nl)/dble(nnx))+1
     nm_per_atm = floor(dble((2*neiy+1)*nm)/dble(nny))+1
     nn_per_atm = floor(dble((2*neiz+1)*nn)/dble(nnz))+1
     if(iprirs>=2)then
       write(nfout,'(a,3i8)') ' !RS number of fft elements surrounding an atom  : ', &
       & nl_per_atm,nm_per_atm,nn_per_atm
     endif
     maxc = 0
     if(kimg==1) maxch = 0
     do ia=1,natm
        if(smallx)then
           i1min = -nl*neix
           i1max = +nl*(neix+1)
        else
           cl = -neix*nl+floor((2*neix+1)*nl*dble(neix+pos(ia,1))/dble(2*neix+1))
           i1min = cl-nl_per_atm
           i1max = cl+nl_per_atm
        endif
        if(smally)then
           j1min = -nm*neiy
           j1max = +nm*(neiy+1)
        else
           cm = -neiy*nm+floor((2*neiy+1)*nm*dble(neiy+pos(ia,2))/dble(2*neiy+1))
           j1min = cm-nm_per_atm
           j1max = cm+nm_per_atm
        endif
        if(smallz)then
           k1min = -nn*neiz
           k1max = +nn*(neiz+1)
        else
           cn = -neiz*nn+floor((2*neiz+1)*nn*dble(neiz+pos(ia,3))/dble(2*neiz+1))
           k1min = cn-nn_per_atm
           k1max = cn+nn_per_atm
        endif
        if(iprirs>=2.and. .not. (smallx.or.smally.or.smallz)) &
        &  write(nfout,'(a,i8,a,3i8)') ' !RS center of mesh for atom ',ia,':',cl,cm,cn
        it = ityp(ia)
        rcut2=rcutr(it)*rcutr(it)
        icount = 0
        if(kimg==1) icounth = 0
        do i1=i1min,i1max
        do j1=j1min,j1max
        do k1=k1min,k1max
           iil = i1-1
           iim = j1-1
           iin = k1-1

           ii1 = mod(iil+(2*neix+1)*nl,nl)+1
           jj1 = mod(iim+(2*neiy+1)*nm,nm)+1
           kk1 = mod(iin+(2*neiz+1)*nn,nn)+1

           fl = dble(iil) * inl
           fm = dble(iim) * inm
           fn = dble(iin) * inn

           dx = fl-pos(ia,1)
           dy = fm-pos(ia,2)
           dz = fn-pos(ia,3)

           cx = altv(1,1)*dx+altv(1,2)*dy+altv(1,3)*dz
           cy = altv(2,1)*dx+altv(2,2)*dy+altv(2,3)*dz
           cz = altv(3,1)*dx+altv(3,2)*dy+altv(3,3)*dz
           r2 = cx*cx+cy*cy+cz*cz
           if(r2<rcut2)then
              tof = .false.
              icount = icount+1
              if(kimg==1.and.ii1<=nlhf) then
                 icounth = icounth+1
                 tof = .true.
              endif
              if(.not.prealloc)then
                 meshx_rs_p(icount,ia) = iil
                 meshy_rs_p(icount,ia) = iim
                 meshz_rs_p(icount,ia) = iin
                 if(kimg==1)then
                    if(ii1>nlhf)then
                       ii1 = id - ii1
                       jj1 = nm+2 - jj1
                       kk1 = nn+2 - kk1
                       if(jj1>nm) jj1 = jj1-nm
                       if(jj1.eq.0) jj1=1
                       if(kk1>nn) kk1 = kk1-nn
                       if(kk1.eq.0) kk1=1
                       pm = +1.0d0
                    else
                       pm = -1.d0
                    endif
                 endif
                 meshxyz_rs_p(icount,ia) = nlhf*mm*(kk1-1)+nlhf*(jj1-1)+ii1
                 if(kimg==1) then
                    meshxyz_rs_conjg_p(icount,ia) = pm
                    if(tof) then
                       meshxyz_rs_h_p(icounth,ia) = meshxyz_rs_p(icount,ia)
                       map_h_p(icounth,ia) = icount
                       map_h_i_p(icount,ia) = icounth
                    endif
                 endif
              endif
           endif
        enddo
        enddo
        enddo
        if(prealloc)then
          if(icount>maxc) maxc = icount
          nmesh_rs_p(ia) = icount
          if(kimg==1) then
             if(icounth>maxch) maxch = icounth
             nmesh_rs_h_p(ia) = icounth
          endif
        endif
     enddo
     if(prealloc.and.present(maxcount))then
        maxcount = maxc
     endif
     if(prealloc.and.kimg==1.and.present(maxcount_h))then
        maxcount_h = maxch
     endif
     
  end subroutine resolve_atom_centered_mesh

  subroutine m_RS_dealloc_soft()
     deallocate(meshx_rs)
     deallocate(meshy_rs)
     deallocate(meshz_rs)
     deallocate(meshxyz_rs)
     if(kimg==1) then
        deallocate(meshxyz_rs_h)
        deallocate(map_h)
        deallocate(map_h_i)
        deallocate(meshxyz_rs_conjg)
     endif
  end subroutine m_RS_dealloc_soft

  subroutine m_RS_dealloc_hard()
     deallocate(meshx_rs_aug)
     deallocate(meshy_rs_aug)
     deallocate(meshz_rs_aug)
     deallocate(meshxyz_rs_aug)
     if(kimg==1) then
        deallocate(meshxyz_rs_aug_h)
        deallocate(map_aug_h)
        deallocate(map_aug_h_i)
        deallocate(meshxyz_rs_aug_conjg)
     endif
  end subroutine m_RS_dealloc_hard

  subroutine m_RS_R_minus_pos(pos,ia,nma,inl,inm,inn,cx,cy,cz,rdiff,meshx,meshy,meshz)
     real(kind=DP), dimension(natm,3), intent(in) :: pos
     integer, intent(in) :: ia,nma
     real(kind=DP), intent(in) :: inl,inm,inn
     real(kind=DP), intent(out), dimension(nma) :: cx,cy,cz,rdiff
     integer, dimension(nma,natm), intent(in) :: meshx,meshy,meshz
     real(kind=DP) :: dx,dy,dz
     integer :: ii
     real(kind=DP) :: fl,fm,fn
     real(kind=DP) :: small_shift = 1.d-8
     cx=0.d0;cy=0.d0;cz=0.d0;rdiff=0.d0
     do ii=1,nma
        fl = dble(meshx(ii,ia))*inl
        fm = dble(meshy(ii,ia))*inm
        fn = dble(meshz(ii,ia))*inn
        dx = fl-pos(ia,1)
        dy = fm-pos(ia,2)
        dz = fn-pos(ia,3)
        cx(ii) = altv(1,1)*dx+altv(1,2)*dy+altv(1,3)*dz
        cy(ii) = altv(2,1)*dx+altv(2,2)*dy+altv(2,3)*dz
        cz(ii) = altv(3,1)*dx+altv(3,2)*dy+altv(3,3)*dz
        rdiff(ii) = dsqrt(cx(ii)*cx(ii)+cy(ii)*cy(ii)+cz(ii)*cz(ii))
        if(rdiff(ii).lt.1.d-15)then
           dx = fl-pos(ia,1)+small_shift
           dy = fm-pos(ia,2)+small_shift
           dz = fn-pos(ia,3)+small_shift
           cx(ii) = altv(1,1)*dx+altv(1,2)*dy+altv(1,3)*dz
           cy(ii) = altv(2,1)*dx+altv(2,2)*dy+altv(2,3)*dz
           cz(ii) = altv(3,1)*dx+altv(3,2)*dy+altv(3,3)*dz
           rdiff(ii) = dsqrt(cx(ii)*cx(ii)+cy(ii)*cy(ii)+cz(ii)*cz(ii))
        endif
     enddo
  end subroutine m_RS_R_minus_pos

  subroutine build_qr_clm_ylm1(deriv)
    logical, intent(in), optional :: deriv
    call build_qr_clm_ylm0(deriv,fft_box_size_CD)
  end subroutine build_qr_clm_ylm1

  subroutine build_qr_clm_ylm0(deriv,box_size)
    logical, intent(in), optional :: deriv
    integer, intent(in), dimension(3,0:1) :: box_size
    integer :: ia,it,lmt1,lmt2,np,imesh,iiqitg,lmtp
    integer :: il1,tau1,ilmta1,il2,tau2,ilmta2,l3,ilm3,n
    real(kind=DP) :: f0
    real(kind=DP), allocatable, dimension(:) :: qrsum
    real(kind=DP), allocatable, dimension(:,:) :: dqrsum
    real(kind=DP) :: inl,inm,inn
    real(kind=DP), allocatable, dimension(:) :: cx,cy,cz,rdiff
    real(kind=DP), allocatable, dimension(:) :: ylm
    real(kind=DP), allocatable, dimension(:,:) :: dylm
    real(kind=DP), allocatable, dimension(:) :: q2,qtmp
    real(kind=DP) :: hn,qq,dqq
    integer :: nma
    integer, allocatable :: il3(:)
    logical :: deri
    integer :: lmtcount
    integer :: id_sname=-1
    deri = .true.
    if(present(deriv))then
       deri = deriv
    endif

    call tstatc0_begin('m_RS_build_qr_clm_ylm ',id_sname,1)
    inl = 1.d0/dble(box_size(1,1))
    inm = 1.d0/dble(box_size(2,1))
    inn = 1.d0/dble(box_size(3,1))
    if(allocated(qrsum)) deallocate(qrsum)
    if(allocated(dqrsum)) deallocate(dqrsum)
    if(allocated(plmt1)) deallocate(plmt1)
    if(allocated(plmt2)) deallocate(plmt2)
    if(allocated(nlmtpair)) deallocate(nlmtpair)
    allocate(qrsum(nmesh_rs_aug_max));qrsum=0.d0
    if(deri) then
       allocate(dqrsum(nmesh_rs_aug_max,3));dqrsum=0.d0
    endif
    allocate(cx(nmesh_rs_aug_max));cx=0.d0
    allocate(cy(nmesh_rs_aug_max));cy=0.d0
    allocate(cz(nmesh_rs_aug_max));cz=0.d0
    allocate(rdiff(nmesh_rs_aug_max));rdiff=0.d0
    allocate(ylm(nmesh_rs_aug_max));ylm=0.d0
    if(deri) then
       allocate(dylm(nmesh_rs_aug_max,3));dylm=0.d0
    endif
    allocate(q2(mmesh));q2=0.d0
    allocate(qtmp(mmesh));qtmp=0.d0

    call m_PP_find_maximum_l(n)    ! n-1: maximum l
    n = (n-1) + (n-1) + 1
    allocate(il3(n**2))
    call substitute_il3(n**2,il3) ! -(b_Elec..)
    lmtcount=0
    allocate(nlmtpair(natm));nlmtpair=0
    do ia=1,natm
       it = ityp(ia)
       do lmt1=1,ilmt(it)
          do lmt2 = lmt1,ilmt(it)
             if(il2p(lmt1,lmt2,it)==0) cycle
             lmtcount = lmtcount+1
          enddo
       enddo
       nlmtpair(ia) = lmtcount
       lmtcount=0
    enddo
    allocate(plmt1(maxval(nlmtpair),natm));plmt1=0
    allocate(plmt2(maxval(nlmtpair),natm));plmt2=0
    lmtcount=0
    do ia=1,natm
       it = ityp(ia)
       do lmt1=1,ilmt(it)
          do lmt2 = lmt1,ilmt(it)
             if(il2p(lmt1,lmt2,it)==0) cycle
             lmtcount = lmtcount+1
             plmt1(lmtcount,ia) = lmt1
             plmt2(lmtcount,ia) = lmt2
          enddo
       enddo
       lmtcount=0
    enddo
    if(allocated(qr_clm_ylm)) deallocate(qr_clm_ylm)
    allocate(qr_clm_ylm(nmesh_rs_aug_max,natm,maxval(nlmtpair)));qr_clm_ylm=0.d0
    if(deri)then
       if(allocated(dqr_clm_ylm)) deallocate(dqr_clm_ylm)
       allocate(dqr_clm_ylm(nmesh_rs_aug_max,natm,maxval(nlmtpair),3));dqr_clm_ylm=0.d0
    endif
    do ia=1,natm
       it = ityp(ia)
       nma = nmesh_rs_aug(ia)
       call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
       call m_RS_R_minus_pos(pos,ia,nmesh_rs_aug_max,inl,inm,inn,cx,cy,cz,rdiff,meshx_rs_aug,meshy_rs_aug,meshz_rs_aug)
       do lmtp=1,nlmtpair(ia)
          lmt1 = plmt1(lmtp,ia)
          lmt2 = plmt2(lmtp,ia)
          il1  = ltp( lmt1, it)
          tau1 = taup(lmt1, it)
          ilmta1 = lmta(lmt1,ia)
          il2  = ltp( lmt2, it)
          tau2 = taup(lmt2, it)
          ilmta2 = lmta(lmt2,ia)
          qrsum=0.d0
          if(deri) dqrsum=0.d0
          do np=1,il2p(lmt1,lmt2,it)
             ilm3 = isph(lmt1,lmt2,np,it)
             l3 = il3(ilm3)
             if(lmt2>=lmt1) then
                iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
             else
                iiqitg = iqitg(il2,tau2,il1,tau1,l3+1,it)
             end if
             if(iiqitg == 0) cycle
             do imesh=1,nmesh(it)
                qtmp(imesh) = qrspspw(imesh,iiqitg)/radr(imesh)/radr(imesh)
             enddo
             call sphr_general(nma,ilm3,cx(1:nma),cy(1:nma),cz(1:nma),ylm(1:nma))
             if(deri) then
                call sphr_diff_general(nma,nma,ilm3,&
                     &                 cx(1:nma),cy(1:nma),cz(1:nma),dylm(1:nma,1:3))
             endif
             call init_cubic_spline(nmesh(it),radr(1:nmesh(it)),&
                  & qtmp(1:nmesh(it)),q2(1:nmesh(it)))
             f0 = iwei(ia) * dl2p(lmt1,lmt2,np,it)
             do imesh=1,nma
                call cubic_spline(nmesh(it),radr,qtmp(1:nmesh(it)),&
                     & q2(1:nmesh(it)),rdiff(imesh),qq,dqq)
                qrsum(imesh) = qrsum(imesh)+univol*f0*ylm(imesh)*qq
                if(deri)then
                  dqrsum(imesh,1) = dqrsum(imesh,1) &
                & -univol*f0*(ylm(imesh)*(dqq*cx(imesh)/rdiff(imesh))+qq*dylm(imesh,1))
                  dqrsum(imesh,2) = dqrsum(imesh,2) &
                & -univol*f0*(ylm(imesh)*(dqq*cy(imesh)/rdiff(imesh))+qq*dylm(imesh,2))
                  dqrsum(imesh,3) = dqrsum(imesh,3) &
                & -univol*f0*(ylm(imesh)*(dqq*cz(imesh)/rdiff(imesh))+qq*dylm(imesh,3))
                endif
             enddo
          enddo
          qr_clm_ylm(1:nma,ia,lmtp) = qrsum(1:nma)
          if(deri) dqr_clm_ylm(1:nma,ia,lmtp,1:3) = dqrsum(1:nma,1:3)
       enddo
    enddo
    deallocate(il3)
    deallocate(qrsum)
    if(deri) deallocate(dqrsum)
    deallocate(cx,cy,cz,rdiff,ylm,q2,qtmp)
    if(deri) deallocate(dylm)

    call tstatc0_end(id_sname)

  end subroutine build_qr_clm_ylm0

end module m_Realspace

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE:  readop, altv_2_rltv, string2values, inver3n,
!              matpr3, inver2n, gnrt_op, gnrt_op_n,
!              bravais2primitive, primitive2bravais
!
!  AUTHOR(S): T. Yamasaki, H. Mizouchi, H.Sawada, K. Betsuyaku
!
!                                                August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine readop(ipri,kopr,altv,nfout,nfopgr,nfmatbp,Iparas,nopr,op,tau,af)
! $Id: b_Crystal_Structure.f90 570 2017-04-21 20:34:50Z yamasaki $
!
!      read operation matrix OP(3,3,kopr) and TAU(3,kopr)
!      from the file 'opgr.data'
!     you must prepare the file 'matrix.BP'
!       ( translation matrix from Bravais lattice coodinates to Primitive one)
!
!     #1) antiferromagnetic calculation is added on 9th Jul. 1996
!                                          by H.Sawada
!     
!     #x1) <rplcps> is moved to <b_Ionic_System.f90>, Jun. 2003
!                                      by T. Yamasaki(FUJITSU LABORATORIES Ltd.)
!     #x2) <gnrt_on_n> is newly added, Jun. 2003
!                                      by T. Yamasaki(FUJITSU LABORATORIES Ltd.)
!**********************************************************************
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)                       :: ipri,kopr
  real(DP), intent(in),dimension(3,3)       :: altv
  integer, intent(in)                       :: nfout,nfopgr,nfmatbp,iparas
  integer, intent(out)                      :: nopr,af
  real(DP), intent(out),dimension(3,3,kopr) :: op
  real(DP), intent(out),dimension(3,kopr)   :: tau

  integer, parameter ::  PARAMETER_SET = 0 , PARAMETER_NO_SET = 1
!     work
  integer            :: nop(3,3,48),ii,jj,iop
  real(DP)           :: taub(3,48),br(3,3),brinv(3,3),trbp(3,3),trpb(3,3)
  real(DP)           :: cc(3,3),rop(3,3)

  rewind nfopgr
  rewind nfmatbp

!     make translation matrix  trpb (P -> B)
  do ii = 1,3
     read(nfmatbp,*)  trbp(ii,1),trbp(ii,2),trbp(ii,3)
  end do

  call inver3n(3,trbp,trpb)
  write(nfout,*) 'TR B->P'
  do ii = 1,3
     write(nfout,100) trbp(ii,1),trbp(ii,2),trbp(ii,3)
  end do

  write(nfout,*) 'TR P->B'
  do ii = 1,3
     write(nfout,100) trpb(ii,1),trpb(ii,2),trpb(ii,3)
  end do

  call matpr3(altv,trpb,br)
  write(nfout,*) 'Bravais lattice'
  write(nfout,100) (br(1,ii),ii=1,3)
  write(nfout,100) (br(2,ii),ii=1,3)
  write(nfout,100) (br(3,ii),ii=1,3)
100 format(8x,3f15.6)

  call inver3n(3,br,brinv)

  read(nfopgr,*) nopr
  if(nopr < 0) then
     nopr=-nopr
     af=1
  else
     af=0
  end if
  if(Iparas == PARAMETER_NO_SET) then
     do iop = 1,nopr
        read(nfopgr,*) taub(1,iop),taub(2,iop),taub(3,iop)
     end do

     do iop = 1,nopr
        read(nfopgr,*) ((nop(ii,jj,iop),ii=1,3),jj=1,3)
     end do
  else
     do iop = 1, nopr
        read(nfopgr,*)
     end do
     do iop = 1, nopr
        read(nfopgr,*)
     enddo
  end if

  if(Iparas == PARAMETER_SET) then
     if(af /= 0) then
        read(nfopgr,*) af
     end if
     goto 1000
  else
     if(af /= 0) then
        read(nfopgr,*) af
        if(ipri >= 1) then 
           write(nfout,*) ' ANTI-FERROMAGNETIC CALCULATION'
           write(nfout,'(41h NUMBER OF ANTI-FERROMAGNETIC OPERATOR = ,i3)') af
        end if
        do iop=nopr+1,nopr+af
           read(nfopgr,*) taub(1,iop),taub(2,iop),taub(3,iop)
        end do
        do iop = nopr+1,nopr+af
           read(nfopgr,*) ((nop(ii,jj,iop),ii=1,3),jj=1,3)
        end do
     end if
  end if

  if(nopr+af < kopr) then 
     write(nfout,*) 'Warning ! kopr should be ',nopr+af
  else if(nopr+af.gt.kopr) then
     write(nfout,*) 'ERROR ! kopr must be ',nopr+af
  end if

  if(IPRI >= 1) then 
     write(nfout,*) 'OPERATION MATRIX ( Bravais lattice )'
     do iop=1,nopr
        write(nfout,*) iop
        write(nfout,300) (nop(1,jj,iop),jj=1,3),taub(1,iop)
        write(nfout,300) (nop(2,jj,iop),jj=1,3),taub(2,iop)
        write(nfout,300) (nop(3,jj,iop),jj=1,3),taub(3,iop)
     end do
     if(af /= 0) then
        write(nfout,*) 'ANTI-FERROMAGNETIC OPERATION'
        do iop = nopr+1,nopr+af
           write(nfout,300) (nop(1,jj,iop),jj=1,3),taub(1,iop)
           write(nfout,300) (nop(2,jj,iop),jj=1,3),taub(2,iop)
           write(nfout,300) (nop(3,jj,iop),jj=1,3),taub(3,iop)
        end do
     end if
  end if

  do iop=1,nopr+af
     do ii=1,3
        do jj=1,3
           rop(ii,jj)=dfloat(nop(ii,jj,iop))
        end do
     end do

     call matpr3(rop,brinv,cc)
     call matpr3(br,cc,op(1,1,iop))

     do ii=1,3
        tau(ii,iop)=br(ii,1)*taub(1,iop)+br(ii,2)*taub(2,iop) &
             & +br(ii,3)*taub(3,iop)
     end do
  end do

!     debug
  if(IPRI >= 1) then 
     write(nfout,*) 'OPERATION MATRIX ( Cartesian coodinates )'
     do iop = 1,nopr
        write(nfout,*) iop
        write(nfout,200) (op(1,jj,iop),jj=1,3),tau(1,iop)
        write(nfout,200) (op(2,jj,iop),jj=1,3),tau(2,iop)
        write(nfout,200) (op(3,jj,iop),jj=1,3),tau(3,iop)
     end do
     if(af /= 0) then
        write(nfout,*) 'ANTI-FERROMAGNETIC OPERATION'
        do iop=nopr+1,nopr+af
           write(nfout,200) (op(1,jj,iop),jj=1,3),tau(1,iop)
           write(nfout,200) (op(2,jj,iop),jj=1,3),tau(2,iop)
           write(nfout,200) (op(3,jj,iop),jj=1,3),tau(3,iop)
        end do
     end if
200  format(8x,3f12.5,5x,f12.5)
300  format(8x,3i4,f10.4)
  end if
      
1000 if(Iparas .eq. PARAMETER_SET) nopr=nopr+af

  return
end subroutine readop

subroutine altv_2_rltv(altv,rltv,univol,rvol)
  use m_Const_Parameters, only : PAI2, DP
  implicit none
  real(kind=DP), dimension(3,3), intent(in)  :: altv
  real(kind=DP), dimension(3,3), intent(out) :: rltv
  real(kind=DP), intent(out):: univol, rvol
  real(kind=DP), external :: deter3

  call inver3n(3, altv, rltv)
  rltv = PAI2*transpose(rltv)

  univol=dabs(deter3(altv))
  rvol = dabs(deter3(rltv))

end subroutine altv_2_rltv

function deter3(a)
  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP), intent(in), dimension(3,3) :: a
  real(kind=DP)                             :: deter3

  deter3 = a(1,1)*(a(2,2)*a(3,3)-a(3,2)*a(2,3)) &
       &     +   a(2,1)*(a(3,2)*a(1,3)-a(1,2)*a(3,3)) &
       &     +   a(3,1)*(a(1,2)*a(2,3)-a(2,2)*a(1,3))

end function deter3

function deter3n(k,a)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)                       :: k
  real(kind=DP), intent(in), dimension(k,k) :: a
  real(kind=DP)                             :: deter3n

  deter3n = a(1,1)*(a(2,2)*a(3,3)-a(3,2)*a(2,3)) &
       &     +   a(2,1)*(a(3,2)*a(1,3)-a(1,2)*a(3,3)) &
       &     +   a(3,1)*(a(1,2)*a(2,3)-a(2,2)*a(1,3))

end function deter3n

subroutine string2values(len_str,str,n,values,nc)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)             :: len_str
  character(len=len_str), intent(in) :: str
  integer, intent(in)             :: n
  real(kind=DP), intent(out),dimension(n) :: values
  integer, intent(out)            :: nc

  call chnnm(str,len_str,n,values,nc)

end subroutine string2values

subroutine inver3n(k,a,b)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)                       :: k
  real(kind=DP), intent(in), dimension(k,k) :: a
  real(kind=DP), intent(out),dimension(k,k) :: b

  real(kind=DP) :: c,d,deter3n,cmax
  integer       :: i,j,l

  d=deter3n(k,a)

  if(dabs(d) < 1.d-20) then
     write(6,9001) abs(d)
9001 format(' ***** ERROR: (inver3) abs(det(a))'&
          &       ,d9.2,'<1.d-20')
     !stop ' ***** ERROR: (inver3) abs(det(a))<1.d-20'
     call phase_error_with_msg(6, '***** ERROR: (inver3) abs(det(a))<1.d-20',__LINE__,__FILE__)
  endif
  b(1,1)=(a(2,2)*a(3,3)-a(3,2)*a(2,3))/d
  b(2,1)=(a(2,3)*a(3,1)-a(3,3)*a(2,1))/d
  b(3,1)=(a(2,1)*a(3,2)-a(3,1)*a(2,2))/d
  b(1,2)=(a(3,2)*a(1,3)-a(1,2)*a(3,3))/d
  b(2,2)=(a(3,3)*a(1,1)-a(1,3)*a(3,1))/d
  b(3,2)=(a(3,1)*a(1,2)-a(1,1)*a(3,2))/d
  b(1,3)=(a(1,2)*a(2,3)-a(2,2)*a(1,3))/d
  b(2,3)=(a(1,3)*a(2,1)-a(2,3)*a(1,1))/d
  b(3,3)=(a(1,1)*a(2,2)-a(2,1)*a(1,2))/d

  cmax=0.d0
  do i=1,3
     do j=1,3
        c=0.d0
        do l=1,3
           c=c+b(i,l)*a(l,j)
        enddo
        if(i == j) then
           c=c-1.d0
        endif
        if(cmax < abs(c)) cmax = abs(c)
     enddo
  enddo
  if(cmax > 1.d-10) then
     write(6,9002) cmax
9002 format(' ***** ERROR: (inver3n) cmax=',d10.3,'>1.d-10')
     !stop ' ***** ERROR: (inver3n) cmax>1.d-10'
     call phase_error_with_msg(6, '***** ERROR: (inver3n) cmax>1.d-10',__LINE__,__FILE__)
  endif
end subroutine inver3n

subroutine matpr3(a,b,c)
  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP), intent(in),  dimension(3,3) :: a,b
  real(kind=DP), intent(out), dimension(3,3) :: c
!   C=A*B  A,B,C is 3x3 matrix

  c = matmul(a,b)

end subroutine matpr3

subroutine inver2n(k,a,b)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)                       :: k
  real(kind=DP), intent(in), dimension(k,k) :: a
  real(kind=DP), intent(out),dimension(k,k) :: b

  real(kind=DP) :: c,d,deter2n,cmax
  integer       :: i,j,l

  d=deter2n(k,a)

  if(dabs(d) < 1.d-20) then
     write(6,9001) abs(d)
9001 format(' ***** ERROR: (inver2n) abs(det(a))'&
          &       ,d9.2,'<1.d-20')
     !stop ' ***** ERROR: (inver2n) abs(det(a))<1.d-20'
     call phase_error_with_msg(6, '***** ERROR: (inver2n) abs(det(a))<1.d-20',__LINE__,__FILE__)
  endif
  b(1,1) =  a(2,2)/d
  b(1,2) = -a(1,2)/d
  b(2,1) = -a(2,1)/d
  b(2,2) =  a(1,1)/d

  cmax=0.d0
  do i=1,2
     do j=1,2
        c=0.d0
        do l=1,2
           c=c+b(i,l)*a(l,j)
        enddo
        if(i == j) then
           c=c-1.d0
        endif
        if(cmax < abs(c)) cmax = abs(c)
     enddo
  enddo
  if(cmax > 1.d-10) then
     write(6,9002) cmax
9002 format(' ***** ERROR: (inver2n) cmax=',d10.3,'>1.d-10')
     !stop ' ***** ERROR: (inver2n) cmax>1.d-10'
     call phase_error_with_msg(6, '***** ERROR: (inver2n) cmax>1.d-10',__LINE__,__FILE__)
  endif
end subroutine inver2n

function deter2n(k,a)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)                       :: k
  real(kind=DP), intent(in), dimension(k,k) :: a
  real(kind=DP)                             :: deter2n

  deter2n = a(1,1)*a(2,2) - a(1,2)*a(2,1)

end function deter2n

subroutine gnrt_op(kopr,altv,nfout,Iparas,nopr,op,tau,af,nbztyp_spg,nfspg,ipri_spg)
!
!      read bnprp4.i5 in setspg
!
!     #1) antiferromagnetic calculation is added on 9th Jul. 1996
!                                          by H.Sawada
!**********************************************************************
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)                       :: kopr, nbztyp_spg, ipri_spg
  real(DP), intent(in),dimension(3,3)       :: altv
  integer, intent(in)                       :: nfout,iparas,nfspg ! 
  integer, intent(out)                      :: nopr,af
  real(DP), intent(out),dimension(3,3,kopr) :: op
  real(DP), intent(out),dimension(3,kopr)   :: tau

  integer, parameter ::  PARAMETER_SET = 0 , PARAMETER_NO_SET = 1
!     work
  integer            :: nop(3,3,48),ii,jj,iop
  real(DP)           :: taub(3,48),br(3,3),brinv(3,3),trbp(3,3),trpb(3,3)
  real(DP)           :: cc(3,3),rop(3,3)
  real(DP)           :: tab(3,3),ta1(3,48)
  integer            :: ng1,lra1(3,3,48)
  integer            :: jpri_spg

  jpri_spg = ipri_spg
!! setspg  !!


  if(nbztyp_spg == 100 .or.nbztyp_spg == 101) then
      call setspg(tab,ng1,ta1,lra1,nfspg,jpri_spg)
  else
      call setspg_default(nbztyp_spg,altv,tab,ng1,ta1,lra1,jpri_spg)
  end if

!     make translation matrix  trpb (P -> B)
  do ii = 1,3
     trbp(ii,1) = tab(ii,1)
     trbp(ii,2) = tab(ii,2)
     trbp(ii,3) = tab(ii,3)
  end do

  call inver3n(3,trbp,trpb)

  if(jpri_spg >= 0) then
      write(nfout,*) 'TR B->P'
      do ii = 1,3
         write(nfout,100) trbp(ii,1),trbp(ii,2),trbp(ii,3)
      end do
      write(nfout,*) 'TR P->B'
      do ii = 1,3
         write(nfout,100) trpb(ii,1),trpb(ii,2),trpb(ii,3)
      end do
  end if
  call matpr3(altv,trpb,br)

  if(jpri_spg >= 0) then
      write(nfout,*) 'Bravais lattice'
      write(nfout,100) (br(1,ii),ii=1,3)
      write(nfout,100) (br(2,ii),ii=1,3)
      write(nfout,100) (br(3,ii),ii=1,3)
  end if

100 format(8x,3f15.6)

  call inver3n(3,br,brinv)

  nopr = ng1 
  if(nopr < 0) then
     nopr=-nopr
     af=1
  else
     af=0
  end if
  if(Iparas == PARAMETER_NO_SET) then
     do iop = 1,nopr
         taub(1,iop) = ta1(1,iop)
         taub(2,iop) = ta1(2,iop)
         taub(3,iop) = ta1(3,iop)
     end do

     do iop = 1,nopr
        do jj =1,3
            do ii = 1,3
                nop(ii,jj,iop) = lra1(ii,jj,iop) 
            end do
        end do
     end do
  end if

  if(Iparas == PARAMETER_SET) then
     if(af /= 0) then
        af = ng1
     end if
     goto 1000
  else
     if(af /= 0) then
        af = ng1
        if(jpri_spg >= -1) then 
           write(nfout,*) ' ANTI-FERROMAGNETIC CALCULATION'
           write(nfout,'(41h NUMBER OF ANTI-FERROMAGNETIC OPERATOR = ,i3)') af
        end if
        do iop=nopr+1,nopr+af
           taub(1,iop) = ta1(1,iop)
           taub(2,iop) = ta1(2,iop)
           taub(3,iop) = ta1(3,iop)
        end do
        do iop = nopr+1,nopr+af
           do jj =1,3
               do ii = 1,3
                   nop(ii,jj,iop) = lra1(ii,jj,iop) 
               end do
           end do
        end do
     end if
  end if

  if(nopr+af < kopr) then 
     write(nfout,*) 'Warning ! kopr should be ',nopr+af
  else if(nopr+af.gt.kopr) then
     write(nfout,*) 'ERROR ! kopr must be ',nopr+af
  end if

  if(jpri_spg >= -1) then 
     write(nfout,*) 'OPERATION MATRIX ( Bravais lattice )'
     do iop=1,nopr
        write(nfout,*) iop
        write(nfout,300) (nop(1,jj,iop),jj=1,3),taub(1,iop)
        write(nfout,300) (nop(2,jj,iop),jj=1,3),taub(2,iop)
        write(nfout,300) (nop(3,jj,iop),jj=1,3),taub(3,iop)
     end do
     if(af /= 0) then
        write(nfout,*) 'ANTI-FERROMAGNETIC OPERATION'
        do iop = nopr+1,nopr+af
           write(nfout,300) (nop(1,jj,iop),jj=1,3),taub(1,iop)
           write(nfout,300) (nop(2,jj,iop),jj=1,3),taub(2,iop)
           write(nfout,300) (nop(3,jj,iop),jj=1,3),taub(3,iop)
        end do
     end if
  end if

  do iop=1,nopr+af
     do ii=1,3
        do jj=1,3
           rop(ii,jj)=dfloat(nop(ii,jj,iop))
        end do
     end do

     call matpr3(rop,brinv,cc)
     call matpr3(br,cc,op(1,1,iop))

     do ii=1,3
        tau(ii,iop)=br(ii,1)*taub(1,iop)+br(ii,2)*taub(2,iop) &
             & +br(ii,3)*taub(3,iop)
     end do
  end do

  if(jpri_spg >= -1) then 
     write(nfout,*) 'OPERATION MATRIX ( Cartesian coodinates )'
     do iop = 1,nopr
        write(nfout,*) iop
        write(nfout,200) (op(1,jj,iop),jj=1,3),tau(1,iop)
        write(nfout,200) (op(2,jj,iop),jj=1,3),tau(2,iop)
        write(nfout,200) (op(3,jj,iop),jj=1,3),tau(3,iop)
     end do
     if(af /= 0) then
        write(nfout,*) 'ANTI-FERROMAGNETIC OPERATION'
        do iop=nopr+1,nopr+af
           write(nfout,200) (op(1,jj,iop),jj=1,3),tau(1,iop)
           write(nfout,200) (op(2,jj,iop),jj=1,3),tau(2,iop)
           write(nfout,200) (op(3,jj,iop),jj=1,3),tau(3,iop)
        end do
     end if
200  format(8x,3f12.5,5x,f12.5)
300  format(8x,3i4,f10.4)
  end if
      
1000 if(Iparas .eq. PARAMETER_SET) nopr=nopr+af

  return
end subroutine gnrt_op

! ================================ modified by K. Tagami ============== 12.0A
!subroutine gnrt_op_paramset(il,ngen,inv,igen,jgen,imag,iaf,jaf,a,b,c,ca,cb,cc &
!  &     , nfout,nopr,af,nbztyp_spg,ig01)
!
subroutine gnrt_op_paramset( il, ngen, inv, igen, jgen, imag, iaf, jaf, &
     &                       a, b, c, ca, cb, cc, &
     &                       nfout, nopr, af, nbztyp_spg, ig01, &
     &                       use_altv_rltv, altv, rltv, gen_name_in_carts  )
! ========================================================================= 12.0A

!
!     #1) antiferromagnetic calculation is added on 9th Jul. 1996
!                                          by H.Sawada
!
!!!  subroutine gnrt_op(ipri,kopr,altv,nfout,Iparas,nopr,op,tau,af,nbztyp_spg)
!!!       modified by mizouchi@adv 2003.2.21 !!!!!
!
!  Subroutine <gnrt_op_n> is revised on <gnrt_op> by T. Yamasaki (FUJITSU Lab.)
!                                                 31 May 2003
!**********************************************************************
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in) ::                       il,ngen,inv
  integer, intent(in), dimension(ngen) ::      igen
  integer, intent(in), dimension(2,3,ngen) ::  jgen
  integer, intent(in) ::                       imag !if(imag==1) Antiferro
  integer, intent(in) ::                       iaf
  integer, intent(in), dimension(2,3) ::       jaf
  real(kind=DP),intent(in) ::                  a,b,c,ca,cb,cc
  integer, intent(in) ::                       nbztyp_spg
  integer, intent(in) ::                       nfout
  integer, intent(out) ::                      nopr,af
  integer, intent(out),dimension(48) ::   ig01

! ================================== added by K. Tagami ================ 12.0A
  logical, intent(in) :: use_altv_rltv
  logical, intent(in) :: gen_name_in_carts
  real(DP), intent(in) :: rltv(3,3), altv(3,3)
! ======================================================================= 12.0A

!!$  real(DP)           :: br(3,3),brinv(3,3),trbp(3,3),trpb(3,3)
!!$  real(DP)           :: tab(3,3),ta1(3,48)
!!$  integer            :: ng1,lra1(3,3,48)
  real(DP)           :: tab(3,3),ta1(3,49)
  integer            :: ng1,lra1(3,3,49)

  if(nbztyp_spg == 100 .or.nbztyp_spg == 101) then
      call setspg_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc,tab,ng1,ta1,lra1,ig01)
!           setspg_n is modified from <setspg> by T. Yamasaki
  else

! ================================= modified by K. Tagami ================= 12.0A
!      call setspg_default_n(il,ngen,inv,igen,jgen,imag,iaf,jaf,a,b,c,ca,cb,cc,tab,ng1,ta1,lra1,0,ig01)
!!          <setspg_default_n> is modified from <setspg_default> by T. Yamasaki
!
     if ( use_altv_rltv ) then
        ng1 = 0
        call setspg_default_n_kt( il, ngen, inv, igen, jgen, imag, iaf, jaf, &
             &                    a, b, c, ca, cb, cc, tab, ng1, ta1, lra1, &
             &                    0, ig01, use_altv_rltv, altv, rltv, &
             &                    gen_name_in_carts )
     else
        call setspg_default_n( il, ngen, inv, igen, jgen, imag, iaf, jaf, &
             &                 a, b, c, ca, cb, cc, tab, ng1, ta1, lra1, 0, ig01 )
     endif
! ============================================================================ 12.0A

  end if

!     make translation matrix  trpb (P -> B)
!!$  do ii = 1,3
!!$     trbp(ii,1) = tab(ii,1)
!!$     trbp(ii,2) = tab(ii,2)
!!$     trbp(ii,3) = tab(ii,3)
!!$  end do
!!$
!!$  call inver3n(3,trbp,trpb)
!!$
!!$  call matpr3(altv,trpb,br)
!!$
!!$  call inver3n(3,br,brinv)

  nopr = ng1 
  if(imag == 1) then
  !!if(nopr < 0) then
  !!   nopr=-nopr
     af=1
  else
     af=0
  end if

  return
end subroutine gnrt_op_paramset

! ====================================== modified by K. Tagami =========== 12.0A
!subroutine gnrt_op_n(il,ngen,inv,igen,jgen,imag,iaf,jaf,a,b,c,ca,cb,cc &
!  &     , kopr,altv,nfout,nopr,op,tau,af,nbztyp_spg,ipri_spg,ig01)
!
subroutine gnrt_op_n( il, ngen, inv, igen, jgen, imag, iaf, jaf, &
     &                a, b, c, ca, cb, cc, &
     &                kopr, altv, nfout, nopr, op, tau, af, &
     &                nbztyp_spg, ipri_spg, ig01, &
     &                use_altv_rltv, rltv, gen_name_in_carts )
! ========================================================================== 12.0A

!
!     #1) antiferromagnetic calculation is added on 9th Jul. 1996
!                                          by H.Sawada
!
!!!  subroutine gnrt_op(ipri,kopr,altv,nfout,Iparas,nopr,op,tau,af,nbztyp_spg)
!!!       modified by mizouchi@adv 2003.2.21 !!!!!
!
!  Subroutine <gnrt_op_n> is revised on <gnrt_op> by T. Yamasaki (FUJITSU Lab.)
!                                                 31 May 2003
!**********************************************************************
  use m_Const_Parameters, only : DP, oh_symbol, d6h_symbol
  implicit none
  integer, intent(in) ::                       il,ngen,inv
  integer, intent(in), dimension(ngen) ::      igen
  integer, intent(in), dimension(2,3,ngen) ::  jgen
  integer, intent(in) ::                       imag !if(imag==1) Antiferro
  integer, intent(in) ::                       iaf
  integer, intent(in), dimension(2,3) ::       jaf
  real(kind=DP),intent(in) ::                  a,b,c,ca,cb,cc
  integer, intent(in) ::                       kopr, nbztyp_spg, ipri_spg
  real(DP), intent(in),dimension(3,3) ::       altv
  integer, intent(in) ::                       nfout
  integer, intent(out) ::                      nopr,af
  real(DP), intent(out),dimension(3,3,kopr) :: op
  real(DP), intent(out),dimension(3,kopr) ::   tau
  integer, intent(out),dimension(48) ::   ig01

! ================================== added by K. Tagami ================ 12.0A
  logical, intent(in) :: use_altv_rltv
  logical, intent(in) :: gen_name_in_carts
  real(DP), intent(in) :: rltv(3,3)
! ======================================================================= 12.0A

  integer, parameter ::  PARAMETER_SET = 0 , PARAMETER_NO_SET = 1
!     work
!!$  integer            :: nop(3,3,48),ii,jj,iop
  integer            :: nop(3,3,49),ii,jj,iop
!!$  real(DP)           :: taub(3,48),br(3,3),brinv(3,3),trbp(3,3),trpb(3,3)
  real(DP)           :: taub(3,49),br(3,3),brinv(3,3),trbp(3,3),trpb(3,3)
  real(DP)           :: ccc(3,3),rop(3,3)
!!$  real(DP)           :: tab(3,3),ta1(3,48)
  real(DP)           :: tab(3,3),ta1(3,49)
!!$  integer            :: ng1,lra1(3,3,48)
  integer            :: ng1,lra1(3,3,49)


  if(nbztyp_spg == 100 .or.nbztyp_spg == 101) then
      call setspg_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc,tab,ng1,ta1,lra1,ig01)
!           setspg_n is modified from <setspg> by T. Yamasaki
  else

! ============================ modified by K. Tagami ===================== 12.0A
!      call setspg_default_n(il,ngen,inv,igen,jgen,imag,iaf,jaf,a,b,c,ca,cb,cc,tab,ng1,ta1,lra1,ipri_spg,ig01)
!!          <setspg_default_n> is modified from <setspg_default> by T. Yamasaki
!
     if ( use_altv_rltv ) then
        ng1 = 0
        call setspg_default_n_kt( il, ngen, inv, igen, jgen, imag, iaf, jaf, &
             &                    a, b, c, ca, cb, cc, tab, ng1, ta1, lra1, &
             &                    ipri_spg, ig01, &
             &                    use_altv_rltv, altv, rltv, gen_name_in_carts )
     else
        call setspg_default_n( il, ngen, inv, igen, jgen, imag, iaf, jaf, &
             &                 a, b, c, ca, cb, cc, tab, ng1, ta1, lra1, &
             &                 ipri_spg, ig01 )
     end if
! ========================================================================= 12.0A     

  endif

!---
!     make translation matrix  trpb (P -> B)
  do ii = 1,3
     trbp(ii,1) = tab(ii,1)
     trbp(ii,2) = tab(ii,2)
     trbp(ii,3) = tab(ii,3)
  end do

  call inver3n(3,trbp,trpb)

  if(ipri_spg >= 1) then
      write(nfout,*) 'TR B->P'
      do ii = 1,3
         write(nfout,100) trbp(ii,1),trbp(ii,2),trbp(ii,3)
      end do
      write(nfout,*) 'TR P->B'
      do ii = 1,3
         write(nfout,100) trpb(ii,1),trpb(ii,2),trpb(ii,3)
      end do
  end if

  call matpr3(altv,trpb,br)


  if(ipri_spg >= 1) then
      write(nfout,*) 'Bravais lattice'
      write(nfout,100) (br(1,ii),ii=1,3)
      write(nfout,100) (br(2,ii),ii=1,3)
      write(nfout,100) (br(3,ii),ii=1,3)
  end if
100 format(8x,3f15.6)

  call inver3n(3,br,brinv)

  nopr = ng1 
  if(imag == 1) then
  !!if(nopr < 0) then
  !!   nopr=-nopr
     af=1
  else
     af=0
  end if
!!$  if(Iparas == PARAMETER_NO_SET) then
  do iop = 1,nopr
     taub(1,iop) = ta1(1,iop)
     taub(2,iop) = ta1(2,iop)
     taub(3,iop) = ta1(3,iop)
  end do

  do iop = 1,nopr
     do jj =1,3
        do ii = 1,3
           nop(ii,jj,iop) = lra1(ii,jj,iop) 
        end do
     end do
  end do

!!$  if(Iparas == PARAMETER_SET) then
!!$     !!if(af /= 0) then
!!$     !!   af = ng1
!!$     !!end if
!!$     goto 1000
!!$  else
  if(af /= 0) then
     !!af = ng1
     if(ipri_spg >= 1) then 
        write(nfout,*) ' ANTI-FERROMAGNETIC CALCULATION'
        write(nfout,'(41h NUMBER OF ANTI-FERROMAGNETIC OPERATOR = ,i3)') af
     end if
     do iop=nopr+1,nopr+af
        taub(1,iop) = ta1(1,iop)
        taub(2,iop) = ta1(2,iop)
        taub(3,iop) = ta1(3,iop)
     end do
     do iop = nopr+1,nopr+af
        do jj =1,3
           do ii = 1,3
              nop(ii,jj,iop) = lra1(ii,jj,iop) 
           end do
        end do
     end do
  end if
!!$  end if

  if(nopr+af < kopr) then 
     write(nfout,*) 'Warning ! kopr should be ',nopr+af
  else if(nopr+af.gt.kopr) then
     write(nfout,*) 'ERROR ! kopr must be ',nopr+af
  end if

  if(ipri_spg >= 1) then 
     write(nfout,*) 'OPERATION MATRIX ( Bravais lattice )'
     do iop=1,nopr
        if(il<=0) then
           write(nfout,*) iop,d6h_symbol(ig01(iop))
        else
           write(nfout,*) iop,oh_symbol(ig01(iop))
        end if
        write(nfout,300) (nop(1,jj,iop),jj=1,3),taub(1,iop)
        write(nfout,300) (nop(2,jj,iop),jj=1,3),taub(2,iop)
        write(nfout,300) (nop(3,jj,iop),jj=1,3),taub(3,iop)
     end do
     if(af /= 0) then
        write(nfout,*) 'ANTI-FERROMAGNETIC OPERATION'
        do iop = nopr+1,nopr+af
           if(il<=0) then
              write(nfout,*) iop,d6h_symbol(iaf)
           else
              write(nfout,*) iop,oh_symbol(iaf)
           end if
           write(nfout,300) (nop(1,jj,iop),jj=1,3),taub(1,iop)
           write(nfout,300) (nop(2,jj,iop),jj=1,3),taub(2,iop)
           write(nfout,300) (nop(3,jj,iop),jj=1,3),taub(3,iop)
        end do
     end if
  end if

  do iop=1,nopr+af
     do ii=1,3
        do jj=1,3
           rop(ii,jj)=dfloat(nop(ii,jj,iop))
        end do
     end do

     call matpr3(rop,brinv,ccc)
     call matpr3(br,ccc,op(1,1,iop))

     do ii=1,3
        tau(ii,iop)=br(ii,1)*taub(1,iop)+br(ii,2)*taub(2,iop) &
             & +br(ii,3)*taub(3,iop)
     end do
  end do

  if(ipri_spg >= 1) then 
     write(nfout,*) 'OPERATION MATRIX ( Cartesian coodinates )'
     do iop = 1,nopr
        if(il>0) then
           write(nfout,*) iop,oh_symbol(ig01(iop))
        else
           write(nfout,*) iop,d6h_symbol(ig01(iop))
        end if
        write(nfout,200) (op(1,jj,iop),jj=1,3),tau(1,iop)
        write(nfout,200) (op(2,jj,iop),jj=1,3),tau(2,iop)
        write(nfout,200) (op(3,jj,iop),jj=1,3),tau(3,iop)
     end do
     if(af /= 0) then
        write(nfout,*) 'ANTI-FERROMAGNETIC OPERATION'
        do iop=nopr+1,nopr+af
           if(il>0) then
              write(nfout,*) iop,oh_symbol(iaf)
           else
              write(nfout,*) iop,d6h_symbol(iaf)
           end if
           write(nfout,200) (op(1,jj,iop),jj=1,3),tau(1,iop)
           write(nfout,200) (op(2,jj,iop),jj=1,3),tau(2,iop)
           write(nfout,200) (op(3,jj,iop),jj=1,3),tau(3,iop)
        end do
     end if
200  format(8x,3f12.5,5x,f12.5)
300  format(8x,3i4,f10.4)
  end if
      
  return
end subroutine gnrt_op_n


subroutine bravais2primitive(nfout,b2pmat,a,b,c,ca,cb,cc,avec,bvec,cvec,il)
! This subroutine was coded by BETSUYAKU, K. (Fuji Research Institute Co., Ltd.), July 2003
!
! [use m_Crystal_Structure] is commented out and b2pmat is included in the argument list,
! and write and stop statements have been revised.
!   by T. Yamasaki (FUJITSU LABORATORIES Ltd.), 10th Aug. 2003

  use m_Const_Parameters, only  : DP
!!$  use m_Crystal_Structure, only : b2pmat
  implicit none
  integer, intent(in) ::          nfout
  real(kind=DP), intent(in), dimension(3,3) :: b2pmat
  real(kind=DP), intent(in)    :: a, b, c, ca, cb, cc
  real(kind=DP), intent(inout) :: avec(3), bvec(3), cvec(3)
  integer,       intent(in)    :: il

  real(kind=DP)                :: abcmat(3,3) = 0.d0
  real(kind=DP), parameter     :: epsilon = 1.d-10
  integer                      :: ido, jdo

  abcmat(1,:) = avec(:)
  abcmat(2,:) = bvec(:)
  abcmat(3,:) = cvec(:)

  do ido = 1, 3
     do jdo = 1, 3
        if (abs(abcmat(ido,jdo)) < epsilon) abcmat(ido,jdo) = 0.d0
     end do
  end do

  if (il == -1) then                  ! Trigonal
     if (abs(ca)>epsilon .or. abs(cb)>epsilon .or. abs(abs(cc)-0.5d0)>epsilon) then
!!$        write(nfout,'(" You must have given wrong lattice.: ca, cb, cc = ",3f8.4," (il=-1)")') ca, cb, cc
        write(nfout,1001) ca,cb,cc,il
        call phase_error_with_msg(nfout, 'il = -1 <<bravais2primitive>>',__LINE__,__FILE__)
        !stop ' il = -1 <<bravais2primitive>>'
     end if
  else if (il == 0) then ! Primitive (Hexagonal)
     if (abs(ca)>epsilon .or. abs(cb)>epsilon .or. abs(abs(cc)-0.5d0)>epsilon) then
!!$        write(nfout,'(" You must have given wrong lattice.: ca, cb, cc = ",3f8.4,', ca, cb, cc
        write(nfout,1001) ca,cb,cc,il
        !stop ' il = 0  <<bravais2primitive>>'
        call phase_error_with_msg(nfout, 'il = 0 <<bravais2primitive>>',__LINE__,__FILE__)
     end if
  else if (il == 1) then ! Primitive

  else if (il == 2) then              ! Face-centered
     if (abs(ca)>epsilon .or. abs(cb)>epsilon .or. abs(cc)>epsilon) then
!!$        write(nfout,*) 'You must have given wrong lattice.', ca, cb, cc
        write(nfout,1001) ca,cb,cc,il
        !stop ' il = 2 <<bravais2primitive>>'
        call phase_error_with_msg(nfout, 'il = 2 <<bravais2primitive>>',__LINE__,__FILE__)
     end if
  else if (il == 3) then              ! Body-centered
     if (abs(ca)>epsilon .or. abs(cb)>epsilon .or. abs(cc)>epsilon) then
!!$        write(nfout,*) 'You must have given wrong lattice.', ca, cb, cc
        write(nfout,1001) ca,cb,cc,il
        !stop ' il = 3 <<bravais2primitive>>'
        call phase_error_with_msg(nfout, 'il = 3 <<bravais2primitive>>',__LINE__,__FILE__)
     end if
  else if (il == 4) then              ! Base-centered
     if ( (abs(cb)>epsilon .and. (abs(ca)>epsilon .or. abs(cc)>epsilon)) .or. &
          (abs(cc)>epsilon .and. (abs(cb)>epsilon .or. abs(ca)>epsilon)) .or. &
          (abs(ca)>epsilon .and. (abs(cc)>epsilon .or. abs(cb)>epsilon)) ) then
!!$        write(nfout,*) 'You must have given wrong lattice.', ca, cb, cc
        write(nfout,1001) ca,cb,cc,il
        !stop ' il = 4 <<bravais2primitive>>'
        call phase_error_with_msg(6, 'il = 4 <<bravais2primitive>>',__LINE__,__FILE__)
     end if
  else
     !write(nfout,*) 'The value of il is invalid. il =', il
     call phase_error_with_msg(nfout, 'The value of il is invalid.',__LINE__,__FILE__)
     !stop
  end if
1001 format(" You must have given wrong lattice. : ca, cb, cc = ",3f8.4," (il = ",i2,")")

  abcmat = matmul(b2pmat,abcmat)

  do ido = 1, 3
     do jdo = 1, 3
        if (abs(abcmat(ido,jdo)) < epsilon) abcmat(ido,jdo) = 0.d0
     end do
  end do

  avec(:) = abcmat(1,:)
  bvec(:) = abcmat(2,:)
  cvec(:) = abcmat(3,:)

end subroutine bravais2primitive


subroutine primitive2bravais(nfout,p2bmat,avec,bvec,cvec,a,b,c,ca,cb,cc,il)
! This subroutine was coded by BETSUYAKU, K. (Fuji Research Institute Co., Ltd.), July 2003
!
! [use m_Crystal_Structure] is commented out and b2pmat is included in the argument list
! and write and stop statements have been revised.
!   by T. Yamasaki (FUJITSU LABORATORIES Ltd.), 10th Aug. 2003
  use m_Const_Parameters, only  : DP
  implicit none
!!$  use m_Crystal_Structure, only : p2bmat
  integer, intent(in) ::          nfout
  real(kind=DP), intent(in), dimension(3,3) :: p2bmat
  real(kind=DP), intent(in)    :: avec(3), bvec(3), cvec(3)
  real(kind=DP), intent(inout) :: a, b, c, ca, cb, cc
  integer,       intent(in)    :: il

  real(kind=DP)                :: abcmat(3,3) = 0.d0
  real(kind=DP), parameter     :: epsilon = 1.d-10

  abcmat(1,:) = avec(:)
  abcmat(2,:) = bvec(:)
  abcmat(3,:) = cvec(:)

  abcmat = matmul(p2bmat,abcmat)

  a = sqrt( sum(abcmat(1,:)*abcmat(1,:)) )
  b = sqrt( sum(abcmat(2,:)*abcmat(2,:)) )
  c = sqrt( sum(abcmat(3,:)*abcmat(3,:)) )

  ca =  dot_product(abcmat(2,:),abcmat(3,:))/(b*c)
  cb =  dot_product(abcmat(3,:),abcmat(1,:))/(c*a)
  cc =  dot_product(abcmat(1,:),abcmat(2,:))/(a*b)

  if (il <= 0) then      ! Trigonal or Hexagonal
     if ( abs(b-a) < epsilon ) b = a
     if ( abs(ca) < epsilon ) ca = 0.d0
     if ( abs(cb) < epsilon ) cb = 0.d0
     if ( abs(cc+0.5d0) < epsilon ) cc = -0.5d0
  else if (il >= 1) then ! the others
     if ( abs(b-a) < epsilon ) b = a
     if ( abs(c-a) < epsilon ) c = a
     if ( abs(ca) < epsilon ) ca = 0.d0
     if ( abs(cb) < epsilon ) cb = 0.d0
     if ( abs(cc) < epsilon ) cc = 0.d0
  else
     write(nfout,'(" The value of il is invalid. il =",i3)') il
     !stop ' The value of il is invalid. <<primitive2bravais>>'
     call phase_error_with_msg(nfout,' The value of il is invalid. <<primitive2bravais>>',__LINE__,__FILE__)
  end if

end subroutine primitive2bravais

logical function is_hexagonal(a,b,ca,cb,cc)
  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP), intent(in) :: a,b
  real(kind=DP), intent(in) :: ca,cb,cc
  real(kind=DP), parameter     :: epsilon = 1.d-10
  is_hexagonal = .false.
  if (abs(ca)<epsilon .and. abs(cb)<epsilon .and. abs(abs(cc)-0.5d0)<epsilon .and. abs(a-b)<epsilon) &
  & is_hexagonal=.true.

end function is_hexagonal

subroutine get_latvec_from_brav_to_prim( b2pmat, altv_brav, altv_pr )
  use m_Const_Parameters, only  : DP
  implicit none

  real(kind=DP), intent(in), dimension(3,3) :: b2pmat
  real(kind=DP), intent(in)   :: altv_brav(3,3)
  real(kind=DP), intent(out)    :: altv_pr(3,3)

  real(kind=DP)                :: abcmat(3,3) = 0.d0

  abcmat(1,:) = altv_brav(:,1)
  abcmat(2,:) = altv_brav(:,2)
  abcmat(3,:) = altv_brav(:,3)

  abcmat = matmul(b2pmat,abcmat)
  altv_pr(:,1) = abcmat(1,:)
  altv_pr(:,2) = abcmat(2,:)
  altv_pr(:,3) = abcmat(3,:)

end subroutine get_latvec_from_brav_to_prim

subroutine get_latvec_from_prim_to_brav( p2bmat, altv_pr, altv_brav )
  use m_Const_Parameters, only  : DP
  implicit none

  real(kind=DP), intent(in), dimension(3,3) :: p2bmat
  real(kind=DP), intent(in)    :: altv_pr(3,3)
  real(kind=DP), intent(out)   :: altv_brav(3,3)

  real(kind=DP)                :: abcmat(3,3) = 0.d0

  abcmat(1,:) = altv_pr(:,1)
  abcmat(2,:) = altv_pr(:,2)
  abcmat(3,:) = altv_pr(:,3)

  abcmat = matmul(p2bmat,abcmat)
  altv_brav(:,1) = abcmat(1,:)
  altv_brav(:,2) = abcmat(2,:)
  altv_brav(:,3) = abcmat(3,:)

end subroutine get_latvec_from_prim_to_brav

  subroutine Renew_WF_by_lmSDorlmCG_fc(isolver,precon,dtim)
    integer, intent(in)         :: isolver,precon
    real(kind=DP)               :: dtim
    real(kind=DP), dimension(3) :: etotal
    real(kind=DP), parameter    :: factor = 2
    real(kind=DP)               :: dtim_new = 0.d0, dtim_msdv
    integer                     :: isolver_core, mode

    isolver_core = what_is_the_core_solver(isolver) ! -(in this file)

    mode = ORTHONORMALIZATION

! ---------------- Added by T. Yamasaki, 28 June 2008, 31 Oct. 2008 ---
    if(sw_use_wfred == ON) call m_ESsd_alloc_wfred()
! ------------------------------------------------------<<
    call m_ESsd_copy_zaj_to_zaj_old()
    etotal(1) = m_TE_tell_band_energy(nfout,kv3)
    dtim_msdv = m_CtrlP_dtim_1Dsearch_now(dtim)
    if(ipri >= 2) write(nfout,'(" !! dtim_msdv = ",f8.4)') dtim_msdv
    if(isolver_core == CG) then
       call m_ESsd_decide_CG_direction(precon)  !  -> betacg
       !    ~~~~~~~~~~~~~~~~~~~~~~~~~~
       call m_ESsd_renew_WF_by_SDorCG(nfout,isolver_core,precon,dtim_msdv)
       !    ~~~~~~~~~~~~~~~~~~~~~~~~~
    else
       call m_ESsd_renew_WF_by_SDorCG(nfout,isolver_core,precon,dtim_msdv)
       !    ~~~~~~~~~~~~~~~~~~~~~~~~~
    end if

    etotal(2) = m_TE_tell_band_energy(nfout,kv3)

!!$    if(isolver_core == CG .or. isolver_core == eazyCG) mode = NORMALIZATION
    call m_ESsd_evolve_WFs_again(nfout,isolver_core,mode,dtim_msdv,factor*dtim_msdv)
	 ! (msdv_grad)

    etotal(3) = m_TE_tell_band_energy(nfout,kv3)
    dtim_new = m_CtrlP_decide_dtim_1Dsearch(nfout,etotal,dtim_msdv,factor)
    mode = ORTHONORMALIZATION
! ------------------- Revised by T. Yamasaki,  03 July 2008, 31 Oct 2008 --->>
    if(sw_use_wfred == ON) then
       call m_ESsd_evolve_WFs_again(nfout,isolver_core,mode,dtim_msdv,dtim_new)
    else
       call m_ESsd_evolve_WFs_again(nfout,isolver_core,mode,factor*dtim_msdv,dtim_new)
    end if
! ------------------------------------------------------------<<
! ---------------- Added by T. Yamasaki, 28 June 2008, 31 Oct. 2008 ---
    if(sw_use_wfred == ON) call m_ESsd_dealloc_wfred()
! ------------------------------------------------------<<
  end subroutine Renew_WF_by_lmSDorlmCG_fc

!TSPACEを用いたPHASEバンド簡約プログラムband_symm
!Copyright (C) 2014-2015 Ryosuke Tomita, Hiroyuki Oshima and Mineo Saito
!TSPACE: Copyright (C) 1995 Akira Yanagi (http://aquarius.mp.es.osaka-u.ac.jp/~tspace/)
!PHASE:  Copyright (C) 2002-2014 NIMS (https://azuma.nims.go.jp/software/phase)

#define READSTOP(func, fileno) \
if(.not.func(fileno)) stop 'error while '//"func";\
rewind(fileno)

program main
  use m_commons, only: stdout, openInputFromArgOrDefaultPath,openOutput
  use m_tspace_defines, only: character_table
  use m_tspace_commons, only: set_lattice_parameters, set_kpoint_irep, get_kgroup, set_pg_name,set_class,print_kpoint_and_kgroup
  use m_container_commons, only: readline_until_tag, k_state, c_state
  use m_container_lattice, only: trp2b, get_cstate, read_lattice_system, read_lattice_parameter, read_lattice_vector, read_kpoint_data
  use m_container_psicoef, only: ikpoint, nspin, readmagstate_psicoef, readstate_psicoef, ndim_spinor
  use m_classification, only: calcAll, printAll, deleteAll
  use m_compatibility, only: add_kpoint, print_compat_table, isDuplicateKpoint
  use m_character_table, only: print_character_table_for_TeX, get_character_table, print_character_table
  implicit none

!入出力用装置番号
  integer, parameter:: fileno = 1000
!出力用装置番号(reduce.data,character.tex)
  integer, parameter:: freduce(2) = (/1001,1011/), ftex = 1002
!k点の総数とスピンインデックス
  integer:: nikps, is, aa
!kpoint.dataから読み込んだk点のリストikps(1:4,1:nikps)
  integer, allocatable:: ikps(:,:)
!空間群の情報
  type(c_state), target:: cst
!k点及びk群の状態
  type(k_state), target:: kst
!指標表
  type(character_table), target:: cht
!**m.saito**
  WRITE(6,*) '** band_symm 202112'
  WRITE(6,*) '** MODIFICATION: main.F90, reduce_band.F90'
  WRITE(6,*) '   degeneracy.F90,tspace_commons.F90 band_symm.pl'

!インプットファイル1(kpoint.data)を開く
  if(.not.openInputFromArgOrDefaultPath(fileno, './kpoint.data'))&
       stop 'error while opening kpoint.data'
!kpoint.dataの読み込み、nikpsとikpsを決める
  call read_kpoint_data(fileno, nikps, ikps)
  close(fileno)

!インプットファイル2(band_sym_input.data)を開く
  if(.not.openInputFromArgOrDefaultPath(fileno, './band_sym_input.data'))&
       stop 'error while opening band_sym_input.data'

!格子情報、パラメータ、セルベクトルの読み込み
  READSTOP(read_lattice_system, fileno)
  READSTOP(read_lattice_parameter, fileno)
  READSTOP(read_lattice_vector, fileno)
  cst = get_cstate()
  call set_lattice_parameters(cst%latparam)

!空間群出力
  write(stdout, '(a)') '#START OF SPACE GROUP'
  call tspgds !TSPACE関数
  write(stdout, '(a)') '#END OF SPACE GROUP'
  write(stdout, '(a)') '#START OF K-POINTS'

!band_sym_input.dataの波動関数の情報が始まる行まで読み飛ばし
  if(readline_until_tag(fileno, '##PSIINPSTART') < 1 .or. &
       .not.readmagstate_psicoef(fileno))&
       stop 'read while reading PSIINPSTART'

!磁性を含めた計算であるかどうか
  kst%kpoint%isdouble = nspin > 1
!基本逆格子をブラベ逆格子に変換する行列(3x3)
  kst%trp2b = trp2b

!磁性を含めた計算のとき、reduce_up.dataとreduce_down.dataを出力用に開く。非磁性のとき、reduce.dataのみ出力用に開く。
!-----------------------------Modified by T.A.Ariasoca-------------------------------------------------
 if(ndim_spinor == 2) then
     if(.not.openOutput(freduce(1), './reduce_soc.data'))&
          stop 'error while opening reduce.data'
  else if(nspin == 2) then
!--------------------------------------------------------------------------------
     if(.not.openOutput(freduce(1), './reduce_up.data'))&
          stop 'error while opening reduce.data'
     if(.not.openOutput(freduce(2), './reduce_down.data'))&
          stop 'error while opening reduce.data'
  else
     if(.not.openOutput(freduce(1), './reduce.data'))&
          stop 'error while opening reduce.data'
  end if

!指標表の出力ファイルを開く
  if(.not.openOutput(ftex, './character.tex'))&
       stop 'error while opening character.tex'

!TeXのプリアンブル文を記述
  write(ftex,*) '\documentclass{article}'
  write(ftex,*) '\begin{document}'
  write(ftex,*) '\section{Character table}'
!band_sym_input.dataの各k点の状態が記述されている行まで読み飛ばし
  do while(readstate_psicoef(fileno))
!k点および点群の情報を変数に格納
     if(ikpoint > nikps) cycle
     kst%kpoint%index = ikpoint
     kst%kpoint%comp = nint(matmul(dble(ikps(1:3, ikpoint)), kst%trp2b))
     kst%kpoint%common_denom = ikps(4,ikpoint)
!k点の情報からk群と既約表現を取得する
     call set_kpoint_irep(kst%kpoint,nspin)
     kst%kgroup = get_kgroup()!this function set kgroup order
     call set_pg_name(kst%kgroup)
     call set_class(kst%kpoint, kst%kgroup)!this function set class number of class
     !call tspgcr
!k点と群の名前の出力
     call print_kpoint_and_kgroup(stdout, kst%kpoint, kst%kgroup)

!指標表の取得
     cht = get_character_table(kst%kpoint, kst%kgroup)!this function set number of representation
     !call print_character_table(cht, kst%kgroup, stdout)
!k-pathの中で名前が重複しないk点のとき、適合関係を計算するk点のリストに登録し、指標表を出力する
     if(.not.isDuplicateKpoint(kst%kpoint)) then
        call add_kpoint(kst%kpoint, cht)
        call print_character_table_for_TeX(cht, kst%kgroup, kst%kpoint, ftex)
     end if

!波動関数の簡約計算を行い、スピンごとに出力する
     call calcAll(kst, cht, fileno)
     do is = 1, nspin/ndim_spinor
        call printAll(kst, is, freduce(is))
     end do
     call deleteAll
  end do
!k点の簡約計算の終わり
  write(stdout, '(a)') '#END OF K-POINTS'
  close(stdout)
  open(stdout, status='scratch')

!ファイルのクローズ及びデータ領域の開放
  if(allocated(ikps)) deallocate(ikps)
  close(fileno)
  do is = 1, nspin/ndim_spinor
     close(freduce(is))
  end do

!TeXファイルに適合関係を出力する
  write(ftex,*) '\clearpage'
  write(ftex,*) '\section{Compatibility table}'
  call print_compat_table(ftex)
  write(ftex,*) '\end{document}'
  close(ftex)
  close(stdout)
  stop
end program main

C *******************************
C *                             *
C *  Coded by NEC CORPORATION.  *
C *                             *
C *******************************
C
      SUBROUTINE dgemm__
     &(TRANSA,TRANSB,NM,NL,NN,ALPHA,A,LMA,B,LNB,BETA,C,LMC)
      IMPLICIT NONE
C
C ::: ARGUMENTS :::
      CHARACTER TRANSA,TRANSB
      INTEGER  LMA,NM,NN,LNB,NL,LMC
      DOUBLE PRECISION A(LMA,*),B(LNB,*),C(LMC,*),ALPHA,BETA
C***********************************************************************
C
      CHARACTER TRANSAW,TRANSBW
      INTEGER MODE
      INTEGER MPANT,MMDNT,IPAR,IST,MM
      INTEGER NT,isw,ierr
      CHARACTER*80 F_RSVTASK
      ierr=0
      isw=1
C
CCCCC SETUP
C
      TRANSAW=TRANSA
      TRANSBW=TRANSB
      IF (TRANSA.EQ.'n') THEN
         TRANSAW='N'
      ELSE IF (TRANSA.EQ.'t') THEN
         TRANSAW='T'
      ELSE IF (TRANSA.EQ.'c') THEN
         TRANSAW='T'
      ELSE IF (TRANSA.EQ.'C') THEN
         TRANSAW='T'
      ENDIF
      IF (TRANSB.EQ.'n') THEN
         TRANSBW='N'
      ELSE IF (TRANSB.EQ.'t') THEN
         TRANSBW='T'
      ELSE IF (TRANSB.EQ.'c') THEN
         TRANSBW='T'
      ELSE IF (TRANSB.EQ.'C') THEN
         TRANSBW='T'
      ENDIF
C
C     GET NUMBER OF TASK
C
      CALL GETENV( "F_RSVTASK", F_RSVTASK)
      READ (F_RSVTASK,'(I8)') NT
      IF (NT.LE.0)THEN
         NT=8
c$$$         NT=1
      ENDIF

CCCCCCCCCCCCCCCCC
C
C   Quickly return if possible
C

      IF( ( NM.EQ.0 ).OR.( NL.EQ.0 ).OR.
     $    ((( ALPHA.EQ.0.0d0 ).OR.( NN.EQ.0 )).AND.( BETA.EQ.1.0d0)))
     $   RETURN



C
CCCCC MULTIPLICATION
C
C.... A * B
      IF(TRANSAW.EQ.'N'.AND.TRANSBW.EQ.'N')THEN
         IF(NM.GE.NL) THEN
            MODE=1
            IF(NL.LT.NT) THEN
               MODE=2
            ENDIF
         ELSE
            MODE=2
            IF(MOD(LNB,2).EQ.0 .AND. MOD(LMC,2).EQ.0) THEN
               MODE=1
            ENDIF
            IF(NM.LT.NT) THEN
               MODE=1
            ENDIF
         ENDIF
C     
         IF(MODE.EQ.1) THEN
            MPANT = NL/NT
            MMDNT = MOD(NL,NT)-1
!CDIR PARDO BY=1
            DO 110 IPAR = 0 , MIN(NT-1,NL-1)
               IF (IPAR.LE.MMDNT) THEN
                  MM = MPANT+1
               ELSE
                  MM = MPANT
               ENDIF
               IST = IPAR*MPANT + MIN(MMDNT+1,IPAR) + 1
!          CALL DAM1MM(A,LMA,NM,NN,B(1,IST),LNB,MM,C(1,IST),LMC,ISW,IERR)
               CALL DGEMM
     &              (TRANSA,TRANSB,NM,MM,NN,
     &              ALPHA,A,LMA,B(1,IST),LNB,BETA,C(1,IST),LMC)
 110        CONTINUE
         ELSE
            MPANT = NM/NT
            MMDNT = MOD(NM,NT)-1
!CDIR PARDO BY=1
            DO 120 IPAR = 0 , MIN(NT-1,NM-1)
               IF (IPAR.LE.MMDNT) THEN
                  MM = MPANT+1
               ELSE
                  MM = MPANT
               ENDIF
               IST = IPAR*MPANT + MIN(MMDNT+1,IPAR) + 1
!          CALL DAM1MM(A(IST,1),LMA,MM,NN,B,LNB,NL,C(IST,1),LMC,ISW,IERR)
               CALL DGEMM
     &              (TRANSA,TRANSB,MM,NL,NN,
     &              ALPHA,A(IST,1),LMA,B,LNB,BETA,C(IST,1),LMC)
 120        CONTINUE
         ENDIF
C.... A * B'
      ELSE IF(TRANSAW.EQ.'N'.AND.TRANSBW.EQ.'T')THEN
         IF(NM.GE.NL) THEN
            MODE=1
            IF(NL.LT.NT) THEN
               MODE=2
            ENDIF
         ELSE
            MODE=2
            IF(MOD(LMC,2).EQ.0) THEN
               MODE=1
            ENDIF
            IF(NM.LT.NT) THEN
               MODE=1
            ENDIF
         ENDIF
C     
         IF(MODE.EQ.1) THEN
            MPANT = NL/NT
            MMDNT = MOD(NL,NT)-1
!CDIR PARDO BY=1
            DO 210 IPAR = 0 , MIN(NT-1,NL-1)
               IF (IPAR.LE.MMDNT) THEN
                  MM = MPANT+1
               ELSE
                  MM = MPANT
               ENDIF
               IST = IPAR*MPANT + MIN(MMDNT+1,IPAR) + 1
!               CALL DAM1MT(A,LMA,NM,NN,B(IST,1),LNB,MM,C(1,IST),LMC,ISW,IERR)
               CALL DGEMM
     &              (TRANSA,TRANSB,NM,MM,NN,
     &              ALPHA,A,LMA,B(IST,1),LNB,BETA,C(1,IST),LMC)
 210        CONTINUE
         ELSE
            MPANT = NM/NT
            MMDNT = MOD(NM,NT)-1
               IF (MIN(NT-1,NM-1) .GE. 0) THEN
!CDIR PARDO BY=1
            DO 220 IPAR = 0 , MIN(NT-1,NM-1)
               IF (IPAR.LE.MMDNT) THEN
                  MM = MPANT+1
               ELSE
                  MM = MPANT
               ENDIF
               IST = IPAR*MPANT + MIN(MMDNT+1,IPAR) + 1
!               CALL DAM1MT(A(IST,1),LMA,MM,NN,B,LNB,NL,C(IST,1),LMC,ISW,IERR)
               CALL DGEMM
     &              (TRANSA,TRANSB,MM,NL,NN,
     &              ALPHA,A(IST,1),LMA,B,LNB,BETA,C(IST,1),LMC)
 220        CONTINUE
               ENDIF
         ENDIF
C.... A' * B
      ELSE IF(TRANSAW.EQ.'T'.AND.TRANSBW.EQ.'N')THEN
         IF(NM.GE.NL) THEN
            MODE=1
            IF(MOD(LMA,2).EQ.0 .AND. MOD(LNB,2).EQ.1) THEN
               MODE=2
            ENDIF
            IF(NL.LT.NT) THEN
               MODE=2
            ENDIF
         ELSE
            MODE=2
            IF(MOD(LNB,2).EQ.0 .AND. MOD(LMA,2).EQ.1) THEN
               MODE=1
            ENDIF
            IF(NM.LT.NT) THEN
               MODE=1
            ENDIF
         ENDIF
C     
         IF(MODE.EQ.1) THEN
            MPANT = NL/NT
            MMDNT = MOD(NL,NT)-1
!CDIR PARDO BY=1
            DO 310 IPAR = 0 , MIN(NT-1,NL-1)
               IF (IPAR.LE.MMDNT) THEN
                  MM = MPANT+1
               ELSE
                  MM = MPANT
               ENDIF
               IST = IPAR*MPANT + MIN(MMDNT+1,IPAR) + 1
!               CALL DAM1TM(A,LMA,NM,NN,B(1,IST),LNB,MM,C(1,IST),LMC,ISW,IERR)
               CALL DGEMM
     &              (TRANSA,TRANSB,NM,MM,NN,
     &              ALPHA,A,LMA,B(1,IST),LNB,BETA,C(1,IST),LMC)
 310        CONTINUE
         ELSE
            MPANT = NM/NT
            MMDNT = MOD(NM,NT)-1
!CDIR PARDO BY=1
            DO 320 IPAR = 0 , MIN(NT-1,NM-1)
               IF (IPAR.LE.MMDNT) THEN
                  MM = MPANT+1
               ELSE
                  MM = MPANT
               ENDIF
               IST = IPAR*MPANT + MIN(MMDNT+1,IPAR) + 1
!               CALL DAM1TM(A(1,IST),LMA,MM,NN,B,LNB,NL,C(IST,1),LMC,ISW,IERR)
               CALL DGEMM
     &              (TRANSA,TRANSB,MM,NL,NN,
     &              ALPHA,A(1,IST),LMA,B,LNB,BETA,C(IST,1),LMC)
 320        CONTINUE
         ENDIF
C.... A' * B'
      ELSE IF(TRANSAW.EQ.'T'.AND.TRANSBW.EQ.'T')THEN
         IF(NM.GE.NL) THEN
            MODE=1
            IF(MOD(LMA,2).EQ.0 .AND. MOD(LMC,2).EQ.1) THEN
               MODE=2
            ENDIF
            IF(NL.LT.NT) THEN
               MODE=2
            ENDIF
         ELSE
            MODE=2
            IF(MOD(LMA,2).EQ.1 .AND. MOD(LMC,2).EQ.0) THEN
               MODE=1
            ENDIF
            IF(NM.LT.NT) THEN
               MODE=1
            ENDIF
         ENDIF
C     
         IF(MODE.EQ.1) THEN
            MPANT = NL/NT
            MMDNT = MOD(NL,NT)-1
!CDIR PARDO BY=1
            DO 410 IPAR = 0 , MIN(NT-1,NL-1)
               IF (IPAR.LE.MMDNT) THEN
                  MM = MPANT+1
               ELSE
                  MM = MPANT
               ENDIF
               IST = IPAR*MPANT + MIN(MMDNT+1,IPAR) + 1
!               CALL DAM1TT(A,LMA,NM,NN,B(IST,1),LNB,MM,C(1,IST),LMC,ISW,IERR)
               CALL DGEMM
     &              (TRANSA,TRANSB,NM,MM,NN,
     &              ALPHA,A,LMA,B(IST,1),LNB,BETA,C(1,IST),LMC)
 410        CONTINUE
         ELSE
            MPANT = NM/NT
            MMDNT = MOD(NM,NT)-1
!CDIR PARDO BY=1
            DO 420 IPAR = 0 , MIN(NT-1,NM-1)
               IF (IPAR.LE.MMDNT) THEN
                  MM = MPANT+1
               ELSE
                  MM = MPANT
               ENDIF
               IST = IPAR*MPANT + MIN(MMDNT+1,IPAR) + 1
!               CALL DAM1TT(A(1,IST),LMA,MM,NN,B,LNB,NL,C(IST,1),LMC,ISW,IERR)
               CALL DGEMM
     &              (TRANSA,TRANSB,MM,NL,NN,
     &              ALPHA,A(1,IST),LMA,B,LNB,BETA,C(IST,1),LMC)
 420        CONTINUE
         ENDIF
      ENDIF
C
      RETURN
      END

!================================================
!  Software name : STM
!  Subroutine(s) : rsreal, tsort, cmpstr, skip_lines, getttr, hpsort,
!                  error
!  Author(s)     : Koichi Kato and Takahiro Yamasaki (June 7, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!
! $Id: bottom_Subroutines.F90,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
!                           @(#)bottom_Subroutines.F90 1.1 01/03/13 00:34:19
subroutine rsreal(n, obj)
  integer, intent(in) :: n
  integer, parameter :: DP = kind(1.d0)
  real(kind=DP), intent(out), dimension(n) :: obj

  integer :: i
  do i = 1, n
     obj(i) = 0.d0
  enddo
end subroutine rsreal

subroutine tsort(ecpu,msbrnm,iorder)
  implicit none
  integer, parameter :: DP = kind(1.d0)
  integer      , intent(in)    :: msbrnm
  real(kind=DP), intent(in), dimension(msbrnm) :: ecpu
  integer      , intent(out),dimension(msbrnm) :: iorder

  integer :: i,ib,ia,it
  do i = 1, msbrnm
     iorder(i) = i
  enddo
  do ib = 2, msbrnm
     do ia = 1, ib-1
        if(ecpu(iorder(ia)).lt.ecpu(iorder(ib))) then
           it = iorder(ia)
           iorder(ia) = iorder(ib)
           iorder(ib) = it
        endif
     enddo
  enddo
end subroutine tsort

subroutine cmpstr(name1,name2,nlen,ident)
  implicit none
  integer, intent(in) :: nlen
  character*(*), intent(in) :: name1, name2
  logical, intent(out) ::  ident

  character :: c
  integer   :: ndif,i

  ndif = ichar('A') - ichar('a')

  ident = .true.
  do i = 1, nlen
     c = name2(i:i)
     if(ichar(c).ge.ichar('a').and.ichar(c).le.ichar('z')) then
        c = char(ichar(c) + ndif)
     endif
     if(name1(i:i) .ne. c) goto 1001
  enddo
  goto 1002
1001 ident = .false.
1002 continue
end subroutine cmpstr

subroutine skip_lines(nfinp, nline)
  integer, intent(in) :: nfinp
  integer, intent(in) :: nline
  integer :: i
  do i = 1, nline
     read(nfinp,*)
  enddo
end subroutine skip_lines

subroutine getttr (rltv,ttr)
  implicit none
  integer, parameter :: DP = kind(1.d0)
  real(kind=DP), intent(in), dimension(3,3) :: rltv
  real(kind=DP), intent(out),dimension(6)   :: ttr

  integer i, j, jj

  call rsreal(6,ttr)
  do j = 1, 3
     jj = mod(j+1,3)
     if(jj.eq.0) jj = 3
     do i = 1, 3
        ttr(j) = ttr(j) + rltv(i,j)*rltv(i,j)
        ttr(j+3) = ttr(j+3) + 2.d0*rltv(i,j)*rltv(i,jj)
     enddo
  enddo
end subroutine getttr


subroutine hpsort(kn,n,bxyz,br)
!^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
!     THIS SUBROUTINE SORTS THE ELEMENTS OF ARRAY BR IN ASCENDING
!     ORDER. THE CODE IS BASED UPON HEAPSORT ALGORITHM WHICH HAS
!     N*LOG(N) SCALING BEHAVIOUR, PARTICULARLY FAVOURABLE FOR LARGE
!     VECTORS BR
!                              STEFAN BL"UGEL, ISSP, NOV 1989
!^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  implicit none
  integer, intent(in) :: kn, n
  real(kind=kind(1.d0)), intent(inout), dimension(kn,3) :: bxyz
  real(kind=kind(1.d0)), intent(inout), dimension(kn)   :: br
  integer   l,i,ii,iheap
  real*8    brr,bxx,byy,bzz

!=====> BUILD-UP OF THE HEAP
!
!-----> LOOP OVER ALL HIERACHICAL LEVELS OF THE HEAP TREE

  Loop_L :  do L = N/2 , 1 , -1
     brr = br(l)
     bxx = bxyz(l,1)
     byy = bxyz(l,2)
     bzz = bxyz(l,3)
     I   = L
     II  = L + L

!-----> GO DOWN ALL THE HIERACHICAL LEVELS OF THE HEAP TREE

20   IF ( II <= N ) THEN

!-----> COMPARE NEIGHBOURING ELEMENTS
        IF ( II < N ) THEN
           IF ( BR(II) < BR(II+1) ) II = II + 1
        ENDIF

!-----> COMPARE THE ELEMENTS OF TWO HIRACHICAL LEVELS
!       PROMOTE LARGER ONE, DEMOTE SMALLER ONE
        IF ( BRR < BR(II) ) THEN
           BR(I) = BR(II)
           bxyz(i,1) = bxyz(ii,1)
           bxyz(i,2) = bxyz(ii,2)
           bxyz(i,3) = bxyz(ii,3)
           I     = II
           II    = II + II
        ELSE

!-----> THIS PART OF THE TREE IS ORDERED , STOP BY PUTTING II=N+1
           II    = N + 1
        END IF
        GO TO 20
     END IF
!-----> PUT ELEMENTS IN THE PROPER SLOT
     br(i) = brr
     bxyz(i,1) = bxx
     bxyz(i,2) = byy
     bxyz(i,3) = bzz
  enddo Loop_L

!=====> NOW COLLECT ALL ELEMENTS FROM THE HEAP

  Loop_IHEAP : do IHEAP = N , 1 , -1

     brr = br(iheap)
     bxx = bxyz(iheap,1)
     byy = bxyz(iheap,2)
     bzz = bxyz(iheap,3)

!-----> THE FIRST ELEMENT IS ALWAYS THE LARGEST
     br(iheap) = br(1)
     bxyz(iheap,1) = bxyz(1,1)
     bxyz(iheap,2) = bxyz(1,2)
     bxyz(iheap,3) = bxyz(1,3)
!-----> NOW LARGEST ELEMENT OF ALL BR(I) WITH 1<=I<=IHEAP IS STORED

     I   = 1
     II  = 2

!-----> NOW GENERATE LARGEST ELEMENT OF BR(I) WITH 1<=I<=IHEAP-1

40   IF ( II <= IHEAP - 1 ) THEN

!-----> COMPARE NEIGHBOURING ELEMENTS
        IF ( II < IHEAP - 1 ) THEN
           IF ( BR(II) < BR(II+1) ) II = II + 1
        ENDIF

!-----> PROMOTE EACH ELEMENT OF THE TWIG OF BR UNTIL BRR > BR(I)
        IF ( BRR < BR(II) ) THEN
           br(i) = br(ii)
           bxyz(i,1) = bxyz(ii,1)
           bxyz(i,2) = bxyz(ii,2)
           bxyz(i,3) = bxyz(ii,3)
           I     = II
           II    = II + II
        ELSE

!-----> THIS PART OF THE TREE IS PROMOTED , STOP BY PUTTING II=IHEAP+1
           II    = IHEAP + 1
        END IF
        GO TO 40
     END IF
!-----> PUT ELEMENTS IN THE PROPER SLOT
     br(i) = brr
     bxyz(i,1) = bxx
     bxyz(i,2) = byy
     bxyz(i,3) = bzz
  enddo Loop_IHEAP
end subroutine hpsort

!!$subroutine eqivvl(value)
!!$c                by T.Yamasaki (JRCAT,ATP)
!!$  use m_Const_Parameters, only : DP
!!$  implicit none
!!$  real(kind=DP), intent(inout) :: value
!!$
!!$  logical flag
!!$#ifdef VPP
!!$#ifdef PARA
!!$  include 'nproc.inc'
!!$!xocl processor pe(npe)
!!$!xocl subprocessor pes(npe)=pe(1:npe)
!!$  include 'para_p.inc'
!!$  include 'inddef_p.inc'
!!$#endif
!!$#endif
!!$
!!$  flag = .false.
!!$!xocl spread do/ind_keg
!!$!xocl index 1
!!$  flag = .true.
!!$!xocl end spread
!!$!xocl broadcast(value) (flag)
!!$end subroutine eqivvl

subroutine error
  write(6,*) ' ! error '
end subroutine error

!PHASEの関数、一部を抜粋
!Copyright (C) 2002-2014 NIMS
!Copyright (C) 2014 Hiroyuki Oshima

module m_phase_commons
  implicit none
#define SCHOENFLIES(MAIN,SUB) MAIN//SUB
contains
!m_CS_SpaceGroup::get_point_group_name
  subroutine get_point_group_name(nfout,system,nsym,nopr,pg_name,pg_name_i)
    integer, intent(in) :: nfout
    character(len=9), intent(in) :: system
    integer, intent(in) :: nsym
    integer, intent(in) :: nopr(nsym)
    character(*), intent(out) :: pg_name
    character(*), intent(out) :: pg_name_i

    logical :: fexist(48)
    integer :: g,i

    fexist(1:48) = .false.
    do i=1,nsym
       fexist(nopr(i)) = .true.
    end do

    pg_name = SCHOENFLIES('C','1')
    pg_name_i = '1'
    g = nsym
    if(system(1:1) == 'c' .or. system(1:1) == 'C') then
       if(fexist(25)) then
! IE
          g = g/2
       end if
       if(g==1) then
          if(fexist(25)) then
! IE
100          pg_name = SCHOENFLIES('C','i')
             pg_name_i = '-1'
          else
             pg_name = SCHOENFLIES('C','1')
             pg_name_i = '1'
          end if
       else if(g==2) then
          if(fexist(2).or.fexist(3).or.fexist(4).or. &
           & fexist(13).or.fexist(14).or.fexist(15).or. &
           & fexist(16).or.fexist(17).or.fexist(18)) then
! C2x or C2y or C2z or
! C2a or C2b or C2c or
! C2d or C2e or C2f
             if(fexist(25)) then
! IE
                pg_name = SCHOENFLIES('C','2h')
                pg_name_i = '2/m'
             else
                pg_name = SCHOENFLIES('C','2')
                pg_name_i = '2'
             end if
          else if(fexist(26).or.fexist(27).or.fexist(28).or. &
                & fexist(37).or.fexist(38).or.fexist(39).or. &
                & fexist(40).or.fexist(41).or.fexist(42)) then
! IC2x or IC2y or IC2z or
! IC2a or IC2b or IC2c or
! IC2d or IC2e or IC2f
             pg_name = SCHOENFLIES('C','s')
             pg_name_i = 'm'
          end if
       else if(g==3) then
          if(fexist(25)) then
! IE
             pg_name = SCHOENFLIES('S','6')
             pg_name_i = '-3'
          else
             pg_name = SCHOENFLIES('C','3')
             pg_name_i = '3'
          end if
       else if(g==4) then
          if((fexist(2).and.fexist(3).and.fexist(4)).or.&
           & (fexist(2).and.fexist(16).and.fexist(18)).or.&
           & (fexist(3).and.fexist(15).and.fexist(17)).or.&
           & (fexist(4).and.fexist(13).and.fexist(14))) then
! C2x and C2y and C2z or
! C2x and C2d and C2f or
! C2y and C2c and C2e or
! C2z and C2a and C2b
             if(fexist(25)) then
! IE
                pg_name = SCHOENFLIES('D','2h')
                pg_name_i ='mmm'
             else
                pg_name =SCHOENFLIES('D','2')
                pg_name_i ='222'
             end if
          else if(fexist(26).or.fexist(27).or.fexist(28).or. &
                & fexist(37).or.fexist(38).or.fexist(39).or. &
                & fexist(40).or.fexist(41).or.fexist(42).and.&
                & .not.(fexist(19).or.fexist(20).or.fexist(21))) then
! IC2x or IC2y or IC2z or
! IC2a or IC2b or IC2c or
! IC2d or IC2e or IC2f
             pg_name =SCHOENFLIES('C','2v')
             pg_name_i ='mm2'
          else if((fexist(19).and.fexist(22)).or. &
                & (fexist(20).and.fexist(23)).or. &
                & (fexist(21).and.fexist(24))) then
! (C4x+ and C4x-) or (C4y+ and C4y-) or (C4z+ and C4z-)
             if(fexist(25)) then
! IE
                pg_name =SCHOENFLIES('C','4h')
                pg_name_i ='4/m'
             else
                pg_name =SCHOENFLIES('C','4')
                pg_name_i ='4'
             end if
          else if((fexist(43).and.fexist(46)).or. &
                & (fexist(44).and.fexist(47)).or. &
                & (fexist(45).and.fexist(48))) then
! (IC4x+ and IC4x-) or (IC4y+ and IC4y-) or (IC4z+ and IC4z-)
             pg_name =SCHOENFLIES('S','4')
             pg_name_i ='-4'
          end if
       else if(g==6) then
          if((fexist(5).and.fexist(14).and.fexist(17).and.fexist(18)) .or. &
           & (fexist(6).and.fexist(14).and.fexist(15).and.fexist(16)) .or. &
           & (fexist(7).and.fexist(13).and.fexist(15).and.fexist(18)) .or. &
           & (fexist(8).and.fexist(13).and.fexist(16).and.fexist(17))) then
! C31+ and C2b and C2e and C2f
! C32+ and C2b and C2c and C2d
! C33+ and C2a and C2c and C2f
! C34+ and C2a and C2d and C2e
             if(fexist(25)) then
! IE
                pg_name =SCHOENFLIES('D','3d')
                pg_name_i ='-3m'
             else
                pg_name =SCHOENFLIES('D','3')
                pg_name_i ='32'
             end if
          else
             pg_name =SCHOENFLIES('C','3v')
             pg_name_i ='3m'
          end if
       else if(g==8) then
          if((fexist(19).and.fexist(22)).or. &
           & (fexist(20).and.fexist(23)).or. &
           & (fexist(21).and.fexist(24))) then
! (C4x+ and C4x-) or (C4y+ and C4y-) or (C4z+ and C4z-)
             if(fexist(37).or.fexist(38).or.fexist(39).or. &
              & fexist(40).or.fexist(41).or.fexist(42)) then
! IC2a or IC2b or IC2c or IC2d or IC2e or IC2f
                if(fexist(25)) then
! IE
                   pg_name =SCHOENFLIES('D','4h')
                   pg_name_i ='4/mmm'
                else
                   pg_name =SCHOENFLIES('C','4v')
                   pg_name_i ='4mm'
                end if
             else
                pg_name =SCHOENFLIES('D','4')
                pg_name_i ='422'
             end if
          else
             pg_name =SCHOENFLIES('D','2d')
             pg_name_i ='-42m'
          end if
       else if(g==12) then
          if(fexist(25)) then
! IE
             pg_name ='Th'
             pg_name_i ='m-3'
          else
             pg_name ='T'
             pg_name_i ='23'
          end if
       else if(g==24) then
          if(fexist(19).and.fexist(22).and. &
           & fexist(20).and.fexist(23).and. &
           & fexist(21).and.fexist(24)) then
! C4x+ and C4x- and C4y+ and C4y- and C4z+ and C4z-
             if(fexist(25)) then
! IE
                pg_name =SCHOENFLIES('O','h')
                pg_name_i ='m-3m'
             else
                pg_name ='O'
                pg_name_i ='432'
             end if
          else
             pg_name ='Td'
             pg_name_i ='-43m'
          end if
       end if
    else if(system(1:1) == 'h' .or. system(1:1) == 'H') then! hexagonal
       if(fexist(13)) then
! IE
          g = g/2
          if(g==1) go to 100 !add By Tomita
       else if(fexist(16)) then
! IC2
          g = g/2
          if(g==1) go to 200 !add by Tomita
       end if
       if(g==2) then
           if(fexist(7).or.fexist(8).or.fexist(9).or. &
           & fexist(10).or.fexist(11).or.fexist(12).or.fexist(4)) then
! C211 or C221 or C231 or C212 or C222 or C232 or C2
             if(fexist(13)) then
! IE
                pg_name =SCHOENFLIES('C','2h')
                pg_name_i ='2/m'
             else
! add by oshima 2013 10 20              
                IF(FEXIST(19).OR.FEXIST(20).OR.FEXIST(21) &
                     .OR.FEXIST(22).OR.FEXIST(23).OR.FEXIST(24) &
                     )THEN
                   pg_name = SCHOENFLIES('C','2v')  
                   pg_name_i = 'mm2'
                else
!ccccccccccccccccccccccccccc
                   pg_name =SCHOENFLIES('C','2')
                   pg_name_i ='2'
                end if
             end if
          else if(fexist(19).or.fexist(20).or.fexist(21).or. &
                & fexist(22).or.fexist(23).or.fexist(24).or.fexist(16)) then
! IC211 or IC221 or IC231 or IC212 or IC222 or IC232 or IC2
200          pg_name =SCHOENFLIES('C','s')
             pg_name_i ='m'
          end if
       else if(g==3) then
          if(fexist(13)) then
! IE
             pg_name =SCHOENFLIES('S','6')
             pg_name_i ='-3'
          else if(fexist(16)) then
! IC2
             pg_name =SCHOENFLIES('C','3h')
             pg_name_i ='-6'
          else
             pg_name =SCHOENFLIES('C','3')
             pg_name_i ='3'
          end if
       else if(g==4) then
          if(fexist(4).and.( &
            & (fexist(7).and.fexist(10)).or. &
            & (fexist(8).and.fexist(11)).or. &
            & (fexist(9).and.fexist(12)))) then
! C2 and ( C211 and C212 ) or ( C221 and C222 ) or ( C231 and C232 ) 
             if(fexist(13)) then
! IE
                pg_name =SCHOENFLIES('D','2h')
                pg_name_i ='mmm'
             else
                pg_name =SCHOENFLIES('D','2')
                pg_name_i ='222'
             end if
          else if( (fexist(4).and.( &
            & (fexist(19).and.fexist(22)).or. &
            & (fexist(20).and.fexist(23)).or. &
            & (fexist(21).and.fexist(24))) ) .or. &
            & (fexist(16).and.( &
            & (fexist(7).and.fexist(22)).or. &
            & (fexist(8).and.fexist(23)).or. &
            & (fexist(9).and.fexist(24)).or. &
            & (fexist(19).and.fexist(10)).or. &
            & (fexist(20).and.fexist(11)).or. &
            & (fexist(21).and.fexist(12))) ) ) then
! C2 and (IC211 and IC212) or (IC221 and IC222) or (IC231 and IC232) 
! or IC2 and (C211 and IC212) or (C221 and IC222) or (C231 and IC232)
!         or (IC211 and C212) or (IC221 and C222) or (IC231 and C232)
             pg_name =SCHOENFLIES('C','2v')
             pg_name_i ='mm2'
          end if
       else if(g==6) then
          if(fexist(2).and.fexist(6)) then
! C6+ and C6-
             if(fexist(13)) then
! IE
                pg_name =SCHOENFLIES('C','6h')
                pg_name_i ='6/m'
             else
                pg_name =SCHOENFLIES('C','6')
                pg_name_i ='6'
             end if
          else if((fexist(7).and.fexist(8).and.fexist(9)) .or. &
                & (fexist(10).and.fexist(11).and.fexist(12))) then
! (C211 and C221 and C231) or (C212 and C222 and C232)
             if(fexist(13)) then
! IE
                pg_name =SCHOENFLIES('D','3d')
                pg_name_i ='-3m'
             else if(fexist(16)) then
! IC2
                pg_name =SCHOENFLIES('D','3h')
                pg_name_i ='-6m2'
             else
                pg_name =SCHOENFLIES('D','3')
                pg_name_i ='32'
             end if
          else if((fexist(19).and.fexist(20).and.fexist(21)) .or. &
                & (fexist(22).and.fexist(23).and.fexist(24))) then
! (IC211 and IC221 and IC231) or (IC212 and IC222 and IC232)
             pg_name =SCHOENFLIES('C','3v')
             pg_name_i ='3m'
          end if
       else if(g==12) then
          if(fexist(7).and.fexist(8).and.fexist(9).and. &
           & fexist(10).and.fexist(11).and.fexist(12)) then
! C211 and C221 and C231 and C212 and C222 and C232
             if(fexist(13)) then
! IE
                pg_name =SCHOENFLIES('D','6h')
                pg_name_i ='6/mmm'
             else
                pg_name =SCHOENFLIES('D','6')
                pg_name_i ='622'
             end if
          else if(fexist(19).and.fexist(20).and.fexist(21).and. &
                & fexist(22).and.fexist(23).and.fexist(24)) then
! IC211 and IC221 and IC231 and IC212 and IC222 and IC232
             pg_name =SCHOENFLIES('C','6v')
             pg_name_i ='6mm'
          end if
       end if
    else
       go to 20
    end if
    if(g>1 .and. trim(pg_name) == SCHOENFLIES('C','1')) then
20     write(nfout,*)'get_point_group_name: error'
       write(nfout,*)'system=',system
       write(nfout,*)'nsym=',nsym
       write(nfout,*)'g=',g
       write(nfout,*)'fexist=',fexist
!      stop 'get_point_group_name: error'
    end if
  end subroutine get_point_group_name
end module m_phase_commons

#define EXTRPL_DGEMM
  ! ========================================================================================
  ! extrapolate the wfs according to the algorithm described in Arias et al
  ! PRB45 1538 (1992)
  ! ========================================================================================

module m_ES_wf_extrpl

use m_Const_Parameters, only : DP,CMPLDP,ON,GAMMA,EXECUT
use m_Files, only : nfout
use m_Control_Parameters, only : ipripredictor, printable, sw_wf_predictor &
 & ,kimg, nspin, neg, rms_threshold
use m_ES_ortho, only : np_g1k_x,np_fs_x &
     & ,m_ESortho_set_np_g1k_x, m_ESortho_set_np_fs_x &
     & ,m_ES_W_transpose_r, m_ES_W_transpose_back_r &
     & ,m_ES_F_transpose_r, m_ES_F_transpose_back_r
use m_Kpoints, only : kv3,k_symmetry
use m_Timing, only : tstatc0_begin,tstatc0_end
use m_Electronic_Structure, only : zaj_l,fsr_l,fsi_l
use m_PlaneWaveBasisSet, only : kg1
use m_Parallelization, only : np_e, ista_k,iend_k, map_k,myrank_k,mpi_k_world, myrank_e,np_fs,np_g1k
use m_Ionic_System, only : m_IS_reset_extrpl_status
use m_PseudoPotential, only : modnrm,nlmta1_p,nlmta2_p,fqwei_p,nac_p,nlmta

! ============================ KT_Test ============================ 12.5Exp
#ifdef USE_ZAJ_HISTORY
use m_Control_Parameters,  only : af
use m_Parallelization,  only : MPI_CommGroup, ierr, mype, map_ek, map_z
#endif
! ================================================================= 12.5Exp
#ifdef _USE_SCALAPACK_
use m_Parallelization, only : nrank_e
#endif
use mpi
implicit none

!include 'mpif.h'
integer istatus(mpi_status_size)

real(kind=DP),allocatable, private, dimension(:,:,:,:) :: zaj_l_diff
real(kind=DP),allocatable, private, dimension(:,:,:,:) :: zaj_l_o
real(kind=DP),allocatable, private, dimension(:,:,:) :: fsr_l_o,fsi_l_o
complex(kind=CMPLDP),allocatable, private, dimension(:,:) :: almat
complex(kind=CMPLDP),private,parameter :: zero=(0.d0,0.d0)
complex(kind=CMPLDP),private,parameter :: one=(1.d0,0.d0)
#ifdef _USE_SCALAPACK_
integer, parameter :: nrank_g = 1
logical, save :: first_call = .true.
integer, save :: nprow, npcol, block_size = 32, lda, occ
integer, save :: ictxt, myrow, mycol
integer, allocatable, dimension(:,:), save :: usermap
integer, dimension(9), save :: desca, descz
integer, save :: lwork_ = -1, lrwork_ = -1, liwork_ = -1
#endif

contains

  subroutine m_ES_wf_extrpl_alloc()
    if(sw_wf_predictor==ON)then
       allocate(almat(neg,neg));almat=zero
       allocate(zaj_l_o(kg1,np_e,ista_k:iend_k,kimg));zaj_l_o=0.d0
       allocate(zaj_l_diff(kg1,np_e,ista_k:iend_k,kimg));zaj_l_diff=0.d0
       allocate(fsr_l_o(np_e,nlmta,ista_k:iend_k));fsr_l_o=0.d0
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
           allocate(fsi_l_o(np_e,nlmta,ista_k:iend_k));fsi_l_o=0.d0
       else
           allocate(fsi_l_o(1,1,1));fsi_l_o=0.d0
       endif
    endif
  end subroutine m_ES_wf_extrpl_alloc

  subroutine m_ES_wf_extrpl_dealloc()
    if(allocated(zaj_l_o)) deallocate(zaj_l_o)
    if(allocated(zaj_l_diff)) deallocate(zaj_l_diff)
    if(allocated(almat)) deallocate(almat)
    if(allocated(fsr_l_o)) deallocate(fsr_l_o)
    if(allocated(fsi_l_o)) deallocate(fsi_l_o)
  end subroutine m_ES_wf_extrpl_dealloc

! ===================== KT_TEST ================================= 12.5Exp
#ifdef USE_ZAJ_HISTORY

  subroutine m_ES_wf_rd_zaj_history
    integer, parameter:: file_id  = 350
!
    integer :: ib, ik, ri
!
    real(kind=DP), allocatable :: tmp1_zaj(:,:), tmp2_zaj(:,:)
    real(kind=DP), allocatable :: tmp1_fs(:),    tmp2_fs(:)
!
    if ( sw_wf_predictor /=ON ) return
!
    allocate( tmp1_zaj(kg1,kimg) ); tmp1_zaj = 0.0d0
    allocate( tmp2_zaj(kg1,kimg) ); tmp1_zaj = 0.0d0
!
    allocate( tmp1_fs(1:nlmta) ); tmp1_fs = 0.0d0
    allocate( tmp2_fs(1:nlmta) ); tmp2_fs = 0.0d0

    call mpi_barrier(MPI_CommGroup,ierr)

    do ik = 1, kv3, af+1
       do ib = 1, neg
          if (mype == 0) read(file_id) tmp1_zaj, tmp2_zaj, tmp1_fs, tmp2_fs

          if (mype == 0 .and. map_ek(ib,ik) /= 0) then ! MPI
             call mpi_send( tmp1_zaj, kg1*kimg, mpi_real, map_ek(ib,ik), 1, &
                  &         MPI_CommGroup, ierr )
             call mpi_send( tmp2_zaj, kg1*kimg, mpi_real, map_ek(ib,ik), 1, &
                  &          MPI_CommGroup, ierr )
             call mpi_send( tmp1_fs,  nlmta, mpi_real, map_ek(ib,ik), 1, &
                  &          MPI_CommGroup, ierr )
             call mpi_send( tmp2_fs,  nlmta, mpi_real, map_ek(ib,ik), 1, &
                  &          MPI_CommGroup, ierr )

          else if(map_ek(ib,ik) == mype .and. map_ek(ib,ik) /= 0) then
             call mpi_recv( tmp1_zaj, kg1*kimg, mpi_real, 0, &
                  &         1, MPI_CommGroup, istatus,ierr )!MPI
             call mpi_recv( tmp2_zaj, kg1*kimg, mpi_real, 0, &
                  &         1, MPI_CommGroup, istatus,ierr )!MPI
             call mpi_recv( tmp1_fs, nlmta, mpi_real, 0, &
                  &         1, MPI_CommGroup, istatus,ierr )!MPI
             call mpi_recv( tmp2_fs, nlmta, mpi_real, 0, &
                  &         1, MPI_CommGroup, istatus,ierr )!MPI
          endif

          if(map_ek(ib,ik) == mype) then              ! MPI
             do ri = 1, kimg
                zaj_l_o(1:kg1,map_z(ib),ik,ri)    = tmp1_zaj(1:kg1,ri)  ! MPI
                zaj_l_diff(1:kg1,map_z(ib),ik,ri) = tmp2_zaj(1:kg1,ri)  ! MPI
             end do
              fsr_l_o(map_z(ib),1:nlmta,ik) = tmp1_fs(1:nlmta)
              fsi_l_o(map_z(ib),1:nlmta,ik) = tmp2_fs(1:nlmta)
          end if

       end do
    end do

    deallocate(tmp1_zaj); deallocate(tmp2_zaj)
    deallocate(tmp1_fs); deallocate(tmp2_fs)

  end subroutine m_ES_wf_rd_zaj_history

  subroutine m_ES_wf_wd_zaj_history
    integer, parameter :: file_id = 350
!
    integer :: ri, ib, ik
!
    real(kind=DP), allocatable :: tmp1_zaj(:,:), tmp2_zaj(:,:)
    real(kind=DP), allocatable :: tmp1_fs(:),    tmp2_fs(:)

    if (sw_wf_predictor/=ON) return

    allocate( tmp1_zaj(kg1,kimg) ); tmp1_zaj = 0.0d0
    allocate( tmp2_zaj(kg1,kimg) ); tmp1_zaj = 0.0d0
!
    allocate( tmp1_fs(1:nlmta) ); tmp1_fs = 0.0d0
    allocate( tmp2_fs(1:nlmta) ); tmp2_fs = 0.0d0

    call mpi_barrier(MPI_CommGroup,ierr)

    do ik = 1, kv3, af+1
       do ib = 1, neg
          if(map_ek(ib,ik) == mype) then                          ! MPI
             do ri = 1, kimg
                tmp1_zaj(1:kg1,ri) = zaj_l_o(1:kg1,map_z(ib),ik,ri)
                tmp2_zaj(1:kg1,ri) = zaj_l_diff(1:kg1,map_z(ib),ik,ri)
             end do
             tmp1_fs(1:nlmta) = fsr_l_o(map_z(ib),1:nlmta,ik)
             tmp2_fs(1:nlmta) = fsi_l_o(map_z(ib),1:nlmta,ik)

             if (map_ek(ib,ik) /= 0) then
                call mpi_send( tmp1_zaj, kg1*kimg, mpi_real, 0, 1, &
                     &          MPI_CommGroup, ierr )
                call mpi_send( tmp2_zaj, kg1*kimg, mpi_real, 0, 1, &
                     &          MPI_CommGroup, ierr )
                call mpi_send( tmp1_fs,  nlmta, mpi_real, 0, 1, &
                     &          MPI_CommGroup, ierr )
                call mpi_send( tmp2_fs,  nlmta, mpi_real, 0, 1, &
                     &          MPI_CommGroup, ierr )
             endif

          else if(mype == 0 .and. map_ek(ib,ik) /= 0) then
             call mpi_recv( tmp1_zaj, kg1*kimg, mpi_real, map_ek(ib,ik), &
                  &         1, MPI_CommGroup, istatus,ierr )!MPI
             call mpi_recv( tmp2_zaj, kg1*kimg, mpi_real, map_ek(ib,ik), &
                  &         1, MPI_CommGroup, istatus,ierr )!MPI
             call mpi_recv( tmp1_fs, nlmta, mpi_real, map_ek(ib,ik), &
                  &         1, MPI_CommGroup, istatus,ierr )!MPI
             call mpi_recv( tmp2_fs, nlmta, mpi_real, map_ek(ib,ik), &
                  &         1, MPI_CommGroup, istatus,ierr )!MPI
          end if
          if (mype == 0) then
             write(file_id) tmp1_zaj, tmp2_zaj, tmp1_fs, tmp2_fs
          endif
       end do
    end do

    deallocate(tmp1_zaj); deallocate(tmp2_zaj)
    deallocate(tmp1_fs); deallocate(tmp2_fs)

  end subroutine m_ES_wf_wd_zaj_history
#endif
! =============================================================== 12.5Exp

  subroutine m_ES_wf_extrpl_doit(alpha,beta,rms,nextpl)
     real(kind=DP),intent(in) :: alpha,beta,rms
     integer, intent(in) :: nextpl
     real(kind=DP) :: r
     integer :: is,ik
     real(kind=DP),allocatable,dimension(:,:,:) :: wf_t
     complex(kind=CMPLDP),allocatable,dimension(:,:) :: wf1,wf2_in,wf3_in,wf2,wf3
     integer :: id_sname = -1
     real(kind=DP),allocatable,dimension(:,:) :: bpr_t,bpi_t,bpr_t_o,bpi_t_o
     integer :: stat, ierr
#ifdef _USE_SCALAPACK_
     integer :: i
     integer :: max_block_size, j, nb, nprocs, myrank, info
#endif
     call tstatc0_begin('m_ES_wf_extrpl ',id_sname,1)
     if(nextpl<2)then ! not ready
        zaj_l_diff(:,:,:,:) = zaj_l(:,:,:,:)-zaj_l_o(:,:,:,:)
        zaj_l_o(:,:,:,:) = zaj_l(:,:,:,:)
        if(modnrm==EXECUT)then
           fsr_l_o(:,:,:) = fsr_l(:,:,:)
           fsi_l_o(:,:,:) = fsi_l(:,:,:)
        endif
        return
     endif
#ifdef _USE_SCALAPACK_
     ! ScaLAPACK setup.
     if(first_call) then
        write(nfout,'(a)') 'ScaLAPACK setup in m_ES_wf_extrpl_doit!'

        ! Define nprow and npcol.
        nprow = int(sqrt(real(nrank_e*nrank_g)))
        do
           if(nprow <= 1) exit
           if(mod(nrank_g*nrank_e,nprow) == 0) exit
           nprow = nprow - 1
        end do
        npcol = nrank_g*nrank_e/nprow

        ! Define block size.
        max_block_size = neg/max(nprow, npcol)
        if(block_size > max_block_size) block_size = max_block_size

        write(nfout,'(a,3i8)') 'nprow, npcol, block_size: ', nprow, npcol, block_size

        ! Make usermap for BLACS.
        allocate(usermap(nprow, npcol))
        do j = 1, npcol
           do i = 1, nprow
              usermap(i, j) = myrank_k*nrank_e*nrank_g + (i-1)*npcol + (j-1)
           end do
        end do

        nb = block_size

        ! Define ScaLAPACK array size (lda, occ).
        ! - Number of blocks.
        if(mod(neg, nb) > 0) then
           lda = neg/nb + 1
        else
           lda = neg/nb
        end if
        occ = lda
        ! - Number of blocks/proc.
        if(mod(lda, nprow) > 0) then
           lda = lda/nprow + 1
        else
           lda = lda/nprow
        end if
        if(mod(occ, npcol) > 0) then
           occ = occ/npcol + 1
        else
           occ = occ/npcol
        end if
        lda = lda*nb
        occ = occ*nb

        write(nfout,'(a,2i8)') 'ScaLAPACK array size (lda, occ): ', lda, occ

        ! Make BLACS context.
        call mpi_comm_size(MPI_COMM_WORLD, nprocs, ierr)
        call mpi_comm_rank(MPI_COMM_WORLD, myrank, ierr)
        call blacs_setup(myrank, nprocs)

        call blacs_get(-1, 0, ictxt)
        call blacs_gridmap(ictxt, usermap, nprow, nprow, npcol)
        call blacs_gridinfo(ictxt, nprow, npcol, myrow, mycol)

        ! Make descripters.
        call descinit(desca, neg, neg, nb, nb, 0, 0, ictxt, lda, info)
        write(nfout,'(a,i3)') 'descinit for amat: info = ', info
        call descinit(descz, neg, neg, nb, nb, 0, 0, ictxt, lda, info)
        write(nfout,'(a,i3)') 'descinit for zmat: info = ', info
     end if
#endif

     if(modnrm==EXECUT)then
        call m_ESortho_set_np_fs_x() !-> np_fs_x
        allocate(bpr_t(np_fs_x,neg));bpr_t=0.d0
        allocate(bpi_t(np_fs_x,neg));bpi_t=0.d0
        allocate(bpr_t_o(np_fs_x,neg));bpr_t_o=0.d0
        allocate(bpi_t_o(np_fs_x,neg));bpi_t_o=0.d0
     endif
     do is=1,nspin
       do ik = is, kv3-nspin+is, nspin
          if(map_k(ik) /= myrank_k) cycle                   ! MPI
          call m_ESortho_set_np_g1k_x(ik) !-> np_g1k_x
          allocate(wf1(np_g1k_x,neg));wf1=zero
          allocate(wf2(np_g1k_x,neg));wf2=zero
          allocate(wf3(np_g1k_x,neg));wf3=zero
          allocate(wf2_in(np_g1k_x,neg));wf2_in=zero
          allocate(wf3_in(np_g1k_x,neg));wf3_in=zero
          allocate(wf_t(np_g1k_x,neg,kimg));wf_t=0.d0

          ! transpose curr wf
          call m_ES_W_transpose_r(.false.,ista_k,iend_k,ik,zaj_l,wf_t)
!!$!!x!!$          if(modnrm==EXECUT) call m_ES_F_transpose(ista_k,iend_k,ik,fsr_l,fsi_l,bpr_t,bpi_t)
          if(modnrm==EXECUT) &
               & call m_ES_F_transpose_r(.false.,ista_k,iend_k,ik,fsr_l,bpr_t,fsi_l,bpi_t)
          if(kimg==1)then
            wf1(:,:) = dcmplx(wf_t(:,:,1),0.d0)
          else
            wf1(:,:) = dcmplx(wf_t(:,:,1),wf_t(:,:,2))
          endif
          ! transpose old wf
          call m_ES_W_transpose_r(.false.,ista_k,iend_k,ik,zaj_l_o,wf_t)
!!x!!$          if(modnrm==EXECUT) call m_ES_F_transpose(ista_k,iend_k,ik,fsr_l_o,fsi_l_o,bpr_t_o,bpi_t_o)
          if(modnrm==EXECUT) call m_ES_F_transpose_r(.false.,ista_k,iend_k,ik &
               &                            ,fsr_l_o,bpr_t_o,fsi_l_o,bpi_t_o)
          if(kimg==1)then
            wf2_in(:,:) = dcmplx(wf_t(:,:,1),0.d0)
          else
            wf2_in(:,:) = dcmplx(wf_t(:,:,1),wf_t(:,:,2))
          endif

          ! transpose the difference of the wfs
          call m_ES_W_transpose_r(.false.,ista_k,iend_k,ik,zaj_l_diff,wf_t)
          if(kimg==1)then
            wf3_in(:,:) = dcmplx(wf_t(:,:,1),0.d0)
          else
            wf3_in(:,:) = dcmplx(wf_t(:,:,1),wf_t(:,:,2))
          endif

          ! align the wfs
          call check_wf_diff_norm(wf1,wf2_in,r)
          if(ipripredictor>=2.and.printable)then
             write(nfout,fmt='(a,i8,a,f20.10)') &
          & 'norm of the difference between the new and old wfs before alignment for kpoint no. ',ik,' : ',r
          endif
          call get_subspace_alignment_matrix(stat)
          if(stat/=0)then
             if(printable) write(nfout,'(a)') '!** WARN failed to obtain the subspace alignment matrix; &
         &   resetting extrapolation status'
!!x!!$             write(nfout,'(a)') '!** WARN failed to obtain the subspace alignment matrix; &
!!x!!$                  &   resetting extrapolation status'
!!x!!$             call flush(nfout)
!!x!!$             stop
             call m_IS_reset_extrpl_status()
             return
          endif

          ! apply the subspace alignment matrix to the wfs
          call zgemm('N','N',np_g1k_x,neg,neg,one,wf2_in,np_g1k_x,almat,neg,zero,wf2,np_g1k_x)
          call zgemm('N','N',np_g1k_x,neg,neg,one,wf3_in,np_g1k_x,almat,neg,zero,wf3,np_g1k_x)

          call check_wf_diff_norm(wf1,wf2,r)
          if(ipripredictor>=2.and.printable)then
             write(nfout,fmt='(a,i8,a,f20.10)') &
          & 'norm of the difference between the new and old wfs after  alignment for kpoint no. ',ik,' : ',r
          endif

          ! transpose back & store wfs
          wf_t(:,:,1) = dble(wf1(:,:))
          if(kimg>1)wf_t(:,:,2) = dimag(wf1(:,:))

          call m_ES_W_transpose_back_r(.false.,ista_k,iend_k,ik,zaj_l_o,wf_t)
!!X!!$          if(modnrm==EXECUT) call m_ES_F_transpose_back(ista_k,iend_k,ik,fsr_l_o,fsi_l_o,bpr_t,bpi_t)
          if(modnrm==EXECUT) call m_ES_F_transpose_back_r(.false.,ista_k,iend_k,ik &
               &                                ,fsr_l_o,bpr_t,fsi_l_o,bpi_t)

          ! extrapolate wfs, then transpose back
          if(rms<rms_threshold)then
             wf_t(:,:,1)   = dble(wf1(:,:)) &
          & +alpha*(dble(wf1(:,:))-dble(wf2(:,:)))+beta*dble(wf3(:,:))
             if(kimg>1)then
               wf_t(:,:,2)   = dimag(wf1(:,:)) &
            & +alpha*(dimag(wf1(:,:))-dimag(wf2(:,:)))+beta*dimag(wf3(:,:))
             endif
          endif
          call m_ES_W_transpose_back_r(.false.,ista_k,iend_k,ik,zaj_l,wf_t)
!!X!!$          if(modnrm==EXECUT) call m_ES_F_transpose_back(ista_k,iend_k,ik,fsr_l,fsi_l,bpr_t,bpi_t)
          if(modnrm==EXECUT) call m_ES_F_transpose_back_r(.false.,ista_k,iend_k,ik &
               &                                ,fsr_l,bpr_t,fsi_l,bpi_t)

          ! transpose back the diff of the wfs and store them
          wf_t(:,:,1) = dble(wf1(:,:))-dble(wf2(:,:))
          if(kimg>1)then
             wf_t(:,:,2) = dimag(wf1(:,:))-dimag(wf2(:,:))
          endif
!!$          call mpi_barrier(mpi_k_world(myrank_k),ierr)
          call m_ES_W_transpose_back_r(.false.,ista_k,iend_k,ik,zaj_l_diff,wf_t)

          deallocate(wf1)
          deallocate(wf_t)
          deallocate(wf2)
          deallocate(wf3)
          deallocate(wf2_in)
          deallocate(wf3_in)
       enddo
     enddo
     if(modnrm==EXECUT)then
       deallocate(bpr_t)
       deallocate(bpi_t)
       deallocate(bpr_t_o)
       deallocate(bpi_t_o)
     endif
     call tstatc0_end(id_sname)

  contains

  ! ========================================================================================
  ! calculate the subspace alignment matrix, as described in Arias et.al. PRB 45 1538 (1992).
  ! i.   Uno =  <new|S|old>
  ! ii.  UU = Uno^* x Uno
  ! iii. diagonalize UU -> eigvec => A^*, eigval => E
  ! iv.  A' = (1/sqrt(E)) x A U^*
  ! v.   the subspace alignment matrix is A'x A^*
  !
  ! note : ^* denotes complex conjugate, x dentoes matrix-matrix multiplication
  ! ========================================================================================
  subroutine get_subspace_alignment_matrix(stat)
    integer, intent(out) :: stat
    complex(kind=CMPLDP),allocatable,dimension(:,:) :: Amat,APmat,Umat,UUmat,eigvec
    real(kind=DP), allocatable, dimension(:) :: eigval
    integer,save :: lwork=-1
    integer :: ig,ib1,ib2,il,iu,info,nn,ierr,ig1,ia,p,q
    real(kind=DP) :: vl,vu,abstol,dlamch,ar,ai
    complex(kind=CMPLDP), allocatable, dimension(:) :: work
    complex(kind=CMPLDP) :: cbp,cbpo
    real(kind=DP),allocatable,dimension(:) :: rwork
    integer,allocatable,dimension(:) :: iwork,ifail
    real(kind=DP) :: eiginv,eigmin
#ifdef EXTRPL_DGEMM
    complex(kind=CMPLDP),allocatable,dimension(:,:) :: tmp1, tmp2
#endif
#ifdef _USE_SCALAPACK_
    complex(kind=CMPLDP),allocatable,dimension(:,:) :: UUmat_, eigvec_
    complex(kind=CMPLDP), allocatable, dimension(:) :: work_
    real(kind=DP),allocatable,dimension(:) :: eigval_, rwork_
    integer,allocatable,dimension(:) :: iwork_
! === This should be removed later!!! ====================================================
    integer :: i_, j_, ist, jst, iind, jind
! ========================================================================================
#endif
    allocate(Umat(neg,neg));Umat=zero
    allocate(UUmat(neg,neg));UUmat=zero
    if(lwork<0) lwork = 2*neg
    allocate(eigvec(neg,neg));eigvec=zero
    allocate(eigval(neg));eigval=0.d0
#ifdef _USE_SCALAPACK_
    allocate(UUmat_(lda, occ))
    allocate(eigvec_(lda, occ))
    allocate(eigval_(neg))
#endif
    allocate(rwork(7*neg));rwork=0.d0
    allocate(iwork(5*neg));iwork=0
    allocate(ifail(neg));ifail=0
    allocate(work(1:lwork));work=zero
    allocate(Amat(neg,neg));Amat=zero
    allocate(APmat(neg,neg));APmat=zero
    almat = zero
    do ib1=1,neg
       almat(ib1,ib1) = one
    enddo
#ifdef EXTRPL_DGEMM
    allocate(tmp1(nac_p, neg))
    allocate(tmp2(nac_p, neg))
#endif
#ifdef _USE_SCALAPACK_
    if(first_call) then
       allocate(work_ (1))
       allocate(rwork_(1))
       allocate(iwork_(1))
       call pzheevd('V', 'U', neg, UUmat_, 1, 1, desca, eigval_, eigvec_, 1, 1, descz, &
                    work_, lwork_, rwork_, lrwork_, iwork_, liwork_, info)
       lwork_  = int(dble(work_(1)))
       lrwork_ = int(rwork_(1))
       liwork_ = int(iwork_(1))
       deallocate(work_)
       deallocate(rwork_)
       deallocate(iwork_)

       first_call = .false.
    end if
    allocate(work_ (lwork_))
    allocate(rwork_(lrwork_))
    allocate(iwork_(liwork_))
#endif
    ! construct U=<new|S|old>
#ifndef EXTRPL_DGEMM
    do ib1=1,neg
      do ib2=1,neg
         ig1=1
         if(k_symmetry(ik)==GAMMA.and.myrank_e==0) ig1 = 2
         do ig=ig1,np_g1k_x
            Umat(ib1,ib2) = Umat(ib1,ib2) + dconjg(wf1(ig,ib1))*wf2_in(ig,ib2)
         enddo
         if(k_symmetry(ik)==GAMMA) Umat(ib1,ib2) = 2.d0*Umat(ib1,ib2)
         if(ig1==2) Umat(ib1,ib2) = Umat(ib1,ib2)+dconjg(wf1(1,ib1))*wf2_in(1,ib2)
         if(modnrm==EXECUT)then ! contribution from the overlap matrix
            do ia=1,nac_p
               p = nlmta1_p(ia);q = nlmta2_p(ia)
               if(k_symmetry(ik)==GAMMA)then
                  cbp=dcmplx(bpr_t(p,ib1),0.d0)
                  cbpo=dcmplx(bpr_t_o(q,ib2),0.d0)
               else
                  cbp=dcmplx(bpr_t(p,ib1),bpi_t(p,ib1))
                  cbpo=dcmplx(bpr_t_o(q,ib2),bpi_t_o(q,ib2))
               endif
               Umat(ib1,ib2) = Umat(ib1,ib2) + fqwei_p(ia)*dconjg(cbp)*cbpo
            enddo
         endif
         if(k_symmetry(ik)==GAMMA) Umat(ib1,ib2) = dcmplx(dble(Umat(ib1,ib2)),0.d0)
      enddo
    enddo
#else
    if(k_symmetry(ik) == GAMMA) then
       call zgemm('C','N',neg,neg,np_g1k_x,(2.0d0,0.0d0), &
                  wf1,np_g1k_x,wf2_in,np_g1k_x,(0.0d0,0.0d0),Umat,neg)
       if(myrank_e == 0) then
          do ib1 = 1, neg
             do ib2 = 1, neg
                Umat(ib1, ib2) = Umat(ib1, ib2) - dconjg(wf1(1, ib1))*wf2_in(1, ib2)
             end do
          end do
       end if
    else
       call zgemm('C','N',neg,neg,np_g1k_x,(1.0d0,0.0d0), &
                  wf1,np_g1k_x,wf2_in,np_g1k_x,(0.0d0,0.0d0),Umat,neg)
    end if

    if(modnrm == EXECUT) then ! contribution from the overlap matrix
! === DEBUG by tkato 2014/07/29 ================================================
       if(nac_p > 0) then
! ==============================================================================
       if(k_symmetry(ik) == GAMMA) then
          do ib1 = 1, neg
             do ia = 1, nac_p
                p = nlmta1_p(ia); q = nlmta2_p(ia)
                tmp1(ia, ib1) = fqwei_p(ia)*dcmplx(bpr_t  (p, ib1), 0.0d0)
                tmp2(ia, ib1) =             dcmplx(bpr_t_o(q, ib1), 0.0d0)
             end do
          end do
       else
          do ib1 = 1, neg
             do ia = 1, nac_p
                p = nlmta1_p(ia); q = nlmta2_p(ia)
                tmp1(ia, ib1) = fqwei_p(ia)*dcmplx(bpr_t  (p,ib1), bpi_t  (p,ib1))
                tmp2(ia, ib1) =             dcmplx(bpr_t_o(q,ib1), bpi_t_o(q,ib1))
             end do
          end do
       end if
       call zgemm('C','N',neg,neg,nac_p,(1.0d0,0.0d0), &
                  tmp1,nac_p,tmp2,nac_p,(1.0d0,0.0d0),Umat,neg)
       if(k_symmetry(ik) == GAMMA) then
          do ib1 = 1, neg
             do ib2 = 1, neg
                Umat(ib1,ib2) = dcmplx(dble(Umat(ib1, ib2)), 0.d0)
             end do
          end do
       end if
! === DEBUG by tkato 2014/07/29 ================================================
       end if
! ==============================================================================
    end if
#endif
    call mpi_allreduce(MPI_IN_PLACE,Umat,neg*neg,mpi_double_complex,mpi_sum,mpi_k_world(myrank_k),ierr)

    ! calculate UU=U^* U
    call zgemm('C','N',neg,neg,neg,one,Umat,neg,Umat,neg,zero,UUmat,neg)

#ifdef _USE_SCALAPACK_
! === This should be removed later!!! ====================================================
    ist = myrow*block_size + 1
    jst = mycol*block_size + 1
    jind = 0
    do j_ = jst, neg, block_size*npcol
       do ib2 = j_, j_+block_size-1
          if(ib2 <= neg) then
             jind = jind + 1
             iind = 0
             do i_ = ist, neg, block_size*nprow
                do ib1 = i_, i_+block_size-1
                   if(ib1 <= neg) then
                      iind = iind + 1
                      UUmat_(iind,jind) = UUmat(ib1,ib2)
                   end if
                enddo
             enddo
          end if
       enddo
    enddo
! ========================================================================================
#endif
    ! diagonalize UU
    vl=0.d0;vu=0.d0;il=0;iu=0
    abstol = 2*dlamch('S')
#ifndef _USE_SCALAPACK_
    call zheevx('V','A','U',neg,UUmat,neg,vl,vu,il,iu,abstol,nn,eigval,eigvec,neg, &
         &  work,lwork,rwork,iwork,ifail,info)
    if(info==0) then
       lwork = int(work(1))
    else
       stat = info
       return
    endif
#else
    call pzheevd('V', 'U', neg, UUmat_, 1, 1, desca, eigval_, eigvec_, 1, 1, descz, &
                 work_, lwork_, rwork_, lrwork_, iwork_, liwork_, info)
    if(info /= 0) then
       stat = info
       return
    endif
#endif
#ifdef _USE_SCALAPACK_
! === This should be removed later!!! ====================================================
    eigval = eigval_

    eigvec = (0.0d0, 0.0d0)
    ist = myrow*block_size + 1
    jst = mycol*block_size + 1
    jind = 0
    do j_ = jst, neg, block_size*npcol
       do ib2 = j_, j_+block_size-1
          if(ib2 <= neg) then
             jind = jind + 1
             iind = 0
             do i_ = ist, neg, block_size*nprow
                do ib1 = i_, i_+block_size-1
                   if(ib1 <= neg) then
                      iind = iind + 1
                      eigvec(ib1,ib2) = eigvec_(iind,jind)
                   end if
                enddo
             enddo
          end if
       enddo
    enddo
    call mpi_allreduce(MPI_IN_PLACE,eigvec,neg*neg,mpi_double_complex,mpi_sum,MPI_COMM_WORLD,ierr)
! ========================================================================================
#endif
    eigmin = minval(dabs(eigval))
    if(eigmin<1.d-15)then
       if(printable) write(nfout,'(a,f15.10)') ' !** minimum eigen value is too small : ',eigmin
       stat = 1
       return
    endif

    ! eigvec^* -> Amat
    do ib1=1,neg
      do ib2=1,neg
        Amat(ib2,ib1) = dconjg(eigvec(ib1,ib2))
      enddo
    enddo

    ! calculate APmat = (1/sqrt(E)) x A x U^*
    call zgemm('N','C',neg,neg,neg,one,Amat,neg,Umat,neg,zero,APmat,neg)
    do ib1=1,neg
      eiginv = 1.d0/dsqrt(eigval(ib1))
      do ib2=1,neg
        APmat(ib1,ib2) = eiginv*APmat(ib1,ib2)
      enddo
    enddo

    ! calculate Ap^* x A and store it to Umat
    Umat = zero
    call zgemm('C','N',neg,neg,neg,one,APmat,neg,Amat,neg,zero,Umat,neg)

    ! the c.c. of Umat is the subspace alignment matrix we want
    do ib1=1,neg
      do ib2=1,neg
        almat(ib1,ib2) = dconjg(Umat(ib2,ib1))
      enddo
    enddo
    stat = 0
    deallocate(Umat)
    deallocate(UUmat)
    deallocate(eigvec)
    deallocate(eigval)
    deallocate(rwork)
    deallocate(iwork)
    deallocate(ifail)
    deallocate(work)
    deallocate(Amat)
    deallocate(APmat)
#ifdef EXTRPL_DGEMM
    deallocate(tmp1)
    deallocate(tmp2)
#endif
#ifdef _USE_SCALAPACK_
    deallocate(UUmat_)
    deallocate(eigvec_)
    deallocate(eigval_)
    deallocate(rwork_)
    deallocate(iwork_)
    deallocate(work_)
#endif
  end subroutine get_subspace_alignment_matrix

  subroutine check_wf_diff_norm(wf1,wf2,rsum)
    complex(kind=CMPLDP),dimension(:,:),intent(in) :: wf1,wf2
    real(kind=DP),intent(out) :: rsum
    real(kind=DP) :: r
    complex(kind=CMPLDP) :: cbp,cbpo
    integer :: ib,ig,ierr,ig1,p,q,ia
    rsum=0.d0
    do ib=1,neg
       ig1=1
       r=0.d0
       if(k_symmetry(ik)==GAMMA.and.myrank_e==0) ig1 = 2
       do ig=ig1,np_g1k_x
          r = r+dconjg(wf1(ig,ib)-wf2(ig,ib))*(wf1(ig,ib)-wf2(ig,ib))
       enddo
       if(k_symmetry(ik)==GAMMA) r=2*r
       if(ig1==2) r=r+dconjg(wf1(1,ib)-wf2(1,ib))*(wf1(1,ib)-wf2(1,ib))
       rsum = rsum+r
    enddo
    call mpi_allreduce(MPI_IN_PLACE,rsum,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
  end subroutine check_wf_diff_norm

  ! ========================================================================================
  ! 'align' the wfs by the subspace alignment matrix
  ! this is done to the old wf and the diff of the wfs,
  ! so that they are 'aligned' to the current wf
  ! ========================================================================================
  subroutine align_wfs(wf,wf_aligned)
    complex(kind=CMPLDP),dimension(:,:),intent(in) :: wf
    complex(kind=CMPLDP),dimension(:,:),intent(out) :: wf_aligned
    complex(kind=CMPLDP) :: matelem
    integer :: ib1,ib2,ig,ierr
    wf_aligned = zero
    do ib1=1,neg
      do ib2=1,neg
         matelem = almat(ib2,ib1)
         do ig=1,np_g1k_x
           if(k_symmetry(ik)==GAMMA)then
              wf_aligned(ig,ib1) = wf_aligned(ig,ib1)+dble(matelem)*wf(ig,ib2)
           else
              wf_aligned(ig,ib1) = wf_aligned(ig,ib1)+matelem*wf(ig,ib2)
           endif
         enddo
      enddo
    enddo
  end subroutine align_wfs

  end subroutine m_ES_wf_extrpl_doit

end module m_ES_wf_extrpl

!ソースコードを簡略化するためのマクロ群(fortranのソースコードでのみ使用)
!Copyright (C) 2014-2015 Ryosuke Tomita
        
#define nxyz_ 3
#define NameLen 20
#define NOP_MAX_CUB 48
#define NOP_MAX_HEX 24

#define CUBIC_C2 2:4,13:18
#define CUBIC_C3 5:12
#define CUBIC_C4 19:24
#define CUBIC_IE 25
#define CUBIC_IC2 26:28,37:42

#define HEX_C2 4,7:12
#define HEX_C3 3,5
#define HEX_C6 2,6
#define HEX_IE 13
#define HEX_IC2 16,19:24

#define READSELECT(nfin) \
  select case(readline(nfin));\
  case(-1); return;\
  case(0); exit;\
  end select
#define READTAG(tag) (index(linebuf, tag) > 0)
#define READLINEERR(nfin) (readline(nfin) < 1)
#define READERR(nfin, tag) (READLINEERR(nfin) .or. READTAG(tag))

#define COMPLEX_T complex(kind(0d0))
#define DOUBLE_T double precision
#define TAG_T character(len=2)

#define CMPLX_(a,b) dcmplx(a,b)
#define CEXP_(a) cdexp(a)
#define TEX_CAPTION_FOR_CHARTABLE(K) '\caption{Character table and relation between classes and operators for $'//K//'$}'
#define TEX_CAPTION_FOR_COMTABLE(K1,K2) '\caption{Compatibility table for $'//K1//'$ and $'//K2//'$}'
#define TEX_BEGINTABLE '\begin{table}[htbp]'
#define TEX_ADJUST '\centering'
#define TEX_ENDTABLE '\end{table}'
#define TEX_BEGINTABULAR(NC) '\begin{tabular}{*{',(NC),'}{|c}|}\hline'
#define TEX_ENDTABULAR '\end{tabular}'
#define TEX_COMPAT_NAME(K,IMR) (trim(K)//'_'//trim(IMR))

#define INDEX_L_ORDER_CONFLICT
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  MODULE: m_Ldos
!
!  AUTHOR(S): T. Yamasaki   January/18/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
module m_Ldos
! $Id: m_Ldos.F90 633 2020-12-01 05:11:03Z jkoga $
  use m_Const_Parameters, only   : DP, CMPLDP, REGULAR_INTERVALS, BY_ATOMIC_POSITIONS &
       &                         , DELTA10, EXECUT, ON, SOFTPART, HARDPART, DIRECT, PAI2 &
       &                         , ALDOS, LAYERDOS, NO, OFF, ELECTRON, BOHR
  use m_Control_Parameters, only : kimg, sw_aldos, sw_layerdos, crtdst_aldos, naldos_from, naldos_to &
       &                         , slicing_way_winlay, deltaz_winlay, normal_axis_winlay &
       &                         , crtdst_winlay,crtdst_is_given, nspin, neg, ipridos,ekmode &
       &                         , af, printable, hardpart_subroutine, sw_rspace_ldos, sw_save_ldos_weight &
       &                         , integration_dimension_winlay, sw_checksum &
       &                         , m_CtrlP_check_naldos_range &
       &                         , sw_ac_mesh, acmesh_factor, ipriparallel, sw_modified_kpoint_increment
  use m_Files, only              : nfout, nfldos &
       &                         , m_Files_open_nfldos, m_Files_close_nfldos
  use m_Crystal_Structure, only :  altv, rltv, univol
  use m_Ionic_System,   only :     natm2,natm,cps,numlay,ityp,iwei,if_aldos,pos
  use m_Parallelization, only :    ista_e,iend_e,istep_e, np_e, map_z, npes, ierr, mype &
       &                         , map_k, myrank_k, map_ek, ista_kngp, iend_kngp, ista_k, iend_k &
       &                         , nrank_k, myrank_e, map_e, MPI_CommGroup &
       &                         , nel_fft_z, nel_fftcd_z, neg_g,  map_fft_x, map_fft_y, map_fft_z &
       &                         , mpi_kg_world, mpi_ke_world, mpi_ge_world, myrank_g, mpi_chg_world &
       &                         , xyz_fftcd_z, xyz_fft_z, ista_atm2, iend_atm2, m_Parallel_init_mpi_atm2 &
       &                         , m_Parallel_init_mpi_atm_f &
       &                         , map_fftcd_z, xyz_fftcd_x,map_fftcd_x, xyz_fftcd_y, map_fftcd_y, ista_atm_f,iend_atm_f &
       &                         , nis_kv3_ek
  use m_Kpoints, only :            kv3, kv3_ek
  use m_FFT, only :                nfft, nfftp,nfftp_nonpara, fft_box_size_WF, fft_box_size_CD &
       &                         , fft_box_size_CD_nonpara &
       &                         , m_FFT_alloc_CD_box, m_FFT_dealloc_CD_box &
       &                         , m_FFT_CD_inverse0 &
       &                         , m_FFT_alloc_WF_work, m_FFT_dealloc_WF_work, m_FFT_CD_direct0
  use m_PlaneWaveBasisSet, only :  kg, igf, ngabc, kgp, kg1
  use m_PseudoPotential, only :    modnrm
!$$  use m_Electronic_Structure,only :neordr, totch, efermi &
!$$       &                         , m_ES_WF_in_Rspace &
!$$       &                         , m_ES_wd_zaj_small_portion
  use m_Electronic_Structure,only :neordr, totch, efermi
  use m_Electronic_Structure,only :m_ES_WF_in_Rspace_3D &
       &                         , m_ES_wd_zaj_small_portion_3D &
       &                         , m_ES_WF_in_Rspace_kt_3D, zaj_l
 use m_Charge_Density, only :     chgq_l, chgq_enl &
       &                         , m_CD_hardpart_sub &
       &                         , m_CD_map_valence_charge_to_fft_box &
       &                         , m_CD_map_fft_box_to_chgqenl &
       &                         , m_CD_restore_chgq &
       &                         , m_CD_cp_chgq_to_chgqo & !ASMS
       &                         , m_CD_map_chgq_to_fft_box &
       &                         , m_CD_set_ylm_enl_etc &
       &                         , m_CD_dealloc_ylm_enl_etc &
       &                         , m_CD_keep_retrieve_hsr


! ============================== added by K. Tagami ============== 11.0
  use m_Control_Parameters,    only : noncol, ndim_magmom, ndim_spinor, sw_fft_xzy
!  use m_Charge_Density, only :    m_CD_hardpart_sub_noncl, &
!       &                          m_CD_hardpart_sub2_noncl, &
!       &                          m_CD_map_chgqenl_to_fft_box_kt
! ================================================================ 11.0
  use m_Control_Parameters,   only : num_extra_bands, sw_rspace_lband, &
       &                             sw_calc_wf_atom_decomposition, &
       &                             sw_calc_wf_layer_decomposition, sw_lband, &
       &                             sw_wd_only_specified_atoms, &
       &                             sw_band_unfolding, band_unfolding_active

  use m_PlaneWaveBasisSet, only :  ngabc_kngp_l
  use m_FFT, only : m_FFT_Direct_3D,m_FFT_Direct_XYZ_3D
  use m_Parallelization, only : mpi_ge_world, mpi_g_world
  use m_Charge_Density, only : m_CD_map_chgq_l_to_fft_l_box

  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use mpi

  implicit none

  integer, private, target, allocatable, dimension(:,:,:) ::  mesh, meshp, meshl, meshpl

  integer ::  nlayer = 0
  integer ::  mlayer = 1
  integer ::  naldos = 0
  integer, private :: naldos_write = 0
  integer ::  maldos = 1
  integer, private ::  n_total_ldoscal = 0
  real(kind=DP),private,allocatable,dimension(:,:)  :: winlay ! d(mlayer,2)
  integer, private, allocatable, dimension(:)       :: nmeshlay, nmeshplay ! d(mlayer)
!  real(kind=DP),public,allocatable,dimension(:,:,:,:) :: weiwsc ! d(maldos,neg|np_e,1|ista_k:iend_k,nspin)
!  real(kind=DP),public,allocatable,dimension(:,:,:,:) :: weilay ! d(mlayer,neg|np_e,1|ista_k:iend_k,nspin)
  real(kind=DP),public,allocatable,dimension(:,:,:) :: weiwsc ! d(maldos,neg|np_e,1|ista_k:iend_k)
  real(kind=DP),public,allocatable,dimension(:,:,:) :: weilay ! d(mlayer,neg|np_e,1|ista_k:iend_k)
!  real(kind=DP),private,allocatable,dimension(:) ::    bfft   ! d(nfft)
  real(kind=DP),private :: maxhv, maxv
  real(kind=DP),private :: height
  integer,private,allocatable,dimension(:) :: if_aldos_full ! d(natm2)

  character(len("HARDPART")), private, dimension(2) :: tag_Hard_or_Soft = (/'SOFTPART','HARDPART'/)

! ============================= added by K. Tagami ===================== 11.0
  real(kind=DP),public,allocatable,dimension(:,:,:,:) :: weiwsc_noncl
  real(kind=DP),public,allocatable,dimension(:,:,:,:) :: weilay_noncl
! ====================================================================== 11.0

  integer, parameter :: ilen = 5

  integer, allocatable, target, dimension(:,:,:) :: ac_mesh,ac_mesh_cd
  integer, allocatable, target, dimension(:) :: nac_mesh,nac_mesh_cd

  real(kind=DP), allocatable, dimension(:,:,:,:) :: dos_weight_ek

  integer :: natom_decomp
  integer, allocatable :: atom_decomp_map(:)

!  include 'mpif.h'
  integer istatus(mpi_status_size)

contains
  integer function m_Ldos_what_is_n_total_ldos()
!!$    m_Ldos_what_is_n_total_ldos = n_total_ldos
    m_Ldos_what_is_n_total_ldos = naldos_write + mlayer
  end function m_Ldos_what_is_n_total_ldos

  subroutine m_Ldos_preparation()

    if(sw_aldos == ON .or. sw_calc_wf_atom_decomposition==ON ) then
       call set_naldos()      ! -> naldos, maldos
       call m_CtrlP_check_naldos_range(nfout,maldos)
!!$       call check_naldos_range()
       call set_if_aldos_full()
       call set_naldos_write()
       call alloc_mesh()
       call fillup_mesh(fillmode=ALDOS)
    end if
    if ( sw_calc_wf_atom_decomposition==ON ) call set_natom_decomp()

    call set_nlayer()
    if(sw_layerdos == ON .or. sw_calc_wf_layer_decomposition==ON ) then
       call alloc_winlay()
       call set_winlay()
       if(integration_dimension_winlay==3) then
          call alloc_meshl()
!!$          call fillup_meshl(fillmode=LAYERDOS)
          call fillup_mesh(fillmode=LAYERDOS)
       end if
!!$       call dealloc_winlay()
    end if
  end subroutine m_Ldos_preparation

  subroutine set_naldos()
    naldos = natm2
    maldos = naldos + 1
  end subroutine set_naldos

!!$  subroutine check_naldos_range()
!!$    if(naldos_from == 0 .and. naldos_to == 0) then
!!$       naldos_from = 1
!!$       naldos_to   = maldos
!!$    else
!!$       if(naldos_from < 1)     naldos_from = 1
!!$       if(naldos_from > maldos) naldos_from = maldos
!!$       if(naldos_to < 1)       naldos_to   = 1
!!$       if(naldos_to > maldos)   naldos_to   = maldos
!!$       if(naldos_to < naldos_from) naldos_to = naldos_from
!!$    end if
!!$    write(nfout,'(" !!ldos naldos_from         = ",i6," <<check_naldos_range>>")') naldos_from
!!$    write(nfout,'(" !!ldos naldos_to           = ",i6," <<check_naldos_range>>")') naldos_to
!!$  end subroutine check_naldos_range

  subroutine set_if_aldos_full()
    integer, allocatable, dimension(:) :: ip_atom
    integer :: i, nb

    if(.not.allocated(if_aldos_full)) allocate(if_aldos_full(naldos_from:naldos_to))
    if(.not.allocated(ip_atom)) allocate(ip_atom(natm2+1)); ip_atom = 0

    nb = natm
    do i = 1, natm
       ip_atom(i) = i
       if(iwei(i) == 2) then
          nb = nb + 1
          ip_atom(nb) = i
       end if
    end do

    do i = 1, natm2
       if(ip_atom(i) == 0) then
          if(ipridos>=1) write(nfout,'(" !!ldos i, ip_atom = ",i5,i5)') i,ip_atom(i)
          call phase_error_with_msg(nfout,' ip_atom is illegal <<set_if_aldos_full>>',__LINE__,__FILE__)
       end if
    end do

    if_aldos_full = OFF
    do i = naldos_from, naldos_to
       if(i <= natm2) then
          if_aldos_full(i) = if_aldos(ip_atom(i))
       else
          if_aldos_full(i) = ON
       end if
    end do

    nb = 0
    ip_atom = 0
    do i = naldos_from, naldos_to
       if(if_aldos_full(i) == ON) then
          nb = nb + 1
          ip_atom(nb) = i
       end if
    end do
    if(ipridos>=1) write(nfout,'(" !!ldos aldos_atoms = ",10i5)') (ip_atom(i),i=1,nb)

    deallocate(ip_atom)
  end subroutine set_if_aldos_full

  subroutine set_naldos_write()
    integer :: i
    naldos_write = 0
    do i = naldos_from, naldos_to
       if(if_aldos_full(i) == ON) naldos_write = naldos_write + 1
    end do
    if(ipridos>=1) write(nfout,'(" !!ldos naldos_write = ",i5)') naldos_write
!!$    naldos_write = naldos_to - naldos_from + 1
  end subroutine set_naldos_write

  subroutine set_natom_decomp()
    integer :: i

    natom_decomp = 0
    if ( sw_wd_only_specified_atoms == ON ) then
       do i = 1, natm2
          if(if_aldos_full(i) == ON) natom_decomp = natom_decomp +1
       end do
    else
       natom_decomp = natm2
    endif

    allocate( atom_decomp_map(natom_decomp+1) )

    natom_decomp = 0
    if ( sw_wd_only_specified_atoms == ON ) then
       do i = 1, natm2
          if(if_aldos_full(i) == ON) natom_decomp = natom_decomp +1
          atom_decomp_map( natom_decomp ) = i
       end do
    else
       do i = 1, natm2
          natom_decomp = natom_decomp +1
          atom_decomp_map( natom_decomp ) = i
       end do
    endif
    atom_decomp_map( natom_decomp +1 ) = natm2 +1

  end subroutine set_natom_decomp

  subroutine set_nlayer()
    integer :: i,j, io,jo
    real(kind=DP) :: h
    integer, allocatable, dimension(:) :: layer_index, layer_order

    if (sw_layerdos == ON .or. sw_calc_wf_layer_decomposition==ON ) then
       call get_height(h)
       height = h
       if(slicing_way_winlay == REGULAR_INTERVALS) then
!!$       call get_height(h)
          if(kimg == 1) h = h*0.5d0
          nlayer = h/deltaz_winlay + (1-DELTA10)
          mlayer = nlayer + 1
       else if(slicing_way_winlay == BY_ATOMIC_POSITIONS) then
          allocate(layer_index(natm))
          nlayer = 1
          layer_index(nlayer) = numlay(1)
          do i = 2, natm
             do j = 1, nlayer
                if(layer_index(j) == numlay(i)) goto 1001
             end do
             nlayer = nlayer + 1
             layer_index(nlayer) = numlay(i)
1001         continue
          end do
          if(minval(layer_index(1:nlayer)) /= 1 .or. maxval(layer_index(1:nlayer)) /= nlayer) then
             allocate(layer_order(nlayer)); layer_order(:) = (/(i,i=1,nlayer)/)
             do i = 1, nlayer-1
                do j = i+1, nlayer
                   io = layer_order(i)
                   jo = layer_order(j)
                   if(layer_index(io) < layer_index(io)) then
                      layer_order(j) = io
                      layer_order(i) = jo
                   end if
                end do
             end do
             if(ipridos>=1) then
                write(nfout,'(" !!ldos i, layer_index, layer_order <<m_Ldos.set_nlayer>>")')
                do i = 1, nlayer
                   write(nfout,'(" !!ldos ",3i8)') i, layer_index(i), layer_order(i)
                end do
             end if
             do i = 1, natm
                do j = 1, nlayer
                   if(layer_index(j) == numlay(i)) then
                      numlay(i) = layer_order(j)
                      goto 1002
                   end if
                end do
1002            continue
             end do
             if(ipridos>=1) then
                write(nfout,'(" !!ldos #atom, numlay <<m_Ldos.set_nlayer>>")')
                do i = 1, natm
                   write(nfout,'(" !!ldos ",3i8)') i, numlay(i)
                end do
             end if
             deallocate(layer_order)
          end if
          deallocate(layer_index)
          mlayer = nlayer + 1
       end if
       if(ipridos>=1) write(nfout,'(" !!ldos nlayer, mlayer = ",2i8)') nlayer, mlayer
    else
       nlayer = 0
       mlayer = 0
    end if
  end subroutine set_nlayer

  subroutine alloc_mesh()
    integer :: id,nd2,nn
    id  = fft_box_size_WF(1,0)
    nd2 = fft_box_size_WF(2,0)
    nn  = fft_box_size_WF(3,1)
    if(.not.allocated(mesh)) allocate(mesh(id,nd2,nn))
    id  = fft_box_size_CD_nonpara(1,0)
    nd2 = fft_box_size_CD_nonpara(2,0)
    nn  = fft_box_size_CD(3,1)
    if(.not.allocated(meshp)) allocate(meshp(id,nd2,nn))
  end subroutine alloc_mesh

  subroutine alloc_meshl()
    integer :: id,nd2,nn
    id  = fft_box_size_WF(1,0)
    nd2 = fft_box_size_WF(2,0)
    nn  = fft_box_size_WF(3,1)
    if(.not.allocated(meshl)) allocate(meshl(id,nd2,nn))
    id  = fft_box_size_CD_nonpara(1,0)
    nd2 = fft_box_size_CD_nonpara(2,0)
    nn  = fft_box_size_CD(3,1)
    if(.not.allocated(meshpl)) allocate(meshpl(id,nd2,nn))
  end subroutine alloc_meshl

  subroutine m_Ldos_dealloc_mesh()
    deallocate(mesh)
    deallocate(meshp)
  end subroutine m_Ldos_dealloc_mesh

  subroutine alloc_winlay()
    if(allocated(winlay)) deallocate(winlay)
    if(allocated(nmeshlay)) deallocate(nmeshlay)
    if(allocated(nmeshplay)) deallocate(nmeshplay)
    allocate(winlay(mlayer,2))
    allocate(nmeshlay(mlayer))
    allocate(nmeshplay(mlayer))
  end subroutine alloc_winlay

  subroutine get_adjustfactor(winlay,m,nmeshl,factor,nwrite)
    integer, intent(in) :: m,nwrite
    real(kind=DP),intent(in), dimension(m,2) :: winlay
    integer, intent(in), dimension(m) :: nmeshl
    real(kind=DP),intent(out), dimension(m) :: factor
    integer :: i,nall
    nall = 0
    do i = 1, m
       nall = nall + nmeshl(i)
    end do
    do i = 1, m
       if(nmeshl(i)>0) then
          factor(i) = nall*(winlay(i,2)-winlay(i,1))/height/nmeshl(i)
       else
          factor(i) = 1.d0
       end if
    end do
    if(nwrite==0) then
       if(ipridos>=1) then
          write(nfout,'("!!ldos  no  delta_window   nmesh  factor  adjustednmesh")')
          do i = 1, m
             write(nfout,'("!!ldos ",i4, f12.5,  i8, f8.4, f16.5)') &
                  & i,winlay(i,2)-winlay(i,1),nmeshl(i),factor(i),nmeshl(i)*factor(i)
          end do
       end if
    end if
  end subroutine get_adjustfactor

  subroutine dealloc_winlay()
    deallocate(nmeshplay,nmeshlay,winlay)
  end subroutine dealloc_winlay

  subroutine fillup_mesh(fillmode)
    integer, intent(in) :: fillmode
    integer :: id, nd2, nl, nm, nn
    real(kind=DP),allocatable,dimension(:,:) :: wk_catoms, cps_full ! d(natm2,3)
    real(kind=DP),allocatable,dimension(:) :: wk_dstnc  ! d(natm2)
    integer, allocatable, dimension(:) ::     wk_ioddst, ityp_full ! d((natm2+1)*4)
    real(kind=DP),allocatable,dimension(:,:) :: winlay_internal    ! d(mlayer,2)
    integer, allocatable, dimension(:,:,:) :: mesht
    integer, allocatable, dimension(:) :: nmesht
    integer :: nmmax,nmmax0,nsize
    integer :: ia,i,ii,ierr
    integer :: id_sname = -1

    call tstatc0_begin('fillup_mesh ',id_sname)
    call m_Parallel_init_mpi_atm2(nfout,ipriparallel,printable,natm2)
    call m_Parallel_init_mpi_atm_f(nfout,ipriparallel,printable,natm2)
    call get_fftbox_size(SOFTPART,id,nd2,nl,nm,nn) ! fft_box_size_WF -> id,nd2,nl,nm,nn
    if(fillmode==ALDOS) then
       allocate(wk_catoms(natm2,3))
       allocate(wk_dstnc(natm2))
       allocate(wk_ioddst((natm2+1)*4))
       allocate(cps_full(natm2,3))
       allocate(ityp_full(natm2))
       cps_full(1:natm,1:3) = cps(1:natm,1:3)
       ityp_full(1:natm) = ityp(1:natm)
       call rplcps(cps_full,ityp_full,1,natm2,natm,iwei)
       if(sw_ac_mesh==ON)then
         allocate(ac_mesh(ista_atm2:iend_atm2,1,3));ac_mesh=0
         allocate(nac_mesh(ista_atm2:iend_atm2));nac_mesh=0
         nmmax = 0
         call anlmes_ac(ista_atm_f,iend_atm_f,ista_atm2,iend_atm2,nfout,ipridos,1,ac_mesh,nac_mesh,id,nd2 &
              &        ,nl*acmesh_factor,nm*acmesh_factor,nn*acmesh_factor &
              &        ,altv,rltv,cps_full,natm2,crtdst_aldos,DELTA10,wk_catoms &
              &        ,wk_ioddst,wk_dstnc,.true.,nmmax)
         call mpi_allreduce(mpi_in_place,nmmax,1,mpi_integer,mpi_max,MPI_CommGroup,ierr)
         deallocate(ac_mesh);allocate(ac_mesh(ista_atm2:iend_atm2,nmmax,3));ac_mesh=0
         allocate(mesht(natm2,nmmax,3));mesht=0
         allocate(nmesht(natm2));nmesht=0
         !nsize = (iend_atm2-ista_atm2+1)*3*nmmax
         nsize = natm2*3*nmmax
         call anlmes_ac(ista_atm_f,iend_atm_f,1,natm2,nfout,ipridos,nmmax,mesht,nmesht,id,nd2 &
              &        ,nl*acmesh_factor,nm*acmesh_factor,nn*acmesh_factor &
              &        ,altv,rltv,cps_full,natm2,crtdst_aldos,DELTA10,wk_catoms &
              &        ,wk_ioddst,wk_dstnc,.false.,nmmax0)
         call mpi_allreduce(mpi_in_place,nmesht,natm2,mpi_integer,mpi_sum,MPI_CommGroup,ierr)
         call mpi_allreduce(mpi_in_place, mesht,nsize,mpi_integer,mpi_sum,MPI_CommGroup,ierr)
         nac_mesh(ista_atm2:iend_atm2) = nmesht(ista_atm2:iend_atm2)
         ac_mesh(ista_atm2:iend_atm2,:,:) = mesht(ista_atm2:iend_atm2,:,:)
         deallocate(nmesht)
         deallocate(mesht)
         write(nfout,'(a)') ' !** AC MESH number of mesh allocated to each atom for this process '
         do ia=ista_atm2,iend_atm2
            write(nfout,'(2i8)') ia,nac_mesh(ia)
         enddo
       else
         call anlmes(nfout,ipridos,mesh,id,nd2,nl,nm,nn,altv,rltv,cps_full &
              &           ,natm2,crtdst_aldos,DELTA10,wk_catoms,wk_ioddst,wk_dstnc)
       endif
    else if(fillmode==LAYERDOS) then
       allocate(winlay_internal(mlayer,2))
       winlay_internal = winlay/height
       call anlmesl(nfout,ipridos,meshl,id,nd2,nl,nm,nn,winlay_internal,mlayer,normal_axis_winlay,nmeshlay)
    end if

    call get_fftbox_size(HARDPART,id,nd2,nl,nm,nn) ! fft_box_size_CD -> id,nd2,nl,nm,nn
    if(fillmode==ALDOS) then
       if(sw_ac_mesh==ON) then
          allocate(ac_mesh_cd(ista_atm2:iend_atm2,1,3));ac_mesh_cd=0
          allocate(nac_mesh_cd(ista_atm2:iend_atm2));nac_mesh_cd=0
          nmmax = 0
          call anlmes_ac(ista_atm_f,iend_atm_f,ista_atm2,iend_atm2,nfout,ipridos,1,ac_mesh_cd,nac_mesh_cd,id,nd2 &
               &        ,nl*acmesh_factor,nm*acmesh_factor,nn*acmesh_factor &
               &        ,altv,rltv,cps_full,natm2,crtdst_aldos,DELTA10 &
               &        ,wk_catoms,wk_ioddst,wk_dstnc,.true.,nmmax)
          call mpi_allreduce(mpi_in_place,nmmax,1,mpi_integer,mpi_max,MPI_CommGroup,ierr)
          deallocate(ac_mesh_cd);allocate(ac_mesh_cd(ista_atm2:iend_atm2,nmmax,3));ac_mesh_cd=0
          !nsize = (iend_atm2-ista_atm2+1)*3*nmmax
          nsize = natm2*3*nmmax
          allocate(mesht(natm2,nmmax,3));mesht=0
          allocate(nmesht(natm2));nmesht=0
          call anlmes_ac(ista_atm_f,iend_atm_f,1,natm2,nfout,ipridos,nmmax,mesht,nmesht,id,nd2 &
               &        ,nl*acmesh_factor,nm*acmesh_factor,nn*acmesh_factor &
               &        ,altv,rltv,cps_full,natm2,crtdst_aldos,DELTA10 &
               &        ,wk_catoms,wk_ioddst,wk_dstnc,.false.,nmmax0)
          call mpi_allreduce(mpi_in_place,nmesht,natm2,mpi_integer,mpi_sum,MPI_CommGroup,ierr)
          call mpi_allreduce(mpi_in_place,mesht,nsize,mpi_integer,mpi_sum,MPI_CommGroup,ierr)
          nac_mesh_cd(ista_atm2:iend_atm2) = nmesht(ista_atm2:iend_atm2)
          ac_mesh_cd(ista_atm2:iend_atm2,:,:) = mesht(ista_atm2:iend_atm2,:,:)
          deallocate(nmesht)
          deallocate(mesht)
          write(nfout,'(a)') ' !** AC MESH number of mesh allocated to each atom for this process (hardpart)'
          do ia=ista_atm2,iend_atm2
             write(nfout,'(2i8)') ia,nac_mesh_cd(ia)
          enddo
       else
          call anlmes(nfout,ipridos-1,meshp,id,nd2,nl,nm,nn,altv,rltv,cps_full &
         &           ,natm2,crtdst_aldos,DELTA10,wk_catoms,wk_ioddst,wk_dstnc)
       endif
       deallocate(ityp_full,cps_full,wk_ioddst,wk_dstnc,wk_catoms)
    else if(fillmode==LAYERDOS) then
       call anlmesl(nfout,ipridos,meshpl,id,nd2,nl,nm,nn,winlay_internal,mlayer,normal_axis_winlay,nmeshplay)
       deallocate(winlay_internal)
    end if
    call tstatc0_end(id_sname)

  end subroutine fillup_mesh

  subroutine get_height(h)
    real(kind=DP), intent(out) :: h
    integer :: iaxis,i2,i3
    real(kind=DP) :: a,b,S

    iaxis = normal_axis_winlay
    i2 = iaxis + 1
    if(i2 >= 4) i2 = i2 - 3
    i3 = i2 + 1
    if(i3 >= 4) i3 = i3 - 3
    a = dsqrt(altv(1,i2)**2 + altv(2,i2)**2 + altv(3,i2)**2)
    b = dsqrt(altv(1,i3)**2 + altv(2,i3)**2 + altv(3,i3)**2)
! ----------------------------
!        29 Jan. 2008
!     Revised by M. Usami
!!$    S = a*a * b*b - (altv(1,i2)*altv(1,i3)+altv(2,i2)*altv(2,i3)+altv(3,i2)*altv(3,i3))
    S = a*a * b*b - (altv(1,i2)*altv(1,i3)+altv(2,i2)*altv(2,i3)+altv(3,i2)*altv(3,i3))**2
! --------------------------
    S = dsqrt(S)
    h = univol/S
    if(ipridos>=1) write(nfout,'(" !!ldos S, h, V = ",3f16.8," <<m_Ldos.set_nlayer>>")') S,h,univol
  end subroutine get_height

  subroutine set_winlay()
! ----------------------------------------------
!       Nov. 17th 1992 by T.Yamasaki
!
!    the original subroutine name was "dwinly2"
!
!       modified by T. Yamasaki, 09th Feb 2004
! ----------------------------------------------
    real(kind=DP) :: zmin, tmp, h
    integer ::  i, nl
    i = normal_axis_winlay
!!$    call get_height(h)
    h = height
    if(kimg == 1) then
       maxhv = h*0.5d0
       maxv  = maxhv*2
    else
       maxhv = h
       maxv  = maxhv
    end if

    winlay = 0.d0
    if(slicing_way_winlay == REGULAR_INTERVALS) then
       if(ipridos>=1) then
          write(nfout,'(" !!ldos slicing_way = REGULAR_INTERVALS")')
          write(nfout,'(" !!ldos nlayer, mlayer = ",2i6)') nlayer, mlayer
          write(nfout,'(" !!ldos maxhv, maxv = ",2f8.4)') maxhv, maxv
          write(nfout,'(" !!deltaz_winlay = ",f8.4)') deltaz_winlay
       end if
       if(kimg == 1) then
          winlay(1,1) = 0.d0
          winlay(mlayer,2) = maxhv
          do i = 1, nlayer
             winlay(i,2) = deltaz_winlay * i
             if(winlay(i,2) > maxhv) winlay(i,2) = maxhv
             if(i+1 <= mlayer) winlay(i+1,1) = winlay(i,2)
          end do
       else if(kimg == 2) then
          zmin = minval(cps(1:natm,normal_axis_winlay))
          winlay(1,1) = zmin - crtdst_winlay
          winlay(mlayer,2) = winlay(1,1) + maxv
          do i = 1, nlayer
             winlay(i,2) = winlay(i,1) + deltaz_winlay
             if(winlay(i,2) > winlay(mlayer,2)) winlay(i,2) = winlay(mlayer,2)
             if(i+1 <= mlayer) winlay(i+1,1) = winlay(i,2)
          end do
       end if
    else if(slicing_way_winlay == BY_ATOMIC_POSITIONS) then
       if(ipridos>=1) &
            & write(nfout,'(" !!ldos slicing_selection = BY_ATOMIC_POSITIONS")')

       do i = 1, mlayer
          winlay(i,1) = +maxv*30
          winlay(i,2) = -maxv*30
       end do

       do i = 1, natm
          nl = numlay(i)
          if(winlay(nl,1) > cps(i,normal_axis_winlay)) winlay(nl,1) = cps(i,normal_axis_winlay)
          if(winlay(nl,2) < cps(i,normal_axis_winlay)) winlay(nl,2) = cps(i,normal_axis_winlay)
       end do

       if(ipridos>=1) then
          write(nfout,'(" !!ldos a range of atomic positions of each layer ")')
          do i = 1, nlayer
             write(nfout,'(2x,i4,2f20.8)') i, winlay(i,1), winlay(i,2)
          end do
       end if

       tmp = winlay(1,1) - crtdst_winlay
       if(kimg == 2) then
          if( tmp < winlay(nlayer,2) - maxhv + crtdst_winlay ) then
!     ( a unit cell has no vacuum region )
             winlay(1,1) = (winlay(1,1) + winlay(nlayer,2) - maxv)*0.5
             winlay(nlayer,2) = winlay(1,1)+maxv
             winlay(mlayer,1) = winlay(1,1)
             winlay(mlayer,2) = winlay(1,1)
          else
!     ( a unit cell has a vacuum region)
             winlay(1,1) = winlay(1,1) - crtdst_winlay
             winlay(nlayer,2) = winlay(nlayer,2) + crtdst_winlay
             winlay(mlayer,1) = winlay(nlayer,2)
             winlay(mlayer,2) = winlay(1,1) + maxv
          endif
       else if(kimg == 1) then
          winlay(1,1) = 0.d0
          winlay(mlayer,2) = maxhv
          winlay(nlayer,2) = winlay(nlayer,2) + crtdst_winlay
          winlay(mlayer,1) = winlay(nlayer,2)
       end if

       do i = 1, nlayer-1
          winlay(i,2) = (winlay(i,2) + winlay(i+1,1))*0.5
          winlay(i+1,1) = winlay(i,2)
       end do
    else
       if(ipridos>=1) write(nfout,'(" !!ldos slicing_selection is illegal")')
    end if

    if(ipridos>=1) then
       write(nfout,'(" !!ldos",3x,a2,5x,a9,11x,a9,8x,a11,5x,a11)') &
            &   "no","min(Bohr)","max(Bohr)","min(Angst.)","max(Angst.)"
!!$       write(nfout,'(" !!ldos    no,        min(Bohr),       max(Bohr),     min(Angst.),    max(Angst.)")')
       do i = 1, nlayer
          write(6,'(" !!ldos ",i4,2f20.8,2f16.4)') i, winlay(i,1), winlay(i,2), winlay(i,1)*BOHR,winlay(i,2)*BOHR
       enddo
       if(mlayer > nlayer) then
          write(6,'(" !!ldos ",i4,2f20.8,2f16.4)') mlayer, winlay(mlayer,1), winlay(mlayer,2) &
               &    ,  winlay(mlayer,1)*BOHR, winlay(mlayer,2)*BOHR
       endif
    end if

  end subroutine set_winlay

  subroutine m_Ldos_alloc_weiwsc_etc()
    integer :: n_ldos_allocated

    if ( hardpart_subroutine /= 2 ) then
       if ( sw_rspace_ldos == OFF .or. sw_rspace_lband == OFF ) then
          call m_CD_cp_chgq_to_chgqo() !ASMS
       endif
    endif

    n_total_ldoscal = 0

    if ( sw_aldos == ON .or. sw_calc_wf_atom_decomposition == ON ) then
       if ( noncol ) then
          call alloc_weiwsc_noncl(n_ldos_allocated)
       else
          call alloc_weiwsc(n_ldos_allocated)
       endif
       n_total_ldoscal = n_total_ldoscal + n_ldos_allocated
    end if
    if ( sw_layerdos == ON .or. sw_calc_wf_layer_decomposition == ON ) then
       if ( noncol ) then
          call alloc_weilay_noncl(n_ldos_allocated)
       else
          call alloc_weilay(n_ldos_allocated)
       endif
       n_total_ldoscal = n_total_ldoscal + n_ldos_allocated
    end if

  end subroutine m_Ldos_alloc_weiwsc_etc

  subroutine m_Ldos_dealloc_weiwsc_etc()
    if ( sw_aldos == ON .or. sw_calc_wf_atom_decomposition == ON ) then
       if ( noncol ) then
          call dealloc_weiwsc_noncl()
       else
          call dealloc_weiwsc()
       endif
    endif
    if ( sw_layerdos == ON .or. sw_calc_wf_layer_decomposition == ON ) then
       if ( noncol ) then
          call dealloc_weilay_noncl()
       else
          call dealloc_weilay()
       endif
    endif
  end subroutine m_Ldos_dealloc_weiwsc_etc

  subroutine alloc_weiwsc(n_ldos_allocated)
    integer, intent(out) :: n_ldos_allocated
    n_ldos_allocated = 0
    if(ekmode == ON) then
       if ( sw_lband == ON ) then
          allocate(weiwsc(maldos,np_e,ista_k:iend_k)); weiwsc = 0.d0
       else
          allocate(weiwsc(maldos,neg,kv3_ek)); weiwsc = 0.d0
       endif
    else
       allocate(weiwsc(maldos,np_e,ista_k:iend_k)); weiwsc = 0.d0
    end if
    n_ldos_allocated = maldos
  end subroutine alloc_weiwsc

! ================================= added by K. Tagami ============= 11.0
  subroutine alloc_weiwsc_noncl(n_ldos_allocated)
    integer, intent(out) :: n_ldos_allocated
    n_ldos_allocated = 0
    if(ekmode == ON) then
       if ( sw_lband == ON ) then
          allocate(weiwsc_noncl(maldos,np_e,ista_k:iend_k,ndim_magmom))
       else
          allocate(weiwsc_noncl(maldos,neg,kv3_ek,ndim_magmom))
       endif
    else if(ekmode == OFF) then
       allocate(weiwsc_noncl(maldos,np_e,ista_k:iend_k,ndim_magmom))
    end if

    weiwsc_noncl = 0.0d0
    n_ldos_allocated = maldos

  end subroutine alloc_weiwsc_noncl
! =============================================================== 11.0

  subroutine dealloc_weiwsc()
    deallocate(weiwsc)
  end subroutine dealloc_weiwsc

! ================================== added by K. Tagami ========== 11.0
  subroutine dealloc_weiwsc_noncl()
    deallocate(weiwsc_noncl)
  end subroutine dealloc_weiwsc_noncl
! =============================================================== 11.0

  subroutine alloc_weilay(n_ldos_allocated)
    integer, intent(out) :: n_ldos_allocated
!!$    allocate(weilay(mlayer,np_e)); weilay = 0.d0
    n_ldos_allocated = 0
    if(ekmode == ON) then
       if ( sw_lband == ON ) then
          allocate(weilay(mlayer,np_e,ista_k:iend_k)); weilay = 0.d0
       else
          allocate(weilay(mlayer,neg,kv3_ek)); weilay = 0.d0
       endif
    else if(ekmode == OFF) then
       allocate(weilay(mlayer,np_e,ista_k:iend_k)); weilay = 0.d0
    end if
    n_ldos_allocated = mlayer
  end subroutine alloc_weilay

! ============================ added by K. Tagami ================= 11.0
  subroutine alloc_weilay_noncl(n_ldos_allocated)
    integer, intent(out) :: n_ldos_allocated

    n_ldos_allocated = 0
    if(ekmode == ON) then
       if ( sw_lband == ON ) then
          allocate(weilay_noncl(mlayer,np_e,ista_k:iend_k,ndim_magmom))
       else
          allocate(weilay_noncl(mlayer,neg,kv3_ek,ndim_magmom))
       endif
    else if(ekmode == OFF) then
       allocate(weilay_noncl(mlayer,np_e,ista_k:iend_k,ndim_magmom))
    end if
    weilay_noncl = 0.d0
    n_ldos_allocated = mlayer
  end subroutine alloc_weilay_noncl
! =============================================================== 11.0

  subroutine dealloc_weilay()
    deallocate(weilay)
  end subroutine dealloc_weilay

! ============================== added by K. Tagami ========== 11.0
  subroutine dealloc_weilay_noncl()
    deallocate(weilay_noncl)
  end subroutine dealloc_weilay_noncl
! ============================================================= 11.0

  subroutine m_Ldos_wd_natm2_and_totch( nfldos )
    integer, intent(in) :: nfldos
    if(mype == 0 .and. ipridos>=0 ) then
!       write(nfldos,'(" natm2 = ",i8)') naldos ! natm2
!       write(nfldos,'(" totch = ",f20.8)') totch
       write(nfldos,'(" num_atoms  = ",i8)') naldos ! natm2
       write(nfldos,'(" num_layers = ",i8)') nlayer
       write(nfldos,'(" num_bands  = ",i8)') neg -num_extra_bands
       write(nfldos,*)
    end if
  end subroutine m_Ldos_wd_natm2_and_totch

  subroutine m_Ldos_cal_ek( nfldos )
    use m_Files, only : nfzaj_kall
    use m_IterationNumbers, only : m_Iter_reset_nk_in_the_process
    use m_ES_IO, only : m_ESIO_rd_next_wfs_ek
    use m_Files, only : m_Files_open_nfzaj_kall
    use m_ES_ortho, only : m_ES_modified_gram_schmidt
    use m_ES_occup, only : m_ESoc_check_if_metalic
    use m_ES_nonlocal, only : m_ES_betar_dot_WFs_4_each_k_3D

    integer, intent(in) :: nfldos

    integer :: id_sname = -1
    integer :: i, is, ikt, nk, ierr, ik, ib
    integer :: sw_atom_decomp, sw_layer_decomp
    real(kind=DP), allocatable, dimension(:,:,:) :: wei
    integer, allocatable, dimension(:) :: kmap

    call m_Files_open_nfzaj_kall()
    rewind(nfzaj_kall)
    allocate(kmap(kv3))

    call tstatc0_begin('m_Ldos_cal_ek ',id_sname,1)
    call m_Iter_reset_nk_in_the_process()

    sw_atom_decomp = OFF;  sw_layer_decomp = OFF
    if ( sw_aldos == ON .or. sw_calc_wf_atom_decomposition == ON ) then
       sw_atom_decomp = ON
    endif
    if ( sw_layerdos == ON .or. sw_calc_wf_layer_decomposition == ON ) then
       sw_layer_decomp = ON
    endif

    do nk=1, kv3_ek, kv3
       if ( sw_atom_decomp == ON )    weiwsc = 0.d0
       if ( sw_layer_decomp == ON ) weilay = 0.d0
       call KpointNumber_Setting2()
       call Preparation_ek()
       call Preparation_for_mpi_ek()
       call epsmain_reallocate()
       call PseudoPotential_ek()

       kmap = 0
       if(sw_modified_kpoint_increment == ON)then
          do i=0,nrank_k-1
             do is=1,nspin
                ikt = nspin*(nis_kv3_ek(i)-1)+(nk-1)*nspin+is
                kmap(i+1) = ikt
                if(ikt>kv3_ek) exit
                call m_ESIO_rd_next_wfs_ek(i+1, nfout, nfzaj_kall)
                if(map_k(i+1) /= myrank_k) cycle
                call m_ES_betar_dot_WFs_4_each_k_3D(nfout, i+1)
             enddo
          enddo
       else
          do is=1, nspin, af+1
             do ik=is, kv3+is-nspin, nspin
                ikt = nk + ik - 1
                if(ikt>kv3_ek) exit
                kmap(ik) = ikt
                call m_ESIO_rd_next_wfs_ek(ik, nfout, nfzaj_kall)
                if(map_k(ik) /= myrank_k) cycle
                call m_ES_betar_dot_WFs_4_each_k_3D(nfout, ik)
             enddo
          enddo
       endif

       call m_Ldos_cal( nfldos, .false. )

       if (sw_atom_decomp==ON) then
          allocate(wei(maldos,neg,kv3));wei=0.d0
          do ik=1,kv3
             if(map_k(ik) /= myrank_k) cycle
             do ib=1, np_e
                wei(1:maldos,neg_g(ib),ik) = weiwsc(1:maldos,ib,ik)
             enddo
          enddo
          call mpi_allreduce(mpi_in_place,wei,maldos*neg*kv3,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
          call mpi_allreduce(mpi_in_place,wei,maldos*neg*kv3,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
          call wd_weight_ek(maldos,kmap,wei,ALDOS,nfldos)
          deallocate(wei)
       endif
       if(sw_layer_decomp==ON) then
          allocate(wei(mlayer, neg, kv3));wei=0.d0
          do ik=1,kv3
             if(map_k(ik) /= myrank_k) cycle
             do ib=1, np_e
                wei(1:mlayer,neg_g(ib),ik) = weilay(1:mlayer,ib,ik)
             enddo
          enddo
          call mpi_allreduce(mpi_in_place,wei,mlayer*neg*kv3,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
          call mpi_allreduce(mpi_in_place,wei,mlayer*neg*kv3,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
          call wd_weight_ek(mlayer,kmap,wei,LAYERDOS,nfldos)
          deallocate(wei)
       endif
    enddo
    deallocate(kmap)

    if(sw_atom_decomp==ON .and. sw_ac_mesh==ON) then
       call check_sum_full('total ',.true.)
       if(sw_checksum == ON) call check_sum_full('total ')
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Ldos_cal_ek

  subroutine m_Ldos_cal( nfldos, print_flag )
    use m_IterationNumbers,   only : nk_in_the_process
    use m_Ionic_System,       only : speciesname

    integer, intent(in) :: nfldos
    logical, intent(in) :: print_flag

    integer :: id_sname = -1
    integer :: ik, is
    integer :: sw_atom_decomp, sw_layer_decomp

    sw_atom_decomp = OFF;  sw_layer_decomp = OFF
    if ( sw_aldos == ON .or. sw_calc_wf_atom_decomposition == ON ) then
       sw_atom_decomp = ON
    endif
    if ( sw_layerdos == ON .or. sw_calc_wf_layer_decomposition == ON ) then
       sw_layer_decomp = ON
    endif

    call tstatc0_begin('m_Ldos_cal ',id_sname,1)

    if ( mype == 0 ) call wd_header

    if ( sw_atom_decomp == ON ) weiwsc = 0.d0
    if ( sw_layer_decomp == ON ) weilay = 0.d0

    do is = 1, nspin, af+1
       do ik = is, kv3+is-nspin, nspin
          if(map_k(ik) /= myrank_k) cycle
          if ( ekmode==ON ) then
             if ( nk_in_the_process +ik -1 > kv3_ek ) cycle
          endif
          call cal_weiwsc( ik, is, nfldos, print_flag )
       enddo
    enddo

    if(sw_atom_decomp == ON .and. sw_ac_mesh==ON) then
      call check_sum_full('total ',.true.)
      if(sw_checksum == ON) call check_sum_full('total ')
    endif

    if(sw_save_ldos_weight == ON .and. print_flag ) then
       if(sw_atom_decomp==ON) call wd_weight(ALDOS,nfldos)
       if(sw_layer_decomp==ON) call wd_weight(LAYERDOS,nfldos)
    end if

    call tstatc0_end(id_sname)

  contains

    subroutine wd_header
      integer :: i, j

      if ( sw_lband == OFF ) then
         if(sw_save_ldos_weight == ON .and. ekmode==OFF) then
            call m_Ldos_wd_natm2_and_totch( nfldos )
         endif
         if ( ekmode == ON .and. nk_in_the_process == 1 ) then
            call m_Ldos_wd_natm2_and_totch( nfldos )
         endif
      endif
      if ( sw_lband == ON ) then
         if ( ( ekmode == ON .and. nk_in_the_process == 1 ) &
              &  .or. ( ekmode == OFF) ) then
            write(nfldos,'(A)') "# Local Decomposition for bands"
            write(nfldos,*) ""
            write(nfldos,'(A,I8)') ' num_kpoints = ', max(kv3,kv3_ek) /ndim_spinor
            write(nfldos,'(A,I8)') ' num_bands   = ', neg -num_extra_bands
            write(nfldos,'(A,I8)') ' nspin       = ', nspin /ndim_spinor
            write(nfldos,*) ""
            write(nfldos,'(A)') "# Decomposition Info."

            if ( sw_atom_decomp == ON ) then
               write(nfldos,'(A,I8,A)') ' num_atoms   = ', natom_decomp +1, &
                    &        "  ( last 1 corresponds to external region )"
            endif
            if ( sw_layer_decomp == ON ) then
               write(nfldos,'(A,I8,A)') ' num_layers  = ', nlayer +1, &
                    &        "  ( last 1 corresponds to external region )"
            endif
            write(nfldos,*) ""

            if ( sw_atom_decomp == ON ) then
               write(nfldos,'(A)') "# Atom Info."
               write(nfldos,'(A)') "   no.    target_atom    species"
               Do i=1, natom_decomp
                  j = atom_decomp_map(i)
                  write(nfldos,'(I5,5X,I5,12X,A)') i, j, speciesname(ityp(j))
               end Do
               write(nfldos,'(I5)') natom_decomp +1
               write(nfldos,*)
            endif
            if ( sw_layer_decomp == ON ) then
               write(nfldos,'(A)') "# Layer Info."
               write(nfldos,'(A)') "   no.       min.         max.  (Angstrom)"
               Do i=1, nlayer +1
                  write(nfldos,'(I5,2(5X,F8.4))') i, winlay(i,1)*BOHR, winlay(i,2)*BOHR
               end Do
               write(nfldos,*)
            endif
         endif
      endif
    end subroutine wd_header

    subroutine wd_weight(mode,nfldos)
      integer, intent(in) :: mode, nfldos
      integer :: m, ib, ib_ordr, kend, kstep, iws, ik, iks
      integer :: count
      real(kind=DP),allocatable,dimension(:,:,:):: wei

!      write(nfout,'(a,2i8)') '!** in wd_weight ',ik,mode

      if(mode==ALDOS) then
         m = maldos
      else if(mode==LAYERDOS) then
         m = mlayer
      end if
      allocate(wei(m,neg,kv3)); wei = 0.d0

      if(mode==ALDOS)then
         do ik=ista_k, iend_k
            do ib = 1, np_e
               wei(1:m,neg_g(ib),ik) = weiwsc(1:m,ib,ik)
            end do
         end do
      else if(mode==LAYERDOS)then
         do ik=ista_k, iend_k
            do ib = 1, np_e
               wei(1:m,neg_g(ib),ik) = weilay(1:m,ib,ik)
            end do
         end do
      endif

      if (npes>1) then
         call mpi_allreduce( MPI_IN_PLACE, wei, m*neg*kv3, mpi_double_precision, &
              &              mpi_sum, mpi_g_world, ierr )
      end if

      if(mype == 0) then
         Do ik=1, kv3
            iks = 0
            if ( sw_lband == ON .and. ekmode == ON ) then
               iks = nk_in_the_process -1
               if ( ik +iks > kv3_ek ) cycle
            endif
            if(mode==ALDOS) then
               write(nfldos,'(" weight for each atomic cell    nk = ",i8)') ik+iks
            else if(mode==LAYERDOS) then
               write(nfldos,'(" weight for each layer          nk = ",i8)') ik+iks
            end if

            if ( mode==ALDOS .and. sw_wd_only_specified_atoms == ON ) then
               do ib = 1, neg -num_extra_bands
                  write(nfldos,'(i4,A)',advance="no") ib, ")"
                  count = 0
                  do iws=1, m-1
                     if ( if_aldos_full(iws)==1 ) then
                        count = count +1
                        if ( count > 1 .and. mod(count,ilen)==1 ) then
                           write(nfldos,'(5x)',advance="no")
                        endif
                        write(nfldos,'(f15.10)',advance="no") wei(iws,ib,ik)
                        if ( mod(count,ilen)==0 ) write(nfldos,*)
                     endif
                  end do
                  count = count +1
                  if ( count > 1 .and. mod(count,ilen)==1 ) then
                     write(nfldos,'(5x)',advance="no")
                  endif
                  write(nfldos,'(f15.10)') wei(maldos,ib,ik)
               end do
            else
               do ib = 1, neg -num_extra_bands
                  if(ilen >= m) then
                     write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws,ib,ik),iws=1,m)
                  else
                     write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws,ib,ik),iws=1,ilen)
                     write(nfldos,'(5x,5f15.10)') (wei(iws,ib,ik),iws=ilen+1,m)
                  end if
               end do
            endif
         end Do
      end if
      deallocate(wei)
    end subroutine wd_weight

  end subroutine m_Ldos_cal

  subroutine cal_weiwsc( ik, is, nfldos, print_flag )
! This subroutine is revised by T. Yamasaki, 2017.9.20
!   A mapping function, mapg2ly is replaced with mapg2lz, because the inner most
!  do-loop of real space fft's is z-axis followed by x and y-axes
!
!  Revised by T. Yamasaki, Feb. 2020
!   Paralelizaed by the band-axis.
!
    integer, intent(in) :: ik,is,nfldos
    logical, intent(in) :: print_flag

    integer :: ib, sw_full_fftmesh
    integer :: sw_atom_decomp, sw_layer_decomp
    real(kind=DP) ::  chgq0
    real(kind=DP), allocatable, dimension(:,:) :: wk_bfft_l ! d(nfft_l,ibsize)

    integer :: ibsize, lsize, nfft_l, nfftp_l, lsize_cd, ierr
    real(kind=DP), allocatable, dimension(:,:) :: chgqt_l
    integer, allocatable, dimension(:) :: mapg2lx,mapg2lz  !  mapg2lz  ! d(nfft)
    integer, allocatable, dimension(:) :: mapg2lz_p
                                        !  mapg2ly is replaced with mapg2lz. 2017.09.20 T. Yamasaki
!!$    integer, allocatable, dimension(:) :: mapg2lz_p ! mapg2lx_p, d(nfftp)
    integer, allocatable, dimension(:) :: nwsc_mesh_l, nwsc_meshlay_l ! d(nl*nm*nn)
    real(kind=DP), allocatable, dimension(:,:,:) :: wscsoft,wschard
    integer :: id_sname = -1

    call tstatc0_begin('m_Ldos_weiwsc ',id_sname)
    call m_CD_cp_chgq_to_chgqo() !ASMS

    sw_atom_decomp = OFF;  sw_layer_decomp = OFF
    if ( sw_aldos == ON .or. sw_calc_wf_atom_decomposition == ON ) then
       sw_atom_decomp = ON
    endif
    if ( sw_layerdos == ON .or. sw_calc_wf_layer_decomposition == ON ) then
       sw_layer_decomp = ON
    endif

    sw_full_fftmesh=OFF
    if(integration_dimension_winlay==3) sw_full_fftmesh=ON

    ibsize = 1

    call m_CD_keep_retrieve_hsr(.true.)

    if(sw_atom_decomp==ON .and. sw_ac_mesh==ON)then
       allocate(wscsoft(maldos,np_e,ik:ik));wscsoft=0.d0
       allocate(wschard(maldos,np_e,ik:ik));wschard=0.d0
    endif

    ! SOFTPART
    call set_fft_3d_size(lsize, nfft_l)                             ! ->lsize, nfft_l
    call make_map() ! -> mapg2lx
    !call make_map_y() ! -> mapg2lz
    call make_map_z() ! -> mapg2lz
    if(modnrm==EXECUT) call make_map_cdz()
    allocate(wk_bfft_l(nfft_l,ibsize))
    if(sw_atom_decomp==ON.and.sw_ac_mesh==OFF) call fillup_mesh_l(mode=SOFTPART,fillmode=ALDOS)
    if(sw_layer_decomp==ON .and. sw_full_fftmesh == ON) call fillup_mesh_l(mode=SOFTPART,fillmode=LAYERDOS)
    do ib = 1, np_e
       if ( sw_band_unfolding == ON .and. band_unfolding_active ) then
          call m_ES_WF_in_Rspace_kt_3D( ista_k, iend_k, ik, ibsize, lsize, &
               &                        zaj_l(:,ib,:,:), wk_bfft_l )
       else
          call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l)
       endif
       if(sw_atom_decomp==ON.and.sw_ac_mesh==OFF) call substitute_weiwsc(ik,ib,mode=SOFTPART)
       if(sw_atom_decomp==ON.and.sw_ac_mesh==ON)  call substitute_weiwsc_acmesh(ik,ib,.false.,wscsoft)
       if(sw_layer_decomp==ON .and. sw_full_fftmesh==ON ) call substitute_weilay_fftmesh(ik,ib,mode=SOFTPART)
       if(sw_layer_decomp==ON .and. sw_full_fftmesh==OFF) call substitute_weilay(ik,ib)
    end do
    if(sw_checksum == ON) call check_sum(ik,"softpart")
    deallocate(wk_bfft_l)

    ! HARDPART
    if(modnrm==EXECUT) then
       call set_fftcd_3d_size(lsize_cd,nfftp_l)               ! -> lsize_cd, nfftp_l
       allocate(wk_bfft_l(nfftp_l,1)) !      if(ldos_hardpart_fft == FFT_redundant)  allocate(bfft(nfftp_nonpara))
       if(sw_atom_decomp==ON.and.sw_ac_mesh==OFF)  call fillup_mesh_l(mode=HARDPART,fillmode=ALDOS)
       if(sw_layer_decomp==ON .and. sw_full_fftmesh == ON) call fillup_mesh_l(mode=HARDPART,fillmode=LAYERDOS)

       do ib = 1, np_e                                  !        do ib = 1,neg
          call m_CD_hardpart_sub(nfout,is,ik,ib,chgq0)  ! -> (hsr)-> chgq_l
          if(sw_atom_decomp==ON .or. (sw_layer_decomp==ON .and. sw_full_fftmesh==ON)) then
             call m_CD_map_chgq_l_to_fft_l_box(nfftp_l,wk_bfft_l(:,1),is) ! chgq_l -> wk_bfft_l (G.sp.)
             call FFT_in_3D_space()                               ! bfft_l(G.sp.) ->(FFT_3D) -> bfft_l(R_sp.)
          end if
          if(sw_atom_decomp==ON.and.sw_ac_mesh==OFF) call substitute_weiwsc(ik,ib,mode=HARDPART) ! weiwsc <- bfft_l
          if(sw_atom_decomp==ON.and.sw_ac_mesh==ON)    call substitute_weiwsc_acmesh(ik,ib,.true.,wschard)
          if(sw_layer_decomp==ON .and. sw_full_fftmesh == ON )  call substitute_weilay_fftmesh(ik,ib,mode=HARDPART)
          if(sw_layer_decomp==ON .and. sw_full_fftmesh == OFF)  call substitute_weilay_cd(ik,ib,is,chgq0)
       end do
       if(sw_checksum == ON) call check_sum(ik,"total   ")
       deallocate(wk_bfft_l)
    endif

    if(sw_atom_decomp==ON .and. sw_ac_mesh==ON) then
       call mpi_allreduce(mpi_in_place,wscsoft,(iend_k-ista_k+1)*np_e*maldos,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
       call mpi_allreduce(mpi_in_place,wschard,(iend_k-ista_k+1)*np_e*maldos,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
       do ib = 1,np_e
          weiwsc(:,ib,ik) = wscsoft(:,ib,ik)+wschard(:,ib,ik)
       enddo
       call check_sum(ik,'total ')
    endif
!    if(npes > 1) call mpi_barrier(MPI_CommGroup,ierr)
!    if(sw_save_ldos_weight == ON .and. ekmode==OFF) then ! will be done later when ekmode is ON
!    if(sw_save_ldos_weight == ON .and. print_flag ) then
!       if(sw_atom_decomp==ON) call wd_weight_for_ik(ik,ALDOS,nfldos)
!       if(sw_layer_decomp==ON) call wd_weight_for_ik(ik,LAYERDOS,nfldos)
!    end if
    call m_CD_keep_retrieve_hsr(.false.)

    if(allocated(mapg2lx)) deallocate(mapg2lx)
    if(allocated(mapg2lz)) deallocate(mapg2lz)
    if(modnrm==EXECUT) deallocate(mapg2lz_p)
    if(sw_atom_decomp==ON .and. sw_ac_mesh==ON) then
       deallocate(wscsoft)
       deallocate(wschard)
    endif

    call m_CD_restore_chgq()
    call tstatc0_end(id_sname)

  contains

    subroutine set_fft_3d_size(lsize,nfft_l)
#ifdef FFT_3D_DIVISION
      use m_Parallelization, only : fft_X_x_nel, fft_X_y_nel, fft_X_z_nel
#else
      use m_Parallelization, only : nel_fft_x, nel_fft_y
#endif
      integer, intent(out) :: lsize,nfft_l
#ifdef FFT_3D_DIVISION
      lsize = fft_X_x_nel*fft_X_y_nel*fft_X_z_nel
#else
      lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
#endif
#ifdef FFT_3D_DIVISION_CD
      nfft_l = lsize*2
#else
      nfft_l = lsize*kimg
#endif
      if(ipridos>=1) write(nfout,'(" lsize, nfft_l = ",2i8)') lsize, nfft_l
    end subroutine set_fft_3d_size

    subroutine set_fftcd_3d_size(lsize_cd,nfftp_l)
#ifndef FFT_3D_DIVISION_CD
      use m_Parallelization, only : nel_fftcd_x, nel_fftcd_y, nel_fftcd_z
#endif
      integer, intent(out) :: lsize_cd, nfftp_l
#ifdef FFT_3D_DIVISION_CD
      lsize_cd = fftcd_X_x_nel*fftcd_X_y_nel*fftcd_X_z_nel
#else
      lsize_cd = max(maxval(nel_fftcd_x(:)),maxval(nel_fftcd_y(:)),maxval(nel_fftcd_z(:)))
#endif
!!$      isrsize = min(lsize_cd,mp_kngp)
!!$      fft_l_size  = nel_fftcd_x(myrank_g) !   fft_l_size  = nel_fftcd_y(myrank_g)
#ifdef FFT_3D_DIVISION_CD
      nfftp_l = lsize_cd*2
#else
      nfftp_l = lsize_cd*kimg
#endif
      if(ipridos>=1) write(nfout,'(" lsize_cd, nfftp_l = ",2i8)') lsize_cd, nfftp_l
    end subroutine set_fftcd_3d_size

    subroutine FFT_in_3D_space()
#ifdef FFT_3D_DIVISION_CD
      use m_FFT, only :                m_FFT_CD_Inverse_3DIV_3D
#else
      use m_FFT, only :                m_FFT_CD_Inverse_XYZ_3D, m_FFT_CD_Inverse_3D
#endif

#ifdef FFT_3D_DIVISION_CD
      call m_FFT_CD_Inverse_3DIV_3D(nfout,wk_bfft_l(:,1),lsize_cd,1)
#else
      if (sw_fft_xzy > 0) then
         call m_FFT_CD_Inverse_3D(nfout,wk_bfft_l(:,1),lsize_cd,1)
      else
         call m_FFT_CD_Inverse_XYZ_3D(nfout,wk_bfft_l(:,1),lsize_cd,1)
      end if
#endif
    end subroutine FFT_in_3D_space

    subroutine make_map()
!     Revised by T. Yamasaki, Feb. 2020
      use m_Parallelization, only : xyz_fft_x  ! xyz_fft_y is replaced with xyz_fft_z, 2017.09.20
      integer :: id1, id2, nl, nm, nn, index_l, index_g
      integer :: i, j, k,  i_, j_, k_

      allocate(mapg2lx(nfft)); mapg2lx = 0
!!$      allocate(mapg2lz(nfft)); mapg2lz = 0

      id1 = fft_box_size_WF(1,0)  ! x
      id2 = fft_box_size_WF(2,0)  ! y

!!$      nl = xyz_fft_z(2,1) - xyz_fft_z(1,1) + 1 ! x
!!$      nm = xyz_fft_z(2,2) - xyz_fft_z(1,2) + 1 ! y
!!$      nn = xyz_fft_z(2,3) - xyz_fft_z(1,3) + 1 ! z
!!$!      Inner-loop : z, middel : x, outer : y
!!$
!!$      do k = xyz_fft_z(1,3), xyz_fft_z(2,3)  ! z
!!$         k_ = k - xyz_fft_z(1,3) + 1
!!$         do j = xyz_fft_z(1,2), xyz_fft_z(2,2)  ! y
!!$            j_ = j - xyz_fft_z(1,2) + 1
!!$            if(kimg==1) then
!!$               do i = xyz_fft_z(1,1), xyz_fft_z(2,1), 2
!!$                  i_ = i - xyz_fft_z(1,1) + 1
!!$                  index_g = id1*id2*(k-1)+id1*(j-1)+i
!!$!                ============== Revised by T. Yamasaki, 2020/02/07 ====
!!$#ifdef INDEX_L_ORDER_CONFLICT
!!$                  index_l = nl*nm*(k_-1)+2*nl*((j_-1)/2)+2*(i_-1)+1
!!$#else
!!$                  index_l = nn*nl*(j_-1)+2*nn*((i_-1)/2)+2*(k_-1)+1
!!$#endif
!!$!                ======================================================
!!$                  mapg2lz(index_g) = index_l
!!$                  mapg2lz(index_g+1) = index_l+1
!!$               end do
!!$            else
!!$               do i = xyz_fft_z(1,1), xyz_fft_z(2,1)  ! x
!!$                  i_ = i - xyz_fft_z(1,1) + 1
!!$                  index_g = id1*id2*2*(k-1)+id1*2*(j-1)+2*(i-1)+1
!!$!                ============== Revised by T. Yamasaki, 2020/02/07 ====
!!$#ifdef INDEX_L_ORDER_CONFLICT
!!$                  index_l = nl*nm*2*(k_-1)+nl*2*(j_-1)+2*(i_-1)+1
!!$#else
!!$                  index_l = nn*nl*2*(j_-1)+nn*2*(i_-1)+2*(k_-1)+1
!!$#endif
!!$!                ======================================================
!!$                  mapg2lz(index_g) = index_l
!!$                  mapg2lz(index_g+1) = index_l+1
!!$               end do
!!$            end if
!!$         end do
!!$      end do

#ifdef DEBUG_LDOS
      write(6,'(" xyz_fft_z(1:2,3) = ",2i5)') xyz_fft_z(1:2,3)
      write(6,'(" xyz_fft_z(1:2,2) = ",2i5)') xyz_fft_z(1:2,2)
      write(6,'(" xyz_fft_z(1:2,1) = ",2i5)') xyz_fft_z(1:2,1)
#endif

      nl = xyz_fft_x(2,1) - xyz_fft_x(1,1) + 1  ! x
      nm = xyz_fft_x(2,2) - xyz_fft_x(1,2) + 1  ! y
      nn = xyz_fft_x(2,3) - xyz_fft_x(1,3) + 1  ! z

      do k = xyz_fft_x(1,3), xyz_fft_x(2,3)       ! z
         k_ = k - xyz_fft_x(1,3) + 1
         do j = xyz_fft_x(1,2), xyz_fft_x(2,2)    ! y
            j_ = j - xyz_fft_x(1,2) + 1
            if(kimg == 1) then
               do i = xyz_fft_x(1,1), xyz_fft_x(2,1) ! x
                  i_ = i - xyz_fft_x(1,1) + 1
                  index_g = id1*id2*(k-1)+id1*(j-1)+i
                  index_l = nl*nm*(k_-1)+nl*(j_-1)+i_
                  mapg2lx(index_g) = index_l
               end do
            else
               do i = xyz_fft_x(1,1), xyz_fft_x(2,1) ! x
                  i_ = i - xyz_fft_x(1,1) + 1
                  index_g = id1*id2*2*(k-1)+id1*2*(j-1)+2*(i-1)+1
                  index_l = nl*nm*2*(k_-1)+nl*2*(j_-1)+2*(i_-1)+1
                  mapg2lx(index_g) = index_l     ! real part
                  mapg2lx(index_g+1) = index_l+1 ! imaginalry part
               end do
            end if
         end do
      end do

    end subroutine make_map

    subroutine make_map_z()
!     Revised by T. Yamasaki, Feb. 2020
      use m_Parallelization, only : xyz_fft_z, xyz_fft_y  ! xyz_fft_y is replaced with xyz_fft_z, 2017.09.20
      integer :: id1, id2, nl, nm, nn, index_l, index_g
      integer :: i, j, k,  i_, j_, k_

      allocate(mapg2lz(nfft)); mapg2lz = 0
!!$      allocate(mapg2lz(nfft)); mapg2lz = 0

      id1 = fft_box_size_WF(1,0)  ! x
      id2 = fft_box_size_WF(2,0)  ! y

#ifdef DEBUG_LDOS
      write(6,'(" xyz_fft_z(1:2,3) = ",2i5)') xyz_fft_z(1:2,3)
      write(6,'(" xyz_fft_z(1:2,2) = ",2i5)') xyz_fft_z(1:2,2)
      write(6,'(" xyz_fft_z(1:2,1) = ",2i5)') xyz_fft_z(1:2,1)
#endif

      nl = xyz_fft_z(2,1) - xyz_fft_z(1,1) + 1  ! x
      nm = xyz_fft_z(2,2) - xyz_fft_z(1,2) + 1  ! y
      nn = xyz_fft_z(2,3) - xyz_fft_z(1,3) + 1  ! z

      do j = xyz_fft_z(1,2), xyz_fft_z(2,2)    ! y
         j_ = j - xyz_fft_z(1,2) + 1
         do k = xyz_fft_z(1,3), xyz_fft_z(2,3)       ! z
            k_ = k - xyz_fft_z(1,3) + 1
            if(kimg == 1) then
               do i = xyz_fft_z(1,1), xyz_fft_z(2,1) ! x
                  i_ = i - xyz_fft_z(1,1) + 1
                  index_g = id1*id2*(k-1)+id1*(j-1)+i
                  index_l = nl*nm*(k_-1)+nl*(j_-1)+i_
                  mapg2lz(index_g) = index_l
               end do
            else
               do i = xyz_fft_z(1,1), xyz_fft_z(2,1) ! x
                  i_ = i - xyz_fft_z(1,1) + 1
                  index_g = id1*id2*2*(k-1)+id1*2*(j-1)+2*(i-1)+1
                  index_l = nl*nm*2*(k_-1)+nl*2*(j_-1)+2*(i_-1)+1
                  mapg2lz(index_g) = index_l     ! real part
                  mapg2lz(index_g+1) = index_l+1 ! imaginalry part
               end do
            end if
         end do
      end do

    end subroutine make_map_z

    subroutine make_map_cdz()
!     Revised by T. Yamasaki, Feb. 2020
      use m_Parallelization, only : xyz_fft_z, xyz_fft_y  ! xyz_fft_y is replaced with xyz_fft_z, 2017.09.20
      integer :: id1, id2, nl, nm, nn, index_l, index_g
      integer :: i, j, k,  i_, j_, k_

      allocate(mapg2lz_p(nfftp_nonpara)); mapg2lz_p = 0
!!$      allocate(mapg2lz(nfft)); mapg2lz = 0

      id1 = fft_box_size_CD_nonpara(1,0)  ! x
      id2 = fft_box_size_CD_nonpara(2,0)  ! y

#ifdef DEBUG_LDOS
      write(6,'(" xyz_fft_z(1:2,3) = ",2i5)') xyz_fftcd_z(1:2,3)
      write(6,'(" xyz_fft_z(1:2,2) = ",2i5)') xyz_fftcd_z(1:2,2)
      write(6,'(" xyz_fft_z(1:2,1) = ",2i5)') xyz_fftcd_z(1:2,1)
#endif

      nl = xyz_fftcd_z(2,1) - xyz_fftcd_z(1,1) + 1  ! x
      nm = xyz_fftcd_z(2,2) - xyz_fftcd_z(1,2) + 1  ! y
      nn = xyz_fftcd_z(2,3) - xyz_fftcd_z(1,3) + 1  ! z

      do j = xyz_fftcd_z(1,2), xyz_fftcd_z(2,2)    ! y
         j_ = j - xyz_fftcd_z(1,2) + 1
         do k = xyz_fftcd_z(1,3), xyz_fftcd_z(2,3)       ! z
            k_ = k - xyz_fftcd_z(1,3) + 1
            if(kimg == 1) then
               do i = xyz_fftcd_z(1,1), xyz_fftcd_z(2,1) ! x
                  i_ = i - xyz_fftcd_z(1,1) + 1
                  index_g = id1*id2*(k-1)+id1*(j-1)+i
                  !index_l = nl*nm*(k_-1)+nl*(j_-1)+i_
                  index_l = nl*nn*2*(j_-1)+nn*2*(i_-1)+2*(k_-1)+1
                  mapg2lz_p(index_g) = index_l
               end do
            else
               do i = xyz_fftcd_z(1,1), xyz_fftcd_z(2,1) ! x
                  i_ = i - xyz_fftcd_z(1,1) + 1
                  index_g = id1*id2*2*(k-1)+id1*2*(j-1)+2*(i-1)+1
                  !index_l = nl*nm*2*(k_-1)+nl*2*(j_-1)+2*(i_-1)+1
                  index_l = nl*nn*2*(j_-1)+nn*2*(i_-1)+2*(k_-1)+1
                  mapg2lz_p(index_g) = index_l     ! real part
                  mapg2lz_p(index_g+1) = index_l+1 ! imaginalry part
               end do
            end if
         end do
      end do

    end subroutine make_map_cdz

    subroutine wd_weight_for_ik(ik,mode,nfldos)
      integer, intent(in) :: ik, mode, nfldos
      integer :: m, ib, ib_ordr, kend, kstep, iws
      real(kind=DP),allocatable,dimension(:,:,:):: wei
      write(nfout,'(a,2i8)') '!** in wd_weight ',ik,mode
      if(mode==ALDOS) then
         m = maldos
      else if(mode==LAYERDOS) then
         m = mlayer
      end if

      allocate(wei(m,neg,ik:ik)); wei = 0.d0

      if(ipridos >= 3) then
         write(nfout,'(" !ldos: ik = ",i8)') ik
         do ib = 1, neg
            write(nfout,'(" !ldos: ib, ib_ordr = ",2i20)') ib, neordr(ib,ik)
         end do
      end if

      if(mode==ALDOS)then
        do ib = 1, np_e
           wei(1:m,neg_g(ib),ik) = weiwsc(1:m,ib,ik)
        end do
      else if(mode==LAYERDOS)then
        do ib = 1, np_e
           wei(1:m,neg_g(ib),ik) = weilay(1:m,ib,ik)
        end do
      endif

      if(npes>1) then
         call mpi_allreduce(MPI_IN_PLACE,wei,m*neg,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
!         call mpi_allreduce(MPI_IN_PLACE,wei,m*neg,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
      end if

      if(mype == 0) then
         if(mode==ALDOS) then
            write(nfldos,'(" weight for each atomic cell    nk = ",i8)') ik
         else if(mode==LAYERDOS) then
            write(nfldos,'(" weight for each layer          nk = ",i8)') ik
         end if

         do ib = 1, neg -num_extra_bands
            if(ilen >= m) then
               write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws,ib,ik),iws=1,m)
            else
               write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws,ib,ik),iws=1,ilen)
               write(nfldos,'(5x,5f15.10)') (wei(iws,ib,ik),iws=ilen+1,m)
            end if
         end do
      end if
      deallocate(wei)
    end subroutine wd_weight_for_ik

    subroutine wd_weight_serial(mode,nfldos)
      integer, intent(in) :: mode, nfldos
      integer :: m, ik, ib, ib_ordr, kend, kstep, iws
      real(kind=DP),allocatable,dimension(:):: wei

      if(mode==ALDOS) then
         m = maldos
      else if(mode==LAYERDOS) then
         m = mlayer
      end if

      allocate(wei(m))

      if(ekmode==OFF) then
         kend = kv3; kstep = af+1
      else if(ekmode==ON) then
         kend = 1;   kstep = 1
      end if

      if(ipridos >= 3) then
         do ik = 1, kv3, af+1
            if(map_k(ik) /= myrank_k) cycle
            write(nfout,'(" !ldos: ik = ",i8)') ik
            do ib = 1, neg
               write(nfout,'(" !ldos: ib, ib_ordr = ",2i20)') ib, neordr(ib,ik)
            end do
         end do
      end if

      do ik = 1, kend, kstep
         if(mype == 0) then
            if(mode==ALDOS) then
               write(nfldos,'(" weight for each atomic cell    nk = ",i8)') ik
            else if(mode==LAYERDOS) then
               write(nfldos,'(" weight for each layer          nk = ",i8)') ik
            end if
         end if

         do ib = 1, neg -num_extra_bands

            if(mode == ALDOS) then
               wei(1:m) = weiwsc(1:m,ib,ik)
            else if(mode == LAYERDOS) then
               wei(1:m) = weilay(1:m,ib,ik)
            end if
            if(mype == 0)  then
               if(ilen >= m) then
                  write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws),iws=1,m)
               else
                  write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws),iws=1,ilen)
                  write(nfldos,'(5x,5f15.10)') (wei(iws),iws=ilen+1,m)
               end if
            end if
         end do
      end do

      deallocate(wei)
    end subroutine wd_weight_serial

    subroutine substitute_weilay(ik,ib)
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!     Revised by T. Yamasaki, Feb. 2020
!
      integer, intent(in) :: ik,ib

      integer :: i, ilay, iax1, iax2, iax3, ri
      real(kind=DP) :: a1,a2,width, g,ss, denom
      complex(kind=CMPLDP) :: zi,zsum,zchg
      real(kind=DP),allocatable,dimension(:) :: zsum_layer
      real(kind=DP), allocatable, dimension(:) :: zrhoik ! d(kg*kimg)
      real(kind=DP), allocatable, dimension(:) :: bfft   ! d(nfft)

      allocate(zsum_layer(mlayer)); zsum_layer = 0.d0

      denom = 1.d0/product(fft_box_size_WF(1:3,1))
!!$      zi = cmplx(0.d0,1.d0)
      zi = cmplx(0.d0,1.d0)*PAI2

      iax1 = normal_axis_winlay
      iax2 = iax1 + 1
      if(iax2 >= 4) iax2 = iax2 - 3
      iax3 = iax2 + 1
      if(iax3 >= 4) iax3 = iax3 - 3

!!$      ss = 1.d0/maxhv
      ss = 3.d0 - kimg

!!$      call get_height(height)

!!$      n = fft_box_size_WF(1,0)*fft_box_size_WF(2,0)*fft_box_size_WF(3,1)
!!$      n = nfft*kimg/kimg/2
      do i = 1, lsize*kimg/2
         wk_bfft_l(2*i-1,1) = wk_bfft_l(2*i-1,1)**2 + wk_bfft_l(2*i,1)**2
         wk_bfft_l(2*i,  1) = 0.d0
      end do
      if(sw_fft_xzy>0)then
         call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
      else
         call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
      endif
      allocate(bfft(nfft)); bfft = 0.0d0
      do ri = 0,kimg-1
         do i = 1, nfft/kimg
            if(map_fft_x(i)-1 == myrank_g) then
               bfft(kimg*(i-1)+1+ri) = wk_bfft_l(mapg2lx(kimg*(i-1)+1+ri),1)
            end if
         end do
      end do
!!$      if(kimg == 1) then
!!$         do i = 1, nfft
!!$            if(map_fft_x(i)-1 == myrank_g) then
!!$               bfft(i) = wk_bfft_l(mapg2lx(i),1)
!!$            end if
!!$         end do
!!$      else
!!$         do i = 1, nfft/2
!!$            if(map_fft_x(i)-1 == myrank_g) then
!!$               bfft(2*i-1) = wk_bfft_l(mapg2lx(2*i-1),1)
!!$               bfft(2*i  ) = wk_bfft_l(mapg2lx(2*i  ),1)
!!$            end if
!!$         end do
!!$      end if
      call mpi_allreduce(MPI_IN_PLACE,bfft,nfft,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)

      allocate(zrhoik(kg*kimg))
      do ri = 0,kimg-1
         do i = 1, kg
            zrhoik(kimg*(i-1)+1+ri) = bfft(kimg*(igf(i)-1)+1+ri)*denom
         end do
      end do
!!$      if(kimg == 1) then
!!$         do i = 1, kg
!!$            zrhoik(i) = bfft(igf(i))*denom
!!$         end do
!!$      else
!!$         do i = 1, kg
!!$            zrhoik(i*2-1) = bfft(igf(i)*2-1)*denom
!!$            zrhoik(i*2  ) = bfft(igf(i)*2  )*denom
!!$         end do
!!$      end if
      deallocate(bfft)

      do ilay = 1, mlayer
!!$         a2 = winlay(ilay,2)
!!$         a1 = winlay(ilay,1)
         a2 = winlay(ilay,2)/height
         a1 = winlay(ilay,1)/height
         width = a2 - a1
         zsum = cmplx(zrhoik(1)*width,0.d0)
!!$         zsum = univol*cmplx(zrhoik(1)*width,0.d0)
         if(kimg == 1) then
            do i = 2, kg
               if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                  g = ngabc(i,iax1)
                  zsum = zsum  + zrhoik(i)*((cdexp(zi*g*a2)-cdexp(zi*g*a1))/( zi*g ))
               end if
            end do
         else if(kimg == 2) then
            do i = 2, kg
               if(ngabc(i,iax2) ==  0 .and. ngabc(i,iax3) == 0) then
                  g = ngabc(i,iax1)
                  zchg = dcmplx(zrhoik(i*2-1),zrhoik(i*2))
                  zsum = zsum  + zchg*((cdexp(zi*g*a2)-cdexp(zi*g*a1))/( zi*g ))
               endif
            enddo
         endif
         zsum_layer(ilay) = real(zsum)*ss
      end do
      deallocate(zrhoik)

      do ilay = 1, mlayer
         weilay(ilay,ib,ik) = zsum_layer(ilay)
      end do

      deallocate(zsum_layer)
#ifdef DEBUG_LDOS
      if(ib<=4) then
         write(nfout,'("weilay(1,ib=",i6,",k=",i6,") (softpart) = ",f8.4)') ib, ik,weilay(1,ib,ik)
      end if
#endif

    end subroutine substitute_weilay

    subroutine substitute_weiwsc(ik,ib,mode)
      integer, intent(in) :: ik,ib,mode ! ib is in [1: np_e]
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!     Revised by T. Yamasaki, Feb. 2020
!
      integer :: nwsc,n, ijk
      real(kind=DP) :: denom
      real(kind=DP), allocatable, dimension(:) :: b

      if(mode==SOFTPART) denom = 1.d0/product(fft_box_size_WF(1:3,1))
      if(mode==HARDPART) denom = 0.5d0*univol/product(fft_box_size_CD(1:3,1))

      allocate(b(maldos)); b(:) = 0.d0
      if(mode==SOFTPART) then
         do n = 1, nel_fft_z(myrank_g)
            nwsc = nwsc_mesh_l(n)
            b(nwsc) = b(nwsc) + wk_bfft_l(2*n-1,1)**2+wk_bfft_l(2*n,1)**2
         end do
      else if(mode==HARDPART) then
         do n = 1, nel_fftcd_z(myrank_g)
            nwsc = nwsc_mesh_l(n)
            b(nwsc) = b(nwsc) + wk_bfft_l(2*n-1,1)
         end do
      end if
      call mpi_allreduce(MPI_IN_PLACE,b,maldos,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
      weiwsc(:,ib,ik) = weiwsc(:,ib,ik) + denom*b(:)
      if(allocated(b)) deallocate(b)

      if(ipridos >=2) then
         write(nfout,'(" !ldos-",a8," : ik ,ib = ",2i8)') tag_Hard_or_Soft(mode), ik, ib
         write(nfout,'(" !ldos : weiwsc: ",8f10.5)') (weiwsc(nwsc,ib,ik),nwsc=1,maldos)
      end if

    end subroutine substitute_weiwsc

    subroutine substitute_weiwsc_acmesh(ik,ib,cd,wsc)
      integer, intent(in) :: ik,ib
      logical, intent(in) :: cd
      real(kind=DP), intent(inout), dimension(maldos,np_e,ista_k:iend_k) :: wsc
      integer :: ijk, nwsc,n
      real(kind=DP) :: xx, denom
      integer :: i,j,k, id, nl, nm, nn, nlhf,inew,jnew,knew,ip,mm,is,nl2,nm2,nn2
      integer :: ii,jj,kk,iatm,rii
      real(kind=DP) :: ri,rj,rk
      real(kind=DP), allocatable, dimension(:) :: xmat,ymat,zmat
      real(kind=DP), allocatable, dimension(:,:,:) :: cmatr
      real(kind=DP) :: rho
      real(kind=DP) :: trilinear_interpolation
      integer, pointer, dimension(:,:) :: amesh
      integer, pointer, dimension(:) :: namesh

      integer :: ista,iend
      real(kind=DP), allocatable, dimension(:) :: bfft
      integer :: iadd,gj,gl,gk,iadd1,nx,ny,nz
      integer :: id_sname = -1
      call tstatc0_begin('substitute_weiwsc_acmesh ',id_sname,level=1)
      if(printable .and. ib==1)then
        if(.not.cd) then
          write(nfout,'(a,i10,a)') ' !** AC MESH processing kpoint no. ',ik,' (softpart)'
        else
          write(nfout,'(a,i10,a)') ' !** AC MESH processing kpoint no. ',ik,' (hardpart)'
        endif
      endif
      if(.not.cd) then
         allocate(bfft(nfft));bfft=0.d0
         do rii = 0,kimg-1
            do i = 1, nfft/kimg
               if(map_fft_z(i)-1 == myrank_g) then
                  bfft(kimg*(i-1)+1+rii) = wk_bfft_l(mapg2lz(kimg*(i-1)+1+rii),1)
               end if
            end do
         end do
         call mpi_allreduce(MPI_IN_PLACE,bfft,nfft,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
      else
         allocate(bfft(nfftp_nonpara));bfft=0.d0
         do rii = 0,kimg-1
            do i = 1, nfftp_nonpara/kimg
               if(map_fftcd_z(i)-1 == myrank_g) then
                  bfft(kimg*(i-1)+1+rii) = wk_bfft_l(mapg2lz_p(kimg*(i-1)+1+rii),1)
               end if
            end do
         enddo
         call mpi_allreduce(MPI_IN_PLACE,bfft,nfftp_nonpara,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
      end if

      if(cd)then
        id = fft_box_size_CD_nonpara(1,0)
        mm = fft_box_size_CD_nonpara(2,0)
        nl = fft_box_size_CD(1,1)
        nm = fft_box_size_CD(2,1)
        nn = fft_box_size_CD(3,1)
      else
        id = fft_box_size_WF(1,0)
        mm = fft_box_size_WF(2,0)
        nl = fft_box_size_WF(1,1)
        nm = fft_box_size_WF(2,1)
        nn = fft_box_size_WF(3,1)
      endif
      ista = ista_atm2
      iend = iend_atm2
      nl2=nl+2;nm2=nm+2;nn2=nn+2
      allocate(xmat(nl2));allocate(ymat(nm2));allocate(zmat(nn2))
      allocate(cmatr(nl2,nm2,nn2))
      if(kimg == 1) then
         nlhf = id/2
      else
         nlhf = id
      end if

      do i = 0, nm+1
        do j = 0, nn+1
          do k = 0, nl+1
            ii=i;jj=j;kk=k
            if(i.eq.0) ii = nm
            if(j.eq.0) jj = nn
            if(k.eq.0) kk = nl
            if(i.eq.nm+1) ii = 1
            if(j.eq.nn+1) jj = 1
            if(k.eq.nl+1) kk = 1
            if(kimg == 1 .and. kk > nlhf) then
               knew = id - kk
               jnew = nn+2 - jj
               inew = nm+2 - ii
               if(jnew > nn) then
                  jnew = jnew - nn
               end if
               if(inew > nm) then
                  inew = inew - nm
               end if
            else
               knew = kk; jnew = jj; inew = ii
            end if
            ip = nlhf*mm*(jnew-1) + nlhf*(inew-1) + knew
            xmat(k+1) = dble(k)/dble(nl)
            ymat(i+1) = dble(i)/dble(nm)
            zmat(j+1) = dble(j)/dble(nn)
            if(.not.cd) then
               cmatr(k+1,i+1,j+1) = bfft(ip*2-1)**2+bfft(ip*2)**2
            else
               cmatr(k+1,i+1,j+1) = bfft(2*ip-1)
            endif
           enddo
        enddo
      enddo

      if(cd) then
        namesh => nac_mesh_cd
      else
        namesh => nac_mesh
      endif

      if(cd) then
        denom = 0.5d0*univol/dble(product(fft_box_size_CD(1:3,1)))/dble(acmesh_factor*acmesh_factor*acmesh_factor)
      else
        denom = 1.d0/dble(product(fft_box_size_WF(1:3,1)))/dble(acmesh_factor*acmesh_factor*acmesh_factor)
      endif
      do iatm=ista,iend
         if(cd)then
           amesh => ac_mesh_cd(iatm,:,:)
         else
           amesh => ac_mesh(iatm,:,:)
         endif
         do ijk=1,namesh(iatm)
            ii = amesh(ijk,1)
            jj = amesh(ijk,2)
            kk = amesh(ijk,3)
            ri = dble(ii+acmesh_factor)/dble(nl*acmesh_factor)+pos(iatm,1)
            rj = dble(jj+acmesh_factor)/dble(nm*acmesh_factor)+pos(iatm,2)
            rk = dble(kk+acmesh_factor)/dble(nn*acmesh_factor)+pos(iatm,3)
            if(ri < 0.d0) ri = (ceiling(-ri)) + ri
            if(ri > 1.d0) ri = ri - floor(ri)
            if(rj < 0.d0) rj = (ceiling(-rj)) + rj
            if(rj > 1.d0) rj = rj - floor(rj)
            if(rk < 0.d0) rk = (ceiling(-rk)) + rk
            if(rk > 1.d0) rk = rk - floor(rk)
            rho = trilinear_interpolation(nl2,nm2,nn2,cmatr,xmat,ymat,zmat,ri,rj,rk)
            xx = denom*rho
            wsc(iatm,ib,ik) = wsc(iatm,ib,ik)+xx
         enddo
      enddo

      deallocate(xmat)
      deallocate(ymat)
      deallocate(zmat)
      deallocate(cmatr)
      deallocate(bfft)
      call tstatc0_end(id_sname)
    end subroutine substitute_weiwsc_acmesh

    subroutine substitute_weilay_cd(ik,ib,is,chgq0)
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!     Revised by T. Yamasaki, Feb. 2020
!
      integer, intent(in) :: ik, ib, is
      real(kind=DP), intent(in) :: chgq0

      integer :: i, ista, iax1, iax2, iax3, ilay
      real(kind=DP) :: g, z_work, ss, a1, a2, width
      complex(kind=CMPLDP) :: zi,zsum,zchg
      real(kind=DP),allocatable,dimension(:,:) :: zsum_layer

#ifdef DEBUG_LDOS
      if(ib<=4) then
         write(nfout,'(" ib,ik = ",2i4," weilay(1,ib,ik) = ", f8.4," chgq0 = ",f14.9)') ib,ik,weilay(1,ib,ik),chgq0
      end if
#endif

      allocate(zsum_layer(mlayer,2)); zsum_layer = 0.d0

!!$      if(chgq0 < 0.d0) chgq0 = 0.d0

      zi = cmplx(0.d0,1.d0)*PAI2

      iax1 = normal_axis_winlay
      iax2 = iax1 + 1
      if(iax2 >= 4) iax2 = iax2 - 3
      iax3 = iax2 + 1
      if(iax3 >= 4) iax3 = iax3 - 3

!!$      ss = 0.5d0*univol/maxhv
      ss = 0.5d0*univol*(3.d0-kimg)

      ista = ista_kngp
      if(ista == 1) ista = 2
      do ilay = 1, mlayer
         if(ipridos >= 2) write(nfout,'(" !!ldos: ib = ",i6," ilay = ",i6 &
              & ," <<substitute_weilay_cd>>")') ib,ilay
         a2 = winlay(ilay,2)/height
         a1 = winlay(ilay,1)/height
         width = a2 - a1
         z_work = chgq0*width

         if(ista/=2) z_work=0.d0

         zsum = 0.d0
         if(kimg == 1) then
            do i = ista, iend_kngp
               if(ngabc_kngp_l(i,iax2) == 0 .and. ngabc_kngp_l(i,iax3) == 0) then
                  g = ngabc_kngp_l(i,iax1)
                  zsum = zsum + chgq_l(i,1,is)*( ( cdexp(zi*g*a2) - cdexp(zi*g*a1))/(zi*g))
               end if
            end do
         else if(kimg == 2) then
            do i = ista, iend_kngp
               if(ngabc_kngp_l(i,iax2) == 0 .and. ngabc_kngp_l(i,iax3) == 0) then
                  g = ngabc_kngp_l(i,iax1)
                  zchg = cmplx(chgq_l(i,1,is),chgq_l(i,2,is))
                  zsum = zsum + zchg * ((cdexp(zi*g*a2) - cdexp(zi*g*a1))/(zi*g))
               end if
            end do
         end if
         zsum = zsum + cmplx(z_work,0.d0)

         zsum_layer(ilay,1) = real(zsum)
         zsum_layer(ilay,2) = dimag(zsum)

      end do
      if(npes > 1) call mpi_allreduce(MPI_IN_PLACE,zsum_layer,mlayer*2,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)

      if(mype == 0) then
         do ilay = 1, mlayer
            if(zsum_layer(ilay,2) > 1.d-6) then
               write(nfout,'(" !!ldos: zsum,ne.real imag = ",d16.8," ilay = ",i6)') &
                    & zsum_layer(ilay,2), ilay
            endif
         end do
      end if

      weilay(:,ib,ik) = weilay(:,ib,ik) + zsum_layer(:,1)*ss
! ========================= modified by K. Tagami =============== 11.0
!      do ilay = 1, mlayer
!         weilay(ilay,ib_t,ik) = weilay(ilay,ib_t,ik) + zsum_layer(ilay,1)*ss
!      end do
!
!      if (map_ek(ib,ik) == mype) then
!         do ilay = 1, mlayer
!            weilay(ilay,ib_t,ik) = weilay(ilay,ib_t,ik) + zsum_layer(ilay,1)*ss
!         end do
!      endif
! ============================================================== 11.0

#ifdef DEBUG_LDOS
      if(ib<=4) then
         write(nfout,'(" ib,ik = ",2i4," zsum_layer(1,1) = ", f8.4)') ib, ik,zsum_layer(1,1)*ss
         write(nfout,'(" ib,ik = ",2i4," weilay(1,ib,ik) = ", f8.4)') ib,ik,weilay(1,ib,ik)
         write(nfout,'("")')
      end if
#endif
      deallocate(zsum_layer)

    end subroutine substitute_weilay_cd

    subroutine substitute_weilay_fftmesh(ik,ib,mode)
!   *********************************
!     by T.Yamasaki
!           7th Apr 2017
!   *********************************
!     Revised by T. Yamasaki, Feb. 2020
!
      integer, intent(in) :: ik, ib, mode
      integer :: ijk, nwsc,n
      real(kind=DP) :: denom
      real(kind=DP),allocatable,dimension(:) :: adjustfactor, b ! d(mlayer)
      integer, save :: nwritecount = 0

      if(mode==SOFTPART) then
         denom = 1.d0/product(fft_box_size_WF(1:3,1))
      else if(mode==HARDPART) then
         denom = 0.5d0*univol/product(fft_box_size_CD(1:3,1))
      end if

      allocate(adjustfactor(mlayer))
      call get_adjustfactor(winlay,mlayer,nmeshplay,adjustfactor,nwritecount) ! winlay,height,nmeshl -> adustfactor
      if(nwritecount==0) nwritecount=1

      allocate(b(mlayer)); b(:) = 0.d0
      if(mode==SOFTPART) then
         do n = 1, nel_fft_z(myrank_g)
            nwsc = nwsc_meshlay_l(n)
            b(nwsc) = b(nwsc) + (wk_bfft_l(2*n-1,1)**2+wk_bfft_l(2*n,1)**2)*adjustfactor(nwsc)
         end do
      else
         do n = 1, nel_fftcd_z(myrank_g)
            nwsc = nwsc_meshlay_l(n)
            b(nwsc) = b(nwsc) + wk_bfft_l(2*n-1,1)*adjustfactor(nwsc)
         end do
      end if
      call mpi_allreduce(MPI_IN_PLACE,b,mlayer,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
      weilay(:,ib,ik) = weilay(:,ib,ik) + denom*b(:)
      deallocate(b)
      deallocate(adjustfactor)
    end subroutine substitute_weilay_fftmesh

    subroutine fillup_mesh_l(mode,fillmode)
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!     Revised by T. Yamasaki, Feb. 2020

      integer, intent(in) :: mode, fillmode
      integer, allocatable :: mesh_t(:,:,:)
      integer, allocatable, dimension(:,:) :: mesh_l ! d(nl*nm*nn,2)

      integer :: i,j,k, icount, nwsc, n, nl, nm,nn, nd2,id, i_, j_, k_, index_l
      integer :: nl1,nl2,nm1,nm2,nn1,nn2

      if(allocated(nwsc_mesh_l)) deallocate(nwsc_mesh_l)

      if(mode == SOFTPART) then

         id  = fft_box_size_WF(1,0)
         nd2 = fft_box_size_WF(2,0)
         nn  = fft_box_size_WF(3,1)

         nl2 = xyz_fft_z(2,1); nl1 = xyz_fft_z(1,1) ! x
         nm2 = xyz_fft_z(2,2); nm1 = xyz_fft_z(1,2) ! y
         nn2 = xyz_fft_z(2,3); nn1 = xyz_fft_z(1,3) ! z
         allocate(mesh_t(id,nd2,nn))
         if(fillmode==ALDOS)    mesh_t = mesh
         if(fillmode==LAYERDOS) mesh_t = meshl
      else if(mode == HARDPART) then

         id  = fft_box_size_CD_nonpara(1,0)
         nd2 = fft_box_size_CD_nonpara(2,0)
         nn  = fft_box_size_CD(3,1)

         nl2 = xyz_fftcd_z(2,1); nl1 = xyz_fftcd_z(1,1) ! x
         nm2 = xyz_fftcd_z(2,2); nm1 = xyz_fftcd_z(1,2) ! y
         nn2 = xyz_fftcd_z(2,3); nn1 = xyz_fftcd_z(1,3) ! z
         allocate(mesh_t(id,nd2,nn))
         if(fillmode==ALDOS)    mesh_t = meshp
         if(fillmode==LAYERDOS) mesh_t = meshpl
      end if

      nl = nl2 - nl1 + 1 ! x
      nm = nm2 - nm1 + 1 ! y
      nn = nn2 - nn1 + 1 ! z
      allocate(mesh_l(nl*nm*nn,2))
      if(fillmode==ALDOS)    allocate(nwsc_mesh_l(nl*nm*nn))
      if(fillmode==LAYERDOS) allocate(nwsc_meshlay_l(nl*nm*nn))

      icount = 0
      do k = nn1, nn2  ! z
         k_ = k - nn1 + 1
         do j = nm1, nm2  ! y
            j_ = j - nm1 + 1
            if(kimg==1) then
               do i = nl1, nl2, 2  ! x
                  icount = icount+1
                  i_ = i - nl1 + 1
#ifdef INDEX_L_ORDER_CONFLICT
                  if(mode==SOFTPART) then
                     index_l = nl*nm*(k_-1)+2*nl*((j_-1)/2)+2*(i_-1)+1
                  else
                     index_l = nn*nl*(j_-1)+2*nn*((i_-1)/2)+2*(k_-1)+1
                  end if
#else
                  index_l = nn*nl*(j_-1)+2*nn*((i_-1)/2)+2*(k_-1)+1
#endif
                  nwsc = mesh_t(i,j,k)
                  mesh_l(icount,1) = nwsc
                  mesh_l(icount,2) = index_l
               end do
            else
               do i = nl1, nl2  ! x
                  icount = icount+1
                  i_ = i - nl1 + 1
#ifdef INDEX_L_ORDER_CONFLICT
                  if(mode==SOFTPART) then
                     index_l = nl*nm*2*(k_-1)+nl*2*(j_-1)+2*(i_-1)+1
                  else
                     index_l = nn*nl*2*(j_-1)+nn*2*(i_-1)+2*(k_-1)+1
                  end if
#else
                  index_l = nn*nl*2*(j_-1)+nn*2*(i_-1)+2*(k_-1)+1
#endif
                  nwsc = mesh_t(i,j,k)
                  mesh_l(icount,1) = nwsc
                  mesh_l(icount,2) = index_l
               end do
            end if
         end do
      end do

      deallocate(mesh_t)

      if(fillmode==ALDOS) then
         nwsc_mesh_l = 0
         do i = 1, nl*nm*nn
            i_ = mesh_l(i,2)
            icount = (i_-1)/2+1
            nwsc_mesh_l(icount) = mesh_l(i,1)
         end do
         do i = 1, nl*nm*nn
            i_ = nwsc_mesh_l(i)
            if(i_<=0 .or. natm2+1<i_) then
               write(nfout,'(" !!ldos nwsc_mesh_l(",i5," ) = ",i8)') i,i_
               call flush(nfout)
            end if
            if(natm2+1<i_) nwsc_mesh_l(i) = 0
         end do

      else if(fillmode==LAYERDOS) then
         nwsc_meshlay_l = 0
         do i = 1, nl*nm*nn
            i_ = mesh_l(i,2)
            icount = (i_-1)/2+1
            nwsc_meshlay_l(icount) = mesh_l(i,1)
         end do
         do i = 1, nl*nm*nn
            i_ = nwsc_meshlay_l(i)
            if(i_<=0 .or. mlayer<i_) then
               write(nfout,'(" !!ldos nwsc_meshlay_l(",i5," ) = ",i8)') i,i_
               call flush(nfout)
            end if
            if(mlayer<i_) nwsc_meshlay_l(i) = 0
         end do
      end if

      deallocate(mesh_l)

    end subroutine fillup_mesh_l

  end subroutine cal_weiwsc


  subroutine wd_weight_ek(m,kmap,wei,mode,nfldos)
    real(kind=DP), intent(in), dimension(m,neg,kv3_ek) :: wei
    integer, intent(in), dimension(kv3) :: kmap
    integer, intent(in) :: mode, nfldos
    integer :: m, ib, ib_ordr, kend, kstep, iws, ik
    if(mype == 0) then
       do ik=1,kv3
         if (kmap(ik)>kv3_ek .or. kmap(ik)==0 ) cycle
         write(nfout,'(a,3i8)') '!** in wd_weight ',ik,kmap(ik),mode
!         write(nfldos,'(2i8)') mode,kmap(ik)
         if ( mode == 1 ) then
            write(nfldos,'(2i8,10x,a)') mode, kmap(ik), " # Atom decomposed,  ik"
         else
            write(nfldos,'(2i8,10x,a)') mode, kmap(ik), " # Layer decomposed, ik"
         endif

         do ib = 1, neg -num_extra_bands
            if(ilen >= m) then
               write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws,ib,ik),iws=1,m)
            else
               write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws,ib,ik),iws=1,ilen)
               write(nfldos,'(5x,5f15.10)') (wei(iws,ib,ik),iws=ilen+1,m)
            end if
         end do
      enddo
    endif
  end subroutine wd_weight_ek

  subroutine check_sum(ik,aword)
    integer,intent(in) :: ik
    character*(*),intent(in) :: aword

    integer :: sw_atom_decomp, sw_layer_decomp
    integer :: ib, ia, ilay, ib_ordr, ik_t
    real(kind=DP), allocatable, dimension(:) :: sum_aldos, sum_layer

    sw_atom_decomp = OFF;  sw_layer_decomp = OFF
    if ( sw_aldos == ON .or. sw_calc_wf_atom_decomposition == ON ) then
       sw_atom_decomp = ON
    endif
    if ( sw_layerdos == ON .or. sw_calc_wf_layer_decomposition == ON ) then
       sw_layer_decomp = ON
    endif

    if(sw_atom_decomp==ON) allocate(sum_aldos(neg))
    if(sw_layer_decomp==ON) allocate(sum_layer(neg))

    if ( sw_lband == ON ) then
       ik_t = ik
    else
       if(ekmode /= ON) then
          ik_t = ik
       else if(ekmode == ON) then
          ik_t = 1
       end if
    endif

    if(sw_atom_decomp==ON) then
       sum_aldos = 0.d0
       do ib = 1, np_e
!!$               ibt = neg_g(ib)
          do ia = 1, natm2 + 1
             sum_aldos(neg_g(ib)) = sum_aldos(neg_g(ib)) + weiwsc(ia,ib,ik_t)
!!$               sum_aldos(neg_g(ib)) = sum_aldos(neg_g(ib)) + weiwsc(ia,ibt,ik_t)
          end do
       end do
       call mpi_allreduce(MPI_IN_PLACE,sum_aldos,neg,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
    end if

    if(sw_layer_decomp==ON) then
       sum_layer = 0.d0
       do ib = 1, np_e
          do ilay = 1, mlayer
             sum_layer(neg_g(ib)) = sum_layer(neg_g(ib)) + weilay(ilay,ib,ik_t)
          end do
       end do
       call mpi_allreduce(MPI_IN_PLACE,sum_layer,neg,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
    end if

!!$      if(mype == 0) then
    if(ipridos>=1) then
       if(sw_atom_decomp==ON .and. sw_layer_decomp==ON) then
          write(nfout,9001) aword,"atomic, layer",neg,natm2,ik
          do ib = 1, neg
             write(nfout,'(" !!ldos ", i4,2f16.8)') ib, sum_aldos(ib), sum_layer(ib)
          end do
       else if(sw_atom_decomp==ON) then
          write(nfout,9002) aword,"atomic",neg,natm2,ik
          do ib = 1, neg
             write(nfout,'(" !!ldos ", i4,f16.8)') ib, sum_aldos(ib)
          end do
       else if(sw_layer_decomp==ON) then
          write(nfout,9002) aword,"layer ",neg,natm2,ik
          do ib = 1, neg
             write(nfout,'(" !!ldos ", i4,f16.8)') ib, sum_layer(ib)
          end do
       end if
9001     format(' !!ldos ',a13,' -- iban , sum(',a6,') --  neg = ',i6,' natm2 = ',i6,' ik = ',i6)
9002     format(' !!ldos ',a8, ' -- iban , sum(',a6,') --  neg = ',i6,' natm2 = ',i6,' ik = ',i6)
    end if

    if(sw_atom_decomp==ON) deallocate(sum_aldos)
    if(sw_layer_decomp==ON) deallocate(sum_layer)

  end subroutine check_sum

  subroutine check_sum_full(aword,normalize)
    character*(*),intent(in) :: aword
    logical, intent(in), optional :: normalize
    integer :: ik, ib, ia, ilay, ike,j,ierr
    integer, parameter :: num_kset = 4
    integer :: sw_atom_decomp, sw_layer_decomp
    real(kind=DP), allocatable, dimension(:,:) :: sum_aldos, sum_layer, sum_mpi
    logical :: norma

    norma = .false.
    if(present(normalize)) norma = .true.

    sw_atom_decomp = OFF;  sw_layer_decomp = OFF
    if ( sw_aldos == ON .or. sw_calc_wf_atom_decomposition == ON ) then
       sw_atom_decomp = ON
    endif
    if ( sw_layerdos == ON .or. sw_calc_wf_layer_decomposition == ON ) then
       sw_layer_decomp = ON
    endif

    if(sw_atom_decomp==ON) allocate(sum_aldos(neg,kv3))
    if(sw_layer_decomp==ON) allocate(sum_layer(neg,kv3))

    if(sw_atom_decomp==ON) then
       sum_aldos = 0.d0
       do ik = ista_k, iend_k
          do ib = 1, np_e
             do ia = 1, natm2 + 1
                sum_aldos(neg_g(ib),ik) = sum_aldos(neg_g(ib),ik) + weiwsc(ia,ib,ik)
             end do
          end do
       end do
       call mpi_allreduce(MPI_IN_PLACE,sum_aldos,neg*kv3,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
       call mpi_allreduce(MPI_IN_PLACE,sum_aldos,neg*kv3,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
    end if
    if(sw_layer_decomp==ON) then
       sum_layer = 0.d0
       do ik = ista_k, iend_k
          do ib = 1, np_e
             do ilay = 1, mlayer
                sum_layer(neg_g(ib),ik) = sum_layer(neg_g(ib),ik) + weilay(ilay,ib,ik)
             end do
          end do
       end do
       call mpi_allreduce(MPI_IN_PLACE,sum_layer,neg*kv3,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
       call mpi_allreduce(MPI_IN_PLACE,sum_layer,neg*kv3,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
    end if

    if(ipridos>=1) then
       do ik = 1, kv3, num_kset
          ike = min(kv3,ik+num_kset-1)
          if(sw_atom_decomp==ON .and. sw_layer_decomp==ON) then
             write(nfout,9001) aword,"atomic,layer",neg,natm2,ik,ike
             write(nfout,'(" !!ldos iban ",4a24)')   (("   aldos      layerdos  "),j=1,4)
             do ib = 1, neg
                write(nfout,'(" !!ldos ",i4,8f12.8)') ib,(sum_aldos(ib,j),sum_layer(ib,j),j=ik,ike)
             end do
          else if(sw_atom_decomp==ON) then
             write(nfout,9002) aword,"atomic",neg,natm2,ik,ike
             do ib = 1, neg
                write(nfout,'(" !!ldos ",i4,4f14.8)') ib,(sum_aldos(ib,j),j=ik,ike)
             end do
          else if(sw_layer_decomp==ON) then
             write(nfout,9002) aword,"layer ",neg,natm2,ik,ike
             do ib = 1, neg
                write(nfout,'(" !!ldos ",i4,4f14.8)') ib,(sum_layer(ib,j),j=ik,ike)
             end do
          end if
       end do
9001     format(' !!ldos ',a13,' -- iban , sum(',a6,') --  neg = ',i6,' natm2 = ',i6,' ik = [',i4,':',i4,']')
9002     format(' !!ldos ',a8, ' -- iban , sum(',a6,') --  neg = ',i6,' natm2 = ',i6,' ik = [',i4,':',i4,']')
    end if
    if(norma .and. sw_atom_decomp==ON .and. sw_ac_mesh==ON)then
       do ik = ista_k, iend_k
          do ib = 1, np_e
             weiwsc(:,ib,ik) = weiwsc(:,ib,ik)/sum_aldos(neg_g(ib),ik)
          enddo
       enddo
    endif
  end subroutine check_sum_full



  subroutine m_Ldos_get_ldos_index(ip,aldos_or_layerdos,ipdos,tagwords)
    integer, intent(in) ::  ip
    integer, intent(out) :: aldos_or_layerdos, ipdos
    character(len=40), intent(out) :: tagwords
    integer :: i, na

    aldos_or_layerdos = NO
    ipdos = 0
    tagwords = ''
    if(sw_aldos == ON) then
!!$       if(1 <= ip .and. ip <= maldos ) then
       if(1 <= ip .and. ip <= naldos_write ) then
          aldos_or_layerdos = ALDOS
!!$          ipdos = naldos_from + ip - 1
          na = 0
          do i = naldos_from, naldos_to
             if(if_aldos_full(i) == ON) na = na + 1
             if(na == ip) then
                ipdos = i
                exit
             end if
          end do
          if(ipdos > maldos .or. ipdos < 1 ) then
             write(nfout,'(" !! ipdos ( = ",i8," ) is illegal << m_Ldos_get_ldos_index>>")') ipdos
             call phase_error_with_msg(nfout,' ipdos is illegal << m_Ldos_get_ldos_index>>',__LINE__,__FILE__)
          end if
       else if( ip > naldos_write ) then
          if(sw_layerdos == ON) then
             aldos_or_layerdos = LAYERDOS
             ipdos = ip - naldos_write
             write(tagwords,999) winlay(ipdos,1)*BOHR,winlay(ipdos,2)*BOHR
          end if
       end if
    else if(sw_layerdos == ON) then
       if( 1 <= ip .and. ip <= mlayer) then
          aldos_or_layerdos = LAYERDOS
          ipdos = ip
          write(tagwords,999) winlay(ipdos,1)*BOHR,winlay(ipdos,2)*BOHR
       end if
    end if
999 format(' range = [',f8.4,' : ',f8.4,']  (Angst.)')

  end subroutine m_Ldos_get_ldos_index

  subroutine m_Ldos_load_dos_weight()
    use m_Const_Parameters, only :FMAXTAGLEN
    integer :: nldos,imode,ik,kread,m,i,ierr
    real(kind=DP),allocatable,dimension(:) :: w
    integer :: ios
    logical :: eof
    call m_Files_open_nfldos()
    nldos = maldos
    if(mlayer>nldos) nldos = mlayer
    if(.not.allocated(dos_weight_ek)) allocate(dos_weight_ek(2,nldos,neg,kv3_ek))
    dos_weight_ek = 0.d0

    if (mype==0) then
      rewind(nfldos)
      kread = 0
      do i=1, 4
         read(nfldos,*,iostat=ios)
      end do

      do
         read(nfldos,*,iostat=ios) imode,ik
         if(ios==-1) then
           write(nfout,*) '!** EOF reached'
           exit
         endif
         if(imode==ALDOS) then
           m = maldos
         else if (imode==LAYERDOS) then
           m = mlayer
         endif
         allocate(w(m));w=0.d0

         do i = 1, neg -num_extra_bands
            call read_dos_weight(m,w,eof)
            dos_weight_ek(imode,1:m,i,ik) = w(1:m)
            if(eof) then
               write(nfout,*) '!** EOF reached'
               exit
            endif
         end do
         deallocate(w)
         kread = kread+1
!         if (kread == kv3_ek) exit
      enddo
    endif

    call m_Files_close_nfldos()
    if(npes>1) call mpi_bcast(dos_weight_ek,neg*kv3_ek*2*nldos, &
                    mpi_double_precision,0,MPI_CommGroup,ierr)

    contains

    subroutine read_dos_weight(m,w,eof)
      integer, intent(in) :: m
      real(kind=DP), dimension(m), intent(out) :: w
      logical, intent(out) :: eof
      character(len=FMAXTAGLEN) :: chr
      integer :: j,ios
      eof = .false.
      read(nfldos,*,iostat=ios) chr,(w(j),j=1,m)
      if(ios == -1) then
         eof = .true.
         return
      endif
    end subroutine read_dos_weight

  end subroutine m_Ldos_load_dos_weight

  subroutine m_Ldos_get_dos_weight(aldos_or_layerdos,ip,nfldos,ne,nk,dos_weight)
    use m_Const_Parameters, only :FMAXTAGLEN
    integer, intent(in) :: aldos_or_layerdos, ip, nfldos
    integer, intent(in) :: ne, nk
    real(kind=DP), intent(out), dimension(ne,nk) :: dos_weight

    integer :: i, j, ierr, kread, m, imode
    real(kind=DP) :: w
    logical :: eof
    character(len=FMAXTAGLEN) :: chr, chrsp

    if(ne < neg) then
       if(ipridos>=1) write(nfout,'(" !ldos: ne (= ",i6," ) < neg (= ",i6 &
            & ," ) <<m_Ldos_get_dos_weight>>")') ne, neg
       call phase_error_with_msg(nfout,' ne < neg <<m_Ldos_get_dos_weight>>',__LINE__,__FILE__)
    end if

    if(ekmode == OFF) then
       if(nk < kv3_ek) then
          if(ipridos>=1) write(nfout,'(" !ldos: nk (= ",i6," ) < kv3_ek (= ",i6 &
               & ," ) <<m_Ldos_get_dos_weight>>")') nk, kv3_ek
          call phase_error_with_msg(nfout,' nk < kv3_ek <<m_Ldos_get_dos_weight>>',__LINE__,__FILE__)
       end if

!       if(ne <= iend_e .and. nk <= iend_k) then
        if(ne <= neg .and. nk <= kv3) then
          dos_weight = 0.d0
          if(aldos_or_layerdos == ALDOS) then
#ifdef DEBUG_LDOS
             write(nfout,'(" aldos_or_layerdos = ALDOS ip = ", i8, " <<m_Ldos_get_dos_weight>>")') ip
             do j = ista_k, iend_k
                write(nfout,'(" ik = ",i8, " weiwsc")') j
                do i = 1, neg
                   if(map_e(i)==myrank_e) then
                      write(nfout,'(3i8,f8.4)') i, neordr(i,j), map_z(i), weiwsc(ip,map_z(i),j)
                   end if
                end do
             end do
#endif
             do j = ista_k, iend_k
                do i = 1, np_e
                   dos_weight(neg_g(i),j) = weiwsc(ip,i,j)
                end do
             end do
          else if(aldos_or_layerdos == LAYERDOS) then
#ifdef DEBUG_LDOS
             write(nfout,'(" aldos_or_layerdos = LAYERDOS ip = ", i8, " <<m_Ldos_get_dos_weight>>")') ip
             do j = ista_k, iend_k
                write(nfout,'(" ik = ",i8, " weilay")') j
                do i = 1, neg
                   if(map_e(i)==myrank_e) then
                      write(nfout,'(3i8,f8.4)') i, neordr(i,j), map_z(i), weilay(ip,map_z(i),j)
                   end if
                end do
             end do
#endif
             do j = ista_k, iend_k
                do i = 1, np_e
                   dos_weight(neg_g(i),j) = weilay(ip,i,j)
                end do
             end do
          end if
          if(npes > 1) then
             call mpi_allreduce(MPI_IN_PLACE,dos_weight,ne*nk,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
             call mpi_allreduce(MPI_IN_PLACE,dos_weight,ne*nk,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
          end if
       end if
#ifdef DEBUG_LDOS
       if(aldos_or_layerdos == LAYERDOS) then
          write(nfout,'(" aldos_or_layerdos = ",i8," ip = ", i8, " <<m_Ldos_get_dos_weight>>")') aldos_or_layerdos, ip
          do i = 1, ne
             write(nfout,'(i3,12f8.4)') i,(dos_weight(i,j),j=1,min(12,nk))
          end do
       end if
#endif

    else if(ekmode == ON) then
       if(nk < kv3) then
          if(ipridos>=1) write(nfout,'(" !ldos: nk (= ",i6," ) < kv3 (= ",i6 &
               & ," ) <<m_Ldos_get_dos_weight>>")') nk, kv3_ek
          call phase_error_with_msg(nfout,' nk < kv3 <<m_Ldos_get_dos_weight>>',__LINE__,__FILE__)
       end if
       dos_weight(:,:) = dos_weight_ek(aldos_or_layerdos,ip,:,:)
!       call m_Files_open_nfldos()
!       if(mype==0) then
!         rewind(nfldos)
!         do
!            read(nfldos,iostat=ierr) chr
!            if (ierr/=0) then
!               exit
!            endif
!            if (aldos_or_layerdos == ALDOS    .and. chr=='ALDOS') then
!               exit
!            endif
!            if (aldos_or_layerdos == LAYERDOS .and. chr=='LAYERDOS') then
!               exit
!            endif
!         enddo
!         kread = 0
!         j = 0
!         m = 0
!         do
!            read(nfldos,iostat=ierr) j
!            if ( j < 1 .or. j > nk ) then
!               write(nfout,'(a)') '!** invalid nfldos.data file'
!               exit
!            endif
!            kread = kread + 1
!            if (imode == ALDOS) then
!               m = maldos
!            else if (imode == LAYERDOS) then
!               m = mlayer
!            endif
!            do i = 1, ne
!               call read_dos_weight(ip,m,w,eof)
!               if(eof) then
!                  write(nfout,*) '!** EOF reached'
!                  exit
!               endif
!               dos_weight(i,j) = w
!            end do
!            if (kread == nk) exit
!         end do
!       endif
!       call m_Files_close_nfldos()
!       if(npes>1) then
!          call mpi_bcast(dos_weight,ne*nk,mpi_double_precision,0,MPI_CommGroup,ierr)
!       endif
    end if

  end subroutine m_Ldos_get_dos_weight

  subroutine m_Ldos_dealloc()
     if(allocated(if_aldos_full)) deallocate(if_aldos_full)
     if(allocated(mesh)) deallocate(mesh)
     if(allocated(meshp)) deallocate(meshp)
     if(allocated(winlay)) deallocate(winlay)
     if(allocated(ac_mesh)) deallocate(ac_mesh)
     if(allocated(nac_mesh)) deallocate(nac_mesh)
     if(allocated(ac_mesh_cd)) deallocate(ac_mesh_cd)
     if(allocated(nac_mesh_cd)) deallocate(nac_mesh_cd)
  end subroutine m_Ldos_dealloc

  subroutine get_fftbox_size(mode,nl0,nm0,nl,nm,nn)
    integer, intent(in)  :: mode
    integer, intent(out) :: nl0,nm0,nl,nm,nn
    if(mode==SOFTPART) then
       nl0 = fft_box_size_WF(1,0)
       nm0 = fft_box_size_WF(2,0)
       nl  = fft_box_size_WF(1,1)
       nm  = fft_box_size_WF(2,1)
       nn  = fft_box_size_WF(3,1)
    else if(mode==HARDPART) then
       nl0 = fft_box_size_CD_nonpara(1,0)
       nm0 = fft_box_size_CD_nonpara(2,0)
       nl  = fft_box_size_CD(1,1)
       nm  = fft_box_size_CD(2,1)
       nn  = fft_box_size_CD(3,1)
    end if
  end subroutine get_fftbox_size

end module m_Ldos

#undef NEC_TIMER
#ifdef NEC_TIMER
#  define START_TIMER(a) call start_timer(a)
#  define STOP_TIMER(a)  call stop_timer(a)
#else
#  define START_TIMER(a)
#  define STOP_TIMER(a)
#endif
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  MODULE:  m_ES_WF_by_Davidson
!
!  AUTHOR(S): T. Yamamoto   June/12/2005
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_ES_WF_by_Davidson
! $Id: m_ES_WF_by_Davidson.F90 570 2017-04-21 20:34:50Z yamasaki $
#ifdef TRANSPOSE
#ifdef VPP
#define _ODD_BOUNDARY_
#endif
#ifdef SX
#define _ODD_BOUNDARY_
#endif
#ifdef NEC_TUNE1
#define _ODD_BOUNDARY_
#endif
  use m_Const_Parameters,    only : DP,SP,DIRECT,ON,OFF,SCF,GAMMA &
        &                         , SmallestPositiveNumber,SKIP,EXECUT,zi, ELECTRON, OLD
  use m_Parallelization,     only : MPI_CommGroup &
       &                          , myrank_e,myrank_k,map_e,map_k,ista_e,iend_e,istep_e &
       &                          , ista_k,iend_k,np_g1k,ista_g1,mpi_k_world,ierr,map_z &
       &                          , np_e,npes,nrank_e,mype
  use m_Control_Parameters,  only : nspin,ipridavidson,kimg,neg,af,ndavid &
       &                          , max_iter_david, delta_eig_occup, delta_eig_empty &
#ifdef SAVE_FFT_TIMES
       &                          , eps_david, max_subspace_size, sw_save_fft
#else
       &                          , eps_david, max_subspace_size
#endif
  use m_Control_Parameters,  only : sw_dav_scalapack, dav_nprow, dav_npcol, dav_divide_square &
                                  , dav_block_size, sw_fft_xzy
  use m_Files,               only : nfout
  use m_Timing,              only : tstatc0_begin, tstatc0_end
!fj$$F  use m_FFT,                 only : nfft,fft_box_size_WF, m_FFT_Vlocal_W, m_FFT_WF
  use m_FFT,                 only : nfft,fft_box_size_WF
  use m_Kpoints,             only : kv3,vkxyz, k_symmetry
  use m_PlaneWaveBasisSet,   only : kg1, iba, igf, nbase, m_pwBS_kinetic_energies
  use m_Electronic_Structure,only : zaj_l, neordr, nrvf_ordr, eko_l, vlhxcQ &
#ifdef SAVE_FFT_TIMES
 &                                , status_saved_phifftr &
#endif
       &                          , occup_l&
       &                          , fsr_l,fsi_l, vnlph_l, vlhxc_l
  use m_ES_ortho            ,only : np_g1k_x
  use m_ES_nonlocal         ,only : m_ES_alloc_scss_etc_3D                            &
 &                                , m_ES_dealloc_scss_etc
  use m_Ionic_System,       only : natm, iwei, ityp, ntyp
  use m_PseudoPotential,    only : ilmt,nlmta,lmta,q,dion &
       &                         , lmtt,ltp,mtp &
       &                         , m_PP_include_vanderbilt_pot &
       &                         , ipaw,dion_paw
  use m_NonLocal_Potential, only : snl
!fj$$F use m_Electronic_Structure,only : zaj_l_3D, eko_l_3D, vnlph_l_3D, snl_l_3D          &
!fj$$F &                                , fsr_l_3D, fsi_l_3D                                &
 use m_Electronic_Structure,only :  m_ES_wd_zaj_small_portion_3D                      &
 &                                , m_ES_wd_eko_3D
  use m_ES_nonlocal         ,only : m_ES_Vnonlocal_W_3D                               &
 &                                , m_ES_betar_dot_WFs_4_each_k_3D                    &
!fj$$F &                                , m_ES_Vnonlocal_W_3D_new                           &
!fj$$F &                                , m_ES_betar_dot_WFs_4_each_k_3D_new
 &                                , m_ES_Vnonlocal_W_3D                           &
 &                                , m_ES_betar_dot_WFs_4_each_k_3D
  use m_Parallelization,     only : ista_g1k, iend_g1k, neg_g, mpi_ke_world &
       &                          , ista_k, iend_k, mpi_kg_world &
       &                          , np_fs, myrank_g, nis_fs
!fj$$F  use z_interface_3D, only        : decomp_zaj_l_3D_ik, decomp_zaj_l_r_3D_ik &
!fj$$F       &                          , decomp_eko_l_3D_new, decomp_vnlph_l_3D &
!fj$$F       &                          , decomp_snl_l_3D_2, decomp_fsr_l_r_3D_ik, decomp_fsr_l_3D_ik &
!fj$$F       &                          , decomp_eko_l_r_3D_new
#ifdef NEC_TIMER
  use nec_timer
#endif
! === FFT Marge. by T.Kato ===============================================================
  use m_Parallelization,     only : nel_fft_x , nel_fft_y, nel_fft_z &
                                  , fft_X_x_nel, fft_X_y_nel, fft_X_z_nel &
                                  , mp_g1k, myrank_g
  use m_Electronic_Structure,only : m_ES_Vlocal_in_Rspace_3D, m_ES_WF_in_Rspace_3D &
!fj$$F                                  , vlhxc_l, vlhxc_l_3D
                                  , vlhxc_l
  use m_FFT,                 only : m_FFT_Vlocal_W_3D, m_FFT_Direct_3D             &
#ifdef FFT_3D_DIVISION
 &                                , m_FFT_Vlocal_W_3DIV_3D, m_FFT_Direct_3DIV_3D   &
#endif
 &                                , m_FFT_Direct_XYZ_3D
  use m_ES_WF_by_SDorCG,     only : map_fft_to_WF_3D
!fj$$F  use z_interface_3D,        only : decomp_vlhxc_l_3D
! ========================================================================================
! === Marge to Riken Source by T.Kato ====================================================
  use m_Electronic_Structure,only : zaj_ball, nblocksize_mgs_default
!fj$$F  use z_interface_3D,        only : replacement_zaj_ball_sequence
! ========================================================================================
! === DEBUG by tkato 2012/04/06 ================================================
  use m_Parallelization,     only : nrank_g
! ==============================================================================


! ==================================== added by K. Tagami ============== 11.0
  use m_Const_Parameters,    only : CMPLDP, Neglected, BuiltIn
  use m_Control_Parameters,  only : noncol, ndim_spinor, ndim_chgpot, ndim_magmom, &
       &                            SpinOrbit_mode, sw_hubbard
  use m_PseudoPotential,     only : q_noncl, dion_scr_noncl
!  use m_Electronic_Structure,  only : m_ES_Vlocal_in_Rspace_noncl, &
!       &                              m_ES_sort_eigen_vals_noncl
!
!  use m_FFT,                 only : m_FFT_Vlocal_W_noncl
! ====================================================================== 11.0
  use mpi

  implicit none

  integer :: nsize_subspace, nsize_matrix
  integer :: nsize_sb_now, nsize_mt_now, nsize_mt_old
  real(kind=DP), allocatable, dimension(:) :: w1hw2
  real(kind=DP), allocatable, dimension(:) :: w1sw2
  real(kind=DP), allocatable, dimension(:) :: w1_mpi
  real(kind=DP), allocatable, dimension(:,:,:,:) :: zat_l
  real(kind=DP), allocatable, dimension(:,:,:) :: zah_l
  real(kind=DP), allocatable, dimension(:,:,:) :: fsr,fsi
  real(kind=DP), allocatable, dimension(:,:,:) :: zaj_l_backup
  logical, allocatable, dimension(:) :: feigconv
  integer, allocatable, dimension(:) :: ibover
#ifdef _USE_SCALAPACK_
  integer :: nprow, npcol, nrowa, ncola
  integer, dimension(9) :: desca
  integer :: lwork1, liwork1
  integer :: lwork2, liwork2, lrwork2
  integer :: ctxt
! === DEBUG by tkato 2012/12/20 ================================================
  integer :: myprow, mypcol
! ==============================================================================
#endif

! ================================= added by K. Tagami ================= 11.0
  real(kind=DP), allocatable, dimension(:,:,:,:,:) :: zat_l_noncl
  real(kind=DP), allocatable, dimension(:,:,:,:) :: zah_l_noncl
  real(kind=DP), allocatable, dimension(:,:,:,:) :: fsr_noncl, fsi_noncl
  real(kind=DP), allocatable, dimension(:,:,:,:) :: zaj_l_backup_noncl
! ===================================================================== 11.0

!  include 'mpif.h'
contains

  subroutine m_ESdavidson_Renew_WF(nfout,precon)
    integer, intent(in) :: nfout,precon

    integer             :: ispin, ik, iksnl, switch_of_eko_part
    integer :: idavid,itot
    real(kind=DP), allocatable, dimension(:) ::  afft, bfft
    real(kind=DP), dimension(maxval(np_g1k)) :: ekin_l,vnldi_l,hdiag_l,sdiag_l
    real(kind=DP) :: vlhxc0
    logical :: frestart
    integer :: max_idavid, max_itot
    integer :: idavid_now, itot_now, ipri0
! === FFT Marge. by T.Kato ===============================================================
    integer :: lsize, ibsize, isrsize, fft_l_size
    real(kind=DP), allocatable, dimension(:) :: afft_l
    real(kind=DP), allocatable, dimension(:,:) :: wk_bfft_l
    real(kind=DP), allocatable, dimension(:,:) :: bfft_l
! ========================================================================================
    integer :: n_unconv
! ========================================================================================

    max_idavid = 1
    max_itot = 1

    call m_ES_alloc_scss_etc_3D()
    allocate(afft(nfft)); allocate(bfft(nfft))

    call allocate_matrix
! ==============================================================================
START_TIMER('Davidson_Initialize')
!fj$$F    do ispin = 1, nspin, (af+1)
!fj$$F       call decomp_vlhxc_l_3D(vlhxc_l,vlhxc_l_3D,ispin)
!fj$$F       do ik = ispin, kv3-nspin+ispin, nspin
!fj$$F          if(map_k(ik) /= myrank_k) cycle
!fj$$F          call decomp_zaj_l_3D_ik(zaj_l,zaj_l_3D,ik,nrvf_ordr,"    ")
!fj$$F          call decomp_snl_l_3D_2(snl,snl_l_3D,ik)
!fj$$F          call decomp_fsr_l_3D_ik(fsr_l,fsr_l_3D,ik,nrvf_ordr,"    ")
!fj$$F          if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) &
!fj$$F             call decomp_fsr_l_3D_ik(fsi_l,fsi_l_3D,ik,nrvf_ordr,"    ")
!fj$$F          call decomp_eko_l_3D_new(eko_l,eko_l_3D,ik,nrvf_ordr,"    ")
!fj$$F       enddo
!fj$$F    enddo
STOP_TIMER('Davidson_Initialize')
! ==============================================================================
! === FFT Marge. by T.Kato ===============================================================

#ifdef FFT_3D_DIVISION
    lsize = fft_X_x_nel*fft_X_y_nel*fft_X_z_nel
    allocate(afft_l(lsize*2), stat=ierr)
#else
    lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
    allocate(afft_l(lsize*kimg), stat=ierr)
#endif
    if(ierr /= 0) then
       write(nfout,*)' m_ESdavidson_Renew_WF : Not allocated afft_l array'
       call flush(nfout)
       call mpi_abort(mpi_comm_world, 201, ierr)
    endif
    ibsize = 1
!   if (nblocksize_fftw_is_given) then
!      ibsize = nblocksize_fftw
!      if (ibsize < 1) ibsize = 1
!   endif
! ========================================================================================
#ifdef _USE_SCALAPACK_
! === DEBUG by tkato 2012/12/20 ================================================
    if(sw_dav_scalapack == ON) call create_scalapack_context()
! ==============================================================================
#endif
    do ispin = 1, nspin, (af+1)
! === FFT Marge. by T.Kato ===============================================================
       call m_ES_Vlocal_in_Rspace_3D(ispin,afft_l,lsize,1,OFF) ! (ptfft1) ->afft
! ========================================================================================
       call vlhxc_l_zero_term(vlhxc0,ispin)        ! vlhxc_l -> vlhxc0
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle          ! MPI
! === FFT Marge. by T.Kato ===============================================================
          isrsize = min(lsize,mp_g1k(ik))
          fft_l_size  = nel_fft_x(myrank_g)
#ifdef FFT_3D_DIVISION
          allocate(wk_bfft_l(lsize*2,ibsize) ,stat=ierr)
          allocate(bfft_l(lsize*2,ibsize) ,stat=ierr)
#else
          allocate(wk_bfft_l(lsize*kimg,ibsize) ,stat=ierr)
          allocate(bfft_l(lsize*kimg,ibsize) ,stat=ierr)
#endif
          if (ierr /= 0) then
             write(nfout,*)' m_ESdavidson_Renew_WF :  Not allocate '
             call flush(nfout)
             call mpi_abort(mpi_comm_world, 205, ierr)
          endif
! ========================================================================================
          iksnl = (ik-1)/nspin + 1
          call allocate_t_matrix_3D(ik) ! -> np_g1k_x
          call m_pwBS_kinetic_energies(ik,vkxyz,ekin_l) ! (diakin) ->ekin
          if(precon==ON) then
             call Vnonlocal_Diagonal_part_3D(ispin,ik,iksnl,vnldi_l)
             hdiag_l(1:maxval(np_g1k)) = ekin_l(1:maxval(np_g1k)) + vlhxc0 + vnldi_l(1:maxval(np_g1k))
             call S_Diagonal_part_3D(ik,iksnl,sdiag_l)
          end if
          !!$write(nfout,*) 'debug loop ik=',ik
          max_itot=0
          max_idavid=0
          Loop: do itot=1,max_iter_david
             itot_now = itot
             if(itot>max_itot) max_itot=itot
             feigconv = .false.
             David_Loop: do idavid=1,ndavid
                idavid_now = idavid
                if(idavid>max_idavid) max_idavid=idavid
                !!$write(nfout,*) 'debug loop itot,idavid=',itot,idavid
                if(precon==ON) then
!fj$$F                   call m_ES_Vnonlocal_W_3D_new(ik,iksnl,ispin,switch_of_eko_part=OFF) ! -> vnlph_l
                   call m_ES_Vnonlocal_W_3D(ik,iksnl,ispin,switch_of_eko_part=OFF) ! -> vnlph_l
                else
!fj$$F                   call m_ES_Vnonlocal_W_3D_new(ik,iksnl,ispin,switch_of_eko_part=ON) ! -> vnlph_l
                   call m_ES_Vnonlocal_W_3D(ik,iksnl,ispin,switch_of_eko_part=ON) ! -> vnlph_l
                end if
START_TIMER('Davidson_build_subspace_3D')
!               call build_subspace_3D(ik,ekin,hdiag,sdiag,afft,bfft,idavid,precon) ! -> zajold_l
                call build_subspace_3D(ik,ekin_l,hdiag_l,sdiag_l,afft_l,bfft_l,wk_bfft_l, &
                                       lsize,ibsize,isrsize,fft_l_size,idavid,precon) ! -> zajold_l
STOP_TIMER('Davidson_build_subspace_3D')
START_TIMER('Davidson_allreduce_fs_3D')
                call allreduce_fs_3D(ik,idavid) ! -> fsr,fsi
STOP_TIMER('Davidson_allreduce_fs_3D')
START_TIMER('Davidson_evolve_WFs_in_subspace_3D')
!               call evolve_WFs_in_subspace_3D&     !-(m_ES_WF_by_Davidson)
!                 &(ik,ispin,ekin,afft,bfft,idavid,frestart) !-> zaj_l
                call evolve_WFs_in_subspace_3D&     !-(m_ES_WF_by_Davidson)
                  &(ik,ispin,ekin_l,afft_l,bfft_l,wk_bfft_l, &
                    lsize,ibsize,isrsize,fft_l_size,idavid,frestart) !-> zaj_l
STOP_TIMER('Davidson_evolve_WFs_in_subspace_3D')
                if(ik==1.and.ipridavidson>= 2) then
! ==============================================================================
!fj$$F                   call decomp_zaj_l_r_3D_ik(zaj_l,zaj_l_3D,ik,neordr,"    ")
! ==============================================================================
                   call m_ES_wd_zaj_small_portion_3D(nfout,ik," -- after davidson --",21)
                endif
!fj$$F                call m_ES_betar_dot_WFs_4_each_k_3D_new(nfout,ik)   ! -> fsr_l,fsi_l
                call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik)   ! -> fsr_l,fsi_l
!               if(nsize_sb_now > max_subspace_size) exit David_Loop
                if(frestart) exit David_Loop
                if(eigenvalues_are_converged_3D(n_unconv)) exit Loop
                if(nsize_sb_now + n_unconv > max_subspace_size) exit David_Loop
             end do David_Loop
          end do Loop
          if(ipridavidson>=2) then
             write(nfout,'("Davidson: ik=",i5," itot=",i5," idavid=",i5," subspace=",i5)') &
                  & ik, itot_now, idavid_now, nsize_sb_now
          end if
          call deallocate_t_matrix_3D
! === FFT Marge. by T.Kato ===============================================================
          deallocate(wk_bfft_l)
          deallocate(bfft_l)
! ========================================================================================
       enddo      ! k-point loop
    enddo      ! spin loop
#ifdef _USE_SCALAPACK_
! === DEBUG by tkato 2012/12/20 ================================================
    if(sw_dav_scalapack == ON) call destroy_scalapack_context()
! ==============================================================================
#endif
! === FFT Marge. by T.Kato ===============================================================
    deallocate(afft_l)
! ========================================================================================
! ==============================================================================
START_TIMER('Davidson_Finalize')
!fj$$F    do ispin = 1, nspin, (af+1)
!fj$$F       do ik = ispin, kv3-nspin+ispin, nspin
!fj$$F          if(map_k(ik) /= myrank_k) cycle
!fj$$F          call decomp_zaj_l_r_3D_ik(zaj_l,zaj_l_3D,ik,neordr,"    ")
!fj$$F          call decomp_fsr_l_r_3D_ik(fsr_l,fsr_l_3D,ik,neordr,"    ",0)
!fj$$F          if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) &
!fj$$F             call decomp_fsr_l_r_3D_ik(fsi_l,fsi_l_3D,ik,neordr,"    ",0)
!fj$$F          call decomp_eko_l_r_3D_new(eko_l,eko_l_3D,ik,neordr,"    ")
!fj$$F          call replacement_zaj_ball_sequence(zaj_ball,ik,neordr,nblocksize_mgs_default)
!fj$$F       enddo
!fj$$F    enddo
STOP_TIMER('Davidson_Finalize')
! ==============================================================================
    call deallocate_matrix
    if(ipridavidson>=2) then
       write(nfout,'("Davidson: max_itot=",i5," max_idavid=",i5)') max_itot,max_idavid
    end if

!!  ( in case of af=1 )
    if(af /= 0) then
       call cp_eigen_values_for_af       !-(contained here)
       call expand_neordr_and_nrvf_ordr  !-(contained here)
    end if

    call get_ipri0(ipridavidson,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko_3D(nfout,mode=SCF)
    deallocate(bfft);   deallocate(afft)
    call m_ES_dealloc_scss_etc()


  contains

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,MPI_CommGroup,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    logical function eigenvalues_are_converged_3D(n_unconv)
       integer, intent(out) :: n_unconv
       integer :: ib
       n_unconv = 0
       eigenvalues_are_converged_3D = .true.
       do ib=1,neg
          if(.not.feigconv(ib)) then
             eigenvalues_are_converged_3D = .false.
             n_unconv = n_unconv + 1
          end if
       end do
    end function eigenvalues_are_converged_3D

    subroutine cp_eigen_values_for_af
      integer :: ik,ib
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle    ! MPI
         do ib = 1, np_e                    ! MPI
            eko_l(ib,ik+af) = eko_l(ib,ik)
         enddo
      enddo
    end subroutine cp_eigen_values_for_af

    subroutine expand_neordr_and_nrvf_ordr
      integer :: ik
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle     ! MPI
         neordr(1:neg,ik+af) = neordr(1:neg,ik)
         nrvf_ordr(1:neg,ik+af) = nrvf_ordr(1:neg,ik)
      end do
    end subroutine expand_neordr_and_nrvf_ordr

  end subroutine m_ESdavidson_Renew_WF


  subroutine allocate_matrix
    nsize_subspace = neg*ndavid
    nsize_matrix =  max_subspace_size*(max_subspace_size+1)/2
    allocate(feigconv(neg))
    allocate(ibover(nsize_subspace))
    allocate(fsr(neg,nlmta,ndavid))
    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       allocate(fsi(neg,nlmta,ndavid))
    end if
! ==============================================================================
    allocate(zaj_l_backup(maxval(np_g1k),np_e,kimg)) ! MPI
! ==============================================================================
  end subroutine allocate_matrix


  subroutine deallocate_matrix
    deallocate(feigconv)
    deallocate(ibover)
    deallocate(fsr)
    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       deallocate(fsi)
    end if
    deallocate(zaj_l_backup)
  end subroutine deallocate_matrix


  subroutine allocate_t_matrix_3D(ik)
    integer, intent(in) :: ik
    integer :: kimg_t
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if
#ifdef _ODD_BOUNDARY_
    if(mod(np_g1k(ik),2) == 0) then
       np_g1k_x = np_g1k(ik) + 1
    else
       np_g1k_x = np_g1k(ik)
    end if
#else
    np_g1k_x = np_g1k(ik)
#endif
    allocate(zat_l(maxval(np_g1k),neg,kimg,ndavid)) ! MPI
    allocate(zah_l(maxval(np_g1k),np_e,kimg)) ! MPI
    allocate(w1hw2(nsize_matrix*kimg_t))
    allocate(w1sw2(nsize_matrix*kimg_t))
  end subroutine allocate_t_matrix_3D

  subroutine deallocate_t_matrix_3D
    deallocate(zat_l) ! MPI
    deallocate(zah_l) ! MPI
    deallocate(w1hw2)
    deallocate(w1sw2)
  end subroutine deallocate_t_matrix_3D

  subroutine allreduce_fs_3D(ik,idavid)
    integer, intent(in) :: ik,idavid
    integer :: ib,ib1,iter,kimg_t,is,is1
    real(kind=DP), allocatable, dimension(:,:) :: fs_mpi,fs_mpi2

    allocate(fs_mpi(neg,nlmta))
    allocate(fs_mpi2(neg,nlmta))
    if(idavid>1) then
!fj$$F       call m_ES_betar_dot_WFs_4_each_k_3D_new(nfout,ik)   ! -> fsr_l,fsi_l
       call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik)   ! -> fsr_l,fsi_l
    end if
    fs_mpi=0.d0
    do is = 1, np_fs ! MPI
       is1=nis_fs(myrank_g)+is-1
       do ib = 1, np_e ! MPI
          ib1=neg_g(ib)
          fs_mpi(ib1,is1) = fsr_l(ib,is,ik)
       end do
    end do
    fs_mpi2=0.d0
    call mpi_allreduce(fs_mpi,fs_mpi2,neg*nlmta &
      & ,mpi_double_precision,mpi_sum &
      & ,mpi_k_world(myrank_k),ierr) ! MPI
    fsr(1:neg,1:nlmta,idavid) = fs_mpi2(1:neg,1:nlmta)
    if(.not. k_symmetry(ik) == GAMMA) then
       fs_mpi=0.d0
       do is = 1, np_fs ! MPI
          is1=nis_fs(myrank_g)+is-1
          do ib = 1, np_e ! MPI
             ib1=neg_g(ib)
             fs_mpi(ib1,is1) = fsi_l(ib,is,ik)
          end do
       end do
       fs_mpi2=0.d0
       call mpi_allreduce(fs_mpi,fs_mpi2,neg*nlmta &
         & ,mpi_double_precision,mpi_sum &
         & ,mpi_k_world(myrank_k),ierr) ! MPI
       fsi(1:neg,1:nlmta,idavid) = fs_mpi2(1:neg,1:nlmta)
    end if
    deallocate(fs_mpi)
    deallocate(fs_mpi2)
  end subroutine allreduce_fs_3D

  subroutine build_subspace_3D(ik,ekin_l,hdiag_l,sdiag_l,afft_l,bfft_l,wk_bfft_l, &
                               lsize,ibsize,isrsize,fft_l_size,idavid,precon)
    integer, intent(in) :: ik,idavid,precon,lsize,ibsize,isrsize,fft_l_size
    real(kind=DP), intent(in)  :: ekin_l(maxval(np_g1k)),hdiag_l(maxval(np_g1k)), &
                                  sdiag_l(maxval(np_g1k))
#ifdef FFT_3D_DIVISION
    real(kind=DP), intent(in)  :: afft_l(lsize*2   )
    real(kind=DP), intent(out) :: bfft_l(lsize*2   ,1)
    real(kind=DP), intent(inout) :: wk_bfft_l(lsize*2   ,ibsize)
#else
    real(kind=DP), intent(in)  :: afft_l(lsize*kimg)
!   real(kind=DP), intent(out) :: bfft_l(lsize*kimg,ibesize)
    real(kind=DP), intent(out) :: bfft_l(lsize*kimg,1)
    real(kind=DP), intent(inout) :: wk_bfft_l(lsize*kimg,ibsize)
#endif
    integer :: iter,ib1,ib,ii,i1,iadd
    real(kind=DP) :: dr1,dr2,di1
    real(kind=DP) :: p(maxval(np_g1k))
    real(kind=DP) :: denom, norm, zajr, zaji

    denom = 1.d0/product(fft_box_size_WF(1:3,1))

    if(idavid==1) then
       return
    end if
    ! if precon == ON
    ! |R> = P*(H-Hdiag)|Psi>
    ! P = (Hdiag-e*Sdiag)^(-1)
    ! else
    ! |R> = (H-eS)|Psi>
    do ib1 = 1, np_e ! MPI
       if(feigconv(neg_g(ib1))) cycle
       ib = ib1 ! MPI
START_TIMER('Davidson2_temprary_FFT_1')
#ifdef __TIMER_COMM__
       call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l,0)
#else
       call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l)
#endif
#ifdef FFT_3D_DIVISION
       call m_FFT_Vlocal_W_3DIV_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_x(myrank_g))
       call m_FFT_Direct_3DIV_3D(nfout,wk_bfft_l,lsize,ibsize)
#else
       if (sw_fft_xzy > 0) then
          call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_y(myrank_g))
          call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
       else
          call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
          call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
       end if
#endif
       call map_fft_to_WF_3D(ik,lsize,ibsize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
STOP_TIMER('Davidson2_temprary_FFT_1')
       if(precon==ON) then
          call decide_precon_factor_david(ik,hdiag_l,sdiag_l,eko_l(ib,ik),p) ! -> p
          if(kimg == 1) then
             do ii=ista_g1k(ik),iend_g1k(ik)
                iadd = ii - ista_g1k(ik) + 1
                i1  = igf(nbase(ii,ik))
                dr1 = zaj_l(iadd,ib,ik,kimg)
                dr2 = bfft_l(iadd,1)*denom
                zajr= (ekin_l(iadd)-hdiag_l(iadd))*dr1+dr2+vnlph_l(iadd,ib,kimg)
                zaj_l(iadd,ib,ik,kimg) = p(iadd)*zajr
             enddo
          else
             do ii=ista_g1k(ik),iend_g1k(ik)
                iadd = ii - ista_g1k(ik) + 1
                i1  = igf(nbase(ii,ik))
                dr1  = zaj_l(iadd,ib,ik,1)
                di1  = zaj_l(iadd,ib,ik,kimg)
                dr2  = ekin_l(iadd) - hdiag_l(iadd)
                zajr= dr2*dr1+bfft_l(2*iadd-1,1)*denom + vnlph_l(iadd,ib,1)
                zaji= dr2*di1+bfft_l(2*iadd,  1)*denom + vnlph_l(iadd,ib,2)
                zaj_l(iadd,ib,ik,1   )=p(iadd)*zajr
                zaj_l(iadd,ib,ik,kimg)=p(iadd)*zaji
             enddo
          endif
       else
          if(kimg == 1) then
             do ii=ista_g1k(ik),iend_g1k(ik)
                iadd = ii - ista_g1k(ik) + 1
                i1  = igf(nbase(ii,ik))
                dr1 = zaj_l(iadd,ib,ik,kimg)
                dr2 = bfft_l(iadd,1)*denom
                zajr= ekin_l(iadd)*dr1+dr2+vnlph_l(iadd,ib,kimg)
                zaj_l(iadd,ib,ik,kimg) = zajr
             enddo
          else
             do ii=ista_g1k(ik),iend_g1k(ik)
                iadd = ii - ista_g1k(ik) + 1
                i1  = igf(nbase(ii,ik))
                dr1  = zaj_l(iadd,ib,ik,1)
                di1  = zaj_l(iadd,ib,ik,kimg)
                zajr= ekin_l(iadd)*dr1+bfft_l(2*iadd-1,1)*denom + vnlph_l(iadd,ib,1)
                zaji= ekin_l(iadd)*di1+bfft_l(2*iadd,  1)*denom + vnlph_l(iadd,ib,2)
                zaj_l(iadd,ib,ik,1   )=zajr
                zaj_l(iadd,ib,ik,kimg)=zaji
             enddo
          endif
       end if

       ! Normalize
       norm = 0.d0
       if(kimg==1) then
          do ii=ista_g1k(ik),iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             zajr = zaj_l(iadd,ib,ik,kimg)
             norm = norm + zajr*zajr
          end do
          call mpi_allreduce(MPI_IN_PLACE,norm,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
          norm = 1.d0/sqrt(norm)
          do ii=ista_g1k(ik),iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             zaj_l(iadd,ib,ik,kimg) = zaj_l(iadd,ib,ik,kimg)*norm
          end do
       else
          do ii=ista_g1k(ik),iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             zajr = zaj_l(iadd,ib,ik,1   )
             zaji = zaj_l(iadd,ib,ik,kimg)
             norm = norm + zajr*zajr+zaji*zaji
          end do
          call mpi_allreduce(MPI_IN_PLACE,norm,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
          norm = 1.d0/sqrt(norm)
          do ii=ista_g1k(ik),iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             zaj_l(iadd,ib,ik,1)   = zaj_l(iadd,ib,ik,1)*norm
             zaj_l(iadd,ib,ik,kimg)= zaj_l(iadd,ib,ik,kimg)*norm
          enddo
       end if
    end do
  contains
    subroutine decide_precon_factor_david(ik,hdiag_l,sdiag_l,eig,p)
      integer, intent(in) :: ik
      real(kind=DP), intent(in) :: hdiag_l(maxval(np_g1k)), &
                                   sdiag_l(maxval(np_g1k)),eig
      real(kind=DP), intent(out) :: p(maxval(np_g1k))

      integer :: ii, iadd
      real(kind=DP) :: denom

      do ii=ista_g1k(ik),iend_g1k(ik)
         iadd = ii - ista_g1k(ik) + 1
         denom = hdiag_l(iadd)-eig*sdiag_l(iadd)
         if(abs(denom) < eps_david) then
            denom = sign(eps_david,denom)
         end if
         p(iadd) = 1.d0/denom
      end do

    end subroutine decide_precon_factor_david
  end subroutine build_subspace_3D

  subroutine evolve_WFs_in_subspace_3D&
       &(ik,ispin,ekin_l,afft_l,bfft_l,wk_bfft_l, &
         lsize,ibsize,isrsize,fft_l_size,idavid,frestart)
    integer, intent(in) :: ik,ispin,lsize,ibsize,isrsize,fft_l_size
    integer, intent(in) :: idavid
    logical, intent(out) :: frestart
    real(kind=DP), intent(in)  :: ekin_l(maxval(np_g1k))
#ifdef FFT_3D_DIVISION
    real(kind=DP), intent(in)  :: afft_l(lsize*2   )
    real(kind=DP), intent(out) :: bfft_l(lsize*2   ,1)
    real(kind=DP), intent(inout) :: wk_bfft_l(lsize*2   ,ibsize)
#else
    real(kind=DP), intent(in)  :: afft_l(lsize*kimg)
!   real(kind=DP), intent(out) :: bfft_l(lsize*kimg,ibesize)
    real(kind=DP), intent(out) :: bfft_l(lsize*kimg,1)
    real(kind=DP), intent(inout) :: wk_bfft_l(lsize*kimg,ibsize)
#endif
! (allocatable variables)
    real(kind=DP), allocatable,dimension(:) ::     eig
    real(kind=DP), allocatable,dimension(:,:) ::   vec
    real(kind=DP), allocatable,dimension(:) ::     eko_d
    real(kind=DP), allocatable,dimension(:) ::     eko_d_mpi
    integer, allocatable,dimension(:) ::     occup
    integer, allocatable,dimension(:) ::     occup_mpi

    integer       :: ib1,ib2,ib1to,ib2to,i1,ii,ri,ib
    integer       :: ibb1,ibb2
    integer       :: ii1,ii2,iter,iter1,iter2
    real(kind=DP) :: denom, eko1, eko2, ekod
    real(kind=DP) :: hr2,hi2,dr1,dr2,di1,di2,dd
    integer :: ip0,ip0b,ip1,ip1b,ib1n,ib2n,ndata,nshift,kimg_t,ig1
    integer :: noffset
    integer :: nsize_max_sb_now
    integer :: ierr_diag
    integer :: id_sname = -1, ipri0
! ========================================================================================
    integer :: ib1_, ib2_, ibmax, iadd
! ========================================================================================
    call tstatc0_begin('evolve_WFs_in_subspace_3D (davidson) ', id_sname,1)

    call get_ipri0(ipridavidson,ipri0)

    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if

    if(idavid==1) then
       ip0=neg
       do ib=1,neg
          ibover(ib) = ib
       end do
       nsize_mt_now=0
    else
       noffset = neg*(idavid-1)
       ip0=nsize_sb_now
       do ib=1,neg
          if(.not.feigconv(ib)) then
             ip0=ip0+1
             ibover(noffset+ib) = ip0
          else
             ibover(noffset+ib) = -1
          end if
       end do
    end if
    nsize_sb_now = ip0
    nsize_mt_old = nsize_mt_now
    nsize_mt_now = nsize_sb_now*(nsize_sb_now+1)/2
    nsize_max_sb_now = neg*idavid
    if(ipridavidson >=2) then
       write(nfout,*) 'ibover=',ibover(1:nsize_max_sb_now)
    end if

    allocate(eig(nsize_sb_now)); eig=0.d0
    allocate(vec(nsize_sb_now*kimg_t,nsize_sb_now))
    allocate(eko_d(neg));     eko_d = 0.d0
    allocate(eko_d_mpi(neg))
    allocate(occup(neg)); occup=0
    allocate(occup_mpi(neg))

    if(ipridavidson >=2) then
       write(nfout,*) 'Davidson:ik,idavid,nsize_sb_now=', ik,idavid,nsize_sb_now
    end if


    do ib1 = 1, np_e
       eko_d(neg_g(ib1)) = eko_l(ib1,ik)  ! MPI
    end do
    call mpi_allreduce(eko_d,eko_d_mpi,neg,mpi_double_precision,mpi_sum &
         & ,mpi_kg_world,ierr) ! MPI
    eko_d = eko_d_mpi                         ! MPI
    eko1 = sum(eko_d(1:neg))

    do ib1=1,neg
       if(map_e(ib1) == myrank_e) then !MPI
          if( occup_l(map_z(ib1),ik) > 0.d0 ) occup(ib1) = 1  ! MPI
       end if
    end do
    call mpi_allreduce(occup,occup_mpi,neg,mpi_integer,mpi_sum &
         & ,mpi_k_world(myrank_k),ierr)       ! MPI
    occup = occup_mpi                         ! MPI

! (zaj_l <- (T+Vloc)|phi> )
!( tenchi ) (zat_l <- zaj_l)
!   call m_ES_W_transpose(ista_k,iend_k,ik,zaj_l,zat_l(1,1,1,idavid))
! ==============================================================================
    zat_l(:,:,:,idavid) = 0.0d0
    do ib1 = 1, np_e
       zat_l(:,neg_g(ib1),:,idavid) = zaj_l(:,ib1,ik,:)
    enddo
    call mpi_allreduce(MPI_IN_PLACE,zat_l(:,:,:,idavid),maxval(np_g1k)*neg*kimg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_kg_world,ierr)
! ==============================================================================
    do ib1 = 1, np_e ! MPI
       ib = ib1 ! MPI
START_TIMER('Davidson2_temprary_FFT_2')
#ifdef __TIMER_COMM__
       call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l,0)
#else
       call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l)
#endif
#ifdef FFT_3D_DIVISION
       call m_FFT_Vlocal_W_3DIV_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_x(myrank_g))
       call m_FFT_Direct_3DIV_3D(nfout,wk_bfft_l,lsize,ibsize)
#else
       if (sw_fft_xzy > 0) then
          call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_y(myrank_g))
          call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
       else
          call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
          call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
       end if
#endif
       call map_fft_to_WF_3D(ik,lsize,ibsize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
STOP_TIMER('Davidson2_temprary_FFT_2')
       if(kimg == 1) then
          do ii=ista_g1k(ik),iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             i1  = igf(nbase(ii,ik))
             dr1 = zaj_l(iadd,ib,ik,1)
             dr2 = bfft_l(iadd,1)*denom
             zaj_l(iadd,ib,ik,1)= ekin_l(iadd)*dr1+dr2
          enddo
       else
          do ii=ista_g1k(ik), iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             i1  = igf(nbase(ii,ik))
             dr1  = zaj_l(iadd,ib,ik,1)
             di1  = zaj_l(iadd,ib,ik,kimg)
             zaj_l(iadd,ib,ik,1)= ekin_l(iadd)*dr1+bfft_l(2*iadd-1,1)*denom
             zaj_l(iadd,ib,ik,kimg)= ekin_l(iadd)*di1+bfft_l(2*iadd,1)*denom
          enddo
       endif
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
    enddo
!( tenchi ) (zah_l <- zaj_l)
!   call m_ES_W_transpose(ista_k,iend_k,ik,zaj_l,zah_l(1,1,1,idavid))
! ==============================================================================
    zah_l(:,:,:) = zaj_l(:,:,ik,:)
! ==============================================================================

! (make matrix elements )
! parallel loop
    ! <n|T+Vloc|m> G-wise parallel
! === Need Initialization to Change Decomposition!!! by T.Kato =================
    w1hw2(nsize_mt_old*kimg_t+1:nsize_mt_now*kimg_t) = 0.0d0
    w1sw2(nsize_mt_old*kimg_t+1:nsize_mt_now*kimg_t) = 0.0d0
! ==============================================================================
    do ib2_ = 1, np_e
       ibb2 = neg_g(ib2_) + neg*(idavid - 1)
       if(ibover(ibb2)<0) cycle
       ib2 = ibover(ibb2)
       iter2 = idavid
       ip0b = ib2*(ib2-1)/2
! ==============================================================================
       do iter = 1, idavid
! ==============================================================================
       ibmax = neg
       if(iter == idavid) ibmax = neg_g(ib2_)
       do ib1_ = 1, ibmax
          ibb1 = ib1_ + neg*(iter - 1)
          if(ibover(ibb1)<0) cycle
          ib1 = ibover(ibb1)
          iter1 = iter
          ip0 = ip0b + ib1
          if(kimg == 1) then
             do ii = ista_g1k(ik), iend_g1k(ik) ! MPI
                iadd = ii - ista_g1k(ik) + 1
                hr2 = zah_l(iadd,ib2_,1)
                dr2 = zat_l(iadd,neg_g(ib2_),1,iter2)
                dr1 = zat_l(iadd,ib1_,1,iter1)
                w1hw2(ip0) = w1hw2(ip0) + dr1*hr2
                w1sw2(ip0) = w1sw2(ip0) + dr1*dr2
             end do
          else
             if(k_symmetry(ik) == GAMMA) then
                do ii = max(ista_g1k(ik),2), iend_g1k(ik) ! MPI
                   iadd = ii - ista_g1k(ik) + 1
                   hr2 = zah_l(iadd,ib2_,1) ! MPI
                   hi2 = zah_l(iadd,ib2_,2) ! MPI
                   dr2 = zat_l(iadd,neg_g(ib2_),1,iter2) ! MPI
                   di2 = zat_l(iadd,neg_g(ib2_),2,iter2) ! MPI
                   dr1 = zat_l(iadd,ib1_,1,iter1) ! MPI
                   di1 = zat_l(iadd,ib1_,2,iter1) ! MPI
                   w1hw2(ip0) =w1hw2(ip0)+(dr1*hr2+di1*hi2)*2.d0
                   w1sw2(ip0) =w1sw2(ip0)+(dr1*dr2+di1*di2)*2.d0
                end do
                if(ista_g1k(ik) == 1) then
                   hr2 = zah_l(1,ib2_,1) ! MPI
                   hi2 = zah_l(1,ib2_,2) ! MPI
                   dr2 = zat_l(1,neg_g(ib2_),1,iter2) ! MPI
                   di2 = zat_l(1,neg_g(ib2_),2,iter2) ! MPI
                   dr1 = zat_l(1,ib1_,1,iter1) ! MPI
                   di1 = zat_l(1,ib1_,2,iter1) ! MPI
                   w1hw2(ip0) =w1hw2(ip0)+dr1*hr2+di1*hi2
                   w1sw2(ip0) =w1sw2(ip0)+dr1*dr2+di1*di2
                endif
             else
                do ii = ista_g1k(ik), iend_g1k(ik) ! MPI
                   iadd = ii - ista_g1k(ik) + 1
                   hr2 = zah_l(iadd,ib2_,1) ! MPI
                   hi2 = zah_l(iadd,ib2_,2) ! MPI
                   dr2 = zat_l(iadd,neg_g(ib2_),1,iter2) ! MPI
                   di2 = zat_l(iadd,neg_g(ib2_),2,iter2) ! MPI
                   dr1 = zat_l(iadd,ib1_,1,iter1) ! MPI
                   di1 = zat_l(iadd,ib1_,2,iter1) ! MPI
                   w1hw2(2*ip0-1) =w1hw2(2*ip0-1)+dr1*hr2+di1*hi2
                   w1hw2(2*ip0  ) =w1hw2(2*ip0  )+dr1*hi2-di1*hr2
                   w1sw2(2*ip0-1) =w1sw2(2*ip0-1)+dr1*dr2+di1*di2
                   w1sw2(2*ip0  ) =w1sw2(2*ip0  )+dr1*di2-di1*dr2
                end do
             end if
          end if
       end do
! ==============================================================================
       enddo
! ==============================================================================
    end do

    if(ipridavidson >= 3) call wd_w1hw2(" -- w1hw2 without nl part--")
    ! <n|Vnl|m> G-wise parallel
START_TIMER('Davidson2_add_nonlocal_part')
! === DEBUG by tkato 2011/07/14 ================================================
    if(myrank_g == 0) then
! ==============================================================================
    call add_nonlocal_part ! w1hw2 = w1hw2 + w1Vnlw2
                           ! w1sw2 = w1sw2 + w1qw2
! === DEBUG by tkato 2011/07/14 ================================================
    endif
! ==============================================================================
STOP_TIMER('Davidson2_add_nonlocal_part')
    if(ipridavidson >= 3) call wd_w1hw2(" -- w1hw2 with nl part--")

!! (spread sum of w1hw2 and w1sw2)
    if(npes > 1) then
       allocate(w1_mpi(nsize_matrix*kimg_t))
       nshift = nsize_mt_old*kimg_t
       ndata = (nsize_mt_now-nsize_mt_old)*kimg_t
       w1_mpi = 0.0d0
       call mpi_allreduce(w1hw2(nshift+1),w1_mpi,ndata,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       w1hw2(nshift+1:nshift+ndata) = w1_mpi(1:ndata) ! MPI
       call mpi_allreduce(w1sw2(nshift+1),w1_mpi,ndata,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       w1sw2(nshift+1:nshift+ndata) = w1_mpi(1:ndata) ! MPI
       deallocate(w1_mpi)
    end if

    if(ipridavidson >= 2) call wd_w1hw2(" -- just after making w1hw2 --")
    if(ipridavidson >= 2) then
       write(nfout,*) 'neordr for ik = ',ik
       write(nfout,9002) (neordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'nrvf_ordr for ik = ',ik
       write(nfout,9002) (nrvf_ordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'eig'
       write(nfout,'(5x,10f8.4)') (eko_l(ib1,ik),ib1=1,np_e)
    endif
9002 format(5x,10i8)

!! (Diagonalization )  !!

#ifdef _USE_LAPACK_
#ifdef _USE_SCALAPACK_
    if(sw_dav_scalapack == ON) then
       call initialize_scalapack()
       if(kimg_t == 1) then
START_TIMER('Davidson_pdsygvx')
          call pdsygvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
STOP_TIMER('Davidson_pdsygvx')
       else
START_TIMER('Davidson_pzhegvx')
          call pzhegvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
STOP_TIMER('pzhegvx_zhpgvx')
       endif
! === DEBUG by tkato 2012/12/20 ================================================
!      call finalize_scalapack()
! ==============================================================================
    else
       if(kimg_t == 1) then
START_TIMER('Davidson_dspgvx')
          call dspgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
STOP_TIMER('Davidson_dspgvx')
       else
START_TIMER('Davidson_zhpgvx')
          call zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
STOP_TIMER('Davidson_zhpgvx')
       endif
    endif
#else
    if(kimg_t == 1) then
START_TIMER('Davidson_dspgvx')
       call dspgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
STOP_TIMER('Davidson_dspgvx')
    else
START_TIMER('Davidson_zhpgvx')
       call zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
STOP_TIMER('Davidson_zhpgvx')
    endif
#endif
#else
    call phase_error_with_msg(nfout,'Complie me with -D_USE_LAPACK_ to use the Davidoson solver',__LINE__,__FILE__)
    !!if(kimg_t == 1) then
    !!   call hobsvw_driver(neg,eig,w1hw2)
    !!else
    !!   call chobsd_driver(neg,eig,w1hw2)
    !!end if
#endif

    frestart = .false.
    if(ierr_diag /= 0) then
       zaj_l(:,:,ik,:) = zaj_l_backup(:,:,:)
       do ib1 = 1, np_e
          eko_l(ib1,ik)=eko_d(neg_g(ib1))
       end do
       frestart = .true.
       if(ipridavidson >= 2) then
          write(nfout,*) '** restart Davidson iteration **'
       end if
    else

       feigconv = .false.
       do ib=1,neg
          if(occup(ib) == 1) then
             if(abs(eko_d(ib)-eig(ib)) < delta_eig_occup) feigconv(ib) = .true.
          else
             if(abs(eko_d(ib)-eig(ib)) < delta_eig_empty) feigconv(ib) = .true.
          end if
       end do

       if(ipridavidson >= 2) then
          write(nfout,*) 'eko_d for ik = ',ik
          write(nfout,9001) (eko_d(ib),ib=1,neg)
          write(nfout,*) 'eig for ik = ',ik
          write(nfout,9001) (eig(ib),ib=1,neg)
          call wd_w1hw2(" -- after diagonalization --")
!sum eko
          dr1=0.d0;dr2=0.d0
          do ib1=1,np_e
             ib1to = neordr(neg_g(ib1),ik)
             if(map_e(ib1to) == myrank_e) dr1=dr1+eko_l(ib1,ik) ! MPI
             dr2=dr2+eig(neg_g(ib1))
          enddo
          call mpi_allreduce(dr1,di1,1,mpi_double_precision,mpi_sum,mpi_kg_world,ierr) ! MPI
          dr1 = di1  ! MPI
          write(nfout,'(" sum of eko_l, eig, abs diff =",3e25.10)') dr1,dr2,abs(dr2-dr1)
       endif
!! (subspace rotation) !!
START_TIMER('Davidson2_subspace_rotation')
       call subspace_rotation ! vec,zat_l -> zat_l
STOP_TIMER('Davidson2_subspace_rotation')
!( tenchi ) (zaj_l <- zat_l)
       iter = min(idavid+1,ndavid)
!      call m_ES_W_transpose_back(ista_k,iend_k,ik,zaj_l,zat_l(1,1,1,iter))
! ==============================================================================
       do ib1 = 1, np_e
          zaj_l(:,ib1,ik,:) = zat_l(:,neg_g(ib1),:,iter)
       enddo
! ==============================================================================
       zaj_l_backup(:,:,:) = zaj_l(:,:,ik,:)
!! (eko_l)
       do ib1 = 1, np_e
          eko_l(ib1,ik)=eig(neg_g(ib1))
       end do
       if(ipridavidson >= 2) then
          eko2 = sum(eig(1:neg))
          write(nfout,1201) ik,eko1,ekod,eko2

          write(nfout,*) 'eko_l'
          write(nfout,9001) (eko_l(ib1,ik),ib1=1,np_e)
       endif
1201 format(' %% for ik = ',i4,4x,' eko1&ekod&eko2 = ',3f14.7)
9001 format(5x,6f12.5)
!! (neordr & nrvf_ordr)

    end if

    neordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
    nrvf_ordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)

! (deallocate)
    deallocate(eko_d)
    deallocate(eko_d_mpi)
    deallocate(eig)
    deallocate(vec)
    deallocate(occup)
    deallocate(occup_mpi)

    call tstatc0_end(id_sname)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine wd_w1hw2(somecomment)
      character(len=*), intent(in) :: somecomment
      integer :: ib1, ib2, neg_wd, nsb_wd
      write(nfout,'(a35)') somecomment
      write(nfout,*) 'w1hw2 for ik = ',ik
      neg_wd = 8
      nsb_wd = 8
      if(neg_wd > neg) neg_wd = neg
      if(nsb_wd > nsize_sb_now) nsb_wd = nsize_sb_now
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
      write(nfout,*) 'w1sw2 for ik = ',ik
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
9001  format(5x,9f12.5)
      write(nfout,*) 'eko_l for ik = ',ik
      write(nfout,9001) (eko_d(neordr(ib1,ik)),ib1=1,neg_wd)
    end subroutine wd_w1hw2

    subroutine add_nonlocal_part
      integer :: ip,ib1,ib2,ibb1,ibb2
      integer       :: ia, lmt1, lmt2, it, p, s, ib
      real(kind=DP) :: facv,facq,vr,vi,qr,qi
      real(kind=DP) :: tmpr,tmpi
      do ibb2 = nsize_max_sb_now-neg+1,nsize_max_sb_now
         if(ibover(ibb2)<0) cycle
         ib2 = ibover(ibb2)
         iter2= (ibb2-1)/neg+1
         ii2  = ibb2-neg*(iter2-1)
         ip0b = ib2*(ib2-1)/2
         do ibb1 = 1,ibb2
            if(ibover(ibb1)<0) cycle
            ib1 = ibover(ibb1)
            iter1=(ibb1-1)/neg+1
            ii1  = ibb1-neg*(iter1-1)
            ip0 = ip0b + ib1
            if(mod(ip0-1,nrank_e)/=myrank_e) cycle
            if(kimg_t==1) then
               vr=0.d0
               qr=0.d0
            else
               vr=0.d0
               vi=0.d0
               qr=0.d0
               qi=0.d0
            end if
            do ia = 1, natm
               it = ityp(ia)
               do lmt1 = 1, ilmt(it)
                  p = lmta(lmt1,ia)
                  do lmt2 = 1, ilmt(it)
                     s = lmta(lmt2,ia)
!!$                     facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     if(ipaw(it)==0)then
                        facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     else
                        facv   = iwei(ia)*(dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     endif
                     facq   = iwei(ia)*q(lmt1,lmt2,it)
                     if(kimg==1) then
                        tmpr = fsr(ii1,p,iter1)*fsr(ii2,s,iter2)&
                    &        + fsi(ii1,p,iter1)*fsi(ii2,s,iter2)
                        vr = vr + facv*tmpr
                        qr = qr + facq*tmpr
                     else
                        if(k_symmetry(ik) == GAMMA) then
                           tmpr = fsr(ii1,p,iter1)*fsr(ii2,s,iter2)
                           vr = vr + facv*tmpr
                           qr = qr + facq*tmpr
                        else
                           tmpr = fsr(ii1,p,iter1)*fsr(ii2,s,iter2)&
                    &        + fsi(ii1,p,iter1)*fsi(ii2,s,iter2)
                           tmpi = fsr(ii1,p,iter1)*fsi(ii2,s,iter2)&
                    &        - fsi(ii1,p,iter1)*fsr(ii2,s,iter2)
                           vr = vr + facv*tmpr
                           vi = vi + facv*tmpi
                           qr = qr + facq*tmpr
                           qi = qi + facq*tmpi
                        end if
                     end if
                  end do
               end do
            end do
            if(kimg_t==1) then
               w1hw2(ip0) = w1hw2(ip0) + vr
               w1sw2(ip0) = w1sw2(ip0) + qr
            else
               w1hw2(2*ip0-1) = w1hw2(2*ip0-1) + vr
               w1hw2(2*ip0  ) = w1hw2(2*ip0  ) + vi
               w1sw2(2*ip0-1) = w1sw2(2*ip0-1) + qr
               w1sw2(2*ip0  ) = w1sw2(2*ip0  ) + qi
            end if
         end do
      end do
    end subroutine add_nonlocal_part

    subroutine subspace_rotation
      integer :: ib1,ib2,ibb2,iadd
      real(kind=DP), dimension(maxval(np_g1k),np_e,kimg) :: zaj_wk

      zaj_wk(:,:,:) = 0.d0
      if(kimg==1) then
         do ib1=1,np_e
! ==============================================================================
            do iter = 1, idavid
! ==============================================================================
            do ib2_=1,neg
               ibb2 = ib2_ + neg*(iter - 1)
               if(ibover(ibb2)<0) cycle
               ib2 = ibover(ibb2)
               do ii=ista_g1k(ik),iend_g1k(ik)
                  iadd = ii - ista_g1k(ik) + 1
                  zaj_wk(iadd,ib1,kimg) = zaj_wk(iadd,ib1,kimg) + zat_l(iadd,ib2_,kimg,iter)*vec(ib2,neg_g(ib1))
               end do
            end do
! ==============================================================================
            end do
! ==============================================================================
         end do
      else
         if(k_symmetry(ik) == GAMMA) then
            do ib1=1,np_e
! ==============================================================================
               do iter = 1, idavid
! ==============================================================================
               do ib2_=1,neg
                  ibb2 = ib2_ + neg*(iter - 1)
                  if(ibover(ibb2)<0) cycle
                  ib2 = ibover(ibb2)
                  hr2=vec(ib2,neg_g(ib1))
                  do ii=ista_g1k(ik),iend_g1k(ik)
                     iadd = ii - ista_g1k(ik) + 1
                     dr1=zat_l(iadd,ib2_,1   ,iter)
                     di1=zat_l(iadd,ib2_,kimg,iter)
                     zaj_wk(iadd,ib1,1   ) = zaj_wk(iadd,ib1,1   ) + dr1*hr2
                     zaj_wk(iadd,ib1,kimg) = zaj_wk(iadd,ib1,kimg) + di1*hr2
                  end do
               end do
! ==============================================================================
               end do
! ==============================================================================
            end do
         else
            do ib1=1,np_e
! ==============================================================================
            do iter = 1, idavid
! ==============================================================================
               do ib2_=1,neg
                  ibb2 = ib2_ +  neg*(iter - 1)
                  if(ibover(ibb2)<0) cycle
                  ib2 = ibover(ibb2)
                  hr2=vec(2*ib2-1,neg_g(ib1))
                  hi2=vec(2*ib2  ,neg_g(ib1))
                  do ii=ista_g1k(ik),iend_g1k(ik)
                     iadd = ii - ista_g1k(ik) + 1
                     dr1=zat_l(iadd,ib2_,1   ,iter)
                     di1=zat_l(iadd,ib2_,kimg,iter)
                     zaj_wk(iadd,ib1,1   ) = zaj_wk(iadd,ib1,1   ) + dr1*hr2 - di1*hi2
                     zaj_wk(iadd,ib1,kimg) = zaj_wk(iadd,ib1,kimg) + dr1*hi2 + di1*hr2
                  end do
               end do
! ==============================================================================
               end do
! ==============================================================================
            end do
         end if
      end if
      iter = min(idavid+1,ndavid)
!     zat_l(:,:,:,iter) = zaj_wk(:,:,:)
! ==============================================================================
      zat_l(:,:,:,iter) = 0.0d0
      do ib1 = 1, np_e
         zat_l(:,neg_g(ib1),:,iter) = zaj_wk(:,ib1,:)
      enddo
      call mpi_allreduce(MPI_IN_PLACE,zat_l(:,:,:,iter),maxval(np_g1k)*neg*kimg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_kg_world,ierr)
! ==============================================================================
    end subroutine subspace_rotation

  end subroutine evolve_WFs_in_subspace_3D

  subroutine vlhxc_l_zero_term(vlhxc0,ispin)
    real(kind=DP), intent(out) :: vlhxc0
    integer, intent(in)        :: ispin

    if(mype == 0) vlhxc0 = vlhxc_l(1,1,ispin)
    call mpi_bcast(vlhxc0,1,mpi_double_precision,0,MPI_CommGroup,ierr)
  end subroutine vlhxc_l_zero_term

! ===================================== added by K. Tagami ============== 11.0
  subroutine vlhxc_l_zero_term_noncl( vlhxc0 )
    real(kind=DP), intent(out) :: vlhxc0(ndim_chgpot)

    vlhxc0 = 0.0d0
    if (mype == 0) then
!	vlhxc0(1)           = vlhxc_l(1,1,1) + vlhxc_l(1,1,ndim_magmom)
!	vlhxc0(ndim_chgpot) = vlhxc_l(1,1,1) - vlhxc_l(1,1,ndim_magmom)
!
       vlhxc0 = vlhxc_l(1,1,1)
    endif

    call mpi_bcast( vlhxc0, ndim_chgpot, mpi_double_precision,0,MPI_CommGroup,ierr)

  end subroutine vlhxc_l_zero_term_noncl
! ========================================================================= 11.0

  subroutine Vnonlocal_Diagonal_part_3D(ispin,ik,iksnl,vnldi_l)
    integer, intent(in)                        :: ispin, ik, iksnl
    real(kind=DP), intent(out), dimension(maxval(np_g1k)) :: vnldi_l

    integer :: it,mdvdb

    vnldi_l = 0.d0
    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) then
          call Vnonlocal_D_norm_conserve_case
       else if(mdvdb == EXECUT) then
          call Vnonlocal_D_vanderbilt_case
       end if
    end do
  contains
    subroutine Vnonlocal_D_vanderbilt_case
      integer       :: ia, p1,p2,lmtt1,il1,lmtt2,il2,i,iadd
      real(kind=DP) :: ph,fac

      do p1 = 1, ilmt(it)
         lmtt1 = lmtt(p1,it); il1 = ltp(p1,it)
         do p2 = p1, ilmt(it)
            lmtt2 = lmtt(p2,it); il2 = ltp(p2,it)
            if( p1 /= p2) then
               ph = 2.d0*real(zi**(il2-il1))
            else
               ph = 1.d0
            endif
            if(mod(il1+il2,2) == 1) cycle
            do ia = 1, natm
               if(ityp(ia) /= it) cycle
               if(ipaw(it)==0) then
                  fac = ph*iwei(ia) * (dion(p1,p2,it)+vlhxcQ(p1,p2,ia,ispin))
               else
                  fac = ph*iwei(ia) * (dion_paw(p1,p2,ispin,ia)+vlhxcQ(p1,p2,ia,ispin))
               endif
               do i = ista_g1k(ik), iend_g1k(ik)
                  iadd = i - ista_g1k(ik) + 1
                  vnldi_l(iadd) = vnldi_l(iadd)+fac*snl(iadd,lmtt1,iksnl)*snl(iadd,lmtt2,iksnl)
               end do
            end do
         end do
      end do
    end subroutine Vnonlocal_D_vanderbilt_case

    subroutine Vnonlocal_D_norm_conserve_case
      integer       :: ia, lmt1,lmt2,lmtt1,il1,im1,il2,im2,i,iadd
      real(kind=DP) :: ph,fac

      ph = 0.d0
      do ia = 1, natm
         if(ityp(ia) /= it) cycle
         ph = ph + iwei(ia)
      end do
      do lmt1 = 1, ilmt(it)
         lmtt1 = lmtt(lmt1,it); il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
         do lmt2 = lmt1, ilmt(it)
            il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
            if(il1 /= il2 .or. im1 /= im2) cycle
            if(mod(il1+il2,2) == 1) cycle
            if(ipaw(it)==0)then
               fac = ph * dion(lmt1,lmt2,it)
            else
               fac = ph * dion_paw(lmt1,lmt2,ispin,ia)
            endif
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               vnldi_l(iadd)  = vnldi_l(iadd) + fac * snl(iadd,lmtt1,iksnl)*snl(iadd,lmtt1,iksnl)
            end do
         end do
      end do
    end subroutine Vnonlocal_D_norm_conserve_case
  end subroutine Vnonlocal_Diagonal_part_3D

  subroutine S_Diagonal_part_3D(ik,iksnl,sdiag_l)
    integer, intent(in)                        :: ik, iksnl
    real(kind=DP), intent(out), dimension(maxval(np_g1k)) :: sdiag_l

    integer :: it,mdvdb

    sdiag_l = 1.d0
    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb /= SKIP) call Vanderbilt_case
    end do
  contains
    subroutine Vanderbilt_case
      integer       :: ia, p1,p2,lmtt1,il1,lmtt2,il2,i,iadd
      real(kind=DP) :: ph,fac

      do p1 = 1, ilmt(it)
         lmtt1 = lmtt(p1,it); il1 = ltp(p1,it)
         do p2 = p1, ilmt(it)
            lmtt2 = lmtt(p2,it); il2 = ltp(p2,it)
            if( p1 /= p2) then
               ph = 2.d0*real(zi**(il2-il1))
            else
               ph = 1.d0
            endif
            if(mod(il1+il2,2) == 1) cycle
            do ia = 1, natm
               if(ityp(ia) /= it) cycle
               fac = ph*iwei(ia) * q(p1,p2,it)
               do i = ista_g1k(ik), iend_g1k(ik)
                  iadd = i - ista_g1k(ik) + 1
                  sdiag_l(iadd) = sdiag_l(iadd)+fac*snl(iadd,lmtt1,iksnl)*snl(iadd,lmtt2,iksnl)
               end do
            end do
         end do
      end do
    end subroutine Vanderbilt_case
  end subroutine S_Diagonal_part_3D

  subroutine dspgvx_driver(eig,vec,w1hw2,w1sw2,ierr)
    real(kind=DP), intent(out) ,dimension(nsize_sb_now) :: eig
    real(kind=DP), intent(out) ,dimension(nsize_sb_now*neg) :: vec
    real(kind=DP), intent(inout) ,dimension(nsize_mt_now) :: w1hw2,w1sw2
    integer, intent(out) :: ierr
    integer :: ITYPE
    character(len=1) :: JOBZ,RANGE,UPLO
    integer :: il,iu
    real(kind=DP),allocatable,dimension(:) :: work_lapack
    integer, allocatable, dimension(:) :: iwork_lapack, ifail_lapack
    real(kind=DP) :: vl,vu,abstol
    integer :: info,m
    real(kind=DP), external :: dlamch
!!$    real(kind=DP), dimension(nsize_mt_now) :: ap,bp
    real(kind=DP), allocatable, dimension(:) :: ap,bp

    allocate(ap(nsize_mt_now),bp(nsize_mt_now))
    abstol = 2*dlamch('S')

    il=1; iu=neg
!(LAPACK)  ITYPE = 1:  A*x = (lambda)*B*x, 2:  A*B*x = (lambda)*x, 3:  B*A*x = (lambda)*x
    ITYPE = 1
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  RANGE = A : all eigenvalues, V: all eigenvalues in (VL, VU], I: the IL-th through IU-th eigenvalues
    RANGE = 'I'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
    allocate(work_lapack(8*nsize_sb_now))
    allocate(iwork_lapack(5*nsize_sb_now))
    allocate(ifail_lapack(nsize_sb_now))

    ap = w1hw2
    bp = w1sw2

    call dspgvx(ITYPE,JOBZ,RANGE,UPLO,nsize_sb_now,ap,bp &
    &          ,vl,vu,il,iu,abstol,m,eig,vec,nsize_sb_now &
    &          ,work_lapack,iwork_lapack,ifail_lapack,info)

    if(ipridavidson >=2 .and. info/=0) then
       write(nfout,*) "debug(dspgvx) info=",info
       write(nfout,*) "debug(dspgvx) ifail"
       write(nfout,'(8(1x,i3))') ifail_lapack
       write(nfout,*) "debug(dspgvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(work_lapack)
    deallocate(iwork_lapack)
    deallocate(ifail_lapack)

    deallocate(ap,bp)

    if(info/=0) then
       !!write(nfout,*) "dspgvx: info=",info
       !!stop 'error in dspgvx_driver'
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine dspgvx_driver

#ifdef _USE_SCALAPACK_
  subroutine pdsygvx_driver(eig, vec, w1hw2, w1sw2, ierr)
    real(kind=DP), intent(out),  dimension(nsize_sb_now)      :: eig
    real(kind=DP), intent(out),  dimension(nsize_sb_now, neg) :: vec
    real(kind=DP), intent(inout),dimension(nsize_mt_now)      :: w1hw2, w1sw2
    integer, intent(out) :: ierr
    integer :: itype
    integer :: il,iu
    integer, allocatable, dimension(:) :: ifail
    real(kind=DP) :: vl, vu, abstol
    integer :: info, m
    real(kind=DP), external :: dlamch
! ==============================================================================
    real(kind=DP), allocatable, dimension(:,:) :: ap, bp, z
    integer :: nz, count
    real(kind=DP) :: orfac = -1.0d0
    real(kind=DP), allocatable, dimension(:) :: work, gap
    integer,       allocatable, dimension(:) :: iwork, iclustr
    integer :: i, j
! ==============================================================================

    abstol = 2*dlamch('S')
    il=1; iu=neg
    itype = 1

    allocate(ap(nrowa,ncola))
    allocate(bp(nrowa,ncola))
    allocate(z (nrowa,ncola))

    count = 1
    do j = 1, nsize_sb_now
      do i = 1, nsize_sb_now
        if(i .le. j) then
          call pdelset(ap,i,j,desca,w1hw2(count))
          call pdelset(bp,i,j,desca,w1sw2(count))
          count = count + 1
        endif
      enddo
    enddo

    allocate(work   (lwork1))
    allocate(iwork  (liwork1))
    allocate(ifail  (nsize_sb_now))
    allocate(iclustr(2*nprow*npcol))
    allocate(gap    (nprow*npcol))

    call pdsygvx(itype,'V','I','U',nsize_sb_now, &
                 ap,1,1,desca, &
                 bp,1,1,desca, &
                 vl,vu,il,iu,abstol,m,nz,eig,orfac, &
                 z,1,1,desca,&
                 work,lwork1,iwork,liwork1, &
                 ifail,iclustr,gap,info)

    do j = 1, neg
      do i = 1, nsize_sb_now
        call pdelget('A',' ',vec(i,j),z,i,j,desca)
      enddo
    enddo

    if(ipridavidson >=2 .and. info/=0) then
       write(nfout,*) "debug(dspgvx) info=",info
       write(nfout,*) "debug(dspgvx) ifail"
       write(nfout,'(8(1x,i3))') ifail
       write(nfout,*) "debug(dspgvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(ap)
    deallocate(bp)
    deallocate(z)
    deallocate(work)
    deallocate(iwork)
    deallocate(iclustr)
    deallocate(gap)
    deallocate(ifail)

    if(info/=0) then
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine pdsygvx_driver
#endif

  subroutine zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr)
    real(kind=DP), intent(out) ,dimension(nsize_sb_now) :: eig
    real(kind=DP), intent(out) ,dimension(nsize_sb_now*kimg,nsize_sb_now) :: vec
    real(kind=DP), intent(in) ,dimension(nsize_mt_now*kimg) :: w1hw2,w1sw2
    integer, intent(out) :: ierr
    integer :: ITYPE
    character(len=1) :: JOBZ,RANGE,UPLO
    integer :: il,iu
    real(kind=DP),allocatable,dimension(:) :: work_lapack
    real(kind=DP),allocatable,dimension(:) :: rwork_lapack
    integer, allocatable, dimension(:) :: iwork_lapack, ifail_lapack
    real(kind=DP) :: vl,vu,abstol
    integer :: info,m
    real(kind=DP), external :: dlamch
!!$    real(kind=DP), dimension(nsize_mt_now*kimg) :: ap,bp
    real(kind=DP), allocatable, dimension(:) :: ap,bp
    integer :: ib,i

    abstol = 2*dlamch('S')

    il=1; iu=neg
!(LAPACK)  ITYPE = 1:  A*x = (lambda)*B*x, 2:  A*B*x = (lambda)*x, 3:  B*A*x = (lambda)*x
    ITYPE = 1
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  RANGE = A : all eigenvalues, V: all eigenvalues in (VL, VU], I: the IL-th through IU-th eigenvalues
    RANGE = 'I'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
    allocate(work_lapack(2*nsize_sb_now*kimg)); work_lapack = 0.d0
    allocate(rwork_lapack(7*nsize_sb_now)); rwork_lapack = 0.d0
    allocate(iwork_lapack(5*nsize_sb_now)); iwork_lapack = 0
    allocate(ifail_lapack(nsize_sb_now)); ifail_lapack=0
    allocate(ap(nsize_mt_now*kimg));ap=0.d0
    allocate(bp(nsize_mt_now*kimg));bp=0.d0

    if(ipridavidson >=3 ) then
       write(nfout,*) "debug(zhpgvx) i,w1hw2,w1sw2"
       do ib=1,nsize_sb_now
          i = ib*(ib-1)/2 + ib
          write(nfout,*) ib,w1hw2(2*i-1),w1sw2(2*i-1)
       end do
       ap = w1sw2
       write(nfout,*) "debug(zhpgvx) i,ap,w1sw2"
       do i=1,nsize_mt_now
          write(nfout,*) i,ap(2*i-1),w1sw2(2*i-1)
       end do
       call zhpevx('N','A','U',nsize_sb_now,ap,vl,vu,il,iu,abstol,m &
    &          ,eig,vec,nsize_sb_now &
    &          ,work_lapack,rwork_lapack,iwork_lapack,ifail_lapack,info)
       write(nfout,*) "debug(zhpgvx) eig of w1sw2"
       do ib=1,nsize_sb_now
          write(nfout,*) ib,eig(ib)
       end do
    end if

    ap = w1hw2
    bp = w1sw2

    call zhpgvx(ITYPE,JOBZ,RANGE,UPLO,nsize_sb_now,ap,bp &
    &          ,vl,vu,il,iu,abstol,m,eig,vec,nsize_sb_now &
    &          ,work_lapack,rwork_lapack,iwork_lapack,ifail_lapack,info)

    if(ipridavidson >=2 .and. info/=0) then
       write(nfout,*) "debug(zhpgvx) info=",info
       write(nfout,*) "debug(zhpgvx) ifail"
       write(nfout,'(8(1x,i3))') ifail_lapack
       write(nfout,*) "debug(zhpgvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(work_lapack)
    deallocate(rwork_lapack)
    deallocate(iwork_lapack)
    deallocate(ifail_lapack)
    deallocate(ap,bp)

    if(info/=0) then
       !!write(nfout,*) "zhpgvx: info=",info
       !!stop 'error in zhpgvx_driver'
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine zhpgvx_driver

#ifdef _USE_SCALAPACK_
  subroutine pzhegvx_driver(eig, vec, w1hw2, w1sw2, ierr)
    real(kind=DP), intent(out),  dimension(nsize_sb_now)           :: eig
    real(kind=DP), intent(out),  dimension(nsize_sb_now*kimg, neg) :: vec
    real(kind=DP), intent(inout),dimension(nsize_mt_now*kimg)      :: w1hw2, w1sw2
    integer, intent(out) :: ierr
    integer :: itype
    integer :: il,iu
    integer, allocatable, dimension(:) :: ifail
    real(kind=DP) :: vl, vu, abstol
    integer :: info, m
    real(kind=DP), external :: dlamch
! ==============================================================================
!!$    complex(kind=16), allocatable, dimension(:,:) :: ap, bp, z
    complex(kind=CMPLDP), allocatable, dimension(:,:) :: ap, bp, z
    integer :: nz, count
    real(kind=DP) :: orfac = -1.0d0
!!$    complex(kind=16), allocatable, dimension(:) :: work, rwork
    complex(kind=CMPLDP), allocatable, dimension(:) :: work, rwork
    integer,          allocatable, dimension(:) :: iwork, iclustr
    real(kind=DP),    allocatable, dimension(:) :: gap
    integer :: i, j
! ==============================================================================

    abstol = 2*dlamch('S')
    il=1; iu=neg
    itype = 1

    allocate(ap(nrowa,ncola))
    allocate(bp(nrowa,ncola))
    allocate(z (nrowa,ncola))

    count = 1
    do j = 1, nsize_sb_now
      do i = 1, nsize_sb_now
        if(i .le. j) then
          call pzelset(ap,i,j,desca,w1hw2(count))
          call pzelset(bp,i,j,desca,w1sw2(count))
          count = count + 2
        endif
      enddo
    enddo

    allocate(work   (lwork2))
    allocate(rwork   (lrwork2))
    allocate(iwork  (liwork2))
    allocate(ifail  (nsize_sb_now))
    allocate(iclustr(2*nprow*npcol))
    allocate(gap    (nprow*npcol))

    call pzhegvx(itype,'V','I','U',nsize_sb_now, &
                 ap,1,1,desca, &
                 bp,1,1,desca, &
                 vl,vu,il,iu,abstol,m,nz,eig,orfac, &
                 z,1,1,desca,&
                 work,lwork2,rwork,lrwork2,iwork,liwork2, &
                 ifail,iclustr,gap,info)

    do j = 1, neg
      do i = 1, nsize_sb_now
        call pzelget('A',' ',vec(2*i-1,j),z,i,j,desca)
      enddo
    enddo

    if(ipridavidson >=2 .and. info/=0) then
       write(nfout,*) "debug(dspgvx) info=",info
       write(nfout,*) "debug(dspgvx) ifail"
       write(nfout,'(8(1x,i3))') ifail
       write(nfout,*) "debug(dspgvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(ap)
    deallocate(bp)
    deallocate(z)
    deallocate(work)
    deallocate(rwork)
    deallocate(iwork)
    deallocate(iclustr)
    deallocate(gap)
    deallocate(ifail)

    if(info/=0) then
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine pzhegvx_driver

! === DEBUG by tkato 2012/12/20 ================================================
  subroutine create_scalapack_context()
    integer :: myrank, nprocs
    integer, allocatable :: usermap(:,:)
    integer :: i, j

    call blacs_setup(myrank, nprocs)

    nprow = dav_nprow
    npcol = dav_npcol
    if(dav_divide_square > 0) then
       if(nprow == 0 .or. npcol == 0) then
          nprow = int(sqrt(real(nrank_e*nrank_g)))
          npcol = nprow
       end if
    else
       if(nprow == 0 .or. npcol == 0) then
          nprow = nrank_g
          npcol = nrank_e
       end if
    end if
    if(nprow*npcol /= nrank_g*nrank_e) then
       nprow = nrank_g
       npcol = nrank_e
    end if

    write(nfout, '("set nprow, npcol = ", 4i5)') nprow, npcol

    allocate(usermap(nprow,npcol))
    do j = 1, npcol
       do i = 1, nprow
          usermap(i,j) = myrank_k*nrank_e*nrank_g + (i - 1)*npcol + j - 1
       end do
    end do

    call blacs_get(-1, 0, ctxt)
    call blacs_gridmap(ctxt, usermap, nprow, nprow, npcol)
    call blacs_gridinfo(ctxt, nprow, npcol, myprow, mypcol)

    deallocate(usermap)
  end subroutine create_scalapack_context

  subroutine initialize_scalapack()
    integer :: nb, nb_max
    integer, external :: numroc, iceil ! External Functions
    integer :: nn, np0, mq0, nq0
    integer :: info

    nb = dav_block_size
    nb_max = min((nsize_sb_now - 1)/nprow + 1, (nsize_sb_now - 1)/npcol + 1)
    if(nb > nb_max) nb = nb_max

    write(nfout, '("set nb_max, nb = ", 4i5)') nb_max, nb

    nrowa = numroc(nsize_sb_now,nb,myprow,0,nprow) ! number of row    elements per proc
    ncola = numroc(nsize_sb_now,nb,mypcol,0,npcol) ! number of column elements per proc
    call descinit(desca,nsize_sb_now,nsize_sb_now,nb,nb,0,0,ctxt,nrowa,info)

    ! For pdsygvx
    nn      = max(max(nsize_sb_now,nb),2)
    np0     = numroc(nn,nb,0,0,nprow)
    mq0     = numroc(max(max(neg,nb),2),nb,0,0,npcol)
    lwork1  = 5*nsize_sb_now + max(5*nn,np0*mq0+2*nb*nb) &
            + iceil(neg,nprow*npcol)*nn + (neg-1)*nsize_sb_now
    liwork1 = 6*max(max(nsize_sb_now,nprow*npcol+1),4)

    ! For pzhegvx
    np0     = numroc(nsize_sb_now,nb,0,0,nprow)
    nq0     = numroc(nsize_sb_now,nb,0,0,npcol)
    lwork2  = nsize_sb_now + (np0+nq0+nb)*nb
    nn      = max(max(nsize_sb_now,nb),2)
    np0     = numroc(nn,nb,0,0,nprow)
    mq0     = numroc(max(max(neg,nb),2),nb,0,0,npcol)
    lrwork2 = 4*nsize_sb_now + max(5*nn,np0*mq0+2*nb*nb) &
            + iceil(neg,nprow*npcol)*nn + (neg-1)*nsize_sb_now
    liwork2 = 6*max(max(nsize_sb_now,nprow*npcol+1),4)
  end subroutine initialize_scalapack

  subroutine destroy_scalapack_context()
     call blacs_gridexit(ctxt)
  end subroutine destroy_scalapack_context
! ==============================================================================

#endif
#endif
end module m_ES_WF_by_Davidson

      SUBROUTINE DLAED9( K, KSTART, KSTOP, N, D, Q, LDQ, RHO, DLAMDA, W,
     $                   S, LDS, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Oak Ridge National Lab, Argonne National Lab,
*     Courant Institute, NAG Ltd., and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, KSTART, KSTOP, LDQ, LDS, N
      DOUBLE PRECISION   RHO
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( * ), DLAMDA( * ), Q( LDQ, * ), S( LDS, * ),
     $                   W( * )
*     ..
*
*  Purpose
*  =======
*
*  DLAED9 finds the roots of the secular equation, as defined by the
*  values in D, Z, and RHO, between KSTART and KSTOP.  It makes the
*  appropriate calls to DLAED4 and then stores the new matrix of
*  eigenvectors for use in calculating the next level of Z vectors.
*
*  Arguments
*  =========
*
*  K       (input) INTEGER
*          The number of terms in the rational function to be solved by
*          DLAED4.  K >= 0.
*
*  KSTART  (input) INTEGER
*  KSTOP   (input) INTEGER
*          The updated eigenvalues Lambda(I), KSTART <= I <= KSTOP
*          are to be computed.  1 <= KSTART <= KSTOP <= K.
*
*  N       (input) INTEGER
*          The number of rows and columns in the Q matrix.
*          N >= K (delation may result in N > K).
*
*  D       (output) DOUBLE PRECISION array, dimension (N)
*          D(I) contains the updated eigenvalues
*          for KSTART <= I <= KSTOP.
*
*  Q       (workspace) DOUBLE PRECISION array, dimension (LDQ,N)
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q.  LDQ >= max( 1, N ).
*
*  RHO     (input) DOUBLE PRECISION
*          The value of the parameter in the rank one update equation.
*          RHO >= 0 required.
*
*  DLAMDA  (input) DOUBLE PRECISION array, dimension (K)
*          The first K elements of this array contain the old roots
*          of the deflated updating problem.  These are the poles
*          of the secular equation.
*
*  W       (input) DOUBLE PRECISION array, dimension (K)
*          The first K elements of this array contain the components
*          of the deflation-adjusted updating vector.
*
*  S       (output) DOUBLE PRECISION array, dimension (LDS, K)
*          Will contain the eigenvectors of the repaired matrix which
*          will be stored for subsequent Z vector calculation and
*          multiplied by the previously accumulated eigenvectors
*          to update the system.
*
*  LDS     (input) INTEGER
*          The leading dimension of S.  LDS >= max( 1, K ).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if INFO = 1, an eigenvalue did not converge
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Jeff Rutter, Computer Science Division, University of California
*     at Berkeley, USA
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, J
      DOUBLE PRECISION   TEMP
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMC3, DNRM2
      EXTERNAL           DLAMC3, DNRM2
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DLAED4, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, SIGN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( K.LT.0 ) THEN
         INFO = -1
      ELSE IF( KSTART.LT.1 .OR. KSTART.GT.MAX( 1, K ) ) THEN
         INFO = -2
      ELSE IF( MAX( 1, KSTOP ).LT.KSTART .OR. KSTOP.GT.MAX( 1, K ) )
     $          THEN
         INFO = -3
      ELSE IF( N.LT.K ) THEN
         INFO = -4
      ELSE IF( LDQ.LT.MAX( 1, K ) ) THEN
         INFO = -7
      ELSE IF( LDS.LT.MAX( 1, K ) ) THEN
         INFO = -12
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DLAED9', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( K.EQ.0 )
     $   RETURN
*
*     Modify values DLAMDA(i) to make sure all DLAMDA(i)-DLAMDA(j) can
*     be computed with high relative accuracy (barring over/underflow).
*     This is a problem on machines without a guard digit in
*     add/subtract (Cray XMP, Cray YMP, Cray C 90 and Cray 2).
*     The following code replaces DLAMDA(I) by 2*DLAMDA(I)-DLAMDA(I),
*     which on any of these machines zeros out the bottommost
*     bit of DLAMDA(I) if it is 1; this makes the subsequent
*     subtractions DLAMDA(I)-DLAMDA(J) unproblematic when cancellation
*     occurs. On binary machines with a guard digit (almost all
*     machines) it does not change DLAMDA(I) at all. On hexadecimal
*     and decimal machines with a guard digit, it slightly
*     changes the bottommost bits of DLAMDA(I). It does not account
*     for hexadecimal or decimal machines without guard digits
*     (we know of none). We use a subroutine call to compute
*     2*DLAMBDA(I) to prevent optimizing compilers from eliminating
*     this code.
*
      DO 10 I = 1, N
         DLAMDA( I ) = DLAMC3( DLAMDA( I ), DLAMDA( I ) ) - DLAMDA( I )
   10 CONTINUE
*
      DO 20 J = KSTART, KSTOP
         CALL DLAED4( K, J, DLAMDA, W, Q( 1, J ), RHO, D( J ), INFO )
*
*        If the zero finder fails, the computation is terminated.
*
         IF( INFO.NE.0 )
     $      GO TO 120
   20 CONTINUE
*
      IF( K.EQ.1 .OR. K.EQ.2 ) THEN
         DO 40 I = 1, K
            DO 30 J = 1, K
               S( J, I ) = Q( J, I )
   30       CONTINUE
   40    CONTINUE
         GO TO 120
      END IF
*
*     Compute updated W.
*
      CALL DCOPY( K, W, 1, S, 1 )
*
*     Initialize W(I) = Q(I,I)
*
      CALL DCOPY( K, Q, LDQ+1, W, 1 )
      DO 70 J = 1, K
         DO 50 I = 1, J - 1
            W( I ) = W( I )*( Q( I, J ) / ( DLAMDA( I )-DLAMDA( J ) ) )
   50    CONTINUE
         DO 60 I = J + 1, K
            W( I ) = W( I )*( Q( I, J ) / ( DLAMDA( I )-DLAMDA( J ) ) )
   60    CONTINUE
   70 CONTINUE
      DO 80 I = 1, K
         W( I ) = SIGN( SQRT( -W( I ) ), S( I, 1 ) )
   80 CONTINUE
*
*     Compute eigenvectors of the modified rank-1 modification.
*
      DO 110 J = 1, K
         DO 90 I = 1, K
            Q( I, J ) = W( I ) / Q( I, J )
   90    CONTINUE
         TEMP = DNRM2( K, Q( 1, J ), 1 )
         DO 100 I = 1, K
            S( I, J ) = Q( I, J ) / TEMP
  100    CONTINUE
  110 CONTINUE
*
  120 CONTINUE
      RETURN
*
*     End of DLAED9
*
      END

!================================================
!  Software name : STM
!  Module : m_ArraySize_Parameters
!  Subroutine(s) : m_ArraySize_Parameters_rd
!  Author(s)     : Takahiro Yamasaki (June 7, 2004)
!
!  FURTHER MODIFICATION: Junichiro  Koga (June 24, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

module m_ArraySize_Parameters
! $Id: m_ArraySize_Parameters.f90,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
  implicit none
  integer :: &
       & kng, kngp&
       &,kng1 &
       &,keg ,   kimg &
       &, knl , knm , knn , kid , kfft&
       &, knlp , knmp , knnp , kidp, kfftp &
       &,knv3 &
       &,kspin

contains
  subroutine m_ArraySize_Parameters_rd(nfcntn_bin)
    integer, intent(in) :: nfcntn_bin

    read(nfcntn_bin) kng
    read(nfcntn_bin) kngp
    read(nfcntn_bin) kng1
    read(nfcntn_bin) keg
    read(nfcntn_bin) kimg
    read(nfcntn_bin) knl
    read(nfcntn_bin) knm
    read(nfcntn_bin) knn
    read(nfcntn_bin) kid
    read(nfcntn_bin) knlp
    read(nfcntn_bin) knmp
    read(nfcntn_bin) knnp
    read(nfcntn_bin) kidp
    read(nfcntn_bin) knv3
    read(nfcntn_bin) kspin

    kfft  = kid *knm *knn *kimg
    kfftp = kidp*knmp*knnp*kimg

    print *, '<< ArraySize parameters read from F_CNTN_BIN >>'
    print *, 'kng: ',kng
    print *, 'kngp: ',kngp
    print *, 'kng1: ',kng1
    print *, 'keg: ',keg
    print *, 'kimg: ',kimg
    print *, 'knl: ',knl
    print *, 'knm: ',knm
    print *, 'knn: ',knn
    print *, 'kid: ',kid
    print *, 'knlp: ',knlp
    print *, 'knmp: ',knmp
    print *, 'knnp: ',knnp
    print *, 'kidp: ',kidp
    print *, 'knv3: ',knv3
    print *, 'kspin: ',kspin

  end subroutine m_ArraySize_Parameters_rd
end module m_ArraySize_Parameters

!TSPACEを使うためのユーティリティ、以下は変数の定義部分
!Copyright (C) 2014-2015 Ryosuke Tomita 

#define DEBUG(F) write(100,F)
module m_tspace_commons
#include "defines.F"
!  use m_character_table, only: get_trace
  use m_commons, only: pi, stdout
  use m_phase_commons, only: get_point_group_name
  use m_tspace_defines, only: num_operator_max, class, kvector, group, lattice_parameter, num_class_max, num_operator_per_class_max, element_name_inversion, element_name_cubic, element_name_hexagonal
  use m_container_psicoef,only:ndim_spinor ! Saito
  implicit none

#define IOPR_TSP(i) ig(jg(i))
!TSPACEの内部変数
!(以下、OhもしくはD6h群での番号)対称操作のJones表現、群表(O_aO_b == O_im(a,b))、逆元表
  integer, private:: it(nxyz_, num_operator_max), im(num_operator_max, num_operator_max), iv(num_operator_max)
!ブラベ格子の番号、空間群の位数、(以下、OhもしくはD6h群での番号)空間群の対称操作の番号、空間群の並進ベクトル
  integer, private:: il, ng, ig(num_operator_max), jv(2, nxyz_, num_operator_max)
!k点の分母、共通分子、k点群の位数、(以下、Γ点群での番号)k点群の対称操作の番号、回転操作に付随するk点に等価な点の番号
  integer, private:: kb(nxyz_), icb, mg, jg(num_operator_max), jk(nxyz_, num_operator_max)
!スピン空間の回転行列(スピン状態は反転対称なので位数の最大は24)
  COMPLEX_T, private:: sn(2,2,num_operator_max/2)
  common/spg1/it, im, iv
  common/spg2/il, ng, ig, jv
  common/spg3/kb, icb, mg, jg, jk
  common/spg6/sn

contains
#ifdef DEBUG
  subroutine debugjv(nfout)
    integer, intent(in):: nfout
    integer:: iopr, j
    write(nfout, *) ig
    do iopr = 1, ng
       write(nfout, *) iopr, ig(iopr), (jv(1:2, j, iopr), j = 1, 3)
    end do
  end subroutine debugjv
#endif

  subroutine tescom()
!      type(character_table), pointer, private:: chtable
      integer:: ndes(12), jtrs(12),ipas(12)
      integer:: i, jdub, nrs, mmg, nstr
!        i= chtable%numimr
      call dgtrst(jdub, nrs, mmg, nstr, ndes, jtrs, ipas)
!      write(stdout,*)'order of kpoint group =', mmg, ' number of star =', nstr,' number of representation =', nrs
      do i = 1, nrs
          if(jtrs(i)==0) write(stdout,*)  '     PAIRING of ',i,' and',ipas(i),':    Herring sum=',jtrs(i)
          if(jtrs(i) < 0) write(stdout,*) '     DUBLING of ',i, ':    Herring sum=',jtrs(i)
!          write(stdout, *)'no', i
!          write(stdout, *)'degeneracy = ', ndes(i)
!          write(stdout, *)'herring sum = ', jtrs(i)
!          write(stdout, *)'partner no = ', ipas(i)
      end do

  end subroutine tescom
!対称操作のインデックス及びTSPACE内部変数から対称操作の文字列表現を得る
  character(len = NameLen) function get_element_name(iopr)&
       result(name)
    integer, intent(in):: iopr
    name = ''
    if(il /= 0) then !立体群(Oh)
       if(iopr > NOP_MAX_CUB) then
          name = ''
!番号が最大値の半分を超えるとき、文字列先頭に'I'をつける
       else if(iopr > NOP_MAX_CUB/2) then
          name = trim(element_name_inversion) // trim(element_name_cubic(iopr - NOP_MAX_CUB/2))
       else
          name = trim(element_name_cubic(iopr))
       end if
    else !六方晶群(D6h)
       if(iopr > NOP_MAX_HEX) then
          name = ''
       else if(iopr > NOP_MAX_HEX/2) then
          name = trim(element_name_inversion) // trim(element_name_hexagonal(iopr - NOP_MAX_HEX/2))
       else
          name = trim(element_name_hexagonal(iopr))
       end if
    end if
  end function get_element_name

!類に属する対称操作の名前から、類の名前を決定する(beta版)
  character(len = NameLen) function get_class_name(cls,grp)&
       result(name)
    type(class), intent(in):: cls
    type(group), intent(in):: grp
    if(cls%order == 1) then
       name = trim(grp%op(cls%ind(1))%name)
    else
       write(name, '(I0,A)') cls%order, trim(grp%op(cls%ind(1))%name)
    end if
  end function get_class_name

!k点群の対称操作の共役元をもとめ、類に分ける,出力は類の数
  subroutine set_class(kpoint, kgroup)
#define CLASS kgroup%cls
#define ORDER kgroup%order
#define NCLASS kgroup%nclass
    type(kvector), intent(in):: kpoint
    type(group), intent(inout):: kgroup
    integer:: iop1, iop2, iop_, jg1, jg2, imbuf
!ある対称操作が類に分けられたかどうか
    logical:: iscount(num_operator_max)
    integer:: v1(3), v2(3), maxang

    NCLASS = 0
    maxang = 0
    
    iscount = .false.
    do iop1 = 1, ORDER!iterate through number of order of kgroup  
       if(NCLASS >= num_class_max) then
          NCLASS = num_class_max
          exit
       end if
!対称操作がすでに処理されているとき、スキップ
       if(iscount(iop1)) cycle
       NCLASS = NCLASS + 1!this iteration set the number of class
       CLASS(NCLASS)%order = 1
       CLASS(NCLASS)%ind = 0
       CLASS(NCLASS)%ind(CLASS(NCLASS)%order) = iop1
       iscount(iop1) = .true.
!対称操作のインデックス(TSPACE内でのインデックス)
       jg1 = IOPR_TSP(iop1)!A
       do iop2 = 1, ORDER
          if(iop2 == iop1) cycle
          jg2 = IOPR_TSP(iop2)!B
!write(stdout, *) iop1, jg1, iop2, jg2, NCLASS, CLASS(NCLASS)%order
!群表imおよび逆元ivにより共役元BAB^-1のインデックスをもとめる
          imbuf = im(im(jg2, jg1), iv(jg2))!BAB^-1
          do iop_ = 1, ORDER!C
!共役元がk点群の中にあり、まだ処理されていないとき
             if(.not.iscount(iop_) .and. imbuf == IOPR_TSP(iop_))& 
                 go to 10!C == BAB^-1           
          end do
          cycle
!類表に共役元を追加する
10        if(CLASS(NCLASS)%order <= num_operator_per_class_max)&
               CLASS(NCLASS)%order = CLASS(NCLASS)%order + 1
          !write(stdout,*)iop1,iop2,iop_,'|',CLASS%order 
          CLASS(NCLASS)%ind(CLASS(NCLASS)%order) = iop_
!この対称操作は処理したのでフラグを立てる
       iscount(iop_) = .true.
       end do
    end do
!類の名前付け
    do jg1 = 1, NCLASS
       CLASS(jg1)%name = get_class_name(CLASS(jg1), kgroup)
    end do

#undef CLASS
#undef ORDER
#undef NCLASS
  end subroutine set_class

!対称操作から点群の名前を得る
  subroutine set_pg_name(grp)
    type(group), intent(out):: grp
    integer:: i, nopr(num_operator_max)
    grp%schname = ''
    grp%hmname = ''
    do i = 1, mg
       nopr(i) = IOPR_TSP(i)
!write(stdout, *) i, nopr(i)
    enddo
    if(il /= 0) then
       call get_point_group_name(stdout, 'cubic    ',&
            mg, nopr, grp%schname, grp%hmname)
    else
       call get_point_group_name(stdout, 'hexagonal',&
            mg, nopr, grp%schname, grp%hmname)
    end if
  end subroutine set_pg_name

!Γ点群を渡し、TSPACEで指定されているk点の群を得る
  type(group) function get_kgroup_from_gammagroup(kgp)&
       result(buf)
    type(group), intent(in):: kgp
    integer:: i
    buf%order = mg
    do i = 1, buf%order
       buf%op(i) = kgp%op(jg(i))
    enddo
  end function get_kgroup_from_gammagroup

!TSPACEから空間群もしくはk点群を得る関数
  type(group) function get_group_template(is_kgroup) result(gr)
    logical, intent(in):: is_kgroup
    integer:: i, ittmp, j, k, igshift, max_
!k点群かどうかで位数が変わる
!六方晶のk点群の場合, 回転軸が実格子と異なるための措置、詳しくはTSPACEを参照されたし
    igshift = 0
    if(is_kgroup) then
       gr%order = mg!this set kgroup order, mg taken from TSPACE
       if(il == 0)&
            igshift = num_operator_max/2
    else
       gr%order = ng
    end if
    if(il == 0) then
       max_ = num_operator_max/4
    else
       max_ = num_operator_max/2
    end if

    gr%inversion = 0
    do i = 1, gr%order
       gr%op(i)%index_for_gamma = jg(i)
       gr%op(i)%index_for_all = IOPR_TSP(i)

       if((il == 0 .and. IOPR_TSP(i) == 13) .or.&
            (il /= 0 .and. IOPR_TSP(i) == 25))&
            gr%inversion = i
       gr%op(i)%rot = 0d0
       gr%op(i)%tr = 0d0
!k点群は空間群の回転操作のみからなる部分群である。k点群においてどの回転操作が要素となるかはk点によって異なり、それについての情報がTSPACE内部変数jg(1: mg)に記憶されている
       do j = 1, nxyz_
!TSPACE内部変数itに対称操作の回転についての情報が格納されている。jones表現XYZはそれぞれ整数1,2,3で表される。-X, -Y, -Z は-1, -2, -3として表現される
          ittmp = it(j, igshift + IOPR_TSP(i))

!jones表現X-Y(TSPACE内でWと表現される)は整数4として記憶されている。六方晶k点群の場合、Wの定義はX+Yに変わる。符号の反転はXYZと同様
          if(abs(ittmp) == 4) then
             k = sign(1, ittmp)
             gr%op(i)%rot(1, j) = k
             gr%op(i)%rot(2, j) = -k
             if(is_kgroup) gr%op(i)%rot(2, j) = k
          else
             k = abs(ittmp)
             gr%op(i)%rot(k, j) = sign(1, ittmp)
          endif
!並進についての情報がTSPACE内部変数jvに記憶されている。jv(1, 1:3, 1:48)が並進ベクトルの分子、jv(2, 1:3, 1:48)が分母、ifは分母が0であったときの措置
          if(jv(2, j, jg(i)) == 0) then
             gr%op(i)%tr(j) = 0d0
          else
             gr%op(i)%tr(j) = dble(jv(1, j, jg(i)))&
                  /jv(2, j, jg(i))
          end if
       enddo
#ifdef _USE_LAPACK_
       gr%op(i)%vaxis = get_rotation_axis(gr%op(i)%rot)
       gr%op(i)%vang = .5d0*(gr%op(i)%rot(1,1) + gr%op(i)%rot(2,2) + gr%op(i)%rot(3,3) - 1d0)
#endif
       gr%op(i)%spinrot(:,:) = sn(:,:,mod(IOPR_TSP(i) - 1, max_) + 1)
       gr%op(i)%name = trim(get_element_name(IOPR_TSP(i)))
    enddo
  end function get_group_template

!TSPACE内で(TSPACE関数TSIREPにより)設定されているk点についての対称操作の情報を返す
  type(group) function get_kgroup() result(gr)
    gr = get_group_template(.true.)
  end function get_kgroup

!TSPACEで設定された結晶系(TSPACE関数TSPACEなどで設定)の空間群の対称操作の情報を返す
  type(group) function get_group() result(gr)
    gr = get_group_template(.false.)
  end function get_group

!晶系を表す文字列[FICRHP]から、TSPACEに指定する整数ilを決定する(inputを分かり易くするための措置)
  integer function determine_lattice_system(hmname) result(il)
    character(len = NameLen), intent(in):: hmname
    select case(hmname(1:1))
    case ('f', 'F')
       il = 2
    case ('i', 'I')
       il = 3
    case ('c', 'C')
       il = 4
    case ('r', 'R')
       il = -1
    case ('h', 'H')
       il = 0
    case ('p', 'P')
       il = 1
    case default
       il = 255
    end select
  end function determine_lattice_system

!結晶系を決める整数(上記のdetermine_lattice_systemから求められる)と生成元および反転対称性の有無から、TSPACE内で空間群を決定するための関数(TSPACE関数tspace, tsgenr, tspgrpを使用)
  subroutine determine_space_group(latsys, ngen, noprs, ntrs, inv)
    integer, intent(in):: latsys, ngen, noprs(ngen), ntrs(2, nxyz_, ngen)
    logical, intent(in):: inv
    integer:: i
!結晶系の決定
    call tspace(latsys)
    do i = 1, ngen
!生成元の登録
       call tsgenr(noprs(i), ntrs(:, :, i))
    enddo
!反転対称性の有無
    if(inv) then
       call tspgrp(1)
    else
       call tspgrp(0)
    endif
  end subroutine determine_space_group

!TSPACE内で格子定数を決定する(TSPACE関数tslatcを使用)
  subroutine set_lattice_parameters(lp)
    type(lattice_parameter), intent(in):: lp
!結晶系の設定
    call determine_space_group(determine_lattice_system(lp%lattice_type),&
            lp%num_generator, lp%index_rotation, &
            lp%translation, lp%isinversion)
!格子定数の設定
    call tslatc(lp%a, lp%b, lp%c,&
         cos(lp%alpha * pi/180),&
         cos(lp%beta * pi/180),&
         cos(lp%gamma * pi/180))
  end subroutine set_lattice_parameters

!TSPACE内でk点を指定する(TSPACE関数tsirep, kpnameを使用)
  subroutine set_kpoint_irep(kp, nspin)
    type(kvector), intent(inout):: kp
    integer, intent(in), optional:: nspin
    if(present(nspin) .and. nspin < 2) then
       call tsirep(kp%comp, kp%common_denom, 0)
!    else if(kp%isdouble) then
    else if(ndim_spinor == 2) then
       call tsirep(kp%comp, kp%common_denom, 1)
    else
       call tsirep(kp%comp, kp%common_denom, 0)
    end if
    kp%name = ""
    call kpname(kp%comp(1), kp%comp(2), kp%comp(3), kp%common_denom, kp%name)
    call tskfbz(kp%comp(1), kp%comp(2), kp%comp(3), kp%common_denom, kp%comm2bz)
  end subroutine set_kpoint_irep

  subroutine print_kpoint_and_kgroup(nfout, kp, grp)
    integer, intent(in):: nfout
    type(kvector), intent(in):: kp
    type(group), intent(in):: grp
    character*2 ctempo
    data ctempo/'  '/ 
    write(nfout, '(I0,1X,A,1X,4(I0,1X),2(A,1X),I0)') kp%index, kp%name, kp%comp, kp%common_denom, grp%schname, grp%hmname, kp%comm2bz
!     PRINT HERRING SUM  Saito
     if (ctempo.ne.kp%name)  call tescom()
     ctempo=kp%name 
!     
  end subroutine print_kpoint_and_kgroup    

!群の対称操作の出力
  subroutine print_group(nfout, grp)
    integer, intent(in):: nfout
    type(group), intent(in):: grp
    integer:: iopr, jd
#define OP grp%op(iopr)
    write(nfout, '("order=",i6)')grp%order
    do iopr = 1, grp%order
       write(nfout, *) iopr, IOPR_TSP(iopr), OP%name, OP%vang
       do jd = 1, 3
          write(nfout, *) OP%rot(:, jd), OP%tr(jd), OP%vaxis(jd)
       end do
       write(nfout, *) 'SpinRot'
       do jd = 1, 2
          write(nfout, *) OP%spinrot(jd,:)
       end do
    end do
#undef OP
  end subroutine print_group

!類の出力、フォーマット=> (類の位数、１のとき省略)(類の名前):(類に属する対称操作１の名前) (対称操作２の名前) ...
  subroutine print_class(nfout, kgroup)
    type(group), intent(in):: kgroup
    integer, intent(in):: nfout
    integer:: ic, iop
    write(nfout, '(a)') '#OPERATOR IN CLASS'
!write(nfout, *) kgroup%cn, kgroup%sv, kgroup%sh, kgroup%inv
    do ic = 1, kgroup%nclass
       write(nfout, fmt = '(A,1X,A10,2X)', advance = 'no')&
            '#class', trim(kgroup%cls(ic)%name)//':'
       do iop = 1, kgroup%cls(ic)%order
          write(nfout, fmt = '(A,1X)', advance = 'no')&
               trim(kgroup%op(kgroup%cls(ic)%ind(iop))%name)
       end do
       write(nfout, *)
    end do
  end subroutine print_class

  character(len=8) function getKpointNameForTex(name1) result(name2)
    character(len=2), intent(in):: name1
    select case(name1(1:2))
    case("GM")
       name2 = "\Gamma"
    case("LD")
       name2 = "\Lambda"
    case("SM")
       name2 = "\Sigma"
    case("DT")
       name2 = "\Delta"
    case("TP")
       name2 = "T'"
    case("SP")
       name2 = "P'"
    case default
       name2 = name1
    end select
  end function getKpointNameForTex
end module m_tspace_commons

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 635 $)
!
!  MODULE: m_ES_IO
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_IODO__
#   define __TIMER_IODO_START(a)   call timer_sta(a)
#   define __TIMER_IODO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_IODO_START(a)
#   define __TIMER_IODO_STOP(a)
#endif
#ifdef __TIMER_IOCOMM__
#   define __TIMER_IOCOMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_IOCOMM_START(a)       call timer_sta(a)
#   define __TIMER_IOCOMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_IOCOMM_START_w_BARRIER(str,a)
#   define __TIMER_IOCOMM_START(a)
#   define __TIMER_IOCOMM_STOP(a)
#endif

!#define _DEBUG_ESIO_

!
module m_ES_IO
! $Id: m_ES_IO.F90 635 2021-02-26 07:16:10Z jkoga $
  use m_Electronic_Structure, only : zaj_l,neordr,nrvf_ordr,eko_l,occup_l,efermi,efermi_spin,totch&
       &                            ,vnlph_l,vlhxc_l,eko_ek, zaj_l_prev, metalic_system, vbm
  use m_Electronic_Structure, only : m_ES_WF_in_Rspace
  use m_PlaneWaveBasisSet,    only : kgp,kg1,ngabc,nbase,iba
  use m_Kpoints,              only : kv3, vkxyz, vkxyz_ek, kv3_ek, k_symmetry, qwgt, &
       &                             m_Kp_get_nkmesh, m_Kp_get_kptable_bxsf, &
       &                             vkxyz_refcell
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,   only : nspin,kimg,neg,num_extra_bands,af,ipri, printable, neg_previous &
       &                           , wf_filetype, wf_title, eigmin_wf, eigmax_wf, ekmode, neg_is_enlarged &
       &                           , icond, fixed_charge_k_parallel, sw_ekzaj, numk_zajsaved, Nw_Psicoef &
       &                           , precision_WFfile
  use m_Const_parameters,     only : DP, SP, CMPLDP, BUCS, OFF, YES, EK, SCF, DENSITY_ONLY &
       &                           , CUBE, VTK, BINARY, GAMMA, GAMMA_base_symmetrization, ONE_BY_ONE &
       &                           , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, DELTA &
       &                           , EFERMI_VICINITY, ALL_VALUES, GRID, ON
  use m_Parallelization,      only : MPI_CommGroup,mpi_k_world,mpi_e_world,is_kngp,ie_kngp,npes &
       &                           , mype,ierr,map_k, map_ek,ista_e,iend_e,istep_e,map_z, np_e &
       &                           , ista_k,iend_k,myrank_e,myrank_k,map_e,nrank_e &
       &                           , ista_kngp,iend_kngp, nrank_k  &
       &                           , ista_g1k,iend_g1k, np_g1k , myrank_g, nrank_g, np_g1k_prev &
       &                           , nis_g1k,nie_g1k,map_rank_gek  &
       &                           , ista_spin, iend_spin, map_s, myrank_spin, map_eks
  use m_IterationNumbers,     only : nk_in_the_process, nk_converged, nkgroup &
       &                           , first_kpoint_in_this_job, iteration_ionic, iteration_electronic
  use m_FFT,                  only : fft_box_size_WF,nfft
  use m_Crystal_Structure,    only : altv, sw_fix_total_spin, altv_refcell
  use m_Ionic_System,         only : natm,natm2,iatomn,m_IS_pack_all_ions_in_uc
  use m_PseudoPotential,      only : ival
  use m_Crystal_Structure,    only : univol, rltv

! ===================================== added by K. Tagami ============= 11.0
  use m_Control_Parameters,    only : ndim_spinor, noncol, &
       &                              previous_nspin_collinear, &
       &                              previous_nband_collinear
! ====================================================================== 11.0
  use m_ErrorMessages,        only : EOF_REACHED

  use m_Control_Parameters, only : ndim_magmom, ik_wf_squared, &
       &                           ib1_wf_squared, ib2_wf_squared, &
       &                           wf_squared_filetype,  max_projs, proj_attribute, &
       &                           ndim_chgpot, SpinOrbit_Mode, &
       &                           wf_orb_proj_print_format, proj_group, num_proj_elems, &
       &                           sw_band_unfolding
  use m_Const_parameters,     only : Neglected, PAI2, CARTS, DELTA07, HARTREE, BOHR
  use m_Files,              only :  nfwfk_sq, m_Files_open_nfwfksq_noncl, &
       &                            nfwfk_integ_mom, &
       &                            m_Files_open_nfwfk_integ_mom, &
       &                            m_Files_close_nfwfk_integ_mom, &
       &                            m_Files_open_nfwfk_orb_proj, &
       &                            m_Files_close_nfwfk_orb_proj, &
       &                            nfwfk_orb_proj
  use m_PseudoPotential,   only : nlmt, ilmt, lmta, q, &
       &                          nlmta_phi, nlmtt_phi, qorb, m_PP_tell_iorb_lmtt, &
       &                          m_PP_tell_iorb_ia_l_m_tau, ilmt_phi, &
       &                          mtp_phi, lmta_phi, ltp_phi, taup_phi
  use m_Nonlocal_Potential,   only : norm_phig
  use m_Charge_Density,    only : chgq_l, hsr, hsi, &
       &                          m_CD_softpart_ktsub_noncl, &
       &                          m_CD_hardpart_ktsub_noncl, &
       &                          m_CD_alloc_rspace_charge, &
       &                          m_CD_dealloc_rspace_charge, &
       &                          m_CD_rspace_charge_noncl
  use m_Ionic_System,      only : ityp, iproj_group
  use m_Electronic_Structure,  only : fsr_l, fsi_l, compr_l, compi_l
  use m_ES_Noncollinear,   only : m_ES_set_Pauli_Matrix
  use m_SpinOrbit_Potential,  only :  MatU_ylm_RC_L0,  MatU_ylm_RC_L1,  MatU_ylm_RC_L2, &
       &                              MatU_ylm_RC_L3

! ==== EXP_CELLOPT ==== 2015/09/24
  use m_PlaneWaveBasisSet,    only : kg1_prev
! ===================== 2015/09/24
  use mpi

  implicit none
!  include 'mpif.h'

  integer istatus(mpi_status_size)

  real(kind=SP), allocatable, dimension(:,:)  :: wf_l   ! work wave functions
  real(kind=DP), allocatable, dimension(:,:)  :: wfdp_l ! work wave functions

!  1.  m_ESIO_rd_EigenValues_etc    <-(Initial_Electronic_Structure)
!  2.  m_ESIO_wd_EigenValues_etc    <-(WriteDownData_onto_Files, Postprocessing)
!  3.  m_ESIO_wd_EigenValues        <-(WriteDownData_onto_Files, Convergence_Check, Postprocessing)
!  4.  m_ESIO_wd_EigenValues_ek     <-(WriteDownData_onto_Files)
!  5.  m_ESIO_wd_vlhxc              <-(Postprocessing)
!  6.  m_ESIO_rd_WFs                <-(Initial_Electronic_Structure, scf_rd_wf_and_chg)
!  7.  m_ESIO_rd_WFs_import_frm_collin    <-(Initial_Electronic_Structure)
!  8.  m_ESIO_wd_WFs                <-(WriteDownData_onto_Files)
!  9.  m_ESIO_wd_WFs_standardout    <-(Renewal_of_WaveFunctions)
! 10.  m_ESIO_rd_WFs_and_EVs_ek     <-(Initial_Electronic_Structure)
! 11.  m_ESIO_rd_EVs_ek             <-(Initial_Electronic_Structure)
! 12.  m_ESIO_wd_Psicoef            <-(WriteDownData_onto_Files)
! 13.  m_ESIO_wd_WFs_and_EVs_ek     <-(WriteDownData_onto_Files, WriteDownData_onto_Files_ek, Convergence_Check)
! 14.  m_ESIO_wd_WFn                <-(Postprocessing)
! 15.  m_ESIO_wd_Efermi             <-(WriteDownData_onto_Files)
! 16.  m_ESIO_rd_Eferm              <-(Initial_Electronic_Structure, scf_rd_wf_and_chg)

contains
  subroutine m_ESIO_rd_EigenValues_etc(nfout,nfcntn_bin,F_CNTN_BIN_partitioned)

    integer, intent(in) :: nfout, nfcntn_bin
    logical, intent(in) :: F_CNTN_BIN_partitioned
    integer  :: ik, ie, ispin
    integer, allocatable, dimension(:,:) :: n1_wk, n2_wk  ! MPI
    real(DP),allocatable, dimension(:,:) :: e1_wk, e2_wk  ! MPI
!!$    read(nfcntn_bin) neordr,nrvf_ordr,eko_l,occup_l,efermi,totch
                                                  __TIMER_SUB_START(1370)
    if(F_CNTN_BIN_partitioned) then
       if(neg_previous /= neg) then
          write(nfout,'(" !! neg_previous /= neg <<m_ESIO_rd_EigenValues_etc>>")')
          write(nfout,'(" !! neg_prevous = ",i8)') neg_previous
          write(nfout,'(" !! neg         = ",i8)') neg
          write(nfout,'(" neg_previous should be neg when F_CNTN_BIN_in_partitioned is true")')
          call phase_error_with_msg(nfout,' neg_previous should be neg when F_CNTN_BIN_in_partitioned is true',__LINE__,__FILE__)
       end if
       allocate(n1_wk(neg,iend_k-ista_k+1), n2_wk(neg,iend_k-ista_k+1))
       allocate(e1_wk(np_e,iend_k-ista_k+1),e2_wk(np_e,iend_k-ista_k+1))
       n1_wk = 0; n2_wk = 0
       e1_wk = 0; e2_wk = 0
       ! -- neordr, nrvf_ordr --
                                                  __TIMER_IODO_START(1405)
       read(nfcntn_bin) n1_wk
       read(nfcntn_bin) n2_wk
                                                  __TIMER_IODO_STOP(1405)
                                                  __TIMER_IODO_START(1406)
       do ik = ista_k, iend_k
          neordr(1:neg,ik) = n1_wk(1:neg,ik-ista_k+1)
          nrvf_ordr(1:neg,ik) = n2_wk(1:neg,ik-ista_k+1)
       end do
                                                  __TIMER_IODO_STOP(1406)
       ! -- eko_l, occup_l --
                                                  __TIMER_IODO_START(1407)
       read(nfcntn_bin) e1_wk
       read(nfcntn_bin) e2_wk
                                                  __TIMER_IODO_STOP(1407)
                                                  __TIMER_IODO_START(1408)
       do ik = ista_k, iend_k
          do ie = ista_e, iend_e
             eko_l(map_z(ie),ik) = e1_wk(ie-ista_e+1,ik-ista_k+1)
             occup_l(map_z(ie),ik) = e2_wk(ie-ista_e+1,ik-ista_k+1)
          end do
       end do
                                                  __TIMER_IODO_STOP(1408)
       deallocate(e2_wk,e1_wk,n2_wk,n1_wk)
       ! -- nfermi, totch --
       read(nfcntn_bin) efermi, totch
    else
       allocate(n1_wk(neg_previous,kv3),n2_wk(neg_previous,kv3)) ! MPI
       allocate(e1_wk(neg_previous,kv3),e2_wk(neg_previous,kv3)) ! MPI
       n1_wk = 0; n2_wk = 0
       e1_wk = 0; e2_wk = 0

       ! -- neordr, nrvf_ordr --
                                                  __TIMER_IODO_START(1409)
       if(mype == 0) read(nfcntn_bin) n1_wk                ! MPI
       if(mype == 0) read(nfcntn_bin) n2_wk                ! MPI
                                                  __TIMER_IODO_STOP(1409)
                                                  __TIMER_IOCOMM_START_w_BARRIER(MPI_CommGroup,1410)
       if(npes > 1) then
          call mpi_bcast(n1_wk,neg_previous*kv3,mpi_integer,0,MPI_CommGroup,ierr) ! MPI
          call mpi_bcast(n2_wk,neg_previous*kv3,mpi_integer,0,MPI_CommGroup,ierr) ! MPI
       endif
                                                  __TIMER_IOCOMM_STOP(1410)
                                                  __TIMER_IODO_START(1411)
       do ispin = ista_spin, iend_spin
       !do ik = ista_k, iend_k                              ! MPI
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          neordr(1:neg_previous,ik) = n1_wk(1:neg_previous,ik)
          nrvf_ordr(1:neg_previous,ik) = n2_wk(1:neg_previous,ik)
          if(neg_previous < neg) then
             do ie = neg_previous+1, neg
                neordr(ie,ik) = ie
                nrvf_ordr(ie,ik) = ie
             end do
          end if
       end do                                              ! MPI
       end do                                              ! MPI
                                                  __TIMER_IODO_STOP(1411)
       ! -- eko_l, occup_l --
                                                  __TIMER_IODO_START(1412)
       if(mype == 0) read(nfcntn_bin) e1_wk                ! MPI
       if(mype == 0) read(nfcntn_bin) e2_wk                ! MPI
                                                  __TIMER_IODO_STOP(1412)
                                                  __TIMER_IOCOMM_START_w_BARRIER(MPI_CommGroup,1413)
       if(npes > 1) then
          call mpi_bcast(e1_wk,neg_previous*kv3,mpi_double_precision,0,MPI_CommGroup,ierr) ! MPI
          call mpi_bcast(e2_wk,neg_previous*kv3,mpi_double_precision,0,MPI_CommGroup,ierr)! MPI
       end if
                                                  __TIMER_IOCOMM_STOP(1413)
                                                  __TIMER_IODO_START(1414)
       do ispin = ista_spin, iend_spin
       !do ik = ista_k, iend_k                              ! MPI
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          do ie = 1, neg_previous                          ! MPI
             if(map_e(ie) == myrank_e) then                ! MPI
                eko_l(map_z(ie),ik) = e1_wk(ie,ik)         ! MPI
                occup_l(map_z(ie),ik) = e2_wk(ie,ik)       ! MPI
             end if
          end do                                           ! MPI
          if(neg_previous < neg) then
             do ie = neg_previous+1, neg
                if(map_e(ie) == myrank_e) then
                   eko_l(map_z(ie),ik) = 1.d+15
                   occup_l(map_z(ie),ik) = 0.d0
                end if
            end do
          end if
       end do                                              ! MPI
       end do                                              ! MPI
                                                  __TIMER_IODO_STOP(1414)
       ! -- nfermi, totch --
       if(mype == 0) read(nfcntn_bin) efermi, totch        ! MPI
       if(npes > 1) then
          call mpi_bcast(efermi,1,mpi_double_precision,0,MPI_CommGroup,ierr) ! MPI
          call mpi_bcast(totch,1, mpi_double_precision,0,MPI_CommGroup,ierr) ! MPI
       end if

       deallocate(e2_wk,e1_wk,n2_wk,n1_wk)
    end if

    if(printable) write(nfout,'(" TOTCH (total charge) = ",f12.6 &
         & ," (= ",8d25.12,") at m_ESIO_rd_EigenValues_etc")') totch,totch

                                                  __TIMER_SUB_STOP(1370)
  end subroutine m_ESIO_rd_EigenValues_etc

  subroutine m_ESIO_wd_EigenValues_etc(nfcntn_bin,F_CNTN_BIN_partitioned,totch_flag)

    integer, intent(in) :: nfcntn_bin
    logical, intent(in) :: F_CNTN_BIN_partitioned
    integer, optional, intent(in) :: totch_flag

    integer  :: ik, ie, ispin, mpi_comm
    integer, allocatable, dimension(:,:) :: n_wk, n2_mpi  ! MPI
    real(DP),allocatable, dimension(:,:) :: e_wk, e2_mpi  ! MPI
    integer  :: id_sname = -1
                                                  __TIMER_SUB_START(1371)
    call tstatc0_begin('m_ESIO_wd_EigenValues_etc ',id_sname)

    mpi_comm = MPI_CommGroup

    if(F_CNTN_BIN_partitioned) then
       allocate(n_wk(neg,iend_k-ista_k+1))
       allocate(e_wk(np_e,iend_k-ista_k+1))
       n_wk = 0; e_wk = 0
       !  -- neordr --
                                                  __TIMER_IODO_START(1415)
       do ik = ista_k, iend_k
          n_wk(1:neg,ik-ista_k+1) = neordr(1:neg,ik)
       end do
                                                  __TIMER_IODO_STOP(1415)
                                                  __TIMER_IODO_START(1416)
       write(nfcntn_bin) n_wk
                                                  __TIMER_IODO_STOP(1416)
       !  -- nrvf_ordr --
                                                  __TIMER_IODO_START(1417)
       do ik = ista_k, iend_k
          n_wk(1:neg,ik-ista_k+1) = nrvf_ordr(1:neg,ik)
       end do
                                                  __TIMER_IODO_STOP(1417)
                                                  __TIMER_IODO_START(1418)
       write(nfcntn_bin) n_wk
                                                  __TIMER_IODO_STOP(1418)
       !  -- eko_l --
       e_wk = 0.d0
                                                  __TIMER_IODO_START(1419)
       do ik = ista_k, iend_k
          do ie = ista_e, iend_e
             e_wk(ie-ista_e+1,ik-ista_k+1) = eko_l(map_z(ie),ik)
!!$             e_wk(ie,ik-ista_k+1) = eko_l(map_z(ie),ik)
          end do
       end do
                                                  __TIMER_IODO_STOP(1419)
                                                  __TIMER_IODO_START(1420)
       write(nfcntn_bin) e_wk
                                                  __TIMER_IODO_STOP(1420)
!!$       if(npes >= 2) then
!!$          call mpi_allreduce(e_wk,e2_mpi,neg*(iend_k-ista_k+1),mpi_double_precision &
!!$               &               , mpi_sum, mpi_k_world)
!!$       else
!!$          e2_mpi = e_wk
!!$       end if
!!$       write(nfcntn_bin) e2_mpi

       !  -- occup_l --
       e_wk = 0.d0
                                                  __TIMER_IODO_START(1421)
       do ik = ista_k, iend_k
          do ie = ista_e, iend_e, istep_e
             e_wk(ie-ista_e+1,ik-ista_k+1) = occup_l(map_z(ie),ik)
!!$             e_wk(ie,ik-ista_k+1) = occup_l(map_z(ie),ik)
          end do
       end do
                                                  __TIMER_IODO_STOP(1421)
                                                  __TIMER_IODO_START(1422)
       write(nfcntn_bin) e_wk
                                                  __TIMER_IODO_STOP(1422)
!!$       if(npes >= 2) then
!!$          call mpi_allreduce(e_wk,e2_mpi,neg*(iend_k-ista_k+1),mpi_double_precision &
!!$               &               , mpi_sum, mpi_k_world)
!!$       else
!!$          e2_mpi = e_wk
!!$       end if
!!$       write(nfcntn_bin) e2_mpi
!!$       deallocate(e2_mpi, e_wk, n_wk)
       deallocate(e_wk, n_wk)
       if(totch_flag == OFF) then
          write(nfcntn_bin) efermi                     ! MPI
       else
          write(nfcntn_bin) efermi,totch               ! MPI
       end if
    else
       allocate(n_wk(neg,kv3)); allocate(n2_mpi(neg,kv3))! MPI
       allocate(e_wk(neg,kv3)); allocate(e2_mpi(neg,kv3))! MPI
       n_wk = 0; n2_mpi = 0
       e_wk = 0; e2_mpi = 0
       !  -- neordr --
       n_wk = 0                                          ! MPI
                                                  __TIMER_IODO_START(1423)
       do ispin = ista_spin, iend_spin
       !do ik = 1, kv3                                     ! MPI
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          n_wk(1:neg,ik) = neordr(1:neg,ik)               ! MPI
       end do                                             ! MPI
       end do                                             ! MPI
                                                  __TIMER_IODO_STOP(1423)
       if(npes >= 2) then
          call mpi_allreduce(n_wk,n2_mpi,neg*kv3,mpi_integer,mpi_sum,mpi_comm,ierr)
          n2_mpi = n2_mpi/nrank_e
       else
          n2_mpi = n_wk
       end if
                                                  __TIMER_IODO_START(1425)
       if(mype == 0) write(nfcntn_bin) n2_mpi             ! MPI ; writing (neordr)
                                                  __TIMER_IODO_STOP(1425)
       !  -- nrvf_ordr --
                                                  __TIMER_IODO_START(1426)
       n_wk = 0                                           ! MPI
       do ispin = ista_spin, iend_spin
       !do ik = 1, kv3                                     ! MPI
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          n_wk(1:neg,ik) = nrvf_ordr(1:neg,ik)            ! MPI
       end do                                             ! MPI
       end do                                             ! MPI
                                                  __TIMER_IODO_STOP(1426)
       if(npes >= 2) then
          call mpi_allreduce(n_wk,n2_mpi,neg*kv3,mpi_integer,mpi_sum,mpi_comm,ierr)
          n2_mpi = n2_mpi/nrank_e
       else
          n2_mpi = n_wk
       end if
                                                  __TIMER_IODO_START(1428)
       if(mype == 0) write(nfcntn_bin) n2_mpi             ! MPI ; writing (nrvf_ordr)
                                                  __TIMER_IODO_STOP(1428)
       !  -- eko_l --
       e_wk = 0.d0                                        ! MPI
                                                  __TIMER_IODO_START(1429)
       do ispin = ista_spin, iend_spin
       !do ik = 1, kv3                                     ! MPI
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          do ie = 1, neg                                  ! MPI
             if(map_e(ie) /= myrank_e) cycle              ! MPI
             e_wk(ie,ik) = eko_l(map_z(ie),ik)            ! MPI
          end do
       end do
       end do
                                                  __TIMER_IODO_STOP(1429)
       if(npes >= 2) then
          call mpi_allreduce(e_wk,e2_mpi,neg*kv3,mpi_double_precision,mpi_sum,mpi_comm,ierr)
       else
          e2_mpi = e_wk
       end if
                                                  __TIMER_IODO_START(1431)
       if(mype == 0) write(nfcntn_bin) e2_mpi             ! MPI ; writing (eko_l)
                                                  __TIMER_IODO_STOP(1431)

       !  -- occup_l --
       e_wk = 0.d0
                                                  __TIMER_IODO_START(1432)
       do ispin = ista_spin, iend_spin
       !do ik = 1, kv3                                     ! MPI
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          do ie = 1, neg                                  ! MPI
             if(map_e(ie) /= myrank_e) cycle              ! MPI
             e_wk(ie,ik) = occup_l(map_z(ie),ik)          ! MPI
          end do                                            ! MPI
       end do                                               ! MPI
       end do                                               ! MPI
                                                  __TIMER_IODO_STOP(1432)
       if(npes >= 2) then
          call mpi_allreduce(e_wk,e2_mpi,neg*kv3,mpi_double_precision,mpi_sum,mpi_comm,ierr)
       else
          e2_mpi = e_wk
       end if
                                                  __TIMER_IODO_START(1434)
       if(mype == 0) write(nfcntn_bin) e2_mpi             ! MPI ; writing (occup_l)
                                                  __TIMER_IODO_STOP(1434)
       if(mype == 0) then
          if(totch_flag == OFF) then
             if(metalic_system) then
               write(nfcntn_bin) efermi                     ! MPI
             else
               write(nfcntn_bin) vbm+1.d-10
             endif
          else
             if(metalic_system) then
               write(nfcntn_bin) efermi,totch               ! MPI
             else
               write(nfcntn_bin) vbm+1.d-10,totch
             endif
          end if
       end if
       deallocate(n_wk); deallocate(n2_mpi)              ! MPI
       deallocate(e_wk); deallocate(e2_mpi)              ! MPI
    end if
    call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(1371)
  end subroutine m_ESIO_wd_EigenValues_etc

  subroutine m_ESIO_wd_EigenValues(nf,iprieigen,nooccupation)

    integer, intent(in)              :: nf
    integer, intent(in)              :: iprieigen
    integer, intent(in)              :: nooccupation
    integer                          :: ie,  ipri0, kv3_i, ks
    integer                          :: hconst_min, lzero_max
    integer, parameter :: NCOLUMN = 6
    integer, parameter :: EIGEN_VALUES = 1, OCCUPATIONS = 2
    integer :: writemode
    real(kind=DP),allocatable, dimension(:,:) :: e_mpi, o_mpi
                                                  __TIMER_SUB_START(1378)
    allocate(e_mpi(neg,kv3)); e_mpi = 0.d0
    allocate(o_mpi(neg,kv3)); o_mpi = 0.d0

    call set_writemode(writemode)  ! ->(writemode) = ALL_VALUES or FERMI_VICINITY
    call get_ipri0(iprieigen,ipri0)

    if(ipri0 >= 2) then
       if(ipri0 >= 3 .and. nf == 6 .and. printable) call wd_neordr()

       call set_kv3_i_and_ks() ! -> kv3_i, ks
#ifndef _DEBUG_WRITE_
       if(writemode == EFERMI_VICINITY .and. kv3_i == kv3) &
            & call cal_vicinity_range(hconst_min,lzero_max) ! -> lzero_max, hconst_min
#endif
!     --- Energy eigen values ---
       call put_kpartArray_into(eko_l,e_mpi)
       if(printable) then
          if(ks == 0 .and. nf==6) call wd_efermi()
!!$          if(ks == 0) call wd_efermi()
          call wd_k_and_values(EIGEN_VALUES)
       end if
    end if
!     --- Occupations ---
    if(ipri0 >= 2 .and. nooccupation /= YES) then
       call put_kpartArray_into(occup_l,o_mpi)
       if(printable) call wd_k_and_values(OCCUPATIONS)
    end if
    deallocate(e_mpi)
    deallocate(o_mpi)
                                                  __TIMER_SUB_STOP(1378)
  contains
    subroutine set_writemode(writemode)
      integer, intent(out) :: writemode
      writemode = ALL_VALUES
#ifndef _DEBUG_WRITE_
      if(nf==6) then
         if((icond == FIXED_CHARGE_CONTINUATION .or. icond == FIXED_CHARGE) .and. &
              & fixed_charge_k_parallel == ONE_BY_ONE) then
            writemode = ALL_VALUES
         else
            if(neg <= NCOLUMN) then
               writemode = ALL_VALUES
            else
               writemode = EFERMI_VICINITY
            end if
         end if
      end if
#endif
    end subroutine set_writemode

    subroutine set_kv3_i_and_ks()
!!$      if(iprieigen>=2 .and. printable) then
      if((icond == FIXED_CHARGE_CONTINUATION .or. icond == FIXED_CHARGE) .and. &
           & fixed_charge_k_parallel == ONE_BY_ONE) then
         kv3_i = kv3_ek - kv3*(nkgroup-1)
         if(kv3_i > kv3) kv3_i = kv3
         ks = max(1,first_kpoint_in_this_job) - 1 + kv3*(nkgroup-1)
      else
         kv3_i = kv3
         ks = 0
      end if

      if(iprieigen>=3 .and. printable) &
           & write(nf,'(" kv3_i, kv3, ks, nkgroup = ",4i8)') kv3_i, kv3, ks, nkgroup
!!$
!!$      call mpi_bcast(kv3_i,1,mpi_integer,0,MPI_CommGroup,ierr)
!!$      call mpi_bcast(ks,1,mpi_integer,0,MPI_CommGroup,ierr)
    end subroutine set_kv3_i_and_ks

    subroutine wd_k_and_values(mode)
      integer, intent(in) :: mode
      integer :: ik, nb
      integer :: ie_s, ie_e, nhw, neg_t
      real(kind=DP) :: hw, hc, hv

#ifndef _DEBUG_WRITE_
      if(writemode == EFERMI_VICINITY) then
         hw = (lzero_max-hconst_min)*0.5d0
         hv = (lzero_max+hconst_min)*0.5d0
         hc = NCOLUMN*0.5d0
         nhw = Int(hw/hc + 1.d0)
         ie_s = max(nint(hv-nhw*hc + DELTA),1)
         ie_e = min(ie_s + nhw*NCOLUMN - 1,neg)
      end if
#endif

#if 1
      if ( nf /= 6 .and. mode == EIGEN_VALUES ) then
         write(nf,*)
         write(nf,*) "kpoint list"
         do ik = 1, kv3, ndim_spinor
            call wd_k_points(ik)
         end do
         write(nf,'(" -----")')
      end if
#endif

      if(mode == EIGEN_VALUES) then
#ifndef _DEBUG_WRITE_
         if(writemode == EFERMI_VICINITY) then
            write(nf,'(" ======  Energy Eigen Values in the vicinity of the Fermi energy level (Range=" &
                 & ,i7," :",i7,") =====")') ie_s, ie_e
         else
#endif
            if(nf==6) write(nf,'(" ======  Energy Eigen Values ======")')
#ifndef _DEBUG_WRITE_
         end if
#endif
      else
#ifndef _DEBUG_WRITE_
         if(writemode == EFERMI_VICINITY) then
            write(nf,'(" ======  Occupations in the vicinity of the Fermi energy level (Range=" &
                 & ,i7," :",i7,") =====")') ie_s, ie_e
         else
#endif
            if(nf==6) write(nf,'(" ======  Occupations ======")')
#ifndef _DEBUG_WRITE_
         end if
#endif
      end if
                                                  __TIMER_IODO_START(1463)
      do ik = 1, kv3_i, ndim_spinor
#ifndef _DEBUG_WRITE_
!!$         if(mode == OCCUPATIONS) e_mpi(:,ik) = e_mpi(:,ik)/(qwgt(ik)*kv3)
!!$         if(mode == OCCUPATIONS) o_mpi(:,ik) = o_mpi(:,ik)/(qwgt(ik)*kv3)
         if(writemode==EFERMI_VICINITY .and. kv3==kv3_i) then
            call wd_k_and_efermi_vicinities(ik,ie_s,ie_e,mode)
         else
#endif
            if(nf /= 6 .and. mode == EIGEN_VALUES) write(nf,'(" ===== energy eigenvalues =====")')
            if(nf /= 6 .and. mode == OCCUPATIONS)  write(nf,'(" ===== occupations =====")')
            if ( noncol ) then
               call wd_k_points_noncl(ik)
            else
               call wd_k_points(ik)
            endif
            neg_t = neg
            if(neg_is_enlarged) neg_t = neg - num_extra_bands
            if(mode == EIGEN_VALUES) then
               write(nf,'(5f16.8)') (e_mpi(nb,ik),nb = 1, neg_t) ! =eko(neordr(nb,ik),ik)
            else if(mode == OCCUPATIONS) then
               write(nf,'(5f16.8)') (o_mpi(nb,ik)/(qwgt(ik)*kv3/ndim_spinor),nb = 1, neg_t) ! =occup(neordr(nb,ik),ik)
            end if
#ifndef _DEBUG_WRITE_
         end if
#endif
      end do
                                                  __TIMER_IODO_STOP(1463)
    end subroutine wd_k_and_values

    subroutine put_kpartArray_into(a_l,a_all)
      real(kind=DP), intent(in), dimension(np_e,ista_k:iend_k) :: a_l
      real(kind=DP), intent(out), dimension(neg,kv3) :: a_all
      integer :: ik, ierr, ie, is
      integer :: ito

                                                  __TIMER_IODO_START(1461)
      a_all = 0.d0
      do is = ista_spin, iend_spin
      do ik = is, kv3-nspin+is, nspin
      !do ik = 1, kv3
         if(map_k(ik) /= myrank_k) cycle
         do ie = 1, neg
            if(map_e(ie) /= myrank_e) cycle
            ito = nrvf_ordr(ie,ik)
            a_all(ito,ik) = a_l(map_z(ie),ik)
         end do
      end do
      enddo
                                                  __TIMER_IODO_STOP(1461)
      if(npes >= 2) then
         call mpi_allreduce(MPI_IN_PLACE,a_all,neg*kv3,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
      end if
     end subroutine put_kpartArray_into

    subroutine wd_neordr()
      integer :: ik
      write(nf,'(" kv3 = ",i8, " neg = ",i8)') kv3,neg
      do ik= 1,kv3
         write(nf,'(" map_k(",i3,") = ",i8)') ik,map_k(ik)
         if(map_k(ik) /= myrank_k) cycle
         write(nf,'(" neordr ik=",i8)') ik
         write(nf,'(10i8)') neordr(1:neg,ik)
      end do
    end subroutine wd_neordr

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,MPI_CommGroup,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine wd_k_points(ik)
      integer, intent(in) :: ik
      real(kind=DP) :: vkxyz_wk(3)

      if ( sw_band_unfolding == ON ) then
         vkxyz_wk(1:3) = vkxyz_refcell(ik,1:3,BUCS)
      else
         vkxyz_wk(1:3) = vkxyz(ik,1:3,BUCS)
      endif

      if(nspin == 1) then
#ifdef _EIGENVALUES_IN_OLD_FORMAT_
          write(nf,'(i6,3f16.8)') ik+ks, vkxyz_wk(1:3)
#else
          write(nf,'(" ik = ",i8," (",3f10.6," )")') ik+ks, vkxyz_wk(1:3)
#endif
       else
#ifdef _EIGENVALUES_IN_OLD_FORMAT_
          if(mod(ik,2) == 1) then
             write(nf,'(i6,"    UP ",3f16.8)') ik+ks, vkxyz_wk(1:3)
          else
             write(nf,'(i6,"  DOWN ",3f16.8)') ik+ks, vkxyz_wk(1:3)
          end if
#else
          if(mod(ik,2) == 1) then
             write(nf,'(" ik = ",i8," (",3f10.6," )    UP ")') ik+ks, vkxyz_wk(1:3)
          else
             write(nf,'(" ik = ",i8," (",3f10.6," )  DOWN ")') ik+ks, vkxyz_wk(1:3)
          end if
#endif
       end if
     end subroutine wd_k_points

! ============================== added by K. Tagami ==================== 11.0
     subroutine wd_k_points_noncl(ik)
       integer, intent(in) :: ik
       real(kind=DP) :: vkxyz_wk(3)

       if ( sw_band_unfolding == ON ) then
          vkxyz_wk(1:3) = vkxyz_refcell(ik,1:3,BUCS)
       else
          vkxyz_wk(1:3) = vkxyz(ik,1:3,BUCS)
       endif

#ifdef _EIGENVALUES_IN_OLD_FORMAT_
       write(nf,'(i6,3f16.8)') ik+ks, vkxyz_wk(1:3)
#else
       write(nf,'(" ik = ",i5," (",3f10.6," )")') ik+ks, vkxyz_wk(1:3)
#endif
     end subroutine wd_k_points_noncl
! ====================================================================== 11.0

     subroutine cal_vicinity_range(hconst_min, lzero_max)
       integer, intent(out) :: hconst_min, lzero_max
       integer :: hconst,lzero
       integer :: ik, ie, nb
       integer :: ito

       e_mpi = 0.d0
       do ik = 1, kv3
          if(map_k(ik) /= myrank_k) cycle
          do ie = 1, neg
             if(map_e(ie) /= myrank_e) cycle
             ito = nrvf_ordr(ie,ik)
             e_mpi(ito,ik) = occup_l(map_z(ie),ik)
          end do
       end do
       if(npes >= 2) then
          call mpi_allreduce(MPI_IN_PLACE,e_mpi,neg*kv3,mpi_double_precision &
               &                  ,mpi_sum,MPI_CommGroup,ierr) ! MPI
       end if
       hconst_min = neg
       lzero_max = 0
       do ik = 1, kv3, ndim_spinor
          hconst = neg
          lzero  = 1
          do nb = neg,1,-1
             if(e_mpi(nb,ik)<DELTA) lzero = nb
!!$             if(e_mpi(nb,ik)>=qwgt(ik)*kv3-DELTA ) then
             if(e_mpi(nb,ik)>=qwgt(ik)*kv3/ndim_spinor-DELTA ) then
                hconst = nb
                exit
             end if
          end do
          if(hconst < hconst_min) hconst_min = hconst
          if(lzero_max < lzero)   lzero_max = lzero
       end do
       if(hconst_min > lzero_max) hconst_min = max(lzero_max-1,1)

       if(ipri>=2) write(nf,'(" hconst_min,lzero_max = ",2i8)') hconst_min,lzero_max
     end subroutine cal_vicinity_range

     subroutine wd_k_and_efermi_vicinities(ik,ie_s,ie_e,mode)
       integer, intent(in) :: ik, ie_s,ie_e,mode
       integer :: nb, nbloop, ie, ie1, ie2
       if(hconst_min >= 1) then
!!$          nb = lzero_max-hconst_min+1
          nb = ie_e - ie_s + 1
          nbloop = Int((nb-1)/NCOLUMN+1)
          do ie = 1, nbloop
!!$             ie1 = hconst_min+(ie-1)*NCOLUMN
!!$             ie2 = min(hconst_min+ie*NCOLUMN-1,neg)
             ie1 = max(ie_s+(ie-1)*NCOLUMN,1)
             ie2 = min(ie_s+ie*NCOLUMN-1,neg)
             if(ie == 1) then
                if(mode == EIGEN_VALUES) then
                   write(nf,'(" ik = ",i5," ",8f12.6)') ik, (e_mpi(nb,ik),nb=ie1,ie2)
                else if(mode == OCCUPATIONS) then
                   write(nf,'(" ik = ",i5," ",8f12.6)') ik, &
                        &           (o_mpi(nb,ik)/(qwgt(ik)*kv3/ndim_spinor),nb=ie1,ie2)
                end if
             else
                if(mode == EIGEN_VALUES) then
                   write(nf,'(12x,8f12.6)') (e_mpi(nb,ik),nb=ie1,ie2)
                else if(mode == OCCUPATIONS) then
                   write(nf,'(12x,8f12.6)') &
                        &      (o_mpi(nb,ik)/(qwgt(ik)*kv3/ndim_spinor),nb=ie1,ie2)
                end if
             end if
          end do
       end if
     end subroutine wd_k_and_efermi_vicinities

     subroutine wd_efermi()
       if(nf == 6) write(nf,'(" **** Eigen Values and Occupations ****")')
       write(nf,'(" ** iteration_ionic = ",i8, ", iteration_electronic = ",i8," **")') &
            & iteration_ionic, iteration_electronic
       write(nf,'(" EFermi = ",f16.8)') efermi
       if(sw_fix_total_spin == YES .and. nspin == 2) then
          write(nf,'(" Efermi_spin(1) = ",f16.8, ",  Efermi_spin(2) = ",f16.8)') &
               & efermi_spin(1), efermi_spin(2)
       end if
     end subroutine wd_efermi
  end subroutine m_ESIO_wd_EigenValues

  subroutine m_ESIO_wd_EigenValues_ek(nf,mode)
    integer, intent(in)              :: nf, mode

    real(kind=DP), parameter :: delta = 1.d-12
    real(kind=DP), allocatable, dimension(:) :: eko_t
    integer, allocatable, dimension(:)       :: neordr_t
    integer                     :: ik, ib,jb,ibo,jbo, neg_t

! =========================== added by K. Tagami ================ 11.0
    integer :: ikskip
! =============================================================== 11.0

    allocate(eko_t(neg))
    allocate(neordr_t(neg))
    eko_t = 0; neordr_t = 0

    if(mode == SCF .and. printable) write(nf,'(" ======  Energy Eigen Values ======")')
!!$    do ik = 1, kv3_ek
!!$    do ik = 1, nk_in_the_process

    if(printable) then
! ========================= modified by K. Tagami ============ 11.0
!       write(nf,'(" nk_converged = ",i8)') min(kv3_ek,nk_converged)
!       do ik = 1, kv3_ek
!          call wd_k_points
!       end do
       if ( noncol ) then
          write(nf,'(" nk_converged = ",i8)') min(kv3_ek,nk_converged) /ndim_spinor
          do ik = 1, kv3_ek, ndim_spinor
             call wd_k_points_noncl
          end do
       else
          write(nf,'(" nk_converged = ",i8)') min(kv3_ek,nk_converged)
          do ik = 1, kv3_ek
             call wd_k_points
          end do
       endif
! ============================================================= 11.0

       write(nf,'(" -----")')
    end if

! ====================== added by K. Tagami =================== 11.0
    if ( noncol ) then
       ikskip = ndim_spinor
    else
       ikskip = 1
    endif
! ============================================================ 11.0

! ============================ modified by K. Tagami ============ 11.0
!    do ik = 1, nk_converged
    do ik = 1, nk_converged, ikskip
! =============================================================== 11.0

!       if(sw_ekzaj == OFF .and. ik <= first_kpoint_in_this_job) cycle
       if(ik > kv3_ek) cycle
       if(mode == EK .and. printable) write(nf,'("=== energy eigenvalues ===")')
       eko_t = eko_ek(:,ik)
       if(nspin == 1 .or. (nspin == 2 .and. mod(ik,2) == 1)) &
            & neordr_t(1:neg) = (/(ib,ib=1,neg)/)
       do ib = 1, neg-1
          do jb = ib+1, neg
             ibo = neordr_t(ib)
             jbo = neordr_t(jb)
             if(eko_t(jbo)  < eko_t(ibo)-delta) then        ! MPI
                neordr_t(jb) = ibo
                neordr_t(ib) = jbo
             end if
          end do
       end do
       if(printable) then
! ================================ modified by K. Tagami ========== 11.0
!          call wd_k_points
          if ( noncol ) then
             call wd_k_points_noncl
          else
             call wd_k_points
          endif
! ================================================================= 11.0
          neg_t = neg

          if(neg_is_enlarged) neg_t = neg - num_extra_bands
          if(mode == SCF) then
             write(nf,'(5f16.8)') (eko_t(neordr_t(ib)),ib=1,neg_t)
          else
             write(nf,'(4f18.10)') (eko_t(neordr_t(ib)),ib=1,neg_t)
          end if
       end if
    end do

    deallocate(neordr_t);     deallocate(eko_t)

  contains

    subroutine wd_k_points
      integer :: j, k
      real(kind=DP) :: c1, vkxyz_wk(3)

      if ( sw_band_unfolding == ON ) then
         vkxyz_wk(1:3) = vkxyz_refcell(ik,1:3,BUCS)
      else
         vkxyz_wk(1:3) = vkxyz_ek(ik,1:3,BUCS)
      endif

      if(mode == SCF) then
         if(nspin == 1) then
            write(nf,'(i6,3f18.10)') ik, vkxyz_wk(1:3)
         else
            if(mod(ik,2) == 1) then
               write(nf,'(i6,"    UP ",3f18.10)') ik, vkxyz_wk(1:3)
            else
               write(nf,'(i6,"  DOWN ",3f18.10)') ik, vkxyz_wk(1:3)
            end if
         end if
      else
         if(nspin == 1) then
            write(nf,'(" ik = ",i8," (",3f10.6," )")') ik, vkxyz_wk(1:3)
         else
            if(mod(ik,2) == 1) then
               write(nf,'(" ik = ",i8," (",3f10.6," )    UP ")') ik, vkxyz_wk(1:3)
            else
               write(nf,'(" ik = ",i8," (",3f10.6," )  DOWN ")') ik, vkxyz_wk(1:3)
            end if
         end if
      end if

    end subroutine wd_k_points

! ============================== added by K. Tagami ==================== 11.0
    subroutine wd_k_points_noncl
      integer :: j, k
      real(kind=DP) :: c1, vkxyz_wk(3)

      if ( sw_band_unfolding == ON ) then
         vkxyz_wk(1:3) = vkxyz_refcell(ik,1:3,BUCS)
      else
         vkxyz_wk(1:3) = vkxyz_ek(ik,1:3,BUCS)
      endif

      if (mode == SCF) then
         write(nf,'(i6,3f18.10)') ik, vkxyz_wk(1:3)
      else
         write(nf,'(" ik = ",i8," (",3f10.6," )")') ik, vkxyz_wk(1:3)
      endif
    end subroutine wd_k_points_noncl
! ====================================================================== 11.0

  end subroutine m_ESIO_wd_EigenValues_ek

! ======================================= modified by K. Tagami ========== 11.0
!  subroutine m_ESIO_wd_vlhxc(nfvlc)
!
  subroutine m_ESIO_wd_vlhxc( nfvlc, ismax )
    integer, intent(in)              :: ismax
! ======================================================================= 11.0

    integer, intent(in)              :: nfvlc
    integer                          :: is, ik, i
    real(DP),allocatable, dimension(:,:,:):: vlhxc_mpi,vlhxc_mpi2

    if(npes >= 2) then

! ========================== modiifed by K. Tagami ============= 11.0
!       allocate(vlhxc_mpi(kgp,kimg,nspin)); vlhxc_mpi = 0.d0  ! MPI
!       allocate(vlhxc_mpi2(kgp,kimg,nspin))

       allocate(vlhxc_mpi(kgp,kimg,ismax));
       allocate(vlhxc_mpi2(kgp,kimg,ismax))
! ============================================================= 11.0
       vlhxc_mpi = 0.0d0;       vlhxc_mpi2 = 0.0d0

! ========================== modiifed by K. Tagami ============= 11.0
!       do is = 1, nspin
       do is = 1, ismax
! ============================================================== 11.0
          do ik = 1, kimg
             do i = ista_kngp, iend_kngp
                vlhxc_mpi(i,ik,is) = vlhxc_l(i,ik,is)
             end do
          end do
       end do

! ========================== modiifed by K. Tagami ====================== 11.0
!       call mpi_allreduce(vlhxc_mpi,vlhxc_mpi2,kgp*kimg*nspin &
!            &     , mpi_double_precision, mpi_sum, MPI_CommGroup,ierr)
       call mpi_allreduce( vlhxc_mpi, vlhxc_mpi2, kgp*kimg*ismax, &
            &              mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )
! ====================================================================== 11.0

       if (mype == 0) write(nfvlc) vlhxc_mpi2

       deallocate(vlhxc_mpi); deallocate(vlhxc_mpi2)
    else
       write(nfvlc) vlhxc_l
    end if
  end subroutine m_ESIO_wd_vlhxc

  subroutine m_ESIO_rd_WFs(nfout,nfzaj, F_ZAJ_partitioned, prev_zaj)
    integer, intent(in) :: nfout, nfzaj
    logical, intent(in) :: F_ZAJ_partitioned
    logical, intent(in), optional :: prev_zaj
    logical    :: pzaj
    integer    :: ik,ib,ri, i, ispin
    integer    :: id_sname = -1
    integer    :: ierror
    integer    :: kg1t
                                                  __TIMER_SUB_START(1372)
    call tstatc0_begin('m_ESIO_rd_WFs ',id_sname)
    pzaj = .false.
    if(present(prev_zaj)) pzaj = prev_zaj

    kg1t = kg1
    if(pzaj) then
      kg1t = kg1_prev
    endif
    if(precision_WFfile==SP) then
       if(ipri >= 1) write(nfout,*) ' !D Reading zaj (single_precision)'
    else
       if(ipri >= 1) write(nfout,*) ' !D Reading zaj (double_precision)'
    end if
    if(precision_WFfile==SP) then
       allocate(wf_l(kg1t,kimg)); wf_l = 0.d0
    else
       allocate(wfdp_l(kg1t,kimg)); wfdp_l = 0.d0
    end if
    rewind nfzaj
    if(F_ZAJ_partitioned) then
       do ik = ista_k, iend_k, af+1        ! MPI
                                                  __TIMER_IODO_START(1435)
          do ib = ista_e, iend_e, istep_e  ! MPI
             if(ib > neg_previous) cycle
                                                  __TIMER_IODO_START(1436)
           if(precision_WFfile==SP) then
             read(nfzaj) wf_l
                                                  __TIMER_IODO_STOP(1436)
             if(kimg == 1) then
                if(pzaj)then
                  do i = 1, kg1t
                     zaj_l_prev(i,map_z(ib),ik,1) = wf_l(i,1)
                  end do
                else
                  do i = 1, kg1t
                     zaj_l(i,map_z(ib),ik,1) = wf_l(i,1)
                  end do
                endif
             else if(kimg==2) then
                if(pzaj)then
                  do i = 1, kg1t
                     zaj_l_prev(i,map_z(ib),ik,1) = wf_l(i,1)
                     zaj_l_prev(i,map_z(ib),ik,2) = wf_l(i,2)
                  end do
                else
                  do i = 1, kg1t
                     zaj_l(i,map_z(ib),ik,1) = wf_l(i,1)
                     zaj_l(i,map_z(ib),ik,2) = wf_l(i,2)
                  end do
                endif
             end if
           else if(precision_WFfile==DP) then
             read(nfzaj) wfdp_l
                                                  __TIMER_IODO_STOP(1436)
             if(kimg == 1) then
                if(pzaj)then
                  do i = 1, kg1t
                     zaj_l_prev(i,map_z(ib),ik,1) = wfdp_l(i,1)
                  end do
                else
                  do i = 1, kg1t
                     zaj_l(i,map_z(ib),ik,1) = wfdp_l(i,1)
                  end do
                endif
             else if(kimg==2) then
                if(pzaj)then
                  do i = 1, kg1t
                     zaj_l_prev(i,map_z(ib),ik,1) = wfdp_l(i,1)
                     zaj_l_prev(i,map_z(ib),ik,2) = wfdp_l(i,2)
                  end do
                else
                  do i = 1, kg1t
                     zaj_l(i,map_z(ib),ik,1) = wfdp_l(i,1)
                     zaj_l(i,map_z(ib),ik,2) = wfdp_l(i,2)
                  end do
                endif
             end if

           end if
          end do
                                                  __TIMER_IODO_STOP(1435)
       end do
    else
#ifdef _DEBUG_ESIO_
       if(mype == 0) write(nfout,'("### zaj reading")')
#endif
       do ispin = 1, nspin, af+1
       !do ik = 1, kv3, af+1
       do ik = ispin, kv3-nspin+ispin, nspin
                                                  __TIMER_IODO_START(1437)
          do ib = 1, neg_previous
                                                  __TIMER_IODO_START(1438)
! -----------------
           if(precision_WFfile==SP) then
             if(mype == 0) read(nfzaj, end = 9999, err = 9999) wf_l  ! MPI
#ifdef _DEBUG_ESIO_
             if(mype == 0) then
                write(nfout,'(" ik = ",i3, " ib = ",i4)')  ik, ib
                write(nfout,'(8f8.4)') (wf_l(ri,1),ri=1,8)
             end if
#endif
                                                  __TIMER_IODO_STOP(1438)
                                                  __TIMER_IOCOMM_START_w_BARRIER(mpi_comm,1439)
                                                  __TIMER_IOCOMM_STOP(1439)
             if(mype == 0 .and. map_eks(ib,ik,ispin) /= 0) then ! MPI
                call mpi_send(wf_l,kg1t*kimg,mpi_real,map_eks(ib,ik,ispin),1,MPI_CommGroup,ierr) ! MPI
             else if(map_eks(ib,ik,ispin) == mype .and. map_eks(ib,ik,ispin) /= 0) then                  ! MPI
                call mpi_recv(wf_l,kg1t*kimg,mpi_real,0,1,MPI_CommGroup,istatus,ierr)     ! MPI
             end if
             if(map_eks(ib,ik,ispin) == mype) then              ! MPI
                if(pzaj)then
                  do ri = 1, kimg
                     zaj_l_prev(1:kg1t,map_z(ib),ik,ri) = wf_l(1:kg1t,ri)  ! MPI
                  end do
                else
                  do ri = 1, kimg
                     zaj_l(1:kg1t,map_z(ib),ik,ri) = wf_l(1:kg1t,ri)  ! MPI
                  end do
                endif
             end if

! -----------------
           else if(precision_WFfile==DP) then
             if(mype == 0) read(nfzaj, end = 9999, err = 9999) wfdp_l  ! MPI
#ifdef _DEBUG_ESIO_
             if(mype == 0) then
                write(nfout,'(" ik = ",i3, " ib = ",i4)')  ik, ib
                write(nfout,'(8f8.4)') (wfdp_l(ri,1),ri=1,8)
             end if
             call flush(nfout)
#endif
                                                  __TIMER_IODO_STOP(1438)
                                                  __TIMER_IOCOMM_START_w_BARRIER(mpi_comm,1439)
                                                  __TIMER_IOCOMM_STOP(1439)
             if(mype == 0 .and. map_eks(ib,ik,ispin) /= 0) then ! MPI
                call mpi_send(wfdp_l,kg1t*kimg,mpi_double_precision,map_eks(ib,ik,ispin),1,MPI_CommGroup,ierr) ! MPI
             else if(map_eks(ib,ik,ispin) == mype .and. map_eks(ib,ik,ispin) /= 0) then                  ! MPI
                call mpi_recv(wfdp_l,kg1t*kimg,mpi_double_precision,0,1,MPI_CommGroup,istatus,ierr)     ! MPI
             end if
             if(map_eks(ib,ik,ispin) == mype) then              ! MPI
                if(pzaj)then
                  do ri = 1, kimg
                     zaj_l_prev(1:kg1t,map_z(ib),ik,ri) = wfdp_l(1:kg1t,ri)  ! MPI
                  end do
                else
                  do ri = 1, kimg
                     zaj_l(1:kg1t,map_z(ib),ik,ri) = wfdp_l(1:kg1t,ri)  ! MPI
                  end do
                endif
             end if

           endif
! -----------------
          end do
                                                  __TIMER_IODO_STOP(1437)
       end do
       end do
    end if

    if(precision_WFfile==SP) then
       deallocate(wf_l)
    else if(precision_WFfile==DP) then
       deallocate(wfdp_l)
    end if
    call tstatc0_end(id_sname)
    return
9999 continue
    ierror = EOF_REACHED
    call phase_error_wo_filename(ierror, nfout, nfzaj, __LINE__, __FILE__)
                                                  __TIMER_SUB_STOP(1372)
  end subroutine m_ESIO_rd_WFs

! ==== EXP_CELLOPT ==== 2015/09/24
  subroutine m_ESIO_import_WFs_prev_cell(nfout,nfzaj, F_ZAJ_partitioned)
    integer, intent(in) :: nfout, nfzaj
    logical, intent(in) :: F_ZAJ_partitioned
    integer    :: ik,ib,ri, i
    integer    :: id_sname = -1
    integer    :: ierror

    call tstatc0_begin('m_ESIO_import_WFs_prev_cell ',id_sname)

    if(precision_WFfile==SP) then
       if(ipri >= 1) write(nfout,*) ' !D Reading zaj (single_precision)'
    else
       if(ipri >= 1) write(nfout,*) ' !D Reading zaj (double_precision)'
    end if
    if(precision_WFfile==SP) then
       allocate(wf_l(kg1_prev,kimg)); wf_l = 0.d0
    else
       allocate(wfdp_l(kg1_prev,kimg)); wfdp_l = 0.d0
    end if
    rewind nfzaj

    zaj_l = 0.0d0

    if(F_ZAJ_partitioned) then
       do ik = ista_k, iend_k, af+1        ! MPI

          do ib = ista_e, iend_e, istep_e  ! MPI
             if(ib > neg_previous) cycle

             if(precision_WFfile==SP) then
                read(nfzaj) wf_l

                if(kimg == 1) then
                   do i = 1, min( kg1, kg1_prev )
                      zaj_l(i,map_z(ib),ik,1) = wf_l(i,1)
                   end do
                else if(kimg==2) then
                   do i = 1, min( kg1, kg1_prev )
                      zaj_l(i,map_z(ib),ik,1) = wf_l(i,1)
                      zaj_l(i,map_z(ib),ik,2) = wf_l(i,2)
                   end do
                end if
             else if(precision_WFfile==DP) then
                read(nfzaj) wfdp_l

                if(kimg == 1) then
                   do i = 1, min( kg1, kg1_prev )
                      zaj_l(i,map_z(ib),ik,1) = wfdp_l(i,1)
                   end do
                else if(kimg==2) then
                   do i = 1, min( kg1, kg1_prev )
                      zaj_l(i,map_z(ib),ik,1) = wfdp_l(i,1)
                      zaj_l(i,map_z(ib),ik,2) = wfdp_l(i,2)
                   end do
                end if

             end if
          end do
       end do
    else

       do ik = 1, kv3, af+1
          do ib = 1, neg_previous
             ! -----------------
             if(precision_WFfile==SP) then
                if(mype == 0) read(nfzaj, end = 9999, err = 9999) wf_l
                if(mype == 0 .and. map_ek(ib,ik) /= 0) then
                   call mpi_send(wf_l,kg1_prev*kimg,mpi_real,map_ek(ib,ik),1,MPI_CommGroup,ierr) ! MPI
                else if(map_ek(ib,ik) == mype .and. map_ek(ib,ik) /= 0) then
                   call mpi_recv(wf_l,kg1_prev*kimg,mpi_real,0,1,MPI_CommGroup,istatus,ierr)     ! MPI
                end if
                if(map_ek(ib,ik) == mype) then              ! MPI
                   do ri = 1, kimg
                      do i = 1, min( kg1, kg1_prev )
                         zaj_l(i,map_z(ib),ik,ri) = wf_l(i,ri)  ! MPI
                      end do
                   end do
                end if

                ! -----------------
             else if(precision_WFfile==DP) then
                if(mype == 0) read(nfzaj, end = 9999, err = 9999) wfdp_l
                if(mype == 0 .and. map_ek(ib,ik) /= 0) then
                   call mpi_send(wfdp_l,kg1_prev*kimg,mpi_double_precision,map_ek(ib,ik),1,MPI_CommGroup,ierr) ! MPI
                else if(map_ek(ib,ik) == mype .and. map_ek(ib,ik) /= 0) then
                   call mpi_recv(wfdp_l,kg1_prev*kimg,mpi_double_precision,0,1,MPI_CommGroup,istatus,ierr)     ! MPI
                end if
                if(map_ek(ib,ik) == mype) then              ! MPI
                   do i = 1, min( kg1, kg1_prev )
                      zaj_l(i,map_z(ib),ik,ri) = wfdp_l(i,ri)  ! MPI
                   end do
                end if
             endif
             ! -----------------
          end do
       end do
    end if
!
    if(precision_WFfile==SP) then
       deallocate(wf_l)
    else if(precision_WFfile==DP) then
       deallocate(wfdp_l)
    end if
    call tstatc0_end(id_sname)
    return
9999 continue
    ierror = EOF_REACHED
    call phase_error_wo_filename(ierror, nfout, nfzaj, __LINE__, __FILE__)
  end subroutine m_ESIO_import_WFs_prev_cell
! ===================== 2015/09/24

! ==================================== added by K. Tagami =============== 11.0
  subroutine m_ESIO_rd_WFs_import_frm_collin(nfout,nfzaj, F_ZAJ_partitioned)
    use m_Crystal_Structure,  only : sw_fix_global_quantz_axis, &
         &                           Global_Quantz_Axis_Fixed
    use m_Const_Parameters,   only : zi

    integer, intent(in) :: nfout, nfzaj
    logical, intent(in) :: F_ZAJ_partitioned

    integer :: neg_to_be_read
    integer    :: id_sname = -1
    call tstatc0_begin('m_ESIO_rd_WFs_import_frm_collin ',id_sname)

    if(precision_WFfile==SP) then
       allocate(wf_l(kg1,kimg))   ;       wf_l = 0
    else
       allocate(wfdp_l(kg1,kimg)) ;       wfdp_l = 0
    end if

    rewind nfzaj
    if(ipri >= 1) write(nfout,*) ' !D Reading zaj'

    zaj_l = 0.0d0

    if(F_ZAJ_partitioned) then
       write(*,*) &
            & 'Not supported : importing collinear Wfns  when F_ZAJ_partitioned = true'

    else
       neg_to_be_read = neg / 2

       write(nfout,*) '******************************** '
       write(nfout,*) '!! Collinear wavefunctions are used. '
       write(nfout,*) '!! neg_to_be_read is assumed to be ', neg_to_be_read
       write(nfout,*) '******************************** '

       if ( previous_nspin_collinear == 1 ) then
          call case_previous_nspin_eq_1
       else if ( previous_nspin_collinear == 2 ) then
          call case_previous_nspin_eq_2
       endif

    end if

    if(precision_WFfile==SP) then
       deallocate(wf_l)
    else if(precision_WFfile==DP) then
       deallocate(wfdp_l)
    end if
    call tstatc0_end(id_sname)

  contains

    subroutine case_previous_nspin_eq_2
      integer :: ik, ib, ri, i
      integer :: ib_0, is, ig
      real(kind=DP) :: spn_quant_dir(3), theta, phi
      complex(kind=CMPLDP) :: rotated_spinor(2,2), z1, z2, ztmp1, ztmp2

      do ik = 1, kv3, ndim_spinor
         Do is=1, ndim_spinor
            do ib_0 = 1, previous_nband_collinear
               ib = ( ib_0 -1 )*ndim_spinor + is
               if(precision_WFfile==SP) then
                  if(mype == 0) read(nfzaj) wf_l

                  if(mype == 0 .and. map_ek(ib,ik) /= 0) then
                     call mpi_send( wf_l, kg1*kimg, mpi_real, map_ek(ib,ik), 1, &
                          &         MPI_CommGroup, ierr )
                  else if(map_ek(ib,ik) == mype .and. map_ek(ib,ik) /= 0 ) then
                     call mpi_recv( wf_l, kg1*kimg, mpi_real, 0, 1, &
                          &         MPI_CommGroup, istatus, ierr )
                  end if

                  if ( ib_0 > neg_to_be_read ) cycle

                  if(map_ek(ib,ik) == mype) then              ! MPI
                     do ri = 1, kimg
                        zaj_l(1:kg1,map_z(ib),ik+is-1,ri) = wf_l(1:kg1,ri)  ! MPI
                     end do
                  end if
               else if(precision_WFfile==DP) then
                  if(mype == 0) read(nfzaj) wfdp_l

                  if(mype == 0 .and. map_ek(ib,ik) /= 0) then
                     call mpi_send( wfdp_l, kg1*kimg, mpi_double_precision, map_ek(ib,ik), 1, MPI_CommGroup, ierr )
                  else if(map_ek(ib,ik) == mype .and. map_ek(ib,ik) /= 0 ) then
                     call mpi_recv( wfdp_l, kg1*kimg, mpi_double_precision, 0, 1, MPI_CommGroup, istatus, ierr )
                  end if

                  if ( ib_0 > neg_to_be_read ) cycle

                  if(map_ek(ib,ik) == mype) then              ! MPI
                     do ri = 1, kimg
                        zaj_l(1:kg1,map_z(ib),ik+is-1,ri) = wfdp_l(1:kg1,ri)  ! MPI
                     end do
                  end if
               end if
            end do
         End Do
      end do
      if ( sw_fix_global_quantz_axis == ON ) then
         spn_quant_dir(1:3) = Global_Quantz_Axis_Fixed(1:3)
         theta = acos( spn_quant_dir(3) )
         phi = atan2( spn_quant_dir(2), spn_quant_dir(1) )

         rotated_spinor(1,1) =  exp( -zi *phi /2.0d0 ) *cos( theta /2.0d0 )
         rotated_spinor(2,1) =  exp(  zi *phi /2.0d0 ) *sin( theta /2.0d0 )

         rotated_spinor(1,2) = -exp( -zi *phi /2.0d0 ) *sin( theta /2.0d0 )
         rotated_spinor(2,2) =  exp(  zi *phi /2.0d0 ) *cos( theta /2.0d0 )

         do ik = 1, kv3, ndim_spinor
            if ( map_k(ik) /= myrank_k ) cycle
            Do ig=1, kg1
               Do ib=1, np_e
                  z1 = dcmplx( zaj_l(ig,ib,ik,  1), zaj_l(ig,ib,ik,  kimg) )
                  z2 = dcmplx( zaj_l(ig,ib,ik+1,1), zaj_l(ig,ib,ik+1,kimg) )
                  ztmp1 = rotated_spinor(1,1) *z1 +rotated_spinor(2,1) *z2
                  ztmp2 = rotated_spinor(1,2) *z1 +rotated_spinor(2,2) *z2
                  zaj_l(ig,ib,ik,1)      = real(ztmp1)
                  zaj_l(ig,ib,ik,kimg)   = aimag(ztmp1)
                  zaj_l(ig,ib,ik+1,1)    = real(ztmp2)
                  zaj_l(ig,ib,ik+1,kimg) = aimag(ztmp2)
               End Do
            End Do
         end do
      end if
    end subroutine case_previous_nspin_eq_2

    subroutine case_previous_nspin_eq_1
      integer :: ik, ib, ri, i
      integer :: ib_0, is

      do ik = 1, kv3, ndim_spinor
         do ib_0 = 1, previous_nband_collinear
            if(precision_WFfile==SP) then
               if(mype == 0) read(nfzaj) wf_l              ! MPI

               Do is=1, ndim_spinor
                  ib = ( ib_0 -1 )*ndim_spinor + is
                  if(mype == 0 .and. map_ek(ib,ik) /= 0) then ! MPI
                     call mpi_send( wf_l, kg1*kimg, mpi_real, map_ek(ib,ik), 1, &
                          &         MPI_CommGroup, ierr ) ! MPI
                  else if(map_ek(ib,ik) == mype .and. map_ek(ib,ik) /= 0 ) then     ! MPI
                     call mpi_recv( wf_l, kg1*kimg, mpi_real, 0, 1, &
                          &         MPI_CommGroup, istatus, ierr )     ! MPI
                  end if

                  if ( ib_0 > neg_to_be_read ) cycle

                  if(map_ek(ib,ik) == mype) then              ! MPI
                     do ri = 1, kimg
                        zaj_l(1:kg1,map_z(ib),ik+is-1,ri) = wf_l(1:kg1,ri)  ! MPI
                     end do
                  end if

               end do
            else
               Do is=1, ndim_spinor
                  ib = ( ib_0 -1 )*ndim_spinor + is
                  if(mype == 0 .and. map_ek(ib,ik) /= 0) then
                     call mpi_send( wfdp_l, kg1*kimg, mpi_double_precision, map_ek(ib,ik), 1, MPI_CommGroup, ierr )
                  else if(map_ek(ib,ik) == mype .and. map_ek(ib,ik) /= 0 ) then
                     call mpi_recv( wfdp_l, kg1*kimg, mpi_double_precision, 0, 1, MPI_CommGroup, istatus, ierr )
                  end if

                  if ( ib_0 > neg_to_be_read ) cycle

                  if(map_ek(ib,ik) == mype) then              ! MPI
                     do ri = 1, kimg
                        zaj_l(1:kg1,map_z(ib),ik+is-1,ri) = wfdp_l(1:kg1,ri)  ! MPI
                     end do
                  end if

               end do
            end if
         End Do
      end do
    end subroutine case_previous_nspin_eq_1

  end subroutine m_ESIO_rd_WFs_import_frm_collin
!===================================================================== 11.0

  subroutine m_ESIO_wd_WFs(nfout,nfzaj,F_ZAJ_partitioned,rew)
    integer, intent(in) :: nfout,nfzaj
    logical, intent(in) :: F_ZAJ_partitioned
    logical, intent(in), optional :: rew
    integer :: ik,ib,ri, ispin
    integer :: id_sname = -1
    call tstatc0_begin('m_ESIO_wd_WFs ',id_sname)

! -------------------- T. Hamada 2021.9.22 --------------------
   if(precision_WFfile == 0) return                  ! UVSOR
! -------------------------------------------------------------
   if(precision_WFfile==SP) then
    allocate(wf_l(kg1,kimg));    wf_l = 0
    call mpi_barrier(MPI_CommGroup,ierr)
    !!$ print *, ' !D Writing zaj '
    if(ipri >= 1) write(nfout,*) ' !D Writing zaj (single_precision)'
    if (present(rew)) then
      if(rew) then
        rewind nfzaj
      endif
    else
      rewind nfzaj
    endif
    if(F_ZAJ_partitioned) then
       do ik = ista_k, iend_k, af+1        ! MPI
          do ib = ista_e, iend_e, istep_e  ! MPI
             do ri = 1, kimg
                wf_l(1:kg1,ri) = zaj_l(1:kg1,map_z(ib),ik,ri)
             end do
             write(nfzaj) wf_l
          end do
       end do
    else
#ifdef _DEBUG_ESIO_
       if(mype == 0) write(nfout,'("### zaj writing")')
#endif
       do ispin = 1, nspin, af+1
       !do ik = 1, kv3, af+1
       do ik = ispin, kv3-nspin+ispin, nspin
          do ib = 1, neg
             !if(map_ek(ib,ik) == mype) then                          ! MPI
             if(map_eks(ib,ik,ispin) == mype) then                          ! MPI
                do ri = 1, kimg
                   wf_l(1:kg1,ri) = zaj_l(1:kg1,map_z(ib),ik,ri)
                end do
                if(map_eks(ib,ik,ispin) /= 0) &                             ! MPI
                     &   call mpi_send(wf_l,kg1*kimg,mpi_real,0,1,MPI_CommGroup,ierr) ! MPI
             else if(mype == 0 .and. map_eks(ib,ik,ispin) /= 0) then
                call mpi_recv(wf_l,kg1*kimg,mpi_real,map_eks(ib,ik,ispin),1,MPI_CommGroup,istatus,ierr)!MPI
             end if
             if(mype == 0) write(nfzaj)  wf_l                        ! MPI
#ifdef _DEBUG_ESIO_
             if(mype == 0) then
                write(nfout,'(" ik = ",i4, " ib = ",i5)')  ik, ib
                write(nfout,'(8f8.4)') (wf_l(ri,1),ri=1,8)
             end if
#endif
          end do
       end do
       end do
    end if
    deallocate(wf_l)
   else if(precision_WFfile==DP) then
    allocate(wfdp_l(kg1,kimg));    wfdp_l = 0
    call mpi_barrier(MPI_CommGroup,ierr)
    if(ipri >= 1) write(nfout,*) ' !D Writing zaj (double_precision) '
    if (present(rew)) then
      if(rew) then
        rewind nfzaj
      endif
    else
      rewind nfzaj
    endif
    if(F_ZAJ_partitioned) then
       do ik = ista_k, iend_k, af+1
          do ib = ista_e, iend_e, istep_e
             do ri = 1, kimg
                wfdp_l(1:kg1,ri) = zaj_l(1:kg1,map_z(ib),ik,ri)
             end do
             write(nfzaj) wfdp_l
          end do
       end do
    else
#ifdef _DEBUG_ESIO_
       if(mype == 0) write(nfout,'("### zaj writing")')
#endif
       do ispin = 1, nspin, af+1
       !do ik = 1, kv3, af+1
       do ik = ispin, kv3-nspin+ispin, nspin
          do ib = 1, neg
             if(map_eks(ib,ik,ispin) == mype) then
                do ri = 1, kimg
                   wfdp_l(1:kg1,ri) = zaj_l(1:kg1,map_z(ib),ik,ri)
                end do
                if(map_eks(ib,ik,ispin) /= 0) &
                     &   call mpi_send(wfdp_l,kg1*kimg,mpi_double_precision,0,1,MPI_CommGroup,ierr)
             else if(mype == 0 .and. map_eks(ib,ik,ispin) /= 0) then
                call mpi_recv(wfdp_l,kg1*kimg,mpi_double_precision,map_eks(ib,ik,ispin),1,MPI_CommGroup,istatus,ierr)
             end if
             if(mype == 0) write(nfzaj)  wfdp_l
#ifdef _DEBUG_ESIO_
             if(mype == 0) then
                write(nfout,'(" ik = ",i4, " ib = ",i5)')  ik, ib
                write(nfout,'(8f8.4)') (wfdp_l(ri,1),ri=1,8)
             end if
#endif
          end do
       end do
       end do
    end if
    deallocate(wfdp_l)
   end if
    call tstatc0_end(id_sname)
  end subroutine m_ESIO_wd_WFs

  subroutine m_ESIO_wd_WFs_standardout(nfout,ipriwf)
    integer, intent(in) :: nfout,ipriwf
    integer :: ik,ib,ri, i, ic, ipriwf0, icycle, icolumn, max_elements, istart, iend
    integer :: id_sname = -1
    real(kind=DP) :: phase2r, phase2i, phaser,phasei
    complex(kind=CMPLDP) :: exp2theta, exptheta
    call tstatc0_begin('m_ESIO_wd_WFs_stndout ',id_sname)

    ipriwf0 = ipriwf
    if(npes > 1) call mpi_bcast(ipriwf0,1,mpi_integer,0,MPI_CommGroup,ierr)

    if(ipriwf0 >= 2) then
       icolumn = 10
       if(precision_WFfile==SP) then
          allocate(wf_l(kg1,kimg+3)); wf_l = 0.d0
       else
          allocate(wfdp_l(kg1,kimg+3)); wfdp_l = 0.d0
       end if
       call mpi_barrier(MPI_CommGroup,ierr)
       if(mype == 0)  write(nfout,*) ' !wf Writing zaj '

       do ik = 1, kv3, af+1
          max_elements = iba(ik)
          if(mype == 0) write(nfout,'(" !wf   ik = ",i5)') ik
          do ib = 1, neg
             if(mype == 0) write(nfout,'(" !wf   ib = ",i5)') ib
           if(precision_WFfile==SP) then
             if(map_ek(ib,ik) == mype) then                          ! MPI
                do ri = 1, kimg
                   wf_l(1:kg1,ri) = zaj_l(1:kg1,map_z(ib),ik,ri)
                end do
                if(map_ek(ib,ik) /= 0) &                             ! MPI
                     &   call mpi_send(wf_l,kg1*kimg,mpi_real,0,1,MPI_CommGroup,ierr) ! MPI
             else if(mype == 0 .and. map_ek(ib,ik) /= 0) then
                call mpi_recv(wf_l,kg1*kimg,mpi_real,map_ek(ib,ik),1,MPI_CommGroup,istatus,ierr)!MPI
             end if
           else
             if(map_ek(ib,ik) == mype) then                          ! MPI
                do ri = 1, kimg
                   wfdp_l(1:kg1,ri) = zaj_l(1:kg1,map_z(ib),ik,ri)
                end do
                if(map_ek(ib,ik) /= 0) &                             ! MPI
                     &   call mpi_send(wfdp_l,kg1*kimg,mpi_double_precision,0,1,MPI_CommGroup,ierr) ! MPI
             else if(mype == 0 .and. map_ek(ib,ik) /= 0) then
                call mpi_recv(wfdp_l,kg1*kimg,mpi_double_precision,map_ek(ib,ik),1,MPI_CommGroup,istatus,ierr)!MPI
             end if
           end if
             if(mype == 0) then
                if(kimg == 2) then
                 if(precision_WFFile==SP) then
                   do i = 1, iba(ik)
                      wf_l(i,3) = wf_l(i,1)**2 + wf_l(i,2)**2
                   end do
                 else
                   do i = 1, iba(ik)
                      wfdp_l(i,3) = wfdp_l(i,1)**2 + wfdp_l(i,2)**2
                   end do
                 end if
                   if(k_symmetry(ik) == GAMMA .or. k_symmetry(ik) == GAMMA_base_symmetrization) then
                    if(precision_WFfile==SP) then
                      phase2r = (wf_l(1,1)**2 - wf_l(1,2)**2)/wf_l(1,3)
                      phase2i = -2.d0*wf_l(1,1)*wf_l(1,2)/wf_l(1,3)
                    else
                      phase2r = (wfdp_l(1,1)**2 - wfdp_l(1,2)**2)/wfdp_l(1,3)
                      phase2i = -2.d0*wfdp_l(1,1)*wfdp_l(1,2)/wfdp_l(1,3)
                    end if
                      exp2theta = cmplx(phase2r, phase2i)
                      exptheta = sqrt(exp2theta)
                      phaser = real(exptheta)
                      phasei = imag(exptheta)
                      write(nfout,'(" !wf exp2theta = ",2d20.8)') exp2theta
                      write(nfout,'(" !wf           = ",2d20.8)') phase2r, phase2i
                      write(nfout,'(" !wf |exp2theta|**2 = ",d20.8)') dsqrt(phase2r**2 + phase2i**2)
                      write(nfout,'(" !wf exptheta  = ",2d20.8)') exptheta
                      write(nfout,'(" !wf |exptheta| = ",d20.8)') abs(exptheta)
                     if(precision_WFfile==SP) then
                      do i = 1, iba(ik)
!!$                      wf_l(i,4) = real(exptheta*cmplx(wf_l(i,1),wf_l(i,2)))
!!$                      wf_l(i,5) = imag(exptheta*cmplx(wf_l(i,1),wf_l(i,2)))
                         wf_l(i,4) = phaser*wf_l(i,1) - phasei*wf_l(i,2)
                         wf_l(i,5) = phaser*wf_l(i,2) + phasei*wf_l(i,1)
                      end do
                     else
                      do i = 1, iba(ik)
                         wfdp_l(i,4) = phaser*wfdp_l(i,1) - phasei*wfdp_l(i,2)
                         wfdp_l(i,5) = phaser*wfdp_l(i,2) + phasei*wfdp_l(i,1)
                      end do
                     end if
                   end if
                else
                 if(precision_WFfile==SP) then
                   do i = 1, iba(ik)
                      wf_l(i,2) = wf_l(i,1)**2
                   end do
                 else
                   do i = 1, iba(ik)
                      wfdp_l(i,2) = wfdp_l(i,1)**2
                   end do
                 end if
                   exp2theta = 1.d0
                   exptheta = 1.d0
                end if
                icycle = ceiling(dble(min(max_elements,iba(ik)))/icolumn)
                istart = 1
                do ic = 1, icycle
                   iend = min(istart+icolumn-1,max_elements,iba(ik))
                   write(nfout,'(" !wf (nx)    ",10i10)') (ngabc(nbase(i,ik),1),i=istart,iend)
                   write(nfout,'(" !wf (ny)    ",10i10)') (ngabc(nbase(i,ik),2),i=istart,iend)
                   write(nfout,'(" !wf (nz)    ",10i10)') (ngabc(nbase(i,ik),3),i=istart,iend)
                 if(precision_WFfile==SP) then
                   write(nfout,'(" !wf (zaj-r) ",10d10.2)') (wf_l(i,1),i=istart,iend)
                   if(kimg == 2) write(nfout,'(" !wf (zaj-i) ",10d10.2)') (wf_l(i,2),i=istart,iend)
                   write(nfout,'(" !wf abs     ",10d10.2)') (wf_l(i,kimg+1),i=istart,iend)
                   if(kimg == 2) then
                      if(k_symmetry(ik) == GAMMA .or. k_symmetry(ik) == GAMMA_base_symmetrization) then
                         write(nfout,'(" !wf (zaj-r)d",10d10.2)') (wf_l(i,4),i=istart,iend)
                         write(nfout,'(" !wf (zaj-i)d",10d10.2)') (wf_l(i,5),i=istart,iend)
                      end if
                   end if
                 else
                   write(nfout,'(" !wf (zaj-r) ",10d10.2)') (wfdp_l(i,1),i=istart,iend)
                   if(kimg == 2) write(nfout,'(" !wf (zaj-i) ",10d10.2)') (wfdp_l(i,2),i=istart,iend)
                   write(nfout,'(" !wf abs     ",10d10.2)') (wfdp_l(i,kimg+1),i=istart,iend)
                   if(kimg == 2) then
                      if(k_symmetry(ik) == GAMMA .or. k_symmetry(ik) == GAMMA_base_symmetrization) then
                         write(nfout,'(" !wf (zaj-r)d",10d10.2)') (wfdp_l(i,4),i=istart,iend)
                         write(nfout,'(" !wf (zaj-i)d",10d10.2)') (wfdp_l(i,5),i=istart,iend)
                      end if
                   end if
                 end if
                   istart = iend+1
                end do
             end if
          end do
       end do
      if(precision_WFfile==SP) then
       deallocate(wf_l)
      else
       deallocate(wfdp_l)
      end if
    end if
    call tstatc0_end(id_sname)
  end subroutine m_ESIO_wd_WFs_standardout

  subroutine m_ESIO_rd_next_wfs_ek(ik,nfout,nfzaj)
    integer, intent(in) :: ik
    integer, intent(in) :: nfout,nfzaj
    integer :: ib, ri, j, ierror
    if(precision_WFfile==SP) then
       allocate(wf_l(kg1,kimg)); wf_l = 0_sp
    else
       allocate(wfdp_l(kg1,kimg)); wfdp_l = 0.d0
    end if
!    zaj_l(:,:,ik,:) = 0.d0
    do ib = 1, neg
! -----------------
       if(precision_WFfile==SP) then
          if(mype == 0) read(nfzaj, end = 9999, err = 9999) wf_l  ! MPI
          if(mype == 0 .and. map_ek(ib,ik) /= 0) then ! MPI
             call mpi_send(wf_l,kg1*kimg,mpi_real4,map_ek(ib,ik),1,MPI_CommGroup,ierr) ! MPI
          else if(map_ek(ib,ik) == mype .and. map_ek(ib,ik) /= 0) then                  ! MPI
             call mpi_recv(wf_l,kg1*kimg,mpi_real4,0,1,MPI_CommGroup,istatus,ierr)     ! MPI
          end if
          if(map_ek(ib,ik) == mype) then              ! MPI
            do ri = 1, kimg
               zaj_l(1:kg1,map_z(ib),ik,ri) = wf_l(1:kg1,ri)  ! MPI
            end do
          end if

! -----------------
       else if(precision_WFfile==DP) then
          if(mype == 0) read(nfzaj, end = 9999, err = 9999) wfdp_l  ! MPI
          if(mype == 0 .and. map_ek(ib,ik) /= 0) then ! MPI
             call mpi_send(wfdp_l,kg1*kimg,mpi_double_precision,map_ek(ib,ik),1,MPI_CommGroup,ierr) ! MPI
          else if(map_ek(ib,ik) == mype .and. map_ek(ib,ik) /= 0) then                  ! MPI
             call mpi_recv(wfdp_l,kg1*kimg,mpi_double_precision,0,1,MPI_CommGroup,istatus,ierr)     ! MPI
          end if
          if(map_ek(ib,ik) == mype) then              ! MPI
            do ri = 1, kimg
               zaj_l(1:kg1,map_z(ib),ik,ri) = wfdp_l(1:kg1,ri)  ! MPI
            end do
          end if
       endif
    end do

    if(precision_WFfile==SP) then
       deallocate(wf_l)
    else
       deallocate(wfdp_l)
    end if

    return

9999 continue
    ierror = EOF_REACHED
    call phase_error_wo_filename(ierror, nfout, nfzaj, __LINE__, __FILE__)
  end subroutine m_ESIO_rd_next_wfs_ek

  subroutine m_ESIO_rd_WFs_and_EVs_ek(nfout,nf)
    integer, intent(in) :: nfout,nf
    integer  :: ik, ie, iks, ri, ikg, ikt, ike, ike2
    integer, allocatable, dimension(:,:) :: n_mpi, n2_mpi  ! MPI
    real(DP),allocatable, dimension(:,:) :: e_mpi, e2_mpi  ! MPI
!!$    read(nf) neordr,nrvf_ordr,eko_l,occup_l,efermi,totch

    allocate(n_mpi(neg,nspin)); allocate(n2_mpi(neg,nspin)) ! MPI
    allocate(e_mpi(neg,nspin)); allocate(e2_mpi(neg,nspin)) ! MPI
    allocate(wf_l(kg1,kimg))

    n_mpi =0; n2_mpi = 0
    e_mpi =0; e2_mpi = 0; wf_l = 0
    if(ipri >= 1) write(nfout,*) ' !D Reading zaj'

    rewind nf

    eko_ek = 0.d0
!!$    do ik = 1, nk_in_the_process-kv3, kv3
    do ik = 1, nk_in_the_process - nspin, nspin
       if(ipri >= 1) write(nfout,*) ' !D     skipping ik = ', ik
!!$       do iks = 1, kv3, af+1
       do iks = 1, nspin, af+1
          do ie = 1, neg
             if(mype == 0) read(nf) wf_l
          end do
       end do
       if(mype == 0) read(nf) n_mpi
       if(mype == 0) read(nf) n2_mpi
       if(mype == 0) read(nf) e_mpi

       if(mype == 0) then
!!$          do iks = 1, kv3
          do iks = 1, nspin
             do ie = 1, neg
                eko_ek(ie,ik+iks-1) = e_mpi(n_mpi(ie,iks),iks)
             end do
          end do
          if(ipri >= 3) then
!!$             do iks=1,kv3
             do iks=1,nspin
                write(nfout,'(" ik = ",i5)') ik+iks-1
                write(nfout,'(8f8.4)') (e_mpi(n_mpi(ie,iks),iks),ie=1,neg)
             end do
          end if
       end if
    end do

    if(nk_in_the_process > kv3_ek) goto 1001

!!$    do ik = 1, kv3, af+1
    KPOINT_LOOP: do ikg = 1, nrank_k
       do ikt = 1, nspin, af+1
          ik = (ikg-1)*nspin+ikt
          if(nk_in_the_process -1 + ik > kv3_ek) exit KPOINT_LOOP
          if(nk_in_the_process -1 + ik > numk_zajsaved) exit KPOINT_LOOP
          if(ipri>=1) write(nfout,*) ' !D     reading  ik = ', ik+first_kpoint_in_this_job-1

          do ie = 1, neg
             if(ipri>=2) write(nfout,*) ' !D     ie = ', ie
             if(mype == 0) read(nf,err=2,end=2) wf_l     ! MPI
             if(mype == 0 .and. map_ek(ie,ik) /= 0) then ! MPI
                call mpi_send(wf_l,kg1*kimg,mpi_real4,map_ek(ie,ik),1,MPI_CommGroup,ierr) ! MPI
             else if(map_ek(ie,ik) == mype .and. map_ek(ie,ik) /= 0) then                  ! MPI
                call mpi_recv(wf_l,kg1*kimg,mpi_real4,0,1,MPI_CommGroup,istatus,ierr)     ! MPI
             end if
             if(map_ek(ie,ik) == mype) then              ! MPI
                do ri = 1, kimg
                   zaj_l(1:kg1,map_z(ie),ik,ri) = wf_l(1:kg1,ri)  ! MPI
                end do
             end if
          end do
       end do

       if(mype == 0) read(nf) n_mpi                ! MPI
       if(mype == 0) read(nf) n2_mpi               ! MPI
       call mpi_bcast(n_mpi,neg*nspin,mpi_integer,0,MPI_CommGroup,ierr) ! MPI
       call mpi_bcast(n2_mpi,neg*nspin,mpi_integer,0,MPI_CommGroup,ierr)! MPI

       do ikt = 1, nspin                             ! MPI
          ik = (ikg-1)*nspin + ikt
          if(map_k(ik) == myrank_k) then
             neordr(1:neg,ik) = n_mpi(1:neg,ikt)     ! MPI
             nrvf_ordr(1:neg,ik) = n2_mpi(1:neg,ikt) ! MPI
          end if
       end do                                        ! MPI

       if(mype == 0) read(nf) e_mpi                ! MPI
       call mpi_bcast(e_mpi,neg*nspin,mpi_double_precision,0,MPI_CommGroup,ierr) ! MPI

       do ikt = 1, nspin                                   ! MPI
          ik = (ikg-1)*nspin + ikt
          do ie = 1, neg                                   ! MPI
             if(map_ek(ie,ik) == mype) then                ! MPI
                eko_l(map_z(ie),ik) = e_mpi(ie,ikt)        ! MPI
             end if                                        ! MPI
          end do                                           ! MPI
          do ie = 1, neg
             eko_ek(ie,nk_in_the_process+ik-1) = e_mpi(n_mpi(ie,ikt),ikt)
          end do
       end do                                              ! MPI
       goto 3
2      continue
       call phase_error_with_msg(nfout, ' eof from nf <<m_ESIO_rd_WFs_and_EVs_ek>>',__LINE__,__FILE__)
3      continue
    end do KPOINT_LOOP

    if(ipri>=2) write(nfout,*) ' !D     ikg  = ', ikg
!!$    if(ikg <= 1) stop ' ikg <= 1 <<m_ESIO_rd_WFs_and_EVs_ek>>'
    if(ikg < nrank_k .and. ikg > 1 ) then
       do ike = ikg, nrank_k
          if(ipri>=2) write(nfout,*) ' !D     ike  = ', ike
          if(ipri>=2) write(nfout,*) ' !D     zaj_l'
          do ikt = 1, nspin, af+1
             ik   = (ikg-2)*nspin+ikt
             ike2 = (ike-1)*nspin+ikt
             if(ipri>=2) write(nfout,*) ' !D     ik, ike2 = ',ik,ike2
             do ie = 1, neg
                if(map_ek(ie,ik) == mype) then
                   do ri = 1, kimg
                      wf_l(1:kg1,ri) = zaj_l(1:kg1,map_z(ie),ik,ri)
                   end do
                end if

                if(map_ek(ie,ik) == mype) then
                   call mpi_send(wf_l,kg1*kimg,mpi_real4,map_ek(ie,ike2),1,MPI_CommGroup,ierr)
                else if(map_ek(ie,ike2) == mype) then
                   call mpi_recv(wf_l,kg1*kimg,mpi_real4,map_ek(ie,ik),1,MPI_CommGroup,istatus,ierr)
                end if
                if(map_ek(ie,ike2) == mype) then
                   do ri = 1, kimg
                      zaj_l(1:kg1,map_z(ie),ike2,ri) = wf_l(1:kg1,ri)
                   end do
                end if
             end do
          end do

          ! ---> neordr, nrvf_ordr
          do ikt = 1, nspin
             ik = (ikg-2)*nspin+ikt
             if(map_k(ik) == myrank_k) then
                n_mpi(1:neg,ikt) = neordr(1:neg,ik)
                n2_mpi(1:neg,ikt) = nrvf_ordr(1:neg,ik)
             end if
          end do
          call mpi_bcast(n_mpi,neg*nspin,mpi_integer,map_k(ik),MPI_CommGroup,ierr)
          call mpi_bcast(n2_mpi,neg*nspin,mpi_integer,map_k(ik),MPI_CommGroup,ierr)

          if(ipri>=2) write(nfout,*) ' !D     neordr and nrvf_ordr'
          do ikt = 1, nspin
             ike2 = (ike-1)*nspin+ikt
             if(map_k(ike2) == myrank_k) then
                neordr(1:neg,ike2) = n_mpi(1:neg,ikt)     ! MPI
                nrvf_ordr(1:neg,ike2) = n2_mpi(1:neg,ikt) ! MPI
             end if
          end do

          ! ---> eko_l
          if(ipri>=2) write(nfout,*) ' !D     eko_l'
          e_mpi = 0.d0
          do ikt = 1, nspin
             ik = (ikg-2)*nspin+ikt
             if(ipri>=2) write(nfout,'(" !D eko_l ik = ",i6)') ik
             do ie = 1, neg
                if(map_ek(ie,ik) == mype) then
                   e_mpi(ie,ikt) = eko_l(map_z(ie),ik)
                end if
             end do
          end do
          if(npes >= 2) then
             call mpi_allreduce(e_mpi,e2_mpi,neg*nspin,mpi_double_precision &
                  & ,mpi_sum,MPI_CommGroup,ierr)
          else
             e2_mpi  = e_mpi
          end if

          if(ipri>=2) then
             write(nfout,'(" <<m_ESIO_rd_WFs_and_EVs_ek>>")')
             do ikt = 1, nspin
                ik = (ikg-2)*nspin+ikt
                write(nfout,'(" ik = ",i5)') ik
                write(nfout,'(10f8.4)') (e2_mpi(ie,ikt),ie=1,neg)
             end do
          end if

          do ikt = 1, nspin
             ike2 = (ike-1)*nspin+ikt
             if(ipri>=2) write(nfout,'(" !D eko_l ike2 = ",i6)') ike2
             do ie = 1, neg
                if(map_ek(ie,ike2) == mype) then
                   eko_l(map_z(ie),ike2) = e2_mpi(ie,ikt)
                end if
             end do
          end do

       end do
    end if

1001 continue

    if(npes >= 2) &
         & call mpi_bcast(eko_ek,neg*kv3_ek,mpi_double_precision,0,MPI_CommGroup,ierr)

    if(nk_in_the_process > kv3_ek) goto 1002
    call m_ESIO_wd_EigenValues(nfout,2,nooccupation=YES)

1002 continue

!!$    ik = nk_in_the_process
!!$    do iks = 1, kv3
!!$          do ie = 1, neg
!!$             eko_ek(ie,ik+iks-1) = e_mpi(n_mpi(ie,iks),iks)
!!$          end do
!!$       end do
!!$    end if
!!$
    if(ipri >= 1) then
       write(nfout,'(" <<m_ESIO_rd_WFs_and_EVs_ek>>")')
       do iks = 1, kv3_ek
          if(iks > numk_zajsaved) cycle
          write(nfout,'(" ik = ",i5)') iks
          write(nfout,'(10f8.4)') (eko_ek(ie,iks),ie=1,neg)
       end do
    end if


    rewind nf

    do ik = 1, nk_in_the_process-nspin, nspin
       do iks = 1, nspin, af+1
          do ie = 1, neg
             if(mype == 0) read(nf) wf_l                 ! MPI
          end do
       end do
       if(mype == 0) read(nf) n_mpi                   ! MPI
       if(mype == 0) read(nf) n2_mpi                  ! MPI
       if(mype == 0) read(nf) e_mpi                   ! MPI
    end do

    deallocate(wf_l)                                    ! MPI
    deallocate(n_mpi); deallocate(n2_mpi)               ! MPI
    deallocate(e_mpi); deallocate(e2_mpi)               ! MPI

!!$    write(nfout,'(" ---<< m_ESIO_rd_WFs_and_EVs_ek>>---")')
  end subroutine m_ESIO_rd_WFs_and_EVs_ek

  subroutine m_ESIO_rd_EVs_ek(nfout,nf)
    integer, intent(in) :: nfout,nf
    integer  :: ik, ie, iks
    integer, allocatable, dimension(:,:) :: n_mpi, n2_mpi  ! MPI
    real(DP),allocatable, dimension(:,:) :: e_mpi, e2_mpi  ! MPI

    allocate(n_mpi(neg,nspin)); allocate(n2_mpi(neg,nspin)) ! MPI
    allocate(e_mpi(neg,nspin)); allocate(e2_mpi(neg,nspin)) ! MPI
    allocate(wf_l(kg1,kimg))
    n_mpi =0; n2_mpi = 0
    e_mpi =0; e2_mpi = 0; wf_l = 0

    if(ipri >= 1) write(nfout,*) ' !D Reading zaj <<m_ESIO_rd_EVs_ek>>'

    rewind nf

    eko_ek = 0.d0
!!$    do ik = 1, nk_in_the_process-kv3, kv3
    do ik = 1, nk_in_the_process - nspin, nspin
       if(ipri >= 1) write(nfout,*) ' !D     skipping ik = ', ik
!!$       do iks = 1, kv3, af+1
       do iks = 1, nspin, af+1
          do ie = 1, neg
             if(mype == 0) read(nf) wf_l
          end do
       end do
       if(mype == 0) read(nf) n_mpi
       if(mype == 0) read(nf) n2_mpi
       if(mype == 0) read(nf) e_mpi

       if(mype == 0) then
          do iks = 1, nspin
             do ie = 1, neg
                eko_ek(ie,ik+iks-1) = e_mpi(n_mpi(ie,iks),iks)
             end do
          end do
          if(ipri >= 3) then
             do iks=1,nspin
                write(nfout,'(" ik = ",i5)') ik+iks-1
                write(nfout,'(8f8.4)') (e_mpi(n_mpi(ie,iks),iks),ie=1,neg)
             end do
          end if
       end if
    end do

    write(nfout,'(" ---<< m_ESIO_rd_EVs_ek>>---")')
  end subroutine m_ESIO_rd_EVs_ek

  subroutine m_ESIO_wd_Psicoef(ipri,nfout,nf)
    integer, intent(in) :: ipri,nfout, nf
    integer :: ii, jj
    integer, parameter :: Ncol = 5
    integer :: ik, ie, ri,  nel, ig, ib,ib1,ib2,ibt,ibsize
    integer, allocatable, dimension(:) :: n_mpi
    real(DP),allocatable, dimension(:) :: e_mpi
    real(DP),allocatable, dimension(:,:,:) :: wf

    integer :: id_sname = -1
    call tstatc0_begin('m_ESIO_wd_Psicoef ',id_sname)

    allocate(e_mpi(neg)); e_mpi = 0.d0
    allocate(n_mpi(neg)); n_mpi = 0

    if(mype == 0) write(nf,'(" !!COEFFICIENTS of WAVE functions")')

    KPOINT: do ik = 1, kv3, af+1
       nel = min(Nw_Psicoef,iba(ik))
       allocate(wf_l(nel,kimg)); wf_l = 0.d0
!-----------------------------Modified by T.A.Ariasoca-------------------------------------------------
       if ( noncol ) then
             call wd_k_points_noncl()
          else
             call wd_k_points()
          endif
!--------------------------------------------------------------
       e_mpi = 0.d0
       n_mpi = 0
       if(map_k(ik) == myrank_k) then
!!$          if(ipri>=1) then
          if(mype == 0) then
             write(nfout,'(" ik = ", i8, " neordr ")') ik
             write(nfout,'(8i8)') (neordr(ie,ik),ie=1,neg)
          end if
          do ie = 1, neg
!!$             if(map_ek(ie,ik) == mype) n_mpi(ie) = neordr(ie,ik)
!-----------------------------Modified by T.A.Ariasoca-------------------------------------------------
             if ( noncol ) then
		        jj = ik-1
		        ii = ik-mod(jj,2)
                n_mpi(ie) = neordr(ie,ii)
                if(map_e(ie) /= myrank_e) cycle
                e_mpi(ie) = eko_l(map_z(ie),ii)
             else
                n_mpi(ie) = neordr(ie,ik)
                if(map_e(ie) /= myrank_e) cycle
                e_mpi(ie) = eko_l(map_z(ie),ik)
             endif
!--------------------------------------------------------------
          end do
       end if
       if(npes>=2) call mpi_allreduce(MPI_IN_PLACE,e_mpi,neg,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
       if(nrank_k>=2) then
          if(map_ek(1,ik) == mype .and. map_ek(1,ik) /= 0) then
             call mpi_send(n_mpi,neg,mpi_integer,0,1,MPI_CommGroup,ierr)
          else if(mype == 0 .and. map_ek(1,ik) /= 0) then
             call mpi_recv(n_mpi,neg,mpi_integer,map_ek(1,ik),1,MPI_CommGroup,istatus,ierr)
          end if
!!$          call mpi_allreduce(MPI_IN_PLACE,n_mpi,neg,mpi_integer,mpi_sum,MPI_CommGroup,ierr)
       end if
       do ie = 1, neg, Ncol
          ib1 = ie; ib2 = min(ie+Ncol-1,neg)
          ibsize = ib2-ib1+1
          if(mype == 0) then
             allocate(wf(nel,kimg,ibsize)); wf=0.d0
          end if
          do ib = ib1, ib2
!!$             ibt = n_mpi(ib)
             ibt = ib
             if(map_ek(ibt,ik) == mype) then                          ! MPI
                do ri = 1, kimg
                   wf_l(1:nel,ri) = zaj_l(1:nel,map_z(ibt),ik,ri)
                end do
                if(map_ek(ibt,ik) /= 0) &                             ! MPI
                     &   call mpi_send(wf_l,nel*kimg,mpi_real4,0,1,MPI_CommGroup,ierr) ! MPI
             else if(mype == 0 .and. map_ek(ibt,ik) /= 0) then
                call mpi_recv(wf_l,nel*kimg,mpi_real4,map_ek(ibt,ik),1,MPI_CommGroup,istatus,ierr)!MPI
             end if
             if(mype == 0) wf(:,:,ib-ib1+1) = wf_l(:,:)
          end do
          call wd_eko(ib1,ib2)
!!$          if(ik <= 2) then
             do ig = 1, nel
                call wd_coef(ibsize,ig)
             end do
!!$          end if
          if(mype == 0) deallocate(wf)
       end do
       deallocate(wf_l)
    end do KPOINT

    call tstatc0_end(id_sname)
  contains
    subroutine wd_coef(ibsize,ig)
      integer, intent(in) :: ibsize,ig
      integer :: ib
!!$      character(3) :: nan
      if(mype == 0) then
         if(kimg==2) then
            write(nf,'(i4," ( ",3i4," )", 5(" (",2f11.5," )"))') &
                 & ig, ngabc(nbase(ig,ik),1:3),(wf(ig,1,ib),wf(ig,2,ib),ib=1,ibsize)
!!$                 & ig, ngabc(nbase(ig,ik),1:3),(wf(ig,1,ie),wf(ig,2,ie),ie=1,3)
         else
!!$            nan="---"
            write(nf,'(i4," ( ",3i4," )", 5(" (",f11.5,4x,"---",4x," )"))') &
                 & ig, ngabc(nbase(ig,ik),1:3),(wf(ig,1,ib),ib=1,ibsize)
!!$            write(nf,'(i4," ( ",3i4," )", 5f11.5)') &
!!$                 & ig, ngabc(nbase(ig,ik),1:3),(wf(ig,1,ie),ie=1,ibsize)
         end if
      end if
    end subroutine wd_coef

    subroutine wd_eko(ib1,ib2)
      integer, intent(in) :: ib1,ib2
      integer :: ie
      if(mype == 0) then
         write(nf,'(a12,5x,a5,5(i7,2x,f10.5,7x))') "ig", "\ e: ", (ie,e_mpi(n_mpi(ie)),ie=ib1,ib2)
      end if
    end subroutine wd_eko

    subroutine wd_k_points()
      if(mype == 0) then
         if(nspin == 1) then
            write(nf,'(" ik = ",i6,"    ( ",3f14.6," )")') ik,(vkxyz(ik,1:3,BUCS))
         else
            if(mod(ik,2) == 1) then
               write(nf,'(" ik = ",i6,"    UP ","    ( ",3f14.6," )")') ik,(vkxyz(ik,1:3,BUCS))
            else
               write(nf,'(" ik = ",i6,"  DOWN ","    ( ",3f14.6," )")') ik,(vkxyz(ik,1:3,BUCS))
            end if
         end if
      end if
    end subroutine wd_k_points
!-----------------------------Modified by T.A.Ariasoca-------------------------------------------------
    subroutine wd_k_points_noncl()
      if(mype == 0) then
         write(nf,'(" ik = ",i6,"    ( ",3f14.6," )")') ik,(vkxyz(ik,1:3,BUCS))
      end if
    end subroutine wd_k_points_noncl
!------------------------------------------------------------------------------
  end subroutine m_ESIO_wd_Psicoef

  subroutine m_ESIO_wd_BandSymInput(ipri,nfout,nf)
    integer, intent(in) :: ipri,nfout, nf
    integer :: ii, jj
    integer :: ik, ie, ri,  nel, ig, ib,ib1,ib2,ibt,ibsize
    integer, allocatable, dimension(:) :: n_mpi
    real(DP),allocatable, dimension(:) :: e_mpi

    integer :: id_sname = -1
    call tstatc0_begin('m_ESIO_wd_BandSymInput ',id_sname)

    allocate(e_mpi(neg)); e_mpi = 0.d0
    allocate(n_mpi(neg)); n_mpi = 0

    if(mype == 0) then
       write(nf,'("##PSIINPSTART")')
       write(nf,'("#MAGNETIC_STATE")')

!-----------------------------Modified by T.A.Ariasoca-------------------------------------------------
       if( noncol ) then
          write(nf,'("2  1  2 ! nspin = 2, af = 1, ndim_spinor = 2 (NONCOLLINEAR)"/"#")')
	      else if(nspin == 2 .and. af == 0) then
          write(nf,'("2  0  1 ! nspin = 2, af = 0, ndim_spinor = 1 (FERRO)"/"#")')
       else if(nspin == 2 .and. af == 1) then
          write(nf,'("2  1  1 ! nspin = 2, af = 1, ndim_spinor = 1 (ANTIFERRO)"/"#")')
       else if(nspin == 1) then
          write(nf,'("1  0  1 ! nspin = 1, af = 0, ndim_spinor = 1 (PARAMAGNETIC)"/"#")')
       else
          write(nf,'(2i5," ! magnetic state = unknown"/"#")') nspin, af
       end if
!-----------------------------------------------------------------------------------
    end if

    KPOINT: do ik = 1, kv3, af+1

       nel = min(Nw_Psicoef,iba(ik))
       allocate(wf_l(nel,kimg)); wf_l = 0.d0
!-----------------------------Modified by T.A.Ariasoca-------------------------------------------------
       if ( noncol ) then
             call wd_k_points_noncl()
          else
             call wd_k_points()
          endif
!----------------------------------------------
       ! --- Eigen Energies --->
       e_mpi = 0.d0
       n_mpi = 0
       if(map_k(ik) == myrank_k) then
          if(ipri>=1) then
             write(nfout,'(" ik = ", i4, " neordr ")') ik
             write(nfout,'(8i8)') (neordr(ie,ik),ie=1,neg)
          end if
          do ie = 1, neg
!!$             if(map_ek(ie,ik) == mype) n_mpi(ie) = neordr(ie,ik)
!-----------------------------Modified by T.A.Ariasoca-------------------------------------------------
             if ( noncol ) then
		        jj = ik-1
		        ii = ik-mod(jj,2)
                n_mpi(ie) = neordr(ie,ii)
                if(map_e(ie) /= myrank_e) cycle
                e_mpi(ie) = eko_l(map_z(ie),ii)
             else
                n_mpi(ie) = neordr(ie,ik)
                if(map_e(ie) /= myrank_e) cycle
                e_mpi(ie) = eko_l(map_z(ie),ik)
             endif
!-----------------------------------------------
          end do
       end if
       if(npes>=2) call mpi_allreduce(MPI_IN_PLACE,e_mpi,neg,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
       if(nrank_k>=2) then
          if(map_ek(1,ik) == mype .and. map_ek(1,ik) /= 0) then
             call mpi_send(n_mpi,neg,mpi_integer,0,1,MPI_CommGroup,ierr)
          else if(mype == 0 .and. map_ek(1,ik) /= 0) then
             call mpi_recv(n_mpi,neg,mpi_integer,map_ek(1,ik),1,MPI_CommGroup,istatus,ierr)
          end if
!!$          call mpi_allreduce(MPI_IN_PLACE,n_mpi,neg,mpi_integer,mpi_sum,MPI_CommGroup,ierr)
       end if
       call wd_eko(1, neg)
       ! <---
       if(mype == 0) write(nf,'("#Number_of_Gvectors"/,i0,/,"#")') nel
       call wd_gvectors(ik)

       ! --- Wave Function Coefficients --->
      if(mype == 0)  write(nf,'("#PSICOEF")')
       do ie = 1, neg
          if(mype == 0)  write(nf,'(i0,"  #EIGEN_ENERGY NUMBER")') ie
          if(map_ek(ie,ik) == mype) then
             wf_l(1:nel,1:kimg) = zaj_l(1:nel,map_z(ie),ik,1:kimg)
             if(map_ek(ie,ik) /= 0) &
                  &   call mpi_send(wf_l,nel*kimg,mpi_real,0,1,MPI_CommGroup,ierr) ! MPI
          else if(mype == 0 .and. map_ek(ie,ik) /= 0) then
             call mpi_recv(wf_l,nel*kimg,mpi_real,map_ek(ie,ik),1,MPI_CommGroup,istatus,ierr)!MPI
          end if
          call wd_coef2()
       end do
       if(mype == 0) write(nf,'("#")')
       deallocate(wf_l)
    end do KPOINT
    if(mype == 0) write(nf,'("##")')

    call tstatc0_end(id_sname)
  contains
    subroutine wd_coef2()
      integer :: ig
      if(mype == 0) then
         if(kimg==2) then
            write(nf,'(8f11.5)') (wf_l(ig,1),wf_l(ig,2),ig=1,nel)
         else
            write(nf,'(8f11.5)') (wf_l(ig,1), 0.d0, ig=1,nel)
         end if
      end if
    end subroutine wd_coef2

    subroutine wd_gvectors(ik)
      integer, intent(in) :: ik
      integer :: i
      if(mype == 0) then
         write(nf,'("#GVECTOR")')
         do i = 1, nel
            write(nf,'(i0,1x,3i6)') i,ngabc(nbase(i,ik),1:3)
         end do
         write(nf,'("#")')
      end if
    end subroutine wd_gvectors

    subroutine wd_nelements()
      if(mype == 0) write(nf,'("#Number_of_Gvectors"/,i0,/,"#")') nel
    end subroutine wd_nelements

    subroutine wd_eko(ib1,ib2)
      integer, intent(in) :: ib1,ib2
      integer :: ie
      if(mype == 0) then
         write(nf,'("#EIGEN_ENERGY")')
         do ie = ib1,ib2
            write(nf,'(i0,2x,f10.5)') ie,e_mpi(n_mpi(ie))
         end do
         write(nf,'("#")')
      end if
    end subroutine wd_eko

    subroutine wd_k_points()
      character(len=4),dimension(3) :: spinstate
      data spinstate/"    ","  UP","DOWN"/
      integer :: ip
      if(mype == 0) then
         if(nspin == 1) then
            ip = 1
         else
            if(mod(ik,2) == 1) then
               ip = 2
            else
               ip = 3
            end if
         end if
         write(nf,'("#KPOINT"/,i06,3f14.6,2x,a4,/"#")') ik,(vkxyz(ik,1:3,BUCS)),spinstate(ip)
      end if
    end subroutine wd_k_points
!-----------------------------Modified by T.A.Ariasoca-------------------------------------------------
    subroutine wd_k_points_noncl()
      write(nf,'("#KPOINT"/,i06,3f14.6,2x,a4,/"#")') ik,(vkxyz(ik,1:3,BUCS))
    end subroutine wd_k_points_noncl
!------------------------------------------------------------------------------

  end subroutine m_ESIO_wd_BandSymInput

  subroutine m_ESIO_wd_WFs_and_EVs_ek(nfout,nf)
    integer, intent(in) :: nfout, nf
    integer  :: ik, ie, ri, ikg, ikt
    integer, allocatable, dimension(:,:) :: n_mpi
    real(DP),allocatable, dimension(:,:) :: e_mpi
    integer :: id_sname = -1
    call tstatc0_begin('m_ESIO_wd_WFs_and_EVs_ek ',id_sname)

    if(precision_WFfile==SP) then
       allocate(wf_l(kg1,kimg));    wf_l = 0
    else
       allocate(wfdp_l(kg1,kimg));    wfdp_l = 0
    end if

    call mpi_barrier(MPI_CommGroup,ierr)
    if(ipri>=2) write(nfout,'(" !D Writing WaveFunctions ")')

    allocate(n_mpi(neg,nspin)); n_mpi = 0
    allocate(e_mpi(neg,nspin)); e_mpi = 0.d0

    KPOINT: do ikg = 1, nrank_k
       ! ---> zaj_l
       if((ikg-1)*nspin + 1 > kv3) then
          if(ipri >= 1) write(nfout,'(" !D ik > kv3")')
          exit KPOINT
       end if

       do ikt = 1, nspin, af+1
          ik = (ikg-1)*nspin + ikt
          if(ipri>=1) write(nfout,'(" !D Writing WaveFunctions ik = ",i5)') ik
          do ie = 1, neg
           if(precision_WFfile==SP) then
             if(map_ek(ie,ik) == mype) then                          ! MPI
                do ri = 1, kimg
                   wf_l(1:kg1,ri) = zaj_l(1:kg1,map_z(ie),ik,ri)
                end do
                if(map_ek(ie,ik) /= 0) &                             ! MPI
                     &   call mpi_send(wf_l,kg1*kimg,mpi_real4,0,1,MPI_CommGroup,ierr) ! MPI
             else if(mype == 0 .and. map_ek(ie,ik) /= 0) then
                call mpi_recv(wf_l,kg1*kimg,mpi_real4,map_ek(ie,ik),1,MPI_CommGroup,istatus,ierr)!MPI
             end if
             if(mype == 0) write(nf)  wf_l                        ! MPI
           else if(precision_WFfile==DP) then
             if(map_ek(ie,ik) == mype) then
                do ri = 1, kimg
                   wfdp_l(1:kg1,ri) = zaj_l(1:kg1,map_z(ie),ik,ri)
                end do
                if(map_ek(ie,ik) /= 0) &
                     &   call mpi_send(wfdp_l,kg1*kimg,mpi_double_precision,0,1,MPI_CommGroup,ierr)
             else if(mype == 0 .and. map_ek(ie,ik) /= 0) then
                call mpi_recv(wfdp_l,kg1*kimg,mpi_double_precision,map_ek(ie,ik),1,MPI_CommGroup,istatus,ierr)
             end if
             if(mype == 0) write(nf)  wfdp_l
           end if
          end do
       end do

       ! --->  neordr
       n_mpi = 0                                          ! MPI
       do ikt = 1, nspin                                  ! MPI
          ik = (ikg-1)*nspin + ikt
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          n_mpi(1:neg,ikt) = neordr(1:neg,ik)             ! MPI
       end do                                             ! MPI
       if(npes >= 2) then
          call mpi_allreduce(MPI_IN_PLACE,n_mpi,neg*nspin,mpi_integer,mpi_sum &
               &                      ,MPI_CommGroup,ierr)  ! MPI
          n_mpi = n_mpi/nrank_e
       end if
       if(ipri>=2) write(nfout,'(" !D Writing neordr ik = ",i5)') ik
       if(mype == 0) write(nf) n_mpi             ! MPI ; writing (neordr)

       ! --->  nrvf_ordr
       n_mpi = 0                                          ! MPI
       do ikt = 1, nspin                                  ! MPI
          ik = (ikg-1)*nspin + ikt
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          n_mpi(1:neg,ikt) = nrvf_ordr(1:neg,ik)          ! MPI
       end do                                             ! MPI
       if(npes >= 2) then
          call mpi_allreduce(MPI_IN_PLACE,n_mpi,neg*nspin,mpi_integer,mpi_sum &
               &                      ,MPI_CommGroup,ierr)  ! MPI
          n_mpi = n_mpi/nrank_e
       end if
       if(ipri>=2) write(nfout,'(" !D Writing nrvf_ordr ik = ",i5)') ik
       if(mype == 0) write(nf) n_mpi             ! MPI ; writing (nrvf_ordr)

       e_mpi = 0.d0                                       ! MPI
       do ikt = 1, nspin                                  ! MPI
          ik = (ikg-1)*nspin + ikt
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          do ie = 1, neg                                  ! MPI
             if(map_e(ie) /= myrank_e) cycle              ! MPI
             e_mpi(ie,ikt) = eko_l(map_z(ie),ik)           ! MPI
          end do
       end do
       if(npes >= 2) then
          call mpi_allreduce(MPI_IN_PLACE,e_mpi,neg*nspin,mpi_double_precision &
               &               ,mpi_sum,MPI_CommGroup,ierr) ! MPI
       end if
       if(ipri>=2) write(nfout,'(" !D Writing eko_l ik = ",i5)') ik
       if(mype == 0) write(nf) e_mpi             ! MPI ; writing (eko_l)
    end do KPOINT

!!$    do ik = 1, kv3, af+1
!!$       do ie = 1, neg
!!$          if(map_ek(ie,ik) == mype) then                          ! MPI
!!$             do ri = 1, kimg
!!$                wf_l(1:kg1,ri) = zaj_l(1:kg1,map_z(ie),ik,ri)
!!$             end do
!!$             if(map_ek(ie,ik) /= 0) &                             ! MPI
!!$            &   call mpi_send(wf_l,kg1*kimg,mpi_real,0,1,MPI_CommGroup,ierr) ! MPI
!!$          else if(mype == 0 .and. map_ek(ie,ik) /= 0) then
!!$             call mpi_recv(wf_l,kg1*kimg,mpi_real,map_ek(ie,ik),1,MPI_CommGroup,istatus,ierr)!MPI
!!$          end if
!!$          if(mype == 0) write(nf)  wf_l                        ! MPI
!!$       end do
!!$    end do
!!$    deallocate(wf_l)
!!$
!!$    allocate(n_mpi(neg,kv3)); allocate(n2_mpi(neg,kv3))! MPI
!!$    allocate(e_mpi(neg,kv3)); allocate(e2_mpi(neg,kv3))! MPI
!!$
!!$    n_mpi = 0                                          ! MPI
!!$    do ik = 1, kv3                                     ! MPI
!!$       if(map_k(ik) /= myrank_k) cycle                 ! MPI
!!$       n_mpi(1:neg,ik) = neordr(1:neg,ik)              ! MPI
!!$    end do                                             ! MPI
!!$    if(npes >= 2) then
!!$       call mpi_allreduce(n_mpi,n2_mpi,neg*kv3,mpi_integer,mpi_sum &
!!$            &                      ,MPI_CommGroup,ierr)  ! MPI
!!$       n2_mpi = n2_mpi/nrank_e
!!$    else
!!$       n2_mpi = n_mpi
!!$    end if
!!$    if(mype == 0) write(nf) n2_mpi             ! MPI ; writing (neordr)
!!$
!!$    n_mpi = 0                                          ! MPI
!!$    do ik = 1, kv3                                     ! MPI
!!$       if(map_k(ik) /= myrank_k) cycle                 ! MPI
!!$       n_mpi(1:neg,ik) = nrvf_ordr(1:neg,ik)           ! MPI
!!$    end do                                             ! MPI
!!$    if(npes >= 2) then
!!$       call mpi_allreduce(n_mpi,n2_mpi,neg*kv3,mpi_integer,mpi_sum &
!!$            &                      ,MPI_CommGroup,ierr)  ! MPI
!!$       n2_mpi = n2_mpi/nrank_e
!!$    else
!!$       n2_mpi = n_mpi
!!$    end if
!!$    if(mype == 0) write(nf) n2_mpi             ! MPI ; writing (nrvf_ordr)
!!$
!!$    e_mpi = 0.d0                                       ! MPI
!!$    do ik = 1, kv3                                     ! MPI
!!$       if(map_k(ik) /= myrank_k) cycle                 ! MPI
!!$       do ie = 1, neg                                  ! MPI
!!$          if(map_e(ie) /= myrank_e) cycle              ! MPI
!!$          e_mpi(ie,ik) = eko_l(map_z(ie),ik)           ! MPI
!!$       end do
!!$    end do
!!$    if(npes >= 2) then
!!$       call mpi_allreduce(e_mpi,e2_mpi,neg*kv3,mpi_double_precision &
!!$            &               ,mpi_sum,MPI_CommGroup,ierr) ! MPI
!!$    else
!!$       e2_mpi = e_mpi
!!$    end if
!!$    if(mype == 0) write(nf) e2_mpi             ! MPI ; writing (eko_l)

!!$    e_mpi = 0.d0                                       ! MPI
!!$    do ik = 1, kv3                                     ! MPI
!!$       if(map_k(ik) /= myrank_k) cycle                 ! MPI
!!$       do ie = 1, neg                                  ! MPI
!!$          if(map_e(ie) /= myrank_e) cycle              ! MPI
!!$          e_mpi(ie,ik) = occup_l(map_z(ie),ik)         ! MPI
!!$       end do                                          ! MPI
!!$    end do                                             ! MPI
!!$    if(npes >= 2) then
!!$       call mpi_allreduce(e_mpi,e2_mpi,neg*kv3,mpi_double_precision &
!!$            &                  ,mpi_sum,MPI_CommGroup,ierr) ! MPI
!!$    else
!!$       e2_mpi = e_mpi
!!$    end if
!!$    if(mype == 0) write(nf) e2_mpi             ! MPI ; writing (occup_l)

    if(precision_WFfile==SP) then
       deallocate(wf_l)
    else if(precision_WFfile==DP) then
       deallocate(wfdp_l)
    end if
    deallocate(n_mpi)
    deallocate(e_mpi)

    call tstatc0_end(id_sname)

  end subroutine m_ESIO_wd_WFs_and_EVs_ek

  subroutine m_ESIO_wd_WFn(nfout,nfwfk,ik,ib)
    integer, intent(in) :: nfout,nfwfk
    integer, intent(in) :: ik,ib
    integer :: jb
    real(kind=DP), allocatable :: bfft(:)
    real(kind=DP) :: eig
    integer :: id_sname = -1
    call tstatc0_begin('m_ESIO_wd_WFn ',id_sname)

    allocate(bfft(nfft));    bfft = 0
    call mpi_barrier(MPI_CommGroup,ierr)
    if(ipri >= 1) write(nfout,*) ' !D Writing Wavefunctions '
    rewind nfwfk

    if(map_k(ik) == myrank_k) jb = neordr(ib,ik)
    if(nrank_k > 1) call mpi_bcast(jb,1,mpi_integer,map_k(ik),mpi_e_world(myrank_e),ierr)

    if(map_ek(jb,ik) == mype) then
       call m_ES_WF_in_Rspace(ik,jb,bfft)
       eig = eko_l(map_z(jb),ik)
       if(map_ek(jb,ik) /= 0) then
          call mpi_send(bfft,nfft,mpi_double_precision,0,1,MPI_CommGroup,ierr)
          call mpi_send(eig,1,mpi_double_precision,0,1,MPI_CommGroup,ierr)
       end if
    else if(mype == 0 .and. map_ek(jb,ik) /= 0) then
       call mpi_recv(bfft,nfft,mpi_double_precision,map_ek(jb,ik),1,MPI_CommGroup,istatus,ierr)
       call mpi_recv(eig,1,mpi_double_precision,map_ek(jb,ik),1,MPI_CommGroup,istatus,ierr)
    end if
    if(mype == 0) then
       call wd_wf(nfout,nfwfk,ik,ib,eig)
    end if
    deallocate(bfft)
    call tstatc0_end(id_sname)
  contains
    subroutine wd_wf(nfout,nfwfk,ik,ib,eig)
      integer, intent(in) :: nfout,nfwfk,ik,ib
      real(kind=DP), intent(in) :: eig
      integer :: i,j,k, id, nl, nm, nn, nlhf,inew,jnew,knew,ip,mm
      real(kind=DP),allocatable,dimension(:,:,:,:) :: wkwf
      real(kind=DP) ::      x,y,z
      integer, parameter :: UP = 1 , DOWN = 2
      integer ::            up_down
      real(kind=DP),allocatable,dimension(:,:) :: cps_full
      integer, allocatable,dimension(:) :: ityp_full
      integer :: m, nk
      real(kind=DP) :: norm
      real(kind=DP) :: normr,normi
      integer :: n1,n2,n3
      real(kind=DP) :: dn1,dn2,dn3
      integer :: icomp

      id = fft_box_size_WF(1,0)
      mm = fft_box_size_WF(2,0)
      nl = fft_box_size_WF(1,1)
      nm = fft_box_size_WF(2,1)
      nn = fft_box_size_WF(3,1)

      if(kimg == 1) then
         nlhf = id/2
      else
         nlhf = id
      end if

      if(wf_filetype == DENSITY_ONLY &
      & .or. wf_filetype == VTK &
      & .or. wf_filetype == BINARY) then
         allocate(wkwf(nl,nm,nn,2)); wkwf = 0.d0
      else if(wf_filetype == CUBE) then
         allocate(wkwf(nn,nm,nl,2)); wkwf = 0.d0
      end if

      if(nspin==2) then
         if(mod(ik/nspin,2) == 1) then
            up_down = UP
         else
            up_down = DOWN
         end if
      end if
      nk = (ik-1)/nspin+1

      if(ipri >= 2) write(nfout,9001) nl*nm*nn, nl, nm, nn
9001  format(' Wavefunction ',i8,'(',3i5,')')

      if(ipri >= 2) write(nfout,*) ' !D FFT cube mapping start'
      do i = 1, nm
         do j = 1, nn
            do k = 1, nl
               if(kimg == 1 .and. k > nlhf) then
                  knew = id - k
                  jnew = nn+2 - j
                  inew = nm+2 - i
                  if(jnew > nn) then
                     jnew = jnew - nn
                  end if
                  if(inew > nm) then
                     inew = inew - nm
                  end if
               else
                  knew = k; jnew = j; inew = i
               end if
               ip = nlhf*mm*(jnew-1) + nlhf*(inew-1) + knew
               if(wf_filetype == DENSITY_ONLY &
               & .or. wf_filetype == VTK &
               & .or. wf_filetype == BINARY) then
                  wkwf(k,i,j,1) = bfft(ip*2-1)
                  wkwf(k,i,j,2) = bfft(ip*2)
               else if(wf_filetype == CUBE) then
                  wkwf(j,i,k,1) = bfft(ip*2-1)
                  wkwf(j,i,k,2) = bfft(ip*2)
               end if
            end do
         end do
      end do
! Normalization
      normr = 0.d0
      normi = 0.d0
      do i = 1, nm
         do j = 1, nn
            do k = 1, nl
               if(wf_filetype == DENSITY_ONLY &
               & .or. wf_filetype == VTK &
               & .or. wf_filetype == BINARY) then
                  normr = normr + wkwf(k,i,j,1)*wkwf(k,i,j,1)
                  normi = normi + wkwf(k,i,j,2)*wkwf(k,i,j,2)
               else if(wf_filetype == CUBE) then
                  normr = normr + wkwf(j,i,k,1)*wkwf(j,i,k,1)
                  normi = normi + wkwf(j,i,k,2)*wkwf(j,i,k,2)
               end if
            end do
         end do
      end do
      norm = normr + normi
      write(nfout,*) 'Real and imaginary parts of wf = ',normr/norm,normi/norm
      if(wf_filetype == VTK .or. wf_filetype == BINARY) then
         if(normr>normi) then
            norm = normr
            icomp = 1
            write(nfout,*) 'Real part of wf will be outputed.'
         else
            norm = normi
            icomp = 2
            write(nfout,*) 'Imaginary part of wf will be outputed.'
         end if
      end if
      norm = univol*norm/dble(nm*nn*nl)
      norm = 1.d0/dsqrt(norm)
      do i = 1, nm
         do j = 1, nn
            do k = 1, nl
               if(wf_filetype == DENSITY_ONLY &
               & .or. wf_filetype == VTK &
               & .or. wf_filetype == BINARY) then
                  wkwf(k,i,j,1) = norm*wkwf(k,i,j,1)
                  wkwf(k,i,j,2) = norm*wkwf(k,i,j,2)
               else if(wf_filetype == CUBE) then
                  wkwf(j,i,k,1) = norm*wkwf(j,i,k,1)
                  wkwf(j,i,k,2) = norm*wkwf(j,i,k,2)
               end if
            end do
         end do
      end do

      if(wf_filetype == DENSITY_ONLY) then
         write(nfwfk,9001) nl*nm*nn, nl, nm, nn
         write(nfwfk,'(6e13.5)') wkwf
      else if(wf_filetype == BINARY) then
         write(nfwfk) nl*nm*nn, nl, nm, nn
         write(nfwfk) altv, nspin, up_down, nk, ib, eig
         write(nfwfk) wkwf(:,:,:,icomp)
      else if(wf_filetype == VTK) then
         write(nfwfk,'("# vtk DataFile Version 2.0")')
         if(nspin == 2) then
            if(up_down == 1) then
               write(nfwfk,'(" SCF Wavefunction UP : k=",i7," n=",i7," eig=",f20.5)') nk,ib,eig
            else
               write(nfwfk,'(" SCF Wavefunction DOWN : k=",i7," n=",i7," eig=",f20.5)') nk,ib,eig
            end if
         else
            write(nfwfk,'(" SCF Wavefunction : k=",i7," n=",i7," eig=",f20.5)') nk, ib, eig
         end if
         write(nfwfk,'("ASCII")')
         write(nfwfk,'("DATASET STRUCTURED_GRID")')
         write(nfwfk,'("DIMENSIONS",3(1x,i5))') nl+1,nm+1,nn+1
         write(nfwfk,'("POINTS",1x,i10,1x,"float")') (nl+1)*(nm+1)*(nn+1)
         do n1=0,nl
            do n2=0,nm
               do n3=0,nn
                  dn1 = n1/dble(nl)
                  dn2 = n2/dble(nm)
                  dn3 = n3/dble(nn)
                  x = altv(1,1)*dn1 + altv(1,2)*dn2 + altv(1,3)*dn3
                  y = altv(2,1)*dn1 + altv(2,2)*dn2 + altv(2,3)*dn3
                  z = altv(3,1)*dn1 + altv(3,2)*dn2 + altv(3,3)*dn3
                  write(nfwfk,'(3(1x,e13.5))') x,y,z
               end do
            end do
         end do
         write(nfwfk,'("")')
         write(nfwfk,'("POINT_DATA",1x,i10)') (nl+1)*(nm+1)*(nn+1)
         write(nfwfk,'("SCALARS scalars float")')
         write(nfwfk,'("LOOKUP_TABLE default")')
         do n1=0,nl
            i=n1+1
             if(n1==nl) i=1
            do n2=0,nm
               j=n2+1
               if(n2==nm) j=1
               do n3=0,nn
                  k=n3+1
                  if(n3==nn) k=1
                  write(nfwfk,'(e13.5)') wkwf(i,j,k,icomp)
               end do
            end do
         end do
      else if(wf_filetype == CUBE) then
         if(len_trim(wf_title) >= 1) then
            write(nfwfk,*) trim(wf_title)
         else
            write(nfwfk,'(" Calculated by phase")')
         end if
         if(nspin == 2) then
            if(up_down == 1) then
               write(nfwfk,'(" SCF Wavefunction UP : k=",i7," n=",i7," eig=",f20.5)') nk,ib,eig
            else
               write(nfwfk,'(" SCF Wavefunction DOWN : k=",i7," n=",i7," eig=",f20.5)') nk,ib,eig
            end if
         else
            write(nfwfk,'(" SCF Wavefunction : k=",i7," n=",i7," eig=",f20.5)') nk, ib, eig
         end if
         x = 0.d0; y = 0.d0; z = 0.d0
         write(nfwfk,'(i6,3f10.4)') -natm2, x,y,z
         do i = 1, 3
            write(nfwfk,'(i6,3f10.6)') fft_box_size_WF(i,1), altv(1:3,i)/dble(fft_box_size_WF(i,1))
         end do

         allocate(cps_full(natm2,3))
         allocate(ityp_full(natm2))
         cps_full = 0; ityp_full = 0
         call m_IS_pack_all_ions_in_uc(ityp_full,cps_full)
         do i = 1, natm2
            m = ityp_full(i)
            write(nfwfk,'(f8.4,4f10.6)') iatomn(m), ival(m), cps_full(i,1:3)
         end do
         deallocate(ityp_full,cps_full)

         write(nfwfk,'(10i5)') 2,1,2
         write(nfwfk,'(6e13.5)') wkwf(:,:,:,1)
         write(nfwfk,'(6e13.5)') wkwf(:,:,:,2)

      end if
      if(allocated(wkwf)) deallocate(wkwf)
    end subroutine wd_wf
  end subroutine m_ESIO_wd_WFn

  logical function m_ESIO_check_energy(ik,ib)
    integer, intent(in) :: ik,ib
    integer :: jb
    real(kind=DP) :: eig
    if(map_k(ik) == myrank_k) jb = neordr(ib,ik)
    if(nrank_k > 1) call mpi_bcast(jb,1,mpi_integer,map_k(ik),mpi_e_world(myrank_e),ierr)

    if(map_ek(jb,ik) == mype) then
       eig = eko_l(map_z(jb),ik)
       if(eig >= eigmin_wf .and. eig <= eigmax_wf) then
          m_ESIO_check_energy = .true.
       else
          m_ESIO_check_energy = .false.
       end if
    end if
    call mpi_bcast(m_ESIO_check_energy,1,mpi_logical,map_ek(jb,ik),MPI_CommGroup,ierr)
  end function m_ESIO_check_energy

  subroutine m_ESIO_wd_Efermi(nfout,nfefermi)
    integer, intent(in) :: nfout, nfefermi
                                                  __TIMER_SUB_START(1377)
    if(mype == 0) then
                                                  __TIMER_IODO_START(1460)
       write(nfefermi,'(f16.8," : Efermi")') efermi
       if(sw_fix_total_spin == YES .and. nspin == 2) then
          write(nfefermi,'(2f16.8," : Ffermi_spin(1), Efermi_spin(2)")') &
               & efermi_spin(1),efermi_spin(2)
       end if
                                                  __TIMER_IODO_STOP(1460)
    end if
                                                  __TIMER_SUB_STOP(1377)
  end subroutine m_ESIO_wd_Efermi

  subroutine m_ESIO_rd_Efermi(nfout,nfefermi)
    integer, intent(in) :: nfout, nfefermi
                                                  __TIMER_SUB_START(1376)
    if(mype == 0) then
                                                  __TIMER_IODO_START(1458)
       read(nfefermi,*,err=1001,end=1001) efermi
       write(nfout,'(" ! efermi = ",f16.8," : this is read from nfefermi")') efermi
       if(sw_fix_total_spin == YES .and. nspin == 2) then
          read(nfefermi,*,err=1002,end=1002) efermi_spin(1),efermi_spin(2)
          write(nfout,'(" ! efermi_spin = ",2f16.8," : these are read from nfefermi")') efermi_spin(1:2)
       end if
                                                  __TIMER_IODO_STOP(1458)
       goto 1010
1001   continue
       efermi = 0.d0
1002   continue
       if(sw_fix_total_spin == YES .and. nspin == 2) then
          efermi_spin(1) = 0.d0; efermi_spin(2) = 0.d0
       end if
1010   continue
    end if
    if(npes > 1) then
                                                  __TIMER_IOCOMM_START_w_BARRIER(MPI_CommGroup,1459)
       call mpi_bcast(efermi,1,mpi_double_precision,0,MPI_CommGroup,ierr)
       if(sw_fix_total_spin == YES .and. nspin == 2) then
          call mpi_bcast(efermi_spin,2,mpi_double_precision,0,MPI_CommGroup,ierr)
       end if
                                                  __TIMER_IOCOMM_STOP(1459)
    end if
                                                  __TIMER_SUB_STOP(1376)
  end subroutine m_ESIO_rd_Efermi


! === KT_add === 2015/05/16
  subroutine m_ESIO_wd_Wfn_squared_noncl( nfout )
    integer, intent(in) :: nfout

    integer :: iloop, ib
    logical :: goflag
    real(kind=DP), allocatable :: chgq_l_save(:,:,:)
    real(kind=DP), allocatable :: hsr_save(:,:,:,:), hsi_save(:,:,:,:)

    if ( ekmode == ON ) then
       if ( nk_in_the_process <= ik_wf_squared &
            &  .and. nk_in_the_process -1 +kv3 > ik_wf_squared ) then
          goflag = .true.
       else
          goflag = .false.
       endif
    else
       goflag = .true.
    endif

    if ( .not. goflag ) return

    allocate( chgq_l_save(ista_kngp:iend_kngp,kimg,ndim_magmom) )
    allocate( hsr_save(natm,nlmt,nlmt,ndim_magmom) )
    allocate( hsi_save(natm,nlmt,nlmt,ndim_magmom) )

    chgq_l_save = chgq_l;     hsr_save = hsr;     hsi_save = hsi

    Do ib=ib1_wf_squared, ib2_wf_squared
       if ( ekmode == ON ) then
          call m_CD_softpart_ktsub_noncl( nfout, kv3, &
               &                          ik_wf_squared -nk_in_the_process+1, ib )
          call m_CD_hardpart_ktsub_noncl( nfout, ik_wf_squared -nk_in_the_process +1, &
               &                          ib )
       else
          call m_CD_softpart_ktsub_noncl( nfout, kv3, ik_wf_squared, ib )
          call m_CD_hardpart_ktsub_noncl( nfout, ik_wf_squared, ib )
       endif

       call m_CD_alloc_rspace_charge()
       Do iloop=1, ndim_magmom
          call m_Files_open_nfwfksq_noncl( iloop, ik_wf_squared, ib )
          call m_CD_rspace_charge_noncl( iloop, nfwfk_sq, nfout, wf_squared_filetype )
       End do
       call m_CD_dealloc_rspace_charge()

    End Do

    chgq_l = chgq_l_save;     hsr_save = hsr;     hsi_save = hsi
    deallocate( chgq_l_save ); deallocate( hsr_save );  deallocate( hsi_save )

  end subroutine m_ESIO_wd_Wfn_squared_noncl
! ============== 2015/05/16

  subroutine m_ESIO_wd_Wfn_integ_magmom       ! noncl
    integer :: ik, ie, ib1, ig, is1, is2, ik2
    integer :: ia, it, lmt1, lmt2, p1, p2
    integer :: neg_t
    real(kind=DP) :: csum(3)
    complex(kind=CMPLDP) :: z1, z2
    complex(kind=CMPLDP) :: PauliMatrix( ndim_magmom, ndim_spinor, ndim_spinor )

    real(kind=DP), allocatable :: work(:,:,:), magmom_each_wfn(:,:,:)

    call m_ES_set_Pauli_matrix( PauliMatrix )

    allocate( magmom_each_wfn( kv3/ndim_spinor, neg, 3 ) )
    magmom_each_wfn = 0.0d0

    Do ik=1, kv3, ndim_spinor
       if ( map_k(ik) /= myrank_k ) cycle! MPI

       Do ie=ista_e, iend_e
          ib1 = map_z(ie)

          csum = 0.0d0

          Do ig=1, iba(ik)
             Do is1=1, ndim_spinor
                Do is2=1, ndim_spinor
                   z1 = cmplx( zaj_l( ig, ib1, ik+is1-1, 1 ), &
                        &      zaj_l( ig, ib1, ik+is1-1, kimg ) )
                   z2 = cmplx( zaj_l( ig, ib1, ik+is2-1, 1 ), &
                        &      zaj_l( ig, ib1, ik+is2-1, kimg ) )

                   csum(1) = csum(1) +conjg(z1) *PauliMatrix(2,is1,is2) *z2
                   csum(2) = csum(2) +conjg(z1) *PauliMatrix(3,is1,is2) *z2
                   csum(3) = csum(3) +conjg(z1) *PauliMatrix(4,is1,is2) *z2
                End do
             End Do
          End Do
!
          Do ia=1, natm
             it = ityp(ia)
             do lmt1 = 1, ilmt(it)
                p1 = lmta(lmt1,ia)
                do lmt2 = 1, ilmt(it)
                   p2 = lmta(lmt2,ia)
                   Do is1=1, ndim_spinor
                      Do is2=1, ndim_spinor
                         z1 = cmplx( fsr_l(ib1,p1,ik+is1-1), fsi_l(ib1,p1,ik+is1-1) )
                         z2 = cmplx( fsr_l(ib1,p2,ik+is2-1), fsi_l(ib1,p2,ik+is2-1) )

                         csum(1) = csum(1) +conjg(z1) *q(lmt1,lmt2,it) &
                              &                       *PauliMatrix(2,is1,is2) *z2
                         csum(2) = csum(2) +conjg(z1) *q(lmt1,lmt2,it) &
                              &                       *PauliMatrix(3,is1,is2) *z2
                         csum(3) = csum(3) +conjg(z1) *q(lmt1,lmt2,it) &
                              &                       *PauliMatrix(4,is1,is2) *z2
                      End do
                   End do
                End do
             End do
          End Do
!
          ik2 = (ik-1)/ndim_spinor +1
          magmom_each_wfn( ik2, ie, 1:3 ) = csum(1:3)
       End Do
    End Do
!
    if ( npes > 1 ) then
       allocate( work (kv3/ndim_spinor, neg, 3 ) ); work = 0.0d0
       call mpi_allreduce( magmom_each_wfn, work, kv3/ndim_spinor *neg *3, &
            &              mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )
       magmom_each_wfn = work
       deallocate( work )
    endif

!
    neg_t = neg -num_extra_bands

    if ( ekmode == on ) then
       if ( mype == 0 ) then
          if ( nk_in_the_process == 1 ) then
             call m_Files_open_nfwfk_integ_mom(2)
             write(nfwfk_integ_mom,'(A,I8)') 'num_kpoints = ', kv3_ek /ndim_spinor
             write(nfwfk_integ_mom,'(A,I8)') 'num_bands   = ', neg_t
             write(nfwfk_integ_mom,'(A,I8)') 'nspin       = ', nspin /ndim_spinor
                                                ! in order to work band**pl properly
             write(nfwfk_integ_mom,*)
          else
             call m_Files_open_nfwfk_integ_mom(3)
          endif
       endif
    else
       if ( mype == 0 ) then
          call m_Files_open_nfwfk_integ_mom(icond)
          write(nfwfk_integ_mom,'(A,I8)') 'num_kpoints = ', kv3 /ndim_spinor
          write(nfwfk_integ_mom,'(A,I8)') 'num_bands   = ', neg_t
          write(nfwfk_integ_mom,'(A,I8)') 'nspin       = ', nspin
          write(nfwfk_integ_mom,*)
       endif
    endif

    if ( ekmode == ON ) then
       if ( mype == 0 ) then
          Do ik=1, kv3, ndim_spinor
             write(nfwfk_integ_mom,'(A)') "================= "
             write(nfwfk_integ_mom,'(" ik = ",i4," (",3f10.6," )")') &
                  &                   ik +nk_in_the_process-1, (vkxyz(ik,1:3,BUCS))
             Do ie=1, neg_t
                ik2 = ( ik -1 )/ndim_spinor +1
                write(nfwfk_integ_mom,'(I5,3F16.8)') ie, magmom_each_wfn( ik2, ie, 1:3 )
             End Do
          End Do
          write(nfwfk_integ_mom,*)
       endif
    else
       if ( mype == 0 ) then
          Do ik=1, kv3, ndim_spinor
             write(nfwfk_integ_mom,'(A)') "================= "
             write(nfwfk_integ_mom,'(" ik = ",i4," (",3f10.6," )")') &
                  &                   ik, (vkxyz(ik,1:3,BUCS))
             Do ie=1, neg_t
                ik2 = ( ik -1 )/ndim_spinor +1
                write(nfwfk_integ_mom,'(I5,3F16.8)') ie, magmom_each_wfn( ik2, ie, 1:3 )
             End Do
          End Do
          write(nfwfk_integ_mom,*)
       endif
    endif

    deallocate( magmom_each_wfn )

    call m_Files_close_nfwfk_integ_mom

  end subroutine m_ESIO_wd_Wfn_integ_magmom

  subroutine m_ESIO_wd_EigenValues_bxsf
    integer :: ik, ib,jb,ibo,jbo, neg_t
    integer :: lun, nbz_mesh(3), ispin
    integer :: kv3_wk

    integer, allocatable :: neordr_t(:,:), kvtab(:)
    real(kind=DP), parameter :: delta = 1.d-12

    if ( ekmode == ON ) then
       allocate(neordr_t(neg,kv3_ek));   neordr_t = 0
       neg_t = neg
       if(neg_is_enlarged) neg_t = neg -num_extra_bands

       do ik = 1, kv3_ek, ndim_spinor
          if (nspin == 1 .or. (nspin == 2 .and. mod(ik,2) == 1)) &
               & neordr_t(1:neg,ik) = (/(ib,ib=1,neg)/)
          do ib = 1, neg-1
             do jb = ib+1, neg
                ibo = neordr_t(ib,ik);  jbo = neordr_t(jb,ik)
                if ( eko_ek(jbo,ik) < eko_ek(ibo,ik)-delta ) then        ! MPI
                   neordr_t(jb,ik) = ibo;    neordr_t(ib,ik) = jbo
                end if
             end do
          end do
       end do
    else
       !write(*,*) "ekmode == Off is not supported "
       call phase_error_with_msg(6,"ekmode == Off is not supported ",__LINE__,__FILE__)
    endif

    call m_Kp_get_nkmesh( nbz_mesh )
    kv3_wk = ( nbz_mesh(1) +1 )*( nbz_mesh(2) +1 )*( nbz_mesh(3) +1 ) *nspin

    allocate(kvtab(kv3_wk));  kvtab = 0
    call m_Kp_get_kptable_bxsf( kv3_wk, kvtab, 1 )

    lun = 360
    Do ispin=1, nspin, ndim_spinor
       if ( nspin == 1 .or. ndim_spinor == 2 ) then
          Open( unit=lun, file="./myband.bxsf", status="unknown", form="formatted" )
       else
          if ( ispin == 1 ) then
             Open( unit=lun, file="./myband_up.bxsf", status="unknown", &
                  &          form="formatted" )
          else
             Open( unit=lun, file="./myband_down.bxsf", status="unknown", &
                  &          form="formatted" )
          endif
       endif
       call print_header( lun );  call print_body( lun );   call print_tail( lun )
       close( lun )
    End Do

    deallocate(kvtab)
    if ( allocated(neordr_t) ) deallocate(neordr_t);

  contains

    subroutine print_header( lun )
      integer, intent(in) :: lun

      write( lun, '(A)') "BEGIN_INFO"
      write( lun, '(A)') "  #"
      write( lun, '(A)') "  # this is a Band-XCRYSDEN-Structure-File"
      write( lun, '(A)') "  #  aimed for Visualization of Fermi Surface"
      write( lun, '(A)') "  #"
      write( lun, '(A,F20.15)') "    Fermi Energy:",  0.0d0
      write( lun, '(A)') "END_INFO"
      write( lun, * )
      write( lun, '(A)') "BEGIN_BLOCK_BANDGRID_3D"
      write( lun, '(A)') "  from_phase/0"
      write( lun, '(A)') "  BEGIN_BANDGRID_3D_fermi"
      write( lun, '(I6)') neg_t
      write( lun, '(3I6)') nbz_mesh(1:3) +1
      write( lun, '(3F10.2)') 0.0, 0.0, 0.0
      write( lun, '(3F12.8)') rltv(1:3,1) /Bohr
      write( lun, '(3F12.8)') rltv(1:3,2) /Bohr
      write( lun, '(3F12.8)') rltv(1:3,3) /Bohr
    end subroutine print_header

    subroutine print_body( lun )
      integer, intent(in) :: lun
      integer ib, ik

      if ( ekmode == ON ) then
         if ( ndim_spinor == 1 ) then
            Do ib=1, neg_t
               write( lun, '(A,I8)') "    BAND: ", ib
               write( lun, '(5F15.8)') &
                    &   ( ( eko_ek( neordr_t(ib,kvtab(ik)),kvtab(ik) )-efermi ) &
                    &         *Hartree,  ik=ispin,kv3_wk,nspin )
            End Do
         else
            Do ib=1, neg_t
               write( lun, '(A,I8)') "    BAND: ", ib
               write( lun, '(5F15.8)') &
                    &   ( ( eko_ek( neordr_t(ib,kvtab(ik)),kvtab(ik) ) -efermi ) &
                    &          *Hartree, ik=ispin,kv3_wk,nspin )
            End Do
         endif
      endif
    end subroutine print_body

    subroutine print_tail( lun )
      integer, intent(in) :: lun
       write( lun, '(A)') "  END_BANDGRID_3D_fermi"
       write( lun, '(A)') "END_BLOCK_BANDGRID_3D"
    end subroutine print_tail

  end subroutine m_ESIO_wd_EigenValues_bxsf

  subroutine m_ESIO_wd_EigenValues_frmsf
    integer :: ik, ib,jb,ibo,jbo, neg_t
    integer :: lun, nbz_mesh(3), ispin
    integer :: kv3_wk

    integer, allocatable :: neordr_t(:,:), kvtab(:)
    real(kind=DP), parameter :: delta = 1.d-12

    if ( ekmode == ON ) then
       allocate(neordr_t(neg,kv3_ek));   neordr_t = 0
       neg_t = neg
       if(neg_is_enlarged) neg_t = neg -num_extra_bands

       do ik = 1, kv3_ek, ndim_spinor
          if (nspin == 1 .or. (nspin == 2 .and. mod(ik,2) == 1)) &
               & neordr_t(1:neg,ik) = (/(ib,ib=1,neg)/)
          do ib = 1, neg-1
             do jb = ib+1, neg
                ibo = neordr_t(ib,ik);  jbo = neordr_t(jb,ik)
                if ( eko_ek(jbo,ik) < eko_ek(ibo,ik)-delta ) then        ! MPI
                   neordr_t(jb,ik) = ibo;    neordr_t(ib,ik) = jbo
                end if
             end do
          end do
       end do
    else
       !write(*,*) "ekmode == Off is not supported "
       call phase_error_with_msg(6,"ekmode == Off is not supported ",__LINE__,__FILE__)
    endif

    call m_Kp_get_nkmesh( nbz_mesh )
    kv3_wk = ( nbz_mesh(1) )*( nbz_mesh(2) )*( nbz_mesh(3) ) *nspin

    allocate(kvtab(kv3_wk));  kvtab = 0
    call m_Kp_get_kptable_bxsf( kv3_wk, kvtab, 0 )

    lun = 360
    Do ispin=1, nspin, ndim_spinor
       if ( nspin == 1 .or. ndim_spinor == 2 ) then
          Open( unit=lun, file="./myband.frmsf", status="unknown", form="formatted" )
       else
          if ( ispin == 1 ) then
             Open( unit=lun, file="./myband_up.frmsf", status="unknown", &
                  &          form="formatted" )
          else
             Open( unit=lun, file="./myband_down.frmsf", status="unknown", &
                  &          form="formatted" )
          endif
       endif
       call print_header( lun );  call print_body( lun );   call print_tail( lun )
       close( lun )
    End Do

    deallocate(kvtab)
    if ( allocated(neordr_t) ) deallocate(neordr_t);

  contains

    subroutine print_header( lun )
      integer, intent(in) :: lun

      write( lun, '(3I6)') nbz_mesh(1:3)
      write( lun, '(I6)') 1
      write( lun, '(I6)') neg_t
      write( lun, '(3F12.8)') rltv(1:3,1) /Bohr
      write( lun, '(3F12.8)') rltv(1:3,2) /Bohr
      write( lun, '(3F12.8)') rltv(1:3,3) /Bohr
    end subroutine print_header

    subroutine print_body( lun )
      integer, intent(in) :: lun
      integer ib, ik

      if ( ekmode == ON ) then
         if ( ndim_spinor == 1 ) then
            Do ib=1, neg_t
               write( lun, '(5F15.8)') &
                    &   ( ( eko_ek( neordr_t(ib,kvtab(ik)),kvtab(ik) )-efermi ) &
                    &         *Hartree,  ik=ispin,kv3_wk,nspin )
            End Do
         else
            Do ib=1, neg_t
               write( lun, '(5F15.8)') &
                    &   ( ( eko_ek( neordr_t(ib,kvtab(ik)),kvtab(ik) ) -efermi ) &
                    &          *Hartree, ik=ispin,kv3_wk,nspin )
            End Do
         endif
      endif
    end subroutine print_body

    subroutine print_tail( lun )
      integer, intent(in) :: lun
    end subroutine print_tail

  end subroutine m_ESIO_wd_EigenValues_frmsf

  subroutine m_ESIO_wd_wfn_parity
    use m_Control_Parameters, only : eval_parity_on_fftmesh
    use m_Const_Parameters,   only : ELECTRON, INVERSE, INITIAL, FIXED_CHARGE, zi
    use m_Crystal_Structure,  only : tau, nopr, op, Global_Quantz_Axis_Fixed
    use m_Ionic_System,       only : pos
    use m_PseudoPotential,    only : ltp
    use m_PlaneWaveBasisSet,  only : kg, igf, ngpt_l, nbase_gamma
    use m_Files,              only : nfout
    use m_FFT,                only : m_FFT_alloc_WF_work, m_FFT_dealloc_WF_work, &
         &                           m_FFT_WF

    integer :: iopr_inv
    real(kind=DP) :: inv_center(3)

    integer, allocatable :: ngpt_inv(:), igf_shift(:,:,:,:)
    real(kind=DP), allocatable :: eko_wk(:,:), moment_wk(:,:,:)
    complex(kind=CMPLDP), allocatable, target :: parity_bands(:,:)

    call chkif_system_has_inv_symm
    if ( iopr_inv == 0 ) then
       !write(*,*) "The system does not have inversion symmetry."
       call phase_error_with_msg(nfout,"The system does not have inversion symmetry.",__LINE__,__FILE__)
    endif

    allocate( eko_wk(neg,kv3/ndim_spinor) );  eko_wk = 0.0d0
    allocate( moment_wk(ndim_magmom,neg,kv3/ndim_spinor) ); moment_wk = 0.0d0
    call set_eko_wk
    call calc_moment_wk

    allocate( parity_bands( ista_e:iend_e, ista_k:iend_k ) )
    parity_bands = 0.0d0

    if ( eval_parity_on_fftmesh == YES ) then
       call softpart_eval_on_Rspace
    else
       allocate( ngpt_inv(kg) );  ngpt_inv = 0
       call set_ngpt_inv( iopr_inv, ngpt_inv )
       call set_igf_with_shift
       call softpart_eval_on_Gspace
    endif

    call hardpart
    call print_parity

    deallocate( parity_bands );
    deallocate( eko_wk );    deallocate( moment_wk )
    if ( allocated( ngpt_inv ) ) deallocate( ngpt_inv )
    if ( allocated( igf_shift ) ) deallocate( igf_shift )

  contains

    subroutine set_eko_wk
      integer :: ik, ie, ierr, iksnl
      real(kind=DP), allocatable :: eko_mpi(:,:), occ_mpi(:,:)

      if ( noncol ) then
         do ik = 1, kv3, ndim_spinor
            if (map_k(ik) /= myrank_k) cycle
            iksnl = (ik-1)/nspin + 1
            do ie = 1, neg
               if (map_e(ie) /= myrank_e) cycle
               eko_wk(ie,iksnl) = eko_l(map_z(ie),ik)
            end do
         end do
      else
         do ik = 1, kv3
            if (map_k(ik) /= myrank_k) cycle
            do ie = 1, neg
               if (map_e(ie) /= myrank_e) cycle
               eko_wk(ie,ik) = eko_l(map_z(ie),ik)
            end do
         end do
      endif

      if ( npes > 1 ) then
         allocate( eko_mpi(neg,kv3/ndim_spinor) ); eko_mpi = 0.0d0
         call mpi_allreduce( eko_wk, eko_mpi, neg*kv3/ndim_spinor, mpi_double_precision,&
              &              mpi_sum, MPI_CommGroup, ierr )
         eko_wk = eko_mpi;
         deallocate( eko_mpi );
      endif
    end subroutine set_eko_wk

    subroutine calc_moment_wk
      integer :: ik, iksnl, ib, ie, is, ig
      integer :: ia, it, lmt1, lmt2, p1, p2
      complex(kind=CMPLDP) :: z1, z2, z3, z4, ztmp1, ztmp2, ztmp3, ztmp4
      real(kind=DP) :: csum(ndim_magmom)
      real(kind=DP), allocatable :: mom_mpi(:,:,:)

      if ( noncol ) then
         Do ik=ista_k, iend_k, ndim_spinor
            iksnl = (ik-1)/nspin + 1
            Do ie =ista_e, iend_e, istep_e
               ib = map_z(ie)
               csum = 0.0d0
               Do ig=1, iba(ik)
                  z1 = cmplx( zaj_l(ig,ib,ik,1),   zaj_l(ig,ib,ik,2) )
                  z2 = cmplx( zaj_l(ig,ib,ik+1,1), zaj_l(ig,ib,ik+1,2) )
                  csum(1) = csum(1) +conjg(z1)*z1 +conjg(z2)*z2
                  csum(2) = csum(2) +conjg(z1)*z2 +conjg(z2)*z1
                  csum(3) = csum(3) +( -conjg(z1)*z2 +conjg(z2)*z1 )*zi
                  csum(4) = csum(4) +conjg(z1)*z1 -conjg(z2)*z2
               End Do
               !
               do ia = 1, natm
                  it = ityp(ia)
                  do lmt1 = 1, ilmt(it)
                     p1 = lmta(lmt1,ia)
                     do lmt2 = 1, ilmt(it)
                        p2 = lmta(lmt2,ia)
                        z1 = cmplx( fsr_l(ib,p1,ik),   fsi_l(ib,p1,ik) )
                        z2 = cmplx( fsr_l(ib,p1,ik+1), fsi_l(ib,p1,ik+1) )
                        z3 = cmplx( fsr_l(ib,p2,ik),   fsi_l(ib,p2,ik) )
                        z4 = cmplx( fsr_l(ib,p2,ik+1), fsi_l(ib,p2,ik+1) )
                        ztmp1 = conjg(z1)*z3 +conjg(z2)*z4
                        ztmp2 = conjg(z1)*z4 +conjg(z2)*z3
                        ztmp3 = ( -conjg(z1)*z4 +conjg(z2)*z3 ) *zi
                        ztmp4 = conjg(z1)*z3 -conjg(z2)*z4
                        csum(1) = csum(1) +q(lmt1,lmt2,it) *ztmp1
                        csum(2) = csum(2) +q(lmt1,lmt2,it) *ztmp2
                        csum(3) = csum(3) +q(lmt1,lmt2,it) *ztmp3
                        csum(4) = csum(4) +q(lmt1,lmt2,it) *ztmp4
                     End do
                  End do
               End do
               moment_wk(1:4,ie,iksnl) = csum(1:4)
            End Do
         End Do
      else
      endif
      if ( npes > 1 ) then
         allocate( mom_mpi(ndim_magmom,neg,kv3/ndim_spinor) ); mom_mpi = 0.0d0
         call mpi_allreduce( moment_wk, mom_mpi, ndim_magmom*neg*kv3/ndim_spinor, &
              &              mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )
         moment_wk = mom_mpi;
         deallocate( mom_mpi );
      endif
    end subroutine calc_moment_wk

    subroutine print_parity
      integer :: ierr, ik, ib, is, lun, iksnl
      real(kind=DP) :: c1, cmul(ndim_spinor)
      complex(kind=CMPLDP) :: z1
      complex(kind=CMPLDP), allocatable, target :: work(:,:)
      complex(kind=CMPLDP), allocatable, target :: work2(:,:)
      complex(kind=CMPLDP), pointer :: wk_array(:,:)
      logical, save :: First = .true.

      lun = 1000

      if ( npes > 1 ) then
         allocate( work(neg,kv3) );  work  = 0.0d0
         allocate( work2(neg,kv3) ); work2 = 0.0d0
         work(ista_e:iend_e,ista_k:iend_k) = parity_bands(ista_e:iend_e,ista_k:iend_k)
         call mpi_allreduce( work, work2, 2*neg*kv3, mpi_double_precision, &
              &              mpi_sum, MPI_CommGroup, ierr )
         deallocate(work)
         wk_array => work2
      else
         wk_array => parity_bands
      endif

      if ( mype == 0 ) then
         if ( ekmode == ON ) then
            if ( nk_in_the_process == 1 ) then
               open( lun, file="WF_parity", status="unknown", form="formatted")
               write(lun,'(A)') '####### Parity Eigenvalues #######'
            else
               open( lun, file="WF_parity", status="unknown", form="formatted", &
                    &     position = 'append' )
            endif

            Do ik=1, kv3, ndim_spinor
               iksnl = (ik-1)/ndim_spinor + 1
               write(lun,'(A,I6,A,3F16.8,A)') 'ik = ', &
                    &       ik +nk_in_the_process -1, " ( ", vkxyz(ik,1:3,BUCS), " )"
               write(lun,'(A,5X,A,12X,A)') &
                    &     "band ", "energy", "parity"

               cmul = 1.0d0
               Do ib=1, neg
                  if ( noncol ) then
                     c1 = moment_wk(2,ib,iksnl) *Global_Quantz_Axis_Fixed(1) &
                          & +moment_wk(3,ib,iksnl) *Global_Quantz_Axis_Fixed(2) &
                          & +moment_wk(4,ib,iksnl) *Global_Quantz_Axis_Fixed(3)
                  else
                     c1 = 1.0d0
                  endif

                  z1 = 0.0d0
                  Do is=1, ndim_spinor
                     z1 = z1 +wk_array(ib,ik+is-1)
                  End Do

                  if ( c1 > 0.0 ) then
                     write(lun,'(I5,2X,F16.12,2X,F10.5)') &
                          &     ib, ( eko_wk(ib,iksnl) -efermi )*Hartree, real(z1)
                  else
                     write(lun,'(I5,2X,F16.12,2X,10X,F10.5)') &
                          &     ib, ( eko_wk(ib,iksnl) -efermi )*Hartree, real(z1)
                  endif

                  if ( eko_wk(ib,iksnl) <= efermi ) then
                     if ( noncol ) then
                        if ( c1 > 0.0 ) then
                           cmul(1) = cmul(1) *real(z1)
                        else
                           cmul(2) = cmul(2) *real(z1)
                        endif
                     else
                        cmul = cmul *real(z1)
                     endif
                  endif
               End Do
               write(lun,'(A)')
               write(lun,'(A)') " product of eigenvalues (below EF) : "
               if ( noncol ) then
                  write(lun,'(25X,2F10.5)') cmul
               else
                  write(lun,'(25X,F10.5)') cmul
               endif
               write(lun,'(A)')
            End Do

            close(lun)

         else
            if ( icond == INITIAL .or. icond == FIXED_CHARGE ) then
               open( lun, file="WF_parity", status="unknown", form="formatted")
               write(lun,'(A)') '####### Parity Eigenvalues #######'
            else
               open( lun, file="WF_parity", status="unknown", form="formatted", &
                    &     position = 'append' )
            endif

            Do ik=1, kv3, ndim_spinor
               iksnl = (ik-1)/ndim_spinor + 1
               write(lun,'(A,I6,A,3F16.8,A)') 'ik = ', &
                    &       ik, " ( ", vkxyz(ik,1:3,BUCS), " )"
               write(lun,'(A,5X,A,12X,A)') &
                    &     "band ", "energy", "parity"

               cmul = 1.0d0
               Do ib=1, neg
                  c1 = moment_wk(2,ib,iksnl) *Global_Quantz_Axis_Fixed(1) &
                       & +moment_wk(3,ib,iksnl) *Global_Quantz_Axis_Fixed(2) &
                       & +moment_wk(4,ib,iksnl) *Global_Quantz_Axis_Fixed(3)

                  z1 = 0.0d0
                  Do is=1, ndim_spinor
                     z1 = z1 +wk_array(ib,ik+is-1)
                  End Do

                  if ( c1 > 0.0 ) then
                     write(lun,'(I5,2X,F16.12,2X,F10.5)') &
                          &     ib, ( eko_wk(ib,iksnl) -efermi )*Hartree, real(z1)
                  else
                     write(lun,'(I5,2X,F16.12,2X,10X,F10.5)') &
                          &     ib, ( eko_wk(ib,iksnl) -efermi )*Hartree, real(z1)
                  endif

                  if ( eko_wk(ib,iksnl) <= efermi ) then
                     if ( noncol ) then
                        if ( c1 > 0.0 ) then
                           cmul(1) = cmul(1) *real(z1)
                        else
                           cmul(2) = cmul(2) *real(z1)
                        endif
                     else
                        cmul = cmul *real(z1)
                     endif
                  endif
               End Do
               write(lun,'(A)')
               write(lun,'(A)') " product of eigenvalues (below EF) : "
               if ( noncol ) then
                  write(lun,'(25X,2F10.5)') cmul
               else
                  write(lun,'(25X,F10.5)') cmul
               endif
               write(lun,'(A)')
            End Do
            close(lun)
         end if
      endif

      if ( allocated(work2) ) deallocate( work2 )
    end subroutine print_parity

    subroutine chkif_system_has_inv_symm
      integer :: iopr
      real(kind=DP) :: c1

      iopr_inv = 0;     inv_center = 0.0d0
      Do iopr=1, nopr
         c1 = op(1,1,iopr)+op(2,2,iopr)+op(3,3,iopr)
         if ( abs( c1 +3.d0 ) < 1.0D-3 ) then
            iopr_inv = iopr
            inv_center(:) = tau(:,iopr,BUCS) /2.0d0
         endif
      End Do
    end subroutine chkif_system_has_inv_symm

    subroutine softpart_eval_on_Gspace
      integer :: ib1, ik, is, ig, ip1, i, nshift(3)
      real(kind=DP) :: vec(3), vec2(3), c1
      real(kind=DP) :: dnorm, c2r, c2i
      complex(kind=CMPLDP) :: zsum

      real(kind=DP), allocatable :: wf1(:), wf2(:), zfcos(:), zfsin(:)

      dnorm = sqrt( inv_center(1)**2 +inv_center(2)**2 +inv_center(3)**2 )
      if ( dnorm > 1.0D-3 ) then
         allocate( zfcos(kg1) );    allocate( zfsin(kg1) )
      endif

      allocate( wf1(nfft) ); wf1 = 0.0d0;
      allocate( wf2(nfft) ); wf2 = 0.0d0;

      Do ik = 1, kv3
         if ( map_k(ik) /= myrank_k ) cycle! MPI
         vec(:) = vkxyz(ik,:,BUCS)*2.d0
         vec2(:) = vec(:) -nint(vec(:))
         c1 = sqrt( vec2(1)**2 +vec2(2)**2 +vec2(3)**2 )
         if ( c1 > 1.0D-3 ) cycle

         nshift(:) = -nint(vec(:))

         if ( dnorm > 1.0D-3 ) then
            zfcos = 0.0d0;  zfsin = 0.0d0
            do ig = 1, iba(ik)
               ip1 = nbase(ig,ik)
               vec(:) = vkxyz(ik,:,BUCS) + ngabc(ip1,:)
               c1 = vec(1) *inv_center(1) +vec(2) *inv_center(2) +vec(3) *inv_center(3)
               c1 = 2.d0 *c1 *PAI2
               zfcos(ig) = cos(c1);    zfsin(ig) = sin(c1)
            End Do
         endif
         Do ib1 = ista_e, iend_e, istep_e     ! MPI
            if ( dnorm > 1.0D-3 ) then
               call map_WF_on_fftmesh( ik, ik, ik, zaj_l(:,map_z(ib1),ik,:), wf1, &
                    &                  igf_shift(:,nshift(1),nshift(2),nshift(3)), &
                    &                  zfcos, zfsin )
            else
               call map_WF_on_fftmesh( ik, ik, ik, zaj_l(:,map_z(ib1),ik,:), wf1, &
                    &                  igf_shift(:,nshift(1),nshift(2),nshift(3)) )
            endif
            call map_WF_on_fftmesh( ik, ik, ik, zaj_l(:,map_z(ib1),ik,:), wf2, &
                 &                  igf )
            zsum = 0.0d0
            Do i=1, nfft, 2
               c2r = wf2(i) *wf1(i)  +wf2(i+1) *wf1(i+1)
               c2i = wf2(i) *wf1(i+1)-wf2(i+1) *wf1(i)
               zsum = zsum +cmplx(c2r,c2i)
            End Do
            parity_bands( ib1,ik ) = zsum
         End Do
      End Do

      deallocate( wf1 );    deallocate( wf2 )
      if ( allocated(zfcos) ) deallocate( zfcos )
      if ( allocated(zfsin) ) deallocate( zfsin )

    end subroutine softpart_eval_on_Gspace

    subroutine softpart_eval_on_Rspace
      integer :: ib1, ik, is, ig
      integer :: ix1, iy1, iz1, ix2, iy2, iz2, nxy, ip1, ip2
      real(kind=DP) :: c1, c2r, c2i, c3r, c3i, dnorm
      real(kind=DP) :: da(3), damul, vec(3), cos1, sin1, vec2(3)
      complex(kind=CMPLDP) :: zsum
      real(kind=DP), allocatable :: wf1(:), zfcos(:), zfsin(:)

      nxy = fft_box_size_WF(1,0) *fft_box_size_WF(2,0)
      da(1:3) = 1.d0/fft_box_size_WF(1:3,1)
      damul = da(1) *da(2) *da(3)

      allocate( wf1(nfft) ); wf1 = 0.0d0;
      call m_FFT_alloc_WF_work()
      !
      dnorm = sqrt( inv_center(1)**2 +inv_center(2)**2 +inv_center(3)**2 )
      if ( dnorm > 1.0D-3 ) then
         allocate( zfcos(kg1) );    allocate( zfsin(kg1) )
      endif

      Do ik = 1, kv3
         if ( map_k(ik) /= myrank_k ) cycle! MPI
         !
         vec(:) = vkxyz(ik,:,BUCS)*2.d0
         vec2(:) = vec(:) -nint(vec(:))
         c1 = sqrt( vec2(1)**2 +vec2(2)**2 +vec2(3)**2 )
         if ( c1 > 1.0D-3 ) cycle

         if ( dnorm > 1.0D-3 ) then
            zfcos = 0.0d0;  zfsin = 0.0d0
            do ig = 1, iba(ik)
               ip1 = nbase(ig,ik)
               vec(:) = vkxyz(ik,:,BUCS) + ngabc(ip1,:)
               c1 = vec(1) *inv_center(1) +vec(2) *inv_center(2) +vec(3) *inv_center(3)
               c1 = c1 *PAI2
               zfcos(ig) = cos(c1);    zfsin(ig) = sin(c1)
            End Do
         endif

         Do ib1 = ista_e, iend_e, istep_e     ! MPI
            if ( dnorm > 1.0D-3 ) then
               call map_WF_on_fftmesh( ik, ik, ik, zaj_l(:,map_z(ib1),ik,:), &
                    &                  wf1, igf, zfcos, zfsin )
               call m_FFT_WF( ELECTRON, nfout, wf1, INVERSE, ON )
            else
               call m_ES_WF_in_Rspace( ik, ib1, wf1 )  ! unk(r)
            endif

            ! unk(-r)
            zsum = 0.0d0

            Do ix1=1, fft_box_size_WF(1,1)
               Do iy1=1, fft_box_size_WF(2,1)
                  Do iz1=1, fft_box_size_WF(3,1)
                     ip1 = (iz1-1) *nxy +(iy1-1) *fft_box_size_WF(1,0) +ix1
                     ix2 = mod( 1-ix1 +fft_box_size_WF(1,1),fft_box_size_WF(1,1) )+1
                     iy2 = mod( 1-iy1 +fft_box_size_WF(2,1),fft_box_size_WF(2,1) )+1
                     iz2 = mod( 1-iz1 +fft_box_size_WF(3,1),fft_box_size_WF(3,1) )+1
                     ip2 = (iz2-1) *nxy +(iy2-1) *fft_box_size_WF(1,0) +ix2
! exp( -2*i *k*r )
                     c1 = vkxyz(ik,1,BUCS) *( ix1 -1 )*da(1) &
                          & +vkxyz(ik,2,BUCS) *( iy1 -1 )*da(2) &
                          & +vkxyz(ik,3,BUCS) *( iz1 -1 )*da(3)
                     cos1 = cos( -2.0 *c1 *PAI2 )
                     sin1 = sin( -2.0 *c1 *PAI2 )

                     c2r = wf1( 2*ip1-1 )*wf1( 2*ip2-1 ) +wf1( 2*ip1 )*wf1( 2*ip2 )
                     c2i = wf1( 2*ip1-1 )*wf1( 2*ip2 )   -wf1( 2*ip1 )*wf1( 2*ip2-1 )
                     !
                     c3r = c2r *cos1 -c2i *sin1
                     c3i = c2r *sin1 +c2i *cos1
                     zsum = zsum +cmplx(c3r,c3i)
                  end Do
               end Do
            end Do
            parity_bands( ib1,ik ) = zsum *damul
         End Do
      End Do

      call m_FFT_dealloc_WF_work()

      deallocate( wf1 )
      if ( allocated(zfcos) ) deallocate( zfcos )
      if ( allocated(zfsin) ) deallocate( zfsin )

    end subroutine softpart_eval_on_Rspace

    subroutine hardpart
      integer :: ia, ja, it, ib1, ik, i
      integer :: lmt1, lmt2, p1, p2, il2
      real(kind=DP) :: dx, dy, dz, c1r, c1i, dist, fac, pos_a_inv(3)
      real(kind=DP) :: ph, c3r, c3i, vec(3), vec2(3)
      complex(kind=CMPLDP) :: zsum

      integer, allocatable :: inv_ia(:)
      real(kind=DP), allocatable :: pos_t(:,:), wkcos(:), wksin(:)

      allocate( pos_t(natm,3) )
      allocate( inv_ia(natm) ); inv_ia = 0

      pos_t(1:natm,1:3) = pos(1:natm,1:3)
      do ia = 1, natm
         do i = 1, 3
            pos_t(ia,i) = pos_t(ia,i) - floor(pos_t(ia,i))
         end do
      end do
      Do ia=1, natm
         pos_a_inv(:) = -pos_t(ia,:) +inv_center(:) *2.d0
         pos_a_inv(:) = pos_a_inv(:) - floor(pos_a_inv(:))
         loop_ja: Do ja=1, natm
            dx = pos_t(ja,1) -pos_a_inv(1)
            dy = pos_t(ja,2) -pos_a_inv(2)
            dz = pos_t(ja,3) -pos_a_inv(3)
            dist = sqrt( dx**2 +dy**2 +dz**2 )
            if ( dist < 1.0D-5 ) then
               inv_ia(ia) = ja;     exit loop_ja
            endif
         End Do loop_ja
      End Do
      !
      Do ia=1, natm
         if ( inv_ia(ia) == 0 ) then
            write(*,*) "Inverted atom is not found for atom", ia
            call phase_error_with_msg(nfout,"Inverted atom is not found ",__LINE__,__FILE__)
         endif
      End Do

      allocate( wkcos(natm) );    allocate( wksin(natm) )

      Do ik = 1, kv3
         if ( map_k(ik) /= myrank_k ) cycle! MPI

         vec(:) = vkxyz(ik,:,BUCS)*2.d0
         vec2(:) = vec(:) -nint(vec(:))
         c1r = sqrt( vec2(1)**2 +vec2(2)**2 +vec2(3)**2 )
         if ( c1r > 1.0D-3 ) cycle
         !
         Do ia=1, natm
            ph = vkxyz(ik,1,BUCS) *( inv_center(1) -pos_t(ia,1) ) &
                 & +vkxyz(ik,2,BUCS) *( inv_center(2) -pos_t(ia,2) ) &
                 & +vkxyz(ik,3,BUCS) *( inv_center(3) -pos_t(ia,3) )
            c1r = 2.0 *ph *PAI2
            wkcos(ia) = cos(c1r);  wksin(ia) = sin(c1r)
         End Do

         Do ib1 = ista_e, iend_e, istep_e     ! MPI
            zsum = 0.0d0

            Do ia=1, natm
               it = ityp(ia)
               do lmt1 = 1, ilmt(it)
                  p1 = lmta(lmt1,ia)
                  if (k_symmetry(ik) == GAMMA) then
                     do lmt2 = 1, ilmt(it)
                        il2 = ltp(lmt2,it) -1
                        fac = 1.0d0
                        if ( mod(il2, 2) == 1 ) fac =-fac

                        p2 = lmta(lmt2,inv_ia(ia))
                        c1r = fsr_l(map_z(ib1),p1,ik) *fsr_l(map_z(ib1),p2,ik)

                        zsum = zsum +fac *c1r *q(lmt1,lmt2,it)
                     end do

                  else
                     do lmt2 = 1, ilmt(it)
                        il2 = ltp(lmt2,it) -1
                        fac = 1.0d0
                        if ( mod(il2, 2) == 1 ) fac =-fac

                        p2 = lmta(lmt2,inv_ia(ia))
                        c1r = fsr_l(map_z(ib1),p1,ik) *fsr_l(map_z(ib1),p2,ik) &
                             & +fsi_l(map_z(ib1),p1,ik) *fsi_l(map_z(ib1),p2,ik)
                        c1i = fsr_l(map_z(ib1),p1,ik) *fsi_l(map_z(ib1),p2,ik) &
                             &  -fsi_l(map_z(ib1),p1,ik) *fsr_l(map_z(ib1),p2,ik)

                        c3r = c1r *wkcos(ia) -c1i *wksin(ia)
                        c3i = c1r *wksin(ia) +c1i *wkcos(ia)

                        zsum = zsum +fac *cmplx(c3r,c3i) *q(lmt1,lmt2,it)
                     end do
                  endif
               End do
            End Do
            parity_bands(ib1,ik) = parity_bands(ib1,ik) +zsum
         End Do
      End Do
      deallocate( pos_t );  deallocate( inv_ia )
      deallocate( wkcos );  deallocate( wksin )
    end subroutine hardpart

    subroutine set_igf_with_shift
      integer :: id, i, i2
      integer :: igf1, igf2, igf3, nx, ny, nz
      integer :: nxmin, nymin, nzmin, nxmax, nymax, nzmax
      !
      nxmin = -1;   nxmax = 1
      nymin = -1;   nymax = 1
      nzmin = -1;   nzmax = 1

      allocate( igf_shift( kg, nxmin:nxmax, nymin:nymax, nzmin:nzmax ) )
      igf_shift = 0
      !
      id = fft_box_size_WF(1,0)

      Do nx=nxmin, nxmax
         Do ny=nymin, nymax
            Do nz=nzmin, nzmax
               do i = 1, kg
                  i2 = ngpt_inv(i)
                  igf1 = ngabc(i2,1) + nx +1
                  igf2 = ngabc(i2,2) + ny +1
                  igf3 = ngabc(i2,3) + nz +1
                  !
                  if ( igf1 <= 0 ) igf1 = igf1 + fft_box_size_WF(1,1)
                  if ( igf2 <= 0 ) igf2 = igf2 + fft_box_size_WF(2,1)
                  if ( igf3 <= 0 ) igf3 = igf3 + fft_box_size_WF(3,1)

                  igf_shift(i,nx,ny,nz) = igf1 + (igf2-1)*id &
                       &                 + (igf3-1)*id*fft_box_size_WF(2,0)
               enddo
            End Do
         End Do
      ENd Do
    end subroutine set_igf_with_shift

    subroutine map_WF_on_fftmesh( k1, k2, ik, psi_l, bfft, igf_in, zfcos, zfsin )
      integer, intent(in) :: k1, k2, ik
      integer, intent(in) :: igf_in( kg )
      real(kind=DP), intent(in) :: psi_l( kg1, 1, k1:k2, kimg )
      real(kind=DP), intent(in), optional :: zfcos( kg1 ), zfsin( kg1 )
      real(kind=DP), intent(inout) :: bfft( nfft )

      integer :: i,i1,ri, j, i2, ii
      real(kind=DP) :: c1, c2

      bfft = 0.d0
      if(k_symmetry(ik) == GAMMA) then
         if(kimg == 1) then
            i1 = igf_in(1)
            bfft(i1) = psi_l(1,1,ik,1)
#ifdef NEC_TUNE_SMP
            !CDIR NODEP
#endif
            if ( present(zfcos) ) then
               do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
                  i = nbase(ii,ik)
                  i1 = igf_in(i)
                  bfft(i1) = psi_l(ii,1,ik,1) *zfcos(ii)
                  j = nbase_gamma(ii,2)
                  i2 = igf_in(j)
                  bfft(i2) = psi_l(ii,1,ik,1) *zfcos(ii)
               end do
            else
               do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
                  i = nbase(ii,ik)
                  i1 = igf_in(i)
                  bfft(i1) = psi_l(ii,1,ik,1)
                  j = nbase_gamma(ii,2)
                  i2 = igf_in(j)
                  bfft(i2) = psi_l(ii,1,ik,1)
               end do
            endif

         else if(kimg == 2) then
            i1 = 2*igf_in(1) - 1
            bfft(i1)   = psi_l(1,1,ik,1)
            bfft(i1+1) = psi_l(1,1,ik,2)
#ifdef NEC_TUNE_SMP
            !CDIR NODEP
#endif
            if ( present(zfcos) ) then
               do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
                  i = nbase(ii,ik)
                  i1 = 2*igf_in(i)-1
                  c1 = psi_l(ii,1,ik,1) *zfcos(ii) -psi_l(ii,1,ik,2) *zfsin(ii)
                  c2 = psi_l(ii,1,ik,1) *zfsin(ii) +psi_l(ii,1,ik,2) *zfcos(ii)
                  bfft(i1  ) = c1;       bfft(i1+1) = c2

                  j = nbase_gamma(ii,2)
                  i2 = 2*igf_in(j)-1
                  c1 = psi_l(ii,1,ik,1) *zfcos(ii) -psi_l(ii,1,ik,2) *zfsin(ii)
                  c2 = psi_l(ii,1,ik,1) *zfsin(ii) +psi_l(ii,1,ik,2) *zfcos(ii)
                  bfft(i2  ) = c1;       bfft(i2+1) = -c2
               end do
            else
               do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
                  i = nbase(ii,ik)
                  i1 = 2*igf_in(i)-1
                  c1 = psi_l(ii,1,ik,1)
                  c2 = psi_l(ii,1,ik,2)
                  bfft(i1  ) = c1;       bfft(i1+1) = c2

                  j = nbase_gamma(ii,2)
                  i2 = 2*igf_in(j)-1
                  c1 = psi_l(ii,1,ik,1)
                  c2 = psi_l(ii,1,ik,2)
                  bfft(i2  ) = c1;       bfft(i2+1) = -c2
               end do
            end if
         endif
      else
#ifdef NEC_TUNE_SMP
         !CDIR NOLOOPCHG
#endif
         if ( present(zfcos) ) then
            if ( kimg == 1 ) then
               do i = 1, iba(ik)
                  i1 = igf_in(nbase(i,ik))
                  c1 = psi_l(i,1,ik,1) *zfcos(i)
                  bfft(i1) = c1
               end do
            else
               do i = 1, iba(ik)
                  i1 = kimg*igf_in(nbase(i,ik)) -1
                  c1 = psi_l(i,1,ik,1) *zfcos(i) -psi_l(i,1,ik,2) *zfsin(i)
                  c2 = psi_l(i,1,ik,1) *zfsin(i) +psi_l(i,1,ik,2) *zfcos(i)
                  bfft(i1) = c1;        bfft(i1+1) = c2
               end do
            endif
         else
            if ( kimg == 1 ) then
               do i = 1, iba(ik)
                  i1 = igf_in(nbase(i,ik))
                  c1 = psi_l(i,1,ik,1)
                  bfft(i1) = c1;
               end do
            else
               do i = 1, iba(ik)
                  i1 = kimg*igf_in(nbase(i,ik)) -1
                  c1 = psi_l(i,1,ik,1)
                  c2 = psi_l(i,1,ik,2)
                  bfft(i1) = c1;        bfft(i1+1) = c2
               end do
            end if
         endif
      end if
    end subroutine map_WF_on_fftmesh

    subroutine set_ngpt_inv( iopr_inv, ngpt_inv )
      integer, intent(in) :: iopr_inv
      integer, intent(out) :: ngpt_inv(kg)

      integer :: iopr, i, ierr
      integer, allocatable :: ngpt_tmp(:)

      iopr = iopr_inv

      if (npes > 1) then
         allocate(ngpt_tmp(kgp));   ngpt_tmp = 0
         do i = ista_kngp, iend_kngp
            ngpt_tmp(i) = ngpt_l(i,iopr)
         end do
         call mpi_allreduce( MPI_IN_PLACE, ngpt_tmp, kgp, mpi_integer, &
              &              mpi_sum, MPI_CommGroup, ierr )
         ngpt_inv(1:kg) = ngpt_tmp(1:kg)
         deallocate( ngpt_tmp )
      else
         do i = 1, kg
            ngpt_inv(i) = ngpt_l(i,iopr)
         end do
      end if
    end subroutine set_ngpt_inv

  end subroutine m_ESIO_wd_wfn_parity


end module m_ES_IO

module m_SpinOrbit_SecondVariation
  use m_Const_Parameters,  only : DP, SP, CMPLDP, PARABOLIC, TETRAHEDRON, COLD, &
       &                          FERMI_DIRAC, MP, GAMMA, &
       &                          Neglected, ByPawPot, ByProjector, ZeffApprox, &
       &                          ReadFromPP, OFF, ON, BUCS, &
       &                          FIXED_CHARGE_CONTINUATION, FIXED_CHARGE, ONE_BY_ONE
  use m_Control_Parameters,  only : neg, nspin, m_CtrlP_way_of_smearing, &
       &                            ndim_spinor, ndim_chgpot, kimg, ekmode, &
       &                            SpinOrbit_mode, icond, fixed_charge_k_parallel, &
       &                            neg_is_enlarged, num_extra_bands, &
       &                            precision_WFfile, sw_modified_kpoint_increment, &
       &                            printable, sw_write_zaj_socsv
  use m_Files,              only : nfout
  use m_Kpoints,          only : kv3, k_symmetry, vkxyz, kv3_ek, qwgt, vkxyz_ek

  use m_Electronic_Structure,  only : eko_l, fsr_l, fsi_l, occup_l, nrvf_ordr, efermi, &
       &                              zaj_l, metalic_system, vbm, eko_ek
  use m_Ionic_System,       only : ityp, natm
  use m_PseudoPotential,   only : nlmt, ltp, taup, nlmta, ilmt, lmta

  use m_Parallelization,  only : map_k, map_e, map_z, myrank_k, myrank_e, mpi_k_world, &
       &                         ista_e, iend_e, istep_e, np_e, npes, ierr, &
       &                         MPI_CommGroup, mype, ista_k, iend_k, map_ek, &
       &                         nrank_k, nis_kv3_ek

  use m_ES_Occup,            only : m_ESoc_fermi_parabolic, m_ESoc_fermi_tetrahedron, &
       &                            m_ESoc_fermi_ColdSmearing, m_ESoc_fermi_Dirac, &
       &                            m_ESoc_methfessel_paxton
  use m_ES_occup,            only : m_ESoc_fermi_parabolic_ek, &
       &                            m_ESoc_fermi_tetra_ek, &
       &                            m_ESoc_fermi_Dirac_ek, &
       &                            m_ESoc_mp_ek

  use m_SpinOrbit_Potential,     only : m_SO_alloc_dsoc, dsoc, &
       &                                m_SO_set_Dsoc_potential1, &
       &                                m_SO_calc_MatLS_orb_s_to_f, &
       &                                m_SO_diagonalize_MatLS, &
       &                                m_SO_set_MatU_ylm_RC, &
       &                                m_SO_alloc_Mat_SOC_strenth, &
       &                                m_SO_set_Dsoc_potential2, &
       &                                m_SO_dealloc_Mat_SOC_strenth, &
       &                                m_SO_dealloc_dsoc
  use m_SpinOrbit_RadInt,       only : m_SO_calc_SOC_strength_pawpot, &
       &                               m_SO_calc_SOC_strength_zeff, &
       &                               m_SO_check_mode_Builtin, &
       &                               m_SO_check_mode_Pawpot, &
       &                               m_SO_check_mode_Zeff
  use m_SpinOrbit_FromFile,     only : m_SO_set_SOC_strength_from_PP

  use m_IterationNumbers,     only : nk_in_the_process, nkgroup, &
       &                             first_kpoint_in_this_job, nk_converged

  use m_PlaneWaveBasisSet,    only : kg1
  use mpi

  implicit none
!  include 'mpif.h'
  integer istatus(mpi_status_size)
!
  integer, parameter :: ndim_spinor_socsv = 2
  integer :: neg_doubled
  integer :: ndim_spinor_prev, ndim_chgpot_prev

  real(kind=DP), allocatable :: eko_ek_socsv(:,:)
  real(kind=DP), allocatable :: zaj_band1_kpt1(:,:,:,:)
  real(kind=DP), allocatable :: zaj_band1_kpt2(:,:,:,:)
  real(kind=DP), allocatable :: zaj_band2_kpt1(:,:,:,:)
  real(kind=DP), allocatable :: zaj_band2_kpt2(:,:,:,:)
!
contains

  subroutine m_SO_init_second_variation
    ndim_spinor_prev = ndim_spinor;   ndim_chgpot_prev = ndim_chgpot
    ndim_spinor = ndim_spinor_socsv;    ndim_chgpot = ndim_spinor **2

    call m_SO_check_mode_Pawpot
    call m_SO_check_mode_Zeff

    if ( SpinOrbit_Mode /= Neglected ) then
       call m_SO_set_MatU_ylm_RC
       call m_SO_calc_MatLS_orb_s_to_f
       call m_SO_diagonalize_MatLS
    endif
    if ( SpinOrbit_Mode == ByPawPot ) then
       call m_SO_alloc_Mat_SOC_strenth
       call m_SO_calc_SOC_strength_pawpot
       call m_SO_alloc_Dsoc
       call m_SO_set_Dsoc_potential2
    endif
    if ( SpinOrbit_Mode == ZeffApprox ) then
       call m_SO_alloc_Mat_SOC_strenth
       call m_SO_calc_SOC_strength_zeff
       call m_SO_alloc_Dsoc
       call m_SO_set_Dsoc_potential2
    endif
    if ( SpinOrbit_Mode == ReadFromPP ) then
       call m_SO_alloc_Mat_SOC_strenth
       call m_SO_set_SOC_strength_from_PP
       call m_SO_alloc_Dsoc
       call m_SO_set_Dsoc_potential2
    endif
    if ( SpinOrbit_Mode == ByProjector ) then
       call m_SO_alloc_Dsoc
       call m_SO_set_Dsoc_potential1
    endif

    if ( ekmode == ON ) then
       allocate( eko_ek_socsv(neg,kv3_ek) );  eko_ek_socsv = 0.0d0
    endif
    ndim_spinor = ndim_spinor_prev;       ndim_chgpot = ndim_chgpot_prev

  end subroutine m_SO_init_second_variation

  subroutine m_SO_finalize_second_variation
    if ( SpinOrbit_Mode == ByPawPot .or. SpinOrbit_Mode == ZeffApprox &
         &                          .or. SpinOrbit_Mode == ReadFromPP ) then
       call m_SO_dealloc_Mat_SOC_strenth
       call m_SO_dealloc_Dsoc
    endif
    if ( SpinOrbit_Mode == ByProjector ) then
       call m_SO_dealloc_Dsoc
    endif
    if ( ekmode == ON ) deallocate( eko_ek_socsv )

  end subroutine m_SO_finalize_second_variation

  subroutine m_SO_calc_band_energy_socsv
    integer :: ik
    real(kind=DP) :: efermi_save, eband
    real(kind=DP), allocatable :: eko_save(:,:), occ_save(:,:)
    complex(kind=CMPLDP), allocatable :: MatH(:,:)

    if ( SpinOrbit_mode == Neglected ) return

    neg_doubled = neg *ndim_spinor_socsv
    allocate( MatH( neg_doubled, neg_doubled ) ); MatH = 0.0d0
    allocate( eko_save( np_e, ista_k:iend_k) ); eko_save = 0.0d0
    allocate( occ_save( np_e, ista_k:iend_k) ); occ_save = 0.0d0
    eko_save = eko_l; occ_save = occup_l;  efermi_save = efermi

    if ( ekmode == OFF ) then
       if ( sw_write_zaj_socsv == ON ) then
          allocate( zaj_band1_kpt1(kg1,np_e,ista_k:iend_k,kimg) )
          allocate( zaj_band2_kpt1(kg1,np_e,ista_k:iend_k,kimg) )
          allocate( zaj_band1_kpt2(kg1,np_e,ista_k:iend_k,kimg) )
          allocate( zaj_band2_kpt2(kg1,np_e,ista_k:iend_k,kimg) )
       endif
!
       Do ik=1, kv3, nspin
          if ( map_k(ik) /= myrank_k ) cycle
          MatH = 0.0d0
          call set_contrib_from_dsoc
          call add_diagonal_elements
          call renew_level_socsv( ik, MatH, eko_l )
          if ( sw_write_zaj_socsv == ON ) call renew_wfn( ik, MatH )
       End Do

       write(nfout,*)
       write(nfout,*) "<<< Spin-orbit by Second Variation "

       call FermiEnergyLevel
       call calc_bandenergy_socsv( map_k, occup_l, eko_l, eband )
       write(nfout,*) "* band energy  = ", eband
       write(nfout,*) ">>>"
       write(nfout,*)

       call m_SO_wd_EigenValues( .true., .false. )

       if ( sw_write_zaj_socsv == ON ) then
          call m_SO_wd_WFs()
          deallocate( zaj_band1_kpt1 );   deallocate( zaj_band2_kpt1 )
          deallocate( zaj_band1_kpt2 );   deallocate( zaj_band2_kpt2 )
       endif

    else
       Do ik=1, kv3, nspin
          if ( map_k(ik) /= myrank_k ) cycle
          MatH = 0.0d0
          call set_contrib_from_dsoc
          call add_diagonal_elements
          call renew_level_socsv( ik, MatH, eko_l )
          call m_SO_cp_eko_l_to_eko_ek_socsv
       End Do
       call m_SO_wd_EigenValues( .false., .true. )
    endif
!
    eko_l = eko_save;   occup_l = occ_save;  efermi = efermi_save
    deallocate( eko_save ); deallocate( occ_save )

  contains

    subroutine renew_wfn( ik, Coeff )
      integer, intent(in) :: ik
      complex(kind=CMPLDP), intent(in) :: Coeff(neg_doubled,neg_doubled)

      integer :: ib, jb, ig, ierr
      complex(kind=CMPLDP) :: z1, z2, zsum1, zsum2, zsum3, zsum4
      real(kind=DP), allocatable :: zaj_wk(:,:,:)

      allocate( zaj_wk(kg1,neg_doubled,kimg) ); zaj_wk = 0.0d0
      if ( nspin==1 ) then
         Do ib=ista_e, iend_e, istep_e
            zaj_wk(:,ib,    1) = zaj_l(:,map_z(ib),ik,1)
            zaj_wk(:,ib+neg,1) = zaj_l(:,map_z(ib),ik,1)
            if (kimg==2) then
               zaj_wk(:,ib,    2) = zaj_l(:,map_z(ib),ik,2)
               zaj_wk(:,ib+neg,2) = zaj_l(:,map_z(ib),ik,2)
            endif
         End Do
      else
         Do ib=ista_e, iend_e, istep_e
            zaj_wk(:,ib,    1) = zaj_l(:,map_z(ib),ik,  1)
            zaj_wk(:,ib+neg,1) = zaj_l(:,map_z(ib),ik+1,1)
            if (kimg==2) then
               zaj_wk(:,ib,    2) = zaj_l(:,map_z(ib),ik,  2)
               zaj_wk(:,ib+neg,2) = zaj_l(:,map_z(ib),ik+1,2)
            endif
         End Do
      endif

      if ( npes > 1 ) then
         call mpi_allreduce( MPI_IN_PLACE, zaj_wk, kg1 *neg_doubled *kimg,&
               &             mpi_double_precision, mpi_sum, &
               &             mpi_k_world(myrank_k),ierr )
      endif

      if ( nspin==1 ) then
         Do ib=ista_e, iend_e, istep_e
            Do ig=1, kg1
               zsum1 = 0.0d0;  zsum2 = 0.0d0;  zsum3 = 0.0d0;  zsum4 = 0.0d0
               Do jb=1, neg
                  z1 = dcmplx( zaj_wk(ig,jb,    1), zaj_wk(ig,jb,    2) )
                  z2 = dcmplx( zaj_wk(ig,jb+neg,1), zaj_wk(ig,jb+neg,2) )
                  zsum1 = zsum1 +coeff(jb,    ib) *z1
                  zsum2 = zsum2 +coeff(jb+neg,ib) *z2
                  zsum3 = zsum3 +coeff(jb,    ib+neg) *z1
                  zsum4 = zsum4 +coeff(jb+neg,ib+neg) *z2
               End Do
               zaj_band1_kpt1(ig,map_z(ib),ik,1) = real(zsum1)
               zaj_band1_kpt1(ig,map_z(ib),ik,2) = aimag(zsum1)
               zaj_band1_kpt2(ig,map_z(ib),ik,1) = real(zsum2)
               zaj_band1_kpt2(ig,map_z(ib),ik,2) = aimag(zsum2)
               zaj_band2_kpt1(ig,map_z(ib),ik,1) = real(zsum3)
               zaj_band2_kpt1(ig,map_z(ib),ik,2) = aimag(zsum3)
               zaj_band2_kpt2(ig,map_z(ib),ik,1) = real(zsum4)
               zaj_band2_kpt2(ig,map_z(ib),ik,2) = aimag(zsum4)
            End Do
         End Do
      else
         Do ib=ista_e, iend_e, istep_e
            Do ig=1, kg1
               zsum1 = 0.0d0;  zsum2 = 0.0d0;  zsum3 = 0.0d0;  zsum4 = 0.0d0
               Do jb=1, neg
                  z1 = dcmplx( zaj_wk(ig,jb,    1), zaj_wk(ig,jb,    2) )
                  z2 = dcmplx( zaj_wk(ig,jb+neg,1), zaj_wk(ig,jb+neg,2) )
                  zsum1 = zsum1 +coeff(jb,    ib) *z1
                  zsum2 = zsum2 +coeff(jb+neg,ib) *z2
                  zsum3 = zsum3 +coeff(jb,    ib+neg) *z1
                  zsum4 = zsum4 +coeff(jb+neg,ib+neg) *z2
               End Do
               zaj_band1_kpt1(ig,map_z(ib),ik,  1) = real(zsum1)
               zaj_band1_kpt1(ig,map_z(ib),ik,  2) = aimag(zsum1)
               zaj_band1_kpt1(ig,map_z(ib),ik+1,1) = real(zsum2)
               zaj_band1_kpt1(ig,map_z(ib),ik+1,2) = aimag(zsum2)
               zaj_band2_kpt1(ig,map_z(ib),ik,  1) = real(zsum3)
               zaj_band2_kpt1(ig,map_z(ib),ik,  2) = aimag(zsum3)
               zaj_band2_kpt1(ig,map_z(ib),ik+1,1) = real(zsum4)
               zaj_band2_kpt1(ig,map_z(ib),ik+1,2) = aimag(zsum4)
            End Do
         End Do
      endif
      deallocate( zaj_wk )
    end subroutine renew_wfn

    subroutine renew_level_socsv( ik, MatH, eko_l )
      integer, intent(in) :: ik
      complex(kind=CMPLDP), intent(inout) :: MatH( neg_doubled, neg_doubled )
      real(kind=DP), intent(out) :: eko_l(np_e,ista_k:iend_k)

      integer :: matsize, lwork, info
      integer :: is, ib, itmp

      real(kind=DP), allocatable :: rwork(:), eigvals(:), eko_wk(:,:)
      complex(kind=CMPLDP), allocatable :: work(:)

      matsize = neg_doubled;   lwork = 2*matsize
      allocate( work( lwork ) );  allocate( rwork( 3*matsize-2 ) )
      allocate( eigvals( neg_doubled ) ); eigvals = 0.0d0

      call zheev( 'V', 'U', matsize,  MatH,  matsize, eigvals, work, lwork, rwork, info )
      if ( info /= 0 ) then
         write(*,*)'Error in zheev';  stop
      endif
      deallocate( work ); deallocate( rwork )
!
      allocate( eko_wk( neg, ndim_spinor_socsv ) ); eko_wk = 0.0d0
      Do ib=1, neg
         Do is=1, ndim_spinor_socsv
            itmp = ( ib -1 )*ndim_spinor_socsv +is
            eko_wk( ib, is ) = eigvals( itmp )
         End do
      End Do

      Do is=1, ndim_spinor_socsv
         itmp = 1
         if ( nspin == 2 ) itmp = is

         Do ib=ista_e, iend_e, istep_e
            eko_l(map_z(ib),ik+itmp-1) = eko_wk(ib,is)
         End do
      End Do
      deallocate( eigvals );   deallocate( eko_wk )
!
    end subroutine renew_level_socsv

    subroutine calc_bandenergy_socsv( map_k, occup_l, eko_l, eband )
      integer, intent(in) :: map_k( kv3 )
      real(kind=DP), intent(in) :: occup_l(np_e,ista_k:iend_k)
      real(kind=DP), intent(in) :: eko_l(np_e,ista_k:iend_k)
      real(kind=DP), intent(out) :: eband
!
      integer             :: ib, ik, ierr
      real(kind=DP)       :: eband_mpi

      eband = 0.d0
      do ik =1, kv3
         if (map_k(ik) /= myrank_k) cycle
         do ib = 1, np_e
            eband = eband + occup_l(ib,ik)*eko_l(ib,ik)
         end do
      end do

      if (npes > 1) then
         call mpi_allreduce( eband, eband_mpi, 1, mpi_double_precision, &
              &              mpi_sum, MPI_CommGroup,ierr )
         eband = eband_mpi
      end if
      eband = 2.0d0 *eband /dble(kv3)

    end subroutine calc_bandenergy_socsv

    subroutine add_diagonal_elements
      integer :: is, ib1, itmp
      real(kind=DP), allocatable :: eko_wk(:,:), eko_mpi(:,:)

      allocate( eko_wk( neg, ndim_spinor_socsv ) ); eko_wk = 0.0d0
      Do is=1, ndim_spinor_socsv
         itmp = 1
         if ( nspin == 2 ) itmp = is

         Do ib1=ista_e, iend_e, istep_e
            eko_wk( ib1, is ) = eko_l( map_z(ib1),ik +itmp-1 )
         End do
      End Do

      if ( npes > 1 ) then
         allocate( eko_mpi( neg, ndim_spinor_socsv ) ); eko_mpi = 0.0d0
         call mpi_allreduce( eko_wk, eko_mpi, neg*ndim_spinor_socsv, &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         eko_wk = eko_mpi
         deallocate( eko_mpi )
      endif
!
      Do is=1, ndim_spinor_socsv
         Do ib1=1, neg
            itmp = ( is -1 )*neg +ib1
            MatH( itmp,itmp ) = MatH( itmp,itmp ) +eko_wk( ib1,is )
         End do
      End Do
      deallocate( eko_wk )

    end subroutine add_diagonal_elements

    subroutine set_contrib_from_dsoc
      integer :: ib1, ib2, is1, is2, itmp1, itmp2
      integer :: ia, it, istmp, jb1, jb2
      integer :: lmt1, lmt2, il1, il2, it1, it2, lmta1, lmta2
      complex(kind=CMPLDP) :: z1, wf1, wf2
      complex(kind=CMPLDP), allocatable :: wk_fsri(:,:), MatH_mpi(:,:)

      allocate( wk_fsri( nlmta, ndim_spinor_socsv ) ); wk_fsri = 0.0d0
      Do ib2=1, neg
         wk_fsri = 0.0d0

         if ( map_e(ib2) == myrank_e ) then
            Do is1=1, ndim_spinor_socsv
               itmp1 = 1
               if ( nspin == 2 ) itmp1 = is1

               if ( kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2 ) then
                  wk_fsri(:,is1) = fsr_l( map_z(ib2),:,ik+itmp1-1 )
               else
                  wk_fsri(:,is1) = dcmplx( fsr_l( map_z(ib2),:,ik+itmp1-1 ), &
                       &                   fsi_l( map_z(ib2),:,ik+itmp1-1 ) )
               endif
            End do
         endif
         call mpi_bcast( wk_fsri, 2*nlmta*ndim_spinor_socsv, mpi_double_precision, &
              &          map_e(ib2), mpi_k_world(myrank_k), ierr )
         !

         DO ib1=ista_e, iend_e, istep_e

            Do ia=1, natm
               it = ityp(ia)

               Do lmt1=1, ilmt(it)
                  il1 = ltp(lmt1,it); it1 = taup(lmt1,it)
                  lmta1 = lmta( lmt1,ia )

                  Do lmt2=1, ilmt(it)
                     il2 = ltp(lmt2,it); it2 = taup(lmt2,it)
                     lmta2 = lmta( lmt2,ia )

                     Do is1=1, ndim_spinor_socsv
                        itmp1 = 1
                        if ( nspin == 2 ) itmp1 = is1

                        Do is2=1, ndim_spinor_socsv
                           itmp2 = 1
                           if ( nspin == 2 ) itmp2 = is2

                           if ( kv3/nspin == 1 .and. k_symmetry(1) == GAMMA &
                                &              .and. kimg == 2 ) then
                              wf1 = fsr_l( map_z(ib1), lmta1, ik +itmp1 -1 )
                           else
                              wf1 = dcmplx( fsr_l( map_z(ib1), lmta1, ik +itmp1 -1 ), &
                                   &        fsi_l( map_z(ib1), lmta1, ik +itmp1 -1 ) )
                           endif
                           wf2 = wk_fsri( lmta2, is2 )

                           istmp = ( is1 -1 )*ndim_spinor_socsv +is2
                           z1 = dconjg(wf1) *dsoc( lmt1, lmt2, ia, istmp ) *wf2

                           jb1 = neg *( is1 -1 )+ib1
                           jb2 = neg *( is2 -1 )+ib2
                           MatH(jb1,jb2) = MatH (jb1,jb2) +z1
                        End Do
                     End do
                  End Do

               End Do
            End do
         End DO
      End Do
!
      if ( npes > 1 ) then
         allocate( MatH_mpi( neg_doubled, neg_doubled ) ); MatH_mpi = 0.0d0
         call mpi_allreduce( MatH, MatH_mpi, 2*neg_doubled**2, &
               &             mpi_double_precision, mpi_sum, &
               &             mpi_k_world(myrank_k), ierr )
         MatH = MatH_mpi
         deallocate( MatH_mpi )
      endif
      deallocate( wk_fsri )

    end subroutine set_contrib_from_dsoc

  end subroutine m_SO_calc_band_energy_socsv

  subroutine FermiEnergyLevel()
    integer :: way_of_smearing

    way_of_smearing = m_CtrlP_way_of_smearing()
    if(way_of_smearing == PARABOLIC) then
       call m_ESoc_fermi_parabolic(nfout)
    else if(way_of_smearing == TETRAHEDRON) then
       call phase_error_with_msg(nfout,"Not supported",__LINE__,__FILE__)
       call m_ESoc_fermi_tetrahedron(nfout)
    else if(way_of_smearing == COLD) then
       call m_ESoc_fermi_ColdSmearing(nfout)
    else if(way_of_smearing == FERMI_DIRAC) then
       call m_ESoc_fermi_Dirac(nfout)
    else if(way_of_smearing == MP) then
        call m_ESoc_methfessel_paxton(nfout)
    end if
  end subroutine FermiEnergyLevel

  subroutine FermiEnergyLevel_ek()
    integer :: way_of_smearing
    way_of_smearing = m_CtrlP_way_of_smearing()

    if(way_of_smearing == PARABOLIC) then
       call m_ESoc_fermi_parabolic_ek(nfout)  ! -> efermi, metalic_system
    else if(way_of_smearing == TETRAHEDRON) then
       call m_ESoc_fermi_tetra_ek(nfout)     ! -> efermi, metalic_system
    else if(way_of_smearing == Fermi_Dirac) then
       call m_ESoc_fermi_dirac_ek(nfout)     ! -> efermi, metalic_system
    else if(way_of_smearing == MP) then
       call m_ESoc_mp_ek(nfout)
    end if
  end subroutine FermiEnergyLevel_ek

  subroutine m_SO_wd_WFs()
    integer :: lun
    character*72 file1

#if 1
    if ( nspin == 2 ) call multiply_wfn_by_rotated_spinor
#endif

    lun = 2000
    file1 = "zaj_socsv.data"
    open( lun, file=file1, status="unknown", form="unformatted" )

    if (precision_WFfile==SP) then
       call case_single_precision
    else
       call case_double_precision
    endif
    close(lun)

  contains

    subroutine case_single_precision
      integer :: ik, ib, ri, is1, is2, ierr
      real(kind=SP), allocatable, dimension(:,:)  :: wf_l

      allocate(wf_l(kg1,kimg));    wf_l = 0
      call mpi_barrier(MPI_CommGroup,ierr)

      if ( nspin == 1 ) then
         do ik = 1, kv3
            Do is1=1, 2
               Do is2=1, 2
                  do ib = 1, neg
                     if (map_ek(ib,ik) == mype) then
                        do ri = 1, kimg
                           if (is1==1 .and. is2==1) then
                              wf_l(1:kg1,ri) = zaj_band1_kpt1(1:kg1,map_z(ib),ik,ri)
                           else if (is1==1 .and. is2==2) then
                              wf_l(1:kg1,ri) = zaj_band2_kpt1(1:kg1,map_z(ib),ik,ri)
                           else if (is1==2 .and. is2==1) then
                              wf_l(1:kg1,ri) = zaj_band1_kpt2(1:kg1,map_z(ib),ik,ri)
                           else if (is1==2 .and. is2==2) then
                              wf_l(1:kg1,ri) = zaj_band2_kpt2(1:kg1,map_z(ib),ik,ri)
                           endif
                        end do
                        if (map_ek(ib,ik) /= 0) then
                           call mpi_send( wf_l, kg1*kimg, mpi_real, 0, 1, &
                                &         MPI_CommGroup, ierr)
                        endif
                     else if(mype == 0 .and. map_ek(ib,ik) /= 0) then
                        call mpi_recv( wf_l, kg1*kimg, mpi_real, map_ek(ib,ik), 1, &
                             &         MPI_CommGroup, istatus, ierr )
                     end if
                     if (mype == 0) write(lun)  wf_l
                  end do
               end Do
            end Do
         End Do
      else
         do ik = 1, kv3
            Do is2=1, 2
               do ib = 1, neg
                  if (map_ek(ib,ik) == mype) then
                     do ri = 1, kimg
                        if (is2==1) then
                           wf_l(1:kg1,ri) = zaj_band1_kpt1(1:kg1,map_z(ib),ik,ri)
                        else if (is2==2) then
                           wf_l(1:kg1,ri) = zaj_band2_kpt1(1:kg1,map_z(ib),ik,ri)
                        endif
                     end do
                     if (map_ek(ib,ik) /= 0) then
                        call mpi_send( wf_l, kg1*kimg, mpi_real, 0, 1, &
                             &         MPI_CommGroup, ierr)
                     endif
                  else if(mype == 0 .and. map_ek(ib,ik) /= 0) then
                     call mpi_recv( wf_l, kg1*kimg, mpi_real, map_ek(ib,ik), 1, &
                          &         MPI_CommGroup, istatus, ierr )
                  end if
                  if (mype == 0) write(lun)  wf_l
               end do
            end Do
         End Do
      end if
      deallocate(wf_l)
    end subroutine case_single_precision

    subroutine case_double_precision
      integer :: ik, ib, ri, is1, is2, ierr
      real(kind=DP), allocatable, dimension(:,:)  :: wfdp_l

      allocate(wfdp_l(kg1,kimg));    wfdp_l = 0
      call mpi_barrier(MPI_CommGroup,ierr)

      if ( nspin == 1 ) then
         do ik = 1, kv3
            Do is1=1, 2
               Do is2=1, 2
                  do ib = 1, neg
                     if (map_ek(ib,ik) == mype) then
                        do ri = 1, kimg
                           if (is1==1 .and. is2==1) then
                              wfdp_l(1:kg1,ri) = zaj_band1_kpt1(1:kg1,map_z(ib),ik,ri)
                           else if (is1==1 .and. is2==2) then
                              wfdp_l(1:kg1,ri) = zaj_band2_kpt1(1:kg1,map_z(ib),ik,ri)
                           else if (is1==2 .and. is2==1) then
                              wfdp_l(1:kg1,ri) = zaj_band1_kpt2(1:kg1,map_z(ib),ik,ri)
                           else if (is1==2 .and. is2==2) then
                              wfdp_l(1:kg1,ri) = zaj_band2_kpt2(1:kg1,map_z(ib),ik,ri)
                           endif
                        end do
                        if (map_ek(ib,ik) /= 0) then
                           call mpi_send( wfdp_l, kg1*kimg, mpi_double_precision, &
                                &         0, 1, &
                                &         MPI_CommGroup, ierr)
                        endif
                     else if(mype == 0 .and. map_ek(ib,ik) /= 0) then
                        call mpi_recv( wfdp_l, kg1*kimg, mpi_double_precision, &
                             &         map_ek(ib,ik), 1, &
                             &         MPI_CommGroup, istatus, ierr )
                     end if
                     if (mype == 0) write(lun)  wfdp_l
                  end do
               end Do
            end Do
         End Do
      else
         do ik = 1, kv3
            Do is2=1, 2
               do ib = 1, neg
                  if (map_ek(ib,ik) == mype) then
                     do ri = 1, kimg
                        if (is2==1) then
                           wfdp_l(1:kg1,ri) = zaj_band1_kpt1(1:kg1,map_z(ib),ik,ri)
                        else if (is2==2) then
                           wfdp_l(1:kg1,ri) = zaj_band2_kpt1(1:kg1,map_z(ib),ik,ri)
                        endif
                     end do
                     if (map_ek(ib,ik) /= 0) then
                        call mpi_send( wfdp_l, kg1*kimg, mpi_real, 0, 1, &
                             &         MPI_CommGroup, ierr)
                     endif
                  else if(mype == 0 .and. map_ek(ib,ik) /= 0) then
                     call mpi_recv( wfdp_l, kg1*kimg, mpi_real, map_ek(ib,ik), 1, &
                          &         MPI_CommGroup, istatus, ierr )
                  end if
                  if (mype == 0) write(lun)  wfdp_l
               end do
            end Do
         End Do
      end if
      deallocate(wfdp_l)
    end subroutine case_double_precision

  end subroutine m_SO_wd_WFs

  subroutine multiply_wfn_by_rotated_spinor
    use m_Crystal_Structure,  only : sw_fix_global_quantz_axis, &
         &                           Global_Quantz_Axis_Fixed
    use m_Const_Parameters,   only : zi

    integer :: ik, ib, ig
    real(kind=DP) :: spn_quant_dir(3), theta, phi
    complex(kind=CMPLDP) :: rotated_spinor(2,2), z1, z2, ztmp1, ztmp2

    if ( sw_fix_global_quantz_axis == OFF ) return

    spn_quant_dir(1:3) = Global_Quantz_Axis_Fixed(1:3)
    theta = acos( spn_quant_dir(3) )
    phi = atan2( spn_quant_dir(2), spn_quant_dir(1) )

    if ( theta == 0.0D0 ) return

    rotated_spinor(1,1) =  exp( -zi *phi /2.0d0 ) *cos( theta /2.0d0 )
    rotated_spinor(2,1) =  exp(  zi *phi /2.0d0 ) *sin( theta /2.0d0 )

    rotated_spinor(1,2) = -exp( -zi *phi /2.0d0 ) *sin( theta /2.0d0 )
    rotated_spinor(2,2) =  exp(  zi *phi /2.0d0 ) *cos( theta /2.0d0 )

    do ik = 1, kv3, nspin
       if ( map_k(ik) /= myrank_k ) cycle
       Do ig=1, kg1
          Do ib=1, np_e
             z1 = dcmplx( zaj_band1_kpt1(ig,ib,ik,  1), zaj_band1_kpt1(ig,ib,ik,  kimg) )
             z2 = dcmplx( zaj_band1_kpt1(ig,ib,ik+1,1), zaj_band1_kpt1(ig,ib,ik+1,kimg) )
             ztmp1 = rotated_spinor(1,1) *z1 +rotated_spinor(2,1) *z2
             ztmp2 = rotated_spinor(1,2) *z1 +rotated_spinor(2,2) *z2
             zaj_band1_kpt1(ig,ib,ik,1)      = real(ztmp1)
             zaj_band1_kpt1(ig,ib,ik,kimg)   = aimag(ztmp1)
             zaj_band1_kpt1(ig,ib,ik+1,1)    = real(ztmp2)
             zaj_band1_kpt1(ig,ib,ik+1,kimg) = aimag(ztmp2)

             z1 = dcmplx( zaj_band2_kpt1(ig,ib,ik,  1), zaj_band2_kpt1(ig,ib,ik,  kimg) )
             z2 = dcmplx( zaj_band2_kpt1(ig,ib,ik+1,1), zaj_band2_kpt1(ig,ib,ik+1,kimg) )
             ztmp1 = rotated_spinor(1,1) *z1 +rotated_spinor(2,1) *z2
             ztmp2 = rotated_spinor(1,2) *z1 +rotated_spinor(2,2) *z2
             zaj_band2_kpt1(ig,ib,ik,1)      = real(ztmp1)
             zaj_band2_kpt1(ig,ib,ik,kimg)   = aimag(ztmp1)
             zaj_band2_kpt1(ig,ib,ik+1,1)    = real(ztmp2)
             zaj_band2_kpt1(ig,ib,ik+1,kimg) = aimag(ztmp2)
          End Do
       End Do
    end do
  end subroutine multiply_wfn_by_rotated_spinor

  subroutine m_SO_wd_EigenValues( fin_mode, no_occ )
    logical, intent(in) :: fin_mode, no_occ
    integer                          :: ie,  ipri0, kv3_i, ks
    integer                          :: hconst_min, lzero_max
    integer, parameter :: NCOLUMN = 6
    integer, parameter :: EIGEN_VALUES = 1, OCCUPATIONS = 2
    real(kind=DP),allocatable, dimension(:,:) :: e_mpi, o_mpi

    integer :: lun
    character*72 :: file1

    lun = 1000
    file1 = "nfefermi_socsv.data"

    if ( mype == 0 ) then
       if ( fin_mode ) then
          open( lun, file=file1, status="unknown", form="formatted" )
          write( lun,'(f16.8," : Efermi")') efermi
          close( lun )
       endif
    endif

    file1 = "nfenergy_socsv.data"
    if ( mype == 0 ) then
       if ( fin_mode ) then
          open( lun, file=file1, status="unknown", form="formatted" )
       else
          if ( nk_in_the_process == 1 ) then
             open( lun, file=file1, status="unknown", form="formatted" )
          else
             open( lun, file=file1, status="unknown", form="formatted", &
                  &     position='append' )
          endif
       endif
    endif
    allocate(e_mpi(neg_doubled,kv3/nspin)); e_mpi = 0.d0
    allocate(o_mpi(neg_doubled,kv3/nspin)); o_mpi = 0.d0

    call set_kv3_i_and_ks() ! -> kv3_i, ks

    call put_kpartArray_into(eko_l,e_mpi)
    if ( mype==0 ) call wd_k_and_values(EIGEN_VALUES)

    if ( .not. no_occ ) then
       call put_kpartArray_into(occup_l,o_mpi)
       if ( mype==0 ) call wd_k_and_values(OCCUPATIONS)
    endif
    deallocate(e_mpi);   deallocate(o_mpi)

    if ( mype == 0 ) close(lun)

  contains

    subroutine set_kv3_i_and_ks()
      if((icond == FIXED_CHARGE_CONTINUATION .or. icond == FIXED_CHARGE) .and. &
           & fixed_charge_k_parallel == ONE_BY_ONE) then
         kv3_i = kv3_ek - kv3*(nkgroup-1)
         if(kv3_i > kv3) kv3_i = kv3
         ks = max(1,first_kpoint_in_this_job) - 1 + kv3*(nkgroup-1)
      else
         kv3_i = kv3
         ks = 0
      end if

    end subroutine set_kv3_i_and_ks

    subroutine wd_k_and_values(mode)
      integer, intent(in) :: mode
      integer :: ik, nb, iktmp
      integer :: ie_s, ie_e, nhw, neg_t
      real(kind=DP) :: hw, hc, hv

      do ik = 1, kv3_i /nspin
         iktmp = (ik-1) *nspin +1
         if ( mode == EIGEN_VALUES) write(lun,'(" ===== energy eigen values =====")')
         if ( mode == OCCUPATIONS)  write(lun,'(" ===== occupations =====")')
         call wd_k_points_socsv(ik)
         neg_t = neg_doubled
         if(neg_is_enlarged) neg_t = neg_doubled - num_extra_bands*2

         if(mode == EIGEN_VALUES) then
            write(lun,'(5f16.8)') (e_mpi(nb,ik),nb=1,neg_t)
                                                    ! =eko(neordr(nb,ik),ik)
         else if(mode == OCCUPATIONS) then
            write(lun,'(5f16.8)') (o_mpi(nb,ik)/(qwgt(iktmp)*kv3),nb = 1,neg_t)
                                                    ! =occup(neordr(nb,ik),ik)
         end if
      end do
    end subroutine wd_k_and_values

    subroutine put_kpartArray_into(a_l,a_all)
      real(kind=DP), intent(in), dimension(np_e,ista_k:iend_k) :: a_l
      real(kind=DP), intent(out), dimension(neg_doubled,kv3/nspin) :: a_all
      integer :: ik, iktmp, ierr, ie, is, ito

      a_all = 0.d0
      if ( nspin==1 ) then
         do ik = 1, kv3
            if(map_k(ik) /= myrank_k) cycle
            do ie = 1, neg
               if(map_e(ie) /= myrank_e) cycle
               ito = nrvf_ordr(ie,ik)
               Do is=1, ndim_spinor_socsv
                  a_all( (ito-1)*ndim_spinor_socsv +is,ik) = a_l(map_z(ie),ik)
               End Do
            end do
         end do
      else
         do ik = 1, kv3, nspin
            iktmp = ( ik-1 )/nspin +1
            if(map_k(ik) /= myrank_k) cycle
            do ie = 1, neg
               if(map_e(ie) /= myrank_e) cycle
               ito = nrvf_ordr(ie,ik)
               Do is=1, ndim_spinor_socsv
                  a_all( (ito-1)*ndim_spinor_socsv +is,iktmp) = a_l(map_z(ie),ik+is-1)
               End Do
            end do
         end do
      endif

      if(npes >= 2) then
         call mpi_allreduce( MPI_IN_PLACE, a_all, neg_doubled*kv3/nspin,&
              &             mpi_double_precision, mpi_sum, MPI_CommGroup, ierr )
      end if
    end subroutine put_kpartArray_into

    subroutine wd_k_points_socsv(ik)
      integer, intent(in) :: ik
      real(kind=DP) :: vkxyz_wk(3)

      vkxyz_wk(1:3) = vkxyz(ik,1:3,BUCS)
      write(lun,'(" ik = ",i5," (",3f10.6," )")') &
           &                 ndim_spinor_socsv*(ik+ks-1)+1, vkxyz_wk(1:3)
    end subroutine wd_k_points_socsv

  end subroutine m_SO_wd_EigenValues

  subroutine m_SO_wd_EigenValues_ek_fin
    real(kind=DP), parameter :: delta = 1.d-12
    real(kind=DP), allocatable, dimension(:) :: eko_t
    integer, allocatable, dimension(:)       :: neordr_t
    integer                     :: ik, ib,jb,ibo,jbo, neg_t

    integer :: lun
    character*72 :: file1
    real(kind=DP) :: efermi_save, vbm_save
    real(kind=DP), allocatable :: eko_ek_save(:,:)

    lun = 1000
    file1 = "nfenergy_socsv.data"
    if ( mype == 0 ) then
       open( lun, file=file1, status="unknown", form="formatted" )
    endif

    vbm_save = vbm;    efermi_save = efermi
    allocate( eko_ek_save(neg,kv3_ek) );  eko_ek_save = eko_ek
    allocate(eko_t(neg_doubled));     eko_t = 0.0d0
    allocate(neordr_t(neg_doubled));  neordr_t = 0

    eko_ek = eko_ek_socsv

    call FermiEnergylevel_ek()

    if ( mype == 0 ) then
       write(lun,'(" num_kpoints = ",i6)') kv3_ek /nspin
       if(neg_is_enlarged) then
          write(lun,'(" num_bands   = ",i6)') neg_doubled -num_extra_bands*2
       else
          write(lun,'(" num_bands   = ",i6)') neg_doubled
       end if
       write(lun,'(" nspin       = ",i6)') 1

       if(metalic_system) then
          write(lun,'(" Fermi energy level = ",f10.6/)') efermi
       else
          write(lun,'(" Valence band max   = ",f10.6/)') vbm
       end if

       write(lun,'(" nk_converged = ",i8)') min(kv3_ek,nk_converged)
       do ik = 1, kv3_ek/nspin
          call wd_k_points_socsv
       end do
       write(lun,'(" -----")')
    end if

    do ik = 1, nk_converged, nspin
       if (ik > kv3_ek) cycle
       if (mype == 0) write(lun,'("=== energy_eigen_values ===")')

       if ( nspin == 1 ) then
          Do ib=1, neg
             eko_t(2*ib-1) = eko_ek_socsv(ib,ik)
             eko_t(2*ib  ) = eko_ek_socsv(ib,ik)
          End do
       else
          Do ib=1, neg
             eko_t(2*ib-1) = eko_ek_socsv(ib,ik)
             eko_t(2*ib  ) = eko_ek_socsv(ib,ik+1)
          End do
       endif

       neordr_t(1:neg_doubled) = (/(ib,ib=1,neg_doubled)/)
       do ib = 1, neg_doubled -1
          do jb = ib+1, neg_doubled
             ibo = neordr_t(ib);  jbo = neordr_t(jb)
             if(eko_t(jbo)  < eko_t(ibo)-delta) then        ! MPI
                neordr_t(jb) = ibo;   neordr_t(ib) = jbo
             end if
          end do
       end do
       if ( mype==0 ) then
          call wd_k_points_socsv
          neg_t = neg_doubled
          if(neg_is_enlarged) neg_t = neg_doubled - num_extra_bands *2
          write(lun,'(4f18.10)') (eko_t(neordr_t(ib)),ib=1,neg_t)
       end if
    end do

    deallocate(neordr_t);     deallocate(eko_t)

    eko_ek = eko_ek_save;  vbm = vbm_save;  efermi = efermi_save
    deallocate( eko_ek_save )
    if ( mype==0 ) close(lun)

  contains

    subroutine wd_k_points_socsv
      integer :: j, k
      real(kind=DP) :: c1, vkxyz_wk(3)

      vkxyz_wk(1:3) = vkxyz_ek(ik,1:3,BUCS)
      write(lun,'(" ik = ",i8," (",3f10.6," )")') &
           &                   ndim_spinor_socsv*(ik-1)+1, vkxyz_wk(1:3)

    end subroutine wd_k_points_socsv

  end subroutine m_SO_wd_EigenValues_ek_fin

  subroutine m_SO_cp_eko_l_to_eko_ek_socsv()
    real(kind=DP),allocatable,dimension(:,:) :: eko_t, eko_t2 ! d(neg,kv3)
    integer :: ik, ib, kv3_e
    integer :: ikt,is, kv3t

    allocate(eko_t(neg,kv3)); allocate(eko_t2(neg,kv3))

    eko_t = 0.d0
    do ik = 1, kv3
       if(map_k(ik) /= myrank_k) cycle
       do ib = 1, neg
          if(map_e(ib) /= myrank_e) cycle
          eko_t(ib,ik) = eko_l(map_z(ib),ik)
       end do
    end do
    if(npes >= 2) then
       call mpi_allreduce(eko_t,eko_t2,neg*kv3,mpi_double_precision &
            &              ,mpi_sum, MPI_CommGroup,ierr)
    else
       eko_t2 = eko_t
    end if

    kv3_e = min(kv3,kv3_ek-kv3*(nkgroup-1))
    if(nk_in_the_process+kv3_e-1 > kv3_ek) kv3_e = kv3_ek - nk_in_the_process + 1
    if(kv3_e <=0) kv3_e = 1

    if(sw_modified_kpoint_increment == ON)then
      do ik=0,nrank_k-1
         do is=1,nspin
            ikt = nspin*(nis_kv3_ek(ik)-1)+(nkgroup-1)*nspin+is
            if(ikt>kv3_ek) ikt = kv3_ek
            eko_ek_socsv(:,ikt) = eko_t2(:,ik*nspin+is)
         enddo
      enddo
    else
      eko_ek_socsv(:,nk_in_the_process:nk_in_the_process+kv3_e-1) = eko_t2(:,1:kv3_e)
    endif

    deallocate(eko_t); deallocate(eko_t2)
  end subroutine m_SO_cp_eko_l_to_eko_ek_socsv

  subroutine m_SO_calc_band_energy_socsv_ek
    use m_ES_occup_EPS, only : occup_l_ek

    integer :: ik, ib
    real(kind=DP) :: eband, eband_mpi

    allocate( occup_l_ek( np_e, kv3_ek ) )
    eko_ek = eko_ek_socsv

    call FermiEnergyLevel_ek2

    eband = 0.d0
    do ik =1, kv3_ek
       do ib = ista_e, iend_e, istep_e
          eband = eband + occup_l_ek( map_z(ib),ik ) *eko_ek(ib,ik)
       end do
    end do

    if (npes > 1) then
       call mpi_allreduce( eband, eband_mpi, 1, mpi_double_precision, &
            &              mpi_sum, mpi_k_world(myrank_k),ierr )
       eband = eband_mpi
    end if

    eband = 2.0d0 *eband /dble(kv3_ek)

!    write(nfout,*)
    write(nfout,*) "<<< Spin-orbit by Second Variation (ekmode)"
    write(nfout,*) "* band energy  = ", eband
   write(nfout,*) ">>>"
    write(nfout,*)

    deallocate( occup_l_ek )

  end subroutine m_SO_calc_band_energy_socsv_ek

  subroutine FermiEnergyLevel_ek2()
    use m_Control_Parameters,   only : iprioccup
    use m_ES_occup_EPS, only : m_ESoc_EPS_fermi_parabolic_ek, &
         &                     m_ESoc_EPS_fermi_tetra_ek, &
         &                     m_ESoc_EPS_fermi_dirac_ek

    integer :: way_of_smearing, iprioccup_save

    efermi = 0.0d0
    iprioccup_save = iprioccup;  iprioccup = -1

    way_of_smearing = m_CtrlP_way_of_smearing()

    if(way_of_smearing == PARABOLIC) then
       call m_ESoc_EPS_fermi_parabolic_ek(nfout)
    else if(way_of_smearing == TETRAHEDRON) then
       call m_ESoc_EPS_fermi_tetra_ek(nfout)
    else if ( way_of_smearing == Fermi_Dirac ) then
       call m_ESoc_EPS_fermi_dirac_ek(nfout)
    end if

    iprioccup = iprioccup_save

  end subroutine FermiEnergyLevel_ek2

end module m_SpinOrbit_SecondVariation

module m_Crystal_Field
  use m_Control_Parameters,   only : nspin, kimg, noncol, ndim_spinor, sw_hubbard, &
       &                             proj_attribute, SpinOrbit_mode
  use m_Const_Parameters, only : DP, PAI4, PAI, CMPLDP, zi, ON, OFF, Neglected, &
       &                         Hartree, CONST_EV, CONST_kB, PLANCK, speed_of_light
  use m_Crystal_Structure, only : univol, rltv
  use m_Ionic_System,     only : natm, ityp, pos, iatomn, ntyp, ivan, ival, ihubbard
  use m_PseudoPotential,  only : lpsmax, flg_paw, nmesh, mmesh, radr_paw, &
       &                         vlocr_pw, rhcorpw, nloc, psirpw, ltp, nlmt, mtp, taup
  use m_Parallelization,   only : ista_kngp, iend_kngp, MPI_CommGroup, ierr, &
       &                          ista_k, mype, npes, mype

  use m_Charge_Density,   only : chgq_l, hsr
  use m_PlaneWaveBasisSet,  only : kgp, ngabc, gr_l
  use m_Electronic_Structure,  only : vlhxc_l
  use m_XC_Potential,   only : vxc_l
!  use m_Nonlocal_Potential,  only : new_radr_and_wos
  use m_Files,  only : nfpot, nfout, m_Files_open_ps_files, m_Files_close_ps_file

  use m_CD_Mag_Moment,  only : rad_cov_default, rad_cov
  use m_SpinOrbit_Potential,  only : MatU_ylm_RC_L0, MatU_ylm_RC_L1, MatU_ylm_RC_L2, &
       &                             MatU_ylm_RC_L3, MatU_ylm_RC_L4, MatU_ylm_RC_L5, &
       &                             MatU_ylm_RC_L6, Mat_LS_with_real_ylm_L3, &
       &                             m_SO_set_MatU_ylm_RC, &
       &                             m_SO_calc_MatLS_orb_s_to_f, Mat_SOC_Strength
  use m_Orbital_Population,  only : i2lp, om
  use m_FFT,                   only : m_FFT_CD_direct_c, m_FFT_CD_inverse_c, &
       &                              m_FFT_alloc_CD_box, m_FFT_dealloc_CD_box, &
       &                              fft_box_size_CD, nfftp
  use m_Parallelization,  only :  nel_fftp, idisp_fftp, ista_fftp, iend_fftp, mp_fftp, &
       &                          nis_fftp, nie_fftp
  use m_PlaneWaveBasisSet, only : igfp_l
  use m_Ionic_System, only : cps

  use m_FFT, only : m_FFT_coef_CD_integration_kt
  use m_Parallelization,  only :  ista_fftph, iend_fftph
  use mpi

  implicit none
!  include 'mpif.h'

  integer :: max_sph = 49

  integer :: sw_contract_forb = OFF
!  integer :: sw_exclude_vh_selfcharge = ON
  integer :: sw_exclude_vh_selfcharge = OFF
  integer :: sw_exclude_vh_occmat = OFF
  integer :: sw_exclude_vxc = ON

  real(kind=DP), parameter :: Hartree_2_Kelvin = 1.0d0 / CONST_kB  ! 315777D0
  real(kind=DP), parameter :: Hartree_2_cminv = (Hartree * CONST_EV) / (1.0d2 * speed_of_light * PLANCK)  ! 2.194746D5

  real(kind=DP), allocatable :: gaunt_coeff(:,:,:)

contains

  subroutine set_psir_f( has_open_forb, psir_f, guzai_f )
    integer, intent(out) :: has_open_forb(ntyp)
    real(kind=DP), intent(out) :: psir_f( mmesh, ntyp )
    real(kind=DP), intent(out) :: guzai_f( ntyp )

    integer :: it, ierr, nfp, i, ir
    integer :: num_core_ae_wfns
    integer, allocatable :: qnum_n_core_ae_wfns(:)
    integer, allocatable :: qnum_l_core_ae_wfns(:)
    real(kind=DP), allocatable :: psir_core_ae_wfns(:,:)
    real(kind=DP), allocatable :: enelevel_core_ae_wfns(:)
    real(kind=DP), allocatable :: focc_core_ae_wfns(:)
    real(kind=DP), allocatable :: guzai_core_ae_wfns(:)
    real(kind=DP) :: weight

! == KT_DEBUG === 2015/06/15 ==
!    call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierr)
!                                      ! this does not work properly by unknown reason.
    call m_Files_open_ps_files(ivan,iatomn,ntyp,ierr)
! =============== 2015/06/15

    if (ierr/=0) call mpi_stop(nfout)

    has_open_forb = 0

    Do it=1, ntyp
       nfp = nfpot(it)

       if ( mype == 0 ) call read_num_core_ae_wfns( nfp, num_core_ae_wfns, it )
       if ( npes > 1 ) then
          call mpi_bcast( num_core_ae_wfns, 1, mpi_integer, 0, mpi_comm_world, ierr )
       endif

       if ( num_core_ae_wfns == 0 ) cycle

       allocate( qnum_n_core_ae_wfns( num_core_ae_wfns ) )
       allocate( qnum_l_core_ae_wfns( num_core_ae_wfns ) )
       allocate( psir_core_ae_wfns( nmesh(it),  num_core_ae_wfns ) )
       allocate( enelevel_core_ae_wfns( num_core_ae_wfns ) )
       allocate( focc_core_ae_wfns( num_core_ae_wfns ) )
       allocate( guzai_core_ae_wfns( num_core_ae_wfns ) )

       if ( mype == 0 ) then
          call read_data_core_ae_wfns( nfp, num_core_ae_wfns, nmesh(it), &
               &                       qnum_n_core_ae_wfns, qnum_l_core_ae_wfns, &
               &                       psir_core_ae_wfns, &
               &                       enelevel_core_ae_wfns, focc_core_ae_wfns )
          call read_data_core_soc( nfp, it, num_core_ae_wfns, &
               &                   qnum_n_core_ae_wfns, qnum_l_core_ae_wfns, &
               &                   guzai_core_ae_wfns )
       endif

       if ( npes > 1 ) then
          call mpi_bcast( qnum_n_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_integer, 0, mpi_comm_world, ierr )
          call mpi_bcast( qnum_l_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_integer, 0, mpi_comm_world, ierr )
          call mpi_bcast( enelevel_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
          call mpi_bcast( focc_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
          call mpi_bcast( psir_core_ae_wfns, nmesh(it)*num_core_ae_wfns, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
          call mpi_bcast( guzai_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
       endif

!
       Do i=1, num_core_ae_wfns
          if ( qnum_l_core_ae_wfns(i) == 3 ) then
             if ( focc_core_ae_wfns(i) > 0.1 .and. focc_core_ae_wfns(i) < 13.9 ) then
                has_open_forb(it) = 1
                Do ir=1, nmesh(it)
                   psir_f(ir,it) = psir_core_ae_wfns(ir,i)
                End Do
             endif
             guzai_f(it) = guzai_core_ae_wfns(i)
          endif
       End Do

       deallocate( qnum_n_core_ae_wfns )
       deallocate( qnum_l_core_ae_wfns )
       deallocate( psir_core_ae_wfns )
       deallocate( enelevel_core_ae_wfns )
       deallocate( focc_core_ae_wfns )
       deallocate( guzai_core_ae_wfns )

       call m_Files_close_ps_file(it)
    End Do
  end subroutine set_psir_f

  subroutine read_num_core_ae_wfns( nfp, nums, it )
    integer, intent(in) :: nfp, it
    integer, intent(out) :: nums

    integer :: length, ierr
    character(30) :: search_key

    nums = 0

    search_key = "CORE STATES";  length = len(search_key)
    call read_size_of_array_from_pp(nfp, nums, length, search_key, ierr)

    if ( ierr /= 0 ) then
       write(nfout,*) '----------------------'
       write(nfout,'(A,I2)') '!!! Keyword CORE STATES is not found in the PP', it
       write(nfout,*) '----------------------'
    endif

  end subroutine read_num_core_ae_wfns

  subroutine read_data_core_ae_wfns( nfp, num_core_ae_wfns, nmesh, &
       &                             qnum_n, qnum_l, psir_core, ene_level, focc )
    implicit none

    integer, intent(in) :: num_core_ae_wfns
    integer, intent(in) :: nmesh, nfp
    integer, intent(out) :: qnum_l(num_core_ae_wfns)
    integer, intent(out) :: qnum_n(num_core_ae_wfns)
    real(kind=8), intent(out) :: psir_core(nmesh, num_core_ae_wfns), &
         &                       ene_level(num_core_ae_wfns), focc(num_core_ae_wfns)

    integer :: i, n1, l1, k
    real(kind=DP) :: ene1, f1

    Do i=1, num_core_ae_wfns
       read(nfp,*) n1, l1, ene1, f1
       read(nfp,*) (psir_core(k,i),k=1,nmesh)
       !
       qnum_n(i) = n1;  qnum_l(i) = l1;  ene_level(i) = ene1;   focc(i) = f1
    End Do
  end subroutine read_data_core_ae_wfns

  subroutine read_size_of_array_from_pp( nfp, size_of_array, length, search_tag, ierr )
    implicit none

    integer, intent(in) :: nfp, length
    integer, intent(out) :: size_of_array, ierr
    character(length), intent(in) :: search_tag

    integer :: ifound
    character(30) :: line1

    size_of_array = 0;  ierr = 0

    Do while (.true.)
       read(nfp,'(a30)',end=10) line1
       ifound = index( line1, search_tag )
       if ( ifound /= 0 ) goto 20
    End do

10  ierr = 1; return

20  read(nfp,*) size_of_array

  end subroutine read_size_of_array_from_pp

  subroutine read_data_core_soc( nfp, it, num_core_ae_wfns, &
       &                         qnum_n, qnum_l, guzai_core )
    implicit none
    integer, intent(in) :: nfp, it, num_core_ae_wfns
    integer, intent(in) :: qnum_n(num_core_ae_wfns)
    integer, intent(in) :: qnum_l(num_core_ae_wfns)
    real(kind=DP), intent(out) :: guzai_core(num_core_ae_wfns)

    integer :: ifound, ier
    integer :: count, n1, l1, i, j
    real(kind=DP) :: c1
    character(30) :: search_tag
    character(30) :: line1

    ierr = 0;    guzai_core = 0.0d0

    search_tag = "SOC-CORE"

    Do while (.true.)
       read(nfp,'(a30)',end=10) line1
       ifound = index( line1, trim(search_tag) )
       if ( ifound /= 0 ) goto 20
    End do

10  ierr = 1;
    write(nfout,*) '----------------------'
    write(nfout,'(A,I2)') '!!! Keyword SOC-CORE is not found in the PP', it
    write(nfout,*) '----------------------'
    return

20  continue

    read(nfp,*) count
    Do i=1, count
       read(nfp,*) n1, l1, c1
       Do j=1, num_core_ae_wfns
          if ( qnum_n(j) == n1 .and. qnum_l(j) == l1 ) then
             guzai_core(j) = c1
             exit
          endif
       End Do
    End Do
  end subroutine read_data_core_soc

  subroutine contract_f_orbital( psir )
    real(kind=DP), intent(inout) :: psir(mmesh,ntyp)

    integer :: ik, ilmt1, il1, tau1, ir, ier, it
    real(kind=DP) :: csum, factor, rcut, beta
    real(kind=DP), allocatable :: tmp_fn(:), wos(:)

    allocate( tmp_fn(mmesh) );  allocate( wos(mmesh) );
    beta = 0.5d0

    Do it=1, ntyp
       rcut = rad_cov_default( nint(iatomn(it)) )
                    ! Revised according to a report from ASMS Co.ltd, 10 March 2016.

       call set_weight_exp( ier, 1, nmesh(it), radr_paw(:,it), wos )

       tmp_fn = 0.0d0
       Do ir=1, nmesh(it)
          tmp_fn(ir) = psir(ir,it) *exp( -radr_paw(ir,it)/rcut)
!          tmp_fn(ir) = psir(ir,it) /( 1.0d0 +exp( beta *(radr_paw(ir,it)-rcut) ) )
       End do

       csum = 0.0d0
       Do ir=1, nmesh(it)
          csum = csum + wos(ir) *tmp_fn(ir)**2
       End do

       factor = 1.0d0 /sqrt(csum)
       psir(:,it) = 0.0d0

       do ir = 1,nmesh(it)
          psir(ir,it) = tmp_fn(ir) *factor
       end do
    End Do
    call mpi_barrier( MPI_CommGroup, ierr )
    deallocate(tmp_fn); deallocate(wos)

  end subroutine contract_f_orbital

  subroutine m_CF_calc_CF_param
    integer :: val_l, lcmax, nsph1, nsph2, nsph3, nr
    integer :: ia, ig, it, excl_flg
    integer :: lun1, lun2
    integer, allocatable :: has_open_forb(:), ilist(:)
    real(kind=DP), allocatable :: qx(:), qy(:), qz(:), psir_f(:,:), guzai_f(:)
    real(kind=DP), allocatable :: zfcos(:), zfsin(:), wos(:)
    real(kind=DP), allocatable :: v_lm(:), v_lm_felec(:)
    real(kind=DP), allocatable :: chgq_self(:,:)
    real(kind=DP) :: rcut, norm_wf2
    real(kind=DP), allocatable :: r_avg(:)

    if ( .not. flg_paw ) return

    lun1 = 1000;   lun2 = 1001

    val_l = 3;     lcmax = 6

    if ( mype == 0 ) then
       open(lun1,file="Crystal_Field.input",status="old",form="formatted")
       read(lun1,*) sw_exclude_vxc
       read(lun1,*) sw_exclude_vh_selfcharge
       read(lun1,*) sw_exclude_vh_occmat
       close(lun1)
    endif
    call mpi_bcast( sw_exclude_vxc, 1, mpi_integer, 0, mpi_comm_world, ierr )
    call mpi_bcast( sw_exclude_vh_selfcharge, 1, mpi_integer, 0, mpi_comm_world, ierr )
    call mpi_bcast( sw_exclude_vh_occmat, 1, mpi_integer, 0, mpi_comm_world, ierr )

    call m_CF_set_gaunt_coeff
    if ( noncol ) then
       call m_SO_set_MatU_ylm_RC
       call m_SO_calc_MatLS_orb_s_to_f
    endif
!
    allocate( ilist(max_sph) ); ilist = 0

    Do nsph1=(val_l)**2+1, (val_l+1)**2
       Do nsph3=(val_l)**2+1, (val_l+1)**2
          Do nsph2=1, max_sph
             if ( abs(gaunt_coeff(nsph1,nsph2,nsph3)) > 1.0D-6 ) then
                ilist(nsph2) = 1
             endif
          End Do
       ENd Do
    End Do

    allocate( qx(ista_kngp:iend_kngp) )
    allocate( qy(ista_kngp:iend_kngp) )
    allocate( qz(ista_kngp:iend_kngp) )

    allocate( zfcos(ista_kngp:iend_kngp) )
    allocate( zfsin(ista_kngp:iend_kngp) )

    Do ig=ista_kngp, iend_kngp
       qx(ig) = rltv(1,1)*ngabc(ig,1) +rltv(1,2)*ngabc(ig,2) +rltv(1,3)*ngabc(ig,3)
       qy(ig) = rltv(2,1)*ngabc(ig,1) +rltv(2,2)*ngabc(ig,2) +rltv(2,3)*ngabc(ig,3)
       qz(ig) = rltv(3,1)*ngabc(ig,1) +rltv(3,2)*ngabc(ig,2) +rltv(3,3)*ngabc(ig,3)
    End do

    allocate( guzai_f(ntyp) ); guzai_f = 0.0d0
    allocate( psir_f(mmesh,ntyp) ); psir_f = 0.0d0
    allocate( has_open_forb(ntyp) );  has_open_forb = 0
    call set_radial_wavefunction( has_open_forb, psir_f, guzai_f )

    allocate( v_lm(max_sph) );  v_lm = 0.0d0

    if ( sw_exclude_vh_selfcharge == ON ) then
       allocate( chgq_self(ista_kngp:iend_kngp,kimg) );
    endif
    if ( sw_exclude_vh_occmat == ON ) then
       allocate( v_lm_felec(max_sph) )
    endif

    if ( mype == 0 ) call file_open( lun1, lun2 )

    Do ia=1, natm
       it = ityp(ia)
       if ( has_open_forb(it) == 0 .and. lpsmax(it) < 4 ) cycle

       rcut = rad_cov_default( nint(iatomn(it)) )
       call set_range_for_radial_integration( it, rcut, nr )

       allocate( wos(nr) )
       call set_weight_exp( ierr, 1, nr, radr_paw(:,it), wos )
       call calc_norm_wf2( nr, wos, norm_wf2 )

       call calc_phase2( natm, pos, ia, kgp, ngabc, ista_kngp, iend_kngp, &
            &            zfcos, zfsin )

       excl_flg = 0
!       if ( sw_exclude_vh_selfcharge == ON .and. has_open_forb(it) ==0 ) then
       if ( sw_exclude_vh_selfcharge == ON ) then
          excl_flg = 1
          call calc_chgq_inside_rcut( ia, rcut, zfcos, zfsin, chgq_self )
       endif

       call calc_v_lm( it, nr, wos, norm_wf2, zfcos, zfsin, v_lm, excl_flg )

       if ( sw_hubbard == ON .and. sw_exclude_vh_occmat == ON ) then
          call calc_v_lm_felec( ia, nr, v_lm_felec )
          v_lm = v_lm -v_lm_felec
       endif

       if ( mype == 0 ) then
          call print_field_param_A_real( ia, lun1, v_lm )
          call print_field_param_B_cmplx( ia, lun2, v_lm )
       endif

       call calc_hamil_eigenval( ia, it, has_open_forb, v_lm, guzai_f )

       deallocate( wos )
    ENd Do

    if ( mype == 0 ) call file_close( lun1, lun2 )

    deallocate(qx);    deallocate(qy);    deallocate(qz);
    deallocate(zfcos); deallocate(zfsin)
    deallocate(psir_f);deallocate(has_open_forb)
    deallocate(ilist); deallocate(v_lm);
    deallocate(guzai_f)

    if (allocated(chgq_self))   deallocate( chgq_self )
    if (allocated(v_lm_felec)) deallocate( v_lm_felec )

  contains

    subroutine file_open( lun1, lun2 )
      integer, intent(in) :: lun1, lun2

      character*32 :: file1, file2

      file1="Crystal_Field_Param_A.dat"
      open( lun1, file=file1, status="unknown", form="formatted")
      write(lun1,'(A)') "# Crystal Field Parameters (real)"

      file2="Crystal_Field_Param_B.dat"
      open( lun2, file=file2, status="unknown", form="formatted")
      write(lun2,'(A)') "# Crystal Field Parameters (complx)"
    end subroutine file_open

    subroutine file_close( lun1, lun2 )
      integer, intent(in) :: lun1, lun2

      close(lun1);  close(lun2)
    end subroutine file_close

    subroutine set_range_for_radial_integration( it, rcut, nr )
      integer, intent(in) :: it
      real(kind=DP), intent(in) :: rcut
      integer, intent(out) :: nr

      integer :: ir

      nr = 0
      Do ir=1, nmesh(it)
         if ( radr_paw(ir,it) < rcut ) nr = nr +1
      End Do
!       nr = nmesh(it)
    end subroutine set_range_for_radial_integration

    subroutine set_radial_wavefunction( has_open_forb, psir_f, guzai_f )
      integer, intent(out) :: has_open_forb(ntyp)
      real(kind=DP), intent(inout) :: psir_f(mmesh,ntyp), guzai_f(ntyp)

      integer :: it

      call set_psir_f( has_open_forb, psir_f, guzai_f )
      Do it=1, ntyp
         if ( lpsmax(it) == 4 ) then
            psir_f(1:nmesh(it),it) = psirpw(1:nmesh(it),4,1,it)
         endif
      End Do
      if ( sw_contract_forb == ON ) call contract_f_orbital( psir_f )
    end subroutine set_radial_wavefunction

    subroutine calc_norm_wf2( nr, wos, norm_wf2 )
      integer, intent(in) :: nr
      real(kind=DP), intent(in) :: wos(nr)
      real(kind=DP), intent(out) :: norm_wf2

      integer :: ir
      real(kind=DP) :: csum, c1

      csum = 0.0d0
      do ir = 1, nr
         c1 = wos(ir) *psir_f(ir,it)**2
         csum = csum +c1
      End do
      norm_wf2 = csum

    end subroutine calc_norm_wf2

    subroutine calc_r_avg( nr, wos, norm_wf2, r_avg )
      integer, intent(in) :: nr
      real(kind=DP), intent(in) :: norm_wf2
      real(kind=DP), intent(in) :: wos(nr)
      real(kind=DP), intent(out) :: r_avg(0:lcmax)

      integer :: il, ir
      real(kind=DP) :: csum, c1

      Do il=0, lcmax
         csum = 0.0d0
         do ir = 1, nr
            c1 = wos(ir) *psir_f(ir,it)**2 *radr_paw(ir,it)**il
            csum = csum +c1
         End do
         r_avg(il) = csum /norm_wf2
      End Do
    end subroutine calc_r_avg

    subroutine calc_chgq_inside_rcut( ia, rcut, zfcos, zfsin, chgq_filtered )
      integer, intent(in) :: ia
      real(kind=DP), intent(in) :: rcut
      real(kind=DP), intent(in) :: zfcos(ista_kngp:iend_kngp)
      real(kind=DP), intent(in) :: zfsin(ista_kngp:iend_kngp)
      real(kind=DP), intent(out) :: chgq_filtered(ista_kngp:iend_kngp,kimg)

      real(kind=DP), allocatable :: afft(:), bfft(:)
      real(kind=DP), allocatable :: wkq_l(:,:)

      allocate(afft(ista_fftp:iend_fftp)); afft =0.0d0
      allocate(bfft(ista_fftp:iend_fftp)); bfft =0.0d0

      call m_FFT_alloc_CD_box()

      allocate( wkq_l(ista_kngp:iend_kngp,kimg) )
      if ( noncol ) then
         wkq_l(ista_kngp:iend_kngp,:) = chgq_l(ista_kngp:iend_kngp,:,1)
      else
         if ( nspin == 1 ) then
            wkq_l(ista_kngp:iend_kngp,:) = chgq_l(ista_kngp:iend_kngp,:,1)
         else
            wkq_l(ista_kngp:iend_kngp,:) = chgq_l(ista_kngp:iend_kngp,:,1) &
                 &                           +chgq_l(ista_kngp:iend_kngp,:,2)
         endif
      endif
      call set_mat_on_fftmesh_rspace( wkq_l, afft )
      call set_filter( ia, rcut, zfcos, zfsin, wkq_l )
      call set_mat_on_fftmesh_rspace( wkq_l, bfft )
      call product_on_fft_mesh( afft, bfft )
      call set_chg( bfft, wkq_l )

      chgq_filtered = wkq_l
      deallocate( afft );    deallocate( bfft );    deallocate( wkq_l )
      call m_FFT_dealloc_CD_box()
    end subroutine calc_chgq_inside_rcut

    subroutine set_chg( afft, wkq_l )
      real(kind=DP), intent(inout) :: afft(ista_fftp:iend_fftp)
      real(kind=DP), intent(out) :: wkq_l(ista_kngp:iend_kngp,kimg)

      integer :: ik, i, ip
      real(kind=DP) :: rinplw
      real(kind=DP), allocatable :: afft_mpi1(:)

      call m_FFT_CD_direct_c( nfout, afft )        ! R -> G

      wkq_l = 0.0d0

      allocate(afft_mpi1(nfftp))
      if ( npes >1 ) then
         call mpi_allgatherv( afft, nel_fftp(mype), mpi_double_precision, &  ! MPI
              &               afft_mpi1, nel_fftp, idisp_fftp, mpi_double_precision, &
              &               MPI_CommGroup, ierr )
      else
         afft_mpi1 = afft
      end if

      rinplw = 1.d0 /product(fft_box_size_CD(1:3,1))
      do ik=1, kimg
         do i=ista_kngp, iend_kngp          !for mpi
            ip = (igfp_l(i)-1)*kimg + ik
            wkq_l(i,ik) = afft_mpi1(ip)*rinplw
         end do
      end do
      deallocate(afft_mpi1)

    end subroutine set_chg

    subroutine product_on_fft_mesh( afft, bfft )
      real(kind=DP), intent(in) :: afft(ista_fftp:iend_fftp)
      real(kind=DP), intent(inout) :: bfft(ista_fftp:iend_fftp)
      integer :: ig
      real(kind=DP) :: c1, c2

      Do ig=ista_fftp, iend_fftp, 2
#if 1
         c1 = afft(ig) *bfft(ig)
         bfft(ig) = c1
         bfft(ig+1) = 0.0d0
#else
         c1 = afft(ig) *bfft(ig) -afft(ig+1) *bfft(ig+1)
         c2 = afft(ig) *bfft(ig+1) +afft(ig+1) *bfft(ig)
         bfft(ig) = c1
         bfft(ig+1) = c2
#endif
      End Do
    end subroutine product_on_fft_mesh

    subroutine set_filter( ia, rcut, zfcos, zfsin, filter_l )
      integer, intent(in) :: ia
      real(kind=DP), intent(in) :: rcut
      real(kind=DP), intent(in) :: zfcos(ista_kngp:iend_kngp)
      real(kind=DP), intent(in) :: zfsin(ista_kngp:iend_kngp)
      real(kind=DP), intent(out) :: filter_l(ista_kngp:iend_kngp,kimg)

      integer :: ig
      real(kind=DP) :: c1, gx, gy, gz, fac, f1
      real(kind=DP), allocatable :: wka(:), wkb(:)

      fac = PAI4 *rcut**3 /univol

      allocate( wka(ista_kngp:iend_kngp) )
      allocate( wkb(ista_kngp:iend_kngp) )
      Do ig=ista_kngp, iend_kngp
         wka(ig) = gr_l(ig) *rcut
      End do

      call dsjnv( 1, iend_kngp -ista_kngp +1, wka, wkb )

      Do ig=ista_kngp, iend_kngp
         if ( ig==1 ) then
            f1 = fac /3.0d0
            filter_l(ig,1) =  f1
            filter_l(ig,2) =  0.0d0
         else
            f1 =  fac *wkb(ig) /wka(ig)      ! j1(GR)/GR
            filter_l(ig,1) =  f1 *zfcos(ig)
            filter_l(ig,2) = -f1 *zfsin(ig)
         endif
      End Do
      deallocate( wka );      deallocate( wkb )

    end subroutine set_filter

    subroutine set_mat_on_fftmesh_rspace( wkq_l, afft )
      real(kind=DP), intent(in) :: wkq_l(ista_kngp:iend_kngp,kimg)
      real(kind=DP), intent(out) :: afft(ista_fftp:iend_fftp)

      integer :: j, i, ip
      real(kind=DP) :: rinplw
      real(kind=DP), allocatable :: afft_mpi1(:), afft_mpi2(:), afft_mpi3(:)

      rinplw = 1.d0 /product(fft_box_size_CD(1:3,1))

      afft = 0.0d0;

      allocate(afft_mpi1(nfftp)); afft_mpi1 = 0.0d0
      if(npes >= 2) then
         allocate(afft_mpi2(mp_fftp)); afft_mpi2 = 0.0d0
         allocate(afft_mpi3(mp_fftp)); afft_mpi3 = 0.0d0
      end if
      do j = 1, kimg
         do i = ista_kngp, iend_kngp  !for mpi
            ip = (igfp_l(i)-1)*kimg + j
            afft_mpi1(ip) = wkq_l(i,j)
         end do
      end do

      if (npes >= 2) then
         call mpi_barrier(MPI_CommGroup,ierr)
         do j = 0, npes-1
            do i = nis_fftp(j),nie_fftp(j)
               afft_mpi2(i-nis_fftp(j)+1) = afft_mpi1(i)
            end do
            call mpi_allreduce(afft_mpi2,afft_mpi3,mp_fftp &
                 &  ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
            if(j == mype) then
               do i = ista_fftp, iend_fftp
                  afft(i) = afft_mpi3(i - ista_fftp + 1)
               end do
            end if
         end do
      else
         afft = afft_mpi1
      end if

      call m_FFT_CD_inverse_c(nfout,afft)        ! G-->R space
      deallocate(afft_mpi1)
      if (allocated(afft_mpi2) ) deallocate(afft_mpi2)
      if (allocated(afft_mpi3) ) deallocate(afft_mpi3)

    end subroutine set_mat_on_fftmesh_rspace

    subroutine calc_v_lm( it, nr, wos, norm_wf2, zfcos, zfsin, v_lm, excl_flg )
      integer, intent(in) :: it, nr, excl_flg
      real(kind=DP), intent(in) :: wos(nr)
      real(kind=DP), intent(in) :: norm_wf2
      real(kind=DP), intent(in) :: zfcos(ista_kngp:iend_kngp)
      real(kind=DP), intent(in) :: zfsin(ista_kngp:iend_kngp)
      real(kind=DP), intent(out) :: v_lm(max_sph)

      integer :: il1, im1, ir, ig, is, nsph1
      integer :: ierr, ismax
      real(kind=DP) :: fac, csum2, c1, csum, csum_mpi, facr, ctmp

      real(kind=DP), allocatable :: wka(:), wkb(:), ylm(:), snl2(:)

      fac = PAI4
      v_lm = 0.0d0
      ! ---
      allocate( wka(ista_kngp:iend_kngp) )
      allocate( wkb(ista_kngp:iend_kngp) )
      allocate( ylm(ista_kngp:iend_kngp) )
      allocate( snl2(ista_kngp:iend_kngp) )

      Do il1=0, lcmax
         Do im1=1, 2*il1 +1
            nsph1 = il1 **2 +im1
            if ( ilist(nsph1) == 0 ) cycle
            call sphr_general( iend_kngp -ista_kngp +1, nsph1, &
                 &     qx(ista_kngp:iend_kngp), &
                 &     qy(ista_kngp:iend_kngp), &
                 &     qz(ista_kngp:iend_kngp), ylm(ista_kngp:iend_kngp) )
            !
            snl2 = 0.0d0
            do ir = 1, nr
               facr = wos(ir) *psir_f(ir,it) *psir_f(ir,it)
               Do ig=ista_kngp, iend_kngp
                  wka(ig) = gr_l(ig) *radr_paw(ir,it)
               End do
               call dsjnv( il1, iend_kngp -ista_kngp +1, &
                    &      wka(ista_kngp:iend_kngp), &
                    &      wkb(ista_kngp:iend_kngp) )
               Do ig=ista_kngp, iend_kngp
                  snl2(ig) = snl2(ig) + fac *facr *wkb(ig) *ylm(ig)
               End do
            end do

            c1 = zi **il1;         snl2 = snl2 *c1

            csum = 0.0d0

            if ( noncol ) then
               ismax = 1
               Do is=1, ismax
                  Do ig=ista_kngp, iend_kngp
                     if ( sw_exclude_vxc == ON ) then
                        c1 = ( vlhxc_l(ig,1,1) -vxc_l(ig,1,1) )*zfcos(ig) &
                             & -(vlhxc_l(ig,2,is) -vxc_l(ig,2,is) )*zfsin(ig)
                     else
                        c1 = ( vlhxc_l(ig,1,is) ) *zfcos(ig) &
                             & -( vlhxc_l(ig,2,is) ) *zfsin(ig)
                     endif
                     csum = csum +c1 *snl2(ig)
                  End do
               End do
            else
               ismax = nspin
               Do is=1, ismax
                  if ( kimg ==2 ) then
                     Do ig=ista_kngp, iend_kngp
                        if ( sw_exclude_vxc == ON ) then
                           c1 = ( vlhxc_l(ig,1,is) -vxc_l(ig,1,is) ) *zfcos(ig) &
                                & -( vlhxc_l(ig,2,is) -vxc_l(ig,2,is) ) *zfsin(ig)
                        else
                           c1 = ( vlhxc_l(ig,1,is) ) *zfcos(ig) &
                                & -( vlhxc_l(ig,2,is) ) *zfsin(ig)
                        endif
                        csum = csum +c1 *snl2(ig)
                     End Do
                  else
                     Do ig=ista_kngp, iend_kngp
                        if ( sw_exclude_vxc == ON ) then
                           c1 = ( vlhxc_l(ig,1,is) -vxc_l(ig,1,is) )*zfcos(ig)
                        else
                           c1 = vlhxc_l(ig,1,is)*zfcos(ig)
                        endif
                        csum = csum +c1 *snl2(ig)
                     End Do
                  endif
               End do
               csum = csum /dble(nspin)
            endif

            if ( excl_flg == 1 ) then     ! kimg == 2 only
               Do ig=ista_kngp, iend_kngp
                  if ( ig /=1 ) then
                     c1 = ( chgq_self(ig,1) *zfcos(ig) -chgq_self(ig,2) *zfsin(ig) )&
                          &  /gr_l(ig)**2 *PAI4
                     csum = csum -c1 *snl2(ig)
                  endif
               End Do
            endif
            call mpi_allreduce( csum, csum_mpi, 1, mpi_double_precision, mpi_sum, &
                 &              MPI_CommGroup, ierr )
            !
            v_lm(nsph1) = csum_mpi
         end Do
      end Do
      v_lm = v_lm /norm_wf2
      deallocate(wka);      deallocate(wkb);      deallocate(ylm)
      deallocate(snl2)

    end subroutine calc_v_lm

    subroutine calc_v_lm_felec( ia, nr, v_lm_felec )
      integer, intent(in) :: ia, nr
      real(kind=DP), intent(out) :: v_lm_felec(max_sph)

      integer :: ih, ie, il1, il2, il3, immax, is, ir
      integer :: im1, im2, im3, nsph1, nsph2, nsph3
      real(kind=DP) :: c1, c2, csum, coeff, c3, c4
      real(kind=DP), allocatable :: rho(:), vh(:)
!
      integer :: ilmt1, ilmt2
      real(kind=DP) :: wk1(1), wk2(1), wk3(1), ylm(1)
!
      csum = 0.0
      it = ityp(ia)
      Do ir=1, nmesh(it)
         csum = csum +rhcorpw(ir,it) *wos(ir)
      End Do
!      write(*,*) "it csum = ", csum, csum/PAI4

      csum = 0.0d0
!
      v_lm_felec = 0.0d0

      ih = ihubbard(ia)
      if (ih == 0 ) return
!
      ie = proj_attribute(ih)%ielem
!      it=ityp(ia)
      il1 = proj_attribute(ih)%l

      if ( il1 /= 3 ) return

      immax = i2lp(ih)
      immax = 3*2 +1

      allocate( rho(nmesh(it)) );      allocate( vh(nmesh(it)) )

      Do il2=0, lcmax
         Do im2=1, 2*il2 +1
            nsph2 = il2**2 +im2
            if ( ilist(nsph2) == 0 ) cycle

            call real_spherical_harmonics( nsph2, 1, wk1, wk2, wk3, ylm, c3 )

            rho = 0.d0;     coeff = 0.0d0

            Do im1=1, immax
               Do im3=1, immax
                  c1 = 0.0d0
                  if ( noncol ) then
                     c1 = c1 +om(im1,im3,ie,ia,1)
                  else
                     Do is=1, nspin
                        c1 = c1 +om(im1,im3,ie,ia,is)
                     End Do
                     if ( nspin == 1 ) c1 = c1 *2.0d0
                  endif
!
!                  c1 = 0.d00
!                  if ( im1 == im3 ) then
!                     c1 = 3.0d0 /dble(immax)
!                  endif
!
                  nsph1 = il1**2 +im1;    nsph3 = il1**2 +im3
                  c2 = gaunt_coeff( nsph1, nsph2, nsph3 )
                  if ( abs(c2) < 1.0D-6 ) cycle
                  coeff = coeff +c1 *c2
               End do
            End Do

            Do ir=1, nmesh(it)
               rho(ir) = coeff *psir_f(ir,it)**2 /radr_paw(ir,it)**2
            End Do
!
            if ( nsph2 == 1 ) rho = rho /PAI4
!            rho = rho *c3**2

            vh = 0.0d0
            call calc_vh_asym( nmesh(it), radr_paw(:,it), rho, vh, il2 )

            csum = 0.0d0
            Do ir=1, nr
               csum = csum +wos(ir) *psir_f(ir,it)**2 *vh(ir)
            End Do
            v_lm_felec(nsph2) = csum
         End Do
      End Do
      deallocate(rho); deallocate(vh)
    end subroutine calc_v_lm_felec

    subroutine print_field_param_A_real( ia, lun, v_lm )
      integer, intent(in) :: lun, ia
      real(kind=DP), intent(in) :: v_lm(max_sph)

      integer :: il1, im1, im2, nsph1
      real(kind=DP) :: c1, c2
      real(kind=DP) :: wk1(1), wk2(1), wk3(1), ylm(1), coeff

      wk1(1) = 1.0;    wk2(1) = 1.0;      wk3(1) = 1.0

      Do il1=0, lcmax
         Do im1=1, 2*il1 +1
            nsph1 = il1 **2 +im1
            if ( ilist(nsph1) == 0 ) cycle
            call real_spherical_harmonics( nsph1, 1, wk1, wk2, wk3, ylm, coeff )

            im2 = get_m_tesseral_harmonics( il1, im1 )

            c1 = coeff *Hartree_2_Kelvin *v_lm(nsph1)
            write(lun,'(A,I4,A,I3,A,I3,A,F20.5,A)') &
                 &      "ia=", ia, ", L= ", il1, ", M= ", im2, &
                 &      ",   A_LM <r^L>=", c1, " [K]"
         End Do
      End Do
    end subroutine print_field_param_A_real

    subroutine print_field_param_B_cmplx( ia, lun, v_lm )
      integer, intent(in) :: lun, ia
      real(kind=DP), intent(in) :: v_lm(max_sph)

      integer :: il1, im1, nsph1, im2
      complex(kind=CMPLDP) :: z1, zsum

      Do il1=0, lcmax
         Do im1=-il1, il1
            zsum = 0.0d0
            Do im2=1, 2*il1 +1
               nsph1 = il1 **2 +im2
               if ( ilist(nsph1) == 0 ) cycle
               if ( il1 == 0 ) then
                  zsum = zsum +v_lm(nsph1) * MatU_ylm_RC_L0(im2,im1)
               else if ( il1 == 1  ) then
                  zsum = zsum +v_lm(nsph1) * MatU_ylm_RC_L1(im2,im1)
               else if ( il1 == 2 ) then
                  zsum = zsum +v_lm(nsph1) * MatU_ylm_RC_L2(im2,im1)
               else if ( il1 == 3 ) then
                  zsum = zsum +v_lm(nsph1) * MatU_ylm_RC_L3(im2,im1)
               else if ( il1 == 4 ) then
                  zsum = zsum +v_lm(nsph1) * MatU_ylm_RC_L4(im2,im1)
               else if ( il1 == 5 ) then
                  zsum = zsum +v_lm(nsph1) * MatU_ylm_RC_L5(im2,im1)
               else if ( il1 == 6 ) then
                  zsum = zsum +v_lm(nsph1) * MatU_ylm_RC_L6(im2,im1)
               endif
            End Do
            z1 = sqrt( (2*il1 +1)/PAI4 ) *zsum *Hartree_2_cminv

            write(lun,'(A,I4,A,I3,A,I3,A,2F18.5,A)') &
                 &      "ia=", ia, ", L= ", il1, ", M= ", im1, &
                 &      ",  B_LM =", real(z1), aimag(z1), " [cm-1]"
         End Do
      End Do
    end subroutine print_field_param_B_cmplx

    subroutine calc_hamil_eigenval( ia, it, has_open_forb, v_lm, guzai_f )
      integer, intent(in) :: ia, it
      integer, intent(in) :: has_open_forb(ntyp)
      real(kind=DP), intent(in) :: v_lm(max_sph), guzai_f(ntyp)

      integer :: im1, im3, nsph1, nsph2, nsph3, immax, is1, is3, istmp, size2
      integer :: lwork, info
      real(kind=DP) :: csum, gzi
      real(kind=DP), allocatable :: eigenval(:), rwork(:)
      complex(kind=CMPLDP), allocatable :: matH(:,:), work(:)

      immax = 2*val_l +1
      size2 = immax *ndim_spinor
      allocate( matH(size2,size2) ); matH = 0.0d0

      Do im1=1, immax
         Do im3=1, immax
            nsph1 = val_l**2 +im1;    nsph3 = val_l**2 +im3

            csum = 0.0d0
            Do nsph2=1, max_sph
               if ( ilist(nsph2) == 0 ) cycle
!               if ( nsph2 /= 5 ) cycle
               csum = csum +v_lm(nsph2) *gaunt_coeff(nsph1,nsph2,nsph3)
            End Do
            Do is1=1, ndim_spinor
               matH(immax*(is1-1)+im1,immax*(is1-1)+im3) = csum
            End Do
         End  Do
      End Do
!
      if ( noncol ) then
         gzi = 0.0d0
         if ( has_open_forb(it) == 1 ) then
            gzi = guzai_f(it)
         else if ( SpinOrbit_mode /= Neglected ) then
            gzi = Mat_Soc_Strength( 4, 1, 1, ia )
         endif

         Do im1=1, immax
            Do im3=1, immax
               Do is1=1, ndim_spinor
                  Do is3=1, ndim_spinor
                     istmp = ( is1 -1 )*ndim_spinor +is3
                     matH(immax*(is1-1)+im1,immax*(is3-1)+im3) &
                          &  = matH(immax*(is1-1)+im1,immax*(is3-1)+im3) &
                          &   +gzi *Mat_LS_with_real_ylm_L3(im1,im3,istmp)
                  End Do
               End Do
            End Do
         End Do
      endif

100   continue
!
      lwork = 2 *size2
      allocate( work(lwork) )
      allocate( eigenval(size2) ); eigenval = 0.0d0
      allocate( rwork( 3*size2 ) );
      call zheev( 'V', 'U', size2, MatH, size2, &
           &       eigenval, work, lwork, rwork, info )

      if ( mype == 0 ) then
         write(nfout,*) "** EigenValues of Hamiltonian of atom ", ia
         write(nfout,*) "  no.  value (cm-1)"
         Do im1=1, size2
!            write(nfout,*) im1, ( eigenval(im1) ) *Hartree_2_cminv
            write(nfout,*) im1, ( eigenval(im1) -eigenval(1) ) *Hartree_2_cminv
         End Do
      endif

      deallocate( work ); deallocate( eigenval );  deallocate( rwork )
      deallocate( matH )
    end subroutine calc_hamil_eigenval

  end subroutine m_CF_calc_CF_param

  subroutine m_CF_set_gaunt_coeff
    integer :: l1, l2, l3, m1, m2, m3, im1, im2, im3
    integer :: nsph1, nsph2, nsph3
    real(kind=DP) :: c0, c1, c2, c3
    complex(kind=CMPLDP) :: zsum
    complex(kind=CMPLDP), allocatable :: matwk(:,:,:)
    complex(kind=CMPLDP), pointer :: matU1(:,:), matU2(:,:), matU3(:,:)

    integer :: lcmax, n
    real(kind=DP), allocatable, dimension(:,:,:) :: cr2
    integer, allocatable, dimension(:,:,:)       :: isph2
    integer, allocatable, dimension(:,:)         :: mmt2
    real(kind=DP), allocatable :: matwk2(:,:,:)

    if ( allocated(gaunt_coeff) ) deallocate( gaunt_coeff )
    allocate( gaunt_coeff(16,49,16) ); gaunt_coeff = 0.0d0

    allocate( matwk(-3:3,-6:6,-3:3) ); matwk = 0.0d0

    Do l1=0, 3
       select case(l1)
       case (0)
          matU1 =>  MatU_ylm_RC_L0
       case (1)
          matU1 =>  MatU_ylm_RC_L1
       case (2)
          matU1 =>  MatU_ylm_RC_L2
       case (3)
          matU1 =>  MatU_ylm_RC_L3
       end select

       Do l2=0, 6
          select case(l2)
          case (0)
             matU2 =>  MatU_ylm_RC_L0
          case (1)
             matU2 =>  MatU_ylm_RC_L1
          case (2)
             matU2 =>  MatU_ylm_RC_L2
          case (3)
             matU2 =>  MatU_ylm_RC_L3
          case (4)
             matU2 =>  MatU_ylm_RC_L4
          case (5)
             matU2 =>  MatU_ylm_RC_L5
          case (6)
             matU2 =>  MatU_ylm_RC_L6
          end select

          Do l3=0, 3
             select case(l3)
             case (0)
                matU3 =>  MatU_ylm_RC_L0
             case (1)
                matU3 =>  MatU_ylm_RC_L1
             case (2)
                matU3 =>  MatU_ylm_RC_L2
             case (3)
                matU3 =>  MatU_ylm_RC_L3
             end select

             c0 = ( 2*l1+1 )*( 2*l2 +1 )*( 2*l3 +1 ) /PAI4
             c0 = sqrt( c0 )

             matwk = 0.0d0
             Do m1=-l1, l1
                Do m2=-l2, l2
                   Do m3=-l3, l3
                      c1 = wigner_3j( dble(l1), 0.0d0, dble(l2), 0.0d0, dble(l3), 0.0d0 )
                      c2 = wigner_3j( dble(l1), -dble(m1), dble(l2), dble(m2), &
                           &          dble(l3), dble(m3) )
                      c3 = (-1)**m1
                      matwk(m1,m2,m3) = c0 *c1 *c2 *c3
                   End Do
                End Do
             End Do
             !
             Do im1=1, 2*l1 +1
                Do im2=1, 2*l2 +1
                   Do im3=1, 2*l3 +1
                      nsph1 = l1**2 +im1
                      nsph2 = l2**2 +im2
                      nsph3 = l3**2 +im3
                      zsum = 0.0d0
                      Do m1=-l1, l1
                         Do m2=-l2, l2
                            Do m3=-l3, l3
                               zsum = zsum +conjg(matU1(im1,m1)) *matU2(im2,m2) &
                                    &      *matU3(im3,m3) *matwk(m1,m2,m3)
                            End Do
                         End Do
                      ENd Do
                      gaunt_coeff(nsph1,nsph2,nsph3) = zsum
                   End Do
                ENd Do
             ENd Do
          End Do
       ENd Do
    End Do
    deallocate( matwk )
  end subroutine m_CF_set_gaunt_coeff

  real(kind=8) function wigner_3j( val_j1, val_m1, val_j2, val_m2, val_j3, val_m3 )
    real(kind=8), intent(in) :: val_j1, val_j2, val_j3, val_m1, val_m2, val_m3

    integer :: i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, k, kmin, kmax
    real(kind=8) :: c1, c2, c3, c4, c5, c6, c7, c8, c9, c10
    real(kind=8) :: d1, d2, term_n, term_s, coeff

    if ( nint(val_m1 +val_m2 +val_m3) .ne. 0 ) then
       wigner_3j = 0.0d0;  return
    endif

    coeff = (-1)**( val_j1 -val_j2 -val_m3 )

    i1 = nint( val_j3 +val_j1 -val_j2 );    i2 = nint( val_j3 -val_j1 +val_j2 )
    i3 = nint( val_j1 +val_j2 -val_j3 );    i4 = nint( val_j3 -val_m3 )
    i5 = nint( val_j3 +val_m3 )
    i6 = nint( val_j1 +val_j2 +val_j3 +1 )
    i7 = nint( val_j1 -val_m1 );            i8 = nint( val_j1 +val_m1 )
    i9 = nint( val_j2 -val_m2 );            i10 = nint( val_j2 +val_m2 )

    c1 = factorial(i1);      c2 = factorial(i2);       c3 = factorial(i3)
    c4 = factorial(i4);      c5 = factorial(i5);       c6 = factorial(i6)
    c7 = factorial(i7);      c8 = factorial(i8);       c9 = factorial(i9)
    c10= factorial(i10)

    d1 = c1 *c2 *c3 *c4 *c5
    d2 = c6 *c7 *c8 *c9 *c10
    write(*,*) "d1 = ", d1, d2

    term_n = sqrt( d1 /d2 )

    kmin = max( 0, nint(val_m1 -val_j1) )
    kmin = max( kmin, nint(val_j2 -val_j1 -val_m3) )
    kmax = min( nint(val_j2 +val_j3 +val_m1), nint(val_j3 -val_j1 +val_j2) )
    kmax = min( kmax, nint(val_j3 -val_m3) )

    term_s = 0.0d0
    Do k=kmin, kmax
!    Do k=0, 100
       i2 = nint( val_j2 +val_j3 +val_m1 -k )
       i3 = nint( val_j1 -val_m1 +k )
       i5 = nint( val_j3 -val_j1 +val_j2 -k )
       i6 = nint( val_j3 -val_m3 -k )
       i7 = nint( val_j1 -val_j2 +val_m3 +k )
!       if ( i2 < 0 ) cycle
!       if ( i3 < 0 ) cycle
!       if ( i5 < 0 ) cycle
!       if ( i6 < 0 ) cycle
!       if ( i7 < 0 ) cycle

       c1 = (-1)**( val_j2 +val_m2 +k )
       c2 = factorial(i2);       c3 = factorial(i3);
       c4 = factorial(k)
       c5 = factorial(i5);       c6 = factorial(i6);       c7 = factorial(i7)
       d1 = c1 *c2 *c3
       d2 = c4 *c5 *c6 *c7
       term_s = term_s +d1 /d2
    End Do
    wigner_3j = coeff *term_n *term_s
    return
  end function wigner_3j

  real(kind=8) recursive function factorial(n)
    integer, intent(in) :: n

    integer :: i

    factorial = 1
    Do i=1, n
       factorial = factorial *i
    End do
    return
  end function factorial

  integer function get_m_tesseral_harmonics( il_in, im_in )
    integer, intent(in) :: il_in, im_in
    integer :: im_out

    select case(il_in)
    case (0)
       im_out = 0
    case (1)
       if ( im_in == 1 ) im_out =  1
       if ( im_in == 2 ) im_out = -1
       if ( im_in == 3 ) im_out =  0
    case (2)
       if ( im_in == 1 ) im_out =  0
       if ( im_in == 2 ) im_out =  2
       if ( im_in == 3 ) im_out = -2
       if ( im_in == 4 ) im_out = -1
       if ( im_in == 5 ) im_out =  1
    case (3,4,5,6)
       im_out = int( im_in /2 )
       if ( mod(im_in,2) == 1 ) im_out = -im_out
    end select
    get_m_tesseral_harmonics = im_out
  end function get_m_tesseral_harmonics


  subroutine calc_vh_asym( nmesh, rpos, rho, vh, qnum_l )
    integer, intent(in) :: nmesh, qnum_l
    real(kind=DP), intent(in) :: rpos(nmesh), rho(nmesh)
    real(kind=DP), intent(out) :: vh(nmesh)

    integer :: ir, ii, i0, is, j, jr, ier
    real(kind=DP) :: sum1, sum2
    real(kind=DP), allocatable :: wt(:)

    allocate( wt (nmesh) ); wt = 0.0d0

    do ir = 1,nmesh
       sum1 = 0.d0;  sum2 = 0.d0
       if (ir == 1) then
          sum1 = 0.d0
       else if ((ir >= 2).and.(ir <= 5)) then
          do ii = 2,ir
             i0 = ii-1; is = 1
             call set_open_weight_exp(ier,i0,is,rpos,wt)

             do j = 1,4
                sum1 = sum1 +rpos(i0+j*is) **(qnum_l +2) *rho(i0+j*is) *wt(i0+j*is)
             end do
          end do
       else
          call set_weight_exp(ier,1,ir,rpos,wt)
          do jr = 1,ir
             sum1 = sum1 + rpos(jr) **( qnum_l +2 ) *rho(jr)*wt(jr)
          end do
       end if
       sum1 = sum1 *PAI4 /rpos(ir) **( qnum_l +1 )

       if (ir == nmesh) then
          sum2 = 0.d0
       else if ((ir <= nmesh-1).and.(ir >= nmesh-4)) then
          do ii = ir,nmesh-1
             i0 = ii+1; is = -1
             call set_open_weight_exp(ier,i0,is,rpos,wt)
             do j = 1,4
                sum2 = sum2 -rpos(i0+j*is)**(qnum_l +2) *rho(i0+j*is) *wt(i0+j*is)
             end do
          end do
       else
          call set_weight_exp(ier,ir,nmesh,rpos,wt)
          do jr = ir,nmesh
             sum2 = sum2 + rpos(jr)**( 1-qnum_l ) *rho(jr)*wt(jr)
          end do
       end if
       sum2 = sum2 *PAI4 *rpos(ir)**( qnum_l )
       vh(ir) = ( sum1 + sum2 ) / ( 2.*qnum_l +1. )
    end do

    deallocate( wt )
  end subroutine calc_vh_asym

  subroutine m_CF_calc_mutiple_moments
    integer :: lcmax
    integer :: ia, it, ig, il1, im1, nsph1, ist, is
    real(kind=DP) :: c1, fac, rcut
    complex(kind=CMPLDP) :: z1, z2, zsum, zsum_mpi
    real(kind=DP), allocatable :: wka(:), wkb(:), qx(:), qy(:), qz(:), ylm(:)
    real(kind=DP), allocatable :: zfcos(:), zfsin(:)
    real(kind=DP), allocatable :: multipole(:)
!
    lcmax = 6
    allocate( wka(ista_kngp:iend_kngp) )
    allocate( wkb(ista_kngp:iend_kngp) )
    allocate( ylm(ista_kngp:iend_kngp) )
    allocate( qx(ista_kngp:iend_kngp) )
    allocate( qy(ista_kngp:iend_kngp) )
    allocate( qz(ista_kngp:iend_kngp) )
    allocate( zfcos(ista_kngp:iend_kngp) )
    allocate( zfsin(ista_kngp:iend_kngp) )

    Do ig=ista_kngp, iend_kngp
       qx(ig) = rltv(1,1)*ngabc(ig,1) +rltv(1,2)*ngabc(ig,2) +rltv(1,3)*ngabc(ig,3)
       qy(ig) = rltv(2,1)*ngabc(ig,1) +rltv(2,2)*ngabc(ig,2) +rltv(2,3)*ngabc(ig,3)
       qz(ig) = rltv(3,1)*ngabc(ig,1) +rltv(3,2)*ngabc(ig,2) +rltv(3,3)*ngabc(ig,3)
    End do

    allocate( multipole(49))

    Do ia=1, natm
       it = ityp(ia)
       if ( lpsmax(it) /=4 ) cycle

!       rcut = rad_cov_default( iatomn(it) )
       rcut = rad_cov( ia )
       fac = rcut**3 *PAI4

       call calc_phase2( natm, pos, ia, kgp, ngabc, ista_kngp, iend_kngp, &
            &            zfcos, zfsin )
       Do ig=ista_kngp, iend_kngp
          wka(ig) = gr_l(ig) *rcut
       End do

       multipole = 0.0d0

       Do il1=0, lcmax
          call dsjnv( il1 +1, iend_kngp -ista_kngp +1, &
               &      wka(ista_kngp:iend_kngp), &
               &      wkb(ista_kngp:iend_kngp) )

          Do im1=1, 2*il1 +1
             nsph1 = il1**2 +im1
             call sphr_general( iend_kngp -ista_kngp +1, nsph1, &
                  &     qx(ista_kngp:iend_kngp), &
                  &     qy(ista_kngp:iend_kngp), &
                  &     qz(ista_kngp:iend_kngp), ylm(ista_kngp:iend_kngp) )

             ist = ista_kngp
             if ( ist == 1 ) ist = 2

             Do is=1, nspin
                zsum = 0.0d0
                Do ig=ist, iend_kngp
                   c1 = ylm(ig) *wkb(ig) /wka(ig)
                   z1 = cmplx( chgq_l(ig,1,is) , chgq_l(ig,2,is) )
                   z2 = cmplx( zfcos(ig), zfsin(ig) )
                   zsum = zsum +z1 *c1 *z2
                End Do
                zsum = zsum *zi **il1 *fac
                if ( il1 == 0 ) then
                   if ( mype == 0 ) zsum = zsum +chgq_l(1,1,is) *fac /3.d0 *ylm(1)
                endif
                multipole(nsph1) = multipole(nsph1) +zsum
             End Do
          end Do
       end Do
       call mpi_allreduce( MPI_IN_PLACE, multipole, 49, mpi_double_precision, &
            &              mpi_sum, MPI_CommGroup,ierr )
!
       Do nsph1=1, 49
          write(nfout,'(A,2I5,F20.12)') &
               &    "ia nsph1 contrib.", ia, nsph1, multipole(nsph1)
       end Do
    End Do
    deallocate( qx );    deallocate( qy );    deallocate( qz )
    deallocate( ylm );   deallocate( wka );   deallocate( wkb )
    deallocate( zfcos );    deallocate( zfsin )
    deallocate( multipole )

  end subroutine m_CF_calc_mutiple_moments

#if 0
R: 4f atom no aru site
vh_lm(|r-R|) = int vh(r) Ylm(|r-R|)
             = int sum_G vh(G)exp(iGr) Ylm(|r-R|)      ( r-R=r'; r = r'+R )
             =                exp(iGr') exp(iGR) Ylm(|r'|)
             = sum_G vh(G) exp(iGR) Ylm(G) j_l(Gr') ??
vh(r) R4f(r-R)^2 (r-R)^2 dr
#endif


end module m_Crystal_Field

module m_timer
  implicit none
  integer, parameter :: dp = kind(0d0)
  integer, parameter :: n_tim = 1750
  integer :: iunit1 = 91
  integer :: iunit2 = 92
#ifdef USE_MEM
  integer :: unitmw = 93
  integer :: unitmr = 94
#endif
!--
!--
  integer, parameter :: n_ite = 10
!--
#ifdef USE_WTIME
  real(dp) :: t_now
  real(dp) :: timers(n_tim,0:n_ite), tsta(n_tim), ttot(3)
  real(dp) :: timers_all(n_tim)
#ifdef USE_MEM
  real(dp) :: t_sta
#endif
#else
  integer(8) :: t_now
  integer(8) :: timers(n_tim,0:n_ite), tsta(n_tim), ttot(3)
  integer(8) :: timers_all(n_tim)
#ifdef USE_MEM
  integer(8) :: t_sta
#endif
#endif
  integer  :: ncount(n_tim,0:n_ite), ncnt_e(n_tim,0:n_ite)
  integer  :: ncount_all(n_tim)
  character(50) :: name(n_tim)
  logical  :: tflag = .false.
  character(len=3) :: ite_num
  character(len=5) :: rnk_num
  character(len=80) :: fname
  character(len=80) :: dname
  character(len=5)  :: crank
  integer :: myrank  
  integer :: orank = 0

end module m_timer

!-----------------------------------------------------------------------
subroutine timer_init
  use m_timer
  implicit none
  include 'mpif.h'
  integer :: ierr
  real(4) :: rdum, rarray(2)
!  real(4), external :: etime
  real(4) :: etime

  call MPI_COMM_RANK(MPI_COMM_WORLD, myrank, ierr)

#ifdef USE_MEM
  if (myrank .eq. 0) then
    open(unitmw,file='mem.txt',status='replace')
    write(unitmw,*) "Kukan Times[s] Virtual_Memory[B] Resident_Set_Size[Page]"
#ifdef USE_WTIME
    t_sta=MPI_WTIME()
#else
    call getclkreg(t_sta)
#endif
  endif
#endif

#ifdef USE_KTRACE
      integer ktrace_target(n_tim)
      common /c_ktrace_target/ ktrace_target

      ! init
      ktrace_target(1:n_tim) = 0
      ! set ktarce target
      ktrace_target(1:n_tim) = 1
!$omp parallel
      call ktrace_enter
!$omp end parallel

#endif

  ! real, user, sys of total
  rdum = etime(rarray)
#ifdef USE_WTIME
  ttot(1) = MPI_WTIME()  ! real
#else
  call getclkreg(ttot(1))! real
#endif
  ttot(2) = rarray(1)    ! user
  ttot(3) = rarray(2)    ! sys

  timers = 0.0d0
  tsta   = 0.0d0
  ncount = 0
  ncnt_e = 0

  name = '-'
  ! set timer name
! name(000) = '---------1---------2---------3---------4---------5---------6----'
  name( 1) =  'Kukan_1                                 '
  name( 2) =  'Kukan_2                                 '
  name( 3) =  'Kukan_3                                 '
  name( 4) =  'Kukan_4                                 '
  name( 5) =  'Kukan_5                                 '
  name( 6) =  'Kukan_6                                 '
  name( 7) =  'Kukan_7                                 '
!fj mod 20110819
! name( 8) =  'Kukan_8_latter_half_&_kukan_9           '
  name( 8) =  'Kukan_8_latter_half                     '
  name( 9) =  'kukan_9                                 '
!fj mod 20110819
  name(10) =  'Kukan_10                                '
  name(11) =  'Kukan_11                                '
  name(12) =  '  Solver_SD_or_MSD_(_or_CG_)            '
  name(13) =  '  Solver_lmSD_or_lmMSD_(_or_CG_)        '
  name(14) =  '  Solver_Submat                         '
  name(15) =  '  Solver_MATRIXDIAGON                   '
  name(16) =  'SCF_Loop                                '
  name(17) =  'Initialization                          '
  name(18) =  '  Solver_RMM                            '
  name(19) =  'Forces                                  '
  name(20) =  'Move_Ions                                '
!fj mod 20110906
  name(1498) = 'Parallel_Region_Overhead                 '
  name(1499) = 'Parallel_Region_Overhead                 '
  name(1500) = 'kukan_9_not_scalapack                    '
!fj mod 20110906
!----- FJ sokutei
  name(21) = 'Initialization'
  name(22) = 'InputData_Analysis'
  name(23) = 'Preparation'
  name(24) = 'Preparation_for_mpi'
  name(25) = 'PseudoPotential_Construction'
  name(26) = 'Ewald_and_Structure_Factor'
  name(27) = 'Initial_Electronic_Structure'
  name(28) = 'INI_1_Gvec'
  name(29) = 'INI_2_PP'
  name(30) = 'INI_3_WF'
  name(31) = 'INI_4_CS'
  name(32) = 'm_ES_modified_gram_schmidt' ! kukan 4,5
  name(33) = 'm_ES_energy_eigen_values'  ! kukan 6
  name(34) = 'm_XC_cal_potential'  !kukan 7
  name(35) = 'm_ESlhxc_potential'  !kukan 11
  name(36) = 'm_ESiVQ_integrate_VlhxcQlm'  !kukan 11
!-----
  name(37) = 'PARA_2Dto3D'  !interface
  name(38) = 'PARA_3Dto2D'  !interface
  name(39) = 'WriteDownData_onto_Files'
!-----
  name(40) = 'm_ESIW_by_randomnumbers' 
  name(41) = 'm_pwBS_generate_G_vectors'
  name(42) = 'count_Gvectors_in_spheres'
  name(43) = 'get_Gvectors_in_a_gmaxp_sphere'
  name(44) = 'm_pwBS_generate_G_vectors_3D:allgather'
!---
! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- MATDIAGON / SUBROUTINE
  name(1201) = 'm_ESmat_solve_Hx_eq_eSx_3D'
  name(1202) = 'wd_hsmat'
  name(1203) = 'solve_Hx_eq_ex_LAPACK'
  name(1204) = 'calphase'
  name(1205) = 'nlmtrx'
  name(1206) = 'ovmtrx'
  name(1207) = 'cholde'
  name(1208) = 'amtrxkinetic'
  name(1209) = 'prjvlhxc_l2vlhxc_t'
  name(1210) = 'amtrxlocalpt'
  name(1211) = 'lhl'
  name(1212) = 'lx'
  name(1213) = 'phase_mult'
  name(1214) = 'cp_zaj_mat_to_zaj_l'
  name(1470) = 'make_index_band_for_scalapack'
!---- MATDIAGON add scalapack
  name(1471) = 'solve_Hx_eq_ex_ScaLAPACK'
  name(1472) = 'scalapack_setup_3D'
  name(1473) = 'make_index_band_for_scalapack_md'
  name(1474) = 'trans_scalapack                         '
  name(1475) = 'trans_scalapack_r                       '
  name(1476) = 'm_ESmat_solve_Hx_eq_eSx_3D:1            '
  name(1477) = 'm_ESmat_solve_Hx_eq_eSx_3D:2            '
  name(1478) = 'm_ESmat_solve_Hx_eq_eSx_3D:3            '
  name(1479) = 'solve_Hx_eq_ex_ScaLAPACK:PDSYGVX        '
  name(1480) = 'solve_Hx_eq_ex_ScaLAPACK:PDSYEVX        '
  name(1481) = 'solve_Hx_eq_ex_ScaLAPACK:DO_1           '
  name(1482) = 'solve_Hx_eq_ex_ScaLAPACK:PZHEGVX        '
  name(1483) = 'solve_Hx_eq_ex_ScaLAPACK:PZHEEVX        '
  name(1484) = 'solve_Hx_eq_ex_ScaLAPACK:DO_2           '
  name(1485) = 'trans_scalapack:DO_1                    '
  name(1486) = 'trans_scalapack:DO_2                    '
  name(1487) = 'trans_scalapack:DO_3                    '
  name(1488) = 'trans_scalapack:DO_4                    '
  name(1489) = 'trans_scalapack:isend/irecv_1           '
  name(1490) = 'trans_scalapack_r:DO_1                  '
  name(1491) = 'trans_scalapack_r:DO_2                  '
  name(1492) = 'trans_scalapack_r:DO_3                  '
  name(1493) = 'trans_scalapack_r:DO_4                  '
  name(1494) = 'trans_scalapack_r:isend/irecv_1         '
! -- Initialization / SUBROUTINE
  name(1215) = 'm_ES_betar_dot_WFs_3D'
  name(1216) = 'cpzaj_l_to_psi_ri'
  name(1217) = 'set_msize'
  name(1218) = 'pre_lmta_k_blk'
  name(1219) = 'post_lmta_k_blk'
  name(1220) = 'm_pwBS_calc_length_of_G_3D'
  name(1221) = 'm_pwBS_for_each_WF'
  name(1222) = 'm_PP_vanderbilt_type_3D'
  name(1223) = 'm_PP_local_part_3D'
  name(1224) = 'm_NLP_betar_dot_PWs_3D'
  name(1225) = 'm_CD_cp_chgq_to_chgqo_3D'
  name(1226) = 'm_CD_initial_CD_by_Gauss_func_3D'
  name(1227) = 'm_CS_gnrt_symmetry_operations'
  name(1228) = 'm_IS_symm_check_of_pos'
  name(1229) = 'm_Parallel_init_mpi_elec_3D'
  name(1230) = 'make_index_band_3D'
  name(1231) = 'make_index_band_for_Gdiv_3D'
  name(1232) = 'm_Parallel_mpi_fft_box'
  name(1233) = 'm_Parallel_mpi_fft_box_cd'
  name(1234) = 'm_Parallel_init_mpi_kngp_B_3D'
  name(1235) = 'm_Parallel_init_mpi_nbmx'
  name(1236) = 'im_Parallel_init_mpi_gga'
  name(1237) = 'm_Parallel_init_mpi_snl_3D'
  name(1238) = 'm_Parallel_init_mpi_atm_3D'
  name(1239) = 'm_Parallel_init_mpi_atm2_3D'
  name(1240) = 'm_Parallel_init_mpi_atm_B_3D'
  name(1241) = 'm_Parallel_init_mpi_mix_3D'
  name(1242) = 'm_Parallel_init_mpi_iba_3D'
  name(1243) = 'm_Parallel_wf_onto_fft_3D'
  name(1244) = 'm_Parallel_fft_onto_wf_3D'
  name(1245) = 'm_Parallel_fft_onto_chgq_3D'
  name(1246) = 'm_Parallel_chgq_onto_fftcd_3D'
  name(1247) = 'm_Parallel_fftcd_onto_chgq_3D'
  name(1248) = 'm_IS_structure_factor_3D'
  name(1249) = 'structure_factor1'
  name(1250) = 'structure_factor2'
  name(1251) = 'm_IS_ewald_3D'
  name(1252) = 'decide_rxyz_size'
  name(1253) = 'substitute_rxyz'
  name(1254) = 'decide_alf'
  name(1255) = 'decide_newldg'
  name(1256) = 'cpspac'
  name(1257) = 'set_ewald_parameters'
  name(1258) = 'ewald_Rspace_summation'
  name(1259) = 'ewald_Gspace_summation'
  name(1260) = 'get_zsum'
  name(1261) = 'add_exp_G2_zsum'
  name(1262) = 'ewald_force_Gspace_summation'

! -- MATDIAGON / COMMUNICATION
  name(1263) = 'solve_Hx_eq_ex_LAPACK:allreduce1'
  name(1264) = 'solve_Hx_eq_ex_LAPACK:allreduce2'
  name(1265) = 'nlmtrx:allreduce'
  name(1266) = 'ovmtrx:allreduce_1'
  name(1267) = 'ovmtrx:allreduce_2'
  name(1268) = 'cholde:allreduce_1'
  name(1269) = 'cholde:allreduce_2'
  name(1270) = 'cholde:allreduce_3'
  name(1271) = 'cholde:allreduce_4'
  name(1272) = 'cholde:allreduce_5'
  name(1273) = 'cholde:allreduce_6'
  name(1274) = 'cholde:allreduce_7'
  name(1275) = 'cholde:allreduce_8'
  name(1276) = 'prjvlhxc_l2vlhxc_t:allreduce'
  name(1277) = 'amtrxlocalpt:allreduce'
  name(1278) = 'lhl:allreduce_1'
  name(1279) = 'lhl:allreduce_2'
  name(1280) = 'lhl:allreduce_3'
  name(1281) = 'lhl:allreduce_4'
  name(1282) = 'lhl:allreduce_5'
  name(1283) = 'lhl:allreduce_6'
  name(1284) = 'lx:allreduce_1'
  name(1285) = 'lx:allreduce_2'
! -- MATDIAGON / DO
  name(1286) = 'solve_Hx_eq_ex_LAPACK:DO_1'
  name(1287) = 'solve_Hx_eq_ex_LAPACK:DO_2'
  name(1288) = 'solve_Hx_eq_ex_LAPACK:DO_3'
  name(1289) = 'solve_Hx_eq_ex_LAPACK:DO_4'
  name(1290) = 'solve_Hx_eq_ex_LAPACK:DO_5'
  name(1291) = 'calphase:DO_1'
  name(1292) = 'nlmtrx:DO_1'
  name(1293) = 'nlmtrx:DO_2'
  name(1294) = 'nlmtrx:DO_3'
  name(1295) = 'nlmtrx:DO_4'
  name(1296) = 'nlmtrx:DO_5'
  name(1297) = 'nlmtrx:DO_6'
  name(1298) = 'ovmtrx:DO_1'
  name(1299) = 'ovmtrx:DO_2'
  name(1300) = 'ovmtrx:DO_3'
  name(1301) = 'ovmtrx:DO_4'
  name(1302) = 'ovmtrx:DO_5'
  name(1303) = 'ovmtrx:DO_6'
  name(1304) = 'ovmtrx:DO_7'
  name(1305) = 'cholde:DO_1'
  name(1306) = 'cholde:DO_2'
  name(1307) = 'cholde:DO_3'
  name(1308) = 'cholde:DO_4'
  name(1309) = 'cholde:DO_5'
  name(1310) = 'cholde:DO_6'
  name(1311) = 'cholde:DO_7'
  name(1312) = 'cholde:DO_8'
  name(1313) = 'cholde:DO_9'
  name(1314) = 'cholde:DO_10'
  name(1315) = 'cholde:DO_11'
  name(1316) = 'cholde:DO_12'
  name(1317) = 'cholde:DO_13'
  name(1318) = 'cholde:DO_14'
  name(1319) = 'amtrxkinetic:DO_1'
  name(1320) = 'prjvlhxc_l2vlhxc_t:DO_1'
  name(1321) = 'amtrxlocalpt:DO_1'
  name(1322) = 'amtrxlocalpt:DO_2'
  name(1323) = 'amtrxlocalpt:DO_3'
  name(1324) = 'amtrxlocalpt:DO_4'
  name(1325) = 'lhl:DO_1'
  name(1326) = 'lhl:DO_2'
  name(1327) = 'lhl:DO_3'
  name(1328) = 'lhl:DO_3'
  name(1329) = 'lhl:DO_5'
  name(1330) = 'lhl:DO_6'
  name(1331) = 'lhl:DO_7'
  name(1332) = 'lx:DO_1'
  name(1333) = 'lx:DO_2'
  name(1334) = 'lx:DO_3'
  name(1335) = 'lx:DO_4'
  name(1336) = 'lx:DO_5'
  name(1337) = 'phase_mult:DO_1'
  name(1338) = 'phase_mult:DO_2'
  name(1339) = 'phase_mult:DO_3'
  name(1340) = 'cp_zaj_mat_to_zaj_l:DO_1'
  name(1341) = 'cp_zaj_mat_to_zaj_l:DO_2'
  name(1342) = 'cp_zaj_mat_to_zaj_l:DO_3'
  name(1343) = 'cp_zaj_mat_to_zaj_l:DO_4'
  name(1344) = 'cp_zaj_mat_to_zaj_l:DO_5'
! -- Initialization / DO    # TIMER_INIDO
  name(1345) = 'm_ESIW_by_randomnumbers_3D:DO_1'
  name(1346) = 'm_ESIW_by_randomnumbers_3D:DO_2'
  name(1347) = 'get_Gvectors_in_a_gmaxp_sphere:DO_1'
  name(1348) = 'get_Gvectors_in_a_gmaxp_sphere:DO_2'
  name(1349) = 'get_Gvectors_in_a_gmaxp_sphere:DO_3'
  name(1350) = 'get_Gvectors_in_a_gmaxp_sphere:DO_4'
  name(1351) = 'count_Gvectors_in_spheres:DO_1'
! -- Initialization / COMMUNICATION    # TIMER_INICOMM
  name(1352) = 'm_Parallel_wf_onto_fft_3D:isend/irecv_1'
  name(1353) = 'm_Parallel_wf_onto_fft_3D:allgater_1'
  name(1354) = 'm_Parallel_wf_onto_fft_3D:isend/irecv_2'
  name(1355) = 'm_Parallel_wf_onto_fft_3D:alltoall_1'
  name(1356) = 'm_Parallel_fft_onto_wf_3D:isend/irecv_1'
  name(1357) = 'm_Parallel_fft_onto_wf_3D:alltoall_1'
  name(1358) = 'm_Parallel_fft_onto_chgq_3D:isend/irecv_1'
  name(1359) = 'm_Parallel_fft_onto_chgq_3D:alltoall_1'
  name(1360) = 'm_Parallel_chgq_onto_fftcd_3D:isend/irecv_1'
  name(1701) = 'm_Parallel_chgq_onto_fftcd_3D:allgather_1'
  name(1702) = 'm_Parallel_chgq_onto_fftcd_3D:isend/irecv_1'
  name(1703) = 'm_Parallel_chgq_onto_fftcd_3D:alltoall_1'
  name(1704) = 'm_Parallel_fftcd_onto_chgq_3D:isend/irecv_1'
  name(1705) = 'm_Parallel_fftcd_onto_chgq_3D:alltoall_1'

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- Finalization / SUBROUTINE
  name(1361) = 'm_PP_rd_PP_parameters_3D'
  name(1362) = 'rd_kgp_array'
  name(1363) = 'rd_kgp_array_p'
  name(1364) = 'bcast_nfcntn_bin'
  name(1365) = 'm_PP_wd_PP_parameters_3D'
  name(1366) = 'wd_kgp_array'
  name(1367) = 'wd_kgp_array_p'
  name(1368) = 'm_NLP_rd_snl_3D'
  name(1369) = 'm_NLP_wd_snl_3D'
  name(1370) = 'm_ESIO_rd_EigenValues_etc'
  name(1371) = 'm_ESIO_wd_EigenValues_etc_3D'
  name(1372) = 'm_ESIO_rd_WFs'
  name(1373) = 'm_ESIO_wd_WFs_3D'
  name(1374) = 'm_CD_rd_chgq_3D'
  name(1375) = 'm_CD_wd_chgq_3D'
  name(1376) = 'm_ESIO_rd_Efermi'
  name(1377) = 'm_ESIO_wd_efermi'
  name(1378) = 'm_ESIO_wd_EigenValues'
  name(1379) = 'm_ESIO_wd_WFs_standardout_3D'
! -- Finalization / COMMUNICATION & DO     #TIMER_IODO TIMER_IOCOMM
  name(1380) = 'rd_kgp_array:READ_1'
  name(1381) = 'rd_kgp_array:bcast_1'
  name(1382) = 'rd_kgp_array:READ_2'
  name(1383) = 'rd_kgp_array:bcast_2'
  name(1384) = 'rd_kgp_array:DO_1'
  name(1385) = 'rd_kgp_array_p:READ_1'
  name(1386) = 'rd_kgp_array_p:DO_1'
  name(1387) = 'bcast_nfcntn_bin:bcast'
  name(1388) = 'wd_kgp_array:allreduce_1'
  name(1389) = 'wd_kgp_array:WRITE_1'
  name(1390) = 'wd_kgp_array:DO_1'
  name(1391) = 'wd_kgp_array:allreduce_2'
  name(1392) = 'wd_kgp_array:WRITE_2'
  name(1393) = 'wd_kgp_array_p:DO_1'
  name(1394) = 'wd_kgp_array_p:WRITE_1'
  name(1395) = 'm_NLP_rd_snl_3D:DO_1'
  name(1396) = 'm_NLP_rd_snl_3D:READ_1'
  name(1397) = 'm_NLP_rd_snl_3D:bcast_1'
  name(1398) = 'm_NLP_rd_snl_3D:DO_2'
  name(1399) = 'm_NLP_wd_snl_3D:WRITE_1'
  name(1400) = 'm_NLP_wd_snl_3D:DO_1'
  name(1401) = 'm_NLP_wd_snl_3D:allreduce_1'
  name(1402) = 'm_NLP_wd_snl_3D:DO_2'
  name(1403) = 'm_NLP_wd_snl_3D:allreduce_2'
  name(1404) = 'm_NLP_wd_snl_3D:WRITE_2'
  name(1405) = 'm_ESIO_rd_EigenValues_etc:READ_1'
  name(1406) = 'm_ESIO_rd_EigenValues_etc:DO_1'
  name(1407) = 'm_ESIO_rd_EigenValues_etc:READ_2'
  name(1408) = 'm_ESIO_rd_EigenValues_etc:DO_2'
  name(1409) = 'm_ESIO_rd_EigenValues_etc:READ_3'
  name(1410) = 'm_ESIO_rd_EigenValues_etc:bcast_1'
  name(1411) = 'm_ESIO_rd_EigenValues_etc:DO_3'
  name(1412) = 'm_ESIO_rd_EigenValues_etc:READ_4'
  name(1413) = 'm_ESIO_rd_EigenValues_etc:bcast_2'
  name(1414) = 'm_ESIO_rd_EigenValues_etc:DO_4'
  name(1415) = 'm_ESIO_wd_EigenValues_etc:DO_1'
  name(1416) = 'm_ESIO_wd_EigenValues_etc:WRITE_1'
  name(1417) = 'm_ESIO_wd_EigenValues_etc:DO_2'
  name(1418) = 'm_ESIO_wd_EigenValues_etc:WRITE_2'
  name(1419) = 'm_ESIO_wd_EigenValues_etc:DO_3'
  name(1420) = 'm_ESIO_wd_EigenValues_etc:WRITE_3'
  name(1421) = 'm_ESIO_wd_EigenValues_etc:DO_4'
  name(1422) = 'm_ESIO_wd_EigenValues_etc:WRITE_4'
  name(1423) = 'm_ESIO_wd_EigenValues_etc:DO_5'
  name(1424) = 'm_ESIO_wd_EigenValues_etc:allreduce_1'
  name(1425) = 'm_ESIO_wd_EigenValues_etc:WRITE_5'
  name(1426) = 'm_ESIO_wd_EigenValues_etc:DO_6'
  name(1427) = 'm_ESIO_wd_EigenValues_etc:allreduce_2'
  name(1428) = 'm_ESIO_wd_EigenValues_etc:WRITE_6'
  name(1429) = 'm_ESIO_wd_EigenValues_etc:DO_7'
  name(1430) = 'm_ESIO_wd_EigenValues_etc:allreduce_3'
  name(1431) = 'm_ESIO_wd_EigenValues_etc:WRITE_7'
  name(1432) = 'm_ESIO_wd_EigenValues_etc:DO_8'
  name(1433) = 'm_ESIO_wd_EigenValues_etc:allreduce_4'
  name(1434) = 'm_ESIO_wd_EigenValues_etc:WRITE_8'
  name(1435) = 'm_ESIO_rd_WFs:DO_1'
  name(1436) = 'm_ESIO_rd_WFs:READ_1'
  name(1437) = 'm_ESIO_rd_WFs:DO_2'
  name(1438) = 'm_ESIO_rd_WFs:READ_2'
  name(1439) = 'm_ESIO_rd_WFs:bcast'
  name(1440) = 'm_ESIO_wd_WFs:DO_1'
  name(1441) = 'm_ESIO_wd_WFs:WRITE_1'
  name(1442) = 'm_ESIO_wd_WFs:DO_2'
  name(1443) = 'm_ESIO_wd_WFs:allreduce'
  name(1444) = 'm_ESIO_wd_WFs:WRITE_2'
  name(1445) = 'm_CD_rd_chgq_3D:READ_1'
  name(1446) = 'm_CD_rd_chgq_3D:DO_1'
  name(1447) = 'm_CD_rd_chgq_3D:READ_2'
  name(1448) = 'm_CD_rd_chgq_3D:READ_3'
  name(1449) = 'm_CD_rd_chgq_3D:bcast'
  name(1450) = 'm_CD_rd_chgq_3D:DO_2'
  name(1451) = 'm_CD_rd_chgq_3D:READ_4'
  name(1452) = 'm_CD_wd_chgq_3D:DO_1'
  name(1453) = 'm_CD_wd_chgq_3D:WRITE_1'
  name(1454) = 'm_CD_wd_chgq_3D:WRITE_2'
  name(1455) = 'm_CD_wd_chgq_3D:allreduce'
  name(1456) = 'm_CD_wd_chgq_3D:WRITE_3'
  name(1457) = 'm_CD_wd_chgq_3D:WRITE_4'
  name(1458) = 'm_ESIO_rd_Efermi:READ_1'
  name(1459) = 'm_ESIO_rd_Efermi:bcast_1'
  name(1460) = 'm_ESIO_wd_Efermi:WRITE_1'
  name(1461) = 'm_ESIO_wd_EigenValues_put_kpart:DO'
  name(1462) = 'm_ESIO_wd_EigenValues_put_kpart:allreduce'
  name(1463) = 'm_ESIO_wd_EigenValues:WRITE_1'
!!$  name(1464) = 'm_ESIO_wd_EigenValues_3D:DO_2'
!!$  name(1465) = 'm_ESIO_wd_EigenValues_3D:allreduce_2'
!!$  name(1466) = 'm_ESIO_wd_EigenValues_3D:WRITE_2'
  name(1467) = 'm_ESIO_wd_WFs_standardout_3D:DO_1'
  name(1468) = 'm_ESIO_wd_WFs_standardout_3D:allreduce_1'
  name(1469) = 'm_ESIO_wd_WFs_standardout_3D:WRITE_1'

  name(1490) = 'FORCE                                   '

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_1 / SUBROUTINE / ID= 101 -> 110
  name(101) =  'm_ES_Vlocal_in_Rspace_3D                '
  name(102) =  'cnt_vlhxc_to_fft_box_3D                 '
  name(103) =  'mp_vlhxc_l_onto_afft_3D                 '
  name(104) =  'm_FFT_WF_3D                             '
  name(105) =  'm_FFT_Direct_3D                         '
  name(106) =  'm_FFT_Inverse_3D                        '
  name(107) =  'm_FFT_Vlocal_W_3D                       '
  name(108) =  'm_FFT_W_Vlocal_W_3D                     '
  name(109) =  'm_FFT_CD_Direct_3D                      '
  name(110) =  'm_FFT_CD_Inverse_3D                     '

! -- KUKAN_1 / COMMUNICATION & DGEMM & DO / ID= 111 -> 189
  name(111) =  'cnt_vlhxc_to_fft_box_3D:isend/irecv_1   '
  name(112) =  'cnt_vlhxc_to_fft_box_3D:DO_1            '
  name(113) =  'cnt_vlhxc_to_fft_box_3D:isend/irecv_2   '
  name(114) =  'cnt_vlhxc_to_fft_box_3D:DO_2            '
  name(115) =  'mp_vlhxc_l_onto_afft_3D:DO_1            '
  name(116) =  'mp_vlhxc_l_onto_afft_3D:isend/irecv_1   '
  name(117) =  'mp_vlhxc_l_onto_afft_3D:DO_2            '
  name(118) =  'm_FFT_Direct_3D:Initial                 '
  name(119) =  'm_FFT_Direct_3D:Initial_FFTW            '
  name(120) =  'm_FFT_Direct_3D:Allocate                '
  name(121) =  'm_FFT_Direct_3D:DO_4                    '
  name(122) =  'm_FFT_Direct_3D:DO_5                    '
  name(123) =  'm_FFT_Direct_3D:alltoall                '
  name(124) =  'm_FFT_Direct_3D:DO_6                    '
  name(125) =  'm_FFT_Direct_3D:DO_7                    '
  name(126) =  'm_FFT_Direct_3D:DO_8                    '
  name(127) =  'm_FFT_Direct_3D:alltoall                '
  name(128) =  'm_FFT_Direct_3D:DO_9                    '
  name(129) =  'm_FFT_Direct_3D:DO_10                   '
  name(130) =  'm_FFT_Direct_3D:DO_11                   '
  name(131) =  'm_FFT_Direct_3D:DO_12                   '
  name(132) =  'm_FFT_Direct_3D:allgatherv              '
  name(133) =  'm_FFT_Direct_3D:DO_13                   '
  name(134) =  'm_FFT_Inverse_3D:Initial                '
  name(135) =  'm_FFT_Inverse_3D:Initial_FFTW           '
  name(136) =  'm_FFT_Inverse_3D:DO_3                   '
  name(137) =  'm_FFT_Inverse_3D:alltoall               '
  name(138) =  'm_FFT_Inverse_3D:DO_4                   '
  name(139) =  'm_FFT_Inverse_3D:DO_5                   '
  name(140) =  'm_FFT_Inverse_3D:DO_6                   '
  name(141) =  'm_FFT_Inverse_3D:DO_7                   '
  name(142) =  'm_FFT_Inverse_3D:alltoall               '
  name(143) =  'm_FFT_Inverse_3D:DO_7                   '
  name(144) =  'm_FFT_Inverse_3D:DO_8                   '
  name(145) =  'm_FFT_Inverse_3D:DO_9                   '
  name(146) =  'm_FFT_Inverse_3D:DO_10                  '
  name(147) =  'm_FFT_Inverse_3D:DO_11                  '
  name(148) =  'm_FFT_Inverse_3D:DO_12                  '
  name(149) =  'm_FFT_Inverse_3D:allgatherv             '
  name(150) =  'm_FFT_Inverse_3D:DO_13                  '
  name(151) =  'm_FFT_Vlocal_W_3D:DO_1                  '
  name(152) =  'm_FFT_W_Vlocal_W_3D:DO_1                '
  name(153) =  'm_FFT_W_Vlocal_W_3D:DO_2                '
  name(154) =  'm_FFT_W_Vlocal_W_3D:DO_3                '
  name(155) =  'm_FFT_W_Vlocal_W_3D:DO_4                '
  name(156) =  'm_FFT_W_Vlocal_W_3D:DO_5                '
  name(157) =  'm_FFT_CD_Direct_3D:Initial              '
  name(158) =  'm_FFT_CD_Direct_3D:Allocate             '
  name(159) =  'm_FFT_CD_Direct_3D:DO_3                 '
  name(160) =  'm_FFT_CD_Direct_3D:DO_4                 '
  name(161) =  'm_FFT_CD_Direct_3D:DO_5                 '
  name(162) =  'm_FFT_CD_Direct_3D:alltoall             '
  name(163) =  'm_FFT_CD_Direct_3D:DO_6                 '
  name(164) =  'm_FFT_CD_Direct_3D:DO_7                 '
  name(165) =  'm_FFT_CD_Direct_3D:DO_8                 '
  name(166) =  'm_FFT_CD_Direct_3D:alltoall             '
  name(167) =  'm_FFT_CD_Direct_3D:DO_9                 '
  name(168) =  'm_FFT_CD_Direct_3D:DO_10                '
  name(169) =  'm_FFT_CD_Direct_3D:DO_11                '
  name(170) =  'm_FFT_CD_Direct_3D:DO_12                '
  name(171) =  'm_FFT_CD_Direct_3D:allgatherv           '
  name(172) =  'm_FFT_CD_Direct_3D:DO_13                '
  name(173) =  'm_FFT_CD_Inverse_3D:Initial             '
  name(174) =  'm_FFT_CD_Inverse_3D:Allocate            '
  name(175) =  'm_FFT_CD_Inverse_3D:DO_3                '
  name(176) =  'm_FFT_CD_Inverse_3D:alltoall            '
  name(177) =  'm_FFT_CD_Inverse_3D:DO_4                '
  name(178) =  'm_FFT_CD_Inverse_3D:DO_5                '
  name(179) =  'm_FFT_CD_Inverse_3D:DO_6                '
  name(180) =  'm_FFT_CD_Inverse_3D:DO_7                '
  name(181) =  'm_FFT_CD_Inverse_3D:alltoall            '
  name(182) =  'm_FFT_CD_Inverse_3D:DO_8                '
  name(183) =  'm_FFT_CD_Inverse_3D:DO_9                '
  name(184) =  'm_FFT_CD_Inverse_3D:DO_10               '
  name(185) =  'm_FFT_CD_Inverse_3D:DO_11               '
  name(186) =  'm_FFT_CD_Inverse_3D:DO_12               '
  name(187) =  'm_FFT_CD_Inverse_3D:DO_13               '
  name(188) =  'm_FFT_CD_Inverse_3D:allgatherv          '
  name(189) =  'm_FFT_CD_Inverse_3D:DO_14               '
  name(266) =  'cnt_vlhxc_to_fft_box_3D:allgather_1     '
  name(267) =  'cnt_vlhxc_to_fft_box_3D:alltoall_1      '
  name(268) =  'mp_vlhxc_l_onto_afft_3D:alltoallv_1     '
! -- KUKAN_1 / FFT / ID= 190         
  name(190)=   'kukan_1:FFT_INVERSE                     '
! -- KUKAN_1 / DO / ID= 251 -> 189
  name(251) =  'm_FFT_Direct_3D:DO_14                   '
  name(252) =  'm_FFT_Direct_3D:DO_15                   '
  name(253) =  'm_FFT_Direct_3D:DO_16                   '
  name(254) =  'm_FFT_Inverse_3D:DO_14                  '
  name(255) =  'm_FFT_Inverse_3D:DO_15                  '
  name(256) =  'm_FFT_Inverse_3D:DO_16                  '
  name(257) =  'm_FFT_CD_Direct_3D:DO_15                '
  name(258) =  'm_FFT_CD_Direct_3D:DO_16                '
  name(259) =  'm_FFT_CD_Direct_3D:DO_17                '
  name(260) =  'm_FFT_CD_Inverse_3D:DO_15               '
  name(261) =  'm_FFT_CD_Inverse_3D:DO_16               '
  name(262) =  'm_FFT_CD_Inverse_3D:DO_17               '
  name(263) =  'm_FFT_Inverse_3D:FFTW                   '
  name(264) =  'm_FFT_Inverse_3D:Allocate               '

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_2 / SUBROUTINE / ID= 201 -> 208
  name(201) =  'm_ES_Vnonlocal_W_3D                     '
  name(202) =  'pre_m_ES_Vnonlocal_W                    '
  name(203) =  'm_ES_gather_f_3d_to_2d                  '
  name(204) =  'calc_phase_blk                          '
  name(205) =  'Vnonlocal_W_part_with_blk_3D            '
  name(206) =  'add_vnlph_l_with_eko_blk_3D             '
  name(207) =  'Vnonlocal_W_part_without_blk_3D         '
  name(208) =  'add_vnlph_l_without_eko_blk_3D          '
! -- KUKAN_2 / COMMUNICATION & DGEMM & DO / ID= 209 -> 231
  name(209) =  'pre_m_ES_Vnonlocal_W:DO_1               '
  name(210) =  'm_ES_gather_f_3d_to_2d:DO_1             '
  name(211) =  'm_ES_gather_f_3d_to_2d:DO_2             '
  name(212) =  'm_ES_gather_f_3d_to_2d:allgatherv_1     '
  name(213) =  'calc_phase_blk:DO_1                     '
  name(214) =  'Vnonlocal_W_part_with_blk_3D:DO_1       '
  name(215) =  'Vnonlocal_W_part_with_blk_3D:DO_2       '
  name(216) =  'Vnonlocal_W_part_with_blk_3D:DO_3       '
  name(217) =  'add_vnlph_l_with_eko_blk_3D:DGEMM_1     '
  name(218) =  'add_vnlph_l_with_eko_blk_3D:DGEMM_2     '
  name(219) =  'add_vnlph_l_with_eko_blk_3D:DGEMM_3     '
  name(220) =  'add_vnlph_l_with_eko_blk_3D:DGEMM_4     '
  name(221) =  'add_vnlph_l_with_eko_blk_3D:DGEMM_5     '
  name(222) =  'add_vnlph_l_with_eko_blk_3D:DGEMM_6     '
  name(223) =  'add_vnlph_l_with_eko_blk_3D:DO_1        '
  name(224) =  'add_vnlph_l_with_eko_blk_3D:DO_2        '
  name(225) =  'add_vnlph_l_with_eko_blk_3D:DO_3        '
  name(226) =  'Vnonlocal_W_part_without_blk_3D:DO_1    '
  name(227) =  'Vnonlocal_W_part_without_blk_3D:DO_2    '
  name(228) =  'Vnonlocal_W_part_without_blk_3D:DO_3    '
  name(229) =  'add_vnlph_l_without_eko_blk_3D:DGEMM_1  '
  name(230) =  'add_vnlph_l_without_eko_blk_3D:DGEMM_2  '
  name(231) =  'add_vnlph_l_without_eko_blk_3D:DGEMM_3  '

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_3 / SUBROUTINE / ID= 301 -> 309
  name(301) =  'evolve_WFs_in_MSD_direction_3D          '
  name(302) =  'm_ES_decide_precon_factor_3D            '
  name(303) =  'kinetic_energy_3D                       '
  name(304) =  'm_ES_WF_in_Rspace_3D                    '
  name(305) =  'Vnonlocal_Diagonal_part_3D              '
  name(306) =  'Vnonlocal_D_norm_conserve_case          '
  name(307) =  'Vnonlocal_D_vanderbilt_case             '
  name(308) =  'map_fft_to_WF_3D                        '
  name(309) =  'modified_steepest_descent_3D            '
! -- KUKAN_3 / COMMUNICATION & DGEMM & DO / ID= 310 -> 326
  name(310) =  'm_ES_decide_precon_factor_3D:DO_1       '
  name(311) =  'kinetic_energy_3D:DO_1                  '
  name(312) =  'kinetic_energy_3D:allreduce_1           '
  name(313) =  'm_ES_WF_in_Rspace_3D:DO_1               '
  name(314) =  'm_ES_WF_in_Rspace_3D:isend/irecv_1      '
  name(315) =  'm_ES_WF_in_Rspace_3D:DO_2               '
  name(316) =  'Vnonlocal_Diagonal_part_3D:DO_1         '
  name(317) =  'Vnonlocal_D_norm_conserve_case:DO_1     '
  name(318) =  'Vnonlocal_D_norm_conserve_case:DO_2     '
  name(319) =  'Vnonlocal_D_vanderbilt_case:DO_1        '
  name(320) =  'Vnonlocal_D_vanderbilt_case:allreduce_1 '
  name(321) =  'Vnonlocal_D_vanderbilt_case:DO_2        '
  name(322) =  'Vnonlocal_D_vanderbilt_case:DO_3        '
  name(323) =  'map_fft_to_WF_3D:isend/irecv_1          '
  name(324) =  'map_fft_to_WF_3D:DO_1                   '
  name(325) =  'map_fft_to_WF_3D:DO_2                   '
  name(326) =  'modified_steepest_descent_3D:DO_1       '
  name(329) =  'm_ES_WF_in_Rspace_3D:alltoallv_1        '
  name(330) =  'map_fft_to_WF_3D:alltoallv_1            '
! -- KUKAN_8 / FFT / ID= 327 -> 328
  name(327)=  'kukan_3:FFT_INVERSE                     '
  name(328)=  'kukan_3:FFT_DIRECT                      '

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_4 / SUBROUTINE / ID= 401 -> 410
  name(401) = 'm_ES_betar_dot_WFs_4_each_k_3D'
  name(402) = 'cpzaj_l_to_psi_ri'
  name(403) = 'set_msize'
  name(404) = 'pre_lmta_k_blk'
  name(405) = 'post_lmta_k_blk'
  name(406) = 'm_ES_betar_dot_WFs_4_lmta_k_blk_3D'
  name(407) = 'G_dot_R_mult_snl_blk'
  name(408) = 'betar_dot_WFs_core_blk'
  name(409) = 'betar_dot_WFs_core2_blk'
  name(410) = 'G_dot_R_map_blk_3D'
! -- KUKAN_4 / DGEMM / ID= 411 -> 418 
  name(411) = 'betar_dot_WFs_core_blk:DGEMM_1'
  name(412) = 'betar_dot_WFs_core_blk:DGEMM_2'
  name(413) = 'betar_dot_WFs_core_blk:DGEMM_3'
  name(414) = 'betar_dot_WFs_core_blk:DGEMM_4'
  name(415) = 'betar_dot_WFs_core2_blk:DGEMM_1'
  name(416) = 'betar_dot_WFs_core2_blk:DGEMM_2'
  name(417) = 'betar_dot_WFs_core2_blk:DGEMM_3'
  name(418) = 'betar_dot_WFs_core2_blk:DGEMM_4'
! -- KUKAN_4 / COMMUNICATION / ID= 419 -> 422
  name(419) = 'm_ES_betar_dot_WFs_4_each_k_3D:reduce_scatter'
  name(420) = 'm_ES_betar_dot_WFs_4_each_k_3D:DO_p'
  name(421) = 'm_ES_betar_dot_WFs_4_each_k_3D:allgatherv'
  name(422) = 'm_ES_betar_dot_WFs_4_each_k_3D:DO_unp'
! -- KUKAN_4 / DO / ID= 423 -> 426
  name(423) = 'cpzaj_l_to_psi_ri:DO_1'
  name(424) = 'post_lmta_k_blk:DO_1'
  name(425) = 'G_dot_R_mult_snl_blk:DO_1'
  name(426) = 'G_dot_R_mult_snl_blk:DO_2'

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_5 / SUBROUTINE / ID= 501 -> 514
  name(501) = 'm_ES_MGS_4_each_k'
  name(502) = 'm_ES_MGS_4_each_k_3D'
  name(503) = 'mgs_4_each_k_G_3D'
  name(504) = 'WSW_t'
  name(505) = 'cp_bpr2bprtw'
  name(506) = 'normalize_bp_and_psi_t'
  name(507) = 'W1SW2_t_r'
  name(508) = 'modify_bp_and_psi_t_r'
  name(509) = 'W1SW2_t_r_block'
  name(510) = 'modify_bp_and_psi_t_r_block'
  name(511) = 'm_ES_F_transpose_r_3D'
  name(512) = 'm_ES_F_transpose_back_r_3D'
  name(513) = 'm_ES_W_transpose_r_3D'
  name(514) = 'm_ES_W_transpose_back_r_3D'
! -- KUKAN_5 / DGEMM / ID= 515 -> 526
  name(515) = 'W1SW2_t_r_block:DGEMM_1'
  name(516) = 'W1SW2_t_r_block:DGEMM_2'
  name(517) = 'W1SW2_t_r_block:DGEMM_3'
  name(518) = 'W1SW2_t_r_block:DGEMM_4'
  name(519) = 'W1SW2_t_r_block:DGEMM_5'
  name(520) = 'W1SW2_t_r_block:DGEMM_6'
  name(521) = 'modify_bp_and_psi_t_r_block:DGEMM_1'
  name(522) = 'modify_bp_and_psi_t_r_block:DGEMM_2'
  name(523) = 'modify_bp_and_psi_t_r_block:DGEMM_3'
  name(524) = 'modify_bp_and_psi_t_r_block:DGEMM_4'
  name(525) = 'modify_bp_and_psi_t_r_block:DGEMM_5'
  name(526) = 'modify_bp_and_psi_t_r_block:DGEMM_6'
! -- KUKAN_5 / COMMUNICATION / ID= 527 -> 539,582 -> 590
  name(527) = 'mgs_4_each_k_G_3D:DO_p'
  name(528) = 'mgs_4_each_k_G_3D:DO_p'
  name(529) = 'mgs_4_each_k_G_3D:bcast_1'
  name(530) = 'mgs_4_each_k_G_3D:DO_unp'
  name(531) = 'mgs_4_each_k_G_3D:bcast_2'
  name(532) = 'mgs_4_each_k_G_3D:DO_unp_1'
  name(533) = 'mgs_4_each_k_G_3D:DO_unp_2'
  name(534) = 'mgs_4_each_k_G_3D:DO_p'
  name(535) = 'mgs_4_each_k_G_3D:allreduce'
  name(536) = 'WSW_t:allreduce'
  name(537) = 'W1SW2_t_r:DO_p'
  name(538) = 'W1SW2_t_r:allreduce'
  name(539) = 'W1SW2_t_r:DO_unp'
  name(582) = 'm_ES_F_transpose_r_3D:isend/irecv_1'
  name(583) = 'm_ES_F_transpose_r_3D:alltoall_1'
! -- KUKAN_5 / DO / ID= 540 -> 581
  name(540) = 'mgs_4_each_k_G_3D:DO_1'
  name(541) = 'mgs_4_each_k_G_3D:DO_2'
  name(542) = 'mgs_4_each_k_G_3D:DO_3'
  name(543) = 'mgs_4_each_k_G_3D:DO_4'
  name(544) = 'mgs_4_each_k_G_3D:DO_5'
  name(545) = 'mgs_4_each_k_G_3D:DO_6'
  name(546) = 'mgs_4_each_k_G_3D:DO_7'
  name(547) = 'mgs_4_each_k_G_3D:DO_8'
  name(548) = 'WSW_t:DO_1'
  name(549) = 'WSW_t:DO_2'
  name(550) = 'WSW_t:DO_3'
  name(551) = 'WSW_t:DO_4'
  name(552) = 'cp_bpr2bprtw:DO_1'
  name(553) = 'cp_bpr2bprtw:DO_2'
  name(554) = 'normalize_bp_and_psi_t:DO_1'
  name(555) = 'normalize_bp_and_psi_t:DO_2'
  name(556) = 'W1SW2_t_r:DO_1'
  name(557) = 'W1SW2_t_r:DO_2'
  name(558) = 'W1SW2_t_r:DO_3'
  name(559) = 'W1SW2_t_r:DO_4'
  name(560) = 'W1SW2_t_r:DO_5'
  name(561) = 'W1SW2_t_r:DO_6'
  name(562) = 'W1SW2_t_r:DO_7'
  name(563) = 'W1SW2_t_r:DO_8'
  name(564) = 'modify_bp_and_psi_t_r:DO_1'
  name(565) = 'modify_bp_and_psi_t_r:DO_2'
  name(566) = 'modify_bp_and_psi_t_r:DO_3'
  name(567) = 'modify_bp_and_psi_t_r:DO_4'
  name(568) = 'modify_bp_and_psi_t_r:DO_5'
  name(569) = 'modify_bp_and_psi_t_r:DO_6'
  name(570) = 'W1SW2_t_r_block:DO_1'
  name(571) = 'W1SW2_t_r_block:DO_2'
  name(572) = 'W1SW2_t_r_block:DO_3'
  name(573) = 'm_ES_F_transpose_r_3D:DO_1'
  name(574) = 'm_ES_F_transpose_r_3D:DO_2'
  name(575) = 'm_ES_F_transpose_back_r_3D:DO_1'
  name(576) = 'm_ES_F_transpose_back_r_3D:DO_2'
  name(577) = 'm_ES_W_transpose_r_3D:DO_1'
  name(578) = 'm_ES_W_transpose_r_3D:DO_2'
  name(579) = 'm_ES_W_transpose_r_3D:DO_3'
  name(580) = 'm_ES_W_transpose_back_r_3D:DO_1'
  name(581) = 'm_ES_W_transpose_back_r_3D:DO_2'
  name(585) = 'gram_schmidt_recursive'
  name(586) = 'gram_schmidt_angle'
  name(587) = 'gram_schmidt_block'
  name(588) = 'gram_schmidt_block:DO_1'
  name(589) = 'gram_schmidt_block:DO_2'
  name(590) = 'gram_schmidt_block:DO_3'
  name(591) = 'gram_schmidt_block:allreduce'
  name(592) = 'gram_schmidt_block:DO_4'
! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_6 / SUBROUTINE / ID= 601 -> 607
  name(601) =  'm_ES_eigen_values_for_each_k_3D         '
  name(602) =  'W_T_W                                   '
  name(603) =  'W_Vnonlocal_W                           '
  name(604) =  'm_ES_sort_eigen_values_3D               '
  name(605) =  'heap_sorting                            '
  name(606) =  'cp_eigen_values_for_af                  '
  name(607) =  'expand_neordr_and_nrvf_ordr             '
! -- KUKAN_6 / COMMUNICATION & DGEMM & DO / ID= 608 -> 635
  name(608) =  'm_ES_eigen_values_for_each_k_3D:alreduce'
  name(609) =  'W_T_W:DO_1                              '
  name(610) =  'W_Vnonlocal_W:DO_1                      '
  name(611) =  'W_Vnonlocal_W:DO_2                      '
  name(612) =  'm_ES_sort_eigen_values_3D:DO_1          '
  name(613) =  'm_ES_sort_eigen_values_3D:DO_2          '
  name(614) =  'm_ES_sort_eigen_values_3D:allgather_1   '
  name(615) =  'm_ES_sort_eigen_values_3D:DO_3          '
  name(616) =  'm_ES_sort_eigen_values_3D:DO_4          '
  name(617) =  'm_ES_sort_eigen_values_3D:DO_5          '
  name(618) =  'm_ES_sort_eigen_values_3D:DO_6          '
  name(619) =  'm_ES_sort_eigen_values_3D:DO_7          '
  name(620) =  'm_ES_sort_eigen_values_3D:DO_8          '
  name(621) =  'm_ES_sort_eigen_values_3D:DO_9          '
  name(622) =  'm_ES_sort_eigen_values_3D:DO_10         '
  name(623) =  'm_ES_sort_eigen_values_3D:DO_11         '
  name(624) =  'm_ES_sort_eigen_values_3D:DO_12         '
  name(625) =  'm_ES_sort_eigen_values_3D:DO_13         '
  name(626) =  'm_ES_sort_eigen_values_3D:DO_14         '
  name(627) =  'm_ES_sort_eigen_values_3D:DO_15         '
  name(628) =  'm_ES_sort_eigen_values_3D:DO_16         '
  name(629) =  'm_ES_sort_eigen_values_3D:DO_17         '
  name(630) =  'm_ES_sort_eigen_values_3D:DO_18         '
  name(631) =  'm_ES_sort_eigen_values_3D:DO_19         '
  name(632) =  'heap_sorting:DO_1                       '
  name(633) =  'heap_sorting:DO_2                       '
  name(634) =  'cp_eigen_values_for_af:DO_1             '
  name(635) =  'expand_neordr_and_nrvf_ordr:DO_1        '
! -- KUKAN_6 / FFT / ID= 608 -> 635
  name(636) =  'kukan_6:FFT_INVERSE                     '
  name(637) =  'kukan_6:FFT_DIRECT                      '

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_7 / SUBROUTINE / ID= 701 -> 799
  name(701) =  'ChargeDensity_Construction_3D           '
  name(702) =  'FermiEnergyLevel_3D                     '
  name(703) =  'm_ESoc_fermi_parabolic_3D               '
  name(704) =  'get_occup_l_and_tot                     '
  name(705) =  'width2                                  '
  name(706) =  'get_entropic_term                       '
  name(707) =  'get_entropy                             '
  name(708) =  'get_total_spin0                         '
  name(709) =  'm_ESoc_fermi_tetrahedron_3D             '
  name(710) =  'fermi1                                  '
  name(711) =  'nsdos2                                  '
  name(712) =  'fermi2                                  '
  name(713) =  'nstt3i                                  '
  name(714) =  'nstt2i                                  '
  name(715) =  'm_ESoc_fermi_ColdSmearing_3D            '
  name(716) =  'm_CD_softpart_3D                        '
  name(717) =  'add_occupied_densities                  '
  name(718) =  'map_fft_to_chgq_3D                      '
  name(719) =  'substitute_CD_for_chgq                  '
  name(720) =  'm_CD_hardpart_3D                        '
  name(721) =  'summation_of_ff_3D                      '
  name(722) =  'add_hardpart_to_chgq_l_3D               '
  name(723) =  'm_PP_set_index_arrays1                  '
  name(724) =  'm_PP_set_index_arrays2                  '
  name(725) =  'substitute_qitgred                      '
  name(726) =  'substitute_ylmred                       '
  name(727) =  'calc_phase_div                          '
  name(728) =  'sum_hsr_dot_gauntc0                     '
  name(729) =  'add_hardpart_to_chgq_l_div0             '
  name(730) =  'add_hardpart_to_chgq_l_div1             '
  name(731) =  'charge_average_3D                       '
  name(732) =  'cp_chgq_by_ngpt                         '
  name(733) =  'm_CD_conversion_check_3D                '
  name(734) =  'm_CD_hardpart_hsr_3D                    '
  name(735) =  'Renewal_of_OccMat_3D                    '
  name(736) =  'm_CD_den_mat_3D                         '
  name(737) =  'm_OP_occ_mat_ylm                        '
  name(738) =  'm_OP_occ_mat_ao_kt                      '
  name(739) =  'm_TE_total_energy                       '
  name(740) =  'get_band_energy_3D                      '
  name(741) =  'get_xc_and_HE_of_old_CD_3D              '
  name(742) =  'get_local_potential_energy_3D           '
  name(743) =  'get_hubbard_energy_3D                   '
  name(744) =  'get_nonlocal_potential_energy_3D        '
  name(745) =  'get_hartree_energy_3D                   '
  name(746) =  'get_dipole_energy_3D                    '
  name(747) =  'get_kinetic_energy                      '
  name(748) =  'get_entropic_term                       '
  name(749) =  'sumup_all_energies                      '
  name(750) =  'm_XC_cal_potential_3D                   '
  name(751) =  'xc_allocate_3D                          '
  name(752) =  'set_f2or1_3D                            '
  name(753) =  'map_charge_onto_a_fftcd_box             '
  name(754) =  'check_of_negative_CD_3D                 '
  name(755) =  'cp_afft_to_chgrhr_3D                    '
  name(756) =  'check_lmn_even_3D                       '
  name(757) =  'ggaxcp_diff_3D                          '
  name(758) =  'ggaxcp0_3D                              '
  name(759) =  'abs_grad_rho_up_down_total_3D           '
  name(760) =  'g_xyz_chden_l_3D                        '
  name(761) =  'boundary_zero_into_afft_3D              '
  name(762) =  'cp_afft_to_cgrad_rho_3D                 '
  name(763) =  'add_sq_afft_to_grad_rho_3D              '
  name(764) =  'ex_ggapw91_3D                           '
  name(765) =  'cr_ggapw91_3D                           '
  name(766) =  'ex_ggapbe_3D                            '
  name(767) =  'cr_ggapbe_3D                            '
  name(768) =  'xclda_3D                                '
  name(769) =  'ggabek_3D                               '
  name(770) =  'ggaprd_3D                               '
  name(771) =  'ggaxcp_3D                               '
  name(772) =  'dFxc_over_ddgradrho_3D                  '
  name(773) =  'dFxc_dgradrho_dot_gradrho2_3D           '
  name(774) =  'G_xyz_afft_3D                           '
  name(775) =  'add_negative_afft_to_grad_rho_3D        '
  name(776) =  'finally_gga_xc_pot_3D                   '
  name(777) =  'xcpotf_3D                               '
  name(778) =  'xcpotf_wigner_3D                        '
  name(779) =  'xcpotf_pzold_3D                         '
  name(780) =  'xcpotf_xalfa_3D                         '
  name(781) =  'xcpotf_pz_3D                            '
  name(782) =  'xcpotf_vwn_3D                          '
  name(783) =  'xcpotf_mjw_bh_gl_3D                     '
  name(784) =  'cpafft_3D                               '
  name(785) =  'map_fftcd_onto_charge                   '
  name(786) =  'rhos_diff                               '
  name(787) =  'rhopc_diff_3D                           '
  name(788) =  'rhoh_diff_3D                            '
  name(789) =  'even_case_3D                            '
  name(790) =  'odd_case_3D                             '
  name(791) =  'real_case_3D                            '
  name(792) =  'complex_case_3D                         '
  name(793) =  'dgrhodh1_3D                             '
  name(794) =  'stress_correlation_part_3D              '
  name(795) =  'sum_s_gga12                             '
  name(796) =  'dgrhodh2_3D                             '
  name(797) =  'stress_exchange_part_3D                 '
  name(798) =  'map_drhodh1_3D                          '
  name(799) =  'map_drhodh2_3D                          '
! -- KUKAN_7 / COMMUNICATION & DGEMM & DO / ID= 800 -> 900, 1001 -> 1049
  name(800) =  'm_ESoc_fermi_parabolic_3D:DO_1          '
  name(801) =  'm_ESoc_fermi_parabolic_3D:allreduce_1   '
  name(802) =  'm_ESoc_fermi_parabolic_3D:allgather_1   '
  name(803) =  'm_ESoc_fermi_parabolic_3D:DO_2          '
  name(804) =  'get_occup_l_and_tot:DO_1                '
  name(805) =  'get_entropic_term:DO_1                  '
  name(806) =  'm_ESoc_fermi_tetrahedron_3D:DO_1        '
  name(807) =  'm_ESoc_fermi_tetrahedron_3D:allreduce_1 '
  name(808) =  'm_ESoc_fermi_tetrahedron_3D:DO_2        '
  name(809) =  'm_ESoc_fermi_tetrahedron_3D:DO_3        '
  name(810) =  'm_ESoc_fermi_tetrahedron_3D:DO_4        '
  name(811) =  'fermi1:DO_1                             '
  name(812) =  'fermi1:DO_2                             '
  name(813) =  'fermi1:DO_3                             '
  name(814) =  'nsdos2:DO_1                             '
  name(815) =  'fermi2:DO_1                             '
  name(816) =  'nstt3i:DO_1                             '
  name(817) =  'nstt3i:DO_2                             '
  name(818) =  'nstt3i:DO_3                             '
  name(819) =  'nstt2i:DO_1                             '
  name(820) =  'nstt2i:DO_20                            '
  name(821) =  'm_ESoc_fermi_ColdSmearing_3D:DO_1       '
  name(822) =  'm_ESoc_fermi_ColdSmearing_3D:allreduce_1'
  name(823) =  'm_ESoc_fermi_ColdSmearing_3D:DO_2       '
  name(824) =  'm_ESoc_fermi_ColdSmearing_3D:DO_3       '
  name(825) =  'm_CD_softpart_3D:allreduce_1            '
  name(826) =  'add_occupied_densities:DO_1             '
  name(827) =  'map_fft_to_chgq_3D:isend/irecv_1        '
  name(828) =  'map_fft_to_chgq_3D:DO_1                 '
  name(829) =  'map_fft_to_chgq_3D:DO_2                 '
  name(830) =  'substitute_CD_for_chgq:DO_1             '
  name(831) =  'summation_of_ff_3D:DO_1                 '
  name(832) =  'summation_of_ff_3D:allreduce_1          '
  name(833) =  'summation_of_ff_3D:allreduce_2          '
  name(834) =  'add_hardpart_to_chgq_l_3D:DO_1          '
  name(835) =  'add_hardpart_to_chgq_l_3D:allgather_1   '
  name(836) =  'add_hardpart_to_chgq_l_3D:DO_2          '
  name(837) =  'add_hardpart_to_chgq_l_3D:allreduce_1   '
  name(838) =  'm_PP_set_index_arrays1:DO_1             '
  name(839) =  'm_PP_set_index_arrays2:DO_1             '
  name(840) =  'substitute_qitgred:DO_1                 '
  name(841) =  'substitute_ylmred:DO_1                  '
  name(842) =  'substitute_ylmred:DO_2                  '
  name(843) =  'calc_phase_div:DO_1                     '
  name(844) =  'sum_hsr_dot_gauntc0:DO_1                '
  name(845) =  'sum_hsr_dot_gauntc0:DO_2                '
  name(846) =  'add_hardpart_to_chgq_l_div0:DO_1        '
  name(847) =  'add_hardpart_to_chgq_l_div1:DO_1        '
  name(848) =  'charge_average_3D:DO_1                  '
  name(849) =  'charge_average_3D:allgather_1           '
  name(850) =  'charge_average_3D:DO_2                  '
  name(851) =  'charge_average_3D:DO_3                  '
  name(852) =  'charge_average_3D:DO_4                  '
  name(853) =  'cp_chgq_by_ngpt:isend/irecv_1           '
  name(854) =  'cp_chgq_by_ngpt:DO_1                    '
  name(855) =  'cp_chgq_by_ngpt:DO_2                    '
  name(856) =  'cp_chgq_by_ngpt:DO_3                    '
  name(857) =  'm_CD_conversion_check_3D:DO_1           '
  name(858) =  'm_CD_conversion_check_3D:allreduce_1    '
  name(859) =  'm_CD_conversion_check_3D:DO_2           '
  name(860) =  'm_CD_conversion_check_3D:bcast_1        '
  name(861) =  'm_OP_occ_mat_ylm:DO_1                   '
  name(862) =  'm_OP_occ_mat_ao_kt:DO_1                 '
  name(863) =  'get_band_energy_3D:DO_1                 '
  name(864) =  'get_band_energy_3D:allreduce_1          '
  name(865) =  'get_xc_and_HE_of_old_CD_3D:DO_1         '
  name(866) =  'get_xc_and_HE_of_old_CD_3D:DO_2         '
  name(867) =  'get_xc_and_HE_of_old_CD_3D:allreduce_1  '
  name(868) =  'get_local_potential_energy_3D:DO_1      '
  name(869) =  'get_local_potential_energy_3D:allreduce '
  name(870) =  'get_nonlocal_potential_energy_3D:DO_1   '
  name(871) =  'get_nonlocal_potential_energy_3D:allredu'
  name(872) =  'get_hartree_energy_3D:DO_1              '
  name(873) =  'get_hartree_energy_3D:allreduce_1       '
  name(874) =  'get_dipole_energy_3D:DO_1               '
  name(875) =  'get_dipole_energy_3D:allreduce_1        '
  name(876) =  'xc_allocate_3D:DO_1                     '
  name(877) =  'set_f2or1_3D:DO_1                       '
  name(878) =  'set_f2or1_3D:DO_2                       '
  name(879) =  'map_charge_onto_a_fftcd_box:DO_1        '
  name(880) =  'map_charge_onto_a_fftcd_box:DO_2        '
  name(881) =  'map_charge_onto_a_fftcd_box:DO_3        '
  name(882) =  'map_charge_onto_a_fftcd_box:isend/irecv1'
  name(883) =  'map_charge_onto_a_fftcd_box:DO_4        '
  name(884) =  'check_of_negative_CD_3D:DO_1            '
  name(885) =  'check_of_negative_CD_3D:DO_2            '
  name(886) =  'check_of_negative_CD_3D:DO_3            '
  name(887) =  'check_of_negative_CD_3D:allreduce_1     '
  name(888) =  'cp_afft_to_chgrhr_3D:DO_1               '
  name(889) =  'check_lmn_even_3D:DO_1                  '
  name(890) =  'ggaxcp_diff_3D:allreduce_1              '
  name(891) =  'ggaxcp_diff_3D:allreduce_2              '
  name(892) =  'abs_grad_rho_up_down_total_3D:DO_1      '
  name(893) =  'abs_grad_rho_up_down_total_3D:DO_2      '
  name(894) =  'g_xyz_chden_l_3D:DO_1                   '
  name(895) =  'boundary_zero_into_afft_3D:DO_1         '
  name(896) =  'cp_afft_to_cgrad_rho_3D:DO_1            '
  name(897) =  'add_sq_afft_to_grad_rho_3D:DO_1         '
  name(898) =  'ex_ggapw91_3D:DO_1                      '
  name(899) =  'cr_ggapw91_3D:DO_1                      '
  name(900) =  'ex_ggapbe_3D:DO_1                       '
  name(1001)=  'cr_ggapbe_3D:DO_1                       '
  name(1002)=  'xclda_3D:DO_1                           '
  name(1003)=  'ggabek_3D:DO_1                          '
  name(1004)=  'ggaprd_3D:DO_1                          '
  name(1005)=  'ggaxcp_3D:allreduce_1                   '
  name(1006)=  'ggaxcp_3D:allreduce_2                   '
  name(1007)=  'dFxc_dgradrho_dot_gradrho2_3D:DO_1      '
  name(1008)=  'G_xyz_afft_3D:DO_1                      '
  name(1009)=  'add_negative_afft_to_grad_rho_3D:DO_1   '
  name(1010)=  'finally_gga_xc_pot_3D:DO_1              '
  name(1011)=  'xcpotf_3D:allreduce_1                   '
  name(1012)=  'xcpotf_3D:allreduce_2                   '
  name(1013)=  'xcpotf_wigner_3D:DO_1                   '
  name(1014)=  'xcpotf_wigner_3D:DO_2                   '
  name(1015)=  'xcpotf_pzold_3D:DO_1                    '
  name(1016)=  'xcpotf_xalfa_3D:DO_1                    '
  name(1017)=  'xcpotf_pz_3D:DO_1                       '
  name(1018)=  'xcpotf_vwn_3D:DO_1                     '
  name(1019)=  'xcpotf_mjw_bh_gl_3D:DO_1                '
  name(1020)=  'cpafft_3D:DO_1                          '
  name(1021)=  'map_fftcd_onto_charge:isend/irecv_1     '
  name(1022)=  'map_fftcd_onto_charge:DO_1              '
  name(1023)=  'map_fftcd_onto_charge:DO_2              '
  name(1024)=  'map_fftcd_onto_charge:DO_3              '
  name(1025)=  'rhos_diff:DO_1                          '
  name(1026)=  'rhopc_diff_3D:DO_1                      '
  name(1027)=  'even_case_3D:DO_1                       '
  name(1028)=  'odd_case_3D:DO_1                        '
  name(1029)=  'real_case_3D:DO_1                       '
  name(1030)=  'real_case_3D:DO_2                       '
  name(1031)=  'complex_case_3D:DO_1                    '
  name(1032)=  'dgrhodh1_3D:DO_1                        '
  name(1033)=  'stress_correlation_part_3D:DO_1         '
  name(1034)=  'sum_s_gga12:allreduce_1                 '
  name(1035)=  'sum_s_gga12:allreduce_2                 '
  name(1036)=  'sum_s_gga12:allreduce_3                 '
  name(1037)=  'sum_s_gga12:allreduce_4                 '
  name(1038)=  'sum_s_gga12:send/recv_1                 '
  name(1039)=  'sum_s_gga12:send/recv_2                 '
  name(1040)=  'dgrhodh2_3D:DO_1                        '
  name(1041)=  'dgrhodh2_3D:DO_2                        '
  name(1042)=  'stress_exchange_part_3D:DO_1            '
  name(1043)=  'stress_exchange_part_3D:DO_2            '
  name(1044)=  'map_drhodh1_3D:DO_1                     '
  name(1045)=  'map_drhodh1_3D:allreduce_1              '
  name(1046)=  'map_drhodh1_3D:allreduce_2              '
  name(1047)=  'map_drhodh2_3D:DO_1                     '
  name(1048)=  'map_drhodh2_3D:allreduce_1              '
  name(1049)=  'map_drhodh2_3D:allreduce_2              '
  name(693)=  'map_fft_to_chgq_3D:alltoallv_1           '
  name(694)=  'cp_chgq_by_ngpt:alltoall_1(List)         '
  name(695)=  'map_fftcd_onto_charge:alltoallv_1        '
  name(696)=  'map_charge_onto_a_fftcd_box:alltoallv_1  '
! -- KUKAN_7 / FFT / ID= 1050 -> 1051
  name(691)=  'kukan_7:FFT_INVERSE                     '
  name(692)=  'kukan_7:FFT_DIRECT                      '

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_8&9 / SUBROUTINE / ID= 901 -> 913
  name(901) =  'evolve_WFs_in_subspace_3D               '
  name(902) =  'set_col_partition_3D                    '
  name(903) =  'scalapack_setup_3D                      '
  name(904) =  'set_hmat_3D                             '
  name(905) =  'gather_zmat_all                         '
  name(906) =  'pdsyev_driver_3D                        '
  name(907) =  'pzheev_driver_3D                        '
  name(908) =  'dsyev_driver                            '
  name(909) =  'zheev_driver                            '
  name(910) =  'hobsvw_driver                           '
  name(911) =  'chobsd_driver                           '
  name(912) =  'subspace_rotation_real_3D               '
  name(913) =  'subspace_rotation_imag_3D               '
!fj add 20110819
  name(963) =  'set_hmat_3D_scl                         '
  name(964) =  'trans_scalapack                         '
  name(965) =  'trans_scalapack_r                       '
!fj add 20110819
!fj add 20110901
  name(988) =  'eig_send                                '
!fj add 20110901
! -- KUKAN_8&9 / COMMUNICATION & DGEMM & DO / ID= 914 -> 959
  name(914) =  'evolve_WFs_in_subspace_3D:allreduce_1   '
  name(915) =  'evolve_WFs_in_subspace_3D:isend/irecv_1 '
  name(916) =  'evolve_WFs_in_subspace_3D:DO_1          '
  name(917) =  'evolve_WFs_in_subspace_3D:DO_2          '
  name(918) =  'evolve_WFs_in_subspace_3D:DO_3          '
  name(919) =  'evolve_WFs_in_subspace_3D:DO_4          '
  name(920) =  'evolve_WFs_in_subspace_3D:DO_5          '
  name(921) =  'evolve_WFs_in_subspace_3D:DGEMM_1       '
  name(922) =  'evolve_WFs_in_subspace_3D:DGEMM_2       '
  name(923) =  'evolve_WFs_in_subspace_3D:DO_6          '
  name(924) =  'evolve_WFs_in_subspace_3D:DGEMM_3       '
  name(925) =  'evolve_WFs_in_subspace_3D:DO_7          '
  name(926) =  'evolve_WFs_in_subspace_3D:DO_8          '
  name(927) =  'evolve_WFs_in_subspace_3D:DO_9          '
  name(928) =  'evolve_WFs_in_subspace_3D:DO_10         '
  name(929) =  'evolve_WFs_in_subspace_3D:DO_11         '
  name(930) =  'evolve_WFs_in_subspace_3D:DO_12         '
  name(931) =  'evolve_WFs_in_subspace_3D:DO_13         '
  name(932) =  'evolve_WFs_in_subspace_3D:DO_14         '
  name(933) =  'evolve_WFs_in_subspace_3D:allreduce_2   '
  name(934) =  'evolve_WFs_in_subspace_3D:DO_15         '
  name(935) =  'evolve_WFs_in_subspace_3D:DO_16         '
  name(936) =  'evolve_WFs_in_subspace_3D:DO_17         '
  name(937) =  'evolve_WFs_in_subspace_3D:DO_18         '
  name(938) =  'evolve_WFs_in_subspace_3D:DO_19         '
  name(939) =  'evolve_WFs_in_subspace_3D:DO_20         '
  name(940) =  'set_col_partition_3D:DO_1               '
  name(941) =  'set_col_partition_3D:DO_2               '
  name(942) =  'make_usermap                            '
  name(943) =  'set_hmat_3D:DO_1                        '
  name(944) =  'set_hmat_3D:reduce_scatter_1            '
  name(945) =  'set_hmat_3D:DO_2                        '
  name(946) =  'set_hmat_3D:reduce_scatter_2            '
  name(947) =  'set_hmat_3D:DO_3                        '
  name(948) =  'gather_zmat_all:DO_1                    '
  name(949) =  'gather_zmat_all:allgather               '
  name(950) =  'gather_zmat_all:DO_2                    '
  name(951) =  'gather_zmat_all:DO_3                    '
  name(952) =  'gather_zmat_all:DO_4                    '
  name(953) =  'subspace_rotation_real_3D:DGEMM_1       '
  name(954) =  'subspace_rotation_real_3D:DO_1          '
  name(955) =  'subspace_rotation_imag_3D:DGEMM_1       '
  name(956) =  'subspace_rotation_imag_3D:DO_2          '
  name(957) =  'subspace_rotation_imag_3D:DO_3          '
  name(958) =  'subspace_rotation_imag_3D:DGEMM_2       '
  name(959) =  'subspace_rotation_imag_3D:DO_4          '
  name(960) =  'evolve_WFs_in_subspace_3D:DO_21         '
! -- KUKAN_8 / FFT / ID= 961 -> 962
  name(961)=  'kukan_8:FFT_INVERSE                     '
  name(962)=  'kukan_8:FFT_DIRECT                      '

!fj add 20110819
  name(966) =  'set_hmat_3D_scl:DO_1                    '
  name(967) =  'set_hmat_3D_scl:reduce_scatter_1        '
  name(968) =  'set_hmat_3D_scl:DO_2                    '
  name(969) =  'set_hmat_3D_scl:reduce_scatter_2        '
  name(970) =  'set_hmat_3D_scl:DO_3                    '
  name(971) =  'trans_scalapack:DO_1                    '
  name(972) =  'trans_scalapack:DO_2                    '
  name(973) =  'trans_scalapack:DO_3                    '
  name(974) =  'trans_scalapack:DO_4                    '
  name(975) =  'trans_scalapack:isend/irecv_1           '
  name(976) =  'trans_scalapack_r:DO_1                  '
  name(977) =  'trans_scalapack_r:DO_2                  '
  name(978) =  'trans_scalapack_r:DO_3                  '
  name(979) =  'trans_scalapack_r:DO_4                  '
  name(980) =  'trans_scalapack_r:isend/irecv_1         '
  name(981) =  'evolve_WFs_in_subspace_3D:DO_21         '
  name(982) =  'evolve_WFs_in_subspace_3D:allgather     '
  name(983) =  'evolve_WFs_in_subspace_3D:DO_22         '
  name(984) =  'evolve_WFs_in_subspace_3D:DO_23         '
  name(985) =  'evolve_WFs_in_subspace_3D:DO_24         '
  name(986) =  'evolve_WFs_in_subspace_3D:DO_25         '
  name(987) =  'evolve_WFs_in_subspace_3D:allgather     '
  name(992) =  'trans_scalapack:alltoall_1(List)        '
  name(993) =  'trans_scalapack_r:alltoall_1(List)      '
  name(994) =  'evolve_WFs_in_subspace_3D:alltoallv_1   '
!fj add 20110820
!fj add 20110901
  name(989) =  'eigsend:send                            '
  name(990) =  'eigsend:recv                            '
  name(991) =  'dsyev_driver  dsyev || dsyevd           '
!fj add 20110901

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_11 / SUBROUTINE / ID= 1101 -> 1145
  name(1101) = 'ChargeDensity_Mixing_3D                 '
  name(1102) = 'm_CD_prepare_precon_3D                  '
  name(1103) = 'm_CD_simple_mixing_3D                   '
  name(1104) = 'alloc_chgqstore_recompose_chgq_3D       '
  name(1105) = 'precon_4_charge_mix_3D                  '
  name(1106) = 'compose_chgq_dealloc_chgqstore_3D       '
  name(1107) = 'm_CD_mix_broyden1_3D                    '
  name(1108) = 'simple_mix1_3D                          '
  name(1109) = 'mix_broyden_alloc3_3D                   '
  name(1110) = 'dF_F_d0_u_v_and_dd_3D                   '
  name(1111) = 'set_ncrspd_mxiter_etc                   '
  name(1112) = 'rotate_cmix_arrays                      '
  name(1113) = 'renew_u_br_3D                           '
  name(1114) = 'mult1s_3D                               '
  name(1115) = 'mult1s5_3D                              '
  name(1116) = 'subtr_j_th_term_3D                      '
  name(1117) = 'renew_v_3D                              '
  name(1118) = 'renew_d_br_3D                           '
  name(1119) = 'store_to_urec2_3D                       '
  name(1120) = 'renew_d_last_br_3D                      '
  name(1121) = 'scatter_chg_onto_d_3D                   '
  name(1122) = 'concentrate_d_to_chg_3D                 '
  name(1123) = 'simple_mix_large_Gc_3D                  '
  name(1124) = 'm_CD_mix_broyden2_3D                    '
  name(1125) = 'dF_F_d0_u_and_v_3D                      '
  name(1126) = 'm_CD_mix_DFP_3D                         '
  name(1127) = 'dF_F_d0_u_and_w_3D                      '
  name(1128) = 'renew_w_3D                              '
  name(1129) = 'renew_d_3D                              '
  name(1130) = 'renew_d_last_3D                         '
  name(1131) = 'm_CD_mix_pulay_3D                       '
  name(1132) = 'Resid_and_dd_into_urec                  '
  name(1133) = 'Ri_dot_Rj_3D                            '
  name(1134) = 'get_finv_3D                             '
  name(1135) = 'rdecomp                                 '
  name(1136) = 'rsolve                                  '
  name(1137) = 'mult1s10_3D                             '
  name(1138) = 'Rj_dot_d_3D                             '
  name(1139) = 'get_gmatrix_3D                          '
  name(1140) = 'renew_d_using_g_3D                      '
  name(1141) = 'm_OP_simple_mixing                      '
  name(1142) = 'm_OP_mix_broyden1                       '
  name(1143) = 'm_OP_mix_broyden2                       '
  name(1144) = 'm_CD_simple_mixing_hsr_3D               '
  name(1145) = 'm_CD_check_3D                           '
  name(1050) = 'm_ESlhxc_potential_3D                   '
  name(1051) = 'm_Dipole_calc_3D                        '
  name(1052) = 'electron_part_3D                        '
  name(1053) = 'ion_part                                '
  name(1054) = 'm_Dipole_potential_3D                   '
  name(1055) = 'edip_ion_part                           '
  name(1056) = 'm_ESlhxc_wd_vlhxc_3D                    '
  name(1057) = 'm_ESiVQ_integrate_VlhxcQlm_3D           '
  name(1058) = 'm_PP_find_maximum_l                     '
  name(1059) = 'm_pwBS_sphrp2_3D                        '
  name(1060) = 'substitute_vlhxcred                     '
  name(1061) = 'dp_Vlhxcq_exp_Q_div                     '
  name(1062) = 'veQ_dot_ylm_div                         '
  name(1063) = 'symmetrize_vlhxcq                       '
! -- KUKAN_11 / COMMUNICATION & DGEMM & DO / ID= 1146 -> 1197
  name(1146) = 'm_CD_prepare_precon_3D:allreduce_1      '
  name(1147) = 'm_CD_prepare_precon_3D:allreduce_2      '
  name(1148) = 'm_CD_simple_mixing_3D:DO_1              '
  name(1149) = 'alloc_chgqstore_recompose_chgq_3D       '
  name(1150) = 'precon_4_charge_mix_3D:DO_1             '
  name(1151) = 'precon_4_charge_mix_3D:DO_2             '
  name(1152) = 'precon_4_charge_mix_3D:DO_3             '
  name(1153) = 'compose_chgq_dealloc_chgqstore_3D:DO_1  '
  name(1154) = 'simple_mix1_3D:DO_1                     '
  name(1155) = 'simple_mix1_3D:DO_2                     '
  name(1156) = 'dF_F_d0_u_v_and_dd_3D:DO_1              '
  name(1157) = 'dF_F_d0_u_v_and_dd_3D:DO_2              '
  name(1158) = 'rotate_cmix_arrays:DO_1                 '
  name(1159) = 'rotate_cmix_arrays:DO_2                 '
  name(1160) = 'mult1s_3D:DO_1                          '
  name(1161) = 'mult1s_3D:allreduce_1                   '
  name(1162) = 'mult1s5_3D:DO_1                         '
  name(1163) = 'mult1s5_3D:allreduce_1                  '
  name(1164) = 'subtr_j_th_term_3D:DO_1                 '
  name(1165) = 'store_to_urec2_3D:DO_1                  '
  name(1166) = 'renew_d_last_br_3D:DO_1                 '
  name(1167) = 'renew_d_last_br_3D:DO_2                 '
  name(1168) = 'scatter_chg_onto_d_3D:DO_1              '
  name(1169) = 'scatter_chg_onto_d_3D:bcast_1           '
  name(1170) = 'scatter_chg_onto_d_3D:DO_2              '
  name(1171) = 'concentrate_d_to_chg_3D:DO_1            '
  name(1172) = 'concentrate_d_to_chg_3D:send/recv_1     '
  name(1173) = 'concentrate_d_to_chg_3D:DO_2            '
  name(1174) = 'simple_mix_large_Gc_3D:DO_1             '
  name(1175) = 'dF_F_d0_u_and_v_3D:DO_1                 '
  name(1176) = 'dF_F_d0_u_and_v_3D:DO_2                 '
  name(1177) = 'dF_F_d0_u_and_w_3D:DO_1                 '
  name(1178) = 'renew_d_last_3D:DO_1                    '
  name(1179) = 'Ri_dot_Rj_3D:DO_1                       '
  name(1180) = 'get_finv_3D:DO_1                        '
  name(1181) = 'get_finv_3D:DO_2                        '
  name(1182) = 'rdecomp:DO_1                            '
  name(1183) = 'rdecomp:DO_2                            '
  name(1184) = 'rsolve:DO_1                             '
  name(1185) = 'rsolve:DO_2                             '
  name(1186) = 'mult1s10_3D:DO_1                        '
  name(1187) = 'mult1s10_3D:allreduce_1                 '
  name(1188) = 'get_gmatrix_3D:DO_1                     '
  name(1189) = 'renew_d_using_g_3D:DO_1                 '
  name(1190) = 'renew_d_using_g_3D:DO_2                 '
  name(1191) = 'm_OP_mix_broyden1:DO_1                  '
  name(1192) = 'm_CD_simple_mixing_hsr_3D:DO_1          '
  name(1193) = 'm_CD_check_3D:DO_1                      '
  name(1194) = 'm_CD_check_3D:DO_2                      '
  name(1195) = 'm_CD_check_3D:DO_3                      '
  name(1196) = 'm_CD_check_3D:bcast_1                   '
  name(1197) = 'm_CD_check_3D:bcast_2                   '
  name(1064) = 'm_ESlhxc_potential_3D:DO_1              '
  name(1065) = 'm_ESlhxc_potential_3D:DO_2              '
  name(1066) = 'm_ESlhxc_potential_3D:DO_3              '
  name(1067) = 'electron_part_3D:DO_1                   '
  name(1068) = 'electron_part_3D:bcast_1                '
  name(1069) = 'electron_part_3D:allreduce_1            '
  name(1070) = 'ion_part:DO_1                           '
  name(1071) = 'ion_part:DO_2                           '
  name(1072) = 'm_Dipole_potential_3D:DO_1              '
  name(1073) = 'm_Dipole_potential_3D:DO_2              '
  name(1074) = 'edip_ion_part:DO_1                      '
  name(1075) = 'edip_ion_part:DO_2                      '
  name(1076) = 'm_ESiVQ_integrate_VlhxcQlm_3D:DO_1      '
  name(1077) = 'm_ESiVQ_integrate_VlhxcQlm_3D:allreduce1'
  name(1078) = 'm_ESiVQ_integrate_VlhxcQlm_3D:DO_2      '
  name(1079) = 'm_ESiVQ_integrate_VlhxcQlm_3D:allreduce2'
  name(1080) = 'm_PP_find_maximum_l:DO_1                '
  name(1081) = 'm_pwBS_sphrp2_3D:DO_1                   '
  name(1082) = 'm_pwBS_sphrp2_3D:DO_2                   '
  name(1083) = 'substitute_vlhxcred:DO_1                '
  name(1084) = 'dp_Vlhxcq_exp_Q_div:DO_1                '
  name(1085) = 'veQ_dot_ylm_div:DO_1                    '
  name(1086) = 'symmetrize_vlhxcq:DO_1                  '
  name(1087) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP0      '
  name(1088) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP1      '
  name(1089) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP2      '
  name(1090) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP3      '
  name(1091) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP4      '
  name(1092) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP5      '
  name(1093) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP6      '
  name(1094) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP7      '
  name(1095) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP8      '
  name(1096) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP9      '
! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_FORCE
  name(1501) =  'm_Force_initialize                      '
  name(1502) =  'm_Force_term_drv_of_flmt_3D             '
  name(1503) =  'm_Force_term_drv_of_VlhxcQ_3D           '
  name(1504) =  'm_Force_term_Elocal_and_Epc_3D          '
  name(1505) =  'm_Force_term_dipole                     '
  name(1506) =  'm_Force_sumup_and_symmetrize            '
  name(1507) =  'm_Force_cal_forcmx                      '
  name(1508) =  'm_Force:comm1                           '
  name(1509) =  'm_Force:comm2                           '
  name(1510) =  'm_Force:comm3                           '
  name(1511) =  'm_Force:comm4                           '
  name(1512) =  'm_Force:comm5                           '
  name(1513) =  'm_Force:comm6                           '
  name(1514) =  'm_Force:comm7                           '
  name(1515) =  'm_Force:comm8                           '
  name(1516) =  'm_Force:comm9                           '
  name(1517) =  'gather_f_3d_to_2d                       '
  name(1518) =  'term_related_to_drv_of_flmt_NC          '
  name(1519) =  'term_related_to_drv_of_flmt_VDB         '
  name(1520) =  'substitute_ngabcred                     '
  name(1521) =  'calc_phase_div                          '
  name(1522) =  'pre_drv_of_betar_dot_WFs_div            '
  name(1523) =  'drv_of_betar_dot_WFs_div                '
  name(1524) =  'calc_phase_div                          '
  name(1525) =  'sum_hsr_dot_gauntc                      '
  name(1526) =  'hsr_dot_gaunt                           '
  name(1527) =  'add_hardpart_to_flhxcq_l_core           '
  name(1528) =  'add_hardpart_to_flhxcq_l_div            '
  name(1529) =  'force_from_Epc_for_each_atom            '
  name(1530) =  'force_from_Elocal_4_each_atom           '
  name(1531) =  'm_Force_term_Elocal_and_Epc_3D:DO_1     '
  name(1532) =  'm_Force_term_Elocal_and_Epc_3D:DO_2     '
  name(1533) =  'force_from_Epc_for_each_atom:DO_1       '
  name(1534) =  'force_from_Epc_for_each_atom:DO_2       '
  name(1535) =  'force_from_Elocal_4_each_atom:DO_1      '
  name(1536) =  'm_Force_term_drv_of_vlhxcQ_3D:DO_1      '
  name(1537) =  'm_Force_term_drv_of_vlhxcQ_3D:DO_2      '
  name(1538) =  'calc_phase_div:DO_1                     '
  name(1539) =  'sum_hsr_dot_gauntc:DO_1                 '
  name(1540) =  'add_hardpart_to_flhxcq_l_core:DO_1      '
  name(1541) =  'add_hardpart_to_flhxcq_l_core:DO_2      '
  name(1542) =  'add_hardpart_to_flhxcq_l_div:DO_1       '
  name(1543) =  'add_hardpart_to_flhxcq_l_div:DO_2       '
  name(1544) =  'm_Force_term_drv_of_flmt_3D:DO_1        '
  name(1545) =  'gather_f_3d_to_2d:DO_1                  '
  name(1546) =  'term_related_to_drv_of_flmt_NC:DO_1     '
  name(1547) =  'term_related_to_drv_of_flmt_VDB:DO_1    '
  name(1548) =  'substitute_ngabcred:DO_1                '
  name(1549) =  'calc_phase_div:DO_1                     '
  name(1550) =  'pre_drv_of_betar_dot_WFs_div:DO_1       '
  name(1551) =  'pre_drv_of_betar_dot_WFs_div:DO_2       '
  name(1552) =  'drv_of_betar_dot_WFs_div:DO_1           '
  name(1553) =  'drv_of_betar_dot_WFs_div:DO_2           '

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- RMM SOLVERE
  name(1601) =  'RMM_Initialize                          '
  name(1602) =  'RMM_zajold2zaj_phi2zaj_old_3D           '
  name(1603) =  'RMM_Vnonlocal_W_RMM_3D                  '
  name(1604) =  'RMM_temporary_FFT                       '
  name(1605) =  'RMM_rmm1_3D                             '
  name(1606) =  'RMM_rmm_n_uda_3D                        '
  name(1607) =  'RMM_zajold2zaj_phi2zaj_old_all_3D       '
  name(1608) =  'RMM_Vnonlocal_W_RMMn_3D                 '
  name(1609) =  'RMM_temporary_FFT                       '
  name(1610) =  'RMM_rmm1_3D                             '
  name(1611) =  'RMM_rmm_n_uda_3D                        '
  name(1612) =  'RMM_Finalize                            '
  name(1613) =  'RMM2_calc_phasek_b_3D                   '
  name(1614) =  'RMM2_sumset_rmm_all4                    '
  name(1615) =  'RMM2_Vnonlocal_W_part_sum_ovr_lmt4      '
  name(1616) =  'RMM2_add_vnlph_l_part4                  '
  name(1617) =  'RMM2_sumset_rmm_all3                    '
  name(1618) =  'RMM2_Vnonlocal_W_part_sum_over_lmt1b    '
  name(1619) =  'RMM2_add_vnlph_l_without_eko_part3      '
  name(1620) =  'RMM2_add_vnlph_l_with_eko_part3         '
  name(1621) =  'RMM2_rr_avr_final_3D:allreduce          '
  name(1622) =  'RMM2_rmm1_3D:allreduce                  '
  name(1623) =  'RMM2_sumset_rmm:allreduce               '
  name(1624) =  'RMM2_sumset_rmm_all4:allreduce          '
  name(1625) =  'RMM2_sumset_rmm_all3:allreduce          '


  return
end subroutine timer_init

!-----------------------------------------------------------------------
subroutine timer_fin
  use m_IterationNumbers,   only  : iteration
  use m_Parallelization ,   only  : nrank_e,nrank_g,nrank_k
  use m_timer
  implicit none

#ifdef USE_WTIME
  include 'mpif.h'
#endif

  integer :: ierr
  integer :: i, it, m, n_err, n_err_g
  real(4) :: rdum, rarray(2)
!  real(4), external :: etime
  real(4) :: etime
  logical  :: infoflg

#ifdef USE_KTRACE
      integer ktrace_target(n_tim)
      common /c_ktrace_target/ ktrace_target

!$omp parallel
      call ktrace_exit
!$omp end parallel
#endif

  ! user and system cpu time
  rdum = etime(rarray)
#ifdef USE_WTIME
  ttot(1) = MPI_WTIME() - ttot(1)  ! real
#else
  call getclkreg(t_now)
  ttot(1) = t_now       - ttot(1)  ! real
#endif
  ttot(2) = rarray(1)   - ttot(2)  ! user
  ttot(3) = rarray(2)   - ttot(3)  ! sys

  call getenv('FJ_TIMER_DIR', dname)
  if (len_trim(dname) .eq. 0) then
    dname = '.'
  else
    call system( &
 &    'if [ ! -d '//dname//' ]; then mkdir -p '//dname//'; fi')
  endif
  call getenv('FJ_TIMER_RNK', crank)
  if (crank .ne. "ALL") then
     if (len_trim(crank) .eq. 0) then
        orank = 0
     else
        read(crank,*) orank
     endif
  endif
  if ((myrank .eq. orank) .or. (crank .eq. "ALL")) then

    ncount_all = 0
    timers_all = 0.0d0

    do it = 0, iteration
!
      if (it > n_ite) cycle
!
      if (crank .eq. "ALL") then
        write(fname,'(A,"/timer_ite_",I3.3,"_",I6.6,".out")') &
     &        dname(:len_trim(dname)), it, myrank
      else
        write(fname,'(A,"/timer_ite_",I3.3,".out")') &
     &        dname(:len_trim(dname)), it
      endif
      if (iunit1 .ne. 6) open(iunit1, file=fname)


      write(IUNIT1,'("cfj_info # nodes = ",i5,2x,"ne,ng,ng = ",i5,x,i5,x,i5)') &
     &                nrank_e*nrank_g*nrank_k,nrank_e,nrank_g,nrank_k
#ifdef USE_WTIME
      write(IUNIT1,'("cfj # rank = ",i6,2x,"real,user,sys = ",3f13.3)') &
     &                myrank, ttot
#else
      write(IUNIT1,'("cfj # rank = ",i6,2x,"real,user,sys = ",3f13.3)') &
     &                myrank, ttot*5e-10
#endif
      write(IUNIT1,'("cfj # rank = ", i6,2x," Iteration = ", i6)') &
     &                myrank, it
      do i = 1, N_TIM
        if ((name(i) .ne. '-').or.(ncount(i,it).ne.0)) then
#ifdef USE_WTIME
          write(IUNIT1,'("cfj ",i4,1x,a,f13.3,1x,i8)') &
         &  i, name(i), timers(i,it),       ncount(i,it)
#else
          write(IUNIT1,'("cfj ",i4,1x,a,f13.3,1x,i8)') &
         &  i, name(i), timers(i,it)*5e-10, ncount(i,it)
#endif
        endif
        timers_all(i) = timers_all(i) + timers(i,it)
        ncount_all(i) = ncount_all(i) + ncount(i,it)
      enddo
      write(IUNIT1,'()')
    enddo

    if (crank .eq. "ALL") then
      write(fname,'(A,"/timer_tot_",I6.6,".out")') &
   &        dname(:len_trim(dname)), myrank
    else
      write(fname,'(A,"/timer_tot.out")') &
   &        dname(:len_trim(dname))
    endif
    if (iunit2 .ne. 6) open(iunit2, file=fname)
    write(IUNIT2,'("cfj_info # nodes = ",i5,2x,"ne,ng,ng = ",i5,x,i5,x,i5)') &
   &                  nrank_e*nrank_g*nrank_k,nrank_e,nrank_g,nrank_k 
#ifdef USE_WTIME
    write(IUNIT2,'("cfj # rank = ",i6,2x,"real,user,sys = ",3f13.3)') &
   &                  myrank, ttot
#else
    write(IUNIT2,'("cfj # rank = ",i6,2x,"real,user,sys = ",3f13.3)') &
   &                  myrank, ttot*5e-10
#endif
    write(IUNIT2,'("cfj # rank = ", i6,2x," Total Iteration = ", i3)') &
   &                  myrank, iteration
    do i = 1, N_TIM
      if ((name(i) .ne. '-').or.(ncount_all(i).ne.0)) then
!      if (ncount_all(i).ne.0) then
#ifdef USE_WTIME
         write(IUNIT2,'("cfj ",i4,1x,a,f13.3,1x,i8)') &
        &  i, name(i), timers_all(i),       ncount_all(i)
#else
         write(IUNIT2,'("cfj ",i4,1x,a,f13.3,1x,i8)') &
        &  i, name(i), timers_all(i)*5e-10, ncount_all(i)
#endif
      endif
    enddo
    write(IUNIT2,'()')

#ifdef USE_MEM
    call flush(unitmw)
    close(unitmw)
#endif
    call flush(IUNIT1)
    call flush(IUNIT2)
    if (IUNIT1 .ne. 6) close(IUNIT1)
    if (IUNIT2 .ne. 6) close(IUNIT2)

  endif

  return
end subroutine timer_fin
!-----------------------------------------------------------------------

subroutine timer_sta(id)
  use m_IterationNumbers,   only  : iteration
  use m_timer
  implicit none
#ifdef USE_WTIME
  include 'mpif.h'
#endif
  integer :: id,idx
  character*5 cid
  character*3 citer
  character*11 ccc

! if (.not.tflag) return
!$omp master
  if(id < 0) then
!   idx = id * (-1) + 90000
    idx = id * (-1)
  else
    idx = id
  endif

  write(cid,'(I5.5)') idx
  write(citer,'(I3.3)') iteration
  ccc = "r_"//citer//"_"//cid

#ifdef USE_MEM
  if (myrank .eq. 0) then
    integer :: j
    character(1000) :: line
    character(15),dimension(24) :: str

    open(unitmr,file='/proc/self/stat', form="formatted", access="stream", status='old')
    read(unitmr,'(a)') line
    close(unitmr)
    read(line,*) (str(j),j=1,24)
#ifdef USE_WTIME
    write(unitmw,*) ccc, " sta", MPI_WTIME()-t_sta, str(23), str(24)
#else
    call getclkreg(t_now)
    write(unitmw,*) ccc, " sta", (t_now-t_sta)*5d-10, str(23), str(24)
#endif
  endif
#endif

#ifdef USE_TOFUPA
  call fj_tofupa_start(ccc,id,1)
#endif

#ifdef USE_KTRACE
  integer ktrace_target(n_tim)
  common /c_ktrace_target/ ktrace_target

  if (ktrace_target(id) .eq. 1) then
    call ktrace_start(id)
  endif
#endif

#ifdef USE_PROF
  call start_collection(ccc)
#endif

#ifdef USE_FAPP
  call FAPP_START(ccc,1,1)
#endif
!
  if(iteration <= n_ite) then
!
#ifdef USE_WTIME
  tsta(idx) = MPI_WTIME()
#else
  call getclkreg(tsta(idx))
#endif
  ncount(idx,iteration) = ncount(idx,iteration) + 1
!
  end if
!
!$omp end master
  return
end subroutine timer_sta

!-----------------------------------------------------------------------
subroutine timer_end(id)
  use m_IterationNumbers,   only  : iteration
  use m_timer
  implicit none
#ifdef USE_WTIME
  include 'mpif.h'
#endif
  integer :: id,idx
  character*5 cid
  character*3 citer
  character*11 ccc

! if (.not.tflag) return
!$omp master
  if(id < 0) then
!   idx = id * (-1) + 90000
    idx = id * (-1)
  else
    idx = id
  endif

  write(cid,'(I5.5)') idx
  write(citer,'(I3.3)') iteration
  ccc = "r_"//citer//"_"//cid

#ifdef USE_MEM
  if (myrank .eq. 0) then
    integer :: j
    character(1000) :: line
    character(15),dimension(24) :: str

    open(unitmr,file='/proc/self/stat', form="formatted", access="stream", status='old')
    read(unitmr,'(a)') line
    close(unitmr)
    read(line,*) (str(j),j=1,24)
#ifdef USE_WTIME
    write(unitmw,*) ccc, " end", MPI_WTIME()-t_sta, str(23), str(24)
#else
    call getclkreg(t_now)
    write(unitmw,*) ccc, " end", (t_now-t_sta)*5d-10, str(23),str(24)
#endif
  endif
#endif

#ifdef USE_KTRACE
      integer ktrace_target(n_tim)
      common /c_ktrace_target/ ktrace_target

      if (ktrace_target(id) .eq. 1) then
        call ktrace_stop(id)
      endif
#endif

#ifdef USE_PROF
  call stop_collection(ccc)
#endif

#ifdef USE_FAPP
  call FAPP_STOP(ccc,1,1)
#endif

#ifdef USE_TOFUPA
  call fj_tofupa_stop(ccc,id,1)
#endif
!
  if(iteration <= n_ite) then
!
#ifdef USE_WTIME
  timers(idx,iteration) = timers(idx,iteration) + (MPI_WTIME() - tsta(idx))
#else
  call getclkreg(t_now)
  timers(idx,iteration) = timers(idx,iteration) + (t_now       - tsta(idx))
#endif
  ncnt_e(idx,iteration) = ncnt_e(idx,iteration) + 1
!
  end if
!
!$omp end master
  return
end subroutine timer_end

!-----------------------------------------------------------------------
subroutine timer_bar(id)
  use m_IterationNumbers,   only  : iteration
  use m_timer
  implicit none
  include 'mpif.h'
  integer :: id
  integer :: ierr

!
  if(iteration > n_ite) return
!
!$omp master
#ifdef USE_WTIME
  tsta(id) = MPI_WTIME()
#else
  call getclkreg(tsta(id))
#endif
  ncount(id,iteration) = ncount(id,iteration) + 1
  call MPI_BARRIER(MPI_COMM_WORLD, ierr)
#ifdef USE_WTIME
  timers(id,iteration) = timers(id,iteration) + (MPI_WTIME() - tsta(id))
#else
  call getclkreg(t_now)
  timers(id,iteration) = timers(id,iteration) + (t_now       - tsta(id))
#endif
  ncnt_e(id,iteration) = ncnt_e(id,iteration) + 1
!$omp end master

  return
end subroutine timer_bar

!-----------------------------------------------------------------------
subroutine timer_barrier(mpi_comm)
  use m_IterationNumbers,   only  : iteration
  use m_timer
  implicit none
  include 'mpif.h'
  integer :: mpi_comm
  integer :: ierr

!$omp master
  call MPI_BARRIER(MPI_COMM, ierr)
!$omp end master

  return
end subroutine timer_barrier

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 603 $)
!
!  SUBROUINE:  Preparation_for_mpi
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Preparation_for_mpi(prepare_communicators)
! $Id: Preparation_for_mpi.F90 603 2020-04-07 03:25:30Z jkoga $
!                           @(#)Preparation_for_mpi.F90 1.10 03/02/19 00:49:14
  use m_Const_Parameters,     only : INITIAL, CONTINUATION &
       &                           , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION,OFF &
       &                           , ALL_AT_ONCE, ON, DP, COORDINATE_CONTINUATION &
       &                           , ONE_BY_ONE
  use m_Kpoints,              only : kv3, kv3_ek
  use m_Files,                only : nfout
  use m_Control_Parameters,   only : ipriparallel,nspin,neg,printable,ngnode_nbmx &
       &                           , flag_mpi_g_dot_r,flag_mpi_g_dot_r_k &
       &                           , icond, ekmode, fixed_charge_k_parallel, sw_rsb, neg_is_given &
       &                           , m_CtrlP_flag_mpi_G_dot_R, fftbox_divide_cube &
       &                           , fftbox_3ddiv_1, fftbox_3ddiv_2, fftbox_3ddiv_3 &
       &                           , fftbox_div_1, fftbox_div_2, sw_fft_xzy &
       &                           , sw_communicator_for_chg, sw_serial_fft
#ifdef KMATH_FFT3D
  use m_Control_Parameters,   only : nproc_fft3d
#endif

  use m_PlaneWaveBasisSet,    only : kg1, kgpm, nbmx, iba, kgp, kgp_reduced
#ifndef PARAMSET
  use m_Kpoints,              only : k_symmetry
  use m_Parallelization,      only : m_Parallel_init_mpi_elec_3D, m_Parallel_init_mpi_iba_3D &
       &                           , make_index_band_3D, m_Parallel_mpi_fft_box &
       &                           , make_index_band_for_Gdiv_3D, m_Parallel_mpi_fft_box_cd &
       &                           , m_Parallel_mpi_fft_box_3div, m_Parallel_mpi_fft_box_cd_3div &
       &                           , m_Parallel_mpi_fft_box_xyz , m_Parallel_mpi_fft_box_cd_xyz  &
       &                           , m_Parallel_init_mpi_kngp_3D, m_Parallel_init_mpi_atm &
       &                           , m_Parallel_init_mpi_atm2 &
       &                           , m_Parallel_init_mpi_atm_f &
       &                           , m_Parallel_init_mpi_kngp_B_3D, m_Parallel_init_mpi_atm_B_3D &
       &                           , m_Parallel_init_mpi_atm_ke &
       &                           , m_Parallel_chgq_onto_fftcd_3D, m_Parallel_fftcd_onto_chgq_3D &
       &                           , m_Parallel_fft_onto_chgq_3D ,m_Parallel_init_mpi_mix &
       &                           , m_Parallel_wf_onto_fft_3D, m_Parallel_fft_onto_wf_3D &
       &                           , nel_fft_x, nel_fft_y, nel_fft_z &
       &                           , m_Parallel_init_mpi_gga     &
       &                           , m_Parallel_init_mpi_nbmx    &
       &                           , m_Parallel_init_mpi_snl_3D  &
       &                           , m_Parallel_init_mpi_ffth &
       &                           , m_Parallel_init_mpi_kv3_ek
#ifdef MPI_FFTW
  use m_Parallelization,      only : m_Parallel_wf_onto_fft_mpifftw, m_Parallel_fft_onto_wf_mpifftw &
       &                           , m_Parallel_fft_onto_chgq_mpifftw
#endif
  use m_Control_Parameters, only :   nblocksize_mgs          &
       &                           , nblocksize_mgs_is_given , kimg, GAMMA
  use m_Electronic_Structure,only:  nblocksize_mgs_default
  use m_FFT,                  only : nfft &
       &                           , fft_box_size_WF               &
       &                           , fft_box_size_CD_3D            &
       &                           , m_FFT_Direct_3D,  m_FFT_Direct_XYZ_3D  &
       &                           , m_FFT_Inverse_3D, m_FFT_Inverse_XYZ_3D  &
       &                           , m_FFT_Inverse_XYZ_3D_oo_place &
#ifdef MPI_FFTW
       &                           , nfftp, nfftps, m_FFT_init_mpifftw
#else
       &                           , nfftp, nfftps
#endif
  use m_PlaneWaveBasisSet,    only : m_pwBS_alloc_ngpt_igfp_gr_3D  &
       &                           , m_pwBS_calc_length_of_G_3D    &
       &                           , m_pwBS_G_trans_functions_3D   &
       &                           , m_pwBS_setup_FFTmapfunctions_3D &
       &                           , m_pwBS_set_ngabc_B_3D       &
       &                           , m_pwBS_set_ngabc_3D         &
       &                           , igfp_l                       &
       &                           , igf, nbase, nbase_gamma, kg, kg_gamma
  use m_Charge_Density,       only : m_CD_alloc_chgq
  use m_XC_Potential,         only : m_XC_alloc_vxc_3D
  use m_Ionic_System,         only : m_IS_alloc_zfm3_3D
  use m_Ionic_System,         only : natm, natm2, m_IS_alloc_fxyzew
  use m_Force,                only : m_Force_alloc
#ifdef __EDA__
  use m_XC_Potential_2D,      only : m_XC_alloc_exc_on_a_grid
  use m_Ionic_System,         only : m_IS_alloc_eewald_per_atom, m_IS_alloc_zfm3_EDA
  use m_PseudoPotential,      only : m_PP_alloc_PP_per_atom_etc
#endif
#endif

! ============================== added by K. Tagami ================== 11.0&13.0XX
  use m_Control_Parameters,   only : noncol, ndim_spinor, sw_calc_ekin_density
  use m_KineticEnergy_Density,  only : m_KE_alloc_ekin_density
! ==================================================================== 11.0&13.0XX

#ifdef __EDA__
  use m_Control_Parameters,   only : sw_eda
#endif

#ifdef KMATH_FFT3D
  use m_Parallelization, only : m_Parallel_kmath3d_init
  use m_Control_Parameters, only : sw_kmath_fft3d, nstage_fft3d
#endif

#ifdef MPI_FFTW
  use m_Control_Parameters,only: sw_mpi_fftw
#endif

  implicit none

  integer, intent(in) :: prepare_communicators
  integer             :: lsize
  real(kind=DP), allocatable, dimension(:,:) :: dfft_l

#ifndef PARAMSET
  call m_IS_alloc_fxyzew()
  call m_Force_alloc()

! === KT_add ==== 13.0XX
  if ( sw_calc_ekin_density == ON ) call m_KE_alloc_ekin_density
! =============== 13.0XX

  if(prepare_communicators==ON)then

!!$     if(neg_is_given) then
        call m_Parallel_init_mpi_elec_3D(nfout,ipriparallel,printable,neg,kv3,nspin,kg1,iba)
        call make_index_band_3D(nfout,ipriparallel,printable,kv3,neg &
             & , nblocksize_mgs,nblocksize_mgs_is_given,nblocksize_mgs_default)
        call make_index_band_for_Gdiv_3D(neg, nblocksize_mgs,nblocksize_mgs_is_given,nblocksize_mgs_default)
!!$     end if
#ifdef FFT_3D_DIVISION
     call m_Parallel_mpi_fft_box_3div(nfout,ipriparallel,printable,fft_box_size_WF,kimg, &
    &                            fftbox_3ddiv_1, fftbox_3ddiv_2,fftbox_3ddiv_3)
#else
     if (sw_fft_xzy > 0) then
        call m_Parallel_mpi_fft_box(nfout,ipriparallel,printable,fft_box_size_WF,kimg,fftbox_divide_cube)
     else
        call m_Parallel_mpi_fft_box_xyz(nfout,ipriparallel,printable,fft_box_size_WF,kimg, &
    &                            fftbox_div_1, fftbox_div_2)
#ifdef KMATH_FFT3D
        if(sw_kmath_fft3d==ON) call m_Parallel_kmath3d_init(fft_box_size_WF,nstage_fft3d)
#endif
     end if
#endif
#ifdef FFT_3D_DIVISION_CD
     call m_Parallel_mpi_fft_box_cd_3div(nfout,ipriparallel,printable,fft_box_size_CD_3D,kimg, &
    &                               fftbox_3ddiv_1,fftbox_3ddiv_2,fftbox_3ddiv_3)
#else
     if (sw_fft_xzy > 0) then
        call m_Parallel_mpi_fft_box_cd(nfout,ipriparallel,printable,fft_box_size_CD_3D,kimg,fftbox_divide_cube)
     else
        call m_Parallel_mpi_fft_box_cd_xyz(nfout,ipriparallel,printable,fft_box_size_CD_3D,kimg, &
    &                               fftbox_div_1,fftbox_div_2)
     endif
#endif
!     call m_Parallel_init_mpi_kngp_3D(nfout,ipriparallel,kgp)  ! -(m_Parallelization) ->ista_kngp,iend_kngp
     call m_Parallel_init_mpi_kngp_B_3D(nfout,ipriparallel,kgp)  ! -(m_Parallelization) ->ista_kngp_B,iend_kngp_B
     call m_pwBS_set_ngabc_B_3D
     call m_pwBS_set_ngabc_3D
!FNS     call m_pwBS_dealloc_ngabc
!!!  call m_CtrlP_flag_mpi_G_dot_R(nfout,nbmx) ! -> flag_mpi_g_dot_r
     call m_Parallel_init_mpi_nbmx(nfout,ipriparallel,printable,nbmx,kg1,ngnode_nbmx,flag_mpi_g_dot_r,flag_mpi_g_dot_r_k)
     call m_Parallel_init_mpi_gga(nfout,ipriparallel,printable,nfftp,nfftps,sw_serial_fft)
     if(sw_rsb==ON) call m_Parallel_init_mpi_ffth(nfout,ipriparallel,printable,nfft)
     call m_Parallel_init_mpi_snl_3D(nfout,ipriparallel,printable,nspin)
     !call m_Parallel_init_mpi_atm_f(nfout,ipriparallel,printable,natm)
     call m_Parallel_init_mpi_atm_ke(nfout,ipriparallel,printable,natm)
     call m_Parallel_init_mpi_atm(nfout,ipriparallel,printable,natm)
     call m_Parallel_init_mpi_atm2(nfout,ipriparallel,printable,natm2)
     call m_Parallel_init_mpi_atm_B_3D(nfout,ipriparallel,printable,natm,sw_communicator_for_chg == ON)
     call m_Parallel_init_mpi_mix(nfout,ipriparallel,printable,kgpm,sw_communicator_for_chg == ON)
#ifdef __EDA__
     if (sw_eda == ON) then
! -----  ascat starts modifying  -----
     call m_XC_alloc_exc_on_a_grid()
     call m_IS_alloc_zfm3_EDA(natm)
     call m_IS_alloc_eewald_per_atom(natm)
     call m_PP_alloc_PP_per_atom_etc
! -----  ascat ceases modifying  -----
  endif
#endif

  endif

  if((icond == INITIAL .or. icond == CONTINUATION .or.  icond==COORDINATE_CONTINUATION) &
       & .or.((icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION).and.ekmode==OFF &
       & .and. fixed_charge_k_parallel == ALL_AT_ONCE)) then
     call m_Parallel_init_mpi_iba_3D(nfout,ipriparallel,printable,kv3,iba) ! -> np_g1k, mp_g1k
  end if
!!!!$!BRANCH_P ORG_Parallel
  if((icond==FIXED_CHARGE .or. icond==FIXED_CHARGE_CONTINUATION) .and. &
    & fixed_charge_k_parallel==ONE_BY_ONE) &
    & call m_Parallel_init_mpi_kv3_ek(nfout,ipriparallel,printable,kv3_ek,nspin)
!!!!$!BRANCH_P_END ORG_Parallel


  call m_IS_alloc_zfm3_3D()
  call m_CD_alloc_chgq()
  call m_XC_alloc_vxc_3D()
!  call m_pwBS_alloc_ngpt_igfp_gr_3D()
!  call m_pwBS_calc_length_of_G_3D()
!  call m_pwBS_G_trans_functions_3D()
!  call m_pwBS_setup_FFTmapfunctions_3D()
! === For epsmain by tkato 2013/11/14 ==========================================
! call m_Parallel_wf_onto_fft_3D(nfout,fft_box_size_WF,igf,nbase,nbase_gamma,k_symmetry,GAMMA,kg,kg_gamma,kv3,1)
! call m_Parallel_fft_onto_wf_3D(nfout,fft_box_size_WF,igf,nbase,kg,kv3,nfft,1)
  if(ekmode == OFF) then
     call m_Parallel_wf_onto_fft_3D(nfout,fft_box_size_WF,igf,nbase,nbase_gamma, &
                                    k_symmetry,GAMMA,kg,kg_gamma,kv3,1)
     call m_Parallel_fft_onto_wf_3D(nfout,fft_box_size_WF,igf,nbase,kg,kv3,nfft,1)
#ifdef MPI_FFTW
     if(sw_mpi_fftw==ON) then
       call m_Parallel_wf_onto_fft_mpifftw(nfout,fft_box_size_WF,igf,nbase,nbase_gamma, &
                                      k_symmetry,GAMMA,kg,kg_gamma,kv3,1)
       call m_Parallel_fft_onto_wf_mpifftw(nfout,fft_box_size_WF,igf,nbase,kg,kv3,nfft,1)
       call m_FFT_init_mpifftw()
     endif
#endif
  end if
! ==============================================================================
  call m_Parallel_fft_onto_chgq_3D(nfout,fft_box_size_WF,igf,kg,nfft)
#ifdef MPI_FFTW
  if(sw_mpi_fftw==ON) then
    call m_Parallel_fft_onto_chgq_mpifftw(nfout,fft_box_size_WF,igf,kg,nfft)
  endif
#endif
  call m_Parallel_chgq_onto_fftcd_3D(nfout,kgp,fft_box_size_CD_3D,igfp_l)
  call m_Parallel_fftcd_onto_chgq_3D(nfout,kgp_reduced,fft_box_size_CD_3D,igfp_l)
#ifndef FFT_USE_SSL2
#ifndef FFT_3D_DIVISION
  lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
  if (kimg==1) lsize=lsize*2
  allocate(dfft_l(lsize*kimg,1))
  if (sw_fft_xzy > 0) then
     call m_FFT_Direct_3D(nfout,dfft_l,lsize,1)
     call m_FFT_Inverse_3D(nfout,dfft_l,lsize,1)
  else
     call m_FFT_Direct_XYZ_3D(nfout,dfft_l,lsize,1)
     call m_FFT_Inverse_XYZ_3D(nfout,dfft_l,lsize,1)
  end if
  deallocate(dfft_l)
#endif
#endif

#endif

end subroutine Preparation_for_mpi

subroutine Preparation_for_mpi_ek
! $Id: Preparation_for_mpi.F90 603 2020-04-07 03:25:30Z jkoga $
!                           @(#)Preparation_for_mpi.F90 1.10 03/02/19 00:49:14
  use m_Kpoints,              only : kv3
  use m_Files,                only : nfout
  use m_Control_Parameters,   only : ipriparallel, printable
  use m_PlaneWaveBasisSet,    only : iba
  use m_Parallelization,      only : m_Parallel_init_mpi_iba_3D

  call m_Parallel_init_mpi_iba_3D(nfout,ipriparallel,printable,kv3,iba) !  -> np_g1k, mp_g1k

end subroutine Preparation_for_mpi_ek

subroutine Preparation_for_mpi_PAW()
  use m_Files,                only : nfout
  use m_Ionic_System,         only : natm
  use m_PseudoPotential,      only : mmesh, flg_paw
  use m_Parallelization,      only : m_Parallel_init_mpi_paw_3D
  use m_Control_Parameters,   only : ipriparallel
  if (flg_paw) then
    call m_Parallel_init_mpi_paw_3D(nfout,ipriparallel,natm,mmesh)
  endif
end subroutine Preparation_for_mpi_PAW

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: fft_c3d fft_r3d fft_trans_yz fft_trans_zy mkd_c3d
!
!  AUTHOR(S): T. Yamasaki, T. Yamamoto   June/01/2007
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!


!     ****************************************************************
!     AUTHORS: T.KOKUBO(NEC), K.TAKADA(NIS), T.FURUTA(NIS), R.SAKA(NIS)
!              Y.SAKAGUCHI(NES)
!     REGD. ON 03/15/02 BY T.F.
!     UPGD. ON 04/18/06 BY T.K. & Y.S.
!     UPGD. ON 09/08/06 BY T.K.
!
      SUBROUTINE FFT_C3D(NX,NY,NZ,NY_D,NZ_D,A,lx,ly,lz,ly_d,lz_d,
     &                   INDEX,ISW,TIME,B,NT,FFT_WORLD,IERR)
!
!     IMPLICIT NONE
#ifdef MKLFFT
      USE MKL_DFTI
#endif
      INCLUDE "mpif.h"
!
      INTEGER,PARAMETER :: PREC=8
      INTEGER,INTENT(IN) :: FFT_WORLD,NX,NY,NZ,ISW,NT
      INTEGER,INTENT(IN) :: INDEX,NY_D,NZ_D
      INTEGER,INTENT(IN) :: lx,ly,ly_d,lz,lz_d
      INTEGER,INTENT(INOUT) :: IERR(2)
      COMPLEX(KIND=PREC),INTENT(INOUT) :: A(0:*),B(0:*)
      REAL(KIND=PREC),INTENT(OUT) :: TIME(5)
!
      INTEGER :: IRANK,ISIZE
#ifdef ASLFFT
      INTEGER :: IFAX(20)
#elif SRFFT
      INTEGER :: ip(4),iopt(3),n,nwkw
      INTEGER,PARAMETER :: MAXFAX = 4
      INTEGER,DIMENSION(MAXFAX) :: NFAX = (/2,3,5,7/)
#elif FFTW3
      INTEGER(KIND=PREC) :: PLAN
      INTEGER,DIMENSION(1) :: NFFTW3
      INTEGER,DIMENSION(1) :: NEMBED
      INTEGER :: ISWFFTW
      INTEGER,PARAMETER :: FFTW_RANK = 1
      INTEGER,PARAMETER :: FFTW_ESTIMATE = 64
#elif MKLFFT
      INTEGER :: STRIDE(2), Status
      TYPE(DFTI_DESCRIPTOR), POINTER :: Desc_Handle
#endif
      INTEGER :: I,J,K,MAXSIZE,KERR,ll,ll_d
      REAL(KIND=PREC) :: T0,T1,T2
      COMPLEX(KIND=PREC),DIMENSION(:),ALLOCATABLE :: TRIGS
!
      KERR = 0
      IERR = 0
#ifdef FFTW3
#ifdef _OPENMP
      if(NT>1) then
         call dfftw_init_threads
         call dfftw_plan_with_nthreads(NT)
      end if
#endif
      ISWFFTW   = -ISW
#endif
!
! *** MPI INITIALIZE ***
      CALL MPI_COMM_RANK(FFT_WORLD,IRANK,IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 8000
         RETURN
      ENDIF
      CALL MPI_COMM_SIZE(FFT_WORLD,ISIZE,IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 8000
         RETURN
      ENDIF
!
! *** ERROR CHECK ***
! NX,NY,NZ
      IF( ( NX .LT. 2 ) .OR. ( NY .LT. 2 ) .OR. ( NZ .LT. 2 ) ) THEN
         IERR(1) = 3000
         RETURN
      ENDIF
      IF( LY .LT. LY_D*ISIZE ) THEN
         IERR(1) = 3010
         RETURN
      ENDIF
      IF( LY_D .LT. NY_D ) THEN
         IERR(1) = 3020
         RETURN
      ENDIF
      IF( LZ .LT. NZ_D*ISIZE ) THEN
         IERR(1) = 3030
         RETURN
      ENDIF
      IF( LZ_D .LT. NZ_D ) THEN
         IERR(1) = 3040
         RETURN
      ENDIF
! ISW
      IF( ( ISW .NE. -1 ) .AND. ( ISW .NE. 1 ) .AND. (ISW .NE. 0 ) )THEN
         IERR(1) = 3050
      ENDIF
! NT
      IF( NT .LT. 1 ) THEN
         IERR(1) = 3060
         RETURN
      ENDIF
! INDEX
      IF( ( INDEX .LT. 2 ) .OR. ( INDEX .GT. 3 ) ) THEN
         IERR(1) = 3100
         RETURN
      ENDIF
!
      TIME = 0.0_PREC
!
! *** ONLY DATA TRANS ***
      IF( ISW .EQ. 0 ) THEN
         T1 = MPI_WTIME()
         if(index.eq.2) then
            CALL FFT_TRANS_YZ(A,LX,LY,LY_D,NY_D,NZ_D,B,FFT_WORLD,IERR)
         elseif(index.eq.3) then
            CALL FFT_TRANS_ZY(A,LX,LY,LY_D,NY_D,NZ_D,B,FFT_WORLD,IERR)
         endif
         T2 = MPI_WTIME()
         TIME(4) = T2 - T1
         TIME(5) = T2 - T1
         RETURN
      ENDIF
!
! WORKING AREA
      MAXSIZE = MAX(NX,NY,NZ)
      ALLOCATE(TRIGS(MAXSIZE),STAT=IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 7000
         RETURN
      ENDIF

      T0 = MPI_WTIME()
      if(index.eq.2) then !!! *** Y==>Z ***
!
! X FFT
      T1 = MPI_WTIME()
#ifdef ASLFFT
      if (mod(lx,4).eq.0) then
         ll=nz
         if(mod(nz,2).ne.0 .and. (lz.gt.nz)) then
            ll=ll+1
         endif
         call ztransb(a,lx,b,ly_d*ll,nx,ly_d*nz,nt)
         CALL HFCMFB(NX,LY_D*NZ,B,LY_D*LL,1,ISW,IFAX,TRIGS,A,NT,KERR)
         call ztransb(b,ly_d*ll,a,lx,ly_d*nz,nx,nt)
      else
         CALL HFCMFB(NX,LY_D*NZ,A,1,LX,ISW,IFAX,TRIGS,B,NT,KERR)
      endif
#elif SRFFT
      n=NX
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      if(isw.eq. 1) iopt(1)=1
      if(isw.eq.-1) iopt(1)=2
      iopt(2)=1
      iopt(3)=1
      nwkw=1
      call hzft5s(A,LX,LY_D*NZ,NX,ip,LY_D*NZ,iopt,trigs,B,nwkw,kerr)
#elif FFTW3
      NFFTW3(1) = NX
      NEMBED(1) = LX
      call dfftw_plan_many_dft
     &     (PLAN,FFTW_RANK,NFFTW3,LY_D*NZ,
     &      A,NEMBED,1,LX,
     &      A,NEMBED,1,LX,
     &      ISWFFTW,FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_COMPLEX, 1, NX)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, LY_D*NZ)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, LX)
     !!$ Status = DftiSetValue(Desc_Handle,
     !!$&         DFTI_OUTPUT_DISTANCE, LX)
      Status = DftiCommitDescriptor(Desc_Handle)
      IF(ISW == 1) THEN
         Status = DftiComputeForward(Desc_Handle,A)
      ELSE
         Status = DftiComputeBackward(Desc_Handle,A)
      ENDIF
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
      T2 = MPI_WTIME()
      TIME(1) = T2 - T1
      IF( KERR .GE. 4000 ) THEN
         IERR(1) = 4000
         RETURN
      ENDIF
!
! Z FFT
      T1 = MPI_WTIME()
#ifdef ASLFFT
      CALL HFCMFB(NZ,LX*NY_D,A,LX*LY_D,1,ISW,IFAX,TRIGS,B,NT,KERR)
#elif SRFFT
      n=NZ
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      if(isw.eq. 1) iopt(1)=1
      if(isw.eq.-1) iopt(1)=2
      iopt(2)=1
      iopt(3)=2
      nwkw=1
      call hzft5s(A,LX*LY_D,NZ,NZ,ip,LX*NY_D,iopt,trigs,B,nwkw,kerr)
#elif FFTW3
      NFFTW3(1) = NZ
      NEMBED(1) = LZ
      call dfftw_plan_many_dft
     &     (PLAN,FFTW_RANK,NFFTW3,LX*NY_D,
     &      A,NEMBED,LX*LY_D,1,
     &      A,NEMBED,LX*LY_D,1,
     &      ISWFFTW,FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_COMPLEX, 1, NZ)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, LX*NY_D)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, 1)
     !!$ Status = DftiSetValue(Desc_Handle,
     !!$&         DFTI_OUTPUT_DISTANCE, 1)
      Stride(1)=0
      Stride(2)=LX*LY_D
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_STRIDES, Stride)
     !!$ Status = DftiSetValue(Desc_Handle,
     !!$&         DFTI_OUTPUT_STRIDES, Stride)
      Status = DftiCommitDescriptor(Desc_Handle)
      IF(ISW == 1) THEN
         Status = DftiComputeForward(Desc_Handle,A)
      ELSE
         Status = DftiComputeBackward(Desc_Handle,A)
      ENDIF
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
      T2 = MPI_WTIME()
      TIME(3) = T2 - T1
      IF( KERR .GE. 4000 ) THEN
         IERR(1) = 4000
         RETURN
      ENDIF
!
! *** TRANSPORT Y==>Z ***
      T1 = MPI_WTIME()
      CALL FFT_TRANS_YZ(A,LX,LY,LY_D,NY_D,NZ_D,B,FFT_WORLD,IERR)
      T2 = MPI_WTIME()
      TIME(4) = T2 - T1
      IF( IERR(1) .NE. 0 ) RETURN
!
! Y FFT
      T1 = MPI_WTIME()
!CDIR PARALLEL DO PRIVATE(I,J,K)
      DO K=0,NZ_D-1
      DO J=0,NY-1
      DO I=0,NX-1
         B(I+K*NX+J*NX*NZ_D)=A(I+J*LX+K*LX*LY)
      ENDDO
      ENDDO
      ENDDO
#ifdef ASLFFT
      CALL HFCMFB(NY,NX*NZ_D,B,NX*NZ_D,1,ISW,IFAX,TRIGS,A,NT,KERR)
#elif SRFFT
      n=NY
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      if(isw.eq. 1) iopt(1)=1
      if(isw.eq.-1) iopt(1)=2
      iopt(2)=1
      iopt(3)=2
      nwkw=1
      call hzft5s(B,NX*NZ_D,NY,NY,ip,NX*NZ_D,iopt,trigs,A,nwkw,kerr)
#elif FFTW3
      NFFTW3(1) = NY
      NEMBED(1) = NY
      call dfftw_plan_many_dft
     &     (PLAN,FFTW_RANK,NFFTW3,NX*NZ_D,
     &      B,NEMBED,NX*NZ_D,1,
     &      B,NEMBED,NX*NZ_D,1,
     &      ISWFFTW,FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_COMPLEX, 1, NY)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, NX*NZ_D)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, 1)
     !!$ Status = DftiSetValue(Desc_Handle,
     !!$&         DFTI_OUTPUT_DISTANCE, 1)
      Stride(1)=0
      Stride(2)=NX*NZ_D
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_STRIDES, Stride)
     !!$ Status = DftiSetValue(Desc_Handle,
     !!$&         DFTI_OUTPUT_STRIDES, Stride)
      Status = DftiCommitDescriptor(Desc_Handle)
      IF(ISW == 1) THEN
         Status = DftiComputeForward(Desc_Handle,B)
      ELSE
         Status = DftiComputeBackward(Desc_Handle,B)
      ENDIF
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
!CDIR PARALLEL DO PRIVATE(I,J,K)
      DO K=0,NZ_D-1
      DO J=0,NY-1
      DO I=0,NX-1
         A(I+J*LX+K*LX*LY)=B(I+K*NX+J*NX*NZ_D)
      ENDDO
      ENDDO
      ENDDO
      T2 = MPI_WTIME()
      TIME(2) = T2 - T1
      IF( KERR .GE. 4000 ) THEN
         IERR(1) = 4000
         RETURN
      ENDIF

      elseif(index.eq.3) then !!! *** Z==>Y ***
!
! X FFT
      T1 = MPI_WTIME()
#ifdef ASLFFT
      if (mod(lx,4).eq.0) then
         ll_d=nz_d
         if(mod(nz_d,2).ne.0 .and. (lz_d.gt.nz_d)) then
            ll_d=ll_d+1
         endif
         call ztransb(a,lx,b,ly*ll_d,nx,ly*nz_d,nt)
         CALL HFCMFB(NX,LY*NZ_D,B,LY*LL_D,1,ISW,IFAX,TRIGS,A,NT,KERR)
         call ztransb(b,ly*ll_d,a,lx,ly*nz_d,nx,nt)
      else
         CALL HFCMFB(NX,LY*NZ_D,A,1,LX,ISW,IFAX,TRIGS,B,NT,KERR)
      endif
#elif SRFFT
      n=NX
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      if(isw.eq. 1) iopt(1)=1
      if(isw.eq.-1) iopt(1)=2
      iopt(2)=1
      iopt(3)=1
      nwkw=1
      call hzft5s(A,LX,LY*NZ_D,NX,ip,LY*NZ_D,iopt,trigs,B,nwkw,kerr)
#elif FFTW3
      NFFTW3(1) = NX
      NEMBED(1) = LX
      call dfftw_plan_many_dft
     &     (PLAN,FFTW_RANK,NFFTW3,LY*NZ_D,
     &      A,NEMBED,1,LX,
     &      A,NEMBED,1,LX,
     &      ISWFFTW,FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_COMPLEX, 1, NX)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, LY*NZ_D)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, LX)
     !!$ Status = DftiSetValue(Desc_Handle,
     !!$&         DFTI_OUTPUT_DISTANCE, LX)
      Status = DftiCommitDescriptor(Desc_Handle)
      IF(ISW == 1) THEN
         Status = DftiComputeForward(Desc_Handle,A)
      ELSE
         Status = DftiComputeBackward(Desc_Handle,A)
      ENDIF
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
      T2 = MPI_WTIME()
      TIME(1) = T2 - T1
      IF( KERR .GE. 4000 ) THEN
         IERR(1) = 4000
         RETURN
      ENDIF
!
! Y FFT
      T1 = MPI_WTIME()
!CDIR PARALLEL DO PRIVATE(I,J,K)
      DO K=0,NZ_D-1
      DO J=0,NY-1
      DO I=0,NX-1
         B(I+K*NX+J*NX*NZ_D)=A(I+J*LX+K*LX*LY)
      ENDDO
      ENDDO
      ENDDO
#ifdef ASLFFT
      CALL HFCMFB(NY,NX*NZ_D,B,NX*NZ_D,1,ISW,IFAX,TRIGS,A,NT,KERR)
#elif SRFFT
      n=NY
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      if(isw.eq. 1) iopt(1)=1
      if(isw.eq.-1) iopt(1)=2
      iopt(2)=1
      iopt(3)=2
      nwkw=1
      call hzft5s(B,NX*NZ_D,NY,NY,ip,NX*NZ_D,iopt,trigs,A,nwkw,kerr)
#elif FFTW3
      NFFTW3(1) = NY
      NEMBED(1) = NY
      call dfftw_plan_many_dft
     &     (PLAN,FFTW_RANK,NFFTW3,NX*NZ_D,
     &      B,NEMBED,NX*NZ_D,1,
     &      B,NEMBED,NX*NZ_D,1,
     &      ISWFFTW,FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_COMPLEX, 1, NY)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, NX*NZ_D)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, 1)
     !!$ Status = DftiSetValue(Desc_Handle,
     !!$&         DFTI_OUTPUT_DISTANCE, 1)
      Stride(1)=0
      Stride(2)=NX*NZ_D
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_STRIDES, Stride)
     !!$ Status = DftiSetValue(Desc_Handle,
     !!$&         DFTI_OUTPUT_STRIDES, Stride)
      Status = DftiCommitDescriptor(Desc_Handle)
      IF(ISW == 1) THEN
         Status = DftiComputeForward(Desc_Handle,B)
      ELSE
         Status = DftiComputeBackward(Desc_Handle,B)
      ENDIF
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
!CDIR PARALLEL DO PRIVATE(I,J,K)
      DO K=0,NZ_D-1
      DO J=0,NY-1
      DO I=0,NX-1
         A(I+J*LX+K*LX*LY)=B(I+K*NX+J*NX*NZ_D)
      ENDDO
      ENDDO
      ENDDO
      T2 = MPI_WTIME()
      TIME(2) = T2 - T1
      IF( KERR .GE. 4000 ) THEN
         IERR(1) = 4000
         RETURN
      ENDIF
!
! *** TRANSPORT Z==>Y ***
      T1 = MPI_WTIME()
      CALL FFT_TRANS_ZY(A,LX,LY,LY_D,NY_D,NZ_D,B,FFT_WORLD,IERR)
      T2 = MPI_WTIME()
      TIME(4) = T2 - T1
      IF( IERR(1) .NE. 0 ) RETURN
!
! Z FFT
      T1 = MPI_WTIME()
#ifdef ASLFFT
      CALL HFCMFB(NZ,LX*NY_D,A,LX*LY_D,1,ISW,IFAX,TRIGS,B,NT,KERR)
#elif SRFFT
      n=NZ
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      if(isw.eq. 1) iopt(1)=1
      if(isw.eq.-1) iopt(1)=2
      iopt(2)=1
      iopt(3)=2
      nwkw=1
      call hzft5s(A,LX*LY_D,NZ,NZ,ip,LX*NY_D,iopt,trigs,B,nwkw,kerr)
#elif FFTW3
      NFFTW3(1) = NZ
      NEMBED(1) = LZ
      call dfftw_plan_many_dft
     &     (PLAN,FFTW_RANK,NFFTW3,LX*NY_D,
     &      A,NEMBED,LX*LY_D,1,
     &      A,NEMBED,LX*LY_D,1,
     &      ISWFFTW,FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_COMPLEX, 1, NZ)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, LX*NY_D)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, 1)
     !!$ Status = DftiSetValue(Desc_Handle,
     !!$&         DFTI_OUTPUT_DISTANCE, 1)
      Stride(1)=0
      Stride(2)=LX*LY_D
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_STRIDES, Stride)
     !!$ Status = DftiSetValue(Desc_Handle,
     !!$&         DFTI_OUTPUT_STRIDES, Stride)
      Status = DftiCommitDescriptor(Desc_Handle)
      IF(ISW == 1) THEN
         Status = DftiComputeForward(Desc_Handle,A)
      ELSE
         Status = DftiComputeBackward(Desc_Handle,A)
      ENDIF
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
      T2 = MPI_WTIME()
      TIME(3) = T2 - T1
      IF( KERR .GE. 4000 ) THEN
         IERR(1) = 4000
         RETURN
      ENDIF

      endif
!
! *** FINALIZE ***
      T1 = MPI_WTIME()
      TIME(5) = T1 - T0
      DEALLOCATE(TRIGS,STAT=IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 7100
         RETURN
      ENDIF

      RETURN

      END

!     ****************************************************************
!     AUTHORS: T.KOKUBO(NEC), K.TAKADA(NIS), T.FURUTA(NIS), R.SAKA(NIS)
!
!     REGD. ON 03/15/02 BY R.S.
!     UPDD. ON 09/08/06 BY T.K.
!
      SUBROUTINE FFT_R3D(NX,NY,NZ,NY_D,NZ_D,A,LX,LY,LZ,LY_D,LZ_D,
     &                   index,isw, TIME, B,NT,FFT_WORLD, IERR )

#ifdef MKLFFT
      USE MKL_DFTI
#endif

      INTEGER,PARAMETER :: NPREC=8
!
! ::: ARGUMENTS :::
!
      INTEGER,INTENT(IN) :: NX,NY,NZ,NY_D,NZ_D, LX,LY,LZ,LY_D,LZ_D,
     &                      index,NT, FFT_WORLD,isw
      INTEGER,INTENT(INOUT),DIMENSION(:) :: IERR(2)
      REAL(KIND=NPREC),DIMENSION(5),INTENT(OUT) :: TIME
      REAL(KIND=NPREC),DIMENSION(:),INTENT(INOUT) :: A(0:*),B(0:*)
!
#ifdef ASLFFT
      INTEGER,DIMENSION(:) :: IFAX(20)
      integer :: kerr
#elif SRFFT
      INTEGER :: ip(4),iopt(3),n,nwkw
      INTEGER,PARAMETER :: MAXFAX = 4
      INTEGER,DIMENSION(MAXFAX) :: NFAX = (/2,3,5,7/)
#elif FFTW3
      INTEGER(KIND=NPREC) :: PLAN
      INTEGER,DIMENSION(1) :: NFFTW3
      INTEGER,DIMENSION(1) :: NEMBED
      INTEGER,DIMENSION(1) :: NEREAL
      INTEGER,PARAMETER :: FFTW_RANK = 1
      INTEGER,PARAMETER :: FFTW_ESTIMATE = 64
      INTEGER :: ISWFFTW
#elif MKLFFT
      INTEGER :: STRIDE(2), Status, II
      TYPE(DFTI_DESCRIPTOR), POINTER :: Desc_Handle
      COMPLEX(KIND=NPREC), allocatable :: C(:)
#endif
      INTEGER :: I,J,K,NX2,LX2,ISIZE,ll,ll_d
      COMPLEX(KIND=NPREC),DIMENSION(:),ALLOCATABLE :: TRIGS
      REAL(KIND=NPREC) :: T0,T1
!
      INCLUDE "mpif.h"
!
#ifdef FFTW3
      ISWFFTW=-ISW
#ifdef _OPENMP
      if(NT>1) then
         call dfftw_init_threads
         call dfftw_plan_with_nthreads(NT)
      end if
!
#endif
#endif
      CALL MPI_COMM_SIZE(FFT_WORLD,ISIZE,IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 8000
         RETURN
      ENDIF
!
      DO I=1,5
         TIME(I) = 0.D0
      ENDDO
      T0      = MPI_WTIME()
      IERR(1) = 0
      IERR(2) = 0

      NX2=(NX+2)/2
      LX2=LX/2

! *** ERROR CHECK
! ++ (1) NX,NY,NZ
      IF(  NX .LT. 2 .OR.
     &     NY .LT. 2 .OR. 
     &     NZ .LT. 2     )THEN
         IERR(1)=3000
         GOTO 999
      ENDIF

! ++ (2) LX
      IF( MOD(NX,2) .EQ. 1 )THEN
         IF( LX .LT. NX+1 )THEN
            IERR(1)=3010
            GOTO 999
         ENDIF
      ELSE
         IF( LX .LT. NX+2 )THEN
            IERR(1)=3010
            GOTO 999
         ENDIF
      ENDIF

! ++ (3) LY,LZ
      IF(  LY .LT. LY_D*ISIZE .OR.
     &     LZ .LT. LZ_D*ISIZE )THEN
         IERR(1)=3020
         GOTO 999
      ENDIF

! ++ (4) LY_d,LZ_d
      IF(  LY_d .LT. NY_d .OR.
     &     LZ_d .LT. NZ_d      )THEN
         IERR(1)=3030
         GOTO 999
      ENDIF

! ++ (5) MOD(LX,2) 
      IF( MOD(LX,2) .EQ. 1 )THEN
         IERR(1)=3040
         GOTO 999
      ENDIF

! ++ (6) NT
      IF( NT .LT. 1 )THEN
         IERR(1)=3050
         GOTO 999
      ENDIF

! ++ (7) index
      IF(  index .LT. 2 .OR.
     &     index .GT. 3      )THEN
         IERR(1)=3100
         GOTO 999
      ENDIF

! *** ONLY DATA TRANS ***
      IF( ISW .EQ. 0 ) THEN
         T1 = MPI_WTIME()
         if(index.eq.2) then
            CALL FFT_TRANS_YZ(A,LX2,LY,LY_D,NY_D,NZ_D,B,FFT_WORLD,IERR)
         elseif(index.eq.3) then
            CALL FFT_TRANS_ZY(A,LX2,LY,LY_D,NY_D,NZ_D,B,FFT_WORLD,IERR)
         endif
         T2 = MPI_WTIME()
         TIME(4) = T2 - T1
         TIME(5) = T2 - T1
         RETURN
      ENDIF

! *** MEMORY ALLOCATE ***
      NNMAX=MAX(NX,NY,NZ)
      ALLOCATE( TRIGS(NNMAX),STAT=IERR(2) )
      IF( IERR(2) .NE. 0 )THEN
         IERR(1)=7000
         GOTO 999
      ENDIF
#if MKLFFT
      NNMAX=MAX(LX*LY*LZ_D,LX*LY_D*LZ)
      ALLOCATE( C(0:NNMAX-1),STAT=IERR(2) )
      IF( IERR(2) .NE. 0 )THEN
         IERR(1)=7001
         GOTO 999
      ENDIF
#endif

      if(isw.eq.1) then
!!!!! forward(real to half complex FFT)

      if(index.eq.2) then !!! *** Y==>Z ***

! *** X - FFT ( REAL ) *** A( NX, NY_D, NZ )
      T1=MPI_WTIME()
#ifdef ASLFFT
      if (mod(lx,4).eq.0) then
        ll=nz
        if(mod(nz,2).ne.0 .and. (lz.gt.nz)) then
          ll=ll+1
        endif
        call transb(a,lx,b,ly_d*ll,nx+2,ly_d*nz,nt)
        CALL QFRMFB(
     &       NX, LY_D*NZ, B, ly_d*ll, 1,
     &       ISW,  IFAX, TRIGS,
     &       A, NT, IERR(1) )
        call transb(b,ly_d*ll,a,lx,ly_d*nz,nx+2,nt)
      else
        CALL QFRMFB(
     &       NX, LY_D*NZ, A, 1, LX,
     &       ISW,  IFAX, TRIGS,
     &       B, NT, IERR(1) )
      endif
#elif SRFFT
      n=NX
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      iopt(1)=1
      iopt(2)=1
      iopt(3)=1
      nwkw=1
      call hdfz5m(A,LX,LY_D*NZ,NX,ip,LY_D*NZ,iopt,trigs,B,nwkw,ierr(1))
#elif FFTW3
      NFFTW3(1) = NX
      NEREAL(1) = LX
      NEMBED(1) = LX2
      call dfftw_plan_many_dft_r2c
     &     (PLAN,FFTW_RANK,NFFTW3,LY_D*NZ,
     &      A,NEREAL,1,LX,
     &      A,NEMBED,1,LX2,
     &      FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_REAL, 1, NX)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, LY_D*NZ)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, LX)
      Status = DftiCommitDescriptor(Desc_Handle)
      Status = DftiComputeForward(Desc_Handle,A)
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
      TIME(1)=MPI_WTIME() - T1
!     write(*,*)'xfft ierr=',ierr(1)
      IF( IERR(1) .GE. 4000 )THEN
         IERR(1)=4000
         GOTO 999
      ENDIF

! *** Z - FFT ( COMPLEX ) *** A( NX, NY_D, NZ )
      T1=MPI_WTIME()
#ifdef ASLFFT
      CALL HFCMFB(
     &     NZ, LX2*NY_D, A, LX2*LY_D, 1,
     &     ISW, IFAX, TRIGS,
     &     B, NT, IERR(1) )
#elif SRFFT
      n=NZ
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      iopt(1)=1
      iopt(2)=1
      iopt(3)=2
      nwkw=1
      call hzft5s(A,LX2*LY_D,NZ,NZ,ip,LX2*NY_D,
     &            iopt,trigs,B,nwkw,IERR(1))
#elif FFTW3
      NFFTW3(1) = NZ
      NEMBED(1) = LZ
      call dfftw_plan_many_dft
     &     (PLAN,FFTW_RANK,NFFTW3,LX2*NY_D,
     &      A,NEMBED,LX2*LY_D,1,
     &      A,NEMBED,LX2*LY_D,1,
     &      ISWFFTW,FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_COMPLEX, 1, NZ)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, LX2*NY_D)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, 1)
      Stride(1)=0
      Stride(2)=LX2*LY_D
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_STRIDES, Stride)
      Status = DftiCommitDescriptor(Desc_Handle)
!!!!  next line may not be working, because A and B are real array....
      call DCOPY(LZ*LX2*LY_D*2,A,1,C,1)
      Status = DftiComputeForward(Desc_Handle,C)
      call DCOPY(LZ*LX2*LY_D*2,C,1,A,1)
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
      TIME(3)=MPI_WTIME() - T1
!     write(*,*)'zfft ierr=',ierr(1)
      IF( IERR(1) .GE. 4000 )THEN
         IERR(1)=4000
         GOTO 999
      ENDIF

!     write(*,*) 'fft_rc3d'

! *** DATA TRANSPOSE *** Y==>Z
      T1=MPI_WTIME()
      CALL FFT_TRANS_YZ(A,LX2,LY,LY_D,NY_D,NZ_D,B,FFT_WORLD,IERR)
      TIME(4)=MPI_WTIME() - T1
      IF( IERR(1) .GE. 4000 )THEN
         IERR(1)=4000
         GOTO 999
      ENDIF

! *** Y FFT  ( COMPLEX ) *** A( NX2, NY, NZ_D )
      T1=MPI_WTIME()
!CDIR PARALLEL DO PRIVATE(I,J,K)
      DO K=0,NZ_D-1
      DO J=0,NY-1
      DO I=0,NX2*2-1
         B(I+K*NX2*2+J*NX2*2*NZ_D)=A(I+J*LX+K*LX*LY)
      ENDDO
      ENDDO
      ENDDO
#ifdef ASLFFT
      CALL HFCMFB(NY,NX2*NZ_D,B,NX2*NZ_D,1,ISW,IFAX,TRIGS,A,NT,KERR)
#elif SRFFT
      n=NY
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      iopt(1)=1
      iopt(2)=1
      iopt(3)=2
      nwkw=1
      call hzft5s(B,NX2*NZ_D,NY,NY,ip,NX2*NZ_D,
     &            iopt,trigs,A,nwkw,IERR(1))
#elif FFTW3
      NFFTW3(1) = NY
      NEMBED(1) = NY
      call dfftw_plan_many_dft
     &     (PLAN,FFTW_RANK,NFFTW3,NX2*NZ_D,
     &      B,NEMBED,NX2*NZ_D,1,
     &      B,NEMBED,NX2*NZ_D,1,
     &      ISWFFTW,FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_COMPLEX, 1, NY)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, NX2*NZ_D)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, 1)
      Stride(1)=0
      Stride(2)=NX2*NZ_D
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_STRIDES, Stride)
      Status = DftiCommitDescriptor(Desc_Handle)
!!!!  next line may not be working, because A and B are real array....
      call DCOPY(NY*NX2*NZ_D*2,B,1,C,1)
      Status = DftiComputeForward(Desc_Handle,C)
      call DCOPY(NY*NX2*NZ_D*2,C,1,B,1)
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
!CDIR PARALLEL DO PRIVATE(I,J,K)
      DO K=0,NZ_D-1
      DO J=0,NY-1
      DO I=0,NX2*2-1
         A(I+J*LX+K*LX*LY)=B(I+K*NX2*2+J*NX2*2*NZ_D)
      ENDDO
      ENDDO
      ENDDO
      IF( IERR(1) .GE. 4000 )THEN
         IERR(1)=4000
         TIME(2)=MPI_WTIME() - T1
         GOTO 999
      ENDIF
      TIME(2)=MPI_WTIME() - T1
!     write(*,*)'yfft ierr=',ierr(1)

      elseif(index.eq.3) then !!! *** Z==>Y ***

! *** X - FFT ( REAL ) *** A( NX, NY, NZ_D )
      T1=MPI_WTIME()
#ifdef ASLFFT
      if (mod(lx,4).eq.0) then
        ll_d=nz_d
        if(mod(nz_d,2).ne.0 .and. (lz_d.gt.nz_d)) then
          ll_d=ll_d+1
        endif
        call transb(a,lx,b,ly*ll_d,nx+2,ly*nz_d,nt)
        CALL QFRMFB(
     &       NX, LY*NZ_D, B, ly*ll_d, 1,
     &       ISW,  IFAX, TRIGS,
     &       A, NT, IERR(1) )
        call transb(b,ly*ll_d,a,lx,ly*nz_d,nx+2,nt)
      else
        CALL QFRMFB(
     &       NX, LY*NZ_D, A, 1, LX,
     &       ISW,  IFAX, TRIGS,
     &       B, NT, IERR(1) )
      endif
#elif SRFFT
      n=NX
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      iopt(1)=1
      iopt(2)=1
      iopt(3)=1
      nwkw=1
      call hdfz5m(A,LX,LY*NZ_D,NX,ip,LY*NZ_D,iopt,trigs,B,nwkw,ierr(1))
#elif FFTW3
      NFFTW3(1) = NX
      NEREAL(1) = LX
      NEMBED(1) = LX2
      call dfftw_plan_many_dft_r2c
     &     (PLAN,FFTW_RANK,NFFTW3,LY*NZ_D,
     &      A,NEREAL,1,LX,
     &      A,NEMBED,1,LX2,
     &      FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_REAL, 1, NX)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, LY*NZ_D)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, LX)
      Status = DftiCommitDescriptor(Desc_Handle)
      Status = DftiComputeForward(Desc_Handle,A)
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
      TIME(1)=MPI_WTIME() - T1
      IF( IERR(1) .GE. 4000 )THEN
         IERR(1)=4000
         GOTO 999
      ENDIF

! *** Y - FFT ( COMPLEX ) *** A( NX2, NY, NZ_D )
      T1=MPI_WTIME()
!CDIR PARALLEL DO PRIVATE(I,J,K)
      DO K=0,NZ_D-1
      DO J=0,NY-1
      DO I=0,NX2*2-1
         B(I+K*NX2*2+J*NX2*2*NZ_D)=A(I+J*LX+K*LX*LY)
      ENDDO
      ENDDO
      ENDDO
#ifdef ASLFFT
      CALL HFCMFB(NY,NX2*NZ_D,B,NX2*NZ_D,1,ISW,IFAX,TRIGS,A,NT,KERR)
#elif SRFFT
      n=NY
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      iopt(1)=1
      iopt(2)=1
      iopt(3)=2
      nwkw=1
      call hzft5s(B,NX2*NZ_D,NY,NY,ip,NX2*NZ_D,
     &            iopt,trigs,A,nwkw,IERR(1))
#elif FFTW3
      NFFTW3(1) = NY
      NEMBED(1) = NY
      call dfftw_plan_many_dft
     &     (PLAN,FFTW_RANK,NFFTW3,NX2*NZ_D,
     &      B,NEMBED,NX2*NZ_D,1,
     &      B,NEMBED,NX2*NZ_D,1,
     &      ISWFFTW,FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_COMPLEX, 1, NY)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, NX2*NZ_D)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, 1)
      Stride(1)=0
      Stride(2)=NX2*NZ_D
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_STRIDES, Stride)
      Status = DftiCommitDescriptor(Desc_Handle)
!!!!  next line may not be working, because A and B are real array....
      call DCOPY(NY*NX2*NZ_D*2,B,1,C,1)
      Status = DftiComputeForward(Desc_Handle,C)
      call DCOPY(NY*NX2*NZ_D*2,C,1,B,1)
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
!CDIR PARALLEL DO PRIVATE(I,J,K)
      DO K=0,NZ_D-1
      DO J=0,NY-1
      DO I=0,NX2*2-1
         A(I+J*LX+K*LX*LY)=B(I+K*NX2*2+J*NX2*2*NZ_D)
      ENDDO
      ENDDO
      ENDDO
      IF( IERR(1) .GE. 4000 )THEN
         IERR(1)=4000
         TIME(2)=MPI_WTIME() - T1
         GOTO 999
      ENDIF
      TIME(2)=MPI_WTIME() - T1

!     write(*,*) 'fft_rc3d'

! *** MPI TRANSPOSE *** Z==Y
      T1=MPI_WTIME()
      CALL FFT_TRANS_ZY(A,LX2,LY,LY_D,NY_D,NZ_D,B,FFT_WORLD,IERR)
      TIME(4)=MPI_WTIME() - T1
      IF( IERR(1) .GE. 4000 )THEN
         IERR(1)=4000
         GOTO 999
      ENDIF

! *** Z FFT ( COMPLEX ) *** A( NX, NY_D, NZ )
      T1=MPI_WTIME()
#ifdef ASLFFT
      CALL HFCMFB(
     &     NZ, LX2*NY_D, A, LX2*LY_D, 1,
     &     ISW,  IFAX, TRIGS,
     &     B, NT, IERR(1) )
#elif SRFFT
      n=NZ
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      iopt(1)=1
      iopt(2)=1
      iopt(3)=2
      nwkw=1
      call hzft5s(A,LX2*LY_D,NZ,NZ,ip,LX2*NY_D,
     &            iopt,trigs,B,nwkw,IERR(1))
#elif FFTW3
      NFFTW3(1) = NZ
      NEMBED(1) = LZ
      call dfftw_plan_many_dft
     &     (PLAN,FFTW_RANK,NFFTW3,LX2*NY_D,
     &      A,NEMBED,LX2*LY_D,1,
     &      A,NEMBED,LX2*LY_D,1,
     &      ISWFFTW,FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_COMPLEX, 1, NZ)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, LX2*NY_D)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, 1)
      Stride(1)=0
      Stride(2)=LX2*LY_D
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_STRIDES, Stride)
      Status = DftiCommitDescriptor(Desc_Handle)
!!!!  next line may not be working, because A and B are real array....
      call DCOPY(LZ*LX2*LY_D*2,A,1,C,1)
      Status = DftiComputeForward(Desc_Handle,C)
      call DCOPY(LZ*LX2*LY_D*2,C,1,A,1)
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
      TIME(3)=MPI_WTIME() - T1
      IF( IERR(1) .GE. 4000 )THEN
         IERR(1)=4000
         GOTO 999
      ENDIF

      endif

      else
!!!!! backward(half complex to real FFT)

      if(index.eq.2) then !!! *** Y==>Z ***

! *** Z FFT ( COMPLEX ) *** A( NX2, NY_D, NZ )

!     write(*,*) 'cr3d zfft yz'
      T1=MPI_WTIME()
#ifdef ASLFFT
      CALL HFCMFB(
     &     NZ, LX2*NY_D, A, LX2*LY_D, 1,
     &     ISW,  IFAX, TRIGS,
     &     B, NT, IERR(1) )
#elif SRFFT
      n=NZ
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      iopt(1)=2
      iopt(2)=1
      iopt(3)=2
      nwkw=1
      call hzft5s(A,LX2*LY_D,NZ,NZ,ip,LX2*NY_D,
     &            iopt,trigs,B,nwkw,IERR(1))
#elif FFTW3
      NFFTW3(1) = NZ
      NEMBED(1) = LZ
      call dfftw_plan_many_dft
     &     (PLAN,FFTW_RANK,NFFTW3,LX2*NY_D,
     &      A,NEMBED,LX2*LY_D,1,
     &      A,NEMBED,LX2*LY_D,1,
     &      ISWFFTW,FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_COMPLEX, 1, NZ)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, LX2*NY_D)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, 1)
      Stride(1)=0
      Stride(2)=LX2*LY_D
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_STRIDES, Stride)
      Status = DftiCommitDescriptor(Desc_Handle)
!!!!  next line may not be working, because A and B are real array....
      call DCOPY(LZ*LX2*LY_D*2,A,1,C,1)
      Status = DftiComputeBackward(Desc_Handle,C)
      call DCOPY(LZ*LX2*LY_D*2,C,1,A,1)
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
      TIME(3)=MPI_WTIME() - T1
      IF( IERR(1) .GE. 4000 )THEN
         IERR(1)=4000
         GOTO 999
      ENDIF

!     write(*,*) 'cr3d trans yz'

! *** DATA TRANSPOSE *** Y==>Z
      T1=MPI_WTIME()
      CALL FFT_TRANS_YZ(A,LX2,LY,LY_D,NY_D,NZ_D,B,FFT_WORLD,IERR)
      TIME(4)=MPI_WTIME() - T1
      IF( IERR(1) .NE. 0 )THEN
         GOTO 999
      ENDIF

! *** Y - FFT ( COMPLEX ) *** A( NX2, NY, NZ_D )
!     write(*,*) 'cr3d yfft yz'
      T1=MPI_WTIME()
!CDIR PARALLEL DO PRIVATE(I,J,K)
      DO K=0,NZ_D-1
      DO J=0,NY-1
      DO I=0,NX2*2-1
         B(I+K*NX2*2+J*NX2*2*NZ_D)=A(I+J*LX+K*LX*LY)
      ENDDO
      ENDDO
      ENDDO
#ifdef ASLFFT
      CALL HFCMFB(NY,NX2*NZ_D,B,NX2*NZ_D,1,ISW,IFAX,TRIGS,A,NT,KERR)
#elif SRFFT
      n=NY
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      iopt(1)=2
      iopt(2)=1
      iopt(3)=2
      nwkw=1
      call hzft5s(B,NX2*NZ_D,NY,NY,ip,NX2*NZ_D,
     &            iopt,trigs,A,nwkw,IERR(1))
#elif FFTW3
      NFFTW3(1) = NY
      NEMBED(1) = NY
      call dfftw_plan_many_dft
     &     (PLAN,FFTW_RANK,NFFTW3,NX2*NZ_D,
     &      B,NEMBED,NX2*NZ_D,1,
     &      B,NEMBED,NX2*NZ_D,1,
     &      ISWFFTW,FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_COMPLEX, 1, NY)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, NX2*NZ_D)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, 1)
      Stride(1)=0
      Stride(2)=NX2*NZ_D
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_STRIDES, Stride)
      Status = DftiCommitDescriptor(Desc_Handle)
!!!!  next line may not be working, because A and B are real array....
      call DCOPY(NY*NX2*NZ_D*2,B,1,C,1)
      Status = DftiComputeBackward(Desc_Handle,C)
      call DCOPY(NY*NX2*NZ_D*2,C,1,B,1)
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
!CDIR PARALLEL DO PRIVATE(I,J,K)
      DO K=0,NZ_D-1
      DO J=0,NY-1
      DO I=0,NX2*2-1
         A(I+J*LX+K*LX*LY)=B(I+K*NX2*2+J*NX2*2*NZ_D)
      ENDDO
      ENDDO
      ENDDO
      IF( IERR(1) .GE. 4000 )THEN
         IERR(1)=4000
         TIME(2)=MPI_WTIME() - T1
         GOTO 999
      ENDIF
      TIME(2)=MPI_WTIME() - T1

! *** X - FFT ( REAL ) *** A( NX, NY, NZ_D )
!     write(*,*) 'cr3d xfft yz'
      T1=MPI_WTIME()
#ifdef ASLFFT
      if (mod(lx,4).eq.0) then
        ll_d=nz_d
        if(mod(nz_d,2).ne.0 .and. (lz_d.gt.nz_d)) then
          ll_d=ll_d+1
        endif
        call transb(A,lx,B,ly*ll_d,nx+2,ly*nz_d,nt)
        CALL QFRMFB(
     &       NX, LY*NZ_D, B, ly*ll_d, 1,
     &       ISW,  IFAX, TRIGS,
     &       A, NT, IERR(1) )
        call transb(B,ly*ll_d,A,lx,ly*nz_d,nx+2,nt)
      else
        CALL QFRMFB(
     &       NX, LY*NZ_D, A, 1, LX,
     &       ISW,  IFAX, TRIGS,
     &       B, NT, IERR(1) )
      endif
#elif SRFFT
      n=NX
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      iopt(1)=2
      iopt(2)=1
      iopt(3)=1
      nwkw=1
      call hzfd5m(A,LX,LY*NZ_D,NX,ip,LY*NZ_D,iopt,trigs,B,nwkw,ierr(1))
#elif FFTW3
      NFFTW3(1) = NX
      NEMBED(1) = LX2
      NEREAL(1) = LX
      call dfftw_plan_many_dft_c2r
     &     (PLAN,FFTW_RANK,NFFTW3,LY*NZ_D,
     &      A,NEMBED,1,LX2,
     &      A,NEREAL,1,LX,
     &      FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_REAL, 1, NX)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, LY*NZ_D)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, LX)
      Status = DftiCommitDescriptor(Desc_Handle)
      Status = DftiComputeBackward(Desc_Handle,A)
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
      TIME(1)=MPI_WTIME() - T1
      IF( IERR(1) .GE. 4000 )THEN
         IERR(1)=4000
         GOTO 999
      ENDIF

      elseif(index.eq.3) then !!! *** Z==>Y ***

! *** Y FFT  ( COMPLEX ) *** A( NX2, NY, NZ_D )
!     write(*,*) 'cr3d yfft zy'
      T1=MPI_WTIME()
!CDIR PARALLEL DO PRIVATE(I,J,K)
      DO K=0,NZ_D-1
      DO J=0,NY-1
      DO I=0,NX2*2-1
         B(I+K*NX2*2+J*NX2*2*NZ_D)=A(I+J*LX+K*LX*LY)
      ENDDO
      ENDDO
      ENDDO
#ifdef ASLFFT
      CALL HFCMFB(NY,NX2*NZ_D,B,NX2*NZ_D,1,ISW,IFAX,TRIGS,A,NT,KERR)
#elif SRFFT
      n=NY
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      iopt(1)=2
      iopt(2)=1
      iopt(3)=2
      nwkw=1
      call hzft5s(B,NX2*NZ_D,NY,NY,ip,NX2*NZ_D,
     &            iopt,trigs,A,nwkw,IERR(1))
#elif FFTW3
      NFFTW3(1) = NY
      NEMBED(1) = NY
      call dfftw_plan_many_dft
     &     (PLAN,FFTW_RANK,NFFTW3,NX2*NZ_D,
     &      B,NEMBED,NX2*NZ_D,1,
     &      B,NEMBED,NX2*NZ_D,1,
     &      ISWFFTW,FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_COMPLEX, 1, NY)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, NX2*NZ_D)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, 1)
      Stride(1)=0
      Stride(2)=NX2*NZ_D
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_STRIDES, Stride)
      Status = DftiCommitDescriptor(Desc_Handle)
!!!!  next line may not be working, because A and B are real array....
      call DCOPY(NY*NX2*NZ_D*2,B,1,C,1)
      Status = DftiComputeBackward(Desc_Handle,C)
      call DCOPY(NY*NX2*NZ_D*2,C,1,B,1)
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
!CDIR PARALLEL DO PRIVATE(I,J,K)
      DO K=0,NZ_D-1
      DO J=0,NY-1
      DO I=0,NX2*2-1
         A(I+J*LX+K*LX*LY)=B(I+K*NX2*2+J*NX2*2*NZ_D)
      ENDDO
      ENDDO
      ENDDO
      IF( IERR(1) .GE. 4000 )THEN
         IERR(1)=4000
         GOTO 999
      ENDIF
      TIME(2)=MPI_WTIME() - T1

!     write(*,*) 'cr3d trans zy'

! *** DATA TRANSPOSE *** Z==>Y
      T1=MPI_WTIME()
      CALL FFT_TRANS_ZY(A,LX2,LY,LY_D,NY_D,NZ_D,B,FFT_WORLD,IERR)
      TIME(4)=MPI_WTIME() - T1
      IF( IERR(1) .NE. 0 )THEN
         GOTO 999
      ENDIF

! *** Z - FFT ( COMPLEX ) *** A( NX2, NY_D, NZ )
!     write(*,*) 'cr3d zfft zy'
      T1=MPI_WTIME()
#ifdef ASLFFT
      CALL HFCMFB(
     &     NZ, LX2*NY_D, A, LX2*LY_D, 1,
     &     ISW, IFAX, TRIGS,
     &     B, NT, IERR(1) )
#elif SRFFT
      n=NZ
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      iopt(1)=2
      iopt(2)=1
      iopt(3)=2
      nwkw=1
      call hzft5s(A,LX2*LY_D,NZ,NZ,ip,LX2*NY_D,
     &            iopt,trigs,B,nwkw,IERR(1))
#elif FFTW3
      NFFTW3(1) = NZ
      NEMBED(1) = LZ
      call dfftw_plan_many_dft
     &     (PLAN,FFTW_RANK,NFFTW3,LX2*NY_D,
     &      A,NEMBED,LX2*LY_D,1,
     &      A,NEMBED,LX2*LY_D,1,
     &      ISWFFTW,FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_COMPLEX, 1, NZ)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, LX2*NY_D)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, 1)
      Stride(1)=0
      Stride(2)=LX2*LY_D
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_STRIDES, Stride)
      Status = DftiCommitDescriptor(Desc_Handle)
!!!!  next line may not be working, because A and B are real array....
      call DCOPY(LZ*LX2*LY_D*2,A,1,C,1)
      Status = DftiComputeBackward(Desc_Handle,C)
      call DCOPY(LZ*LX2*LY_D*2,C,1,A,1)
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
      TIME(3)=MPI_WTIME() - T1
      IF( IERR(1) .GE. 4000 )THEN
         IERR(1)=4000
         GOTO 999
      ENDIF

! *** X - FFT ( REAL ) *** A( NX, NY_D, NZ )
!     write(*,*) 'cr3d xfft zy'
      T1=MPI_WTIME()
#ifdef ASLFFT
      if (mod(lx,4).eq.0) then
        ll=nz
        if(mod(nz,2).ne.0 .and. (lz.gt.nz)) then
          ll=ll+1
        endif
        call transb(a,lx,b,ly_d*ll,nx+2,ly_d*nz,nt)
        CALL QFRMFB(
     &       NX, LY_D*NZ, B, ly_d*ll, 1,
     &       ISW,  IFAX, TRIGS,
     &       A, NT, IERR(1) )
        call transb(b,ly_d*ll,a,lx,ly_d*nz,nx+2,nt)
      else
        CALL QFRMFB(
     &       NX, LY_D*NZ, A, 1, LX,
     &       ISW,  IFAX, TRIGS,
     &       B, NT, IERR(1) )
      endif
#elif SRFFT
      n=NX
      ip=0
      IFCNT=0
      DO I=1,MAXFAX
        IFACT=NFAX(I)
        DO WHILE (MOD(N,IFACT).EQ.0)
          ip(i)=ip(i)+1
          N=N/IFACT
        ENDDO
        IF(N.EQ.1) EXIT
      ENDDO
      iopt(1)=2
      iopt(2)=1
      iopt(3)=1
      nwkw=1
      call hzfd5m(A,LX,LY_D*NZ,NX,ip,LY_D*NZ,iopt,trigs,B,nwkw,ierr(1))
#elif FFTW3
      NFFTW3(1) = NX
      NEMBED(1) = LX2
      NEREAL(1) = LX
      call dfftw_plan_many_dft_c2r
     &     (PLAN,FFTW_RANK,NFFTW3,LY_D*NZ,
     &      A,NEMBED,1,LX2,
     &      A,NEREAL,1,LX,
     &      FFTW_ESTIMATE)
      call dfftw_execute(PLAN)
      call dfftw_destroy_plan(PLAN)
#elif MKLFFT
      Status = DftiCreateDescriptor(Desc_Handle,DFTI_DOUBLE,
     &         DFTI_REAL, 1, NX)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_NUMBER_OF_TRANSFORMS, LY_D*NZ)
      Status = DftiSetValue(Desc_Handle,
     &         DFTI_INPUT_DISTANCE, LX)
      Status = DftiCommitDescriptor(Desc_Handle)
      Status = DftiComputeBackward(Desc_Handle,A)
      Status = DftiFreeDescriptor(Desc_Handle)
#endif
      TIME(1)=MPI_WTIME() - T1
      IF( IERR(1) .GE. 4000 )THEN
         IERR(1)=4000
         GOTO 999
      ENDIF

      endif

      endif

      DEALLOCATE( TRIGS, STAT=IERR(2) )
      IF( IERR(2) .NE. 0 )THEN
         IERR(1)=7100
         GOTO 999
      ENDIF

  999 CONTINUE
      TIME(5)=MPI_WTIME() - T0
      RETURN
      END

!     ****************************************************************
!     AUTHORS: T.KOKUBO(NEC), K.TAKADA(NIS), T.FURUTA(NIS), R.SAKA(NIS)
!
!     REGD. ON 03/19/02 BY T.K.
!
      subroutine fftflop(nn,m,flops,ierr)
      IMPLICIT NONE
      INTEGER,PARAMETER :: PREC=8
                                !
      INTEGER,INTENT(IN) :: nn,m
      INTEGER,INTENT(OUT) :: ierr
      REAL(KIND=PREC),INTENT(OUT) :: flops
                                !
      INTEGER :: IFAX(0:63)
      INTEGER :: I,N,IFACT,IFCNT
      INTEGER,PARAMETER :: MAXFAX = 4
      INTEGER,DIMENSION(MAXFAX) :: NFAX = (/2,4,3,5/)
                                !
      n=nn
      ierr=0
                                !
      IFCNT=0
                                !
      DO I=MAXFAX,1,-1
         IFACT=NFAX(I)
         DO WHILE (MOD(N,IFACT).EQ.0)
            IFCNT=IFCNT+1
            IFAX(IFCNT)=IFACT
            N=N/IFACT
         ENDDO
         IF(N.EQ.1) EXIT
      ENDDO
                                !
      IF(N.NE.1) THEN
         ierr=n
         return
      ENDIF
                                !
      IFAX(0)=IFCNT

      if(ifax(1).eq.2) then
         flops=flops+4.d0*dble(nn)*dble(m)/2.d0
      elseif(ifax(1).eq.3) then
         flops=flops+16.d0*dble(nn)*dble(m)/3.d0
      elseif(ifax(1).eq.4) then
         flops=flops+16.d0*dble(nn)*dble(m)/4.d0
      elseif(ifax(1).eq.5) then
         flops=flops+44.d0*dble(nn)*dble(m)/5.d0
      endif
      do i=2,ifax(0)
         if(ifax(i).eq.2) then
            flops=flops+10.d0*dble(nn)*dble(m)/2.d0
         elseif(ifax(i).eq.3) then
            flops=flops+28.d0*dble(nn)*dble(m)/3.d0
         elseif(ifax(i).eq.4) then
            flops=flops+34.d0*dble(nn)*dble(m)/4.d0
         elseif(ifax(i).eq.5) then
            flops=flops+66.d0*dble(nn)*dble(m)/5.d0
         endif
      enddo

      return
      end

!     ****************************************************************
!     AUTHORS: T.KOKUBO(NEC), K.TAKADA(NIS), T.FURUTA(NIS), R.SAKA(NIS)
!
!  REGD. ON 03/15/02 BY T.F.
!  UPDD. ON 08/31/06 BY T.K.
!
      SUBROUTINE FFT_TRANS_YZ(A,lx,ly,ly_d,ny_d,nz_d,
     &                        B,my_comm_world,IERR)
!
      IMPLICIT NONE
      INCLUDE "mpif.h"
!
      INTEGER,PARAMETER :: PREC=8
      INTEGER,INTENT(IN) :: my_comm_world
      INTEGER,INTENT(IN) :: lx,ly_d,ny_d,nz_d,ly
      INTEGER,INTENT(INOUT) :: IERR(2)
      COMPLEX(KIND=PREC),INTENT(INOUT) :: A(0:*)
      COMPLEX(KIND=PREC),INTENT(INOUT) :: B(0:*)
      COMPLEX(KIND=PREC),DIMENSION(:),ALLOCATABLE :: C
      INTEGER :: I,K,LXYZ_D,IS,IDIST
      INTEGER :: ITAG,IRECV,ISEND,IRANK,ISIZE
      INTEGER :: STATUS(MPI_STATUS_SIZE)
      INTEGER,DIMENSION(:),ALLOCATABLE :: IREQS,IREQR
!
! *** INITIALIZE ***
!
! *** MPI INITIALIZE ***
      CALL MPI_COMM_RANK(MY_COMM_WORLD,IRANK,IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 8000
         RETURN
      ENDIF
      CALL MPI_COMM_SIZE(MY_COMM_WORLD,ISIZE,IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 8000
         RETURN
      ENDIF

      LXYZ_D=LX*LY_D*NZ_D

      ALLOCATE(C(0:LXYZ_D-1),STAT=IERR(2))

      ALLOCATE(IREQS(0:ISIZE-1),STAT=IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 7000
         RETURN
      ENDIF

      ALLOCATE(IREQR(0:ISIZE-1),STAT=IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 7000
         RETURN
      ENDIF

! *** MPI RECIEVE ***
      DO IS=1,ISIZE-1
         IRECV=MOD(ISIZE+IRANK-IS,ISIZE)
         IDIST=LXYZ_D * IRECV
         ITAG =0
         CALL MPI_IRECV
     &        (B(IDIST),LXYZ_D,MPI_DOUBLE_COMPLEX,
     &         IRECV,ITAG,MY_COMM_WORLD,IREQR(IS),IERR(2))
         IF( IERR(2) .NE. 0 ) THEN
            IERR(1) = 8000
            RETURN
         ENDIF
      ENDDO

      CALL MPI_BARRIER(MY_COMM_WORLD,IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 8000
         RETURN
      ENDIF

! *** MPI SEND ***
      DO IS=1,ISIZE-1
         ISEND=MOD(IRANK+IS,ISIZE)
         IDIST=LXYZ_D * ISEND
         ITAG = 0
         CALL MPI_ISEND
     &        (A(IDIST),LXYZ_D,MPI_DOUBLE_COMPLEX,
     &         ISEND,ITAG,MY_COMM_WORLD,IREQS(IS),IERR(2))
         IF( IERR(2) .NE. 0 ) THEN
            IERR(1) = 8000
            RETURN
         ENDIF
      ENDDO

! *** DATA COPY IN MEMORY ON SAME RANK  ***
!CDIR PARALLEL DO PRIVATE(I,K)
      DO K=0,NZ_D-1
      DO I=0,LX*NY_D-1
         C(I+K*LX*LY_D) = A(I+K*LX*LY_D+LXYZ_D*IRANK)
      ENDDO
      ENDDO

! *** MPI WAIT ***
      DO IS=1,ISIZE-1
         CALL MPI_WAIT(IREQS(IS), STATUS, IERR(2))
         IF( IERR(2) .NE. 0 ) THEN
            IERR(1) = 8000
            RETURN
         ENDIF
         CALL MPI_WAIT(IREQR(IS), STATUS, IERR(2))
         IF( IERR(2) .NE. 0 ) THEN
            IERR(1) = 8000
            RETURN
         ENDIF
      ENDDO

! *** DATA COPY ***
!CDIR PARALLEL DO PRIVATE(I,K,IS,IRECV)
         DO K=0,NZ_D-1
      DO IS=1,ISIZE-1
         IRECV=MOD(ISIZE+IRANK-IS,ISIZE)
         DO I=0,LX*NY_D-1
            A(I+K*LX*LY+LX*NY_D*IRECV) = B(I+K*LX*LY_D+LXYZ_D*IRECV)
         ENDDO
      ENDDO
         ENDDO

! *** DATA COPY IN MEMORY ON SAME RANK  ***
!CDIR PARALLEL DO PRIVATE(I,K)
      DO K=0,NZ_D-1
      DO I=0,LX*NY_D-1
         A(I+K*LX*LY+LX*NY_D*IRANK) = C(I+K*LX*LY_D)
      ENDDO
      ENDDO
!edit_s(end  : sendrecv NO TYPE)------------------------------
 
      DEALLOCATE(C,STAT=IERR(2))
      DEALLOCATE(IREQS,STAT=IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 7100
         RETURN
      ENDIF
      DEALLOCATE(IREQR,STAT=IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 7100
         RETURN
      ENDIF
!     write(*,*) 'done fft_trans_yz'
!     write(*,*) 'done fft_trans_yz',irank
!     CALL MPI_BCAST(i,1,mpi_integer,0,MY_COMM_WORLD,IERR(2))
      RETURN
      END SUBROUTINE FFT_TRANS_YZ
!
      SUBROUTINE FFT_TRANS_ZY(A,lx,ly,ly_d,ny_d,nz_d,
     &                        B,my_comm_world,IERR)
!
      IMPLICIT NONE
      INCLUDE "mpif.h"
!
      INTEGER,PARAMETER :: PREC=8
      INTEGER,INTENT(IN) :: my_comm_world
      INTEGER,INTENT(IN) :: lx,ly_d,ny_d,nz_d,ly
      INTEGER,INTENT(INOUT) :: IERR(2)
      COMPLEX(KIND=PREC),INTENT(INOUT) :: A(0:*)
      COMPLEX(KIND=PREC),INTENT(INOUT) :: B(0:*)
      COMPLEX(KIND=PREC),DIMENSION(:),ALLOCATABLE :: C
      INTEGER :: I,K,LXYZ_D,IS,IDIST
      INTEGER :: ITAG,IRECV,ISEND,IRANK,ISIZE
      INTEGER :: STATUS(MPI_STATUS_SIZE)
      INTEGER,DIMENSION(:),ALLOCATABLE :: IREQS,IREQR
!
! *** INITIALIZE ***
!
! *** MPI INITIALIZE ***
      CALL MPI_COMM_RANK(MY_COMM_WORLD,IRANK,IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 8000
         RETURN
      ENDIF
      CALL MPI_COMM_SIZE(MY_COMM_WORLD,ISIZE,IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 8000
         RETURN
      ENDIF

      LXYZ_D=LX*LY_D*NZ_D
      ALLOCATE(C(0:LXYZ_D-1),STAT=IERR(2))

      ALLOCATE(IREQS(0:ISIZE-1),STAT=IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 7000
         RETURN
      ENDIF

      ALLOCATE(IREQR(0:ISIZE-1),STAT=IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 7000
         RETURN
      ENDIF

!CDIR PARALLEL DO PRIVATE(I,K,IS,ISEND)
         DO K=0,NZ_D-1
      DO IS=1,ISIZE-1
         ISEND=MOD(IRANK+IS,ISIZE)
         DO I=0,LX*NY_D-1
            B(I+K*LX*LY_D+LXYZ_D*ISEND) = A(I+K*LX*LY+LX*NY_D*ISEND)
         ENDDO
      ENDDO
         ENDDO

! *** DATA COPY ***
!CDIR PARALLEL DO PRIVATE(I,K)
      DO K=0,NZ_D-1
      DO I=0,LX*NY_D-1
         C(I+K*LX*LY_D) = A(I+K*LX*LY+LX*NY_D*IRANK)
      ENDDO
      ENDDO

! *** MPI RECIEVE ***
      DO IS=1,ISIZE-1
         IRECV=MOD(ISIZE+IRANK-IS,ISIZE)
         IDIST=LXYZ_D*IRECV
         ITAG =0
         CALL MPI_IRECV
     &        (A(IDIST),LXYZ_D,MPI_DOUBLE_COMPLEX,
     &         IRECV,ITAG,MY_COMM_WORLD,IREQR(IS),IERR(2))
         IF( IERR(2) .NE. 0 ) THEN
            IERR(1) = 8000
            RETURN
         ENDIF
      ENDDO
      CALL MPI_BARRIER(MY_COMM_WORLD,IERR(2))

! *** MPI SEND ***
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 8000
         RETURN
      ENDIF

      DO IS=1,ISIZE-1
         ISEND=MOD(IRANK+IS,ISIZE)
         IDIST=LXYZ_D*ISEND
         ITAG =0
         CALL MPI_ISEND
     &        (B(IDIST),LXYZ_D,MPI_DOUBLE_COMPLEX,
     &         ISEND,ITAG,MY_COMM_WORLD,IREQS(IS),IERR(2))
!        CALL MPI_SEND
!    &        (B(IDIST),LXYZ_D,MPI_DOUBLE_COMPLEX,
!    &         ISEND,ITAG,MY_COMM_WORLD,IERR(2))
         IF( IERR(2) .NE. 0 ) THEN
            IERR(1) = 8000
            RETURN
         ENDIF
      ENDDO

! *** MPI WAIT ***
      DO IS=1,ISIZE-1
         CALL MPI_WAIT(IREQS(IS), STATUS, IERR(2))
         IF( IERR(2) .NE. 0 ) THEN
            IERR(1) = 8000
            RETURN
         ENDIF
         CALL MPI_WAIT(IREQR(IS), STATUS, IERR(2))
         IF( IERR(2) .NE. 0 ) THEN
            IERR(1) = 8000
            RETURN
         ENDIF
      ENDDO

! *** DATA COPY ***
!!CDIR PARALLEL DO PRIVATE(I,K)
      DO K=0,NZ_D-1
      DO I=0,LX*NY_D-1
         A(I+K*LX*LY_D+LXYZ_D*IRANK) = C(I+K*LX*LY_D) 
      ENDDO
      ENDDO
!edit_s(end  : sendrecv NO TYPE)------------------------------
      DEALLOCATE(C,STAT=IERR(2))
      DEALLOCATE(IREQS,STAT=IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 7100
         RETURN
      ENDIF
      DEALLOCATE(IREQR,STAT=IERR(2))
      IF( IERR(2) .NE. 0 ) THEN
         IERR(1) = 7100
         RETURN
      ENDIF
!     write(*,*) 'done fft_trans_zy',irank
      RETURN
      END SUBROUTINE FFT_TRANS_ZY
      subroutine transb(a,la,b,lb,n1,n2,nt)
      INTEGER,PARAMETER :: PREC=8
      INTEGER,INTENT(IN) :: LA,LB,N1,N2,NT
      REAL(KIND=PREC),INTENT(INOUT) :: A(LA,N2),B(LB,N1)
      INTEGER :: I,J
      IF (N2 .GE. N1) THEN
!cdir pardo for=NT
        DO 70 I=0,N1-1
!cdir noloopchg
          DO 60 J=1,N1-I
            B(J,I+J)=A(I+J,J)
   60     CONTINUE
   70   CONTINUE
!cdir pardo for=NT
        DO 90 I=1,N2-N1
!cdir noloopchg
          DO 80 J=1,N1
            B(I+J,J)=A(J,I+J)
   80     CONTINUE
   90   CONTINUE
!cdir pardo for=NT
        DO 110 I=N2-N1+1,N2-1
!cdir noloopchg
          DO 100 J=1,N2-I
            B(I+J,J)=A(J,I+J)
  100     CONTINUE
  110   CONTINUE
      ELSE
!cdir pardo for=NT
        DO 130 I=0,N2-1
!cdir noloopchg
          DO 120 J=1,N2-I
            B(I+J,J)=A(J,I+J)
  120     CONTINUE
  130   CONTINUE
!cdir pardo for=NT
        DO 150 I=1,N1-N2
!cdir noloopchg
          DO 140 J=1,N2
            B(J,I+J)=A(I+J,J)
  140     CONTINUE
  150   CONTINUE
!cdir pardo for=NT
        DO 170 I=N1-N2+1,N1-1
!cdir noloopchg
          DO 160 J=1,N1-I
            B(J,I+J)=A(I+J,J)
  160     CONTINUE
  170   CONTINUE
      END IF
      RETURN
      END subroutine transb
      subroutine ztransb(a,la,b,lb,n1,n2,nt)
      INTEGER,PARAMETER :: PREC=8
      INTEGER,INTENT(IN) :: LA,LB,N1,N2,NT
      COMPLEX(KIND=PREC),INTENT(INOUT) :: A(LA,N2),B(LB,N1)
      INTEGER :: I,J
      IF (N2 .GE. N1) THEN
!cdir pardo for=NT
        DO 70 I=0,N1-1
!cdir noloopchg
          DO 60 J=1,N1-I
            B(J,I+J)=A(I+J,J)
   60     CONTINUE
   70   CONTINUE
!cdir pardo for=NT
        DO 90 I=1,N2-N1
!cdir noloopchg
          DO 80 J=1,N1
            B(I+J,J)=A(J,I+J)
   80     CONTINUE
   90   CONTINUE
!cdir pardo for=NT
        DO 110 I=N2-N1+1,N2-1
!cdir noloopchg
          DO 100 J=1,N2-I
            B(I+J,J)=A(J,I+J)
  100     CONTINUE
  110   CONTINUE
      ELSE
!cdir pardo for=NT
        DO 130 I=0,N2-1
!cdir noloopchg
          DO 120 J=1,N2-I
            B(I+J,J)=A(J,I+J)
  120     CONTINUE
  130   CONTINUE
!cdir pardo for=NT
        DO 150 I=1,N1-N2
!cdir noloopchg
          DO 140 J=1,N2
            B(J,I+J)=A(I+J,J)
  140     CONTINUE
  150   CONTINUE
!cdir pardo for=NT
        DO 170 I=N1-N2+1,N1-1
!cdir noloopchg
          DO 160 J=1,N1-I
            B(J,I+J)=A(I+J,J)
  160     CONTINUE
  170   CONTINUE
      END IF
      RETURN
      END subroutine ztransb

!     ****************************************************************
!     AUTHORS: T.KOKUBO(NEC), K.TAKADA(NIS), T.FURUTA(NIS), R.SAKA(NIS)
!
!     REGD. ON 02/18/02 BY K.T.
!     UPDD. ON 02/18/02 BY K.T.
!     UPDD. ON 02/25/02 BY K.T.
!     UPDD. ON 03/12/02 BY K.T.
!
!      SUBROUTINE MKDATA_ZFC3FB
      SUBROUTINE MKD_C3D
     &(A,LX,LY,NX,NY,NZ,ID_IN,N_IN,ISW,PARAM,IRANK,NPROC,IERR)
!
      USE m_Const_Parameters, only : PAI
      IMPLICIT NONE
      INTEGER,PARAMETER :: PREC=8
!
! ARGUMENTS
!
      INTEGER,INTENT(IN) :: LX,LY,NX,NY,NZ,ID_IN,N_IN,ISW,IRANK,NPROC
      INTEGER,INTENT(INOUT) :: IERR
      REAL(KIND=PREC),INTENT(IN) :: PARAM(*)
      COMPLEX(KIND=PREC),INTENT(OUT) :: A(*)
!
! FUNCTION:
!
! ALGORITHM:
!
! ARGUMENTS:
!
      REAL(KIND=PREC) :: SW1(20)
      REAL(KIND=PREC),PARAMETER :: PI=PAI
      INTEGER :: NW,I,J,K,II,JJ,KK,NN(3),NSTART(3),NEND(3)
      REAL(KIND=PREC) :: ARG,ARGI,ARGJ,ARGK
      REAL(KIND=PREC),PARAMETER :: C0=0.0D0,C1=1.0D0,C2=2.0D0
      COMPLEX(KIND=PREC) :: WZI,WZJ,WZK,BP,BQ,BR
!F-debug      COMPLEX(KIND=PREC),PARAMETER :: ZC1=(C1,C0)
      COMPLEX(KIND=PREC),PARAMETER :: ZC1=(1.0D0,0.0D0)
      INTEGER :: LXY,IS,JS,KS,IFLAG,JFLAG,KFLAG
!
      IERR = 0
!
      NN(1)=NX
      NN(2)=NY
      NN(3)=NZ
      IF(NN(ID_IN).LT.N_IN) THEN
        IERR=3000
        RETURN
      ENDIF
      IF(N_IN.LE.0) THEN
        IERR=3010
        RETURN
      ENDIF
      IF((IRANK.LT.0).OR.(IRANK.GE.NPROC)) THEN
        IERR=3100
        RETURN
      ENDIF
      IF((ID_IN.LT.1).OR.(ID_IN.GT.3)) THEN
        IERR=3110
        RETURN
      ENDIF
      IF((ISW.LT.-1).OR.(ISW.GT.1)) THEN
        IERR=3200
        RETURN
      ENDIF
!
      NN(1) = NX
      NN(2) = NY
      NN(3) = NZ
      NW=NN(ID_IN)
      NN(ID_IN)=N_IN
      NSTART(1)=1
      NSTART(2)=1
      NSTART(3)=1
      NEND(1)=NN(1)
      NEND(2)=NN(2)
      NEND(3)=NN(3)
      NSTART(ID_IN)=IRANK*NN(ID_IN)+1
      NEND(ID_IN)=MIN(NW,(IRANK+1)*NN(ID_IN))
      LXY=LX*LY
      IF(ISW.EQ.1) THEN
        SW1(1)=-PI*PARAM(1)/REAL(NX,PREC)
        SW1(2)=-PI*PARAM(2)/REAL(NY,PREC)
        SW1(3)=-PI*PARAM(3)/REAL(NZ,PREC)
        DO I=NSTART(1),NEND(1)
          II=I-NSTART(1)+1
          DO J=NSTART(2),NEND(2)
            JJ=J-NSTART(2)+1
            DO K=NSTART(3),NEND(3)
              KK=K-NSTART(3)+1
              ARG=SW1(1)*REAL(I-1,PREC)
     &            +SW1(2)*REAL(J-1,PREC)
     &            +SW1(3)*REAL(K-1,PREC)
              A(II+(JJ-1)*LX+(KK-1)*LXY)=CMPLX(COS(ARG),SIN(ARG))
     &        /(REAL(NX,PREC)*REAL(NY,PREC)*REAL(NZ,PREC))
            ENDDO
          ENDDO
        ENDDO
      ELSE IF(ISW.EQ.-1) THEN
        IF(ABS(PARAM(1)-REAL(INT(PARAM(1)),PREC)).LE.PARAM(4)) THEN
          IFLAG=1
          IS=PARAM(1)
        ELSE
          IFLAG=0
        ENDIF
        IF(ABS(PARAM(2)-REAL(INT(PARAM(2)),PREC)).LE.PARAM(4)) THEN
          JFLAG=1
          JS=PARAM(2)
        ELSE
          JFLAG=0
        ENDIF
        IF(ABS(PARAM(3)-REAL(INT(PARAM(3)),PREC)).LE.PARAM(4)) THEN
          KFLAG=1
          KS=PARAM(3)
        ELSE
          KFLAG=0
        ENDIF
        DO I=NSTART(1),NEND(1)
          II=I-NSTART(1)+1
          ARGI=-PI*(C2*REAL(I-1,PREC)+PARAM(1))
          WZI=ZC1-EXP(CMPLX(C0,ARGI/REAL(NX,PREC)))
          IF((IFLAG.EQ.1).AND.(MOD(IS+2*(I-1),2*NX).EQ.0)) THEN
            BP=REAL(NX,PREC)
          ELSE
            BP=(ZC1-EXP(CMPLX(C0,ARGI,PREC)))/WZI
          ENDIF
          DO J=NSTART(2),NEND(2)
            JJ=J-NSTART(2)+1
            ARGJ=-PI*(C2*REAL(J-1,PREC)+PARAM(2))
            WZJ=ZC1-EXP(CMPLX(C0,ARGJ/REAL(NY,PREC)))
            IF((JFLAG.EQ.1).AND.(MOD(JS+2*(J-1),2*NY).EQ.0)) THEN
              BQ=REAL(NY,PREC)
            ELSE
              BQ=(ZC1-EXP(CMPLX(C0,ARGJ,PREC)))/WZJ
            ENDIF
            DO K=NSTART(3),NEND(3)
              KK=K-NSTART(3)+1
              ARGK=-PI*(C2*REAL(K-1,PREC)+PARAM(3))
              WZK=ZC1-EXP(CMPLX(C0,ARGK/REAL(NZ,PREC)))
              IF((KFLAG.EQ.1).AND.(MOD(KS+2*(K-1),2*NZ).EQ.0)) THEN
                BR=REAL(NZ,PREC)
              ELSE
                BR=(ZC1-EXP(CMPLX(C0,ARGK,PREC)))/WZK
              ENDIF
              A(II+(JJ-1)*LX+(KK-1)*LXY)=BP*BQ*BR
     &        /(REAL(NX,PREC)*REAL(NY,PREC)*REAL(NZ,PREC))
            ENDDO
          ENDDO
        ENDDO
      ENDIF
!
      RETURN
      END

!     ****************************************************************
!     AUTHORS: T.KOKUBO(NEC), K.TAKADA(NIS), T.FURUTA(NIS), R.SAKA(NIS)
!
!     REGD. ON 03/01/02 BY K.T.
!     UPDD. ON 03/12/02 BY K.T.
!     UPDD. ON 03/14/02 BY K.T.
!
!      SUBROUTINE MKDATA_DFR3FB
      SUBROUTINE MKD_R3D
     &(A,LXW,LY,NX,NY,NZ,ID_IN,N_INW,ISW,PARAM,IRANK,NPROC,IERR)
!
      USE m_Const_Parameters, only : PAI
      IMPLICIT  NONE
      INTEGER,PARAMETER :: PREC=8
!
! ARGUMENTS
!
      INTEGER,INTENT(IN) :: LXW,LY,NX,NY,NZ,ID_IN,N_INW
      INTEGER,INTENT(IN) :: ISW,IRANK,NPROC
      INTEGER,INTENT(INOUT) :: IERR
      REAL(KIND=PREC),INTENT(IN) :: PARAM(*)
      REAL(KIND=PREC),INTENT(OUT) :: A(*)
!
! FUNCTION:
!
! ALGORITHM:
!
! ARGUMENTS:
!
      REAL(KIND=PREC) :: ARGX,ARGY,ARG,SW1(20)
      REAL(KIND=PREC),PARAMETER :: C0=0.0D0,C1=1.0D0,C2=2.0D0
      COMPLEX(KIND=PREC) :: WZI,WZI2,WZJ,WZJ2,WZK,WZK2,BP,BQ,BR
!F-debug      COMPLEX(KIND=PREC),PARAMETER :: ZC1=(C1,C0)
      COMPLEX(KIND=PREC),PARAMETER :: ZC1=(1.0D0,0.0D0)
      REAL(KIND=PREC),PARAMETER :: PI=PAI
      INTEGER :: LXY,NW,I,J,K,II,JJ,KK,NN(3),NSTART(3),NEND(3),LX
      INTEGER :: N_IN
!
      IERR = 0
!
      NN(1)=NX
      NN(2)=NY
      NN(3)=NZ
      N_IN=N_INW
      IF(ISW.GT.0) THEN
        LX=LXW
      ELSE
        LX=2*LXW
!       IF(ID_IN.EQ.1) THEN
!         N_IN=2*N_INW
!       ENDIF
      ENDIF
      IF(NN(ID_IN).LT.N_IN) THEN
        IERR=3000
        RETURN
      ENDIF
      IF(N_IN.LE.0) THEN
        IERR=3010
        RETURN
      ENDIF
      IF((IRANK.LT.0).OR.(IRANK.GE.NPROC)) THEN
        IERR=3100
        RETURN
      ENDIF
      IF((ID_IN.LT.1).OR.(ID_IN.GT.3)) THEN
        IERR=3110
        RETURN
      ENDIF
      IF((ISW.LT.-1).OR.(ISW.GT.1)) THEN
        IERR=3200
        RETURN
      ENDIF
!
      IF(ISW.GT.0) THEN
        NN(1) = NX
      ELSE
        NN(1) = (NX+2)/2
      ENDIF
      NN(2) = NY
      NN(3) = NZ
      NW=NN(ID_IN)
      NN(ID_IN)=N_IN
      NSTART(1)=1
      NSTART(2)=1
      NSTART(3)=1
      NEND(1)=NN(1)
      NEND(2)=NN(2)
      NEND(3)=NN(3)
      NSTART(ID_IN)=IRANK*NN(ID_IN)+1
      NEND(ID_IN)=MIN(NW,(IRANK+1)*NN(ID_IN))
      LXY=LX*LY
      IF(ISW.EQ.1) THEN
        SW1(1)=PARAM(1)/REAL(NX,PREC)
        SW1(2)=PARAM(2)/REAL(NY,PREC)
        SW1(3)=PARAM(3)/REAL(NZ,PREC)
        DO I=NSTART(1),NEND(1)
          II=I-NSTART(1)+1
          DO J=NSTART(2),NEND(2)
            JJ=J-NSTART(2)+1
            DO K=NSTART(3),NEND(3)
              KK=K-NSTART(3)+1
              ARG=SW1(1)*REAL(I-1,PREC)
     &            +SW1(2)*REAL(J-1,PREC)
     &            +SW1(3)*REAL(K-1,PREC)
              A(II+(JJ-1)*LX+(KK-1)*LXY)=EXP(ARG)
     &        /(REAL(NX,PREC)*REAL(NY,PREC)*REAL(NZ,PREC))
            ENDDO
          ENDDO
        ENDDO
      ELSE IF(ISW.EQ.-1) THEN
        DO I=NSTART(1),NEND(1)
          II=I-NSTART(1)+1
          ARGX=PARAM(1)
          ARGY=-PI*C2*REAL(I-1,PREC)
          WZI=ZC1-EXP(ARGX/REAL(NX,PREC))*
     &        CMPLX(COS(ARGY/REAL(NX,PREC)),SIN(ARGY/REAL(NX,PREC)))
          WZI2=ZC1-EXP(ARGX)*CMPLX(COS(ARGY),SIN(ARGY))
          IF(ABS(WZI).LT.PARAM(4)) THEN
            BP=ZC1
          ELSE
            BP=WZI2/(WZI*REAL(NX,PREC))
          ENDIF
          DO J=NSTART(2),NEND(2)
            JJ=J-NSTART(2)+1
            ARGX=PARAM(2)
            ARGY=-PI*C2*REAL(J-1,PREC)
            WZJ=ZC1-EXP(ARGX/REAL(NY,PREC))*
     &        CMPLX(COS(ARGY/REAL(NY,PREC)),SIN(ARGY/REAL(NY,PREC)))
            WZJ2=ZC1-EXP(ARGX)*CMPLX(COS(ARGY),SIN(ARGY))
            IF(ABS(WZJ).LT.PARAM(4)) THEN
              BQ=ZC1
            ELSE
              BQ=WZJ2/(WZJ*REAL(NY,PREC))
            ENDIF
            DO K=NSTART(3),NEND(3)
              KK=K-NSTART(3)+1
              ARGX=PARAM(3)
              ARGY=-PI*C2*REAL(K-1,PREC)
              WZK=ZC1-EXP(ARGX/REAL(NZ,PREC))*
     &        CMPLX(COS(ARGY/REAL(NZ,PREC)),SIN(ARGY/REAL(NZ,PREC)))
              WZK2=ZC1-EXP(ARGX)*CMPLX(COS(ARGY),SIN(ARGY))
              IF(ABS(WZK).LT.PARAM(4)) THEN
                BR=ZC1
              ELSE
                BR=WZK2/(WZK*REAL(NZ,PREC))
              ENDIF
              A(2*II-1+(JJ-1)*LX+(KK-1)*LXY)=REAL(BP*BQ*BR,PREC)
              A(2*II+(JJ-1)*LX+(KK-1)*LXY)=DIMAG(BP*BQ*BR)
            ENDDO
          ENDDO
        ENDDO
      ENDIF
!
      RETURN
      END

!-----------------------------------------------------------------------!
!     Module Spg_plus_Tetra/Common_Blocks ver.1.0
!
!     Author : T. Hamada
!   
!     December 20, 2021
!
!     This module is a dummy module containing global variales
!     used by subroutinnes of spg+tetra.F90. The variables are
!     the common block variables used by spg+tetra.F subroutines.
!     This module also contains logical variables and constants
!     used by the spg+tetra.F90 subroutines.
! --------------------------------------------------------------------
      module m_Spg_plus_Tetra_Common_Blocks
! nspg00
         character(len=5), dimension(48) :: schoen
         character(len=2), dimension(3,48) :: jones
! nspg0
         integer :: ng0_0
         integer, dimension(3,24) :: ieuler
         integer, dimension(3,3,48) :: irot
         integer, dimension(48,48) :: im0
         integer, dimension(48) :: iv0
         integer, dimension(3,48) :: ir1234
         real(kind=8), dimension(3,24) :: euler
         real(kind=8), dimension(3,3,48) :: rot

! nspg2
         integer :: ig02, iv02
         integer, dimension(3) :: ieule2, ieulv2
         integer, dimension(3,3) :: irotr2, irotk2
         real(kind=8), dimension(3) :: eeule2, eeulv2

! nspg03
         real(kind=8), dimension(3,3) :: tca, tac, tab, tba, tcb, tbc

! nspg04

         real(kind=8), dimension(3,3) :: grc, gkc, gra, gka, grb, gkb
! nspg06
         integer :: id0, il, ng0, ng1
         integer, dimension(48) :: ig01, iv1
         integer, dimension(48,48) :: im1
         integer, dimension(3,3,48) :: lra1, lsa1, lrb1, lsb1
         real(kind=8), dimension(3,48) :: ta1, tb1
! nspg07
         integer, dimension(48) :: inver1
         real(kind=8), dimension(3,48) :: euler1

! spg1
         integer, dimension(3,48) :: it
         integer, dimension(48,48) :: im
         integer, dimension(48) :: iv

! spg2
         integer :: il9, ng9
         integer, dimension(48) :: ig0
         integer, dimension(2,3,48) :: jv

! ntcntr
         integer :: ncounter, ncounter1, ncounter2, ncounter3

! ipr
         integer, dimension(10,2) :: ipa

! logical
         logical :: nstt3i_called = .false.
         logical :: nstt1i_flag = .false.
         logical :: nskpb0_s_called = .false.
         logical :: nskp00_called = .false.
         logical :: ka00_called = .false.
         logical  :: nskma0_called = .false.
         logical :: tet_sub_called =  .false.
         logical :: ip0_index_generated = .false.
         logical :: tbspg_called = .false.
         logical :: tbspg_kt_called = .false.
         logical :: setkp0_default_n_called = .false.
         logical :: setkp0_default_n_kt_called = .false.

! nsdos0 and nstt1i
         integer :: npx, npy, npz, np, ntet, ncub
         integer, allocatable, dimension(:) :: ip0_index1
         integer, dimension(2,2,2) :: ip0_index2
         real(kind=8) :: rntet_1
         real(kind=8) :: tetra_eps = 1.0d-4

! constant
         real(kind=8) :: factor_1_3 = 1.0d0/3.0d0
         real(kind=8) :: factor_1_12 = 1.0d0/12.0d0
         contains
         subroutine dummy
         end subroutine dummy
      end  module m_Spg_plus_Tetra_Common_Blocks

*> \brief <b> DPOSV computes the solution to system of linear equations A * X = B for PO matrices</b>
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*> \htmlonly
*> Download DPOSV + dependencies
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dposv.f">
*> [TGZ]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dposv.f">
*> [ZIP]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dposv.f">
*> [TXT]</a>
*> \endhtmlonly
*
*  Definition:
*  ===========
*
*       SUBROUTINE DPOSV( UPLO, N, NRHS, A, LDA, B, LDB, INFO )
*
*       .. Scalar Arguments ..
*       CHARACTER          UPLO
*       INTEGER            INFO, LDA, LDB, N, NRHS
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DPOSV computes the solution to a real system of linear equations
*>    A * X = B,
*> where A is an N-by-N symmetric positive definite matrix and X and B
*> are N-by-NRHS matrices.
*>
*> The Cholesky decomposition is used to factor A as
*>    A = U**T* U,  if UPLO = 'U', or
*>    A = L * L**T,  if UPLO = 'L',
*> where U is an upper triangular matrix and L is a lower triangular
*> matrix.  The factored form of A is then used to solve the system of
*> equations A * X = B.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>          = 'U':  Upper triangle of A is stored;
*>          = 'L':  Lower triangle of A is stored.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of linear equations, i.e., the order of the
*>          matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in] NRHS
*> \verbatim
*>          NRHS is INTEGER
*>          The number of right hand sides, i.e., the number of columns
*>          of the matrix B.  NRHS >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is DOUBLE PRECISION array, dimension (LDA,N)
*>          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
*>          N-by-N upper triangular part of A contains the upper
*>          triangular part of the matrix A, and the strictly lower
*>          triangular part of A is not referenced.  If UPLO = 'L', the
*>          leading N-by-N lower triangular part of A contains the lower
*>          triangular part of the matrix A, and the strictly upper
*>          triangular part of A is not referenced.
*>
*>          On exit, if INFO = 0, the factor U or L from the Cholesky
*>          factorization A = U**T*U or A = L*L**T.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,N).
*> \endverbatim
*>
*> \param[in,out] B
*> \verbatim
*>          B is DOUBLE PRECISION array, dimension (LDB,NRHS)
*>          On entry, the N-by-NRHS right hand side matrix B.
*>          On exit, if INFO = 0, the N-by-NRHS solution matrix X.
*> \endverbatim
*>
*> \param[in] LDB
*> \verbatim
*>          LDB is INTEGER
*>          The leading dimension of the array B.  LDB >= max(1,N).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*>          > 0:  if INFO = i, the leading minor of order i of A is not
*>                positive definite, so the factorization could not be
*>                completed, and the solution has not been computed.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \ingroup doublePOsolve
*
*  =====================================================================
      SUBROUTINE DPOSV( UPLO, N, NRHS, A, LDA, B, LDB, INFO )
*
*  -- LAPACK driver routine --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
*     ..
*
*  =====================================================================
*
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DPOTRF, DPOTRS, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( .NOT.LSAME( UPLO, 'U' ) .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DPOSV ', -INFO )
         RETURN
      END IF
*
*     Compute the Cholesky factorization A = U**T*U or A = L*L**T.
*
      CALL DPOTRF( UPLO, N, A, LDA, INFO )
      IF( INFO.EQ.0 ) THEN
*
*        Solve the system A*X = B, overwriting B with X.
*
         CALL DPOTRS( UPLO, N, NRHS, A, LDA, B, LDB, INFO )
*
      END IF
      RETURN
*
*     End of DPOSV
*
      END

module m_ES_WF_mixing

  use m_Control_Parameters,  only : nspin, kimg, af, g0_wf_precon, amin_wf_precon, &
       &                            ndim_magmom, noncol
  use m_Const_Parameters,  only : BUCS, DP
  use m_Crystal_Structure,   only : rltv
  use m_KPoints,             only : kv3, vkxyz
  use m_PlaneWaveBasisSet,  only : ngabc, iba, nbase, ngabc, kg1
  use m_Parallelization,     only : MPI_CommGroup, mype, myrank_k, map_k, &
       &                            ista_k, iend_k, np_e

  use m_Electronic_Structure,  only : zaj_l, fsr_l, fsi_l
  use m_ES_nonlocal,       only : m_ES_betar_dot_WFs_4_each_k
  use m_Files,             only : nfout

  use m_Ionic_System,      only : natm
  use m_Charge_Density,   only : hsr, hsro, m_CD_hardpart_hsr, m_CD_hardpart_hsr_noncl
  use m_PseudoPotential,  only : nlmt, nlmta
  use mpi

  implicit none
!  include 'mpif.h'

  real(kind=DP),private,allocatable,dimension(:,:,:,:):: zaj_prev
                                          !d(kg1,np_e,ista_k:iend_k,kimg)

  real(kind=DP), allocatable :: dhsr_precon(:,:,:,:)

contains

  subroutine m_ES_WF_alloc_zaj_prev
    allocate( zaj_prev(kg1,np_e,ista_k:iend_k,kimg) )
  end subroutine m_ES_WF_alloc_zaj_prev

  subroutine m_ES_WF_dealloc_zaj_prev
    deallocate( zaj_prev )
  end subroutine m_ES_WF_dealloc_zaj_prev

  subroutine m_ES_WF_cp_zaj_to_zaj_prev
    integer :: ik, ir

    do ir = 1, kimg
       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle                       ! MPI
          zaj_prev(:,:,ik,ir) = zaj_l(:,:,ik,ir)
       end do
    end do
  end subroutine m_ES_WF_cp_zaj_to_zaj_prev

  subroutine m_ES_WF_alloc_dhsr_precon
    allocate( dhsr_precon(natm,nlmt,nlmt,ndim_magmom) )
    dhsr_precon = 0.0d0
  end subroutine m_ES_WF_alloc_dhsr_precon

  subroutine m_ES_WF_dealloc_dhsr_precon
    deallocate( dhsr_precon )
  end subroutine m_ES_WF_dealloc_dhsr_precon

  subroutine m_ES_WF_kerker_mixing( recover_zaj )
    logical, intent(in) :: recover_zaj

    integer :: ik, i, nb
    real(kind=DP) :: ga, gb, gc, gg, q0
    real(kind=DP) :: factor, fac_min
    real(kind=DP) :: ttr(6)

    real(kind=DP), allocatable :: dzaj(:,:,:,:)
    real(kind=DP), allocatable :: zaj_bkup(:,:,:,:)
    real(kind=DP), allocatable :: fsr_bkup(:,:,:), fsi_bkup(:,:,:)

    q0 = g0_wf_precon **2
    fac_min = amin_wf_precon

    allocate( dzaj( kg1, np_e, ista_k:iend_k, kimg ) )
    dzaj = zaj_l -zaj_prev

    if ( recover_zaj ) then
       allocate( zaj_bkup( kg1, np_e, ista_k:iend_k, kimg ) )
       zaj_bkup = zaj_l

       allocate( fsr_bkup(np_e,nlmta,ista_k:iend_k) );
       fsr_bkup = fsr_l

       allocate( fsi_bkup(np_e,nlmta,ista_k:iend_k) );
       fsi_bkup = fsi_l
    endif

    call getttr(rltv,ttr)

    Do ik=1, kv3
       if(map_k(ik) /= myrank_k) cycle

       do i=1, iba(ik)
          nb = nbase(i,ik)
          ga = vkxyz(ik,1,BUCS) + ngabc(nb,1)
          gb = vkxyz(ik,2,BUCS) + ngabc(nb,2)
          gc = vkxyz(ik,3,BUCS) + ngabc(nb,3)
          gg = ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
               &            + ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga
          factor = max( fac_min, gg /(gg+q0) )
          zaj_l(i,:,ik,:) = zaj_prev(i,:,ik,:) + dzaj(i,:,ik,:)*factor
       end do
    End Do

    Do ik=1, kv3
       if(map_k(ik) /= myrank_k) cycle
       call m_ES_betar_dot_WFs_4_each_k(nfout,ik)
    End Do

    if ( noncol ) then
       call m_CD_hardpart_hsr_noncl(nfout,kv3)
    else
       call m_CD_hardpart_hsr(nfout,kv3)
    endif

    deallocate( dzaj )

    if ( recover_zaj ) then
       zaj_l = zaj_bkup
       fsr_l = fsr_bkup;  fsi_l = fsi_bkup
       deallocate( zaj_bkup )
       deallocate( fsr_bkup );  deallocate( fsi_bkup )
    endif

  end subroutine m_ES_WF_kerker_mixing

  subroutine m_ES_WF_precon_hsr
    integer :: ik, i, nb
    real(kind=DP) :: ga, gb, gc, gg, q0
    real(kind=DP) :: factor, fac_min
    real(kind=DP) :: ttr(6)
    real(kind=DP), allocatable :: dzaj(:,:,:,:)
    real(kind=DP), allocatable :: zaj_bkup(:,:,:,:)
    real(kind=DP), allocatable :: hsr_bkup(:,:,:,:)
    real(kind=DP), allocatable :: fsr_bkup(:,:,:), fsi_bkup(:,:,:)

    q0 = g0_wf_precon **2
    fac_min = amin_wf_precon

    allocate( dzaj( kg1, np_e, ista_k:iend_k, kimg ) )
    dzaj = zaj_l -zaj_prev

    allocate( hsr_bkup(natm,nlmt,nlmt,ndim_magmom) )
    hsr_bkup = hsr

    allocate( zaj_bkup( kg1, np_e, ista_k:iend_k, kimg ) )
    zaj_bkup = zaj_l

    allocate( fsr_bkup(np_e,nlmta,ista_k:iend_k) );
    fsr_bkup = fsr_l

    allocate( fsi_bkup(np_e,nlmta,ista_k:iend_k) );
    fsi_bkup = fsi_l

    call getttr(rltv,ttr)

    Do ik=1, kv3
       if(map_k(ik) /= myrank_k) cycle

       do i=1, iba(ik)
          nb = nbase(i,ik)
          ga = vkxyz(ik,1,BUCS) + ngabc(nb,1)
          gb = vkxyz(ik,2,BUCS) + ngabc(nb,2)
          gc = vkxyz(ik,3,BUCS) + ngabc(nb,3)
          gg = ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
               &            + ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga
          factor = max( fac_min, gg /(gg+q0) )
          zaj_l(i,:,ik,:) = zaj_prev(i,:,ik,:) +dzaj(i,:,ik,:)*factor
       end do
    End Do

    Do ik=1, kv3
       if(map_k(ik) /= myrank_k) cycle
       call m_ES_betar_dot_WFs_4_each_k(nfout,ik)
    End Do

    if ( noncol ) then
       call m_CD_hardpart_hsr_noncl(nfout,kv3)
    else
       call m_CD_hardpart_hsr(nfout,kv3)
    endif

    dhsr_precon = hsr -hsro

    zaj_l = zaj_bkup
    hsr = hsr_bkup
    fsr_l = fsr_bkup;  fsi_l = fsi_bkup

    deallocate( hsr_bkup )
    deallocate( fsr_bkup );  deallocate( fsi_bkup )

    deallocate( dzaj );      deallocate( zaj_bkup )

  end subroutine m_ES_WF_precon_hsr

end module m_ES_WF_mixing

!=======================================================================
!
!  PROGRAM  PHASE/0 2023.01
!
!  SUBROUINE: ChargeDensity_Mixing
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine ChargeDensity_Mixing
! $Id: ChargeDensity_Mixing.F90 615 2020-05-08 13:58:30Z ktagami $
  use m_Const_Parameters,    only : DP,SIMPLE,BROYD1,BROYD2,DFP,PULAY,RMM2P,ON &
       &                          , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, CONTINUATION, SKIP
  use m_Charge_Density,      only : m_CD_check
  use m_CD_mixing,           only : m_CD_simple_mixing, m_CD_prepare_precon &
       &                           ,m_CD_mix_broyden1,m_CD_mix_broyden2,m_CD_mix_DFP &
       &                           ,m_CD_mix_pulay, m_CD_simple_mixing_hsr, m_CD_mixing_write_DEFINITION
  use m_Ionic_System,        only : natm
  use m_Total_Energy,        only : m_TE_what_is_edeltb_now, m_TE_wd_total_energy_with_solvers
  use m_Control_Parameters,  only : c_precon,waymix,intzaj,icond &
       &                          , tag_solver_of_WF_is_found &
       &                          , tag_charge_mixing_is_found &
       &                          , iprichargemixing, nspin, af &
       &                          , m_CtrlP_rmx_now &
       &                          , m_CtrlP_solver_for_WFs_now &
       &                          , m_CtrlP_set_rmx &
       &                          , m_CtrlP_waymix_now &
       &                          , m_CtrlP_set_mix_parameter &
       &                          , m_CtrlP_clear_cdmixing_applied &
       &                          , sw_hubbard, sw_mix_occ_matrix, sw_opencore
  use m_Files,               only : nfout
  use m_IterationNumbers,    only : iteration_electronic, iteration_ionic &
       &                          , m_Iter_cmix_reset
  use m_Orbital_Population,  only : m_OP_simple_mixing, m_OP_mix_broyden1 &
       &                          , m_OP_mix_broyden2, m_OP_mix_DFP, m_OP_mix_pulay
  use m_PseudoPotential,     only : flg_paw, modnrm
  use m_PS_opencore,          only : m_PS_print_core_Magmom_on_atom
! ================================= added by K. Tagami =============== 5.0
  use m_Const_Parameters,    only : OFF
  use m_Control_Parameters,  only : sw_update_charge_total, &
       &                            sw_mix_charge_hardpart, occ_matrix_mixfactor
  use m_Charge_Density,      only : m_CD_cp_hsr_to_hsro
  use m_CD_mixing,           only : m_CD_mix_broyden2_with_hsr, m_CD_mix_pulay_with_hsr &
                                  , m_CD_simple_mixing_hard
  use m_IterationNumbers,     only : iteration, iteration_for_cmix
  use m_Orbital_Population,    only :  m_OP_cp_om_to_ommix
! ==================================================================== 5.0

! ================================= added by K. Tagami ================== 11.0&13.0U
  use m_Control_Parameters,   only : noncol, SpinOrbit_mode
  use m_Charge_Density,       only : m_CD_check_noncl
  use m_CD_Mag_Moment,        only : m_CD_calc_ChgMagMom_in_sphere, &
       &                             m_CD_print_ChgMagmom_on_atom, &
       &                             m_CD_estim_magmom_local, &
       &                             m_CD_print_magmom_local, &
       &                             m_CD_set_rad_cov_now, &
       &                             m_CD_set_rad_cov_default, &
       &                             sw_monitor_atomcharge
  use m_Const_Parameters,      only : Neglected
#ifndef WO_OP_MOMENT
  use m_OP_Moment,             only : m_OP_calc_orbmom_from_OCC
#endif
! ======================================================================== 11.0&13.0U


! === KT_add ========== 13.0U2-3, 13.0XX
  use m_Control_Parameters,  only : sw_modified_TFW_functional, hardpart_mixfactor, &
       &                            precon_hardpart, sw_wf_mixing, &
       &                            wf_mixing_is_active, &
       &                            recover_wf_after_mixing
  use m_Kpoints,         only : kv3
  use m_ES_WF_mixing,     only : m_ES_WF_precon_hsr, m_ES_WF_kerker_mixing
  use m_Charge_Density,     only : m_CD_hardpart_hsr, m_CD_hardpart_hsr_noncl
! ===================== 13.0U2-3, 13.0XX

! ==== KT_add === 2014/09/01
  use m_Control_Parameters, only : sw_calc_orbital_moment, sw_use_add_proj, &
       &                          Orbital_decomp_mode
  use m_Charge_Density,    only : m_CD_hardpart_hsr_add, m_CD_hardpart_hsr_add_noncl
  use m_CD_Mag_Moment,   only : m_CD_calc_SpinMagMom_method2
  use m_OP_Moment,  only :        m_OP_calc_OrbMagMom_method2
! =============== 2014/09/01

! === KT_add ==== 2014/09/19
  use m_Control_Parameters,  only : sw_calc_ekin_density, ekin_density_type, &
       &                            sw_mix_charge_with_ekindens
  use m_CD_mixing,  only : m_CD_mix_broyden2_intg, m_CD_mix_pulay_intg, &
       &                   m_CD_simple_mixing_intg, m_CD_force_dealloc
  use m_KE_mixing,  only : m_KE_simple_mixing, m_KE_mix_broyden2, m_KE_mix_pulay, &
       &                   m_KE_prepare_precon, &
       &                   m_KE_simple_mixing_00, m_KE_kerker_mixing, &
       &                   m_KE_set_pointer_ekinq_00, m_KE_set_pointer_ekinq
! =============== 2014/09/19

  implicit none
  real(kind=DP) :: rmxt
  real(kind=DP) :: edeltb_per_atom
  integer,save  :: waymix_at_CDmix_previous = 0
  integer       :: waymix_at_CDmix
  logical       :: ini = .false., mixer_changed
  real(kind=DP) :: rmxt_tot, rmxt_hard, rmxt_occmat
  integer,save :: definition_check_in_m_CD_mixing = 0
  interface
     subroutine Renewal_of_OccMat( flag, mode, skip )
        logical flag, skip
        integer mode
        optional :: skip
     end subroutine
  end interface
#ifdef __TIMER_SUB__
    call timer_sta(1101)
#endif
  call m_CtrlP_clear_cdmixing_applied()

  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
!      call procedure_charge_fixed;  return
      return
  endif

  if(iprichargemixing>=1) then
     if(definition_check_in_m_CD_mixing == 0) then
        call m_CD_mixing_write_DEFINITION(nfout)
        definition_check_in_m_CD_mixing = 1
     end if
  end if

  edeltb_per_atom = m_TE_what_is_edeltb_now()/natm 
  waymix_at_CDmix = m_CtrlP_waymix_now(iteration_electronic, iteration_ionic &
       &                             , edeltb_per_atom,mixer_changed)
  if(mixer_changed) call m_CD_force_dealloc()
  if(tag_solver_of_WF_is_found .and. tag_charge_mixing_is_found) then
     if(waymix_at_CDmix_previous /= waymix_at_CDmix) call m_Iter_cmix_reset()
  end if

  rmxt = m_CtrlP_rmx_now(iteration_electronic, iteration_ionic)
  call m_CtrlP_set_mix_parameter()
  if(c_precon) call m_CD_prepare_precon(nfout,rmxt)
  if(iprichargemixing >= 2) &
       & write(6,'(" waymix_at_CDmix = ",i4," rmxt = ",f8.4)') waymix_at_CDmix, rmxt

  call push_cd_mixing_name_applied(waymix_at_CDmix)

! ===================== added by K. Tagami========================= 5.0
  if ( sw_update_charge_total == OFF ) then
     iteration_for_cmix = iteration_for_cmix -1
  endif
  if ( iteration <= 1 .or. (icond==CONTINUATION .and. .not.ini))then
     call m_CD_cp_hsr_to_hsro
     ini = .true.
  endif
!
  rmxt_tot = rmxt
  rmxt_hard = rmxt *hardpart_mixfactor
!
  rmxt_occmat = rmxt *occ_matrix_mixfactor
!
! === KT_add === 2014/09/19
  if ( sw_calc_ekin_density == ON .and. ekin_density_type == 0 ) then
     if ( sw_mix_charge_with_ekindens == ON ) then
        call m_KE_set_pointer_ekinq
     else
        call m_KE_set_pointer_ekinq_00
        if ( c_precon ) call m_KE_prepare_precon(nfout,rmxt)
     endif
  endif
! ============= 2014/09/19

  if ( sw_calc_ekin_density == ON .and. ekin_density_type == 0 ) then
     if ( sw_mix_charge_hardpart == OFF ) then
        call mix_charge_total_intg()
        if ( flg_paw ) call mix_charge_only_hsr          !! only exception
        if ( sw_hubbard == ON ) call mix_charge_only_occmat
     else
        if ( precon_hardpart ) call precon_hardpart_kt
        call mix_charge_total_intg()
     endif
     if ( sw_mix_charge_with_ekindens == OFF ) call mix_kinetic_energy_density()
  else
     if ( sw_update_charge_total == ON ) then
        if ( modnrm == SKIP .or. sw_mix_charge_hardpart == OFF ) then
           call mix_charge_total()
           if ( flg_paw ) call mix_charge_only_hsr          !! only exception
           if ( sw_hubbard == ON ) call mix_charge_only_occmat
        else
           if ( precon_hardpart ) call precon_hardpart_kt
           call mix_charge_total_with_hsr()
        endif
     endif
  endif
! ================================================================= 5.0

! ================================== modified by K. Tagami ========== 11.0
  if ( noncol ) then
     call m_CD_check_noncl(nfout)

! ============================ KT_mod ========== 13.0U
!     if ( iteration_ionic >1 .and. iteration_electronic ==1 ) then
!        call m_CD_set_rad_cov_default
!        call m_CD_set_rad_cov_now
!     endif
! ============================================== 13.0U

     call m_CD_calc_ChgMagMom_in_sphere
     call m_CD_print_ChgMagmom_on_atom(nfout)
     if ( sw_opencore == ON ) call m_PS_print_core_Magmom_on_atom( nfout )

! ==== KT_add === 2014/09/01
     if ( Orbital_decomp_mode == 2 ) then
        call m_CD_calc_SpinMagMom_method2
     else
        if ( .not. flg_paw ) call m_CD_estim_magmom_local(nfout)
        call m_CD_print_magmom_local(nfout)
     endif

     if ( sw_use_add_proj == ON .and. Orbital_decomp_mode == 2 ) then
        call m_CD_hardpart_hsr_add_noncl( nfout,kv3 )
     endif
     if ( sw_calc_orbital_moment == ON ) then
        if ( Orbital_decomp_mode == 2 ) call m_OP_calc_OrbMagMom_method2
     endif
! =============== 2014/09/01

     if ( SpinOrbit_mode /= Neglected ) then
#ifndef WO_OP_MOMENT
        if ( sw_hubbard == ON ) call m_OP_calc_orbmom_from_OCC
#endif
     endif

  else
     call m_CD_check(nfout)
     if ( sw_monitor_atomcharge == ON ) then
        call m_CD_calc_ChgMagMom_in_sphere
        call m_CD_print_ChgMagmom_on_atom(nfout)
        if ( sw_opencore == ON ) call m_PS_print_core_Magmom_on_atom( nfout )
     endif

! ==== KT_add === 2014/08/28
     if ( sw_use_add_proj == ON .and. Orbital_decomp_mode == 2 ) then
        call m_CD_hardpart_hsr_add( nfout,kv3 )
     endif
! =============== 2014/08/28
  endif
! =================================================================== 11.0


  if(tag_solver_of_WF_is_found .and. tag_charge_mixing_is_found) then
     waymix_at_CDmix_previous = waymix_at_CDmix
  end if

#ifdef __TIMER_SUB__
    call timer_end(1101)
#endif

! ========== KT_add ========== 13.0U2
  if ( sw_modified_TFW_functional == ON ) call ThomasFermiWeiz_loop
! ============================ 13.0U2

  call m_TE_wd_total_energy_with_solvers(nfout)

contains

  subroutine mix_charge_total()
    mixing_way: select case(waymix_at_CDmix)
    case (SIMPLE)
       call m_CD_simple_mixing(nfout,rmxt_tot)
    case (BROYD1)
       call m_CD_mix_broyden1(rmxt_tot)
    case (BROYD2)
       call m_CD_mix_broyden2(nfout,rmxt_tot)
    case (DFP)
       call m_CD_mix_DFP(rmxt_tot)
    case (PULAY)
       call m_CD_mix_pulay(nfout,rmxt_tot)
    case default
       call phase_error_with_msg(nfout,' ! waymix is invalid',__LINE__,__FILE__)
    end select mixing_way

  end subroutine mix_charge_total

  subroutine mix_charge_only_hsr
     call m_CD_simple_mixing_hsr(nfout,rmxt)
  end subroutine mix_charge_only_hsr

  subroutine mix_charge_only_occmat
    mixing_way: select case(waymix_at_CDmix)
    case (SIMPLE)
        call m_OP_simple_mixing(nfout,rmxt_occmat)
    case (BROYD1)
        call m_OP_mix_broyden1(rmxt_occmat)
    case (BROYD2)
        call m_OP_mix_broyden2(rmxt_occmat)
    case (DFP)
        call m_OP_mix_DFP(rmxt_occmat)
    case (PULAY)
        call m_OP_mix_Pulay(rmxt_occmat)
    case default
       call phase_error_with_msg(nfout,' ! waymix is invalid',__LINE__,__FILE__)
    end select mixing_way

  end subroutine mix_charge_only_occmat

  logical function fix_occ_matrix()
    use m_Control_Parameters, only : occ_matrix_fix_period
    use m_IterationNumbers, only : iteration_electronic
    fix_occ_matrix = iteration_electronic <= occ_matrix_fix_period 
    return
  end function fix_occ_matrix

  subroutine mix_charge_total_with_hsr()
    mixing_way: select case(waymix_at_CDmix)

    case (SIMPLE)
       call m_CD_simple_mixing( nfout,rmxt_tot )
       call m_CD_simple_mixing_hard( nfout, rmxt_hard )
       if ( sw_hubbard == ON .and.sw_mix_occ_matrix==OFF ) then
          call Renewal_of_OccMat( .false., ON, fix_occ_matrix() )           ! hsr --> om 
       endif
       if (sw_hubbard==ON) call m_OP_cp_om_to_ommix( nfout, rmxt_hard )       ! om --> ommix

    case (BROYD1)
!       call m_CD_mix_broyden1_with_hsr(rmxt_tot)
       write(*,*) 'Not supported '
       call phase_error_with_msg(nfout,' broyd1 unsupported',__LINE__,__FILE__)

    case (BROYD2)
       call m_CD_mix_broyden2_with_hsr(nfout,rmxt_tot,sw_mix_occ_matrix==ON)
       if ( sw_hubbard == ON .and. sw_mix_occ_matrix==OFF ) then
          call Renewal_of_OccMat(.false., ON, fix_occ_matrix() )           ! hsr --> om 
       endif
       if(sw_hubbard==ON) call m_OP_cp_om_to_ommix( nfout, rmxt_hard )      ! om --> ommix
    case (DFP)
!       call m_CD_mix_DFP(rmxt_tot)
       !write(*,*) 'Not supported '
!       stop
       call phase_error_with_msg(nfout,' dfp unsupported',__LINE__,__FILE__)
    case (PULAY)
       call m_CD_mix_pulay_with_hsr(nfout,rmxt_tot,sw_mix_occ_matrix==ON)
       if ( sw_hubbard == ON .and. sw_mix_occ_matrix==OFF ) then
          call Renewal_of_OccMat(.false., ON, fix_occ_matrix() )           ! hsr --> om 
       endif
       if(sw_hubbard==ON) call m_OP_cp_om_to_ommix( nfout, rmxt_hard )      ! om --> ommix
    case default
       call phase_error_with_msg(nfout,' ! waymix is invalid',__LINE__,__FILE__)
    end select mixing_way
  end subroutine mix_charge_total_with_hsr

! === KT_add == 2014/09/19
  subroutine mix_charge_total_intg()
    mixing_way: select case(waymix_at_CDmix)

    case (SIMPLE)
       call m_CD_simple_mixing_intg( nfout,rmxt_tot )
       if ( sw_hubbard == ON ) then
          call Renewal_of_OccMat( .false., ON )           ! hsr --> om
          call m_OP_cp_om_to_ommix( nfout, rmxt_hard )       ! om --> ommix
       endif

    case (BROYD2)
       call m_CD_mix_broyden2_intg(nfout,rmxt_tot,sw_mix_occ_matrix==ON)
       if ( sw_hubbard == ON ) then
          call Renewal_of_OccMat(.false., ON )           ! hsr --> om
          call m_OP_cp_om_to_ommix( nfout, rmxt_hard )       ! om --> ommix
       endif
    case (PULAY)
       call m_CD_mix_pulay_intg(nfout,rmxt_tot,sw_mix_occ_matrix==ON)
       if ( sw_hubbard == ON ) then
          call Renewal_of_OccMat(.false., ON )           ! hsr --> om
          call m_OP_cp_om_to_ommix( nfout, rmxt_hard )       ! om --> ommix
       endif

    case default
       call phase_error_with_msg(nfout,' ! waymix is invalid',__LINE__,__FILE__)
    end select mixing_way

  end subroutine mix_charge_total_intg

  subroutine mix_kinetic_energy_density()
    mixing_way: select case(waymix_at_CDmix)

    case (SIMPLE)
       call m_KE_simple_mixing(nfout,rmxt_tot)
    case (BROYD2)
       call m_KE_mix_broyden2(nfout,rmxt_tot)
    case (PULAY)
       call m_KE_mix_pulay(nfout,rmxt_tot)
    case default
       call phase_error_with_msg(nfout,' ! waymix is invalid',__LINE__,__FILE__)
    end select mixing_way

  end subroutine mix_kinetic_energy_density

  subroutine procedure_charge_fixed
    if ( sw_calc_ekin_density == ON ) then
       call m_KE_simple_mixing_00( rmxt_tot )
!     call m_KE_Kerker_mixing( rmxt_tot )
    endif
  end subroutine procedure_charge_fixed
! ======= 2014/09/19

! === KT_add ======= 13.0U3
  subroutine precon_hardpart_kt
    real(kind=DP) :: threshold = 2.5D-2

    if ( sw_wf_mixing == OFF ) return
    if ( .not. wf_mixing_is_active ) return

#if 0
    if ( abs(edeltb_per_atom) > threshold ) return
#endif

    if ( sw_wf_mixing == ON ) then
!       call m_ES_WF_precon_hsr
       call m_ES_WF_kerker_mixing( .true. )
    endif

  end subroutine precon_hardpart_kt
! ================== 13.0U3

end subroutine ChargeDensity_Mixing

subroutine push_cd_mixing_name_applied(waymix)
  use m_Const_Parameters,   only :  SIMPLE , BROYD1, BROYD2, DFP, PULAY
  use m_Control_Parameters, only :  m_CtrlP_push_CDMixingNameApplied, len_cdmixingname
  implicit none
  integer, intent(in) :: waymix
  character(len=len_cdmixingname) :: cdmixname
  character*20 :: name
  integer :: len_char
  name = ""
  solver: select case(waymix)
  case (SIMPLE)
     name = "SIMPLE"
  case (BROYD1)
     name = "BROYD1"
  case (BROYD2)
     name = "BROYD2"
  case (DFP)
     name = "DFP"
  case (PULAY)
     name = "PULAY"
  case default
     name = "notDefined"
  end select solver
  len_char = len_trim(name)
  cdmixname = ""
  cdmixname(1:min(len_char,len_cdmixingname)) = name(1:min(len_char,len_cdmixingname))
  call m_CtrlP_push_CDMixingNameApplied(cdmixname,len_cdmixingname)
end subroutine push_cd_mixing_name_applied

#ifdef HIUX
*OPTION MP(P(0))
#endif
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifdef WF_JRCATFFT
      subroutine jrcat_r3ft(ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                      kc1,kc2,kc3,key)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
c
c------------------>      for Estimation of CPU cost.
c                             by T.Yamasaki
c                               22th May. 1996
      real*8 CRTVL, PCPUDF
      parameter (CRTVL = 1.d-5, PCPUDF = 2.0)
c        CRTVL : CRItical VaLue for Division.
c        PCPUDF: Percent of CPU DiFference.
      real*8 cpu0ol,cpudif,rcpudf,ecpu,tcpu
      integer icount
      data icount/0/
      data ecpu/0.d0/
      data cpu0ol/0.d0/
      real*8 t_start, t_end, UMICRO
      parameter (UMICRO = 1.d-6)
c <-------------------------------------------
      real*8 ra   (id,n2,n3)
      real*8 work (id,n2,n3)

      complex*16 cw1(0:n1-1)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank

c********************************************************************************
c*   key = 0 : set up of FFT.
c*             ( Calculation of cw1,cw2 and cw3. )
c********************************************************************************
c*   n1,n2 and n3 must include radix 2, and they may include 3 or 5.
c*   id must be larger than or equal to n1 + 2.
c*
c********************************************************************************
c*  key = -1 & -2 : F.T. of real 3d array ra(0:n1-1,0:n2-1,0:n3-1) .
c********************************************************************************
c*
c*   The result(complex 'cb') is overwritten on 'ra'.
c*   ( i.e. equivalence(ra,cb) ).
c*   
c*     cb(k1,k2,k3) 
c*   = sum(ix=0:n1-1,iy=0:n2-1,iz=0:n3-1) 
c*     ra(i1,i2,i3) exp [- 2 * pai * ci * ( k1*i1/n1 + k2*i2/n2 + k3*i3/n3 ) ]
c*     
c*     where 0 <= k1 <= n1/2, 0 <= k2 <= n2-1, 0 <= k3 <= n3-1.
c*
c********************************************************************************
c*  key = +1 & +2: Inverse F.T. of copmplex 3d array cb(0:n1/2,0:n2-1,0:n3-1) .
c********************************************************************************
c*   Transform from 'cb' to 'ra'.
c*
c********************************************************************************
c*  kc1,kc2 kc3 are integer parameters specifying the mask for
c*  input data or output data.
c*
c*     If kc1.ge.n1/2.or.kc1.lt.0, then kc1 is forced to be 0. 
c*     If kc2.ge.n2/2.or.kc2.lt.0, then kc2 is forced to be 0. 
c*     If kc3.ge.n3/2.or.kc3.lt.0, then kc3 is forced to be 0. 
c*
c********************************************************************************
c** REMARK on Mask.
c********************************************************************************
c*
c*  key = -1 : Mask is for Output data ( cb ),
c*  key = +1 : Mask is for Input  data ( cb ),
c*  key = -2 : Mask is for Input  data ( ca ),
c*  key = +2 : Mask is for Output data ( ca ),
c*
c*     where ca(0:idh/2,0:n2-1,0:n3-1) and equivalence(ra,ca).
c*
c********************************************************************************
c*     Mask for Output data:
c********************************************************************************
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full wavenumber
c*     range is calculated.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" range is calculated.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2 <= n2-1" 
c*     range is calculated.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3 <= n3-1" 
c*     range is calculated.
c*
c********************************************************************************
c*     Mask for Input data:
c********************************************************************************
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full wavenumber
c*     range is used to obtain real array 'ra'.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" range is used.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2 <= n2-1" 
c*     range is used.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3 <= n3-1" 
c*     range is used.
c*
c********************************************************************************
c*
c******************************************************************
c**   choose nbank = 0 or nbank = 1 
c******************************************************************
c*   nbank = 0:
c*      The transpose is normally implemented.
c*      Bank conflict may appear patriculary in Vector Computers.
c*   nbank = 1:
c*      The transpose is implemented so as to prevent
c*      the bank conflict in the case the conflict may appear.
c******************************************************************
c
      call gettod(t_start)

      nbank = 0

c**

      if(key.eq.0) then

c** set up of FFT.

         call r3ft_0(cw1,cw2,cw3,n1,n2,n3)

         goto 1001
c$$$         return

      end if

c**
      if(kc1.ge.n1/2.or.kc1.lt.0) then 
         write(6,*) 'warning in FFT: kc1 is irrelevant.'
         write(6,*) 'kc1 has changed to be 0.'
         kc1 = 0
      end if

      if(kc2.ge.n2/2.or.kc2.lt.0) then 
         write(6,*) 'warning in FFT: kc2 is irrelevant.'
         write(6,*) 'kc2 has changed to be 0.'
         kc2 = 0
      end if

      if(kc3.ge.n3/2.or.kc3.lt.0) then 
         write(6,*) 'warning in FFT: kc3 is irrelevant.'
         write(6,*) 'kc3 has changed to be 0.'
         kc3 = 0
      end if
c**

      if(key.eq.-1) then

c** Forword FFT with mask for output.

         call r3ft_f_mask_for_out(ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank)

      else if(key.eq.-2) then

c** Forword FFT with mask for input.

         call r3ft_f_mask_for_in (ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank)

      else if(key.eq.+1) then

c** Backword FFT with mask for input.

         call r3ft_b_mask_for_in (ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank)

      else if(key.eq.+2) then

c** Backword FFT with mask for output.

         call r3ft_b_mask_for_out(ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank)

      end if

c**  
 1001 continue

c -------->  CPU cost estimation
      call gettod(t_end)
      tcpu = (t_end - t_start)*UMICRO
      icount = icount + 1
      ecpu = ecpu + tcpu
c <-------
      
      return

      entry jrc_r3strt
      icount = 0
      ecpu = 0.d0
      return
c--------------------------
      entry jrc_r3end
      cpudif = dabs(cpu0ol - ecpu)
      if(ecpu.gt.CRTVL) then
         rcpudf = cpudif/ecpu * 100.0
      else if(cpu0ol.le.CRTVL) then
         rcpudf = 0.0
      else
         rcpudf = 100.0
      endif
c               <-- Ratio in percent of CPU time difference
c                 between previous one and present one.
      cpu0ol = ecpu

c$$$      call eqivvl(rcpudf)

      if(rcpudf.gt.PCPUDF) then
         if(icount.gt.0) then
            tcpu = ecpu/dfloat(icount)
         endif
         write(6,9001) ecpu, icount, tcpu
 9001    format(1H ,' <<CPU TIME for JRCAT_R3FT = ',f11.3
     &        ,'(Sec.) = (',i6,' *',f10.5,')>>')
      endif
      return
      end  

      subroutine r3ft_0(cw1,cw2,cw3,n1,n2,n3)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      use m_Const_Parameters, only  : PAI
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      complex*16 cw1(0:n1/2-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

c**
      if(mod(n1,2).ne.0) then
         stop 'The first length is not an even number.'
      end if

         n1h = n1/2

c**         pai=3.14159265358979323846d0
         pc =2.0d0*pai/dble(n1)
         ci=(0.0d0,1.0d0)

         call setcw(cw1,n1h)
         call setcw(cw2,n2 )
         call setcw(cw3,n3 ) 

      do i=0,n1h-1
         tr=dcos(pc*dble(i))
         ti=dsin(pc*dble(i))
         cw1(i,2)=ci*dcmplx(tr,ti)
      end do   

      return
      end  

      subroutine r3ft_b_mask_for_in(ca,cb,id,n1,n2,n3,cw1,cw2,cw3,
     &                        kc1,kc2,kc3,nbank)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (2,0:id/2-1,0:n2-1,0:n3-1)
      real*8 cb (0:id/2-1,0:n2-1,0:n3-1,2)
c     complex*16 ca (0:id/2-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id/2-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1/2-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank
c**
         n1h = n1/2
         idh = id/2

      if(kc1.eq.0) then
           mm1 = n1h+1
c          mm1 = idh
      else
           mm1 = kc1+1
      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if

c** Packin from ca(2,0:idh-1,0:n2-1,0:n3-1) to cb(0:mm1-1,0:mm2-1,0:n3-1,2)

      call trans_in_b0(ca,cb,idh,n2,n3,mm1,mm2,kc1,kc2,kc3)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw3,n3,mm1*mm2,lp2,lp3,lp4,lp5,lp8)

c** cb(i1,i3,i2,2) <- ca(i1,i2,i3,2)

      call trans_in_b1(ca,cb,mm1,n2,mm2,n3,kc2)

c** Length:n2 CFFT    

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw2,n2,mm1*n3,lp2,lp3,lp4,lp5,lp8) 

c** cb(i3,i2,i1,2) <- ca(i1,i3,i2,2)

      call trans_in_b2(ca,cb,mm1,n2,n3,n1h)

c**
      call trans_in_b3(cb,ca,cw1(0,2),n3*n2,n1h,kc1)

c** Length:n1h RCFFT  

      call setlp(n1h,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(ca,cb,cw1,n1h,n3*n2,lp2,lp3,lp4,lp5,lp8)

c** ca(2,i1,i2,i3) <- cb(i3,i2,i1,2)

      call trans_in_b4(cb,ca,n3,n2,idh,n1h)

      return

      end  

      subroutine r3ft_b_mask_for_out(ca,cb,id,n1,n2,n3,
     &                        cw1,cw2,cw3,
     &                        kc1,kc2,kc3,nbank)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (2,0:id/2-1,0:n2-1,0:n3-1)
      real*8 cb (0:id/2-1,0:n2-1,0:n3-1,2)
c     complex*16 ca (0:id/2-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id/2-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1/2-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank
c**
         n1h = n1/2
         idh = id/2

c$$$      if(kc1.eq.0) then
c$$$           mm1 = n1h+1 
c$$$      else
c$$$           mm1 = kc1+1
c$$$      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if

      if(kc3.eq.0) then
           mm3 = n3
      else
           mm3 = kc3*2+1
      end if

c** cb(i1,i2,i3,2) <- ca(2,i1,i2,i3)

      call trans_out_b0(ca,cb,idh,n2,n3,n1h)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw3,n3,(n1h+1)*n2,lp2,lp3,lp4,lp5,lp8)

c** cb(i1,i3,i2,2) <- ca(i1,i2,i3,2)

      call trans_out_b1(ca,cb,n1h,n2,n3,mm3,kc3)

c** Length:n2 CFFT    

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw2,n2,(n1h+1)*mm3,lp2,lp3,lp4,lp5,lp8) 

c** cb(i3,i2,i1,2) <- ca(i1,i3,i2,2)

      call trans_out_b2(ca,cb,n1h,n2,mm2,mm3,kc2)

c**
      call trans_out_b3(cb,ca,cw1(0,2),mm3*mm2,n1h)

c** Length:n1h RCFFT  

      call setlp(n1h,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(ca,cb,cw1,n1h,mm3*mm2,lp2,lp3,lp4,lp5,lp8)

c** ca(2,i1,i2,i3) <- cb(i3,i2,i1,2)

      call trans_out_b4(cb,ca,idh,n1h,n2,n3,mm2,mm3,kc1,kc2,kc3)

      return

      end  

      subroutine r3ft_f_mask_for_out(ca,cb,id,n1,n2,n3,
     &                        cw1,cw2,cw3,
     &                        kc1,kc2,kc3,nbank)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (2,0:id/2-1,0:n2-1,0:n3-1)
      real*8 cb (0:id/2-1,0:n2-1,0:n3-1,2)
c     complex*16 ca (0:id/2-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id/2-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1/2-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank
c**
         n1h = n1/2
         idh = id/2

      if(kc1.eq.0) then
           mm1 = n1h+1
      else
           mm1 = kc1+1
      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if
    
c**   cb(i3,i2,i1,2) <- CONJG(ca(2,i1,i2,i3))

         call trans_out_f1(ca,cb,idh,n1h,n2,n3)
 
c** Length:n1h RFFT

      call setlp(n1h,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw1,n1h,n3*n2,lp2,lp3,lp4,lp5,lp8)
      
c** Transform from 'n1h' complex to 'n1' real array. 

         call trans_out_f2(ca,cb,cw1(0,2),n3,n2,n1h,kc1) 

c**   ca(i3,k1,i2,2) <- cb(i3,i2,k1,2)

         call trans_out_f3(cb,ca,n3,n2,mm1,n1h)

c** Length:n2 CFFT  

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(ca,cb,cw2,n2,n3*mm1,lp2,lp3,lp4,lp5,lp8)

c**   ca(k1,k2,i3,2) <- cb(i3,k1,k2,2)

            call trans_out_f4(cb,ca,n3,mm1,n2,mm2,kc2)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(ca,cb,cw3,n3,mm1*mm2,lp2,lp3,lp4,lp5,lp8)

c**   ca(2,i1,i2,i3) <- CONJG(cb(i1,i2,i3,2))

         call trans_out_f5(cb,ca,idh,n1h,n2,n3,mm1,mm2,kc1,kc2,kc3)

      return

      end  

      subroutine r3ft_f_mask_for_in(ca,cb,id,n1,n2,n3,cw1,cw2,cw3,
     &                        kc1,kc2,kc3,nbank)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (2,0:id/2-1,0:n2-1,0:n3-1)
      real*8 cb (0:id/2-1,0:n2-1,0:n3-1,2)

c     complex*16 ca (0:id/2-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id/2-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1/2-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank
c**
         n1h = n1/2
         idh = id/2

c$$$      if(kc1.eq.0) then
c$$$           mm1 = n1h+1 
c$$$      else
c$$$           mm1 = kc1+1
c$$$      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if

      if(kc3.eq.0) then
           mm3 = n3
      else
           mm3 = kc3*2+1
      end if
    
c**   cb(i3,i2,i1,2) <- CONJG(ca(2,i1,i2,i3))

         call trans_in_f1(ca,cb,idh,n1h,n2,n3,mm2,mm3,kc1,kc2,kc3)

c** Length:n1h RFFT

      call setlp(n1h,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw1,n1h,mm3*mm2,lp2,lp3,lp4,lp5,lp8)
      
c** Transform from 'n1h' complex to 'n1' real array. 

         call trans_in_f2(ca,cb,cw1(0,2),mm3,mm2,n1h) 

c**   ca(i3,k1,i2,2) <- cb(i3,i2,k1,2)

         call trans_in_f3(cb,ca,mm3,n2,mm2,n1h,kc2)

c** Length:n2 CFFT  

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(ca,cb,cw2,n2,mm3*(n1h+1),lp2,lp3,lp4,lp5,lp8)

c**   ca(k1,k2,i3,2) <- cb(i3,k1,k2,2)

            call trans_in_f4(cb,ca,n1h,n2,n3,mm3,kc3)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(ca,cb,cw3,n3,(n1h+1)*n2,lp2,lp3,lp4,lp5,lp8)

c**   ca(2,i1,i2,i3) <- CONJG(cb(i1,i2,i3,2))

         call trans_in_f5(cb,ca,idh,n1h,n2,n3)

      return

      end  

      subroutine fsb_lp235(ca,cb,cw,n,ndim,lp2,lp3,lp4,lp5,lp8)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
      implicit complex*16(a-h,o-z)

      real*8 ca(ndim*n*2),cb(ndim*n*2)
c     complex*16 ca(ndim,n),cb(ndim,n)

      complex*16 cw(0:n-1)

      k =1
      la=1

c*** RADIX 2 FFT.

      do 2 i=1,lp2
      if(k.eq.1) then
         call fsb_lp2(ca,cb,cw,la,n,ndim)
      else
         call fsb_lp2(cb,ca,cw,la,n,ndim)
      end if
         k=k*(-1)
         la=la*2
    2 continue

c*** RADIX 3 FFT.

      do 3 i=1,lp3
      if(k.eq.1) then
         call fsb_lp3(ca,cb,cw,la,n,ndim)
      else
         call fsb_lp3(cb,ca,cw,la,n,ndim)
      end if
         k=k*(-1)
         la=la*3
    3 continue

c*** RADIX 4 FFT.

      do 4 i=1,lp4
      if(k.eq.1) then
         call fsb_lp4(ca,cb,cw,la,n,ndim)
      else
         call fsb_lp4(cb,ca,cw,la,n,ndim)
      end if
         k=k*(-1)
         la=la*4
    4 continue

c*** RADIX 5 FFT.

      do 5 i=1,lp5
      if(k.eq.1) then
         call fsb_lp5(ca,cb,cw,la,n,ndim)
      else
         call fsb_lp5(cb,ca,cw,la,n,ndim)
      end if
         k=k*(-1)
         la=la*5
    5 continue

c*** RADIX 8 FFT.

      do 8 i=1,lp8
      if(k.eq.1) then
         call fsb_lp8(ca,cb,cw,la,n,ndim)
      else
         call fsb_lp8(cb,ca,cw,la,n,ndim)
      end if
         k=k*(-1)
         la=la*8
    8 continue
c***
      if(k.eq.+1) then

         do 100 ii=1,ndim*n*2
            cb(ii)=ca(ii)
  100    continue

      else

         do 101 ii=1,ndim*n*2
            ca(ii)=cb(ii)
  101    continue

      end if
c**
      return
      end
c---------------------------------------------
      subroutine fsb_lp2(ca,cb,cw,la,n,ndim)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c---------------------------------------------
      implicit real*8(a-h,o-z)

      real*8 ca(ndim,n,2),cb(ndim,n,2),cw(2,0:n-1)

      m=n/2
      np=(m-la)/la

      i1=m
      j1=la
      jump=la  

      do 20 l=1,la
      do 20 ii=1,ndim

         cb(ii,l   ,1)=(ca(ii,l,1)+ca(ii,l+i1,1))
         cb(ii,l   ,2)=(ca(ii,l,2)+ca(ii,l+i1,2))

         cb(ii,l+j1,1)=(ca(ii,l,1)-ca(ii,l+i1,1))
         cb(ii,l+j1,2)=(ca(ii,l,2)-ca(ii,l+i1,2))

   20 continue

      do 21 kp=1,np
      do 21 l=1,la
      do 21 ii=1,ndim

         i0=l+kp*la         
         j0=l+kp*(la+jump)         

         cb(ii,j0   ,1)=(ca(ii,i0,1)+ca(ii,i0+i1,1))
         cb(ii,j0   ,2)=(ca(ii,i0,2)+ca(ii,i0+i1,2))

         cc1r = ca(ii,i0,1)-ca(ii,i0+i1,1)
         cc1i = ca(ii,i0,2)-ca(ii,i0+i1,2)

         cb(ii,j0+j1,1)=cc1r*cw(1,kp*la) - cc1i*cw(2,kp*la)
         cb(ii,j0+j1,2)=cc1r*cw(2,kp*la) + cc1i*cw(1,kp*la)

   21 continue

      return
      end
c---------------------------------------------
      subroutine fsb_lp3(ca,cb,cw,la,n,ndim)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c---------------------------------------------
      implicit real*8(a-h,o-z)  

      real*8 ca(ndim,n,2),cb(ndim,n,2),cw(2,0:n-1)

      real*8 sin60

      m=n/3
      np=(m-la)/la

      i1=m
      i2=m*2 

      j1=la
      j2=la*2

      jump=la*2

      sin60=0.5d0*dsqrt(3.0d0)

c*    k=0 
      do 30 l=1,la
      do 30 ii=1,ndim

         ct1r=ca(ii,l+i1,1)+ca(ii,l+i2,1)
         ct1i=ca(ii,l+i1,2)+ca(ii,l+i2,2)

         ct2r=ca(ii,l   ,1)-0.5d0*ct1r       
         ct2i=ca(ii,l   ,2)-0.5d0*ct1i       

         ct3r= - sin60*(ca(ii,l+i1,2)-ca(ii,l+i2,2))
         ct3i=   sin60*(ca(ii,l+i1,1)-ca(ii,l+i2,1))

         cb(ii,l   ,1)=ca(ii,l,1)+ct1r
         cb(ii,l   ,2)=ca(ii,l,2)+ct1i

         cb(ii,l+j1,1)=(ct2r+ct3r)
         cb(ii,l+j1,2)=(ct2i+ct3i)

         cb(ii,l+j2,1)=(ct2r-ct3r)
         cb(ii,l+j2,2)=(ct2i-ct3i)

   30 continue

      do 31 kp=1,np
      do 31 l=1,la
      do 31 ii=1,ndim

         i0=l+kp*la         
         j0=l+kp*(la+jump)         

         ct1r=ca(ii,i0+i1,1)+ca(ii,i0+i2,1)
         ct1i=ca(ii,i0+i1,2)+ca(ii,i0+i2,2)

         ct2r=ca(ii,i0   ,1)-0.5d0*ct1r       
         ct2i=ca(ii,i0   ,2)-0.5d0*ct1i       

         ct3r= - sin60*(ca(ii,i0+i1,2)-ca(ii,i0+i2,2))
         ct3i=   sin60*(ca(ii,i0+i1,1)-ca(ii,i0+i2,1))

         cb(ii,j0   ,1)=ca(ii,i0,1)+ct1r
         cb(ii,j0   ,2)=ca(ii,i0,2)+ct1i

         ct4r = ct2r + ct3r
         ct4i = ct2i + ct3i

         ct5r = ct2r - ct3r
         ct5i = ct2i - ct3i

         cb(ii,j0+j1,1)=ct4r*cw(1,kp*j1) - ct4i*cw(2,kp*j1)
         cb(ii,j0+j1,2)=ct4r*cw(2,kp*j1) + ct4i*cw(1,kp*j1)

         cb(ii,j0+j2,1)=ct5r*cw(1,kp*j2) - ct5i*cw(2,kp*j2)
         cb(ii,j0+j2,2)=ct5r*cw(2,kp*j2) + ct5i*cw(1,kp*j2)

   31 continue

      return
      end

c---------------------------------------------
      subroutine fsb_lp4(ca,cb,cw,la,n,ndim)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c---------------------------------------------
      implicit real*8(a-h,o-z)

      real*8 ca(ndim,n,2),cb(ndim,n,2),cw(2,0:n-1)

         m   =n/4
         np  =(m-la)/la
         jump=la*3
   
      do 40 l=1,la
      do 40 ii=1,ndim

      cc0r = ca(ii,l  ,1)+ca(ii,l+2*M,1)
      cc0i = ca(ii,l  ,2)+ca(ii,l+2*M,2)

      cc1r = ca(ii,l+M,1)+ca(ii,l+3*M,1)
      cc1i = ca(ii,l+M,2)+ca(ii,l+3*M,2)

      cc2r = ca(ii,l  ,1)-ca(ii,l+2*M,1)
      cc2i = ca(ii,l  ,2)-ca(ii,l+2*M,2)

      cc3r = - ca(ii,l+M,2) + ca(ii,l+3*M,2)
      cc3i =   ca(ii,l+M,1) - ca(ii,l+3*M,1)

         cb(ii,l     ,1)= cc0r+cc1r
         cb(ii,l     ,2)= cc0i+cc1i

         cb(ii,l+  LA,1)= cc2r+cc3r
         cb(ii,l+  LA,2)= cc2i+cc3i

         cb(ii,l+2*LA,1)= cc0r-cc1r
         cb(ii,l+2*LA,2)= cc0i-cc1i

         cb(ii,l+3*LA,1)= cc2r-cc3r
         cb(ii,l+3*LA,2)= cc2i-cc3i

   40 continue
   
      DO 41 KP=1,NP
      DO 41 L=1,LA
      DO 41 ii=1,ndim

         I0=L+KP* LA
         J0=L+KP*(LA+JUMP)

      cc1r =  ca(ii,I0  ,1)+ca(ii,I0+2*M,1)
      cc1i =  ca(ii,I0  ,2)+ca(ii,I0+2*M,2)

      cc2r =  ca(ii,I0+M,1)+ca(ii,I0+3*M,1)
      cc2i =  ca(ii,I0+M,2)+ca(ii,I0+3*M,2)

      cc3r =  ca(ii,I0  ,1)-ca(ii,I0+2*M,1)
      cc3i =  ca(ii,I0  ,2)-ca(ii,I0+2*M,2)

      cc4r = -ca(ii,I0+M,2)+ca(ii,I0+3*M,2)
      cc4i =  ca(ii,I0+M,1)-ca(ii,I0+3*M,1)

         cc5r = cc3r + cc4r
         cc5i = cc3i + cc4i

         cc6r = cc1r - cc2r
         cc6i = cc1i - cc2i

         cc7r = cc3r - cc4r
         cc7i = cc3i - cc4i

         cb(ii,J0     ,1) = cc1r+cc2r
         cb(ii,J0     ,2) = cc1i+cc2i

         cb(ii,J0+  LA,1) = cc5r*cw(1,KP*LA  ) - cc5i*cw(2,KP*LA  )
         cb(ii,J0+  LA,2) = cc5r*cw(2,KP*LA  ) + cc5i*cw(1,KP*LA  )

         cb(ii,J0+2*LA,1) = cc6r*cw(1,KP*LA*2) - cc6i*cw(2,KP*LA*2)
         cb(ii,J0+2*LA,2) = cc6r*cw(2,KP*LA*2) + cc6i*cw(1,KP*LA*2)

         cb(ii,J0+3*LA,1) = cc7r*cw(1,KP*LA*3) - cc7i*cw(2,KP*LA*3)
         cb(ii,J0+3*LA,2) = cc7r*cw(2,KP*LA*3) + cc7i*cw(1,KP*LA*3)

   41 continue
         
      RETURN
      END

c---------------------------------------------
      subroutine fsb_lp5(ca,cb,cw,la,n,ndim)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c---------------------------------------------
      use m_Const_Parameters, only : PAI
      implicit real*8(a-h,o-z)

      real*8 ca(ndim,n,2),cb(ndim,n,2),cw(2,0:n-1)
      real*8 pai,sin36,sin72,r54

      m=n/5
      np  =(m-la)/la

      i1=m
      i2=m*2 
      i3=m*3 
      i4=m*4 

      j1=la
      j2=la*2
      j3=la*3
      j4=la*4

      jump=la*4

c**      pai  =3.14159265358979323846d0
      sin36=dsin(pai*0.2d0)
      sin72=dsin(pai*0.4d0)
      r54  =dsqrt(5.0d0)/4.0d0

c** k=0
      do 50 l=1,la
      do 50 ii=1,ndim

         ct1r=ca(ii,l+i1,1)+ca(ii,l+i4,1)
         ct1i=ca(ii,l+i1,2)+ca(ii,l+i4,2)

         ct2r=ca(ii,l+i2,1)+ca(ii,l+i3,1)
         ct2i=ca(ii,l+i2,2)+ca(ii,l+i3,2)

         ct3r=ca(ii,l+i1,1)-ca(ii,l+i4,1)
         ct3i=ca(ii,l+i1,2)-ca(ii,l+i4,2)

         ct4r=ca(ii,l+i2,1)-ca(ii,l+i3,1)
         ct4i=ca(ii,l+i2,2)-ca(ii,l+i3,2)

         ct5r=     ct1r+ct2r
         ct5i=     ct1i+ct2i

         ct6r=r54*(ct1r-ct2r)
         ct6i=r54*(ct1i-ct2i)

         ct7r=ca(ii,l   ,1)-0.25d0*ct5r
         ct7i=ca(ii,l   ,2)-0.25d0*ct5i

         ct8r=ct7r+ct6r
         ct8i=ct7i+ct6i

         ct9r=ct7r-ct6r
         ct9i=ct7i-ct6i

         ct10r=-(sin72*ct3i+sin36*ct4i)
         ct10i= (sin72*ct3r+sin36*ct4r)

         ct11r=-(sin36*ct3i-sin72*ct4i)
         ct11i= (sin36*ct3r-sin72*ct4r)

         cb(ii,l   ,1)=ca(ii,l,1)+ct5r
         cb(ii,l   ,2)=ca(ii,l,2)+ct5i

         cb(ii,l+j1,1)=(ct8r+ct10r)
         cb(ii,l+j1,2)=(ct8i+ct10i)

         cb(ii,l+j2,1)=(ct9r+ct11r)
         cb(ii,l+j2,2)=(ct9i+ct11i)

         cb(ii,l+j3,1)=(ct9r-ct11r)
         cb(ii,l+j3,2)=(ct9i-ct11i)

         cb(ii,l+j4,1)=(ct8r-ct10r)
         cb(ii,l+j4,2)=(ct8i-ct10i)

   50 continue

      do 51 kp=1,np
      do 51 l=1,la
      do 51 ii=1,ndim

         I0=L+KP* LA
         J0=L+KP*(LA+JUMP)

         ct1r=ca(ii,i0+i1,1)+ca(ii,i0+i4,1)
         ct1i=ca(ii,i0+i1,2)+ca(ii,i0+i4,2)

         ct2r=ca(ii,i0+i2,1)+ca(ii,i0+i3,1)
         ct2i=ca(ii,i0+i2,2)+ca(ii,i0+i3,2)

         ct3r=ca(ii,i0+i1,1)-ca(ii,i0+i4,1)
         ct3i=ca(ii,i0+i1,2)-ca(ii,i0+i4,2)

         ct4r=ca(ii,i0+i2,1)-ca(ii,i0+i3,1)
         ct4i=ca(ii,i0+i2,2)-ca(ii,i0+i3,2)

         ct5r=     ct1r+ct2r
         ct5i=     ct1i+ct2i

         ct6r=r54*(ct1r-ct2r)
         ct6i=r54*(ct1i-ct2i)

         ct7r=ca(ii,i0  ,1)-0.25d0*ct5r
         ct7i=ca(ii,i0  ,2)-0.25d0*ct5i

         ct8r=ct7r+ct6r
         ct8i=ct7i+ct6i

         ct9r=ct7r-ct6r
         ct9i=ct7i-ct6i

         ct10r=-(sin72*ct3i+sin36*ct4i)
         ct10i= (sin72*ct3r+sin36*ct4r)

         ct11r=-(sin36*ct3i-sin72*ct4i)
         ct11i= (sin36*ct3r-sin72*ct4r)

         ct12r = ct8r + ct10r
         ct12i = ct8i + ct10i

         ct13r = ct9r + ct11r
         ct13i = ct9i + ct11i

         ct14r = ct9r - ct11r
         ct14i = ct9i - ct11i

         ct15r = ct8r - ct10r
         ct15i = ct8i - ct10i

         cb(ii,j0   ,1)=ca(ii,i0,1)+ct5r
         cb(ii,j0   ,2)=ca(ii,i0,2)+ct5i

         cb(ii,j0+j1,1)=ct12r*cw(1,kp*j1)-ct12i*cw(2,kp*j1)
         cb(ii,j0+j1,2)=ct12r*cw(2,kp*j1)+ct12i*cw(1,kp*j1)

         cb(ii,j0+j2,1)=ct13r*cw(1,kp*j2)-ct13i*cw(2,kp*j2)
         cb(ii,j0+j2,2)=ct13r*cw(2,kp*j2)+ct13i*cw(1,kp*j2)

         cb(ii,j0+j3,1)=ct14r*cw(1,kp*j3)-ct14i*cw(2,kp*j3)
         cb(ii,j0+j3,2)=ct14r*cw(2,kp*j3)+ct14i*cw(1,kp*j3)

         cb(ii,j0+j4,1)=ct15r*cw(1,kp*j4)-ct15i*cw(2,kp*j4)
         cb(ii,j0+j4,2)=ct15r*cw(2,kp*j4)+ct15i*cw(1,kp*j4)

   51 continue

      return
      end
c---------------------------------------------
      subroutine fsb_lp8(ca,cb,cw,la,n,ndim)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c---------------------------------------------
      implicit real*8(a-h,o-z)

      real*8 CA(ndim,n,2),CB(ndim,n,2),CW(2,0:n-1)
   
         R2=0.5D0
         X=DSQRT(R2)

         M   =N/8
         NP  =(M-LA)/LA
         JUMP=LA*7

      DO 80 L=1,LA
      DO 80 ii=1,ndim

      CC0r = CA(ii,l    ,1)+CA(ii,l+4*M,1)
      CC0i = CA(ii,l    ,2)+CA(ii,l+4*M,2)

      CC1r = CA(ii,l+  M,1)+CA(ii,l+5*M,1)
      CC1i = CA(ii,l+  M,2)+CA(ii,l+5*M,2)

      CC2r = CA(ii,l+2*M,1)+CA(ii,l+6*M,1)
      CC2i = CA(ii,l+2*M,2)+CA(ii,l+6*M,2)

      CC3r = CA(ii,l+3*M,1)+CA(ii,l+7*M,1)
      CC3i = CA(ii,l+3*M,2)+CA(ii,l+7*M,2)

      CC4r = CA(ii,l    ,1)-CA(ii,l+4*M,1)
      CC4i = CA(ii,l    ,2)-CA(ii,l+4*M,2)

      CC5r = CA(ii,l+  M,1)-CA(ii,l+5*M,1)
      CC5i = CA(ii,l+  M,2)-CA(ii,l+5*M,2)

      CC6r = -CA(ii,l+2*M,2)+CA(ii,l+6*M,2)
      CC6i =  CA(ii,l+2*M,1)-CA(ii,l+6*M,1)

      CC7r = -CA(ii,l+3*M,2)+CA(ii,l+7*M,2)
      CC7i =  CA(ii,l+3*M,1)-CA(ii,l+7*M,1)

         CD0r = CC0r+CC2r
         CD0i = CC0i+CC2i

         CD1r = CC1r+CC3r
         CD1i = CC1i+CC3i

         CD2r = CC4r+CC6r
         CD2i = CC4i+CC6i

            CE1r = CC5r+CC7r
            CE1i = CC5i+CC7i

         CD3r = (CE1r-CE1i)*x
         CD3i = (CE1r+CE1i)*x

         CD4r = CC0r-CC2r
         CD4i = CC0i-CC2i

         CD5r =-(CC1i-CC3i)
         CD5i = (CC1r-CC3r)

         CD6r = CC4r-CC6r
         CD6i = CC4i-CC6i

            CE2r = CC5r-CC7r
            CE2i = CC5i-CC7i

         CD7r = (-CE2r-CE2i)*x
         CD7i = ( CE2r-CE2i)*x

      CB(ii,l     ,1) = CD0r+CD1r
      CB(ii,l     ,2) = CD0i+CD1i

      CB(ii,l+  LA,1) = CD2r+CD3r
      CB(ii,l+  LA,2) = CD2i+CD3i

      CB(ii,l+2*LA,1) = CD4r+CD5r
      CB(ii,l+2*LA,2) = CD4i+CD5i

      CB(ii,l+3*LA,1) = CD6r+CD7r
      CB(ii,l+3*LA,2) = CD6i+CD7i

      CB(ii,l+4*LA,1) = CD0r-CD1r
      CB(ii,l+4*LA,2) = CD0i-CD1i

      CB(ii,l+5*LA,1) = CD2r-CD3r
      CB(ii,l+5*LA,2) = CD2i-CD3i

      CB(ii,l+6*LA,1) = CD4r-CD5r
      CB(ii,l+6*LA,2) = CD4i-CD5i

      CB(ii,l+7*LA,1) = CD6r-CD7r
      CB(ii,l+7*LA,2) = CD6i-CD7i

   80 CONTINUE
   
      DO 81 KP=1,NP
      DO 81 L=1,LA
      DO 81 ii=1,ndim

         I0=L+KP*LA
         J0=L+KP*(LA+JUMP)

      CC0r = CA(ii,I0    ,1)+CA(ii,I0+4*M,1)
      CC0i = CA(ii,I0    ,2)+CA(ii,I0+4*M,2)

      CC1r = CA(ii,I0+  M,1)+CA(ii,I0+5*M,1)
      CC1i = CA(ii,I0+  M,2)+CA(ii,I0+5*M,2)

      CC2r = CA(ii,I0+2*M,1)+CA(ii,I0+6*M,1)
      CC2i = CA(ii,I0+2*M,2)+CA(ii,I0+6*M,2)

      CC3r = CA(ii,I0+3*M,1)+CA(ii,I0+7*M,1)
      CC3i = CA(ii,I0+3*M,2)+CA(ii,I0+7*M,2)

      CC4r = CA(ii,I0    ,1)-CA(ii,I0+4*M,1)
      CC4i = CA(ii,I0    ,2)-CA(ii,I0+4*M,2)

      CC5r = CA(ii,I0+  M,1)-CA(ii,I0+5*M,1)
      CC5i = CA(ii,I0+  M,2)-CA(ii,I0+5*M,2)

      CC6r = -CA(ii,I0+2*M,2)+CA(ii,I0+6*M,2)
      CC6i =  CA(ii,I0+2*M,1)-CA(ii,I0+6*M,1)

      CC7r = -CA(ii,I0+3*M,2)+CA(ii,I0+7*M,2)
      CC7i =  CA(ii,I0+3*M,1)-CA(ii,I0+7*M,1)

         CD0r = CC0r+CC2r
         CD0i = CC0i+CC2i

         CD1r = CC1r+CC3r
         CD1i = CC1i+CC3i

         CD2r = CC4r+CC6r
         CD2i = CC4i+CC6i

            CE1r = CC5r+CC7r
            CE1i = CC5i+CC7i

         CD3r = (CE1r-CE1i)*x
         CD3i = (CE1r+CE1i)*x

         CD4r = CC0r-CC2r
         CD4i = CC0i-CC2i

         CD5r =-(CC1i-CC3i)
         CD5i = (CC1r-CC3r)

         CD6r = CC4r-CC6r
         CD6i = CC4i-CC6i

            CE2r = CC5r-CC7r
            CE2i = CC5i-CC7i

         CD7r = (-CE2r-CE2i)*x
         CD7i = ( CE2r-CE2i)*x

      CF1r = CD2r+CD3r
      CF1i = CD2i+CD3i

      CF2r = CD4r+CD5r
      CF2i = CD4i+CD5i

      CF3r = CD6r+CD7r
      CF3i = CD6i+CD7i

      CF4r = CD0r-CD1r
      CF4i = CD0i-CD1i

      CF5r = CD2r-CD3r
      CF5i = CD2i-CD3i

      CF6r = CD4r-CD5r
      CF6i = CD4i-CD5i

      CF7r = CD6r-CD7r
      CF7i = CD6i-CD7i

      CB(ii,J0     ,1) = CD0r+CD1r
      CB(ii,J0     ,2) = CD0i+CD1i

      CB(ii,J0+  LA,1) = CF1r*CW(1,KP*LA  )-CF1i*CW(2,KP*LA  )
      CB(ii,J0+  LA,2) = CF1r*CW(2,KP*LA  )+CF1i*CW(1,KP*LA  )

      CB(ii,J0+2*LA,1) = CF2r*CW(1,KP*LA*2)-CF2i*CW(2,KP*LA*2)
      CB(ii,J0+2*LA,2) = CF2r*CW(2,KP*LA*2)+CF2i*CW(1,KP*LA*2)

      CB(ii,J0+3*LA,1) = CF3r*CW(1,KP*LA*3)-CF3i*CW(2,KP*LA*3)
      CB(ii,J0+3*LA,2) = CF3r*CW(2,KP*LA*3)+CF3i*CW(1,KP*LA*3)

      CB(ii,J0+4*LA,1) = CF4r*CW(1,KP*LA*4)-CF4i*CW(2,KP*LA*4)
      CB(ii,J0+4*LA,2) = CF4r*CW(2,KP*LA*4)+CF4i*CW(1,KP*LA*4)

      CB(ii,J0+5*LA,1) = CF5r*CW(1,KP*LA*5)-CF5i*CW(2,KP*LA*5)
      CB(ii,J0+5*LA,2) = CF5r*CW(2,KP*LA*5)+CF5i*CW(1,KP*LA*5)

      CB(ii,J0+6*LA,1) = CF6r*CW(1,KP*LA*6)-CF6i*CW(2,KP*LA*6)
      CB(ii,J0+6*LA,2) = CF6r*CW(2,KP*LA*6)+CF6i*CW(1,KP*LA*6)

      CB(ii,J0+7*LA,1) = CF7r*CW(1,KP*LA*7)-CF7i*CW(2,KP*LA*7)
      CB(ii,J0+7*LA,2) = CF7r*CW(2,KP*LA*7)+CF7i*CW(1,KP*LA*7)

   81 CONTINUE
C**
      RETURN
      END
      subroutine setcw(cw,n)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
      use m_Const_Parameters, only : PAI
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      complex*16 cw(0:n-1)

c**      pai=3.14159265358979323846d0
      pc =2.0d0*pai/dble(n)

      do 10 i=0,n-1
         tr=dcos(pc*dble(i))
         ti=dsin(pc*dble(i))
         cw(i)=dcmplx(tr,ti)
   10 continue

      return
      end
      subroutine setlp(n,lp2,lp3,lp4,lp5,lp8)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
      implicit real*8(a-b,d-h,o-z)

         nn =n

         lp8=0
         lp5=0
         lp4=0
         lp3=0
         lp2=0

      do while(mod(nn,8).eq.0)
         lp8=lp8+1
         nn=nn/8
      end do

      do while(mod(nn,5).eq.0)
         lp5=lp5+1
         nn=nn/5
      end do

      do while(mod(nn,4).eq.0)
         lp4=lp4+1
         nn=nn/4
      end do

      do while(mod(nn,3).eq.0)
         lp3=lp3+1
         nn=nn/3
      end do

      do while(mod(nn,2).eq.0)
         lp2=lp2+1
         nn=nn/2
      end do

c     if(lp8+lp4+lp2.eq.0) stop 'n is not an even number.'
      if(nn.ne.1) stop 'n is an improper number.'

      return
      end
      subroutine trans_in_b0(ca,cb,idh,n2,n3,mm1,mm2,kc1,kc2,kc3)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1,0:n2-1 ,0:n3-1)
      real*8 cb(0:mm1-1,0:mm2-1,0:n3-1,2)

c     complex*16 ca(0:idh-1,0:n2-1 ,0:n3-1)
c     complex*16 cb(0:mm1-1,0:mm2-1,0:n3-1)
c*
      if(kc1.eq.0) then
         kk1 = mm1-1
      else
         kk1 = kc1
      end if 

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if 

c*
c* Packing from ca to cb
  
      do 10 i3=0,n3-1
      do 10 i2=0,kk2
      do 10 i1=0,kk1

         cb(i1,i2,i3,1) = ca(1,i1,i2,i3) 
         cb(i1,i2,i3,2) = ca(2,i1,i2,i3) 

  10  continue

      if(kc2.ne.0) then

         nskip2 = kc2*2+1-n2

         do 20 i3=0,n3-1
         do 20 i2=n2-kc2,n2-1
         do 20 i1=0,kk1

            cb(i1,i2+nskip2,i3,1) = ca(1,i1,i2,i3) 
            cb(i1,i2+nskip2,i3,2) = ca(2,i1,i2,i3) 

  20     continue

      end if
c*
      if(kc3.ne.0) then

         do 30 i3=kc3+1,n3-kc3-1
         do 30 i2=0,mm2-1
         do 30 i1=0,mm1-1

            cb(i1,i2,i3,1) = 0.0d0
            cb(i1,i2,i3,2) = 0.0d0

  30     continue

      end if
       
c*
      return
      end
      subroutine trans_in_b1(ca,cb,mm1,n2,mm2,n3,kc2)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)
      real*8 ca(0:mm1-1,0:mm2-1,0:n3-1,2)
      real*8 cb(0:mm1-1,0:n3-1 ,0:n2-1,2)

c     complex*16 ca(0:mm1-1,0:mm2-1,0:n3-1)
c     complex*16 cb(0:mm1-1,0:n3-1 ,0:n2-1)

c*
      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

c*
      do 10 i3=0,n3-1
      do 10 i2=0,kk2
      do 10 i1=0,mm1-1

         cb(i1,i3,i2,1) = ca(i1,i2,i3,1)
         cb(i1,i3,i2,2) = ca(i1,i2,i3,2)

  10  continue

c*
      if(kc2.ne.0) then

         do 20 i2=kc2+1,n2-kc2-1
         do 20 i3=0,n3-1
         do 20 i1=0,mm1-1

            cb(i1,i3,i2,1) = 0.0d0 
            cb(i1,i3,i2,2) = 0.0d0 

  20     continue

         nstep2 = kc2*2-n2+1

         do 30 i3=0,n3-1
         do 30 i2=n2-kc2,n2-1
         do 30 i1=0,mm1-1

            cb(i1,i3,i2,1) = ca(i1,i2+nstep2,i3,1)
            cb(i1,i3,i2,2) = ca(i1,i2+nstep2,i3,2)

  30     continue

      end if
c*

      return
      end
      subroutine trans_in_b2(ca,cb,mm1,n2,n3,n1h)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(0:mm1-1  ,0:n3*n2-1 ,2)
      real*8 cb(0:n3*n2-1,0:n1h     ,2)

c     real*8 cb(0:n3*n2-1,0:mm1-1   ,2)
c     complex*16 ca(0:mm1-1  ,0:n3*n2-1 )
c     complex*16 cb(0:n3*n2-1,0:mm1-1   )

         do 10 i2 = 0,n3*n2-1
         do 10 i1 = 0,mm1-1

            cb(i2,i1,1) = ca(i1,i2,1)
            cb(i2,i1,2) = ca(i1,i2,2)

 10      continue

c*
         do 20 i1 = mm1,n1h
         do 20 i2 = 0,n3*n2-1

            cb(i2,i1,1) = 0.0d0
            cb(i2,i1,2) = 0.0d0

 20      continue

c*

      return
      end 
      subroutine trans_in_b3(cb,ca,cw1,nn,n1h,kc1)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 cb(nn,0:n1h  ,2)
      real*8 ca(nn,0:n1h-1,2)

c     complex*16 cb(nn,0:idh-1)
c     complex*16 ca(nn,0:idh-1)

      real*8 cw1(2,0:n1h-1)
c     complex*16 cw1(0:n1h-1)

      real*8 r0,r1
      real*8 rr0,rr1,ri0,ri1

c*
      do 10 ii=1,nn

         r0 = cb(ii,  0,1)
         r1 = cb(ii,n1h,1)

c        r0 = dble(cb(ii,  0))
c        r1 = dble(cb(ii,n1h))

         ca(ii,0,1)= r0 + r1 
         ca(ii,0,2)= r0 - r1 

c        ca(ii,0)=dcmplx( r0 + r1 , r0 - r1 )

  10  continue

      do 20 k1=1,n1h-1
      do 20 ii=1,nn

         rr0 = cb(ii,k1,1)
         ri0 = cb(ii,k1,2)

         rr1 = cb(ii,n1h-k1,1)
         ri1 = cb(ii,n1h-k1,2)

c        rr2 = rr0 + rr1 
c        ri2 = ri0 - ri1 

         rr3 = rr0 - rr1 
         ri3 = ri0 + ri1 

         ca(ii,k1,1) = rr0 + rr1 + rr3*cw1(1,k1) - ri3*cw1(2,k1)
         ca(ii,k1,2) = ri0 - ri1 + rr3*cw1(2,k1) + ri3*cw1(1,k1)

c        ca(ii,k1)=   cb(ii,k1)+dconjg(cb(ii,n1h-k1))
c    &             + (cb(ii,k1)-dconjg(cb(ii,n1h-k1)))*cw1(k1) 

  20  continue 

      return
      end 
      subroutine trans_in_b4(cb,ca,n3,n2,idh,n1h) 
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

c**
      implicit real*8(a-h,o-z)

      real*8 cb(0:n3-1 ,0:n2-1,0:n1h-1,2)
      real*8 ca(2,0:idh-1,0:n2-1,0:n3-1 )

c     complex*16 cb(0:n3-1 ,0:n2-1,0:idh-1)
c     complex*16 ca(0:idh-1,0:n2-1,0:n3-1 )
c**
         do 10 i1=0,n1h-1
         do 10 i2=0,n2-1
         do 10 i3=0,n3-1

            ca(1,i1,i2,i3) = cb(i3,i2,i1,1)
            ca(2,i1,i2,i3) = cb(i3,i2,i1,2)

  10     continue

         do 20 i3=0,n3-1
         do 20 i2=0,n2-1
         do 20 i1=n1h,idh-1

            ca(1,i1,i2,i3) = 0.0d0
            ca(2,i1,i2,i3) = 0.0d0

  20     continue

c**
      return
      end
      subroutine trans_in_f1(ca,cb,idh,n1h,n2,n3,
     &                       mm2,mm3,kc1,kc2,kc3)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1,0:n2-1,0:n3-1)
      real*8 cb(0:mm3-1,0:mm2-1,0:n1h-1,2)

c***
      if(kc1.eq.0) then
         kk1 = n1h-1
      else
         kk1 = kc1
      end if

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3
      end if
c**

         do 10 i3=0,kk3
         do 10 i2=0,kk2
         do 10 i1=0,kk1

            cb(i3,i2,i1,1) =   ca(1,i1,i2,i3) 
            cb(i3,i2,i1,2) = - ca(2,i1,i2,i3) 

   10    continue

c**
      if(kc2.ne.0) then

         do 20 i3=0,kk3
         do 20 i2=n2-kc2,n2-1
         do 20 i1=0,kk1

            ii2 = i2 + mm2 - n2
            cb(i3,ii2,i1,1) =   ca(1,i1,i2,i3) 
            cb(i3,ii2,i1,2) = - ca(2,i1,i2,i3) 

   20    continue
  
      end if
c**
      if(kc3.ne.0) then

         do 30 i3=n3-kc3,n3-1
         do 30 i2=0,kk2
         do 30 i1=0,kk1

            ii3 = i3 + mm3 - n3
            cb(ii3,i2,i1,1) =   ca(1,i1,i2,i3) 
            cb(ii3,i2,i1,2) = - ca(2,i1,i2,i3) 

   30    continue

      end if
c**
      if(kc2.ne.0.and.kc3.ne.0) then

         do 40 i3=n3-kc3,n3-1
         do 40 i2=n2-kc2,n2-1
         do 40 i1=0,kk1

            ii2 = i2 + mm2 - n2
            ii3 = i3 + mm3 - n3
            cb(ii3,ii2,i1,1) =   ca(1,i1,i2,i3) 
            cb(ii3,ii2,i1,2) = - ca(2,i1,i2,i3) 

   40    continue

      end if
c**
         do 50 i1=kk1+1,n1h-1
         do 50 i2=0,mm2-1
         do 50 i3=0,mm3-1

            cb(i3,i2,i1,1) = 0.0d0
            cb(i3,i2,i1,2) = 0.0d0

   50    continue
c**

      return
      end
      subroutine trans_in_f2(ca,cb,cw1,mm3,mm2,n1h)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8 (a-h,o-z)

      real*8 ca(mm3*mm2,0:n1h-1,2)
      real*8 cb(mm3*mm2,0:n1h  ,2)
      real*8 cw1(2,0:n1h-1)

c     complex*16 ca(mm3*mm2,0:n1h)
c     complex*16 cb(mm3*mm2,0:n1h)
c     complex*16 cw1(0:n1h-1)

      real*8 rr,ri
c**
      do i32 = 1,mm3*mm2

         rr = ca(i32,0,1)
         ri = ca(i32,0,2)

c        rr = dble (ca(i32,0))
c        ri = dimag(ca(i32,0))
       
         cb(i32,0  ,1) = rr-ri
         cb(i32,n1h,1) = rr+ri

         cb(i32,0  ,2) = 0.0d0 
         cb(i32,n1h,2) = 0.0d0 

c        cb(i32,0  )=dcmplx(rr-ri,0.0d0)
c        cb(i32,n1h)=dcmplx(rr+ri,0.0d0)

      end do
c**   
      do k1  = 1,n1h-1
      do ii = 1,mm3*mm2

         rr0 = ca(ii,k1,1)
         ri0 = ca(ii,k1,2)

         rr1 = ca(ii,n1h-k1,1)
         ri1 = ca(ii,n1h-k1,2)

c        rr2 = rr0 + rr1
c        ri2 = ri0 - ri1

         rr3 = rr0 - rr1
         ri3 = ri0 + ri1

         cb(ii,k1,1) = (rr0 + rr1 + rr3*cw1(1,k1) - ri3*cw1(2,k1))*0.5d0
         cb(ii,k1,2) = (ri0 - ri1 + rr3*cw1(2,k1) + ri3*cw1(1,k1))*0.5d0


c     cb(i32,k1) = ( ca(i32,k1)+dconjg(ca(i32,n1h-k1))
c    &            +( ca(i32,k1)-dconjg(ca(i32,n1h-k1)) )*cw1(k1))
c    &            * 0.5d0

      end do
      end do

      return
      end
      subroutine trans_in_f3(cb,ca,mm3,n2,mm2,n1h,kc2)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(0:mm3-1,0:n1h,0:n2-1,2)
      real*8 cb(0:mm3-1,0:mm2-1,0:n1h,2)
c     complex*16 ca(0:mm3-1,0:idh-1,0:n2-1)
c     complex*16 cb(0:mm3-1,0:mm2-1,0:idh-1)

c***********************************************
c**   transpose between 2nd axis and 3rd axis.
c***********************************************

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2 
      end if

      do 10 i1=0,n1h
      do 10 i2=0,kk2
      do 10 i3=0,mm3-1

         ca(i3,i1,i2,1) = cb(i3,i2,i1,1)
         ca(i3,i1,i2,2) = cb(i3,i2,i1,2)

  10  continue  

c**
      if(kc2.ne.0) then

         do 30 ii2=kk2+1,n2-kc2-1
         do 30 i1=0,n1h
         do 30 i3=0,mm3-1

            ca(i3,i1,ii2,1) = 0.0d0
            ca(i3,i1,ii2,2) = 0.0d0

  30     continue  

         do 20 i1=0,n1h
         do 20 i2=kk2+1,mm2-1
         do 20 i3=0,mm3-1

            ii2 = i2 + n2 - mm2
            ca(i3,i1,ii2,1) = cb(i3,i2,i1,1)
            ca(i3,i1,ii2,2) = cb(i3,i2,i1,2)

  20     continue  

      end if
c**
      return
      end
      subroutine trans_in_f4(cb,ca,n1h,n2,n3,mm3,kc3)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca((n1h+1)*n2 ,0:n3-1,2)
      real*8 cb(0:mm3-1,(n1h+1)*n2,2)
c     complex*16 ca(0:idh-1,0:n2-1 ,0:n3-1)
c     complex*16 cb(0:mm3-1,0:idh-1,0:n2-1)

c*
      if(kc3.eq.0) then
         kk3 = n3 - 1
      else
         kk3 = kc3
      end if

c     do 10 i2 =0,n2-1  
      do 10 i12 =1,(n1h+1)*n2
      do 10 i3 =0,kk3
      
         ca(i12,i3,1) = cb(i3,i12,1)
         ca(i12,i3,2) = cb(i3,i12,2)

  10  continue

c**
      if(kc3.ne.0) then

         do 20 ii3 = kk3+1,n3-kc3-1
c        do 20 i2 = 0,n2-1
         do 20 i12 =1,(n1h+1)*n2
      
            ca(i12,ii3,1) = 0.0d0
            ca(i12,ii3,2) = 0.0d0

  20     continue

c        do 30 i2 = 0,n2-1
         do 30 i12 =1,(n1h+1)*n2
         do 30 i3 = kk3+1,mm3-1
      
            ii3 = i3 + n3 - mm3 
            ca(i12,ii3,1) = cb(i3,i12,1)
            ca(i12,ii3,2) = cb(i3,i12,2)

  30     continue

      end if
c**
      return
      end


      subroutine trans_in_f5(cb,ca,idh,n1h,n2,n3)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1,0:n2*n3-1)
      real*8 cb(  0:n1h  ,0:n2*n3-1,2)
c     complex*16 ca(0:idh-1,0:n2-1,0:n3-1)
c     complex*16 cb(0:idh-1,0:n2-1,0:n3-1)
c*
      do 10 i23=0,n2*n3-1 
      do 10 i1=0,n1h 

         ca(1,i1,i23) =   cb(i1,i23,1)
         ca(2,i1,i23) = - cb(i1,i23,2)
c        ca(i1,i2,i3) = dconjg(cb(i1,i2,i3))

  10  continue                        

      do 20 i1=n1h+1,idh-1 
      do 20 i23=0,n2*n3-1 

         ca(1,i1,i23) = 0.0d0
         ca(2,i1,i23) = 0.0d0 

  20  continue                        

c*

      return
      end
      subroutine trans_out_b0(ca,cb,idh,n2,n3,n1h)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1,n2*n3)
      real*8 cb(0:n1h,n2*n3,2)

c     complex*16 ca(0:idh*n2*n3-1)
c     complex*16 cb(0:idh*n2*n3-1)
c*
  
      do 10 ii=1,n2*n3
      do 10  i=0,n1h   

         cb(i,ii,1) = ca(1,i,ii) 
         cb(i,ii,2) = ca(2,i,ii) 

  10  continue

c*
      return
      end
      subroutine trans_out_b1(ca,cb,n1h,n2,n3,mm3,kc3)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      real*8 ca(0:n1h,0:n2-1  ,0:n3-1,2)
      real*8 cb(0:n1h,0:mm3-1 ,0:n2-1,2)

c     complex*16 ca(0:idh-1,0:n2-1  ,0:n3-1)
c     complex*16 cb(0:idh-1,0:mm3-1 ,0:n2-1)

c*
      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3
      end if

c*
      do 10 i3=0,kk3
      do 10 i2=0,n2-1
      do 10 i1=0,n1h  

         cb(i1,i3,i2,1) = ca(i1,i2,i3,1)
         cb(i1,i3,i2,2) = ca(i1,i2,i3,2)

  10  continue

c*
      if(kc3.ne.0) then

         do 30 i3=n3-kc3,n3-1
         do 30 i2=0,n2-1
         do 30 i1=0,n1h   

            ii3 = i3 + mm3 - n3
            cb(i1,ii3,i2,1) = ca(i1,i2,i3,1)
            cb(i1,ii3,i2,2) = ca(i1,i2,i3,2)

  30     continue

      end if
c*

      return
      end
      subroutine trans_out_b2(ca,cb,n1h,n2,mm2,mm3,kc2)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)
      real*8 ca(0:n1h,0:mm3-1,0:n2-1 ,2)
      real*8 cb(0:mm3-1,0:mm2-1,0:n1h,2)

c     complex*16 ca(0:idh-1,0:mm3-1,0:n2-1 )
c     complex*16 cb(0:mm3-1,0:mm2-1,0:idh-1)

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2 
      end if

         do 10 i2 = 0,kk2
         do 10 i3 = 0,mm3-1
         do 10 i1 = 0,n1h   

            cb(i3,i2,i1,1) = ca(i1,i3,i2,1)
            cb(i3,i2,i1,2) = ca(i1,i3,i2,2)

 10      continue

      if(kc2.ne.0) then

         do 20 i2 = n2-kc2,n2-1
         do 20 i3 = 0,mm3-1
         do 20 i1 = 0,n1h   

            ii2 = i2 + mm2 - n2
            cb(i3,ii2,i1,1) = ca(i1,i3,i2,1)
            cb(i3,ii2,i1,2) = ca(i1,i3,i2,2)

 20      continue

      end if

      return
      end
      subroutine trans_out_b3(cb,ca,cw1,nn,n1h)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 cb(nn,0:n1h  ,2)
      real*8 ca(nn,0:n1h-1,2)
      real*8 cw1(2,0:n1h-1)

c     complex*16 cb(nn,0:n1h)
c     complex*16 ca(nn,0:n1h-1)
c     complex*16 cw1(0:n1h-1)

      real*8 r0,r1

c**
      do 10 ii=1,nn

         r0 = cb(ii,  0,1)
         r1 = cb(ii,n1h,1)

c        r0 = dble(cb(ii,  0))
c        r1 = dble(cb(ii,n1h))

         ca(ii,0,1)= r0 + r1 
         ca(ii,0,2)= r0 - r1 

c        ca(ii,0)=dcmplx( r0 + r1 , r0 - r1 )

  10  continue

      do 20 k1=1,n1h-1
      do 20 ii=1,nn

         rr0 = cb(ii,k1,1)
         ri0 = cb(ii,k1,2)

         rr1 = cb(ii,n1h-k1,1)
         ri1 = cb(ii,n1h-k1,2)

c        rr2 = rr0 + rr1
c        ri2 = ri0 - ri1

         rr3 = rr0 - rr1
         ri3 = ri0 + ri1

         ca(ii,k1,1) = rr0 + rr1 + rr3*cw1(1,k1) - ri3*cw1(2,k1)
         ca(ii,k1,2) = ri0 - ri1 + rr3*cw1(2,k1) + ri3*cw1(1,k1)

c        ca(ii,k1)=   cb(ii,k1)+dconjg(cb(ii,n1h-k1))
c    &             + (cb(ii,k1)-dconjg(cb(ii,n1h-k1)))*cw1(k1) 

  20  continue 

      return
      end 
      subroutine trans_out_b4(cb,ca,idh,n1h,n2,n3,mm2,mm3,
     &                        kc1,kc2,kc3) 
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-h,o-z)

      real*8 cb(0:mm3-1 ,0:mm2-1,0:n1h-1,2)
      real*8 ca(2,0:idh-1 ,0:n2-1 ,0:n3-1 )

c     complex*16 cb(0:mm3-1 ,0:mm2-1,0:idh-1)
c     complex*16 ca(0:idh-1 ,0:n2-1 ,0:n3-1 )
c**
      if(kc1.eq.0) then
         kk1 = n1h-1
      else
         kk1 = kc1
      end if

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3
      end if
c**
      do 100 i3 = 0,n3-1
      do 100 i2 = 0,n2-1
      do 100 i1 = 0,idh-1

         ca(1,i1,i2,i3) = 0.0d0
         ca(2,i1,i2,i3) = 0.0d0

 100  continue

c**
      do 10 i1=0,kk1
      do 10 i2=0,kk2
      do 10 i3=0,kk3

         ca(1,i1,i2,i3) = cb(i3,i2,i1,1)
         ca(2,i1,i2,i3) = cb(i3,i2,i1,2)

  10  continue
c**
      if(kc2.ne.0) then

         do 20 i1=0,kk1
         do 20 i2=kc2+1,kc2+kc2
         do 20 i3=0,kk3

            ii2 = i2 + n2-1-kc2*2
            ca(1,i1,ii2,i3) = cb(i3,i2,i1,1)
            ca(2,i1,ii2,i3) = cb(i3,i2,i1,2)

  20     continue

      end if
c**
      if(kc3.ne.0) then

         do 30 i1=0,kk1
         do 30 i2=0,kk2
         do 30 i3=kc3+1,kc3+kc3

            ii3 = i3 + n3-1-kc3*2
            ca(1,i1,i2,ii3) = cb(i3,i2,i1,1)
            ca(2,i1,i2,ii3) = cb(i3,i2,i1,2)

  30     continue

      end if
c**
      if(kc2.ne.0.and.kc3.ne.0) then

         do 40 i1=0,kk1
         do 40 i2=kc2+1,kc2+kc2
         do 40 i3=kc3+1,kc3+kc3

            ii2 = i2 + n2-1-kc2*2
            ii3 = i3 + n3-1-kc3*2
            ca(1,i1,ii2,ii3) = cb(i3,i2,i1,1)
            ca(2,i1,ii2,ii3) = cb(i3,i2,i1,2)

  40     continue

      end if

c**
      return
      end  
      subroutine trans_out_f1(ca,cb,idh,n1h,n2,n3)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1,0:n2-1,0:n3-1)
      real*8 cb(0:n3-1 ,0:n2-1,0:n1h-1,2)

c     complex*16 ca(0:m1-1,0:m2-1,0:m3-1),cb(0:m3-1,0:m2-1,0:m1-1)

c***
         do 10 i3=0,n3-1
         do 10 i2=0,n2-1
         do 10 i1=0,n1h-1

            cb(i3,i2,i1,1) =   ca(1,i1,i2,i3) 
            cb(i3,i2,i1,2) = - ca(2,i1,i2,i3) 

   10    continue

      return
      end
      subroutine trans_out_f2(ca,cb,cw1,n3,n2,n1h,kc1)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(n3*n2,0:n1h-1,2)
      real*8 cb(n3*n2,0:n1h  ,2)
      real*8 cw1(2,0:n1h-1)
      real*8 rr,ri
c**
      do i32 = 1,n3*n2

         rr = ca(i32,0,1)
         ri = ca(i32,0,2)
c        rr = dble (ca(i32,0))
c        ri = dimag(ca(i32,0))

         cb(i32,0  ,1) = rr-ri
         cb(i32,n1h,1) = rr+ri

         cb(i32,0  ,2) = 0.0d0
         cb(i32,n1h,2) = 0.0d0

c        rr = dble (ca(i32,0))
c        ri = dimag(ca(i32,0))
       
c        cb(i32,0  )=dcmplx(rr-ri,0.0d0)
c        cb(i32,n1h)=dcmplx(rr+ri,0.0d0)

      end do
c**   
      if(kc1.eq.0) then
         mm = n1h-1
      else
         mm = kc1
      end if
c**
      do k1  = 1,mm
      do ii = 1,n3*n2

         rr0 = ca(ii,k1,1)
         ri0 = ca(ii,k1,2)

         rr1 = ca(ii,n1h-k1,1)
         ri1 = ca(ii,n1h-k1,2)

         rr2 = rr0 + rr1
         ri2 = ri0 - ri1

         rr3 = rr0 - rr1
         ri3 = ri0 + ri1

         cb(ii,k1,1) = ( rr2 + rr3*cw1(1,k1) - ri3*cw1(2,k1) )*0.5d0
         cb(ii,k1,2) = ( ri2 + rr3*cw1(2,k1) + ri3*cw1(1,k1) )*0.5d0

c     cb(i32,k1) = ( ca(i32,k1)+dconjg(ca(i32,n1h-k1))
c    &            +( ca(i32,k1)-dconjg(ca(i32,n1h-k1)) )*cw1(k1))
c    &            * 0.5d0

      end do
      end do

      return
      end
      subroutine trans_out_f3(cb,ca,n3,n2,mm1,n1h)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)
      real*8 ca(n3,0:mm1-1,n2,2)
      real*8 cb(n3,n2,0:n1h,2)

c***********************************************
c**   transpose between 2nd axis and 3rd axis.
c***********************************************

      do 10 i1=0,mm1-1
      do 10 i2=1,n2
      do 10 i3=1,n3

         ca(i3,i1,i2,1) = cb(i3,i2,i1,1)
         ca(i3,i1,i2,2) = cb(i3,i2,i1,2)

  10  continue  

      return
      end
      subroutine trans_out_f4(cb,ca,n3,mm1,n2,mm2,kc2)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)
      real*8 ca(0:mm1-1,0:mm2-1, 0:n3-1,2)
      real*8 cb(0:n3-1 ,0:mm1-1, 0:n2-1,2)

c*
      if(kc2.eq.0) then
         kk2 = n2 - 1
      else
         kk2 = kc2
      end if

      do 10 i2 =0,kk2  
      do 10 i1 =0,mm1-1
      do 10 i3 =0,n3-1
      
         ca(i1,i2,i3,1) = cb(i3,i1,i2,1)
         ca(i1,i2,i3,2) = cb(i3,i1,i2,2)

  10  continue

c*
      if(kc2.ne.0) then

         do 20 i2 = -kc2,-1
         do 20 i1 =    0,mm1-1
         do 20 i3 =    0,n3-1
      
            ii2 = i2 + kc2*2 + 1 
            ca(i1,ii2,i3,1) = cb(i3,i1,i2+n2,1)
            ca(i1,ii2,i3,2) = cb(i3,i1,i2+n2,2)

  20     continue

      end if

c*
      return
      end
      subroutine trans_out_f5(cb,ca,idh,n1h,n2,n3,mm1,mm2,kc1,kc2,kc3)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)
      real*8 ca(2,0:idh-1,0:n2-1 ,0:n3-1 )
      real*8 cb(0:mm1-1,0:mm2-1,0:n3-1 ,2)
c*
      if(kc1.eq.0) then
           kk1 = n1h
      else
           kk1 = kc1
      end if

      if(kc2.eq.0) then
           kk2 = n2-1
      else
           kk2 = kc2
      end if

      if(kc3.eq.0) then
           kk3 = n3-1
      else
           kk3 = kc3
      end if
c*

      do 100 i3=0,n3-1 
      do 100 i2=0,n2-1 
      do 100 i1=0,idh-1 

         ca(1,i1,i2,i3) = 0.0d0
 100     ca(2,i1,i2,i3) = 0.0d0

c*

      do 10 i3=0,kk3 
      do 10 i2=0,kk2 
      do 10 i1=0,kk1 

         ca(1,i1,i2,i3) =    cb(i1,i2,i3,1)
         ca(2,i1,i2,i3) =  - cb(i1,i2,i3,2)

  10  continue 

      if(kc2.ne.0) then

         nskip2 = n2-1-kc2*2

         do 11 i3=0,kk3 
         do 11 i2=kc2+1,kc2*2 
         do 11 i1=0,kk1 

            ca(1,i1,i2+nskip2,i3) =   cb(i1,i2,i3,1)
            ca(2,i1,i2+nskip2,i3) = - cb(i1,i2,i3,2)

  11     continue 

      end if

c******************************
      if(kc3.ne.0) then
c******************************

      do 20 i3=n3-kc3,n3-1 
      do 20 i2=0,kk2 
      do 20 i1=0,kk1 

         ca(1,i1,i2,i3) =   cb(i1,i2,i3,1)
         ca(2,i1,i2,i3) = - cb(i1,i2,i3,2)

  20  continue 

      if(kc2.ne.0) then

         nskip2 = n2-1-kc2*2

         do 21 i3=n3-kc3,n3-1 
         do 21 i2=kc2+1,kc2*2 
         do 21 i1=0,kk1 

            ca(1,i1,i2+nskip2,i3) =   cb(i1,i2,i3,1)
            ca(2,i1,i2+nskip2,i3) = - cb(i1,i2,i3,2)

  21     continue 

      end if

c******************************
      end if
c******************************

      return
      end
      subroutine jrcat_c3ft(ca,cwork,id,n1,n2,n3,cw1,cw2,cw3,
     &                      kc1,kc2,kc3,key)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

c********************************************************************************
c*    3 dimensional complex to complex FFT with mask
c*    either for input array or output array,
c*    developed by T.Sanada (sanada@think.com) on 1996.01.04.
c*    It is specified for Fujitsu VPP500.
c********************************************************************************

      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

c------------------>      for Estimation of CPU cost.
c                             by T.Yamasaki
c                               22th May. 1996
      real*8 CRTVL, PCPUDF
      parameter (CRTVL = 1.d-5, PCPUDF = 2.0)
c        CRTVL : CRItical VaLue for Division.
c        PCPUDF: Percent of CPU DiFference.
      real*8 cpu0ol,cpudif,rcpudf,ecpu,tcpu
      integer icount
      data icount/0/
      data ecpu/0.d0/
      data cpu0ol/0.d0/
      real*8 t_start, t_end, UMICRO
      parameter (UMICRO = 1.d-6)
c <-------------------------------------------

      complex*16 ca    (id,n2,n3)
      complex*16 cwork (id,n2,n3)

      complex*16 cw1(0:n1-1)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank

c********************************************************************************
c*   key = 0 : set up of FFT.
c*             ( Calculation of cw1,cw2 and cw3. )
c********************************************************************************
c*   n1,n2 and n3 must include radix 2, and they may include 3 or 5.
c*   id must be n1 + 2.
c*
c********************************************************************************
c*  key = -1 & -2 : F.T. of complex 3d array ca(0:n1-1,0:n2-1,0:n3-1) .
c********************************************************************************
c*
c*   The result(complex 'cb') is overwritten on 'ca'.
c*   
c*     cb(k1,k2,k3) 
c*   = sum(ix=0:n1-1,iy=0:n2-1,iz=0:n3-1) 
c*     ca(i1,i2,i3) exp [- 2 * pai * ci * ( k1*i1/n1 + k2*i2/n2 + k3*i3/n3 ) ]
c*     
c*     where 0 <= k1 <= n1/2, 0 <= k2 <= n2-1, 0 <= k3 <= n3-1.
c*
c********************************************************************************
c*  key = +1 & +2: Inverse F.T. of copmplex 3d array cb(0:n1/2,0:n2-1,0:n3-1) .
c********************************************************************************
c*   Transform from 'cb' to 'ra'.
c*
c********************************************************************************
c*  kc1,kc2 kc3 are integer parameters specifying the mask for
c*  input data or output data.
c*
c*     If kc1.ge.n1/2.or.kc1.lt.0, then kc1 is forced to be 0. 
c*     If kc2.ge.n2/2.or.kc2.lt.0, then kc2 is forced to be 0. 
c*     If kc3.ge.n3/2.or.kc3.lt.0, then kc3 is forced to be 0. 
c*
c********************************************************************************
c** REMARK on Mask.
c********************************************************************************
c*
c*  key = -1 : Mask is for Output data ( cb ),
c*  key = +1 : Mask is for Input  data ( cb ),
c*  key = -2 : Mask is for Input  data ( ca ),
c*  key = +2 : Mask is for Output data ( ca ),
c*
c*     where ca(0:idh/2,0:n2-1,0:n3-1) and equivalence(ra,ca).
c*
c********************************************************************************
c*     Mask for Output data:
c********************************************************************************
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full wavenumber
c*     range is calculated.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" range is calculated.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2 <= n2-1" 
c*     range is calculated.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3 <= n3-1" 
c*     range is calculated.
c*
c********************************************************************************
c*     Mask for Input data:
c********************************************************************************
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full wavenumber
c*     range is used to obtain real array 'ra'.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" range is used.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2 <= n2-1" 
c*     range is used.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3 <= n3-1" 
c*     range is used.
c*
c********************************************************************************
c*
c******************************************************************
c**   choose nbank = 0 or nbank = 1 
c******************************************************************
c*   nbank = 0:
c*      The transpose is normally implemented.
c*      Bank conflict may appear patriculary in Vector Computers.
c*   nbank = 1:
c*      The transpose is implemented so as to prevent
c*      the bank conflict in the case the conflict may appear.
c******************************************************************
c
      call gettod(t_start)

      nbank = 0

c**

      if(key.eq.0) then

c** set up of FFT.

         call c3ft_0(cw1,cw2,cw3,n1,n2,n3)

         goto 1001
c$$$         return

      end if

c**
      if(kc1.ge.n1/2.or.kc1.lt.0) then 
         write(6,*) 'warning in FFT: kc1 is irrelevant.'
         write(6,*) 'kc1 has changed to be 0.'
         kc1 = 0
      end if

      if(kc2.ge.n2/2.or.kc2.lt.0) then 
         write(6,*) 'warning in FFT: kc2 is irrelevant.'
         write(6,*) 'kc2 has changed to be 0.'
         kc2 = 0
      end if

      if(kc3.ge.n3/2.or.kc3.lt.0) then 
         write(6,*) 'warning in FFT: kc3 is irrelevant.'
         write(6,*) 'kc3 has changed to be 0.'
         kc3 = 0
      end if

c******************************************
      if(key.eq.-1.or.key.eq.+2) then
c******************************************

c** Forword  FFT with mask for output.
c** Backword FFT with mask for output.

         call c3ft_mask_for_out(ca,cwork,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank,key)

c******************************************
      else 
c******************************************

c** Forword  FFT with mask for input.
c** Backword FFT with mask for input.

         call c3ft_mask_for_in (ca,cwork,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank,key)


c******************************************
      end if
c******************************************

 1001 continue

c -------->  CPU cost estimation
      call gettod(t_end)
      tcpu = (t_end - t_start)*UMICRO
      icount = icount + 1
      ecpu = ecpu + tcpu
c <-------

      return
      entry jrc_c3strt
      icount = 0
      ecpu = 0.d0
      return
c--------------------------
      entry jrc_c3end
      cpudif = dabs(cpu0ol - ecpu)
      if(ecpu.gt.CRTVL) then
         rcpudf = cpudif/ecpu * 100.0
      else if(cpu0ol.le.CRTVL) then
         rcpudf = 0.0
      else
         rcpudf = 100.0
      endif
c               <-- Ratio in percent of CPU time difference
c                 between previous one and present one.
      cpu0ol = ecpu

c$$$      call eqivvl(rcpudf)

      if(rcpudf.gt.PCPUDF) then
         if(icount.gt.0) then
            tcpu = ecpu/dfloat(icount)
         endif
         write(6,9001) ecpu, icount, tcpu
 9001    format(1H ,' <<CPU TIME for JRCAT_C3FT = ',f11.3
     &        ,'(Sec.) = (',i6,' *',f10.5,')>>')
      endif
      return
      end  

      subroutine c3ft_0(cw1,cw2,cw3,n1,n2,n3)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      complex*16 cw1(0:n1-1)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

c**
         call setcw(cw1,n1)
         call setcw(cw2,n2)
         call setcw(cw3,n3) 

      return
      end  

      subroutine c3ft_mask_for_in(ca,cb,id,n1,n2,n3,cw1,cw2,cw3,
     &                            kc1,kc2,kc3,nbank,key)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (0:id-1,0:n2-1,0:n3-1,2)
      real*8 cb (0:id-1,0:n2-1,0:n3-1,2)

c     complex*16 ca (0:id-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1-1)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank
c**
      if(kc1.eq.0) then
           mm1 = n1
      else
           mm1 = kc1*2+1
      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if

c$$$      if(kc3.eq.0) then
c$$$           mm3 = n3
c$$$      else
c$$$           mm3 = kc3*2+1
c$$$      end if

c** Packin from ca(2,0:id-1,0:n2-1,0:n3-1) to cb(0:mm1-1,0:mm2-1,0:n3-1,2)

      call trans_in_c0(ca,cb,id,n1,n2,n3,mm1,mm2,kc1,kc2,kc3,key)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw3,n3,mm1*mm2,lp2,lp3,lp4,lp5,lp8)

c** cb(i1,i3,i2,2) <- ca(i1,i2,i3,2)

      call trans_in_c1(ca,cb,mm1,n2,mm2,n3,kc2)

c** Length:n2 CFFT    

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw2,n2,mm1*n3,lp2,lp3,lp4,lp5,lp8) 

c** cb(i3,i2,i1,2) <- ca(i1,i3,i2,2)

      call trans_in_c2(ca,cb,n1,mm1,n2,n3,kc1)

c** Length:n1 CFFT  

      call setlp(n1,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw1,n1,n3*n2,lp2,lp3,lp4,lp5,lp8)

c** cb(2,i1,i2,i3) <- ca(i3,i2,i1,2)

      call trans_in_c3(ca,cb,n3,n2,n1,id,key)

c** ca(2,i1,i2,i3) <- cb(2,i1,i2,i3)

      call trans_in_c4(cb,ca,id,n2,n3)   

      return

      end  

      subroutine c3ft_mask_for_out(ca,cb,id,n1,n2,n3,
     &                        cw1,cw2,cw3,
     &                        kc1,kc2,kc3,nbank,key)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (0:id-1,0:n2-1,0:n3-1,2)
      real*8 cb (0:id-1,0:n2-1,0:n3-1,2)

c     complex*16 ca (0:id-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1-1)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank

c$$$      if(kc1.eq.0) then
c$$$           mm1 = n1
c$$$      else
c$$$           mm1 = kc1*2+1
c$$$      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if

      if(kc3.eq.0) then
           mm3 = n3
      else
           mm3 = kc3*2+1
      end if

c** cb(i1,i2,i3,2) <- ca(2,i1,i2,i3)

      call trans_out_c0(ca,cb,id,n1,n2,n3,key)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw3,n3,n1*n2,lp2,lp3,lp4,lp5,lp8)

c** cb(i1,i3,i2,2) <- ca(i1,i2,i3,2)

      call trans_out_c1(ca,cb,n1,n2,n3,mm3,kc3)

c** Length:n2 CFFT    

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw2,n2,n1*mm3,lp2,lp3,lp4,lp5,lp8) 

c** cb(i3,i2,i1,2) <- ca(i1,i3,i2,2)

      call trans_out_c2(ca,cb,n1,n2,mm2,mm3,kc2)

c** Length:n1 CFFT  

      call setlp(n1,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw1,n1,mm3*mm2,lp2,lp3,lp4,lp5,lp8)

c** cb(2,i1,i2,i3) <- ca(i3,i2,i1,2)

      call trans_out_c3(ca,cb,id,n1,n2,n3,mm2,mm3,kc1,kc2,kc3,key)

c** ca(2,i1,i2,i3) <- cb(2,i1,i2,i3)

      call trans_out_c4(cb,ca,id,n2,n3)

      return
      end
      subroutine trans_in_c0(ca,cb,id,n1,n2,n3,mm1,mm2,kc1,kc2,kc3,key)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:id-1 ,0:n2-1 ,0:n3-1)
      real*8 cb(0:mm1-1,0:mm2-1,0:n3-1,2)

      real*8 parity
c*
      if(kc1.eq.0) then
         kk1 = n1-1
      else
         kk1 = kc1
      end if

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3
      end if
c*
      if(key.eq.+1.or.key.eq.+2) then
         parity = +1.0d0
      else
         parity = -1.0d0
      end if

c*
      do 10 i3=0,n3-1
      do 10 i2=0,mm2-1
      do 10 i1=0,mm1-1

         cb(i1,i2,i3,1)=0.0d0
         cb(i1,i2,i3,2)=0.0d0

 10   continue
c*
      do 20 i3=0,kk3
      do 20 i2=0,kk2
      do 20 i1=0,kk1

         cb(i1,i2,i3,1) = ca(1,i1,i2,i3)
         cb(i1,i2,i3,2) = ca(2,i1,i2,i3) * parity

 20   continue

      if(kc1.ne.0) then

         do 30 i3=0,kk3
         do 30 i2=0,kk2
         do 30 i1=n1-kc1,n1-1
     
            ii1 = i1 + mm1 - n1
            cb(ii1,i2,i3,1) = ca(1,i1,i2,i3)
            cb(ii1,i2,i3,2) = ca(2,i1,i2,i3) * parity

 30      continue

      end if

      if(kc2.ne.0) then

         do 40 i3=0,kk3
         do 40 i2=n2-kc2,n2-1
         do 40 i1=0,kk1
     
            ii2 = i2 + mm2 - n2
            cb(i1,ii2,i3,1) = ca(1,i1,i2,i3)
            cb(i1,ii2,i3,2) = ca(2,i1,i2,i3) * parity

 40      continue

      end if

      if(kc3.ne.0) then

         do 50 i3=n3-kc3,n3-1
         do 50 i2=0,kk2
         do 50 i1=0,kk1
     
            ii3 = i3 
            cb(i1,i2,ii3,1) = ca(1,i1,i2,i3)
            cb(i1,i2,ii3,2) = ca(2,i1,i2,i3) * parity

 50      continue

      end if

      if(kc1.ne.0.and.kc2.ne.0) then

         do 60 i3=0,kk3
         do 60 i2=n2-kc2,n2-1
         do 60 i1=n1-kc1,n1-1
     
            ii1 = i1 + mm1 - n1
            ii2 = i2 + mm2 - n2
            cb(ii1,ii2,i3,1) = ca(1,i1,i2,i3)
            cb(ii1,ii2,i3,2) = ca(2,i1,i2,i3) * parity

 60      continue

      end if

      if(kc1.ne.0.and.kc3.ne.0) then

         do 70 i3=n3-kc3,n3-1
         do 70 i2=0,kk2
         do 70 i1=n1-kc1,n1-1
     
            ii1 = i1 + mm1 - n1
            ii3 = i3 
            cb(ii1,i2,ii3,1) = ca(1,i1,i2,i3)
            cb(ii1,i2,ii3,2) = ca(2,i1,i2,i3) * parity

 70      continue

      end if

      if(kc2.ne.0.and.kc3.ne.0) then

         do 80 i3=n3-kc3,n3-1
         do 80 i2=n2-kc2,n2-1
         do 80 i1=0,kk1
     
            ii2 = i2 + mm2 - n2
            ii3 = i3 
            cb(i1,ii2,ii3,1) = ca(1,i1,i2,i3)
            cb(i1,ii2,ii3,2) = ca(2,i1,i2,i3) * parity

 80      continue

      end if

      if(kc1.ne.0.and.kc2.ne.0.and.kc3.ne.0) then

         do 90 i3=n3-kc3,n3-1
         do 90 i2=n2-kc2,n2-1
         do 90 i1=n1-kc1,n1-1
     
            ii1 = i1 + mm1 - n1
            ii2 = i2 + mm2 - n2
            ii3 = i3 
            cb(ii1,ii2,ii3,1) = ca(1,i1,i2,i3)
            cb(ii1,ii2,ii3,2) = ca(2,i1,i2,i3) * parity

 90      continue

      end if

      return
      end
      subroutine trans_in_c1(ca,cb,mm1,n2,mm2,n3,kc2)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(0:mm1-1,0:mm2-1,0:n3-1,2)
      real*8 cb(0:mm1-1,0:n3-1 ,0:n2-1,2)

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      do 10 i3=0,n3-1
      do 10 i2=0,kk2
      do 10 i1=0,mm1-1

         cb(i1,i3,i2,1) = ca(i1,i2,i3,1)
         cb(i1,i3,i2,2) = ca(i1,i2,i3,2)

  10  continue

      if(kc2.ne.0) then

         do 20 i2=kk2+1,n2-kc2-1
         do 20 i3=0,n3-1
         do 20 i1=0,mm1-1

            cb(i1,i3,i2,1) = 0.0d0
            cb(i1,i3,i2,2) = 0.0d0

  20     continue

         do 30 i2=n2-kc2,n2-1
         do 30 i3=0,n3-1
         do 30 i1=0,mm1-1

            ii2 = i2 + mm2 - n2
            cb(i1,i3,i2,1) = ca(i1,ii2,i3,1)
            cb(i1,i3,i2,2) = ca(i1,ii2,i3,2)

  30     continue

      end if

      return
      end
      subroutine trans_in_c2(ca,cb,n1,mm1,n2,n3,kc1)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(0:mm1-1  ,0:n3*n2-1,2)
      real*8 cb(0:n3*n2-1,0:n1-1   ,2)

      if(kc1.eq.0) then
         kk1 = n1-1
      else
         kk1 = kc1
      end if

c**
      do 10 i1 = 0,kk1
      do 10 i32 = 0,n3*n2-1

         cb(i32,i1,1) = ca(i1,i32,1)
         cb(i32,i1,2) = ca(i1,i32,2)

  10  continue

      if(kc1.ne.0) then

         do 20 i1 = kk1+1,n1-kc1-1
         do 20 i32 = 0,n3*n2-1

            cb(i32,i1,1) = 0.0d0
            cb(i32,i1,2) = 0.0d0

  20     continue

         do 30 i1 = n1-kc1,n1-1
         do 30 i32 = 0,n3*n2-1

            ii1 = i1 + mm1 - n1
            cb(i32,i1,1) = ca(ii1,i32,1)
            cb(i32,i1,2) = ca(ii1,i32,2)

  30     continue

      end if

      return
      end
      subroutine trans_in_c3(ca,cb,n3,n2,n1,id,key)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(0:n3-1,0:n2-1,0:n1-1,2)
      real*8 cb(2,0:id-1,0:n2-1,0:n3-1)

      real*8 parity
c*
      if(key.eq.+1.or.key.eq.+2) then
         parity = +1.0d0
      else
         parity = -1.0d0
      end if
c*
      do 10 i3=0,n3-1
      do 10 i2=0,n2-1
      do 10 i1=n1,id-1

         cb(1,i1,i2,i3) = 0.0d0
         cb(2,i1,i2,i3) = 0.0d0

  10  continue

      do 20 i1=0,n1-1
      do 20 i2=0,n2-1
      do 20 i3=0,n3-1

         cb(1,i1,i2,i3) = ca(i3,i2,i1,1)
         cb(2,i1,i2,i3) = ca(i3,i2,i1,2) * parity

  20  continue

      return
      end

      subroutine trans_in_c4(cb,ca,id,n2,n3)   
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 cb(id*n2*n3*2)
      real*8 ca(id*n2*n3*2)

      do 10 ii=1,id*n2*n3*2

         ca(ii) = cb(ii)

 10   continue

      return
      end
      subroutine trans_out_c0(ca,cb,id,n1,n2,n3,key)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(2,id,n2*n3)
      real*8 cb(n1,n2*n3,2)

      real*8 parity
c*
      if(key.eq.+1.or.key.eq.+2) then
         parity = +1.0d0
      else
         parity = -1.0d0
      end if
c*
      do 10 i23=1,n2*n3
      do 10 i1=1,n1

         cb(i1,i23,1) = ca(1,i1,i23)
         cb(i1,i23,2) = ca(2,i1,i23) * parity

 10   continue

      return
      end 
      subroutine trans_out_c1(ca,cb,n1,n2,n3,mm3,kc3)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(0:n1-1,0:n2-1 ,0:n3-1,2)
      real*8 cb(0:n1-1,0:mm3-1,0:n2-1,2)

      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3  
      end if

      do 10 i3=0,kk3
      do 10 i2=0,n2-1
      do 10 i1=0,n1-1

         cb(i1,i3,i2,1) = ca(i1,i2,i3,1)
         cb(i1,i3,i2,2) = ca(i1,i2,i3,2)

 10   continue

      if(kc3.ne.0) then

         do 20 i3=n3-kc3,n3-1
         do 20 i2=0,n2-1
         do 20 i1=0,n1-1

            ii3 = i3 + mm3 - n3
            cb(i1,ii3,i2,1) = ca(i1,i2,i3,1)
            cb(i1,ii3,i2,2) = ca(i1,i2,i3,2)

 20      continue

      end if

      return
      end
      subroutine trans_out_c2(ca,cb,n1,n2,mm2,mm3,kc2)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(0:n1-1 ,0:mm3-1,0:n2-1,2)
      real*8 cb(0:mm3-1,0:mm2-1,0:n1-1,2)

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      do 10 i2 = 0,kk2
      do 10 i3 = 0,mm3-1
      do 10 i1 = 0,n1-1
   
         cb(i3,i2,i1,1) = ca(i1,i3,i2,1)
         cb(i3,i2,i1,2) = ca(i1,i3,i2,2)

  10  continue

      if(kc2.ne.0) then

      do 20 i2 = n2-kc2,n2-1
      do 20 i3 = 0,mm3-1
      do 20 i1 = 0,n1-1
   
         ii2 = i2 + mm2 - n2
         cb(i3,ii2,i1,1) = ca(i1,i3,i2,1)
         cb(i3,ii2,i1,2) = ca(i1,i3,i2,2)

  20  continue

      end if

      return
      end
      subroutine trans_out_c3(ca,cb,id,n1,n2,n3,mm2,mm3,kc1,kc2,kc3,key)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(0:mm3-1,0:mm2-1,0:n1-1,2)
      real*8 cb(2,0:id-1 ,0:n2-1 ,0:n3-1)

      real*8 parity
c*
      if(key.eq.+1.or.key.eq.+2) then
         parity = +1.0d0
      else
         parity = -1.0d0
      end if
c*

      do 1 i3=0,n3-1
      do 1 i2=0,n2-1
      do 1 i1=0,id-1

         cb(1,i1,i2,i3) = 0.0d0
         cb(2,i1,i2,i3) = 0.0d0

  1   continue

      if(kc1.eq.0) then
         kk1 = n1-1
      else
         kk1 = kc1
      end if

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3
      end if

      do 10 i1 = 0,kk1
      do 10 i3 = 0,kk3
      do 10 i2 = 0,kk2

         cb(1,i1,i2,i3) = ca(i3,i2,i1,1)
         cb(2,i1,i2,i3) = ca(i3,i2,i1,2) * parity

  10  continue

      if(kc1.ne.0) then

      do 20 i1 = n1-kc1,n1-1
      do 20 i3 = 0,kk3
      do 20 i2 = 0,kk2

         ii1 = i1
         cb(1,i1,i2,i3) = ca(i3,i2,ii1,1)
         cb(2,i1,i2,i3) = ca(i3,i2,ii1,2) * parity

  20  continue

      end if

      if(kc2.ne.0) then

      do 30 i1 = 0,kk1
      do 30 i3 = 0,kk3
      do 30 i2 = n2-kc2,n2-1

         ii2 = i2 + mm2 - n2
         cb(1,i1,i2,i3) = ca(i3,ii2,i1,1)
         cb(2,i1,i2,i3) = ca(i3,ii2,i1,2) * parity

  30  continue

      end if

      if(kc3.ne.0) then

      do 40 i1 = 0,kk1
      do 40 i3 = n3-kc3,n3-1
      do 40 i2 = 0,kk2

         ii3 = i3 + mm3 - n3
         cb(1,i1,i2,i3) = ca(ii3,i2,i1,1)
         cb(2,i1,i2,i3) = ca(ii3,i2,i1,2) * parity

  40  continue

      end if

      if(kc1.ne.0.and.kc2.ne.0) then

      do 50 i1 = n1-kc1,n1-1
      do 50 i3 = 0,kk3
      do 50 i2 = n2-kc2,n2-1

         ii1 = i1
         ii2 = i2 + mm2 - n2
         cb(1,i1,i2,i3) = ca(i3,ii2,ii1,1)
         cb(2,i1,i2,i3) = ca(i3,ii2,ii1,2) * parity

  50  continue

      end if

      if(kc1.ne.0.and.kc3.ne.0) then

      do 60 i1 = n1-kc1,n1-1
      do 60 i3 = n3-kc3,n3-1
      do 60 i2 = 0,kk2

         ii1 = i1
         ii3 = i3 + mm3 - n3
         cb(1,i1,i2,i3) = ca(ii3,i2,ii1,1)
         cb(2,i1,i2,i3) = ca(ii3,i2,ii1,2) * parity

  60  continue

      end if

      if(kc2.ne.0.and.kc3.ne.0) then

      do 70 i1 = 0,kk1
      do 70 i3 = n3-kc3,n3-1
      do 70 i2 = n2-kc2,n2-1

         ii2 = i2 + mm2 - n2
         ii3 = i3 + mm3 - n3
         cb(1,i1,i2,i3) = ca(ii3,ii2,i1,1)
         cb(2,i1,i2,i3) = ca(ii3,ii2,i1,2) * parity

  70  continue

      end if

      if(kc1.ne.0.and.kc2.ne.0.and.kc3.ne.0) then

      do 80 i1 = n1-kc1,n1-1
      do 80 i3 = n3-kc3,n3-1
      do 80 i2 = n2-kc2,n2-1

         ii1 = i1
         ii2 = i2 + mm2 - n2
         ii3 = i3 + mm3 - n3
         cb(1,i1,i2,i3) = ca(ii3,ii2,ii1,1)
         cb(2,i1,i2,i3) = ca(ii3,ii2,ii1,2) * parity

  80  continue

      end if

      return
      end
      subroutine trans_out_c4(cb,ca,id,n2,n3)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(id*n2*n3*2)
      real*8 cb(id*n2*n3*2)

c*
      do 10 ii=1,id*n2*n3*2

         ca(ii) = cb(ii)

 10   continue

      return
      end
#else
!
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c---------------------------------------------
      subroutine jrcat_c3ft(ca,cwork,id,n1,n2,n3,cw1,cw2,cw3,
     &                      kc1,kc2,kc3,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
c
c------------------>      for Estimation of CPU cost.
c                             by T.Yamasaki
c                               22th May. 1996
      real*8 CRTVL, PCPUDF
      parameter (CRTVL = 1.d-5, PCPUDF = 2.0)
c        CRTVL : CRItical VaLue for Division.
c        PCPUDF: Percent of CPU DiFference.
      real*8 cpu0ol,cpudif,rcpudf,ecpu,tcpu
      integer icount
      data icount/0/
      data ecpu/0.d0/
      data cpu0ol/0.d0/
      real*8 t_start, t_end, UMICRO
      parameter (UMICRO = 1.d-6)
c <-------------------------------------------
      dimension ca    (id,n2,n3)
      dimension cwork (id+n2+n3,2)

      dimension cw1(0:n1-1)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer key

c*******************************************************************************
c*  3 DIMENSIONAL FAST FOURIER TRANSFORM OF COMPLEX ARRAY WITH MASK,
c*                developed on 1997.6.5.
c*                modified  on 1998.5.18.
c*******************************************************************************
c*  
c*  The 3-dimensional array ca(id,n2,n3) is fourier-transfomed and
c*  its result is overwritten on ca. The size of fourier-transformed is
c*  (n1,n2,n3) and hence id must be larger than or equal to n1.
c*  Also n1,n2 and n3 must be radix 2,3,5 integers.
c*
c*  cwork is complex work array and the size must be at least (id+n2+n3)*2
c*
c*******************************************************************************
c*  How to set the value of key.
c*
c*(1) key = 0       : set up of FFT 
c*    
c*     Calculations of cw1,cw2 and cw3.
c*
c*(2) key = -1 & -2 : 
c*
c*     Forward F.T. of complex 3d array ca(0:id-1,0:n2-1,0:n3-1),
c*
c*     here the definition of fourier-transform is
c*  
c*       cb(k1,k2,k3) 
c*     = sum(i1=0:n1-1,i2=0:n2-1,i3=0:n3-1) 
c*       ca(i1,i2,i3) exp [- 2 * pai * ci * ( k1*i1/n1 + k2*i2/n2 + k3*i3/n3 ) ]
c*     
c*        where 0 <= k1 <= n1-1, 0 <= k2 <= n2-1, 0 <= k3 <= n3-1,
c*              and ci is the imaginary unit.
c*
c*    The result(complex array cb(0:id-1,0:n2-1,0:n3-1)) is overwritten on 'ca'.
c*
c*(3) key = +1 & +2 : 
c*
c*     Inverse F.T. of complex 3d array cb(0:id-1,0:n2-1,0:n3-1) 
c*                   to ca(0:id-1,0:n2-1,0:n3-1).
c*
c*******************************************************************************
c*  How to set the mask.
c*
c*  kc1,kc2,kc3 and key are integer parameters specifying the mask for
c*  input data or output data.
c*
c*     key = -1 : Mask is for Output data ( cb ),
c*     key = +1 : Mask is for Input  data ( cb ),
c*     key = -2 : Mask is for Input  data ( ca ),
c*     key = +2 : Mask is for Output data ( ca ),
c*
c*     If kc1.ge.n1/2.or.kc1.lt.0, then kc1 is forced to be 0. 
c*     If kc2.ge.n2/2.or.kc2.lt.0, then kc2 is forced to be 0. 
c*     If kc3.ge.n3/2.or.kc3.lt.0, then kc3 is forced to be 0. 
c*
c*     where ca(0:id-1,0:n2-1,0:n3-1) is equivalent to cb.
c*
c*******************************************************************************
c*  Mask for Output data:
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full 
c*     range is calculated.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" and "n1-kc1 <= k1 <= n1-1" 
c*     range is calculated.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2 <= n2-1" 
c*     range is calculated.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3 <= n3-1" 
c*     range is calculated.
c*
c*******************************************************************************
c*  Mask for Input data:
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full 
c*     range is used to obtain complex array 'ca'.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" and "n1-kc1 <= k1 <= n1-1" 
c*     range is calculated.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2 <= n2-1" 
c*     range is used.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3 <= n3-1" 
c*     range is used.
c*
c*******************************************************************************
c
      call gettod(t_start)

c** Set up of FFT.
      if(key.eq.0) then
         call c3ft_0(cw1,cw2,cw3,n1,n2,n3)
         return
      end if
c**
      if(kc1.ge.n1/2.or.kc1.lt.0) then 
         write(6,*) 'warning in JRCAT_C3FT: kc1 is irrelevant.'
         write(6,*) 'kc1 has changed to be 0.'
         kc1 = 0
      end if
c*
      if(kc2.ge.n2/2.or.kc2.lt.0) then 
         write(6,*) 'warning in JRCAT_C3FT: kc2 is irrelevant.'
         write(6,*) 'kc2 has changed to be 0.'
         kc2 = 0
      end if
c*
      if(kc3.ge.n3/2.or.kc3.lt.0) then 
         write(6,*) 'warning in JRCAT_C3FT: kc3 is irrelevant.'
         write(6,*) 'kc3 has changed to be 0.'
         kc3 = 0
      end if
c**
      if(key.eq.-1.or.key.eq.-2) then
         call c3ft_conj(cw1,n1)
         call c3ft_conj(cw2,n2)
         call c3ft_conj(cw3,n3)
      end if
c********************************************************************
      if(key.eq.-1.or.key.eq.+2) then
c********************************************************************
c*  Forword or Backword FFT with mask for output.

         call c3ft_mask_for_out(ca,cwork,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,key)

c********************************************************************
      else 
c********************************************************************
c*  Forword or Backword FFT with mask for input.

         call c3ft_mask_for_in (ca,cwork,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,key)

c********************************************************************
      end if
c********************************************************************
      if(key.eq.-1.or.key.eq.-2) then
         call c3ft_conj(cw1,n1)
         call c3ft_conj(cw2,n2)
         call c3ft_conj(cw3,n3)
      end if
c**  
c -------->  CPU cost estimation
      call gettod(t_end)
      tcpu = (t_end - t_start)*UMICRO
      icount = icount + 1
      ecpu = ecpu + tcpu
c <-------

      return
      entry jrc_c3strt
      icount = 0
      ecpu = 0.d0
      return
c--------------------------
      entry jrc_c3end
      cpudif = dabs(cpu0ol - ecpu)
      if(ecpu.gt.CRTVL) then
         rcpudf = cpudif/ecpu * 100.0
      else if(cpu0ol.le.CRTVL) then
         rcpudf = 0.0
      else
         rcpudf = 100.0
      endif
c               <-- Ratio in percent of CPU time difference
c                 between previous one and present one.
      cpu0ol = ecpu

c$$$      call eqivvl(rcpudf)

      if(rcpudf.gt.PCPUDF) then
         if(icount.gt.0) then
            tcpu = ecpu/dfloat(icount)
         endif
         write(6,9001) ecpu, icount, tcpu
 9001    format(1H ,' <<CPU TIME for JRCAT_C3FT = ',f11.3
     &        ,'(Sec.) = (',i6,' *',f10.5,')>>')
      endif
      return
      end  

c---------------------------------------------
      subroutine jrcat_r3ft(ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                      kc1,kc2,kc3,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
c
c------------------>      for Estimation of CPU cost.
c                             by T.Yamasaki
c                               22th May. 1996
      real*8 CRTVL, PCPUDF
      parameter (CRTVL = 1.d-5, PCPUDF = 2.0)
c        CRTVL : CRItical VaLue for Division.
c        PCPUDF: Percent of CPU DiFference.
      real*8 cpu0ol,cpudif,rcpudf,ecpu,tcpu
      integer icount
      data icount/0/
      data ecpu/0.d0/
      data cpu0ol/0.d0/
      real*8 t_start, t_end, UMICRO
      parameter (UMICRO = 1.d-6)
c <-------------------------------------------

      dimension ra   (id,n2,n3)
      dimension work (id+n2+n3,2)

      dimension cw1(0:n1-1)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer key 

c*******************************************************************************
c*  3 DIMENSIONAL FAST FOURIER TRANSFORM OF REAL ARRAY WITH MASK,
c*                developed on 1997.6.5.
c*******************************************************************************
c*
c*  The 3-dimensional array ra(id,n2,n3) is fourier-transfomed and
c*  its result is overwritten on ra. The size of fourier-transformed is
c*  (n1,n2,n3) and n1 axis is the complex conjugate axis. id must be n1 + 2.
c*  Also n1 must be an even number and n1,n2 and n3 must be radix 2,3,5
c*  integers.
c*
c*  work is real work array and the size must be at least (id+n2+n3)*2.
c*
c*******************************************************************************
c*  How to set the value of key.
c*
c*(1) key = 0 : set up of FFT.
c*
c*    Calculation of cw1,cw2 and cw3. 
c*
c*(2) key = -1 & -2 :
c*
c*    F.T. of real 3d array ra(0:id-1,0:n2-1,0:n3-1),
c*
c*    here the definition of fourier-transform is
c*
c*     cb(k1,k2,k3) 
c*   = sum(i1=0:n1-1,i2=0:n2-1,i3=0:n3-1) 
c*     ra(i1,i2,i3) exp [- 2 * pai * ci * ( k1*i1/n1 + k2*i2/n2 + k3*i3/n3 ) ]
c*     
c*     where 0 <= k1 <= n1/2, 0 <= k2 <= n2-1, 0 <= k3 <= n3-1.
c*           and ci is the imaginary unit.
c*
c*  The result(complex array cb(0:id/2-1,0:n2-1,0:n3-1)) is overwritten on 'ra'.
c*
c*(3) key = +1 & +2 :
c*
c*     Inverse F.T. of complex 3d array cb(0:id/2-1,0:n2-1,0:n3-1)
c*                   to ra(0:id-1,0:n2-1,0:n3-1).
c*
c*******************************************************************************
c*  How to set the mask.
c*
c*  kc1,kc2 kc3 and key are integer parameters specifying the mask for
c*  input data or output data.
c*
c*     key = -1 : Mask is for Output data ( cb ),
c*     key = +1 : Mask is for Input  data ( cb ),
c*     key = -2 : Mask is for Input  data ( ca ),
c*     key = +2 : Mask is for Output data ( ca ),
c*
c*     If kc1.ge.n1/2.or.kc1.lt.0, then kc1 is forced to be 0. 
c*     If kc2.ge.n2/2.or.kc2.lt.0, then kc2 is forced to be 0. 
c*     If kc3.ge.n3/2.or.kc3.lt.0, then kc3 is forced to be 0. 
c*
c*  where ca(0:id/2-1,0:n2-1,0:n3-1) are equivalent to ra(0:id-1,0:n2-1,0:n3-1).
c*
c*******************************************************************************
c*  Mask for Output data:
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full 
c*     range is calculated.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" range is calculated.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2 <= n2-1" 
c*     range is calculated.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3 <= n3-1" 
c*     range is calculated.
c*
c*******************************************************************************
c*  Mask for Input data:
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full wavenumber
c*     range is used to obtain real array 'ra'.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" range is used.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2 <= n2-1" 
c*     range is used.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3 <= n3-1" 
c*     range is used.
c*
c*******************************************************************************
c
      call gettod(t_start)

      if(mod(n1,2).ne.0) then
         write(6,*) 'ERROR in JRCAT_R3FT: n1 is not an even number.'
         stop
      end if
c*******************************************************************************
      if(key.eq.0) then
c** set up of FFT.
         call r3ft_0(cw1,cw2,cw3,n1,n2,n3)
         return
      end if
c*******************************************************************************
      if(id.ne.n1+2) then
         write(6,*) 'ERROR in JRCAT_R3FT: id is not n1+2.'
         stop
      end if
c*******************************************************************************
      if(kc1.ge.n1/2.or.kc1.lt.0) then 
         write(6,*) 'warning in JRCAT_R3FT: kc1 is irrelevant.'
         write(6,*) 'kc1 has changed to be 0.'
         kc1 = 0
      end if

      if(kc2.ge.n2/2.or.kc2.lt.0) then 
         write(6,*) 'warning in JRCAT_R3FT: kc2 is irrelevant.'
         write(6,*) 'kc2 has changed to be 0.'
         kc2 = 0
      end if

      if(kc3.ge.n3/2.or.kc3.lt.0) then 
         write(6,*) 'warning in JRCAT_R3FT: kc3 is irrelevant.'
         write(6,*) 'kc3 has changed to be 0.'
         kc3 = 0
      end if
c*******************************************************************************
      if(key.eq.-1) then  
c** Forword FFT with mask for output.
         call r3ft_f_mask_for_out(ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                            kc1,kc2,kc3)
      else if(key.eq.-2) then
c** Forword FFT with mask for input.
         call r3ft_f_mask_for_in (ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                            kc1,kc2,kc3)
      else if(key.eq.+1) then
c** Backword FFT with mask for input.
         call r3ft_b_mask_for_in (ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                            kc1,kc2,kc3)
      else if(key.eq.+2) then
c** Backword FFT with mask for output.
         call r3ft_b_mask_for_out(ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                            kc1,kc2,kc3)
      end if
c*******************************************************************************
c -------->  CPU cost estimation
      call gettod(t_end)
      tcpu = (t_end - t_start)*UMICRO
      icount = icount + 1
      ecpu = ecpu + tcpu
c <-------
      return

      entry jrc_r3strt
      icount = 0
      ecpu = 0.d0
      return
c--------------------------
      entry jrc_r3end
      cpudif = dabs(cpu0ol - ecpu)
      if(ecpu.gt.CRTVL) then
         rcpudf = cpudif/ecpu * 100.0
      else if(cpu0ol.le.CRTVL) then
         rcpudf = 0.0
      else
         rcpudf = 100.0
      endif
c               <-- Ratio in percent of CPU time difference
c                 between previous one and present one.
      cpu0ol = ecpu

c$$$      call eqivvl(rcpudf)

      if(rcpudf.gt.PCPUDF) then
         if(icount.gt.0) then
            tcpu = ecpu/dfloat(icount)
         endif
         write(6,9001) ecpu, icount, tcpu
 9001    format(1H ,' <<CPU TIME for JRCAT_R3FT = ',f11.3
     &        ,'(Sec.) = (',i6,' *',f10.5,')>>')
      endif
      return
      end  
c---------------------------------------------
      subroutine c3ft_0(cw1,cw2,cw3,n1,n2,n3)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      dimension cw1(0:n1-1)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

         call setcw(cw1,n1)
         call setcw(cw2,n2)
         call setcw(cw3,n3) 

      return
      end  
c---------------------------------------------
      subroutine c3ft_conj(cw,nn)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension cw(nn) 

      do 10 ii=1,nn
         cw(ii) = dconjg(cw(ii))
  10  continue
c 10  end do

      return
      end 
c---------------------------------------------
      subroutine c3ft_mask_for_in(ca,cwork,id,n1,n2,n3,
     &                            cw1,cw2,cw3,kc1,kc2,kc3,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      dimension ca   (0:id-1,0:n2-1,0:n3-1)
      dimension cwork(*)

      dimension cw1(0:n1-1)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer key
      integer lp(8,3)
c**
      if(kc2.eq.0) then
           nk2 = n2
      else
           nk2 = kc2+1
      end if
      if(kc3.eq.0) then
           nk3 = n3
      else
           nk3 = kc3+1
      end if
c**
      call setlp(n1,lp(1,1))
      call setlp(n2,lp(1,2))
      call setlp(n3,lp(1,3))
c**
      call c3ft_zeroset(ca,id,n1,n2,n3,kc1,kc2,kc3)

c** Length:n1&n2 CFFT    
      do 10 i3=0,n3-1
         if(i3.le.nk3-1.or.i3.ge.n3-kc3) then
         do 11 i2=0,nk2-1
            call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1,lp(1,1),key)
  11     continue
c 11     end do
         do 12 i2=n2-kc2,n2-1 
            call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1,lp(1,1),key)
  12     continue
c 12     end do
         call fsb_lp235v(ca(0,0,i3),cwork,cw2,n2,id,1,n1,lp(1,2),key) 
         end if
  10  continue
c 10  end do

c** Length:n3 CFFT  
      call fsb_lp235v(ca,cwork,cw3,n3,id*n2,1,id*n2,lp(1,3),key)
c**
      return
      end
c---------------------------------------------
      subroutine c3ft_mask_for_out(ca,cwork,id,n1,n2,n3,
     &                             cw1,cw2,cw3,kc1,kc2,kc3,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      dimension ca   (0:id-1,0:n2-1,0:n3-1)
      dimension cwork(*)

      dimension cw1(0:n1-1)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer key         
      integer lp(8,3)
c**
      if(kc2.eq.0) then
           nk2 = n2
      else
           nk2 = kc2+1
      end if
      if(kc3.eq.0) then
           nk3 = n3
      else
           nk3 = kc3+1
      end if
c**
      call setlp(n1,lp(1,1))
      call setlp(n2,lp(1,2))
      call setlp(n3,lp(1,3))

c** Length:n3 CFFT  
      call fsb_lp235v(ca,cwork,cw3,n3,id*n2,1,id*n2,lp(1,3),key)

c** Length:n2 & n1 CFFT    
      do 10 i3=0,n3-1
         if(i3.le.nk3-1.or.i3.ge.n3-kc3) then
            call fsb_lp235v(ca(0,0,i3),cwork,cw2,n2,id,1,n1,lp(1,2),key) 
         do 11 i2=0,nk2-1
            call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1,lp(1,1),key)
  11     continue
c 11     end do
         do 12 i2=n2-kc2,n2-1 
            call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1,lp(1,1),key)
  12     continue
c 12     end do
         end if
  10  continue
c 10  end do
c**
      call c3ft_zeroset(ca,id,n1,n2,n3,kc1,kc2,kc3)
c**
      return
      end
c---------------------------------------------
      subroutine c3ft_zeroset(ca,id,n1,n2,n3,kc1,kc2,kc3)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:id-1,0:n2-1,0:n3-1)

      do 10 i3=0,n3-1
      do 10 i2=0,n2-1
      do 10 i1=n1,id-1
         ca(i1,i2,i3) = (0.0d0,0.0d0)
 10   continue
c10   end do

      if(kc1.ne.0) then
      do 20 i3=0,n3-1
      do 20 i2=0,n2-1
      do 20 i1=kc1+1,n1-kc1-1
         ca(i1,i2,i3) = (0.0d0,0.0d0)
 20   continue
c20   end do
      end if

      if(kc2.ne.0) then
      do 30 i3=0,n3-1
      do 30 i2=kc2+1,n2-kc2-1
      do 30 i1=0,id-1
         ca(i1,i2,i3) = (0.0d0,0.0d0)
 30   continue
c30   end do
      end if

      if(kc3.ne.0) then
      do 40 i3=kc3+1,n3-kc3-1
      do 40 i2=0,n2-1
      do 40 i1=0,id-1
         ca(i1,i2,i3) = (0.0d0,0.0d0)
 40   continue
c40   end do
      end if

      return
      end 
c---------------------------------------------
      subroutine r3ft_0(cw1,cw2,cw3,n1,n2,n3)
c---------------------------------------------
      use m_Const_Parameters, only : PAI
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      dimension cw1(0:n1/2-1,2)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)
c**
      n1h = n1/2

      call setcw(cw1,n1h)
      call setcw(cw2,n2 )
      call setcw(cw3,n3 ) 

c**      pai=3.14159265358979323846d0
      pc =2.0d0*pai/dble(n1)
      ci=(0.0d0,1.0d0)

      do i=0,n1h-1
         tr=dcos(pc*dble(i))
         ti=dsin(pc*dble(i))
c        cw1(i,2)=ci*dcmplx(tr,ti)
         cw1(i,2)=dcmplx(-ti,tr)
      end do   
c**
      return
      end  

c---------------------------------------------
      subroutine r3ft_b_mask_for_in (ca,cwork,id,n1,n2,n3,
     &                               cw1,cw2,cw3,kc1,kc2,kc3)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      dimension ca   (0:id/2-1,0:n2-1,0:n3-1)
      dimension cwork(*)

      dimension cw1(0:n1/2-1,2)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer lp(8,3)
c**
      n1h = n1/2
      idh = id/2
c**
      if(kc1.eq.0) then
           nk1 = idh
      else
           nk1 = kc1+1
      end if

      if(kc3.eq.0) then
           nk3 = n3
      else
           nk3 = kc3+1
      end if
c**
      call setlp(n1h,lp(1,1))
      call setlp(n2 ,lp(1,2))
      call setlp(n3 ,lp(1,3))
c**
      call r3ft_zeroset(ca,id,n1,n2,n3,kc1,kc2,kc3)
    
c** Length:n2 CFFT
      do 10 i3=0,n3-1
         if(i3.le.nk3-1.or.i3.ge.n3-kc3) then
      call fsb_lp235v(ca(0,0,i3),cwork,cw2,n2,idh,1,nk1,lp(1,2),+1)
         end if
  10  end do

c** Length:n3 CFFT
      if(kc1.eq.0) then
         call fsb_lp235v(ca,cwork,cw3,n3,idh*n2,1,idh*n2,lp(1,3),+1)
      else
         do 20 nn1=1,idh*(n2-1)+1,idh
            nn2=nn1+nk1-1
         call fsb_lp235v(ca,cwork,cw3,n3,idh*n2,nn1,nn2,lp(1,3),+1)
  20     continue
c 20     end do
      end if

c** Length:n1h RFFT
      do 30 i3=0,n3-1
      do 30 i2=0,n2-1
         call trans_b(ca(0,i2,i3),cw1(0,2),n1h,0)
         call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1h,lp(1,1),+1)
  30  continue
c 30  end do
c**  
      return
      end  

c---------------------------------------------
      subroutine r3ft_b_mask_for_out(ca,cwork,id,n1,n2,n3,
     &                               cw1,cw2,cw3,kc1,kc2,kc3)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      dimension ca   (0:id/2-1,0:n2-1,0:n3-1)
      dimension cwork(*)

      dimension cw1(0:n1/2-1,2)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer lp(8,3)
c**
      n1h = n1/2
      idh = id/2

      if(kc2.eq.0) then
           nk2 = n2
      else
           nk2 = kc2+1
      end if

      if(kc3.eq.0) then
           nk3 = n3
      else
           nk3 = kc3+1
      end if
c**
      call setlp(n1h,lp(1,1))
      call setlp(n2 ,lp(1,2))
      call setlp(n3 ,lp(1,3))

c** Length:n3 CFFT
      call fsb_lp235v(ca,cwork,cw3,n3,idh*n2,1,idh*n2,lp(1,3),+1)

      do 30 i3=0,n3-1
         if(i3.le.nk3-1.or.i3.ge.n3-kc3) then
c** Length:n2 CFFT
         call fsb_lp235v(ca(0,0,i3),cwork,cw2,n2,idh,1,idh,lp(1,2),+1)
      do 10 i2=0,nk2-1
c** Length:n1h RFFT
         call trans_b(ca(0,i2,i3),cw1(0,2),n1h,0)
         call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1h,lp(1,1),+1)
  10  end do
      do 20 i2=n2-kc2,n2-1
c** Length:n1h RFFT
         call trans_b(ca(0,i2,i3),cw1(0,2),n1h,0)
         call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1h,lp(1,1),+1)
  20  end do
         end if
  30  end do
c**
      call r3ft_zeroset(ca,id,n1,n2,n3,kc1,kc2,kc3)
c**
      return
      end  

c---------------------------------------------
      subroutine r3ft_f_mask_for_in (ca,cwork,id,n1,n2,n3,
     &                               cw1,cw2,cw3,kc1,kc2,kc3)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      dimension ca   (0:id/2-1,0:n2-1,0:n3-1)
      dimension cwork(*)

      dimension cw1(0:n1/2-1,2)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer lp(8,3)
c**
      n1h = n1/2
      idh = id/2

      if(kc2.eq.0) then
           nk2 = n2
      else
           nk2 = kc2+1
      end if

      if(kc3.eq.0) then
           nk3 = n3
      else
           nk3 = kc3+1
      end if
c**   
      call setlp(n1h,lp(1,1))
      call setlp(n2 ,lp(1,2))
      call setlp(n3 ,lp(1,3))
c**   
      call c3ft_conj(cw1,n1)
      call c3ft_conj(cw2,n2)
      call c3ft_conj(cw3,n3)
c**   
      call r3ft_zeroset(ca,id,n1,n2,n3,kc1,kc2,kc3)
c**   
      do 30 i3=0,n3-1
         if(i3.le.nk3-1.or.i3.ge.n3-kc3) then
      do 10 i2=0,nk2-1
c** Length:n1h RFFT
         call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1h,lp(1,1),-1)
         call trans_f(ca(0,i2,i3),cw1(0,2),n1h,0)
  10  end do
      do 20 i2=n2-kc2,n2-1
c** Length:n1h RFFT
         call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1h,lp(1,1),-1)
         call trans_f(ca(0,i2,i3),cw1(0,2),n1h,0)
  20  end do
c** Length:n2 CFFT  
         call fsb_lp235v(ca(0,0,i3),cwork,cw2,n2,idh,1,idh,lp(1,2),-1)   
         end if
  30  end do

c** Length:n3 CFFT  
      call fsb_lp235v(ca,cwork,cw3,n3,idh*n2,1,idh*n2,lp(1,3),-1)
c**   
      call c3ft_conj(cw1,n1)
      call c3ft_conj(cw2,n2)
      call c3ft_conj(cw3,n3)
c**   
      return
      end  

c---------------------------------------------
      subroutine r3ft_f_mask_for_out(ca,cwork,id,n1,n2,n3,
     &                               cw1,cw2,cw3,kc1,kc2,kc3)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      dimension ca   (0:id/2-1,0:n2-1,0:n3-1)
      dimension cwork(*)

      dimension cw1(0:n1/2-1,2)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer lp(8,3)
c**
      n1h = n1/2
      idh = id/2
c**
      if(kc1.eq.0) then
           nk1 = idh
      else
           nk1 = kc1+1
      end if

      if(kc3.eq.0) then
           nk3 = n3
      else
           nk3 = kc3+1
      end if
c**   
      call setlp(n1h,lp(1,1))
      call setlp(n2 ,lp(1,2))
      call setlp(n3 ,lp(1,3))
c**   
      call c3ft_conj(cw1,n1)
      call c3ft_conj(cw2,n2)
      call c3ft_conj(cw3,n3)
      
c** Length:n1h RFFT
      do 10 i3=0,n3-1
      do 10 i2=0,n2-1
         call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1h,lp(1,1),-1)
         call trans_f(ca(0,i2,i3),cw1(0,2),n1h,kc1)
  10  continue
c 10  end do

c** Length:n3 CFFT  
      if(kc1.eq.0) then
         call fsb_lp235v(ca,cwork,cw3,n3,idh*n2,1,idh*n2,lp(1,3),-1)
      else
         do 20 nn1=1,idh*(n2-1)+1,idh
            nn2=nn1+nk1-1
         call fsb_lp235v(ca,cwork,cw3,n3,idh*n2,nn1,nn2,lp(1,3),-1)
  20     continue
c 20     end do
      end if

c** Length:n2 CFFT  
      do 30 i3=0,n3-1
         if(i3.le.nk3-1.or.i3.ge.n3-kc3) then
      call fsb_lp235v(ca(0,0,i3),cwork,cw2,n2,idh,1,nk1,lp(1,2),-1)   
         end if
  30  end do
c**   
      call r3ft_zeroset(ca,id,n1,n2,n3,kc1,kc2,kc3)
c**   
      call c3ft_conj(cw1,n1)
      call c3ft_conj(cw2,n2)
      call c3ft_conj(cw3,n3)
c**   
      return
      end  

c---------------------------------------------
      subroutine r3ft_zeroset(ca,id,n1,n2,n3,kc1,kc2,kc3)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:id/2-1,0:n2-1,0:n3-1)

      idh = id/2

      if(kc1.ne.0) then
      do 20 i3=0,n3-1
      do 20 i2=0,n2-1
      do 20 i1=kc1+1,idh-1
         ca(i1,i2,i3) = (0.0d0,0.0d0)
 20   continue
c20   end do
      end if

      if(kc2.ne.0) then
      do 30 i3=0,n3-1
      do 30 i2=kc2+1,n2-kc2-1
      do 30 i1=0,idh-1
         ca(i1,i2,i3) = (0.0d0,0.0d0)
 30   continue
c30   end do
      end if

      if(kc3.ne.0) then
      do 40 i3=kc3+1,n3-kc3-1
      do 40 i2=0,n2-1
      do 40 i1=0,idh-1
         ca(i1,i2,i3) = (0.0d0,0.0d0)
 40   continue
c40   end do
      end if

      return
      end 
c---------------------------------------------
      subroutine fsb_lp235(ca,cb,cw,n,lp,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:n-1),cb(0:n-1)
      dimension cw(0:n-1)
      dimension lp(8)

      k =1
      la=1

c*** radix 2 fft.

      do 2 i=1,lp(2)
      if(k.eq.1) then
         call fsb_lp2(ca,cb,cw,la,n,key)
      else
         call fsb_lp2(cb,ca,cw,la,n,key)
      end if
         k=k*(-1)
         la=la*2
    2 continue

c*** radix 3 fft.

      do 3 i=1,lp(3)
      if(k.eq.1) then
         call fsb_lp3(ca,cb,cw,la,n,key)
      else
         call fsb_lp3(cb,ca,cw,la,n,key)
      end if
         k=k*(-1)
         la=la*3
    3 continue

c*** radix 4 fft.

      do 4 i=1,lp(4)
      if(k.eq.1) then
         call fsb_lp4(ca,cb,cw,la,n,key)
      else
         call fsb_lp4(cb,ca,cw,la,n,key)
      end if
         k=k*(-1)
         la=la*4
    4 continue

c*** radix 5 fft.

      do 5 i=1,lp(5)
      if(k.eq.1) then
         call fsb_lp5(ca,cb,cw,la,n,key)
      else
         call fsb_lp5(cb,ca,cw,la,n,key)
      end if
         k=k*(-1)
         la=la*5
    5 continue

c*** radix 6 fft.

      do 6 i=1,lp(6)
      if(k.eq.1) then
         call fsb_lp6(ca,cb,cw,la,n,key)
      else
         call fsb_lp6(cb,ca,cw,la,n,key)
      end if
         k=k*(-1)
         la=la*6
    6 continue

c*** radix 8 fft.

      do 8 i=1,lp(8)
      if(k.eq.1) then
         call fsb_lp8(ca,cb,cw,la,n,key)
      else
         call fsb_lp8(cb,ca,cw,la,n,key)
      end if
         k=k*(-1)
         la=la*8
    8 continue
c***
      if(k.eq.-1) then
         do 10 i=0,n-1
            ca(i)=cb(i)
   10    continue
      end if
c***
      return
      end
c---------------------------------------------
      subroutine fsb_lp2(ca,cb,cw,la,n,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:n-1),cb(0:n-1)
      dimension cw(0:n-1)

      m=n/2

      if(la.eq.1) go to 22

      do 20 l=0,la-1

         cb(l   )=(ca(l)+ca(l+m))
         cb(l+la)=(ca(l)-ca(l+m))

   20 continue

      do 21 kpla=la,m-la,la
      do 21 l=kpla,kpla+la-1

         j0=l+kpla         

         cb(j0   )=(ca(l)+ca(l+m))
         cb(j0+la)=(ca(l)-ca(l+m))*cw(kpla)

   21 continue

      return

   22 cb(0)=(ca(0)+ca(m))
      cb(1)=(ca(0)-ca(m))

      do 23 l=1,m-1

         j0=l*2         

         cb(j0  )=(ca(l)+ca(l+m))
         cb(j0+1)=(ca(l)-ca(l+m))*cw(l)

   23 continue

      return
      end
c---------------------------------------------
      subroutine fsb_lp3(ca,cb,cw,la,n,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:n-1),cb(0:n-1)
      dimension cw(0:n-1)

      m=n/3

      sin60=0.5d0*dsqrt(3.0d0)
      if(key.gt.0) then
         cisin60=dcmplx(0.0d0,+sin60)
      else
         cisin60=dcmplx(0.0d0,-sin60)
      end if

      if(la.eq.1) go to 32

      do 30 l=0,la-1

         ct1=ca(l+m)+ca(l+m*2)
         ct2=ca(l  )-0.5d0*ct1       
         ct3=cisin60*(ca(l+m)-ca(l+m*2))

         cb(l     )=ca(l)+ct1
         cb(l+la  )=(ct2+ct3)
         cb(l+la*2)=(ct2-ct3)

   30 continue

      do 31 kpla=la,m-la,la
      do 31 l=kpla,kpla+la-1

         j0=l+kpla*2         

         ct1=ca(l+m)+ca(l+m*2)
         ct2=ca(l  )-0.5d0*ct1       
         ct3=cisin60*(ca(l+m)-ca(l+m*2))

         cb(j0     )=ca(l)+ct1
         cb(j0+la  )=(ct2+ct3)*cw(kpla  )
         cb(j0+la*2)=(ct2-ct3)*cw(kpla*2)

   31 continue

      return

   32 ct1=ca(m)+ca(m*2)
      ct2=ca(0)-0.5d0*ct1       
      ct3=cisin60*(ca(m)-ca(m*2))

      cb(0)=ca(0)+ct1
      cb(1)=(ct2+ct3)
      cb(2)=(ct2-ct3)

      do 33 l=1,m-1

         j0=l*3         

         ct1=ca(l+m)+ca(l+m*2)
         ct2=ca(l  )-0.5d0*ct1       
         ct3=cisin60*(ca(l+m)-ca(l+m*2))

         cb(j0  )=ca(l)+ct1
         cb(j0+1)=(ct2+ct3)*cw(l  )
         cb(j0+2)=(ct2-ct3)*cw(l*2)

   33 continue

      return
      end
c---------------------------------------------
      subroutine fsb_lp4(ca,cb,cw,la,n,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:n-1),cb(0:n-1)
      dimension cw(0:n-1)

      m=n/4

      if(key.gt.0) then
         ci=(0.0d0,+1.0d0)
      else
         ci=(0.0d0,-1.0d0)
      end if
   
      if(la.eq.1) go to 42

      do 40 l=0,la-1

         cc0 = ca(l  )+ca(l+m*2)
         cc1 = ca(l+m)+ca(l+m*3)
         cc2 = ca(l  )-ca(l+m*2)
         cc3 =(ca(l+m)-ca(l+m*3))*ci

         cb(l     )= cc0+cc1
         cb(l+la  )= cc2+cc3
         cb(l+la*2)= cc0-cc1
         cb(l+la*3)= cc2-cc3

   40 continue
   
      do 41 kpla=la,m-la,la
      do 41 l=kpla,kpla+la-1

         j0=l+kpla*3

         cc1 = ca(l  )+ca(l+m*2)
         cc2 = ca(l+m)+ca(l+m*3)
         cc3 = ca(l  )-ca(l+m*2)
         cc4 =(ca(l+m)-ca(l+m*3))*ci

         cb(j0     )= cc1+cc2
         cb(j0+la  )=(cc3+cc4)*cw(kpla  )
         cb(j0+la*2)=(cc1-cc2)*cw(kpla*2)
         cb(j0+la*3)=(cc3-cc4)*cw(kpla*3)

   41 continue
         
      return

   42 cc0 = ca(0)+ca(m*2)
      cc1 = ca(m)+ca(m*3)
      cc2 = ca(0)-ca(m*2)
      cc3 =(ca(m)-ca(m*3))*ci

      cb(0)= cc0+cc1
      cb(1)= cc2+cc3
      cb(2)= cc0-cc1
      cb(3)= cc2-cc3

      do 43 l=1,m-1

         j0=l*4

         cc1 = ca(l  )+ca(l+m*2)
         cc2 = ca(l+m)+ca(l+m*3)
         cc3 = ca(l  )-ca(l+m*2)
         cc4 =(ca(l+m)-ca(l+m*3))*ci

         cb(j0  )= cc1+cc2
         cb(j0+1)=(cc3+cc4)*cw(l  )
         cb(j0+2)=(cc1-cc2)*cw(l*2)
         cb(j0+3)=(cc3-cc4)*cw(l*3)

   43 continue
         
      return
      end
c---------------------------------------------
      subroutine fsb_lp5(ca,cb,cw,la,n,key)
c---------------------------------------------
      use m_Const_Parameters, only : PAI
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:n-1),cb(0:n-1)
      dimension cw(0:n-1)

      m=n/5

      r54=dsqrt(5.0d0)/4.0d0
c**      pai=3.14159265358979323846d0
      sin36=dsin(pai*0.2d0)
      sin72=dsin(pai*0.4d0)
      if(key.gt.0) then
         cisin36=dcmplx(0.0d0,+sin36)
         cisin72=dcmplx(0.0d0,+sin72)
      else
         cisin36=dcmplx(0.0d0,-sin36)
         cisin72=dcmplx(0.0d0,-sin72)
      end if

      if(la.eq.1) go to 52

      do 50 l=0,la-1

         ct1=ca(l+m  )+ca(l+m*4)
         ct2=ca(l+m*2)+ca(l+m*3)
         ct3=ca(l+m  )-ca(l+m*4)
         ct4=ca(l+m*2)-ca(l+m*3)
         ct5=     ct1+ct2
         ct6=r54*(ct1-ct2)
         ct7=ca(l   )-0.25d0*ct5
         ct8=ct7+ct6
         ct9=ct7-ct6
         ct10=cisin72*ct3+cisin36*ct4
         ct11=cisin36*ct3-cisin72*ct4

         cb(l     )=ca(l)+ct5
         cb(l+la  )=(ct8+ct10)
         cb(l+la*2)=(ct9+ct11)
         cb(l+la*3)=(ct9-ct11)
         cb(l+la*4)=(ct8-ct10)

   50 continue

      do 51 kpla=la,m-la,la
      do 51 l=kpla,kpla+la-1

         j0=l+kpla*4

         ct1=ca(l+m  )+ca(l+m*4)
         ct2=ca(l+m*2)+ca(l+m*3)
         ct3=ca(l+m  )-ca(l+m*4)
         ct4=ca(l+m*2)-ca(l+m*3)
         ct5=     ct1+ct2
         ct6=r54*(ct1-ct2)
         ct7=ca(l  )-0.25d0*ct5
         ct8=ct7+ct6
         ct9=ct7-ct6
         ct10=cisin72*ct3+cisin36*ct4
         ct11=cisin36*ct3-cisin72*ct4

         cb(j0     )=ca(l)+ct5
         cb(j0+la  )=(ct8+ct10)*cw(kpla  )
         cb(j0+la*2)=(ct9+ct11)*cw(kpla*2)
         cb(j0+la*3)=(ct9-ct11)*cw(kpla*3)
         cb(j0+la*4)=(ct8-ct10)*cw(kpla*4)

   51 continue

      return

   52 ct1=ca(m  )+ca(m*4)
      ct2=ca(m*2)+ca(m*3)
      ct3=ca(m  )-ca(m*4)
      ct4=ca(m*2)-ca(m*3)
      ct5=     ct1+ct2
      ct6=r54*(ct1-ct2)
      ct7=ca(0)-0.25d0*ct5
      ct8=ct7+ct6
      ct9=ct7-ct6
      ct10=cisin72*ct3+cisin36*ct4
      ct11=cisin36*ct3-cisin72*ct4

      cb(0)=ca(0)+ct5
      cb(1)=(ct8+ct10)
      cb(2)=(ct9+ct11)
      cb(3)=(ct9-ct11)
      cb(4)=(ct8-ct10)

      do 53 l=1,m-1

         j0=l*5

         ct1=ca(l+m  )+ca(l+m*4)
         ct2=ca(l+m*2)+ca(l+m*3)
         ct3=ca(l+m  )-ca(l+m*4)
         ct4=ca(l+m*2)-ca(l+m*3)
         ct5=     ct1+ct2
         ct6=r54*(ct1-ct2)
         ct7=ca(l  )-0.25d0*ct5
         ct8=ct7+ct6
         ct9=ct7-ct6
         ct10=cisin72*ct3+cisin36*ct4
         ct11=cisin36*ct3-cisin72*ct4

         cb(j0  )=ca(l)+ct5
         cb(j0+1)=(ct8+ct10)*cw(l  )
         cb(j0+2)=(ct9+ct11)*cw(l*2)
         cb(j0+3)=(ct9-ct11)*cw(l*3)
         cb(j0+4)=(ct8-ct10)*cw(l*4)

   53 continue

      return
      end
c---------------------------------------------
      subroutine fsb_lp6(ca,cb,cw,la,n,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:n-1),cb(0:n-1)
      dimension cw(0:n-1)

      m=n/6

      sin60=0.5d0*dsqrt(3.0d0)
      if(key.gt.0) then
         cisin60=dcmplx(0.0d0,+sin60)
      else
         cisin60=dcmplx(0.0d0,-sin60)
      end if

      if(la.eq.1) go to 62

      do 60 l=0,la-1

         ct0=ca(l+m*2)+ca(l+m*4)
         ct1=ca(l+m  )+ca(l+m*5)
         ct2=ca(l    )-0.5d0*ct0
         ct3=ca(l+m*3)-0.5d0*ct1
         ct4=cisin60*(ca(l+m*2)-ca(l+m*4))
         ct5=cisin60*(ca(l+m*5)-ca(l+m  ))

         cd0 = ca(l    )+ct0
         cd1 = ct3-ct5
         cd2 = ct2+ct4
         cd3 = ca(l+m*3)+ct1
         cd4 = ct2-ct4
         cd5 = ct3+ct5

         cb(l     )=(cd0+cd3)
         cb(l+la  )=(cd2-cd5)
         cb(l+la*2)=(cd4+cd1)
         cb(l+la*3)=(cd0-cd3)
         cb(l+la*4)=(cd2+cd5)
         cb(l+la*5)=(cd4-cd1)

   60 continue

      do 61 kpla=la,m-la,la
      do 61 l=kpla,kpla+la-1

         j0=l+kpla*5

         ct0=ca(l+m*2)+ca(l+m*4)
         ct1=ca(l+m  )+ca(l+m*5)
         ct2=ca(l    )-0.5d0*ct0
         ct3=ca(l+m*3)-0.5d0*ct1
         ct4=cisin60*(ca(l+m*2)-ca(l+m*4))
         ct5=cisin60*(ca(l+m*5)-ca(l+m  ))

         cd0 = ca(l    )+ct0
         cd1 = ct3-ct5
         cd2 = ct2+ct4
         cd3 = ca(l+m*3)+ct1
         cd4 = ct2-ct4
         cd5 = ct3+ct5

         cb(j0     )=(cd0+cd3)
         cb(j0+la  )=(cd2-cd5)*cw(kpla  )
         cb(j0+la*2)=(cd4+cd1)*cw(kpla*2)
         cb(j0+la*3)=(cd0-cd3)*cw(kpla*3)
         cb(j0+la*4)=(cd2+cd5)*cw(kpla*4)
         cb(j0+la*5)=(cd4-cd1)*cw(kpla*5)

   61 continue

      return

   62 ct0=ca(m*2)+ca(m*4)
      ct1=ca(m  )+ca(m*5)
      ct2=ca(0  )-0.5d0*ct0
      ct3=ca(m*3)-0.5d0*ct1
      ct4=cisin60*(ca(m*2)-ca(m*4))
      ct5=cisin60*(ca(m*5)-ca(m  ))

      cd0=ca(0  )+ct0
      cd1=ct3-ct5
      cd2=ct2+ct4
      cd3=ca(m*3)+ct1
      cd4=ct2-ct4
      cd5=ct3+ct5

      cb(0)=(cd0+cd3)
      cb(1)=(cd2-cd5)
      cb(2)=(cd4+cd1)
      cb(3)=(cd0-cd3)
      cb(4)=(cd2+cd5)
      cb(5)=(cd4-cd1)

      do 63 l=1,m-1

         j0=l*6

         ct0=ca(l+m*2)+ca(l+m*4)
         ct1=ca(l+m  )+ca(l+m*5)
         ct2=ca(l    )-0.5d0*ct0
         ct3=ca(l+m*3)-0.5d0*ct1
         ct4=cisin60*(ca(l+m*2)-ca(l+m*4))
         ct5=cisin60*(ca(l+m*5)-ca(l+m  ))

         cd0=ca(l    )+ct0
         cd1=ct3-ct5
         cd2=ct2+ct4
         cd3=ca(l+m*3)+ct1
         cd4=ct2-ct4
         cd5=ct3+ct5

         cb(j0  )=(cd0+cd3)
         cb(j0+1)=(cd2-cd5)*cw(l  )
         cb(j0+2)=(cd4+cd1)*cw(l*2)
         cb(j0+3)=(cd0-cd3)*cw(l*3)
         cb(j0+4)=(cd2+cd5)*cw(l*4)
         cb(j0+5)=(cd4-cd1)*cw(l*5)

   63 continue

      return
      end
c---------------------------------------------
      subroutine fsb_lp8(ca,cb,cw,la,n,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:n-1),cb(0:n-1)
      dimension cw(0:n-1)
   
      m=n/8

      x=dsqrt(0.5d0)
      if(key.gt.0) then
         ci1=dcmplx(x, +x)
      else
         ci1=dcmplx(x, -x)
      end if
      ci2=ci1*ci1
      ci3=ci1*ci2

      if(la.eq.1) go to 82

      do 80 l=0,la-1

         cc0 = ca(l    )+ca(l+m*4)
         cc1 = ca(l+m  )+ca(l+m*5)
         cc2 = ca(l+m*2)+ca(l+m*6)
         cc3 = ca(l+m*3)+ca(l+m*7)
         cc4 = ca(l    )-ca(l+m*4)
         cc5 = ca(l+m  )-ca(l+m*5)
         cc6 =(ca(l+m*2)-ca(l+m*6))*ci2
         cc7 =(ca(l+m*3)-ca(l+m*7))*ci2

         cd0 = cc0+cc2
         cd1 = cc1+cc3
         cd2 = cc4+cc6
         cd3 =(cc5+cc7)*ci1
         cd4 = cc0-cc2
         cd5 =(cc1-cc3)*ci2
         cd6 = cc4-cc6
         cd7 =(cc5-cc7)*ci3

         cb(l     ) = cd0+cd1
         cb(l+la  ) = cd2+cd3
         cb(l+la*2) = cd4+cd5
         cb(l+la*3) = cd6+cd7
         cb(l+la*4) = cd0-cd1
         cb(l+la*5) = cd2-cd3
         cb(l+la*6) = cd4-cd5
         cb(l+la*7) = cd6-cd7

   80 continue
   
      do 81 kpla=la,m-la,la
      do 81 l=kpla,kpla+la-1

         j0=l+kpla*7

         cc0 = ca(l    )+ca(l+m*4)
         cc1 = ca(l+m  )+ca(l+m*5)
         cc2 = ca(l+m*2)+ca(l+m*6)
         cc3 = ca(l+m*3)+ca(l+m*7)
         cc4 = ca(l    )-ca(l+m*4)
         cc5 = ca(l+m  )-ca(l+m*5)
         cc6 =(ca(l+m*2)-ca(l+m*6))*ci2
         cc7 =(ca(l+m*3)-ca(l+m*7))*ci2

         cd0 = cc0+cc2
         cd1 = cc1+cc3
         cd2 = cc4+cc6
         cd3 =(cc5+cc7)*ci1
         cd4 = cc0-cc2
         cd5 =(cc1-cc3)*ci2
         cd6 = cc4-cc6
         cd7 =(cc5-cc7)*ci3

         cb(j0     ) = cd0+cd1
         cb(j0+la  ) =(cd2+cd3)*cw(kpla  )
         cb(j0+la*2) =(cd4+cd5)*cw(kpla*2)
         cb(j0+la*3) =(cd6+cd7)*cw(kpla*3)
         cb(j0+la*4) =(cd0-cd1)*cw(kpla*4)
         cb(j0+la*5) =(cd2-cd3)*cw(kpla*5)
         cb(j0+la*6) =(cd4-cd5)*cw(kpla*6)
         cb(j0+la*7) =(cd6-cd7)*cw(kpla*7)

   81 continue
    
      return

   82 cc0 = ca(0  )+ca(m*4)
      cc1 = ca(m  )+ca(m*5)
      cc2 = ca(m*2)+ca(m*6)
      cc3 = ca(m*3)+ca(m*7)
      cc4 = ca(0  )-ca(m*4)
      cc5 = ca(m  )-ca(m*5)
      cc6 =(ca(m*2)-ca(m*6))*ci2
      cc7 =(ca(m*3)-ca(m*7))*ci2

      cd0 = cc0+cc2
      cd1 = cc1+cc3
      cd2 = cc4+cc6
      cd3 =(cc5+cc7)*ci1
      cd4 = cc0-cc2
      cd5 =(cc1-cc3)*ci2
      cd6 = cc4-cc6
      cd7 =(cc5-cc7)*ci3

      cb(0) = cd0+cd1
      cb(1) = cd2+cd3
      cb(2) = cd4+cd5
      cb(3) = cd6+cd7
      cb(4) = cd0-cd1
      cb(5) = cd2-cd3
      cb(6) = cd4-cd5
      cb(7) = cd6-cd7
   
      do 83 l=1,m-1

         j0=l*8

         cc0 = ca(l    )+ca(l+m*4)
         cc1 = ca(l+m  )+ca(l+m*5)
         cc2 = ca(l+m*2)+ca(l+m*6)
         cc3 = ca(l+m*3)+ca(l+m*7)
         cc4 = ca(l    )-ca(l+m*4)
         cc5 = ca(l+m  )-ca(l+m*5)
         cc6 =(ca(l+m*2)-ca(l+m*6))*ci2
         cc7 =(ca(l+m*3)-ca(l+m*7))*ci2

         cd0 = cc0+cc2
         cd1 = cc1+cc3
         cd2 = cc4+cc6
         cd3 =(cc5+cc7)*ci1
         cd4 = cc0-cc2
         cd5 =(cc1-cc3)*ci2
         cd6 = cc4-cc6
         cd7 =(cc5-cc7)*ci3

         cb(j0  ) = cd0+cd1
         cb(j0+1) =(cd2+cd3)*cw(l  )
         cb(j0+2) =(cd4+cd5)*cw(l*2)
         cb(j0+3) =(cd6+cd7)*cw(l*3)
         cb(j0+4) =(cd0-cd1)*cw(l*4)
         cb(j0+5) =(cd2-cd3)*cw(l*5)
         cb(j0+6) =(cd4-cd5)*cw(l*6)
         cb(j0+7) =(cd6-cd7)*cw(l*7)

   83 continue

      return
      end
c---------------------------------------------
      subroutine fsb_lp235v(ca,cb,cw,n,ndim,nn1,nn2,lp,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(ndim,0:n-1),cb(0:n-1,2)
      dimension cw(0:n-1)
      dimension lp(8)

      do 10 i=nn1,nn2

         do 20 j=0,n-1
            cb(j,1) = ca(i,j)
  20     continue
 
         call fsb_lp235(cb(0,1),cb(0,2),cw,n,lp,key)

         do 30 j=0,n-1
            ca(i,j) = cb(j,1)
  30     continue

  10  continue
  
c***
      return
      end
c---------------------------------------------
      subroutine setcw(cw,n)
c---------------------------------------------
      use m_Const_Parameters, only : PAI
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      complex*16 cw(0:n-1)

c**      pai=3.14159265358979323846d0
      pc =2.0d0*pai/dble(n)

      do 10 i=0,n-1
         tr=dcos(pc*dble(i))
         ti=dsin(pc*dble(i))
         cw(i)=dcmplx(tr,ti)
   10 continue

      return
      end
c---------------------------------------------
      subroutine setlp(n,lp)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      integer lp(8)

         nn =n

         lp(8)=0
         lp(6)=0
         lp(5)=0
         lp(4)=0
         lp(3)=0
         lp(2)=0

      do while(mod(nn,8).eq.0)
         lp(8)=lp(8)+1
         nn=nn/8
      end do

c     do while(mod(nn,6).eq.0)
c        lp(6)=lp(6)+1
c        nn=nn/6
c     end do

      do while(mod(nn,5).eq.0)
         lp(5)=lp(5)+1
         nn=nn/5
      end do

      do while(mod(nn,4).eq.0)
         lp(4)=lp(4)+1
         nn=nn/4
      end do

      do while(mod(nn,3).eq.0)
         lp(3)=lp(3)+1
         nn=nn/3
      end do

      do while(mod(nn,2).eq.0)
         lp(2)=lp(2)+1
         nn=nn/2
      end do

      if(nn.ne.1) stop 'n is an improper number.'

      return
      end
c---------------------------------------------
      subroutine trans_b(ca,cw1,n1h,kc1)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca (0:n1h)
      dimension cw1(0:n1h-1)
c**
      r0 = dble(ca(  0))
      r1 = dble(ca(n1h))
       
      ca(  0)=dcmplx( r0 + r1 , r0 - r1 )
      ca(n1h)=(0.0d0,0.0d0)
c**   
      if(kc1.eq.0) then
         nn=n1h/2
      else
         nn=min(n1h/2,kc1) 
      end if

c**COMMENT.
c* When n1h is an even number and k1 is n1h/2, k1 is eqaul to n1h-k1.
c* This does not make any problem.
c**
      do 10 k1 = 1,nn

      cc1 = ca(k1)
      cc2 = ca(n1h-k1)
      cc1j = dconjg(cc1)
      cc2j = dconjg(cc2)

      ca(k1    ) = cc1+cc2j + (cc1-cc2j)*cw1(k1    )
      ca(n1h-k1) = cc2+cc1j + (cc2-cc1j)*cw1(n1h-k1)

  10  continue
c 10  end do
c**   
      return
      end

c---------------------------------------------
      subroutine trans_f(ca,cw1,n1h,kc1)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca (0:n1h)
      dimension cw1(0:n1h-1)
c**
      rr = dble (ca(0))
      ri = dimag(ca(0))
       
      ca(0  )=dcmplx(rr+ri,0.0d0)
      ca(n1h)=dcmplx(rr-ri,0.0d0)
c**   
      if(kc1.eq.0) then
         nn=n1h/2
      else
         nn=min(n1h/2,kc1) 
      end if

c**COMMENT.
c* When n1h is an even number and k1 is n1h/2, k1 is eqaul to n1h-k1.
c* This does not make any problem.
c**
      do 10 k1 = 1,nn

      cc1 = ca(k1)
      cc2 = ca(n1h-k1)
      cc1j = dconjg(cc1)
      cc2j = dconjg(cc2)

      ca(k1    ) = ( cc1+cc2j + (cc1-cc2j)*cw1(k1    ) )*0.5d0
      ca(n1h-k1) = ( cc2+cc1j + (cc2-cc1j)*cw1(n1h-k1) )*0.5d0

  10  continue
c 10  end do
c**   
      return
      end
#endif

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a module for calculating < n'k | exp(i (q+G) r ) | n k-q >
!  for the LR-TDDFT .
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

module m_LinearResponse_Density

  use m_Files,                      only : nfout, nfpot, &
       &                                   m_Files_open_ps_files, &
       &                                   m_Files_close_ps_files, &
       &                                   m_Files_open_ps_file, &
       &                                   m_Files_close_ps_file

  use m_FFT,                        only : nfft, fft_box_size_WF, m_FFT_wf, &
       &                                   m_fft_alloc_wf_work, &
       &                                   m_fft_dealloc_wf_work
  use m_Const_Parameters,           only : DP, GAMMA, ELECTRON, DIRECT, &
       &                                   INVERSE, ON, OFF, CMPLDP, DELTA, &
       &                                   CARTS, BUCS, Valence_Plus_PC_Charge, &
       &                                   Hartree, NO, YES, &
       &                                   TETRAHEDRON, PARABOLIC, &
       &                                   PAI, PAI2, CMPLDP, EXECUT, SKIP, &
       &                                   DELTA_FermiSearchRange

  use m_Kpoints,                    only : kv3_ek, kv3, vkxyz_ek, qwgt_ek, &
       &                                   k_symmetry, np0, np2
  use m_Control_Parameters,         only : ipri, nspin, kimg, af, neg, printable, &
       &                                   way_of_smearing,width_tetra

  use m_LinearResponse_Control,     only  : nrd_efermi, nstep, e, nmax_G_LR, &
       &                                    vqxyz,  &
       &                                    scissor, eta

  use m_LinearResponse_tools,  only : wfn_k, wfn_kmq, map_z_k, map_z_kmq,  &
       &                                   nbase_k, nbase_kmq, &
       &                                   igf_k, igf_kmq, iba_k, iba_kmq

  use m_LinearResponse_tools,  only  : occup_k, occup_kmq, &
       &                                   Get_WF_in_Rspace, &
       &                                    eko_k, &
       &                                    fsval_k, fsval_kmq

  use m_PlaneWaveBasisSet,    only : ngabc,igf, kg0, kg1,kg, kgp, iba, &
       &                             nbase, nbase_gamma,   nbmx

  use m_IterationNumbers,     only : nk_in_the_process, nk_converged

  use m_Kpoints,                        only : kv3_ek, kv3, vkxyz_ek, qwgt_ek, &
       &                                       vkxyz, qwgt, nxyz_tetra, ip20, iwt, &
       &                                       ip2cub

  use m_Crystal_Structure,              only : altv,rltv, univol
  use m_Parallelization,                only : ista_e,iend_e,istep_e,map_z,np_e, &
    &                                          ista_k, iend_k, map_k, map_ek,  &
    &                                          myrank_k, myrank_e, map_e, npes, &
    &                                          MPI_CommGroup, ierr, mype, istatus, &
    &                                          ista_snl, iend_snl

  use m_Electronic_Structure,       only : fsr_l,fsi_l,fsr_add_l,fsi_add_l,vlhxcQ, &
       &                                    zaj_l
  use m_ES_nonlocal,                only : m_ES_add_betar_dot_WFs
  use m_Ionic_System,               only : pos, cps, ntyp,ityp,iwei,natm,natm2 ,ivan,&
       &                                   iatomn
  use m_PseudoPotential,            only : ival,ilmt,nlmt,nlmtt,nlmta,lmta,lmtt, &
       &                                   ltp,mtp, q, dion, modnrm,   &
       &                                   nac,fqwei,ilmt_add,nlmta_add, &
       &                                   ltp_add,mtp_add,lmta_add,lpsmax, &
       &                                   m_PP_include_vanderbilt_pot, &
       &                                   m_PP_tell_lmtt_l_m_tau, &
       &                                   m_PP_make_index_lmtt_add, &
       &                                   m_PP_tell_lmtt_l_m_tau_add

  use m_Timing,                     only : tstatc0_begin, tstatc0_end

  use m_Control_Parameters,         only : Num_q_Points, m_CtrlP_way_of_smearing, &
       &                                   iprioccup, width, sw_use_add_proj, &
       &                                   paramset, icond
  use m_PseudoPotential,            only : vec_q_plus_G_LR
  use m_Parallelization,            only : ista_kngp, iend_kngp

  use m_Electronic_Structure,       only : efermi, eko_ek, totch, metalic_system, vbm
  use m_LinearResponse_Control,     only : sw_LongWaveLimit
!
  use m_LinearResponse_Qpt,         only :ftqval

!! UVSOR
  use m_ES_occup,             only : check_totch, check_if_metalic
!! UVSOR
  use mpi

  implicit none
!  include 'mpif.h'

! ------------------------------
  complex(kind=CMPLDP), allocatable :: RhoTilde( :,:,:,: )
! -------------------------------------------
  real(kind=DP),        allocatable :: occup_lkt_ek( :,: )
  real(kind=DP),        allocatable :: qwgt_All(:)

! ----------------------------------------------
  real(kind=DP), allocatable :: dipole_dxyz_us(:,:,:)
  real(kind=DP), allocatable :: ptrans(:,:,:,:,:)

  integer,  allocatable :: nppc_data(:)
  integer,  allocatable :: phase_ylm1(:,:),phase_ylm2(:,:)
  integer,  allocatable :: dipole_tau1(:,:),dipole_tau2(:,:)

  integer,  allocatable :: ilocal_l(:)
  integer,  allocatable :: PP_norm_type(:), PP_local_type(:)

  integer               :: nppcorr, mnppc
!
  integer  :: nonlocal=0, n_check_ts = 1
  integer  :: NC_PP = 1, US_PP = 2
  integer  :: BHS_POLY=1, ORBITAL=2

contains

!----------------------------------------------------
!!
!!!         Alloc and Dealloc RhoTilde
!!
!----------------------------------------------------
  subroutine m_LR_alloc_Array_Densities
    if ( sw_LongWaveLimit == OFF ) then
       Allocate( RhoTilde( kg1, neg, np_e, kv3_ek / (Num_q_Points+1) ) )
    else
       Allocate( RhoTilde( kg1, neg, np_e, kv3_ek ) )
    endif
    RhoTilde = 0.0d0
  end subroutine m_LR_alloc_Array_Densities

  subroutine m_LR_dealloc_Array_Densities
    Deallocate( RhoTilde )
  end subroutine m_LR_dealloc_Array_Densities


  subroutine m_LR_alloc_Array_Occups_ek
    Allocate( Occup_lkt_ek( neg,kv3_ek) ) ; occup_lkt_ek = 0.0d0
  end subroutine m_LR_alloc_Array_Occups_ek

  subroutine m_LR_dealloc_Array_Occups_ek
    Deallocate( Occup_lkt_ek )
  end subroutine m_LR_dealloc_Array_Occups_ek

  subroutine m_LR_alloc_Array_Eko_ek
    Allocate( eko_ek( neg,kv3_ek) ) ; eko_ek = 0.0d0
  end subroutine m_LR_alloc_Array_Eko_ek

  subroutine m_LR_dealloc_Array_Eko_ek
    Deallocate( eko_ek )
  end subroutine m_LR_dealloc_Array_Eko_ek

!------------------------------------------------------------------
!!
!!!            Calc RhoTilde in the case of Q > 0   ( soft part )
!!
!-------------------------------------------------------------------
  subroutine Add_SoftPart_General
    Real(kind=DP), allocatable :: wfn_k_Rspace(:,:), Wfn_kmq_Rspace(:,:)
    Real(kind=DP), allocatable :: chgr(:), chgi(:)
    Real(kind=DP), allocatable :: wf1_tmp(:), wf2_tmp(:)

    Real(kind=DP) occ1, occ2, c1
    integer ngrid, nffth
    integer ispin, ik
    integer ib1, ib2, jb2
    integer :: id_sname = -1
! -------------------------------- start ------------
    call tstatc0_begin( 'Add_SoftPart_General', id_sname )
!
    ngrid = product(fft_box_size_WF(1:3,1));   nffth = nfft/2
    call m_FFT_alloc_WF_work()
    call set_work_arrays
! ---------------------------------- main --------------------
! ------------------ < Phi_ib1 | exp(igr) | Phi_ib2 > --------
! ------------------------------------------------------------
    Do ik=1, kv3
!
       Do ib1=1, neg                 ! unoccupied Band

          if ( nrd_efermi ==1 ) then
             occ1 = occup_k( ib1,ik )
             if ( occ1 > DELTA ) cycle
          endif
          call set_wf1_tmp

          Do ib2=1, neg                ! occupied Band

             if ( nrd_efermi==1 ) then
                occ2 = occup_kmq( ib2,ik )
                if ( occ2 < DELTA ) cycle
             end if

             if ( map_e(ib2) /= myrank_e ) cycle
             jb2 = map_z_kmq(ib2)

             call set_wf2_tmp
             call set_RhoTilde_in_Gspace
          End do
       End do
    End do
! --------------------------- end ------------
    call unset_work_arrays
    Call m_FFT_dealloc_WF_work()
    call tstatc0_end(id_sname)

  contains
! ---------
    subroutine set_work_arrays
      allocate( wfn_k_Rspace(nfft,np_e) );   wfn_k_Rspace = 0.0d0
      allocate( wfn_kmq_Rspace(nfft,np_e) ); wfn_kmq_Rspace = 0.0d0
      allocate( chgr(nffth)); allocate(chgi(nffth)); chgr = 0.0d0; chgi = 0.0d0
      allocate( wf1_tmp(nfft) ); wf1_tmp = 0.0d0
      allocate( wf2_tmp(nfft) ); wf2_tmp = 0.0d0

      Do ik=1, kv3
         Do ib1=1, np_e
            Call  Get_WF_in_Rspace( ik, ib1, wfn_k, wf1_tmp, &
                 &                  nbase_k, iba_k, igf_k, map_z_k )
            wfn_k_Rspace(1:nfft,ib1) = wf1_tmp(1:nfft)
         End do
      End do
      Do ik=1, kv3
         Do ib1=1, np_e
            Call  Get_WF_in_Rspace( ik, ib1, wfn_kmq, wf1_tmp, &
                 &                  nbase_kmq, iba_kmq, igf_kmq, map_z_kmq )
            wfn_kmq_Rspace(1:nfft,ib1) = wf1_tmp(1:nfft)
         End do
      End do
!
      wfn_k_Rspace   = wfn_k_Rspace / sqrt(univol)
      wfn_kmq_Rspace = wfn_kmq_Rspace / sqrt(univol)
    end subroutine set_work_arrays

    subroutine unset_work_arrays
      deallocate( chgr )
      if ( allocated( chgi) ) deallocate( chgi )
      deallocate( wfn_k_Rspace, wfn_kmq_Rspace )
      deallocate( wf1_tmp, wf2_tmp )
    end subroutine unset_work_arrays

    subroutine set_wf1_tmp
      integer :: jb1

      wf1_tmp = 0.0d0
      if ( map_e(ib1) == myrank_e ) then
         jb1 = map_z_k(ib1)
         wf1_tmp(1:nfft) = wfn_k_Rspace(1:nfft,jb1)
      endif
      if ( npes > 1 ) then
         call mpi_bcast( wf1_tmp, nfft, MPI_DOUBLE_PRECISION, &
              &         map_e(ib1), MPI_CommGroup, ierr )
         if ( ierr /= 0 ) write(*,*) 'MPI error ', mype, ierr
      endif
    end subroutine set_wf1_tmp

    subroutine set_wf2_tmp
      wf2_tmp(1:nfft) = wfn_kmq_Rspace(1:nfft,jb2)
    end subroutine set_wf2_tmp

    subroutine set_RhoTilde_in_Gspace
      integer i, ip
      integer ic1, i1

      if ( k_symmetry(ik) == GAMMA ) then
         do i=1,nffth
            ip = 2*i-1
            chgr(i) = wf1_tmp(ip)  *wf2_tmp(ip)
            chgi(i) =-wf1_tmp(ip+1)*wf2_tmp(ip)
         end do
      else
         do i=1,nffth
            ip = 2*i-1
            chgr(i) = wf1_tmp(ip)*wf2_tmp(ip)  +wf1_tmp(ip+1)*wf2_tmp(ip+1)
            chgi(i) = wf1_tmp(ip)*wf2_tmp(ip+1)-wf1_tmp(ip+1)*wf2_tmp(ip)
         end do
      end if
! ---
      wf2_tmp = 0.0d0
      do i=1,nffth
         ip = 2*i-1
         wf2_tmp(ip)   =  chgr(i);  wf2_tmp(ip+1) =  chgi(i)
      end do
! ----------------------------- FFT : Rspace -> G-space ---------
      call m_FFT_WF( ELECTRON,nfout, wf2_tmp, DIRECT,OFF )
      wf2_tmp = wf2_tmp / dble(ngrid) *univol
! ----------------------------------------------------------------
      ic1 = ( nk_in_the_process -1 )/ ( nspin*(Num_q_Points+1) )
      Do i=1, kg1
         i1 = igf_k( nbase_k(i,ik) )
         ip = 2*i1 - 1
         RhoTilde( i, ib1, jb2, ik + ic1*nspin ) &
              & = dcmplx( wf2_tmp(ip), wf2_tmp(ip+1) )
      End do
    end subroutine set_RhoTilde_in_Gspace

  end subroutine Add_SoftPart_General

!------------------------------------------------------------------
!!
!!!            Calc RhoTilde in the case of Q > 0   ( hard part )
!!
!-------------------------------------------------------------------
  Subroutine Add_HardPart_General
    Real(kind=DP), allocatable :: fs1_tmp( :,: ), fs2_tmp(:,:)
    complex(kind=CMPLDP),   allocatable  :: zsum(:,:)

    real(kind=DP) :: occ1, occ2
!
    integer :: ik, ib1, ib2, jb2
    integer :: id_sname = -1
! -------------------------------- start ------------
    call tstatc0_begin( 'Add_HardPart_General', id_sname )
    call set_work_arrays
!------------------------------------------------------
!------------------------------- main -----------------
!------------------------------------------------------
    Do ik=1, kv3

       Do ib1= 1, neg

          if ( nrd_efermi==1 ) then
             occ1 = occup_k( ib1,ik )
             if ( occ1 > DELTA ) cycle
          endif
          call set_fs1_tmp

          Do ib2=1, neg                ! occupied Band

             if ( nrd_efermi==1 ) then
                occ2 = occup_kmq( ib2,ik )
                if ( occ2 < DELTA ) cycle
             end if

             if ( map_e(ib2) /= myrank_e ) cycle
             jb2 = map_z_kmq(ib2)

             call set_fs2_tmp
             zsum = 0.0d0
             Call part_of_USPP_correction
             call add_zsum_to_RhoTilde

          End do
       End do
    End do
! ------------------------------- end -----------
    call unset_work_arrays
    call tstatc0_end(id_sname)

  contains

    subroutine set_work_arrays
      allocate( zsum( Num_q_Points, kg1 ) ); zsum = 0.0d0
      allocate( fs1_tmp(nlmta,kimg)); fs1_tmp = 0.0d0
      allocate( fs2_tmp(nlmta,kimg)); fs2_tmp = 0.0d0
    end subroutine set_work_arrays

    subroutine unset_work_arrays
      deallocate( fs1_tmp, fs2_tmp )
      deallocate( zsum )
    end subroutine unset_work_arrays

    subroutine set_fs1_tmp
      integer :: jb1

      if ( map_e(ib1) == myrank_e ) then
         jb1 = map_z_k(ib1)
         fs1_tmp( 1:nlmta,1:kimg ) = fsval_k( jb1, 1:nlmta, ik, 1:kimg )
      endif
! --
      if ( npes > 1 ) then
         call mpi_bcast( fs1_tmp, nlmta*kimg, MPI_DOUBLE_PRECISION, &
              &          map_e(ib1), MPI_CommGroup, ierr )
         if ( ierr /= 0 ) write(*,*) 'MPI error ', mype, ierr
      endif
    end subroutine set_fs1_tmp

    subroutine set_fs2_tmp
      fs2_tmp( 1:nlmta,1:kimg ) = fsval_kmq( jb2, 1:nlmta, ik, 1:kimg )
    end subroutine set_fs2_tmp

    subroutine part_of_USPP_correction
      integer       :: ia, it, mdvdb
      integer       :: ig, nq
      integer       :: lmt1, lmt2, u, v
      real(kind=DP) :: ctmp_r, ctmp_i, ph
      complex(kind=CMPLDP) :: z1, z2, ztmp
! -------------
      Do ia=1, natm
         it = ityp(ia)
         mdvdb = m_PP_include_vanderbilt_pot(it)
         if ( mdvdb == SKIP ) cycle

         Do lmt1=1,ilmt(it)
            u = lmta(lmt1,ia)

            Do lmt2=1,ilmt(it)
               v = lmta(lmt2,ia)

               if ( kimg==1 ) then
                  ctmp_r = fs1_tmp( u,1 ) *fs2_tmp( v,1 )
                  ctmp_i = 0.0d0
               else
                  ctmp_r = fs1_tmp( u,1 ) *fs2_tmp( v,1 ) &
                       &  +fs1_tmp( u,2 ) *fs2_tmp( v,2 )
                  ctmp_i = fs1_tmp( u,1 ) *fs2_tmp( v,2 ) &
                       &  -fs1_tmp( u,2 ) *fs2_tmp( v,1 )
               endif
               Do nq=1, Num_q_Points
                  Do ig=1, kg1
                     ph = vec_q_plus_G_LR(ig,1,nq) *cps(ia,1) &
                          & +vec_q_plus_G_LR(ig,2,nq)*cps(ia,2) &
                          & +vec_q_plus_G_LR(ig,3,nq)*cps(ia,3)
!                     ph = dot_product( vec_q_plus_G_LR(ig,:,nq), &
!                       & cps(ia,:) )
                     z1 = dcmplx( 0.0d0, ph )
                     z2 = ftqval( lmt1,lmt2,it,nq,ig )
!                                                conjg wo toruhitsuyou ?
                     ztmp = exp(-z1) *z2 *iwei(ia)
!!!                     ztmp = z2 *iwei(ia)
!                     if ( ig==1 ) then
!                        write(*,*) 'ao ', exp(z1), z2
!                     endif
                     zsum(nq,ig) = zsum(nq,ig) + ztmp *dcmplx( ctmp_r, ctmp_i )
                  End do
               End do

            End do
         End do
      End do
    end subroutine part_of_USPP_correction

    subroutine add_zsum_to_RhoTilde           ! nq == 1 is supported
      integer :: ic1, nq, ig

      ic1 = ( nk_in_the_process -1 )/ (nspin*(Num_q_Points+1))
      Do nq=1, Num_q_Points
!!!                Do ig=1, nmax_G
         Do ig=1, kg1
            RhoTilde( ig, ib1,jb2, ik+ic1*nspin ) = &
                 & RhoTilde( ig, ib1,jb2, ik+ic1*nspin ) &
                 & + zsum(nq,ig)
         End do
      End do
    end subroutine add_zsum_to_RhoTilde

  end Subroutine Add_HardPart_General

  subroutine Delete_G0_Contrib
    RhoTilde(1,:,:,:) = 0.0d0
  end subroutine Delete_G0_Contrib

!------------------------------------------------------------------
!!
!!!            Calc RhoTilde in the case of LongWaveLimit   ( soft part )
!!
!-------------------------------------------------------------------
  subroutine Add_SoftPart_LWLimit
    Real(kind=DP), allocatable :: wfn_k_Rspace(:,:)
    Real(kind=DP), allocatable :: chgr(:), chgi(:)
    Real(kind=DP), allocatable :: wf1_tmp(:), wf2_tmp(:)

    Real(kind=DP) :: occ1, occ2, c1

    integer ngrid, nffth
    integer ispin, ik
    integer ib1, ib2, jb2

    integer :: id_sname = -1
! ---------------------------------- start ---------
    call tstatc0_begin('Add_SoftPart_LWLimit ', id_sname)
!
    ngrid = product(fft_box_size_WF(1:3,1));   nffth = nfft/2
    call m_FFT_alloc_WF_work()
    call set_work_arrays
! ---------------------------------- main --------------------
! ------------------ < Phi_ib1 | exp(igr) | Phi_ib2 > --------
! ------------------------------------------------------------
    Do ik=1, kv3
       !
       Do ib1=1, neg                  ! unoccupied Band

          if ( nrd_efermi==1 ) then
             occ1 = occup_k( ib1,ik )
             if ( occ1 > DELTA ) cycle
          endif
          call set_wf1_tmp

          Do ib2=1, neg                ! occupied Band

             if ( nrd_efermi==1 ) then
                occ2 = occup_k( ib2,ik )
                if ( occ2 < DELTA ) cycle
             end if

             if ( map_e(ib2) /= myrank_e ) cycle
             jb2 = map_z_k(ib2)

             call set_wf2_tmp
             call set_RhoTilde_in_Gspace
!
          End do
       End do
    End do
! --------------------------------- end -------------
    call unset_work_arrays
    Call m_FFT_dealloc_WF_work()
    call tstatc0_end(id_sname)

  contains
!
    subroutine set_work_arrays
      allocate( wfn_k_Rspace(nfft,np_e) ); wfn_k_Rspace = 0.0d0
      allocate( chgr(nffth)); allocate(chgi(nffth)); chgr = 0.0d0; chgi = 0.0d0
      allocate( wf1_tmp(nfft) ); wf1_tmp = 0.0d0
      allocate( wf2_tmp(nfft) ); wf2_tmp = 0.0d0

      Do ik=1, kv3
         Do ib1=1, np_e
            Call  Get_WF_in_Rspace( ik, ib1, wfn_k, wf1_tmp, &
                 &                  nbase_k, iba_k, igf_k, map_z_k )
            wfn_k_Rspace(1:nfft,ib1) = wf1_tmp(1:nfft)
         End do
      End do
      wfn_k_Rspace = wfn_k_Rspace / sqrt(univol)
    end subroutine set_work_arrays
!
    subroutine unset_work_arrays
      deallocate( chgr )
      if ( allocated( chgi) ) deallocate( chgi )
      deallocate( wfn_k_Rspace )
      deallocate( wf1_tmp, wf2_tmp )
    end subroutine unset_work_arrays

    subroutine set_wf1_tmp
      integer :: jb1

      wf1_tmp = 0.0d0
      if ( map_e(ib1) == myrank_e ) then
         jb1 = map_z_k(ib1)
         wf1_tmp(1:nfft) = wfn_k_Rspace(1:nfft,jb1)
      endif
      if ( npes > 1 ) then
         call mpi_bcast( wf1_tmp, nfft, MPI_DOUBLE_PRECISION, &
              &         map_e(ib1), MPI_CommGroup, ierr )
         if ( ierr /= 0 ) write(*,*) 'MPI error ', mype, ierr
      endif
    end subroutine set_wf1_tmp

    subroutine set_wf2_tmp
      wf2_tmp(1:nfft) = wfn_k_Rspace(1:nfft,jb2)
    end subroutine set_wf2_tmp

    subroutine set_RhoTilde_in_Gspace
      integer i, ip, i1
      integer ic1

      if ( k_symmetry(ik) == GAMMA ) then
         do i=1,nffth
            ip = 2*i-1
            chgr(i) = wf1_tmp(ip)  *wf2_tmp(ip)
            chgi(i) =-wf1_tmp(ip+1)*wf2_tmp(ip)
         end do
      else
         do i=1,nffth
            ip = 2*i-1
            chgr(i) = wf1_tmp(ip)*wf2_tmp(ip)  +wf1_tmp(ip+1)*wf2_tmp(ip+1)
            chgi(i) = wf1_tmp(ip)*wf2_tmp(ip+1)-wf1_tmp(ip+1)*wf2_tmp(ip)
         end do
      end if
      ! ---
      wf2_tmp = 0.0d0
      do i=1,nffth
         ip = 2*i-1
         wf2_tmp(ip)   =  chgr(i);  wf2_tmp(ip+1) =  chgi(i)
      end do
! ----------------------------- FFT : Rspace -> G-space ---------
      call m_FFT_WF( ELECTRON,nfout, wf2_tmp, DIRECT,OFF )
      wf2_tmp = wf2_tmp / dble(ngrid) *univol
! ----------------------------------------------------------------
      ic1 = ( nk_in_the_process -1 )/ ( nspin*(Num_q_Points+1) )
      Do i=1, kg1
         if(nbase_k(i,ik)<1) cycle
         i1 = igf_k( nbase_k(i,ik) )
         ip = 2*i1 - 1
         RhoTilde( i, ib1, jb2, ik + ic1*nspin ) &
              & = dcmplx( wf2_tmp(ip), wf2_tmp(ip+1) )
      End do
    end subroutine set_RhoTilde_in_Gspace

  end subroutine Add_SoftPart_LWLimit

!------------------------------------------------------------------
!!
!!!            Calc RhoTilde in the case of LongWaveLimit   ( hard part )
!!
!-------------------------------------------------------------------
  subroutine Add_HardPart_LWLimit
    Real(kind=DP), allocatable :: fs1_tmp( :,: ), fs2_tmp(:,:)
    Real(kind=DP), allocatable :: fs2_tmp_mpi( :,: )
    complex(kind=CMPLDP),   allocatable  :: zsum(:,:)

    real(kind=DP) :: occ1, occ2

    integer :: ik, ib1, ib2
    integer :: jb2
    integer :: id_sname = -1
! -------------------------------- start ------------
    call tstatc0_begin( 'Add_HardPart_LWLimit', id_sname )
    call set_work_arrays
!------------------------------------------------------
!------------------------------- main -----------------
!------------------------------------------------------
    Do ik=1, kv3

       Do ib1= 1, neg

          if ( nrd_efermi==1 ) then
             occ1 = occup_k( ib1,ik )
             if ( occ1 > DELTA ) cycle
          endif
          call set_fs1_tmp

          Do ib2=1, neg                ! occupied Band

             if ( nrd_efermi==1 ) then
                occ2 = occup_k( ib2,ik )
                if ( occ2 < DELTA ) cycle
             end if

             if ( map_e(ib2) /= myrank_e ) cycle
             jb2 = map_z_k(ib2)

             call set_fs2_tmp
             zsum = 0.0d0
             Call part_of_USPP_correction
             call add_zsum_to_RhoTilde

          End do
       End do
    End do
! ----------------------------------end -------------------
    call unset_work_arrays
!    stop

    call tstatc0_end(id_sname)

  contains

    subroutine set_work_arrays
      allocate( zsum( Num_q_Points, kg1 ) ); zsum = 0.0d0
      allocate( fs1_tmp(nlmta,kimg)); fs1_tmp = 0.0d0
      allocate( fs2_tmp(nlmta,kimg)); fs2_tmp = 0.0d0
    end subroutine set_work_arrays

    subroutine unset_work_arrays
      if ( allocated(fs1_tmp) ) deallocate( fs1_tmp )
      if ( allocated(fs2_tmp) ) deallocate( fs2_tmp )
      if ( allocated(zsum   ) ) deallocate( zsum )
    end subroutine unset_work_arrays

    subroutine set_fs1_tmp
      integer :: jb1

      if ( map_e(ib1) == myrank_e ) then
         jb1 = map_z_k(ib1)
         fs1_tmp( 1:nlmta,1:kimg ) = fsval_k( jb1, 1:nlmta, ik, 1:kimg )
      endif
! --
      if ( npes > 1 ) then
         call mpi_bcast( fs1_tmp, nlmta*kimg, MPI_DOUBLE_PRECISION, &
              &          map_e(ib1), MPI_CommGroup, ierr )
         if ( ierr /= 0 ) write(*,*) 'MPI error ', mype, ierr
      endif
    end subroutine set_fs1_tmp

    subroutine set_fs2_tmp
      fs2_tmp( 1:nlmta,1:kimg ) = fsval_k( jb2, 1:nlmta, ik, 1:kimg )
    end subroutine set_fs2_tmp

    subroutine part_of_USPP_correction
      integer       :: ia, it, mdvdb
      integer       :: nq, ig
      integer       :: lmt1, lmt2, u, v
      real(kind=DP) :: ctmp_r, ctmp_i, ph
      complex(kind=CMPLDP) :: z1, z2, ztmp
! -------------
      Do ia=1, natm
         it = ityp(ia)
         mdvdb = m_PP_include_vanderbilt_pot(it)
         if ( mdvdb == SKIP ) cycle

         Do lmt1=1,ilmt(it)
            u = lmta(lmt1,ia)

            Do lmt2=1,ilmt(it)
               v = lmta(lmt2,ia)

               if ( kimg==1 ) then
                  ctmp_r = fs1_tmp( u,1 ) *fs2_tmp( v,1 )
                  ctmp_i = 0.0d0
               else
                  ctmp_r = fs1_tmp( u,1 ) *fs2_tmp( v,1 ) &
                       &  +fs1_tmp( u,2 ) *fs2_tmp( v,2 )
                  ctmp_i = fs1_tmp( u,1 ) *fs2_tmp( v,2 ) &
                       &  -fs1_tmp( u,2 ) *fs2_tmp( v,1 )
               endif

!               write(*,*) 'ctmp_r, i =', ctmp_r, ctmp_i, iwei(ia)
!
               Do nq=1, Num_q_Points
                  Do ig=1, nmax_G_LR
!!!                  Do ig=1, min( nmax_G_LR, kg0 )

                     ph = vec_q_plus_G_LR(ig,1,nq) *cps(ia,1) &
                          & +vec_q_plus_G_LR(ig,2,nq)*cps(ia,2) &
                          & +vec_q_plus_G_LR(ig,3,nq)*cps(ia,3)

!                     ph = dot_product( vec_q_plus_G_LR(ig,:,nq), &
!                       & cps(ia,:) )
                     z1 = cmplx( 0.0d0, ph )
                     z2 = ftqval( lmt1,lmt2,it,nq,ig )
                     ztmp = exp(-z1) *z2 *iwei(ia)
!                     write(*,*) 'ztmp = ', ztmp

!!!                     ztmp = z2 *iwei(ia)
!                     if ( ig==1 ) then
!                        write(*,*) 'ao ', ztmp, ctmp_r
!                     endif
                     zsum(nq,ig) = zsum(nq,ig) + ztmp *dcmplx( ctmp_r, ctmp_i )
                  End do
               End do

            End do
         End do

      End do

    end subroutine part_of_USPP_correction

    subroutine add_zsum_to_RhoTilde           ! nq == 1 is supported
      integer :: ic1, nq, ig

      ic1 = ( nk_in_the_process -1 )/ nspin
      Do nq=1, Num_q_Points
!!!                Do ig=1, nmax_G
         Do ig=1, kg1
            RhoTilde( ig, ib1,jb2, ik+ic1*nspin ) = &
                 & RhoTilde( ig, ib1,jb2, ik+ic1*nspin ) &
                 & + zsum(nq,ig)
         End do
      End do
    end subroutine add_zsum_to_RhoTilde

  end Subroutine Add_HardPart_LWLimit

!------------------------------------------------------------------
!!
!!!            Calc RhoTilde in the case of LongWaveLimit   ( soft, correction )
!!
!-------------------------------------------------------------------
  subroutine Add_Correction_To_G0
    Real(kind=DP), allocatable :: wf1_tmp(:,:)
    Real(kind=DP), allocatable :: wf2_tmp(:,:)
    Real(kind=DP), allocatable :: k_plus_G(:,:)

    real(kind=DP) :: csum_r(3), csum_i(3)
    integer       :: ik
    integer       :: ib1, ib2, jb2
    real(kind=DP) :: occ1, occ2
! -------------------------------------- start ---------
    call set_work_arrays
! ----------------------------------------- main -------
    Do ik=1, kv3
       call set_vectors_kplusG

       Do ib1=1, neg                  ! unoccupied Band

          if ( nrd_efermi ==1 ) then
             occ1 = occup_k( ib1,ik )
             if ( occ1 > DELTA ) cycle
          endif

          call set_wf1_tmp

          Do ib2=1, neg                ! occupied Band

             if ( nrd_efermi ==1 ) then
                occ2 = occup_k( ib2,ik )
                if ( occ2 < DELTA ) cycle
             end if
             if ( ib1 == ib2 ) cycle

             if ( map_e(ib2) /= myrank_e ) cycle
             jb2 = map_z(ib2)

             call set_wf2_tmp
!
             csum_r = 0.0d0; csum_i = 0.0d0
             call part_of_local_contrib
             call add_csum_to_RhoTilde

          End do
       End do

    End do
! ---------------------------- end ---------------
    call unset_work_arrays
  contains

    subroutine set_work_arrays
      allocate( k_plus_G( kg1,3 ) ); k_plus_G = 0.0d0
      allocate( wf1_tmp(kg1,kimg) ); wf1_tmp = 0.0d0
      allocate( wf2_tmp(kg1,kimg) ); wf2_tmp = 0.0d0
    end subroutine set_work_arrays

    subroutine unset_work_arrays
      deallocate( k_plus_G )
      deallocate( wf1_tmp, wf2_tmp )
    end subroutine unset_work_arrays

    subroutine set_vectors_kplusG
      integer :: i, ip
      Real(kind=DP) :: ga, gb, gc

      Do i = 1, iba_k(ik)
         ip = nbase_k(i,ik)
         ga = vkxyz(ik,1,BUCS) + real(ngabc(ip,1),kind=DP)
         gb = vkxyz(ik,2,BUCS) + real(ngabc(ip,2),kind=DP)
         gc = vkxyz(ik,3,BUCS) + real(ngabc(ip,3),kind=DP)

         k_plus_G(i,1)  = rltv(1,1)*ga + rltv(1,2)*gb + rltv(1,3)*gc
         k_plus_G(i,2)  = rltv(2,1)*ga + rltv(2,2)*gb + rltv(2,3)*gc
         k_plus_G(i,3)  = rltv(3,1)*ga + rltv(3,2)*gb + rltv(3,3)*gc
      End do
    end subroutine set_vectors_kplusG

    subroutine set_wf1_tmp
      integer :: jb1
!
      if ( map_e(ib1) == myrank_e ) then
         jb1 = map_z(ib1)
         wf1_tmp( 1:kg1, 1:kimg ) = wfn_k( 1:kg1, jb1, ik, 1:kimg )
      endif
      if ( npes > 1 ) then
         call mpi_bcast( wf1_tmp, kg1*kimg, MPI_DOUBLE_PRECISION, &
              &         map_e(ib1), MPI_CommGroup, ierr )
         if ( ierr /= 0 ) write(*,*) 'MPI error ', mype, ierr
      endif
    end subroutine set_wf1_tmp

    subroutine set_wf2_tmp
      wf2_tmp(1:kg1,1:kimg) = wfn_k(1:kg1,jb2,ik,1:kimg)
    end subroutine set_wf2_tmp

    subroutine part_of_local_contrib
      integer       :: i
      real(kind=DP) :: ctmp_r, ctmp_i
! ----------------------------------
      if ( kimg <= 1 ) then
         Do i = 1, iba(ik)
            ctmp_r = wf1_tmp( i,1 ) *wf2_tmp( i,1 )
            csum_r(1) = csum_r(1) + ctmp_r *k_plus_G(i,1)
            csum_r(2) = csum_r(2) + ctmp_r *k_plus_G(i,2)
            csum_r(3) = csum_r(3) + ctmp_r *k_plus_G(i,3)
         End do
      else
         Do i=1, iba(ik)
            ctmp_r = wf1_tmp( i,1 ) *wf2_tmp( i,1 ) &
                 &  +wf1_tmp( i,2 ) *wf2_tmp( i,2 )
            ctmp_i = wf1_tmp( i,1 ) *wf2_tmp( i,2 ) &
                 &  -wf1_tmp( i,2 ) *wf2_tmp( i,1 )

            csum_r(1) = csum_r(1) + ctmp_r *k_plus_G(i,1)
            csum_r(2) = csum_r(2) + ctmp_r *k_plus_G(i,2)
            csum_r(3) = csum_r(3) + ctmp_r *k_plus_G(i,3)
            !
            csum_i(1) = csum_i(1) + ctmp_i *k_plus_G(i,1)
            csum_i(2) = csum_i(2) + ctmp_i *k_plus_G(i,2)
            csum_i(3) = csum_i(3) + ctmp_i *k_plus_G(i,3)
         end do
      end if
    end subroutine part_of_local_contrib

    subroutine add_csum_to_RhoTilde
      integer :: ic1
      Complex(kind=CMPLDP) :: ztmp(3), zz1
      Real(kind=DP) :: ebi, ebj, ediff

      ic1 = ( nk_in_the_process -1 ) / nspin
!
      ztmp(1) = dcmplx( csum_r(1), csum_i(1) ) *vqxyz( 1,1,CARTS )
      ztmp(2) = dcmplx( csum_r(2), csum_i(2) ) *vqxyz( 1,2,CARTS )
      ztmp(3) = dcmplx( csum_r(3), csum_i(3) ) *vqxyz( 1,3,CARTS )
      !
      ebi = eko_k( ib1,ik ); ebj = eko_k( ib2,ik )
      ediff = ebi - ebj
      !
      zz1 = ( ztmp(1)+ztmp(2)+ztmp(3) ) / ediff
      !
! --------------- test-
      if ( mype == 0 ) then
	write(*,'(I5,2I3,6F12.7)') ik+ic1, ib1, ib2, vkxyz(ik,1,CARTS), &
        & vkxyz(ik,2,CARTS), vkxyz(ik,3,CARTS), csum_r(1), csum_r(2), csum_r(3)
      endif
! ---------------

      RhoTilde( 1, ib1, jb2, ik + ic1*nspin ) = &
           & RhoTilde( 1, ib1, jb2, ik + ic1*nspin )  + zz1
    end subroutine add_csum_to_RhoTilde

  end subroutine Add_Correction_To_G0

!------------------------------------------------------------------
!!
!!!            Correction by Kageshima Shiraishi
!!
!-------------------------------------------------------------------
  subroutine Add_KageShira_To_G0
    real(kind=DP) :: occ1, occ2
    real(kind=DP) :: csum_r(3), csum_i(3)

    integer       :: i, ip, ik
    integer       :: ib1, ib2, jb2
! -------------------------------- start -------------
    nppcorr = 2
!    call check_PP(nfout)
    if ( nppcorr>0  ) call calc_ptrans_ek
    if ( nppcorr==2 ) call calc_ptrans_TM_PP_ek
! -------------------------------- main -----------
    Do ik=1, kv3

       Do ib1=1, neg                  ! unoccupied Band

          if ( nrd_efermi == ON ) then
             occ1 = occup_k( ib1,ik )
             if ( occ1 > DELTA ) cycle
          endif

          Do ib2=1, neg                ! occupied Band
             if ( ib1 == ib2 ) cycle

             if ( map_e(ib2) /= myrank_e ) cycle
             jb2 = map_z(ib2)
!
             csum_r = 0.0d0; csum_i = 0.0d0
             call part_of_nonlocal_contrib
             call add_csum_to_RhoTilde
          End do
       End do
    End do
!
  contains

    subroutine part_of_nonlocal_contrib
      csum_r(1) = ptrans( ik, ib1, ib2, 1, 1 )
      csum_r(2) = ptrans( ik, ib1, ib2, 2, 1 )
      csum_r(3) = ptrans( ik, ib1, ib2, 3, 1 )

      csum_i(1) = ptrans( ik, ib1, ib2, 1, 2 )
      csum_i(2) = ptrans( ik, ib1, ib2, 2, 2 )
      csum_i(3) = ptrans( ik, ib1, ib2, 3, 2 )
    end subroutine part_of_nonlocal_contrib

    subroutine add_csum_to_RhoTilde
      integer :: ic1
      Complex(kind=CMPLDP) :: ztmp(3), zz1
      Real(kind=DP) :: ebi, ebj, ediff

      ic1 = ( nk_in_the_process -1 )/  nspin
!
      ztmp(1) = dcmplx( csum_r(1), csum_i(1) ) *vqxyz( 1,1,CARTS )
      ztmp(2) = dcmplx( csum_r(2), csum_i(2) ) *vqxyz( 1,2,CARTS )
      ztmp(3) = dcmplx( csum_r(3), csum_i(3) ) *vqxyz( 1,3,CARTS )
!
      ebi = eko_k( ib1,ik ); ebj = eko_k( ib2,ik )
      ediff = ebi - ebj

      zz1 = ( ztmp(1)+ztmp(2)+ztmp(3) ) / ediff

      RhoTilde( 1, ib1, jb2, ik + ic1*nspin ) = &
           & + RhoTilde( 1, ib1, jb2, ik + ic1*nspin ) + zz1
    end subroutine add_csum_to_RhoTilde

  end subroutine Add_KageShira_To_G0

!---------------------------------------------------------------------
!!
!!!           calc Fermi level
!!                            from WriteDownData_onto_Files_ek.f90
!----------------------------------------------------------------------

  subroutine Calc_FermiLevel_ek(nrd_efermi)
!                        calculate fermi energy (efermi) if nrd_efermi=0
    integer             :: way_of_smearing
    integer, intent(in) :: nrd_efermi
    real(kind=DP)            :: efermi1
! ----------------------------------------------
    if ( nrd_efermi== 1 ) then
       efermi1 = efermi;     efermi = 0.0d0
    end if
    way_of_smearing = m_CtrlP_way_of_smearing()

    if ( way_of_smearing==PARABOLIC ) then
       call Fermi_parabolic_ek(nfout)
    else if ( way_of_smearing == TETRAHEDRON ) then
       !       write(*,*) ' ------------------ Under construction ---------'
       !       stop
       call Fermi_tetra_ek(nfout)
    end if
    !
    if ( nrd_efermi==0 ) then
       if (printable) write(nfout,10) efermi
    else
       if (printable) write(nfout,20) efermi1-efermi
       efermi=efermi1
    end if
10  format(1x,"!*--- efermi = ",f10.5)
20  format(1x,"!*--- difference between read and calculated efermi = ",f10.5)
  end subroutine Calc_FermiLevel_ek

  subroutine Fermi_parabolic_ek(nfout)
!
!   Coded from <m_ESoc_fermi_parabolic>
!                      by T. Yamasaki (FUJITSU LABORATORIES Ltd.), 28th Jun. 2003
    integer, intent(in) :: nfout

    integer             :: jcount
    real(kind=DP)       :: emin, emax, e1, e2, tot
    real(kind=DP), parameter :: DELTA_TOTCH = 1.d-10
    integer,       parameter :: MAXITR = 100000
    integer :: id_sname = -1
!! UVSOR
    integer             :: ik, ie
    integer             :: ik1, ik2, k, ispin, nq, nq_max
    real(kind=DP),allocatable,dimension(:,:) :: occup_mpi

    allocate(occup_mpi(neg,kv3_ek)); occup_mpi =0.0d0
    !! UVSOR

    call tstatc0_begin('Fermi_parabolic_ek ', id_sname)
    call check_totch(nfout)

    emin = minval(eko_ek);     emax = maxval(eko_ek)
    efermi = emax
    e1 = emin - dabs(DELTA_FermiSearchRange)
    e2 = emax + dabs(DELTA_FermiSearchRange)

    jcount = 1
    occupied_ch_equals_totch : do

       call get_tot_eps()             ! -(contained here) ->tot
!          ~~~~~~~~~~~~~~~~~~~~
       if(jcount == 1 .and. tot < totch) &
            call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
       if(dabs(tot - totch) < DELTA_TOTCH) exit occupied_ch_equals_totch
       if( tot < totch) then
          e1 = efermi; efermi = efermi + (e2-efermi)/2
       else
          e2 = efermi; efermi = efermi + (e1-efermi)/2
       end if
       jcount = jcount + 1
       if(jcount > MAXITR) then
          call wd_fermi_error2 &   !-(b_Fermi)
               & (nfout,e1,e2,efermi,emin,emax,tot,totch,neg,MAXITR)
       end if
    end do occupied_ch_equals_totch
    if(iprioccup >= 2) &
         &write(nfout,'( " efermi = ", f10.4, " tot = ", f10.4)') efermi, tot

    call check_if_metalic(nfout,metalic_system)
    if(iprioccup >= 2 .and. .not.metalic_system) &
         &write(nfout,'( " The highest occupied band enrgy = ", f10.4)') vbm

    call tstatc0_end(id_sname)
!!  -----------------------------------------
    if ( sw_LongWaveLimit ==ON ) then
       nq_max = 0
    else
       nq_max = Num_q_Points
    endif

    Do k=1, kv3_ek / ( nspin*(nq_max+1 ))
       Do ispin=1, nspin, af+1
          ik1 = ( nq_max +1 )*nspin*(k-1) + ispin
          Do nq=0, nq_max
             ik2 = ik1 + nspin *nq

!             Do ie = 1, neg                                   ! MPI
!                if(map_e(ie) == myrank_e) then                ! MPI
!                   occup_l_ek(map_z(ie),ik2) = occup_mpi(ie,ik2)! MPI
!                end if                                        ! MPI
!             end do                                           ! MPI
! ----------
             occup_lkt_ek(1:neg, ik2) = occup_mpi(1:neg,ik2)
! ------------
          End do
       end do                                              ! MPI
   End do
   deallocate(occup_mpi)
   !! UVSOR

 contains
    subroutine get_tot_eps
      integer       :: k, i, ik1, ik2, ispin, nq
      integer       :: nq_max

      real(kind=DP) :: wspin = 1.d0, e, dos, weight, totw

      tot = 0.d0
! ------------------------
      if ( sw_LongWaveLimit ==ON ) then
         nq_max = 0
      else
         nq_max = Num_q_Points
      endif
! ---
      Do k=1, kv3_ek / ( nspin*(nq_max+1 ))
         Do ispin=1, nspin, af+1
            ik1 = ( nq_max +1 )*nspin*(k-1) + ispin
            Do nq=0, nq_max
               ik2 = ik1 + nspin *nq

               Do i = 1, neg
                  e = eko_ek(i,ik2)

                  call width2(e,efermi,width,dos,weight)  ! -(b_Fermi)
                  totw = weight *wspin *kv3_ek *qwgt_ek(k)
                  !! LR-TDDDFT
                  totw = totw / dble( nq_max + 1 )
                  occup_mpi(i,ik2) = totw
                  !            write(*,*) 'occ ' , i, k, totw
                  !!
                  tot = tot + 2*totw
               End do
            End do
         End do
      End do

      tot = tot/kv3_ek * (af+1)
      if(iprioccup >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12," jcount = ",i7)') efermi,tot, jcount
!      write(*,*) 'aaa ', efermi, tot, jcount
!      stop
    end subroutine get_tot_eps

  end subroutine Fermi_parabolic_ek

  subroutine Fermi_tetra_ek(nfout)
    integer, intent(in) :: nfout

#ifndef NO_TETRAHEDRON
    real(kind=DP), parameter :: delta = 1.d-12
    integer, parameter       :: idim = 3
    integer        :: neig,nengy,ispin,ip2,ik,instts1,ikee,nxx,nyy,nzz, ib, jb
    real(kind=DP)  :: efermi2,eval,totind, et
    real(kind=DP), pointer, dimension(:,:,:,:) :: eig2
    real(kind=DP), pointer, dimension(:) :: eawk,cdwk,cswk,cdos,cind,valud
    integer             :: id_sname = -1

    integer        :: ip_mpi, ieig
    integer, allocatable, dimension(:,:,:) :: neordr_ek
    real(kind=DP), pointer, dimension(:,:,:,:) :: occup2

    integer nq, ik_kt1, ik_kt2, nq_max
! --------------------------
    call tstatc0_begin('m_ESoc_fermi_tetra_ek ', id_sname)

    if ( sw_LongWaveLimit ==ON ) then
       nq_max = 0
    else
       nq_max = Num_q_Points
    endif

    allocate( eig2( np2, neg, nspin, 0:nq_max )); eig2 = 0.d0
    allocate( eawk(np0) ); eawk = 0.d0
    allocate( cdwk(np0) ); cdwk = 0.d0
    allocate( cswk(np0) ); cswk = 0.d0
    allocate( cdos(np2*neg) ); cdos = 0.d0
    allocate( cind(np2*neg) ); cind = 0.d0
    allocate( valud(nspin) ); valud = 0.d0
!! UVSOR
    allocate( neordr_ek( neg, kv3_ek, 0:nq_max ) ); neordr_ek = 0
    allocate( occup2( neg, np2, nspin, 0:nq_max )); occup2 = 0.0d0
!! UVSOR

    call check_totch(nfout)           ! totch is checked

    nxx = nxyz_tetra(1)
    nyy = nxyz_tetra(2)
    nzz = nxyz_tetra(3)
    neig=neg
    nengy=0
!
    Do nq=0, nq_max
       Do ispin=1,nspin
          Do ip2=1,np2
             ik = nspin*(ip2-1)+ispin

             ik_kt1 = ( nq_max +1)*nspin*(ip2-1) + ispin
             ik_kt2 = ik_kt1 + nspin *nq

             neordr_ek(1:neg,ik,nq) = (/(ib,ib = 1, neg)/)

             Do ib=1,neg
                eig2(ip2,ib,ispin,nq) = eko_ek(ib,ik_kt2)
             End Do
             Do ib = 1,neg-1
                Do jb = ib+1, neg
                   if ( eig2(ip2,jb,ispin,nq) < eig2(ip2,ib,ispin,nq)-delta ) then
                      et = eig2(ip2,ib,ispin,nq)
                      eig2(ip2,ib,ispin,nq) = eig2(ip2,jb,ispin,nq)
                      eig2(ip2,jb,ispin,nq) = et

                      neordr_ek(ib,ik,nq) =jb
                      neordr_ek(jb,ik,nq) =ib

                   end if
                End do
             End do
          Enddo
       Enddo
    End do
!
    if(iprioccup>=2) write(nfout,*) ' === tetrahedron method', &
                &  ' for k-space integration ==='
    if(iprioccup>=2) then
       write(nfout,'(" --- eig2 ---")')
       do ip2 = 1, np2
          write(nfout,'(" (ip2 = ",i8,")",99(/,8d12.4))') ip2,(eig2(ip2,ib,ispin,0),ib=1,neg)
       end do
    end if

    efermi2 = efermi
    call fermi1(nxx,nyy,nzz,np2,np2,neig,neg,nspin, &
             &  eig2(1,1,1,0), ip20, np0,totch, efermi2,eval,valud, &
             &  iwt,ip2cub,iprioccup)
    if(iprioccup>=2) write(nfout,*) 'eval=',eval

! ------------------------------ nq == 0 ------ evaluated @ q=0 --
    nq = 0
    Do ispin=1,nspin
       instts1 = 0
       call nsdos3(nfout,idim,efermi2,nxx,nyy,nzz,np2,1,neig, &
            &  eig2(1,1,ispin,nq),ip20,np0,eawk,instts1,np2, &
            &  iwt,ip2cub,iprioccup)
       call nstt3i(idim,nengy,efermi2,nxx,nyy,nzz, &
            &  np2,np2,neig,eig2(1,1,ispin,nq), &
            &  ip20,np0,eawk,cdwk,cswk,np2,neig,cdos,cind,width_tetra )
       efermi=efermi2

       totind=0.d0
       Do ip2=1,np2
          Do ib=1,neig
             ikee=ip2+np2*(ib-1)

             ik = nspin * (ip2-1) + ispin
             ip_mpi = neordr_ek(ib,ik,nq)
             occup2(ip_mpi,ip2,ispin,nq) = cind(ikee)*dble(np2)

!             write(*,*) 'FFA ', cind(ikee)*dble(np2)
             totind=totind+cind(ikee)
          End do
       End do
       if(iprioccup>=2) write(nfout,*) 'for spin=',ispin, &
                  &  ' ** TOTAL CHARGE after fermi1 = ',totind
!       write(*,*) 'aaaaa', totind
    Enddo
! ---------------------------- nq > 0 --------
    Do nq=1, nq_max
       Do ispin=1,nspin
          instts1 = 0
          call nsdos3(nfout,idim,efermi2,nxx,nyy,nzz,np2,1,neig, &
               &  eig2(1,1,ispin,nq),ip20,np0,eawk,instts1,np2, &
               &  iwt,ip2cub,iprioccup)
          call nstt3i(idim,nengy,efermi2,nxx,nyy,nzz, &
               &  np2,np2,neig,eig2(1,1,ispin,nq), &
               &  ip20,np0,eawk,cdwk,cswk,np2,neig,cdos,cind,width_tetra )

          Do ip2=1,np2
             Do ib=1,neig
                ikee=ip2+np2*(ib-1)

                ik = nspin * (ip2-1) + ispin
                ip_mpi = neordr_ek(ib,ik,nq)
                occup2(ip_mpi,ip2,ispin,nq) = cind(ikee)*dble(np2)
!!                write(*,*) 'FFF ', cind(ikee)*dble(np2)
             End do
          End do
       End do
    Enddo
! -------------------------------------
!! UVSOR
    Do ieig = 1, neg
!!!!!!!       if(map_e(ieig) /= myrank_e) cycle                          ! MPI
       Do nq=0, nq_max
          Do ispin=1,nspin
             Do ip2=1,np2
                ik = nspin*(ip2-1)+ispin
                ik_kt1 = ( nq_max+1 )*nspin*(ip2-1) + ispin
                ik_kt2 = ik_kt1 + nspin *nq

!!!!!!!!                occup_l_ek(map_z(ieig),ik_kt2) = occup2(ieig,ip2,ispin,nq) ! MPI
! --------------------------
                occup_lkt_ek(ieig,ik_kt2) = occup2(ieig,ip2,ispin,nq) ! MPI
! -------------------------
             End do
          End do
       End do
    End do
    deallocate(neordr_ek)
    deallocate(occup2)
!! UVSOR

    deallocate(valud); deallocate(cind); deallocate(cdos); deallocate(cswk)
    deallocate(cdwk);  deallocate(eawk)
    deallocate(eig2)

    call check_if_metalic(nfout,metalic_system)
    if(iprioccup >= 2 .and. .not.metalic_system) &
         &write(nfout,'( " The highest occupied band enrgy = ", f10.4)') vbm

    call tstatc0_end(id_sname)
#endif
  end subroutine Fermi_tetra_ek

! ------------------------------------------------------
!! -----------------------------
!!!              other subroutines inspired from m_Epsilon_ek.f90
!! -----------------------------
! ------------------------------------------------------

  subroutine Dealloc_Ptrans_Nppc_ilocal_etc
    call Dealloc_Ptrans
    if ( nppcorr>=1 )  then
       call Dealloc_Nppc_data
       call Dealloc_ptrans_data_array_ek
    end if
    if(nppcorr==2)  call Dealloc_ilocal_l
  end subroutine Dealloc_Ptrans_Nppc_ilocal_etc

  subroutine Alloc_ptrans
    allocate( ptrans( kv3, neg,neg,3,2 ) ); ptrans = 0.0d0
  end subroutine Alloc_ptrans

  subroutine Dealloc_ptrans
    deallocate( ptrans )
  end subroutine Dealloc_ptrans

  subroutine Alloc_Nppc_data
    allocate(nppc_data(ntyp)) ; nppc_data=0
  end subroutine Alloc_Nppc_data

  subroutine Dealloc_Nppc_data
    deallocate(nppc_data)
  end subroutine Dealloc_Nppc_data

  subroutine Alloc_ilocal_l
    allocate(ilocal_l(ntyp))
  end subroutine Alloc_ilocal_l

  subroutine Dealloc_ilocal_l
    deallocate( ilocal_l )
  end subroutine Dealloc_ilocal_l

  subroutine alloc_ptrans_data_array_ek    ! allocate data array for core-repair term
    integer :: it
    ! find maximum of nppc_data(it): it=1-ntyp
    if(mype == 0) then
       if(ntyp==1) then
          mnppc=nppc_data(1)
       else
          mnppc=nppc_data(1)
          do it=1,ntyp
             if(mnppc<nppc_data(it)) mnppc=nppc_data(it)
          end do
       end if
    end if
    call mpi_bcast(mnppc,1,mpi_integer,0,MPI_CommGroup, ierr) ! MPI
    if (printable) write(nfout,'(1x,"!* mnppc = ",i3)') mnppc
    ! allocate data array
    allocate(dipole_dxyz_us(ntyp,mnppc,3)); dipole_dxyz_us=0.0d0
    allocate(dipole_tau1(ntyp,mnppc));      dipole_tau1=0
    allocate(dipole_tau2(ntyp,mnppc));      dipole_tau2=0
    allocate(phase_ylm1(ntyp,mnppc));       phase_ylm1=0
    allocate(phase_ylm2(ntyp,mnppc));       phase_ylm2=0
  end subroutine alloc_ptrans_data_array_ek

  subroutine dealloc_ptrans_data_array_ek
    deallocate( dipole_tau1, dipole_tau2 )
    deallocate( dipole_dxyz_us )
    deallocate( phase_ylm1, phase_ylm2 )
  end subroutine dealloc_ptrans_data_array_ek

  subroutine set_ppc_data(nfout)     ! set core-repair param for Kagashima-Shiraishi
!
    integer, intent(in) :: nfout
    integer             :: it, nfpp, ierr

    call Alloc_Nppc_data
    call m_Files_open_ps_files(ivan,iatomn,ntyp,ierr)
    if(mype == 0) then
       if(nppcorr==2) then
          if(printable) &
           & write(nfout,'(1x,"!* KS Transition Moment Correction for Troullier-Martin pseudopotential")')
          if(sw_use_add_proj == ON) then
             paramset=.false.
             call m_PP_make_index_lmtt_add(nfout,paramset)
          end if
       end if
    end if
    call find_ppc_data_number(nfout)
    call Alloc_ptrans_data_array_ek
    call read_ptrans_data_ek
    if (nppcorr==2) then
       call Alloc_ilocal_l
       call prepare_for_TM_PP_ek
    endif

  end subroutine set_ppc_data

  subroutine set_ppc_data_it(nfout)
    integer, intent(in) :: nfout
    integer             :: it, nfpp, ierr
    call Alloc_Nppc_data
    if(mype==0)then
       if(nppcorr==2) then
          if(printable) &
           & write(nfout,'(1x,"!* KS Transition Moment Correction for Troullier-Martin pseudopotential")')
          if(sw_use_add_proj == ON) then
             paramset=.false.
             call m_PP_make_index_lmtt_add(nfout,paramset)
          end if
       end if
    endif
    do it=1,ntyp
       call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierr)
       call find_ppc_data_number_it(nfout,it)
       call m_Files_close_ps_file(it)
    enddo
    call Alloc_ptrans_data_array_ek()
    do it=1,ntyp
       call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierr)
       call find_ppc_data_number_it(nfout,it)
       call read_ptrans_data_ek_it(it)
       call m_Files_close_ps_file(it)
    enddo
    if (nppcorr==2) then
       call Alloc_ilocal_l
       call prepare_for_TM_PP_ek
    endif
  end subroutine set_ppc_data_it

  subroutine Alloc_PP_norm_type
    allocate(PP_norm_type(ntyp))  ; PP_norm_type = 0
  end subroutine Alloc_PP_norm_type

  subroutine Dealloc_PP_norm_type
    deallocate(PP_norm_type)
  end subroutine Dealloc_PP_norm_type

  subroutine Alloc_PP_local_type
    allocate(PP_local_type(ntyp))  ; PP_local_type = 0
  end subroutine Alloc_PP_local_type

  subroutine Dealloc_PP_local_type
    deallocate(PP_local_type)
  end subroutine Dealloc_PP_local_type

  subroutine check_PP(nfout)
!
!   find pseudopotantial norm and local potential types
!
!   norm type        NC_PP : norm conserving
!                    US_PP : ultrasoft
!   local potential  BHS_POLY : BHS or polynomial type
!                    ORBITAL  : orbital local potential for Troullier-Martin pseudopotentials

    integer, intent(in)                      :: nfout
    integer                                  :: it, ntype, ltype, ilocal
    integer, allocatable, dimension(:)       :: PP_local_orbital
    character(len=1), dimension(7)           :: local_potential
    data local_potential/'s','p','d','f',' ',' ',' '/


    allocate( PP_local_orbital(ntyp) );
    PP_local_orbital = 0

    do it = 1, ntyp
       call find_norm_type(it,ntype)
       PP_norm_type(it) = ntype
       call find_local_orbital(it,ilocal)
       if(ilocal == 0) then
          PP_local_type(it) = BHS_POLY
       else
          PP_local_type(it) = ORBITAL
       end if
       PP_local_orbital(it) = ilocal
    end do


    if(printable) write(nfout,'(1x,"!* ---------- pseudopotential type ----------")')
    if(printable) write(nfout,'(1x,4x,"it",10x,"norm",12x,"local potential")')

    do it = 1, ntyp
       if(printable) then
          if(PP_norm_type(it)==NC_PP.and.PP_local_type(it)==BHS_POLY) &
         & write(nfout,'(1x,3x,i3,5x,"norm conserving",5x,"BHS or polynomial")') it
          if(PP_norm_type(it)==NC_PP.and.PP_local_type(it)==ORBITAL) &
         & write(nfout,'(1x,3x,i3,5x,"norm conserving",9x,a1,1x,"orbital")') it, local_potential(PP_local_orbital(it))
          if(PP_norm_type(it)==US_PP.and.PP_local_type(it)==BHS_POLY) &
         & write(nfout,'(1x,3x,i3,8x,"ultrasoft",8x,"BHS or polynomial")') it
          if(PP_norm_type(it)==US_PP.and.PP_local_type(it)==ORBITAL) &
         & write(nfout,'(1x,3x,i3,8x,"ultrasoft",12x,a1,1x,"orbital")') it, local_potential(PP_local_orbital(it))
       end if
    end do
!
!   check transition moment option and stop if it is wrong
!
    if(n_check_ts/=0) then
       call check_ts_option
    else
       if(printable) write(nfout,'(/1x,"!* transition moment option is not checked",/)')
    end if

    deallocate(PP_local_orbital)

  contains
    subroutine find_norm_type(it,ntype)
      implicit none
      integer, intent(in)  :: it
      integer, intent(out) :: ntype
      integer              :: lmt1, lmt2
      real(kind=DP)        :: deficit_ch
      ntype = NC_PP
      do lmt1 = 1, ilmt(it)
         do lmt2 = lmt1, ilmt(it)
            deficit_ch=dabs(q(lmt1,lmt2,it))
            if(deficit_ch>0.0d0) then
               ntype=US_PP
               exit
            end if
         end do
         if(ntype==US_PP) exit
      end do
    end subroutine find_norm_type

    subroutine find_local_orbital(it,ilocal)
      implicit none
      integer, intent(in)  :: it
      integer, intent(out) :: ilocal
      integer :: lmt, il1, il2
      ilocal = 0
      do il1=1,lpsmax(it)
         do lmt=1,ilmt(it)
            il2=ltp(lmt,it)
            if(il1==il2) exit
         end do
         if(il1/=il2) then
            ilocal=il1
         end if
      end do
    end subroutine find_local_orbital

    subroutine check_ts_option
      implicit none
      integer :: it
      if(icond==3) return
      if(printable) write(nfout,'(/1x,"!* enter check of transition moment option")')
      if(nonlocal==0.and.nppcorr==0) then
         if(printable) write(nfout,'(1x,"!* local transition moment : check is skipped",/)')
         return
      end if

      if(nonlocal/=0) then
         do it = 1, ntyp
            if(printable.and.PP_norm_type(it)/=NC_PP) then
               write(nfout,'(1x,"!* A pseudopotential in use is the ultra-soft type")')
               write(nfout,'(1x,"!* Read and Needs method cannot be used for the ultra-soft type.   LinearResponse Calc. stop")')
               stop
            end if
         end do
      end if
      if(nppcorr/=0) then
         do it = 1, ntyp
            if(PP_local_type(it)/=BHS_POLY) then
               if(printable.and.sw_use_add_proj /= ON) then
                  write(nfout,'(1x,"!* A pseudopotential in use is the Troullier-Martin type")')
                  write(nfout,'(1x,"!* set use_additional_projector = on in Control tag.   LinearRespone Calc. stop")')
                  stop
               end if
            end if
         end do
      end if
      if(printable) write(nfout,'(1x,"!* no problem with transition moment option setting",/)')

    end subroutine check_ts_option
  end subroutine check_PP

  subroutine find_ppc_data_number(nfout)
    !
    !   find data number of core-repair term
    !   nppc_data(it) : data number for it-th type pseudopotential
    !
    integer,intent(in) :: nfout
    integer            :: it, nfpp, nptrans
    nfpp=0
    if(mype == 0) then
       do it=1, ntyp
          nfpp=nfpp+1

          call find_dipole_section(nfpot(nfpp),nfout,it,nptrans)
          if(printable) &
               & write(nfout,'(1x,"! PP transition moment correction data : it = ",i3, &
               & 2x,"number of data read from PP file = ",i3)') it, nptrans
          nppc_data(it)=nptrans
       end do
    end if
    call mpi_bcast(nppc_data,ntyp,mpi_integer,0,MPI_CommGroup,ierr) ! MPI
  end subroutine find_ppc_data_number

  subroutine find_ppc_data_number_it(nfout,it)
    integer,intent(in) :: nfout,it
    integer, save :: nfpp=0
    integer :: nptrans
    if(mype == 0) then
       nfpp=nfpp+1
       call find_dipole_section(nfpot(nfpp),nfout,it,nptrans)
       if(printable) &
            & write(nfout,'(1x,"! PP transition moment correction data : it = ",i3, &
            & 2x,"number of data read from PP file = ",i3)') it, nptrans
       nppc_data(it)=nptrans
    end if
    if(it==ntyp) then
       call mpi_bcast(nppc_data,ntyp,mpi_integer,0,MPI_CommGroup,ierr) ! MPI
       nfpp=0
    endif
  end subroutine find_ppc_data_number_it

  subroutine find_dipole_section(nfp,nfout,it,nptrans)
    !
    !   find dipole section in gncpp2 potential file
    !
    integer,intent(in)   :: nfp, nfout,it
    integer, intent(out) :: nptrans
    integer              :: idipole
    character(len=10)    :: line
    if(mype /= 0) return
10  read(nfp,'(a10)',end=20) line
    idipole=index(line,'DIPOLE')

    if ( idipole/=0 ) then
       read(nfp,*) nptrans
       if ( nptrans==0 ) then
          if (printable) &
               & write(nfout,'(1x,"!* Warning : number of dipole data is zero for atom type ",i3 )') it
!!!          stop
       end if
       return
    end if
    goto 10
! ------
20  if (printable) then
       write(*,'(1x,"!* Warning : dipole section is not found in pseudopotential file")')
       nptrans = 0
!!    stop
    endif

! --
  end subroutine find_dipole_section


  subroutine read_ptrans_data_ek
    implicit none
    !
    !   read core-repair term
    !
    integer :: it,nfpp
    nfpp=0
    if(mype == 0)  then
       do it =1, ntyp
          nfpp=nfpp+1
          if(printable) &
               & write(nfout,'(1x,"! ppc data for it = ",i4," are read: nppc = ",i4)') it,nppc_data(it)
          call read_ptrans_data_ek_core(nfpot(nfpp),nfout,it)
       end do
    end if

    if (printable) write(nfout,'(1x,"!* ntyp = ",i3)') ntyp
    call mpi_bcast(dipole_dxyz_us,ntyp*mnppc*3,mpi_double_precision,0,MPI_CommGroup,ierr) ! MPI
    call mpi_bcast(dipole_tau1,ntyp*mnppc,mpi_integer,0,MPI_CommGroup,ierr)      ! MPI
    call mpi_bcast(dipole_tau2,ntyp*mnppc,mpi_integer,0,MPI_CommGroup,ierr)      ! MPI
    call mpi_bcast(phase_ylm1,ntyp*mnppc,mpi_integer,0,MPI_CommGroup,ierr)       ! MPI
    call mpi_bcast(phase_ylm2,ntyp*mnppc,mpi_integer,0,MPI_CommGroup,ierr)       ! MPI

 end subroutine read_ptrans_data_ek

 subroutine read_ptrans_data_ek_it(it)
    integer, intent(in) :: it
    integer, save :: nfpp=0
    if(mype == 0)  then
       nfpp=nfpp+1
       if(printable) &
            & write(nfout,'(1x,"! ppc data for it = ",i4," are read: nppc = ",i4)') it,nppc_data(it)
       call read_ptrans_data_ek_core(nfpot(nfpp),nfout,it)
    end if

    if (printable) write(nfout,'(1x,"!* ntyp = ",i3)') ntyp
    if(it==ntyp) then
       call mpi_bcast(dipole_dxyz_us,ntyp*mnppc*3,mpi_double_precision,0,MPI_CommGroup,ierr) ! MPI
       call mpi_bcast(dipole_tau1,ntyp*mnppc,mpi_integer,0,MPI_CommGroup,ierr)      ! MPI
       call mpi_bcast(dipole_tau2,ntyp*mnppc,mpi_integer,0,MPI_CommGroup,ierr)      ! MPI
       call mpi_bcast(phase_ylm1,ntyp*mnppc,mpi_integer,0,MPI_CommGroup,ierr)       ! MPI
       call mpi_bcast(phase_ylm2,ntyp*mnppc,mpi_integer,0,MPI_CommGroup,ierr)       ! MPI
       nfpp=0
    endif
 end subroutine read_ptrans_data_ek_it

 subroutine read_ptrans_data_ek_core(nfp,nfout,it)
   implicit none
!
!      read core-repair term pij(I)
!      cf. H. Kageshima and K. Shiraishi,Phys. Rev. B vol.56, 14985 (1997)
!      pij(I)
!      i, j :: atomic orbital index (CIAO)
!      i ->  ltmltm(n1,l1,t1,m1)  j-> ltmltm(n2,l2,t1,m1)  ltm: compound index
!      n :: principal quantum number    l :: azimuthal quantum number
!      m :: magnetic quantum number     t :: energy reference index
!      dipole_dxyz_us(it,ltmltm,ixyz)     :: core repair term for it-th type pseudopotential in ixyz direction
!                                         :: ixyz=1 -> x; ixyz=2 -> y;  ixyz= 3 -> z
!      phase_ylm  :: Ylm index for phase
!      dipole_tau :: reference index
!
!
   integer, intent(in) :: nfp,nfout,it
   integer :: n1,l1,t1,m1,n2,l2,t2,m2
   integer :: ltmltm,lmax
   do ltmltm = 1, nppc_data(it)
!         n1 = n1_dipole_lm_us(ltmltm) ; n2 = n2_dipole_lm_us(ltmltm)
!         l1 = l1_dipole_lm_us(ltmltm) ; l2 = l2_dipole_lm_us(ltmltm)
!         t1 = t1_dipole_lm_us(ltmltm) ; t2 = t2_dipole_lm_us(ltmltm)
!         m1 = m1_dipole_lm_us(ltmltm) ; m2 = m2_dipole_lm_us(ltmltm)
      read (nfp,53) n1,l1,t1,m1,n2,l2,t2,m2, &
      dipole_dxyz_us(it,ltmltm,1),dipole_dxyz_us(it,ltmltm,2),dipole_dxyz_us(it,ltmltm,3), &
      phase_ylm1(it,ltmltm), phase_ylm2(it,ltmltm)

      dipole_tau1(it,ltmltm)=t1;  dipole_tau2(it,ltmltm)=t2

      if ( printable ) then
         write(nfout,53) n1,l1,dipole_tau1(it,ltmltm),m1,n2,l2,dipole_tau2(it,ltmltm),m2, &
       & dipole_dxyz_us(it,ltmltm,1),dipole_dxyz_us(it,ltmltm,2),dipole_dxyz_us(it,ltmltm,3), &
       & phase_ylm1(it,ltmltm),phase_ylm2(it,ltmltm)
      end if
   end do
53 format(1x,8i3,3e18.10,2i3)
 end subroutine read_ptrans_data_ek_core

 subroutine prepare_for_TM_PP_ek
   implicit none
    integer :: lmax,ilocal,il1,il2,lmt
    integer :: it,lmt1,lmt2

    if(mype == 0) then
       ilocal=0
       do it = 1, ntyp
          lmax=lpsmax(it)
          call check_local_orbital
          if(printable) then
             if(ilocal==0) then
                write(nfout,'(1x,"!* all non-local projectors are given for it =",i3)') it
                write(nfout,'(1x,"!* skip correction for Troullier-Martin pseudopotential for it =",i3)') it
             else
                write(nfout,'(1x,"!* ptrans correction for Troullier-Matrtin pseudopotential for it =",i3)') it
                write(nfout,'(1x,"!* non-local projector for iloc =",i3," is not given")') ilocal
                write(nfout,'(1x,"!* correction for iloc =",i3," is made")') ilocal
             end if
          end if
          ilocal_l(it)=ilocal
       end do
    end if
    call mpi_bcast(ilocal_l,ntyp,mpi_integer,0,MPI_CommGroup,ierr)
    contains
     subroutine check_local_orbital
       do il1=1,lmax
          do lmt=1,ilmt(it)
             il2=ltp(lmt,it)
             if(il1==il2) exit
          end do
          if(il1/=il2) then
             ilocal=il1
          end if
       end do
     end subroutine check_local_orbital
 end subroutine prepare_for_TM_PP_ek


 subroutine calc_ptrans_ek
    implicit none
!
!   calculate KS correction term
!
    integer                                :: id_sname = -1
    integer                                :: ispin, it, lmt1, lmt2, il1, im1, il2, im2, ia
    integer                                :: ik, ii, ib, ib1, ilmta, p, p1, index, ifact
    integer                                :: nspher1,nspher2
    real(kind=DP) :: fac, eib, eib1
    real(kind=DP),pointer,dimension(:,:,:) :: wkfsr, wkfsi
! --> T. Yamasaki 2008/02/21
    real(kind=DP),pointer,dimension(:)     :: wkfsr_tmp, wkfsi_tmp
! <-- T. Yamasaki 2008/02/21


    call tstatc0_begin('calc_ptans_ek ',id_sname)
    allocate(wkfsr(neg,nlmta,kv3)); allocate(wkfsi(neg,nlmta,kv3))

    if(npes >= 2) call mpi_barrier(MPI_CommGroup,ierr)

!   make copy of <beta|WF>
! --> T. Yamasaki 2008/02/21
    allocate(wkfsr_tmp(nlmta),wkfsi_tmp(nlmta))
!!$    do ik = 1, kv3, af+1
!!$       do ib = 1, neg
!!$          if(map_ek(ib,ik) == mype) then
!!$               do ilmta=1, nlmta
!!$                  wkfsr(ib,ilmta,ik) = fsr_l(map_z(ib),ilmta,ik)
!!$                  wkfsi(ib,ilmta,ik) = fsi_l(map_z(ib),ilmta,ik)
!!$               end do
!!$               if(map_ek(ib,ik) /= 0) then
!!$                   call mpi_send(wkfsr,neg*nlmta*kv3,mpi_double_precision,0,1,MPI_CommGroup,ierr) ! MPI
!!$                   call mpi_send(wkfsi,neg*nlmta*kv3,mpi_double_precision,0,1,MPI_CommGroup,ierr) ! MPI
!!$               end if
!!$          else if(mype == 0 .and. map_ek(ib,ik) /= 0) then
!!$            call mpi_recv(wkfsr,neg*nlmta*kv3,mpi_double_precision,map_ek(ib,ik),1,MPI_CommGroup,istatus,ierr)!MPI
!!$            call mpi_recv(wkfsi,neg*nlmta*kv3,mpi_double_precision,map_ek(ib,ik),1,MPI_CommGroup,istatus,ierr)!MPI
!!$         end if
!!$         if(npes >= 2)  then
!!$              call mpi_bcast(wkfsr,neg*nlmta*kv3,mpi_double_precision,0,MPI_CommGroup,ierr)!MPI
!!$              call mpi_bcast(wkfsi,neg*nlmta*kv3,mpi_double_precision,0,MPI_CommGroup,ierr)!MPI
!!$         end if
!!$       end do
!!$    end do
    do ik = 1, kv3, af+1
       do ib = 1, neg
          if(map_ek(ib,ik) == mype) then
             if(mype == 0) then
                do ilmta=1, nlmta
                   wkfsr(ib,ilmta,ik) = fsr_l(map_z(ib),ilmta,ik)
                   wkfsi(ib,ilmta,ik) = fsi_l(map_z(ib),ilmta,ik)
                end do
             else
                do ilmta=1, nlmta
                   wkfsr_tmp(ilmta) = fsr_l(map_z(ib),ilmta,ik)
                   wkfsi_tmp(ilmta) = fsi_l(map_z(ib),ilmta,ik)
                end do
                call mpi_send(wkfsr_tmp,nlmta,mpi_double_precision,0,1,MPI_CommGroup,ierr) ! MPI
                call mpi_send(wkfsi_tmp,nlmta,mpi_double_precision,0,1,MPI_CommGroup,ierr) ! MPI
             end if
          else if(mype == 0 .and. map_ek(ib,ik) /= 0) then
             call mpi_recv(wkfsr_tmp,nlmta,mpi_double_precision,map_ek(ib,ik),1,MPI_CommGroup,istatus,ierr)!MPI
             call mpi_recv(wkfsi_tmp,nlmta,mpi_double_precision,map_ek(ib,ik),1,MPI_CommGroup,istatus,ierr)!MPI
             do ilmta=1, nlmta
                wkfsr(ib,ilmta,ik) = wkfsr_tmp(ilmta)
                wkfsi(ib,ilmta,ik) = wkfsi_tmp(ilmta)
             end do
         end if
       end do
    end do
    if(npes >= 2)  then
       call mpi_bcast(wkfsr,neg*nlmta*kv3,mpi_double_precision,0,MPI_CommGroup,ierr)!MPI
       call mpi_bcast(wkfsi,neg*nlmta*kv3,mpi_double_precision,0,MPI_CommGroup,ierr)!MPI
    end if

    deallocate(wkfsr_tmp,wkfsi_tmp)
! <-- T. Yamasaki 2008/02/21

    ptrans=0.0d0

!   calculate sum[<WF1|beta(i)>pij<beta(j)|WF2>
    do ii = 1,3
       do ispin = 1, nspin, af+1
          do ik = ispin, kv3-nspin+ispin, nspin
             do ib = 1, neg
                do ib1 = 1, neg

!                   if(nrd_efermi==1) then
!                      eib=e2_mpi(ib,ik)
!                      eib1=e2_mpi(ib1,ik)
!                      if(eib.gt.efermi.and.eib1.le.efermi) call calc_ptrans_ek_core(ib,ib1)                   else
                      if(ib/=ib1) call calc_ptrans_ek_core(ib,ib1)
!                   end if
                end do
             end do
          end do
       end do
    end do

!!$    if(nk_in_the_process + kv3-1 >= kv3_ek) stop ' m_Epsilon_ek (1)'

    ptrans = ptrans*(af+1)

    deallocate(wkfsr)
    deallocate(wkfsi)
    call tstatc0_end(id_sname)

    contains
     subroutine find_ptrans_index_ek(it,lmt1,lmt2,nptrans,index,ifact,nspher1,nspher2)
       implicit none
!
!      find core repair term pij for <WF1|beta(i)>pij<beta(j)|WF2>
!      i -> (it,lmt1)   j -> (it,lmt2)
!
       integer, intent(in)  :: it, lmt1, lmt2, nptrans
       integer, intent(out) :: index, ifact
       integer              :: lmtt1, il1, im1, tau1, nspher1
       integer              :: lmtt2, il2, im2, tau2, nspher2
       integer              :: nspher10, nspher20
       integer              :: tau10, tau20
       integer              :: iptrans
       index=0
       ifact=0
       call m_PP_tell_lmtt_l_m_tau(lmt1,it,lmtt1,il1,im1,tau1,nspher1)
       call m_PP_tell_lmtt_l_m_tau(lmt2,it,lmtt2,il2,im2,tau2,nspher2)
       if(nspher1>nspher2) then
          nspher20=nspher1
          nspher10=nspher2
          tau10=tau2
          tau20=tau1
          ifact=-1
       else
          nspher10=nspher1
          nspher20=nspher2
          tau10=tau1
          tau20=tau2
          ifact=1
       end if

!      find core-repair term with dipole_tau = tau, phase_ylm = nspher
       do iptrans=1,nptrans
          if(phase_ylm1(it,iptrans)==nspher10.and.phase_ylm2(it,iptrans)==nspher20) then
             if(dipole_tau1(it,iptrans)==tau10.and.dipole_tau2(it,iptrans)==tau20) then
                index=iptrans
                exit
             end if
          end if
       end do
     end subroutine find_ptrans_index_ek

     subroutine calc_ptrans_ek_core(ib,ib1)
!
!      calculate <WF1|beta(i)>pij<beta(j)|WF2>
!
       integer,intent(in) :: ib,ib1
       integer            :: index,iv,ic,ifind

!       call find_ind_vb_and_cb2(ib1,ib,iv,ic,nk_in_the_process+ik-1,ifind)
!       if(ifind==0.and.printable) then
!          write(nfout,'(1x,"!!* valence or conduction band index is not found   UVSOR-Epsilon STOP at calc_ptrans")')
!       end if

! --
       iv = ib1
       ic = ib
! ---

       do it=1,ntyp
          do lmt1 = 1, ilmt(it)
             do lmt2 = 1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                call find_ptrans_index_ek(it,lmt1,lmt2,nppc_data(it),index,ifact,nspher1,nspher2)
                if(index==0) cycle
                do ia = 1, natm
                   if(ityp(ia) /= it) cycle
                   p = lmta(lmt1,ia)
                   p1 = lmta(lmt2,ia)
                   fac=real(iwei(ia),kind=DP)
                   fac = real(ifact,kind=DP)*fac
! --- debug
!                   write(*,*) it, lmt1, lmt2, ia, fac, dipole_dxyz_us(it,index,ii)
! --

                   ptrans(ik,ic,iv,ii,1) = ptrans(ik,ic,iv,ii,1) &
                & + fac*(dipole_dxyz_us(it,index,ii)) &
                & *(wkfsr(ib,p,ik)*wkfsi(ib1,p1,ik) - wkfsi(ib,p,ik)*wkfsr(ib1,p1,ik))
                   ptrans(ik,ic,iv,ii,2) = ptrans(ik,ic,iv,ii,2) &
                & -1.0d0* fac*(dipole_dxyz_us(it,index,ii)) &
                & *(wkfsr(ib,p,ik)*wkfsr(ib1,p1,ik) + wkfsi(ib,p,ik)*wkfsi(ib1,p1,ik))
!
!                   write(*,*) 'G ', it, lmt1, lmt2, ia, ptrans(ik,ic,iv,ii,1), ptrans(ik,ic,iv,ii,2)
!
                end do
             end do
          end do
       end do

     end subroutine calc_ptrans_ek_core
 end subroutine calc_ptrans_ek

 subroutine calc_ptrans_TM_PP_ek
!
!   calculate KS correction term for Troullier-Martin PP
!
    implicit none
    integer                                :: id_sname = -1
    integer                                :: ispin, it, lmt, lmt1, lmt2, il, il1, il2, ia
    integer                                :: ik, ii, ib, ib1, ilmta, p, p1
    integer                                :: ilmta_add, nspher1, nspher2
    integer                                :: icount, im1
    real(kind=DP)                          :: fac, eib, eib1
    real(kind=DP),pointer,dimension(:,:,:) :: wkfsr, wkfsi, wkfsr_add, wkfsi_add

    call tstatc0_begin('calc_ptrans_TM_PP_ek ',id_sname)
    allocate(wkfsr(neg,nlmta,kv3)); wkfsr=0.0d0
    allocate(wkfsi(neg,nlmta,kv3)); wkfsi=0.0d0
    allocate(wkfsr_add(neg,nlmta_add,kv3)); wkfsr_add=0.0d0
    allocate(wkfsi_add(neg,nlmta_add,kv3)); wkfsi_add=0.0d0

    if(sw_use_add_proj==ON) then
       call m_ES_add_betar_dot_WFs(nfout)
       if(printable) &
       & write(nfout,'(1x,"!* fsr_add_l and fsi_add_l have been calculated")')
    else
       if(printable) then
          write(nfout,'(1x,"!* fsr_add_l and fsi_add_l cannot be callculated")')
          write(nfout,'(1x,"!* skip correction for additional projector ")')
       end if
       return
    end if

    if(npes >= 2) call mpi_barrier(MPI_CommGroup,ierr)

! make copy of fsr_l and fsi_l
    do ik = 1, kv3, af+1
       do ib = 1, neg
          if(map_ek(ib,ik) == mype) then
               do ilmta=1, nlmta
                  wkfsr(ib,ilmta,ik) = fsr_l(map_z(ib),ilmta,ik)
                  wkfsi(ib,ilmta,ik) = fsi_l(map_z(ib),ilmta,ik)
               end do
               if(map_ek(ib,ik) /= 0) then
                   call mpi_send(wkfsr,neg*nlmta*kv3,mpi_double_precision,0,1,MPI_CommGroup,ierr) ! MPI
                   call mpi_send(wkfsi,neg*nlmta*kv3,mpi_double_precision,0,1,MPI_CommGroup,ierr) ! MPI
               end if
          else if(mype == 0 .and. map_ek(ib,ik) /= 0) then
            call mpi_recv(wkfsr,neg*nlmta*kv3,mpi_double_precision,map_ek(ib,ik),1,MPI_CommGroup,istatus,ierr)!MPI
            call mpi_recv(wkfsi,neg*nlmta*kv3,mpi_double_precision,map_ek(ib,ik),1,MPI_CommGroup,istatus,ierr)!MPI
         end if
         if(npes >= 2)  then
              call mpi_bcast(wkfsr,neg*nlmta*kv3,mpi_double_precision,0,MPI_CommGroup,ierr)!MPI
              call mpi_bcast(wkfsi,neg*nlmta*kv3,mpi_double_precision,0,MPI_CommGroup,ierr)!MPI
         end if
       end do
    end do

! make copy of fsr_add_l and fsi_add_l
    do ik = 1, kv3, af+1
       do ib = 1, neg
          if(map_ek(ib,ik) == mype) then
               do ilmta_add = 1, nlmta_add
                  wkfsr_add(ib,ilmta_add,ik) = fsr_add_l(map_z(ib),ilmta_add,ik)
                  wkfsi_add(ib,ilmta_add,ik) = fsi_add_l(map_z(ib),ilmta_add,ik)
               end do
               if(map_ek(ib,ik) /= 0) then
                  call mpi_send(wkfsr_add,neg*nlmta_add*kv3,mpi_double_precision,0,1,MPI_CommGroup,ierr) ! MPI
                  call mpi_send(wkfsi_add,neg*nlmta_add*kv3,mpi_double_precision,0,1,MPI_CommGroup,ierr) ! MPI
               end if
          else if(mype == 0 .and. map_ek(ib,ik) /= 0) then
            call mpi_recv(wkfsr_add,neg*nlmta_add*kv3,mpi_double_precision,map_ek(ib,ik),1,MPI_CommGroup,istatus,ierr)!MPI
            call mpi_recv(wkfsi_add,neg*nlmta_add*kv3,mpi_double_precision,map_ek(ib,ik),1,MPI_CommGroup,istatus,ierr)!MPI
         end if
         if(npes >= 2)  then
              call mpi_bcast(wkfsr_add,neg*nlmta_add*kv3,mpi_double_precision,0,MPI_CommGroup,ierr)!MPI
              call mpi_bcast(wkfsi_add,neg*nlmta_add*kv3,mpi_double_precision,0,MPI_CommGroup,ierr)!MPI
         end if
       end do
    end do

! skip if PP has no local orbital
    do it = 1, ntyp
       !!if(printable) then
       !!  write(nfout,*) 'local orbital: it=',it
       !!  write(nfout,*) 'local orbital: l=',ilocal_l(it)
       !!end if
       if(ilocal_l(it)==0) then
          if(printable) then
             write(nfout,'(1x,"!* ilocal =0 for it = ",i3)') it
             write(nfout,'(1x,"!* additional projector correction is skipped")')
          end if
          cycle
       end if

! check <additional projector|WF> for l=ilocal
       do lmt=1,ilmt_add(it)
          il=ltp_add(lmt,it)
          if(il==ilocal_l(it)) then
             exit
          else
             if(lmt== ilmt_add(it)) then
                if(printable) then
                   write(nfout,'(1x,"!* additional projector for for iloc is not given for it = ",i3)') it
                   write(nfout,'(1x,"!* calculate additional projector for iloc")')
                end if
                stop
             end if
          end if
       end do

! calculate correction for local orbital
! add sum[<WF1|additional projector>p<beta|WF2>] term
       !!if(printable) write(nfout,*) 'nrd_efermi=',nrd_efermi
       icount=0
       do ii = 1, 3
          do ispin = 1, nspin, af+1
             do ik = ispin, kv3-nspin+ispin, nspin
                do ib = 1, neg
                   do ib1 = 1, neg

!                      if(nrd_efermi==1) then
!                         eib=e2_mpi(ib,ik)
!                         eib1=e2_mpi(ib1,ik)
                         !!if(printable) write(nfout,*) 'calc_ptrans_TM_PP_ek_core_1, eib,eib1=',eib,eib1
!                         if(eib.gt.efermi.and.eib1.le.efermi) call calc_ptrans_TM_PP_ek_core_1
!                      else
                         !!if(printable) write(nfout,*) 'calc_ptrans_TM_PP_ek_core_1, ib,ib1=',ib,ib1
                         if(ib/=ib1) call calc_ptrans_TM_PP_ek_core_1
!                      end if
                   end do
                end do
             end do
          end do
       end do
       if(printable) write(nfout,'(1x,"!* number of additional ppc1 terms = ", i8)') icount
! add sum sum[<WF1|beta>p<additional projector|WF2>] term
       icount=0
       do ii = 1, 3
          do ispin = 1, nspin, af+1
             do ik = ispin, kv3-nspin+ispin, nspin
                do ib = 1, neg
                   do ib1 = 1, neg
!                      if(nrd_efermi==1) then
!                         eib=e2_mpi(ib,ik)
!                         eib1=e2_mpi(ib1,ik)
!                         if(eib.gt.efermi.and.eib1.le.efermi) call calc_ptrans_TM_PP_ek_core_2
!                      else
                         if(ib/=ib1) call calc_ptrans_TM_PP_ek_core_2
!                      end if
                   end do
                end do
             end do
          end do
       end do
       if(printable) write(nfout,'(1x,"!* number of additional ppc2 terms = ", i8)') icount
    end do

    deallocate(wkfsr)
    deallocate(wkfsi)
    deallocate(wkfsr_add)
    deallocate(wkfsi_add)

    call tstatc0_end(id_sname)

    contains
     subroutine calc_ptrans_TM_PP_ek_core_1
       integer :: iv, ic, ifind
       integer :: index, ifact

!       call find_ind_vb_and_cb2(ib1,ib,iv,ic,nk_in_the_process+ik-1,ifind)
!       if(ifind==0.and.printable) then
!          write(nfout,'(1x,"!!* valence or conduction band index is not found   UVSOR-Epsilon STOP at calc_ptrans")')
!       end if

! -----------------
       iv = ib1
       ic = ib
! ----------------

       do lmt1 = 1, ilmt_add(it)
          il1 = ltp_add(lmt1,it)
          if(il1/=ilocal_l(it)) cycle
          do lmt2 = 1, ilmt(it)
! lmt1 -> index for additional projector
! lmt2 -> index for beta
             !!if(printable) &
             !!& write(nfout,*) 'find_ptrans_index_add_beta: it,lmt1,il1,lmt2,nppc_data(it)=',it,lmt1,il1,lmt2,nppc_data(it)
             call find_ptrans_index_add_beta(it,lmt1,lmt2,nppc_data(it),index,ifact)
             !!if(printable) write(nfout,*) 'find_ptrans_index_add_beta: index,ifact=',index,ifact
             if(index==0) cycle
             do ia = 1, natm
                if(ityp(ia) /= it) cycle
                fac = real(ifact,kind=DP)*real(iwei(ia),kind=DP)
                p =  lmta_add(lmt1,ia)
                p1 = lmta(lmt2,ia)
                ptrans(ik,ic,iv,ii,1) = ptrans(ik,ic,iv,ii,1) &
             & + fac*dipole_dxyz_us(it,index,ii) &
             & *(wkfsr_add(ib,p,ik)*wkfsi(ib1,p1,ik) - wkfsi_add(ib,p,ik)*wkfsr(ib1,p1,ik))
                ptrans(ik,ic,iv,ii,2) = ptrans(ik,ic,iv,ii,2) &
             & -1.0d0*fac*dipole_dxyz_us(it,index,ii) &
             & *(wkfsr_add(ib,p,ik)*wkfsr(ib1,p1,ik) + wkfsi_add(ib,p,ik)*wkfsi(ib1,p1,ik))
                icount=icount+1
             end do
          end do
       end do
     end subroutine calc_ptrans_TM_PP_ek_core_1

     subroutine calc_ptrans_TM_PP_ek_core_2
       integer :: iv, ic, ifind
       integer :: index, ifact

!       call find_ind_vb_and_cb2(ib1,ib,iv,ic,nk_in_the_process+ik-1,ifind)
!       if(ifind==0.and.printable) then
!          write(nfout,'(1x,"!!* valence or conduction band index is not found   UVSOR-Epsilon STOP at calc_ptrans")')
!       end if

! ------------------
       iv = ib1
       ic = ib
! -----------------
       do lmt1 = 1, ilmt(it)
          do lmt2 = 1, ilmt_add(it)
! lmt1 --> index for beta
! lmt2 --> index for additional projector
             il2 = ltp_add(lmt2,it)
             if(il2/=ilocal_l(it)) cycle
             call find_ptrans_index_add_beta(it,lmt2,lmt1,nppc_data(it),index,ifact)
             if(index==0) cycle
             ifact=-1*ifact
             do ia = 1, natm
                if(ityp(ia) /= it) cycle
                fac = real(ifact,kind=DP)*real(iwei(ia),kind=DP)
                p = lmta(lmt1,ia)
                p1 = lmta_add(lmt2,ia)
! p  --> index for beta
! p1 --> index for addtional projector
                ptrans(ik,ic,iv,ii,1) = ptrans(ik,ic,iv,ii,1) &
             & + fac*dipole_dxyz_us(it,index,ii) &
             & *(wkfsr(ib,p,ik)*wkfsi_add(ib1,p1,ik) - wkfsi(ib,p,ik)*wkfsr_add(ib1,p1,ik))
                ptrans(ik,ic,iv,ii,2) = ptrans(ik,ic,iv,ii,2) &
             & -1.0d0*fac*dipole_dxyz_us(it,index,ii) &
             & *(wkfsr(ib,p,ik)*wkfsr_add(ib1,p1,ik) + wkfsi(ib,p,ik)*wkfsi_add(ib1,p1,ik))
                icount=icount+1
             end do
          end do
       end do
     end subroutine calc_ptrans_TM_PP_ek_core_2

     subroutine find_ptrans_index_add_beta(it,lmt1,lmt2,nptrans,index,ifact)
       implicit none
!
!      find core-repair term pij for <WF|addotional projector(i)>pij<beta(j)|WF2>
!
!      lmt1      : lmt index for additinal projector
!      lmt2      : lmt index for beta
!      nspher1   : spherical harmonics index for lmt1
!      nspher2   : spherical harmonics index for lmt2
!      ifact = 1 : nspher1 < nspher2
!      ifact = -1: nspher1 > nspher2
!      index     : dipole_dxyz_us index
!            = 0 : for nspher1=nspher2 case
!
       integer, intent(in)  :: it,lmt1,lmt2, nptrans
       integer, intent(out) :: index,ifact
       integer              :: lmtt1,il1,im1,tau1,nspher1
       integer              :: lmtt2,il2,im2,tau2,nspher2
       integer              :: nspher10, nspher20
       integer              :: tau10,tau20
       integer              :: iptrans

       index=0
       ifact=0

       !!if(printable) write(nfout,*) 'm_PP_tell_lmtt_l_m_tau_add:lmt1=',lmt1
       call m_PP_tell_lmtt_l_m_tau_add(lmt1,it,lmtt1,il1,im1,tau1,nspher1)
       !!if(printable) then
       !!   write(nfout,*) 'm_PP_tell_lmtt_l_m_tau_add:tau1,nspher1=',tau1,nspher1
       !!   write(nfout,*) 'm_PP_tell_lmtt_l_m_tau:lmt2=',lmt2
       !!end if
       call m_PP_tell_lmtt_l_m_tau(lmt2,it,lmtt2,il2,im2,tau2,nspher2)
       !!if(printable) write(nfout,*) 'm_PP_tell_lmtt_l_m_tau:tau2,nspher2=',tau2,nspher2

       if(nspher1>nspher2) then
          nspher20=nspher1
          nspher10=nspher2
          tau20=tau1
          tau10=tau2
          ifact=-1
       else
          nspher10=nspher1
          nspher20=nspher2
          tau10=tau1
          tau20=tau2
         ifact=1
       end if
       !!if(printable) write(nfout,*) 'loop iptans'
!      find core repair term with dipole_tau=tau, phase_ylm=nspher
       do iptrans=1,nptrans
          if(phase_ylm1(it,iptrans)==nspher10.and.phase_ylm2(it,iptrans)==nspher20) then
             if(dipole_tau1(it,iptrans)==tau10.and.dipole_tau2(it,iptrans)==tau20) then
                index=iptrans
                exit
              end if
          end if
       end do
       !!if(printable) write(nfout,*) 'end loop iptans'
     end subroutine find_ptrans_index_add_beta

   end subroutine calc_ptrans_TM_PP_ek

 end module m_LinearResponse_Density

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 635 $)
!
!  MODULE: m_ES_IO
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_IODO__
#   define __TIMER_IODO_START(a)   call timer_sta(a)
#   define __TIMER_IODO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_IODO_START(a)
#   define __TIMER_IODO_STOP(a)
#endif
#ifdef __TIMER_IOCOMM__
#   define __TIMER_IOCOMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_IOCOMM_START(a)       call timer_sta(a)
#   define __TIMER_IOCOMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_IOCOMM_START_w_BARRIER(str,a)
#   define __TIMER_IOCOMM_START(a)
#   define __TIMER_IOCOMM_STOP(a)
#endif

!#define _DEBUG_ESIO_

#define _USE_ALLREDUCE_IN_WD_WFS_

!
module m_ES_IO
! $Id: m_ES_IO.F90 635 2021-02-26 07:16:10Z jkoga $
  use m_Electronic_Structure, only : zaj_l,neordr,nrvf_ordr,eko_l,occup_l,efermi,efermi_spin,totch&
       &                            ,vnlph_l,vlhxc_l,eko_ek, zaj_l_prev, metalic_system, vbm
  use m_PlaneWaveBasisSet,    only : kgp,kg1,ngabc,nbase,iba
  use m_Kpoints,              only : kv3, vkxyz, vkxyz_ek, kv3_ek, k_symmetry, qwgt, &
       &                             m_Kp_get_nkmesh, m_Kp_get_kptable_bxsf, &
       &                             vkxyz_refcell
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,   only : nspin,kimg,neg,num_extra_bands,af,ipri, printable, neg_previous &
       &                           , wf_filetype, wf_title, eigmin_wf, eigmax_wf, ekmode, neg_is_enlarged &
       &                           , icond, fixed_charge_k_parallel, sw_ekzaj, numk_zajsaved, Nw_Psicoef &
       &                           , precision_WFfile
  use m_Const_parameters,     only : DP, SP, CMPLDP, BUCS, OFF, YES, EK, SCF, DENSITY_ONLY &
       &                           , CUBE, VTK, BINARY, GAMMA, GAMMA_base_symmetrization, ONE_BY_ONE &
       &                           , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, DELTA &
       &                           , EFERMI_VICINITY, ALL_VALUES, GRID, ON
  use m_Parallelization,      only : MPI_CommGroup,mpi_k_world,mpi_e_world,is_kngp,ie_kngp,npes &
       &                           , mype,ierr,map_k, map_ek,ista_e,iend_e,istep_e,map_z, np_e &
       &                           , ista_k,iend_k,myrank_e,myrank_k,map_e,nrank_e &
       &                           , ista_kngp,iend_kngp, nrank_k  &
       &                           , ista_g1k,iend_g1k, np_g1k , myrank_g, nrank_g, np_g1k_prev &
       &                           , nis_g1k,nie_g1k,map_rank_gek, myrank_ke, mpi_ke_world  &
       &                           , ista_spin, iend_spin, map_s, myrank_spin
  use m_IterationNumbers,     only : nk_in_the_process, nk_converged, nkgroup &
       &                           , first_kpoint_in_this_job, iteration_ionic, iteration_electronic
  use m_FFT,                  only : fft_box_size_WF,nfft
  use m_Crystal_Structure,    only : altv, sw_fix_total_spin, altv_refcell
  use m_Ionic_System,         only : natm,natm2,iatomn,m_IS_pack_all_ions_in_uc
  use m_PseudoPotential,      only : ival
  use m_Crystal_Structure,    only : univol, rltv
  use m_Parallelization,      only : neg_g,ista_g1k_prev,iend_g1k_prev

! ===================================== added by K. Tagami ============= 11.0
  use m_Control_Parameters,    only : ndim_spinor, noncol, &
       &                              previous_nspin_collinear, &
       &                              previous_nband_collinear
! ====================================================================== 11.0
  use m_ErrorMessages,        only : EOF_REACHED
  use m_Parallelization,      only : mpi_kg_world, mpi_ge_world

  use m_Control_Parameters, only : ndim_magmom, ik_wf_squared, &
       &                           ib1_wf_squared, ib2_wf_squared, &
       &                           wf_squared_filetype,  max_projs, proj_attribute, &
       &                           ndim_chgpot, SpinOrbit_Mode, &
       &                           wf_orb_proj_print_format, proj_group, num_proj_elems, &
       &                           sw_band_unfolding
  use m_Const_parameters,     only : Neglected, PAI2, CARTS, DELTA07, HARTREE, BOHR
  use m_Files,              only :  nfwfk_sq, m_Files_open_nfwfksq_noncl, &
       &                            nfwfk_integ_mom, &
       &                            m_Files_open_nfwfk_integ_mom, &
       &                            m_Files_close_nfwfk_integ_mom, &
       &                            m_Files_open_nfwfk_orb_proj, &
       &                            m_Files_close_nfwfk_orb_proj, &
       &                            nfwfk_orb_proj
  use m_PseudoPotential,   only : nlmt, ilmt, lmta, q, &
       &                          nlmta_phi, nlmtt_phi, qorb, m_PP_tell_iorb_lmtt, &
       &                          m_PP_tell_iorb_ia_l_m_tau, ilmt_phi, &
       &                          mtp_phi, lmta_phi, ltp_phi, taup_phi
  use m_Nonlocal_Potential,   only : norm_phig
  use m_Charge_Density,    only : chgq_l, hsr, hsi, &
       &                          m_CD_alloc_rspace_charge, &
       &                          m_CD_dealloc_rspace_charge, &
       &                          m_CD_rspace_charge_noncl
  use m_Ionic_System,      only : ityp, iproj_group
  use m_Electronic_Structure,  only : fsr_l, fsi_l, compr_l, compi_l
  use m_ES_Noncollinear,   only : m_ES_set_Pauli_Matrix
  use m_SpinOrbit_Potential,  only :  MatU_ylm_RC_L0,  MatU_ylm_RC_L1,  MatU_ylm_RC_L2, &
       &                              MatU_ylm_RC_L3

! ==== EXP_CELLOPT ==== 2015/09/24
  use m_PlaneWaveBasisSet,    only : kg1_prev
! ===================== 2015/09/24

  use m_ES_initialWF, only : m_ESIW_by_randomnumbers0_3D
  use m_ES_ortho, only : m_ES_modified_gram_schmidt
  use m_ES_nonlocal, only : m_ES_betar_dot_WFs_3D
  use mpi

  implicit none
!  include 'mpif.h'

  integer istatus(mpi_status_size)

  real(kind=SP), allocatable, dimension(:,:)  :: wf_l   ! work wave functions
  real(kind=DP), allocatable, dimension(:,:)  :: wfdp_l ! work wave functions

!  1.  m_ESIO_rd_EigenValues_etc    <-(Initial_Electronic_Structure)
!  2.  m_ESIO_wd_EigenValues_etc    <-(WriteDownData_onto_Files, Postprocessing)
!  3.  m_ESIO_wd_EigenValues        <-(WriteDownData_onto_Files, Convergence_Check, Postprocessing)
!  4.  m_ESIO_wd_EigenValues_ek     <-(WriteDownData_onto_Files)
!  5.  m_ESIO_wd_vlhxc              <-(Postprocessing)
!  6.  m_ESIO_rd_WFs                <-(Initial_Electronic_Structure, scf_rd_wf_and_chg)
!  7.  m_ESIO_rd_WFs_import_frm_collin    <-(Initial_Electronic_Structure)
!  8.  m_ESIO_wd_WFs                <-(WriteDownData_onto_Files)
!  9.  m_ESIO_wd_WFs_standardout    <-(Renewal_of_WaveFunctions)
! 10.  m_ESIO_rd_WFs_and_EVs_ek     <-(Initial_Electronic_Structure)
! 11.  m_ESIO_rd_EVs_ek             <-(Initial_Electronic_Structure)
! 12.  m_ESIO_wd_Psicoef            <-(WriteDownData_onto_Files)
! 13.  m_ESIO_wd_WFs_and_EVs_ek     <-(WriteDownData_onto_Files, WriteDownData_onto_Files_ek, Convergence_Check)
! 14.  m_ESIO_wd_WFn                <-(Postprocessing)
! 15.  m_ESIO_wd_Efermi             <-(WriteDownData_onto_Files)
! 16.  m_ESIO_rd_Eferm              <-(Initial_Electronic_Structure, scf_rd_wf_and_chg)
! 17.  m_ESIO_wd_WFs_3D             <-(WriteDownData_onto_Files)
! 18.  m_ESIO_rd_WFs_dp_3D
! 19.  m_ESIO_wd_WFs_dp_3D

contains
  subroutine m_ESIO_rd_EigenValues_etc(nfout,nfcntn_bin,F_CNTN_BIN_partitioned)
   use m_Parallelization,     only : mpi_ke_world, mpi_kg_world, mpi_chg_world

    integer, intent(in) :: nfout, nfcntn_bin
    logical, intent(in) :: F_CNTN_BIN_partitioned
    integer  :: ik, ie, ispin
    integer  :: ie_from
    integer, allocatable, dimension(:,:) :: n1_wk, n2_wk  ! MPI
    real(DP),allocatable, dimension(:,:) :: e1_wk, e2_wk  ! MPI
!!$    read(nfcntn_bin) neordr,nrvf_ordr,eko_l,occup_l,efermi,totch
                                                  __TIMER_SUB_START(1370)
    if(F_CNTN_BIN_partitioned) then
       if(neg_previous /= neg) then
          write(nfout,'(" !! neg_previous /= neg <<m_ESIO_rd_EigenValues_etc>>")')
          write(nfout,'(" !! neg_prevous = ",i8)') neg_previous
          write(nfout,'(" !! neg         = ",i8)') neg
          write(nfout,'(" neg_previous should be neg when F_CNTN_BIN_in_partitioned is true")')
          call phase_error_with_msg(nfout,' neg_previous should be neg when F_CNTN_BIN_in_partitioned is true',__LINE__,__FILE__)
       end if
       allocate(n1_wk(neg,iend_k-ista_k+1), n2_wk(neg,iend_k-ista_k+1))
       allocate(e1_wk(np_e,iend_k-ista_k+1),e2_wk(np_e,iend_k-ista_k+1))
       n1_wk = 0; n2_wk = 0
       e1_wk = 0; e2_wk = 0
       ! -- neordr, nrvf_ordr --
                                                  __TIMER_IODO_START(1405)
       read(nfcntn_bin) n1_wk
       read(nfcntn_bin) n2_wk
                                                  __TIMER_IODO_STOP(1405)
                                                  __TIMER_IODO_START(1406)
       do ik = ista_k, iend_k
          neordr(1:neg,ik) = n1_wk(1:neg,ik-ista_k+1)
          nrvf_ordr(1:neg,ik) = n2_wk(1:neg,ik-ista_k+1)
       end do
                                                  __TIMER_IODO_STOP(1406)
       ! -- eko_l, occup_l --
                                                  __TIMER_IODO_START(1407)
       read(nfcntn_bin) e1_wk
       read(nfcntn_bin) e2_wk
                                                  __TIMER_IODO_STOP(1407)
                                                  __TIMER_IODO_START(1408)
       do ik = ista_k, iend_k
          do ie = 1, np_e
             eko_l(ie,ik)   = e1_wk(ie,ik-ista_k+1)
             occup_l(ie,ik) = e2_wk(ie,ik-ista_k+1)
          end do
       end do
                                                  __TIMER_IODO_STOP(1408)
       deallocate(e2_wk,e1_wk,n2_wk,n1_wk)
       ! -- nfermi, totch --
       read(nfcntn_bin) efermi, totch
    else
       allocate(n1_wk(neg_previous,kv3),n2_wk(neg_previous,kv3)) ! MPI
       allocate(e1_wk(neg_previous,kv3),e2_wk(neg_previous,kv3)) ! MPI
       n1_wk = 0; n2_wk = 0
       e1_wk = 0; e2_wk = 0

       ! -- neordr, nrvf_ordr --
                                                  __TIMER_IODO_START(1409)
       if(mype == 0) read(nfcntn_bin) n1_wk                ! MPI
       if(mype == 0) read(nfcntn_bin) n2_wk                ! MPI
                                                  __TIMER_IODO_STOP(1409)
                                                  __TIMER_IOCOMM_START_w_BARRIER(MPI_CommGroup,1410)
       if(npes > 1) then
          call mpi_bcast(n1_wk,neg_previous*kv3,mpi_integer,0,MPI_CommGroup,ierr) ! MPI
          call mpi_bcast(n2_wk,neg_previous*kv3,mpi_integer,0,MPI_CommGroup,ierr) ! MPI
       endif
                                                  __TIMER_IOCOMM_STOP(1410)
                                                  __TIMER_IODO_START(1411)
       do ispin = ista_spin, iend_spin
       do ik = ispin, kv3-nspin+ispin, nspin
       !do ik = ista_k, iend_k                              ! MPI
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          neordr(1:neg_previous,ik) = n1_wk(1:neg_previous,ik)
          nrvf_ordr(1:neg_previous,ik) = n2_wk(1:neg_previous,ik)
          if(neg_previous < neg) then
             do ie = neg_previous+1, neg
                neordr(ie,ik) = ie
                nrvf_ordr(ie,ik) = ie
             end do
          end if
       end do                                              ! MPI
       end do                                              ! MPI
                                                  __TIMER_IODO_STOP(1411)
       ! -- eko_l, occup_l --
                                                  __TIMER_IODO_START(1412)
       if(mype == 0) read(nfcntn_bin) e1_wk                ! MPI
       if(mype == 0) read(nfcntn_bin) e2_wk                ! MPI
                                                  __TIMER_IODO_STOP(1412)
                                                  __TIMER_IOCOMM_START_w_BARRIER(MPI_CommGroup,1413)
       if(npes > 1) then
          call mpi_bcast(e1_wk,neg_previous*kv3,mpi_double_precision,0,MPI_CommGroup,ierr) ! MPI
          call mpi_bcast(e2_wk,neg_previous*kv3,mpi_double_precision,0,MPI_CommGroup,ierr)! MPI
       end if
                                                  __TIMER_IOCOMM_STOP(1413)
                                                  __TIMER_IODO_START(1414)
       do ispin = ista_spin, iend_spin
       do ik = ispin, kv3-nspin+ispin, nspin
       !do ik = ista_k, iend_k                              ! MPI
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          do ie = 1, np_e                          ! MPI
             ie_from = neordr(neg_g(ie),ik)
             if( ie_from > neg_previous ) cycle
              eko_l(ie,ik) = e1_wk(ie_from,ik)            ! MPI
              occup_l(ie,ik) = e2_wk(ie_from,ik)            ! MPI
          end do                                           ! MPI
          if(neg_previous < neg) then
            do ie = 1, np_e
             ie_from = neordr(neg_g(ie),ik)
             if( ie_from < neg_previous ) cycle
               eko_l(ie,ik) = 1.d+15
               occup_l(ie,ik) = 0.d0
            end do
          end if
       end do                                              ! MPI
       end do                                              ! MPI
                                                  __TIMER_IODO_STOP(1414)
       ! -- nfermi, totch --
       if(mype == 0) read(nfcntn_bin) efermi, totch        ! MPI
       if(npes > 1) then
          call mpi_bcast(efermi,1,mpi_double_precision,0,MPI_CommGroup,ierr) ! MPI
          call mpi_bcast(totch,1, mpi_double_precision,0,MPI_CommGroup,ierr) ! MPI
       end if

       deallocate(e2_wk,e1_wk,n2_wk,n1_wk)
    end if

    if(printable) write(nfout,'(" TOTCH (total charge) = ",f12.6 &
         & ," (= ",8d25.12,") at m_ESIO_rd_EigenValues_etc")') totch,totch

                                                  __TIMER_SUB_STOP(1370)
  end subroutine m_ESIO_rd_EigenValues_etc

  subroutine m_ESIO_wd_EigenValues_etc(nfcntn_bin,F_CNTN_BIN_partitioned,totch_flag)
   use m_Parallelization,     only : mpi_ke_world, mpi_kg_world, mpi_ge_world, mpi_chg_world

    integer, intent(in) :: nfcntn_bin
    logical, intent(in) :: F_CNTN_BIN_partitioned
    integer, optional, intent(in) :: totch_flag

    integer  :: ik, ie, mpi_comm1,mpi_comm2
    integer, allocatable, dimension(:,:) :: n_wk, n2_mpi  ! MPI
    real(DP),allocatable, dimension(:,:) :: e_wk, e2_mpi  ! MPI
    integer    :: ispin
    integer  :: id_sname = -1
                                                  __TIMER_SUB_START(1371)
    call tstatc0_begin('m_ESIO_wd_EigenValues_etc ',id_sname)

    mpi_comm1 = mpi_kg_world
    mpi_comm2 = mpi_ge_world

    if(F_CNTN_BIN_partitioned) then
       allocate(n_wk(neg,iend_k-ista_k+1))
       allocate(e_wk(np_e,iend_k-ista_k+1))
       n_wk = 0; e_wk = 0
       !  -- neordr --
                                                  __TIMER_IODO_START(1415)
       do ik = ista_k, iend_k
          n_wk(1:neg,ik-ista_k+1) = neordr(1:neg,ik)
       end do
                                                  __TIMER_IODO_STOP(1415)
                                                  __TIMER_IODO_START(1416)
       write(nfcntn_bin) n_wk
                                                  __TIMER_IODO_STOP(1416)
       !  -- nrvf_ordr --
                                                  __TIMER_IODO_START(1417)
       do ik = ista_k, iend_k
          n_wk(1:neg,ik-ista_k+1) = nrvf_ordr(1:neg,ik)
       end do
                                                  __TIMER_IODO_STOP(1417)
                                                  __TIMER_IODO_START(1418)
       write(nfcntn_bin) n_wk
                                                  __TIMER_IODO_STOP(1418)
       !  -- eko_l --
       e_wk = 0.d0
                                                  __TIMER_IODO_START(1419)
       do ik = ista_k, iend_k
          do ie = 1, np_e
             e_wk(ie,ik-ista_k+1) = eko_l(ie,ik)
          end do
       end do
                                                  __TIMER_IODO_STOP(1419)
                                                  __TIMER_IODO_START(1420)
       write(nfcntn_bin) e_wk
                                                  __TIMER_IODO_STOP(1420)
!!$       if(npes >= 2) then
!!$          call mpi_allreduce(e_wk,e2_mpi,neg*(iend_k-ista_k+1),mpi_double_precision &
!!$               &               , mpi_sum, mpi_k_world)
!!$       else
!!$          e2_mpi = e_wk
!!$       end if
!!$       write(nfcntn_bin) e2_mpi

       !  -- occup_l --
       e_wk = 0.d0
                                                  __TIMER_IODO_START(1421)
       do ik = ista_k, iend_k
          do ie = 1, np_e
             e_wk(ie,ik-ista_k+1) = occup_l(ie,ik)
          end do
       end do
                                                  __TIMER_IODO_STOP(1421)
                                                  __TIMER_IODO_START(1422)
       write(nfcntn_bin) e_wk
                                                  __TIMER_IODO_STOP(1422)
!!$       if(npes >= 2) then
!!$          call mpi_allreduce(e_wk,e2_mpi,neg*(iend_k-ista_k+1),mpi_double_precision &
!!$               &               , mpi_sum, mpi_k_world)
!!$       else
!!$          e2_mpi = e_wk
!!$       end if
!!$       write(nfcntn_bin) e2_mpi
!!$       deallocate(e2_mpi, e_wk, n_wk)
       deallocate(e_wk, n_wk)

       if(totch_flag == OFF) then
          write(nfcntn_bin) efermi                     ! MPI
       else
          write(nfcntn_bin) efermi,totch               ! MPI
       end if
    else
       allocate(n_wk(neg,kv3)); allocate(n2_mpi(neg,kv3))! MPI
       allocate(e_wk(neg,kv3)); allocate(e2_mpi(neg,kv3))! MPI
       n_wk = 0; n2_mpi = 0
       e_wk = 0; e2_mpi = 0
       !  -- neordr --
       n_wk = 0                                          ! MPI
                                                  __TIMER_IODO_START(1423)
       do ispin = ista_spin, iend_spin
       !do ik = 1, kv3                                     ! MPI
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          n_wk(1:neg,ik) = neordr(1:neg,ik)               ! MPI
       end do                                             ! MPI
       end do                                             ! MPI
                                                  __TIMER_IODO_STOP(1423)
       if(npes >= 2) then
                                                  __TIMER_IOCOMM_START_w_BARRIER(mpi_comm1,1424)
          call mpi_allreduce(MPI_IN_PLACE,n_wk,neg*kv3,mpi_integer,mpi_sum,mpi_comm1,ierr)
          call mpi_allreduce(MPI_IN_PLACE,n_wk,neg*kv3,mpi_integer,mpi_sum,mpi_comm2,ierr)
          n2_mpi = n_wk/nrank_e
                                                  __TIMER_IOCOMM_STOP(1424)
       else
          n2_mpi = n_wk
       end if
                                                  __TIMER_IODO_START(1425)
       if(mype == 0) write(nfcntn_bin) n2_mpi             ! MPI ; writing (neordr)
                                                  __TIMER_IODO_STOP(1425)
       !  -- nrvf_ordr --
                                                  __TIMER_IODO_START(1426)
       n_wk = 0                                           ! MPI
       do ispin = ista_spin, iend_spin
       !do ik = 1, kv3                                     ! MPI
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          n_wk(1:neg,ik) = nrvf_ordr(1:neg,ik)            ! MPI
       end do                                             ! MPI
       end do                                             ! MPI
                                                  __TIMER_IODO_STOP(1426)
       if(npes >= 2) then
                                                  __TIMER_IOCOMM_START_w_BARRIER(mpi_comm1,1427)
          call mpi_allreduce(MPI_IN_PLACE,n_wk,neg*kv3,mpi_integer,mpi_sum,mpi_comm1,ierr)
          call mpi_allreduce(MPI_IN_PLACE,n_wk,neg*kv3,mpi_integer,mpi_sum,mpi_comm2,ierr)
          n2_mpi = n_wk/nrank_e
                                                  __TIMER_IOCOMM_STOP(1427)
       else
          n2_mpi = n_wk
       end if
                                                  __TIMER_IODO_START(1428)
       if(mype == 0) write(nfcntn_bin) n2_mpi             ! MPI ; writing (nrvf_ordr)
                                                  __TIMER_IODO_STOP(1428)
       !  -- eko_l --
       e_wk = 0.d0                                        ! MPI
                                                  __TIMER_IODO_START(1429)
       do ispin = ista_spin, iend_spin
       !do ik = 1, kv3                                     ! MPI
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          do ie = 1, np_e                                   ! MPI
             e_wk(neordr(neg_g(ie),ik),ik) = eko_l(ie,ik)           ! MPI
          end do
       end do
       end do
                                                  __TIMER_IODO_STOP(1429)
       if(npes >= 2) then
                                                  __TIMER_IOCOMM_START_w_BARRIER(mpi_comm1,1430)
          call mpi_allreduce(MPI_IN_PLACE,e_wk,neg*kv3,mpi_double_precision,mpi_sum,mpi_comm1,ierr)
          call mpi_allreduce(MPI_IN_PLACE,e_wk,neg*kv3,mpi_double_precision,mpi_sum,mpi_comm2,ierr)
          e2_mpi = e_wk
                                                  __TIMER_IOCOMM_STOP(1430)
       else
          e2_mpi = e_wk
       end if
                                                  __TIMER_IODO_START(1431)
       if(mype == 0) write(nfcntn_bin) e2_mpi             ! MPI ; writing (eko_l)
                                                  __TIMER_IODO_STOP(1431)

       !  -- occup_l --
       e_wk = 0.d0
                                                  __TIMER_IODO_START(1432)
       do ispin = ista_spin, iend_spin
       !do ik = 1, kv3                                     ! MPI
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          do ie = 1, np_e                                   ! MPI
             e_wk(neordr(neg_g(ie),ik),ik) = occup_l(ie,ik)         ! MPI
          end do                                            ! MPI
       end do                                               ! MPI
       end do                                               ! MPI
                                                  __TIMER_IODO_STOP(1432)
       if(npes >= 2) then
                                                  __TIMER_IOCOMM_START_w_BARRIER(mpi_comm1,1433)
          call mpi_allreduce(MPI_IN_PLACE,e_wk,neg*kv3,mpi_double_precision,mpi_sum,mpi_comm1,ierr)
          call mpi_allreduce(MPI_IN_PLACE,e_wk,neg*kv3,mpi_double_precision,mpi_sum,mpi_comm2,ierr)
          e2_mpi = e_wk
                                                  __TIMER_IOCOMM_STOP(1433)
       else
          e2_mpi = e_wk
       end if
                                                  __TIMER_IODO_START(1434)
       if(mype == 0) write(nfcntn_bin) e2_mpi             ! MPI ; writing (occup_l)
                                                  __TIMER_IODO_STOP(1434)
       if(mype == 0) then
          if(totch_flag == OFF) then
             if(metalic_system) then
               write(nfcntn_bin) efermi                     ! MPI
             else
               write(nfcntn_bin) vbm+1.d-10
             endif
          else
             if(metalic_system) then
               write(nfcntn_bin) efermi,totch               ! MPI
             else
               write(nfcntn_bin) vbm+1.d-10,totch
             endif
          end if
       end if
       deallocate(n_wk); deallocate(n2_mpi)              ! MPI
       deallocate(e_wk); deallocate(e2_mpi)              ! MPI
    end if
    call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(1371)
  end subroutine m_ESIO_wd_EigenValues_etc

  subroutine m_ESIO_wd_EigenValues(nf,iprieigen,nooccupation)
   use m_Parallelization,     only : mpi_ke_world, mpi_kg_world, mpi_chg_world
   use m_Parallelization,     only : mpi_ge_world

    integer, intent(in)              :: nf
    integer, intent(in)              :: iprieigen
    integer, intent(in)              :: nooccupation
    integer                          :: ie,  ipri0, kv3_i, ks
    integer                          :: hconst_min, lzero_max
    integer, parameter :: NCOLUMN = 6
    integer, parameter :: EIGEN_VALUES = 1, OCCUPATIONS = 2
    integer :: writemode
    real(kind=DP),allocatable, dimension(:,:) :: e_mpi, o_mpi
                                                  __TIMER_SUB_START(1378)
    allocate(e_mpi(neg,kv3)); e_mpi = 0.d0
    allocate(o_mpi(neg,kv3)); o_mpi = 0.d0

    call set_writemode(writemode)  ! ->(writemode) = ALL_VALUES or FERMI_VICINITY
    call get_ipri0(iprieigen,ipri0)

    if(ipri0 >= 2) then
       if(ipri0 >= 3 .and. nf == 6 .and. printable) call wd_neordr()

       call set_kv3_i_and_ks() ! -> kv3_i, ks
#ifndef _DEBUG_WRITE_
       if(writemode == EFERMI_VICINITY .and. kv3_i == kv3) &
            & call cal_vicinity_range(hconst_min,lzero_max) ! -> lzero_max, hconst_min
#endif
!     --- Energy eigen values ---
       call put_kpartArray_into(eko_l,e_mpi)
       if(printable) then
          if(ks == 0 .and. nf==6) call wd_efermi()
!!$          if(ks == 0) call wd_efermi()
          call wd_k_and_values(EIGEN_VALUES)
       end if
    end if
!     --- Occupations ---
    if(ipri0 >= 2 .and. nooccupation /= YES) then
       call put_kpartArray_into(occup_l,o_mpi)
       if(printable) call wd_k_and_values(OCCUPATIONS)
    end if
    deallocate(e_mpi)
    deallocate(o_mpi)
                                                  __TIMER_SUB_STOP(1378)
  contains
    subroutine set_writemode(writemode)
      integer, intent(out) :: writemode
      writemode = ALL_VALUES
#ifndef _DEBUG_WRITE_
      if(nf==6) then
         if((icond == FIXED_CHARGE_CONTINUATION .or. icond == FIXED_CHARGE) .and. &
              & fixed_charge_k_parallel == ONE_BY_ONE) then
            writemode = ALL_VALUES
         else
            if(neg <= NCOLUMN) then
               writemode = ALL_VALUES
            else
               writemode = EFERMI_VICINITY
            end if
         end if
      end if
#endif
    end subroutine set_writemode

    subroutine set_kv3_i_and_ks()
!!$      if(iprieigen>=2 .and. printable) then
      if((icond == FIXED_CHARGE_CONTINUATION .or. icond == FIXED_CHARGE) .and. &
           & fixed_charge_k_parallel == ONE_BY_ONE) then
         kv3_i = kv3_ek - kv3*(nkgroup-1)
         if(kv3_i > kv3) kv3_i = kv3
         ks = max(1,first_kpoint_in_this_job) - 1 + kv3*(nkgroup-1)
      else
         kv3_i = kv3
         ks = 0
      end if

      if(iprieigen>=3 .and. printable) &
           & write(nf,'(" kv3_i, kv3, ks, nkgroup = ",4i8)') kv3_i, kv3, ks, nkgroup
!!$
!!$      call mpi_bcast(kv3_i,1,mpi_integer,0,MPI_CommGroup,ierr)
!!$      call mpi_bcast(ks,1,mpi_integer,0,MPI_CommGroup,ierr)
    end subroutine set_kv3_i_and_ks

    subroutine wd_k_and_values(mode)
      integer, intent(in) :: mode
      integer :: ik, nb
      integer :: ie_s, ie_e, nhw, neg_t
      real(kind=DP) :: hw, hc, hv

#ifndef _DEBUG_WRITE_
      if(writemode == EFERMI_VICINITY) then
         hw = (lzero_max-hconst_min)*0.5d0
         hv = (lzero_max+hconst_min)*0.5d0
         hc = NCOLUMN*0.5d0
         nhw = Int(hw/hc + 1.d0)
         ie_s = max(nint(hv-nhw*hc + DELTA),1)
         ie_e = min(ie_s + nhw*NCOLUMN - 1,neg)
      end if
#endif

#if 1
      if ( nf /= 6 .and. mode == EIGEN_VALUES ) then
         write(nf,*)
         write(nf,*) "kpoint list"
         do ik = 1, kv3, ndim_spinor
            call wd_k_points(ik)
         end do
         write(nf,'(" -----")')
      end if
#endif

      if(mode == EIGEN_VALUES) then
#ifndef _DEBUG_WRITE_
         if(writemode == EFERMI_VICINITY) then
            write(nf,'(" ======  Energy Eigen Values in the vicinity of the Fermi energy level (Range=" &
                 & ,i7," :",i7,") =====")') ie_s, ie_e
         else
#endif
            if(nf==6) write(nf,'(" ======  Energy Eigen Values ======")')
#ifndef _DEBUG_WRITE_
         end if
#endif
      else
#ifndef _DEBUG_WRITE_
         if(writemode == EFERMI_VICINITY) then
            write(nf,'(" ======  Occupations in the vicinity of the Fermi energy level (Range=" &
                 & ,i7," :",i7,") =====")') ie_s, ie_e
         else
#endif
            if(nf==6) write(nf,'(" ======  Occupations ======")')
#ifndef _DEBUG_WRITE_
         end if
#endif
      end if
                                                  __TIMER_IODO_START(1463)
      do ik = 1, kv3_i, ndim_spinor
#ifndef _DEBUG_WRITE_
!!$         if(mode == OCCUPATIONS) e_mpi(:,ik) = e_mpi(:,ik)/(qwgt(ik)*kv3)
!!$         if(mode == OCCUPATIONS) o_mpi(:,ik) = o_mpi(:,ik)/(qwgt(ik)*kv3)
         if(writemode==EFERMI_VICINITY .and. kv3==kv3_i) then
            call wd_k_and_efermi_vicinities(ik,ie_s,ie_e,mode)
         else
#endif
            if(nf /= 6 .and. mode == EIGEN_VALUES) write(nf,'(" ===== energy eigenvalues =====")')
            if(nf /= 6 .and. mode == OCCUPATIONS)  write(nf,'(" ===== occupations =====")')
               call wd_k_points(ik)
            neg_t = neg
            if(neg_is_enlarged) neg_t = neg - num_extra_bands
            if(mode == EIGEN_VALUES) then
               write(nf,'(5f16.8)') (e_mpi(nb,ik),nb = 1, neg_t) ! =eko(neordr(nb,ik),ik)
            else if(mode == OCCUPATIONS) then
               write(nf,'(5f16.8)') (o_mpi(nb,ik)/(qwgt(ik)*kv3/ndim_spinor),nb = 1, neg_t) ! =occup(neordr(nb,ik),ik)
            end if
#ifndef _DEBUG_WRITE_
         end if
#endif
      end do
                                                  __TIMER_IODO_STOP(1463)
    end subroutine wd_k_and_values

    subroutine put_kpartArray_into(a_l,a_all)
      real(kind=DP), intent(in), dimension(np_e,ista_k:iend_k) :: a_l
      real(kind=DP), intent(out), dimension(neg,kv3) :: a_all
      integer :: ik, ierr, ie, is

                                                  __TIMER_IODO_START(1461)
      a_all = 0.d0
      do is = ista_spin, iend_spin
      do ik = is, kv3-nspin+is, nspin
      !do ik = 1, kv3
         if(map_k(ik) /= myrank_k) cycle
         do ie = 1, np_e
            a_all(neg_g(ie),ik) = a_l(ie,ik)
         end do
      end do
      enddo
                                                  __TIMER_IODO_STOP(1461)
      if(npes >= 2) then
                                                  __TIMER_IOCOMM_START_w_BARRIER(mpi_comm,1433)
         call mpi_allreduce(MPI_IN_PLACE,a_all,neg*kv3,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
         call mpi_allreduce(MPI_IN_PLACE,a_all,neg*kv3,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
                                                  __TIMER_IOCOMM_STOP(1462)
      end if
     end subroutine put_kpartArray_into

    subroutine wd_neordr()
      integer :: ik
      write(nf,'(" kv3 = ",i8, " neg = ",i8)') kv3,neg
      do ik= 1,kv3
         write(nf,'(" map_k(",i3,") = ",i8)') ik,map_k(ik)
         if(map_k(ik) /= myrank_k) cycle
         write(nf,'(" neordr ik=",i8)') ik
         write(nf,'(10i8)') neordr(1:neg,ik)
      end do
    end subroutine wd_neordr

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,MPI_CommGroup,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine wd_k_points(ik)
      integer, intent(in) :: ik
      real(kind=DP) :: vkxyz_wk(3)

      if ( sw_band_unfolding == ON ) then
         vkxyz_wk(1:3) = vkxyz_refcell(ik,1:3,BUCS)
      else
         vkxyz_wk(1:3) = vkxyz(ik,1:3,BUCS)
      endif

      if(nspin == 1) then
#ifdef _EIGENVALUES_IN_OLD_FORMAT_
          write(nf,'(i6,3f16.8)') ik+ks, vkxyz_wk(1:3)
#else
          write(nf,'(" ik = ",i8," (",3f10.6," )")') ik+ks, vkxyz_wk(1:3)
#endif
       else
#ifdef _EIGENVALUES_IN_OLD_FORMAT_
          if(mod(ik,2) == 1) then
             write(nf,'(i6,"    UP ",3f16.8)') ik+ks, vkxyz_wk(1:3)
          else
             write(nf,'(i6,"  DOWN ",3f16.8)') ik+ks, vkxyz_wk(1:3)
          end if
#else
          if(mod(ik,2) == 1) then
             write(nf,'(" ik = ",i8," (",3f10.6," )    UP ")') ik+ks, vkxyz_wk(1:3)
          else
             write(nf,'(" ik = ",i8," (",3f10.6," )  DOWN ")') ik+ks, vkxyz_wk(1:3)
          end if
#endif
       end if
     end subroutine wd_k_points

! ============================== added by K. Tagami ==================== 11.0
     subroutine wd_k_points_noncl(ik)
       integer, intent(in) :: ik
       real(kind=DP) :: vkxyz_wk(3)

       if ( sw_band_unfolding == ON ) then
          vkxyz_wk(1:3) = vkxyz_refcell(ik,1:3,BUCS)
       else
          vkxyz_wk(1:3) = vkxyz(ik,1:3,BUCS)
       endif

#ifdef _EIGENVALUES_IN_OLD_FORMAT_
       write(nf,'(i6,3f16.8)') ik+ks, vkxyz_wk(1:3)
#else
       write(nf,'(" ik = ",i5," (",3f10.6," )")') ik+ks, vkxyz_wk(1:3)
#endif
     end subroutine wd_k_points_noncl
! ====================================================================== 11.0

     subroutine cal_vicinity_range(hconst_min, lzero_max)
       integer, intent(out) :: hconst_min, lzero_max
       integer :: hconst,lzero
       integer :: ik, ie, nb

       e_mpi = 0.d0
       do ik = 1, kv3
          if(map_k(ik) /= myrank_k) cycle
          do ie = 1, np_e
             e_mpi(neg_g(ie),ik) = occup_l(ie,ik)
          end do
       end do
       if(npes >= 2) then
          call mpi_allreduce(MPI_IN_PLACE,e_mpi,neg*kv3,mpi_double_precision &
               &                  ,mpi_sum,mpi_kg_world,ierr) ! MPI
! === DEBUG by tkato 2012/12/19 ================================================
          call mpi_allreduce(MPI_IN_PLACE,e_mpi,neg*kv3,mpi_double_precision &
                            ,mpi_sum,mpi_ge_world,ierr)
       end if
       hconst_min = neg
       lzero_max = 0
       do ik = 1, kv3, ndim_spinor
          hconst = neg
          lzero  = 1
          do nb = neg,1,-1
             if(e_mpi(nb,ik)<DELTA) lzero = nb
!!$             if(e_mpi(nb,ik)>=qwgt(ik)*kv3-DELTA ) then
             if(e_mpi(nb,ik)>=qwgt(ik)*kv3/ndim_spinor-DELTA ) then
                hconst = nb
                exit
             end if
          end do
          if(hconst < hconst_min) hconst_min = hconst
          if(lzero_max < lzero)   lzero_max = lzero
       end do
       if(hconst_min > lzero_max) hconst_min = max(lzero_max-1,1)

       if(ipri>=2) write(nf,'(" hconst_min,lzero_max = ",2i8)') hconst_min,lzero_max
     end subroutine cal_vicinity_range

     subroutine wd_k_and_efermi_vicinities(ik,ie_s,ie_e,mode)
       integer, intent(in) :: ik, ie_s,ie_e,mode
       integer :: nb, nbloop, ie, ie1, ie2
       if(hconst_min >= 1) then
!!$          nb = lzero_max-hconst_min+1
          nb = ie_e - ie_s + 1
          nbloop = Int((nb-1)/NCOLUMN+1)
          do ie = 1, nbloop
!!$             ie1 = hconst_min+(ie-1)*NCOLUMN
!!$             ie2 = min(hconst_min+ie*NCOLUMN-1,neg)
             ie1 = max(ie_s+(ie-1)*NCOLUMN,1)
             ie2 = min(ie_s+ie*NCOLUMN-1,neg)
             if(ie == 1) then
                if(mode == EIGEN_VALUES) then
                   write(nf,'(" ik = ",i5," ",8f12.6)') ik, (e_mpi(nb,ik),nb=ie1,ie2)
                else if(mode == OCCUPATIONS) then
                   write(nf,'(" ik = ",i5," ",8f12.6)') ik, &
                        &           (o_mpi(nb,ik)/(qwgt(ik)*kv3/ndim_spinor),nb=ie1,ie2)
                end if
             else
                if(mode == EIGEN_VALUES) then
                   write(nf,'(12x,8f12.6)') (e_mpi(nb,ik),nb=ie1,ie2)
                else if(mode == OCCUPATIONS) then
                   write(nf,'(12x,8f12.6)') &
                        &      (o_mpi(nb,ik)/(qwgt(ik)*kv3/ndim_spinor),nb=ie1,ie2)
                end if
             end if
          end do
       end if
     end subroutine wd_k_and_efermi_vicinities

     subroutine wd_efermi()
       if(nf == 6) write(nf,'(" **** Eigen Values and Occupations ****")')
       write(nf,'(" ** iteration_ionic = ",i8, ", iteration_electronic = ",i8," **")') &
            & iteration_ionic, iteration_electronic
       write(nf,'(" EFermi = ",f16.8)') efermi
       if(sw_fix_total_spin == YES .and. nspin == 2) then
          write(nf,'(" Efermi_spin(1) = ",f16.8, ",  Efermi_spin(2) = ",f16.8)') &
               & efermi_spin(1), efermi_spin(2)
       end if
     end subroutine wd_efermi
  end subroutine m_ESIO_wd_EigenValues

  subroutine m_ESIO_wd_EigenValues_ek(nf,mode)
    integer, intent(in)              :: nf, mode

    real(kind=DP), parameter :: delta = 1.d-12
    real(kind=DP), allocatable, dimension(:) :: eko_t
    integer, allocatable, dimension(:)       :: neordr_t
    integer                     :: ik, ib,jb,ibo,jbo, neg_t

! =========================== added by K. Tagami ================ 11.0
    integer :: ikskip
! =============================================================== 11.0

    allocate(eko_t(neg))
    allocate(neordr_t(neg))
    eko_t = 0; neordr_t = 0

    if(mode == SCF .and. printable) write(nf,'(" ======  Energy Eigen Values ======")')
!!$    do ik = 1, kv3_ek
!!$    do ik = 1, nk_in_the_process

    if(printable) then
! ========================= modified by K. Tagami ============ 11.0
!       write(nf,'(" nk_converged = ",i8)') min(kv3_ek,nk_converged)
!       do ik = 1, kv3_ek
!          call wd_k_points
!       end do
       if ( noncol ) then
          write(nf,'(" nk_converged = ",i8)') min(kv3_ek,nk_converged) /ndim_spinor
          do ik = 1, kv3_ek, ndim_spinor
             call wd_k_points_noncl
          end do
       else
          write(nf,'(" nk_converged = ",i8)') min(kv3_ek,nk_converged)
          do ik = 1, kv3_ek
             call wd_k_points
          end do
       endif
! ============================================================= 11.0

       write(nf,'(" -----")')
    end if

! ====================== added by K. Tagami =================== 11.0
    if ( noncol ) then
       ikskip = ndim_spinor
    else
       ikskip = 1
    endif
! ============================================================ 11.0

! ============================ modified by K. Tagami ============ 11.0
!    do ik = 1, nk_converged
    do ik = 1, nk_converged, ikskip
! =============================================================== 11.0

!       if(sw_ekzaj == OFF .and. ik <= first_kpoint_in_this_job) cycle
       if(ik > kv3_ek) cycle
       if(mode == EK .and. printable) write(nf,'("=== energy eigenvalues ===")')
       eko_t = eko_ek(:,ik)
       if(nspin == 1 .or. (nspin == 2 .and. mod(ik,2) == 1)) &
            & neordr_t(1:neg) = (/(ib,ib=1,neg)/)
       do ib = 1, neg-1
          do jb = ib+1, neg
             ibo = neordr_t(ib)
             jbo = neordr_t(jb)
             if(eko_t(jbo)  < eko_t(ibo)-delta) then        ! MPI
                neordr_t(jb) = ibo
                neordr_t(ib) = jbo
             end if
          end do
       end do
       if(printable) then
! ================================ modified by K. Tagami ========== 11.0
!          call wd_k_points
          if ( noncol ) then
             call wd_k_points_noncl
          else
             call wd_k_points
          endif
! ================================================================= 11.0
          neg_t = neg

          if(neg_is_enlarged) neg_t = neg - num_extra_bands
          if(mode == SCF) then
             write(nf,'(5f16.8)') (eko_t(neordr_t(ib)),ib=1,neg_t)
          else
             write(nf,'(4f18.10)') (eko_t(neordr_t(ib)),ib=1,neg_t)
          end if
       end if
    end do

    deallocate(neordr_t);     deallocate(eko_t)

  contains

    subroutine wd_k_points
      integer :: j, k
      real(kind=DP) :: c1, vkxyz_wk(3)

      if ( sw_band_unfolding == ON ) then
         vkxyz_wk(1:3) = vkxyz_refcell(ik,1:3,BUCS)
      else
         vkxyz_wk(1:3) = vkxyz_ek(ik,1:3,BUCS)
      endif

      if(mode == SCF) then
         if(nspin == 1) then
            write(nf,'(i6,3f18.10)') ik, vkxyz_wk(1:3)
         else
            if(mod(ik,2) == 1) then
               write(nf,'(i6,"    UP ",3f18.10)') ik, vkxyz_wk(1:3)
            else
               write(nf,'(i6,"  DOWN ",3f18.10)') ik, vkxyz_wk(1:3)
            end if
         end if
      else
         if(nspin == 1) then
            write(nf,'(" ik = ",i8," (",3f10.6," )")') ik, vkxyz_wk(1:3)
         else
            if(mod(ik,2) == 1) then
               write(nf,'(" ik = ",i8," (",3f10.6," )    UP ")') ik, vkxyz_wk(1:3)
            else
               write(nf,'(" ik = ",i8," (",3f10.6," )  DOWN ")') ik, vkxyz_wk(1:3)
            end if
         end if
      end if

    end subroutine wd_k_points

! ============================== added by K. Tagami ==================== 11.0
    subroutine wd_k_points_noncl
      integer :: j, k
      real(kind=DP) :: c1, vkxyz_wk(3)

      if ( sw_band_unfolding == ON ) then
         vkxyz_wk(1:3) = vkxyz_refcell(ik,1:3,BUCS)
      else
         vkxyz_wk(1:3) = vkxyz_ek(ik,1:3,BUCS)
      endif

      if (mode == SCF) then
         write(nf,'(i6,3f18.10)') ik, vkxyz_wk(1:3)
      else
         write(nf,'(" ik = ",i8," (",3f10.6," )")') ik, vkxyz_wk(1:3)
      endif
    end subroutine wd_k_points_noncl
! ====================================================================== 11.0

  end subroutine m_ESIO_wd_EigenValues_ek

! ======================================= modified by K. Tagami ========== 11.0
!  subroutine m_ESIO_wd_vlhxc(nfvlc)
!
  subroutine m_ESIO_wd_vlhxc( nfvlc, ismax )
    use m_Parallelization, only : mpi_ke_world, mpi_chg_world
    integer, intent(in)              :: ismax
! ======================================================================= 11.0

    integer, intent(in)              :: nfvlc
    integer                          :: is, ik, i
    real(DP),allocatable, dimension(:,:,:):: vlhxc_mpi,vlhxc_mpi2

    if(npes >= 2) then

! ========================== modiifed by K. Tagami ============= 11.0
!       allocate(vlhxc_mpi(kgp,kimg,nspin)); vlhxc_mpi = 0.d0  ! MPI
!       allocate(vlhxc_mpi2(kgp,kimg,nspin))

       allocate(vlhxc_mpi(kgp,kimg,ismax));
       allocate(vlhxc_mpi2(kgp,kimg,ismax))
! ============================================================= 11.0
       vlhxc_mpi = 0.0d0;       vlhxc_mpi2 = 0.0d0

! ========================== modiifed by K. Tagami ============= 11.0
!       do is = 1, nspin
       do is = 1, ismax
! ============================================================== 11.0
          do ik = 1, kimg
             do i = ista_kngp, iend_kngp
                vlhxc_mpi(i,ik,is) = vlhxc_l(i,ik,is)
             end do
          end do
       end do

! ========================== modiifed by K. Tagami ====================== 11.0
!       call mpi_allreduce(vlhxc_mpi,vlhxc_mpi2,kgp*kimg*nspin &
!            &     , mpi_double_precision, mpi_sum, MPI_CommGroup,ierr)
       call mpi_allreduce( vlhxc_mpi, vlhxc_mpi2, kgp*kimg*ismax, &
            &              mpi_double_precision, mpi_sum, mpi_chg_world, ierr )
! ====================================================================== 11.0

       if (mype == 0) write(nfvlc) vlhxc_mpi2

       deallocate(vlhxc_mpi); deallocate(vlhxc_mpi2)
    else
       write(nfvlc) vlhxc_l
    end if
  end subroutine m_ESIO_wd_vlhxc

  subroutine m_ESIO_rd_WFs(nfout,nfzaj, F_ZAJ_partitioned, prev_zaj)
   use m_Parallelization,     only : mpi_ke_world, mpi_kg_world
    integer, intent(in) :: nfout, nfzaj
    logical, intent(in) :: F_ZAJ_partitioned
    logical, intent(in), optional :: prev_zaj
    logical    :: pzaj
    integer    :: ik,ib,ri, i
    integer    :: j
    integer    :: id_sname = -1
    integer    :: ierror
    integer    :: kg1t
    integer    :: ispin
    integer, allocatable, dimension(:) :: npg1kt,istag1kt,iendg1kt
                                                  __TIMER_SUB_START(1372)
    call tstatc0_begin('m_ESIO_rd_WFs ',id_sname)
    pzaj = .false.
    if(present(prev_zaj)) pzaj = prev_zaj

    kg1t = kg1
    allocate(npg1kt(kv3))
    allocate(istag1kt(kv3))
    allocate(iendg1kt(kv3))
    npg1kt = np_g1k
    istag1kt = ista_g1k
    iendg1kt = iend_g1k
    if(pzaj) then
      kg1t = kg1_prev
      npg1kt = np_g1k_prev
      istag1kt = ista_g1k_prev
      iendg1kt = iend_g1k_prev
    endif
    if(precision_WFfile==SP) then
       if(ipri >= 1) write(nfout,*) ' !D Reading zaj (single_precision)'
    else
       if(ipri >= 1) write(nfout,*) ' !D Reading zaj (double_precision)'
    end if
    rewind nfzaj
    if(F_ZAJ_partitioned) then
       if(precision_WFfile==SP) then
          allocate(wf_l(maxval(npg1kt),kimg)); wf_l = 0.d0
       else
          allocate(wfdp_l(maxval(npg1kt),kimg)); wfdp_l = 0.d0
       end if
       do ik = ista_k, iend_k, af+1        ! MPI
                                                  __TIMER_IODO_START(1435)
          do ib = 1, np_e  ! MPI
             if(ista_e+ib-1 > neg_previous) cycle
                                                  __TIMER_IODO_START(1436)
           if(precision_WFfile==SP) then
             read(nfzaj) wf_l
                                                  __TIMER_IODO_STOP(1436)
             if(kimg == 1) then
                if(pzaj)then
                  do i = 1, npg1kt(ik)
                     zaj_l_prev(i,ib,ik,1) = wf_l(i,1)
                  end do
                else
                  do i = 1, npg1kt(ik)
                     zaj_l(i,ib,ik,1) = wf_l(i,1)
                  end do
                endif
             else if(kimg==2) then
                if(pzaj)then
                  do i = 1, npg1kt(ik)
                     zaj_l_prev(i,ib,ik,1) = wf_l(i,1)
                     zaj_l_prev(i,ib,ik,2) = wf_l(i,2)
                  end do
                else
                  do i = 1, npg1kt(ik)
                     zaj_l(i,ib,ik,1) = wf_l(i,1)
                     zaj_l(i,ib,ik,2) = wf_l(i,2)
                  end do
                endif
             end if
           else if(precision_WFfile==DP) then
             read(nfzaj) wfdp_l
                                                  __TIMER_IODO_STOP(1436)
             if(kimg == 1) then
                if(pzaj) then
                  do i = 1, npg1kt(ik)
                     zaj_l_prev(i,ib,ik,1) = wfdp_l(i,1)
                  end do
                else
                  do i = 1, npg1kt(ik)
                     zaj_l(i,ib,ik,1) = wfdp_l(i,1)
                  end do
                endif
             else if(kimg==2) then
                if(pzaj)then
                  do i = 1, npg1kt(ik)
                     zaj_l_prev(i,ib,ik,1) = wfdp_l(i,1)
                     zaj_l_prev(i,ib,ik,2) = wfdp_l(i,2)
                  end do
                else
                  do i = 1, npg1kt(ik)
                     zaj_l(i,ib,ik,1) = wfdp_l(i,1)
                     zaj_l(i,ib,ik,2) = wfdp_l(i,2)
                  end do
                endif
             end if

           end if
          end do
                                                  __TIMER_IODO_STOP(1435)
       end do
       if(precision_WFfile==SP) then
          deallocate(wf_l)
       else if(precision_WFfile==DP) then
          deallocate(wfdp_l)
       end if
    else
#ifdef _DEBUG_ESIO_
       if(mype == 0) write(nfout,'("### zaj reading")')
#endif
       if(precision_WFfile==SP) then
          allocate(wf_l(kg1t,kimg));  wf_l = 0
       else
          allocate(wfdp_l(kg1t,kimg));  wfdp_l = 0
       end if
       do ispin = 1, nspin, af+1
       !do ik = 1, kv3, af+1
       do ik = ispin, kv3-nspin+ispin, nspin
                                                  __TIMER_IODO_START(1437)
          do ib = 1, neg_previous
                                                  __TIMER_IODO_START(1438)
! -----------------
           if(precision_WFfile==SP) then
             if(mype == 0) read(nfzaj, end = 9999, err = 9999) wf_l  ! MPI
#ifdef _DEBUG_ESIO_
             if(mype == 0) then
                write(nfout,'(" ik = ",i3, " ib = ",i4)')  ik, ib
                write(nfout,'(8f8.4)') (wf_l(ri,1),ri=1,8)
             end if
#endif
                                                  __TIMER_IODO_STOP(1438)
                                                  __TIMER_IOCOMM_START_w_BARRIER(mpi_comm,1439)
             call mpi_bcast(wf_l,kg1t*kimg,mpi_real4,0,MPI_CommGroup,ierr)
                                                  __TIMER_IOCOMM_STOP(1439)
             if((map_k(ik) == myrank_k) .and. (map_e(ib) == myrank_e) .and. (map_s(ispin) == myrank_spin))then         ! MPI
                if(pzaj) then
                  do ri = 1, kimg
                    do j = istag1kt(ik),iendg1kt(ik)
                       zaj_l_prev(j-istag1kt(ik)+1,map_z(ib),ik,ri) = wf_l(j,ri)  ! MPI
                    end do
                  end do
                else
                  do ri = 1, kimg
                    do j = istag1kt(ik),iendg1kt(ik)
                       zaj_l(j-istag1kt(ik)+1,map_z(ib),ik,ri) = wf_l(j,ri)  ! MPI
                    end do
                  end do
                endif
             end if

! -----------------
           else if(precision_WFfile==DP) then
             if(mype == 0) read(nfzaj, end = 9999, err = 9999) wfdp_l  ! MPI
#ifdef _DEBUG_ESIO_
             if(mype == 0) then
                write(nfout,'(" ik = ",i3, " ib = ",i4)')  ik, ib
                write(nfout,'(8f8.4)') (wfdp_l(ri,1),ri=1,8)
             end if
             call flush(nfout)
#endif
                                                  __TIMER_IODO_STOP(1438)
                                                  __TIMER_IOCOMM_START_w_BARRIER(mpi_comm,1439)
             call mpi_bcast(wfdp_l,kg1t*kimg,mpi_double_precision,0,MPI_CommGroup,ierr)
                                                  __TIMER_IOCOMM_STOP(1439)
             if((map_k(ik) == myrank_k) .and. (map_e(ib) == myrank_e) .and. (map_s(ispin) == myrank_spin))then         ! MPI
                if(pzaj)then
                  do ri = 1, kimg
                    do j = istag1kt(ik),iendg1kt(ik)
                       zaj_l_prev(j-istag1kt(ik)+1,map_z(ib),ik,ri) = wfdp_l(j,ri)  ! MPI
                    end do
                  end do
                else
                  do ri = 1, kimg
                    do j = istag1kt(ik),iendg1kt(ik)
                       zaj_l(j-istag1kt(ik)+1,map_z(ib),ik,ri) = wfdp_l(j,ri)  ! MPI
                    end do
                  end do
                endif
             end if

           endif
! -----------------
          end do
                                                  __TIMER_IODO_STOP(1437)
       end do
       end do
       if(precision_WFfile==SP) then
          deallocate(wf_l)
       else if(precision_WFfile==DP) then
          deallocate(wfdp_l)
       end if
    end if

    deallocate(npg1kt)
    deallocate(istag1kt)
    deallocate(iendg1kt)
    call tstatc0_end(id_sname)
    return
9999 continue
    ierror = EOF_REACHED
    call phase_error_wo_filename(ierror, nfout, nfzaj, __LINE__, __FILE__)
                                                  __TIMER_SUB_STOP(1372)
  end subroutine m_ESIO_rd_WFs

! ==== TY 2019/06/25 revised the same subroutine in the 2D version m_ES_IO.f90
! ==== EXP_CELLOPT ==== 2015/09/24
  subroutine m_ESIO_import_WFs_prev_cell(nfout,nfzaj, F_ZAJ_partitioned)
    integer, intent(in) :: nfout, nfzaj
    logical, intent(in) :: F_ZAJ_partitioned
    integer    :: ik,ib,ri, i, j
    integer    :: id_sname = -1
    integer    :: ierror

    call tstatc0_begin('m_ESIO_import_WFs_prev_cell ',id_sname)

    if(precision_WFfile==SP) then
       if(ipri >= 1) write(nfout,*) ' !D Reading zaj (single_precision) in m_ESIO_import_WFs_prev_cell'
    else
       if(ipri >= 1) write(nfout,*) ' !D Reading zaj (double_precision) in m_ESIO_import_WFs_prev_cell'
    end if
    rewind nfzaj
    if(F_ZAJ_partitioned) then
       if(precision_WFfile==SP) then
          allocate(wf_l(maxval(np_g1k_prev),kimg)); wf_l = 0.d0
       else
          allocate(wfdp_l(maxval(np_g1k_prev),kimg)); wfdp_l = 0.d0
       end if
!!$
!!$    zaj_l = 0.0d0
       do ik = ista_k, iend_k, af+1        ! MPI
          do ib = 1, np_e
!!$          do ib = ista_e, iend_e, istep_e  ! MPI
             if(ista_e+ib-1 >neg_previous) cycle
!!$             if(ib > neg_previous) cycle
             if(precision_WFfile==SP) then
                read(nfzaj) wf_l

                if(kimg == 1) then
                   do i = 1, min(np_g1k(ik),np_g1k_prev(ik))
                      zaj_l(i,ib,ik,1) = wf_l(i,1)
                   end do
                else if(kimg==2) then
                   do i = 1, min(np_g1k(ik),np_g1k_prev(ik))
                      zaj_l(i,ib,ik,1) = wf_l(i,1)
                      zaj_l(i,ib,ik,2) = wf_l(i,2)
                   end do
                end if
             else if(precision_WFfile==DP) then
                read(nfzaj) wfdp_l

                if(kimg == 1) then
                   do i = 1, min(np_g1k(ik),np_g1k_prev(ik))
                      zaj_l(i,ib,ik,1) = wfdp_l(i,1)
                   end do
                else if(kimg==2) then
                   do i = 1, min(np_g1k(ik),np_g1k_prev(ik))
                      zaj_l(i,ib,ik,1) = wfdp_l(i,1)
                      zaj_l(i,ib,ik,2) = wfdp_l(i,2)
                   end do
                end if

             end if
          end do

       end do
       if(precision_WFfile==SP) then
          deallocate(wf_l)
       else if(precision_WFfile==DP) then
          deallocate(wfdp_l)
       end if
    else
       zaj_l = 0.d0
       if(precision_WFfile==SP) then
          allocate(wf_l(kg1_prev,kimg));  wf_l = 0
       else
          allocate(wfdp_l(kg1_prev,kimg));  wfdp_l = 0
       end if
       do ik = 1, kv3, af+1
          do ib = 1, neg_previous
! -----------------
           if(precision_WFfile==SP) then
             if(mype == 0) read(nfzaj, end = 9999, err = 9999) wf_l  ! MPI
             call mpi_bcast(wf_l,kg1_prev*kimg,mpi_real4,0,MPI_CommGroup,ierr)

             if((map_k(ik) == myrank_k) .and. (map_e(ib) == myrank_e) )then         ! MPI
                do ri = 1, kimg
                  do j = min(ista_g1k(ik),kg1_prev),min(iend_g1k(ik),kg1_prev)
                     zaj_l(j-ista_g1k(ik)+1,map_z(ib),ik,ri) = wf_l(j,ri)  ! MPI
                  end do
                end do
             end if
! -----------------
           else if(precision_WFfile==DP) then
             if(mype == 0) read(nfzaj, end = 9999, err = 9999) wfdp_l  ! MPI
             call mpi_bcast(wfdp_l,kg1_prev*kimg,mpi_double_precision,0,MPI_CommGroup,ierr)
             if((map_k(ik) == myrank_k) .and. (map_e(ib) == myrank_e) )then         ! MPI
                do ri = 1, kimg
                  do j = min(ista_g1k(ik),kg1_prev),min(iend_g1k(ik),kg1_prev)
                     zaj_l(j-ista_g1k(ik)+1,map_z(ib),ik,ri) = wfdp_l(j,ri)  ! MPI
                  end do
                end do
             end if
           endif
! -----------------
          end do
       end do
       if(precision_WFfile==SP) then
          deallocate(wf_l)
       else if(precision_WFfile==DP) then
          deallocate(wfdp_l)
       end if
    end if
    return
9999 continue
    ierror = EOF_REACHED
    call phase_error_wo_filename(ierror, nfout, nfzaj, __LINE__, __FILE__)
  end subroutine m_ESIO_import_WFs_prev_cell
! ===================== 2015/09/24
! ==== TY 2019/06/25


  subroutine m_ESIO_wd_WFs_standardout(nfout,ipriwf)
    integer, intent(in) :: nfout,ipriwf
    integer :: ik,ib,ri, i, ic, ipriwf0, icycle, icolumn, max_elements, istart, iend
    integer :: id_sname = -1
    real(kind=DP) :: phase2r, phase2i, phaser,phasei
    real(kind=SP), allocatable, dimension(:,:)  :: wf_mpi   ! work wave functions
    real(kind=DP), allocatable, dimension(:,:)  :: wfdp_mpi
    complex(kind=CMPLDP) :: exp2theta, exptheta
                                                  __TIMER_SUB_START(1379)
    call tstatc0_begin('m_ESIO_wd_WFs_stndout ',id_sname)

    ipriwf0 = ipriwf
    if(npes > 1) call mpi_bcast(ipriwf0,1,mpi_integer,0,MPI_CommGroup,ierr)

    if(ipriwf0 >= 2) then
       icolumn = 10
       if(precision_WFfile==SP) then
          allocate(wf_l(kg1,kimg+3)); wf_l = 0.d0
          allocate(wf_mpi(kg1,kimg+3))
       else
          allocate(wfdp_l(kg1,kimg+3)); wfdp_l = 0.d0
          allocate(wfdp_mpi(kg1,kimg+3))
       end if
       call mpi_barrier(MPI_CommGroup,ierr)
       if(mype == 0)  write(nfout,*) ' !wf Writing zaj '

       do ik = 1, kv3, af+1
          max_elements = iba(ik)
          if(mype == 0) write(nfout,'(" !wf   ik = ",i5)') ik
          do ib = 1, neg
             if(mype == 0) write(nfout,'(" !wf   ib = ",i5)') ib
           if(precision_WFfile==SP) then
             wf_mpi = 0.0d0
             if((map_k(ik) == myrank_k) .and. (map_e(ib) == myrank_e) )then         ! MPI
                                                  __TIMER_IODO_START(1467)
                do ri = 1, kimg
                  do i = ista_g1k(ik),iend_g1k(ik)
                     wf_mpi(i,ri) = zaj_l(i-ista_g1k(ik)+1,map_z(ib),ik,ri)
                  end do
                end do
                                                  __TIMER_IODO_STOP(1467)
             endif
                                                  __TIMER_IOCOMM_START_w_BARRIER(MPI_CommGroup,1468)
             call mpi_allreduce(wf_mpi,wf_l,kg1*kimg,mpi_real4,mpi_sum,MPI_CommGroup,ierr)
                                                  __TIMER_IOCOMM_STOP(1468)
                                                  __TIMER_IODO_START(1469)
           else
             wfdp_mpi = 0.0d0
             if((map_k(ik) == myrank_k) .and. (map_e(ib) == myrank_e) )then         ! MPI
                                                  __TIMER_IODO_START(1467)
                do ri = 1, kimg
                  do i = ista_g1k(ik),iend_g1k(ik)
                     wfdp_mpi(i,ri) = zaj_l(i-ista_g1k(ik)+1,map_z(ib),ik,ri)
                  end do
                end do
                                                  __TIMER_IODO_STOP(1467)
             endif
                                                  __TIMER_IOCOMM_START_w_BARRIER(MPI_CommGroup,1468)
             call mpi_allreduce(wfdp_mpi,wf_l,kg1*kimg,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
                                                  __TIMER_IOCOMM_STOP(1468)
                                                  __TIMER_IODO_START(1469)
           end if
             if(mype == 0) then
                if(kimg == 2) then
                 if(precision_WFFile==SP) then
                   do i = 1, iba(ik)
                      wf_l(i,3) = wf_l(i,1)**2 + wf_l(i,2)**2
                   end do
                 else
                   do i = 1, iba(ik)
                      wfdp_l(i,3) = wfdp_l(i,1)**2 + wfdp_l(i,2)**2
                   end do
                 end if
                   if(k_symmetry(ik) == GAMMA .or. k_symmetry(ik) == GAMMA_base_symmetrization) then
                    if(precision_WFfile==SP) then
                      phase2r = (wf_l(1,1)**2 - wf_l(1,2)**2)/wf_l(1,3)
                      phase2i = -2.d0*wf_l(1,1)*wf_l(1,2)/wf_l(1,3)
                    else
                      phase2r = (wfdp_l(1,1)**2 - wfdp_l(1,2)**2)/wfdp_l(1,3)
                      phase2i = -2.d0*wfdp_l(1,1)*wfdp_l(1,2)/wfdp_l(1,3)
                    end if
                      exp2theta = cmplx(phase2r, phase2i)
                      exptheta = sqrt(exp2theta)
                      phaser = real(exptheta)
                      phasei = imag(exptheta)
                      write(nfout,'(" !wf exp2theta = ",2d20.8)') exp2theta
                      write(nfout,'(" !wf           = ",2d20.8)') phase2r, phase2i
                      write(nfout,'(" !wf |exp2theta|**2 = ",d20.8)') dsqrt(phase2r**2 + phase2i**2)
                      write(nfout,'(" !wf exptheta  = ",2d20.8)') exptheta
                      write(nfout,'(" !wf |exptheta| = ",d20.8)') abs(exptheta)
                     if(precision_WFfile==SP) then
                      do i = 1, iba(ik)
!!$                      wf_l(i,4) = real(exptheta*cmplx(wf_l(i,1),wf_l(i,2)))
!!$                      wf_l(i,5) = imag(exptheta*cmplx(wf_l(i,1),wf_l(i,2)))
                         wf_l(i,4) = phaser*wf_l(i,1) - phasei*wf_l(i,2)
                         wf_l(i,5) = phaser*wf_l(i,2) + phasei*wf_l(i,1)
                      end do
                     else
                      do i = 1, iba(ik)
                         wfdp_l(i,4) = phaser*wfdp_l(i,1) - phasei*wfdp_l(i,2)
                         wfdp_l(i,5) = phaser*wfdp_l(i,2) + phasei*wfdp_l(i,1)
                      end do
                     end if
                   end if
                else
                 if(precision_WFfile==SP) then
                   do i = 1, iba(ik)
                      wf_l(i,2) = wf_l(i,1)**2
                   end do
                 else
                   do i = 1, iba(ik)
                      wfdp_l(i,2) = wfdp_l(i,1)**2
                   end do
                 end if
                   exp2theta = 1.d0
                   exptheta = 1.d0
                end if
                icycle = ceiling(dble(min(max_elements,iba(ik)))/icolumn)
                istart = 1
                do ic = 1, icycle
                   iend = min(istart+icolumn-1,max_elements,iba(ik))
                   write(nfout,'(" !wf (nx)    ",10i10)') (ngabc(nbase(i,ik),1),i=istart,iend)
                   write(nfout,'(" !wf (ny)    ",10i10)') (ngabc(nbase(i,ik),2),i=istart,iend)
                   write(nfout,'(" !wf (nz)    ",10i10)') (ngabc(nbase(i,ik),3),i=istart,iend)
                 if(precision_WFfile==SP) then
                   write(nfout,'(" !wf (zaj-r) ",10d10.2)') (wf_l(i,1),i=istart,iend)
                   if(kimg == 2) write(nfout,'(" !wf (zaj-i) ",10d10.2)') (wf_l(i,2),i=istart,iend)
                   write(nfout,'(" !wf abs     ",10d10.2)') (wf_l(i,kimg+1),i=istart,iend)
                   if(kimg == 2) then
                      if(k_symmetry(ik) == GAMMA .or. k_symmetry(ik) == GAMMA_base_symmetrization) then
                         write(nfout,'(" !wf (zaj-r)d",10d10.2)') (wf_l(i,4),i=istart,iend)
                         write(nfout,'(" !wf (zaj-i)d",10d10.2)') (wf_l(i,5),i=istart,iend)
                      end if
                   end if
                 else
                   write(nfout,'(" !wf (zaj-r) ",10d10.2)') (wfdp_l(i,1),i=istart,iend)
                   if(kimg == 2) write(nfout,'(" !wf (zaj-i) ",10d10.2)') (wfdp_l(i,2),i=istart,iend)
                   write(nfout,'(" !wf abs     ",10d10.2)') (wfdp_l(i,kimg+1),i=istart,iend)
                   if(kimg == 2) then
                      if(k_symmetry(ik) == GAMMA .or. k_symmetry(ik) == GAMMA_base_symmetrization) then
                         write(nfout,'(" !wf (zaj-r)d",10d10.2)') (wfdp_l(i,4),i=istart,iend)
                         write(nfout,'(" !wf (zaj-i)d",10d10.2)') (wfdp_l(i,5),i=istart,iend)
                      end if
                   end if
                 end if
                   istart = iend+1
                end do
             end if
                                                  __TIMER_IODO_STOP(1469)
          end do
       end do
      if(precision_WFfile==SP) then
       deallocate(wf_l)
      else
       deallocate(wfdp_l)
      end if
    end if
    call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(1379)
  end subroutine m_ESIO_wd_WFs_standardout

  subroutine m_ESIO_rd_next_wfs_ek(ik,nfout,nfzaj)
    integer, intent(in) :: ik
    integer, intent(in) :: nfout,nfzaj
    integer :: ib, ri, j, ierror
    if(precision_WFfile==SP) then
       allocate(wf_l(kg1,kimg)); wf_l = 0_sp
    else
       allocate(wfdp_l(kg1,kimg)); wfdp_l = 0.d0
    end if
!    zaj_l(:,:,ik,:) = 0.d0
    do ib = 1, neg
! -----------------
       if(precision_WFfile==SP) then
          if(mype == 0) read(nfzaj, end = 9999, err = 9999) wf_l  ! MPI
          call mpi_bcast(wf_l,kg1*kimg,mpi_real4,0,MPI_CommGroup,ierr)
          if((map_k(ik) == myrank_k) .and. (map_e(ib) == myrank_e) )then         ! MPI
            do ri = 1, kimg
               do j = ista_g1k(ik),iend_g1k(ik)
                  zaj_l(j-ista_g1k(ik)+1,map_z(ib),ik,ri) = wf_l(j,ri)  ! MPI
               end do
            end do
          end if

! -----------------
       else if(precision_WFfile==DP) then
          if(mype == 0) read(nfzaj, end = 9999, err = 9999) wfdp_l  ! MPI
          call mpi_bcast(wfdp_l,kg1*kimg,mpi_double_precision,0,MPI_CommGroup,ierr)
          if((map_k(ik) == myrank_k) .and. (map_e(ib) == myrank_e) )then         ! MPI
             do ri = 1, kimg
               do j = ista_g1k(ik),iend_g1k(ik)
                  zaj_l(j-ista_g1k(ik)+1,map_z(ib),ik,ri) = wfdp_l(j,ri)  ! MPI
               end do
             end do
          end if
       endif
    end do

    if(precision_WFfile==SP) then
       deallocate(wf_l)
    else
       deallocate(wfdp_l)
    end if

    return

9999 continue
    ierror = EOF_REACHED
    call phase_error_wo_filename(ierror, nfout, nfzaj, __LINE__, __FILE__)
  end subroutine m_ESIO_rd_next_wfs_ek

  subroutine m_ESIO_rd_WFs_and_EVs_ek(nfout,nf)
    integer, intent(in) :: nfout,nf
    integer  :: ik, ie, iks, ri, ikg, ikt, ike, ike2, ib, j, ig
    integer, allocatable, dimension(:,:) :: n_mpi, n2_mpi  ! MPI
    real(DP),allocatable, dimension(:,:) :: e_mpi, e2_mpi  ! MPI
    real(SP),allocatable, dimension(:,:) :: wf_buf
!!$    read(nf) neordr,nrvf_ordr,eko_l,occup_l,efermi,totch

    allocate(n_mpi(neg,nspin)); allocate(n2_mpi(neg,nspin)) ! MPI
    allocate(e_mpi(neg,nspin)); allocate(e2_mpi(neg,nspin)) ! MPI
    allocate(wf_l(kg1,kimg))
    allocate(wf_buf(kg1,kimg))

    n_mpi =0; n2_mpi = 0
    e_mpi =0; e2_mpi = 0; wf_l = 0
    if(ipri >= 1) write(nfout,*) ' !D Reading zaj'
    rewind nf

    eko_ek = 0.d0
!!$    do ik = 1, nk_in_the_process-kv3, kv3
    do ik = 1, nk_in_the_process - nspin, nspin
       if(ipri >= 1) write(nfout,*) ' !D     skipping ik = ', ik
!!$       do iks = 1, kv3, af+1
       do iks = 1, nspin, af+1
          do ie = 1, neg
             if(mype == 0) read(nf) wf_l
          end do
       end do
       if(mype == 0) read(nf) n_mpi
       if(mype == 0) read(nf) n2_mpi
       if(mype == 0) read(nf) e_mpi

       if(mype == 0) then
!!$          do iks = 1, kv3
          do iks = 1, nspin
             do ie = 1, neg
                eko_ek(ie,ik+iks-1) = e_mpi(n_mpi(ie,iks),iks)
             end do
          end do
          if(ipri >= 3) then
!!$             do iks=1,kv3
             do iks=1,nspin
                write(nfout,'(" ik = ",i5)') ik+iks-1
                write(nfout,'(8f8.4)') (e_mpi(n_mpi(ie,iks),iks),ie=1,neg)
             end do
          end if
       end if
    end do

    if(nk_in_the_process > kv3_ek) goto 1001

!    deallocate(wf_l)
!    allocate(wf_l(maxval(np_g1k),kimg)); wf_l = 0.d0
!!$    do ik = 1, kv3, af+1
    KPOINT_LOOP: do ikg = 1, nrank_k
       do ikt = 1, nspin, af+1
          ik = (ikg-1)*nspin+ikt
          if(nk_in_the_process -1 + ik > kv3_ek) exit KPOINT_LOOP
          if(nk_in_the_process -1 + ik > numk_zajsaved) exit KPOINT_LOOP
          if(ipri>=1) write(nfout,*) ' !D     reading  ik = ', ik+first_kpoint_in_this_job-1
          do ib = 1, neg
             if(mype == 0) read(nf,err=2,end=2) wf_l     ! MPI
#ifdef _DEBUG_ESIO_
             if(mype == 0) then
                write(nfout,'(" ik = ",i3, " ib = ",i4)')  ik, ib
                write(nfout,'(8f8.4)') (wf_l(ri,1),ri=1,8)
             end if
#endif
             call mpi_bcast(wf_l,kg1*kimg,mpi_real4,0,MPI_CommGroup,ierr)
                                                  __TIMER_IOCOMM_STOP(1439)
             if((map_k(ik) == myrank_k) .and. (map_e(ib) == myrank_e) )then         ! MPI
                do ri = 1, kimg
                  do j = ista_g1k(ik),iend_g1k(ik)
                     zaj_l(j-ista_g1k(ik)+1,map_z(ib),ik,ri) = wf_l(j,ri)  ! MPI
                  end do
                end do
             end if
          end do

       end do

       if(mype == 0) read(nf) n_mpi                ! MPI
       if(mype == 0) read(nf) n2_mpi               ! MPI
       call mpi_bcast(n_mpi,neg*nspin,mpi_integer,0,MPI_CommGroup,ierr) ! MPI
       call mpi_bcast(n2_mpi,neg*nspin,mpi_integer,0,MPI_CommGroup,ierr)! MPI

       do ikt = 1, nspin                             ! MPI
          ik = (ikg-1)*nspin + ikt
          if(map_k(ik) == myrank_k) then
             neordr(1:neg,ik) = n_mpi(1:neg,ikt)     ! MPI
             nrvf_ordr(1:neg,ik) = n2_mpi(1:neg,ikt) ! MPI
          end if
       end do                                        ! MPI

       if(mype == 0) read(nf) e_mpi                ! MPI
       call mpi_bcast(e_mpi,neg*nspin,mpi_double_precision,0,MPI_CommGroup,ierr) ! MPI

       do ikt = 1, nspin                                   ! MPI
          ik = (ikg-1)*nspin + ikt
          do ie = 1, neg                                   ! MPI
             !if(map_ek(ie,ik) == mype) then                ! MPI
             if((map_k(ik) == myrank_k) .and. (map_e(ie) == myrank_e) )then         ! MPI
                eko_l(map_z(ie),ik) = e_mpi(ie,ikt)        ! MPI
             end if                                        ! MPI
          end do                                           ! MPI
          do ie = 1, neg
             eko_ek(ie,nk_in_the_process+ik-1) = e_mpi(n_mpi(ie,ikt),ikt)
          end do
       end do                                              ! MPI
       goto 3
2      continue
       call phase_error_with_msg(nfout,' eof from nf <<m_ESIO_rd_WFs_and_EVs_ek>>',__LINE__,__FILE__)
3      continue
    end do KPOINT_LOOP

    if(ipri>=2) write(nfout,*) ' !D     ikg  = ', ikg
!!$    if(ikg <= 1) stop ' ikg <= 1 <<m_ESIO_rd_WFs_and_EVs_ek>>'
    if(ikg < nrank_k .and. ikg > 1 ) then
       do ike = ikg, nrank_k
          if(ipri>=2) write(nfout,*) ' !D     ike  = ', ike
          if(ipri>=2) write(nfout,*) ' !D     zaj_l'
          do ikt = 1, nspin, af+1
             ik   = (ikg-2)*nspin+ikt
             ike2 = (ike-1)*nspin+ikt
             !wf_l = 0.0
             !do ie = 1, neg
             !   if((map_k(ik) == myrank_k) .and. (map_e(ie) == myrank_e) )then         ! MPI
             !      do ri = 1, kimg
             !         do ig = ista_g1k(ik), iend_g1k(ik)
!            !           do ig = 1, np_g1k(ik)
             !            wf_l(ig,ri) = zaj_l(ig-ista_g1k(ik)+1,map_z(ie),ik,ri)
             !         enddo
             !      end do
             !   endif
             !   call mpi_allreduce(mpi_in_place, wf_l, kg1*kimg, mpi_real4, mpi_sum, mpi_ke_world,ierr)
             !   if((map_k(ike2) == myrank_k) .and. (map_e(ie) == myrank_e) )then         ! MPI
             !      do ri = 1, kimg
             !         do ig = ista_g1k(ike2), iend_g1k(ike2)
             !            zaj_l(ig-ista_g1k(ike2)+1,map_z(ie),ike2,ri) = wf_buf(ig,ri)
             !         enddo
             !      end do
             !   end if
             !end do
             if(map_k(ike2)==myrank_k) call m_ESIW_by_randomnumbers0_3D(nfout,kv3,1,neg,ike2,ike2)
          end do

          ! ---> neordr, nrvf_ordr
          do ikt = 1, nspin
             ik = (ikg-2)*nspin+ikt
             if(map_k(ik) == myrank_k) then
                n_mpi(1:neg,ikt) = neordr(1:neg,ik)
                n2_mpi(1:neg,ikt) = nrvf_ordr(1:neg,ik)
             end if
          end do
          call mpi_bcast(n_mpi,neg*nspin,mpi_integer,map_k(ik),MPI_CommGroup,ierr)
          call mpi_bcast(n2_mpi,neg*nspin,mpi_integer,map_k(ik),MPI_CommGroup,ierr)

          if(ipri>=2) write(nfout,*) ' !D     neordr and nrvf_ordr'
          do ikt = 1, nspin
             ike2 = (ike-1)*nspin+ikt
             if(map_k(ike2) == myrank_k) then
                neordr(1:neg,ike2) = n_mpi(1:neg,ikt)     ! MPI
                nrvf_ordr(1:neg,ike2) = n2_mpi(1:neg,ikt) ! MPI
             end if
          end do

          ! ---> eko_l
          if(ipri>=2) write(nfout,*) ' !D     eko_l'
          e_mpi = 0.d0
          do ikt = 1, nspin
             ik = (ikg-2)*nspin+ikt
             if(ipri>=2) write(nfout,'(" !D eko_l ik = ",i6)') ik
             do ie = 1, neg
                if((map_k(ik) == myrank_k) .and. (map_e(ie) == myrank_e) )then         ! MPI
                   e_mpi(ie,ikt) = eko_l(map_z(ie),ik)
                end if
             end do
          end do
          if(npes >= 2) then
             call mpi_allreduce(MPI_IN_PLACE,e_mpi,neg*nspin,mpi_double_precision &
                  & ,mpi_sum,mpi_kg_world,ierr)
             call mpi_allreduce(MPI_IN_PLACE,e_mpi,neg*nspin,mpi_double_precision &
                  & ,mpi_sum,mpi_ge_world,ierr)

             call mpi_allreduce(e_mpi,e2_mpi,neg*nspin,mpi_double_precision &
                  & ,mpi_sum,mpi_kg_world,ierr)
             call mpi_allreduce(e_mpi,e2_mpi,neg*nspin,mpi_double_precision &
                  & ,mpi_sum,mpi_ge_world,ierr)
          else
             e2_mpi  = e_mpi
          end if

          if(ipri>=2) then
             write(nfout,'(" <<m_ESIO_rd_WFs_and_EVs_ek>>")')
             do ikt = 1, nspin
                ik = (ikg-2)*nspin+ikt
                write(nfout,'(" ik = ",i5)') ik
                write(nfout,'(10f8.4)') (e2_mpi(ie,ikt),ie=1,neg)
             end do
          end if

          do ikt = 1, nspin
             ike2 = (ike-1)*nspin+ikt
             if(ipri>=2) write(nfout,'(" !D eko_l ike2 = ",i6)') ike2
             do ie = 1, neg
                if((map_k(ike2) == myrank_k) .and. (map_e(ie) == myrank_e) )then         ! MPI
                   eko_l(map_z(ie),ike2) = e2_mpi(ie,ikt)
                end if
             end do
          end do

       end do
       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle
          call m_ES_betar_dot_WFs_3D(nfout,ik)     ! (fsrfsi,sumset)
       end do
       call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
    end if

1001 continue

    if(npes >= 2) &
         & call mpi_bcast(eko_ek,neg*kv3_ek,mpi_double_precision,0,MPI_CommGroup,ierr)

    if(nk_in_the_process > kv3_ek) goto 1002
    call m_ESIO_wd_EigenValues(nfout,2,nooccupation=YES)

1002 continue

!!$    ik = nk_in_the_process
!!$    do iks = 1, kv3
!!$          do ie = 1, neg
!!$             eko_ek(ie,ik+iks-1) = e_mpi(n_mpi(ie,iks),iks)
!!$          end do
!!$       end do
!!$    end if
!!$
    if(ipri >= 1) then
       write(nfout,'(" <<m_ESIO_rd_WFs_and_EVs_ek>>")')
       do iks = 1, kv3_ek
          if(iks > numk_zajsaved) cycle
          write(nfout,'(" ik = ",i5)') iks
          write(nfout,'(10f8.4)') (eko_ek(ie,iks),ie=1,neg)
       end do
    end if


    rewind nf
    do ik = 1, nk_in_the_process-nspin, nspin
       do iks = 1, nspin, af+1
          do ie = 1, neg
             if(mype == 0) read(nf) wf_l                 ! MPI
          end do
       end do
       if(mype == 0) read(nf) n_mpi                   ! MPI
       if(mype == 0) read(nf) n2_mpi                  ! MPI
       if(mype == 0) read(nf) e_mpi                   ! MPI
    end do

    deallocate(wf_l)                                    ! MPI
    deallocate(n_mpi); deallocate(n2_mpi)               ! MPI
    deallocate(e_mpi); deallocate(e2_mpi)               ! MPI
    return
9999 continue
    call phase_error_wo_filename(EOF_REACHED, nfout, nf, __LINE__, __FILE__)

!!$    write(nfout,'(" ---<< m_ESIO_rd_WFs_and_EVs_ek>>---")')
  end subroutine m_ESIO_rd_WFs_and_EVs_ek


  subroutine m_ESIO_wd_WFs_and_EVs_ek(nfout,nf)
    integer, intent(in) :: nfout, nf
    integer  :: ik, ie, ri, ikg, ikt, ib, j
    integer, allocatable, dimension(:,:) :: n_mpi
    real(DP),allocatable, dimension(:,:) :: e_mpi
    integer :: id_sname = -1
    call tstatc0_begin('m_ESIO_wd_WFs_and_EVs_ek ',id_sname)

    allocate(wf_l(kg1,kimg));    wf_l = 0

    call mpi_barrier(MPI_CommGroup,ierr)
    if(ipri>=2) write(nfout,'(" !D Writing WaveFunctions ")')

    allocate(n_mpi(neg,nspin)); n_mpi = 0
    allocate(e_mpi(neg,nspin)); e_mpi = 0.d0

    KPOINT: do ikg = 1, nrank_k
       ! ---> zaj_l
       if((ikg-1)*nspin + 1 > kv3) then
          if(ipri >= 1) write(nfout,'(" !D ik > kv3")')
          exit KPOINT
       end if

       do ikt = 1, nspin, af+1
          ik = (ikg-1)*nspin + ikt
          if(ipri>=1) write(nfout,'(" !D Writing WaveFunctions ik = ",i5)') ik
#ifdef _USE_ALLREDUCE_IN_WD_WFS_
          do ib = 1, neg
             wf_l = 0.0d0
             if((map_k(ik) == myrank_k) .and. (map_e(ib) == myrank_e)) then         ! MPI
                do ri = 1, kimg
                  do j = ista_g1k(ik),iend_g1k(ik)
                     wf_l(j,ri) = zaj_l(j-ista_g1k(ik)+1,map_z(ib),ik,ri)
                  end do
                end do
             endif
             call mpi_allreduce(MPI_IN_PLACE,wf_l,kg1*kimg,mpi_real4,mpi_sum,MPI_CommGroup,ierr)
             if(mype == 0) write(nf)  wf_l                        ! MPI
          end do
#else
!! coded by T. Yamasaki, 2021.02.25 -->
          allocate(wf_buf(maxval(np_g1k),kimg))
          do ib = 1, neg
             wf_l = 0.0d0
             wf_buf = 0.d0
             do j = 0, nrank_g-1
                if(map_k(ik)==myrank_k .and. map_e(ib)==myrank_e .and. j==myrank_g) then
                   do ig = ista_g1k(ik), iend_g1k(ik)
                      do ri=1, kimg
                         wf_buf(ig-ista_g1k(ik)+1,ri) = zaj_l(ig-ista_g1k(ik)+1,map_z(ib),ik,ri)
                      end do
                   end do
                   call mpi_send(wf_buf,maxval(np_g1k)*kimg,mpi_real4,0,1,MPI_CommGroup,ierr)
                end if
                if(mype==0) then
                   call mpi_recv(wf_buf,maxval(np_g1k)*kimg,mpi_real4,map_rank_gek(j,map_e(ib),map_k(ik)),1,MPI_CommGroup,istatus,ierr)
                   wf_l(nis_g1k(j,ik):nie_g1k(j,ik),1:kimg) = wf_buf(1:nie_g1k(j,ik)-nis_g1k(j,ik)+1,1:kimg)
                end if
             end do
             if(mype==0) write(nf) wf_l
          end do
          deallocate(wf_buf)
!! <--
#endif
       end do

       ! --->  neordr
       n_mpi = 0                                          ! MPI
       do ikt = 1, nspin                                  ! MPI
          ik = (ikg-1)*nspin + ikt
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          n_mpi(1:neg,ikt) = neordr(1:neg,ik)             ! MPI
       end do                                             ! MPI
       if(npes >= 2) then
          call mpi_allreduce(MPI_IN_PLACE,n_mpi,neg*nspin,mpi_integer,mpi_sum &
               &                      ,MPI_CommGroup,ierr)  ! MPI
          n_mpi = n_mpi/nrank_e/nrank_g
       end if
       if(ipri>=2) write(nfout,'(" !D Writing neordr ik = ",i5)') ik
       if(mype == 0) write(nf) n_mpi             ! MPI ; writing (neordr)

       ! --->  nrvf_ordr
       n_mpi = 0                                          ! MPI
       do ikt = 1, nspin                                  ! MPI
          ik = (ikg-1)*nspin + ikt
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          n_mpi(1:neg,ikt) = nrvf_ordr(1:neg,ik)          ! MPI
       end do                                             ! MPI
       if(npes >= 2) then
          call mpi_allreduce(MPI_IN_PLACE,n_mpi,neg*nspin,mpi_integer,mpi_sum &
               &                      ,MPI_CommGroup,ierr)  ! MPI
          n_mpi = n_mpi/nrank_e/nrank_g
       end if
       if(ipri>=2) write(nfout,'(" !D Writing nrvf_ordr ik = ",i5)') ik
       if(mype == 0) write(nf) n_mpi             ! MPI ; writing (nrvf_ordr)

       e_mpi = 0.d0                                       ! MPI
       do ikt = 1, nspin                                  ! MPI
          ik = (ikg-1)*nspin + ikt
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          do ie = 1, neg                                  ! MPI
             if(map_e(ie) /= myrank_e) cycle              ! MPI
             e_mpi(ie,ikt) = eko_l(map_z(ie),ik)           ! MPI
          end do
       end do
       if(npes >= 2) then
          call mpi_allreduce(MPI_IN_PLACE,e_mpi,neg*nspin,mpi_double_precision &
               &               ,mpi_sum,mpi_kg_world,ierr) ! MPI
          call mpi_allreduce(MPI_IN_PLACE,e_mpi,neg*nspin,mpi_double_precision &
               &               ,mpi_sum,mpi_ge_world,ierr) ! MPI
       end if
       if(ipri>=2) write(nfout,'(" !D Writing eko_l ik = ",i5)') ik
       if(mype == 0) write(nf) e_mpi             ! MPI ; writing (eko_l)
    end do KPOINT

!!$    do ik = 1, kv3, af+1
!!$       do ie = 1, neg
!!$          if(map_ek(ie,ik) == mype) then                          ! MPI
!!$             do ri = 1, kimg
!!$                wf_l(1:kg1,ri) = zaj_l(1:kg1,map_z(ie),ik,ri)
!!$             end do
!!$             if(map_ek(ie,ik) /= 0) &                             ! MPI
!!$            &   call mpi_send(wf_l,kg1*kimg,mpi_real,0,1,MPI_CommGroup,ierr) ! MPI
!!$          else if(mype == 0 .and. map_ek(ie,ik) /= 0) then
!!$             call mpi_recv(wf_l,kg1*kimg,mpi_real,map_ek(ie,ik),1,MPI_CommGroup,istatus,ierr)!MPI
!!$          end if
!!$          if(mype == 0) write(nf)  wf_l                        ! MPI
!!$       end do
!!$    end do
!!$    deallocate(wf_l)
!!$
!!$    allocate(n_mpi(neg,kv3)); allocate(n2_mpi(neg,kv3))! MPI
!!$    allocate(e_mpi(neg,kv3)); allocate(e2_mpi(neg,kv3))! MPI
!!$
!!$    n_mpi = 0                                          ! MPI
!!$    do ik = 1, kv3                                     ! MPI
!!$       if(map_k(ik) /= myrank_k) cycle                 ! MPI
!!$       n_mpi(1:neg,ik) = neordr(1:neg,ik)              ! MPI
!!$    end do                                             ! MPI
!!$    if(npes >= 2) then
!!$       call mpi_allreduce(n_mpi,n2_mpi,neg*kv3,mpi_integer,mpi_sum &
!!$            &                      ,MPI_CommGroup,ierr)  ! MPI
!!$       n2_mpi = n2_mpi/nrank_e
!!$    else
!!$       n2_mpi = n_mpi
!!$    end if
!!$    if(mype == 0) write(nf) n2_mpi             ! MPI ; writing (neordr)
!!$
!!$    n_mpi = 0                                          ! MPI
!!$    do ik = 1, kv3                                     ! MPI
!!$       if(map_k(ik) /= myrank_k) cycle                 ! MPI
!!$       n_mpi(1:neg,ik) = nrvf_ordr(1:neg,ik)           ! MPI
!!$    end do                                             ! MPI
!!$    if(npes >= 2) then
!!$       call mpi_allreduce(n_mpi,n2_mpi,neg*kv3,mpi_integer,mpi_sum &
!!$            &                      ,MPI_CommGroup,ierr)  ! MPI
!!$       n2_mpi = n2_mpi/nrank_e
!!$    else
!!$       n2_mpi = n_mpi
!!$    end if
!!$    if(mype == 0) write(nf) n2_mpi             ! MPI ; writing (nrvf_ordr)
!!$
!!$    e_mpi = 0.d0                                       ! MPI
!!$    do ik = 1, kv3                                     ! MPI
!!$       if(map_k(ik) /= myrank_k) cycle                 ! MPI
!!$       do ie = 1, neg                                  ! MPI
!!$          if(map_e(ie) /= myrank_e) cycle              ! MPI
!!$          e_mpi(ie,ik) = eko_l(map_z(ie),ik)           ! MPI
!!$       end do
!!$    end do
!!$    if(npes >= 2) then
!!$       call mpi_allreduce(e_mpi,e2_mpi,neg*kv3,mpi_double_precision &
!!$            &               ,mpi_sum,MPI_CommGroup,ierr) ! MPI
!!$    else
!!$       e2_mpi = e_mpi
!!$    end if
!!$    if(mype == 0) write(nf) e2_mpi             ! MPI ; writing (eko_l)

!!$    e_mpi = 0.d0                                       ! MPI
!!$    do ik = 1, kv3                                     ! MPI
!!$       if(map_k(ik) /= myrank_k) cycle                 ! MPI
!!$       do ie = 1, neg                                  ! MPI
!!$          if(map_e(ie) /= myrank_e) cycle              ! MPI
!!$          e_mpi(ie,ik) = occup_l(map_z(ie),ik)         ! MPI
!!$       end do                                          ! MPI
!!$    end do                                             ! MPI
!!$    if(npes >= 2) then
!!$       call mpi_allreduce(e_mpi,e2_mpi,neg*kv3,mpi_double_precision &
!!$            &                  ,mpi_sum,MPI_CommGroup,ierr) ! MPI
!!$    else
!!$       e2_mpi = e_mpi
!!$    end if
!!$    if(mype == 0) write(nf) e2_mpi             ! MPI ; writing (occup_l)

    if(precision_WFfile==SP) then
       deallocate(wf_l)
    else if(precision_WFfile==DP) then
       deallocate(wfdp_l)
    end if
    deallocate(n_mpi)
    deallocate(e_mpi)

    call tstatc0_end(id_sname)

  end subroutine m_ESIO_wd_WFs_and_EVs_ek


  logical function m_ESIO_check_energy(ik,ib)
    integer, intent(in) :: ik,ib
    integer :: jb
    real(kind=DP) :: eig
    if(map_k(ik) == myrank_k) jb = neordr(ib,ik)
    if(nrank_k > 1) call mpi_bcast(jb,1,mpi_integer,map_k(ik),mpi_e_world(myrank_e),ierr)

    if(map_ek(jb,ik) == mype) then
       eig = eko_l(map_z(jb),ik)
       if(eig >= eigmin_wf .and. eig <= eigmax_wf) then
          m_ESIO_check_energy = .true.
       else
          m_ESIO_check_energy = .false.
       end if
    end if
    call mpi_bcast(m_ESIO_check_energy,1,mpi_logical,map_ek(jb,ik),MPI_CommGroup,ierr)
  end function m_ESIO_check_energy

  subroutine m_ESIO_wd_Efermi(nfout,nfefermi)
    integer, intent(in) :: nfout, nfefermi
                                                  __TIMER_SUB_START(1377)
    if(mype == 0) then
                                                  __TIMER_IODO_START(1460)
       write(nfefermi,'(f16.8," : Efermi")') efermi
       if(sw_fix_total_spin == YES .and. nspin == 2) then
          write(nfefermi,'(2f16.8," : Ffermi_spin(1), Efermi_spin(2)")') &
               & efermi_spin(1),efermi_spin(2)
       end if
                                                  __TIMER_IODO_STOP(1460)
    end if
                                                  __TIMER_SUB_STOP(1377)
  end subroutine m_ESIO_wd_Efermi

  subroutine m_ESIO_rd_Efermi(nfout,nfefermi)
    integer, intent(in) :: nfout, nfefermi
                                                  __TIMER_SUB_START(1376)
    if(mype == 0) then
                                                  __TIMER_IODO_START(1458)
       read(nfefermi,*,err=1001,end=1001) efermi
       write(nfout,'(" ! efermi = ",f16.8," : this is read from nfefermi")') efermi
       if(sw_fix_total_spin == YES .and. nspin == 2) then
          read(nfefermi,*,err=1002,end=1002) efermi_spin(1),efermi_spin(2)
          write(nfout,'(" ! efermi_spin = ",2f16.8," : these are read from nfefermi")') efermi_spin(1:2)
       end if
                                                  __TIMER_IODO_STOP(1458)
       goto 1010
1001   continue
       efermi = 0.d0
1002   continue
       if(sw_fix_total_spin == YES .and. nspin == 2) then
          efermi_spin(1) = 0.d0; efermi_spin(2) = 0.d0
       end if
1010   continue
    end if
    if(npes > 1) then
                                                  __TIMER_IOCOMM_START_w_BARRIER(MPI_CommGroup,1459)
       call mpi_bcast(efermi,1,mpi_double_precision,0,MPI_CommGroup,ierr)
       if(sw_fix_total_spin == YES .and. nspin == 2) then
          call mpi_bcast(efermi_spin,2,mpi_double_precision,0,MPI_CommGroup,ierr)
       end if
                                                  __TIMER_IOCOMM_STOP(1459)
    end if
                                                  __TIMER_SUB_STOP(1376)
  end subroutine m_ESIO_rd_Efermi

  subroutine m_ESIO_wd_WFs_3D(nfout,nfzaj,F_ZAJ_partitioned,rew)
   use m_Parallelization,     only : mpi_ke_world, mpi_kg_world

    integer, intent(in) :: nfout,nfzaj
    logical, intent(in) :: F_ZAJ_partitioned
    logical, intent(in), optional :: rew
    real(kind=SP), allocatable, dimension(:,:) :: wf_buf
    integer :: ik,ib,ri,j,i,ig, ispin
    integer :: id_sname = -1
                                                  __TIMER_SUB_START(1373)
    call tstatc0_begin('m_ESIO_wd_WFs ',id_sname)

    call mpi_barrier(MPI_CommGroup,ierr)
    if (present(rew)) then
      if(rew) then
        rewind nfzaj
      endif
    else
      rewind nfzaj
    endif
   if(precision_WFfile==SP) then
    if(ipri >= 1) write(nfout,*) ' !D Writing zaj (single_precision)'
    if(F_ZAJ_partitioned) then
       allocate(wf_l(maxval(np_g1k),kimg))
                                                  __TIMER_IODO_START(1440)
       do ik = ista_k, iend_k, af+1
          do ib = 1, np_e
             do ri = 1, kimg
                wf_l(1:np_g1k(ik),ri) = zaj_l(1:np_g1k(ik),ib,ik,ri)
             end do
                                                  __TIMER_IODO_START(1441)
             write(nfzaj) wf_l
                                                  __TIMER_IODO_STOP(1441)
          end do
       end do
                                                  __TIMER_IODO_STOP(1440)
       deallocate(wf_l)
    else
       allocate(wf_l(kg1,kimg))
       do ispin = 1, nspin, af+1
       !do ik = 1, kv3, af+1
       do ik = ispin, kv3-nspin+ispin, nspin
                                                  __TIMER_IODO_START(1442)
#ifdef _USE_ALLREDUCE_IN_WD_WFS_
          do ib = 1, neg
             wf_l = 0.0d0
             if((map_k(ik) == myrank_k) .and. (map_e(ib) == myrank_e) .and. (map_s(ispin) == myrank_spin) ) then         ! MPI
                do ri = 1, kimg
                  do j = ista_g1k(ik),iend_g1k(ik)
                     wf_l(j,ri) = zaj_l(j-ista_g1k(ik)+1,map_z(ib),ik,ri)
                  end do
                end do
             endif
                                                  __TIMER_IOCOMM_START_w_BARRIER(MPI_CommGroup,1443)
             call mpi_allreduce(MPI_IN_PLACE,wf_l,kg1*kimg,mpi_real4,mpi_sum,MPI_CommGroup,ierr)
                                                  __TIMER_IOCOMM_STOP(1443)
                                                  __TIMER_IODO_START(1444)
             if(mype == 0) write(nfzaj)  wf_l                        ! MPI
                                                  __TIMER_IODO_STOP(1444)
          end do
#else
!! coded by T. Yamasaki, 2021.02.25 -->
          allocate(wf_buf(maxval(np_g1k),kimg))
          do ib = 1, neg
             wf_l = 0.0d0
             wf_buf = 0.d0
             do j = 0, nrank_g-1
                if(map_k(ik)==myrank_k .and. map_e(ib)==myrank_e .and. j==myrank_g) then
                   do ig = ista_g1k(ik), iend_g1k(ik)
                      do ri=1, kimg
                         wf_buf(ig-ista_g1k(ik)+1,ri) = zaj_l(ig-ista_g1k(ik)+1,map_z(ib),ik,ri)
                      end do
                   end do
                   call mpi_send(wf_buf,maxval(np_g1k)*kimg,mpi_real4,0,1,MPI_CommGroup,ierr)
                end if
                if(mype==0) then
                   call mpi_recv(wf_buf,maxval(np_g1k)*kimg,mpi_real4,map_rank_gek(j,map_e(ib),map_k(ik)),1,MPI_CommGroup,istatus,ierr)
                   wf_l(nis_g1k(j,ik):nie_g1k(j,ik),1:kimg) = wf_buf(1:nie_g1k(j,ik)-nis_g1k(j,ik)+1,1:kimg)
                end if
             end do
             if(mype==0) write(nfzaj) wf_l
          end do
          deallocate(wf_buf)
!! <--
#endif
                                                  __TIMER_IODO_STOP(1442)
       end do
       enddo
       deallocate(wf_l)
    end if
   else if(precision_WFfile==DP) then
    if(ipri >= 1) write(nfout,*) ' !D Writing zaj (double_precision)'
    if(F_ZAJ_partitioned) then
       allocate(wfdp_l(maxval(np_g1k),kimg))
                                                  __TIMER_IODO_START(1440)
       do ik = ista_k, iend_k, af+1
          do ib = 1, np_e
             do ri = 1, kimg
                wfdp_l(1:np_g1k(ik),ri) = zaj_l(1:np_g1k(ik),ib,ik,ri)
             end do
                                                  __TIMER_IODO_START(1441)
             write(nfzaj) wfdp_l
                                                  __TIMER_IODO_STOP(1441)
          end do
       end do
                                                  __TIMER_IODO_STOP(1440)
       deallocate(wfdp_l)
    else
       allocate(wfdp_l(kg1,kimg))
       do ispin = 1, nspin, af+1
       !do ik = 1, kv3, af+1
       do ik = ispin, kv3-nspin+ispin, nspin
                                                  __TIMER_IODO_START(1442)
          do ib = 1, neg
             wfdp_l = 0.0d0
             if((map_k(ik) == myrank_k) .and. (map_e(ib) == myrank_e) .and. (map_s(ispin) == myrank_spin))then         ! MPI
                do ri = 1, kimg
                  do j = ista_g1k(ik),iend_g1k(ik)
                     wfdp_l(j,ri) = zaj_l(j-ista_g1k(ik)+1,map_z(ib),ik,ri)
                  end do
                end do
             endif
                                                  __TIMER_IOCOMM_START_w_BARRIER(MPI_CommGroup,1443)
             call mpi_allreduce(MPI_IN_PLACE,wfdp_l,kg1*kimg,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
                                                  __TIMER_IOCOMM_STOP(1443)
                                                  __TIMER_IODO_START(1444)
             if(mype == 0) write(nfzaj)  wfdp_l
                                                  __TIMER_IODO_STOP(1444)
          end do
                                                  __TIMER_IODO_STOP(1442)
       end do
       end do
       deallocate(wfdp_l)
    end if
   end if
    call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(1373)
  end subroutine m_ESIO_wd_WFs_3D

!-- for test
  subroutine m_ESIO_rd_WFs_dp_3D(nfout,nfzaj, F_ZAJ_partitioned)
   use m_Parallelization,     only : mpi_ke_world, mpi_kg_world

    real(kind=DP), allocatable, dimension(:,:)  :: wf_ldp   ! work wave functions
    integer, intent(in) :: nfout, nfzaj
    logical, intent(in) :: F_ZAJ_partitioned
    integer    :: ik,ib,ri, i, j
    integer    :: id_sname = -1
    call tstatc0_begin('m_ESIO_rd_WFs ',id_sname)

!f    allocate(wf_ldp(kg1,kimg))
!!$ASASASASAS
!f    wf_l = 0
!!$ASASASASAS
    rewind nfzaj
    if(ipri >= 1) write(nfout,*) ' !D Reading zaj'
    if(F_ZAJ_partitioned) then
       allocate(wf_ldp(maxval(np_g1k),kimg))
       wf_ldp = 0
       do ik = ista_k, iend_k, af+1        ! MPI
          do ib = 1, np_e  ! MPI
             if(ista_e+ib-1 > neg_previous) cycle
             read(nfzaj) wf_ldp
             if(kimg == 1) then
                do i = 1, np_g1k(ik)
                   zaj_l(i,ib,ik,1) = wf_ldp(i,1)
                end do
             else if(kimg==2) then
                do i = 1, np_g1k(ik)
                   zaj_l(i,ib,ik,1) = wf_ldp(i,1)
                   zaj_l(i,ib,ik,2) = wf_ldp(i,2)
                end do
             end if
          end do
       end do
       deallocate(wf_ldp)
    else
       allocate(wf_ldp(kg1,kimg))
       wf_ldp = 0
       do ik = 1, kv3, af+1
          do ib = 1, neg_previous
             if(mype == 0) read(nfzaj) wf_ldp              ! MPI
             call mpi_bcast(wf_ldp,kg1*kimg,mpi_real8,0,MPI_CommGroup,ierr)
             if((map_k(ik) == myrank_k) .and. (map_e(ib) == myrank_e) )then         ! MPI
                do ri = 1, kimg
                  do j = ista_g1k(ik),iend_g1k(ik)
                     zaj_l(j-ista_g1k(ik)+1,map_z(ib),ik,ri) = wf_ldp(j,ri)  ! MPI
                  end do
                end do
             end if
          end do
       end do
       deallocate(wf_ldp)
    end if

    call tstatc0_end(id_sname)
  end subroutine m_ESIO_rd_WFs_dp_3D

  subroutine m_ESIO_wd_WFs_dp_3D(nfout,nfzaj,F_ZAJ_partitioned)
   use m_Parallelization,     only : mpi_ke_world, mpi_kg_world

    real(kind=DP), allocatable, dimension(:,:)  :: wf_ldp   ! work wave functions
    integer, intent(in) :: nfout,nfzaj
    logical, intent(in) :: F_ZAJ_partitioned
    integer :: ik,ib,ri,j,i
    integer :: id_sname = -1
    real(kind=DP), allocatable, dimension(:,:)  :: wf_mpi   ! work wave functions
    call tstatc0_begin('m_ESIO_wd_WFs ',id_sname)

!f    allocate(wf_ldp(kg1,kimg))
    call mpi_barrier(MPI_CommGroup,ierr)
    !!$ print *, ' !D Writing zaj '
    if(ipri >= 1) write(nfout,*) ' !D Writing zaj '
    rewind nfzaj
    if(F_ZAJ_partitioned) then
       allocate(wf_ldp(maxval(np_g1k),kimg))
       allocate(wf_mpi(kg1,kimg))
       do ik = ista_k, iend_k, af+1        ! MPI
          do ib = 1, np_e
             do ri = 1, kimg
                wf_ldp(1:np_g1k(ik),ri) = zaj_l(1:np_g1k(ik),ib,ik,ri)
             end do
             write(nfzaj) wf_ldp
          end do
       end do
       deallocate(wf_ldp)
       deallocate(wf_mpi)
    else
       allocate(wf_ldp(kg1,kimg))
       allocate(wf_mpi(kg1,kimg))
       do ik = 1, kv3, af+1
          do ib = 1, neg
             wf_ldp = 0.0d0
             if((map_k(ik) == myrank_k) .and. (map_e(ib) == myrank_e) )then         ! MPI
                do ri = 1, kimg
                  do j = ista_g1k(ik),iend_g1k(ik)
                     wf_ldp(j,ri) = zaj_l(j-ista_g1k(ik)+1,map_z(ib),ik,ri)
                  end do
                end do
             endif
             call mpi_allreduce(wf_ldp,wf_mpi,kg1*kimg,mpi_real8,mpi_sum,MPI_CommGroup,ierr)
             if(mype == 0) write(nfzaj)  wf_mpi                        ! MPI
          end do
       end do
       deallocate(wf_ldp)
       deallocate(wf_mpi)
    end if
    call tstatc0_end(id_sname)
  end subroutine m_ESIO_wd_WFs_dp_3D


end module m_ES_IO

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 629 $)
!
!  MODULE: m_Kpoint
!
!  AUTHORS: T. Yamasaki, T. Yamamoto,  August/20/2003
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!  patch 10.1 by K. Tagami @adv    2011/06/18
!
!  patch 10.1 :  k_sample_mesh is changed from private to public
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developOPed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Kpoints
!     (m_Kp)
!  $Id: m_Kpoints.F90 629 2020-07-07 02:21:33Z ktagami $
!
  use m_Crystal_Structure,   only : il,imag,inv,ngen,igen,jgen, a,b,c,ca,cb,cc &
       &                          , altv, rltv, nbztyp , nbztyp_spg, n1_sc, n2_sc, n3_sc
  use m_Files,               only : nfout,nfkpoint, nfmatbp, m_Files_open_kpoint_files
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,  only : nspin, ipri, tag_accuracy, icond &
       &                          , ipriinputfile, ipri_kp, sw_berry_phase, ekmode, printable, kimg &
       &                          , fixed_charge_k_parallel, sw_hybrid_functional &
       &                          , m_CtrlP_way_of_smearing, m_CtrlP_set_way_ksample,way_of_smearing, way_ksample &
       &                          , sw_modified_kpoint_increment
  use m_Const_Parameters,    only : CARTS, BUCS, CRDTYP, NONAME &
       &                          , MESH, MONKHORST_PACK &
       &                          , SKPS_DIRECT_IN, GAMMA, FILE, DP, PAI2 &
       &                          , SURFACE, WHOLE_BZ, SIMPLE_CUBIC &
       &                          , BCC, FCC, DIAMOND, HEXAGONAL, ORTHORHOMBIC &
       &                          , RUTILE, C2v_SURFACE, Csy_SURFACE &
       &                          , GENERAL, GENERAL_LARGER &
       &                          , HEX1fold, HEX2fold, HEX3fold &
       &                          , LOWER, NODATA, FMAXVALLEN &
       &                          , TETRAHEDRON, ON, OFF, GRID, DELTA &
       &                          , GAMMA_base_symmetrization, PARA, ONE_BY_ONE
  use m_Parallelization,     only : MPI_CommGroup,npes,ierr,nrank_k,mype, myrank_k, ista_kv3_ek, nis_kv3_ek

! ================================= added by. Tagami =========== 11.0
  use m_Control_Parameters,    only : ndim_spinor, noncol, SpinOrbit_mode
  use m_Const_Parameters,      only : Neglected
! ============================================================= 11.0

! ================================= added by. Tagami =========== 12.0A
  use m_Crystal_Structure,   only : gen_name_in_carts, use_altv_rltv
! ============================================================== 12.0A

! === KT_add ==== 2014/08/14+
  use m_CS_Magnetic,  only : magmom_dir_inversion_opr_flag, sw_neglect_magmom
! =============== 2014/08/14+

! === KT_add ==== 2014/09/30, 2018/02/26
  use m_Const_Parameters,  only : DELTA07, USE_OPR_IN_STAR_OF_K, &
       &                          chg_symm_level1, chg_symm_level2
  use m_Crystal_Structure, only : nopr, op
! =============== 2014/09/30, 2018/02/26
! === KT_add ==== 13.2S
  use m_Crystal_Structure, only : sw_use_magnetic_symmetry
! =============== 13.2S

  use m_Control_Parameters,  only : sw_excitation, sw_band_unfolding, charge_symm_mode, &
       &                            sw_write_bxsf_file, use_metagga, vtau_exists
  use m_Crystal_Structure,  only : rltv_refcell, altv_refcell
  use m_IterationNumbers,   only : nkgroup
  use mpi

  implicit none
!  include 'mpif.h'

  integer, target                                      :: kv3=0 ! #sampling k-points
  real(kind=DP), allocatable, target, dimension(:,:,:) :: vkxyz ! d(kv3,3,CRDTYP), sampling k-points
  real(kind=DP), allocatable, target, dimension(:)     :: qwgt  ! d(kv3), weight factors
  integer, allocatable, dimension(:)           :: k_symmetry ! d(kv3), symmetries of k-points, Gamma or not
  integer, target                              :: kv3_ek ! k-points with charge-fixed
  integer                                      :: ek_group = 1 ! #k-point groups with charge-fixed
  real(kind=DP), allocatable, target, dimension(:,:,:) :: vkxyz_ek ! k-points
  real(kind=DP), allocatable, target, dimension(:)     :: qwgt_ek ! weight factors

! ========================= modified by K. Tagami ==================== 10.1
!  integer,          private,  dimension(3,2)   :: k_sample_mesh = 1
  integer,                     dimension(3,2)   :: k_sample_mesh = 1
! =================================================================== 10.1

  integer                                      :: kv3_previous = 0
  integer, private                             :: ipri_kp_count = 0, ipri_kp_t = 0
  integer                                      :: nkek  ! #kpoints for ek curve
  integer, private                             :: base_reduction_for_GAMMA = ON ! default=ON if possible
  integer, private                             :: base_symmetrization_for_GAMMA = ON ! default=ON if possible
  integer, parameter, private :: len_str = 132
  character(len=len_str),private :: str
  real(kind=DP),private,pointer,dimension(:,:) :: work

  integer                                      :: np0,np1,np2,nx1,ny1,nz1,nd
  integer,allocatable, dimension(:)            :: ip20,ip10,ip02,ip12
  integer,allocatable, dimension(:)            :: ip01,ip21,iu21,iv21,iwt,ip2cub
  integer,allocatable, dimension(:)            :: nxyz_tetra
  real(kind=DP), dimension(3,3)                :: trmat

  ! --- Ksampling ---
  character(len("ksampling")),private,parameter :: tag_ksampling = "ksampling"
  character(len("method")),private,parameter ::    tag_method    = "method"
  character(len("mesh")),private,parameter ::      tag_mesh      = "mesh"
  character(len("nx")),private,parameter ::        tag_nx        = "nx"
  character(len("ny")),private,parameter ::        tag_ny        = "ny"
  character(len("nz")),private,parameter ::        tag_nz        = "nz"
  character(len("monk")),private,parameter ::      tag_monkhorst_pack = "monk"
  character(len("mp_index")),private,parameter ::  tag_mp_index  = "mp_index"
  character(len("n1")),private,parameter ::        tag_n1        = "n1"
  character(len("n2")),private,parameter ::        tag_n2        = "n2"
  character(len("n3")),private,parameter ::        tag_n3        = "n3"
  character(len("kshift")),private,parameter ::    tag_kshift    = "kshift"
  character(len("k1")),private,parameter ::        tag_k1        = "k1"
  character(len("k2")),private,parameter ::        tag_k2        = "k2"
  character(len("k3")),private,parameter ::        tag_k3        = "k3"
  character(len("file")),private,parameter ::      tag_file      = "file"
  character(len("gamma")),private,parameter ::     tag_gamma     = "gamma"
  character(len("directin")),private,parameter ::  tag_directin  = "directin"
  character(len("num_kpoints")),private,parameter ::tag_num_kpoints = "num_kpoints"
  character(len("sum_weight")),private,parameter:: tag_sum_weight = "sum_weight"
  character(len("kpoints")),private,parameter ::   tag_kpoints   = "kpoints"
  character(len("kx")),private,parameter ::        tag_kx        = "kx"
  character(len("ky")),private,parameter ::        tag_ky        = "ky"
  character(len("kz")),private,parameter ::        tag_kz        = "kz"
  character(len("denom")),private,parameter ::     tag_denom     = "denom"
  character(len("weight")),private,parameter ::    tag_weight    = "weight"
  character(len("base_reduction_for_GAMMA")),private,parameter :: &
       &                       tag_base_reduction_for_GAMMA = "base_reduction_for_GAMMA"
  character(len("base_symmetrization_for_GAMMA")),private,parameter :: &
       &                       tag_base_symmetrization_for_G = "base_symmetrization_for_GAMMA"
  character(len("kv3")),private,parameter ::       tag_kv3       = "kv3"
  character(len("use_trs")),private,parameter ::  tag_use_trs  = "use_trs"
  character(len("density")),private,parameter :: tag_density = "density"
  ! --- temporary ---
  real(kind=DP), allocatable, dimension(:) :: kx_t,ky_t,kz_t
  real(kind=DP), allocatable, dimension(:) :: weight_t
  integer ::                                  kv3_t = -1

  real(kind=DP) :: k_density = 4.d0

  ! --- Monknorst-Pack method---
  !!integer, parameter, private :: ng=45,ngrid=(2*ng+1)**3,nshell=10000
  integer, private :: ng,ngrid,nshell
  integer, parameter, private :: nface_max = 125
  type shell
    integer :: ndim
    real(kind=DP) :: length
    real(kind=DP), pointer :: rindex(:,:) !(3,ndim)
  end type
  integer :: mp_index(3)
  real(kind=DP) :: kshift(3)

  integer :: itrs = ON

! ==================================== added by K. Tagami ==================== 12.0A
  character(len("gen_tetramesh_mode")), private,parameter :: &
       &                 tag_gen_tetramesh_mode    = "gen_tetramesh_mode"
  integer :: gen_tetramesh_mode = 0
!
!!  character(len("use_altv_rltv")), private,parameter :: &
 !!      &                 tag_use_altv_rltv    = "use_altv_rltv"
!!!  integer :: sw_use_altv_rltv = ON
!!!  logical :: use_altv_rltv = .true.
! ============================================================================ 12.0A

! ==================================== added by K. Tagami ==================== 11.0P
  character(len("use_op_before_sym_reduction")),private,parameter ::  &
       &         tag_use_op_before_sym_reduction = "use_op_before_sym_reduction"
  logical :: use_op_before_sym_reduction = .false.
  integer :: sw_use_op_before_sym_reduction = OFF
! ============================================================================ 11.0P

! === KT_add ==== 2014/09/30
  integer :: kv3_fbz
  integer, allocatable :: to_ibz_from_fbz_for_kpoint(:)
  real(kind=DP), allocatable :: vkxyz_fbz(:,:,:) ! d(kv3_fbz,3,CRDTYP)
!
  integer :: max_num_star_of_k
  integer, allocatable :: iopr_k_fbz_to_ibz(:)
  integer, allocatable :: trev_k_fbz_to_ibz(:)
  integer, allocatable :: num_star_of_k(:)
  integer, allocatable :: star_of_k(:,:)
! =============== 2014/09/30

! ==== ASMS ==== 2018/02/19
  integer :: nopr_from_fbz_to_ibz
  integer, allocatable :: flg_opr_from_fbz_to_ibz(:)
! ==== ASMS ==== 2018/02/19

  character(len("fix_ibz_on_fbz_mesh")),private,parameter :: &
       &  tag_fix_ibz_on_fbz_mesh  = "fix_ibz_on_fbz_mesh"
  integer :: sw_fix_ibz_on_fbz_mesh = OFF

! === unfolding ===
  real(kind=DP), allocatable :: vkxyz_refcell(:,:,:) ! d(kv3,3,CRDTYP)
! === unfolding ===

  character(len("sw_force_kpt_inside_bz")),private,parameter :: &
       &  tag_sw_force_kpt_inside_bz = "sw_force_kpt_inside_bz"
  integer :: sw_force_kpt_inside_bz = OFF
  integer, allocatable :: GvecTrans_kpt(:,:)
  integer, allocatable :: GvecTrans_kpt_ek(:,:)

! === Fast Monk-horst Pack
  character(len("segmentation")),private,parameter :: &
       &  tag_segmentation = "segmentation"
  character(len("sw_kpt_segmentation")),private,parameter :: &
       &  tag_sw_kpt_segmentation = "sw_kpt_segmentation"
  character(len("kpt_save_memory_mode")),private,parameter :: &
       &  tag_kpt_save_memory_mode = "kpt_save_memory_mode"
  integer :: sw_kpt_segmentation = OFF
  integer :: ndiv_segment(3)
  integer :: kpt_save_memory_mode = 1

contains

  subroutine alloc_kxyzweight(na)
    integer, intent(in) :: na
    allocate(kx_t(na)); allocate(ky_t(na));allocate(kz_t(na));allocate(weight_t(na))
  end subroutine alloc_kxyzweight

  subroutine dealloc_kxyzweight()
    if(allocated(kx_t)) deallocate(kx_t)
    if(allocated(ky_t)) deallocate(ky_t)
    if(allocated(kz_t)) deallocate(kz_t)
    if(allocated(weight_t)) deallocate(weight_t)
  end subroutine dealloc_kxyzweight

  subroutine m_Kp_sample_mesh(kmesh)
    integer, intent(out), dimension(3) :: kmesh
    kmesh(1:3) = k_sample_mesh(1:3,1)
  end subroutine m_Kp_sample_mesh

  subroutine m_Kp_wd_kv3(nfcntn)
    integer, intent(in) :: nfcntn
    if(mype==0) then
       write(nfcntn,'(a11)') tag_kv3
       write(nfcntn,'(i10)') kv3
    end if
  end subroutine m_Kp_wd_kv3

  subroutine m_Kp_rd_kv3(nfcntn,nfout)
    integer, intent(in) :: nfcntn,nfout
    logical :: EOF_reach, tag_is_found
    if(mype==0) then
       call rewind_to_tag0(nfcntn,len(tag_kv3),tag_kv3 &
            & , EOF_reach, tag_is_found, str,len_str)
       if(.not.tag_is_found) then
          write(nfout,'(" tag_kv3 is not found")')
       else
          read(nfcntn,*) kv3_previous
       end if
    end if
    if(npes > 1) call mpi_bcast(kv3_previous,1,mpi_integer,0,MPI_CommGroup,ierr)
    if(printable) write(nfout,'(i8, " : kv3_previous_job")') kv3_previous
  end subroutine m_Kp_rd_kv3

  subroutine m_Kp_rd_n(nfout)
    integer, intent(in) :: nfout
    character(len=FMAXVALLEN) :: rstr
    integer :: iret, f_selectBlock, f_getStringValue, f_getIntValue &
            & ,f_getRealValue, f_selectFirstTableLine
    integer :: f_selectParentBlock, f_selectTop
    integer :: sum_weight
    integer :: i,j
    real(kind=DP) :: dret
    logical :: prealloc = .false.
    real(kind=DP), dimension(3) :: rltv_len
    logical :: mesh_block_exists

    if(ipriinputfile >= 2) write(nfout,'(" !**  << m_Kp_rd_n >>")')
    ! --- accuracy ---
    iret = f_selectTop()
    if(icond > 1) then
       base_reduction_for_GAMMA = 0
       base_symmetrization_for_GAMMA = 0
    endif
    if(way_of_smearing == TETRAHEDRON) then
       call m_CtrlP_set_way_ksample(MESH)
    endif
    if( f_selectBlock( tag_accuracy) == 0) then
       if(ipriinputfile >= 2) write(nfout,'(" !** -- tag_accuracy --")')
       if( f_selectBlock(tag_ksampling) == 0) then
         if(f_getRealValue(tag_density,dret,'bohr') == 0) then
            k_density = dret
            write(nfout, '(a,f10.5)') ' !** density of the sampling kpoints',k_density
         endif
         iret = f_selectParentBlock()
       endif
       if(k_density>0)then
          do i=1,3
             rltv_len(i) = 0.d0
             do j=1,3
                rltv_len(i) = rltv_len(i)+rltv(i,j)*rltv(i,j)
             enddo
             rltv_len(i) = dsqrt(rltv_len(i))
             k_sample_mesh(i,1) = int(rltv_len(i)*k_density)
             if(k_sample_mesh(i,1)<1) k_sample_mesh(i,1) = 1
             k_sample_mesh(i,2) = k_sample_mesh(i,1)
          enddo
          mesh_block_exists = .false.
          if( f_selectBlock( tag_ksampling) == 0) then
             if(f_selectBlock(tag_mesh) ==0)then
                iret = f_selectParentBlock()
                mesh_block_exists = .true.
             endif
             iret = f_selectParentBlock()
          endif
          if(.not.mesh_block_exists)then
            if(ipriinputfile>=1) write(nfout,'(a,f10.5,3i8)') &
           & ' !** kmesh density and sampling kmesh resolved from it : ' &
           & , k_density, k_sample_mesh(1:3,1)
          endif
          if(way_ksample == MONKHORST_PACK)then
            do i=1,3
               mp_index(i) = k_sample_mesh(i,1)
            enddo
            kshift(1:3) = 0.5d0   ! default value for cubic system
            if(il == 0) then   ! default value for hexagonal system
               kshift(1:2) = 0.0d0;     kshift(3) = 0.5d0
            end if
          endif
       else
          if(mype==0) write(nfout,'(a,f10.5)') ' !** WARNING : invalid density specification ',k_density
       endif
       if( f_selectBlock( tag_ksampling) == 0) then

          if(icond > 1) base_reduction_for_GAMMA = 0
          if( f_getIntValue(tag_base_reduction_for_GAMMA, iret)==0) then
             base_reduction_for_GAMMA = iret
             if(ipri_kp >= 1) then
                write(nfout,'(" !** base_reduction_for_GAMMA = ",i3 &
                     & ," in tag_ksampling <<m_Kp_rd_n>>")') base_reduction_for_GAMMA
             end if
             if(base_reduction_for_GAMMA < 0 .or. base_reduction_for_GAMMA >1) then
                base_reduction_for_GAMMA = 1
                if(ipri_kp >= 1) write(nfout,'(" !** base_reduction_for_GAMMA = ",i3 &
                     & ," (reset) in tag_ksampling <<m_Kp_rd_n>>")') base_reduction_for_GAMMA
             end if
          else
             if(ipri_kp >= 1) then
                write(nfout,'(" !** base_reduction_for_GAMMA = ",i3 &
                     & ," (=default value) <<m_Kp_rd_n>>")') base_reduction_for_GAMMA
             end if
          end if

          if(icond > 1) base_symmetrization_for_GAMMA = 0
          if( f_getIntValue(tag_base_symmetrization_for_G, iret)==0) then
             base_symmetrization_for_GAMMA = iret
             if(ipri_kp >= 1) then
                write(nfout,'(" !** base_symmetrization_for_GAMMA = ",i3 &
                     & ," in tag_ksampling <<m_Kp_rd_n>>")') base_symmetrization_for_GAMMA
             end if
             if(base_symmetrization_for_GAMMA < 0 .or. base_symmetrization_for_GAMMA >1) then
                base_symmetrization_for_GAMMA = 1
                write(nfout,'(" !** base_symmetrization_for_GAMMA = ",i3 &
                     & ," (reset) in tag_ksampling <<m_Kp_rd_n>>")') base_symmetrization_for_GAMMA
             end if
          else
             if(ipri_kp >= 1) then
                write(nfout,'(" !** base_symmetrization_for_GAMMA = ",i3 &
                     & ," (=default value) <<m_Kp_rd_n>>")') base_symmetrization_for_GAMMA
             end if
          end if

          if ( sw_excitation == ON .or. ( use_metagga .and. vtau_exists ) ) then
             base_reduction_for_GAMMA = off
             base_symmetrization_for_GAMMA = off
             write(nfout,*) "!** base_reduction_for_GAMMA is forced to OFF"
             write(nfout,*) "!** base_symmetrization_for_GAMMA is forced to OFF"
          endif

          if( f_getStringValue( tag_method, rstr, LOWER) == 0) then
             call set_ksamplingmethod(rstr)
             if(way_ksample == MONKHORST_PACK .and. way_of_smearing == TETRAHEDRON) then
               !if(printable) write(nfout,'(a)') ' !** tetrahedral smearing cannot be used in &
               !                       & conjunction with monk sampling. specify mesh instead.'
               call phase_error_with_msg(nfout,' !** tetrahedral smearing cannot be used in &
                                      & conjunction with monk sampling. specify mesh instead.'&
                                      ,__LINE__,__FILE__)
             endif
          else
             if(ipri_kp >= 1) then
                write(nfout,'(" !** a method of sampling is not defined in the accuracy block <<m_Kp_rd_n>>")')
             end if
          end if
          if( way_ksample == MESH ) then
             if( f_selectBlock( tag_mesh) == 0) then
                if( f_getIntValue( tag_nx, iret) == 0) k_sample_mesh(1,1) = iret
                if( f_getIntValue( tag_ny, iret) == 0) k_sample_mesh(2,1) = iret
                if( f_getIntValue( tag_nz, iret) == 0) k_sample_mesh(3,1) = iret
                k_sample_mesh(:,2) = k_sample_mesh(:,1)
                iret = f_selectParentBlock()
             else
!!                k_sample_mesh(1:3,1) = 4   ! default value
             end if

! ================================ added by K. Tagami ======================== 12.0A
!             if( f_getIntValue( tag_use_altv_rltv, iret) == 0 ) then
!                sw_use_altv_rltv = iret
!             endif
!             if ( sw_use_altv_rltv == ON ) then
!                use_altv_rltv = .true.
!             else
!                use_altv_rltv = .false.
!             endif             ! ---- judgement is moved to m_Crystal_Structre.F90

             if( f_getIntValue( tag_gen_tetramesh_mode, iret) == 0 ) then
                if ( iret == 0 .or. iret == 1  ) then
                   gen_tetramesh_mode = iret
                endif
             endif

! === KT 2018/03/07
             if ( use_altv_rltv ) gen_tetramesh_mode = 1
! === KT 2018/03/07

             write(nfout,*) '!************************************ '
             write(nfout,*) '!** gen_tetramesh_mode is set to ', gen_tetramesh_mode
!!             write(nfout,*) '!** use_altv_rltv is set to ', use_altv_rltv
             write(nfout,*) '!************************************ '

!
             if ( noncol ) then
                write(*,*) '***** Caution *****'
                write(*,*) 'In noncollinear systems "method = mesh" is experimental '
             endif
!
             if( f_getIntValue( tag_use_trs, iret) == 0) then
                itrs = iret
             else
                itrs = OFF       ! for consistency with previous programs
             endif
! ----------
             if ( noncol ) then
                if ( sw_neglect_magmom == OFF ) itrs = OFF
!                itrs = OFF
             else
                if ( imag /= PARA ) itrs = OFF
             endif
! ----------
! ================================================================== 12.0A
             if ( sw_write_bxsf_file == ON ) then
                if ( nopr > 1 ) call phase_error_with_msg(nfout," kpoint = mesh is not supported when nopr > 1",__LINE__,__FILE__)
             endif

           else if( way_ksample == MONKHORST_PACK ) then
              if( f_selectBlock( tag_mp_index) == 0) then
                 if( f_getIntValue( tag_n1, iret) == 0) mp_index(1) = iret
                 if( f_getIntValue( tag_n2, iret) == 0) mp_index(2) = iret
                 if( f_getIntValue( tag_n3, iret) == 0) mp_index(3) = iret
                 iret = f_selectParentBlock()
              else if( f_selectBlock( tag_mesh) == 0) then
                 if( f_getIntValue( tag_nx, iret) == 0) mp_index(1) = iret
                 if( f_getIntValue( tag_ny, iret) == 0) mp_index(2) = iret
                 if( f_getIntValue( tag_nz, iret) == 0) mp_index(3) = iret
                 iret = f_selectParentBlock()
              else
                 !!$ mp_index(1:3) = 4   ! default value
                 continue
              end if

              kshift(1:3) = 0.5d0   ! default value for cubic system
              if(il == 0) then   ! default value for hexagonal system
                 kshift(1:2) = 0.0d0;     kshift(3) = 0.5d0
              end if
              if( f_selectBlock( tag_kshift) == 0) then
                 if( f_getRealValue( tag_k1, dret, '' ) == 0) kshift(1) = dret
                 if( f_getRealValue( tag_k2, dret, '' ) == 0) kshift(2) = dret
                 if( f_getRealValue( tag_k3, dret, '' ) == 0) kshift(3) = dret
                 iret = f_selectParentBlock()
              end if

              if ( sw_excitation == ON .or. sw_write_bxsf_file == ON ) then
                 kshift = 0.0d0
                 write(nfout,*) "!** kshift is forced to 0.0"
              endif

              if( f_getIntValue( tag_use_trs, iret) == 0) then
                 itrs = iret
              else
                 if ( noncol ) itrs = OFF
              endif
! ----------
              if ( noncol ) then
                 if ( sw_neglect_magmom == OFF ) itrs = OFF
!                 itrs = OFF
              else
                 if ( imag /= PARA ) itrs = OFF
              endif
! ----------
! ==== ASMS ===
              if( f_getIntValue( tag_fix_ibz_on_fbz_mesh, iret) == 0) then
                 sw_fix_ibz_on_fbz_mesh = iret
                 write(nfout,*) "!** sw_fix_ibz_on_fbz_mesh is set to ", iret
              endif
! ==== ASMS ===

              if( f_selectBlock( tag_segmentation) == 0) then
                 if( f_getIntValue( tag_sw_kpt_segmentation, iret) == 0 ) then
                    sw_kpt_segmentation = iret
                    write(nfout,*) "!** sw_kpt_segmentation is set to ", iret
                 endif
                 if( f_getIntValue( tag_kpt_save_memory_mode, iret) == 0 ) then
                    kpt_save_memory_mode = iret
                    write(nfout,*) "!** kpt_save_memory_mode set to ", iret
                 endif
                 ndiv_segment(1:3) = mp_index(1:3)
                 if( f_getRealValue( tag_nx, dret, '' ) == 0) ndiv_segment(1) = dret
                 if( f_getRealValue( tag_ny, dret, '' ) == 0) ndiv_segment(2) = dret
                 if( f_getRealValue( tag_nz, dret, '' ) == 0) ndiv_segment(3) = dret
                 iret = f_selectParentBlock()
              end if

              if( f_getIntValue( tag_use_op_before_sym_reduction, iret) == 0 ) then
                 sw_use_op_before_sym_reduction = iret
              endif
              if ( sw_use_op_before_sym_reduction == ON ) then
                 use_op_before_sym_reduction = .true.
              else
                 use_op_before_sym_reduction = .false.
              endif
              if(ipri_kp >= 1) then
                 write(nfout,'("<< Monkhorst-Pack scheme")')
                 write(nfout,'(" MP index:",3(1x,i3))') mp_index(1:3)
                 write(nfout,'(" kp shift:",3(1x,f10.5))') kshift(1:3)
                 write(nfout,'(" il = ",i3)') il
                 write(nfout,'(" use_trs = ",i3)') itrs

                 if ( noncol ) then
                    write(nfout,*) "use_op_before_sym_reduction = ", &
                         &            use_op_before_sym_reduction
                 endif

                 write(nfout,'("   Monkhorst-Pack scheme >>")')
              end if

              do i=1,3
                if(mp_index(i) > 100) then
                   if(printable) then
                      write(nfout,*)  &
                           & 'Monkhorst-Pack: found a bad parameter'
                      write(nfout,*)  &
                           & '#### Use Monknorst-Pack indeces less than 101. ###'
                   end if
                   call phase_error_with_msg(nfout,'Monkhorst-Pack: found a bad parameter',__LINE__,__FILE__)
                end if
              end do

           else if( way_ksample == FILE ) then
              if( f_getIntValue( tag_sw_force_kpt_inside_bz, iret) == 0) then
                 sw_force_kpt_inside_bz = iret
                 write(nfout,*) "!** sw_force_kpt_inside_bz is set to ", iret
              endif

           else if( way_ksample == SKPS_DIRECT_IN ) then
             sum_weight = 0
             if( f_getIntValue( tag_sum_weight,  iret) == 0) sum_weight = iret
             if( f_getIntValue( tag_num_kpoints, iret) == 0) then
                kv3_t = iret
                if(kv3_t <= 0) call phase_error_with_msg(nfout,' kv3 is not positive value << m_Kp_rd_n >>',__LINE__,__FILE__)
             else
                prealloc = .true.
                call set_kxyz(prealloc,iret)
                kv3_t = iret
                if(ipriinputfile >= 3) write(nfout,'(" !* kv3_t = ",i6," <<m_Kp_rd_n>>")') kv3_t
             end if
             prealloc = .false.
             call alloc_kxyzweight(kv3_t)
             call set_kxyz(prealloc,iret)
          end if
          iret = f_selectParentBlock()
       end if
       iret = f_selectParentBlock()
    end if
    if(way_ksample == MESH) then
!!$       if(ipriinputfile >= 1) write(nfout,'(" !** k-point sampling method = ",i6)') way_ksample
       if(ipriinputfile >= 1) write(nfout,'(" !** k_sample_mesh = ",3i6)') k_sample_mesh(1:3,1)
    end if
  contains
    subroutine set_kxyz(prealloc,iret)
      logical, intent(in) ::  prealloc
      integer, intent(out)::  iret
      integer :: i, f_readKPoints, f_selectFirstTableLine, f_selectNextTableLine
      real(kind=DP),dimension(3) :: kvec
      integer ::              weight, sum
      if( f_selectBlock(tag_kpoints) == 0) then
         sum = 0
         i = 1
         do while(.true.)
            if( i == 1 ) then
               if( f_selectFirstTableLine() /= 0 ) then
                  exit
               end if
            else
               if( f_selectNextTableLine() /= 0 ) then
                  exit
               end if
            end if
            iret = f_readKPoints( tag_kx,tag_ky,tag_kz,tag_denom,tag_weight &
                 & ,kvec, weight )
!!$            print '(f8.4, f8.4, f8.4, I3)', kvec(1),  kvec(2), kvec(3), weight
            if(.not.prealloc) then
               if(i > kv3_t) exit
               if(weight < 1.d-13) weight = 1
               sum = sum + weight
               kx_t(i) = kvec(1); ky_t(i) = kvec(2); kz_t(i) = kvec(3)
               weight_t(i) = weight
            end if
            i = i+1
         end do
         if(ipriinputfile >= 3) write(nfout,'(" !*  weight-sum = ", i6)') sum
         if(.not.prealloc .and. sum_weight /= 0) then
            if(sum_weight /= sum) then
               if(printable) write(nfout,'(" !* Given sum_weight is not equal to summed weight")')
            end if
         end if
         if(.not.prealloc) weight_t = weight_t/dble(sum)
         iret = f_selectParentBlock()
      else
         call phase_error_with_msg(nfout,' ! No kpoints is given in the inputfile <<m_Kp_rd_n>>',__LINE__,__FILE__)
      end if
      if(prealloc) iret = i-1
      if(.not.prealloc) then
         if(ipriinputfile >= 2) then
            do i = 1, kv3_t
               write(nfout,'(" !* i = ",i6," kvxyz,weight = ",4f8.4)') i,kx_t(i),ky_t(i),kz_t(i),weight_t(i)
            end do
         end if
      end if
    end subroutine set_kxyz

    subroutine set_ksamplingmethod(rstr)
      character(len=FMAXVALLEN),intent(in) :: rstr
      logical :: tf
      integer :: ksamp
      ksamp = MONKHORST_PACK
      if(way_of_smearing == TETRAHEDRON) then
         call m_CtrlP_set_way_ksample(MESH)
      endif
      call strncmp0(tag_monkhorst_pack, trim(rstr), tf)
      if(tf) then
         ksamp = MONKHORST_PACK
         goto 1001
      end if
      call strncmp0(tag_mesh, trim(rstr), tf)
      if(tf) then
         ksamp = MESH
         goto 1001
      end if
      call strncmp0(tag_file, trim(rstr), tf)
      if(tf) then
         ksamp = FILE
         goto 1001
      end if
      call strncmp0(tag_gamma,trim(rstr),tf)
      if(tf) then
         ksamp = GAMMA
         goto 1001
      end if
      call strncmp0(tag_directin, trim(rstr),tf)
      if(tf) then
         ksamp = SKPS_DIRECT_IN
         goto 1001
      end if
      call phase_error_with_msg(nfout,' ! tag for ksampling is invalid <<m_Kp_rd_n.set_ksamplingmethod>>',__LINE__,__FILE__)
1001  continue
      if(ipri_kp>= 2) write(nfout,'(" !** ksampling method = ",a14)') trim(rstr)
      call m_CtrlP_set_way_ksample(ksamp)
    end subroutine set_ksamplingmethod
  end subroutine m_Kp_rd_n

  subroutine m_Kp_alloc_kpoints()
    if(.not.allocated(vkxyz)) then
       allocate(vkxyz(kv3,3,CRDTYP)); vkxyz = 0.d0
       if(ipri_kp >= 2) then
          write(nfout,'(" !kp vkxyz is allocated now <<m_Kp_alloc_kpoints>>")')
          write(nfout,'(" !kp kv3 = ", i8," CRDTYP = ",i3)') kv3,CRDTYP
       end if
    else
       if(ipri_kp >= 2) write(nfout,'(" !kp vkxyz is already allocated <<m_Kp_alloc_kpoints>>")')
    end if
    if(.not.allocated(qwgt)) then
       allocate(qwgt(kv3))
       if(ipri_kp >= 2) write(nfout,'(" !kp qwgt is allocated now <<m_Kp_alloc_kpoints>>")')
       qwgt = 1.d0
    else
       if(ipri_kp >= 2) write(nfout,'(" !kp qwgt is already allocated <<m_Kp_alloc_kpoints>>")')
    end if
    if(.not.allocated(k_symmetry)) then
       if(ekmode==OFF .or. kv3_ek==0) then
           allocate(k_symmetry(kv3)); k_symmetry = 0
       else
           allocate(k_symmetry(kv3_ek)); k_symmetry = 0
       endif
       if(ipri_kp >= 2) then
          write(nfout,'(" !kp k_symmetry is allocated now <<m_Kp_alloc_symmetry>>")')
       end if
    else
       if(ipri_kp >= 2) write(nfout,'(" !kp k_symmetry is already allocated <<m_Kp_alloc_kpoints>>")')
    end if

! === KT_add === 2014/09/30
!    write(*,*) "kv3_fbz = ", kv3_fbz, kv3
    if ( .not. allocated(vkxyz_fbz) ) allocate(vkxyz_fbz(kv3_fbz,3,CRDTYP))
    if ( .not. allocated(to_ibz_from_fbz_for_kpoint) ) then
       allocate( to_ibz_from_fbz_for_kpoint(kv3_fbz) )
    endif
! ============== 2014/09/30
    if ( sw_band_unfolding == ON ) then
       if ( .not. allocated(vkxyz_refcell) ) allocate(vkxyz_refcell(kv3,3,CRDTYP) )
    endif
    if ( sw_force_kpt_inside_bz == ON ) then
       if ( .not. allocated(GvecTrans_kpt) ) allocate(GvecTrans_kpt(kv3,3) )
    endif

  end subroutine m_Kp_alloc_kpoints

  subroutine m_Kp_alloc_kpoints_ek()
    kv3_ek = kv3
    if(.not.allocated(vkxyz_ek)) allocate(vkxyz_ek(kv3_ek,3,CRDTYP))
    if(.not.allocated(qwgt_ek))  allocate(qwgt_ek(kv3_ek))
    if ( sw_force_kpt_inside_bz == ON ) then
       if ( .not. allocated(GvecTrans_kpt_ek) ) then
          allocate(GvecTrans_kpt_ek(kv3_ek,3) )
       endif
    endif
    if(allocated(k_symmetry)) then
      deallocate(k_symmetry)
    endif
    allocate(k_symmetry(kv3_ek));k_symmetry = 0
  end subroutine m_Kp_alloc_kpoints_ek

  subroutine m_Kp_cp_vkxyz_to_vkxyz_ek()
    vkxyz_ek = vkxyz
    qwgt_ek  = qwgt
    if ( sw_force_kpt_inside_bz == ON ) then
       GvecTrans_kpt_ek = GvecTrans_kpt
    endif
  end subroutine m_Kp_cp_vkxyz_to_vkxyz_ek

  subroutine m_Kp_cp_vkxyz_ek_to_vkxyz(nk)
    integer, intent(in) :: nk
    integer :: i, kvt, nks, is, kv3t, ikt
    if(ipri_kp >= 1) write(nfout,'(" !kp nk, kv3, kv3_ek = ",3i6)') nk, kv3, kv3_ek
    if(nk+kv3-1 > kv3_ek) then
       if(fixed_charge_k_parallel /= ONE_BY_ONE) &
            & call phase_error_with_msg(nfout,' nk is illegal (m_Kp_cp_vkxyz_ek_to_vkxyz)',__LINE__,__FILE__)
    end if

    if(sw_modified_kpoint_increment == ON)then
       do i=0,nrank_k-1
          do is=1,nspin
             ikt = nspin*(nis_kv3_ek(i)-1)+(nkgroup-1)*nspin+is
             if(ikt>kv3_ek) ikt = kv3_ek
             vkxyz(i*nspin+is,1:3,1:CRDTYP) = vkxyz_ek(ikt,1:3,1:CRDTYP)
             qwgt(i*nspin+is) = qwgt_ek(ikt)
          enddo
       enddo
    else
       if(fixed_charge_k_parallel == ONE_BY_ONE .and. nk+kv3-1 > kv3_ek) then
          kvt = kv3_ek - nk + 1
          vkxyz(1:kvt,1:3,1:CRDTYP) = vkxyz_ek(nk:kv3_ek,1:3,1:CRDTYP)
          qwgt(1:kvt) = qwgt_ek(nk:kv3_ek-1)

          if ( sw_force_kpt_inside_bz == ON ) then
             GVecTrans_kpt(1:kvt,1:3) = GvecTrans_kpt_ek(nk:kv3_ek,1:3)
          endif
          do i = kvt+1, kv3
             vkxyz(i,1:3,1:CRDTYP) = vkxyz_ek(kv3_ek,1:3,1:CRDTYP)
             qwgt(i) = qwgt_ek(kv3_ek)
             if ( sw_force_kpt_inside_bz == ON ) then
                GVecTrans_kpt(i,1:3) = GvecTrans_kpt_ek(kv3_ek,1:3)
             endif
          end do
       else
          vkxyz(1:kv3,1:3,1:CRDTYP) = vkxyz_ek(nk:nk+kv3-1,1:3,1:CRDTYP)
          qwgt(1:kv3) = qwgt_ek(nk:nk+kv3-1)
          if ( sw_force_kpt_inside_bz == ON ) then
             GVecTrans_kpt(i,1:3) = GvecTrans_kpt_ek(kv3_ek,1:3)
          endif
       endif
    end if

    if(kimg == 2) then
       if(base_reduction_for_GAMMA == ON) then
          do i = 1, kv3
             if(vkxyz(i,1,1)**2 + vkxyz(i,2,1)**2 + vkxyz(i,3,1)**2 < DELTA) then
                k_symmetry(i) = GAMMA
             else
                k_symmetry(i) = 0
             end if
          end do
       else if(base_reduction_for_GAMMA == OFF .and. base_symmetrization_for_GAMMA == ON) then
          do i = 1, kv3
             if(vkxyz(i,1,1)**2 + vkxyz(i,2,1)**2 + vkxyz(i,3,1)**2 < DELTA) then
                k_symmetry(i) = GAMMA_base_symmetrization
             else
                k_symmetry(i) = 0
             end if
          end do
       end if
    else
       do i = 1, kv3
          k_symmetry(i) = 0
       end do
    end if

! ================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
       write(nfout,*) '!----- '
       write(nfout,*) '! k_symmetry is forced to 0 in the non-collinear system'
       write(nfout,*) '!----- '
       k_symmetry(:) = 0
    endif
! ===================================================================== 11.0

    if(ipri_kp >= 1) then
       do i = 1, kv3
          if(k_symmetry(i) == GAMMA) then
             write(nfout,'(" !kp ",i6, 6f8.4, " GAMMA")') &
                  & i, vkxyz(i,1:3,CARTS), vkxyz(i,1:3,BUCS)
          else
             write(nfout,'(" !kp ",i6, 6f8.4)') &
                  & i, vkxyz(i,1:3,CARTS), vkxyz(i,1:3,BUCS)
          end if
       end do
    end if
  end subroutine m_Kp_cp_vkxyz_ek_to_vkxyz

  subroutine m_Kp_set_ek_group()
! ============================== modified by K. Tagami =========== 11.0
!    if(nspin == 1) then
!       ek_group = ceiling(dble(kv3_ek)/nrank_k)
!    else
!       ek_group = ceiling(dble(kv3_ek/nspin)/nrank_k)*nspin
!    end if
!    kv3 = nrank_k*nspin
!
    if ( noncol ) then
      ek_group = ceiling(dble(kv3_ek/ndim_spinor)/nrank_k)*ndim_spinor
      kv3 = nrank_k *ndim_spinor
    else
      if(nspin == 1) then
         ek_group = ceiling(dble(kv3_ek)/nrank_k)
      else
         ek_group = ceiling(dble(kv3_ek/nspin)/nrank_k)*nspin
      end if
      kv3 = nrank_k *nspin
    endif
! ================================================================ 11.0

    if(ipri_kp >=1 ) then
       write(nfout,'(" !kp ek_group = ",i8)') ek_group
       write(nfout,'(" !kp kv3_ek   = ",i8)') kv3_ek
       write(nfout,'(" !kp kv3      = ",i8)') kv3
    end if
  end subroutine m_Kp_set_ek_group

  subroutine m_Kp_realloc_kpoints2()
    if(allocated(vkxyz)) deallocate(vkxyz)
    if(allocated(qwgt))  deallocate(qwgt)
    if(allocated(k_symmetry)) deallocate(k_symmetry)
    call m_Kp_alloc_kpoints()
  end subroutine m_Kp_realloc_kpoints2

  subroutine m_Kp_realloc_kpoints()
! ================================ modified by K. Tagami ========== 11.0
!    kv3 = nspin
!
    if ( noncol ) then
       kv3 = ndim_spinor
    else
       kv3 = nspin
    endif
! ================================================================= 11.0

    if(allocated(vkxyz)) deallocate(vkxyz)
    if(allocated(qwgt))  deallocate(qwgt)
    if(allocated(k_symmetry)) deallocate(k_symmetry)

! === KT_add === 2014/09/30
    if ( allocated(vkxyz_fbz) ) deallocate(vkxyz_fbz)
    if ( allocated(to_ibz_from_fbz_for_kpoint) ) deallocate(to_ibz_from_fbz_for_kpoint)
! ============== 2014/09/30
    if ( sw_force_kpt_inside_bz == ON ) then
       if ( allocated(GvecTrans_kpt) ) deallocate(GvecTrans_kpt)
    endif
    if ( sw_band_unfolding == ON ) then
       if ( allocated(vkxyz_refcell) ) deallocate(vkxyz_refcell)
    endif

    call m_Kp_alloc_kpoints()

  end subroutine m_Kp_realloc_kpoints

  subroutine m_Kp_rd_way_ksample_etc(nfinp,nlines)
    integer, intent(in) :: nfinp,nlines
    integer, parameter  :: NWK = 6
    integer             :: natm0, ntyp0
    allocate(work(NWK,1))

    if(npes >= 2) call mpi_barrier(MPI_CommGroup,ierr)
    rewind nfinp
    if(ipri_kp >= 2) write(nfout,'(" <<< m_Kp_rd_way_ksample_etc >>>")')
!       ==========================
    call read_natm_ntyp          ! -> natm0, ntyp0
    if(ipri_kp >= 2) then
       write(nfout,'(" !kp nlines+14+natm0+ntyp0 = ",i8)') nlines+14+natm0+ntyp0
       write(nfout,'(" !kp ntyp0, natm0 = ",2i8)') ntyp0, natm0
    end if
    call skip_lines(nfinp,nlines+14+natm0+ntyp0)
    call read_way_ksample_etc    ! -> way_ksample, k_sample_mesh
!       ==========================
    deallocate(work)
  contains
    subroutine read_natm_ntyp
      integer nsize
      read(nfinp,'(a132)') str
      call chnnm(str,len_str,4,work,nsize)
      ntyp0 = nint(work(3,1))
      natm0 = nint(work(4,1))
    end subroutine read_natm_ntyp

    subroutine read_way_ksample_etc
      integer :: i, ikpnt, sw_k_coord_system
      integer :: ksamp
      read(nfinp,'(a132)') str
      if(ipri_kp >= 2) write(nfout,'(a132)') str
      call ch4ksample(str,len_str,ksamp)
      if(ksamp == NONAME .or. ksamp == MESH) then
         if(ksamp == NONAME) then
            read(str,*) (k_sample_mesh(i,1), i=1,3)
            ksamp = MESH
         else
            read(nfinp,*) (k_sample_mesh(i,1),i=1,3)
         endif
         if(ipri_kp>=1) write(nfout,680) (k_sample_mesh(i,1),i=1,3)
         read(nfinp,*) (k_sample_mesh(i,2),i=1,3)
         if(ipri_kp>=1) write(nfout,690) (k_sample_mesh(i,2),i=1,3)
         if(k_sample_mesh(1,1) == 0  &
              & .or.(     k_sample_mesh(1,2) == 0 &
              &     .and. k_sample_mesh(2,2) == 0 &
              &     .and. k_sample_mesh(3,2) == 0)) &
              &  ksamp = GAMMA
      else if(ksamp.eq.SKPS_DIRECT_IN) then
         if(ipri_kp>=1) write(nfout,'(" ! way_ksample = SKPS_DIRECT_IN")')
         read(nfinp,'(a132)') str
         if(ipri_kp>=2) write(nfout,'(" ! str : ",a50)') str(1:50)
         call read_nkpnt(str,len_str,ikpnt) !-(b_Kpoints)
         if(ipri_kp>=2) write(nfout,'(" ! ikpnt(#skipped lines) = ",i8)') ikpnt
         read(nfinp,'(a132)') str
         call read_coordsystem(str,len_str,sw_k_coord_system) !-(b_Kpoints)
         if(sw_k_coord_system == NODATA) ikpnt = ikpnt - 1
         call skip_lines(nfinp,ikpnt)      !-(bottom_Subroutines)
!         call read_konly
!     >        (nfinp,nfout,knv3,altv,rltv,nspin
!     <        ,kv3,vkxyz,qwgt,wka)
      else if(ksamp == FILE) then
         if(ipri_kp>=1) write(nfout,'(" ! way_ksample = FILE")')
         call skip_lines(nfinp,2)
      else if(ksamp == MONKHORST_PACK) then
         if(ipri_kp>=1) write(nfout,'(" ! way_ksample = MONKHORST_PACK")')
         call read_mpindex(nfinp) !-(b_SpeicalKpints)
      endif

      call m_CtrlP_set_way_ksample(ksamp)
680   format(' ',3i6,'   : nkx, nky, nkz ')
690   format(' ',3i6,'   : nkx2,nky2,nkz2')
    end subroutine read_way_ksample_etc
  end subroutine m_Kp_rd_way_ksample_etc

  subroutine m_Kp_gnrt_or_rd_k_points(nfinp,preallocation)
    ! -> kv3(when preallocation == .true.), kv3,vkxyz,qwgt(when preallocation == .flase.)
    external kpmsf0, kpmwbz0, sccm0, bccm0, fccm0, hexm0
    integer, intent(in)      :: nfinp
    logical, intent(in)      :: preallocation
    integer                  :: knv3_t, id_sname = -1, i, kv3_adj, j
    integer :: knv3_t_fbz
    call tstatc0_begin('m_Kp_gnrt_or_rd_k_points ', id_sname)

    if(ipri_kp >= 2) then
       write(nfout,'(" !kpgnrt way_ksample = ",i6)') way_ksample
       write(nfout,'(" !kpgnrt nbztyp      = ",i6)') nbztyp
       write(nfout,'(" !kpgnrt nbztyp_spg  = ",i6)') nbztyp_spg
    end if

    if(preallocation) then
       allocate(vkxyz(1,1,1))
       allocate(qwgt(1))
       allocate(vkxyz_fbz(1,1,1))
       allocate(to_ibz_from_fbz_for_kpoint(1))
    end if

    knv3_t = kv3;  knv3_t_fbz = kv3_fbz

    if(sw_berry_phase == 1) then
       continue

    else if(way_ksample == GAMMA) then
       call gen_gamma_p0(preallocation,knv3_t,kv3,vkxyz,qwgt)  !-(b_Kpoints)

       if ( preallocation ) then
          kv3_fbz = kv3
       else
          kv3_fbz = kv3_fbz /nspin
          vkxyz_fbz = vkxyz
          to_ibz_from_fbz_for_kpoint = 1
       endif

    else if(way_ksample == FILE) then
       call m_Files_open_kpoint_files(way_ksample,nbztyp_spg)
       if ( sw_band_unfolding == OFF ) then
          call readk0(preallocation,nfout,ipri_kp,knv3_t,rltv,nfkpoint,nfmatbp&
               &,kv3,vkxyz,qwgt) !-(b_Kpoints)
       else
          call readk0(preallocation,nfout,ipri_kp,knv3_t,rltv_refcell,nfkpoint,nfmatbp&
               &,kv3,vkxyz_refcell,qwgt) !-(b_Kpoints)
          call readk0_for_band_unfolding( preallocation, nfout, ipri_kp, knv3_t, &
               &                          rltv_refcell, altv,&
               &                          nfkpoint, nfmatbp, kv3, vkxyz, qwgt )
       endif

       if(ipriinputfile >= 2 .and. .not.preallocation) then
          do i=1, kv3
             write(nfout,'(" !** id, vkxyz, qwgt = ",i6,4f8.4," << m_Kp_gnrt_or_rd_k_points>>")') &
                  & i,vkxyz(i,1,CARTS),vkxyz(i,2,CARTS),vkxyz(i,3,CARTS),qwgt(i)
          end do
       end if
    else if(way_ksample == SKPS_DIRECT_IN) then
       if(ipri_kp>=2) write(nfout,'(" !kp kv3_t = ", i6)') kv3_t
       if(kv3_t > 0) then  ! directin from inputfile in new format style
          kv3 = kv3_t
          if(preallocation) then
             if(ipriinputfile >= 2) then
                do i=1, kv3_t
                   write(nfout,'(" !** id,kx_t,ky_t,kz_t,weight_t = " &
                        &    ,i6,4f8.4," <<m_Kp_gnrt_or_rd_k_points>>")') &
                        & i,kx_t(i),ky_t(i),kz_t(i),weight_t(i)
                end do
             end if
          else
             kv3_adj = ubound(vkxyz,1)-lbound(vkxyz,1) + 1
             call set_kfromtemporaryarray(nfout,ipri,nfmatbp,kv3_adj,kv3_t,kx_t,ky_t,kz_t,weight_t &
                  &   ,rltv,vkxyz,qwgt)
!!$             call dealloc_kxyzweight()
             if(ipriinputfile >= 2) then
                do i=1, kv3
                   write(nfout,'(" !** id, vkxyz, qwgt = ",i6,4f8.4," << m_Kp_gnrt_or_rd_k_points>>")') &
                        & i,vkxyz(i,1,CARTS),vkxyz(i,2,CARTS),vkxyz(i,3,CARTS),qwgt(i)
                end do
             end if
          end if
       else
          call read_konly(preallocation,nfinp,nfout,knv3_t &
               & ,altv,rltv,kv3,vkxyz,qwgt,str,len_str)
       end if

    else if(way_ksample == MONKHORST_PACK) then

       call gen_special_kpoints( preallocation, nfout, ipri, knv3_t, &
            &                    nfmatbp, kv3, vkxyz, qwgt, imag, itrs, &
            &                    kv3_fbz, vkxyz_fbz, to_ibz_from_fbz_for_kpoint )

    else if( nbztyp == GENERAL .or. nbztyp == GENERAL_LARGER) then
       ipri_kp_t = ipri_kp*(1-ipri_kp_count)
       if(ipri_kp_count == 0) ipri_kp_count = 1


! ======================================= modified by K. Tagami =========== 12.0A
!       call gnrt_k0_n( il, ngen, inv, igen, jgen, a, b, c, ca, cb, cc, &
!            &          nbztyp_spg, &
!            &          k_sample_mesh(1,1),k_sample_mesh(2,1),k_sample_mesh(3,1), &
!            &          preallocation, nfout, ipri, knv3_t, rltv, &
!            &          kv3, vkxyz, qwgt, ipri_kp_t, trmat )
!                                                               !-(b_Kpoints)
!
       call gnrt_k0_n( il, ngen, inv, igen, jgen, a, b, c, ca, cb, cc, &
            &          nbztyp_spg, &
            &          k_sample_mesh(1,1),k_sample_mesh(2,1),k_sample_mesh(3,1), &
            &          preallocation, nfout, ipri, knv3_t, rltv, &
            &          kv3, vkxyz, qwgt, ipri_kp_t, trmat, &
            &          gen_tetramesh_mode, use_altv_rltv, altv, itrs, &
            &          gen_name_in_carts, &
            &          knv3_t_fbz, kv3_fbz, vkxyz_fbz, to_ibz_from_fbz_for_kpoint )
                                                         !-(b_Kpoints)
       if(ipri_kp_t >= 1) then
          write(nfout,'(" << trmat >>")')
          write(nfout,'(3f8.4)') ((trmat(i,j),j=1,3),i=1,3)
       end if
!        === modified by T. Y. 2015/01/16 ===
!!$       call gen_kpoint_in_full_BZ( preallocation, kv3_fbz, vkxyz_fbz )
       call gen_kpoint_in_full_BZ( preallocation )
!        ====================================
! ========================================================================= 12.0A

    else if(way_ksample == MESH) then

       if(ipri_kp>=1) call wd_k_sample_mesh          !-(contained here) k_sample_mesh->
       BZtype: select case(nbztyp)
       case (SURFACE, C2v_SURFACE, Csy_SURFACE)
          call call_k_generator(kpmsf0)
       case (WHOLE_BZ, ORTHORHOMBIC, RUTILE)
          call call_k_generator(kpmwbz0)
       case (SIMPLE_CUBIC)
          call call_k_generator(sccm0)
       case (BCC)
          call call_k_generator(bccm0)
       case (FCC, DIAMOND)
          call call_k_generator(fccm0)
       case (HEXAGONAL, 9)
          call call_k_generator(hexm0)
!!$          case (HEX1fold,HEX2fold,HEX3fold)
!!$          call kccrdf0(paramset,kv3,nfout,nbztyp,nfkpoint,nfmatbp &
!!$               &,vkxyz,qwgt,kv3)
       end select BZtype

    endif

! ==================================== modified by K. Tagami ======= 11.0
!!!    kv3 = kv3*nspin
!
    if ( noncol ) then             ! non-collinear case
       kv3 = kv3 *ndim_spinor;   kv3_fbz = kv3_fbz *ndim_spinor
    else
       kv3 = kv3 *nspin;         kv3_fbz = kv3_fbz *nspin
    endif
! =================================================================== 11.0

    if(.not.preallocation) then
       if(ipri_kp >= 2 ) write(nfout,*) ' << generate_or_read_k_sampling_points >>'

       if(way_ksample == MESH .and.  m_CtrlP_way_of_smearing() == TETRAHEDRON &
            & .and. nbztyp == WHOLE_BZ )   call change_kpoints_order

! ======================= modified by K. Tagami ================ 11.0
!!!       if(nspin == 2)  call double_k_points
!
       if ( noncol ) then
	  call gen_k_points_noncol
       else
          if ( nspin == 2 )  call double_k_points
       endif
! ========================================================= 11.0

       call k_points_in_BUCS_from_CARTS

       if ( way_ksample == FILE ) then
          if ( sw_force_kpt_inside_bz == ON ) then
             call m_Kp_force_kpoint_into_BZ
          endif
       endif

       call set_k_symmetry()
       if(ipri_kp>=1) call wd_kpoints()
! ==== KT_add === 2014/09/30
       if ( way_ksample == MONKHORST_PACK .or. way_ksample == MESH ) then
          if(ipri_kp>=2) call wd_kpoints_fbz()
       endif
! =============== 2014/09/30
! ==== ASMS ==== 2018/02/26
       if ( charge_symm_mode >= chg_symm_level1 ) then
          call m_Kp_chk_opr_from_fbz_to_ibz
       endif
       if ( charge_symm_mode >= chg_symm_level2 ) then
          call m_Kp_set_star_of_k
       endif
! ==== ASMS ==== 2018/02/26

       if ( way_ksample == FILE .and. sw_band_unfolding == ON ) then
          call wd_kpoints_refcell()
       endif

    else
       if(ipri_kp>=1) write(nfout,'(" !kp kv3 = ",i8, " nspin = ", i5)') kv3,nspin

! ======================= added by K. Tagami ================== 11.0
       if(ipri_kp>=1) write(nfout,*) 'ndim_spinor = ', ndim_spinor
! ============================================================= 11.0
    end if

    if(preallocation) then
       deallocate(vkxyz)
       deallocate(qwgt)
       deallocate(vkxyz_fbz)
       deallocate(to_ibz_from_fbz_for_kpoint)
       if ( sw_force_kpt_inside_bz == ON ) then
          if ( allocated(GvecTrans_kpt) ) deallocate(GvecTrans_kpt)
       endif
    end if

    call tstatc0_end(id_sname)
  contains
    subroutine set_k_symmetry()
      integer :: ik
      if(kimg == 2) then
         if(base_reduction_for_GAMMA == ON) then
            do ik = 1, kv3
               if(vkxyz(ik,1,CARTS)**2 + vkxyz(ik,2,CARTS)**2 &
                    & + vkxyz(ik,3,CARTS)**2 < DELTA) then
                  k_symmetry(ik) = GAMMA
               else
                  k_symmetry(ik) = 0
               end if
            end do
         else if(base_reduction_for_GAMMA == OFF .and. base_symmetrization_for_GAMMA == ON) then
            do ik = 1, kv3
               if(vkxyz(ik,1,CARTS)**2 + vkxyz(ik,2,CARTS)**2 &
                    & + vkxyz(ik,3,CARTS)**2 < DELTA) then
                  k_symmetry(ik) = GAMMA_base_symmetrization
               else
                  k_symmetry(ik) = 0
               end if
            end do
         else
            do ik = 1, kv3
               k_symmetry(ik) = 0
            end do
         end if
      else
         do ik = 1, kv3
            k_symmetry(ik) = 0
         end do
      end if

! ================================== added by K. Tagami =============== 11.0
      if ( noncol ) then
         write(nfout,*) '!----- '
         write(nfout,*) '! k_symmetry is forced to 0 in the non-collinear system'
         write(nfout,*) '!----- '
         k_symmetry(:) = 0
      endif
! ===================================================================== 11.0
    end subroutine set_k_symmetry

    subroutine wd_kpoints
      integer ik,i
      write(nfout,*)
      write(nfout,*) ' === k-points generated or read ==='
      write(nfout,'(" ik",8x,"CARTS",22x,"BUCS",19x,"QITG")')
      do ik = 1, kv3
         if(k_symmetry(ik) == GAMMA) then
            write(nfout,9002) ik,(vkxyz(ik,i,CARTS),i=1,3) &
                 &        ,           (vkxyz(ik,i,BUCS) ,i=1,3),qwgt(ik)
         else
            write(nfout,9001) ik,(vkxyz(ik,i,CARTS),i=1,3) &
                 &        ,           (vkxyz(ik,i,BUCS) ,i=1,3),qwgt(ik)
         end if
9001     format(i6,3f8.4,3x,3f8.4,3x,f8.4)
9002     format(i6,3f8.4,3x,3f8.4,3x,f8.4," GAMMA")
      enddo
    end subroutine wd_kpoints

! === KT_add === 2014/09/30
    subroutine wd_kpoints_fbz
      integer ik,i
      write(nfout,*)
      write(nfout,*) ' === k-points in full BZ ==='
      write(nfout,'(" ik",8x,"CARTS",22x,"BUCS",19x,"in IBZ")')
      do ik = 1, kv3_fbz
         write(nfout,9001) ik, (vkxyz_fbz(ik,i,CARTS),i=1,3), &
              &                (vkxyz_fbz(ik,i,BUCS) ,i=1,3), &
              &                to_ibz_from_fbz_for_kpoint(ik)
9001     format(i6,3f8.4,3x,3f8.4,3x,i6)
      enddo
    end subroutine wd_kpoints_fbz

    subroutine wd_kpoints_refcell
      integer ik,i
      write(nfout,*)
      write(nfout,*) ' === k-points in ref cell ==='
      write(nfout,'(" ik",8x,"CARTS",22x,"BUCS",19x,"in refcell")')
      do ik = 1, kv3
         write(nfout,9001) ik, (vkxyz_refcell(ik,i,CARTS),i=1,3), &
              &                (vkxyz_refcell(ik,i,BUCS) ,i=1,3)
9001     format(i6,3f8.4,3x,3f8.4)
      enddo
    end subroutine wd_kpoints_refcell

!!$    subroutine wd_kpoints(kv3,vkxyz)
!!$      integer, intent(in) :: kv3
!!$      real(kind=DP),intent(inout),dimension(kv3,3,CRDTYP) :: vkxyz
!!$
!!$      integer :: ik,i
!!$
!!$      write(nfout,*)
!!$      write(nfout,*) ' === k-points generated ==='
!!$      write(nfout,'(" ik",8x,"CARTS",22x,"BUCS",19x,"QITG")')
!!$      do ik = 1, kv3
!!$         write(nfout,9001) ik,(vkxyz(ik,i,CARTS),i=1,3) &
!!$              &     ,         (vkxyz(ik,i,BUCS) ,i=1,3),qwgt(ik)
!!$9001     format(i3,3f8.4,3x,3f8.4,3x,f8.4)
!!$      enddo
!!$    end subroutine wd_kpoints

    subroutine call_k_generator(external_k_gen)
      external   external_k_gen
      call external_k_gen(preallocation,nfout,altv,rltv,k_sample_mesh &
           &,knv3_t,kv3,vkxyz,qwgt)
    end subroutine call_k_generator

    subroutine double_k_points
      integer :: ik, is, k1
      integer, allocatable :: ilist(:)
      real(kind=DP), allocatable :: vkxyz_fbz_org(:,:,:)

      do ik = kv3/nspin, 1, -1
         vkxyz(ik*2,  1:3,CARTS) = vkxyz(ik,1:3,CARTS)
         vkxyz(ik*2-1,1:3,CARTS) = vkxyz(ik,1:3,CARTS)
         qwgt(ik*2)            = qwgt(ik)*0.5d0
         qwgt(ik*2-1)          = qwgt(ik)*0.5d0
      enddo
      if ( sw_band_unfolding == ON ) then
         do ik = kv3/nspin, 1, -1
            vkxyz_refcell(ik*2,  1:3,CARTS) = vkxyz_refcell(ik,1:3,CARTS)
            vkxyz_refcell(ik*2-1,1:3,CARTS) = vkxyz_refcell(ik,1:3,CARTS)
         enddo
      endif

      allocate( vkxyz_fbz_org(kv3_fbz,3,2 ) );
      vkxyz_fbz_org(1:kv3_fbz/nspin,:,:) = vkxyz_fbz(1:kv3_fbz/nspin,:,:)

      allocate( ilist(kv3_fbz) )
      ilist(1:kv3_fbz/nspin) = to_ibz_from_fbz_for_kpoint(1:kv3_fbz/nspin)

      do ik=1, kv3_fbz/nspin
         Do is=1, nspin
            k1 = ( ik -1 )*nspin + is
            if ( is == 1 ) then
               vkxyz_fbz( k1,:,CARTS) = vkxyz_fbz_org(ik,:,CARTS)
               to_ibz_from_fbz_for_kpoint(k1) = 2*ilist(ik) -1
            else
               vkxyz_fbz( k1,:,CARTS) = vkxyz_fbz_org(ik,:,CARTS)
               to_ibz_from_fbz_for_kpoint(k1) = 2*ilist(ik)
            endif
         End do
      End do

      deallocate( vkxyz_fbz_org ); deallocate( ilist )

    end subroutine double_k_points

! =========================== added by K. Tagami =========== 11.0
    subroutine gen_k_points_noncol
      integer :: ik, is, k1
      integer, allocatable :: ilist(:)
      real(kind=DP), allocatable :: vkxyz_org(:,:,:), qwgt_org(:)
      real(kind=DP), allocatable :: vkxyz_fbz_org(:,:,:)
!
!      allocate( vkxyz_org(kv3/ndim_spinor,3,2 ) );
      allocate( vkxyz_org(kv3,3,2 ) );
      vkxyz_org(1:kv3/ndim_spinor,:,:) = vkxyz(1:kv3/ndim_spinor,:,:)

!      allocate( qwgt_org(kv3/ndim_spinor) );
      allocate( qwgt_org(kv3) );
      qwgt_org(1:kv3/ndim_spinor) =  qwgt(1:kv3/ndim_spinor)
!
      do ik=1, kv3/ndim_spinor
         Do is=1, ndim_spinor
            k1 = ( ik -1 )*ndim_spinor + is

	    if ( is == 1 ) then
              vkxyz( k1,:,CARTS) = vkxyz_org(ik,:,CARTS)
              qwgt( k1 ) = qwgt_org(ik)
            else
              vkxyz( k1,:,CARTS) = vkxyz_org(ik,:,CARTS)
              qwgt( k1 ) = 0.0d0
           endif
         End do
      enddo
!
      if ( sw_band_unfolding == ON ) then
         do ik = kv3/nspin, 1, -1
            vkxyz_refcell(ik*2,  1:3,CARTS) = vkxyz_refcell(ik,1:3,CARTS)
            vkxyz_refcell(ik*2-1,1:3,CARTS) = vkxyz_refcell(ik,1:3,CARTS)
         enddo
      endif

      deallocate( vkxyz_org, qwgt_org )

!      allocate( vkxyz_fbz_org(kv3_fbz/ndim_spinor,3,2 ) );
      allocate( vkxyz_fbz_org(kv3_fbz,3,2 ) );
      vkxyz_fbz_org(1:kv3_fbz/ndim_spinor,:,:) = vkxyz_fbz(1:kv3_fbz/ndim_spinor,:,:)

!      allocate( ilist(kv3_fbz/ndim_spinor) )
      allocate( ilist(kv3_fbz) )
      ilist(1:kv3_fbz/ndim_spinor) = to_ibz_from_fbz_for_kpoint(1:kv3_fbz/ndim_spinor)

      do ik=1, kv3_fbz/ndim_spinor
         Do is=1, ndim_spinor
            k1 = ( ik -1 )*ndim_spinor + is
	    if ( is == 1 ) then
               vkxyz_fbz( k1,:,CARTS) = vkxyz_fbz_org(ik,:,CARTS)
               to_ibz_from_fbz_for_kpoint(k1) = 2*ilist(ik) -1
            else
               vkxyz_fbz( k1,:,CARTS) = vkxyz_fbz_org(ik,:,CARTS)
               to_ibz_from_fbz_for_kpoint(k1) = 2*ilist(ik) -1
            endif
         End do
      End do
      deallocate( vkxyz_fbz_org ); deallocate( ilist )

    end subroutine gen_k_points_noncol
! ========================================================== 11.0

    subroutine k_points_in_BUCS_from_CARTS
      integer       :: i, ik
      real(kind=DP) :: fact
      do i = 1, 3
         do ik = 1, kv3
            vkxyz(ik,i,BUCS) = (altv(1,i)*vkxyz(ik,1,CARTS)&
                 &           +  altv(2,i)*vkxyz(ik,2,CARTS)&
                 &           +  altv(3,i)*vkxyz(ik,3,CARTS))/PAI2
         enddo
      enddo

      ! -- >      check of BUCS system
      do i = 1, 3
         do ik = 1, kv3
            fact =   rltv(i,1)*vkxyz(ik,1,BUCS)&
                 & + rltv(i,2)*vkxyz(ik,2,BUCS)&
                 & + rltv(i,3)*vkxyz(ik,3,BUCS)
            if(dabs(fact - vkxyz(ik,i,CARTS)) > 1.d-5) then
               if(ipri_kp>=1) then
                  write(nfout,*) ' !D (i = ',i,',ik = ',ik,')'
                  write(nfout,*) vkxyz(ik,i,BUCS),fact, vkxyz(ik,i,CARTS)
               end if
               call phase_error_with_msg(nfout,' Coordinate transformation is invalid',__LINE__,__FILE__)
            endif
         enddo
      enddo

! === KT_add === 2014/09/30
      do i = 1, 3
         do ik = 1, kv3_fbz
            vkxyz_fbz(ik,i,BUCS) = ( altv(1,i) *vkxyz_fbz(ik,1,CARTS) &
                 &                    +  altv(2,i) *vkxyz_fbz(ik,2,CARTS) &
                 &                    +  altv(3,i) *vkxyz_fbz(ik,3,CARTS) )/PAI2
         enddo
      enddo
! ============= 2014/09/30

      if ( sw_band_unfolding == ON ) then
         do i = 1, 3
            do ik = 1, kv3
               vkxyz_refcell(ik,i,BUCS) &
                    &        = ( altv_refcell(1,i) *vkxyz_refcell(ik,1,CARTS) &
                    &          + altv_refcell(2,i) *vkxyz_refcell(ik,2,CARTS) &
                    &          + altv_refcell(3,i) *vkxyz_refcell(ik,3,CARTS) )/PAI2
            enddo
         enddo
      endif
    end subroutine k_points_in_BUCS_from_CARTS

    subroutine wd_k_sample_mesh
      integer :: i
      write(nfout,680) (k_sample_mesh(i,1),i=1,3)
      write(nfout,690) (k_sample_mesh(i,2),i=1,3)
680   format(' ',3i6,'   : nkx, nky, nkz ')
690   format(' ',3i6,'   : nkx2, nky2, nkz2 ')
    end subroutine wd_k_sample_mesh
  end subroutine m_Kp_gnrt_or_rd_k_points



!!$  subroutine m_Kp_rd_kpoints_table
!!$!    for tetrahedron method
!!$!     read k-table from the file 'f.kp0 '
!!$!           Tsuyoshi Miyazaki  '94.8.10
!!$#ifndef NO_TETRAHEDRON
!!$    integer :: nx1,ny1,nz1
!!$    integer,       pointer, dimension(:,:) :: ip2cub_wk
!!$    real(kind=DP), pointer, dimension(:,:) :: pa0,pb0
!!$
!!$    write(nfout,*) '-- read k-table from <f.kp0> --'
!!$    call m_Files_open_nfkindex
!!$    read(nfkindex,*) np0
!!$    read(nfkindex,*) np0,np1,np2
!!$    write(nfout,'(" np0,np1,np2 = ",3i6)') np0,np1,np2
!!$    if(np2 /= kv3/nspin) then
!!$       write(nfout,*) ' np0,np1,np2 ',np0,np1,np2
!!$       write(nfout,*) ' kv3/nspin ',kv3/nspin
!!$       write(nfout,*) ' np2  /=  (kv3/nspin)'
!!$       stop
!!$    endif
!!$    allocate(ip20(np0)) ; ip20 = 0
!!$    allocate(ip10(np0)) ; ip10 = 0
!!$    allocate(ip01(np1)) ; ip01 = 0
!!$    allocate(ip21(np1)) ; ip21 = 0
!!$    allocate(iu21(np1)) ; iu21 = 0
!!$    allocate(iv21(np1)) ; iv21 = 0
!!$    allocate(ip02(np2)) ; ip02 = 0
!!$    allocate(ip12(np2)) ; ip12 = 0
!!$    allocate(iwt(np2)) ; iwt = 0
!!$    allocate(ip2cub(np1)) ; ip2cub = 0
!!$    allocate(nxyz_tetra(3)) ; nxyz_tetra = 0
!!$    allocate(pa0(3,np0)) ; pa0 = 0.d0
!!$    allocate(pb0(3,np0)) ; pb0 = 0.d0
!!$    rewind nfkindex
!!$    write(nfout,'(" nfkindex = ",i9)') nfkindex
!!$    call nskpr0(nfkindex,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
!!$           &    ,nx1,ny1,nz1,np0,np1,np2 &
!!$           &    ,pa0,pb0 &
!!$           &    ,ip10,ip20,ip01,ip21,ip02,ip12,iu21,iv21)
!!$    deallocate(pa0)
!!$    deallocate(pb0)
!!$    allocate(ip2cub_wk(9,nxyz_tetra(1)*nxyz_tetra(2)*nxyz_tetra(3)))
!!$    ip2cub_wk = 0.d0
!!$    call wtetra &
!!$      &  (nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3),np0,np2,ip20 &
!!$      &  ,iwt,ip2cub &
!!$      &  ,ip2cub_wk)
!!$    deallocate(ip2cub_wk)
!!$#endif
!!$  end subroutine m_Kp_rd_kpoints_table

!! added by mizouchi@adv !!
!!!!!!!! modified by mizouchi@adv 2003.2.25 !!!!!
  subroutine m_Kp_cr_kpoints_table
!    for tetrahedron method
#ifndef NO_TETRAHEDRON
!!$    integer :: nx1,ny1,nz1,nd
    integer :: nx,ny,nz
    integer :: nxx,nyy,nzz
    integer :: ill,ii,lmnp0, lmnp1, lmnp2
    real(kind=DP), pointer, dimension(:,:) :: pa0,pb0,pb
    integer,       pointer, dimension(:,:) :: ka0,ka2
    integer,       pointer, dimension(:,:) :: ip2cub_wk
    integer,       pointer, dimension(:)   :: nstar2

    if(ipri_kp >= 2) write(nfout,*) '-- create k-table for tetrahedron method --'

    if(way_ksample == SKPS_DIRECT_IN) then
        call phase_error_with_msg(nfout,'way_ksample = SKPS_DIRECT_IN case is not'// &
             & 'supportted in tetrahedron method.',__LINE__,__FILE__)
    end if

    if(nbztyp.eq.WHOLE_BZ) then

        np0 = (k_sample_mesh(1,2)+1)*(k_sample_mesh(2,2)+1)*(k_sample_mesh(3,2)+1)
        np2 = k_sample_mesh(1,2)*k_sample_mesh(2,2)*k_sample_mesh(3,2)
        np1=np2

        if(ipri_kp>=1) write(nfout,'(" np0,np1,np2 = ",3i6)') np0,np1,np2

! ============================== modified by K. Tagami ============== 11.0
!        if(np2 /= kv3/nspin) then
!           if(ipri_kp>=1) then
!              write(nfout,*) ' np0,np1,np2 ',np0,np1,np2
!              write(nfout,*) ' kv3/nspin ',kv3/nspin
!              write(nfout,*) ' np2  /=  (kv3/nspin)'
!           end if
!           stop
!        endif
!
        if ( noncol ) then
          if(np2 /= kv3/ndim_spinor) then
             if(ipri_kp>=1) then
                write(nfout,*) ' np0,np1,np2 ',np0,np1,np2
                write(nfout,*) ' kv3/ndim_spinor ',kv3/ndim_spinor
                write(nfout,*) ' np2  /=  (kv3/ndim_spinor)'
             end if
             call phase_error_with_msg(nfout,'np2 /= kv3/ndim_spinor',__LINE__,__FILE__)
          endif
        else
          if(np2 /= kv3/nspin) then
             if(ipri_kp>=1) then
                write(nfout,*) ' np0,np1,np2 ',np0,np1,np2
                write(nfout,*) ' kv3/nspin ',kv3/nspin
                write(nfout,*) ' np2  /=  (kv3/nspin)'
             end if
             call phase_error_with_msg(nfout,'np2 /= kv3/nspin',__LINE__,__FILE__)
          endif
        endif
! ==================================================================== 11.0

        allocate(ip20(np0)) ; ip20 = 0
	if(ipri_kp>=2) write(nfout,'(" !kp ip20 is allocated")')
        allocate(iwt(np2)) ; iwt = 0
        allocate(ip2cub(np1)) ; ip2cub = 0
        allocate(nxyz_tetra(3)) ; nxyz_tetra = 0

        nx = k_sample_mesh(1,2)
        ny = k_sample_mesh(2,2)
        nz = k_sample_mesh(3,2)
        ill = 1

        lmnp0=np0
        lmnp1=np1

        allocate(ip01(np1)) ; ip01 = 0
        allocate(pa0(3,np0)) ; pa0 = 0.d0

        call nskma0(ill,nx,ny,nz,nxyz_tetra(1),nxyz_tetra(2) &
                    &,nxyz_tetra(3),nx1,ny1,nz1,nd)

        call nskp00(nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
                    &,nx1,ny1,nz1,nd,lmnp0,np0,pa0)

!! When nbztyp=1, ip10 in FLAPW program should be ip20 in this program !!

        call nskpbm(np0,lmnp0,lmnp1,pa0,np1,ip20,ip01)

        deallocate(pa0)
        deallocate(ip01)

    else

      if(nbztyp_spg == GENERAL .or.nbztyp_spg == GENERAL_LARGER) then

         nx=k_sample_mesh(1,1); ny=k_sample_mesh(2,1); nz=k_sample_mesh(3,1)

         call nskma0(il,nx,ny,nz,nxx,nyy,nzz,nx1,ny1,nz1,nd)
         lmnp0=(nxx+1)*(nyy+1)*(nzz+1)
         lmnp1=lmnp0
         lmnp2=lmnp0

         allocate(nxyz_tetra(3)) ; nxyz_tetra = 0
         allocate(ip10(lmnp0))  ; ip10 = 0
         allocate(ip20(lmnp0))  ; ip20 = 0
         allocate(ip01(lmnp1))    ; ip01 = 0
         allocate(ip02(lmnp2))    ; ip02 = 0
         allocate(ip21(lmnp1))    ; ip21 = 0
         allocate(ip12(lmnp2))    ; ip12 = 0
         allocate(iu21(lmnp1))    ; iu21 = 0
         allocate(iv21(lmnp1))    ; iv21 = 0
         allocate(nstar2(lmnp2))  ; nstar2 = 0
         allocate(pa0(3,lmnp0))  ; pa0 = 0
         allocate(pb0(3,lmnp0))  ; pb0 = 0
         allocate(pb(3,lmnp2))  ; pb = 0
         allocate(ka0(4,lmnp0))  ; ka0 = 0
         allocate(ka2(4,lmnp2))  ; ka2 = 0

         ipri_kp_t = ipri_kp*(1-ipri_kp_count)
         if(ipri_kp_count == 0) ipri_kp_count = 1

! === KT_mod === 2015/02/18
!         call setkp0_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
!              & ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
!              & ,nx,ny,nz,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
!              & ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
!              & ,nstar2,pa0,pb0,pb,ka0,ka2 &
!              & ,ipri_kp_t)
         if ( gen_tetramesh_mode == 0 ) then
            call setkp0_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
                 & ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
                 & ,nx,ny,nz,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
                 & ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
                 & ,nstar2,pa0,pb0,pb,ka0,ka2 &
                 & ,ipri_kp_t, itrs )
         else if ( gen_tetramesh_mode == 1 ) then
            call setkp0_n_kt(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
                 & ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
                 & ,nx,ny,nz,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
                 & ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
                 & ,nstar2,pa0,pb0,pb,ka0,ka2 &
                 & ,ipri_kp_t, &
                 &  use_altv_rltv, altv, rltv, itrs, &
                 &  gen_name_in_carts )
         endif
! ================ 2015/02/18

      else
           nx = k_sample_mesh(1,1)
           ny = k_sample_mesh(2,1)
           nz = k_sample_mesh(3,1)

           if(ipri_kp>=2) write(nfout,'(" !kp nx,ny,nz = ",3i6)') nx,ny,nz
!!$           if(nbztyp_spg.eq.SIMPLE_CUBIC) il = 1
!!$           if(nbztyp_spg.eq.BCC) il = 3
!!$           if(nbztyp_spg.eq.FCC) il = 2
!!$           if(nbztyp_spg.eq.DIAMOND) il = 2
!!$           if(nbztyp_spg.eq.HEXAGONAL) il = 0

           call nskma0(il,nx,ny,nz,nxx,nyy,nzz,nx1,ny1,nz1,nd)
           if(ipri_kp >=2) write(nfout,'(" !kp nxx,nyy,nzz = ",3i6)') nxx,nyy,nzz

           lmnp0=(nxx+1)*(nyy+1)*(nzz+1)
           lmnp1=lmnp0
           lmnp2=lmnp0

           allocate(nxyz_tetra(3)) ; nxyz_tetra = 0
           allocate(ip10(lmnp0))  ; ip10 = 0
           allocate(ip20(lmnp0))  ; ip20 = 0
           allocate(ip01(lmnp1))    ; ip01 = 0
           allocate(ip02(lmnp2))    ; ip02 = 0
           allocate(ip21(lmnp1))    ; ip21 = 0
           allocate(ip12(lmnp2))    ; ip12 = 0
           allocate(iu21(lmnp1))    ; iu21 = 0
           allocate(iv21(lmnp1))    ; iv21 = 0
           allocate(nstar2(lmnp2))  ; nstar2 = 0
           allocate(pa0(3,lmnp0))  ; pa0 = 0
           allocate(pb0(3,lmnp0))  ; pb0 = 0
           allocate(pb(3,lmnp2))  ; pb = 0
           allocate(ka0(4,lmnp0))  ; ka0 = 0
!!$           allocate(ka2(4,lmnp2))  ; ka2 = 0

!!$           call setkp0_default_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
!!$                &               ,nbztyp_spg,altv,nx,ny,nz &
!!$                &               ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
!!$                &               ,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3)&
!!$                &               ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
!!$                &               ,nstar2,pa0,pb0,pb,ka0,ka2 &
!!$                &               ,ipri_kp)
           ipri_kp_t = ipri_kp*(1-ipri_kp_count)
           if(ipri_kp_count == 0) ipri_kp_count = 1

! ===================================== modified by K. Tagami ============== 12.0A
!           call setkp0_default_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
!                &               ,nx,ny,nz &
!                &               ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
!                &               ,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3)&
!                &               ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
!                &               ,nstar2,pa0,pb0,pb,ka0 &
!                &               ,ipri_kp_t)
           if ( gen_tetramesh_mode == 0 ) then
              call setkp0_default_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
                   &               ,nx,ny,nz &
                   &               ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
                   &               ,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3)&
                   &               ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
                   &               ,nstar2,pa0,pb0,pb,ka0 &
                   &               ,ipri_kp_t, itrs )
           else if ( gen_tetramesh_mode == 1 ) then
              call setkp0_default_n_kt(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
                   &               ,nx,ny,nz &
                   &               ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
                   &               ,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3)&
                   &               ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
                   &               ,nstar2,pa0,pb0,pb,ka0 &
                   &               ,ipri_kp_t, &
                   &               use_altv_rltv, altv, rltv, itrs, &
                   &               gen_name_in_carts )
           else if ( gen_tetramesh_mode == 2 ) then
              call setkp0_default_n_kt2(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
                   &               ,nx,ny,nz &
                   &               ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
                   &               ,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3)&
                   &               ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
                   &               ,nstar2,pa0,pb0,pb,ka0 &
                   &               ,ipri_kp_t, &
                   &               use_altv_rltv, altv, rltv, itrs, &
                   &               gen_name_in_carts )
           endif
! ========================================================================== 12.0A
        end if

        if(ipri_kp>=2) write(nfout,'(" np0,np1,np2 = ",3i6)') np0,np1,np2
        if(ipri_kp>=1) then
           write(nfout,'("!Kp nxyz_tetra(1:3) = ",3i8)') nxyz_tetra(1:3)
        end if

! ==================================== modified by K. Tagami =========== 11.0
!        if(np2 /= kv3/nspin) then
!           if(ipri_kp>=1) then
!              write(nfout,*) ' np0,np1,np2 ',np0,np1,np2
!              write(nfout,*) ' kv3/nspin ',kv3/nspin
!              write(nfout,*) ' np2  /=  (kv3/nspin)'
!           end if
!           stop
!        endif
!
        if ( noncol ) then
          if(np2 /= kv3/ndim_spinor) then
             if(ipri_kp>=1) then
                write(nfout,*) ' np0,np1,np2 ',np0,np1,np2
                write(nfout,*) ' kv3/ndim_spinor ',kv3/ndim_spinor
                write(nfout,*) ' np2  /=  (kv3/ndim_spinor)'
             end if
             call phase_error_with_msg(nfout,'np2 /= kv3/ndim_spinor',__LINE__,__FILE__)
          endif
        else
          if(np2 /= kv3/nspin) then
             if(ipri_kp>=1) then
                write(nfout,*) ' np0,np1,np2 ',np0,np1,np2
                write(nfout,*) ' kv3/nspin ',kv3/nspin
                write(nfout,*) ' np2  /=  (kv3/nspin)'
             end if
             call phase_error_with_msg(nfout,'np2 /= kv3/nspin',__LINE__,__FILE__)
          endif
        endif
! =================================================================== 11.0

        allocate(iwt(np2)) ; iwt = 0
        allocate(ip2cub(np1)) ; ip2cub = 0

         deallocate(ip10)
         deallocate(ip01)
         deallocate(ip02)
         deallocate(ip21)
         deallocate(ip12)
         deallocate(iu21)
         deallocate(iv21)
         deallocate(nstar2)
         deallocate(pa0)
         deallocate(pb0)
         deallocate(pb)
         deallocate(ka0)
         if(nbztyp_spg == GENERAL .or.nbztyp_spg == GENERAL_LARGER) &
              & deallocate(ka2)
    end if

    if(ipri_kp >= 2) then
       write(nfout,*) 'ip20'
       write(nfout,'(" np0 = ",i8)') np0
       write(nfout,*) (ip20(ii),ii=1,np0)
       write(nfout,'(" nx1,ny1,nz1,nd = ",4i6)') nx1,ny1,nz1,nd
    end if

    allocate(ip2cub_wk(9,nxyz_tetra(1)*nxyz_tetra(2)*nxyz_tetra(3)))
    ip2cub_wk = 0.d0
    call wtetra &
      &  (nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3),np0,np2,ip20 &
      &  ,iwt,ip2cub &
      &  ,ip2cub_wk)
    deallocate(ip2cub_wk)
#endif
  end subroutine m_Kp_cr_kpoints_table

  subroutine change_kpoints_order
    integer :: nx,ny,nz,ik,ix,iy,iz &
          & , k0(k_sample_mesh(1,2),k_sample_mesh(2,2),k_sample_mesh(3,2)) &
          & , k1(kv3)
    real(kind=DP) :: wk(1:kv3,3)

    nx = k_sample_mesh(1,2)
    ny = k_sample_mesh(2,2)
    nz = k_sample_mesh(3,2)

! ======================================= modified by K. Tagami ======== 11.0
!    do ik = 1, kv3/nspin
!       wk(ik,1) = vkxyz(ik,1,CARTS)
!       wk(ik,2) = vkxyz(ik,2,CARTS)
!       wk(ik,3) = vkxyz(ik,3,CARTS)
!    end do

    if ( noncol ) then
      do ik = 1, kv3/ndim_spinor
         wk(ik,1) = vkxyz(ik,1,CARTS)
         wk(ik,2) = vkxyz(ik,2,CARTS)
         wk(ik,3) = vkxyz(ik,3,CARTS)
      end do
    else
      do ik = 1, kv3/nspin
         wk(ik,1) = vkxyz(ik,1,CARTS)
         wk(ik,2) = vkxyz(ik,2,CARTS)
         wk(ik,3) = vkxyz(ik,3,CARTS)
      end do
    endif
! ====================================================================== 11.0

    ik = 0
    do ix = 1,nx
    do iy = 1,ny
    do iz = 1,nz
        ik = ik+1
        k0(ix,iy,iz) = ik
        k1(ik) = 0
    end do
    end do
    end do

    ik = 0
    do iz = 1,nz
    do iy = 1,ny
    do ix = 1,nx
        ik = ik+1
        k1(ik) = k0(ix,iy,iz)
    end do
    end do
    end do

! ===================================== modified by K. Tagami ============= 11.0
!    do ik = 1, kv3/nspin
!      vkxyz(ik,1,CARTS) = wk(k1(ik),1)
!      vkxyz(ik,2,CARTS) = wk(k1(ik),2)
!      vkxyz(ik,3,CARTS) = wk(k1(ik),3)
!    end do

    if ( noncol ) then
      do ik = 1, kv3/ndim_spinor
        vkxyz(ik,1,CARTS) = wk(k1(ik),1)
        vkxyz(ik,2,CARTS) = wk(k1(ik),2)
        vkxyz(ik,3,CARTS) = wk(k1(ik),3)
      end do
    else
      do ik = 1, kv3/nspin
        vkxyz(ik,1,CARTS) = wk(k1(ik),1)
        vkxyz(ik,2,CARTS) = wk(k1(ik),2)
        vkxyz(ik,3,CARTS) = wk(k1(ik),3)
      end do
    endif
! ======================================================================== 11.0

  end subroutine change_kpoints_order


  !  <<< Monkhorst-Pack special kpoints generator >>>
  !  coded by Takenori YAMAMOTO (Univ. Tokyo)
  !  last update : Aug. 12, 2003
! ========================================== modified by K. Tagami ======== 11.0P
!  subroutine special_kpoints(printlevel,output,nsym,rot,b1,b2,b3,a1,a2,a3 &
!    & ,nkpoint,nkpmax,kpoint,weight,magnetic,use_trs )

  subroutine special_kpoints( printlevel, output, nsym, rot, b1, b2, b3, a1, a2, a3, &
       &                      nkpoint, nkpmax, kpoint, weight, magnetic, use_trs, &
       &                      nkpoint_full, kpoint_full, to_ibz_from_fbz_for_kpoint, &
       &                      nsym_before_sym_reduction, rot_before_sym_reduction )
! ========================================================================== 11.0P
    implicit none

    integer, intent(in) :: printlevel
    integer, intent(in) :: output
    integer, intent(in) :: nsym
    real(kind=DP), intent(in) :: rot(3,3,nsym)
    real(kind=DP), intent(in) :: b1(3),b2(3),b3(3)
    real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
    integer, intent(inout) :: nkpoint
    integer, intent(in) :: nkpmax
    real(kind=DP), intent(inout) :: kpoint(3,*),weight(*)
    logical, intent(in) :: magnetic
    logical, intent(in) :: use_trs

! === KT_add === 2014/09/30
    integer, optional, intent(inout) :: nkpoint_full
    real(kind=DP), optional, intent(inout) :: kpoint_full(3,*)
    integer, optional, intent(inout) :: to_ibz_from_fbz_for_kpoint(*)
! ============== 2014/09/30

! ============================ aded by K. Tagami ======================== 11.0P
    integer, optional, intent(in) :: nsym_before_sym_reduction
    real(kind=DP), optional, intent(in) :: rot_before_sym_reduction(3,3,*)
! ======================================================================= 11.0P

    ! local variables
    integer :: i,nkmesh,nmp_kmesh,nfbz_kmesh
    real(kind=DP), allocatable :: kmesh(:,:)
    real(kind=DP), allocatable :: mp_kmesh(:,:),fbz_kmesh(:,:)
    integer :: nsym_trs
    real(kind=DP), allocatable :: rot_trs(:,:,:),grot(:,:,:)
    real(kind=DP) :: kshf(3)
    integer :: face(3,nface_max),nface

! ============================= added by K. Tagami =============== 11.0P
    integer :: nsym_trs_before_sym_reduction
    real(kind=DP), allocatable :: rot_trs_before_sym_reduction(:,:,:)
    real(kind=DP), allocatable :: grot_before_sym_reduction(:,:,:)

    logical :: use_rot_before_sym_reduction
! ================================================================= 11.0P

    real(kind=DP) :: kshift_norm2
    if(printable .and. printlevel .ge. 0) then
      write(output,*) 'Special k-points generation starts.'
    end if

    ! debug
    !if(printable .and. printlevel .ge. 3) then
    !  write(output,'("Symmetry operation matirx")')
    !  do i=1,nsym
    !    write(output,*) 'n=',i
    !    write(output,'(3(1x,f10.5))') rot(1,1:3,i)
    !    write(output,'(3(1x,f10.5))') rot(2,1:3,i)
    !    write(output,'(3(1x,f10.5))') rot(3,1:3,i)
    !  end do
    !end if
    ! end debug

    call set_number_nsym_trs( nsym, rot, magnetic, use_trs, nsym_trs )
    allocate( rot_trs(3,3,nsym_trs), grot(3,3,nsym_trs) )
    call gen_rot_trs( nsym, rot, nsym_trs, rot_trs )
    call get_grot(a1,a2,a3,b1,b2,b3,nsym_trs,rot_trs,grot)

! ============================= added by K. Tagami =============== 11.0P
    if ( noncol .and. present( nsym_before_sym_reduction ) ) then
       use_rot_before_sym_reduction = .true.
    else
       use_rot_before_sym_reduction = .false.
    endif

    if ( use_rot_before_sym_reduction ) then
       call set_number_nsym_trs( nsym_before_sym_reduction, rot_before_sym_reduction, &
            &                    magnetic, use_trs, nsym_trs_before_sym_reduction )
       allocate( rot_trs_before_sym_reduction(3,3,nsym_trs_before_sym_reduction) )
       allocate( grot_before_sym_reduction(3,3,nsym_trs_before_sym_reduction) )
       call gen_rot_trs( nsym_before_sym_reduction, rot_before_sym_reduction, &
            &            nsym_trs_before_sym_reduction, rot_trs_before_sym_reduction )
       call get_grot( a1, a2, a3, b1, b2, b3, nsym_trs_before_sym_reduction, &
            &         rot_trs_before_sym_reduction, grot_before_sym_reduction )
    endif
! =================================================================== 11.0P

    ! debug
    !if(printable .and. printlevel .ge. 3) then
    !  write(output,'("Symmetry operation matirx for reciprocal lattice indeces")')
    !  do n=1,nsym
    !    write(output,*) 'n=',n
    !    write(output,'(3(1x,f10.5))') grot(1,1:3,n)
    !    write(output,'(3(1x,f10.5))') grot(2,1:3,n)
    !    write(output,'(3(1x,f10.5))') grot(3,1:3,n)
    !  end do
    !end if
    ! end debug

    if (nkpoint == 0) then

      nkmesh = (2*mp_index(1)+1)*(2*mp_index(2)+1)*(2*mp_index(3)+1)
      allocate(kmesh(3,nkmesh*nsym_trs))
      call gen_gmesh(mp_index,nkmesh,kmesh)

      kshf(1:3) = kshift(1:3)/mp_index(1:3)
      do i=1,nkmesh
        kmesh(1:3,i) = kmesh(1:3,i) + kshf(1:3)
      end do

      ! debug
      !do i=1,nkmesh
      !  write(output,'(3(1x,f10.5))') kmesh(1:3,i)
      !end do
      !stop 'debug kmesh'
      ! end debug

      call fbz_face(b1,b2,b3,nface,face)

      allocate(mp_kmesh(3,nkmesh))
      allocate(fbz_kmesh(3,nkmesh))

      if ( sw_kpt_segmentation == ON ) then
         call first_bz_segment(b1,b2,b3,nkmesh,kmesh,nmp_kmesh,mp_kmesh,nface,face)
      else
         call first_bz(b1,b2,b3,nkmesh,kmesh,nmp_kmesh,mp_kmesh,nface,face)
      endif

      if(printable .and. printlevel .ge. 0) &
      &  write(output,'(1x,"number of k-points in MP mesh        = ",i8)') nmp_kmesh

      ! debug
      !do i=1,nmp_kmesh
      !  write(output,'(3(1x,f10.5))') mp_kmesh(1:3,i)
      !end do
      !stop 'debug mp_kmesh'
      ! end debug

! == KT_add == 2014/09/30
#ifndef EXPERIMENTAL_REGEN_KMESH
      if ( present( kpoint_full ) ) then
         if ( sw_kpt_segmentation == ON ) then
            call regen_kmesh_using_grot_segment( nkmesh, kmesh, mp_kmesh, &
                 &                               1, grot(1:3,1:3,1) )
         else
            call regen_kmesh_using_grot( nkmesh, kmesh, mp_kmesh, 1, grot(1:3,1:3,1) )
         endif
         if ( sw_kpt_segmentation == ON ) then
            call first_bz_segment(b1,b2,b3,nkmesh,kmesh,nfbz_kmesh,fbz_kmesh,nface,face)
         else
            call first_bz(b1,b2,b3,nkmesh,kmesh,nfbz_kmesh,fbz_kmesh,nface,face)
         endif
         nkpoint_full = nfbz_kmesh
         kpoint_full(1:3,1:nkpoint_full) = fbz_kmesh(1:3,1:nkpoint_full)
      endif
#endif
! ============ 2014/09/30

      if ( use_rot_before_sym_reduction ) then
         call regen_kmesh_using_grot( nkmesh, kmesh, mp_kmesh, &
              &                       nsym_trs_before_sym_reduction, &
              &                       grot_before_sym_reduction )
      else
         if ( sw_kpt_segmentation == ON ) then
            call regen_kmesh_using_grot_segment( nkmesh, kmesh, mp_kmesh, &
                 &                               nsym_trs, grot )
         else
            call regen_kmesh_using_grot( nkmesh, kmesh, mp_kmesh, nsym_trs, grot )
         endif
      endif

      if ( sw_kpt_segmentation == ON ) then
         call first_bz_segment(b1,b2,b3,nkmesh,kmesh,nfbz_kmesh,fbz_kmesh,nface,face)
      else
         call first_bz(b1,b2,b3,nkmesh,kmesh,nfbz_kmesh,fbz_kmesh,nface,face)
      endif

      if(printable .and. printlevel .ge. 0) &
      &  write(output,'(1x,"number of k-points in full BZ        = ",i8)') nfbz_kmesh

      ! debug
      !do i=1,nfbz_kmesh
      !  write(output,'(3(1x,f10.5))') fbz_kmesh(1:3,i)
      !end do
      !stop 'debug fbz_kmesh'
      ! end debug

#ifndef EXPERIMENTAL_REGEN_KMESH
      if ( present( kpoint_full ) ) then
         if ( sw_kpt_segmentation == ON ) then
            call gen_spk2_segment( nsym_trs, grot, nkpoint_full, kpoint_full, nkpoint, &
                 &                 nkpmax, kpoint, weight, to_ibz_from_fbz_for_kpoint )
         else
            call gen_spk2( nsym_trs, grot, nkpoint_full, kpoint_full, nkpoint, nkpmax, &
                 &        kpoint, weight, to_ibz_from_fbz_for_kpoint )
         endif
      else
         call gen_spk( nsym_trs, grot, nfbz_kmesh, fbz_kmesh, nkpoint, nkpmax, &
              &        kpoint, weight )
      endif
#else
! == KT_add == 2014/09/30
      if ( present( kpoint_full ) ) then
         nkpoint_full = nfbz_kmesh
         kpoint_full(1:3,1:nkpoint_full) = fbz_kmesh(1:3,1:nkpoint_full)
      endif
      call gen_spk2( nsym_trs, grot, nfbz_kmesh, fbz_kmesh, nkpoint, nkpmax, &
           &         kpoint, weight, to_ibz_from_fbz_for_kpoint )
! ============ 2014/09/30
#endif

! === ASMS ====
!      call positive(nsym_trs,grot,nkpoint,kpoint)

      kshift_norm2 = kshift(1)**2 +kshift(2)**2 +kshift(3)**2
      if ( sw_hybrid_functional == ON .and. kshift_norm2 > 0 ) then
         sw_fix_ibz_on_fbz_mesh = ON
         write(nfout,*) "!** sw_fix_ibz_on_fbz_mesh is forced to ON"
      endif
      if ( sw_fix_ibz_on_fbz_mesh == OFF ) then
         if ( charge_symm_mode >= chg_symm_level1 ) then
            sw_fix_ibz_on_fbz_mesh = ON
            write(nfout,*) "!** sw_fix_ibz_on_fbz_mesh is forced to ON"
         endif
      endif

      if ( present( kpoint_full ) ) then
         if ( sw_fix_ibz_on_fbz_mesh == ON ) then
            call positive2( nsym_trs, grot, nkpoint, kpoint, nkpoint_full, kpoint_full )
         else
            call positive(nsym_trs,grot,nkpoint,kpoint)
         endif
      else
         call positive(nsym_trs,grot,nkpoint,kpoint)
      endif
! === ASMS ====

      deallocate(rot_trs,mp_kmesh,kmesh,fbz_kmesh)

    end if

    !!call accuracy(a1,a2,a3,nsym_trs,grot,nkpoint,kpoint,weight)

    deallocate(grot)

! ============================= added by K. Tagami ======================== 11.0P
    if ( allocated(grot_before_sym_reduction) ) deallocate( grot_before_sym_reduction )
    if ( allocated(rot_trs_before_sym_reduction) ) deallocate( rot_trs_before_sym_reduction )
! ========================================================================= 11.0P

    if(printable .and. printlevel .ge. 0) then
      write(output,*) 'Special k-points generation ends.'
    end if

  contains

! ================================ added by K. Tagami ================= 11.0P
    subroutine regen_kmesh_using_grot( nkmesh, kmesh, mp_kmesh, nsym_trs, grot )
      integer, intent(in) :: nsym_trs
      integer, intent(inout) :: nkmesh
      real(kind=DP), intent(inout) :: kmesh(3,nkmesh*nsym_trs)
      real(kind=DP), intent(in) :: mp_kmesh(3,nkmesh)
      real(kind=DP), intent(in) :: grot(3,3,nsym_trs)

      real(kind=DP), allocatable :: kt_mesh(:,:)

      integer :: i, j, n
      logical :: new_kp
      real(kind=DP) :: v(3)

      allocate( kt_mesh(3,nmp_kmesh) ); kt_mesh = 0

#ifndef EXPERIMENTAL_REGEN_KMESH
      Do i=1, nmp_kmesh
         kt_mesh(1,i) = mp_kmesh(1,i)
         kt_mesh(2,i) = mp_kmesh(2,i)
         kt_mesh(3,i) = mp_kmesh(3,i)
      End Do
#else
      Do i=1, nmp_kmesh
         kt_mesh(1,i) = mp_kmesh(1,i) -kshf(1)
         kt_mesh(2,i) = mp_kmesh(2,i) -kshf(2)
         kt_mesh(3,i) = mp_kmesh(3,i) -kshf(3)
      End Do
#endif

      nkmesh=1
      kmesh(1:3,nkmesh) = kt_mesh(1:3,1)

      do i=1,nmp_kmesh
         do n=1,nsym_trs
            v(1:3) = grot(1:3,1,n)*kt_mesh(1,i) +grot(1:3,2,n)*kt_mesh(2,i) &
                 & + grot(1:3,3,n)*kt_mesh(3,i)

            new_kp = .true.
            do j=1,nkmesh
               if (abs(v(1)-kmesh(1,j)) < 1.d-10 .and. &
                    &abs(v(2)-kmesh(2,j)) < 1.d-10 .and. &
                    &abs(v(3)-kmesh(3,j)) < 1.d-10 ) then
                  new_kp = .false.
                  exit
               end if
            end do
            if(new_kp) then
               nkmesh = nkmesh + 1
               kmesh(1:3,nkmesh) = v(1:3)
            end if
         end do
      end do
#ifdef EXPERIMENTAL_REGEN_KMESH
      Do i=1, nkmesh
         kmesh(1,i) = kmesh(1,i) +kshf(1)
         kmesh(2,i) = kmesh(2,i) +kshf(2)
         kmesh(3,i) = kmesh(3,i) +kshf(3)
      End Do
#endif
      deallocate( kt_mesh )

    end subroutine regen_kmesh_using_grot

    subroutine regen_kmesh_using_grot_segment( nkmesh, kmesh, mp_kmesh, nsym_trs, grot )
      integer, intent(in) :: nsym_trs
      integer, intent(inout) :: nkmesh
      real(kind=DP), intent(inout) :: kmesh(3,nkmesh*nsym_trs)
      real(kind=DP), intent(in) :: mp_kmesh(3,nkmesh)
      real(kind=DP), intent(in) :: grot(3,3,nsym_trs)

      real(kind=DP), allocatable :: kt_mesh(:,:)

      integer :: i, j, n
      logical :: new_kp
      real(kind=DP) :: v(3)
! ===
      integer :: ix, iy, iz, ndiv_x, ndiv_y, ndiv_z
      integer :: nx, ny, nz
      integer :: range_xs, range_ys, range_zs, range_xe, range_ye, range_ze
      integer :: m1, m2, num1, num2, num3, j1, j2, n1, n2
      real(kind=DP) :: w(3), resol_x, resol_y, resol_z, dx, dy, dz
      real(kind=DP) :: eps = 1.0D-10
      real(kind=DP) :: eps2 = 1.0D-3

      type t_kpt_segment
         integer :: nkpt
         integer, allocatable :: list(:,:)
         integer :: nkpt_reg
         integer, allocatable :: list_reg(:,:)
      end type t_kpt_segment
      type(t_kpt_segment), allocatable :: kpt_segment(:,:,:)
      if ( kpt_save_memory_mode == 1 ) then
         if ( npes > 1 .and. mype /= 0 ) goto 1000
      endif

      allocate( kt_mesh(3,nmp_kmesh) ); kt_mesh = 0

#ifndef EXPERIMENTAL_REGEN_KMESH
      Do i=1, nmp_kmesh
         kt_mesh(1,i) = mp_kmesh(1,i)
         kt_mesh(2,i) = mp_kmesh(2,i)
         kt_mesh(3,i) = mp_kmesh(3,i)
      End Do
#else
      Do i=1, nmp_kmesh
         kt_mesh(1,i) = mp_kmesh(1,i) -kshf(1)
         kt_mesh(2,i) = mp_kmesh(2,i) -kshf(2)
         kt_mesh(3,i) = mp_kmesh(3,i) -kshf(3)
      End Do
#endif

      resol_x = 1.0d0 /dble(ndiv_segment(1))
      resol_y = 1.0d0 /dble(ndiv_segment(2))
      resol_z = 1.0d0 /dble(ndiv_segment(3))
!
#if 1
      ndiv_x = nint( ( 1.0d0 +kshift(1) ) /resol_x )
      ndiv_y = nint( ( 1.0d0 +kshift(2) ) /resol_y )
      ndiv_z = nint( ( 1.0d0 +kshift(3) ) /resol_z )
#else
      ndiv_x = int( ( 1.0d0 +kshift(1) ) /resol_x ) +1
      ndiv_y = int( ( 1.0d0 +kshift(2) ) /resol_y ) +1
      ndiv_z = int( ( 1.0d0 +kshift(3) ) /resol_z ) +1
#endif

      allocate( kpt_segment( -ndiv_x:ndiv_x, -ndiv_y:ndiv_y, -ndiv_z:ndiv_z ) )
      kpt_segment(:,:,:)%nkpt = 0

      do i=1,nmp_kmesh
         do n=1,nsym_trs
#if 1
            if ( n==1 ) then
               v(1:3) = kt_mesh(1:3,i)
            else
               v(1:3) = grot(1:3,1,n)*kt_mesh(1,i) +grot(1:3,2,n)*kt_mesh(2,i) &
                    & + grot(1:3,3,n)*kt_mesh(3,i)
            endif
#else
            v(1:3) = grot(1:3,1,n)*kt_mesh(1,i) +grot(1:3,2,n)*kt_mesh(2,i) &
                 & + grot(1:3,3,n)*kt_mesh(3,i)
#endif
            ix = nint( v(1) /resol_x )
            iy = nint( v(2) /resol_y )
            iz = nint( v(3) /resol_z )
            kpt_segment(ix,iy,iz)%nkpt = kpt_segment(ix,iy,iz)%nkpt +1
         end do
      end do
      Do ix=-ndiv_x, ndiv_x
         Do iy=-ndiv_y, ndiv_y
            Do iz=-ndiv_z, ndiv_z
               num1 = kpt_segment(ix,iy,iz)%nkpt
               if ( num1 > 0 ) allocate( kpt_segment(ix,iy,iz)%list(num1,2) )
            End Do
         ENd Do
      end Do
      kpt_segment(:,:,:)%nkpt = 0

      do i=1,nmp_kmesh
         do n=1,nsym_trs
#if 1
            if ( n==1 ) then
               v(1:3) = kt_mesh(1:3,i)
            else
               v(1:3) = grot(1:3,1,n)*kt_mesh(1,i) +grot(1:3,2,n)*kt_mesh(2,i) &
                    & + grot(1:3,3,n)*kt_mesh(3,i)
            endif
#else
            v(1:3) = grot(1:3,1,n)*kt_mesh(1,i) +grot(1:3,2,n)*kt_mesh(2,i) &
                 & + grot(1:3,3,n)*kt_mesh(3,i)
#endif
            ix = nint( v(1) /resol_x )
            iy = nint( v(2) /resol_y )
            iz = nint( v(3) /resol_z )

            kpt_segment(ix,iy,iz)%nkpt = kpt_segment(ix,iy,iz)%nkpt +1
            num1 = kpt_segment(ix,iy,iz)%nkpt
            kpt_segment(ix,iy,iz)%list(num1,1) = i
            kpt_segment(ix,iy,iz)%list(num1,2) = n
         End do
      End do

      nkmesh = 0

      kpt_segment(:,:,:)%nkpt_reg = 0
      Do ix=-ndiv_x, ndiv_x
         Do iy=-ndiv_y, ndiv_y
            Do iz=-ndiv_z, ndiv_z
               num1 = kpt_segment(ix,iy,iz)%nkpt
               if ( num1 > 0 ) allocate( kpt_segment(ix,iy,iz)%list_reg(num1,2 ) )
            End Do
         ENd Do
      end Do

#if 1
      nkmesh=1;     kmesh(1:3,nkmesh) = kt_mesh(1:3,1)
      v(1:3) = kt_mesh(1:3,1)
      ix = nint( v(1) /resol_x )
      iy = nint( v(2) /resol_y )
      iz = nint( v(3) /resol_z )
      kpt_segment(ix,iy,iz)%nkpt_reg = kpt_segment(ix,iy,iz)%nkpt_reg +1
      num1 = kpt_segment(ix,iy,iz)%nkpt_reg
      kpt_segment(ix,iy,iz)%list_reg(num1,1) = 1
      kpt_segment(ix,iy,iz)%list_reg(num1,2) = 1       ! E
#endif

      do i=1,nmp_kmesh
         do n=1,nsym_trs
#if 1
            if ( n==1 ) then
               v(1:3) = kt_mesh(1:3,i)
            else
               v(1:3) = grot(1:3,1,n)*kt_mesh(1,i) +grot(1:3,2,n)*kt_mesh(2,i) &
                    & + grot(1:3,3,n)*kt_mesh(3,i)
            endif
#else
            v(1:3) = grot(1:3,1,n)*kt_mesh(1,i) +grot(1:3,2,n)*kt_mesh(2,i) &
                 & + grot(1:3,3,n)*kt_mesh(3,i)
#endif
            ix = nint( v(1) /resol_x )
            iy = nint( v(2) /resol_y )
            iz = nint( v(3) /resol_z )
!
            dx = v(1) -ix *resol_x
            dy = v(2) -iy *resol_y
            dz = v(3) -iz *resol_z
!
            range_xs = 0;  range_ys = 0;    range_zs = 0
            range_xe = 0;  range_ye = 0;    range_ze = 0
            if ( dx < -resol_x /2. +eps2 ) range_xs = -1
            if ( dx >  resol_x /2. -eps2 ) range_xe =  1
            if ( dy < -resol_y /2. +eps2 ) range_ys = -1
            if ( dy >  resol_y /2. -eps2 ) range_ye =  1
            if ( dz < -resol_z /2. +eps2 ) range_zs = -1
            if ( dz >  resol_z /2. -eps2 ) range_ze =  1

            new_kp = .true.

            nxloop: Do nx=range_xs, range_xe
               Do ny=range_ys, range_ye
                  Do nz=range_zs, range_ze
                     num1 = ix +nx
                     num2 = iy +ny
                     num3 = iz +nz
                     if ( num1 < -ndiv_x .or. num1 > ndiv_x ) cycle
                     if ( num2 < -ndiv_y .or. num2 > ndiv_y ) cycle
                     if ( num3 < -ndiv_z .or. num3 > ndiv_z ) cycle

                     do j1=1, kpt_segment(num1,num2,num3)%nkpt_reg
                        m1 = kpt_segment(num1,num2,num3)%list_reg(j1,1)
                        m2 = kpt_segment(num1,num2,num3)%list_reg(j1,2)
                        w(1:3) = grot(1:3,1,m2) *kt_mesh(1,m1) &
                             &  +grot(1:3,2,m2) *kt_mesh(2,m1) &
                             &  +grot(1:3,3,m2) *kt_mesh(3,m1)
                        if ( abs(v(1)-w(1)) < eps &
                             & .and. abs(v(2)-w(2)) < eps &
                             & .and. abs(v(3)-w(3)) < eps ) then
                           new_kp = .false.;  exit nxloop
                        end if
                     end do

                  end Do
               end Do
            end Do nxloop

            if (new_kp) then
               nkmesh = nkmesh +1;
               kmesh(1:3,nkmesh) = v(1:3)
               kpt_segment(ix,iy,iz)%nkpt_reg = kpt_segment(ix,iy,iz)%nkpt_reg +1

               num1 = kpt_segment(ix,iy,iz)%nkpt_reg
               kpt_segment(ix,iy,iz)%list_reg(num1,1) = i
               kpt_segment(ix,iy,iz)%list_reg(num1,2) = n
            end if
         End do
      End do
      deallocate( kpt_segment )

#ifdef EXPERIMENTAL_REGEN_KMESH
      Do i=1, nkmesh
         kmesh(1,i) = kmesh(1,i) +kshf(1)
         kmesh(2,i) = kmesh(2,i) +kshf(2)
         kmesh(3,i) = kmesh(3,i) +kshf(3)
      End Do
#endif
      deallocate( kt_mesh )

1000  continue
      if ( kpt_save_memory_mode == 1 ) then
         if ( npes > 1 ) then
            call mpi_bcast( nkmesh, 1, mpi_integer, 0, MPI_CommGroup, ierr )
            call mpi_bcast( kmesh, nkmesh, mpi_double_precision, &
                 &          0, MPI_CommGroup, ierr )
         endif
      endif

    end subroutine regen_kmesh_using_grot_segment

    subroutine set_number_nsym_trs( nsym, rot, magnetic, use_trs, nsym_trs )
      integer, intent(in) :: nsym
      logical, intent(in) :: magnetic, use_trs
      real(kind=DP), intent(in) :: rot(3,3,nsym)

      integer, intent(out) :: nsym_trs

      integer :: i
      logical :: with_inverse

      real(kind=DP), parameter :: eps = 1.d-8

! check if the inverse operation is in rot
      with_inverse = .false.

      do i=1,nsym
         if ( abs(rot(1,1,i)+1.d0) < eps .and. &
              & abs(rot(2,2,i)+1.d0) < eps .and. &
              & abs(rot(3,3,i)+1.d0) < eps .and. &
              & abs(rot(1,2,i)) < eps .and. &
              & abs(rot(2,1,i)) < eps .and. &
              & abs(rot(2,3,i)) < eps .and. &
              & abs(rot(3,2,i)) < eps .and. &
              & abs(rot(3,1,i)) < eps .and. &
              & abs(rot(1,3,i)) < eps ) then
            with_inverse = .true.
         end if
      end do

! ----------------------------------------------
!    if(magnetic) with_inverse = .true.
! ---------------------------------------------

#if 0
      if ( magnetic ) then
         if ( .not. noncol ) with_inverse = .true.
      endif
#endif

! ----------------------------------------------
!    if(with_inverse) then
!      nsym_trs = nsym
!    else
!      if(use_trs) then
!         nsym_trs = nsym*2
!      else
!         nsym_trs = nsym
!      end if
!    end if
!    allocate(rot_trs(3,3,nsym_trs),grot(3,3,nsym_trs))
!    do i=1,nsym
!      rot_trs(1:3,1:3,i) = rot(1:3,1:3,i)
!    end do
!    if(use_trs .and. .not.with_inverse) then
!      do i=nsym+1,nsym_trs
!        rot_trs(1:3,1:3,i) = -rot(1:3,1:3,i-nsym)
!      end do
!    end if
! ------------------------------------------------------

      if ( noncol ) then
         if(with_inverse) then
            nsym_trs = nsym
         else
            if(use_trs) then
               nsym_trs = nsym*2
            else
               nsym_trs = nsym
            end if
         end if
      else
         if(with_inverse) then
            nsym_trs = nsym
         else
            if(use_trs) then
               nsym_trs = nsym*2
            else
               nsym_trs = nsym
            end if
         end if
      endif

    end subroutine set_number_nsym_trs

    subroutine gen_rot_trs( nsym, rot, nsym_trs, rot_trs )
      integer, intent(in) :: nsym, nsym_trs
      real(kind=DP), intent(in) :: rot(3,3,nsym)
      real(kind=DP), intent(out) :: rot_trs(3,3,nsym_trs)

      integer :: i

      do i=1,nsym
         rot_trs(1:3,1:3,i) = rot(1:3,1:3,i)
      end do
      if ( nsym_trs > nsym ) then
         do i=nsym+1,nsym_trs
            rot_trs(1:3,1:3,i) = -rot(1:3,1:3,i-nsym)
         end do
      end if

    end subroutine gen_rot_trs
! ====================================================================== 11.0P

    subroutine gen_gmesh(mp_index,nmesh,gmesh)
      implicit none

      integer, intent(in) :: mp_index(3)
      integer, intent(in) :: nmesh
      real(kind=DP), intent(out) :: gmesh(3,nmesh)

      ! local variables
      integer :: i,j,k,n

      n=0
      do i=-mp_index(1),mp_index(1)
        do j=-mp_index(2),mp_index(2)
          do k=-mp_index(3),mp_index(3)
            n=n+1
            gmesh(1,n)=dble(i)/mp_index(1)
            gmesh(2,n)=dble(j)/mp_index(2)
            gmesh(3,n)=dble(k)/mp_index(3)
          end do
        end do
      end do

    end subroutine gen_gmesh

    subroutine first_bz(b1,b2,b3,nkmesh,kmesh,nfbz_kmesh,fbz_kmesh &
    & ,nface,face)
      implicit none

      real(kind=DP), intent(in) :: b1(3),b2(3),b3(3)
      integer, intent(in) :: nkmesh
      real(kind=DP), intent(in) :: kmesh(3,nkmesh)
      integer, intent(out) :: nfbz_kmesh
      real(kind=DP), intent(out) :: fbz_kmesh(3,nkmesh)
      integer, intent(in) :: nface,face(3,nface_max)

      ! local variables
      integer :: i,j,k
      real(kind=DP) :: g(3),q(3),gg,qg,g1(3),g2(3),g3(3),diff
      logical :: exists_in_fbz(nkmesh),trans_sym
      real(kind=DP), parameter :: eps = 1.d-8

      g1(1:3)=b1(1:3)*0.5d0
      g2(1:3)=b2(1:3)*0.5d0
      g3(1:3)=b3(1:3)*0.5d0

      ! restrict k-points within FBZ
      exists_in_fbz(1:nkmesh) = .true.
      do i=1,nface
        g(1:3) = face(1,i)*g1(1:3) + face(2,i)*g2(1:3) + face(3,i)*g3(1:3)
        gg = sum(g(1:3)*g(1:3))
        do j=1,nkmesh
          q(1:3) = kmesh(1,j)*b1(1:3) + kmesh(2,j)*b2(1:3) + kmesh(3,j)*b3(1:3)
          qg = sum(q(1:3)*g(1:3))
          if(qg > gg + eps) exists_in_fbz(j) = .false.
        end do
      end do

      ! traslational symmetry
      loop_1: do i=1,nkmesh
        if(.not.exists_in_fbz(i)) cycle loop_1
        loop_2: do j=i+1,nkmesh
          if(.not.exists_in_fbz(j)) cycle loop_2
          trans_sym = .true.
          do k=1,3
            diff =  kmesh(k,i) - kmesh(k,j)
            if(abs(dble(nint(diff))-diff) .gt. eps) trans_sym = .false.
          end do
          if(trans_sym) exists_in_fbz(j) = .false.
        end do loop_2
      end do loop_1

      nfbz_kmesh=0
      do i=1,nkmesh
        if(exists_in_fbz(i)) then
          nfbz_kmesh=nfbz_kmesh+1
          fbz_kmesh(1:3,nfbz_kmesh)=kmesh(1:3,i)
        end if
      end do

    end subroutine first_bz

    subroutine first_bz_segment(b1,b2,b3,nkmesh,kmesh,nfbz_kmesh,fbz_kmesh &
         & ,nface,face)
      implicit none

      real(kind=DP), intent(in) :: b1(3),b2(3),b3(3)
      integer, intent(in) :: nkmesh
      real(kind=DP), intent(in) :: kmesh(3,nkmesh)
      integer, intent(out) :: nfbz_kmesh
      real(kind=DP), intent(out) :: fbz_kmesh(3,nkmesh)
      integer, intent(in) :: nface,face(3,nface_max)

      ! local variables
      integer :: i,j,k
      real(kind=DP) :: g(3),q(3),gg,qg,g1(3),g2(3),g3(3),diff
      logical :: trans_sym
      real(kind=DP), parameter :: eps = 1.d-8
      logical, allocatable :: exists_in_fbz(:)
      real(kind=DP) :: eps2 = 1.0D-3

      integer :: ndiv_x, ndiv_y, ndiv_z
      integer :: ix, iy, iz, nx, ny, nz, j1, m1, mx, my, mz, jx, jy, jz
      integer :: num1, num2, num3, range_x2, range_y2, range_z2
      integer :: range_xs, range_xe, range_ys, range_ye, range_zs, range_ze
      real(kind=DP) :: resol_x, resol_y, resol_z, v(3)
      real(kind=DP) :: dx, dy, dz

      type t_kpt_segment
         integer :: nkpt
         integer, allocatable :: list(:,:)
         integer :: nkpt_reg
         integer, allocatable :: list_reg(:,:)
      end type t_kpt_segment
      type(t_kpt_segment), allocatable :: kpt_segment(:,:,:)

      if ( kpt_save_memory_mode == 1 ) then
         if ( npes > 1 .and. mype /= 0 ) goto 1000
      endif

      allocate( exists_in_fbz(nkmesh) )

      g1(1:3)=b1(1:3)*0.5d0
      g2(1:3)=b2(1:3)*0.5d0
      g3(1:3)=b3(1:3)*0.5d0

      ! restrict k-points within FBZ
      exists_in_fbz(1:nkmesh) = .true.
      do i=1,nface
        g(1:3) = face(1,i)*g1(1:3) + face(2,i)*g2(1:3) + face(3,i)*g3(1:3)
        gg = sum(g(1:3)*g(1:3))
        do j=1,nkmesh
          q(1:3) = kmesh(1,j)*b1(1:3) + kmesh(2,j)*b2(1:3) + kmesh(3,j)*b3(1:3)
          qg = sum(q(1:3)*g(1:3))
          if(qg > gg + eps) exists_in_fbz(j) = .false.
        end do
      end do

      resol_x = 1.0d0 /dble(ndiv_segment(1))
      resol_y = 1.0d0 /dble(ndiv_segment(2))
      resol_z = 1.0d0 /dble(ndiv_segment(3))

      ndiv_x = nint( ( 1.0d0 +kshift(1) ) /resol_x )
      ndiv_y = nint( ( 1.0d0 +kshift(2) ) /resol_y )
      ndiv_z = nint( ( 1.0d0 +kshift(3) ) /resol_z )
!      ndiv_x = nint( ( 2.0d0 +kshift(1) ) /resol_x )
!      ndiv_y = nint( ( 2.0d0 +kshift(2) ) /resol_y )
!      ndiv_z = nint( ( 2.0d0 +kshift(3) ) /resol_z )

      allocate( kpt_segment( -ndiv_x:ndiv_x, -ndiv_y:ndiv_y, -ndiv_z:ndiv_z ) )
      kpt_segment(:,:,:)%nkpt = 0

      do i=1,nkmesh
         v(1:3) = kmesh(1:3,i)
         ix = nint( v(1) /resol_x )
         iy = nint( v(2) /resol_y )
         iz = nint( v(3) /resol_z )
         kpt_segment(ix,iy,iz)%nkpt = kpt_segment(ix,iy,iz)%nkpt +1
      end do
      Do ix=-ndiv_x, ndiv_x
         Do iy=-ndiv_y, ndiv_y
            Do iz=-ndiv_z, ndiv_z
               num1 = kpt_segment(ix,iy,iz)%nkpt
               if ( num1 > 0 ) allocate( kpt_segment(ix,iy,iz)%list(num1,1) )
            End Do
         ENd Do
      end Do
      kpt_segment(:,:,:)%nkpt = 0

      do i=1, nkmesh
         v(1:3) = kmesh(1:3,i)
         ix = nint( v(1) /resol_x )
         iy = nint( v(2) /resol_y )
         iz = nint( v(3) /resol_z )
         kpt_segment(ix,iy,iz)%nkpt = kpt_segment(ix,iy,iz)%nkpt +1
         num1 = kpt_segment(ix,iy,iz)%nkpt
         kpt_segment(ix,iy,iz)%list(num1,1) = i
      End do

      range_x2 = 1;      range_y2 = 1;      range_z2 = 1
!      range_x2 = 2;      range_y2 = 2;      range_z2 = 2

      ! traslational symmetry
      loop_1: do i=1,nkmesh
         if (.not.exists_in_fbz(i)) cycle loop_1
         v(1:3) = kmesh(1:3,i)
         ix = nint( v(1) /resol_x )
         iy = nint( v(2) /resol_y )
         iz = nint( v(3) /resol_z )

         dx = v(1) -ix *resol_x
         dy = v(2) -iy *resol_y
         dz = v(3) -iz *resol_z
!
         range_xs = 0;  range_ys = 0;    range_zs = 0
         range_xe = 0;  range_ye = 0;    range_ze = 0
         if ( dx < -resol_x /2. +eps2 ) range_xs = -1
         if ( dx >  resol_x /2. -eps2 ) range_xe =  1
         if ( dy < -resol_y /2. +eps2 ) range_ys = -1
         if ( dy >  resol_y /2. -eps2 ) range_ye =  1
         if ( dz < -resol_z /2. +eps2 ) range_zs = -1
         if ( dz >  resol_z /2. -eps2 ) range_ze =  1
!
         Do mx=range_xs, range_xe
            Do my=range_ys, range_ye
               Do mz=range_zs, range_ze
                  jx = ix +mx;   jy = iy +my;   jz = iz +mz
                  do nx=-range_x2, range_x2
                     do ny=-range_y2, range_y2
                        do nz=-range_z2, range_z2
                           num1 = jx +ndiv_segment(1) *nx
                           num2 = jy +ndiv_segment(2) *ny
                           num3 = jz +ndiv_segment(3) *nz
                           if ( num1 < -ndiv_x .or. num1 > ndiv_x ) cycle
                           if ( num2 < -ndiv_y .or. num2 > ndiv_y ) cycle
                           if ( num3 < -ndiv_z .or. num3 > ndiv_z ) cycle

                           loop_2: do j1=1, kpt_segment(num1,num2,num3)%nkpt
                              m1 = kpt_segment(num1,num2,num3)%list(j1,1)
                              if ( m1 <= i ) cycle
                              if (.not.exists_in_fbz(m1)) cycle loop_2

                              trans_sym = .true.
                              do k=1,3
                                 diff = kmesh(k,i) - kmesh(k,m1)
                                 if ( abs( dble( nint(diff)) -diff ) .gt. eps) &
                                      &        trans_sym = .false.
                              end do
                              if(trans_sym) exists_in_fbz(m1) = .false.
                           end do loop_2
                        end do
                     end do
                  end do
               end do
            end do
         end do
      end do loop_1

      deallocate( kpt_segment )

      nfbz_kmesh=0
      do i=1,nkmesh
        if(exists_in_fbz(i)) then
          nfbz_kmesh=nfbz_kmesh+1
          fbz_kmesh(1:3,nfbz_kmesh)=kmesh(1:3,i)
        end if
      end do
      deallocate( exists_in_fbz )

1000  continue
      if ( kpt_save_memory_mode == 1 ) then
         if ( npes > 1 ) then
            call mpi_bcast( nfbz_kmesh, 1, mpi_integer, 0, MPI_CommGroup, ierr )
            call mpi_bcast( fbz_kmesh, 3*nfbz_kmesh, mpi_double_precision, &
                 &          0, MPI_CommGroup, ierr )
         endif
      endif

    end subroutine first_bz_segment

    subroutine fbz_face(b1,b2,b3,nface,face)
      implicit none

      real(kind=DP), intent(in) :: b1(3),b2(3),b3(3)
      integer, intent(out) :: nface
      integer, intent(out) :: face(3,nface_max)

      ! local variables
      integer :: i,j,k,n
      real(kind=DP) :: gg_ref,gg
      real(kind=DP) :: g1(3),g2(3),g3(3)
      real(kind=DP) :: gface(3,nface_max)
      integer :: iface(3,nface_max)
      logical :: exists_in_fbz(nface_max)
      real(kind=DP), parameter :: lambda = 1.d0+1.d-8

      g1(1:3)=b1(1:3)*0.5d0
      g2(1:3)=b2(1:3)*0.5d0
      g3(1:3)=b3(1:3)*0.5d0

      n=0
      do i=-2,2
        do j=-2,2
          do k=-2,2
            if(i == 0 .and. j == 0 .and. k == 0) cycle
            n=n+1
            gface(1:3,n) = i*g1(1:3) + j*g2(1:3) + k*g3(1:3)
            iface(1,n)=i
            iface(2,n)=j
            iface(3,n)=k
          end do
        end do
      end do

      exists_in_fbz(1:nface_max) = .true.
      do i=1,n
        if(exists_in_fbz(i)) then
          gg_ref = gface(1,i)**2 + gface(2,i)**2 + gface(3,i)**2
          do j=1,n
            if(i /= j) then
              gg = gface(1,i)*gface(1,j) + gface(2,i)*gface(2,j) + gface(3,i)*gface(3,j)
              if(gg*lambda > gg_ref) exists_in_fbz(j) = .false.
            end if
          end do
        end if
      end do

      nface=0
      do i=1,n
        if(exists_in_fbz(i)) then
          nface=nface+1
          face(1:3,nface)=iface(1:3,i)
        end if
      end do

      ! debug
      !if(printable .and. printlevel .ge. 3) then
      !  write(output,*) 'nface=',nface
      !  write(output,'(4(1x,a3))') ' no',' n1',' n2',' n3'
      !  do i=1,nface
      !    write(output,'(4(1x,i3))') i,face(1:3,i)
      !  end do
      !end if
      !stop 'debug fbz_face'
      ! end debug

    end subroutine fbz_face

    subroutine get_grot(a1,a2,a3,b1,b2,b3,nsym,rot,grot)
      implicit none

      real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
      real(kind=DP), intent(in) :: b1(3),b2(3),b3(3)
      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: rot(3,3,nsym)
      real(kind=DP), intent(out) :: grot(3,3,nsym)

      ! local variables
      integer :: n,i,j
      real(kind=DP) :: amat(3,3),bmat(3,3)

      amat(1:3,1) = a1(1:3)
      amat(1:3,2) = a2(1:3)
      amat(1:3,3) = a3(1:3)
      bmat(1:3,1) = b1(1:3)
      bmat(1:3,2) = b2(1:3)
      bmat(1:3,3) = b3(1:3)

      do n=1,nsym
        do j=1,3
          do i=1,3
            grot(i,j,n) = element(amat(1,i),bmat(1,j),rot(1,1,n))
          end do
        end do
      end do


! === KT_add === 2014/08/14 & 13.2S
      do n=1, nsym
         if ( noncol .or. sw_use_magnetic_symmetry == ON ) then
            if(magmom_dir_inversion_opr_flag(n) == -1 ) then
               grot(:,:,n) = -grot(:,:,n)
            endif
         endif
      end do
! ============== 2014/08/14 & 13.2S

    end subroutine get_grot

    function element(a,b,rot) result(value)
      implicit none

      real(kind=DP) :: value

      real(kind=DP), intent(in) :: a(3),b(3),rot(3,3)

      ! local variables
      integer :: i,j

      value = 0.d0

      do j=1,3
        do i=1,3
          value = value + a(i)*rot(i,j)*b(j)
        end do
      end do

    end function element

    subroutine gen_spk( nsym, grot, nfbz_kmesh, fbz_kmesh, nkpoint, nkpmax,  &
         &              kpoint, weight )
      implicit none

      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: grot(3,3,nsym)
      integer, intent(in) :: nfbz_kmesh
      real(kind=DP), intent(in) :: fbz_kmesh(3,nfbz_kmesh)
      integer, intent(inout) :: nkpoint
      integer, intent(in) :: nkpmax
      real(kind=DP), intent(inout) :: kpoint(3,nkpmax), weight(nkpmax)

      ! local variables
      integer :: i,j,n
      integer :: nequiv(nkpmax)
      real(kind=DP) :: g(3),q(3)
!      real(kind=DP), parameter :: eps = 1.d-3
      real(kind=DP), parameter :: eps = 1.d-5
      logical :: not_included(nfbz_kmesh)

      not_included(1:nfbz_kmesh) = .true.

      nkpoint = 0
      do i=1,nfbz_kmesh
        if(not_included(i)) then
          nkpoint = nkpoint+1
          if(nkpoint > nkpmax) call phase_error_with_msg(nfout,'gen_spk: nkpoint > nkpmax',__LINE__,__FILE__)
          g(1:3) = fbz_kmesh(1:3,i)
          kpoint(1:3,nkpoint) = g(1:3)
          nequiv(nkpoint) = 1

          do j=i+1,nfbz_kmesh
            do n=1,nsym
              q(1:3) = grot(1:3,1,n)*fbz_kmesh(1,j) + grot(1:3,2,n)*fbz_kmesh(2,j) + grot(1:3,3,n)*fbz_kmesh(3,j)

              if(sum((g(1:3)-q(1:3))**2) < eps .and. not_included(j)) then
                nequiv(nkpoint) = nequiv(nkpoint)+1
                not_included(j) = .false.
              end if

              ! debug
              !write(output,'(i2,3(1x,f10.5),2x,3(1x,f10.5),2x,l1)') n,g(1:3),q(1:3),not_included(j)
              ! end debug
            end do
          end do
        end if
      end do

      ! debug
      !do i=1,nfbz_kmesh
      !  write(output,'(3(1x,f10.5),1x,l1)') fbz_kmesh(1:3,i), not_included(i)
      !end do
      ! end debug

      n=sum(nequiv(1:nkpoint))
      do i=1,nkpoint
        weight(i) = dble(nequiv(i))/dble(n)
      end do

    end subroutine gen_spk

! === KT_add ==== 2014/09/30
    subroutine gen_spk2( nsym, grot, nfbz_kmesh, fbz_kmesh, nkpoint, nkpmax,  &
         &               kpoint, weight, kpoint_index_in_ibz )
      implicit none

      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: grot(3,3,nsym)
      integer, intent(in) :: nfbz_kmesh
      real(kind=DP), intent(in) :: fbz_kmesh(3,nfbz_kmesh)
      integer, intent(inout) :: nkpoint
      integer, intent(in) :: nkpmax
      real(kind=DP), intent(inout) :: kpoint(3,nkpmax), weight(nkpmax)
      integer, optional, intent(inout) :: kpoint_index_in_ibz(nfbz_kmesh)

      ! local variables
      integer :: i,j,n
      integer :: nequiv(nkpmax)
      real(kind=DP) :: g(3), q(3), vec_tmp(3)
!      real(kind=DP), parameter :: eps = 1.d-3
      real(kind=DP), parameter :: eps = 1.d-5
      logical :: not_included(nfbz_kmesh)

      not_included(1:nfbz_kmesh) = .true.

      nkpoint = 0
      do i=1,nfbz_kmesh
         if(not_included(i)) then
            nkpoint = nkpoint+1
            if(nkpoint > nkpmax) call phase_error_with_msg(nfout,'gen_spk: nkpoint > nkpmax',__LINE__,__FILE__)
            g(1:3) = fbz_kmesh(1:3,i)
            kpoint(1:3,nkpoint) = g(1:3)
            nequiv(nkpoint) = 1
! ============ KT_add === 2014/09/30
            if ( present(kpoint_index_in_ibz) ) kpoint_index_in_ibz(i) = nkpoint
! ======================= 2014/09/30

            do j=i+1,nfbz_kmesh
               do n=1,nsym
                  q(1:3) = grot(1:3,1,n)*fbz_kmesh(1,j) &
                       &    +grot(1:3,2,n)*fbz_kmesh(2,j) &
                       &    +grot(1:3,3,n)*fbz_kmesh(3,j)

                  vec_tmp(1:3) = g(1:3) -q(1:3)
                  vec_tmp(1:3) = vec_tmp(1:3) -nint( vec_tmp(1:3) )

                  if ( sum( vec_tmp(1:3)**2 ) < eps .and. not_included(j) ) then
                     nequiv(nkpoint) = nequiv(nkpoint)+1
                     not_included(j) = .false.
! ============ KT_add === 2014/09/30
                     if ( present(kpoint_index_in_ibz) ) &
                          &        kpoint_index_in_ibz( j ) = nkpoint
! ======================= 2014/09/30
                  end if
               end do
            end do
         end if
      end do

      ! debug
      !do i=1,nfbz_kmesh
      !  write(output,'(3(1x,f10.5),1x,l1)') fbz_kmesh(1:3,i), not_included(i)
      !end do
      ! end debug

      n=sum(nequiv(1:nkpoint))
      do i=1,nkpoint
        weight(i) = dble(nequiv(i))/dble(n)
      end do

    end subroutine gen_spk2
! =============== 2014/09/30

    subroutine gen_spk2_segment( nsym, grot, nfbz_kmesh, fbz_kmesh, nkpoint, nkpmax,  &
         &                       kpoint, weight, kpoint_index_in_ibz )
      implicit none

      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: grot(3,3,nsym)
      integer, intent(in) :: nfbz_kmesh
      real(kind=DP), intent(in) :: fbz_kmesh(3,nfbz_kmesh)
      integer, intent(inout) :: nkpoint
      integer, intent(in) :: nkpmax
      real(kind=DP), intent(inout) :: kpoint(3,nkpmax), weight(nkpmax)
      integer, optional, intent(inout) :: kpoint_index_in_ibz(nfbz_kmesh)

      ! local variables
      integer :: i,n
      real(kind=DP) :: g(3), q(3), vec_tmp(3)
!      real(kind=DP), parameter :: eps = 1.d-3
      real(kind=DP), parameter :: eps = 1.d-5
      real(kind=DP) :: eps2 = 1.0D-3

      integer, allocatable :: nequiv(:)
      logical, allocatable :: not_included(:)

      integer :: ndiv_x, ndiv_y, ndiv_z
      integer :: ix, iy, iz, nx, ny, nz, j1, m1, m2, mx, my, mz, jx, jy, jz
      integer :: num1, num2, num3, range_x2, range_y2, range_z2
      integer :: range_xs, range_xe, range_ys, range_ye, range_zs, range_ze
      real(kind=DP) :: resol_x, resol_y, resol_z
      real(kind=DP) :: dx, dy, dz

      type t_kpt_segment
         integer :: nkpt
         integer, allocatable :: list(:,:)
         integer :: nkpt_reg
         integer, allocatable :: list_reg(:,:)
      end type t_kpt_segment
      type(t_kpt_segment), allocatable :: kpt_segment(:,:,:)

      if ( kpt_save_memory_mode == 1 ) then
         if ( npes > 1 .and. mype /= 0 ) goto 1000
      endif

      allocate( nequiv(nkpmax) );  nequiv = 0
      allocate( not_included(nfbz_kmesh) );   not_included(1:nfbz_kmesh) = .true.

      resol_x = 1.0d0 /dble(ndiv_segment(1))
      resol_y = 1.0d0 /dble(ndiv_segment(2))
      resol_z = 1.0d0 /dble(ndiv_segment(3))

      ndiv_x = nint( ( 1.0d0 +kshift(1) ) /resol_x )
      ndiv_y = nint( ( 1.0d0 +kshift(2) ) /resol_y )
      ndiv_z = nint( ( 1.0d0 +kshift(3) ) /resol_z )

      allocate( kpt_segment( -ndiv_x:ndiv_x, -ndiv_y:ndiv_y, -ndiv_z:ndiv_z ) )
      kpt_segment(:,:,:)%nkpt = 0

      do i=1, nfbz_kmesh
         do n=1, nsym
            q(1:3) = grot(1:3,1,n)*fbz_kmesh(1,i) +grot(1:3,2,n)*fbz_kmesh(2,i) &
                 & + grot(1:3,3,n)*fbz_kmesh(3,i)
            ix = nint( q(1) /resol_x )
            iy = nint( q(2) /resol_y )
            iz = nint( q(3) /resol_z )
            kpt_segment(ix,iy,iz)%nkpt = kpt_segment(ix,iy,iz)%nkpt +1
         end do
      end do
      Do ix=-ndiv_x, ndiv_x
         Do iy=-ndiv_y, ndiv_y
            Do iz=-ndiv_z, ndiv_z
               num1 = kpt_segment(ix,iy,iz)%nkpt
               if ( num1 > 0 ) allocate( kpt_segment(ix,iy,iz)%list(num1,2) )
            End Do
         ENd Do
      end Do
      kpt_segment(:,:,:)%nkpt = 0

      do i=1, nfbz_kmesh
         do n=1, nsym
            q(1:3) = grot(1:3,1,n)*fbz_kmesh(1,i) +grot(1:3,2,n)*fbz_kmesh(2,i) &
                 & + grot(1:3,3,n)*fbz_kmesh(3,i)
            ix = nint( q(1) /resol_x )
            iy = nint( q(2) /resol_y )
            iz = nint( q(3) /resol_z )
            kpt_segment(ix,iy,iz)%nkpt = kpt_segment(ix,iy,iz)%nkpt +1
            num1 = kpt_segment(ix,iy,iz)%nkpt
            kpt_segment(ix,iy,iz)%list(num1,1) = i
            kpt_segment(ix,iy,iz)%list(num1,2) = n
         End do
      End do

      range_x2 = 1;  range_y2 = 1;  range_z2 = 1
!      range_x2 = 2;  range_y2 = 2;  range_z2 = 2

      nkpoint = 0
      do i=1,nfbz_kmesh
         if (not_included(i)) then
            nkpoint = nkpoint+1
            if(nkpoint > nkpmax) call phase_error_with_msg(nfout,'gen_spk: nkpoint > nkpmax',__LINE__,__FILE__)
            g(1:3) = fbz_kmesh(1:3,i)
            kpoint(1:3,nkpoint) = g(1:3)
            nequiv(nkpoint) = 1
            if ( present(kpoint_index_in_ibz) ) kpoint_index_in_ibz(i) = nkpoint

            ix = nint( g(1) /resol_x )
            iy = nint( g(2) /resol_y )
            iz = nint( g(3) /resol_z )

            dx = g(1) -ix *resol_x
            dy = g(2) -iy *resol_y
            dz = g(3) -iz *resol_z
!
            range_xs = 0;  range_ys = 0;    range_zs = 0
            range_xe = 0;  range_ye = 0;    range_ze = 0
            if ( dx < -resol_x /2. +eps2 ) range_xs = -1
            if ( dx >  resol_x /2. -eps2 ) range_xe =  1
            if ( dy < -resol_y /2. +eps2 ) range_ys = -1
            if ( dy >  resol_y /2. -eps2 ) range_ye =  1
            if ( dz < -resol_z /2. +eps2 ) range_zs = -1
            if ( dz >  resol_z /2. -eps2 ) range_ze =  1
!
            Do mx=range_xs, range_xe
               Do my=range_ys, range_ye
                  Do mz=range_zs, range_ze
                     jx = ix +mx;   jy = iy +my;   jz = iz +mz

                     Do nx=-range_x2, range_x2
                        Do ny=-range_y2, range_y2
                           Do nz=-range_z2, range_z2
                              num1 = jx +ndiv_segment(1) *nx
                              num2 = jy +ndiv_segment(2) *ny
                              num3 = jz +ndiv_segment(3) *nz
                              if ( num1 < -ndiv_x .or. num1 > ndiv_x ) cycle
                              if ( num2 < -ndiv_y .or. num2 > ndiv_y ) cycle
                              if ( num3 < -ndiv_z .or. num3 > ndiv_z ) cycle

                              do j1=1, kpt_segment(num1,num2,num3)%nkpt
                                 m1 = kpt_segment(num1,num2,num3)%list(j1,1)
                                 m2 = kpt_segment(num1,num2,num3)%list(j1,2)
                                 if ( m1 <= i ) cycle

                                 q(1:3) = grot(1:3,1,m2)*fbz_kmesh(1,m1) &
                                      &    +grot(1:3,2,m2)*fbz_kmesh(2,m1) &
                                      &    +grot(1:3,3,m2)*fbz_kmesh(3,m1)
                                 vec_tmp(1:3) = g(1:3) -q(1:3)
                                 vec_tmp(1:3) = vec_tmp(1:3) -nint( vec_tmp(1:3) )

                                 if ( sum( vec_tmp(1:3)**2 ) < eps &
                                      &   .and. not_included(m1) ) then
                                    nequiv(nkpoint) = nequiv(nkpoint)+1
                                    not_included(m1) = .false.
                                    if ( present(kpoint_index_in_ibz) ) &
                                         &        kpoint_index_in_ibz(m1) = nkpoint
                                 end if
                              end do
                           End Do
                        end do
                     end Do
                  end Do
               end Do
            end do
         end if
      end do
      deallocate( kpt_segment )

      n=sum(nequiv(1:nkpoint))
      do i=1,nkpoint
        weight(i) = dble(nequiv(i))/dble(n)
      end do
      deallocate( nequiv );   deallocate( not_included )

1000  continue

      if ( kpt_save_memory_mode == 1 ) then
         if ( npes > 1 ) then
            call mpi_bcast( nkpoint, 1, mpi_integer, 0, MPI_CommGroup, ierr )
            call mpi_bcast( kpoint, 3*nkpoint, mpi_double_precision, &
                 &          0, MPI_CommGroup, ierr )
            call mpi_bcast( weight, nkpoint, mpi_double_precision, &
                 &          0, MPI_CommGroup, ierr )
            if ( present(kpoint_index_in_ibz) ) then
               call mpi_bcast( kpoint_index_in_ibz, nfbz_kmesh, mpi_integer, &
                    &          0, MPI_CommGroup, ierr )
            endif
         endif
      endif

    end subroutine gen_spk2_segment

    subroutine positive(nsym,grot,nkpoint,kpoint)
      implicit none

      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: grot(3,3,nsym)
      integer, intent(in) :: nkpoint
      real(kind=DP), intent(inout) :: kpoint(3,nkpoint)

      ! local variables
      integer :: i,n
      real(kind=DP) :: g(3)

      do i=1,nkpoint
        if(kpoint(1,i) /= 0.d0 .or. kpoint(2,i) /= 0.d0 .or. kpoint(3,i) /= 0.d0) then
          do n=1,nsym
            g(1:3) = grot(1:3,1,n)*kpoint(1,i) + grot(1:3,2,n)*kpoint(2,i) + grot(1:3,3,n)*kpoint(3,i)
            if(g(1) >= 0.d0 .and. g(2) >= 0.d0 .and. g(3) >= 0.d0) then
              kpoint(1:3,i)=g(1:3)
              exit
            end if
          end do
        end if
      end do

    end subroutine positive

! === ASMS ====
    subroutine positive2( nsym, grot, nkpoint, kpoint, nkpoint_full, kpoint_full )
      implicit none

      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: grot(3,3,nsym)
      integer, intent(in) :: nkpoint, nkpoint_full
      real(kind=DP), intent(inout) :: kpoint(3,nkpoint)
      real(kind=DP), intent(in) :: kpoint_full(3,nkpoint_full)

      integer :: iopr, ik, ikbz
      real(kind=DP) :: v0(3), dk(3)

      Do ik=1, nkpoint
         Do iopr=1, nsym
            v0 = matmul( grot(:,:,iopr), kpoint(:,ik) )

!            write(nfout,*) "ik iopr ", ik, iopr
!            write(nfout,'(A,3F20.10)') "kp ", kpoint(1:3,ik)
!            write(nfout,'(A,3F20.10)') "v0 ", v0(1:3)

            if ( v0(1) >= 0.0d0 .and. v0(2) >= 0.0d0 .and. v0(3) >= 0.0d0 ) then
               LOOP_S: Do ikbz=1, nkpoint_full
                  dk(1:3) = v0(1:3) -kpoint_full(1:3,ikbz)

                  if( abs(dk(1)-nint(dk(1)))<DELTA07  &
                       &      .and. abs(dk(2)-nint(dk(2)))<DELTA07  &
                       &      .and. abs(dk(3)-nint(dk(3)))<DELTA07 ) then
                     kpoint(:,ik) = v0(:)
!                     write(nfout,'(A,3F20.10)') "kp new ", kpoint(1:3,ik)
                     exit LOOP_S
                  endif
               End do LOOP_S
            endif
         End Do
      End Do

    end subroutine positive2
! === ASMS ====

    subroutine accuracy(a1,a2,a3,nsym,grot,nkpoint,kpoint,weight)
      implicit none

      real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: grot(3,3,nsym)
      integer, intent(in) :: nkpoint
      real(kind=DP), intent(in) :: kpoint(3,nkpoint),weight(nkpoint)

      ! local variables
      real(kind=DP) :: rgrid(0:3,ngrid)
      type(shell), allocatable :: rshell(:)
      type(shell) :: rshtmp
      integer, allocatable :: id_sub(:)
      integer :: i,j,k,nsub
      real(kind=DP) :: sm
      integer :: n,istart
      integer :: none_zero
      real(kind=DP) :: sm_nz,length_nz


      if(printable .and. printlevel .ge. 0) &
      &  write(output,'(1x,"number of k-points in irreducible BZ = ",i8)') nkpoint


      call gen_rgrid(a1,a2,a3,rgrid)

      ! debug
      !do i=1,ngrid
      !  write(output,'(3(1x,i4),1x,f10.5)') nint(rgrid(1:3,i)), rgrid(0,i)
      !end do
      !stop 'debug rgrid'
      ! end debug

      istart=2
      n=0
      shell_loop : do
        if( n+1 > nshell ) exit shell_loop
        call get_shell(rgrid,rshtmp,istart)
        allocate(id_sub(rshtmp%ndim))
        call get_subshell(nsym,grot,rshtmp,id_sub,nsub)

        ! debug
        !write(output,*) 'n=',n+1
        !do i=1,rshtmp%ndim
        !  write(output,'(3(1x,i5),1x,i2)') nint(rshtmp%rindex(1:3,i)),id_sub(i)
        !end do
        !stop 'debug rshtmp'
        ! end debug
        allocate(rshell(nsub))
        do i=1,nsub
          allocate(rshell(i)%rindex(3,48))
          rshell(i)%ndim = 0
          do j=1,rshtmp%ndim
            if(id_sub(j) == i) then
              rshell(i)%ndim = rshell(i)%ndim+1
              rshell(i)%rindex(1:3,rshell(i)%ndim) = rshtmp%rindex(1:3,j)
            end if
          end do
          rshell(i)%length=rshtmp%length
        end do
        do i=1,nsub
          if( n+1 > nshell ) exit shell_loop
          n=n+1
          ! debug
          !write(output,'(i5,1x,f10.5,4(1x,i5))') n,rshell(i)%length,nint(rshell(i)%rindex(1:3,1)),rshell(i)%ndim
          ! end debug
          do j=1,rshell(i)%ndim
            if(nint(rshell(i)%rindex(1,j)) == ng ) call phase_error_with_msg(nfout,'accuracy: rindex >= ng',__LINE__,__FILE__)
            if(nint(rshell(i)%rindex(2,j)) == ng ) call phase_error_with_msg(nfout,'accuracy: rindex >= ng',__LINE__,__FILE__)
            if(nint(rshell(i)%rindex(3,j)) == ng ) call phase_error_with_msg(nfout,'accuracy: rindex >= ng',__LINE__,__FILE__)
          end do
          sm=0.d0
          do k=1,nkpoint
             sm = sm + weight(k)*amk(rshell(i)%rindex,rshell(i)%ndim,kpoint(1,k))
          end do

          ! debug
          !write(output,'(i5,2(1x,f10.5))') n, rshell(i)%length, sm
          ! end debug

          if(abs(sm) > 1.d-8) then
            none_zero = n
            sm_nz = sm/dble(2*nkpoint)
            length_nz = rshell(i)%length
            do j=1,nsub
              deallocate(rshell(j)%rindex)
            end do
            deallocate(rshtmp%rindex,rshell,id_sub)
            exit shell_loop
          end if
        end do
        do i=1,nsub
          deallocate(rshell(i)%rindex)
        end do
        deallocate(rshtmp%rindex,rshell,id_sub)
      end do shell_loop

      if( n == nshell ) call phase_error_with_msg(nfout,'accuracy: n == nshell, accuracy check failure',__LINE__,__FILE__)

      if(printable .and. printlevel .ge. 0 ) then
        write(output,'(1x,"Index of the first none zero shell = ",i8)') none_zero
        write(output,'(1x,"|R| of the first none zero shell   = ",f10.5)') length_nz
        write(output,'(1x,"phase sum = ",f10.5)') sm_nz
        write(output,'(1x,"efficiency = ",f8.2)') dble(none_zero)/dble(nkpoint)
      end if

      if(printable .and. printlevel .ge. 1) then
        write(output,'(5x,4(1x,a10))') 'k1','k2','k3','weight'
        do i=1,nkpoint
          write(output,'(i8,4(1x,f10.5))') i,kpoint(1:3,i),weight(i)
        end do
      end if

    end subroutine accuracy

    subroutine gen_rgrid(a1,a2,a3,rgrid)
      implicit none

      real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
      real(kind=DP), intent(out) :: rgrid(0:3,ngrid)

      ! local variables
      integer :: n,i1,i2,i3
      real(kind=DP) :: x(3)

      n=0
      loop_1: do i1=-ng,ng
        loop_2: do i2=-ng,ng
          loop_3: do i3=-ng,ng
            n=n+1
            x(1:3) = i1*a1(1:3) + i2*a2(1:3) + i3*a3(1:3)
            rgrid(0,n) = sqrt(sum(x(1:3)**2))
            rgrid(1,n) = dble(i1)
            rgrid(2,n) = dble(i2)
            rgrid(3,n) = dble(i3)
          end do loop_3
        end do loop_2
      end do loop_1

      call heap_sort(4,ngrid,rgrid,1)

    end subroutine gen_rgrid

    subroutine get_shell(rgrid,rshell,istart)
      implicit none

      real(kind=DP), intent(in) :: rgrid(0:3,ngrid)
      type(shell), intent(out) :: rshell
      integer, intent(inout) :: istart

      ! local variables
      real(kind=DP) :: eps = 1.d-10
      integer :: i,ndim

      ndim=0
      do
        ndim=ndim+1
        if(istart+ndim>ngrid) exit
        if(abs(rgrid(0,istart+ndim)-rgrid(0,istart+ndim-1)) > eps) exit
      end do

      allocate(rshell%rindex(3,ndim))
      do i=1,ndim
        rshell%rindex(1:3,i) = rgrid(1:3,istart+i-1)
      end do
      rshell%length = rgrid(0,istart)
      rshell%ndim = ndim

      istart=istart+ndim

    end subroutine get_shell

    subroutine get_subshell(nsym,grot,rshell,id_sub,nsub)
      implicit none

      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: grot(3,3,nsym)
      type(shell), intent(in) :: rshell
      integer, intent(out) :: id_sub(rshell%ndim)
      integer, intent(out) :: nsub

      ! local variables
      integer :: i,j,n
      real(kind=DP) :: eps=1.d-8
      real(kind=DP) :: v(3)

      id_sub(1:rshell%ndim)=0
      nsub=0
      do i=1,rshell%ndim
        if(id_sub(i) /= 0) cycle
        nsub=nsub+1
        id_sub(i)=nsub
        do n=1,nsym
          v(1:3) =   rshell%rindex(1,i)*grot(1,1:3,n) &
                 & + rshell%rindex(2,i)*grot(2,1:3,n) &
                 & + rshell%rindex(3,i)*grot(3,1:3,n)
          do j=1,rshell%ndim
            if(abs(v(1)-rshell%rindex(1,j)) < eps .and. &
               abs(v(2)-rshell%rindex(2,j)) < eps .and. &
               abs(v(3)-rshell%rindex(3,j)) < eps ) then
              id_sub(j)=id_sub(i)
            end if
          end do
        end do
      end do

    end subroutine get_subshell

    function amk(ri,ndim,kp) result(value)
      use m_Const_Parameters, only : PAI
      implicit none

      real(kind=DP) :: value

      integer, intent(in) :: ndim
      real(kind=DP), intent(in) :: ri(3,ndim),kp(3)

      ! local variables
      integer :: i
      real(kind=DP), parameter :: pi = PAI, pi2=2*pi

      value=0.d0
      do i=1,ndim
        value = value + cos(pi2*sum(kp(1:3)*ri(1:3,i)))
      end do
      value = value/dble(ndim)

    end function amk

  end subroutine special_kpoints

  subroutine gen_special_kpoints( paramset, nfout, printlevel, nkpmax, &
       &                          nfmatbp, nkpoint, vkxyz, qwgt, imag, itrs, &
       &                          nkpoint_full, vkxyz_full, to_ibz_from_fbz_for_kpoint )

    use m_Const_Parameters, only : CARTS, CRDTYP, DP, PAI
    use m_Crystal_Structure, only : altv, rltv, nopr, op

! ========================= added by K. Tagami =========================== 11.0P
    use m_CS_Magnetic,   only : nopr_before_sym_reduction, op_before_sym_reduction
! ======================================================================== 11.0P

    implicit none

    logical, intent(in)        :: paramset
    integer, intent(in)        :: nfout, printlevel, nkpmax
    integer, intent(in)        :: nfmatbp
    integer, intent(inout)     :: nkpoint
    ! if nkpoint == 0 then generating special k-points
    ! else ckecking accuracy of special k-points
    real(kind=DP), intent(out) :: vkxyz(nkpmax,3,CRDTYP),qwgt(nkpmax)
    integer, intent(in)        :: imag
    integer, intent(in)        :: itrs

! === KT_add === 2014/09/30
    integer, intent(inout)     :: nkpoint_full
    real(kind=DP), intent(out) :: vkxyz_full(nkpoint_full,3,CRDTYP)
    integer, intent(out) :: to_ibz_from_fbz_for_kpoint(nkpoint_full)
! ============== 2014/09/30

    ! local variables
    real(kind=DP), parameter :: pi = PAI, pi2=2*pi
    integer       :: i,nk,pl
    real(kind=DP), allocatable, dimension(:,:) :: trmat,trbp,trpb,mat1,mat2
    real(kind=DP) :: v(3)
    real(kind=DP) :: b1(3),b2(3),b3(3)
    real(kind=DP), allocatable :: kpoint(:,:), weight(:)

! === KT_add ==== 2014/09/30
    real(kind=DP), allocatable :: kpoint_full(:,:)
    integer,       allocatable :: kpoint_num_in_ibz(:)
! =============== 2014/09/30

    !!integer, parameter :: nkpmax0 = 10000
    integer :: nkpmax0
    logical :: magnetic
    logical :: use_trs

    if(imag/=PARA) then
       magnetic = .true.
    else
       magnetic = .false.
    end if
    if(itrs == 1) then
       use_trs = .true.
    else
       use_trs = .false.
    end if

    b1(1:3) = rltv(1:3,1)/pi2
    b2(1:3) = rltv(1:3,2)/pi2
    b3(1:3) = rltv(1:3,3)/pi2

    if(paramset) then
      pl = -1
    else
      pl = printlevel
    end if
    !write(nfout,*) 'paramset=',paramset

    if(.not.(allocated(kpoint).or.allocated(weight))) then
      nkpoint = 0 ! for generating special k-points
      nkpmax0 = 2*mp_index(1)*mp_index(2)*mp_index(3)
      ng= 2 * maxval(mp_index)
      ngrid=(2*ng+1)**3
      nshell = nkpmax0
      allocate(kpoint(3,nkpmax0));   allocate(weight(nkpmax0))
! === KT_add === 2014/09/30
      allocate(kpoint_full(3,nkpmax0))
      allocate(kpoint_num_in_ibz(nkpmax0))
! ============== 2014/09/30
    end if

! ==================================== modified by K. Tagami ============== 11.0P
!    call special_kpoints( pl, nfout, nopr, op, &
!    &                     b1, b2, b3, altv(1,1), altv(1,2), altv(1,3), &
!    &                     nkpoint, nkpmax0, kpoint, weight, magnetic, use_trs )
!
    if ( noncol .and. use_op_before_sym_reduction ) then
       call special_kpoints( pl, nfout, nopr, op, &
            &                b1, b2, b3, altv(1,1), altv(1,2), altv(1,3), &
            &                nkpoint, nkpmax0, kpoint, weight, magnetic, use_trs, &
            &                nkpoint_full, kpoint_full, kpoint_num_in_ibz, &
            &                nopr_before_sym_reduction, op_before_sym_reduction )
    else
       call special_kpoints( pl, nfout, nopr, op, &
            &                b1, b2, b3, altv(1,1), altv(1,2), altv(1,3), &
            &                nkpoint, nkpmax0, kpoint, weight, magnetic, use_trs, &
            &                nkpoint_full, kpoint_full, kpoint_num_in_ibz )
    endif
! ========================================================================== 11.0P

    ! exists in m_SpecicalKpoints

    ! debug
    ! stop 'debug b_SpecailKpoints when first calling'
    ! end debug


    if(paramset) then
      deallocate(kpoint,weight);
      deallocate(kpoint_full); deallocate(kpoint_num_in_ibz)
      return
    end if

    allocate(trmat(3,3))
    allocate(trbp(3,3))
    allocate(trpb(3,3))
    allocate(mat1(3,3))
    allocate(mat2(3,3))

    call get_trmat  !-(contained here) ->(trmat)

    do nk = 1, nkpoint
      v(1:3) = kpoint(1:3,nk)
      vkxyz(nk,1:3,CARTS) = matmul(trmat,v)
      qwgt(nk) = weight(nk)
    enddo

! ==== KT_add === 2014/09/30
    do nk = 1, nkpoint_full
      v(1:3) = kpoint_full(1:3,nk)
      vkxyz_full(nk,1:3,CARTS) = matmul(trmat,v)
      to_ibz_from_fbz_for_kpoint(nk) = kpoint_num_in_ibz(nk)
    end do
    deallocate( kpoint_full ); deallocate( kpoint_num_in_ibz )
! =============== 2014/09/30

    deallocate(kpoint,weight)

    deallocate(trmat); deallocate(trbp ); deallocate(trpb )
    deallocate(mat1 ); deallocate(mat2 )

    if(printable .and. printlevel >= 2) then
       write(nfout,'(/,"  << gen_special_kpoints >>")')
       write(nfout,*) ' !Total Generated Kpoints = ',nkpoint
       do nk = 1, nkpoint
         write(nfout,'(i6," ",3f12.6," : ",f12.6)') &
         & nk,(vkxyz(nk,i,CARTS),i=1,3),qwgt(nk)
       end do
    end if

  contains
    subroutine get_trmat
    !    make translation matrix  trpb (P -> B)
      integer  :: i
      logical :: open

      trbp = 0.d0
      do i = 1,3
        trbp(i,i) = 1.d0
      end do

      inquire(unit=nfmatbp, opened = open)
      if(open) then
        rewind nfmatbp
        do i = 1, 3
          read(nfmatbp,*,end=1,err=1) trbp(i,1),trbp(i,2),trbp(i,3)
        enddo
        goto 2
1       trbp = 0.d0
        do i = 1,3
          trbp(i,i) = 1.d0
        end do
2       continue
      end if

      call inver3n(3,trbp,trpb)

      mat1 = transpose(trpb)
      call inver3n(3,mat1,mat2)
      call matpr3(rltv,mat2,trmat)

    end subroutine get_trmat
  end subroutine gen_special_kpoints

  subroutine read_mpindex(input)
    implicit none

    integer, intent(in) :: input

    read(input,*) mp_index(1:3)
    read(input,*) kshift(1:3)

  end subroutine read_mpindex

  subroutine m_Kp_cp_kxyz_to_vkxyz(nk,kxyz)
    integer, intent(in) :: nk
    real(kind=DP),intent(in) :: kxyz(3,nk)
    integer :: i,ik

    if(.not.allocated(vkxyz)) then
       if(ipri_kp >= 1) write(nfout,'(" vkxyz is not allocated")')
       call phase_error_with_msg(nfout,'vkxyz is not allocated',__LINE__,__FILE__)
    end if

    if(ipri_kp>=1) write(nfout,'(" nk = ",i6," <<m_Kp_cp_kxyz_to_vkxyz>>")') nk
    do ik = 1, nk
       vkxyz(ik,1:3,BUCS) = kxyz(1:3,ik)
       if(ipri_kp>=1) write(nfout,'(" kxyz = ",3f10.6)') kxyz(1:3,ik)
    end do

    do ik = 1,nk
       do i = 1, 3
          vkxyz(ik,i,CARTS) = rltv(i,1)*vkxyz(ik,1,BUCS) &
               &            + rltv(i,2)*vkxyz(ik,2,BUCS) &
               &            + rltv(i,3)*vkxyz(ik,3,BUCS)
       end do
    end do

  end subroutine m_Kp_cp_kxyz_to_vkxyz

  subroutine m_Kp_set_kv3(nk)
    integer, intent(in) ::nk
    kv3 = nk
    if(ipri_kp>=1) write(nfout,'(" !kp kv3 = ",i8," <<m_kp_set_kv3>>")') kv3
  end subroutine m_Kp_set_kv3

  subroutine m_Kp_set_mesh_super
    integer :: n
    if( way_ksample == MESH ) then
       n = k_sample_mesh(1,1)
       k_sample_mesh(1,1) = max(nint(dble(n)/n1_sc),1)
!       n = k_sample_mesh(1,1)
       n = k_sample_mesh(2,1)
       k_sample_mesh(2,1) = max(nint(dble(n)/n2_sc),1)
!       n = k_sample_mesh(1,1)
       n = k_sample_mesh(3,1)
       k_sample_mesh(3,1) = max(nint(dble(n)/n3_sc),1)
       k_sample_mesh(:,2) = k_sample_mesh(:,1)

       if(printable) then
          write(nfout,*) 'k-point mesh will be changed.'
          write(nfout,'("mesh=",6i3)') k_sample_mesh
       end if
    else if( way_ksample == MONKHORST_PACK ) then
       n = mp_index(1)
       mp_index(1) = max(nint(dble(n)/n1_sc),1)
       n = mp_index(2)
       mp_index(2) = max(nint(dble(n)/n2_sc),1)
       n = mp_index(3)
       mp_index(3) = max(nint(dble(n)/n3_sc),1)
       if(printable) then
          write(nfout,*) 'k-point mesh will be changed.'
          write(nfout,'("mesh=",3i3)') mp_index
       end if
    end if
  end subroutine m_Kp_set_mesh_super

  subroutine m_Kp_dealloc
    if(allocated(vkxyz)) deallocate(vkxyz)
    if(allocated(qwgt)) deallocate(qwgt)
    if(allocated(k_symmetry)) deallocate(k_symmetry)
    if(allocated(nxyz_tetra)) deallocate(nxyz_tetra)
    if(allocated(ip20)) deallocate(ip20)
    if(allocated(iwt)) deallocate(iwt)
    if(allocated(ip2cub)) deallocate(ip2cub)

! === KT_add ==== 2014/09/30
    if ( allocated( vkxyz_fbz ) ) deallocate( vkxyz_fbz )
    if ( allocated( to_ibz_from_fbz_for_kpoint ) ) then
       deallocate( to_ibz_from_fbz_for_kpoint )
    endif
    if ( allocated( iopr_k_fbz_to_ibz ) ) deallocate( iopr_k_fbz_to_ibz )
    if ( allocated( num_star_of_k ) ) deallocate( num_star_of_k )
    if ( allocated( star_of_k ) ) deallocate( star_of_k )
! ================ 2014/09/30

  end subroutine m_Kp_dealloc

! === KT_add ==== 2014/09/30
!        === modified by T. Y. 2015/01/16 ===
!!$  subroutine gen_kpoint_in_full_BZ( paramset, kv3_fbz, vkxyz_fbz )
  subroutine gen_kpoint_in_full_BZ( paramset)
    logical, intent(in) :: paramset
!!$    integer, intent(in) :: kv3_fbz
!!$    real(kind=DP), intent(inout) :: vkxyz_fbz(kv3_fbz,3,CARTS)
!        ====================================

    integer :: i, ik
    real(kind=DP) :: b1(3), b2(3), b3(3)

    integer :: nface, face(3,nface_max)

    if ( paramset ) return

    b1(1:3) = rltv(1:3,1) /PAI2
    b2(1:3) = rltv(1:3,2) /PAI2
    b3(1:3) = rltv(1:3,3) /PAI2

    do i = 1, 3
       do ik = 1, kv3_fbz
          vkxyz_fbz(ik,i,BUCS) = (altv(1,i) *vkxyz_fbz(ik,1,CARTS) &
               &                + altv(2,i) *vkxyz_fbz(ik,2,CARTS) &
               &                + altv(3,i) *vkxyz_fbz(ik,3,CARTS) ) /PAI2
       enddo
    enddo

    call fbz_face(b1,b2,b3,nface,face)
    call move_kpt_to_inside_fbz( nface, face )

    do i = 1, 3
       do ik = 1, kv3_fbz
          vkxyz_fbz(ik,i,CARTS) = (rltv(i,1) *vkxyz_fbz(ik,1,BUCS) &
               &                + rltv(i,2) *vkxyz_fbz(ik,2,BUCS) &
               &                + rltv(i,3) *vkxyz_fbz(ik,3,BUCS) )
       enddo
    enddo

  contains

    subroutine move_kpt_to_inside_fbz( nface, iface_bz )
      integer, intent(in) :: nface
      integer, intent(in) :: iface_bz(3,nface_max)

      integer :: i, j, ik
      real(kind=DP) :: mtr(3,3)
      real(kind=DP), parameter :: lambda = 1.d0+1.d-8
      real(kind=DP) :: gg, gg_ref, ko(3)
!        === modified by T. Y. 2015/01/16 ===
      integer,parameter :: max_icount = 10000
      integer :: icount
!        ====================================

      do i=1,3
         do j=1,3
            mtr(i,j) = dot_product(rltv(:,i),rltv(:,j))
         end do
      end do

      Do ik=1, kv3_fbz
         ko(1:3) = vkxyz_fbz(ik,1:3,BUCS)
         do i=1,nface
            gg_ref = dot_product(iface_bz(:,i),matmul(mtr,iface_bz(:,i))) * 0.5d0
            icount = 0
            do
               gg = dot_product(iface_bz(:,i),matmul(mtr,ko))
               if(gg > gg_ref*lambda) then
                  ko(1:3) = ko(1:3) - dble(iface_bz(1:3,i))
               else
                  exit
               end if
!        === modified by T. Y. 2015/01/16 ===
               icount = icount+1
               if(icount > max_icount) then
                  write(nfout,'(" icount > max_icount in <<move_kpt_to_inside_fbz>>")')
                  write(nfout,'(" icount = ",i8)') icount
                  call phase_error_with_msg(nfout,' stop at <<move_kpt_to_inside_fbz>>. Icount is too large',__LINE__,__FILE__)
               end if
!        ====================================
            end do
         end do
         vkxyz_fbz(ik,1:3,BUCS) = ko(1:3)
      End do
    end subroutine move_kpt_to_inside_fbz

    subroutine fbz_face(b1,b2,b3,nface,face)
      implicit none

      real(kind=DP), intent(in) :: b1(3),b2(3),b3(3)
      integer, intent(out) :: nface
      integer, intent(out) :: face(3,nface_max)

      ! local variables
      integer :: i,j,k,n
      real(kind=DP) :: gg_ref,gg
      real(kind=DP) :: g1(3),g2(3),g3(3)
      real(kind=DP) :: gface(3,nface_max)
      integer :: iface(3,nface_max)
      logical :: exists_in_fbz(nface_max)
      real(kind=DP), parameter :: lambda = 1.d0+1.d-8

      g1(1:3)=b1(1:3)*0.5d0
      g2(1:3)=b2(1:3)*0.5d0
      g3(1:3)=b3(1:3)*0.5d0

      n=0
      do i=-2,2
        do j=-2,2
          do k=-2,2
            if(i == 0 .and. j == 0 .and. k == 0) cycle
            n=n+1
            gface(1:3,n) = i*g1(1:3) + j*g2(1:3) + k*g3(1:3)
            iface(1,n)=i
            iface(2,n)=j
            iface(3,n)=k
          end do
        end do
      end do

      exists_in_fbz(1:nface_max) = .true.
      do i=1,n
        if(exists_in_fbz(i)) then
          gg_ref = gface(1,i)**2 + gface(2,i)**2 + gface(3,i)**2
          do j=1,n
            if(i /= j) then
              gg = gface(1,i)*gface(1,j) + gface(2,i)*gface(2,j) + gface(3,i)*gface(3,j)
              if(gg*lambda > gg_ref) exists_in_fbz(j) = .false.
            end if
          end do
        end if
      end do

      nface=0
      do i=1,n
        if(exists_in_fbz(i)) then
          nface=nface+1
          face(1:3,nface)=iface(1:3,i)
        end if
      end do

    end subroutine fbz_face

  end subroutine gen_kpoint_in_full_BZ

  subroutine m_Kp_force_kpoint_into_BZ
    integer :: i, ik
    real(kind=DP) :: b1(3), b2(3), b3(3)

    integer :: nface, face(3,nface_max)

    b1(1:3) = rltv(1:3,1) /PAI2
    b2(1:3) = rltv(1:3,2) /PAI2
    b3(1:3) = rltv(1:3,3) /PAI2

    call fbz_face(b1,b2,b3,nface,face)
    call move_kpt_to_inside_fbz( nface, face )

    do i = 1, 3
       do ik = 1, kv3
          vkxyz(ik,i,CARTS) = (rltv(i,1) *vkxyz(ik,1,BUCS) &
               &                + rltv(i,2) *vkxyz(ik,2,BUCS) &
               &                + rltv(i,3) *vkxyz(ik,3,BUCS) )
      enddo
    enddo

  contains

    subroutine move_kpt_to_inside_fbz( nface, iface_bz )
      integer, intent(in) :: nface
      integer, intent(in) :: iface_bz(3,nface_max)

      integer :: i, j, ik
      real(kind=DP) :: mtr(3,3)
      real(kind=DP), parameter :: lambda = 1.d0+1.d-8
      real(kind=DP) :: gg, gg_ref, ko(3)
!        === modified by T. Y. 2015/01/16 ===
      integer,parameter :: max_icount = 10000
      integer :: icount
!        ====================================

      do i=1,3
         do j=1,3
            mtr(i,j) = dot_product(rltv(:,i),rltv(:,j))
         end do
      end do

      Do ik=1, kv3
         ko(1:3) = vkxyz(ik,1:3,BUCS)
         do i=1,nface
            gg_ref = dot_product(iface_bz(:,i),matmul(mtr,iface_bz(:,i))) * 0.5d0
            icount = 0
            do
               gg = dot_product(iface_bz(:,i),matmul(mtr,ko))
               if(gg > gg_ref*lambda) then
                  ko(1:3) = ko(1:3) - dble(iface_bz(1:3,i))
               else
                  exit
               end if
!        === modified by T. Y. 2015/01/16 ===
               icount = icount+1
               if(icount > max_icount) then
                  write(nfout,'(" icount > max_icount in <<move_kpt_to_inside_fbz>>")')
                  write(nfout,'(" icount = ",i8)') icount
                  call phase_error_with_msg(nfout,' stop at <<move_kpt_to_inside_fbz>>. Icount is too large',__LINE__,__FILE__)
               end if
!        ====================================
            end do
         end do
         GvecTrans_kpt(ik,1:3) = nint( ko(1:3) -vkxyz(ik,1:3,BUCS) )
         vkxyz(ik,1:3,BUCS) = ko(1:3)
      ENd Do

    end subroutine move_kpt_to_inside_fbz

    subroutine fbz_face(b1,b2,b3,nface,face)
      implicit none

      real(kind=DP), intent(in) :: b1(3),b2(3),b3(3)
      integer, intent(out) :: nface
      integer, intent(out) :: face(3,nface_max)

      ! local variables
      integer :: i,j,k,n
      real(kind=DP) :: gg_ref,gg
      real(kind=DP) :: g1(3),g2(3),g3(3)
      real(kind=DP) :: gface(3,nface_max)
      integer :: iface(3,nface_max)
      logical :: exists_in_fbz(nface_max)
      real(kind=DP), parameter :: lambda = 1.d0+1.d-8

      g1(1:3)=b1(1:3)*0.5d0
      g2(1:3)=b2(1:3)*0.5d0
      g3(1:3)=b3(1:3)*0.5d0

      n=0
      do i=-2,2
        do j=-2,2
          do k=-2,2
            if(i == 0 .and. j == 0 .and. k == 0) cycle
            n=n+1
            gface(1:3,n) = i*g1(1:3) + j*g2(1:3) + k*g3(1:3)
            iface(1,n)=i
            iface(2,n)=j
            iface(3,n)=k
          end do
        end do
      end do

      exists_in_fbz(1:nface_max) = .true.
      do i=1,n
        if(exists_in_fbz(i)) then
          gg_ref = gface(1,i)**2 + gface(2,i)**2 + gface(3,i)**2
          do j=1,n
            if(i /= j) then
              gg = gface(1,i)*gface(1,j) + gface(2,i)*gface(2,j) + gface(3,i)*gface(3,j)
              if(gg*lambda > gg_ref) exists_in_fbz(j) = .false.
            end if
          end do
        end if
      end do

      nface=0
      do i=1,n
        if(exists_in_fbz(i)) then
          nface=nface+1
          face(1:3,nface)=iface(1:3,i)
        end if
      end do

    end subroutine fbz_face

  end subroutine m_Kp_force_kpoint_into_BZ

  subroutine m_Kp_set_star_of_k
    integer :: iopr, i, j
    integer :: ikbz, jtrs, ik, jk, is
    real(kind=DP) :: x(3), y(3), rkxyz(3), dk(3)
    real(kind=DP), allocatable :: oprec(:,:,:)
    real(kind=DP), allocatable :: wk_star_of_k(:,:)
    integer :: id_sname = -1

    call tstatc0_begin('m_Kp_set_star_of_k ',id_sname)
    allocate(oprec(3,3,nopr))
    do iopr=1,nopr
       do j=1,3
          x = matmul(op(:,:,iopr),rltv(:,j))
          do i=1,3
             y = altv(:,i)
             oprec(i,j,iopr) = dot_product(y,x)/PAI2
          end do
       end do
    end do

    if ( allocated( num_star_of_k ) ) deallocate( num_star_of_k )
    if ( allocated( star_of_k ) )     deallocate( star_of_k )
    if ( allocated( iopr_k_fbz_to_ibz ) )   deallocate( iopr_k_fbz_to_ibz )
    if ( allocated( trev_k_fbz_to_ibz ) )   deallocate( trev_k_fbz_to_ibz )

    allocate( num_star_of_k( kv3 ) );         num_star_of_k = 0;
    allocate( iopr_k_fbz_to_ibz( kv3_fbz ) );  iopr_k_fbz_to_ibz = 0
    allocate( trev_k_fbz_to_ibz( kv3_fbz ) );  trev_k_fbz_to_ibz = 0

! --------------
    Do is=1, nspin
       do ikbz=is, kv3_fbz, nspin
          LOOP_S1: do jtrs=0,1
             do iopr=1,nopr
                rkxyz = (1-2*jtrs) * matmul(oprec(:,:,iopr),vkxyz_fbz(ikbz,1:3,BUCS))
                if ( allocated(magmom_dir_inversion_opr_flag) ) then
                   if ( magmom_dir_inversion_opr_flag(iopr) == -1 ) rkxyz = -rkxyz
                endif

                do jk=is, kv3, nspin
                   dk(1:3) = vkxyz(jk,1:3,BUCS) -rkxyz(1:3)

                   if( abs(dk(1)-nint(dk(1)))<DELTA07  &
                        &      .and. abs(dk(2)-nint(dk(2)))<DELTA07  &
                        &      .and. abs(dk(3)-nint(dk(3)))<DELTA07 ) then

                      iopr_k_fbz_to_ibz(ikbz) = iopr
                      trev_k_fbz_to_ibz(ikbz) = jtrs
                      num_star_of_k(jk) = num_star_of_k(jk) +1
                      exit LOOP_S1
                   end if
                end do
             end do
          end do LOOP_S1
       End do
    End Do
    max_num_star_of_k = maxval( num_star_of_k )

    allocate( star_of_k( kv3, max_num_star_of_k ) );  star_of_k = 0

    num_star_of_k = 0
    Do is=1, nspin
       do ikbz=is, kv3_fbz, nspin
          LOOP_S2: do jtrs=0,1
             do iopr=1,nopr
                rkxyz = (1-2*jtrs) * matmul(oprec(:,:,iopr),vkxyz_fbz(ikbz,1:3,BUCS))
                if ( allocated(magmom_dir_inversion_opr_flag) ) then
                   if ( magmom_dir_inversion_opr_flag(iopr) == -1 ) rkxyz = -rkxyz
                endif

                do jk=is, kv3, nspin
                   dk(1:3) = vkxyz(jk,1:3,BUCS) -rkxyz(1:3)

                   if( abs(dk(1)-nint(dk(1)))<DELTA07  &
                        &      .and. abs(dk(2)-nint(dk(2)))<DELTA07  &
                        &      .and. abs(dk(3)-nint(dk(3)))<DELTA07 ) then

                      iopr_k_fbz_to_ibz(ikbz) = iopr
                      trev_k_fbz_to_ibz(ikbz) = jtrs
                      num_star_of_k(jk) = num_star_of_k(jk) +1
                      star_of_k( jk, num_star_of_k(jk) ) = ikbz
                      exit LOOP_S2
                   end if
                end do
             end do
          end do LOOP_S2
       End do
    End Do
    call tstatc0_end(id_sname)

  end subroutine m_Kp_set_star_of_k

! ==== ASMS === 2018/02/26
  subroutine m_Kp_chk_opr_from_fbz_to_ibz
    integer :: iopr, i, j
    integer :: ikbz, jtrs, ik, jk, is
    real(kind=DP) :: x(3), y(3), rkxyz(3), dk(3), g0(3)
    real(kind=DP), allocatable :: oprec(:,:,:)

    if ( allocated( flg_opr_from_fbz_to_ibz) ) deallocate( flg_opr_from_fbz_to_ibz )
    allocate( flg_opr_from_fbz_to_ibz( nopr ) );  flg_opr_from_fbz_to_ibz = 0

#ifdef USE_ALL_OPR_FOR_CHARGE_SYMMETRIZATION
    nopr_from_fbz_to_ibz = nopr
    flg_opr_from_fbz_to_ibz = 1
    return
#endif

    allocate(oprec(3,3,nopr))
    do iopr=1,nopr
       do j=1,3
          x = matmul(op(:,:,iopr),rltv(:,j))
          do i=1,3
             y = altv(:,i)
             oprec(i,j,iopr) = dot_product(y,x)/PAI2
          end do
       end do
    end do

    if ( way_ksample == SKPS_DIRECT_IN .or. way_ksample == FILE ) then
! --- E operation --
       nopr_from_fbz_to_ibz = 1
       flg_opr_from_fbz_to_ibz(1) = 1
! -----------------

       write(nfout,*) "** nopr_from_fbz_to_ibz is assumed to be 1 "
       return
    endif

    nopr_from_fbz_to_ibz = 0
    Do is=1, nspin
       do ikbz=is, kv3_fbz, nspin
          LOOP_S: do jtrs=0,1
             do iopr=1,nopr
                rkxyz = (1-2*jtrs) * matmul(oprec(:,:,iopr),vkxyz_fbz(ikbz,1:3,BUCS))
                if ( allocated(magmom_dir_inversion_opr_flag) ) then
                   if ( magmom_dir_inversion_opr_flag(iopr) == -1 ) rkxyz = -rkxyz
                endif

                do jk=is, kv3, nspin
                   dk(1:3) = vkxyz(jk,1:3,BUCS) -rkxyz(1:3)
                   if( abs(dk(1)-nint(dk(1)))<DELTA07  &
                        &      .and. abs(dk(2)-nint(dk(2)))<DELTA07  &
                        &      .and. abs(dk(3)-nint(dk(3)))<DELTA07 ) then
                      g0(1:3) = nint(dk(1:3))
                      flg_opr_from_fbz_to_ibz(iopr) = 1
                      exit LOOP_S
                   end if
                end do
             end do
          end do LOOP_S
       End do
    End Do
    Do iopr=1, nopr
       if ( flg_opr_from_fbz_to_ibz(iopr) == 1 ) then
          nopr_from_fbz_to_ibz = nopr_from_fbz_to_ibz +1
       endif
    End do

    if ( ipri_kp >= 2 ) then
       write(nfout,'(A,I5)') &
            &  "=== Number of sym. operations for reducing from fbz to ibz : ", &
            &  nopr_from_fbz_to_ibz
       write(nfout,'(A)') " no.     Flag "
       Do iopr=1, nopr
          write(nfout,'(I5,I5)') iopr, flg_opr_from_fbz_to_ibz(iopr)
       End do
       write(nfout,*)
    endif

    deallocate( oprec )

  end subroutine m_Kp_chk_opr_from_fbz_to_ibz
! ==== ASMS === 2018/02/26

  subroutine m_Kp_wd_BandSymInput(ipri,nfout,nf)
    integer, intent(in) ::ipri, nfout, nf
    character(len=4),dimension(3) :: spinstate
    data spinstate/"    ","  UP","DOWN"/
    integer :: ip, ik
    integer :: id_sname = -1
    call tstatc0_begin('m_Kp_wd_BandSymInput ',id_sname)
    if(mype == 0) then
       write(nf,'("##KPOINTS")')
       ip = 1
       if(allocated(vkxyz_ek) .and. kv3_ek >= kv3) then
          do ik = 1, kv3_ek
             if(nspin==2) ip = 3 - mod(ik,2)
             write(nf,'(i6,3f14.6,2x,a4)') ik,vkxyz_ek(ik,1:3,BUCS),spinstate(ip)
          end do
       else
          do ik = 1, kv3
             if(nspin==2) ip = 3 - mod(ik,2)
             write(nf,'(i6,3f14.6,2x,a4)') ik,vkxyz(ik,1:3,BUCS),spinstate(ip)
          end do
       end if
       write(nf,'("##"/)')
    end if
    call tstatc0_end(id_sname)
  end subroutine m_Kp_wd_BandSymInput

  subroutine m_Kp_get_nkmesh(nkmesh)
    integer, intent(out), dimension(3) :: nkmesh

    if ( way_ksample == MONKHORST_PACK ) then
       nkmesh(1:3) = mp_index(1:3)
    else
       nkmesh(1:3) = k_sample_mesh(1:3,1)
    endif
  end subroutine m_Kp_get_nkmesh

  subroutine m_Kp_get_kptable_bxsf( nkpt_in, kvtab, flg_add_boundary )
    integer, intent(in) :: nkpt_in
    integer, intent(out) :: kvtab(nkpt_in)
    integer, intent(in) :: flg_add_boundary

    integer :: iopr, i, j, nadd_k
    integer :: jtrs, ik, jk, is, num
    integer :: i1, i2, i3, nbz_mesh(3), nkpt_wk
    real(kind=DP) :: x(3), y(3), rkxyz(3), dk(3)
    real(kind=DP), allocatable :: oprec(:,:,:), vkxyz_wk(:,:)
    logical :: found

    allocate(oprec(3,3,nopr))
    do iopr=1,nopr
       do j=1,3
          x = matmul(op(:,:,iopr),rltv(:,j))
          do i=1,3
             y = altv(:,i)
             oprec(i,j,iopr) = dot_product(y,x)/PAI2
          end do
       end do
    end do

    call m_Kp_get_nkmesh( nbz_mesh )
    if ( flg_add_boundary == 1 ) then
       nadd_k = 1
    else
       nadd_k = 0
    endif

    nkpt_wk = ( nbz_mesh(1) +nadd_k ) &
         &   *( nbz_mesh(2) +nadd_k ) &
         &   *( nbz_mesh(3) +nadd_k ) *nspin

    if ( nkpt_wk /= nkpt_in ) call phase_error_with_msg(nfout,"nkpt_wk /= nkpt_in",__LINE__,__FILE__)

    allocate( vkxyz_wk(nkpt_wk,3) )

    num = 0
    Do i1=0, nbz_mesh(1) -1+nadd_k
       Do i2=0, nbz_mesh(2) -1 +nadd_k
          Do i3=0, nbz_mesh(3) -1 +nadd_k
             Do is=1, nspin
                num = num +1
                vkxyz_wk(num,1) = dble(i1)/dble(nbz_mesh(1))
                vkxyz_wk(num,2) = dble(i2)/dble(nbz_mesh(2))
                vkxyz_wk(num,3) = dble(i3)/dble(nbz_mesh(3))
             End do
          End do
       End do
    End Do

    Do is=1, nspin
       do ik=is, nkpt_wk, nspin
          found = .false.
          LOOP_S: do jtrs=0,1
             do iopr=1,nopr
                rkxyz = (1-2*jtrs) * matmul(oprec(:,:,iopr),vkxyz_wk(ik,1:3))
                if ( allocated(magmom_dir_inversion_opr_flag) ) then
                   if ( magmom_dir_inversion_opr_flag(iopr) == -1 ) rkxyz = -rkxyz
                endif

                if ( ekmode == ON ) then
                   do jk=is, kv3_ek, nspin
                      dk(1:3) = vkxyz_ek(jk,1:3,BUCS) -rkxyz(1:3)
                      if( abs(dk(1)-nint(dk(1)))<DELTA07  &
                           &      .and. abs(dk(2)-nint(dk(2)))<DELTA07  &
                           &      .and. abs(dk(3)-nint(dk(3)))<DELTA07 ) then
                         kvtab(ik) = jk;   found = .true.;  exit LOOP_S
                      end if
                   end do
                else
                   do jk=is, kv3, nspin
                      dk(1:3) = vkxyz(jk,1:3,BUCS) -rkxyz(1:3)
                      if( abs(dk(1)-nint(dk(1)))<DELTA07  &
                           &      .and. abs(dk(2)-nint(dk(2)))<DELTA07  &
                           &      .and. abs(dk(3)-nint(dk(3)))<DELTA07 ) then
                         kvtab(ik) = jk;   found = .true.;  exit LOOP_S
                      end if
                   end do
                endif
             End do
          End do LOOP_S
          if ( .not. found ) then
             write(nfout,*) "Not found k point", ik, vkxyz_wk(ik,1:3)
             call phase_error_with_msg(nfout,"Not found k point",__LINE__,__FILE__)
          endif
       End do
    End Do
    deallocate( oprec ); deallocate( vkxyz_wk )

  end subroutine m_Kp_get_kptable_bxsf

end module m_Kpoints

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 612 $)
!
!  SUBROUINE: get_crotylm
!
!  AUTHOR: Takenori Yamamotoi   June/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
! coded by Takenori YAMAMOTO (Univ. Tokyo) at Jun. 1, 2004
!
subroutine get_crotylm(l1max,mmax,nsph,nopr,crotylm,iylm,nylm,op)
! $Id: crotylm.f90 612 2020-04-25 10:36:25Z ktagami $
  implicit none
  integer, intent(in) :: l1max,mmax,nsph,nopr
  integer, intent(out) :: iylm(mmax,nsph,nopr),nylm(nsph,nopr)
  real(kind=8), intent(out) :: crotylm(mmax,nsph,nopr)
  real(kind=8), intent(in) :: op(3,3,nopr)

  integer :: llmax,lmax,nmax,n,np,nt
  integer :: m,m2,is,is1,is2,i,l,iopr
  integer :: mm
  real(kind=8) :: dint, cwk
  real(kind=8),allocatable :: x(:),y(:),z(:),w(:)
  real(kind=8),allocatable :: x2(:),y2(:),z2(:)
  real(kind=8),allocatable :: ylm(:,:),ylmr(:)
  real(kind=8), parameter  :: eps=1.d-6

  lmax = l1max-1
  nt = 1 + int(3*lmax/2)
  np = 1 + 3*lmax
  nmax = np*nt
  allocate(x(nmax),y(nmax),z(nmax),w(nmax))
  call int_spherical_surf(lmax,nmax,n,x,y,z,w)

  lmax = l1max-1
  llmax=(lmax+1)**2
  allocate(ylm(n,llmax),ylmr(n))
  do is=1,llmax
     call real_spherical_harmonics(is,n,x,y,z,ylm(1,is),cwk)
! debug
!     write(*,'(i3,10(1x,f25.10))') is,ylm(1:10,is)
! end debug
  end do

  allocate(x2(nmax),y2(nmax),z2(nmax))
  do iopr=1,nopr
     do i=1,n
        x2(i) = op(1,1,iopr)*x(i)+op(1,2,iopr)*y(i)+op(1,3,iopr)*z(i)
        y2(i) = op(2,1,iopr)*x(i)+op(2,2,iopr)*y(i)+op(2,3,iopr)*z(i)
        z2(i) = op(3,1,iopr)*x(i)+op(3,2,iopr)*y(i)+op(3,3,iopr)*z(i)
     end do
     do l=0,lmax
        do m2=1,2*l+1
           is2 = l**2+m2
           call real_spherical_harmonics(is2,n,x2,y2,z2,ylmr,cwk)
! debug
!           write(*,'(4(1x,i3))') iopr,l,m2,is2
! end debug
           mm=0
           do m=1,2*l+1
              is1 = l**2+m
              dint = 0.d0
              do i=1,n
                 dint = dint + ylm(i,is1)*ylmr(i)*w(i)
              end do
              if(dabs(dint)>eps) then
                 mm = mm+1
                 nylm(is2,iopr) = mm
                 iylm(mm,is2,iopr) = is1
                 crotylm(mm,is2,iopr) = dint
! debug
!                 write(*,'(1x,i3,"=",f25.10)') is1,dint
! end debug
              end if
           end do
        end do
     end do
  end do

  deallocate(x,y,z,w)
  deallocate(x2,y2,z2)
  deallocate(ylm,ylmr)

end subroutine get_crotylm

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 593 $)
!
!  MODULE:  m_ES_WF_by_SDorCG
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
#undef NEC_TIMER
#ifdef NEC_TIMER
#  define START_TIMER(a) call start_timer(a)
#  define STOP_TIMER(a)  call stop_timer(a)
#else
#  define START_TIMER(a)
#  define STOP_TIMER(a)
#endif
!
#ifdef __TIMER__
#   define __TIMER_START_w_BARRIER(str,a)   call mpi_barrier(str,ierr) ;   call timer_sta(a)
#   define __TIMER_START(a)       call timer_sta(a)
#   define __TIMER_STOP(a)        call timer_end(a)
#else
#   define __TIMER_START_w_BARRIER(str,a)
#   define __TIMER_START(a)
#   define __TIMER_STOP(a)
#endif
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif
module m_ES_WF_by_SDorCG
!     (m_ESsd or m_ESSD)
! $Id: m_ES_WF_by_SDorCG.F90 593 2019-06-20 03:47:31Z jkoga $
! This module evolves wave functions.
! MSD: modified steepest descent algorithm (Original subroutine name was
! "msdv").
! Following lines are comments in the "msdv".
!
!!$C ref.: Williams and Soler, Bull.Am.Phys.Soc.32 ('87),p562.
!!$c
!!$c      revised by T.Yamasaki
!!$c         #1) 2 folding inline expansion at an do loop of NEG is
!!$c            rewrited as before as a simple do loop
!!$c                                               5th May 1994
!!$c         #2) Parallelization                   9th May 1994
!!$c         #3) Parallelization transient
!!$c                         by T.Yamasaki        15th May 1994
!!$c
!!$c         #4)  Following arrays are removed from the arguments.
!!$c                                  ----> 31th May '94 Y.M
!!$cc   >        VXC,CHGQ,PSC,ZFM3,
!!$c                                  ----> 3rd June '94, Y.M.
!!$cc   W        W31,
!!$c                                  ----> 3rd June '94, Y.M.
!!$cc   W        W310,
!!$c
!!$c         #5)  data array size is reduced by T.Yamasaki
!!$c             snlfmc(kng1,klmt),snlfms(kng1,klmt)
!!$c          -->  snlfmc(kng1), snlfms(kng1)       on 17th Jun. 1994
!!$c
!!$c         #6) Data parallelization               on 24th Jun. 1994
!!$c                 eko --> eko_l             by T.Yamasaki
!!$c         #7) indx0 is removed                      26th Jun. 1994
!!$c         #8) Interface has changed                 27th Jun. 1994
!!$c         #9) imsd is added in the argument list     4th Aug. 1994
!!$cc      imsd = 1
!!$cc    for preconditioning IMSD=2   '94.6.14 Tsuyoshi Miyazaki
!!$cc      imsd = 2
!!$c         #10) ivanl is inserted in the arugment list  13th Sep. 1994
!!$c         #11) A do loop of 450 is tuned up.        15th Sep. 1994
!!$c         #12) Spin polarization is introduced.     11th Dec. 1994
!!$c         #13) vlhxc --> vlhxc_l                    31st Jan. 1995
!!$c                                          by T.Yamasaki
!!$c         #14) gx,gy,gz --> ngabc, vx,vy,vz --> vkxyz
!!$c                   by T.Yamasaki                on 15th Feb. 1995
!!$c         #15) antiferromagnetic calculation is added on 9th Jul. 1996
!!$c                                          by H.Sawada
!
! The "msdv" subroutine was translated into a subroutine,
! "evolve_WFs_in_MSD_direction" by T. Yamasaki in 1999.
!
  use m_Control_Parameters,  only : nspin,ipri,iprisolver,kimg,neg,af,sw_hybrid_functional, sw_fef &
#ifdef SAVE_FFT_TIMES
 &                                , sw_modified_cg_formula, sw_save_fft, sw_retard_eigval_evaluation
#else
 &                                , sw_modified_cg_formula, sw_retard_eigval_evaluation
#endif
  use m_Const_Parameters,    only : DP,SP,DIRECT,ON,SD,MSD,eazyCG,CG,SKIP,EXECUT,zi &
 &                                , ORTHONORMALIZATION, NORMALIZATION, ELECTRON &
 &                                , OTHER_BANDS, SAME_BAND, ALL_BANDS, SCF, OFF, GAMMA, OLD
  use m_Crystal_Structure,   only : rltv
  use m_Electronic_Structure,only : zaj_l, afft,bfft &
 &                                , eko_l,vnlph_l,vlhxcQ &
 &                                , vlhxc_l, vtau_l &
#ifdef SAVE_FFT_TIMES
 &                                , status_saved_phifftr &
#endif
 &                                , m_ES_WF_in_Rspace &
 &                                , m_ES_sort_eigen_values &
 &                                , m_ES_Vlocal_in_Rspace  &
 &                                , m_ES_eigen_values_for_each_k  &
 &                                , m_ES_wd_zaj_small_portion &
 &                                , m_ES_wd_eko &
 &                                , m_ES_decide_precon_factor     &
 &                                , m_ES_sum_of_LocalPart  &
 &                                , m_ES_sum_of_LocalPart2 &
 &                                , m_ES_sum_of_LocalPart3

  use m_ES_ortho            ,only : m_ES_MGS_4_each_k
  use m_ES_ortho            ,only : m_ES_orthogonalize_SD_to_WFs
  use m_ES_nonlocal         ,only : sc,ss,qc                                          &
 &                                , m_ES_alloc_afft_scss_etc                          &
 &                                , m_ES_dealloc_afft_scss_etc
  use m_ES_nonlocal         ,only : m_ES_Vnonlocal_W                                  &
 &                                , m_ES_betar_dot_Psi_4_each_k
  use m_FFT,                 only : nfft, fft_box_size_WF
  use m_FFT,                 only : m_FFT_Vlocal_W, m_FFT_WF
  use m_Ionic_System,        only : ntyp, natm, ityp, iwei
  use m_Kpoints,             only : kv3,vkxyz,k_symmetry
  use m_NonLocal_Potential,  only : snl
  use m_Files,               only : nfout
  use m_Parallelization,     only : MPI_CommGroup,is_kngp,ie_kngp,npes,mype &
       &, nrank_e, myrank_e, map_e, ista_e, iend_e, istep_e, map_z, np_e &
       &, nrank_k, myrank_k, map_k, ista_k, iend_k, mpi_k_world, nis_k, nel_k, ierr, ista_fs, iend_fs &
       &, nrank_s, ista_spin, iend_spin
  use m_PlaneWaveBasisSet,   only : kg1,iba, igf, nbase, m_pwBS_kinetic_energies
  use m_PseudoPotential,     only : ilmt, lmtt, ltp, mtp, q, dion, modnrm, nlmta &
       &                           ,m_PP_include_vanderbilt_pot,ipaw,dion_paw
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_ES_ExactExchange,    only : m_ES_Vexx_W, m_ES_EXX_eigenvalue_for_each_k &
       &                          , m_ES_EXX_Diagonal_part, m_ES_EXX_add_Diagonal_part &
                                  , m_ES_EXX_cp_eigenvalue, m_ES_EXX_gather_valence_states
#ifdef NEC_TIMER
  use nec_timer
#endif
  use m_FiniteElectricField, only : m_FEF_add_grad_to_vnlph, m_FEF_build_grad

! ==================================== added by K. Tagami ============= 11.0
  use m_Control_Parameters,    only : noncol, ndim_spinor, ndim_chgpot, ndim_magmom, &
       &                              SpinOrbit_mode, sw_hubbard
  use m_Const_Parameters,    only : CMPLDP, Neglected
  use m_PseudoPotential,       only : dion_scr_noncl, q_noncl
  use m_ES_ortho,              only : m_ES_orthogonl_SD_to_WFs_noncl, &
       &                              m_ES_MGS_4_each_k_noncl

  use m_Electronic_Structure,   only : m_ES_sum_of_LocalPart2_noncl, &
       &                               m_ES_Vlocal_in_Rspace_noncl, &
       &                               m_ES_sort_eigen_vals_noncl, &
       &                               m_ES_eigen_vals_each_k_noncl, &
       &                               m_ES_sum_of_LocalPart_noncl, &
       &                               m_ES_sum_of_LocalPart3_noncl

  use m_ES_nonlocal,            only : m_ES_alloc_scss_etc, &
       &                               m_ES_dealloc_scss_etc
  use m_FFT,                    only : m_FFT_Vlocal_W_noncl
!! for debug
  use m_Electronic_Structure,     only : fsr_l, fsi_l
! ===================================================================== 11.0

! === 0 divide occurs if abs(wdi) < epsilon. by tkato 2012/12/18 ===============
  use m_Const_Parameters, only : SmallestPositiveNumber
! ==============================================================================

  use m_Control_Parameters,  only : use_metagga, vtau_exists

  use m_IterationNumbers, only : iteration_electronic
  use mpi

  implicit none
  real(kind=DP),private,allocatable,dimension(:,:,:,:):: zaj_old !d(kg1,np_e,ista_k:iend_k,kimg)
  real(kind=DP),private,allocatable,dimension(:,:,:,:):: wfsd_l  !d(kg1,np_e,ik:ik,kimg)
! ----------- Added by T. Yamasaki, 28 June 2008 -----
  real(kind=DP),private,allocatable,dimension(:,:,:,:):: wfred_l !d(kg1,np_e,ista_k:iend_k,kimg)
  logical, private                                    :: wfred_is_allocated = .false.
! ----------------------------------------------------
  real(kind=DP),public ,allocatable,dimension(:,:,:,:):: wfsd_old!d(kg1,np_e,ista_k:iend_k,kimg)
  real(kind=DP),private,allocatable,dimension(:,:,:,:):: wfsd_np !d(kg1,np_e,1,kimg)
  real(kind=DP),private,allocatable,dimension(:,:,:)  :: bsdr_l, bsdi_l !d(np_e,nlmta,1)
  real(kind=DP),private,allocatable,dimension(:,:,:)  :: bsdr_old, bsdi_old !d(np_e,nlmta,1)
  real(kind=DP),private,allocatable,dimension(:,:,:)  :: bsdr_np, bsdi_np !d(np_e,nlmta,1)

  real(kind=DP),private,allocatable,dimension(:)          :: dzajn2  !d(kv3)
  real(kind=DP),private                               :: betacg

!   1. m_ESsd_alloc_dzajn2            <-(Initial_Electronic_Structure)
!   2. m_ESsd_dealloc_dzajn2          <-(Finalization_of_mpi)
!   3. m_ESsd_alloc_zaj_old           <-(Initial_Electronic_Structure)
!   4. m_ESsd_evolve_WFs_again        <-(Renewal_of_WaveFunctions) ->(5)
!   5. evolve_each_WF_again           <-(4)
!   6. m_ESsd_decide_CG_direction     <-(Renewal_of_WaveFunctions) ->(7)
!   7. decide_CG_direction_core       <-(6,) ->(16,29)
!   8. m_ESsd_renew_WF_by_SDorCG      <-(Renewal_of_WaveFunctions) ->(9,10,11,12,13,14)
!   9. evolve_WFs_in_MSD_direction    <-(8) ->(15,19)
!  10. evolve_WFs_in_SD_direction     <-(8)
!  11. evolve_WFs_in_eazyCG_direction <-(8) ->(16,17,18,26,28,30,33)
!  12. evolve_WFs_in_CG_direction     <-(8) ->(18,26,28,29)
!  13. evolve_WFs_in_CG_direction0    <-(8) ->(26,27)
!  14. vlhxc_l_zero_term              <-(8)
!  15. modified_steepest_descent      <-(9)
!  16. square_of_SD_direction(ik,ibo,dz) <-(7,11)
!  17. square_of_SD_direction2(ik,ibo,dz) <-(11)
!  18. SD_direction                   <-(11,12)
!  19. Vnonlocal_Diagonal_part        <-(9)
!  20.  - Vnonlocal_D_vanderbilt_case, - Vnonlocal_D_norm_conserve_case
!  21. m_ESsd_reset_dzajn2            <-(Renewal_of_WaveFunctions)
!  22. m_ESsd_copy_zaj_to_zaj_old     <-(Renewal_of_WaveFunctions)
!  23. m_ESsd_copy_zaj_old_to_zaj     <-(m_ES_WF_by_RMM.zajold2zaj_phi2zaj_old)
!  24. m_ESsd_copy_phi_to_zaj_old     <-(m_ES_WF_by_RMM.zajold2zaj_phi2zaj_old)
!  25. m_ESsd_diff_WFs_to_zaj_old     <-(m_ES_WF_by_RMM.m_ESrmm_renew_WF)
!  26. WF_conjugate_gradient          <-(11,12,13)
!  27. WF_conjugate_gradient0         <-(13)
!  28. make_CG_direction              <-(11,12)
!  29. orthogonalize_SD_drctns        <-(7,12)
!  30. Precon_dot_SD                  <-(11)  ->(31)
!  31. decide_precon_factor_wfsd      <-(30)  ->(32)
!  32. kinetic_energy_wfsd            <-(31)
!  33. cp_wfsd_to_wfsd_old            <-(11)

!  include 'mpif.h'

contains
  subroutine m_ESsd_alloc_dzajn2
    allocate(dzajn2(ista_k:iend_k)); dzajn2 = 0.d0
  end subroutine m_ESsd_alloc_dzajn2

  subroutine m_ESsd_dealloc_dzajn2
    if(allocated(zaj_old)) deallocate(zaj_old)
    if(allocated(dzajn2)) deallocate(dzajn2)
  end subroutine m_ESsd_dealloc_dzajn2

  subroutine m_ESsd_alloc_zaj_old
    allocate(zaj_old(kg1,np_e,ista_k:iend_k,kimg))
  end subroutine m_ESsd_alloc_zaj_old

  subroutine m_ESsd_alloc_wfsd
    if(.not.allocated(wfsd_old)) then
       allocate(wfsd_old(kg1,np_e,ista_k:iend_k,kimg))
       wfsd_old = 0.d0
    end if
    if(.not.allocated(bsdr_old)) then
       allocate(bsdr_old(np_e,nlmta,ista_k:iend_k));bsdr_old=0.0d0
    endif
    if(.not.allocated(bsdi_old)) then
       allocate(bsdi_old(np_e,nlmta,ista_k:iend_k));bsdi_old=0.0d0
    endif
  end subroutine m_ESsd_alloc_wfsd

  subroutine m_ESsd_dealloc_wfsd
    if(allocated(wfsd_old)) deallocate(wfsd_old)
    if(allocated(bsdr_old)) deallocate(bsdr_old)
    if(allocated(bsdi_old)) deallocate(bsdi_old)
  end subroutine m_ESsd_dealloc_wfsd

! -------------------- Added by T. Yamasaki, 28 June 2008 --->>
  subroutine m_ESsd_alloc_wfred()
    allocate(wfred_l(kg1,np_e,ista_k:iend_k,kimg)); wfred_l = 0.d0
    wfred_is_allocated = .true.
  end subroutine m_ESsd_alloc_wfred

  subroutine m_ESsd_dealloc_wfred()
    deallocate(wfred_l)
    wfred_is_allocated = .false.
  end subroutine m_ESsd_dealloc_wfred

  subroutine cp_wfred(ik)
    integer, intent(in) :: ik
    integer :: ir, ib, ig
    do ir = 1, kimg
       do ib = 1, np_e
          do ig = 1, iba(ik)
             wfred_l(ig,ib,ik,ir) = zaj_l(ig,ib,ik,ir) - zaj_old(ig,ib,ik,ir)
          end do
       end do
    end do
  end subroutine cp_wfred
! ----------------------------------<<

  subroutine alloc_wfsd_bsdri(ik)
    integer, intent(in) :: ik
    allocate(wfsd_l(kg1,np_e,ik:ik,kimg)); wfsd_l = 0.d0
    allocate(bsdr_l(np_e,nlmta,ik:ik))
    allocate(bsdi_l(np_e,nlmta,ik:ik)); bsdi_l = 0.0d0
!!$    write(nfout,'(" -- bsdr_l, bsdi_l have been allocated --  np_e, nlmta, ik = ",3i5)') np_e,nlmta,ik
  end subroutine alloc_wfsd_bsdri

! ==================================== added by K. Tagami ============== 11.0
  subroutine alloc_wfsd_bsdri_noncl( ik1, ik2 )
    integer, intent(in) :: ik1, ik2
    allocate(wfsd_l(kg1,np_e,ik1:ik2,kimg)); wfsd_l = 0.d0
    allocate(bsdr_l(np_e,nlmta,ik1:ik2))
    allocate(bsdi_l(np_e,nlmta,ik1:ik2)); bsdi_l = 0.0d0
  end subroutine alloc_wfsd_bsdri_noncl
! ====================================================================== 11.0

  subroutine dealloc_wfsd_bsdri()
    deallocate(wfsd_l)
    deallocate(bsdr_l)
    deallocate(bsdi_l)
  end subroutine dealloc_wfsd_bsdri

  subroutine alloc_wfsdnp_bsdrinp(ik)
    integer, intent(in) :: ik
    allocate(wfsd_np(kg1,np_e,ik:ik,kimg))
    allocate(bsdr_np(np_e,nlmta,ik:ik))
    allocate(bsdi_np(np_e,nlmta,ik:ik))
  end subroutine alloc_wfsdnp_bsdrinp

! ========================================= added by K. Tagami =========== 11.0
  subroutine alloc_wfsdnp_bsdrinp_noncl(ik1, ik2)
    integer, intent(in) :: ik1, ik2
    allocate(wfsd_np(kg1,np_e,ik1:ik2,kimg))
    allocate(bsdr_np(np_e,nlmta,ik1:ik2))
    allocate(bsdi_np(np_e,nlmta,ik1:ik2))
  end subroutine alloc_wfsdnp_bsdrinp_noncl
! ====================================================================== 11.0

  subroutine dealloc_wfsdnp_bsdrinp()
    deallocate(wfsd_np)
    deallocate(bsdr_np)
    deallocate(bsdi_np)
  end subroutine dealloc_wfsdnp_bsdrinp

  subroutine m_ESsd_dealloc_zaj_old
    if(allocated(zaj_old)) deallocate(zaj_old)
!!$    deallocate(wfsd_l)
!!$    deallocate(wfsd_np)
!!$    deallocate(bsdr_l)
!!$    deallocate(bsdi_l)
!!$    deallocate(bsdr_np)
!!$    deallocate(bsdi_np)
  end subroutine m_ESsd_dealloc_zaj_old

  subroutine m_ESsd_evolve_WFs_again(nfout,isolver2,mode,dtim_old,dtim_new,iupdate)
#ifdef __TIMER__
    use m_Const_Parameters,   only : VDB, NORMCONSERVATION
#endif
    integer,       intent(in) :: nfout,isolver2 &
         &                     , mode   ! mode = {ORTHONORMALIZATION | NORMALIZATION}
    real(kind=DP), intent(in) :: dtim_old, dtim_new
    integer, intent(in), optional :: iupdate
    integer       :: ispin, ik, iksnl
    real(kind=DP), pointer, dimension(:) :: ekin
    real(kind=DP), allocatable, dimension(:,:) :: afft_spin
#ifdef __TIMER__
    integer       :: ierr
#endif

    call m_ES_alloc_afft_scss_etc()
    ekin => sc(1:kg1)
    if(nrank_s==2) then
      allocate(afft_spin(nfft,2))
      do ispin=1, nspin
       call m_ES_Vlocal_in_Rspace(ispin,afft_spin(:,ispin))                 ! (ptfft1)
      enddo
    endif
!    do ispin = 1, nspin, af+1
    do ispin = ista_spin, iend_spin, af+1
       if(nrank_s==1) then
         call m_ES_Vlocal_in_Rspace(ispin,afft)                 ! (ptfft1)
       else
         afft(:) = afft_spin(:,ispin)
       endif

       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) == myrank_k ) then                     ! MPI
             call m_pwBS_kinetic_energies(ik,vkxyz,ekin) !-(PWBS) (diakin) ->ekin
             call evolve_each_WF_again(ik,isolver2,dtim_new,dtim_old)  !-(m_ES_WF_by_SDorCG)
             if(ipri>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
!!$             if(modnrm == EXECUT) call m_ES_betar_dot_WFs_4_each_k(nfout,ik)       ! -> fsr_l, fsi_l
             call m_ES_MGS_4_each_k(nfout,ik,mode)
             if(sw_hybrid_functional==ON) then
                if(sw_retard_eigval_evaluation==OFF)then
                   call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,iupdate=iupdate)
                else
                   call m_ES_EXX_cp_eigenvalue(ik)
                endif
             endif
             call m_ES_eigen_values_for_each_k(ispin,ik,ekin,afft)
          end if
       end do
    end do
    if(sw_hybrid_functional==ON.and.sw_retard_eigval_evaluation==ON)then
       call m_ES_EXX_gather_valence_states(nfout)
       do ispin=1,nspin,af+1
          do ik=ispin, kv3+ispin-nspin, nspin
             if(map_k(ik) /= myrank_k) cycle ! MPI
             call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,update_eko=.false.,iupdate=iupdate)
          enddo
       enddo
    endif
#ifdef LMM_PREVIOUS
    call m_ES_sort_eigen_values    !-(m_Elec.)
! --> T. Yamasaki, 21th Jul. 2009
!!$    call m_ES_sort_eigen_values    !-(m_Elec.)
! <--
#endif
    call m_ES_dealloc_afft_scss_etc()
    if(nrank_s==2) deallocate(afft_spin)

  end subroutine m_ESsd_evolve_WFs_again

! ============================= added by K. Tagami ======================== 11.0
  subroutine m_ESsd_evolve_WFs_again_noncl(nfout,isolver2,mode,dtim_old,dtim_new,iupdate)
    integer,       intent(in) :: nfout,isolver2 &
         &                     , mode   ! mode = {ORTHONORMALIZATION | NORMALIZATION}
    real(kind=DP), intent(in) :: dtim_old, dtim_new
    integer, intent(in), optional :: iupdate

    integer       :: ispin, ik, iksnl
    integer :: is

    real(kind=DP), pointer, dimension(:) :: ekin

    real(kind=DP), allocatable :: afft_kt(:,:)
    real(kind=DP), allocatable :: bfft_kt(:,:)

!    return

    call m_ES_alloc_scss_etc()
    allocate(afft_kt(nfft,ndim_chgpot)); afft_kt = 0.0d0      ! pot
    allocate(bfft_kt(nfft,ndim_spinor)); bfft_kt = 0.0d0      ! wfn

    ekin => sc(1:kg1)

    call m_ES_Vlocal_in_Rspace_noncl( afft_kt )   ! vlhxc_ss -> afft_kt

    Do ik=1, kv3, ndim_spinor
       if (map_k(ik) /= myrank_k ) cycle
       iksnl = (ik-1)/ndim_spinor + 1

       call m_pwBS_kinetic_energies( ik, vkxyz, ekin )     !-(PWBS) (diakin) ->ekin

       Do is=1, ndim_spinor
         call evolve_each_WF_again( ik+is-1, isolver2, dtim_new, dtim_old )
                          !-(m_ES_WF_by_SDorCG)
       End do

       call m_ES_MGS_4_each_k_noncl( nfout, ik, mode )

       if (sw_hybrid_functional==ON) call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,iupdate=iupdate)

       call m_ES_eigen_vals_each_k_noncl( ik, ekin, afft_kt, bfft_kt )

    End do

#ifdef LMM_PREVIOUS
    call m_ES_sort_eigen_vals_noncl           !-(m_Elec.)

#endif
    call m_ES_dealloc_scss_etc()
    deallocate( afft_kt, bfft_kt )

  end subroutine m_ESsd_evolve_WFs_again_noncl
! ========================================================================= 11.0

  subroutine evolve_each_WF_again(ik,isolver2,dt_new,dt_old)
    integer,       intent(in) :: ik,isolver2
    real(kind=DP), intent(in) :: dt_new,dt_old
    integer ::        ir, ib, ig
    real(kind=DP) ::  dtt
    integer   :: id_sname = -1
    call tstatc0_begin('evolve_each_WF_again ', id_sname,1)

!!$    if(isolver2 == CG .or. isolver2 == eazyCG) then
#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) then
       do ib = 1, np_e
          status_saved_phifftr(ib,ik) = OLD
       end do
    end if
#endif

  if(isolver2 == eazyCG) then
       do ir = 1, kimg
          do ib = 1, np_e
             do ig = 1, iba(ik)
                zaj_l(ig,ib,ik,ir) = zaj_old(ig,ib,ik,ir) + dt_new*wfsd_l(ig,ib,ik,ir)
             end do
          end do
       end do
    else
       dtt = dt_new/dt_old
!!$       if(ipri >= 3) write(nfout,'(" dtt = ",f8.4)') dtt
! ------------------- Revised by T. Yamasaki,  31 Oct 2008 --->>
       if(wfred_is_allocated) then
          do ir = 1, kimg
             do ib = 1, np_e
                do ig = 1, iba(ik)
! ------------------- Revised by T. Yamasaki,  03 July 2008 --->>
                   zaj_l(ig,ib,ik,ir) = zaj_old(ig,ib,ik,ir) + dtt*wfred_l(ig,ib,ik,ir)
! ------------------------------------<<
                end do
             end do
          end do
       else if(.not.wfred_is_allocated) then
          do ir = 1, kimg
             do ib = 1, np_e
                do ig = 1, iba(ik)
                   zaj_l(ig,ib,ik,ir) = (1-dtt)*zaj_old(ig,ib,ik,ir) + dtt*zaj_l(ig,ib,ik,ir)
                end do
             end do
          end do
       end if
! <----------------
    end if
!!$    do ir = 1, kimg
!!$       do ib = 1, np_e                         ! MPI
!!$          do i = 1, iba(ik)
!!$             dzz = zaj_l(i,ib,ik,ir) - zaj_old(i,ib,ik,ir)
!!$             zaj_l(i,ib,ik,ir) = zaj_old(i,ib,ik,ir) + dtt*dzz
!!$          end do
!!$       end do
!!$    end do
    call tstatc0_end(id_sname)
  end subroutine evolve_each_WF_again

  subroutine m_ESsd_decide_CG_direction(precon)
    integer, intent(in) :: precon

    integer ispin, iksnl, ik
    real(kind=DP), parameter             :: Delta = 1.d-10
    real(kind=DP), pointer, dimension(:) :: ekin, p
    real(kind=DP)                        :: gmgm, gmmgmm, sumdz2, sumdz
    real(kind=DP), allocatable :: cfft(:)
    real(kind=DP), allocatable, dimension(:,:) :: afft_spin

    if(sw_fef==ON) call m_FEF_build_grad() !->grad_fef
    call m_ES_alloc_afft_scss_etc()
    ekin => sc(1:kg1); p => ss(1:kg1)
    gmgm = 0.d0; gmmgmm = 0.d0

    if ( use_metagga .and. vtau_exists ) allocate( cfft(nfft) )
    if(nrank_s==2) then
      allocate(afft_spin(nfft,2))
      do ispin=1,nspin
        call m_ES_Vlocal_in_Rspace(ispin,afft_spin(:,ispin))      ! (ptfft1) -> afft
      enddo
    endif
    do ispin = 1, nspin, (af+1)
       if(nrank_s==1) then
         call m_ES_Vlocal_in_Rspace(ispin,afft)      ! (ptfft1) -> afft
       else
         afft(:) = afft_spin(:,ispin)
       endif
       if ( use_metagga .and. vtau_exists ) then
          call m_ES_Vlocal_in_Rspace( ispin, cfft, vtau_l )    ! r space
       endif

       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) == myrank_k) then           ! MPI
             iksnl = (ik-1)/nspin + 1
             call alloc_wfsd_bsdri(ik)
             call m_ES_Vnonlocal_W(ik,iksnl,ispin,ON)    ! (nonloc) ->(vnlph_l)
             if(sw_hybrid_functional==ON) call m_ES_Vexx_W(ik) ! (exx) ->(vnlph_l)
             if(sw_fef==ON) call m_FEF_add_grad_to_vnlph(ik) !->vnlph_l

             if ( use_metagga .and. vtau_exists ) then
                call m_ES_contrib_kindens_to_vnlph( ispin, ik, cfft )
             endif

             call m_pwBS_kinetic_energies(ik,vkxyz,ekin) ! -(m_PWBS) (diakin) ->ekin
             call decide_CG_direction_core &     ! -(m_ES_WF_by_SDorCG) ->wfsd_l
                  &(precon,ik,ekin,afft,bfft,p,sumdz2,sumdz)
             gmgm   = gmgm + sumdz
             gmmgmm = gmmgmm + dzajn2(ik)
             dzajn2(ik) = sumdz2
             if(ipri >= 2) write(nfout,'(" dzajn2(",i3,") = ",d20.8)') ik,dzajn2(ik)
             call dealloc_wfsd_bsdri()
          end if
       enddo
    enddo
    if ( allocated(cfft) ) deallocate( cfft )

    if(npes > 1) then
       call mpi_allreduce(MPI_IN_PLACE,gmgm,1,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)    ! MPI
       call mpi_allreduce(MPI_IN_PLACE,gmmgmm,1,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)    ! MPI
    end if

    if(gmmgmm > Delta) then
       betacg = gmgm/gmmgmm
    else
       betacg = 0.d0
    endif
    if(ipri >= 1) write(nfout,'(" ! betacg = ",d20.8," gmgm = ",d20.8," gmmgmm = ",d20.8)') betacg,gmgm,gmmgmm
    if(betacg > 1.d0) then
       betacg = 0.d0
       if(ipri >= 1) write(nfout,*) ' beta for CG is too large, and it sets to be zero'
    else if(betacg < 0.d0) then
       betacg = 0.d0
       if(ipri >= 1) write(nfout,*) ' beta for CG is less than zero, and it sets to be zero'
    end if

    call m_ES_dealloc_afft_scss_etc()
!!$  contains
!!$    subroutine bcast_dzajn2                     ! MPI
!!$      integer       :: i
!!$
!!$      do i = 0, nrank_k-1
!!$         call mpi_bcast(dzajn2(nis_k(i)),nel_k(i),mpi_double_precision &
!!$              & ,i*nrank_e,MPI_CommGroup,ierr)
!!$      end do
!!$    end subroutine bcast_dzajn2
  end subroutine m_ESsd_decide_CG_direction

! ====================================== added by K. Tagami ============== 11.0
  subroutine m_ESsd_decide_CG_direc_noncl(precon)
    integer, intent(in) :: precon

    integer ispin, iksnl, ik
    integer :: is1, is2, k2, istmp

    real(kind=DP), parameter             :: Delta = 1.d-10
    real(kind=DP), pointer, dimension(:) :: ekin, p
    real(kind=DP)                        :: gmgm, gmmgmm, sumdz2, sumdz

    real(kind=DP), allocatable :: vnlph_noncl(:,:,:,:)
    real(kind=DP), allocatable :: afft_kt(:,:)
    real(kind=DP), allocatable :: bfft_kt(:,:)

    call m_ES_alloc_scss_etc()
    ekin => sc(1:kg1); p => ss(1:kg1)
    allocate(afft_kt(nfft,ndim_chgpot)); afft_kt = 0.0d0      ! pot
    allocate(bfft_kt(nfft,ndim_spinor)); bfft_kt = 0.0d0      ! wfn

    allocate(vnlph_noncl(kg1,np_e,kimg,ndim_spinor)); vnlph_noncl = 0.0d0

    gmgm = 0.d0; gmmgmm = 0.d0

    call m_ES_Vlocal_in_Rspace_noncl( afft_kt )

    do ik = 1, kv3, ndim_spinor

      if (map_k(ik) /= myrank_k) cycle
      iksnl = (ik-1)/ndim_spinor + 1

      call alloc_wfsd_bsdri_noncl( ik, ik+ndim_spinor-1 )

      vnlph_noncl = 0.0d0

      Do is1=1, ndim_spinor
          Do is2=1, ndim_spinor
            istmp = ( is1-1 )*ndim_spinor +is2
            k2 = ik +is2 -1

            call m_ES_Vnonlocal_W( k2, iksnl, istmp, ON )  ! (nonloc) ->(vnlph_l)

            vnlph_noncl(:,:,:,is1) = vnlph_noncl(:,:,:,is1) &
             &                     + vnlph_l(:,:,:)
          End do
       End do

      if (sw_hybrid_functional==ON) call m_ES_Vexx_W(ik) ! (exx) ->(vnlph_l)

      call m_pwBS_kinetic_energies( ik, vkxyz, ekin ) ! -(m_PWBS) (diakin) ->ekin

      call decide_CG_direction_core_noncl( precon, ik, ekin, &
              &                               afft_kt, bfft_kt, vnlph_noncl, &
              &                               p, sumdz2, sumdz )

!!!!!!!!!!!!!      gmgm   = gmgm + sumdz2
      gmgm   = gmgm + sumdz
      gmmgmm = gmmgmm + dzajn2(ik)
      dzajn2(ik) = sumdz2

      if(ipri >= 2) write(nfout,'(" dzajn2(",i3,") = ",d20.8)') ik,dzajn2(ik)
      call dealloc_wfsd_bsdri()

    enddo

    if(npes > 1) then
       call mpi_allreduce(MPI_IN_PLACE, gmgm,1,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)    ! MPI
       call mpi_allreduce(MPI_IN_PLACE, gmmgmm,1,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)    ! MPI
    end if

    if(gmmgmm > Delta) then
       betacg = gmgm/gmmgmm
    else
       betacg = 0.d0
    endif
    if(ipri >= 1) write(nfout,'(" ! betacg = ",d20.8," gmgm = ",d20.8," gmmgmm = ",d20.8)') betacg,gmgm,gmmgmm
    if(betacg > 1.d0) then
       betacg = 0.d0
       if(ipri >= 1) write(nfout,*) ' beta for CG is too large, and it sets to be zero'
    else if(betacg < 0.d0) then
       betacg = 0.d0
       if(ipri >= 1) write(nfout,*) ' beta for CG is less than zero, and it sets to be zero'
    end if

    call m_ES_dealloc_scss_etc()
    deallocate( afft_kt, bfft_kt )
    deallocate( vnlph_noncl )

  end subroutine m_ESsd_decide_CG_direc_noncl
! ================================================================ 11.0

  subroutine decide_CG_direction_core(precon,ik,ekin,afft,bfft,p,sumdz2,sumdz)
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)
    real(kind=DP)              :: p(kg1)
    real(kind=DP), intent(out) :: sumdz2,sumdz

    integer :: ib
    integer :: id_sname = -1
    call tstatc0_begin('decide_CG_direction_core ', id_sname,1)

    do ib = ista_e, iend_e, istep_e      ! MPI
       call m_ES_WF_in_Rspace(ik,ib,bfft)! (swffft)
       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft) -> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON) ! bfft: G-space repres.
       call SD_direction(precon,ik,ib,ekin,bfft,p) !-(m_ES_WF_by_SDorCG)
    end do

    call orthogonalize_SD_drctns(ik,to=OTHER_BANDS)  ! -(m_ES_WF_by_SDorCG) ->(wfsd_l, bsd(ri)_l)

    call WFSD_dot_WFSD                   ! -(contained here)
    !    ~~~~~~~~~~~~~
    call tstatc0_end(id_sname)
  contains
    subroutine WFSD_dot_WFSD
      real(kind=DP) :: dz,dz2
      integer :: ib

      sumdz2 = 0.d0
      sumdz = 0.0d0
      do ib = ista_e, iend_e, istep_e      ! MPI
         call square_of_SD_direction(ik,ib,dz)
         dz2 = 0.d0
         if(sw_modified_cg_formula==ON) call square_of_SD_direction3(ik,ib,dz2)
         sumdz2 = sumdz2 + dz
         sumdz = sumdz + (dz-dz2)
!!$         sumdz = sumdz + dz
      end do
      if(npes > 1) then
         call mpi_allreduce(MPI_IN_PLACE, sumdz2,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
         call mpi_allreduce(MPI_IN_PLACE, sumdz ,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
      end if
    end subroutine WFSD_dot_WFSD
  end subroutine decide_CG_direction_core

! ================================== added by K. Tagami ================== 11.0
  subroutine decide_CG_direction_core_noncl( precon, ik, ekin, afft_kt, bfft_kt, &
       &                                    vnlph_noncl, p, sumdz2, sumdz )
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: ekin(kg1)

    real(kind=DP), intent(inout)  :: afft_kt(nfft,ndim_chgpot)
    real(kind=DP), intent(out) :: bfft_kt(nfft,ndim_spinor)
    real(kind=DP), intent(in)  :: vnlph_noncl(kg1,np_e,kimg,ndim_spinor)

    real(kind=DP)              :: p(kg1)
    real(kind=DP), intent(out) :: sumdz2, sumdz

    integer :: ib, is
    integer :: id_sname = -1
    call tstatc0_begin('decide_CG_direction_core_noncl ', id_sname,1)

    do ib = ista_e, iend_e, istep_e      ! MPI

       Do is=1, ndim_spinor
         call m_ES_WF_in_Rspace( ik+is-1, ib, bfft_kt(:,is) )! (swffft)
       End do

       call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, ndim_chgpot, ndim_spinor )
                                           ! (afft, bfft)-> (bfft)
       Do is=1, ndim_spinor
         call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
       End do

       call SD_direction_noncl( precon, ik, ib, ekin, bfft_kt, vnlph_noncl, p )
    end do

    call orthogonalize_SD_drctns_noncl( ik,to=OTHER_BANDS )
                               ! -(m_ES_WF_by_SDorCG) ->(wfsd_l, bsd(ri)_l)

    call WFSD_dot_WFSD_noncl                   ! -(contained here)

    call tstatc0_end(id_sname)

  contains

    subroutine WFSD_dot_WFSD_noncl
      real(kind=DP) :: dz, dz2
      integer :: ib

      sumdz2 = 0.d0
      sumdz = 0.0
      do ib = ista_e, iend_e, istep_e
         call square_of_SD_direction_noncl( ik, ib, dz )
         dz2 = 0.0d0

         if(sw_modified_cg_formula==ON) call square_of_SD_direction3_noncl(ik,ib,dz2)

         sumdz2 = sumdz2 + dz
         sumdz = sumdz + ( dz - dz2 )
      end do
      if(npes > 1) then
         call mpi_allreduce(MPI_IN_PLACE,sumdz2,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
         call mpi_allreduce(MPI_IN_PLACE,sumdz, 1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
      end if
    end subroutine WFSD_dot_WFSD_noncl

  end subroutine decide_CG_direction_core_noncl
! ====================================================================== 11.0

  subroutine m_ESsd_renew_WF_by_SDorCG(nfout,isolver,precon,dtim,iupdate)
    use m_IterationNumbers,     only : iteration
    use m_Control_Parameters,   only : sw_gep
#ifdef __TIMER__
    use m_Const_Parameters,   only : VDB, NORMCONSERVATION
#endif

    integer, intent(in) :: nfout,isolver, precon
    integer, intent(in), optional :: iupdate
    real(kind=DP)       :: dtim

    integer                              :: ispin, iksnl, ik, mode, ipri0
    real(kind=DP), pointer, dimension(:) :: ekin, p, vnldi
    real(kind=DP)                        :: vlhxc0
    real(kind=DP), allocatable :: cfft(:)
    real(kind=DP), allocatable, dimension(:,:) :: afft_spin

    if(sw_gep == ON.and.iteration>=2) then
      mode = NORMALIZATION
    else
      mode = ORTHONORMALIZATION
    endif
    call m_ES_alloc_afft_scss_etc()
    ekin => sc(1:kg1); p => ss(1:kg1); vnldi => qc(1:kg1)

    if(iprisolver >= 2) then
       if(isolver == SD) then
          write(nfout,'(" !! isolver_core = SD")')
       else if(isolver == MSD) then
          write(nfout,'(" !! isolver_core = MSD")')
       else if(isolver == CG) then
          write(nfout,'(" !! isolver_core = CG")')
       end if
    end if

    if ( use_metagga .and. vtau_exists ) allocate( cfft(nfft) )

    if(sw_fef==ON) call m_FEF_build_grad() !->grad_fef
    if(nrank_s==2) then
      allocate(afft_spin(nfft, 2))
      do ispin = 1, nspin
        call m_ES_Vlocal_in_Rspace(ispin,afft_spin(:,ispin))      ! (ptfft1) vlhxc_l->afft
      enddo
    endif
    do ispin = 1, nspin, (af+1)
       if(isolver == MSD) call vlhxc_l_zero_term(vlhxc0,ispin) ! -(m_ES_WF_by_SDorCG) ->vlhxc0
       if(nrank_s==1) then
         call m_ES_Vlocal_in_Rspace(ispin,afft)      ! (ptfft1) vlhxc_l->afft
       else
         afft(:) = afft_spin(:,ispin)
       endif
       if ( use_metagga .and. vtau_exists ) then
          call m_ES_Vlocal_in_Rspace( ispin, cfft, vtau_l )    ! r space
       endif

       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) == myrank_k) then           ! MPI
             iksnl = (ik-1)/nspin + 1
             call m_ES_Vnonlocal_W(ik,iksnl,ispin,ON)    ! (nonloc) ->(vnlph_l)
             if(sw_hybrid_functional==ON) call m_ES_Vexx_W(ik) ! (exx) ->(vnlph_l)
             if(sw_fef==ON) call m_FEF_add_grad_to_vnlph(ik) !->vnlph_l

             if ( use_metagga .and. vtau_exists ) then
                call m_ES_contrib_kindens_to_vnlph( ispin, ik, cfft )
             endif

             call m_pwBS_kinetic_energies(ik,vkxyz,ekin) ! (diakin) ->ekin
             if(isolver == SD) then
                call evolve_WFs_in_SD_direction&      ! -(m_ES_WF_by_SDorCG)
                     &(precon,ik,dtim,ekin, afft,bfft,p)
             else if(isolver == MSD ) then
                call evolve_WFs_in_MSD_direction&     !-(m_ES_WF_by_SDorCG)
                     &(precon,ik,iksnl,ispin,dtim,ekin, afft,bfft,p,vnldi,vlhxc0)
                if(ipri>=3.and.ik==1) &
                     & call m_ES_wd_zaj_small_portion(nfout,ik," -- after MSD --",16)
             else if(isolver == eazyCG) then
                call evolve_WFs_in_eazyCG_direction(precon,ik,dtim,ekin,afft,bfft,p)
             else if(isolver == CG) then
                call evolve_WFs_in_CG_direction(precon,ik,dtim,ekin,afft,bfft,p)
!!$                call evolve_WFs_in_CG_direction0(precon,ik,dtim,ekin,afft,bfft,p)
             endif
!!$             if(modnrm == EXECUT) call m_ES_betar_dot_WFs_4_each_k(nfout,ik) !-> fsr_l,fsi_l
! --------------- Added by T. Yamasaki, 28 June 2008 ---
             if(wfred_is_allocated) call cp_wfred(ik)
! ------------------------------------------------------<<
             call m_ES_MGS_4_each_k(nfout,ik,mode)
             if(sw_hybrid_functional==ON) then
                if(sw_retard_eigval_evaluation==OFF)then
                   call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,iupdate=iupdate)
                else
                   call m_ES_EXX_cp_eigenvalue(ik)
                endif
             endif
             call m_ES_eigen_values_for_each_k(ispin,ik,ekin,afft)
          end if
       enddo
    enddo
    if ( allocated(cfft) ) deallocate(cfft)

    if(sw_hybrid_functional==ON.and.sw_retard_eigval_evaluation==ON)then
       call m_ES_EXX_gather_valence_states(nfout)
       do ispin=1,nspin,af+1
          do ik=ispin, kv3+ispin-nspin, nspin
             if(map_k(ik) /= myrank_k) cycle ! MPI
             call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,update_eko=.false.,iupdate=iupdate)
          enddo
       enddo
    endif

!!$    if(nspin == 2 .and. sw_so == ON) then
!!$       do ik = 1, kv3, nspin

#ifdef LMM_PREVIOUS
    call m_ES_sort_eigen_values()   ! -> neordr, nrvf_ordr
! --> T. Yamasaki, 21th Jul. 2009
!!$    call m_ES_sort_eigen_values()   ! -> neordr, nrvf_ordr
! <--
#endif
    call get_ipri0(ipri, ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)
    call m_ES_dealloc_afft_scss_etc()
  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,MPI_CommGroup,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0
  end subroutine m_ESsd_renew_WF_by_SDorCG

! =============================== added by K. Tagami ================== 11.0
  subroutine m_ESsd_renew_WF_by_SDorCG_noncl(nfout,isolver,precon,dtim,iupdate)
    integer, intent(in) :: nfout,isolver, precon
    integer, intent(in), optional :: iupdate
    real(kind=DP)       :: dtim

    integer                              :: ispin, iksnl, ik, mode, ipri0
    integer :: is1, is2, istmp, k2

    real(kind=DP), pointer, dimension(:) :: ekin, p, vnldi

    real(kind=DP)                        :: vlhxc0( ndim_chgpot )
    real(kind=DP), allocatable :: afft_kt(:,:)
    real(kind=DP), allocatable :: bfft_kt(:,:)
    real(kind=DP), allocatable :: vnlph_noncl(:,:,:,:)

    call m_ES_alloc_scss_etc()

! --
!   Note : The followig is done in order to prevent allocating new arrays.
!
    ekin => sc(1:kg1); p => ss(1:kg1); vnldi => qc(1:kg1)
! --
    allocate(afft_kt(nfft,ndim_chgpot)); afft_kt = 0.0d0      ! pot
    allocate(bfft_kt(nfft,ndim_spinor)); bfft_kt = 0.0d0      ! wfn

    allocate(vnlph_noncl(kg1,np_e,kimg,ndim_spinor)); vnlph_noncl = 0.0d0

    mode = ORTHONORMALIZATION

    if(iprisolver >= 2) then
       if(isolver == SD) then
          write(nfout,'(" !! isolver_core = SD")')
       else if(isolver == MSD) then
          write(nfout,'(" !! isolver_core = MSD")')
       else if(isolver == CG) then
          write(nfout,'(" !! isolver_core = CG")')
       end if
    end if

    call m_ES_Vlocal_in_Rspace_noncl( afft_kt )      ! (ptfft1) vlhxc_l->afft
    if ( isolver == MSD ) then
       call vlhxc_l_zero_term_noncl( vlhxc0 )
    endif

    Do ik=1, kv3, ndim_spinor
       if (map_k(ik) /= myrank_k) cycle
       iksnl = (ik-1)/ndim_spinor + 1

       vnlph_noncl = 0.0d0

       Do is1=1, ndim_spinor
          Do is2=1, ndim_spinor
             istmp = ( is1-1 )*ndim_spinor +is2
             k2 = ik +is2 -1

             call m_ES_Vnonlocal_W( k2, iksnl, istmp, ON )
             ! (nonloc) ->(vnlph_l)

             vnlph_noncl(:,:,:,is1) = vnlph_noncl(:,:,:,is1) &
                  &                     + vnlph_l(:,:,:)
          End do
       End do

       if (sw_hybrid_functional==ON) call m_ES_Vexx_W(ik) ! (exx) ->(vnlph_l)

       call m_pwBS_kinetic_energies(ik,vkxyz,ekin) ! (diakin) ->ekin

       select case (isolver)
       case (SD)
          call evolve_WFs_in_SD_direc_noncl( precon, ik, dtim, ekin, &
               &                             afft_kt, bfft_kt, vnlph_noncl, p )
       case (MSD)
          call evolve_WFs_in_MSD_direc_noncl( precon, ik, iksnl, &
               &                              dtim, ekin, afft_kt, bfft_kt,&
               &                              vnlph_noncl, p, vnldi, vlhxc0 )
          if ( ipri>=3.and.ik==1 ) then
             Do is1=1, ndim_spinor
                write(nfout,*) 'is = ', is1
                call m_ES_wd_zaj_small_portion( nfout, ik+is1-1, " -- after MSD  --",21)
             End do
          endif
       case (eazyCG)
          call evolve_WFs_in_ezCG_direc_noncl( precon, ik, dtim, ekin, &
               &                               afft_kt, bfft_kt, vnlph_noncl, p )

       case (CG)
          call evolve_WFs_in_CG_direc_noncl( precon, ik, dtim, ekin, &
               &                             afft_kt, bfft_kt, vnlph_noncl, p )
       end select


       if (wfred_is_allocated) then
          Do is1=1, ndim_spinor
             call cp_wfred(ik+is1-1)
          End do
       endif

       call m_ES_MGS_4_each_k_noncl( nfout, ik, mode )

       if (sw_hybrid_functional==ON) call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,iupdate=iupdate)

       call m_ES_eigen_vals_each_k_noncl( ik, ekin, afft_kt, bfft_kt )

    End do


#ifdef LMM_PREVIOUS
    call m_ES_sort_eigen_vals_noncl
#endif
    call get_ipri0(ipri, ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)
    call m_ES_dealloc_scss_etc()
    deallocate( afft_kt, bfft_kt )

    deallocate( vnlph_noncl )

  contains

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,MPI_CommGroup,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0
  end subroutine m_ESsd_renew_WF_by_SDorCG_noncl
! ======================================================================== 11.0

  subroutine evolve_WFs_in_MSD_direction&
       &(precon,ik,iksnl,ispin,dtim,ekin,afft,bfft,p,vnldi,vlhxc0)
    integer, intent(in)        :: precon, ik, iksnl, ispin
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)
    real(kind=DP)              :: p(kg1), vnldi(kg1)
    real(kind=DP), intent(in)  :: vlhxc0

    real(kind=DP), allocatable :: vxdi(:) !d(kg1)

    integer ib, ig
    integer :: id_sname = -1
    call tstatc0_begin('evolve_WFs_in_MSD_direction ', id_sname,1)

    if(sw_hybrid_functional==ON) then
       allocate(vxdi(kg1))
       call m_ES_EXX_Diagonal_part(ispin,ik,vxdi)
    end if

#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(bfft,vnldi,p)
#endif
    do ib = ista_e, iend_e, istep_e      ! MPI
       call m_ES_WF_in_Rspace(ik,ib,bfft)! (swffft)

       if(ipri >= 2) then
          write(nfout,'(" --- afft and bfft <<evolve_WFs_in_MSD_direction>>,  ib = ",i5)') ib
          write(nfout,'(" afft: ",5d16.8)') (afft(ig),ig=1,min(5,nfft))
          write(nfout,'(" bfft: ",5d16.8)') (bfft(ig),ig=1,min(5,nfft))
       end if

       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft)-> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
       call Vnonlocal_Diagonal_part(ispin,ik,iksnl,ib,vnldi)
                                         ! -(m_ES_WF_by_SDorCG) (nonldj)
       if(sw_hybrid_functional==ON) call m_ES_EXX_add_Diagonal_part(ik,ib,vxdi,vnldi)
       if(ipri >= 2) then
          write(nfout,'(" --- vnlph_l <<evolve_WFs_in_MSD_direction>>,  ib = ",i5)') ib
                       write(nfout,'(" vnlph_l: Re ",5d16.8)') (vnlph_l(ig,ib,1),ig=1,min(5,iba(ik)))
          if(kimg== 2) write(nfout,'(" vnlph_l: Im ",5d16.8)') (vnlph_l(ig,ib,2),ig=1,min(5,iba(ik)))

          write(nfout,'(" vnldi ",5d16.8)') (vnldi(ig),ig=1,min(5,iba(ik)))
          write(nfout,'(" VlocalW: Re ",5d16.8)') (bfft(2*igf(nbase(ig,ik))-1),ig=1,min(5,iba(ik)))
          write(nfout,'(" VlocalW: Im ",5d16.8)') (bfft(2*igf(nbase(ig,ik))),ig=1,min(5,iba(ik)))
          write(nfout,'(" vlhxc0 = ",5d16.8)') vlhxc0
       end if
       call modified_steepest_descent&   ! -(m_ES_WF_by_SDorCG)
            &(precon,ik,ib,dtim,vnldi,vlhxc0,ekin,bfft,p)
    end do
    if(ipri>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')

    if(sw_hybrid_functional==ON) deallocate(vxdi)

    call tstatc0_end(id_sname)
  end subroutine evolve_WFs_in_MSD_direction

! ========================================= added by K. Tagami =============== 11.0
 subroutine evolve_WFs_in_MSD_direc_noncl( precon, ik, iksnl, &
       &                                    dtim, ekin, afft_kt, bfft_kt, &
       &                                    vnlph_noncl, p, vnldi, vlhxc0 )

    integer, intent(in)        :: precon, ik, iksnl
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(inout)  :: afft_kt(nfft,ndim_chgpot)
    real(kind=DP), intent(out) :: bfft_kt(nfft,ndim_spinor)
    real(kind=DP), intent(in)  :: vnlph_noncl(kg1,np_e,kimg,ndim_spinor)

    real(kind=DP)              :: p(kg1), vnldi(kg1)
    real(kind=DP), intent(in)  :: vlhxc0(ndim_chgpot)
!
#ifdef USE_COMPLEX_VNLDI
    complex(kind=CMPLDP), allocatable :: vnldi_noncl(:,:)
#else
    real(kind=DP), allocatable :: vnldi_noncl(:,:)
#endif
!
    integer ib, ig, is, istmp
    integer :: is1, is2

    integer :: id_sname = -1

    call tstatc0_begin('evolve_WFs_in_MSD_direc_noncl ', id_sname,1)

! ---------------------
    allocate( vnldi_noncl( kg1, ndim_spinor)); vnldi_noncl = 0.0d0
!    Do is=1, ndim_spinor
!      vnldi_noncl(:,is) = vnldi(:)
!    End do
! -----------------------

#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(bfft,vnldi,p)
#endif
    do ib = ista_e, iend_e, istep_e      ! MPI

       Do is=1, ndim_spinor
          call m_ES_WF_in_Rspace( ik +is -1, ib, bfft_kt(:,is) ) ! (swffft)
       End do

       call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, ndim_chgpot, ndim_spinor )
                                                       ! (afft, bfft)-> (bfft)
       Do is=1, ndim_spinor
         call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
       End do

       vnldi_noncl = 0.0d0
       Do is1=1, ndim_spinor
          Do is2=1, ndim_spinor
             istmp = ( is1 -1 )*ndim_spinor +is2

             call Vnonlocal_Diagonal_part_noncl( istmp, ik, iksnl, ib, &
                  &                              vnldi_noncl(:,is1) )
!             call Vnonlocal_Diagonal_part_noncl( istmp, ik, iksnl, ib, &
!                  &                              vnldi_noncl(:,is2) )
                                                    ! -(m_ES_WF_by_SDorCG) (nonldj)
          End do
       End do

       call modified_steepest_desc_noncl( precon, ik, ib, dtim, &
            &                             vnldi_noncl, vlhxc0, ekin,&
            &                             bfft_kt, vnlph_noncl, p )
    end do

    call tstatc0_end(id_sname)
    deallocate( vnldi_noncl)

  end subroutine evolve_WFs_in_MSD_direc_noncl
! ========================================================================= 11.0

  subroutine evolve_WFs_in_SD_direction&
       &(precon,ik,dtim,ekin,afft,bfft,p)
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)
    real(kind=DP)              :: p(kg1)

    integer :: ib
    integer :: id_sname = -1
    call tstatc0_begin('evolve_WFs_in_SD_direction ', id_sname,1)

    do ib = ista_e, iend_e, istep_e      ! MPI
       call m_ES_WF_in_Rspace(ik,ib,bfft)! (swffft)
       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft)-> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
       call steepest_descent(precon,ik,ib,dtim,ekin,bfft,p)
                                         ! -(m_ES_WF_by_SDorCG)
    end do
    if(ipri>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
    call tstatc0_end(id_sname)
  end subroutine evolve_WFs_in_SD_direction

! =============================== added by K. Tagami =================== 11.0
  subroutine evolve_WFs_in_SD_direc_noncl( precon, ik, dtim, ekin, &
       &                                   afft_kt, bfft_kt, vnlph_noncl, p )
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(inout)  :: afft_kt( nfft,ndim_chgpot )
    real(kind=DP), intent(out) :: bfft_kt(nfft,ndim_spinor)
    real(kind=DP), intent(in)  :: vnlph_noncl(kg1,np_e,kimg,ndim_spinor)

    real(kind=DP)              :: p(kg1)

    integer :: ib, is
    integer :: id_sname = -1
    call tstatc0_begin('evolve_WFs_in_SD_direc_noncl ', id_sname,1)

    do ib = ista_e, iend_e, istep_e      ! MPI
       Do is=1, ndim_spinor
         call m_ES_WF_in_Rspace( ik+is-1, ib, bfft_kt(:,is) )  ! (swffft)
       End do

       call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, nspin, ndim_spinor )

       Do is=1, ndim_spinor
         call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
       End do

       call steepest_descent_noncl( precon, ik, ib, dtim, ekin, bfft_kt, &
            &                       vnlph_noncl, p )
    end do

    call tstatc0_end(id_sname)

  end subroutine evolve_WFs_in_SD_direc_noncl
! =========================================================================== 11.0

  subroutine evolve_WFs_in_eazyCG_direction(precon,ik,dtim,ekin,afft,bfft,p)
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)
    real(kind=DP)              :: p(kg1)

    real(kind=DP), parameter   :: Delta = 1.d-10
!!$    real(kind=DP)   :: dz, sumdz2
    integer :: ib
    integer :: id_sname = -1
    call tstatc0_begin('evolve_WFs_in_eazyCG_direction ', id_sname,1)

    if(modnrm == EXECUT) call alloc_wfsd_bsdri(ik)
    if(modnrm == EXECUT .and. precon == ON) call alloc_wfsdnp_bsdrinp(ik)

    do ib = ista_e, iend_e, istep_e      ! MPI
       call m_ES_WF_in_Rspace(ik,ib,bfft)! (swffft)
       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft) -> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON) ! bfft: G-space repres.
       call SD_direction(precon,ik,ib,ekin,bfft,p)! -(m_ES_WF_by_SDorCG) zaj_l, etc -> wfsd_l
       !    ~~~~~~~~~~~~
    end do

!!$    call orthogonalize_SD_drctns(ik,to=OTHER_BANDS)   ! -(m_ES_WF_by_SDorCG) ->wfsd_l
    if(precon == ON) call Precon_dot_SD(ik,ekin,p)  ! -(m_ES_WF_by_SDorCG) -> wfsd_np, wfsd_l
!!$    call orthogonalize_SD_drctns(ik,to=ALL_BANDS)     ! -(m_ES_WF_by_SDorCG) ->wfsd_l
    !                                      wfsd_l is orthogonalized to zaj_l's
    if(modnrm == EXECUT) call m_ES_betar_dot_Psi_4_each_k(nfout,wfsd_l,ik,ik,ik,bsdr_l,bsdi_l)
    if(modnrm == EXECUT .and. precon == ON ) then
       write(6,'(" m_ES_betar_dot_Psi_4_each_k is being called (evolve_WFs_in_eazyCG_direction)")')
       call m_ES_betar_dot_Psi_4_each_k(nfout,wfsd_np,ik,ik,ik,bsdr_np,bsdi_np)
    end if
    call get_betacg                      ! -(contained here) wfsd_l ->betacg, dzajn2
    !    ~~~~~~~~~~
!!$    do ib = ista_e, iend_e, istep_e      ! MPI
!!$       call m_ES_WF_in_Rspace(ik,ib,bfft)! (swffft)
!!$       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft) -> (bfft)
!!$       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON) ! bfft: G-space repres.
!!$       call SD_direction(precon,ik,ib,ekin,bfft,p)! -(m_ES_WF_by_SDorCG) zaj_l, etc -> wfsd_l
!!$       !    ~~~~~~~~~~~~
!!$    end do
!!$
!!$    sumdz2 = 0.d0
!!$    do ib = ista_e, iend_e, istep_e      ! MPI
!!$       call square_of_SD_direction(ik,ib,dz)  ! wfsd_l dot wfsd_l
!!$       write(nfout,'(" dz = ",d20.8)') dz
!!$       sumdz2 = sumdz2 + dz
!!$    end do

    call make_CG_direction(ik)
!!$    write(6,'(" -- before orthonormalization -- ")')
!!$    call check_of_orthonormality(ik)  ! z = <wfsd_l(i)|zaj_l(j)>
!!$    call orthogonalize_SD_drctns(ik,to=OTHER_BANDS)     ! -(m_ES_WF_by_SDorCG) ->wfsd_l
    call cp_wfsd_to_wfsd_old(ik)                        ! -(m_ES_WF_by_SDorCG) wfsd_l ->wfsd_old
!!$    write(6,'(" -- after orthonormalization -- ")')
!!$    call check_of_orthonormality(ik)  ! z = <wfsd_l(i)|zaj_l(j)>

!!$    write(6,'(" -- before evolution -- ")')
!!$    call check_of_orthonormality2(ik)  ! <zaj_l(i)|zaj_l(j)>
    do ib = ista_e, iend_e, istep_e      ! MPI
       call WF_conjugate_gradient(ik,ib,dtim) !-(m_ES_WF_by_SDorCG)
    end do
    if(ipri>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
!!$    write(6,'(" -- after evolution -- ")')
!!$    call check_of_orthonormality2(ik)  ! <zaj_l(i)|zaj_l(j)>

!!$    do ib = ista_e, iend_e, istep_e      ! MPI
!!$       call m_ES_WF_in_Rspace(ik,ib,bfft)! (swffft)
!!$       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft) -> (bfft)
!!$       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
!!$       call WF_conjugate_gradient0(precon,ik,ib,dtim,ekin,bfft,p)
!!$       !    ~~~~~~~~~~~~~~~~~~~~~~         -(m_ES_WF_by_SDorCG)
!!$    end do
    if(modnrm == EXECUT) call dealloc_wfsd_bsdri()
    if(modnrm == EXECUT .and. precon == ON) call dealloc_wfsdnp_bsdrinp()
    call tstatc0_end(id_sname)
  contains
    subroutine get_betacg
      real(kind=DP) :: sumdz2, dz, avbetacg, betacg_min, betacg_max, avnewbetacg
      integer       :: ib

      if(ik == ista_k) then
         betacg_min = 1.d+10; betacg_max = -1.d+10; avbetacg = 0.d0
         avnewbetacg = 0.d0
      end if

      sumdz2 = 0.d0
      do ib = ista_e, iend_e, istep_e
         if(ipri >=1 ) write(6,'(" !! square_of_SD_direction(2?) is being called (evolve_WFs_in_eazyCG_direction.betacg)")')
         if(Precon == ON) then
            call square_of_SD_direction2(ik,ib,dz)
         else
            call square_of_SD_direction(ik,ib,dz)
         end if
         sumdz2 = sumdz2 + dz
      end do
      if(npes>1) call mpi_allreduce(MPI_IN_PLACE,sumdz2,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)

      if(dabs(dzajn2(ik)) > Delta) then
         betacg = sumdz2/dzajn2(ik)
      else
         betacg = 0.d0
      endif
      dzajn2(ik) = sumdz2

      if(ipri >= 1) write(nfout,'(" ik = ",i5," sumdz2 = ", d20.8, " betacg = ",d20.8)') ik,sumdz2,betacg
      if(betacg_min > betacg) betacg_min = betacg
      if(betacg_max < betacg) betacg_max = betacg
      avbetacg = avbetacg + betacg/kv3

      if(betacg > 1.d0) betacg = 1.d0
      if(betacg < 0.d0) betacg = 0.d0

      if(kv3 > 1 .and. ik == iend_k) then              ! MPI
         avnewbetacg = avnewbetacg + betacg/kv3
         if(ipri >= 1) write(nfout, '(" ! average of betacg = ",2f10.6," range ",f10.6,"-" &
              &,       f10.6)') avbetacg, avnewbetacg, betacg_min, betacg_max
      end if
    end subroutine get_betacg

    subroutine check_of_orthonormality(ik)
      integer, intent(in) :: ik
      integer             :: i, j, ig
      real(kind=DP)       :: wz

      if(k_symmetry(ik) == GAMMA) then
         do j = ista_e, iend_e, istep_e
            do i = ista_e, iend_e, istep_e
               wz = 0.d0
               do ig = 2, iba(ik)
                  wz = wz + wfsd_l(ig,i,ik,1)*zaj_l(ig,j,ik,1)
               end do
               wz = wz*2.d0 + wfsd_l(1,i,ik,1)*zaj_l(1,j,ik,1)
               if(ipri >= 1) write(6,'(" (i,j) = ",2i5, " wz = ",d20.8)') i,j, wz
            end do
         end do
      else
         do j = ista_e, iend_e, istep_e
            do i = ista_e, iend_e, istep_e
               wz = 0.d0
               do ig = 1, iba(ik)
                  wz = wz + wfsd_l(ig,i,ik,1)*zaj_l(ig,j,ik,1)
               end do
               if(ipri >= 1) write(6,'(" (i,j) = ",2i5, " wz = ",d20.8)') i,j, wz
            end do
         end do
      end if
    end subroutine check_of_orthonormality

    subroutine check_of_orthonormality2(ik)
      integer, intent(in) :: ik
      integer             :: i, j, ig
      real(kind=DP)       :: wz

      if(k_symmetry(ik) == GAMMA) then
         do j = ista_e, iend_e, istep_e
            do i = ista_e, iend_e, istep_e
               wz = 0.d0
               do ig = 2, iba(ik)
                  wz = wz + zaj_l(ig,i,ik,1)*zaj_l(ig,j,ik,1)
               end do
               wz = wz*2.d0 + zaj_l(1,i,ik,1)*zaj_l(1,j,ik,1)
               if(ipri >=1 ) write(6,'(" (i,j) = ",2i5, " zz = ",d20.8)') i,j, wz
            end do
         end do
      else
         do j = ista_e, iend_e, istep_e
            do i = ista_e, iend_e, istep_e
               wz = 0.d0
               do ig = 1, iba(ik)
                  wz = wz + zaj_l(ig,i,ik,1)*zaj_l(ig,j,ik,1)
               end do
               wz = wz*2.d0
               if(ipri >=1 ) write(6,'(" (i,j) = ",2i5, " zz = ",d20.8)') i,j, wz
            end do
         end do
      end if
    end subroutine check_of_orthonormality2
  end subroutine evolve_WFs_in_eazyCG_direction

! ============================ added by K. Tagami ========================= 11.0
  subroutine evolve_WFs_in_ezCG_direc_noncl( precon, ik, dtim, ekin,&
       &                                     afft_kt, bfft_kt, vnlph_noncl,  p )
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(inout)  :: afft_kt(nfft,ndim_chgpot)
    real(kind=DP), intent(out) :: bfft_kt(nfft,ndim_spinor)
    real(kind=DP), intent(in)  :: vnlph_noncl(kg1,np_e,kimg,ndim_spinor)
    real(kind=DP)              :: p(kg1)

    real(kind=DP), parameter   :: Delta = 1.d-10

    integer :: ib, is
    integer :: id_sname = -1
    call tstatc0_begin('evolve_WFs_in_eazyCG_dire_noncl ', id_sname,1)

    if (modnrm==EXECUT) call alloc_wfsd_bsdri_noncl(ik,ik+ndim_spinor-1)

    if (modnrm==EXECUT .and. precon==ON) then
	call alloc_wfsdnp_bsdrinp_noncl( ik,ik+ndim_spinor-1 )
    endif

    do ib = ista_e, iend_e, istep_e      ! MPI
       Do is=1, ndim_spinor
         call m_ES_WF_in_Rspace( ik+is-1, ib, bfft_kt(:,is) )  ! (swffft)
       End do

       call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, nspin, ndim_spinor )

       Do is=1, ndim_spinor
         call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
                                           ! bfft: G-space repres.
       End do
!
       call SD_direction_noncl( precon, ik, ib, ekin, bfft_kt, vnlph_noncl, p )

    end do

    if (precon == ON) then
       call Precon_dot_SD_noncl( ik, ekin, p )
                   ! -(m_ES_WF_by_SDorCG) -> wfsd_np, wfsd_l
    endif

    if (modnrm == EXECUT) then
       Do is=1, ndim_spinor
          call m_ES_betar_dot_Psi_4_each_k(nfout, wfsd_l, ik, ik+ndim_spinor-1, &
	&                                   ik+is-1, bsdr_l, bsdi_l)
       End do
    endif
    if (modnrm == EXECUT .and. precon == ON ) then
       Do is=1, ndim_spinor
          call m_ES_betar_dot_Psi_4_each_k(nfout, wfsd_np, ik, ik+ndim_spinor-1, &
	&                                   ik+is-1, bsdr_np, bsdi_np )
       End do
    end if

    call get_betacg_noncl
                                     ! -(contained here) wfsd_l ->betacg, dzajn2
    Do is=1, ndim_spinor
      call cp_wfsd_to_wfsd_old(ik+is-1)
                                   ! -(m_ES_WF_by_SDorCG) wfsd_l ->wfsd_old
      call make_CG_direction(ik+is-1)
    End do

    do ib = ista_e, iend_e, istep_e      ! MPI
       Do is=1, ndim_spinor
          call WF_conjugate_gradient( ik+is-1, ib, dtim ) !-(m_ES_WF_by_SDorCG)
       End do
    end do

    if(modnrm == EXECUT) call dealloc_wfsd_bsdri()
    if(modnrm == EXECUT .and. precon == ON) call dealloc_wfsdnp_bsdrinp()

    call tstatc0_end(id_sname)

  contains

    subroutine get_betacg_noncl
      real(kind=DP) :: sumdz2, dz, avbetacg, betacg_min, betacg_max, avnewbetacg
      integer       :: ib

      if(ik == ista_k) then                ! MPI
         betacg_min = 1.d+10; betacg_max = -1.d+10; avbetacg = 0.d0
         avnewbetacg = 0.d0
      end if

      sumdz2 = 0.d0
      do ib = ista_e, iend_e, istep_e
         if(ipri >=1 ) write(6,'(" !! square_of_SD_direction(2?) is being called (evolve_WFs_in_eazyCG_direction.betacg)")')
         if(Precon == ON) then
            call square_of_SD_direction2_noncl(ik,ib,dz)
         else
            call square_of_SD_direction_noncl(ik,ib,dz)
         end if
         sumdz2 = sumdz2 + dz
      end do

      if(npes>1) call mpi_allreduce(MPI_IN_PLACE,sumdz2,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)

      if(dabs(dzajn2(ik)) > Delta) then
         betacg = sumdz2/dzajn2(ik)
      else
         betacg = 0.d0
      endif
      dzajn2(ik) = sumdz2

      if(ipri >= 1) write(nfout,'(" ik = ",i5," sumdz2 = ", d20.8, " betacg = ",d20.8)') ik,sumdz2,betacg
      if(betacg_min > betacg) betacg_min = betacg
      if(betacg_max < betacg) betacg_max = betacg
      avbetacg = avbetacg + betacg / ( kv3/ndim_spinor )

      if(betacg > 1.d0) betacg = 1.d0
      if(betacg < 0.d0) betacg = 0.d0

      if(kv3 > 1 .and. ik == iend_k-ndim_spinor+1 )  then              ! MPI
         avnewbetacg = avnewbetacg + betacg/ ( kv3 /ndim_spinor )
         if(ipri >= 1) write(nfout, '(" ! average of betacg = ",2f10.6," range ",f10.6,"-" &
              &,       f10.6)') avbetacg, avnewbetacg, betacg_min, betacg_max
      end if
    end subroutine get_betacg_noncl

    subroutine check_of_orthonormality_noncl(ik)
      integer, intent(in) :: ik
      integer             :: i, j, ig
      real(kind=DP)       :: wz
      real(kind=DP)       :: wz1, wz2

      if(k_symmetry(ik) == GAMMA) then
         do j = ista_e, iend_e, istep_e
            do i = ista_e, iend_e, istep_e
               wz1 = 0.d0; wz2 = 0.0d0
               Do is=1, ndim_spinor
                 do ig = 2, iba(ik)
                    wz1 = wz1 + wfsd_l(ig,i,ik+is-1,1)*zaj_l(ig,j,ik+is-1,1)
                 end do
               End do
               Do is=1, ndim_spinor
                  wz2 = wz2 + wfsd_l(1,i,ik+is-1,1)*zaj_l(1,j,ik+is-1,1)
               End do
               wz = wz1*2.d0 + wz2
               if(ipri >= 1) write(6,'(" (i,j) = ",2i5, " wz = ",d20.8)') i,j, wz
            end do
         end do
      else
         do j = ista_e, iend_e, istep_e
            do i = ista_e, iend_e, istep_e
               wz = 0.d0
               Do is=1, ndim_spinor
                  do ig = 1, iba(ik)
                     wz = wz + wfsd_l(ig,i,ik+is-1,1)*zaj_l(ig,j,ik+is-1,1)
                  end do
               End do
               if(ipri >= 1) write(6,'(" (i,j) = ",2i5, " wz = ",d20.8)') i,j, wz
            end do
         end do
      end if
    end subroutine check_of_orthonormality_noncl

    subroutine check_of_orthonormality2_noncl(ik)
      integer, intent(in) :: ik
      integer             :: i, j, ig
      real(kind=DP)       :: wz
      real(kind=DP)       :: wz1, wz2

      if(k_symmetry(ik) == GAMMA) then
         do j = ista_e, iend_e, istep_e
            do i = ista_e, iend_e, istep_e
               wz1 = 0.d0; wz2 = 0.0d0
               Do is=1, ndim_spinor
                 do ig = 2, iba(ik)
                    wz1 = wz1 + zaj_l(ig,i,ik+is-1,1)*zaj_l(ig,j,ik+is-1,1)
                 end do
               End do
               Do is=1, ndim_spinor
                  wz2 = wz2 + zaj_l(1,i,ik+is-1,1)*zaj_l(1,j,ik+is-1,1)
               End do
               wz = wz1*2.d0 + wz2

               if(ipri >=1 ) write(6,'(" (i,j) = ",2i5, " zz = ",d20.8)') i,j, wz
            end do
         end do
      else
         do j = ista_e, iend_e, istep_e
            do i = ista_e, iend_e, istep_e
               wz = 0.d0
               Do is=1, ndim_spinor
                 do ig = 1, iba(ik)
                    wz = wz + zaj_l(ig,i,ik+is-1,1)*zaj_l(ig,j,ik+is-1,1)
                 end do
               End do
               wz = wz*2.d0
               if(ipri >=1 ) write(6,'(" (i,j) = ",2i5, " zz = ",d20.8)') i,j, wz
            end do
         end do
      end if
    end subroutine check_of_orthonormality2_noncl

  end subroutine evolve_WFs_in_ezCG_direc_noncl
! ===================================================================== 11.0

  subroutine evolve_WFs_in_CG_direction(precon,ik,dtim,ekin,afft,bfft,p)
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)
    real(kind=DP)              :: p(kg1)

    integer :: ib
    integer :: id_sname = -1
    call tstatc0_begin('evolve_WFs_in_CG_direction ', id_sname,1)

    call alloc_wfsd_bsdri(ik)

    do ib = ista_e, iend_e, istep_e
       call m_ES_WF_in_Rspace(ik,ib,bfft)! (swffft)
       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft) -> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON) ! bfft: G-space repres.
       call SD_direction(precon,ik,ib,ekin,bfft,p)     ! -(m_ES_WF_by_SDorCG) -> wfsd_l
       !                wfsd_l : -(H-e_{k\mu}^m)\Psi_{k\mu}^m
    end do

    call orthogonalize_SD_drctns(ik,to=SAME_BAND) ! -(m_ES_WF_by_SDorCG) ->(wfsd_l,bsd(ri)_l)
    call make_CG_direction(ik)       ! -(m_ES_WF_by_SDorCG) -> wfsd_l + betacg*wfsd_old -> wfsd_l
!!$    call orthogonalize_SD_drctns(ik,to=SAME_BAND) ! Actually, CG direction ->(wfsd_l,bsd(ri)_l)

    do ib = ista_e, iend_e, istep_e
       call WF_conjugate_gradient(ik,ib,dtim) !-(m_ES_WF_by_SDorCG)
    end do

    call cp_wfsd_to_wfsd_old(ik)    ! -(m_ES_WF_by_SDorCG) wfsd_l ->wfsd_old

    call dealloc_wfsd_bsdri()
    call tstatc0_end(id_sname)
  end subroutine evolve_WFs_in_CG_direction

! ======================================= added by K. Tagami ================= 11.0
  subroutine evolve_WFs_in_CG_direc_noncl( precon, ik, dtim, ekin, &
       &                                   afft_kt, bfft_kt, vnlph_noncl, p)
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(inout)  :: afft_kt(nfft,ndim_chgpot)
    real(kind=DP), intent(out) :: bfft_kt(nfft,ndim_spinor)
    real(kind=DP), intent(in)  :: vnlph_noncl(kg1,np_e,kimg,ndim_spinor)
    real(kind=DP)              :: p(kg1)

    integer :: ib, is
    integer :: id_sname = -1
    call tstatc0_begin('evolve_WFs_in_CG_direc_noncl ', id_sname,1)

    call alloc_wfsd_bsdri_noncl( ik,ik+ndim_spinor-1 )

    do ib = ista_e, iend_e, istep_e

       Do is=1, ndim_spinor
          call m_ES_WF_in_Rspace( ik+is-1, ib, bfft_kt(:,is) )   ! (swffft)
       End do

       call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, ndim_chgpot, ndim_spinor )

       Do is=1, ndim_spinor
         call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
       End do

       call SD_direction_noncl( precon, ik, ib, ekin, bfft_kt, vnlph_noncl, p )
                                 ! -(m_ES_WF_by_SDorCG) -> wfsd_l
                                  !        wfsd_l : -(H-e_{k\mu}^m)\Psi_{k\mu}^m

    end do

    call orthogonalize_SD_drctns_noncl( ik,to=SAME_BAND )
                       ! -(m_ES_WF_by_SDorCG) ->(wfsd_l,bsd(ri)_l)

    Do is=1, ndim_spinor
      call make_CG_direction(ik+is-1)
                  ! -(m_ES_WF_by_SDorCG) -> wfsd_l + betacg*wfsd_old -> wfsd_l
    End do
    do ib = ista_e, iend_e, istep_e           ! MPI
       Do is=1, ndim_spinor
          call WF_conjugate_gradient( ik+is-1, ib, dtim )   !-(m_ES_WF_by_SDorCG)
       End do
    end do

    Do is=1, ndim_spinor
       call cp_wfsd_to_wfsd_old( ik+is-1 )
                                       ! -(m_ES_WF_by_SDorCG) wfsd_l ->wfsd_old
    End do

    call dealloc_wfsd_bsdri()
    call tstatc0_end(id_sname)
  end subroutine evolve_WFs_in_CG_direc_noncl
! ================================================================= 11.0

  subroutine evolve_WFs_in_CG_direction0 &
       &(precon,ik,dtim,ekin,afft,bfft,p)
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)
    real(kind=DP)              :: p(kg1)

    integer :: ib
    integer :: id_sname = -1
    call tstatc0_begin('evolve_WFs_in_CG_direction0 ', id_sname,1)

    do ib = ista_e, iend_e, istep_e
       call m_ES_WF_in_Rspace(ik,ib,bfft)! (swffft)
       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft) -> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
       call WF_conjugate_gradient0(precon,ik,ib,dtim,ekin,bfft,p) !-(m_ES_WF_by_SDorCG)
    end do
    if(ipri>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
    call tstatc0_end(id_sname)
  end subroutine evolve_WFs_in_CG_direction0

  subroutine vlhxc_l_zero_term(vlhxc0,ispin)
    real(kind=DP), intent(out) :: vlhxc0
    integer, intent(in)        :: ispin

    if(mype == 0) vlhxc0 = vlhxc_l(1,1,ispin)
    call mpi_bcast(vlhxc0,1,mpi_double_precision,0,MPI_CommGroup,ierr)
  end subroutine vlhxc_l_zero_term

! ===================================== added by K. Tagami ============== 11.0
  subroutine vlhxc_l_zero_term_noncl( vlhxc0 )
    real(kind=DP), intent(out) :: vlhxc0(ndim_chgpot)

    vlhxc0 = 0.0d0
!
    if (mype == 0) then
! ------------------------------ uncertain ----
!        vlhxc0(1)           = vlhxc_l(1,1,1) + vlhxc_l(1,1,ndim_magmom)
!        vlhxc0(ndim_chgpot) = vlhxc_l(1,1,1) - vlhxc_l(1,1,ndim_magmom)
!
       vlhxc0 = vlhxc_l(1,1,1)
! --------------------------
    endif
    call mpi_bcast( vlhxc0, ndim_chgpot, mpi_double_precision,0,MPI_CommGroup,ierr)
  end subroutine vlhxc_l_zero_term_noncl
! ========================================================================= 11.0

  subroutine modified_steepest_descent&
       &(precon,ik,ibo,dtim,vnldi,vlhxc0,ekin,VlocalW,p)
    integer      , intent(in)                  :: precon,ik,ibo
    real(kind=DP), intent(in)                  :: dtim
    real(kind=DP), intent(in), dimension(kg1)  :: vnldi
    real(kind=DP), intent(in)                  :: vlhxc0
    real(kind=DP), intent(in), dimension(kg1)  :: ekin
    real(kind=DP), intent(in), dimension(nfft) :: VlocalW
    real(kind=DP)            , dimension(kg1)  :: p

    integer       :: i, i1, ib
    real(kind=DP) :: evr,devr,denom, wdi, evi,e1, devi, fdexp
!!$    integer :: id_sname = -1
!!$    call tstatc0_begin('modified_steepest_descent ', id_sname)

    ib = map_z(ibo)                            ! MPI
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    call m_ES_decide_precon_factor(precon,ik,ibo,ekin,p)  ! -> p(1:iba(ik))
    if(ipri >= 3) then
       write(nfout,'(" ekin : ",5d16.8)') (ekin(i),i=1,iba(ik))
       write(nfout,'(" p    : ",5d16.8)') (p(i),i=1,iba(ik))
    end if

#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
    if(kimg == 1) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          evr   = zaj_l(i,ib,ik,1)
          devr  = (ekin(i)-eko_l(ib,ik))*evr&
               & + VlocalW(i1)*denom + vnlph_l(i,ib,1)
          wdi   = ekin(i) + vlhxc0 + vnldi(i) - eko_l(ib,ik)
! === 0 divide occurs if abs(wdi) < epsilon. by tkato 2012/12/18 ===============
!         fdexp = dexp( -p(i) * wdi * dtim)
!         zaj_l(i,ib,ik,1) = (fdexp - 1)*devr/wdi + evr
          if(dabs(wdi) < SmallestPositiveNumber) then
             zaj_l(i,ib,ik,1) = -p(i)*devr*dtim + evr
          else
             fdexp = dexp( -p(i) * wdi * dtim)
             zaj_l(i,ib,ik,1) = (fdexp - 1)*devr/wdi + evr
          end if
! ==============================================================================
       end do
    else if(kimg == 2) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          evr   = zaj_l(i,ib,ik,1);    evi   = zaj_l(i,ib,ik,2)
          e1    = ekin(i) - eko_l(ib,ik)
          devr  = e1*evr+VlocalW(2*i1-1)*denom+vnlph_l(i,ib,1)
          devi  = e1*evi+VlocalW(2*i1  )*denom+vnlph_l(i,ib,2)
          wdi   = ekin(i) + vlhxc0 + vnldi(i) - eko_l(ib,ik)
! === 0 divide occurs if abs(wdi) < epsilon. by tkato 2012/12/18 ===============
!         fdexp = dexp( -p(i) * wdi * dtim)
!         zaj_l(i,ib,ik,1) = (fdexp - 1)*devr/wdi + evr
!         zaj_l(i,ib,ik,2) = (fdexp - 1)*devi/wdi + evi
          if(dabs(wdi) < SmallestPositiveNumber) then
             zaj_l(i,ib,ik,1) = -p(i)*devr*dtim + evr
             zaj_l(i,ib,ik,2) = -p(i)*devi*dtim + evi
          else
             fdexp = dexp( -p(i) * wdi * dtim)
             zaj_l(i,ib,ik,1) = (fdexp - 1)*devr/wdi + evr
             zaj_l(i,ib,ik,2) = (fdexp - 1)*devi/wdi + evi
          end if
! ==============================================================================
       end do
    end if
!!$    call tstatc0_end(id_sname)
  end subroutine modified_steepest_descent

! ================================ added by K. Tagami =================== 11.0
  subroutine modified_steepest_desc_noncl( precon, ik, ibo, dtim, &
       &                                   vnldi_noncl, vlhxc0, ekin, &
       &                                   VlocalW_noncl, vnlph_noncl, p )
    integer      , intent(in)                  :: precon,ik,ibo
    real(kind=DP), intent(in)                  :: dtim

#ifdef USE_COMPLEX_VNLDI
    complex(kind=CMPLDP), intent(in), dimension(kg1,ndim_spinor)  :: vnldi_noncl
#else
    real(kind=DP), intent(in), dimension(kg1,ndim_spinor)  :: vnldi_noncl
#endif

    real(kind=DP), intent(in)                  :: vlhxc0(ndim_chgpot)
    real(kind=DP), intent(in), dimension(kg1)  :: ekin
    real(kind=DP), intent(in), dimension(nfft,ndim_spinor) :: VlocalW_noncl
    real(kind=DP), intent(in), dimension(kg1,np_e,kimg,ndim_spinor) :: vnlph_noncl

    real(kind=DP)            , dimension(kg1)  :: p

    integer       :: i, i1, ib
    integer  :: is, k1, istmp

#ifdef USE_COMPLEX_VNLDI
    real(kind=DP) :: evr,devr,denom, evi, e1, devi
    complex(kind=CMPLDP) :: zwdi, zfdexp, ztmp1
    real(kind=DP) :: ctmp1, stmp1
#else
    real(kind=DP) :: evr,devr,denom, wdi, evi,e1, devi, fdexp
#endif

    ib = map_z(ibo)                            ! MPI
    denom = 1.d0/product(fft_box_size_WF(1:3,1))

    call m_ES_decide_precon_factor(precon,ik,ibo,ekin,p)  ! -> p(1:iba(ik))

    if(ipri >= 3) then
       write(nfout,'(" ekin : ",5d16.8)') (ekin(i),i=1,iba(ik))
       write(nfout,'(" p    : ",5d16.8)') (p(i),i=1,iba(ik))
    end if

#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) then
       do is = 1, ndim_spinor
          k1 = ik+is-1
          status_saved_phifftr(ib,k1) = OLD
       end do
    end if
#endif
#ifdef USE_COMPLEX_VNLDI
    if(kimg == 1) then

    else if(kimg == 2) then

       Do is=1, ndim_spinor
         k1 = ik +is -1
         istmp = ( is -1 )*ndim_spinor + is

         do i = 1, iba(ik)
            i1    = igf(nbase(i,ik))
            evr   = zaj_l(i,ib,k1,1);    evi   = zaj_l(i,ib,k1,2)
            e1    = ekin(i) - eko_l(ib,ik)

            devr  = e1*evr+VlocalW_noncl(2*i1-1,is)*denom +vnlph_noncl(i,ib,1,is)
            devi  = e1*evi+VlocalW_noncl(2*i1,  is)*denom +vnlph_noncl(i,ib,2,is)

            zwdi   = ekin(i) + vlhxc0(istmp) + vnldi_noncl(i,is) - eko_l(ib,ik)

            ztmp1 = -p(i) * zwdi * dtim
            zfdexp = exp( ztmp1 )

            ztmp1 = ( zfdexp - 1.0d0 ) / zwdi
            ztmp1 = ztmp1 *cmplx( devr, devi )

            ctmp1 = real(ztmp1);  stmp1 = aimag(ztmp1)

            zaj_l(i,ib,k1,1) = ctmp1 + evr
            zaj_l(i,ib,k1,2) = stmp1 + evi
          End do
       end do
    end if

#else
    if(kimg == 1) then
       Do is=1, ndim_spinor
         k1 = ik +is -1
         istmp = ( is -1 )*ndim_spinor + is

         do i = 1, iba(ik)
            i1    = igf(nbase(i,ik))
            evr   = zaj_l(i,ib,k1,1)
            devr  = (ekin(i)-eko_l(ib,ik))*evr&
               & + VlocalW_noncl(i1,is)*denom + vnlph_noncl(i,ib,1,is)
            wdi   = ekin(i) + vlhxc0(istmp) + vnldi_noncl(i,is) - eko_l(ib,ik)

            fdexp = dexp( -p(i) * wdi * dtim)
            zaj_l(i,ib,k1,1) = (fdexp - 1)*devr/wdi + evr
          End do
       end do
    else if(kimg == 2) then
       Do is=1, ndim_spinor
         k1 = ik +is -1
         istmp = ( is -1 )*ndim_spinor + is

         do i = 1, iba(ik)
            i1    = igf(nbase(i,ik))
            evr   = zaj_l(i,ib,k1,1);    evi   = zaj_l(i,ib,k1,2)
            e1    = ekin(i) - eko_l(ib,ik)

            devr  = e1*evr+VlocalW_noncl(2*i1-1,is)*denom +vnlph_noncl(i,ib,1,is)
            devi  = e1*evi+VlocalW_noncl(2*i1,  is)*denom +vnlph_noncl(i,ib,2,is)

            wdi   = ekin(i) + vlhxc0(istmp) + vnldi_noncl(i,is) - eko_l(ib,ik)

            fdexp = dexp( -p(i) * wdi * dtim)

            zaj_l(i,ib,k1,1) = (fdexp - 1)*devr/wdi + evr
            zaj_l(i,ib,k1,2) = (fdexp - 1)*devi/wdi + evi
          End do
       end do
    end if

#endif

  end subroutine modified_steepest_desc_noncl
! ================================================================== 11.0

  subroutine steepest_descent(precon,ik,ibo,dtim,ekin,VlocalW,p)
    integer      , intent(in)                  :: precon,ik,ibo
    real(kind=DP), intent(in)                  :: dtim
    real(kind=DP), intent(in), dimension(kg1)  :: ekin
    real(kind=DP), intent(in), dimension(nfft) :: VlocalW
    real(kind=DP)            , dimension(kg1)  :: p

    integer       :: i, i1, ib
    real(kind=DP) :: evr,devr,denom, evi,e1, devi

    ib = map_z(ibo)                            ! MPI
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    call m_ES_decide_precon_factor(precon,ik,ibo,ekin,p)  ! -> p(1:iba(ik))

#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
    if(kimg == 1) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          evr   = zaj_l(i,ib,ik,1)
          devr  = (ekin(i)-eko_l(ib,ik))*evr + VlocalW(i1)*denom + vnlph_l(i,ib,1)
          zaj_l(i,ib,ik,1) = evr - p(i)*dtim*devr
       end do
    else if(kimg == 2) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          evr   = zaj_l(i,ib,ik,1);    evi   = zaj_l(i,ib,ik,2)
          e1    = ekin(i) - eko_l(ib,ik)
          devr  = e1*evr+VlocalW(2*i1-1)*denom+vnlph_l(i,ib,1)
          devi  = e1*evi+VlocalW(2*i1  )*denom+vnlph_l(i,ib,2)
          zaj_l(i,ib,ik,1) = evr - p(i)*dtim*devr
          zaj_l(i,ib,ik,2) = evi - p(i)*dtim*devi
       end do
    end if
  end subroutine steepest_descent

! ================================== added by K. Tagami ======================= 11.0
  subroutine steepest_descent_noncl( precon, ik, ibo, dtim, ekin, VlocalW_noncl, &
       &                             vnlph_noncl, p )
    integer      , intent(in)                  :: precon,ik,ibo
    real(kind=DP), intent(in)                  :: dtim
    real(kind=DP), intent(in), dimension(kg1)  :: ekin
    real(kind=DP), intent(in), dimension(nfft,ndim_spinor) :: VlocalW_noncl
    real(kind=DP), intent(in), dimension(kg1,np_e,kimg,ndim_spinor) :: vnlph_noncl

    real(kind=DP)            , dimension(kg1)  :: p

    integer       :: i, i1, ib
    integer :: is, istmp, k1
    real(kind=DP) :: evr,devr,denom, evi,e1, devi

    ib = map_z(ibo)                            ! MPI
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    call m_ES_decide_precon_factor(precon,ik,ibo,ekin,p)  ! -> p(1:iba(ik))
#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) then
       do is = 1, ndim_spinor
          k1 = ik+is-1
          status_saved_phifftr(ib,k1) = OLD
       end do
    end if
#endif
    if(kimg == 1) then
       Do is=1, ndim_spinor
          k1 = ik +is -1
          istmp = ( is -1 )*ndim_spinor + is

          do i = 1, iba(ik)
             i1    = igf(nbase(i,ik))
             evr   = zaj_l(i,ib,k1,1)
             devr  = ( ekin(i)-eko_l(ib,ik))*evr + VlocalW_noncl(i1,is)*denom &
	&           + vnlph_noncl(i,ib,1,is)
             zaj_l(i,ib,k1,1) = evr - p(i)*dtim*devr
          End do
       end do
    else if(kimg == 2) then
       Do is=1, ndim_spinor
          k1 = ik +is -1
          istmp = ( is -1 )*ndim_spinor + is

          do i = 1, iba(ik)
             i1    = igf(nbase(i,ik))
             evr   = zaj_l(i,ib,k1,1);    evi   = zaj_l(i,ib,k1,2)
             e1    = ekin(i) - eko_l(ib,ik)
             devr  = e1*evr+VlocalW_noncl(2*i1-1,is)*denom+vnlph_noncl(i,ib,1,is)
             devi  = e1*evi+VlocalW_noncl(2*i1,  is)*denom+vnlph_noncl(i,ib,2,is)
             zaj_l(i,ib,k1,1) = evr - p(i)*dtim*devr
             zaj_l(i,ib,k1,2) = evi - p(i)*dtim*devi
          End do
       end do
    end if
  end subroutine steepest_descent_noncl
! ============================================================================ 11.0

  subroutine square_of_SD_direction(ik,ibo,dz)
    integer,       intent(in)       :: ik,ibo
    real(kind=DP), intent(out)      :: dz  ! dz = <wfsd|w|wfsd>
    integer                         :: i,ib

    dz = 0.d0
    if(modnrm == EXECUT) then
       call m_ES_sum_of_LocalPart(ik,ibo,bsdr_l,bsdi_l,dz)
    end if
    ib = map_z(ibo)                     ! MPI
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          dz = dz + wfsd_l(1,ib,ik,1)*wfsd_l(1,ib,ik,1)
          do i = 2, iba(ik)
             dz = dz + 2.d0*wfsd_l(i,ib,ik,1)*wfsd_l(i,ib,ik,1)
          end do
       else
          dz = dz + wfsd_l(1,ib,ik,1)**2 + wfsd_l(1,ib,ik,2)**2
          do i = 2, iba(ik)
             dz = dz + 2.d0*(wfsd_l(i,ib,ik,1)**2 + wfsd_l(i,ib,ik,2)**2)
          end do
       end if
    else
       if(kimg == 1) then
          do i = 1, iba(ik)
             dz = dz + wfsd_l(i,ib,ik,1)*wfsd_l(i,ib,ik,1)
          end do
       else
          do i = 1, iba(ik)
             dz = dz + wfsd_l(i,ib,ik,1)**2 + wfsd_l(i,ib,ik,2)**2
          end do
       end if
    end if
  end subroutine square_of_SD_direction

! ==================================== added by K. Tagami ================== 11.0
  subroutine square_of_SD_direction_noncl( ik,ibo,dz )
    integer,       intent(in)       :: ik,ibo
    real(kind=DP), intent(out)      :: dz  ! dz = <wfsd|w|wfsd>
    integer                         :: i,ib
    integer :: is, k1

    dz = 0.d0
    if(modnrm == EXECUT) then
       call m_ES_sum_of_LocalPart_noncl( ik, ibo, ik, ik+ndim_spinor-1, &
     &                                   bsdr_l, bsdi_l, dz )
    end if

    ib = map_z(ibo)                     ! MPI
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          Do is=1, ndim_spinor
            k1 = ik + is -1
            dz = dz + wfsd_l(1,ib,k1,1)*wfsd_l(1,ib,k1,1)
          End do
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do i = 2, iba(ik)
              dz = dz + 2.d0*wfsd_l(i,ib,k1,1)*wfsd_l(i,ib,k1,1)
            end do
          End do
       else
          Do is=1, ndim_spinor
            k1 = ik + is -1
            dz = dz + wfsd_l(1,ib,k1,1)**2 + wfsd_l(1,ib,k1,2)**2
          End do
          Do is=1, ndim_spinor
            do i = 2, iba(ik)
               k1 = ik + is -1
               dz = dz + 2.d0*(wfsd_l(i,ib,k1,1)**2 + wfsd_l(i,ib,k1,2)**2)
            end do
          End do
       end if
    else
       if(kimg == 1) then
          Do is=1, ndim_spinor
            do i = 1, iba(ik)
               k1 = ik + is -1
               dz = dz + wfsd_l(i,ib,k1,1)*wfsd_l(i,ib,k1,1)
            end do
          End do
       else
          Do is=1, ndim_spinor
            do i = 1, iba(ik)
               k1 = ik + is -1
               dz = dz + wfsd_l(i,ib,k1,1)**2 + wfsd_l(i,ib,k1,2)**2
            end do
          End do
       end if
    end if
  end subroutine square_of_SD_direction_noncl
! ======================================================================== 11.0

  subroutine square_of_SD_direction2(ik,ibo,dz)
    integer,       intent(in)       :: ik,ibo
    real(kind=DP), intent(out)      :: dz  ! dz = <wfsd|w|wfsd>
    integer                         :: i,ib

    ib = map_z(ibo)                     ! MPI
    dz = 0.d0
    if(modnrm == EXECUT) then
       call m_ES_sum_of_LocalPart2(ik,ibo,bsdr_l,bsdi_l,bsdr_np,bsdi_np,dz)
    end if
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          dz = dz + wfsd_l(1,ib,ik,1)*wfsd_np(1,ib,ik,1)
          do i = 2, iba(ik)
             dz = dz + 2.d0*wfsd_l(i,ib,ik,1)*wfsd_np(i,ib,ik,1)
          end do
       else
          dz = dz + wfsd_l(1,ib,ik,1)*wfsd_np(1,ib,ik,1)
          do i = 2, iba(ik)
             dz = dz + 2.d0*( wfsd_l(i,ib,ik,1)*wfsd_np(i,ib,ik,1) &
                  &         + wfsd_l(i,ib,ik,2)*wfsd_np(i,ib,ik,2))
          end do
       end if
    else
       if(kimg == 1) then
          do i = 1, iba(ik)
             dz = dz + wfsd_l(i,ib,ik,1)*wfsd_np(i,ib,ik,1)
          end do
       else
          do i = 1, iba(ik)
             dz = dz + wfsd_l(i,ib,ik,1)*wfsd_np(i,ib,ik,1) &
                  &  + wfsd_l(i,ib,ik,2)*wfsd_np(i,ib,ik,2)
          end do
       end if
    end if
  end subroutine square_of_SD_direction2

! =================================== added by K. Tagami =================== 11.0
  subroutine square_of_SD_direction2_noncl( ik,ibo,dz )
    integer,       intent(in)       :: ik,ibo
    real(kind=DP), intent(out)      :: dz  ! dz = <wfsd|w|wfsd>
    integer                         :: i,ib, is, k1

    ib = map_z(ibo)                     ! MPI
    dz = 0.d0
    if(modnrm == EXECUT) then
       call m_ES_sum_of_LocalPart2_noncl( ik, ibo, ik, ik+ndim_spinor-1, &
	&                                 bsdr_l, bsdi_l, bsdr_np, bsdi_np, dz )
    end if
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          Do is=1, ndim_spinor
            k1 = ik + is -1
            dz = dz + wfsd_l(1,ib,k1,1)*wfsd_np(1,ib,k1,1)
          End do
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do i = 2, iba(ik)
               dz = dz + 2.d0*wfsd_l(i,ib,k1,1)*wfsd_np(i,ib,k1,1)
            end do
          End do
       else
          Do is=1, ndim_spinor
            k1 = ik + is -1
            dz = dz + wfsd_l(1,ib,k1,1)*wfsd_np(1,ib,k1,1) &
                 &  + wfsd_l(1,ib,k1,2)*wfsd_np(1,ib,k1,2)
          End do
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do i = 2, iba(ik)
               dz = dz + 2.d0*( wfsd_l(i,ib,k1,1)*wfsd_np(i,ib,k1,1) &
                    &         + wfsd_l(i,ib,k1,2)*wfsd_np(i,ib,k1,2))
            end do
          End do
       end if
    else
       if(kimg == 1) then
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do i = 1, iba(ik)
               dz = dz + wfsd_l(i,ib,k1,1)*wfsd_np(i,ib,k1,1)
            end do
          End do
       else
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do i = 1, iba(ik)
               dz = dz + wfsd_l(i,ib,k1,1)*wfsd_np(i,ib,k1,1) &
                    &  + wfsd_l(i,ib,k1,2)*wfsd_np(i,ib,k1,2)
            end do
          End do
       end if
    end if
  end subroutine square_of_SD_direction2_noncl
! ========================================================================== 11.0
!fj$$#endif

  subroutine square_of_SD_direction3(ik,ibo,dz)
    integer,       intent(in)       :: ik,ibo
    real(kind=DP), intent(out)      :: dz  ! dz = <wfsd|w|wfsd>
    integer                         :: i,ib

    dz = 0.d0
    if(modnrm == EXECUT) then
       call m_ES_sum_of_LocalPart3(ik,ibo,bsdr_l,bsdi_l,bsdr_old,bsdi_old,dz)
    end if
    ib = map_z(ibo)                     ! MPI
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          dz = dz + wfsd_l(1,ib,ik,1)*wfsd_old(1,ib,ik,1)
          do i = 2, iba(ik)
             dz = dz + 2.d0*wfsd_l(i,ib,ik,1)*wfsd_old(i,ib,ik,1)
          end do
       else
          dz = dz + wfsd_l(1,ib,ik,1)*wfsd_old(1,ib,ik,1) + wfsd_l(1,ib,ik,2)*wfsd_old(1,ib,ik,2)
          do i = 2, iba(ik)
             dz = dz + 2.d0*(wfsd_l(i,ib,ik,1)*wfsd_old(i,ib,ik,1) + wfsd_l(i,ib,ik,2)*wfsd_old(i,ib,ik,2))
          end do
       end if
    else
       if(kimg == 1) then
          do i = 1, iba(ik)
             dz = dz + wfsd_l(i,ib,ik,1)*wfsd_old(i,ib,ik,1)
          end do
       else
          do i = 1, iba(ik)
             dz = dz + wfsd_l(i,ib,ik,1)*wfsd_old(i,ib,ik,1) + wfsd_l(i,ib,ik,2)*wfsd_old(i,ib,ik,2)
          end do
       end if
    end if
  end subroutine square_of_SD_direction3

! =================================== added by K. Tagami =================== 11.0
  subroutine square_of_SD_direction3_noncl( ik,ibo,dz )
    integer,       intent(in)       :: ik,ibo
    real(kind=DP), intent(out)      :: dz  ! dz = <wfsd|w|wfsd>
    integer                         :: i,ib, is, k1

    dz = 0.d0
    if (modnrm == EXECUT) then
       call m_ES_sum_of_LocalPart3_noncl( ik, ibo, ik, ik+ndim_spinor-1, &
	&                                 bsdr_l, bsdi_l, bsdr_old, bsdi_old, dz )
    end if
    ib = map_z(ibo)                     ! MPI

    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          Do is=1, ndim_spinor
             k1 = ik + is -1
             dz = dz + wfsd_l(1,ib,k1,1) *wfsd_old(1,ib,k1,1)
          End do
          Do is=1, ndim_spinor
             k1 = ik + is -1
             do i = 2, iba(ik)
                dz = dz + 2.d0*wfsd_l(i,ib,k1,1)*wfsd_old(i,ib,k1,1)
             end do
          End do
       else
          Do is=1, ndim_spinor
             k1 = ik + is -1
             dz = dz + wfsd_l(1,ib,k1,1)*wfsd_old(1,ib,k1,1) &
                  &  + wfsd_l(1,ib,k1,2)*wfsd_old(1,ib,k1,2)
          End do
          Do is=1, ndim_spinor
             k1 = ik + is -1
             do i = 2, iba(ik)
                dz = dz + 2.d0*( wfsd_l(i,ib,k1,1)*wfsd_old(i,ib,k1,1) &
                     &         + wfsd_l(i,ib,k1,2)*wfsd_old(i,ib,k1,2))
             end do
          End do
       end if
    else
       if(kimg == 1) then
          Do is=1, ndim_spinor
             k1 = ik + is -1
             do i = 1, iba(ik)
                dz = dz + wfsd_l(i,ib,k1,1)*wfsd_old(i,ib,k1,1)
             end do
          End do
       else
          Do is=1, ndim_spinor
             k1 = ik + is -1
             do i = 1, iba(ik)
                dz = dz + wfsd_l(i,ib,k1,1)*wfsd_old(i,ib,k1,1) &
                     &  + wfsd_l(i,ib,k1,2)*wfsd_old(i,ib,k1,2)
             end do
          End do
       end if
    end if
  end subroutine square_of_SD_direction3_noncl
! =========================================================================== 11.0
  subroutine SD_direction(precon,ik,ibo,ekin,VlocalW,p)
    integer      , intent(in)                  :: precon,ik,ibo
    real(kind=DP), intent(in), dimension(kg1)  :: ekin
    real(kind=DP), intent(in), dimension(nfft) :: VlocalW
    real(kind=DP)            , dimension(kg1)  :: p

    integer       :: i, i1, ib
    real(kind=DP) :: devr,denom, e1, devi

    ib = map_z(ibo)                                  ! MPI
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    call m_ES_decide_precon_factor(precon,ik,ibo,ekin,p)  ! -> p(1:iba(ik))

    if(kimg == 1) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          devr  = (ekin(i)-eko_l(ib,ik))*zaj_l(i,ib,ik,1)&
               & + VlocalW(i1)*denom + vnlph_l(i,ib,1)
          wfsd_l(i,ib,ik,1) = - p(i)*devr
       end do
    else if(kimg == 2) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          e1    = ekin(i) - eko_l(ib,ik)
          devr  = e1*zaj_l(i,ib,ik,1) + VlocalW(2*i1-1)*denom+vnlph_l(i,ib,1)
          devi  = e1*zaj_l(i,ib,ik,2) + VlocalW(2*i1  )*denom+vnlph_l(i,ib,2)
          wfsd_l(i,ib,ik,1) = - p(i)*devr
          wfsd_l(i,ib,ik,2) = - p(i)*devi
       end do
    end if
  end subroutine SD_direction

! =================================== added by K. Tagami ================= 11.0
  subroutine SD_direction_noncl( precon, ik, ibo, ekin, VlocalW_noncl, &
       &                         vnlph_noncl, p )
    integer      , intent(in)                  :: precon,ik,ibo
    real(kind=DP), intent(in), dimension(kg1)  :: ekin
    real(kind=DP), intent(in), dimension(nfft,ndim_spinor) :: VlocalW_noncl
    real(kind=DP), intent(in), dimension(kg1,np_e,kimg,ndim_spinor) :: vnlph_noncl

    real(kind=DP)            , dimension(kg1)  :: p

    integer       :: i, i1, ib
    integer :: is, k1
    real(kind=DP) :: devr,denom, e1, devi

    ib = map_z(ibo)                                  ! MPI
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    call m_ES_decide_precon_factor(precon,ik,ibo,ekin,p)  ! -> p(1:iba(ik))

    if(kimg == 1) then
       Do is=1, ndim_spinor
         k1 = ik + is -1
         do i = 1, iba(ik)
            i1    = igf(nbase(i,ik))
            devr  = (ekin(i)-eko_l(ib,ik))*zaj_l(i,ib,k1,1)&
               &     + VlocalW_noncl(i1,is)*denom + vnlph_noncl(i,ib,1,is)
            wfsd_l(i,ib,k1,1) = - p(i)*devr
         end do
       End do
    else if(kimg == 2) then
       Do is=1, ndim_spinor
         k1 = ik + is -1
         do i = 1, iba(ik)
            i1    = igf(nbase(i,ik))
            e1    = ekin(i) - eko_l(ib,ik)
            devr  = e1*zaj_l(i,ib,k1,1) + VlocalW_noncl(2*i1-1,is)*denom &
	&           +vnlph_noncl(i,ib,1,is)
            devi  = e1*zaj_l(i,ib,k1,2) + VlocalW_noncl(2*i1,  is)*denom &
	&           +vnlph_noncl(i,ib,2,is)
            wfsd_l(i,ib,k1,1) = - p(i)*devr
            wfsd_l(i,ib,k1,2) = - p(i)*devi
         end do
       End do
    end if
  end subroutine SD_direction_noncl
! ===================================================================== 11.0

  subroutine Vnonlocal_Diagonal_part(ispin,ik,iksnl,ibo,vnldi)
    integer, intent(in)                        :: ispin, ik, iksnl,ibo
    real(kind=DP), intent(out), dimension(kg1) :: vnldi

    integer :: it,mdvdb,ib

!!$    integer :: id_sname = -1
!!$    call tstatc0_begin('Vnonlocal_Diagonal_part ', id_sname)

    ib = map_z(ibo)                ! MPI

    vnldi = 0.d0

    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) then
          call Vnonlocal_D_norm_conserve_case
       else if(mdvdb == EXECUT) then
          call Vnonlocal_D_vanderbilt_case
       end if
    end do

!!$    call tstatc0_end(id_sname)
  contains

    subroutine Vnonlocal_D_vanderbilt_case
      integer       :: ia, p1,p2,lmtt1,il1,lmtt2,il2,i
      real(kind=DP) :: ph,fac, dion_eq

      do p1 = 1, ilmt(it)
         lmtt1 = lmtt(p1,it); il1 = ltp(p1,it)
         do p2 = p1, ilmt(it)
            lmtt2 = lmtt(p2,it); il2 = ltp(p2,it)
            if( p1 /= p2) then
               ph = 2.d0*real(zi**(il2-il1))
            else
               ph = 1.d0
            endif
            if(mod(il1+il2,2) == 1) cycle
            dion_eq = dion(p1,p2,it)-eko_l(ib,ik)*q(p1,p2,it)
            fac = 0.d0
            do ia = 1, natm
               if(ityp(ia) /= it) cycle
!!$               fac = fac + ph*iwei(ia) * (dion_eq+vlhxcQ(p1,p2,ia,ispin))
               if(ipaw(it)==0) then
                   fac = fac + ph*iwei(ia) * (dion_eq+vlhxcQ(p1,p2,ia,ispin))
               else
! ======================================== modified by K. Tagami ============= 11.0
!                   fac = ph*iwei(ia) * &
!                        & (dion_paw(p1,p2,ispin,ia)-eko_l(ib,ik)*q(p1,p2,it)+vlhxcQ(p1,p2,ia,ispin))
!
                   fac = fac + ph*iwei(ia) &
        &                   * (dion_paw(p1,p2,ispin,ia)-eko_l(ib,ik)*q(p1,p2,it) &
	&                     +vlhxcQ(p1,p2,ia,ispin) )
! ============================================================================ 11.0
               end if
            end do

            do i = 1, iba(ik)
               vnldi(i) = vnldi(i)+fac*snl(i,lmtt1,iksnl)*snl(i,lmtt2,iksnl)
            end do
         end do
      end do

!!$      do p1 = 1, ilmt(it)
!!$         lmtt1 = lmtt(p1,it); il1 = ltp(p1,it)
!!$         do p2 = p1, ilmt(it)
!!$            lmtt2 = lmtt(p2,it); il2 = ltp(p2,it)
!!$            if( p1 /= p2) then
!!$               ph = 2.d0*real(zi**(il2-il1))
!!$            else
!!$               ph = 1.d0
!!$            endif
!!$            if(mod(il1+il2,2) == 1) cycle
!!$            dion_eq = dion(p1,p2,it)-eko_l(ib,ik)*q(p1,p2,it)
!!$            do ia = 1, natm
!!$               if(ityp(ia) /= it) cycle
!!$!!$               fac = ph*iwei(ia) * &
!!$!!$                    & (dion(p1,p2,it)-eko_l(ib,ik)*q(p1,p2,it)+vlhxcQ(p1,p2,ia,ispin))
!!$               fac = ph*iwei(ia) * (dion_eq+vlhxcQ(p1,p2,ia,ispin))
!!$               do i = 1, iba(ik)
!!$                  vnldi(i) = vnldi(i)+fac*snl(i,lmtt1,iksnl)*snl(i,lmtt2,iksnl)
!!$               end do
!!$            end do
!!$         end do
!!$      end do
    end subroutine Vnonlocal_D_vanderbilt_case

    subroutine Vnonlocal_D_norm_conserve_case
      integer       :: ia, lmt1,lmt2,lmtt1,il1,im1,il2,im2,i
      real(kind=DP) :: ph,fac

      ph = 0.d0
      do ia = 1, natm
         if(ityp(ia) /= it) cycle
         ph = ph + iwei(ia)
      end do
      do lmt1 = 1, ilmt(it)
         lmtt1 = lmtt(lmt1,it); il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
         do lmt2 = lmt1, ilmt(it)
            il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
            if(il1 /= il2 .or. im1 /= im2) cycle
            if(mod(il1+il2,2) == 1) cycle

! ====================================== modified by K. Tagami ============= 11.0
!!            fac = ph * dion(lmt1,lmt2,it)
!
            fac = 0.d0
            Do ia=1, natm
              if(ityp(ia) /= it) cycle
              if(ipaw(it)==0)then
                 fac = fac + iwei(ia) * dion(lmt1,lmt2,it)
              else
                 fac = fac + iwei(ia) * dion_paw(lmt1,lmt2,ispin,ia)
              endif
            End do
! ========================================================================== 11.0

            do i = 1, iba(ik)
               vnldi(i)  = vnldi(i) + fac * snl(i,lmtt1,iksnl)**2
            end do
         end do
      end do
    end subroutine Vnonlocal_D_norm_conserve_case

  end subroutine Vnonlocal_Diagonal_part

! ====================================== added by K. Tagami ================ 11.0
  subroutine Vnonlocal_Diagonal_part_noncl(ispin,ik,iksnl,ibo,vnldi)
    integer, intent(in)                        :: ispin, ik, iksnl,ibo

#ifdef USE_COMPLEX_VNLDI
    complex(kind=CMPLDP), intent(out), dimension(kg1) :: vnldi
#else
    real(kind=DP), intent(out), dimension(kg1) :: vnldi
#endif

    integer :: it,mdvdb,ib

!!$    integer :: id_sname = -1
!!$    call tstatc0_begin('Vnonlocal_Diagonal_part ', id_sname)

    ib = map_z(ibo)                ! MPI

!    vnldi = 0.d0

    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) then
          call Vnonlocal_D_norm_consv_noncl
       else if(mdvdb == EXECUT) then
         call Vnonlocal_D_vanderbilt_noncl
       end if
    end do

!!$    call tstatc0_end(id_sname)
  contains

    subroutine Vnonlocal_D_vanderbilt_noncl
      integer       :: ia, p1,p2,lmtt1,il1,lmtt2,il2,i
      integer :: im1, im2
      complex(kind=CMPLDP) :: ph, fac

      do p1 = 1, ilmt(it)
         lmtt1 = lmtt(p1,it); il1 = ltp(p1,it);  im1 = mtp(p1,it)

         do p2 = 1, ilmt(it)
            lmtt2 = lmtt(p2,it); il2 = ltp(p2,it);  im2 = mtp(p2,it)


! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
            if ( il1 /= il2 ) cycle
            if ( SpinOrbit_mode == Neglected .and. sw_hubbard == OFF ) then
               if ( im1 /= im2 ) cycle
            endif
#endif
! ---------------------------------------------------- 11.0S

            if( p1 /= p2 ) then
               ph = zi**(il2-il1)
           else
               ph = 1.d0
            endif

!            if(mod(il1+il2,2) == 1) cycle

            fac = 0.d0

            do ia = 1, natm
               if(ityp(ia) /= it) cycle
               fac = fac + ph*iwei(ia)* ( dion_scr_noncl( p1,p2,ispin,ia ) &
        &                                -eko_l(ib,ik) *q_noncl( p1, p2, ispin, it ) )
            end do

            do i = 1, iba(ik)
               vnldi(i) = vnldi(i)+fac*snl(i,lmtt1,iksnl)*snl(i,lmtt2,iksnl)
            end do
         end do
      end do

    end subroutine Vnonlocal_D_vanderbilt_noncl

    subroutine Vnonlocal_D_norm_consv_noncl
      integer       :: ia, p1,p2,lmtt1,il1,lmtt2,il2,i
      integer :: im1, im2
      complex(kind=CMPLDP) :: ph, fac

      do p1 = 1, ilmt(it)
         lmtt1 = lmtt(p1,it); il1 = ltp(p1,it);  im1 = mtp(p1,it)

         do p2 = 1, ilmt(it)
            lmtt2 = lmtt(p2,it); il2 = ltp(p2,it);  im2 = mtp(p2,it)

! ---------------------------------------------------- 11.0S
            if ( il1 /= il2 ) cycle
            if ( SpinOrbit_mode == Neglected .and. sw_hubbard == OFF ) then
               if ( im1 /= im2 ) cycle
            endif
! ---------------------------------------------------- 11.0S

            if( p1 /= p2 ) then
               ph = zi**(il2-il1)
            else
               ph = 1.d0
            endif

!            if(mod(il1+il2,2) == 1) cycle

            fac = 0.d0

            do ia = 1, natm
               if(ityp(ia) /= it) cycle
               fac = fac + ph*iwei(ia)* dion_scr_noncl( p1,p2,ispin,ia )

            end do

            do i = 1, iba(ik)
               vnldi(i) = vnldi(i)+fac*snl(i,lmtt1,iksnl)*snl(i,lmtt2,iksnl)
            end do
         end do
      end do

    end subroutine Vnonlocal_D_norm_consv_noncl

  end subroutine Vnonlocal_Diagonal_part_noncl
! ==================================================================== 11.0


  subroutine m_ESsd_reset_dzajn2
    dzajn2 = 0.d0
  end subroutine m_ESsd_reset_dzajn2

  subroutine m_ESsd_copy_zaj_to_zaj_old
    integer :: ik, ir
    do ir = 1, kimg
       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle                       ! MPI
          zaj_old(:,:,ik,ir) = zaj_l(:,:,ik,ir)
       end do
    end do
  end subroutine m_ESsd_copy_zaj_to_zaj_old

  subroutine m_ESsd_copy_zaj_old_to_zaj(ik,ibo)
    integer, intent(in)                           :: ik, ibo

    integer    :: ir, ib

    ib = map_z(ibo)
     do ir = 1, kimg
       zaj_l(:,ib,ik,ir) = zaj_old(:,ib,ik,ir)
    end do
#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
  end subroutine m_ESsd_copy_zaj_old_to_zaj

  subroutine m_ESsd_copy_phi_to_zaj_old(ik,ibo,phi)
    integer, intent(in)                           :: ik, ibo
    real(kind=DP),intent(in),dimension(kg1,kimg)  :: phi

    integer    :: ir, ib

    ib = map_z(ibo)
     do ir = 1, kimg
       zaj_old(:,ib,ik,ir) = phi(:,ir)
    end do
  end subroutine m_ESsd_copy_phi_to_zaj_old
!!$!BRANCH_P 3D_Parallel
!!$  subroutine m_ESsd_copy_phi_to_zaj_old_3D(ik,ibo,phi)
!!$    integer, intent(in)                           :: ik, ibo
!!$    real(kind=DP),intent(in),dimension(maxval(np_g1k),kimg)  :: phi
!!$
!!$    integer    :: ir, ib
!!$
!!$     do ir = 1, kimg
!!$       zaj_old(:,ib,ik,ir) = phi(:,ir)
!!$    end do
!!$  end subroutine m_ESsd_copy_phi_to_zaj_old_3D
!!$!BRANCH_P_END 3D_Parallel

  subroutine m_ESsd_diff_WFs_to_zaj_old(dt)
    real(kind=DP), intent(in) :: dt
    integer                   :: ik, ir
    real(kind=DP), parameter  :: Delta = 1.d-10
    real(kind=DP)             :: rdt

    if(dt < Delta ) then
       if(ipri >=1 ) write(nfout,'(" !! dt is smaller than ",d20.8)') Delta
       rdt = 0.d0
    else
       rdt = 1.d0/dt
    end if

    do ir = 1, kimg
       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle                ! MPI
          zaj_old(:,:,ik,ir) = rdt * (zaj_l(:,:,ik,ir) - zaj_old(:,:,ik,ir))
       end do
    end do
  end subroutine m_ESsd_diff_WFs_to_zaj_old

  subroutine WF_conjugate_gradient(ik,ibo,dtim)
! \Psi_{k\mu}^{m+1} = \Psi_{k\mu}^{m} + \Delta t_{opt}^{m} d^{m}
!   d^{m} = g^{m} + \beta_CG d^{m-1}
!   g^{m} = - \Phi_{k\mu}^{m}
!   d^{m-1} = (\Psi_{k\mu}^{m} - \Psi_{k\mu}^{m-1})\frac{1}{\Delta t_{opt}^{m-1}}
!
    integer      , intent(in)                  :: ik,ibo
    real(kind=DP), intent(in)                  :: dtim

    integer       :: i,ib
    real(kind=DP) :: evr,evi

    ib = map_z(ibo)                    ! MPI
#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
    if(kimg == 1) then
       do i = 1, iba(ik)
          evr   = zaj_l(i,ib,ik,1)
          zaj_l(i,ib,ik,1) = evr + dtim*wfsd_l(i,ib,ik,1)
       end do
    else if(kimg == 2) then
       do i = 1, iba(ik)
          evr   = zaj_l(i,ib,ik,1);  evi   = zaj_l(i,ib,ik,kimg)
          zaj_l(i,ib,ik,1) = evr + dtim*wfsd_l(i,ib,ik,1)
          zaj_l(i,ib,ik,2) = evi + dtim*wfsd_l(i,ib,ik,2)
       end do
    end if
  end subroutine WF_conjugate_gradient

  subroutine WF_conjugate_gradient0 &
       &(precon,ik,ibo,dtim,ekin,VlocalW,p)
! \Psi_{k\mu}^{m+1} = \Psi_{k\mu}^{m} + \Delta t_{opt}^{m} d^{m}
!   d^{m} = g^{m} + \beta_CG d^{m-1}
!   g^{m} = - \Phi_{k\mu}^{m}
!   d^{m-1} = (\Psi_{k\mu}^{m} - \Psi_{k\mu}^{m-1})\frac{1}{\Delta t_{opt}^{m-1}}
!
    integer      , intent(in)                  :: precon,ik,ibo
    real(kind=DP), intent(in)                  :: dtim
    real(kind=DP), intent(in), dimension(kg1)  :: ekin
    real(kind=DP), intent(in), dimension(nfft) :: VlocalW
    real(kind=DP)            , dimension(kg1)  :: p

    integer       :: i, i1, ib
    real(kind=DP) :: evr,devr,denom, evi,e1, devi

    ib = map_z(ibo)
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    call m_ES_decide_precon_factor(precon,ik,ibo,ekin,p)  ! ->p(1:iba(ik))

#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
    if(kimg == 1) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          evr   = zaj_l(i,ib,ik,1)
          devr  = (ekin(i)-eko_l(ib,ik))*evr&
               & + VlocalW(i1)*denom + vnlph_l(i,ib,1)
          zaj_l(i,ib,ik,1) = evr + dtim*(-p(i)*devr+betacg*zaj_old(i,ib,ik,1))
          zaj_old(i,ib,ik,1) = evr
       end do
    else if(kimg == 2) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          evr   = zaj_l(i,ib,ik,1)
          evi   = zaj_l(i,ib,ik,kimg)
          e1    = ekin(i) - eko_l(ib,ik)
          devr  = e1*evr+VlocalW(2*i1-1)*denom+vnlph_l(i,ib,1)
          devi  = e1*evi+VlocalW(2*i1  )*denom+vnlph_l(i,ib,2)
          zaj_l(i,ib,ik,1) = evr +dtim*(-p(i)*devr+betacg*zaj_old(i,ib,ik,1))
          zaj_l(i,ib,ik,2) = evi +dtim*(-p(i)*devi+betacg*zaj_old(i,ib,ik,2))
          zaj_old(i,ib,ik,1) = evr; zaj_old(i,ib,ik,2) = evi
       end do
    end if
  end subroutine WF_conjugate_gradient0

  subroutine make_CG_direction(ik)
    integer, intent(in) :: ik

    real(kind=DP), parameter             :: Delta = 1.d-20
    integer :: i, ib
    integer :: id_sname = -1
    call tstatc0_begin('make_CG_direction', id_sname)

    if(betacg > Delta) then
       if(kimg == 1) then
          do ib = 1, np_e
             do i = 1, iba(ik)
                wfsd_l(i,ib,ik,1) = wfsd_l(i,ib,ik,1) + betacg*wfsd_old(i,ib,ik,1)
             end do
          end do
       else
          do ib = 1, np_e
             do i = 1, iba(ik)
                wfsd_l(i,ib,ik,1) = wfsd_l(i,ib,ik,1) + betacg*wfsd_old(i,ib,ik,1)
                wfsd_l(i,ib,ik,2) = wfsd_l(i,ib,ik,2) + betacg*wfsd_old(i,ib,ik,2)
             end do
          end do
       end if
    end if
    call tstatc0_end(id_sname)
  end subroutine make_CG_direction

  subroutine orthogonalize_SD_drctns(ik,to)
    integer, intent(in) :: ik,to

    integer :: id_sname = -1
    call tstatc0_begin('orthogonalize_SD_drctns ', id_sname)

!!$    if(modnrm == EXECUT) call m_ES_betar_dot_Psi_4_each_k(wfsd_l,ista_k,iend_k,ik,bsdr_l,bsdi_l)
    if(modnrm == EXECUT) call m_ES_betar_dot_Psi_4_each_k(nfout,wfsd_l,ik,ik,ik,bsdr_l,bsdi_l)
    !                                                          ->bsd(ri)_l
    call m_ES_orthogonalize_SD_to_WFs(ik,to,wfsd_l,bsdr_l,bsdi_l) ! ->(wfsd_l,bsd(ri)_l)

!!$    call orthogonalize_SD(ik,wfsd_l,bsdr_l,bsdi_l)           !-(m_E.S.) ->(wfsd_l)
    call tstatc0_end(id_sname)
  end subroutine orthogonalize_SD_drctns

! =============================== added by K. Tagami =================== 11.0
  subroutine orthogonalize_SD_drctns_noncl( ik,to )
    integer, intent(in) :: ik,to

    integer :: is
    integer :: id_sname = -1

    call tstatc0_begin('orthogonalize_SD_drctns_noncl ', id_sname)

    if (modnrm == EXECUT) then
       Do is=1, ndim_spinor
          call m_ES_betar_dot_Psi_4_each_k(nfout, wfsd_l, ik, ik+ndim_spinor-1, &
	&                                   ik +is -1, bsdr_l, bsdi_l )
                                               !           ->bsd(ri)_l
       End do
    endif

    call m_ES_orthogonl_SD_to_WFs_noncl( ik, to, ik, ik+ndim_spinor-1, &
	&                                wfsd_l, bsdr_l, bsdi_l)
                                             ! ->(wfsd_l,bsd(ri)_l)

    call tstatc0_end(id_sname)

  end subroutine orthogonalize_SD_drctns_noncl
! ========================================================================= 11.0

  subroutine Precon_dot_SD(ik,ekin,p)
    integer,      intent(in)                 :: ik
    real(kind=DP),intent(in),dimension(kg1)  :: ekin
    real(kind=DP),           dimension(kg1)  :: p

    integer :: ib, ri, i

    do ri = 1, kimg
       do ib = ista_e, iend_e, istep_e
          do i = 1, iba(ik)
             wfsd_np(i,map_z(ib),ik,ri) = wfsd_l(i,map_z(ib),ik,ri)
          end do
       end do
    end do

    do ib = ista_e, iend_e, istep_e   ! MPI
       call decide_precon_factor_wfsd(ik,ib,ekin,p)
       if(kimg == 1) then
          do i = 1, iba(ik)
             wfsd_l(i,map_z(ib),ik,1) = p(i)*wfsd_l(i,map_z(ib),ik,1)
          end do
       else if(kimg == 2) then
          do i = 1, iba(ik)
             wfsd_l(i,map_z(ib),ik,1) = p(i)*wfsd_l(i,map_z(ib),ik,1)
             wfsd_l(i,map_z(ib),ik,2) = p(i)*wfsd_l(i,map_z(ib),ik,2)
          end do
       end if
    end do

  end subroutine Precon_dot_SD

! ======================================== added by K. Tagami =============== 11.0
  subroutine Precon_dot_SD_noncl( ik,ekin,p )
    integer,      intent(in)                 :: ik
    real(kind=DP),intent(in),dimension(kg1)  :: ekin
    real(kind=DP),           dimension(kg1)  :: p

    integer :: ib, ri, i
    integer :: is, k1

    do ri = 1, kimg
       Do is=1, ndim_spinor
         k1 = ik + is -1
         do ib = ista_e, iend_e, istep_e
            do i = 1, iba(ik)
               wfsd_np(i,map_z(ib),k1,ri) = wfsd_l(i,map_z(ib),k1,ri)
            end do
         end do
       End do
    end do

    do ib = ista_e, iend_e, istep_e   ! MPI
       call decide_precon_factor_wfsd( ik, ib, ekin, p )

       if (kimg == 1) then
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do i = 1, iba(ik)
               wfsd_l(i,map_z(ib),k1,1) = p(i)*wfsd_l(i,map_z(ib),k1,1)
            end do
          End do
       else if(kimg == 2) then
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do i = 1, iba(ik)
               wfsd_l(i,map_z(ib),k1,1) = p(i)*wfsd_l(i,map_z(ib),k1,1)
               wfsd_l(i,map_z(ib),k1,2) = p(i)*wfsd_l(i,map_z(ib),k1,2)
            end do
          End do
       end if
    end do

  end subroutine Precon_dot_SD_noncl
! ===================================================================== 11.0

  subroutine decide_precon_factor_wfsd(ik,ib,ekin,p)
    integer, intent(in)                         :: ik,ib
    real(kind=DP), intent(in),  dimension(kg1)  :: ekin
    real(kind=DP), intent(out), dimension(kg1)  :: p

    integer       :: i
    real(kind=DP) :: ektot, x, x1, x2, d_ektot

! ===================================== modified by K. Tagami ========== 11.0
!    call kinetic_energy_wfsd(ik,ib,ekin,ektot)   ! -(m_ES_WF_by_SDorCG)
!
    if ( noncol ) then
       call kinetic_energy_wfsd_noncl(ik,ib,ekin,ektot)
    else
       call kinetic_energy_wfsd(ik,ib,ekin,ektot)   ! -(m_ES_WF_by_SDorCG)
    endif
! ====================================================================== 11.0

    d_ektot = 1.d0/ektot
    p = 0.d0
    do i = 1, iba(ik)
       x = ekin(i)*d_ektot
       x1 = 27 + ( 18 + (12 + 8*x) *x) *x
       x2 = 16*(x*x)*(x*x)
       p(i)  = x1/(x1 + x2 )
    end do
  end subroutine decide_precon_factor_wfsd

  subroutine kinetic_energy_wfsd(ik,ib,dekin,ektot)
    integer, intent(in) :: ik, ib
    real(kind=DP), intent(in), dimension(kg1)  :: dekin
    real(kind=DP), intent(out)                 :: ektot
    integer  :: i, ri
    ektot = 0.d0

    do ri = 1, kimg
       do i = 1, iba(ik)
          ektot = ektot + dekin(i)*wfsd_l(i,map_z(ib),ik,ri)**2   ! MPI
       end do
    end do

    if(k_symmetry(ik) == GAMMA) ektot = ektot*2.d0

  end subroutine kinetic_energy_wfsd

! ====================================== added by K. Tagami ================ 11.0
  subroutine kinetic_energy_wfsd_noncl( ik,ib,dekin,ektot )
    integer, intent(in) :: ik, ib
    real(kind=DP), intent(in), dimension(kg1)  :: dekin
    real(kind=DP), intent(out)                 :: ektot
    integer  :: i, ri
    integer :: is, k1

    ektot = 0.d0

    do ri = 1, kimg
       Do is=1, ndim_spinor
         k1 = ik + is -1
         do i = 1, iba(ik)
            ektot = ektot + dekin(i)*wfsd_l(i,map_z(ib),k1,ri)**2   ! MPI
         end do
       End do
    end do

    if(k_symmetry(ik) == GAMMA) ektot = ektot*2.d0

  end subroutine kinetic_energy_wfsd_noncl
! ========================================================================= 11.0


  subroutine cp_wfsd_to_wfsd_old(ik)
    integer, intent(in) :: ik
    wfsd_old(:,:,ik,:) = wfsd_l(:,:,ik,:)
    bsdr_old(:,:,ik) = bsdr_l(:,:,ik)
    bsdi_old(:,:,ik) = bsdi_l(:,:,ik)
  end subroutine cp_wfsd_to_wfsd_old

  subroutine m_ESsd_dealloc
    if(allocated(zaj_old)) deallocate(zaj_old)
    if(allocated(dzajn2)) deallocate(dzajn2)


  end subroutine m_ESsd_dealloc

! =============
!   meta-gga
!
  subroutine m_ES_contrib_kindens_to_vnlph( is, ik, afft )
    use m_Crystal_Structure,  only : rltv
    use m_PlaneWaveBasisSet,   only : ngabc, kgp
    use m_Electronic_Structure,   only : vtau_l, m_ES_WF_in_Rspace_kt, &
         &                               m_ES_add_it_to_vnlph, &
         &                               m_ES_Vlocal_in_Rspace

    use m_FFT,                 only : m_FFT_Vlocal_W

    integer, intent(in) :: is, ik
    real(kind=DP), intent(in) :: afft(nfft)

    integer :: ib, in, ri, i1, ig
    real(kind=DP) :: denom
    real(kind=DP), allocatable :: G_vec(:,:), k_plus_G(:,:), vlength(:)
    real(kind=DP), allocatable :: bfft(:)
    real(kind=DP), allocatable :: zwk1(:,:,:,:), zwk2(:,:)

    allocate( vlength(kg1) )
    allocate( k_plus_G(kg1,3) );
    allocate( bfft(nfft) )

    call k_plus_G_vectors( ik, kgp, kg1, kv3, iba, nbase, vkxyz, &
         &                 ngabc, rltv, &
         &                 k_plus_G(1,1), k_plus_G(1,2), k_plus_G(1,3), vlength )

    denom = 1.d0 /product(fft_box_size_WF(1:3,1))

    do ib = 1, np_e
       allocate( zwk1(kg1,1,ik:ik,kimg ) );  zwk1 = 0.0d0
       allocate( zwk2(kg1,kimg) );  zwk2 = 0.0d0
#if 0
       Do in=1, 3
          Do ig=1, iba(ik)
             zwk1(ig,1,ik,2) = zaj_l(ig,ib,ik,1) *k_plus_G(ig,in)
             zwk1(ig,1,ik,1) =-zaj_l(ig,ib,ik,2) *k_plus_G(ig,in)
          End do
          call m_ES_WF_in_Rspace_kt( ik ,ik, ik, zwk1, bfft )
          call m_FFT_Vlocal_W( afft, bfft )  ! --> bfft  in R space
          call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)  ! G space

          do ig=1,iba(ik)
             i1 = kimg*igf(nbase(ig,ik)) -1
             zwk2(ig,2) = zwk2(ig,2) +bfft(i1) *k_plus_G(ig,in) *denom
             zwk2(ig,1) = zwk2(ig,1) -bfft(i1+1) *k_plus_G(ig,in) *denom
          enddo
       end Do
       zwk2 = -zwk2 /2.0d0       ! -> vnlph_l   zwk2( kg1, kimg )
#else
       Do in=1, 3
          do ri=1,kimg
             Do ig=1, iba(ik)
                zwk1(ig,1,ik,ri) = zaj_l(ig,ib,ik,ri) *k_plus_G(ig,in)
             End Do
          End do

          call m_ES_WF_in_Rspace_kt( ik ,ik, ik, zwk1, bfft )
          call m_FFT_Vlocal_W( afft, bfft )  ! --> bfft  in R space
          call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)  ! G space

          do ri=1,kimg
             do ig=1,iba(ik)
                i1 = kimg*igf(nbase(ig,ik)) + (ri - kimg)
                zwk2(ig,ri) = zwk2(ig,ri) +bfft(i1) *k_plus_G(ig,in) *denom
             enddo
          enddo
       End Do

       zwk2 = zwk2 /2.0d0       ! -> vnlph_l   zwk2( kg1, kimg )
!       zwk2 = zwk2 /4.0d0       ! -> vnlph_l   zwk2( kg1, kimg )

#endif
       call m_ES_add_it_to_vnlph( ik, ib, zwk2 )
       deallocate( zwk1 );   deallocate( zwk2 )
    end do
    deallocate( k_plus_G );  deallocate( vlength )
    deallocate( bfft )

  end subroutine m_ES_contrib_kindens_to_vnlph

  subroutine m_ES_kindens_to_vnlph_ib( is, ik, ib, afft )
    use m_Crystal_Structure,  only : rltv
    use m_PlaneWaveBasisSet,   only : ngabc, kgp
    use m_FFT,                 only : m_FFT_Vlocal_W
    use m_Electronic_Structure,   only : vtau_l, m_ES_WF_in_Rspace_kt, &
         &                               m_ES_add_it_to_vnlph, &
         &                               m_ES_Vlocal_in_Rspace

    integer, intent(in) :: is, ik, ib
    real(kind=DP), intent(in) :: afft(nfft)

    integer :: in, ri, i1, ig
    real(kind=DP) :: denom
    real(kind=DP), allocatable :: G_vec(:,:), k_plus_G(:,:), vlength(:)
    real(kind=DP), allocatable :: bfft(:)
    real(kind=DP), allocatable :: zwk1(:,:,:,:), zwk2(:,:)

    allocate( vlength(kg1) );   allocate( k_plus_G(kg1,3) );
    allocate( bfft(nfft) )

    call k_plus_G_vectors( ik, kgp, kg1, kv3, iba, nbase, vkxyz, &
         &                 ngabc, rltv, &
         &                 k_plus_G(1,1), k_plus_G(1,2), k_plus_G(1,3), vlength )

    denom = 1.d0 /product(fft_box_size_WF(1:3,1))

    allocate( zwk1(kg1,1,ik:ik,kimg ) );  zwk1 = 0.0d0
    allocate( zwk2(kg1,kimg) );  zwk2 = 0.0d0
    Do in=1, 3
       do ri=1,kimg
          Do ig=1, iba(ik)
             zwk1(ig,1,ik,ri) = zaj_l(ig,ib,ik,ri) *k_plus_G(ig,in)
          End Do
       End do
       call m_ES_WF_in_Rspace_kt( ik ,ik, ik, zwk1, bfft )
       call m_FFT_Vlocal_W( afft, bfft )  ! --> bfft  in R space
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)  ! G space

       do ri=1,kimg
          do ig=1,iba(ik)
             i1 = kimg*igf(nbase(ig,ik)) + (ri - kimg)
             zwk2(ig,ri) = zwk2(ig,ri) +bfft(i1) *k_plus_G(ig,in) *denom
          enddo
       enddo
    End Do
    zwk2 = zwk2 /2.0d0       ! -> vnlph_l   zwk2( kg1, kimg )

    if(kimg==1) then
       do ig=1,iba(ik)
          vnlph_l(ig,ib,1) = vnlph_l(ig,ib,1) + zwk2(ig,1)
       end do
    else
       do ig=1,iba(ik)
          vnlph_l(ig,ib,1) = vnlph_l(ig,ib,1) + zwk2(ig,1)
          vnlph_l(ig,ib,2) = vnlph_l(ig,ib,2) + zwk2(ig,2)
       end do
    end if

    deallocate( zwk1 );   deallocate( zwk2 )
    deallocate( k_plus_G );  deallocate( vlength )
    deallocate( bfft )

  end subroutine m_ES_kindens_to_vnlph_ib

  subroutine m_ES_kindens_to_vnlph_ib2( is, ik, ib, afft, vtau_phl )
    use m_Crystal_Structure,  only : rltv
    use m_PlaneWaveBasisSet,   only : ngabc, kgp
    use m_FFT,                 only : m_FFT_Vlocal_W
    use m_Electronic_Structure,   only : vtau_l, m_ES_WF_in_Rspace_kt, &
         &                               m_ES_add_it_to_vnlph, &
         &                               m_ES_Vlocal_in_Rspace

    integer, intent(in) :: is, ik, ib
    real(kind=DP), intent(in) :: afft(nfft)
    real(kind=DP), intent(out) :: vtau_phl(kg1,kimg)

    integer :: in, ri, i1, ig
    real(kind=DP) :: denom
    real(kind=DP), allocatable :: G_vec(:,:), k_plus_G(:,:), vlength(:)
    real(kind=DP), allocatable :: bfft(:)
    real(kind=DP), allocatable :: zwk1(:,:,:,:), zwk2(:,:)

    allocate( vlength(kg1) );   allocate( k_plus_G(kg1,3) );
    allocate( bfft(nfft) )

    call k_plus_G_vectors( ik, kgp, kg1, kv3, iba, nbase, vkxyz, &
         &                 ngabc, rltv, &
         &                 k_plus_G(1,1), k_plus_G(1,2), k_plus_G(1,3), vlength )

    denom = 1.d0 /product(fft_box_size_WF(1:3,1))

    allocate( zwk1(kg1,1,ik:ik,kimg ) );  zwk1 = 0.0d0
    allocate( zwk2(kg1,kimg) );  zwk2 = 0.0d0
    Do in=1, 3
       do ri=1,kimg
          Do ig=1, iba(ik)
             zwk1(ig,1,ik,ri) = zaj_l(ig,ib,ik,ri) *k_plus_G(ig,in)
          End Do
       End do
       call m_ES_WF_in_Rspace_kt( ik ,ik, ik, zwk1, bfft )
       call m_FFT_Vlocal_W( afft, bfft )  ! --> bfft  in R space
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)  ! G space

       do ri=1,kimg
          do ig=1,iba(ik)
             i1 = kimg*igf(nbase(ig,ik)) + (ri - kimg)
             zwk2(ig,ri) = zwk2(ig,ri) +bfft(i1) *k_plus_G(ig,in) *denom
          enddo
       enddo
    End Do
    zwk2 = zwk2 /2.0d0       ! -> vnlph_l   zwk2( kg1, kimg )

    if(kimg==1) then
       do ig=1,iba(ik)
          vtau_phl(ig,1) = zwk2(ig,1)
       end do
    else
       do ig=1,iba(ik)
          vtau_phl(ig,1) = zwk2(ig,1)
          vtau_phl(ig,2) = zwk2(ig,2)
       end do
    end if

    deallocate( zwk1 );   deallocate( zwk2 )
    deallocate( k_plus_G );  deallocate( vlength );  deallocate( bfft )

  end subroutine m_ES_kindens_to_vnlph_ib2


end module m_ES_WF_by_SDorCG

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  SUBROUINE: ChargeDensity_Construction, FermiEnergyLevel,
!             CD_Softpart_plus_Hardpart
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine ChargeDensity_Construction(ic)
! $Id: ChargeDensity_Construction.F90 633 2020-12-01 05:11:03Z jkoga $
  use m_Total_Energy,         only : m_TE_total_energy, ehartr
  use m_Charge_Density,       only : m_CD_convergence_check &
       &                           , m_CD_softpart, m_CD_hardpart &
       &                           , chgq_l &
       &                           , m_CD_hardpart_hsr
  use m_Electronic_Structure, only : metalic_system
  use m_ES_occup,             only : m_ESoc_fermi_parabolic, m_ESoc_fermi_tetrahedron &
       &                           , m_ESoc_fermi_ColdSmearing, m_ESoc_check_num_bands &
       &                           , m_ESoc_occup_fix &
       &                           , check_if_metalic, check_if_metalic_noncl
  use m_ES_IO,                only : m_ESIO_wd_EigenValues
  use m_Kpoints,              only : kv3
  use m_Files,                only : nfout
  use m_Crystal_Structure,    only : sw_bandgap_constraint, imag
  use m_Control_Parameters,   only : iprieigenvalue, projector_type, num_projectors &
       &                           , sw_hubbard, alpha_hubbard, icond, ekmode, occ_matrix_fix_period &
#ifdef ENABLE_ESM_PACK
       &                           , m_CtrlP_way_of_smearing,sw_esm, kimg, nspin
#else
       &                           , m_CtrlP_way_of_smearing
#endif
  use m_Const_Parameters,     only : PARABOLIC, MP, TETRAHEDRON, COLD, YES, OFF, ON &
       &                           , SPHERICAL_HARMONICS, ATOMIC_ORBITAL &
       &                           , INITIAL,CONTINUATION,FIXED_CHARGE,FIXED_CHARGE_CONTINUATION,CMPLDP
  use m_Orbital_Population,   only : m_OP_occ_mat_is_not_read

! ============================= added by K. Tagami =================== 5.0
  use m_Control_Parameters,  only : sw_eval_energy_before_charge, &
       &                            sw_update_charge_total, iprigap
! ==================================================================== 5.0

  use m_Parallelization,      only : ista_kngp,iend_kngp,MPI_CommGroup,mype

! =========================================== added by K. Tagami ========== 11.0
  use m_Control_Parameters,      only : noncol
  use m_Charge_Density,        only : m_CD_hardpart_hsr_noncl, &
       &                              m_CD_softpart_noncl, &
       &                              m_CD_hardpart_noncl
  use m_Total_Energy,          only : m_TE_total_energy_noncl
! ========================================================================= 11.0


  use m_PlaneWaveBasisSet,       only : kgp
  use m_FFT,                     only : fft_box_size_CD

  use m_IterationNumbers, only : iteration_electronic


! ============================= KT_add ================ 13.0E
  use m_Const_Parameters,       only : FERMI_Dirac
  use m_ES_Occup,               only : m_ESoc_fermi_Dirac
! ===================================================== 13.0E
  use m_Const_Parameters,       only : MP, FERMI_DIRAC, LOWEST_AT_EACH_KPT
  use m_ES_Occup,               only : m_ESoc_fermi_Dirac, m_ESoc_methfessel_paxton

! ============================= KT_add ================ 13.0U
  use m_CD_Mag_Moment,        only : m_CD_calc_ChgMagMom_in_sphere, &
       &                             m_CD_print_ChgMagmom_on_atom, &
       &                             sw_monitor_atomcharge
! ===================================================== 13.0U

! ======= KT_add ==== 13.0XX
  use m_Control_Parameters,     only : sw_calc_ekin_density, use_symm_ekin_density, &
       &                               use_asymm_ekin_density, ekin_density_is_active

  use m_KineticEnergy_Density,  only : m_KE_calc_symm_ekin_density, &
       &                               m_KE_calc_asymm_ekin_density, &
       &                               m_KE_cp_ekin_density_to_old
! =================== 13.0XX

! === KT_add === 2014/09/26
  use m_Crystal_Structure,  only : sw_fix_global_quantz_axis, sw_neglect_magmom
  use m_ES_Mag_Constraint,  only : m_ES_proj_magmom_G_quantz_axis, m_ES_set_magmom_zero
! ============== 2014/09/26

! === KT_add === 2014/08/26
  use m_Control_Parameters, only : sw_calc_orbital_moment, sw_use_add_proj, &
       &                          Orbital_decomp_mode
  use m_Charge_Density,    only : m_CD_hardpart_hsr_add, m_CD_hardpart_hsr_add_noncl
  use m_OP_Moment,  only :        m_OP_calc_OrbMagMom_in_sphere, &
       &                          m_OP_calc_OrbMagMom_method1, &
       &                          m_OP_calc_OrbMagMom_method2, &
       &                          m_OP_print_OrbMagMom_on_atom
! ============== 2014/08/26

! ==== Positron SCF === 2015/11/28
  use m_Control_Parameters,  only : sw_positron, positron_method
  use m_Const_Parameters,    only : positron_CONV
  use m_Positron_Wave_Functions, only : m_pWF_construct_pcharge, m_pWF_charge_rspace
! ===================== 2015/11/28
  use mpi

  implicit none
!  include 'mpif.h'

  integer, intent(in) :: ic
  logical             :: display_on, enough_bands
  complex(kind=CMPLDP),allocatable,dimension(:) :: vhar
  complex(kind=CMPLDP),allocatable, dimension(:,:) :: chgc
  integer :: ig,is,nfftcd,ierr, iflag
  integer :: nspin_m

#ifdef __TIMER_SUB__
  call timer_sta(701)
#endif

  if(ic == 0) display_on = .true.
  if(ic /= 0) display_on = .false.


  enough_bands = m_ESoc_check_num_bands()
  if(enough_bands) then
     call FermiEnergyLevel()            ! -(contained here)
     if ( iprigap > 1 ) then
        if ( noncol ) then
           call check_if_metalic_noncl( nfout, metalic_system )
        else
           call check_if_metalic( nfout, metalic_system )
        endif
     endif
  else
     if(iprieigenvalue >= 1) write(nfout,'(" the number of bands is not enough")')
     stop ' the number of bands is not enough'
  end if

! =================== added by K. Tagami ============ 5.0
  if ( sw_eval_energy_before_charge == ON ) then
! ================================= modified by K.Tagami ====== 11.0
!     call m_TE_total_energy(nfout,display_on,kv3)
!
     if ( noncol ) then
        call m_TE_total_energy_noncl(nfout,display_on,kv3)
     else
        call m_TE_total_energy(nfout,display_on,kv3)
     endif
! ============================================================= 11.0
  endif
! =================================================== 5.0

! ======================== modified by K. Tagami ======= 5.0
!  if(icond == INITIAL .or. icond == CONTINUATION) then
!     call CD_Softpart_plus_Hardpart()   ! -(contained here)
!     if(ic == 0) call m_CD_conversion_check(nfout)
!  else if ((icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION).and.ekmode==OFF) then
!     call m_CD_hardpart_hsr(nfout,kv3)  ! fsr_l, fsi_l -> hsr
!  end if
  if ( sw_update_charge_total == ON ) then
     if ( icond == INITIAL .or. icond == CONTINUATION ) then
! ======================== modifided by K. Tagami ========================= 11.0
!       call CD_Softpart_plus_Hardpart()   ! -(contained here)
!
        if ( noncol ) then
           call CD_Softpart_plus_Hardpart_noncl()   ! -(contained here)
        else
           call CD_Softpart_plus_Hardpart()   ! -(contained here)
        endif
! ========================================================================= 11.0

! === KT_add == 2014/09/26
        if ( noncol ) then
           if ( sw_fix_global_quantz_axis == ON ) then
              call m_ES_proj_magmom_G_quantz_axis
           endif
           if ( sw_neglect_magmom == ON ) then
              call m_ES_set_magmom_zero
           endif
        endif
! ============= 2014/09/26

        if ( ic == 0 ) call m_CD_convergence_check(nfout)
     else if ( ( icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION ) &
          &         .and. ekmode==OFF ) then
! ======================== modifided by K. Tagami ========================= 11.0
!!     call m_CD_hardpart_hsr(nfout,kv3)             ! fsr_l, fsi_l -> hsr
        if ( noncol ) then
           call m_CD_hardpart_hsr_noncl(nfout,kv3)
        else
           call m_CD_hardpart_hsr(nfout,kv3)             ! fsr_l, fsi_l -> hsr
        endif
! ========================================================================== 11.0
     end if
     if( icond == INITIAL .or. icond == CONTINUATION .or. &
          & ((icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION ) .and. &
          & m_OP_occ_mat_is_not_read())) then
        call Renewal_of_OccMat( .false., OFF, iteration_electronic<=occ_matrix_fix_period ) ! evaluated with new om, hsr
     end if
  endif
! ========================================================= 5.0


#ifdef ENABLE_ESM_PACK
  if ( noncol ) then
     nspin_m = 1
  else
     nspin_m = nspin
  endif
  if(sw_esm==ON)then
     nfftcd = fft_box_size_CD(1,0)*fft_box_size_CD(2,0)*fft_box_size_CD(3,0)
     allocate(vhar(nfftcd));vhar=(0.d0,0.d0)
!     allocate(chgc(iend_kngp-ista_kngp+1,nspin));chgc=(0.d0,0.d0)
     allocate(chgc(1:kgp,nspin_m));chgc=(0.d0,0.d0)
     if(kimg==1)then
        do ig=ista_kngp,iend_kngp
!           chgc(ig-ista_kngp+1,1:nspin) = dcmplx(chgq_l(ig,1,1:nspin),0.d0)
           chgc(ig,1:nspin_m) = dcmplx(chgq_l(ig,1,1:nspin_m),0.d0)
        enddo
     else
        do ig=ista_kngp,iend_kngp
!           chgc(ig-ista_kngp+1,1:nspin) = dcmplx(chgq_l(ig,1,1:nspin),chgq_l(ig,2,1:nspin))
           chgc(ig,1:nspin_m) = dcmplx(chgq_l(ig,1,1:nspin_m),chgq_l(ig,2,1:nspin_m))
        enddo
     endif
     call mpi_allreduce(mpi_in_place,chgc,kgp*nspin_m,mpi_double_complex,mpi_sum,MPI_CommGroup,ierr)
     call esm_hartree(chgc,ehartr,vhar)
     ehartr  = 0.5d0*ehartr  !Ry -> Ha
     deallocate(chgc)
     deallocate(vhar)
  endif
#endif

! ======= KT_add ===== 13.0XX
!  if ( sw_calc_ekin_density == ON .and. ekin_density_is_active ) then
  if ( sw_calc_ekin_density == ON ) then
     if ( icond == INITIAL .or. icond == CONTINUATION ) then
        call m_KE_cp_ekin_density_to_old
        if ( use_symm_ekin_density )  call m_KE_calc_symm_ekin_density
        if ( use_asymm_ekin_density ) call m_KE_calc_asymm_ekin_density
     endif
  endif
! ==================== 13.0XX

! ============================= KT_add ================ 13.0U
  if ( sw_monitor_atomcharge == ON ) then
     call m_CD_calc_ChgMagMom_in_sphere
  endif
! ===================================================== 13.0U

! === KT_add === 2014/08/26
  if ( noncol .and. sw_calc_orbital_moment == ON ) then
     call m_OP_calc_OrbMagMom_in_sphere
     call m_OP_print_OrbMagMom_on_atom(nfout)

     if ( Orbital_decomp_mode == 1 ) then
        call m_OP_calc_OrbMagMom_method1
#if 0
     else if ( Orbital_decomp_mode == 2 ) then
        call m_OP_calc_OrbMagMom_method2
#endif
     endif
  endif
! ============== 2014/08/26

  if ( sw_positron /= OFF ) then
     if ( positron_method /= Positron_CONV ) then
        call m_pWF_construct_pcharge
        call m_pWF_charge_rspace
     endif
  endif

  if ( sw_eval_energy_before_charge == OFF ) then
! ================================== modified by K. Tagami ================ 11.0
     if ( noncol ) then
        call m_TE_total_energy_noncl(nfout,display_on,kv3)
     else
        call m_TE_total_energy(nfout,display_on,kv3)
     endif
! ========================================================================== 11.0
  endif
! ======================================================== 5.0

  if(ic == 0) call m_ESIO_wd_EigenValues(nfout,iprieigenvalue,nooccupation=YES)

#ifdef __TIMER_SUB__
  call timer_end(701)
#endif
contains
  subroutine FermiEnergyLevel()
    integer :: way_of_smearing
#ifdef __TIMER_SUB__
  call timer_sta(702)
#endif
    way_of_smearing = m_CtrlP_way_of_smearing()
    if(way_of_smearing == PARABOLIC) then
       call m_ESoc_fermi_parabolic(nfout)
!!$  else if(way_of_smearing == MP) then
!!$     call fermi_mesfessel_paxton(nfout)
    else if(way_of_smearing == TETRAHEDRON) then
        call m_ESoc_fermi_tetrahedron(nfout)
    else if(way_of_smearing == COLD) then
        call m_ESoc_fermi_ColdSmearing(nfout)

! ================ KT_add ========================= 13.0E
    else if(way_of_smearing == FERMI_DIRAC) then
        call m_ESoc_fermi_Dirac(nfout)
! ================================================= 13.0E
    else if(way_of_smearing == MP) then
        call m_ESoc_methfessel_paxton(nfout)
    else if(way_of_smearing == LOWEST_AT_EACH_KPT) then
       call m_ESoc_occup_fix(nfout)
    end if
    if(sw_bandgap_constraint == ON) then
       call m_ESoc_occup_fix(nfout)
    end if
#ifdef __TIMER_SUB__
  call timer_end(702)
#endif
  end subroutine FermiEnergyLevel

  subroutine CD_Softpart_plus_Hardpart
! $Id: ChargeDensity_Construction.F90 633 2020-12-01 05:11:03Z jkoga $
!fj#ifdef __TIMER_SUB__
!fj  call timer_sta(716)
!fj#endif
    call m_CD_softpart(nfout,kv3)
    call m_CD_hardpart(nfout,kv3)
!fj#ifdef __TIMER_SUB__
!fj  call timer_end(716)
!fj#endif
  end subroutine CD_Softpart_plus_Hardpart

! ============================ added by K. Tagami ============== 11.0
  subroutine CD_Softpart_plus_Hardpart_noncl
    call m_CD_softpart_noncl(nfout,kv3)
    call m_CD_hardpart_noncl(nfout,kv3)
  end subroutine CD_Softpart_plus_Hardpart_noncl
! ============================================================= 11.0

end subroutine ChargeDensity_Construction

      SUBROUTINE DLARFB( SIDE, TRANS, DIRECT, STOREV, M, N, K, V, LDV,
     $                   T, LDT, C, LDC, WORK, LDWORK )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          DIRECT, SIDE, STOREV, TRANS
      INTEGER            K, LDC, LDT, LDV, LDWORK, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   C( LDC, * ), T( LDT, * ), V( LDV, * ),
     $                   WORK( LDWORK, * )
*     ..
*
*  Purpose
*  =======
*
*  DLARFB applies a real block reflector H or its transpose H' to a
*  real m by n matrix C, from either the left or the right.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply H or H' from the Left
*          = 'R': apply H or H' from the Right
*
*  TRANS   (input) CHARACTER*1
*          = 'N': apply H (No transpose)
*          = 'T': apply H' (Transpose)
*
*  DIRECT  (input) CHARACTER*1
*          Indicates how H is formed from a product of elementary
*          reflectors
*          = 'F': H = H(1) H(2) . . . H(k) (Forward)
*          = 'B': H = H(k) . . . H(2) H(1) (Backward)
*
*  STOREV  (input) CHARACTER*1
*          Indicates how the vectors which define the elementary
*          reflectors are stored:
*          = 'C': Columnwise
*          = 'R': Rowwise
*
*  M       (input) INTEGER
*          The number of rows of the matrix C.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C.
*
*  K       (input) INTEGER
*          The order of the matrix T (= the number of elementary
*          reflectors whose product defines the block reflector).
*
*  V       (input) DOUBLE PRECISION array, dimension
*                                (LDV,K) if STOREV = 'C'
*                                (LDV,M) if STOREV = 'R' and SIDE = 'L'
*                                (LDV,N) if STOREV = 'R' and SIDE = 'R'
*          The matrix V. See further details.
*
*  LDV     (input) INTEGER
*          The leading dimension of the array V.
*          If STOREV = 'C' and SIDE = 'L', LDV >= max(1,M);
*          if STOREV = 'C' and SIDE = 'R', LDV >= max(1,N);
*          if STOREV = 'R', LDV >= K.
*
*  T       (input) DOUBLE PRECISION array, dimension (LDT,K)
*          The triangular k by k matrix T in the representation of the
*          block reflector.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T. LDT >= K.
*
*  C       (input/output) DOUBLE PRECISION array, dimension (LDC,N)
*          On entry, the m by n matrix C.
*          On exit, C is overwritten by H*C or H'*C or C*H or C*H'.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDA >= max(1,M).
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (LDWORK,K)
*
*  LDWORK  (input) INTEGER
*          The leading dimension of the array WORK.
*          If SIDE = 'L', LDWORK >= max(1,N);
*          if SIDE = 'R', LDWORK >= max(1,M).
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      CHARACTER          TRANST
      INTEGER            I, J
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DGEMM, DTRMM
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( M.LE.0 .OR. N.LE.0 )
     $   RETURN
*
      IF( LSAME( TRANS, 'N' ) ) THEN
         TRANST = 'T'
      ELSE
         TRANST = 'N'
      END IF
*
      IF( LSAME( STOREV, 'C' ) ) THEN
*
         IF( LSAME( DIRECT, 'F' ) ) THEN
*
*           Let  V =  ( V1 )    (first K rows)
*                     ( V2 )
*           where  V1  is unit lower triangular.
*
            IF( LSAME( SIDE, 'L' ) ) THEN
*
*              Form  H * C  or  H' * C  where  C = ( C1 )
*                                                  ( C2 )
*
*              W := C' * V  =  (C1'*V1 + C2'*V2)  (stored in WORK)
*
*              W := C1'
*
               DO 10 J = 1, K
                  CALL DCOPY( N, C( J, 1 ), LDC, WORK( 1, J ), 1 )
   10          CONTINUE
*
*              W := W * V1
*
               CALL DTRMM( 'Right', 'Lower', 'No transpose', 'Unit', N,
     $                     K, ONE, V, LDV, WORK, LDWORK )
               IF( M.GT.K ) THEN
*
*                 W := W + C2'*V2
*
                  CALL DGEMM( 'Transpose', 'No transpose', N, K, M-K,
     $                        ONE, C( K+1, 1 ), LDC, V( K+1, 1 ), LDV,
     $                        ONE, WORK, LDWORK )
               END IF
*
*              W := W * T'  or  W * T
*
               CALL DTRMM( 'Right', 'Upper', TRANST, 'Non-unit', N, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - V * W'
*
               IF( M.GT.K ) THEN
*
*                 C2 := C2 - V2 * W'
*
                  CALL DGEMM( 'No transpose', 'Transpose', M-K, N, K,
     $                        -ONE, V( K+1, 1 ), LDV, WORK, LDWORK, ONE,
     $                        C( K+1, 1 ), LDC )
               END IF
*
*              W := W * V1'
*
               CALL DTRMM( 'Right', 'Lower', 'Transpose', 'Unit', N, K,
     $                     ONE, V, LDV, WORK, LDWORK )
*
*              C1 := C1 - W'
*
               DO 30 J = 1, K
                  DO 20 I = 1, N
                     C( J, I ) = C( J, I ) - WORK( I, J )
   20             CONTINUE
   30          CONTINUE
*
            ELSE IF( LSAME( SIDE, 'R' ) ) THEN
*
*              Form  C * H  or  C * H'  where  C = ( C1  C2 )
*
*              W := C * V  =  (C1*V1 + C2*V2)  (stored in WORK)
*
*              W := C1
*
               DO 40 J = 1, K
                  CALL DCOPY( M, C( 1, J ), 1, WORK( 1, J ), 1 )
   40          CONTINUE
*
*              W := W * V1
*
               CALL DTRMM( 'Right', 'Lower', 'No transpose', 'Unit', M,
     $                     K, ONE, V, LDV, WORK, LDWORK )
               IF( N.GT.K ) THEN
*
*                 W := W + C2 * V2
*
                  CALL DGEMM( 'No transpose', 'No transpose', M, K, N-K,
     $                        ONE, C( 1, K+1 ), LDC, V( K+1, 1 ), LDV,
     $                        ONE, WORK, LDWORK )
               END IF
*
*              W := W * T  or  W * T'
*
               CALL DTRMM( 'Right', 'Upper', TRANS, 'Non-unit', M, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - W * V'
*
               IF( N.GT.K ) THEN
*
*                 C2 := C2 - W * V2'
*
                  CALL DGEMM( 'No transpose', 'Transpose', M, N-K, K,
     $                        -ONE, WORK, LDWORK, V( K+1, 1 ), LDV, ONE,
     $                        C( 1, K+1 ), LDC )
               END IF
*
*              W := W * V1'
*
               CALL DTRMM( 'Right', 'Lower', 'Transpose', 'Unit', M, K,
     $                     ONE, V, LDV, WORK, LDWORK )
*
*              C1 := C1 - W
*
               DO 60 J = 1, K
                  DO 50 I = 1, M
                     C( I, J ) = C( I, J ) - WORK( I, J )
   50             CONTINUE
   60          CONTINUE
            END IF
*
         ELSE
*
*           Let  V =  ( V1 )
*                     ( V2 )    (last K rows)
*           where  V2  is unit upper triangular.
*
            IF( LSAME( SIDE, 'L' ) ) THEN
*
*              Form  H * C  or  H' * C  where  C = ( C1 )
*                                                  ( C2 )
*
*              W := C' * V  =  (C1'*V1 + C2'*V2)  (stored in WORK)
*
*              W := C2'
*
               DO 70 J = 1, K
                  CALL DCOPY( N, C( M-K+J, 1 ), LDC, WORK( 1, J ), 1 )
   70          CONTINUE
*
*              W := W * V2
*
               CALL DTRMM( 'Right', 'Upper', 'No transpose', 'Unit', N,
     $                     K, ONE, V( M-K+1, 1 ), LDV, WORK, LDWORK )
               IF( M.GT.K ) THEN
*
*                 W := W + C1'*V1
*
                  CALL DGEMM( 'Transpose', 'No transpose', N, K, M-K,
     $                        ONE, C, LDC, V, LDV, ONE, WORK, LDWORK )
               END IF
*
*              W := W * T'  or  W * T
*
               CALL DTRMM( 'Right', 'Lower', TRANST, 'Non-unit', N, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - V * W'
*
               IF( M.GT.K ) THEN
*
*                 C1 := C1 - V1 * W'
*
                  CALL DGEMM( 'No transpose', 'Transpose', M-K, N, K,
     $                        -ONE, V, LDV, WORK, LDWORK, ONE, C, LDC )
               END IF
*
*              W := W * V2'
*
               CALL DTRMM( 'Right', 'Upper', 'Transpose', 'Unit', N, K,
     $                     ONE, V( M-K+1, 1 ), LDV, WORK, LDWORK )
*
*              C2 := C2 - W'
*
               DO 90 J = 1, K
                  DO 80 I = 1, N
                     C( M-K+J, I ) = C( M-K+J, I ) - WORK( I, J )
   80             CONTINUE
   90          CONTINUE
*
            ELSE IF( LSAME( SIDE, 'R' ) ) THEN
*
*              Form  C * H  or  C * H'  where  C = ( C1  C2 )
*
*              W := C * V  =  (C1*V1 + C2*V2)  (stored in WORK)
*
*              W := C2
*
               DO 100 J = 1, K
                  CALL DCOPY( M, C( 1, N-K+J ), 1, WORK( 1, J ), 1 )
  100          CONTINUE
*
*              W := W * V2
*
               CALL DTRMM( 'Right', 'Upper', 'No transpose', 'Unit', M,
     $                     K, ONE, V( N-K+1, 1 ), LDV, WORK, LDWORK )
               IF( N.GT.K ) THEN
*
*                 W := W + C1 * V1
*
                  CALL DGEMM( 'No transpose', 'No transpose', M, K, N-K,
     $                        ONE, C, LDC, V, LDV, ONE, WORK, LDWORK )
               END IF
*
*              W := W * T  or  W * T'
*
               CALL DTRMM( 'Right', 'Lower', TRANS, 'Non-unit', M, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - W * V'
*
               IF( N.GT.K ) THEN
*
*                 C1 := C1 - W * V1'
*
                  CALL DGEMM( 'No transpose', 'Transpose', M, N-K, K,
     $                        -ONE, WORK, LDWORK, V, LDV, ONE, C, LDC )
               END IF
*
*              W := W * V2'
*
               CALL DTRMM( 'Right', 'Upper', 'Transpose', 'Unit', M, K,
     $                     ONE, V( N-K+1, 1 ), LDV, WORK, LDWORK )
*
*              C2 := C2 - W
*
               DO 120 J = 1, K
                  DO 110 I = 1, M
                     C( I, N-K+J ) = C( I, N-K+J ) - WORK( I, J )
  110             CONTINUE
  120          CONTINUE
            END IF
         END IF
*
      ELSE IF( LSAME( STOREV, 'R' ) ) THEN
*
         IF( LSAME( DIRECT, 'F' ) ) THEN
*
*           Let  V =  ( V1  V2 )    (V1: first K columns)
*           where  V1  is unit upper triangular.
*
            IF( LSAME( SIDE, 'L' ) ) THEN
*
*              Form  H * C  or  H' * C  where  C = ( C1 )
*                                                  ( C2 )
*
*              W := C' * V'  =  (C1'*V1' + C2'*V2') (stored in WORK)
*
*              W := C1'
*
               DO 130 J = 1, K
                  CALL DCOPY( N, C( J, 1 ), LDC, WORK( 1, J ), 1 )
  130          CONTINUE
*
*              W := W * V1'
*
               CALL DTRMM( 'Right', 'Upper', 'Transpose', 'Unit', N, K,
     $                     ONE, V, LDV, WORK, LDWORK )
               IF( M.GT.K ) THEN
*
*                 W := W + C2'*V2'
*
                  CALL DGEMM( 'Transpose', 'Transpose', N, K, M-K, ONE,
     $                        C( K+1, 1 ), LDC, V( 1, K+1 ), LDV, ONE,
     $                        WORK, LDWORK )
               END IF
*
*              W := W * T'  or  W * T
*
               CALL DTRMM( 'Right', 'Upper', TRANST, 'Non-unit', N, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - V' * W'
*
               IF( M.GT.K ) THEN
*
*                 C2 := C2 - V2' * W'
*
                  CALL DGEMM( 'Transpose', 'Transpose', M-K, N, K, -ONE,
     $                        V( 1, K+1 ), LDV, WORK, LDWORK, ONE,
     $                        C( K+1, 1 ), LDC )
               END IF
*
*              W := W * V1
*
               CALL DTRMM( 'Right', 'Upper', 'No transpose', 'Unit', N,
     $                     K, ONE, V, LDV, WORK, LDWORK )
*
*              C1 := C1 - W'
*
               DO 150 J = 1, K
                  DO 140 I = 1, N
                     C( J, I ) = C( J, I ) - WORK( I, J )
  140             CONTINUE
  150          CONTINUE
*
            ELSE IF( LSAME( SIDE, 'R' ) ) THEN
*
*              Form  C * H  or  C * H'  where  C = ( C1  C2 )
*
*              W := C * V'  =  (C1*V1' + C2*V2')  (stored in WORK)
*
*              W := C1
*
               DO 160 J = 1, K
                  CALL DCOPY( M, C( 1, J ), 1, WORK( 1, J ), 1 )
  160          CONTINUE
*
*              W := W * V1'
*
               CALL DTRMM( 'Right', 'Upper', 'Transpose', 'Unit', M, K,
     $                     ONE, V, LDV, WORK, LDWORK )
               IF( N.GT.K ) THEN
*
*                 W := W + C2 * V2'
*
                  CALL DGEMM( 'No transpose', 'Transpose', M, K, N-K,
     $                        ONE, C( 1, K+1 ), LDC, V( 1, K+1 ), LDV,
     $                        ONE, WORK, LDWORK )
               END IF
*
*              W := W * T  or  W * T'
*
               CALL DTRMM( 'Right', 'Upper', TRANS, 'Non-unit', M, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - W * V
*
               IF( N.GT.K ) THEN
*
*                 C2 := C2 - W * V2
*
                  CALL DGEMM( 'No transpose', 'No transpose', M, N-K, K,
     $                        -ONE, WORK, LDWORK, V( 1, K+1 ), LDV, ONE,
     $                        C( 1, K+1 ), LDC )
               END IF
*
*              W := W * V1
*
               CALL DTRMM( 'Right', 'Upper', 'No transpose', 'Unit', M,
     $                     K, ONE, V, LDV, WORK, LDWORK )
*
*              C1 := C1 - W
*
               DO 180 J = 1, K
                  DO 170 I = 1, M
                     C( I, J ) = C( I, J ) - WORK( I, J )
  170             CONTINUE
  180          CONTINUE
*
            END IF
*
         ELSE
*
*           Let  V =  ( V1  V2 )    (V2: last K columns)
*           where  V2  is unit lower triangular.
*
            IF( LSAME( SIDE, 'L' ) ) THEN
*
*              Form  H * C  or  H' * C  where  C = ( C1 )
*                                                  ( C2 )
*
*              W := C' * V'  =  (C1'*V1' + C2'*V2') (stored in WORK)
*
*              W := C2'
*
               DO 190 J = 1, K
                  CALL DCOPY( N, C( M-K+J, 1 ), LDC, WORK( 1, J ), 1 )
  190          CONTINUE
*
*              W := W * V2'
*
               CALL DTRMM( 'Right', 'Lower', 'Transpose', 'Unit', N, K,
     $                     ONE, V( 1, M-K+1 ), LDV, WORK, LDWORK )
               IF( M.GT.K ) THEN
*
*                 W := W + C1'*V1'
*
                  CALL DGEMM( 'Transpose', 'Transpose', N, K, M-K, ONE,
     $                        C, LDC, V, LDV, ONE, WORK, LDWORK )
               END IF
*
*              W := W * T'  or  W * T
*
               CALL DTRMM( 'Right', 'Lower', TRANST, 'Non-unit', N, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - V' * W'
*
               IF( M.GT.K ) THEN
*
*                 C1 := C1 - V1' * W'
*
                  CALL DGEMM( 'Transpose', 'Transpose', M-K, N, K, -ONE,
     $                        V, LDV, WORK, LDWORK, ONE, C, LDC )
               END IF
*
*              W := W * V2
*
               CALL DTRMM( 'Right', 'Lower', 'No transpose', 'Unit', N,
     $                     K, ONE, V( 1, M-K+1 ), LDV, WORK, LDWORK )
*
*              C2 := C2 - W'
*
               DO 210 J = 1, K
                  DO 200 I = 1, N
                     C( M-K+J, I ) = C( M-K+J, I ) - WORK( I, J )
  200             CONTINUE
  210          CONTINUE
*
            ELSE IF( LSAME( SIDE, 'R' ) ) THEN
*
*              Form  C * H  or  C * H'  where  C = ( C1  C2 )
*
*              W := C * V'  =  (C1*V1' + C2*V2')  (stored in WORK)
*
*              W := C2
*
               DO 220 J = 1, K
                  CALL DCOPY( M, C( 1, N-K+J ), 1, WORK( 1, J ), 1 )
  220          CONTINUE
*
*              W := W * V2'
*
               CALL DTRMM( 'Right', 'Lower', 'Transpose', 'Unit', M, K,
     $                     ONE, V( 1, N-K+1 ), LDV, WORK, LDWORK )
               IF( N.GT.K ) THEN
*
*                 W := W + C1 * V1'
*
                  CALL DGEMM( 'No transpose', 'Transpose', M, K, N-K,
     $                        ONE, C, LDC, V, LDV, ONE, WORK, LDWORK )
               END IF
*
*              W := W * T  or  W * T'
*
               CALL DTRMM( 'Right', 'Lower', TRANS, 'Non-unit', M, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - W * V
*
               IF( N.GT.K ) THEN
*
*                 C1 := C1 - W * V1
*
                  CALL DGEMM( 'No transpose', 'No transpose', M, N-K, K,
     $                        -ONE, WORK, LDWORK, V, LDV, ONE, C, LDC )
               END IF
*
*              W := W * V2
*
               CALL DTRMM( 'Right', 'Lower', 'No transpose', 'Unit', M,
     $                     K, ONE, V( 1, N-K+1 ), LDV, WORK, LDWORK )
*
*              C1 := C1 - W
*
               DO 240 J = 1, K
                  DO 230 I = 1, M
                     C( I, N-K+J ) = C( I, N-K+J ) - WORK( I, J )
  230             CONTINUE
  240          CONTINUE
*
            END IF
*
         END IF
      END IF
*
      RETURN
*
*     End of DLARFB
*
      END

!k点の適合関係についての処理
!Copyright (C) 2014-2015 Ryosuke Tomita

module m_compatibility
#include "defines.F"
  use m_commons, only: stdout
  use m_tspace_defines, only: kvector, character_table, comtable
  use m_tspace_commons, only: getKpointNameForTex
!  use m_character_table
  implicit none

!k点バッファの最大要素数
  integer, parameter, private:: num_kpoint_max = 255
!k点バッファの現在の要素数
  integer, private:: numk = 0
!k点のバッファ(k-pathのすべての点ではなく、k-pathの各節と中間から1つずつ登録する
  type(kvector), private:: kps(num_kpoint_max)
  type(character_table), private:: chts(num_kpoint_max)
contains 
!k点を二つ渡し(ik1, ik2)、それら二つのk点群間の適合関係を返す。ik1がik2の部分群になるように指定する。isdoubleは任意変数、TRUEにすると二重表現における適合関係を返す。errは計算が成功したかどうか、部分群の条件を満たさないなどのエラーが発生したときFALSEが格納される。TSPACE関数compatを使用
  type(comtable) function get_compat_table(ik1, ik2, err) result(tbl)
    type(kvector), intent(in):: ik1, ik2
    logical, intent(out):: err
    integer:: isd, ind, jsd
    integer:: ndes(12), jtrs(12), ipas(12)
    tbl%kp(1) = ik1
    tbl%kp(2) = ik2
    if(ik1%isdouble) then
       isd = 1
    else
       isd = 0
    endif

    tbl%comp = 0
    call compat(ik1%comp, ik1%common_denom, tbl%nimr(1),&
         ik2%comp, ik2%common_denom, tbl%nimr(2),&
         isd, tbl%comp, ind)
    !call cmptrv(ik1%comp, ik1%common_denom, ik2%comp, ik2%common_denom, isd, tbl%comp, tbl%comp)
    if(ind > 0) then
       err = .false.
    else
       err = .true.
    endif
    !call dgtrst(jdub,nrs,mmg,nstr,ndes,jtrs,ipas)

  end function get_compat_table

!k点のリストkpsに入力されたkpが登録されていたら.true.、されていなかったら.false.を返す
!k点の比較はk点の名前同士を比較する
  logical function isDuplicateKpoint(kp) result(is)
    type(kvector), intent(in):: kp  
    integer:: ik
    is = .false.
    do ik = 1, numk
       if(kps(ik)%name(1:2) == kp%name(1:2)) is = .true.
    end do
  end function isDuplicateKpoint

!k点バッファにkpを追加する。重複チェックは行われない。バッファの数が最大数を超えた時、バッファ先頭の値が上書きされる
 subroutine add_kpoint(kp, cht)
   type(kvector), intent(in):: kp
   type(character_table), intent(in):: cht
!k点の追加
   numk = numk + 1
   numk = mod(numk, num_kpoint_max)
   kps(numk) = kp
   chts(numk) = cht
 end subroutine add_kpoint

!k点のリストkpsを、k点のインデックスをつかってソートする
 subroutine sort_kpoint()
   integer:: i, j
   type(kvector):: kp
   type(character_table):: cht
   j = numk - 1
   do while(j > 1)
      do i = 1, j
         if(kps(i)%index > kps(i + 1)%index) then
            kp = kps(i)
            kps(i) = kps(i + 1)
            kps(i + 1) = kp

            cht = chts(i)
            chts(i) = chts(i + 1)
            chts(i + 1) = cht
         end if
      end do
      j = j - 1
   end do
 end subroutine sort_kpoint

!適合関係出力のためのフォーマット
!あるk点(knameとは無関係)のある既約表現imr_sがk点(knameと対応する)のどの既約表現と適合するかを、適合関係comtを用いて判断し、出力を行う。
  subroutine format_compat_table(imr_s, kname, cht, comt, nfout)
    integer, intent(in):: imr_s, nfout 
    character(len=8), intent(in):: kname
    type(character_table), intent(in):: cht
    type(comtable), intent(in):: comt
    integer:: imr_l, imr_k!k点(knameと対応する)の既約表現のインデックス
#define COMP(i) comt%comp(imr_s, i)
    imr_k = 1
!TSPACE関数compatから得た、既約表現imr_sの中に部分群の既約表現imr_lが含まれる数をcomt%comp(imr_s, imr_l)が記憶している
!最初に含まれる既約表現の番号までスキップし、その番号をimr_kに記憶させる
    do while(COMP(imr_k) == 0)
       imr_k = imr_k + 1
       if(imr_k > comt%nimr(1)) go to 200
    end do
    if(COMP(imr_k) > 1) write(nfout, fmt = '(I0)', advance = 'no') COMP(imr_k)
    write(nfout, fmt = '(A)', advance = 'no') TEX_COMPAT_NAME(kname, cht%imrs(imr_k)%name)
!最初以降の既約表現が含まれるかどうかを調べる
    do imr_l = imr_k + 1, comt%nimr(1)
       select case(COMP(imr_l))
       case(0)!1つも含まれない場合
          cycle
       case(1:)!1つ以上含まれる場合
          if(COMP(imr_l) > 1) write(nfout, fmt = '(I0)', advance = 'no') COMP(imr_l)
          write(nfout, fmt = '(2A)', advance = 'no') '+',TEX_COMPAT_NAME(kname, cht%imrs(imr_l)%name)
       end select
    end do
200  continue
#undef COMP
  end subroutine format_compat_table

!適合関係の出力(バッファ内にあるk点から2つ選ぶ、すべてのk点の組み合わせについて適合関係を出力する)
  subroutine print_compat_table(nfout)
    integer, intent(in):: nfout
    integer:: ik

    call sort_kpoint
!    open(stdout)
    do ik = 1, numk - 1
       call PRINTCT(nfout, ik, ik + 1)
       call PRINTCT(nfout, ik + 1, ik)
    end do
!    close(stdout)
    return
contains
!適合関係の出力関数(k点を2つ指定する)
  subroutine PRINTCT(nfout, ik1, ik2)
    integer, intent(in):: nfout, ik1, ik2
    type(comtable):: comt
    integer:: imr_s
    logical:: is_success
!適合関係の取得
    comt = get_compat_table(kps(ik1), kps(ik2), is_success)
    if(.not.is_success) then
       write(stdout, *) '!COMTABLEERROR', ik1, kps(ik1)%name, ik2, kps(ik2)%name
       return
    end if
!TeXのtabular環境の出力
    write(nfout, *) TEX_BEGINTABULAR(2)
    write(nfout, *) '$', getKpointNameForTex(kps(ik2)%name), '$&$',&
         getKpointNameForTex(kps(ik1)%name), '$ \\ \hline\hline'
    do imr_s = 1, comt%nimr(2)
       write(nfout, fmt = '(3A)', advance = 'no') '$',TEX_COMPAT_NAME(getKpointNameForTex(kps(ik2)%name),chts(ik2)%imrs(imr_s)%name),'$&$'
       call format_compat_table(imr_s, getKpointNameForTex(kps(ik1)%name), chts(ik1), comt, nfout)
       write(nfout, '(A)') '$\\ \hline'
    end do
    write(nfout, *) TEX_ENDTABULAR
  end subroutine PRINTCT
  end subroutine print_compat_table

  subroutine print_compat_csv(nfout)
    integer, intent(in):: nfout
    integer:: ik

!    open(stdout)
    call sort_kpoint
    do ik = 1, numk - 1
       call PRINTCT(nfout, ik, ik + 1)
       call PRINTCT(nfout, ik + 1, ik)
    end do
!    close(stdout)
    return
contains
!適合関係の出力関数(k点を2つ指定する)
  subroutine PRINTCT(nfout, ik1, ik2)
    integer, intent(in):: nfout, ik1, ik2
    type(comtable):: comt
    integer:: imr_s
    logical:: is_success
    comt = get_compat_table(kps(ik1), kps(ik2), is_success)
    if(.not.is_success) then
       write(stdout, *) '!COMTABLEERROR', ik1, kps(ik1)%name, ik2, kps(ik2)%name
       return
    end if
    write(nfout, *) getKpointNameForTex(kps(ik2)%name)//','//getKpointNameForTex(kps(ik1)%name)
    do imr_s = 1, comt%nimr(2)
       write(nfout, fmt = '(A)', advance = 'no') TEX_COMPAT_NAME(getKpointNameForTex(kps(ik2)%name),chts(ik2)%imrs(imr_s)%name)//','
       call format_compat_table(imr_s, getKpointNameForTex(kps(ik1)%name), chts(ik1), comt, nfout)
       write(nfout, *)
    end do
    write(nfout, *)
  end subroutine PRINTCT

  end subroutine print_compat_csv

end module m_compatibility

!================================================
!  Software name : STM
!  Module : m_Control_Parameters
!  Subroutine(s) : m_CtrlP_rd_nc_z_axis, m_CtrlP_rd_energy_range,
!                  m_CtrlP_rd_z_range, m_CtrlP_set_wct_start,
!                  m_CtrlP_rd_mixing_ratio, m_CtrlP_rd_error_limit
!  Author(s)     : Takahiro Yamasaki (June 7, 2004)
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.

module m_Control_Parameters
! $Id: m_Control_Parameters.F90,v 1.1.1.1 2004/06/26 11:21:37 yamasaki Exp $
  use m_Const_Parameters, only : DP
  implicit none

  integer       :: ipri
  real(DP)      :: e1, e2      ! energy range, Efermi+e1 - Efermi+e2
  integer       :: izi, izf    ! z range top and bottom
  real(kind=DP) :: rini, rfin  ! mixing ratio in iteration
  integer       :: nfin        ! rmix = rini + (rfin - rini)*(iter-1)/nfin
  integer       :: nc_z        ! column position of the z-component,
                               ! which is normaly 1, sometimes 3
  integer, dimension(3) :: n_fc,n_fc_i
  real(kind=DP) :: erlmt ! error limit
  real(kind=DP) :: wct_start = 0.d0
#ifdef VPP
!                 wct_start: remaining time at start(sec).
!                 wct_now  : remaining time now(sec).
  real(kind=DP), parameter :: Critical_Remaining_CPU_TIME = 600  !(sec.)
#else
!                 wct_start: Wall Clock Time Start.
!                 wct_now  : Wall Clock Time Now.
#endif
contains
  subroutine m_CtrlP_rd_nc_z_axis(nfinp)
    integer, intent(in) :: nfinp
    read(nfinp,*) nc_z
    print '(" nc_z = ",i5)',nc_z
    if(nc_z .eq. 1) then
       n_fc(1) = 1; n_fc(2) = 2; n_fc(3) = 3
       n_fc_i(1) = 1; n_fc_i(2) = 2; n_fc_i(3) = 3
    else if(nc_z .eq. 2) then
       n_fc(1) = 2; n_fc(2) = 3; n_fc(3) = 1
       n_fc_i(1) = 3; n_fc_i(2) = 1; n_fc_i(3) = 2
    else if(nc_z .eq. 3) then
       n_fc(1) = 3; n_fc(2) = 1; n_fc(3) = 2
       n_fc_i(1) = 2; n_fc_i(2) = 3; n_fc_i(3) = 1
    end if
  end subroutine m_CtrlP_rd_nc_z_axis

  subroutine m_CtrlP_rd_energy_range(nfinp)
    integer, intent(in) :: nfinp
    read(nfinp,*) e1, e2
    print '(" Bias Voltage (V) = ", 2f10.5)', e1, e2
    if(e1 > e2 ) stop ' e1 > e2'
  end subroutine m_CtrlP_rd_energy_range

  subroutine m_CtrlP_rd_z_range(nfinp)
    integer, intent(in) :: nfinp
    read(nfinp,*) izi, izf
    print '(" izi = ", i5, " izf = ",i5)',izi,izf
    if(izi > izf ) stop ' !! izi > izf (m_CtrlP_rd_z_range)'
  end subroutine m_CtrlP_rd_z_range

  subroutine m_CtrlP_set_wct_start
#ifdef VPP
    integer :: iremain
    call chkelaps(iremain)
    wct_start = iremain
#else
    call gettod(wct_start)
#endif
  end subroutine m_CtrlP_set_wct_start

  subroutine m_CtrlP_rd_mixing_ratio(nfinp)
    integer, intent(in) :: nfinp
    read(nfinp,*) rini, rfin, nfin
    print '(" r_{ini}, r_{fin}, n_{fin} = ",2f10.5,i5)', rini,rfin,nfin
  end subroutine m_CtrlP_rd_mixing_ratio

  subroutine m_CtrlP_rd_error_limit(nfinp)
    integer, intent(in) :: nfinp
    read (nfinp,*) erlmt
    print '(" erlmt(error limit) = ", d20.8)', erlmt
  end subroutine m_CtrlP_rd_error_limit
    
end module m_Control_Parameters

!=======================================================================
!
!  PROGRAM  PHASE/0 2023.01
!
!  MODULE: m_Crystal_Structure
!
!  AUTHORS: T. Yamasaki, K. Betsuyaku,    August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Crystal_Structure
!      (m_CS)
! $Id: m_Crystal_Structure.F90 630 2020-07-29 09:03:26Z ktagami $
!!$  use m_Files,              only : nfout,nfopgr,nfmatbp &
  use m_Timing,             only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters, only : ipri, af, m_CtrlP_set_af, m_CtrlP_set_nspin_and_af &
#ifndef ENABLE_ESM_PACK
       &                         , ipriinputfile, ipri_spg, printable, nspin, iprisym
#else
       &                         , ipriinputfile, ipri_spg, printable, nspin &
       &                         , sw_esm,esm_z1_defined,esm_z1,esm_w, iprisym
#endif
  use m_Const_Parameters,   only : DP,PAI,PAI2,CRDTYP,CARTS,BUCS,GENERAL &
       &                         , GENERAL_LARGER, HCP,SIMPLE_CUBIC, BCC, FCC &
       &                         , DIAMOND, HEXAGONAL, TRIGONAL, FMAXVALLEN &
       &                         , TRIGONAL_lattice, HEXAGONAL_lattice, PRIMITIVE_lattice &
       &                         , FCC_lattice, BCC_lattice, BottomCenteredCubic_lattice &
       &                         , num_d6h, num_oh, d6h_symbol, oh_symbol &
       &                         , PARA, NONMAG, ANTIFERRO, FERRO, NOCONV, LOWER, UPPER, ON, OFF &
       &                         , AUTOMATIC, MANUAL, BRAVAIS, PRIMITIVE, YES, NO &
       &                         , WHOLE, INITIALLY
  use m_Parallelization,    only : mype

! ================================== added by K. Tagami =============== 11.0 & 13.2S
  use m_Control_Parameters,  only : noncol, SpinOrbit_mode
  use m_Const_Parameters,    only : NONCOLLINEAR, Neglected
! ===================================================================== 11.0 & 13.2S

! =============================== KT_add ========================= 13.0U
  use m_Control_Parameters,  only : num_projectors
  use m_Const_Parameters,    only : MAG_MOMENT_VALS_GLOBAL, MAG_MOMENT_DIREC_GLOBAL, &
       &                            MAG_MOMENT_VALS_LOCAL,  MAG_MOMENT_DIREC_LOCAL, &
       &                            MAG_MOMENT_VALS_OCCMAT, &
       &                            MAG_MOMENT_DIREC_HARDPART, &
       &                            ABRUPT, STEPWISE, LINEAR
! ================================================================ 13.0U

! === KT_add ==== 13.1R
  use m_Control_Parameters,  only : sw_keep_symmetry_strict, icond
  use m_Const_Parameters,    only : COORDINATE_CONTINUATION, CONTINUATION, FIXED_CHARGE_CONTINUATION
! =============== 13.1R

  implicit none

!!$  integer :: input_coordinate_system             ! ncord

  integer ::                          inv = 0    ! flag for moving the origin (0:nomove, 1:move)
  integer :: inversion_symmetry = 0              ! ninv , same as inv.  {0|1} 0=noinversion nomove,1=inversion move
!!$  integer :: ntyp = 1
!!$  integer :: natm = 1
  integer :: nbztyp = GENERAL
  integer :: nbztyp_spg = 0      

  !!$integer :: symmetry_method = AUTOMATIC
  integer :: symmetry_method = MANUAL
  integer :: sw_supercell_symmetry = ON
  real(kind=DP) :: misalignment = 0.1D0    ! Bohr

  real(kind=DP) ::                          univol, rvol
  real(kind=DP) ::                          univol_prev
  real(kind=DP) ::                          univol_super, rvol_super
  real(kind=DP) ::                          univol_prim, rvol_prim
  real(kind=DP) ::                          symmetry_check_criterion = 1.d-12
  real(kind=DP), dimension(3,3) ::          altv, rltv
  real(kind=DP), dimension(3,3) ::          altv_super, rltv_super
  real(kind=DP), dimension(3,3) ::          altv_prim, rltv_prim

! ===================================== Added by K. Tagami ==========
  integer :: kt_iuctype
! ===================================================================

  ! ---- nfspg ---
  integer ::                                      il         ! lattice system
  character, private, dimension(-1:4)  ::         Char_lattice_system
  data Char_lattice_system /'R','H','P','F','I','C'/ 
                   ! Trigonal|Hexagonal|Simple|FaceCentered|BodyCentered|BaseCentered(C-basecentered)
                   ! Each of them corresponds to il= -1, 0, 1, 2, 3, and 4, respectively.
  integer ::                                      imag = NONMAG ! para(nonmag), antiferro, ferro
  integer ::                                      sw_fix_total_spin = NO ! effective when imag==FERRO
  integer ::                                      sw_fix_total_spin_in = NO
  integer ::                                      sw_bandgap_constraint = NO
  integer ::                                      spin_fix_period  = WHOLE
  real(kind=DP) ::                                total_spin = 0.d0 ! effecitve when imag=FERRO
  real(kind=DP) ::                                a,b,c      ! lattice parameter (length)
  real(kind=DP) ::                                ca,cb,cc   ! lattice parameter (cos(angle))
  real(kind=DP),dimension(3) ::                   Bravais_lattice_length ! unit:Bohr
  real(kind=DP),dimension(3) ::                   Bravais_lattice_angle  ! unit:degrees
  integer ::                                      ngen = 1   ! # of generators
  integer, allocatable, dimension(:)::            igen       ! d(ngen) rotation of generater
  integer, allocatable, dimension(:,:,:) ::       jgen       ! d(2,3,ngen) nonprimitive translation vector of genertor 
  integer                              ::         iaf=1      ! rotation of generater for AF case
  integer, dimension(2,3)              ::         jaf=reshape((/0,1,0,1,0,1/),(/2,3/)) ! nonprimitive translation vector of generator for AF case
!  integer, dimension(2,3)              ::         jaf ! nonprimitive translation vector of generator for AF case
  
  integer ::                                      nopr ! (=ng1) # of group elements
  integer ::                                      phonon_nopr ! for Phonon code
  real(kind=DP),allocatable,dimension(:,:,:),target :: tau ! (=ta1) d(3,nopr,CRDTYP), nonprimitive translation vector (A system)
  real(kind=DP),allocatable,dimension(:,:,:),target :: op ! (=ra1) d(3,3,nopr),rotation matrix in real space (A system)

  integer ::                                ngen_tl = 0 ! # of additional generators for supercell
!!$  integer, allocatable,dimension(:)::       igen_tl ! d(ngen_tl) rotation of generater
  integer, allocatable,dimension(:,:,:) ::  jgen_tl ! d(2,3,ngen_tl) nonprimitive translation vector of generator
  integer ::                                nopr_tl = 0 ! (=ng1) # of additional group elements for supercell
  real(kind=DP),allocatable,dimension(:,:,:):: tau_tl !(=ta1)d(3,ngen_tl,CRDTYP),nonprimitive translation vector (A system)
  real(kind=DP),allocatable,dimension(:,:,:):: op_tl !(=ra1)d(3,3,ngen_tl),rotation matrix in real space (A system)
  real(kind=DP), allocatable, dimension(:,:,:) :: sa1  ! d(3,3,nopr), rotation matrix in reciprocal space (A system)
  integer, dimension(48)                       :: ig01 ! symmetry operation numbers
  real(kind=DP) :: b2pmat(3,3) = 0.d0 ! transformation matrix (Bravais -> Primitive)
! ==================== Modified by K. Tagami =======
!  real(kind=DP) :: p2bmat(3,3) = 0.d0 ! transformation matrix (Bravais -> Primitive)
  real(kind=DP) :: p2bmat(3,3) = 0.d0 ! transformation matrix (Bravais <- Primitive)
! ===============================================


  character(len=9) :: pg_symbol_system = 'cubic'

 ! strain tensor
  real(kind=DP), dimension(1:3,1:3) :: strain
  integer,save                      :: sw_strained_cell = OFF
  character(len("strain")),private,parameter ::    tag_strain    = "strain"
  character(len("sw_strained_cell")),private,parameter :: tag_sw_strained_cell = "sw_strained_cell"

 ! reference cell for band unfolding
  character(len("reference_cell")), private,parameter :: &
       &                          tag_reference_cell = 'reference_cell'
  integer :: refcell_unit_type = PRIMITIVE
  real(kind=DP) ::  altv_refcell(3,3), rltv_refcell(3,3)
  real(kind=DP) ::  univol_refcell, rvol_refcell
  real(kind=DP) :: tmpmat(3,3)
  real(kind=DP) :: unit_cell_scale = 1.d0

  ! supercell
  integer :: sw_supercell = OFF
  integer :: supercell_unit_type = BRAVAIS
  integer :: n1_sc=1, n2_sc=1, n3_sc=1
  integer :: nlpnt = 1
  real(kind=DP), allocatable :: lpnt(:,:) ! dim(nlpnt,3)
  character(len("supercell")), private,parameter :: tag_supercell = 'supercell'
  character(len("sw_supercell")), private,parameter :: tag_sw_supercell = 'sw_supercell'
  character(len("size")), private,parameter :: tag_size = 'size'
  character(len("n1")), private,parameter :: tag_n1 = 'n1'
  character(len("n2")), private,parameter :: tag_n2 = 'n2'
  character(len("n3")), private,parameter :: tag_n3 = 'n3'

  ! space group
  character(len("method")),private,parameter ::    tag_method    = "method"
  character(len("automatic")),private,parameter ::    tag_automatic    = "automatic"
  character(len("manual")),private,parameter ::    tag_manual    = "manual"
  character(len("misalignment")),private,parameter :: tag_misalignment = "misalignment"
  character(len("tspace")),private,parameter ::    tag_tspace    = "tspace"
  ! sw_supercell_symmetry
  character(len("sw_supercell_symmetry")),private,parameter :: &
       &                                           tag_sw_supercell_symmetry = "sw_supercell_symmetry"
  ! ---> input tag terms
  ! --- Structure ---
  character(len("structure")),public,parameter ::  tag_structure = "structure"
  character(len("unit_cell")),private,parameter :: tag_unit_cell = "unit_cell"
  character(len("unit_cell_type")),private,parameter :: tag_unit_cell_type = "unit_cell_type"
  character(len("a_vector")), private,parameter :: tag_avector  = 'a_vector'
  character(len("b_vector")), private,parameter :: tag_bvector  = 'b_vector'
  character(len("c_vector")), private,parameter :: tag_cvector  = 'c_vector'
  character(len("a")), private,parameter ::        tag_a        = 'a'
  character(len("b")), private,parameter ::        tag_b        = 'b'
  character(len("c")), private,parameter ::        tag_c        = 'c'
  character(len("alpha")),private,parameter ::     tag_alpha    = 'alpha'
  character(len("beta")), private,parameter ::     tag_beta      = 'beta'
  character(len("gamma")), private,parameter ::    tag_gamma     = 'gamma'
  character(len("unit_cell_scale")), private, parameter :: tag_unit_cell_scale = "unit_cell_scale"

  character(len("symmetry")),private,parameter ::  tag_symmetry  = "symmetry"
  character(len("symmetry_check_criterion")),private,parameter :: tag_symmetry_check_criterion = "symmetry_check_criterion"
  character(len("crystal_structure")),private,parameter ::  tag_crystal_structure = "crystal_structure"
  character(len("crystal")),private,parameter ::            tag_crystal           = "crystal"
  character(len("simple_cubic")),private,parameter ::       tag_simple_cubic      = "simple_cubic"
  character(len("diamond")),private,parameter ::            tag_diamond           = "diamond"

  character(len("lattice_system")),private,parameter ::     tag_lattice_system = "lattice_system"
  character(len("system")),private,parameter ::             tag_system    = "system"
  character(len("rhombohedral")),private,parameter ::       tag_rhombohedral = "rhombohedral"
  character(len("trigonal")),private,parameter ::           tag_trigonal  = "trigonal"
  character(len("hexagonal")),private,parameter ::          tag_hexagonal = "hexagonal"
  character(len("hcp")),private,parameter ::                tag_hcp       = "hcp"
  character(len("primitive")),private,parameter ::          tag_primitive = "primitive"
  character(len("simple")),private,parameter ::             tag_simple    = "simple"
  character(len("facecentered_cubic")),private,parameter::  tag_facecentered = "facecentered_cubic"
  character(len("bodycentered_cubic")),private,parameter::  tag_bodycentered = "bodycentered_cubic"
  character(len("bcc")),private,parameter ::                tag_bcc       = "bcc"
  character(len("fcc")),private,parameter ::                tag_fcc       = "fcc"
  character(len("onefacecentered")),private,parameter ::    tag_onefacecentered = "onefacecentered"
  character(len("bottomcentered")),private,parameter ::     tag_bottomcentered = "bottomcentered"
  character(len("basecentered")),private,parameter ::       tag_basecentered = "basecentered"
  character(len("num_generators")),private,parameter ::     tag_num_generators = "num_generators"
  character(len("generators")),private,parameter ::         tag_generators = "generators"
  character(len("additional_translations")),private,parameter::tag_additional_tl = "additional_translations"
  character(len("af_generator")),private,parameter ::       tag_af_generator = "af_generator"
  character(len("rotation")),private,parameter ::           tag_rotation  = "rotation"
  character(len("tx")),private,parameter ::                 tag_tx        = "tx"
  character(len("ty")),private,parameter ::                 tag_ty        = "ty"
  character(len("tz")),private,parameter ::                 tag_tz        = "tz"
  character(len("sw_inversion")),private,parameter ::       tag_sw_inversion = "sw_inversion"
  character(len("bandgap_constraint")),private,parameter :: tag_bandgap_constraint  = "bandgap_constraint"
  character(len("nspin")),private,parameter ::              tag_nspin     = "nspin"
  logical ::                                                tag_nspin_is_found = .false.
  character(len("magnetic_state")),private,parameter ::     tag_magnetic_state  = "magnetic_state"
  logical ::                                                tag_magnetic_state_is_found = .false.
  character(len("para")),private,parameter ::               tag_para      = "para"
  character(len("nonmagnetic")),private,parameter ::        tag_nonmagnetic = "nonmagnetic"
  character(len("nonmag")),private,parameter ::             tag_nonmag    = "nonmag"
  character(len("none")),private,parameter ::               tag_none      = "none"
  character(len("af")),private,parameter ::                 tag_af        = "af"
  character(len("antiferro")),private,parameter ::          tag_antiferro = "antiferro"
  character(len("ferro")),private,parameter ::              tag_ferro     = "ferro"
  character(len("ferromagnetic_state")),private,parameter:: tag_ferromagnetic_state = "ferromagnetic_state"
  character(len("magnetic")),private,parameter ::           tag_magnetic  = "magnetic"
  character(len("mag")),private,parameter ::                tag_mag       = "mag"

  character(len("sw_non_symmorphic")),private,parameter  :: tag_sw_non_symmorphic="sw_non_symmorphic"
  character(len("cpumax")), private, parameter           :: tag_cpumax="cpumax"
  character(len("sw_read_symmetry_from_file")), private, parameter :: tag_sw_read_symmetry_from_file &
                                                         & = "sw_read_symmetry_from_file"

  character(len("sw_fix_total_spin")),private,parameter ::  tag_sw_fix_total_spin = "sw_fix_total_spin"
  character(len("spin_fix_period")),private,parameter   ::  tag_spin_fix_period = "spin_fix_period"
  character(len("whole")),private,parameter ::              tag_whole     = "whole"
  character(len("initially")),private,parameter ::          tag_initially = "initially"
  character(len("total_spin")),private,parameter ::         tag_total_spin = "total_spin" 

  character(len("primitive")),private,parameter ::          val_primitive     = "primitive"
  character(len("bravais")),private,parameter ::          val_bravais  = "bravais"

! --> T. Yamasaki 18th Aug. 2009 
  integer, parameter :: len_str = 132
  character(len=len_str) :: str
  character(len("fix_spin_status")),private,parameter ::    tag_fix_spin_status = "fix_spin_status" 
! <--

! ================================== added by K. Tagami =============== 11.0
!
!!  -- NonCollinear --
!
  character(len("noncollinear")),private,parameter ::   tag_noncollinear = "noncollinear"
  character(len("noncol")),      private,parameter ::   tag_noncol = "noncol"
!
  character(len("noncollinear_state")),private,parameter :: &
       &                         tag_noncollinear_state = "noncollinear_state"
!
!
  character(len("use_magnetic_symmetry")), private, parameter :: &
       &             tag_use_magnetic_symmetry = "use_magnetic_symmetry"
  character(len("use_mag_symm")), private, parameter :: &
       &             tag_use_mag_symm = "use_mag_symm"
  character(len("reduce_sym_by_magmom")), private, parameter :: &
       &             tag_reduce_sym_by_magmom = "reduce_sym_by_magmom"
  character(len("reduce_sym_by_orbital")), private, parameter :: &
       &             tag_reduce_sym_by_orbital = "reduce_sym_by_orbital"

! --- GGA noncl -
  character(len("constrain_on_grad_correction")), private, parameter :: &
       &             tag_constrain_on_grad_corr = "constrain_on_grad_correction"
! ---- PAW noncl --
  character(len("level_of_projection_paw_charge")), private, parameter :: &
       &             tag_level_projection_paw_charge = "level_of_projection_paw_charge"

! --- magnetic moment
  character(len("axis")),private,parameter :: tag_axis = "axis"
  character(len("direction")),private,parameter :: tag_direction = "direction"
  character(len("moment")),private,parameter :: tag_moment = "moment"
  character(len("magnetic_moment")),private,parameter :: tag_magnetic_moment &
       &                                       = "magnetic_moment"

  character(len("mx")),private,parameter :: tag_mx = "mx"
  character(len("my")),private,parameter :: tag_my = "my"
  character(len("mz")),private,parameter :: tag_mz = "mz"
  character(len("mdx")),private,parameter :: tag_mdx = "mdx"
  character(len("mdy")),private,parameter :: tag_mdy = "mdy"
  character(len("mdz")),private,parameter :: tag_mdz = "mdz"

  character(len("norm")),private,parameter :: tag_norm = "norm"
  character(len("theta")),private,parameter :: tag_theta = "theta"
  character(len("phi")),private,parameter :: tag_phi = "phi"
!
  real(kind=DP) :: norm
!
  integer :: sw_use_magnetic_symmetry = ON
  integer :: sw_reduce_sym_by_magmom = ON
  integer :: sw_reduce_sym_by_orbital = OFF
!!
  integer :: sw_constrain_on_grad_correction = OFF
  integer :: level_of_projection_paw_charge = 1
!
  real(kind=DP) :: mag_moment0_global(3) = (/ 0.0d0, 0.0d0, 0.0d0 /)
  real(kind=DP) :: mag_direc0_global(3) = (/ 0.0d0, 0.0d0, 1.0d0 /)
! ================================================================== 11.0

! === KT_add === 2014/08/04
!
! -- lowering contanumation in the case of noncol+GGA
!
  character(len("sw_neglect_low_helicity")),private,parameter :: &
       &          tag_sw_neglect_low_helicity = "sw_neglect_low_helicity"
  character(len("sw_neglect_low_vorticity")),private,parameter :: &
       &          tag_sw_neglect_low_vorticity = "sw_neglect_low_vorticity"
  character(len("threshold_helicity")),private,parameter :: &
       &          tag_threshold_helicity = "threshold_helicity"
  character(len("threshold_vorticity")),private,parameter :: &
       &          tag_threshold_vorticity = "threshold_vorticity"
!
  integer :: sw_neglect_low_helicity = OFF
  integer :: sw_neglect_low_vorticity = OFF
!
  integer :: sw_monitor_magnetic_vorticity = OFF
!
  real(kind=DP) :: threshold_helicity = 1.0D-6
  real(kind=DP) :: threshold_vorticity = 1.0D-4
! ============== 2014/08/04

! === KT_add ==== 2014/09/26
  character(len("sw_neglect_magmom")),private,parameter :: &
       &          tag_sw_neglect_magmom = "sw_neglect_magmom"
  integer :: sw_neglect_magmom = OFF
! =============== 2014/09/26

  character(len("sw_allow_mag_sym_inversion")),private,parameter :: &
       &          tag_sw_allow_mag_sym_inversion = "sw_allow_mag_sym_inversion"
  character(len("sw_allow_improper_rotation")),private,parameter :: &
       &          tag_sw_allow_improper_rotation = "sw_allow_improper_rotation"
  character(len("sw_allow_frac_translation")),private,parameter :: &
       &          tag_sw_allow_frac_translation = "sw_allow_frac_translation"
  integer :: sw_allow_mag_sym_inversion = ON
  integer :: sw_allow_improper_rotation = ON
  integer :: sw_allow_frac_translation = ON

! ==== KT_add ==== 2014/08/09 & 13.2S
  character(len("magnetic_restriction")),private,parameter :: &
       &          tag_magnetic_restriction = "magnetic_restriction"
  character(len("sw_fix_global_quantz_axis")),private,parameter :: &
       &          tag_sw_fix_global_quantz_axis = "sw_fix_global_quantz_axis"
  character(len("global_quantz_axis")),private,parameter :: &
       &        tag_global_quantz_axis = "global_quantz_axis"
  character(len("sx")),private,parameter :: tag_sx = "sx"
  character(len("sy")),private,parameter :: tag_sy = "sy"
  character(len("sz")),private,parameter :: tag_sz = "sz"
!
  integer :: sw_fix_global_quantz_axis = OFF
  real(kind=DP) :: Global_Quantz_Axis_Fixed(3) = (/0.0d0, 0.0d0, 1.0d0/)
! ================ 2014/08/09 & 13.2S

! =========================== KT_add ===================== 13.0U
!
! -- constraint on magnetic moment --
!
  character(len("magnetic_constraint")), private, parameter :: &
       &             tag_magnetic_constraint = "magnetic_constraint"
  character(len("constraint_type")), private, parameter :: &
       &             tag_constraint_type = "constraint_type"

  character(len("vals_global")), private, parameter :: &
       &                             tag_moment_vals_global = "vals_global"
  character(len("direc_global")), private, parameter :: &
       &                             tag_moment_direc_global = "direc_global"
  character(len("vals_local")), private, parameter :: &
       &                             tag_moment_vals_local = "vals_local"
  character(len("direc_local")), private, parameter :: &
       &                             tag_moment_direc_local = "direc_local"
  character(len("vals_occmat")), private, parameter :: &
       &                             tag_moment_vals_occmat = "vals_occmat"
  character(len("direc_hardpart")), private, parameter :: &
       &                             tag_moment_direc_hardpart = "direc_hardpart"
!
  character(len("damping_method")), private, parameter :: &
       &                            tag_damping_method = "damping_method"
  character(len("abrupt")), private, parameter :: &
       &                            tag_damp_abrupt = "abrupt"
  character(len("stepwise")), private, parameter :: &
       &                            tag_damp_stepwize = "stepwise"
  character(len("linear")), private, parameter :: &
       &                            tag_damp_linear = "linear"
! --
  character(len("lambda")), private, parameter ::  tag_lambda = "lambda"
  character(len("num_intermid_lambda")), private, parameter :: &
       &                          tag_num_intermid_lambda = "num_intermid_lambda"

  character(len("edelta_change_lambda_first")), private, parameter :: &
       &                 tag_edelta_change_lambda_first = "edelta_change_lambda_first"
  character(len("edelta_change_lambda_last")), private, parameter :: &
       &                 tag_edelta_change_lambda_last = "edelta_change_lambda_last"
!
  character(len("max_iter_elec_mag_constraint")), private, parameter :: &
       &                 tag_max_iter_elec_mag_constr = "max_iter_elec_mag_constraint"
  character(len("max_iter_ion_mag_constraint")), private, parameter :: &
       &                 tag_max_iter_ion_mag_constr = "max_iter_ion_mag_constraint"
  character(len("max_iter_cell_mag_constraint")), private, parameter :: &
       &                 tag_max_iter_cell_mag_constr = "max_iter_cell_mag_constraint"
!
  character(len("sw_fix_charge_after_constraint")), private, parameter :: &
       &              tag_sw_fix_charge_after_constr = "sw_fix_charge_after_constraint"

  integer, parameter :: nmax_intermid_lambda = 100
!
  integer :: sw_magnetic_constraint = OFF
  integer :: mag_constraint_type = 0
  integer :: damping_method_mag_constraint = ABRUPT
  integer :: num_intermid_lambda = 2
!
  integer :: max_iter_elec_mag_constraint = 50
  integer :: max_iter_ion_mag_constraint = 1
!  integer :: max_iter_cell_mag_constraint = 100
  integer :: max_iter_cell_mag_constraint = 1

  integer :: sw_fix_charge_after_constraint = OFF
!
  real(kind=DP) :: mag_constraint_lambda = 0.20d0
  real(kind=DP) :: edelta_change_lambda_first = 1.0D-4     ! hartree
  real(kind=DP) :: edelta_change_lambda_last = 1.0D-4     ! hartree
! ======================================================== 13.0U

! === KT_add === 2014/06/08
! Charged state
!
  character(len("charged_state")),private,parameter :: &
       &               tag_charged_state  = "charged_state"
  character(len("extra_charge")),private,parameter :: &
       &               tag_extra_charge  = "extra_charge"
  character(len("additional_charge")),private,parameter :: &
       &               tag_additional_charge  = "additional_charge"
!
  real(kind=DP) :: additional_charge = 0.0d0
! ============== 2014/06/08

! === KT_add === 13.2S
  character(len("sw_use_magnetic_symmetry")), private, parameter :: &
       &                tag_sw_use_magnetic_symmetry = "sw_use_magnetic_symmetry"
!  integer :: sw_spinorbit_force_theorem = off
  integer :: sw_spinorbit_second_variation = off
! ============== 13.2S

! =============================== added by K. Tagami ============ 12.0A
  logical :: use_altv_rltv = .false.
  character(len("use_altv_rltv")), private, parameter :: &
       &                tag_use_altv_rltv = "use_altv_rltv"
!
  logical :: gen_name_in_carts = .false.
  character(len("gen_name_in_carts")), private, parameter :: &
       &                tag_gen_name_in_carts = "gen_name_in_carts"
! =============================================================== 12.0A

! == KT_add == 13.1R
  integer, save :: nopr_previous
  real(kind=DP), allocatable :: op_previous(:,:,:), tau_previous(:,:,:)
! ============ 13.1R

  logical, private :: symmetry_not_printed  = .true.

  integer :: sw_non_symmorphic = ON
  real(kind=DP) :: cpumax_symsearch = -1.d0
  integer :: sw_read_symmetry_from_file = ON

contains
  subroutine m_CS_put_Bravais_lattice(length,angle)
    real(kind=DP), dimension(3) :: length, angle
    Bravais_lattice_length = length
    Bravais_lattice_angle  = angle
  end subroutine m_CS_put_Bravais_lattice

  subroutine m_CS_set_total_spin(nfout,total_spin_new)
    integer,       intent(in) :: nfout 
    real(kind=DP), intent(in) :: total_spin_new
    total_spin = total_spin_new
    if(ipri>=1) write(nfout,'(" total_spin_new = ", f12.6)') total_spin_new
  end subroutine m_CS_set_total_spin

  subroutine m_CS_free_fixed_total_spin(nfout)
    integer,       intent(in) :: nfout 
    sw_fix_total_spin = NO
    if(ipri >=1) write(nfout,'(" !** (new setting) sw_fix_total_spin = NO <<m_CS_free_fixed_total_spin>>")')
  end subroutine m_CS_free_fixed_total_spin

  subroutine m_CS_reset_fixed_total_spin(nfout)   ! 2024.03.27 T. Yamasaki
    integer,       intent(in) :: nfout 
    sw_fix_total_spin = sw_fix_total_spin_in
    if(ipri >=1) &
    write(nfout,'(" !** (new setting) sw_fix_total_spin = sw_fix_total_spin_in = ",I3," <<m_CS_reset_fixed_total_spin>>")') &
    sw_fix_total_spin
  end subroutine m_CS_reset_fixed_total_spin

  subroutine m_CS_fix_total_spin(nfout)  ! T. Yamasaki 17th Aug. 2009
    integer,       intent(in) :: nfout 
    sw_fix_total_spin = YES
    if(ipri >=1) write(nfout,'(" !** (new setting) sw_fix_total_spin = YES <<m_CS_fix_total_spin>>")')
  end subroutine m_CS_fix_total_spin

  subroutine m_CS_rd_n(nfout)
    ! <m_CS_rd_n> reads the information of crystal system from an input file
    !    formatted in a new style.
    ! This subroutine was coded by T. Yamasaki (FUJITSU LABORATORIES LTD.), Jun. 2003

    integer, intent(in) :: nfout
    character(len=FMAXVALLEN) :: rstr, dummy
    integer :: i, iret, rint, iuctype=BRAVAIS, ucinptype     !!! iuctype=0:bravais, 1:primitive;  ucinptype=0:length, 1:vector
    integer :: f_selectBlock, f_getStringValue, f_getIntValue
    integer :: f_selectParentBlock, f_getRealValue
    integer :: f_readUnitCell, f_readAfTauVec
    real(kind=DP),allocatable,dimension(:) :: avec,bvec,cvec
    logical :: number_is_given, prealloc, is_hexagonal, hext
    real(kind=DP) :: dret

    il = PRIMITIVE_lattice !!! K.Mae 040121
    if(ipriinputfile >= 2 .and. printable) write(nfout,'(" !** << m_CS_rd_n >>")')
    ! --- Structure ---
    if( f_selectBlock( tag_structure) == 0) then
       if(ipriinputfile >= 2 .and. printable) write(nfout,'(" !** -- tag_structure --")')
       ! --- magnetic_state

       if( f_getIntValue( tag_nspin, iret) == 0) then
          call set_imag_from_nspin(iret)
          tag_nspin_is_found = .true.
       else
          tag_nspin_is_found = .false.
       end if
       if( f_getStringValue( tag_magnetic_state, rstr, LOWER) == 0) then ! == modified by K. Tagami == 11.0
          tag_magnetic_state_is_found = .true.
          if(tag_nspin_is_found ) then
             if(ipriinputfile>=1) then
                write(nfout,'(" !** Both tags ",a1,"nspin",a1," and ",a1,"magnetic_state",a1," are defined.")') &
                     & char(34),char(34),char(34),char(34)
                write(nfout,'(" !**   The tag ",a1,"nspin",a1," takes priority")') char(34),char(34)
             end if
          else
             call set_imag(rstr) ! imag = {PARA|ANTIFERRO|FERRO|NONCOLLINEAR}  == modified by K. Tagami == 11.0
          endif
       end if

       if(ipriinputfile >= 1 .and. printable) then
          if(.not.tag_magnetic_state_is_found .and. .not.tag_nspin_is_found) then
             write(nfout,'(" !** Neither ",a1,"nspin",a1," nor ",a1,"magnetic_state",a1 &
                  & ," is defined in the input file")') char(34),char(34),char(34),char(34)
             write(nfout,'(" !** nspin is set 1 (default)")')
          end if
!!$          write(nfout,'(" !** imag = ", i6)') imag
       end if
       call m_CtrlP_set_nspin_and_af(nfout,imag)

       ! --- bandgap_constraint
       if( f_getIntValue( tag_bandgap_constraint, iret) == 0) then
          sw_bandgap_constraint = iret
          if(ipriinputfile >= 1 .and. printable) write(nfout,'(" !** bandgap_constraint = ",i6)') &
               & sw_bandgap_constraint
          if(imag .ne. NONMAG .and. sw_bandgap_constraint .ne. NO) then
             sw_bandgap_constraint = OFF
             if(ipriinputfile >=1 .and. printable) write(nfout,'(" !** bandgap_constraint(reset) = ",i6)') &
                  & sw_bandgap_constraint
          end if
       end if

       if(imag == FERRO) then
          if( f_selectBlock(tag_ferromagnetic_state) == 0) then
             if(f_getIntValue( tag_sw_fix_total_spin,iret) == 0) sw_fix_total_spin_in = iret
             if(sw_fix_total_spin_in /= YES .and. sw_fix_total_spin_in /= NO) sw_fix_total_spin_in = NO
             sw_fix_total_spin = sw_fix_total_spin_in
             if(f_getRealValue(tag_total_spin,dret,'') == 0) total_spin = dret
             if( f_getStringValue( tag_spin_fix_period, rstr, LOWER) == 0) &
                  & call set_spin_fix_period(rstr) ! spin_fix_period = {WHOLE|INITIALLY}
             if( f_getIntValue(tag_spin_fix_period,iret)==0) spin_fix_period=iret
             iret = f_selectParentBlock()
             if(ipriinputfile >= 1) then
                write(nfout,'(" !** sw_fix_total_spin_in = ",i3)') sw_fix_total_spin_in
                write(nfout,'(" !** set_spin_fix_period = ",i3," : 0=WHOLE, 1=INITIALLY")') spin_fix_period
                write(nfout,'(" !** total_spin        = ",f15.10)') total_spin
             end if
          end if
       end if

! == KT_add == 13.2S
       if ( .not. noncol ) then
          sw_use_magnetic_symmetry = off
#if 0
          if( f_getIntValue( tag_sw_use_magnetic_symmetry,iret)==0 ) then
             sw_use_magnetic_symmetry = iret
          endif
          if ( sw_use_magnetic_symmetry == ON ) sw_spinorbit_second_variation = on
#endif
          if ( SpinOrbit_mode /= Neglected ) then
             sw_spinorbit_second_variation = on
             if ( imag==FERRO ) sw_use_magnetic_symmetry = on
          endif
       endif
! ============ 13.2S

! =========================== added by K. Tagami ===================== 11.0
       if ( imag == NONCOLLINEAR ) then
          if( f_selectBlock( tag_noncollinear_state ) == 0 ) then

             call set_sw_reduce_sym_by_magmom
             call set_sw_reduce_sym_by_orbital
             call set_sw_magnetic_symmetry
! ============ KT_mod ================== 13.0U
!             if( f_selectBlock( tag_magnetic_constraint ) == 0 ) then
!                call set_magnetic_constraint
!                iret = f_selectParentBlock()
!             end if
! =======================================13.0U
! ==== KT_add === 2014/09/26
             call set_sw_neglect_magmom
! =============== 2014/09/26
             call set_sw_constrain_on_grad_corr
             call set_level_projection_paw_charge

! ==== KT_add === 2014/08/04
             call set_threshold_lowering_contami     ! vorticity, helicity
! =============== 2014/08/04
             iret = f_selectParentBlock()
          end if
       end if
! ===================================================================== 11.0

! ==== KT_add === 2014/08/09
       call set_magnetic_restriction
! =============== 2014/08/09
! ====================== KT_add ======================= 13.0U
       if( f_selectBlock( tag_magnetic_constraint ) == 0 ) then
          call set_magnetic_constraint
          iret = f_selectParentBlock()
       end if
! ===================================================== 13.0U

! == KT_add === 2014/06/08
       if ( f_selectBlock( tag_charged_state ) == 0 ) then
          if (f_getRealValue(tag_extra_charge,dret,'') == 0) &
               &                        additional_charge = dret
          if (f_getRealValue(tag_additional_charge,dret,'') == 0) &
               &                        additional_charge = dret
          if ( additional_charge > 0.0 ) then
             write(nfout,*) "** The system is positively charged : ", additional_charge
          else if ( additional_charge < 0.0 ) then
             write(nfout,*) "** The system is negatively charged : ", -additional_charge
          endif
          iret = f_selectParentBlock()
       endif
! ============= 2014/06/08

       ! --- symmetry ---
       if( f_selectBlock( tag_symmetry) == 0) then
          if(ipriinputfile >= 2 .and. printable) write(nfout,'(" !** -- tag_symmetry --")')
          if( f_getIntValue( tag_sw_inversion, iret) == 0) inversion_symmetry = iret
          if(ipriinputfile >= 1 .and. printable) write(nfout,'(" !** inversion_symmetry = ",i6)') inversion_symmetry
          ! --- symmetry_check_criterion
          if(f_getRealValue(tag_symmetry_check_criterion,dret,'') == 0) symmetry_check_criterion = dret
          if(ipriinputfile >= 1 .and. printable) then
             write(nfout,'(" !** symmetry_check_criterion = ",d20.8)') symmetry_check_criterion
          end if
          ! --- method ---
          call set_symmetry_method(symmetry_method)
          if(f_getRealValue(tag_misalignment,dret,'bohr') == 0) misalignment = dret
          if(ipriinputfile >= 1 .and. printable) then
             write(nfout,'(" !** symmetry_method = ",i6)') symmetry_method
             if(symmetry_method == AUTOMATIC) then
                write(nfout,'(" !** misalignment = ",f15.10)') misalignment 
             end if
          end if

          if(symmetry_method == AUTOMATIC) then
             if(f_getIntValue(tag_sw_non_symmorphic,iret) == 0) sw_non_symmorphic = iret  
             if(ipriinputfile>=1 .and. printable) write(nfout,'(a,i6)') ' !** sw_non_symmorphic = ',sw_non_symmorphic
             if(f_getRealValue(tag_cpumax,dret,'sec') == 0) cpumax_symsearch = dret
             if(ipriinputfile>=1 .and. printable .and. cpumax_symsearch>0) write(nfout,'(a,f10.5,a)') &
               & ' !** cpumax (for symmetry search) = ',sw_non_symmorphic, '(s)'
             if(f_getIntValue(tag_sw_read_symmetry_from_file,iret)==0) sw_read_symmetry_from_file = iret
             if(ipriinputfile>=1 .and. printable .and.  sw_read_symmetry_from_file == OFF &
               & .and. (icond == CONTINUATION .or. icond == FIXED_CHARGE_CONTINUATION &
               & .or. icond == COORDINATE_CONTINUATION)) then
               write(nfout,'(a)') ' !** since sw_read_symmetry_from_file is set to OFF, &
               & symmetry will be re-searched '
             endif
          endif

          ! --- sw_supercell_symmetry ---
          if(f_getIntValue( tag_sw_supercell_symmetry, iret) == 0) sw_supercell_symmetry = iret
          if(ipriinputfile >= 1 .and. printable) then
             write(nfout,'(" !** sw_supercell_symmetry = ",i6)') sw_supercell_symmetry
          end if
             
          if( f_getIntValue( tag_sw_allow_mag_sym_inversion,iret)==0 ) then
             sw_allow_mag_sym_inversion = iret
             write(nfout,*) '!** sw_allow_mag_sym_inversion is set to ', iret
          endif
          if( f_getIntValue( tag_sw_allow_improper_rotation,iret)==0 ) then
             sw_allow_improper_rotation = iret
             write(nfout,*) '!** sw_allow_improper_rotation is set to ', iret
          endif
          if( f_getIntValue( tag_sw_allow_frac_translation,iret)==0 ) then
             sw_allow_frac_translation = iret
             write(nfout,*) '!** sw_allow_frac_translation is set to ', iret
          endif
#if 1
          if ( .not. noncol ) then
             sw_use_magnetic_symmetry = off
             if( f_getIntValue( tag_sw_use_magnetic_symmetry,iret)==0 ) then
                sw_use_magnetic_symmetry = iret
                write(nfout,*) '!** sw_use_magnetic_symmetry is set to ', iret
             endif
             if ( imag==FERRO .and. sw_spinorbit_second_variation==ON ) then
                sw_use_magnetic_symmetry = ON
             endif
          endif
#endif
          ! --- tspace ---
          if( f_selectBlock( tag_tspace) == 0) then
             if(ipriinputfile >= 1 .and. printable) write(nfout,'(" !*  tag_tspace is found")')
             call set_lattice_system()  ! -> il
             number_is_given = f_getIntValue( tag_num_generators, iret) == 0
             if(number_is_given) then
                ngen = iret
                if( ngen >= 4 .or. ngen <= 0) then
                   if(ipriinputfile >= 0 .and. printable) &
                        & write(nfout,'(" !* <ngen> given is not proper, so it is redefined to be 1")')
                   ngen = 1
                end if
             end if
             ! --- generators ---
             prealloc = .true.
             !   --- count generators
             call set_igen_jgen(prealloc,iret)
             if(iret < 0) call phase_error_with_msg(nfout, ' symmetry operation generators are not given properly <<m_CS_rd_n>>'&
                                                         , __LINE__, __FILE__)
             if(.not.number_is_given) ngen = iret
             if(number_is_given .and. ngen > iret) ngen = iret
             if(ngen > 3) call phase_error_with_msg(nfout, ' number of operation generators should be smaller than 4 <<m_CS_rd_n>>'&
                                                         , __LINE__, __FILE__)
                if(ipriinputfile >= 1 .and. printable) write(nfout,'(" !** ngen = ",i5," <<m_CS_rd_n>>")') ngen
             !   --- allocate and set generatos for supercell
             call alloc_igen_jgen()
             prealloc = .false.
             call set_igen_jgen(prealloc,iret)  ! -> igen, jgen
             if(imag==ANTIFERRO) call set_iaf_jaf(iret)  ! -> iaf, jaf

             if(sw_supercell_symmetry == ON) then
                ! --- additional translation operators ---
                prealloc = .true.
                !   --- count additional translation vectors ---
                call set_jgen_tl(prealloc,iret)
                if(iret < 0) call phase_error_with_msg(nfout, &
                             ' symmetry operation generators for sc are not given properly <<m_CS_rd_n>>' &
                             , __LINE__, __FILE__)
                ngen_tl = iret
                if(ipriinputfile>=1.and.printable) write(nfout,'(" !** ngen_tl = ",i5," <<m_CS_rd_n>>")') ngen_tl
                !   --- allocate and set additional translations for supercell
                call alloc_jgen_tl()
                prealloc = .false.
                call set_jgen_tl(prealloc,iret)  ! -> jgen_tl
             end if

! =================================== added by K. Tagami ==================== 12.0A
             if (symmetry_method == AUTOMATIC .and. il>=1 ) then
                gen_name_in_carts = .true.
                if(printable)then
                write(nfout,*) '** ** ** ** ** ** **'
                write(nfout,*) '* Generators are assumed to be in Cartesian system'
                write(nfout,*) '** ** ** ** ** ** **'
                endif
             else
                if ( f_getIntValue( tag_gen_name_in_carts, iret) == 0 ) then
                   if ( iret == YES ) then
                      gen_name_in_carts = .true.
                      if(printable)then
                      write(nfout,*) '** ** ** ** ** ** **'
                      write(nfout,*) '* Generators are assumed to be in Cartesian system'
                      write(nfout,*) '** ** ** ** ** ** **'
                      endif
                   else
                      if(printable)then
                      write(nfout,*) '** ** ** ** ** ** **'
                      write(nfout,*) '* Generators are assumed to be in Bravais system'
                      write(nfout,*) '** ** ** ** ** ** **'
                      endif
                   endif
                endif
             endif
!
             if ( f_getIntValue( tag_use_altv_rltv, iret) == 0 ) then
                if ( iret == YES ) then
                   use_altv_rltv = .true.
                   if(printable)then
                   write(nfout,*) '** use_altv_rltv is set to ', use_altv_rltv
                   write(nfout,*) '** ** ** ** ** ** **'
                   endif
                else
                   if(printable)then
                   write(nfout,*) '** use_altv_rltv is set to .false. '
                   write(nfout,*) '** ** ** ** ** ** **'
                   endif
                endif
             endif
! =========================================================================== 12.0A

             iret = f_selectParentBlock()

          else
             call set_crystal_structure()  ! -> nbztyp_spg
             call m_CS_set_default_symm_op(nfout) ! -> igen, jgen
          end if
          iret = f_selectParentBlock()
       else !!! K.Mae 040121
          call set_crystal_structure()
          call m_CS_set_default_symm_op(nfout) 
       end if

       if(ipriinputfile >= 1 .and. printable) then
          write(nfout,'(" !** il = ",i0, 3x, a)') il, Char_lattice_system(il)
       end if

       ! --- strain
       if( f_selectBlock( tag_strain) == 0) then
          call set_strain_tensor()
          if(ipriinputfile >= 1 .and. printable) then
             write(nfout,'(" !** Strain tensor <<m_CS_rd_n>>")')
             write(nfout,'(" !**      [",3(1x,f10.5)," ]")') strain(1,1:3)
             write(nfout,'(" !**  e = [",3(1x,f10.5)," ]")') strain(2,1:3)
             write(nfout,'(" !**      [",3(1x,f10.5)," ]")') strain(3,1:3)
          end if
          if( f_getIntValue( tag_sw_strained_cell, iret) == 0) sw_strained_cell = iret
          iret = f_selectParentBlock()
       end if

       ! supercell
       if( f_selectBlock( tag_supercell) == 0) then
          if( f_getIntValue( tag_sw_supercell, iret) == 0) sw_supercell = iret
          ! --- unit_cell ---
          iret = f_getStringValue(tag_unit_cell_type,rstr, LOWER)
          if( rstr == val_primitive ) then
             supercell_unit_type = PRIMITIVE ! 1
          else
             supercell_unit_type = BRAVAIS   ! 0
          end if
          if( f_selectBlock( tag_size) == 0) then
             if( f_getIntValue( tag_n1, iret) == 0) n1_sc = iret
             if( f_getIntValue( tag_n2, iret) == 0) n2_sc = iret
             if( f_getIntValue( tag_n3, iret) == 0) n3_sc = iret
             iret = f_selectParentBlock()
          end if
          iret = f_selectParentBlock()
       end if

       ! --- unit_cell ---
       iret = f_getStringValue(tag_unit_cell_type,rstr, LOWER)
       if( rstr == val_primitive ) then
          iuctype = PRIMITIVE ! 1
       else
          iuctype = BRAVAIS   ! 0
       end if
! ================================ Added by K. Tagami ===============
       kt_iuctype = iuctype
! ==================================================================
       if(ipriinputfile >= 1 .and. printable) then
          if(iret == 0) then
             write(nfout,'(" !** unit_cell_type = ",i6," [",a,"] <<m_CS_rd_n>>")') iuctype, trim(rstr)
          else
             write(nfout,'(" !** unit_cell_type is not given")')
          end if
       end if
       ! peek lattice_system
       hext = .false.
       if(f_selectBlock(tag_symmetry)==0) then
          if(f_selectBlock(tag_tspace)==0) then
            if(f_getStringValue('lattice_system',rstr,LOWER)==0) then
              if(rstr==tag_hexagonal .or. rstr==tag_hcp .or. &
              &  rstr==tag_trigonal  .or. rstr==tag_rhombohedral) hext = .true.
            endif
            iret = f_selectParentBlock()
          endif
          iret = f_selectParentBlock()
       endif
       if(f_getRealValue(tag_unit_cell_scale,dret,'bohr')==0) then
          unit_cell_scale = dret
          if(printable) write(nfout,'(a,f10.5)') ' !** unit_cell_scale : ',unit_cell_scale
       endif
       if( f_selectBlock( tag_unit_cell) == 0) then
          allocate(avec(1:3)); allocate(bvec(1:3)); allocate(cvec(1:3))
          iret = f_readUnitCell(avec,bvec,cvec,a,b,c,ca,cb,cc,ucinptype,'Bohr' &
               & ,tag_avector,tag_bvector,tag_cvector,tag_a,tag_b,tag_c &
               & ,tag_alpha,tag_beta,tag_gamma,unit_cell_scale,hext,printable)
          if(ipriinputfile >= 1 .and. printable) then
             if(iret == 0) then
                write(nfout,'(" !** a,b,c,ca,cb,cc = ",6f12.6," <<m_CS_rd_n>>")') a,b,c,ca,cb,cc
                write(nfout,'(" !** avec = ",3f12.6)') avec(1:3)
                write(nfout,'(" !** bvec = ",3f12.6)') bvec(1:3)
                write(nfout,'(" !** cvec = ",3f12.6)') cvec(1:3)
                write(nfout,'(" !** ucinptype = ",i6)') ucinptype
             else
                write(nfout,'(" !** iret /= 0: iret = ",i6)') iret
             end if
          end if
!!!!
          call m_CS_gnrt_tmatrices(il)

          if ( sw_strained_cell == OFF ) then
             if(is_hexagonal(a,b,ca,cb,cc).and. il==1 .and. symmetry_method == AUTOMATIC) then
                if(printable) then
                   write(nfout,'(" !** lattice_system is converted to hexagonal")')
                endif
                il = 0
             endif
          endif

          if (iuctype == BRAVAIS) then ! Bravais: 0
!             if (ucinptype == 0) then ! length: 0
                call bravais2primitive(nfout,b2pmat,a,b,c,ca,cb,cc,avec,bvec,cvec,il) ! in b_CS

                if ( icond /= COORDINATE_CONTINUATION ) then
                   if(ipriinputfile >= 1 .and. printable) then
                      write(nfout,*) '!** primitive unit cell vectors are given as'
                      write(nfout,'(" !** avec = ",3f12.6)') avec(1:3)
                      write(nfout,'(" !** bvec = ",3f12.6)') bvec(1:3)
                      write(nfout,'(" !** cvec = ",3f12.6)') cvec(1:3)
                   end if
                endif

             else                ! Primitive
                if  (ucinptype == 0) then ! length: 0
                   !if(printable) write(nfout,*) 'You must give a lattice system by the Vector expression for the primitive cell.'
                   call phase_error_with_msg(nfout, &
                   'You must give a lattice system by the Vector expression for the primitive cell.', &
                   __LINE__, __FILE__) 
                end if
                call primitive2bravais(nfout,p2bmat,avec,bvec,cvec,a,b,c,ca,cb,cc,il) ! in b_CS
!             end if
          end if
          if(sw_strained_cell == ON) then
             call set_strained_cell(avec,bvec,cvec)
             if(ipriinputfile >= 1 .and. printable) then
                write(nfout,'(" !** << Strained cell >>")')
                write(nfout,'(" !** avec = ",3f12.6)') avec(1:3)
                write(nfout,'(" !** bvec = ",3f12.6)') bvec(1:3)
                write(nfout,'(" !** cvec = ",3f12.6)') cvec(1:3)
             end if
             call primitive2bravais(nfout,p2bmat,avec,bvec,cvec,a,b,c,ca,cb,cc,il) ! in b_CS
          end if
          if(sw_supercell == ON) then
             if(ipriinputfile >= 1 .and. printable) then
                write(nfout,'(" !** << supercell >>")')
                write(nfout,'(" !** unit_cell_type =",i5)') supercell_unit_type
                write(nfout,'(" !** n1,n2,n3 = ",3i5)') n1_sc,n2_sc,n3_sc
             end if
          end if
!!!!
          altv(1:3,1) = avec(1:3); altv(1:3,2) = bvec(1:3); altv(1:3,3) = cvec(1:3)
          deallocate(avec); deallocate(bvec); deallocate(cvec)
          call altv_2_rltv(altv,rltv,univol,rvol)  ! in b_CS
#ifdef ENABLE_ESM_PACK
          if(sw_esm==ON .and. esm_z1_defined)then
             esm_w = esm_z1-altv(3,3)*0.5d0
          endif
#endif
          iret = f_selectParentBlock()
       else
          if(ipriinputfile >= 1 .and. printable) write(nfout,'(" !* tag_unit_cell is not found")')
       end if

! === KT 2018/03/07
       if ( symmetry_method == AUTOMATIC .and. il == 1 ) then
          if ( ucinptype == 1 ) then
             use_altv_rltv = .true.
             write(nfout,*) '** use_altv_rltv is turned to ', use_altv_rltv
          endif
       endif
! === KT 2018/03/07

!  ---- refcell for band-unfolding---- 2016/04/14AS
       if( f_selectBlock( tag_reference_cell) == 0) then
          iret = f_getStringValue(tag_unit_cell_type,rstr, LOWER)
          if( rstr == val_bravais ) then
             refcell_unit_type = BRAVAIS   ! 0
          else
             refcell_unit_type = PRIMITIVE ! 1
          end if

          allocate(avec(1:3)); allocate(bvec(1:3)); allocate(cvec(1:3))

!          iret = f_readUnitCell(avec,bvec,cvec,a,b,c,ca,cb,cc,ucinptype,'Bohr' &
!               & ,tag_avector,tag_bvector,tag_cvector,tag_a,tag_b,tag_c &
!               & ,tag_alpha,tag_beta,tag_gamma,printable)
          iret = f_readUnitCell(avec,bvec,cvec,a,b,c,ca,cb,cc,ucinptype,'Bohr' &
               & ,tag_avector,tag_bvector,tag_cvector,tag_a,tag_b,tag_c &
               & ,tag_alpha,tag_beta,tag_gamma,unit_cell_scale,hext,printable)

          if ( refcell_unit_type == BRAVAIS ) then
             tmpmat = 0.0d0
             tmpmat(1,1) = 1.0d0;  tmpmat(2,2) = 1.0d0;  tmpmat(3,3) = 1.0d0
             call bravais2primitive( nfout, tmpmat, a, b, c, ca, cb, cc, &
                  &                  avec, bvec, cvec, 1 )
          endif
          altv_refcell(1:3,1) = avec(1:3);
          altv_refcell(1:3,2) = bvec(1:3);
          altv_refcell(1:3,3) = cvec(1:3)

          deallocate(avec); deallocate(bvec); deallocate(cvec)
          call altv_2_rltv(altv_refcell,rltv_refcell,univol_refcell,rvol_refcell)

          iret = f_selectParentBlock()
       else
          altv_refcell = altv;   rltv_refcell = rltv;
          univol_refcell = univol;  rvol_refcell = rvol
       endif
! --------------------------------- 2016/04/14AS

       iret = f_selectParentBlock()
    else
       if(ipriinputfile >= 1 .and. printable) write(nfout,'(" !* tag_structure is not found")')
    end if

    if ( icond /= COORDINATE_CONTINUATION ) then
       if(ipriinputfile >= 1 .and. printable) then
          write(nfout,'(" !** univol = ",f20.12," <<m_CS_rd_n>>")') univol
       end if
    endif

  contains
    subroutine set_symmetry_method(symmetry_method)
      integer, intent(inout) :: symmetry_method
      integer :: iret
      logical :: tf
      iret = f_getStringValue( tag_method, rstr,LOWER)
      if(iret == 0) then
         if(ipriinputfile >= 1 .and. printable) write(nfout,'(" !*  tag_method is found")')
         call strncmp0(trim(rstr),tag_automatic,tf)
         if(tf) then
            symmetry_method = AUTOMATIC
            goto 1001
         end if
         call strncmp0(trim(rstr),tag_manual,tf)
         if(tf) then
            symmetry_method = MANUAL
            goto 1001
         end if
      end if
1001  continue
    end subroutine set_symmetry_method

    subroutine set_crystal_structure()
      integer :: iret
      logical :: tf
      nbztyp_spg = 0
      iret = f_getStringValue( tag_crystal_structure, rstr,LOWER)
      if(iret /= 0) iret = f_getStringValue( tag_crystal, rstr,LOWER)
      if(iret == 0) then
         if(ipriinputfile >= 1 .and. printable) write(nfout,'(" !*  tag_crystal is found")')
         call strncmp0(trim(rstr),tag_trigonal,tf)
         if(tf) then
            nbztyp_spg = TRIGONAL
            goto 1001
         end if
         call strncmp0(trim(rstr),tag_hexagonal,tf)
         if(tf) then
            nbztyp_spg = HEXAGONAL
            goto 1001
         end if
         call strncmp0(trim(rstr),tag_hcp,tf)
         if(tf) then
            nbztyp_spg = HCP
            goto 1001
         end if
         call strncmp0(trim(rstr),tag_simple_cubic,tf)
         if(tf) then
            nbztyp_spg = SIMPLE_CUBIC
            goto 1001
         end if
         call strncmp0(trim(rstr),tag_diamond, tf)
         if(tf) then
            nbztyp_spg = DIAMOND
            goto 1001
         end if

         call strncmp0(trim(rstr),tag_facecentered, tf)
         if(.not.tf) call strncmp0(trim(rstr),tag_fcc, tf)
         if(tf) then
            nbztyp_spg = FCC
            goto 1001
         end if

         call strncmp0(trim(rstr),tag_bodycentered,  tf)
         if(.not.tf) call strncmp0(trim(rstr),tag_bcc, tf)
         if(tf) then
            nbztyp_spg = BCC
            goto 1001
         end if
      end if
1001  continue
    end subroutine set_crystal_structure
         
    subroutine set_imag(rstr)
      character(len=FMAXVALLEN),intent(in) :: rstr
      logical :: tf
      call strncmp2(rstr, FMAXVALLEN, tag_para, len(tag_para), tf)
      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, tag_nonmagnetic,len(tag_nonmagnetic),tf)
      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, tag_nonmag, len(tag_nonmag),tf)
      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, tag_none,   len(tag_nonmag),tf)
!!$      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, '1', 1, tf)
      if(tf) then
         imag = NONMAG
         goto 1001
      end if
      call strncmp2(rstr, FMAXVALLEN, tag_af, len(tag_af), tf)
      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, tag_antiferro ,len(tag_antiferro), tf)
!!$      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, '-2', 2, tf)
      if(tf) then
         imag = ANTIFERRO
         goto 1001
      end if
      call strncmp2(rstr, FMAXVALLEN, tag_ferro, len(tag_ferro), tf)
      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, tag_magnetic, len(tag_magnetic),tf)
      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, tag_mag, len(tag_mag),tf)
!!$      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, '2', 1, tf)
      if(tf) then
         imag = FERRO
         goto 1001
      end if

! =========================== added by K. Tagami ================= 11.0
      call strncmp2(rstr, FMAXVALLEN, tag_noncollinear, len(tag_noncollinear), tf)
      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, tag_noncol, len(tag_noncol), tf)
!!$      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, '4', 1, tf)
      if(tf) then
         imag = NONCOLLINEAR
         goto 1001
      end if
! ================================================================ 11.0

1001  continue
      if(.not.(imag == NONMAG .or. imag == ANTIFERRO .or. imag == FERRO)) then
         if(printable) then
            write(nfout,'("!ERROR A setting in the inputfile as (( magnetic_state = ",a10," )) is not proper.")') rstr
            write(nfout,'("!ERROR  The value must be nonmag (=para), magnetic (=ferro), or antiferro for phae/0 3D version.")')
         end if
         call phase_error_with_msg(nfout,'(!** nspin is not given properly in the inputfile' &
              & ,__LINE__,__FILE__)
      end if
    end subroutine set_imag

    subroutine set_imag_from_nspin(iret)
      ! Coded by T. Yamasaki, 16th June 2023
      integer,intent(in) :: iret
      logical :: tf
      if(iret==1) then
         imag = NONMAG
      else if(iret==2) then
         imag = FERRO
      else if(iret==-2) then
         imag = ANTIFERRO
      else if(iret==4) then
         imag = NONCOLLINEAR
      else
      end if
      if(.not.(iret==1 .or. iret==2 .or. iret==-2)) then
         if(printable) then
            write(nfout,'("!ERROR A setting in the inputfile as (( nspin = ", i4, " )) is not proper.")') iret
            write(nfout,'("!ERROR  The value must be 1, 2, or -2 for phase/0 3D version")')
         end if
         call phase_error_with_msg(nfout,'(!** nspin is not given properly in the inputfile' &
              & ,__LINE__,__FILE__)
      end if
    end subroutine set_imag_from_nspin

    subroutine set_spin_fix_period(rstr)
      ! Coded by T. Yamasaki, 06th Aug. 2009
      character(len=FMAXVALLEN),intent(in) :: rstr
      logical :: tf
      call strncmp2(rstr, FMAXVALLEN, tag_whole, len(tag_whole), tf)
      if(tf) then
         spin_fix_period = WHOLE
         goto 1001
      end if
      call strncmp2(rstr, FMAXVALLEN, tag_initially, len(tag_initially), tf)
      if(tf) then
         spin_fix_period = INITIALLY
         goto 1001
      end if
1001  continue
    end subroutine set_spin_fix_period

! =========================== Added by K. Tagami =============== 11.0
    subroutine set_sw_magnetic_symmetry

      sw_use_magnetic_symmetry = OFF
      if ( sw_reduce_sym_by_magmom == ON .or. sw_reduce_sym_by_orbital == ON ) then
         sw_use_magnetic_symmetry = ON
      endif

    end subroutine set_sw_magnetic_symmetry

    subroutine set_sw_reduce_sym_by_magmom
      logical :: tf

      tf = ( f_getIntValue( tag_reduce_sym_by_magmom, iret ) == 0 )
      if (tf) then
         if ( iret == ON ) then
            sw_reduce_sym_by_magmom = ON
            write(nfout,*) '**** sw_reduce_sym_by_magmom is set ON'
         else
            sw_reduce_sym_by_magmom = OFF
            write(nfout,*) '**** sw_reduce_sym_by_magmom is set OFF'
         endif
      else
         write(nfout,*) '**** sw_reduce_sym_by_magmom is set to default, ON'
      endif

    end subroutine set_sw_reduce_sym_by_magmom

    subroutine set_sw_reduce_sym_by_orbital
      logical :: tf

      tf = ( f_getIntValue( tag_reduce_sym_by_orbital, iret ) == 0 )
      if (tf) then
         if ( iret == ON ) then
            sw_reduce_sym_by_orbital = ON
            write(nfout,*) '**** sw_reduce_sym_by_orbital is set ON'
         else
            sw_reduce_sym_by_orbital = OFF
            write(nfout,*) '**** sw_reduce_sym_by_orbital is set OFF'
         endif
      else
         write(nfout,*) '**** sw_reduce_sym_by_orbital is set to default, OFF'
      endif

    end subroutine set_sw_reduce_sym_by_orbital

! ==== KT_add === 2014/08/09 & 13.2S
    subroutine set_magnetic_restriction
      if ( (.not. noncol) .and. (sw_use_magnetic_symmetry == ON) ) then
         sw_fix_global_quantz_axis = on

         if ( f_selectBlock( tag_magnetic_restriction ) == 0 ) then
            call set_global_quantz_axis
            iret = f_selectParentBlock()
         endif
      else
         if ( f_selectBlock( tag_magnetic_restriction ) == 0 ) then
            if ( f_getIntValue( tag_sw_fix_global_quantz_axis, iret ) == 0 ) then
               sw_fix_global_quantz_axis = iret
            endif
            if ( sw_fix_global_quantz_axis == ON ) call set_global_quantz_axis
            iret = f_selectParentBlock()
         endif
      endif
    end subroutine set_magnetic_restriction

    subroutine set_global_quantz_axis
      integer :: Flag
      Real(kind=DP) :: mdx, mdy, mdz, cnorm
      Real(kind=DP) :: ctmp, theta, phi

      Flag = 0
      mdx = 0.0d0; mdy = 0.0d0; mdz = 0.0d0
      theta = 0.0d0;   phi = 0.0d0

      Global_Quantz_Axis_Fixed(1) = 0.0d0
      Global_Quantz_Axis_Fixed(2) = 0.0d0
      Global_Quantz_Axis_Fixed(3) = 1.0d0

      if ( f_selectBlock( tag_global_quantz_axis ) == 0 ) then
         if( f_getRealValue( tag_sx, dret, '') == 0 ) then
            mdx = dret;   Flag = 1
         endif
         if( f_getRealValue( tag_sy, dret, '') == 0 ) then
            mdy = dret;   Flag = 1
         endif
         if( f_getRealValue( tag_sz, dret, '') == 0 ) then
            mdz = dret;   Flag = 1
         endif
         cnorm = sqrt( mdx**2 + mdy**2 + mdz**2 )

         if ( abs(cnorm) > 1.0E-4 ) then
            Global_Quantz_Axis_Fixed(1) = mdx / cnorm;
            Global_Quantz_Axis_Fixed(2) = mdy / cnorm;
            Global_Quantz_Axis_Fixed(3) = mdz / cnorm;
         endif
         !
         if ( Flag == 0 ) then
            if ( f_getRealValue( tag_theta, dret, "" ) == 0 ) then
               theta = dret
            end if
            if ( f_getRealValue( tag_phi, dret, "" ) == 0 ) then
               phi = dret
            end if

            theta  = theta / 180.0d0 *PAI
            phi  =  phi / 180.0d0 *PAI
!
            Global_Quantz_Axis_Fixed(1) = sin( theta ) *cos( phi )
            Global_Quantz_Axis_Fixed(2) = sin( theta ) *sin( phi )
            Global_Quantz_Axis_Fixed(3) = cos( theta )
         endif

         iret = f_selectParentBlock()
      endif
!
      write(nfout,*) '!************* Magnetic Restriction ************'
      write(nfout,'(A,F10.5,A,F10.5,A,F10.5)' ) &
           &             '!** global axis : sx = ', Global_Quantz_Axis_Fixed(1), &
           &             ' sy = ', Global_Quantz_Axis_Fixed(2), &
           &             ' sz = ', Global_Quantz_Axis_Fixed(3)

    end subroutine set_global_quantz_axis
! ============== 2014/08/09 & 13.2S

    subroutine set_sw_constrain_on_grad_corr
      logical :: tf

      tf = ( f_getIntValue( tag_constrain_on_grad_corr, iret ) == 0 )
      if (tf) then
         if ( iret == ON ) then
            sw_constrain_on_grad_correction = ON
            write(nfout,*) '**** sw_constrain_on_grad_correction is set ON'
         else
            sw_constrain_on_grad_correction = OFF
            write(nfout,*) '**** sw_constrain_on_grad_correction is set OFF'
         endif
      else
         write(nfout,*) '**** sw_constrain_on_grad_correction is set to default, OFF'
      endif

! === KT_add == 2014/08/09
      if ( sw_fix_global_quantz_axis == ON ) then
         sw_constrain_on_grad_correction = ON
         write(nfout,*) '**** sw_constrain_on_grad_correction is turned ON'
      endif
! ============== 2014/08/09

    end subroutine set_sw_constrain_on_grad_corr

    subroutine set_level_projection_paw_charge
      logical :: tf

      tf = ( f_getIntValue( tag_level_projection_paw_charge, iret ) == 0 )

      if (tf) then
         level_of_projection_paw_charge = iret

         if ( iret > 0 .and. iret < 4 ) then
            write(nfout,*) '**** level_of_projection_paw_charge is set to ', iret
         else
            level_of_projection_paw_charge = 1
            write(nfout,*) '**** level_of_projection_paw_charge is set to ', 1
         endif

      else
         write(nfout,*) '**** level_of_projection_paw_charge is set to default', 1
      endif

    end subroutine set_level_projection_paw_charge
! =============================================================== 11.0

! ==== KT_add ==== 2014/08/04
    subroutine set_threshold_lowering_contami        ! in case of GGA+noncl
      if ( f_getIntValue( tag_sw_neglect_low_vorticity, iret ) == 0 ) then
         sw_neglect_low_vorticity = iret
      endif
      if ( f_getIntValue( tag_sw_neglect_low_helicity, iret ) == 0 ) then
         sw_neglect_low_helicity = iret
      endif

      if ( sw_neglect_low_vorticity == ON .and. sw_neglect_low_helicity == ON ) then
         call phase_error_with_msg(nfout, "Select either sw_neglect_low_vorticity or sw_neglect_low_helicty" &
                                        , __LINE__, __FILE__)
      endif
!
      if ( sw_neglect_low_vorticity == ON ) then
         sw_monitor_magnetic_vorticity = ON
         if ( f_getRealValue( tag_threshold_vorticity, dret, '' ) == 0 ) then
            threshold_vorticity = dret
         endif
         write(nfout,*) '!** sw_neglect_low_vorticity is ', sw_neglect_low_vorticity
         write(nfout,*) '!** threshold_vorticity is ', threshold_vorticity
      endif
      if ( sw_neglect_low_helicity == ON ) then
         sw_monitor_magnetic_vorticity = ON
         if ( f_getRealValue( tag_threshold_helicity, dret, '' ) == 0 ) then
            threshold_helicity = dret
         endif
         write(nfout,*) '!** sw_neglect_low_helicity is ', sw_neglect_low_helicity
         write(nfout,*) '!** threshold_helicity is ', threshold_helicity
      endif
!
    end subroutine set_threshold_lowering_contami
! ================ 2014/08/04

! ==== KT_add === 2014/09/26
    subroutine set_sw_neglect_magmom
      if ( f_getIntValue( tag_sw_neglect_magmom, iret ) == 0 ) then
         sw_neglect_magmom = iret
      endif
      write(nfout,*) '!** sw_neglect_magmom is ', sw_neglect_magmom
    end subroutine set_sw_neglect_magmom
! =============== 2014/09/26

! ================================= KT_add =================== 11.0&13.0U
    subroutine set_magnetic_constraint
      logical :: tf
!
      if ( f_getStringValue( tag_constraint_type,rstr,LOWER ) == 0 ) then

         call strncmp0( tag_moment_vals_global, trim(rstr), tf )
         if ( tf ) mag_constraint_type = MAG_MOMENT_VALS_GLOBAL

         call strncmp0( tag_moment_direc_global, trim(rstr), tf )
         if ( tf ) mag_constraint_type = MAG_MOMENT_DIREC_GLOBAL

         call strncmp0( tag_moment_vals_local, trim(rstr), tf )
         if ( tf ) mag_constraint_type = MAG_MOMENT_VALS_LOCAL

         call strncmp0( tag_moment_direc_local, trim(rstr), tf )
         if ( tf ) mag_constraint_type = MAG_MOMENT_DIREC_LOCAL

         call strncmp0( tag_moment_vals_occmat, trim(rstr), tf )
         if ( tf ) mag_constraint_type = MAG_MOMENT_VALS_OCCMAT

         call strncmp0( tag_moment_direc_hardpart, trim(rstr), tf )
         if ( tf ) mag_constraint_type = MAG_MOMENT_DIREC_HARDPART

      endif

      write(nfout,*) '!**************************************************'

      if ( mag_constraint_type == MAG_MOMENT_VALS_GLOBAL ) then
         call set_mag_constraint_type1;    sw_magnetic_constraint = ON
         write(nfout,*) '!*** Magnetic constraint type : MOMENT_VALS_GLOBAL'

      else if ( mag_constraint_type == MAG_MOMENT_DIREC_GLOBAL ) then
         call set_mag_constraint_type2;    sw_magnetic_constraint = ON
         write(nfout,*) '!*** Magnetic constraint type : MOMENT_DIREC_GLOBAL'

      else if ( mag_constraint_type == MAG_MOMENT_VALS_LOCAL ) then
         sw_magnetic_constraint = ON
         write(nfout,*) '!*** Magnetic constraint type : MOMENT_VALS_LOCAL'

      else if ( mag_constraint_type == MAG_MOMENT_DIREC_LOCAL ) then
         sw_magnetic_constraint = ON
         write(nfout,*) '!*** Magnetic constraint type : MOMENT_DIREC_LOCAL'

      else if ( mag_constraint_type == MAG_MOMENT_DIREC_HARDPART ) then
         sw_magnetic_constraint = ON
         write(nfout,*) '!*** Magnetic constraint type : MOMENT_DIREC_HARDPART'

      else if ( mag_constraint_type == MAG_MOMENT_VALS_OCCMAT ) then
         if ( num_projectors > 0 ) then
            sw_magnetic_constraint = ON
            write(nfout,*) '!*** Magnetic constraint type : MOMENT_VALS_OCCMAT'
         else
            write(nfout,*) '!!!! ---- This constraint requires projectors'
         endif

      endif

! ------------
      if ( sw_magnetic_constraint == OFF ) then
         write(nfout,*) '! mag_constraint is not set '; return
      endif
! ------------

      if ( f_getRealValue( tag_lambda,dret,"hartree" ) == 0 ) then
         mag_constraint_lambda = dret
      end if

      if ( f_getStringValue( tag_damping_method, rstr,LOWER ) == 0 ) then
         call strncmp0( tag_damp_abrupt, trim(rstr), tf )
         if ( tf ) damping_method_mag_constraint = ABRUPT

         call strncmp0( tag_damp_stepwize, trim(rstr), tf )
         if ( tf ) damping_method_mag_constraint = STEPWISE

         call strncmp0( tag_damp_linear, trim(rstr), tf )
         if ( tf ) damping_method_mag_constraint = LINEAR
      endif

      if ( damping_method_mag_constraint == STEPWISE ) then
         if ( f_getIntValue( tag_num_intermid_lambda, iret ) == 0 ) then
            if ( iret < 0 ) num_intermid_lambda = 0
            if ( iret > nmax_intermid_lambda ) num_intermid_lambda = nmax_intermid_lambda
            num_intermid_lambda = iret
         endif

         if ( f_getRealValue( tag_edelta_change_lambda_first,dret,"hartree" )==0 ) then
            edelta_change_lambda_first = dret
         endif
         if ( f_getRealValue( tag_edelta_change_lambda_last,dret,"hartree" )==0 ) then
            edelta_change_lambda_last = dret
         endif
         if ( num_intermid_lambda == 0 ) then
            edelta_change_lambda_last = edelta_change_lambda_first
         endif
      endif

      if ( damping_method_mag_constraint == ABRUPT .or. &
           &  damping_method_mag_constraint == LINEAR ) then

         if ( f_getIntValue( tag_max_iter_elec_mag_constr, iret ) == 0 ) then
            if ( iret < 0 ) max_iter_elec_mag_constraint = 0
            max_iter_elec_mag_constraint = iret
         endif
      endif

      write(nfout,*) '! mag_constraint_lambda is set to ', &
           &            mag_constraint_lambda
      write(nfout,*) '! damping_method is set to ', &
           &            damping_method_mag_constraint

      if ( damping_method_mag_constraint == STEPWISE ) then
         write(nfout,*) '! number_of_intermidiate lambda is ', num_intermid_lambda
         write(nfout,*) '! edelta_change_lambda_first is ', edelta_change_lambda_first
         write(nfout,*) '! edelta_change_lambda_last  is ', edelta_change_lambda_last
      endif

      if ( damping_method_mag_constraint == ABRUPT .or. &
           &  damping_method_mag_constraint == LINEAR ) then
         write(nfout,*) '! max_iter_elec_mag_constraint is ', &
              &            max_iter_elec_mag_constraint
      endif

      if ( f_getIntValue( tag_max_iter_ion_mag_constr, iret ) == 0 ) then
         if ( iret < 0 ) max_iter_ion_mag_constraint = 0
         max_iter_ion_mag_constraint = iret
      endif
      if ( f_getIntValue( tag_max_iter_cell_mag_constr, iret ) == 0 ) then
         if ( iret < 0 ) max_iter_cell_mag_constraint = 0
         max_iter_cell_mag_constraint = iret
      endif

      if ( f_getIntValue( tag_sw_fix_charge_after_constr, iret ) == 0 ) then
         sw_fix_charge_after_constraint = iret
         write(nfout,*) '! sw_fix_charge_after_constraint is ', &
              &             sw_fix_charge_after_constraint
      endif

      write(nfout,*) '! max_iter_ion_mag_constraint is ', max_iter_ion_mag_constraint
      write(nfout,*) '! max_iter_cell_mag_constraint is ', max_iter_cell_mag_constraint

      write(nfout,*) '! *********************************************** '

    end subroutine set_magnetic_constraint

!--
    subroutine set_mag_constraint_type1
      integer :: Flag
      Real(kind=DP) :: mx, my, mz, cnorm
      Real(kind=DP) :: ctmp, theta, phi

      Flag = 0
      mx = 0.0d0; my = 0.0d0; mz = 0.0d0
      theta = 0.0d0;   phi = 0.0d0

      mag_moment0_global = 0.0d0

      if ( f_selectBlock( tag_magnetic_moment ) == 0 ) then

         if ( noncol ) then
            if( f_getRealValue( tag_mx, dret, '') == 0 ) then
               mx = dret;   Flag = 1
            endif
            if( f_getRealValue( tag_my, dret, '') == 0 ) then
               my = dret;   Flag = 1
            endif
            if( f_getRealValue( tag_mz, dret, '') == 0 ) then
               mz = dret;   Flag = 1
            endif

            mag_moment0_global(1) = mx
            mag_moment0_global(2) = my
            mag_moment0_global(3) = mz
            norm = sqrt( mx**2 + my**2 +mz**2 )
         !
            if ( Flag == 0 ) then
               if ( f_getRealValue( tag_norm, dret, "" ) == 0 ) then
                  norm = dret
               end if
               if ( f_getRealValue( tag_moment, dret, "" ) == 0 ) then
                  norm = dret
               end if
               if ( f_getRealValue( tag_theta, dret, "" ) == 0 ) then
                  theta = dret
               end if
               if ( f_getRealValue( tag_phi, dret, "" ) == 0 ) then
                  phi = dret
               end if

               theta  = theta / 180.0d0 *PAI
               phi  =  phi / 180.0d0 *PAI
!
               mag_moment0_global(1) = norm *sin( theta ) *cos( phi )
               mag_moment0_global(2) = norm *sin( theta ) *sin( phi )
               mag_moment0_global(3) = norm *cos( theta )
            endif

         else
            if ( f_getRealValue( tag_norm, dret, "" ) == 0 ) then
               norm = dret;   mag_moment0_global(1) = norm
            end if
            if ( f_getRealValue( tag_moment, dret, "" ) == 0 ) then
               norm = dret;   mag_moment0_global(1) = norm
            end if

         endif

         iret = f_selectParentBlock()
      endif
!
      write(nfout,*) '!************* Magnetic constraint : type 1 ************'
      write(nfout,'(A,F10.5)') '!** magnetic moment is wanted to reach ', norm

      if ( noncol ) then
         write(nfout,'(A,F10.5,A,F10.5,A,F10.5)' ) &
              &             '!** The xyz component is mx =', mag_moment0_global(1), &
              &               ' my = ', mag_moment0_global(2), &
              &               ' mz = ', mag_moment0_global(3)

      else
         call m_CS_set_total_spin( nfout, mag_moment0_global(1) )
      endif

    end subroutine set_mag_constraint_type1

    subroutine set_mag_constraint_type2
      integer :: Flag
      Real(kind=DP) :: mdx, mdy, mdz, cnorm
      Real(kind=DP) :: ctmp, theta, phi

      Flag = 0
      mdx = 0.0d0; mdy = 0.0d0; mdz = 0.0d0
      theta = 0.0d0;   phi = 0.0d0

      mag_direc0_global(1) = 0.0d0
      mag_direc0_global(2) = 0.0d0
      mag_direc0_global(3) = 1.0d0

      if ( f_selectBlock( tag_direction ) == 0 .or. &
           &  f_selectBlock( tag_magnetic_moment ) == 0 ) then

         if( f_getRealValue( tag_mdx, dret, '') == 0 ) then
            mdx = dret;   Flag = 1
         endif
         if( f_getRealValue( tag_mdy, dret, '') == 0 ) then
            mdy = dret;   Flag = 1
         endif
         if( f_getRealValue( tag_mdz, dret, '') == 0 ) then
            mdz = dret;   Flag = 1
         endif

         if( f_getRealValue( tag_mx, dret, '') == 0 ) then
            mdx = dret;   Flag = 1
         endif
         if( f_getRealValue( tag_my, dret, '') == 0 ) then
            mdy = dret;   Flag = 1
         endif
         if( f_getRealValue( tag_mz, dret, '') == 0 ) then
            mdz = dret;   Flag = 1
         endif
         cnorm = sqrt( mdx**2 + mdy**2 + mdz**2 )

         if ( abs(cnorm) > 1.0E-4 ) then
            mag_direc0_global(1) = mdx / cnorm;
            mag_direc0_global(2) = mdy / cnorm;
            mag_direc0_global(3) = mdz / cnorm;
         endif
         !
         if ( Flag == 0 ) then
            if ( f_getRealValue( tag_theta, dret, "" ) == 0 ) then
               theta = dret
            end if
            if ( f_getRealValue( tag_phi, dret, "" ) == 0 ) then
               phi = dret
            end if

            theta  = theta / 180.0d0 *PAI
            phi  =  phi / 180.0d0 *PAI
!
            mag_direc0_global(1) = sin( theta ) *cos( phi )
            mag_direc0_global(2) = sin( theta ) *sin( phi )
            mag_direc0_global(3) = cos( theta )
         endif

         iret = f_selectParentBlock()
      endif
!
      write(nfout,*) '!************* Magnetic constraint : type 2 ************'
      write(nfout,'(A,F10.5,A,F10.5,A,F10.5)' ) &
           &             '!** The xyz component is mdx =', mag_direc0_global(1), &
           &               ' mdy = ', mag_direc0_global(2), &
           &               ' mdz = ', mag_direc0_global(3)

    end subroutine set_mag_constraint_type2
! ============================================================ 11.0&13.0U

    subroutine set_igen_jgen(prealloc,iret)
      logical, intent(in) ::  prealloc
      integer, intent(out) :: iret
      integer :: ip, linecounter
      integer, parameter :: limit_number_of_generators = 50
!!$      integer :: f_selectParentBlock, f_selectFirstTableLine, f_selectNextTableLine
      integer :: f_selectFirstTableLine, f_selectNextTableLine
      integer :: f_readSymmetryGenerator
      integer :: txu,txd,tyu,tyd,tzu,tzd
      if( f_selectBlock( tag_generators) == 0) then
         ip = 1
         linecounter = 0
         Generators: do while(.true.)
            linecounter = linecounter+1
            if(ip == 1) then
               if( f_selectFirstTableLine() /= 0) then
                  exit Generators
               end if
            else
               if( f_selectNextTableLine() /= 0) then
                  exit Generators
               end if
            end if
            if( f_readSymmetryGenerator(il, rint ,txu,txd,tyu,tyd,tzu,tzd, tag_rotation, tag_tx,tag_ty,tag_tz,printable) == 0) then
               if(.not.prealloc) then
                  if(ip > ngen) exit
                  igen(ip) = rint
                  jgen(1,1,ip) = txu; jgen(2,1,ip) = txd
                  jgen(1,2,ip) = tyu; jgen(2,2,ip) = tyd
                  jgen(1,3,ip) = tzu; jgen(2,3,ip) = tzd
               
                  if(ipriinputfile >= 1 .and. printable) then
                     write(nfout,'(" !** igen = ",i6,"  jgen = ",6i5)') igen(ip), jgen(1,1,ip), jgen(2,1,ip) &
                          & , jgen(1,2,ip),jgen(2,2,ip),jgen(1,3,ip),jgen(2,3,ip)
                  end if
               end if
               ip = ip + 1
            end if
            if(linecounter > limit_number_of_generators) then
               write(nfout,'(" linecounter exceeds limit_number_of_generatos: ip = ",i8," at <<set_igen_jgen>>")') ip
               write(nfout,'(" check tag names in <generatos block> of the input file")')
               call phase_error_with_msg(nfout, ' linecounter exceeds limit_number_of_generators at <<set_igen_jgen>>'&
                                              , __LINE__, __FILE__)
            end if
         end do Generators
         iret = f_selectParentBlock()
         iret = ip - 1
      else
         iret = 1
         if(.not.prealloc) call set_igen_jgen_default(1)
      end if
    end subroutine set_igen_jgen

    subroutine set_jgen_tl(prealloc,iret)
      logical, intent(in) ::  prealloc
      integer, intent(out) :: iret
      integer :: ip, linecounter
      integer, parameter :: limit_number_of_generators = 50
      integer :: f_selectFirstTableLine, f_selectNextTableLine
      integer :: f_readSymmetryGenerator, f_readTranslationVectors
      integer :: txu,txd,tyu,tyd,tzu,tzd
      if( f_selectBlock( tag_additional_tl) == 0) then
         ip = 1
         linecounter = 0
         Generators: do while(.true.)
            linecounter = linecounter+1
            if(ip == 1) then
               if( f_selectFirstTableLine() /= 0) then
                  exit Generators
               end if
            else
               if( f_selectNextTableLine() /= 0) then
                  exit Generators
               end if
            end if
            if( f_readTranslationVectors(il, txu,txd,tyu,tyd,tzu,tzd, tag_tx,tag_ty,tag_tz,printable) == 0) then
               if(.not.prealloc) then
                  if(ip > ngen_tl) exit
                  jgen_tl(1,1,ip) = txu; jgen_tl(2,1,ip) = txd
                  jgen_tl(1,2,ip) = tyu; jgen_tl(2,2,ip) = tyd
                  jgen_tl(1,3,ip) = tzu; jgen_tl(2,3,ip) = tzd
               
                  if(ipriinputfile >= 1 .and. printable) then
                     write(nfout,'(" !** jgen_tl = ",6i5)') &
                          &  jgen_tl(1:2,1,ip), jgen_tl(1:2,2,ip),jgen_tl(1:2,3,ip)
                  end if
               end if
               ip = ip + 1
            end if
            if(linecounter > limit_number_of_generators) then
               write(nfout,'(" linecounter exceeds limit_number_of_generatos: ip = ",i8," at <<set_igen_jgen>>")') ip
               write(nfout,'(" check tag names in <generatos block> of the input file")')
               call phase_error_with_msg(nfout, ' linecounter exceeds limit_number_of_generators at <<set_igen_jgen>>' &
                                              , __LINE__, __FILE__)
            end if
         end do Generators
         iret = f_selectParentBlock()
         iret = ip - 1
      else
         iret = 0
!!$         if(.not.prealloc) call set_jgen_default_tl(1)
      end if
    end subroutine set_jgen_tl

    subroutine set_iaf_jaf(iret)
      integer, intent(out) :: iret
      integer :: ip
      integer :: f_selectFirstTableLine, f_selectNextTableLine
      integer :: f_readSymmetryGenerator
      integer :: txu,txd,tyu,tyd,tzu,tzd
      if( f_selectBlock( tag_af_generator) == 0) then
         ip = 1
         Generators: do while(.true.)
            if(ip == 1) then
               if( f_selectFirstTableLine() /= 0) then
                  exit Generators
               end if
            else
               if( f_selectNextTableLine() /= 0) then
                  exit Generators
               end if
            end if
            if( f_readSymmetryGenerator(il, rint ,txu,txd,tyu,tyd,tzu,tzd, tag_rotation, tag_tx,tag_ty,tag_tz,printable) == 0) then
                  if(ip > 1) exit
                  iaf = rint
                  jaf(1,1) = txu; jaf(2,1) = txd
                  jaf(1,2) = tyu; jaf(2,2) = tyd
                  jaf(1,3) = tzu; jaf(2,3) = tzd

                  if(ipriinputfile >= 1 .and. printable) then
                     write(nfout,'(" !** iaf  = ",i6,"  jaf  = ",6i5)') iaf, jaf(1,1), jaf(2,1) &
                          & , jaf(1,2),jaf(2,2),jaf(1,3),jaf(2,3)
                  end if
               ip = ip + 1
            end if
         end do Generators
         iret = f_selectParentBlock()
         iret = ip - 1
      end if
    end subroutine set_iaf_jaf

    subroutine set_igen_jgen_default(i)
      integer, intent(in) :: i
      integer :: j
      igen(i) = 1
      do j = 1, 3
         jgen(1,j,i) = 0
         jgen(2,j,i) = 1
      end do
    end subroutine set_igen_jgen_default

    subroutine set_jgen_default_tl(i)
      integer, intent(in) :: i
      integer :: j
!!$      igen_tl(i) = 1
      do j = 1, 3
         jgen_tl(1,j,i) = 0
         jgen_tl(2,j,i) = 1
      end do
    end subroutine set_jgen_default_tl

    subroutine set_lattice_system()
      integer :: iret
      logical :: proper_lattice_system
      proper_lattice_system = .false.
      iret = f_getstringValue( tag_lattice_system, rstr, LOWER)
      if(iret /= 0) iret = f_getstringValue( tag_system, rstr, LOWER)
      if(iret == 0) then
         proper_lattice_system = set_lattice_system0(rstr) ! -->il
         if(.not.proper_lattice_system) then
            if(ipriinputfile>= 0 .and. printable)  &
                 & write(nfout,'(" !* lattice_system defined in the [tspace] block is not approprieate (",a32,")")') rstr
            il = PRIMITIVE_lattice
            if(ipriinputfile>= 0 .and. printable) &
                 & write(nfout,'(" !* lattice_system is set to be PRIMITIVE lattice at <<m_CS_rd_n.set_lattice_system>>")')
         end if
      else
         il = PRIMITIVE_lattice !!! K. Mae 040121
         if(ipriinputfile >= 0 .and. printable) then
            write(nfout,'(" ! lattice_system is not defined in the [tspace] block")')
            write(nfout,'(" ! lattice_system is set to be PRIMITIVE lattice at <<m_CS_rd_n.set_lattice_system>>")')
         end if
      end if
      if(ipriinputfile >= 1 .and. printable) then
         write(nfout,'(" !** il = ",i5," <<m_CS_rd_n.set_lattice_system>>")') il
         if(il == -1) write(nfout,'(" !** il = ",a32)') tag_trigonal
         if(il ==  0) write(nfout,'(" !** il = ",a32)') tag_hexagonal
         if(il ==  1) write(nfout,'(" !** il = ",a32)') tag_primitive
         if(il ==  2) write(nfout,'(" !** il = ",a32)') tag_facecentered
         if(il ==  3) write(nfout,'(" !** il = ",a32)') tag_bodycentered
         if(il ==  4) write(nfout,'(" !** il = ",a32)') tag_basecentered
      end if
    end subroutine set_lattice_system

    logical function set_lattice_system0(rstr)
      character(len=FMAXVALLEN), intent(in) :: rstr
      logical :: tf
      integer :: lenstr
      set_lattice_system0 = .false.
      lenstr = len(trim(rstr))
      if(lenstr >= 1) call strncmp0(tag_rhombohedral, trim(rstr), tf)
      if(.not.tf .and. lenstr >= 1) call strncmp0(tag_trigonal, trim(rstr), tf)
      if(.not.tf .and. lenstr == 2) call strncmp0(trim(rstr), "-1", tf)
      if(tf) then
         il = TRIGONAL_lattice
         set_lattice_system0 = .true.
         goto 1001
      end if

      if(lenstr >= 1) call strncmp0(tag_hexagonal, trim(rstr), tf)
      if(.not.tf .and. lenstr == 1) call strncmp0(trim(rstr), "0", tf)
      if(tf) then
         il = HEXAGONAL_lattice
         set_lattice_system0 = .true.
         goto 1001
      end if

      if(lenstr >= 1) call strncmp0(tag_primitive, trim(rstr), tf)
      if(.not.tf .and. lenstr >= 1) call strncmp0(tag_simple, trim(rstr), tf)
      if(.not.tf .and. lenstr == 1) call strncmp0(trim(rstr),"1",tf)
      if(tf) then
         il = PRIMITIVE_lattice
         set_lattice_system0 = .true.
         goto 1001
      end if

      if(lenstr >= 1) call strncmp0(tag_facecentered, trim(rstr), tf)
      if(.not.tf .and. lenstr >= 1) call strncmp0(tag_fcc, trim(rstr), tf)
      if(.not.tf .and. lenstr == 1) call strncmp0(trim(rstr),"2",tf)
      if(tf) then
         il = FCC_lattice
         set_lattice_system0 = .true.
         goto 1001
      end if

      if(lenstr >= 3) call strncmp0(tag_bodycentered, trim(rstr), tf)
      if(.not.tf .and. lenstr >= 2) call strncmp0(tag_bcc, trim(rstr), tf)
      if(.not.tf .and. lenstr == 1) call strncmp0(trim(rstr),"3",tf)
      if(tf) then
         il = BCC_lattice
         set_lattice_system0 = .true.
         goto 1001
      end if

      if(lenstr >= 3) call strncmp0(tag_bottomcentered, trim(rstr), tf)
      if(.not.tf .and. lenstr >= 2) call strncmp0(tag_basecentered, trim(rstr), tf)
      if(.not.tf .and. lenstr >= 1) call strncmp0(tag_onefacecentered, trim(rstr),tf)
      if(.not.tf .and. lenstr == 1) call strncmp0(trim(rstr),"4",tf)
      if(tf) then
         il = BottomCenteredCubic_lattice
         set_lattice_system0 = .true.
         goto 1001
      end if
1001  continue
    end function set_lattice_system0

!!$    integer function f_readUnitCell(avec,bvec,cvec,a,b,c,alpha,beta,gamma)
!!$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$! intelligent reading of unit cell
!!$! This function has been coded by K. Mae(adv), May-Jun. 2003
!!$! Subtle modifications( (8) -> (DP), PI -> PAI ) were done
!!$!        by  T. Yamasaki(FUJITSU LABORATORIES LTD.),  9th Jun. 2003
!!$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$      real(DP), dimension(3), intent(out) :: avec
!!$      real(DP), dimension(3), intent(out) :: bvec
!!$      real(DP), dimension(3), intent(out) :: cvec
!!$      real(DP), intent(out) :: a, b, c
!!$      real(DP), intent(out) :: alpha, beta, gamma
!!$      real(DP) :: s, al, be, ga, cos_al, sin_be, cos_be, sin_ga, cos_ga
!!$      integer :: getRealVectorValue
!!$      integer :: getRealValue
!!$      integer :: iret
!!$
!!$      if( getRealVectorValue( trim(TAG_AVECTOR)//char(0), avec ) == 0 ) then
!!$         iret = getRealVectorValue( trim(TAG_BVECTOR)//char(0), bvec )
!!$         iret = getRealVectorValue( trim(TAG_CVECTOR)//char(0), cvec )
!!$         a = sqrt( sum(avec(:)*avec(:)) )
!!$         b = sqrt( sum(bvec(:)*bvec(:)) )
!!$         c = sqrt( sum(cvec(:)*cvec(:)) )
!!$         alpha = acos( dot_product(bvec,cvec)/(b*c) )*180.d0/PAI
!!$         beta = acos( dot_product(cvec,avec)/(c*a) )*180.d0/PAI
!!$         gamma = acos( dot_product(avec,bvec)/(a*b) )*180.d0/PAI
!!$      else if( getRealValue( trim(TAG_A)//char(0), a ) == 0 ) then
!!$         iret = getRealValue( trim(TAG_B)//char(0), b )
!!$         iret = getRealValue( trim(TAG_C)//char(0), c )
!!$         iret = getRealValue( trim(TAG_ALPHA)//char(0), alpha )
!!$         iret = getRealValue( trim(TAG_BETA)//char(0), beta )
!!$         iret = getRealValue( trim(TAG_GAMMA)//char(0), gamma )
!!$         al = alpha*PAI/180.d0
!!$         be = beta*PAI/180.d0
!!$         ga = gamma*PAI/180.d0
!!$         cos_al = cos(al)
!!$         sin_be = sin(be)
!!$         cos_be = cos(be)
!!$         sin_ga = sin(ga)
!!$         cos_ga = cos(ga)
!!$         s = (cos_ga*cos_be-cos_al)/sin_ga/cos_be
!!$         avec(1) = a
!!$         avec(2) = 0.d0
!!$         avec(3) = 0.d0
!!$         bvec(1) = b*cos_ga
!!$         bvec(2) = b*sin_ga
!!$         bvec(3) = 0.d0
!!$
!!$         cvec(1) = c*cos_be
!!$         cvec(2) = (b*c*cos_al - bvec(2)*cvec(1))/bvec(2)
!!$         cvec(3) = sqrt(c*c - cvec(1)**2 - cvec(2)**2)
!!$		cvec(1) = c*cos_be
!!$		cvec(2) = c*abs(s)*cos_be
!!$		cvec(3) = c*sqrt(sin_be*sin_be-s*s*cos_be*cos_be)
!!$      else
!!$         f_readUnitCell = -1
!!$         return
!!$      end if
!!$	
!!$      f_readUnitCell = 0
!!$      return
!!$    end function f_readUnitCell
  end subroutine m_CS_rd_n

  subroutine m_CS_altv_2_rltv()
    call altv_2_rltv(altv,rltv,univol,rvol)
  end subroutine m_CS_altv_2_rltv

  subroutine m_CS_set_nbztyp_spg()
    nbztyp_spg = nbztyp
  end subroutine m_CS_set_nbztyp_spg

  subroutine m_CS_set_nbztyp(type)
    integer, intent(in) :: type
    nbztyp    = type
  end subroutine m_CS_set_nbztyp

  subroutine m_CS_alloc_op_tau(nfout)
    integer, intent(in) :: nfout
    if(printable) then
       write(nfout,'(" -- m_CS_alloc_op_tau --")')
       write(nfout,'(" !! nopr, af = ",2i5)') nopr,af
    end if
    if(nopr == 0) call phase_error_with_msg(nfout, ' nopr is invalid',__LINE__,__FILE__)
    if(allocated(op)) deallocate(op)
    if(allocated(tau)) deallocate(tau)
    allocate(op(3,3,nopr+af))
    allocate(tau(3,nopr+af,CRDTYP))
  end subroutine m_CS_alloc_op_tau

  subroutine m_CS_alloc_op_tau_tl(nfout)
    integer, intent(in) :: nfout
    if(printable) then
       write(nfout,'(" -- m_CS_alloc_op_tau_tl --")')
       write(nfout,'(" !! ngen_tl = ",i5)') ngen_tl
    end if
    if(ngen_tl > 0) then
       if(allocated(op_tl)) deallocate(op_tl)
       allocate(op_tl(3,3,ngen_tl))
       if(allocated(tau_tl)) deallocate(tau_tl)
       allocate(tau_tl(3,ngen_tl,CRDTYP))
    else
       if(.not.allocated(op_tl)) allocate(op_tl(3,3,1))
       if(.not.allocated(tau_tl)) allocate(tau_tl(3,1,CRDTYP))
    end if
  end subroutine m_CS_alloc_op_tau_tl

  subroutine alloc_igen_jgen
    allocate(igen(ngen)); igen = 0
    allocate(jgen(2,3,ngen)); jgen = 0
  end subroutine alloc_igen_jgen

  subroutine alloc_jgen_tl
!!$    allocate(igen_tl(ngen_tl)); igen_tl = 0
    allocate(jgen_tl(2,3,ngen_tl)); jgen_tl = 0
  end subroutine alloc_jgen_tl

  subroutine dealloc_igen_jgen
    deallocate(igen)
    deallocate(jgen)
  end subroutine dealloc_igen_jgen

  subroutine m_CS_wd_CS_data(nfcntn,nfout)
    integer, intent(in) :: nfcntn,nfout
    write(nfcntn) inversion_symmetry
    write(nfcntn) nbztyp
    write(nfcntn) altv,rltv, univol, rvol
  end subroutine m_CS_wd_CS_data

  subroutine m_CS_rd_CS_data(nfcntn,nfout)
    integer, intent(in) :: nfcntn, nfout
    if(printable)  write(nfout,*) ' <<< m_CS_rd_CS_data >>>'
!!$    read(nfcntn) input_coordinate_system
!!$    write(nfout,*) ' input_coordinate_system = ', input_coordinate_system
    read(nfcntn) inversion_symmetry
    read(nfcntn) nbztyp
    read(nfcntn) altv,rltv, univol, rvol
  end subroutine m_CS_rd_CS_data

! --> T. Yamasaki, 18th Aug. 2009
  subroutine m_CS_wd_fix_spin_status(nfcntn)

    integer, intent(in) :: nfcntn

! ================================== added by K. Tagami ====================== 11.0
    if ( noncol ) return
! ============================================================================ 11.0

    if(nspin == 2) then
       if(mype == 0) then
          write(nfcntn,'(a15)') tag_fix_spin_status
          write(nfcntn,'(2i5,d20.8)') sw_fix_total_spin_in, sw_fix_total_spin, total_spin
       end if
    end if
  end subroutine m_CS_wd_fix_spin_status

  subroutine m_CS_rd_fix_spin_status(nfcntn,nfout)
    integer, intent(in) :: nfcntn,nfout
    integer :: i
    logical :: EOF_reach, tag_is_found

! ================================== added by K. Tagami ====================== 11.0
    if ( noncol ) return
! ============================================================================ 11.0

    if(nspin == 2) then
       if(mype == 0) then
          call rewind_to_tag0(nfcntn,len(tag_fix_spin_status),tag_fix_spin_status &
               &, EOF_reach, tag_is_found, str, len_str)
          write(nfout,'(" << m_CS_rd_fix_spin_status>>")')
          if(.not.tag_is_found) then
             write(nfout,'(" sw_fix_total_spin_in, sw_fix_total_spin and total_spin  are not read")')
          else
             read(nfcntn,*) i, sw_fix_total_spin, total_spin
             write(nfout,'(" sw_fix_total_spin_in, sw_fix_total_spin, total_spin = ",2i5,d20.8)') &
                  &         i, sw_fix_total_spin, total_spin
          end if
       end if
    end if
  end subroutine m_CS_rd_fix_spin_status
! <--

! --- subroutine m_CS_read_symmtry_op_etc ---
!  This subroutine is revised version of the subroutine <rdprp>
!                 T. Yamasaki(FUJITSU Lab.) 31 May 2003
  subroutine m_CS_rd_symmetry_op_etc(nf)
    integer, intent(in) :: nf
    integer :: ianti,janti(2,3),i,j,k
    character(len=60) :: cname
    logical :: skip_to_tagbegin

    rewind nf

    if(.not.skip_to_tagbegin(nf,tag_tspace)) then
       if(printable) write(6,'(" ! tag of tspace is not found in the inputfile")')
       call phase_error_with_msg(6, ' stopped at <<m_CS_rd_symmetry_op_etc>>',__LINE__,__FILE__)
    end if

    read(nf,*) i ! jpr

    read(nf,'(a60)') cname
    read(nf,*) i, il, ngen, inv  ! i<-idim

    if(ipri_spg >= 1 .and. printable) then
       write(6,820) cname,i,il,ngen,inv
       write(6,*) 'ngen=',ngen     
    end if
  820 format(' == ',a60,' ==' / &
     &  ' dimension=',i2,'      il=',i2,'   ngen=',i2,'   inv=',i2)

    call alloc_igen_jgen()
    do i = 1, ngen
       read (nf,*)   igen(i),((jgen(j,k,i),j=1,2),k=1,3)
    end do

    read(nf,*) imag
    if(imag == 1) then
       if(printable) write(6,*) ' antiferromagnetic calculation'
       read (nf,*)   ianti,((janti(j,k),j=1,2),k=1,3)
    endif

!!$    read(nf,*) a,b,c,ca,cb,cc

    if(ipri_spg >= 1 .and. printable) then
       write(6,*) ' << m_CS_rd_symmetry_op_etc >>'
       write(6,860) a,b,c,ca,cb,cc
860    format(' a, b, c =',3f12.6/ &
       &       'ca,cb,cc =',3f12.6)
    end if
  end subroutine m_CS_rd_symmetry_op_etc

  subroutine m_CS_set_abccacbcc()
    a=dsqrt(altv(1,1)**2+altv(2,1)**2+altv(3,1)**2)
    b=dsqrt(altv(1,2)**2+altv(2,2)**2+altv(3,2)**2)
    c=dsqrt(altv(1,3)**2+altv(2,3)**2+altv(3,3)**2)
    ca=(altv(1,2)*altv(1,3)+altv(2,2)*altv(2,3)+altv(3,2)*altv(3,3)) /(b*c)
    cb=(altv(1,3)*altv(1,1)+altv(2,3)*altv(2,1)+altv(3,3)*altv(3,1)) /(c*a)
    cc=(altv(1,1)*altv(1,2)+altv(2,1)*altv(2,2)+altv(3,1)*altv(3,2)) /(a*b)
    if(printable) then 
       write(6,*) ' << m_CS_set_abccacbcc >>  '
       write(6,860) a,b,c,ca,cb,cc
    end if
860 format(' a, b, c =',3f12.6/ 'ca,cb,cc =',3f12.6)
  end subroutine m_CS_set_abccacbcc

  ! --- subroutine m_CS_set_default_symm_op
  !  This subroutine is revised from <setspg_default> by T. Yamasaki(FUJITSU Lab.)
  !  The former part of the <setspg_default> is taken.
  !                                                            31 May 2003
  subroutine m_CS_set_default_symm_op(nfout)
    integer, intent(in) :: nfout
    integer ::   ip

    if(ipri_spg >= 1 .and. printable)  write(nfout,'(" !** nbztyp_spg = ",i6)') nbztyp_spg

!!$    if(ipri_spg >= 1 .and. printable) then
!!$       write(nfout,*) ' '
!!$       write(nfout,860) a,b,c,ca,cb,cc
!!$860    format(' !** a, b, c =',3f12.6/ ' !** ca,cb,cc =',3f12.6)
!!$    end if
    if(nbztyp_spg == SIMPLE_CUBIC) then
       il=1
       ngen=3
       inv=1
    else if(nbztyp_spg == BCC) then
       il=3
       ngen=3
       inv=1
    else if(nbztyp_spg == FCC) then
       il=2
       ngen=3
       inv=1
    else if(nbztyp_spg == DIAMOND) then
       il=2
       ngen=3
       inv=0
    else if(nbztyp_spg == HEXAGONAL) then
       il=0
       ngen=1       !!! K.Mae 040315
       !!! ngen=2   !!! K.Mae 040315
       inv=0
    else if(nbztyp_spg == HCP) then
       il=0
       ngen=3
       inv=1
    else if(nbztyp_spg == TRIGONAL) then
       il=-1
       ngen=1
       inv=0
    else
       il=1
       ngen=1
       inv=0
       if(printable) write(nfout,'(" !** nbztyp_spg = ",i6," <m_CS_set_default_symm_op>")') nbztyp_spg
!!$       stop ' nbztyp_spg (m_CS_set_default_symm_op) is illegal'
    end if
    call alloc_igen_jgen()

    if(nbztyp_spg == SIMPLE_CUBIC) then     ! Oh
       igen(1)=5
       jgen(1,1,1)=0;         jgen(2,1,1)=1
       jgen(1,2,1)=0;         jgen(2,2,1)=1
       jgen(1,3,1)=0;         jgen(2,3,1)=1
       igen(2)=19
       jgen(1,1,2)=0;         jgen(2,1,2)=1
       jgen(1,2,2)=0;         jgen(2,2,2)=1
       jgen(1,3,2)=0;         jgen(2,3,2)=1
       igen(3)=25
       jgen(1,1,3)=0;         jgen(2,1,3)=1
       jgen(1,2,3)=0;         jgen(2,2,3)=1
       jgen(1,3,3)=0;         jgen(2,3,3)=1
    else if(nbztyp_spg == BCC) then
       igen(1)=5
       jgen(1,1,1)=0;         jgen(2,1,1)=1
       jgen(1,2,1)=0;         jgen(2,2,1)=1
       jgen(1,3,1)=0;         jgen(2,3,1)=1
       igen(2)=19
       jgen(1,1,2)=0;         jgen(2,1,2)=1
       jgen(1,2,2)=0;         jgen(2,2,2)=1
       jgen(1,3,2)=0;         jgen(2,3,2)=1
       igen(3)=25
       jgen(1,1,3)=0;         jgen(2,1,3)=1
       jgen(1,2,3)=0;         jgen(2,2,3)=1
       jgen(1,3,3)=0;         jgen(2,3,3)=1
    else if(nbztyp_spg == FCC) then
       igen(1)=5
       jgen(1,1,1)=0;         jgen(2,1,1)=1
       jgen(1,2,1)=0;         jgen(2,2,1)=1
       jgen(1,3,1)=0;         jgen(2,3,1)=1
       igen(2)=19
       jgen(1,1,2)=0;         jgen(2,1,2)=1
       jgen(1,2,2)=0;         jgen(2,2,2)=1
       jgen(1,3,2)=0;         jgen(2,3,2)=1
       igen(3)=25
       jgen(1,1,3)=0;         jgen(2,1,3)=1
       jgen(1,2,3)=0;         jgen(2,2,3)=1
       jgen(1,3,3)=0;         jgen(2,3,3)=1
    else if(nbztyp_spg == DIAMOND) then
       igen(1)=5
       jgen(1,1,1)=0;         jgen(2,1,1)=1
       jgen(1,2,1)=0;         jgen(2,2,1)=1
       jgen(1,3,1)=0;         jgen(2,3,1)=1
!ccccccc 2nd choice ccccccccccccccccccccc
       igen(2)=19
       jgen(1,1,2)=1;         jgen(2,1,2)=4
       jgen(1,2,2)=1;         jgen(2,2,2)=2
       jgen(1,3,2)=3;         jgen(2,3,2)=4
       igen(3)=25
       jgen(1,1,3)=0;         jgen(2,1,3)=1
       jgen(1,2,3)=0;         jgen(2,2,3)=1
       jgen(1,3,3)=0;         jgen(2,3,3)=1
!ccccccc 2nd choice ccccccccccccccccccccc
    else if(nbztyp_spg == HEXAGONAL) then
      !!! K.Mae 040315, only C3
      igen(1)=3
      jgen(1,1,1)=0;         jgen(2,1,1)=1
      jgen(1,2,1)=0;         jgen(2,2,1)=1
      jgen(1,3,1)=0;         jgen(2,3,1)=1
      !!! commented out by K.Mae 040315, These generators only for SiO2
      ! igen(1)=3
      ! jgen(1,1,1)=0;         jgen(2,1,1)=1
      ! jgen(1,2,1)=0;         jgen(2,2,1)=1
      ! jgen(1,3,1)=2;         jgen(2,3,1)=3
      ! igen(2)=10
      ! jgen(1,1,2)=0;         jgen(2,1,2)=1
      ! jgen(1,2,2)=0;         jgen(2,2,2)=1
      ! jgen(1,3,2)=0;         jgen(2,3,2)=1
      !!! end commented out by K.Mae 040315
    else if(nbztyp_spg == HCP) then
! [nbztyp_spg == HCP] is added by T. Yamasaki(FUJITSU LABORATORIES LTD.) 11th Jun. 2003
       igen(1)=2
       jgen(1,1,1)=0;         jgen(2,1,1)=1
       jgen(1,2,1)=0;         jgen(2,2,1)=1
       jgen(1,3,1)=1;         jgen(2,3,1)=2
       igen(2)=7
       jgen(1,1,2)=0;         jgen(2,1,2)=1
       jgen(1,2,2)=0;         jgen(2,2,2)=1
       jgen(1,3,2)=1;         jgen(2,3,2)=2
       igen(3)=13
       jgen(1,1,3)=0;         jgen(2,1,3)=1
       jgen(1,2,3)=0;         jgen(2,2,3)=1
       jgen(1,3,3)=0;         jgen(2,3,3)=1
    else if(nbztyp_spg == TRIGONAL) then
       igen(1)=3
       jgen(1,1,1)=0;         jgen(2,1,1)=1
       jgen(1,2,1)=0;         jgen(2,2,1)=1
       jgen(1,3,1)=0;         jgen(2,3,1)=1
    else
       igen(1)=1
       jgen(1,1,1)=0;         jgen(2,1,1)=1
       jgen(1,2,1)=0;         jgen(2,2,1)=1
       jgen(1,3,1)=0;         jgen(2,3,1)=1
    end if
    if(ipri_spg >= 1 .and. printable) then
       write(nfout,'(" !** il = ",i6, "<<m_CS_set_default_symm_op>>")') il
       do ip = 1, ngen
          write(nfout,'(" !** igen = ",i6,"  jgen = ",6i5)') igen(ip), jgen(1,1,ip), jgen(2,1,ip) &
               & , jgen(1,2,ip),jgen(2,2,ip),jgen(1,3,ip),jgen(2,3,ip)
       end do
    end if
  end subroutine m_CS_set_default_symm_op

  ! ---------- 
  subroutine m_CS_wd_op_and_tau(nfout)
    integer, intent(in) :: nfout
    integer :: no ,i, j, l, k
    real(kind=DP),dimension(3,3) :: op_br
    write(nfout,*) ' --- Symmetry Operations (CARTS, PUCV) --- (in m_CS_wd_op_and_tau)'
    write(nfout,'(" !! nopr+af = ",i6)') nopr+af

    do no = 1, nopr + af
       do i = 1, 3
          do j = 1, 3
             op_br(i,j) = 0.d0
             do l = 1,3
                do k = 1,3
                   op_br(i,j) = op_br(i,j) &
                        &           + altv(l,i)*op(l,k,no)*rltv(k,j)
                enddo
             enddo
             op_br(i,j) = op_br(i,j)/PAI2
          enddo
       enddo
       if( no<= nopr ) then
          if(il<=0 .or. pg_symbol_system == 'hexagonal') then
             write(nfout,*) ' #symmetry op. = ', no, d6h_symbol(ig01(no))
          else
             write(nfout,*) ' #symmetry op. = ', no, oh_symbol(ig01(no))
          end if
       else
          if(il<=0 .or. pg_symbol_system == 'hexagonal') then
             write(nfout,*) ' #symmetry op. = ', no, d6h_symbol(iaf)
          else
             write(nfout,*) ' #symmetry op. = ', no, oh_symbol(iaf)
          end if
       end if
         
       do i = 1, 3
          write(nfout,'(4f8.4,3x,4f8.4)') &
               &           (op   (i,j,no),j=1,3),tau(i,no,CARTS) &
               &          ,(op_br(i,j),j=1,3),tau(i,no,BUCS)
       enddo
    end do
    if(ipri >= 1 .and. symmetry_not_printed) symmetry_not_printed=.false.
  end subroutine m_CS_wd_op_and_tau

  subroutine m_CS_gnrt_symmetry_operations(paramset,nfout)
    logical, intent(in) :: paramset
    integer, intent(in) :: nfout
    integer ::             i, j, iopr, ip
    integer ::             af_t
    integer ::             id_sname = -1
    real(kind=DP),dimension(3,3) :: op_br
#ifdef __TIMER_SUB__
  call timer_sta(1227)
#endif

    call tstatc0_begin('m_CS_gnrt_symmetry_operations ',id_sname)
! ----- iopr, op, tau

! ---> T. Yamasaki(FUJITSU Laboratoreis) 31 May 2003
!!$    if(paramset) then
!!$       if(nbztyp >= 2 .and. &
!!$            & (nbztyp_spg == GENERAL .or. nbztyp_spg == GENERAL_LARGER)) then
!!$          call m_CS_rd_symmetry_op_etc(nfspg)
!!$       else
!!$          call m_CS_set_default_symm_op()  ! <-- nbztyp_spg
!!$       end if
!!$    end if
! <----

    if(printable .and. paramset) then
       write(nfout,'(" ngen = ", i6)') ngen
       do ip = 1, ngen
          write(nfout,'(" igen = ",i6," jgen = ",6i5)') igen(ip) &
               & , jgen(1,1,ip), jgen(2,1,ip), jgen(1,2,ip) &
               & , jgen(2,2,ip), jgen(1,3,ip), jgen(2,3,ip)
       end do
       if(af > 0) then
          write(nfout,'(" iaf  = ",i6," jaf  = ",6i5)') iaf &
                & , jaf(1,1), jaf(2,1), jaf(1,2) &
                & , jaf(2,2), jaf(1,3), jaf(2,3)
       end if
    end if
    call iopr_op_tau(af_t)  ! depends on 'paramset'

    if(ipri >= 3 .and. paramset) write(nfout,'(" !! af_t = ",i10)') af_t
    if(af_t > 1) call phase_error_with_msg(nfout, ' ! illegal af_t value',__LINE__,__FILE__)
    call m_CtrlP_set_af(af_t)
    if(ipri >= 2 .and. paramset) write(nfout,'(" !! af_t (after m_CtrlP_set_af) = " ,i6)') af_t

!!$    if(ipri >= 0 .and. printable) then
    if((.not.paramset .and. ipri >= 3 ) .or. (paramset .and. ipri >= 0 .and. printable)) then
       write(nfout,*) ' << rltv, altv >>'
       write(nfout,'(3f8.4,11x,3f8.4)') &
            & ((rltv(i,j),j=1,3),(altv(i,j),j=1,3),i=1,3)
    endif
    if(paramset) then
       nopr = iopr
       goto 1001
    end if

    call tau_in_PUCV()

!!$    if(ipri>=1) call wd_op_and_tau()

1001 continue

!! --------------- supercell (redundant space-group) -------------
!  transfered by T. Yamasaki from a revised subroutine of fd_symmetry by Usami-san
!                                                          March 2014

!!$    call gnrt_operators_for_supsercell()

!! ---------------------------------------------------------------    

    call tstatc0_end(id_sname)
#ifdef __TIMER_SUB__
  call timer_end(1227)
#endif
  contains
    subroutine wd_op_and_tau()
      integer :: no ,i, j, l, k
      write(nfout,*) ' --- Symmetry Operations (CARTS, PUCV) --- (in generator)'
      write(nfout,'(" !! nopr+af = ",i6)') nopr+af

      do no = 1, nopr + af
         do i = 1, 3
            do j = 1, 3
               op_br(i,j) = 0.d0
               do l = 1,3
                  do k = 1,3
                     op_br(i,j) = op_br(i,j) &
                          &           + altv(l,i)*op(l,k,no)*rltv(k,j)
                  enddo
               enddo
               op_br(i,j) = op_br(i,j)/PAI2
            enddo
         enddo
         if( no<= nopr ) then
            if(il<=0 .or. pg_symbol_system == 'hexagonal') then
               write(nfout,*) ' #symmetry op. = ', no, d6h_symbol(ig01(no))
            else
               write(nfout,*) ' #symmetry op. = ', no, oh_symbol(ig01(no))
            end if
         else
            if(il<=0 .or. pg_symbol_system == 'hexagonal') then
               write(nfout,*) ' #symmetry op. = ', no, d6h_symbol(iaf)
            else
               write(nfout,*) ' #symmetry op. = ', no, oh_symbol(iaf)
            end if
         end if
         
         do i = 1, 3
            write(nfout,'(4f8.4,3x,4f8.4)') &
                 &           (op   (i,j,no),j=1,3),tau(i,no,CARTS) &
                 &          ,(op_br(i,j),j=1,3),tau(i,no,BUCS)
         enddo
      end do
    end subroutine wd_op_and_tau

    subroutine iopr_op_tau(af_t)  ! --> iopr,af,op,tau 
      integer, intent(out) :: af_t
      integer ::              ipri_spg_t

      af_t = 0

      if(paramset) then
! ====================================== modified by K. Tagami ============ 12.0A
!         call gnrt_op_paramset(il,ngen,inv,igen,jgen,imag,iaf,jaf,a,b,c,ca,cb,cc &
!              &        ,nfout,iopr,af_t,nbztyp_spg,ig01) !-(b_Crystal_Structure)

         call gnrt_op_paramset( il, ngen, inv, igen, jgen, imag, iaf, jaf, &
              &                 a, b, c, ca, cb, cc, &
              &                 nfout, iopr, af_t, nbztyp_spg, ig01, &
              &                 use_altv_rltv, altv, rltv,&
              &                 gen_name_in_carts )
                                                      !-(b_Crystal_Structure)
! ========================================================================== 12.0A
      else
         ipri_spg_t = ipri_spg
         if(nbztyp < 2) then
            iopr = 1
            op = 0.d0
            tau = 0.d0
            op(1,1,iopr) = 1.d0
            op(2,2,iopr) = 1.d0
            op(3,3,iopr) = 1.d0
         end if
!-----  nbztype =100 & 101   - by Tsuyoshi Miyazaki '94.8.16
!      read operation matrix and k-point from the files
!        1.opgr.data  : operation matrix
!        2.matrix.BP  : transformation matrix from
!                       Bravais lattice to Primitive lattice
!        3.kpoint.dat : irreducible k-point
!      these files can be made by using Dr Hamada-san's code
!     (these files must be located at the working directory)

! ====================================== modified by K. Tagami ============ 12.0A
!         call gnrt_op_n(il,ngen,inv,igen,jgen,imag,iaf,jaf,a,b,c,ca,cb,cc &
!              &        ,nopr+af,altv,nfout,iopr,op,tau, af_t, nbztyp_spg,ipri_spg_t,ig01) !-(b_Crystal_Structure)
!
         call gnrt_op_n( il, ngen, inv, igen, jgen, imag, iaf, jaf, &
              &          a, b, c, ca, cb, cc, &
              &          nopr+af, altv, nfout, iopr, op, tau, af_t, &
              &          nbztyp_spg, ipri_spg_t, ig01, &
              &          use_altv_rltv, rltv, &
              &          gen_name_in_carts ) 
                                          !-(b_Crystal_Structure)
! ============================================================================= 12.0A
      endif

    end subroutine iopr_op_tau

    subroutine tau_in_PUCV
      integer i, no
      do i = 1, 3
         do no = 1, iopr + af
            tau(i,no,BUCS) = (rltv(1,i)*tau(1,no,CARTS) &
                 &     +      rltv(2,i)*tau(2,no,CARTS) &
                 &     +      rltv(3,i)*tau(3,no,CARTS))/PAI2
         enddo
      enddo
    end subroutine tau_in_PUCV
  end subroutine m_CS_gnrt_symmetry_operations

  ! ---------- 
  subroutine m_CS_gnrt_symm_operators_tl(paramset,nfout)
    logical, intent(in) :: paramset
    integer, intent(in) :: nfout
    integer ::             i, j, ip
    integer ::             af_t
    integer ::             id_sname = -1

    if(sw_supercell_symmetry == OFF) return

    call tstatc0_begin('m_CS_gnrt_symm_operators_tl ',id_sname)
! -----  op, tau

!!$    if(printable .and. paramset) then
       write(nfout,'(" ngen_tl = ", i6)') ngen_tl
       do ip = 1, ngen_tl
          write(nfout,'(" jgen_tl = ",6i5)') jgen_tl(1:2,1,ip), jgen_tl(1:2,2,ip), jgen_tl(1:2,3,ip)
       end do
!!$    end if
    if(paramset) goto 1001

    call op_tau_tl()  ! depends on 'paramset'
    call tau_in_CARTS()

    if(ipri>=1) call wd_op_and_tau()

1001 continue

    call tstatc0_end(id_sname)
  contains
    subroutine wd_op_and_tau()
      integer :: no ,i, j, l, k
      real(kind=DP),dimension(3,3) :: op_br

      write(nfout,*) ' --- SC Symmetry Operations (CARTS, PUCV) --- (in m_CS_gnrt_symm_operators_tl)'
      write(nfout,'(" !! ngen_tl = ",i6)') ngen_tl

      do no = 1, ngen_tl
         do i = 1, 3
            do j = 1, 3
               op_br(i,j) = 0.d0
               do l = 1,3
                  do k = 1,3
                     op_br(i,j) = op_br(i,j) &
                          &           + altv(l,i)*op_tl(l,k,no)*rltv(k,j)
                  enddo
               enddo
               op_br(i,j) = op_br(i,j)/PAI2
            enddo
         enddo
         if(il<=0 .or. pg_symbol_system == 'hexagonal') then
            write(nfout,*) ' #symmetry op. = ', no, d6h_symbol(ig01(1))
         else
            write(nfout,*) ' #symmetry op. = ', no, oh_symbol(ig01(1))
         end if
         do i = 1, 3
            write(nfout,'(4f8.4,3x,4f8.4)') &
                 &           (op_tl(i,j,no),j=1,3),tau_tl(i,no,CARTS) &
                 &          ,(op_br(i,j),j=1,3),tau_tl(i,no,BUCS)
         enddo
      end do
    end subroutine wd_op_and_tau

    subroutine op_tau_tl()  ! --> op,tau 
      integer ::              i

      if(ngen_tl < 1) return

      op_tl = 0.d0
      do i = 1, ngen_tl
         op_tl(1,1,i) = 1.d0
         op_tl(2,2,i) = 1.d0
         op_tl(3,3,i) = 1.d0
         tau_tl(1,i,BUCS) = dble(jgen_tl(1,1,i))/dble(jgen_tl(2,1,i))
         tau_tl(2,i,BUCS) = dble(jgen_tl(1,2,i))/dble(jgen_tl(2,2,i))
         tau_tl(3,i,BUCS) = dble(jgen_tl(1,3,i))/dble(jgen_tl(2,3,i))
      end do
    end subroutine op_tau_tl

    subroutine tau_in_CARTS
      integer i, no
      if(ngen_tl < 1) return
      do i = 1, 3
         do no = 1, ngen_tl
            tau_tl(i,no,CARTS) = (altv(i,1)*tau_tl(1,no,BUCS) &
                 &     +          altv(i,2)*tau_tl(2,no,BUCS) &
                 &     +          altv(i,3)*tau_tl(3,no,BUCS))
         enddo
      enddo
    end subroutine tau_in_CARTS
  end subroutine m_CS_gnrt_symm_operators_tl

! ================================== modified by K. Tagami ========== 11.0Ex
  subroutine m_CS_op_in_PUCV(nfout,op_br, n, print_flag, comment )
! =================================================================== 11.0Ex
    integer, intent(in) :: nfout, n
    real(kind=DP), intent(out), dimension(3,3,n) :: op_br

! ================================== added by K. Tagami ========== 11.0Ex
    logical, optional, intent(in) :: print_flag
    character(len=*), optional, intent(in) :: comment
!
    logical :: print_go_flag
! =================================================================== 11.0Ex
    integer :: i,j,l,k,no
    op_br = 0.d0
! ================================== added by K. Tagami ========== 11.0Ex
    print_go_flag = .true.
    if ( present(print_flag) ) then
       print_go_flag = print_flag
    endif
! =================================================================== 11.0Ex

    if ( iprisym >=2 ) symmetry_not_printed = .true.
!!    if ( noncol ) symmetry_not_printed = .true.

! ================================== modified by K. Tagami ========== 11.0Ex
    if(ipri >= 1 .and. print_go_flag .and. symmetry_not_printed) then
       if ( present(comment) ) then
          write(nfout,*) comment
       endif
       write(nfout,*) ' --- Symmetry Operations (CARTS, PUCV) --- (m_CS_op_in_PUCV)'
       write(nfout,'(" !! nopr+af, n = ",2i6)') nopr+af,n
    end if
! ==================================================================== 11.0Ex

    do no = 1, nopr + af
       do i = 1, 3
          do j = 1, 3
             op_br(i,j,no) = 0.d0
             do l = 1,3
                do k = 1,3
                   op_br(i,j,no) = op_br(i,j,no) &
                        &           + altv(l,i)*op(l,k,no)*rltv(k,j)
                enddo
             enddo
             op_br(i,j,no) = op_br(i,j,no)/PAI2
          enddo
       enddo

! ================================== modified by K. Tagami ========== 11.0Ex
!       if(ipri >= 1 .and. printable) then
       if(ipri >= 1 .and. printable .and. print_go_flag .and. symmetry_not_printed) then
! ==================================================================== 11.0Ex
! ================================= Added by K. Tagami =============
          if( no<= nopr ) then
! ==================================================================
             if(il<=0 .or. pg_symbol_system == 'hexagonal') then
                write(nfout,*) ' #symmetry op. = ', no, d6h_symbol(ig01(no))
             else
                write(nfout,*) ' #symmetry op. = ', no, oh_symbol(ig01(no))
             end if
          else
             if(il<=0 .or. pg_symbol_system == 'hexagonal') then
                write(nfout,*) ' #symmetry op. = ', no, d6h_symbol(iaf)
             else
                write(nfout,*) ' #symmetry op. = ', no, oh_symbol(iaf)
             end if
          end if
          do i = 1, 3
             write(nfout,'(4f8.4,3x,4f8.4)') &
                  &           (op   (i,j,no),j=1,3),tau(i,no,CARTS) &
                  &          ,(op_br(i,j,no),j=1,3),tau(i,no,BUCS)
          enddo
       endif
    enddo
    if(ipri >= 1.and.printable.and.print_go_flag.and.symmetry_not_printed) symmetry_not_printed = .false.
  end subroutine m_CS_op_in_PUCV


! ================================== modified by K. Tagami ========== 11.0Ex
  subroutine m_CS_op_in_PUCD(nfout,op_pr, n, print_flag, comment )
! =================================================================== 11.0Ex

    integer, intent(in) :: nfout, n
    real(kind=DP), intent(out), dimension(3,3,n) :: op_pr
      
! ================================== added by K. Tagami ========== 11.0Ex
    logical, optional, intent(in) :: print_flag
    character(len=*), optional, intent(in) :: comment
!
    logical :: print_go_flag
! =================================================================== 11.0Ex

    integer :: i,j,l,k,no

    op_pr = 0.d0

! ================================== added by K. Tagami ========== 11.0Ex
    print_go_flag = .true.
    if ( present(print_flag) ) then
       print_go_flag = print_flag
    endif
! =================================================================== 11.0Ex

! ================================== modified by K. Tagami ========== 11.0Ex
    if(ipri >= 1 .and. print_go_flag .and. symmetry_not_printed) then
       if ( present(comment) ) then
           write(nfout,*) comment
       endif
       write(nfout,*) ' --- Symmetry Operations (CARTS, PUCD) ---'
       write(nfout,'(" !! nopr+af, n = ",2i6)') nopr+af,n
    end if
! ==================================================================== 11.0Ex

    do no = 1, nopr + af
       do i = 1, 3
          do j = 1, 3
             op_pr(i,j,no) = 0.d0
             do l = 1,3
                do k = 1,3
                   op_pr(i,j,no) = op_pr(i,j,no) &
                        &           + rltv(l,i)*op(l,k,no)*altv(k,j)
                enddo
             enddo
             op_pr(i,j,no) = op_pr(i,j,no)/PAI2
          enddo
       enddo

! ================================== modified by K. Tagami ========== 11.0Ex
!       if(ipri >= 1) then
       if(ipri >= 1 .and. print_go_flag .and. symmetry_not_printed) then
! ==================================================================== 11.0Ex
          write(nfout,*) ' #symmetry op. = ', no
          do i = 1, 3
             write(nfout,'(4f8.4,3x,4f8.4)') &
                  &           (op   (i,j,no),j=1,3),tau(i,no,CARTS) &
                  &          ,(op_pr(i,j,no),j=1,3),tau(i,no,BUCS)
          enddo
       endif
    enddo
    if(ipri >= 1.and.print_go_flag.and.symmetry_not_printed) symmetry_not_printed=.false.
  end subroutine m_CS_op_in_PUCD

  subroutine m_CS_gnrt_tmatrices(il)
! This subroutine was coded by BETSUYAKU, K. (Fuji Research Institute Co., Ltd.), July 2003

    integer,       intent(in)    :: il
    real(kind=DP)                :: unimat(3,3) = 0.d0
    real(kind=DP), parameter     :: one=1.d0, half=0.5d0, &
         &                          one3rd = 0.33333333333333333d0, &
         &                          two3rd = 0.66666666666666667d0, &
         &                          epsilon = 1.d-10
    integer                      :: ido, jdo

    b2pmat(1,1) = one ; b2pmat(2,2) = one ; b2pmat(3,3) = one
    p2bmat(1,1) = one ; p2bmat(2,2) = one ; p2bmat(3,3) = one

    if (il == -1) then                  ! Trigonal

       b2pmat(1,1) =  two3rd ; b2pmat(1,2) =  one3rd ; b2pmat(1,3) =  one3rd
       b2pmat(2,1) = -one3rd ; b2pmat(2,2) =  one3rd ; b2pmat(2,3) =  one3rd
       b2pmat(3,1) = -one3rd ; b2pmat(3,2) = -two3rd ; b2pmat(3,3) =  one3rd

       p2bmat(1,1) =  one ; p2bmat(1,2) = -one ; p2bmat(1,3) = 0.d0
       p2bmat(2,1) = 0.d0 ; p2bmat(2,2) =  one ; p2bmat(2,3) = -one
       p2bmat(3,1) =  one ; p2bmat(3,2) =  one ; p2bmat(3,3) =  one

    else if (il == 0) then              ! Primitive (Hexagonal)
    else if (il == 1) then              ! Primitive
    else if (il == 2) then              ! Face-centered

       b2pmat(1,1) =  0.d0  ;   b2pmat(1,2) =  half  ;   b2pmat(1,3) =  half
       b2pmat(2,1) =  half  ;   b2pmat(2,2) =  0.d0  ;   b2pmat(2,3) =  half
       b2pmat(3,1) =  half  ;   b2pmat(3,2) =  half  ;   b2pmat(3,3) =  0.d0

       p2bmat(1,1) = -one ;  p2bmat(1,2) =  one ;  p2bmat(1,3) =  one
       p2bmat(2,1) =  one ;  p2bmat(2,2) = -one ;  p2bmat(2,3) =  one
       p2bmat(3,1) =  one ;  p2bmat(3,2) =  one ;  p2bmat(3,3) = -one

    else if (il == 3) then              ! Body-centered

       b2pmat(1,1) = -half  ;   b2pmat(1,2) =  half  ;   b2pmat(1,3) =  half
       b2pmat(2,1) =  half  ;   b2pmat(2,2) = -half  ;   b2pmat(2,3) =  half
       b2pmat(3,1) =  half  ;   b2pmat(3,2) =  half  ;   b2pmat(3,3) = -half

       p2bmat(1,1) =  0.d0 ; p2bmat(1,2) =  one  ; p2bmat(1,3) =  one
       p2bmat(2,1) =  one  ; p2bmat(2,2) =  0.d0 ; p2bmat(2,3) =  one
       p2bmat(3,1) =  one  ; p2bmat(3,2) =  one  ; p2bmat(3,3) =  0.d0

    else if (il == 4) then              ! Base-centered

       b2pmat(1,1) =  half  ;   b2pmat(1,2) = -half  ;   b2pmat(1,3) =  0.d0
       b2pmat(2,1) =  half  ;   b2pmat(2,2) =  half  ;   b2pmat(2,3) =  0.d0
       b2pmat(3,1) =  0.d0  ;   b2pmat(3,2) =  0.d0  ;   b2pmat(3,3) =  one

       p2bmat(1,1) =  one  ; p2bmat(1,2) =  one  ; p2bmat(1,3) =  0.d0
       p2bmat(2,1) = -one  ; p2bmat(2,2) =  one  ; p2bmat(2,3) =  0.d0
       p2bmat(3,1) =  0.d0 ; p2bmat(3,2) =  0.d0 ; p2bmat(3,3) =  one

    else
       if(printable) write(6,*) 'The value of il is invalid. il =', il
       !stop
       call phase_error_with_msg(6, 'The value of il is invalid. ',__LINE__,__FILE__)
    end if

    unimat = matmul(b2pmat,p2bmat)
    do ido = 1, 3
       do jdo = 1, 3
          if (ido == jdo) then
             if ((unimat(ido,jdo)-one) > epsilon) call phase_error_with_msg(6, 'not unit matrix' &
                                                  , __LINE__, __FILE__)
          else
             if (unimat(ido,jdo) > epsilon) call phase_error_with_msg(6, 'not unit matrix' &
                                                  , __LINE__, __FILE__)
          end if
       end do
    end do

  end subroutine m_CS_gnrt_tmatrices

  subroutine m_CS_phonon_symmetry(on_or_off)
    use m_Files, only : nfout
    integer, intent(in) :: on_or_off
    integer :: i

    if(on_or_off == ON) then
       nopr = phonon_nopr
       if(printable) then
          do i=1,nopr
             write(nfout,'(i2)') i
             write(nfout,'(3(1x,f10.5),2x,f10.5)') op(1,1:3,i),tau(1,i,CARTS)
             write(nfout,'(3(1x,f10.5),2x,f10.5)') op(2,1:3,i),tau(2,i,CARTS)
             write(nfout,'(3(1x,f10.5),2x,f10.5)') op(3,1:3,i),tau(3,i,CARTS)
          end do
       end if
    else
       phonon_nopr = nopr
       nopr = 1
       ngen = 1 
       igen(ngen)=1
       jgen(1,1:3,ngen) = 0
       jgen(2,1:3,ngen) = 1
    end if

  end subroutine m_CS_phonon_symmetry

  subroutine set_strain_tensor()
    integer :: iret
    integer :: f_getRealValue
    real(kind=DP) :: val

    if(f_getRealValue( "e11", val, '') == 0) strain(1,1) = val
    if(f_getRealValue( "e12", val, '') == 0) strain(1,2) = val
    if(f_getRealValue( "e13", val, '') == 0) strain(1,3) = val
    if(f_getRealValue( "e21", val, '') == 0) strain(2,1) = val
    if(f_getRealValue( "e22", val, '') == 0) strain(2,2) = val
    if(f_getRealValue( "e23", val, '') == 0) strain(2,3) = val
    if(f_getRealValue( "e31", val, '') == 0) strain(3,1) = val
    if(f_getRealValue( "e32", val, '') == 0) strain(3,2) = val
    if(f_getRealValue( "e33", val, '') == 0) strain(3,3) = val

  end subroutine set_strain_tensor

  subroutine set_strained_cell(avec,bvec,cvec)
    real(kind=DP), intent(inout), dimension(3) :: avec,bvec,cvec

    integer :: i,j
    real(kind=DP), dimension(3) :: avec0,bvec0,cvec0

    avec0 = avec; bvec0 = bvec; cvec0 = cvec
    do i=1,3
       do j=1,3
          avec(i) = avec(i) + strain(i,j)*avec0(j)
          bvec(i) = bvec(i) + strain(i,j)*bvec0(j)
          cvec(i) = cvec(i) + strain(i,j)*cvec0(j)
       end do
    end do

  end subroutine set_strained_cell

  subroutine m_CS_supercell(nfout)
    integer, intent(in) :: nfout
    integer :: i,j,k,n,l
    real(kind=DP) :: bltv(3,3)
    
    if(sw_supercell == ON) then
       if(supercell_unit_type == BRAVAIS) then
          do j=1,3
             do i=1,3
                bltv(i,j) = sum(altv(i,1:3)*p2bmat(j,1:3))
             end do
          end do
       else ! PRIMITIVE
          bltv = altv
       end if
       altv_super(1:3,1) = n1_sc*bltv(1:3,1)
       altv_super(1:3,2) = n2_sc*bltv(1:3,2)
       altv_super(1:3,3) = n3_sc*bltv(1:3,3)
       call altv_2_rltv(altv_super,rltv_super,univol_super,rvol_super)  ! in b_CS
       if(printable) then
          write(nfout,'("rltv_super",28x,"altv_super")') 
          do i=1,3
             write(nfout,'(3(1x,f10.5),2x,3(1x,f10.5))') rltv_super(i,1:3), altv_super(i,1:3) 
          end do
       end if

       altv_prim = altv
       rltv_prim = rltv
       univol_prim = univol
       rvol_prim = rvol

       altv = altv_super
       rltv = rltv_super
       univol = univol_super
       rvol = rvol_super

       if(il<=1.or.supercell_unit_type==PRIMITIVE) then
          ! trigonal, hexagonal, primitive
          nlpnt = n1_sc*n2_sc*n3_sc
       else if(il==2) then ! facecentered
          nlpnt = n1_sc*n2_sc*n3_sc*4
       else if(il==3.or.il==4) then ! bodycentered, basecentered
          nlpnt = n1_sc*n2_sc*n3_sc*2
       end if
       allocate(lpnt(nlpnt,3))
       n = 0
       do k=0,n3_sc-1
          do j=0,n2_sc-1
             do i=0,n1_sc-1
                if(il<=1.or.supercell_unit_type==PRIMITIVE) then
                ! trigonal, hexagonal, primitive
                   n = n + 1
                   lpnt(n,1:3) = bltv(1:3,1)*i+bltv(1:3,2)*j+bltv(1:3,3)*k
                else if(il==2) then ! facecentered
                   n = n + 4
                   lpnt(n-3,1:3) = bltv(1:3,1)*i+bltv(1:3,2)*j+bltv(1:3,3)*k
                   lpnt(n-2,1:3) = lpnt(n-3,1:3)+0.5d0*(bltv(1:3,2)+bltv(1:3,3))
                   lpnt(n-1,1:3) = lpnt(n-3,1:3)+0.5d0*(bltv(1:3,1)+bltv(1:3,3))
                   lpnt(n  ,1:3) = lpnt(n-3,1:3)+0.5d0*(bltv(1:3,1)+bltv(1:3,2))
                else if(il==3) then ! bodycentered
                   n = n + 2
                   lpnt(n-1,1:3) = bltv(1:3,1)*i+bltv(1:3,2)*j+bltv(1:3,3)*k
                   lpnt(n  ,1:3) = lpnt(n-1,1:3)+0.5d0*(bltv(1:3,1)+bltv(1:3,2)+bltv(1:3,3))
                else if(il==4) then ! basecentered
                   n = n + 2
                   lpnt(n-1,1:3) = bltv(1:3,1)*i+bltv(1:3,2)*j+bltv(1:3,3)*k
                   lpnt(n  ,1:3) = lpnt(n-1,1:3)+0.5d0*(bltv(1:3,1)+bltv(1:3,2))
                end if
             end do
          end do
       end do

    end if
  end subroutine m_CS_supercell

  subroutine m_CS_supercell_on(nfout,uc_type,n1,n2,n3)
    integer, intent(in) :: nfout,uc_type,n1,n2,n3
    sw_supercell = ON
    supercell_unit_type = uc_type
    n1_sc = n1
    n2_sc = n2
    n3_sc = n3
    if(printable) write(nfout,'("supercell_on: uc_type,n1,n2,n3=",4i4)') uc_type,n1,n2,n3
  end subroutine m_CS_supercell_on

  subroutine m_CS_set_altv_prim
    altv = altv_prim
    rltv = rltv_prim
    univol = univol_prim
    rvol = rvol_prim
  end subroutine m_CS_set_altv_prim

  subroutine m_CS_set_altv_super
    altv = altv_super
    rltv = rltv_super
    univol = univol_super
    rvol = rvol_super
  end subroutine m_CS_set_altv_super

  subroutine m_CS_set_inv_sym_off()
    inversion_symmetry = OFF
  end subroutine m_CS_set_inv_sym_off

  subroutine m_CS_dealloc(neb_mode)
    logical, intent(in), optional :: neb_mode
    logical :: neb
    neb = .false.

! === KT_add === 13.1R
    if ( sw_keep_symmetry_strict == ON ) call m_CS_save_op_tau
! ============== 13.1R

    if(present(neb_mode)) neb = neb_mode
    if(allocated(op)) deallocate(op)
    if(allocated(tau)) deallocate(tau)
    if(.not.neb)then
       if(allocated(igen)) deallocate(igen)
       if(allocated(jgen)) deallocate(jgen)
       if(allocated(lpnt)) deallocate(lpnt)
       if(allocated(jgen_tl)) deallocate(jgen_tl)
       if(allocated(op_tl)) deallocate(op_tl)
       if(allocated(tau_tl)) deallocate(tau_tl)
    endif
  end subroutine m_CS_dealloc

! === KT_add == 13.1R
  subroutine m_CS_dealloc_op_tau
    if(allocated(op)) deallocate(op)
    if(allocated(tau)) deallocate(tau)
  end subroutine m_CS_dealloc_op_tau

  subroutine m_CS_save_op_tau
    if ( .not. allocated( op_previous ) )  allocate( op_previous( 3,3,nopr+af) )
    if ( .not. allocated( tau_previous ) ) allocate( tau_previous(3,nopr+af,CRDTYP) )
    nopr_previous = nopr;    op_previous = op;     tau_previous = tau
  end subroutine m_CS_save_op_tau

  subroutine m_CS_read_op_tau_previous
    integer :: iopr, i, j

    if ( sw_keep_symmetry_strict == OFF) return

    nopr = nopr_previous  
    if ( .not. allocated( op ) )  allocate( op( 3,3,nopr+af) )
    if ( .not. allocated( tau ) ) allocate( tau(3,nopr+af,CRDTYP) )

    op = op_previous;     tau = tau_previous

    do iopr=1, nopr +af
       do i=1, 3
          tau(i,iopr,CARTS) = altv(1,i)*tau(1,iopr,BUCS) &
               &     +      altv(2,i)*tau(2,iopr,BUCS) &
               &     +      altv(3,i)*tau(3,iopr,BUCS)
       enddo
    enddo

#if 0
    Do iopr=1, nopr
       write(800+mype,*) 'iopr = ', iopr
       Do i=1, 3
          write(800+mype,*) tau( i,iopr,CARTS), tau_previous( i,iopr, CARTS )
       End do
    End do
#endif

  end subroutine m_CS_read_op_tau_previous
! ============== 13.1R

! ======================== added by K. Tagami ==================== 12.0YAM
  subroutine check_if_sw_inversion_is_valid( nfout )
    integer, intent(in) :: nfout

    integer :: iopr

    real(kind=DP), parameter :: eps = 1.d-4
    real(kind=DP) :: c1

    logical :: Flag_inverse, sw_inversion_is_valid

    if ( inversion_symmetry == OFF ) return

    Flag_inverse = .false.
    sw_inversion_is_valid = .false.

    Do iopr=1, nopr
       if ( abs(op(1,1,iopr)+1.d0) < eps .and. &
            & abs(op(2,2,iopr)+1.d0) < eps .and. &
            & abs(op(3,3,iopr)+1.d0) < eps .and. &
            & abs(op(1,2,iopr)) < eps .and. &
            & abs(op(2,1,iopr)) < eps .and. &
            & abs(op(2,3,iopr)) < eps .and. &
            & abs(op(3,2,iopr)) < eps .and. &
            & abs(op(3,1,iopr)) < eps .and. &
            & abs(op(1,3,iopr)) < eps ) then

          Flag_inverse = .true.
       end if
!
       if ( Flag_inverse ) then
          c1 = abs( tau(1,iopr,BUCS) ) + abs( tau(2,iopr,BUCS) ) &
               &                       + abs( tau(3,iopr,BUCS) )
          if ( c1 < eps ) then
             sw_inversion_is_valid = .true.
          endif
          exit
       endif

    End do
! -------
    if ( sw_inversion_is_valid ) then
       write(nfout,*) '********************************************************'
       write(nfout,*) '******** Confirmed that sw_inversion is avalibale *****'
       write(nfout,*) '********************************************************'
    else
       if ( Flag_inverse ) then
          write(nfout,*) '********************************************************'
          write(nfout,*) '*   sw_inversion is invalid in this system !! '
          write(nfout,*) '*   Translation vector is non-zero for inversion operation'
          write(nfout,*) '********************************************************'
       else
          write(nfout,*) '********************************************************'
          write(nfout,*) '*   sw_inversion is invalid in this system !! '
          write(nfout,*) '*   Inversion operation does not exist'
          write(nfout,*) '********************************************************'
       endif
       call phase_error_with_msg(nfout,'sw_inversion is invalid',__LINE__,__FILE__)
    endif

  end subroutine check_if_sw_inversion_is_valid
! ================================================================ 12.0YAM

  subroutine m_CS_wd_BandSymInput(ipri,nfout,nf)
    integer, intent(in) :: ipri, nfout, nf
    character :: TF_inversion_symmetry ! {'T'|'F'}
    integer :: i, j
    integer :: id_sname = -1
    call tstatc0_begin('m_CS_wd_BandSymInput ',id_sname)
    if(mype == 0) then
       write(nf,'("##CRYSTAL_DATA")')
       write(nf,'("#LATTICE_SYSTEM")')
       if(inversion_symmetry == 0) TF_inversion_symmetry = 'F'
       if(inversion_symmetry == 1) TF_inversion_symmetry = 'T'
       write(nf,'(a,3x,a,3x,"! System{Rhombo|Hexa|Primitive|FCC|BCC|CBaseCentered},InversionSymmetry"/,"#")') &
            & Char_lattice_system(il), TF_inversion_symmetry

       write(nf,'("#GENERATORS")')
       write(nf,'(7(i0,1x))') (igen(i),(jgen(1,j,i),jgen(2,j,i),j=1,3),i=1,ngen);  write(nf,'("#")')

       write(nf,'("#BRAVAIS_LATTICE_PARAMETER"/,3f22.6," ! a,b,c"/,3f22.6," ! alpha,beta,gamma"/"#")') &
            & Bravais_lattice_length, Bravais_lattice_angle

       write(nf,'("#PRIMITIVE_LATTICE_PARAMETER",3(/,3f11.5,4x,3f11.5," ! rltv, altv"),/"#")') &
            &          ((rltv(i,j),j=1,3),(altv(i,j),j=1,3),i=1,3)
       write(nf,'("##"/)')
    end if
    call tstatc0_end(id_sname)
  end subroutine m_CS_wd_BandSymInput

end module m_Crystal_Structure

      SUBROUTINE ZLAED7( N, CUTPNT, QSIZ, TLVLS, CURLVL, CURPBM, D, Q,
     $                   LDQ, RHO, INDXQ, QSTORE, QPTR, PRMPTR, PERM,
     $                   GIVPTR, GIVCOL, GIVNUM, WORK, RWORK, IWORK,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            CURLVL, CURPBM, CUTPNT, INFO, LDQ, N, QSIZ,
     $                   TLVLS
      DOUBLE PRECISION   RHO
*     ..
*     .. Array Arguments ..
      INTEGER            GIVCOL( 2, * ), GIVPTR( * ), INDXQ( * ),
     $                   IWORK( * ), PERM( * ), PRMPTR( * ), QPTR( * )
      DOUBLE PRECISION   D( * ), GIVNUM( 2, * ), QSTORE( * ), RWORK( * )
      COMPLEX*16         Q( LDQ, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZLAED7 computes the updated eigensystem of a diagonal
*  matrix after modification by a rank-one symmetric matrix. This
*  routine is used only for the eigenproblem which requires all
*  eigenvalues and optionally eigenvectors of a dense or banded
*  Hermitian matrix that has been reduced to tridiagonal form.
*
*    T = Q(in) ( D(in) + RHO * Z*Z' ) Q'(in) = Q(out) * D(out) * Q'(out)
*
*    where Z = Q'u, u is a vector of length N with ones in the
*    CUTPNT and CUTPNT + 1 th elements and zeros elsewhere.
*
*     The eigenvectors of the original matrix are stored in Q, and the
*     eigenvalues are in D.  The algorithm consists of three stages:
*
*        The first stage consists of deflating the size of the problem
*        when there are multiple eigenvalues or if there is a zero in
*        the Z vector.  For each such occurence the dimension of the
*        secular equation problem is reduced by one.  This stage is
*        performed by the routine DLAED2.
*
*        The second stage consists of calculating the updated
*        eigenvalues. This is done by finding the roots of the secular
*        equation via the routine DLAED4 (as called by SLAED3).
*        This routine also calculates the eigenvectors of the current
*        problem.
*
*        The final stage consists of computing the updated eigenvectors
*        directly using the updated eigenvalues.  The eigenvectors for
*        the current problem are multiplied with the eigenvectors from
*        the overall problem.
*
*  Arguments
*  =========
*
*  N      (input) INTEGER
*         The dimension of the symmetric tridiagonal matrix.  N >= 0.
*
*  CUTPNT (input) INTEGER
*         Contains the location of the last eigenvalue in the leading
*         sub-matrix.  min(1,N) <= CUTPNT <= N.
*
*  QSIZ   (input) INTEGER
*         The dimension of the unitary matrix used to reduce
*         the full matrix to tridiagonal form.  QSIZ >= N.
*
*  TLVLS  (input) INTEGER
*         The total number of merging levels in the overall divide and
*         conquer tree.
*
*  CURLVL (input) INTEGER
*         The current level in the overall merge routine,
*         0 <= curlvl <= tlvls.
*
*  CURPBM (input) INTEGER
*         The current problem in the current level in the overall
*         merge routine (counting from upper left to lower right).
*
*  D      (input/output) DOUBLE PRECISION array, dimension (N)
*         On entry, the eigenvalues of the rank-1-perturbed matrix.
*         On exit, the eigenvalues of the repaired matrix.
*
*  Q      (input/output) COMPLEX*16 array, dimension (LDQ,N)
*         On entry, the eigenvectors of the rank-1-perturbed matrix.
*         On exit, the eigenvectors of the repaired tridiagonal matrix.
*
*  LDQ    (input) INTEGER
*         The leading dimension of the array Q.  LDQ >= max(1,N).
*
*  RHO    (input) DOUBLE PRECISION
*         Contains the subdiagonal element used to create the rank-1
*         modification.
*
*  INDXQ  (output) INTEGER array, dimension (N)
*         This contains the permutation which will reintegrate the
*         subproblem just solved back into sorted order,
*         ie. D( INDXQ( I = 1, N ) ) will be in ascending order.
*
*  IWORK  (workspace) INTEGER array, dimension (4*N)
*
*  RWORK  (workspace) DOUBLE PRECISION array,
*                                 dimension (3*N+2*QSIZ*N)
*
*  WORK   (workspace) COMPLEX*16 array, dimension (QSIZ*N)
*
*  QSTORE (input/output) DOUBLE PRECISION array, dimension (N**2+1)
*         Stores eigenvectors of submatrices encountered during
*         divide and conquer, packed together. QPTR points to
*         beginning of the submatrices.
*
*  QPTR   (input/output) INTEGER array, dimension (N+2)
*         List of indices pointing to beginning of submatrices stored
*         in QSTORE. The submatrices are numbered starting at the
*         bottom left of the divide and conquer tree, from left to
*         right and bottom to top.
*
*  PRMPTR (input) INTEGER array, dimension (N lg N)
*         Contains a list of pointers which indicate where in PERM a
*         level's permutation is stored.  PRMPTR(i+1) - PRMPTR(i)
*         indicates the size of the permutation and also the size of
*         the full, non-deflated problem.
*
*  PERM   (input) INTEGER array, dimension (N lg N)
*         Contains the permutations (from deflation and sorting) to be
*         applied to each eigenblock.
*
*  GIVPTR (input) INTEGER array, dimension (N lg N)
*         Contains a list of pointers which indicate where in GIVCOL a
*         level's Givens rotations are stored.  GIVPTR(i+1) - GIVPTR(i)
*         indicates the number of Givens rotations.
*
*  GIVCOL (input) INTEGER array, dimension (2, N lg N)
*         Each pair of numbers indicates a pair of columns to take place
*         in a Givens rotation.
*
*  GIVNUM (input) DOUBLE PRECISION array, dimension (2, N lg N)
*         Each number indicates the S value to be used in the
*         corresponding Givens rotation.
*
*  INFO   (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if INFO = 1, an eigenvalue did not converge
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            COLTYP, CURR, I, IDLMDA, IND1, IND2, INDX,
     $                   INDXC, INDXP, IQ, IW, IZ, K, N1, N2, PTR
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLAED9, DLAEDA, DLAMRG, XERBLA, ZLACRM, ZLAED8
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
*     IF( ICOMPQ.LT.0 .OR. ICOMPQ.GT.1 ) THEN
*        INFO = -1
*     ELSE IF( N.LT.0 ) THEN
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( MIN( 1, N ).GT.CUTPNT .OR. N.LT.CUTPNT ) THEN
         INFO = -2
      ELSE IF( QSIZ.LT.N ) THEN
         INFO = -3
      ELSE IF( LDQ.LT.MAX( 1, N ) ) THEN
         INFO = -9
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZLAED7', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     The following values are for bookkeeping purposes only.  They are
*     integer pointers which indicate the portion of the workspace
*     used by a particular array in DLAED2 and SLAED3.
*
      IZ = 1
      IDLMDA = IZ + N
      IW = IDLMDA + N
      IQ = IW + N
*
      INDX = 1
      INDXC = INDX + N
      COLTYP = INDXC + N
      INDXP = COLTYP + N
*
*     Form the z-vector which consists of the last row of Q_1 and the
*     first row of Q_2.
*
      PTR = 1 + 2**TLVLS
      DO 10 I = 1, CURLVL - 1
         PTR = PTR + 2**( TLVLS-I )
   10 CONTINUE
      CURR = PTR + CURPBM
      CALL DLAEDA( N, TLVLS, CURLVL, CURPBM, PRMPTR, PERM, GIVPTR,
     $             GIVCOL, GIVNUM, QSTORE, QPTR, RWORK( IZ ),
     $             RWORK( IZ+N ), INFO )
*
*     When solving the final problem, we no longer need the stored data,
*     so we will overwrite the data from this level onto the previously
*     used storage space.
*
      IF( CURLVL.EQ.TLVLS ) THEN
         QPTR( CURR ) = 1
         PRMPTR( CURR ) = 1
         GIVPTR( CURR ) = 1
      END IF
*
*     Sort and Deflate eigenvalues.
*
      CALL ZLAED8( K, N, QSIZ, Q, LDQ, D, RHO, CUTPNT, RWORK( IZ ),
     $             RWORK( IDLMDA ), WORK, QSIZ, RWORK( IW ),
     $             IWORK( INDXP ), IWORK( INDX ), INDXQ,
     $             PERM( PRMPTR( CURR ) ), GIVPTR( CURR+1 ),
     $             GIVCOL( 1, GIVPTR( CURR ) ),
     $             GIVNUM( 1, GIVPTR( CURR ) ), INFO )
      PRMPTR( CURR+1 ) = PRMPTR( CURR ) + N
      GIVPTR( CURR+1 ) = GIVPTR( CURR+1 ) + GIVPTR( CURR )
*
*     Solve Secular Equation.
*
      IF( K.NE.0 ) THEN
         CALL DLAED9( K, 1, K, N, D, RWORK( IQ ), K, RHO,
     $                RWORK( IDLMDA ), RWORK( IW ),
     $                QSTORE( QPTR( CURR ) ), K, INFO )
         CALL ZLACRM( QSIZ, K, WORK, QSIZ, QSTORE( QPTR( CURR ) ), K, Q,
     $                LDQ, RWORK( IQ ) )
         QPTR( CURR+1 ) = QPTR( CURR ) + K**2
         IF( INFO.NE.0 ) THEN
            RETURN
         END IF
*
*     Prepare the INDXQ sorting premutation.
*
         N1 = K
         N2 = N - K
         IND1 = 1
         IND2 = N
         CALL DLAMRG( N1, N2, D, 1, -1, INDXQ )
      ELSE
         QPTR( CURR+1 ) = QPTR( CURR )
         DO 20 I = 1, N
            INDXQ( I ) = I
   20    CONTINUE
      END IF
*
      RETURN
*
*     End of ZLAED7
*
      END

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  MODULE: m_PAW_ChargeDensity
!
!  AUTHOR(S): T. Yamasaki, T. Yamamoto and T. Ohno November/2009
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_PAW_ChargeDensity
  use m_db,                   only : getIntDB,getStringDB_TB,getIntDB_TB
  use m_Const_Parameters,     only : DP,PAI2,PAI4,BUCS,SphericalHarmonicsExpansion, GaussLegendre, LOWER, Bohr &
       &                           , FMAXVALLEN,NOCONV, ON, UP, OFF, AMU
  use m_Control_Parameters,   only : kimg,nspin,af,ipripaw,ipriinputfile,printable
  use m_Files,                only : nfout
  use m_Ionic_System,         only : ityp,natm,ntyp,pos,iwei, speciesname, amion, surface_integral_method_paw
  use m_Charge_Density,       only : hsr,chgq_l,chgsoft
  use m_PlaneWaveBasisSet,    only : igfp_l
  use m_PseudoPotential,      only : psirpw,phirpw,qrspspw &
       &                            ,rhcorpw,rhpcrpw &
       &                            ,ilmt,ltp,mtp,taup,radr_paw &
       &                            ,il2p,isph,dl2p,iqitg &
       &                            ,m_PP_find_maximum_l &
       &                            ,ipaw,wf_mnrc,flg_symmtry &
       &                            ,mmesh, nmesh
  use m_FFT,                  only : fft_box_size_CD,fft_box_size_CD_c, nfftp &
       , m_FFT_CD_inverse0 &
       , m_FFT_check_of_negative_CD &
       , m_FFT_cp_afft_CD &
       , m_FFT_alloc_CD_box &
       , m_FFT_dealloc_CD_box
  use m_Parallelization,      only : ista_kngp,iend_kngp,npes,mype,ierr &
       , ista_fftp,iend_fftp &
       , nis_fftp,nie_fftp,mp_fftp &
       , npes_cdfft, ista_fftph, iend_fftph &
       , MPI_CommGroup
  use m_Crystal_Structure,    only : altv,rltv,nopr,m_CS_op_in_PUCD,tau,op
  use m_PAW_Tecplot,          only : unusedUnit,output_box_tecplot
  use m_PlaneWaveBasisSet,    only : ngabc,kgp, kgp_reduced
  use m_Timing,               only : tstatc0_begin, tstatc0_end

! ============================ added by K. Tagami =============== 11.0
  use m_Control_Parameters,    only : ndim_magmom, noncol
  use m_Parallelization,      only : ista_atm, iend_atm
  use m_ES_NonCollinear,     only :  Global_Quantz_Axis_now
! =============================================================== 11.0

  use m_Control_Parameters,  only : sw_opencore, sw_xc_opencore_ae_only
  use m_PS_opencore,  only : rmag_opencore, has_opencore, mag_opencore_pol
  use mpi

  implicit none
!  include 'mpif.h'

  private

  integer:: ntheta,nphi
  real(DP),pointer,dimension(:)                 :: cos_theta
  real(DP),pointer,dimension(:)                 :: omg_wght
  real(DP),pointer,dimension(:,:,:)             :: ylm,dylm_dth,dylm_dph
  integer,pointer,dimension(:,:)               :: ia2ia_symmtry_op
  real(kind=DP), allocatable,dimension(:,:,:)  :: op_pr
!!$    character(len=64),pointer,dimension(:)       :: surface_integral_method_char
  integer,allocatable,dimension(:)             :: surface_integral_method

  real(kind=DP), pointer, dimension(:,:,:)      :: paw_cr2
  integer, pointer, dimension(:,:,:)           :: paw_isph2
  integer, pointer, dimension(:,:)             :: paw_mmt2
  integer, pointer, dimension(:)               :: paw_dnr

  character(len("paw_one_center_integral")),private,parameter :: tag_paw_integral="paw_one_center_integral"
  character(len("element_list")),private,parameter :: tag_element_list="element_list"
  character(len("element")),private,parameter :: tag_element = "element"
  character(len("surface_integral_method")),private,parameter :: tag_surface_integral_method="surface_integral_method"
  character(len("dnr")),private,parameter ::  tag_dnr = "dnr"
  character(len("SphericalHarmonicsExpansion")),private,parameter :: tag_Sphex ="sphericalharmonicsexpansion"
  character(len("SphericalHarmonics"))         ,private,parameter :: tag_Sphex2="sphericalharmonics"
  character(len("Sphex"))                      ,private,parameter :: tag_Sphex3="sphex"
  character(len("GaussLegendre"))              ,private,parameter :: tag_GL ="gausslegendre"
  character(len("GL"))                         ,private,parameter :: tag_GL2="gl"

  logical:: calcGaussLegendreIntegration = .false.
  logical:: calcSphericalHarmonicsExpansion = .false.

  public:: ntheta,nphi,omg_wght
  public:: m_PAWCD_rd_ntheta_nphi
  public:: m_PAWCD_init_surf_integration
  public:: m_PAWCD_set_ae_cd
  public:: m_PAWCD_set_ae_cd_sym
  public:: m_PAWCD_set_ae_der_cd
  public:: m_PAWCD_set_ae_der_cd_sym
  public:: m_PAWCD_set_ps_cd
  public:: m_PAWCD_set_ps_cd_sym
  public:: m_PAWCD_set_ps_der_cd
  public:: m_PAWCD_set_ps_der_cd_sym
  public:: ylm,dylm_dth,dylm_dph
  public:: cos_theta
  public:: m_PAWCD_dealloc
  public:: m_PAWCD_wd_cd

  public:: m_PAWCD_wd_number_of_state
  public:: surface_integral_method


! ======================== added by K. Tagami ================= 11.0
  integer max_sph_expansion
  parameter( max_sph_expansion = 25 )

  integer, parameter :: project_on_local_quantz_axis = 10
  integer, parameter :: project_on_global_quantz_axis = 15
!
  integer :: mode_of_projection = project_on_local_quantz_axis
!
  public :: m_PAWCD_ae_cd_sphex2_nonclA
  public :: m_PAWCD_ps_cd_sphex2_nonclA
  public :: max_sph_expansion
! ============================================================== 11.0

!!$    public:: m_PAWCD_set_ae_cd_sphex
  public:: m_PAWCD_set_ae_cd_sphex2
!!$    public:: m_PAWCD_set_ae_cd_sphex3
!!$    public:: m_PAWCD_set_ps_cd_sphex
  public:: m_PAWCD_set_ps_cd_sphex2
!!$    public:: m_PAWCD_set_ps_cd_sphex3
!!$    public:: m_PAWCD_set_sq_der_cd_sdphex
  public:: m_PAWCD_set_sq_der_cd_sdphex2
!!$    public:: m_PAWCD_set_sq_der_cd_sphex3
  public:: m_PAWCD_set_cr2_isph2_mmt2

  public:: m_PAW_dealloc
  public:: paw_cr2,paw_isph2,paw_mmt2,paw_dnr
  public:: calcGaussLegendreIntegration
  public:: calcSphericalHarmonicsExpansion

  public :: m_PAWCD_calc_contact_density

contains

  subroutine m_PAW_dealloc()
    call dealloc_integral_method_etc()
  end subroutine m_PAW_dealloc

  subroutine alloc_integral_method_etc
    allocate(surface_integral_method(ntyp));  surface_integral_method = SphericalHarmonicsExpansion
    allocate(paw_dnr(ntyp)); paw_dnr = 1
  end subroutine alloc_integral_method_etc

  subroutine dealloc_integral_method_etc()
    if(allocated(surface_integral_method)) deallocate(surface_integral_method)
    deallocate(paw_dnr)
  end subroutine dealloc_integral_method_etc

  subroutine m_PAWCD_rd_ntheta_nphi
    call getIntDB("paw surface_integration ntheta",ntheta,10)
    call getIntDB("paw surface_integration nphi",nphi,10)
    call alloc_integral_method_etc()
    surface_integral_method(:) = surface_integral_method_paw(:)
    deallocate(surface_integral_method_paw)
    call rd_surface_integral_method
    return
  end subroutine m_PAWCD_rd_ntheta_nphi

  subroutine rd_surface_integral_method
    integer :: i,j, npt, itr
    integer :: f_selectBlock, f_selectParentBlock
    integer :: f_selectFirstTableLine, f_selectNextTableLine, f_getStringValue, f_getIntValue
    logical :: found, tf
    character(len=FMAXVALLEN) :: rstr

    if(f_selectBlock(tag_paw_integral) == 0) then

       if(ipriinputfile >=2)  write(nfout,'(" !** -- tag_paw_one_center_integral --")')
       if( f_selectBlock(tag_element_list) == 0) then
          i = 1
          do while(.true.)
             if(i==1) then
                if( f_selectFirstTableLine() /= 0) then
                   exit
                end if
             else
                if( f_selectNextTableLine() /= 0) then
                   exit
                end if
             end if
             if(i > ntyp) exit
             found = .false.
             if(f_getStringValue(tag_element,rstr,NOCONV) == 0) then
                do j = 1, ntyp
                   if(trim(rstr).eq.trim(speciesname(j))) then
                      found = .true.
                      npt = j
                      exit
                   end if
                end do
             end if
             if(found) then
                if(npt >=1 .and. npt <=ntyp) then
                   if(f_getStringValue(tag_surface_integral_method,rstr,LOWER) == 0) then
                      call strncmp0(tag_Sphex,trim(rstr),tf)
                      if(.not.tf) call strncmp0(tag_Sphex2,trim(rstr),tf)
                      if(.not.tf) call strncmp0(tag_Sphex3,trim(rstr),tf)
                      if(tf) surface_integral_method(npt) = SphericalHarmonicsExpansion
                      call strncmp0(tag_GL,trim(rstr),tf)
                      if(.not.tf) call strncmp0(tag_GL2,trim(rstr),tf)
                      if(tf) surface_integral_method(npt) = GaussLegendre
                   end if
                   if(f_getIntValue(tag_dnr,itr) == 0) then
                      paw_dnr(npt) = itr
                   end if
                end if
             end if
             i = i+1
          end do
          itr = f_selectParentBlock()
       end if
       itr = f_selectParentBlock()
    end if
    if(ipriinputfile>=1) then
       write(nfout,*)
       write(nfout,*) '<***   PAW one center integral   ***>'
       do i=1,ntyp
          if(surface_integral_method(i) == SphericalHarmonicsExpansion) then
             write(nfout,'(i2,a,a,a,a,a,i2)') i,'-th element : ',trim(speciesname(i)) &
                  & ,' : ',trim(tag_Sphex),' : dnr = ',paw_dnr(i)
          else if(surface_integral_method(i) == GaussLegendre) then
             write(nfout,'(i2,a,a,a,a,a,i2)') i,'-th element : ',trim(speciesname(i)) &
                  & ,' : ',trim(tag_GL),' : dnr = ',paw_dnr(i)
          end if
          if(surface_integral_method(i) .ne. SphericalHarmonicsExpansion .and. &
               surface_integral_method(i) .ne. GaussLegendre) then
             write(nfout,*) 'Error in rd_surface_integral_method !'
             call phase_error_with_msg(nfout,'Error in rd_surface_integral_method !',__LINE__,__FILE__)
          end if
       end do
    end if

  end subroutine rd_surface_integral_method

  subroutine m_PAWCD_init_surf_integration
    logical:: doGaussLegendre
    doGaussLegendre=.false.
    call setDoGaussLegendre(doGaussLegendre)
    calcGaussLegendreIntegration=doGaussLegendre
    call setDoSphHarmonicsExpansion(calcSphericalHarmonicsExpansion)
    !        if(.not.doGaussLegendre) return
    allocate(cos_theta(ntheta));cos_theta=0
    allocate(omg_wght(ntheta));omg_wght=0
    call GaussLeg(-1.d0,1.d0,ntheta,cos_theta,omg_wght)
    omg_wght=omg_wght/2.d0/dble(nphi)
    call m_PAWCD_set_ylms(25)
    allocate(ia2ia_symmtry_op(natm,nopr+af))
    ia2ia_symmtry_op=0
    call set_ia2ia_symmtry_op
    return
  end subroutine m_PAWCD_init_surf_integration

  subroutine setDoGaussLegendre(flg)
    logical,intent(out):: flg
    integer:: i

    flg=.false.
    do i=1,ntyp
       if(ipaw(i)/=1) cycle
!!$            if(surface_integral_method(i) .eq. "GaussLegendre") then
       if(surface_integral_method(i) .eq. GaussLegendre) then
          flg=.true.
          exit
       end if
    end do
    return
  end subroutine setDoGaussLegendre

  subroutine setDoSphHarmonicsExpansion(flg)
    logical,intent(out):: flg
    integer:: i

    flg=.false.
    do i=1,ntyp
       if(ipaw(i)/=1) cycle
!!$            if(surface_integral_method(i) .eq. "SphericalHarmonicsExpansion") then
       if(surface_integral_method(i) .eq. SphericalHarmonicsExpansion) then
          flg=.true.
          exit
       end if
    end do
    return
  end subroutine setDoSphHarmonicsExpansion

  subroutine m_PAWCD_set_ylms(ilmax)
    integer,intent(in):: ilmax

    real(DP):: cos_the,sin_the
    real(DP):: phi,rr
    integer:: it,ip,itp,is
    real(DP),pointer,dimension(:)     :: gx,gy,gz,tylm
    real(DP),pointer,dimension(:,:)   :: tdylm

    allocate(gx(ntheta*nphi))
    allocate(gy(ntheta*nphi))
    allocate(gz(ntheta*nphi))
    allocate(tylm(ntheta*nphi))
    allocate(tdylm(ntheta*nphi,3))

    allocate(ylm(ntheta,nphi,ilmax))
    allocate(dylm_dth(ntheta,nphi,ilmax))
    allocate(dylm_dph(ntheta,nphi,ilmax))

    itp=0
    do it=1,ntheta
       cos_the=cos_theta(it)
       sin_the=sqrt(1.d0-cos_the*cos_the)
       do ip=1,nphi
          itp=itp+1
          phi=PAI2/dble(nphi)*dble(ip-1)
          gx(itp)=sin_the*cos(phi)
          gy(itp)=sin_the*sin(phi)
          gz(itp)=cos_the
       end do
    end do

    do is=1,ilmax
       call sphr(ntheta*nphi,is,gx,gy,gz,tylm)
       itp=0
       do it=1,ntheta
          do ip=1,nphi
             itp=itp+1
             ylm(it,ip,is)=tylm(itp)
          end do
       end do
    end do

    do is=1,ilmax
       call sphr_diff(ntheta*nphi,ntheta*nphi,is,gx,gy,gz,tdylm)
       itp=0
       do it=1,ntheta
          do ip=1,nphi
             itp=itp+1
!                    ylm(it,ip,is)=tylm(itp)
             rr=sqrt(gx(itp)**2+gy(itp)**2)
             dylm_dth(it,ip,is)= gz(itp)*gx(itp)/rr*tdylm(itp,1)+ &
                  gy(itp)*gz(itp)/rr*tdylm(itp,2)- &
                  rr*tdylm(itp,3)
             dylm_dph(it,ip,is)=-gy(itp)*tdylm(itp,1)+ &
                  gx(itp)*tdylm(itp,2)
          end do
       end do
    end do

    deallocate(gx,gy,gz,tylm,tdylm)
    return
  end subroutine m_PAWCD_set_ylms

  subroutine m_PAWCD_dealloc
! ======================= ASMS_DEBUG ================= 2013/02/07
    if (.not. associated(cos_theta)) return
                               !   sw_phonon == on .and. sw_calc_force == off
! ======================= ASMS_DEBUG ================= 2013/02/07
    deallocate(cos_theta)
    deallocate(omg_wght)
    deallocate(ylm,dylm_dth,dylm_dph)
    deallocate(ia2ia_symmtry_op)
    return
  end subroutine m_PAWCD_dealloc

  subroutine m_PAWCD_set_ae_cd(ith,iph,ia,nspin,nrc,n1nc)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: n1nc(nrc,nspin)

    real(8):: n1(nrc,nspin),sum,fac, weight
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj

    it=ityp(ia)
    n1nc=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1
       do lmt2=lmt1,ilmt(it)
          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0

          do is=1,nspin
             sum=fac*hsr(ia,lmt1,lmt2,is)* &
                  ylm(ith,iph,ii)* &
                  ylm(ith,iph,jj)
             do ir=1,nrc
                n1nc(ir,is)=n1nc(ir,is)+sum* &
                     psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)
             end do
          end do
       end do
    end do

    do is=1,nspin
       do ir=1,nrc
          n1nc(ir,is)=(n1nc(ir,is)+rhcorpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it)
       end do
    end do
    if ( sw_opencore == ON .and. nspin == 2 )then
       if ( has_opencore(it) == 1 ) then
          weight = 0.5d0 *mag_opencore_pol(ia,1)
          do ir=1,nrc
             n1nc(ir,1) = n1nc(ir,1) +rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
             n1nc(ir,2) = n1nc(ir,2) -rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
          end do
       endif
    endif
    return
  end subroutine m_PAWCD_set_ae_cd

  subroutine m_PAWCD_set_ae_cd_sym(vec0,ia,nspin,nrc,n1nc)
    integer,intent(in) :: ia,nspin,nrc
    real(DP),intent(in) :: vec0(3)
    real(8),intent(out):: n1nc(nrc,nspin)

    real(8):: n1(nrc,nspin),sum,fac,sum2, weight
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj
    integer:: ja,iopr
    real(DP),pointer,dimension(:,:):: ylm_sym
    integer :: id_sname = -1
    call tstatc0_begin('m_PAWCD_set_ae_cd_sym ',id_sname)

    allocate(ylm_sym(nopr+af,25))
    ylm_sym=0.d0
    call set_ylms_symmtry_op(ia,25,vec0,ylm_sym)

    it=ityp(ia)

    n1nc=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1
       do lmt2=lmt1,ilmt(it)
          if(nspin==1 .and.dabs(hsr(ia,lmt1,lmt2,1)) < 1.d-10) cycle
          if(nspin==2) then
             if ( dabs(hsr(ia,lmt1,lmt2,1))+dabs(hsr(ia,lmt1,lmt2,2))<1.d-10 ) cycle
          endif

          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0

          do is=1,nspin
             sum2=0.d0
             do iopr=1,nopr
                ja=abs(ia2ia_symmtry_op(ia,iopr))
                sum2=sum2+hsr(ja,lmt1,lmt2,is)* &
                     ylm_sym(iopr,ii)* &
                     ylm_sym(iopr,jj)
             end do
             sum2=sum2/dble(nopr)

             do ir=1,nrc
                n1nc(ir,is)=n1nc(ir,is)+fac* &
                     psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)* &
                     sum2
             end do
          end do

       end do
    end do

    do is=1,nspin
       do ir=1,nrc
          n1nc(ir,is)=(n1nc(ir,is)+rhcorpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it)
       end do
    end do
    if ( sw_opencore == ON .and. nspin == 2 )then
       if ( has_opencore(it) == 1 ) then
          weight = 0.5d0 *mag_opencore_pol(ia,1)
          do ir=1,nrc
             n1nc(ir,1) = n1nc(ir,1) +rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
             n1nc(ir,2) = n1nc(ir,2) -rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
          end do
       endif
    endif
    deallocate(ylm_sym)
    call tstatc0_end(id_sname)
    return
  end subroutine m_PAWCD_set_ae_cd_sym

  subroutine m_PAWCD_set_ae_cd2(ith,iph,ia,nspin,nrc,n1nc)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: n1nc(nrc,nspin)

    real(8):: n1(nrc,nspin),sum,fac, weight
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj

    it=ityp(ia)
    do is=1,nspin
       do ir=1,nrc
          sum=0.d0
          do lmt1=1,ilmt(it)
             il1=ltp(lmt1,it)
             im1=mtp(lmt1,it)
             it1=taup(lmt1,it)
             ii=(il1-1)**2+im1
             do lmt2=lmt1,ilmt(it)
                il2=ltp(lmt2,it)
                im2=mtp(lmt2,it)
                it2=taup(lmt2,it)
                jj=(il2-1)**2+im2
                fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                sum=sum+fac*hsr(ia,lmt1,lmt2,is)* &
                     psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)* &
                     ylm(ith,iph,ii)* &
                     ylm(ith,iph,jj)
             end do
          end do
          n1nc(ir,is)=(sum+rhcorpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it)
       end do
    end do
    if ( sw_opencore == ON .and. nspin == 2 )then
       if ( has_opencore(it) == 1 ) then
          weight = 0.5d0 *mag_opencore_pol(ia,1)
          do ir=1,nrc
             n1nc(ir,1) = n1nc(ir,1) +rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
             n1nc(ir,2) = n1nc(ir,2) -rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
          end do
       endif
    endif

    return
  end subroutine m_PAWCD_set_ae_cd2

  subroutine m_PAWCD_set_ae_cd_sym2(vec0,ia,nspin,nrc,n1nc)
    integer,intent(in) :: ia,nspin,nrc
    real(DP),intent(in) :: vec0(3)
    real(8),intent(out):: n1nc(nrc,nspin)

    real(8):: n1(nrc,nspin),sum,fac,sum2, weight
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj
    integer:: ja,iopr
    real(DP),pointer,dimension(:,:):: ylm_sym

    allocate(ylm_sym(nopr+af,25))
    ylm_sym=0.d0
    call set_ylms_symmtry_op(ia,25,vec0,ylm_sym)

    it=ityp(ia)
    do is=1,nspin
       do ir=1,nrc
          sum=0.d0
          do lmt1=1,ilmt(it)
             il1=ltp(lmt1,it)
             im1=mtp(lmt1,it)
             it1=taup(lmt1,it)
             ii=(il1-1)**2+im1
             do lmt2=lmt1,ilmt(it)
                il2=ltp(lmt2,it)
                im2=mtp(lmt2,it)
                it2=taup(lmt2,it)
                jj=(il2-1)**2+im2
                fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0

                sum2=0.d0
                do iopr=1,nopr
                   ja=abs(ia2ia_symmtry_op(ia,iopr))
                   sum2=sum2+hsr(ja,lmt1,lmt2,is)* &
                        ylm_sym(iopr,ii)* &
                        ylm_sym(iopr,jj)
                end do
                sum2=sum2/dble(nopr)

                sum=sum+fac* &
                     psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)* &
                     sum2
             end do
          end do
          n1nc(ir,is)=(sum+rhcorpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it)
       end do
    end do
    if ( sw_opencore == ON .and. nspin == 2 )then
       if ( has_opencore(it) == 1 ) then
          weight = 0.5d0 *mag_opencore_pol(ia,1)
          do ir=1,nrc
             n1nc(ir,1) = n1nc(ir,1) +rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
             n1nc(ir,2) = n1nc(ir,2) -rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
          end do
       endif
    endif

    deallocate(ylm_sym)
    return
  end subroutine m_PAWCD_set_ae_cd_sym2

  subroutine m_PAWCD_set_ae_vd_sym(vec0,ia,nspin,nrc,n1nc)
    integer,intent(in) :: ia,nspin,nrc
    real(DP),intent(in) :: vec0(3)
    real(8),intent(out):: n1nc(nrc,nspin)

    real(8):: n1(nrc,nspin),sum,fac,sum2
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj
    integer:: ja,iopr
    real(DP),pointer,dimension(:,:):: ylm_sym

    allocate(ylm_sym(nopr+af,25))
    ylm_sym=0.d0
    call set_ylms_symmtry_op(ia,25,vec0,ylm_sym)

    it=ityp(ia)

    n1nc=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1
       do lmt2=lmt1,ilmt(it)
          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0

          do is=1,nspin
             sum2=0.d0
             do iopr=1,nopr
                ja=abs(ia2ia_symmtry_op(ia,iopr))
                sum2=sum2+hsr(ja,lmt1,lmt2,is)* &
                     ylm_sym(iopr,ii)* &
                     ylm_sym(iopr,jj)
             end do
             sum2=sum2/dble(nopr)

             do ir=1,nrc
                n1nc(ir,is)=n1nc(ir,is)+fac* &
                     psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)* &
                     sum2
             end do
          end do

       end do
    end do

    do is=1,nspin
       do ir=1,nrc
          n1nc(ir,is)=n1nc(ir,is)/radr_paw(ir,it)/radr_paw(ir,it)
       end do
    end do
    deallocate(ylm_sym)
    return
  end subroutine m_PAWCD_set_ae_vd_sym

  subroutine m_PAWCD_set_ae_der_cd(ith,iph,ia,nspin,nrc,dn1_dth,dn1_dph)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: dn1_dth(nrc,nspin)
    real(8),intent(out):: dn1_dph(nrc,nspin)

    real(8):: n1(nrc,nspin),sum1,sum2,fac,bb
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj
    real(8):: sin_theta
    integer :: id_sname = -1
    call tstatc0_begin('m_PAWCD_set_ae_der_cd ',id_sname)

    sin_theta=sqrt(1.d0-cos_theta(ith)**2)

    it=ityp(ia)
    dn1_dth=0.d0
    dn1_dph=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1
       do lmt2=lmt1,ilmt(it)
          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
          sum1=   dylm_dth(ith,iph,ii)* &
               ylm(ith,iph,jj)+ &
               ylm(ith,iph,ii)* &
               dylm_dth(ith,iph,jj)
          sum2=   dylm_dph(ith,iph,ii)* &
               ylm(ith,iph,jj)+ &
               ylm(ith,iph,ii)* &
               dylm_dph(ith,iph,jj)
          do is=1,nspin
             bb=fac*hsr(ia,lmt1,lmt2,is)
             do ir=1,nrc
                dn1_dth(ir,is)=dn1_dth(ir,is)+bb*sum1* &
                     psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)
                dn1_dph(ir,is)=dn1_dph(ir,is)+bb*sum2* &
                     psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)
             end do
          end do
       end do
    end do
    do is=1,nspin
       do ir=1,nrc
          dn1_dth(ir,is)=dn1_dth(ir,is)/radr_paw(ir,it)**3
          dn1_dph(ir,is)=dn1_dph(ir,is)/radr_paw(ir,it)**3
       end do
    end do
    dn1_dph=dn1_dph/sin_theta

    call tstatc0_end(id_sname)
    return
  end subroutine m_PAWCD_set_ae_der_cd

  subroutine m_PAWCD_set_ae_der_cd_sym(vec0,ith,iph,ia,nspin,nrc,&
       &                               dn1_dth,dn1_dph)
    real(8),intent(in) :: vec0(3)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: dn1_dth(nrc,nspin)
    real(8),intent(out):: dn1_dph(nrc,nspin)

    real(8):: n1(nrc,nspin),fac,bb,bb1,bb2
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj
    real(8):: sin_theta
    integer:: ja,iopr,n
    real(DP),pointer,dimension(:,:):: ylm_sym
    real(DP),pointer,dimension(:,:):: dylm_dth_sym
    real(DP),pointer,dimension(:,:):: dylm_dph_sym
    integer :: id_sname = -1
    call tstatc0_begin('m_PAWCD_set_ae_der_cd_sym ',id_sname)

    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1

    allocate(ylm_sym(nopr+af,n**2))
    allocate(dylm_dth_sym(nopr+af,n**2))
    allocate(dylm_dph_sym(nopr+af,n**2))
    ylm_sym=0.d0
    dylm_dth_sym=0.d0
    dylm_dph_sym=0.d0
    call set_diff_ylms_symmtry_op(ia,n**2,vec0,ylm_sym &
         ,dylm_dth_sym &
         ,dylm_dph_sym)

    sin_theta=sqrt(1.d0-cos_theta(ith)**2)

    it=ityp(ia)
    dn1_dth=0.d0
    dn1_dph=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1
       do lmt2=lmt1,ilmt(it)
          if(nspin==1 .and.dabs(hsr(ia,lmt1,lmt2,1)) < 1.d-10) cycle
          if(nspin==2) then
             if ( dabs(hsr(ia,lmt1,lmt2,1))+dabs(hsr(ia,lmt1,lmt2,2))<1.d-10 ) cycle
          endif

          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0

          do is=1,nspin
!                    bb1= fac*hsr(ia,lmt1,lmt2,is)* &
!                               (dylm_dth(ith,iph,ii)* &
!                                ylm(ith,iph,jj)+ &
!                                ylm(ith,iph,ii)* &
!                                dylm_dth(ith,iph,jj))
!                    bb2= fac*hsr(ia,lmt1,lmt2,is)*&
!                               (dylm_dph(ith,iph,ii)* &
!                                ylm(ith,iph,jj)+ &
!                                ylm(ith,iph,ii)* &
!                                dylm_dph(ith,iph,jj))

             bb1=0.d0
             do iopr=1,nopr
                ja=abs(ia2ia_symmtry_op(ia,iopr))
                bb1=bb1+hsr(ja,lmt1,lmt2,is)* &
                     (dylm_dth_sym(iopr,ii)* &
                     ylm_sym(iopr,jj)+ &
                     ylm_sym(iopr,ii)* &
                     dylm_dth_sym(iopr,jj))
             end do
             bb1=bb1/dble(nopr)*fac

             bb2=0.d0
             do iopr=1,nopr
                ja=abs(ia2ia_symmtry_op(ia,iopr))
                bb2=bb2+hsr(ja,lmt1,lmt2,is)* &
                     (dylm_dph_sym(iopr,ii)* &
                     ylm_sym(iopr,jj)+ &
                     ylm_sym(iopr,ii)* &
                     dylm_dph_sym(iopr,jj))
             end do
             bb2=bb2/dble(nopr)*fac

             do ir=1,nrc
                bb= psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)
                dn1_dth(ir,is)=dn1_dth(ir,is)+bb*bb1
                dn1_dph(ir,is)=dn1_dph(ir,is)+bb*bb2
             end do
          end do

       end do
    end do

    do is=1,nspin
       do ir=1,nrc
          dn1_dth(ir,is)=dn1_dth(ir,is)/radr_paw(ir,it)**3
          dn1_dph(ir,is)=dn1_dph(ir,is)/radr_paw(ir,it)**3
       end do
    end do
    dn1_dph=dn1_dph/sin_theta

    deallocate(ylm_sym,dylm_dth_sym,dylm_dph_sym)
    call tstatc0_end(id_sname)
    return
  end subroutine m_PAWCD_set_ae_der_cd_sym

  subroutine m_PAWCD_set_ae_der_cd2(ith,iph,ia,nspin,nrc,dn1_dth,dn1_dph)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: dn1_dth(nrc,nspin)
    real(8),intent(out):: dn1_dph(nrc,nspin)

    real(8):: n1(nrc,nspin),sum1,sum2,fac,bb
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj
    real(8):: sin_theta

    sin_theta=sqrt(1.d0-cos_theta(ith)**2)

    it=ityp(ia)
    do is=1,nspin
       do ir=1,nrc
          sum1=0.d0
          sum2=0.d0
          do lmt1=1,ilmt(it)
             il1=ltp(lmt1,it)
             im1=mtp(lmt1,it)
             it1=taup(lmt1,it)
             ii=(il1-1)**2+im1
             do lmt2=lmt1,ilmt(it)
                il2=ltp(lmt2,it)
                im2=mtp(lmt2,it)
                it2=taup(lmt2,it)
                jj=(il2-1)**2+im2
                fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0

                bb=fac*hsr(ia,lmt1,lmt2,is)* &
                     psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)
                sum1=sum1+bb* &
                     (dylm_dth(ith,iph,ii)* &
                     ylm(ith,iph,jj)+ &
                     ylm(ith,iph,ii)* &
                     dylm_dth(ith,iph,jj))
                sum2=sum2+bb* &
                     (dylm_dph(ith,iph,ii)* &
                     ylm(ith,iph,jj)+ &
                     ylm(ith,iph,ii)* &
                     dylm_dph(ith,iph,jj))
             end do
          end do
          dn1_dth(ir,is)=sum1/radr_paw(ir,it)**3
          dn1_dph(ir,is)=sum2/radr_paw(ir,it)**3
       end do
    end do
    dn1_dph=dn1_dph/sin_theta

    return
  end subroutine m_PAWCD_set_ae_der_cd2

  subroutine m_PAWCD_set_ps_cd(ith,iph,ia,nspin,nrc,nps)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: nps(nrc,nspin)

    real(8):: sum,fac, weight
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3
    real(8),pointer,dimension(:):: qsum

    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(n**2));call substitute_il3(n**2,il3)
    allocate(qsum(nrc))

    it=ityp(ia)
    nps=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1
       do lmt2=lmt1,ilmt(it)
          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
          qsum=0.d0
          do n=1,il2p(lmt1,lmt2,it)
             ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
             iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
             if(iiqitg==0) cycle
             do ir=1,nrc
                qsum(ir)=qsum(ir)+qrspspw(ir,iiqitg)* &
                     dl2p(lmt1,lmt2,n,it)* &
                     ylm(ith,iph,ilm3)
             end do
          end do
          do is=1,nspin
             do ir=1,nrc
                nps(ir,is)=nps(ir,is)+fac*hsr(ia,lmt1,lmt2,is)* &
                     (phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)* &
                     ylm(ith,iph,ii)* &
                     ylm(ith,iph,jj)+qsum(ir))
             end do
          end do
       end do
    end do
    do is=1,nspin
       do ir=1,nrc
          nps(ir,is)=(nps(ir,is)+rhpcrpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it)
          if(nps(ir,is).lt.0.d0) nps(ir,is)=0.d0
       end do
    end do
    if ( sw_opencore == ON .and. nspin == 2 .and. sw_xc_opencore_ae_only ==OFF )then
       if ( has_opencore(it) == 1 ) then
          weight = 0.5d0 *mag_opencore_pol(ia,1)
          do ir=1,nrc
             nps(ir,1) = nps(ir,1) +rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
             nps(ir,2) = nps(ir,2) -rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
          end do
       endif
    endif

    deallocate(il3,qsum)
    return
  end subroutine m_PAWCD_set_ps_cd

  subroutine m_PAWCD_set_ps_cd_sym(vec0,ia,nspin,nrc,nps)
    integer,intent(in) :: ia,nspin,nrc
    real(DP),intent(in):: vec0(3)
    real(8),intent(out):: nps(nrc,nspin)

    real(8):: sum,fac,sum2,sum3, weight
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3
    real(DP),pointer,dimension(:):: qsum
    integer:: ja,iopr
    real(DP),pointer,dimension(:,:):: ylm_sym
    integer :: id_sname = -1
    call tstatc0_begin('m_PAWCD_set_ps_cd_sym ',id_sname)

    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(n**2));call substitute_il3(n**2,il3)

    allocate(ylm_sym(nopr+af,n**2))
    ylm_sym=0.d0
    call set_ylms_symmtry_op(ia,n**2,vec0,ylm_sym)

    allocate(qsum(nrc))

    it=ityp(ia)
    sum=0.d0
    nps=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1
       do lmt2=lmt1,ilmt(it)
          if(nspin==1 .and.dabs(hsr(ia,lmt1,lmt2,1)) < 1.d-10) cycle
          if(nspin==2) then
             if ( dabs(hsr(ia,lmt1,lmt2,1))+dabs(hsr(ia,lmt1,lmt2,2))<1.d-10 ) cycle
          endif

          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0

          do is=1,nspin

             sum2=0.d0
             do iopr=1,nopr
                ja=abs(ia2ia_symmtry_op(ia,iopr))
                sum2=sum2+hsr(ja,lmt1,lmt2,is)* &
                     ylm_sym(iopr,ii)* &
                     ylm_sym(iopr,jj)
             end do
             sum2=sum2/dble(nopr)

             qsum=0.d0
             do n=1,il2p(lmt1,lmt2,it)
                ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
                iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
                if(iiqitg==0) cycle

                sum3=0.d0
                do iopr=1,nopr
                   ja=abs(ia2ia_symmtry_op(ia,iopr))
                   sum3=sum3+hsr(ja,lmt1,lmt2,is)* &
                        ylm_sym(iopr,ilm3)
                end do
                sum3=sum3/dble(nopr)

                do ir=1,nrc
                   qsum(ir)=qsum(ir)+qrspspw(ir,iiqitg)* &
                        dl2p(lmt1,lmt2,n,it)* &
                        sum3
                end do
             end do

             do ir=1,nrc
                nps(ir,is)=nps(ir,is)+fac* &
                     phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)* &
                     sum2 + &
                     fac*qsum(ir)

             end do
          end do

       end do
    end do

    do is=1,nspin
       do ir=1,nrc
          nps(ir,is)=(nps(ir,is)+rhpcrpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it)
          if(nps(ir,is).lt.0.d0) nps(ir,is)=0.d0
       end do
    end do
    if ( sw_opencore == ON .and. nspin == 2 .and. sw_xc_opencore_ae_only ==OFF )then
       if ( has_opencore(it) == 1 ) then
          weight = 0.5d0 *mag_opencore_pol(ia,1)
          do ir=1,nrc
             nps(ir,1) = nps(ir,1) +rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
             nps(ir,2) = nps(ir,2) -rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
          end do
       endif
    endif

    deallocate(il3,ylm_sym,qsum)
    call tstatc0_end(id_sname)
    return
  end subroutine m_PAWCD_set_ps_cd_sym

  subroutine m_PAWCD_set_ps_cd2(ith,iph,ia,nspin,nrc,nps)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: nps(nrc,nspin)

    real(8):: sum,fac,qsum, weight
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3

    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(n**2));call substitute_il3(n**2,il3)

    it=ityp(ia)
    do is=1,nspin
       do ir=1,nrc
          sum=0.d0
          do lmt1=1,ilmt(it)
             il1=ltp(lmt1,it)
             im1=mtp(lmt1,it)
             it1=taup(lmt1,it)
             ii=(il1-1)**2+im1
             do lmt2=lmt1,ilmt(it)
                il2=ltp(lmt2,it)
                im2=mtp(lmt2,it)
                it2=taup(lmt2,it)
                jj=(il2-1)**2+im2
                fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                qsum=0.d0
                do n=1,il2p(lmt1,lmt2,it)
                   ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
                   iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
                   if(iiqitg==0) cycle
                   qsum=qsum+qrspspw(ir,iiqitg)* &
                        dl2p(lmt1,lmt2,n,it)* &
                        ylm(ith,iph,ilm3)
                end do
                sum=sum+fac*hsr(ia,lmt1,lmt2,is)* &
                     (phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)* &
                     ylm(ith,iph,ii)* &
                     ylm(ith,iph,jj)+qsum)
             end do
          end do
          nps(ir,is)=(sum+rhpcrpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it)
          if(nps(ir,is).lt.0.d0) nps(ir,is)=0.d0
       end do
    end do
    if ( sw_opencore == ON .and. nspin == 2 .and. sw_xc_opencore_ae_only ==OFF )then
       if ( has_opencore(it) == 1 ) then
          weight = 0.5d0 *mag_opencore_pol(ia,1)
          do ir=1,nrc
             nps(ir,1) = nps(ir,1) +rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
             nps(ir,2) = nps(ir,2) -rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
          end do
       endif
    endif

    deallocate(il3)
    return
  end subroutine m_PAWCD_set_ps_cd2

  subroutine m_PAWCD_set_ps_cd_sym2(vec0,ia,nspin,nrc,nps)
    integer,intent(in) :: ia,nspin,nrc
    real(DP),intent(in):: vec0(3)
    real(8),intent(out):: nps(nrc,nspin)

    real(8):: sum,fac,qsum,sum2,sum3, weight
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3
    integer:: ja,iopr
    real(DP),pointer,dimension(:,:):: ylm_sym

    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(n**2));call substitute_il3(n**2,il3)

    allocate(ylm_sym(nopr+af,25))
    ylm_sym=0.d0
    call set_ylms_symmtry_op(ia,25,vec0,ylm_sym)

    it=ityp(ia)
    do is=1,nspin
       do ir=1,nrc
          sum=0.d0
          do lmt1=1,ilmt(it)
             il1=ltp(lmt1,it)
             im1=mtp(lmt1,it)
             it1=taup(lmt1,it)
             ii=(il1-1)**2+im1
             do lmt2=lmt1,ilmt(it)
                il2=ltp(lmt2,it)
                im2=mtp(lmt2,it)
                it2=taup(lmt2,it)
                jj=(il2-1)**2+im2
                fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0

                sum2=0.d0
                do iopr=1,nopr
                   ja=abs(ia2ia_symmtry_op(ia,iopr))
                   sum2=sum2+hsr(ja,lmt1,lmt2,is)* &
                        ylm_sym(iopr,ii)* &
                        ylm_sym(iopr,jj)
                end do
                sum2=sum2/dble(nopr)

                qsum=0.d0
                do n=1,il2p(lmt1,lmt2,it)
                   ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
                   iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
                   if(iiqitg==0) cycle

                   sum3=0.d0
                   do iopr=1,nopr
                      ja=abs(ia2ia_symmtry_op(ia,iopr))
                      sum3=sum3+hsr(ja,lmt1,lmt2,is)* &
                           ylm_sym(iopr,ilm3)
                   end do
                   sum3=sum3/dble(nopr)

                   qsum=qsum+qrspspw(ir,iiqitg)* &
                        dl2p(lmt1,lmt2,n,it)* &
                        sum3
                end do

                sum=sum+fac* &
                     phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)* &
                     sum2 + &
                     fac*qsum

             end do
          end do
          nps(ir,is)=(sum+rhpcrpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it)
          if(nps(ir,is).lt.0.d0) nps(ir,is)=0.d0
       end do
    end do
    if ( sw_opencore == ON .and. nspin == 2 .and. sw_xc_opencore_ae_only ==OFF )then
       if ( has_opencore(it) == 1 ) then
          weight = 0.5d0 *mag_opencore_pol(ia,1)
          do ir=1,nrc
             nps(ir,1) = nps(ir,1) +rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
             nps(ir,2) = nps(ir,2) -rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
          end do
       endif
    endif

    deallocate(il3,ylm_sym)
    return
  end subroutine m_PAWCD_set_ps_cd_sym2

  subroutine m_PAWCD_set_ps_der_cd(ith,iph,ia,nspin,nrc,dnps_dth,dnps_dph)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: dnps_dth(nrc,nspin)
    real(8),intent(out):: dnps_dph(nrc,nspin)

    real(8):: sum1,sum2,fac,qc,sin_theta
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3
    real(8),pointer,dimension(:):: qsum1,qsum2

    allocate(qsum1(nrc))
    allocate(qsum2(nrc))

    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(n**2));call substitute_il3(n**2,il3)

    sin_theta=sqrt(1.d0-cos_theta(ith)**2)

    it=ityp(ia)
    dnps_dth=0.d0
    dnps_dph=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1
       do lmt2=lmt1,ilmt(it)
          if(nspin==1 .and.dabs(hsr(ia,lmt1,lmt2,1)) < 1.d-10) cycle
          if(nspin==2) then
             if ( dabs(hsr(ia,lmt1,lmt2,1))+dabs(hsr(ia,lmt1,lmt2,2))<1.d-10 ) cycle
          endif

          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
          qsum1=0.d0
          qsum2=0.d0
          do n=1,il2p(lmt1,lmt2,it)
             ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
             iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
             if(iiqitg==0) cycle
             do ir=1,nrc
                qc=qrspspw(ir,iiqitg)* &
                     dl2p(lmt1,lmt2,n,it)
                qsum1(ir)=qsum1(ir)+qc*dylm_dth(ith,iph,ilm3)
                qsum2(ir)=qsum2(ir)+qc*dylm_dph(ith,iph,ilm3)
             end do
          end do
          sum1=dylm_dth(ith,iph,ii)* &
               ylm(ith,iph,jj)+ &
               ylm(ith,iph,ii)* &
               dylm_dth(ith,iph,jj)
          sum2=dylm_dph(ith,iph,ii)* &
               ylm(ith,iph,jj)+ &
               ylm(ith,iph,ii)* &
               dylm_dph(ith,iph,jj)
          do is=1,nspin
             do ir=1,nrc
                dnps_dth(ir,is)=dnps_dth(ir,is)+fac*hsr(ia,lmt1,lmt2,is)* &
                     (phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)* &
                                                    sum1+qsum1(ir))
                dnps_dph(ir,is)=dnps_dph(ir,is)+fac*hsr(ia,lmt1,lmt2,is)* &
                     (phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)* &
                     sum2+qsum2(ir))
             end do
          end do
       end do
    end do
    do is=1,nspin
       do ir=1,nrc
          dnps_dth(ir,is)=dnps_dth(ir,is)/radr_paw(ir,it)**3
          dnps_dph(ir,is)=dnps_dph(ir,is)/radr_paw(ir,it)**3
       end do
    end do

    dnps_dph=dnps_dph/sin_theta

    deallocate(il3,qsum1,qsum2)
    return
  end subroutine m_PAWCD_set_ps_der_cd

  subroutine m_PAWCD_set_ps_der_cd_sym(vec0,ith,iph,ia,nspin,nrc,&
       &                               dnps_dth,dnps_dph)
    real(8),intent(in) :: vec0(3)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: dnps_dth(nrc,nspin)
    real(8),intent(out):: dnps_dph(nrc,nspin)

    real(8):: fac,qc,bb1,bb2,sin_theta,cc1,cc2
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3
    real(DP),pointer,dimension(:):: qsum1,qsum2
    integer:: ja,iopr
    real(DP),pointer,dimension(:,:):: ylm_sym
    real(DP),pointer,dimension(:,:):: dylm_dth_sym
    real(DP),pointer,dimension(:,:):: dylm_dph_sym
    integer :: id_sname = -1
    call tstatc0_begin('m_PAWCD_set_ps_der_cd_sym ',id_sname)

    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(n**2));call substitute_il3(n**2,il3)

    allocate(ylm_sym(nopr+af,n**2))
    allocate(dylm_dth_sym(nopr+af,n**2))
    allocate(dylm_dph_sym(nopr+af,n**2))
    ylm_sym=0.d0
    dylm_dth_sym=0.d0
    dylm_dph_sym=0.d0
    call set_diff_ylms_symmtry_op(ia,n**2,vec0,ylm_sym &
         ,dylm_dth_sym &
         ,dylm_dph_sym)

    allocate(qsum1(nrc))
    allocate(qsum2(nrc))

    sin_theta=sqrt(1.d0-cos_theta(ith)**2)

    it=ityp(ia)
    dnps_dth=0.d0
    dnps_dph=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1
       do lmt2=lmt1,ilmt(it)
          if(nspin==1 .and.dabs(hsr(ia,lmt1,lmt2,1)) < 1.d-10) cycle
          if(nspin==2) then
             if ( dabs(hsr(ia,lmt1,lmt2,1))+dabs(hsr(ia,lmt1,lmt2,2))<1.d-10 ) cycle
          endif

          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0

          if(ipripaw >= 2) then
             iiqitg = 0
             do n=1,il2p(lmt1,lmt2,it)
                ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
                if(iqitg(il1,it1,il2,it2,l3+1,it)>0) iiqitg=iiqitg+1
             end do
             write(nfout,'(" it, lmt1, lmt2, il2p iiqitg/=0 = ",5i8)') it, lmt1, lmt2,il2p(lmt1,lmt2,it),iiqitg
             if(iiqitg > 0) then
                do n=1,il2p(lmt1,lmt2,it)
                   ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
!                         write(nfout,'("        il1,im1,it1, il2,im2,it2, n, iiqitg = ",8i6)') il1,im1,it1,il2,im2,it2, n, iqitg(il1,it1,il2,it2,l3+1,it)
                end do
             end if
          end if

          do is=1,nspin
!                    bb1=fac*hsr(ia,lmt1,lmt2,is)*( &
!                                dylm_dth(ith,iph,ii)* &
!                                ylm(ith,iph,jj)+ &
!                                ylm(ith,iph,ii)* &
!                                dylm_dth(ith,iph,jj))

             bb1=0.d0
             do iopr=1,nopr
                ja=abs(ia2ia_symmtry_op(ia,iopr))
                bb1=bb1+hsr(ja,lmt1,lmt2,is)*( &
                     dylm_dth_sym(iopr,ii)* &
                     ylm_sym(iopr,jj)+ &
                     ylm_sym(iopr,ii)* &
                     dylm_dth_sym(iopr,jj))
             end do
             bb1=bb1/dble(nopr)*fac

!                    bb2=fac*hsr(ia,lmt1,lmt2,is)*( &
!                                dylm_dph(ith,iph,ii)* &
!                                ylm(ith,iph,jj)+ &
!                                ylm(ith,iph,ii)* &
!                                dylm_dph(ith,iph,jj))

             bb2=0.d0
             do iopr=1,nopr
                ja=abs(ia2ia_symmtry_op(ia,iopr))
                bb2=bb2+hsr(ja,lmt1,lmt2,is)*( &
                     dylm_dph_sym(iopr,ii)* &
                     ylm_sym(iopr,jj)+ &
                     ylm_sym(iopr,ii)* &
                     dylm_dph_sym(iopr,jj))
             end do
             bb2=bb2/dble(nopr)*fac

             qsum1=0.d0
             qsum2=0.d0
             do n=1,il2p(lmt1,lmt2,it)
                ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
                iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
                if(iiqitg==0) cycle

                cc1=0.d0
                do iopr=1,nopr
                   ja=abs(ia2ia_symmtry_op(ia,iopr))
                   cc1=cc1+dylm_dth_sym(iopr,ilm3)*hsr(ja,lmt1,lmt2,is)
                end do
                cc1=cc1/dble(nopr)*dl2p(lmt1,lmt2,n,it)

                cc2=0.d0
                do iopr=1,nopr
                   ja=abs(ia2ia_symmtry_op(ia,iopr))
                   cc2=cc2+dylm_dph_sym(iopr,ilm3)*hsr(ja,lmt1,lmt2,is)
                end do
                cc2=cc2/dble(nopr)*dl2p(lmt1,lmt2,n,it)

                do ir=1,nrc
                   qc=qrspspw(ir,iiqitg)
                   qsum1(ir)=qsum1(ir)+qc*cc1
                   qsum2(ir)=qsum2(ir)+qc*cc2
                end do
             end do
             qsum1=qsum1*fac
             qsum2=qsum2*fac

             do ir=1,nrc
!                        qsum1=0.d0
!                        qsum2=0.d0
!                        do n=1,il2p(lmt1,lmt2,it)
!                            ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
!                            iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
!                            if(iiqitg==0) cycle
!                            qc=qrspspw(ir,iiqitg)* &
!                                        dl2p(lmt1,lmt2,n,it)
!                            qsum1=qsum1+qc*dylm_dth(ith,iph,ilm3)*hsr(ia,lmt1,lmt2,is)
!                            qsum2=qsum2+qc*dylm_dph(ith,iph,ilm3)*hsr(ia,lmt1,lmt2,is)
!                        end do
!                        qsum1=qsum1*fac
!                        qsum2=qsum2*fac
!                        dnps_dth(ir,is)=dnps_dth(ir,is)+ &
!                                fac*hsr(ia,lmt1,lmt2,is)* &
!                                (phirpw(ir,il1,it1,it)* &
!                                phirpw(ir,il2,it2,it)* &
!                                (dylm_dth(ith,iph,ii)* &
!                                ylm(ith,iph,jj)+ &
!                                ylm(ith,iph,ii)* &
!                                dylm_dth(ith,iph,jj))+qsum1)

                dnps_dth(ir,is)=dnps_dth(ir,is)+ &
                     bb1*phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)+ &
                     qsum1(ir)

!                        dnps_dph(ir,is)=dnps_dph(ir,is)+ &
!                                fac*hsr(ia,lmt1,lmt2,is)* &
!                                (phirpw(ir,il1,it1,it)* &
!                                phirpw(ir,il2,it2,it)* &
!                                (dylm_dph(ith,iph,ii)* &
!                                ylm(ith,iph,jj)+ &
!                                ylm(ith,iph,ii)* &
!                                dylm_dph(ith,iph,jj))+qsum2)

                dnps_dph(ir,is)=dnps_dph(ir,is)+ &
                     bb2*phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)+ &
                     qsum2(ir)

             end do
          end do

       end do
    end do

    do is=1,nspin
       do ir=1,nrc
          dnps_dth(ir,is)=dnps_dth(ir,is)/radr_paw(ir,it)**3
          dnps_dph(ir,is)=dnps_dph(ir,is)/radr_paw(ir,it)**3
       end do
    end do

    dnps_dph=dnps_dph/sin_theta

    deallocate(il3,qsum1,qsum2)
    deallocate(ylm_sym,dylm_dth_sym,dylm_dph_sym)
    call tstatc0_end(id_sname)
    return
  end subroutine m_PAWCD_set_ps_der_cd_sym

  subroutine m_PAWCD_set_ps_der_cd2(ith,iph,ia,nspin,nrc,dnps_dth,dnps_dph)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: dnps_dth(nrc,nspin)
    real(8),intent(out):: dnps_dph(nrc,nspin)

    real(8):: sum1,sum2,fac,qsum1,qsum2,qc,sin_theta
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3

    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(n**2));call substitute_il3(n**2,il3)

    sin_theta=sqrt(1.d0-cos_theta(ith)**2)

    it=ityp(ia)
    do is=1,nspin
       do ir=1,nrc
          sum1=0.d0
          sum2=0.d0
          do lmt1=1,ilmt(it)
             il1=ltp(lmt1,it)
             im1=mtp(lmt1,it)
             it1=taup(lmt1,it)
             ii=(il1-1)**2+im1
             do lmt2=lmt1,ilmt(it)
                il2=ltp(lmt2,it)
                im2=mtp(lmt2,it)
                it2=taup(lmt2,it)
                jj=(il2-1)**2+im2
                fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                qsum1=0.d0
                qsum2=0.d0
                do n=1,il2p(lmt1,lmt2,it)
                   ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
                   iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
                   if(iiqitg==0) cycle
                   qc=qrspspw(ir,iiqitg)* &
                        dl2p(lmt1,lmt2,n,it)
                   qsum1=qsum1+qc*dylm_dth(ith,iph,ilm3)
                   qsum2=qsum2+qc*dylm_dph(ith,iph,ilm3)
                end do
                sum1=sum1+fac*hsr(ia,lmt1,lmt2,is)* &
                     (phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)* &
                     (dylm_dth(ith,iph,ii)* &
                     ylm(ith,iph,jj)+ &
                     ylm(ith,iph,ii)* &
                     dylm_dth(ith,iph,jj))+qsum1)
                sum2=sum2+fac*hsr(ia,lmt1,lmt2,is)* &
                     (phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)* &
                     (dylm_dph(ith,iph,ii)* &
                     ylm(ith,iph,jj)+ &
                     ylm(ith,iph,ii)* &
                            dylm_dph(ith,iph,jj))+qsum2)
             end do
          end do
          dnps_dth(ir,is)=sum1/radr_paw(ir,it)**3
          dnps_dph(ir,is)=sum2/radr_paw(ir,it)**3
       end do
    end do

    dnps_dph=dnps_dph/sin_theta

    deallocate(il3)
    return
  end subroutine m_PAWCD_set_ps_der_cd2

  subroutine m_PAWCD_wd_cd(nfout)
    integer,intent(in):: nfout
    integer:: unit
    integer:: iloop !,ie,je,ke
    integer:: idp,nlp,nmp,nnp
    real(DP),allocatable,dimension(:) :: afft
    real(DP),pointer,dimension(:)      :: afft_mpi1
    real(DP),pointer,dimension(:)      :: afft_mpi2
    real(DP),pointer,dimension(:)      :: afft_mpi3
    real(DP),pointer,dimension(:,:,:)  :: chg_rs
    logical:: flg_wrtn(natm)

    call m_FFT_alloc_CD_box()
    allocate(afft(ista_fftp:iend_fftp))
    allocate(afft_mpi1(nfftp))
    if(npes >= 2) then
       allocate(afft_mpi2(mp_fftp))
       allocate(afft_mpi3(mp_fftp))
    end if
    if(mype==0) then
       flg_wrtn=.false.
!            ie=fft_box_size_CD(1)
!            je=fft_box_size_CD(2)
!            ke=fft_box_size_CD(3)
!!$            idp = fft_box_size_CD(0)
!!$            nlp = fft_box_size_CD(1)
!!$            nmp = fft_box_size_CD(2)
!!$            nnp = fft_box_size_CD(3)
#ifdef _MPIFFT_
       idp  = fft_box_size_CD_c(1,0)
#else
       idp  = fft_box_size_CD(1,0)
#endif
       nlp  = fft_box_size_CD(1,1)
       nmp  = fft_box_size_CD(2,1)
       nnp  = fft_box_size_CD(3,1)
!            allocate(chg_rs(0:ie,0:je,0:ke))
       allocate(chg_rs(0:nlp,0:nmp,0:nnp))
       chg_rs=0.d0
       unit=unusedUnit()
       open(unit,file='nfchgt_paw.data',status='unknown',form='formatted')
    end if

    do iloop=1,nspin
       call map_charge_onto_a_fft_box_paw('soft')
       call m_FFT_CD_inverse0(nfout,afft)
!!$            call m_FFT_check_of_negative_CD(afft,nfout,nspin,iloop)
!!$            call m_FFT_check_of_negative_CD(npes,ista_fftp,iend_fftp&
!!$               & ,ista_fftph,iend_fftph,afft,nfout,nspin,iloop)
       if(mype == 0) then
          call m_FFT_cp_afft_CD(afft_mpi1)
          call get_cd_in_rspace
       end if
    end do
!call tmp
!stop
    if(mype==0) then
       call output_box_tecplot(chg_rs,altv,'chgsoft','cd',unit,0)
       deallocate(chg_rs)
    end if

    call m_FFT_dealloc_CD_box()
    deallocate(afft)
!!$deallocate(afft_mpi1)
    if(npes >= 2) then
       deallocate(afft_mpi2);deallocate(afft_mpi3)
    end if

    if(mype==0) then
!            call wd_ae_cd(unit)
!            call wd_averaged_ae_cd(unit)
!            call wd_ps_cd(unit)
!            call wd_averaged_ps_cd(unit)
!            call wd_valence_cd(unit)
!            call wd_averaged_valence_cd(unit)
       if(flg_symmtry) then
          call wd_averaged_ps_cd(unit)
!                call wd_averaged_valence_cd(unit)
       else
          call wd_ps_cd(unit)
!                call wd_valence_cd(unit)
       end if
       close(unit)
    end if

    return

  contains

    subroutine map_charge_onto_a_fft_box_paw(s_or_a)
      character(len=*),intent(in):: s_or_a
      integer:: i,j,ip, ilast

      ilast = min(iend_kngp,kgp_reduced)
      afft_mpi1=0.d0
      select case(s_or_a)
      case('all')
         do j=1,kimg
!!$                    do i=ista_kngp,iend_kngp
            do i=ista_kngp,ilast
               ip=(igfp_l(i)-1)*kimg+j
               afft_mpi1(ip)=afft_mpi1(ip)+chgq_l(i,j,iloop)
            end do
         end do
      case('soft')
         do j=1,kimg
!!$                    do i=ista_kngp,iend_kngp
            do i=ista_kngp,ilast
               ip=(igfp_l(i)-1)*kimg+j
               afft_mpi1(ip)=afft_mpi1(ip)+chgsoft(i,j,iloop)
            end do
         end do
      case('hard')
         do j=1,kimg
!!$                    do i=ista_kngp,iend_kngp
            do i=ista_kngp,ilast
               ip=(igfp_l(i)-1)*kimg+j
               afft_mpi1(ip)=afft_mpi1(ip)+chgq_l(i,j,iloop)-chgsoft(i,j,iloop)
            end do
         end do
      case default
         write(6,*) 'Error in map_charge_onto_a_fft_box_paw !'
         write(6,*) 'Unknown a_or_s : ',s_or_a
         call phase_error_with_msg(6,'Error in map_charge_onto_a_fft_box_paw !',__LINE__,__FILE__)
      end select

      if(npes >= 2) then
         call mpi_barrier(MPI_CommGroup,ierr)
         do j=0,npes-1
            do i=nis_fftp(j),nie_fftp(j)
               afft_mpi2(i-nis_fftp(j)+1) = afft_mpi1(i)
            end do
            call mpi_allreduce(afft_mpi2,afft_mpi3,mp_fftp &
                 ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
            if(j==mype) then
               do i=ista_fftp,iend_fftp
                  afft(i)=afft_mpi3(i-ista_fftp+1)
               end do
            end if
         end do
      else
         afft=afft_mpi1
      end if
    end subroutine map_charge_onto_a_fft_box_paw

    subroutine get_cd_in_rspace
      integer:: i,j,k,ip
      integer:: ii,jj,kk
!real(8):: vec(3)
!            do k=1,ke
!                do j=1,je
!	                do i=1,ie
      do k=1,nnp
         do j=1,nmp
            do i=1,nlp
!                        ip = (ie+1)*je*(k-1) + (ie+1)*(j-1) + i
               ii=i
               jj=j
               kk=k
               if(kimg==1) then
                  if(2*(i-1).le.nlp) then
                     ii=2*i-1
                  else
                     ii=2*(-i+nlp+2)-1
                     jj=-j+nmp+2;if(j.eq.1) jj=1
                     kk=-k+nnp+2;if(k.eq.1) kk=1
                  end if
               end if
               ip = idp*nmp*(kk-1) + idp*(jj-1) + ii
               chg_rs(i-1,j-1,k-1) = chg_rs(i-1,j-1,k-1)+ &
                    afft_mpi1(ip*kimg+1-kimg)
!                                                afft_mpi1(2*ip-1)
!vec=(/dble(i)/dble(ie),dble(j)/dble(je),dble(k)/dble(ke)/)
!chg_rs(i-1,j-1,k-1)=getFFTValue(vec)
            end do
         end do
      end do
!            chg_rs(ie,:,:)=chg_rs(0,:,:)
!            chg_rs(:,je,:)=chg_rs(:,0,:)
!            chg_rs(:,:,ke)=chg_rs(:,:,0)
      chg_rs(nlp,:,:)=chg_rs(0,:,:)
      chg_rs(:,nmp,:)=chg_rs(:,0,:)
      chg_rs(:,:,nnp)=chg_rs(:,:,0)
      return
    end subroutine get_cd_in_rspace

    subroutine tmp
      integer:: idp,nlp,nmp,nnp
      integer:: i,j,k,n,nn


!!$            idp = fft_box_size_CD(0)
!!$            nlp = fft_box_size_CD(1)
!!$            nmp = fft_box_size_CD(2)
!!$            nnp = fft_box_size_CD(3)
#ifdef _MPIFFT_
      idp  = fft_box_size_CD_c(1,0)
#else
      idp  = fft_box_size_CD(1,0)
#endif
      nlp  = fft_box_size_CD(1,1)
      nmp  = fft_box_size_CD(2,1)
      nnp  = fft_box_size_CD(3,1)

      do n = 1,nfftp
         nn = (n+kimg-1)/kimg
         i  = mod(nn,idp)
         j  = mod((nn-1)/idp,nmp) + 1
         k  = (nn - (j-1)*idp - i)/(idp*nmp) + 1
!!$                print *,i,j,k,n,afft_mpi1(n)
      end do
      return
    end subroutine tmp

    function getFFTValue(vec,mode)
      real(8):: getFFTValue
      real(8),dimension(3),intent(inout):: vec
      character(len=*),intent(in):: mode
      integer:: i,is
      real(8):: value,phi,kk1,kk2,kk3

      value=0.d0
      select case(mode)
      case('soft')
         if(kimg==1) then
            do i=1,kgp
               kk1=dble(ngabc(i,1))
               kk2=dble(ngabc(i,2))
               kk3=dble(ngabc(i,3))
               phi=PAI2*(kk1*vec(1)+ &
                    kk2*vec(2)+ &
                    kk3*vec(3))
               do is=1,nspin
                  value=value+chgsoft(i,1,is)*cos(phi)
               end do
            end do
         else if(kimg==2) then
            do i=1,kgp
               kk1=dble(ngabc(i,1))
               kk2=dble(ngabc(i,2))
               kk3=dble(ngabc(i,3))
               phi=PAI2*(kk1*vec(1)+ &
                    kk2*vec(2)+ &
                    kk3*vec(3))
               do is=1,nspin
                  value=value+chgsoft(i,1,is)*cos(phi)- &
                       chgsoft(i,2,is)*sin(phi)
               end do
            end do
         end if
      end select
      getFFTValue=value
      return
    end function getFFTValue

    subroutine wd_ae_cd(unit)
      integer,intent(in):: unit
      integer:: ia,it,ith,iph,nrc,ir,is,ip
      integer:: lmt1,lmt2,il1,il2,im1,im2,it1,it2,ii,jj
      real(DP):: sint,cost,phi
      real(DP):: x0,y0,z0,xorg,yorg,zorg,pos1,pos2,pos3
      real(DP):: sum,fac,rr
      character(len=32):: title
      do ia=1,natm
         it=ityp(ia)
         if(ipaw(it)/=1) cycle
         nrc=wf_mnrc(it)
         pos1=pos(ia,1);if(pos1<0) pos1=pos1+1.d0
         pos2=pos(ia,2);if(pos2<0) pos2=pos2+1.d0
         pos3=pos(ia,3);if(pos3<0) pos3=pos3+1.d0
         xorg=altv(1,1)*pos1+altv(1,2)*pos2+altv(1,3)*pos3
         yorg=altv(2,1)*pos1+altv(2,2)*pos2+altv(2,3)*pos3
         zorg=altv(3,1)*pos1+altv(3,2)*pos2+altv(3,3)*pos3
         write(title,'("nae",i4.4)') ia
         write(unit,'(3a,i6,a,i6,a,i6,a)') &
              'ZONE T=',trim(title),'  I=',nrc &
              ,', J=',nphi+1 &
              ,', K=',ntheta &
              ,', F=POINT'
         do ith=1,ntheta
            cost=cos_theta(ith)
            sint=sqrt(1.d0-cost**2)
            do ip=1,nphi+1
               iph=ip
               if(ip.eq.nphi+1) iph=1
               phi=PAI2/dble(nphi)*dble(iph-1)
               x0=sint*cos(phi)
               y0=sint*sin(phi)
               z0=cost

               do ir=1,nrc
                  sum=0.d0
                  do is=1,nspin
                     do lmt1=1,ilmt(it)
                        il1=ltp(lmt1,it)
                        im1=mtp(lmt1,it)
                        it1=taup(lmt1,it)
                        ii=(il1-1)**2+im1
                        do lmt2=lmt1,ilmt(it)
                           il2=ltp(lmt2,it)
                           im2=mtp(lmt2,it)
                           it2=taup(lmt2,it)
                           jj=(il2-1)**2+im2
                           fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                           sum=sum+fac*hsr(ia,lmt1,lmt2,is)* &
                                psirpw(ir,il1,it1,it)* &
                                psirpw(ir,il2,it2,it)* &
                                ylm(ith,iph,ii)* &
                                ylm(ith,iph,jj)
                        end do
                     end do
                  end do
                  rr=radr_paw(ir,it)
                  write(unit,'(4e19.6)') xorg+x0*rr, &
                       yorg+y0*rr, &
                       zorg+z0*rr,sum/rr/rr
               end do
            end do
         end do
      end do

      return
    end subroutine wd_ae_cd

    subroutine wd_ps_cd(unit)
      integer,intent(in):: unit
      integer:: ia,it,ith,iph,nrc,ir,is,ip
      integer:: lmt1,lmt2,il1,il2,im1,im2,it1,it2,ii,jj
      real(DP):: sint,cost,phi
      real(DP):: x0,y0,z0,xorg,yorg,zorg,pos1,pos2,pos3
      real(DP):: sum,fac,rr
      character(len=32):: title
      do ia=1,natm
         it=ityp(ia)
         if(ipaw(it)/=1) cycle
         nrc=wf_mnrc(it)
         pos1=pos(ia,1);if(pos1<0) pos1=pos1+1.d0
         pos2=pos(ia,2);if(pos2<0) pos2=pos2+1.d0
         pos3=pos(ia,3);if(pos3<0) pos3=pos3+1.d0
         xorg=altv(1,1)*pos1+altv(1,2)*pos2+altv(1,3)*pos3
         yorg=altv(2,1)*pos1+altv(2,2)*pos2+altv(2,3)*pos3
         zorg=altv(3,1)*pos1+altv(3,2)*pos2+altv(3,3)*pos3
         write(title,'("nps",i4.4)') ia
         write(unit,'(3a,i6,a,i6,a,i6,a)') &
              'ZONE T=',trim(title),'  I=',nrc &
              ,', J=',nphi+1 &
              ,', K=',ntheta &
              ,', F=POINT'
         do ith=1,ntheta
            cost=cos_theta(ith)
            sint=sqrt(1.d0-cost**2)
            do ip=1,nphi+1
               iph=ip
               if(ip.eq.nphi+1) iph=1
               phi=PAI2/dble(nphi)*dble(iph-1)
               x0=sint*cos(phi)
               y0=sint*sin(phi)
               z0=cost

               do ir=1,nrc
                  sum=0.d0
                  do is=1,nspin
                     do lmt1=1,ilmt(it)
                        il1=ltp(lmt1,it)
                        im1=mtp(lmt1,it)
                        it1=taup(lmt1,it)
                        ii=(il1-1)**2+im1
                        do lmt2=lmt1,ilmt(it)
                           il2=ltp(lmt2,it)
                           im2=mtp(lmt2,it)
                           it2=taup(lmt2,it)
                           jj=(il2-1)**2+im2
                           fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                           sum=sum+fac*hsr(ia,lmt1,lmt2,is)* &
                                phirpw(ir,il1,it1,it)* &
                                phirpw(ir,il2,it2,it)* &
                                ylm(ith,iph,ii)* &
                                ylm(ith,iph,jj)
                        end do
                     end do
                  end do
                  rr=radr_paw(ir,it)
                  write(unit,'(4e19.6)') xorg+x0*rr, &
                       yorg+y0*rr, &
                       zorg+z0*rr,sum/rr/rr
               end do
            end do
         end do
      end do

      return
    end subroutine wd_ps_cd

    subroutine wd_valence_cd(unit)
      integer,intent(in):: unit
      integer:: ia,it,ith,iph,nrc,ir,is,ip
      integer:: lmt1,lmt2,il1,il2,im1,im2,it1,it2,ii,jj
      real(DP):: sint,cost,phi
      real(DP):: x0,y0,z0,xorg,yorg,zorg,pos1,pos2,pos3
      real(DP):: sum1,sum2,fac,rr,vec(3)
      character(len=32):: title
      do ia=1,natm
         it=ityp(ia)
         if(ipaw(it)/=1) cycle
         nrc=wf_mnrc(it)
         pos1=pos(ia,1);if(pos1<0) pos1=pos1+1.d0
         pos2=pos(ia,2);if(pos2<0) pos2=pos2+1.d0
         pos3=pos(ia,3);if(pos3<0) pos3=pos3+1.d0
         xorg=altv(1,1)*pos1+altv(1,2)*pos2+altv(1,3)*pos3
         yorg=altv(2,1)*pos1+altv(2,2)*pos2+altv(2,3)*pos3
         zorg=altv(3,1)*pos1+altv(3,2)*pos2+altv(3,3)*pos3
         write(title,'("chgval",i4.4)') ia
         write(unit,'(3a,i6,a,i6,a,i6,a)') &
              'ZONE T=',trim(title),'  I=',nrc &
              ,', J=',nphi+1 &
              ,', K=',ntheta &
              ,', F=POINT'
         do ith=1,ntheta
            cost=cos_theta(ith)
            sint=sqrt(1.d0-cost**2)
            do ip=1,nphi+1
               iph=ip
               if(ip.eq.nphi+1) iph=1
               phi=PAI2/dble(nphi)*dble(iph-1)
               x0=sint*cos(phi)
               y0=sint*sin(phi)
               z0=cost

               do ir=1,nrc
                  sum1=0.d0
                  sum2=0.d0
                  do is=1,nspin
                     do lmt1=1,ilmt(it)
                        il1=ltp(lmt1,it)
                        im1=mtp(lmt1,it)
                        it1=taup(lmt1,it)
                        ii=(il1-1)**2+im1
                        do lmt2=lmt1,ilmt(it)
                           il2=ltp(lmt2,it)
                           im2=mtp(lmt2,it)
                           it2=taup(lmt2,it)
                           jj=(il2-1)**2+im2
                           fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                           sum1=sum1+fac*hsr(ia,lmt1,lmt2,is)* &
                                psirpw(ir,il1,it1,it)* &
                                psirpw(ir,il2,it2,it)* &
                                ylm(ith,iph,ii)* &
                                ylm(ith,iph,jj)
                           sum2=sum2+fac*hsr(ia,lmt1,lmt2,is)* &
                                phirpw(ir,il1,it1,it)* &
                                phirpw(ir,il2,it2,it)* &
                                ylm(ith,iph,ii)* &
                                ylm(ith,iph,jj)
                        end do
                     end do
                  end do
                  rr=radr_paw(ir,it)
                  vec=(/xorg+x0*rr,yorg+y0*rr,zorg+z0*rr/)
                  vec=matmul(rltv,vec)/PAI2
                  write(unit,'(4e19.6)') xorg+x0*rr, &
                       yorg+y0*rr, &
                       zorg+z0*rr, &
                       (sum1-sum2)/rr/rr+ &
                       getFFTValue(vec,'soft')
               end do
            end do
         end do
      end do

      return
    end subroutine wd_valence_cd

    subroutine wd_averaged_ae_cd(unit)
      integer,intent(in):: unit
      integer:: ia,it,ith,iph,nrc,ir,is,ip,iopr,ja
      integer:: lmt1,lmt2,il1,il2,im1,im2,it1,it2,ii,jj
      real(DP):: sint,cost,phi
      real(DP):: x0,y0,z0,xorg,yorg,zorg,pos1,pos2,pos3
      real(DP):: sum,fac,rr,vec0(3),sum2
      real(DP),pointer,dimension(:,:):: ylm_sym
      character(len=32):: title

      allocate(ylm_sym(nopr+af,25))
      ylm_sym=0.d0

      do ia=1,natm
         it=ityp(ia)
         if(ipaw(it)/=1) cycle
         nrc=wf_mnrc(it)
         pos1=pos(ia,1);if(pos1<0) pos1=pos1+1.d0
         pos2=pos(ia,2);if(pos2<0) pos2=pos2+1.d0
         pos3=pos(ia,3);if(pos3<0) pos3=pos3+1.d0
         xorg=altv(1,1)*pos1+altv(1,2)*pos2+altv(1,3)*pos3
         yorg=altv(2,1)*pos1+altv(2,2)*pos2+altv(2,3)*pos3
         zorg=altv(3,1)*pos1+altv(3,2)*pos2+altv(3,3)*pos3
         write(title,'("nae_sym",i4.4)') ia
         write(unit,'(3a,i6,a,i6,a,i6,a)') &
              'ZONE T=',trim(title),'  I=',nrc &
              ,', J=',nphi+1 &
              ,', K=',ntheta &
              ,', F=POINT'
         do ith=1,ntheta
            cost=cos_theta(ith)
            sint=sqrt(1.d0-cost**2)
            do ip=1,nphi+1
               iph=ip
               if(ip.eq.nphi+1) iph=1
               phi=PAI2/dble(nphi)*dble(iph-1)
               x0=sint*cos(phi)
               y0=sint*sin(phi)
               z0=cost
               vec0(1)=x0
               vec0(2)=y0
               vec0(3)=z0
               call set_ylms_symmtry_op(ia,25,vec0,ylm_sym)

               do ir=1,nrc
                  sum=0.d0
                  do is=1,nspin
                     do lmt1=1,ilmt(it)
                        il1=ltp(lmt1,it)
                        im1=mtp(lmt1,it)
                        it1=taup(lmt1,it)
                        ii=(il1-1)**2+im1
                        do lmt2=lmt1,ilmt(it)
                           il2=ltp(lmt2,it)
                           im2=mtp(lmt2,it)
                           it2=taup(lmt2,it)
                           jj=(il2-1)**2+im2
                           fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0

                           sum2=0.d0
                           do iopr=1,nopr
                              ja=abs(ia2ia_symmtry_op(ia,iopr))
                              sum2=sum2+hsr(ja,lmt1,lmt2,is)* &
                                   ylm_sym(iopr,ii)* &
                                   ylm_sym(iopr,jj)
                           end do
                           sum2=sum2/dble(nopr)

                           sum=sum+fac* &
                                psirpw(ir,il1,it1,it)* &
                                psirpw(ir,il2,it2,it)* &
                                sum2
                        end do
                     end do
                  end do
                  rr=radr_paw(ir,it)
                  write(unit,'(4e19.6)') xorg+x0*rr, &
                       yorg+y0*rr, &
                       zorg+z0*rr,sum/rr/rr
               end do
            end do
         end do
      end do

      deallocate(ylm_sym)

      return
    end subroutine wd_averaged_ae_cd

    subroutine wd_averaged_ps_cd(unit)
      integer,intent(in):: unit
      integer:: ia,it,ith,iph,nrc,ir,is,ip,iopr,ja
      integer:: lmt1,lmt2,il1,il2,im1,im2,it1,it2,ii,jj
      real(DP):: sint,cost,phi
      real(DP):: x0,y0,z0,xorg,yorg,zorg,pos1,pos2,pos3
      real(DP):: sum,fac,rr,vec0(3),sum2
      real(DP),pointer,dimension(:,:):: ylm_sym
      character(len=32):: title

      allocate(ylm_sym(nopr+af,25))
      ylm_sym=0.d0

      do ia=1,natm
         it=ityp(ia)
         if(ipaw(it)/=1) cycle
         nrc=wf_mnrc(it)
         pos1=pos(ia,1);if(pos1<0) pos1=pos1+1.d0
         pos2=pos(ia,2);if(pos2<0) pos2=pos2+1.d0
         pos3=pos(ia,3);if(pos3<0) pos3=pos3+1.d0
         xorg=altv(1,1)*pos1+altv(1,2)*pos2+altv(1,3)*pos3
         yorg=altv(2,1)*pos1+altv(2,2)*pos2+altv(2,3)*pos3
         zorg=altv(3,1)*pos1+altv(3,2)*pos2+altv(3,3)*pos3
         write(title,'("nps_sym",i4.4)') ia
         write(unit,'(3a,i6,a,i6,a,i6,a)') &
              'ZONE T=',trim(title),'  I=',nrc &
              ,', J=',nphi+1 &
              ,', K=',ntheta &
              ,', F=POINT'
         do ith=1,ntheta
            cost=cos_theta(ith)
            sint=sqrt(1.d0-cost**2)
            do ip=1,nphi+1
               iph=ip
               if(ip.eq.nphi+1) iph=1
               phi=PAI2/dble(nphi)*dble(iph-1)
               x0=sint*cos(phi)
               y0=sint*sin(phi)
               z0=cost
               vec0(1)=x0
               vec0(2)=y0
               vec0(3)=z0
               call set_ylms_symmtry_op(ia,25,vec0,ylm_sym)

               do ir=1,nrc
                  sum=0.d0
                  do is=1,nspin
                     do lmt1=1,ilmt(it)
                        il1=ltp(lmt1,it)
                        im1=mtp(lmt1,it)
                        it1=taup(lmt1,it)
                        ii=(il1-1)**2+im1
                        do lmt2=lmt1,ilmt(it)
                           il2=ltp(lmt2,it)
                           im2=mtp(lmt2,it)
                           it2=taup(lmt2,it)
                           jj=(il2-1)**2+im2
                           fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0

                           sum2=0.d0
                           do iopr=1,nopr
                              ja=abs(ia2ia_symmtry_op(ia,iopr))
                              sum2=sum2+hsr(ja,lmt1,lmt2,is)* &
                                   ylm_sym(iopr,ii)* &
                                   ylm_sym(iopr,jj)
                           end do
                           sum2=sum2/dble(nopr)

                           sum=sum+fac* &
                                phirpw(ir,il1,it1,it)* &
                                phirpw(ir,il2,it2,it)* &
                                sum2
                        end do
                     end do
                  end do
                  rr=radr_paw(ir,it)
                  write(unit,'(4e19.6)') xorg+x0*rr, &
                       yorg+y0*rr, &
                       zorg+z0*rr,sum/rr/rr
               end do
            end do
         end do
      end do

      deallocate(ylm_sym)
      return
    end subroutine wd_averaged_ps_cd

    subroutine wd_averaged_valence_cd(unit)
      integer,intent(in):: unit
      integer:: ia,it,ith,iph,nrc,ir,is,ip,iopr,ja
      integer:: lmt1,lmt2,il1,il2,im1,im2,it1,it2,ii,jj
      real(DP):: sint,cost,phi
      real(DP):: x0,y0,z0,xorg,yorg,zorg,pos1,pos2,pos3
      real(DP):: sum1,sum2,fac,rr,vec(3),vec0(3),sum3
      real(DP),pointer,dimension(:,:):: ylm_sym
      character(len=32):: title

      allocate(ylm_sym(nopr+af,25))
      ylm_sym=0.d0

      do ia=1,natm
         it=ityp(ia)
         if(ipaw(it)/=1) cycle
         nrc=wf_mnrc(it)
         pos1=pos(ia,1);if(pos1<0) pos1=pos1+1.d0
         pos2=pos(ia,2);if(pos2<0) pos2=pos2+1.d0
         pos3=pos(ia,3);if(pos3<0) pos3=pos3+1.d0
         xorg=altv(1,1)*pos1+altv(1,2)*pos2+altv(1,3)*pos3
         yorg=altv(2,1)*pos1+altv(2,2)*pos2+altv(2,3)*pos3
         zorg=altv(3,1)*pos1+altv(3,2)*pos2+altv(3,3)*pos3
         write(title,'("chgval_sym",i4.4)') ia
         write(unit,'(3a,i6,a,i6,a,i6,a)') &
              'ZONE T=',trim(title),'  I=',nrc &
              ,', J=',nphi+1 &
              ,', K=',ntheta &
              ,', F=POINT'
         do ith=1,ntheta
            cost=cos_theta(ith)
            sint=sqrt(1.d0-cost**2)
            do ip=1,nphi+1
               iph=ip
               if(ip.eq.nphi+1) iph=1
               phi=PAI2/dble(nphi)*dble(iph-1)
               x0=sint*cos(phi)
               y0=sint*sin(phi)
               z0=cost
               vec0(1)=x0
               vec0(2)=y0
               vec0(3)=z0
               call set_ylms_symmtry_op(ia,25,vec0,ylm_sym)

               do ir=1,nrc
                  sum1=0.d0
                  sum2=0.d0
                  do is=1,nspin
                     do lmt1=1,ilmt(it)
                        il1=ltp(lmt1,it)
                        im1=mtp(lmt1,it)
                        it1=taup(lmt1,it)
                        ii=(il1-1)**2+im1
                        do lmt2=lmt1,ilmt(it)
                           il2=ltp(lmt2,it)
                           im2=mtp(lmt2,it)
                           it2=taup(lmt2,it)
                           jj=(il2-1)**2+im2
                           fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0

                           sum3=0.d0
                           do iopr=1,nopr
                              ja=abs(ia2ia_symmtry_op(ia,iopr))
                              sum3=sum3+hsr(ja,lmt1,lmt2,is)* &
                                   ylm_sym(iopr,ii)* &
                                   ylm_sym(iopr,jj)
                           end do
                           sum3=sum3/dble(nopr)

                           sum1=sum1+fac* &
                                psirpw(ir,il1,it1,it)* &
                                psirpw(ir,il2,it2,it)* &
                                sum3
                           sum2=sum2+fac* &
                                phirpw(ir,il1,it1,it)* &
                                phirpw(ir,il2,it2,it)* &
                                sum3
                        end do
                     end do
                  end do
                  rr=radr_paw(ir,it)
                  vec=(/xorg+x0*rr,yorg+y0*rr,zorg+z0*rr/)
                  vec=matmul(rltv,vec)/PAI2
                  write(unit,'(4e19.6)') xorg+x0*rr, &
                       yorg+y0*rr, &
                       zorg+z0*rr, &
                       (sum1-sum2)/rr/rr+ &
                       getFFTValue(vec,'soft')
               end do
            end do
         end do
      end do

      return
    end subroutine wd_averaged_valence_cd

  end subroutine m_PAWCD_wd_cd

  subroutine set_ia2ia_symmtry_op
    integer:: ia,it,no,ja,jt
    integer:: i,j,k
    real(DP):: pos0(3),pos1(3),pos2(3),pos3(3)
    real(DP):: distance

    allocate(op_pr(3,3,nopr+af))
    call m_CS_op_in_PUCD(nfout,op_pr,nopr+af)

    do ia=1,natm
       it=ityp(ia)
       if(ipaw(it)/=1) cycle
       pos0(1:3)=pos(ia,1:3)
!print *,'pos0=',pos0
       pos0(:) = pos0(:) - floor(pos0(:))
       do no=1,nopr
          pos1(:)=matmul(op_pr(:,:,no),pos0(:))+tau(:,no,BUCS)

          pos1(:) = pos1(:) - floor(pos1(:))
          KLoop: do k=-1,1
             do j=-1,1
                do i=-1,1
                   do ja=1,natm
                      jt=ityp(ja)
                      if(it/=jt) cycle
                      pos3(1:3) = pos(ja,1:3)
                      pos3(:) = pos3(:) - floor(pos3(:))
                      pos2(1:3)=pos3(1:3)+(/dble(i),dble(j),dble(k)/)

                      distance=abs(pos1(1)-pos2(1))+abs(pos1(2)-pos2(2)) &
                           +abs(pos1(3)-pos2(3))
                      if(distance < 1.d-5) then
                         ia2ia_symmtry_op(ia,no)=ja

                         exit KLoop
                      end if

                      if(kimg==1 .and. iwei(ja)==2) then
                         pos2(1:3)=-pos3(1:3)+(/dble(i),dble(j),dble(k)/)
                         distance=abs(pos1(1)-pos2(1))+abs(pos1(2)-pos2(2)) &
                              +abs(pos1(3)-pos2(3))
                         if(distance < 1.d-5) then
                            ia2ia_symmtry_op(ia,no)=-ja

                            exit KLoop
                         end if
                      end if

                      if(i.eq.1 .and. j.eq.1 .and. k.eq.1 .and. ja==natm) then
                         write(nfout,*) 'Error in set_ia2ia_symmtry_op (in m_PAW_ChargeDensity) !'
                         write(nfout,*) 'ia,no =', ia,no
                         write(nfout,'(" pos(ia)                     = ",3f10.4)') pos(ia,1:3)
                         write(nfout,'(" pos1(ia) = op*pos(ia)+tau   = ",3f10.4)') pos1(1:3)
                         call phase_error_with_msg(nfout,'Error in set_ia2ia_symmtry_op (in m_PAW_ChargeDensity) !'&
                                                  ,__LINE__,__FILE__)
                      end if

                   end do
                end do
             end do
          end do KLoop
       end do
    end do

    deallocate(op_pr)
    return
  end subroutine set_ia2ia_symmtry_op

  subroutine set_ylms_symmtry_op(ia,ilmax,vec0,ylm_sym)
    integer,intent(in):: ia,ilmax
    real(DP),intent(in):: vec0(3)
    real(DP),intent(out):: ylm_sym(nopr+af,ilmax)

    integer:: is,iopr
    real(DP),pointer,dimension(:)     :: gx,gy,gz,tylm
    real(DP):: vec(3)

    allocate(gx(nopr+af))
    allocate(gy(nopr+af))
    allocate(gz(nopr+af))
    allocate(tylm(nopr+af))

    do iopr=1,nopr
       vec(:)=matmul(op(:,:,iopr),vec0(:))
       if(ia2ia_symmtry_op(ia,iopr) < 0) vec=-vec
       gx(iopr)=vec(1)
       gy(iopr)=vec(2)
       gz(iopr)=vec(3)
    end do

    do is=1,ilmax
       call sphr(nopr,is,gx(1:nopr),gy(1:nopr),gz(1:nopr),tylm(1:nopr))
       do iopr=1,nopr
          ylm_sym(iopr,is)=tylm(iopr)
       end do
    end do

    deallocate(gx,gy,gz,tylm)
    return
  end subroutine set_ylms_symmtry_op

  subroutine set_diff_ylms_symmtry_op(ia,ilmax,vec0,ylm_sym,dylm_dth_sym,dylm_dph_sym)
    integer,intent(in):: ia,ilmax
    real(DP),intent(in):: vec0(3)
    real(DP),intent(out):: ylm_sym(nopr+af,ilmax)
    real(DP),intent(out):: dylm_dth_sym(nopr+af,ilmax)
    real(DP),intent(out):: dylm_dph_sym(nopr+af,ilmax)

    integer:: is,iopr
    real(DP),pointer,dimension(:)     :: gx,gy,gz,tylm
    real(DP),pointer,dimension(:,:)   :: tdylm
    real(DP):: vec(3),rr,vec1(3),vec2(3)

    allocate(gx(nopr+af))
    allocate(gy(nopr+af))
    allocate(gz(nopr+af))
    allocate(tylm(nopr+af))
    allocate(tdylm(nopr+af,3))

    do iopr=1,nopr
       vec(:)=matmul(op(:,:,iopr),vec0(:))
       if(ia2ia_symmtry_op(ia,iopr) < 0) vec=-vec
       gx(iopr)=vec(1)
       gy(iopr)=vec(2)
       gz(iopr)=vec(3)
    end do

    do is=1,ilmax
       call sphr(nopr,is,gx(1:nopr),gy(1:nopr),gz(1:nopr),tylm(1:nopr))
       do iopr=1,nopr
          ylm_sym(iopr,is)=tylm(iopr)
       end do
    end do

    rr=sqrt(vec0(1)**2+vec0(2)**2)
    vec1(1)=vec0(3)*vec0(1)/rr
    vec1(2)=vec0(2)*vec0(3)/rr
    vec1(3)=-rr
    vec2(1)=-vec0(2)
    vec2(2)=vec0(1)
    vec2(3)=0.d0

    do is=1,ilmax
       call sphr_diff(nopr,nopr,is,gx(1:nopr),gy(1:nopr),gz(1:nopr),tdylm(1:nopr,1:3))
       do iopr=1,nopr
          vec=matmul(op(:,:,iopr),vec1(:))
          dylm_dth_sym(iopr,is)=  tdylm(iopr,1)*vec(1)+ &
               tdylm(iopr,2)*vec(2)+ &
               tdylm(iopr,3)*vec(3)
          vec=matmul(op(:,:,iopr),vec2(:))
          dylm_dph_sym(iopr,is)=  tdylm(iopr,1)*vec(1)+ &
               tdylm(iopr,2)*vec(2)+ &
               tdylm(iopr,3)*vec(3)

          if(ia2ia_symmtry_op(ia,iopr) < 0) then
             dylm_dth_sym(iopr,is)=-dylm_dth_sym(iopr,is)
             dylm_dph_sym(iopr,is)=-dylm_dph_sym(iopr,is)
          end if
          !                ylm_sym(iopr,is)=tylm(iopr)
       end do
    end do

    deallocate(gx,gy,gz,tylm,tdylm)
    return
  end subroutine set_diff_ylms_symmtry_op

  subroutine m_PAWCD_wd_number_of_state(nfout)
    integer,intent(in):: nfout

    integer:: ia,ja,it,ith,iph
    integer:: ir,is,ier,nrc
    real(DP):: costh,sinth,phi,dvec(3)
    real(DP),pointer,dimension(:,:):: nae
    real(DP),pointer,dimension(:):: wos
    real(DP),pointer,dimension(:,:):: nsae
    logical,pointer,dimension(:):: flg_done

    allocate(nae(mmesh,nspin))
    allocate(wos(mmesh));wos=0.d0
    allocate(nsae(natm,nspin))
    if(af /= 0) then
       allocate(flg_done(natm))
       flg_done=.false.
    end if
    nsae=0.d0

    do ia=1,natm
       if(af /= 0) then
          if(flg_done(ia)) cycle
       end if
       it=ityp(ia)
       if(ipaw(it)/=1) cycle
       nrc=wf_mnrc(it)
       call set_weight_exp(ier,1,nrc,radr_paw(:,it),wos)
       do ir=1,nrc
          wos(ir)=wos(ir)*radr_paw(ir,it)**2
       end do
!            wos=wos*iwei(ia)
       do ith=1,ntheta
          costh=cos_theta(ith)
          sinth=sqrt(1.d0-costh**2)
          do iph=1,nphi
             phi=PAI2/dble(nphi)*dble(iph-1)
             dvec(1)=sinth*cos(phi)
             dvec(2)=sinth*sin(phi)
             dvec(3)=costh
             call m_PAWCD_set_ae_vd_sym &
                  (dvec,ia,nspin,nrc,nae(1:nrc,1:nspin))

             do is=1,nspin
                do ir=1,nrc
                   nsae(ia,is)=nsae(ia,is)+ &
                        nae(ir,is)*omg_wght(ith)*wos(ir)
                end do
             end do
          end do
       end do

       if(af /= 0) then
          ja=ia2ia_symmtry_op(ia,nopr+af)
          flg_done(ja)=.true.
       end if
    end do
    nsae=nsae*PAI4

    if(printable)then
       write(nfout,*) 'Site-decomposed number of states below the Fermi energy.'
       write(nfout,*) '      Site        Spin-up            Spin-down'
    endif

    flg_done=.false.

    do ia=1,natm
       if(af /= 0) then
          if(flg_done(ia)) cycle
       end if
       it=ityp(ia)
       if(ipaw(it)/=1) cycle
       if(nspin.eq.2) then
          if(printable) write(nfout,'(i10,2f19.6)')  ia,nsae(ia,1),nsae(ia,2)
       else
          if(printable) write(nfout,'(i10,2f19.6)')  ia,nsae(ia,1)/2.d0,nsae(ia,1)/2.d0
       end if
       if(af /= 0) then
          ja=ia2ia_symmtry_op(ia,nopr+af)
          if(printable) write(nfout,'(i10,2f19.6)')  ja,nsae(ia,2),nsae(ia,1)
          flg_done(ja)=.true.
       end if
    end do

    if(printable) write(nfout,*)

    deallocate(nae)
    deallocate(wos)
    deallocate(nsae)
    if(af /= 0) deallocate(flg_done)

  end subroutine m_PAWCD_wd_number_of_state

  subroutine m_PAWCD_set_ae_cd_sphex2( ia,nspin,nrc,dnr &
       &                              ,msph,n1nc,msphmx &
       &                              ,num_isph,isph_chg )
    integer,intent(in) :: ia,nspin,nrc,dnr,msph
    real(8),intent(out):: n1nc(nrc,nspin,25)
    integer,intent(out):: msphmx
    integer,intent(out):: num_isph,isph_chg(25)

    real(8):: n1(nrc,nspin),sum,fac,isqrt4pi,eps,abshsr, weight
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj,n,isp
    logical:: flg_isph(25)

    it=ityp(ia)
    n1nc=0.d0
    msphmx=0
    eps=1.d-10
    flg_isph=.false.
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1
       do lmt2=lmt1,ilmt(it)
          abshsr=abs(hsr(ia,lmt1,lmt2,1))
          if(nspin.eq.2) abshsr=abshsr+abs(hsr(ia,lmt1,lmt2,2))
          if(abshsr .lt. eps) cycle
          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
          do n=1,il2p(lmt1,lmt2,it)
             isp=isph(lmt1,lmt2,n,it)
             if(isp.gt.msphmx) msphmx=isp
             flg_isph(isp)=.true.
             do is=1,nspin
                sum=fac*hsr(ia,lmt1,lmt2,is)*dl2p(lmt1,lmt2,n,it)

                do ir=1,nrc,dnr
                   n1nc(ir,is,isp)=n1nc(ir,is,isp)+sum* &
                        psirpw(ir,il1,it1,it)* &
                        psirpw(ir,il2,it2,it)
                end do
             end do
          end do
       end do
    end do

    num_isph=0
    isph_chg=0
    do isp=1,25
       if(flg_isph(isp)) then
          num_isph=num_isph+1
          isph_chg(num_isph)=isp
       end if
    end do

    isqrt4pi=1.d0/sqrt(PAI4)
    do is=1,nspin
       do ir=1,nrc,dnr
          n1nc(ir,is,1)=(n1nc(ir,is,1)*isqrt4pi+rhcorpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it)
       end do
    end do

    if ( sw_opencore == ON .and. nspin == 2 ) then
       if ( has_opencore(it) == 1 ) then
          weight = 0.5d0 *mag_opencore_pol(ia,1)
          do ir=1,nrc,dnr
             n1nc(ir,1,1) = n1nc(ir,1,1) +rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
             n1nc(ir,2,1) = n1nc(ir,2,1) -rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
          end do
       endif
    endif

!        do n=2,msph
    do isp=2,num_isph
       n=isph_chg(isp)
       do is=1,nspin
          do ir=1,nrc,dnr
             n1nc(ir,is,n)=n1nc(ir,is,n)/radr_paw(ir,it)/radr_paw(ir,it)
          end do
       end do
    end do
!
!do ir=1,nrc
!print '(11e19.6)', radr_paw(ir,it),n1nc(ir,1,11:20)
!end do
!stop
    return
  end subroutine m_PAWCD_set_ae_cd_sphex2


! ============================ added by K. Tagami ========== 11.0
  subroutine m_PAWCD_ae_cd_sphex2_nonclA( ia, nspin, nrc, dnr,  &
       &                                  msph, n1nc, msphmx, &
       &                                  num_isph, isph_chg, wos, &
       &                                  level_of_projection, &
       &                                  magmom_avg_spherical, rho_rad )
    integer, intent(in) :: ia,nspin,nrc,dnr,msph
    integer, intent(out):: msphmx
    integer, intent(out):: num_isph,isph_chg(max_sph_expansion)
    integer, intent(in) :: level_of_projection

    real(kind=DP), intent(out):: n1nc( nrc, nspin, max_sph_expansion )
    real(kind=DP), intent(in) :: wos(mmesh)
    real(kind=DP), intent(out) :: magmom_avg_spherical(3,max_sph_expansion)
    real(kind=DP), intent(out) :: rho_rad( nrc, ndim_magmom, max_sph_expansion )

    real(kind=DP) :: sum,fac,isqrt4pi,eps,abshsr, ctmp, weight

    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj,n,isp
    logical:: flg_isph( max_sph_expansion )

    it=ityp(ia)
    n1nc=0.d0; rho_rad = 0.0d0

    msphmx=0
    eps=1.d-10
    flg_isph=.false.

    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it);  im1=mtp(lmt1,it);   it1=taup(lmt1,it)

       ii=(il1-1)**2+im1

       do lmt2=lmt1,ilmt(it)
          abshsr = abs(hsr(ia,lmt1,lmt2,1))
          if(abshsr .lt. eps) cycle

          il2=ltp(lmt2,it); im2=mtp(lmt2,it);  it2=taup(lmt2,it)
          jj=(il2-1)**2+im2

          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0

          do n=1,il2p(lmt1,lmt2,it)
             isp = isph(lmt1,lmt2,n,it)
             if (isp.gt.msphmx ) msphmx=isp
             flg_isph(isp)=.true.

             do is=1,ndim_magmom
                sum = fac*hsr(ia,lmt1,lmt2,is)*dl2p(lmt1,lmt2,n,it)
                do ir=1,nrc,dnr
                   rho_rad(ir,is,isp) = rho_rad(ir,is,isp) &
                        &         +sum * psirpw(ir,il1,it1,it) &
                        &              * psirpw(ir,il2,it2,it)
                end do
             end do
          end do
       end do
    end do

    num_isph=0;   isph_chg=0

    do isp=1,max_sph_expansion
       if (flg_isph(isp)) then
          num_isph=num_isph+1
          isph_chg(num_isph)=isp
       end if
    end do

    if ( mode_of_projection == project_on_local_quantz_axis ) then
!
       select case( level_of_projection )
       case (1)
          call get_magmom_spherical( ia, nrc, dnr, rho_rad, wos, &
               &                     magmom_avg_spherical(:,1) )
          call radial_chg_along_LocalQuanzAxis( nrc, dnr, rho_rad, &
               &                                magmom_avg_spherical(:,1), n1nc )

       case(2,3)
          call get_magmom_spherical2( ia, nrc, dnr, rho_rad, wos, magmom_avg_spherical )
          call radial_chg_along_LocalQuanzAxis( nrc, dnr, rho_rad, &
               &                                magmom_avg_spherical(:,1), n1nc )

       case(4)
          call get_magmom_spherical( ia, nrc, dnr, rho_rad, wos, &
               &                     magmom_avg_spherical(:,1) )
          call radial_chg_alng_LocalQuanzAxis2( nrc, dnr, rho_rad, n1nc )

       end select

    else
       call phase_error_with_msg(nfout,'kt : under conctruction ',__LINE__,__FILE__)
    end if
!
    isqrt4pi=1.d0/sqrt(PAI4)
    do is=1,nspin
       do ir=1,nrc,dnr
          n1nc(ir,is,1) = (n1nc(ir,is,1)*isqrt4pi+rhcorpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it)
       end do
    end do

    if ( sw_opencore == ON .and. nspin == 2 ) then
       if ( has_opencore(it) == 1 ) then
          ctmp = magmom_avg_spherical(1,1)**2 +magmom_avg_spherical(2,1)**2 &
               & +magmom_avg_spherical(3,1)**2
          ctmp = sqrt(ctmp)
          if ( ctmp > 1.0D-11 ) then
             weight = magmom_avg_spherical(1,1)/ctmp *mag_opencore_pol(ia,1) &
                  &  +magmom_avg_spherical(2,1)/ctmp *mag_opencore_pol(ia,2) &
                  &  +magmom_avg_spherical(3,1)/ctmp *mag_opencore_pol(ia,3)
             weight = 0.5d0 *weight
          else
             weight = 0.50d0
          endif

          do ir=1,nrc,dnr
             n1nc(ir,1,1) = n1nc(ir,1,1) +rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
             n1nc(ir,2,1) = n1nc(ir,2,1) -rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
          end do
       endif
    endif

!        do n=2,msph
    do isp=2,num_isph
       n=isph_chg(isp)
       do is=1,nspin
          do ir=1,nrc,dnr
             n1nc(ir,is,n)=n1nc(ir,is,n)/radr_paw(ir,it)/radr_paw(ir,it)
          end do
       end do
    end do

    return

  end subroutine m_PAWCD_ae_cd_sphex2_nonclA
! =========================================================== 11.0

! ============================== added by K. Tagami ================== 11.0
  subroutine radial_chg_along_LocalQuanzAxis( nrc, dnr, rho_rad, &
       &                                      magmom_avg_spherical, &
       &                                      rho_rad_along_quantz_axis )
! --
    integer, intent(in) :: nrc, dnr
    real(kind=DP), intent(in) :: rho_rad( nrc, ndim_magmom, max_sph_expansion )
    real(kind=DP), intent(in) :: magmom_avg_spherical( 3 )
    real(kind=DP), intent(out) :: &
         &                rho_rad_along_quantz_axis( nrc, nspin, max_sph_expansion )

    real(kind=DP) :: c_mx, c_my, c_mz, m_norm
    real(kind=DP) :: mmx, mmy, mmz

    real(kind=DP) :: c1, c2, d1, d2, ctmp2
    integer :: ir, isp
!    real(kind=DP) :: m_norm_criteria = 1.0D-20
    real(kind=DP) :: m_norm_criteria = 1.0D-18

    c_mx = magmom_avg_spherical(1)
    c_my = magmom_avg_spherical(2)
    c_mz = magmom_avg_spherical(3)
    m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )
!
    if ( m_norm > m_norm_criteria ) then
       mmx = c_mx / m_norm
       mmy = c_my / m_norm
       mmz = c_mz / m_norm
    else
       mmx = 0.0d0;  mmy = 0.0d0;  mmz = 1.0d0
       mmx = 0.0d0;  mmy = 0.0d0;  mmz = 0.0d0

!       ctmp2 =  c_mx *Global_Quantz_Axis_now(1) &
!            &  +c_my *Global_Quantz_Axis_now(2) &
!            &  +c_mz *Global_Quantz_Axis_now(3)
!
!       if ( ctmp2 > 0.0 ) then
!          mmx = Global_Quantz_Axis_now(1)
!          mmy = Global_Quantz_Axis_now(2)
!          mmz = Global_Quantz_Axis_now(3)
!       else
!          mmx = -Global_Quantz_Axis_now(1)
!          mmy = -Global_Quantz_Axis_now(2)
!          mmz = -Global_Quantz_Axis_now(3)
!       endif
    endif

    Do ir=1, nrc, dnr
       c1 = rho_rad(ir,1,1);
       c2 = rho_rad(ir,2,1) *mmx + rho_rad(ir,3,1) *mmy + rho_rad(ir,4,1) *mmz
       d1 = ( c1 + c2 ) /2.0d0;
       d2 = ( c1 - c2 ) /2.0d0;

       rho_rad_along_quantz_axis(ir,1,1) = d1
       rho_rad_along_quantz_axis(ir,2,1) = d2
    End do

    Do isp=2, max_sph_expansion
       Do ir=1, nrc, dnr
          c1 = rho_rad(ir,1,isp);
          c2 = rho_rad(ir,2,isp) *mmx +rho_rad(ir,3,isp) *mmy +rho_rad(ir,4,isp) *mmz
          d1 = ( c1 + c2 ) /2.0d0;
          d2 = ( c1 - c2 ) /2.0d0;

          rho_rad_along_quantz_axis(ir,1,isp) = d1
          rho_rad_along_quantz_axis(ir,2,isp) = d2
       End do
    End do
!
  end subroutine radial_chg_along_LocalQuanzAxis

  subroutine radial_chg_alng_LocalQuanzAxis2( nrc, dnr, rho_rad, &
       &                                      rho_rad_along_quantz_axis )
! --
    integer, intent(in) :: nrc, dnr
    real(kind=DP), intent(in) :: rho_rad( nrc, ndim_magmom, max_sph_expansion )
    real(kind=DP), intent(out) :: &
         &                rho_rad_along_quantz_axis( nrc, nspin, max_sph_expansion )

    real(kind=DP) :: c_mx, c_my, c_mz, m_norm
    real(kind=DP) :: mmx, mmy, mmz

    real(kind=DP) :: c1, c2, d1, d2, ctmp2, c3
    integer :: ir, isp
!    real(kind=DP) :: m_norm_criteria = 1.0D-20
    real(kind=DP) :: m_norm_criteria = 1.0D-18

    Do ir=1, nrc, dnr
       c1 = rho_rad(ir,1,1);
       c2 = sqrt( rho_rad(ir,2,1)**2 + rho_rad(ir,3,1)**2 + rho_rad(ir,4,1)**2 )

       d1 = ( c1 + c2 ) /2.0d0;
       d2 = ( c1 - c2 ) /2.0d0;

       rho_rad_along_quantz_axis(ir,1,1) = d1
       rho_rad_along_quantz_axis(ir,2,1) = d2

       Do isp=2, max_sph_expansion
          c1 = rho_rad(ir,1,isp);

          if ( c2 > m_norm_criteria ) then
             mmx = rho_rad(ir,2,1) / c2
             mmy = rho_rad(ir,3,1) / c2
             mmz = rho_rad(ir,4,1) / c2
          else
             mmx = 0.0;  mmy = 0.0;  mmz = 0.0
          endif

          c3 = rho_rad(ir,2,isp) *mmx +rho_rad(ir,3,isp) *mmy +rho_rad(ir,4,isp) *mmz

          d1 = ( c1 + c3 ) /2.0d0;
          d2 = ( c1 - c3 ) /2.0d0;

          rho_rad_along_quantz_axis(ir,1,isp) = d1
          rho_rad_along_quantz_axis(ir,2,isp) = d2
       End do
    End do
!
  end subroutine radial_chg_alng_LocalQuanzAxis2

  subroutine get_magmom_spherical( ia, nrc, dnr, rho_rad, wos, magmom_avg_spherical )
    integer, intent(in) :: nrc, ia, dnr
    real(kind=DP), intent(in) :: rho_rad(nrc,ndim_magmom,max_sph_expansion)
    real(kind=DP), intent(in) :: wos(nrc)
    real(kind=DP), intent(out) :: magmom_avg_spherical(3)

    integer :: is, ir
    real(kind=DP) :: csum

    Do is=2, ndim_magmom
       csum = 0.0d0
       Do ir=1, nrc, dnr
          csum = csum + rho_rad(ir,is,1) *wos(ir)
       End do
       magmom_avg_spherical( is-1 ) = csum
    End do
  end subroutine get_magmom_spherical

  subroutine get_magmom_spherical2( ia, nrc, dnr, rho_rad, wos, magmom_avg_spherical )
    integer, intent(in) :: nrc, ia, dnr
    real(kind=DP), intent(in) :: rho_rad(nrc,ndim_magmom,max_sph_expansion)
    real(kind=DP), intent(in) :: wos(nrc)
    real(kind=DP), intent(out) :: magmom_avg_spherical(3,max_sph_expansion)

    integer :: is, ir, ii
    real(kind=DP) :: csum

    magmom_avg_spherical = 0.0d0
    Do ii=1, max_sph_expansion
       Do is=2, ndim_magmom
          csum = 0.0d0
          Do ir=1, nrc, dnr
             csum = csum + rho_rad(ir,is,ii) *wos(ir)
          End do
          magmom_avg_spherical( is-1, ii ) = csum
       End do
    End do
  end subroutine get_magmom_spherical2
! ============================================================= 11.0
  subroutine m_PAWCD_set_ps_cd_sphex2( ia,nspin,nrc,dnr &
       &                               ,msph,nps,msphmx &
       &                               ,num_isph,isph_chg )
    integer,intent(in) :: ia,nspin,nrc,dnr,msph
    real(8),intent(out):: nps(nrc,nspin,25)
    integer,intent(out):: msphmx
    integer,intent(out):: num_isph,isph_chg(25)

    real(8):: sum,fac,isqrt4pi,eps,abshsr, weight
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3
    logical:: flg_isph(25)
!        real(8),pointer,dimension(:):: qsum

    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(25));call substitute_il3(25,il3)
!        allocate(qsum(nrc))
    it=ityp(ia)
    nps=0.d0
    msphmx=0
    eps=1.d-10
    flg_isph=.false.
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1
       do lmt2=lmt1,ilmt(it)
          abshsr=abs(hsr(ia,lmt1,lmt2,1))
          if(nspin.eq.2) abshsr=abshsr+abs(hsr(ia,lmt1,lmt2,2))
          if(abshsr .lt. eps) cycle
          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
!                qsum=0.d0
          do n=1,il2p(lmt1,lmt2,it)
             ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
             iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
!!$                    if(iiqitg == 0) cycle
             if(ilm3.gt.msphmx) msphmx=ilm3
             flg_isph(ilm3)=.true.
             do is=1,nspin
                sum=fac*hsr(ia,lmt1,lmt2,is)*dl2p(lmt1,lmt2,n,it)
                do ir=1,nrc,dnr
                   nps(ir,is,ilm3)=nps(ir,is,ilm3) + sum* &
                        & (phirpw(ir,il1,it1,it)*phirpw(ir,il2,it2,it) &
                        &  +qrspspw(ir,iiqitg))
                end do
             end do
          end do
       end do
    end do

    num_isph=0
    isph_chg=0
    do ilm3=1,25
       if(flg_isph(ilm3)) then
          num_isph=num_isph+1
          isph_chg(num_isph)=ilm3
       end if
    end do

    isqrt4pi=1.d0/sqrt(PAI4)
    do is=1,nspin
       do ir=1,nrc,dnr
          nps(ir,is,1)=(nps(ir,is,1)*isqrt4pi+rhpcrpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it)
!            if(nps(ir,is,1).lt.0.d0) nps(ir,is,1)=0.d0
       end do
    end do

    if ( sw_opencore == ON .and. nspin == 2 .and. sw_xc_opencore_ae_only ==OFF ) then
       if ( has_opencore(it) == 1 ) then
          weight = 0.5d0 *mag_opencore_pol(ia,1)
          do ir=1,nrc,dnr
             nps(ir,1,1) = nps(ir,1,1) +rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
             nps(ir,2,1) = nps(ir,2,1) -rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
          end do
       endif
    endif

!        do n=2,msph
    do ilm3=2,num_isph
       n=isph_chg(ilm3)
       do is=1,nspin
          do ir=1,nrc,dnr
             nps(ir,is,n)=nps(ir,is,n)/radr_paw(ir,it)/radr_paw(ir,it)
!            if(nps(ir,is,n).lt.0.d0) nps(ir,is,n)=0.d0
          end do
       end do
    end do

!do ir=1,nrc
!print '(17e19.6)', radr_paw(ir,it),nps(ir,1,10:25)
!end do
!stop

    deallocate(il3)
    return
  end subroutine m_PAWCD_set_ps_cd_sphex2

! ===================== added by K. Tagami ==================== 11.0
  subroutine m_PAWCD_ps_cd_sphex2_nonclA( ia, nspin, nrc, dnr, &
       &                                  msph, nps, msphmx, &
       &                                  num_isph, isph_chg, wos, &
       &                                  level_of_projection, &
       &                                  magmom_avg_spherical, rho_rad )

    integer, intent(in) :: ia,nspin,nrc,dnr,msph
    integer, intent(in) :: level_of_projection
    integer, intent(out):: msphmx
    integer, intent(out):: num_isph,isph_chg(max_sph_expansion)

    real(kind=DP), intent(out):: nps( nrc, nspin, max_sph_expansion )
    real(kind=DP), intent(in) :: wos(mmesh)
    real(kind=DP), intent(out) :: magmom_avg_spherical(3,max_sph_expansion)
    real(kind=DP), intent(out) :: rho_rad( nrc, ndim_magmom, max_sph_expansion )

    real(kind=DP) :: sum,fac,isqrt4pi,eps,abshsr, ctmp, weight

    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3

    logical:: flg_isph( max_sph_expansion )

    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(max_sph_expansion))
    call substitute_il3(max_sph_expansion,il3)

    it=ityp(ia)
    nps=0.d0; rho_rad = 0.0d0

    msphmx=0
    eps=1.d-10
    flg_isph=.false.

    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
       ii=(il1-1)**2+im1

       do lmt2=lmt1,ilmt(it)
          abshsr =abs(hsr(ia,lmt1,lmt2,1))
          if(abshsr .lt. eps) cycle

          il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)
          jj=(il2-1)**2+im2

          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0

          do n=1,il2p(lmt1,lmt2,it)
             ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
             iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)

             if(ilm3.gt.msphmx) msphmx=ilm3
             flg_isph(ilm3)=.true.

             do is=1, ndim_magmom
                sum=fac*hsr(ia,lmt1,lmt2,is)*dl2p(lmt1,lmt2,n,it)
                do ir=1,nrc,dnr
                   rho_rad(ir,is,ilm3) = rho_rad(ir,is,ilm3) &
                        &               + sum* ( phirpw(ir,il1,it1,it) &
                        &                       *phirpw(ir,il2,it2,it) &
                        &                        +qrspspw(ir,iiqitg) )
                end do
             end do
          end do
       end do
    end do

    num_isph=0; isph_chg=0

    do ilm3=1,max_sph_expansion
       if(flg_isph(ilm3)) then
          num_isph=num_isph+1
          isph_chg(num_isph)=ilm3
       end if
    end do

    if ( mode_of_projection == project_on_local_quantz_axis ) then

       select case( level_of_projection )
       case (1)
          call get_magmom_spherical( ia, nrc, dnr, rho_rad, wos, &
               &                     magmom_avg_spherical(:,1) )
          call radial_chg_along_LocalQuanzAxis( nrc, dnr, rho_rad, &
               &                                magmom_avg_spherical(:,1), nps )

       case(2,3)
          call get_magmom_spherical2( ia, nrc, dnr, rho_rad, wos, magmom_avg_spherical )
          call radial_chg_along_LocalQuanzAxis( nrc, dnr, rho_rad, &
               &                                magmom_avg_spherical(:,1), nps )

       case(4)
          call get_magmom_spherical( ia, nrc, dnr, rho_rad, wos, &
               &                     magmom_avg_spherical(:,1) )
          call radial_chg_alng_LocalQuanzAxis2( nrc, dnr, rho_rad, nps )

       end select

    else
       call phase_error_with_msg(nfout,'kt : under conctruction ',__LINE__,__FILE__)
    end if

    isqrt4pi=1.d0/sqrt(PAI4)
    do is=1,nspin
       do ir=1,nrc,dnr
          nps(ir,is,1) = (nps(ir,is,1)*isqrt4pi+rhpcrpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it)
       end do
    end do

    if ( sw_opencore == ON .and. nspin == 2 .and. sw_xc_opencore_ae_only ==OFF ) then
       if ( has_opencore(it) == 1 ) then
          ctmp = magmom_avg_spherical(1,1)**2 +magmom_avg_spherical(2,1)**2 &
               & +magmom_avg_spherical(3,1)**2
          ctmp = sqrt(ctmp)
          if ( ctmp > 1.0D-11 ) then
             weight = magmom_avg_spherical(1,1)/ctmp *mag_opencore_pol(ia,1) &
                  &  +magmom_avg_spherical(2,1)/ctmp *mag_opencore_pol(ia,2) &
                  &  +magmom_avg_spherical(3,1)/ctmp *mag_opencore_pol(ia,3)
             weight = 0.5d0 *weight
          else
             weight = 0.50d0
          endif

          do ir=1,nrc,dnr
             nps(ir,1,1) = nps(ir,1,1) +rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
             nps(ir,2,1) = nps(ir,2,1) -rmag_opencore(ir,it)/PAI4 *weight &
                  &                        /radr_paw(ir,it)/radr_paw(ir,it)
          end do
       endif
    endif

    do ilm3=2,num_isph
       n=isph_chg(ilm3)
       do is=1,nspin
          do ir=1,nrc,dnr
             nps(ir,is,n)=nps(ir,is,n)/radr_paw(ir,it)/radr_paw(ir,it)
          end do
       end do
    end do

    deallocate(il3)
    return
  end subroutine m_PAWCD_ps_cd_sphex2_nonclA
! ================================================================= 11.0

  subroutine m_PAWCD_set_cr2_isph2_mmt2()
    integer:: lcmax
    logical,save:: initialized=.false.
    if(.not.initialized) then
       lcmax=4
       allocate(paw_cr2(25,25,6))
       allocate(paw_isph2(25,25,6))
       allocate(paw_mmt2(25,25))
       call sphset3(nfout,ipripaw,paw_cr2,paw_isph2,paw_mmt2)
       initialized=.true.
    end if
    return
  end subroutine m_PAWCD_set_cr2_isph2_mmt2

  subroutine m_PAWCD_set_sq_der_cd_sdphex2( ia,nspin,nrc,dnr &
       &                                    ,msphmx, num_isph_chg &
       &                                    ,isph_chg, nae_sph &
       &                                    ,dnae_dr_sph, grad_nae2 &
       &                                    ,grad_tnae2, msphmx_grd &
       &                                    ,num_isph_grd ,isph_grd )
    integer,intent(in) :: ia,nspin,nrc,dnr,msphmx,num_isph_chg,isph_chg(25)
    real(8),intent(in) :: nae_sph(nrc,nspin,25)
    real(8),intent(in) :: dnae_dr_sph(nrc,nspin,25)
    real(8),intent(out):: grad_nae2(nrc,nspin,25)
    real(8),intent(out):: grad_tnae2(nrc,25)
    integer,intent(out):: msphmx_grd,num_isph_grd
    integer,intent(out):: isph_grd(25)

    real(8):: n1(nrc,nspin),fac,bb
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj
    real(8):: sum1(nrc,nspin),sum2(nrc,nspin,25),sum3(nrc),sum4(nrc,25)
    real(8):: dl,dl1,dl2,dl3,cijk
    integer:: isp,isp2,isp3,lcmax,n
    integer:: nsp,nsp2,nsp3
    logical:: flg_isp(25)
    integer,pointer,dimension(:):: il3
    logical,save:: initialized=.false.

    if(.not.initialized) then
       lcmax=4
!            allocate(paw_cr2(16,16,6))
!            allocate(paw_isph2(16,16,6))
!            allocate(paw_mmt2(16,16))
!            call sphset2(nfout,ipri,lcmax,paw_cr2,paw_isph2,paw_mmt2)
       allocate(paw_cr2(25,25,6))
       allocate(paw_isph2(25,25,6))
       allocate(paw_mmt2(25,25))
       call sphset3(nfout,ipripaw,paw_cr2,paw_isph2,paw_mmt2)
       initialized=.true.
    end if

    allocate(il3(25));call substitute_il3(25,il3)
    it=ityp(ia)
    grad_nae2=0.d0
    grad_tnae2=0.d0
    sum1=0.d0
    sum3=0.d0
    flg_isp=.false.
!        do isp=2,msphmx
    do nsp=2,num_isph_chg
       isp=isph_chg(nsp)
       dl=dble(il3(isp))
       dl=dl*(dl+1.d0)
       do is=1,nspin
          do ir=1,nrc,dnr
             sum1(ir,is)=sum1(ir,is) + &
                  dnae_dr_sph(ir,is,isp)**2 + &
                  dl*nae_sph(ir,is,isp)**2/radr_paw(ir,it)/radr_paw(ir,it)
          end do
       end do
       if(nspin.eq.2) then
          do ir=1,nrc,dnr
             sum3(ir)=sum3(ir) + &
                  (dnae_dr_sph(ir,1,isp)+dnae_dr_sph(ir,2,isp))**2 + &
                  dl*(nae_sph(ir,1,isp)+nae_sph(ir,2,isp))**2/radr_paw(ir,it)/radr_paw(ir,it)
          end do
       end if
    end do
    do ir=1,nrc,dnr
       do is=1,nspin
          grad_nae2(ir,is,1)=dnae_dr_sph(ir,is,1)**2 + sum1(ir,is)/PAI4
       end do
       if(nspin.eq.2) then
          grad_tnae2(ir,1)=(dnae_dr_sph(ir,1,1)+dnae_dr_sph(ir,2,1))**2+sum3(ir)/PAI4
       end if
    end do
    flg_isp(1)=.true.

    sum2=0.d0
    sum4=0.d0
    msphmx_grd=0
!        do isp2=2,min(16,msphmx)                                ! sphset2
!        do isp2=2,msphmx                                        ! sphset3
    do nsp2=2,num_isph_chg
       isp2=isph_chg(nsp2)
       dl2=dble(il3(isp2))
       dl2=dl2*(dl2+1.d0)
!            do isp3=isp2,min(16,msphmx)                         ! sphset2
!            do isp3=isp2,msphmx                                 ! sphset3
       do nsp3=nsp2,num_isph_chg
          isp3=isph_chg(nsp3)
          dl3=dble(il3(isp3))
          dl3=dl3*(dl3+1.d0)
          fac=2.d0;if(isp2.eq.isp3) fac=1.d0
          do n=1,paw_mmt2(isp2,isp3)
             isp=paw_isph2(isp2,isp3,n)
             if(isp.eq.1) cycle
             if(isp.gt.msphmx_grd) msphmx_grd=isp
             flg_isp(isp)=.true.
             cijk=paw_cr2(isp2,isp3,n)
             dl=dble(il3(isp))
             dl=dl*(dl+1.d0)
!print *,isp,isp2,isp3
!print '(5e19.6)', fac, 0.5d0*(dl2+dl3-dl),dl,dl2,dl3
             do is=1,nspin
                do ir=1,nrc,dnr
                   sum2(ir,is,isp)=sum2(ir,is,isp) + &
                        fac*( &
                        dnae_dr_sph(ir,is,isp2)*dnae_dr_sph(ir,is,isp3) + &
                        0.5d0*(dl2+dl3-dl)*nae_sph(ir,is,isp2)*nae_sph(ir,is,isp3)/ &
                        radr_paw(ir,it)/radr_paw(ir,it) &
                        )*cijk
                end do
             end do

             if(nspin.eq.2) then
                do ir=1,nrc,dnr
                   sum4(ir,isp)=sum4(ir,isp) + &
                        fac*( &
                        (dnae_dr_sph(ir,1,isp2)+dnae_dr_sph(ir,2,isp2)) * &
                        (dnae_dr_sph(ir,1,isp3)+dnae_dr_sph(ir,2,isp3)) + &
                        0.5d0*(dl2+dl3-dl) * &
                        (nae_sph(ir,1,isp2)+nae_sph(ir,2,isp2)) * &
                        (nae_sph(ir,1,isp3)+nae_sph(ir,2,isp3))/ &
                        radr_paw(ir,it)/radr_paw(ir,it) &
                        )*cijk
                end do
             end if

          end do
       end do
    end do

    num_isph_grd=0
    isph_grd=0
    do isp=1,25
       if(flg_isp(isp)) then
          num_isph_grd=num_isph_grd+1
          isph_grd(num_isph_grd)=isp
       end if
    end do

!        do isp=2,msphmx_grd
    do nsp=2,num_isph_grd
       isp=isph_grd(nsp)
       do is=1,nspin
          do ir=1,nrc,dnr
             grad_nae2(ir,is,isp)=2.d0*dnae_dr_sph(ir,is,1)*dnae_dr_sph(ir,is,isp) &
                  & + sum2(ir,is,isp)
!if(isnan(grad_nae2(ir,is,isp))) then
!print '(i4,3e19.6)',isp,dnae_dr_sph(ir,is,1),dnae_dr_sph(ir,is,isp),sum2(ir,is,isp)
!stop
!end if
          end do
       end do

       if(nspin.eq.2) then
          do ir=1,nrc,dnr
             grad_tnae2(ir,isp)=2.d0*(dnae_dr_sph(ir,1,1)+dnae_dr_sph(ir,2,1)) * &
                  &               (dnae_dr_sph(ir,1,isp)+dnae_dr_sph(ir,2,isp))  &
                         &                + sum4(ir,isp)
!if(isnan(grad_nae2(ir,is,isp))) then
!print '(i4,3e19.6)',isp,dnae_dr_sph(ir,is,1),dnae_dr_sph(ir,is,isp),sum2(ir,is,isp)
!stop
!end if
          end do
       end if

    end do

    if(nspin.eq.1) then
!            do isp=1,msphmx_grd
       do nsp=1,num_isph_grd
          isp=isph_grd(nsp)
          do ir=1,nrc,dnr
             grad_tnae2(ir,isp)=grad_nae2(ir,1,isp)
          end do
       end do
    end if

    deallocate(il3)

    return
  end subroutine m_PAWCD_set_sq_der_cd_sdphex2

  subroutine m_PAWCD_calc_contact_density
                                   ! AE hard part density at nuclear radius
                                   ! assuming only s-orbital contributes

    integer :: ia, it, is, ir_nucl
    integer :: il1, il2, im1, im2, it1, it2, lmt1, lmt2
    integer :: n, isp
    real(kind=DP)  :: csum, ctmp, c1, c2, fac
    real(kind=DP), allocatable :: contact_charge_density(:)

    allocate( contact_charge_density(natm) ); contact_charge_density = 0.0d0

#if 1
    Do it=1, ntyp
       call calc_nuclear_radius( it, ir_nucl )

       Do ia=1, natm
          if ( ityp(ia) /= it ) cycle

          csum = 0.0d0

          do lmt1=1,ilmt(it)
             il1 = ltp(lmt1,it);  im1 = mtp(lmt1,it);   it1 = taup(lmt1,it)

             do lmt2=lmt1,ilmt(it)
                il2 = ltp(lmt2,it);   im2 = mtp(lmt2,it);    it2 = taup(lmt2,it)

                c1 = psirpw( ir_nucl, il1, it1, it )
                c2 = psirpw( ir_nucl, il2, it2, it )

                fac=2.d0; if( lmt1.eq.lmt2 ) fac=1.d0

                do n=1,il2p(lmt1,lmt2,it)
                   isp = isph(lmt1,lmt2,n,it)
                   if ( isp > 1 ) cycle

                   if ( noncol ) then
                      ctmp = hsr(ia,lmt1,lmt2,1)
                   else
                      ctmp = 0.0d0
                      Do is=1, nspin
                         ctmp = ctmp +hsr(ia,lmt1,lmt2,is)
                      End Do
                   endif

                   csum = csum + fac *ctmp *dl2p(lmt1,lmt2,n,it) *c1 *c2 /sqrt(PAI4)
                end do
             end do
          end do
          csum = csum + rhcorpw(ir_nucl,it)/PAI4

          contact_charge_density(ia) = csum /radr_paw( ir_nucl,it )**2
       end do
    end do

#else
    Do it=1, ntyp
       call calc_nuclear_radius( it, ir_nucl )

       Do ia=1, natm
          if ( ityp(ia) /= it ) cycle

          csum = 0.0d0

          Do lmt1=1, ilmt(it)
             il1 = ltp(lmt1,it);  im1 = mtp(lmt1,it);  it1 = taup(lmt1,it)
             if ( il1 > 1 ) cycle

             Do lmt2=1, ilmt(it)
                il2 = ltp(lmt2,it);  im2 = mtp(lmt2,it);  it2 = taup(lmt2,it)
                if ( il2 > 1 ) cycle

                if ( noncol ) then
                   ctmp = hsr(ia,lmt1,lmt2,1)
                else
                   ctmp = 0.0d0
                   Do is=1, nspin
                      ctmp = ctmp +hsr(ia,lmt1,lmt2,is)
                   End Do
                endif
                c1 = psirpw( ir_nucl, il1, it1, it )
                c2 = psirpw( ir_nucl, il2, it2, it )
                !
                ctmp = ctmp *c1 *c2 /sqrt(PAI4) + rhcorpw(ir_nucl,it)/PAI4
                csum = csum +ctmp /radr_paw( ir_nucl,it )**2
             End Do
          End Do
          contact_charge_density(ia) = csum
       End Do
    End Do
#endif
!
    write(nfout,*)
    write(nfout,*) '------------  MOSSB  ---------------'
    write(nfout,*) '!** contact charge density at nuclear radius '
    write(nfout,*) '!** ia,    density **'
    Do ia=1, natm
       write(nfout,'(I5,F25.12)') ia, contact_charge_density(ia)
    End Do
    write(nfout,*) '----------------------------------------'
    write(nfout,*)

    deallocate( contact_charge_density )

  contains

    subroutine calc_nuclear_radius( it, ir_nucl )
      integer, intent(in) :: it
      integer, intent(out):: ir_nucl

      integer :: ir
      real(kind=DP) :: r0, coeff, mass_no, r_nucl

      r0 = 1.20d0 *1.0D-5/ Bohr                    ! in bohr

      coeff = 1.0 / AMU  ! 1.66053d-27 /9.1093897d-31
      mass_no = amion(it) /coeff

      r_nucl = r0 *( mass_no )**(1.0d0/3.d0)

      Do ir=1, nmesh(it)
         if ( radr_paw(ir,it) > r_nucl ) exit
      End Do
      ir_nucl = ir
    end subroutine calc_nuclear_radius

  end subroutine m_PAWCD_calc_contact_density


end module m_PAW_ChargeDensity

!================================================
!  Software name : STM
!  Module : m_Files
!  Subroutine(s) : open_nfcntn_bin, m_Files_set_default_filenames,
!                  m_Files_read_file_names_data, m_Files_open_files_initially,
!                  open0, m_Files_close_all_files
!  Author(s)     : Takahiro Yamasaki and Koichi Kato (June 7, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

module m_Files
! $Id: m_Files.F90,v 1.1.1.1 2004/06/26 11:21:37 yamasaki Exp $
  use m_Const_Parameters, only : OLD, NEW, UNKNOWN, FORMATTED &
       & ,UNFORMATTED, check_file_name_on, check_file_name_off, DP &
       & ,ON, GENERAL

  implicit none

  integer :: nfinp, nfout, nfcntn_bin, nfchgu, nfchgd, nfzaj, nfvlc, nfchgu_p, nfchgd_p, nfvlcr
  data nfinp, nfout, nfcntn_bin, nfchgu, nfchgd, nfzaj, nfvlc, nfchgu_p, nfchgd_p, nfvlcr  &
       & /31,     6,     55,     60,     61,    44,    45,  46,  47,48 /
!!$  integer :: nfinp, nfopgr, nfmatbp, nfkpoint, nfkindex, nfgpt &
!!$       &, nfout, nfcntn, nfcntn_bin, nfchgt, nfchgu, nfchgd, nfzaj, nfvlc
!!$  data nfinp, nfopgr, nfmatbp, nfkpoint, nfkindex, nfgpt &
!!$       &, nfout, nfcntn, nfcntn_bin, nfchgt, nfchgu, nfchgd, nfzaj, nfvlc  &
!!$       & /31,21,22,23,24,54 &
!!$       &,  6,42,55,43,60,61,44,45 /

  integer, parameter :: number_of_all_files = 10
  integer, dimension(number_of_all_files) :: n_file
  data n_file &
       & /31,6,55,60,61,44,45,46,47,48 /
!!$       & /31,21,22,23,24,54 &
!!$       &,  6,42,55,43,60,61,44,45 /

  character*80 &
       &  F_INP, F_CNTN_BIN, F_CHGU, F_CHGD, F_ZAJ, F_VLC, F_CHGU_P, F_CHGD_P, F_VLCR &
!!$       &  F_INP, F_OPGR, F_MATBP, F_KPOINT, F_KINDEX, F_GPT &
!!$       &, F_CNTN, F_CNTN_BIN, F_CHGT, F_CHGU, F_CHGD, F_ZAJ, F_VLC &
       &, F_file_names_data
  namelist/fnames/&
       &  F_INP, F_CNTN_BIN, F_CHGU, F_CHGD, F_ZAJ, F_VLC, F_CHGU_P, F_CHGD_P, F_VLCR
!!$       &  F_INP, F_OPGR, F_MATBP, F_KPOINT, F_KINDEX, F_GPT &
!!$       &, F_CNTN, F_CNTN_BIN, F_CHGT, F_CHGU, F_CHGD, F_ZAJ, F_VLC

contains
!!$  subroutine open_nfcntn
!!$    logical open
!!$    inquire(unit = nfcntn, opened = open)
!!$    if(.not.open) &
!!$         & call open0(nfcntn,F_CNTN,'F_CNTN    ',unknown,formatted&
!!$         &     ,check_file_name_on)
!!$  end subroutine open_nfcntn

  subroutine open_nfcntn_bin
    logical open
    inquire(unit = nfcntn_bin, opened = open)
    if(.not.open) &
         & call open0(nfcntn_bin,F_CNTN_BIN,'F_CNTN_BIN',unknown,unformatted&
         &     ,check_file_name_on)
  end subroutine open_nfcntn_bin

  subroutine m_Files_set_default_filenames
    F_file_names_data   = './stm_file_names.data'

    F_INP       = './nfstminput.data'
!c---------- nbztype >= 100
!!$    F_OPGR      = './opgr.data'
!!$    F_MATBP     = './matrix.BP'
!!$    F_KPOINT    = './kpoint.dat'
!!$    F_KINDEX    = './f.kp0'
!c----------- Continue file
!!$    F_GPT       = './nfgpt.data'
!!$    F_CHGT      = './nfchgt.data'
    F_CHGU      = './nfchgu.cube'
    F_CHGD      = './nfchgd.cube'
    F_CHGU_P    = './nfchgu_asis.cube'
    F_CHGD_P    = './nfchgd_asis.cube'
!!$    F_CNTN      = './continue.data'
    F_CNTN_BIN  = './continue_bin_stm.data'
    F_ZAJ       = './zaj.data'
!c---------------------
    F_VLC       = './nfvlc.data'
    F_VLCR      = './nfvlcr.data'
  end subroutine m_Files_set_default_filenames

  subroutine m_Files_read_file_names_data
    integer, parameter ::  nffile = 5
    logical :: ex
    inquire(file=F_file_names_data,exist=ex)
    if (ex) then
      call open0(nffile, F_file_names_data, 'FFILENAMES', old, formatted,check_file_name_on)
      rewind nffile
      read(nffile,NML = fnames, err = 1004, end = 1004)
1004  continue
      close(nffile,status='keep')
    endif

    print *,' F_INP      = ', F_INP
!!$    print *,' F_CHGT     = ', F_CHGT
    print *,' F_CHGU     = ', F_CHGU
    print *,' F_CHGD     = ', F_CHGD
    print *,' F_CHGU_P   = ', F_CHGU_P
    print *,' F_CHGD_P   = ', F_CHGD_P
!!$    print *,' F_CNTN     = ', F_CNTN
    print *,' F_CNTN_BIN = ', F_CNTN_BIN
    print *,' F_ZAJ      = ', F_ZAJ
    print *,' F_VLC      = ', F_VLC
    print *,' F_VLCR     = ', F_VLCR
  end subroutine m_Files_read_file_names_data

  subroutine m_Files_open_files_initially
    print *,' open_files_initially start'
    call open0(nfinp, F_INP, 'F_INP     ',    old,   formatted,check_file_name_on)
!    call open0(nfchgt,F_CHGT,'F_CHGT    ',unknown, unformatted,check_file_name_on)
    call open0(nfchgu,F_CHGU,'F_CHGU    ',unknown,   formatted,check_file_name_on)
    call open0(nfchgd,F_CHGD,'F_CHGD    ',unknown,   formatted,check_file_name_on)
    call open0(nfchgu_p,F_CHGU_P,'F_CHGU_P  ',unknown,   formatted,check_file_name_on)
    call open0(nfchgd_p,F_CHGD_P,'F_CHGD_P  ',unknown,   formatted,check_file_name_on)
    call open0(nfzaj, F_ZAJ, 'F_ZAJ     ',unknown, unformatted,check_file_name_on)
!!$    call open0(nfcntn,F_CNTN,'F_CNTN    ',    old,   formatted,check_file_name_on)
    call open0(nfcntn_bin,F_CNTN_BIN,'F_CNTN_BIN',    old, unformatted,check_file_name_on)
    call open0(nfvlc, F_VLC, 'F_VLC     ',unknown, unformatted,check_file_name_on)
    call open0(nfvlcr,F_VLCR,'F_VLCR    ',unknown, formatted,check_file_name_on)
    print *,' open_files_initially end'
  end subroutine m_Files_open_files_initially

  subroutine open0(nfile,filename,tagname,status, form, write_or_no)
    integer, intent(in) :: nfile
    character*(*), intent(in) :: filename
    character*(10),intent(in) ::  tagname
    integer, intent(in) :: status, form, write_or_no

    if(status==old .and. form==formatted) then
       open(nfile,file=filename, status='old', form='formatted')
    else if(status==old .and. form==unformatted) then
       open(nfile,file=filename, status='old', form='unformatted')
    else if(status==unknown .and. form==formatted) then
       open(nfile,file=filename, status='unknown', form='formatted')
    else if(status==unknown .and. form==unformatted) then
       open(nfile,file=filename, status='unknown', form='unformatted')
    endif

    if(write_or_no == check_file_name_on) then
       write(nfout,9001) tagname, ' = ', filename
    endif
9001 format(' ',a10,a3,a60)
  end subroutine open0

  subroutine m_Files_close_all_files
    integer i
    logical open
    do i = 1, number_of_all_files
       if(n_file(i) == 6) cycle
       inquire(unit = n_file(i), opened = open)
       if(open) then
          close(n_file(i),status='keep')
          write(nfout,*) ' closed filenumber = ', n_file(i)
       endif
    enddo
    close(6, status='keep')
  end subroutine m_Files_close_all_files
end module m_Files

!=======================================================================
!
!  PROGRAM  PHASE/0 2023.01
!
!  FUNCTION:  getUnitId, setUnit, updateUnits, clearUnitFlag, setDefaultUnits,
!            realConvByUnit, f_openInputFile, f_closeInputFile, f_selectTop,
!        f_selectBlock, f_selectParentBlock, f_getIntValue, f_getIntVectorValue
!          f_getRealValue, f_getRealVectorValue, f_getStringValue,
!          f_selectFirstTableLine, f_selectNextTableLine, f_readUnitCell,
!          f_readSymmetryGenerator, f_readKPoints, fstreq
!
!  AUTHOR(S): K. Mae, T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
! $Id: input_interface.F90 572 2017-04-28 06:39:12Z ktagami $
!
!!$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$! interface functions
!!$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$module input_interface
!!$
!!$        use input_tag
!!$        use unit_conv
!!$
!!$	integer, parameter :: FMAXTAGLEN = 256
!!$	integer, parameter :: FMAXVALLEN = 256
!!$	integer, parameter :: FMAXUNITLEN = 16
!!$	real(8), parameter :: PI = 3.14159265358979323846d0
!!$
!!$        type unitsystem
!!$            integer :: energy
!!$            integer :: length
!!$            integer :: time
!!$            integer :: mass
!!$            integer :: angle
!!$            integer :: temperature
!!$            integer :: velocity
!!$            integer :: force
!!$            integer :: pressure
!!$        end type unitsystem
!!$        type(unitsystem) :: usys_file, usys_ret
!!$
!!$        private getUnitNo
!!$        !interface
!!$        !    integer function getUnitNo( usys, unittypeid )
!!$        !        type(unitsystem), intent(in) :: usys
!!$        !        integer, intent(in) :: unittypeid
!!$        !    end function getUnitNo
!!$        !end interface
!!$contains


integer function getUnitId( usys, unittype )
    use m_Const_Parameters
    implicit none
    type(unitsystem), intent(in) :: usys
    integer, intent(in) :: unittype

    select case ( unittype )
    case ( TYPE_ENERGY )
        getUnitId = usys%energy
    case ( TYPE_LENGTH )
        getUnitId = usys%length
    case ( TYPE_TIME )
        getUnitId = usys%time
    case ( TYPE_MASS )
        getUnitId = usys%mass
    case ( TYPE_ANGLE )
        getUnitId = usys%angle
    case ( TYPE_TEMPERATURE )
        getUnitId = usys%temperature
    case ( TYPE_VELOCITY )
        getUnitId = usys%velocity
    case ( TYPE_FORCE )
        getUnitId = usys%force
    case ( TYPE_PRESSURE )
        getUnitId = usys%pressure
    end select

    return
end function getUnitId

integer function setUnit( usys, unitid, unittype )
    use m_Const_Parameters
    implicit none
    type(unitsystem), intent(inout) :: usys
    integer, intent(in) :: unitid, unittype

    select case ( unittype )
    case ( TYPE_ENERGY )
        if( usys%inpfg_energy ) then
            setUnit = -1
            return           
        end if
        usys%energy = unitid
        usys%inpfg_energy = .true.
    case ( TYPE_LENGTH )
        if( usys%inpfg_length ) then
            setUnit = -1
            return           
        end if
        usys%length = unitid
        usys%inpfg_length = .true.
    case ( TYPE_TIME )
        if( usys%inpfg_time ) then
            setUnit = -1
            return           
        end if
        usys%time = unitid
        usys%inpfg_time = .true.
    case ( TYPE_MASS )
        if( usys%inpfg_mass ) then
            setUnit = -1
            return           
        end if
        usys%mass = unitid
        usys%inpfg_mass = .true.
    case ( TYPE_ANGLE )
        if( usys%inpfg_angle ) then
            setUnit = -1
            return           
        end if
        usys%angle = unitid
        usys%inpfg_angle = .true.
    case ( TYPE_TEMPERATURE )
        if( usys%inpfg_temperature ) then
            setUnit = -1
            return           
        end if
        usys%temperature = unitid
        usys%inpfg_temperature = .true.
    case ( TYPE_VELOCITY )
        if( usys%inpfg_velocity ) then
            setUnit = -1
            return           
        end if
        usys%velocity = unitid
        usys%inpfg_velocity = .true.
    case ( TYPE_FORCE )
        if( usys%inpfg_force ) then
            setUnit = -1
            return           
        end if
        usys%force = unitid
        usys%inpfg_force = .true.
    case ( TYPE_PRESSURE )
        if( usys%inpfg_pressure ) then
            setUnit = -1
            return           
        end if
        usys%pressure = unitid
        usys%inpfg_pressure = .true.
    end select

    setUnit = 0
    return
end function setUnit

integer function updateUnits( usys )
    use m_Const_Parameters
    implicit none
    type(unitsystem), intent(inout) :: usys
    character(FMAXUNITLEN) :: unit1, unit2, unit3
    integer unitid, unittype, iret

    !!! velocity unit
    if( .not. usys%inpfg_velocity ) then
        unit1 = unit_list(usys%length)%name
        unit2 = unit_list(usys%time)%name
        unit3 = trim(unit1)//'/'//trim(unit2)
        iret = get_unit_id( unit3, unitid, unittype )
        if( iret == 0 .and. unittype == TYPE_VELOCITY ) then
            usys%velocity = unitid
        end if
    end if

    !!! force unit
    if( .not. usys%inpfg_force ) then
        unit1 = unit_list(usys%energy)%name
        unit2 = unit_list(usys%length)%name
        if( unit1 == 'j' .and. unit2 == 'm' ) then
            unit3 = 'n'
        else
            unit3 = trim(unit1)//'/'//trim(unit2)
        end if
        iret = get_unit_id( unit3, unitid, unittype )
        if( iret == 0 .and. unittype == TYPE_FORCE ) then
            usys%force = unitid
        end if
    end if

    !!! force pressure
    if( .not. usys%inpfg_pressure ) then
        unit1 = unit_list(usys%energy)%name
        unit2 = unit_list(usys%length)%name
        if( unit1 == 'j' .and. unit2 == 'm' ) then
            unit3 = 'pa'
        else
            unit3 = trim(unit1)//'/'//trim(unit2)//'3'
        end if
        iret = get_unit_id( unit3, unitid, unittype )
        if( iret == 0 .and. unittype == TYPE_PRESSURE ) then
            usys%pressure = unitid
        end if
    end if

    updateUnits = 0
    return
end function updateUnits


integer function clearUnitFlag( usys )
    use m_Const_Parameters
    implicit none
    type(unitsystem), intent(inout) :: usys

    usys%inpfg_energy = .false.
    usys%inpfg_length = .false.
    usys%inpfg_time = .false.
    usys%inpfg_mass = .false.
    usys%inpfg_angle = .false.
    usys%inpfg_temperature = .false.
    usys%inpfg_velocity = .false.
    usys%inpfg_force = .false.
    usys%inpfg_pressure = .false.

    clearUnitFlag = 0
    return
end function clearUnitFlag

integer function setDefaultUnits()
    use m_Const_Parameters
    implicit none
    integer unitid, unittype, i, iret
    integer setUnit, clearUnitFlag

    iret = clearUnitFlag( usys_file(1) )
    do i = 1, numdefaultunits
        iret = get_unit_id( defaultunits(i), unitid, unittype )
        iret = setUnit( usys_file(1), unitid, unittype )
    end do
    iret = clearUnitFlag( usys_file(1) )
    setDefaultUnits = iret
    return
end function setDefaultUnits


integer function realConvByUnit( val_f, val_r, unit_f, unit_r )
        use m_Const_Parameters
	implicit none
	real(8), intent(in)     :: val_f
	real(8), intent(out)     :: val_r
	character(*), intent(in) :: unit_f
	character(*), intent(in) :: unit_r
        real(8) wkret
	character(FMAXUNITLEN) wk_unit_f, wk_unit_r
	integer unitid_r, unittype_r, unitid_f, unittype_f, iret
        integer getUnitId

	wk_unit_f = unit_f
	wk_unit_r = unit_r
	call f_strlower( wk_unit_f )
	call f_strlower( wk_unit_r )
	!!! print '( a, "=>", a )', unit_f, wk_unit_f
	!!!print '( a, "=>", a )', unit_r, wk_unit_r
	
        if( unit_r == '' ) then
            val_r = val_f
            realConvByUnit = 0
        else
	    iret = get_unit_id( wk_unit_r, unitid_r, unittype_r ) 
 !!!debug print '( "get_unit_id,1: wk_unit_r=[", a, "] unitid_r=",I4,"unittype_r=",I4 )', wk_unit_r, unitid_r, unittype_r
            if( iret < 0 ) then
	       print '( "The unit [", a, "] in the program is not in the unit list." )', trim(unit_r)
	       realConvByUnit = -1
	       return
	    end if    
	    if( wk_unit_f == '' ) then
	        unittype_f = unittype_r
	        unitid_f = getUnitId( usys_file(fblkdepth), unittype_f )
!!!debug print '( "getUnitId,1: unitid_f=", I4, " unittype_f=",I4," fblkdepth=",I4 )', unitid_f, unittype_f, fblkdepth
 	    else
	        iret = get_unit_id( wk_unit_f, unitid_f, unittype_f )
	        if( iret < 0 ) then
		    print '( "The unit [", a, "] in the file is not in the unit list." )', trim(unit_f)
		    realConvByUnit = -1
		    return    
		else if( unittype_r /= unittype_f ) then
		    print *, "unit category mismatch"
		    realConvByUnit = -2
		    return
		end if 
	    end if
!!!debug print '( "unit_conv_byid,1: unitid_f=", I4, " unitid_r=",I4 )', unitid_f, unitid_r
            realConvByUnit = unit_conv_byid( val_f, val_r, unitid_f, unitid_r )
        end if 
	return
end function realConvByUnit

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! open and read input file
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer function f_openInputFile( fname )

	implicit none
	character(*), intent(in) :: fname
	integer openInputFile, setDefaultUnits, iret
	f_openInputFile = openInputFile( trim(fname)//char(0) )
        iret = setDefaultUnits()
	return
end function f_openInputFile

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! dealloc read buffer
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer function f_closeInputFile()

	implicit none
	integer closeInputFile

	f_closeInputFile = closeInputFile()
	return;
end function f_closeInputFile

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer function f_selectTop()
  use m_Const_Parameters, only : fblkdepth
	implicit none
	integer selectTop

	f_selectTop = selectTop()
	if( f_selectTop >= 0 ) then
	    fblkdepth = 1
	end if
	return
end function f_selectTop


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer function f_selectBlock( blocktag )
  use m_Const_Parameters
  use m_ErrorMessages
  
	implicit none
	character(*), intent(in) :: blocktag
	integer numunits, ret, i, unittype, unitid
	character(FMAXUNITLEN) :: unit
	integer selectBlock, getNumBlockUnits, getBlockUnit, setUnit, iret 
	integer clearUnitFlag, updateUnits, f_selectParentBlock 

	f_selectBlock = selectBlock( trim(blocktag)//char(0) )
	if( f_selectBlock == -1 ) then  ! eSYNTAX
            call phase_execution_error(ERROR_IN_INPUTFILE_OPENING)
        else if( f_selectBlock == -9 ) then  ! eBIGTABLE
            call phase_execution_error(ERROR_IN_INPUTFILE_OPENING)
	end if
	if( f_selectBlock /= 0 ) then
	    return
	end if

        fblkdepth = fblkdepth + 1
        usys_file(fblkdepth) = usys_file(fblkdepth-1)
        f_selectBlock = clearUnitFlag( usys_file(fblkdepth) ) 
	f_selectBlock = getNumBlockUnits( numunits )
	do i = 0, numunits-1
	    iret = getBlockUnit( unit, i )
            iret = get_unit_id( unit, unitid, unittype )
	    if( iret < 0 ) then
	        f_selectBlock  = iret
                iret = f_selectParentBlock()
                print '( "The unit [", a, "] in the block [", a, "]is not found in the unit list.")', trim(unit), trim(blocktag)
 		return
	    end if
	    iret = setUnit( usys_file(fblkdepth), unitid, unittype )
	    if( iret < 0 ) then
	        f_selectBlock  = iret
                iret = f_selectParentBlock()
                print '( "A unit with the same dimension as [", a, "] has been already given in the block [", a, "]." )'&
              & , trim(unit), trim(blocktag)
 		return
	    end if
	end do
        iret = updateUnits( usys_file(fblkdepth) )
	return
end function f_selectBlock

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer function f_selectParentBlock()
  use m_Const_Parameters, only : fblkdepth
	implicit none
	integer selectParentBlock

	f_selectParentBlock = selectParentBlock()
	if( f_selectParentBlock /= 0 ) then
	    return
	end if
        fblkdepth = fblkdepth - 1
	return;
end function f_selectParentBlock

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  get integer value at tag
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer function f_getIntValue( tag, ret )

	implicit none
	character(*), intent(in) :: tag
	integer, intent(out)     :: ret
	integer getIntValue

	f_getIntValue = getIntValue( trim(tag)//char(0), ret )
	return
end function f_getIntValue

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  get integer vector value at tag
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer function f_getIntVectorValue( tag, ret )

	implicit none
	character(*), intent(in) :: tag
	integer, dimension(:), intent(out)     :: ret
	integer getIntVectorValue

	f_getIntVectorValue = getIntVectorValue( trim(tag)//char(0), ret )
	return
end function f_getIntVectorValue

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  get real value at tag
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer function f_getRealValue( tag, ret, unit_r )
  use m_Const_Parameters
	implicit none
	character(*), intent(in) :: tag
	real(8), intent(out)     :: ret
	character(*), intent(in) :: unit_r
        real(8) wkret
	character(FMAXUNITLEN) unit_f
	integer getRealValue, realConvByUnit, iret_unit, iret_val

        unit_f = ''
	iret_val = getRealValue( trim(tag)//char(0), wkret, unit_f )
        if( iret_val /= 0 ) then
           f_getRealValue = iret_val
           return
        end if

  	iret_unit = realConvByUnit( wkret, ret, unit_f, unit_r )
        f_getRealValue = iret_unit !!!iret_val

	return
end function f_getRealValue

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! get real vector value at tag
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer function f_getRealVectorValue( tag, ret, unit_r )
  use m_Const_Parameters
	implicit none
	character(*), intent(in)           :: tag
	real(8), dimension(:), intent(out) :: ret
	character(*), intent(in) :: unit_r
        real(8), dimension(3) :: wkret
	character(FMAXUNITLEN) unit_f
	integer i
	integer getRealVectorValue, realConvByUnit, iret_unit, iret_val

	iret_val = getRealVectorValue( trim(tag)//char(0), wkret, unit_f )
        if( iret_val /= 0 ) then
           f_getRealVectorValue = iret_val
            return
        end if

	do i = 1, 3
            iret_unit = realConvByUnit( wkret(i), ret(i), unit_f, unit_r )
	    if( iret_unit < 0 ) then
                f_getRealVectorValue = iret_unit
       	        return;
	    end if 
	end do
        f_getRealVectorValue = iret_val
	return
end function f_getRealVectorValue

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! get string value at tag
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer function f_getStringValue( tag, ret, convfg )

	implicit none
	character(*), intent(in)  :: tag
	character(*), intent(out) :: ret
	integer, intent(in)  :: convfg
	integer getStringValue

	!!ret = "\0"
	f_getStringValue = getStringValue( trim(tag)//char(0), ret, convfg )

	!! print *,"in f_getStringValue ret=", ret
	return
end function f_getStringValue

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! seek the first line of a table
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer function f_selectFirstTableLine()

	implicit none
	integer selectFirstTableLine

	f_selectFirstTableLine = selectFirstTableLine()
	return
end function f_selectFirstTableLine

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! seek the next line in a table
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer function f_selectNextTableLine()

	implicit none
	integer selectNextTableLine

	f_selectNextTableLine = selectNextTableLine()
	return
end function f_selectNextTableLine

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! intelligent reading of unit cell
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$integer function f_readUnitCell(avec,bvec,cvec,a,b,c,alpha,beta,gamma,unit &
!!$     & , tag_avector,tag_bvector,tag_cvector,tag_a,tag_b,tag_c,tag_alpha,tag_beta,tag_gamma)
integer function f_readUnitCell(avec,bvec,cvec,a,b,c,ca,cb,cc,ucinptype,unit &
     & , tag_avector,tag_bvector,tag_cvector,tag_a,tag_b,tag_c,tag_alpha,tag_beta,tag_gamma,scale,is_hex,printable)
  use m_Const_Parameters, only : DP, FMAXUNITLEN,PAI

	implicit none
	real(DP), dimension(3), intent(inout) :: avec
	real(DP), dimension(3), intent(out) :: bvec
	real(DP), dimension(3), intent(out) :: cvec
	real(DP), intent(out) :: a, b, c
	real(DP), intent(out) :: ca, cb, cc
        integer, intent(out) :: ucinptype
        character(*), intent(in) :: unit
        character(*), intent(in) :: tag_avector,tag_bvector,tag_cvector
        character(*), intent(in) :: tag_a,tag_b,tag_c,tag_alpha,tag_beta,tag_gamma
        real(DP), intent(in) :: scale
        logical, intent(in) :: is_hex, printable

        character(FMAXUNITLEN) :: readunit
	real(DP) :: s, al, be, ga, sin_be, sin_ga, wk, wkbuf, alpha, beta,gamma
	real(DP), dimension(3) :: wvec
	integer getRealVectorValue, realConvByUnit
	integer getRealValue
	integer i

	f_readUnitCell = -1
	if( getRealVectorValue( trim(TAG_AVECTOR)//char(0), wvec, readunit ) == 0 ) then
!!$           if(printable) then
!!$              write(6,'("  wvec(i), avec(i) = ",2f8.4)') wvec(i),avec(i)
!!$              write(6,'(" !! readunit = ",a16, " unit = ",a16)') readunit,unit
!!$           end if
		do i = 1, 3
		    if( realConvByUnit( wvec(i), avec(i), readunit, unit ) < 0 ) then
       		        return;
		    end if
!!$                    if(printable) write(6,'("  wvec(i), avec(i) = ",2f8.4)') wvec(i),avec(i)
		end do
		if( getRealVectorValue( trim(TAG_BVECTOR)//char(0), wvec, readunit ) /= 0 ) then
   		!    return;
                    wvec = 0.d0;wvec(2) = avec(1)
		end if
		do i = 1, 3
		    if( realConvByUnit( wvec(i), bvec(i), readunit, unit ) < 0 ) then
       		        return;
		    end if 
		end do
		if( getRealVectorValue( trim(TAG_CVECTOR)//char(0), wvec, readunit ) /= 0 ) then
   		    !return;
                    wvec = 0.d0;wvec(3) = avec(1)
		end if
		do i = 1, 3
		    if( realConvByUnit( wvec(i), cvec(i), readunit, unit ) < 0 ) then
       		        return;
		    end if 
		end do
                avec = avec*scale
                bvec = bvec*scale
                cvec = cvec*scale

		a = sqrt( sum(avec(:)*avec(:)) )
		b = sqrt( sum(bvec(:)*bvec(:)) )
		c = sqrt( sum(cvec(:)*cvec(:)) )
!!$		alpha = acos( dot_product(bvec,cvec)/(b*c) )*180.d0/PAI
!!$		beta = acos( dot_product(cvec,avec)/(c*a) )*180.d0/PAI
!!$		gamma = acos( dot_product(avec,bvec)/(a*b) )*180.d0/PAI
		ca =  dot_product(bvec,cvec)/(b*c)
		cb =  dot_product(cvec,avec)/(c*a)
		cc =  dot_product(avec,bvec)/(a*b)
                ucinptype = 1
	else if( getRealValue( trim(TAG_A)//char(0), wk, readunit ) == 0 ) then
!!$                if(printable) write(6,'(" !!! readunit = ",a15)') trim(readunit)
                wkbuf = wk
	 	if( realConvByUnit( wk, a, readunit, unit ) < 0 ) then
   		    return;
		end if

		if( getRealValue( trim(TAG_B)//char(0), wk, readunit ) /= 0 ) then
		    !return;
                    wk = wkbuf
		end if
	 	if( realConvByUnit( wk, b, readunit, unit ) < 0 ) then
   		    return;
		end if

		if( getRealValue( trim(TAG_C)//char(0), wk, readunit ) /= 0 ) then
		    !return;
                    wk = wkbuf
		end if
	 	if( realConvByUnit( wk, c, readunit, unit ) < 0 ) then
   		    return;
		end if

		if( getRealValue( trim(TAG_ALPHA)//char(0), wk, readunit ) /= 0 ) then
		    !return;
                    wk = 90.d0
		end if
		alpha = wk
	 	! if( realConvByUnit( wk, alpha, readunit, unit ) < 0 ) then
   		!     return;
		! end if

		if( getRealValue( trim(TAG_BETA)//char(0), wk, readunit ) /= 0 ) then
		    !return;
                    wk = 90.d0
		end if
		beta = wk
	 	! if( realConvByUnit( wk, beta, readunit, unit ) < 0 ) then
   		!     return;
		! end if

		if( getRealValue( trim(TAG_GAMMA)//char(0), wk, readunit ) /= 0 ) then
		    !return;
                    if(.not. is_hex) then
                        wk =  90.d0
                    else
                        wk = 120.d0
                    endif
		end if
		gamma = wk
	 	! if( realConvByUnit( wk, gamma, readunit, unit ) < 0 ) then
   		!    return;
		! end if
                a  = a*scale
                b  = b*scale
                c  = c*scale
		al = alpha*PAI/180.d0
		be = beta*PAI/180.d0
		ga = gamma*PAI/180.d0
!!$		sin_al = sin(al)
		ca = cos(al)
		sin_be = sin(be)
		cb = cos(be)
		sin_ga = sin(ga)
		cc = cos(ga)
		s = (cc*cb-ca)/sin_ga/cb
		avec(1) = a
		avec(2) = 0.d0
		avec(3) = 0.d0
		bvec(1) = b*cc
		bvec(2) = b*sin_ga
		bvec(3) = 0.d0
		cvec(1) = c*cb
!!$		cvec(2) = c*abs(s)*cb
		cvec(2) = -c*s*cb
		cvec(3) = c*sqrt(sin_be*sin_be-s*s*cb*cb)
                ucinptype = 0
	else
                ucinptype = -1
		return
	end if
	
	f_readUnitCell = 0
	return
end function f_readUnitCell


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! intelligent reading of Symmetry Generator
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! integer function f_readSymmetryGenerator(sys,op,tvec)  ! old version 
integer function f_readSymmetryGenerator(sys,op,txu,txd,tyu,tyd,tzu,tzd,tag_rotation,tag_tx,tag_ty,tag_tz,printable)
  use m_Const_Parameters, only : DP, FMAXVALLEN, num_d6h, num_oh, d6h_symbol, oh_symbol, LOWER, NOCONV

	implicit none

	integer, intent(in) :: sys
	integer, intent(out) :: op
	!!! real(8), dimension(3), intent(out) :: tvec  ! old version
        integer, intent(out) :: txu, txd, tyu, tyd, tzu, tzd
        character(*),intent(in) :: tag_rotation,tag_tx,tag_ty,tag_tz
        logical, intent(in) :: printable
	integer getIntValue, getStringValue, frac2intint            !!!frac2real
	character(FMAXVALLEN) opstr, tstr
	integer i, iret

	if( getIntValue( trim(TAG_ROTATION)//char(0), iret ) == 0 ) then
	    if( sys <= 0 .and. (iret <=0 .or. iret > num_d6h) ) then
                print '("In f_readSymmetryGenerator: op =",I4," (1 < op <  ",i2,")" )', iret,num_d6h
	        f_readSymmetryGenerator = -1
		return
	    else if( sys > 0 .and. (iret <=0 .or. iret > num_oh) ) then
                print '("In f_readSymmetryGenerator: op =",I4," (1 < op <  ",i2,")" )', iret,num_oh
	        f_readSymmetryGenerator = -1
		return
	    end if
	    op = iret
	else
	f_readSymmetryGenerator = getStringValue( trim(TAG_ROTATION)//char(0), opstr, LOWER )
	if( f_readSymmetryGenerator /= 0 ) then
		return
	end if
	if( sys <= 0 ) then	! for rhombo, hexagonal  !!! should be checked
		do i = 1, num_d6h
			if( opstr == d6h_symbol(i) ) then
				exit
			end if
		end do
		op = i
                if(op > num_d6h) goto 1001
	else
		do i = 1, num_oh
			if( opstr == oh_symbol(i) ) then
				exit
			end if
		end do
		op = i
                if(op > num_oh) goto 1001
	end if
	endif
	f_readSymmetryGenerator = getStringValue( trim(TAG_TX)//char(0), tstr, NOCONV  )
	if( f_readSymmetryGenerator /= 0 ) then
		return
	end if
	!!! f_readSymmetryGenerator = frac2real( trim(tstr)//char(0), tvec(1) )    ! old version
	f_readSymmetryGenerator = frac2intint( trim(tstr)//char(0), txu, txd )
	if( f_readSymmetryGenerator /= 0 ) then
		return
	end if
	f_readSymmetryGenerator = getStringValue( trim(TAG_TY)//char(0), tstr, NOCONV )
	if( f_readSymmetryGenerator /= 0 ) then
		return
	end if
	!!! f_readSymmetryGenerator = frac2real( trim(tstr)//char(0), tvec(2) )     ! old version
	f_readSymmetryGenerator = frac2intint( trim(tstr)//char(0), tyu, tyd )
	if( f_readSymmetryGenerator /= 0 ) then
		return
	end if
	f_readSymmetryGenerator = getStringValue( trim(TAG_TZ)//char(0), tstr, NOCONV )
	if( f_readSymmetryGenerator /= 0 ) then
		return
	end if
	!!! f_readSymmetryGenerator = frac2real( trim(tstr)//char(0), tvec(3) )     ! old version
	f_readSymmetryGenerator = frac2intint( trim(tstr)//char(0), tzu, tzd )
	if( f_readSymmetryGenerator /= 0 ) then
		return
	end if
	return
1001    continue
        if(printable) then
           write(6,'(" !** illegal operator = [ ",a4,"]")') opstr
           if(sys <= 0) then
              write(6,'(" !** op = ",i6," > num_d6h = ",i6)') op,num_d6h
           else
              write(6,'(" !** op = ",i6," > num_oh = ",i6)') op,num_oh
           end if
        end if
        call phase_error_with_msg(6, ' !* illegal operation generator <f_readSymmetryGenerator>',__LINE__,__FILE__)

end function f_readSymmetryGenerator

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! intelligent reading of Symmetry Generator
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer function f_readTranslationVectors(sys,txu,txd,tyu,tyd,tzu,tzd,tag_tx,tag_ty,tag_tz,printable)
  use m_Const_Parameters, only : DP, FMAXVALLEN, num_d6h, num_oh, d6h_symbol, oh_symbol, LOWER, NOCONV

	implicit none

	integer, intent(in) :: sys
	!!! real(8), dimension(3), intent(out) :: tvec  ! old version
        integer, intent(out) :: txu, txd, tyu, tyd, tzu, tzd
        character(*),intent(in) :: tag_tx,tag_ty,tag_tz
        logical, intent(in) :: printable
	integer getStringValue, frac2intint            !!!frac2real
	character(FMAXVALLEN) tstr
	integer i, iret

	f_readTranslationVectors = getStringValue( trim(TAG_TX)//char(0), tstr, NOCONV  )
	if( f_readTranslationVectors /= 0 ) then
		return
	end if

	f_readTranslationVectors = frac2intint( trim(tstr)//char(0), txu, txd )
	if( f_readTranslationVectors /= 0 ) then
		return
	end if
	f_readTranslationVectors = getStringValue( trim(TAG_TY)//char(0), tstr, NOCONV )
	if( f_readTranslationVectors /= 0 ) then
		return
	end if

	f_readTranslationVectors = frac2intint( trim(tstr)//char(0), tyu, tyd )
	if( f_readTranslationVectors /= 0 ) then
		return
	end if
	f_readTranslationVectors = getStringValue( trim(TAG_TZ)//char(0), tstr, NOCONV )
	if( f_readTranslationVectors /= 0 ) then
		return
	end if

	f_readTranslationVectors = frac2intint( trim(tstr)//char(0), tzu, tzd )
	if( f_readTranslationVectors /= 0 ) then
		return
	end if
	return
1001    continue
!!$        if(printable) then
!!$        end if
        call phase_error_with_msg(6, ' !* illegal operation generator <f_readSymmetryGenerator>',__LINE__,__FILE__)

end function f_readTranslationVectors
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! intelligent reading of K-Point Coordinates
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer function f_readKPoints(tag_kx,tag_ky,tag_kz,tag_k_denom,tag_k_weight &
     &                        ,kvec,weight)

  use m_Const_Parameters, only : DP,FMAXUNITLEN

	implicit none
        character(*), intent(in) :: tag_kx, tag_ky, tag_kz, tag_k_denom, tag_k_weight
	real(DP), dimension(3), intent(out) :: kvec
	integer, intent(out) :: weight
!	integer getIntValue, i, wk
	integer getIntValue,getRealValue, i
        real(DP) wk
	real(DP) a
	character(FMAXUNITLEN) unit_f

        weight = 0

        unit_f = ''
	!f_readKPoints = getIntValue(trim(TAG_KX)//char(0),wk)
	f_readKPoints = getRealValue(trim(TAG_KX)//char(0),wk,unit_f)
        kvec(1) = wk
	if( f_readKPoints /= 0 ) then
		return
	end if 
	f_readKPoints = getRealValue(trim(TAG_KY)//char(0),wk,unit_f)
        kvec(2) = wk
	if( f_readKPoints /= 0 ) then
		return
	end if 
	f_readKPoints = getRealValue(trim(TAG_KZ)//char(0),wk,unit_f)
        kvec(3) = wk
	if( f_readKPoints /= 0 ) then
		return
	end if 
	f_readKPoints = getRealValue(trim(TAG_K_DENOM)//char(0),wk,unit_f)
        a = wk
	if( f_readKPoints /= 0 ) then
		return
	end if

	kvec(:) = kvec(:)/a 

	f_readKPoints = getIntValue(trim(TAG_K_WEIGHT)//char(0),weight)
	if( f_readKPoints /= 0 ) then
		return
	end if 
	return

end function f_readKPoints

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  convert to lower case string
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine f_strlower( str )
    implicit none
    character(*), intent(inout) :: str
    integer i, slen

    slen = len_trim(str)
    do i = 1, slen
        if( str(i:i) >= 'A' .and. str(i:i) <= 'Z' ) then
	    str(i:i) = achar( iachar(str(i:i)) - iachar('A') + iachar('a') )
        end if
    end do

end subroutine f_strlower


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  check s1 == s2
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
logical function fstreq( s1, s2 )
    implicit none
    character(*), intent(in) :: s1
    character(*), intent(in) :: s2
    integer len1, len2, i

    len1 = len_trim(s1)
    len2 = len_trim(s2)
   !! print '("len1=",i8,"s1=[",a,"]")', len1, s1
   !! print '("len2=",i8,"s2=[",a,"]")', len2, s2
    if( len1 /= len2 ) then
        fstreq = .false.
        return
    end if

    do i = 1, len1
        if( s1(i:i) /= s2(i:i) ) then
            fstreq = .false.
            return
        end if       
    end do	
    fstreq = .true.
    return
end function fstreq

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! intelligent reading of antiferro tau vector
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer function f_readAfTauVec(tvec,unit,tag_tvec)
  use m_Const_Parameters, only : DP, FMAXUNITLEN

	implicit none
	real(DP), dimension(3), intent(inout) :: tvec
        character(*), intent(in) :: unit
        character(*), intent(in) :: tag_tvec
        character(FMAXUNITLEN) :: readunit
	real(DP), dimension(3) :: wvec
!	integer getRealVectorValue, realConvByUnit
        integer getRealVectorValue, realConvByUnit
!	integer getRealValue
	integer i
!interface 
!	integer function getRealVectorValue(ttag,rret,unit)
!	!DEC$ ATTRIBUTES C, ALIAS: '_getrealvectorvalue' :: getRealVectorValue
!	!DEC$ ATTRIBUTES REFERENCE :: ttag
!	!DEC$ ATTRIBUTES REFERENCE :: rret
!	!DEC$ ATTRIBUTES REFERENCE :: unit
!	character*(*):: ttag
!	real(8):: rret(3)
!	character*(*):: unit	
!	end function getRealVectorValue
!end interface
!interface 
!	integer function getRealValue(ttag,rret,unit)
!	!DEC$ ATTRIBUTES C, ALIAS: '_getrealvalue' :: getRealValue
!	!DEC$ ATTRIBUTES REFERENCE :: ttag
!	!DEC$ ATTRIBUTES REFERENCE :: rret
!	!DEC$ ATTRIBUTES REFERENCE :: unit
!	character*(*):: ttag
!	real(8):: rret
!	character*(*):: unit	
!	end function getRealValue
!end interface

	f_readAfTauVec = -1
	if( getRealVectorValue( trim(tag_tvec)//char(0), wvec, readunit ) == 0 ) then
!           write(6,'("  wvec(i), avec(i) = ",2f8.4)') wvec(i),avec(i)
           write(6,'(" !! readunit = ",a16, " unit = ",a16)') readunit,unit
		do i = 1, 3
		    if( realConvByUnit( wvec(i), tvec(i), readunit, unit ) < 0 ) then
       		        return;
		    end if
                    write(6,'("  wvec(i), tvec(i) = ",2f8.4)') wvec(i),tvec(i)
		end do
	else
		return
	end if
	
	f_readAfTauVec = 0
	return
end function f_readAfTauVec

integer function f_check_input_duplicated_tag( )
  ! Coded by T. Yamasaki, May/23/2023
  integer check_input_duplicated_tag
  integer :: i
  i = check_input_duplicated_tag()
  f_check_input_duplicated_tag = i
  return
end function f_check_input_duplicated_tag

subroutine f_cp_duplicated_block_name(block_name)
  ! Coded by T. Yamasaki, May/23/2023
  use m_Const_Parameters,   only : FMAXTAGLEN
  character(len=FMAXTAGLEN),intent(out) :: block_name
  integer ::i
  call cp_duplicated_block_name(block_name)
  do i = 1, FMAXTAGLEN
     if(ichar(block_name(i:i))==0) block_name(i:i) = " "
  end do
  len_name = len_trim(block_name)
  
end subroutine f_cp_duplicated_block_name

!!$end module input_interface

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  MODULE: m_FFT
!
!  AUTHOR(S): T. Yamasaki, K. Betsuyaku,   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!                                   , March/14/2005, April/10/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!

  ! ---------------------
  integer(8) :: plan_WF(2),plan_CD(2)

  integer(8) :: plan_CD_exx(2)

  ! ------- Positron start 
  integer(8) :: plan_pWF(2)
  ! ------- Positron end

! ======= KT_add ============================== 13.0F
  integer(8) :: plan_exx(2)
! ============================================= 13.0F

  integer :: sw_avoiding_odd_fftbox = OFF
  integer :: sw_zero_padding = OFF

!  include 'mpif.h'
  integer, parameter :: FFTW_MEASURE=0
contains
  subroutine m_FFT_alloc_WF_work
  end subroutine m_FFT_alloc_WF_work

  subroutine m_FFT_alloc_pWF_work()
  end subroutine m_FFT_alloc_pWF_work

  subroutine m_FFT_dealloc_WF_work
  end subroutine m_FFT_dealloc_WF_work

! ======= KT_add ============================= 13.0F
  subroutine m_FFT_alloc_exx_work
  end subroutine m_FFT_alloc_exx_work

  subroutine m_FFT_dealloc_exx_work
  end subroutine m_FFT_dealloc_exx_work
! =========================================== 13.0F

  subroutine m_FFT_alloc_CD_box
    integer :: istat
    if(sw_mpifft == OFF) then
       allocate(afft_CD(nfftp), stat=istat)
    end if
  end subroutine m_FFT_alloc_CD_box

  subroutine m_FFT_dealloc_CD_box
    integer :: istat
    if(sw_mpifft == OFF) then
       deallocate(afft_CD)
    end if
  end subroutine m_FFT_dealloc_CD_box

  subroutine m_FFT_finalize()
    call dfftw_destroy_plan(plan_WF(1))    
    call dfftw_destroy_plan(plan_WF(2))    
!    call dfftw_destroy_plan(plan_CD(1))    
!    call dfftw_destroy_plan(plan_CD(2))    
    if(sw_positron/=OFF)then
       call dfftw_destroy_plan(plan_pWF(1))
       call dfftw_destroy_plan(plan_pWF(2))
    endif

!    call dfftw_cleanup()
  end subroutine m_FFT_finalize

  subroutine m_FFT_setup(inversion_symmetry,paramset)
    integer, intent(in) :: inversion_symmetry
    logical, intent(in) :: paramset

    real(kind=DP), allocatable, dimension(:)          :: ftw

    integer :: istat = 0
    integer :: nfft_t, ipad
    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_setup ',id_sname)

    if(inversion_symmetry == ON) then  ! kimg == 1
       ipad = 2
    else if(inversion_symmetry == OFF) then ! kimg == 2
       ipad = 0
    end if
! --- fft_box_size_WF, fft_box_size_pWF ---
    fft_box_size_WF(1,0) = fft_box_size_WF(1,1) + ipad
    fft_box_size_WF(2:3,0) = fft_box_size_WF(2:3,1)
    if(sw_positron /= OFF) then
       fft_box_size_pWF(1,0)   = fft_box_size_pWF(1,1) + ipad
       fft_box_size_pWF(2:3,0) = fft_box_size_pWF(2:3,1)
    end if

    nfft =   product(fft_box_size_WF(1:3,0)) * (2-inversion_symmetry)
! --- fft_box_size_CD ---
    fft_box_size_CD_nonpara(1,0)   = fft_box_size_CD(1,1) + ipad
    fft_box_size_CD_nonpara(2:3,0) = fft_box_size_CD(2:3,1)
    nfftp_nonpara  = product(fft_box_size_CD_nonpara(1:3,0)) * (2-inversion_symmetry)

    if(sw_mpifft == ON) then
       if(ipri >= 1) write(nfout,*) '!FFT_CD = MPIFFT <<m_FFT_setup>>'
       call set_mpifft_box_size_CD(inversion_symmetry) ! -> fft_box_size_CD, fft_box_size_CD_c, ny_d, nz_d, etc.
       nfftp  = product(fft_box_size_CD_c(1:3,0)) * (2-inversion_symmetry)

!$$!!#ifdef PARA3D
       fft_box_size_CD_3D(:,1) = fft_box_size_CD(:,1)
       fft_box_size_CD_3D(:,0) = fft_box_size_CD_nonpara(:,0)
       nfftps = product(fft_box_size_CD_3D(1:3,0)) * (2-inversion_symmetry)
!$$!!#endif

    else
       fft_box_size_CD(1:3,0) = fft_box_size_CD_nonpara(1:3,0)
       fft_box_size_CD_c(1:3,0) = fft_box_size_CD(1:3,0)
       nfftp  = product(fft_box_size_CD(1:3,0)) * (2-inversion_symmetry)
       nfftps = nfftp
    end if

    if(ipri >= 1) call wd_FFTboxsizes(nfout)

    if(sw_positron /= OFF) &
         & nfft_pstrn = product(fft_box_size_pWF(1:3,0))*(2-inversion_symmetry)

    if(.not. paramset) then
! Initialization of the Wave-Function FFT
       nfft_t = nfft
       if(sw_positron /= OFF .and. nfft_t < nfft_pstrn) nfft_t = nfft_pstrn
       allocate(ftw(nfft_t), stat=istat) ! ftw is used only for initiallization
       if(istat /= 0) then
          if(ipri >= 1) then
             write(nfout,*) 'Allocation error for ftw in sub. m_FFT_setup'
             write(nfout,*) 'stat =', istat, 'nfft =', nfft
          end if
          stop
       end if

       call init_fft_coefficients_arrays_WF()

       deallocate(ftw,stat=istat)
       if(istat /= 0 ) then
          if(ipri >= 1) then
             write(nfout,*) 'Deallocation error for ftw in sub. m_FFT_setup'
             write(nfout,*) 'stat =', istat
          end if
          stop
       end if
!!$#ifndef _MPIFFT_
       if(sw_mpifft == OFF) then
! Initialization of the Charge-Density FFT
          call CDFFT_setup()
!!$#endif
       end if
    end if

    call tstatc0_end(id_sname)
  contains
    subroutine init_fft_coefficients_arrays_WF()
      integer :: nl, nm, nn
      integer :: nl_p, nm_p, nn_p
      nl = fft_box_size_WF(1,1)
      nm = fft_box_size_WF(2,1)
      nn = fft_box_size_WF(3,1)
      if(sw_positron /= OFF) then
         nl_p = fft_box_size_pWF(1,1)
         nm_p = fft_box_size_pWF(2,1)
         nn_p = fft_box_size_pWF(3,1)
      end if

      if(kimg == 1) then
         ! Forward FFT
         call dfftw_plan_dft_c2r_3d(plan_WF(1) &
       &                       ,nl,nm,nn &
       &                       ,ftw(1),ftw(1) &
       &                       ,FFTW_MEASURE)
         ! Inverse FFT
         call dfftw_plan_dft_r2c_3d(plan_WF(2) &
       &                       ,nl,nm,nn &
       &                       ,ftw(1),ftw(1) &
       &                       ,FFTW_MEASURE)
         if(sw_positron /= OFF) then
            ! Forward FFT
            call dfftw_plan_dft_c2r_3d(plan_pWF(1) &
       &                       ,nl_p,nm_p,nn_p &
       &                       ,ftw(1),ftw(1) &
       &                       ,FFTW_MEASURE)
            ! Inverse FFT
            call dfftw_plan_dft_r2c_3d(plan_pWF(2) &
       &                       ,nl_p,nm_p,nn_p &
       &                       ,ftw(1),ftw(1) &
       &                       ,FFTW_MEASURE)
         end if
      else
         ! Forward FFT
         call dfftw_plan_dft_3d(plan_WF(1),nl,nm,nn &
     &                         ,ftw(1),ftw(1) &
     &                         ,-1,FFTW_MEASURE)
         ! Inverse FFT
         call dfftw_plan_dft_3d(plan_WF(2),nl,nm,nn &
     &                         ,ftw(1),ftw(1) &
     &                         ,+1,FFTW_MEASURE)
         if(sw_positron /= OFF) then
            ! Forward FFT
            call dfftw_plan_dft_3d(plan_pWF(1),nl_p,nm_p,nn_p &
     &                         ,ftw(1),ftw(1) &
     &                         ,-1,FFTW_MEASURE)
            ! Inverse FFT
            call dfftw_plan_dft_3d(plan_pWF(2),nl_p,nm_p,nn_p &
     &                         ,ftw(1),ftw(1) &
     &                         ,+1,FFTW_MEASURE)
         end if
      end if
      if(ipri >= 1) then
         write(nfout,'(" !(init_fft_coef_WF) nl, nm, nn   = ",3i8)') nl, nm, nn
         write(nfout,'(" !(init_fft_coef_WF) plan_WF(1:2) = ",2i20)') plan_WF(1:2)
      end if
    end subroutine init_fft_coefficients_arrays_WF


  end subroutine m_FFT_setup

! ======= KT_add =========================================== 13.0F
  subroutine m_FFT_setup_exx(inversion_symmetry,paramset)
    integer, intent(in) :: inversion_symmetry
    logical, intent(in) :: paramset

    real(kind=DP), allocatable, dimension(:)          :: ftw

    integer :: istat = 0
    integer :: nfft_t, ipad

    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_setup_exx ',id_sname)

    if(inversion_symmetry == ON) then  ! kimg == 1
       ipad = 2
    else if(inversion_symmetry == OFF) then ! kimg == 2
       ipad = 0
    end if

    fft_box_size_exx(1,0)   = fft_box_size_exx(1,1) + ipad
    fft_box_size_exx(2:3,0) = fft_box_size_exx(2:3,1)

    nfft_exx = product(fft_box_size_exx(1:3,0)) * (2-inversion_symmetry)

    if(ipri >= 1) call wd_FFTboxsizes_exx(nfout)

    if(.not. paramset) then
! Initialization of the Wave-Function FFT
       nfft_t = nfft_exx

       allocate(ftw(nfft_t), stat=istat) ! ftw is used only for initiallization
       if(istat /= 0) then
          if(ipri >= 1) then
             write(nfout,*) 'Allocation error for ftw in sub. m_FFT_setup_exx'
             write(nfout,*) 'stat =', istat, 'nfft_exx =', nfft_exx
          end if
          stop
       end if

       call init_fft_coefficients_arrays_WF()

       deallocate(ftw,stat=istat)
       if(istat /= 0 ) then
          if(ipri >= 1) then
             write(nfout,*) 'Deallocation error for ftw in sub. m_FFT_setup_exx'
             write(nfout,*) 'stat =', istat
          end if
          stop
       end if
    end if

    call tstatc0_end(id_sname)

  contains

    subroutine init_fft_coefficients_arrays_WF()
      integer :: nl_exx, nm_exx, nn_exx

      nl_exx = fft_box_size_exx(1,1)
      nm_exx = fft_box_size_exx(2,1)
      nn_exx = fft_box_size_exx(3,1)

      if(kimg == 1) then
         ! Forward FFT
         call dfftw_plan_dft_c2r_3d( plan_exx(1),nl_exx,nm_exx, nn_exx &
              &                     ,ftw(1),ftw(1) &
              &                     ,FFTW_MEASURE)
         ! Inverse FFT
         call dfftw_plan_dft_r2c_3d( plan_exx(2),nl_exx, nm_exx,nn_exx &
              &                     ,ftw(1),ftw(1) &
              &                     ,FFTW_MEASURE)
      else
         ! Forward FFT
         call dfftw_plan_dft_3d( plan_exx(1),nl_exx,nm_exx, nn_exx &
              &                         ,ftw(1),ftw(1) &
              &                         ,-1,FFTW_MEASURE)
         ! Inverse FFT
         call dfftw_plan_dft_3d( plan_exx(2),nl_exx, nm_exx,nn_exx &
              &                         ,ftw(1),ftw(1) &
              &                         ,+1,FFTW_MEASURE)
      end if

      if(ipri >= 1) then
         write(nfout,'(" !(init_fft_coef_exx) nl_exx, nm_exx, nn_exx   = ",3i8)') &
              &              nl_exx, nm_exx, nn_exx
         write(nfout,'(" !(init_fft_coef_exx) plan_exx(1:2) = ",2i20)') &
              &             plan_exx(1:2)
      end if
    end subroutine init_fft_coefficients_arrays_WF

  end subroutine m_FFT_setup_exx
! ======================================================== 13.0F

  subroutine CDFFT_setup_exx()
    allocate(afft_CD_exx(nfftp_exx_nonpara))
    call init_fft_coefficients_arrays_CDx()
    CD_setup_is_done_exx = YES
    deallocate(afft_CD_exx)
  contains
    subroutine init_fft_coefficients_arrays_CDx
      integer :: nl, nm, nn

   !  ---> FFT for Charge density
      nl = fft_box_size_CD_exx(1,1)
      nm = fft_box_size_CD_exx(2,1)
      nn = fft_box_size_CD_exx(3,1)
      if(kimg == 1) then
         ! Forward FFT
         call dfftw_plan_dft_c2r_3d(plan_CD_exx(1) &
       &                       ,nl,nm,nn &
       &                       ,afft_CD_exx(1),afft_CD_exx(1) &
       &                       ,FFTW_MEASURE)
         ! Inverse FFT
         call dfftw_plan_dft_r2c_3d(plan_CD_exx(2) &
       &                       ,nl,nm,nn &
       &                       ,afft_CD_exx(1),afft_CD_exx(1) &
       &                       ,FFTW_MEASURE)
      else
         ! Forward FFT
         call dfftw_plan_dft_3d(plan_CD_exx(1),nl,nm,nn &
     &                         ,afft_CD_exx(1),afft_CD_exx(1) &
     &                         ,-1,FFTW_MEASURE)
         ! Inverse FFT
         call dfftw_plan_dft_3d(plan_CD_exx(2),nl,nm,nn &
     &                         ,afft_CD_exx(1),afft_CD_exx(1) &
     &                         ,+1,FFTW_MEASURE)
      end if
      if(ipri >= 1) then
         write(nfout,'(" !(CDFFT_setup_exx) nl, nm, nn   = ",3i8)') nl, nm, nn
         write(nfout,'(" !(CDFFT_setup_exx) plan_CD_exx(1:2) = ",2i20)') plan_CD_exx(1:2)
      end if
    end subroutine init_fft_coefficients_arrays_CDx
  end subroutine CDFFT_setup_exx

  subroutine CDFFT_setup()
    allocate(afft_CD(nfftp_nonpara))
    call init_fft_coefficients_arrays_CD()
    CD_setup_is_done = YES
    deallocate(afft_CD)
  contains
    subroutine init_fft_coefficients_arrays_CD
      integer :: nl, nm, nn

   !  ---> FFT for Charge density
      nl = fft_box_size_CD(1,1)
      nm = fft_box_size_CD(2,1)
      nn = fft_box_size_CD(3,1)
      if(kimg == 1) then
         ! Forward FFT
         call dfftw_plan_dft_c2r_3d(plan_CD(1) &
       &                       ,nl,nm,nn &
       &                       ,afft_CD(1),afft_CD(1) &
       &                       ,FFTW_MEASURE)
         ! Inverse FFT
         call dfftw_plan_dft_r2c_3d(plan_CD(2) &
       &                       ,nl,nm,nn &
       &                       ,afft_CD(1),afft_CD(1) &
       &                       ,FFTW_MEASURE)
      else
         ! Forward FFT
         call dfftw_plan_dft_3d(plan_CD(1),nl,nm,nn &
     &                         ,afft_CD(1),afft_CD(1) &
     &                         ,-1,FFTW_MEASURE)
         ! Inverse FFT
         call dfftw_plan_dft_3d(plan_CD(2),nl,nm,nn &
     &                         ,afft_CD(1),afft_CD(1) &
     &                         ,+1,FFTW_MEASURE)
      end if
      if(ipri >= 1) then
         write(nfout,'(" !(CDFFT_setup) nl, nm, nn   = ",3i8)') nl, nm, nn
         write(nfout,'(" !(CDFFT_setup) plan_CD(1:2) = ",2i20)') plan_CD(1:2)
      end if
    end subroutine init_fft_coefficients_arrays_CD
  end subroutine CDFFT_setup

! === necessary to make 3D_Parallel, too!!! by tkato ===========================
!!BRANCH_P ORG_Parallel
! ==============================================================================
!$$#ifndef PARA3D
  subroutine m_FFT_WF(electron_or_positron,nfout,afft,inverse_or_direct,switch)  ! G space --> R space
    integer, intent(in)          :: electron_or_positron
    integer, intent(in)          :: nfout
    real(kind=DP), intent(inout) :: afft(nfft)
    integer, intent(in)          :: inverse_or_direct
    integer, intent(in)          :: switch

    integer(8) :: plan(2)
    integer :: id_sname = -1
    if(electron_or_positron == ELECTRON) then
       call tstatc0_begin('m_FFT_WF ',id_sname)
    else if(electron_or_positron == POSITRON) then
       call tstatc0_begin('m_FFT_pWF ',id_sname)
    end if

    if(electron_or_positron == ELECTRON) then
       plan(1:2) = plan_WF(1:2)
    else if(electron_or_positron == POSITRON) then
       plan(1:2) = plan_pWF(1:2)
    end if

    if(inverse_or_direct == DIRECT) then
       if(kimg==1) then
          call dfftw_execute_dft_c2r(plan(1),afft(1),afft(1))
       else
          call dfftw_execute_dft(plan(1),afft(1),afft(1))
       end if
    else ! INVERSE
       if(kimg==1) then
          call dfftw_execute_dft_r2c(plan(2),afft(1),afft(1))
       else
          call dfftw_execute_dft(plan(2),afft(1),afft(1))
       end if
    end if

    call tstatc0_end(id_sname)
  end subroutine m_FFT_WF
!$$#endif
! === necessary to make 3D_Parallel, too!!! by tkato ===========================
!!BRANCH_P_END ORG_Parallel
! ==============================================================================

! ========== KT_add ========================================= 13.0F
  subroutine m_FFT_exx( nfout,afft,inverse_or_direct,switch)  ! G space --> R space
    integer, intent(in)          :: nfout
    real(kind=DP), intent(inout) :: afft(nfft_exx)
    integer, intent(in)          :: inverse_or_direct
    integer, intent(in)          :: switch

    integer(8) :: plan(2)
    integer :: id_sname = -1

    call tstatc0_begin('m_FFT_exx ',id_sname)

    plan(1:2) = plan_exx(1:2)

    if(inverse_or_direct == DIRECT) then
       if(kimg==1) then
          call dfftw_execute_dft_c2r(plan(1),afft(1),afft(1))
       else
          call dfftw_execute_dft(plan(1),afft(1),afft(1))
       endif
    else ! INVERSE
       if(kimg==1) then
          call dfftw_execute_dft_r2c(plan(2),afft(1),afft(1))
       else
          call dfftw_execute_dft(plan(2),afft(1),afft(1))
       end if
    end if

    call tstatc0_end(id_sname)
  end subroutine m_FFT_exx
! ============================================================ 13.0F

  subroutine fft_CD_inverse_core(afft_CD)
    real(kind=DP),intent(inout),dimension(nfftp_nonpara) :: afft_CD

    if(kimg==1) then
       call dfftw_execute_dft_r2c(plan_CD(2),afft_CD(1),afft_CD(1))
    else
       call dfftw_execute_dft(plan_CD(2),afft_CD(1),afft_CD(1))
    endif
  end subroutine fft_CD_inverse_core

  subroutine fft_CD_direct_core(afft_CD)
    real(kind=DP),intent(inout),dimension(nfftp_nonpara) :: afft_CD
    if(kimg==1) then
       call dfftw_execute_dft_c2r(plan_CD(1),afft_CD(1),afft_CD(1))
    else
       call dfftw_execute_dft(plan_CD(1),afft_CD(1),afft_CD(1))
    end if
  end subroutine fft_CD_direct_core

  subroutine fft_CD_inverse_core_exx(afft_CD)
    real(kind=DP),intent(inout),dimension(nfftp_exx_nonpara) :: afft_CD

    if(kimg==1) then
       call dfftw_execute_dft_r2c(plan_CD_exx(2),afft_CD(1),afft_CD(1))
    else
       call dfftw_execute_dft(plan_CD_exx(2),afft_CD(1),afft_CD(1))
    endif
  end subroutine fft_CD_inverse_core_exx

  subroutine fft_CD_direct_core_exx(afft_CD)
    real(kind=DP),intent(inout),dimension(nfftp_exx_nonpara) :: afft_CD
    if(kimg==1) then
       call dfftw_execute_dft_c2r(plan_CD_exx(1),afft_CD(1),afft_CD(1))
    else
       call dfftw_execute_dft(plan_CD_exx(1),afft_CD(1),afft_CD(1))
    end if
  end subroutine fft_CD_direct_core_exx

! --------------

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 579 $)
!
!  MODULE: m_PAW_Hartree
!
!  AUTHOR(S): T. Yamasaki, T. Yamamoto and T. Ohno November/2009
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!#========================================================================
!
! Bug fix:  2016/10/13
!    *Antiferromagnetic calculation
!        The variable flg_done is neglected for the moment
!        because the skipping mechanism does not work properly in some cases.
!
!#========================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_PAW_Hartree
  use m_Const_Parameters,     only   : DP, chg_symm_level1
  use m_Control_Parameters,   only   : nspin,af,printable,ipripp, charge_symm_mode
  use m_Ionic_System,         only   : ntyp,ivan,iatomn,iatom,natm, iwei, ityp
  use m_Charge_Density,       only   : hsr,hsro
  use m_PseudoPotential,      only   : dion_hartree,dion_hartree_now, ilmt,ipaw &
       , n_cijkclmk,ilmt3_cijkclmk,ilmt4_cijkclmk &
       , CijkClmkVVVVijlm_k &
       , CijkClmkVVVVijlm_k_ae &
       , flg_symmtry,ia2ia_symmtry_op &
       , n_cijkclmn,ilmt3_cijkclmn,ilmt4_cijkclmn &
       , CijkClmnVVVVijlm_kn &
       , CijkClmnVVVVijlm_kn_ae
  use m_Crystal_Structure,    only   : nopr
  use m_Files,                only   : nfout
  
! =========================== added by K. Tagami ============= 11.0
  use m_Control_Parameters,   only : noncol
! ============================================================ 11.0

  implicit none
  private
  
  real(DP),pointer,dimension(:):: eh_paw,eho_paw
  
  public:: m_PAW_Hartree_alloc_ehs
  public:: m_PAWH_get_dion_hartree
  public:: m_PAWH_get_dion_hartree_now
  public:: m_PAWH_get_energy_hartree
    
contains
    
  subroutine m_PAW_Hartree_alloc_ehs
    allocate(eh_paw(natm));eh_paw=0.d0
    allocate(eho_paw(natm));eho_paw=0.d0
    return
  end subroutine m_PAW_Hartree_alloc_ehs
  
  subroutine m_PAW_Hartree_dealloc_ehs
    deallocate(eh_paw,eho_paw)
    return
  end subroutine m_PAW_Hartree_dealloc_ehs
  
  subroutine m_PAWH_get_dion_hartree(nfout)
    integer,intent(in):: nfout
    integer:: ia,ja,it,lmt1,lmt2,lmt3,lmt4,is,mp,nlmt
    real(DP):: fac,sum,sum_ae
    real(DP),pointer:: dion_hartree_ae(:,:,:)
    integer:: iopr, nopr_max
    integer, parameter :: PRINTLEVEL = 2
    logical,pointer:: flg_done(:)
    
! ========================== added by K. Tagami ================== 11.0
    integer :: ismax
    if ( noncol ) then
       ismax = 1
    else
       ismax = nspin
    endif
! ================================================================ 11.0
    
    if ( charge_symm_mode >= chg_symm_level1 ) then
       nopr_max = 1
    else
       nopr_max = nopr
    endif

    nlmt=maxval(ilmt)
    allocate(dion_hartree_ae(nlmt,nlmt,natm))
    dion_hartree_ae=0.d0
    
    do ia=1,natm
       it=ityp(ia)
!TypeLoop:   do it=1,ntyp
!                if(ityp(ia)/=it) cycle
       if(ipaw(it)/=1) then
          dion_hartree(:,:,ia)=0.d0
!                    exit TypeLoop
          cycle
       end if
       
       if(.not.flg_symmtry) then
          do lmt1=1,ilmt(it)
             do lmt2=lmt1,ilmt(it)
                sum=0.d0
                sum_ae=0.d0
                do mp=1,n_cijkclmk(lmt1,lmt2,it)
                   lmt3=ilmt3_cijkclmk(lmt1,lmt2,mp,it)
                   lmt4=ilmt4_cijkclmk(lmt1,lmt2,mp,it)
                   if(lmt3.gt.lmt4) then
                      write(nfout,*) 'Error in calcDionHartree !'
                      write(nfout,'(a,i4)') 'lmt3 = ',lmt3
                      write(nfout,'(a,i4)') 'lmt4 = ',lmt4
                      stop
                   end if
                   fac=2.d0;if(lmt3.eq.lmt4) fac=1.d0

! ========================== modified by K. Tagami ================== 11.0
!                   do is=1,nspin
                   do is=1, ismax
! =================================================================== 11.0
                      sum=sum+CijkClmkVVVVijlm_k(lmt1,lmt2,mp,it)* &
                           hsr(ia,lmt3,lmt4,is)*fac
                      sum_ae=sum_ae+CijkClmkVVVVijlm_k_ae(lmt1,lmt2,mp,it)* &
                           hsr(ia,lmt3,lmt4,is)*fac
                   end do

                end do
                dion_hartree(lmt1,lmt2,ia)=sum
                dion_hartree_ae(lmt1,lmt2,ia)=sum_ae
             end do
          end do
       else
          do lmt1=1,ilmt(it)
             do lmt2=lmt1,ilmt(it)
                sum=0.d0
                sum_ae=0.d0
                do iopr=1,nopr_max
                   do mp=1,n_cijkclmn(lmt1,lmt2,ia,iopr)
                      lmt3=ilmt3_cijkclmn(lmt1,lmt2,mp,ia,iopr)
                      lmt4=ilmt4_cijkclmn(lmt1,lmt2,mp,ia,iopr)
                      if(lmt3.gt.lmt4) then
                         write(nfout,*) 'Error in calcDionHartree !'
                         write(nfout,'(a,i4)') 'lmt3 = ',lmt3
                         write(nfout,'(a,i4)') 'lmt4 = ',lmt4
                         stop
                      end if
                      fac=2.d0;if(lmt3.eq.lmt4) fac=1.d0

! ========================== modified by K. Tagami ================== 11.0
!                      do is=1,nspin
                      do is=1, ismax
! =================================================================== 11.0

                         sum=sum+CijkClmnVVVVijlm_kn(lmt1,lmt2,mp,ia,iopr)* &
                              hsr(abs(ia2ia_symmtry_op(ia,iopr)),lmt3,lmt4,is)*fac
                         sum_ae=sum_ae+CijkClmnVVVVijlm_kn_ae(lmt1,lmt2,mp,ia,iopr)* &
                              hsr(abs(ia2ia_symmtry_op(ia,iopr)),lmt3,lmt4,is)*fac
                         !print *,CijkClmnVVVVijlm_kn_ae(lmt1,lmt2,mp,ia,iopr)
                      end do
                   end do
                end do
                dion_hartree(lmt1,lmt2,ia)=sum/dble(nopr_max)
                dion_hartree_ae(lmt1,lmt2,ia)=sum_ae/dble(nopr_max)
             end do
          end do
       end if
            
!            end do TypeLoop
    end do

!ASMS    if(af /= 0) then
!ASMS       allocate(flg_done(natm))
!ASMS       flg_done=.false.
!ASMS       do ia=1,natm
!ASMS          if(flg_done(ia)) cycle
!ASMS          ja=ia2ia_symmtry_op(ia,nopr+af)
!ASMS          dion_hartree(:,:,ia)=(dion_hartree(:,:,ia)+dion_hartree(:,:,ja))/2.d0
!ASMS          dion_hartree(:,:,ja)=dion_hartree(:,:,ia)
!ASMS          flg_done(ja)=.true.
!ASMS       end do
!ASMS       deallocate(flg_done)
!ASMS    end if
    
    if(ipripp>=PRINTLEVEL.and.printable)then
       write(nfout,*)
       write(nfout,*) ' -- dion_hartree ---'
       do ia=1,natm
          write(nfout,'(a,i2)') 'ia = ',ia
          it=ityp(ia)
          if(ipaw(it)/=1) cycle
          do lmt1 = 1, ilmt(it)
             write(nfout,'(i3,15f15.9/15f15.9)') lmt1 &
                  &               ,(dion_hartree(lmt1,lmt2,ia),lmt2 = 1, ilmt(it))
          enddo
       end do
       write(nfout,*)
       write(nfout,*) ' -- dion_hartree_ae ---'
       do ia=1,natm
          write(nfout,'(a,i2)') 'ia = ',ia
          it=ityp(ia)
          if(ipaw(it)/=1) cycle
          do lmt1 = 1, ilmt(it)
             write(nfout,'(i3,15f15.9/15f15.9)') lmt1 &
                  &               ,(dion_hartree_ae(lmt1,lmt2,ia),lmt2 = 1, ilmt(it))
          enddo
       end do
    endif
    
    deallocate(dion_hartree_ae)
!    do lmt1=1,8
!    print '(8f19.6)',(dion_hartree(lmt1,lmt2,1),lmt2=1,8)
!    end do
!    stop
    return
  end subroutine m_PAWH_get_dion_hartree
    
  subroutine m_PAWH_get_dion_hartree_now(nfout)
    integer,intent(in):: nfout
    integer:: ia,ja,it,lmt1,lmt2,lmt3,lmt4,is,mp
    real(DP):: fac,sum
    integer:: iopr, nopr_max
    logical,pointer:: flg_done(:)
    
! ========================== added by K. Tagami ================== 11.0
    integer :: ismax
    if ( noncol ) then
       ismax = 1
    else
       ismax = nspin
    endif
! ================================================================ 11.0

    if ( charge_symm_mode >= chg_symm_level1 ) then
       nopr_max = 1
    else
       nopr_max = nopr
    endif

    do ia=1,natm
       it=ityp(ia)
       !TypeLoop:   do it=1,ntyp
       !                if(ityp(ia)/=it) cycle
       if(ipaw(it)/=1) then
          dion_hartree_now(:,:,ia)=0.d0
!                    exit TypeLoop
          cycle
       end if
       
       if(.not.flg_symmtry) then
          
          do lmt1=1,ilmt(it)
             do lmt2=lmt1,ilmt(it)
                sum=0.d0
                do mp=1,n_cijkclmk(lmt1,lmt2,it)
                   lmt3=ilmt3_cijkclmk(lmt1,lmt2,mp,it)
                   lmt4=ilmt4_cijkclmk(lmt1,lmt2,mp,it)
                   if(lmt3.gt.lmt4) then
                      write(nfout,*) 'Error in calcDionHartree !'
                      write(nfout,'(a,i4)') 'lmt3 = ',lmt3
                      write(nfout,'(a,i4)') 'lmt4 = ',lmt4
                      stop
                   end if
                   fac=2.d0;if(lmt3.eq.lmt4) fac=1.d0
! ========================== modified by K. Tagami ================== 11.0
!                   do is=1,nspin
                   do is=1, ismax
! =================================================================== 11.0
                      sum=sum+CijkClmkVVVVijlm_k(lmt1,lmt2,mp,it)* &
                           hsr(ia,lmt3,lmt4,is)*fac
                   end do
                end do
                dion_hartree_now(lmt1,lmt2,ia)=sum
             end do
          end do
          
       else
          
          do lmt1=1,ilmt(it)
             do lmt2=lmt1,ilmt(it)
                sum=0.d0
                do iopr=1,nopr_max
                   do mp=1,n_cijkclmn(lmt1,lmt2,ia,iopr)
                      lmt3=ilmt3_cijkclmn(lmt1,lmt2,mp,ia,iopr)
                      lmt4=ilmt4_cijkclmn(lmt1,lmt2,mp,ia,iopr)
                      if(lmt3.gt.lmt4) then
                         write(nfout,*) 'Error in calcDionHartree !'
                         write(nfout,'(a,i4)') 'lmt3 = ',lmt3
                         write(nfout,'(a,i4)') 'lmt4 = ',lmt4
                         stop
                      end if
                      fac=2.d0;if(lmt3.eq.lmt4) fac=1.d0
! ========================== modified by K. Tagami ================== 11.0
!                   do is=1,nspin
                      do is=1, ismax
! =================================================================== 11.0
                         sum=sum+CijkClmnVVVVijlm_kn(lmt1,lmt2,mp,ia,iopr)* &
                              hsr(abs(ia2ia_symmtry_op(ia,iopr)),lmt3,lmt4,is)*fac
                      end do
                   end do
                end do
                dion_hartree_now(lmt1,lmt2,ia)=sum/dble(nopr_max)
             end do
          end do
          
       end if
                
!            end do TypeLoop
    end do
!        write(nfout,*)
!        write(nfout,*) ' -- dion_hartree ---'
!        do ia=1,natm
!            write(nfout,'(a,i2)') 'ia = ',ia
!            it=ityp(ia)
!            if(.not.ipaw(it)) cycle
!            do lmt1 = 1, ilmt(it)
!                write(nfout,'(i3,9f8.5/9f8.5)') lmt1 &
!                  &               ,(dion_hartree(lmt1,lmt2,ia),lmt2 = 1, ilmt(it))
!            enddo
!        end do
!    do lmt1=1,8
!    print '(8f19.6)',(dion_hartree(lmt1,lmt2,1),lmt2=1,8)
!    end do
!    stop

!ASMS    if(af /= 0) then
!ASMS       allocate(flg_done(natm))
!ASMS       flg_done=.false.
!ASMS       do ia=1,natm
!ASMS          if(flg_done(ia)) cycle
!ASMS          ja=ia2ia_symmtry_op(ia,nopr+af)
!ASMS          dion_hartree_now(:,:,ia)=(dion_hartree_now(:,:,ia)+dion_hartree_now(:,:,ja))/2.d0
!ASMS          dion_hartree_now(:,:,ja)=dion_hartree_now(:,:,ia)
!ASMS          flg_done(ja)=.true.
!ASMS       end do
!ASMS       deallocate(flg_done)
!ASMS    end if

    return
  end subroutine m_PAWH_get_dion_hartree_now
    
  subroutine m_PAWH_get_energy_hartree
    integer:: lmt1,lmt2,is,ia,it
    real(DP):: fac

! ========================== added by K. Tagami ================== 11.0
    integer :: ismax
    if ( noncol ) then
       ismax = 1
    else
       ismax = nspin
    endif
! ================================================================ 11.0

    do ia=1,natm
       eho_paw(ia)=0.d0
       do it=1,ntyp
          if(ityp(ia)/=it .or. ipaw(it)/=1) cycle
          
          do lmt1=1,ilmt(it)
             do lmt2=lmt1,ilmt(it)
                fac=2.d0*iwei(ia);if(lmt1.eq.lmt2) fac=iwei(ia)
! ========================== modified by K. Tagami ================== 11.0
!                do is=1,nspin
                do is=1, ismax
! =================================================================== 11.0
                   eho_paw(ia)=eho_paw(ia)+ &
                        fac*hsr(ia,lmt1,lmt2,is)* &
                        dion_hartree(lmt1,lmt2,ia)
                end do
             end do
          end do
          eho_paw(ia)=eho_paw(ia)/2.d0
       end do
    end do
    
    call m_PAWH_get_dion_hartree(nfout)
    
    do ia=1,natm
       eh_paw(ia)=0.d0
       do it=1,ntyp
          if(ityp(ia)/=it .or. ipaw(it)/=1) cycle
          
          do lmt1=1,ilmt(it)
             do lmt2=lmt1,ilmt(it)
                fac=2.d0*iwei(ia);if(lmt1.eq.lmt2) fac=iwei(ia)
! ========================== modified by K. Tagami ================== 11.0
!                do is=1,nspin
                do is=1, ismax
! =================================================================== 11.0
                   eh_paw(ia)=eh_paw(ia)+ &
                        fac*hsr(ia,lmt1,lmt2,is)* &
                        dion_hartree(lmt1,lmt2,ia)
                end do
             end do
          end do
          eh_paw(ia)=eh_paw(ia)/2.d0
       end do
    end do
    return
    
  end subroutine m_PAWH_get_energy_hartree
  

end module m_PAW_Hartree

!=======================================================================
!
!  SOFTWARE NAME : PHASE (ver. 6.01)
!
!  MODULE: m_Dipole
!
!  AUTHOR(S): T. Yamamoto   December/21/2005
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!
module m_Dipole
  use m_Const_Parameters,    only : DP,PAI4,PAI2,PAI,UP,DOWN,ON, speed_of_light,CONST_EV,BOHR_RADIUS
  use m_Parallelization,     only : MPI_CommGroup,ista_kngp,iend_kngp,npes,mype,ierr
  use m_Control_Parameters,  only : rvac,idir_dip,ndiv_dip,width_dip,kimg &
      &                           , printable,nspin,sw_dipole_correction &
      &                           , amix_dip, elec_field
  use m_Crystal_Structure,   only : altv,univol
  use m_Ionic_System,        only : natm, natm2, ityp, iwei, pos
  use m_PseudoPotential,     only : ival
  use m_PlaneWaveBasisSet,   only : ngabc
  use m_Charge_Density,      only : chgq_l
  use m_Electronic_Structure,only : vlhxc_l

! ================================ added by K. Tagami ============== 11.0
  use m_Control_Parameters,  only : noncol, ndim_magmom
! ================================================================== 11.0
  use mpi

  implicit none
!  include 'mpif.h'

  real(kind=DP), private, parameter :: E30CM = CONST_EV * BOHR_RADIUS * 1.0d30
  real(kind=DP), private, parameter :: DEBYE = speed_of_light * CONST_EV * BOHR_RADIUS * 1.0d21
  real(kind=DP), public :: dipole(3),dipole_old(3)
  real(kind=DP), public :: field(3),field_old(3)
  real(kind=DP), public :: edip_ion,eext_ion

  real(kind=DP), allocatable :: vdip_l(:,:) !d(ista_kngp:iend_kngp,kimg)
  real(kind=DP), allocatable :: vext_l(:,:) !d(ista_kngp:iend_kngp,kimg)

contains

!$$#ifndef PARA3D
  subroutine m_Dipole_vdip_alloc
    if(allocated(vdip_l)) deallocate(vdip_l)
    if(allocated(vext_l)) deallocate(vext_l)
    allocate(vdip_l(ista_kngp:iend_kngp,kimg))
    allocate(vext_l(ista_kngp:iend_kngp,kimg))
  end subroutine m_Dipole_vdip_alloc

  subroutine m_Dipole_calc(nfout)
    integer, intent(in) :: nfout

    real(kind=DP) :: mue,mui,mu
    real(kind=DP) :: a1,a2
    integer :: id

    do id=1,3
       if(id /= idir_dip .and. idir_dip /= 0) cycle
       a1 = rvac(id)
       a2 = a1+1.d0
       call electron_part(a1,a2,id,mue)
       call ion_part(a1,a2,id,mui)
       mu = mui - mue
       if(printable) then
          write(nfout,'("Dipole: rmin,rmax,idir =",2f15.8,i3)') a1,a2,id
          write(nfout,'("Dipole: Total =",f18.8,1x,"=",f13.4,1x,"Debye =",f13.4,"x10^-30 Cm")') mu,mu*DEBYE,mu*E30CM
          write(nfout,'("Dipole: Ion   =",f20.8)') mui
          write(nfout,'("Dipole: Elec  =",f20.8)') mue
       end if
       if(sw_dipole_correction == ON) then
          dipole(id) = mu/univol*sqrt(sum(altv(1:3,id)**2))
          field(id)  = -sum(altv(1:3,id)*elec_field(1:3))/PAI4
          if(printable) then
             write(nfout,'("Dipole: mix dipole and field with amix_dip=",f15.8)') amix_dip
             write(nfout,'("Dipole: (NOW) dipole,field =",2f15.8)') dipole(id),field(id)
             write(nfout,'("Dipole: (OLD) dipole,field =",2f15.8)') dipole_old(id),field_old(id)
          end if
          dipole(id) = (1.d0-amix_dip)*dipole_old(id) + amix_dip*dipole(id)
          field(id) = (1.d0-amix_dip)*field_old(id) + amix_dip*field(id)
          if(printable) then
             write(nfout,'("Dipole: (NEW) dipole,field =",2f15.8)') dipole(id),field(id)
          end if
          dipole_old(id) = dipole(id)
          field_old(id) = field(id)
       end if
    end do
  end subroutine m_Dipole_calc

  subroutine m_Dipole_layer(nfout)
    integer, intent(in) :: nfout

    real(kind=DP) :: mue,mui,mu(0:ndiv_dip),muel(0:ndiv_dip),muil(0:ndiv_dip)
    real(kind=DP) :: a1,a2
    integer :: id,i

    if(printable) then
       write(nfout,'("Dipole: Layered dipole moment (electronic part only)")')
    end if
    do id=1,3
       if(id /= idir_dip .and. idir_dip /= 0) cycle
       a1 = rvac(id)
       do i=0,ndiv_dip
          a2 = a1+i/dble(ndiv_dip)
          call electron_part(a1,a2,id,mue)
          call ion_part_gauss(a1,a2,id,mui)
          muel(i) = mue
          muil(i) = mui
          mu(i) = mui - mue
       end do
       if(printable) then
          write(nfout,'("Dipole: rmin,rmax,idir =",2f15.8,i3)') a1,a2,id
          write(nfout,'("# i     r    mui(a.u.)   mue(a.u.)   mu(a.u.)   mu(Debye)")')
          do i=0,ndiv_dip
             a2 = a1+i/dble(ndiv_dip)
             write(nfout,'(i5,4(1x,f20.8),1x,f15.4)') i,a2,muil(i),muel(i),mu(i),mu(i)*DEBYE
          end do
       end if
    end do
  end subroutine m_Dipole_layer

  subroutine electron_part(a1,a2,iax1,mue)
    real(kind=DP), intent(in) :: a1,a2
    integer, intent(in) :: iax1
    real(kind=DP), intent(out) :: mue

    real(kind=DP) :: ss,chgq0,mue_mpi,mue0,length
    integer :: ista,iax2,iax3,g,i,ispin
    complex(kind=DP) :: zi,zchg,zga1,zga2

! ====================== added by K. Tagami ================== 11.0
    integer :: ismax
!
    if ( noncol ) then
       ismax = 1
    else
       ismax = nspin
    endif
! ============================================================ 11.0

    length = sqrt(sum(altv(1:3,iax1)**2))
    zi = cmplx(0.d0,1.d0)*PAI2

    iax2 = iax1 + 1
    if(iax2 >= 4) iax2 = iax2 - 3
    iax3 = iax2 + 1
    if(iax3 >= 4) iax3 = iax3 - 3

    ss = univol*length/PAI2**2

    ista = ista_kngp
    if (ista == 1) then
! ========================= modified by K. Tagami =============== 11.0
!       chgq0 = sum(chgq_l(1,1,1:nspin))

       if ( noncol ) then
          chgq0 = chgq_l(1,1,1)
       else
          chgq0 = sum(chgq_l(1,1,1:nspin))
       endif
! =============================================================== 11.0
       mue0  = 0.5d0*chgq0*univol*(a2**2-a1**2)*length
       ista = 2
    end if
    mue = 0.d0
    if(kimg == 1) then
! ========================= modified by K. Tagami =============== 11.0
!       do ispin=1,nspin
       do ispin=1, ismax
! =============================================================== 11.0
          do i = ista, iend_kngp
             if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                g = ngabc(i,iax1)
                zga1 = zi*g*a1
                zga2 = zi*g*a2
                mue = mue  &
                  & + chgq_l(i,1,ispin)*( ( (zga1-1.d0)*cdexp(zga1) - (zga2-1.d0)*cdexp(zga2) )/(g*g) )
             end if
          end do
       end do
    else
! ========================= modified by K. Tagami =============== 11.0
!       do ispin=1,nspin
       do ispin=1, ismax
! =============================================================== 11.0
          do i = ista, iend_kngp
             if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                g = ngabc(i,iax1)
                zga1 = zi*g*a1
                zga2 = zi*g*a2
                zchg = cmplx(chgq_l(i,1,ispin),chgq_l(i,2,ispin))
                mue = mue &
                  & + dble(zchg * ( ( (zga1-1.d0)*cdexp(zga1) - (zga2-1.d0)*cdexp(zga2) )/(g*g) ) )
             end if
          end do
       end do
    end if
    if(npes > 1) then
       call mpi_bcast(mue0,1,mpi_double_precision,0,MPI_CommGroup,ierr)
       mue_mpi = 0.d0
       call mpi_allreduce(mue, mue_mpi, 1,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
       mue = mue_mpi
    end if
    mue = mue * ss + mue0
  end subroutine electron_part
!$$#endif

  subroutine ion_part(a1,a2,iax1,mui)
    real(kind=DP), intent(in) :: a1,a2
    integer, intent(in) :: iax1
    real(kind=DP), intent(out) :: mui

    real(kind=DP) :: ps(natm2),t
    integer :: ia,ja,ityp2(natm2)
#ifdef __TIMER_SUB__
  call timer_sta(1053)
#endif

    ja = 0
#ifdef __TIMER_DO__
  call timer_sta(1070)
#endif
    do ia=1,natm
       ja = ja + 1
       if(iwei(ia)==1) then
          ityp2(ja) = ityp(ia)
          ps(ja) = pos(ia,iax1)
       else
          ityp2(ja) = ityp(ia)
          ps(ja) = pos(ia,iax1)
          ja = ja + 1
          ityp2(ja) = ityp(ia)
          ps(ja) = -pos(ia,iax1)
       end if
    end do
#ifdef __TIMER_DO__
  call timer_end(1070)
#endif
    mui = 0.d0
#ifdef __TIMER_DO__
  call timer_sta(1071)
#endif
    do ia=1,natm2
       t = ps(ia) - a1
       t = mod(t,1.d0)
       t = t + a1
       if(t <= a2) mui = mui + ival(ityp2(ia))*t
    end do
#ifdef __TIMER_DO__
  call timer_end(1071)
#endif
    mui = mui * sqrt(sum(altv(1:3,iax1)**2))
#ifdef __TIMER_SUB__
  call timer_end(1053)
#endif
  end subroutine ion_part

  subroutine ion_part_gauss(a1,a2,iax1,mui)
    real(kind=DP), intent(in) :: a1,a2
    integer, intent(in) :: iax1
    real(kind=DP), intent(out) :: mui

    real(kind=DP) :: ps(natm2),t, derf
    integer :: ia,ja,ityp2(natm2)
    real(kind=DP) :: a,f1,f2,w,fac1,fac2,fac3,x,length

    length = sqrt(sum(altv(1:3,iax1)**2))
    w = width_dip
    a = 4.d0*log(2.d0)
    f1 = -a/w**2
    f2 = sqrt(a)/w
    fac1 = -0.5d0*length*w/sqrt(PAI*a)
    fac2 = 0.5d0*length

    ja = 0
    do ia=1,natm
       ja = ja + 1
       if(iwei(ia)==1) then
          ityp2(ja) = ityp(ia)
          ps(ja) = pos(ia,iax1)
       else
          ityp2(ja) = ityp(ia)
          ps(ja) = pos(ia,iax1)
          ja = ja + 1
          ityp2(ja) = ityp(ia)
          ps(ja) = -pos(ia,iax1)
       end if
    end do
    mui = 0.d0
    do ia=1,natm2
       t = ps(ia) - a1
       t = mod(t,1.d0)
       t = t + a1
       x = a2-t
       mui = mui + ival(ityp2(ia))*(fac1*dexp(f1*x**2)+t*fac2*(1.d0+derf(f2*x)))
    end do
  end subroutine ion_part_gauss

!$$#ifndef PARA3D
  subroutine m_Dipole_potential(nfout,chg)
    integer, intent(in) :: nfout

! ================================== modified by K. Tagami ========= 11.0
!    real(kind=DP), intent(in) :: chg(ista_kngp:iend_kngp,kimg,nspin)
    real(kind=DP), intent(in) :: chg(ista_kngp:iend_kngp,kimg,ndim_magmom)
! ================================================================== 11.0

    integer :: ista,iax1,iax2,iax3,g,ik,i,ispin,id
    real(kind=DP) :: mud,muf,a1,zx,fac

    vdip_l = 0.d0
    vext_l = 0.d0
    ista = ista_kngp
    if(ista == 1) then
       ista = 2
    end if
    do id=1,3
       !!$if(id /= idir_dip .and. idir_dip /= 0) cycle
       if(id /= idir_dip) cycle
       mud = dipole(id)
       muf = field(id)
       iax1 = id
       iax2 = iax1 + 1
       if(iax2 >= 4) iax2 = iax2 - 3
       iax3 = iax2 + 1
       if(iax3 >= 4) iax3 = iax3 - 3
       a1 = rvac(id)
       do ik=1,kimg
          do i = ista, iend_kngp
             if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                g = ngabc(i,iax1)
                if(ik==1) then
                   fac = 2.d0*sin(PAI2*g*a1)/g
                else
                   fac = -2.d0*cos(PAI2*g*a1)/g
                end if
                vdip_l(i,ik) = vdip_l(i,ik) + mud*fac
                vext_l(i,ik) = vext_l(i,ik) + muf*fac
             end if
          end do
       end do
    end do

    edip_ion = 0.d0
    eext_ion = 0.d0
    do id=1,3
       !!$if(id /= idir_dip .and. idir_dip /= 0) cycle
       if(id /= idir_dip) cycle
       a1 = rvac(id)
       call edip_ion_part(a1,a1+1.d0,id,zx)
       edip_ion = edip_ion + PAI4*dipole(id)*zx
       eext_ion = eext_ion + PAI4*field(id)*zx
    end do
    edip_ion = 0.5d0*edip_ion
    if(printable) then
       write(nfout,'("Dipole: Edip(ion),Eext(ion)=",2f15.5)') edip_ion,eext_ion
       write(nfout,'("Dipole: potential jump (dip and ext)=",2f15.5)') PAI4*dipole(idir_dip),PAI4*field(idir_dip)
    end if
  end subroutine m_Dipole_potential
!$$#endif

  subroutine edip_ion_part(a1,a2,iax1,zx)
    real(kind=DP), intent(in) :: a1,a2
    integer, intent(in) :: iax1
    real(kind=DP), intent(out) :: zx

    real(kind=DP) :: ps(natm2),t
    integer :: ia,ja,ityp2(natm2)

#ifdef __TIMER_SUB__
  call timer_sta(1055)
#endif

    ja = 0
#ifdef __TIMER_DO__
  call timer_sta(1074)
#endif
    do ia=1,natm
       ja = ja + 1
       if(iwei(ia)==1) then
          ityp2(ja) = ityp(ia)
          ps(ja) = pos(ia,iax1)
       else
          ityp2(ja) = ityp(ia)
          ps(ja) = pos(ia,iax1)
          ja = ja + 1
          ityp2(ja) = ityp(ia)
          ps(ja) = -pos(ia,iax1)
       end if
    end do
#ifdef __TIMER_DO__
  call timer_end(1074)
#endif
    zx = 0.d0
#ifdef __TIMER_DO__
  call timer_sta(1075)
#endif
    do ia=1,natm2
       t = ps(ia) - a1
       t = mod(t,1.d0)
       t = t - 0.5d0
       zx = zx + ival(ityp2(ia))*t
    end do
#ifdef __TIMER_DO__
  call timer_end(1075)
#endif
#ifdef __TIMER_SUB__
  call timer_end(1055)
#endif
  end subroutine edip_ion_part

  subroutine m_Dipole_wd_vlhxc(nfout,vxc_l)
    integer, intent(in) :: nfout

! ============================== modified by K. Tagami ================== 11.0
!    real(kind=DP), intent(in) :: vxc_l(ista_kngp:iend_kngp,kimg,nspin)
    real(kind=DP), intent(in) :: vxc_l(ista_kngp:iend_kngp,kimg,ndim_magmom)
! ======================================================================= 11.0

    integer :: g,ia,ix,i
    integer :: iax1,iax2,iax3
    real(kind=DP) :: a1,x,ph,dx
    real(kind=DP) :: vloc(0:ndiv_dip)
    real(kind=DP), allocatable :: vloc_mpi(:)
    real(kind=DP) :: vm,vp,vj

    integer, parameter :: ispin = 1

    if(idir_dip == 0) return

    iax1 = idir_dip
    iax2 = iax1 + 1
    if(iax2 >= 4) iax2 = iax2 - 3
    iax3 = iax2 + 1
    if(iax3 >= 4) iax3 = iax3 - 3

    vloc(:) = 0.d0
    a1 = rvac(idir_dip)
    dx = 1.d0/ndiv_dip
    do ix=0,ndiv_dip
       x = a1+dx*ix
       if(kimg==1) then
          do i = ista_kngp, iend_kngp
             if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                g = ngabc(i,idir_dip)
                vloc(ix) = vloc(ix) + (vlhxc_l(i,kimg,ispin)-vxc_l(i,kimg,ispin))*cos(PAI2*g*x)
             end if
          end do
       else
          do i = ista_kngp, iend_kngp
             if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
                g = ngabc(i,idir_dip)
                ph = PAI2*g*x
                vloc(ix) = vloc(ix) + (vlhxc_l(i,1,ispin)-vxc_l(i,1,ispin))*cos(ph) &
                         &          - (vlhxc_l(i,kimg,ispin)-vxc_l(i,kimg,ispin))*sin(ph)
             end if
          end do
       end if
    end do
    if(npes > 1) then
       allocate(vloc_mpi(0:ndiv_dip))
       vloc_mpi = 0.d0
       call mpi_allreduce(vloc,vloc_mpi,(ndiv_dip+1),mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
       vloc = vloc_mpi
       deallocate(vloc_mpi)
    end if
    if(printable) then
       vm = sum(vloc(1:5))/5
       vp = sum(vloc(ndiv_dip-6:ndiv_dip-1))/5
       vj = vm-vp
       write(nfout,'("Dipole: Vh; dir_dip=",i1)') idir_dip
       write(nfout,'("Dipole: Vh(-)=",f10.5," Vh(+)=",f10.5," Vh(-)-Vh(+)",f10.5)') vm,vp,vj
       write(nfout,'(" x, Vh(x)")')
       do ix=0,ndiv_dip
          x = a1+dx*ix
          write(nfout,'(f10.5,1x,f10.5)') x,vloc(ix)
       end do
    end if
  end subroutine m_Dipole_wd_vlhxc


end module m_Dipole

#define MOMENT_AS_PSEUDO_VECTOR

module m_CS_Magnetic
! $Id: m_CS_Magnetic.F90 250 2012-11-16 05:29:11Z ktagami $
  use m_Const_Parameters,   only : DP, BUCS, CARTS, CRDTYP, DELTA10, &
       &                           oh=>oh_symbol, d6h=>d6h_symbol, ON, DELTA07, &
       &                           CMPLDP, zi, PAI, OFF, PAI2

  use m_Crystal_Structure,      only : nopr, op, ig01, tau, m_CS_op_in_PUCD, &
       &                               pg_symbol_system, ngen, igen, jgen, &
       &                               alloc_igen_jgen, dealloc_igen_jgen, &
       &                               sw_reduce_sym_by_magmom, &
       &                               sw_reduce_sym_by_orbital, sw_neglect_magmom, &
       &                               sw_allow_mag_sym_inversion, &
       &                               sw_allow_improper_rotation

  use m_Ionic_System,       only : natm, ntyp, ityp, mag_direction0_atomtyp, &
       &                           natm2, pos, iwei, magmom_local_now, &
       &                           has_partially_filled_lcore

  use m_Files,                 only : nfout

! == KT_add === 2014/08/14
  use m_Ionic_System,  only :   lattice_system_from_m_CS_SG
! ============= 2014/08/14

! == KT_add === 2014/08/26
  use m_Control_Parameters,   only : SpinOrbit_mode, noncol, iprisym
  use m_Const_Parameters,    only : Neglected
  use m_Ionic_System,  only :   mag_moment0_atoms, ionic_charge_atoms, &
       &                        mag_moment0_atoms_is_defined
! ============= 2014/08/26

! === KT_add === 13.2S
  use m_Crystal_Structure,   only : sw_use_magnetic_symmetry
! ============== 13.2S
  use mpi

  implicit none

!  include 'mpif.h'
  integer istatus(mpi_status_size)

! ---------------------------
  integer :: nopr_before_sym_reduction
  real(kind=DP), allocatable :: op_before_sym_reduction(:,:,:)
  integer :: invop(48)
  integer :: determinant_op(48)
! -------------------------

! == KT_add === 2014/08/14
  integer, allocatable :: magmom_dir_inversion_opr_flag(:)
! ============= 2014/08/14

  complex(kind=CMPLDP), allocatable :: op_spinor(:,:,:)

contains

! ------------------------------------------------------------------------
!!
!!!   Removing sym. operations by considering magnetic moment
!!
! ------------------------------------------------------------------------
  subroutine m_CS_set_Magnetic_Sym
    integer :: nsym_with_magmom
    real(kind=DP), allocatable :: mag_loc(:,:), pos2(:,:), ion_chg(:)

    if (  ( .not. noncol ) .and. ( sw_use_magnetic_symmetry == OFF ) ) then
       if ( .not. mag_moment0_atoms_is_defined ) return
    endif

    nopr_before_sym_reduction = nopr

    allocate( pos2(natm2,3) );  pos2 = 0.0d0
    call set_val_pos2( pos2 )

    if ( mag_moment0_atoms_is_defined ) then
       allocate( ion_chg(natm2) ); ion_chg = 0.0d0
       call set_val_ion_charge( ion_chg )
    endif

    if ( noncol .or. sw_use_magnetic_symmetry == ON ) then
       allocate( mag_loc(natm2,3) ); mag_loc = 0.0d0
       call set_val_mag_loc_noncol( mag_loc )

       if ( noncol ) then
          if ( .not. allocated( op_before_sym_reduction ) ) then
             allocate( op_before_sym_reduction(3,3,nopr) )
          endif
          op_before_sym_reduction = op
       endif

! == KT_add === 2014/08/14
       if ( allocated( magmom_dir_inversion_opr_flag ) ) then
          deallocate( magmom_dir_inversion_opr_flag )
       endif
       allocate( magmom_dir_inversion_opr_flag(nopr) )
! ============= 2014/08/14

! ==== KT_add === 2014/09/26
       if ( sw_neglect_magmom == ON ) then
          magmom_dir_inversion_opr_flag = 1;  return
       endif
! =============== 2014/09/26

       call set_magnetic_symm_noncl( natm2, pos2, nopr, ig01, op, tau, mag_loc, &
            &                  nsym_with_magmom, magmom_dir_inversion_opr_flag, &
            &                  ion_chg )

    else
       allocate( mag_loc(natm2,1) ); mag_loc = 0.0d0
       call set_val_mag_loc_col( mag_loc )
       call set_magnetic_symm_col( natm2, pos2, nopr, ig01, op, tau, mag_loc, &
            &                      nsym_with_magmom, ion_chg )
    endif

    call resize_matrix_size( nopr, nsym_with_magmom )
#if 0
    call set_magnetic_tspace_gnerators( nopr, ig01, op, tau )
#endif

    deallocate( pos2 ); deallocate( mag_loc )
    if ( allocated( ion_chg ) ) deallocate( ion_chg )

  contains

    subroutine set_val_pos2( pos2 )
      real(kind=DP), intent(out) :: pos2(natm2,3)
      integer :: i, ia

      pos2(1:natm,1:3) = pos(1:natm,1:3)

      i = natm
      do ia=1,natm
         if (iwei(ia)/=1) then
            i = i+1
            pos2(i,1:3) = -pos(ia,1:3)
         end if
      end do
    end subroutine set_val_pos2

    subroutine set_val_ion_charge( ion_chg )
      real(kind=DP), optional, intent(out) :: ion_chg(natm2)

      integer :: i, ia

      i = natm
      ion_chg(1:natm) = ionic_charge_atoms(1:natm)
      do ia=1,natm
         if (iwei(ia)/=1) then
            i = i+1
            ion_chg(i) = ionic_charge_atoms(ia)
         endif
      end do
    end subroutine set_val_ion_charge

    subroutine set_val_mag_loc_noncol( mag_loc )
      real(kind=DP), intent(out) :: mag_loc(natm2,3)

      integer :: i, ia

      i = natm
      mag_loc(1:natm,:) = magmom_local_now(1:natm,:)
      do ia=1,natm
         if (iwei(ia)/=1) then
            i = i+1
            mag_loc(i,1:3) = magmom_local_now(ia,1:3)
         end if
      end do
!
!      write(nfout,*) 'mag_loc now '
!      Do i=1, natm
!         write(nfout,'(I4,3F20.15)') i, mag_loc(i,1:3)
!      End Do

    end subroutine set_val_mag_loc_noncol

    subroutine set_val_mag_loc_col( mag_loc )
      real(kind=DP), intent(out) :: mag_loc(natm2,1)

      integer :: i, ia

      i = natm
      Do ia=1, natm
         mag_loc(ia,1) = mag_moment0_atoms(ia,1)
      End Do
      do ia=1,natm
         if (iwei(ia)/=1) then
            i = i+1
            mag_loc(i,1) = mag_moment0_atoms(ia,1)
         end if
      end do
    end subroutine set_val_mag_loc_col

    subroutine set_magnetic_symm_noncl( natom, apos, nsym, nopr, rot, tau, mag_loc, &
         &                              nsym_with_mag, magmom_dir_inversion_opr_flag, &
         &                              ion_chg )
      integer, intent(in) :: natom
      integer, intent(inout) :: nsym
      integer, intent(out) :: nopr(48), nsym_with_mag
      integer, intent(inout) :: magmom_dir_inversion_opr_flag(nsym)

! --------------------- kDEBUG --------------------------------- 20121020
!      real(kind=DP), intent(inout) :: rot(3,3,48), tau(3,48,CRDTYP)
      real(kind=DP), intent(inout) :: rot(3,3,nsym), tau(3,nsym,CRDTYP)
! --------------------- kDEBUG --------------------------------- 20121020

      real(kind=DP), intent(in) :: apos(natom,3)
      real(kind=DP), intent(in) :: mag_loc(natom,3)
      real(kind=DP), optional, intent(in) :: ion_chg(natom)

      logical :: mag_sym_flag(nsym)
      integer :: isym, count
      real(kind=DP) :: determinant
! ----
!      write(*,*) 'sw_reduce_ = ',  sw_reduce_sym_by_magmom
      if ( sw_reduce_sym_by_magmom==ON ) then
#if 0
         call check_if_op_has_magnetic_sym1( natom, apos, nsym, rot, tau, &
              &                              mag_loc, mag_sym_flag, &
              &                              magmom_dir_inversion_opr_flag, ion_chg )
#else
         call check_if_op_has_magnetic_sym2( natom, apos, nsym, rot, tau, &
              &                              mag_loc, mag_sym_flag, &
              &                              magmom_dir_inversion_opr_flag, ion_chg )
#endif
      else
         mag_sym_flag = .true.
      endif

      if ( sw_reduce_sym_by_orbital==ON ) then
         call check_if_op_has_sym_for_orb( natom, nsym, rot, mag_loc, mag_sym_flag )
      endif
!
      if ( sw_allow_improper_rotation == OFF ) then
         Do isym=1, nsym
            if ( mag_sym_flag(isym) ) then
               call calc_determinant( rot(:,:,isym), determinant )
               if ( determinant < 0 ) mag_sym_flag(isym) = .false.
            endif
         end Do
      endif
      if ( sw_allow_mag_sym_inversion == OFF ) then
         Do isym=1, nsym
            if ( mag_sym_flag(isym) ) then
               if ( magmom_dir_inversion_opr_flag(isym) == -1 ) then
                  mag_sym_flag(isym) = .false.
               endif
            endif
         End Do
      endif
! -----
      write(nfout,*) '!*** magnetic symmetry info'
      Do isym=1, nsym
         write(nfout,*) isym, mag_sym_flag(isym), magmom_dir_inversion_opr_flag(isym)
      End do

      count = 0
      Do isym=1, nsym
         if ( mag_sym_flag(isym) ) then
            count = count + 1
            nopr(count) = nopr(isym)
            rot(:,:,count) = rot(:,:,isym)
            tau(:,count,:) = tau(:,isym,:)
            magmom_dir_inversion_opr_flag(count) = magmom_dir_inversion_opr_flag(isym)
         endif
      End do

      nsym_with_mag = count

    end subroutine set_magnetic_symm_noncl

    subroutine set_magnetic_symm_col( natom, apos, nsym, nopr, rot, tau, mag_loc, &
         &                            nsym_with_mag, ion_chg )
      integer, intent(in) :: natom
      integer, intent(inout) :: nsym
      integer, intent(out) :: nopr(48), nsym_with_mag

! --------------------- kDEBUG --------------------------------- 20121020
!      real(kind=DP), intent(inout) :: rot(3,3,48), tau(3,48,CRDTYP)
      real(kind=DP), intent(inout) :: rot(3,3,nsym), tau(3,nsym,CRDTYP)
! --------------------- kDEBUG --------------------------------- 20121020

      real(kind=DP), intent(in) :: apos(natom,3)
      real(kind=DP), intent(in) :: mag_loc(natom,3)
      real(kind=DP), optional, intent(in) :: ion_chg(natm)

      logical :: mag_sym_flag(nsym)
      integer :: isym, count
      
      call check_if_op_has_magnetic_sym0( natom, apos, nsym, rot, tau, &
              &                           mag_loc, mag_sym_flag, ion_chg )

      write(nfout,*) '!*** magnetic symmetry info'
      Do isym=1, nsym
         write(nfout,*) isym, mag_sym_flag(isym)
      End do

      count = 0
      Do isym=1, nsym
         if ( mag_sym_flag(isym) ) then
            count = count + 1
            nopr(count) = nopr(isym)
            rot(:,:,count) = rot(:,:,isym)
            tau(:,count,:) = tau(:,isym,:)
         endif
      End do

      nsym_with_mag = count

    end subroutine set_magnetic_symm_col

    subroutine check_if_op_has_sym_for_orb( natom, nsym, rot, &
         &                                  mag_loc, mag_sym_flag )
      integer, intent(in) :: natom, nsym
      logical, intent(inout) :: mag_sym_flag(48)
      real(kind=DP), intent(inout) :: rot(3,3,nsym)
      real(kind=DP), intent(in) :: mag_loc(natom,3)

      integer :: isym, it, ia
      real(kind=DP) :: c1, c2
      real(kind=DP) :: vec1(3), vec_tmp(3), dvec_m(3), dvec_p(3)
      real(kind=DP), parameter :: criterion = 1.0D-5

      Do isym=1, nsym
         if ( .not. mag_sym_flag(isym) ) cycle

         Do it=1, ntyp
            if ( has_partially_filled_lcore(it) == 0 ) cycle

            Do ia=1, natom
               if ( ityp(ia) /=it ) cycle
               
               call calc_normal_vector( mag_loc(ia,1:3), vec1(1:3) )
               vec_tmp(1:3) = matmul( rot(:,:,isym), vec1(1:3) )
!
               dvec_m(1:3) = vec_tmp(1:3) - vec1(1:3)
               dvec_p(1:3) = vec_tmp(1:3) + vec1(1:3)
!
               c1 = abs( dvec_m(1) ) +abs( dvec_m(2) ) +abs( dvec_m(3) )
               c2 = abs( dvec_p(1) ) +abs( dvec_p(2) ) +abs( dvec_p(3) )
!
               if ( c1 < criterion .or. c2 < criterion ) then
                  mag_sym_flag(isym) = .true.
               else
                  mag_sym_flag(isym) = .false.
               endif

               exit
            End do
         End Do

      End Do
!
    end subroutine check_if_op_has_sym_for_orb

    subroutine calc_normal_vector( vec_in, vec_out )
      real(kind=DP), intent(in)  :: vec_in(3)
      real(kind=DP), intent(out) :: vec_out(3)
!
      integer :: k
      real(kind=DP) :: c1, cnorm, vec_tmp(3)
      real(kind=DP), parameter :: criterion = 1.0D-5

! --- trial 1 --
      vec_tmp(1) = 1.0;  vec_tmp(2) = 2.0;    vec_tmp(3) = 3.0
!
      c1 = 0.0d0; cnorm = 0.0d0
      Do k=1, 3
         c1 = c1 + vec_tmp(k)*vec_in(k)
      End do
      vec_tmp(:) = vec_tmp(:) - c1*vec_in(:)
      Do k=1, 3
         cnorm = cnorm + vec_tmp(k)**2
      End do
      cnorm = sqrt(cnorm)
!
      if ( cnorm > criterion ) then
         vec_out(:) = vec_tmp(:) / cnorm
!         write(*,*) 'vec_out = ', vec_out
         return
      endif

! --- trial 2 --
      vec_tmp(1) = 3.0;  vec_tmp(2) = 2.0;    vec_tmp(3) = 1.0
!
      c1 = 0.0d0; cnorm = 0.0d0
      Do k=1, 3
         c1 = c1 + vec_tmp(k)*vec_in(k)
      End do
      vec_tmp(:) = vec_tmp(:) - c1*vec_in(:)
      Do k=1, 3
         cnorm = cnorm + vec_tmp(k)**2
      End do
      cnorm = sqrt(cnorm)
!
      if ( cnorm > criterion ) then
         vec_out(:) = vec_tmp(:) / cnorm
      endif

    end subroutine calc_normal_vector

    subroutine check_if_op_has_magnetic_sym1( natom, apos, nsym, rot, &
         &                                    tau, mag_loc, mag_sym_flag, &
         &                                    magmom_dir_inversion_opr_flag, &
         &                                    ion_chg )
      integer, intent(in) :: natom, nsym
      logical, intent(inout) :: mag_sym_flag(nsym)
      integer, intent(inout) :: magmom_dir_inversion_opr_flag(nsym)
      real(kind=DP), intent(in) :: apos(natom,3), mag_loc(natom,3)
      real(kind=DP), optional, intent(in) :: ion_chg(natm)

! --------------------- kDEBUG --------------------------------- 20121020
!      real(kind=DP), intent(inout) :: rot(3,3,48), tau(3,48,CRDTYP)
      real(kind=DP), intent(inout) :: rot(3,3,nsym), tau(3,nsym,CRDTYP)
! --------------------- kDEBUG --------------------------------- 20121020

      real(kind=DP), parameter :: criterion = 1.0D-5
      real(kind=DP), allocatable :: apos_t(:,:)

      integer :: i, ia, ja, ja_found, it, isym, count
      real(kind=DP) :: coord_tmp(3), dcoord(3), dist
      real(kind=DP) :: mag_tmp(3), dmag_p(3), dmag_m(3)
      real(kind=DP) :: c1, c2, determinant
!
      real(kind=DP), allocatable :: rot_pr(:,:,:)
!
! -- init --
      allocate( rot_pr(3,3,nsym) ); rot_pr = 0.0d0
      call m_CS_op_in_PUCD( nfout, rot_pr, nsym, .true., &
           &                '***** Before considering magnetic symmetry ****** ')

      allocate(apos_t(natom,3))
      apos_t(1:natm,1:3) = apos(1:natom,1:3)
      do ia = 1, natom
         do i = 1, 3
            apos_t(ia,i) = apos_t(ia,i) - floor(apos_t(ia,i))
         end do
      end do

      mag_sym_flag = .false.

      magmom_dir_inversion_opr_flag = 1

! -- begin --
      Do isym=1, nsym

! ================== KT_add ======= 2014/08/14
         if ( lattice_system_from_m_CS_SG == "cubic" ) then
            if ( ig01(isym) > 24 ) cycle
         else if ( lattice_system_from_m_CS_SG == "hexagonal" ) then
            if ( ig01(isym) > 12 ) cycle
         endif
! ================================= 2014/08/14
         call calc_determinant( rot_pr(:,:,isym), determinant )

         Loop_it : Do it=1, ntyp
            Do ia=1, natom
               if ( ityp(ia) /=it ) cycle

               coord_tmp(1:3) = matmul( rot_pr(:,:,isym), apos_t(ia,1:3) ) &
                    &         + tau(1:3,isym,BUCS)
               coord_tmp(1:3) = coord_tmp(1:3) - floor(coord_tmp(1:3))

               ja_found = 0
               Do ja=1, natom
                  dcoord(:) = apos_t(ja,1:3) - coord_tmp(:)

! === KT_mod === 2015/01/05
!                  dist = dcoord(1)**2 + dcoord(2)**2 + dcoord(3)**2
!                  dist = sqrt(dist)
!                  dist = dist - floor( dist +DELTA10 )

                  dcoord = abs( dcoord )
                  dcoord = dcoord - floor(dcoord + DELTA10)
                  dist = sum(dcoord)
! ============== 2015/01/05

                  if ( dist < criterion ) then
                     ja_found = ja
                     !  goto 100
                     exit
                  endif
               End do

100            continue
               !
               if ( ja_found ==0 ) then
                  write(*,*) 'kt: Not found symmetry', isym, ia
                  !stop
                  call phase_error_with_msg(nfout,'kt: Not found symmetry',__LINE__,__FILE__)
               endif
! ----
               if ( present(ion_chg) ) then
                  if ( abs( ion_chg(ia)-ion_chg(ja_found) ) > 1.0d-7 ) then
                     mag_sym_flag(isym) = .false.;  exit Loop_it
                  endif
               endif
! ----
               mag_tmp(1:3) = matmul( rot(:,:,isym), mag_loc(ia,1:3) )
#ifdef MOMENT_AS_PSEUDO_VECTOR
               if ( determinant < 0 ) mag_tmp = -mag_tmp
#endif
               dmag_m(1:3) = mag_tmp(1:3) - mag_loc(ja_found,1:3)
               dmag_p(1:3) = mag_tmp(1:3) + mag_loc(ja_found,1:3)
!
               c1 = abs( dmag_m(1) ) +abs( dmag_m(2) ) +abs( dmag_m(3) )
               c2 = abs( dmag_p(1) ) +abs( dmag_p(2) ) +abs( dmag_p(3) )
!
! ====== KT_mod === 2014/08/14
!               if ( c1 < criterion ) then
!                  mag_sym_flag(isym) = .true.
!                  exit
!               endif
!               if ( mag_sym_flag(isym) ) then
!                  if ( c1 > criterion ) then
!                     mag_sym_flag(isym) = .false.
!                  endif
!               endif
! --
               if ( c1 < criterion ) then
                  mag_sym_flag(isym) = .true.
                  magmom_dir_inversion_opr_flag(isym) = 1
                  exit
               endif
               if ( c2 < criterion ) then
                  mag_sym_flag(isym) = .true.
                  magmom_dir_inversion_opr_flag(isym) = -1
                  exit
               endif
               if ( mag_sym_flag(isym) ) then
                  if ( c1 > criterion .and. c2 > criterion ) then
                     mag_sym_flag(isym) = .false.
                  endif
               endif
! =============== 2014/08/14
            End do
         End do Loop_it
      End do
      deallocate( rot_pr )
    end subroutine check_if_op_has_magnetic_sym1

    subroutine check_if_op_has_magnetic_sym2( natom, apos, nsym, rot, &
         &                                    tau, mag_loc, mag_sym_flag, &
         &                                    magmom_dir_inversion_opr_flag, &
         &                                    ion_chg )
      integer, intent(in) :: natom, nsym
      logical, intent(inout) :: mag_sym_flag(nsym)
      integer, intent(inout) :: magmom_dir_inversion_opr_flag(nsym)
      real(kind=DP), intent(in) :: apos(natom,3), mag_loc(natom,3)
      real(kind=DP), optional, intent(in) :: ion_chg(natm)

! --------------------- kDEBUG --------------------------------- 20121020
!      real(kind=DP), intent(inout) :: rot(3,3,48), tau(3,48,CRDTYP)
      real(kind=DP), intent(inout) :: rot(3,3,nsym), tau(3,nsym,CRDTYP)
! --------------------- kDEBUG --------------------------------- 20121020

      real(kind=DP), parameter :: criterion = 1.0D-5
      real(kind=DP), allocatable :: apos_t(:,:)

      integer :: i, ia, ja, ja_found, it, isym, count
      real(kind=DP) :: coord_tmp(3), dcoord(3), dist
      real(kind=DP) :: mag_tmp(3), dmag_p(3), dmag_m(3)
      real(kind=DP) :: c1, c2, m_norm, determinant
      real(kind=DP), allocatable :: rot_pr(:,:,:)
!
      logical :: first
!
! -- init --
      allocate( rot_pr(3,3,nsym) ); rot_pr = 0.0d0
      call m_CS_op_in_PUCD( nfout, rot_pr, nsym, .true., &
           &                '***** Before considering magnetic symmetry (2) ****** ')

      allocate(apos_t(natom,3))
      apos_t(1:natm,1:3) = apos(1:natom,1:3)
      do ia = 1, natom
         do i = 1, 3
            apos_t(ia,i) = apos_t(ia,i) - floor(apos_t(ia,i))
         end do
      end do

      mag_sym_flag = .true.
      magmom_dir_inversion_opr_flag = 1

! -- begin --
      Do isym=1, nsym
#if 0
         if ( SpinOrbit_mode /= Neglected ) then
            if ( lattice_system_from_m_CS_SG == "cubic" ) then
               if ( ig01(isym) > 24 ) then
                  mag_sym_flag(isym) = .false. ;  cycle
               endif
            else if ( lattice_system_from_m_CS_SG == "hexagonal" ) then
               if ( ig01(isym) > 12 ) then
                  mag_sym_flag(isym) = .false. ;  cycle
               endif
            endif
         endif
#endif
         call calc_determinant( rot_pr(:,:,isym), determinant )

         first = .true.

         Loop_it : Do it=1, ntyp
            Do ia=1, natom
               if ( ityp(ia) /=it ) cycle

               m_norm = sqrt( mag_loc(ia,1)**2 +mag_loc(ia,2)**2 +mag_loc(ia,3)**2 )
               if ( m_norm < 1.0D-8 ) cycle

               coord_tmp(1:3) = matmul( rot_pr(:,:,isym), apos_t(ia,1:3) ) &
                    &         + tau(1:3,isym,BUCS)
               coord_tmp(1:3) = coord_tmp(1:3) - floor(coord_tmp(1:3))

               ja_found = 0
               Loop_ja : Do ja=1, natom
                  dcoord(:) = apos_t(ja,1:3) - coord_tmp(:)

! === KT_mod === 2015/01/05
!                  dist = dcoord(1)**2 + dcoord(2)**2 + dcoord(3)**2
!                  dist = sqrt(dist)
!                  dist = dist - floor( dist +DELTA10 )

                  dcoord = abs( dcoord )
                  dcoord = dcoord - floor(dcoord + DELTA10)
                  dist = sum(dcoord)
! ============== 2015/01/05

                  if ( dist < criterion ) then
                     ja_found = ja;  exit Loop_ja
                  endif
               End do Loop_ja

100            continue
               !
               if ( ja_found ==0 ) then
                  write(*,*) 'kt: Not found symmetry', isym, ia
                  !stop
                  call phase_error_with_msg(nfout,'kt: Not found symmetry',__LINE__,__FILE__)
               endif
! ----
               if ( present(ion_chg) ) then
                  if ( abs( ion_chg(ia)-ion_chg(ja_found) ) > 1.0d-5 ) then
                     mag_sym_flag(isym) = .false.;  exit Loop_it
                  endif
               endif
#if 0
               if ( abs(mag_loc(ia,1)-mag_loc(ja_found,1) )  > 1.0d-5 ) then
                  mag_sym_flag(isym) = .false.;  exit Loop_it
               endif
               if ( abs(mag_loc(ia,2)-mag_loc(ja_found,2) )  > 1.0d-5 ) then
                  mag_sym_flag(isym) = .false.;  exit Loop_it
               endif
               if ( abs(mag_loc(ia,3)-mag_loc(ja_found,3) )  > 1.0d-5 ) then
                  mag_sym_flag(isym) = .false.;  exit Loop_it
               endif
#endif

! --
               mag_tmp(1:3) = matmul( rot(:,:,isym), mag_loc(ia,1:3) )
#ifdef MOMENT_AS_PSEUDO_VECTOR
               if ( determinant < 0 ) mag_tmp = -mag_tmp
#endif
               dmag_m(1:3) = mag_tmp(1:3) - mag_loc(ja_found,1:3)
               dmag_p(1:3) = mag_tmp(1:3) + mag_loc(ja_found,1:3)
!
               c1 = abs( dmag_m(1) ) +abs( dmag_m(2) ) +abs( dmag_m(3) )
               c2 = abs( dmag_p(1) ) +abs( dmag_p(2) ) +abs( dmag_p(3) )

               if ( c1 > criterion .and. c2 > criterion ) then
                  mag_sym_flag(isym) = .false.;  exit Loop_it
               endif
               if ( first ) then
                  if ( c1 < criterion ) then
                     magmom_dir_inversion_opr_flag(isym) = 1
                  else if ( c2 < criterion ) then
                     magmom_dir_inversion_opr_flag(isym) = -1
                  endif
                  first = .false.
               endif

               if ( magmom_dir_inversion_opr_flag(isym) == 1 &
                    &      .and. c2 < criterion ) then
                  mag_sym_flag(isym) = .false.;  exit Loop_it
               endif
               if ( magmom_dir_inversion_opr_flag(isym) == -1 &
                    &      .and. c1 < criterion ) then
                  mag_sym_flag(isym) = .false.;   exit Loop_it
               endif

            End do
         End do Loop_it
      End do
!
      deallocate( rot_pr )

!      write(nfout,*) '!*** magnetic symmetry info'
!      Do isym=1, nsym
!         write(nfout,*) isym, mag_sym_flag(isym), magmom_dir_inversion_opr_flag(isym)
!      End do

    end subroutine check_if_op_has_magnetic_sym2

    subroutine check_if_op_has_magnetic_sym0( natom, apos, nsym, rot, &
         &                                    tau, mag_loc, mag_sym_flag, &
         &                                    ion_chg )
      integer, intent(in) :: natom, nsym
      logical, intent(inout) :: mag_sym_flag(nsym)
      real(kind=DP), intent(in) :: apos(natom,3), mag_loc(natom,1)
      real(kind=DP), optional, intent(in) :: ion_chg(natm)

! --------------------- kDEBUG --------------------------------- 20121020
!      real(kind=DP), intent(inout) :: rot(3,3,48), tau(3,48,CRDTYP)
      real(kind=DP), intent(inout) :: rot(3,3,nsym), tau(3,nsym,CRDTYP)
! --------------------- kDEBUG --------------------------------- 20121020

      real(kind=DP), parameter :: criterion = 1.0D-5
      real(kind=DP), allocatable :: apos_t(:,:)

      integer :: i, ia, ja, ja_found, it, isym, count
      real(kind=DP) :: coord_tmp(3), dcoord(3), dist
      real(kind=DP) :: c1, c2, m_norm
      real(kind=DP), allocatable :: rot_pr(:,:,:)
!
      logical :: first
!
! -- init --
      allocate( rot_pr(3,3,nsym) ); rot_pr = 0.0d0
      call m_CS_op_in_PUCD( nfout, rot_pr, nsym, .true., &
           &                '***** Before considering magnetic symmetry ****** ')

      allocate(apos_t(natom,3))
      apos_t(1:natm,1:3) = apos(1:natom,1:3)
      do ia = 1, natom
         do i = 1, 3
            apos_t(ia,i) = apos_t(ia,i) - floor(apos_t(ia,i))
         end do
      end do

      mag_sym_flag = .true.

! -- begin --
      Do isym=1, nsym
         first = .true.

         Loop_it : Do it=1, ntyp
            Do ia=1, natom
               if ( ityp(ia) /=it ) cycle

!               m_norm = sqrt( mag_loc(ia,1)**2 +mag_loc(ia,2)**2 +mag_loc(ia,3)**2 )
               m_norm = abs( mag_loc(ia,1) )
               if ( m_norm < 1.0D-8 ) cycle

               coord_tmp(1:3) = matmul( rot_pr(:,:,isym), apos_t(ia,1:3) ) &
                    &         + tau(1:3,isym,BUCS)
               coord_tmp(1:3) = coord_tmp(1:3) - floor(coord_tmp(1:3))

               ja_found = 0
               Loop_ja : Do ja=1, natom
                  dcoord(:) = apos_t(ja,1:3) - coord_tmp(:)

! === KT_mod === 2015/01/05
!                  dist = dcoord(1)**2 + dcoord(2)**2 + dcoord(3)**2
!                  dist = sqrt(dist)
!                  dist = dist - floor( dist +DELTA10 )

                  dcoord = abs( dcoord )
                  dcoord = dcoord - floor(dcoord + DELTA10)
                  dist = sum(dcoord)
! ============== 2015/01/05

                  if ( dist < criterion ) then
                     ja_found = ja;  exit Loop_ja
                  endif
               End do Loop_ja

100            continue
               !
               if ( ja_found ==0 ) then
                  write(*,*) 'kt: Not found symmetry', isym, ia
                  !stop
                  call phase_error_with_msg(nfout,'kt: Not found symmetry',__LINE__,__FILE__)
               endif
! ----
               if ( present(ion_chg) ) then
                  if ( abs( ion_chg(ia)-ion_chg(ja_found) ) > 1.0d-7 ) then
                     mag_sym_flag(isym) = .false.;  exit Loop_it
                  endif
               endif
! --
               if ( abs( mag_loc(ia,1)-mag_loc(ja_found,1) ) > 1.0d-7 ) then
                  mag_sym_flag(isym) = .false.;  exit Loop_it
               endif

            End do
         End do Loop_it
      End do
!
      deallocate( rot_pr )

!      write(nfout,*) '!*** magnetic symmetry info'
!      Do isym=1, nsym
!         write(nfout,*) isym, mag_sym_flag(isym)
!      End do

    end subroutine check_if_op_has_magnetic_sym0

    subroutine resize_matrix_size( nsym, nsym_with_mag )
      integer, intent(inout) :: nsym, nsym_with_mag
      real(kind=DP), allocatable :: rot_tmp(:,:,:), tau_tmp(:,:,:)
      integer, allocatable :: magmom_dir_inversion_opr_flag_tmp(:)
!
      allocate( rot_tmp(3,3,nsym) );      rot_tmp = 0.0d0
      allocate( tau_tmp(3,nsym,CRDTYP) ); tau_tmp = 0.0d0
!
      rot_tmp = op;  tau_tmp = tau
      deallocate( op );  deallocate( tau )
!
      allocate( op(3,3,nsym_with_mag ) );       op = 0.0d0
      allocate( tau(3,nsym_with_mag,CRDTYP ) ); tau = 0.0d0
!
      op(:,:,1:nsym_with_mag) = rot_tmp(:,:,1:nsym_with_mag)
      tau(:,1:nsym_with_mag,:) = tau_tmp(:,1:nsym_with_mag,:)
!
      deallocate( rot_tmp ); deallocate( tau_tmp )
!
      if ( noncol ) then
! === KT_add === 2014/08/14
         allocate( magmom_dir_inversion_opr_flag_tmp( nsym ) )
         magmom_dir_inversion_opr_flag_tmp = 0
         
         magmom_dir_inversion_opr_flag_tmp = magmom_dir_inversion_opr_flag
         deallocate( magmom_dir_inversion_opr_flag )

         allocate( magmom_dir_inversion_opr_flag(nsym_with_mag) )
         magmom_dir_inversion_opr_flag = 0
         
         magmom_dir_inversion_opr_flag(1:nsym_with_mag) &
              &         = magmom_dir_inversion_opr_flag_tmp(1:nsym_with_mag)
         deallocate( magmom_dir_inversion_opr_flag_tmp )
      endif
! ============== 2014/08/14

      nsym = nsym_with_mag

    end subroutine resize_matrix_size

    subroutine set_magnetic_tspace_gnerators( nsym, nopr, rot, tau )
      integer, intent(in) :: nsym
      integer, intent(in) :: nopr(48)
      real(kind=DP), intent(in) :: rot(3,3,nsym), tau(3,nsym,CRDTYP)
      
      integer :: iptab(nsym,nsym)
      integer :: ng, ig(3)
      character(len=9) :: system

      system = pg_symbol_system

      call set_mini_product_table( nsym, rot, tau, iptab )
      call search_generators( nsym, iptab, ng, ig )
      call set_generators( ng, ig, nopr )
      call write_tspace_generators(system)

    end subroutine set_magnetic_tspace_gnerators

! --
    subroutine set_mini_product_table( nsym, rot, tau, iptab )
      integer, intent(in) :: nsym
      integer, intent(out) :: iptab(nsym,nsym)
      real(kind=DP), intent(in) :: rot(3,3,nsym), tau(3,nsym,CRDTYP)
      
      real(kind=DP) :: rot_pr(3,3,48)
      real(kind=DP) :: op_tmp(3,3), tau_tmp(3)
      real(kind=DP) :: c1, c2, cx, cy, cz
      real(kind=DP), parameter :: eps = 1.d-4

      integer :: isym, jsym, ksym
      integer :: ksym_found
      integer :: m1, m2, m3
      integer :: nx, ny, nz

      iptab = 0

      call m_CS_op_in_PUCD( nfout, rot_pr, nsym, .false. )

      Do jsym=1, nsym
         Do isym=1, nsym
            
            op_tmp = 0.0d0; tau_tmp = 0.0d0
            Do m1=1, 3
               Do m2=1, 3
                  Do m3=1, 3
                     op_tmp(m1,m2) = op_tmp(m1,m2) &
                          & + rot_pr(m1,m3,isym) *rot_pr(m3,m2,jsym) 
                  End do
               End Do
            End do
!            Do m1=1, 3
!               Do m2=1, 3
!                  tau_tmp(m1) = tau_tmp(m1) &
!                       &       + rot_pr(m1,m2,isym)*tau(m2,jsym,BUCS)
!               End do
!               tau_tmp(m1) = tau_tmp(m1) + tau(m1,isym,BUCS)
!            End do
! ---------------------------------
            ksym_found = 0
! ---------------------------------

!            write(*,*) 'isym jsym ', isym, jsym
!            write(*,*) 'op_tmp ', op_tmp(1,1), op_tmp(1,2), op_tmp(1,3)
!            write(*,*) 'op_tmp ', op_tmp(2,1), op_tmp(2,2), op_tmp(2,3)
!            write(*,*) 'op_tmp ', op_tmp(3,1), op_tmp(3,2), op_tmp(3,3)
!            write(*,*) 'tau_tmp ', tau_tmp(1), tau_tmp(2), tau_tmp(3)


            Do ksym=1, nsym
               c1 = 0.0d0
               Do m1=1, 3
                  Do m2=1, 3
                     c1 = c1 + abs( op_tmp(m1,m2) - rot_pr(m1,m2,ksym) )
                  End do
               End do

               if ( c1 < eps ) then
                  Do nx=-1, 1
                     Do ny=-1, 1
                        Do nz=-1, 1
!                           cx = tau_tmp(1) - tau(1,ksym,BUCS) +nx
!                           cy = tau_tmp(2) - tau(2,ksym,BUCS) +ny
!                           cz = tau_tmp(3) - tau(3,ksym,BUCS) +nz

                           cx = tau(1,jsym,BUCS) +nx
                           cy = tau(2,jsym,BUCS) +ny
                           cz = tau(3,jsym,BUCS) +nz
                           Do m1=1, 3
                              tau_tmp(m1) = rot_pr(m1,1,isym)*cx &
                                   &       +rot_pr(m1,2,isym)*cy &
                                   &       +rot_pr(m1,3,isym)*cz &
                                   &       +tau(m1,isym,BUCS)
                           End do
                           cx = tau_tmp(1) - tau(1,ksym,BUCS)
                           cy = tau_tmp(2) - tau(2,ksym,BUCS)
                           cz = tau_tmp(3) - tau(3,ksym,BUCS)
                           
                           c2 = abs(cx) + abs(cy) + abs(cz)

                           if ( c2 < eps ) then
                              ksym_found = ksym
                              goto 1000
                           endif
                        End Do
                     End Do
                  End Do
               endif
            End Do

1000        continue
            iptab(isym,jsym) = ksym_found
!            write(*,*) 'isym jsym ', isym, jsym, ksym_found
         End do
      End do

    end subroutine set_mini_product_table

    subroutine search_generators( nsym, iptab, ng, ig )
      integer, intent(in) :: nsym, iptab(nsym,nsym)
      integer, intent(out) :: ng, ig(3)
      
      integer :: i,j,k
      logical :: fexist(1:nsym)
      integer :: ii

! --------------
      ng = 1
      do i=1,nsym
         fexist(1:nsym) = .false.
         fexist(i) = .true.
         if (group_is_the_same(nsym,fexist,iptab)) then
            ig(ng) = i
            return
         end if
      end do
! --------------
      ng = 2
      do i=2,nsym
         do j=i+1,nsym
            fexist(1:nsym) = .false.
            fexist(i) = .true.
            fexist(j) = .true.
            if (group_is_the_same(nsym,fexist,iptab)) then
               ig(1)  = i
               ig(ng) = j
               return
            end if
         end do
      end do
! ------------
      ng = 3
      do i=2,nsym
         do j=i+1,nsym
            do k=j+1,nsym
               fexist(1:nsym) = .false.
               fexist(i) = .true.
               fexist(j) = .true.
               fexist(k) = .true.
               if (group_is_the_same(nsym,fexist,iptab)) then
                  ig(1)  = i
                  ig(2)  = j
                  ig(ng) = k
                  return
               end if
            end do
         end do
      end do

      !stop 'Mag: Set of generators of the space group was not found.'
      call phase_error_with_msg(nfout,'Mag: Set of generators of the space group was not found.',__LINE__,__FILE__)

    end subroutine search_generators

    logical function group_is_the_same( nsym, fexist, iptab)
      integer, intent(in) :: nsym
      integer, intent(in) :: iptab(nsym,nsym)
      logical, intent(inout) :: fexist(nsym)

      integer :: i,j
      integer :: n,no
      logical :: flag(nsym)

      n=0
      no=-1 
      do while(n > no)
         flag(1:nsym) = .false.
         do j=1,nsym
            do i=1,nsym
               if(fexist(i).and.fexist(j)) flag(iptab(i,j)) = .true.
            end do
         end do
         do i=1,nsym
            if(flag(i)) fexist(i) = .true.
         end do
         no = n
         n = 0
         do i=1,nsym
            if(fexist(i)) n=n+1
         end do
      end do
      if(n==nsym) then
         group_is_the_same = .true.
      else
         group_is_the_same = .false.
      end if

    end function group_is_the_same

    subroutine set_generators( ng, ig, nopr )
      integer, intent(in) :: ng, ig(3)
      integer, intent(in) :: nopr(48)

      integer :: i,j,k,n
      real(kind=DP) :: t,r,tb(3)
      real(kind=DP), parameter :: eps = 1.d-4

      ngen = ng
      call dealloc_igen_jgen
      call alloc_igen_jgen

      do i=1,ngen
         igen(i) = nopr(ig(i))

         tb(:) = tau(:,ig(i),BUCS)

         do j=1,3
            t = tb(j)
            do k=1,20
               r=t*k
               if(abs(nint(r)-r)<eps) then
                  jgen(1,j,i) = nint(r)
                  jgen(2,j,i) = k
                  exit
               end if
            end do
         end do
      end do
      
    end subroutine set_generators

    subroutine set_translations_zero
      integer :: i,j
      do i=1,ngen
         do j=1,3
            jgen(1,j,i) = 0
            jgen(2,j,i) = 1
         end do
      end do
    end subroutine set_translations_zero

    subroutine write_tspace_generators(system)
      character(len=9), intent(in) :: system
      
      integer :: i
      
      write(nfout,*) '----------------------------------- '
      write(nfout,'("TSPACE Generators with Magnetic symmetry :")')
      
      if (system == 'cubic') then
         do i=1,ngen
            write(nfout,'("igen,jgen(2,3)=",i2,"(",a5,")",3(3x,i2,"/",i2))') igen(i),oh(igen(i)),jgen(:,:,i)
         end do
      else
         do i=1,ngen
            write(nfout,'("igen,jgen(2,3)=",i2,"(",a5,")",3(3x,i2,"/",i2))') igen(i),d6h(igen(i)),jgen(:,:,i)
         end do
      end if

    end subroutine write_tspace_generators

  end subroutine m_CS_set_Magnetic_Sym

! ---------------------------------------------------------------------------
  subroutine m_CS_set_inverse_operation
    integer :: iopr1, iopr2
    real(kind=DP) :: ss(3,3)

    do iopr1=1,nopr
       do iopr2=1,nopr
          ss = matmul(op(:,:,iopr1),op(:,:,iopr2))
          if(abs(ss(1,1)-1.d0)<DELTA07 .and. &
          & abs(ss(2,2)-1.d0)<DELTA07 .and. &
          & abs(ss(3,3)-1.d0)<DELTA07 .and. &
          & abs(ss(1,2))<DELTA07 .and. &
          & abs(ss(1,3))<DELTA07 .and. &
          & abs(ss(2,3))<DELTA07) then
             invop(iopr1) = iopr2
             exit
          end if
       end do
    end do

  end subroutine m_CS_set_inverse_operation

  subroutine m_CS_chk_determinant_op
    integer :: iopr
    real(kind=DP) :: determinant

    do iopr=1,nopr
       call calc_determinant( op(:,:,iopr), determinant )
       determinant_op(iopr) = nint(determinant)
    end do
  end subroutine m_CS_chk_determinant_op

#if 0
  subroutine m_CS_set_op_spinor
    integer :: i, j
    real(kind=DP) :: k1, k2, k3, ux, uy, uz, c1, c2, c3
    real(kind=DP) :: sinth, costh, theta, s1, determinant
!
    real(kind=DP), parameter :: delta = 1.0D-4
    complex(kind=CMPLDP), parameter :: zi = ( 0.0d0, 1.0d0 )
!
    real(kind=DP), allocatable :: op_work(:,:,:)
!
    allocate( op_work(3,3,nopr) );     op_work = op
    if ( .not. allocated( op_spinor ) ) allocate( op_spinor(2,2,nopr) )

    Do i=1, nopr
       call calc_determinant( op(:,:,i), determinant )
       if ( determinant < 0 ) then
          op_work(1,1,i) = -op_work(1,1,i)
          op_work(2,2,i) = -op_work(2,2,i)
          op_work(3,3,i) = -op_work(3,3,i)
       endif

       costh = ( op_work(1,1,i) +op_work(2,2,i) +op_work(3,3,i) -1.0d0 ) /2.0d0
       sinth = sqrt( 1.0d0 -costh**2 )

       theta = acos( costh )
!
       if ( sinth > delta ) then
          k1 = ( op_work(3,2,i) -op_work(2,3,i) ) /2.0d0
          k2 = ( op_work(1,3,i) -op_work(3,1,i) ) /2.0d0
          k3 = ( op_work(2,1,i) -op_work(1,2,i) ) /2.0d0

          ux = k1 /sinth;       uy = k2 /sinth;         uz = k3 /sinth
       else
          if ( costh > 1.0 -delta ) then
             ux = 0.0d0;  uy = 0.0d0;   uz = 1.0d0
             theta = 0.0d0
          else if ( costh < -1.0 +delta ) then
             k1 = ( op_work(1,1,i) + 1.d0 )/2.0d0
             k2 = ( op_work(2,2,i) + 1.d0 )/2.0d0
             k3 = ( op_work(3,3,i) + 1.d0 )/2.0d0

             ux = sqrt(k1);   uy = sqrt(k2);     uz = sqrt(k3)

             if ( uz > delta ) then
                if ( op_work(1,3,i) < 0 )  ux = -ux
                if ( op_work(2,3,i) < 0 )  uy = -uy
             else
                if ( op_work(1,2,i) < 0 )  uy = -uy
             endif

          endif
       endif

#if 0
       write(*,*) "i = ", i, "costh = ", costh, "sinth = ", sinth
       write(*,'(4(A,F10.2))') "Axis: ux = ", ux,  ", uy = ", uy,  ", uz = ", uz, &
            &                  ", Angle = ", theta /PAI *180.0d0
       write(*,*)
#endif

       c1 = cos( theta /2.0d0 );   s1 = sin( theta /2.0d0 );

       op_spinor(1,1,i) = c1 -zi *uz *s1
       op_spinor(1,2,i) = ( -zi *ux -uy ) *s1
       op_spinor(2,1,i) = ( -zi *ux +uy ) *s1
       op_spinor(2,2,i) = c1 +zi *uz *s1
!
       if ( determinant < 0 ) op_spinor(:,:,i) = zi *op_spinor(:,:,i)
    End Do
!
    if ( iprisym > 1 ) then
       write(nfout,*) '*** symmetry operation for spinor ***'
       Do i=1, nopr
          write(nfout,*) ' #symmetry op. = ', i
          write(nfout,'(A,F8.4,A,F8.4,2A,F8.4,A,F8.4,A)') &
               &                '( ', real(op_spinor(1,1,i)), ', ', &
               &                      aimag(op_spinor(1,1,i)), ' I ) ',  &
               &                '( ',real(op_spinor(1,2,i)), ', ', &
               &                      aimag(op_spinor(1,2,i)), ' I )'
          write(nfout,'(A,F8.4,A,F8.4,2A,F8.4,A,F8.4,A)') &
               &                '( ', real(op_spinor(2,1,i)), ', ', &
               &                      aimag(op_spinor(2,1,i)), ' I ) ',  &
               &                '( ',real(op_spinor(2,2,i)), ', ', &
               &                      aimag(op_spinor(2,2,i)), ' I )'
       End Do
    endif
    deallocate( op_work )

  contains

    subroutine calc_determinant( a, determinant )
      real(kind=DP), intent(in) :: a(3,3)
      real(kind=DP), intent(out) :: determinant
      determinant = a(1,1)*( a(2,2)*a(3,3) -a(2,3)*a(3,2) ) &
          &       -a(1,2)*( a(2,1)*a(3,3) -a(2,3)*a(3,1) ) &
           &       +a(1,3)*( a(2,1)*a(3,2) -a(2,2)*a(3,1) )
    end subroutine calc_determinant

  end subroutine m_CS_set_op_spinor
#endif
  
  subroutine calc_determinant( a, determinant )
    real(kind=DP), intent(in) :: a(3,3)
    real(kind=DP), intent(out) :: determinant
    determinant = a(1,1)*( a(2,2)*a(3,3) -a(2,3)*a(3,2) ) &
         &       -a(1,2)*( a(2,1)*a(3,3) -a(2,3)*a(3,1) ) &
         &       +a(1,3)*( a(2,1)*a(3,2) -a(2,2)*a(3,1) )
  end subroutine calc_determinant

  subroutine m_CS_gen_opr_spinor_full( system, nsym, op_spinor )
    character(len=9), intent(in) :: system
    integer, intent(in) :: nsym
    complex(kind=CMPLDP), intent(out) :: op_spinor(2,2,nsym)

    if ( system .eq. 'cubic' ) then
       call cubic_point_group
    else if ( system .eq. 'hexagonal' ) then
       call hexagonal_point_group
    end if

  contains    

    subroutine cubic_point_group
      integer :: n
      real(kind=DP) :: direc(3), angle

      op_spinor = 0.0d0
! E
      n = 1;
      direc(1) = 0.0d0;  direc(2) = 0.0d0;   direc(3) = 1.0d0;  angle = 0.0d0
      call set_rot_mat( direc, angle, op_spinor(:,:,n) )
! C2xyz
      Do n=2, 4
         direc = 0.0d0; angle = PAI2 /2.0d0
         if ( n==2 ) direc(1) = 1.0d0
         if ( n==3 ) direc(2) = 1.0d0
         if ( n==4 ) direc(3) = 1.0d0
         call set_rot_mat( direc, angle, op_spinor(:,:,n) )
      End Do
! C3+
      n = 5
      direc = 1.0d0;  angle = PAI2 /3.0d0
      call set_rot_mat( direc, angle, op_spinor(:,:,n) )
      Do n=6, 8
         direc = -1.0d0;  angle = PAI2 /3.0d0
         if ( n==6 ) direc(3) = 1.0d0
         if ( n==7 ) direc(1) = 1.0d0
         if ( n==8 ) direc(2) = 1.0d0
         call set_rot_mat( direc, angle, op_spinor(:,:,n) )
      End Do
! C3-
      n = 9
      direc = 1.0d0;  angle = -PAI2 /3.0d0
      call set_rot_mat( direc, angle, op_spinor(:,:,n) )
      Do n=10, 12
         direc = -1.0d0;  angle = -PAI2 /3.0d0
         if ( n==10 ) direc(3) = 1.0d0
         if ( n==11 ) direc(1) = 1.0d0
         if ( n==12 ) direc(2) = 1.0d0
         call set_rot_mat( direc, angle, op_spinor(:,:,n) )
      End Do
! C2_*
      Do n=13, 14
         direc(1) = 1.0d0;  direc(3) = 0.0d0;  angle = PAI2 /2.0
         if ( n==13 ) direc(2) =  1.0d0
         if ( n==14 ) direc(2) = -1.0d0
         call set_rot_mat( direc, angle, op_spinor(:,:,n) )
      End Do
      Do n=15, 17, 2
         direc(3) = 1.0d0;  direc(2) = 0.0d0;  angle = PAI2 /2.0
         if ( n==15 ) direc(1) =  1.0d0
         if ( n==17 ) direc(1) = -1.0d0
         call set_rot_mat( direc, angle, op_spinor(:,:,n) )
      End Do
      Do n=16, 18, 2
         direc(1) = 0.0d0;  direc(2) = 1.0d0;  angle = PAI2 /2.0
         if ( n==16 ) direc(3) =  1.0d0
         if ( n==18 ) direc(3) = -1.0d0
         call set_rot_mat( direc, angle, op_spinor(:,:,n) )
      End Do
! C4+       
      Do n=19, 21
         direc = 0.0d0;  angle = PAI2 /4.0d0
         if ( n==19 ) direc(1) = 1.0d0
         if ( n==20 ) direc(2) = 1.0d0
         if ( n==21 ) direc(3) = 1.0d0
         call set_rot_mat( direc, angle, op_spinor(:,:,n) )
      End Do
! C4-
      Do n=22, 24
         direc = 0.0d0;  angle = -PAI2 /4.0d0
         if ( n==22 ) direc(1) = 1.0d0
         if ( n==23 ) direc(2) = 1.0d0
         if ( n==24 ) direc(3) = 1.0d0
         call set_rot_mat( direc, angle, op_spinor(:,:,n) )
      End Do
    !
      Do n=1, 24
         op_spinor(:,:,n+24) = op_spinor(:,:,n)
      End Do
    end subroutine cubic_point_group

    subroutine hexagonal_point_group
      integer :: n
      real(kind=DP) :: direc(3), angle

      op_spinor = 0.0d0
! E
      n = 1;
      direc(1) = 0.0d0;  direc(2) = 0.0d0;   direc(3) = 1.0d0;  angle = 0.0d0
      call set_rot_mat( direc, angle, op_spinor(:,:,n) )
! C6+
      n = 2;
      direc(1) = 0.0d0;  direc(2) = 0.0d0;   direc(3) = 1.0d0;  angle = PAI2 /6.0d0
      call set_rot_mat( direc, angle, op_spinor(:,:,n) )
! C3+
      n = 3;
      direc(1) = 0.0d0;  direc(2) = 0.0d0;   direc(3) = 1.0d0;  angle = PAI2 /3.0d0
      call set_rot_mat( direc, angle, op_spinor(:,:,n) )
! C2
      n = 4;
      direc(1) = 0.0d0;  direc(2) = 0.0d0;   direc(3) = 1.0d0;  angle = PAI2 /2.0d0
      call set_rot_mat( direc, angle, op_spinor(:,:,n) )
! C3-
      n = 5;
      direc(1) = 0.0d0;  direc(2) = 0.0d0;   direc(3) = 1.0d0;  angle = -PAI2 /3.0d0
      call set_rot_mat( direc, angle, op_spinor(:,:,n) )
! C6-
      n = 6;
      direc(1) = 0.0d0;  direc(2) = 0.0d0;   direc(3) = 1.0d0;  angle = -PAI2 /6.0d0
      call set_rot_mat( direc, angle, op_spinor(:,:,n) )
! C2 (ab plane, 90deg. direc)
      n = 7;
      direc(1) = 0.0d0;  direc(2) = 1.0d0;   direc(3) = 0.0d0;  angle = PAI2 /2.0d0
      call set_rot_mat( direc, angle, op_spinor(:,:,n) )
! C2 (ab plane, 30deg. direc)
      n = 8;
      direc(1) = sqrt(3.d0);  direc(2) = 1.d0;   direc(3) = 0.0d0;  angle = PAI2 /2.0d0
      call set_rot_mat( direc, angle, op_spinor(:,:,n) )
! C2 (ab plane, 150deg. direc)
      n = 9;
      direc(1) =-sqrt(3.d0);  direc(2) = 1.d0;   direc(3) = 0.0d0;  angle = PAI2 /2.0d0
      call set_rot_mat( direc, angle, op_spinor(:,:,n) )
! C2 (ab plane, 0deg. direc)
      n = 10;
      direc(1) = 1.0d0;  direc(2) = 0.d0;   direc(3) = 0.0d0;  angle = PAI2 /2.0d0
      call set_rot_mat( direc, angle, op_spinor(:,:,n) )
! C2 (ab plane, 120deg. direc)
      n = 11;
      direc(1) = -1.d0;  direc(2) = sqrt(3.d0);  direc(3) = 0.0d0;  angle = PAI2 /2.0d0
      call set_rot_mat( direc, angle, op_spinor(:,:,n) )
! C2 (ab plane, 60deg. direc)
      n = 12;
      direc(1) =  1.d0;  direc(2) = sqrt(3.d0);  direc(3) = 0.0d0;  angle = PAI2 /2.0d0
      call set_rot_mat( direc, angle, op_spinor(:,:,n) )

      Do n=1, 12
         op_spinor(:,:,n+12) = op_spinor(:,:,n)
      End Do
    end subroutine hexagonal_point_group

    subroutine set_rot_mat( direc, angle, mat )
      real(kind=DP), intent(in) :: direc(3), angle
      complex(kind=CMPLDP), intent(out) :: mat(2,2)

      real(kind=DP) :: s1, c1, norm, vec(3)
      
      norm = sqrt( direc(1)**2 +direc(2)**2 +direc(3)**2 )
      vec(:) = direc(:) /norm

      c1 = cos(angle/2.d0);  s1 = sin(angle/2.d0)
      mat(1,1) = c1 +zi *vec(3) *s1
      mat(1,2) = ( zi *vec(1) +vec(2) ) *s1
      mat(2,1) = ( zi *vec(1) -vec(2) ) *s1
      mat(2,2) = c1 -zi *vec(3) *s1
    end subroutine set_rot_mat

  end subroutine m_CS_gen_opr_spinor_full
  
end module m_CS_Magnetic

!=======================================================================
!
!  SOFTWARE NAME : PHASE (ver. 6.01)
!
!  MODULE: m_ELF
!
!  AUTHOR(S): T. Yamamoto   April/30/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!
module m_ELF
!$$#ifndef PARA3D
! $Id: m_ELF.f90 376 2014-06-17 07:48:31Z jkoga $
  use m_PlaneWaveBasisSet,    only : ngabc,gr_l,igfp_l,kg,kgp,kgp_reduced, igf,iba,nbase,ngpt_l
  use m_PseudoPotential,      only : iatomn,ival
  use m_Crystal_Structure,    only : nopr,tau,altv,rltv,univol
  use m_Kpoints,              only : kv3
  use m_Ionic_System,         only : natm2, m_IS_pack_all_ions_in_uc
  use m_Charge_Density,       only : chgq_l
  use m_Electronic_Structure, only : occup_l,zaj_l
  use m_FFT,                  only : fft_box_size_CD,nfftp &
       &                           , m_FFT_CD_inverse &
       &                           , m_FFT_CD_direct &
       &                           , m_FFT_alloc_CD_box &
       &                           , m_FFT_dealloc_CD_box
  use m_FFT,                  only : fft_box_size_WF,nfft &
       &                           , m_FFT_WF &
       &                           , m_FFT_alloc_WF_work &
       &                           , m_FFT_dealloc_WF_work
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,   only : ipri,nspin,kimg,af,nel_Ylm,elf_filetype,elf_title
  use m_Const_Parameters,     only : BUCS,DP,DOWN,UP &
       &                           , PAI,PAI2,SKIP,DENSITY_ONLY,CUBE &
       &                           , DIRECT,INVERSE,OFF,ON &
       &                           , unit_conv_byname, ELECTRON
  use m_Parallelization,      only : MPI_CommGroup,ista_kngp,iend_kngp,npes,mype,ierr &
       &                           , ista_sfftp,iend_sfftp,ista_sfftph,iend_sfftph &
       &                           , nis_sfftp,nie_sfftp,nel_sfftp,idisp_sfftp,np_sfftp,mp_sfftp &
       &                           , map_k,myrank_k,np_e,ista_e,iend_e,istep_e,map_z
  use mpi
  implicit none

!  include 'mpif.h'

  real(kind=DP),private,allocatable, dimension(:)   :: chden_l ! d(ista_sfftp:iend_sfftp)
  real(kind=DP),private,allocatable, dimension(:)   :: keden_l ! d(ista_sfftp:iend_sfftp)
  real(kind=DP),private,allocatable, dimension(:)   :: grho2_l ! d(ista_sfftp:iend_sfftp)
  real(kind=DP),private,allocatable, dimension(:)   :: ita_l ! d(ista_sfftp:iend_sfftp)
  real(kind=DP),private,allocatable, dimension(:)   :: ita   ! d(nfftp)
  logical,      private, dimension(3)               :: lmn_even
  integer,private, allocatable, dimension(:) :: inx,jnx,knx ! d(ista_sfftp:iend_sfftp)

contains

  subroutine m_ELF_alloc()
    integer :: idp,nlp,nmp,nnp,nd2p,n,nn,i,j,k

    allocate(inx(ista_sfftp:iend_sfftp))
    allocate(jnx(ista_sfftp:iend_sfftp))
    allocate(knx(ista_sfftp:iend_sfftp))

    idp  = fft_box_size_CD(1,0)
    nlp  = fft_box_size_CD(1,1)
    nmp  = fft_box_size_CD(2,1)
    nnp  = fft_box_size_CD(3,1)
    nd2p = fft_box_size_CD(2,0)

    do n = ista_sfftp, iend_sfftp
       nn = (n+kimg-1)/kimg
       i  = mod(nn,idp)
       j  = mod((nn-1)/idp,nd2p) + 1
       k  = (nn - (j-1)*idp - i)/(idp*nd2p) + 1
       inx(n) = i - 1;  if(2*inx(n) > nlp) inx(n) = inx(n) - nlp
       jnx(n) = j - 1;  if(2*jnx(n) > nmp) jnx(n) = jnx(n) - nmp
       knx(n) = k - 1;  if(2*knx(n) > nnp) knx(n) = knx(n) - nnp
    end do

    allocate(chden_l(ista_sfftp:iend_sfftp))
    allocate(keden_l(ista_sfftp:iend_sfftp))
    allocate(grho2_l(ista_sfftp:iend_sfftp))
    allocate(ita_l(ista_sfftp:iend_sfftp))
    allocate(ita(nfftp))
  end subroutine m_ELF_alloc

  subroutine m_ELF_dealloc()
    deallocate(inx)
    deallocate(jnx)
    deallocate(knx)
    deallocate(chden_l)
    deallocate(keden_l)
    deallocate(grho2_l)
    deallocate(ita_l)
    deallocate(ita)
  end subroutine m_ELF_dealloc

  subroutine m_ELF_cnstrct_elf(nfout)
    integer, intent(in) :: nfout

    real(kind=DP), parameter :: cf = 7.15294982885971d0 ! 3.d-1*(3.d0*PAI**2)**(2.d0/3.d0)
    real(kind=DP), parameter :: third5 = 5.d0/3.d0
    real(kind=DP) :: d,tp,th,xs
    integer :: i

    call map_charge_onto_a_fft_box(nspin,chgq_l,chden_l) ! chgq_l -> chden_l
    call m_ELF_kinetic_energy_density(nfout,keden_l)
    call m_ELF_gradRho2(grho2_l)

    call m_FFT_alloc_CD_box
    call m_FFT_CD_inverse(nfout,chden_l)  ! G space --> R space
    call m_FFT_dealloc_CD_box

    ita_l = 0.d0
    do i=ista_sfftp,iend_sfftp
       d = chden_l(i)
       if(d >= 1.d-30) then
          tp = keden_l(i) - 0.125d0*grho2_l(i)/d
          th = cf*d**third5
          xs = tp/th
          ita_l(i) = 1.d0/(1.d0+xs*xs)
       end if
    end do

  end subroutine m_ELF_cnstrct_elf

  subroutine m_ELF_wd_elf(nfout,nfelf)
    integer, intent(in) :: nfout,nfelf

    integer :: i,j,k, idp, nlp, nmp, nnp, nlphf,inew,jnew,knew,ip,mmp
    real(kind=DP),allocatable,dimension(:,:,:) :: wkelf
    real(kind=DP) :: x,y,z
    real(kind=DP),allocatable,dimension(:,:) :: cps_full
    integer, allocatable,dimension(:) :: ityp_full
    real(kind=DP), dimension(3) :: r_wk
    integer :: ucret, m

    real(kind=DP) :: ita_mpi(nfftp)

    if(npes >= 2) then
       ita = 0.d0
       ita_mpi = 0.d0
       do i=ista_sfftp,iend_sfftp
          ita_mpi(i) = ita_l(i)
       end do
       call mpi_allreduce(ita_mpi,ita,nfftp,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr) ! MPI
    else
       ita = ita_l
    end if

    if(mype /= 0) return

    idp = fft_box_size_CD(1,0)
    mmp = fft_box_size_CD(2,0)
    nlp = fft_box_size_CD(1,1)
    nmp = fft_box_size_CD(2,1)
    nnp = fft_box_size_CD(3,1)

    if(kimg == 1) then
       nlphf = idp/2
    else
       nlphf = idp
    end if

    if(elf_filetype == DENSITY_ONLY) then
       allocate(wkelf(nlp,nmp,nnp)); wkelf = 0.d0
    else if(elf_filetype == CUBE) then
       allocate(wkelf(nnp,nmp,nlp)); wkelf = 0.d0
    end if

    write(nfout,9001) nlp*nmp*nnp, nlp, nmp, nnp
9001  format(' Electron Localization Function NE = ',i8,'(',3i5,')')

    write(nfout,*) ' !D FFT cube mapping start'
    do i = 1, nmp
       do j = 1, nnp
          do k = 1, nlp
             if(kimg == 1 .and. k > nlphf) then
                knew = idp - k
                jnew = nnp+2 - j
                inew = nmp+2 - i
                if(jnew > nnp) then
                   jnew = jnew - nnp
                end if
                if(inew > nmp) then
                   inew = inew - nmp
                end if
             else
                knew = k; jnew = j; inew = i
             end if
             ip = nlphf*mmp*(jnew-1) + nlphf*(inew-1) + knew
             if(elf_filetype == DENSITY_ONLY) then
                wkelf(k,i,j) = ita(ip*2-1)
             else if(elf_filetype == CUBE) then
                wkelf(j,i,k) = ita(ip*2-1)
             end if
          end do
       end do
    end do
    if(elf_filetype == DENSITY_ONLY) then
       write(nfelf,9001) nlp*nmp*nnp, nlp, nmp, nnp
       write(nfelf,'(6e13.5)') wkelf
    else if(elf_filetype == CUBE) then
       if(len_trim(elf_title) >= 1) then
          write(nfelf,*) trim(elf_title)
       else
          write(nfelf,'(" Calculated by phase")')
       end if
       write(nfelf,'(" SCF Total Density")')
       x = 0.d0; y = 0.d0; z = 0.d0
       write(nfelf,'(i6,3f10.4)') natm2, x,y,z
       do i = 1, 3
       !!   do m = 1, 3
       !!      ucret = unit_conv_byname( altv(m,i), r_wk(m), 'bohr', 'angstrom' )
       !!   end do
       !!   write(nfelf,'(i6,3f10.6)') fft_box_size_CD(i,1), r_wk(1:3)/dble(fft_box_size_CD(i,1))
          write(nfelf,'(i6,3f10.6)') fft_box_size_CD(i,1), altv(1:3,i)/dble(fft_box_size_CD(i,1))
       end do

       allocate(cps_full(natm2,3))
       allocate(ityp_full(natm2))
       call m_IS_pack_all_ions_in_uc(ityp_full,cps_full)
       do i = 1, natm2
          m = ityp_full(i)
          write(nfelf,'(f8.4,4f10.6)') iatomn(m), ival(m), cps_full(i,1:3)
       end do
       deallocate(ityp_full,cps_full)

       write(nfelf,'(6e13.5)') wkelf
       deallocate(wkelf)

    end if

  end subroutine m_ELF_wd_elf


  subroutine m_ELF_kinetic_energy_density(nfout,keden)
    integer, intent(in) :: nfout
    real(kind=DP), intent(out), dimension(ista_sfftp:iend_sfftp) :: keden

    real(kind=DP), dimension(nfft) :: afft,bfft
    real(kind=DP), dimension(ista_sfftp:iend_sfftp) :: afft_mpi
    real(kind=DP), dimension(ista_kngp:iend_kngp,kimg) :: kedq_l
    integer :: ik,ib1,in,i,i1,i2,ri,iend,ip
    real(kind=DP) :: occupation,fac

    afft = 0.d0

    ! debug
    !  write(*,*) 'debug: (1)'
    !  write(*,*) 'ista_e,iend_e,istep_e=',ista_e, iend_e, istep_e
    ! end debug

    call m_FFT_alloc_WF_work

    do ib1 = ista_e, iend_e, istep_e     ! MPI
       do ik=1,kv3
          if(map_k(ik) /= myrank_k) cycle ! MPI
          do in=1,3
            ! debug
            !  write(*,*) 'ib1,ik,in=',ib1,ik,in
            ! end debug
             call m_ELF_gradWF_in_Rspace(in,ik,ib1,bfft)
             occupation = occup_l(map_z(ib1),ik)
             do i = 1, nfft-1, 2
                afft(i) = afft(i) + occupation*(bfft(i)**2+bfft(i+1)**2) ! MPI
             end do
          end do
       end do
    end do
    if(npes >= 2) then
       call mpi_allreduce(afft,bfft,nfft,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr) ! MPI
       afft = bfft                          ! MPI
    end if

    call m_FFT_WF(ELECTRON,nfout,afft,DIRECT,ON)

    call m_FFT_dealloc_WF_work

! if nopr==1
!    keden = 0.d0
!    fac = 0.5d0*2.d0/(univol*kv3*product(fft_box_size_WF(1:3,1)))
!    do ri = 1, kimg
!       iend = iend_kngp
!       if( iend_kngp > kg ) iend = kg
!       if( ista_kngp <= iend ) then
!          do i = ista_kngp, iend  !for mpi
!             i1 = kimg*igf(i) + (ri - kimg)
!             ip = (igfp_l(i)-1)*kimg + ri
!             keden(ip) = afft(i1)*fac
!          end do
!       endif
!    end do
! end if

    fac = 0.5d0*2.d0/(univol*kv3*product(fft_box_size_WF(1:3,1)))
    do ri = 1, kimg
       iend = iend_kngp
       if( iend_kngp > kg ) iend = kg
       if( ista_kngp <= iend ) then
          do i = ista_kngp, iend  !for mpi
             i1 = kimg*igf(i) + (ri - kimg)
             kedq_l(i,ri) = afft(i1)*fac
          end do
       endif
    end do

    call ked_average(kedq_l)
    call map_charge_onto_a_fft_box(1,kedq_l,keden)

    call m_FFT_alloc_CD_box
    call m_FFT_CD_inverse(nfout,keden)  ! G space --> R space
    call m_FFT_dealloc_CD_box

  end subroutine m_ELF_kinetic_energy_density


  subroutine m_ELF_gradRho2(grho2)
    real(kind=DP), intent(out), dimension(ista_sfftp:iend_sfftp) :: grho2

    real(kind=DP) :: afft(ista_sfftp:iend_sfftp)
    integer :: in,i

    grho2 = 0.d0
    do in=1,3
       call m_ELF_gradRho_in_Rspace(in,afft)
       do i= ista_sfftp, iend_sfftp, 2
          grho2(i) = grho2(i) + afft(i)**2 + afft(i+1)**2
       end do
    end do

  end subroutine m_ELF_gradRho2


  subroutine map_charge_onto_a_fft_box(nspin,chgq_l,chden_l)
    integer, intent(in) :: nspin
    real(kind=DP), dimension(ista_kngp:iend_kngp,kimg,nspin) :: chgq_l
    real(kind=DP), dimension(ista_sfftp:iend_sfftp) :: chden_l

    real(kind=DP), dimension(nfftp) :: afft_mpi1
    real(kind=DP), dimension(mp_sfftp) :: afft_mpi2,afft_mpi3

    integer :: j, i, ip, is

    afft_mpi1 = 0.d0
    do is = 1, nspin
    do j = 1, kimg
       do i = ista_kngp, iend_kngp
          if(kgp_reduced <i ) cycle
          ip = (igfp_l(i)-1)*kimg + j
          afft_mpi1(ip) = afft_mpi1(ip) + chgq_l(i,j,is) !MPI
       end do
    end do
    end do

    if(npes >= 2) then
       call mpi_barrier(MPI_CommGroup,ierr)
       do j = 0, npes-1
          do i = nis_sfftp(j),nie_sfftp(j)
             afft_mpi2(i-nis_sfftp(j)+1) = afft_mpi1(i)
          end do
          call mpi_allreduce(afft_mpi2,afft_mpi3,mp_sfftp &
               &  ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)

          if(j == mype) then
             do i = ista_sfftp, iend_sfftp
                chden_l(i) = afft_mpi3(i - ista_sfftp + 1)
             end do
          end if
       end do
    else
       chden_l = afft_mpi1
    end if

  end subroutine map_charge_onto_a_fft_box


  subroutine m_ELF_gradWF_in_Rspace(in,ik,ib,bfft)
    use m_Files, only : nfout
    integer, intent(in)                           :: in, ik, ib
    real(kind=DP), intent(inout), dimension(nfft) :: bfft

    integer :: i,i1,ri,ip
    real(kind=DP) :: g

    bfft = 0.d0
    do ri = 1, kimg
       do i = 1, iba(ik)
          ip = nbase(i,ik)
          i1 = kimg*igf(ip) + (ri - kimg)
          g = rltv(in,1)*ngabc(ip,1)+rltv(in,2)*ngabc(ip,2)+rltv(in,3)*ngabc(ip,3)
          bfft(i1) = g*zaj_l(i,map_z(ib),ik,ri)   ! MPI
       end do
    end do
    if(ipri >= 2) then
       if(ik <= 2 .and. ib <= 3) then
          write(6,'(" ! bfft G-space in = ",i1," ik = ",i3," ib = ",i3," <<m_ELF_in_Rspace>>")') in, ik, ib
          write(6,'(8f8.4)') (bfft(i),i=1,120)
       end if
    end if
    call m_FFT_WF(ELECTRON,nfout,bfft,INVERSE,OFF)
    if(ipri >= 2) then
       if(ik <=  2 .and. ib <= 3) then
          write(6,'(" ! bfft R-space in = ",i1," ik = ",i3," ib = ",i3," <<m_ELF_in_Rspace>>")') in, ik, ib
          write(6,'(8f8.4)') (bfft(i),i=1,120)
       end if
    end if

  end subroutine m_ELF_gradWF_in_Rspace


  subroutine m_ELF_gradRho_in_Rspace(in,afft)
    use m_Files, only : nfout
    integer, intent(in) :: in
    real(kind=DP), intent(out) :: afft(ista_sfftp:iend_sfftp)

    integer       :: n
    real(kind=DP) :: gxyz

    afft = 0.d0
    do n = ista_sfftp, iend_sfftp  ! MPI
       gxyz = rltv(in,1)*inx(n)+rltv(in,2)*jnx(n)+rltv(in,3)*knx(n)
       afft(n) = afft(n) + gxyz*chden_l(n)
    enddo
    call check_lmn_even
    call boundary_zero(afft,in)

    call m_FFT_alloc_CD_box
    call m_FFT_CD_inverse(nfout,afft)  ! G space --> R space
    call m_FFT_dealloc_CD_box

  end subroutine m_ELF_gradRho_in_Rspace

  subroutine boundary_zero(afft,in)
    real(kind=DP), intent(inout) :: afft(ista_sfftp:iend_sfftp)
    integer, intent(in) :: in
    integer             :: i,j,k,nn,n,idp,nlp,nmp,nnp,nd2p

    idp = fft_box_size_CD(1,0)
    nlp = fft_box_size_CD(1,1)
    nmp = fft_box_size_CD(2,1)
    nd2p = fft_box_size_CD(2,0)
    nnp = fft_box_size_CD(3,1)

    if(lmn_even(in)) then
       if( in == 1) then
          do j = 1, nmp
             do k = 1, nnp
!!$                  nn = nlp/2 + 1 + idp*(j-1) + idp*nmp*(k-1)
                nn = nlp/2 + 1 + idp*(j-1) + idp*nd2p*(k-1)
                n  = nn*kimg - (kimg-1)
                if(n >= ista_sfftp .and. n <= iend_sfftp) afft(n) = 0.d0
                n  = nn*kimg
                if(n >= ista_sfftp .and. n <= iend_sfftp) afft(n) = 0.d0
             end do
          end do
       else if( in == 2) then
          do i = 1, idp
             do k = 1, nnp
!!$                  nn = i + idp*(nmp/2) + idp*nmp*(k-1)
                nn = i + idp*(nmp/2) + idp*nd2p*(k-1)
                n  = nn*kimg - (kimg-1)
                if(n >= ista_sfftp .and. n <= iend_sfftp) afft(n) = 0.d0
                n  = nn*kimg
                if(n >= ista_sfftp .and. n <= iend_sfftp) afft(n) = 0.d0
             end do
          end do
       else if(in == 3) then
          do i = 1, idp
             do j = 1, nmp
!!$                  nn = i + idp*(j-1) + idp*nmp*(nnp/2)
                nn = i + idp*(j-1) + idp*nd2p*(nnp/2)
                n  = nn*kimg - (kimg-1)
                if(n >= ista_sfftp .and. n <= iend_sfftp) afft(n) = 0.d0
                n  = nn*kimg
                if(n >= ista_sfftp .and. n <= iend_sfftp) afft(n) = 0.d0
             end do
          end do
       end if
    end if
  end subroutine boundary_zero

  subroutine check_lmn_even
    integer             :: nlmn, i

    do i = 1, 3
       nlmn = fft_box_size_CD(i,1)/2
       if(2*nlmn == fft_box_size_CD(i,1)) then
          lmn_even(i) = .true.
       else
          lmn_even(i) = .false.
       end if
    end do
  end subroutine check_lmn_even

  subroutine ked_average(ked)
    real(kind=DP), intent(inout) :: ked(ista_kngp:iend_kngp,kimg)
    integer ::       ng, no, ngp, no1, no2
    real(kind=DP) :: fi, tx,ty,tz, fp, fc, fs, zcr, zci
    real(kind=DP), dimension(kgp,kimg) :: work
    real(kind=DP), pointer, dimension(:,:) :: work2

    allocate(work2(ista_kngp:iend_kngp,kimg)); work2 = 0.d0

    fi = 1.d0/dble(nopr)
    no1 = 1; no2 = nopr

    call cp_ked_to_work(ked,work) ! ked -> work
    work2 = 0.d0                  ! initialization
    do no = no1, no2
       tx = tau(1,no,BUCS)*PAI2
       ty = tau(2,no,BUCS)*PAI2
       tz = tau(3,no,BUCS)*PAI2
       if(kimg == 1) then
          do ng = ista_kngp, iend_kngp !for mpi
             ngp = ngpt_l(ng,no)
             fp = ngabc(ngp,1)*tx + ngabc(ngp,2)*ty + ngabc(ngp,3)*tz
             work2(ng,1)        = work2(ng,1) + dcos(fp)*work(ngp,1)
          end do
       else if(kimg == 2) then
          do ng = ista_kngp, iend_kngp !for mpi
             ngp= ngpt_l(ng,no)
             fp = ngabc(ngp,1)*tx + ngabc(ngp,2)*ty + ngabc(ngp,3)*tz
             fc = dcos(fp);     fs = dsin(fp)
             zcr= work(ngp,1);  zci= work(ngp,kimg)
             work2(ng,1)        = work2(ng,1) + fc*zcr - fs*zci
             work2(ng,2)        = work2(ng,2) + fc*zci + fs*zcr
          end do
       end if
    end do
    ked(:,:) = work2(:,:)*fi

    deallocate(work2)

  contains

    subroutine cp_ked_to_work(ked,work)
      real(DP),intent(in),dimension(ista_kngp:iend_kngp,kimg) :: ked
      real(DP),intent(out),dimension(kgp,kimg) :: work
      integer :: ng,ri
      real(kind=DP), pointer, dimension(:,:) :: work_mpi
      allocate(work_mpi(kgp,kimg)); work_mpi = 0.d0
      work = 0.d0
      do ri = 1, kimg
         do ng = ista_kngp, iend_kngp  !for mpi
            work_mpi(ng,ri) = ked(ng,ri)
         end do
      end do
      call mpi_allreduce(work_mpi,work,kgp*kimg &
            &  ,mpi_double_precision,mpi_sum,MPI_CommGroup,ierr)
      deallocate(work_mpi)
     end subroutine cp_ked_to_work

  end subroutine ked_average

!$$#endif

end module m_ELF

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a module for setting control parameters for the LR-TDDFT .
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

module m_LinearResponse_Control

  use m_Electronic_Structure,       only : efermi
  use m_Control_Parameters,         only : ipriinputfile, printable, uvsormode
 
  use m_Const_parameters,           only : DP, SP, BUCS, ON, OFF,CARTS, & 
       &              PAI4, PAI2, PAI, FMAXVALLEN, LOWER, BOHR, &
       &              MESH

  use m_Files,                      only : nfout, m_Files_reopen_nfinp
  use m_Kpoints,                    only : way_ksample

  use m_Control_Parameters,          only : sw_LinearResponse
  use mpi

  Implicit None
!  include 'mpif.h'
  
! -----------  General ------------------------
  integer                ::         iprilrspectr = 1         !     OFF=0, ON=1
  integer, parameter     ::         OPTICS=0,  PACS=1, EELS=2, IXSS=3
  integer                ::         spectrum_type = OPTICS
! ------------ momentum transfer -------
  real(kind=DP)          ::         vec_q(3), norm_q
  real(kind=DP)          ::         min_norm_q = 1.0D-3
! -----------  TDDFT -------------------------
  integer                ::         sw_tddft  = OFF
  integer                ::         sw_LongWaveLimit  = ON
! ------------ Solver --------
  integer, parameter     ::         DYSON = 0,  BS = 1     
  integer                ::         tddft_eqn_type = DYSON        ! default
! --
  integer                ::         sw_NODA = OFF       ! approximatin in BS eq.
! ------------ Coulomb Kernel ---------
  integer                ::         sw_NLF    = OFF
! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< EXPERIMENTAL <<<<<<<<<<<<<<<<<
  integer                ::         sw_Coulomb_screening = OFF      ! default
  integer                ::         sw_Fxc_enhanced  = OFF      ! default
  Real(kind=DP)          ::         rcut_yukawa      = 1.0 / Bohr
! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
! ----------- XC Kernel ---------
  integer, parameter     ::         RPA = 0, ALDA_G = 1,  LRC = 2, ALDA_R = 11
  integer                ::         xc_kernel_type = RPA     ! default
  real(kind=DP)          ::         LRC_alpha = 1.0
  real(kind=DP)          ::         LRC_beta  = 1.0
! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< EXPERIMENTAL <<<<<<<<<<<<<<<<<
  Real(kind=DP)          ::         fxc_enhanced_facotr = 1.0
! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
! ------------ Expansion ----------
  integer                ::         nmax_G_LR = 100        ! default
! ------------ BZ ---------------------
  integer, parameter     ::         LORENTZIAN_B=1,  GAUSSIAN_B=2, L_TETRAHEDRON=3
  integer                ::         way_BZintegral = LORENTZIAN_B
!
  real(kind=DP)          ::         eta = 1.0E-4    ! in hartree unit
!
  integer                ::         nistep, nstep
  real(kind=DP)          ::         width, deltaq, tetra_eps
  real(kind=DP)          ::         scissor = 0.0D0
! ------------- Energy range -------------
  real(kind=DP)          ::         e_low, e_high, e_step
! ------------- Fermi ----------------
  integer                ::         nrd_efermi = 0
  real(kind=DP)          ::         efermi_backup

! ----------------------- Arrays to be allocated -----------
  Real(kind=DP),    allocatable     :: vqxyz( :,:,: )
  real(kind=DP),    allocatable     :: e(:)
!
  integer                ::         ipriqpt = 0
! ---------------------------------------------------------
contains

  subroutine m_CtrlP_rd_LinearResponse( nfout )
    integer, intent(in) :: nfout
! ------------------------------ General ----------------------
    character(len("spectrum")), parameter  ::  tag_spectrum       = "spectrum"
    character(len("LongWaveLimit")),  parameter  ::  tag_longwave  = "LongWaveLimit"
! --
    character(len("type")),     parameter  ::  tag_spectrum_type  = "type"
    character(len("optics")),   parameter  ::  tag_optics         = "optics" 
    character(len("PACS")),     parameter  ::  tag_PACS           = "PACS" 
    character(len("EELS")),     parameter  ::  tag_EELS           = "EELS" 
    character(len("IXSS")),     parameter  ::  tag_IXSS           = "IXSS" 
! ------------------------------- Momentum Transfer ----------
    character(len("momentum_transfer")), parameter  ::  tag_momentum = "momentum_transfer"
    character(len("deltaq")),   parameter  ::  tag_deltaq   = "deltaq"
    character(len("nx")),       parameter  ::  tag_nx       = "nx"
    character(len("ny")),       parameter  ::  tag_ny       = "ny"
    character(len("nz")),       parameter  ::  tag_nz       = "nz"
! ---------------------------------- TDDFT --------------------
    character(len("tddft")),    parameter  ::  tag_tddft    = "tddft"
    character(len("sw_tddft")), parameter  ::  tag_sw_tddft    = "sw_tddft"
! ----------------------------------- Solver ----------------
    character(len("solver")),   parameter  ::  tag_solver  = "solver"
    character(len("equation")),   parameter  ::  tag_equation  = "equation"
    character(len("DYSON")),    parameter  ::  tag_DYSON   = "DYSON"
    character(len("BS")),       parameter  ::  tag_BS      = "BS"
    character(len("sw_NODA")),  parameter  ::  tag_sw_NODA   = "sw_NODA"
! ----------------------------------- Coulomb Kernel -----------
    character(len("Coulomb_Kernel")),parameter  ::  tag_CoulombKernel = "Coulomb_Kernel"
    character(len("sw_NLF")),   parameter  ::  tag_sw_NLF   = "sw_NLF"
! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< experimenal <<<<<<<<<
    character(len("sw_Coulomb_screening")), parameter :: tag_sw_Coulomb_screening &
         &                                   = "sw_Coulomb_screening"
    character(len("screening_length")),  parameter  ::  tag_screening_length &
         &                                   = "screening_length"
! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
! ---------------------------------- XC Kernel --------------------
    character(len("XC_Kernel")),parameter  ::  tag_XCKernel = "XC_Kernel"
    character(len("kernel_type")), parameter  ::  tag_kernel_type = "kernel_type"
    character(len("RPA")),      parameter  ::  tag_RPA      = "RPA"
    character(len("ALDA-G")),   parameter  ::  tag_ALDA_G   = "ALDA-G"
    character(len("ALDA-R")),   parameter  ::  tag_ALDA_R   = "ALDA-R"
    character(len("LRC")),      parameter  ::  tag_LRC      = "LRC"
    character(len("LRC_alpha")),parameter  ::  tag_LRC_alpha = "LRC_alpha"
    character(len("LRC_beta")), parameter  ::  tag_LRC_beta  = "LRC_beta"
! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< experimenal <<<<<<<<<
    character(len("sw_Fxc_enhanced")), parameter :: tag_sw_Fxc_enhanced &
         &                                   = "sw_Fxc_enhanced"
! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
! -------------------------------- Expansion --------------
    character(len("Expansion")),parameter  ::  tag_expansion = "expansion"
    character(len("NumGVec")),  parameter  ::  tag_num_GVec  = "NumGvec"
! ----------------------------------- energy -------------------
    character(len("energy")),   parameter  ::  tag_energy   = "energy"
    character(len("low")),      parameter  ::  tag_low      = "low"
    character(len("high")),     parameter  ::  tag_high     = "high"
    character(len("step")),     parameter  ::  tag_step     = "step"
! --------------------------------- BZ integration ------------
    character(len("BZ_integration")), parameter :: tag_BZ_integration = "BZ_integration"
    character(len("method")), parameter         :: tag_method = "method"
!
    character(len("lorentzian")), parameter     :: tag_lorentzian = "lorentzian"
    character(len("l")), parameter              :: tag_l = "l"
!
    character(len("gaussian")), parameter       :: tag_gaussian = "gaussian"
    character(len("g")), parameter              :: tag_g = "g"
    character(len("width")), parameter          :: tag_width = "width"
! ----------------------------- --- not supported ----------------
    character(len("tetrahedron")), parameter    :: tag_tetrahedron = "tetrahedron"
    character(len("t"))                         :: tag_t = "t"
    character(len("nistep")), parameter         :: tag_nistep = "nistep"
    character(len("spin")),  parameter          :: tag_spin  = "spin"
    character(len("both")),  parameter          :: tag_both  = "both"
    character(len("tetra_eps")),parameter       :: tag_tetra_eps = "tetra_eps"
! ------------------------------ band gap correction ----------
    character(len("band_gap_correction")), parameter   ::  tag_band_gap_correction = "band_gap_correction"
    character(len("scissor_operator")), parameter      ::  tag_scissor  = "scissor_operator"
! ----------------------------------- Fermi --------------------
    character(len("on")), parameter              ::  tag_on  = "on"
    character(len("off")), parameter             ::  tag_off = "off"
    character(len("fermi_energy")), parameter    ::  tag_fermi_energy = "fermi_energy"
    character(len("read_efermi")), parameter     ::  tag_read_efermi = "read_efermi"
    character(len("efermi")),parameter           ::  tag_efermi = "efermi"
! --

    character( len=FMAXVALLEN ) :: rstr
    integer :: iret, f_selectBlock, f_selectParentBlock, f_selectTop
    integer :: f_getStringValue, f_getRealValue, f_getIntValue
    real(kind=DP) :: dret
    
! ---------------------------------------------------------------------
! ----------------------------------------- start ---------------------
! ---------------------------------------------------------------------
    iret = f_selectTop()
    if ( ipriinputfile >= 2 .and. printable ) then
       write(nfout,'(" !*  tag_spectrum")')
    endif
    if ( f_selectBlock( tag_spectrum ) == 0 ) then
       sw_LinearResponse = ON
       call Set_Spectrum_Type
       call Set_switch_LongWaveLimit
! ----- momentum transfer
       if ( f_selectBlock( tag_momentum ) == 0 ) then
          call Set_Momentum_Transfer(1)
          iret = f_selectParentBlock()
       else
          call Set_Momentum_Transfer(0)
       endif
! ---- tddft --
       if ( f_selectBlock( tag_tddft ) == 0 ) then
          call Set_switch_TDDFT
          if ( f_selectBlock( tag_solver ) == 0 ) then
             call set_Equation_type
             call Set_switch_NODA
             iret = f_selectParentBlock()
          endif
! ---------------------------- Coulomb Kernel --------
          if ( f_selectBlock( tag_CoulombKernel ) == 0 ) then
             call Set_switch_NLF
! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< experimental <<<<<<<<<<<<<<<<<
             call set_switch_Coulomb_screening
             call Set_screening_length(1)
! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
             iret = f_selectParentBlock()
          endif
! ---------------------------- XC Kernel --------------
          if ( f_selectBlock( tag_XCKernel ) == 0 ) then
             call Set_XCKernel_Type
! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< experimental <<<<<<<<<<<<<<<<<
             call set_switch_Fxc_enhanced
! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
             iret = f_selectParentBlock()
          endif
          call Limitation_Equation_Type
! ------------------------------ G-expansion ----------
          if ( f_selectBlock( tag_expansion ) == 0 ) then
             call Set_Num_GVectors(1)
             iret = f_selectParentBlock()
          else
             call Set_Num_GVectors(0)
          endif
          iret = f_selectParentBlock()
       endif
! ------------- Fermi -----------
       if ( f_selectBlock( tag_fermi_energy ) == 0 ) then
          if( f_getStringValue( tag_read_efermi, rstr, LOWER) == 0) then
             call set_efermi(rstr)
          endif
          iret = f_selectParentBlock()
       else
          call Set_FermiLevel_Later
       end if
! --- Energy --
       if ( f_selectBlock( tag_energy ) == 0 ) then
          call set_energy_range
          iret = f_selectParentBlock()
       end if
! --- BZ Integral
       if (f_selectBlock(tag_BZ_integration) == 0 ) then
          call Set_BZ_Integration_Type
          iret = f_selectParentBlock()
       end if
! --- read band gap correction option
       if ( f_selectBlock(tag_band_gap_correction) == 0 ) then
          call set_band_gap_correction
          iret = f_selectParentBlock()
       end if
       write(nfout,*) '***********************************************'
! --- 
    else
       stop ' tag_spectrum is not given in the input file <<CtrlP_rd_spectrum>> '
    end if
    
  contains

!----------------------------------------------------------------
!!
!!!               Spectrum type
!!
!----------------------------------------------------------------
    subroutine Set_Spectrum_Type
      logical :: tf

      write(nfout,*) '*************************** Spectrum ***********'

      if ( f_getStringValue( tag_spectrum_type, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_optics, trim(rstr), tf )
         if(tf) then
            spectrum_type = OPTICS;   goto 1001
         end if
         call strncmp0( tag_PACS, trim(rstr), tf )
         if(tf) then
            spectrum_type = PACS;      goto 1001
         end if
         call strncmp0( tag_EELS, trim(rstr), tf )
         if(tf) then
            spectrum_type = EELS;      goto 1001
         end if
         call strncmp0( tag_IXSS, trim(rstr), tf )
         if(tf) then
            spectrum_type = IXSS;      goto 1001
         end if
         if ( printable ) call Comment_Spectrum_Type( 1 )

1001     continue
         if ( printable ) call Comment_Spectrum_Type( 0 )
      else
         call Comment_Spectrum_Type( -1 )
      endif
    end subroutine Set_Spectrum_Type

    subroutine Comment_Spectrum_Type( icode )
      integer, intent(in) :: icode

      select case( icode )
      case(0)
         write(nfout,'("!* Spectrum type = ",i3)') spectrum_type
         write(nfout,*) "!* ------ 0:Optics; 1:PACS, 2:EELS, 3:IXSS -- "
      case (-1)
         write(nfout,'(1x,"!* tag_spectrum_type is not found")')
         write(nfout,'(1x,"!* spectrum_type is set to OPTICS")')
      case (1)
         write(nfout,'(1x,"!* incorrect words for spectrum_type")')
         write(nfout,'(1x,"!* spectrum type is set to OPTICS")')
      end select

    end subroutine Comment_Spectrum_Type
    
!----------------------------------------------------------------
!!
!!!               LongWaveLimit
!!
!----------------------------------------------------------------
    subroutine Set_switch_LongWaveLimit
      logical :: tf

      if ( f_getStringValue( tag_longwave, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_off, trim(rstr), tf )
         if (tf) then
            sw_LongWaveLimit = OFF; goto 1002
         endif
         call strncmp0( tag_on, trim(rstr), tf )
         if (tf) then
            sw_LongWaveLimit = ON; goto 1002
         endif
         if ( printable ) Call Comment_sw_LongWaveLimit(1)

1002     continue
         if ( printable ) Call Comment_sw_LongWaveLimit(0)
      else
         if ( printable ) Call Comment_sw_LongWaveLimit(-1)
      endif
    end subroutine Set_switch_LongWaveLimit

    subroutine Comment_sw_LongWaveLimit( icode )
      integer, intent(in) :: icode

      select case( icode )
      case(0)
         if ( sw_LongWaveLimit == ON ) then
            write(nfout,'(1x,"!*         LongWaveLimit set ON")')
         else
            write(nfout,'(1x,"!*         LongWaveLimit is set OFF")')
         endif
      case(-1)
         write(nfout,'(1x,"!* tag_longwave is not found")')
         write(nfout,'(1x,"!* LongWaveLimit is set ON as default")')
      case(1)
         write(nfout,'(1x,"!* incorrect words for LongWaveLimit")')
         write(nfout,'(1x,"!* LongWaveLimit is set ON as default")')
      end select

    end subroutine Comment_sw_LongWaveLimit

!----------------------------------------------------------------
!!
!!!               Momentum transfer
!!
!----------------------------------------------------------------
    subroutine Set_Momentum_Transfer( itype )
      integer :: itype
      real(kind=DP) c1
      integer :: f_getRealValue

      select case ( itype )
      case (0)
         vec_q = 0.0d0; vec_q(3) = min_norm_q;
         vec_q = vec_q *Bohr
         call Comment_MomentumTransfer( 0 )
      case (1)
         if ( f_getRealValue( tag_deltaq, dret," " ) == 0 ) norm_q = dret
         if ( f_getRealValue( tag_nx, dret," " ) == 0 ) vec_q(1) = dret
         if ( f_getRealValue( tag_ny, dret," " ) == 0 ) vec_q(2) = dret
         if ( f_getRealValue( tag_nz, dret," " ) == 0 ) vec_q(3) = dret
         
         if ( vec_q(1)**2 +vec_q(2)**2 +vec_q(3)**2 == 0.0d0 ) vec_q = 0.0d0

!      if ( qnorm < qnorm_min .or. sw_LongWaveLimit==ON ) qnorm = qnorm_min
         if ( sw_LongWaveLimit==ON ) norm_q = min_norm_q
! --
         call Comment_MomentumTransfer( 1 )
         norm_q = norm_q *Bohr
         c1 = sqrt( vec_q(1)**2 + vec_q(2)**2 + vec_q(3)**2 )
         vec_q = norm_q * vec_q / c1
      end select

    end subroutine Set_Momentum_Transfer

    subroutine Comment_MomentumTransfer( icode )
      integer, intent(in) :: icode

      select case( icode )
      case(0)
         write(nfout,'(1x,"!* momentum transfer is set to a default value  ",F12.5," Angstrom^(-1)")') min_norm_q
         write(nfout,'(1x,"!*         Direction = ",3F12.5)') 0, 0, 1.0
      case (1)
         write(nfout,'(1x,"!* momentum transfer = ",F12.5," Angstrom^(-1)")') norm_q
         write(nfout,'(1x,"!*         Direction = ",3F12.5)') vec_q(1), vec_q(2), vec_q(3)
      end select
      
    end subroutine Comment_MomentumTransfer
    
!----------------------------------------------------------------
!!
!!!               TDDFT
!!
!----------------------------------------------------------------
    subroutine set_switch_TDDFT
      logical :: tf

      if ( f_getStringValue( tag_sw_tddft, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_off, trim(rstr), tf )
         if (tf) then
            sw_tddft = OFF; goto 1003
         endif
         call strncmp0( tag_on, trim(rstr), tf )
         if (tf) then
            sw_tddft = ON; goto 1003
         endif
         if ( printable ) Call Comment_sw_tddft(1)
1003     continue
         if ( printable ) Call Comment_sw_tddft(0)
      else
         if ( printable ) Call Comment_sw_tddft(-1)
      endif
    end subroutine set_switch_TDDFT

    subroutine Comment_sw_tddft( icode )
      integer, intent(in) :: icode

      select case(icode)
      case(0)
         if ( sw_tddft == ON ) then
            write(nfout,*) "!* sw_tddft is set to ON"
         else
            write(nfout,*) "!* sw_tddft is set to OFF"
         endif
      case(-1)
         write(nfout,'(1x,"!* tag_sw_tddft is not found")')
         write(nfout,'(1x,"!* sw_tddft is set OFF as default")')
      case(1)
         write(nfout,'(1x,"!* incorrect words for sw_tddft")')
         write(nfout,'(1x,"!* sw_tddft is set OFF as default")')
      end select
    end subroutine Comment_sw_tddft

!----------------------------------------------------------------
!!
!!!               Solver       ( Dyson or BS )
!!
!----------------------------------------------------------------
    subroutine Set_Equation_Type
      logical :: tf

      if ( f_getStringValue( tag_equation, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_DYSON, trim(rstr), tf )
         if(tf) then
            tddft_eqn_type  = DYSON;   goto 1006
         end if
         call strncmp0( tag_BS, trim(rstr), tf )
         if(tf) then
            tddft_eqn_type = BS;   goto 1006
         end if

         call Comment_Equation_Type(1)
!
1006     continue
         call Comment_Equation_Type(0)
      else
         call Comment_Equation_Type(-1)
      endif
    end subroutine Set_Equation_Type

    subroutine Comment_Equation_Type( icode )
      integer, intent(in) :: icode

      select case(icode)
      case(0)
         write(nfout,'("!* TDDFT Solver = ",i3)') tddft_eqn_type
         write(nfout,'(1x,"!*         DYSON_like : 0,  BS_like : 1  ")')
      case(-1)
         write(nfout,'(1x,"!* tag_equation is not found")')
         write(nfout,'(1x,"!* tddft_eqn_type is set to DYSON_like")')
      case (1)
         write(nfout,'(1x,"!* incorrect words for tag_solver")')
         write(nfout,'(1x,"!* tddft_eqn_type is set to DYSON_like")')
      end select
    end subroutine Comment_Equation_Type

    subroutine Limitation_Equation_Type
      if ( tddft_eqn_type == BS ) then
         if ( xc_kernel_type /= ALDA_R .and. xc_kernel_type /= RPA ) then
            write(nfout,'(1x,"!** BS_Like equation is supported with xc_kernel = ALDA_R/RPA")')
            stop
         endif
      endif
    end subroutine Limitation_Equation_Type

    subroutine Set_switch_NODA           ! Neglect Off-Diagonal Approximation
      logical :: tf

      if ( tddft_eqn_type /= BS ) return

      if ( f_getStringValue( tag_sw_NODA, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_off, trim(rstr), tf )
         if (tf) then
            sw_NODA = OFF; goto 1011
         endif
         call strncmp0( tag_on, trim(rstr), tf )
         if (tf) then
            sw_NODA = ON; goto 1011
         endif
         if ( printable ) Call Comment_sw_NODA(1)
1011     continue
         if ( printable ) Call Comment_sw_NODA(0)
      else
         if ( printable ) Call Comment_sw_NODA(-1)
      endif
    end subroutine Set_switch_NODA

    subroutine Comment_sw_NODA( icode )
      integer, intent(in) :: icode

      select case(icode)
      case(0)
         if ( sw_NODA == ON ) then
            write(nfout,*) "!* sw_NODA is set to ON"
         else
            write(nfout,*) "!* sw_NODA is set to OFF"
         endif
      case(-1)
         write(nfout,'(1x,"!* tag_sw_NODA is not found")')
         write(nfout,'(1x,"!* sw_NODA is set OFF as default")')
      case(1)
         write(nfout,'(1x,"!* incorrect words for sw_NODA")')
         write(nfout,'(1x,"!* sw_NODA is set OFF as default")')
      end select
    end subroutine Comment_sw_NODA

!----------------------------------------------------------------
!!
!!!              Coulomb Kernel
!!
!----------------------------------------------------------------
    subroutine Set_switch_NLF
      logical :: tf

      if ( f_getStringValue( tag_sw_NLF, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_off, trim(rstr), tf )
         if (tf) then
            sw_NLF = OFF; goto 1004
         endif
         call strncmp0( tag_on, trim(rstr), tf )
         if (tf) then
            sw_NLF = ON; goto 1004
         endif
         if ( printable ) Call Comment_sw_NLF(1)
1004     continue
         if ( printable ) Call Comment_sw_NLF(0)
      else
         if ( printable ) Call Comment_sw_NLF(-1)
      endif
    end subroutine Set_switch_NLF

    subroutine Comment_sw_NLF( icode )
      integer, intent(in) :: icode

      select case(icode)
      case(0)
         if ( sw_NLF == ON ) then
            write(nfout,*) "!* sw_NLF is set to ON"
         else
            write(nfout,*) "!* sw_NLF is set to OFF"
         endif
      case(-1)
         write(nfout,'(1x,"!* tag_sw_NLF is not found")')
         write(nfout,'(1x,"!* sw_NLF is set OFF as default")')
      case(1)
         write(nfout,'(1x,"!* incorrect words for sw_NLF")')
         write(nfout,'(1x,"!* sw_NLF is set OFF as default")')
      end select
    end subroutine Comment_sw_NLF

! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<< EXPERIMENTAL <<<<<<<<<<<<<<<<<<<<<<<
    subroutine Set_switch_Coulomb_Screening
      logical :: tf

      if ( f_getStringValue( tag_sw_Coulomb_screening, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_off, trim(rstr), tf )
         if (tf) then
            sw_Coulomb_screening = OFF; goto 1012
         endif
         call strncmp0( tag_on, trim(rstr), tf )
         if (tf) then
            sw_Coulomb_screening = ON; goto 1012
         endif
         if ( printable ) Call Comment_sw_Coulomb_Screening(1)
1012     continue
         if ( printable ) Call Comment_sw_Coulomb_Screening(0)
      else
         if ( printable ) Call Comment_sw_Coulomb_Screening(-1)
      endif
    end subroutine Set_switch_Coulomb_Screening

    subroutine Comment_sw_Coulomb_Screening( icode )
      integer, intent(in) :: icode
      
      select case(icode)
      case(0)
         if ( sw_Coulomb_Screening == ON ) then
            write(nfout,*) "!* sw_Coulomb_Screening is set to ON"
         else
            write(nfout,*) "!* sw_Coulomb_Screening is set to OFF"
         endif
      case(-1)
         write(nfout,'(1x,"!* tag_sw_Coulomb_Screening is not found")')
         write(nfout,'(1x,"!* sw_Coulomb_Screening is set OFF as default")')
      case(1)
         write(nfout,'(1x,"!* incorrect words for sw_Coulomb_Screeing")')
         write(nfout,'(1x,"!* sw_Coulomb_Screening is set OFF as default")')
      end select
    end subroutine Comment_sw_Coulomb_Screening

    subroutine Set_screening_length( icode )
      integer, intent(in) :: icode
      integer :: f_getRealValue

      if ( sw_Coulomb_Screening == OFF ) return

      select case(icode)
      case(0)
         call Comment_screening_length(-2)
      case(1)
         if ( f_getRealValue( tag_screening_length, dret, "" ) == 0 ) then
            rcut_yukawa = dret
            call Comment_screening_length(0)
         else
            call Comment_screening_length(-1)
         endif
      end select

    end subroutine Set_screening_length

    subroutine Comment_screening_length( icode )
      integer, intent(in) :: icode
      
      select case(icode)
      case(0)
         write(nfout,*) "!* The screening lengh is set to ", rcut_yukawa, " bohr"
      case(-1)
         write(nfout,*) "!* tag_screening_length is not found"
         write(nfout,*) "!* The screening length is set to a default value ", rcut_yukawa
      case(-2)
         write(nfout,*) "!* tag_screening_length is not found"
         write(nfout,*) "!* The screening length is set to a default value ", rcut_yukawa
      end select
    end subroutine Comment_screening_length

! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

!----------------------------------------------------------------
!!
!!!              Exchange correlatio Kernel
!!
!----------------------------------------------------------------
    subroutine Set_XCKernel_Type
      logical :: tf

      if ( f_getStringValue( tag_kernel_type, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_RPA, trim(rstr), tf )
         if(tf) then
            xc_kernel_type = RPA;   goto 1005
         end if
         call strncmp0( tag_ALDA_G, trim(rstr), tf )
         if(tf) then
            xc_kernel_type = ALDA_G;      goto 1005
         end if
         call strncmp0( tag_ALDA_R, trim(rstr), tf )
         if(tf) then
            xc_kernel_type = ALDA_R;      goto 1005
         end if
         call strncmp0( tag_LRC, trim(rstr), tf )
         if(tf) then
            xc_kernel_type = LRC;      goto 1005
         end if

         call Comment_XCKernel_Type(1)
!
1005     continue
         call Comment_XCKernel_Type(0)
         if ( xc_kernel_type == LRC ) call Set_XCKernel_Param_LRC
      else
         call Comment_XCKernel_Type(-1)
      endif
    end subroutine Set_XCKernel_Type

    subroutine Comment_XCKernel_Type( icode )
      integer, intent(in) :: icode

      select case(icode)
      case(0)
         write(nfout,'(" !* XC Kernel type = ",i3)') xc_kernel_type
         write(nfout,'(1x,"!*         RPA : 0,  ALDA-G : 1, LRC : 2  ")')
         write(nfout,'(1x,"!*                   ALAD-R :11  ")')
      case(-1)
         write(nfout,'(1x,"!* tag_xc_kernel is not found")')
         write(nfout,'(1x,"!* xc_kernel_type is set to RPA")')
      case (1)
         write(nfout,'(1x,"!* incorrect words for xc_kernel")')
         write(nfout,'(1x,"!* xc_kernel_type is set to RPA")')
      end select
    end subroutine Comment_XCKernel_Type

    subroutine Set_XCKernel_Param_LRC
      integer :: f_getRealValue

      if ( f_getRealValue( tag_LRC_alpha, dret,"" ) == 0 ) then
         LRC_alpha = dret
         call Comment_XCKernel_LRC(0)
      else
         call Comment_XCKernel_LRC(20)
      endif
    end subroutine Set_XCKernel_Param_LRC

    subroutine Comment_XCKernel_LRC( icode )
      integer, intent(in) :: icode
      
      select case(icode)
      case(0)
         write(nfout,*) "!* LRC_alpha is set to", LRC_alpha         
      case(20)
         write(nfout,*) "!* tag_LRC_alpha is not found"
         write(nfout,*) "!* The parameter LRC_alpha is set to a dafault value", LRC_alpha
      end select
    end subroutine Comment_XCKernel_LRC

! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< EXPERIMENTAL <<<<<<<<<<<<<<<<<<<<<<
    subroutine Set_switch_Fxc_enhanced
      logical :: tf

      if ( f_getStringValue( tag_sw_Fxc_enhanced, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_off, trim(rstr), tf )
         if (tf) then
            sw_Fxc_enhanced = OFF; goto 1015
         endif
         call strncmp0( tag_on, trim(rstr), tf )
         if (tf) then
            sw_Fxc_enhanced = ON; goto 1015
         endif
         if ( printable ) Call Comment_sw_Fxc_enhanced(1)
1015     continue
         if ( printable ) Call Comment_sw_Fxc_enhanced(0)
      else
         if ( printable ) Call Comment_sw_Fxc_enhanced(-1)
      endif
    end subroutine Set_switch_Fxc_enhanced

    subroutine Comment_sw_Fxc_enhanced( icode )
      integer, intent(in) :: icode
      
      select case(icode)
      case(0)
         if ( sw_Fxc_enhanced == ON ) then
            write(nfout,*) "!* sw_Fxc_enhanced is set to ON"
         else
            write(nfout,*) "!* sw_Fxc_enhanced is set to OFF"
         endif
      case(-1)
         write(nfout,'(1x,"!* tag_sw_Fxc_enhanced is not found")')
         write(nfout,'(1x,"!* sw_Fxc_enhanced set OFF as default")')
      case(1)
         write(nfout,'(1x,"!* incorrect words for sw_Fxc_enhanced")')
         write(nfout,'(1x,"!* sw_Fxc_enhanced set OFF as default")')
      end select
    end subroutine Comment_sw_Fxc_enhanced
    
! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

!----------------------------------------------------------------
!!
!!!              G-expansion
!!
!----------------------------------------------------------------
    subroutine Set_Num_GVectors( icode )
      integer, intent(in) :: icode
      integer :: f_getIntValue

      select case(icode)
      case(0)
         call Comment_GVecTruncated(-2)
      case(1)
         if ( f_getIntValue( tag_Num_GVec, iret ) == 0 ) then
            nmax_G_LR = iret
            call Comment_GVecTruncated(0)
         else
            call Comment_GVecTruncated(-1)
         endif
      end select

    end subroutine Set_Num_GVectors

    subroutine Comment_GVecTruncated( icode )
      integer, intent(in) :: icode
      
      select case(icode)
      case(0)
         write(nfout,*) "!* The number of G-Vector is limited to ", nmax_G_LR
         write(nfout,*) "!* This value may be changed later, depending on kgp"
      case(-1)
         write(nfout,*) "!* tag_Num_GVec is not found"
         write(nfout,*) "!* The number of G-Vector is set to a default value ", nmax_G_LR
      case(-2)
         write(nfout,*) "!* tag_trunctated is not found"
         write(nfout,*) "!* The number of G-Vector is set to a default value ", nmax_G_LR
      end select
    end subroutine Comment_GVecTruncated

!----------------------------------------------------------------
!!
!!!               Fermi ????????????
!!
!----------------------------------------------------------------
    subroutine Set_FermiLevel_Later
      write(nfout,*) "!* Fermi energy is set later"
    end subroutine Set_FermiLevel_Later

! ------------------------------------------------------------------
!!
!!! ---------------  Fermi, Range, BZ, Scissor  ----------------
!!
! ------------------------------------------------------------------

    subroutine set_efermi(rstr)
      character(len=FMAXVALLEN),intent(in) :: rstr

      integer :: f_getRealValue
      logical :: tf

      call strncmp0(tag_off, trim(rstr), tf)
      if(tf) then
         nrd_efermi=0;  goto 1001
      end if
      call strncmp0(tag_on, trim(rstr), tf)
      if(tf) then
         nrd_efermi=1
         if( f_getRealValue( tag_efermi, dret,'hartree') == 0) efermi=dret
         goto 1001
      end if
1001  if ( printable ) then
         write(nfout,'(1x,"!* nrd_efermi = ",i3)') nrd_efermi
         write(nfout,'(1x,"!*     Fermi level is set to ",f15.8)') efermi
      endif
      
    end subroutine set_efermi
      
    subroutine set_energy_range
      integer :: f_getRealValue
      if( f_getRealValue( tag_low, dret, 'hartree') == 0)  e_low=dret
      if( f_getRealValue( tag_high, dret,'hartree') == 0) e_high=dret
      if( f_getRealValue( tag_step, dret,'hartree') == 0) e_step=dret
      !       write(*,*) 'e_low = ', e_low, e_high, e_step
    end subroutine set_energy_range

    subroutine Set_BZ_Integration_Type
      integer :: f_getRealValue, f_getIntValue

      if ( f_getStringValue( tag_method, rstr, LOWER) == 0 ) call set_integration_method(rstr)
      if ( way_BZintegral == LORENTZIAN_B ) then
         if( f_getRealValue( tag_width, dret, 'hartree' ) == 0) then
            if ( dret > 0.0 ) then 
               eta = dret
            endif
         endif
      end if
      if ( way_BZintegral == GAUSSIAN_B ) then
         if( f_getRealValue( tag_width, dret, 'hartree' ) == 0) width = dret
      end if
      if ( way_BZintegral==L_TETRAHEDRON ) then
         if( f_getIntValue( tag_nistep, iret) == 0) nistep=iret
         if( f_getRealValue( tag_tetra_eps, dret, 'hartree' ) == 0) tetra_eps=dret
      end if
    end subroutine Set_BZ_Integration_Type

    subroutine set_integration_method(rstr)
      character(len=FMAXVALLEN),intent(in) :: rstr
      logical :: tf
      way_BZintegral = LORENTZIAN_B
      
      call strncmp0(tag_lorentzian, trim(rstr), tf)
      if(tf) then
         way_BZintegral = LORENTZIAN_B
         goto 1001
      end if
      call strncmp0(tag_l, trim(rstr), tf)
      if(tf) then
         way_BZintegral = L_TETRAHEDRON
         goto 1001
      end if
!
      call strncmp0(tag_gaussian,trim(rstr),tf)
      if(tf) then
         way_BZintegral = GAUSSIAN_B
         goto 1001
      end if
      call strncmp0(tag_g,trim(rstr),tf)
      if(tf) then
         way_BZintegral = GAUSSIAN_B
         goto 1001
      end if

      call strncmp0(tag_tetrahedron, trim(rstr), tf)
      if(tf) then
         way_BZintegral = L_TETRAHEDRON
         goto 1001
      end if
      call strncmp0(tag_t, trim(rstr), tf)
      if(tf) then
         way_BZintegral = L_TETRAHEDRON
         goto 1001
      end if
      
      stop ' ! tag for BZ_integration method is invalid <<m_CtrlP_rd_LinearResponse>>'
1001  continue
      if ( ipriinputfile >= 2 .and. printable) then
         write(nfout,'(" !* Brillouin zone integration  method = ",a10)') trim(rstr)
      endif
      
    end subroutine set_integration_method

    subroutine set_band_gap_correction
      integer f_getRealValue
      if( f_getRealValue( tag_scissor, dret, 'hartree') == 0) then
         scissor=dret
      else
         scissor=0.0d0
      end if
    end subroutine set_band_gap_correction
    
   end subroutine m_CtrlP_rd_LinearResponse
   

 end module m_LinearResponse_Control

! Copyright (c) 2012, Minoru Otani <minoru.otani@aist.go.jp> 
! 
! Permission is hereby granted, free of charge, to any person 
! obtaining a copy of this software and associated documentation 
! files (the "Software"), to deal in the Software without restriction, 
! including without limitation the rights to use, copy, modify, merge, 
! publish, distribute, sublicense, and/or sell copies of the Software, 
! and to permit persons to whom the Software is furnished to do so, 
! subject to the following conditions:
 
! The above copyright notice and this permission notice shall be 
! included in all copies or substantial portions of the Software.
 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
! EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
! OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
! NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
! HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
! WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
! DEALINGS IN THE SOFTWARE.

Subroutine cft_1z(c, nsl, nz, ldz, isign, cout)
  Implicit None
#ifndef SX
#ifdef __NEC__
  Include "aslfftw3.f"
#else
#include "fftw3.f"
#endif
#endif

  Integer,    Intent(In)  :: nsl, nz, ldz, isign
  Complex(8), Intent(In)  :: c(0:nsl*ldz-1)
  Complex(8), Intent(Out) :: cout(0:nsl*ldz-1)
  
#ifndef SX
  Integer(8) :: plan
  Integer :: FFTW_WARD, isl

  If ( isign < 0 ) Then
     FFTW_WARD = FFTW_FORWARD
  Else
     FFTW_WARD = FFTW_BACKWARD
  End If

  Do isl = 0, nsl-1
     Call dfftw_plan_dft_1d ( plan, nz, c(isl*ldz), cout(isl*ldz), FFTW_WARD, &
          FFTW_ESTIMATE )
     Call dfftw_execute ( plan )
     Call dfftw_destroy_plan ( plan )
  End Do

  If( isign < 0 ) Then
     cout(:) = cout(:) / nz
  End If
#else
  Integer, save :: isw=0
  Integer :: n,ierr,isl
  Real(8),allocatable,dimension(:) :: rpart,ipart
  Integer,save :: ifax(20)
  Real(8),allocatable,dimension(:),save :: trigs
  Real(8),allocatable,dimension(:) :: wk
  allocate(rpart(0:nsl*ldz-1));rpart(:) = dble(c(:))
  allocate(ipart(0:nsl*ldz-1));ipart(:) = dimag(c(:))
  n = nsl*ldz
  if(isw==0) allocate(trigs(2*n))
  allocate(wk(2*n))

  if(isw.eq.0)then
     do isl=0,nsl-1
        call dfc1fb(nz,rpart(isl*ldz),ipart(isl*ldz),nz,isw,ifax,trigs,wk,ierr)
     enddo
     isw=1
  else
     if(isign<0)then
        isw = 1
     else
        isw = -1
     endif
     do isl=0,nsl-1
        call dfc1bf(nz,rpart(isl*ldz),ipart(isl*ldz),nz,isw,ifax,trigs,wk,ierr)
     enddo
  endif
  cout(:) = dcmplx(rpart(:),ipart(:))
  if(isign<0) cout(:) = cout(:)/nz
  deallocate(rpart)
  deallocate(ipart)
  deallocate(wk)
#endif


End Subroutine cft_1z

!================================================
!  Software name : STM
!  Subroutine(s) : rd_WFs_doFFT_and_solve_eq, alloc_afft_etc, dealloc_afft_etc,
!                  print_ck_etc,print_VLC_Rspace, sumup_afft_to, print_dz_etc,
!                  print_summative_charges
!  Author(s)     : Koichi Kato and Takahiro Yamasaki (June 7, 2004)
!
!  FURTHER MODIFICATION: Junichiro  Koga (June 24, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

subroutine rd_WFs_doFFT_and_solve_eq
! $Id: rd_WFs_doFFT_and_solve_eq.F90,v 1.1.1.1 2004/06/26 11:21:37 yamasaki Exp $
  use m_Const_Parameters,     only : DP, BUCS, CARTS &
       &                           , HIGHER, LOWER, IN_BETWEEN, INVERSE, DIRECT &
       &                           , Hartree, NEGATIVE, BOHR
  use m_Control_Parameters,   only : e1, e2, izi, izf,rini,rfin,nfin,erlmt &
       &                           , n_fc,n_fc_i
  use m_Charge_File,          only : natm2,x_origin,y_origin,z_origin &
       &                           , fft_param,cell1,cell2,cell3 &
       &                           , iatomtype,ival,atom_pos
  use m_Kpoints, only :              kv3, nspin
  use m_Electronic_Structure, only : neordr,eko,efermi &
       &                           , m_ES_rd_WFs, m_ES_rd_VLCs &
       &                           , m_ES_WF_in_Rspace_fine_mesh &
       &                           , m_ES_VLC_in_Rspace_fine_mesh
  use m_FFT,                  only : nfft, nfftp, nfftpf, nlpf, fft_box_size_fine &
       &                           , m_FFT_WF_2dFFT_fine, m_FFT_Vlocal_W_fine
  use m_Crystal_Structure,    only : neg, zl
  use m_Files,                only : nfzaj, nfinp, nfout, nfchgu, nfchgd, nfvlc, nfchgu_p &
       &                           , nfchgd_p, nfvlcr,nfvlcr_av
  use m_Kpoints,              only : vkxyz
  use m_PlaneWaveBasisSet,    only : m_pwBS_kinetic_energies
  use m_ArraySize_Parameters, only : kspin, kimg

  implicit none
  integer :: i, kg2d, nls, it, ig, nlfid, n,n0, nmp, nnp
  real(kind=DP) :: ertmp, ermx, rmix, dz, ck, rdz, dz2, errsum
  real(kind=DP), allocatable, dimension(:,:,:) :: sfft, tfft
  real(kind=DP), allocatable, dimension(:,:,:) :: c, y
  real(kind=DP), allocatable, dimension(:,:)   :: am, w
  real(kind=DP), allocatable, dimension(:) :: ekin
  real(kind=DP), allocatable, dimension(:) :: bfft, cfft
  real(kind=DP), allocatable, dimension(:) :: ertmp_t, domin
  real(kind=DP), allocatable, dimension(:)  :: afft
  real(kind=DP) :: fac
  integer                                   :: id_sname = -1
  integer                                   :: ik, is, ib, ibto, ikp
  integer, dimension(3) :: tmpind

  nmp = fft_box_size_fine(2)
  nnp = fft_box_size_fine(3)

  allocate(bfft(nfftpf));bfft=0.d0
  call m_ES_rd_VLCs(nfvlc)               !-(m_E.S.)
  do is = 1, nspin
     call m_ES_VLC_in_Rspace_fine_mesh(is,bfft) !-(m_E.S.) \Vlc(G) -> \Vlc(r)
     call print_VLC_Rspace(is)             !-(contained here)
  enddo
  deallocate(bfft)

contains

  subroutine print_VLC_Rspace(is)
    integer, intent(in) :: is
    integer :: i, n, idp,nlp,nmp,nnp,nlphf, j,k, ip(4),knew,inew,jnew,nlph
    real(kind=DP), allocatable, dimension(:,:,:) :: wk,wk2
    real(kind=DP) :: vav

    idp = fft_box_size_fine(0)
    nlp = fft_box_size_fine(1); nmp = fft_box_size_fine(2); nnp = fft_box_size_fine(3)
    if(kimg.eq.1) then
       nlphf = idp/2
    else
       nlphf = idp
    end if
    
    allocate(wk(nlp,nmp,nnp))
    nlph = nlp
    if(kimg.eq.1) nlph = nlp/2
    do i = 1, nmp
       do j = 1, nnp
          do k = 1, nlp
             if(kimg.eq.1.and.k.gt.nlphf) then
                knew = idp -k
                jnew = nnp+2 -j
                inew = nmp+2 -i
                if(jnew.gt.nnp) then
                   jnew = jnew - nnp
                end if
                if(inew.gt.nmp) then
                   inew = inew - nmp
                end if
             else
                knew = k
                jnew = j
                inew = i
             end if
             ip(1) = nlphf*nmp*(jnew-1) + nlphf*(inew-1) + knew
             wk(k,i,j) = bfft(ip(1)*2-1) * Hartree ! to eV units
          end do
       end do
    end do

    write(nfvlcr_av,'(a,f10.5)') '# Fermi energy (eV) ',efermi*Hartree
    write(nfvlcr_av,'(a)')       '# distance along the z-axis(Angstrom)  averaged local potential (eV) '
    
    ! output the local potential in cube format
    do i=1,nlpf
       vav=0.d0
       do j=1,nnp
          do k=1,nmp
             vav = vav+wk(i,k,j)
          enddo
       enddo
       if ( n_fc(1).eq.1 ) then
           dz = cell1(1) * BOHR
       else if ( n_fc(1).eq.2 ) then
           dz = cell2(2) * BOHR
       else if ( n_fc(1).eq.3 ) then
           dz = cell3(3) * BOHR
       endif

       write(nfvlcr_av,'(f14.6,3e20.6)') dz*i, vav/dble(nnp*nmp)
    enddo

    write(nfvlcr,9001) nlpf*nmp*nnp,nmp,nnp,nlpf
    write(nfvlcr,*) ' -- local potential -- '

    if ( kimg .eq. 1 ) then
      fac = 2
    else
      fac = 1
    endif

    write(nfvlcr,'(i8,3f20.10)') nint(natm2/fac), x_origin,y_origin,z_origin
    tmpind(n_fc(1)) = nlpf
    tmpind(n_fc(2)) = nmp
    tmpind(n_fc(3)) = nnp

    write(nfvlcr,'(i8,3f20.10)') tmpind(1),cell1(1:3)
    write(nfvlcr,'(i8,3f20.10)') tmpind(2),cell2(1:3)
    write(nfvlcr,'(i8,3f20.10)') tmpind(3),cell3(1:3)

    do i=1,natm2/fac
      write(nfvlcr,'(i8,4f20.10)') iatomtype(i),ival(i),atom_pos(i,1:3)
    enddo

    allocate(wk2(tmpind(3),tmpind(2),tmpind(1)));wk2=0.d0

    do j=1,nnp
       do k=1,nmp
          do i=1,nlpf
             tmpind(n_fc_i(1)) = j
             tmpind(n_fc_i(2)) = k
             tmpind(n_fc_i(3)) = i
             wk2(tmpind(1),tmpind(2),tmpind(3)) = wk(i,k,j)
          enddo
       enddo
    enddo

    write(nfvlcr,9002) wk2

    deallocate(wk2)
    deallocate(wk)
9001 format(' CHARGE DENSITY NE = ',i8,'(',3i5,')')
9002 format(6e12.4)

  end subroutine print_VLC_Rspace

end subroutine rd_WFs_doFFT_and_solve_eq

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: dxml_fft, mulfac
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
      subroutine dxml_fft(iop,id,nl,nm,nn,afft)
c $Id: dxmlfft.f 570 2017-04-21 20:34:50Z yamasaki $
      implicit real*8(a-h,o-z)
      include '/usr/include/DXMLDEF.FOR'
      real*8 afft(*)
      record /DXML_d_fft_structure_3D/ fft_struct_cd,fft_struct_wd
      record /DXML_z_fft_structure_3D/ fft_struct_cz,fft_struct_wz
      save fft_struct_cd,fft_struct_wd
      save fft_struct_cz,fft_struct_wz
      save nfft_cd,nfft_cz,nfft_wd,nfft_wz
      save nbox_cd,nbox_cz,nbox_wd,nbox_wz
c
c     IOP=1..DIRECT, IOP=2..INVERSE (REAL TRANSFORM)
c     IOP=1..INVERSE, IOP=2..DIRECT (COMPLEX TRANSFORM)
c
      entry cd_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call dfft_apply_3d('r','c','f',afft,afft,id,nm,
     $                        fft_struct_cd,1,1,1)
        else
          call dfft_apply_3d('c','r','b',afft,afft,id,nm,
     $                        fft_struct_cd,1,1,1)
c         scale=nfft_cd
c         call dscal(nbox_cd,scale,afft,1)
          call mulfac(afft,nbox_cd,nfft_cd)
        endif
      return
c
      entry cz_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call zfft_apply_3d('c','c','b',afft,afft,id,nm,
     $                        fft_struct_cz,1,1,1)
c         scale=nfft_cz
c         call dscal(nbox_cz,scale,afft,1)
          call mulfac(afft,nbox_cz,nfft_cz)
        else
          call zfft_apply_3d('c','c','f',afft,afft,id,nm,
     $                        fft_struct_cz,1,1,1)
        endif
      return
c
      entry wd_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call dfft_apply_3d('r','c','f',afft,afft,id,nm,
     $                        fft_struct_wd,1,1,1)
        else
          call dfft_apply_3d('c','r','b',afft,afft,id,nm,
     $                        fft_struct_wd,1,1,1)
c         scale=nfft_wd
c         call dscal(nbox_wd,scale,afft,1)
          call mulfac(afft,nbox_wd,nfft_wd)
        endif
      return
c
      entry wz_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call zfft_apply_3d('c','c','b',afft,afft,id,nm,
     $                        fft_struct_wz,1,1,1)
c         scale=nfft_wz
c         call dscal(nbox_wz,scale,afft,1)
          call mulfac(afft,nbox_wz,nfft_wz)
        else
          call zfft_apply_3d('c','c','f',afft,afft,id,nm,
     $                        fft_struct_wz,1,1,1)
        endif
      return
          
      entry cd_init(id,nl,nm,nn)
        call dfft_init_3d(nl,nm,nn,fft_struct_cd,.true.)
        nbox_cd=id*nm*nn
        nfft_cd=nl*nm*nn
        return
      entry cz_init(id,nl,nm,nn)
        call zfft_init_3d(nl,nm,nn,fft_struct_cz,.true.)
        nbox_cz=id*nm*nn*2
        nfft_cz=nl*nm*nn*2
        return
      entry wd_init(id,nl,nm,nn)
        call dfft_init_3d(nl,nm,nn,fft_struct_wd,.true.)
        nbox_wd=id*nm*nn
        nfft_wd=nl*nm*nn
        return
      entry wz_init(id,nl,nm,nn)
        call zfft_init_3d(nl,nm,nn,fft_struct_wz,.true.)
        nbox_wz=id*nm*nn*2
        nfft_wz=nl*nm*nn*2
        return
      end
      subroutine mulfac(afft,nbox,nfft)
      implicit real*8(a-h,o-z)
      dimension afft(nbox)
      scale=dble(nfft)
      do i=1,nbox
        afft(i)=afft(i)*scale
      enddo
      return
      end

module m_PAW_Tecplot
    use m_Const_Parameters,     only : DP
    implicit none
    private
    
    public:: output_box_tecplot
    public:: output_box_tecplot2
    public:: unusedUnit
    
contains
    
    subroutine output_box_tecplot(v_data,vec,title,axis,unit,mode)
        real(kind=DP),intent(in),dimension(0:,0:,0:) :: v_data
        real(kind=DP),dimension(3,3),intent(in):: vec
        character(len=*),intent(in):: title,axis
        integer,intent(in):: unit,mode

        integer:: i,j,k,ie,je,ke
        real(DP):: x,y,z,xx,yy,zz,vec2(3,3)

        ie=size(v_data,1)-1
        je=size(v_data,2)-1
        ke=size(v_data,3)-1
        
        vec2=vec
        
        if(mode.eq.0) &
            write(unit,'(3a)') 'VARIABLES = "X", "Y", "Z", "',trim(axis),'"'
        write(unit,'(3a,i3,a,i3,a,i3,a)') &
           'ZONE T=',trim(title),' I=',ie+1,', J=',je+1,', K=',ke+1,', F=POINT'
        do k=0,ke
	        do j=0,je
	            do i=0,ie
                    if(ie.ne.0) xx=dble(i)/dble(ie)
                    if(je.ne.0) yy=dble(j)/dble(je)
                    if(ke.ne.0) zz=dble(k)/dble(ke)
	                x=vec2(1,1)*xx+vec2(1,2)*yy+vec2(1,3)*zz
	                y=vec2(2,1)*xx+vec2(2,2)*yy+vec2(2,3)*zz
                    z=vec2(3,1)*xx+vec2(3,2)*yy+vec2(3,3)*zz
	                write(unit,'(4e19.6)') x,y,z,v_data(i,j,k)
                end do
            end do
        end do
        return
    end subroutine output_box_tecplot
    
    subroutine output_box_tecplot2(r_data,v_data,title,axis,unit,mode)
        real(kind=DP),intent(in),dimension(1:,1:,1:,1:)   :: r_data
        real(kind=DP),intent(in),dimension(1:,1:,1:)      :: v_data
        character(len=*),intent(in):: title,axis
        integer,intent(in):: unit,mode

        integer:: i,j,k,ie,je,ke

        ie=size(v_data,1)
        je=size(v_data,2)
        ke=size(v_data,3)
        
        if(mode.eq.0) &
            write(unit,'(3a)') 'VARIABLES = "X", "Y", "Z", "',trim(axis),'"'
        write(unit,'(3a,i3,a,i3,a,i3,a)') &
           'ZONE T=',trim(title),' I=',ie,', J=',je,', K=',ke,', F=POINT'
        do k=1,ke
	        do j=1,je
	            do i=1,ie
	                write(unit,'(4e19.6)') r_data(i,j,k,1), &
	                                        r_data(i,j,k,2), &
	                                        r_data(i,j,k,3), &
	                                        v_data(i,j,k)
                end do
            end do
        end do
        return
    end subroutine output_box_tecplot2
    
    function unusedUnit()    
        integer:: unusedUnit
        integer:: unit
        logical:: opened
        do unit=99,10,-1
        inquire(unit,opened=opened)
        if(.not.opened) then
            unusedUnit = unit
            return
        endif
        enddo
        write(6,*) 'All devices are used!'
        stop
    end function unusedUnit


end module m_PAW_Tecplot

#undef NEC_TIMER
#ifdef NEC_TIMER
#  define START_TIMER(a) call start_timer(a)
#  define STOP_TIMER(a)  call stop_timer(a)
#else
#  define START_TIMER(a)
#  define STOP_TIMER(a)
#endif
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  MODULE:  m_ES_WF_by_Davidson
!
!  AUTHOR(S): T. Yamamoto   June/12/2005
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_ES_WF_by_Davidson
! $Id: m_ES_WF_by_Davidson.F90 570 2017-04-21 20:34:50Z yamasaki $
#ifdef TRANSPOSE
#ifdef VPP
#define _ODD_BOUNDARY_
#endif
#ifdef SX
#define _ODD_BOUNDARY_
#endif
#ifdef NEC_TUNE1
#define _ODD_BOUNDARY_
#endif
  use m_Const_Parameters,    only : DP,SP,DIRECT,ON,OFF,SCF,GAMMA &
        &                         , SmallestPositiveNumber,SKIP,EXECUT,zi, ELECTRON, OLD
  use m_Parallelization,     only : MPI_CommGroup &
       &                          , myrank_e,myrank_k,map_e,map_k,ista_e,iend_e,istep_e &
       &                          , ista_k,iend_k,np_g1k,ista_g1,mpi_k_world,ierr,map_z &
       &                          , np_e,npes,nrank_e,mype
  use m_Control_Parameters,  only : nspin,ipridavidson,kimg,neg,af,ndavid &
       &                          , max_iter_david, delta_eig_occup, delta_eig_empty &
#ifdef SAVE_FFT_TIMES
       &                          , eps_david, max_subspace_size, sw_save_fft
#else
       &                          , eps_david, max_subspace_size
#endif
  use m_Control_Parameters,  only : sw_dav_scalapack, dav_nprow, dav_npcol, dav_divide_square &
                                  , dav_block_size
  use m_Files,               only : nfout
  use m_Timing,              only : tstatc0_begin, tstatc0_end
!fj$$F  use m_FFT,                 only : nfft,fft_box_size_WF, m_FFT_Vlocal_W, m_FFT_WF
  use m_FFT,                 only : nfft,fft_box_size_WF
  use m_FFT,                 only : m_FFT_Vlocal_W, m_FFT_WF
  use m_Kpoints,             only : kv3,vkxyz, k_symmetry
  use m_PlaneWaveBasisSet,   only : kg1, iba, igf, nbase, m_pwBS_kinetic_energies
  use m_Electronic_Structure,only : zaj_l, neordr, nrvf_ordr, eko_l, vlhxcQ &
#ifdef SAVE_FFT_TIMES
 &                                , status_saved_phifftr &
#endif
       &                          , occup_l&
       &                          , fsr_l,fsi_l, vnlph_l, vlhxc_l
  use m_Electronic_Structure,only : m_ES_Vlocal_in_Rspace &
 &                                , m_ES_WF_in_Rspace &
 &                                , m_ES_wd_zaj_small_portion &
 &                                , m_ES_decide_precon_factor &
 &                                , m_ES_wd_eko
  use m_ES_ortho            ,only : np_g1k_x
  use m_ES_ortho            ,only : m_ES_W_transpose_r                              &
 &                                , m_ES_W_transpose_back_r
  use m_ES_nonlocal         ,only : m_ES_Vnonlocal_W                                  &
 &                                , m_ES_betar_dot_WFs_4_each_k                       &
 &                                , m_ES_alloc_scss_etc                               &
 &                                , m_ES_dealloc_scss_etc
#endif
  use m_Ionic_System,       only : natm, iwei, ityp, ntyp
  use m_PseudoPotential,    only : ilmt,nlmta,lmta,q,dion &
       &                         , lmtt,ltp,mtp &
       &                         , m_PP_include_vanderbilt_pot &
       &                         , ipaw,dion_paw
  use m_NonLocal_Potential, only : snl
#ifdef NEC_TIMER
  use nec_timer
#endif

! ==================================== added by K. Tagami ============== 11.0
  use m_Const_Parameters,    only : CMPLDP, Neglected, BuiltIn
  use m_Control_Parameters,  only : noncol, ndim_spinor, ndim_chgpot, ndim_magmom, &
       &                            SpinOrbit_mode, sw_hubbard
  use m_PseudoPotential,     only : q_noncl, dion_scr_noncl
  use m_Electronic_Structure,  only : m_ES_Vlocal_in_Rspace_noncl, &
       &                              m_ES_sort_eigen_vals_noncl

  use m_FFT,                 only : m_FFT_Vlocal_W_noncl
! ====================================================================== 11.0
  use mpi


  implicit none

  integer :: nsize_subspace, nsize_matrix
  integer :: nsize_sb_now, nsize_mt_now, nsize_mt_old
  real(kind=DP), allocatable, dimension(:) :: w1hw2,w1hw2_mpi
  real(kind=DP), allocatable, dimension(:) :: w1sw2,w1sw2_mpi
  real(kind=DP), allocatable, dimension(:,:,:,:) :: zat_l
  real(kind=DP), allocatable, dimension(:,:,:) :: zah_l
  real(kind=DP), allocatable, dimension(:,:,:) :: fsr,fsi
  real(kind=DP), allocatable, dimension(:,:,:) :: zaj_l_backup
  logical, allocatable, dimension(:) :: feigconv
  integer, allocatable, dimension(:) :: ibover
#ifdef _USE_SCALAPACK_
  integer :: nprow, npcol, nrowa, ncola
  integer, dimension(9) :: desca
  integer :: lwork1, liwork1
  integer :: lwork2, liwork2, lrwork2
  integer :: ctxt
! === DEBUG by tkato 2012/12/20 ================================================
  integer :: myprow, mypcol
! ==============================================================================
#endif

! ================================= added by K. Tagami ================= 11.0
  real(kind=DP), allocatable, dimension(:,:,:,:,:) :: zat_l_noncl
  real(kind=DP), allocatable, dimension(:,:,:,:) :: zah_l_noncl
  real(kind=DP), allocatable, dimension(:,:,:,:) :: fsr_noncl, fsi_noncl
  real(kind=DP), allocatable, dimension(:,:,:,:) :: zaj_l_backup_noncl
! ===================================================================== 11.0

!  include 'mpif.h'
contains

  subroutine m_ESdavidson_Renew_WF(nfout,precon)
    integer, intent(in) :: nfout,precon

    integer             :: ispin, ik, iksnl, switch_of_eko_part
    integer :: idavid,itot
    real(kind=DP), allocatable, dimension(:) ::  afft, bfft
!!$    real(kind=DP), dimension(kg1) :: ekin,vnldi,hdiag,sdiag
    real(kind=DP), allocatable, dimension(:) :: ekin,vnldi,hdiag,sdiag
    real(kind=DP) :: vlhxc0
    logical :: frestart
    integer :: max_idavid, max_itot
    integer :: idavid_now, itot_now, ipri0
! ========================================================================================
    integer :: n_unconv
! ========================================================================================

    max_idavid = 1
    max_itot = 1

    allocate(ekin(kg1),vnldi(kg1),hdiag(kg1),sdiag(kg1))
    call m_ES_alloc_scss_etc()
    allocate(afft(nfft)); allocate(bfft(nfft))

    call allocate_matrix
#ifdef _USE_SCALAPACK_
! === DEBUG by tkato 2012/12/20 ================================================
    if(sw_dav_scalapack == ON) call create_scalapack_context()
! ==============================================================================
#endif
    do ispin = 1, nspin, (af+1)
       call m_ES_Vlocal_in_Rspace(ispin,afft)      ! (ptfft1) vlhxc_l->afft
       call vlhxc_l_zero_term(vlhxc0,ispin)        ! vlhxc_l -> vlhxc0
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle          ! MPI
          iksnl = (ik-1)/nspin + 1
          call allocate_t_matrix(ik) ! -> np_g1k_x
          call m_pwBS_kinetic_energies(ik,vkxyz,ekin) ! (diakin) ->ekin
          if(precon==ON) then
             call Vnonlocal_Diagonal_part(ispin,ik,iksnl,vnldi)
             hdiag(1:iba(ik)) = ekin(1:iba(ik)) + vlhxc0 + vnldi(1:iba(ik))

! ======================================= modified by K. Tagami ====== 11.0
!             call S_Diagonal_part(ik,iksnl,sdiag)
             call S_Diagonal_part(ispin,ik,iksnl,sdiag)
! ==================================================================== 11.0

          end if
          !!$write(nfout,*) 'debug loop ik=',ik
          max_itot=0
          max_idavid=0
          Loop: do itot=1,max_iter_david
             itot_now = itot
             if(itot>max_itot) max_itot=itot
             feigconv = .false.
             David_Loop: do idavid=1,ndavid
                idavid_now = idavid
                if(idavid>max_idavid) max_idavid=idavid
                !!$write(nfout,*) 'debug loop itot,idavid=',itot,idavid
                if(precon==ON) then
                   call m_ES_Vnonlocal_W(ik,iksnl,ispin,switch_of_eko_part=OFF) ! -> vnlph_l
                else
                   call m_ES_Vnonlocal_W(ik,iksnl,ispin,switch_of_eko_part=ON) ! -> vnlph_l
                end if
                call build_subspace(ik,ekin,hdiag,sdiag,afft,bfft,idavid,precon) ! -> zajold_l
                call allreduce_fs(ik,idavid) ! -> fsr,fsi
                call evolve_WFs_in_subspace&     !-(m_ES_WF_by_Davidson)
                  &(ik,ispin,ekin,afft,bfft,idavid,frestart) !-> zaj_l
                if(ik==1.and.ipridavidson>= 2) &
                  & call m_ES_wd_zaj_small_portion(nfout,ik," -- after davidson --",21)
                call m_ES_betar_dot_WFs_4_each_k(nfout,ik)   ! -> fsr_l,fsi_l
                if(frestart) exit David_Loop
                if(eigenvalues_are_converged(n_unconv)) exit Loop
                if(nsize_sb_now + n_unconv > max_subspace_size) exit David_Loop
             end do David_Loop
          end do Loop
          if(ipridavidson>=2) then
             write(nfout,'("Davidson: ik=",i5," itot=",i5," idavid=",i5," subspace=",i5)') ik, itot_now, idavid_now, nsize_sb_now
          end if
          call deallocate_t_matrix
       enddo      ! k-point loop
    enddo      ! spin loop
!fj$$#endif
#ifdef _USE_SCALAPACK_
! === DEBUG by tkato 2012/12/20 ================================================
    if(sw_dav_scalapack == ON) call destroy_scalapack_context()
! ==============================================================================
#endif
    call deallocate_matrix
    if(ipridavidson>=2) then
       write(nfout,'("Davidson: max_itot=",i5," max_idavid=",i5)') max_itot,max_idavid
    end if

!!  ( in case of af=1 )
    if(af /= 0) then
       call cp_eigen_values_for_af       !-(contained here)
       call expand_neordr_and_nrvf_ordr  !-(contained here)
    end if

    call get_ipri0(ipridavidson,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)
    deallocate(bfft);   deallocate(afft)
    call m_ES_dealloc_scss_etc()

    deallocate(ekin,vnldi,hdiag,sdiag)

  contains

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,MPI_CommGroup,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    logical function eigenvalues_are_converged(n_unconv)
       integer, intent(out) :: n_unconv
       integer :: ib

       n_unconv = 0
       eigenvalues_are_converged = .true.
       do ib=1,neg
          if(.not.feigconv(ib)) then
             eigenvalues_are_converged = .false.
             n_unconv = n_unconv + 1
          end if
       end do
    end function eigenvalues_are_converged

    subroutine cp_eigen_values_for_af
      integer :: ik,ib
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle    ! MPI
         do ib = 1, np_e                    ! MPI
            eko_l(ib,ik+af) = eko_l(ib,ik)
         enddo
      enddo
    end subroutine cp_eigen_values_for_af

    subroutine expand_neordr_and_nrvf_ordr
      integer :: ik
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle     ! MPI
         neordr(1:neg,ik+af) = neordr(1:neg,ik)
         nrvf_ordr(1:neg,ik+af) = nrvf_ordr(1:neg,ik)
      end do
    end subroutine expand_neordr_and_nrvf_ordr

  end subroutine m_ESdavidson_Renew_WF

! ================================ added by K. Tagami =================== 11.0
  subroutine m_ESdavidson_Renew_WF_noncl(nfout,precon)
    integer, intent(in) :: nfout,precon

    integer             :: ik, iksnl, switch_of_eko_part
    integer :: idavid,itot
    real(kind=DP), allocatable ::  afft_kt(:,:)
    real(kind=DP), allocatable ::  bfft_kt(:,:)
    real(kind=DP), allocatable :: vnlph_noncl(:,:,:,:)

    real(kind=DP), allocatable :: ekin(:)

    real(kind=DP) :: vlhxc0( ndim_chgpot )

#ifdef USE_COMPLEX_VNLDI
    complex(kind=CMPLDP), allocatable :: hdiag(:,:), sdiag(:,:)
    complex(kind=CMPLDP), allocatable :: vnldi_noncl(:,:)
#else
    real(kind=DP), allocatable :: hdiag(:,:), sdiag(:,:)
    real(kind=DP), allocatable :: vnldi_noncl(:,:)
#endif

    logical :: frestart
    integer :: max_idavid, max_itot
    integer :: idavid_now, itot_now, ipri0
    integer :: n_unconv

    integer :: is1, is2, istmp, k2

    integer :: iitmp, jjtmp

    max_idavid = 1
    max_itot = 1

!$$#ifndef PARA3D
    allocate( ekin(kg1) )
    allocate( vnldi_noncl(kg1,ndim_spinor) )
    allocate( hdiag(kg1,ndim_spinor) ); hdiag = 0.0d0
    allocate( sdiag(kg1,ndim_spinor) ); sdiag = 0.0d0
    call m_ES_alloc_scss_etc()
!$$#endif
    allocate(afft_kt(nfft,ndim_chgpot)); afft_kt = 0.0d0
    allocate(bfft_kt(nfft,ndim_spinor)); bfft_kt = 0.0d0
    allocate(vnlph_noncl(kg1,np_e,kimg,ndim_spinor)); vnlph_noncl = 0.0d0

    call allocate_matrix_noncl
!$$#ifndef PARA3D

    call m_ES_Vlocal_in_Rspace_noncl( afft_kt )    ! (ptfft1) vlhxc_l->afft
    call vlhxc_l_zero_term_noncl( vlhxc0 )        ! vlhxc_l -> vlhxc0
#ifdef _USE_SCALAPACK_
! === DEBUG by tkato 2012/12/20 ================================================
    if(sw_dav_scalapack == ON) call create_scalapack_context()
! ==============================================================================
#endif

    Do ik=1, kv3, ndim_spinor
       if ( map_k(ik) /= myrank_k )  cycle          ! MPI
       iksnl = (ik-1)/ndim_spinor + 1

       call allocate_t_matrix(ik) ! -> np_g1k_x
       call m_pwBS_kinetic_energies( ik, vkxyz, ekin ) ! (diakin) ->ekin

       if ( precon==ON ) then
          vnldi_noncl = 0.0d0;   sdiag = 1.0d0

          Do is1=1, ndim_spinor
             Do is2=1, ndim_spinor
                istmp = ( is1-1 )*ndim_spinor +is2

                call Vnonlocal_Diagonal_part_noncl( istmp, ik, iksnl, &
                     &                              vnldi_noncl(:,is1) )
             End do
          End do

          Do is1=1, ndim_spinor
             hdiag(1:iba(ik),is1) = ekin(1:iba(ik)) &
                  &                + vlhxc0(1) + vnldi_noncl(1:iba(ik),is1)

          End do
          Do is1=1, ndim_spinor
             Do is2=1, ndim_spinor
                istmp = ( is1-1 )*ndim_spinor +is2

                call S_Diagonal_part_noncl( istmp, ik, iksnl, sdiag(:,is1) )
             End do
          End do

       end if

       max_itot=0;     max_idavid=0
       Loop: do itot=1,max_iter_david
         itot_now = itot
         if ( itot>max_itot ) max_itot=itot
         feigconv = .false.

         David_Loop: do idavid=1,ndavid
           idavid_now = idavid
           if ( idavid>max_idavid ) max_idavid=idavid

           vnlph_noncl = 0.0d0
           Do is1=1, ndim_spinor
             Do is2=1, ndim_spinor
               istmp = ( is1-1 )*ndim_spinor +is2
               k2 = ik +is2 -1

               if ( precon==ON ) then
                  call m_ES_Vnonlocal_W( k2, iksnl, istmp, switch_of_eko_part=OFF )
                                                          ! -> vnlph_l
               else
                  call m_ES_Vnonlocal_W( k2, iksnl, istmp, switch_of_eko_part=ON )
                                                          ! -> vnlph_l
               endif
               vnlph_noncl(:,:,:,is1) = vnlph_noncl(:,:,:,is1) &
                  &                     + vnlph_l(:,:,:)
             End do
           End do

           call build_subspace_noncl( ik, ekin, hdiag, sdiag, afft_kt, bfft_kt, &
	&                             vnlph_noncl, idavid, precon )    ! -> zajold_l

           call allreduce_fs_noncl( ik, idavid )     ! -> fsr,fsi

           call evolve_WFs_in_subspace_noncl( ik, ekin, afft_kt, bfft_kt,&
	&                                     idavid, frestart ) !-> zaj_l

           if ( ik==1 .and. ipridavidson>= 2 ) then
             Do is1=1, ndim_spinor
               call m_ES_wd_zaj_small_portion( nfout, ik+is1-1, &
	&                                      " -- after davidson --",21 )
             End do
           endif
           Do is1=1, ndim_spinor
              call m_ES_betar_dot_WFs_4_each_k( nfout,ik+is1-1 )
                                             ! -> fsr_l,fsi_l
           End do

           if (frestart) exit David_Loop
           if (eigenvalues_are_converged(n_unconv)) exit Loop
           if (nsize_sb_now + n_unconv > max_subspace_size) exit David_Loop
         end do David_Loop
       end do Loop

!       stop

      if (ipridavidson>=2) then
          write(nfout,'("Davidson: ik=",i5," itot=",i5," idavid=",i5, &
	&               " subspace=",i5)') ik, itot_now, idavid_now, nsize_sb_now
       end if
       call deallocate_t_matrix

    enddo      ! k-point loop

!$$#endif
#ifdef _USE_SCALAPACK_
! === DEBUG by tkato 2012/12/20 ================================================
    if(sw_dav_scalapack == ON) call destroy_scalapack_context()
! ==============================================================================
#endif

    call deallocate_matrix_noncl
    if(ipridavidson>=2) then
       write(nfout,'("Davidson: max_itot=",i5," max_idavid=",i5)') max_itot,max_idavid
    end if


! ****************************************** This is important ******
    call m_ES_sort_eigen_vals_noncl()
! *******************************************************************


!$$#ifndef PARA3D
    call get_ipri0(ipridavidson,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)
!$$#endif
    deallocate(bfft_kt);   deallocate(afft_kt)
    call m_ES_dealloc_scss_etc()

    deallocate(ekin,vnldi_noncl,hdiag,sdiag)

  contains

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,MPI_CommGroup,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

!$$#ifndef PARA3D
    logical function eigenvalues_are_converged(n_unconv)
       integer, intent(out) :: n_unconv
       integer :: ib

       n_unconv = 0
       eigenvalues_are_converged = .true.
       do ib=1,neg
          if(.not.feigconv(ib)) then
             eigenvalues_are_converged = .false.
             n_unconv = n_unconv + 1
          end if
       end do
    end function eigenvalues_are_converged
!$$#endif

  end subroutine m_ESdavidson_Renew_WF_noncl
! =========================================================== 11.0

  subroutine allocate_matrix
    nsize_subspace = neg*ndavid
    nsize_matrix =  max_subspace_size*(max_subspace_size+1)/2
    allocate(feigconv(neg))
    allocate(ibover(nsize_subspace))
    allocate(fsr(neg,nlmta,ndavid))
    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       allocate(fsi(neg,nlmta,ndavid))
    end if
    allocate(zaj_l_backup(kg1,np_e,kimg)) ! MPI
  end subroutine allocate_matrix

! ================================ added by K. Tagami =============== 11.0
  subroutine allocate_matrix_noncl
    nsize_subspace = neg*ndavid
    nsize_matrix =  max_subspace_size*(max_subspace_size+1)/2
    allocate(feigconv(neg))
    allocate(ibover(nsize_subspace))

    allocate( fsr_noncl( neg, nlmta, ndavid, ndim_spinor ) )

    if(.not.(kv3/ndim_spinor==1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       allocate( fsi_noncl( neg, nlmta, ndavid, ndim_spinor ) )
    end if

    allocate( zaj_l_backup_noncl( kg1, np_e, kimg, ndim_spinor ))

  end subroutine allocate_matrix_noncl
! ======================================================================= 11.0

  subroutine deallocate_matrix
    deallocate(feigconv)
    deallocate(ibover)
    deallocate(fsr)
    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       deallocate(fsi)
    end if
    deallocate(zaj_l_backup)
  end subroutine deallocate_matrix

! ================================ added by K. Tagami =============== 11.0
  subroutine deallocate_matrix_noncl
    deallocate(feigconv)
    deallocate(ibover)
    deallocate(fsr_noncl)
    if (allocated(fsi_noncl)) deallocate(fsi_noncl)
    deallocate(zaj_l_backup_noncl)
  end subroutine deallocate_matrix_noncl
! ======================================================================= 11.0

  subroutine allocate_t_matrix(ik)
    integer, intent(in) :: ik
    integer :: kimg_t
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if
#ifdef _ODD_BOUNDARY_
    if(mod(np_g1k(ik),2) == 0) then
       np_g1k_x = np_g1k(ik) + 1
    else
       np_g1k_x = np_g1k(ik)
    end if
#else
    np_g1k_x = np_g1k(ik)
#endif

! ================================ modified by K. Tagami ============== 11.0
!    allocate(zat_l(np_g1k_x,neg,kimg,ndavid)) ! MPI
!    allocate(zah_l(np_g1k_x,neg,kimg)) ! MPI

    if ( noncol ) then
       allocate(zat_l_noncl(np_g1k_x,neg,kimg,ndavid,ndim_spinor)) ! MPI
       allocate(zah_l_noncl(np_g1k_x,neg,kimg,ndim_spinor)) ! MPI
    else
       allocate(zat_l(np_g1k_x,neg,kimg,ndavid)) ! MPI
       allocate(zah_l(np_g1k_x,neg,kimg)) ! MPI
    endif
! ======================================================================== 11.0

    allocate(w1hw2(nsize_matrix*kimg_t))
    allocate(w1sw2(nsize_matrix*kimg_t))
    if(npes>1) then
       allocate(w1hw2_mpi(nsize_matrix*kimg_t))
       allocate(w1sw2_mpi(nsize_matrix*kimg_t))
    end if
  end subroutine allocate_t_matrix

  subroutine deallocate_t_matrix
! =============================== modified by K. Tagami ============ 11.0
!    deallocate(zat_l) ! MPI
!    deallocate(zah_l) ! MPI

    if ( noncol ) then
       deallocate(zat_l_noncl) ! MPI
       deallocate(zah_l_noncl) ! MPI
    else
       deallocate(zat_l) ! MPI
       deallocate(zah_l) ! MPI
    endif
! ====================================================================== 11.0
    deallocate(w1hw2)
    deallocate(w1sw2)
    if(npes>1) then
       deallocate(w1hw2_mpi)
       deallocate(w1sw2_mpi)
    end if
  end subroutine deallocate_t_matrix

  subroutine allreduce_fs(ik,idavid)
    integer, intent(in) :: ik,idavid
    integer :: ib,ib1,iter,kimg_t
    real(kind=DP), allocatable, dimension(:,:) :: fs_mpi,fs_mpi2

    allocate(fs_mpi(neg,nlmta))
    allocate(fs_mpi2(neg,nlmta))
    if(idavid>1) then
       call m_ES_betar_dot_WFs_4_each_k(nfout,ik)   ! -> fsr_l,fsi_l
    end if
    fs_mpi=0.d0
    do ib1 = ista_e, iend_e, istep_e     ! MPI
       ib=map_z(ib1)
       fs_mpi(ib1,1:nlmta) = fsr_l(ib,1:nlmta,ik)
    end do
    fs_mpi2=0.d0
    call mpi_allreduce(fs_mpi,fs_mpi2,neg*nlmta &
      & ,mpi_double_precision,mpi_sum &
      & ,mpi_k_world(myrank_k),ierr)       ! MPI
    fsr(1:neg,1:nlmta,idavid) = fs_mpi2(1:neg,1:nlmta)
    if(.not. k_symmetry(ik) == GAMMA) then
       fs_mpi=0.d0
       do ib1 = ista_e, iend_e, istep_e     ! MPI
          ib=map_z(ib1)
          fs_mpi(ib1,1:nlmta) = fsi_l(ib,1:nlmta,ik)
       end do
       fs_mpi2=0.d0
       call mpi_allreduce(fs_mpi,fs_mpi2,neg*nlmta &
         & ,mpi_double_precision,mpi_sum &
         & ,mpi_k_world(myrank_k),ierr)       ! MPI
       fsi(1:neg,1:nlmta,idavid) = fs_mpi2(1:neg,1:nlmta)
    end if
    deallocate(fs_mpi)
    deallocate(fs_mpi2)
  end subroutine allreduce_fs

! =================================== added by K. Tagami ================ 11.0
  subroutine allreduce_fs_noncl( ik, idavid )
    integer, intent(in) :: ik,idavid

    integer :: ib, ib1, iter, is, kimg_t
    real(kind=DP), allocatable, dimension(:,:,:) :: fs_mpi,fs_mpi2

    allocate(fs_mpi( neg,nlmta,ndim_spinor));  fs_mpi  = 0.0d0
    allocate(fs_mpi2(neg,nlmta,ndim_spinor));  fs_mpi2 = 0.0d0

    if ( idavid>1 ) then
       Do is=1, ndim_spinor
         call m_ES_betar_dot_WFs_4_each_k( nfout,ik+is-1 )   ! -> fsr_l,fsi_l
       End do
    end if

    do ib1 = ista_e, iend_e, istep_e     ! MPI
       ib = map_z(ib1)
       Do is=1, ndim_spinor
         fs_mpi( ib1, 1:nlmta, is ) = fsr_l( ib, 1:nlmta, ik+is-1 )
       End do
    end do
    call mpi_allreduce( fs_mpi, fs_mpi2, neg*nlmta*ndim_spinor, &
      &                 mpi_double_precision, mpi_sum, mpi_k_world(myrank_k), ierr)

!
    Do is=1, ndim_spinor
      fsr_noncl( 1:neg, 1:nlmta, idavid, is ) = fs_mpi2( 1:neg, 1:nlmta, is )
    End do
!
    if ( .not. k_symmetry(ik) == GAMMA ) then
       fs_mpi=0.d0;  fs_mpi2 = 0.0d0
       do ib1 = ista_e, iend_e, istep_e     ! MPI
          ib=map_z(ib1)
          Do is=1, ndim_spinor
             fs_mpi( ib1, 1:nlmta, is ) = fsi_l( ib, 1:nlmta, ik+is-1 )
          End do
       end do

       call mpi_allreduce( fs_mpi, fs_mpi2, neg*nlmta*ndim_spinor, &
         &                 mpi_double_precision, mpi_sum, mpi_k_world(myrank_k), ierr )
       Do is=1, ndim_spinor
         fsi_noncl( 1:neg, 1:nlmta, idavid, is ) = fs_mpi2( 1:neg, 1:nlmta, is )
       End do
    end if

    deallocate(fs_mpi);   deallocate(fs_mpi2)
  end subroutine allreduce_fs_noncl
! ===================================================================== 11.0

  subroutine build_subspace(ik,ekin,hdiag,sdiag,afft,bfft,idavid,precon)
    integer, intent(in) :: ik,idavid,precon
    real(kind=DP), intent(in)  :: ekin(kg1),hdiag(kg1),sdiag(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)

    integer :: iter,ib1,ib,ii,i1
    real(kind=DP) :: dr1,dr2,di1
    real(kind=DP) :: p(kg1)
    real(kind=DP) :: denom, norm, zajr, zaji

    denom = 1.d0/product(fft_box_size_WF(1:3,1))

    if(idavid==1) then
       return
    end if
    ! if precon == ON
    ! |R> = P*(H-Hdiag)|Psi>
    ! P = (Hdiag-e*Sdiag)^(-1)
    ! else
    ! |R> = (H-eS)|Psi>
    do ib1 = ista_e, iend_e, istep_e     ! MPI
       if(feigconv(ib1)) cycle
       call m_ES_WF_in_Rspace(ik,ib1,bfft)!(swffft)
       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft)-> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
       ib = map_z(ib1)                 ! MPI
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
       if(precon==ON) then
          call decide_precon_factor_david(ik,hdiag,sdiag,eko_l(ib,ik),p) ! -> p
          if(kimg == 1) then
             do ii=1,iba(ik)
                i1  = igf(nbase(ii,ik))
                dr1 = zaj_l(ii,ib,ik,kimg)
                dr2 = bfft(i1)*denom
                zajr= (ekin(ii)-hdiag(ii))*dr1+dr2+vnlph_l(ii,ib,kimg)
                zaj_l(ii,ib,ik,kimg) = p(ii)*zajr
             enddo
          else
             do ii=1,iba(ik)
                i1  = igf(nbase(ii,ik))
                dr1  = zaj_l(ii,ib,ik,1)
                di1  = zaj_l(ii,ib,ik,kimg)
                dr2  = ekin(ii) - hdiag(ii)
                zajr= dr2*dr1+bfft(2*i1-1)*denom + vnlph_l(ii,ib,1)
                zaji= dr2*di1+bfft(2*i1)*denom + vnlph_l(ii,ib,2)
                zaj_l(ii,ib,ik,1   )=p(ii)*zajr
                zaj_l(ii,ib,ik,kimg)=p(ii)*zaji
             enddo
          endif
       else
          if(kimg == 1) then
             do ii=1,iba(ik)
                i1  = igf(nbase(ii,ik))
                dr1 = zaj_l(ii,ib,ik,kimg)
                dr2 = bfft(i1)*denom
                zajr= ekin(ii)*dr1+dr2+vnlph_l(ii,ib,kimg)
                zaj_l(ii,ib,ik,kimg) = zajr
             enddo
          else
             do ii=1,iba(ik)
                i1  = igf(nbase(ii,ik))
                dr1  = zaj_l(ii,ib,ik,1)
                di1  = zaj_l(ii,ib,ik,kimg)
                zajr= ekin(ii)*dr1+bfft(2*i1-1)*denom + vnlph_l(ii,ib,1)
                zaji= ekin(ii)*di1+bfft(2*i1)*denom + vnlph_l(ii,ib,2)
                zaj_l(ii,ib,ik,1   )=zajr
                zaj_l(ii,ib,ik,kimg)=zaji
             enddo
          endif
       end if

       ! Normalize
       norm = 0.d0
       if(kimg==1) then
          do ii=1,iba(ik)
             zajr = zaj_l(ii,ib,ik,kimg)
             norm = norm + zajr*zajr
          end do
          norm = 1.d0/sqrt(norm)
          do ii=1,iba(ik)
             zaj_l(ii,ib,ik,1) = zaj_l(ii,ib,ik,1)*norm
          end do
       else
          do ii=1,iba(ik)
             zajr = zaj_l(ii,ib,ik,1   )
             zaji = zaj_l(ii,ib,ik,kimg)
             norm = norm + zajr*zajr+zaji*zaji
          end do
          norm = 1.d0/sqrt(norm)
          do ii=1,iba(ik)
             zaj_l(ii,ib,ik,1)= zaj_l(ii,ib,ik,1)*norm
! === DEBUG by tkato 2011/07/13 ================================================
!            zaj_l(ii,ib,ik,2)= zaj_l(ii,ib,ik,1)*norm
             zaj_l(ii,ib,ik,2)= zaj_l(ii,ib,ik,2)*norm
! ==============================================================================
          enddo
       end if
    end do
  contains
    subroutine decide_precon_factor_david(ik,hdiag,sdiag,eig,p)
      integer, intent(in) :: ik
      real(kind=DP), intent(in) :: hdiag(kg1),sdiag(kg1),eig
      real(kind=DP), intent(out) :: p(kg1)

      integer :: ii
      real(kind=DP) :: denom

      do ii=1,iba(ik)
         denom = hdiag(ii)-eig*sdiag(ii)
         if(abs(denom) < eps_david) then
            denom = sign(eps_david,denom)
         end if
         p(ii) = 1.d0/denom
      end do

    end subroutine decide_precon_factor_david
  end subroutine build_subspace

! ================================ added by K. Tagami ==================== 11.0
  subroutine build_subspace_noncl( ik, ekin, hdiag, sdiag, afft_kt, bfft_kt, &
	&                          vnlph_noncl, idavid, precon )
    integer, intent(in) :: ik,idavid,precon
    real(kind=DP), intent(in)  :: ekin(kg1)


#ifdef USE_COMPLEX_VNLDI
    complex(kind=CMPLDP), intent(in)  :: hdiag(kg1,ndim_spinor), sdiag(kg1,ndim_spinor)
#else
    real(kind=DP), intent(in)  :: hdiag(kg1,ndim_spinor), sdiag(kg1,ndim_spinor)
#endif

    real(kind=DP), intent(inout)  :: afft_kt(nfft,ndim_chgpot)
    real(kind=DP), intent(out) :: bfft_kt(nfft,ndim_spinor)
    real(kind=DP), intent(in)  :: vnlph_noncl(kg1,np_e,kimg,ndim_spinor)

    integer :: iter,ib1,ib,ii,i1
    integer :: is, k1

    real(kind=DP) :: dr1,dr2,di1
    real(kind=DP) :: denom, norm, zajr, zaji

    complex(kind=CMPLDP) :: zdr2
    real(kind=DP) :: ctmp1, stmp1, ctmp2, stmp2

#ifdef USE_COMPLEX_VNLDI
    complex(kind=CMPLDP), allocatable :: p(:,:)
#else
    real(kind=DP), allocatable :: p(:,:)
#endif

    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    allocate( p( kg1,ndim_spinor ) ); p = 0.0d0

    if(idavid==1) then
       return
    end if

    ! if precon == ON
    ! |R> = P*(H-Hdiag)|Psi>
    ! P = (Hdiag-e*Sdiag)^(-1)
    ! else
    ! |R> = (H-eS)|Psi>
    do ib1 = ista_e, iend_e, istep_e     ! MPI
       if ( feigconv(ib1) ) cycle

       Do is=1, ndim_spinor
         call m_ES_WF_in_Rspace( ik+is-1, ib1, bfft_kt(:,is) )!(swffft)
       End do
       call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, ndim_chgpot, ndim_spinor )
                                           ! (afft, bfft)-> (bfft)
       Do is=1, ndim_spinor
         call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
       End do

       ib = map_z(ib1)                 ! MPI
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) then
          do is = 1, ndim_spinor
             k1 = ik+is-1
             status_saved_phifftr(ib,k1) = OLD
          end do
       end if
#endif
       if ( precon==ON ) then
          call decide_precon_fac_david_noncl( ik, hdiag, sdiag, eko_l(ib,ik), p )
                                                              ! -> p
#ifdef USE_COMPLEX_VNLDI
          if ( kimg == 1 ) then
          else
             Do is=1, ndim_spinor
                k1 = ik +is -1
                do ii=1,iba(ik)
                   i1  = igf( nbase(ii,ik) )

                   dr1  = zaj_l( ii, ib, k1, 1 )
                   di1  = zaj_l( ii, ib, k1, kimg )
                   zdr2  = ekin(ii) - hdiag(ii,is)

                   ctmp1 = real(zdr2)*dr1 - aimag(zdr2)*di1
                   stmp1 = aimag(zdr2)*dr1 + real(zdr2)*di1

                   zajr= ctmp1 +bfft_kt( 2*i1-1,is )*denom &
        &                        +vnlph_noncl( ii, ib, 1, is )
                   zaji= stmp1 +bfft_kt( 2*i1,  is )*denom &
        &                        +vnlph_noncl( ii, ib, 2, is )

                   ctmp2 = real(p(ii,is)) *zajr - aimag(p(ii,is))*zaji
                   stmp2 = aimag(p(ii,is)) *zajr + real(p(ii,is))*zaji

                   zaj_l( ii, ib, k1, 1    ) = ctmp2
                   zaj_l( ii, ib, k1, kimg ) = stmp2
                End do
             enddo
          endif

#else
          if ( kimg == 1 ) then
             Do is=1, ndim_spinor
                k1 = ik +is -1
                do ii=1, iba(ik)
                   i1 = igf( nbase(ii,ik) )

	           dr1 = zaj_l( ii, ib, k1, kimg )
                   dr2 = bfft_kt( i1,is )*denom
                   zajr= ( ekin(ii) - hdiag(ii,is) )*dr1 &
	&                   + dr2 +vnlph_noncl( ii, ib, kimg, is  )
                   zaj_l( ii, ib, k1, kimg ) = p(ii,is) *zajr
                End do
             enddo
          else
             Do is=1, ndim_spinor
                k1 = ik +is -1
                do ii=1,iba(ik)
                   i1  = igf( nbase(ii,ik) )

                   dr1  = zaj_l( ii, ib, k1, 1 )
                   di1  = zaj_l( ii, ib, k1, kimg )
                   dr2  = ekin(ii) - hdiag(ii,is)
                   zajr= dr2*dr1 +bfft_kt( 2*i1-1,is )*denom &
	&                        +vnlph_noncl( ii, ib, 1, is )
                   zaji= dr2*di1 +bfft_kt( 2*i1,  is )*denom &
	&                        +vnlph_noncl( ii, ib, 2, is )
                   zaj_l( ii, ib, k1, 1    ) = p(ii,is) *zajr
                   zaj_l( ii, ib, k1, kimg ) = p(ii,is) *zaji
                End do
             enddo
          endif

#endif
       else
          if ( kimg == 1 ) then
             Do is=1, ndim_spinor
                k1 = ik +is -1
                do ii=1, iba(ik)
                   i1  = igf(nbase(ii,ik))

                   dr1 = zaj_l( ii, ib, k1, kimg )
                   dr2 = bfft_kt( i1,is )*denom
                   zajr = ekin(ii)*dr1 +dr2 +vnlph_noncl( ii, ib, kimg, is )
                   zaj_l( ii, ib, k1, kimg ) = zajr
                enddo
             End do
          else
             Do is=1, ndim_spinor
                k1 = ik +is -1
                do ii=1, iba(ik)
                   i1  = igf(nbase(ii,ik))

                   dr1  = zaj_l( ii, ib, k1, 1 )
                   di1  = zaj_l( ii, ib, k1, kimg )
                   zajr = ekin(ii)*dr1 +bfft_kt( 2*i1-1,is )*denom &
	&                              +vnlph_noncl( ii, ib, 1,is )
                   zaji = ekin(ii)*di1 +bfft_kt( 2*i1,  is )*denom &
	&                              +vnlph_noncl( ii, ib, 2,is )
                   zaj_l( ii, ib, k1, 1    ) = zajr
                   zaj_l( ii, ib, k1, kimg ) = zaji
                enddo
             End do
          endif
       end if

       ! Normalize
       norm = 0.d0
       if ( kimg==1 ) then
          Do is=1, ndim_spinor
             k1 = ik +is -1
             do ii=1, iba(ik)
                zajr = zaj_l( ii, ib, k1, kimg )
                norm = norm + zajr*zajr
             End do
          end do
          norm = 1.d0 /sqrt(norm)
          Do is=1, ndim_spinor
             k1 = ik +is -1
             do ii=1, iba(ik)
                zaj_l( ii, ib, k1, 1 ) = zaj_l( ii, ib, k1, 1 )*norm
             End do
          end do
       else
          Do is=1, ndim_spinor
             k1 = ik +is -1
             do ii=1, iba(ik)
                zajr = zaj_l( ii, ib, k1, 1    )
                zaji = zaj_l( ii, ib, k1, kimg )
                norm = norm + zajr*zajr +zaji*zaji
             end do
          end do
          norm = 1.d0 /sqrt(norm)
          Do is=1, ndim_spinor
             k1 = ik +is -1
             do ii=1,iba(ik)
                zaj_l( ii, ib, k1, 1 )    = zaj_l( ii, ib, k1, 1    )*norm
                zaj_l( ii, ib, k1, kimg ) = zaj_l( ii, ib, k1, kimg )*norm
             end do
          enddo
       end if
    end do
!
    deallocate(p)

  contains

    subroutine decide_precon_fac_david_noncl( ik, hdiag, sdiag, eig, p )
      integer, intent(in) :: ik

#ifdef USE_COMPLEX_VNLDI
      complex(kind=CMPLDP), intent(in) :: hdiag(kg1,ndim_spinor), &
           &                              sdiag(kg1,ndim_spinor)
      complex(kind=CMPLDP), intent(out) :: p(kg1,ndim_spinor)
#else
      real(kind=DP), intent(in) :: hdiag(kg1,ndim_spinor), sdiag(kg1,ndim_spinor)
      real(kind=DP), intent(out) :: p(kg1,ndim_spinor)
#endif

      real(kind=DP), intent(in) :: eig

      integer :: ii, is
      real(kind=DP) :: denom
      complex(kind=CMPLDP) :: ztmp

#ifdef USE_COMPLEX_VNLDI
      Do is=1, ndim_spinor
         do ii=1,iba(ik)
            ztmp = hdiag(ii,is)-eig*sdiag(ii,is)
            denom = real(ztmp)
            if ( abs(denom) < eps_david ) then
               if ( denom > 0.0d0 ) then
                  ztmp = eps_david
               else
                  ztmp = -eps_david
               endif
            end if
            p(ii,is) = 1.d0 / ztmp
         End do
      end do
#else
      Do is=1, ndim_spinor
         do ii=1,iba(ik)
           denom = hdiag(ii,is)-eig*sdiag(ii,is)
           if(abs(denom) < eps_david) then
              denom = sign(eps_david,denom)
           end if
           p(ii,is) = 1.d0/denom
         End do
      end do
#endif

    end subroutine decide_precon_fac_david_noncl

  end subroutine build_subspace_noncl
! ===================================================================== 11.0


  subroutine evolve_WFs_in_subspace&
       &(ik,ispin,ekin,afft,bfft,idavid,frestart)
    integer, intent(in) :: ik,ispin
    integer, intent(in) :: idavid
    logical, intent(out) :: frestart
    real(kind=DP), intent(in)  :: ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)
! (allocatable variables)
    real(kind=DP), allocatable,dimension(:) ::     eig
    real(kind=DP), allocatable,dimension(:,:) ::   vec
    real(kind=DP), allocatable,dimension(:) ::     eko_d
    real(kind=DP), allocatable,dimension(:) ::     eko_d_mpi
    integer, allocatable,dimension(:) ::     occup
    integer, allocatable,dimension(:) ::     occup_mpi

    integer       :: ib1,ib2,ib1to,ib2to,i1,ii,ri,ib
    integer       :: ibb1,ibb2
    integer       :: ii1,ii2,iter,iter1,iter2
    real(kind=DP) :: denom, eko1, eko2, ekod
    real(kind=DP) :: hr2,hi2,dr1,dr2,di1,di2,dd
    integer :: ip0,ip0b,ip1,ip1b,ib1n,ib2n,ndata,nshift,kimg_t,ig1
    integer :: noffset
    integer :: nsize_max_sb_now
    integer :: ierr_diag
    integer :: id_sname = -1, ipri0
    call tstatc0_begin('evolve_WFs_in_subspace (davidson) ', id_sname,1)

    call get_ipri0(ipridavidson,ipri0)

! ==================== added by K. Tagami ========== 11.0
#ifdef forsafe
    ekod = 0.0d0
#endif
! ================================================== 11.0

    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if

    if(idavid==1) then
       ip0=neg
       do ib=1,neg
          ibover(ib) = ib
       end do
       nsize_mt_now=0
    else
       noffset = neg*(idavid-1)
       ip0=nsize_sb_now
       do ib=1,neg
          if(.not.feigconv(ib)) then
             ip0=ip0+1
             ibover(noffset+ib) = ip0
          else
             ibover(noffset+ib) = -1
          end if
       end do
    end if
    nsize_sb_now = ip0
    nsize_mt_old = nsize_mt_now
    nsize_mt_now = nsize_sb_now*(nsize_sb_now+1)/2
    nsize_max_sb_now = neg*idavid
    if(ipridavidson >=2) then
       write(nfout,*) 'ibover=',ibover(1:nsize_max_sb_now)
    end if

    allocate(eig(nsize_sb_now)); eig=0.d0
    allocate(vec(nsize_sb_now*kimg_t,nsize_sb_now))
    allocate(eko_d(neg));     eko_d = 0.d0
    allocate(eko_d_mpi(neg))
    allocate(occup(neg)); occup=0
    allocate(occup_mpi(neg))

    if(ipridavidson >=2) then
       write(nfout,*) 'Davidson:ik,idavid,nsize_sb_now=', ik,idavid,nsize_sb_now
    end if


    do ib1 = 1, neg
       if(map_e(ib1) == myrank_e) eko_d(ib1) = eko_l(map_z(ib1),ik)  ! MPI
    end do
    call mpi_allreduce(eko_d,eko_d_mpi,neg,mpi_double_precision,mpi_sum &
         & ,mpi_k_world(myrank_k),ierr)       ! MPI
    eko_d = eko_d_mpi                         ! MPI
    eko1 = sum(eko_d(1:neg))

    do ib1=1,neg
       if(map_e(ib1) == myrank_e) then !MPI
          if( occup_l(map_z(ib1),ik) > 0.d0 ) occup(ib1) = 1  ! MPI
       end if
    end do
    call mpi_allreduce(occup,occup_mpi,neg,mpi_integer,mpi_sum &
         & ,mpi_k_world(myrank_k),ierr)       ! MPI
    occup = occup_mpi                         ! MPI

! (zaj_l <- (T+Vloc)|phi> )
!( tenchi ) (zat_l <- zaj_l)
    call m_ES_W_transpose_r(.false.,ista_k,iend_k,ik,zaj_l,zat_l(1,1,1,idavid))
    do ib1 = ista_e, iend_e, istep_e     ! MPI
       call m_ES_WF_in_Rspace(ik,ib1,bfft)!(swffft)
       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft)-> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
       ib = map_z(ib1)                 ! MPI
       if(kimg == 1) then
          do ii=1,iba(ik)
             i1  = igf(nbase(ii,ik))
             dr1 = zaj_l(ii,ib,ik,1)
             dr2 = bfft(i1)*denom
             zaj_l(ii,ib,ik,1)= ekin(ii)*dr1+dr2
          enddo
       else
          do ii=1,iba(ik)
             i1  = igf(nbase(ii,ik))
             dr1  = zaj_l(ii,ib,ik,1)
             di1  = zaj_l(ii,ib,ik,kimg)
             zaj_l(ii,ib,ik,1)= ekin(ii)*dr1+bfft(2*i1-1)*denom
             zaj_l(ii,ib,ik,kimg)= ekin(ii)*di1+bfft(2*i1)*denom
          enddo
       endif
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
    enddo
    if(ipridavidson>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
!( tenchi ) (zah_l <- zaj_l)
    call m_ES_W_transpose_r(.false.,ista_k,iend_k,ik,zaj_l,zah_l(1,1,1))

! (make matrix elements )
! parallel loop
    ! <n|T+Vloc|m> G-wise parallel
    do ibb2 = nsize_max_sb_now-neg+1,nsize_max_sb_now
       if(ibover(ibb2)<0) cycle
       ib2 = ibover(ibb2)
       iter2 = (ibb2-1)/neg+1
       ii2  = ibb2-neg*(iter2-1)
       ip0b = ib2*(ib2-1)/2
       do ibb1 = 1,ibb2
          if(ibover(ibb1)<0) cycle
          ib1 = ibover(ibb1)
          iter1 = (ibb1-1)/neg+1
          ii1 = ibb1-neg*(iter1-1)
          ip0 = ip0b + ib1
          if(kimg == 1) then
             w1hw2(ip0) = 0.d0
             w1sw2(ip0) = 0.d0
             do ii = 1, np_g1k(ik)            ! MPI
                hr2 = zah_l(ii,ii2,1)
                dr2 = zat_l(ii,ii2,1,iter2)
                dr1 = zat_l(ii,ii1,1,iter1)
                w1hw2(ip0) = w1hw2(ip0) + dr1*hr2
                w1sw2(ip0) = w1sw2(ip0) + dr1*dr2
             end do
          else
             if(k_symmetry(ik) == GAMMA) then
                w1hw2(ip0) = 0.d0
                w1sw2(ip0) = 0.d0
!!$                ig1 = 1;  if(mype == 0) ig1 = 2
                ig1 = 1;  if(myrank_e == 0) ig1 = 2
                do ii = ig1, np_g1k(ik)            ! MPI
                   hr2 = zah_l(ii,ii2,1) ! MPI
                   hi2 = zah_l(ii,ii2,2) ! MPI
                   dr2 = zat_l(ii,ii2,1,iter2) ! MPI
                   di2 = zat_l(ii,ii2,2,iter2) ! MPI
                   dr1 = zat_l(ii,ii1,1,iter1) ! MPI
                   di1 = zat_l(ii,ii1,2,iter1) ! MPI
                   w1hw2(ip0) =w1hw2(ip0)+(dr1*hr2+di1*hi2)*2.d0
                   w1sw2(ip0) =w1sw2(ip0)+(dr1*dr2+di1*di2)*2.d0
                end do
!!$                if(mype == 0) then
                if(myrank_e == 0) then
                   hr2 = zah_l(1,ii2,1) ! MPI
                   hi2 = zah_l(1,ii2,2) ! MPI
                   dr2 = zat_l(1,ii2,1,iter2) ! MPI
                   di2 = zat_l(1,ii2,2,iter2) ! MPI
                   dr1 = zat_l(1,ii1,1,iter1) ! MPI
                   di1 = zat_l(1,ii1,2,iter1) ! MPI
                   w1hw2(ip0) =w1hw2(ip0)+dr1*hr2+di1*hi2
                   w1sw2(ip0) =w1sw2(ip0)+dr1*dr2+di1*di2
                end if
             else
                w1hw2(2*ip0-1:2*ip0) = 0.d0
                w1sw2(2*ip0-1:2*ip0) = 0.d0
                do ii = 1, np_g1k(ik)           ! MPI
                   hr2 = zah_l(ii,ii2,1) ! MPI
                   hi2 = zah_l(ii,ii2,2) ! MPI
                   dr2 = zat_l(ii,ii2,1,iter2) ! MPI
                   di2 = zat_l(ii,ii2,2,iter2) ! MPI
                   dr1 = zat_l(ii,ii1,1,iter1) ! MPI
                   di1 = zat_l(ii,ii1,2,iter1) ! MPI
                   w1hw2(2*ip0-1) =w1hw2(2*ip0-1)+dr1*hr2+di1*hi2
                   w1hw2(2*ip0  ) =w1hw2(2*ip0  )+dr1*hi2-di1*hr2
                   w1sw2(2*ip0-1) =w1sw2(2*ip0-1)+dr1*dr2+di1*di2
                   w1sw2(2*ip0  ) =w1sw2(2*ip0  )+dr1*di2-di1*dr2
                end do
             end if
          end if
       end do
    end do
    if(ipridavidson >= 3) call wd_w1hw2(" -- w1hw2 without nl part--")
    ! <n|Vnl|m> G-wise parallel
    call add_nonlocal_part ! w1hw2 = w1hw2 + w1Vnlw2
                           ! w1sw2 = w1sw2 + w1qw2
    if(ipridavidson >= 3) call wd_w1hw2(" -- w1hw2 with nl part--")

!! (spread sum of w1hw2 and w1sw2)
    if(npes > 1) then
       w1hw2_mpi = 0.d0
       w1sw2_mpi = 0.d0
       nshift = nsize_mt_old*kimg_t
       ndata = (nsize_mt_now-nsize_mt_old)*kimg_t
       call mpi_allreduce(w1hw2(nshift+1),w1hw2_mpi,ndata,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       w1hw2(nshift+1:nshift+ndata) = w1hw2_mpi(1:ndata) ! MPI
       call mpi_allreduce(w1sw2(nshift+1),w1sw2_mpi,ndata,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       w1sw2(nshift+1:nshift+ndata) = w1sw2_mpi(1:ndata) ! MPI
    end if

    if(ipridavidson >= 2) call wd_w1hw2(" -- just after making w1hw2 --")
    if(ipridavidson >= 2) then
       write(nfout,*) 'neordr for ik = ',ik
       write(nfout,9002) (neordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'nrvf_ordr for ik = ',ik
       write(nfout,9002) (nrvf_ordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'eig'
       write(nfout,'(5x,10f8.4)') (eko_l(ib1,ik),ib1=1,np_e)
    endif
9002 format(5x,10i8)

!! (Diagonalization )  !!

#ifdef _USE_SCALAPACK_
    if(sw_dav_scalapack == ON) then
       call initialize_scalapack()
       if(kimg_t == 1) then
          call pdsygvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
       else
          call pzhegvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
       endif
! === DEBUG by tkato 2012/12/20 ================================================
!      call finalize_scalapack()
! ==============================================================================
    else
       if(kimg_t == 1) then
          call dspgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
       else
          call zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
       endif
    endif
#else
    if(kimg_t == 1) then
       call dspgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
    else
       call zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
    endif
#endif

    frestart = .false.
    if(ierr_diag /= 0) then
       zaj_l(:,:,ik,:) = zaj_l_backup(:,:,:)
       if(ipridavidson>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
       do ib1 = 1, neg
          if(map_e(ib1) == myrank_e) then         ! MPI
             eko_l(map_z(ib1),ik)=eko_d(ib1)
          end if
       end do
       frestart = .true.
       if(ipridavidson >= 2) then
          write(nfout,*) '** restart Davidson iteration **'
       end if
    else

       feigconv = .false.
       do ib=1,neg
          if(occup(ib) == 1) then
             if(abs(eko_d(ib)-eig(ib)) < delta_eig_occup) feigconv(ib) = .true.
          else
             if(abs(eko_d(ib)-eig(ib)) < delta_eig_empty) feigconv(ib) = .true.
          end if
       end do

!!$       if(ipridavidson >= 2) then
       if(ipri0 >= 2) then
          write(nfout,*) 'eko_d for ik = ',ik
          write(nfout,9001) (eko_d(ib),ib=1,neg)
          write(nfout,*) 'eig for ik = ',ik
          write(nfout,9001) (eig(ib),ib=1,neg)
          call wd_w1hw2(" -- after diagonalization --")
!sum eko
          dr1=0.d0;dr2=0.d0
          do ib1=1,neg
             ib1to = neordr(ib1,ik)
             if(map_e(ib1to) == myrank_e) dr1=dr1+eko_l(map_z(ib1to),ik) ! MPI
             dr2=dr2+eig(ib1)
          enddo
          call mpi_allreduce(dr1,di1,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
          dr1 = di1  ! MPI
          write(nfout,'(" sum of eko_l, eig, abs diff =",3e25.10)') dr1,dr2,abs(dr2-dr1)
       endif
!! (subspace rotation) !!
       call subspace_rotation ! vec,zat_l -> zat_l
!( tenchi ) (zaj_l <- zat_l)
       iter = min(idavid+1,ndavid)
       call m_ES_W_transpose_back_r(.false.,ista_k,iend_k,ik,zaj_l,zat_l(1,1,1,iter))
       zaj_l_backup(:,:,:) = zaj_l(:,:,ik,:)
!! (eko_l)
       do ib1 = 1, neg
          if(map_e(ib1) == myrank_e) then         ! MPI
             eko_l(map_z(ib1),ik)=eig(ib1)
          end if
       end do
       if(ipridavidson >= 2) then
          eko2 = sum(eig(1:neg))
          write(nfout,1201) ik,eko1,ekod,eko2

          write(nfout,*) 'eko_l'
          write(nfout,9001) (eko_l(ib1,ik),ib1=1,neg)
       endif
1201 format(' %% for ik = ',i4,4x,' eko1&ekod&eko2 = ',3f14.7)
9001 format(5x,6f12.5)
!! (neordr & nrvf_ordr)

    end if

    neordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
    nrvf_ordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)

! (deallocate)
    deallocate(eko_d)
    deallocate(eko_d_mpi)
    deallocate(eig)
    deallocate(vec)
    deallocate(occup)
    deallocate(occup_mpi)

    call tstatc0_end(id_sname)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine wd_w1hw2(somecomment)
      character(len=*), intent(in) :: somecomment
      integer :: ib1, ib2, neg_wd, nsb_wd
      write(nfout,'(a35)') somecomment
      write(nfout,*) 'w1hw2 for ik = ',ik
      neg_wd = 8
      nsb_wd = 8
      if(neg_wd > neg) neg_wd = neg
      if(nsb_wd > nsize_sb_now) nsb_wd = nsize_sb_now
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
      write(nfout,*) 'w1sw2 for ik = ',ik
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
9001  format(5x,9f12.5)
      write(nfout,*) 'eko_l for ik = ',ik
      write(nfout,9001) (eko_d(neordr(ib1,ik)),ib1=1,neg_wd)
    end subroutine wd_w1hw2

    subroutine add_nonlocal_part
      integer :: ip,ib1,ib2,ibb1,ibb2
      integer       :: ia, lmt1, lmt2, it, p, s, ib
      real(kind=DP) :: facv,facq,vr,vi,qr,qi
      real(kind=DP) :: tmpr,tmpi

! ========================== added by K. Tagami ========== 11.0
#ifdef forsafe
      integer :: ipaw_tmp
#endif
! ======================================================== 11.0

      do ibb2 = nsize_max_sb_now-neg+1,nsize_max_sb_now
         if(ibover(ibb2)<0) cycle
         ib2 = ibover(ibb2)
         iter2= (ibb2-1)/neg+1
         ii2  = ibb2-neg*(iter2-1)
         ip0b = ib2*(ib2-1)/2
         do ibb1 = 1,ibb2
            if(ibover(ibb1)<0) cycle
            ib1 = ibover(ibb1)
            iter1=(ibb1-1)/neg+1
            ii1  = ibb1-neg*(iter1-1)
            ip0 = ip0b + ib1
            if(mod(ip0-1,nrank_e)/=myrank_e) cycle
            if(kimg_t==1) then
               vr=0.d0
               qr=0.d0
            else
               vr=0.d0
               vi=0.d0
               qr=0.d0
               qi=0.d0
            end if
            do ia = 1, natm
               it = ityp(ia)

! ========================== added by K. Tagami =================== 11.0
#ifdef forsafe
               ipaw_tmp = ipaw(it)
#endif
! ================================================================= 11.0

               do lmt1 = 1, ilmt(it)
                  p = lmta(lmt1,ia)
                  do lmt2 = 1, ilmt(it)
                     s = lmta(lmt2,ia)
!!$                     facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
! ========================== modified by K. Tagami =================== 11.0
!                     if(ipaw(it)==0)then
#ifdef forsafe
                     if ( ipaw_tmp == 0 ) then
#else
                     if (ipaw(it)==0 ) then
#endif
! ================================================================= 11.0

                        facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     else
                        facv   = iwei(ia)*(dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     endif
                     facq   = iwei(ia)*q(lmt1,lmt2,it)
                     if(kimg==1) then
                        tmpr = fsr(ii1,p,iter1)*fsr(ii2,s,iter2)&
                    &        + fsi(ii1,p,iter1)*fsi(ii2,s,iter2)
                        vr = vr + facv*tmpr
                        qr = qr + facq*tmpr
                     else
                        if(k_symmetry(ik) == GAMMA) then
                           tmpr = fsr(ii1,p,iter1)*fsr(ii2,s,iter2)
                           vr = vr + facv*tmpr
                           qr = qr + facq*tmpr
                        else
                           tmpr = fsr(ii1,p,iter1)*fsr(ii2,s,iter2)&
                    &        + fsi(ii1,p,iter1)*fsi(ii2,s,iter2)
                           tmpi = fsr(ii1,p,iter1)*fsi(ii2,s,iter2)&
                    &        - fsi(ii1,p,iter1)*fsr(ii2,s,iter2)
                           vr = vr + facv*tmpr
                           vi = vi + facv*tmpi
                           qr = qr + facq*tmpr
                           qi = qi + facq*tmpi
                        end if
                     end if
                  end do
               end do
            end do
            if(kimg_t==1) then
               w1hw2(ip0) = w1hw2(ip0) + vr
               w1sw2(ip0) = w1sw2(ip0) + qr
            else
               w1hw2(2*ip0-1) = w1hw2(2*ip0-1) + vr
               w1hw2(2*ip0  ) = w1hw2(2*ip0  ) + vi
               w1sw2(2*ip0-1) = w1sw2(2*ip0-1) + qr
               w1sw2(2*ip0  ) = w1sw2(2*ip0  ) + qi
            end if
         end do
      end do
    end subroutine add_nonlocal_part

    subroutine subspace_rotation
      integer :: ib1,ib2,ibb2
!!$      real(kind=DP), dimension(np_g1k_x,neg,kimg) :: zaj_wk
      real(kind=DP), allocatable, dimension(:,:,:) :: zaj_wk
      allocate(zaj_wk(np_g1k_x,neg,kimg))

      zaj_wk(:,:,:) = 0.d0
      if(kimg==1) then
         do ib1=1,neg
            do ibb2=1,nsize_max_sb_now
               if(ibover(ibb2)<0) cycle
               ib2 = ibover(ibb2)
               iter2=(ibb2-1)/neg+1
               ii2=ibb2-neg*(iter2-1)
               do ii=1,np_g1k(ik)
                  zaj_wk(ii,ib1,kimg) = zaj_wk(ii,ib1,kimg) + zat_l(ii,ii2,kimg,iter2)*vec(ib2,ib1)
               end do
            end do
         end do
      else
         if(k_symmetry(ik) == GAMMA) then
            do ib1=1,neg
               do ibb2=1,nsize_max_sb_now
                  if(ibover(ibb2)<0) cycle
                  ib2 = ibover(ibb2)
                  iter2=(ibb2-1)/neg+1
                  ii2=ibb2-neg*(iter2-1)
                  hr2=vec(ib2,ib1)
                  do ii=1,np_g1k(ik)
                     dr1=zat_l(ii,ii2,1   ,iter2)
                     di1=zat_l(ii,ii2,kimg,iter2)
                     zaj_wk(ii,ib1,1   ) = zaj_wk(ii,ib1,1   ) + dr1*hr2
                     zaj_wk(ii,ib1,kimg) = zaj_wk(ii,ib1,kimg) + di1*hr2
                  end do
               end do
            end do
         else
            do ib1=1,neg
               do ibb2=1,nsize_max_sb_now
                  if(ibover(ibb2)<0) cycle
                  ib2 = ibover(ibb2)
                  iter2=(ibb2-1)/neg+1
                  ii2=ibb2-neg*(iter2-1)
                  hr2=vec(2*ib2-1,ib1)
                  hi2=vec(2*ib2  ,ib1)
                  do ii=1,np_g1k(ik)
                     dr1=zat_l(ii,ii2,1   ,iter2)
                     di1=zat_l(ii,ii2,kimg,iter2)
                     zaj_wk(ii,ib1,1   ) = zaj_wk(ii,ib1,1   ) + dr1*hr2 - di1*hi2
                     zaj_wk(ii,ib1,kimg) = zaj_wk(ii,ib1,kimg) + dr1*hi2 + di1*hr2
                  end do
               end do
            end do
         end if
      end if
      iter = min(idavid+1,ndavid)
      zat_l(:,:,:,iter) = zaj_wk(:,:,:)
      deallocate(zaj_wk)
    end subroutine subspace_rotation

  end subroutine evolve_WFs_in_subspace

! ==================================== added by K. Tagami ================= 11.0
  subroutine evolve_WFs_in_subspace_noncl( ik, ekin, afft_kt, bfft_kt, &
	&                                  idavid, frestart )
    integer, intent(in) :: ik
    integer, intent(in) :: idavid
    logical, intent(out) :: frestart
    real(kind=DP), intent(in)  :: ekin(kg1)
    real(kind=DP), intent(inout)  :: afft_kt(nfft,ndim_chgpot)
    real(kind=DP), intent(out) :: bfft_kt(nfft,ndim_spinor)

! (allocatable variables)
    real(kind=DP), allocatable,dimension(:) ::     eig
    real(kind=DP), allocatable,dimension(:,:) ::   vec
    real(kind=DP), allocatable,dimension(:) ::     eko_d
    real(kind=DP), allocatable,dimension(:) ::     eko_d_mpi
    integer, allocatable,dimension(:) ::     occup
    integer, allocatable,dimension(:) ::     occup_mpi

    integer       :: ib1,ib2,ib1to,ib2to,i1,ii,ri,ib
    integer       :: ibb1,ibb2
    integer       :: ii1,ii2,iter,iter1,iter2
    real(kind=DP) :: denom, eko1, eko2, ekod
    real(kind=DP) :: hr2,hi2,dr1,dr2,di1,di2,dd
    integer :: is, k1

    integer :: ip0,ip0b,ip1,ip1b,ib1n,ib2n,ndata,nshift,kimg_t,ig1
    integer :: noffset
    integer :: nsize_max_sb_now
    integer :: ierr_diag
    integer :: id_sname = -1, ipri0

    call tstatc0_begin('evolve_WFs_in_subspace (davidson) ', id_sname,1)
    call get_ipri0(ipridavidson,ipri0)

! ==================== added by K. Tagami ========== 11.0
#ifdef forsafe
    ekod = 0.0d0
#endif
! ================================================== 11.0

    denom = 1.d0 /product(fft_box_size_WF(1:3,1))
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if

    if(idavid==1) then
       ip0=neg
       do ib=1,neg
          ibover(ib) = ib
       end do
       nsize_mt_now=0
    else
       noffset = neg*(idavid-1)
       ip0=nsize_sb_now
       do ib=1,neg
          if(.not.feigconv(ib)) then
             ip0=ip0+1
             ibover(noffset+ib) = ip0
          else
             ibover(noffset+ib) = -1
          end if
       end do
    end if
    nsize_sb_now = ip0
    nsize_mt_old = nsize_mt_now
    nsize_mt_now = nsize_sb_now*(nsize_sb_now+1)/2
    nsize_max_sb_now = neg*idavid
    if(ipridavidson >=2) then
       write(nfout,*) 'ibover=',ibover(1:nsize_max_sb_now)
    end if

    allocate(eig(nsize_sb_now)); eig=0.d0
    allocate(vec(nsize_sb_now*kimg_t,nsize_sb_now))
    allocate(eko_d(neg));     eko_d = 0.d0
    allocate(eko_d_mpi(neg))
    allocate(occup(neg)); occup=0
    allocate(occup_mpi(neg))

    if(ipridavidson >=2) then
       write(nfout,*) 'Davidson:ik,idavid,nsize_sb_now=', ik,idavid,nsize_sb_now
    end if

    do ib1 = 1, neg
       if(map_e(ib1) == myrank_e) eko_d(ib1) = eko_l(map_z(ib1),ik)  ! MPI
    end do
    call mpi_allreduce(eko_d,eko_d_mpi,neg,mpi_double_precision,mpi_sum &
         & ,mpi_k_world(myrank_k),ierr)       ! MPI
    eko_d = eko_d_mpi                         ! MPI
    eko1 = sum(eko_d(1:neg))

    do ib1=1,neg
       if(map_e(ib1) == myrank_e) then !MPI
          if( occup_l(map_z(ib1),ik) > 0.d0 ) occup(ib1) = 1  ! MPI
       end if
    end do
    call mpi_allreduce(occup,occup_mpi,neg,mpi_integer,mpi_sum &
         & ,mpi_k_world(myrank_k),ierr)       ! MPI
    occup = occup_mpi                         ! MPI

! (zaj_l <- (T+Vloc)|phi> )
!( tenchi ) (zat_l <- zaj_l)

    Do is=1, ndim_spinor
      k1 = ik +is -1

      call m_ES_W_transpose_r(.false., ista_k, iend_k, k1, zaj_l, &
	&                    zat_l_noncl(1,1,1,idavid,is) )
    End do

    do ib1 = ista_e, iend_e, istep_e     ! MPI
       Do is=1, ndim_spinor
	  k1 = ik +is- 1
         call m_ES_WF_in_Rspace( k1, ib1, bfft_kt(:,is) )!(swffft)
       End do
       call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, ndim_chgpot, ndim_spinor )
                                       ! (afft, bfft)-> (bfft)
       Do is=1, ndim_spinor
         call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
       End do

       ib = map_z(ib1)                 ! MPI
       if ( kimg == 1 ) then
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do ii=1,iba(ik)
               i1  = igf(nbase(ii,ik))
               dr1 = zaj_l( ii, ib, k1, 1 )
               dr2 = bfft_kt( i1,is )*denom
               zaj_l( ii, ib, k1, 1 )= ekin(ii)*dr1 +dr2
            end do
#ifdef SAVE_FFT_TIMES
            if(sw_save_fft == ON) status_saved_phifftr(ib,k1) = OLD
#endif
          Enddo
       else
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do ii=1,iba(ik)
               i1  = igf(nbase(ii,ik))
               dr1  = zaj_l( ii, ib, k1,   1 )
               di1  = zaj_l( ii, ib, k1,kimg )
               zaj_l( ii, ib, k1,    1 ) = ekin(ii)*dr1 &
	&                                + bfft_kt( 2*i1-1,is )*denom
               zaj_l( ii, ib, k1, kimg ) = ekin(ii)*di1 &
	&                                + bfft_kt( 2*i1,  is )*denom
            enddo
#ifdef SAVE_FFT_TIMES
            if(sw_save_fft == ON) status_saved_phifftr(ib,k1) = OLD
#endif
          End do
       endif
    enddo
    if(ipridavidson>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
!( tenchi ) (zah_l <- zaj_l)
    Do is=1, ndim_spinor
      k1 = ik +is -1
      call m_ES_W_transpose_r(.false., ista_k, iend_k, k1, zaj_l, zah_l_noncl(1,1,1,is) )
    End do

! (make matrix elements )
! parallel loop
    ! <n|T+Vloc|m> G-wise parallel
    do ibb2 = nsize_max_sb_now-neg+1,nsize_max_sb_now
       if(ibover(ibb2)<0) cycle
       ib2 = ibover(ibb2)
       iter2 = (ibb2-1)/neg+1
       ii2  = ibb2-neg*(iter2-1)
       ip0b = ib2*(ib2-1)/2

       do ibb1 = 1,ibb2
          if(ibover(ibb1)<0) cycle
          ib1 = ibover(ibb1)
          iter1 = (ibb1-1)/neg+1
          ii1 = ibb1-neg*(iter1-1)
          ip0 = ip0b + ib1

          if ( kimg == 1 ) then
             w1hw2(ip0) = 0.d0
             w1sw2(ip0) = 0.d0

             Do is=1, ndim_spinor
               do ii = 1, np_g1k(ik)            ! MPI
                  hr2 = zah_l_noncl( ii, ii2, 1, is )
                  dr2 = zat_l_noncl( ii, ii2, 1, iter2, is )
                  dr1 = zat_l_noncl( ii, ii1, 1, iter1, is )
                  w1hw2(ip0) = w1hw2(ip0) + dr1*hr2
                  w1sw2(ip0) = w1sw2(ip0) + dr1*dr2
               end do
             End do
          else
             if ( k_symmetry(ik) == GAMMA ) then
                w1hw2(ip0) = 0.d0
                w1sw2(ip0) = 0.d0
!!$                ig1 = 1;  if(mype == 0) ig1 = 2
                ig1 = 1;  if(myrank_e == 0) ig1 = 2
!
                Do is=1, ndim_spinor
                  do ii = ig1, np_g1k(ik)
                     hr2 = zah_l_noncl( ii, ii2, 1, is )
                     hi2 = zah_l_noncl( ii, ii2, 2, is )
                     dr2 = zat_l_noncl( ii, ii2, 1, iter2, is )
                     di2 = zat_l_noncl( ii, ii2, 2, iter2, is )
                     dr1 = zat_l_noncl( ii, ii1, 1, iter1, is )
                     di1 = zat_l_noncl( ii, ii1, 2, iter1, is )
                     w1hw2(ip0) = w1hw2(ip0) +( dr1*hr2 +di1*hi2 )*2.d0
                     w1sw2(ip0) = w1sw2(ip0) +( dr1*dr2 +di1*di2 )*2.d0
                  end do
                End do
!!$                if(mype == 0) then
                if ( myrank_e == 0 ) then
                   Do is=1, ndim_spinor
                      hr2 = zah_l_noncl( 1, ii2, 1, is )
                      hi2 = zah_l_noncl( 1, ii2, 2, is )
                      dr2 = zat_l_noncl( 1, ii2, 1, iter2, is )
                      di2 = zat_l_noncl( 1, ii2, 2, iter2, is )
                      dr1 = zat_l_noncl( 1, ii1, 1, iter1, is )
                      di1 = zat_l_noncl( 1, ii1, 2, iter1, is )
                      w1hw2(ip0) = w1hw2(ip0) +dr1*hr2 +di1*hi2
                      w1sw2(ip0) = w1sw2(ip0) +dr1*dr2 +di1*di2
                   End do
                end if
             else
                w1hw2( 2*ip0-1:2*ip0 ) = 0.d0
                w1sw2( 2*ip0-1:2*ip0 ) = 0.d0
                Do is=1, ndim_spinor
                   do ii = 1, np_g1k(ik)
                      hr2 = zah_l_noncl( ii, ii2, 1, is )
                      hi2 = zah_l_noncl( ii, ii2, 2, is )
                      dr2 = zat_l_noncl( ii, ii2, 1, iter2, is )
                      di2 = zat_l_noncl( ii, ii2, 2, iter2, is )
                      dr1 = zat_l_noncl( ii, ii1, 1, iter1, is )
                      di1 = zat_l_noncl( ii, ii1, 2, iter1, is )
                      w1hw2( 2*ip0-1 ) = w1hw2( 2*ip0-1 ) +dr1*hr2 +di1*hi2
                      w1hw2( 2*ip0   ) = w1hw2( 2*ip0   ) +dr1*hi2 -di1*hr2
                      w1sw2( 2*ip0-1 ) = w1sw2( 2*ip0-1 ) +dr1*dr2 +di1*di2
                      w1sw2( 2*ip0   ) = w1sw2( 2*ip0   ) +dr1*di2 -di1*dr2
                  end do
                End do
             end if
          end if
       end do
    end do
! --
    if ( ipridavidson >= 3 ) call wd_w1hw2(" -- w1hw2 without nl part--")
    ! <n|Vnl|m> G-wise parallel
    call add_nonlocal_part_noncl      ! w1hw2 = w1hw2 + w1Vnlw2
                                      ! w1sw2 = w1sw2 + w1qw2
    if(ipridavidson >= 3) call wd_w1hw2(" -- w1hw2 with nl part--")

!! (spread sum of w1hw2 and w1sw2)

    if (npes > 1) then
       w1hw2_mpi = 0.d0
       w1sw2_mpi = 0.d0
       nshift = nsize_mt_old*kimg_t
       ndata = (nsize_mt_now-nsize_mt_old)*kimg_t
       call mpi_allreduce(w1hw2(nshift+1),w1hw2_mpi,ndata,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI

       w1hw2(nshift+1:nshift+ndata) = w1hw2_mpi(1:ndata) ! MPI
       call mpi_allreduce(w1sw2(nshift+1),w1sw2_mpi,ndata,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       w1sw2(nshift+1:nshift+ndata) = w1sw2_mpi(1:ndata) ! MPI
    end if

    if (ipridavidson >= 2) call wd_w1hw2(" -- just after making w1hw2 --")
    if (ipridavidson >= 2) then
       write(nfout,*) 'neordr for ik = ',ik
       write(nfout,9002) (neordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'nrvf_ordr for ik = ',ik
       write(nfout,9002) (nrvf_ordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'eig'
       write(nfout,'(5x,10f8.4)') (eko_l(ib1,ik),ib1=1,np_e)
    endif
9002 format(5x,10i8)

!! (Diagonalization )  !!

#ifdef _USE_SCALAPACK_
    if(sw_dav_scalapack == ON) then
       call initialize_scalapack()
       if(kimg_t == 1) then
          call pdsygvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
       else
          call pzhegvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
       endif
! === DEBUG by tkato 2012/12/20 ================================================
!      call finalize_scalapack()
! ==============================================================================
    else
       if(kimg_t == 1) then
          call dspgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
       else
          call zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
       endif
    endif
#else
    if(kimg_t == 1) then
       call dspgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
    else
       call zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
    endif
#endif

    frestart = .false.
    if ( ierr_diag /= 0 ) then
       if(ipridavidson>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
       Do is=1, ndim_spinor
         zaj_l(:,:,ik+is-1,:) = zaj_l_backup_noncl(:,:,:,is)   ! ????
       End do

       do ib1 = 1, neg
          if(map_e(ib1) == myrank_e) then         ! MPI
             eko_l(map_z(ib1),ik)=eko_d(ib1)
          end if
       end do
       frestart = .true.
       if(ipridavidson >= 2) then
          write(nfout,*) '** restart Davidson iteration **'
       end if
    else

       feigconv = .false.
       do ib=1,neg
          if(occup(ib) == 1) then
             if(abs(eko_d(ib)-eig(ib)) < delta_eig_occup) feigconv(ib) = .true.
          else
             if(abs(eko_d(ib)-eig(ib)) < delta_eig_empty) feigconv(ib) = .true.
          end if
       end do

!!$       if(ipridavidson >= 2) then
       if(ipri0 >= 2) then
          write(nfout,*) 'eko_d for ik = ',ik
          write(nfout,9001) (eko_d(ib),ib=1,neg)
          write(nfout,*) 'eig for ik = ',ik
          write(nfout,9001) (eig(ib),ib=1,neg)
          call wd_w1hw2(" -- after diagonalization --")
!sum eko
          dr1=0.d0;dr2=0.d0
          do ib1=1,neg
             ib1to = neordr(ib1,ik)
             if(map_e(ib1to) == myrank_e) dr1=dr1+eko_l(map_z(ib1to),ik) ! MPI
             dr2=dr2+eig(ib1)
          enddo
          call mpi_allreduce(dr1,di1,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
          dr1 = di1  ! MPI
          write(nfout,'(" sum of eko_l, eig, abs diff =",3e25.10)') dr1,dr2,abs(dr2-dr1)
       endif

!! (subspace rotation) !!
       call subspace_rotation_noncl        ! vec,zat_l -> zat_l

!( tenchi ) (zaj_l <- zat_l)
       iter = min(idavid+1,ndavid)
       Do is=1, ndim_spinor
         call m_ES_W_transpose_back_r(.false., ista_k, iend_k, ik+is-1, &
	&                            zaj_l, zat_l_noncl(1,1,1,iter,is) )
         zaj_l_backup_noncl(:,:,:,is) = zaj_l(:,:,ik+is-1,:)
       End do

!! (eko_l)
       do ib1 = 1, neg
          if(map_e(ib1) == myrank_e) then         ! MPI
             eko_l(map_z(ib1),ik)=eig(ib1)
          end if
       end do
       if(ipridavidson >= 2) then
          eko2 = sum(eig(1:neg))
          write(nfout,1201) ik,eko1,ekod,eko2

          write(nfout,*) 'eko_l'
          write(nfout,9001) (eko_l(ib1,ik),ib1=1,neg)
       endif
1201 format(' %% for ik = ',i4,4x,' eko1&ekod&eko2 = ',3f14.7)
9001 format(5x,6f12.5)
!! (neordr & nrvf_ordr)

    end if

    neordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
    nrvf_ordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)

! (deallocate)
    deallocate(eko_d)
    deallocate(eko_d_mpi)
    deallocate(eig)
    deallocate(vec)
    deallocate(occup)
    deallocate(occup_mpi)

    call tstatc0_end(id_sname)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine wd_w1hw2(somecomment)
      character(len=*), intent(in) :: somecomment
      integer :: ib1, ib2, neg_wd, nsb_wd
      write(nfout,'(a35)') somecomment
      write(nfout,*) 'w1hw2 for ik = ',ik
      neg_wd = 8
      nsb_wd = 8
      if(neg_wd > neg) neg_wd = neg
      if(nsb_wd > nsize_sb_now) nsb_wd = nsize_sb_now
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
      write(nfout,*) 'w1sw2 for ik = ',ik
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
9001  format(5x,9f12.5)
      write(nfout,*) 'eko_l for ik = ',ik
      write(nfout,9001) (eko_d(neordr(ib1,ik)),ib1=1,neg_wd)
    end subroutine wd_w1hw2

    subroutine add_nonlocal_part_noncl
      integer :: ip,ib1,ib2,ibb1,ibb2
      integer       :: ia, lmt1, lmt2, it, p, s, ib

      integer :: is1, is2, is_tmp
      integer :: il1, il2, im1, im2
      integer :: mdvdb

      complex(kind=CMPLDP) :: facv,facq
      real(kind=DP) :: vr,vi,qr,qi, cv1, cv2, cq1, cq2

      real(kind=DP) :: tmpr,tmpi

      do ibb2 = nsize_max_sb_now-neg+1,nsize_max_sb_now
         if(ibover(ibb2)<0) cycle
         ib2 = ibover(ibb2)
         iter2= (ibb2-1)/neg+1
         ii2  = ibb2-neg*(iter2-1)
         ip0b = ib2*(ib2-1)/2
         do ibb1 = 1,ibb2
            if(ibover(ibb1)<0) cycle
            ib1 = ibover(ibb1)
            iter1=(ibb1-1)/neg+1
            ii1  = ibb1-neg*(iter1-1)
            ip0 = ip0b + ib1
            if(mod(ip0-1,nrank_e)/=myrank_e) cycle
            if(kimg_t==1) then
               vr=0.d0
               qr=0.d0
            else
               vr=0.d0
               vi=0.d0
               qr=0.d0
               qi=0.d0
            end if

            do ia = 1, natm
               it = ityp(ia)

! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
               mdvdb = m_PP_include_vanderbilt_pot(it)
#endif
! ---------------------------------------------------- 11.0S

               do lmt1 = 1, ilmt(it)
                  p = lmta(lmt1,ia)
                  il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)

                  do lmt2 = 1, ilmt(it)
                     s = lmta(lmt2,ia)
                     il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)

! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
                     if ( mdvdb == SKIP ) then
                        if ( il1 /= il2 ) cycle
                        if ( SpinOrbit_mode == Neglected .and. sw_hubbard == OFF ) then
                           if ( im1 /= im2 ) cycle
                        endif
                     endif
#endif
! ---------------------------------------------------- 11.0S

                     Do is1=1, ndim_spinor
                        Do is2=1, ndim_spinor
                           is_tmp = ndim_spinor*( is1 -1 ) +is2
                           facv = iwei(ia) *dion_scr_noncl( lmt1, lmt2, is_tmp, ia )
                           facq = iwei(ia) *q_noncl( lmt1, lmt2, is_tmp, it )

                           if ( kimg==1 ) then
                              tmpr = fsr_noncl( ii1, p, iter1, is1 ) &
	&                           *fsr_noncl( ii2, s, iter2, is2 ) &
        &                          + fsi_noncl( ii1, p, iter1, is1 ) &
	&                           *fsi_noncl( ii2, s, iter2, is2 )
                              tmpi = fsr_noncl( ii1, p, iter1, is1 )&
        &                           *fsi_noncl( ii2, s, iter2, is2 )&
        &                          - fsi_noncl( ii1, p, iter1, is1 )&
	&                           *fsr_noncl( ii2, s, iter2, is2 )
                              vr = vr + real( facv )*tmpr -aimag( facv )*tmpi
                              qr = qr + real( facq )*tmpr -aimag( facq )*tmpi
                           else
                              if ( k_symmetry(ik) == GAMMA ) then
                                 tmpr = fsr_noncl( ii1, p, iter1, is1 )&
	&                              *fsr_noncl( ii2, s, iter2, is2 )
                                 vr = vr + real( facv )*tmpr
                                 qr = qr + real( facq )*tmpr
                              else
                                 tmpr = fsr_noncl( ii1, p, iter1, is1 )&
	&                              *fsr_noncl( ii2, s, iter2, is2 )&
                    &                 + fsi_noncl( ii1, p, iter1, is1 )&
	&                              *fsi_noncl( ii2, s, iter2, is2 )
	                         tmpi = fsr_noncl( ii1, p, iter1, is1 )&
	&                              *fsi_noncl( ii2, s, iter2, is2 )&
        &                             - fsi_noncl( ii1, p, iter1, is1 )&
	&                              *fsr_noncl( ii2, s, iter2, is2 )

                                 cv1 = real(facv);  cv2 = aimag(facv)
                                 cq1 = real(facq);  cq2 = aimag(facq)

                                 vr = vr + cv1 *tmpr - cv2 *tmpi
                                 vi = vi + cv1 *tmpi + cv2 *tmpr
                                 qr = qr + cq1 *tmpr - cq2 *tmpi
                                 qi = qi + cq1 *tmpi + cq2 *tmpr

                              endif
                           end if
                        End do
                     End do
                  end do
               end do
            end do

            if ( kimg_t==1 ) then
               w1hw2(ip0) = w1hw2(ip0) + vr
               w1sw2(ip0) = w1sw2(ip0) + qr
            else
               w1hw2(2*ip0-1) = w1hw2(2*ip0-1) + vr
               w1hw2(2*ip0  ) = w1hw2(2*ip0  ) + vi
               w1sw2(2*ip0-1) = w1sw2(2*ip0-1) + qr
               w1sw2(2*ip0  ) = w1sw2(2*ip0  ) + qi
            end if
         end do
      end do
    end subroutine add_nonlocal_part_noncl

    subroutine subspace_rotation_noncl
      integer :: ib1,ib2,ibb2
      real(kind=DP), allocatable, dimension(:,:,:,:) :: zaj_wk

      allocate(zaj_wk(np_g1k_x,neg,kimg,ndim_spinor))
      zaj_wk = 0.d0

      if ( kimg==1 ) then
         do ib1=1,neg
            do ibb2=1,nsize_max_sb_now
               if(ibover(ibb2)<0) cycle
               ib2 = ibover(ibb2)
               iter2=(ibb2-1)/neg+1
               ii2=ibb2-neg*(iter2-1)

               Do is=1, ndim_spinor
                 k1 = ik +is -1
                 do ii=1,np_g1k(ik)
                    zaj_wk( ii, ib1, kimg, is ) = zaj_wk( ii, ib1, kimg,is ) &
	&                  + zat_l_noncl( ii, ii2, kimg, iter2, is )*vec( ib2,ib1 )
                 end do
               End do
            end do
         end do
      else
         if ( k_symmetry(ik) == GAMMA ) then
            do ib1=1,neg
               do ibb2=1,nsize_max_sb_now
                  if(ibover(ibb2)<0) cycle
                  ib2 = ibover(ibb2)
                  iter2=(ibb2-1)/neg+1
                  ii2=ibb2-neg*(iter2-1)
                  hr2=vec(ib2,ib1)

                  Do is=1, ndim_spinor
                     k1 = ik +is -1
                     do ii=1,np_g1k(ik)
                        dr1 = zat_l_noncl( ii, ii2, 1   , iter2, is )
                        di1 = zat_l_noncl( ii, ii2, kimg, iter2, is )
                        zaj_wk( ii, ib1, 1, is ) &
	&                   = zaj_wk( ii, ib1, 1, is ) + dr1*hr2
                        zaj_wk( ii, ib1, kimg, is ) &
	&                   = zaj_wk( ii, ib1, kimg, is ) + di1*hr2
                     end do
                  End do
               end do
            end do
         else
            do ib1=1,neg
               do ibb2=1,nsize_max_sb_now
                  if(ibover(ibb2)<0) cycle
                  ib2 = ibover(ibb2)
                  iter2=(ibb2-1)/neg+1
                  ii2=ibb2-neg*(iter2-1)
                  hr2=vec(2*ib2-1,ib1)
                  hi2=vec(2*ib2  ,ib1)

                  Do is=1, ndim_spinor
                     k1 = ik +is -1
                     do ii=1,np_g1k(ik)
                        dr1 = zat_l_noncl( ii, ii2, 1   , iter2, is )
                        di1 = zat_l_noncl( ii, ii2, kimg, iter2, is )
                        zaj_wk( ii, ib1, 1, is ) &
	&                   = zaj_wk( ii, ib1, 1, is ) + dr1*hr2 - di1*hi2
                        zaj_wk( ii, ib1, kimg, is ) &
	&                   = zaj_wk( ii, ib1, kimg,is ) + dr1*hi2 + di1*hr2
                     end do
                  End do
               end do
            end do
         end if
      end if
      iter = min(idavid+1,ndavid)

      Do is=1, ndim_spinor
        zat_l_noncl(:,:,:,iter,is) = zaj_wk(:,:,:,is)
      End do

      deallocate(zaj_wk)
    end subroutine subspace_rotation_noncl

  end subroutine evolve_WFs_in_subspace_noncl
!======================================================================= 11.0


  subroutine vlhxc_l_zero_term(vlhxc0,ispin)
    real(kind=DP), intent(out) :: vlhxc0
    integer, intent(in)        :: ispin

    if(mype == 0) vlhxc0 = vlhxc_l(1,1,ispin)
    call mpi_bcast(vlhxc0,1,mpi_double_precision,0,MPI_CommGroup,ierr)
  end subroutine vlhxc_l_zero_term

! ===================================== added by K. Tagami ============== 11.0
  subroutine vlhxc_l_zero_term_noncl( vlhxc0 )
    real(kind=DP), intent(out) :: vlhxc0(ndim_chgpot)

    vlhxc0 = 0.0d0
    if (mype == 0) then
!	vlhxc0(1)           = vlhxc_l(1,1,1) + vlhxc_l(1,1,ndim_magmom)
!	vlhxc0(ndim_chgpot) = vlhxc_l(1,1,1) - vlhxc_l(1,1,ndim_magmom)
!
       vlhxc0 = vlhxc_l(1,1,1)
    endif

    call mpi_bcast( vlhxc0, ndim_chgpot, mpi_double_precision,0,MPI_CommGroup,ierr)

  end subroutine vlhxc_l_zero_term_noncl
! ========================================================================= 11.0

#ifndef PARA3D
  subroutine Vnonlocal_Diagonal_part(ispin,ik,iksnl,vnldi)
    integer, intent(in)                        :: ispin, ik, iksnl
    real(kind=DP), intent(out), dimension(kg1) :: vnldi

    integer :: it,mdvdb

    vnldi = 0.d0

    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) then
          call Vnonlocal_D_norm_conserve_case
       else if(mdvdb == EXECUT) then
          call Vnonlocal_D_vanderbilt_case
       end if
    end do

  contains

    subroutine Vnonlocal_D_vanderbilt_case
      integer       :: ia, p1,p2,lmtt1,il1,lmtt2,il2,i
      real(kind=DP) :: ph,fac

      do p1 = 1, ilmt(it)
         lmtt1 = lmtt(p1,it); il1 = ltp(p1,it)
         do p2 = p1, ilmt(it)
            lmtt2 = lmtt(p2,it); il2 = ltp(p2,it)
            if( p1 /= p2) then
               ph = 2.d0*real(zi**(il2-il1))
            else
               ph = 1.d0
            endif
            if(mod(il1+il2,2) == 1) cycle
            do ia = 1, natm
               if(ityp(ia) /= it) cycle
               if(ipaw(it)==0) then
                  fac = ph*iwei(ia) * (dion(p1,p2,it)+vlhxcQ(p1,p2,ia,ispin))
               else
                  fac = ph*iwei(ia) * (dion_paw(p1,p2,ispin,ia)+vlhxcQ(p1,p2,ia,ispin))
               endif
               do i = 1, iba(ik)
                  vnldi(i) = vnldi(i)+fac*snl(i,lmtt1,iksnl)*snl(i,lmtt2,iksnl)
               end do
            end do
         end do
      end do
    end subroutine Vnonlocal_D_vanderbilt_case

    subroutine Vnonlocal_D_norm_conserve_case
      integer       :: ia, lmt1,lmt2,lmtt1,il1,im1,il2,im2,i
      real(kind=DP) :: ph,fac

      ph = 0.d0
      do ia = 1, natm
         if(ityp(ia) /= it) cycle
         ph = ph + iwei(ia)
      end do
      do lmt1 = 1, ilmt(it)
         lmtt1 = lmtt(lmt1,it); il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
         do lmt2 = lmt1, ilmt(it)
            il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
            if(il1 /= il2 .or. im1 /= im2) cycle
            if(mod(il1+il2,2) == 1) cycle

! ======================================== modified by K. Tagami =========== 11.0
!            if(ipaw(it)==0)then
!               fac = ph * dion(lmt1,lmt2,it)
!            else
!               fac = ph * dion_paw(lmt1,lmt2,ispin,ia)
!            endif
!
            fac = 0.d0
            Do ia=1, natm
              if(ityp(ia) /= it) cycle
              if(ipaw(it)==0)then
                 fac = fac + iwei(ia) * dion(lmt1,lmt2,it)
              else
                 fac = fac + iwei(ia) * dion_paw(lmt1,lmt2,ispin,ia)
              endif
            End do
! ========================================================================= 11.0
            do i = 1, iba(ik)
               vnldi(i)  = vnldi(i) + fac * snl(i,lmtt1,iksnl)*snl(i,lmtt1,iksnl)
            end do
         end do
      end do
    end subroutine Vnonlocal_D_norm_conserve_case

  end subroutine Vnonlocal_Diagonal_part

! ====================================== added by K. Tagami ================ 11.0
  subroutine Vnonlocal_Diagonal_part_noncl(ispin,ik,iksnl,vnldi)
    integer, intent(in)                        :: ispin, ik, iksnl

#ifdef USE_COMPLEX_VNLDI
    complex(kind=CMPLDP), intent(out), dimension(kg1) :: vnldi
#else
    real(kind=DP), intent(out), dimension(kg1) :: vnldi
#endif

    integer :: it,mdvdb,ib

!!$    integer :: id_sname = -1
!!$    call tstatc0_begin('Vnonlocal_Diagonal_part ', id_sname)

!    vnldi = 0.d0

    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) then
          call Vnonlocal_D_norm_consv_noncl
       else if(mdvdb == EXECUT) then
          call Vnonlocal_D_vanderbilt_noncl
       end if
    end do

!!$    call tstatc0_end(id_sname)
  contains

    subroutine Vnonlocal_D_vanderbilt_noncl
     integer       :: ia, p1,p2,lmtt1,il1,lmtt2,il2,i
      integer :: im1, im2
      complex(kind=CMPLDP) :: ph, fac

      do p1 = 1, ilmt(it)
         lmtt1 = lmtt(p1,it); il1 = ltp(p1,it);  im1 = mtp(p1,it)

         do p2 = 1, ilmt(it)
            lmtt2 = lmtt(p2,it); il2 = ltp(p2,it);  im2 = mtp(p2,it)

            if( p1 /= p2 ) then
               ph = zi**(il2-il1)
            else
               ph = 1.d0
            endif

!            if(mod(il1+il2,2) == 1) cycle

            fac = 0.d0

            do ia = 1, natm
               if(ityp(ia) /= it) cycle
               fac = fac + ph*iwei(ia)* dion_scr_noncl( p1,p2,ispin,ia )
            end do

            do i = 1, iba(ik)
               vnldi(i) = vnldi(i)+fac*snl(i,lmtt1,iksnl)*snl(i,lmtt2,iksnl)
            end do
         end do
      end do

    end subroutine Vnonlocal_D_vanderbilt_noncl

    subroutine Vnonlocal_D_norm_consv_noncl
      integer       :: ia, p1,p2,lmtt1,il1,lmtt2,il2,i
      integer :: im1, im2
      complex(kind=CMPLDP) :: ph, fac

      do p1 = 1, ilmt(it)
         lmtt1 = lmtt(p1,it); il1 = ltp(p1,it);  im1 = mtp(p1,it)

         do p2 = 1, ilmt(it)
            lmtt2 = lmtt(p2,it); il2 = ltp(p2,it);  im2 = mtp(p2,it)

            if ( il1 /= il2 ) cycle
            if ( SpinOrbit_mode == Neglected .and. sw_hubbard == OFF ) then
               if ( im1 /= im2 ) cycle
            endif

            if( p1 /= p2 ) then
               ph = zi**(il2-il1)
            else
               ph = 1.d0
            endif

!            if(mod(il1+il2,2) == 1) cycle

            fac = 0.d0

            do ia = 1, natm
               if(ityp(ia) /= it) cycle
               fac = fac + ph*iwei(ia)* dion_scr_noncl( p1,p2,ispin,ia )

            end do

            do i = 1, iba(ik)
               vnldi(i) = vnldi(i)+fac*snl(i,lmtt1,iksnl)*snl(i,lmtt2,iksnl)
            end do
         end do
      end do

    end subroutine Vnonlocal_D_norm_consv_noncl

  end subroutine Vnonlocal_Diagonal_part_noncl
! ==================================================================== 11.0



! ====================================== modified by K. Tagami ============ 11.0
!!!  subroutine S_Diagonal_part(ik,iksnl,sdiag)
!!    integer, intent(in)                        :: ik, iksnl
!
  subroutine S_Diagonal_part(ispin,ik,iksnl,sdiag)
    integer, intent(in)                        :: ik, iksnl, ispin
! ========================================================================= 11.0

    real(kind=DP), intent(out), dimension(kg1) :: sdiag

    integer :: it,mdvdb

    sdiag = 1.d0
    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb /= SKIP) call Vanderbilt_case
    end do

  contains

    subroutine Vanderbilt_case
      integer       :: ia, p1,p2,lmtt1,il1,lmtt2,il2,i
      real(kind=DP) :: ph,fac

      do p1 = 1, ilmt(it)
         lmtt1 = lmtt(p1,it); il1 = ltp(p1,it)
         do p2 = p1, ilmt(it)
            lmtt2 = lmtt(p2,it); il2 = ltp(p2,it)
            if( p1 /= p2) then
               ph = 2.d0*real(zi**(il2-il1))
            else
               ph = 1.d0
            endif
            if(mod(il1+il2,2) == 1) cycle
            do ia = 1, natm
               if(ityp(ia) /= it) cycle
               fac = ph*iwei(ia) * q(p1,p2,it)
               do i = 1, iba(ik)
                  sdiag(i) = sdiag(i)+fac*snl(i,lmtt1,iksnl)*snl(i,lmtt2,iksnl)
               end do
            end do
         end do
      end do
    end subroutine Vanderbilt_case

  end subroutine S_Diagonal_part

! ================================== added by K. Tagami ====================== 11.0
  subroutine S_Diagonal_part_noncl(ispin,ik,iksnl,sdiag)
    integer, intent(in)                        :: ik, iksnl, ispin

#ifdef USE_COMPLEX_VNLDI
    complex(kind=CMPLDP), intent(out), dimension(kg1) :: sdiag
#else
    real(kind=DP), intent(out), dimension(kg1) :: sdiag
#endif

    integer :: it,mdvdb

!    sdiag = 1.d0

    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if (mdvdb /= SKIP) then
          Call Vanderbilt_case_noncl2
       endif
    end do

  contains

    subroutine Vanderbilt_case_noncl2
      integer       :: ia, p1,p2,lmtt1,il1,lmtt2,il2,i
      integer :: im1, im2
      complex(kind=CMPLDP) :: ph,fac


      do p1 = 1, ilmt(it)
         lmtt1 = lmtt(p1,it); il1 = ltp(p1,it);  im1 = mtp(p1,it)

         do p2 = 1, ilmt(it)
            lmtt2 = lmtt(p2,it); il2 = ltp(p2,it);  im2 = mtp(p2,it)

            if ( il1 /= il2 ) cycle
            if ( SpinOrbit_mode /= BuiltIn ) then
               if ( im1 /= im2 ) cycle
            endif

            if( p1 /= p2) then
               ph = zi**(il2-il1)
            else
               ph = 1.d0
            endif

!            if(mod(il1+il2,2) == 1) cycle

            fac = 0.0d0
            do ia = 1, natm
               if(ityp(ia) /= it) cycle
               fac = fac + ph*iwei(ia) * q_noncl(p1,p2,ispin,it)
            End do

            do i = 1, iba(ik)
               sdiag(i) = sdiag(i)+ fac *snl(i,lmtt1,iksnl)*snl(i,lmtt2,iksnl)
            end do
         end do
      end do
    end subroutine Vanderbilt_case_noncl2

  end subroutine S_Diagonal_part_noncl
! ============================================================================ 11.0


  subroutine dspgvx_driver(eig,vec,w1hw2,w1sw2,ierr)
    real(kind=DP), intent(out) ,dimension(nsize_sb_now) :: eig
    real(kind=DP), intent(out) ,dimension(nsize_sb_now*neg) :: vec
    real(kind=DP), intent(inout) ,dimension(nsize_mt_now) :: w1hw2,w1sw2
    integer, intent(out) :: ierr
    integer :: ITYPE
    character(len=1) :: JOBZ,RANGE,UPLO
    integer :: il,iu
    real(kind=DP),allocatable,dimension(:) :: work_lapack
    integer, allocatable, dimension(:) :: iwork_lapack, ifail_lapack
    real(kind=DP) :: vl,vu,abstol
    integer :: info,m
    real(kind=DP), external :: dlamch
!!$    real(kind=DP), dimension(nsize_mt_now) :: ap,bp
    real(kind=DP), allocatable, dimension(:) :: ap,bp

    allocate(ap(nsize_mt_now),bp(nsize_mt_now))
    abstol = 2*dlamch('S')

    il=1; iu=neg
!(LAPACK)  ITYPE = 1:  A*x = (lambda)*B*x, 2:  A*B*x = (lambda)*x, 3:  B*A*x = (lambda)*x
    ITYPE = 1
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  RANGE = A : all eigenvalues, V: all eigenvalues in (VL, VU], I: the IL-th through IU-th eigenvalues
    RANGE = 'I'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
    allocate(work_lapack(8*nsize_sb_now))
    allocate(iwork_lapack(5*nsize_sb_now))
    allocate(ifail_lapack(nsize_sb_now))

    ap = w1hw2
    bp = w1sw2

    call dspgvx(ITYPE,JOBZ,RANGE,UPLO,nsize_sb_now,ap,bp &
    &          ,vl,vu,il,iu,abstol,m,eig,vec,nsize_sb_now &
    &          ,work_lapack,iwork_lapack,ifail_lapack,info)

    if(ipridavidson >=2 .and. info/=0) then
       write(nfout,*) "debug(dspgvx) info=",info
       write(nfout,*) "debug(dspgvx) ifail"
       write(nfout,'(8(1x,i3))') ifail_lapack
       write(nfout,*) "debug(dspgvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(work_lapack)
    deallocate(iwork_lapack)
    deallocate(ifail_lapack)

    deallocate(ap,bp)

    if(info/=0) then
       !!write(nfout,*) "dspgvx: info=",info
       !!stop 'error in dspgvx_driver'
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine dspgvx_driver

#ifdef _USE_SCALAPACK_
  subroutine pdsygvx_driver(eig, vec, w1hw2, w1sw2, ierr)
    real(kind=DP), intent(out),  dimension(nsize_sb_now)      :: eig
    real(kind=DP), intent(out),  dimension(nsize_sb_now, neg) :: vec
    real(kind=DP), intent(inout),dimension(nsize_mt_now)      :: w1hw2, w1sw2
    integer, intent(out) :: ierr
    integer :: itype
    integer :: il,iu
    integer, allocatable, dimension(:) :: ifail
    real(kind=DP) :: vl, vu, abstol
    integer :: info, m
    real(kind=DP), external :: dlamch
! ==============================================================================
    real(kind=DP), allocatable, dimension(:,:) :: ap, bp, z
    integer :: nz, count
    real(kind=DP) :: orfac = -1.0d0
    real(kind=DP), allocatable, dimension(:) :: work, gap
    integer,       allocatable, dimension(:) :: iwork, iclustr
    integer :: i, j
! ==============================================================================

    abstol = 2*dlamch('S')
    il=1; iu=neg
    itype = 1

    allocate(ap(nrowa,ncola))
    allocate(bp(nrowa,ncola))
    allocate(z (nrowa,ncola))

    count = 1
    do j = 1, nsize_sb_now
      do i = 1, nsize_sb_now
        if(i .le. j) then
          call pdelset(ap,i,j,desca,w1hw2(count))
          call pdelset(bp,i,j,desca,w1sw2(count))
          count = count + 1
        endif
      enddo
    enddo

    allocate(work   (lwork1))
    allocate(iwork  (liwork1))
    allocate(ifail  (nsize_sb_now))
    allocate(iclustr(2*nprow*npcol))
    allocate(gap    (nprow*npcol))

    call pdsygvx(itype,'V','I','U',nsize_sb_now, &
                 ap,1,1,desca, &
                 bp,1,1,desca, &
                 vl,vu,il,iu,abstol,m,nz,eig,orfac, &
                 z,1,1,desca,&
                 work,lwork1,iwork,liwork1, &
                 ifail,iclustr,gap,info)

    do j = 1, neg
      do i = 1, nsize_sb_now
        call pdelget('A',' ',vec(i,j),z,i,j,desca)
      enddo
    enddo

    if(ipridavidson >=2 .and. info/=0) then
       write(nfout,*) "debug(dspgvx) info=",info
       write(nfout,*) "debug(dspgvx) ifail"
       write(nfout,'(8(1x,i3))') ifail
       write(nfout,*) "debug(dspgvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(ap)
    deallocate(bp)
    deallocate(z)
    deallocate(work)
    deallocate(iwork)
    deallocate(iclustr)
    deallocate(gap)
    deallocate(ifail)

    if(info/=0) then
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine pdsygvx_driver
#endif

  subroutine zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr)
    real(kind=DP), intent(out) ,dimension(nsize_sb_now) :: eig
    real(kind=DP), intent(out) ,dimension(nsize_sb_now*kimg,nsize_sb_now) :: vec
    real(kind=DP), intent(in) ,dimension(nsize_mt_now*kimg) :: w1hw2,w1sw2
    integer, intent(out) :: ierr
    integer :: ITYPE
    character(len=1) :: JOBZ,RANGE,UPLO
    integer :: il,iu
    real(kind=DP),allocatable,dimension(:) :: work_lapack
    real(kind=DP),allocatable,dimension(:) :: rwork_lapack
    integer, allocatable, dimension(:) :: iwork_lapack, ifail_lapack
    real(kind=DP) :: vl,vu,abstol
    integer :: info,m
    real(kind=DP), external :: dlamch
!!$    real(kind=DP), dimension(nsize_mt_now*kimg) :: ap,bp
    real(kind=DP), allocatable, dimension(:) :: ap,bp
    integer :: ib,i

    abstol = 2*dlamch('S')

    il=1; iu=neg
!(LAPACK)  ITYPE = 1:  A*x = (lambda)*B*x, 2:  A*B*x = (lambda)*x, 3:  B*A*x = (lambda)*x
    ITYPE = 1
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  RANGE = A : all eigenvalues, V: all eigenvalues in (VL, VU], I: the IL-th through IU-th eigenvalues
    RANGE = 'I'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
    allocate(work_lapack(2*nsize_sb_now*kimg)); work_lapack = 0.d0
    allocate(rwork_lapack(7*nsize_sb_now)); rwork_lapack = 0.d0
    allocate(iwork_lapack(5*nsize_sb_now)); iwork_lapack = 0
    allocate(ifail_lapack(nsize_sb_now)); ifail_lapack=0
    allocate(ap(nsize_mt_now*kimg));ap=0.d0
    allocate(bp(nsize_mt_now*kimg));bp=0.d0

    if(ipridavidson >=3 ) then
       write(nfout,*) "debug(zhpgvx) i,w1hw2,w1sw2"
       do ib=1,nsize_sb_now
          i = ib*(ib-1)/2 + ib
          write(nfout,*) ib,w1hw2(2*i-1),w1sw2(2*i-1)
       end do
       ap = w1sw2
       write(nfout,*) "debug(zhpgvx) i,ap,w1sw2"
       do i=1,nsize_mt_now
          write(nfout,*) i,ap(2*i-1),w1sw2(2*i-1)
       end do
       call zhpevx('N','A','U',nsize_sb_now,ap,vl,vu,il,iu,abstol,m &
    &          ,eig,vec,nsize_sb_now &
    &          ,work_lapack,rwork_lapack,iwork_lapack,ifail_lapack,info)
       write(nfout,*) "debug(zhpgvx) eig of w1sw2"
       do ib=1,nsize_sb_now
          write(nfout,*) ib,eig(ib)
       end do
    end if

    ap = w1hw2
    bp = w1sw2

    call zhpgvx(ITYPE,JOBZ,RANGE,UPLO,nsize_sb_now,ap,bp &
    &          ,vl,vu,il,iu,abstol,m,eig,vec,nsize_sb_now &
    &          ,work_lapack,rwork_lapack,iwork_lapack,ifail_lapack,info)

    if(ipridavidson >=2 .and. info/=0) then
       write(nfout,*) "debug(zhpgvx) info=",info
       write(nfout,*) "debug(zhpgvx) ifail"
       write(nfout,'(8(1x,i3))') ifail_lapack
       write(nfout,*) "debug(zhpgvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(work_lapack)
    deallocate(rwork_lapack)
    deallocate(iwork_lapack)
    deallocate(ifail_lapack)
    deallocate(ap,bp)

    if(info/=0) then
       !!write(nfout,*) "zhpgvx: info=",info
       !!stop 'error in zhpgvx_driver'
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine zhpgvx_driver

#ifdef _USE_SCALAPACK_
  subroutine pzhegvx_driver(eig, vec, w1hw2, w1sw2, ierr)
    real(kind=DP), intent(out),  dimension(nsize_sb_now)           :: eig
    real(kind=DP), intent(out),  dimension(nsize_sb_now*kimg, neg) :: vec
    real(kind=DP), intent(inout),dimension(nsize_mt_now*kimg)      :: w1hw2, w1sw2
    integer, intent(out) :: ierr
    integer :: itype
    integer :: il,iu
    integer, allocatable, dimension(:) :: ifail
    real(kind=DP) :: vl, vu, abstol
    integer :: info, m
    real(kind=DP), external :: dlamch
! ==============================================================================
!!$    complex(kind=16), allocatable, dimension(:,:) :: ap, bp, z
    complex(kind=CMPLDP), allocatable, dimension(:,:) :: ap, bp, z
    integer :: nz, count
    real(kind=DP) :: orfac = -1.0d0
!!$    complex(kind=16), allocatable, dimension(:) :: work, rwork
    complex(kind=CMPLDP), allocatable, dimension(:) :: work, rwork
    integer,          allocatable, dimension(:) :: iwork, iclustr
    real(kind=DP),    allocatable, dimension(:) :: gap
    integer :: i, j
! ==============================================================================

    abstol = 2*dlamch('S')
    il=1; iu=neg
    itype = 1

    allocate(ap(nrowa,ncola))
    allocate(bp(nrowa,ncola))
    allocate(z (nrowa,ncola))

    count = 1
    do j = 1, nsize_sb_now
      do i = 1, nsize_sb_now
        if(i .le. j) then
          call pzelset(ap,i,j,desca,w1hw2(count))
          call pzelset(bp,i,j,desca,w1sw2(count))
          count = count + 2
        endif
      enddo
    enddo

    allocate(work   (lwork2))
    allocate(rwork   (lrwork2))
    allocate(iwork  (liwork2))
    allocate(ifail  (nsize_sb_now))
    allocate(iclustr(2*nprow*npcol))
    allocate(gap    (nprow*npcol))

    call pzhegvx(itype,'V','I','U',nsize_sb_now, &
                 ap,1,1,desca, &
                 bp,1,1,desca, &
                 vl,vu,il,iu,abstol,m,nz,eig,orfac, &
                 z,1,1,desca,&
                 work,lwork2,rwork,lrwork2,iwork,liwork2, &
                 ifail,iclustr,gap,info)

    do j = 1, neg
      do i = 1, nsize_sb_now
        call pzelget('A',' ',vec(2*i-1,j),z,i,j,desca)
      enddo
    enddo

    if(ipridavidson >=2 .and. info/=0) then
       write(nfout,*) "debug(dspgvx) info=",info
       write(nfout,*) "debug(dspgvx) ifail"
       write(nfout,'(8(1x,i3))') ifail
       write(nfout,*) "debug(dspgvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(ap)
    deallocate(bp)
    deallocate(z)
    deallocate(work)
    deallocate(rwork)
    deallocate(iwork)
    deallocate(iclustr)
    deallocate(gap)
    deallocate(ifail)

    if(info/=0) then
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine pzhegvx_driver

! === DEBUG by tkato 2012/12/20 ================================================
  subroutine create_scalapack_context()
    integer :: myrank, nprocs
    integer, allocatable :: usermap(:,:)
    integer :: i, j

    call blacs_setup(myrank, nprocs)

    nprow = dav_nprow
    npcol = dav_npcol
    call set_nprow_npcol(nprow, npcol)

    write(nfout, '("set nprow, npcol = ", 4i5)') nprow, npcol

    allocate(usermap(nprow,npcol))
    do j = 1, npcol
       do i = 1, nprow
          usermap(i,j) = myrank_k*nrank_e + (i - 1)*npcol + j - 1
       end do
    end do

    call blacs_get(-1, 0, ctxt)
    call blacs_gridmap(ctxt, usermap, nprow, nprow, npcol)
    call blacs_gridinfo(ctxt, nprow, npcol, myprow, mypcol)

    deallocate(usermap)
  end subroutine create_scalapack_context

  subroutine initialize_scalapack()
    integer :: nb, nb_max
    integer, external :: numroc, iceil ! External Functions
    integer :: nn, np0, mq0, nq0
    integer :: info

    nb = dav_block_size
    nb_max = min((nsize_sb_now - 1)/nprow + 1, (nsize_sb_now - 1)/npcol + 1)
    if(nb > nb_max) nb = nb_max

    write(nfout, '("set nb_max, nb = ", 4i5)') nb_max, nb

    nrowa = numroc(nsize_sb_now,nb,myprow,0,nprow) ! number of row    elements per proc
    ncola = numroc(nsize_sb_now,nb,mypcol,0,npcol) ! number of column elements per proc
    call descinit(desca,nsize_sb_now,nsize_sb_now,nb,nb,0,0,ctxt,nrowa,info)

    ! For pdsygvx
    nn      = max(max(nsize_sb_now,nb),2)
    np0     = numroc(nn,nb,0,0,nprow)
    mq0     = numroc(max(max(neg,nb),2),nb,0,0,npcol)
    lwork1  = 5*nsize_sb_now + max(5*nn,np0*mq0+2*nb*nb) &
            + iceil(neg,nprow*npcol)*nn + (neg-1)*nsize_sb_now
    liwork1 = 6*max(max(nsize_sb_now,nprow*npcol+1),4)

    ! For pzhegvx
    np0     = numroc(nsize_sb_now,nb,0,0,nprow)
    nq0     = numroc(nsize_sb_now,nb,0,0,npcol)
    lwork2  = nsize_sb_now + (np0+nq0+nb)*nb
    nn      = max(max(nsize_sb_now,nb),2)
    np0     = numroc(nn,nb,0,0,nprow)
    mq0     = numroc(max(max(neg,nb),2),nb,0,0,npcol)
    lrwork2 = 4*nsize_sb_now + max(5*nn,np0*mq0+2*nb*nb) &
            + iceil(neg,nprow*npcol)*nn + (neg-1)*nsize_sb_now
    liwork2 = 6*max(max(nsize_sb_now,nprow*npcol+1),4)
  end subroutine initialize_scalapack

  subroutine destroy_scalapack_context()
     call blacs_gridexit(ctxt)
  end subroutine destroy_scalapack_context
! ==============================================================================

  subroutine set_nprow_npcol(npr, npc)
    integer, intent(inout) :: npr, npc
    logical :: cflag
    integer :: j, n

    cflag = .true.

    if(npr*npc /= nrank_e) then
       npr = 1
       npc = 1
       j = nrank_e
 120   continue
       if(mod(j, 2) == 0) then
          j = j/2
          n = 2
          call prod(cflag, n, npr, npc)
          goto 120
       else if(mod(j, 3) == 0) then
         j = j/3
         n = 3
         call prod(cflag, n, npr, npc)
         goto 120
       else if(mod(j, 5) == 0) then
         j = j/5
         n = 5
         call prod(cflag, n, npr, npc)
         goto 120
       else if(j == 1) then
         n = 1
       else
         n = j
       end if
       call prod(cflag, n, npr, npc)
    end if
  end subroutine set_nprow_npcol

  subroutine prod(cflag, n, nr, nc)
    logical, intent(inout) :: cflag
    integer, intent(in)    :: n
    integer, intent(inout) :: nr,nc
    if(cflag) then
       nr = nr * n
    else
       nc = nc * n
    endif
    cflag = .not. cflag
  end subroutine prod
#endif
#endif
end module m_ES_WF_by_Davidson

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 599 $)
!
!  MAIN PROGRAM: CPMD
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!
!  $Id: nebmain.f90 599 2019-12-03 05:25:28Z ktagami $
!
program PHASENEB

  use m_Files,                only : nfneb
  use m_Const_Parameters, only : OFF,ON
  use m_IterationNumbers, only : iteration,iteration_electronic,iteration_ionic
  use m_Replica
  use m_Parallelization, only : MPI_CommGroup
  use mpi

  implicit none
  logical  :: ChargeDensity_is_Converged, TotalEnergy_is_Divergent
  logical  :: Already_Converged, Positron_bulk
  logical  :: Hubbard_model
  logical  :: Forces_are_Converged, Ending_Time, Ending_Time2, Force_errors_are_tolerable
  logical  :: replica_converged

  integer i, j, itr
  integer mpi_err
  logical all_conv_flag

  integer prepare_communicator

!  include 'mpif.h'

  call initialize_neb

  call Initialization(OFF)
  call InputData_Analysis(OFF) ! rd_cntn_data = ON

  call set_neb_condition
  call create_replica

  itr = 0
  all_conv_flag = all(neb%image(:)%scf_convergence)  ! for restart
  prepare_communicator = ON

  NEBIteration: do

     itr = itr + 1
     if(all(neb%image(:)%scf_convergence)) then
        neb%step = neb%step + 1
     end if
     call set_neb_parameter

     MultiReplica: do i = 1, neb%number_of_images

        if(mod(i-1,nrank_r) /= mype_r) then
           neb%image(i)%scf_convergence = .true.
           cycle
        end if

        if(neb%cond%condition == 1) then
           if(itr == 1 .and. (.not. all_conv_flag)) then
              if(neb%image(i)%scf_convergence) then
                 neb%image(i)%energy = neb%image(i)%energy0
                 neb%image(i)%force = neb%image(i)%force0
                 neb%image(i)%force_org = neb%image(i)%force0
                 cycle
              end if
           end if
        end if

        if(itr > 1 .and. (i==1 .or. i==neb%number_of_images)) then
           neb%image(i)%energy = neb%image(i)%energy0
           neb%image(i)%force = neb%image(i)%force0
           neb%image(i)%force_org = neb%image(i)%force0
           cycle
        end if

!        write(nfneb,*) 'neb: ', neb%step, i, mype
        write(nfneb,*) 'neb: ', neb%step, i

        call set_neb_replica_parameter(i)
        call set_neb_replica_coordinate(i)

        if(.not.neb%image(i)%scf_convergence) then
           call InputData_Analysis_neb()
        end if

        call Preparation(0)                   ! Basis set, symmetry check etc.
        call Preparation_for_mpi(prepare_communicator)           ! mpi
        call PseudoPotential_Construction
        call Ewald_and_Structure_Factor
        call Initial_Electronic_Structure
        call Initial_MD_Condition

        if(neb%cond%condition == 1 .and. neb%image(i)%scf_convergence) then
           iteration = 0
           iteration_electronic = 0
           iteration_ionic = 0
        end if
        neb%image(i)%scf_convergence = .true.

        if(.not.Already_Converged()) then
           AtomicConfiguration: do
              ChargeDensity:    do
                 call IterationNumber_Setting
                 call Renewal_of_WaveFunctions
                 call ChargeDensity_Construction(0)
                 call ChargeDensity_Mixing
                 call Renewal_of_Potential
                 if(Hubbard_model()) then
                    call Renewal_of_Hubbard_Potential
                 end if
!                 if(Ending_Time())                 exit ChargeDensity
                 if(Ending_Time()) then
                    neb%image(i)%scf_convergence = .false.
                    exit AtomicConfiguration
                 end if
                 if(TotalEnergy_is_Divergent())    exit ChargeDensity
                 if(ChargeDensity_is_Converged())  exit ChargeDensity
              enddo ChargeDensity
#ifdef LIBRARY_BUILD
              call Forces_phase0
#else
              call Forces
#endif
!              if(Forces_are_Converged()) exit AtomicConfiguration
              exit AtomicConfiguration
!!$              if(Force_errors_are_tolerable()) then
!!$                 call Move_Ions
!!$                 call Ewald_and_Structure_Factor
!!$                 call MDIterationNumber_Setting
!!$              end if

           enddo AtomicConfiguration

        end if

!        if(.not.Ending_Time2()) call set_neb_replica_energy_force(i)
        call set_neb_replica_energy_force(i)

!!$        if(Positron_bulk()) then
!!$           call Renewal_of_pPotential()
!!$           call Solve_pWaveFunctions()
!!$        end if

!!$        call Postprocessing
        call WriteDownData_onto_Files

        call deallocate_array

        write(nfneb,*) 'scf convergence: ', i, neb%image(i)%scf_convergence

        prepare_communicator=OFF
     end do MultiReplica

     call allreduce_scf_convergence
     call allreduce_neb_energy_force

     if(.not. all(neb%image(:)%scf_convergence)) then
        write(nfneb,*) 'scf not convergence...'
        exit NEBIteration
     end if

!     call allreduce_neb_energy_force

     call force_neb
     call atom_update_neb
!     call atom_update_pos_neb

     if(replica_converged()) then
        exit NEBIteration
     end if
     if(neb%step >= neb%max_iteration) then
        exit NEBIteration
     end if

  end do NEBIteration

  call write_down_data_replica

  call finalize_neb()

  call mpi_finalize(mpi_err)

end program PHASENEB

!subroutine deallocate_array
!
!  use m_Control_Parameters
!  use m_Crystal_Structure
!  use m_Ionic_System
!  use m_PlaneWaveBasisSet
!  use m_Parallelization
!  use m_Kpoints
!  use m_Force
!  use m_Charge_Density
!  use m_XC_Potential
!  use m_PseudoPotential
!  use m_NonLocal_Potential
!  use m_Electronic_Structure
!  use m_ES_WF_by_SDorCG
!
!!  call m_CtrlP_dealloc
!
!  call m_CS_dealloc
!  call m_IS_dealloc
!  call m_pwBS_dealloc
!  call m_Parallel_dealloc
!  call m_Kp_dealloc
!  call m_Force_dealloc
!  call m_CD_dealloc
!  call m_XC_dealloc_vxc
!  call m_PP_dealloc
!  call m_NLP_dealloc
!  call m_ES_dealloc
!  call m_ESsd_dealloc
!
!
!end subroutine deallocate_array

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a module for setting Coulomb and exchange kernels for the LR-TDDFT .
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

module m_LinearResponse_Kernel

  use m_Charge_Density,        only : chgq_l
  use m_Const_Parameters,        only : Bohr
  use m_PseudoPotential,      only : itpcc,ilmt,ltp,taup,il2p,isph,iqitg, &
      & rhpcg_l, qitg_l,rhpcg_diff_l,qitg_diff_l,dl2p, &
      & m_PP_include_vanderbilt_pot, m_PP_find_maximum_l,nlmt

  use m_Ionic_System,         only : ntyp,natm,iwei,ityp,pos,zfm3_l
  use m_Const_Parameters,     only : DP, CMPLDP, BUCS, PAI, PAI2, PAI4, &
       &                             GGA, LDA, DOWN,UP, &
       &                             Partial_Core_Charge,Valence_plus_PC_Charge

  use m_PlaneWaveBasisSet,    only : ngabc, igf, kg1,kg, igfp_l, n_rGpv, kgp
  use m_Crystal_Structure,    only :  rltv, univol

  use m_Control_Parameters,   only : ipri, nspin, kimg,af, neg, printable, &
       & xctype
  use m_Files,                only : nfout

  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Parallelization,      only : ista_kngp,iend_kngp,npes,mype, ierr, &
       & npes_cdfft, nrank_ggacmp, myrank_cdfft, &
       & myrank_ggacmp, ista_fftp, iend_fftp, ista_fftph, iend_fftp, &
       & nis_fftp, nie_fftp, nel_fftp, idisp_fftp,np_fftp,mp_fftp,  &
       & nel_fftph, idisp_fftph, nrest_cdfft, &
       & mpi_ggacmp_cross_world,mpi_cdfft_world, &
       & map_ggacmp, map_pe2ggacmp, map_pe2cdfft, MPI_CommGroup, &
       & ista_fftph, iend_fftph

  use m_FFT,                  only : fft_box_size_CD, fft_box_size_CD_c, &
       &                             nfftp, &
       &                             m_FFT_CD_inverse_c, &
       &                             m_FFT_check_of_negative_CD, &
       &                             m_FFT_CD_direct_c

#ifdef _MPIFFT_
  use m_FFT,                  only : m_FFT_set_cdata  &
       &                           , lx,ly,lz,ly_d,lz_d, ny_d,nz_d
  use m_PlaneWaveBasisSet,    only : igfp_l_c
#else
  use m_FFT,                  only : m_FFT_alloc_CD_box &
       &                           , m_FFT_dealloc_CD_box
#endif

  use m_FFT,                   only : nfft, fft_box_size_WF
  use m_XC_Potential,         only : check_of_xctype
! ----------------
  use m_LinearResponse_Control,  only : nmax_G_LR, vqxyz, xc_kernel_type, &
       &                                RPA, ALDA_G, LRC, LRC_alpha
  use m_LinearResponse_ALDA,    only :  ker_ex, ker_cr, set_ispin_kt, &
       &                                xc_deallocate, xc_allocate, &
       &                                m_LR_alloc_phase_factor, &
       &                                m_LR_dealloc_phase_factor, &
       &                                calc_phase_factor, afft_allgatherv, &
       &                                Calc_Density_in_Rspace, &
       &                                m_LR_alloc_RKernels_ALDA, &
       &                                m_LR_dealloc_RKernels_ALDA, afft, &
       &                                igfp_LR, &
       &                                Calc_Kernels_ALDA_Rspace

  use m_LinearResponse_Control,  only : rcut_yukawa

!
  Implicit None
  include 'mpif.h'

! ------------------ public ---------
  real(kind=DP), allocatable :: Kernel_Coulomb(:)
  complex(kind=CMPLDP), allocatable :: Kernel_XC(:,:,:,:)

contains

!------------------------------------------------------------------
!!
!!!            Alloc and Dealloc Kernels
!!
!-------------------------------------------------------------------
  subroutine m_LR_alloc_Coulomb_Kernels
    if ( mype == 0 ) then
       allocate( Kernel_Coulomb( nmax_G_LR ) ); Kernel_Coulomb = 0.0D0
    endif
  end subroutine m_LR_alloc_Coulomb_Kernels

  subroutine m_LR_dealloc_Coulomb_Kernels
    if ( mype == 0 ) deallocate( Kernel_Coulomb )
  end subroutine m_LR_dealloc_Coulomb_Kernels

  subroutine m_LR_alloc_XC_Kernels
    if ( mype == 0 ) then
       allocate( Kernel_xc( nmax_G_LR,nmax_G_LR,nspin,nspin ) ); Kernel_XC = 0.0D0
    endif
  end subroutine m_LR_alloc_XC_Kernels

  subroutine m_LR_dealloc_XC_Kernels
    if ( mype == 0 ) deallocate( Kernel_xc )
  end subroutine m_LR_dealloc_XC_Kernels

!-----------------------------------------------------------
!!
!!!              Coulomb Kernels
!!
!-----------------------------------------------------------
  subroutine set_Coulomb_Kernel
    integer i
    real(kind=DP) :: ga, gb, gc, g2
    real(kind=DP) :: ttr(6)
! ----------------------------- start -------------------
    if ( mype /= 0 ) return
    Call getttr (rltv,ttr)
! ------------------------------ main ------------------
    Do i=1, nmax_G_LR
       ga = ngabc(i,1) + vqxyz( 1,1,BUCS )
       gb = ngabc(i,2) + vqxyz( 1,2,BUCS )
       gc = ngabc(i,3) + vqxyz( 1,3,BUCS )
       g2 = ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
            &   +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga
       Kernel_Coulomb(i) = PAI4 / g2
    End Do
  end subroutine set_Coulomb_Kernel

  subroutine set_Screened_Coulomb_Kernel
    integer i
    real(kind=DP) :: ga, gb, gc, g2, gm
    real(kind=DP) :: ttr(6)
! ----------------------------- start -------------------
    if ( mype /= 0 ) return
    Call getttr (rltv,ttr)
    gm = 1.0d0 / rcut_yukawa
    gm = gm **2
! ------------------------------ main ------------------
    Do i=1, nmax_G_LR
       ga = ngabc(i,1) + vqxyz( 1,1,BUCS )
       gb = ngabc(i,2) + vqxyz( 1,2,BUCS )
       gc = ngabc(i,3) + vqxyz( 1,3,BUCS )
       g2 = ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
            &   +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga
       g2 = g2 + gm
       Kernel_Coulomb(i) = PAI4 / g2
    End Do
  end subroutine set_Screened_Coulomb_Kernel

! ---------------------------------------------------------
!!
!!!          XC Kernels ( RPA, LRC, ALDA )
!!
! ---------------------------------------------------------
  subroutine set_XC_Kernel_RPA
    if ( mype == 0 )  Kernel_XC = 0.0d0
  end subroutine set_XC_Kernel_RPA

  subroutine set_XC_Kernel_LRC( alpha_LRC )
    Real(kind=DP), intent(in) :: alpha_LRC
!
    integer i, ni, nj
    real(kind=DP) :: ga, gb, gc, g2
    real(kind=DP) :: ttr(6)
! ---------------------------------- start -------
    if ( mype /= 0 ) return
    Call getttr (rltv,ttr)
! ---------------------------------- main --------
    Do i=1, nmax_G_LR
       ga = ngabc(i,1) + vqxyz( 1,1,BUCS )
       gb = ngabc(i,2) + vqxyz( 1,2,BUCS )
       gc = ngabc(i,3) + vqxyz( 1,3,BUCS )
       g2 = ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
               &   +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga
       Do ni=1, nspin
          Do nj=1, nspin
             Kernel_XC(i,i,ni,nj) = -alpha_LRC / g2
          End Do
       End Do
    End Do
  end subroutine set_XC_Kernel_LRC

  subroutine set_XC_Kernel_LRC_Dynamic( alpha_LRC, beta_LRC, ene )
    Real(kind=DP), intent(in) :: alpha_LRC, beta_LRC, ene
!
    integer i, ni, nj
    real(kind=DP) :: ga, gb, gc, g2, c1
    real(kind=DP) :: ttr(6)
! ------------------------------- start --------------
    if ( mype /= 0 ) return
    Call getttr (rltv,ttr)
! ------------------------------ main --------------
    c1 = alpha_LRC + beta_LRC * ene**2
!
    Do i=1, nmax_G_LR
       ga = ngabc(i,1) + vqxyz( 1,1,BUCS )
       gb = ngabc(i,2) + vqxyz( 1,2,BUCS )
       gc = ngabc(i,3) + vqxyz( 1,3,BUCS )
       g2 = ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
            &   +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga
       Do ni=1, nspin
          Do nj=1, nspin
             Kernel_XC(i,i,ni,nj) = -c1 / g2
          End do
       End do
    End Do
  end subroutine set_XC_Kernel_LRC_Dynamic

  subroutine set_XC_kernel_ALDA_G( input_Charge )
    integer, intent(in) :: input_charge
!
    Real(kind=DP), allocatable :: afft_mpi1(:)
    integer, allocatable       :: GVec_Table( :,:,: )

    integer ngrid, iloop
    integer ispin
! --------------------------- start ---------------
    ngrid = product( fft_box_size_CD(1:3,1) )
! --------------------------- main ---------------
    call set_ispin_kt( ispin, input_charge )
    if(ipri >= 2) write(nfout,*) ' ! ispin = ', ispin
    call xc_allocate( ispin,nfout )
!
    call m_LR_alloc_Phase_Factor
    Call Calc_Phase_Factor

    Call Calc_Density_in_Rspace(ispin, input_Charge )
    call Calc_Kernels_ALDA_Rspace(ispin)

    call Alloc_Tables_For_Gspace
    call Set_Tables_For_Gspace
    call Map_Kernels_To_Gspace
    call Dealloc_Tables_For_Gspace

    call m_LR_dealloc_Phase_Factor
    call xc_deallocate

  contains

    subroutine Alloc_Tables_For_Gspace
      integer :: i,j,k
      i = n_rGpv(1); j = n_rGpv(2); k = n_rGpv(3)
      allocate( GVec_Table(-i:i,-j:j,-k:k) );  GVec_Table = 0
    end subroutine Alloc_Tables_For_Gspace

    subroutine Dealloc_Tables_For_Gspace
      Deallocate( GVec_Table )
    end subroutine Dealloc_Tables_For_Gspace

    subroutine Set_Tables_For_Gspace
      integer :: i, igf1, igf2, igf3
      do i = 1, kgp
         igf1 = ngabc(i,1); igf2 = ngabc(i,2); igf3 = ngabc(i,3)
         if(        igf1 >= -n_rGpv(1) .and. igf1 <= n_rGpv(1) &
            & .and. igf2 >= -n_rGpv(2) .and. igf2 <= n_rGpv(2) &
            & .and. igf3 >= -n_rGpv(3) .and. igf3 <= n_rGpv(3)) then
            GVec_Table(igf1,igf2,igf3) = i
         end if
      end do
    end subroutine Set_Tables_For_Gspace

    subroutine Search_Tables_For_Gspace( ix, iy, iz, G_found )
      integer, intent(in)  :: ix, iy, iz
      integer, intent(out) :: G_found

      G_found = -1
      if ( ix < -n_rGpv(1) .or. ix > n_rGpv(1) ) return
      if ( iy < -n_rGpv(2) .or. iy > n_rGpv(2) ) return
      if ( iz < -n_rGpv(3) .or. iz > n_rGpv(3) ) return
      G_found = GVec_Table( ix, iy, iz )
    end subroutine Search_Tables_For_Gspace

    subroutine Map_Kernels_To_Gspace
      integer ntmp_x, ntmp_y, ntmp_z, G_to_be_mapped
      integer i, j, ni, nj
      integer ip, i1
      real(kind=DP) :: normalization_factor
! ----
      if ( mype == 0 ) Kernel_XC = 0.0d0
      allocate( afft_mpi1(nfftp) )
      call m_FFT_alloc_CD_box()
      normalization_factor = 1.0d0/ product(fft_box_size_CD(1:3,1))
! ----------
      Do ni=1, ispin
         Do nj=1, ispin
            afft = 0.0d0
            Do i=ista_fftph, iend_fftph
               ip = 2 *i - 1
               afft(ip)   = ker_cr(i,ni,nj);     afft(ip+1) = 0.0d0
            End do
            ! ------------- Map to Kernel_XC --
            call m_FFT_CD_direct_c( nfout,afft )     ! afft(R sp) -> afft(G sp)
            ! -------
            call afft_allgatherv( afft, afft_mpi1 )
            afft_mpi1 = afft_mpi1 * normalization_factor
            !
            Do i=1, nmax_G_LR
               Do j=1, nmax_G_LR
!                  ntmp_x = ngabc(i,1) -ngabc(j,1);
!                  ntmp_y = ngabc(i,2) -ngabc(j,2);
!                  ntmp_z = ngabc(i,3) -ngabc(j,3);
                  ntmp_x = ngabc(j,1) -ngabc(i,1);
                  ntmp_y = ngabc(j,2) -ngabc(i,2);
                  ntmp_z = ngabc(j,3) -ngabc(i,3);

                  call Search_Tables_For_Gspace( ntmp_x, ntmp_y, ntmp_z, &
                       &                         G_to_be_mapped  )
                  if ( G_to_be_mapped <= 0 ) then
                     write(*,*) 'Error Code ', i,j, G_to_be_mapped
                     goto 1000
                  endif
                  i1 = igfp_LR( G_to_be_mapped )
                  ip = 2 * i1 -1
! --------------------
                  if ( mype == 0 ) then
                     Kernel_XC(i,j,ni,nj) = dcmplx( afft_mpi1(ip), afft_mpi1(ip+1) ) &
                          &         / univol
                  endif
1000              continue

               End do
            End do
         End do
      End do
! -------------------------------
      call m_FFT_dealloc_CD_box()
      deallocate( afft_mpi1 )
    end subroutine Map_Kernels_To_Gspace

  end subroutine set_XC_kernel_ALDA_G

  subroutine set_XC_Kernel_ALDA_R( input_charge )
    integer, intent(in) :: input_charge

    integer ngrid, iloop
    integer ispin
    Real(kind=DP), allocatable :: afft_mpi1(:)

    call set_ispin_kt(ispin, input_Charge )
    if (ipri >= 2) write(nfout,*) ' ! ispin = ', ispin
    call xc_allocate( ispin,nfout )
    Call Calc_Density_in_Rspace( ispin, input_Charge )
    call Calc_Kernels_ALDA_Rspace( ispin )
    call xc_deallocate
  end subroutine set_XC_Kernel_ALDA_R

end module m_LinearResponse_Kernel

!================================================
!  Software name : STM
!  Subroutine(s) : rd_WFs_doFFT_and_solve_eq, alloc_afft_etc, dealloc_afft_etc,
!                  print_ck_etc,print_VLC_Rspace, sumup_afft_to, print_dz_etc,
!                  print_summative_charges
!  Author(s)     : Koichi Kato and Takahiro Yamasaki (June 7, 2004)
!
!  FURTHER MODIFICATION: Junichiro  Koga (June 24, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

subroutine rd_WFs_doFFT_and_solve_eq
! $Id: rd_WFs_doFFT_and_solve_eq.F90,v 1.1.1.1 2004/06/26 11:21:37 yamasaki Exp $
  use m_Const_Parameters,     only : DP, BUCS, CARTS &
       &                           , HIGHER, LOWER, IN_BETWEEN, INVERSE, DIRECT &
       &                           , Hartree, NEGATIVE
  use m_Control_Parameters,   only : e1, e2, izi, izf,rini,rfin,nfin,erlmt &
       &                           , n_fc,n_fc_i
  use m_Charge_File,          only : natm2,natm,x_origin,y_origin,z_origin &
       &                           , fft_param,cell1,cell2,cell3 &
       &                           , iatomtype,ival,atom_pos
  use m_Kpoints, only :              kv3, nspin, kweight
  use m_Electronic_Structure, only : neordr,eko,efermi &
       &                           , m_ES_rd_WFs, m_ES_rd_VLCs &
       &                           , m_ES_WF_in_Rspace_fine_mesh &
       &                           , m_ES_VLC_in_Rspace_fine_mesh
  use m_FFT,                  only : nfft, nfftp, nfftpf, nlpf, fft_box_size_fine &
       &                           , m_FFT_WF_2dFFT_fine, m_FFT_Vlocal_W_fine
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Crystal_Structure,    only : neg, zl
  use m_Files,                only : nfzaj, nfinp, nfout, nfchgu, nfchgd, nfvlc, nfchgu_p &
       &                           , nfchgd_p, nfvlcr
  use m_Kpoints,              only : vkxyz
  use m_PlaneWaveBasisSet,    only : m_pwBS_kinetic_energies
  use m_ArraySize_Parameters, only : kspin, kimg

  implicit none
  integer :: i, kg2d, nls, it, ig, nlfid, n,n0, nmp, nnp
  real(kind=DP) :: ertmp, ermx, rmix, dz, ck, rdz, dz2, errsum
  real(kind=DP), allocatable, dimension(:,:,:,:) :: sfft, tfft
  real(kind=DP), allocatable, dimension(:,:,:) :: c, y
  real(kind=DP), allocatable, dimension(:,:)   :: am, w
  real(kind=DP), allocatable, dimension(:) :: ekin
  real(kind=DP), allocatable, dimension(:) :: bfft, cfft
  real(kind=DP), allocatable, dimension(:) :: ertmp_t, domin
  real(kind=DP), allocatable, dimension(:)  :: afft
  integer                                   :: id_sname = -1
  integer                                   :: ik, is, ib, ibto, ikp

  nmp = fft_box_size_fine(2)
  nnp = fft_box_size_fine(3)

  dz = zl / (nlpf*(3-kimg))   ! unit length along z axis
  dz2 = dz*dz
  !rdz = 1./dz2            !  = ar(i), al(i), i=1,nls
  rdz = 0.5d0/dz2            !  = ar(i), al(i), i=1,nls
!!$  nls = nlpf - izi + 2    ! mesh number for WF tail
  nls = izf - izi + 2    ! mesh number for WF tail
  nlfid = fft_box_size_fine(0)
  kg2d = nmp * nnp        ! 2D Gpoints
  e1 = e1 / Hartree       !eV -> Hartree unit
  e2 = e2 / Hartree       !eV -> Hartree unit

  call alloc_afft_etc  !-(contained here)
  call print_dz_etc       ! -(contained here)
!
  call m_ES_rd_VLCs(nfvlc)               !-(m_E.S.)
  sfft = 0.d0 ; tfft = 0.d0
  Kpoints: do ik = 1, kv3-nspin+1, nspin

     do is = 1, nspin
        print '(" spin = ", i3)', is

        call m_ES_VLC_in_Rspace_fine_mesh(is,bfft) !-(m_E.S.) \Vlc(G) -> \Vlc(r)
        call print_VLC_Rspace(is)             !-(contained here)
     
!!$        cycle
!        ikp = is + kspin*(ik-1)
        ikp = ik+(is-1)
        print '(" ik = ", i3, " ikp = ",i3)', ik, ikp
        call m_pwBS_kinetic_energies(ikp,vkxyz,ekin,nmp,nnp) !-(m_P.W.B.S)
        call m_ES_rd_WFs(nfzaj)
        write(6, *) 'efermi',efermi
        do ib = 1, neg
           ibto = neordr(ib,ikp)
           print '(" ** ib, ibto = ",2i6)',ib, ibto
           if(eko(ibto,ikp) > efermi + e2 ) exit
           if(eko(ibto,ikp) < efermi + e1 ) cycle

           ck = vkxyz(ikp,n_fc(2),CARTS)**2+vkxyz(ikp,n_fc(3),CARTS)**2 &
!!$           ck = vkxyz(ikp,n_fc(2),BUCS)**2+vkxyz(ikp,n_fc(3),BUCS)**2 &
                & - eko(ibto,ikp)
           if(ck > 0.) then
              ck = sqrt(ck)
           else
              ck = NEGATIVE
           end if
           call print_ck_etc
!!$#ifdef _DEBUG_WRITE_
!!$           call print_ck_etc
!!$#endif

           call m_ES_WF_in_Rspace_fine_mesh(ikp,ibto,afft)  !-(m_E.S.) \Psi(G) -> \Psi(r)
           call sumup_afft_to(tfft(:,:,:,is), ikp)

#ifdef _DEBUG_WRITE_
           print '(" m_ES_WF_in_Rspace_fine_mesh, ib = ",i3)',ib
           print *,'Wave Functions afft(first row in R-space)'
           do i = 1, fft_box_size_fine(1)/2 + 1
              n = 2*i - 1
              write(nfout,9001) afft(n), afft(n+1)
           end do
#endif
!
! convolution of local potential and WF start
!
           it = 1
1000       continue

           call m_FFT_Vlocal_W_fine (afft,bfft,cfft) !-(m_FFT)  cfft<-VLC(r)*Psi(r)
           call m_FFT_WF_2dFFT_fine(cfft,DIRECT)     !-(m_FFT) \Vlc*WF(r) -> \Vlc*WF(G(2D)&r(1D))

           call m_FFT_WF_2dFFT_fine(afft,DIRECT)     !-(m_FFT) \WF(r) -> \WF(G(2D)&r(1D))

!!$#ifdef _DEBUG_WRITE_
           if( it .lt. 3 ) then
              write(nfout,*) 'Convolution of WF & Potentials FFT-Backward cfft(first row)'
              print *,'no1 ekin =',ekin(1)
              do i = izi, nlpf
                 n = 2*i - 1
                 write(nfout,'(2d20.8)') cfft(n), cfft(n+1)
              end do
           end if
!!$#endif

           call tstatc0_begin('rd_WFs_doFFT_and_solve_eq_core ',id_sname)
!    print *,'finished \WF(r) -> \WF(G(2D)&r(1D))'
!
! diagonalization for tail WF start
!
           rmix = what_rmix(rini,rfin,nfin,it)

           am = 0. ; c = 0.; y = 0.; w = 0.

           do i = 2, nls
!!$              ar(i) = 1.0/dz**2 ;  al(i) = 1.0/dz**2
              do ig = 1, kg2d
                 n  = 1 + 2 * (izi+i-1-1) + kimg*nlfid*(ig-1)
                 !                     nlfid = fft_box_size_fine(0)
!                 am(ig,i) = eko(ibto, ikp) - ekin(ig) - 2./dz**2 
                 am(ig,i) = eko(ibto, ikp) - ekin(ig) - 1./dz**2 
                 c(ig,i,1) = cfft(n)
                 c(ig,i,2) = cfft(n+1)
              end do
           end do

           do ig = 1, kg2d
              n  = 1 + 2*(izi+2-1-1) + kimg*nlfid*(ig-1)
              n0 = 1 + 2*(izi+1-1-1) + kimg*nlfid*(ig-1)
              c(ig,2, 1) = cfft(n)   - afft(n0)*rdz
              c(ig,2, 2) = cfft(n+1) - afft(n0+1)*rdz
              c(ig,nls, 1) = 0.d0
              c(ig,nls, 2) = 0.d0
           end do

!!$           if(ck > 0) then
!!$              do ig = 1, kg2d
!!$                 am(ig,nls) = (dz*ck + 2.)/((dz*ck - 2.)*dz**2)
!!$              end do
!!$           end if

              ! -- forward substitution -->
           do ig = 1, kg2d
!!$              l(ig,2) = ar(2) / am(ig,2) 
              w(ig,2) = rdz / (am(ig,2))
              y(ig,2,1) = c(ig,2,1)/am(ig,2)
              y(ig,2,2) = c(ig,2,2)/am(ig,2)
           end do

           do i = 3, nls - 1
              do ig = 1, kg2d
                 w(ig,i) = rdz /  (am(ig,i) - rdz * w(ig,i-1))
                 y(ig,i,1) = (c(ig,i,1) - rdz*y(ig,i-1,1))*w(ig,i)/rdz
                 y(ig,i,2) = (c(ig,i,2) - rdz*y(ig,i-1,2))*w(ig,i)/rdz
              end do
           end do

           do ig = 1, kg2d
              y(ig,nls,1) = (c(ig,nls,1)-rdz*y(ig,nls-1,1)) &
                   &        /(am(ig,nls) - rdz*w(ig,nls-1))
              y(ig,nls,2) = (c(ig,nls,2)-rdz*y(ig,nls-1,2)) &
                   &        /(am(ig,nls) - rdz*w(ig,nls-1))
              ! <--

              ! -- backward substitution -->
!!$              c(ig,nls, 1) = y(ig,nls,1)/(d(ig,nls)**2)
!!$              c(ig,nls, 2) = y(ig,nls,2)/(d(ig,nls)**2)
              c(ig,nls, 1) = y(ig,nls,1)
              c(ig,nls, 2) = y(ig,nls,2)
           end do

           do i = nls-1, 2, -1
              do ig = 1, kg2d
                 c(ig,i,1) = y(ig,i,1) - w(ig,i) * c(ig,i+1,1)
                 c(ig,i,2) = y(ig,i,2) - w(ig,i) * c(ig,i+1,2)
              end do
           end do
              ! <--

           if(it.eq.1) then
              print '( " c (1:nls) (R|I)")'
              do i = 1, nls
                 print '(2d12.4)', c(1,i,1),c(1,i,2)
              end do
           end if

           ermx = 0.
           errsum = 0.
           do ig = 1, kg2d
             do i = 2, nls
                n = 1 + 2*(izi+i-1-1) + kimg*nlfid*(ig-1)
                if(sqrt(afft(n)**2 + afft(n+1)**2) > 1.e-8) then
!!$                if(sqrt(afft(n)**2 + afft(n+1)**2) < 1.e-8) cycle
                   ertmp =  ((c(ig,i,1)-afft(n))**2 &
                        &  + (c(ig,i,2)-afft(n+1))**2) &
                        &   / (afft(n)**2 + afft(n+1)**2)
                   errsum = errsum + ertmp
                   if ( ertmp > ermx) ermx = ertmp
                   afft(n)   = (1-rmix)*afft(n)   + rmix*c(ig,i,1)
                   afft(n+1) = (1-rmix)*afft(n+1) + rmix*c(ig,i,2)
                end if
              end do
           end do
           ermx = dsqrt(ermx)

           print '(" ( ",i4," ) rmix = ",f6.2," ||d WF|| (errsum) = " &
                & ,d12.4,"  (",d12.4,")")' ,it, rmix, ermx,errsum
           it = it + 1

!       if( ermx .le. erlmt ) then
!         write(nfout,*) 'Wave Functions afft(1st row in 2g-space) recalculated'
!         print *,'no1 ekin =',ekin(1)
!         write(nfout,*) (afft(i), i=1,nlpfd+2)
!       end if

           call tstatc0_end(id_sname)

           call m_FFT_WF_2dFFT_fine(afft,INVERSE)  !-(m_FFT)  \WF(G(2D)&r(1D)) -> \WF(r)

           if(it > 10*nfin) stop ' !! it > 10*nfin, but no-conversion'
           if(ermx > erlmt ) go to 1000

           print '(" *** Wave Function Converged!! ***,  it = ",i6)',it

#ifdef _DEBUG_WRITE_
           write(nfout,*) 'Wave Functions afft(first row in R-space) recalculated'
           write(nfout,*) (afft(i), i=1,2*(izf+1))
           write(nfout,*) 'Electron Densities afft(first row) recalculated'
           write(nfout,*) (afft(2*i-1)**2 + afft(2*i)**2, i=1, izf + 1)
#endif

           call sumup_afft_to(sfft(:,:,:,is), ikp)
        end do
     end do
  end do Kpoints
  do is=1,nspin
     call print_summative_charges(nfchgu,nfchgd,sfft(:,:,:,is),e1,e2)
     call print_summative_charges(nfchgu_p,nfchgd_p,tfft(:,:,:,is),e1,e2)
  enddo
  call dealloc_afft_etc
contains
!!$  subroutine solve_txdsml_equation(ibto,ikp,kg2d,ck)
!!$    integer,       intent(in) :: ibto, ikp, kg2d
!!$    real(kind=DP), intent(in) :: ck
!!$
!!$    integer :: i, ig
!!$
!!$    do ig = 1, kg2d
!!$       w(ig, 2) = ar(2) / am(ig, 2) 
!!$       g(ig,2,1) = c(ig,2,1)/am(ig,2)
!!$       g(ig,2,2) = c(ig,2,2)/am(ig,2)
!!$    end do
!!$
!!$    do i = 3, nls - 1
!!$       do ig = 1, kg2d
!!$          w(ig,i) = ar(i) / (am(ig,i) - al(i) * w(ig,i-1))
!!$          g(ig,i,1) = (c(ig,i,1) - al(i)*g(ig,i-1,1))*w(ig,i)/ar(i)
!!$          g(ig,i,2) = (c(ig,i,2) - al(i)*g(ig,i-1,2))*w(ig,i)/ar(i)
!!$       end do
!!$    end do
!!$    do ig = 1, kg2d
!!$       g(ig,nls,1) = (c(ig,nls,1) - al(nls)*g(ig,nls-1,1)) &
!!$            & /(am(ig,nls) - al(nls)*w(ig,nls-1))
!!$       g(ig,nls,2) = (c(ig,nls,2) - al(nls)*g(ig,nls-1,2)) &
!!$            & /(am(ig,nls) - al(nls)*w(ig,nls-1))
!!$
!!$       c(ig,nls,1) = g(ig,nls,1)
!!$       c(ig,nls,2) = g(ig,nls,2)
!!$    end do
!!$    do i = nls-1, 2, -1
!!$       do ig = 1, kg2d
!!$          c(ig,i,1) = g(ig,i,1) - w(ig,i) * c(ig,i+1,1)
!!$          c(ig,i,2) = g(ig,i,2) - w(ig,i) * c(ig,i+1,2)
!!$       end do
!!$    end do
!!$
!!$  end subroutine solve_txdsml_equation

  subroutine alloc_afft_etc
    allocate(afft(nfftpf))
    allocate(bfft(nfftpf))
    allocate(cfft(nfftpf))
    allocate(sfft(nmp,nnp,nlpf+1,nspin))
    allocate(tfft(nmp,nnp,nlpf+1,nspin))
    allocate(c(nmp*nnp+1,nls, 2))
    allocate(y(nmp*nnp+1,nls, 2))
!!$    allocate(c(izf+2, 2))
!!$    allocate(g(izf+2, 2))
    allocate(ekin(nmp*nnp+1))
!!$    allocate(al(nls))
    allocate(am(nmp*nnp+1, nls))
    allocate(w(nmp*nnp+1,nls))
!!$    allocate(ar(nls))
!!$    allocate(l(nmp*nnp+1, nls))
    allocate(ertmp_t(nmp*nnp))
    allocate(domin(nmp*nnp))
  end subroutine alloc_afft_etc

  subroutine dealloc_afft_etc
    deallocate(afft)
    deallocate(bfft)
    deallocate(cfft)
    deallocate(sfft)
    deallocate(tfft)
    deallocate(c)
    deallocate(y)
    deallocate(ekin)
!!$    deallocate(al)
    deallocate(am)
    deallocate(w)
!!$    deallocate(ar)
!!$    deallocate(l)
    deallocate(ertmp_t)
    deallocate(domin)
  end subroutine dealloc_afft_etc
    
  subroutine print_ck_etc
    print *,'ck =', ck
    print '(" ib = ",i3," ibto = ", i3)', ib, ibto
    print '(" eko(ibto,is + kspin*(ik-1)) = ",f10.6)',eko(ibto,ikp)
  end subroutine print_ck_etc
    
  subroutine print_VLC_Rspace(is)
    integer, intent(in) :: is
    integer :: i, n, idp,nlp,nmp,nnp,nlphf, j,k, ip(4),knew,inew,jnew,nlph, ixh,iyh,ipx(4),ipy(4)
    real(kind=DP), allocatable, dimension(:,:,:) :: wk

    print *,'finished m_ES_VLC_in_Rspace_fine_mesh'
    ixh = fft_box_size_fine(2)/2
    iyh = fft_box_size_fine(3)/2
    ipx(1) = 0;     ipy(1) = 0
    ipx(2) = ixh-1; ipy(2) = 0
    ipx(3) = 0;     ipy(3) = iyh-1
    ipx(4) = ixh-1; ipy(4) = iyh-1

    write(nfout,'(" kimg = ",i6," fft_box_size_fine(1) = ",i8)') kimg, fft_box_size_fine(1)
!!$    write(nfout,*) 'Local Potentials (first row in R-space)'
    write(nfout,*) 'Local Potentials ( 4 rows in R-space)'
    write(nfout,*) ' first coloumn:  ',ipx(1),ipy(1)
    write(nfout,*) ' second coloumn: ',ipx(2),ipy(2)
    write(nfout,*) ' third coloumn:  ',ipx(3),ipy(3)
    write(nfout,*) ' fourth coloumn: ',ipx(4),ipy(4)

!!$    do it = 1, 2
!!$       if(it == 1) then
!!$       else if(it == 2) then
!!$          write(nfout,*) 'Local Potentials (second row in R-space)'
!!$       end if
!!$    end do

    idp = fft_box_size_fine(0)
    nlp = fft_box_size_fine(1); nmp = fft_box_size_fine(2); nnp = fft_box_size_fine(3)
    if(kimg.eq.1) then
       nlphf = idp/2
    else
       nlphf = idp
    end if
    
    do i = 1, 4
       ip(i) = (nlphf*nmp*ipy(i) + nlphf*ipx(i))*2
    end do
    if(kimg.eq.2) then
!!$       if(it == 2) ip = fft_box_size_fine(0)*2
       do i = 1, fft_box_size_fine(1)
          n = 2*i-1
!!$          write(nfout,'(i8,2d20.8)') i,bfft(ip+n),bfft(ip+n+1)
          write(nfout,'(i8,4d15.7)') i,bfft(ip(1)+n),bfft(ip(2)+n),bfft(ip(3)+n),bfft(ip(4)+n)
       end do
    else if(kimg.eq.1) then
!!$       if(it == 2) ip = fft_box_size_fine(0)
       do i = 1, fft_box_size_fine(1)/2
!!$          write(nfout,'(i8,2d20.8)') i,bfft(ip+2*i-1),bfft(ip+2*i)
          write(nfout,'(i8,4d15.7)') i,bfft(ip(1)+i),bfft(ip(2)+i),bfft(ip(3)+i),bfft(ip(4)+i)
       end do
    end if

    write(nfvlcr,*) ' spin = ', is
    allocate(wk(nlp,nmp,nnp))
    nlph = nlp
    if(kimg.eq.1) nlph = nlp/2
    do i = 1, nmp
       do j = 1, nnp
          do k = 1, nlp
             if(kimg.eq.1.and.k.gt.nlphf) then
                knew = idp -k
                jnew = nnp+2 -j
                inew = nmp+2 -i
                if(jnew.gt.nnp) then
                   jnew = jnew - nnp
                end if
                if(inew.gt.nmp) then
                   inew = inew - nmp
                end if
             else
                knew = k
                jnew = j
                inew = i
             end if
             ip(1) = nlphf*nmp*(jnew-1) + nlphf*(inew-1) + knew
             wk(k,i,j) = bfft(ip(1)*2-1)
          end do
       end do
    end do
    write(nfout,*) ' !D FFT cube mapping finished'
    write(nfvlcr,9001) nlp*nmp*nnp,nlp,nmp,nnp
    write(nfvlcr,9002) wk
 9001 format(' CHARGE DENSITY NE = ',i8,'(',3i5,')')
 9002 format(6e12.4)
  end subroutine print_VLC_Rspace

  subroutine sumup_afft_to(xfft, ik)
!    real(kind=DP), intent(out), dimension(nmp,nnp,nlpf+1) :: xfft
    real(kind=DP), intent(inout), dimension(nmp,nnp,nlpf+1) :: xfft
    integer, intent(in) :: ik
    integer :: k, j, i, n
    do k = 1, nlpf
       do j = 1, nnp
          do i = 1, nmp
             n = 1 + 2*(k-1) + kimg*nlfid*((i-1) + nmp*(j-1))
             xfft(i,j,k) = xfft(i,j,k) + kweight(ik)*(afft(n)**2 + afft(n+1)**2)
          end do
       end do
    end do

!!$    do k = 1, nnp
!!$       do j = 1, nmp
!!$          do i = 1, nlpf + 1
!!$             n = 1 + 2*(i-1) + kimg*nlfid*((j-1) + nmp*(k-1))
!!$             sfft(i, j, k) = sfft(i, j, k) + afft(n)**2 + afft(n+1)**2
!!$          end do
!!$       end do
!!$    end do
  end subroutine sumup_afft_to

  real(kind=DP) function what_rmix(rini,rfin,nfin,it)
    real(kind=DP), intent(in) :: rini,rfin
    integer, intent(in)       :: nfin,it
    if( it <= nfin ) then
       what_rmix = rini + (rfin - rini) * (it-1)/nfin
    else
       what_rmix = rfin
    end if
!!$    print '(" Iteration Loop No, rmix = ",i8,f10.4)', it, rmix
!!$    write(nfout,*) 'Iteration Loop No, rmix = ', it, rmix
  end function what_rmix

  subroutine print_dz_etc
    print '(" -- dz -- ", f10.6)', dz
    print '(" -- nls, nlpf, izi, izf -- ", 4i6)', nls,nlpf,izi,izf
    print '(" -- rini, rfin, nfin -- ",2f10.6,i5)',rini,rfin,nfin
    print '(" -- erlmt -- ",f10.6)',erlmt
    print '(" unit length along z axis = ",f10.6)',dz
    print '(" Bias Voltage (V) = ", f10.6)', e1
  end subroutine print_dz_etc
    
  subroutine print_summative_charges(nfchgu,nfchgd,xfft,e1,e2)
    integer, intent(in) :: nfchgu, nfchgd
    integer :: i,j,k,scale
    integer, dimension(3) :: index_tmp
    real(kind=DP), intent(in) :: xfft(nmp,nnp,nlpf+1),e1,e2
    real(kind=DP), allocatable, dimension(:,:,:) :: xfft_wk
    integer :: nfchg
!
! Print out charges sumed at all k points
!
    if ( is .eq. 1) then
       nfchg = nfchgu
       print *,' -- nfchgu --'
    else if( is .eq. 2) then
       nfchg = nfchgd
       print *,' -- nfchgd --'
    end if


!      write(nfchg,9001) nlpf*nmp*nnp,nmp,nnp,nlpf, e1*Hartree, e2*Hartree
!      write(nfchg,501) xfft
!!$    do k = 1, nnp
!!$       do j = 1, nmp
!!$          do i = 1, nlpf + 1
!!$             write(nfchr,500) i, j, k, sfft(i,j,k)
!!$          end do
!!$       end do
!!$    end do

      write(nfchg,9001) nlpf*nmp*nnp,nmp,nnp,nlpf, e1*Hartree, e2*Hartree
      if ( is .eq. 1) then
         write(nfchg,*) ' -- nfchgu --'
      else if( is .eq. 2) then
         write(nfchg,*) ' -- nfchgd --'
      end if

      if ( kimg .eq. 1 ) then
        scale = 2
      else
        scale = 1
      endif

      write(nfchg,'(i6,3f12.6)') natm, x_origin,y_origin,z_origin

      index_tmp(n_fc(1)) = nlpf
      index_tmp(n_fc(2)) = nmp
      index_tmp(n_fc(3)) = nnp

      write(nfchg,'(i6,3f12.6)') index_tmp(1),cell1(1:3)
      write(nfchg,'(i6,3f12.6)') index_tmp(2),cell2(1:3)
      write(nfchg,'(i6,3f12.6)') index_tmp(3),cell3(1:3)

      do i=1,natm
        write(nfchg,'(i6,4f12.6)') iatomtype(i),ival(i),atom_pos(i,1:3)
      enddo
        
      allocate(xfft_wk(index_tmp(3),index_tmp(2),index_tmp(1)))

      do j=1,nnp
        do k=1,nmp
          do i=1,nlpf
            index_tmp(n_fc_i(1)) = j
	    index_tmp(n_fc_i(2)) = k
	    index_tmp(n_fc_i(3)) = i
	    xfft_wk(index_tmp(1),index_tmp(2),index_tmp(3)) = xfft(k,j,i)
	  enddo
	enddo
      enddo

      write(nfchg,501) xfft_wk
      deallocate(xfft_wk)
     
    print *,'finished write nfchg'

 9001 format(' CHARGE DENSITY NE = ',i8,'(',3i5,' )  Energy-Range ',f8.4,' : ',f8.4,' (eV)')
500   format(3I4,1pe12.4)
501   format(6e16.8)

  end subroutine print_summative_charges

end subroutine rd_WFs_doFFT_and_solve_eq

!PHASEから読み込んだ平面波波動関数とk群の射影演算子との計算を行うモジュール
!Copyright (C) 2014-2015 Ryosuke Tomita

module m_reduce_band
!$ use omp_lib
!読み込んだデータ及びTSPACEから得られる情報から、波動関数を簡約する
#include "defines.F"
#ifdef NUM_G_DEBUG
#define G_DEBUG ig<NUM_G_DEBUG
#else
#define G_DEBUG .true.
#endif

  use m_commons, only: pi2, stdout, zi
  use m_tspace_defines, only: irrep, character_table
  use m_container_commons, only: k_state, psicoef_t, transd_vector_index
!---------------------Modified by T.A.Ariasoca-----------------------------
!import ndim_spinor from container_psicoef module
  use m_container_psicoef, only: ndim_spinor
!--------------------------------------------------------------------------
  use m_character_table, only: get_trace
  use m_transd_vector, only: find_gvector
  implicit none

!kベクトルの実数表現
  DOUBLE_T, dimension(nxyz_), private:: kv
!現在のk点バンドの可約表現(redrep(縮退エネルギー準位,スピンインデックス))
  type(irrep), allocatable, target, private:: redrep(:,:)
  logical, private:: is_special_k

  type(k_state), pointer, private:: ks
  type(psicoef_t), pointer, private:: ps
  type(transd_vector_index), pointer, private:: tvi
  type(character_table), pointer, private:: chtable
contains
!特定のエネルギー準位、対称操作における可約表現の行列成分をもとめる(<psi^k_ie1,is1|R|psi^k_ie2,is2>)
  function get_reducible_rep(ie1, ie2, is1, is2, iopr)&
       result(sbuf)
    integer, intent(in):: ie1, ie2, is1, is2, iopr

    integer:: ig, new_ig
    integer, dimension(nxyz_):: new_ig_vec, Rk !RG - g
        COMPLEX_T:: cc, sbuf
    DOUBLE_T:: ktr
#define IS_OUTER_BOUNDS(ig) (ig < 1 .or. ig > ps%gv%num)

    sbuf = 0d0
    Rk = 0
    if(is_special_k) then
       new_ig = tvi%kv(iopr)
!領域外処理
       if(.not.IS_OUTER_BOUNDS(new_ig)) then
          Rk = ps%gv%comp(:, new_ig)
       else
          return
       end if
    end if
    ktr = dot_product(- Rk, ks%kgroup%op(iopr)%tr)
#ifdef DEBUG
    write(stdout, *) '#make_psi_op_psi#kp',ks%kpoint%name,'ie1 ', ie1, 'ie2 ', ie2, 'opr ', ks%kgroup%op(iopr)%name, 'iopr', iopr
    write(stdout, *) 'kv ', kv, 'RK ', Rk
    write(stdout, *) 'tr ', ks%kgroup%op(iopr)%tr
#endif

!$omp parallel
!$omp do private(new_ig, new_ig_vec, cc), reduction(+:sbuf)
!全g点に関する処理
    do ig = 1, ps%gv%num
!対称操作により変化したg点のインデックスをコピー
       new_ig = tvi%gv(ig, iopr)
!領域外処理
       if(IS_OUTER_BOUNDS(new_ig)) cycle

#ifdef DEBUG
       if(G_DEBUG) then
          write(stdout, *) 'Transd_gv_index', ig, ps%gv%comp(:, ig)
          write(stdout, *) 'Transd_gv_index', new_ig, ps%gv%comp(:, new_ig)
          write(stdout, *)
       end if
#endif
       new_ig_vec = ps%gv%comp(:, new_ig)! RG

!k点が非共型であり、BZ境界のk点のとき
       if(is_special_k) then
          new_ig = find_gvector(new_ig_vec - Rk, ps%gv)
!領域外処理
          if(IS_OUTER_BOUNDS(new_ig)) cycle
       end if

!並進操作からなる位相cc(k点がBZ境界にあるとき、1でない値を持つ、k点がBZ内部にあるときは常に１)
       cc = CEXP_(-pi2 * (ktr + dot_product(new_ig_vec, ks%kgroup%op(iopr)%tr))*zi)

#define RIGHT ps%comp(ig, ie2, is2)
#define LEFT ps%comp(new_ig, ie1, is1)

#ifdef DEBUG
       if(G_DEBUG) then
          write(stdout, *) 'psi(', ig, ')= ', RIGHT
          write(stdout, *) 'psi(', new_ig, ')= ', LEFT
          write(stdout, *) 'k-g+RG ', kv + new_ig_vec, 'tr ', ks%kgroup%op(iopr)%tr
          write(stdout, *) 'cc ', cc, sbuf
          write(stdout, *)
       endif
#endif
       sbuf = sbuf + cc*conjg(LEFT)*RIGHT
    enddo
#undef RIGHT
#undef LEFT
!$omp end do
!$omp end parallel
#ifdef DEBUG
    write(stdout, *) '<psi|op|psi>= ', sbuf
    write(stdout, *)
#endif
#undef IS_OUTER_BOUNDS
  end function get_reducible_rep

!---------------------Modified by T.A.Ariasoca----------------------------------------
!Subroutine to calculate double group irreducible representation, modified version of get_reducible_rep subroutine
  function get_reducible_rep_noncol(ie1, ie2, is1, iopr)&
       result(sbuf)
    integer, intent(in):: ie1, ie2, is1, iopr

    integer:: ig, new_ig
    integer, dimension(nxyz_):: new_ig_vec, Rk !RG - g
        COMPLEX_T:: cc, sbuf, dg1, dg2
    DOUBLE_T:: ktr
#define IS_OUTER_BOUNDS(ig) (ig < 1 .or. ig > ps%gv%num)

    sbuf = 0d0
    Rk = 0
    if(is_special_k) then
       new_ig = tvi%kv(iopr)
!if special kpoint
       if(.not.IS_OUTER_BOUNDS(new_ig)) then
          Rk = ps%gv%comp(:, new_ig)
       else
          return
       end if
    end if
    ktr = dot_product(- Rk, ks%kgroup%op(iopr)%tr)

!$omp parallel
!$omp do private(new_ig, new_ig_vec, cc), reduction(+:sbuf)
    do ig = 1, ps%gv%num
       new_ig = tvi%gv(ig, iopr)

       if(IS_OUTER_BOUNDS(new_ig)) cycle

       new_ig_vec = ps%gv%comp(:, new_ig)! RG

       if(is_special_k) then
          new_ig = find_gvector(new_ig_vec - Rk, ps%gv)

          if(IS_OUTER_BOUNDS(new_ig)) cycle
       end if

!cc is the translation vector part exp(-i(c_i*G_n)\dot\tau_i)
       cc = CEXP_(-pi2 * (ktr + dot_product(new_ig_vec, ks%kgroup%op(iopr)%tr))*zi)

!dg1 and dg2 correspond to spin rotation
       dg1 = (ks%kgroup%op(iopr)%spinrot(1,1)*ps%comp(ig, ie2, is1))+(ks%kgroup%op(iopr)%spinrot(1,2)*ps%comp(ig, ie2, is1+1))
       dg2 = (ks%kgroup%op(iopr)%spinrot(2,1)*ps%comp(ig, ie2, is1))+(ks%kgroup%op(iopr)%spinrot(2,2)*ps%comp(ig, ie2, is1+1))

!sbuf is the modified version of <psi|op|psi> with double group operation
!bag fixed M.saito
!       sbuf = sbuf + cc*((conjg(ps%comp(new_ig, ie1, is1))*dg1)+(conjg(ps%comp(new_ig, ie1, is1+1)*dg2)))
        sbuf = sbuf + cc*( conjg(ps%comp(new_ig, ie1, is1))*dg1 +conjg(ps%comp(new_ig, ie1, is1+1))*dg2)
    enddo
!$omp end do
!$omp end parallel
#ifdef DEBUG
    write(stdout, *) '<psi|op|psi>= ', sbuf
    write(stdout, *)
#endif
#undef IS_OUTER_BOUNDS
  end function get_reducible_rep_noncol
!---------------------------------------------------------------------------------------------


!get_reducible_repで計算した可約表現の指標から、指定した既約表現imrの係数を求める1/h sum_R x_(R)<psi|R|psi>
  COMPLEX_T function irreducible_coefficient(ideg, is, imr)&
       result(coef)
!エネルギー準位、既約表現インデックス、スピンインデックス
    integer, intent(in):: ideg, imr, is
    integer:: ic
    coef = 0d0

#define CLASS ks%kgroup%cls(ic)
#define COEF(imr) imr%comp(ic)
    do ic = 1, chtable%nclass!ks%kgroup%nclass
       coef = coef + CLASS%order *&
            conjg(COEF(chtable%imrs(imr))) *&
            COEF(redrep(ideg,is))
    end do
    coef = coef / CMPLX_(ks%kgroup%order, 0d0)
#undef CLASS
#undef IRREP
  end function irreducible_coefficient

#define I_ENERGY(id) ps%e_tag(ps%deg(ideg,is)%ie(id),is)
!バンドの可約表現の出力
  subroutine print_reduce_band(nfout,is)
    integer, intent(in):: nfout, is
    integer:: ideg, imr
    do ideg = 1, ps%num_deg_point(is)
       write(nfout, fmt = '(A)', advance = 'no') '!'
!エネルギーのインデックス、縮退点のエネルギー、縮退度
       write(nfout, '(I0,1X,f16.8,1X,I0)') I_ENERGY(1)%ie, I_ENERGY(1)%hartree, ps%deg(ideg,is)%ne
!可約表現の指標及び行列表現の出力
       !call print_cr_wd(ideg, is, nfout)
!可約表現に含まれる、既約表現の係数の出力
       do imr = 1, chtable%numimr
          write(nfout, fmt = '(A,1X)', advance = 'no') trim(chtable%imrs(imr)%name)//'('//trim(chtable%imrs(imr)%name_mulliken)//')'
          write(nfout, 400) irreducible_coefficient(ideg, is, imr), chtable%imrs(imr)%dim
       end do
       write(nfout, *)
    end do
400 format('(',f0.8,',',f0.8,')',1X,I0)
  end subroutine print_reduce_band

  subroutine new_reduce_band(cht, kst, pst, tvit)
    type(k_state), target, intent(in):: kst
    type(psicoef_t), target, intent(in):: pst
    type(character_table), target, intent(in):: cht
    type(transd_vector_index), target, intent(in):: tvit
    integer:: ideg, ic, iopr_ind, is
!k点、波動関数、指標表、kベクトル変化の情報を受け取る(ポインタによるシャローコピー)
    ks => kst
    ps => pst
    chtable => cht
    tvi => tvit
    is_special_k = (ks%kpoint%comm2bz > 1)
    kv(1:3) = dble(ks%kpoint%comp(1:3))/ks%kpoint%common_denom
    if(.not.AllocateAll()) return

!--------------------Modified by T.A.Ariasoca---------------------------------
!Used to get double group irreducible representation, by not looping through nspin
    if(ndim_spinor == 2) then
        is = 1
       do ideg = 1, ps%num_deg_point(is)
          do ic = 1, ks%kgroup%nclass
             call set_cr(ideg, is, ic)
          end do
       end do
    else
!for collinear calculation, loop through all spin
!----------------------------------------------------------------------------
       do is = 1, ps%nspin
!全縮退エネルギー準位におけるループ
          do ideg = 1, ps%num_deg_point(is)
!k点の属する群の全類に関するループ
             do ic = 1, ks%kgroup%nclass
                call set_cr(ideg, is, ic)
             end do
          end do
       end do
    end if

  contains
!指定されたエネルギー準位と対称操作における、可約表現の指標を返し、行列表現を変数に保存する
    subroutine set_cr(ideg, is, ic)
      integer, intent(in):: ideg, ic, is
      integer:: iopr, id, jd!, is, js
      COMPLEX_T:: buf!(2,2)

#define CLS ks%kgroup%cls(ic)
!一つの縮退エネルギー準位に含まれるバンドに対するループ
      redrep(ideg,is)%dim = ps%deg(ideg,is)%ne
      do iopr = 1, CLS%order
         do id = 1, ps%deg(ideg,is)%ne
!同上
            do jd = 1, ps%deg(ideg,is)%ne
!指定された2つのバンドと、対称操作における可約表現の行列表現を返す
!--------------------Modified by T.A.Ariasoca---------------------------------
!Calculate buf for double group representation
               if(ndim_spinor == 2) then
                  buf = get_reducible_rep_noncol(I_ENERGY(id)%ie, I_ENERGY(jd)%ie, is, CLS%ind(iopr))
               else
!-----------------------------------------------------------------------------
                  buf = get_reducible_rep(I_ENERGY(id)%ie, I_ENERGY(jd)%ie, is, is, CLS%ind(iopr))
               end if
               redrep(ideg,is)%wd(id,jd,CLS%ind(iopr)) = buf
            end do
         end do
      end do

      redrep(ideg,is)%comp(ic) = get_trace(&
           redrep(ideg,is)%wd(:,:, CLS%ind(1)), ps%deg(ideg,is)%ne)
#undef CLS
    end subroutine set_cr

    logical function AllocateAll()
      integer:: ndeg
      AllocateAll = .false.
      if(.not.allocated(redrep)) then
         ndeg = 0
         if(ps%num_deg_point(1) > ps%num_deg_point(2)) then
            ndeg = ps%num_deg_point(1)
         else
            ndeg = ps%num_deg_point(2)
         end if
         allocate(redrep(ndeg,ps%nspin))
      end if
      AllocateAll = .true.
    end function AllocateAll
  end subroutine new_reduce_band

  subroutine delete_reduce_band
    if(.not.DeallocateAll()) return
  contains
    logical function DeallocateAll()
      DeallocateAll = .false.
      if(allocated(redrep)) deallocate(redrep)
      DeallocateAll = .true.
    end function DeallocateAll
  end subroutine delete_reduce_band

!指定されたエネルギー準位の可約表現を出力
  subroutine print_cr_wd(ideg, is, nfout)
    integer, intent(in):: ideg, is, nfout
    integer:: ic, iopr_ind, id, jd, dim
!可約表現の次元。バンドの縮退数
    dim = ps%deg(ideg,is)%ne
    write(nfout, *) '##reducible representation ', ks%kpoint%name
!類に関するループ
    do ic = 1, ks%kgroup%nclass
!類の名前及び可約表現の指標の出力
       write(nfout, 401) '##', ks%kgroup%cls(ic)%name, redrep(ideg,is)%comp(ic)
!類に属する対称操作のループ
       do iopr_ind = 1, ks%kgroup%cls(ic)%order
!対称操作の名前の出力
          write(nfout, 403) '#', ks%kgroup%op(ks%kgroup%cls(ic)%ind(iopr_ind))%name
!可約表現の次元のループ
          do id = 1, dim
!同上
             do jd = 1, dim
!表現行列のid,jd成分の出力
                write(nfout, 402) '#', id, jd,&
                     redrep(ideg,is)%wd(id, jd, ks%kgroup%cls(ic)%ind(iopr_ind))
             end do
          end do
       end do
    end do
401 format(2(A,1X),'(',f0.8,',',f0.8,')')
402 format(A,1X,2(I0,1X),'(',f0.8,',',f0.8,')')
403 format(2(A,1X))
  end subroutine print_cr_wd
end module m_reduce_band

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: matrix_inversion, psbhs0, qitgft_diff, qitgft, 
!             read_chgpc_nrc_mord, read_nrc_mord, read_tau_eps_nrc_mord, 
!             read_itau_ivanl, coef_simpson_integration, rmeshs, ggabp,
!             ggacorl_pbe, ggaexch_pbe, ggacorl_pw91, ggaexch_pw91,
!             gga_xc_potential_atomic, get_gradient_of_rho
!
!  AUTHOR(S): T. Yamasaki   June/25/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! $Id: b_PseudoPotential.F90 570 2017-04-21 20:34:50Z yamasaki $
subroutine get_gradient_of_rho(jsm,mddiff,kmesh,mesh,a &
     &, rad,h,fdiff,coeff1,coeff2,rho,grdnts)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE:  get_gradient_of_rho
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)  :: jsm, mddiff, kmesh, mesh
  real(kind=DP),intent(in),dimension(kmesh,jsm)        :: a
  real(kind=DP),intent(in),dimension(kmesh)            :: rad
  real(kind=DP),intent(in)                             :: h
  real(kind=DP),           dimension(kmesh,0:mddiff)   :: fdiff
  real(kind=DP),           dimension(0:mddiff,mddiff)  :: coeff1
  real(kind=DP),           dimension(0:mddiff,2:mddiff):: coeff2
  real(kind=DP),           dimension(kmesh,jsm)      :: rho
  real(kind=DP),intent(out),dimension(kmesh,jsm*3) :: grdnts

  integer, parameter :: execut = 2, modeex = execut &
       &, abslut = 1, normal = 2
  integer :: nddiff, npcntr, nddriv, cpmod, ngp, i

  nddiff = 8
  if(mddiff < nddiff) nddiff = mddiff
  npcntr = (nddiff+1)/2
#ifdef GGA_CHECK
  write(6,'(" -- get_gradient_of_rho -- ")')
#endif
  do i = 1, jsm
     nddriv = 1
     call getroh(a(1,i),kmesh,mesh,rad,rho(1,i))
#ifdef GGA_CHECK
     do j = 1, 10
        write(6,'(" ! ( ",i5,") rho = ",d16.8)') j, rho(j,i)
     end do
#endif
     cpmod = normal
     call cpval(rho(1,i),kmesh,mesh,cpmod,1,fdiff(1,0))
     call gdiffs(h,rad,fdiff,kmesh,mesh,mddiff,nddiff)
     !               output: fdiff
     ngp = 1 + (i-1)*3
     call gtgrad(h,rad,fdiff(1,1),kmesh,mesh,nddiff,nddriv &
          &       ,npcntr,coeff1 ,mddiff,grdnts(1,ngp),modeex)
     !               output: grdnts(*,1or4) = \nabla \rho
     !                                      = \partial \rho/\partial \r
     nddriv = 2
     call gtgrad(h,rad,fdiff(1,1),kmesh,mesh,nddiff,nddriv &
          &       ,npcntr,coeff2,mddiff,grdnts(1,ngp+1),modeex)
     !               output: grdnts(*,2or5) = \nabla^2 \rho
     cpmod = abslut
     call cpval(grdnts(1,ngp),kmesh,mesh,cpmod,1,fdiff(1,0))
     call gdiffs(h,rad,fdiff,kmesh,mesh,mddiff,nddiff)
     nddriv = 1
     call gtgrad(h,rad,fdiff(1,1),kmesh,mesh,nddiff,nddriv &
          &       ,npcntr,coeff1,mddiff,grdnts(1,ngp+2),modeex)
     !               output: grdnts(*,3or6) = \nabla (abs \nabla \rho)
     call cnggrd(grdnts(1,ngp),rad,kmesh,mesh )
     !               output: grdnts
  end do
end subroutine get_gradient_of_rho

subroutine gga_xc_potential_atomic(jsm,len_str,xctype,kmesh,nmesh,rho,rad&
     &,grdnts,exc,vxc,eps_chg,eps_grad)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: gga_xc_potential_atomic
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)         :: jsm,len_str
  character(len=len_str), intent(in) :: xctype
  integer, intent(in)         :: kmesh,nmesh
  real(kind=DP),intent(in),dimension(kmesh)   :: rho,rad
  real(kind=DP),intent(in),dimension(kmesh,3) :: grdnts
  real(kind=DP),intent(out),dimension(kmesh)  :: exc, vxc
  real(kind=DP),intent(in)                    :: eps_chg, eps_grad

  integer :: i
#ifdef GGA_CHECK
  integer :: j
#endif

  if(jsm == 2) then
     write(6,*) ' -- Warning -- '
     write(6,*) ' Sorry, this program( xc potential calculation) is not'&
          &     , ' corresponding to ferromagnetic case.'
  end if
#ifdef GGA_CHECK
  write(6,'(" -- gga_xc_potential_atomic --")')
  do j = 1, 10
     write(6,'(" ( ",i5,") rho = ",d12.4)') j, rho(j)
  end do
#endif

  exc = 0.d0; vxc = 0.d0
  if(         xctype == 'ggapw91' .or. xctype == 'GGAPW91'&
       & .or. xctype == 'ldapw91' .or. xctype == 'LDAPW91') then
     call ggaexch_pw91(nmesh,rho,grdnts(1,1),grdnts(1,2),grdnts(1,3),exc,vxc)  ! -> exc,vxc
     call ggacorl_pw91(nmesh,rho,grdnts(1,1),grdnts(1,2),grdnts(1,3),exc,vxc)  ! -> exc,vxc
  else if(    xctype == 'ggapbe ' .or. xctype == 'GGAPBE ' &
       & .or. xctype == 'ggapbex' .or. xctype == 'GGAPBEX' &
       & .or. xctype == 'ggapbey' .or. xctype == 'GGAPBEY' &
       & .or. xctype == 'vdwdf  ' .or. xctype == 'VDWDF  ' &
       & .or. xctype == 'ldapbe ' .or. xctype == 'LDAPBE ' &
       & .or. xctype == 'ggapbek' .or. xctype == 'GGAPBEK' &
       & .or. xctype == 'ldapbek' .or. xctype == 'LDAPBEK' &
       & .or. xctype == 'katopbe' .or. xctype == 'KATOPBE' ) then
     call ggaexch_pbe(nmesh,rho,grdnts(1,1),grdnts(1,2),grdnts(1,3),exc,vxc,eps_chg)  ! -> exc,vxc
     call ggacorl_pbe (nmesh,rho,grdnts(1,1),grdnts(1,2),grdnts(1,3),exc,vxc,eps_chg,eps_grad)  ! -> exc,vxc

! ================================= KT_add =================== 13.0A
  else if (   xctype == 'rpbe   ' .or. xctype == 'RPBE   ' ) then
     call ggaexch_rpbe(nmesh,rho,grdnts(1,1),grdnts(1,2),grdnts(1,3),exc,vxc,eps_chg)
     call ggacorl_pbe (nmesh,rho,grdnts(1,1),grdnts(1,2),grdnts(1,3),exc,vxc,eps_chg,&
          &            eps_grad)
! ============================================================= 13.0A

  else if(xctype == 'ggabp  ' .or. xctype == 'GGABP  ') then
     call ggabp(nmesh,rho,grdnts(1,1),grdnts(1,2),grdnts(1,3),exc,vxc)
  else
     write(6,'(" !! xctype does not match with any term")')
     call phase_error_with_msg(6, ' xctype is not properly set',__LINE__,__FILE__)
  end if

#ifdef GGA_CHECK
  write(6,'(" --- after gga[exch,corl]* in ( gga_xc_potential_atomic()) ---")')
#endif
  do i = 1, nmesh
     vxc(i) = vxc(i)*rad(i)
#ifdef GGA_CHECK
     if(i < 10 .or. i > nmesh-10+1 ) &
          & write(6,'(" ( ",i4," ) radr, rho, vxc = ", 3d18.8)') i, rad(i), rho(i), vxc(i)
#endif
  end do
  !  write(6,*) '! after vxc'

end subroutine gga_xc_potential_atomic

subroutine ggaexch_pw91(nmesh,rho,grad1,grad2,grad3,exc,vxc )
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: ggaexch_pw91
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP, PAI
  implicit none
  integer, intent(in)                         :: nmesh
  real(kind=DP),intent(in),   dimension(nmesh):: rho,grad1,grad2,grad3
  real(kind=DP),intent(inout),dimension(nmesh):: exc,vxc
  
!                           @(#)ggaexch_pw91.f 9.1 97/05/08 14:48:26 
!*********************************************************************
!      PW'91 GGA exchange energy and potential.
!      The original code came from Jim White and David Bird.
!           Ref: J.P.Perdew, in "Electronic Structure of Solids '91",
!                                edited by P.Ziesche and E.Eschrig
!                                   (Akademie Verlag, Berlin,1991).
!        modified  by T.Yamasaki  94/11/14
!        modified  by Y.Morikawa '94/11/30 at JRCAT Tsukuba.
!        modified  by T.Yamasaki '94/12/01 
! inputs:
!     nmesh      : number of grid points
!     rho     : charge density
!     grad1   : abs(\nabla(rho))
!     grad2   : \div(\nabla(rho))
!     grad3   : 1/2*(\nabla(rho))\cdot(\nabla(\abs(\nabla(rho))**2))
!                                           /(\abs(\nabla(rho))**2
! outputs:
!     exc     : exchange energy
!     vxc     : exchange potential
!     
!*********************************************************************
  real(kind=DP),parameter :: a1  = 0.19645d0,    a2 = 0.27430d0 &
       &                   , a3  = 0.15084d0,    a4 = 100.0d0   &
       &                   , ax  = -0.7385588d0,  a = 7.7956d0,  b1 = 0.004d0 &
       &                   , thrd = 0.33333333333d0, thrd4 = 1.333333333333333d0
!!$  real(kind=DP),parameter :: thpith = 3.0936677262801d0

  real(kind=DP)  :: d,dd,fk,s,fac,s2,s3,s4,p0,p1,p2,p3,p4,f,ex &
       &          , p5,p6,fs,exc0&
       &          , p5s,p6s,p7,fs2,vx1,vx2,vx3,vx4,vx5, vxall
  integer  ::  i

  do  i = 1, nmesh
     d = rho(i)
     if(d < 1.d-40) cycle
     dd = grad1(i)
     fk = (3*PAI*PAI*d)**thrd
!!$     sk = dsqrt(4*fk/PAI)
     if(d > 1.d-20) then
        s = dd/(d*fk*2.d0)
     else
        s = 0.d0
     endif
!  -------------------------------------
     fac = ax*d**thrd
     s2  = s*s
     s3  = s2*s
     s4  = s2*s2
     p0  = 1.d0/(dsqrt(1.d0+a*a*s2))
     p1  = dlog(a*s+1.d0/p0)
     p2  = dexp(-a4*s2)
     p3  = 1.d0/(1.d0+a1*s*p1+b1*s4)
     p4  = 1.d0 + a1*s*p1 + (a2-a3*p2)*s2
     f   = p3*p4

!  exchange energy

     ex  = fac*f*d

     p5  = 2.d0*(s*(a2-a3*p2)+a3*a4*s3*p2 - 2.d0*b1*s3)
     p6  = (a1*(p1+a*s*p0)+4.d0*b1*s3)*((a2-a3*p2)*s2-b1*s4)
     fs  = (p5*p3-p6*p3*p3)
!!$     exd = thrd4*fac*(f-s*fs)
!!$     exdd = ax*fs*0.5d0/thpith
!!$     p5  = 2*(s*(a2-a3*p2)+a3*a4*s3*p2 - 2*b1*s3)
!!$     p6  = (a1*(p1+a*s*p0)+4*b1*s3)*((a2-a3*p2)*s2-b1*s4)
!!$     fs  = (p5*p3-p6*p3*p3)
!!$     exd = thrd4*fac*(f-s*fs)
!!$     exdd = ax*fs*0.5d0/thpith

     p5s = 2.d0*(a2-a3*p2*(1.d0-2.d0*a4*s2*(1.d0-a4*s2))&
          &              +3.d0*s2*(a3*a4*p2-2.d0*b1))

     p6s = (a1*a*p0*(2.d0-(a*s*p0)**2)+12.d0*b1*s2) &
          &       *((a2-a3*p2)*s2-b1*s4) &
          &       +(a1*(p1+a*s*p0)+4*b1*s3)*2.d0*s&
          &        *(a3*a4*s2*p2+(a2-a3*p2)-2.d0*b1*s2)

!!$     p5s = 2*(a2-a3*p2*(1-2*a4*s2*(1-a4*s2))+3*s2*(a3*a4*p2-2*b1))
!!$
!!$     p6s = (a1*a*p0*(2-(a*s*p0)**2)+12*b1*s2)*((a2-a3*p2)*s2-b1*s4) &
!!$          &   +(a1*(p1+a*s*p0)+4*b1*s3)*2*s*(a3*a4*s2*p2+(a2-a3*p2)-2*b1*s2)

     p7  =  a1*(p1+a*s*p0)+4*b1*s3
     fs2 = p3*(p5s-p3*((p5*p7+p6s)-p3*2*p6))

!  exchange potential

     vx1 =  thrd4*fac*f
     vx2 =  thrd4*fac*s2*fs2
     vx3 = -thrd4*fac*s*fs
     if(dd < 1.d-20) then
        vx4 = 0.d0
        vx5 = 0.d0
     else
        vx4 = -grad2(i)*d/dd**2 * fac*s*fs
        vx5 =  grad3(i)*d/dd**2*fac*(s*fs-s2*fs2)
     endif
     vxall = vx1 + vx2 + vx3 + vx4 + vx5
     vxc(i) = vxc(i) + vxall
!------------------------------------------     
     exc0 = ex
     exc(i)  = exc(i) + exc0
  end do
end subroutine ggaexch_pw91

subroutine ggacorl_pw91(nmesh,rho,grad1,grad2,grad3,exc,vxc)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: ggacorl_pw91
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP, PAI
  implicit none
  integer, intent(in)                         :: nmesh
  real(kind=DP),intent(in),   dimension(nmesh):: rho,grad1,grad2,grad3
  real(kind=DP),intent(inout),dimension(nmesh):: exc,vxc
!                           @(#)ggacorl_pw91.f 9.1 97/05/08 14:48:26 
!*********************************************************************
!      PW'91 GGA correlation energy and potential.
!      The original code came from Jim White and David Bird.
!           Ref: J.P.Perdew, in "Electronic Structure of Solids '91",
!                                edited by P.Ziesche and E.Eschrig
!                                   (Akademie Verlag, Berlin,1991).
!                LDA part is given in
!                J.P.Perdew and Y.Wang, PRB45, 13244 (1992).
!
!        modified  by T.Yamasaki  94/11/15
!        modified  by Y.Morikawa '94/11/30 at JRCAT Tsukuba.
!        modified  by T.Yamasaki '94/12/01 
! inputs:
!     nmesh      : number of grid points
!     rho     : charge density
!     grad1   : abs(\nabla(rho))
!     grad2   : \div(\nabla(rho))
!     grad3   : 1/2*(\nabla(rho))\cdot(\nabla(\abs(\nabla(rho))**2))
!                                           /(\abs(\nabla(rho))**2
! outputs:
!     exc        : correlation energy
!     vxc   : correlation potential
!*********************************************************************
!  parameters for LDA part
  real(kind=DP),parameter :: a   = 0.0310907d0&
       &,                    a1  = 0.21370d0  &
       &,                    b1  = 7.5957d0   &
       &,                    b2n = 3.5876d0   &
       &,                    b3  = 1.6382d0   &
       &,                    b4  = 0.49294d0  &
       &,                    p   = 1.00d0     &
       &,                    p1  = p+1.d0 

!  parameters for GGA part
  real(kind=DP),parameter :: xnu = 15.75592d0,     cc0 = 0.004235d0 &
       &,                    cx  = -0.001667212d0, alf = 0.09d0     &
       &,                    c1  = 0.002568d0,      c2 = 0.023266d0 &
       &,                    c3  = 7.389d-6,        c4 = 8.723d0    &
       &,                    c5  = 0.472d0,         c6 = 7.389d-2   &
       &,                    a4  = 100.d0 &
       &,                  thrd  = 0.333333333333d0, sixth7 = 1.1666666666666666d0

  integer :: i
  real(kind=DP) :: bet,delt,g,g3,g4,facpon &
       &   , d,dd,rs,fk,sk,t,q0,q1,q2,q3,q4,q5,q6,q7,q8 &
       &   , rs12,rs32,rsp,eu,eurs,pon,b,b2,t2,t4,t6,rs2,rs3 &
       &   , h0,h0t,h0b,h0bt,h0rs,h0rst,h0t2 &
       &   , h1,h1t,h1rs,h1rst,h1t2,cc,r0,r1,r2,r3,coeff &
       &   , ccrs,r1rs,h &
       &   , v1,v2,v3,v4,v5

!--------------------------
  bet  = xnu*cc0
  delt = 2*alf/bet
  g    = 1.d0
  g3   = g**3
  g4  =  g3*g
  facpon = -delt/(g3*bet)
!---------------------------
  do i = 1, nmesh
     d = rho(i)
     if(d < 1.d-15) cycle

     dd = grad1(i)
	
     rs = (0.75d0/(PAI*d))**thrd
     fk = (3*PAI*PAI*d)**thrd
     sk = dsqrt(4*fk/PAI)
     if(d > 1.d-15) then
        t = dd/(d*sk*2)
     else
        t = 0.d0
     endif

!   LDA part

     q0   = -2*a*(1+a1*rs)
     rs12 = dsqrt(rs)
     rs32 = rs12**3
     rsp  = rs**p
     q1   = 2*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
     q2   = log(1+1.d0/q1)
     q3   = a*(b1/rs12+2*b2n+3*b3*rs12+2*b4*p1*rsp)
     
     eu   = q0*q2
     eurs = -2*a*a1*q2 - q0*q3/(q1**2 + q1)

!  GGA part

!  H0 part

     pon = facpon*eu
     b   = delt/(dexp(pon)-1)
     b2  = b*b
     t2  = t*t
     t4  = t2*t2
     t6  = t4*t2
     rs2 = rs*rs
     rs3 = rs2*rs
     q4  = 1+b*t2
     q5  = 1+b*t2+b2*t4
     q8  = q5*q5+delt*q4*q5*t2

!!$     q8s = 2*t*(1+2*b*t2)*(2*b*q5+delt*(1+2*b*t2*(1+b*t2)))

     h0  = g3*(bet/delt)*dlog(1+delt*q4*t2/q5)
     h0t = 2*bet*t*(1+2*b*t2)/q8
     h0b = -bet*t6*(2*b+b2*t2)/q8

     h0bt = -bet*b*g3*t4*t/q8**2 &
          &   *(4*q5*(3*(1+b*t2)-5*b2*t4)+2*delt*t2*(4+7*b*t2+4*b2*t4))

     h0rs = h0b*b*eurs*(b+delt)/bet

     h0rst= h0bt*b*eurs*(b+delt)/bet
     h0t2 = 2*bet*g3/q8**2 &
          &    *(q5     *(1+b*t2*(3+b*t2*(-9-b*t2*10))) &
          &     -delt*t2*(1+b*t2*(4+b*t2*(14+b*t2*(19+b*t2*10)))))

!  H1 part

     q6  = c1+c2*rs+c3*rs2
     q7  = 1+c4*rs+c5*rs2+c6*rs3
     cc  = -cx + q6/q7
     r0  = (sk/fk)**2
     r1  = a4*r0*g4
     coeff = cc-cc0-3*cx/7.d0
     r2  = xnu*coeff*g3
     r3  = dexp(-r1*t2)

     h1  = r3*r2*t2
     h1t  = 2*r3*r2*t*(1-r1*t2)
     ccrs = (c2+2*c3*rs)/q7-q6*(c4+2*c5*rs+3*c6*rs2)/q7**2
     r1rs = 100*r0/rs
     h1rs = xnu*t2*r3*(ccrs - coeff*t2*r1rs)

     h1rst= xnu*g3*2*t*r3 &
          &  *((1-r1*t2)*(ccrs-t2*coeff*r1rs)-t2*coeff*r1rs)
     h1t2 = 2*r2*r3*(1-r1*t2*(5-2*r1*t2))

!======================================================
     h   = h0+h1
!!$     ht   = h0t+h1t
!!$     hrs  = h0rs + h1rs

!!$     hrst = h0rst + h1rst
!!$     ht2  = h0t2  + h1t2

!!$     ec1  = d*h
!!$     ec1d = h-thrd*rs*hrs-sixth7*t*ht
!!$     ec1dd = 0.5d0*ht/sk

     v1 = eu+h0+h1-thrd*rs*(eurs+h0rs+h1rs)
     v2 = sixth7*t2*(h0t2+h1t2)
     v3 = -t*((h0t+h1t)-thrd*rs*(h0rst+h1rst))
     if(dd < 1.d-15) then
        v4 = 0.d0
        v5 = 0.d0
     else
        v4 = -grad2(i)/dd**2*t*d*(h0t+h1t)
        v5 =  grad3(i)      /dd**2*d*t*(h0t+h1t-t*(h0t2+h1t2))
     endif

     vxc(i) = vxc(i) + v1+v2+v3+v4+v5
     exc(i) = exc(i) + (eu+h)*d
  end do
end subroutine ggacorl_pw91

! ========================================== KT_add =============== 13.0A
subroutine ggaexch_rpbe(nmesh,rho,grad1,grad2,grad3,exc,vxc,eps_chg )

  use m_Const_Parameters, only : DP, PAI
  implicit none
  integer, intent(in)                         :: nmesh
  real(kind=DP),intent(in),   dimension(nmesh):: rho,grad1,grad2,grad3
  real(kind=DP),intent(inout),dimension(nmesh):: exc,vxc
  real(kind=DP),intent(in)                    :: eps_chg

!***
!       Coded based on the subroutine of ggaexch_pw91 by K. Kato 99/06/25
!       Modified into F90 by T. Yamasaki 99/06/26
! inputs:
!     nmesh      : number of grid points
!     rho     : charge density
!     grad1   : abs(\nabla(rho))
!     grad2   : \div(\nabla(rho))
!     grad3   : 1/2*(\nabla(rho))\cdot(\nabla(\abs(\nabla(rho))**2))
!                                           /(\abs(\nabla(rho))**2
! outputs:
!     exc     : exchange energy
!     vxc     : exchange potential
!
!*********************************************************************
  real(kind=DP),parameter :: ax  = -0.738558766382022405884230032680836d0 &
!!$       &                   , ax  = -0.7385588d0,  a = 7.7956d0,  b1 = 0.004d0 &
       &                   , thrd = 1.d0/3.d0, thrd4 = 4.d0/3.d0 &
!!$  real(kind=DP),parameter :: thpith = 3.0936677262801d0 &
!!$       &                   , cupa = 0.804,      yum = 0.21951
       &                   , cupa = 0.8040d0,      yum = 0.2195149727645171d0

  real(kind=DP)  :: d,dd,fk,s,fac,s2,f,ex,fs,exc0&
       &          , fs2,vx1,vx2,vx3,vx4,vx5, vxall,yums2, ctmp1
  integer  ::  i

#ifdef GGA_CHECK
  write(6,'(" -- ggaexch_rpbe --")')
#endif
  do  i = 1, nmesh
#ifdef GGA_ATOMIC_WITH_NEW_GNCPP
     d  = max(rho(i),eps_chg)
#else
     d = rho(i)
     if(d < 1.d-40) cycle
#endif
     dd = grad1(i)
     fk = (3*PAI*PAI*d)**thrd
!!$     sk = dsqrt(4*fk/PAI)
     if(d > 1.d-20) then
        s = dd/(d*fk*2)
     else
        s = 0.d0
     endif
!  -------------------------------------
     fac = ax*d**thrd
     s2  = s*s
     yums2 = yum * s2

     ctmp1 = exp( -yums2 /cupa )
     f = 1.0D0 + cupa *( 1.0D0 - ctmp1 )
     fs = 2.0D0 *yum * s * ctmp1
     fs2 = 2.0D0 *yum *( 1.0D0 - 2.0D0 *yums2/cupa ) *ctmp1

!  exchange energy

     ex  = fac*f*d
!!$     exd = thrd4*fac*(f-s*fs)
!!$     exdd = ax*fs*0.5/thpith

!  exchange potential

     vx1 =  thrd4*fac*f
     vx2 =  thrd4*fac*s2*fs2
     vx3 = -thrd4*fac*s*fs
     if(dd < 1.d-20) then
        vx4 = 0.d0
        vx5 = 0.d0
     else
        vx4 = -grad2(i)*d/dd**2 * fac*s*fs
        vx5 =  grad3(i)*d/dd**2*fac*(s*fs-s2*fs2)
     endif
     vxall = vx1 + vx2 + vx3 + vx4 + vx5
     vxc(i) = vxc(i) + vxall
#ifdef GGA_CHECK
     write(6,'(" (",i4,") rho, vxc = ",2d18.8," (ggaexch_rpbe)")') i, rho(i), vxc(i)
#endif
!------------------------------------------
     exc0 = ex
     exc(i)  = exc(i) + exc0
  end do
end subroutine ggaexch_rpbe
! ==============================================================================13.0A

subroutine ggaexch_pbe(nmesh,rho,grad1,grad2,grad3,exc,vxc,eps_chg )
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE:  ggaexch_pbe
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP, PAI
  implicit none
  integer, intent(in)                         :: nmesh
  real(kind=DP),intent(in),   dimension(nmesh):: rho,grad1,grad2,grad3
  real(kind=DP),intent(inout),dimension(nmesh):: exc,vxc
  real(kind=DP),intent(in)                    :: eps_chg
  
!***
!       Coded based on the subroutine of ggaexch_pw91 by K. Kato 99/06/25 
!       Modified into F90 by T. Yamasaki 99/06/26
! inputs:
!     nmesh      : number of grid points
!     rho     : charge density
!     grad1   : abs(\nabla(rho))
!     grad2   : \div(\nabla(rho))
!     grad3   : 1/2*(\nabla(rho))\cdot(\nabla(\abs(\nabla(rho))**2))
!                                           /(\abs(\nabla(rho))**2
! outputs:
!     exc     : exchange energy
!     vxc     : exchange potential
!     
!*********************************************************************
  real(kind=DP),parameter :: ax  = -0.738558766382022405884230032680836d0 &
!!$       &                   , ax  = -0.7385588d0,  a = 7.7956d0,  b1 = 0.004d0 &
       &                   , thrd = 1.d0/3.d0, thrd4 = 4.d0/3.d0 &
!!$  real(kind=DP),parameter :: thpith = 3.0936677262801d0 &
!!$       &                   , cupa = 0.804,      yum = 0.21951
       &                   , cupa = 0.8040d0,      yum = 0.2195149727645171d0

  real(kind=DP)  :: d,dd,fk,s,fac,s2,f,ex,fs,exc0&
       &          , fs2,vx1,vx2,vx3,vx4,vx5, vxall,yums2
  integer  ::  i

#ifdef GGA_CHECK
  write(6,'(" -- ggaexch_pbe --")')
#endif
  do  i = 1, nmesh
#ifdef GGA_ATOMIC_WITH_NEW_GNCPP
     d  = max(rho(i),eps_chg)
#else
     d = rho(i)
     if(d < 1.d-40) cycle
#endif
     dd = grad1(i)
     fk = (3*PAI*PAI*d)**thrd
!!$     sk = dsqrt(4*fk/PAI)
     if(d > 1.d-20) then
        s = dd/(d*fk*2)
     else
        s = 0.d0
     endif
!  -------------------------------------
     fac = ax*d**thrd
     s2  = s*s
     yums2 = yum * s2
     f   = 1 + cupa*yums2/(cupa+yums2)
!  exchange energy

     ex  = fac*f*d
     fs = 2 * cupa ** 2 * yum * s / ( cupa + yums2 ) ** 2
!!$     exd = thrd4*fac*(f-s*fs)
!!$     exdd = ax*fs*0.5/thpith

     fs2 = 2 * cupa **2 * (cupa*yum - 3*yum*yums2)/(cupa+yums2)**3

!  exchange potential

     vx1 =  thrd4*fac*f
     vx2 =  thrd4*fac*s2*fs2
     vx3 = -thrd4*fac*s*fs
     if(dd < 1.d-20) then
        vx4 = 0.d0
        vx5 = 0.d0
     else
        vx4 = -grad2(i)*d/dd**2 * fac*s*fs
        vx5 =  grad3(i)*d/dd**2*fac*(s*fs-s2*fs2)
     endif
     vxall = vx1 + vx2 + vx3 + vx4 + vx5
     vxc(i) = vxc(i) + vxall
#ifdef GGA_CHECK
     write(6,'(" (",i4,") rho, vxc = ",2d18.8," (ggaexch_pbe)")') i, rho(i), vxc(i)
#endif
!------------------------------------------     
     exc0 = ex
     exc(i)  = exc(i) + exc0
  end do
end subroutine ggaexch_pbe

subroutine ggacorl_pbe(nmesh,rho,grad1,grad2,grad3,exc,vxc,eps_chg,eps_grad)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE:  ggacorl_pbe
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP, PAI
  implicit none
  integer, intent(in)                         :: nmesh
  real(kind=DP),intent(in),   dimension(nmesh):: rho,grad1,grad2,grad3
  real(kind=DP),intent(inout),dimension(nmesh):: exc,vxc
  real(kind=DP),intent(in)                    :: eps_chg, eps_grad
!***
!       Coded based on the subroutine of ggaexch_pw91 by K. Kato 99/06/25 
!       Modified into F90 by T. Yamasaki 99/06/26
!
! inputs:
!     nmesh      : number of grid points
!     rho     : charge density
!     grad1   : abs(\nabla(rho))
!     grad2   : \div(\nabla(rho))
!     grad3   : 1/2*(\nabla(rho))\cdot(\nabla(\abs(\nabla(rho))**2))
!                                           /(\abs(\nabla(rho))**2
! outputs:
!     exc        : correlation energy
!     vxc   : correlation potential
!*********************************************************************
!  parameters for LDA part
  real(kind=DP),parameter :: a   = 0.0310907d0&
       &,                    a1  = 0.21370d0  &
       &,                    b1  = 7.5957d0   &
       &,                    b2n = 3.5876d0   &
       &,                    b3  = 1.6382d0   &
       &,                    b4  = 0.49294d0  &
       &,                    p   = 1.00d0     &
       &,                    p1  = p+1.d0 

!  parameters for GGA part
!!$  real(kind=DP),parameter :: xnu = 15.75592d0,      cc0 = 0.004235d0 &
  real(kind=DP),parameter :: bet = 0.06672455060314922d0 &
       &                   , thrd = 1.d0/3.d0, sixth7 = 7.d0/6.d0 &
       &                   , gamma = 0.03109069086965489503494086371273d0

  real(kind=DP) :: delt,g,g3,facpon &
       &   , d,dd,rs,fk,sk,t,q0,q1,q2,q3,q4,q5,q8 &
       &   , rs12,rs32,rsp,eu,eurs,pon,b,b2,t2,t4,t6 &
       &   , h0,h0t,h0b,h0bt,h0rs,h0rst,h0t2,h &
       &   , v1,v2,v3,v4,v5
  integer :: i
#ifdef GGA_CHECK
  write(6,'(" -- ggacorl_pbe --")')
#endif

!!$  bet = xnu*cc0
  delt = bet / gamma
  g = 1.d0
  g3  = g**3
  facpon = -delt/(g3*bet)
!---------------------------
  do i = 1, nmesh
#ifdef GGA_ATOMIC_WITH_NEW_GNCPP
     d  = max(rho(i), eps_chg)
     dd = max(grad1(i), eps_grad)
#else
     d  = rho(i)
     if(d < 1.d-15) cycle
     dd = grad1(i)
#endif

	
     rs = (0.75d0/(PAI*d))**thrd
     fk = (3*PAI*PAI*d)**thrd
     sk = dsqrt(4*fk/PAI)
#ifdef GGA_ATOMIC_WITH_NEW_GNCPP
     if(rho(i) > eps_chg) then
#else
     if(d > 1.d-15) then
#endif
        t = dd/(d*sk*2)
     else
        t = 0.d0
     endif

!   LDA part

     q0   = -2*a*(1+a1*rs)
     rs12 = dsqrt(rs)
     rs32 = rs12**3
     rsp  = rs**p
     q1   = 2*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
     q2   = log(1+1.d0/q1)
     q3   = a*(b1/rs12+2*b2n+3*b3*rs12+2*b4*p1*rsp)
     
     eu   = q0*q2
     eurs = -2*a*a1*q2 - q0*q3/(q1**2 + q1)

!  GGA part

!  H0 part

     pon = facpon*eu
     b   = delt/(dexp(pon)-1)
     b2  = b*b
     t2  = t*t
     t4  = t2*t2
     t6  = t4*t2
!!$     rs2 = rs*rs
!!$     rs3 = rs2*rs
     q4  = 1+b*t2
     q5  = 1+b*t2+b2*t4
     q8  = q5*q5+delt*q4*q5*t2

!!$     q8s = 2*t*(1+2*b*t2)*(2*b*q5+delt*(1+2*b*t2*(1+b*t2)))

     h0  = g3*gamma*dlog(1+delt*q4*t2/q5)
#ifdef GGA_ATOMIC_WITH_NEW_GNCPP
     if(abs(rho(i)) < eps_chg) h0 = 0.d0
#endif
     h0t = 2*bet*t*(1+2*b*t2)/q8
     h0b = -bet*t6*(2*b+b2*t2)/q8

     h0bt = -bet*b*g3*t4*t/q8**2 &
          &   *(4*q5*(3*(1+b*t2)-5*b2*t4)+2*delt*t2*(4+7*b*t2+4*b2*t4))

     h0rs = h0b*b*eurs*(b+delt)/bet

     h0rst= h0bt*b*eurs*(b+delt)/bet
     h0t2 = 2*bet*g3/q8**2 &
          &    *(q5     *(1+b*t2*(3+b*t2*(-9-b*t2*10))) &
          &       -delt*t2*(1+b*t2*(4+b*t2*(14+b*t2 &
          &                          *(19+b*t2*10)))))

!  H1 part
     h   = h0
!!$     ht   = h0t
!!$     hrs  = h0rs

     v1 = eu+h0-thrd*rs*(eurs+h0rs)
     v2 = sixth7*t2*h0t2
     v3 = -t*(h0t-thrd*rs*(h0rst))

#ifdef GGA_ATOMIC_WITH_NEW_GNCPP
     if(grad1(i) < eps_grad) then
#else
     if(dd < 1.d-15) then
#endif
        v4 = 0.d0
        v5 = 0.d0
     else
        v4 = -grad2(i)/dd**2*t*d*h0t
        v5 =  grad3(i)/dd**2*d*t*(h0t-t*h0t2)
     endif

     vxc(i) = vxc(i) + v1+v2+v3+v4+v5
     exc(i) = exc(i) + (eu+h)*d
#ifdef GGA_CHECK
     write(6,'(" (",i4,") rho,vxc,v4,v5 = ",4d18.6," ggacorl_pbe")') i, rho(i), vxc(i), v4, v5
#endif
  end do
end subroutine ggacorl_pbe

subroutine ggabp(nmesh,rho,grad1,grad2,grad3,exc,vxc)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: ggabp
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP, PAI
  implicit none
  integer, intent(in)                         :: nmesh
  real(kind=DP),intent(in),   dimension(nmesh):: rho,grad1,grad2,grad3
  real(kind=DP),intent(inout),dimension(nmesh):: exc,vxc
!        by T. Yamasaki on  Dec. 1994
  real(kind=DP),parameter :: a1 = 0.19645d0,   a2 = 0.27430d0 &
       &,                    a3 = 0.15084d0,   a4 = 100.0d0   &
       &,                    ax = -0.7385588d0, a = 7.7956d0,  b1 = 0.004d0 &
       &,                  thrd = 0.33333333333d0, thrd4 = 1.333333333333333d0
!!$       &,                thpith = 3.0936677262801d0

  integer :: i
  real(kind=DP) :: d,dd,fk,s,fac,s2,s3,s4,p0,p1,p2,p3,p4 &
       &         , f,ex,p5,p6,fs &
       &         , p5s,p6s,p7,fs2,vx1,vx2,vx3,vx4,vx5

  do i = 1, nmesh

     d = rho(i)
     dd = grad1(i)
     fk = (3*PAI*PAI*d)**thrd
!!$     sk = dsqrt(4*fk/PAI)
     if(d > 1.d-20) then
        s = dd/(d*fk*2)
     else
        s = 0.d0
     endif
!-------------------------------------
     fac = ax*d**thrd
     s2  = s*s
     s3  = s2*s
     s4  = s2*s2
     p0  = 1.d0/(dsqrt(1+a*a*s2))
     p1  = dlog(a*s+1/p0)
     p2  = dexp(-a4*s2)
     p3  = 1.d0/(1+a1*s*p1+b1*s4)
     p4  = 1+a1*s*p1 + (a2-a3*p2)*s2
     f   = p3*p4

!  exchange energy

     ex  = fac*f*d

     p5  = 2*(s*(a2-a3*p2)+a3*a4*s3*p2 - 2*b1*s3)
     p6  = (a1*(p1+a*s*p0)+4*b1*s3)*((a2-a3*p2)*s2-b1*s4)
     fs  = (p5*p3-p6*p3*p3)
!!$     exd = thrd4*fac*(f-s*fs)
!!$     exdd = ax*fs*0.5d0/thpith

     p5s = 2*(a2-a3*p2*(1-2*a4*s2*(1-a4*s2)) &
          &              +3*s2*(a3*a4*p2-2*b1))
     p6s = (a1*a*p0*(2-(a*s*p0)**2)+12*b1*s2) &
          &       *((a2-a3*p2)*s2-b1*s4) &
          &       +(a1*(p1+a*s*p0)+4*b1*s3)*2*s &
          &        *(a3*a4*s2*p2+(a2-a3*p2)-2*b1*s2)

     p7  =  a1*(p1+a*s*p0)+4*b1*s3
     fs2 = p3*(p5s-p3*((p5*p7+p6s)-p3*2*p6))

!  exchange potential

     vx1 =  thrd4*fac*f
     vx2 =  thrd4*fac*s2*fs2
     vx3 = -thrd4*fac*s*fs

     if(dd.lt.1.d-20) then
        vx4 = 0.d0
        vx5 = 0.d0
     else
        vx4 = -grad2(i)*d/dd**2 * fac*s*fs
        vx5 =        grad3(i)*d/dd**2*fac*(s*fs-s2*fs2)
     end if

     vxc(i) = vx1+vx2+vx3+vx4+vx5
     exc(i) = ex
  end do
end subroutine ggabp

subroutine rmeshs(k,m,xh,rmax,radr,h)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: rmeshs
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)                      :: k, m
  real(kind=DP), intent(in)                :: xh, rmax
  real(kind=DP), intent(out), dimension(k) :: radr
  real(kind=DP), intent(out)               :: h

  integer i

  h = 1.d0/xh
  do i = 1, m
     radr(i) = rmax*exp(h*dble(i-m))
  enddo

end subroutine rmeshs

subroutine coef_simpson_integration(k,m,xh,radr,wos)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: coef_simpson_integration
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)                      :: k, m
  real(kind=DP), intent(in)                :: xh
  real(kind=DP), intent(in),  dimension(k) :: radr
  real(kind=DP), intent(out), dimension(k) :: wos

  integer i

!!$  h = 1.d0/xh
  do i = 2, m-1, 2
     wos(i  ) = radr(i  )*4/(xh*3)
     wos(i+1) = radr(i+1)*2/(xh*3)
  enddo
  wos(1) = radr(1)    /(xh*3)
  wos(m) = radr(m)    /(xh*3)

end subroutine coef_simpson_integration

subroutine read_itau_ivanl(nfp,nfout,iloc,il,itau,ivanl,ipri)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE:  read_itau_ivanl
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  implicit none
  integer, intent(in)  :: nfp, nfout
  integer, intent(in)  :: iloc, il, ipri
  integer, intent(out) :: itau
  integer, intent(out) :: ivanl

  integer il_f

  read(nfp,*)      il_f, itau, ivanl
  if(ipri>=2) write(nfout,201) il_f, itau, ivanl
201 format(' !bPP ',3i4,'  :   IL, ITAU(IL1),IVANL(IL1) ')
  if(il_f /= il) then
     !write(nfout,*) ' IL_F in the psfile is invalid'
     !stop
     call phase_error_with_msg(nfout, 'IL_F in the psfile is invalid',__LINE__,__FILE__)
  endif
  if( (  il_f == iloc                         .and. &
     &       (itau /= 1 .or. ivanl /= 0) )           ) then
     !write(nfout,*) ' iloc,il1,itau,ivanl is not good'
     !stop
     call phase_error_with_msg(nfout, 'iloc,il1,itau,ivanl is not good',__LINE__,__FILE__)
  endif
end subroutine read_itau_ivanl

subroutine read_tau_eps_nrc_mord(nfp,nfout,kord,il,t1,eps,nrc,mord)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: read_tau_eps_nrc_mord
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)  :: nfp,nfout,kord
  integer, intent(in)  :: il
  integer, intent(in)  :: t1
  real(kind=DP), intent(out) :: eps
  integer, intent(out) :: nrc, mord

  integer              :: il0, tau0

  read(nfp,*) il0,tau0,eps,nrc,mord
!!$  write(nfout,202) il0, tau0, eps,nrc,mord
!!$202 format(' ',2i4,f12.8,2i6,' : il, ntau,  eps, nrc, mord')
  if(il0 /= il .or. tau0 /= t1) then
     write(nfout,*) ' il0, il = ', il0, il, ' t1, tau0 = ', t1, tau0
     !stop
     call phase_error_with_msg(nfout,'invalid il0 or ta0',__LINE__,__FILE__)
  endif
  if(mord > kord) then
     write(nfout,*) ' ! MORD is too large : mord = ', mord, ' kord = ', kord
!     stop
     call phase_error_with_msg(nfout,'MORD is too large',__LINE__,__FILE__)
  endif
end subroutine read_tau_eps_nrc_mord

subroutine read_tau_eps_nrc_mord_nrc0(nfp,nfout,kord,il,t1,eps,nrc,mord,nrc0)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: read_tau_eps_nrc_mord_nrc0
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)  :: nfp,nfout,kord
  integer, intent(in)  :: il
  integer, intent(in)  :: t1
  real(kind=DP), intent(out) :: eps
  integer, intent(out) :: nrc, mord, nrc0

  integer              :: il0, tau0, ios

  read(nfp,*,iostat=ios) il0,tau0,eps,nrc,mord,nrc0
!!$  write(nfout,202) il0, tau0, eps,nrc,mord
!!$202 format(' ',2i4,f12.8,2i6,' : il, ntau,  eps, nrc, mord')
  if(il0 /= il .or. tau0 /= t1) then
     write(nfout,*) ' il0, il = ', il0, il, ' t1, tau0 = ', t1, tau0
     !stop
     call phase_error_with_msg(nfout, 'invalid il0 or tau0',__LINE__,__FILE__)
  endif
  if(mord > kord) then
     write(nfout,*) ' ! MORD is too large : mord = ', mord, ' kord = ', kord
     !stop
     call phase_error_with_msg(nfout, 'MORD is too large',__LINE__,__FILE__)
  endif
  if(ios.ne.0) nrc0=0
end subroutine read_tau_eps_nrc_mord_nrc0

subroutine read_nrc_mord(nfp,nfout,kord,mm,il1,tau1,il2,tau2,il3,nrc&
     & ,mord,ipripp)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: read_nrc_mord
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  implicit none
  integer, intent(in)  :: nfp,nfout,kord,mm,il1,tau1,il2,tau2,il3,ipripp
  integer, intent(out) :: nrc, mord

  integer :: l1, t1, l2, t2, l3
  character(len=80) :: str

  if(ipripp >= 2) write(nfout,'(" !bPP nfp,nfout,kord,mm,il1,tau1,il2,tau2,il3 = ",9i5)') &
       &  nfp,nfout,kord,mm,il1,tau1,il2,tau2,il3
  read(nfp,'(a80)') str
  if(ipripp >= 2) write(nfout,'(" !bPP ",a80)') str
  read(str,*)          L1,T1,L2,T2,L3,NRC,MORD
!!$  READ(NFP,*)          L1,T1,L2,T2,L3,NRC,MORD
  if(ipripp >= 2) WRITE(NFOUT,341) MM, L1,T1,L2,T2,L3,NRC,MORD
341 FORMAT(' !bPP ',6I4,I6,I4,' : MM, L1,T1,L2,T2,L3,NRC,MORD')
  IF(IL1.NE.L1.OR.TAU1.NE.T1.OR. &
       &        IL2.NE.L2.OR.TAU2.NE.T2.OR.IL3.NE.L3) THEN
     WRITE(NFOUT,'(" !bPP L1,T1,L2,T2,L3 ARE NOT CORRECT")')
     STOP
  END IF
  if(mord > kord) then
     write(nfout,*) ' ! MORD is too large : mord = ', mord, ' kord = ', kord
     !stop
     call phase_error_with_msg(nfout, 'MORD is too large',__LINE__,__FILE__)
  endif
end subroutine read_nrc_mord

subroutine read_chgpc_nrc_mord(ipri,nfp,nfout,chgpc,nrc,mord)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: read_chgpc_nrc_mord
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)        :: ipri, nfp, nfout
  real(kind=DP), intent(out) :: chgpc
  integer, intent(out)       :: nrc, mord

  read(nfp,*)      chgpc, nrc, mord
  if(ipri>=2) then
     write(nfout,400) chgpc, nrc, mord
400  format(' !bPP',' chgpc = ',f12.8,' nrc, mord = ',2i4)
  end if

end subroutine read_chgpc_nrc_mord

subroutine qitgft &
     &     (ista_kngp,iend_kngp,KMESH,kqitg,NMESH,IPRI,NFOUT,IL3 &
     &     ,RADR,WOS,QRSPS,gr_l,UNIVOL,mmpt,qitg_l &
     &     ,X,Y)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: qitgft
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

! Fouriner transformation of the deficit charge QRSPS.
!***********************************************************
  use m_Const_Parameters, only : DP, PAI4
  implicit none
  integer, intent(in) :: ista_kngp, iend_kngp, kmesh,kqitg,nmesh,ipri,nfout,il3
  real(kind=DP), intent(in), dimension(kmesh) :: radr, wos, qrsps
  real(kind=DP), intent(in)                   :: gr_l(ista_kngp:iend_kngp)
  real(kind=DP), intent(in)                   :: univol
  integer,       intent(in)                   :: mmpt
  real(kind=DP), intent(out)                  :: qitg_l(ista_kngp:iend_kngp,kqitg)
  real(kind=DP), dimension(kmesh), optional   :: x, y

  integer       ::  i, n
  real(kind=DP) ::  time_start, time_end
!!$#ifndef VPP
!!$  integer,parameter :: nblock = 32
!!$  integer           :: nn, kgpcount, nmeshcount
!!$  integer           :: ii,is,ie,nis,nie
!!$  real(kind=DP),pointer, dimension(:) :: fact1
!!$  real(kind=DP),allocatable,dimension(:,:) :: xm, ym
!!$  real(kind=DP) ::  pai4univol
!!$
!!$  allocate(fact1(nblock)); allocate(xm(nblock,nblock)); allocate(ym(nblock,nblock))
!!$#else
  real(kind=DP) :: gabs, f2
!!$#endif

  call gettod(time_start)

!CDIR PARALLEL DO PRIVATE ( gabs, x, y, n, f2 )
  do i = ista_kngp, iend_kngp  !for mpi
     gabs = gr_l(i)
     x(1:nmesh) = gabs*radr(1:nmesh)
     call dsjnv(il3,nmesh,x,y)
     qitg_l(i,mmpt) = 0.d0
     do n = 1, nmesh
#ifdef QITGFT_OLD
        f2 = wos(n)/univol*PAI4*qrsps(n)
#else
        f2 = wos(n)*qrsps(n)
#endif
        qitg_l(i,mmpt) = qitg_l(i,mmpt) + f2*y(n)
     enddo
#ifndef QITGFT_OLD
     qitg_l(i,mmpt) = qitg_l(i,mmpt)/univol*PAI4
#endif
  end do

  call gettod(time_end)
  if(ipri >= 2) write(nfout,'(" !bPP sub qitgft time = ",f20.6,"(sec.)")') &
       & (time_end-time_start)/1.d6
  IF(IPRI.GE.3) THEN
     WRITE(NFOUT,400)
400  FORMAT(' ',' SUB Q I T G F T ')
  end IF
end subroutine qitgft
  
subroutine qitgft_diff &
     &     (ista_kngp,iend_kngp,KMESH,kqitg,NMESH,IPRI,NFOUT,IL3 &
     &     ,RADR,WOS,QRSPS,gr_l,UNIVOL,mmpt &
     &     ,qitg_l,qitg_diff_l &
     &     ,X,Y,Z1,Z2)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: qitgft_diff
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

! Fouriner transformation of the deficit charge QRSPS.
!***********************************************************
  use m_Const_Parameters, only : DP, PAI4
  implicit none
  integer, intent(in) :: ista_kngp, iend_kngp, kmesh,kqitg,nmesh,ipri,nfout,il3
  real(kind=DP), intent(in), dimension(kmesh) :: radr, wos, qrsps
  real(kind=DP), intent(in), dimension(ista_kngp:iend_kngp) :: gr_l
  real(kind=DP), intent(in)                   :: univol
  integer, intent(in)                         :: mmpt
  real(kind=DP), intent(out), dimension(ista_kngp:iend_kngp,kqitg) &
       & :: qitg_l, qitg_diff_l
  real(kind=DP), dimension(kmesh), optional :: x, y, z1, z2

  integer       ::  i, n
  real(kind=DP) ::  gabs, fac
  real(kind=DP) ::  time_start, time_end
!!$#ifndef VPP
!!$  integer,parameter :: nblock = 32
!!$  integer           :: nn, kgpcount, nmeshcount
!!$  integer           :: ii,is,ie,nis,nie
!!$  real(kind=DP),pointer, dimension(:) :: fact1,fact2
!!$  real(kind=DP),allocatable,dimension(:,:) :: xm, ym, zm1, zm2
!!$  real(kind=DP) ::  pai4univol
!!$
!!$  allocate(fact1(nblock)); allocate(xm(nblock,nblock)); allocate(ym(nblock,nblock))
!!$  allocate(fact2(nblock)); allocate(zm1(nblock,nblock)); allocate(zm2(nblock,nblock))
!!$#endif

  call gettod(time_start)

!!$#ifdef VPP
!CDIR PARALLEL DO PRIVATE ( gabs, x, y, z1, z2, fac, n, f2 )
  do i = ista_kngp, iend_kngp  !for mpi
     gabs = gr_l(i)
     qitg_l(i,mmpt) = 0.d0
     qitg_diff_l(i,mmpt) = 0.d0
     x(1:nmesh) = gabs*radr(1:nmesh)
     call dsjnv(il3,  nmesh,x,y)
     if(il3 == 0) then
       z1 = 0.d0
     else
       call dsjnv(il3-1,nmesh,x,z1)
     endif
     call dsjnv(il3+1,nmesh,x,z2)
     do n = 1, nmesh
        fac = wos(n)/univol*PAI4*qrsps(n)
        qitg_l(i,mmpt) = qitg_l(i,mmpt) + fac*y(n)
        qitg_diff_l(i,mmpt) = qitg_diff_l(i,mmpt) + fac * radr(n) &
     &          / (2.d0*il3+1.d0) * (il3*z1(n)-(il3+1)*z2(n))
     enddo
  end do

  call gettod(time_end)
  if(ipri >= 2) write(nfout,'(" sub qitgft_diff time = ",f20.6,"(sec.)")') &
       & (time_end-time_start)/1.d6
  IF(IPRI >= 3 ) THEN
     WRITE(NFOUT,400)
400  FORMAT(' ',' SUB Q I T G F T _ D I F F')
     write(nfout,'('' mmpt ='',i5)') mmpt
     write(nfout,'(8f10.5)') (qitg_l(i,mmpt),i=ista_kngp+1,ista_kngp+20)
     write(nfout,'(8f10.5)') (qitg_diff_l(i,mmpt),i=ista_kngp+1,ista_kngp+20)
  end IF
end subroutine qitgft_diff

subroutine psbhs0(nfout, iatomn,ival,itpcc,alp,cc)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: psbhs0
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in) ::                      nfout, iatomn
  real(kind=DP), intent(out) ::               ival
  integer, intent(out) ::                     itpcc
  real(kind=DP), intent(out), dimension(2) :: alp, cc

  IF (IATOMN.EQ.1) THEN
!--*-- H  --*--
     IVAL   =   1.d0
     ITPCC  =   0
     ALP(1) =  16.2200D0
     ALP(2) =   5.5500D0
     CC(1)  =   1.1924D0
     CC(2)  =  -0.1924D0
  ELSE IF (IATOMN.EQ.2) THEN
!--*-- H  --*--
     ALP(1) =  56.2300D0
     ALP(2) =  19.2400D0
     CC(1)  =   1.1998D0
     CC(2)  =  -0.1998D0
  ELSE IF(IATOMN.EQ.3) THEN
!--*-- Li --*--
     IVAL   =   1.d0
     ITPCC  =   1
     ALP(1) =   1.8400D0
     ALP(2) =   0.7300D0
     CC(1)  =   2.9081D0
     CC(2)  =  -1.9081D0
  ELSE IF(IATOMN.EQ.4) THEN
!--*-- Be --*--
     ALP(1) =   2.6100D0
     ALP(2) =   1.0000D0
     CC(1)  =   1.5280D0
     CC(2)  =  -0.5280D0
  ELSE IF(IATOMN.EQ.5) THEN
!--*-- B  --*--
     IVAL   =   3.d0
     ITPCC  =   0
     ALP(1) =   6.2100D0
     ALP(2) =   2.4700D0
     CC(1)  =   1.6546D0
     CC(2)  =  -0.6546D0
  ELSE IF(IATOMN.EQ.6) THEN
!--*-- C  --*--
     IVAL   =   4.d0
     ITPCC  =   0
     ALP(1) =   9.2800D0
     ALP(2) =   3.6900D0
     CC(1)  =   1.5222D0
     CC(2)  =  -0.5222D0
  ELSE IF(IATOMN.EQ.7) THEN
!--*-- N  --*--
     IVAL   =   5.d0
     ITPCC  =   0
     ALP(1) =  12.8700D0
     ALP(2) =   5.1200D0
     CC(1)  =   1.4504D0
     CC(2)  =  -0.4504D0
  ELSE IF(IATOMN.EQ.8) THEN
!--*-- O  --*--
     IVAL   =   6.d0
     ITPCC  =   0
     ALP(1) =  18.0900D0
     ALP(2) =   7.1900D0
     CC(1)  =   1.4224D0
     CC(2)  =  -0.4224D0
  ELSE IF(IATOMN.EQ.9) THEN
!--*-- F  --*--
     IVAL   =   7.d0
     ITPCC  =   0
     ALP(1) =  23.7800D0
     ALP(2) =   9.4500D0
     CC(1)  =   1.3974D0
     CC(2)  =  -0.3974D0
  ELSE IF(IATOMN.EQ.10) THEN
!--*-- Ne  --*--
     ALP(1) =  29.1300D0
     ALP(2) =  11.5800D0
     CC(1)  =   1.3711D0
     CC(2)  =  -0.3711D0
  ELSE IF(IATOMN.EQ.11) THEN
!--*-- Na --*--
     IVAL   =   1.d0
     ITPCC  =   1
     ALP(1) =   1.7100D0
     ALP(2) =   0.5000D0
     CC(1)  =   5.1815D0
     CC(2)  =  -4.1815D0
  ELSE IF(IATOMN.EQ.12) THEN
!--*-- Mg --*--
     IVAL   =   2.d0
     ITPCC  =   1
     ALP(1) =   2.0400D0
     ALP(2) =   0.8100D0
     CC(1)  =   3.5602D0
     CC(2)  =  -2.5602D0
  ELSE IF(IATOMN.EQ.13) THEN
!--*-- Al --*--
     IVAL   =   3.d0
     ITPCC  =   0
     ALP(1) =   1.7700D0
     ALP(2) =   0.7000D0
     CC(1)  =   1.7905D0
     CC(2)  =  -0.7905D0
  ELSE IF(IATOMN.EQ.14) THEN
!--*-- Si --*--
     IVAL   =   4.d0
     ITPCC  =   0
     ALP(1) =   2.1600D0
     ALP(2) =   0.8600D0
     CC(1)  =   1.6054D0
     CC(2)  =  -0.6054D0
  ELSE IF(IATOMN.EQ.15) THEN
!--*-- P  --*--
     IVAL   =   5.d0
     ITPCC  =   0
     ALP(1) =   2.5900D0
     ALP(2) =   1.0300D0
     CC(1)  =   1.4995D0
     CC(2)  =  -0.4995D0
  ELSE IF(IATOMN.EQ.16) THEN
!--*-- S  --*--
     IVAL   =   6.d0
     ITPCC  =   0
     ALP(1) =   2.9900D0
     ALP(2) =   1.1900D0
     CC(1)  =   1.4261D0
     CC(2)  =  -0.4261D0
  ELSE IF(IATOMN.EQ.17) THEN
!--*-- Cl --*--
     IVAL   =   7.d0
     ITPCC  =   0
     ALP(1) =   3.4800D0
     ALP(2) =   1.3800D0
     CC(1)  =   1.3860D0
     CC(2)  =  -0.3860D0
  ELSE IF(IATOMN.EQ.18) THEN
!--*-- Ar --*--
     ALP(1) =   3.9900D0
     ALP(2) =   1.5900D0
     CC(1)  =   1.3622D0
     CC(2)  =  -0.3622D0
  ELSE IF(IATOMN.EQ.19) THEN
!--*-- K  --*--
     IVAL   =   1.d0
     ITPCC  =   1
     ALP(1) =   1.4200D0
     ALP(2) =   0.2600D0
     CC(1)  =   6.3140D0
     CC(2)  =  -5.3140D0
  ELSE IF(IATOMN.EQ.20) THEN
!--*-- Ca --*--
     IVAL   =   2.d0
     ITPCC  =   1
     ALP(1) =   1.6100D0
     ALP(2) =   0.4500D0
     CC(1)  =   4.8360D0
     CC(2)  =  -3.8360D0
  ELSE IF(IATOMN.EQ.21) THEN
!--*-- Sc --*--
     ALP(1) =   3.9600D0
     ALP(2) =   0.6900D0
     CC(1)  =   3.7703D0
     CC(2)  =  -2.7703D0
  ELSE IF(IATOMN.EQ.22) THEN
!--*-- Ti --*--
     ALP(1) =   4.6800D0
     ALP(2) =   0.9400D0
     CC(1)  =   3.3889D0
     CC(2)  =  -2.3889D0
  ELSE IF(IATOMN.EQ.23) THEN
!--*-- V  --*--
     ALP(1) =   5.1400D0
     ALP(2) =   1.1100D0
     CC(1)  =   2.9680D0
     CC(2)  =  -1.9680D0
  ELSE IF(IATOMN.EQ.24) THEN
!--*-- Cr --*--
     ALP(1) =   5.1900D0
     ALP(2) =   1.3700D0
     CC(1)  =   2.8897D0
     CC(2)  =  -1.8897D0
  ELSE IF(IATOMN.EQ.25) THEN
!--*-- Mn --*--
     ALP(1) =   6.0300D0
     ALP(2) =   1.6300D0
     CC(1)  =   2.7024D0
     CC(2)  =  -1.7024D0
  ELSE IF(IATOMN.EQ.26) THEN
!--*-- Fe --*--
     ALP(1) =   6.5100D0
     ALP(2) =   1.9100D0
     CC(1)  =   2.6179D0
     CC(2)  =  -1.6179D0
  ELSE IF(IATOMN.EQ.27) THEN
!--*-- Co --*--
     ALP(1) =   6.9500D0
     ALP(2) =   2.3800D0
     CC(1)  =   2.7407D0
     CC(2)  =  -1.7407D0
  ELSE IF(IATOMN.EQ.28) THEN
!--*-- Ni --*--
     ALP(1) =   7.6000D0
     ALP(2) =   2.7400D0
     CC(1)  =   2.6949D0
     CC(2)  =  -1.6949D0
  ELSE IF(IATOMN.EQ.29) THEN
!--*-- Cu --*--
     ALP(1) =   7.5900D0
     ALP(2) =   3.0200D0
     CC(1)  =   2.6959D0
     CC(2)  =  -1.6959D0
  ELSE IF(IATOMN.EQ.30) THEN
!--*-- Zn --*--
     ALP(1) =   8.7800D0
     ALP(2) =   3.4900D0
     CC(1)  =   2.6313D0
     CC(2)  =  -1.6313D0
  ELSE IF(IATOMN.EQ.31) THEN
!--*-- Ga --*--
     IVAL   =   3.d0
     ITPCC  =   0
     ALP(1) =   2.0100D0
     ALP(2) =   0.8000D0
     CC(1)  =   4.0433D0
     CC(2)  =  -3.0433D0
  ELSE IF(IATOMN.EQ.32) THEN
!--*-- Ge --*--
     IVAL   =   4.d0
     ITPCC  =   0
     ALP(1) =   2.2800D0
     ALP(2) =   0.9100D0
     CC(1)  =   3.1110D0
     CC(2)  =  -2.1110D0
  ELSE IF(IATOMN.EQ.33) THEN
!--*-- As --*--
     IVAL   =   5.d0
     ITPCC  =   0
     ALP(1) =   2.6000D0
     ALP(2) =   1.0300D0
     CC(1)  =   2.6218D0
     CC(2)  =  -1.6218D0
  ELSE IF(IATOMN.EQ.34) THEN
!--*-- Se --*--
     IVAL   =   6.d0
     ITPCC  =   0
     ALP(1) =   2.8800D0
     ALP(2) =   1.1400D0
     CC(1)  =   2.2934D0
     CC(2)  =  -1.2934D0
  ELSE IF(IATOMN.EQ.35) THEN
!--*-- Br --*--
     ALP(1) =   3.200D0
     ALP(2) =   1.390D0
     CC(1)  =   2.1007D0
     CC(2)  =  -1.1007D0
  ELSE IF(IATOMN.EQ.36) THEN
!--*-- Kr --*--
     ALP(1) =   3.4900D0
     ALP(2) =   1.3900D0
     CC(1)  =   1.9478D0
     CC(2)  =  -0.9478D0
  ELSE IF(IATOMN.EQ.37) THEN
!--*-- Rb --*--
     ALP(1) =   1.3700D0
     ALP(2) =   0.2100D0
     CC(1)  =   6.8301D0
     CC(2)  =  -5.8301D0
  ELSE IF(IATOMN.EQ.38) THEN
!--*-- Sr --*--
     ALP(1) =   1.5200D0
     ALP(2) =   0.3300D0
     CC(1)  =   4.8514D0
     CC(2)  =  -3.8514D0
  ELSE IF(IATOMN.EQ.39) THEN
!--*-- Y  --*--
     ALP(1) =   2.0600D0
     ALP(2) =   0.4900D0
     CC(1)  =   4.1719D0
     CC(2)  =  -3.1719D0
  ELSE IF(IATOMN.EQ.40) THEN
!--*-- Zr --*--
     ALP(1) =   2.2800D0
     ALP(2) =   0.6600D0
     CC(1)  =   3.9162D0
     CC(2)  =  -2.9162D0
  ELSE IF(IATOMN.EQ.41) THEN
!--*-- Nb --*--
     ALP(1) =   2.4100D0
     ALP(2) =   0.8200D0
     CC(1)  =   3.7419D0
     CC(2)  =  -2.7419D0
  ELSE IF(IATOMN.EQ.42) THEN
!--*-- Mo --*--
     ALP(1) =   2.5700D0
     ALP(2) =   1.0200D0
     CC(1)  =   3.8044D0
     CC(2)  =  -2.8044D0
  ELSE IF(IATOMN.EQ.43) THEN
!--*-- Tc --*--
     ALP(1) =   2.8200D0
     ALP(2) =   1.1200D0
     CC(1)  =   3.3669D0
     CC(2)  =  -2.3669D0
  ELSE IF(IATOMN.EQ.44) THEN
!--*-- Ru --*--
     ALP(1) =   3.0000D0
     ALP(2) =   1.1900D0
     CC(1)  =   3.0213D0
     CC(2)  =  -2.0213D0
  ELSE IF(IATOMN.EQ.45) THEN
!--*-- Rh --*--
     ALP(1) =   3.2100D0
     ALP(2) =   1.2800D0
     CC(1)  =   2.7857D0
     CC(2)  =  -1.7857D0
  ELSE IF(IATOMN.EQ.46) THEN
!--*-- Pd --*--
     ALP(1) =   3.3100D0
     ALP(2) =   1.3200D0
     CC(1)  =   2.5256D0
     CC(2)  =  -1.5256D0
  ELSE IF(IATOMN.EQ.47) THEN
!--*-- Ag --*--
     ALP(1) =   3.5300D0
     ALP(2) =   1.4100D0
     CC(1)  =   2.3857D0
     CC(2)  =  -1.3857D0
  ELSE IF(IATOMN.EQ.48) THEN
!--*-- Cd --*--
     ALP(1) =   3.9100D0
     ALP(2) =   1.5600D0
     CC(1)  =   2.3128D0
     CC(2)  =  -1.3128D0
  ELSE IF(IATOMN.EQ.49) THEN
!--*-- In --*--
     ALP(1) =   1.7900D0
     ALP(2) =   0.7100D0
     CC(1)  =   6.7251D0
     CC(2)  =  -5.7251D0
  ELSE IF(IATOMN.EQ.50) THEN
!--*-- Sn --*--
     ALP(1) =   1.9700D0
     ALP(2) =   0.7800D0
     CC(1)  =   5.0086D0
     CC(2)  =  -4.0086D0
  ELSE IF(IATOMN.EQ.51) THEN
!--*-- Sb --*--
     ALP(1) =   2.1200D0
     ALP(2) =   0.8500D0
     CC(1)  =   4.0534D0
     CC(2)  =  -3.0534D0
  ELSE IF(IATOMN.EQ.52) THEN
!--*-- Te --*--
     ALP(1) =   2.3700D0
     ALP(2) =   0.9500D0
     CC(1)  =   3.5696D0
     CC(2)  =  -2.5696D0
  ELSE IF(IATOMN.EQ.53) THEN
!--*-- I  --*--
     ALP(1) =   2.5200D0
     ALP(2) =   1.0100D0
     CC(1)  =   3.0856D0
     CC(2)  =  -2.0856D0
  ELSE IF(IATOMN.EQ.54) THEN
!--*-- Xe --*--
     ALP(1) =   2.6300D0
     ALP(2) =   1.0500D0
     CC(1)  =   2.6837D0
     CC(2)  =  -1.6837D0
  ELSE IF(IATOMN.EQ.55) THEN
!--*-- Cs --*--
     ALP(1) =   1.2900D0
     ALP(2) =   1.0500D0
     CC(1)  =   2.6837D0
     CC(2)  =  -1.6837D0
  ELSE IF(IATOMN.EQ.56) THEN
!--*-- Ba --*--
     ALP(1) =   1.3400D0
     ALP(2) =   0.2500D0
     CC(1)  =   5.3338D0
     CC(2)  =  -4.3338D0
  ELSE IF(IATOMN.EQ.57) THEN
!--*-- La --*--
     ALP(1) =   5.0000D0
     ALP(2) =   2.0000D0
     CC(1)  =   3.2494D0
     CC(2)  =  -2.2494D0
  ELSE IF(IATOMN.EQ.58) THEN
!--*-- Ce --*--
     ALP(1) =   5.3200D0
     ALP(2) =   2.1300D0
     CC(1)  =   3.0538D0
     CC(2)  =  -2.0538D0
  ELSE IF(IATOMN.EQ.59) THEN
!--*-- Pr --*--
     ALP(1) =   5.5300D0
     ALP(2) =   2.2100D0
     CC(1)  =   2.8422D0
     CC(2)  =  -1.8422D0
  ELSE IF(IATOMN.EQ.60) THEN
!--*-- Nd --*--
     ALP(1) =   5.6900D0
     ALP(2) =   2.2800D0
     CC(1)  =   2.6639D0
     CC(2)  =  -1.6639D0
  ELSE IF(IATOMN.EQ.61) THEN
!--*-- Pm --*--
     ALP(1) =   5.9100D0
     ALP(2) =   2.3600D0
     CC(1)  =   2.5202D0
     CC(2)  =  -1.5202D0
  ELSE IF(IATOMN.EQ.62) THEN
!--*-- Sm --*--
     ALP(1) =   6.0700D0
     ALP(2) =   2.4300D0
     CC(1)  =   2.3958D0
     CC(2)  =  -1.3958D0
  ELSE IF(IATOMN.EQ.63) THEN
!--*-- Eu --*--
     ALP(1) =   6.2400D0
     ALP(2) =   2.500D0
     CC(1)  =   2.2886D0
     CC(2)  =  -1.2886D0
  ELSE IF(IATOMN.EQ.64) THEN
!--*-- Gd --*--
     ALP(1) =   6.4700D0
     ALP(2) =   2.5900D0
     CC(1)  =   2.2076D0
     CC(2)  =  -1.2076D0
  ELSE IF(IATOMN.EQ.65) THEN
!--*-- Tb --*--
     ALP(1) =   7.1500D0
     ALP(2) =   2.8600D0
     CC(1)  =   2.2267D0
     CC(2)  =  -1.2267D0
  ELSE IF(IATOMN.EQ.66) THEN
!--*-- Dy --*--
     ALP(1) =   7.3400D0
     ALP(2) =   2.9400D0
     CC(1)  =   2.1510D0
     CC(2)  =  -1.1510D0
  ELSE IF(IATOMN.EQ.67) THEN
!--*-- Ho --*--
     ALP(1) =   7.6100D0
     ALP(2) =   3.0400D0
     CC(1)  =   2.0909D0
     CC(2)  =  -1.0909D0
  ELSE IF(IATOMN.EQ.68) THEN
!--*-- Er --*--
     ALP(1) =   7.8100D0
     ALP(2) =   3.1200D0
     CC(1)  =   2.0304D0
     CC(2)  =  -1.0304D0
  ELSE IF(IATOMN.EQ.69) THEN
!--*-- Tm --*--
     ALP(1) =   8.0000D0
     ALP(2) =   3.2000D0
     CC(1)  =   1.9772D0
     CC(2)  =  -0.9772D0
  ELSE IF(IATOMN.EQ.70) THEN
!--*-- Yb --*--
     ALP(1) =   8.2100D0
     ALP(2) =   3.2800D0
     CC(1)  =   1.9271D0
     CC(2)  =  -0.9271D0
  ELSE IF(IATOMN.EQ.71) THEN
!--*-- Lu --*--
     ALP(1) =   8.5000D0
     ALP(2) =   3.4000D0
     CC(1)  =   1.8919D0
     CC(2)  =  -0.8919D0
  ELSE IF(IATOMN.EQ.72) THEN
!--*-- Hf --*--
     ALP(1) =   2.0200D0
     ALP(2) =   0.8000D0
     CC(1)  =   5.8921D0
     CC(2)  =  -4.8921D0
  ELSE IF(IATOMN.EQ.73) THEN
!--*-- Ta --*--
     ALP(1) =   2.1600D0
     ALP(2) =   0.8600D0
     CC(1)  =   4.7264D0
     CC(2)  =  -3.7264D0
  ELSE IF(IATOMN.EQ.74) THEN
!--*-- W  --*--
     ALP(1) =   2.2600D0
     ALP(2) =   0.9000D0
     CC(1)  =   3.9028D0
     CC(2)  =  -2.9028D0
  ELSE IF(IATOMN.EQ.75) THEN
!--*-- Re --*--
     ALP(1) =   2.4400D0
     ALP(2) =   0.9800D0
     CC(1)  =   3.5075D0
     CC(2)  =  -2.5075D0
  ELSE IF(IATOMN.EQ.76) THEN
!--*-- Os --*--
     ALP(1) =   2.4700D0
     ALP(2) =   0.9900D0
     CC(1)  =   2.9996D0
     CC(2)  =  -1.9996D0
  ELSE IF(IATOMN.EQ.77) THEN
!--*-- Ir --*--
     ALP(1) =   2.6700D0
     ALP(2) =   1.0700D0
     CC(1)  =   2.8089D0
     CC(2)  =  -1.8089D0
  ELSE IF(IATOMN.EQ.78) THEN
!--*-- Pt --*--
     ALP(1) =   2.7100D0
     ALP(2) =   1.0800D0
     CC(1)  =   2.5166D0
     CC(2)  =  -1.5166D0
  ELSE IF(IATOMN.EQ.79) THEN
!--*-- Au --*--
     ALP(1) =   2.8500D0
     ALP(2) =   1.1400D0
     CC(1)  =   2.3778D0
     CC(2)  =  -1.3778D0
  ELSE IF(IATOMN.EQ.80) THEN
!--*-- Hg --*--
     ALP(1) =   2.9900D0
     ALP(2) =   1.2000D0
     CC(1)  =   2.2533D0
     CC(2)  =  -1.2533D0
  ELSE IF(IATOMN.EQ.81) THEN
!--*-- Tl --*--
     ALP(1) =   1.7700D0
     ALP(2) =   0.5900D0
     CC(1)  =   6.7158D0
     CC(2)  =  -5.7158D0
  ELSE IF(IATOMN.EQ.82) THEN
!--*-- Pb --*--
     ALP(1) =   1.9200D0
     ALP(2) =   0.7600D0
     CC(1)  =   6.5444D0
     CC(2)  =  -5.5444D0
  ELSE IF(IATOMN.EQ.83) THEN
!--*-- Bi --*--
     ALP(1) =   2.0300D0
     ALP(2) =   0.8100D0
     CC(1)  =   5.2104D0
     CC(2)  =  -4.2104D0
  ELSE IF(IATOMN.EQ.84) THEN
!--*-- Po --*--
     ALP(1) =   2.1700D0
     ALP(2) =   0.8700D0
     CC(1)  =   4.4190D0
     CC(2)  =  -3.4190D0
  ELSE IF(IATOMN.EQ.85) THEN
!--*-- At --*--
     ALP(1) =   2.2900D0
     ALP(2) =   0.9200D0
     CC(1)  =   3.8179D0
     CC(2)  =  -2.8179D0
  ELSE IF(IATOMN.EQ.86) THEN
!--*-- Rn --*--
     ALP(1) =   2.4500D0
     ALP(2) =   0.9800D0
     CC(1)  =   3.4235D0
     CC(2)  =  -2.4235D0
  ELSE IF(IATOMN.EQ.87) THEN
!--*-- Fr --*--
     ALP(1) =   1.2300D0
     ALP(2) =   0.1600D0
     CC(1)  =   8.4416D0
     CC(2)  =  -7.4416D0
  ELSE IF(IATOMN.EQ.88) THEN
!--*-- Ra --*--
     ALP(1) =   0.9900D0
     ALP(2) =   0.2400D0
     CC(1)  =   6.1114D0
     CC(2)  =  -5.1114D0
  ELSE IF(IATOMN.EQ.89) THEN
!--*-- Ac --*--
     ALP(1) =   1.4900D0
     ALP(2) =   0.3100D0
     CC(1)  =   4.7270D0
     CC(2)  =  -3.7270D0
  ELSE IF(IATOMN.EQ.90) THEN
!--*-- Th --*--
     ALP(1) =   1.5900D0
     ALP(2) =   0.4000D0
     CC(1)  =   4.3902D0
     CC(2)  =  -3.3902D0
  ELSE IF(IATOMN.EQ.91) THEN
!--*-- Pa --*--
     ALP(1) =   2.0600D0
     ALP(2) =   0.4500D0
     CC(1)  =   3.8349D0
     CC(2)  =  -2.8349D0
  ELSE IF(IATOMN.EQ.92) THEN
!--*-- U  --*--
     ALP(1) =   2.0800D0
     ALP(2) =   0.5000D0
     CC(1)  =   3.5183D0
     CC(2)  =  -2.5183D0
  ELSE IF(IATOMN.EQ.93) THEN
!--*-- Np  --*--
     ALP(1) =   2.7200D0
     ALP(2) =   0.6000D0
     CC(1)  =   3.5099D0
     CC(2)  =  -2.5099D0
  ELSE IF(IATOMN.EQ.94) THEN
!--*-- Pu  --*--
     ALP(1) =   2.7600D0
     ALP(2) =   0.6200D0
     CC(1)  =   3.1671D0
     CC(2)  =  -2.1671D0
  ELSE
     WRITE(NFOUT,*) ' IATOMN =',IATOMN,'IS NOT PREPARED IN PSBHS'
  END IF
end subroutine psbhs0

subroutine matrix_inversion(nfout,k,n,a,b)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: matrix_inversion
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)                        :: nfout,k, n
  real(kind=DP), intent(in),  dimension(k,k) :: a
  real(kind=DP), intent(out), dimension(k,k) :: b

  if(n == 1) then
     b(1,1) = 1.d0/a(1,1)
  else if(n == 2) then
     call inver2n(k,a,b)
  else if(n == 3) then
     call inver3n(k,a,b)
  else
     write(nfout,*) ' n >= 4 ', ' n = ',n
     !stop
     call phase_error_with_msg(nfout, 'n>=4',__LINE__,__FILE__)
  endif
end subroutine matrix_inversion

#!/bin/sh
NP=1
NE=1
NK=1
nvol=20
ivol=990
dvol=15
rm -f nfefn.data
for v in `seq 1 $nvol`;do
vol=$( echo \($v-1\)*$dvol+$ivol | bc -l )
cd vol$vol
mpiexec -n $NP ../../../../bin/phase ne=$NE nk=$NK < /dev/null
echo -n $vol >> ../nfefn.data; echo -n; tail -1 nfefn.data >> ../nfefn.data
cd ../
done

#!/bin/sh

phase=$HOME/phase_v1001/bin/phase

# (1) PBE DFT
cd PBE
mpirun -np 47 $phase ne=1 nk=47 >& log

# (2) HSE06 hybrid DFT
cd ../HSE06
cp ../PBE/nfchgt.data .
cp ../PBE/zaj.data .
mpirun -np 47 $phase ne=1 nk=47 >& log

#!/bin/sh
if [ -e ../.git ];then
echo -n 'character(len=40), parameter :: commit_id = ' > version.h ; git rev-parse --sq HEAD >> version.h ; echo >> version.h
else
echo "character(len=40), parameter :: commit_id = 'unknown'" > version.h
fi

#!/bin/sh

phase=$HOME/phase_v1001/bin/phase

# (1) PBE DFT
cd PBE
$phase >& log

# (2) HSE06 Hybrid DFT
cd ../HSE06
cp ../PBE/nfchgt.data .
cp ../PBE/zaj.data .
$phase >& log

# (3) PBE0 Hybrid DFT
cd ../PBE0
cp ../PBE/nfchgt.data .
cp ../PBE/zaj.data .
$phase >& log

# (4) Hartree-Fock
cd ../HF
cp ../PBE/nfchgt.data .
cp ../PBE/zaj.data .
$phase >& log
